(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   2420470,      69820]*)
(*NotebookOutlinePosition[   2421893,      69865]*)
(*  CellTagsIndexPosition[   2421802,      69859]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
Evolving
Ant Foraging Behavior\
\>", "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Christian Jacob, jacob@cpsc.ucalgary.ca  April 1997 / February 2001 \
\[Copyright]\
\>", "Subsubtitle"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.18, Ind.1, Fit.21.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.18, Ind.1, Fit.21.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 .943 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 .966 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .713 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .69 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .667 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .644 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.115 1 0 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.138 1 0 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 .943 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 .966 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .713 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .69 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .667 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .644 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.115 1 0 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.138 1 0 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 .92 1 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .621 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.161 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.736 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.759 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.782 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.805 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.828 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.851 1 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 .92 1 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .621 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.161 1 0 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.736 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.759 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.782 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.805 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.828 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.851 1 0 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 .989 1 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .736 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
.092 1 0 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 .897 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .598 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.184 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.207 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.23 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.874 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.897 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.92 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.943 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.966 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.989 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .989 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .966 0 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 .989 1 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .736 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
.092 1 0 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 .897 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .598 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.184 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.207 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.23 1 0 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.874 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.897 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.92 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.943 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.966 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.989 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .989 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .966 0 r
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 .874 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .575 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .552 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.253 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.713 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .943 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .92 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .897 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .506 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .483 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .46 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 .874 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .575 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .552 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.253 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.713 1 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .989 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .759 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
.069 1 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .943 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .92 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .897 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .506 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .483 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .46 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 .851 1 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.276 1 0 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .989 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .759 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
.069 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .874 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .529 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .437 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .414 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .391 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .069 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .046 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .023 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 .851 1 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.276 1 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .874 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .529 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .437 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .414 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .391 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .069 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .046 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .023 0 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
0 1 .529 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .782 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .805 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .828 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.299 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.667 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.69 1 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .851 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .552 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .368 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .092 0 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
0 1 .529 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .782 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .805 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .828 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.299 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.667 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.69 1 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .966 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .782 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
.023 1 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
.046 1 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .851 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .552 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .368 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .092 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 .759 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.322 1 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.644 1 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .966 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .782 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
.023 1 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
.046 1 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .828 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .621 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .598 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .575 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .345 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .115 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 .759 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.322 1 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.644 1 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .506 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .483 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .46 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .437 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .414 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .391 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .368 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .345 r
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .828 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .621 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .598 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .575 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .345 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .115 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 .736 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.345 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.368 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.391 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.621 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .506 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .483 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .46 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .437 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .414 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .391 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .368 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .345 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .805 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .644 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .322 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .138 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .943 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .805 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .046 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .023 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 .736 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.345 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.368 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.391 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.621 1 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .805 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .644 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .322 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .138 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .943 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .805 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .046 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .023 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 .713 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.414 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.552 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.575 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.598 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .782 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .759 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .736 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .713 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .69 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .667 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .299 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .161 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 1 .069 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 .713 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.414 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.552 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.575 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.598 1 0 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .322 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .299 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .276 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .253 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .23 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .207 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .184 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .161 r
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .782 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .759 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .736 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .713 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .69 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .667 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .299 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .161 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 1 .069 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
0 .69 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.437 1 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.529 1 0 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .322 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .299 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .276 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .253 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .23 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .207 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .184 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .161 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .92 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .897 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .874 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .851 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .828 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .276 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .253 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .23 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .207 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .184 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 1 .092 r
F P
s
P
p
.002 w
.81196 .43865 m .78102 .44769 L .76758 .43092 L p
.8 g
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
0 .69 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.437 1 0 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.529 1 0 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .92 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .897 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .874 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .851 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .828 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .276 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .253 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .23 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .207 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .184 0 r
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 1 .092 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 .644 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 .667 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.46 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.483 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.506 1 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .138 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .115 r
F P
s
P
p
.002 w
.76758 .43092 m .79875 .42169 L .81196 .43865 L p
.8 g
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 .644 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 .667 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.46 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.483 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.506 1 0 r
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .138 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .115 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
0 .621 1 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
0 .621 1 r
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
0 .598 1 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
0 .598 1 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
0 .575 1 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
0 .575 1 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.75748 .36868 m .72557 .3785 L .71097 .36028 L p
.8 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
0 .552 1 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.71097 .36028 m .74314 .35025 L .75748 .36868 L p
.8 g
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
0 .552 1 r
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.65218 .34967 m .63631 .3547 L .62847 .34539 L p
0 .506 1 r
F P
s
P
p
.002 w
.65218 .34967 m .63631 .3547 L .62847 .34539 L p
0 .529 1 r
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.62847 .34539 m .64441 .34031 L .65218 .34967 L p
0 .506 1 r
F P
s
P
p
.002 w
.62847 .34539 m .64441 .34031 L .65218 .34967 L p
0 .529 1 r
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .322 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .345 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .368 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .391 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .414 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .437 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .46 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .483 1 r
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .322 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .345 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .368 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .391 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .414 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .437 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .46 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .483 1 r
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .138 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .161 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .184 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .207 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .23 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .253 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .276 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .299 1 r
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .138 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .161 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .184 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .207 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .23 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .253 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .276 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .299 1 r
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .023 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .046 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .069 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .092 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .115 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .138 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .161 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .184 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .207 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .23 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .253 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .276 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .299 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .322 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .345 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .368 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .391 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .414 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .437 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .46 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .483 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .506 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .529 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .552 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .575 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .598 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .621 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .644 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .667 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .69 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .713 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .736 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .759 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .782 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .805 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .828 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .851 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .874 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .897 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .92 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .943 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .966 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .989 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.989 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.966 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.943 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.92 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.897 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.874 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.851 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.828 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.805 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.782 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.759 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.736 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.713 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.69 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.667 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.644 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.621 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.598 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.575 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.552 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.529 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.506 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.483 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.46 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.437 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.414 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.391 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.368 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.345 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.322 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.299 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.276 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.253 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.23 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.207 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.184 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.161 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.138 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.115 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.092 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.069 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.046 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.023 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .023 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .046 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .069 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .092 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .115 1 r
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .023 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .046 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .069 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .092 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .115 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .138 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .161 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .184 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .207 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .23 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .253 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .276 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .299 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .322 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .345 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .368 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .391 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .414 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .437 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .46 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .483 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .506 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .529 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .552 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .575 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .598 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .621 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .644 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .667 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .69 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .713 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .736 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .759 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .782 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .805 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .828 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .851 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .874 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .897 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .92 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .943 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .966 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .989 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.989 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.966 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.943 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.92 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.897 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.874 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.851 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.828 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.805 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.782 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.759 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.736 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.713 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.69 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.667 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.644 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.621 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.598 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.575 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.552 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.529 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.506 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.483 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.46 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.437 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.414 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.391 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.368 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.345 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.322 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.299 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.276 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.253 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.23 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.207 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.184 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.161 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.138 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.115 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.092 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.069 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.046 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.023 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .023 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .046 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .069 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .092 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .115 1 r
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 253},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000o@P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l04@02og<0003o00L00_l70004o`00og80003o00@0
0ol00`3o00060004o`00og80003o00400ol400;o1P001?l00?mb0000oP02o`030?l000@000?o0?l0
1@001?l00?mb0000n`03o`T000Co0?oo1@02og<0003h00?o3002o`030?l007T0003f00;o40001?l0
0?mi0000l`03oa8000Co003oN@000?000ol00`3o000B0005o`000?l0N0000>d00olH0003o`000080
00?o0000M@000>/00_lK0003o`0000<000?o0000M0000;l00ol300?o8003oa`00_l50003o`0007@0
00300003o`0000D000?o00006P03oa/01?l00`3o00050003o`0007<000300003o`0000D000?o0000
6002o`030?l001P01Ol40003o`0000@000?o0000LP000<0000?o00000P03oaP00olJ00Co1=H00ol0
00020003o`0000800_md0000`0000ol000020003o`0001D00olJ00Co2=H01Ol0003o00H000?o0000
L@000;l00_l400Co4P02oa/01?l:eP03o`00008000?o000010000ol0001`0000f003oaX01?l>eP03
o`00008000?o00000`000ol0001`0000e@03o`030?l001L01?lBeP05o`000?l01P000ol0001_0000
d`02oa/01?l;eP;o2=H01Ol0003o00H000?o0000KP000=000olJ00Co2mH3o`03a?oF00OF00?o0000
0P000ol000030003o`0006h0001N00?o0`02o`<00ol200?o0P000ol0001G00?o6P04o`_F0ol5a003
omKF00KF00?o00000P000ol000030003o`0006d0001M0007o`000?l0o`020003o`3o008000Ko003o
0?l20003o`0005@00olJ00Co3=H2o`W400?oe]H01]H01Ol0003o00H00_m]0000H@000ol0o`020003
o`3o008000Ko003o0?l20003o`0005800_l20003o`0001H01?l;eP?o3<@00ooFeP05eP03o`000080
00?o00000P02ofh0001N00?o0P001_l00?l0o`8000Ko003o0?l20003o`0004l00ol50003o`000180
1?l<eP;o4<@00ooFeP05eP03o`00008000?o00000`000ol0001[0000G@000ol0000400;o0P001Ol0
0?l000KoC`03oaX01?l<eP?o00?4ol@03l@00ooFeP06eP05o`000?l01P000ol0001Z0000G@001Ol0
003o00`000?o0?l0C`02oa/01?l;eP?o1L@00oo4a00>a003omKF00GF00?o00000P000ol000040003
o`0006T0001N00?o3`000ol0001:00?o6P04o`cF0_l9a003olC400k400?oe]H01MH00ol000020003
o`0000<000?o0000J@000;X00ol20003o`0001D01?l<eP?o2l@00oo4a00?a003omKF00GF00Go0000
o`060003o`0006P0002h00;o6P04o`gF0_l?a003olC400[40ol00lCoeP07eP05o`000?l01P000ol0
001W0000]@03oaX01?l<eP?o00?4ol@03l@00oo4a006a0?o1L@00ooFeP05eP03o`00008000?o0000
0`000ol0001W0000/P03oaX01?l<eP?o1L@00oo4a00=a003olC400?40ol9a003omKF00GF00Go0000
o`0600;oI`000;000olI00Co3=H3o`W400?oa<@03L@00oo4o`02o`c400?oe]H01]H01Ol0003o00@0
00?o0?l0I`000:d00ol20003o`0001D00ol<eP?o3<@00oo4a00>a003olC400k400?oe]H01MH00ol0
00020003o`0000<000?o0000I@000:X00olJ00Co3=H2oa3400?oa<@02L@3o`03e_o4013400?oe]H0
1MH01Ol0003o00H000?o0000I00007l00ol400;o8002oaX01?l<eP?o00?4ol@04<@00oo4a005a0?o
1MH00oo4a00>a003omKF00KF00Go0000o`060003o`0006<000200003o`00008000Co003o7003oaT0
1?l=eP;o1L@00oo4a00>a003olC400?40_l9eP03olC400k400?oe]H01MH00ol000020003o`0000<0
00?o0000H`00080000?o00000P001?l00?lI00?o00<0o`005`04o`gF0_l8a003olC400k400?oa?l0
0_l<eP03olC400k400?oe]H01MH00ol000020003o`0000<000?o0000HP00080000?o00000P001?l0
0?lF00?o6P04o`gF0ol;a003olC400k400?oe]H03]H00oo4a009a0?o00?4omH01mH01Ol0003o00H0
00?o0000H@00080000?o00000P001?l00?lD00;o6P04o`gF0ol?a003olC400W40olBeP03olC400K4
0ol5a003omKF00KF00Go0000o`060003o`000600001o00;o1@02oa800olJ00?o3MH3o`;400?oa<@0
3L@00oo4a006a0?o5]H00oo4a003a0;o2L@00ooFeP05eP03o`00008000?o00000P03of40002G00?o
6P04o`cF0ol6a003olC400g400?oa<@00l@2oa[F00?oa?l00_l;a003omKF00KF00Go0000o`060003
o`0005l0002E00;o0P000ol0000E00Co3=H3o`[400?oa<@03L@00oo4o`02oagF00?oa<@03L@00ooF
eP06eP05o`000?l01P000ol0001N0000TP03oaT01?l<eP?o3/@00oo4a00;a003olCo023F00?oa<@0
3/@00ooFeP05eP03o`00008000?o00000`000ol0000700?oE00008l00olJ00Co2mH3o`03a?o400k4
00?oa<@02<@3obCF00?oa<@03L@00ooFeP06eP05o`000?l01P000ol000090003o`000540002<00?o
6P04o`_F0ol5a003olC400g400?oa<@01<@3obSF00?oa<@03L@00ooFeP06eP05o`000?l01P000ol0
00080003o`000540002:00Co6004o`cF0_l9a003olC400g400?oa<@00ol/eP03olC400_400?oa?l0
1mH00ol000020003o`0000<000?o00001@03oe@0002700?o10000ol0000C00?o3=H3o`c400?oa<@0
3L@2oboF00?oa<@02<@3o`;400?oe]H01]H01Ol0003o00H000?o000010000ol0001D0000Q@02oaX0
1?l<eP;o4<@00oo4a008a0?o<mH00oo4a004a0?o1/@00ooFeP06eP05o`000?l01@02o`D01?mC0000
PP03oaT01?l<eP?o00?4ol@03l@00oo4a006a0;o=mH00oo4a003o`[400?oe]H01]H01Ol0003o00<0
00?o0?l0G00007l00olI00Co3=H3o`G400?oa<@03/@00oo4a003a0;o>MH3o`k400?oe]H01MH00ol0
00020003o`0000<000?o0000F@0007d00_l20003o`0001D00ol<eP?o2L@00oo4a00>a003olCo00;o
>=H3o`03a?o400k400?oe]H01]H01Ol0003o00H000?o0000F00007X00olI00Co2mH3o`g400?oa<@0
3<@00oo4o`0heP?o1L@00oo4a00=a003omKF00KF00Go0000o`050003o`0005P0001g00?o6@04o`_F
0ol00lCoa00>a003olC400S40olieP;o2L@00oo4a00=a003omKF00GF00?o00000P000ol000030003
o`0005L0001d00?o6@04o`_F0ol5a003olC400g400?oa<@01<@3ocWF0ol;a003olC400k400?oe]H0
1MH01Ol0003o00H000?o0000EP0007800_l00`3o000G00Co2mH2o`W400?oa<@03L@00oo4a003ocWF
0ol?a003olC400W40ol00lCoeP07eP05o`000?l01P000ol0001E0000K`03oaT01?l;eP?o3<@00oo4
a00=a0;o>MH3o`;400?oa<@03/@00oo4a005a0?o1L@00ooFeP05eP03o`00008000?o00000`000ol0
001E0000B@03ob000olI00Co3=H2oa3400?oa<@02<@3ocWF0ol6a003olC400g400?oa<@00l@2o`W4
00?oe]H01MH01Ol0003o00D00_mF0000C0000ol0000K00;o6P03o`cF0ol2a003olC400g400?oa<@0
1/@2ocWF0ol:a003olC400g400?oa?l00_l<a003omKF00GF00Go0000o`060003o`0005<0001<0003
o`0001P00olI00Co2mH3o`K400?oa<@03L@00oo4a003a0;o>=H3o`k400?oa<@02l@00oo4o`0?a003
omKF00KF00Go0000o`050003o`0005<0001900?o6003o`8000?o00005004o`_F0ol:a003olC400g4
00?oa?l00_lJeP?o6]H3o`03a?o400k400?oa<@02<@3o`;F00?oa<@03/@00ooFeP05eP05o`000?l0
1P000ol0001B0000B@000ol0000F00;o6@04o`_F0ol>a003olC400g400?oe]H06=H3o`9V00?oe]H0
5]H2o`G400?oa<@03L@00oo4a004a0?o1]H00oo4a00>a003omKF00GF00Go0000o`060003o`000540
001900Co4P03oaT01?l:eP?o0/@00oo4a00=a003olC400S40ol00lCoeP0FeP?o1VH00ooFeP0CeP;o
2<@00oo4a00=a003olC400?o2]H00oo4a00>a003omKF00GF00Go0000o`050003o`000540001L00?o
6@04o`_F0_l6a003olC400g400?oa<@01<@3o`G400?oe]H04MH3o`YV00?oe]H03mH3o`_400?oa<@0
3L@2o`kF00?oa<@02L@3o`03a?oF00KF00Go0000o`060003o`000500001J00;o0P000ol0000D00Co
3=H2o`W400?oa<@03L@00oo4a003o`W400?oe]H03]H2o`iV00?oe]H03MH00oo4a00=a003olC400S4
0olAeP03olC400K40ol5a003omKF00GF00Go0000o`060003o`0004l0001G00?o6@03o`cF0ol<a003
olC400g40_l=a003omKF00gF00?oIVH03FH00ooFeP0=eP03olC400k400?oa<@01<@3oaGF00?oa<@0
0l@2o`W400?oe]H01MH01Ol0003o00@00_mA0000E003oaT01?l<eP;o4<@00oo4a008a0?o00?Fol@0
3/@00ooFeP0=eP03ofIV00eV00?oe]H03MH00oo4a00>a003olC400?o6MH00oo4o`02o`c400?oe]H0
1=H00ol000020003o`0000<000?o0000CP0005400olI00Co3=H3o`;400?oa<@03/@00oo4a004a0?o
1MH00oo4a00=a003omKF00gF00?oIVH03FH00ooFeP0=eP03olC400k40_lMeP03olC400g400?oe]H0
1MH01Ol0003o00H000?o0000C@0004l00_l00`3o000F00Co3=H3o`K400?oa<@03/@00oo4a003o`WF
00?oa<@03L@00ooFeP0=eP03ofIV00eV00?oe]H03MH00oo4a009a0?o00?4omH07MH00oo4a00>a003
omKF00GF00Go0000o`050003o`0004d0001<00?o10000ol0000B00?o3=H3o`[400?oa<@03/@2o`gF
00?oa<@03L@00ooFeP0=eP03ofIV00QV0ol00fKoeP0>eP03olC400K40ol5a003omKF01cF00?oa<@0
3/@00ooFeP05eP05o`000?l01@000ol0001<0000B@03oaT01?l;eP?o3/@00oo4a009a0?o4MH00oo4
a008a0?o4]H00omVIP04IP?o1FH00ooFeP0=eP03olC400?40_l9a003omKF01cF00?oa<@03/@00ooF
eP04eP05o`000?l01P000ol0001;0000A`02oaT01?l;eP?o0/@00oo4a00=a003olC400K40_lEeP03
olC400C40olFeP03ofIV00?o2FH00ooFeP0=eP03olCo00;o3<@00ooFeP0LeP03olC400W40ol00lCo
eP06eP05o`000?l01P000ol0001:0000A003oaT00ol;eP?o1/@00oo4a00=a003olC400?40_lHeP03
olC400?o6]H2o`eV00?oe]H03MH00oo4a00=a003omKF01cF00?oa<@01/@3o`G400?oe]H01MH01Ol0
003o00D00_m;0000@@03o`<000?o00004`04o`[F0ol:a003olC400g400?oa?l00_lJeP?o7MH00omV
IP0=IP03omKF00cF00?oa<@03/@00ooFeP0LeP03olC400?40_l9a003omKF00CF00Go0000o`040003
o`3o02801Ol01@3oool000?o0`02oaL0000o00;o6@04o`_F0_l>a003olC400g400?oe]H06=H3o`03
I_oF01kF00?oIVH03FH00ooFeP0<eP03olC400k400?oe]H07=H00oo4o`02o`_400?oe]H01MH01Ol0
003o00H000?o00007`000ol000020004o`00o`@000Co003o600003`00olH00Co2mH3o`03a?o400k4
00?oa<@02<@3oaWF0ol5IP03omKF01gF00?oIVH03FH00ooFeP0<eP03olC400k400?oe]H07=H00oo4
a00=a003omKF00GF00Go0000o`050003o`0001l000?o00000`03o`800_l30003o`0001H0000i00?o
6@03o`cF0_l5a003olC400g400?oa<@01<@3oaWF0ol9IP03omKF01gF00?oIVH02fH00omVo`0>eP03
olC400W40ol00lCoeP0MeP03olC400g400?oe]H01MH01Ol0003o00H000?o00007P05o`<000?o0?l0
1@000ol0000F0000=`02o`<000?o00004`04o`cF0_l8a003olC400g400?oa<@00olIeP?o3FH00ooF
eP0<eP;o3]H00omVIP08IP?o0VH00ooFeP0<eP03olC400K40ol5a003omKF01cF00?oa<@03L@00ooF
eP05eP05o`000?l01P000ol0000M0003o`0000<00_l300?o00@0oooo5`0003@00olH00Co3=H3o`_4
00?oa<@03L@2oaWF0ol00fKoIP0>IP03omKF00SF0ol00lCoeP0>eP03ofIV00AV0ol6IP03omKF00cF
00?oa<@00l@2o`W400?oe]H07=H00oo4a00=a003omKF00GF00Go0000o`050003o`0001d000?o0000
3@000ol0000F00004P02oad00olI00?o3MH2o`o400?oa<@02<@3oaWF0ol5IP03ofIV00eV00?oe]H0
1=H3o`G400?oe]H03MH00omVIP03o`YV00?oe]H03=H00oo4o`02o`c400?oe]H07=H00oo4a007a0?o
0/@00ooFeP06eP04o`00o`H000?o00007005ob@0000A0004o`00oaX00_lI00Co3=H3o`?400?oa<@0
3<@00oo4a004a0?o6MH3o`UV00?oIVH03FH00ooFeP03o`W400?oe]H03MH2o`iV00?oe]H03=H00oo4
a00=a003omKF01cF00?oa<@01<@3o`K400?oe]H01MH01Ol0003o00H000?o0000A000014000Co003o
5`03o`8000?o00004`04o`cF0ol7a003olC400c400?oa<@00olJeP;o3FH00omVIP0=IP;o3L@00ooF
eP0<eP03ofIV00eV00?oe]H03=H00oo4a00>a003omKF01cF00?oa<@00ol:a003omKF00GF00Go0000
o`0400;oAP00014000Co003o5003oaP01?l<eP?o2l@00oo4a00<a0;o7MH00omVIP0=IP03ofIV00QV
0ol00mKoa00>a003omKF00cF00?oIVH03FH00ooFeP0<eP03olC400k400?oe]H07=H2o`k400?oe]H0
1MH01Ol0003o00D000?o0000@`00014000Co003o4@03oaT00ol=eP;o3l@00oo4a007a0?o8MH00omV
IP0=IP03ofIV00AV0ol5eP03olC400g400?oe]H03=H00omVIP0=IP03omKF00cF00?oa<@03/@00ooF
eP0KeP03olC400g400?oe]H01MH01Ol0003o00H000?o00001@03o`@00_ld00004P02oa000_lI00Co
3=H3o`?400?oa<@03<@00oo4a003a0?o9MH00omVIP0=IP03ofIV00?o2MH00oo4a00=a003omKF00cF
00?oIVH03FH00ooFeP0<eP03olC400S40ol2a003omKF01cF00?oa<@03L@00ooFeP05eP05o`000?l0
1P000ol000050003o`00008000Co003o<`0002400ol20003o`0001<01?l<eP?o1l@00oo4a00<a003
olCo00;o:MH00omVIP0=IP;o3MH00oo4a008a0?o00?4omH03]H00omVIP08IP?o4MH00oo4a004a0?o
1/@00ooFeP0LeP03olC400g400?oe]H01MH01Ol0003o00D000?o00001@000ol000020004o`00oc<0
000N00?o6@03o`cF0ol;a003olC400c400?oe]H06]H3o`kF00?oIVH026H3oa7F00?oa<@01<@3o`G4
00?oe]H03MH00omVIP04IP?o5MH00oo4a003o`[400?oe]H07=H00oo4a00;a003olCo00KF00Go0000
o`060003o`0000@000?o00000P001?l00?lc00007002oaT00ol<eP?o3l@00oo4a007a0?o6mH3o`=V
00?oe]H03=H00omVIP04IP?o5MH00oo4a003o`W400?oe]H03MH00omVIP03oaWF0_l>a003omKF01_F
00?oa<@02<@3o`;400?oe]H01MH01Ol0003o00H000?o00000`000ol000020004o`00oc<0000I00?o
6004o`_F0ol3a003olC400g400?oa<@00l@3oa_F0ol7IP03omKF00cF00?oIVH00olHeP?o3L@00ooF
eP0=eP;o7=H00oo4a00=a003omKF01cF00?oa<@01<@3o`K400?oe]H01MH01Ol0003o00<00ol400;o
1@02oc@0000F00?o0P000ol0000C00Co2mH3o`O400?oa<@03L@00oo4o`02oa_F0ol;IP03omKF00cF
0_lHeP?o00?4ol@03/@00ooFeP0[eP03olC400g400?oe]H07=H00oo4a003o`[400?oe]H01=H01Ol0
003o00H000?o0000?P0001D00_l50003o`0001000ol;eP?o2l@00oo4a00=a003omKF01[F0_l?IP03
omKF02;F0ol5a003olC400g400?oe]H0:mH00oo4a00=a003omKF01cF0_l>a003omKF00CF00Go0000
o`060003o`0003d0000E0003o`3o01@01?l;eP;o3l@00oo4a008a0?o6mH3o`9V00?oIVH03FH00ooF
eP0NeP?o2L@00oo4a00=a003omKF02_F00?oa<@02l@00oo4o`0MeP03olC400g400?oe]H01MH01Ol0
003o00D000?o0000?@0001D000Co003o4004o`_F0ol3a003olC400c400?oa<@01<@3oa_F0ol6IP03
ofIV00eV00?oe]H06mH2o`g400?oa<@03L@00ooFeP0ZeP03olC400S40ol2a003omKF01cF00?oa<@0
3L@00ooFeP05eP04o`00o`H000?o0000?00001D000Go0000o`0=00?o2mH3o`O400?oa<@03<@00oo4
a003oa_F0ol:IP03ofIV00eV00?oe]H05mH3o`03a?o400g400?oa<@02<@3oboF00?oa<@01<@3o`K4
00?oe]H07=H00oo4a00=a003omKF00CF00Go0000o`060003o`0003/0000D0003o`0000<000?o0000
1`03o`_F0ol;a003olC400c40_lLeP;o3VH00omVIP08IP?o6=H3o`G400?oa<@03<@00oo4a004a0?o
<mH00oo4a003o`[400?oe]H07=H00oo4a007a0?o0/@00ooFeP05eP05o`000?l01@000ol0000k0000
50000ol000040003o`0000<01?l;eP;o3l@00oo4a007a0?o8MH00omVIP0<IP03ofIV00AV0olHeP?o
2L@00oo4a00<a003olC400?o6=H2oagF0_l>a003omKF01_F00?oa<@01<@3o`K400?oe]H01MH01Ol0
003o00@00_ll000050000ol000050003o`3o00?o2mH3o`?400?oa<@03<@00oo4a003a0?o9MH00omV
IP0<IP03ofIV00?o6=H3o`g400?oa<@03<@2oaSF0ol00fKoeP0LeP03olC400g400?oe]H07=H00oo4
a003o`[400?oe]H01=H01Ol0003o00H000?o0000>@0001@000?o00001P02o`_F0ol7a003olC400c4
00?oa?l00_lYeP03ofIV00aV0_lHeP?o00?4ol@03L@00oo4a008a0?o6=H3o`EV00?oe]H06mH00oo4
a00=a003omKF01cF0_l=a003omKF00GF00Go0000o`050003o`0003T0000D0003o`0000<00ol00`3o
o`07eP?o2l@00oo4a00<a003omKF02_F00?oIVH01fH3oaSF0ol5a003olC400c400?oa<@01<@3oaSF
0ol9IP03omKF01_F00?oa<@03L@00ooFeP0KeP03olC400g400?oe]H01MH01Ol0003o00D000?o0000
>00001<000Co00000ol60003omKF00?F00?oa<@03L@00oo4a007a0?o<=H00omVIP03IP?o6=H3o`W4
00?oa<@03<@00oo4a003oaWF0_l=IP03omKF01_F00?oa<@02<@3o`03a?oF01gF00?oa<@03<@00ooF
eP05eP05o`000?l01P000ol0000g00004`04o`X000?oe]H01=H00oo4a00<a003olC400?40oldeP03
ofKo00;o6MH2o`g400?oa<@03<@2oagF00?oIVH02fH00ooFeP0LeP03olC400C40ol5a003omKF01cF
00?oa<@03<@00ooFeP05eP05o`000?l01P000ol0000f00004`02o`d000?oe]H01=H00oo4a00<a003
olCo00;o>=H00ooFeP0GeP?o00?4ol@03L@00oo4a007a0?o8MH00omVIP0;IP03omKF01cF00?oa<@0
0ol9a003omKF01cF00?oa<@03<@00ooFeP05eP05o`000?l01@000ol0000f00005@000ol0000;0003
omKF00CF0_l=a0;oDMH3o`G400?oa<@03<@00oo4a003a0?o9MH00omVIP0;IP03omKF01_F0ol=a003
omKF01_F00?oa<@02<@3o`03a?oF00OF00Co003o1P000ol0000e00005P000ol0000;0003omKF00GF
00?oa<@01/@3o`?400?oe]H0BmH3o`W400?oa<@03<@00oo4o`02obWF00?oIVH02FH00omVo`0IeP?o
00?4ol@03/@00ooFeP0KeP03olC400C40ol5a003omKF00GF00Go0000o`040003o`3o03H0000G0003
o`0000/000?oe]H01MH00oo4a003a0;o1l@00ooFeP18eP;o3L@00oo4a00<a003omKF02_F00?oIVH0
16H4oaWF0ol5a003olC400g400?oe]H01mH2oa;F00?oa<@00ol9a003omKF00GF00Go0000o`050003
o`0003@0000H0003o`0000/00_l6eP03olCo00;o2/@00ooFeP18eP03olC400_400?oa<@02<@3o`;4
00?oe]H0:mH00omVIP03oa[F0ol9a003olC400g400?oe]H00mH3o`03P?oF01;F0_l=a003omKF00GF
00Co003o1P000ol0000c00006@000ol0000<0003omKF00CF00?oa<@03<@00ooFeP18eP03olC400_4
00?oa<@01<@3o`K400?oe]H0:mH2oa[F0ol=a003olC400S40ol5eP;o00I<P4b0C?lBeP03olC400c4
00?oe]H01MH01Ol0003o00H000?o0000<P0001X000?o000030000ooFeP04eP03olC400c400?oe]H0
B=H00oo4a00;a003olC400?o2/@00ooFeP13eP?o00?4ol@03/@00oo4a004a0?o2=H02On0C81<P4b0
o`0BeP03olC400c400?oe]H01MH01Ol0003o00D000?o0000<P0001/00_l=0003omKF00CF00?oa<@0
3<@00ooFeP0heP;o3]H00oo4a009a004olCoo`k400?oe]H0?mH3o`G400?oa<@03L@00oo4a003o`CF
0_l6eP09odb0C81<P4co01;F00?oa<@03<@00ooFeP05eP04o`00o`H000?o0000<@0001d000?o0000
2`000ooFeP04eP03olC400c40_leeP?o0VH00ooFeP0<eP03olC400C41?l3a003olC400g400?oe]H0
>mH3o`W400?oa<@03L@2o`CF0ol2P003omKF00CF00?oP4`00olEeP03olC400O40ol00lCoeP06eP05
o`000?l01P000ol0000`00007P000ol0000;0003omKF00CF00?oa<@01l@3o`?400?oe]H0;mH3o`IV
00?oe]H03=H00oo4a003o`S400?oa<@03L@00ooFeP0JeP;o6]H4o`g400?oa<@02<@3o`GF0_l01h1<
P4b0C?l01]H2oaSF00?oa<@01<@3o`G400?oe]H01MH01Ol0003o00@00_lb00007`000ol0000;0003
omKF00CF00?oa<@00l@3o`O400?oe]H0:mH3o`YV00?oe]H03=H2o`c400?oa<@03L@00ooFeP0FeP?o
00=VomH05MH4o`;400?oa<@03L@00oo4a004a0?o2MH00on0P005P003omKF01kF00?oa<@00ol9a003
omKF00GF00Go0000o`050003o`0002l0000P0003o`0000/00_l5eP03olCo00;o2l@00ooFeP0YeP03
ofIV00aV00?oe]H03=H00oo4a00;a003olC400S40olGeP?o1FH00ooFeP0@eP?o1l@00oo4a00=a003
olC400?o1=H2o`OF00?oC8000olQePCo3L@00ooFeP05eP04o`00o`H000?o0000;P00024000?o0000
2`02o`GF00?oa<@03L@00ooFeP0YeP03ofIV00aV00?oe]H03=H00oo4a00;a003olC400C40olGeP?o
2FH00ooFeP0=eP;o2l@00oo4a00=a0;o1=H3o`;000?oe]H01MH2ob3F1?l2IP03olC400c400?oe]H0
1MH01Ol0003o00D000?o0000;P0002800_l=0003omKF00CF00?oa<@03<@00ooFeP0YeP03ofIV00aV
00?oe]H03=H00oo4a00;a003olC400?o6=H2o`eV00?oe]H03=H00oo4a00;a003olC400S40ol5eP;o
00N0`830P<3o02CF1?l7IP03olC400c400?oe]H01MH01Ol0003o00D000?o0000;@0002@000?o0000
2`000ooFeP04eP03olC400c400?oe]H0:MH00omVIP0<IP03omKF00cF00?oa<@02L@01?o4oolLeP03
ofIV00aV00?oe]H03=H00oo4a00;a003olC400C40ol9eP03ol3000G000?oe]H07]H3o`aV00?oa<@0
3<@00ooFeP05eP04o`00o`H000?o0000;00002D000?o00002`000ooFeP04eP03olC400c400?oe]H0
:MH00omVIP07IP?o0VH00ooFeP0<eP03olC400C41?lQeP03ofIV00aV00?oe]H03=H00oo4a00;a003
olC400?o0mH4o`KF00?o`8000olOeP?o00=VofH03FH00oo4a007a0?o00?4omH01]H01Ol0003o00D0
0_l]00009P000ol0000;0003omKF00CF00?oa<@01l@3o`;400?oe]H0:MH00omVIP03IP?o1VH00ooF
eP0<eP03olC400?o9]H00omVIP0<IP03omKF00cF00?oa<@02L@01?o4ool3eP?o0h000ooFeP05eP;o
7mH3o`EV00?oIVH02fH00oo4a004a0?o1L@00ooFeP05eP05o`000?l00`000ol0o`0]00009`000ol0
000;0003omKF00CF00?oa<@00l@3o`K400?oe]H0:MH00omVo`02o`YV00?oe]H03=H2oaWF0ol>eP03
ofIV00MV0olAeP03olC400C41?l3a005omKFe_l01/000ooFeP0ReP?o2FH00omVIP0;IP03olC400?o
2L@00ooFeP05eP04o`00o`H000?o00001@03o`<00olL0000:0000ol0000;0003omKF00CF00?oa?l0
0_l:a003omKF02WF00?oIVH036H00ooFeP0RePCo0/@00ooFeP0=eP03ofIV00=V0olEeP03olC400?o
2<@01OoFe]Ko00J000?oe]H07]H3o`eV00?oIVH02FH01?mVool=a003omKF00CF00Go0000o`060003
o`0000D000?o00001@000ol0000I0000:@000ol0000;00;o1MH00oo4a00<a003omKF02WF00?oIVH0
36H00ooFeP0NeP?o1l@00ooFeP0=eP03ofKo00;o6MH2o`c400Koe]KFol03oaoF0ol00fKoIP0=IP03
ofIV00EV1?l2IP03olC400c400?oe]H01MH01Ol0003o00D000?o00001@000ol000050003o`0001T0
000Z00;o3@000ooFeP04eP03olC400_400?oe]H0:MH00omVIP0<IP03omKF01[F0ol;a003omKF00gF
00?oe]H06]H00oo4a00<a005omKFe_l07mH3o`EV00?oIVH036H00omVIP04o`MV00?oa<@03<@00ooF
eP05eP04o`00o`H000?o000010000ol0000200?o700002`000?o00002`000ooFeP04eP03olC400_4
00?oe]H0:MH00omVIP0<IP03omKF01KF0ol00lCoa00<a003omKF02[F00?oa<@03<@00ooFeP07eP;o
5=H3o`UV00?oIVH036H2o`aV00?oa<@03<@00ooFeP05eP04o`00o`H000?o00000`000ol000020003
o`0001`0000]0003o`0000/000?oe]H01=H00oo4a00;a0;o:]H00omVIP07IP?o5mH3o`G400?oa<@0
2l@00ooFeP0ZeP03olC400c400?oe]H00mH3o`03P?oF00oF1?l=IP03ofIV00MV0ol00mKoIP0=IP03
olC400G41?l2a003omKF00GF00Go0000o`0400;o1002o`@01?lK0000;P000ol0000;0003omKF00CF
00?oa<@01/@3o`?400?oe]H0:=H00omVIP03IP?o5mH3o`W400?oa<@02l@00ooFeP0ZeP03olC400O4
0ol00lCoeP02eP;o00K0P<20`?l;ePCo0VH00omVIP0<IP03ofIV00AV0ol5eP03ofIV00aV00?oa<@0
1?l7a003omKF00GF00Co003o0`001?l00?lX0000;`000ol0000;0003omKF00CF00?oa<@00l@2o`O4
00?oe]H0:=H00omVo`02oaWF00?oa<@02l@00oo4a009a004olCoob_F00?oa<@00l@3o`G400coe]Ko
P<20`830P?l6ePCo1fH00omVIP0<IP03ofIV00?o2MH00omVIP0<IP;o3<@00ooFeP05eP04o`00o`H0
00?o00009@00030000?o00002`000ooFeP04eP03olCo00;o2/@00ooFeP0XeP03omKF01[F00?oa<@0
3<@00oo4a004a0Co1<@00ooFeP0YeP03olCo00;o2L@03?oFe_o0P<20`830o`?F0_l<IP03ofIV00aV
0_l=eP03ofIV00MV0ol00fKoa00=a003omKF00CF00Go0000o`050003o`0002D0000a0003o`0000/0
00?oe]H01=H00oo4a00<a003omKF04GF00?oa<@03<@00oo4a003o`W400?oe]H0:=H2o`g400Koe]Ko
P<03o`GF00?oIVH036H00omVIP07IP?o4=H00omVIP04IP?o1FH00oo4a00<a003omKF00CF00Go0000
o`050003o`0002@0000b00;o3002o`KF00?oa<@02l@00ooFeP15eP03olC400c40_l=a003omKF02CF
0ol00fKoa00=a003omKF00;o2MH00omVIP0;IP03ofIV00AV0olDeP03ofIV00?o2FH00oo4a00<a003
omKF00CF00Co003o1P000ol0000S0000=0000ol0000;0003omKF00CF00?oa<@02l@00ooFeP15eP03
olC400O40ol2a003olC400c400?oe]H08=H3o`EV00?oa<@03<@00ooFeP07eP;o0]H00omVIP0;IP03
ofIV00?o5mH3o`eV00?oa<@01l@3o`03a?oF00GF00Go0000o`0500;o900003D000?o00002`000ooF
eP04eP03olC400_40_m6eP03olC400?40ol6a003olC400c400?oe]H07=H3o`UV00?oa<@03<@00ooF
eP03eP?o0/001?oFe_l;IP04ofKooaOF0ol00fKoIP0=IP03olC400C40ol5a003omKF00CF00Go0000
o`030003o`3o02@0000f0003o`0000/000?oe]H01=H00oo4a004a0Co1<@00ooFeP14eP03olCo00;o
2/@00oo4a00<a003omKF01WF0_l=IP03olC400O40ol00lCoeP02eP;o00O0P<20`83o00;F00?oIVH0
16H4oaSF0ol5IP03ofIV00aV00?oa<@00ol8a003omKF00GF00Co003o1P000ol0000Q0000=`000ol0
000;0003omKF00CF00?oa<@00ol9a003omKF04CF00?oa<@03<@00oo4a007a0?o7]H00omVIP0;IP03
olC400C40ol5a005omKFe_l01l001?oFe_l2IP?o6MH3o`UV00?oIVH036H2o`c400?oe]H01MH01?l0
0?l60003o`000200000h0003o`0000/000?oe]H01=H2o`g400?oe]H0AMH00oo4a00;a003olC400?4
0olReP03ofIV00]V00?oa<@00ol9a007omKFe_n0`003o`GF0_lHePCo3FH00omVIP07IP?o00?Fol@0
3L@00ooFeP04eP05o`000?l01@000ol0000P0000>@02o``000?oe]H01=H00oo4a00<a003omKF04GF
00?oa<@02l@00oo4o`02obKF00?oIVH02fH2o`g400Coe]KF0_lNePCo0VH00omVIP0<IP03ofIV00AV
0ol5eP03olC400_400?oe]H01MH01?l00?l60003o`0001l0000k0003o`0000X00_l5eP03olC400c4
00?oe]H0=MH2o`kF00?oa<@02l@00ooFeP0XeP03ofIV00AV1?l3eP03olC400_400?oe]H07]H3o`MV
00?oIVH036H00omVIP03o`WF00?oa<@02l@00ooFeP05eP04o`00o`H000?o00007P0003`000?o0000
2`000ooFeP03eP03olC400c400?oe]H0<MH3o`9V00?oe]H03=H00oo4a004a0Co0l@00ooFeP0XeP03
ofIV00?o2=H00oo4a00;a003omKF00KF0olBeP;o2fH00omVIP0<IP;o3MH00oo4a006a0?o00?4omH0
1]H01Ol0003o00@00_lP0000?@000ol0000;0003omKF00?F00?oa<@01l@3o`;400?oe]H0;]H2o`IV
00?oe]H03=H00oo4a003o`S400?oe]H0:=H2o`cF00?oa<@02l@00ooFeP02eP?o00C0P<3o4MH00omV
IP0;IP03ofIV00EV1?lAeP03olC400?40ol5a003omKF00GF00Co003o1P000ol0000M0000?P000ol0
000;0003omKF00?F00?oa<@00l@3o`K400?oe]H0:]H3o`UV00?oe]H03=H2o`c400?oe]H0=]H00oo4
a004a0Co1mH02?n0`830P<3o4MH00omVIP0;IP03ofIV00Co5]H00oo4o`02o`W400?oe]H01MH01?l0
0?l60003o`0001`0000o0003o`0000/000?oe]H00mH00oo4o`02o`[400?oe]H0:=H00omVIP0;IP03
omKF00_F00?oa<@03<@00ooFeP0feP03olC400?o3=H02?n0`830P<3o4MH00omVIP0;IP;o6mH00oo4
a00;a003omKF00CF00Go0000o`050003o`0001`000100003o`0000/000?oe]H00mH00oo4a00<a003
omKF02SF00?oIVH02fH00ooFeP0;eP03olC400c400?oe]H0=]H2o`oF00?o`8000olDeP03ofIV00IV
0ol00fKoeP0KeP03olC400c400?oe]H01=H01Ol0003o00D000?o00006`0004400_l<0003omKF00CF
00?oa<@02l@00ooFeP0XeP03ofIV00]V00?oe]H02mH00oo4a00<a003omKF04OF0_lGeP03ofIV00=V
0ol5IP03omKF01[F00?oa<@03<@00ooFeP04eP04o`00o`H000?o00006P0004<000?o00002P000ooF
eP04eP03olC400_400?oe]H0:=H00omVIP0;IP03omKF00_F00?oa<@01l@3o`03a?oF053F0_l@eP03
ofKo00;o2FH00ooFeP0JeP03olC400O40ol00lCoeP06eP04o`00o`D000?o00006P0004@000?o0000
2P02o`GF0_l<a0;o:MH00omVIP04IPCo0fH00ooFeP0;eP03olC400?40ol5a003omKF04_F0ol00h3o
eP0@eP03ofIV00]V00?oe]H06MH00oo4a004a0?o1L@00ooFeP04eP05o`000?l00`000ol0o`0K0000
A@000ol0000;0003omKF00CF00?oa<@01<@3o`C400?oe]H09mH00omVIP03o`QV00?oe]H02mH00oo4
o`02o`W400?oe]H0B=H2o`G000?oe]H03]H00omVIP0<IP03omKF01WF00?oa<@00ol8a003omKF00GF
00Co003o1P000ol0000H0000AP000ol0000;0003omKF00CF00?oa<@00ol8a003omKF02OF0_l<IP03
omKF00_F00?oa<@02l@00ooFeP18eP08ol20`830P?l@eP03ofIV00aV00?oe]H06MH2o`c400?oe]H0
1MH01?l00?l60003o`0001L000170003o`0000/000?oe]H01=H2o`c400?oe]H0:=H00omVIP0:IP03
omKF00_F00?oa<@02l@00ooFeP18eP03ol3o00;o4mH00omVIP07IP?o00=VomH06]H00oo4a00<a003
omKF00CF00Go0000o`050003o`0001L000180003o`0000/000?oe]H01MH00oo4a00:a003omKF02SF
00?oIVH02VH00ooFeP07eP;o0]H00oo4a00;a003omKF04SF00?oe]H05MH00omVIP03IP?o1FH00ooF
eP0IeP03olC400_400?oe]H01MH01?l00?l60003o`0001H0001900;o30000ooFeP05eP03olC400[4
00?oe]H0:=H00omVIP0:IP03omKF00?F0ol00n3@o`02eP03olC400_400?oe]H0C]H2oa3F00?oI_l0
0_l9IP03omKF01WF00?oa<@02l@00ooFeP05eP04o`00o`D00_lG0000B`000ol0000:0003omKF00GF
00?oa<@02/@2obWF00?oIVH016H3o`KF0_l01m3Pd>3@h?l00]H00oo4a004a0Co0l@00ooFeP1:eP?o
00?AomH04=H00omVIP0;IP03omKF01WF00?oa<@01<@4o`;400?oe]H01MH01Ol0003o00<000?o0?l0
5`0004`000?o00002P000ooFeP05eP03olC400C40ol4a003omKF02OF00?oIVH00ol3eP;o1]H02?oP
d>3@h=3o0]H00oo4a003o`S400?oe]H0AmH2o`06g]7NdMko4=H00omVIP0;IP03omKF01[F00?oa<@0
0ol7a003omKF00GF00Co003o1P000ol0000D0000C@000ol0000:00;o1]H00oo4a003o`S400?oe]H0
5=H2oa7F0_l3eP?o00?PomH01]H00oo@o`02o`GF0_l<a003omKF04OF00?odM401=400ooFeP0>eP03
ofIV00]V00?oe]H01MH4o`oF00Coe_oo2l@00ooFeP05eP04o`00o`@00olE0000CP000ol0000;0003
omKF00CF0_l<a003omKF013F0ol00`P1o`0DeP07on3@h=3Po`07eP03omKF00OF00?oa<@02l@00ooF
eP0mePCo1]H00ooAo`02oa?F00?oIVH02fH01?oFe]H3o`04GamOo`_F1?l2a003olC400_400?oe]H0
1MH00ol00004o`8000?o00004`0004l000?o00002`000ooFeP03eP03olC400c400?oe]H03MH2o`H8
00?oe]H04]H01ooPd>3@h?l03MH2o`;F00?oa<@02l@00ooFeP0ieP?o0m400ooFeP05eP03omKF01GF
00?oIVH016H4o`OF00?oGel00el00ooFeP04ePCo1l@00oo4a00;a003omKF00CF1?l50003o`0001<0
001@00;o30000ooFeP03eP03olC400c400?oe]H03]H02?l80@P1207o2]H4o`KF00Ooh=3Pon3o00WF
0ol00n3@o`02eP03olC400_400?oe]H0>MH00ooNgP03gP03omKF01gF00?oIVH00ol3eP;o1mH01omO
7eooGol00]H3o`c400?oa<@02l@00ooFeP04eP04o`00o`@000?o00004`00058000?o00002P000ooF
eP03eP03olC400c400?oe]H03]H00ol8o`02o`WF0ol01N3@h=3o00KF0ol;eP03on3P00CP00Coe]Ko
1/@4o`?400?oe]H0<=H2o`OF00OodM7Aom7o01oF0_l3eP?o0Ul00ooFeP05eP?o0]H3o`03a?o400c4
00?oa<@01L@4o`[F00Co003o0`000ol0000C0000D`000ol0000:0003omKF00?F00?oa<@01l@3o`;4
00?oe]H03]H00ooFeP0;eP08on3@h=3Pd?lDeP08on3@h=3Pd?l2eP03olC400?o2<@00ooFeP0/eP?o
00?NdOl01mH3obKF00So7elOGamOo`SF0ol5a003olC400_400?oa<@01?l9eP?o1P001?l00?lE0000
E0000ol0000:0003omKF00?F00?oa<@00l@3o`K400?oe]H05=H2o`KF00Coh=3P0_l00m3oeP0CeP03
on3o00;o1MH2o`c400?oe]H0:]H02?oNdMkAg]7o:=H2o`GF00?oGel01El00ooFeP02eP?o2L@00oo4
a00;a0;o2MH4o`T000Go0000o`0D0000E@000ol0000:00;o1=H00oo4o`02o`[400?oe]H04=H3o`;@
00?oe]H01=H3oaWF00?oe]H01mH00oo4a00;a003omKF02;F0_l6eP08omkAg]7NdOlTeP?o0Ql00ooF
eP03eP03oelO00?o0mH3o`g400?oa<@01/@3o`WF0ol>0004o`00oa@0001F0003o`0000/000?oe]H0
0]H00oo4a00<a003omKF00kF00?od=001=000ooFeP0VeP;o0]H00oo4a00;a003omKF01kF0ol00mkA
o`06eP03omko00;o9MH00omOG`04G`03omKF00?F0_l2ePCo0/@00oo4a00;a003olC400?40ol8ePCo
4P000ol0o`0D0000E`000ol0000;0003omKF00?F00?oa<@02l@00ooFeP0>eP03om3@00C@00?oe]H0
8]H3o`;P00Coe]Ko3L@00ooFeP0LeP03omkN00CN00?oe]H01=H00ooFeP0VeP03oalO00DO00?oe]H0
0mH3o`O400?oa<@02l@00oo4o`02o`SF0olF0003o`3o01@0001H00;o30000ooFeP03eP;o3<@2o`oF
00?od?l00_lUeP03on3P00CP00Coe]Ko1/@4o`;400?oe]H07MH02?oNdMkAg]7o9MH4o`KF00?oGel0
0ol3ePCo2l@00oo4a00;a003omKF00GF1?lJ00;o500005X000?o00002P000ooFeP04eP03olC400C4
0ol4a003omKF00gF00?oe]H09mH00ooPh004h004omKFo`;40ol7a003omKF01?F1?l6eP03omko00;o
9=H3o`04GamOo`OF0_l2ePCo0/@00oo4a00;a003olC400C41?l7eP?o7@03oa@0001K0003o`0000X0
00?oe]H01=H00oo4a003o`S400?oe]H04mH3ob7F00?oh?l00_l5eP;o2l@00ooFeP0?eP?o0mh00ooF
eP05eP03omKF02KF00Oo7elOGaoo00KF1?l7a003olC400_400?oa<@00ol7ePCo7@03oaL0001L0003
o`0000X000?oe]H01=H2o`c400?oe]H03mH3o`04dM3Aob7F00?oe]H01mH00oo4a00:a003omKF00oF
00Oog]7NdMko02KF1?l6eP08oelOGomOomH4o`c400?oa<@02l@2o`KF1?lM00Co6P0005d000?o0000
2P000ooFeP05eP03olC400[400?oe]H03MH00oo@d005d003omKF02GF0_l2eP03olC400[400?oe]H0
1MH4o`KF00Oog]kNomko02;F0ol015lOGol7ePOo0/@00oo4a00;a003olC400G41?l7eP?o7@04oah0
001N0003o`0000X00_l6eP03olC400[400?oe]H03MH02OoAd=7@dM3Ao`0SeP?o0PP01?oFe_l<a004
omKFeP?o00GNgmkOo`06eP?o9]H01omO7elOGol01]H3o`O400?oa<@02l@00oo4a004o`OF1?lM00?o
8P0005l000?o00002`000ooFeP04eP03olC400[400?oe]H03MH00oo@d003obCF00?oh>001>001?oF
e_l6a0?o1mH00ooNgP04gP03omKF02GF0_l6eP07oelOGomOo`02eP?o2l@00oo4a00;a0;o2=H3oad0
1?lU0000H002o``000?oe]H01=H00oo4a004a0?o0l@00ooFeP0=eP;o:=H00ol820042004omKFo`;4
0ol3eP;o1]H01?oNgmh2o`03gooF02;F0ol00aooeP06eP?o0]H3o`03a?o400c400?oa<@01<@4o`SF
1?lM00?o:@00068000?o00002P000ooFeP04eP03olC400?o1l@00ooFeP0DeP;o8MH00ooPo`02o`GF
0_l3eP?o00?Ad?l01]H3obKF00?o7al00al00ooFeP06eP?o1L@00oo4a00;a003olC400?o2MH3oad0
1?l/0000H`000ol0000:0003omKF00CF0_l;a003omKF013F0ol00m3Ao`0QeP03omKF00[F00?odM40
1=400ooFeP0UeP;o1]H00olO7`037`03omKF00;F0ol9a003olC400_40_l8ePCo7@03oc00001T0003
o`0000X000?oe]H01=H00oo4a00:a003omKF00gF0_l01m3Ad=7@dOl09mH2o`KF00Ood=7@dM3o00[F
0olFeP?o0Ql00ooFeP04eP?o1=H3o`g400?oa<@01<@4o`WF0olM00Co<`0006D000?o00002P000ooF
eP04eP03olC400[400?oe]H03]H2o`06dM3Ad=7o8mH3o`;A00?oe]H01=H3o`CF1?l2eP?o0mh00ooF
eP0BeP03oalO00@O00?oe]H01mH3o`?400?oa<@02l@00oo4a003o`WF1?lL00Co=`0006H000?o0000
2P000ooFeP04eP03olC400[400?oe]H03mH3obCF0_l01m7@dM3Ad?l02MH3o`C400[oe]Kog]oNgmko
3=H2o`GF00?o7al01Al00ooFeP03eP?o1l@00oo4a00;a0;o2MH3oad00olk0000I`02o`/00_l5eP03
olC400C40ol3a003omKF02oF0_l5eP03om7A00GA00?oe]H00mH3o`S400Coe]Ko0mh00ooNo`08eP?o
00>Ogol01MH00olO7`03o`?F1?l;a003olC400C41?l9ePCo7004och0001Y0003o`0000X000?oe]H0
0mH00oo4a003o`O400?oe]H04mH3oaGF0ol00m7@o`05eP03om3A00?o1MH2o`c400?oe]H00ol:eP03
omoO00CO00?oe]H00mH2o`;F1?l3a003olC400[400?oa<@00ol:eP?o7@03od80001Z0003o`0000X0
00?oe]H00mH2o`_400?oe]H03mH3o`04dM3Aoa?F00Sod=7@dM3Ao`GF0_l9eP03olC400_400?oe]H0
1]H2o`GF00SoWmnOgioOo`GF0ol8a003olC400[40_l9ePCo7004odD0001[0003o`0000X000?oe]H0
0mH00oo4a00:a003omKF00oF00OodM3Ad=7o00cF0_l5eP08om7@dM3Ad?l@eP03olC400_400?oe]H0
0]H3o`03g_oF00GF00?ogol00_l3ePCo3<@00oo4a004a0?o2]H3oad00om90000K0000ol0000:0003
omKF00?F00?oa<@02/@00ooFeP0?eP07om7@dOoAo`08eP?o00?@dOl01MH00oo@o`02oa?F00?oa<@0
1<@4o`;400_oe]KFomoNgmkOo`06eP03omKF00Co0l@00oo4a00;a003olC400?o2MH4oa`01?m<0000
K@000ol0000:0003omKF00?F00?oa<@02/@2oa3F0ol:eP03om7A00CA00?oe]H00mH00ooFeP0EeP03
olC400?o1l@01?oFe_l6gP03omKF00?F0ol8a003olC400_40_l9eP?o7004oe00001^0003o`0000X0
00?oe]H00mH00oo4a004a0?o1<@00ooFeP0DeP;o1MH02?o@dM3Ad=7o7MH2o`_400Goe]KogP03o`?F
1?l<a003olC400C41?l9ePCo7003oe@0001_00;o2`02o`CF00?oa<@00ol8a0;o4MH3o`;A00?oe]H0
0mH00ooAo`02ob3F00?oa<@02/@01?oFe_l3eP?o1<@00oo4a00:a003olC400?o2]H3oa`01?mG0000
L@000ol0000:0003omKF00;F0_l=a003omKF00gF00?od=001=000ooFeP03eP03omKF02;F00?oa<@0
2/@00ooFeP03o`S400?oa<@02/@2o`WF1?lL00?oF`00078000?o00002P000ooFeP03eP03olC400_4
00?oe]H03MH00ooAd@04d@03omKF02SF00?oa<@02/@2o`c400?oa<@01<@3o`WF1?lL00CoGP0007<0
00?o00002P000ooFeP03eP;o3<@00ooFeP0=eP03om3o00;o;MH00oo4a004a0?o0l@00oo4a00;a003
olC400?o2MH3oad00omR0000M0000ol0000:0003omKF00CF00?oa<@01<@3o`?400?oe]H03MH00ooF
eP0_eP03olC400?o1l@00oo4a00;a0;o2=H4oa`01?mU0000M@000ol0000:0003omKF00CF00?oa<@0
0ol7a003omKF03gF1?l;a003olC400C41?l9eP?o7004ofT0001f0003o`0000X000?oe]H01=H2o`_4
00?oe]H0>=H4o`?400?oa<@02/@00oo4a003o`WF1?lL00?oK@0007L00_l;0003omKF00CF00?oa<@0
2/@00ooFeP0deP?o2<@00oo4a00:a0;o2MH3oa`01?m`0000N@000ol0000900;o1MH00oo4a00:a003
omKF02oF1?l<a003olC400C40ol9ePCo7003og@0001j0003o`0000X000?oe]H00mH00oo4a00:a0;o
;=H3o`C400?oa<@02/@00oo4a003o`WF0olL00CoM`0007/000?o00002P000ooFeP03eP03olC400C4
0ol4a003omKF02KF0ol8a003olC400[40_l8ePCo6`04og/0001l0003o`0000X000?oe]H00mH00oo4
a003o`S400?oe]H08MH4o`c400?oa<@01<@3o`WF0olL00?oO`0007d000?o00002P000ooFeP03eP;o
3<@00ooFeP0MeP?o1<@00oo4a00:a003olC400?o2=H4oa/01?n20000OP02o`/000?oe]H01=H00oo4
a00:a003omKF01WF0ol8a003olC400[40_l8eP?o7003ohH000200003o`0000T000?oe]H01=H00oo4
a00:a003omKF01CF1?l<a003olC400C40ol8ePCo6`04ohT000210003o`0000T000?oe]H01=H00oo4
a004a0?o0l@00ooFeP0@eP?o1<@00oo4a00:a003olC400?o2=H3oa`00on=0000PP000ol0000900;o
1MH00oo4a003o`O400?oe]H03=H3o`S400?oa<@02/@2o`OF1?lK00CoT00008<000?o00002P000ooF
eP03eP;o2l@00ooFeP07ePCo3<@00oo4a004a0?o2=H3oa/01?nD0000Q0000ol0000:0003omKF00CF
00?oa<@02L@01?oFe]H5o`C400?oa<@02/@00oo4a003o`OF1?lK00?oV00008D000?o00002P000ooF
eP04eP03olC400W40ol:a003olC400[40_l7eP?o6`04oi/0002600;o2`000ooFeP04eP03olC400C4
0ol2a003olC400[400?oa<@01<@3o`OF1?lK00?oW`0008P000?o00002@000ooFeP04eP03olC400?o
1/@00oo4a00:a003olC400?o1]H4oa/01?nR0000R@000ol000090003omKF00CF0_l:a003olC400[4
0_l6eP?o7003ojH0002:0003o`0000T00_l5eP03olC400W400?oa<@01<@3o`KF1?lK00CoZ@0008/0
00?o00002P000ooFeP03eP03olC400W400?oa<@00ol6eP?o6`04ojd0002<0003o`0000X000?oe]H0
0mH00oo4a007a004olCoo`GF1?lK00?o/@0008d000?o00002P000ooFeP03eP04olC4a0Go1]H3oa/0
1?nd0000SP02o`/000?oe]H00mH3o`OF1?lK00?o^000090000?o00002@000ooFeP09eP?o6`04ok/0
002A0003o`0000T000?oe]H01=H4oa/00ono0000TP000ol000090003omKF00?o6`04ol80002C0003
o`0000P00olJ00CoaP0009@000?o00001`000ol0000G00?obP0009D00_l70003o`0001<01?o=0000
U`000ol000040003o`0001000ooA0000V0000ol000030003o`0000`01?oD0000V@001Ol0003o00`0
0ooH0000VP001?l00?l800Cof`0009/000?o0?l01004oml0002L00;o00@0ooooh`0009d00_oV0000
o`260000o`260000o`260000o`260000o`260000o`260000o`260000o`260000o`260000o`260000
o`260000o`260000YP000ol0000W0003o`000;80002100Co0`04o`040?oo00;o0P02o`<00ol400;o
10000ol0000800Go00@0ool00_l200Go00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`<0
1?l200?o1002oh<000200005o`000?l00P000ol000030004o`00o`<00_l40003o`00008000Co003o
10000ol000090005o`000?l00P001?l00?l30003o`0000;o10000ol000040003o`0000L000?o0000
1@000ol000020004o`00o`800_l40003o`0000<000?o00000`02oh<000200003o`3o00;o0P05o`05
0?l00?l02@000ol000020004o`00oa0000Go0000o`020004o`00o`<000?o00001P000ol0000>0003
o`0000D000?o00000P000ol0000:0003o`00008000?o0000R000080000?o000010001ol0003o0?l0
0P000ol000070003o`0000<00_lA0005o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D0
00?o00000P000ol0000;0005o`000?l0RP00080000Go0000o`0300?o00<0ool00ol90003o`000080
00Co003o40000ol00005o`<01?l80003o`0000h000?o00001002o`<01?l80004o`00o`<000?o0000
R00008401?lD00;o1@02o`l01Ol;0003o`0000D00_l?00Go2@000ol0000900;o0`02ohX0003000;o
8@000ol000020003o`0009X0003o08H00000\
\>"],
  ImageRangeCache->{{{0, 388}, {252, 0}} -> {-0.0531933, 0.125294, 0.00273287,
   0.00273287}},
  CellTags->"AntTracker2D - Gen 18"],

Cell[CellGroupData[{

Cell[" Introduction", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
This is the original version of our notebook used for evolving ant \
control programs by Genetic Programming.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[" Packages and Notebooks", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Basic directory"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Note",
  StyleBox[": Evaluate the following cells to load the definitions needed to \
perform any calculations in this notebook.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "For setting the ",
  StyleBox["Evolvica Directory",
    FontWeight->"Bold"],
  StyleBox[" ",
    FontSlant->"Italic"],
  "please refer to the ",
  ButtonBox["IEC Notebook",
    ButtonData:>{
      FrontEnd`FileName[ {"..", "..", "IEC-Evolvica.nb"}], 
      "Setting EVOLVICA Directory"},
    ButtonStyle->"Hyperlink"],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SetDirectory[\[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
"\<Chapters\>", \[IndentingNewLine]"\<08-AdvancedGP\>", "\<AntTracker\>", \
"\<Packages\>"}]]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \("/Users/jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/08-\
AdvancedGP/AntTracker/Packages"\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["System Defaults"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData["Print a message whenever a new symbol is created:"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData["Off[General::newsym]"], "Input",
  AspectRatioFixed->True],

Cell[TextData["On[General::stop]"], "Input",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Imported Packages and Notebooks"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["General packages"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Needs[\"Statistics`DescriptiveStatistics`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"LinearAlgebra`CrossProduct`\"]", "Input",
  AspectRatioFixed->True],

Cell["Needs[\"DiscreteMath`Tree`\"];", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`Graphics`\"];", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`Shapes`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Needs[\"Graphics`Graphics3D`\"];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Special notebooks"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"AntTrackerInterpret-Wall.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["General notebooks"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"ExprGeneration.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Get[\"ExprModification.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Expression Generation and Variation", "Subtitle"],

Cell[CellGroupData[{

Cell[" Expression Generation Templates", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Constants"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
numbers = Range[1,10];

constants = 
  Flatten[ numbers ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Patterns"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
patterns = 
{ 
  anExpression[], 
  anExpressionSequence[], 
  aBlank[],
  aSequence[],
  aNull[]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Parameters"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
maxSequenceLength = 3;

stepSize   := Random[Integer, {1,1}];
pitchAngle := Random[Integer,{90,90}];
yawAngle   := Random[Integer,{90,90}];
rollAngle  := Random[Integer,{90,90}];

aIndex     := Random[Integer,{0,4}];
iiIndex    := Random[Integer,{0,4}];
lIndex     := Random[Integer,{0,4}];
mIndex     := Random[Integer,{0,4}];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(lIndex\)\" is similar \
to existing symbol \"\!\(aIndex\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(mIndex\)\" is similar \
to existing symbols \!\({aIndex, lIndex}\)."\)], "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Templates"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  FontColor->RGBColor[0.500008, 0.100999, 0.477989]],

Cell[CellGroupData[{

Cell[TextData["Editable templates"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprGenerationPATTERNSsole :=
{
  AntTracker[_seq],
  
  seq[advance],
  seq[turnLeft],
  seq[turnRight],
  seq[nop],
  seq[stop],
  seq[advance|turnLeft|turnRight,again],
  
  seq[BlankSequence[_seq | 
                    Blank[ifSensor[dust]] |
                    Blank[ifSensor[phero]] |
                    Blank[ifSensor[food]] |
                    Blank[ifSensor[wall]]
                    ]],
  
  ifSensor[dust][_seq,_seq],
  ifSensor[phero][_seq,_seq],
  ifSensor[food][_seq,_seq],
  ifSensor[wall][_seq,_seq],
  
  dust, phero, food, wall,
  advance, turnLeft, turnRight
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Template ranks"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprGenerationRANKS = (* selection probabilities *)
  Flatten[
    {
      {1,    (** AntTracker **)
       
       1,    (** advance **)
       1,    (** turnLeft **)
       1,    (** turnRight **)
       1,    (** nop **)
       1,    (** stop **)
       1,    (** again **)
       6,    (** seq **)
       
       1,    (** ifSensor **)
       1,    (** ifSensor **)
       1,    (** ifSensor **)
       1,    (** ifSensor **)
       
       1, 1, 1, 1, (** dust, phero, food, wall **)
       1, 1, 1 (** advance, turnLeft, turnRight **)
    }, 

      Table[1,{Length[constants]}]       (* constants *)
      
      (* Table[1,{Length[patterns]}] *)      (* patterns *)
    },
    Infinity
  ];
  \
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Templates collection ",
  StyleBox["(do not edit ! )",
    FontSlant->"Italic"]
}], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprGenerationPATTERNS :=
  Flatten[
  Join[
    exprGenerationPATTERNSsole,
    {
     constants

     (* patterns *)
    }
  ]];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[" Expression Modification", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Expression template ranks"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"The hierarchical descriptions of ranked expressions are used by the genetic \
operators in order to find expressions for modification."], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Mutation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprMutationRANKS =
{
  PRexpr[_seq,1,{}],
  PRexpr[ifSensor[dust|phero|food|wall][_seq,_seq],1,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprMutationRANKS::usage = 
\"The ranks used by the mutation operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Crossover"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprCrossoverRANKS = 
{
  PRexpr[_seq,4,{}],
  PRexpr[ifSensor[_][__],1,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprCrossoverRANKS::usage = 
\"The ranks used by the crossover operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Shrink"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprShrinkRANKS =
{
  PRexpr[seq[k__]/;Length[{k}] > 1,2,{}],
  PRexpr[ifSensor[_][__],1,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprShrinkRANKS::usage = 
\"The ranks used by the shrink operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Duplication"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprDuplicationRANKS =
{
  PRexpr[_seq,2,{}],
  PRexpr[ifSensor[_][__],1,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprDuplicationRANKS::usage = 
\"The ranks used by the duplication operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Permutation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprPermutationRANKS =
{ 
  PRexpr[_seq,2,{}],
  PRexpr[ifSensor[_][__],1,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprPermutationRANKS::usage = 
\"The ranks used by the permutation operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Encapsulation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprEncapsulationRANKS =
{
  PRexpr[x_seq /; Depth[x] > 1,4,{}],
  PRexpr[ifSensor[_][x__] /; Depth[{x}] > 1,1,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprEncapsulationRANKS::usage = 
\"The ranks used by the encapsulation operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Decapsulation"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprDecapsulationRANKS =
{
  PRexpr[_seq,1,{}],
  PRexpr[ifSensor[food][_seq,_seq],1,{}],
  PRexpr[ifSensor[phero][_seq,_seq],1,{}],
  PRexpr[ifSensor[dust][_seq,_seq],1,{}]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprDecapsulationRANKS::usage = 
\"The ranks used by the decapsulation operator\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["GP operator ranks"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "gpOperatorRanksInitial =\n{\n  {REPRO,  0}, ",
  StyleBox["(* reproduction *)\n",
    FontSlant->"Italic"],
  "  (**{ELITIST,0},**) ",
  StyleBox["(* elitist reproduction *)",
    FontSlant->"Italic"],
  "\n  {MUTAT,  0.4}, ",
  StyleBox["(* mutation *)",
    FontSlant->"Italic"],
  "\n  {CROSS,  0.4}, ",
  StyleBox["(* crossover *)",
    FontSlant->"Italic"],
  "\n  {SHRINK, 0.1}, ",
  StyleBox["(* shrink *)\n  ",
    FontSlant->"Italic"],
  "{DUPL,   0.2}, ",
  StyleBox["(* duplication *)",
    FontSlant->"Italic"],
  "\n  {PERM,   0.2}, ",
  StyleBox["(* permutation *)",
    FontSlant->"Italic"],
  "\n  {ENCAPS, 0.0}, ",
  StyleBox["(* encapsulation *)\n  ",
    FontSlant->"Italic"],
  "{DECAPS, 0.0} ",
  StyleBox[" (* decapsulation *)\n};",
    FontSlant->"Italic"]
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[{
  StyleBox["(* These ranks will be adjusted automatically ... *)",
    FontSlant->"Italic"],
  "\n\ngpOperatorRanks = Sort[gpOperatorRanksInitial];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
gaOperatorAttributes := Map[Last[#]&,Sort[gpOperatorRanks]];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["GP Evolution", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Evolution control"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Global symbols"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
population = {};
newPopulation = {};

generationsList = {};

populationHistory = {};
populationHistoryList = {};

populationFitnesses = {};
(* populationFitnessesList = {}; *) (* only needed for fitness histogram *)

\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Control algorithm"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["From Generation to Generation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{\(createNextGeneration[initialPopulation_List, 
            fitnesses_List, generationIndex_Integer, opts___]\), ":=", 
          "\[IndentingNewLine]", 
          RowBox[{"Module", "[", "\[IndentingNewLine]", 
            
            RowBox[{\({currentGeneration = {}, currentFitnesses = {}, 
                nextGeneration = {}, members, maxMembers, 
                restMembers, \
\[IndentingNewLine]\[IndentingNewLine]generationGap = \
\[IndentingNewLine]\(GenerationGap /. {opts}\) /. 
                    Options[
                      createNextGeneration], \[IndentingNewLine]\
\[IndentingNewLine]startPattern = \(StartPattern /. {opts}\) /. 
                    Options[
                      createNextGeneration], \[IndentingNewLine]\
\[IndentingNewLine]gaOpAttributes \
:= \[IndentingNewLine]\(GeneticOperatorRanks /. {opts}\) /. 
                    Options[
                      createNextGeneration], \[IndentingNewLine]\
\[IndentingNewLine]operatorCounter, operatorIndex, 
                operatorLabel, \
\[IndentingNewLine]\[IndentingNewLine]operatorRanks = \(GeneticOperatorRanks /. \
{opts}\) /. Options[createNextGeneration]\[IndentingNewLine]}\), ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              
              StyleBox[\( (*\ Reset\ global\ population\ history\ list\ *) \),
                
                FontSlant->"Italic"], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              
              RowBox[{\(populationHistory = {}\), ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ \(--\(-\ 
                            Set\)\)\ current\ population\ and\ fitnesses\  \
... \ *) \),
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(currentGeneration = 
                  initialPopulation\), ";", 
                "\[IndentingNewLine]", \(maxMembers = 
                  Length[currentGeneration]\), ";", 
                "\[IndentingNewLine]", \(members = 
                  Max[1, Floor[maxMembers*generationGap]]\), ";", 
                "\[IndentingNewLine]", \(restMembers = maxMembers - members\),
                 ";", "\[IndentingNewLine]", \(currentFitnesses = fitnesses\),
                 ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ \(--\(-\ 
                            Apply\)\)\ reproduction\ and\ genetic\ operators\ \
 ... \ *) \),
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(operatorCounter = 0\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ 
                    Elitist\ \(selection : \n\t\ \ \ always\ reproduce\ the\ \
best\ so\ far\ individual\)\n\t*) \),
                  FontSlant->"Italic"], 
                StyleBox["\n",
                  FontSlant->"Italic"], \(nextGeneration = 
                  gpElitistReproduction[currentGeneration, currentFitnesses, 
                    nextGeneration]\), ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(operatorCounter += 1\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ \(--\(-\ 
                            Apply\)\)\ genetic\ operators\ until\ next\ \
population\ is\ completed\  ... \ *) \),
                  FontSlant->"Italic"], 
                StyleBox["\n",
                  FontSlant->"Italic"], 
                StyleBox["    ",
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                RowBox[{"While", "[", 
                  RowBox[{\(operatorCounter < members\), ",", 
                    
                    StyleBox[\( (*\ 
                        select\ genetic\ operation\ \(probabilistically : \n\ \
\ \ \ \ \ \ \ \ \ \ \ \ reproduction\), \ mutation, \ 
                        crossover, \  ... \n\ \ \ \ \ \ *) \),
                      FontSlant->"Italic"], 
                    "\[IndentingNewLine]", \(operatorIndex = 
                      rouletteWheelSelectionAttributesOnly[
                        gaOpAttributes]; \[IndentingNewLine]\
\[IndentingNewLine]operatorLabel = 
                      First[gpOperatorRanks[\([operatorIndex]\)]]; \
\[IndentingNewLine]\[IndentingNewLine]protoPrint["\<Operator index: \>", 
                      operatorIndex]; \
\[IndentingNewLine]protoPrint["\<Operator label: \>", 
                      operatorLabel]; \
\[IndentingNewLine]\[IndentingNewLine]Switch[
                      operatorLabel, \[IndentingNewLine]ELITIST, 
                      operatorCounter += 
                        0, \[IndentingNewLine]\[IndentingNewLine]REPRO, \
\[IndentingNewLine]nextGeneration = 
                        gpReproduction[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]MUTAT, \
\[IndentingNewLine]nextGeneration = 
                        gpMutation[currentGeneration, currentFitnesses, 
                          nextGeneration]; \[IndentingNewLine]\ 
                      operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]CROSS, \
\[IndentingNewLine]nextGeneration = 
                        gpCrossover[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        2, \[IndentingNewLine]\[IndentingNewLine]SHRINK, \
\[IndentingNewLine]nextGeneration = 
                        gpShrink[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]DUPL, \
\[IndentingNewLine]nextGeneration = 
                        gpDuplication[currentGeneration, currentFitnesses, 
                          nextGeneration]; \[IndentingNewLine]\ 
                      operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]PERM, \
\[IndentingNewLine]nextGeneration = 
                        gpPermutation[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]ENCAPS, \
\[IndentingNewLine]nextGeneration = 
                        gpEncapsulation[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 
                        1, \[IndentingNewLine]\[IndentingNewLine]DECAPS, \
\[IndentingNewLine]nextGeneration = 
                        gpDecapsulation[currentGeneration, currentFitnesses, 
                          nextGeneration]; \ \
\[IndentingNewLine]operatorCounter += 1];\)}], " ", "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", \( (*end\ switch*) \), 
                  "\[IndentingNewLine]", "]"}], ";", " ", 
                "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \( (*end\ while\ operators*) \), 
                
                StyleBox[\( (*\ 
                    Fill\ up\ the\ rest\ with\ new\ expressions\ *) \),
                  FontSlant->"Italic"], 
                StyleBox["\n",
                  FontSlant->"Italic"], 
                StyleBox["    ",
                  FontSlant->"Italic"], 
                "\[IndentingNewLine]", \(If[restMembers > 0, 
                  nextGeneration = 
                    Join[nextGeneration, 
                      exprGeneration[restMembers, 
                        startPattern]]\[IndentingNewLine]]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Return\ next\ generation\ *) \),
                  FontSlant->"Italic"], "\[IndentingNewLine]", 
                "nextGeneration"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
      " ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", \( (*end\ \(module : 
            createNextGeneration\)*) \)}]], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(GenerationGap\)\" is \
similar to existing symbol \"\!\(generationGap\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(StartPattern\)\" is \
similar to existing symbol \"\!\(startPattern\)\"."\)], "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[createNextGeneration] =
{
  GeneticOperatorRanks :> gaOperatorAttributes,
  
  GenerationGap -> 1.0
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Interactive Evolution"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "Expression ",
  StyleBox["generation",
    FontSlant->"Italic"]
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Generating Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprGeneration[howManyIndividuals_Integer,startPattern_,opts___] :=

Module[{newGeneration = {}},
  
  While[Length[newGeneration] < howManyIndividuals,
  
    newGeneration =
      Append[
        newGeneration,
        doGenerateExprWithStart[
          startPattern,
          opts
        ]
      ] // Union
  ];
    
  (***
  Table[
    doGenerateExprWithStart[
      startPattern,
      opts
    ],
    {howManyIndividuals}
  ];
  ***)
  
  resultInfo[
    \"Generated expressions:\",newGeneration,
      Formatter -> ColumnForm
    ];
    
  newGeneration
  
]; (* end module *)
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[exprGeneration] =
{
  GenerationPatterns -> exprGenerationPATTERNS,
  GenerationRanks -> exprGenerationRANKS
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Expression ",
  StyleBox["interpretation",
    FontSlant->"Italic"]
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Messages"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["", "Input",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Evaluating Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "exprEvaluation[expr_, generation_, index_, opts___] :=\n  \
Module[{exprDecoded,exprFitness, maxDepth,d\n         },\n         \n     ",
  StyleBox["(** Convert all strings to expressions \n         and replace all \
encapsulated expressions\n         by their extended definitions **)",
    FontSlant->"Italic"],
  "\n     \n    \n     ",
  StyleBox["(** Call expr. decoding ... **)\n     \n     ",
    FontSlant->"Italic"],
  "maxEvaluationTime = 10;",
  StyleBox[" (* seconds *)\n     \n     ",
    FontSlant->"Italic"],
  "evalValue = ",
  StyleBox["\n     ",
    FontSlant->"Italic"],
  "  evaluateAntProgram[\n         expr //.",
  StyleBox[" ",
    FontSlant->"Italic"],
  "encapsRulesList];\n            \n     ",
  StyleBox["(** Call expr. interpretation here ... **)",
    FontSlant->"Italic"],
  "\n     \n     \n     ",
  StyleBox["(** Calculate phenotype fitness ... **)",
    FontSlant->"Italic"],
  "\n     \n     maxDepth = 12;\n     \n     If[(d = Depth[expr //. \
encapsRulesList]) <= maxDepth,\n       1+ foodEaten,\n       1.+ \
N[(maxDepth/d) foodEaten]\n     ]\n     \n  ];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[exprEvaluation] =
{
  decodingRules -> \"not yet implemented\",
  decodingFunction -> \"not yet implemented\",
  interpretationFunction -> \"not yet implemented\",
  LSystemIterations -> 1
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Population ",
  StyleBox["evaluation",
    FontSlant->"Italic"]
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Evaluating a Population of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "populationEvaluation[population_,generation_, opts___] :=\n  Module[{},\n  \
  \n    ",
  StyleBox["(* Reset global graphics lists *)",
    FontSlant->"Italic"],
  "\n    \n    globalTurtleGraphics = {};\n    \n    ",
  StyleBox["(* Compute new fitnesses ... *)",
    FontSlant->"Italic"],
  "\n    \n    populationFitnesses = \n      MapIndexed[\n        \
exprEvaluation[#1,generation,#2,opts]&,\n        population\n      ];\n    \n \
   protoPrint[\"Population fitnesses: \"];\n    \
protoPrint[populationFitnesses];\n    \n    \
AppendTo[fitnessesListSorted,Reverse[Sort[populationFitnesses]]];\n    \n    \
If[(DisplayFitnessCharts /. {opts}) === True,\n      \
fitnessChart3D[fitnessesListSorted,\n        DisplayGeneration -> \
generation,opts]\n    ];\n];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
 Options[populationEvaluation] = 
  {
  \tExperimentName ->    \"Turtles\",
  \tExperimentDirectoryName -> \"Examples\",
  \t
  \tRuleApplications -> 3,
  \t
  \tDisplayInteractiveSelection -> False
  };\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Interactive Control"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Initialization "], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "doEPInitialize[] :=\nModule[{},\n\n",
  StyleBox["  (* Initialize global variables *)\n",
    FontSlant->"Italic"],
  "  \n  population = {};\n  newPopulation = {};\n\n  generationsList = {};\n\
\n  populationHistory = {};\n  populationHistoryList = {};\n\n  \
populationFitnesses = {};  (* ... for the current generation *)\n  \
previousPopFitnesses = {}; (* ... for the previous generation *)\n  \n  \
fitnessesListSorted = {}; (* cumulates all fitnesses *)\n\t\n  \
encapsulationList = {};\n  \n  \n  ",
  StyleBox["(* Reset GA operator ranks to their initial values *)\n  \n  ",
    FontSlant->"Italic"],
  "gpOperatorRanks = Sort[gpOperatorRanksInitial];\n  \n  gpOperatorRanksList \
= {gpOperatorRanks};\n\t\n\t\n\t",
  StyleBox["(* Graphics ... *)",
    FontSlant->"Italic"],
  "\n\t\n\tglobalTurtleGraphics = {};\n\t\n\t\n]; (* end module *)\n"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
 resetFitnesses[] :=
   (populationFitnesses = {}; 
    
    minFitness = {}; 
    maxFitness = {}; 
    aveFitness = {};
   );\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Function"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
evolveExpressions::generationInfo =
 \"Generation: `1`\";
 
evolveExpressions::fitnessesInfo =
 \"Fitnesses: `1`\";
 
evolveExpressions::fitnessMax =
 \"Max. Fitness: `1`\";

evolveExpressions::fitnessMean =
 \"Mean Fitness: `1`\";
 
 evolveExpressions::gpOperatorRanksInfo =
 \"GA Operator Ranks: `1`\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(evolveExpressions[startPattern_, opts___] := 
        Module[{initialPopulationPrivate = {}, newPopulationPrivate = {}, 
            restPopulation = {}, gen = 0, r, runDirName, backupDirName, 
            doDisplayOnScreen, 
            theInput, \[IndentingNewLine]howManyIndividuals = \(Individuals /. \
{opts}\) /. Options[
                  evolveExpressions], \[IndentingNewLine]genCounter = \
\(howManyGenerations = \(Generations /. {opts}\) /. 
                  Options[evolveExpressions]\), 
            runName = \(ExperimentName /. {opts}\) /. 
                Options[evolveExpressions], 
            examplesDir = \(ExamplesDirectory /. {opts}\) /. 
                Options[
                  evolveExpressions], \[IndentingNewLine]newOpts = "\<DEFAULT\
\>" \[Rule] "\<DEFAULT\>"}, \[IndentingNewLine]\[IndentingNewLine] \
(*\(\(*\)\(Initialize\)\(\ \)\(global\)\(\ \)\(symbols\)\) \
... **) \[IndentingNewLine]doEPInitialize[]; \[IndentingNewLine]\
\[IndentingNewLine] (*\(\(*\)\(Then\)\(\ \)\(start\)\(\ \)\(interactive/
                  automatic\)\(\ \)\(expression\)\(\ \)\(evolution\)\) \
... **) \[IndentingNewLine]\[IndentingNewLine] (*\(--\(-First\)\)\ create\ a\ \
directory\ where\ to\ put\ evolution\ data*) \[IndentingNewLine]\
\[IndentingNewLine]If[\((runDirName = 
                  doCreateDirectory[examplesDir, runName])\) === False, 
            Return[]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Generate\)\)\ an\ initial\ population\ of\ expressions*) Off[
            General::stop]; \[IndentingNewLine]Message[
            evolveExpressions::generationInfo, 
            gen + \((\(GenerationOffset /. {opts}\) /. 
                  Options[evolveExpressions])\)]; \[IndentingNewLine]On[
            General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]userInfo["\<Generating initial \
population of expressions ...\>"]; \
\[IndentingNewLine]\[IndentingNewLine]theInput = 
            getUserInputInitialPop[]; \
\[IndentingNewLine]\[IndentingNewLine]If[theInput === stop, 
            Break[]]; \
\[IndentingNewLine]\[IndentingNewLine]{initialPopulationPrivate, 
              encapsRulesList} = 
            Which[theInput === {}, \[IndentingNewLine]{exprGeneration[
                  howManyIndividuals, 
                  startPattern], {}}, \
\[IndentingNewLine]\[IndentingNewLine]StringQ[theInput[\([1]\)]] && 
                NumberQ[
                  theInput[\([2]\)]] && \((theInput[\([3]\)] === all)\), {Get[
                  StringJoin[examplesDir, $PathnameSeparator, 
                    theInput[\([1]\)], $PathnameSeparator, 
                    theInput[\([1]\)], "\<.\>", 
                    ToString[theInput[\([2]\)]], "\<.pop\>"]], 
                Get[StringJoin[examplesDir, $PathnameSeparator, 
                    theInput[\([1]\)], $PathnameSeparator, 
                    theInput[\([1]\)], "\<.\>", 
                    ToString[
                      theInput[\([2]\)]], "\<.enc\>"]]}, \[IndentingNewLine]\
\[IndentingNewLine]StringQ[theInput[\([1]\)]] && 
                Length[theInput] \[Equal] 
                  3, {\(Get[
                    StringJoin[examplesDir, $PathnameSeparator, 
                      theInput[\([1]\)], $PathnameSeparator, 
                      theInput[\([1]\)], "\<.\>", 
                      ToString[
                        theInput[\([2]\)]], \
"\<.pop\>"]]\)[\([theInput[\([3]\)]]\)], 
                Get[StringJoin[examplesDir, $PathnameSeparator, 
                    theInput[\([1]\)], $PathnameSeparator, 
                    theInput[\([1]\)], "\<.\>", 
                    ToString[
                      theInput[\([2]\)]], "\<.enc\>"]]}, \[IndentingNewLine]\
\[IndentingNewLine]True, 
              Print["\<Do not understand the input:\>", 
                theInput]; \[IndentingNewLine]Print["\<Generating new \
expressions ...\>"]; \[IndentingNewLine]exprGeneration[howManyIndividuals, 
                startPattern]\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-Evaluate\)\)\ expressions ... *) 
            userInfo["\<Starting expression evaluation ...\>"]; \
\[IndentingNewLine]resetFitnesses[]; \
\[IndentingNewLine]\[IndentingNewLine]population = 
            initialPopulationPrivate; \
\[IndentingNewLine]\[IndentingNewLine]populationEvaluation[population, gen, 
            ExperimentDirectoryName \[Rule] runDirName, 
            ExperimentName \[Rule] runName, 
            opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
            General::stop]; \[IndentingNewLine]Message[
            evolveExpressions::fitnessesInfo, 
            populationFitnesses]; \[IndentingNewLine]On[
            General::stop]; \[IndentingNewLine]Off[
            General::stop]; \[IndentingNewLine]Message[
            evolveExpressions::fitnessMax, 
            Max[populationFitnesses]]; \[IndentingNewLine]On[
            General::stop]; \[IndentingNewLine]Off[
            General::stop]; \[IndentingNewLine]Message[
            evolveExpressions::fitnessMean, 
            N[Mean[populationFitnesses]]]; \[IndentingNewLine]On[
            General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
            populationFitnesses, Generation \[Rule] gen, 
            ExperimentDirectoryName \[Rule] runDirName, 
            ExperimentName \[Rule] runName, newOpts, 
            opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
            showTurtleGraphics[globalTurtleGraphics, gen, 
              opts]]; \[IndentingNewLine]\[IndentingNewLine] (*\(--\(-Now\)\)\
\ populationFitnesses\ contains\ the\ fitness\ values*) \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-The\)\)\ interactive\ evolution\ loop \
... *) \[IndentingNewLine]\[IndentingNewLine]While[
            True,  (*Interactive\ dialog\ panels ... *) \[IndentingNewLine] \
(*Indices ... *) \[IndentingNewLine]userInputIndices = 
              getUserInputIndices[]; \[IndentingNewLine]\[IndentingNewLine]If[
              userInputIndices === stop, 
              Print["\<Evolution aborted ...\>"]; \ 
              Break[]]; \[IndentingNewLine]\[IndentingNewLine] (*Generations \
... *) \[IndentingNewLine]userInputGen = 
              getUserInputGen[
                genCounter]; \[IndentingNewLine]\[IndentingNewLine] (*Options \
... *) \[IndentingNewLine]userInputOpts = 
              getUserInputOpts[]; \[IndentingNewLine]If[
              userInputOpts \[NotEqual] {}, 
              newOpts = 
                Apply[Sequence, 
                  userInputOpts]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Now\)\)\ construct\ a\ new\ population ... *) \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-Collect\)\)\ expressions\ due\ to\ user\ input \
... *) \[IndentingNewLine]\[IndentingNewLine]If[userInputIndices === all, 
              userInputIndices = 
                Range[1, 
                  Length[population]]]; \
\[IndentingNewLine]\[IndentingNewLine]If[
              userInputIndices === {}, \
\[IndentingNewLine]newPopulationPrivate = {}, \
\[IndentingNewLine]newPopulationPrivate = 
                Flatten[
                  Table[theInput = 
                      userInputIndices[\([i]\)]; \[IndentingNewLine]Which[\
\[IndentingNewLine]NumberQ[theInput], 
                      population[\([theInput]\)], \[IndentingNewLine]\
\[IndentingNewLine]VectorQ[theInput] && 
                        Length[theInput] \[Equal] 0, \[IndentingNewLine]\t
                      First[exprGeneration[1, 
                          startPattern]], \[IndentingNewLine]\
\[IndentingNewLine]VectorQ[theInput] && 
                        Length[theInput] \[Equal] 1, \[IndentingNewLine]\t
                      population[\([First[
                            theInput]]\)], \[IndentingNewLine]\
\[IndentingNewLine]VectorQ[theInput] && 
                        Length[theInput] \[Equal] 
                          2, \[IndentingNewLine]\t\(Get[
                          StringJoin[examplesDir, $PathnameSeparator, 
                            runName, $PathnameSeparator, runName, "\<.\>", 
                            ToString[First[theInput]], "\<.pop\>"]]\)[\([Last[
                            theInput]]\)], \[IndentingNewLine]\
\[IndentingNewLine]VectorQ[theInput] && Length[theInput] \[Equal] 3 && 
                        NumberQ[theInput[\([3]\)]], \(Get[
                          StringJoin[examplesDir, $PathnameSeparator, 
                            theInput[\([1]\)], $PathnameSeparator, 
                            theInput[\([1]\)], "\<.\>", 
                            ToString[
                              theInput[\([2]\)]], "\<.pop\>"]]\)[\([theInput[\
\([3]\)]]\)], \[IndentingNewLine]\[IndentingNewLine]StringQ[
                          theInput[\([1]\)]] && 
                        NumberQ[
                          theInput[\([2]\)]] && \((theInput[\([3]\)] === 
                            all)\), 
                      Get[StringJoin[examplesDir, $PathnameSeparator, 
                          theInput[\([1]\)], $PathnameSeparator, 
                          theInput[\([1]\)], "\<.\>", 
                          ToString[
                            theInput[\([2]\)]], "\<.pop\>"]], \
\[IndentingNewLine]\[IndentingNewLine]True, \[IndentingNewLine]Print["\<Do \
not understand: \>", ToString[
                          theInput]]; \[IndentingNewLine]Print["\<New \
individual generated ...\>"]; \[IndentingNewLine]First[
                        exprGeneration[1, 
                          startPattern]]\[IndentingNewLine]], \
\[IndentingNewLine]{i, 1, 
                      Length[userInputIndices]}\[IndentingNewLine]]\
\[IndentingNewLine]]\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-Add\)\)\ new\ expressions\ up\ to\ population\ \
capacity ... *) \[IndentingNewLine]\[IndentingNewLine]If[\((r = 
                    Length[population] - Length[newPopulationPrivate])\) > 0, 
              userInfo["\<Generating \>", 
                ToString[
                  r], "\< individuals ...\>"]; \
\[IndentingNewLine]restPopulation = 
                exprGeneration[r, 
                  startPattern]; \[IndentingNewLine]newPopulationPrivate = 
                Join[newPopulationPrivate, 
                  restPopulation];\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*Now\ evaluate\ this\ new\ population \
... *) \[IndentingNewLine]\[IndentingNewLine]\(gen++\); \
\[IndentingNewLine]population = 
              newPopulationPrivate; \[IndentingNewLine]\[IndentingNewLine]Off[
              General::stop]; \[IndentingNewLine]Message[
              evolveExpressions::generationInfo, 
              gen + \((\(GenerationOffset /. {opts}\) /. 
                    Options[evolveExpressions])\)]; \[IndentingNewLine]On[
              General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]userInfo["\<Starting expression \
evaluation (after IS dialogue) ... \>" <> "\<(Gen: \>" <> 
                ToString[
                  gen] <> "\<)\>"]; \
\[IndentingNewLine]\[IndentingNewLine]populationFitnesses = {}; \
\[IndentingNewLine]\[IndentingNewLine]populationEvaluation[population, gen, 
              ExperimentDirectoryName \[Rule] runDirName, 
              ExperimentName \[Rule] runName, 
              DisplayInteractiveSelection \[Rule] True, 
              opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
              General::stop]; \[IndentingNewLine]Message[
              evolveExpressions::fitnessesInfo, 
              populationFitnesses]; \[IndentingNewLine]On[
              General::stop]; \[IndentingNewLine]Off[
              General::stop]; \[IndentingNewLine]Message[
              evolveExpressions::fitnessMax, 
              Max[populationFitnesses]]; \[IndentingNewLine]On[
              General::stop]; \[IndentingNewLine]Off[
              General::stop]; \[IndentingNewLine]Message[
              evolveExpressions::fitnessMean, 
              N[Mean[populationFitnesses]]]; \[IndentingNewLine]On[
              General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
              populationFitnesses, Generation \[Rule] gen, 
              ExperimentDirectoryName \[Rule] runDirName, 
              ExperimentName \[Rule] runName, newOpts, 
              
              opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
              showTurtleGraphics[globalTurtleGraphics, gen, 
                opts]]; \[IndentingNewLine]\[IndentingNewLine] (*Start\ \
automatic\ evolution\ loop ... *) \[IndentingNewLine]\[IndentingNewLine]If[
              NumberQ[userInputGen], genCounter = userInputGen; \ 
              protoPrint["\< \>"]; \
\[IndentingNewLine]protoPrint["\<genCounter set to \>", 
                genCounter]]; \[IndentingNewLine]\[IndentingNewLine]Do[\
\[IndentingNewLine]userInfo["\<Starting expression evolution process ... \>" <> \
"\<(Gen: \>" <> ToString[
                    gen] <> "\<)\>"]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Create\)\)\ the\ next\ generation \
... *) \[IndentingNewLine]population = 
                createNextGeneration[population, populationFitnesses, gen, 
                  StartPattern \[Rule] startPattern, newOpts, 
                  opts]; \[IndentingNewLine]\[IndentingNewLine]\(gen++\); \
\[IndentingNewLine]\[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                evolveExpressions::generationInfo, 
                gen + \((\(GenerationOffset /. {opts}\) /. 
                      Options[evolveExpressions])\)]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]\[IndentingNewLine] (*\(\(\
\(*\)\(resultInfo["\<Generation \>" <> ToString[gen] <> "\<:\>", population, 
                      Formatter \[Rule] 
                        ColumnForm]\)\);\)**) \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(-Evaluate\)\)\ this\ new\ generation \
... *) \[IndentingNewLine]\[IndentingNewLine]userInfo["\<Starting expression \
interpretation ...\>" <> "\<(Gen: \>" <> 
                  ToString[
                    gen] <> "\<)\>"]; \[IndentingNewLine]\[IndentingNewLine] \
(*Keep\ fitnesses\ of\ the\ previous\ generation ... *) 
                previousPopFitnesses = 
                populationFitnesses; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Evaluate\)\)\ new\ generation ... *) 
                populationFitnesses = {}; \
\[IndentingNewLine]populationEvaluation[population, gen, 
                ExperimentDirectoryName \[Rule] runDirName, 
                ExperimentName \[Rule] runName, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                evolveExpressions::fitnessesInfo, 
                populationFitnesses]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                evolveExpressions::fitnessMax, 
                Max[populationFitnesses]]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                evolveExpressions::fitnessMean, 
                N[Mean[populationFitnesses]]]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]\[IndentingNewLine] (*\(\
--\(-Adjust\)\)\ GP\ operator\ ranks ... *)  (*\(\(\(*\)\(Print["\<GP-Adj: \
\>", \(AdjustOperatorRanks /. {opts}\) /. Options[evolveExpressions]]\)\);\)**) 
                If[\[IndentingNewLine]\[IndentingNewLine]\(\
AdjustOperatorRanks /. {opts}\) /. 
                  Options[
                    evolveExpressions],  (*\(\(\(*\)\(Print["\<Adjusting \
operator ranks \
...\>"]\)\);\)**) \[IndentingNewLine]\[IndentingNewLine]adjustgpOperatorRanks[
                  opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
                  General::stop]; \[IndentingNewLine]Message[
                  evolveExpressions::gpOperatorRanksInfo, 
                  ColumnForm[gpOperatorRanks]]; \[IndentingNewLine]Off[
                  General::stop]]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
                populationFitnesses, Generation \[Rule] gen, 
                ExperimentDirectoryName \[Rule] runDirName, 
                ExperimentName \[Rule] runName, newOpts, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
                showTurtleGraphics[globalTurtleGraphics, gen, 
                  opts]], \
\[IndentingNewLine]{genCounter}\[IndentingNewLine]]; \[IndentingNewLine] (*\(\
--\(-end\)\)\ \(of : 
                  automatic\ evolution\ loop ... \)*) \[IndentingNewLine]\
\[IndentingNewLine] (*Visualize\ GP\ operator\ ranks*)  \
(*\(\(\(**\)\(gaRanksChart3D[
                    gpOperatorRanksList]\)\);\)***) \[IndentingNewLine]]; \  \
(*end\ while*) \[IndentingNewLine] (*\(--\(-end\)\)\ \(of : 
                
                interactive\ evolution\ loop ... \)*) \[IndentingNewLine]];\)\
\(\ \)\( (*end\ module*) \)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Generations\)\" is \
similar to existing symbol \"\!\(Generation\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(all\)\" is similar to \
existing symbol \"\!\(All\)\"."\)], "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Options[evolveExpressions] =
{
  Individuals -> 4,
  Generations -> 1,
  
  AdjustOperatorRanks -> False,
  
  DisplayPopulationGraphics -> True,
  DisplayFitnessCharts -> True,
  DisplayOperatorRanks -> True,
  
  GenerationOffset -> 0,
  
  ExperimentName -> \"ExprTest\",
  ExamplesDirectory -> $basicDirectory <> $PathnameSeparator <> \"Examples\"
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(StringJoin::"string" \(\(:\)\(\ \)\) 
      "String expected at position \!\(1\) in \!\($basicDirectory <> \"/\" <> \
\"Examples\"\)."\)], "Message"],

Cell[BoxData[
    \(StringJoin::"string" \(\(:\)\(\ \)\) 
      "String expected at position \!\(1\) in \!\($basicDirectory <> \
\"/Examples\"\)."\)], "Message"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Protocolling"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{\(protocolPopulation[population_List, fitnesses_List, 
            opts___]\), ":=", 
          RowBox[{"Module", "[", 
            
            RowBox[{\({dumpFileName, expFileName, 
                protoFile, \[IndentingNewLine]gen = \((\(Generation /. {opts}\
\) /. Options[protocolPopulation])\) + \((\(GenerationOffset /. {opts}\) /. 
                        Options[protocolPopulation])\)}\), ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              
              RowBox[{\(expFileName = \((\(ExperimentDirectoryName /. \
{opts}\) /. 
                        Options[
                          protocolPopulation])\) <> $PathnameSeparator <> \((\
\(ExperimentName /. {opts}\) /. Options[protocolPopulation])\)\), ";", 
                "\[IndentingNewLine]", 
                "\[IndentingNewLine]", \(dumpFileName = 
                  expFileName <> "\<.\>" <> ToString[gen]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ population\  ... \ *) \),
                  FontSlant->"Italic"], 
                "\[IndentingNewLine]", \(protoFile = 
                  dumpFileName <> "\<.pop\>"\), ";", 
                "\[IndentingNewLine]", \(Put[population, protoFile]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ 
                    Save\ fitness\ function\ definition\  ... \ *) \),
                  FontSlant->"Italic"], \(If[gen === 0, 
                  protoFile = 
                    dumpFileName <> "\<.fitFct\>"; \[IndentingNewLine]Save[
                    protoFile, exprEvaluation]\[IndentingNewLine]]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ fitnesses\  ... \ *) \),
                  FontSlant->"Italic"], 
                "\[IndentingNewLine]", \(protoFile = 
                  dumpFileName <> "\<.fit\>"\), ";", 
                "\[IndentingNewLine]", \(Put[fitnesses, protoFile]\), ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ operator\ history\  ... \ *) \),
                  FontSlant->"Italic"], \(protoFile = 
                  dumpFileName <> "\<.hist\>"\), ";", 
                "\[IndentingNewLine]", \(Put[populationHistory, protoFile]\), 
                ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                StyleBox[\( (*\ 
                    Save\ encapsulation\ definitions\  ... \ *) \),
                  FontSlant->"Italic"], \(protoFile = 
                  dumpFileName <> "\<.enc\>"\), ";", 
                "\[IndentingNewLine]", \(Put[encapsRulesList, protoFile]\), 
                ";", \(protoFile = dumpFileName <> "\<.pat\>"\), ";", 
                "\[IndentingNewLine]", \(Put[encapsPatternList, protoFile]\), 
                ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                StyleBox[\( (*\ Save\ GP\ operator\ ranks\  ... \ *) \),
                  FontSlant->"Italic"], 
                StyleBox["\n",
                  FontSlant->"Italic"], \(protoFile = 
                  dumpFileName <> "\<.opr\>"\), ";", 
                "\[IndentingNewLine]", \(Put[gpOperatorRanksList, 
                  protoFile]\), ";"}]}], 
            StyleBox["  ",
              FontSlant->"Italic"], "\[IndentingNewLine]", 
            StyleBox["]",
              FontSlant->"Italic"]}]}], 
        StyleBox[";",
          FontSlant->"Italic"]}], 
      StyleBox[" ",
        FontSlant->"Italic"], 
      StyleBox[\( (*\ end\ module\ *) \),
        FontSlant->"Italic"]}]], "Input",
  InitializationCell->True],

Cell["\<\
Options[protocolPopulation] :=
{
  
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Utilities"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["File Input/Output"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(doCreateDirectory[examplesDir_String, runName_String] := 
        Module[{runDirName, backupDirName, userInput}, 
          Off[RenameDirectory::filex]; \  (*\(*\)\(Switch\)\(\ \)\(off\)\(\ \
\)\(warning\)\(\ \
\)\(message\)**) \[IndentingNewLine]\[IndentingNewLine]runDirName = 
            StringJoin[examplesDir, $PathnameSeparator, 
              runName]; \[IndentingNewLine]backupDirName = 
            StringJoin[
              runDirName, "\<~\>"]; \[IndentingNewLine]\[IndentingNewLine]If[
            CreateDirectory[runDirName] =!= runDirName, 
            Print["\<***\>"]; \[IndentingNewLine]Print["\<Could not create \
directory \>", 
              runDirName]; \
\[IndentingNewLine]Print["\<--------------------------------------------------\
------------\>"]; \[IndentingNewLine]If[
              RenameDirectory[runDirName, backupDirName] =!= backupDirName, 
              Print["\<***\>"]; \[IndentingNewLine]Print["\<Directory \>", 
                runDirName, "\< and backup \>", 
                backupDirName, "\< already exist!\>"]; \
\[IndentingNewLine]Print["\<--------------------------------------------------\
------------\>"]; \[IndentingNewLine]\[IndentingNewLine]While[True, 
                userInput = 
                  InputString["\<Delete backup? (y/n) \>"]; \
\[IndentingNewLine]If[userInput \[Equal] "\<y\>", 
                  DeleteDirectory[backupDirName, 
                    DeleteContents \[Rule] 
                      True]; \[IndentingNewLine]RenameDirectory[runDirName, 
                    backupDirName]; \[IndentingNewLine]Break[], \(Return[
                      False];\)\[IndentingNewLine]];\[IndentingNewLine]];\
\[IndentingNewLine]]; \[IndentingNewLine]\[IndentingNewLine]CreateDirectory[
              runDirName], 
            Print["\<***\>"]; \[IndentingNewLine]Print["\<Directory created: \
\>", runDirName]; \
\[IndentingNewLine]Print["\<--------------------------------------------------\
------------\>"];]; \[IndentingNewLine]On[
            RenameDirectory::filex]; \  (*\(*\)\(Switch\)\(\ \)\(warning\)\(\ \
\)\(message\)\(\ \)\(on\)\(\ \)\(again\)**) \[IndentingNewLine]\
\[IndentingNewLine]Return[runDirName];\[IndentingNewLine]];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Screen output and formatting"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
userInfo[message_String] :=
  Module[{},

    Return[];
    Print[\" \"];
    Print[\"----------------------------------------------------------\"];
    Print[message];
    Print[\"----------------------------------------------------------\"];
    Print[\" \"];
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
resultInfo[message_String, result_, opts___] :=
  Module[
    {theFormatter =
      Formatter /. {opts} /. Options[resultInfo]
    },
    
    Print[\" \"];
    Print[message];
    Print[\"----------------------------------------------------------\"];
    Print[result // theFormatter];
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[resultInfo] =
{
  Formatter -> Identity
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
ClearAll[theMessage];

theMessage[message__] :=
Module[{},

  i::info = First[{message}];
  Off[General::stop];
  Message[i::info,Apply[Sequence,Rest[{message}]]];
  On[General::stop]
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Input panel utilities"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
getInput[
  panelMessage_String,
  notebookMessage_List 
] :=
  Module[{theInput},
    
    Print[\" \"];
    Print[\"***** Input panel information: *****\"];
    Print[\" \"];
    Print[notebookMessage // ColumnForm];
    Print[\" \"];
    
    theInput = Input[panelMessage];
    
    Print[\"INPUT: \",theInput];
    Print[\" \"];
    Print[\"***** End of input panel info *****\"];
    Print[\" \"];

    theInput
  ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
getUserInputIndices[] :=
  Module[{},
  
    getInput[
      \"Index list: { {generation,index}.. }\",
      {
       \"Enter an index list for the expressions to be selected.\",
       \"Enter a list of the form: { {generation,index}.. }\",
       \" \",
       \"If you only enter an index this refers to the last generation.\",
       \" \",
       \"Enter 'all' to refer to the whole population.\",
       \" \",
       \"Enter 'stop' to abort.\"
       }
     ]
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
getUserInputOpts[] :=
  Module[{},
  
    getInput[
      \"Options: { symbol -> value .. }\",
      {
       \"Enter a list of rules: { symbol -> value .. }\",

       \"Enter {} for no additonal options.\"
       }
     ]
  ];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
  getUserInputGen[genCounter_Integer] :=
  Module[{},
  
    getInput[
      \"Evolution steps:\",
      {
       \"How many evolution steps? (current value: \",
       StringJoin[\"Current value: \",ToString[genCounter]],
       \" \",
       \"Enter a single number.\"
      }
     ]
   ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
  getUserInputInitialPop[] :=
  Module[{},
  
    getInput[
      \"Initial population: (Enter {} for a random population.)\",
      {\"\"}
     ]
   ];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Visualization"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Expression visualization"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Initialization "], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "doVisuInitialize[] :=\nModule[{},\n\n",
  StyleBox["  (* Initialize global variables *)\n",
    FontSlant->"Italic"],
  "  \n  population = {};\n  newPopulation = {};\n\n  generationsList = {};\n\
\n  populationHistory = {};\n  populationHistoryList = {};\n\n  \
populationFitnesses = {};  (* ... for the current generation *)\n  \
previousPopFitnesses = {}; (* ... for the previous generation *)\n  \n  \
fitnessesListSorted = {}; (* cumulates all fitnesses *)\n\t\n  \
encapsulationList = {};\n  \n  \n  ",
  StyleBox["(* Reset GA operator ranks to their initial values *)\n  \n  ",
    FontSlant->"Italic"],
  "gpOperatorRanks = Sort[gpOperatorRanksInitial];\n  \n  gpOperatorRanksList \
= {gpOperatorRanks};\n\t\n\t\n\t",
  StyleBox["(* Graphics ... *)",
    FontSlant->"Italic"],
  "\n\t\n\tglobalTurtleGraphics = {};\n\t\n\tdisplayGenIndexList = {}; (* the \
indices of the generations *)\n\t                          (* to be displayed \
               *)\n\t\n]; (* end module *)\n"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
 resetFitnesses[] :=
   (populationFitnesses = {}; 
    
    minFitness = {}; 
    maxFitness = {}; 
    aveFitness = {};
   );\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Function"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
visualizeExpressions::generationInfo =
 \"Generation: `1`\";
 
visualizeExpressions::fitnessesInfo =
 \"Fitnesses: `1`\";
 
visualizeExpressions::fitnessMax =
 \"Max. Fitness: `1`\";
 
 visualizeExpressions::gpOperatorRanksInfo =
 \"GA Operator Ranks: `1`\";\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(visualizeExpressions[
          opts___] \
:= \[IndentingNewLine]Module[\[IndentingNewLine]{initialPopulationPrivate = \
{}, newPopulationPrivate = {}, restPopulation = {}, gen = 0, r, runDirName, 
            backupDirName, doDisplayOnScreen, 
            theInput, \[IndentingNewLine]\[IndentingNewLine]initialInput = \
\(InitialInput /. {opts}\) /. 
                Options[
                  visualizeExpressions], \[IndentingNewLine]\
\[IndentingNewLine]runName = \(ExperimentName /. {opts}\) /. 
                Options[
                  visualizeExpressions], \[IndentingNewLine]\
\[IndentingNewLine]examplesDir = \(ExamplesDirectory /. {opts}\) /. 
                Options[
                  visualizeExpressions], \[IndentingNewLine]\
\[IndentingNewLine]newOpts = "\<DEFAULT\>" \[Rule] "\<DEFAULT\>"}, \
\[IndentingNewLine]\[IndentingNewLine] (*Define\ some\ local\ function\ \
modules*) \[IndentingNewLine]\[IndentingNewLine]\
populationEvaluateAndVisualize[pop_, 
              gen_] := \(( (*\(--\(-Evaluate\)\)\ expressions \
... *) \[IndentingNewLine]userInfo["\<Starting expression evaluation ...\>"]; \
\[IndentingNewLine]resetFitnesses[]; \[IndentingNewLine]\[IndentingNewLine] \
(*Update\ the\ list\ of\ generation\ indices*) AppendTo[displayGenIndexList, 
                gen]; \[IndentingNewLine]\[IndentingNewLine] (*Evaluate\ \
population*) \[IndentingNewLine]population = 
                pop; \[IndentingNewLine]\[IndentingNewLine]\
populationEvaluation[population, gen, 
                ExperimentDirectoryName \[Rule] 
                  runDirName, \[IndentingNewLine]ExperimentName \[Rule] 
                  runName, \[IndentingNewLine]GenIndices \[Rule] 
                  displayGenIndexList, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                visualizeExpressions::fitnessesInfo, 
                populationFitnesses]; \[IndentingNewLine]On[
                General::stop]; \[IndentingNewLine]Off[
                General::stop]; \[IndentingNewLine]Message[
                visualizeExpressions::fitnessMax, 
                Max[populationFitnesses]]; \[IndentingNewLine]On[
                General::stop]; \
\[IndentingNewLine]\[IndentingNewLine]protocolPopulation[population, 
                populationFitnesses, 
                Generation \[Rule] 
                  gen, \[IndentingNewLine]ExperimentDirectoryName \[Rule] 
                  runDirName, ExperimentName \[Rule] runName, newOpts, 
                opts]; \[IndentingNewLine]\[IndentingNewLine]If[\((\
DisplayPopulationGraphics /. {opts})\) === True, 
                showTurtleGraphics[globalTurtleGraphics, gen, 
                  opts]];\[IndentingNewLine])\); \ \[IndentingNewLine] (*end\ \
of\ first\ function\ \
definition*) \[IndentingNewLine]\[IndentingNewLine]doEvaluateInput[
              inputExpr_] \
:= \[IndentingNewLine]\((\(Map[\((initialPopulationPrivate = \
\[IndentingNewLine]Which[# === {}, 
                          exprGeneration[howManyIndividuals, startPattern], 
                          StringQ[#[\([1]\)]] && 
                            NumberQ[#[\([2]\)]] && \((#[\([3]\)] === all)\), 
                          Get[StringJoin[
                              examplesDir, $PathnameSeparator, #[\([1]\)], \
$PathnameSeparator, #[\([1]\)], "\<.\>", ToString[#[\([2]\)]], "\<.pop\>"]], 
                          StringQ[#[\([1]\)]] && 
                            Length[#] \[Equal] 
                              3, {\(Get[
                                StringJoin[
                                  examplesDir, $PathnameSeparator, \
#[\([1]\)], $PathnameSeparator, #[\([1]\)], "\<.\>", 
                                  ToString[#[\([2]\)]], \
"\<.pop\>"]]\)[\([#[\([3]\)]]\)]}, True, 
                          Print["\<Do not understand the input:\>", #]; \
\[IndentingNewLine]Print["\<Generating new expressions ...\>"]; \
\[IndentingNewLine]\[IndentingNewLine]exprGeneration[howManyIndividuals, 
                            startPattern]\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]populationEvaluateAndVisualize[\
\[IndentingNewLine]initialPopulationPrivate, #[\([2]\)]])\) &, \
\[IndentingNewLine]inputExpr];\)\ \[IndentingNewLine] (*end\ map*) )\); \ \
\[IndentingNewLine]\[IndentingNewLine] (*end\ of\ second\ function\ \
definition*)  (*end\ of\ function\ definitions*) \[IndentingNewLine]\
\[IndentingNewLine] (*\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(\
--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(----\)\)\)\)\)\)\)\)\)\)\)\)\)\
\)\)\)\)\)\)\)\)\)\)\)\)\)*)  (*\ 
            Now\ start\ the\ evaluation\ and\ visualization\ process ... *)  \
(*\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(--\(\
--\(--\(--\(--\(--\(--\(--\(----\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\
\)\)\)*) \[IndentingNewLine]\[IndentingNewLine] (*\(\(*\)\(Initialize\)\(\ \)\
\(global\)\(\ \)\(symbols\)\) ... **) \[IndentingNewLine]doVisuInitialize[]; \
\[IndentingNewLine]\[IndentingNewLine] (*\(--\(-First\)\)\ create\ a\ \
directory\ where\ to\ put\ visualization\ data*) 
            If[\((runDirName = doCreateDirectory[examplesDir, runName])\) === 
              False, Return[]]; \[IndentingNewLine]\[IndentingNewLine] (*If\ \
there\ is\ an\ initial\ input\ process\ this\ one\ first*) If[
            initialInput =!= {}, 
            doEvaluateInput[
              initialInput]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(--\(-Now\)\)\ start\ the\ interactive\ visualization\ loop\
*) \[IndentingNewLine]\[IndentingNewLine]While[
            True, \[IndentingNewLine]theInput = 
              getUserInputInitialPop[]; \[IndentingNewLine]If[
              theInput === stop, Break[]]; \[IndentingNewLine]doEvaluateInput[
              theInput]\[IndentingNewLine]]\  (*end\ while\
*) \[IndentingNewLine]];\)\(\ \)\( (*end\ module*) \)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(InitialInput\)\" is \
similar to existing symbol \"\!\(initialInput\)\"."\)], "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Options"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Options[visualizeExpressions] =
{
  InitialInput -> {},
  
  DisplayPopulationGraphics -> True,
  DisplayFitnessCharts -> True,
  
  ExperimentName -> \"ExprVisuTest\",
  ExamplesDirectory -> $basicDirectory <> $PathnameSeparator <> \"Examples\"
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(StringJoin::"string" \(\(:\)\(\ \)\) 
      "String expected at position \!\(1\) in \!\($basicDirectory <> \"/\" <> \
\"Examples\"\)."\)], "Message"],

Cell[BoxData[
    \(StringJoin::"string" \(\(:\)\(\ \)\) 
      "String expected at position \!\(1\) in \!\($basicDirectory <> \
\"/Examples\"\)."\)], "Message"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Graphics"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Fitness charts"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\

fitnessChart[fitnesses_List] :=
Module[{},
  (**
  BarChart[Reverse[Sort[fitnesses]],
    BarEdges -> True,
    BarLabels -> 
      Append[Table[\" \",{Length[fitnesses]-1}],
        Length[fitnesses]],
    BarSpacing -> Automatic,
    BarStyle -> (GrayLevel[0.0]&),
    BarOrientation -> Horizontal,
    DefaultFont -> {\"Helvetica\",12},
    PlotLabel -> \"Sorted Fitnesses Histogram\"
  ];
  **)
  
  ListPlot[Reverse[Sort[fitnesses]],
    PlotJoined -> True
  ];
  
]; (* end module *)\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "\nfitnessChart3D[fitnesses_List,opts___] :=\nModule[{l,r,\n        \
theFitnesses,\n        maxLength,\n        gen =\n          DisplayGeneration \
/. {opts} /. Options[fitnessChart3D],\n        genIndices =\n          \
GenIndices /. {opts} /. Options[fitnessChart3D],\n        genAxisTicks\n      \
 },\n\n  ",
  StyleBox["(* First scale all lists to the same length ... *)",
    FontSlant->"Italic"],
  "\n  \n  theFitnesses = fitnesses;\n  \n  maxLength = \
Max[Map[Length[#]&,theFitnesses]];\n  \n  theFitnesses =\n    Map[\n      \
If[(r = maxLength - Length[#]) > 0,\n        Join[#,Table[-1.,{r}]],\n        \
#\n      ]&,\n      theFitnesses\n    ];\n  \n  ",
  StyleBox["(* Graphics generation and display ... *)",
    FontSlant->"Italic"],
  "\n  \n  l = Length[theFitnesses];\n  \n  If[gen === {},gen = l-1];\n  \
If[genIndices === {},genIndices = Range[l]];\n  \n  genAxisTicks = \
MapIndexed[{First[#2],#1}&,genIndices];\n  \n  If[l > 1,\n    \n    \
ListShadowPlot3D[theFitnesses,\n      ViewPoint -> {1.3, -2.4, 0.7},\n      \
Ticks -> {Automatic,genAxisTicks,Automatic},\n      Color -> True,\n      \
SurfaceMesh -> True,\n      ShadowMesh -> False,\n      PlotLabel -> \n       \
FontForm[\n         \"Sorted Fitnesses History, Gen. \" <> ToString[gen],\n   \
      {\"Helvetica-Bold\",12}\n       ],\n      FaceGrids -> \
{{-1,0,0},{0,1,0}},\n      Boxed -> False,\n      Axes -> True,\n      \
AxesEdge -> {Automatic,{1,-1},Automatic},\n      AxesLabel -> \
{\"Indiv.\",\"Gen.\",\"Fit.\"},\n      DefaultFont -> {\"Helvetica\",12},\n   \
   Background -> GrayLevel[0.8]\n    ],\n    \n    \
BarChart[First[theFitnesses],\n      BarEdges -> True,\n      BarLabels -> \n \
       Append[Table[\" \",{Length[First[theFitnesses]]-1}],\n        \
Length[First[theFitnesses]]],\n      BarSpacing -> Automatic,\n      BarStyle \
-> (GrayLevel[0.0]&),\n      BarOrientation -> Vertical,\n      DefaultFont \
-> {\"Helvetica\",12},\n      PlotLabel -> \n        FontForm[\n          \
\"Sorted Fitnesses Histogram, Gen. \" <> ToString[gen],\n          \
{\"Helvetica-Bold\",12}\n        ],\n      PlotRange -> All,\n      \
Background -> GrayLevel[0.8]\n    ]\n  ];\n  \n]; (* end module *)"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(genIndices\)\" is \
similar to existing symbol \"\!\(GenIndices\)\"."\)], "Message"]
}, Open  ]],

Cell["\<\
Options[fitnessChart3D] =
{
  DisplayGeneration -> {},
  GenIndices -> {}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Turtle graphics"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[showTurtleGraphics] =
{
  TableWidth -> 3
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[{
  "showTurtleGraphics[\n  graphicsList_List,generation_Integer,opts___] :=\n\
Module[{\n  width = TableWidth /. {opts} /. Options[showTurtleGraphics], \n  \
listLength = Length[graphicsList],\n  dummyGraphic,\n  restLength, \
restGraphics,\n  displayGraphicsArray},\n\n  dummyGraphic = \
Show[Graphics3D[{Hue[0.0]}],\n                   Boxed -> False, \
DisplayFunction -> Identity];\n       \n  restLength = Mod[listLength,width]; \
        \n  restGraphics =  \n    If[restLength === 0,\n      {},\n      \
Table[dummyGraphic,{width - restLength}]\n    ];\n  \n  displayGraphicsArray \
= \n    Partition[Join[graphicsList,restGraphics],width];\n    \n  ",
  StyleBox["(* Display the graphics table *)",
    FontSlant->"Italic"],
  "\n  \n  theGraphics =\n  Show[\n    GraphicsArray[displayGraphicsArray],\n \
   PlotLabel -> \n      FontForm[\"Gen. \" <> ToString[generation],\n        \
{\"Times\",14}\n      ],\n    DisplayFunction -> Identity\n  ];\n  \n  Show[\n\
    Graphics[\n     {\n      Rectangle[{0,0},{1,1},theGraphics],\n      Text[\
\n          FontForm[\"Fractals\",{\"Times-Italic\",18}],{0,0.95},{-1,0}\n    \
  ]\n     }\n    ],\n    Background -> GrayLevel[0.9]\n  ];\n  \n];"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[
"Show[\n  Graphics[\n   {\n    Rectangle[{0,0},{1,1},Graphics3D[{Hue[1]}]],\n \
   Rectangle[Scaled[{0.0,0.8}],Scaled[{0.3,1.0}],\n      \
Graphics[Text[\"Hallo\",{0,0}]]]\n   }\n  ]\n];"], "Input",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Ant graphics"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["Ant path"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
showAntPath[posList_List,dirList_List,n_:actionSteps] :=
Module[{tmpBoard, entry = 1},

  maxEntry = Length[posList];
  
  tmpBoard = (theBoard - theBoard) * maxEntry;

  MapThread[(tmpBoard[[#1[[1]],#1[[2]]]] = maxEntry - entry++; 
       Show[
         ListDensityPlot[tmpBoard // Transpose, 
           Mesh -> True,
           ColorFunction -> (Hue[0.7,#,0.5]&),
           DisplayFunction -> Identity
         ],
         PlotLabel -> StringJoin[\"Step:\",ToString[entry-2],\", \",
                                 \"Pos:\",ToString[#],\", \",
                                 ToString[#2]],
         DisplayFunction -> $DisplayFunction
       ];)&,
    {Take[posList,n],Take[dirList,n]}
  ];
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Ant path 3D"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
boardGraphics[board_] :=
Module[{pathCoords,boardWidth,boardHeight,
        theRectangle},
  
  boardWidth = Length[board];
  boardHeight = Length[board//Transpose];
  
  theRectangle[{x_,y_,z_},w_,h_] :=
    Polygon[{{x-w,y-h,z},{x+w,y-h,z},
            {x+w,y+h,z},{x-w,y+h,z},{x-w,y-h,z}}];
    
  pathCoords = Position[board,2,Infinity];
  
  {
  Show[
    Graphics3D[
      {GrayLevel[0.9],
       theRectangle[{N[boardWidth/2]+0.5,N[boardHeight/2]+0.5,0},
         N[boardWidth/2]+0.5,N[boardHeight/2]+0.5]}
    ],
    DisplayFunction -> Identity,
    Lighting -> False
  ],
  Show[
    Graphics3D[
      {GrayLevel[0.8],
       Map[theRectangle[Append[#,0],0.5,0.5]&,pathCoords]}
    ],
    DisplayFunction -> Identity,
    Lighting -> False
  ]
  }
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
trailGraphics[posList_List,dirList_List] :=
Module[{stepZ, deltaZ,
        theRectangle},
  
  deltaZ = N[1/Length[posList]];
  stepZ = -deltaZ;
  
  theRectangle[{x_,y_,z_},w_,h_] :=
    Polygon[{{x-w,y-h,z},{x+w,y-h,z},
            {x+w,y+h,z},{x-w,y+h,z},{x-w,y-h,z}}];
    
  {
  Show[
    Graphics3D[
      {GrayLevel[0.3],
       Map[
         {Hue[stepZ+=deltaZ],
          theRectangle[Append[#,0],0.25,0.25]
         }&,posList]}
    ],
    DisplayFunction -> Identity,
    Lighting -> False
  ]
  }
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
showAntPath3D[board_,posList_List,dirList_List,
              n_Integer:Length[posList]] :=
Module[{},
  Show[
    {boardGraphics[board],
     trailGraphics[posList,dirList]},
    DisplayFunction -> $DisplayFunction,
    Boxed -> False,
    Axes -> {True,True,False},
    PlotRange -> All
  ];
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
animateAntPath3D[board_,posList_List,dirList_List,
              from_Integer:1,to_Integer] :=
Module[{},
  MapThread[
    Show[
      {boardGraphics[board],
       trailGraphics[#1,#2]},
      DisplayFunction -> $DisplayFunction,
      Boxed -> False,
      Axes -> {True,True,False}
    ]&,
    {Table[Take[posList,i],{i,from,to}],
     Table[Take[dirList,i],{i,from,to}]
    }
  ];
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Ant actions"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
showAntActions[posList_List,dirList_List] :=
Module[{hueScale,theHue = 0.,zStep, zStepDelta = 0.3,
        posListLength = Length[posList]},

  zStep = -zStepDelta;
  
  hueScale = N[1/posListLength];
  
  Show[Graphics3D[
    Flatten[
      Map[
        (theHue += hueScale;
        zStep += zStepDelta;
         {Hue[theHue],
          If[Abs[Apply[Plus,#[[1]]-#[[2]]]] > 1,
            Thickness[0.005],
            Thickness[0.01]
          ],
          Line[Map[Append[#,zStep]&,#]]})&,
        Partition[posList,2,1]],
      1
    ]
   ],
   Axes -> True, AspectRatio -> 1.,
   ViewPoint -> {-1.3,-2.4,2.0},
   PlotRange -> {{1,boardWidth},{1,boardHeight},Automatic},
   FaceGrids -> {{1,0,0},{0,1,0},{0,0,-1}}
  ];
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["AntTrackers: Evolution ...", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Here is one examples of how to start a typical ",
  StyleBox["AntTrackers",
    FontSlant->"Italic"],
  " evolution run."
}], "Text"],

Cell[CellGroupData[{

Cell["Example Evolution", "Subsection"],

Cell[BoxData[
    \(\($basicDirectory = 
        ToFileName[{EvolvicaDirectory, "\<Chapters\>", \
\[IndentingNewLine]"\<08-AdvancedGP\>", "\<AntTracker\>", "\<Examples\>"}];\)\
\)], "Input"],

Cell[CellGroupData[{

Cell["\<\
$RecursionLimit = 1000;

evolveExpressions[
  _AntTracker,
  LSystemIterations -> 1,
  Individuals -> 10,
  Generations -> 1,
  
  AdjustOperatorRanks -> True,
  OperatorRankDecay -> 0.01,
  GenerationGap -> 1.0,
  
  TableWidth -> 7,
  
  DisplayFitnessCharts -> True,
  DisplayOperatorRanks -> True,
  
  GenerationOffset -> 0,
  
  ExperimentName -> \"AntTracker-Example\",
  
  ExamplesDirectory -> $basicDirectory
]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \("***"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Directory created: \
"\[InvisibleSpace]"~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/\
Chapters/08-AdvancedGP/AntTracker/Examples//AntTracker-Example"\),
      SequenceForm[ 
      "Directory created: ", 
        "~jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/08-\
AdvancedGP/AntTracker/Examples//AntTracker-Example"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(0\)"\)], "Message"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** Input panel information: *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {""}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("INPUT: "\[InvisibleSpace]{}\),
      SequenceForm[ "INPUT: ", {}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** End of input panel info *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("Generated expressions:"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(AntTracker[AntTracker[seq[stop]]]\)},
          {\(AntTracker[AntTracker[seq[turnRight]]]\)},
          {\(AntTracker[AntTracker[seq[turnLeft, again]]]\)},
          {\(AntTracker[seq[advance]]\)},
          {\(AntTracker[seq[nop]]\)},
          {\(AntTracker[seq[stop]]\)},
          {\(AntTracker[seq[turnLeft]]\)},
          {\(AntTracker[seq[advance, again]]\)},
          {\(AntTracker[seq[turnLeft, again]]\)},
          {\(AntTracker[seq[turnRight, again]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {
        AntTracker[ 
          AntTracker[ 
            seq[ stop]]], 
        AntTracker[ 
          AntTracker[ 
            seq[ turnRight]]], 
        AntTracker[ 
          AntTracker[ 
            seq[ turnLeft, again]]], 
        AntTracker[ 
          seq[ advance]], 
        AntTracker[ 
          seq[ nop]], 
        AntTracker[ 
          seq[ stop]], 
        AntTracker[ 
          seq[ turnLeft]], 
        AntTracker[ 
          seq[ advance, again]], 
        AntTracker[ 
          seq[ turnLeft, again]], 
        AntTracker[ 
          seq[ turnRight, again]]}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0344995 0.0971817 0.0147151 0.0981006 [
[.06268 .00222 -3.65625 -14 ]
[.06268 .00222 3.65625 0 ]
[.15986 .00222 -3.65625 -14 ]
[.15986 .00222 3.65625 0 ]
[.25705 .00222 -3.65625 -14 ]
[.25705 .00222 3.65625 0 ]
[.35423 .00222 -3.65625 -14 ]
[.35423 .00222 3.65625 0 ]
[.45141 .00222 -3.65625 -14 ]
[.45141 .00222 3.65625 0 ]
[.54859 .00222 -3.65625 -14 ]
[.54859 .00222 3.65625 0 ]
[.64577 .00222 -3.65625 -14 ]
[.64577 .00222 3.65625 0 ]
[.74295 .00222 -3.65625 -14 ]
[.74295 .00222 3.65625 0 ]
[.84014 .00222 -3.65625 -14 ]
[.84014 .00222 3.65625 0 ]
[.93732 .00222 -8.625 -14 ]
[.93732 .00222 8.625 0 ]
[-0.00813 .11282 -10.625 -7 ]
[-0.00813 .11282 0 7 ]
[-0.00813 .21092 -10.625 -7 ]
[-0.00813 .21092 0 7 ]
[-0.00813 .30902 -10.625 -7 ]
[-0.00813 .30902 0 7 ]
[-0.00813 .40712 -10.625 -7 ]
[-0.00813 .40712 0 7 ]
[-0.00813 .50522 -10.625 -7 ]
[-0.00813 .50522 0 7 ]
[-0.00813 .60332 -10.625 -7 ]
[-0.00813 .60332 0 7 ]
[.5 .63053 -102.781 0 ]
[.5 .63053 102.781 14 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.06268 .01472 m
.06268 .02097 L
s
gsave
.06268 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.15986 .01472 m
.15986 .02097 L
s
gsave
.15986 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25705 .01472 m
.25705 .02097 L
s
gsave
.25705 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.35423 .01472 m
.35423 .02097 L
s
gsave
.35423 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.45141 .01472 m
.45141 .02097 L
s
gsave
.45141 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.54859 .01472 m
.54859 .02097 L
s
gsave
.54859 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.64577 .01472 m
.64577 .02097 L
s
gsave
.64577 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.74295 .01472 m
.74295 .02097 L
s
gsave
.74295 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.84014 .01472 m
.84014 .02097 L
s
gsave
.84014 .00222 -64.6562 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
66.312 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.93732 .01472 m
.93732 .02097 L
s
gsave
.93732 .00222 -69.625 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
0 .01472 m
1 .01472 L
s
.00437 .11282 m
.01062 .11282 L
s
gsave
-0.00813 .11282 -71.625 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.00437 .21092 m
.01062 .21092 L
s
gsave
-0.00813 .21092 -71.625 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.00437 .30902 m
.01062 .30902 L
s
gsave
-0.00813 .30902 -71.625 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.00437 .40712 m
.01062 .40712 L
s
gsave
-0.00813 .40712 -71.625 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00437 .50522 m
.01062 .50522 L
s
gsave
-0.00813 .50522 -71.625 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.00437 .60332 m
.01062 .60332 L
s
gsave
-0.00813 .60332 -71.625 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.00437 .03434 m
.00812 .03434 L
s
.00437 .05396 m
.00812 .05396 L
s
.00437 .07358 m
.00812 .07358 L
s
.00437 .0932 m
.00812 .0932 L
s
.00437 .13244 m
.00812 .13244 L
s
.00437 .15206 m
.00812 .15206 L
s
.00437 .17168 m
.00812 .17168 L
s
.00437 .1913 m
.00812 .1913 L
s
.00437 .23054 m
.00812 .23054 L
s
.00437 .25016 m
.00812 .25016 L
s
.00437 .26978 m
.00812 .26978 L
s
.00437 .2894 m
.00812 .2894 L
s
.00437 .32864 m
.00812 .32864 L
s
.00437 .34826 m
.00812 .34826 L
s
.00437 .36788 m
.00812 .36788 L
s
.00437 .3875 m
.00812 .3875 L
s
.00437 .42674 m
.00812 .42674 L
s
.00437 .44636 m
.00812 .44636 L
s
.00437 .46598 m
.00812 .46598 L
s
.00437 .4856 m
.00812 .4856 L
s
.00437 .52484 m
.00812 .52484 L
s
.00437 .54446 m
.00812 .54446 L
s
.00437 .56408 m
.00812 .56408 L
s
.00437 .5837 m
.00812 .5837 L
s
.25 Mabswid
.00437 0 m
.00437 .61803 L
s
gsave
.5 .63053 -163.781 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(Histogram) show
221.438 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
228.062 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
251.312 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
257.938 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
264.562 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02381 .60332 L
.10155 .60332 L
.10155 .01472 L
F
.5 Mabswid
.02381 .01472 m
.02381 .60332 L
.10155 .60332 L
.10155 .01472 L
.02381 .01472 L
s
.12099 .01472 m
.12099 .60332 L
.19874 .60332 L
.19874 .01472 L
F
.12099 .01472 m
.12099 .60332 L
.19874 .60332 L
.19874 .01472 L
.12099 .01472 L
s
.21817 .01472 m
.21817 .11282 L
.29592 .11282 L
.29592 .01472 L
F
.21817 .01472 m
.21817 .11282 L
.29592 .11282 L
.29592 .01472 L
.21817 .01472 L
s
.31535 .01472 m
.31535 .11282 L
.3931 .11282 L
.3931 .01472 L
F
.31535 .01472 m
.31535 .11282 L
.3931 .11282 L
.3931 .01472 L
.31535 .01472 L
s
.41254 .01472 m
.41254 .11282 L
.49028 .11282 L
.49028 .01472 L
F
.41254 .01472 m
.41254 .11282 L
.49028 .11282 L
.49028 .01472 L
.41254 .01472 L
s
.50972 .01472 m
.50972 .11282 L
.58746 .11282 L
.58746 .01472 L
F
.50972 .01472 m
.50972 .11282 L
.58746 .11282 L
.58746 .01472 L
.50972 .01472 L
s
.6069 .01472 m
.6069 .11282 L
.68465 .11282 L
.68465 .01472 L
F
.6069 .01472 m
.6069 .11282 L
.68465 .11282 L
.68465 .01472 L
.6069 .01472 L
s
.70408 .01472 m
.70408 .11282 L
.78183 .11282 L
.78183 .01472 L
F
.70408 .01472 m
.70408 .11282 L
.78183 .11282 L
.78183 .01472 L
.70408 .01472 L
s
.80126 .01472 m
.80126 .11282 L
.87901 .11282 L
.87901 .01472 L
F
.80126 .01472 m
.80126 .11282 L
.87901 .11282 L
.87901 .01472 L
.80126 .01472 L
s
.89845 .01472 m
.89845 .11282 L
.97619 .11282 L
.97619 .01472 L
F
.89845 .01472 m
.89845 .11282 L
.97619 .11282 L
.97619 .01472 L
.89845 .01472 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oooo<c<`P
olc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo
003oolc<c23oc<c<0Oooool00?Woc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0001goc<c<0Oooool0
0?Woc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<01[oc<c<0Oooool0
0?Woc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<01[oc<c<0Oooool0
0?Woc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<01[oc<c<0Oooool0
0?Woc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<01[oc<c<0Oooool0
0?Woc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<01[oc<c<0Oooool0
0?Ooc<c<0ol00003olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`06_o<c<`1oooo
o`00nOo<c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`06_o<c<`1oooo
o`008?o<c<`00ol0003oc<c<olc<c03Folc<c003o`000?o<c<coc<c<00;oc<c<1?l0000Molc<c07o
oooo000Polc<c003o`000?o<c<coc<c<0?coc<c<0Oooool0023oc<c<00?o0000olc<c?o<c<`0o?o<
c<`1ooooo`008?o<c<`00ol0003oc<c<olc<c03lolc<c07ooooo000Oolc<c>ko00004_o<c<`1oooo
o`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l00003olc<c1Co00001?o<c<`Co`00
00Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`00
01Soc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co00000oo<c<`Do`00
00Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`00
00Coc<c<4ol0000Holc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`00
00?oc<c<5?l00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`00
00Coc<c<4ol00004olc<c1?o00006?o<c<`1ooooo`008?o<c<`2o`0000;oc<c<5?l00003olc<c1Co
00000oo<c<`Do`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o
00001?o<c<`Co`0000Coc<c<4ol0000Holc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co
00000oo<c<`Do`0000?oc<c<5?l00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o
00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00006?o<c<`1ooooo`008?o<c<`01?l0003oc<c<
olc<c?o<c<`Do`0000?oc<c<5?l00003olc<c1Co00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o
00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0001Soc<c<0Oooool0023oc<c<
00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co00000oo<c<`Do`0000Coc<c<4ol00004olc<c1?o
00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol0000Holc<c07o
oooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`0000?oc<c<5?l00004olc<c1?o
00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o
00006?o<c<`1ooooo`008?o<c<`2o`0000;oc<c<5?l00003olc<c1Co00000oo<c<`Do`0000Coc<c<
4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<
4ol0000Holc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`0000?oc<c<
5?l00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<
4ol00004olc<c1?o00006?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<
5?l00003olc<c1Co00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<
4ol00004olc<c1?o00001?o<c<`Co`0001Soc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<
5?l00003olc<c1Co00000oo<c<`Do`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<
4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol0000Holc<c07ooooo000Polc<c0;o00000_o<
c<`Do`0000?oc<c<5?l00003olc<c1Co00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<
c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0001Soc<c<0Oooool0023oc<c<00Co0000
olc<c?o<c<coc<c<5?l00003olc<c1Co00000oo<c<`Do`0000Coc<c<4ol00004olc<c1?o00001?o<
c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol0000Holc<c07ooooo000P
olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`0000?oc<c<5?l00004olc<c1?o00001?o<
c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00006?o<
c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l00003olc<c1Co00001?o<
c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<
c<`Co`0001Soc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co00000oo<
c<`Do`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<
c<`Co`0000Coc<c<4ol0000Holc<c07ooooo000Polc<c0;o00000_o<c<`Do`0000?oc<c<5?l00003
olc<c1Co00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004
olc<c1?o00001?o<c<`Co`0001Soc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003
olc<c1Co00000oo<c<`Do`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004
olc<c1?o00001?o<c<`Co`0000Coc<c<4ol0000Holc<c07ooooo000Polc<c004o`000?o<c<coc<c<
olc<c1Co00000oo<c<`Do`0000?oc<c<5?l00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004
olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00006?o<c<`1ooooo`005oo<c<`00ol0
003oc<c<olc<c006olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`0000?oc<c<5?l00004
olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004
olc<c1?o00006?o<c<`1ooooo`005oo<c<`00ol0003oc<c<olc<c006olc<c004o`000?o<c<coc<c<
olc<c1Co00000oo<c<`Do`0000?oc<c<5?l00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004
olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00006?o<c<`1ooooo`005oo<c<`00ol0
003oc<c<olc<c006olc<c0;o00000_o<c<`Do`0000?oc<c<5?l00003olc<c1Co00001?o<c<`Co`00
00Coc<c<4ol00004olc<c1?o00001?o<c<`Co`0000Coc<c<4ol00004olc<c1?o00001?o<c<`Co`00
01Soc<c<0Oooool001Ooc<c<00?o0000olc<c?o<c<`01_o<c<`01?l0003oc<c<olc<c?o<c<`Do`00
00?oc<c<5?l0003@olc<c07ooooo000Golc<c003o`000?o<c<coc<c<00Koc<c<00Co0000olc<c?o<
c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005oo<c<`00ol0003oc<c<olc<c006olc<c004
o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Goc<c<0ol00008olc<c0;o
00000_o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Golc<c003o`000?o<c<coc<c<00Koc<c<
00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005oo<c<`00ol0003oc<c<
olc<c006olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<
00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<
olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c0;o00000_o<c<`Do`0000?oc<c<
5?l0003@olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<
0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<
c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<
c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002olc<c1Co00000oo<
c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<
c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000P
olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002
olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003
olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@
olc<c07ooooo000Dolc<c0Ko00001_o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@
olc<c07ooooo000Dolc<c003o`000?o<c<coc<c<00Woc<c<00Co0000olc<c?o<c<coc<c<5?l00003
olc<c1Co0000d?o<c<`1ooooo`005Oo<c<`00ol0003oc<c<olc<c008olc<c0;o00000_o<c<`Do`00
00?oc<c<5?l0003@olc<c07ooooo000Folc<c0;o00002?o<c<`01?l0003oc<c<olc<c?o<c<`Do`00
00?oc<c<5?l0003@olc<c07ooooo000Holc<c003o`000?o<c<coc<c<00Goc<c<00Co0000olc<c?o<
c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`006Oo<c<`00ol0003oc<c<olc<c004olc<c004
o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Coc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`00
0=3oc<c<0Oooool001Coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c0;o
00000_o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Eolc<c0Co00001oo<c<`01?l0003oc<c<
olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co
00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co
0000d?o<c<`1ooooo`008?o<c<`2o`0000;oc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<
c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<
c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<
5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<
5?l0003@olc<c07ooooo000Polc<c0;o00000_o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000P
olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000
olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<
c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<
c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0
023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005Oo<c<`4o`00
00Ooc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005?o<c<`00ol0
003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coc<c<5?l00003
olc<c1Co0000d?o<c<`1ooooo`005?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<
00Coc<c<0_l00002olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Woc<c<00?o0000olc<c?o<
c<`01?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Folc<c0?o
00001oo<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Iolc<c003
o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1oooo
o`005?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<
c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005?o<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<00Coc<c<0_l00002olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Goc<c<
1?l00007olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<
00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<
olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co
00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002olc<c1Co00000oo<c<`Do`000=3oc<c<
0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<
c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<
c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002olc<c1Co00000oo<
c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<
c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000P
olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000
olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`2o`0000;oc<c<5?l00003
olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@
olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0
01Soc<c<00?o0000olc<c?o<c<`01Oo<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@
olc<c07ooooo000Holc<c003o`000?o<c<coc<c<00Goc<c<00Co0000olc<c?o<c<coc<c<5?l00003
olc<c1Co0000d?o<c<`1ooooo`005?o<c<`6o`0000Koc<c<0_l00002olc<c1Co00000oo<c<`Do`00
0=3oc<c<0Oooool001Coc<c<00Go0000olc<c?o<c<coc<c<o`000007olc<c004o`000?o<c<coc<c<
olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Goc<c<00Co0000olc<c?o<c<co00001oo<c<`0
1?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Folc<c003o`000?o<c<co
000000Ooc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005_o<c<`0
0ol0003oc<c<o`000007olc<c0;o00000_o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Golc<
c0;o00001oo<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Holc<
c003o`000?o<c<coc<c<00Goc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1
ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<
c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002olc<
c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<
c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<
c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023o
c<c<0_l00002olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<co
c<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?o
c<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3o
c<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`00
8?o<c<`2o`0000;oc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<
c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co0000
0oo<c<`Do`000=3oc<c<0Oooool001Goc<c<1?l00007olc<c004o`000?o<c<coc<c<olc<c1Co0000
0oo<c<`Do`000=3oc<c<0Oooool001Coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<
c004olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Woc<c<00?o
0000olc<c?o<c<`01?o<c<`2o`0000;oc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`006Oo<c<`0
0ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Ooo
ool001Coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<co
c<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Coc<c<1Ol00007olc<c004o`000?o<c<co
c<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Coc<c<00?o0000olc<c?o<c<`02Oo<c<`2
o`0000;oc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005Oo<c<`00ol0003oc<c<olc<c008olc<
c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool001Goc<c<1Ol00006olc<
c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<
c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`D
o`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c0;o00000_o<c<`Do`0000?oc<c<5?l0003@olc<
c07ooooo000Polc<c004o`000?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023o
c<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`008?o<c<`01?l0003o
c<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`000?o<c<coc<c<olc<
c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002olc<c1Co00000oo<c<`Do`000=3o
c<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`00
8?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Polc<c004o`00
0?o<c<coc<c<olc<c1Co00000oo<c<`Do`000=3oc<c<0Oooool0023oc<c<0_l00002olc<c1Co0000
0oo<c<`Do`000=3oc<c<0Oooool0023oc<c<00Co0000olc<c?o<c<coc<c<5?l00003olc<c1Co0000
d?o<c<`1ooooo`008?o<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo
000Eolc<c0Co00001oo<c<`01?l0003oc<c<olc<c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo
000Dolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<
c?o<c<`Do`0000?oc<c<5?l0003@olc<c07ooooo000Dolc<c003o`000?o<c<coc<c<00;oc<c<00?o
0000olc<c?o<c<`01?o<c<`2o`0000;oc<c<5?l00003olc<c1Co0000d?o<c<`1ooooo`005?o<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`0o?o<c<`1
ooooo`005?o<c<`2o`0000?oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c03lolc<
c07ooooo000Dolc<c003o`000?o<c<co000000;o00001oo<c<`00ol0003oc<c<olc<c03lolc<c07o
oooo000Dolc<c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<c?o<c<`0o?o<c<`1ooooo`005Oo<
c<`01Ol0003oc<c<olc<c?o<c<co00000?ooc<c<1_o<c<`1ooooo`005_o<c<`3o`000?ooc<c<1oo<
c<`1ooooo`00ooo<c<`Polc<c07ooooo002eolc<c0Co0000I_o<c<`1ooooo`00]?o<c<`2o`0000;o
c<c<0_l0000Folc<c003o`000?o<c<coc<c<04coc<c<0Oooool00;Soc<c<0_l0000Golc<c003o`00
0?o<c<coc<c<04_oc<c<0Oooool003?oc<c<1Ol00004olc<c0?o00000oo<c<`2o`0000?oc<c<0ol0
0002olc<c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`3o`000003olc<c?l0
003o000000;oc<c<0_l00002olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<
c<`4o`0000Coc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0ol0
0003olc<c0?o00001?o<c<`5o`000003olc<c?l0003o000000?oc<c<1Ol000000oo<c<co0000o`00
0002olc<c0;o00000_o<c<`4o`0000Ooc<c<1?l000001?o<c<co0000olc<c?o<c<`4o`0000;oc<c<
0_l00002olc<c0;o000000?oc<c<o`000?l000001?o<c<`4o`0002Ooc<c<0Oooool003;oc<c<0_l0
0003olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00000_o<
c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l0
0002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?o
c<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`00
0002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00003olc<c0;o000000Co
c<c<o`000?l0003oc<c<0_l00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000
o`000002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`0000;oc<c<1?l00006olc<c0;o00000_o<c<`3o`000003olc<
c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l00000
0oo<c<`2o`0000;oc<c<0_l0000Volc<c07ooooo000bolc<c0;o00000oo<c<`2o`000003olc<c?l0
003o000000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o00000_o<c<`2o`0000Goc<c<0_l0
0002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l0
00000oo<c<co0000o`000008olc<c0?o00001?o<c<`3o`000003olc<c?l0003o000000Soc<c<0ol0
0003olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000Coc<c<0ol00002olc<c0;o00000_o<
c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<
c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000_o<c<`2o`0000Ooc<c<0_l0
0004olc<c0;o000000?oc<c<o`000?l000001Oo<c<`2o`0000;oc<c<0_l00006olc<c0;o00000_o<
c<`2o`0002Koc<c<0Oooool003Koc<c<0ol000000oo<c<co0000o`000003olc<c0;o000000?oc<c<
o`000?l000000oo<c<`2o`0000;oc<c<1_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2
o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000004
o`0000;oc<c<1?l00003olc<c0Co00000_o<c<`6o`0000;oc<c<1?l00004olc<c0;o00000oo<c<`2
o`000003olc<c?l0003o000000;oc<c<1?l00003olc<c0;o00000_o<c<`2o`0000?oc<c<0_l00000
0oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`000004olc<c?l0003o
0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00007olc<c0;o00001?o<c<`2o`000003olc<c?l0
003o000000Co000000?oc<c<o`000?l000000_o<c<`2o`0000Koc<c<0_l00002olc<c0;o00009_o<
c<`1ooooo`00<oo<c<`5o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2
o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<1Ol00000
0oo<c<co0000o`000002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002
olc<c0;o000000Coc<c<o`000?l0003o00001?o<c<`3o`0000Coc<c<0_l00002olc<c0;o000000Co
c<c<o`000?l0003o00001_o<c<`2o`0000?oc<c<0_l000001?o<c<co0000o`000?o<c<`3o`0000Go
c<c<0_l00002olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co
0000o`000005olc<c0?o000000?oc<c<o`000?l000000_o<c<`2o`0000;oc<c<0_l00007olc<c0;o
00000_o<c<`4o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o
00001_o<c<`2o`0000;oc<c<0_l0000Volc<c07ooooo000bolc<c0?o00001_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0ol00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000
o`000002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<
0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l00000
0_o<c<`2o`0000?oc<c<1ol000001?o<c<co0000o`000?o<c<`2o`0000;oc<c<0_l00002olc<c0;o
00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00002olc<c0;o000000Goc<c<o`000?l0
003o0000olc<c002o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000_o<c<`2o`00
00Ooc<c<0_l00007olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00006olc<
c0;o00000_o<c<`2o`0002Koc<c<0Oooool003;oc<c<0_l00003olc<c0;o00000oo<c<`3o`0000?o
c<c<0ol000000oo<c<co0000o`000002o`0000;oc<c<1?l00003olc<c0Go00000oo<c<`2o`0000Co
c<c<0_l000000oo<c<co0000o`000002o`000003olc<c?l0003o000000?o00000oo<c<`4o`0000?o
c<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00004olc<c0;o00000oo<c<`2o`000003
olc<c?l0003o000000;oc<c<1?l00002olc<c0Co00000oo<c<`3o`0000Coc<c<1Ol000001?o<c<co
0000o`000?l00002olc<c0Go000000?oc<c<o`000?l000001ol00008olc<c0;o00001?o<c<`2o`00
00;oc<c<1?l00002olc<c0Go00001oo<c<`2o`0000;oc<c<0_l0000Volc<c07ooooo000bolc<c0;o
00000oo<c<`2o`0000koc<c<0_l0000=olc<c0;o00000oo<c<`2o`0000Soc<c<0_l0000^olc<c0;o
00000oo<c<`2o`0000coc<c<0_l0000^olc<c0;o00000_o<c<`2o`0001Goc<c<0_l00002olc<c0;o
00009_o<c<`1ooooo`00<oo<c<`5o`0000ooc<c<0_l0000=olc<c0;o00000oo<c<`8o`0000;oc<c<
0_l0000^olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000Woc<c<0_l0000_olc<c0Co0000
5oo<c<`4o`0002Ooc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.00178, -0.72945, 0.04341, \
0.0430034}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({1, 1, 1, 6, 1, 1, 1, 6, 1, 1}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(2.`\)"\)], "Message"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** Input panel information: *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Enter an index list for the expressions to be \
selected.\"\>"},
          {"\<\"Enter a list of the form: { {generation,index}.. }\"\>"},
          {"\<\" \"\>"},
          {"\<\"If you only enter an index this refers to the last \
generation.\"\>"},
          {"\<\" \"\>"},
          {"\<\"Enter 'all' to refer to the whole population.\"\>"},
          {"\<\" \"\>"},
          {"\<\"Enter 'stop' to abort.\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {"Enter an index list for the expressions to be selected.", 
        "Enter a list of the form: { {generation,index}.. }", " ", 
        "If you only enter an index this refers to the last generation.", " ",
         "Enter 'all' to refer to the whole population.", " ", 
        "Enter 'stop' to abort."}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("INPUT: "\[InvisibleSpace]all\),
      SequenceForm[ "INPUT: ", all],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** End of input panel info *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** Input panel information: *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"How many evolution steps? (current value: \"\>"},
          {"\<\"Current value: 1\"\>"},
          {"\<\" \"\>"},
          {"\<\"Enter a single number.\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {"How many evolution steps? (current value: ", 
        "Current value: 1", " ", "Enter a single number."}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("INPUT: "\[InvisibleSpace]10\),
      SequenceForm[ "INPUT: ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** End of input panel info *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** Input panel information: *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Enter a list of rules: { symbol -> value .. }\"\>"},
          {"\<\"Enter {} for no additonal options.\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {"Enter a list of rules: { symbol -> value .. }", 
        "Enter {} for no additonal options."}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("INPUT: "\[InvisibleSpace]{}\),
      SequenceForm[ "INPUT: ", {}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** End of input panel info *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(1\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 0 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.73232 .00576 0 -8.88217 ]
[.73232 .00576 10.625 5.11783 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.71869 .00942 m
.71188 .01126 L
s
gsave
.73232 .00576 -61 -12.8822 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.16815 .24691 m
.13455 .92146 L
s
.26233 .29961 m
.23906 .93186 L
s
.34519 .34598 m
.33001 .94091 L
s
.41866 .3871 m
.40989 .94886 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.12592 .18455 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.18133 .16991 m .57042 .37159 L .52233 .38044 L 0 1 1 r
F
.12592 .18455 m .18133 .16991 L .52233 .38044 L 1 0 0 r
F
.23859 .15478 m .61975 .36251 L .57042 .37159 L F
.18133 .16991 m .23859 .15478 L .57042 .37159 L 0 1 1 r
F
.2978 .13914 m .67039 .35318 L .61975 .36251 L 1 0 0 r
F
.23859 .15478 m .2978 .13914 L .61975 .36251 L F
.5 Mabswid
.62175 .5415 m .57122 .54845 L .22934 .3814 L p F P
0 0 0 r
s
.57122 .54845 m .52132 .93033 L .14671 .88315 L p 0 1 1 r
F P
0 0 0 r
s
.14671 .88315 m .22934 .3814 L .57122 .54845 L p 0 1 1 r
F P
0 0 0 r
s
.35907 .12295 m .72237 .34361 L .67039 .35318 L 1 0 0 r
F
.2978 .13914 m .35907 .12295 L .67039 .35318 L F
.67363 .53437 m .62175 .5415 L .29027 .36926 L p F P
0 0 0 r
s
.22934 .3814 m .29027 .36926 L .62175 .5415 L p 1 0 0 r
F P
0 0 0 r
s
.42251 .10619 m .77575 .33379 L .72237 .34361 L 1 0 0 r
F
.35907 .12295 m .42251 .10619 L .72237 .34361 L F
.52132 .93033 m .47106 .93222 L .08662 .88649 L p F P
0 0 0 r
s
.72693 .52703 m .67363 .53437 L .35338 .35667 L p 1 0 0 r
F P
0 0 0 r
s
.29027 .36926 m .35338 .35667 L .67363 .53437 L p 1 0 0 r
F P
0 0 0 r
s
.48823 .08883 m .8306 .32369 L .77575 .33379 L 1 0 0 r
F
.42251 .10619 m .48823 .08883 L .77575 .33379 L F
.08662 .88649 m .14671 .88315 L .52132 .93033 L p F P
0 0 0 r
s
.7817 .5195 m .72693 .52703 L .41879 .34363 L p 1 0 0 r
F P
0 0 0 r
s
.35338 .35667 m .41879 .34363 L .72693 .52703 L p 1 0 0 r
F P
0 0 0 r
s
.55636 .07083 m .88697 .31331 L .8306 .32369 L 1 0 0 r
F
.48823 .08883 m .55636 .07083 L .8306 .32369 L F
.83801 .51176 m .7817 .5195 L .48663 .3301 L p F P
0 0 0 r
s
.41879 .34363 m .48663 .3301 L .7817 .5195 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .94492 .30264 L .88697 .31331 L 1 0 0 r
F
.55636 .07083 m .62703 .05216 L .88697 .31331 L F
.89593 .50379 m .83801 .51176 L .55704 .31606 L p F P
0 0 0 r
s
.48663 .3301 m .55704 .31606 L .83801 .51176 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .70039 .03278 L .94492 .30264 L 1 0 0 r
F
.95551 .49559 m .89593 .50379 L .63017 .30148 L p F P
0 0 0 r
s
.55704 .31606 m .63017 .30148 L .89593 .50379 L p 1 0 0 r
F P
0 0 0 r
s
.63017 .30148 m .70619 .28632 L .95551 .49559 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00001Golc<c003o`000?o<
c<coc<c<04Ooc<c<0Oooool006Soc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<o`00
0003olc<c0;o000000Goc<c<o`000?o<c<coc<c<o`000003olc<c003o`000?o<c<coc<c<05Coc<c<
00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`01?l0003oc<c<o`000?o<c<`2o`0000?oc<c<
0ol000001?o<c<co0000olc<c?l00002olc<c005o`000?o<c<coc<c<olc<c?l00000BOo<c<`3o`00
00[oc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00
J?o<c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<co000001coc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01coc<c<1?l000000oo<c<co0000
olc<c003olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00UOo<
c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<01Soc<c<1?l00005olc<c003o`000?o<
c<coc<c<00;oc<c<0_l00008olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Goc<c<00?o0000
olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c00Eolc<c0Co00003oo<c<`00ol0003oc<c<olc<c003
olc<c0?o0000BOo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c004olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Koc<c<00?o0000olc<c?o<
c<`01?o<c<`5o`00013oc<c<1?l0000Iolc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<
c<`0Aoo<c<`1ooooo`00Uoo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00ooc<c<
0ol00002olc<c003o`000?o<c<coc<c<01Woc<c<00?o0000olc<c?o<c<`0C?o<c<`1ooooo`00V?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00[oc<c<1?l0000Rolc<c003o`000?o<
c<coc<c<04_oc<c<0Oooool009?oc<c<1_l00005olc<c0Go00001?o<c<`4o`000003olc<c?l0003o
c<c<01Soc<c<0_oo0009olc<c003o`000?o<c<coc<c<04_oc<c<0Oooool00:Coc<c<0ol00005olc<
c003o`000?o<c<coc<c<01Coc<c<1_oo0009olc<c003o`000?o<c<coc<c<04[oc<c<0Oooool007?o
c<c<1?l0000Yolc<c0Go00006_o<c<`;ool000Woc<c<00?o0000olc<c?o<c<`0BOo<c<`1ooooo`00
L_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<02;oc<c<1?l00004olc<c003o`00
0?o<c<coc<c<01Goc<c<3ooo0009olc<c003o`000?o<c<coc<c<04Soc<c<0Oooool007Ooc<c<00?o
0000olc<c?o<c<`07oo<c<`3o`0001goc<c<4ooo0009olc<c003o`000?o<c<coc<c<04Ooc<c<0Ooo
ool007Ooc<c<00?o0000olc<c?o<c<`06oo<c<`4o`0000;oc<c<00?o0000olc<c?o<c<`05oo<c<`H
ool000Woc<c<00?o0000olc<c?o<c<`0A_o<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01Ooc<c<1?l00006olc<c003o`000?o<c<coc<c<01?oc<c<7Ooo0009olc<
c003o`000?o<c<coc<c<04Goc<c<0Oooool007;oc<c<1Ol0000Golc<c0?o00000_o<c<`00ol0003o
c<c<olc<c00Folc<c2?oo`002?o<c<`00ol0003oc<c<olc<c015olc<c07ooooo001bolc<c003o`00
0?o<c<coc<c<01Goc<c<1?l0000Jolc<c2Soo`002?o<c<`00ol0003oc<c<olc<c014olc<c07ooooo
001colc<c003o`000?o<c<coc<c<013oc<c<1?l000000oo<c<co0000olc<c00Golc<c2goo`002?o<
c<`00ol0003oc<c<olc<c013olc<c07ooooo001colc<c0Go00002oo<c<`3o`0001[oc<c<<_oo0008
olc<c003o`000?o<c<coc<c<04;oc<c<0Oooool007ooc<c<1?l000000oo<c<co0000olc<c00Folc<
c3Koo`002Oo<c<`00ol0003oc<c<olc<c011olc<c07ooooo0019olc<c0Ko00000_o<c<`00ol0003o
c<c<olc<c004o`0002?oc<c<1?l0000Iolc<c3_oo`002Oo<c<`00ol0003oc<c<olc<c010olc<c07o
oooo0019olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c00Molc<c0?o000000?oc<c<o`000?o<c<`05_o<c<a0ool000Woc<c<00?o0000olc<c?o<c<`0
?oo<c<`1ooooo`00B_o<c<`00ol0003oc<c<olc<c00;olc<c003o`000?o<c<coc<c<01Woc<c<1?l0
0004olc<c003o`000?o<c<coc<c<017oc<c<AOoo0009olc<c003o`000?o<c<coc<c<03koc<c<0Ooo
ool004_oc<c<0_l0000;olc<c003o`000?o<c<coc<c<01Koc<c<0ol000000oo<c<co0000olc<c00E
olc<c4[oo`002?o<c<`00ol0003oc<c<olc<c00nolc<c07ooooo001=olc<c003o`000?o<c<coc<c<
00?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001?o<c<`00ol0
003oc<c<olc<c00@olc<c4ooo`002?o<c<`00ol0003oc<c<olc<c00molc<c07ooooo001>olc<c003
o`000?o<c<coc<c<00;oc<c<1Ol0000Aolc<c0Go00005_o<c<aDool000Soc<c<00?o0000olc<c?o<
c<`0??o<c<`1ooooo`00BOo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00;oc<c<
00?o0000olc<c?o<c<`04?o<c<`3o`0000Coc<c<00?o0000olc<c?o<c<`04?o<c<aIool000Soc<c<
00?o0000olc<c?o<c<`0>oo<c<`1ooooo`00BOo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<
c<coc<c<00?oc<c<00?o0000olc<c?o<c<`02oo<c<`5o`0001Koc<c<GOoo0008olc<c003o`000?o<
c<coc<c<03[oc<c<0Oooool004[oc<c<1?l00006olc<c0Go00001Oo<c<`4o`0000Coc<c<00?o0000
olc<c?o<c<`04?o<c<aRool000Soc<c<00?o0000olc<c?o<c<`0>Oo<c<`1ooooo`00;oo<c<`4o`00
02Soc<c<0ol000000oo<c<co0000olc<c00Dolc<c6Koo`002Oo<c<`00ol0003oc<c<olc<c00holc<
c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`08Oo<c<`4o`0001Ko
c<c<Jooo0009olc<c003o`000?o<c<coc<c<03Ooc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Molc<c0Co000000?oc<c<o`000?o<c<`05?o<c<a_ool000Soc<c<
00?o0000olc<c?o<c<`07_o<c<`4o`000004olc<c?l0003oc<c<olc<c0Co00000_o<c<`01ol0003o
c<c<olc<c?o<c<co0000olc<c?l000001?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01[oc<c<0ol0000Golc<c7Coo`002?o<c<`00ol0003oc<c<olc<c00Lolc<
c003o`000?o<c<coc<c<00;oc<c<0_l000000oo<c<co0000olc<c003olc<c003o`000?o<c<co0000
00?oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<01Koc<c<1?l000000oo<c<co0000olc<c00Colc<c7Woo`002?o<c<`00ol0003o
c<c<olc<c00Jolc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?l000001_o<c<`01Ol0003o
c<c<olc<c?o<c<co000000Koc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003o
c<c<olc<c00Bolc<c0Co00001Oo<c<`00ol0003oc<c<olc<c00?olc<c7goo`002?o<c<`00ol0003o
c<c<olc<c00Iolc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?l000001Ol000000oo<c<co
0000olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00?olc<c0?o00000_o<c<`00ol0003oc<c<olc<c00Bolc<c8;oo`00
2?o<c<`00ol0003oc<c<olc<c00Holc<c004o`000?o<c<coc<c<olc<c0Co000000?oc<c<o`000?o<
c<`00oo<c<`00ol0003oc<c<o`000003olc<c003o`000?o<c<coc<c<00Coc<c<0Oooool002koc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00;olc<c0Co00005oo<c<b6ool000Soc<c<
00?o0000olc<c?o<c<`05oo<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<00;oc<c<
00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<olc<c004olc<c07ooooo000_olc<c0Co0000
2_o<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`3oohOoo`002?o<c<`00ol0003oc<c<
olc<c00Folc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`01?l00002olc<c004o`00
0?o<c<co0000o`0000Ooc<c<0Oooool003[oc<c<1?l0000Golc<c0So0?ooQooo0007olc<c003o`00
0?o<c<coc<c<01Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c07ooooo
000folc<c0Co00000oo<c<`00ol0003oc<c<olc<c00Bolc<c0go0?ooQ_oo0007olc<c003o`000?o<
c<coc<c<01Ooc<c<1?l0000Eolc<c07ooooo000bolc<c0Co000000?oc<c<o`000?o<c<`05_o<c<`A
o`3oohGoo`002?o<c<`00ol0003oc<c<olc<c00_olc<c07ooooo000_olc<c0?o00006Oo<c<`4ool0
01?o0?ooQ?oo0008olc<c003o`000?o<c<coc<c<02koc<c<0Oooool002goc<c<0_l000000oo<c<co
0000olc<c00Dolc<c0[oo`005?l0oon3ool000Soc<c<00?o0000olc<c?o<c<`0;Oo<c<`1ooooo`00
;Oo<c<`01?l0003oc<c<olc<c?l0000Aolc<c13oo`004ol0oon3ool000Soc<c<00?o0000olc<c?o<
c<`0;?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHAolc<c1;oo`004ol0oon2ool000So
c<c<00?o0000olc<c?o<c<`0:oo<c<`1ooooo`00;Oo<c<`2o`000003olc<c?mVIVKoc<c<01;oc<c<
4Ooo000Co`3ooh;oo`002?o<c<`00ol0003oc<c<olc<c00Zolc<c07ooooo000]olc<c004o`000?o<
c<coc<c<ofIVIQCoc<c<4_oo000Co`3ooh7oo`001oo<c<`00ol0003oc<c<olc<c00Zolc<c07ooooo
000]olc<c004o`000?o<c<coc<c<ofIVIQKoc<c<4_oo000Bo`3ooh7oo`001oo<c<`00ol0003oc<c<
olc<c00Yolc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIQSoc<c<4Ooo000Co`3ooh3oo`00
1oo<c<`00ol0003oc<c<olc<c00Xolc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIQWoc<c<
4_oo000Bo`3ooh3oo`001oo<c<`00ol0003oc<c<olc<c00Wolc<c07ooooo000]olc<c004o`000?o<
c<coc<c<ofIVIQ_oc<c<4_oo000Bo`3oogooo`001oo<c<`00ol0003oc<c<olc<c00Volc<c07ooooo
000/olc<c005o`000?o<c<coc<c<olc<c?mVIVH07Oo<c<`Aool001;o0?ooO_oo0008olc<c003o`00
0?o<c<coc<c<02Goc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`Bool001;o0?oo
OOoo0008olc<c003o`000?o<c<coc<c<02Coc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV
8Oo<c<`Bool001;o0?ooO?oo0008olc<c003o`000?o<c<coc<c<02?oc<c<0Oooool002coc<c<00Co
0000olc<c?o<c<coIVIV8oo<c<`Aool001;o0?ooO?oo0007olc<c003o`000?o<c<coc<c<02?oc<c<
0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV9?o<c<`Bool001;o0?ooNooo0007olc<c003o`00
0?o<c<coc<c<02;oc<c<0Oooool002coc<c<0_l000000oo<c<coIVIVolc<c00Uolc<c1;oo`004Ol0
oomkool000Ooc<c<00?o0000olc<c?o<c<`08Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mV
IVHXolc<c17oo`004_l0oomjool000Ooc<c<00?o0000olc<c?o<c<`08?o<c<`1ooooo`00;?o<c<`0
1?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00goc<c<4Ooo000Ao`3oog[oo`001oo<
c<`00ol0003oc<c<olc<c00Oolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?o
IVIVolc<c?o<c<`03_o<c<`Bool0017o0?ooNOoo0007olc<c003o`000?o<c<coc<c<01koc<c<0Ooo
ool002coc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00@olc<c17oo`004Ol0
oomiool000Ooc<c<00?o0000olc<c?o<c<`07Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mV
IVHJolc<c003ofIVI_o<c<coc<c<01;oc<c<4Ooo000Ao`3oogOoo`001oo<c<`00ol0003oc<c<olc<
c00Molc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`04oo<
c<`Bool0017o0?ooM_oo0007olc<c003o`000?o<c<coc<c<01coc<c<0Oooool002coc<c<00Co0000
olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Eolc<c17oo`004Ol0oomfool000Ooc<c<00?o
0000olc<c?o<c<`01oo<c<`6o`0000koc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV6_o<
c<`00omVIVKoc<c<olc<c00Golc<c17oo`004Ol0oomeool000Ooc<c<00?o0000olc<c?o<c<`01_o<
c<`00ol0003oc<c<olc<c00Aolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?o
IVIVolc<c?o<c<`06?o<c<`Bool0013o0?ooMOoo0007olc<c003o`000?o<c<coc<c<00Koc<c<00?o
0000olc<c?o<c<`04?o<c<`1ooooo`00;?o<c<`2o`000003olc<c?mVIVKoc<c<01Woc<c<00?oIVIV
olc<c?o<c<`06_o<c<`Aool0017o0?ooM?oo0007olc<c003o`000?o<c<coc<c<00Koc<c<0_l0000@
olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`07?o<c<`A
ool0013o0?oo?Ooo0004o`0003?oo`001_o<c<`2o`0000Woc<c<00?o0000olc<c?o<c<`03Oo<c<`1
ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01koc<c<4?oo000A
o`3oocKoo`001Ol00004ool00003o`000?oo003oo`00037oo`001oo<c<`00ol0003oc<c<olc<c007
olc<c003o`000?o<c<coc<c<00coc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`0
0omVIVKoc<c<olc<c00Polc<c17oo`004?l0oolaool000Co00002_oo00000ol0003oo`00ool0000a
ool000?oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<00coc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00D
olc<c003ofIVI_o<c<coc<c<00_oc<c<4Ooo000@o`3oob[oo`001Ol0000?ool00003o`000?oo003o
o`00037oo`000_o<c<`00omVIVKoc<c<olc<c005olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000
olc<c?o<c<`03?o<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<co
c<c<01Coc<c<00?oIVIVolc<c?o<c<`03Oo<c<`@ool0013o0?oo9?oo0005o`0001Goo`0000?o0000
ool00?oo0000<Ooo00000oo<c<coIVIVolc<c007olc<c0Co00003oo<c<`1ooooo`00:oo<c<`01?l0
003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`03_o<c<`A
ool0013o0?oo7?oo0006o`0001_oo`0000?o0000ool00?oo0000;_oo0003olc<c003ofIVI_o<c<co
c<c<01Woc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00D
olc<c003ofIVI_o<c<coc<c<013oc<c<4Ooo000@o`3ooaGoo`001Ol0000<ool00003o`000?oo003o
o`0001?oo`000_l0000Yool000Soc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00:oo<c<`01?l0
003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`04_o<c<`@
ool0013o0?oo3ooo0005o`0001;oo`0000?o0000ool00?oo00005?oo00000ol0003oo`00ool0000Q
ool000goc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHJ
olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`04oo<c<`Aool0013o0?oo2Ooo0004
o`0001Woo`0000?o0000ool00?oo00004ooo00000ol0003oo`00ool0000Kool001;oc<c<00?oIVIV
olc<c?o<c<`06Oo<c<`1ooooo`00:oo<c<`2ofIVIP03o`000?mVIVKoc<c<01Woc<c<00?oIVIVolc<
c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Eolc<c17oo`003ol0ool3ool000Go00002Ooo00000ol0
003oo`00ool0000Bool00003o`000?oo003oo`0001?oo`0000?o0000ool00?oo00004ooo000Iolc<
c003ofIVI_o<c<coc<c<01Woc<c<0Oooool0023oc<c<1?l00007olc<c004o`000?o<c<coIVIVofIV
IQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Golc<c13oo`003Ol0ool4o`00
02Coo`000_l0000Dool00003o`000?oo003oo`0000coo`007oo<c<`00omVIVKoc<c<olc<c00Iolc<
c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003o
c<c<olc<c003ofIVIQSoc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Holc<c17o
o`001_l0ool5o`0001Goo`0000?o0000ool00?oo00004_oo00000ol0003oo`00ool0000Bool000;o
00001Ooo0004olc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00
7oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<co
IVIV0_o<c<`2ofIVIQKoc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Jolc<c13o
o`001Ol0000Kool000;o00004ooo00000ol0003oo`00ool0000Cool00003o`000?o<c<coc<c<00Ko
c<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH4olc<c0?o
IVIV4oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01coc<c<2Ooo0005o`0000_o
o`0000?o0000ool00?oo00005?oo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`0001?o
o`0000?o0000olc<c?o<c<`01Oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01So
c<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`00
0?o<c<coc<c<ofIVIPOoc<c<0_mVIVHAolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<
c<`04Oo<c<`00omVIVKoc<c<olc<c00:olc<c0;oo`001Ol0000Bool00003o`000?oo003oo`0001?o
o`000_l0000Bool000;o00005?oo00000ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<023o
c<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`00
0?o<c<coc<c<00?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP09olc<c0;oIVIV3oo<c<`00omVIVKo
c<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`01oo<c<`5o`0001Wo
o`0000?o0000ool00?oo00004ooo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`0001;o
o`0000?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01So
c<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c004o`00
0?o<c<coc<c<ofIVIPcoc<c<0_mVIVH=olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<
c<`04Oo<c<`00omVIVKoc<c<olc<c002olc<c0Go00007ooo0002o`0001Coo`000_l0000Bool00003
o`000?oo003oo`0001;oo`0000?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Polc<c003
ofIVI_o<c<coc<c<01Soc<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c003olc<c004o`000?o<c<coc<c<ofIVIPkoc<c<0_mVIVH;olc<c003ofIVI_o<c<coc<c<01Co
c<c<00?oIVIVolc<c?o<c<`04Oo<c<`5o`00017oo`0000?o0000ool00?oo00004_oo00000ol0003o
o`00ool0000Cool00003o`000?oo003oo`00013oo`000_l0000Cool000;o00000_o<c<`00omVIVKo
c<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool0023oc<c<1?l00006olc<c004o`00
0?o<c<coc<c<ofIVIQ3oc<c<0_mVIVH9olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<
c<`03?o<c<`5o`0001Soo`0000?o0000ool00?oo00004Ooo0002o`0001Coo`0000?o0000ool00?oo
00004Ooo00000ol0003oo`00ool0000Bool00003o`000?o<c<coIVIV02;oc<c<00?oIVIVolc<c?o<
c<`06?o<c<`1ooooo`00:_o<c<`2o`000003olc<c?mVIVKoc<c<017oc<c<0_mVIVH7olc<c003ofIV
I_o<c<coc<c<01?oc<c<00?oIVIVolc<c?o<c<`02?o<c<`5o`0001ooo`0000?o0000ool00?oo0000
4Ooo0002o`0001?oo`000_l0000Bool00003o`000?oo003oo`0001;oo`0000?o0000ofIVI_o<c<`0
8Oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQCoc<c<
0_mVIVH5olc<c003ofIVI_o<c<coc<c<01?oc<c<00?oIVIVolc<c?o<c<`00oo<c<`5o`0001;oo`00
00?o0000ool00?oo00004?oo0002o`0001?oo`0000?o0000ool00?oo00004_oo00000ol0003oo`00
ool0000@ool000;o00004ooo00000ol0003oc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<
0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV5_o<c<`2ofIVIP?oc<c<00?oIVIVolc<c?o<c<`0
4oo<c<`00omVIVKo0000o`000003o`0001Soo`000_l0000Bool000;o00004_oo0002o`0001?oo`00
0_l0000Bool00003o`000?oo003oo`00017oo`0000?o0000olc<c?o<c<`07oo<c<`00omVIVKoc<c<
olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<0omVIVHBolc<c0Go0000
2ooo00000ol0003oo`00ool0000Aool000;o00004_oo00000ol0003oo`00ool0000Aool00003o`00
0?oo003oo`0001;oo`0000?o0000ool00?oo00004?oo00000ol0003oo`00ool0000Aool000;o0000
7oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<
0omVIVH=olc<c0?o00004_oo00000ol0003oo`00ool0000Aool000;o00004Ooo0002o`0001;oo`00
0_l0000Cool000;o00004Ooo0002o`0001?oo`0000?o0000olc<c?o<c<`07?o<c<`00omVIVKoc<c<
olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`0
0_mVIVH;olc<c003o`000?l0ooooo`0001Coo`0000?o0000ool00?oo00004Ooo0002o`00017oo`00
0_l0000Bool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00004?oo00000ol0003oo`00
ool0000Aool00003o`000?o<c<coc<c<01_oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<
c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00;oc<c<0_mVIVH9olc<c005o`00
0?l0oooo0?ooo`3oool000005?oo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`00013o
o`000_l0000Aool000;o00004ooo00000ol0003oo`00ool0000@ool00003o`000?oo003oo`00017o
o`0000?o0000olc<c?o<c<`06_o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`00
0?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`01?o<c<`2ofIVIPOoc<c<00?o0000o`3oool0
ool00ol0ool00ol0003oo`00ool0000Aool000;o00004_oo0002o`0001;oo`0000?o0000ool00?oo
00004?oo0002o`0001;oo`000_l0000Aool000;o00004_oo00000ol0003oc<c<olc<c00Iolc<c003
ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKo
c<c<olc<c006olc<c0;oIVIV1?o<c<`00ol0003o0?ooo`3oo`06o`3oo`;o00004_oo0002o`0001;o
o`000_l0000Aool000;o00004_oo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`00013o
o`0000?o0000ool00?oo00004?oo00000ol0003oc<c<olc<c00Holc<c003ofIVI_o<c<coc<c<01So
c<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c008olc<c0;o
IVIV0_o<c<`00ol0003o0?ooo`3oo`08o`3oo`;o00004_oo0002o`0001;oo`000_l0000Aool000;o
00004Ooo0002o`0001;oo`000_l0000Aool00003o`000?oo003oo`00013oo`000_l0000Holc<c003
ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKo
c<c<olc<c00:olc<c0;oIVIV00?o0000o`3oool0ool02_l0ool2o`0001;oo`000_l0000Bool000;o
00004Ooo00000ol0003oo`00ool0000@ool00003o`000?oo003oo`00017oo`0000?o0000ool00?oo
00003ooo00000ol0003oo`00ool0000Aool00003o`000?o<c<coc<c<01Goc<c<00?oIVIVolc<c?o<
c<`06?o<c<`1ooooo`00:_o<c<`2o`000003olc<c?mVIVKoc<c<01Woc<c<00?oIVIVolc<c?o<c<`0
3?o<c<`00ol0003o0?ooo`3oo`0=o`3oo`;o00004Ooo0002o`0001;oo`0000?o0000ool00?oo0000
3ooo0002o`00017oo`000_l0000Bool000;o00004?oo0002o`0001;oo`0000?o0000olc<c?o<c<`0
5?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Yolc<c005o`000?o<c<coc<c<olc<c?mVIVH0
6_o<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo00oo0?oo0_l0000Aool000;o0000
4Ooo0002o`00017oo`000_l0000Aool000;o00004_oo00000ol0003oo`00ool0000?ool00003o`00
0?oo003oo`00013oo`0000?o0000olc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo
000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`03?o<c<`00ol0003o0?oo
o`3oo`0Ao`3oo`;o00004Ooo0002o`00017oo`000_l0000Aool00003o`000?oo003oo`00013oo`00
00?o0000ool00?oo00004?oo00000ol0003oo`00ool0000?ool00003o`000?oo003oo`00013oo`00
00?o0000olc<c?o<c<`04oo<c<`4ofIVIQKoc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV
6oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo0?oo01Co0?oo0_l0000Aool000;o0000
4Ooo0002o`00013oo`000_l0000Aool000;o00004Ooo0002o`00013oo`000_l0000Aool000;o0000
3?o<c<`8ofIVIQWoc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<
olc<c00;olc<c003o`000?l0oooo0?oo01Ko0?oo0_l0000Aool000;o00004Ooo0002o`00013oo`00
0_l0000Aool00003o`000?oo003oo`00013oo`0000?o0000ool00?oo00003ooo00000ol0003oo`00
ool0000@ool00003o`000?o<c<coc<c<00?oc<c<1_mVIVH7olc<c003ofIVI_o<c<coc<c<01Ooc<c<
0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`00
0?l0oooo0?oo01So0?oo0_l0000Aool00003o`000?oo003oo`00013oo`0000?o0000ool00?oo0000
3ooo0002o`00013oo`000_l0000Aool000;o00004?oo00000ol0003oo`00ool0000@ool00003o`00
0?mVIVKoIVIV00;oIVIV3Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<
c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Jo`3oo`;o0000
4?oo0002o`00017oo`000_l0000Aool00003o`000?oo003oo`0000ooo`000_l0000Aool00003o`00
0?oo003oo`0000koo`000_l0000Aool00003o`000?o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`0
5oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00_oc<c<
00?o0000o`3oool0ool07?l0ool2o`00013oo`000_l0000Aool000;o00004?oo0002o`00017oo`00
00?o0000ool00?oo00003ooo00000ol0003oo`00ool0000?ool00003o`000?oo003oo`0000ooo`00
00?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<
c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0No`3oo`;o0000
4?oo0002o`00017oo`000_l0000@ool000;o00004?oo0002o`00013oo`000_l0000@ool00003o`00
0?oo003oo`0000ooo`0000?o0000olc<c?o<c<`03?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo
000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?oo
o`3oo`0Po`3oo`;o00004?oo0002o`00017oo`000_l0000@ool00003o`000?oo003oo`0000ooo`00
00?o0000ool00?oo00003ooo00000ol0003oo`00ool0000>ool000;o00004?oo0002o`0000coc<c<
00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIV
I_o<c<coc<c<00[oc<c<00?o0000o`3oool0ool08ol0ool2o`00013oo`000_l0000Aool000;o0000
3ooo0002o`00013oo`000_l0000@ool000;o00004?oo00000ol0003oo`00ool0000?ool00003o`00
0?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`2o`000003olc<c?mV
IVKoc<c<01[oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3oo`0Uo`3oo`;o00004?oo
0002o`00017oo`0000?o0000ool00?oo00003_oo0002o`00013oo`000_l0000@ool00003o`000?oo
003oo`0000koo`0000?o0000ool00?oo00003ooo00000ol0003oc<c<olc<c008olc<c003ofIVI_o<
c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<
c00;olc<c003o`000?l0oooo0?oo02Oo0?oo0ol0000?ool000;o00004?oo0002o`00013oo`0000?o
0000ool00?oo00003ooo00000ol0003oo`00ool0000>ool000;o00003ooo0002o`00013oo`0000?o
0000olc<c?o<c<`01oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<co
c<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Zo`3oo`;o00003ooo
0002o`00013oo`000_l0000?ool000;o00004?oo0002o`00013oo`0000?o0000ool00?oo00003_oo
00000ol0003oo`00ool0000>ool00003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`05oo<
c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00_oc<c<00?o
0000o`3oool0ool0;?l0ool2o`0000ooo`000_l0000@ool000;o00003ooo0002o`00013oo`0000?o
0000ool00?oo00003_oo00000ol0003oo`00ool0000>ool00003o`000?oo003oo`0000koo`000_l0
0006olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6_o<
c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo0?oo02ko0?oo0_l0000?ool000;o00004?oo
0002o`0000ooo`0000?o0000ool00?oo00003_oo0002o`0000ooo`000_l0000?ool00003o`000?oo
003oo`0000ooo`0000?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Y
olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3o
o`0ao`3oo`;o00003ooo00000ol0003oo`00ool0000?ool00003o`000?oo003oo`0000goo`000_l0
000@ool00003o`000?oo003oo`0000koo`0000?o0000ool00?oo00003Ooo0002o`00013oo`0000?o
0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Xolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3oo`0co`3oo`;o00003_oo
0002o`00013oo`000_l0000?ool000;o00003ooo0002o`0000ooo`000_l0000?ool00003o`000?oo
003oo`0000koo`0000Go0000olc<c?o<c<coc<c<ofIVIP0Iolc<c07ooooo000Xolc<c004o`000?o<
c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3oo`0eo`3oo`;o0000
3_oo0002o`00013oo`000_l0000?ool000;o00003ooo0002o`0000ooo`0000?o0000ool00?oo0000
3Ooo00000ol0003oo`00ool0000>ool00004o`000?o<c<coc<c<ofIVIQWoc<c<0Oooool002Soc<c<
00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00:olc<c003o`000?l0oooo0?oo03Oo
0?oo0_l0000>ool000;o00004?oo0002o`0000ooo`0000?o0000ool00?oo00003_oo00000ol0003o
o`00ool0000=ool000;o00003_oo0002o`0000ooo`0000?o0000olc<c?mVIVH06Oo<c<`1ooooo`00
:?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00[oc<c<00?o0000o`3oool0
ool0>Ol0ool2o`0000koo`000_l0000@ool000;o00003_oo0002o`0000ooo`000_l0000?ool00003
o`000?oo003oo`0000goo`0000?o0000ool00?oo00002_oo0004o`000003olc<c?mVIVKoc<c<01Oo
c<c<0Oooool002Soc<c<0ol000000omVIVKoc<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<00[oc<c<
00?o0000o`3oool0ool0>ol0ool2o`0000koo`000_l0000@ool00003o`000?oo003oo`0000goo`00
0_l0000?ool00003o`000?oo003oo`0000goo`0000?o0000ool00?oo00003Ooo00000ol0003oo`00
ool00002ool000Oo00001Oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Lolc<c0Ko00001_o<
c<`2ofIVIP03olc<c?mVIVKoc<c<01[oc<c<00?oIVIVolc<c?o<c<`02Oo<c<`00ol0003o0?ooo`3o
o`0no`3oo`;o00003_oo0002o`0000ooo`000_l0000?ool00003o`000?oo003oo`0000goo`000_l0
000>ool000;o00002ooo0007o`0000coc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`0
0ol0003oc<c<olc<c009olc<c003o`000?o<c<coIVIV00;oIVIV6_o<c<`00omVIVKoc<c<olc<c009
olc<c003o`000?l0oooo0?oo043o0?oo0_l0000>ool000;o00003ooo0002o`0000koo`000_l0000?
ool000;o00003_oo00001?l0003oo`00ool00?oo0007o`0001?oc<c<00?oIVIVolc<c?o<c<`05_o<
c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c008olc<c005o`000?o<c<coc<c<ofIVI_o<c<`00omV
IVHGolc<c003ofIVI_o<c<coc<c<00Woc<c<00?o0000o`3oool0ool0@_l0ool2o`0000koo`000_l0
000?ool000;o00003_oo0002o`0000ooo`0000?o0000ool00?oo00001Ooo000:o`0001[oc<c<00?o
IVIVolc<c?o<c<`05_o<c<`1ooooo`007_o<c<`2o`0000Soc<c<00Co0000olc<c?o<c<coIVIV1?o<
c<`3ofIVIQCoc<c<00?oIVIVolc<c?o<c<`02Oo<c<`00ol0003o0?ooo`3oo`14o`3oo`?o00003Ooo
0002o`0000ooo`000_l0000>ool00003o`000?oo003oo`0000[oo`002_l000000oo<c<coIVIVolc<
c00Qolc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool0023oc<c<00?o0000olc<c?o<c<`01Oo<c<`0
1?l0003oc<c<olc<c?mVIVH7olc<c0?oIVIV4Oo<c<`00omVIVKoc<c<olc<c009olc<c003o`000?l0
oooo0?oo04Oo0?oo0_l0000=ool00003o`000?oo003oo`0000koo`0000?o0000ool00?oo00003?oo
0002o`0000?oo`001ol0000;olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<
c<`1ooooo`008Oo<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP[oc<c<0omV
IVH>olc<c003ofIVI_o<c<coc<c<00Woc<c<00?o0000o`3oool0ool0BOl0ool2o`0000coo`000_l0
000?ool000;o00002ooo0006o`0001;oc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<
c00Folc<c07ooooo000Lolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`0
1?l0003oc<c<olc<c?mVIVH=olc<c0?oIVIV2oo<c<`00omVIVKoc<c<olc<c008olc<c003o`000?l0
oooo0?oo04co0?oo0_l0000<ool000;o00003ooo0002o`0000?oo`001_l0000Holc<c003ofIVI_o<
c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c002
olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`2ofIVIPWoc<c<00?o
IVIVolc<c?o<c<`02?o<c<`00ol0003o0?ooo`3oo`1>o`3oo`;o00003?oo0002o`0000coo`001_l0
000Nolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`0
0ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00;o00000_o<c<`00ol0003oc<c<olc<c00:
olc<c0Co00001oo<c<`01?l0003oc<c<olc<c?mVIVHBolc<c0?oIVIV1_o<c<`00omVIVKoc<c<olc<
c008olc<c003o`000?l0oooo0?oo053o0?oo0_l0000<ool000;o00000ooo0007o`0000Coc<c<00?o
IVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Koc<c<0Ooo
ool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Kolc<c004o`000?o<
c<coc<c<ofIVIQGoc<c<0omVIVH3olc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0ool0
D_l0ool2o`0000Koo`002Ol0000;olc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`0
8?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co
0000olc<c?o<c<co00006_o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01Soc<c<0omVIVH;olc<c003
o`000?l0oooo0?oo05Co0?oo1_l0000Dolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<
c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<
00Co0000olc<c?o<c<co00006_o<c<`2o`000003olc<c?mVIVKoc<c<01[oc<c<1?mVIVH8olc<c003
o`000?l0oooo0?oo05Co0?oo00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Molc<c003
ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`7o`0000;oc<c<
00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c004ofIVI_o<c<coc<c<olc<
c0?oIVIV1Oo<c<`00ol0003o0?ooo`3oo`1Do`3oo`03o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<
c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?o
c<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c004o`000?o<c<coc<c<
ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01?o<c<`2ofIVIP;oc<c<00?o0000o`3oool0ool0EOl0ool0
0ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`08?o<c<`0
0omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<
c?l000000_l0000Iolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`2
ofIVIP03o`000?l0oooo0?oo05Go0?oo00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00M
olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`00ol0
003oc<c<olc<c006olc<c003o`000?o<c<coc<c<01Soc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`0
0omVIVKoc<c<olc<c008olc<c003o`000?l0oooo0?oo05Co0?oo00?o0000olc<c?o<c<`06?o<c<`0
0omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1
ooooo`000oo<c<`7o`0000;oc<c<00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHK
olc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0ool0E?l0ool00ol0003oc<c<olc<c00H
olc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00F
olc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02?o<c<`0
0ol0003o0?ooo`3oo`1Do`3oo`03o`000?o<c<coc<c<01Soc<c<00?oIVIVolc<c?o<c<`07Oo<c<`0
0omVIVKoc<c<olc<c00Polc<c0GoIVIV5?o<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHK
olc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0ool0E?l0ool00ol0003oc<c<olc<c00H
olc<c003ofIVI_o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`05oo<c<`8ofIVIP03olc<c?mVIVKo
c<c<01Koc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c007
olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000olc<c?o<c<`06?o<c<`00omVIVKoc<c<olc<c00N
olc<c003ofIVI_o<c<coc<c<00koc<c<2OmVIVH9olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool0
02Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c007olc<c003o`000?l0oooo
0?oo05Go0?oo00?o0000olc<c?o<c<`06?o<c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<co
c<c<00Koc<c<2?mVIVHBolc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00Co0000olc<
c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c007olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000
olc<c?o<c<`06?o<c<`00omVIVKoc<c<olc<c00Nolc<c0WoIVIV6_o<c<`00omVIVKoc<c<olc<c00E
olc<c07ooooo000Wolc<c0;o000000?oc<c<ofIVI_o<c<`06_o<c<`00omVIVKoc<c<olc<c007olc<
c003o`000?l0oooo0?oo05Co0?oo00?o0000olc<c?o<c<`06Oo<c<`00omVIVKoc<c<olc<c00Golc<
c0SoIVIV8_o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIV
IQ_oc<c<00?oIVIVolc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`1Do`3oo`03o`000?o<c<coc<c<
01Woc<c<00?oIVIVolc<c?o<c<`03_o<c<`9ofIVIPOoc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omV
IVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<
c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`1Do`3oo`03o`000?o<c<coc<c<01Woc<c<00?oIVIVolc<
c?o<c<`01_o<c<`8ofIVIQ3oc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Eolc<
c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0
003o0?ooo`3oo`1Eo`3oo`03o`000?o<c<coc<c<01Woc<c<2OmVIVHHolc<c003ofIVI_o<c<coc<c<
023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV
01_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?o<c<coc<c<
01;oc<c<2?mVIVHPolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1oooo
o`009_o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3o
ool0ool0EOl0ool00ol0003oc<c<olc<c009olc<c0WoIVIV1oo<c<`00omVIVKoc<c<olc<c00Nolc<
c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01?l0003o
c<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0ool0EOl0ool01?l0
003oc<c<olc<c?o<c<`8ofIVIQ3oc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00P
olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`0
0omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo05Go0?oo00Co0000ofIVI_mVIVKoIVIV6?o<
c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<
c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Ooc<c<00?o
0000o`3oool0ool0E?l0ool00ol0003oc<c<olc<c00Jolc<c003ofIVI_o<c<coc<c<01koc<c<00?o
IVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?o<
c<coc<c<01[oc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<
c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c006olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000olc<c?o<c<`06_o<c<`00omVIVKoc<c<olc<
c00Nolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`2
o`000003olc<c?mVIVKoc<c<01[oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`1E
o`3oo`03o`000?o<c<coc<c<01_oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00P
olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`0
0omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000olc<c?o<c<`06oo<c<`0
0omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1
ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000
o`3oool0ool0EOl0ool00ol0003oc<c<olc<c00Kolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIV
olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<
ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?o<c<co
c<c<01_oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<co
c<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c006
olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000olc<c?o<c<`06oo<c<`00omVIVKoc<c<olc<c00M
olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0
003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool0EOl0ool0
0ol0003oc<c<olc<c00Lolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`08Oo<c<`0
0omVIVKoc<c<olc<c00Dolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIV
olc<c?o<c<`01Oo<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?o<c<coc<c<01coc<c<00?oIVIV
olc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool0
02Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c005olc<c003o`000?l0oooo
0?oo05Go0?oo00?o0000olc<c?o<c<`07?o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<co
c<c<027oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHK
olc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool0EOl0ool00ol0003oc<c<olc<c00L
olc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00D
olc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`01Oo<c<`0
0ol0003o0?ooo`3oo`1Eo`3oo`03o`000?o<c<coc<c<01coc<c<00?oIVIVolc<c?o<c<`07_o<c<`0
0omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<
c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c005olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000
olc<c?o<c<`07?o<c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIV
olc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c0CoIVIV7?o<c<`00omV
IVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo05Ko0?oo00?o0000olc<c?o<c<`07?o<c<`00omV
IVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1oooo
o`007Oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00CoIVIV6Oo<c<`00omVIVKo
c<c<olc<c004olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000ofIVI_o<c<`07Oo<c<`00omVIVKo
c<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`00
6Oo<c<`6o`0000Koc<c<00Co0000olc<c?o<c<coIVIV0oo<c<`4ofIVIQGoc<c<00?oIVIVolc<c?o<
c<`01?o<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?mVIVKoc<c<01goc<c<00?oIVIVolc<c?o<
c<`07_o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001Woc<c<
00Go0000olc<c?o<c<coc<c<o`000007olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<1OmVIVH@olc<
c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool0EOl0ool00ol0003oIVIVolc<c00Molc<
c003ofIVI_o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Dolc<
c07ooooo000Jolc<c004o`000?o<c<coc<c<o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV3?o<c<`4
ofIVIPcoc<c<00?oIVIVolc<c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?mVIVKo
c<c<01goc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<co
c<c<01Coc<c<0Oooool001_oc<c<00?o0000olc<c?l000001oo<c<`01?l0003oc<c<olc<c?mVIVH@
olc<c0CoIVIV2?o<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo05Go0?oo00?o0000
ofIVI_o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIV
olc<c?o<c<`05?o<c<`1ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c004o`000?o<c<coc<c<
ofIVIQCoc<c<1?mVIVH3olc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool0E_l0ool0
0ol0003oIVIVolc<c00Molc<c003ofIVI_o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`08?o<c<`0
0omVIVKoc<c<olc<c00Dolc<c07ooooo000Lolc<c0;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHH
olc<c0CoIVIV1_o<c<`00ol0003o0?ooo`3oo`1Fo`3oo`03o`000?mVIVKoc<c<01goc<c<00?oIVIV
olc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool0
01goc<c<00?o0000olc<c?o<c<`01Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c0GoIVIV0_o<c<`0
0ol0003o0?ooo`3oo`1Fo`3oo`03o`000?mVIVKoc<c<01goc<c<00?oIVIVolc<c?o<c<`07_o<c<`0
0omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<
c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c002olc<c0;oIVIV00?o0000o`3oool0ool0EOl0ool0
0ol0003oc<c<ofIVIP0Nolc<c003ofIVI_o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`08?o<c<`0
0omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIV
olc<c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?o<c<coIVIV01koc<c<00?oIVIV
olc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool0
02Goc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo
0?oo05Go0?oo00?o0000olc<c?mVIVH07_o<c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<co
c<c<027oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009Oo<c<`2o`000003olc<c?mVIVKoc<c<
01[oc<c<00?oIVIVolc<c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`1Eo`3oo`03o`000?o<c<coIVIV
01koc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Nolc<c0OoIVIV4_o<c<`1oooo
o`009Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3o
ool0ool0E_l0ool00ol0003oc<c<ofIVIP0Nolc<c003ofIVI_o<c<coc<c<01koc<c<00?oIVIVolc<
c?o<c<`04_o<c<`<ofIVIP?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003o
c<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3oool0ool0E_l0ool00ol0
003oc<c<ofIVIP0Nolc<c003ofIVI_o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`01Oo<c<`=ofIV
IPooc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<
c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3oool0ool0E_l0ool00ol0003oc<c<ofIVIP0Nolc<
c003ofIVI_o<c<coc<c<01[oc<c<3?mVIVHLolc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Co
c<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo
05Go0?oo00Co0000olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<c00>olc<c0coIVIV1?o<c<`0
0omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<
c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo05Go0?oo00Co0000
olc<c?o<c<coIVIV7_o<c<`01?mVIVKoc<c<olc<c?o<c<`=ofIVIQ3oc<c<00?oIVIVolc<c?o<c<`0
8Oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<
00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`1Eo`3oo`04o`000?o<c<coc<c<ofIVIQKo
c<c<3?mVIVHMolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`00
9?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0
ool0E_l0ool01?l0003oc<c<olc<c?mVIVH:olc<c0coIVIV2?o<c<`00omVIVKoc<c<olc<c00Nolc<
c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003o
c<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0ool0E_l0ool00ol0
003oc<c<ofIVIP0;ofIVIQCoc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Qolc<
c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omV
IVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo05Ko0?oo00Co0000ofIVI_o<c<coIVIV7_o<c<`0
0omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1
ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000
o`3oool0ool0E_l0ool01?l0003oc<c<olc<c?mVIVHNolc<c003ofIVI_o<c<coc<c<01ooc<c<00?o
IVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c0;o000000?oc<c<
ofIVI_o<c<`06oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo05Ko0?oo00Co0000
olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<023oc<c<00?o
IVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<
c<coc<c<00;oc<c<00?o0000o`3oool0ool0EOl0ool01Ol0003oc<c<olc<c?o<c<coIVIV01koc<c<
00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01?oc<c<
0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01OmVIVKoc<c<olc<c?o<c<co000005So
0?oo00Go0000olc<c?o<c<coc<c<ofIVIP0Nolc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<
c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIV
IQ_oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`1Fo`3oo`05o`000?o<c<coc<c<
olc<c?mVIVH07_o<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIV
olc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<co
c<c<00;oc<c<00?o0000o`3oool0ool0E_l0ool01Ol0003oc<c<olc<c?o<c<coIVIV01koc<c<00?o
IVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01?oc<c<0Ooo
ool002Coc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0
oooo0?oo05Ko0?oo00Go0000olc<c?o<c<coc<c<ofIVIP0Nolc<c003ofIVI_o<c<coc<c<01ooc<c<
00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Solc<c005o`000?o<
c<coc<c<olc<c?mVIVH06oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo05Ko0?oo
00Go0000olc<c?o<c<coc<c<ofIVIP0Nolc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<
c<`08?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQco
c<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`1Fo`3oo`05o`000?o<c<coc<c<olc<
c?mVIVH07_o<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<
c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c005ofIVI_o<c<coc<c<
olc<c?l00000F?l0ool00ol0003oc<c<olc<c002olc<c003ofIVI_o<c<coc<c<01coc<c<00?oIVIV
olc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool0
02?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01OmVIVKoc<c<olc<c?o<c<co000005So0?oo00?o
0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Lolc<c003ofIVI_o<c<coc<c<01ooc<c<00?o
IVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<co
c<c<ofIVIQcoc<c<00GoIVIVolc<c?o<c<coc<c<o`00001Ho`3oo`03o`000?o<c<coc<c<00;oc<c<
00?oIVIVolc<c?o<c<`07?o<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<027oc<c<
00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c005ofIV
I_o<c<coc<c<olc<c?l00000F?l0ool00ol0003oc<c<olc<c002olc<c003ofIVI_o<c<coc<c<01co
c<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01;o
c<c<0Oooool002?oc<c<0_l000000oo<c<coIVIVolc<c00Kolc<c005ofIVI_o<c<coc<c<olc<c?l0
0000F?l0ool00ol0003oc<c<olc<c002olc<c003ofIVI_o<c<coc<c<01coc<c<00?oIVIVolc<c?o<
c<`07oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<
00Co0000olc<c?o<c<coIVIV7?o<c<`01OmVIVKoc<c<olc<c?o<c<co000005So0?oo00?o0000olc<
c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<01koc<c<00?oIVIVolc<
c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIV
IQcoc<c<00GoIVIVolc<c?o<c<coc<c<o`00001Ho`3oo`03o`000?o<c<coc<c<00;oc<c<00?oIVIV
olc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIV
olc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c004ofIVI_o<c<co
c<c<o`0005Wo0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<
c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000S
olc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00CoIVIVolc<c?o<c<co0000F?l0ool00ol0003oc<c<
olc<c003olc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<
olc<c00Qolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV
7?o<c<`01?mVIVKoc<c<olc<c?l0001Ho`3oo`03o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<
c<`07Oo<c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<
c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c004ofIVI_o<c<coc<c<o`00
05So0?oo00?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<
01koc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004
o`000?o<c<coc<c<ofIVIQcoc<c<00CoIVIVolc<c?o<c<co0000F?l0ool00ol0003oc<c<olc<c003
olc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Q
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`0
1?mVIVKoc<c<olc<c?l0001Ho`3oo`03o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`07Oo<
c<`00omVIVKoc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04_o<
c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<co000005Wo0?oo00?o
0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<01koc<c<00?o
IVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Rolc<c004o`000?o<c<co
c<c<ofIVIQgoc<c<00?oIVIVolc<c?l00000FOl0ool00ol0003oc<c<olc<c003olc<c003ofIVI_o<
c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<
c<coc<c<01;oc<c<0Oooool001Ooc<c<1?l00007olc<c004o`000?o<c<coc<c<ofIVIQ3oc<c<5?l0
001Eo`3oo`03o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<
c00Nolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`005_o<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<1_mVIVHColc<c003o`000?oo003o
o`0000coo`002?l0001<o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`07Oo<c<`0
0omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1
ooooo`005_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<
c?o<c<coIVIV0_o<c<`9ofIVIQ7oc<c<00?oIVIVolc<c?l000003Ooo0008o`0004Co0?oo00?o0000
olc<c?o<c<`01?o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIV
olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Folc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH;olc<c0WoIVIV2?o<c<`0
0omVIVKoc<c<olc<c007olc<c0;o00003?oo0008o`0003co0?oo00?o0000olc<c?o<c<`01?o<c<`0
0omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`08Oo<c<`0
0omVIVKoc<c<olc<c00Aolc<c07ooooo000Folc<c0;o00000oo<c<`00ol0003oc<c<olc<c004olc<
c004o`000?o<c<coc<c<ofIVIQCoc<c<2OmVIVHAolc<c0Co00002_oo0008o`0003Co0?oo00?o0000
olc<c?o<c<`01?o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIV
olc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo000Folc<c003o`000?o<c<co0000
00;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c0[oIVIV3oo<c<`00omVIVKoc<c<o`000003
o`0000Woo`002?l0000/o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`07Oo<c<`0
0omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1
ooooo`005_o<c<`00ol0003oc<c<olc<c009olc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIV
olc<c?o<c<`01oo<c<`9ofIVIPKoc<c<00?oIVIVolc<c?o<c<`01oo<c<`6o`0000Ooo`002?l0000T
o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00O
olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`005oo<c<`01Ol0
003oc<c<olc<c?o<c<co000002Koc<c<00?oIVIVolc<c?o<c<`04?o<c<`9ofIVIPooc<c<1ol00006
ool000So00007?l0ool00ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIV
olc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Golc<c0ooIVIV3oo<c<`1ooooo`006?o<c<`3o`00
02Ooc<c<00?oIVIVolc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c009ofIVIPWoc<c<00?oIVIVolc<
c?o<c<`00oo<c<`7o`0000Goo`002?l0000Co`3oo`03o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<
c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Nolc<c1_oIVIV2_o<c<`00omVIVKoc<c<olc<c00Aolc<
c07ooooo0012olc<c003ofIVI_o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`02Oo<c<`:ofIVIPgo
c<c<2?l00004ool000So00002ol0ool00ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<01go
c<c<00?oIVIVolc<c?o<c<`00_o<c<`LofIVIP03olc<c?mVIVKoc<c<02;oc<c<00?oIVIVolc<c?o<
c<`04Oo<c<`1ooooo`00Foo<c<`00omVIVKoc<c<olc<c00Bolc<c0WoIVIV2_o<c<`00omVIVKoc<c<
olc<c009o`0000?oo`002?l00003o`3oo`03o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`0
1_o<c<`LofIVIQgoc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo
001Kolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`01_o<c<`9ofIVIP03olc<c?mV
IVKoc<c<00?oc<c<00?oIVIVolc<c?o<c<`01?o<c<`:o`000003ool00?l0003o000000;o00004?mV
IVHGolc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<
c00Aolc<c07ooooo001`olc<c003ofIVI_o<c<coc<c<00ooc<c<4OmVIVHBolc<c003ofIVI_o<c<co
c<c<01goc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00eolc<c07ooooo001`olc<
c003ofIVI_o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Jolc<
c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`0Eoo<c<`1ooooo`00Poo<c<`00omVIVKo
c<c<olc<c002olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIVolc<c?o<c<`0Moo<c<`1ooooo`00
Poo<c<`00omVIVKoc<c<olc<c002olc<c003ofIVI_o<c<coc<c<09Coc<c<0Oooool00?ooc<c<8?o<
c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00
aOo<c<`2o`0005Soc<c<0Oooool00<Koc<c<0_l00002olc<c003o`000?o<c<coc<c<05;oc<c<0Ooo
ool00<Ooc<c<0_l00002olc<c003o`000?o<c<coc<c<057oc<c<0Oooool003ooc<c<1Ol00004olc<
c0?o00000oo<c<`2o`0000?oc<c<0ol00002olc<c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<
c0;o00000_o<c<`3o`000003olc<c?l0003o000000;oc<c<0_l00002olc<c0Co00000oo<c<`4o`00
00?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000Coc<c<0_l00003olc<c0;o000000?oc<c<o`00
0?l000000_o<c<`4o`0000?oc<c<0ol00003olc<c0?o00000oo<c<`2o`0000Coc<c<0ol000000oo<
c<co0000o`000007olc<c0Co000000Coc<c<o`000?o<c<coc<c<1?l00002olc<c0;o00000_o<c<`2
o`000003olc<c?l0003o000000Koc<c<0_l0000]olc<c07ooooo000nolc<c0;o00000oo<c<`2o`00
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000;oc<c<0_l00002olc<
c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`00
00;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o0000
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`00
0003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00000oo<c<`2o`000004olc<c?l0003o0000
olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`2
o`0000Coc<c<0ol000000oo<c<co0000o`000006olc<c0;o00000_o<c<`3o`000003olc<c?l0003o
000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000001_o<c<`2
o`0002goc<c<0Oooool003koc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`00
0003olc<c?l0003o000000?oc<c<0_l00002olc<c0;o00001Oo<c<`2o`0000;oc<c<0_l00003olc<
c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o0000
00Soc<c<0ol00004olc<c0?o000000?oc<c<o`000?l000002?o<c<`3o`0000?oc<c<0_l00003olc<
c0;o000000?oc<c<o`000?l000001?o<c<`3o`0000;oc<c<0_l00002olc<c0;o00000oo<c<`2o`00
0003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001?o<c<`2o`00
0003olc<c?l0003o000000Goc<c<0_l00002olc<c0;o00002Oo<c<`2o`0002goc<c<0Oooool004;o
c<c<0ol000000oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`0000;o
c<c<1_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<c0;o
00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000004o`0000;oc<c<1?l00003olc<c0Co
00000_o<c<`6o`0000;oc<c<1?l00004olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;o
c<c<1?l00003olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o
000000?oc<c<o`000?l000001oo<c<`2o`0000Coc<c<0_l000000oo<c<co0000o`000004o`000003
olc<c?l0003o000000;oc<c<0_l00009olc<c0;o0000;Oo<c<`1ooooo`00?oo<c<`5o`0000;oc<c<
0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`0000;oc<c<0_l00002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<1Ol000000oo<c<co0000o`000002olc<c0;o0000
0_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000Coc<c<o`000?l0003o
00001?o<c<`3o`0000Coc<c<0_l00002olc<c0;o000000Coc<c<o`000?l0003o00001_o<c<`2o`00
00?oc<c<0_l000001?o<c<co0000o`000?o<c<`3o`0000Goc<c<0_l00002olc<c0;o00000oo<c<`2
o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00000_o<c<`4
o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00002Oo<c<`2
o`0002goc<c<0Oooool003koc<c<0ol00006olc<c0;o000000?oc<c<o`000?l000000_o<c<`3o`00
00;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<
c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o0000
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`00
0003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`7o`00
0004olc<c?l0003o0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<
o`000?l000000_o<c<`3o`0000;oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001oo<c<`2
o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00002Oo<c<`2o`0002goc<c<0Oooool0
03koc<c<0_l00003olc<c0;o00000oo<c<`3o`0000?oc<c<0ol000000oo<c<co0000o`000002o`00
00;oc<c<1?l00003olc<c0Go00000oo<c<`2o`0000Coc<c<0_l000000oo<c<co0000o`000002o`00
0003olc<c?l0003o000000?o00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`00
00?oc<c<1?l00004olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<1?l00002olc<
c0Co00000oo<c<`3o`0000?oc<c<0ol000000oo<c<co0000o`000003olc<c0;o00001_o<c<`2o`00
00Coc<c<0_l00002olc<c0Co00000_o<c<`5o`0000[oc<c<0_l0000]olc<c07ooooo000nolc<c0;o
00000oo<c<`2o`0000koc<c<0_l0000=olc<c0;o00000oo<c<`2o`0000Soc<c<0_l0000^olc<c0;o
00000oo<c<`2o`0000coc<c<0_l0000Lolc<c0;o00000_o<c<`2o`0001Koc<c<1?l0000]olc<c07o
oooo000oolc<c0Go00003oo<c<`2o`0000goc<c<0_l00003olc<c0So00000_o<c<`2o`0002koc<c<
0_l00003olc<c0;o000000?oc<c<o`000?l000002Oo<c<`2o`0001goc<c<1?l0000Iolc<c0;o0000
;Oo<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1oooo
o`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`P
olc<c07ooooo003oolc<c23oc<c<0Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({1, 1, 1, 6, 1, 1, 1, 6, 1, 1}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(2.`\)"\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[_]\)\)[__]\)}\) is not present in \
expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No duplication performed."\
\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[nop]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \!\(AntTracker[\(\(seq[\(\
\(turnRight, again\)\)]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[_]\)\)[__]\)}\) is not present in \
expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No shrink performed."\)], \
"Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(2\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 0 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.73232 .00576 0 -8.88217 ]
[.73232 .00576 10.625 5.11783 ]
[.87052 .16524 0 -8.54656 ]
[.87052 .16524 10.625 5.45344 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.71869 .00942 m
.71188 .01126 L
s
gsave
.73232 .00576 -61 -12.8822 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.85674 .16829 m
.84985 .16981 L
s
gsave
.87052 .16524 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.16815 .24691 m
.13455 .92146 L
s
.26233 .29961 m
.23906 .93186 L
s
.34519 .34598 m
.33001 .94091 L
s
.41866 .3871 m
.40989 .94886 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.32346 .30014 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.37437 .28909 m .57042 .37159 L .52233 .38044 L .5 0 1 r
F
.32346 .30014 m .37437 .28909 L .52233 .38044 L 1 0 0 r
F
.42676 .27772 m .61975 .36251 L .57042 .37159 L 0 1 1 r
F
.37437 .28909 m .42676 .27772 L .57042 .37159 L .5 0 1 r
F
.48069 .26602 m .67039 .35318 L .61975 .36251 L 0 1 1 r
F
.42676 .27772 m .48069 .26602 L .61975 .36251 L F
.53623 .25397 m .72237 .34361 L .67039 .35318 L F
.48069 .26602 m .53623 .25397 L .67039 .35318 L F
.59346 .24155 m .77575 .33379 L .72237 .34361 L .5 1 0 r
F
.53623 .25397 m .59346 .24155 L .72237 .34361 L 0 1 1 r
F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .30596 .91258 L p 1 0 0 r
F P
0 0 0 r
s
.65246 .22875 m .8306 .32369 L .77575 .33379 L 1 0 0 r
F
.59346 .24155 m .65246 .22875 L .77575 .33379 L .5 1 0 r
F
.57295 .92839 m .52132 .93033 L .36084 .91012 L p .5 0 1 r
F P
0 0 0 r
s
.30596 .91258 m .36084 .91012 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.71331 .21554 m .88697 .31331 L .8306 .32369 L 1 0 0 r
F
.65246 .22875 m .71331 .21554 L .8306 .32369 L F
.62603 .92639 m .57295 .92839 L .42382 .47643 L p 0 1 1 r
F P
0 0 0 r
s
.36084 .91012 m .42382 .47643 L .57295 .92839 L p .5 0 1 r
F P
0 0 0 r
s
.83801 .51176 m .7817 .5195 L .65577 .43867 L p 1 0 0 r
F P
0 0 0 r
s
.7817 .5195 m .73675 .92223 L .59507 .44855 L p .5 1 0 r
F P
0 0 0 r
s
.59507 .44855 m .65577 .43867 L .7817 .5195 L p .5 1 0 r
F P
0 0 0 r
s
.77609 .20192 m .94492 .30264 L .88697 .31331 L 1 0 0 r
F
.71331 .21554 m .77609 .20192 L .88697 .31331 L F
.68061 .92434 m .62603 .92639 L .47918 .46742 L p 0 1 1 r
F P
0 0 0 r
s
.42382 .47643 m .47918 .46742 L .62603 .92639 L p 0 1 1 r
F P
0 0 0 r
s
.89593 .50379 m .83801 .51176 L .71843 .42847 L p 1 0 0 r
F P
0 0 0 r
s
.65577 .43867 m .71843 .42847 L .83801 .51176 L p 1 0 0 r
F P
0 0 0 r
s
.77609 .20192 m .84091 .18786 L .94492 .30264 L 1 0 0 r
F
.12592 .18455 m .37437 .28909 L .32346 .30014 L F
.73675 .92223 m .68061 .92434 L .53623 .45813 L p 0 1 1 r
F P
0 0 0 r
s
.47918 .46742 m .53623 .45813 L .68061 .92434 L p 0 1 1 r
F P
0 0 0 r
s
.95551 .49559 m .89593 .50379 L .78315 .41793 L p 1 0 0 r
F P
0 0 0 r
s
.71843 .42847 m .78315 .41793 L .89593 .50379 L p 1 0 0 r
F P
0 0 0 r
s
.18133 .16991 m .42676 .27772 L .37437 .28909 L 0 1 1 r
F
.12592 .18455 m .18133 .16991 L .37437 .28909 L 1 0 0 r
F
.53623 .45813 m .59507 .44855 L .73675 .92223 L p 0 1 1 r
F P
0 0 0 r
s
.78315 .41793 m .85002 .40705 L .95551 .49559 L p 1 0 0 r
F P
0 0 0 r
s
.23859 .15478 m .48069 .26602 L .42676 .27772 L 1 0 0 r
F
.18133 .16991 m .23859 .15478 L .42676 .27772 L 0 1 1 r
F
.2978 .13914 m .53623 .25397 L .48069 .26602 L 1 0 0 r
F
.23859 .15478 m .2978 .13914 L .48069 .26602 L F
.47918 .46742 m .42382 .47643 L .22934 .3814 L p F P
0 0 0 r
s
.42382 .47643 m .36084 .91012 L .14671 .88315 L p 0 1 1 r
F P
0 0 0 r
s
.14671 .88315 m .22934 .3814 L .42382 .47643 L p 0 1 1 r
F P
0 0 0 r
s
.35907 .12295 m .59346 .24155 L .53623 .25397 L 1 0 0 r
F
.2978 .13914 m .35907 .12295 L .53623 .25397 L F
.53623 .45813 m .47918 .46742 L .29027 .36926 L p F P
0 0 0 r
s
.22934 .3814 m .29027 .36926 L .47918 .46742 L p 1 0 0 r
F P
0 0 0 r
s
.42251 .10619 m .65246 .22875 L .59346 .24155 L 1 0 0 r
F
.35907 .12295 m .42251 .10619 L .59346 .24155 L F
.36084 .91012 m .30596 .91258 L .08662 .88649 L p F P
0 0 0 r
s
.59507 .44855 m .53623 .45813 L .35338 .35667 L p 1 0 0 r
F P
0 0 0 r
s
.29027 .36926 m .35338 .35667 L .53623 .45813 L p 1 0 0 r
F P
0 0 0 r
s
.48823 .08883 m .71331 .21554 L .65246 .22875 L 1 0 0 r
F
.42251 .10619 m .48823 .08883 L .65246 .22875 L F
.08662 .88649 m .14671 .88315 L .36084 .91012 L p F P
0 0 0 r
s
.65577 .43867 m .59507 .44855 L .41879 .34363 L p 1 0 0 r
F P
0 0 0 r
s
.35338 .35667 m .41879 .34363 L .59507 .44855 L p 1 0 0 r
F P
0 0 0 r
s
.55636 .07083 m .77609 .20192 L .71331 .21554 L 1 0 0 r
F
.48823 .08883 m .55636 .07083 L .71331 .21554 L F
.71843 .42847 m .65577 .43867 L .48663 .3301 L p F P
0 0 0 r
s
.41879 .34363 m .48663 .3301 L .65577 .43867 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .84091 .18786 L .77609 .20192 L 1 0 0 r
F
.55636 .07083 m .62703 .05216 L .77609 .20192 L F
.78315 .41793 m .71843 .42847 L .55704 .31606 L p F P
0 0 0 r
s
.48663 .3301 m .55704 .31606 L .71843 .42847 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .70039 .03278 L .84091 .18786 L 1 0 0 r
F
.85002 .40705 m .78315 .41793 L .63017 .30148 L p F P
0 0 0 r
s
.55704 .31606 m .63017 .30148 L .78315 .41793 L p 1 0 0 r
F P
0 0 0 r
s
.63017 .30148 m .70619 .28632 L .85002 .40705 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00001Golc<c003o`000?o<
c<coc<c<04Ooc<c<0Oooool006Soc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<o`00
0003olc<c0;o000000Goc<c<o`000?o<c<coc<c<o`000003olc<c003o`000?o<c<coc<c<05Coc<c<
00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`01?l0003oc<c<o`000?o<c<`2o`0000?oc<c<
0ol000001?o<c<co0000olc<c?l00002olc<c005o`000?o<c<coc<c<olc<c?l00000BOo<c<`3o`00
00[oc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00
J?o<c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<co000001coc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01coc<c<1?l000000oo<c<co0000
olc<c003olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00UOo<
c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<01Soc<c<1?l00005olc<c003o`000?o<
c<coc<c<00;oc<c<0_l00008olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Goc<c<00?o0000
olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c00Eolc<c0Co00003oo<c<`00ol0003oc<c<olc<c003
olc<c0?o0000BOo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c004olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Koc<c<00?o0000olc<c?o<
c<`01?o<c<`5o`00013oc<c<1?l0000Iolc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<
c<`0Aoo<c<`1ooooo`00Uoo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00ooc<c<
0ol00002olc<c003o`000?o<c<coc<c<01Woc<c<00?o0000olc<c?o<c<`0C?o<c<`1ooooo`00V?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00[oc<c<1?l0000Rolc<c003o`000?o<
c<coc<c<04_oc<c<0Oooool009?oc<c<1_l00005olc<c0Go00001?o<c<`4o`000003olc<c?l0003o
c<c<01Soc<c<0_oo0009olc<c003o`000?o<c<coc<c<04_oc<c<0Oooool00:Coc<c<0ol00005olc<
c003o`000?o<c<coc<c<01Coc<c<1_oo0009olc<c003o`000?o<c<coc<c<04[oc<c<0Oooool007?o
c<c<1?l0000Yolc<c0Go00006_o<c<`;ool000Woc<c<00?o0000olc<c?o<c<`0BOo<c<`1ooooo`00
L_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<02;oc<c<1?l00004olc<c003o`00
0?o<c<coc<c<01Goc<c<3ooo0009olc<c003o`000?o<c<coc<c<04Soc<c<0Oooool007Ooc<c<00?o
0000olc<c?o<c<`07oo<c<`3o`0001goc<c<4ooo0009olc<c003o`000?o<c<coc<c<04Ooc<c<0Ooo
ool007Ooc<c<00?o0000olc<c?o<c<`06oo<c<`4o`0000;oc<c<00?o0000olc<c?o<c<`05oo<c<`H
ool000Woc<c<00?o0000olc<c?o<c<`0A_o<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01Ooc<c<1?l00006olc<c003o`000?o<c<coc<c<01?oc<c<7Ooo0009olc<
c003o`000?o<c<coc<c<04Goc<c<0Oooool007;oc<c<1Ol0000Golc<c0?o00000_o<c<`00ol0003o
c<c<olc<c00Folc<c2?oo`002?o<c<`00ol0003oc<c<olc<c015olc<c07ooooo001bolc<c003o`00
0?o<c<coc<c<01Goc<c<1?l0000Jolc<c2Soo`002?o<c<`00ol0003oc<c<olc<c014olc<c07ooooo
001colc<c003o`000?o<c<coc<c<013oc<c<1?l000000oo<c<co0000olc<c00Golc<c2coo`002Oo<
c<`00ol0003oc<c<olc<c013olc<c07ooooo001colc<c0Go00002oo<c<`3o`0001[oc<c<<Ooo0009
olc<c003o`000?o<c<coc<c<04;oc<c<0Oooool007ooc<c<1?l000000oo<c<co0000olc<c00Folc<
c3Koo`002Oo<c<`00ol0003oc<c<olc<c011olc<c07ooooo0019olc<c0Ko00000_o<c<`00ol0003o
c<c<olc<c004o`0002?oc<c<1?l0000Iolc<c3_oo`002Oo<c<`00ol0003oc<c<olc<c010olc<c07o
oooo0019olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c00Molc<c0?o000000?oc<c<o`000?o<c<`05_o<c<a0ool000Woc<c<00?o0000olc<c?o<c<`0
?oo<c<`1ooooo`00B_o<c<`00ol0003oc<c<olc<c00;olc<c003o`000?o<c<coc<c<01Woc<c<1?l0
0004olc<c003o`000?o<c<coc<c<017oc<c<AOoo0009olc<c003o`000?o<c<coc<c<03koc<c<0Ooo
ool004_oc<c<0_l0000;olc<c003o`000?o<c<coc<c<01Koc<c<0ol000000oo<c<co0000olc<c00E
olc<c4[oo`002?o<c<`00ol0003oc<c<olc<c00nolc<c07ooooo001=olc<c003o`000?o<c<coc<c<
00?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001?o<c<`00ol0
003oc<c<olc<c00@olc<c4ooo`002?o<c<`00ol0003oc<c<olc<c00molc<c07ooooo001>olc<c003
o`000?o<c<coc<c<00;oc<c<1Ol0000Aolc<c0Go00005_o<c<aDool000Soc<c<00?o0000olc<c?o<
c<`0??o<c<`1ooooo`00BOo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00;oc<c<
00?o0000olc<c?o<c<`04?o<c<`3o`0000Coc<c<00?o0000olc<c?o<c<`04?o<c<aIool000Soc<c<
00?o0000olc<c?o<c<`0>oo<c<`1ooooo`00BOo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<
c<coc<c<00?oc<c<00?o0000olc<c?o<c<`02oo<c<`5o`0001Koc<c<G?oo0009olc<c003o`000?o<
c<coc<c<03[oc<c<0Oooool004[oc<c<1?l00006olc<c0Go00001Oo<c<`4o`0000Coc<c<00?o0000
olc<c?o<c<`04?o<c<aQool000Woc<c<00?o0000olc<c?o<c<`0>Oo<c<`1ooooo`00;oo<c<`4o`00
02Soc<c<0ol000000oo<c<co0000olc<c00Dolc<c6Koo`002Oo<c<`00ol0003oc<c<olc<c00holc<
c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`08Oo<c<`4o`0001Ko
c<c<Jooo0009olc<c003o`000?o<c<coc<c<03Ooc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Molc<c0Co000000?oc<c<o`000?o<c<`05?o<c<a_ool000Soc<c<
00?o0000olc<c?o<c<`07_o<c<`4o`000004olc<c?l0003oc<c<olc<c0Co00000_o<c<`01ol0003o
c<c<olc<c?o<c<co0000olc<c?l000001?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01[oc<c<0ol0000Golc<c7Coo`002?o<c<`00ol0003oc<c<olc<c00Lolc<
c003o`000?o<c<coc<c<00;oc<c<0_l000000oo<c<co0000olc<c003olc<c003o`000?o<c<co0000
00?oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<01Koc<c<1?l000000oo<c<co0000olc<c00Colc<c7Woo`002?o<c<`00ol0003o
c<c<olc<c00Jolc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?l000001_o<c<`01Ol0003o
c<c<olc<c?o<c<co000000Koc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003o
c<c<olc<c00Bolc<c0Co00001Oo<c<`00ol0003oc<c<olc<c00?olc<c7goo`002?o<c<`00ol0003o
c<c<olc<c00Iolc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?l000001Ol000000oo<c<co
0000olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00?olc<c0?o00000_o<c<`00ol0003oc<c<olc<c00Bolc<c8;oo`00
2?o<c<`00ol0003oc<c<olc<c006olc<c0Ko00003?o<c<`01?l0003oc<c<olc<c?o<c<`4o`000003
olc<c?l0003oc<c<00?oc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c004olc<c07o
oooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`02oo<c<`4o`0001Ooc<c<
QOoo0009olc<c003o`000?o<c<coc<c<00Goc<c<00?o0000olc<c?o<c<`03oo<c<`00ol0003oc<c<
olc<c006olc<c003o`000?o<c<coc<c<00;oc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003o
c<c<olc<c004olc<c07ooooo000_olc<c0Co00002_o<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`0
4Oo<c<`4o`3oohKoo`002Oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00koc<c<
00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0000;oc<c<00Co0000olc<c?l0003o
00001oo<c<`1ooooo`00>_o<c<`4o`0001Ooc<c<2?l0oon6ool000Soc<c<00?o0000olc<c?o<c<`0
1_o<c<`2o`0000ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c07ooooo
000folc<c0Co00000oo<c<`00ol0003oc<c<olc<c00Bolc<c0go0?ooQOoo0008olc<c0;o00002?o<
c<`00ol0003oc<c<olc<c00=olc<c0Co00005Oo<c<`1ooooo`00<_o<c<`4o`000003olc<c?l0003o
c<c<01Koc<c<4Ol0oon5ool000Koc<c<00?o0000olc<c?l000002Oo<c<`00ol0003oc<c<olc<c00U
olc<c07ooooo000_olc<c0?o00006Oo<c<`4ool001?o0?ooQ?oo0008olc<c005o`000?o<c<coc<c<
olc<c?l000001?o<c<`00ol0003oc<c<olc<c00Uolc<c07ooooo000]olc<c0;o000000?oc<c<o`00
0?o<c<`05?o<c<`:ool001Co0?ooPooo0008olc<c004o`000?o<c<coc<c<o`0000Coc<c<00?o0000
olc<c?o<c<`09Oo<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?l0000Aolc<c13oo`004ol0oon3
ool000Soc<c<00?o0000olc<c?o<c<`01?l0000Xolc<c07ooooo000]olc<c004o`000?o<c<coc<c<
ofIVIQ7oc<c<4_oo000Co`3ooh;oo`002?o<c<`00ol0003oc<c<olc<c00[olc<c07ooooo000]olc<
c0;o000000?oc<c<ofIVI_o<c<`04_o<c<`Aool001?o0?ooPOoo0009olc<c003o`000?o<c<coc<c<
02[oc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`Bool001?o0?ooP?oo0008olc<
c003o`000?o<c<coc<c<02[oc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV5_o<c<`Bool0
01;o0?ooP?oo0008olc<c003o`000?o<c<coc<c<02Woc<c<0Oooool002goc<c<00Co0000olc<c?o<
c<coIVIV6?o<c<`Aool001?o0?ooOooo0008olc<c003o`000?o<c<coc<c<02Soc<c<0Oooool002go
c<c<00Co0000olc<c?o<c<coIVIV6_o<c<`Aool001;o0?ooOooo0008olc<c003o`000?o<c<coc<c<
02Ooc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`Bool001;o0?ooO_oo0008olc<
c003o`000?o<c<coc<c<02Koc<c<0Oooool002coc<c<00Go0000olc<c?o<c<coc<c<ofIVIP0Molc<
c17oo`004ol0oommool000Soc<c<00?o0000olc<c?o<c<`09Oo<c<`1ooooo`00;?o<c<`01?l0003o
c<c<olc<c?mVIVHPolc<c17oo`004_l0oommool000Soc<c<00?o0000olc<c?o<c<`09?o<c<`1oooo
o`00;?o<c<`01?l0003oc<c<olc<c?mVIVHRolc<c17oo`004_l0oomlool000Soc<c<00?o0000olc<
c?o<c<`08oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHSolc<c17oo`004_l0oomlool0
00Ooc<c<00?o0000olc<c?o<c<`08oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHUolc<
c17oo`004_l0oom3ool000CoOol0=?oo0007olc<c003o`000?o<c<coc<c<02;oc<c<0Oooool002co
c<c<0_l000000oo<c<coIVIVolc<c00Volc<c13oo`004_l0oolmool000[oOol0=?oo0007olc<c003
o`000?o<c<coc<c<027oc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV:Oo<c<`@ool001;o
0?oo=_oo000@ogoo03Coo`001oo<c<`00ol0003oc<c<olc<c00Polc<c07ooooo000/olc<c004o`00
0?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`03Oo<c<`Aool0017o0?oo<?oo0005o`3ooa7o
Ool0=?oo0007olc<c003o`000?o<c<coc<c<01ooc<c<0Oooool002coc<c<00Co0000olc<c?o<c<co
IVIV6_o<c<`00omVIVKoc<c<olc<c00?olc<c13oo`004_l0oolWool000go0?oo4Omoo`0cool000So
c<c<00?o0000olc<c?o<c<`07_o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003
ofIVI_o<c<coc<c<017oc<c<4?oo000Ao`3oob3oo`005?l0oolBogoo03;oo`002?o<c<`00ol0003o
c<c<olc<c00Molc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<
c<`04_o<c<`Aool0017o0?oo6Ooo000Jo`3ooa;oOol0<_oo0007olc<c003o`000?o<c<coc<c<01go
c<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Dolc<c13o
o`004_l0oolCool0023o0?oo4Omoo`0bool000Ooc<c<00?o0000olc<c?o<c<`07?o<c<`1ooooo`00
;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Koc<c<4?oo000Ao`3oo`ko
o`009Ol0oolAogoo03;oo`001oo<c<`00ol0003oc<c<olc<c008olc<c0Co00003oo<c<`1ooooo`00
;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Soc<c<4?oo000Ao`3oo`Oo
o`00:ol0oolAogoo03;oo`001oo<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<00;o
c<c<00?o0000olc<c?o<c<`03?o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003
ofIVI_o<c<coc<c<01Woc<c<4?oo000Ao`3oo`;oo`00<?l0oolBogoo037oo`001oo<c<`00ol0003o
c<c<olc<c005olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03?o<c<`1ooooo`00
;?o<c<`2o`000003olc<c?mVIVKoc<c<01Woc<c<00?oIVIVolc<c?o<c<`06oo<c<`@ool000go0?oo
1?mo0?lbo`3ooa7oOol0<Ooo0007olc<c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<c?o<c<`0
3?o<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01goc<c<
4?oo0007o`3oo`WoO`3o<_l0ool;ogoo00Co00000_moo`0aool000Koc<c<0_l00007olc<c0?o0000
3oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01ooc<c<
3ooo0002o`3oo`ooO`3o<Ol0ool5ogoo00Go00001?oo00000ol0003oOol0ogoo000aool000Ooc<c<
00?o0000olc<c?o<c<`01oo<c<`00ol0003oc<c<olc<c00<olc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`08Oo<c<`@ool0013oO`3o<Ol0ool4o`0000[oo`00
00Co0000ogoo0?moo`3oOol0<?oo0003olc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c00<olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQ[o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00<olc<c13oo`004?mo0?lZo`3oo`Go
00003ooo00001?l0003oOol0ogoo0?moo`0`ool000;oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0
003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00coc<c<0Oooool002_oc<c<00Co0000olc<c?o<
c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<00koc<c<3ooo000Aogl0
ob?o0?oo1Ol0000Eool00004o`000?moo`3oOol0ogoo033oo`0000?oc<c<ofIVI_o<c<`01oo<c<`4
o`0000ooc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00D
olc<c003ofIVI_o<c<coc<c<00ooc<c<4?oo000@ogl0oaco0?oo1_l0000Kool00004o`000?moo`3o
Ool0ogoo02goo`000oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`000?o<c<co
c<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Aolc<c13oo`004?mo
0?lEo`3oo`Go00003?oo00000ol0003oo`00ool0000Cool000;o00000_moo`0Wool000Soc<c<00?o
IVIVolc<c?o<c<`06Oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<
c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`04oo<c<`?ool0013oO`3o3ol0ool5o`0001;oo`000_l0
000Eool00004o`000?moo`3oOol0ogoo023oo`003Oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo
000[olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<
olc<c00Dolc<c13oo`004?mo0?l9o`3oo`Co00006Ooo00000ol0003oo`00ool0000Cool00004o`00
0?moo`3oOol0ogoo01[oo`004_o<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c0;oIVIV
00?o0000ofIVI_o<c<`06Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Koc<c<
4?oo000?ogl0o`?o0?oo1Ol00009ool00003o`000?oo003oo`0001;oo`000_l0000Dool00004o`00
0?moo`3oOol0ogoo01;oo`006Oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000Polc<c0Co0000
1oo<c<`01?l0003oc<c<ofIVI_mVIVHJolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<
c<`06?o<c<`?ool000goO`3o1?l0000@ool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo
00004_oo00001?l0003oOol0ogoo0?moo`0;ool001ooc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1oooo
o`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<
c<`00omVIVHHolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`06Oo<c<`@ool000Ko
O`3o1Ol0000Eool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00004_oo00001?l0003o
Ool0ogoo0?moo`03ool000Coc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Iolc<
c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003o
c<c<olc<c?mVIVH2olc<c0;oIVIV5_o<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<
01_oc<c<3ooo0005o`0001_oo`000_l0000Cool000;o00004ooo0002o`0000Soc<c<00?oIVIVolc<
c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;o
c<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH4olc<c0?oIVIV4oo<c<`00omV
IVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01goc<c<2?oo0005o`0000_oo`000_l0000Eool0
0003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00004_oo00000ol0003oc<c<olc<c005olc<
c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV1oo<c<`2ofIV
IQ7oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<
00[oc<c<0_oo0005o`0001;oo`000_l0000Dool000;o00004ooo00000ol0003oo`00ool0000Bool0
0003o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`01Ol0003o
c<c<olc<c?o<c<coIVIV00Woc<c<0_mVIVH?olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<
c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c007olc<c0Go00006Ooo00000ol0003oo`00ool0000Cool0
0003o`000?oo003oo`00017oo`000_l0000Cool00003o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<
c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;o
c<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?mVIVH<olc<c0;oIVIV3Oo<c<`00omV
IVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`00_o<c<`5o`00
00_oo`0000?o0000ool00?oo00004Ooo0002o`0001Coo`0000?o0000ool00?oo00004_oo00000ol0
003oo`00ool0000Aool00003o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omV
IVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<
c<`00oo<c<`01?l0003oc<c<olc<c?mVIVH>olc<c0;oIVIV2oo<c<`00omVIVKoc<c<olc<c00Dolc<
c003ofIVI_o<c<coc<c<017oc<c<1Ol0000Aool000;o00004ooo00000ol0003oo`00ool0000Bool0
00;o00004ooo0002o`0001;oo`000_l00002olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<
c?o<c<`06?o<c<`1ooooo`008?o<c<`4o`0000Koc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`2ofIV
IPWoc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00<olc<c0Go00006?oo0002o`00
01;oo`000_l0000Dool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00004Ooo00000ol0
003oc<c<ofIVIP0Rolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<0_l000000oo<c<co
IVIVolc<c00Aolc<c0;oIVIV1oo<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<00So
c<c<1Ol0000;ool00003o`000?oo003oo`00017oo`0000?o0000ool00?oo00004Ooo0002o`0001?o
o`000_l0000Cool00003o`000?oo003oo`00017oo`0000?o0000ofIVI_o<c<`08Oo<c<`00omVIVKo
c<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQCoc<c<0_mVIVH5olc<c003
ofIVI_o<c<coc<c<01?oc<c<00?oIVIVolc<c?o<c<`00oo<c<`5o`00017oo`000_l0000Bool000;o
00004ooo00000ol0003oo`00ool0000Bool00003o`000?oo003oo`00017oo`000_l0000Bool00003
o`000?o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<
olc<c?mVIVHFolc<c0;oIVIV0oo<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_l0003o000000?o
00006?oo0002o`0001;oo`000_l0000Bool000;o00004ooo00000ol0003oo`00ool0000Bool00003
o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Holc<c07o
oooo000Zolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<0omVIVHBolc<c0Go00002ooo00000ol0003o
o`00ool0000Aool000;o00004_oo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`00017o
o`000_l0000Cool00003o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`07_o<c<`00omVIVKo
c<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<0omVIVH=olc<c0?o
00004_oo0002o`0001;oo`000_l0000Aool000;o00004_oo0002o`0001?oo`0000?o0000ool00?oo
00004Ooo0002o`00017oo`000_l0000Nolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<
00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c002ofIVIP_oc<c<00?o0000o`3ooooo
00005?oo0002o`0001;oo`0000?o0000ool00?oo00004?oo0002o`0001;oo`000_l0000Bool000;o
00004ooo00000ol0003oo`00ool0000@ool00003o`000?o<c<coc<c<01_oc<c<00?oIVIVolc<c?o<
c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00;o
c<c<0_mVIVH9olc<c005o`000?l0oooo0?ooo`3oool000005?oo0002o`00017oo`000_l0000Bool0
0003o`000?oo003oo`00017oo`0000?o0000ool00?oo00004Ooo00000ol0003oo`00ool0000Aool0
0003o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`06_o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`01?o<c<`2ofIV
IPOoc<c<00?o0000o`3oool0ool00ol0ool2o`0001?oo`0000?o0000ool00?oo00004?oo0002o`00
017oo`000_l0000Bool000;o00004_oo00000ol0003oo`00ool0000Aool000;o00004Ooo00000ol0
003oc<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<
c<coIVIV6_o<c<`00omVIVKoc<c<olc<c006olc<c0;oIVIV1?o<c<`00ol0003o0?ooo`3oo`06o`3o
o`;o00004_oo0002o`0001;oo`000_l0000Aool000;o00004_oo00000ol0003oo`00ool0000@ool0
00;o00004ooo00000ol0003oo`00ool0000?ool00003o`000?o<c<coc<c<01Soc<c<00?oIVIVolc<
c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<
00Soc<c<0_mVIVH2olc<c003o`000?l0oooo0?oo00So0?oo0ol0000Aool000;o00004_oo0002o`00
017oo`0000?o0000ool00?oo00004?oo0002o`0001;oo`0000?o0000ool00?oo00004Ooo0002o`00
013oo`0000?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004
o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`02_o<c<`2ofIVIP03o`000?l0oooo0?oo
00_o0?oo0_l0000Aool000;o00004_oo00000ol0003oo`00ool0000?ool000;o00004_oo0002o`00
017oo`000_l0000Cool00003o`000?oo003oo`0000[oo`001_l0000Golc<c003ofIVI_o<c<coc<c<
01Soc<c<0Oooool002[oc<c<0_l000000oo<c<coIVIVolc<c00Iolc<c003ofIVI_o<c<coc<c<00co
c<c<00?o0000o`3oool0ool03Ol0ool2o`00017oo`000_l0000Aool000;o00004Ooo0002o`0001;o
o`0000?o0000ool00?oo00004?oo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`0000;o
o`001ol00006ool00003o`000?o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00
:Oo<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01[oc<c<00?oIVIVolc<c?o<c<`03?o<c<`00ol0003o
0?ooo`3oo`0?o`3oo`;o00004Ooo0002o`00017oo`000_l0000Aool00003o`000?oo003oo`00013o
o`000_l0000Aool00003o`000?oo003oo`0000koo`001ol0000>ool00003o`000?o<c<coc<c<01Co
c<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003
ofIVI_o<c<coc<c<00coc<c<00?o0000o`3oool0ool04Ol0ool2o`00017oo`000_l0000Aool000;o
00004?oo0002o`0001;oo`0000?o0000ool00?oo00003ooo0002o`0000Woo`001Ol0000Fool00003
o`000?o<c<coc<c<01?oc<c<1?mVIVHFolc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ_o
c<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Do`3oo`;o00004Ooo0002o`00017o
o`000_l0000@ool000;o00004Ooo0002o`00017oo`0000Co0000ool00?oo003oo`001Ol0000;ool0
0003o`000?oo003oo`0000koo`0000?o0000olc<c?o<c<`02oo<c<`8ofIVIQWoc<c<0Oooool002Wo
c<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo0?oo
01Ko0?oo0_l0000Aool000;o00004Ooo00000ol0003oo`00ool0000?ool00003o`000?oo003oo`00
013oo`000_l0000<ool000Oo00004Ooo00000ol0003oo`00ool0000>ool000;o00001Oo<c<`6ofIV
IPOoc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<
c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool06?l0ool2o`00017oo`000_l0000@ool0
00;o00004?oo0002o`0001;oo`0000?o0000ool00?oo00000_oo0007o`0001Woo`000_l0000@ool0
0003o`000?mVIVKoIVIV00;oIVIV3Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004
o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Jo`3o
o`;o00004Ooo0002o`00013oo`000_l0000@ool000;o00003ooo0006o`0000koo`000_l0000Bool0
0003o`000?oo003oo`0000koo`0000?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Golc<
c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0
003o0?ooo`3oo`0Lo`3oo`;o00004Ooo00000ol0003oo`00ool0000?ool000;o00004?oo00000ol0
003oo`00ool00007ool000Go00001?moo`0Bool00003o`000?oo003oo`00013oo`0000?o0000ool0
0?oo00003_oo00000ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Wo
c<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo0?oo
01ko0?oo0_l0000@ool000;o00004Ooo0002o`0000ooo`000_l00002ool000Go00002_moo`02o`00
013oo`000_l0000Aool00003o`000?oo003oo`0000koo`0000?o0000olc<c?o<c<`03?o<c<`00omV
IVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<
c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Po`3oo`?o00003ooo0002o`00017oo`0000?o0000ool0
0?oo00002ooo0005o`00017oOol00_l0000@ool00003o`000?oo003oo`0000ooo`000_l0000?ool0
00;o00003?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIV
IQ_oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3oo`0To`3oo`;o00003ooo0002o`00
013oo`000_l00004ool000Oo00000ol0ool00ol0003oOol0ogoo000Bogoo0003o`000?oo003oo`00
00koo`0000?o0000ool00?oo00004?oo00000ol0003oo`00ool0000>ool00003o`000?o<c<coc<c<
00Woc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`2o`000003olc<c?mVIVKoc<c<01[o
c<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3oo`0Vo`3oo`;o00003ooo0002o`0000go
o`001ol0000:o`3oo`03o`000?moo`3oOol001?oOol00_l0000?ool000;o00004Ooo00000ol0003o
o`00ool0000>ool00003o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00
:Oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0
ool0:?l0ool2o`0000ooo`000_l00004ool000Oo00004_l0ool00ol0003oOol0ogoo000Dogoo0003
o`000?oo003oo`0000koo`0000?o0000ool00?oo00003ooo00000ol0003oo`00ool0000>ool00003
o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<
olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool0:_l0ool2o`0000co
o`001ol0000:o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005Omoo`02o`0000oo
o`000_l0000@ool00003o`000?oo003oo`0000koo`0000?o0000olc<c?o<c<`01_o<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<
c<`02oo<c<`00ol0003o0?ooo`3oo`0/o`3oo`;o00000ooo0007o`00023o0?oo00?o0000ogoo0?mo
o`005omoo`000ol0003oo`00ool0000>ool00003o`000?oo003oo`0000koo`000_l0000?ool00003
o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<
olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool0;_l0ool3o`0000[o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001Oo
Ool00_l0000?ool000;o00004?oo00000ol0003oo`00ool0000=ool000;o00001Oo<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<
c<`02_o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?l0oooo0?oo01Wo0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo000Iogoo00;o00003ooo00000ol0003oo`00ool0000>ool00003
o`000?oo003oo`0000koo`0000?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Golc<c07o
oooo000Xolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o
0?ooo`3oo`0_o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool06_l0ool00ol0003o
Ool0ogoo000Kogoo0003o`000?oo003oo`0000goo`000_l0000?ool00003o`000?oo003oo`0000ko
o`0000Go0000olc<c?o<c<coc<c<ofIVIP0Iolc<c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIV
IQ_oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
01_oOol00_l0000?ool00003o`000?oo003oo`0000goo`000_l0000?ool00004o`000?o<c<coc<c<
ofIVIQWoc<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00:
olc<c003o`000?l0oooo0?oo02ko0?oo00?o0000ogl0ool000006ol0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol001goOol000?o0000ool00?oo00003Ooo00000ol0003oo`00ool0000>
ool00003o`000?oo003oo`0000goo`0000?o0000olc<c?mVIVH06Oo<c<`1ooooo`00:?o<c<`01?l0
003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00[oc<c<00?o0000o`3oool0ool0;_l0ool0
0ol0003oO`3oogl0o`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003oOol0ogoo000Nogoo00;o00003_oo0002o`0000ooo`0000?o0000ool00?oo00002_oo0004
o`000003olc<c?mVIVKoc<c<01Ooc<c<0Oooool002Soc<c<0ol000000omVIVKoc<c<olc<c00Iolc<
c003ofIVI_o<c<coc<c<00[oc<c<00?o0000o`3oool0ool0;_l0ool00ol0003oO`3oogl0o`0=o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Pogoo
0003o`000?oo003oo`0000goo`0000?o0000ool00?oo00003Ooo00000ol0003oo`00ool00002ool0
00Oo00001Oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Lolc<c0Ko00001_o<c<`2ofIVIP03
olc<c?mVIVKoc<c<01[oc<c<00?oIVIVolc<c?o<c<`02Oo<c<`00ol0003o0?ooo`3oo`0_o`3oo`04
o`000?mo0?ooO`3oo`0000go0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol0023oOol00_l0000>ool000;o00002ooo0007o`0000coc<c<00?oIVIVolc<
c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coIVIV00;o
IVIV6_o<c<`00omVIVKoc<c<olc<c009olc<c003o`000?l0oooo0?oo02oo0?oo00Co0000ogl0oomo
0?ooO`3o3Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo
0?moo`008_moo`02o`0000koo`0000Co0000ool00?oo003oo`001ol0000Colc<c003ofIVI_o<c<co
c<c<01Koc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`02?o<c<`01Ol0003oc<c<olc<c?mVIVKo
c<c<00?oIVIV5oo<c<`00omVIVKoc<c<olc<c009olc<c003o`000?l0oooo0?oo02oo0?oo00Go0000
ogl0oomo0?ooO`3oo`00000<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0
ool00ol0003oOol0ogoo000Togoo0003o`000?oo003oo`0000Goo`002_l0000Jolc<c003ofIVI_o<
c<coc<c<01Koc<c<0Oooool001koc<c<0_l00008olc<c004o`000?o<c<coc<c<ofIVIPCoc<c<0omV
IVHDolc<c003ofIVI_o<c<coc<c<00Woc<c<00?o0000o`3oool0ool0;ol0ool01Ol0003oO`3oogl0
oomo0?oo000000go0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol002CoOol01ol000000oo<c<coIVIVolc<c00Qolc<c003ofIVI_o<c<coc<c<01Koc<c<
0Oooool0023oc<c<00?o0000olc<c?o<c<`01Oo<c<`01?l0003oc<c<olc<c?mVIVH7olc<c0?oIVIV
4Oo<c<`00omVIVKoc<c<olc<c009olc<c003o`000?l0oooo0?oo02ko0?oo00?o0000ogl0oomo0?l0
0omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo000Togoo0003o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`0
8?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Qolc<c003o`000?o<c<coc<c<00Coc<c<00Co
0000olc<c?o<c<coIVIV2_o<c<`3ofIVIPkoc<c<00?oIVIVolc<c?o<c<`02Oo<c<`00ol0003o0?oo
o`3oo`0^o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`009?moo`000ol0003oc<c<
olc<c005olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<
c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV
3Oo<c<`3ofIVIP_oc<c<00?oIVIVolc<c?o<c<`02?o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`00
0?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`008omoo`000ol0003oc<c<olc<c005olc<c003ofIV
I_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<
c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`2ofIVIPWoc<c<
00?oIVIVolc<c?o<c<`02?o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o00CoO`3o
00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`008omoo`000ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<023oc<c<
00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<
c<coc<c<00;o00000_o<c<`00ol0003oc<c<olc<c00:olc<c0Co00001oo<c<`01?l0003oc<c<olc<
c?mVIVHBolc<c0?oIVIV1_o<c<`00omVIVKoc<c<olc<c008olc<c003o`000?l0oooo0?oo02oo0?oo
00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Sogoo0003o`000?o<c<coc<c<00Goc<c<
00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<
c<coc<c<00?oc<c<00Co0000olc<c?o<c<co00006oo<c<`01?l0003oc<c<olc<c?mVIVHEolc<c0?o
IVIV0oo<c<`00omVIVKoc<c<olc<c008olc<c003o`000?l0oooo0?oo02oo0?oo00?o0000ogl0oomo
0?l01?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo000Qogoo0003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<
c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<
00Co0000olc<c?o<c<co00006_o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01Soc<c<0omVIVH;olc<
c003o`000?l0oooo0?oo02oo0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0:o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Qogoo
0003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<
c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co00006_o<c<`2o`00
0003olc<c?mVIVKoc<c<01[oc<c<1?mVIVH8olc<c003o`000?l0oooo0?oo02ko0?oo00?o0000ogl0
oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003oOol0ogoo000Qogoo0003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<
c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c0Oo00000_o<c<`00ol0003o
c<c<olc<c00Holc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00CoIVIVolc<c?o<c<coc<c<0omVIVH5
olc<c003o`000?l0oooo0?oo02ko0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Q
ogoo0003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00F
olc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co00006_o<c<`0
1?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Coc<c<0_mVIVH2olc<c003o`000?l0
oooo0?oo02oo0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Pogoo0003o`000?o<
c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003
olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?l000000_l0000Iolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`2ofIVIP03o`000?l0oooo0?oo02oo0?oo00?o
0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Pogoo0003o`000?o<c<coc<c<00Koc<c<00?o
IVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<co
c<c<00Koc<c<00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<
c<coc<c<00Soc<c<00?o0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
o`3oOol0023oOol000?o0000olc<c?o<c<`01_o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<
c<coc<c<01Koc<c<0Oooool000?oc<c<1ol00002olc<c003o`000?o<c<coc<c<01Soc<c<00Co0000
olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c008olc<c003o`000?l0oooo0?oo02oo0?oo00?o
0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Oogoo0003o`000?o<c<coc<c<00Koc<c<00?o
IVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Wolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02?o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo
0?ooO`3o00SoO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000ogoo0?moo`007omoo`000ol0003oc<c<olc<c006olc<c003ofIVI_o<
c<coc<c<023oc<c<1OmVIVHDolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`02?o<c<`00ol0003o0?ooo`3oo`0^o`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o
0000ogoo0?moo`007_moo`000ol0003oc<c<olc<c008olc<c003ofIVI_o<c<coc<c<01Ooc<c<2?mV
IVH00oo<c<coIVIVolc<c00Folc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`007Omoo`000ol0003oc<c<olc<c008olc<c003ofIVI_o<c<coc<c<00koc<c<2OmV
IVH9olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<
c<`00omVIVKoc<c<olc<c007olc<c003o`000?l0oooo0?oo02oo0?oo00?o0000ogl0oomo0?l02_mo
0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo000Mogoo0003o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`01_o<
c<`8ofIVIQ;oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mV
IVHKolc<c003ofIVI_o<c<coc<c<00Ooc<c<00?o0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0
o`0:ogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?moo`3oOol001goOol000?o0000olc<c?o<c<`02?o<c<`9ofIVIQ[oc<c<00?o
IVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`2o`000003olc<c?mVIVKoc<c<01[oc<c<00?oIVIV
olc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o00_oO`3o00?o0000
o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`007Omoo`001?l0003oc<c<olc<c?o<c<`8ofIVIR;oc<c<00?oIVIVolc<c?o<c<`05Oo<
c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Ooc<c<00?o
0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00[o0?oo00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001coOol000Co
0000ofIVI_mVIVKoIVIV1oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Goc<c<
0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c007olc<c003o`00
0?l0oooo0?oo02oo0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Logoo0003o`00
0?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo
000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?oo
o`3oo`0_o`3oo`03o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`007?moo`000ol0003oc<c<
olc<c008olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<
c<`01Ol0003oc<c<olc<c?o<c<coIVIV01_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?oo
o`3oo`0_o`3oo`03o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006omoo`000ol0003oc<c<
olc<c008olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<
c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0ool0
;ol0ool00ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001_oOol000?o0000olc<c?o<c<`0
2?o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co
0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo02oo0?oo
00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Jogoo0003o`000?o<c<coc<c<00Woc<c<
00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<
c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`00
0?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006Omoo`000ol0003oc<c<olc<c009olc<c003ofIV
I_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<
c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Ooc<c<00?o0000o`3oool0ool0;ol0ool00ol0003oO`3o
ogl0o`0>ogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?moo`3oOol001WoOol000?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<
olc<c00Polc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV
6oo<c<`00omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo033o0?oo00?o0000ogl0oomo0?l0
3omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
2ol0ool00ol0003oOol0ogoo000Iogoo0003o`000?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`0
8?o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<
00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o013oO`3o
00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`006?moo`000ol0003oc<c<olc<c009olc<c003ofIVI_o<c<coc<c<023oc<c<
00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`2o`000003olc<c?mVIVKoc<c<01[oc<c<00?o
IVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o
0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`006?moo`000ol0003oc<c<olc<c009olc<c003ofIVI_o<c<coc<c<023oc<c<00?o
IVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<
c<coc<c<00Koc<c<00?o0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0o`0Aogl0o`03o`000?l0
oooo0?oo00[o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
o`3oOol001SoOol000?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<
c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c006olc<c003o`000?l0oooo0?oo02oo0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3o
o`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo
000Hogoo0003o`000?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<
c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01_o<
c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool02_l0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005omo
o`000ol0003oc<c<olc<c009olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`05?o<
c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o
0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00[o0?oo00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001OoOol000?o
0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01Coc<c<0Ooo
ool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c005olc<c003o`000?l0
oooo0?oo033o0?oo00?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Fogoo0003o`000?o<
c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000V
olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003o0?ooo`3o
o`0_o`3oo`03o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005Omoo`000ol0003oc<c<olc<
c00:olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`0
1?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool0;ol0
ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001GoOol000?o0000olc<c?o<c<`02_o<
c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000
olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c005olc<c003o`000?l0oooo0?oo02oo0?oo00?o
0000ogl0oomo0?l05?mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?o<c<coc<c<00[oc<c<00?o
IVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<c004o`000?o<c<co
c<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo
0?ooO`3o01CoO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`000ol0003oc<c<olc<c00;olc<c003ofIVI_o<
c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mV
IVHLolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0
o`0Eogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?moo`3oOol001CoOol000?o0000olc<c?o<c<`02oo<c<`00omVIVKoc<c<olc<
c00Polc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`01Oo<c<`4
ofIVIQcoc<c<00?oIVIVolc<c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`0`o`3oo`03o`000?mo0?oo
O`3o01GoO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`005?moo`000ol0003oc<c<olc<c00;olc<c003ofIVI_o<c<co
c<c<023oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<
c003o`000?o<c<coc<c<00CoIVIV6Oo<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo
02oo0?oo00?o0000ogl0oomo0?l05_mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Dogoo0003o`000?o<c<coc<c<
00_oc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Iolc<c0Ko
00001_o<c<`01?l0003oc<c<olc<c?mVIVH3olc<c0CoIVIV5Oo<c<`00omVIVKoc<c<olc<c004olc<
c003o`000?l0oooo0?oo02oo0?oo00?o0000ogl0oomo0?l05omo0?l00ol0003o0?ooo`3oo`0:o`3o
o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Cogoo
0003o`000?o<c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Dolc<
c07ooooo000Iolc<c005o`000?o<c<coc<c<olc<c?l000001oo<c<`01?l0003oc<c<olc<c?mVIVH7
olc<c0GoIVIV4?o<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo02oo0?oo00?o0000
ogl0oomo0?l05omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003oOol0ogoo000Bogoo0003o`000?o<c<coc<c<00coc<c<00?oIVIV
olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Jolc<c004o`000?o<c<coc<c<
o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV3?o<c<`4ofIVIPcoc<c<00?oIVIVolc<c?o<c<`01?o<
c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o01OoO`3o00?o0000o`3oool0ool02_l0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004_mo
o`000ol0003oc<c<olc<c00<olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05?o<
c<`1ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c004o`000?o<c<coc<c<ofIVIQ3oc<c<1?mV
IVH8olc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0
o`0Hogl0o`03o`000?l0oooo0?oo00Wo0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol0017oOol000?o0000olc<c?o<c<`03?o<c<`00omVIVKoc<c<olc<
c00Polc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001_oc<c<00?o0000olc<c?l000001oo<c<`0
1?l0003oc<c<olc<c?mVIVHDolc<c0CoIVIV0oo<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0
oooo0?oo033o0?oo00?o0000ogl0oomo0?l06?mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Aogoo0003o`000?o<
c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000L
olc<c0;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c0CoIVIV1_o<c<`00ol0003o0?ooo`3o
o`0`o`3oo`03o`000?mo0?ooO`3o01SoO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004Omoo`000ol0003oc<c<olc<
c00<olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`0
0ol0003oc<c<olc<c005olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<1OmVIVH2olc<c003o`000?l0
oooo0?oo02oo0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0003o0?ooo`3oo`09o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?o<
c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000U
olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`00_o<c<`2ofIVIP03o`000?l0
oooo0?oo02oo0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000@ogoo0003o`000?o<
c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000U
olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01?o<c<`00ol0003o0?ooo`3o
o`0_o`3oo`03o`000?mo0?ooO`3o01[oO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004?moo`000ol0003oc<c<olc<
c00<olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`0
1?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool0;ol0
ool00ol0003oO`3oogl0o`0Kogl0o`03o`000?l0oooo0?oo00Wo0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol0013oOol000?o0000olc<c?o<c<`03?o<
c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Goc<c<0_l00000
0oo<c<coIVIVolc<c00Jolc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool0;ol0ool0
0ol0003oO`3oogl0o`0Kogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000ooOol000?o0000olc<c?o<c<`03?o<c<`0
0omVIVKoc<c<olc<c00Nolc<c0OoIVIV4_o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHK
olc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3oool0ool0<?l0ool00ol0003oO`3oogl0o`0K
ogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?moo`3oOol000koOol000?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<c00B
olc<c0coIVIV0oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<
ofIVIQcoc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`0`o`3oo`03o`000?mo0?oo
O`3o01coO`3o00?o0000o`3oool0ool02Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`003_moo`000ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<co
c<c<00Goc<c<3OmVIVH?olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<
c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo02oo0?oo00?o0000
ogl0oomo0?l07Omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00[o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000=ogoo0003o`000?o<c<coc<c<00Woc<c<3?mVIVHL
olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`0
0omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo02oo0?oo00?o0000ogl0oomo0?l07Omo0?l0
0ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003oOol0ogoo000=ogoo0003o`000?mVIVKoIVIV00WoIVIV1?o<c<`00omVIVKoc<c<olc<c00Q
olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`0
0omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo02oo0?oo00?o0000ogl0oomo0?l07_mo0?l0
0ol0003o0?ooo`3oo`09o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003oOol0ogoo000=ogoo0003o`000?o<c<coc<c<00goc<c<00?oIVIVolc<c?o<c<`08Oo<c<`0
0omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIV
olc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o01koO`3o00?o0000
o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`003?moo`000ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIV
olc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<co
c<c<00;oc<c<00?o0000o`3oool0ool0<?l0ool00ol0003oO`3oogl0o`0Nogl0o`03o`000?l0oooo
0?oo00[o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3o
Ool000coOol000?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<co
c<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c002
olc<c003o`000?l0oooo0?oo033o0?oo00?o0000ogl0oomo0?l07omo0?l00ol0003o0?ooo`3oo`09
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000<
ogoo0003o`000?o<c<coc<c<00goc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00C
olc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`00_o<c<`0
0ol0003o0?ooo`3oo`0`o`3oo`03o`000?mo0?ooO`3o01ooO`3o00?o0000o`3oool0ool02_l0ool0
0ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`00
0ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1
ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000
o`3oool0ool0;ol0ool00ol0003oO`3oogl0o`0Pogl0o`03o`000?l0oooo0?oo00[o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000[oOol000?o0000
olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool0
02Coc<c<0_l000000oo<c<coIVIVolc<c00Kolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3o
ool0ool0;ol0ool00ol0003oO`3oogl0o`0Qogl0o`03o`000?l0oooo0?oo00Wo0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000[oOol000?o0000olc<
c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Co
c<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo
02oo0?oo00?o0000ogl0oomo0?l08Omo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo
00[o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000:ogoo0003o`000?o<c<coc<c<
00ooc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004
o`000?o<c<coc<c<ofIVIQcoc<c<00GoIVIVolc<c?o<c<coc<c<o`00000bo`3oo`03o`000?mo0?oo
O`3o027oO`3o00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<co
c<c<023oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHK
olc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0ool0<?l0ool00ol0003oO`3oogl0o`0R
ogl0o`03o`000?l0oooo0?oo00Wo0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?moo`3oOol000WoOol000?o0000olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00P
olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`0
0omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo033o0?oo00?o0000ogl0oomo0?l08_mo0?l0
0ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003oOol0ogoo0009ogoo0003o`000?o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`08?o<c<`0
0omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIV
olc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0`o`3oo`03o`000?mo0?ooO`3o02;oO`3o00?o0000
o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`002?moo`000ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIV
olc<c?o<c<`04oo<c<`1ooooo`008oo<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01_oc<c<00?oIVIV
olc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0_o`3oo`03o`000?mo0?ooO`3o02CoO`3o00?o0000
o`3oool0ool02Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`002?moo`000ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIV
olc<c?o<c<`04oo<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<co
c<c<00;oc<c<00?o0000o`3oool0ool0;ol0ool00ol0003oO`3oogl0o`0Togl0o`03o`000?l0oooo
0?oo00Wo0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3o
Ool000SoOol000?o0000olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<co
c<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01OmVIVKoc<c<olc<c?o<
c<co000003;o0?oo00?o0000ogl0oomo0?l09?mo0?l00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0
oooo0?oo00[o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?o<
c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000S
olc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00GoIVIVolc<c?o<c<coc<c<o`00000bo`3oo`03o`00
0?mo0?ooO`3o02GoO`3o00?o0000o`3oool0ool02Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`001_moo`000ol0003oc<c<olc<c00@olc<c003ofIV
I_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<
c?mVIVHLolc<c005ofIVI_o<c<coc<c<olc<c?l00000<_l0ool00ol0003oO`3oogl0o`0Uogl0o`03
o`000?l0oooo0?oo00Wo0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?moo`3oOol000KoOol000?o0000olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Qolc<c003
ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01OmVIVKo
c<c<olc<c?o<c<co000003;o0?oo00?o0000ogl0oomo0?l09Omo0?l00ol0003o0?ooo`3oo`0:o`3o
o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0006ogoo
0003o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<
c07ooooo000Solc<c0;o000000?oc<c<ofIVI_o<c<`06oo<c<`01OmVIVKoc<c<olc<c?o<c<co0000
03;o0?oo00?o0000ogl0oomo0?l09_mo0?l00ol0003o0?ooo`3oo`09o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?o<c<coc<c<
013oc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004
o`000?o<c<coc<c<ofIVIQcoc<c<00GoIVIVolc<c?o<c<coc<c<o`00000ao`3oo`03o`000?mo0?oo
O`3o02OoO`3o00?o0000o`3oool0ool02Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oc<c<olc<c00@olc<c003ofIVI_o<c<co
c<c<027oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHL
olc<c005ofIVI_o<c<coc<c<olc<c?l00000<Ol0ool00ol0003oO`3oogl0o`0Wogl0o`03o`000?l0
oooo0?oo00[o0?oo00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
o`3oOol000GoOol000?o0000olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<
c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01?mVIVKoc<c<olc<
c?l0000bo`3oo`03o`000?mo0?ooO`3o02SoO`3o00?o0000o`3oool0ool02Ol0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`001?moo`000ol0003oc<c<
olc<c00@olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<
c<`01?l0003oc<c<olc<c?mVIVHLolc<c004ofIVI_o<c<coc<c<o`0003;o0?oo00?o0000ogl0oomo
0?l0:?mo0?l00ol0003o0?ooo`3oo`09o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool02ol0ool00ol0003oOol0ogoo0004ogoo0003o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<
c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQco
c<c<00CoIVIVolc<c?o<c<co0000<_l0ool00ol0003oO`3oogl0o`0Xogl0o`03o`000?l0oooo0?oo
00[o0?oo00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol0
00CoOol000?o0000olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<
01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01?mVIVKoc<c<olc<c?l0000b
o`3oo`03o`000?mo0?ooO`3o02WoO`3o00?o0000o`3oool0ool02Ol0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`000omoo`000ol0003oc<c<olc<c00@
olc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0
003oc<c<olc<c?mVIVHLolc<c004ofIVI_o<c<coc<c<o`0003;o0?oo00?o0000ogl0oomo0?l0:Omo
0?l00ol0003o0?ooo`3oo`09o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0
ool00ol0003oOol0ogoo0002ogoo0003o`000?o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`08Oo<
c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00Co
IVIVolc<c?o<c<co0000<Ol0ool00ol0003oO`3oogl0o`0Zogl0o`03o`000?l0oooo0?oo00[o0?oo
00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000;oOol0
00?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01;oc<c<
0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<o`00000bo`3oo`03o`00
0?mo0?ooO`3o02_oO`3o00?o0000o`3oool0ool02Ol0ool00ol0003o0?ooo`3oo`0:o`3oo`03o`00
0?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Colc<c003ofIVI_o<c<coc<c<027o
c<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008_o<c<`01?l0003oc<c<olc<c?mVIVHMolc<c003
ofIVI_o<c<co000003;o0?oo00?o0000ogl0oomo0?l0:omo0?l00ol0003o0?ooo`3oo`09o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool01Ol0003oOol0ogoo0?moo`3o0000
01?oc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Golc<c0Co
00001oo<c<`01?l0003oc<c<olc<c?mVIVH@olc<c1Co0000;_l0ool00ol0003oO`3oogl0o`0[ogl0
o`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3o
o`05o`000?moo`3oOol0ogoo0?l000004oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<co
c<c<01;oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<
c0KoIVIV4oo<c<`00ol0003oo`00ool0000<ool000Wo00009Ol0ool00ol0003oO`3oogl0o`0/ogl0
o`03o`000?l0oooo0?oo00Wo0?oo00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3o
o`05o`000?moo`3oOol0ogoo0?l000005?o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<co
c<c<01;oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<
c004o`000?o<c<coc<c<ofIVIP;oc<c<2OmVIVHAolc<c0Go00003?oo0008o`0001go0?oo00?o0000
ogl0oomo0?l0;?mo0?l00ol0003o0?ooo`3oo`09o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool01?l0003oOol0ogoo0?l0000Dolc<c003ofIVI_o<c<coc<c<023oc<c<00?o
IVIVolc<c?o<c<`04_o<c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<00Coc<c<00Co0000olc<c?o<c<coIVIV2oo<c<`9ofIVIPSoc<c<00?oIVIVolc<c?o<c<`01Oo<
c<`7o`0000[oo`002?l0000Eo`3oo`03o`000?mo0?ooO`3o02coO`3o00?o0000o`3oool0ool02_l0
ool00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00Co0000ogoo0?moo`3o0000
5?o<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool001Koc<c<0_l0
0003olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`9ofIVIPkoc<c<
1ol0000;ool000Wo00002ol0ool00ol0003oO`3oogl0o`0^ogl0o`03o`000?l0oooo0?oo00Wo0?oo
00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3oo`0;o`3oo`04o`000?moo`3oOol0o`0001Co
c<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo000Folc<c003o`00
0?o<c<co000000;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c0[oIVIV3?o<c<`8o`0000co
o`002?l00003o`3oo`03o`000?mo0?ooO`3o02koO`3o00?o0000o`3oool0ool02Ol0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo0_l0000Eolc<c003ofIVI_o<c<coc<c<027o
c<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c009olc<c004o`00
0?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`01oo<c<`9ofIVIPKoc<c<00?oIVIVolc<c?o<
c<`00_o<c<`7o`0000[oo`000_l000000ooo003o0000o`000002o`00033oO`3o00?o0000o`3oool0
ool02_l0ool00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo0_l0000Eolc<c003
ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`005oo<c<`01Ol0003oc<c<
olc<c?o<c<co000002Koc<c<00?oIVIVolc<c?o<c<`04?o<c<`9ofIVIPWoc<c<2_l0000;ool000;o
0000:omo0?l00ol0003o0?ooo`3oo`09o`3oo`03o`000?l0oooo0?oo00[o0?oo00?o0000o`3oool0
ool02ol0ool2o`0001Goc<c<00?oIVIVolc<c?o<c<`05oo<c<`?ofIVIPooc<c<0Oooool001Soc<c<
0ol0000Wolc<c003ofIVI_o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`02OmVIVH9olc<c003o`00
0?oo003oo`00013oo`002?l0000Nogl0o`03o`000?l0oooo0?oo00Wo0?oo00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?o<c<coc<c<01;oc<c<6omVIVH:olc<c003ofIV
I_o<c<coc<c<017oc<c<0Oooool004;oc<c<00?oIVIVolc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<
c009olc<c0[oIVIV2Oo<c<`4o`0000goo`002?l0000Fogl0o`03o`000?l0oooo0?oo00[o0?oo00?o
0000o`3oool0ool01?l0oolEo`0001CoIVIV00?oc<c<ofIVI_o<c<`08_o<c<`00omVIVKoc<c<olc<
c00Aolc<c07ooooo001Kolc<c003ofIVI_o<c<coc<c<01;oc<c<2OmVIVH:olc<c003ofIVI_l0003o
000000Go00002?oo0007o`0000[oO`3o00?o0000ogl0oomo0?l00omo0?lCo`0000goIVIV7Oo<c<`0
0omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool005_oc<c<00?oIVIVolc<
c?o<c<`04_o<c<`00omVIVKoc<c<olc<c006olc<c0WoIVIV00?oc<c<ofIVI_o<c<`00oo<c<`00omV
IVKoc<c<olc<c003olc<c0[o00000_oo000:o`0000[oIVIV5oo<c<`00omVIVKoc<c<olc<c00Oolc<
c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`00L?o<c<`00omVIVKo
c<c<olc<c00?olc<c17oIVIV4_o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<01oo
c<c<00?oIVIVolc<c?o<c<`0=Oo<c<`1ooooo`00L?o<c<`00omVIVKoc<c<olc<c00@olc<c003ofIV
I_o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`06_o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIV
I_o<c<coc<c<05Ooc<c<0Oooool008?oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<
c00Jolc<c003ofIVI_o<c<coc<c<07Ooc<c<0Oooool008?oc<c<00?oIVIVolc<c?o<c<`00_o<c<`0
0omVIVKoc<c<olc<c02Dolc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00
ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00<Goc<c<0_l0001Holc<c07ooooo0036olc<
c0;o00000_o<c<`00ol0003oc<c<olc<c01Bolc<c07ooooo0037olc<c0;o00000_o<c<`00ol0003o
c<c<olc<c01Aolc<c07ooooo000oolc<c0Go00001?o<c<`3o`0000?oc<c<0_l00003olc<c0?o0000
0_o<c<`4o`0000?oc<c<1Ol00003olc<c0;o00001?o<c<`2o`0000;oc<c<0ol000000oo<c<co0000
o`000002olc<c0;o00000_o<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<
1?l00004olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<1?l00003olc<c0?o0000
0oo<c<`3o`0000?oc<c<0_l00004olc<c0?o000000?oc<c<o`000?l000001oo<c<`4o`000004olc<
c?l0003oc<c<olc<c0Co00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000004olc<c0Ko
0000:oo<c<`1ooooo`00?_o<c<`2o`0000?oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l00000
0_o<c<`2o`0000?oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<
0_l00003olc<c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l00000
0_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o0000
0oo<c<`2o`0000?oc<c<0_l000001?o<c<co0000o`000?o<c<`2o`0000;oc<c<0_l00002olc<c0;o
00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00004olc<c0?o000000?oc<c<o`000?l0
00001_o<c<`2o`0000;oc<c<0ol000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l0
00000_o<c<`2o`000003olc<c?l0003o000000Coc<c<0_l0000_olc<c07ooooo000nolc<c0;o0000
0oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o0000
0_o<c<`2o`0000Goc<c<0_l00002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<c0;o0000
0_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000008olc<c0?o00001?o<c<`3o`000003olc<
c?l0003o000000Soc<c<0ol00003olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000Coc<c<
0ol00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o0000
00?oc<c<o`000?l000001oo<c<`2o`0000Coc<c<0_l000000oo<c<co0000o`000005olc<c0;o0000
0_o<c<`2o`0000Soc<c<0_l0000^olc<c07ooooo0012olc<c0?o000000?oc<c<o`000?l000000oo<
c<`2o`000003olc<c?l0003o000000?oc<c<0_l00002olc<c0Ko000000?oc<c<o`000?l000000_o<
c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?o
c<c<o`000?l000001?l00002olc<c0Co00000oo<c<`4o`0000;oc<c<1_l00002olc<c0Co00001?o<
c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0Co00000oo<c<`2o`0000;oc<c<0_l0
0003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o000000Ooc<c<0_l0
0004olc<c0;o000000?oc<c<o`000?l000001?l000000oo<c<co0000o`000002olc<c0;o00002Oo<
c<`2o`0002goc<c<0Oooool003ooc<c<1Ol00002olc<c0;o00000oo<c<`2o`000003olc<c?l0003o
000000?oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003
olc<c0Go000000?oc<c<o`000?l000000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<
o`000?l000000_o<c<`2o`000004olc<c?l0003o0000o`0000Coc<c<0ol00004olc<c0;o00000_o<
c<`2o`000004olc<c?l0003o0000o`0000Koc<c<0_l00003olc<c0;o000000Coc<c<o`000?l0003o
c<c<0ol00005olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o
000000?oc<c<o`000?l000001oo<c<`2o`0000;oc<c<1?l000000oo<c<co0000o`000002olc<c0;o
000000?oc<c<o`000?l000000_o<c<`2o`0000[oc<c<0_l0000/olc<c07ooooo000nolc<c0?o0000
1_o<c<`2o`000003olc<c?l0003o000000;oc<c<0ol00002olc<c0;o00000_o<c<`2o`0000;oc<c<
0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<c0;o0000
0_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l00000
0_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<1ol000001?o<c<co0000o`000?o<c<`2o`0000;o
c<c<0_l00002olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<0ol00002olc<c0;o
000000?oc<c<o`000?l000001oo<c<`2o`0000Ooc<c<0_l00002olc<c0;o000000?oc<c<o`000?l0
00000_o<c<`2o`0000_oc<c<0_l0000[olc<c07ooooo000nolc<c0;o00000oo<c<`2o`0000?oc<c<
0ol00003olc<c0?o000000?oc<c<o`000?l000000_l00002olc<c0Co00000oo<c<`5o`0000?oc<c<
0_l00004olc<c0;o000000?oc<c<o`000?l000000_l000000oo<c<co0000o`000003o`0000?oc<c<
1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00001?o<c<`2o`0000?oc<c<
0_l000000oo<c<co0000o`000002olc<c0Co00000_o<c<`4o`0000?oc<c<0ol00003olc<c0?o0000
00?oc<c<o`000?l000000oo<c<`2o`0000Koc<c<0_l00004olc<c0;o00000_o<c<`4o`0000;oc<c<
1Ol00008olc<c0;o00000_o<c<`2o`0002_oc<c<0Oooool003koc<c<0_l00003olc<c0;o00003_o<
c<`2o`0000goc<c<0_l00003olc<c0;o00002?o<c<`2o`0002koc<c<0_l00003olc<c0;o00003?o<
c<`2o`0001coc<c<0_l00002olc<c0;o00005_o<c<`2o`0000;oc<c<0_l0000[olc<c07ooooo000o
olc<c0Go00003oo<c<`2o`0000goc<c<0_l00003olc<c0So00000_o<c<`2o`0002koc<c<0_l00003
olc<c0;o000000?oc<c<o`000?l000002Oo<c<`2o`0001goc<c<1?l0000Holc<c0Co0000;?o<c<`1
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 1, 6, 1, 6, 1, 1, 6, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(4.`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 0.0147151 5.88604 [
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(1.2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(1.4)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(1.6)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(1.8)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(2)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 0.0147151 2.94302 [
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .16187 -24 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -24 -4.5 ]
[.01131 .45617 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(1.2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(1.4)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(1.6)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(1.8)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(2)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .16187 m
.03006 .16187 L
s
[(0.05)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.1)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.15)] .01131 .45617 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 -0.377687 0.981006 [
[.21429 .59082 -9 -9 ]
[.21429 .59082 9 0 ]
[.40476 .59082 -9 -9 ]
[.40476 .59082 9 0 ]
[.59524 .59082 -9 -9 ]
[.59524 .59082 9 0 ]
[.78571 .59082 -9 -9 ]
[.78571 .59082 9 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -18 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .11282 -18 -4.5 ]
[.01131 .11282 0 4.5 ]
[.01131 .21092 -18 -4.5 ]
[.01131 .21092 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .40712 -18 -4.5 ]
[.01131 .40712 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .60332 m
.21429 .60957 L
s
[(1.2)] .21429 .59082 0 1 Mshowa
.40476 .60332 m
.40476 .60957 L
s
[(1.4)] .40476 .59082 0 1 Mshowa
.59524 .60332 m
.59524 .60957 L
s
[(1.6)] .59524 .59082 0 1 Mshowa
.78571 .60332 m
.78571 .60957 L
s
[(1.8)] .78571 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(2)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.07143 .60332 m
.07143 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.16667 .60332 m
.16667 .60707 L
s
.2619 .60332 m
.2619 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.5 .60332 m
.5 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.7381 .60332 m
.7381 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.4)] .01131 .01472 1 0 Mshowa
.02381 .11282 m
.03006 .11282 L
s
[(0.5)] .01131 .11282 1 0 Mshowa
.02381 .21092 m
.03006 .21092 L
s
[(0.6)] .01131 .21092 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.7)] .01131 .30902 1 0 Mshowa
.02381 .40712 m
.03006 .40712 L
s
[(0.8)] .01131 .40712 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(0.9)] .01131 .50522 1 0 Mshowa
.125 Mabswid
.02381 .03434 m
.02756 .03434 L
s
.02381 .05396 m
.02756 .05396 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .0932 m
.02756 .0932 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .15206 m
.02756 .15206 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .23054 m
.02756 .23054 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .26978 m
.02756 .26978 L
s
.02381 .2894 m
.02756 .2894 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34826 m
.02756 .34826 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .3875 m
.02756 .3875 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .44636 m
.02756 .44636 L
s
.02381 .46598 m
.02756 .46598 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .52484 m
.02756 .52484 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .56408 m
.02756 .56408 L
s
.02381 .5837 m
.02756 .5837 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 -0.272059 1.43387 [
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .1581 -18 -4.5 ]
[.01131 .1581 0 4.5 ]
[.01131 .30149 -18 -4.5 ]
[.01131 .30149 0 4.5 ]
[.01131 .44488 -18 -4.5 ]
[.01131 .44488 0 4.5 ]
[.01131 .58826 -18 -4.5 ]
[.01131 .58826 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(1.2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(1.4)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(1.6)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(1.8)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(2)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .1581 m
.03006 .1581 L
s
[(0.3)] .01131 .1581 1 0 Mshowa
.02381 .30149 m
.03006 .30149 L
s
[(0.4)] .01131 .30149 1 0 Mshowa
.02381 .44488 m
.03006 .44488 L
s
[(0.5)] .01131 .44488 1 0 Mshowa
.02381 .58826 m
.03006 .58826 L
s
[(0.6)] .01131 .58826 1 0 Mshowa
.125 Mabswid
.02381 .04339 m
.02756 .04339 L
s
.02381 .07207 m
.02756 .07207 L
s
.02381 .10075 m
.02756 .10075 L
s
.02381 .12942 m
.02756 .12942 L
s
.02381 .18678 m
.02756 .18678 L
s
.02381 .21546 m
.02756 .21546 L
s
.02381 .24413 m
.02756 .24413 L
s
.02381 .27281 m
.02756 .27281 L
s
.02381 .33017 m
.02756 .33017 L
s
.02381 .35884 m
.02756 .35884 L
s
.02381 .38752 m
.02756 .38752 L
s
.02381 .4162 m
.02756 .4162 L
s
.02381 .47355 m
.02756 .47355 L
s
.02381 .50223 m
.02756 .50223 L
s
.02381 .53091 m
.02756 .53091 L
s
.02381 .55959 m
.02756 .55959 L
s
.02381 .61694 m
.02756 .61694 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .01472 m
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 -0.573889 5.88604 [
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(1.2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(1.4)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(1.6)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(1.8)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(2)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.12)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.14)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.16)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.18)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 0.0147151 5.88604 [
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(1.2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(1.4)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(1.6)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(1.8)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(2)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 -58.2571 147.151 [
[.21429 .59082 -9 -9 ]
[.21429 .59082 9 0 ]
[.40476 .59082 -9 -9 ]
[.40476 .59082 9 0 ]
[.59524 .59082 -9 -9 ]
[.59524 .59082 9 0 ]
[.78571 .59082 -9 -9 ]
[.78571 .59082 9 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -30 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .16187 -30 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -30 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -30 -4.5 ]
[.01131 .45617 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .60332 m
.21429 .60957 L
s
[(1.2)] .21429 .59082 0 1 Mshowa
.40476 .60332 m
.40476 .60957 L
s
[(1.4)] .40476 .59082 0 1 Mshowa
.59524 .60332 m
.59524 .60957 L
s
[(1.6)] .59524 .59082 0 1 Mshowa
.78571 .60332 m
.78571 .60957 L
s
[(1.8)] .78571 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(2)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.07143 .60332 m
.07143 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.16667 .60332 m
.16667 .60707 L
s
.2619 .60332 m
.2619 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.5 .60332 m
.5 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.7381 .60332 m
.7381 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.396)] .01131 .01472 1 0 Mshowa
.02381 .16187 m
.03006 .16187 L
s
[(0.397)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.398)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.399)] .01131 .45617 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .60332 m
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.952381 0.0147151 5.88604 [
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(1.2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(1.4)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(1.6)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(1.8)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(2)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H002goi^KV0ol00004onKViP04
o`000?oVi^Koi^KVonKViPGo00000_oVi^H00ol0003oi^KVonKViP02onKViPCo00000ooVi^H00ol0
003oi^KVonKViP02onKViP?o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H5o`00
037oi^KV0ol00004onKViP04o`000?oVi^Koi^KVonKViPGo00000ooVi^H00ol0003oi^KVonKViP02
onKViPCo00000ooVi^H00ol0003oi^KVonKViP02onKViP?o00001?oVi^H00ol0003oi^KVonKViP02
onKViP?o000000?oi^KVo`000?l000000ol0000ConKViP00;_oVi^H00ol0003oi^KVonKViP08onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00008onKViP05o`000?oVi^Ko0000onKVi_l000001ooV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Co0000onKVi_oVi^Ko0000<_oVi^H00ol0003o
i^KVonKViP08onKViP;o000000?oi^KVo`000?oVi^H02?oVi^H2o`0000Soi^KV00Go0000onKVi_l0
003oi^KVo`000007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000002onKViP03o`000?oV
i^Koi^KV017oi^KV000^onKViP03o`000?oVi^Koi^KV00Soi^KV0_l00008onKViPGo00001ooVi^H0
1Ol0003oi^KVo`000?oVi^Ko000000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP03o`00
0?oVi^Koi^KV03;oi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003oi^KVonKViP07onKViPGo0000
1ooVi^H01Ol0003oi^KVo`000?oVi^Ko000000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKV
iP03o`000?oVi^Koi^KV01?oi^KV000^onKViP03o`000?oVi^Koi^KV00Soi^KV00?o0000onKVi_l0
00001ooVi^H01?l0003oi^KVo`000?l00008onKViPCo00002OoVi^H3o`0000Goi^KV00?o0000onKV
i_oVi^H0<OoVi^H00ol0003oi^KVonKViP09onKViP;o00002?oVi^H01?l0003oi^KVo`000?l00008
onKViPCo00002OoVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H04_oVi^H002koi^KV00?o0000onKV
i_oVi^H01ooVi^H2o`0000;oi^KV00?o0000onKVi_oVi^H01OoVi^H3o`0000Soi^KV00?o0000onKV
i_l000002OoVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_l000000ooVi^H00ol0003oi^KVonKV
iP0`onKViP03o`000?oVi^Koi^KV00Ooi^KV00Go0000onKVi_l0003oi^KVo`000008onKViP?o0000
2?oVi^H00ol0003oi^KVo`000009onKViP04o`000?oVi^Koi^KVonKViP;o00000ooVi^H00ol0003o
i^KVonKViP0AonKViP00;OoVi^H2o`0000Woi^KV0_l00002onKViP03o`000?oVi^Koi^KV00Goi^KV
0ol00009onKViP;o00002OoVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_l000000ooVi^H00ol0
003oi^KVonKViP0_onKViP;o00002OoVi^H3o`000003onKVi_l0003oi^KV00Ooi^KV0ol00009onKV
iP;o00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H04OoVi^H0
02koi^KV00?o0000onKVi_oVi^H02?oVi^H3o`0000Woi^KV0_l0000:onKViP;o00002OoVi^H3o`00
00?oi^KV0ol0000conKViP03o`000?oVi^Koi^KV00Soi^KV0ol0000:onKViP;o00002_oVi^H2o`00
00Woi^KV0ol00002onKViP?o00005?oVi^H00>?oi^KV000YonKViP03o`000?oVi^Koi^KV06Ooi^KV
00?o0000onKVi_oVi^H0COoVi^H002Ooi^KV0_l00002ok>c/c_o0000;?oVi^Hoo`0001;oi^KV000Y
onKViP03o`000?oVi^Ko/k>c06Ooi^KV00?o0000onKVi_oVi^H0COoVi^H002Woi^KV00?o0000onKV
i_oVi^H00_nc/k=UonKViP;o0000C_oVi^H002Woi^KV00?o0000onKVi_oVi^H00_oVi^H2ok>c/f?o
i^KV0_l0001>onKViP00:OoVi^H00ol0003oi^KVonKViP04onKViP03ok>c/ooVi^Koi^KV063oi^KV
00?o0000onKVi_oVi^H0COoVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0
0002onKViPGo00000_oVi^H00ol0003oi^KVonKViP05onKViP;o/k>cH?oVi^H2o`0004koi^KV000A
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KV
onKVi_l00002onKViP03o`000?oVi^Koi^KV00Ooi^KV0_nc/k=8onKViP;o00001?oVi^H00ol0003o
i^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H0COoVi^H0017oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV
00;oi^KV00?o0000onKVi_oVi^H02OoVi^H00onc/k?oi^KVonKViP14onKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0004ko
i^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000coi^KV0_nc/k=4onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co
0000onKVi_oVi^Ko00001OoVi^H00ol0003oi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKV
i_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0000>
onKViP;o/k>c@_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Goi^KV
00Co0000onKVi_l0003o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003o
i^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00004?oVi^H00onc/k?oi^KVonKV
iP0oonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP04o`0000;o
i^KV00?o0000onKVi_oVi^H0COoVi^H001;oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000?oi^KV
00?o0000onKVi_oVi^H03ooVi^H2ok>c/cooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003o
i^KVonKVi_l0003oi^KVo`0000Goi^KV0_l0001>onKViP004_oVi^H2o`0000Coi^KV00?o0000onKV
i_oVi^H00ooVi^H2o`0000Coi^KV0ol00002onKViP03o`000?oVi^Koi^KV017oi^KV00?o/k>conKV
i_oVi^H0?OoVi^H2o`0000[oi^KV0_l00002onKViPGo000000?oi^KVo`000?oVi^H0C_oVi^H0017o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP05o`000?oVi^Ko
i^KVonKVi_l000005?oVi^H2ok>c/e?oi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01Ol00002onKViP03o`000?oVi^Koi^KV01Coi^KV
0_nc/k=AonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KV
onKVi_l0003oi^KVo`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000HonKViP03ok>c/ooVi^Ko
i^KV03koi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViP03o`000?oVi^Ko
i^KV04goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H00ol0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV01Ooi^KV0_nc/k<monKViP04o`000?oV
i^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l00003onKViP03o`000?oVi^Koi^KV
01Woi^KV0_nc/k<konKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00
001?onKViP004_oVi^H2o`0000[oi^KV0_l00005onKViP05o`000?oVi^Koi^KVonKVi_l000007OoV
i^H00onc/k?oi^KVonKViP0honKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Ko
i^KV??o<c<`DonKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV
0ol00003onKViP03o`000?oVi^Koi^KV01coi^KV0_nc/k<honKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKV
iP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0000PonKViP;o/k>c
=_oVi^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooVi^H2o`0004koi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko
i^KVo`0002;oi^KV00?o/k>conKVi_oVi^H0=?oVi^H2o`0000[oi^KV00Go0000onKVi_oVi^Koi^KV
o`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oV
i^H01?l00003onKViP03o`000?oVi^Koi^KV027oi^KV0_nc/k=4onKViP;o0000C_oVi^H0017oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Koi^KV00?o0000
onKVi_oVi^H08ooVi^H2ok>c/d;oi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKV
iP0UonKViP03ok>c/ooVi^Koi^KV03ooi^KV00?o0000onKVi_oVi^H0COoVi^H001;oi^KV0_l0000:
onKViP;o00001?oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H09_oVi^H2ok>c/bWoi^KV0_l00004
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP?o00000_oVi^H2o`0004koi^KV000BonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKV
i_oVi^H0:?oVi^H00onc/k?oi^KVonKViP0UonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000
onKVi_oVi^Koi^KVo`000003onKViP03o`000?oVi^Ko000004ooi^KV000AonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`00
02_oi^KV0_nc/k<UonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01OoVi^H0
1?l0003oi^KVo`000?l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0000]onKViP;o/k>c8ooVi^H01?l0
003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00Goi^KV00?o0000onKVi_l00000CooVi^H0
017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000ooV
i^H00ol0003oi^KVonKViP0]onKViP03ok>c/ooVi^Koi^KV023oi^KV00Co0000onKVi_oVi^Ko0000
2OoVi^H01?l0003oi^KVonKVi_oVi^H4o`0000;oi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KV
onKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0
000`onKViP;o/k>c8?oVi^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooVi^H00ol0003oi^KV
onKViP03onKViP03o`000?oVi^Koi^KV04goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0003;oi^KV0_nc/k<O
onKViP;o00002_oVi^H01?l0003oi^KVonKVi_oVi^H5o`000003onKVi_l0003o000004koi^KV000B
onKViP;o00002_oVi^H2o`0000?oi^KV0ol00003onKViP03o`000?oVi^Koi^KV03;oi^KV00?o/k>c
onKVi_oVi^H0<_oVi^H00ol0003oi^KVonKViP1=onKViP00:OoVi^H00ol0003oi^KVonKViP0conKV
iP;o/k>c<_oVi^H2o`0004koi^KV000HonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o
00000ooVi^H00ol0003oi^KVonKViP0eonKViP;o/k>c8?oVi^H2o`0000Coi^KV00Co0000onKVi_oV
i^Koi^KV1Ol000000ooVi^Ko0000o`00001>onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKV
iP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0=ooVi^H00onc/k?oi^KVonKViP0LonKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0001?onKViP005ooV
i^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0
>?oVi^H00onc/k?oi^KVonKViP0KonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oV
i^Koi^KV0_l0001>onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV
00;oi^KV00?o0000onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKVi_l0000:onKViP04o`000?oVi^Ko
i^KVo`0004ooi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H0FooV
i^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l00000DOoVi^H001Ooi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H2o`0005goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko0000057oi^KV000HonKViP;o00002_oVi^H00ol0003oi^KVonKViP1LonKV
iP;o00002OoVi^H3o`0005;oi^KV003SonKViP00=ooVi^H3o`0000;oi^KV1_l000001?oVi^Ko0000
o`000?l00003onKViP?o00000_oVi^H00ol0003oi^KVo`000002o`0004goi^KV0ol00002onKViP?o
000000?oi^KVo`000?l000000ol00002onKViPKo000000Ooi^KVo`000?l0003o0000onKVi_l0003o
i^KV00?o000000?oi^KVo`000?l000008?oVi^H003Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00Ko0000onKVi_oVi^Ko0000
onKVi_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0
003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oV
i^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00027oi^KV000honKViP03o`00
0?oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP03onKViP03o`00
0?oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV00Co
0000onKVi_l0003o00000_oVi^H00ol0003oi^KVo`00000RonKViP00>?oVi^H3o`0000?oi^KV0ol0
0003onKViP?o00000ooVi^H3o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00001=onKViP;o0000
0ooVi^H4o`0000;oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_l0003o
00000_oVi^H2o`0002?oi^KV000honKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oV
i^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H00ol0003oi^KVonKViP1:onKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV0_l000001ooVi^Ko
0000onKVi_oVi^Ko0000onKVi_l000008_oVi^H003Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko
0000onKVi_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H0
0_oVi^H2o`000005onKVi_l0003oi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0OonKViP00
=ooVi^H4o`0000;oi^KV1Ol000000ooVi^Ko0000o`000002o`0000;oi^KV1?l00003onKViP?o0000
C_oVi^H3o`000005onKVi_l0003o0000o`000?oVi^H01_l00002onKViPGo000000Coi^KVo`000?l0
003oi^KV1_l000000ooVi^Ko0000o`00000PonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV002DonKViP?o00001?oVi^H01?l0003oi^KVonKVi_oV
i^H5o`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H00_oV
i^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`000003onKVi_l0003o000000?o00005_oV
i^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0ol0001eonKViP03o`000?oVi^Ko
i^KV00Soi^KV0_l000000ooVi^Ko0000onKViP08onKViP;o00002?oVi^H01Ol0003oi^KVo`000?oV
i^Ko000000Ooi^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^Ko000000;oi^KV00?o0000onKVi_oV
i^H05?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
07;oi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003oi^KVonKViP07onKViPGo00001ooVi^H01Ol0
003oi^KVo`000?oVi^Ko000000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV01Koi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1Ol00002onKViP;oOgmoLOoV
i^H00ol0003oi^KVonKViP09onKViP;o00002?oVi^H01?l0003oi^KVo`000?l00008onKViPCo0000
2OoVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H05OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko0000
1ooVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^KoOgmo073oi^KV00?o0000onKVi_oV
i^H01ooVi^H01Ol0003oi^KVo`000?oVi^Ko000000Soi^KV0ol00008onKViP03o`000?oVi^Ko0000
00Woi^KV00Co0000onKVi_oVi^Koi^KV0_l00003onKViP03o`000?oVi^Koi^KV01Coi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00?o0000onKVi_l000000ooVi^H00ol0003oi^KVonKViP02
ogmoOfgoi^KV0_l00009onKViP?o000000?oi^KVo`000?oVi^H01ooVi^H3o`0000Woi^KV0_l00009
onKViP04o`000?oVi^Koi^KVonKViP;o00000ooVi^H00ol0003oi^KVonKViP0DonKViP004?oVi^H0
1?l0003oi^KVonKVi_l00009onKViP;o00000ooVi^H00ol0003oi^KVonKViP02onKViP;oOgmoK?oV
i^H00ol0003oi^KVonKViP08onKViP?o00002_oVi^H2o`0000[oi^KV0_l00009onKViP?o00000_oV
i^H3o`0001Ooi^KV000AonKViP;o00002ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV00?o
OgmoonKVi_oVi^H0]ooVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003
onKViP03o`000?oVi^Koi^KV00Goi^KV0_moOgmTonKViP03o`000?oVi^Koi^KV053oi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV00Ooi^KV00?oOgmoonKVi_oVi^H0H?oVi^H00ol0003oVIVIoiVIV@0lo`0001Goi^KV000@
onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H2ogmoOf7oi^KV
0_l000000onIVIWoi^KVonKViP1>onKViP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`00
0?oVi^Koi^KVo`0000coi^KV0_moOgmOonKViP03o`000?oVi^Koi^KV00;oVIVIC_oVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H03?oVi^H00omoOgoo
i^KVonKViP1LonKViP;o00000ooVi^H2oiVIVDcoi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP0=onKViP;oOgmoG?oVi^H00ol0003o
i^KVonKViP04onKViP03oiVIVOoVi^Koi^KV04Woi^KV000AonKViP;o00002?oVi^H5o`0000;oi^KV
00?o0000onKVi_oVi^H03ooVi^H00omoOgooi^KVonKViP1IonKViP;o00001_oVi^H2oiVIVDWoi^KV
000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKV
iP0@onKViP;oOgmoBOoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o
0000onKVi_oVi^H01ooVi^H2oiVIVDOoi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go
0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01;oi^KV0_moOgm6onKViP04o`00
0?oVi^Koi^KVo`0000Ooi^KV00Ko0000onKVi_oVi^Koi^KVo`000?oVi^H2o`0000[oi^KV00?oVIVI
onKVi_oVi^H0A?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000;oi^KV00?o0000onKVi_oVi^H05?oVi^H00omoOgooi^KVonKViP13onKViP04o`000?oV
i^Koi^KVo`0000_oi^KV00?o0000onKVi_l000003?oVi^H2oiVIVDCoi^KV000@onKViP04o`000?oV
i^Koi^KVo`0000Ooi^KV1?l00003onKViP03o`000?oVi^Koi^KV01Goi^KV0_moOgm3onKViP04o`00
0?oVi^Koi^KVo`0000Woi^KV0_l00002onKViP;o00003OoVi^H2oiVIVD;oi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP0GonKViP03
ogmoOooVi^Koi^KV043oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVo`000?l0000?
onKViP03oiVIVOoVi^Koi^KV03ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?o0000
onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP0HonKViP;oOgmo@?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`00000AonKViP;oVIVI?ooVi^H0017oi^KV
0_l0000:onKViP;o00000ooVi^H00ol0003oi^KVonKViP0JonKViP;oOgmo?ooVi^H2o`0000Woi^KV
0ol00002onKViP;o00004_oVi^H00onIVIWoi^KVonKViP0lonKViP004OoVi^H2o`0000Coi^KV00?o
0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV01coi^KV00?o
OgmoonKVi_oVi^H0C?oVi^H00ol0003oi^KVonKViP0BonKViP;oVIVI??oVi^H0013oi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV01goi^KV0_mo
Ogm<onKViP;o00005OoVi^H2oiVIVC[oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go
0000onKVi_oVi^Koi^KVo`00000QonKViP03ogmoOooVi^Koi^KV03Woi^KV0_l00004onKViP03o`00
0?oVi^Koi^KV00?oi^KV0ol000000ooVi^Ko0000onKViP0GonKViP03oiVIVOoVi^Koi^KV03Ooi^KV
000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00000RonKViP;o
Ogmo>?oVi^H01?l0003oi^KVonKVi_l0000:onKViP03o`000?oVi^Koi^KV00;o00006?oVi^H2oiVI
VCOoi^KV000@onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00009?oVi^H0
0omoOgooi^KVonKViP0eonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1Ol000000ooVi^Ko0000o`00
000JonKViP;oVIVI=OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H08ooVi^H2ogmoOcGoi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV01_oi^KV00?oVIVIonKV
i_oVi^H0<_oVi^H0017oi^KV0_l00008onKViPGo00000_oVi^H00ol0003oi^KVonKViP0UonKViP;o
Ogmo<ooVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Ko000000;oi^KV0_l0000MonKV
iP;oVIVI<_oVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03
o`000?oVi^Koi^KV02Ooi^KV00?oOgmoonKVi_oVi^H0<?oVi^H01?l0003oi^KVonKVi_l00009onKV
iP;o00000_oVi^H00ol0003oi^KVonKViP0NonKViP;oVIVI<?oVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0:?oVi^H2
ogmoOc7oi^KV0_l0000;onKViP03o`000?oVi^Koi^KV00;o00008OoVi^H00onIVIWoi^KVonKViP0]
onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oV
i^H00ol0003oi^KVonKViP0ZonKViP03ogmoOooVi^Koi^KV03koi^KV00?o0000onKVi_oVi^H08OoV
i^H2oiVIVBgoi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV0ol00003onKViP03o`000?oV
i^Koi^KV02_oi^KV0_moOglnonKViP;o00009?oVi^H2oiVIVB_oi^KV000@onKViP04o`000?oVi^Ko
i^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV02goi^KV
0_moOgl/onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H2o`0002Koi^KV
00?oVIVIonKVi_oVi^H0:?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0;ooVi^H00omoOgooi^KVonKViP0XonKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^Ko000002Soi^KV0_nI
VITXonKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000
onKVi_oVi^H0<?oVi^H2ogmoObSoi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVo`00
0?l0000YonKViP03oiVIVOoVi^Koi^KV02Goi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV
00Go0000onKVi_oVi^Koi^KVo`000004onKViP?o00001?oVi^H01?l0003oi^KVonKVi_oVi^H6o`00
00Coi^KV00?o0000onKVi_oVi^H00ooVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H5o`00
00Coi^KV00?oOgmoonKVi_oVi^H00_oVi^H3o`0000?oi^KV1Ol0000HonKViP04o`000?oVi^Koi^KV
o`0000_oi^KV00?o0000onKVi_l00000:ooVi^H2oiVIVBGoi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000_oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H00ol0003oi^KVonKViP08onKViP04o`000?oV
i^Koi^KVo`0000coi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ko
i^KV0_moOgl00ooVi^Ko0000onKViP02onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0
003oi^KVonKViP0FonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l00002onKViP;o0000;?oVi^H2
oiVIVB?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00002onKViP03o`000?oVi^Ko
i^KV00?oi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003oi^KVo`000009onKViPGo00002?oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000Soi^KV0_moOgl3onKViP03o`000?oVi^Koi^KV00;oi^KV00?o
0000onKVi_oVi^H06?oVi^H01?l0003oi^KVonKVi_l00007onKViP03o`000?oVi^Koi^KV00?oi^KV
00?o0000onKVi_oVi^H0;OoVi^H00onIVIWoi^KVonKViP0PonKViP004?oVi^H01?l0003oi^KVonKV
i_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP03onKViP03
o`000?oVi^Koi^KV00[oi^KV0_l00009onKViP04o`000?oVi^Koi^KVo`0000Woi^KV1Ol0000:onKV
iP03ogmoOol0003o000000Koi^KV00?o0000onKVi_oVi^H06?oVi^H2o`0000Soi^KV1Ol000000ooV
i^Ko0000o`00000_onKViP;oVIVI8?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP07
onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H00ol0003oi^KVo`000009onKViP05o`000?oV
i^Koi^KVonKVi_l000002OoVi^H01Ol0003oi^KVogmoOomoOgoo000000;oi^KV00Go0000onKVi_oV
i^Koi^KVo`00000YonKViP03o`000?oVi^Koi^KV033oi^KV0_nIVITNonKViP004OoVi^H2o`0000Wo
i^KV0ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV0_l00009onKViP03o`000?oVi^Koi^KV00;o
00002ooVi^H2o`0000[oi^KV00Co0000onKVi_l0003o00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko
Ogmo00;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000YonKViP;o0000<ooVi^H00onIVIWoi^KVonKV
iP0KonKViP008_oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00Soi^KV1?l0000<
onKViP03o`000?oVi^Koi^KV00Woi^KV0ol0000:onKViP?o000000Coi^KVogmoOomoOgooi^KV0ol0
000JonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H2o`0003Coi^KV0_nI
VITKonKViP008_oVi^H00ol0003oi^KVonKViP0monKViP;oOgmo6ooVi^H01?l0003oi^KVonKVi_l0
0007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`00000gonKViP;oVIVI6OoVi^H002;oi^KV
00?o0000onKVi_oVi^H0?ooVi^H00omoOgooi^KVonKViP0HonKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Ko0000onKVi_oVi^Koi^KVo`000?oVi^H2o`0003Soi^KV00?oVIVIonKVi_oVi^H05_oVi^H0
023oi^KVAOl000000omoOgoo0000o`00000GonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l00002
onKViP03o`000?oVi^Koi^KV03Soi^KV00?oVIVIonKVi_oVi^H05OoVi^H002;oi^KV00?o0000onKV
i_oVi^H0F_oVi^H01?l0003oi^KVonKVi_l00007onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0001A
onKViP00OooVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Koi^KV05Goi^KV0020onKV
iP;o00002_oVi^H2o`0005Goi^KV003SonKViP00hooVi^H003Goi^KV0_l000001?oVi^Ko0000o`00
0?l00002onKViP;o00000ooVi^H3o`0000;oi^KV0_l000001OoVi^Ko0000o`000?l0003oi^KV00?o
0000DOoVi^H3o`0000?oi^KV1Ol000001?oVi^Ko0000o`000?l00002onKViP?o000000Coi^KVo`00
0?l0003o0000:OoVi^H003Goi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP04o`000?oVi^Ko
i^KVo`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP05o`000?oVi^Koi^KVonKVi_l0
0000DooVi^H00ol0003oi^KVonKViP03onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKV
i_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV02Soi^KV000eonKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKViP04o`000?oVi^Koi^KVonKViPGo
00000ooVi^H00ol0003oi^KVonKViP1AonKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oV
i^H00ooVi^H00ol0003oi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l00000:_oVi^H003Go
i^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000
onKVi_oVi^H00_oVi^H00ol0003oi^KVo`000004onKViP03o`000?oVi^Koi^KV057oi^KV0ol00003
onKViP?o00000ooVi^H3o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000ZonKViP00=OoVi^H0
1Ol0003oi^KVo`000?oVi^Ko000000;oi^KV00[o0000onKVi_oVi^Ko0000onKVi_l0003oi^KVo`00
0?oVi^Ko00000_oVi^H00ol0003oi^KVo`000002onKViP05o`000?oVi^Ko0000onKVi_l00000DOoV
i^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00[o0000onKVi_oVi^Ko
0000onKVi_l0003oi^KVo`000?oVi^Ko0000:_oVi^H003Goi^KV0_l000000ooVi^Ko0000o`000002
onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`0000?oi^KV00Wo0000onKV
i_oVi^Koi^KVo`000?oVi^Ko0000onKVi_l00000DOoVi^H01?l0003oi^KVonKVi_l00002onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00Go0000onKVi_oVi^Ko0000onKViP02o`000003onKVi_l0003o
000002[oi^KV000eonKViP04o`000?oVi^Koi^KVonKViPGo000000?oi^KVo`000?l000001Ol00002
onKViP;o00000ooVi^H5o`00053oi^KV1?l00002onKViPGo000000?oi^KVo`000?l000000_l00002
onKViP04o`000?oVi^Koi^KVonKViP;o0000:OoVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV
003SonKViP00hooVi^H00>?oi^KV003SonKViP00;OoVi^H3o`0000Coi^KV00Co0000onKVi_oVi^Ko
i^KV1Ol00002onKViP03o`000?oVi^Koi^KV00;oi^KV1?l00003onKViP03o`000?oVi^Koi^KV00;o
i^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViPGo0000<OoVi^H3o`0000Co
i^KV00Co0000onKVi_oVi^Koi^KV1Ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV1?l00003onKV
iP03o`000?oVi^Koi^KV00;oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol000000ooV
i^Ko0000o`000003o`0001?oi^KV000^onKViP03o`000?oVi^Koi^KV00Soi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H2o`0000Soi^KV00Go0000onKVi_l0003oi^KVo`000007onKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l0000bonKViP03o`000?oVi^Koi^KV00Soi^KV
0_l000000ooVi^Ko0000onKViP08onKViP;o00002?oVi^H01Ol0003oi^KVo`000?oVi^Ko000000Oo
i^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H04OoVi^H0
02koi^KV00?o0000onKVi_oVi^H02?oVi^H2o`0000Soi^KV1Ol00007onKViP05o`000?oVi^Ko0000
onKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H0<_oV
i^H00ol0003oi^KVonKViP09onKViP03o`000?oVi^Koi^KV00Ooi^KV1Ol00007onKViP05o`000?oV
i^Ko0000onKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oV
i^H04ooVi^H002koi^KV00?o0000onKVi_oVi^H02?oVi^H00ol0003oi^KVo`000007onKViP04o`00
0?oVi^Ko0000o`0000Soi^KV1?l00009onKViP?o00001OoVi^H00ol0003oi^KVonKViP0aonKViP03
o`000?oVi^Koi^KV00Woi^KV0_l00008onKViP04o`000?oVi^Ko0000o`0000Soi^KV1?l00009onKV
iP?o00001?oVi^H00ol0003oi^KVonKViP0BonKViP00;_oVi^H00ol0003oi^KVonKViP07onKViP;o
00000_oVi^H00ol0003oi^KVonKViP05onKViP?o00002?oVi^H00ol0003oi^KVo`000009onKViP07
o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV033oi^KV00?o0000
onKVi_oVi^H01ooVi^H01Ol0003oi^KVo`000?oVi^Ko000000Soi^KV0ol00008onKViP03o`000?oV
i^Ko000000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l00003onKViP03o`000?oVi^Koi^KV017oi^KV
000]onKViP;o00002OoVi^H2o`0000;oi^KV00?o0000onKVi_oVi^H01OoVi^H3o`0000Woi^KV0_l0
0009onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV02oo
i^KV0_l00009onKViP?o000000?oi^KVo`000?oVi^H01ooVi^H3o`0000Woi^KV0_l00009onKViP04
o`000?oVi^Koi^KVonKViP;o00000ooVi^H00ol0003oi^KVonKViP0AonKViP00;_oVi^H00ol0003o
i^KVonKViP08onKViP?o00002OoVi^H2o`0000[oi^KV0_l00009onKViP?o00000ooVi^H3o`0003?o
i^KV00?o0000onKVi_oVi^H02?oVi^H3o`0000[oi^KV0_l0000:onKViP;o00002OoVi^H3o`0000;o
i^KV0ol0000DonKViP00hooVi^H002Ooi^KV??l00002oda<C003o`000?oVi^Koi^KV02[oi^KV00?o
0000ofIVI_mVIVH0??l0000BonKViP00:OoVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002
onKViP04o`000?m<C4coi^KVo`0002koi^KV00Co0000onKVi_mVIVKo00000_oVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000_oV
i^H01?l0003oi^KVonKVi_l0000DonKViP00:OoVi^H00ol0003oi^KVonKViP0donKViP;oC4a<<OoV
i^H2o`000003onKVi_mVIVKoIVIV04_oi^KV000YonKViP03o`000?oVi^Koi^KV03;oi^KV0_m<C4`c
onKViP03o`000?oVi^Koi^KV00;oi^KV0_mVIVI9onKViP00:OoVi^H00ol0003oi^KVonKViP0aonKV
iP03oda<C?oVi^Koi^KV03?oi^KV0_l00005onKViP03ofIVI_oVi^Koi^KV04Koi^KV000BonKViP;o
00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H5o`0000;oi^KV00?o0000onKVi_oV
i^H0;ooVi^H2oda<C23oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00002onKViPGo
000000?oi^KVo`000?oVi^H01_oVi^H2ofIVITKoi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV
02koi^KV00?oC4a<onKVi_oVi^H07ooVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Go0000onKVi_oVi^Ko0000onKViP02o`0000Soi^KV00?oIVIVonKVi_oVi^H0
@ooVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP03onKViP03o`00
0?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0;?oVi^H2oda<C2;oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H2
ofIVIT?oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01?oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000002coi^KV0_m<C4`TonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Co0000onKVi_oVi^Ko00001?oVi^H00ol0003oi^KVonKViP02o`0000_oi^KV0_mVIVI1onKViP00
4OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0
003oi^KVonKVi_l0000[onKViP03oda<C?oVi^Koi^KV02Coi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_l000003_oVi^H00omVIVKo
i^KVonKViP0nonKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H09ooVi^H2oda<C2Ooi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o
00003_oVi^H2ofIVISkoi^KV000BonKViP;o00002_oVi^H00ol0003oi^KVonKViP02onKViP?o0000
0ooVi^H00ol0003oi^KVonKViP0VonKViP03oda<C?oVi^Koi^KV02Soi^KV0_l0000:onKViP;o0000
0ooVi^H3o`0000;oi^KV0_l0000@onKViP03ofIVI_oVi^Koi^KV03_oi^KV000YonKViP03o`000?oV
i^Koi^KV02Coi^KV0_m<C4a1onKViP03o`000?oVi^Koi^KV013oi^KV0_mVIVHkonKViP004_oVi^H2
o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000Coi^KV0ol00002onKViP03o`000?oVi^Ko
i^KV02;oi^KV0_m<C4`]onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00001?oVi^H3
o`000003onKVi_l0003o000001?oi^KV0_mVIVHionKViP004OoVi^H01?l0003oi^KVonKVi_l00009
onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`00000SonKViP03oda<C?oV
i^Koi^KV02coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP04
o`000?oVi^Koi^KVo`0001Koi^KV00?oIVIVonKVi_oVi^H0=_oVi^H0017oi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H07ooVi^H2
oda<C2ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Go0000
00?oi^KVo`000?l000005_oVi^H2ofIVISKoi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00Go0000onKVi_oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l000008?oVi^H00om<
C4coi^KVonKViP0_onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKV
i_l00002onKViP04o`000?oVi^Koi^KVo`0001Woi^KV00?oIVIVonKVi_oVi^H0<ooVi^H0017oi^KV
00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Ko000000?o
i^KV00?o0000onKVi_oVi^H07?oVi^H2oda<C3;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0
003oi^KVonKVi_l00002onKViP03o`000?oVi^Ko000000;oi^KV0_l0000IonKViP;oIVIV<ooVi^H0
017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0000Goi^KV0_l00003onKViP03o`000?oVi^Ko
i^KV01[oi^KV0_m<C4`donKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
0ooVi^H2o`0000;oi^KV00?o0000onKVi_oVi^H06_oVi^H2ofIVIS7oi^KV000BonKViP;o00002_oV
i^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l000006ooVi^H00om<C4coi^KV
onKViP0eonKViP;o00002_oVi^H2o`0000Goi^KV00?o0000onKVi_oVi^H00_l0000MonKViP03ofIV
I_oVi^Koi^KV02koi^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooV
i^H3o`0000?oi^KV00?o0000onKVi_oVi^H05ooVi^H2oda<C3Soi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00?oi^KV0_l00003onKViP?o00000_oVi^H2o`0001koi^KV0_mVIVH^onKViP004OoVi^H0
1?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KV
onKVi_l0000HonKViP03oda<C?oVi^Koi^KV03Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0
003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_l000008OoVi^H00omVIVKoi^KVonKV
iP0[onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l00000
0ooVi^H01?l0003oi^KVonKVi_l0000FonKViP;oC4a<>_oVi^H01?l0003oi^KVonKVi_l00008onKV
iP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l0000QonKViP;oIVIV
:ooVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H4o`0000?o
i^KV00?o0000onKVi_oVi^H04ooVi^H00om<C4coi^KVonKViP0jonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Go0000onKVi_oVi^Ko0000onKViP04o`0000;oi^KV00?o0000onKVi_oVi^H08_oVi^H0
0omVIVKoi^KVonKViP0XonKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Ko
i^KVonKVi_l000001_oVi^H00ol0003oi^KVonKViP0AonKViP;oC4a<?OoVi^H01?l0003oi^KVonKV
i_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00001OoVi^H2o`0002Coi^KV0_mVIVHXonKV
iP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKV
iP03o`000?oVi^Koi^KV00ooi^KV0_m<C4`oonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV02Goi^KV0_mV
IVHVonKViP004_oVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV00?o0000
onKVi_oVi^H03_oVi^H00om<C4coi^KVonKViP10onKViP;o00002_oVi^H2o`0000Coi^KV0_l00002
onKViP;o0000:?oVi^H00omVIVKoi^KVonKViP0SonKViP004_oVi^H2o`0000Coi^KV00?o0000onKV
i_oVi^H00_oVi^H3o`0000?oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00coi^KV0_m<C4a3onKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKV
i_oVi^H0:?oVi^H2ofIVIR?oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKV
i_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000goi^KV00?oC4a<onKVi_oVi^H0@_oV
i^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0
003oi^KVo`000?l0000[onKViP03ofIVI_oVi^Koi^KV023oi^KV000AonKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000_oi^KV
0_m<C4a5onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003
onKViP03o`000?oVi^Ko000002goi^KV0_mVIVHPonKViP004OoVi^H01?l0003oi^KVonKVi_l00009
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00Ooi^KV0_m<C4a7
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000;oi^KV
0_l0000^onKViP;oIVIV7_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00om<C4coi^KVonKViP17onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`00
0?oVi^Ko0000o`00033oi^KV00?oIVIVonKVi_oVi^H06ooVi^H0017oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H2o`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV
00Coi^KV0_m<C4a:onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKV
i_l00003onKViP03o`000?oVi^Ko000003;oi^KV0_mVIVHKonKViP004_oVi^H2o`0000[oi^KV00?o
0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00om<C4coi^KVonKV
iP1;onKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP;o0000<ooVi^H00omVIVKoi^KVonKV
iP0HonKViP006?oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002onKViP04o`000?oV
i^Koi^KVonKViP;oC4a<E?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV
00?o0000onKVi_oVi^H0<ooVi^H2ofIVIQSoi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVoda<C?m<C4aEonKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l0000fonKViP;oIVIV5_oVi^H001Ooi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?m<C4coi^KV05Koi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000003Woi^KV00?oIVIVonKVi_oV
i^H04ooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^KoC4a<
05Soi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0003Woi^KV00?o
IVIVonKVi_oVi^H04_oVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKVi_l00009onKViP05
o`000?oVi^Koi^KVonKVi_l00000CooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000005_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0005?oi^KV000H
onKViP;o00002OoVi^H3o`0005goi^KV0_l0000:onKViP03o`000?oVi^Koi^KV057oi^KV003SonKV
iP00hooVi^H003[oi^KV1?l00004onKViP;o00000_oVi^H3o`0000?oi^KV1Ol0001>onKViPGo0000
00Koi^KVo`000?l0003o0000onKVi_l00003onKViP;o00000_oVi^H2o`000003onKVi_l0003o0000
00Co00001?oVi^H3o`0002;oi^KV000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP04o`000?oVi^Koi^KVo`0004ooi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00027oi^KV
000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003o
i^KVonKViP03onKViP03o`000?oVi^Koi^KV053oi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0003o
i^KVo`000?l0003oi^KVo`0000Goi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00Koi^KV00?o0000
onKVi_oVi^H07ooVi^H003_oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0
0002onKViP?o00000ooVi^H00ol0003oi^KVonKViP1@onKViP?o00000ooVi^H01_l0003oi^KVo`00
0?l0003oi^KVo`0000Koi^KV00?o0000onKVi_l000000ooVi^H3o`0000Coi^KV0_l0000RonKViP00
>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1@onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00000
1?oVi^Ko0000onKVi_l00006onKViP03o`000?oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP0RonKViP00>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1@onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV0_l000001OoVi^Ko0000onKVi_oVi^Ko000000;oi^KV00Go
0000onKVi_oVi^Koi^KVo`000004onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oV
i^Ko00008OoVi^H003[oi^KV1?l00002onKViP?o000000?oi^KVo`000?l000001?l00002onKViP?o
0000D?oVi^H5o`000004onKVi_l0003o0000onKViP?o00000_oVi^H3o`0000;oi^KV0_l00003onKV
iPCo00001?oVi^H3o`00027oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?o
i^KV003SonKViP00hooVi^H009Ooi^KV0ol00004onKViP04o`000?oVi^Koi^KVonKViPGo00000ooV
i^H00ol0003oi^KVonKViP02onKViPCo00000ooVi^H00ol0003oi^KVonKViP02onKViP?o00001?oV
i^H00ol0003oi^KVonKViP02onKViP?o000000?oi^KVo`000?l000000ol0000ConKViP00V?oVi^H0
0ol0003oi^KVonKViP08onKViP;o000000?oi^KVo`000?oVi^H02?oVi^H2o`0000Soi^KV00Go0000
onKVi_l0003oi^KVo`000007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000002onKViP03
o`000?oVi^Koi^KV017oi^KV000=onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o0000
0ooVi^H2o`0000Coi^KV0ol0001aonKViP03o`000?oVi^Koi^KV00Woi^KV00?o0000onKVi_oVi^H0
1ooVi^H5o`0000Ooi^KV00Go0000onKVi_l0003oi^KVo`000007onKViP05o`000?oVi^Koi^KVonKV
i_l000000_oVi^H00ol0003oi^KVonKViP0ConKViP003?oVi^H01?l0003oi^KVonKVi_l00007onKV
iP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01?l0003oi^KVonKVi_l00003onKViP04o`000?oV
i^Koi^KVo`0006goi^KV00?o0000onKVi_oVi^H02OoVi^H2o`0000Soi^KV00Co0000onKVi_l0003o
00002?oVi^H4o`0000Woi^KV0ol00004onKViP03o`000?oVi^Koi^KV01;oi^KV000<onKViP04o`00
0?oVi^Koi^KVo`0000_oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVo`000003onKViP04
o`000?oVi^Koi^KVo`0003goi^KV0_lI6AT^onKViP03o`000?oVi^Koi^KV00Ooi^KV00Go0000onKV
i_l0003oi^KVo`000008onKViP?o00002?oVi^H00ol0003oi^KVo`000009onKViP04o`000?oVi^Ko
i^KVonKViP;o00000ooVi^H00ol0003oi^KVonKViP0AonKViP003?oVi^H01?l0003oi^KVonKVi_l0
0009onKViP;o00000ooVi^H4o`000003onKVi_l0003o000000;o00000ooVi^H00ol0003oi^KVonKV
iP0jonKViP03oaTI6OoVi^Koi^KV02goi^KV0_l00009onKViP?o000000?oi^KVo`000?oVi^H01ooV
i^H3o`0000Woi^KV0_l00009onKViP04o`000?oVi^Koi^KVonKViP;o00000ooVi^H00ol0003oi^KV
onKViP0AonKViP003?oVi^H01?l0003oi^KVonKVi_l0000;onKViP03o`000?oVi^Ko000000?oi^KV
00?o0000onKVi_l000001_oVi^H00ol0003oi^KVonKViP0honKViP;o6ATI<OoVi^H00ol0003oi^KV
onKViP08onKViP?o00002_oVi^H2o`0000[oi^KV0_l00009onKViP?o00000_oVi^H3o`0001Coi^KV
000<onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^Ko0000
00?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H00ol0003oi^KVonKViP0fonKViP;o6ATI;_oVi^H0
0ol0003oi^KVonKViP1=onKViP003OoVi^H2o`0000Woi^KV0ol00003onKViP?o00001?oVi^H2o`00
00?oi^KV00?o0000onKVi_oVi^H0=OoVi^H00olI6AWoi^KVonKViP0]onKViP03o`000?lc<c?o<c<c
03co00004_oVi^H002[oi^KV00?o0000onKVi_oVi^H0<ooVi^H2oaTI6C7oi^KV00Co0000onKVi_lc
<c?o00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000DonKViP00:_oVi^H00ol0003o
i^KVonKViP0aonKViP;o6ATI<ooVi^H2o`000003onKVi_lc<c?o<c<c04_oi^KV000ZonKViP03o`00
0?oVi^Koi^KV033oi^KV00?o6ATIonKVi_oVi^H0<ooVi^H00ol0003oi^KVonKViP02onKViP;o<c<c
BOoVi^H000goi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP;o00001OoV
i^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV02koi^KV0_lI6ATfonKViP;o00001OoV
i^H00olc<c?oi^KVonKViP16onKViP003?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oV
i^Koi^KVonKVi_l000001?oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00;oi^KV
00?o0000onKVi_oVi^H0;OoVi^H00olI6AWoi^KVonKViP0PonKViP;o00001?oVi^H00ol0003oi^KV
onKViP03onKViP;o00000_oVi^H5o`000003onKVi_l0003oi^KV00Koi^KV0_lc<c=6onKViP003?oV
i^H01?l0003oi^KVonKVi_l0000;onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H0
0_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000002goi^KV0_lI6ATRonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00;o00002?oV
i^H00olc<c?oi^KVonKViP13onKViP003?oVi^H01?l0003oi^KVonKVi_l00009onKViP;o00000ooV
i^H4o`0000Coi^KV00Go0000onKVi_oVi^Koi^KVo`00000[onKViP;o6ATI9?oVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`00000:
onKViP;o<c<c@ooVi^H000coi^KV00Co0000onKVi_oVi^Ko00002ooVi^H00ol0003oi^KVo`000003
onKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko0000:_oVi^H00olI6AWoi^KVonKV
iP0TonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H00ol0003o
i^KVonKViP02o`0000_oi^KV0_lc<c=1onKViP003?oVi^H01?l0003oi^KVonKVi_l00007onKViP07
o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000003onKViP03o`000?oVi^Ko000000?oi^KV00Co0000
onKVi_oVi^Ko0000:?oVi^H2oaTI6BOoi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KV
onKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o00003OoVi^H00olc<c?oi^KVonKViP0n
onKViP003OoVi^H2o`0000Woi^KV0ol00003onKViP?o00000_oVi^H5o`0000;oi^KV00?o0000onKV
i_oVi^H09OoVi^H00olI6AWoi^KVonKViP0WonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko000000ooi^KV0_lc<c<nonKViP00:_oV
i^H00ol0003oi^KVonKViP0SonKViP;o6ATI:ooVi^H2o`0000[oi^KV0_l00003onKViP?o00000_oV
i^H2o`00013oi^KV00?o<c<conKVi_oVi^H0>ooVi^H002[oi^KV00?o0000onKVi_oVi^H08OoVi^H2
oaTI6Bgoi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP?o000000?oi^KV
o`000?oVi^H04OoVi^H2oc<c<c_oi^KV000=onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKV
iP?o00000ooVi^H2o`0000Coi^KV0ol00003onKViP03o`000?oVi^Koi^KV023oi^KV00?o6ATIonKV
i_oVi^H0;?oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?o
0000onKVi_oVi^H00_l0000ConKViP;o<c<c>OoVi^H000coi^KV00Co0000onKVi_oVi^Ko00001ooV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01?l0003o
i^KVonKVi_l0000PonKViP;o6ATI;ooVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Ko
i^KVo`000?oVi^H01Ol000000ooVi^Ko0000onKViP0EonKViP03oc<c<ooVi^Koi^KV03Koi^KV000<
onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVo`00
0003onKViP04o`000?oVi^Koi^KVo`0001koi^KV0_lI6ATaonKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP03o`000?oVi^Koi^KV00;o00005_oVi^H2
oc<c<cKoi^KV000<onKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00003onKViPCo00000_oVi^H3
o`0000?oi^KV00?o0000onKVi_oVi^H06ooVi^H00olI6AWoi^KVonKViP0aonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVo`000002onKViP03o`00
0?oVi^Koi^KV01Ooi^KV00?o<c<conKVi_oVi^H0<ooVi^H000coi^KV00Co0000onKVi_oVi^Ko0000
2ooVi^H00ol0003oi^KVo`000003onKViP03o`000?oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko
00006ooVi^H2oaTI6CCoi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003
onKViP;o00000_oVi^H2o`0001Woi^KV0_lc<c<conKViP003?oVi^H01?l0003oi^KVonKVi_l00007
onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000003onKViP03o`000?oVi^Ko000000?oi^KV
00Co0000onKVi_oVi^Ko00006_oVi^H00olI6AWoi^KVonKViP0eonKViP;o00002_oVi^H2o`0000Go
i^KV00Co0000onKVi_oVi^Ko00007?oVi^H2oc<c<c7oi^KV000=onKViP;o00002OoVi^H3o`0000?o
i^KV0ol00003onKViP?o00000ooVi^H00ol0003oi^KVonKViP0FonKViP;o6ATIC_oVi^H2o`0001go
i^KV00?o<c<conKVi_oVi^H0;_oVi^H002[oi^KV00?o0000onKVi_oVi^H05?oVi^H2oaTI6C[oi^KV
0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o00000_oVi^H2o`0001koi^KV
0_lc<c<^onKViP00:_oVi^H00ol0003oi^KVonKViP0ConKViP03oaTI6OoVi^Koi^KV03Woi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKV
i_l000008OoVi^H00olc<c?oi^KVonKViP0[onKViP00:_oVi^H00ol0003oi^KVonKViP0AonKViP;o
6ATI??oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H01?l0003oi^KVo`000?l0000QonKViP;o<c<c:ooVi^H000goi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00;oi^KV0ol00003onKViP;o00001?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H04?oV
i^H00olI6AWoi^KVonKViP0lonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko
0000onKViP04o`0000;oi^KV00?o0000onKVi_oVi^H08_oVi^H00olc<c?oi^KVonKViP0XonKViP00
3?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H00ol0
003oi^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_l000004?oVi^H2oaTI6Cooi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Goi^KV0_l0000TonKViP;o
<c<c:?oVi^H000coi^KV00Co0000onKVi_oVi^Ko00002ooVi^H00ol0003oi^KVonKViP03onKViP03
o`000?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko00003_oVi^H2oaTI6D7oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o
0000onKVi_oVi^H09OoVi^H2oc<c<bKoi^KV000<onKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l0
0003onKViPCo00000_oVi^H4o`0000;oi^KV00?o0000onKVi_oVi^H02ooVi^H00olI6AWoi^KVonKV
iP12onKViP;o00002_oVi^H2o`0000Coi^KV0_l00002onKViP;o0000:?oVi^H00olc<c?oi^KVonKV
iP0SonKViP003?oVi^H01?l0003oi^KVonKVi_l0000;onKViP03o`000?oVi^Ko000000?oi^KV00?o
0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00004onKViP?o00001?oVi^H2oaTI6@;oi^KV
1Ol00003onKViP03o`000?oVi^Koi^KV00?oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV
0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViPGo00004_oVi^H2o`0000Coi^KV
00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol00002onKViP03o`000?oVi^Koi^KV02Soi^KV
0_lc<c<SonKViP003?oVi^H01?l0003oi^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKVi_l0
003oi^KVo`000003onKViP03o`000?oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H0
1?l0003oi^KVonKVi_oVi^H2oaTI6@Goi^KV0_l000000ooVi^Ko0000onKViP09onKViP03o`000?oV
i^Koi^KV00Ooi^KV00Go0000onKVi_l0003oi^KVo`000007onKViP05o`000?oVi^Koi^KVonKVi_l0
00000ooVi^H01?l0003oi^KVonKVi_l0000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0002_oi^KV00?o<c<conKVi_oV
i^H08?oVi^H000goi^KV0_l00009onKViP?o00000ooVi^H3o`0000?oi^KV0ol00003onKViP03o`00
0?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko6ATI2?oVi^H00ol0003oi^KVonKViP07onKViPGo
00002?oVi^H01Ol0003oi^KVo`000?oVi^Ko000000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000004
onKViP03o`000?oVi^Koi^KV017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKV
i_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o0000;?oVi^H2oc<c<b3oi^KV000ZonKViP03
o`000?oVi^Koi^KV00?oi^KV00?o0000oaTI6OlI6AT02OoVi^H2o`0000Soi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H4o`0000Woi^KV0ol00006onKViP03o`000?oVi^Koi^KV013oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000_oVi^H00ol0003oi^KVonKV
iP0]onKViP;o<c<c7_oVi^H002[oi^KV00?o0000onKVi_oVi^H00ooVi^H00olI6AWoi^KVonKViP07
onKViP05o`000?oVi^Ko0000onKVi_l000002?oVi^H00ol0003oi^KVo`000009onKViP03o`000?oV
i^Ko000000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l0
00004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H01?l0003oi^KVo`000?l0000`onKViP03oc<c<ooVi^Koi^KV01_oi^KV000ZonKViP04o`000?oV
i^Koi^KVonKViP;o6ATI00?o0000onKVi_oVi^H01ooVi^H3o`000003onKVi_l0003oi^KV00Soi^KV
0_l0000:onKViP;o00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oV
i^Koi^KVo`00000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKV
i_l00003onKViP03o`000?oVi^Ko000003;oi^KV0_lc<c<KonKViP00:_oVi^H01?l0003oi^KVoaTI
6OlI6AT2onKViP03o`000?oVi^Koi^KV00Soi^KV0ol0000;onKViP03o`000?oVi^Koi^KV00Woi^KV
0_l00009onKViP?o00001?oVi^H3o`0001?oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000;oi^KV
0_l0000conKViP03oc<c<ooVi^Koi^KV01Soi^KV000ZonKViP03o`000?lI6AWoi^KV05Koi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV03?oi^KV0_lc
<c<HonKViP00:?oVi^H2o`000003oaTI6Ol0003o000003oo00005_oVi^H01?l0003oi^KVonKVi_l0
0009onKViP04o`000?oVi^Koi^KVonKViP;o0000=_oVi^H2oc<c<aKoi^KV000ZonKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00002onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKV
iP04o`000?oVi^Koi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKV
iP0FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00000ionKViP03
oc<c<ooVi^Koi^KV01?oi^KV0022onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oV
i^Koi^KV0_l0000ionKViP03oc<c<ooVi^Koi^KV01;oi^KV0022onKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP00P_oVi^H01?l0003oi^KVonKVi_l00008
onKViP;o0000DooVi^H008?oi^KV0_l0000:onKViP03o`000?oVi^Koi^KV057oi^KV000lonKViP;o
00000_oVi^H3o`0000;oi^KV00?o0000onKVi_l000000_l00003onKViP?o00000ooVi^H3o`0008go
i^KV000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KV
onKViP16onKViPCo00000_oVi^H5o`0000?oi^KV0_l00002onKViP;o000000?oi^KVo`000?l00000
1?l00004onKViP?o00008_oVi^H003[oi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVo`00
0002onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KVonKViP03onKViP03o`00
0?oVi^Koi^KV04Ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKV
iP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP04o`00
0?oVi^Koi^KVo`00027oi^KV000jonKViP03o`000?oVi^Koi^KV00Coi^KV0ol00002onKViP05o`00
0?oVi^Koi^KVonKVi_l000000ooVi^H2o`0000Coi^KV0_l0001:onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP03onKViPGo00000_oVi^H00ol0
003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV01ooi^KV000jonKViP03o`000?oVi^Koi^KV00Co
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00?o
0000onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000_oVi^H00ol0003oi^KV
onKViP04onKViP03o`000?oVi^Ko000000?oi^KV0ol00004onKViP;o00008_oVi^H003_oi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04Ooi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00Coi^KV
00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV02;o
i^KV000lonKViP?o000000?oi^KVo`000?l000000_l00003onKViP?o00001?oVi^H3o`0000?oi^KV
0ol00019onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0
003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H01?l0003oi^KVonKVi_l0000QonKViP00WooVi^H4o`0000;oi^KV1Ol00003onKViP?o00000_oV
i^H2o`0000?oi^KV1?l00004onKViP?o00008OoVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV
003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H005[o
i^KV1?l00025onKViP00FooVi^H2o`0008Koi^KV001KonKViP;o0000Q_oVi^H003ooi^KV1Ol00002
onKViPCo00002OoVi^H5o`0000?oi^KV1Ol00002onKViP?o000000?oi^KVo`000?l000000_l00000
0ooVi^Ko0000o`000004o`0000;oi^KV0_l000000ooVi^Ko0000o`000002o`000003onKVi_l0003o
000000;o00001OoVi^H4o`0000;oi^KV3?l000000ooVi^Ko0000o`000004o`000003onKVi_l0003o
000000Go0000?_oVi^H003koi^KV0_l00003onKViP;o00000_oVi^H2o`0000Woi^KV0_l00003onKV
iP;o00000_oVi^H2o`0000;oi^KV1?l00002onKViP04o`000?oVi^Ko0000o`0000;oi^KV0_l00000
0ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o
000000Ooi^KV0_l00002onKViP?o000000Coi^KVo`000?l0003oi^KV0_l00002onKViP;o000000?o
i^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000onKVi_l000000_oVi^H2o`0003goi^KV
000monKViP;o00001?oVi^H2o`0000;oi^KV0_l00008onKViP;o00001OoVi^H2o`000003onKVi_l0
003o000000;oi^KV1?l00004onKViP;o00000_oVi^H2o`000003onKVi_l0003o000000;oi^KV0_l0
00000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000001ooVi^H2o`000004onKVi_l0
003o0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l00000
0_oVi^H2o`000003onKVi_l0003o000000?oi^KV0ol0000monKViP00?OoVi^H2o`0000?oi^KV1?l0
00000ooVi^Ko0000o`000003o`0000Goi^KV0_l00005onKViP;o000000?oi^KVo`000?l000000_oV
i^H7o`000003onKVi_l0003o000000Coi^KV0ol00002onKViP;o000000?oi^KVo`000?l000000_oV
i^H2o`000003onKVi_l0003o000000Ooi^KV1Ol00005onKViP?o00000_oVi^H2o`000003onKVi_l0
003o000000;oi^KV1?l00002onKViP?o0000?ooVi^H003goi^KV0_l00008onKViP;o00000_oVi^H2
o`0000Coi^KV0_l00005onKViP;o000000Goi^KVo`000?l0003o0000onKViP04o`000004onKVi_l0
003o0000onKViPKo000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000;oi^KV
0_l000000ooVi^Ko0000o`000002o`0000Goi^KV0_l00003onKViP;o000000Coi^KVo`000?l0003o
i^KV0_l00002onKViPGo00000_oVi^H2o`0000;oi^KV00Co0000onKVi_l0003o00000_oVi^H00ol0
003oi^KVonKViP0konKViP00?OoVi^H2o`0000Goi^KV00?o0000onKVi_oVi^H00_l00002onKViP;o
00001?oVi^H2o`0000Goi^KV1Ol000000ooVi^Ko0000o`000002onKViP?o000000Ooi^KVo`000?l0
003o0000onKVi_l0003oi^KV00?o00000_oVi^H4o`000003onKVi_l0003o000000;o000000Koi^KV
o`000?l0003o0000onKVi_l00005onKViP;o00000ooVi^H2o`0000;oi^KV0ol00002onKViP?o0000
00?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000o`000?oVi^H01?l0000monKViP00
?_oVi^H2o`0000?oi^KV0_l00002onKViP;o00000_oVi^H2o`0000Goi^KV0_l00003onKViP;o0000
6OoVi^H2o`00017oi^KV0_l00003onKViP;o00003ooVi^H2o`0004Koi^KV000oonKViPCo000000?o
i^KVo`000?oVi^H01_l00007onKViPGo00006ooVi^H00ol0003oi^KVonKViP0>onKViPOo00003ooV
i^H3o`0004Koi^KV003SonKViP00hooVi^H00001\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {0.29701, \
-0.0445132, 0.0169706, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-1.51089, -0.0890264, 0.0169706, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {0.48719, -0.711658, 0.0149074, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-1.45998, -0.725265, 0.0169706, 0.0112719}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {0.29701, -0.306114, 0.0169706, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-1.51089, -0.406114, 0.0169706, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {0.327639, 0.374463, \
0.0158612, 0.000102656}, {{118.125, 214.938}, {82.9375, 23.0625}} -> \
{-1.51089, -0.587, 0.0169706, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 0.396`}\\)}, \
{\\({DECAPS, 0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, \
{\\({MUTAT, 1}\\)}, {\\({PERM, 0.6105`}\\)}, {\\({REPRO, 0.1`}\\)}, \
{\\({SHRINK, 0.1`}\\)}}, ColumnAlignments -> Left, GridBaseline -> {Baseline, \
{1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[nop]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(3\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 0 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.73232 .00576 0 -8.88217 ]
[.73232 .00576 10.625 5.11783 ]
[.82929 .11766 0 -8.64429 ]
[.82929 .11766 10.625 5.35571 ]
[.90783 .2083 0 -8.4598 ]
[.90783 .2083 10.625 5.5402 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.71869 .00942 m
.71188 .01126 L
s
gsave
.73232 .00576 -61 -12.8822 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.81556 .12089 m
.80869 .1225 L
s
gsave
.82929 .11766 -61 -12.6443 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.89402 .21118 m
.88711 .21262 L
s
gsave
.90783 .2083 -61 -12.4598 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.20094 .26526 m
.17108 .92509 L
s
.3187 .33116 m
.30103 .93802 L
s
.41866 .3871 m
.40989 .94886 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.37834 .33225 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.42785 .32211 m .57042 .37159 L .52233 .38044 L F
.37834 .33225 m .42785 .32211 L .52233 .38044 L F
.47874 .31169 m .61975 .36251 L .57042 .37159 L F
.42785 .32211 m .47874 .31169 L .57042 .37159 L F
.53107 .30097 m .67039 .35318 L .61975 .36251 L F
.47874 .31169 m .53107 .30097 L .61975 .36251 L F
.58489 .28995 m .72237 .34361 L .67039 .35318 L F
.53107 .30097 m .58489 .28995 L .67039 .35318 L F
.64027 .27861 m .77575 .33379 L .72237 .34361 L .5 0 1 r
F
.58489 .28995 m .64027 .27861 L .72237 .34361 L 1 0 0 r
F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .36594 .91971 L p F P
0 0 0 r
s
.69728 .26693 m .8306 .32369 L .77575 .33379 L 0 1 1 r
F
.64027 .27861 m .69728 .26693 L .77575 .33379 L .5 0 1 r
F
.2636 .26511 m .42785 .32211 L .37834 .33225 L 1 0 0 r
F
.57295 .92839 m .52132 .93033 L .41921 .91747 L p F P
0 0 0 r
s
.36594 .91971 m .41921 .91747 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.756 .25491 m .88697 .31331 L .8306 .32369 L .5 1 0 r
F
.69728 .26693 m .756 .25491 L .8306 .32369 L 0 1 1 r
F
.31595 .25303 m .47874 .31169 L .42785 .32211 L .5 0 1 r
F
.2636 .26511 m .31595 .25303 L .42785 .32211 L 1 0 0 r
F
.62603 .92639 m .57295 .92839 L .47409 .91515 L p F P
0 0 0 r
s
.41921 .91747 m .47409 .91515 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.8165 .24252 m .94492 .30264 L .88697 .31331 L 1 0 0 r
F
.756 .25491 m .8165 .24252 L .88697 .31331 L .5 1 0 r
F
.3699 .24058 m .53107 .30097 L .47874 .31169 L 0 1 1 r
F
.31595 .25303 m .3699 .24058 L .47874 .31169 L .5 0 1 r
F
.68061 .92434 m .62603 .92639 L .53064 .91277 L p 1 0 0 r
F P
0 0 0 r
s
.47409 .91515 m .53064 .91277 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.8165 .24252 m .87887 .22975 L .94492 .30264 L 1 0 0 r
F
.42552 .22775 m .58489 .28995 L .53107 .30097 L 0 1 1 r
F
.3699 .24058 m .42552 .22775 L .53107 .30097 L F
.73675 .92223 m .68061 .92434 L .58895 .91031 L p 1 0 0 r
F P
0 0 0 r
s
.53064 .91277 m .58895 .91031 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.95551 .49559 m .89593 .50379 L .82435 .4493 L p 1 0 0 r
F P
0 0 0 r
s
.89593 .50379 m .85402 .91782 L .76206 .45885 L p .5 1 0 r
F P
0 0 0 r
s
.76206 .45885 m .82435 .4493 L .89593 .50379 L p .5 1 0 r
F P
0 0 0 r
s
.48288 .21451 m .64027 .27861 L .58489 .28995 L 0 1 1 r
F
.42552 .22775 m .48288 .21451 L .58489 .28995 L F
.79453 .92005 m .73675 .92223 L .64909 .90777 L p .5 0 1 r
F P
0 0 0 r
s
.58895 .91031 m .64909 .90777 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.82435 .4493 m .88861 .43944 L .95551 .49559 L p 1 0 0 r
F P
0 0 0 r
s
.54207 .20086 m .69728 .26693 L .64027 .27861 L .5 1 0 r
F
.48288 .21451 m .54207 .20086 L .64027 .27861 L 0 1 1 r
F
.85402 .91782 m .79453 .92005 L .70166 .46812 L p F P
0 0 0 r
s
.64909 .90777 m .70166 .46812 L .79453 .92005 L p .5 0 1 r
F P
0 0 0 r
s
.41921 .91747 m .36594 .91971 L .24006 .90474 L p 1 0 0 r
F P
0 0 0 r
s
.60318 .18676 m .756 .25491 L .69728 .26693 L 1 0 0 r
F
.54207 .20086 m .60318 .18676 L .69728 .26693 L .5 1 0 r
F
.12592 .18455 m .31595 .25303 L .2636 .26511 L 1 0 0 r
F
.70166 .46812 m .76206 .45885 L .85402 .91782 L p 0 1 1 r
F P
0 0 0 r
s
.47409 .91515 m .41921 .91747 L .29663 .90203 L p .5 0 1 r
F P
0 0 0 r
s
.24006 .90474 m .29663 .90203 L .41921 .91747 L p 1 0 0 r
F P
0 0 0 r
s
.66629 .17219 m .8165 .24252 L .756 .25491 L 1 0 0 r
F
.60318 .18676 m .66629 .17219 L .756 .25491 L F
.18133 .16991 m .3699 .24058 L .31595 .25303 L 0 1 1 r
F
.12592 .18455 m .18133 .16991 L .31595 .25303 L 1 0 0 r
F
.53064 .91277 m .47409 .91515 L .36524 .4478 L p 0 1 1 r
F P
0 0 0 r
s
.29663 .90203 m .36524 .4478 L .47409 .91515 L p .5 0 1 r
F P
0 0 0 r
s
.76206 .45885 m .70166 .46812 L .60518 .40619 L p 1 0 0 r
F P
0 0 0 r
s
.70166 .46812 m .64909 .90777 L .54224 .41711 L p .5 1 0 r
F P
0 0 0 r
s
.54224 .41711 m .60518 .40619 L .70166 .46812 L p .5 1 0 r
F P
0 0 0 r
s
.73152 .15714 m .87887 .22975 L .8165 .24252 L 1 0 0 r
F
.66629 .17219 m .73152 .15714 L .8165 .24252 L F
.23859 .15478 m .42552 .22775 L .3699 .24058 L F
.18133 .16991 m .23859 .15478 L .3699 .24058 L 0 1 1 r
F
.58895 .91031 m .53064 .91277 L .42236 .4379 L p F P
0 0 0 r
s
.36524 .4478 m .42236 .4379 L .53064 .91277 L p 0 1 1 r
F P
0 0 0 r
s
.82435 .4493 m .76206 .45885 L .67025 .39491 L p 1 0 0 r
F P
0 0 0 r
s
.60518 .40619 m .67025 .39491 L .76206 .45885 L p 1 0 0 r
F P
0 0 0 r
s
.73152 .15714 m .79898 .14158 L .87887 .22975 L 1 0 0 r
F
.2978 .13914 m .48288 .21451 L .42552 .22775 L F
.23859 .15478 m .2978 .13914 L .42552 .22775 L F
.64909 .90777 m .58895 .91031 L .48133 .42767 L p 0 1 1 r
F P
0 0 0 r
s
.42236 .4379 m .48133 .42767 L .58895 .91031 L p 0 1 1 r
F P
0 0 0 r
s
.88861 .43944 m .82435 .4493 L .73757 .38324 L p 1 0 0 r
F P
0 0 0 r
s
.67025 .39491 m .73757 .38324 L .82435 .4493 L p 1 0 0 r
F P
0 0 0 r
s
.42236 .4379 m .36524 .4478 L .22934 .3814 L p 1 0 0 r
F P
0 0 0 r
s
.36524 .4478 m .29663 .90203 L .14671 .88315 L p 0 1 1 r
F P
0 0 0 r
s
.14671 .88315 m .22934 .3814 L .36524 .4478 L p 0 1 1 r
F P
0 0 0 r
s
.35907 .12295 m .54207 .20086 L .48288 .21451 L 1 0 0 r
F
.2978 .13914 m .35907 .12295 L .48288 .21451 L F
.48133 .42767 m .54224 .41711 L .64909 .90777 L p 0 1 1 r
F P
0 0 0 r
s
.73757 .38324 m .80726 .37115 L .88861 .43944 L p 1 0 0 r
F P
0 0 0 r
s
.48133 .42767 m .42236 .4379 L .29027 .36926 L p 1 0 0 r
F P
0 0 0 r
s
.22934 .3814 m .29027 .36926 L .42236 .4379 L p 1 0 0 r
F P
0 0 0 r
s
.42251 .10619 m .60318 .18676 L .54207 .20086 L 1 0 0 r
F
.35907 .12295 m .42251 .10619 L .54207 .20086 L F
.29663 .90203 m .24006 .90474 L .08662 .88649 L p F P
0 0 0 r
s
.54224 .41711 m .48133 .42767 L .35338 .35667 L p 1 0 0 r
F P
0 0 0 r
s
.29027 .36926 m .35338 .35667 L .48133 .42767 L p 1 0 0 r
F P
0 0 0 r
s
.48823 .08883 m .66629 .17219 L .60318 .18676 L 1 0 0 r
F
.42251 .10619 m .48823 .08883 L .60318 .18676 L F
.08662 .88649 m .14671 .88315 L .29663 .90203 L p F P
0 0 0 r
s
.60518 .40619 m .54224 .41711 L .41879 .34363 L p 1 0 0 r
F P
0 0 0 r
s
.35338 .35667 m .41879 .34363 L .54224 .41711 L p 1 0 0 r
F P
0 0 0 r
s
.55636 .07083 m .73152 .15714 L .66629 .17219 L 1 0 0 r
F
.48823 .08883 m .55636 .07083 L .66629 .17219 L F
.67025 .39491 m .60518 .40619 L .48663 .3301 L p F P
0 0 0 r
s
.41879 .34363 m .48663 .3301 L .60518 .40619 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .79898 .14158 L .73152 .15714 L 1 0 0 r
F
.55636 .07083 m .62703 .05216 L .73152 .15714 L F
.73757 .38324 m .67025 .39491 L .55704 .31606 L p F P
0 0 0 r
s
.48663 .3301 m .55704 .31606 L .67025 .39491 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .70039 .03278 L .79898 .14158 L 1 0 0 r
F
.80726 .37115 m .73757 .38324 L .63017 .30148 L p F P
0 0 0 r
s
.55704 .31606 m .63017 .30148 L .73757 .38324 L p 1 0 0 r
F P
0 0 0 r
s
.63017 .30148 m .70619 .28632 L .80726 .37115 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00001Golc<c003o`000?o<
c<coc<c<04Ooc<c<0Oooool006Soc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<o`00
0003olc<c0;o000000Goc<c<o`000?o<c<coc<c<o`000003olc<c003o`000?o<c<coc<c<05Coc<c<
00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`01?l0003oc<c<o`000?o<c<`2o`0000?oc<c<
0ol000001?o<c<co0000olc<c?l00002olc<c005o`000?o<c<coc<c<olc<c?l00000BOo<c<`3o`00
00[oc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00
J?o<c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<co000001coc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01coc<c<1?l000000oo<c<co0000
olc<c003olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00UOo<
c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<01Soc<c<1?l00005olc<c003o`000?o<
c<coc<c<00;oc<c<0_l00008olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Goc<c<00?o0000
olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c00Eolc<c0Co00003oo<c<`00ol0003oc<c<olc<c003
olc<c0?o0000BOo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c004olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Koc<c<00?o0000olc<c?o<
c<`01?o<c<`5o`00013oc<c<1?l0000Iolc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<
c<`0Aoo<c<`1ooooo`00Uoo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00ooc<c<
0ol00002olc<c003o`000?o<c<coc<c<01Woc<c<00?o0000olc<c?o<c<`0C?o<c<`1ooooo`00V?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00[oc<c<1?l0000Rolc<c003o`000?o<
c<coc<c<04_oc<c<0Oooool009?oc<c<1_l00005olc<c0Go00001?o<c<`4o`000003olc<c?l0003o
c<c<01Soc<c<0_oo0009olc<c003o`000?o<c<coc<c<04_oc<c<0Oooool00:Coc<c<0ol00005olc<
c003o`000?o<c<coc<c<01Coc<c<1_oo0009olc<c003o`000?o<c<coc<c<04[oc<c<0Oooool007?o
c<c<1?l0000Yolc<c0Go00006_o<c<`;ool000Woc<c<00?o0000olc<c?o<c<`0BOo<c<`1ooooo`00
L_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<02;oc<c<1?l00004olc<c003o`00
0?o<c<coc<c<01Goc<c<3ooo0009olc<c003o`000?o<c<coc<c<04Soc<c<0Oooool007Ooc<c<00?o
0000olc<c?o<c<`07oo<c<`3o`0001goc<c<4ooo0009olc<c003o`000?o<c<coc<c<04Ooc<c<0Ooo
ool007Ooc<c<00?o0000olc<c?o<c<`06oo<c<`4o`0000;oc<c<00?o0000olc<c?o<c<`05oo<c<`H
ool000Woc<c<00?o0000olc<c?o<c<`0A_o<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01Ooc<c<1?l00006olc<c003o`000?o<c<coc<c<01?oc<c<7Ooo0009olc<
c003o`000?o<c<coc<c<04Goc<c<0Oooool007;oc<c<1Ol0000Golc<c0?o00000_o<c<`00ol0003o
c<c<olc<c00Folc<c2?oo`002?o<c<`00ol0003oc<c<olc<c015olc<c07ooooo001bolc<c003o`00
0?o<c<coc<c<01Goc<c<1?l0000Jolc<c2Soo`002?o<c<`00ol0003oc<c<olc<c014olc<c07ooooo
001colc<c003o`000?o<c<coc<c<013oc<c<1?l000000oo<c<co0000olc<c00Golc<c2coo`002Oo<
c<`00ol0003oc<c<olc<c013olc<c07ooooo001colc<c0Go00002oo<c<`3o`0001[oc<c<<Ooo0009
olc<c003o`000?o<c<coc<c<04;oc<c<0Oooool007ooc<c<1?l000000oo<c<co0000olc<c00Folc<
c3Koo`002Oo<c<`00ol0003oc<c<olc<c011olc<c07ooooo0019olc<c0Ko00000_o<c<`00ol0003o
c<c<olc<c004o`0002?oc<c<1?l0000Iolc<c3_oo`002Oo<c<`00ol0003oc<c<olc<c010olc<c07o
oooo0019olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c00Molc<c0?o000000?oc<c<o`000?o<c<`05_o<c<a0ool000Woc<c<00?o0000olc<c?o<c<`0
?oo<c<`1ooooo`00B_o<c<`00ol0003oc<c<olc<c00;olc<c003o`000?o<c<coc<c<01Woc<c<1?l0
0004olc<c003o`000?o<c<coc<c<017oc<c<AOoo0009olc<c003o`000?o<c<coc<c<03koc<c<0Ooo
ool004_oc<c<0_l0000;olc<c003o`000?o<c<coc<c<01Koc<c<0ol000000oo<c<co0000olc<c00E
olc<c4[oo`002?o<c<`00ol0003oc<c<olc<c00nolc<c07ooooo001=olc<c003o`000?o<c<coc<c<
00?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001?o<c<`00ol0
003oc<c<olc<c00@olc<c4ooo`002?o<c<`00ol0003oc<c<olc<c007olc<c0Ko0000<?o<c<`1oooo
o`00C_o<c<`00ol0003oc<c<olc<c002olc<c0Go00004Oo<c<`5o`0001Koc<c<Dooo0009olc<c003
o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0<oo<c<`1ooooo`00BOo<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04?o<c<`3o`0000Coc<c<
00?o0000olc<c?o<c<`04?o<c<aHool000Woc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<
olc<c00bolc<c07ooooo0019olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<
c<`00ol0003oc<c<olc<c00;olc<c0Go00005_o<c<aLool000Woc<c<00?o0000olc<c?o<c<`01_o<
c<`2o`0003;oc<c<0Oooool004[oc<c<1?l00006olc<c0Go00001Oo<c<`4o`0000Coc<c<00?o0000
olc<c?o<c<`04?o<c<aQool000Soc<c<0_l00009olc<c003o`000?o<c<coc<c<02ooc<c<0Oooool0
02ooc<c<1?l0000Xolc<c0?o000000?oc<c<o`000?o<c<`05?o<c<aVool000Woc<c<00?o0000olc<
c?o<c<`01oo<c<`00ol0003oc<c<olc<c00^olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;o
c<c<00?o0000olc<c?o<c<`08Oo<c<`4o`0001Koc<c<Jooo0009olc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c00^olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;o
c<c<00?o0000olc<c?o<c<`07Oo<c<`4o`000003olc<c?l0003oc<c<01Coc<c<Kooo0008olc<c005
o`000?o<c<coc<c<olc<c?l000001?o<c<`00ol0003oc<c<olc<c00Eolc<c0Co000000Coc<c<o`00
0?o<c<coc<c<1?l00002olc<c007o`000?o<c<coc<c<olc<c?l0003oc<c<o`000004olc<c07ooooo
000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`06_o<c<`3o`0001Ooc<c<M?oo
0008olc<c004o`000?o<c<coc<c<olc<c0Co00005oo<c<`00ol0003oc<c<olc<c002olc<c0;o0000
00?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<o`000003olc<c003o`000?o<c<coc<c<00Coc<c<
0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Folc<c0Co000000?o
c<c<o`000?o<c<`04oo<c<aiool000Soc<c<00?o0000olc<c?o<c<`06_o<c<`00ol0003oc<c<olc<
c004olc<c003o`000?o<c<co000000Koc<c<00Go0000olc<c?o<c<coc<c<o`000006olc<c07ooooo
000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`4o`0000Goc<c<00?o
0000olc<c?o<c<`03oo<c<alool000Woc<c<00?o0000olc<c?o<c<`06Oo<c<`00ol0003oc<c<olc<
c004olc<c003o`000?o<c<co000000Go000000?oc<c<o`000?o<c<`00_o<c<`00ol0003oc<c<olc<
c004olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03oo<c<`3
o`0000;oc<c<00?o0000olc<c?o<c<`04_o<c<b1ool000Woc<c<00?o0000olc<c?o<c<`06?o<c<`0
1?l0003oc<c<olc<c?o<c<`4o`000003olc<c?l0003oc<c<00?oc<c<00?o0000olc<c?l000000oo<
c<`00ol0003oc<c<olc<c004olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000
olc<c?o<c<`02oo<c<`4o`0001Ooc<c<QOoo0009olc<c003o`000?o<c<coc<c<01Ooc<c<00?o0000
olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c002olc<c004o`000?o<c<co0000o`0000;oc<c<00?o
0000olc<c?o<c<`01?o<c<`1ooooo`00;oo<c<`4o`0000[oc<c<1?l00003olc<c003o`000?o<c<co
c<c<017oc<c<1?l0oon6ool000Woc<c<00?o0000olc<c?o<c<`05_o<c<`00ol0003oc<c<olc<c004
olc<c003o`000?o<c<coc<c<00Co00000_o<c<`01?l0003oc<c<o`000?l00007olc<c07ooooo000j
olc<c0Co00005oo<c<`8o`3oohKoo`002?o<c<`00ol0003oc<c<olc<c00Golc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`1ooooo`00=_o<c<`4o`0000?oc<c<00?o0000olc<
c?o<c<`04_o<c<`=o`3oohGoo`002?o<c<`00ol0003oc<c<olc<c00Golc<c0Co00005Oo<c<`1oooo
o`00<_o<c<`4o`000003olc<c?l0003oc<c<01Koc<c<4_l0oon4ool000Soc<c<00?o0000olc<c?o<
c<`0;oo<c<`1ooooo`00;oo<c<`3o`0001Woc<c<1?oo000Co`3oohCoo`002?o<c<`00ol0003oc<c<
olc<c00^olc<c07ooooo000]olc<c0;o000000?oc<c<o`000?o<c<`05?o<c<`;ool001?o0?ooPooo
0008olc<c003o`000?o<c<coc<c<02goc<c<0Oooool002goc<c<00Co0000olc<c?o<c<co00004Oo<
c<`@ool001?o0?ooPooo0008olc<c003o`000?o<c<coc<c<02coc<c<0Oooool002goc<c<00Co0000
olc<c?o<c<coIVIV4Oo<c<`Bool001?o0?ooP_oo0008olc<c003o`000?o<c<coc<c<02_oc<c<0Ooo
ool002goc<c<0_l000000oo<c<coIVIVolc<c00Bolc<c1;oo`004ol0oom6ool000CoOol0=_oo0009
olc<c003o`000?o<c<coc<c<00Ooc<c<1?l0000Oolc<c07ooooo000]olc<c004o`000?o<c<coc<c<
ofIVIQCoc<c<4_oo000Co`3ood3oo`002_moo`0fool000Soc<c<00?o0000olc<c?o<c<`01_o<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01coc<c<0Oooool002goc<c<00Co0000olc<
c?o<c<coIVIV5_o<c<`Bool001?o0?oo>Ooo000@ogoo03Koo`002?o<c<`00ol0003oc<c<olc<c005
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`07?o<c<`1ooooo`00;Oo<c<`01?l0
003oc<c<olc<c?mVIVHHolc<c1;oo`004_l0oolcool000Co0?oo4_moo`0fool000Soc<c<00?o0000
olc<c?o<c<`02Oo<c<`00ol0003oc<c<olc<c00Lolc<c07ooooo000]olc<c004o`000?o<c<coc<c<
ofIVIQWoc<c<4_oo000Co`3oobcoo`002_l0oolBogoo03Koo`002?o<c<`2o`0000Koc<c<0ol0000O
olc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<4_oo000Co`3oobGoo`004?l0oolB
ogoo03Koo`001_o<c<`00ol0003oc<c<o`000009olc<c003o`000?o<c<coc<c<01coc<c<0Oooool0
02coc<c<00Go0000olc<c?o<c<coc<c<ofIVIP0Molc<c1;oo`004_l0oolPool001Ko0?oo4_moo`0e
ool000Soc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<01coc<c<0Ooo
ool002coc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`Bool001?o0?oo6Ooo000Lo`3ooa;oOol0=Ooo
0008olc<c004o`000?o<c<coc<c<o`0000Coc<c<00?o0000olc<c?o<c<`07?o<c<`1ooooo`00;?o<
c<`01?l0003oc<c<olc<c?mVIVHQolc<c1;oo`004_l0oolDool0027o0?oo4_moo`0eool000Soc<c<
00?o0000olc<c?o<c<`01?l0000Oolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIR?oc<c<
4_oo000Bo`3oo`koo`009ol0oolAogoo03Goo`001oo<c<`00ol0003oc<c<olc<c00Solc<c07ooooo
000/olc<c004o`000?o<c<coc<c<ofIVIRCoc<c<4_oo000Co`3oo`Ooo`00;Ol0oolAogoo03Coo`00
2?o<c<`00ol0003oc<c<olc<c00Rolc<c07ooooo000/olc<c0;o000000?oc<c<ofIVI_o<c<`09Oo<
c<`Bool001;o0?oo0_oo000bo`3ooa7oOol0=?oo0008olc<c003o`000?o<c<coc<c<027oc<c<0Ooo
ool002coc<c<00Co0000olc<c?o<c<coIVIV:?o<c<`Bool000ko0?oo1?mo0?ldo`3ooa3oOol0=?oo
0008olc<c003o`000?o<c<coc<c<023oc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV:Oo<
c<`Bool000So0?oo2_mo0?ldo`3ooa7oOol07ooo0003ogoo017oo`002?o<c<`00ol0003oc<c<olc<
c00Oolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIR_oc<c<4_oo0002o`3ooa3oO`3o<ol0
oolAogoo01Woo`002Omoo`0Aool000Soc<c<00?o0000olc<c?o<c<`07_o<c<`1ooooo`00;?o<c<`0
1?l0003oc<c<olc<c?mVIVH]olc<c1;oo`004Omo0?ldo`3ooa3oOol04ooo000?ogoo017oo`002?o<
c<`00ol0003oc<c<olc<c00Molc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIRkoc<c<4_oo
000Bogl0oc?o0?oo4?moo`0>ool000Co0?oo4?moo`0Aool000Ooc<c<00?o0000olc<c?o<c<`07Oo<
c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHRolc<c003ofIVI_o<c<coc<c<00_oc<c<4_oo
000Aogl0oc?o0?oo4?moo`08ool000[o0?oo4?moo`0Aool000Ooc<c<00?o0000olc<c?o<c<`07?o<
c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHRolc<c003ofIVI_o<c<coc<c<00goc<c<4Ooo
000Bogl0oc?o0?oo3omoo`02ool0013o0?oo4?moo`0Aool000Ooc<c<00?o0000olc<c?o<c<`02oo<
c<`00ol0003oc<c<olc<c00=olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIR;oc<c<00?o
IVIVolc<c?o<c<`03oo<c<`Aool0017oO`3o<ol0ool;ogoo00GoO`3o4Ol0ool@ogoo017oo`001oo<
c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<00goc<c<0Oooool002coc<c<00Co0000
olc<c?o<c<coIVIV8_o<c<`00omVIVKoc<c<olc<c00@olc<c17oo`004_mo0?lbo`3oo`?oOol03Omo
0?lAo`3ooa3oOol04Ooo0007olc<c003o`000?o<c<coc<c<00Goc<c<1_l0000>olc<c07ooooo000/
olc<c0;o000000?oc<c<ofIVI_o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Bolc<c17oo`004Omo0?l_
o`3oo`Coo`003omo0?lAo`3ooa3oOol04Ooo0007olc<c003o`000?o<c<coc<c<00Coc<c<00Go0000
olc<c?o<c<coc<c<o`00000?olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIR?oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`@ool0017oO`3o:Ol0ool:ool000[oO`3o1?l000000omo0?oo0?ooo`3o
o`0?o`3ooa3oOol04Ooo0006olc<c0;o00001_o<c<`01?l0003oc<c<olc<c?l0000?olc<c07ooooo
000[olc<c004o`000?o<c<coc<c<ofIVIR?oc<c<00?oIVIVolc<c?o<c<`05_o<c<`@ool0017oO`3o
8ol0ool?ool000CoO`3o1Ol00004ool00003o`000?mo0?ooO`3o013o0?oo4?moo`0Aool000Ooc<c<
00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<o`00000?olc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIR?oc<c<00?oIVIVolc<c?o<c<`05oo<c<`Aool0013oO`3o7_l0oolCool000Co0000
2_oo00000ol0003oO`3oogl0o`0Ao`3oo`ooOol04Ooo0003olc<c003ofIVI_o<c<coc<c<00Ooc<c<
00?o0000olc<c?l000003oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHSolc<c003ofIV
I_o<c<coc<c<01Woc<c<4?oo000Aogl0oaOo0?oo4ooo0005o`0000ooo`0000?o0000ogl0oomo0?l0
4Ol0ool?ogoo017oo`000_o<c<`00omVIVKoc<c<olc<c008olc<c0;o00003oo<c<`1ooooo`00:oo<
c<`01?l0003oc<c<olc<c?mVIVHSolc<c003ofIVI_o<c<coc<c<01_oc<c<4?oo000@ogl0oa;o0?oo
4_oo0005o`0001Goo`0000Co0000ogl0oomo0?ooO`3o4?l0ool?ogoo017oo`0000?oc<c<ofIVI_o<
c<`02_o<c<`00ol0003oc<c<olc<c00=olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIR?o
c<c<00?oIVIVolc<c?o<c<`07Oo<c<`?ool0017oO`3o2ol0oolAool000Ko00006ooo0002o`0000;o
O`3o4?l0ool?ogoo00koo`000oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`00
0?o<c<coc<c<ofIVIR;oc<c<00?oIVIVolc<c?o<c<`07oo<c<`@ool0013oO`3o0ol0oolCool000Go
00003?oo00000ol0003oo`00ool0000Dool00003o`000?mo0?ooO`3o013o0?oo3omoo`08ool000So
c<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHRolc<c003
ofIVI_o<c<coc<c<027oc<c<3ooo000=ogl0oa?oo`001Ol0000Bool000;o00005Ooo00000ol0003o
O`3oogl0o`0@o`3oo`ooOol00_oo000=olc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool002_oc<c<
00Co0000olc<c?o<c<coIVIV8_o<c<`00omVIVKoc<c<olc<c00Solc<c0ooo`001omo0?lCool000Co
00006Ooo00000ol0003oo`00ool0000Cool00004o`000?mo0?ooO`3oogl0o`oo0?oo2omoo`0Bolc<
c003ofIVI_o<c<coc<c<01Woc<c<0Oooool002_oc<c<0_mVIVH00ol0003oIVIVolc<c00Qolc<c003
ofIVI_o<c<coc<c<02Goc<c<3_oo0002ogl0oa;oo`001Ol00009ool000;o00004ooo0002o`0001Co
o`0000Co0000ogl0oomo0?ooO`3o3ol0ool3ogoo01Woc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1oooo
o`008?o<c<`4o`0000Ooc<c<00Co0000olc<c?mVIVKoIVIV8_o<c<`00omVIVKoc<c<olc<c00Volc<
c1goo`001?l0000@ool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00004_oo0002o`00
00;oO`3o2ol0oolOolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool001ooc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<00?oIVIV8?o<c<`00omVIVKo
c<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<00coc<c<5_oo0005o`0001Goo`0000?o0000ool00?oo
00004_oo00000ol0003oo`00ool0000Cool00003o`000?mo0?ooO`3o00?o0?oo1?o<c<`00omVIVKo
c<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP;oc<c<0_mVIVHNolc<c003
ofIVI_o<c<coc<c<01Woc<c<00?oIVIVolc<c?o<c<`03_o<c<`?ool000Go00006ooo0002o`0001?o
o`000_l0000Dool00003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKo
c<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`0
1?o<c<`01?l0003oc<c<olc<c?mVIVH4olc<c0?oIVIV6oo<c<`00omVIVKoc<c<olc<c00Iolc<c003
ofIVI_o<c<coc<c<00ooc<c<2Ooo0005o`0000_oo`000_l0000Eool00003o`000?oo003oo`0001;o
o`0000?o0000ool00?oo00004_oo00000ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<023o
c<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`00
0?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV1oo<c<`2ofIVIQWoc<c<00?oIVIVolc<c?o<
c<`06Oo<c<`00omVIVKoc<c<olc<c00Aolc<c0;oo`001Ol0000Bool00003o`000?oo003oo`0001?o
o`000_l0000Cool00003o`000?oo003oo`0001;oo`0000?o0000olc<c?o<c<`01?o<c<`00omVIVKo
c<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c003olc<c005o`000?o<c<coc<c<olc<c?mVIVH02Oo<c<`2ofIVIQOo
c<c<00?oIVIVolc<c?o<c<`06Oo<c<`00omVIVKoc<c<olc<c00>olc<c0Go00006?oo0002o`0001Go
o`0000?o0000ool00?oo00004Ooo0002o`0001?oo`000_l00004olc<c003ofIVI_o<c<coc<c<023o
c<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`00
0?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<coIVIV3?o<c<`2ofIVIQGoc<c<00?oIVIVolc<c?o<
c<`06Oo<c<`00omVIVKoc<c<olc<c009olc<c0Go00002ooo00000ol0003oo`00ool0000Aool000;o
00005?oo0002o`0001?oo`0000?o0000ool00?oo00004_oo00001Ol0003oc<c<olc<c?o<c<coIVIV
02;oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<coIVIV3_o<c<`2ofIVIQ?oc<c<00?oIVIVolc<
c?o<c<`06Oo<c<`00omVIVKoc<c<olc<c004olc<c0Go00004Ooo0002o`0001?oo`0000?o0000ool0
0?oo00004ooo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`0001;oo`0000Co0000olc<
c?o<c<coIVIV8_o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Polc<c0Co00001_o<c<`01?l0
003oc<c<olc<c?mVIVH@olc<c0;oIVIV4Oo<c<`00omVIVKoc<c<olc<c00Iolc<c003ofIVI_o<c<co
000000Co00001?oo00000ol0003oo`00ool0000Aool000;o00004_oo0002o`0001Coo`0000?o0000
ool00?oo00004Ooo0002o`0001?oo`0000?o0000olc<c?mVIVH08_o<c<`00omVIVKoc<c<olc<c00H
olc<c07ooooo000Zolc<c0;o000000?oc<c<ofIVI_o<c<`04Oo<c<`2ofIVIPooc<c<00?oIVIVolc<
c?o<c<`05_o<c<`5o`0000_oo`0000?o0000ool00?oo00004Ooo00000ol0003oo`00ool0000Aool0
0003o`000?oo003oo`0001;oo`000_l0000Cool00003o`000?oo003oo`00017oo`0000?o0000ofIV
I_o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIV
IQCoc<c<0_mVIVH=olc<c003ofIVI_o<c<coc<c<017oc<c<1Ol0000Aool000;o00004_oo0002o`00
01;oo`000_l0000Dool00003o`000?oo003oo`00017oo`000_l0000?ool000Go00008Oo<c<`00omV
IVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQKoc<c<0_mVIVH;olc<
c003ofIVI_o<c<coc<c<00coc<c<1Ol00004ool00003o`000?oo003oo`00017oo`000_l0000Bool0
00;o00004_oo00000ol0003oo`00ool0000Bool000;o00004ooo00000ol0003oo`00ool00007ool0
00Go00001Ooo00000ol0003oc<c<olc<c00Nolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[o
c<c<00Co0000olc<c?o<c<coIVIV6?o<c<`3ofIVIPSoc<c<00?oIVIVolc<c?o<c<`01oo<c<`5o`00
00_oo`000_l0000Bool000;o00004_oo0002o`00017oo`000_l0000Dool00003o`000?oo003oo`00
017oo`0000Co0000ool00?oo003oo`001Ol0000;ool00003o`000?o<c<coc<c<01goc<c<00?oIVIV
olc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c0;oIVIV1_o<c<`0
0omVIVKoc<c<olc<c004olc<c0?o00004_oo0002o`0001;oo`0000?o0000ool00?oo00004Ooo0000
0ol0003oo`00ool0000@ool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00003_oo0006
o`00017oo`0000?o0000olc<c?o<c<`07?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<
c004o`000?o<c<coc<c<ofIVIQgoc<c<0_mVIVH4olc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000
o`3oool000005?oo0002o`00017oo`000_l0000Bool000;o00004Ooo0002o`0001?oo`000_l00009
ool000Go00006?oo0002o`0001coc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0
003oc<c<olc<c?mVIVHOolc<c0;oIVIV00?oc<c<ofIVI_o<c<`01_o<c<`01?l0003o0?ooo`3oool0
ool2o`0001?oo`000_l0000Aool000;o00004_oo0002o`00017oo`000_l0000Cool00004o`000?oo
003oo`00ool000Go00002ooo00000ol0003oo`00ool0000Aool00003o`000?o<c<coc<c<01Woc<c<
00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHQolc<c0;oIVIV
1oo<c<`00ol0003o0?ooo`3oo`03o`3oo`;o00004ooo0002o`00017oo`000_l0000Bool00003o`00
0?oo003oo`00013oo`0000?o0000ool00?oo00003_oo0006o`00017oo`0000?o0000ool00?oo0000
4Ooo00000ol0003oc<c<olc<c00Holc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co
0000olc<c?o<c<coIVIV8_o<c<`3ofIVIPCoc<c<00?o0000o`3oool0ool01_l0ool3o`0001;oo`00
0_l0000Aool000;o00004Ooo0002o`00017oo`000_l00009ool000Go00006?oo0002o`0001;oo`00
00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<
c<coc<c<ofIVIR;oc<c<00?oIVIVolc<c?o<c<`00_mVIVH2olc<c003o`000?l0oooo0?oo00Wo0?oo
0_l0000Bool00003o`000?oo003oo`00013oo`0000?o0000ool00?oo00004?oo0002o`00017oo`00
00Co0000ool00?oo003oo`001Ol0000;ool000;o00004_oo00000ol0003oo`00ool0000@ool000;o
00005oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIR;o
c<c<00?oIVIVolc<c?o<c<`00_o<c<`2ofIVIP03o`000?l0oooo0?oo00_o0?oo0_l0000Aool000;o
00004Ooo0002o`0001;oo`0000?o0000ool00?oo00002ooo0007o`0001;oo`0000?o0000ool00?oo
00004?oo00000ol0003oo`00ool0000Aool00003o`000?o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<
c<`06?o<c<`1ooooo`00:_o<c<`2o`000003olc<c?mVIVKoc<c<027oc<c<00?oIVIVolc<c?o<c<`0
1?o<c<`00ol0003o0?ooo`3oo`0=o`3oo`;o00004Ooo0002o`00017oo`000_l0000Aool000;o0000
1?oo0007o`0000KoOol000?o0000ool00?oo00004Ooo0002o`00017oo`0000?o0000ool00?oo0000
4Ooo00000ol0003oc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002Woc<c<00Go
0000olc<c?o<c<coc<c<ofIVIP0Rolc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool0
3ol0ool2o`00017oo`000_l0000Aool000;o00003ooo00000ol0003oo`00o`000003o`0000koOol0
0_l0000Cool00003o`000?oo003oo`0000ooo`000_l0000Bool00003o`000?o<c<coc<c<01?oc<c<
00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHSolc<c003ofIV
I_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool04Ol0ool2o`00017oo`000_l0000Aool00003o`00
0?oo003oo`0000Ooo`001Ol00002o`3oo`03o`000?moo`3oOol0017oOol00_l0000Bool000;o0000
4Ooo00000ol0003oo`00ool0000@ool000;o00004oo<c<`4ofIVIQKoc<c<0Oooool002Woc<c<00Co
0000olc<c?o<c<coIVIV8oo<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo01Co0?oo
0_l0000Aool000;o00004?oo0002o`0000;oo`001Ol00007o`3oo`03o`000?moo`3oOol001?oOol0
00?o0000ool00?oo00004Ooo00000ol0003oo`00ool0000?ool00003o`000?oo003oo`00017oo`00
00?o0000olc<c?o<c<`02Oo<c<`8ofIVIQWoc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV
8oo<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo01Ko0?oo0ol0000@ool000;o0000
3Ooo0002o`000003ool00?l0003o000000go0?oo00?o0000ogoo0?moo`004omoo`02o`0001;oo`00
00?o0000ool00?oo00003ooo00000ol0003oo`00ool0000Aool00003o`000?o<c<coc<c<00;oc<c<
1_mVIVH7olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV
8oo<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo01Wo0?oo0_l0000@ool000;o0000
1?oo0007o`0001;o0?oo00?o0000ogoo0?moo`005Omoo`02o`00017oo`000_l0000@ool000;o0000
4_oo00001?l0003oIVIVofIVI_mVIVH=olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<
00Co0000olc<c?o<c<coIVIV8oo<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo01_o
0?oo0_l0000=ool000;o000000?oo`00o`000?l000000_l0000:o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`005omoo`000ol0003oo`00ool0000@ool00003o`000?oo003oo`0000oo
o`0000?o0000ool00?oo00003Ooo0005o`0000koc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00
:Oo<c<`01?l0003oc<c<olc<c?mVIVHSolc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3oool0
ool07Ol0ool2o`0000Coo`001ol0000Po`3oo`03o`000?moo`3oOol001SoOol00_l0000Aool000;o
00004?oo00000ol0003oo`00ool00007ool000Go00001Ooo00000ol0003oc<c<olc<c00;olc<c003
ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`00omVIVKo
c<c<olc<c003olc<c003o`000?l0oooo0?oo01oo0?oo1?l0000:o`3oo`03o`000?l0oooo0?oo01[o
0?oo00?o0000ogoo0?moo`006_moo`02o`00017oo`0000?o0000ool00?oo00003_oo00001?l0003o
o`00ool00?oo0005o`0000_oo`0000?o0000olc<c?o<c<`02_o<c<`00omVIVKoc<c<olc<c00Golc<
c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIR?oc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0
003o0?ooo`3oo`0Oo`3oo`03o`000?l0oooo0?oo01[o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000Kogoo0003o`000?oo003oo`0000ooo`000_l0000<ool000Ko00004Ooo00000ol0
003oc<c<olc<c009olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<
c<coIVIV8oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo023o0?oo00?o0000o`3o
ool0ool06_l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001coOol00_l0000Aool0
0003o`000?oo003oo`0000;oo`001ol00005ogoo01?oo`0000?o0000olc<c?o<c<`02?o<c<`00omV
IVKoc<c<olc<c00Golc<c07ooooo000Yolc<c0;o000000?oc<c<ofIVI_o<c<`08_o<c<`00omVIVKo
c<c<olc<c002olc<c003o`000?l0oooo0?oo023o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`007_moo`02o`0000co
o`000ol000000ooo003o0000o`000002o`0000goOol000?o0000ool00?oo00004?oo00000ol0003o
c<c<olc<c007olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<co
IVIV8oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo01oo0?oo00?o0000ogl0ool0
ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`008?moo`000ol0003oo`00ool00002ool000Oo00001?l0ool00ol0003oOol0ogoo000?ogoo00;o
00004Ooo00000ol0003oc<c<olc<c006olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<
00Co0000olc<c?o<c<coIVIV8oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo01oo
0?oo00?o0000ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`008?moo`04o`0000_o0?oo00?o0000ogoo0?moo`004Omoo`000ol0003o
o`00ool0000?ool00003o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00
:Oo<c<`01?l0003oc<c<olc<c?mVIVHSolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0
ool07ol0ool00ol0003oO`3oo`00000>o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo000Pogoo0003o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`004_moo`000ol0003oo`00ool0000?ool00003o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<
c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHRolc<c003ofIVI_o<c<coc<c<00?o
c<c<00?o0000o`3oool0ool07ol0ool00ol0003oO`3oogl0o`0>o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Pogoo0003o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`004_moo`02o`00013oo`0000?o0000olc<c?o<c<`00oo<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIR;oc<c<00?oIVIVolc<c?o<
c<`00_o<c<`00ol0003o0?ooo`3oo`0Po`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol0023oOol000?o0000o`3o
ool0ool03Ol0ool00ol0003oOol0ogoo000Dogoo0003o`000?oo003oo`0000koo`0000?o0000olc<
c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIV
IR?oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0Po`3oo`04o`000?mo0?ooO`3o
o`0000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3o
Ool0023oOol000?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?oo003o
o`0000koo`0000Go0000olc<c?o<c<coc<c<ofIVIP0Iolc<c07ooooo000Xolc<c004o`000?o<c<co
c<c<ofIVIR?oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0Po`3oo`04o`000?mo
0?ooO`3oo`0000ko0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol001koOol000?o0000ogl0ool000003_l0ool00ol0003oOol0ogoo000Fogoo0003o`00
0?oo003oo`0000koo`0000Co0000olc<c?o<c<coIVIV6Oo<c<`1ooooo`00:?o<c<`01?l0003oc<c<
olc<c?mVIVHSolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0ool07ol0ool01Ol0003o
O`3oogl0oomo0?oo000000ko0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol001koOol000?o0000ogl0ool000003_l0ool00ol0003oOol0ogoo000Gogoo
00;o00003ooo00000ol0003oc<c<ofIVIP0Iolc<c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIV
IR?oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0Oo`3oo`03o`000?mo0?ooO`3o
00;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000ogoo0?moo`007_moo`000ol0003oO`3oo`00000?o`3oo`03o`000?moo`3oOol0
01SoOol000?o0000ool00?oo00002_oo0004o`000003olc<c?mVIVKoc<c<01Ooc<c<0Oooool002So
c<c<0ol000000omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0
ool07ol0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001koOol000Co0000ogl0oomo
0?oo00003_l0ool00ol0003oOol0ogoo000Iogoo0003o`000?oo003oo`0000;oo`001ol00005olc<
c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001coc<c<1_l00006olc<c0;oIVIV00?oc<c<ofIVI_o<
c<`08_o<c<`01OmVIVKoc<c<olc<c?o<c<co000002;o0?oo00?o0000ogl0oomo0?l00_mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000Mogoo0004o`000?mo0?ooO`3oo`0000ko0?oo00?o0000ogoo0?moo`006_moo`04
o`0000coc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c009olc<
c003o`000?o<c<coIVIV00;oIVIV8_o<c<`01OmVIVKoc<c<olc<c?o<c<co000002;o0?oo00?o0000
ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Mogoo0004o`000?mo0?ooO`3oo`0000ko0?oo00?o
0000ogoo0?moo`006_moo`000ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Koc<c<0Ooo
ool001goc<c<00?o0000olc<c?o<c<`02?o<c<`01Ol0003oc<c<olc<c?mVIVKoc<c<00?oIVIV7oo<
c<`01OmVIVKoc<c<olc<c?o<c<co000002;o0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo000Mogoo0004o`000?mo0?ooO`3oo`0000ko0?oo00?o0000ogoo0?moo`006_moo`000ol0003o
c<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001koc<c<0_l00008olc<c004o`00
0?o<c<coc<c<ofIVIPCoc<c<0omVIVHLolc<c005ofIVI_o<c<coc<c<olc<c?l000008_l0ool00ol0
003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001goOol000Co0000ogl0oomo0?oo00003ol0ool0
0ol0003oOol0ogoo000Iogoo0003o`000?o<c<coc<c<00goc<c<00?oIVIVolc<c?o<c<`05_o<c<`1
ooooo`008?o<c<`00ol0003oc<c<olc<c005olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<0omVIVHI
olc<c005ofIVI_o<c<coc<c<olc<c?l000008Ol0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
o`3oOol001goOol000Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?moo`3oOol001WoOol0
00?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Qolc<c003o`000?o<
c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV2_o<c<`3ofIVIQKoc<c<00GoIVIVolc<c?o<c<co
c<c<o`00000Qo`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006omoo`000ol0003o
O`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006Omoo`000ol0003o
c<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001coc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIPgoc<c<0omVIVHColc<c004
ofIVI_o<c<coc<c<o`0002;o0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Kogoo
0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Hogoo
0003o`000?o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`2ofIV
IQ7oc<c<00CoIVIVolc<c?o<c<co00008_l0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3o
Ool001_oOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool001SoOol000?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<
c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`00_l00002olc<c003o`000?o<c<coc<c<
00[oc<c<1?l00007olc<c004o`000?o<c<coc<c<ofIVIQ;oc<c<0omVIVH>olc<c004ofIVI_o<c<co
c<c<o`0002;o0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Kogoo0003o`000?mo
0?ooO`3o00;oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Gogoo0003o`000?o<
c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003
olc<c004o`000?o<c<coc<c<o`0001_oc<c<00Co0000olc<c?o<c<coIVIV5Oo<c<`3ofIVIP_oc<c<
00CoIVIVolc<c?o<c<co00008_l0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001[o
Ool000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001Oo
Ool000?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`00
0?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co00006_o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV
01Soc<c<0omVIVH8olc<c004ofIVI_o<c<coc<c<o`0002;o0?oo00?o0000ogl0oomo0?l01_mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000Jogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000Gogoo0003o`000?o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`05_o<c<`1
ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001[oc<c<0_l00000
0oo<c<coIVIVolc<c00Kolc<c0?oIVIV1Oo<c<`01?mVIVKoc<c<olc<c?l0000Qo`3oo`03o`000?mo
0?ooO`3o00OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000ogoo0?moo`006_moo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`005omoo`000ol0003oc<c<olc<c00>olc<c003ofIVI_o<
c<coc<c<01Koc<c<0Oooool000?oc<c<1ol00002olc<c003o`000?o<c<coc<c<01Soc<c<00Co0000
olc<c?o<c<coIVIV7oo<c<`3ofIVIP;oc<c<00CoIVIVolc<c?o<c<co00008Ol0ool00ol0003oO`3o
ogl0o`07ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?moo`3oOol001[oOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol001OoOol000?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<
olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co0000
6_o<c<`01?l0003oc<c<olc<c?mVIVHRolc<c0;oIVIV0_o<c<`00ol0003o0?ooo`3oo`0Po`3oo`03
o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`006_moo`000ol0003oO`3oogl0o`03ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`005_moo`000ol0003oc<c<olc<c00>olc<c003
ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<
o`000002o`0001Woc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`3ofIVIP03o`000?l0oooo0?oo023o
0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Hogoo0003o`000?mo0?ooO`3o00Go
O`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Fogoo0003o`000?o<c<coc<c<00ko
c<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c006olc<c003o`00
0?o<c<coc<c<01Soc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`01?mVIVKoc<c<olc<c?l0000Ro`3o
o`03o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006?moo`000ol0003oO`3oogl0o`05ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005_moo`000ol0003oc<c<olc<c00>olc<
c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<1ol00002olc<c003o`000?o<c<coc<c<01So
c<c<00Co0000olc<c?o<c<coIVIV8oo<c<`01?mVIVKoc<c<olc<c?l0000Ro`3oo`03o`000?mo0?oo
O`3o00SoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`006?moo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`005Omoo`000ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<co
c<c<01Koc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`01?mVIVKoc<c<olc<c?l0
000Qo`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`006?moo`000ol0003oO`3oogl0
o`05ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005Omoo`000ol0003oc<c<olc<
c00?olc<c0GoIVIV5?o<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHSolc<c004ofIVI_o<
c<coc<c<o`00027o0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Gogoo0003o`00
0?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Eogoo0003o`00
0?o<c<coc<c<00Ooc<c<2?mVIVH00oo<c<coIVIVolc<c00Folc<c07ooooo000Wolc<c004o`000?o<
c<coc<c<ofIVIR?oc<c<00?oIVIVolc<c?l000008_l0ool00ol0003oO`3oogl0o`0:ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol001OoOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol001CoOol000?o0000ofIVI_mVIVH01omVIVH9olc<c003ofIVI_o<c<coc<c<01Goc<c<
0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`00omVIVKoc<c<o`00000Ro`3oo`03o`00
0?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`005omoo`000ol0003oO`3oogl0o`06ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`000ol0003oc<c<olc<c00@olc<c003ofIV
I_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`00omVIVKoc<c<
o`00000Ro`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`005omoo`000ol0003oO`3o
ogl0o`06ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`000ol0003oc<c<
olc<c00@olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<0_l000000oo<c<coIVIVolc<
c00Rolc<c003ofIVI_o<c<co000002;o0?oo00?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo
000Gogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000Dogoo0003o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`0
1?l0003oc<c<olc<c?mVIVHSolc<c003ofIVI_o<c<co000002;o0?oo00?o0000ogl0oomo0?l02omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo000Eogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo000Dogoo0003o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`05Oo<
c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHSolc<c003ofIVI_o<c<co0000027o0?oo00?o
0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Eogoo0003o`000?mo0?ooO`3o00SoO`3o00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Cogoo0003o`000?o<c<coc<c<013oc<c<00?o
IVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHSolc<c003ofIVI_l0
003o0?oo027o0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?mo
0?ooO`3o00SoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Bogoo0003o`000?o<
c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01Ol0003oc<c<olc<c?o<
c<coIVIV02?oc<c<00?oIVIVo`000?l0ool08Ol0ool00ol0003oO`3oogl0o`0<ogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
o`3oOol001GoOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol001;oOol000?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000V
olc<c004o`000?o<c<coc<c<ofIVIRCoc<c<00?oIVIVo`000?l0ool08Ol0ool00ol0003oO`3oogl0
o`0<ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol001CoOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol001;oOol000?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<
c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIRCoc<c<00?oIVIVo`000?l0ool08Ol0
ool00ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001CoOol000?o0000ogl0oomo0?l02Omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001;oOol000?o0000olc<c?o<c<`04Oo<
c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIRCoc<c<00?o
IVIVo`000?l0ool08Ol0ool00ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001CoOol000?o
0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0017oOol000?o
0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<co
c<c<ofIVIRCoc<c<00?oIVIVo`000?l0ool08Ol0ool00ol0003oO`3oogl0o`0=ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
o`3oOol001CoOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol0017oOol000?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000V
olc<c004o`000?o<c<coc<c<ofIVIRCoc<c<00?o0000o`3oool0ool08?l0ool00ol0003oO`3oogl0
o`0>ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?moo`3oOol001?oOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol0017oOol000?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<
c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIR?oc<c<00?oIVIVo`000?l0ool08Ol0
ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001;oOol000?o0000ogl0oomo0?l02_mo
0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0017oOol000?o0000olc<c?o<c<`04Oo<
c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c0;o000000?oc<c<ofIVI_o<c<`08_o<c<`0
0omVIVKo0000o`3oo`0Qo`3oo`03o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004_moo`00
0ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004Omoo`00
0ol0003oc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<
c?o<c<coIVIV8oo<c<`00omVIVKo0000o`3oo`0Qo`3oo`03o`000?mo0?ooO`3o00ooO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`004_moo`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`004?moo`000ol0003oc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool0
02Koc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`00omVIVKo0000o`3oo`0Qo`3oo`03o`000?mo0?oo
O`3o00ooO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`004_moo`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`003omoo`000ol0003oc<c<olc<c00Bolc<c003ofIVI_o<c<co
c<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`00omVIVKo0000o`3oo`0Q
o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`000ol0003oO`3oogl0o`0;
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`000ol0003oc<c<olc<c00C
olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`0
0omVIVKo0000o`3oo`0Qo`3oo`03o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`00
0ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`00
0ol0003oc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<
c?o<c<coIVIV8oo<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o017oO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`004Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`003omoo`000ol0003oc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool0
02Koc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?oo
O`3o017oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`004Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`003_moo`000ol0003oc<c<olc<c00Colc<c003ofIVI_o<c<co
c<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`00ol0003o0?ooo`3oo`0P
o`3oo`03o`000?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0o`0=
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003_moo`000ol0003oc<c<olc<c00C
olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`0
0ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`00
0ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003_moo`00
0ol0003oc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<
c?o<c<coIVIV9?o<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o01;oO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`003omoo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`003_moo`000ol0003oc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool0
02Goc<c<00Co0000olc<c?o<c<coIVIV9?o<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?oo
O`3o01;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`003_moo`000ol0003oc<c<olc<c00Colc<c003ofIVI_o<c<co
c<c<01Coc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`01Oo<c<`4ofIVIR?oc<c<00?o0000o`3o
ool0ool08?l0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0
oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o0000olc<
c?o<c<`04oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Molc<c003o`000?o<c<coc<c<00Go
c<c<00?o0000olc<c?o<c<`01?mVIVHPolc<c003o`000?l0oooo0?oo023o0?oo00?o0000ogl0oomo
0?l05?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo000<ogoo0003o`000?o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`006Oo<c<`6o`0000Koc<c<00Co0000olc<c?o<c<coIVIV0oo<c<`4ofIVIQco
c<c<00?o0000o`3oool0ool08?l0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ko
Ool000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000co
Ool000?o0000olc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Iolc<c005o`00
0?o<c<coc<c<olc<c?l000001oo<c<`01?l0003oc<c<olc<c?mVIVH7olc<c0GoIVIV5oo<c<`00ol0
003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`003_moo`000ol0
003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003?moo`000ol0
003oc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001[oc<c<00Co0000olc<c?o<
c<co00001oo<c<`01?l0003oc<c<olc<c?mVIVH<olc<c0CoIVIV4oo<c<`00ol0003o0?ooo`3oo`0P
o`3oo`03o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`0?
ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`003?moo`000ol0003oc<c<olc<c00D
olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001_oc<c<00?o0000olc<c?l000001oo<c<`01?l0
003oc<c<olc<c?mVIVH@olc<c0CoIVIV3oo<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?oo
O`3o01GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`003?moo`000ol0003oc<c<olc<c00Dolc<c003ofIVI_o<c<co
c<c<01Coc<c<0Oooool001_oc<c<00?o0000olc<c?l000001oo<c<`01?l0003oc<c<olc<c?mVIVHD
olc<c0CoIVIV2_o<c<`00ol0003o0?ooo`3oo`0Qo`3oo`03o`000?mo0?ooO`3o01GoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`003?moo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`002omoo`000ol0003oc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool0
01coc<c<0_l00007olc<c004o`000?o<c<coc<c<ofIVIQSoc<c<1?mVIVH6olc<c003o`000?l0oooo
0?oo023o0?oo00?o0000ogl0oomo0?l05_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?oo
O`3o013oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?o<c<co
c<c<01Coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<
c004o`000?o<c<coc<c<ofIVIQcoc<c<1?mVIVH2olc<c003o`000?l0oooo0?oo023o0?oo00?o0000
ogl0oomo0?l05_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?o<c<coc<c<01Coc<c<00?oIVIV
olc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHPolc<c0;oIVIV00?o0000
o`3oool0ool08?l0ool00ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000coOol000?o0000
ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000_oOol000?o0000
olc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<c004o`000?o<c<coc<c<
ofIVIR;oc<c<00?o0000o`3oool0ool08?l0ool00ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000_oOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3o
Ool000_oOol000?o0000olc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<
c004o`000?o<c<coc<c<ofIVIR;oc<c<00?o0000o`3oool0ool08?l0ool00ol0003oO`3oogl0o`0G
ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol000WoOol000?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00C
olc<c07ooooo000Uolc<c0;o000000?oc<c<ofIVI_o<c<`08Oo<c<`00ol0003o0?ooo`3oo`0Po`3o
o`03o`000?mo0?ooO`3o01OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`0Aogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oc<c<olc<c00Colc<
c0OoIVIV4_o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHQolc<c003o`000?l0oooo0?oo
027o0?oo00?o0000ogl0oomo0?l06?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o
017oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?o<c<coc<c<
00Ooc<c<3?mVIVH3olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<
c<coIVIV8_o<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o01WoO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo
0?moo`002_moo`000ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo
0?moo`002Omoo`000ol0003oIVIVofIVIP07ofIVIPooc<c<00?oIVIVolc<c?o<c<`04oo<c<`1oooo
o`009?o<c<`01?l0003oc<c<olc<c?mVIVHRolc<c003o`000?l0oooo0?oo023o0?oo00?o0000ogl0
oomo0?l06Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o01?oO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<
c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHRolc<c003o`000?l0oooo0?oo
023o0?oo00?o0000ogl0oomo0?l06Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o
01?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?o<c<coc<c<
01Koc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHRolc<
c003o`000?l0oooo0?oo023o0?oo00?o0000ogl0oomo0?l06Omo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0009ogoo
0003o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo
0003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003o
c<c<olc<c?mVIVHRolc<c003o`000?l0oooo0?oo023o0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0
003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo0008ogoo0003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`04oo<c<`1oooo
o`009?o<c<`01?l0003oc<c<olc<c?mVIVHQolc<c003o`000?l0oooo0?oo027o0?oo00?o0000ogl0
oomo0?l06_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o01CoO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<
c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHQolc<c003o`000?l0oooo0?oo
027o0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o
01CoO`3o00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?o<c<coc<c<
01Koc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHQolc<
c003o`000?l0oooo0?oo023o0?oo00?o0000ogl0oomo0?l06omo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0008ogoo
0003o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo
0003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003o
c<c<olc<c?mVIVHQolc<c003o`000?l0oooo0?oo023o0?oo00?o0000ogl0oomo0?l07?mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0
003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo0006ogoo0003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`04oo<c<`1oooo
o`009?o<c<`2o`000003olc<c?mVIVKoc<c<023oc<c<00?o0000o`3oool0ool08?l0ool00ol0003o
O`3oogl0o`0Logl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l05_mo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000KoOol000?o0000olc<c?o<c<`05oo<c<`00omVIVKo
c<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIR7oc<c<00?o0000o`3oool0
ool08?l0ool00ol0003oO`3oogl0o`0Logl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo
0?l05_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000KoOol000?o0000olc<c?o<
c<`05oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIR3o
c<c<00?o0000o`3oool0ool08Ol0ool00ol0003oO`3oogl0o`0Logl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000Ko
Ool000?o0000ogl0oomo0?l05_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000Ko
Ool000?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`00
0?o<c<coc<c<ofIVIR3oc<c<00?o0000o`3oool0ool08Ol0ool00ol0003oO`3oogl0o`0Mogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l05_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000GoOol000?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Colc<c07o
oooo000Tolc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?o0000o`3oool0ool08?l0ool00ol0003o
O`3oogl0o`0Nogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l05_mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000GoOol000?o0000olc<c?o<c<`05oo<c<`00omVIVKo
c<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?o0000o`3oool0
ool08?l0ool00ol0003oO`3oogl0o`0Nogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo
0?l05omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000GoOol000?o0000olc<c?o<
c<`05oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Solc<c005o`000?o<c<coc<c<olc<c?mV
IVH08?o<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o01koO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`001Omoo`000ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`001Omoo`000ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002?oc<c<
00Co0000olc<c?o<c<coIVIV8Oo<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o01ko
O`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000ogoo0?moo`001?moo`000ol0003oc<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<01;o
c<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV8?o<c<`00ol0003o0?ooo`3oo`0Qo`3oo`03
o`000?mo0?ooO`3o01ooO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0Hogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`001?moo`000ol0003oc<c<olc<c00Iolc<c003
ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV8?o<c<`00ol0003o
0?ooo`3oo`0Qo`3oo`03o`000?mo0?ooO`3o01ooO`3o00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`001?moo`000ol0003o
O`3oogl0o`0Hogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000omoo`000ol0003o
c<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<co
IVIV8?o<c<`00ol0003o0?ooo`3oo`0Qo`3oo`03o`000?mo0?ooO`3o01ooO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`000omoo`000ol0003oO`3oogl0o`0Iogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`000omoo`000ol0003oc<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<
00Co0000olc<c?o<c<coIVIV8?o<c<`00ol0003o0?ooo`3oo`0Po`3oo`03o`000?mo0?ooO`3o023o
O`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0Iogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000ogoo0?moo`000omoo`000ol0003oc<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<01;o
c<c<0Oooool002?oc<c<0_l000000oo<c<coIVIVolc<c00Oolc<c003o`000?l0oooo0?oo023o0?oo
00?o0000ogl0oomo0?l08Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o01WoO`3o
00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?o<c<coc<c<01Woc<c<
00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHPolc<c003o`00
0?l0oooo0?oo023o0?oo00?o0000ogl0oomo0?l08Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0003ogoo0003o`00
0?mo0?ooO`3o01WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0003ogoo0003o`00
0?o<c<coc<c<01Woc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<
c?mVIVHPolc<c003o`000?l0oooo0?oo023o0?oo00?o0000ogl0oomo0?l08Omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0002ogoo0003o`000?mo0?ooO`3o01WoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0002ogoo0003o`000?o<c<coc<c<01Woc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<
c<`01?l0003oc<c<olc<c?mVIVHOolc<c003o`000?l0oooo0?oo027o0?oo00?o0000ogl0oomo0?l0
8Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
2ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o01[oO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?o<c<coc<c<01Woc<c<00?oIVIVolc<c?o<c<`0
4_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003o`000?l0oooo0?oo027o0?oo
00?o0000ogl0oomo0?l08_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o01[oO`3o
00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?o<c<coc<c<01Woc<c<
00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003o`00
0?l0oooo0?oo027o0?oo00?o0000ogl0oomo0?l08_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool01Ol0003oOol0ogoo0?moo`3o000001go
O`3o00?o0000o`3oool0ool02ol0ool01Ol0003oOol0ogoo0?moo`3o000001coc<c<00?oIVIVolc<
c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003o`000?l0oooo0?oo
023o0?oo00?o0000ogl0oomo0?l08omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool02ol0ool01Ol0003oOol0ogoo0?moo`3o000001goO`3o00?o0000
o`3oool0ool02ol0ool01Ol0003oOol0ogoo0?moo`3o000001coc<c<00?oIVIVolc<c?o<c<`04_o<
c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003o`000?l0oooo0?oo023o0?oo00?o
0000ogl0oomo0?l08omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool02ol0ool01?l0003oOol0ogoo0?l0000Mogl0o`03o`000?l0oooo0?oo00co0?oo
00Co0000ogoo0?moo`3o00007?o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`00
0?o<c<coc<c<ofIVIQooc<c<00?o0000o`3oool0ool08?l0ool00ol0003oO`3oogl0o`0Togl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`04
o`000?moo`3oOol0o`0001koO`3o00?o0000o`3oool0ool02ol0ool01?l0003oOol0ogoo0?l0000L
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7_o<c<`0
0ol0003o0?ooo`3oo`0Qo`3oo`03o`000?mo0?ooO`3o02CoO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00Co0000ogoo0?moo`3o00007_mo
0?l00ol0003o0?ooo`3oo`0;o`3oo`04o`000?moo`3oOol0o`0001coc<c<00?oIVIVolc<c?o<c<`0
4_o<c<`1ooooo`008_o<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003o`000?l0oooo0?oo027o0?oo
00?o0000ogl0oomo0?l09?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool02ol0ool01?l0003oOol0ogoo0?l0000Nogl0o`03o`000?l0oooo0?oo00_o
0?oo00Co0000ogoo0?moo`3o00007?o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Golc<c0Co
00001oo<c<`01?l0003oc<c<olc<c?mVIVH@olc<c1Co00007ol0ool00ol0003oO`3oogl0o`0Togl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?moo`3o000001koO`3o00?o0000o`3oool0ool02ol0ool01?l0003oOol0ogoo0?l0000L
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0
003oc<c<olc<c004olc<c0KoIVIV4oo<c<`2o`0000goo`002Ol0000Fo`3oo`03o`000?mo0?ooO`3o
02CoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000ogoo0?l000007_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o0000
01coc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV0_o<c<`9ofIVIQ7oc<c<2?l00009ool0
00Wo00003?l0ool00ol0003oO`3oogl0o`0Vogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3o000001ooO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003oOol0o`00000Lolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Ko
c<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIV
IP_oc<c<2OmVIVH@olc<c0Oo00002ooo0009o`0000?o0?oo00?o0000ogl0oomo0?l09_mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool2o`00
023oO`3o00?o0000o`3oool0ool02ol0ool00ol0003oOol0o`00000Molc<c003ofIVI_o<c<coc<c<
017oc<c<0Oooool001Koc<c<0_l00003olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<
c<coIVIV5?o<c<`9ofIVIPOoc<c<00?oIVIVolc<c?o<c<`01?o<c<`7o`0000[oo`0000?o0000ool0
0?oo00001?l0000Xogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0;o`3oo`;o00008?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`;o00007_o<c<`00omV
IVKoc<c<olc<c00Aolc<c07ooooo000Folc<c003o`000?o<c<co000000;o00001oo<c<`01?l0003o
c<c<olc<c?mVIVHMolc<c0WoIVIV3?o<c<`:o`0000_oo`000ol0000Qogl0o`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o
01koO`3o00?o0000o`3oool0ool02ol0ool2o`0001koc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1oooo
o`005_o<c<`00ol0003oc<c<olc<c009olc<c004o`000?o<c<coc<c<ofIVIRCoc<c<00?oIVIVolc<
c?mVIVH02?mVIVH<olc<c0;o00004Ooo0007o`0001OoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`04o`3ooaKo00008?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<
01coc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`005oo<c<`01Ol0003oc<c<olc<c?o<c<co0000
02koc<c<00?oIVIVolc<c?o<c<`02?o<c<`9ofIVIP_oc<c<00?oIVIVolc<c?l000001Ol0000:ool0
00Oo00004?mo0?lEo`0000coo`000_l0000<ool000Go00006?mo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?o<c<coc<c<01;oc<c<3omVIVH?olc<c07ooooo000Holc<c0?o0000;oo<c<`00omVIVKo
c<c<olc<c00Aolc<c0WoIVIV0_o<c<`00omVIVKoc<c<olc<c009olc<c0[o00000ooo000:o`0000_o
o`000_l0000<ool000Go00004?oo0007o`0000Ooo`001ol0000?ogl0o`oo00005?mVIVH:olc<c003
ofIVI_o<c<coc<c<017oc<c<0Oooool004[oc<c<00?oIVIVolc<c?o<c<`06_o<c<`9ofIVIPkoc<c<
0_l0000:ool000Go00004?oo0006o`0000Ooo`001ol0000>ool000_o00000ooo0009o`0000koIVIV
00?oc<c<ofIVI_o<c<`08_o<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo001:olc<c003ofIVI_o<
c<coc<c<01coc<c<00?oIVIVolc<c?o<c<`01?o<c<`9ofIVIP[oc<c<00CoIVIVolc<c?o<c<coc<c<
1Ol00006ool000So00003Ooo000:o`0000;oo`002_l0000=ofIVIQgoc<c<00?oIVIVolc<c?o<c<`0
8Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo001Yolc<c003ofIVI_o<c<coc<c<00goc<c<2OmV
IVH00oo<c<coIVIVolc<c003olc<c003ofIVI_o<c<coc<c<00Coc<c<2Ol00002ool000[o00002_mV
IVHGolc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<
c00Aolc<c07ooooo001Yolc<c003ofIVI_o<c<coc<c<01Koc<c<4OmVIVHBolc<c003ofIVI_o<c<co
c<c<01goc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00eolc<c07ooooo001Yolc<
c003ofIVI_o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Jolc<
c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`0Eoo<c<`1ooooo`00Poo<c<`00omVIVKo
c<c<olc<c002olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIVolc<c?o<c<`0Moo<c<`1ooooo`00
Poo<c<`00omVIVKoc<c<olc<c002olc<c003ofIVI_o<c<coc<c<09Coc<c<0Oooool00?ooc<c<8?o<
c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00
aOo<c<`2o`0005Soc<c<0Oooool00<Koc<c<0_l00002olc<c003o`000?o<c<coc<c<05;oc<c<0Ooo
ool00<Ooc<c<0_l00002olc<c003o`000?o<c<coc<c<057oc<c<0Oooool003ooc<c<1Ol00004olc<
c0?o00000oo<c<`2o`0000?oc<c<0ol00002olc<c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<
c0;o00000_o<c<`3o`000003olc<c?l0003o000000;oc<c<0_l00002olc<c0Co00000oo<c<`4o`00
00?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000Coc<c<0_l00003olc<c0;o000000?oc<c<o`00
0?l000000_o<c<`4o`0000?oc<c<0ol00003olc<c0?o00000oo<c<`2o`0000Coc<c<0ol000000oo<
c<co0000o`000007olc<c0Co000000Coc<c<o`000?o<c<coc<c<1?l00002olc<c0;o00000_o<c<`2
o`000003olc<c?l0003o000000Goc<c<1?l0000/olc<c07ooooo000nolc<c0;o00000oo<c<`2o`00
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000;oc<c<0_l00002olc<
c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`00
00;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o0000
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`00
0003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00000oo<c<`2o`000004olc<c?l0003o0000
olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`2
o`0000Coc<c<0ol000000oo<c<co0000o`000006olc<c0;o00000_o<c<`3o`000003olc<c?l0003o
000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000001?o<c<`2
o`0000;oc<c<0_l0000[olc<c07ooooo000nolc<c0;o00000oo<c<`2o`000003olc<c?l0003o0000
00?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o00000_o<c<`2o`0000Goc<c<0_l00002olc<
c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<
c<co0000o`000008olc<c0?o00001?o<c<`3o`000003olc<c?l0003o000000Soc<c<0ol00003olc<
c0;o00000oo<c<`2o`000003olc<c?l0003o000000Coc<c<0ol00002olc<c0;o00000_o<c<`2o`00
00?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000001oo<c<`2o`00
00Coc<c<0_l000000oo<c<co0000o`000005olc<c0;o00000_o<c<`2o`0000Ooc<c<0_l00002olc<
c0;o0000:oo<c<`1ooooo`00@_o<c<`3o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co
0000o`000003olc<c0;o00000_o<c<`6o`000003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o
00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000Co
00000_o<c<`4o`0000?oc<c<1?l00002olc<c0Ko00000_o<c<`4o`0000Coc<c<0_l00003olc<c0;o
000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0_l00002olc<c0;o00000oo<c<`2o`000003
olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001?o<c<`2o`000003
olc<c?l0003o000000Co000000?oc<c<o`000?l000000_o<c<`2o`0000_oc<c<0_l0000[olc<c07o
oooo000oolc<c0Go00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o0000
0_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`5o`000003olc<
c?l0003o000000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<
0_l000001?o<c<co0000o`000?l00004olc<c0?o00001?o<c<`2o`0000;oc<c<0_l000001?o<c<co
0000o`000?l00006olc<c0;o00000oo<c<`2o`000004olc<c?l0003o0000olc<c0?o00001Oo<c<`2
o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o
000000Ooc<c<0_l00002olc<c0Co000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o
000000;oc<c<0_l00009olc<c0?o0000;?o<c<`1ooooo`00?_o<c<`3o`0000Koc<c<0_l000000oo<
c<co0000o`000002olc<c0?o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`00
0?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002olc<
c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<
c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o0000
00;oc<c<0_l00003olc<c0Oo000000Coc<c<o`000?l0003oc<c<0_l00002olc<c0;o00000_o<c<`2
o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0?o00000_o<c<`2o`000003olc<c?l0003o
000000Ooc<c<0_l00007olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l0000;
olc<c0;o0000:oo<c<`1ooooo`00?_o<c<`2o`0000?oc<c<0_l00003olc<c0?o00000oo<c<`3o`00
0003olc<c?l0003o000000;o00000_o<c<`4o`0000?oc<c<1Ol00003olc<c0;o00001?o<c<`2o`00
0003olc<c?l0003o000000;o000000?oc<c<o`000?l000000ol00003olc<c0Co00000oo<c<`4o`00
00?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000Coc<c<0_l00003olc<c0;o000000?oc<c<o`00
0?l000000_o<c<`4o`0000;oc<c<1?l00003olc<c0?o00000oo<c<`3o`000003olc<c?l0003o0000
00?oc<c<0_l00006olc<c0;o00001?o<c<`2o`0000;oc<c<1?l00002olc<c0Go00002?o<c<`2o`00
00;oc<c<0_l0000[olc<c07ooooo000nolc<c0;o00000oo<c<`2o`0000koc<c<0_l0000=olc<c0;o
00000oo<c<`2o`0000Soc<c<0_l0000^olc<c0;o00000oo<c<`2o`0000coc<c<0_l0000Lolc<c0;o
00000_o<c<`2o`0001Koc<c<0_l00002olc<c0;o0000:oo<c<`1ooooo`00?oo<c<`5o`0000ooc<c<
0_l0000=olc<c0;o00000oo<c<`8o`0000;oc<c<0_l0000^olc<c0;o00000oo<c<`2o`000003olc<
c?l0003o000000Woc<c<0_l0000Molc<c0Co00006?o<c<`4o`0002coc<c<0Oooool00?ooc<c<8?o<
c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00
ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<
c07ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 6, 1, 6, 6, 6, 1, 6, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(5.`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 0.0147151 5.88604 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(1.5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(2.5)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(3)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.5 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 0.0147151 2.94302 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .16187 -24 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -24 -4.5 ]
[.01131 .45617 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(1.5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(2.5)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(3)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .16187 m
.03006 .16187 L
s
[(0.05)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.1)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.15)] .01131 .45617 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.5 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 -0.377687 0.981006 [
[.2619 .59082 -9 -9 ]
[.2619 .59082 9 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.7381 .59082 -9 -9 ]
[.7381 .59082 9 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -18 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .11282 -18 -4.5 ]
[.01131 .11282 0 4.5 ]
[.01131 .21092 -18 -4.5 ]
[.01131 .21092 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .40712 -18 -4.5 ]
[.01131 .40712 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .60332 m
.2619 .60957 L
s
[(1.5)] .2619 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(2)] .5 .59082 0 1 Mshowa
.7381 .60332 m
.7381 .60957 L
s
[(2.5)] .7381 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(3)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.07143 .60332 m
.07143 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.16667 .60332 m
.16667 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.4)] .01131 .01472 1 0 Mshowa
.02381 .11282 m
.03006 .11282 L
s
[(0.5)] .01131 .11282 1 0 Mshowa
.02381 .21092 m
.03006 .21092 L
s
[(0.6)] .01131 .21092 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.7)] .01131 .30902 1 0 Mshowa
.02381 .40712 m
.03006 .40712 L
s
[(0.8)] .01131 .40712 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(0.9)] .01131 .50522 1 0 Mshowa
.125 Mabswid
.02381 .03434 m
.02756 .03434 L
s
.02381 .05396 m
.02756 .05396 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .0932 m
.02756 .0932 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .15206 m
.02756 .15206 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .23054 m
.02756 .23054 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .26978 m
.02756 .26978 L
s
.02381 .2894 m
.02756 .2894 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34826 m
.02756 .34826 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .3875 m
.02756 .3875 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .44636 m
.02756 .44636 L
s
.02381 .46598 m
.02756 .46598 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .52484 m
.02756 .52484 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .56408 m
.02756 .56408 L
s
.02381 .5837 m
.02756 .5837 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.5 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 -0.272059 1.43387 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .1581 -18 -4.5 ]
[.01131 .1581 0 4.5 ]
[.01131 .30149 -18 -4.5 ]
[.01131 .30149 0 4.5 ]
[.01131 .44488 -18 -4.5 ]
[.01131 .44488 0 4.5 ]
[.01131 .58826 -18 -4.5 ]
[.01131 .58826 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(1.5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(2.5)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(3)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .1581 m
.03006 .1581 L
s
[(0.3)] .01131 .1581 1 0 Mshowa
.02381 .30149 m
.03006 .30149 L
s
[(0.4)] .01131 .30149 1 0 Mshowa
.02381 .44488 m
.03006 .44488 L
s
[(0.5)] .01131 .44488 1 0 Mshowa
.02381 .58826 m
.03006 .58826 L
s
[(0.6)] .01131 .58826 1 0 Mshowa
.125 Mabswid
.02381 .04339 m
.02756 .04339 L
s
.02381 .07207 m
.02756 .07207 L
s
.02381 .10075 m
.02756 .10075 L
s
.02381 .12942 m
.02756 .12942 L
s
.02381 .18678 m
.02756 .18678 L
s
.02381 .21546 m
.02756 .21546 L
s
.02381 .24413 m
.02756 .24413 L
s
.02381 .27281 m
.02756 .27281 L
s
.02381 .33017 m
.02756 .33017 L
s
.02381 .35884 m
.02756 .35884 L
s
.02381 .38752 m
.02756 .38752 L
s
.02381 .4162 m
.02756 .4162 L
s
.02381 .47355 m
.02756 .47355 L
s
.02381 .50223 m
.02756 .50223 L
s
.02381 .53091 m
.02756 .53091 L
s
.02381 .55959 m
.02756 .55959 L
s
.02381 .61694 m
.02756 .61694 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .01472 m
.5 .60332 L
.97619 .59457 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 -0.573889 5.88604 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(1.5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(2.5)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(3)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.12)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.14)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.16)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.18)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.5 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 0.0147151 5.88604 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(1.5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(2.5)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(3)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.5 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 -0.371191 0.97451 [
[.2619 .59082 -9 -9 ]
[.2619 .59082 9 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.7381 .59082 -9 -9 ]
[.7381 .59082 9 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01861 -18 -4.5 ]
[.01131 .01861 0 4.5 ]
[.01131 .11606 -18 -4.5 ]
[.01131 .11606 0 4.5 ]
[.01131 .21352 -18 -4.5 ]
[.01131 .21352 0 4.5 ]
[.01131 .31097 -18 -4.5 ]
[.01131 .31097 0 4.5 ]
[.01131 .40842 -18 -4.5 ]
[.01131 .40842 0 4.5 ]
[.01131 .50587 -18 -4.5 ]
[.01131 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .60332 m
.2619 .60957 L
s
[(1.5)] .2619 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(2)] .5 .59082 0 1 Mshowa
.7381 .60332 m
.7381 .60957 L
s
[(2.5)] .7381 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(3)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.07143 .60332 m
.07143 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.16667 .60332 m
.16667 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01861 m
.03006 .01861 L
s
[(0.4)] .01131 .01861 1 0 Mshowa
.02381 .11606 m
.03006 .11606 L
s
[(0.5)] .01131 .11606 1 0 Mshowa
.02381 .21352 m
.03006 .21352 L
s
[(0.6)] .01131 .21352 1 0 Mshowa
.02381 .31097 m
.03006 .31097 L
s
[(0.7)] .01131 .31097 1 0 Mshowa
.02381 .40842 m
.03006 .40842 L
s
[(0.8)] .01131 .40842 1 0 Mshowa
.02381 .50587 m
.03006 .50587 L
s
[(0.9)] .01131 .50587 1 0 Mshowa
.125 Mabswid
.02381 .0381 m
.02756 .0381 L
s
.02381 .05759 m
.02756 .05759 L
s
.02381 .07708 m
.02756 .07708 L
s
.02381 .09657 m
.02756 .09657 L
s
.02381 .13555 m
.02756 .13555 L
s
.02381 .15504 m
.02756 .15504 L
s
.02381 .17453 m
.02756 .17453 L
s
.02381 .19402 m
.02756 .19402 L
s
.02381 .23301 m
.02756 .23301 L
s
.02381 .2525 m
.02756 .2525 L
s
.02381 .27199 m
.02756 .27199 L
s
.02381 .29148 m
.02756 .29148 L
s
.02381 .33046 m
.02756 .33046 L
s
.02381 .34995 m
.02756 .34995 L
s
.02381 .36944 m
.02756 .36944 L
s
.02381 .38893 m
.02756 .38893 L
s
.02381 .42791 m
.02756 .42791 L
s
.02381 .4474 m
.02756 .4474 L
s
.02381 .46689 m
.02756 .46689 L
s
.02381 .48638 m
.02756 .48638 L
s
.02381 .52536 m
.02756 .52536 L
s
.02381 .54485 m
.02756 .54485 L
s
.02381 .56434 m
.02756 .56434 L
s
.02381 .58383 m
.02756 .58383 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.5 .01472 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.47619 0.0147151 5.88604 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(1.5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(2.5)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(3)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.5 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H0033oi^KV0ol00004onKViP03
o`000?oVi^Koi^KV00;oi^KV0ol00004onKViPGo00001?oVi^H5o`0000?oi^KV00?o0000onKVi_oV
i^H00_oVi^H3o`0000Koi^KV0ol0000eonKViP?o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o
00001OoVi^H5o`0000Coi^KV1Ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00005onKViP?o
00005?oVi^H0037oi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Co
i^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Ko
i^KVonKVi_l000001?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000003Goi^KV00?o0000onKVi_oVi^H0
1ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000001?oi^KV000aonKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H00ooV
i^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01_oV
i^H00ol0003oi^KVonKViP0conKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01?oV
i^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01OoV
i^H00ol0003oi^KVonKViP0AonKViP00<OoVi^H00ol0003oi^KVonKViP0;onKViP03o`000?oVi^Ko
i^KV00Coi^KV00?o0000onKVi_oVi^H01_oVi^H00ol0003oi^KVonKViP0:onKViP03o`000?oVi^Ko
i^KV00Coi^KV0_l0000fonKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01OoVi^H0
0ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV00[oi^KV00?o0000onKVi_oVi^H00ooVi^H2
o`0001Coi^KV000aonKViP03o`000?oVi^Koi^KV00Ooi^KV1?l00004onKViP05o`000?oVi^Koi^KV
onKVi_l000001?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV1?l00009onKViP03o`000?oV
i^Koi^KV03?oi^KV00?o0000onKVi_oVi^H01ooVi^H4o`0000Goi^KV00Go0000onKVi_oVi^Koi^KV
o`000004onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H4o`0000Soi^KV00?o0000onKVi_oV
i^H04OoVi^H0033oi^KV0_l00009onKViP03o`000?oVi^Koi^KV00Goi^KV00Go0000onKVi_oVi^Ko
i^KVo`000004onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP06onKV
iP05o`000?oVi^Koi^KVonKVi_l00000=?oVi^H2o`0000Woi^KV00?o0000onKVi_oVi^H01_oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`00
0?oVi^Koi^KV00Goi^KV00Go0000onKVi_oVi^Koi^KVo`00000ConKViP00<OoVi^H00ol0003oi^KV
onKViP07onKViPGo00001?oVi^H3o`0000Koi^KV0ol00008onKViPGo00001OoVi^H3o`0003Koi^KV
00?o0000onKVi_oVi^H01ooVi^H5o`0000Goi^KV0ol00006onKViP?o00002?oVi^H5o`0000Coi^KV
0ol0000DonKViP00hooVi^H002Woi^KV00?o0000onKVi_oVi^H0IooVi^H00ol0003oi^KVonKViP1=
onKViP009ooVi^H2o`000003ok>c/ol0003o000003[o0000;?oVi^Hoo`0001;oi^KV000YonKViP03
ok>c/ooVi^Koi^KV06Ooi^KV00?o0000onKVi_oVi^H0COoVi^H002Woi^KV00?o0000ok>c/ooVi^H0
IooVi^H2o`0004koi^KV000YonKViP03o`000?oVi^Ko/k>c06Ooi^KV0_l0001>onKViP00:OoVi^H0
1?l0003oi^KVonKVi_nc/k=VonKViP03o`000?oVi^Koi^KV04goi^KV000BonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP03onKViP;o00000_oVi^H5o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVok>c
/`1UonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKV
i_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Go0000onKVi_oVi^Koi^KVok>c/`1?onKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKV
i_oVi^H0COoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003
onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H00_oVi^H00onc/k?oi^KVonKViP1;
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04
o`000?oVi^Ko0000o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKV
i_oVi^Ko00001?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00?o/k>conKVi_oVi^H0B_oV
i^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00?o0000onKVi_l0
0000CooVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000?oi^KV00Co0000onKVi_oVi^Ko00001_oVi^H00onc/k?oi^KVonKViP19onKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVo`000?l0001>onKV
iP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H01?l0003oi^KVonKVi_l00007onKViP03ok>c/ooVi^Koi^KV04Soi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Co00000_oVi^H00ol0003oi^KVonKViP1=onKV
iP004_oVi^H2o`0000[oi^KV0_l00003onKViP?o00000ooVi^H00ol0003oi^KVonKViP05onKViP03
ok>c/ooVi^Koi^KV04Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003o
i^KVo`0000Goi^KV0_l0001>onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2
o`0000Coi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Koi^KV00?o/k>conKVi_oVi^H0B?oVi^H2
o`0000[oi^KV0_l00002onKViPGo000000?oi^KVo`000?oVi^H0C_oVi^H0017oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP05o`000?oVi^Koi^KVonKVi_l00000
2OoVi^H00onc/k?oi^KVonKViP1MonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Go00000_oVi^H00ol0003oi^KVonKViP08onKViP03
ok>c/ooVi^Koi^KV05coi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000_oi^KV00?o
/k>conKVi_oVi^H0BooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o
0000onKVi_oVi^H0COoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKV
i_l00002onKViP03o`000?oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H02OoVi^H00onc/k?oi^KV
onKViP1:onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l0001>onKV
iP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l00003
onKViP03o`000?oVi^Koi^KV00[oi^KV00?o/k>conKVi_oVi^H0BOoVi^H01?l0003oi^KVonKVi_l0
0009onKViP05o`000?oVi^Koi^KVonKVi_l00000CooVi^H001;oi^KV0_l0000:onKViP;o00001OoV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000goi^KV00?o/k>conKVi_oVi^H0B?oVi^H01?l0003oi^KV
onKVi_l00009onKViP04o`000?oVi^Koi^KVonKViScoc<c<5?oVi^H001;oi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o00000ooVi^H00ol0003oi^KVonKViP0<onKViP03
ok>c/ooVi^Koi^KV04Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko
000004ooi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKV
i_l00003onKViP04o`000?oVi^Koi^KVo`0000ooi^KV00?o/k>conKVi_oVi^H0A_oVi^H01?l0003o
i^KVonKVi_l00008onKViP;o00000ooVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`00013oi^KV
00?o/k>conKVi_oVi^H0A_oVi^H2o`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP00
4OoVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l00003onKV
iP03o`000?oVi^Koi^KV00koi^KV00?o/k>conKVi_oVi^H0E_oVi^H2o`0004koi^KV000AonKViP04
o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00006onKViP03o`000?oV
i^Koi^KV00ooi^KV00?o/k>conKVi_oVi^H0EOoVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP03o`00
0?oVi^Koi^KV013oi^KV00?o/k>conKVi_oVi^H0E?oVi^H00ol0003oi^KVonKViP1=onKViP004_oV
i^H2o`0000[oi^KV0_l00004onKViP;o00000ooVi^H00ol0003oi^KVonKViP0AonKViP03ok>c/ooV
i^Koi^KV03goi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP?o00000_oV
i^H2o`0004koi^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3
o`0000?oi^KV00?o0000onKVi_oVi^H04_oVi^H00onc/k?oi^KVonKViP0konKViP04o`000?oVi^Ko
i^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP03o`000?oVi^Ko000004ooi^KV
000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP04o`000?oVi^Koi^KVo`0001Coi^KV00?o/k>conKVi_oVi^H0>ooVi^H01?l0003oi^KVonKVi_l0
0009onKViP03o`000?oVi^Koi^KV00Goi^KV00Co0000onKVi_l0003o0000C_oVi^H0017oi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKV
i_oVi^Ko00005OoVi^H00onc/k?oi^KVonKViP0jonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o
0000onKVi_oVi^H01OoVi^H00ol0003oi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV01Coi^KV
00?o/k>conKVi_oVi^H0>OoVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKV
iPCo00000_oVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKV
i_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0001Ooi^KV00?o/k>conKVi_oVi^H0
>?oVi^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooVi^H00ol0003oi^KVonKViP03onKViP03
o`000?oVi^Koi^KV04goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oV
i^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0001Soi^KV00?o/k>conKVi_oVi^H0>?oV
i^H2o`0000[oi^KV00Co0000onKVi_oVi^Koi^KV1Ol000000ooVi^Ko0000o`00001>onKViP004_oV
i^H2o`0000[oi^KV0_l00003onKViP?o00000ooVi^H00ol0003oi^KVonKViP0FonKViP03ok>c/ooV
i^Koi^KV04koi^KV00?o0000onKVi_oVi^H0COoVi^H002Woi^KV00?o0000onKVi_oVi^H05ooVi^H0
0onc/k?oi^KVonKViP1=onKViP;o0000C_oVi^H001Soi^KV0_l00004onKViP03o`000?oVi^Koi^KV
00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV01Soi^KV00?o/k>conKVi_oVi^H0??oVi^H2o`00
00Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol000000ooVi^Ko0000o`00001>onKViP005ooVi^H01?l0
003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H06OoVi^H0
0onc/k?oi^KVonKViP0jonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000
onKVi_l0001?onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;o
i^KV00?o0000onKVi_oVi^H06_oVi^HOok>c/agoi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0
003oi^KVonKVi_oVi^H2o`0004koi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000
onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP1FonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Co
0000onKVi_oVi^Ko0000CooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KV
onKViP1KonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00001AonKV
iP005ooVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000GOoVi^H01?l0003oi^KVonKVi_l00007
onKViP05o`000?oVi^Koi^KVonKVi_l00000DOoVi^H001Soi^KV0_l0000:onKViP03o`000?oVi^Ko
i^KV05coi^KV0_l00009onKViP?o0000D_oVi^H00>?oi^KV000gonKViP?o00000_oVi^H6o`000004
onKVi_l0003o0000o`0000?oi^KV0ol00002onKViP03o`000?oVi^Ko000000;o0000COoVi^H3o`00
00;oi^KV0ol000000ooVi^Ko0000o`000003o`0000;oi^KV1_l000001ooVi^Ko0000o`000?l0003o
i^KVo`000?oVi^H00ol000000ooVi^Ko0000o`00000PonKViP00>?oVi^H01?l0003oi^KVonKVi_l0
0002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0003oi^KV
onKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KV
onKViP02onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00008OoVi^H003So
i^KV00?o0000onKVi_l000000ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00?o
i^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Coi^KV00?o0000onKVi_oVi^H0
0_oVi^H01?l0003oi^KVo`000?l00002onKViP03o`000?oVi^Ko000002;oi^KV000honKViP?o0000
0ooVi^H3o`0000?oi^KV0ol00003onKViP?o00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004go
i^KV0_l00003onKViPCo00000_oVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003o
i^KVo`000?l00002onKViP;o00008ooVi^H003Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0
003oi^KVonKViP03onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKV
i_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H2o`00
0007onKVi_l0003oi^KVonKVi_l0003oi^KVo`00000RonKViP00>?oVi^H01?l0003oi^KVonKVi_l0
0002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003o
i^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l0
0002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003o
i^KVonKViP02onKViP;o000000Goi^KVo`000?oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV
01ooi^KV000gonKViPCo00000_oVi^H5o`000003onKVi_l0003o000000;o00000_oVi^H4o`0000?o
i^KV0ol0001>onKViP?o000000Goi^KVo`000?l0003o0000onKViP06o`0000;oi^KV1Ol000001?oV
i^Ko0000o`000?oVi^H6o`000003onKVi_l0003o0000023oi^KV003SonKViP00hooVi^H00>?oi^KV
003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H009Ooi^KV0ol00004onKViP03o`000?oV
i^Koi^KV00;oi^KV0ol00005onKViPGo00001?oVi^H5o`0000?oi^KV00?o0000onKVi_oVi^H00_oV
i^H3o`0000Goi^KV0ol0000GonKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H3
o`0007Soi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Co
0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKV
i_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000001Koi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00001eonKViP03o`000?oVi^Koi^KV00_oi^KV00?o
0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV00_oi^KV00?o
0000onKVi_oVi^H01OoVi^H00ol0003oi^KVonKViP0DonKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViPGo00000_oVi^H00omoOgooi^KVonKViP1conKViP03o`000?oVi^Koi^KV00_oi^KV00?o
0000onKVi_oVi^H01OoVi^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV00[oi^KV00?o
0000onKVi_oVi^H00ooVi^H2o`0001Ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co
0000onKVi_oVi^Ko00000ooVi^H00omoOgooi^KVonKViP1conKViP03o`000?oVi^Koi^KV00Ooi^KV
1?l00005onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00Ooi^KV1?l00008onKViP03o`000?oVi^Koi^KV01Coi^KV000@onKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00?o0000onKVi_l000000ooVi^H00ol0003oOgmoonKViP1bonKViP;o00002OoVi^H00ol0
003oi^KVonKViP06onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Ooi^KV00?o0000onKVi_oVi^H01OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000001Koi^KV
000@onKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00003onKViP03o`000?oVi^KoOgmo07?oi^KV
00?o0000onKVi_oVi^H01ooVi^H5o`0000Goi^KV0ol00006onKViP?o00002?oVi^H5o`0000Coi^KV
0ol0000GonKViP004OoVi^H2o`0000_oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03ogmo
OooVi^Koi^KV0;_oi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooV
i^H01Ol0003oi^KVonKVi_oVi^KoOgmo06Woi^KV00?o0000onKVi_oVi^H0D?oVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oV
i^Koi^KVogmoO`1XonKViP03o`000?nIVIWo000003co00005OoVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00002ooVi^H01?l0003oi^KVonKVi_l00004onKViP03ogmoOooVi^Koi^KV06Koi^KV00?oVIVI
o`000?oVi^H0D?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0
0005onKViP03ogmoOooVi^Koi^KV06Goi^KV00?o0000oiVIVOoVi^H0D?oVi^H0013oi^KV00Co0000
onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H01?oVi^H00omoOgooi^KVonKV
iP1TonKViP;o000000?oVIVIonKVi_oVi^H0C_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooV
i^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV00Coi^KV00?oOgmoonKVi_oVi^H0I?oV
i^H01?l0003oi^KVonKVi_nIVIU?onKViP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oV
i^Koi^KV00Goi^KV00?oOgmoonKVi_oVi^H0HooVi^H2o`0000;oi^KV00?oVIVIonKVi_oVi^H0C?oV
i^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Ko
i^KV00Koi^KV00?oOgmoonKVi_oVi^H0D_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3
o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00onIVIWoi^KVonKViP1;onKViP004?oVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKV
iP07onKViP03ogmoOooVi^Koi^KV053oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01_l0003oi^KV
onKVi_oVi^Ko0000onKViP;o00000ooVi^H00onIVIWoi^KVonKViP1;onKViP004?oVi^H01?l0003o
i^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP08
onKViP03ogmoOooVi^Koi^KV04ooi^KV00Co0000onKVi_oVi^Ko00002ooVi^H00ol0003oi^KVo`00
0005onKViP03oiVIVOoVi^Koi^KV04[oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l0
0003onKViP03o`000?oVi^Koi^KV00Soi^KV00?oOgmoonKVi_oVi^H0CooVi^H01?l0003oi^KVonKV
i_l00009onKViP;o00000_oVi^H2o`0000Goi^KV00?oVIVIonKVi_oVi^H0BOoVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV00Woi^KV
00?oOgmoonKVi_oVi^H0C_oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^Ko0000o`00
00Koi^KV00?oVIVIonKVi_oVi^H0B?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0
003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00[oi^KV00?oOgmoonKVi_oVi^H0COoVi^H01?l0
003oi^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000008onKViP03oiVI
VOoVi^Koi^KV04Ooi^KV000AonKViP;o00002_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H02ooV
i^H00omoOgooi^KVonKViP1=onKViP;o00002OoVi^H3o`0000;oi^KV0_l00008onKViP03oiVIVOoV
i^Koi^KV04Koi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Ko
i^KV00;oi^KV00?o0000onKVi_oVi^H03?oVi^H00omoOgooi^KVonKViP1LonKViP03o`000?oVi^Ko
i^KV00Ooi^KV00?oVIVIonKVi_oVi^H0A_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H0
0ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00coi^KV00?oOgmoonKVi_oVi^H0G?oVi^H2
o`0000Woi^KV00?oVIVIonKVi_oVi^H0AOoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000ooi^KV00?oOgmoonKVi_oVi^H0BooVi^H2o`0000Coi^KV00?o
0000onKVi_oVi^H00ooVi^H3o`000003onKVi_l0003oi^KV00[oi^KV00?oVIVIonKVi_oVi^H0A?oV
i^H0013oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000013oi^KV
00?oOgmoonKVi_oVi^H0BOoVi^H01?l0003oi^KVonKVi_l0000:onKViP03o`000?oVi^Koi^KV00;o
00002ooVi^H00onIVIWoi^KVonKViP13onKViP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04
o`000?oVi^Koi^KVo`00017oi^KV00?oOgmoonKVi_oVi^H0B?oVi^H01?l0003oi^KVonKVi_l00007
onKViPGo000000?oi^KVo`000?l000003?oVi^H00onIVIWoi^KVonKViP12onKViP004?oVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKV
iP0?onKViP03ogmoOooVi^Koi^KV04Soi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01?l0003oi^KV
onKVi_l00002onKViP03o`000?oVi^Koi^KV00coi^KV00?oVIVIonKVi_oVi^H0@OoVi^H0017oi^KV
0_l00008onKViPGo00000_oVi^H00ol0003oi^KVonKViP0@onKViP03ogmoOooVi^Koi^KV04Ooi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVo`000002onKViP;o00003OoVi^H00onIVIWo
i^KVonKViP11onKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV
00?o0000onKVi_oVi^H04OoVi^H00omoOgooi^KVonKViP16onKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV0_l00002onKViP03o`000?oVi^Koi^KV00goi^KV00?oVIVIonKVi_oVi^H0@?oVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKV
i_oVi^H04_oVi^H00omoOgooi^KVonKViP16onKViP;o00002ooVi^H00ol0003oi^KVonKViP02o`00
00ooi^KV00?oVIVIonKVi_oVi^H0?ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H04ooVi^H00omoOgooi^KVonKViP1E
onKViP03o`000?oVi^Koi^KV00ooi^KV00?oVIVIonKVi_oVi^H0?_oVi^H0013oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H04ooVi^H00omoOgooi^KVonKViP1E
onKViP;o00004OoVi^H00onIVIWoi^KVonKViP0monKViP004?oVi^H01?l0003oi^KVonKVi_l00007
onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0DonKViP03ogmoOooV
i^Koi^KV04Coi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViP;o00004_oV
i^H00onIVIWoi^KVonKViP0lonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oV
i^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0EonKViP03ogmoOooVi^Koi^KV04;oi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_l000004ooVi^H0
0onIVIWoi^KVonKViP0lonKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`00
00?oi^KV00?o0000onKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP11onKViP04o`000?oVi^Koi^KV
o`0000_oi^KV00Co0000onKVi_l0003o00004ooVi^H00onIVIWoi^KVonKViP0konKViP004?oVi^H0
1?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000002?oVi^H3o`0000Coi^KV
00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00CoOgmoonKVi_oVi^Koi^KV1Ol00006onKViPGo
00000ooVi^H00ol0003oi^KVonKViP02onKViP?o00002?oVi^H3o`0001Woi^KV00Co0000onKVi_oV
i^Ko00002ooVi^H00ol0003oi^KVo`00000EonKViP03oiVIVOoVi^Koi^KV03[oi^KV000@onKViP04
o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP07
onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVogmoO`04onKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV00Go0000
onKVi_oVi^Koi^KVo`00000HonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l00002onKViP;o0000
5OoVi^H00onIVIWoi^KVonKViP0ionKViP004?oVi^H01?l0003oi^KVonKVi_l00008onKViPCo0000
0_oVi^H00ol0003oi^KVonKViP07onKViP03o`000?oVi^Koi^KV00_oi^KV00Co0000onKVi_oVi^Ko
Ogmo1?oVi^H00ol0003oi^KVonKViP08onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oV
i^H02?oVi^H00ol0003oi^KVonKViP0FonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000onKV
i_oVi^H00ooVi^H00ol0003oi^KVonKViP0EonKViP03oiVIVOoVi^Koi^KV03Soi^KV000@onKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Ko
i^KV00Ooi^KV00?o0000onKVi_oVi^H02ooVi^H01Ol0003oi^KVonKVi_oVi^KoOgmo00Coi^KV00?o
0000onKVi_oVi^H02?oVi^H00ol0003oi^KVonKViP0:onKViP03o`000?oVi^Koi^KV00Koi^KV0_l0
000JonKViP;o00002?oVi^H5o`000003onKVi_l0003o000001Ooi^KV00?oVIVIonKVi_oVi^H0=ooV
i^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV
00?o0000onKVi_oVi^H01ooVi^H00ol0003oi^KVonKViP07onKViPCo00001OoVi^H00omoOgoo0000
onKViP02onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViPCo
00002ooVi^H00ol0003oi^KVonKViP0WonKViP03o`000?oVi^Koi^KV01Koi^KV00?oVIVIonKVi_oV
i^H0=ooVi^H0017oi^KV0_l00009onKViP?o00000ooVi^H00ol0003oi^KVonKViP06onKViP;o0000
2OoVi^H00ol0003oi^KVonKViP06onKViP03ogmoOol0003oi^KV00;oi^KV00?o0000onKVi_oVi^H0
1?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H02?oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000002Woi^KV0_l0000HonKViP03oiVIVOoVi^Koi^KV03Koi^KV000RonKViP03
o`000?oVi^Koi^KV00Ooi^KV00?o0000onKVi_oVi^H01ooVi^H5o`0000Goi^KV00CoOgmoo`000?l0
003o00002?oVi^H3o`0000Soi^KV1Ol00007onKViP?o00006_oVi^H2o`0000Coi^KV00?o0000onKV
i_oVi^H00_oVi^H3o`0000;oi^KV0_l0000IonKViP03oiVIVOoVi^Koi^KV03Goi^KV000RonKViP03
o`000?oVi^Koi^KV01coi^KV00?oOgmoonKVi_oVi^H0>ooVi^H01?l0003oi^KVonKVi_l00007onKV
iP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`00000KonKViP03oiVIVOoVi^Koi^KV03Coi^KV000R
onKViP03o`000?oVi^Koi^KV01goi^KV00?oOgmoonKVi_oVi^H0>_oVi^H01?l0003oi^KVonKVi_l0
0007onKViP06o`000?oVi^Koi^KVonKVi_l0003oi^KV0_l0000KonKViP03oiVIVOoVi^Koi^KV03?o
i^KV000PonKViR?o00008omoOgl2o`0001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000;o
i^KV00?o0000onKVi_oVi^H06ooVi^HNoiVIVAOoi^KV000RonKViP03o`000?oVi^Koi^KV05[oi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP03onKViP;o0000DOoVi^H007ooi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP1EonKViP00P?oVi^H2o`0000[oi^KV
0_l0001EonKViP00hooVi^H00>?oi^KV000eonKViP;o000000Coi^KVo`000?l0003o00000_oVi^H2
o`0000?oi^KV0ol00002onKViP;o000000Goi^KVo`000?l0003o0000onKViP03o`00057oi^KV0ol0
0003onKViPGo000000Coi^KVo`000?l0003o00000_oVi^H3o`000004onKVi_l0003o0000o`0002Wo
i^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKV
iP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000005?oi^KV00?o
0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H00ol0003oi^KVonKViP0XonKViP00=OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_oVi^H5o`0000?oi^KV00?o
0000onKVi_oVi^H0DOoVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00?oi^KV00?o
0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000002[oi^KV000eonKViP05o`000?oV
i^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;o
i^KV00?o0000onKVi_l000001?oVi^H00ol0003oi^KVonKViP1AonKViP?o00000ooVi^H3o`0000?o
i^KV0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l00000:_oVi^H003Goi^KV00Go0000onKVi_l0
003oi^KVo`000002onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`0000;o
i^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko0000057oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000
onKVi_l0003oi^KVo`0002[oi^KV000eonKViP;o000000?oi^KVo`000?l000000_oVi^H02_l0003o
i^KVonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l00003onKViP09o`000?oVi^Koi^KVonKVi_l0
003oi^KVo`000?oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKV
i_l00002onKViP05o`000?oVi^Koi^KVo`000?oVi^H00_l000000ooVi^Ko0000o`00000ZonKViP00
=OoVi^H01?l0003oi^KVonKVi_oVi^H5o`000003onKVi_l0003o000000Go00000_oVi^H2o`0000?o
i^KV1Ol0001@onKViPCo00000_oVi^H5o`000003onKVi_l0003o000000;o00000_oVi^H01?l0003o
i^KVonKVi_oVi^H2o`0002Woi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?o
i^KV003SonKViP00hooVi^H0033oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00004
onKViPGo00001?oVi^H5o`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000Koi^KV0ol0000e
onKViP?o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00001OoVi^H5o`0000Coi^KV1Ol00003
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00005onKViP?o00005?oVi^H0037oi^KV00?o0000onKV
i_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00Co0000onKVi_oVi^Ko00001OoV
i^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000003Goi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000Goi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`00
0?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000001?oi^KV000aonKViP03
o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP06onKViP03
o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01_oVi^H00ol0003oi^KVonKViP0conKViP03
o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP06onKViP03
o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0003oi^KVonKViP0AonKViP00
<OoVi^H00ol0003oi^KVonKViP0;onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H0
1_oVi^H00ol0003oi^KVonKViP0:onKViP03o`000?oVi^Koi^KV00Coi^KV0_l0000fonKViP03o`00
0?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0003oi^KVonKViP06onKViP03o`00
0?oVi^Koi^KV00[oi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0001Coi^KV000aonKViP03o`000?oV
i^Koi^KV00Ooi^KV1?l00004onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000Ooi^KV1?l00009onKViP03o`000?oVi^Koi^KV03?oi^KV00?o0000onKVi_oV
i^H01ooVi^H4o`0000Goi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP05o`000?oVi^Koi^KV
onKVi_l000001ooVi^H4o`0000Soi^KV00?o0000onKVi_oVi^H04OoVi^H0033oi^KV0_l00009onKV
iP03o`000?oVi^Koi^KV00Goi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP05o`000?oVi^Ko
i^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP06onKViP05o`000?oVi^Koi^KVonKVi_l00000
=?oVi^H2o`0000Woi^KV00?o0000onKVi_oVi^H01_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Co
i^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV00Goi^KV00Go0000onKV
i_oVi^Koi^KVo`00000ConKViP00<OoVi^H00ol0003oi^KVonKViP07onKViPGo00001?oVi^H3o`00
00Koi^KV0ol00008onKViPGo00001OoVi^H3o`0003Koi^KV00?o0000onKVi_oVi^H01ooVi^H5o`00
00Goi^KV0ol00006onKViP?o00002?oVi^H5o`0000Coi^KV0ol0000DonKViP00hooVi^H002Ooi^KV
7ol0000Ooda<C003o`000?oVi^Koi^KV02[oi^KV00?o0000ofIVI_l00000??l0000BonKViP00:OoV
i^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Co0000onKVi_oVi^KoC4a<
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0002koi^KV
00CoIVIVonKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002
onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000DonKViP00
:OoVi^H00ol0003oi^KVonKViP0IonKViP03oda<C?oVi^Koi^KV04_oi^KV00?o0000ofIVI_oVi^H0
COoVi^H002Woi^KV00?o0000onKVi_oVi^H06?oVi^H00om<C4coi^KVonKViP1<onKViP03o`000?oV
i^KoIVIV04goi^KV000YonKViP03o`000?oVi^Koi^KV01Ooi^KV00?oC4a<onKVi_oVi^H0COoVi^H2
o`000003onKVi_mVIVKoi^KV04_oi^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKV
iP?o00000_oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H05_oVi^H00om<C4coi^KVonKViP0honKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000_oVi^H5o`000003onKVi_l0003oi^KV
00;oi^KV00?oIVIVonKVi_oVi^H0BOoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0
003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H05_oVi^H0
0om<C4coi^KVonKViP0gonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00;o00000_oVi^H00omVIVKoi^KVonKViP19onKViP00
4OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oV
i^H00_oVi^H00ol0003oi^KVonKViP0EonKViP03oda<C?oVi^Koi^KV03Soi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP05o`000?oVi^Koi^KVonKVi_l000001?oV
i^H00omVIVKoi^KVonKViP18onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oV
i^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`00000FonKViP03oda<C?oVi^Koi^KV03Woi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP03o`000?oVi^Koi^KV
00;o00001?oVi^H00omVIVKoi^KVonKViP17onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKV
iP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l0000EonKViP03oda<C?oV
i^Koi^KV03[oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`00
00?oi^KV00?o0000onKVi_l000001_oVi^H00omVIVKoi^KVonKViP16onKViP004OoVi^H01?l0003o
i^KVonKVi_l00008onKViP;o00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000
onKVi_oVi^H04ooVi^H00om<C4coi^KVonKViP0jonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0000Koi^KV00?oIVIVonKV
i_oVi^H0AOoVi^H001;oi^KV0_l0000:onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03
o`000?oVi^Koi^KV01;oi^KV00?oC4a<onKVi_oVi^H0??oVi^H2o`0000[oi^KV0_l00003onKViP?o
00000_oVi^H2o`0000Ooi^KV00?oIVIVonKVi_oVi^H0A?oVi^H002Woi^KV00?o0000onKVi_oVi^H0
4OoVi^H00om<C4coi^KVonKViP1ConKViP03o`000?oVi^Koi^KV00Koi^KV00?oIVIVonKVi_oVi^H0
A?oVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00004onKViP?o00000_oV
i^H00ol0003oi^KVonKViP0@onKViP03oda<C?oVi^Koi^KV03koi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00?oi^KV0_l00004onKViP?o000000?oi^KVo`000?l000002?oVi^H00omVIVKoi^KVonKV
iP13onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00Coi^KV00Go
0000onKVi_oVi^Koi^KVo`00000AonKViP03oda<C?oVi^Koi^KV03koi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00?oIVIV
onKVi_oVi^H0@_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oV
i^H5o`0000;oi^KV00?o0000onKVi_oVi^H03ooVi^H00om<C4coi^KVonKViP0nonKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP05o`000003onKVi_l0003o000000[o
i^KV00?oIVIVonKVi_oVi^H0@OoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000@onKViP03oda<C?oVi^Ko
i^KV03ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;o
i^KV00Co0000onKVi_oVi^Ko00003?oVi^H00omVIVKoi^KVonKViP10onKViP004OoVi^H01?l0003o
i^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_l000000ooVi^H00ol0
003oi^KVonKViP0=onKViP03oda<C?oVi^Koi^KV043oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Ko000000;oi^KV0_l0000;onKViP03ofIVI_oV
i^Koi^KV043oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00005onKViP;o00000ooV
i^H00ol0003oi^KVonKViP0<onKViP03oda<C?oVi^Koi^KV047oi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H01?l0003oi^KVonKVi_l00003onKViP;o00000_oVi^H00ol0003oi^KVonKViP0;onKViP03
ofIVI_oVi^Koi^KV03ooi^KV000BonKViP;o00002_oVi^H00ol0003oi^KVonKViP04onKViP05o`00
0?oVi^Koi^KVonKVi_l000003OoVi^H00om<C4coi^KVonKViP13onKViP;o00002_oVi^H2o`0000Go
i^KV00?o0000onKVi_oVi^H00_l0000=onKViP03ofIVI_oVi^Koi^KV03koi^KV000BonKViP;o0000
1?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H0
2ooVi^H00om<C4coi^KVonKViP13onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o0000
0ooVi^H3o`0000;oi^KV0_l0000>onKViP03ofIVI_oVi^Koi^KV03goi^KV000AonKViP04o`000?oV
i^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`00
00coi^KV00?oC4a<onKVi_oVi^H0@ooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`00000@onKViP03ofIVI_oVi^Koi^KV03coi^KV
000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04
o`000?oVi^Koi^KVo`0000_oi^KV00?oC4a<onKVi_oVi^H0A?oVi^H01?l0003oi^KVonKVi_l00008
onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l0000?onKViP03
ofIVI_oVi^Koi^KV03coi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oV
i^Koi^KV1?l00003onKViP03o`000?oVi^Koi^KV00Soi^KV00?oC4a<onKVi_oVi^H0AOoVi^H01?l0
003oi^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l00002onKViP03o`000?oV
i^Koi^KV00ooi^KV00?oIVIVonKVi_oVi^H0>ooVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV00?o0000onKVi_oVi^H02?oVi^H00om<C4coi^KV
onKViP15onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00005
onKViP;o00004OoVi^H00omVIVKoi^KVonKViP0jonKViP004OoVi^H01?l0003oi^KVonKVi_l00008
onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00Ooi^KV00?oC4a<
onKVi_oVi^H0A_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0AonKViP03ofIVI_oVi^Koi^KV03Woi^KV
000BonKViP;o00002_oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H00ol0003oi^KVonKV
iP06onKViP03oda<C?oVi^Koi^KV04Soi^KV0_l0000:onKViP;o00001?oVi^H2o`0000;oi^KV0_l0
000ConKViP03ofIVI_oVi^Koi^KV03Soi^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02
onKViP?o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H01OoVi^H00om<C4coi^KVonKViP19
onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000
onKVi_oVi^H04_oVi^H00omVIVKoi^KVonKViP0honKViP004OoVi^H01?l0003oi^KVonKVi_l00009
onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00006onKViP03oda<
C?oVi^Koi^KV04Woi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000?oi^KV00Co0000onKVi_l0003o00005?oVi^H00omVIVKoi^KVonKViP0gonKViP004OoVi^H0
1?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KV
onKVi_l00006onKViP03oda<C?oVi^Koi^KV04Woi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0
003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_l000005_oVi^H00omVIVKoi^KVonKV
iP0fonKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV0ol0
0003onKViP03o`000?oVi^Koi^KV00?oi^KV00?oC4a<onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKV
i_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP;o00005_oVi^H00omVIVKo
i^KVonKViP0eonKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKV
i_l000000ooVi^H01?l0003oi^KVonKVi_l00004onKViP03oda<C?oVi^Koi^KV04_oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0
003o00005ooVi^H00omVIVKoi^KVonKViP0donKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKV
iP;o00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVoda<
C01>onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP03o`000?oVi^Ko000001Woi^KV00?oIVIVonKVi_oVi^H0<ooVi^H001;oi^KV0_l0000:onKViP03
o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP05o`000?oVi^Koi^KVonKVi_m<C4`0CooVi^H2o`00
00[oi^KV0_l00003onKViP?o00000_oVi^H2o`0001Soi^KV00?oIVIVonKVi_oVi^H0<ooVi^H001So
i^KV0_l00004onKViP04o`000?oVi^Koi^KVonKViPGo00000_oVi^H01?l0003oi^KVonKVi_m<C4aF
onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H00ol0003oi^KVonKViP0H
onKViP03ofIVI_oVi^Koi^KV03;oi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVoda<C01FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00Co0000onKVi_oVi^Koi^KV0_l0000JonKViP03ofIVI_oVi^Koi^KV037oi^KV000GonKViP04o`00
0?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oC4a<onKViP1FonKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00000LonKViP03ofIVI_oVi^Ko
i^KV033oi^KV000GonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVoda<
C01HonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l0000LonKViQko
IVIV5?oVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00;oi^KV00?o0000onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Ko
i^KVonKVi_l00000CooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000005_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0005?oi^KV000HonKViP;o0000
2OoVi^H3o`0005goi^KV0_l0000:onKViP03o`000?oVi^Koi^KV057oi^KV003SonKViP00hooVi^H0
03[oi^KV1?l00004onKViP;o00000_oVi^H3o`0000?oi^KV1Ol0001>onKViPGo000000Koi^KVo`00
0?l0003o0000onKVi_l00003onKViP;o00000_oVi^H2o`000003onKVi_l0003o000000Co00001?oV
i^H3o`0002;oi^KV000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP03onKViP04o`000?oVi^Koi^KVo`0004ooi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0ooVi^H01?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00027oi^KV000konKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03
onKViP03o`000?oVi^Koi^KV053oi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0003oi^KVo`000?l0
003oi^KVo`0000Goi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00Koi^KV00?o0000onKVi_oVi^H0
7ooVi^H003_oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP?o
00000ooVi^H00ol0003oi^KVonKViP1@onKViP?o00000ooVi^H01_l0003oi^KVo`000?l0003oi^KV
o`0000Koi^KV00?o0000onKVi_l000000ooVi^H3o`0000Coi^KV0_l0000RonKViP00>ooVi^H01?l0
003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP1@onKViP03o`000?oVi^Koi^KV00?oi^KV0_l000001?oVi^Ko0000
onKVi_l00006onKViP03o`000?oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0
003oi^KVonKViP0RonKViP00>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1@onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV0_l000001OoVi^Ko0000onKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oV
i^Koi^KVo`000004onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00008OoV
i^H003[oi^KV1?l00002onKViP?o000000?oi^KVo`000?l000001?l00002onKViP?o0000D?oVi^H5
o`000004onKVi_l0003o0000onKViP?o00000_oVi^H3o`0000;oi^KV0_l00003onKViPCo00001?oV
i^H3o`00027oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKV
iP00hooVi^H009[oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00005onKViPGo0000
1?oVi^H5o`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000Goi^KV0ol0000DonKViP004OoV
i^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H3o`0007_oi^KV00?o0000onKVi_oVi^H01ooV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003o
i^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000001?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KV
o`00001honKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KV
onKViP06onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0003oi^KV
onKViP0AonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViPGo00000_oVi^HRoaTI6EOoi^KV
00?o0000onKVi_oVi^H02ooVi^H00ol0003oi^KVonKViP05onKViP03o`000?oVi^Koi^KV00Koi^KV
00?o0000onKVi_oVi^H02_oVi^H00ol0003oi^KVonKViP03onKViP;o00005?oVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV01ko
i^KV00?o6ATIonKVi_oVi^H0EOoVi^H00ol0003oi^KVonKViP07onKViPCo00001OoVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Coi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViPCo00002?oVi^H0
0ol0003oi^KVonKViP0AonKViP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Ko
000000?oi^KV00?o0000onKVi_oVi^H07ooVi^H00olI6AWoi^KVonKViP1ConKViP;o00002OoVi^H0
0ol0003oi^KVonKViP06onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H01OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000001?o
i^KV000@onKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00003onKViP03o`000?oVi^Koi^KV023o
i^KV00?o6ATIonKVi_oVi^H0DooVi^H00ol0003oi^KVonKViP07onKViPGo00001OoVi^H3o`0000Ko
i^KV0ol00008onKViPGo00001?oVi^H3o`0001Coi^KV000AonKViP;o00001?oVi^H00ol0003oi^KV
onKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP0QonKViP03oaTI6OoVi^Koi^KV04[oi^KV
00?o0000onKVi_oVi^H0COoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H08_oVi^H00olI6AWoi^KVonKViP18onKViP03
o`000?lc<c?o000003co00004_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003o
i^KVonKVi_l0000TonKViP03oaTI6OoVi^Koi^KV04Woi^KV00Co<c<conKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000DonKViP004?oVi^H01?l0003oi^KVonKVi_l0000;
onKViP04o`000?oVi^Koi^KVo`0002Goi^KV00?o6ATIonKVi_oVi^H0B?oVi^H00ol0003o<c<conKV
iP1=onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000ooVi^H00ol0003oi^KVonKV
iP0TonKViP03oaTI6OoVi^Koi^KV04Ooi^KV00?o0000onKVi_lc<c<0COoVi^H0013oi^KV00Co0000
onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV02Goi^KV00?o
6ATIonKVi_oVi^H0A_oVi^H2o`000003onKVi_lc<c?oi^KV04_oi^KV000AonKViP;o00002?oVi^H5
o`0000;oi^KV00?o0000onKVi_oVi^H09_oVi^H00olI6AWoi^KVonKViP0_onKViP;o00001?oVi^H0
0ol0003oi^KVonKViP03onKViP;o00000_oVi^H5o`000003onKVi_l0003oi^KV00;oi^KV00?o<c<c
onKVi_oVi^H0BOoVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKV
iP03o`000?oVi^Koi^KV02Ooi^KV00?o6ATIonKVi_oVi^H0;OoVi^H01?l0003oi^KVonKVi_l00008
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Go0000onKVi_oVi^Ko0000onKViP02o`0000;oi^KV
00?o<c<conKVi_oVi^H0BOoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H09ooVi^H00olI6AWoi^KVonKViP0]onKViP04
o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Coi^KV00?o<c<conKVi_oVi^H0B?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0:?oVi^H00olI6AWoi^KV
onKViP0/onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H00ol0
003oi^KVonKViP02o`0000Coi^KV00?o<c<conKVi_oVi^H0AooVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H0:OoVi^H00olI6AWoi^KVonKViP0[onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`00
0?oVi^Ko0000o`0000Goi^KV00?o<c<conKVi_oVi^H0A_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV02[oi^KV00?o6ATIonKVi_oV
i^H0:_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H00ol0003oi^KVo`000007onKViP03oc<c<ooVi^Koi^KV04Goi^KV000@onKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP0[onKViP03oaTI6OoV
i^Koi^KV02[oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000;oi^KV0_l00007onKViP03oc<c<ooV
i^Koi^KV04Coi^KV000AonKViP;o00002_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H0:ooVi^H0
0olI6AWoi^KVonKViP0ZonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00001?oVi^H3
o`000003onKVi_l0003oi^KV00Ooi^KV00?o<c<conKVi_oVi^H0A?oVi^H0017oi^KV0_l00004onKV
iP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0/onKV
iP03oaTI6OoVi^Koi^KV02Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l0
0004onKViP03o`000?oVi^Koi^KV00;o00002?oVi^H00olc<c?oi^KVonKViP13onKViP004?oVi^H0
1?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0;OoV
i^H00olI6AWoi^KVonKViP0WonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko
0000onKViP05o`000003onKVi_l0003oi^KV00Woi^KV00?o<c<conKVi_oVi^H0@_oVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000033oi^KV00?o6ATIonKV
i_oVi^H09_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP02o`0000[oi^KV00?o<c<conKVi_oVi^H0@OoVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000037oi^KV00?o6ATIonKVi_oV
i^H09OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000
onKVi_l000000_oVi^H00ol0003oi^KVonKViP0:onKViP03oc<c<ooVi^Koi^KV043oi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko0000<OoVi^H00olI6AWoi^KVonKV
iP0UonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H2o`0000;o
i^KV0_l0000;onKViP03oc<c<ooVi^Koi^KV043oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV033oi^KV00?o6ATIonKV
i_oVi^H09OoVi^H2o`0000[oi^KV0_l00005onKViP04o`000?oVi^Koi^KVo`0000goi^KV00?o<c<c
onKVi_oVi^H0?ooVi^H0017oi^KV0_l00008onKViPGo00000_oVi^H00ol0003oi^KVonKViP0aonKV
iP03oaTI6OoVi^Koi^KV03[oi^KV0_l0000=onKViP03oc<c<ooVi^Koi^KV03koi^KV000AonKViP;o
00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP0bonKViP03
oaTI6OoVi^Koi^KV02?oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o
00000_oVi^H2o`0000koi^KV00?o<c<conKVi_oVi^H0?OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0<ooVi^H00olI
6AWoi^KVonKViP0QonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKV
i_l00003onKViP03o`000?oVi^Ko0000013oi^KV00?o<c<conKVi_oVi^H0??oVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oV
i^H0<ooVi^H00olI6AWoi^KVonKViP0QonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKV
i_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0000ooi^KV00?o<c<conKVi_oVi^H0
??oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H0
=?oVi^H00olI6AWoi^KVonKViP0PonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oV
i^Ko0000onKViP04o`0000;oi^KV00?o0000onKVi_oVi^H03ooVi^H00olc<c?oi^KVonKViP0konKV
iP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H0
0ol0003oi^KVonKViP0eonKViP03oaTI6OoVi^Koi^KV01ooi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Goi^KV0_l0000AonKViP03oc<c<ooVi^Koi^KV03[o
i^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKV
iP03o`000?oVi^Koi^KV03Koi^KV00?o6ATIonKVi_oVi^H07_oVi^H01?l0003oi^KVonKVi_l00008
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKV
iP0AonKViP03oc<c<ooVi^Koi^KV03Woi^KV000AonKViP;o00002OoVi^H3o`0000?oi^KV00?o0000
onKVi_oVi^H0=ooVi^H00olI6AWoi^KVonKViP0NonKViP;o00002_oVi^H2o`0000Coi^KV0_l00002
onKViP;o00004ooVi^H00olc<c?oi^KVonKViP0honKViP004OoVi^H2o`0000Coi^KV00?o0000onKV
i_oVi^H00_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H0>?oVi^H00olI6AWoi^KVonKViP0MonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKV
i_oVi^H04_oVi^H00olc<c?oi^KVonKViP0honKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKV
iP05o`000?oVi^Koi^KVonKVi_l000002?oVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3
o`0000Koi^KV1Ol00006onKViPGo00000ooVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H0
0olI6AWoi^KVonKViP03onKViP?o00005_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l0000DonKViP03oc<c<ooVi^Koi^KV
03Ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H0
0ol0003oi^KVonKViP07onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H01?l0003oi^KVonKV
i_l00007onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKV
iP05oaTI6OoVi^Koi^KVonKVi_l000000ooVi^H00ol0003oi^KVonKViP0ConKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`00
01Goi^KV00?o<c<conKVi_oVi^H0=_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H4o`00
00;oi^KV00?o0000onKVi_oVi^H01ooVi^H00ol0003oi^KVonKViP0;onKViP03o`000?oVi^Koi^KV
00Goi^KV00?o0000onKVi_oVi^H02?oVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KV
onKVi_lI6AT01_oVi^H00ol0003oi^KVonKViP0ConKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H05OoVi^H00olc<c?oi^KV
onKViP0eonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l0
00000_oVi^H00ol0003oi^KVonKViP07onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oV
i^H01_oVi^H00ol0003oi^KVonKViP08onKViP03o`000?oVi^Koi^KV00[oi^KV00?o0000onKVi_oV
i^H00_oVi^H01?lI6AWoi^KVonKVi_oVi^H2o`0001Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o00005ooVi^H00olc<c?o
i^KVonKViP0donKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKV
i_l000000_oVi^H00ol0003oi^KVonKViP07onKViP03o`000?oVi^Koi^KV00Ooi^KV1?l00006onKV
iP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV1?l0
0006onKViP03oaTI6OoVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H04ooVi^H01?l0003oi^KVonKV
i_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`00000IonKV
iP03oc<c<ooVi^Koi^KV03?oi^KV000AonKViP;o00002OoVi^H3o`0000?oi^KV00?o0000onKVi_oV
i^H01_oVi^H2o`0000Woi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00Koi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV00Ooi^KV00?o6ATI
o`000?oVi^H00_oVi^H00ol0003oi^KVonKViP0DonKViP;o00002_oVi^H2o`0000?oi^KV0ol00002
onKViP;o00006?oVi^H00olc<c?oi^KVonKViP0conKViP008_oVi^H00ol0003oi^KVonKViP07onKV
iP03o`000?oVi^Koi^KV00Ooi^KV1Ol00006onKViP?o00002?oVi^H3o`0000Soi^KV1Ol00006onKV
iP04oaTI6Ol0003o0000o`0001goi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002
onKViP03o`000?oVi^Koi^KV01Soi^KV00?o<c<conKVi_oVi^H0<_oVi^H002;oi^KV00?o0000onKV
i_oVi^H0?_oVi^H00olI6AWoi^KVonKViP0LonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000
onKVi_oVi^Koi^KV0_l0000JonKViP03oc<c<ooVi^Koi^KV037oi^KV000RonKViP03o`000?oVi^Ko
i^KV03ooi^KV00?o6ATIonKVi_oVi^H06ooVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oV
i^Koi^KVonKVi_l000007?oVi^H00olc<c?oi^KVonKViP0`onKViP008?oVi^I5o`000003oaTI6Ol0
003o000001[oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0001co
i^KV7_lc<c<DonKViP008_oVi^H00ol0003oi^KVonKViP1MonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP00P_oVi^H01?l0003oi^KVonKVi_l00008onKV
iP;o0000DooVi^H008?oi^KV0_l0000:onKViP03o`000?oVi^Koi^KV057oi^KV003SonKViP00=ooV
i^H2o`0000;oi^KV0ol00002onKViP03o`000?oVi^Ko000000;o00000ooVi^H3o`0000?oi^KV0ol0
001>onKViPCo00000_oVi^H5o`0000?oi^KV0_l00002onKViP;o000000?oi^KVo`000?l000001?l0
0004onKViP?o00008_oVi^H003Koi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKV
i_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002
onKViP03o`000?oVi^Koi^KV04coi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKV
i_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005
onKViP04o`000?oVi^Koi^KVo`00027oi^KV000eonKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000
onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00?o0000onKVi_oVi^H00ooV
i^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0
0_oVi^H00ol0003oi^KVonKViP03onKViPGo00000_oVi^H00ol0003oi^KVonKViP06onKViP03o`00
0?oVi^Koi^KV01ooi^KV000eonKViP03o`000?oVi^Koi^KV00Coi^KV0ol00002onKViP05o`000?oV
i^Koi^KVonKVi_l000000ooVi^H2o`0000Coi^KV0_l0001?onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV0ol00002onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000ooVi^H3o`0000Co
i^KV0_l0000RonKViP00=OoVi^H00ol0003oi^KVonKViP04onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP03o`000?oVi^Koi^KV04ooi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00Coi^KV00?o
0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV02;oi^KV
000fonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKV
iP1<onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003o
i^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l0000QonKViP00=ooVi^H3o`000003onKVi_l0003o000000;o00000ooVi^H3
o`0000Coi^KV0ol00003onKViP?o0000COoVi^H4o`0000;oi^KV1Ol00003onKViP?o00000_oVi^H2
o`0000?oi^KV1?l00004onKViP?o00008OoVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003S
onKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H005[oi^KV
1?l00025onKViP00FooVi^H2o`0008Koi^KV001KonKViP;o0000Q_oVi^H003ooi^KV1Ol00002onKV
iPCo00002OoVi^H5o`0000?oi^KV1Ol00002onKViP?o000000?oi^KVo`000?l000000_l000000ooV
i^Ko0000o`000004o`0000;oi^KV0_l000000ooVi^Ko0000o`000002o`000003onKVi_l0003o0000
00;o00001OoVi^H4o`0000;oi^KV3?l000000ooVi^Ko0000o`000004o`000003onKVi_l0003o0000
00Go0000?_oVi^H003koi^KV0_l00003onKViP;o00000_oVi^H2o`0000Woi^KV0_l00003onKViP;o
00000_oVi^H2o`0000;oi^KV1?l00002onKViP04o`000?oVi^Ko0000o`0000;oi^KV0_l000000ooV
i^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o0000
00Ooi^KV0_l00002onKViP?o000000Coi^KVo`000?l0003oi^KV0_l00002onKViP;o000000?oi^KV
o`000?l000000_oVi^H2o`000005onKVi_l0003o0000onKVi_l000000_oVi^H2o`0003goi^KV000m
onKViP;o00001?oVi^H2o`0000;oi^KV0_l00008onKViP;o00001OoVi^H2o`000003onKVi_l0003o
000000;oi^KV1?l00004onKViP;o00000_oVi^H2o`000003onKVi_l0003o000000;oi^KV0_l00000
0ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000001ooVi^H2o`000004onKVi_l0003o
0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_oV
i^H2o`000003onKVi_l0003o000000?oi^KV0ol0000monKViP00?OoVi^H2o`0000?oi^KV1?l00000
0ooVi^Ko0000o`000003o`0000Goi^KV0_l00005onKViP;o000000?oi^KVo`000?l000000_oVi^H7
o`000003onKVi_l0003o000000Coi^KV0ol00002onKViP;o000000?oi^KVo`000?l000000_oVi^H2
o`000003onKVi_l0003o000000Ooi^KV1Ol00005onKViP?o00000_oVi^H2o`000003onKVi_l0003o
000000;oi^KV1?l00002onKViP?o0000?ooVi^H003goi^KV0_l00008onKViP;o00000_oVi^H2o`00
00Coi^KV0_l00005onKViP;o000000Goi^KVo`000?l0003o0000onKViP04o`000004onKVi_l0003o
0000onKViPKo000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000;oi^KV0_l0
00000ooVi^Ko0000o`000002o`0000Goi^KV0_l00003onKViP;o000000Coi^KVo`000?l0003oi^KV
0_l00002onKViPGo00000_oVi^H2o`0000;oi^KV00Co0000onKVi_l0003o00000_oVi^H00ol0003o
i^KVonKViP0konKViP00?OoVi^H2o`0000Goi^KV00?o0000onKVi_oVi^H00_l00002onKViP;o0000
1?oVi^H2o`0000Goi^KV1Ol000000ooVi^Ko0000o`000002onKViP?o000000Ooi^KVo`000?l0003o
0000onKVi_l0003oi^KV00?o00000_oVi^H4o`000003onKVi_l0003o000000;o000000Koi^KVo`00
0?l0003o0000onKVi_l00005onKViP;o00000ooVi^H2o`0000;oi^KV0ol00002onKViP?o000000?o
i^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000o`000?oVi^H01?l0000monKViP00?_oV
i^H2o`0000?oi^KV0_l00002onKViP;o00000_oVi^H2o`0000Goi^KV0_l00003onKViP;o00006OoV
i^H2o`00017oi^KV0_l00003onKViP;o00003ooVi^H2o`0004Koi^KV000oonKViPCo000000?oi^KV
o`000?oVi^H01_l00007onKViPGo00006ooVi^H00ol0003oi^KVonKViP0>onKViPOo00003ooVi^H3
o`0004Koi^KV003SonKViP00hooVi^H00001\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-0.40598, \
-0.0445132, 0.0339412, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-4.02178, -0.0890264, 0.0339412, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-0.0256192, -0.711658, 0.0298148, 0.0144724}, {{118.125, \
214.938}, {214.625, 154.75}} -> {-3.91996, -0.725265, 0.0339412, 0.0112719}, \
{{11.5625, 108.438}, {148.812, 88.9375}} -> {-0.40598, -0.306114, 0.0339412, \
0.0027459}, {{118.125, 214.938}, {148.812, 88.9375}} -> {-4.02178, -0.406114, \
0.0339412, 0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> \
{-0.0129065, -2.61842, 0.0296264, 0.0144768}, {{118.125, 214.938}, {82.9375, \
23.0625}} -> {-4.02178, -0.587, 0.0339412, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 1}\\)}, {\\({DECAPS, \
0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, {\\({MUTAT, 1}\\)}, \
{\\({PERM, 0.604395`}\\)}, {\\({REPRO, 0.1`}\\)}, {\\({SHRINK, 0.1`}\\)}}, \
ColumnAlignments -> Left, GridBaseline -> {Baseline, {1, 1}}]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[_]\)\)[__]\)}\) is not present in \
expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No shrink performed."\)], \
"Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[_]\)\)[__]\)}\) is not present in \
expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No shrink performed."\)], \
"Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(4\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 0 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.73232 .00576 0 -8.88217 ]
[.73232 .00576 10.625 5.11783 ]
[.80701 .09195 0 -8.69794 ]
[.80701 .09195 10.625 5.30206 ]
[.87052 .16524 0 -8.54656 ]
[.87052 .16524 10.625 5.45344 ]
[.92519 .22833 0 -8.41997 ]
[.92519 .22833 10.625 5.58003 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.71869 .00942 m
.71188 .01126 L
s
gsave
.73232 .00576 -61 -12.8822 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.7933 .09528 m
.78644 .09694 L
s
gsave
.80701 .09195 -61 -12.6979 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.85674 .16829 m
.84985 .16981 L
s
gsave
.87052 .16524 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.91136 .23113 m
.90444 .23254 L
s
gsave
.92519 .22833 -61 -12.42 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.16815 .24691 m
.13455 .92146 L
s
.26233 .29961 m
.23906 .93186 L
s
.34519 .34598 m
.33001 .94091 L
s
.41866 .3871 m
.40989 .94886 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.40411 .34733 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.45294 .3376 m .57042 .37159 L .52233 .38044 L F
.40411 .34733 m .45294 .3376 L .52233 .38044 L F
.5031 .32761 m .61975 .36251 L .57042 .37159 L F
.45294 .3376 m .5031 .32761 L .57042 .37159 L F
.55465 .31734 m .67039 .35318 L .61975 .36251 L F
.5031 .32761 m .55465 .31734 L .61975 .36251 L F
.60764 .30678 m .72237 .34361 L .67039 .35318 L F
.55465 .31734 m .60764 .30678 L .67039 .35318 L F
.32346 .30014 m .45294 .3376 L .40411 .34733 L F
.66214 .29593 m .77575 .33379 L .72237 .34361 L F
.60764 .30678 m .66214 .29593 L .72237 .34361 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .39395 .92305 L p F P
0 0 0 r
s
.37437 .28909 m .5031 .32761 L .45294 .3376 L 1 0 0 r
F
.32346 .30014 m .37437 .28909 L .45294 .3376 L F
.7182 .28476 m .8306 .32369 L .77575 .33379 L F
.66214 .29593 m .7182 .28476 L .77575 .33379 L F
.57295 .92839 m .52132 .93033 L .44644 .9209 L p F P
0 0 0 r
s
.39395 .92305 m .44644 .9209 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.42676 .27772 m .55465 .31734 L .5031 .32761 L 1 0 0 r
F
.37437 .28909 m .42676 .27772 L .5031 .32761 L F
.77591 .27326 m .88697 .31331 L .8306 .32369 L .5 0 1 r
F
.7182 .28476 m .77591 .27326 L .8306 .32369 L 1 0 0 r
F
.62603 .92639 m .57295 .92839 L .50048 .91868 L p F P
0 0 0 r
s
.44644 .9209 m .50048 .91868 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.48069 .26602 m .60764 .30678 L .55465 .31734 L 1 0 0 r
F
.42676 .27772 m .48069 .26602 L .55465 .31734 L F
.83532 .26143 m .94492 .30264 L .88697 .31331 L 0 1 1 r
F
.77591 .27326 m .83532 .26143 L .88697 .31331 L .5 0 1 r
F
.68061 .92434 m .62603 .92639 L .55613 .91641 L p 1 0 0 r
F P
0 0 0 r
s
.50048 .91868 m .55613 .91641 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.53623 .25397 m .66214 .29593 L .60764 .30678 L 1 0 0 r
F
.48069 .26602 m .53623 .25397 L .60764 .30678 L F
.83532 .26143 m .89653 .24924 L .94492 .30264 L 0 1 1 r
F
.23158 .24637 m .37437 .28909 L .32346 .30014 L 1 0 0 r
F
.73675 .92223 m .68061 .92434 L .61346 .91406 L p F P
0 0 0 r
s
.55613 .91641 m .61346 .91406 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.59346 .24155 m .7182 .28476 L .66214 .29593 L .5 0 1 r
F
.53623 .25397 m .59346 .24155 L .66214 .29593 L 1 0 0 r
F
.44644 .9209 m .39395 .92305 L .30596 .91258 L p F P
0 0 0 r
s
.28468 .23372 m .42676 .27772 L .37437 .28909 L .5 0 1 r
F
.23158 .24637 m .28468 .23372 L .37437 .28909 L 1 0 0 r
F
.79453 .92005 m .73675 .92223 L .67256 .91164 L p F P
0 0 0 r
s
.61346 .91406 m .67256 .91164 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.65246 .22875 m .77591 .27326 L .7182 .28476 L 0 1 1 r
F
.59346 .24155 m .65246 .22875 L .7182 .28476 L .5 0 1 r
F
.50048 .91868 m .44644 .9209 L .36084 .91012 L p 1 0 0 r
F P
0 0 0 r
s
.30596 .91258 m .36084 .91012 L .44644 .9209 L p 1 0 0 r
F P
0 0 0 r
s
.33943 .22067 m .48069 .26602 L .42676 .27772 L 0 1 1 r
F
.28468 .23372 m .33943 .22067 L .42676 .27772 L .5 0 1 r
F
.85402 .91782 m .79453 .92005 L .7335 .90915 L p 1 0 0 r
F P
0 0 0 r
s
.67256 .91164 m .7335 .90915 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.71331 .21554 m .83532 .26143 L .77591 .27326 L .5 1 0 r
F
.65246 .22875 m .71331 .21554 L .77591 .27326 L 0 1 1 r
F
.55613 .91641 m .50048 .91868 L .41746 .90757 L p 1 0 0 r
F P
0 0 0 r
s
.36084 .91012 m .41746 .90757 L .50048 .91868 L p 1 0 0 r
F P
0 0 0 r
s
.39592 .20721 m .53623 .25397 L .48069 .26602 L 0 1 1 r
F
.33943 .22067 m .39592 .20721 L .48069 .26602 L F
.91529 .91551 m .85402 .91782 L .79638 .90657 L p .5 0 1 r
F P
0 0 0 r
s
.7335 .90915 m .79638 .90657 L .85402 .91782 L p 1 0 0 r
F P
0 0 0 r
s
.77609 .20192 m .89653 .24924 L .83532 .26143 L 1 0 0 r
F
.71331 .21554 m .77609 .20192 L .83532 .26143 L .5 1 0 r
F
.61346 .91406 m .55613 .91641 L .4759 .90495 L p 1 0 0 r
F P
0 0 0 r
s
.41746 .90757 m .4759 .90495 L .55613 .91641 L p 1 0 0 r
F P
0 0 0 r
s
.45423 .19332 m .59346 .24155 L .53623 .25397 L 0 1 1 r
F
.39592 .20721 m .45423 .19332 L .53623 .25397 L F
.97843 .91314 m .91529 .91551 L .8435 .46388 L p F P
0 0 0 r
s
.79638 .90657 m .8435 .46388 L .91529 .91551 L p .5 0 1 r
F P
0 0 0 r
s
.77609 .20192 m .84091 .18786 L .89653 .24924 L 1 0 0 r
F
.12592 .18455 m .28468 .23372 L .23158 .24637 L F
.67256 .91164 m .61346 .91406 L .53623 .90224 L p F P
0 0 0 r
s
.4759 .90495 m .53623 .90224 L .61346 .91406 L p 1 0 0 r
F P
0 0 0 r
s
.51443 .17897 m .65246 .22875 L .59346 .24155 L .5 1 0 r
F
.45423 .19332 m .51443 .17897 L .59346 .24155 L 0 1 1 r
F
.8435 .46388 m .90653 .45448 L .97843 .91314 L p F P
0 0 0 r
s
.90653 .45448 m .8435 .46388 L .78315 .41793 L p 1 0 0 r
F P
0 0 0 r
s
.8435 .46388 m .79638 .90657 L .71843 .42847 L p .5 1 0 r
F P
0 0 0 r
s
.71843 .42847 m .78315 .41793 L .8435 .46388 L p .5 1 0 r
F P
0 0 0 r
s
.36084 .91012 m .30596 .91258 L .20461 .90053 L p 1 0 0 r
F P
0 0 0 r
s
.18133 .16991 m .33943 .22067 L .28468 .23372 L 0 1 1 r
F
.12592 .18455 m .18133 .16991 L .28468 .23372 L 1 0 0 r
F
.7335 .90915 m .67256 .91164 L .59856 .89944 L p .5 0 1 r
F P
0 0 0 r
s
.53623 .90224 m .59856 .89944 L .67256 .91164 L p 1 0 0 r
F P
0 0 0 r
s
.57664 .16415 m .71331 .21554 L .65246 .22875 L 1 0 0 r
F
.51443 .17897 m .57664 .16415 L .65246 .22875 L .5 1 0 r
F
.78315 .41793 m .85002 .40705 L .90653 .45448 L p 1 0 0 r
F P
0 0 0 r
s
.41746 .90757 m .36084 .91012 L .26204 .89767 L p .5 0 1 r
F P
0 0 0 r
s
.20461 .90053 m .26204 .89767 L .36084 .91012 L p 1 0 0 r
F P
0 0 0 r
s
.23859 .15478 m .39592 .20721 L .33943 .22067 L 1 0 0 r
F
.18133 .16991 m .23859 .15478 L .33943 .22067 L 0 1 1 r
F
.79638 .90657 m .7335 .90915 L .65577 .43867 L p F P
0 0 0 r
s
.59856 .89944 m .65577 .43867 L .7335 .90915 L p .5 0 1 r
F P
0 0 0 r
s
.64095 .14883 m .77609 .20192 L .71331 .21554 L 1 0 0 r
F
.57664 .16415 m .64095 .14883 L .71331 .21554 L F
.4759 .90495 m .41746 .90757 L .33378 .43243 L p 0 1 1 r
F P
0 0 0 r
s
.26204 .89767 m .33378 .43243 L .41746 .90757 L p .5 0 1 r
F P
0 0 0 r
s
.2978 .13914 m .45423 .19332 L .39592 .20721 L 1 0 0 r
F
.23859 .15478 m .2978 .13914 L .39592 .20721 L F
.65577 .43867 m .71843 .42847 L .79638 .90657 L p 0 1 1 r
F P
0 0 0 r
s
.71843 .42847 m .65577 .43867 L .57788 .38867 L p 1 0 0 r
F P
0 0 0 r
s
.65577 .43867 m .59856 .89944 L .51378 .40017 L p .5 1 0 r
F P
0 0 0 r
s
.51378 .40017 m .57788 .38867 L .65577 .43867 L p .5 1 0 r
F P
0 0 0 r
s
.70747 .13298 m .84091 .18786 L .77609 .20192 L 1 0 0 r
F
.64095 .14883 m .70747 .13298 L .77609 .20192 L F
.53623 .90224 m .4759 .90495 L .39182 .42203 L p 0 1 1 r
F P
0 0 0 r
s
.33378 .43243 m .39182 .42203 L .4759 .90495 L p 0 1 1 r
F P
0 0 0 r
s
.39182 .42203 m .33378 .43243 L .22934 .3814 L p 1 0 0 r
F P
0 0 0 r
s
.33378 .43243 m .26204 .89767 L .14671 .88315 L p 0 1 1 r
F P
0 0 0 r
s
.14671 .88315 m .22934 .3814 L .33378 .43243 L p 0 1 1 r
F P
0 0 0 r
s
.35907 .12295 m .51443 .17897 L .45423 .19332 L 1 0 0 r
F
.2978 .13914 m .35907 .12295 L .45423 .19332 L F
.78315 .41793 m .71843 .42847 L .64423 .37678 L p F P
0 0 0 r
s
.57788 .38867 m .64423 .37678 L .71843 .42847 L p 1 0 0 r
F P
0 0 0 r
s
.70747 .13298 m .77632 .11657 L .84091 .18786 L 1 0 0 r
F
.59856 .89944 m .53623 .90224 L .45179 .41128 L p 0 1 1 r
F P
0 0 0 r
s
.39182 .42203 m .45179 .41128 L .53623 .90224 L p 0 1 1 r
F P
0 0 0 r
s
.45179 .41128 m .39182 .42203 L .29027 .36926 L p 1 0 0 r
F P
0 0 0 r
s
.22934 .3814 m .29027 .36926 L .39182 .42203 L p 1 0 0 r
F P
0 0 0 r
s
.42251 .10619 m .57664 .16415 L .51443 .17897 L 1 0 0 r
F
.35907 .12295 m .42251 .10619 L .51443 .17897 L F
.85002 .40705 m .78315 .41793 L .71292 .36447 L p F P
0 0 0 r
s
.64423 .37678 m .71292 .36447 L .78315 .41793 L p 1 0 0 r
F P
0 0 0 r
s
.26204 .89767 m .20461 .90053 L .08662 .88649 L p 1 0 0 r
F P
0 0 0 r
s
.45179 .41128 m .51378 .40017 L .59856 .89944 L p 0 1 1 r
F P
0 0 0 r
s
.51378 .40017 m .45179 .41128 L .35338 .35667 L p 1 0 0 r
F P
0 0 0 r
s
.29027 .36926 m .35338 .35667 L .45179 .41128 L p 1 0 0 r
F P
0 0 0 r
s
.48823 .08883 m .64095 .14883 L .57664 .16415 L 1 0 0 r
F
.42251 .10619 m .48823 .08883 L .57664 .16415 L F
.71292 .36447 m .78409 .35171 L .85002 .40705 L p F P
0 0 0 r
s
.08662 .88649 m .14671 .88315 L .26204 .89767 L p 1 0 0 r
F P
0 0 0 r
s
.57788 .38867 m .51378 .40017 L .41879 .34363 L p 1 0 0 r
F P
0 0 0 r
s
.35338 .35667 m .41879 .34363 L .51378 .40017 L p 1 0 0 r
F P
0 0 0 r
s
.55636 .07083 m .70747 .13298 L .64095 .14883 L 1 0 0 r
F
.48823 .08883 m .55636 .07083 L .64095 .14883 L F
.64423 .37678 m .57788 .38867 L .48663 .3301 L p F P
0 0 0 r
s
.41879 .34363 m .48663 .3301 L .57788 .38867 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .77632 .11657 L .70747 .13298 L 1 0 0 r
F
.55636 .07083 m .62703 .05216 L .70747 .13298 L F
.71292 .36447 m .64423 .37678 L .55704 .31606 L p F P
0 0 0 r
s
.48663 .3301 m .55704 .31606 L .64423 .37678 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .70039 .03278 L .77632 .11657 L 1 0 0 r
F
.78409 .35171 m .71292 .36447 L .63017 .30148 L p F P
0 0 0 r
s
.55704 .31606 m .63017 .30148 L .71292 .36447 L p 1 0 0 r
F P
0 0 0 r
s
.63017 .30148 m .70619 .28632 L .78409 .35171 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00001Golc<c003o`000?o<
c<coc<c<04Ooc<c<0Oooool006Soc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<o`00
0003olc<c0;o000000Goc<c<o`000?o<c<coc<c<o`000003olc<c003o`000?o<c<coc<c<05Coc<c<
00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`01?l0003oc<c<o`000?o<c<`2o`0000?oc<c<
0ol000001?o<c<co0000olc<c?l00002olc<c005o`000?o<c<coc<c<olc<c?l00000BOo<c<`3o`00
00[oc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00
J?o<c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<co000001coc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01coc<c<1?l000000oo<c<co0000
olc<c003olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00UOo<
c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<01Soc<c<1?l00005olc<c003o`000?o<
c<coc<c<00;oc<c<0_l00008olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Goc<c<00?o0000
olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c00Eolc<c0Co00003oo<c<`00ol0003oc<c<olc<c003
olc<c0?o0000BOo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c004olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Koc<c<00?o0000olc<c?o<
c<`01?o<c<`5o`00013oc<c<1?l0000Iolc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<
c<`0Aoo<c<`1ooooo`00Uoo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00ooc<c<
0ol00002olc<c003o`000?o<c<coc<c<01Woc<c<00?o0000olc<c?o<c<`0C?o<c<`1ooooo`00V?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00[oc<c<1?l0000Rolc<c003o`000?o<
c<coc<c<04_oc<c<0Oooool009?oc<c<1_l00005olc<c0Go00001?o<c<`4o`000003olc<c?l0003o
c<c<01Soc<c<0_oo0009olc<c003o`000?o<c<coc<c<04_oc<c<0Oooool00:Coc<c<0ol00005olc<
c003o`000?o<c<coc<c<01Coc<c<1_oo0009olc<c003o`000?o<c<coc<c<04[oc<c<0Oooool007?o
c<c<1?l0000Yolc<c0Go00006_o<c<`;ool000Woc<c<00?o0000olc<c?o<c<`0BOo<c<`1ooooo`00
L_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<02;oc<c<1?l00004olc<c003o`00
0?o<c<coc<c<01Goc<c<3ooo0009olc<c003o`000?o<c<coc<c<04Soc<c<0Oooool007Ooc<c<00?o
0000olc<c?o<c<`07oo<c<`3o`0001goc<c<4ooo0009olc<c003o`000?o<c<coc<c<04Ooc<c<0Ooo
ool007Ooc<c<00?o0000olc<c?o<c<`06oo<c<`4o`0000;oc<c<00?o0000olc<c?o<c<`05oo<c<`H
ool000Woc<c<00?o0000olc<c?o<c<`0A_o<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01Ooc<c<1?l00006olc<c003o`000?o<c<coc<c<01?oc<c<7Ooo0009olc<
c003o`000?o<c<coc<c<04Goc<c<0Oooool007;oc<c<1Ol0000Golc<c0?o00000_o<c<`00ol0003o
c<c<olc<c00Folc<c2?oo`002?o<c<`00ol0003oc<c<olc<c015olc<c07ooooo001bolc<c003o`00
0?o<c<coc<c<01Goc<c<1?l0000Jolc<c2Soo`002?o<c<`00ol0003oc<c<olc<c014olc<c07ooooo
001colc<c003o`000?o<c<coc<c<013oc<c<1?l000000oo<c<co0000olc<c00Golc<c2goo`002?o<
c<`00ol0003oc<c<olc<c007olc<c0Ko0000=_o<c<`1ooooo`00Loo<c<`5o`0000_oc<c<0ol0000J
olc<c37oo`002Oo<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<03Woc<c<0Oooool0
07ooc<c<1?l000000oo<c<co0000olc<c00Folc<c3Koo`002Oo<c<`00ol0003oc<c<olc<c006olc<
c003o`000?o<c<coc<c<03Soc<c<0Oooool004Woc<c<1_l00002olc<c003o`000?o<c<coc<c<00Co
00008oo<c<`4o`0001Woc<c<>ooo0009olc<c003o`000?o<c<coc<c<00Koc<c<0_l0000holc<c07o
oooo0019olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c00Molc<c0?o000000?oc<c<o`000?o<c<`05_o<c<a0ool000Woc<c<00?o0000olc<c?o<c<`0
1oo<c<`00ol0003oc<c<olc<c00eolc<c07ooooo001:olc<c003o`000?o<c<coc<c<00_oc<c<00?o
0000olc<c?o<c<`06Oo<c<`4o`0000Coc<c<00?o0000olc<c?o<c<`04Oo<c<a5ool000Ooc<c<0ol0
0009olc<c003o`000?o<c<coc<c<03Coc<c<0Oooool004_oc<c<0_l0000;olc<c003o`000?o<c<co
c<c<01Koc<c<0ol000000oo<c<co0000olc<c00Eolc<c4[oo`002?o<c<`00ol0003oc<c<olc<c002
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`0=?o<c<`1ooooo`00COo<c<`00ol0
003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`4o`00
00Coc<c<00?o0000olc<c?o<c<`04?o<c<a?ool000Soc<c<00Go0000olc<c?o<c<coc<c<o`000004
olc<c003o`000?o<c<coc<c<03Coc<c<0Oooool004koc<c<00?o0000olc<c?o<c<`00_o<c<`5o`00
017oc<c<1Ol0000Folc<c5Coo`002?o<c<`01?l0003oc<c<olc<c?o<c<`4o`0003Ooc<c<0Oooool0
04Woc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<
013oc<c<0ol00004olc<c003o`000?o<c<coc<c<013oc<c<FOoo0008olc<c003o`000?o<c<coc<c<
03_oc<c<0Oooool004Woc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c003
o`000?o<c<coc<c<00_oc<c<1Ol0000Folc<c5goo`002?o<c<`00ol0003oc<c<olc<c00jolc<c07o
oooo001:olc<c0Co00001_o<c<`5o`0000Goc<c<1?l00004olc<c003o`000?o<c<coc<c<013oc<c<
HOoo0009olc<c003o`000?o<c<coc<c<03Woc<c<0Oooool002ooc<c<1?l0000Xolc<c0?o000000?o
c<c<o`000?o<c<`05?o<c<aVool000Woc<c<00?o0000olc<c?o<c<`0>?o<c<`1ooooo`00;_o<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<027oc<c<1?l0000Folc<c6_oo`002Oo<c<`0
0ol0003oc<c<olc<c00golc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<
c?o<c<`07Oo<c<`4o`000003olc<c?l0003oc<c<01Coc<c<Kooo0008olc<c003o`000?o<c<coc<c<
01koc<c<1?l000001?o<c<co0000olc<c?o<c<`4o`0000;oc<c<00Oo0000olc<c?o<c<coc<c<o`00
0?o<c<co000000Coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<
c00Jolc<c0?o00005oo<c<adool000Soc<c<00?o0000olc<c?o<c<`07?o<c<`00ol0003oc<c<olc<
c002olc<c0;o000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<coc<c<00Coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00F
olc<c0Co000000?oc<c<o`000?o<c<`04oo<c<aiool000Soc<c<00?o0000olc<c?o<c<`06_o<c<`0
0ol0003oc<c<olc<c004olc<c003o`000?o<c<co000000Koc<c<00Go0000olc<c?o<c<coc<c<o`00
0006olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`4
o`0000Goc<c<00?o0000olc<c?o<c<`03oo<c<amool000Soc<c<00?o0000olc<c?o<c<`06Oo<c<`0
0ol0003oc<c<olc<c004olc<c003o`000?o<c<co000000Go000000?oc<c<o`000?o<c<`00_o<c<`0
0ol0003oc<c<olc<c004olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<
c?o<c<`03oo<c<`3o`0000;oc<c<00?o0000olc<c?o<c<`04_o<c<b2ool000Soc<c<00?o0000olc<
c?o<c<`01oo<c<`4o`0000goc<c<00Co0000olc<c?o<c<coc<c<1?l000000oo<c<co0000olc<c003
olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<c<`00ol0
003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00_oc<c<1?l0000Golc<c8Koo`002?o<c<`00ol0
003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`02_o<c<`00ol0
003oc<c<olc<c006olc<c003o`000?o<c<coc<c<00;oc<c<00Co0000olc<c?l0003o00000_o<c<`0
0ol0003oc<c<olc<c004olc<c07ooooo000_olc<c0Co00002_o<c<`4o`0000?oc<c<00?o0000olc<
c?o<c<`04Oo<c<`4o`3oohKoo`002Oo<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00Co00000_o<c<`01?l0003oc<c<o`000?l00007olc<c07ooooo000jolc<c0Co00005oo<c<`8o`3o
ohKoo`002?o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coc<c<00_oc<c<00?o0000olc<
c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c07ooooo000folc<c0Co00000oo<c<`00ol0003o
c<c<olc<c00Bolc<c0go0?ooB_oo0004ogoo03Ooo`002?o<c<`2o`0000Koc<c<0ol0000?olc<c0Co
00005Oo<c<`1ooooo`00<_o<c<`4o`000003olc<c?l0003oc<c<01Koc<c<4Ol0oom5ool000WoOol0
=ooo0006olc<c003o`000?o<c<co000000Woc<c<00?o0000olc<c?o<c<`09Oo<c<`1ooooo`00;oo<
c<`3o`0001Woc<c<1?oo000Co`3ood3oo`003Omoo`0gool000Soc<c<00Go0000olc<c?o<c<coc<c<
o`000004olc<c003o`000?o<c<coc<c<02Goc<c<0Oooool002goc<c<0_l000000oo<c<co0000olc<
c00Dolc<c0[oo`004ol0oolkool001;oOol0=ooo0008olc<c004o`000?o<c<coc<c<o`0000Coc<c<
00?o0000olc<c?o<c<`09Oo<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?l0000Aolc<c13oo`00
4ol0ooleool000Co0?oo4omoo`0gool000Soc<c<00?o0000olc<c?o<c<`01?l0000Xolc<c07ooooo
000]olc<c004o`000?o<c<coc<c<ofIVIQ7oc<c<4_oo000Bo`3oobooo`002_l0oolCogoo03Ooo`00
2?o<c<`00ol0003oc<c<olc<c00[olc<c07ooooo000]olc<c0;o000000?oc<c<ofIVI_o<c<`04_o<
c<`Aool001?o0?oo:?oo000@o`3ooa?oOol0=_oo0009olc<c003o`000?o<c<coc<c<02[oc<c<0Ooo
ool002goc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`Bool001;o0?oo8ooo000Eo`3ooa?oOol0=_oo
0008olc<c003o`000?o<c<coc<c<02[oc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV5_o<
c<`Aool001?o0?oo7?oo000Lo`3ooa?oOol0=Ooo0008olc<c003o`000?o<c<coc<c<02Woc<c<0Ooo
ool002goc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`Aool001;o0?oo5_oo000Ro`3ooa?oOol08Ooo
0003ogoo017oo`002?o<c<`00ol0003oc<c<olc<c00Xolc<c07ooooo000]olc<c004o`000?o<c<co
c<c<ofIVIQWoc<c<4_oo000Bo`3ooa3oo`009ol0oolCogoo01_oo`002Omoo`0Aool000Soc<c<00?o
0000olc<c?o<c<`09oo<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c17oo`004_l0
ool<ool002co0?oo4_moo`0Eool000ooOol04Ooo0008olc<c003o`000?o<c<coc<c<00[oc<c<00?o
0000olc<c?o<c<`06Oo<c<`1ooooo`00;?o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01goc<c<4Ooo
000Bo`3oo`Koo`00<Ol0oolBogoo00ooo`001?l0oolAogoo017oo`002?o<c<`00ol0003oc<c<olc<
c009olc<c003o`000?o<c<coc<c<01Woc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV7oo<
c<`Aool001;o0?oo0_oo000eo`3ooa;oOol02ooo0008o`3ooa7oOol04Ooo0008olc<c003o`000?o<
c<coc<c<00Coc<c<1_l0000Jolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIR7oc<c<4Ooo
000>o`3oo`CoO`3o=_l0oolBogoo00Koo`003Ol0oolAogoo017oo`002?o<c<`00ol0003oc<c<olc<
c003olc<c005o`000?o<c<coc<c<olc<c?l000006oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<
c?mVIVHSolc<c17oo`001ol0ool:ogl0ocOo0?oo4Omoo`02ool0017o0?oo4Omoo`0Aool000Koc<c<
0ol00005olc<c004o`000?o<c<coc<c<o`0001_oc<c<0Oooool002coc<c<00Co0000olc<c?o<c<co
IVIV9?o<c<`Aool000;o0?oo4?mo0?lfo`3oo`koOol01?mo0?lBo`3ooa7oOol04Ooo0007olc<c003
o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?l000006oo<c<`1ooooo`00;?o<c<`2o`000003olc<
c?mVIVKoc<c<02Goc<c<4Ooo000Bogl0ocGo0?oo2?moo`0:ogl0oa;o0?oo4Omoo`0Aool000Ooc<c<
00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<o`00000Kolc<c07ooooo000/olc<c004o`000?o<
c<coc<c<ofIVIRSoc<c<4Ooo000Aogl0ocGo0?oo0_moo`0@ogl0oa;o0?oo4Omoo`0Aool000Ooc<c<
00?o0000olc<c?o<c<`00oo<c<`2o`0001_oc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV
6_o<c<`00omVIVKoc<c<olc<c00<olc<c17oo`004_mo0?l`o`3oo`Goo`004Omo0?lBo`3ooa7oOol0
4Ooo0007olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`06Oo<c<`1ooooo`00;?o<
c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00koc<c<4Ooo000Bogl0obOo0?oo
3Ooo000Aogl0oa;o0?oo4Omoo`0>ool000;o0?oo2?o<c<`00ol0003oc<c<olc<c00Nolc<c07ooooo
000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`04?o<c<`Aool0017oO`3o
8?l0oolDool0017oO`3o4_l0oolAogoo00Soo`002?l0ool8olc<c003o`000?o<c<coc<c<01goc<c<
0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Bolc<c13oo`00
4_mo0?lIo`3ooa_oo`004Omo0?lAo`3ooa7oOol00_oo000>o`3oo`Ooc<c<00?o0000olc<c?o<c<`0
7Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01?oc<c<
4Ooo000Aogl0oaCo0?oo8?oo000Aogl0oa7o0?oo3_moo`02ogl0oa7o0?oo1oo<c<`00ol0003oc<c<
olc<c00Lolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`0
5Oo<c<`Aool0017oO`3o3_l0oolUool0017oO`3o4Ol0ool8ogoo00SoO`3o4Ol0ool7olc<c003o`00
0?o<c<coc<c<00Soc<c<1?l0000?olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<
00?oIVIVolc<c?o<c<`05oo<c<`@ool001;oO`3o1ol0ool/ool0013oO`3o4Ol0ool2ogoo00koO`3o
4Ol0ool7olc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c00<olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`0
6Oo<c<`@ool0017oO`3o0_l0oolaool0013oO`3o3_l0ool4ool000ooO`3o4Ol0ool7olc<c003o`00
0?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`03?o<c<`1ooooo`00;?o<c<`2o`000003olc<c?mV
IVKoc<c<01Woc<c<00?oIVIVolc<c?o<c<`06oo<c<`@ool000goO`3o=_oo000@ogl0o`So0?oo2_oo
000?ogl0oa7o0?oo1oo<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coc<c<00coc<c<0Ooo
ool002_oc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Molc<c0ooo`002?mo
0?llool000[oO`3o1?l000000omo0?oo0?ooo`3oo`0@ool000ooO`3o4Ol0ool6olc<c0;o00001Oo<
c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00coc<c<0Oooool002_oc<c<00Co0000
olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Nolc<c13oo`000_mo0?m1ool000CoO`3o1Ol0
0004ool00003o`000?oo003oo`00017oo`003omo0?lAo`3oo`Ooc<c<00?o0000olc<c?o<c<`00_o<
c<`5o`0000ooc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<
c00Qolc<c57oo`001?l0000:ool00003o`000?oo003oo`00017oo`003omo0?lAo`3oo`?oc<c<00?o
IVIVolc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c00Aolc<c07ooooo000[olc<c004o`000?o<c<co
c<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00<olc<c4[oo`001Ol0
000?ool00003o`000?oo003oo`00017oo`003omo0?lAo`3oo`;oc<c<00?oIVIVolc<c?o<c<`01_o<
c<`00ol0003oc<c<olc<c00@olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00>olc<c4?oo`001Ol0000Eool00003o`000?oo
003oo`00017oo`003omo0?lAo`3oo`03olc<c?mVIVKoc<c<00Ooc<c<1Ol0000>olc<c07ooooo000[
olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<
c00?olc<c3coo`001_l00005ool00003o`000?oo003oo`0001?oo`000_l0000Bool000ooO`3o3_l0
ool3olc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<
c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<=Ooo0005o`0000coo`0000?o
0000ool00?oo00005?oo00000ol0003oo`00ool0000@ool000ooO`3o2?l0ool8olc<c003ofIVI_o<
c<coc<c<01Woc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<
c00Dolc<c003ofIVI_o<c<coc<c<01?oc<c<;_oo0005o`0001;oo`000_l0000Eool00003o`000?oo
003oo`00013oo`003omo0?l2o`3oo`goc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00:oo<c<`0
1?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`05?o<
c<`Yool000Co00001?oo00000ol0003oo`00ool0000Bool00003o`000?oo003oo`0001?oo`0000?o
0000ool00?oo00004?oo000;ogl0oa;oc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00:oo<c<`2
ofIVIP03o`000?mVIVKoc<c<01Woc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00F
olc<c2;oo`001Ol00009ool000;o00004ooo00000ol0003oo`00ool0000Cool00003o`000?oo003o
o`00013oo`000omo0?lIolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool0023oc<c<1?l00007olc<
c004o`000?o<c<coIVIVofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00G
olc<c1goo`001?l0000@ool00003o`000?oo003oo`00017oo`000_l0000Dool00003o`000?oo003o
o`0000coo`007oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000Oolc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c003ofIVIQSoc<c<00?oIVIVolc<
c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Iolc<c1Koo`001Ol0000Eool00003o`000?oo003oo`00
01;oo`0000?o0000ool00?oo00004_oo0002o`0000Goo`001?o<c<`00omVIVKoc<c<olc<c00Oolc<
c003ofIVI_o<c<coc<c<01Woc<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003o
c<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP;oc<c<0_mVIVHFolc<c003ofIVI_o<c<coc<c<
01Coc<c<00?oIVIVolc<c?o<c<`06_o<c<`@ool000Go00001Ooo00000ol0003oo`00ool0000Cool0
00;o00004ooo00000ol0003oo`00ool0000Cool00003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<
c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;o
c<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH4olc<c0?oIVIV4oo<c<`00omV
IVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01coc<c<2Ooo0005o`0000coo`0000?o0000ool0
0?oo00004ooo00000ol0003oo`00ool0000Aool000;o00005?oo00000ol0003oc<c<olc<c005olc<
c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV1oo<c<`2ofIV
IQ7oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<
00[oc<c<0_oo0005o`0001;oo`000_l0000Dool000;o00004ooo00000ol0003oo`00ool0000Bool0
0003o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`01Ol0003o
c<c<olc<c?o<c<coIVIV00Woc<c<0_mVIVH?olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<
c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c007olc<c0Go00001?oo00000ol0003oo`00ool0000Bool0
00;o00005?oo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`0001;oo`0000?o0000olc<
c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool001oo
c<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<ofIV
IPcoc<c<0_mVIVH=olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00omV
IVKoc<c<olc<c002olc<c0Go00002ooo00000ol0003oo`00ool0000Bool00003o`000?oo003oo`00
01;oo`0000?o0000ool00?oo00004Ooo0002o`00013oo`000_l000000ooo003o0000o`000003olc<
c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<coIVIV3_o<c<`2ofIV
IP_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Aolc<c0Go00004Ooo0002o`00
01?oo`000_l0000Cool000;o00004ooo00000ol0003oo`00ool00007ool000Ko00001Ooo00001?l0
003oc<c<olc<c?mVIVHRolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool0023oc<c<1?l00006olc<
c004o`000?o<c<coc<c<ofIVIQ3oc<c<0_mVIVH9olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIV
olc<c?o<c<`03?o<c<`5o`0000Coo`0000?o0000ool00?oo00004Ooo0002o`0001?oo`000_l0000C
ool00003o`000?oo003oo`00017oo`0000Co0000ool00?oo003oo`001Ol0000<ool00003o`000?o<
c<coIVIV02;oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`2o`000003olc<c?mVIVKo
c<c<017oc<c<0_mVIVH7olc<c003ofIVI_o<c<coc<c<01?oc<c<00?oIVIVolc<c?o<c<`02?o<c<`5
o`0000_oo`0000?o0000ool00?oo00004Ooo0002o`0001?oo`0000?o0000ool00?oo00004Ooo0002
o`0000ooo`000_l000001?oo003o0000o`000?l0000Bool00003o`000?mVIVKoc<c<027oc<c<00?o
IVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHDolc<c0;oIVIV1Oo<
c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<00?oc<c<1Ol0000Aool000;o00004ooo
0002o`0001;oo`000_l0000Cool00003o`000?oo003oo`0000Ooo`001Ol00005ool00003o`000?oo
003oo`00017oo`0000?o0000olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Z
olc<c004o`000?o<c<coc<c<ofIVIQKoc<c<0_mVIVH3olc<c003ofIVI_o<c<coc<c<01?oc<c<00?o
IVIVo`000?l000000ol00004ool00003o`000?oo003oo`00017oo`000_l0000Cool00003o`000?oo
003oo`00017oo`000_l0000Bool00004o`000?oo003oo`00ool000Go00002ooo0002o`0001;oo`00
00?o0000olc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<
c<coc<c<ofIVIQSoc<c<0omVIVHBolc<c0Go00002ooo0002o`0001;oo`000_l0000Bool000;o0000
4ooo00000ol0003oo`00ool0000<ool000?o000000Coo`00o`000?l0003o00004_oo00000ol0003o
o`00ool0000@ool000;o00007oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`00
0?o<c<coc<c<ofIVIQ[oc<c<0omVIVH=olc<c0?o00004_oo0002o`0001;oo`000_l0000Bool000;o
00004_oo0002o`0000Coo`002?l00006ool00003o`000?oo003oo`00017oo`0000?o0000ool00?oo
00004Ooo00000ol0003oc<c<olc<c00Lolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<
00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c002ofIVIP_oc<c<00?o0000o`3oool0
00005?oo0002o`0001;oo`0000?o0000ool00?oo00004Ooo0002o`00013oo`0000?o0000ool00?l0
00000ol0000?ool000;o00004_oo0002o`0001;oo`0000?o0000olc<c?o<c<`06oo<c<`00omVIVKo
c<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<
c<`00_o<c<`2ofIVIPWoc<c<00Co0000o`3oool0oooo0?oo0_l0000Cool000;o00004Ooo0002o`00
01?oo`0000?o0000ool00?oo00002?oo0005o`0000CoOol000?o0000ool00?oo00004?oo00000ol0
003oo`00ool0000Aool00003o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`06_o<c<`00omV
IVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<
c?o<c<`01?o<c<`2ofIVIPOoc<c<00?o0000o`3oool0ool00ol0ool2o`0001?oo`000_l0000Aool0
00;o00004_oo0002o`0000?oo`001Ol0000:ogoo00;o00004Ooo00000ol0003oo`00ool0000Aool0
00;o00004Ooo00000ol0003oc<c<olc<c00Iolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[o
c<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c006olc<c0;oIVIV1?o<c<`00ol0
003o0?ooo`3oo`06o`3oo`;o00004ooo0002o`00017oo`000_l0000@ool00003o`000?oo003o0000
00;o00004Omoo`000ol0003oo`00ool0000?ool000;o00004ooo00000ol0003oo`00ool0000?ool0
0003o`000?o<c<coc<c<01Soc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003o
c<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00Soc<c<0_mVIVH2olc<c003o`000?l0oooo0?oo
00So0?oo0_l0000Cool000;o00004Ooo00000ol0003oo`00ool00008ool000Go00000_l0ool00ol0
003oOol0ogoo000Bogoo00;o00004Ooo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`00
00ooo`0000?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004
o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`02_o<c<`2ofIVIP03o`000?l0oooo0?oo
00[o0?oo0ol0000Bool000;o00004?oo0002o`0000?oo`001Ol00007o`3oo`03o`000?moo`3oOol0
01CoOol000?o0000ool00?oo00003ooo0002o`0001;oo`000_l0000<ool000?o000000?oo`00o`00
0?l000005oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c0;o000000?oc<c<ofIVI_o<
c<`06Oo<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo00go0?oo0_l0000Bool000;o
00003Ooo0002o`000004ool00?l0003o0000o`0000co0?oo00?o0000ogoo0?moo`005Omoo`02o`00
017oo`0000?o0000ool00?oo00004Ooo00000ol0003oo`00ool00002ool000Oo00001_oo00000ol0
003oc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002Woc<c<00Go0000olc<c?o<
c<coc<c<ofIVIP0Jolc<c003ofIVI_o<c<coc<c<00coc<c<00?o0000o`3oool0ool03ol0ool2o`00
01;oo`000_l00004ool000Oo00004ol0ool00ol0003oOol0ogoo000Fogoo0003o`000?oo003oo`00
00ooo`0000?o0000ool00?oo00003_oo0002o`000003ool00?l0003o000000;o00003_oo00000ol0
003oc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<
c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo017o0?oo0_l0000@ool0
0003o`000?oo003o000000?o00006_l0ool00ol0003oOol0ogoo000Gogoo00;o00004?oo0002o`00
00Woo`001Ol00005ogoo0003o`000?oo003oo`0000koo`0000?o0000olc<c?o<c<`04oo<c<`4ofIV
IQKoc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00;olc<
c003o`000?l0oooo0?oo01Co0?oo0_l00009ool000Go00004?l0ool00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol001WoOol000?o0000ool00?oo00003ooo00001?l0003oo`00ool00?oo0005
o`0000_oOol000?o0000ool00?oo00003_oo0002o`0000coc<c<2?mVIVHIolc<c07ooooo000Yolc<
c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0F
o`3oo`;o00000_oo0005o`0002Go0?oo00?o0000ogoo0?moo`006_moo`02o`0000coo`000ol00000
1?oo003o0000o`000?l0000Aogoo0003o`000?oo003oo`0000ooo`0000?o0000olc<c?o<c<`00oo<
c<`6ofIVIPOoc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mV
IVHKolc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool06?l0ool2o`0000co0?oo00?o
0000o`3oool0ool06ol0ool00ol0003oOol0ogoo000Logoo0003o`000?oo003oo`0000;oo`001ol0
0004o`3oo`03o`000?moo`3oOol001;oOol00_l0000@ool00003o`000?mVIVKoIVIV00;oIVIV3Oo<
c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?l0oooo0?oo01[o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Mogoo00Co00002ol0ool00ol0003oOol0ogoo
000Dogoo0003o`000?oo003oo`0000koo`000_l0000?olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Ooo
ool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0
oooo0?oo01So0?oo00?o0000o`3oool0ool06_l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol001coOol000?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Eogoo0003o`000?oo
003oo`0000ooo`0000?o0000olc<c?o<c<`03?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Y
olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3o
o`0Ho`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol001coOol000?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
000Eogoo00;o00004?oo00000ol0003oc<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Ooo
ool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0
oooo0?oo01Oo0?oo00?o0000ogl0ool0ool03Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00go0?oo00?o0000ogoo0?moo`007?moo`000ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol001OoOol000?o0000ool00?oo00003_oo00000ol0003oc<c<olc<c00:olc<c003ofIVI_o<
c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c00:olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0ool0ool03Ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`007?moo`000ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol001SoOol000?o0000ool00?oo00002_oo0003o`000003ool00?l0
003oc<c<00[oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`2o`000003olc<c?mVIVKo
c<c<01[oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?oo
000000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool001_oOol000?o0000ogl0ool0ool03_l0ool00ol0003oOol0ogoo000Iogoo0003o`000?oo003o
o`0000;oo`001ol00004o`3oo`03o`000?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`05oo<c<`1
ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000
o`3oool0ool06?l0ool00ol0003oO`3oo`00000>o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Kogoo0003o`000?mo0?oo000000ko0?oo00?o0000
ogoo0?moo`006_moo`04o`0000_o0?oo00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00G
olc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`02oo<c<`0
0ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?oo000000ko0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001[oOol000?o0000ogl0ool000003_l0ool0
0ol0003oOol0ogoo000Jogoo0003o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`02Oo<c<`0
0omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIV
olc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001[oOol000?o
0000ogl0ool000003ol0ool00ol0003oOol0ogoo000Iogoo0003o`000?l0oooo0?oo00go0?oo00?o
0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<co
c<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`04o`000?mo
0?ooO`3oo`0000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol001[oOol000?o0000ogl0ool000003ol0ool00ol0003oOol0ogoo000Iogoo0003o`00
0?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo
000Yolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?oo
o`3oo`0Ho`3oo`05o`000?mo0?ooO`3oogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006_moo`001?l0003oO`3oogl0ool0000>o`3o
o`03o`000?moo`3oOol001WoOol000?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c008olc<
c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omV
IVKoc<c<olc<c00:olc<c003o`000?l0oooo0?oo01So0?oo00Go0000ogl0oomo0?ooO`3oo`00000>
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000J
ogoo0004o`000?mo0?ooO`3oo`0000ko0?oo00?o0000ogoo0?moo`006Omoo`000ol0003o0?ooo`3o
o`0=o`3oo`03o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:?o<c<`0
1?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00[oc<c<00?o0000o`3oool0ool06?l0
ool01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol001[oOol000Co0000ogl0oomo0?oo00003_l0ool00ol0003o
Ool0ogoo000Hogoo0003o`000?mo0?oo000000ko0?oo00?o0000olc<c?o<c<`02?o<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<
c<`02_o<c<`00ol0003o0?ooo`3oo`0Ho`3oo`05o`000?mo0?ooO`3oogl0ool000003_l0ool00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`006Omoo`001?l0
003oO`3oogl0ool0000>o`3oo`03o`000?moo`3oOol001SoOol000?o0000ogl0ool000003_l0ool0
0ol0003oc<c<olc<c008olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Soc<c<00Co0000olc<
c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00:olc<c003o`000?l0oooo0?oo01So0?oo00?o0000
ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Hogoo0005o`000?mo0?ooO`3oogl0ool000003ol0
ool00ol0003oOol0ogoo000Gogoo0003o`000?mo0?oo000000ko0?oo00?o0000olc<c?o<c<`02Oo<
c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Xolc<c0?o000000?oIVIVolc<c?o<c<`06Oo<c<`0
0omVIVKoc<c<olc<c00:olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l00_mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000Hogoo0005o`000?mo0?ooO`3oogl0ool000003ol0ool00ol0003oOol0ogoo
000Gogoo0003o`000?mo0?oo000000oo0?oo00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<
c00Folc<c07ooooo000Lolc<c0Ko00001_o<c<`2ofIVIP03olc<c?mVIVKoc<c<01[oc<c<00?oIVIV
olc<c?o<c<`02Oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`006?moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`005omoo`001?l0003oO`3oogl0ool0000>o`3oo`03o`000?o<c<coc<c<00Soc<c<00?o
IVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<co
IVIV00;oIVIV6_o<c<`00omVIVKoc<c<olc<c009olc<c003o`000?l0oooo0?oo01So0?oo00?o0000
ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Hogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Gogoo0004o`000?mo0?ooO`3oo`0000ko0?oo00?o
0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Molc<c003o`000?o<c<co
c<c<00Soc<c<00Go0000olc<c?o<c<coIVIVolc<c003ofIVIQOoc<c<00?oIVIVolc<c?o<c<`02Oo<
c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006?mo
o`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005omo
o`001?l0003oO`3oogl0ool0000>o`3oo`03o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`0
5_o<c<`1ooooo`007_o<c<`2o`0000Soc<c<00Co0000olc<c?o<c<coIVIV1?o<c<`3ofIVIQCoc<c<
00?oIVIVolc<c?o<c<`02Oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o00?oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`005omoo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`005omoo`001?l0003oO`3oogl0ool0000>o`3oo`03o`000?o<c<coc<c<00So
c<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`008?o<c<`00ol0003oc<c<olc<c005olc<c004o`00
0?o<c<coc<c<ofIVIPOoc<c<0omVIVHAolc<c003ofIVI_o<c<coc<c<00Woc<c<00?o0000o`3oool0
ool06?l0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001OoOol000?o0000ogl0oomo
0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001KoOol000Co0000ogl0oomo
0?oo00003_l0ool00ol0003oc<c<olc<c008olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool0027o
c<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH:olc<c0?oIVIV3_o<c<`00omV
IVKoc<c<olc<c009olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000Gogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogoo000Eogoo0005o`000?mo0?ooO`3oogl0ool000003ol0ool00ol0003oc<c<olc<c007
olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0
003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIPgoc<c<0omVIVH;olc<c003ofIVI_o<c<co
c<c<00Soc<c<00?o0000o`3oool0ool06Ol0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool001KoOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool001GoOol000Go0000ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?o<c<coc<c<00Ooc<c<00?o
IVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<00Coc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`2ofIVIPWoc<c<00?oIVIVolc<c?o<c<`02?o<
c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005_mo
o`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005Omo
o`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`01oo<
c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000
olc<c?o<c<`00_l00002olc<c003o`000?o<c<coc<c<00[oc<c<1?l00007olc<c004o`000?o<c<co
c<c<ofIVIQ;oc<c<0omVIVH6olc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0ool06?l0
ool00ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001KoOol000?o0000ogl0oomo0?l01?mo
0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001GoOol000?o0000ogl0oomo0?l00_mo
0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`05_o<
c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001_oc<c<00Co
0000olc<c?o<c<coIVIV5Oo<c<`3ofIVIP?oc<c<00?oIVIVolc<c?o<c<`02?o<c<`00ol0003o0?oo
o`3oo`0Ho`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`005Omoo`000ol0003oO`3o
ogl0o`04ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005Omoo`000ol0003oO`3o
ogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`01oo<c<`00omVIVKoc<c<
olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co0000
6_o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01Soc<c<0omVIVH;olc<c003o`000?l0oooo0?oo01So
0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?mo0?ooO`3o00Co
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Dogoo0003o`000?mo0?ooO`3o00;o
O`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c007olc<c003ofIVI_o<c<coc<c<01Ko
c<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c0;o
000000?oc<c<ofIVI_o<c<`06_o<c<`4ofIVIPSoc<c<00?o0000o`3oool0ool06?l0ool00ol0003o
O`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001GoOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001CoOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`00
0oo<c<`7o`0000;oc<c<00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c004
ofIVI_o<c<coc<c<olc<c0?oIVIV1Oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o
00KoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`005Omoo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`005?moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo
00go0?oo00?o0000olc<c?o<c<`01_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003
o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co00006_o<c<`01?l0003oc<c<olc<c?mVIVHK
olc<c003ofIVI_o<c<coc<c<00Coc<c<0_mVIVH2olc<c003o`000?l0oooo0?oo01So0?oo00?o0000
ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Eogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Dogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oc<c<olc<c006olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool0
00?oc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<o`000002o`0001Woc<c<00Co0000olc<
c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c006olc<c0;oIVIV00?o0000o`3oool0ool06?l0ool0
0ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001GoOol000?o0000ogl0oomo0?l01Omo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001CoOol000?o0000ogl0oomo0?l00omo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`05_o<c<`1
ooooo`000oo<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<01Soc<c<00Co0000olc<
c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c008olc<c003o`000?l0oooo0?oo01So0?oo00?o0000
ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oc<c<olc<c006olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool0
00?oc<c<1ol00002olc<c003o`000?o<c<coc<c<01Soc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`0
0omVIVKoc<c<olc<c008olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l02?mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool0
0ol0003oOol0ogoo000Cogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oOol0ogoo000Bogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003oc<c<olc<c006olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool002Ooc<c<00Co0000olc<
c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c008olc<c003o`000?l0oooo0?oo01So0?oo00?o0000
ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Bogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oc<c<olc<c006olc<c0GoIVIV5?o<c<`1ooooo`009oo<c<`01?l0
003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0ool06?l0ool0
0ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001?oOol000?o0000ogl0oomo0?l01omo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001;oOol000?o0000ogl0oomo0?l01?mo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?mVIVKoIVIV00GoIVIV00?oc<c<ofIVI_o<c<`05_o<c<`1
ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Ooc<c<00?o0000
o`3oool0ool06Ol0ool00ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001?oOol000?o0000
ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001;oOol000?o0000
ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Koc<c<00?oIVIV
olc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<co
c<c<00Ooc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool001?oOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool001;oOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<co
c<c<00Koc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHK
olc<c003ofIVI_o<c<coc<c<00Ooc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0:
ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?moo`3oOol001;oOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol001;oOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`2o`00
0003olc<c?mVIVKoc<c<01[oc<c<00?oIVIVolc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0Ho`3o
o`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004_moo`000ol0003oO`3oogl0o`07ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004Omoo`000ol0003oO`3oogl0o`05ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`01_o<c<`00omVIVKoc<c<olc<c00Eolc<
c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01oo<c<`00ol0
003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`000ol0
003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`000ol0
003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`01_o<c<`00omV
IVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<
c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004Omoo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004?moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<
c?o<c<`01Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIV
IQ_oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`0Io`3oo`03o`000?mo0?ooO`3o
00[oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`004Omoo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo
00go0?oo00?o0000olc<c?o<c<`01Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c005
o`000?o<c<coc<c<olc<c?mVIVH06oo<c<`00omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo
01So0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Aogoo0003o`000?mo0?ooO`3o
00WoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o
00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<
01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c006olc<
c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c005olc<
c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omV
IVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0
003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<
c<coIVIV7?o<c<`00omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0
oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ko
c<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c007olc<c003o`000?l0oooo0?oo
01So0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o
00[oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o
00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<
01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c006olc<
c003o`000?l0oooo0?oo01Wo0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo
0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c004olc<
c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omV
IVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo01Wo0?oo00?o0000ogl0oomo0?l03Omo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03?l0ool00ol0
003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<0_l000000oo<c<co
IVIVolc<c00Jolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0ool06?l0ool00ol0003o
O`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l02omo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`00
9_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0
ool06?l0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo
0?l02omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo
0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<
c<`05Oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Ko
c<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ko
Ool000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000go
Ool000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Co
c<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003
ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0>ogl0o`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<
olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0ool06?l0ool00ol0003o
O`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`00
9_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0
ool06Ol0ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo
0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo
0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Go
c<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000go
Ool000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000co
Ool000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Co
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003
ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0@ogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<
olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool06?l0ool00ol0003o
O`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`00
9Oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0
ool06?l0ool00ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo
0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo
0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00Go
c<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000co
Ool000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_o
Ool000?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00?o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c0CoIVIV
7?o<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo01Wo0?oo00?o0000ogl0oomo0?l0
4Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001goc<c<00?o
0000olc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c004ofIVIQWoc<c<00?oIVIVolc<c?o<c<`01?o<
c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omo
o`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002_mo
o`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`00oo<
c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Iolc<c0Ko00001_o<c<`01?l0003oc<c<olc<c?mV
IVH3olc<c0CoIVIV5Oo<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo01So0?oo00?o
0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00koO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00coO`3o00?o
0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<01Coc<c<0Ooo
ool001Woc<c<00Go0000olc<c?o<c<coc<c<o`000007olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<
1OmVIVH@olc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3o
ogl0o`0Bogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006_o<
c<`01?l0003oc<c<olc<c?l00007olc<c004o`000?o<c<coc<c<ofIVIPcoc<c<1?mVIVH<olc<c003
ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0Cogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006oo<c<`00ol0003oc<c<
o`000007olc<c004o`000?o<c<coc<c<ofIVIQ3oc<c<1?mVIVH8olc<c003ofIVI_o<c<coc<c<00Co
c<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[o
Ool000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[o
Ool000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00?o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c004o`00
0?o<c<coc<c<ofIVIQCoc<c<1?mVIVH3olc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0
ool06Ol0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo
0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo
0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`007?o<c<`2o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`4ofIVIPKo
c<c<00?o0000o`3oool0ool06Ol0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000Wo
Ool000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000Wo
Ool000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00;o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c004o`00
0?o<c<coc<c<ofIVIQ_oc<c<1OmVIVH2olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo
0?l05?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0
ool03?l0ool00ol0003oc<c<olc<c002olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<
00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c002olc<c0;oIVIV00?o0000o`3oool0
ool06?l0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo
0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo
0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Co
c<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000Wo
Ool000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000So
Ool000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00;o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003
ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0Eogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009Oo<c<`2o`000003olc<
c?mVIVKoc<c<01[oc<c<00?oIVIVolc<c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`00
0?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0Aogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0>ogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000olc<c?mVIVH01_mVIVHBolc<c07ooooo000Uolc<c004o`000?o<
c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`0Io`3oo`03o`00
0?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0Bogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0?ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000ofIVI_o<c<`00_o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo
000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?oo
o`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3o
ogl0o`0Bogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3o
ogl0o`0?ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<
olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`0
0oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
1omoo`000ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
1omoo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`0
0_o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<
00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01OoO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<
c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`00
0?mo0?ooO`3o01OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0Cogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0?ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo
000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?oo
o`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3o
ogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3o
ogl0o`0?ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<
olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`0
0_o<c<`00ol0003o0?ooo`3oo`0Io`3oo`03o`000?mo0?ooO`3o01OoO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
1_moo`000ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
1Omoo`000ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00co0?oo00Go0000olc<c?o<c<co
c<c<ofIVIP0Eolc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<
c<`00_o<c<`00ol0003o0?ooo`3oo`0Io`3oo`03o`000?mo0?ooO`3o01OoO`3o00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`001_moo`000ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`001Omoo`000ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00co0?oo00Go0000olc<c?o<
c<coc<c<ofIVIP0Eolc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<
c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01WoO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`001Omoo`000ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`001Omoo`000ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00co0?oo00Go0000olc<
c?o<c<coc<c<ofIVIP0Eolc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIV
olc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01WoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00co0?oo00Go0000
olc<c?o<c<coc<c<ofIVIP0Eolc<c07ooooo000Tolc<c0;o000000?oc<c<ofIVI_o<c<`06oo<c<`0
0omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l06Omo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03?l0ool0
1Ol0003oc<c<olc<c?o<c<coIVIV01Goc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<
c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l06Omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03?l0
ool01Ol0003oc<c<olc<c?o<c<coIVIV01Goc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV
7?o<c<`01OmVIVKoc<c<olc<c?o<c<co000001_o0?oo00?o0000ogl0oomo0?l06Omo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo0004ogoo0003o`000?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo0004ogoo0003o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03Ol0ool01?l0003o
c<c<olc<c?mVIVHEolc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<
c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`0Io`3oo`03o`000?mo0?ooO`3o01WoO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`001?moo`000ol0003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`001?moo`000ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00co0?oo00Co0000olc<
c?o<c<coIVIV5Oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<co
c<c<00;oc<c<00?o0000o`3oool0ool06?l0ool00ol0003oO`3oogl0o`0Kogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000CoOol000?o0000ogl0oomo0?l05_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000CoOol000?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`04o`000?o<c<co
c<c<ofIVIQGoc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c002olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l06omo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0004ogoo0003o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0003ogoo0003o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool03?l0ool01?l0003oc<c<olc<
c?mVIVHEolc<c07ooooo000Solc<c005o`000?o<c<coc<c<olc<c?mVIVH06oo<c<`00omVIVKoc<c<
olc<c002olc<c003o`000?l0oooo0?oo01So0?oo00?o0000ogl0oomo0?l06omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0004ogoo0003o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0003ogoo0003o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool03?l0ool01?l0003oc<c<
olc<c?mVIVHEolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<
c<`00_o<c<`00ol0003o0?ooo`3oo`0Ho`3oo`03o`000?mo0?ooO`3o01_oO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`000_moo`000ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`000omoo`000ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00Go0000olc<c?o<
c<coc<c<ofIVIP0Dolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00GoIVIVolc<
c?o<c<coc<c<o`00000Ko`3oo`03o`000?mo0?ooO`3o01_oO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`00
0ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`00
0ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00Go0000olc<c?o<c<coc<c<ofIV
IP0Dolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00GoIVIVolc<c?o<c<coc<c<
o`00000Ko`3oo`03o`000?mo0?ooO`3o01coO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3o
ogl0o`0Hogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3o
ogl0o`0Dogl0o`03o`000?l0oooo0?oo00co0?oo00Co0000olc<c?o<c<coIVIV5?o<c<`1ooooo`00
8oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c005ofIVI_o<c<coc<c<olc<c?l000006ol0ool00ol0
003oO`3oogl0o`0Logl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l06?mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l05?mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`04o`000?o<c<coc<c<ofIVIQCoc<c<0Oooool002?oc<c<00Co0000olc<
c?o<c<coIVIV7?o<c<`01OmVIVKoc<c<olc<c?o<c<co000001[o0?oo00?o0000ogl0oomo0?l07Omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o01SoO`3o00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool03?l0
ool01?l0003oc<c<olc<c?mVIVHDolc<c07ooooo000Solc<c0;o000000?oc<c<ofIVI_o<c<`06oo<
c<`01OmVIVKoc<c<olc<c?o<c<co000001[o0?oo00?o0000ogl0oomo0?l07Omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0002ogoo0003o`000?mo0?ooO`3o01SoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0002ogoo0003o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool03?l0ool01?l0003oc<c<
olc<c?mVIVHDolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00GoIVIVolc<c?o<
c<coc<c<o`00000Jo`3oo`03o`000?mo0?ooO`3o01goO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000J
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0D
ogl0o`03o`000?l0oooo0?oo00co0?oo00Co0000olc<c?o<c<coIVIV5?o<c<`1ooooo`008oo<c<`0
1?l0003oc<c<olc<c?mVIVHLolc<c005ofIVI_o<c<coc<c<olc<c?l000006_l0ool00ol0003oO`3o
ogl0o`0Mogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`05o`000?moo`3oOol0ogoo0?l000006_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05
o`000?moo`3oOol0ogoo0?l000005_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`04o`000?o<c<coc<c<
ofIVIQCoc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01?mVIVKoc<c<olc<c?l0
000Ko`3oo`03o`000?mo0?ooO`3o01koO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00007?mo0?l00ol0003o0?oo
o`3oo`0<o`3oo`04o`000?moo`3oOol0o`0001SoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
c<c<ofIVIP0Dolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00CoIVIVolc<c?o<
c<co00006ol0ool00ol0003oO`3oogl0o`0Nogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`04o`000?moo`3oOol0o`0001coO`3o00?o0000
o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Hogl0o`03o`000?l0oooo0?oo00co0?oo00?o
0000olc<c?mVIVH05?o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c004ofIVI_o<
c<coc<c<o`0001[o0?oo00?o0000ogl0oomo0?l07omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Logl0o`03
o`000?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00006?mo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?o<c<coIVIV01Coc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`01?mV
IVKoc<c<olc<c?l0000Jo`3oo`03o`000?mo0?ooO`3o01ooO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00007?mo
0?l00ol0003o0?ooo`3oo`0<o`3oo`04o`000?moo`3oOol0o`0001SoO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oc<c<ofIVIP0Dolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<
00CoIVIVolc<c?o<c<co00006_l0ool00ol0003oO`3oogl0o`0Oogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o000001co
O`3o00?o0000o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Hogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000olc<c?mVIVH05?o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<
c004ofIVI_o<c<coc<c<o`0001[o0?oo00?o0000ogl0oomo0?l07omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0o`00000L
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000006?mo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?o<c<coIVIV01Coc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`0
0omVIVKoc<c<o`00000Ko`3oo`03o`000?mo0?ooO`3o023oO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?l000007Omo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o000001SoO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oIVIVolc<c00Colc<c07ooooo000Rolc<c004o`000?o<c<coc<c<ofIVIQgoc<c<00?oIVIV
olc<c?l000006ol0ool00ol0003oO`3oogl0o`0Pogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o000001goO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0o`00000Iogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
ofIVI_o<c<`04oo<c<`1ooooo`005oo<c<`4o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`E
o`0001Ko0?oo00?o0000ogl0oomo0?l08?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0o`00000Mogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?l000006Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mVIVKo
c<c<01?oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<
c0KoIVIV4oo<c<`3o`0000goo`002Ol0000<o`3oo`03o`000?mo0?ooO`3o027oO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo0_l0000Nogl0
o`03o`000?l0oooo0?oo00co0?oo0_l0000Jogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ofIV
I_o<c<`04oo<c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Co
c<c<00Co0000olc<c?o<c<coIVIV0_o<c<`9ofIVIQ7oc<c<1ol0000;ool000Wo00000ol0ool00ol0
003oO`3oogl0o`0Qogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01coO`3o00?o0000o`3oool0ool03?l0ool2o`00
01[oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oIVIVolc<c00Colc<c07ooooo000Folc<c003
o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH;olc<
c0WoIVIV2?o<c<`00omVIVKoc<c<olc<c004olc<c0Oo00002Ooo00001?l0003oo`00ool00?oo0004
o`0002CoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000ogl0oomo0?l07?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?oo
O`3o01SoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<ofIVIP0Colc<c07ooooo000Folc<
c0;o00000oo<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIQCoc<c<2OmVIVH=
olc<c0Wo00003?oo0005o`0001_oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`04
o`3ooaOo00007omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01SoO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oc<c<ofIVIP0Colc<c07ooooo000Folc<c003o`000?o<c<co0000
00;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c0[oIVIV2oo<c<`5o`00017oo`001ol0000A
ogl0oaGo00002ooo0005o`0000_oo`001?l0000Gogl0o`03o`000?l0oooo0?oo00Go0?oo2?l0000K
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ofIVI_o<c<`04_o<c<`1ooooo`005_o<c<`00ol0
003oc<c<olc<c009olc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`01oo<c<`9
ofIVIPKoc<c<00CoIVIVolc<c?o<c<coc<c<2?l0000=ool000[o00002ooo0003o`0000_oo`001Ol0
000?ool000Ko00003Ooo000;o`0000OoO`3o2?l0000:ool000Go00005?mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?mVIVKoc<c<01;oc<c<0Oooool001Ooc<c<00Go0000olc<c?o<c<coc<c<o`00
000Volc<c003ofIVI_o<c<coc<c<013oc<c<2OmVIVH9olc<c0[o00002ooo0005o`0000ooo`001ol0
0007ool000Ko00003Ooo0009o`0000_oo`001?l0000<ool000?o00003ooo0004o`0000WoO`3o00?o
0000ogl0oomo0?l01?mo0?l@o`0000GoIVIV3oo<c<`1ooooo`006?o<c<`3o`0002Ooc<c<00?oIVIV
olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c009ofIVIPWoc<c<1?l0000?ool000Oo00003Ooo000;
o`0000;oo`002Ol0000;ool000Co00003_oo0005o`0000goo`002_l00005ool000Wo00003OmVIVH:
olc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool004;oc<c<00?oIVIVolc<c?o<c<`05_o<c<`00omV
IVKoc<c<olc<c009olc<c0[oIVIV2_o<c<`:o`0000Goo`002Ol0000;ool000?o00002_oo0008o`00
00goo`002ol00004ool000Wo00003_mVIVH00oo<c<coIVIVolc<c00Rolc<c003ofIVI_o<c<coc<c<
017oc<c<0Oooool005_oc<c<00?oIVIVolc<c?o<c<`04_o<c<`9ofIVIP[oc<c<00?oIVIVolc<c?l0
00000_l00009ool000Wo00003Ooo0009o`0000?oo`002_l0000=ofIVIQgoc<c<00?oIVIVolc<c?o<
c<`08Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo001Kolc<c003ofIVI_o<c<coc<c<01;oc<c<
00?oIVIVolc<c?o<c<`01_o<c<`9ofIVIP03olc<c?mVIVKoc<c<00?oc<c<00?oIVIVolc<c?o<c<`0
0oo<c<`9o`0000?oo`002_l0000:ofIVIQOoc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<
olc<c00Qolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool0073oc<c<00?oIVIVolc<c?o<c<`03oo<
c<`AofIVIQ;oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<
c<coc<c<03Goc<c<0Oooool0073oc<c<00?oIVIVolc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c002
olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c01G
olc<c07ooooo0023olc<c003ofIVI_o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`06_o<c<`00omV
IVKoc<c<olc<c01golc<c07ooooo0023olc<c003ofIVI_o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<
c<`0U?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1
ooooo`00ooo<c<`Polc<c07ooooo0035olc<c0;o0000F?o<c<`1ooooo`00a_o<c<`2o`0000;oc<c<
00?o0000olc<c?o<c<`0D_o<c<`1ooooo`00aoo<c<`2o`0000;oc<c<00?o0000olc<c?o<c<`0DOo<
c<`1ooooo`00?oo<c<`5o`0000Coc<c<0ol00003olc<c0;o00000oo<c<`3o`0000;oc<c<1?l00003
olc<c0Go00000oo<c<`2o`0000Coc<c<0_l00002olc<c0?o000000?oc<c<o`000?l000000_o<c<`2
o`0000;oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00001?o<c<`2
o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0Co00000oo<c<`3o`0000?oc<c<0ol00003
olc<c0;o00001?o<c<`3o`000003olc<c?l0003o000000Ooc<c<1?l000001?o<c<co0000olc<c?o<
c<`4o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000001oo<c<`2o`0002coc<c<0Ooo
ool003koc<c<0_l00003olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003
olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2
o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002
olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00000
0oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00003
olc<c0;o000000Coc<c<o`000?l0003oc<c<0_l00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l0
00000oo<c<co0000o`000002olc<c0;o00001?o<c<`3o`000003olc<c?l0003o000000Koc<c<0_l0
0002olc<c0?o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l0
00000oo<c<co0000o`000007olc<c0;o0000;?o<c<`1ooooo`00?_o<c<`2o`0000?oc<c<0_l00000
0oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`0000;oc<c<0_l00005
olc<c0;o00000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002
olc<c0;o000000?oc<c<o`000?l000002?o<c<`3o`0000Coc<c<0ol000000oo<c<co0000o`000008
olc<c0?o00000oo<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000004olc<c0?o00000_o<c<`2
o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o
000000Ooc<c<0_l00004olc<c0;o000000?oc<c<o`000?l000001Oo<c<`2o`0000;oc<c<0_l00007
olc<c0Ko0000:oo<c<`1ooooo`00@_o<c<`3o`000003olc<c?l0003o000000?oc<c<0_l000000oo<
c<co0000o`000003olc<c0;o00000_o<c<`6o`000003olc<c?l0003o000000;oc<c<0_l00003olc<
c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o0000
00Co00000_o<c<`4o`0000?oc<c<1?l00002olc<c0Ko00000_o<c<`4o`0000Coc<c<0_l00003olc<
c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0_l00002olc<c0;o00000oo<c<`2o`00
0003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001?o<c<`2o`00
0003olc<c?l0003o000000Co000000?oc<c<o`000?l000000_o<c<`2o`0000Ooc<c<00?o0000olc<
c?o<c<`00_l0000/olc<c07ooooo000oolc<c0Go00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co
0000o`000003olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o
00000oo<c<`5o`000003olc<c?l0003o000000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003
olc<c?l0003o000000;oc<c<0_l000001?o<c<co0000o`000?l00004olc<c0?o00001?o<c<`2o`00
00;oc<c<0_l000001?o<c<co0000o`000?l00006olc<c0;o00000oo<c<`2o`000004olc<c?l0003o
0000olc<c0?o00001Oo<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<
c<`2o`000003olc<c?l0003o000000Ooc<c<0_l00002olc<c0Co000000?oc<c<o`000?l000000_o<
c<`2o`000003olc<c?l0003o000000;oc<c<0_l00008olc<c004o`000?o<c<co0000o`0002coc<c<
0Oooool003koc<c<0ol00006olc<c0;o000000?oc<c<o`000?l000000_o<c<`3o`0000;oc<c<0_l0
0002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00001?o<
c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l0
00000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0
003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`7o`000004olc<c?l0
003o0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l00000
0_o<c<`3o`0000;oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001oo<c<`2o`0000;oc<c<
0_l000000oo<c<co0000o`000002olc<c0;o00002?o<c<`01?l0003oc<c<o`000?l0000/olc<c07o
oooo000nolc<c0;o00000oo<c<`2o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`000?l00000
0_l00002olc<c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<c0;o000000?oc<c<o`000?l00000
0_l000000oo<c<co0000o`000003o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<
1?l00003olc<c0Co00001?o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0Co0000
0_o<c<`4o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`000?l000000oo<c<`2o`0000Koc<c<
0_l00004olc<c0;o00000_o<c<`4o`0000;oc<c<1Ol0000:olc<c0?o0000;?o<c<`1ooooo`00?_o<
c<`2o`0000?oc<c<0_l0000>olc<c0;o00003Oo<c<`2o`0000?oc<c<0_l00008olc<c0;o0000;_o<
c<`2o`0000?oc<c<0_l0000<olc<c0;o00007?o<c<`2o`0000;oc<c<0_l0000Holc<c0?o0000;?o<
c<`1ooooo`00?oo<c<`5o`0000ooc<c<0_l0000=olc<c0;o00000oo<c<`8o`0000;oc<c<0_l0000^
olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000Woc<c<0_l0000Molc<c0Co00006_o<c<`2
o`0002coc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<
0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?oo
c<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 6, 6, 6, 6, 6, 6, 6, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(6.`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 0.0147151 5.88604 [
[.18254 .00222 -9 -9 ]
[.18254 .00222 9 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -9 -9 ]
[.81746 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(1.5)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(2)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2.5)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(3)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(3.5)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(4)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.34127 .60332 L
.65873 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 0.0147151 2.94302 [
[.18254 .00222 -9 -9 ]
[.18254 .00222 9 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -9 -9 ]
[.81746 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .16187 -24 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -24 -4.5 ]
[.01131 .45617 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(1.5)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(2)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2.5)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(3)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(3.5)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(4)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .16187 m
.03006 .16187 L
s
[(0.05)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.1)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.15)] .01131 .45617 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.34127 .30902 L
.65873 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 -0.377687 0.981006 [
[.18254 .59082 -9 -9 ]
[.18254 .59082 9 0 ]
[.34127 .59082 -3 -9 ]
[.34127 .59082 3 0 ]
[.5 .59082 -9 -9 ]
[.5 .59082 9 0 ]
[.65873 .59082 -3 -9 ]
[.65873 .59082 3 0 ]
[.81746 .59082 -9 -9 ]
[.81746 .59082 9 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -18 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .11282 -18 -4.5 ]
[.01131 .11282 0 4.5 ]
[.01131 .21092 -18 -4.5 ]
[.01131 .21092 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .40712 -18 -4.5 ]
[.01131 .40712 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .60332 m
.18254 .60957 L
s
[(1.5)] .18254 .59082 0 1 Mshowa
.34127 .60332 m
.34127 .60957 L
s
[(2)] .34127 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(2.5)] .5 .59082 0 1 Mshowa
.65873 .60332 m
.65873 .60957 L
s
[(3)] .65873 .59082 0 1 Mshowa
.81746 .60332 m
.81746 .60957 L
s
[(3.5)] .81746 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(4)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.05556 .60332 m
.05556 .60707 L
s
.0873 .60332 m
.0873 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.15079 .60332 m
.15079 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.24603 .60332 m
.24603 .60707 L
s
.27778 .60332 m
.27778 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.37302 .60332 m
.37302 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.43651 .60332 m
.43651 .60707 L
s
.46825 .60332 m
.46825 .60707 L
s
.53175 .60332 m
.53175 .60707 L
s
.56349 .60332 m
.56349 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.62698 .60332 m
.62698 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.72222 .60332 m
.72222 .60707 L
s
.75397 .60332 m
.75397 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.84921 .60332 m
.84921 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.9127 .60332 m
.9127 .60707 L
s
.94444 .60332 m
.94444 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.4)] .01131 .01472 1 0 Mshowa
.02381 .11282 m
.03006 .11282 L
s
[(0.5)] .01131 .11282 1 0 Mshowa
.02381 .21092 m
.03006 .21092 L
s
[(0.6)] .01131 .21092 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.7)] .01131 .30902 1 0 Mshowa
.02381 .40712 m
.03006 .40712 L
s
[(0.8)] .01131 .40712 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(0.9)] .01131 .50522 1 0 Mshowa
.125 Mabswid
.02381 .03434 m
.02756 .03434 L
s
.02381 .05396 m
.02756 .05396 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .0932 m
.02756 .0932 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .15206 m
.02756 .15206 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .23054 m
.02756 .23054 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .26978 m
.02756 .26978 L
s
.02381 .2894 m
.02756 .2894 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34826 m
.02756 .34826 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .3875 m
.02756 .3875 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .44636 m
.02756 .44636 L
s
.02381 .46598 m
.02756 .46598 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .52484 m
.02756 .52484 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .56408 m
.02756 .56408 L
s
.02381 .5837 m
.02756 .5837 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.34127 .60332 L
.65873 .60332 L
.97619 .59351 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 -0.272059 1.43387 [
[.18254 .00222 -9 -9 ]
[.18254 .00222 9 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -9 -9 ]
[.81746 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .1581 -18 -4.5 ]
[.01131 .1581 0 4.5 ]
[.01131 .30149 -18 -4.5 ]
[.01131 .30149 0 4.5 ]
[.01131 .44488 -18 -4.5 ]
[.01131 .44488 0 4.5 ]
[.01131 .58826 -18 -4.5 ]
[.01131 .58826 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(1.5)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(2)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2.5)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(3)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(3.5)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(4)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .1581 m
.03006 .1581 L
s
[(0.3)] .01131 .1581 1 0 Mshowa
.02381 .30149 m
.03006 .30149 L
s
[(0.4)] .01131 .30149 1 0 Mshowa
.02381 .44488 m
.03006 .44488 L
s
[(0.5)] .01131 .44488 1 0 Mshowa
.02381 .58826 m
.03006 .58826 L
s
[(0.6)] .01131 .58826 1 0 Mshowa
.125 Mabswid
.02381 .04339 m
.02756 .04339 L
s
.02381 .07207 m
.02756 .07207 L
s
.02381 .10075 m
.02756 .10075 L
s
.02381 .12942 m
.02756 .12942 L
s
.02381 .18678 m
.02756 .18678 L
s
.02381 .21546 m
.02756 .21546 L
s
.02381 .24413 m
.02756 .24413 L
s
.02381 .27281 m
.02756 .27281 L
s
.02381 .33017 m
.02756 .33017 L
s
.02381 .35884 m
.02756 .35884 L
s
.02381 .38752 m
.02756 .38752 L
s
.02381 .4162 m
.02756 .4162 L
s
.02381 .47355 m
.02756 .47355 L
s
.02381 .50223 m
.02756 .50223 L
s
.02381 .53091 m
.02756 .53091 L
s
.02381 .55959 m
.02756 .55959 L
s
.02381 .61694 m
.02756 .61694 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .01472 m
.34127 .60332 L
.65873 .59457 L
.97619 .5859 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 -0.573889 5.88604 [
[.18254 .00222 -9 -9 ]
[.18254 .00222 9 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -9 -9 ]
[.81746 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(1.5)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(2)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2.5)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(3)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(3.5)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(4)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.12)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.14)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.16)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.18)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.34127 .01472 L
.65873 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 0.0147151 5.88604 [
[.18254 .00222 -9 -9 ]
[.18254 .00222 9 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -9 -9 ]
[.81746 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(1.5)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(2)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2.5)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(3)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(3.5)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(4)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.34127 .60332 L
.65873 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 -0.371191 0.97451 [
[.18254 .59082 -9 -9 ]
[.18254 .59082 9 0 ]
[.34127 .59082 -3 -9 ]
[.34127 .59082 3 0 ]
[.5 .59082 -9 -9 ]
[.5 .59082 9 0 ]
[.65873 .59082 -3 -9 ]
[.65873 .59082 3 0 ]
[.81746 .59082 -9 -9 ]
[.81746 .59082 9 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01861 -18 -4.5 ]
[.01131 .01861 0 4.5 ]
[.01131 .11606 -18 -4.5 ]
[.01131 .11606 0 4.5 ]
[.01131 .21352 -18 -4.5 ]
[.01131 .21352 0 4.5 ]
[.01131 .31097 -18 -4.5 ]
[.01131 .31097 0 4.5 ]
[.01131 .40842 -18 -4.5 ]
[.01131 .40842 0 4.5 ]
[.01131 .50587 -18 -4.5 ]
[.01131 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .60332 m
.18254 .60957 L
s
[(1.5)] .18254 .59082 0 1 Mshowa
.34127 .60332 m
.34127 .60957 L
s
[(2)] .34127 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(2.5)] .5 .59082 0 1 Mshowa
.65873 .60332 m
.65873 .60957 L
s
[(3)] .65873 .59082 0 1 Mshowa
.81746 .60332 m
.81746 .60957 L
s
[(3.5)] .81746 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(4)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.05556 .60332 m
.05556 .60707 L
s
.0873 .60332 m
.0873 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.15079 .60332 m
.15079 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.24603 .60332 m
.24603 .60707 L
s
.27778 .60332 m
.27778 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.37302 .60332 m
.37302 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.43651 .60332 m
.43651 .60707 L
s
.46825 .60332 m
.46825 .60707 L
s
.53175 .60332 m
.53175 .60707 L
s
.56349 .60332 m
.56349 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.62698 .60332 m
.62698 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.72222 .60332 m
.72222 .60707 L
s
.75397 .60332 m
.75397 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.84921 .60332 m
.84921 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.9127 .60332 m
.9127 .60707 L
s
.94444 .60332 m
.94444 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01861 m
.03006 .01861 L
s
[(0.4)] .01131 .01861 1 0 Mshowa
.02381 .11606 m
.03006 .11606 L
s
[(0.5)] .01131 .11606 1 0 Mshowa
.02381 .21352 m
.03006 .21352 L
s
[(0.6)] .01131 .21352 1 0 Mshowa
.02381 .31097 m
.03006 .31097 L
s
[(0.7)] .01131 .31097 1 0 Mshowa
.02381 .40842 m
.03006 .40842 L
s
[(0.8)] .01131 .40842 1 0 Mshowa
.02381 .50587 m
.03006 .50587 L
s
[(0.9)] .01131 .50587 1 0 Mshowa
.125 Mabswid
.02381 .0381 m
.02756 .0381 L
s
.02381 .05759 m
.02756 .05759 L
s
.02381 .07708 m
.02756 .07708 L
s
.02381 .09657 m
.02756 .09657 L
s
.02381 .13555 m
.02756 .13555 L
s
.02381 .15504 m
.02756 .15504 L
s
.02381 .17453 m
.02756 .17453 L
s
.02381 .19402 m
.02756 .19402 L
s
.02381 .23301 m
.02756 .23301 L
s
.02381 .2525 m
.02756 .2525 L
s
.02381 .27199 m
.02756 .27199 L
s
.02381 .29148 m
.02756 .29148 L
s
.02381 .33046 m
.02756 .33046 L
s
.02381 .34995 m
.02756 .34995 L
s
.02381 .36944 m
.02756 .36944 L
s
.02381 .38893 m
.02756 .38893 L
s
.02381 .42791 m
.02756 .42791 L
s
.02381 .4474 m
.02756 .4474 L
s
.02381 .46689 m
.02756 .46689 L
s
.02381 .48638 m
.02756 .48638 L
s
.02381 .52536 m
.02756 .52536 L
s
.02381 .54485 m
.02756 .54485 L
s
.02381 .56434 m
.02756 .56434 L
s
.02381 .58383 m
.02756 .58383 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.34127 .01472 L
.65873 .60332 L
.97619 .59357 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.31746 0.0147151 5.88604 [
[.18254 .00222 -9 -9 ]
[.18254 .00222 9 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -9 -9 ]
[.81746 .00222 9 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(1.5)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(2)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(2.5)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(3)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(3.5)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(4)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.34127 .60332 L
.65873 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H002_oi^KV0ol00004onKViP03
o`000?oVi^Koi^KV00;oi^KV2ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV0ol000001OoVi^Ko
0000o`000?l0003oi^KV00?o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H3o`00
02ooi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV3?l00003onKViP03o`000?oVi^Koi^KV
00;oi^KV0ol000001OoVi^Ko0000o`000?l0003oi^KV00?o00001?oVi^H00ol0003oi^KVonKViP02
onKViP?o000000Coi^KVo`000?l0003o00004ooVi^H002coi^KV00?o0000onKVi_oVi^H01ooVi^H0
1?l0003oi^KVonKVi_oVi^H2o`0000;oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KV
onKVi_l000000_oVi^H00ol0003oi^KVonKViP0_onKViP03o`000?oVi^Koi^KV00Ooi^KV00Co0000
onKVi_oVi^Koi^KV0_l00002onKViP;o00000_oVi^H00ol0003oi^KVonKViP05onKViP05o`000?oV
i^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00Oo0000onKVi_oV
i^Koi^KVo`000?oVi^Ko000001Coi^KV000/onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKV
i_l000000_oVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H0
0ol0003oi^KVonKViP09onKViPGo0000<?oVi^H00ol0003oi^KVonKViP0;onKViP03o`000?oVi^Ko
000000?oi^KV00?o0000onKVi_oVi^H02ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00?o
0000onKVi_oVi^H02?oVi^H5o`0001?oi^KV000/onKViP03o`000?oVi^Koi^KV00_oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP0:onKViP04o`000?oVi^Ko0000o`0000;oi^KV
0_l0000<onKViP04o`000?oVi^Koi^KVo`00037oi^KV00?o0000onKVi_oVi^H02ooVi^H01?l0003o
i^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00[oi^KV00Co0000onKVi_l0003o00000_oVi^H2
o`0000_oi^KV0_l000000ooVi^Ko0000onKViP0ConKViP00;?oVi^H00ol0003oi^KVonKViP07onKV
iPGo00000_oVi^H2o`0000;oi^KV00?o0000onKVi_oVi^H01OoVi^H4o`0000Coi^KV00Go0000onKV
i_oVi^Koi^KVo`000007onKViPCo000000Coi^KVo`000?oVi^Ko0000<OoVi^H00ol0003oi^KVonKV
iP07onKViPGo00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV1?l00004onKViP05o`00
0?oVi^Koi^KVonKVi_l000001ooVi^H5o`000003onKVi_l0003oi^KV01?oi^KV000[onKViP;o0000
2OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV0_l00002onKViP03o`000?oVi^Koi^KV00Go
i^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H0
0ol0003oi^KVonKViP03onKViP;o0000<?oVi^H2o`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00
0003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?o
i^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV00;oi^KV0_l0000DonKV
iP00;?oVi^H00ol0003oi^KVonKViP07onKViP_o00002?oVi^H8o`000004onKVi_l0003o0000o`00
00Soi^KV1Ol00002onKViP03o`000?oVi^Koi^KV02ooi^KV00?o0000onKVi_oVi^H01ooVi^H8o`00
0004onKVi_l0003o0000o`0000Soi^KV2?l000001?oVi^Ko0000o`000?l00008onKViPGo000000?o
i^KVo`000?oVi^H04ooVi^H00>?oi^KV000YonKViP03o`000?oVi^Koi^KV06Ooi^KV00?o0000onKV
i_oVi^H0COoVi^H002Ooi^KV0_l000000onc/k?o0000o`00000jo`0002coi^KV?ol0000BonKViP00
:OoVi^H00onc/k?oi^KVonKViP1WonKViP03o`000?oVi^Koi^KV04goi^KV000YonKViP03o`000?nc
/k?oi^KV06Ooi^KV0_l0001>onKViP00:OoVi^H00ol0003o/k>conKViP1WonKViP;o0000C_oVi^H0
02Woi^KV00?o0000onKVi_nc/k<0IooVi^H00ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000Co
i^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000;oi^KV1Ol00002onKViP04o`000?oVi^Koi^KVok>c
/fKoi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_nc/k=@onKViP;o0000
1?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H0
COoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03
o`000?oVi^Koi^KV00;oi^KV00Go0000onKVi_oVi^Koi^KVok>c/`1>onKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0004ko
i^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000?oi^KV00?o/k>conKVi_oVi^H0C?oVi^H01?l0003oi^KVonKVi_l0
0008onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00?o0000onKVi_l00000CooVi^H0017oi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKV
i_oVi^Ko00001?oVi^H00onc/k?oi^KVonKViP1;onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co
0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVo`000?l0001>onKViP004OoVi^H01?l0003oi^KV
onKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0
0004onKViP03ok>c/ooVi^Koi^KV04_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KV
onKVi_l0003oi^KV00Co00000_oVi^H00ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000[oi^KV
0_l00003onKViP?o00000ooVi^H00ol0003oi^KVonKViP03onKViP03ok>c/ooVi^Koi^KV04[oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Goi^KV0_l0001>
onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000Coi^KV0ol00002onKV
iP03o`000?oVi^Koi^KV00?oi^KV00?o/k>conKVi_oVi^H0BooVi^H2o`0000[oi^KV0_l00002onKV
iPGo000000?oi^KVo`000?oVi^H0C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0
003oi^KVonKVi_l00004onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H00onc/k?oi^KVonKV
iP1PonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKV
i_l0003oi^KV00Go00000_oVi^H00ol0003oi^KVonKViP05onKViP03ok>c/ooVi^Koi^KV05ooi^KV
0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o/k>conKVi_oVi^H0CooVi^H2
o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H0COoVi^H0
017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oV
i^Ko000000?oi^KV00?o0000onKVi_oVi^H01_oVi^H00onc/k?oi^KVonKViP1=onKViP04o`000?oV
i^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l00003onKViP03o`000?oVi^Koi^KV
00Koi^KV00?o/k>conKVi_oVi^H0COoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Ko
i^KVonKVi_l00000CooVi^H001;oi^KV0_l0000:onKViP;o00001OoVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Woi^KV00?o/k>conKVi_oVi^H0C?oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`00
0?oVi^Koi^KVonKViScoc<c<5?oVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV
0_l00003onKViP?o00000ooVi^H00ol0003oi^KVonKViP07onKViP03ok>c/ooVi^Koi^KV04coi^KV
00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV000AonKViP04
o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oV
i^Koi^KVo`0000[oi^KV00?o/k>conKVi_oVi^H0BooVi^H01?l0003oi^KVonKVi_l00008onKViP;o
00000ooVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oV
i^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00?o/k>conKVi_oVi^H0C?oV
i^H2o`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKV
i_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l00003onKViP03o`000?oVi^Koi^KV00Wo
i^KV00?o/k>conKVi_oVi^H0FooVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00006onKViP03o`000?oVi^Koi^KV00[oi^KV00?o/k>c
onKVi_oVi^H0F_oVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00[oi^KV00?o
/k>conKVi_oVi^H0F_oVi^H00ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000[oi^KV0_l00004
onKViP;o00000ooVi^H00ol0003oi^KVonKViP0;onKViP03ok>c/ooVi^Koi^KV04?oi^KV0_l00004
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP?o00000_oVi^H2o`0004koi^KV000BonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKV
i_oVi^H02ooVi^H00onc/k?oi^KVonKViP12onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000
onKVi_oVi^Koi^KVo`000003onKViP03o`000?oVi^Ko000004ooi^KV000AonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`00
00koi^KV00?o/k>conKVi_oVi^H0@OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Ko
i^KV00Goi^KV00Co0000onKVi_l0003o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00003_oVi^H00onc
/k?oi^KVonKViP11onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01OoVi^H0
0ol0003oi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00goi^KV00?o/k>conKVi_oVi^H0@?oV
i^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViPCo00000_oVi^H2o`0004ko
i^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003
onKViP04o`000?oVi^Koi^KVo`0000ooi^KV00?o/k>conKVi_oVi^H0@?oVi^H01?l0003oi^KVonKV
i_l00008onKViP;o00000ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV04goi^KV
000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP04o`000?oVi^Koi^KVo`00013oi^KV00?o/k>conKVi_oVi^H0@?oVi^H2o`0000[oi^KV00Co0000
onKVi_oVi^Koi^KV1Ol000000ooVi^Ko0000o`00001>onKViP004_oVi^H2o`0000[oi^KV0_l00003
onKViP?o00000ooVi^H00ol0003oi^KVonKViP0?onKViP03ok>c/ooVi^Koi^KV05Goi^KV00?o0000
onKVi_oVi^H0COoVi^H002Woi^KV00?o0000onKVi_oVi^H03ooVi^H00onc/k?oi^KVonKViP1EonKV
iP;o0000C_oVi^H001Soi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03
o`000?oVi^Koi^KV013oi^KV00?o/k>conKVi_oVi^H0A?oVi^H2o`0000Coi^KV00Co0000onKVi_oV
i^Koi^KV1Ol000000ooVi^Ko0000o`00001>onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKV
iP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H04?oVi^H00onc/k?oi^KVonKViP13onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0001?onKViP005ooV
i^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0
4OoVi^HXok>c/agoi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`00
04koi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0
003oi^KVonKViP1FonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Co0000onKVi_oVi^Ko0000CooV
i^H001Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP1KonKViP04o`000?oV
i^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00001AonKViP005ooVi^H01?l0003oi^KV
onKVi_l00008onKViP;o0000GOoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KV
onKVi_l00000DOoVi^H001Soi^KV0_l0000:onKViP03o`000?oVi^Koi^KV05coi^KV0_l00009onKV
iP?o0000D_oVi^H00>?oi^KV000gonKViP?o00000_oVi^H6o`000004onKVi_l0003o0000o`0000?o
i^KV0ol00002onKViP03o`000?oVi^Ko000000;o0000COoVi^H3o`0000;oi^KV0ol000000ooVi^Ko
0000o`000003o`0000;oi^KV1_l000001ooVi^Ko0000o`000?l0003oi^KVo`000?oVi^H00ol00000
0ooVi^Ko0000o`00000PonKViP00>?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?o
i^KV00?o0000onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00008OoVi^H003Soi^KV00?o0000onKVi_l00000
0ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_l00000
0_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0
003oi^KVonKVi_l0003oi^KVo`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVo`00
0?l00002onKViP03o`000?oVi^Ko000002;oi^KV000honKViP?o00000ooVi^H3o`0000?oi^KV0ol0
0003onKViP?o00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004goi^KV0_l00003onKViPCo0000
0_oVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVo`000?l00002onKViP;o
00008ooVi^H003Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oV
i^Koi^KV04[oi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`00
0?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H2o`000007onKVi_l0003oi^KVonKV
i_l0003oi^KVo`00000RonKViP00>?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`00
00?oi^KV00?o0000onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP;o0000
00Goi^KVo`000?oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01ooi^KV000gonKViPCo0000
0_oVi^H5o`000003onKVi_l0003o000000;o00000_oVi^H4o`0000?oi^KV0ol0001>onKViP?o0000
00Goi^KVo`000?l0003o0000onKViP06o`0000;oi^KV1Ol000001?oVi^Ko0000o`000?oVi^H6o`00
0003onKVi_l0003o0000023oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?o
i^KV003SonKViP00hooVi^H009;oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV3?l00003
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol000001OoVi^Ko0000o`000?l0003oi^KV00?o00001?oV
i^H00ol0003oi^KVonKViP02onKViP?o000000Coi^KVo`000?l0003o00005_oVi^H0017oi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00?oi^KV0ol0001conKViP03o`000?oVi^Koi^KV00Ooi^KV00Co
0000onKVi_oVi^Koi^KV0_l00002onKViP;o00000_oVi^H00ol0003oi^KVonKViP05onKViP05o`00
0?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00Oo0000onKV
i_oVi^Koi^KVo`000?oVi^Ko000001Ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go
0000onKVi_oVi^Koi^KVo`00001`onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_l00000
0ooVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H00ol0003o
i^KVonKViP08onKViPGo00005_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H5o`0000;o
i^KV00?oOgmoonKVi_oVi^H0K_oVi^H00ol0003oi^KVonKViP0;onKViP04o`000?oVi^Koi^KVo`00
00?oi^KV00?o0000onKVi_oVi^H02_oVi^H01?l0003oi^KVo`000?l00002onKViP;o00002ooVi^H2
o`000003onKVi_l0003oi^KV01Koi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co0000
onKVi_oVi^Ko00000ooVi^H00omoOgooi^KVonKViP1^onKViP03o`000?oVi^Koi^KV00Ooi^KV1Ol0
0003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H4o`0000Coi^KV00Go0000onKVi_oVi^Ko
i^KVo`000007onKViPGo000000?oi^KVo`000?oVi^H05_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H00ol0003oi^KVo`000003onKViP03o`000?moOgooi^KV06goi^KV0_l00009onKViP05
o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`000003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KV
onKViP02onKViP;o00005ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000?oi^KV
00?o0000ogmoOooVi^H0K_oVi^H00ol0003oi^KVonKViP07onKViPSo000000Coi^KVo`000?l0003o
00002?oVi^H8o`000004onKVi_l0003o0000o`0000Soi^KV1Ol000000ooVi^Ko0000onKViP0FonKV
iP004OoVi^H2o`0000_oi^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^KoOgmo0;koi^KV000AonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVogmoO`1[onKV
iP03o`000?oVi^Koi^KV053oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKV
i_oVi^Koi^KVo`000002onKViP04o`000?oVi^Koi^KVogmoOfWoi^KV00?o0000oiVIVOl00000??l0
000EonKViP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?oOgmoonKVi_oVi^H0J?oVi^H00onIVIWo0000onKViP1@onKViP004?oVi^H01?l0003oi^KVonKV
i_l0000;onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?oOgmoonKVi_oVi^H0IooVi^H00ol0003o
VIVIonKViP1@onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000ooVi^H01Ol0003o
i^KVonKVi_oVi^KoOgmo06Woi^KV00?o0000oiVIVOoVi^H0D?oVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV00;oi^KV00?oOgmoonKV
i_oVi^H0I_oVi^H00ol0003oi^KVoiVIV@1@onKViP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03
o`000?oVi^Koi^KV00?oi^KV00?oOgmoonKVi_oVi^H0IOoVi^H2o`000003onKVi_nIVIWoi^KV04ko
i^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KV
onKViP03onKViP03ogmoOooVi^Koi^KV05Goi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV
0ol00002onKViP04o`000?oVi^Koi^KVoiVIVDooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Coi^KV00?oOgmoonKV
i_oVi^H0DooVi^H01?l0003oi^KVonKVi_l00007onKViP06o`000?oVi^Koi^KVonKVi_l0003oi^KV
0_l00002onKViP03oiVIVOoVi^Koi^KV04coi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV
00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Coi^KV00?oOgmoonKVi_oV
i^H0DooVi^H01?l0003oi^KVonKVi_l0000;onKViP03o`000?oVi^Ko000000?oi^KV00?oVIVIonKV
i_oVi^H0C?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00?o0000onKV
i_oVi^H01OoVi^H00omoOgooi^KVonKViP1BonKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00002
onKViP;o00000ooVi^H00onIVIWoi^KVonKViP1;onKViP004?oVi^H01?l0003oi^KVonKVi_l00007
onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H01OoVi^H00omoOgooi^KVonKViP1B
onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_l0003o00000ooVi^H00onIVIWoi^KV
onKViP1;onKViP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Koi^KV00?oi^KV
00?o0000onKVi_oVi^H01_oVi^H00omoOgooi^KVonKViP1AonKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^Ko000000Goi^KV00?oVIVIonKVi_oVi^H0B_oVi^H0
017oi^KV0_l0000:onKViP;o00000ooVi^H00ol0003oi^KVonKViP06onKViP03ogmoOooVi^Koi^KV
05;oi^KV0_l00009onKViP?o00000_oVi^H2o`0000Coi^KV00?oVIVIonKVi_oVi^H0B_oVi^H0017o
i^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003o
i^KVonKViP07onKViP03ogmoOooVi^Koi^KV067oi^KV00?o0000onKVi_oVi^H01?oVi^H00onIVIWo
i^KVonKViP19onKViP004?oVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;o
i^KV00?o0000onKVi_oVi^H01ooVi^H00omoOgooi^KVonKViP1QonKViP;o00001_oVi^H00onIVIWo
i^KVonKViP18onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKV
i_l000002_oVi^H00omoOgooi^KVonKViP1@onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKV
iP?o000000?oi^KVo`000?oVi^H01_oVi^H00onIVIWoi^KVonKViP18onKViP004?oVi^H01?l0003o
i^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H00omoOgooi^KVonKViP1?
onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00?o0000onKVi_oVi^H00_l00007onKViP03oiVIVOoV
i^Koi^KV04Ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko0000
2ooVi^H00omoOgooi^KVonKViP1>onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1Ol000000ooVi^Ko
0000o`000007onKViP03oiVIVOoVi^Koi^KV04Ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Woi^KV00?oOgmoonKV
i_oVi^H0C_oVi^H01?l0003oi^KVonKVi_l00007onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o
0000onKVi_oVi^H01ooVi^H00onIVIWoi^KVonKViP16onKViP004OoVi^H2o`0000Soi^KV1Ol00002
onKViP03o`000?oVi^Koi^KV00[oi^KV00?oOgmoonKVi_oVi^H0COoVi^H01?l0003oi^KVonKVi_l0
0008onKViP03o`000?oVi^Ko000000;oi^KV0_l00008onKViP03oiVIVOoVi^Koi^KV04Koi^KV000A
onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP0:
onKViP03ogmoOooVi^Koi^KV04goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000;oi^KV00?o
0000onKVi_oVi^H02?oVi^H00onIVIWoi^KVonKViP15onKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0;onKViP03ogmo
OooVi^Koi^KV04goi^KV0_l0000;onKViP03o`000?oVi^Koi^KV00;o00002OoVi^H00onIVIWoi^KV
onKViP15onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l0
00000_oVi^H00ol0003oi^KVonKViP0;onKViP03ogmoOooVi^Koi^KV05goi^KV00?o0000onKVi_oV
i^H02OoVi^H00onIVIWoi^KVonKViP14onKViP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP?o
00000ooVi^H00ol0003oi^KVonKViP0<onKViP03ogmoOooVi^Koi^KV05coi^KV0_l0000;onKViP03
oiVIVOoVi^Koi^KV04?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oV
i^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00coi^KV00?oOgmoonKVi_oVi^H0C?oVi^H2o`00
00Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV0_l0000;onKViP03oiVIVOoVi^Koi^KV
04?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002
onKViP03o`000?oVi^Koi^KV00goi^KV00?oOgmoonKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l0
0007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`00000=onKViP03oiVIVOoVi^Koi^KV04;o
i^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KV
onKViP0>onKViP03ogmoOooVi^Koi^KV04Woi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003o
i^KVo`000?l0000<onKViP03oiVIVOoVi^Koi^KV04;oi^KV000@onKViP04o`000?oVi^Koi^KVo`00
00[oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP?o00001?oVi^H00ol0003oi^KVonKViP02
onKViP;o000000?oOgmoonKVi_l000002Ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003
onKViP?o00000_oVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV0ol0000H
onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00?o0000onKVi_l000003_oVi^H00onIVIWoi^KVonKV
iP11onKViP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^Koi^KVo`0000?oi^KV
00?o0000onKVi_oVi^H01ooVi^H01ol0003oi^KVonKVi_oVi^KoOgmoonKVi_l000000_oVi^H00ol0
003oi^KVo`000002onKViP03o`000?oVi^Koi^KV00Goi^KV00Oo0000onKVi_oVi^Koi^KVo`000?oV
i^Ko000000?oi^KV0_l00003onKViP03o`000?oVi^Koi^KV00Goi^KV00Go0000onKVi_oVi^Koi^KV
o`000003onKViP03o`000?oVi^Koi^KV01Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000;o
i^KV0_l0000=onKViP03oiVIVOoVi^Koi^KV047oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000So
i^KV1?l00002onKViP05o`000?oVi^Koi^KVonKVi_l000003OoVi^H01?moOgooi^KVonKVi_l00004
onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP02
onKViP03o`000?oVi^Koi^KV00Woi^KV1_l0000HonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o
0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP0=onKViP03oiVIVOoVi^Koi^KV043oi^KV000@
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP05o`00
0?oVi^Koi^KVonKVi_l000003OoVi^H01Ol0003oOgmoonKVi_oVi^Ko000000Coi^KV00?o0000onKV
i_oVi^H02_oVi^H01?l0003oi^KVonKVi_oVi^H2o`0000?oi^KV0_l0000<onKViP;o00000_oVi^H0
0ol0003oi^KVonKViP0HonKViP;o00002?oVi^H5o`000003onKVi_l0003o000000koi^KV00?oVIVI
onKVi_oVi^H0@?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`000009onKViPCo000000?oi^KVogmoOooVi^H0
0_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H01OoVi^H4o`0000Koi^KV00?o0000onKVi_oVi^H0
0_oVi^H00ol0003oi^KVonKViP05onKViPCo00000_oVi^H00ol0003oi^KVo`00000ZonKViP03o`00
0?oVi^Koi^KV00koi^KV00?oVIVIonKVi_oVi^H0?ooVi^H0017oi^KV0_l00009onKViP?o00000ooV
i^H00ol0003oi^KVonKViP02o`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oOgmoonKV
i_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0003oi^KVonKViP03onKViP04o`00
0?oVi^Koi^KVonKViP;o00000ooVi^H00ol0003oi^KVonKViP05onKViP03o`000?oVi^Koi^KV00Co
i^KV0_l0000ZonKViP;o00004?oVi^H00onIVIWoi^KVonKViP0nonKViP008_oVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000Woi^KV1Ol000001?oVi^KoOgmoo`000?l00002onKViP?o00002?oVi^H5o`00
00;oi^KV0ol00002onKViP?o00002?oVi^H5o`0000?oi^KV00?o0000onKVi_oVi^H06?oVi^H2o`00
00Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV0_l0000@onKViP03oiVIVOoVi^Koi^KV
03koi^KV000RonKViP03o`000?oVi^Koi^KV01;oi^KV00?oOgmoonKVi_oVi^H0AOoVi^H01?l0003o
i^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`00000BonKViP03oiVIVOoV
i^Koi^KV03goi^KV000RonKViP03o`000?oVi^Koi^KV01;oi^KV00?oOgmoonKVi_oVi^H08?oVi^H<
ogmoOaWoi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01_l0003oi^KVonKVi_oVi^Ko0000onKViP;o
00004OoVi^H00onIVIWoi^KVonKViP0LonKViP[oVIVI5ooVi^H0023oi^KV6?l0000RogmoO`ko0000
5ooVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000_oVi^H00ol0003oi^KVonKViP0AonKViQko
VIVI8OoVi^H002;oi^KV00?o0000onKVi_oVi^H0F_oVi^H01?l0003oi^KVonKVi_l00007onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l0001AonKViP00OooVi^H01?l0003oi^KVonKVi_l00008onKViP03
o`000?oVi^Koi^KV05Goi^KV0020onKViP;o00002_oVi^H2o`0005Goi^KV003SonKViP00hooVi^H0
03Goi^KV0_l000001?oVi^Ko0000o`000?l00002onKViP;o00000ooVi^H3o`0000;oi^KV0_l00000
1OoVi^Ko0000o`000?l0003oi^KV00?o0000DOoVi^H3o`0000?oi^KV1Ol000001?oVi^Ko0000o`00
0?l00002onKViP?o000000Coi^KVo`000?l0003o0000:OoVi^H003Goi^KV00Go0000onKVi_oVi^Ko
i^KVo`000002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000003
onKViP05o`000?oVi^Koi^KVonKVi_l00000DooVi^H00ol0003oi^KVonKViP03onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV
02Soi^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003
onKViP04o`000?oVi^Koi^KVonKViPGo00000ooVi^H00ol0003oi^KVonKViP1AonKViP03o`000?oV
i^Koi^KV00?oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVo`000002onKViP05o`000?oV
i^Koi^KVonKVi_l00000:_oVi^H003Goi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP04o`00
0?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVo`000004onKViP03
o`000?oVi^Koi^KV057oi^KV0ol00003onKViP?o00000ooVi^H3o`0000;oi^KV00Go0000onKVi_oV
i^Koi^KVo`00000ZonKViP00=OoVi^H01Ol0003oi^KVo`000?oVi^Ko000000;oi^KV00[o0000onKV
i_oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko00000_oVi^H00ol0003oi^KVo`000002onKViP05
o`000?oVi^Ko0000onKVi_l00000DOoVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Ko
i^KV00?oi^KV00[o0000onKVi_oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000:_oVi^H003Go
i^KV0_l000000ooVi^Ko0000o`000002onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_l0
003oi^KVo`0000?oi^KV00Wo0000onKVi_oVi^Koi^KVo`000?oVi^Ko0000onKVi_l00000DOoVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Go0000onKVi_oVi^Ko
0000onKViP02o`000003onKVi_l0003o000002[oi^KV000eonKViP04o`000?oVi^Koi^KVonKViPGo
000000?oi^KVo`000?l000001Ol00002onKViP;o00000ooVi^H5o`00053oi^KV1?l00002onKViPGo
000000?oi^KVo`000?l000000_l00002onKViP04o`000?oVi^Koi^KVonKViP;o0000:OoVi^H00>?o
i^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00:ooVi^H3
o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H;o`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H3
o`000005onKVi_l0003o0000o`000?oVi^H00ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol0
0002onKViP?o0000;ooVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H<o`0000?oi^KV00?o
0000onKVi_oVi^H00_oVi^H3o`000005onKVi_l0003o0000o`000?oVi^H00ol00004onKViP03o`00
0?oVi^Koi^KV00;oi^KV0ol000001?oVi^Ko0000o`000?l0000ConKViP00;?oVi^H00ol0003oi^KV
onKViP07onKViP04o`000?oVi^Koi^KVonKViP;o00000_oVi^H01?l0003oi^KVonKVi_l00007onKV
iP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00Go
0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV02ooi^KV00?o0000onKVi_oVi^H0
1ooVi^H01?l0003oi^KVonKVi_oVi^H2o`0000;oi^KV0_l00002onKViP03o`000?oVi^Koi^KV00Go
i^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H0
1ol0003oi^KVonKVi_oVi^Ko0000onKVi_l000005?oVi^H002coi^KV00?o0000onKVi_oVi^H02ooV
i^H00ol0003oi^KVo`000002onKViP03o`000?oVi^Koi^KV00_oi^KV00Go0000onKVi_oVi^Koi^KV
o`000003onKViP03o`000?oVi^Koi^KV00Woi^KV1Ol0000`onKViP03o`000?oVi^Koi^KV00_oi^KV
00?o0000onKVi_l000000ooVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KVonKVi_l0
00000ooVi^H00ol0003oi^KVonKViP08onKViPGo00004ooVi^H002coi^KV00?o0000onKVi_oVi^H0
2ooVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00[oi^KV00Co0000onKVi_l0
003o00000_oVi^H2o`0000coi^KV00Co0000onKVi_oVi^Ko0000<OoVi^H00ol0003oi^KVonKViP0;
onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H02_oVi^H01?l0003oi^KVo`00
0?l00002onKViP;o00002ooVi^H2o`000003onKVi_l0003oi^KV01?oi^KV000/onKViP03o`000?oV
i^Koi^KV00Ooi^KV1Ol00002onKViP;o00000_oVi^H00ol0003oi^KVonKViP05onKViPCo00001?oV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV1?l000001?oVi^Ko0000onKVi_l0000aonKViP03
o`000?oVi^Koi^KV00Ooi^KV1Ol00003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H4o`00
00Coi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViPGo000000?oi^KVo`000?oVi^H04ooVi^H0
02_oi^KV0_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H2o`0000;oi^KV00?o0000
onKVi_oVi^H01OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KV
o`000007onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0000`onKViP;o00002OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KV
onKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H00_oV
i^H2o`0001Coi^KV000/onKViP03o`000?oVi^Koi^KV00Ooi^KV2ol00008onKViPSo000000Coi^KV
o`000?l0003o00002?oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H0;ooVi^H00ol0003oi^KVonKV
iP07onKViPSo000000Coi^KVo`000?l0003o00002?oVi^H8o`000004onKVi_l0003o0000o`0000So
i^KV1Ol000000ooVi^Ko0000onKViP0ConKViP00hooVi^H002Ooi^KV5_l0000Xoda<C003o`000?oV
i^Koi^KV02[oi^KV00?o0000ofIVI_l00000??l0000BonKViP00:OoVi^H05_l0003oi^KVo`000?oV
i^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0
003oi^KVoda<C?oVi^H2o`00000TonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`00
0?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKV
i_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000;_oVi^H0=?mVIVKoi^KV
o`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000
onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KV
o`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000
onKVi_l0003oi^KVo`000?oVi^H2o`000006onKVi_l0003oi^KVo`000?oVi^Ko00005?oVi^H002Wo
i^KV00?o0000onKVi_oVi^H04?oVi^H00om<C4coi^KVonKViP1DonKViP03o`000?mVIVKoi^KV04go
i^KV000YonKViP03o`000?oVi^Koi^KV013oi^KV00?oC4a<onKVi_oVi^H0E?oVi^H00ol0003oIVIV
onKViP1=onKViP00:OoVi^H00ol0003oi^KVonKViP0?onKViP03oda<C?oVi^Koi^KV05Goi^KV0_l0
00000omVIVKoi^KVonKViP1;onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3
o`0000;oi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00ooi^KV00?oC4a<onKVi_oVi^H0?ooVi^H2
o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000;oi^KV1Ol000001?oVi^Ko0000onKVi_mV
IVI=onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP0>onKViP03oda<C?oVi^Koi^KV03ooi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP05o`000?oVi^Koi^KV
o`000?oVi^H00_l000000ooVi^KoIVIVonKViP1;onKViP004OoVi^H01?l0003oi^KVonKVi_l00009
onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0=
onKViP03oda<C?oVi^Koi^KV043oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKV
i_l00003onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H00omVIVKoi^KVonKViP19onKViP00
4OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oV
i^Koi^KVo`00000?onKViP03oda<C?oVi^Koi^KV043oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1?l0003oi^KVonKVi_l00004onKViP03o`000?oVi^Koi^KV00;o00000_oVi^H00omVIVKoi^KVonKV
iP19onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l00000
0ooVi^H01?l0003oi^KVonKVi_l0000>onKViP03oda<C?oVi^Koi^KV047oi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_l000001?oV
i^H00omVIVKoi^KVonKViP18onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H03?oVi^H00om<C4coi^KV
onKViP11onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003
onKViP04o`000?oVi^Ko0000o`0000?oi^KV00?oIVIVonKVi_oVi^H0B?oVi^H001;oi^KV0_l0000:
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00_oi^KV00?oC4a<
onKVi_oVi^H0@ooVi^H2o`0000[oi^KV0_l00003onKViP?o00000_oVi^H2o`0000Coi^KV00?oIVIV
onKVi_oVi^H0AooVi^H002Woi^KV00?o0000onKVi_oVi^H02ooVi^H00om<C4coi^KVonKViP1IonKV
iP03o`000?oVi^Koi^KV00?oi^KV00?oIVIVonKVi_oVi^H0AooVi^H001;oi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00;oi^KV0ol00004onKViP?o00000_oVi^H00ol0003oi^KVonKViP0:onKViP03
oda<C?oVi^Koi^KV04Coi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP?o
000000?oi^KVo`000?l000001OoVi^H00omVIVKoi^KVonKViP16onKViP004OoVi^H01?l0003oi^KV
onKVi_l00009onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`00000<onKV
iP03oda<C?oVi^Koi^KV04?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l0
0004onKViP04o`000?oVi^Koi^KVo`0000Koi^KV00?oIVIVonKVi_oVi^H0A_oVi^H0017oi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H5o`0000;oi^KV00?o0000onKVi_oV
i^H02OoVi^H00om<C4coi^KVonKViP14onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKV
i_oVi^Ko0000onKViP05o`000003onKVi_l0003o000000Koi^KV00?oIVIVonKVi_oVi^H0AOoVi^H0
017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go
0000onKVi_oVi^Koi^KVo`00000;onKViP03oda<C?oVi^Koi^KV04Coi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00001ooV
i^H00omVIVKoi^KVonKViP15onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oV
i^Koi^KV00;oi^KV00?o0000onKVi_l000000ooVi^H00ol0003oi^KVonKViP08onKViP03oda<C?oV
i^Koi^KV04Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03
o`000?oVi^Ko000000;oi^KV0_l00007onKViP03ofIVI_oVi^Koi^KV04Coi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV0_l00005onKViP;o00000ooVi^H00ol0003oi^KVonKViP08onKViP03
oda<C?oVi^Koi^KV04Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003
onKViP;o00000_oVi^H00ol0003oi^KVonKViP06onKViP03ofIVI_oVi^Koi^KV04Coi^KV000BonKV
iP;o00002_oVi^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l000002OoVi^H0
0om<C4coi^KVonKViP17onKViP;o00002_oVi^H2o`0000Goi^KV00?o0000onKVi_oVi^H00_l00008
onKViP03ofIVI_oVi^Koi^KV04?oi^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKV
iP?o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H01_oVi^H00om<C4coi^KVonKViP18onKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV0_l00009onKV
iP03ofIVI_oVi^Koi^KV04;oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKV
i_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?oC4a<onKVi_oVi^H0AooV
i^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0
003oi^KVo`00000:onKViP03ofIVI_oVi^Koi^KV04;oi^KV000AonKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o
C4a<onKVi_oVi^H0B?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H01?l0003oi^KVo`000?l0000:onKViP03ofIVI_oVi^Koi^KV047oi^KV000AonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV1?l00003onKViP03o`000?oV
i^Koi^KV00Goi^KV00?oC4a<onKVi_oVi^H0B?oVi^H01?l0003oi^KVonKVi_l00008onKViP05o`00
0?oVi^Koi^KVo`000?oVi^H01?l00002onKViP03o`000?oVi^Koi^KV00Woi^KV00?oIVIVonKVi_oV
i^H0@OoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00Koi^KV00?o0000onKVi_oVi^H01?oVi^H00om<C4coi^KVonKViP19onKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00005onKViP;o00002ooVi^H00omVIVKoi^KV
onKViP10onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP;o00001?oVi^H00ol0003oi^KV
onKViP03onKViP03o`000?oVi^Koi^KV00Coi^KV00?oC4a<onKVi_oVi^H0BOoVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0
003oi^KVonKViP0:onKViP03ofIVI_oVi^Koi^KV043oi^KV000BonKViP;o00002_oVi^H00ol0003o
i^KVonKViP03onKViP;o00000ooVi^H00ol0003oi^KVonKViP03onKViP03oda<C?oVi^Koi^KV04_o
i^KV0_l0000:onKViP;o00001?oVi^H2o`0000;oi^KV0_l0000<onKViP03ofIVI_oVi^Koi^KV03oo
i^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H3o`0000?oi^KV
00?o0000onKVi_oVi^H00ooVi^H00om<C4coi^KVonKViP1;onKViP;o00001?oVi^H00ol0003oi^KV
onKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H02ooVi^H00omVIVKoi^KV
onKViP0oonKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l0
00000ooVi^H01?l0003oi^KVonKVi_l00004onKViP03oda<C?oVi^Koi^KV04_oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o
00003OoVi^H00omVIVKoi^KVonKViP0nonKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05
o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00004onKViP03oda<C?oVi^Ko
i^KV04_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?o
i^KV00?o0000onKVi_l000003_oVi^H00omVIVKoi^KVonKViP0nonKViP004OoVi^H01?l0003oi^KV
onKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP05o`000?oVi^Koi^KVonKV
i_m<C4`0C_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol0
0002onKViP;o00003_oVi^H00omVIVKoi^KVonKViP0monKViP004OoVi^H01?l0003oi^KVonKVi_l0
0009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00003onKViP03
oda<C?oVi^Koi^KV04coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003o
i^KVo`0000?oi^KV00Co0000onKVi_l0003o00003_oVi^H00omVIVKoi^KVonKViP0monKViP004OoV
i^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;o
i^KV00Co0000onKVi_oVi^KoC4a<CooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`00000@onKViP03ofIVI_oVi^Koi^KV03coi^KV
000BonKViP;o00002_oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVoda<
C01AonKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP;o00004?oVi^H00omVIVKoi^KVonKV
iP0konKViP006?oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002onKViP03o`000?oV
i^KoC4a<05Ooi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViP03o`000?oV
i^Koi^KV00ooi^KV00?oIVIVonKVi_oVi^H0>ooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01?l0003oi^KVonKVi_l00002onKViP03o`000?m<C4coi^KV05Koi^KV00Co0000onKVi_oVi^Ko
00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`00017oi^KV00?oIVIVonKVi_oVi^H0>_oVi^H001Oo
i^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?m<C4coi^KV
05Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000001;oi^KV00?o
IVIVonKVi_oVi^H0>_oVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKV
i_oVi^KoC4a<05Soi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`00
01;oi^KV:?mVIVHDonKViP005ooVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KV
onKVi_l000000_oVi^H00ol0003oi^KVonKViP1FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go
0000onKVi_oVi^Koi^KVo`00001?onKViP005ooVi^H01?l0003oi^KVonKVi_l00007onKViP05o`00
0?oVi^Koi^KVonKVi_l00000FooVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000DooVi^H001So
i^KV0_l00009onKViP?o0000GOoVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H0DOoVi^H00>?oi^KV
003SonKViP00>_oVi^H4o`0000Coi^KV0_l00002onKViP?o00000ooVi^H5o`0004koi^KV1Ol00000
1_oVi^Ko0000o`000?l0003oi^KVo`0000?oi^KV0_l00002onKViP;o000000?oi^KVo`000?l00000
1?l00004onKViP?o00008_oVi^H003_oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KV
onKVi_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko0000CooVi^H01?l0
003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000
onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00Co0000onKVi_oVi^Ko00008OoVi^H0
03_oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oV
i^Koi^KV00?oi^KV00?o0000onKVi_oVi^H0D?oVi^H00ol0003oi^KVonKViP03onKViP06o`000?oV
i^Ko0000o`000?oVi^Ko00001OoVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H01_oVi^H00ol0003o
i^KVonKViP0OonKViP00>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV053oi^KV0ol00003onKViP06o`000?oVi^Ko0000
o`000?oVi^Ko00001_oVi^H00ol0003oi^KVo`000003onKViP?o00001?oVi^H2o`0002;oi^KV000k
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KV
onKVi_l00002onKViP03o`000?oVi^Koi^KV053oi^KV00?o0000onKVi_oVi^H00ooVi^H2o`000004
onKVi_l0003oi^KVo`0000Koi^KV00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00002
onKViP03o`000?oVi^Koi^KV02;oi^KV000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV053oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H2o`000005onKVi_l0003oi^KVonKVi_l000000_oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000Coi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKV
i_l0000QonKViP00>_oVi^H4o`0000;oi^KV0ol000000ooVi^Ko0000o`000004o`0000;oi^KV0ol0
001@onKViPGo000000Coi^KVo`000?l0003oi^KV0ol00002onKViP?o00000_oVi^H2o`0000?oi^KV
1?l00004onKViP?o00008OoVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooV
i^H00>?oi^KV003SonKViP00UOoVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H<o`0000?o
i^KV00?o0000onKVi_oVi^H00_oVi^H3o`000005onKVi_l0003o0000o`000?oVi^H00ol00004onKV
iP03o`000?oVi^Koi^KV00;oi^KV0ol000001?oVi^Ko0000o`000?l0000ConKViP004OoVi^H2o`00
00Coi^KV00?o0000onKVi_oVi^H00ooVi^H3o`0007Koi^KV00?o0000onKVi_oVi^H01ooVi^H01?l0
003oi^KVonKVi_oVi^H2o`0000;oi^KV0_l00002onKViP03o`000?oVi^Koi^KV00Goi^KV00Go0000
onKVi_oVi^Koi^KVo`000003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H01ol0003oi^KV
onKVi_oVi^Ko0000onKVi_l000005?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000007?oi^KV00?o0000onKVi_oVi^H02ooVi^H00ol0003oi^KVo`000003
onKViP03o`000?oVi^Koi^KV00_oi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP03o`000?oV
i^Koi^KV00Soi^KV1Ol0000ConKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViPGo00000_oV
i^HGoaTI6Egoi^KV00?o0000onKVi_oVi^H02ooVi^H01?l0003oi^KVonKVi_l00003onKViP03o`00
0?oVi^Koi^KV00[oi^KV00Co0000onKVi_l0003o00000_oVi^H2o`0000_oi^KV0_l000000ooVi^Ko
0000onKViP0ConKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP04o`000?oVi^Koi^KVo`00
00?oi^KV00?o0000onKVi_oVi^H04ooVi^H00olI6AWoi^KVonKViP1KonKViP03o`000?oVi^Koi^KV
00Ooi^KV1Ol00003onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H4o`0000Coi^KV00Go0000
onKVi_oVi^Koi^KVo`000007onKViPGo000000?oi^KVo`000?oVi^H04ooVi^H0013oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV01Coi^KV00?o
6ATIonKVi_oVi^H0FOoVi^H2o`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP05o`00
0?oVi^Koi^KVonKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Go0000onKV
i_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV00;oi^KV0_l0000DonKViP004?oVi^H01?l0
003oi^KVonKVi_l00009onKViP;o00000ooVi^H00ol0003oi^KVonKViP0DonKViP03oaTI6OoVi^Ko
i^KV05[oi^KV00?o0000onKVi_oVi^H01ooVi^H8o`000004onKVi_l0003o0000o`0000Soi^KV2?l0
00001?oVi^Ko0000o`000?l00008onKViPGo000000?oi^KVo`000?oVi^H04ooVi^H0017oi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV01Goi^KV00?o
6ATIonKVi_oVi^H0E_oVi^H00ol0003oi^KVonKViP1=onKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0EonKViP03oaTI
6OoVi^Koi^KV05Goi^KV00?o0000oc<c<ol00000??l0000BonKViP004?oVi^H01?l0003oi^KVonKV
i_l0000;onKViP04o`000?oVi^Koi^KVo`0001Soi^KV00?o6ATIonKVi_oVi^H0EOoVi^H0=?lc<c?o
i^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko
0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003o
i^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko
0000onKVi_l0003oi^KVo`000?oVi^H2o`000006onKVi_l0003oi^KVo`000?oVi^Ko00005?oVi^H0
013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000IonKViP03oaTI6OoV
i^Koi^KV05Coi^KV00?o0000oc<c<ooVi^H0COoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooV
i^H4o`0000?oi^KV00?o0000onKVi_oVi^H05ooVi^H00olI6AWoi^KVonKViP1DonKViP03o`000?lc
<c?oi^KV04goi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oVi^H01?oV
i^H00ol0003oi^KVonKViP0HonKViP03oaTI6OoVi^Koi^KV05?oi^KV0_l000000olc<c?oi^KVonKV
iP1;onKViP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oVi^Koi^KV01Soi^KV00?o6ATI
onKVi_oVi^H0?OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000;oi^KV1Ol00000
1?oVi^Ko0000onKVi_lc<c==onKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3
o`0000?oi^KV00?o0000onKVi_oVi^H06OoVi^H00olI6AWoi^KVonKViP0konKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00;o
000000?oi^KVoc<c<ooVi^H0BooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H06OoVi^H00olI6AWoi^KVonKViP0konKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000?oi^KV00?o<c<conKVi_oVi^H0BOoVi^H0013oi^KV00Co0000onKVi_oVi^Ko0000
1ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H06_oVi^H00olI6AWo
i^KVonKViP0jonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H0
0ol0003oi^KVonKViP02o`0000;oi^KV00?o<c<conKVi_oVi^H0BOoVi^H0013oi^KV00Co0000onKV
i_oVi^Ko00001ooVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H06_oVi^H00olI6AWoi^KVonKViP0j
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04
o`000?oVi^Ko0000o`0000?oi^KV00?o<c<conKVi_oVi^H0B?oVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV01_oi^KV00?o6ATIonKV
i_oVi^H0>OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0ooVi^H00ol0003oi^KVo`000004onKViP03oc<c<ooVi^Koi^KV04Soi^KV000@onKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP0KonKViP03oaTI
6OoVi^Koi^KV03[oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000;oi^KV0_l00004onKViP03oc<c
<ooVi^Koi^KV04Ooi^KV000AonKViP;o00002_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H07?oV
i^H00olI6AWoi^KVonKViP0ionKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00001?oV
i^H3o`000003onKVi_l0003oi^KV00Coi^KV00?o<c<conKVi_oVi^H0AooVi^H0017oi^KV0_l00004
onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0M
onKViP03oaTI6OoVi^Koi^KV03Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKV
i_l00004onKViP03o`000?oVi^Koi^KV00;o00001OoVi^H00olc<c?oi^KVonKViP16onKViP004?oV
i^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0
7OoVi^H00olI6AWoi^KVonKViP0gonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oV
i^Ko0000onKViP05o`000003onKVi_l0003oi^KV00Goi^KV00?o<c<conKVi_oVi^H0A_oVi^H0013o
i^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000023oi^KV00?o6ATI
onKVi_oVi^H0=_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000_oVi^H00ol0003oi^KVonKViP02o`0000Koi^KV00?o<c<conKVi_oVi^H0AOoVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000023oi^KV00?o6ATIonKV
i_oVi^H0=_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o
0000onKVi_l000000_oVi^H00ol0003oi^KVonKViP05onKViP03oc<c<ooVi^Koi^KV04Goi^KV000@
onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00008OoVi^H00olI6AWoi^KV
onKViP0eonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H2o`00
00;oi^KV0_l00007onKViP03oc<c<ooVi^Koi^KV04Coi^KV000@onKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01ooi^KV00?o6ATI
onKVi_oVi^H0=_oVi^H2o`0000[oi^KV0_l00005onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?o
<c<conKVi_oVi^H0A?oVi^H0017oi^KV0_l00008onKViPGo00000_oVi^H00ol0003oi^KVonKViP0P
onKViP03oaTI6OoVi^Koi^KV04_oi^KV0_l00008onKViP03oc<c<ooVi^Koi^KV04?oi^KV000AonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP0PonKV
iP03oaTI6OoVi^Koi^KV03Goi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKV
iP?o00000_oVi^H2o`0000Woi^KV00?o<c<conKVi_oVi^H0@_oVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H08OoVi^H0
0olI6AWoi^KVonKViP0conKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000
onKVi_l00003onKViP03o`000?oVi^Ko000000[oi^KV00?o<c<conKVi_oVi^H0@_oVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKV
i_oVi^H08_oVi^H00olI6AWoi^KVonKViP0bonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0000[oi^KV00?o<c<conKVi_oV
i^H0@OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H3o`0000?oi^KV00?o0000onKVi_oV
i^H08_oVi^H00olI6AWoi^KVonKViP0bonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKV
i_oVi^Ko0000onKViP04o`0000;oi^KV00?o0000onKVi_oVi^H02OoVi^H00olc<c?oi^KVonKViP11
onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oV
i^H00ol0003oi^KVonKViP0SonKViP03oaTI6OoVi^Koi^KV037oi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Goi^KV0_l0000;onKViP03oc<c<ooVi^Koi^KV
043oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002
onKViP03o`000?oVi^Koi^KV02?oi^KV00?o6ATIonKVi_oVi^H0<OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KV
onKViP0:onKViP03oc<c<ooVi^Koi^KV043oi^KV000AonKViP;o00002OoVi^H3o`0000?oi^KV00?o
0000onKVi_oVi^H09?oVi^H00olI6AWoi^KVonKViP0aonKViP;o00002_oVi^H2o`0000Coi^KV0_l0
0002onKViP;o00003?oVi^H00olc<c?oi^KVonKViP0oonKViP004OoVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H09?oVi^H00olI6AWoi^KVonKViP0a
onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000
onKVi_oVi^H02ooVi^H00olc<c?oi^KVonKViP0oonKViP004?oVi^H01?l0003oi^KVonKVi_l0000:
onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oV
i^H3o`000003onKVi_l0003o000000So00000ooVi^H00ol0003oi^KVonKViP02onKViP?o000000?o
6ATIonKVi_oVi^H00ol00002onKViP?o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooV
i^H3o`0001Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`00
00?oi^KV00Co0000onKVi_l0003o00003OoVi^H00olc<c?oi^KVonKViP0nonKViP004?oVi^H01?l0
003oi^KVonKVi_l0000;onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H01ooV
i^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_l000000_oVi^H00ol0003oi^KVo`000002onKViP03
o`000?oVi^Koi^KV00Goi^KV00Oo0000onKVi_oVi^Koi^KVoaTI6OoVi^Ko000000?oi^KV0_l00003
onKViP03o`000?oVi^Koi^KV00Goi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP03o`000?oV
i^Koi^KV01Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`00
00?oi^KV00Co0000onKVi_l0003o00003OoVi^H00olc<c?oi^KVonKViP0nonKViP004?oVi^H01?l0
003oi^KVonKVi_l00008onKViPCo00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000goi^KV00Co
0000onKVi_oVi^Ko00001?oVi^H00ol0003oi^KVonKViP0;onKViP03o`000?lI6AWoi^KV00?oi^KV
00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP09onKViPKo00005OoVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV
00goi^KV00?o<c<conKVi_oVi^H0?OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000=onKViP05o`000?oV
i^Koi^KVonKVi_l000001?oVi^H00ol0003oi^KVonKViP0:onKViP04o`000?lI6AWoi^KVonKViP;o
00000ooVi^H2o`0000coi^KV0_l00002onKViP03o`000?oVi^Koi^KV01Coi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o0000
3_oVi^H00olc<c?oi^KVonKViP0monKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`00
0?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Woi^KV1?l000000ooV
i^Ko0000onKViP02onKViP;o00000ooVi^H00ol0003oi^KVonKViP05onKViPCo00000_oVi^H01OlI
6AWoi^KVonKVi_oVi^Ko000000Coi^KV00?o0000onKVi_oVi^H01OoVi^H4o`0000;oi^KV00?o0000
onKVi_l000005_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000ooVi^H00ol0003oi^KVo`00000@onKViP03oc<c<ooVi^Koi^KV03coi^KV000AonKViP;o0000
2OoVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H00_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV
00Co0000onKVi_oVi^Koi^KV0_l00003onKViP03o`000?oVi^Koi^KV00Goi^KV00?o0000onKVi_oV
i^H00ooVi^H01?l0003o6ATIonKVi_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0
003oi^KVonKViP04onKViP;o00005ooVi^H2o`0000[oi^KV0_l00003onKViP?o00000_oVi^H2o`00
013oi^KV00?o<c<conKVi_oVi^H0>ooVi^H002;oi^KV00Go0000onKVi_oVi^Koi^KVo`000009onKV
iPGo000000Coi^KVo`000?l0003o00000_oVi^H3o`0000Soi^KV1Ol00002onKViP03oaTI6Ol0003o
000000;oi^KV0ol00008onKViPGo00000ooVi^H00ol0003oi^KVonKViP0KonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP02onKViP?o00000_oVi^H00ol0003oi^KVonKViP0?onKViP03oc<c<ooVi^Ko
i^KV03_oi^KV000RonKViP03o`000?oVi^Koi^KV02Woi^KV00?o6ATIonKVi_oVi^H0<OoVi^H01?l0
003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o00004OoVi^H00olc<c?oi^KVonKV
iP0jonKViP008_oVi^H00ol0003oi^KVonKViP0YonKViP03oaTI6OoVi^Koi^KV00Woi^KV3?lI6ATL
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00000BonKViP03oc<c
<ooVi^Koi^KV03[oi^KV000PonKViRoo00002olI6AT>o`0001[oi^KV00Co0000onKVi_oVi^Ko0000
2OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0001;oi^KV:?lc<c<DonKViP008_oVi^H00ol0003oi^KV
onKViP1MonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKV
iP00P_oVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000DooVi^H008?oi^KV0_l0000:onKViP03
o`000?oVi^Koi^KV057oi^KV003SonKViP00=ooVi^H2o`0000;oi^KV0ol00002onKViP03o`000?oV
i^Ko000000;o00000ooVi^H3o`0000?oi^KV0ol0001>onKViPCo00000_oVi^H5o`0000?oi^KV0_l0
0002onKViP;o000000?oi^KVo`000?l000001?l00004onKViP?o00008_oVi^H003Koi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04coi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00027oi^KV000e
onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Goi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP03onKViPGo0000
0_oVi^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV01ooi^KV000eonKViP03o`000?oV
i^Koi^KV00Coi^KV0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H2o`0000Coi^KV
0_l0001?onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Co
i^KV00?o0000onKVi_l000000ooVi^H3o`0000Coi^KV0_l0000RonKViP00=OoVi^H00ol0003oi^KV
onKViP04onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005
onKViP03o`000?oVi^Koi^KV04ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKV
iP02onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKV
i_l00002onKViP03o`000?oVi^Koi^KV02;oi^KV000fonKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV
00;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000QonKViP00=ooVi^H3
o`000003onKVi_l0003o000000;o00000ooVi^H3o`0000Coi^KV0ol00003onKViP?o0000COoVi^H4
o`0000;oi^KV1Ol00003onKViP?o00000_oVi^H2o`0000?oi^KV1?l00004onKViP?o00008OoVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooV
i^H00>?oi^KV003SonKViP00hooVi^H005[oi^KV1?l00025onKViP00FooVi^H2o`0008Koi^KV001K
onKViP;o0000Q_oVi^H003ooi^KV1Ol00002onKViPCo00002OoVi^H5o`0000?oi^KV1Ol00002onKV
iP?o000000?oi^KVo`000?l000000_l000000ooVi^Ko0000o`000004o`0000;oi^KV0_l000000ooV
i^Ko0000o`000002o`000003onKVi_l0003o000000;o00001OoVi^H4o`0000;oi^KV3?l000000ooV
i^Ko0000o`000004o`000003onKVi_l0003o000000Go0000?_oVi^H003koi^KV0_l00003onKViP;o
00000_oVi^H2o`0000Woi^KV0_l00003onKViP;o00000_oVi^H2o`0000;oi^KV1?l00002onKViP04
o`000?oVi^Ko0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`00
0?l000000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV0_l00002onKViP?o000000Coi^KVo`00
0?l0003oi^KV0_l00002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o
0000onKVi_l000000_oVi^H2o`0003goi^KV000monKViP;o00001?oVi^H2o`0000;oi^KV0_l00008
onKViP;o00001OoVi^H2o`000003onKVi_l0003o000000;oi^KV1?l00004onKViP;o00000_oVi^H2
o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KV
o`000?l000001ooVi^H2o`000004onKVi_l0003o0000o`0000;oi^KV0_l000000ooVi^Ko0000o`00
0002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000?oi^KV0ol0
000monKViP00?OoVi^H2o`0000?oi^KV1?l000000ooVi^Ko0000o`000003o`0000Goi^KV0_l00005
onKViP;o000000?oi^KVo`000?l000000_oVi^H7o`000003onKVi_l0003o000000Coi^KV0ol00002
onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV1Ol00005
onKViP?o00000_oVi^H2o`000003onKVi_l0003o000000;oi^KV1?l00002onKViP?o0000?ooVi^H0
03goi^KV0_l00008onKViP;o00000_oVi^H2o`0000Coi^KV0_l00005onKViP;o000000Goi^KVo`00
0?l0003o0000onKViP04o`000004onKVi_l0003o0000onKViPKo000000?oi^KVo`000?l000000_oV
i^H2o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002o`0000Goi^KV0_l0
0003onKViP;o000000Coi^KVo`000?l0003oi^KV0_l00002onKViPGo00000_oVi^H2o`0000;oi^KV
00Co0000onKVi_l0003o00000_oVi^H00ol0003oi^KVonKViP0konKViP00?OoVi^H2o`0000Goi^KV
00?o0000onKVi_oVi^H00_l00002onKViP;o00001?oVi^H2o`0000Goi^KV1Ol000000ooVi^Ko0000
o`000002onKViP?o000000Ooi^KVo`000?l0003o0000onKVi_l0003oi^KV00?o00000_oVi^H4o`00
0003onKVi_l0003o000000;o000000Koi^KVo`000?l0003o0000onKVi_l00005onKViP;o00000ooV
i^H2o`0000;oi^KV0ol00002onKViP?o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0
003o0000o`000?oVi^H01?l0000monKViP00?_oVi^H2o`0000?oi^KV0_l00002onKViP;o00000_oV
i^H2o`0000Goi^KV0_l00003onKViP;o00006OoVi^H2o`00017oi^KV0_l00003onKViP;o00003ooV
i^H2o`0004Koi^KV000oonKViPCo000000?oi^KVo`000?oVi^H01_l00007onKViPGo00006ooVi^H0
0ol0003oi^KVonKViP0>onKViPOo00003ooVi^H3o`0004Koi^KV003SonKViP00hooVi^H00001\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-1.10897, \
-0.0445132, 0.0509119, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-6.53267, -0.0890264, 0.0509119, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-0.538429, -0.711658, 0.0447221, 0.0144724}, {{118.125, \
214.938}, {214.625, 154.75}} -> {-6.37994, -0.725265, 0.0509119, 0.0112719}, \
{{11.5625, 108.438}, {148.812, 88.9375}} -> {-1.10897, -0.306114, 0.0509119, \
0.0027459}, {{118.125, 214.938}, {148.812, 88.9375}} -> {-6.53267, -0.406114, \
0.0509119, 0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-0.51936, \
-2.61842, 0.0444396, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> \
{-6.53267, -0.587, 0.0509119, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 0.99`}\\)}, \
{\\({DECAPS, 0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, \
{\\({MUTAT, 0.99`}\\)}, {\\({PERM, 0.59835105`}\\)}, {\\({REPRO, 0.1`}\\)}, {\
\\({\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)}}, ColumnAlignments -> Left, \
GridBaseline -> {Baseline, {1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \!\(AntTracker[\(\(seq[\(\
\(advance, advance\)\)]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[food]\)\)[\(\(_seq, _seq\)\)]\)}\) is not \
present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
decapsulation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(5\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 5.55112e-17 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.73232 .00576 0 -8.88217 ]
[.73232 .00576 10.625 5.11783 ]
[.79306 .07584 0 -8.73184 ]
[.79306 .07584 10.625 5.26816 ]
[.84629 .13728 0 -8.60375 ]
[.84629 .13728 10.625 5.39625 ]
[.89334 .19158 0 -8.49331 ]
[.89334 .19158 10.625 5.50669 ]
[.93522 .23991 0 -8.39709 ]
[.93522 .23991 10.625 5.60291 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.71869 .00942 m
.71188 .01126 L
s
gsave
.73232 .00576 -61 -12.8822 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.77936 .07923 m
.77251 .08093 L
s
gsave
.79306 .07584 -61 -12.7318 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.83254 .14043 m
.82566 .14201 L
s
gsave
.84629 .13728 -61 -12.6037 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.87954 .19452 m
.87264 .19599 L
s
gsave
.89334 .19158 -61 -12.4933 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.92138 .24267 m
.91446 .24405 L
s
gsave
.93522 .23991 -61 -12.3971 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.14775 .2355 m
.11175 .91919 L
s
.29671 .31885 m
.27691 .93562 L
s
.41866 .3871 m
.40989 .94886 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.41906 .35608 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.4675 .34659 m .57042 .37159 L .52233 .38044 L F
.41906 .35608 m .4675 .34659 L .52233 .38044 L F
.51723 .33684 m .61975 .36251 L .57042 .37159 L F
.4675 .34659 m .51723 .33684 L .57042 .37159 L F
.56833 .32683 m .67039 .35318 L .61975 .36251 L F
.51723 .33684 m .56833 .32683 L .61975 .36251 L F
.35695 .31973 m .4675 .34659 L .41906 .35608 L F
.62083 .31654 m .72237 .34361 L .67039 .35318 L F
.56833 .32683 m .62083 .31654 L .67039 .35318 L F
.40701 .30924 m .51723 .33684 L .4675 .34659 L F
.35695 .31973 m .40701 .30924 L .4675 .34659 L F
.67481 .30596 m .77575 .33379 L .72237 .34361 L F
.62083 .31654 m .67481 .30596 L .72237 .34361 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .41017 .92497 L p F P
0 0 0 r
s
.45849 .29846 m .56833 .32683 L .51723 .33684 L 1 0 0 r
F
.40701 .30924 m .45849 .29846 L .51723 .33684 L F
.73032 .29508 m .8306 .32369 L .77575 .33379 L F
.67481 .30596 m .73032 .29508 L .77575 .33379 L F
.57295 .92839 m .52132 .93033 L .46221 .92288 L p F P
0 0 0 r
s
.41017 .92497 m .46221 .92288 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.51145 .28736 m .62083 .31654 L .56833 .32683 L 1 0 0 r
F
.45849 .29846 m .51145 .28736 L .56833 .32683 L F
.78743 .28389 m .88697 .31331 L .8306 .32369 L F
.73032 .29508 m .78743 .28389 L .8306 .32369 L F
.28819 .27949 m .40701 .30924 L .35695 .31973 L F
.62603 .92639 m .57295 .92839 L .51575 .92073 L p F P
0 0 0 r
s
.46221 .92288 m .51575 .92073 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.56595 .27595 m .67481 .30596 L .62083 .31654 L 1 0 0 r
F
.51145 .28736 m .56595 .27595 L .62083 .31654 L F
.84621 .27237 m .94492 .30264 L .88697 .31331 L F
.78743 .28389 m .84621 .27237 L .88697 .31331 L F
.33996 .26784 m .45849 .29846 L .40701 .30924 L F
.28819 .27949 m .33996 .26784 L .40701 .30924 L F
.68061 .92434 m .62603 .92639 L .57087 .91851 L p F P
0 0 0 r
s
.51575 .92073 m .57087 .91851 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.62206 .26419 m .73032 .29508 L .67481 .30596 L 1 0 0 r
F
.56595 .27595 m .62206 .26419 L .67481 .30596 L F
.84621 .27237 m .90674 .2605 L .94492 .30264 L F
.46221 .92288 m .41017 .92497 L .3426 .91694 L p F P
0 0 0 r
s
.39327 .25585 m .51145 .28736 L .45849 .29846 L 1 0 0 r
F
.33996 .26784 m .39327 .25585 L .45849 .29846 L F
.73675 .92223 m .68061 .92434 L .62763 .91623 L p F P
0 0 0 r
s
.57087 .91851 m .62763 .91623 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.67985 .25208 m .78743 .28389 L .73032 .29508 L 1 0 0 r
F
.62206 .26419 m .67985 .25208 L .73032 .29508 L F
.51575 .92073 m .46221 .92288 L .39651 .91461 L p F P
0 0 0 r
s
.3426 .91694 m .39651 .91461 L .46221 .92288 L p 1 0 0 r
F P
0 0 0 r
s
.4482 .24349 m .56595 .27595 L .51145 .28736 L 1 0 0 r
F
.39327 .25585 m .4482 .24349 L .51145 .28736 L F
.79453 .92005 m .73675 .92223 L .68612 .91388 L p F P
0 0 0 r
s
.62763 .91623 m .68612 .91388 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.73941 .23961 m .84621 .27237 L .78743 .28389 L .5 0 1 r
F
.67985 .25208 m .73941 .23961 L .78743 .28389 L 1 0 0 r
F
.21164 .23471 m .33996 .26784 L .28819 .27949 L F
.57087 .91851 m .51575 .92073 L .45208 .91221 L p F P
0 0 0 r
s
.39651 .91461 m .45208 .91221 L .51575 .92073 L p 1 0 0 r
F P
0 0 0 r
s
.50483 .23074 m .62206 .26419 L .56595 .27595 L 1 0 0 r
F
.4482 .24349 m .50483 .23074 L .56595 .27595 L F
.85402 .91782 m .79453 .92005 L .7464 .91145 L p F P
0 0 0 r
s
.68612 .91388 m .7464 .91145 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.8008 .22674 m .90674 .2605 L .84621 .27237 L 0 1 1 r
F
.73941 .23961 m .8008 .22674 L .84621 .27237 L .5 0 1 r
F
.2652 .22169 m .39327 .25585 L .33996 .26784 L F
.21164 .23471 m .2652 .22169 L .33996 .26784 L 1 0 0 r
F
.62763 .91623 m .57087 .91851 L .50937 .90973 L p F P
0 0 0 r
s
.45208 .91221 m .50937 .90973 L .57087 .91851 L p 1 0 0 r
F P
0 0 0 r
s
.56322 .2176 m .67985 .25208 L .62206 .26419 L .5 0 1 r
F
.50483 .23074 m .56322 .2176 L .62206 .26419 L 1 0 0 r
F
.91529 .91551 m .85402 .91782 L .80857 .90895 L p F P
0 0 0 r
s
.7464 .91145 m .80857 .90895 L .85402 .91782 L p 1 0 0 r
F P
0 0 0 r
s
.8008 .22674 m .86412 .21348 L .90674 .2605 L 0 1 1 r
F
.39651 .91461 m .3426 .91694 L .26718 .90797 L p 1 0 0 r
F P
0 0 0 r
s
.32044 .20826 m .4482 .24349 L .39327 .25585 L 0 1 1 r
F
.2652 .22169 m .32044 .20826 L .39327 .25585 L .5 0 1 r
F
.68612 .91388 m .62763 .91623 L .56848 .90717 L p 1 0 0 r
F P
0 0 0 r
s
.50937 .90973 m .56848 .90717 L .62763 .91623 L p 1 0 0 r
F P
0 0 0 r
s
.97843 .91314 m .91529 .91551 L .87271 .90637 L p 1 0 0 r
F P
0 0 0 r
s
.80857 .90895 m .87271 .90637 L .91529 .91551 L p 1 0 0 r
F P
0 0 0 r
s
.62347 .20405 m .73941 .23961 L .67985 .25208 L 0 1 1 r
F
.56322 .2176 m .62347 .20405 L .67985 .25208 L .5 0 1 r
F
.45208 .91221 m .39651 .91461 L .32307 .90536 L p 1 0 0 r
F P
0 0 0 r
s
.26718 .90797 m .32307 .90536 L .39651 .91461 L p 1 0 0 r
F P
0 0 0 r
s
.37746 .1944 m .50483 .23074 L .4482 .24349 L 0 1 1 r
F
.32044 .20826 m .37746 .1944 L .4482 .24349 L F
.7464 .91145 m .68612 .91388 L .62948 .90454 L p 1 0 0 r
F P
0 0 0 r
s
.56848 .90717 m .62948 .90454 L .68612 .91388 L p 1 0 0 r
F P
0 0 0 r
s
.87271 .90637 m .93893 .90371 L .97843 .91314 L p 1 0 0 r
F P
0 0 0 r
s
.68566 .19005 m .8008 .22674 L .73941 .23961 L .5 1 0 r
F
.62347 .20405 m .68566 .19005 L .73941 .23961 L 0 1 1 r
F
.12592 .18455 m .2652 .22169 L .21164 .23471 L 1 0 0 r
F
.50937 .90973 m .45208 .91221 L .38077 .90266 L p F P
0 0 0 r
s
.32307 .90536 m .38077 .90266 L .45208 .91221 L p 1 0 0 r
F P
0 0 0 r
s
.43634 .18009 m .56322 .2176 L .50483 .23074 L 0 1 1 r
F
.37746 .1944 m .43634 .18009 L .50483 .23074 L F
.80857 .90895 m .7464 .91145 L .69247 .90181 L p 1 0 0 r
F P
0 0 0 r
s
.62948 .90454 m .69247 .90181 L .7464 .91145 L p 1 0 0 r
F P
0 0 0 r
s
.74989 .1756 m .86412 .21348 L .8008 .22674 L 1 0 0 r
F
.68566 .19005 m .74989 .1756 L .8008 .22674 L .5 1 0 r
F
.18133 .16991 m .32044 .20826 L .2652 .22169 L 0 1 1 r
F
.12592 .18455 m .18133 .16991 L .2652 .22169 L 1 0 0 r
F
.56848 .90717 m .50937 .90973 L .44038 .89988 L p F P
0 0 0 r
s
.38077 .90266 m .44038 .89988 L .50937 .90973 L p 1 0 0 r
F P
0 0 0 r
s
.49718 .16531 m .62347 .20405 L .56322 .2176 L .5 1 0 r
F
.43634 .18009 m .49718 .16531 L .56322 .2176 L 0 1 1 r
F
.87271 .90637 m .80857 .90895 L .75755 .899 L p .5 0 1 r
F P
0 0 0 r
s
.69247 .90181 m .75755 .899 L .80857 .90895 L p 1 0 0 r
F P
0 0 0 r
s
.74989 .1756 m .81627 .16066 L .86412 .21348 L 1 0 0 r
F
.32307 .90536 m .26718 .90797 L .18247 .89789 L p F P
0 0 0 r
s
.23859 .15478 m .37746 .1944 L .32044 .20826 L 1 0 0 r
F
.18133 .16991 m .23859 .15478 L .32044 .20826 L 0 1 1 r
F
.62948 .90454 m .56848 .90717 L .50199 .897 L p 1 0 0 r
F P
0 0 0 r
s
.44038 .89988 m .50199 .897 L .56848 .90717 L p 1 0 0 r
F P
0 0 0 r
s
.56006 .15002 m .68566 .19005 L .62347 .20405 L 1 0 0 r
F
.49718 .16531 m .56006 .15002 L .62347 .20405 L .5 1 0 r
F
.93893 .90371 m .87271 .90637 L .80835 .43712 L p 0 1 1 r
F P
0 0 0 r
s
.75755 .899 m .80835 .43712 L .87271 .90637 L p .5 0 1 r
F P
0 0 0 r
s
.80835 .43712 m .87364 .42687 L .93893 .90371 L p 0 1 1 r
F P
0 0 0 r
s
.87364 .42687 m .80835 .43712 L .75637 .39755 L p 1 0 0 r
F P
0 0 0 r
s
.80835 .43712 m .75755 .899 L .69012 .40875 L p .5 1 0 r
F P
0 0 0 r
s
.69012 .40875 m .75637 .39755 L .80835 .43712 L p .5 1 0 r
F P
0 0 0 r
s
.38077 .90266 m .32307 .90536 L .24042 .89495 L p .5 0 1 r
F P
0 0 0 r
s
.18247 .89789 m .24042 .89495 L .32307 .90536 L p 1 0 0 r
F P
0 0 0 r
s
.2978 .13914 m .43634 .18009 L .37746 .1944 L 1 0 0 r
F
.23859 .15478 m .2978 .13914 L .37746 .1944 L F
.69247 .90181 m .62948 .90454 L .5657 .89402 L p .5 0 1 r
F P
0 0 0 r
s
.50199 .897 m .5657 .89402 L .62948 .90454 L p 1 0 0 r
F P
0 0 0 r
s
.6251 .13422 m .74989 .1756 L .68566 .19005 L 1 0 0 r
F
.56006 .15002 m .6251 .13422 L .68566 .19005 L F
.75637 .39755 m .8249 .38597 L .87364 .42687 L p F P
0 0 0 r
s
.44038 .89988 m .38077 .90266 L .31414 .42284 L p 0 1 1 r
F P
0 0 0 r
s
.24042 .89495 m .31414 .42284 L .38077 .90266 L p .5 0 1 r
F P
0 0 0 r
s
.31414 .42284 m .37275 .41212 L .44038 .89988 L p 0 1 1 r
F P
0 0 0 r
s
.37275 .41212 m .31414 .42284 L .22934 .3814 L p 1 0 0 r
F P
0 0 0 r
s
.31414 .42284 m .24042 .89495 L .14671 .88315 L p 0 1 1 r
F P
0 0 0 r
s
.14671 .88315 m .22934 .3814 L .31414 .42284 L p 0 1 1 r
F P
0 0 0 r
s
.35907 .12295 m .49718 .16531 L .43634 .18009 L 1 0 0 r
F
.2978 .13914 m .35907 .12295 L .43634 .18009 L F
.75755 .899 m .69247 .90181 L .62603 .41958 L p 0 1 1 r
F P
0 0 0 r
s
.5657 .89402 m .62603 .41958 L .69247 .90181 L p .5 0 1 r
F P
0 0 0 r
s
.62603 .41958 m .69012 .40875 L .75755 .899 L p 0 1 1 r
F P
0 0 0 r
s
.69012 .40875 m .62603 .41958 L .56081 .37771 L p 1 0 0 r
F P
0 0 0 r
s
.62603 .41958 m .5657 .89402 L .49598 .38957 L p .5 1 0 r
F P
0 0 0 r
s
.49598 .38957 m .56081 .37771 L .62603 .41958 L p .5 1 0 r
F P
0 0 0 r
s
.69242 .11786 m .81627 .16066 L .74989 .1756 L 1 0 0 r
F
.6251 .13422 m .69242 .11786 L .74989 .1756 L F
.50199 .897 m .44038 .89988 L .37275 .41212 L p 0 1 1 r
F P
0 0 0 r
s
.37275 .41212 m .43333 .40103 L .50199 .897 L p 0 1 1 r
F P
0 0 0 r
s
.43333 .40103 m .37275 .41212 L .29027 .36926 L p 1 0 0 r
F P
0 0 0 r
s
.22934 .3814 m .29027 .36926 L .37275 .41212 L p 1 0 0 r
F P
0 0 0 r
s
.42251 .10619 m .56006 .15002 L .49718 .16531 L 1 0 0 r
F
.35907 .12295 m .42251 .10619 L .49718 .16531 L F
.75637 .39755 m .69012 .40875 L .62793 .36543 L p F P
0 0 0 r
s
.56081 .37771 m .62793 .36543 L .69012 .40875 L p 1 0 0 r
F P
0 0 0 r
s
.69242 .11786 m .76213 .10091 L .81627 .16066 L 1 0 0 r
F
.24042 .89495 m .18247 .89789 L .08662 .88649 L p F P
0 0 0 r
s
.5657 .89402 m .50199 .897 L .43333 .40103 L p 0 1 1 r
F P
0 0 0 r
s
.43333 .40103 m .49598 .38957 L .5657 .89402 L p 0 1 1 r
F P
0 0 0 r
s
.49598 .38957 m .43333 .40103 L .35338 .35667 L p 1 0 0 r
F P
0 0 0 r
s
.29027 .36926 m .35338 .35667 L .43333 .40103 L p 1 0 0 r
F P
0 0 0 r
s
.48823 .08883 m .6251 .13422 L .56006 .15002 L 1 0 0 r
F
.42251 .10619 m .48823 .08883 L .56006 .15002 L F
.8249 .38597 m .75637 .39755 L .69747 .35271 L p F P
0 0 0 r
s
.62793 .36543 m .69747 .35271 L .75637 .39755 L p 1 0 0 r
F P
0 0 0 r
s
.08662 .88649 m .14671 .88315 L .24042 .89495 L p 1 0 0 r
F P
0 0 0 r
s
.56081 .37771 m .49598 .38957 L .41879 .34363 L p 1 0 0 r
F P
0 0 0 r
s
.35338 .35667 m .41879 .34363 L .49598 .38957 L p 1 0 0 r
F P
0 0 0 r
s
.55636 .07083 m .69242 .11786 L .6251 .13422 L 1 0 0 r
F
.48823 .08883 m .55636 .07083 L .6251 .13422 L F
.69747 .35271 m .76957 .33952 L .8249 .38597 L p F P
0 0 0 r
s
.62793 .36543 m .56081 .37771 L .48663 .3301 L p 1 0 0 r
F P
0 0 0 r
s
.41879 .34363 m .48663 .3301 L .56081 .37771 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .76213 .10091 L .69242 .11786 L 1 0 0 r
F
.55636 .07083 m .62703 .05216 L .69242 .11786 L F
.69747 .35271 m .62793 .36543 L .55704 .31606 L p F P
0 0 0 r
s
.48663 .3301 m .55704 .31606 L .62793 .36543 L p 1 0 0 r
F P
0 0 0 r
s
.62703 .05216 m .70039 .03278 L .76213 .10091 L 1 0 0 r
F
.76957 .33952 m .69747 .35271 L .63017 .30148 L p F P
0 0 0 r
s
.55704 .31606 m .63017 .30148 L .69747 .35271 L p 1 0 0 r
F P
0 0 0 r
s
.63017 .30148 m .70619 .28632 L .76957 .33952 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00001Golc<c003o`000?o<
c<coc<c<04Ooc<c<0Oooool006Soc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<o`00
0003olc<c0;o000000Goc<c<o`000?o<c<coc<c<o`000003olc<c003o`000?o<c<coc<c<05Coc<c<
00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`01?l0003oc<c<o`000?o<c<`2o`0000?oc<c<
0ol000001?o<c<co0000olc<c?l00002olc<c005o`000?o<c<coc<c<olc<c?l00000BOo<c<`3o`00
00[oc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00
J?o<c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<co000001coc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01coc<c<1?l000000oo<c<co0000
olc<c003olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0Aoo<c<`1ooooo`00UOo<
c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<01Soc<c<1?l00005olc<c003o`000?o<
c<coc<c<00;oc<c<0_l00008olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Goc<c<00?o0000
olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c00Eolc<c0Co00003oo<c<`00ol0003oc<c<olc<c003
olc<c0?o0000BOo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c004olc<c003o`000?o<c<coc<c<04Ooc<c<0Oooool009Koc<c<00?o0000olc<c?o<
c<`01?o<c<`5o`00013oc<c<1?l0000Iolc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<
c<`0Aoo<c<`1ooooo`00Uoo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00ooc<c<
0ol00002olc<c003o`000?o<c<coc<c<01Woc<c<00?o0000olc<c?o<c<`0C?o<c<`1ooooo`00V?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00[oc<c<1?l0000Rolc<c003o`000?o<
c<coc<c<04_oc<c<0Oooool009?oc<c<1_l00005olc<c0Go00001?o<c<`4o`000003olc<c?l0003o
c<c<01Soc<c<0_oo0009olc<c003o`000?o<c<coc<c<04_oc<c<0Oooool00:Coc<c<0ol00005olc<
c003o`000?o<c<coc<c<01Coc<c<1_oo0009olc<c003o`000?o<c<coc<c<04[oc<c<0Oooool007?o
c<c<1?l0000Yolc<c0Go00006_o<c<`;ool000Woc<c<00?o0000olc<c?o<c<`0BOo<c<`1ooooo`00
L_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<02;oc<c<1?l00004olc<c003o`00
0?o<c<coc<c<01Goc<c<3ooo0009olc<c003o`000?o<c<coc<c<04Soc<c<0Oooool007Ooc<c<00?o
0000olc<c?o<c<`07oo<c<`3o`0001goc<c<4ooo0009olc<c003o`000?o<c<coc<c<04Ooc<c<0Ooo
ool007Ooc<c<00?o0000olc<c?o<c<`06oo<c<`4o`0000;oc<c<00?o0000olc<c?o<c<`05oo<c<`H
ool000Woc<c<00?o0000olc<c?o<c<`0A_o<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01Ooc<c<1?l00006olc<c003o`000?o<c<coc<c<01?oc<c<7Ooo0009olc<
c003o`000?o<c<coc<c<00Koc<c<1_l0000iolc<c07ooooo001bolc<c0Go00005oo<c<`3o`0000;o
c<c<00?o0000olc<c?o<c<`05_o<c<`Sool000Soc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003o
c<c<olc<c00lolc<c07ooooo001bolc<c003o`000?o<c<coc<c<01Goc<c<1?l0000Jolc<c2Soo`00
2?o<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<03_oc<c<0Oooool007?oc<c<00?o
0000olc<c?o<c<`04?o<c<`4o`000003olc<c?l0003oc<c<01Ooc<c<;Ooo0008olc<c003o`000?o<
c<coc<c<00Koc<c<0_l0000kolc<c07ooooo001colc<c0Go00002oo<c<`3o`0001[oc<c<<_oo0007
olc<c0?o00002?o<c<`00ol0003oc<c<olc<c00holc<c07ooooo001oolc<c0Co000000?oc<c<o`00
0?o<c<`05_o<c<`gool000Soc<c<00?o0000olc<c?o<c<`01oo<c<`00ol0003oc<c<olc<c00golc<
c07ooooo0019olc<c0Ko00000_o<c<`00ol0003oc<c<olc<c004o`0002?oc<c<1?l0000Iolc<c3co
o`002?o<c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`0=oo<c<`1oooo
o`00BOo<c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<
c<`07Oo<c<`3o`000003olc<c?l0003oc<c<01Koc<c<@Ooo0008olc<c004o`000?o<c<coc<c<o`00
00Coc<c<00?o0000olc<c?o<c<`0=oo<c<`1ooooo`00B_o<c<`00ol0003oc<c<olc<c00;olc<c003
o`000?o<c<coc<c<01Woc<c<1?l00004olc<c003o`000?o<c<coc<c<017oc<c<A_oo0008olc<c003
o`000?o<c<coc<c<00Co0000>_o<c<`1ooooo`00Boo<c<`2o`0000_oc<c<00?o0000olc<c?o<c<`0
5_o<c<`3o`000003olc<c?l0003oc<c<01Goc<c<Booo0007olc<c003o`000?o<c<coc<c<03koc<c<
0Oooool004goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<
c<coc<c<01;oc<c<1?l00004olc<c003o`000?o<c<coc<c<013oc<c<Cooo0008olc<c003o`000?o<
c<coc<c<03goc<c<0Oooool004koc<c<00?o0000olc<c?o<c<`00_o<c<`5o`00017oc<c<1Ol0000F
olc<c5Coo`002?o<c<`00ol0003oc<c<olc<c00lolc<c07ooooo0019olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00@olc<c0?o00001?o<c<`00ol0
003oc<c<olc<c00@olc<c5Woo`002?o<c<`00ol0003oc<c<olc<c00kolc<c07ooooo0019olc<c003
o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00;olc<c0Go
00005_o<c<aMool000Soc<c<00?o0000olc<c?o<c<`0>_o<c<`1ooooo`00B_o<c<`4o`0000Koc<c<
1Ol00005olc<c0Co00001?o<c<`00ol0003oc<c<olc<c00@olc<c6;oo`002?o<c<`00ol0003oc<c<
olc<c008olc<c0Co0000;Oo<c<`1ooooo`00;oo<c<`4o`0002Soc<c<0ol000000oo<c<co0000olc<
c00Dolc<c6Ooo`002?o<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<00;oc<c<00?o
0000olc<c?o<c<`0:_o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<027oc<c<1?l0000Folc<c6coo`002?o<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`0:_o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01goc<c<1?l000000oo<c<co0000olc<c00Dolc<c6ooo`002?o<c<`00ol0
003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<017oc<c<1?l000001?o<c<co0000olc<c?o<c<`4
o`0000;oc<c<00Oo0000olc<c?o<c<coc<c<o`000?o<c<co000000Coc<c<0Oooool002koc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Jolc<c0?o00005oo<c<adool000Soc<c<00?o
0000olc<c?o<c<`01_o<c<`3o`0001?oc<c<00?o0000olc<c?o<c<`00_o<c<`2o`000003olc<c?l0
003oc<c<00?oc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c004olc<c07ooooo000^
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`05_o<c<`4o`000003olc<c?l0003o
c<c<01?oc<c<NOoo0007olc<c0;o00002_o<c<`00ol0003oc<c<olc<c00?olc<c003o`000?o<c<co
c<c<00Coc<c<00?o0000olc<c?l000001_o<c<`01Ol0003oc<c<olc<c?o<c<co000000Koc<c<0Ooo
ool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001Oo<c<`0
0ol0003oc<c<olc<c00?olc<c7goo`002?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`03oo<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<co
000000Go000000?oc<c<o`000?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c07ooooo000^olc<
c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03oo<c<`3o`0000;oc<c<00?o0000olc<
c?o<c<`04_o<c<b2ool000Soc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<co
c<c<00ooc<c<00Co0000olc<c?o<c<coc<c<1?l000000oo<c<co0000olc<c003olc<c003o`000?o<
c<co000000?oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002
olc<c003o`000?o<c<coc<c<00_oc<c<1?l0000Golc<c4Woo`001?moo`0iool000Soc<c<00Co0000
olc<c?o<c<coc<c<1?l0000Bolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`00_o<
c<`01?l0003oc<c<o`000?l00002olc<c003o`000?o<c<coc<c<00Coc<c<0Oooool002ooc<c<1?l0
000:olc<c0Co00000oo<c<`00ol0003oc<c<olc<c00Aolc<c0Co0?ooA?oo000:ogoo03Woo`002?o<
c<`00ol0003oc<c<olc<c00Folc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`01?l0
0002olc<c004o`000?o<c<co0000o`0000Ooc<c<0Oooool003[oc<c<1?l0000Golc<c0So0?oo?_oo
000@ogoo03Soo`002?o<c<`00ol0003oc<c<olc<c00Golc<c003o`000?o<c<coc<c<00;oc<c<00?o
0000olc<c?o<c<`04_o<c<`1ooooo`00=_o<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`04_o<c<`=
o`3oocOoo`001?l0oolBogoo03Soo`002?o<c<`00ol0003oc<c<olc<c00Golc<c0Co00005Oo<c<`1
ooooo`00<_o<c<`4o`000003olc<c?l0003oc<c<01Koc<c<4Ol0oolbool000Wo0?oo4_moo`0hool0
00Soc<c<00?o0000olc<c?o<c<`0;oo<c<`1ooooo`00;oo<c<`3o`0001Woc<c<1?oo000Co`3oobgo
o`003Ol0oolBogoo03Soo`002?o<c<`00ol0003oc<c<olc<c00;olc<c003o`000?o<c<coc<c<023o
c<c<0Oooool002goc<c<0_l000000oo<c<co0000olc<c00Dolc<c0_oo`004_l0oolXool001;o0?oo
4omoo`0Qool000CoOol04_oo0008olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`0
8?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?l0000Aolc<c13oo`004ol0oolRool001Oo0?oo
4omoo`0Kool000[oOol04_oo0008olc<c003o`000?o<c<coc<c<00Goc<c<1_l0000Qolc<c07ooooo
000]olc<c003o`000?o<c<coc<c<01;oc<c<4_oo000Co`3ooa_oo`007Ol0oolCogoo01Goo`004?mo
o`0Bool000Soc<c<00?o0000olc<c?o<c<`01?o<c<`01Ol0003oc<c<olc<c?o<c<co000002;oc<c<
0Oooool002goc<c<0_l0000Eolc<c1;oo`004_l0oolEool002Co0?oo4_moo`0?ool000Co0?oo4_mo
o`0Bool000Soc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?l0000Rolc<c07ooooo
000]olc<c003o`000?o<c<coc<c<01Goc<c<4_oo000Co`3oo`ooo`00:Ol0oolBogoo00_oo`002?l0
oolBogoo01;oo`001_o<c<`2o`0000Ooc<c<00?o0000olc<c?l000008_o<c<`1ooooo`00;Oo<c<`0
0ol0003oc<c<olc<c00Golc<c1;oo`004_l0ool;ool002go0?oo4_moo`06ool000go0?oo4_moo`0B
ool000Ooc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<o`00000Rolc<c07ooooo000]olc<
c003o`000?o<c<coc<c<01Woc<c<4_oo000Bo`3oo`Koo`00<Ol0oolBogoo00;oo`004Ol0oolBogoo
01;oo`001oo<c<`00ol0003oc<c<olc<c004olc<c0;o00008_o<c<`1ooooo`00;Oo<c<`00ol0003o
c<c<olc<c00Jolc<c1;oo`004_l0ool2ool003Go0?oo3omoo`04ogl0oa;o0?oo4_moo`0Bool000Oo
c<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c00Polc<c07ooooo000]olc<c003o`00
0?o<c<coc<c<01coc<c<4_oo000>o`3oo`CoO`3o=_l0ool9ogoo00[oO`3o4_l0oolBogoo01;oo`00
1oo<c<`00ol0003oc<c<olc<c00Volc<c07ooooo000/olc<c003o`000?o<c<coc<c<01ooc<c<4_oo
0007o`3oo`[oO`3o=_l0ool3ogoo013oO`3o4_l0oolBogoo00ooo`000_l0ool8olc<c003o`000?o<
c<coc<c<02Goc<c<0Oooool002coc<c<00?o0000olc<c?o<c<`08?o<c<`Bool000;o0?oo4?mo0?lb
o`3oo`Coo`004_mo0?lBo`3ooa;oOol02Ooo0008o`3oo`Soc<c<00?o0000olc<c?o<c<`09?o<c<`1
ooooo`00;?o<c<`00ol0003oc<c<olc<c00Rolc<c1;oo`004Omo0?l/o`3oo`[oo`004_mo0?lBo`3o
oa;oOol00ooo000>o`3oo`Soc<c<00?o0000olc<c?o<c<`01oo<c<`4o`0001Soc<c<0Oooool002co
c<c<00?o0000olc<c?o<c<`09?o<c<`Aool001;oO`3o9_l0ool?ool001?oO`3o4Ol0ool?ogoo00?o
O`3o4Ol0ool7olc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003o
c<c<olc<c00Eolc<c07ooooo000/olc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`0
3?o<c<`Bool001;oO`3o8?l0oolDool001?oO`3o4Ol0ool9ogoo00WoO`3o4Ol0ool7olc<c003o`00
0?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`05Oo<c<`1ooooo`00;?o<c<`2o`0001Ooc<c<00?o
IVIVolc<c?o<c<`03_o<c<`Aool001;oO`3o6_l0oolKool001;oO`3o4Ol0ool3ogoo00ooO`3o4Ol0
ool7olc<c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<c?o<c<`05Oo<c<`1ooooo`00;?o<c<`0
0ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<00ooc<c<4_oo000Bogl0oa?o0?oo8Ooo000B
ogl0o`ko0?oo1?oo000Aogl0oa7o0?oo1_o<c<`2o`0000Goc<c<00?o0000olc<c?o<c<`00_o<c<`0
0ol0003oc<c<olc<c00Eolc<c07ooooo000/olc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<
c?o<c<`04Oo<c<`Bool0017oO`3o3_l0oolVool001;oO`3o2?l0ool:ool0017oO`3o4Ol0ool7olc<
c003o`000?o<c<coc<c<00;oc<c<1Ol0000Holc<c07ooooo000/olc<c003o`000?o<c<coc<c<01Ko
c<c<00?oIVIVolc<c?o<c<`04oo<c<`Aool001;oO`3o1ol0ool]ool0017oO`3o0_l0ool@ool0017o
O`3o4Ol0ool7olc<c005o`000?o<c<coc<c<olc<c?l000007?o<c<`1ooooo`00;?o<c<`00ol0003o
c<c<olc<c00Folc<c003ofIVI_o<c<coc<c<01Coc<c<4_oo000Aogl0o`;o0?oo<_oo000>ogl0oaGo
o`004Omo0?lAo`3oo`Ooc<c<00Go0000olc<c?o<c<coc<c<o`00000Kolc<c07ooooo000/olc<c003
o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`05_o<c<`Aool000koO`3o=ooo0008ogl0oa_o
o`004Omo0?lAo`3oo`Koc<c<00Co0000olc<c?o<c<coc<c<1Ol0000Golc<c07ooooo000/olc<c003
o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`06?o<c<`Aool000OoO`3o?Ooo0002ogl0ob7o
o`004Omo0?l>o`3oo`;oo`001oo<c<`00ol0003oc<c<olc<c00Lolc<c07ooooo000/olc<c003o`00
0?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`06Oo<c<`Aool000;oO`3oIOoo000Aogl0o`So0?oo
2?oo0007olc<c003o`000?o<c<coc<c<00Soc<c<1?l0000?olc<c07ooooo000/olc<c003o`000?o<
c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`06oo<c<agool0017oO`3o0_l0ool>ool000Ooc<c<00?o
0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00coc<c<0Ooo
ool002coc<c<00?o0000olc<c?o<c<`05Oo<c<`00omVIVKoc<c<olc<c00Nolc<c7Koo`003_mo0?lC
ool000Ooc<c<00?o0000olc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<00coc<c<0Oooool002coc<c<0_l0000Folc<c003ofIVI_o<c<coc<c<01ooc<c<M_oo0008ogl0
oaWoo`001oo<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<
c?o<c<`03?o<c<`1ooooo`00:oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<027o
c<c<Gooo0004o`0001;oo`000_mo0?lOool000Koc<c<0_l00005olc<c0;o00000oo<c<`00ol0003o
c<c<olc<c00<olc<c07ooooo000[olc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`0
8oo<c<aHool000Go00001?oo00000ol0003oo`00ool0000aool000Ooc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<o`000002o`0000ooc<c<0Oooool002_oc<c<00?o0000olc<c?o<c<`05_o<
c<`00omVIVKoc<c<olc<c00Tolc<c5?oo`001?l0000:ool00003o`000?oo003oo`00037oo`000oo<
c<`00omVIVKoc<c<olc<c005olc<c003o`000?o<c<coc<c<017oc<c<0Oooool002_oc<c<00?o0000
olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00Volc<c4coo`001Ol0000?ool00003o`000?oo003o
o`00037oo`000_o<c<`00omVIVKoc<c<olc<c006olc<c005o`000?o<c<coc<c<olc<c?l000003_o<
c<`1ooooo`00:oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<02Soc<c<AOoo0005
o`0001Goo`0000?o0000ool00?oo0000<Ooo00000oo<c<coIVIVolc<c008olc<c0?o00003oo<c<`1
ooooo`00:oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<02[oc<c<?Ooo0006o`00
00Goo`0000?o0000ool00?oo00004ooo00000ol0003oo`00ool0000^ool000?oc<c<00?oIVIVolc<
c?o<c<`06Oo<c<`1ooooo`00:oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<02co
c<c<=_oo0005o`0000coo`0000?o0000ool00?oo00004ooo0002o`0002Woo`002?o<c<`00omVIVKo
c<c<olc<c00Iolc<c07ooooo000[olc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`0
;Oo<c<``ool000Go00004_oo0002o`0001Goo`0000?o0000ool00?oo00008Ooo000=olc<c003ofIV
I_o<c<coc<c<01Woc<c<0Oooool002_oc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<
c00Qolc<c003ofIVI_o<c<coc<c<00_oc<c<:_oo0004o`0000Coo`0000?o0000ool00?oo00004_oo
00000ol0003oo`00ool0000Cool00003o`000?oo003oo`0001_oo`004_o<c<`00omVIVKoc<c<olc<
c00Iolc<c07ooooo000[olc<c0;oIVIV00?o0000olc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Q
olc<c003ofIVI_o<c<coc<c<00goc<c<8ooo0005o`0000Woo`000_l0000Cool00003o`000?oo003o
o`0001?oo`0000?o0000ool00?oo00004ooo000Iolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool0
023oc<c<1?l00007olc<c004o`000?o<c<coIVIVofIVIQGoc<c<00?oIVIVolc<c?o<c<`08Oo<c<`0
0omVIVKoc<c<olc<c00?olc<c1goo`001?l0000@ool00003o`000?oo003oo`00017oo`000_l0000D
ool00003o`000?oo003oo`0000coo`007oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000Oolc<
c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?o<c<`2
ofIVIQ?oc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00@olc<c1Ooo`001Ol0000E
ool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00004_oo00000ol0003oo`00ool00004
ool000Coc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000Oolc<
c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c003olc<
c0;oIVIV4Oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01;oc<c<4?oo0005o`00
00Goo`0000?o0000ool00?oo00004ooo0002o`0001?oo`0000?o0000ool00?oo00004_oo00000ol0
003oc<c<olc<c007olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1oooo
o`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<
c<`01Oo<c<`3ofIVIPkoc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Dolc<c0Wo
o`001Ol0000;ool000;o00005Ooo00000ol0003oo`00ool0000Aool000;o00004?oo0002o`000003
ool00?l0003o000000Ooc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07o
oooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<
olc<c008olc<c0;oIVIV3?o<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<01Goc<c<
0ooo0005o`0001;oo`000_l0000Dool000;o00004ooo00000ol0003oo`00ool00007ool000Ko0000
1Ooo00000ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`0
6?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00?oc<c<00?o
0000olc<c?o<c<`02oo<c<`2ofIVIP[oc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<
c00Colc<c0Go00001?oo00000ol0003oo`00ool0000Bool00003o`000?oo003oo`0001?oo`0000?o
0000ool00?oo00004Ooo00001?l0003oo`00ool00?oo0005o`0000coo`0000?o0000olc<c?o<c<`0
0oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool001ooc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00goc<c<0_mV
IVH7olc<c003ofIVI_o<c<coc<c<02;oc<c<00?oIVIVolc<c?o<c<`03_o<c<`5o`0000[oo`000_l0
000Cool000;o00005?oo00000ol0003oo`00ool0000>ool000;o000000Coo`00o`000?l0003o0000
4_oo00000ol0003oc<c<olc<c002olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`0
6?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00?oc<c<00?o
0000olc<c?o<c<`03oo<c<`2ofIVIPGoc<c<00?oIVIVolc<c?o<c<`08_o<c<`00omVIVKoc<c<olc<
c009olc<c0Go00004Ooo0002o`0001?oo`000_l0000Cool000;o00002Ooo0005o`0000Goo`0000?o
0000ool00?oo00004Ooo00001Ol0003oc<c<olc<c?o<c<coIVIV02;oc<c<00?oIVIVolc<c?o<c<`0
6?o<c<`1ooooo`008?o<c<`4o`0000Koc<c<00?o0000olc<c?o<c<`04Oo<c<`2ofIVIP?oc<c<00?o
IVIVolc<c?o<c<`08_o<c<`00omVIVKoc<c<olc<c004olc<c0Go00001?oo00000ol0003oo`00ool0
000Aool00003o`000?oo003oo`0001;oo`0000?o0000ool00?oo00004_oo00001?l0003oo`00ool0
0?oo0005o`0000_oo`0000?o0000ool00?oo00004Ooo0002o`000003olc<c?mVIVKoc<c<027oc<c<
00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`2o`0001Coc<c<0_mVIVH00oo<c<coIVIVolc<
c00Solc<c003ofIVI_o<c<co000000Co00002ooo0002o`00017oo`000_l0000Cool000;o00004?oo
0002o`000004ool00?l0003o0000o`00017oo`0000?o0000ool00?oo00004_oo00000ol0003oIVIV
olc<c00Qolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00?o0000olc<c?o<c<`05Oo<
c<`2ofIVIR7oc<c<1Ol0000Bool000;o00004Ooo0002o`0001?oo`000_l00009ool000Go00001Ooo
00000ol0003oo`00ool0000@ool000;o00004ooo00000ol0003oc<c<olc<c00Polc<c003ofIVI_o<
c<coc<c<01Soc<c<0Oooool002[oc<c<00?o0000olc<c?o<c<`05_o<c<`3ofIVIQ[oc<c<1Ol00004
ool00003o`000?oo003oo`0001;oo`000_l0000Aool00003o`000?oo003oo`0001;oo`0000Co0000
ool00?oo003oo`001Ol0000;ool000;o00004_oo00000ol0003oo`00ool0000Aool00003o`000?o<
c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`00ol0003oc<c<olc<c00F
olc<c003ofIVI_o<c<coc<c<00?oIVIV4_o<c<`5o`0000_oo`000_l0000Cool00003o`000?oo003o
o`0000ooo`000_l0000@ool000;o000000Coo`00o`000?l0003o00004_oo00000ol0003oo`00ool0
000@ool00003o`000?oo003oo`00017oo`0000?o0000olc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<
c00Holc<c07ooooo000Zolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`00oo<c<`2
ofIVIPgoc<c<0ol0000Bool000;o00004_oo0002o`00017oo`000_l00009ool000Go00001Omoo`00
0ol0003oo`00ool0000Aool000;o00004Ooo0002o`0001;oo`0000?o0000olc<c?o<c<`07Oo<c<`0
0omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<
c?o<c<`01Oo<c<`2ofIVIP_oc<c<00?o0000o`3oool000005?oo0002o`0001;oo`000_l0000Aool0
0004o`000?oo003oo`00ool000Go00002omoo`02o`0001?oo`0000?o0000ool00?oo00004?oo0000
0ol0003oo`00ool0000=ool000;o000000?oo`00o`000?l000007Oo<c<`00omVIVKoc<c<olc<c00H
olc<c07ooooo000Zolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`01oo<c<`2ofIV
IPWoc<c<00Co0000o`3oool0oooo0?oo0_l0000Cool00003o`000?oo003oo`00017oo`000_l0000=
ool000;o000000Coo`00o`000?l0003o00004_moo`000ol0003oo`00ool0000Aool000;o00004Ooo
00000ol0003oo`00ool00007ool000Go00001Ooo00000ol0003oc<c<olc<c00Jolc<c003ofIVI_o<
c<coc<c<01Soc<c<0Oooool002[oc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c009
olc<c0;oIVIV1oo<c<`00ol0003o0?ooo`3oo`03o`3oo`;o00004_oo0002o`0001?oo`000_l00004
ool000Oo00000ol0ool00ol0003oOol0ogoo000Cogoo00;o00004ooo00000ol0003oo`00ool0000?
ool00004o`000?oo003oo`00ool000Go00002ooo00000ol0003oc<c<olc<c00Iolc<c003ofIVI_o<
c<coc<c<01Soc<c<0Oooool002[oc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00;
olc<c0;oIVIV1?o<c<`00ol0003o0?ooo`3oo`06o`3oo`;o00004_oo0002o`00017oo`0000?o0000
ool00?l000000ol0000:o`3oo`03o`000?moo`3oOol001GoOol000?o0000ool00?oo00004Ooo0002
o`0000coo`000ol000001?oo003o0000o`000?l0000Aool000;o00006Oo<c<`00omVIVKoc<c<olc<
c00Holc<c07ooooo000Zolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`03Oo<c<`2
ofIVIP;oc<c<00?o0000o`3oool0ool02?l0ool2o`0001;oo`000_l0000:ool000Go00004?l0ool0
0ol0003oOol0ogoo000Fogoo00;o00004ooo00000ol0003oo`00ool00002ool000Oo00001_moo`00
0ol0003oo`00ool0000Aool00003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`06?o<c<`1
ooooo`00:_o<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<00ooc<c<0_mVIVH00ol0
003o0?ooo`3oo`0:o`3oo`;o00004_oo0002o`0000?oo`001Ol0000Fo`3oo`03o`000?moo`3oOol0
01OoOol000?o0000ool00?oo00003_oo0002o`000003ool00?l0003o000000;o00003_moo`02o`00
01;oo`0000?o0000olc<c?o<c<`05Oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c0;o
00005oo<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00co0?oo0_l0000@ool00003
o`000?oo003o000000;o00003?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001So
Ool00_l00009ool000Go00000ol0ool00ol0003oOol0ogoo000Aogoo0003o`000?oo003oo`00013o
o`000_l0000Eolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002Woc<c<00?o0000olc<c?o<c<`0
5oo<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00ko0?oo0_l00009ool000Go0000
4Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001[oOol000Co0000ool00?oo003o
o`001Ol00008o`3oo`03o`000?moo`3oOol001;oOol00_l0000Bool00003o`000?o<c<coc<c<01?o
c<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`00ol0003oc<c<olc<c00Golc<c003ofIV
I_o<c<coc<c<017oc<c<00?o0000o`3oool0ool04?l0ool2o`0000;oo`001Ol0000Uo`3oo`03o`00
0?moo`3oOol001_oOol00ol0000=o`3oo`03o`000?moo`3oOol001CoOol000?o0000ool00?oo0000
4?oo00000ol0003oc<c<olc<c00Bolc<c0CoIVIV5_o<c<`1ooooo`00:Oo<c<`00ol0003oc<c<olc<
c00Golc<c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool04ol0ool2o`0000co0?oo00?o
0000o`3oool0ool06ol0ool00ol0003oOol0ogoo000Kogoo0003o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`005Omoo`000ol0003oo`00ool0000>ool00003o`000?oo003o000000coc<c<2?mV
IVHIolc<c07ooooo000Yolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`04Oo<c<`0
0ol0003o0?ooo`3oo`0Co`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001_oOol000?o0000o`3oool0ool03_l0ool0
0ol0003oOol0ogoo000Eogoo00;o00002Ooo0005o`0000;o0?oo00?o0000olc<c?o<c<`01?o<c<`6
ofIVIPOoc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`00ol0003oc<c<olc<c00Folc<
c003ofIVI_o<c<coc<c<017oc<c<00?o0000o`3oool0ool04ol0ool00ol0003o0?ooo`3oo`0Ko`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`006omoo`000ol0003o0?ooo`3oo`0>o`3o
o`03o`000?moo`3oOol001OoOol000Co0000ool00?oo003oo`001Ol00007o`3oo`03o`000?mVIVKo
IVIV00CoIVIV3Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c003o`000?o<c<coc<c<
01Koc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?l0oooo0?oo
01_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Jogoo0003o`000?l0oooo0?oo
00ko0?oo00?o0000ogoo0?moo`006?moo`03o`0000co0?oo00?o0000olc<c?o<c<`04Oo<c<`00omV
IVKoc<c<olc<c00Golc<c07ooooo000Yolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<
c<`04Oo<c<`00ol0003o0?ooo`3oo`0Bo`3oo`;o00003_l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006Omoo`000ol0003oO`3oo`3oo`0?o`3oo`03
o`000?moo`3oOol001SoOol000?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c00Aolc<c003
ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<
olc<c00Aolc<c003o`000?l0oooo0?oo01;o0?oo00?o0000ogl0ool0ool03Ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`006Omoo`000ol0003oO`3o
o`00000?o`3oo`03o`000?moo`3oOol001SoOol000?o0000o`3oool0ool03Ol0ool00ol0003oc<c<
olc<c00@olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00?o0000olc<c?o<c<`05_o<
c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo01;o0?oo00?o0000ogl0ool0ool03Ol0
ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`006Omo
o`000ol0003oO`3oo`00000?o`3oo`03o`000?moo`3oOol001SoOol000?o0000o`3oool0ool03Ol0
ool00ol0003oc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00?o0000
olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00@olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000
ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`006Omoo`000ol0003oO`3oo`00000?o`3oo`03o`000?moo`3oOol001SoOol000?o0000
o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool0
02Woc<c<0_l0000Golc<c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool04ol0ool00ol0
003oO`3oo`00000=o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0ool00ol0
003oOol0ogoo000Iogoo0003o`000?mo0?oo000000oo0?oo00?o0000ogoo0?moo`005omoo`000ol0
003oO`3oo`3oo`0>o`3oo`03o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1oooo
o`00:Oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0
ool04ol0ool00ol0003oO`3oo`00000>o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool02ol0ool00ol0003oOol0ogoo000Iogoo0003o`000?mo0?oo0000013o0?oo00?o0000ogoo0?mo
o`005_moo`000ol0003oO`3oo`00000>o`3oo`03o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<
c<`05oo<c<`1ooooo`00:Oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<013oc<c<
00?o0000o`3oool0ool04ol0ool00ol0003oO`3oo`00000>o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Hogoo0003o`000?mo0?oo0000013o0?oo
00?o0000ogoo0?moo`005_moo`000ol0003oO`3oo`00000>o`3oo`03o`000?o<c<coc<c<013oc<c<
00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<
c<coc<c<013oc<c<00?o0000o`3oool0ool04_l0ool01?l0003oO`3oogl0ool0000>o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Hogoo0004o`00
0?mo0?ooO`3oo`0000oo0?oo00?o0000ogoo0?moo`005_moo`000ol0003oO`3oo`00000>o`3oo`03
o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`00ol0003oc<c<
olc<c00Folc<c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool04_l0ool01Ol0003oO`3o
ogl0oomo0?oo000000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol001OoOol000Go0000ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?moo`3oOol0
01KoOol000?o0000ogl0ool000003ol0ool00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<
01Ooc<c<0Oooool002Woc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00?olc<c003
o`000?l0oooo0?oo01?o0?oo00Go0000ogl0oomo0?ooO`3oo`00000=o`3oo`03o`000?l0oooo0?oo
00go0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Gogoo0005o`000?mo0?ooO`3o
ogl0ool000003ol0ool00ol0003oOol0ogoo000Fogoo0003o`000?mo0?oo000000oo0?oo00?o0000
olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Xolc<c003o`000?o<c<coc<c<
01Ooc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`0Co`3oo`05o`000?mo0?ooO`3o
ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`005omoo`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o0000ogoo0?moo`005_mo
o`000ol0003oO`3oo`00000?o`3oo`03o`000?o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`05oo<
c<`1ooooo`00:?o<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000
o`3oool0ool04ol0ool01Ol0003oO`3oogl0oomo0?oo000000go0?oo00?o0000o`3oool0ool03Ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001OoOol000Go0000ogl0oomo0?ooO`3o
o`00000?o`3oo`03o`000?moo`3oOol001KoOol000Co0000ogl0oomo0?oo00003_l0ool00ol0003o
c<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Soc<c<00?o0000olc<c?o<c<`0
5oo<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo01?o0?oo00Go0000ogl0oomo0?oo
O`3oo`00000>o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
Ool0ogoo000Gogoo0005o`000?mo0?ooO`3oogl0ool000004?l0ool00ol0003oOol0ogoo000Eogoo
0004o`000?mo0?ooO`3oo`0000ko0?oo00?o0000olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00G
olc<c07ooooo000Xolc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0
003o0?ooo`3oo`0Bo`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005_moo`001Ol0
003oO`3oogl0oomo0?oo0000013o0?oo00?o0000ogoo0?moo`005?moo`001Ol0003oO`3oogl0oomo
0?oo000000ko0?oo00?o0000olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000X
olc<c0?o00005oo<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo01;o0?oo00?o0000
ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Fogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Dogoo0005o`000?mo0?ooO`3oogl0ool000003_l0
ool00ol0003oc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001coc<c<1_l00006
olc<c0;oIVIV5oo<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000
ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Fogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Dogoo0005o`000?mo0?ooO`3oogl0ool000003ol0
ool00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001coc<c<00?o0000
olc<c?o<c<`02Oo<c<`00ol0003oc<c<ofIVIP02ofIVIQCoc<c<00?oIVIVolc<c?o<c<`03oo<c<`0
0ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005Omoo`00
0ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`005?moo`00
1Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o0000olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<
c00Folc<c07ooooo000Molc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`00_o<c<`3
ofIVIQ7oc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?oo
O`3o00?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000ogoo0?moo`005Omoo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo
0?oo00go0?oo00?o0000ogoo0?moo`005?moo`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o
0000olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Nolc<c0;o00002?o<c<`0
0ol0003oc<c<olc<c005olc<c0?oIVIV3_o<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo
0?oo01?o0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00go0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?mo0?oo
O`3o00?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Dogoo0003o`000?mo0?oo
O`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<co
c<c<01Koc<c<0Oooool0023oc<c<00?o0000olc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c008olc<
c0?oIVIV2oo<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0
oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3o
ool0ool03Ol0ool00ol0003oOol0ogoo000Dogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool0027o
c<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c00;olc<c0?oIVIV2?o<c<`00omVIVKo
c<c<olc<c00?olc<c003o`000?l0oooo0?oo01;o0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000Dogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03_l0ool00ol0003o
Ool0ogoo000Cogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
c<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001coc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<00koc<c<0omVIVH5olc<c003ofIV
I_o<c<coc<c<00koc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`04ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol001CoOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol001;oOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<
c002olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`04Oo<c<`2ofIVIP?oc<c<00?o
IVIVolc<c?o<c<`03_o<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`005?moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`004_moo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<co
c<c<00?oc<c<00?o0000olc<c?o<c<`00_l00002olc<c003o`000?o<c<coc<c<00[oc<c<1?l00007
olc<c003o`000?o<c<coc<c<01?oc<c<1?mVIVH@olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000
ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Dogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Bogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool0
00?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Kolc<c003o`000?o<c<co
c<c<01Koc<c<0omVIVH>olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l01Omo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003oOol0ogoo000Cogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oOol0ogoo000Bogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<
c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIV
olc<c?o<c<`00omVIVH;olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l01Omo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003oOol0ogoo000Cogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oOol0ogoo000Bogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<
c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c0;o00006?o<c<`00omVIVKoc<c<olc<c003
olc<c0?oIVIV2?o<c<`00ol0003o0?ooo`3oo`0Bo`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
ogoo0?moo`004omoo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogoo0?moo`004_moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
olc<c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c0Oo00000_o<c<`00ol0
003oc<c<olc<c00Holc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`01_o<c<`3ofIV
IPGoc<c<00?o0000o`3oool0ool04_l0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
01;oOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0
01;oOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<
00koc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c004
o`000?o<c<coc<c<o`0001[oc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c009olc<
c0;oIVIV0_o<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004_moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`004Omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<
c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?o
c<c<00?o0000olc<c?l000000_l0000Iolc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<
c<`02oo<c<`2ofIVIP03o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000Bogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo000@ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
c<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c00Holc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`0
3Oo<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
4_moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
4?moo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`0
3Oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c0Oo00000_o<c<`00ol0003oc<c<olc<
c00Holc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3o
o`0Co`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004_moo`000ol0003oO`3oogl0
o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0
o`05ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<
c00Folc<c07ooooo000Wolc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`03Oo<c<`0
0ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004Omoo`00
0ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004?moo`00
0ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`03Oo<c<`5
ofIVIQCoc<c<0Oooool002Ooc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00>olc<
c003o`000?l0oooo0?oo01;o0?oo00?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Aogoo
0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c005olc<
c0SoIVIV00?oc<c<ofIVI_o<c<`05_o<c<`1ooooo`009oo<c<`00ol0003oc<c<olc<c00Folc<c003
ofIVI_o<c<coc<c<00goc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`08ogl0o`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol0013oOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol0013oOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?mVIVKoIVIV00GoIVIV2Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c003o`00
0?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`00
0?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0o`08ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0o`06ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo
000Wolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3o
o`0Co`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0
o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0
o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<
c00Eolc<c07ooooo000Wolc<c0;o00005oo<c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo
0?oo01?o0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?oo
O`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?oo
O`3o00KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<co
c<c<01Goc<c<0Oooool002Ooc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00=olc<
c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000>ogoo
0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00=olc<
c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKo
c<c<olc<c00=olc<c003o`000?l0oooo0?oo01;o0?oo00?o0000ogl0oomo0?l02_mo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
Ool0ogoo000@ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo000>ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
c<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00?o0000olc<c?o<c<`0
5_o<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l0
2_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool0
2ol0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00?o
0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo01?o0?oo00?o
0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o
0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01Goc<c<0Ooo
ool002Koc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo
0?oo01?o0?oo00?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?oo
O`3o00[oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?oo
O`3o00SoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<co
c<c<01Goc<c<0Oooool002Koc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00<olc<
c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo
0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo
0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00<olc<
c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKo
c<c<olc<c00<olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000>ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo000=ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
c<c<olc<c00<olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00?o0000olc<c?o<c<`0
5oo<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l0
2omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oc<c<olc<c00<olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00?o
0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo0?oo01?o0?oo00?o
0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o
0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00<olc<c003ofIVI_o<c<coc<c<01Goc<c<0Ooo
ool002Koc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo
0?oo01?o0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00go0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?oo
O`3o00[oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?oo
O`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00<olc<c003ofIVI_o<c<co
c<c<01Goc<c<0Oooool002Koc<c<0_l0000Holc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3o
ool0ool04ol0ool00ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0
oomo0?l02omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0
oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<
c?o<c<`05Oo<c<`1ooooo`009_o<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00_o
c<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000co
Ool000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000co
Ool000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00co
c<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`00ol0003oc<c<olc<c00Golc<c003ofIV
I_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0=ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000coOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000coOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?o<c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`00ol0003oc<c<olc<
c00Folc<c003ofIVI_o<c<coc<c<00coc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0
o`0=ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`0
0ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<00coc<c<00?o0000o`3oool0ool04_l0ool0
0ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l03?mo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l02_mo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1
ooooo`009_o<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3o
ool0ool04ol0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0
oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0
oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<
c?o<c<`05?o<c<`1ooooo`009_o<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<00_o
c<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000co
Ool000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000[o
Ool000?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00co
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`00ol0003oc<c<olc<c00Folc<c003ofIV
I_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0>ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000_oOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol000[oOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`00ol0003oc<c<olc<
c00Folc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0
o`0>ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`0
0ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool04ol0ool0
0ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l03_mo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l03?mo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`05?o<c<`1
ooooo`009Oo<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3o
ool0ool04ol0ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0
oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0
oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00_oc<c<00?oIVIVolc<
c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c0?oIVIV5oo<c<`00omVIVKo
c<c<olc<c00:olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l04?mo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000:ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo0009ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
c<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`0
1Oo<c<`00ol0003oc<c<olc<c004ofIVIQ?oc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o0?oo
o`3oo`0Co`3oo`03o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3o
ogl0o`0>ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3o
ogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02oo<c<`00omVIVKoc<c<
olc<c00Dolc<c07ooooo000Iolc<c0Ko00001_o<c<`00ol0003oc<c<olc<c004olc<c0CoIVIV3oo<
c<`00omVIVKoc<c<olc<c00:olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l04?mo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0
ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oc<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001Woc<c<00Go0000
olc<c?o<c<coc<c<o`000007olc<c003o`000?o<c<coc<c<00Soc<c<1OmVIVH:olc<c003ofIVI_o<
c<coc<c<00[oc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0@ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000WoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000WoOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<
c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006_o<c<`01?l0003oc<c<olc<c?l0
0007olc<c003o`000?o<c<coc<c<00goc<c<1?mVIVH6olc<c003ofIVI_o<c<coc<c<00[oc<c<00?o
0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o
0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000SoOol000?o
0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00_oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`1ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c003o`000?o<c<co
c<c<017oc<c<1?mVIVH2olc<c003ofIVI_o<c<coc<c<00[oc<c<00?o0000o`3oool0ool04ol0ool0
0ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l04?mo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l03_mo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1
ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c003o`000?o<c<coc<c<01Goc<c<1?mVIVH:olc<
c003o`000?l0oooo0?oo01Co0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo
0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo
0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00:olc<
c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001coc<c<0_l00007olc<c003o`000?o<c<coc<c<01Oo
c<c<00?oIVIVolc<c?mVIVH00omVIVH6olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo
0?l04_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oc<c<olc<c00:olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001goc<c<
00?o0000olc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00?oc<c<
1?mVIVH2olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l04_mo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0008ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo0007ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<
olc<c00:olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00?o0000olc<c?o<c<`05oo<
c<`00omVIVKoc<c<olc<c007olc<c0;oIVIV00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0
o`0Bogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`0
0ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<00[oc<c<00?o0000o`3oool0ool04ol0ool0
0ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l04?mo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l03_mo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1
ooooo`009Oo<c<`00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<00[oc<c<00?o0000o`3o
ool0ool04ol0ool00ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0
oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0
oomo0?l03omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00_oc<c<00?oIVIVolc<
c?o<c<`04oo<c<`1ooooo`009Oo<c<`2o`0001Ooc<c<00?oIVIVolc<c?o<c<`02_o<c<`00ol0003o
0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003o
O`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001_moo`000ol0003o
O`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`02?o<c<`7ofIVIQ;o
c<c<0Oooool002Goc<c<00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c009olc<c003o`00
0?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l05?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003o`00
0?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003o`00
0?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oIVIVofIVIP07ofIVIP?oc<c<
00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<
c<coc<c<00Woc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000KoOol000?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000KoOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<
c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`00ol0003oc<c<olc<c00G
olc<c003ofIVI_o<c<coc<c<00Woc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0D
ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`00ol0
003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00Woc<c<00?o0000o`3oool0ool04ol0ool00ol0
003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l04_mo0?l00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l04?mo0?l00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1oooo
o`009?o<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00Woc<c<00?o0000o`3oool0
ool04ol0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo
0?l04_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo
0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<
c<`04oo<c<`1ooooo`009?o<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00Woc<c<
00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000GoOol0
00?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000GoOol0
00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00[oc<c<
00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<
c<coc<c<00Soc<c<00?o0000o`3oool0ool05?l0ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000GoOol000?o0000ogl0oomo0?l04omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000GoOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<
c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`00ol0003oc<c<olc<c00G
olc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0F
ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l04omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`00ol0
003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0ool04ol0ool00ol0
003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l05?mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l04_mo0?l00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`04oo<c<`1oooo
o`009?o<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00Soc<c<00?o0000o`3oool0
ool04ol0ool00ol0003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo
0?l05?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo
0?l04_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<
c<`04oo<c<`1ooooo`009?o<c<`2o`0001Soc<c<00?oIVIVolc<c?o<c<`02?o<c<`00ol0003o0?oo
o`3oo`0Co`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3o
ogl0o`0Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3o
ogl0o`0Bogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<
olc<c00Colc<c07ooooo000Tolc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`02?o<
c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000omo
o`000ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000omo
o`000ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02Oo<
c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIV
olc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0Do`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c003o`000?o<c<coc<c<
01Ooc<c<00?oIVIVolc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o
01SoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c003
o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0Co`3oo`03
o`000?mo0?ooO`3o01SoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0Eogl0o`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0Cogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Colc<c07o
oooo000Tolc<c003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`02?o<c<`00ol0003o0?oo
o`3oo`0Co`3oo`03o`000?mo0?ooO`3o01SoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3o
ogl0o`0Eogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3o
ogl0o`0Cogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<
olc<c00Colc<c07ooooo000Solc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`02?o<
c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o01SoO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_mo
o`000ol0003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_mo
o`000ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02?o<
c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Solc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIV
olc<c?o<c<`02?o<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o01SoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c003o`000?o<c<coc<c<
01Ooc<c<00?oIVIVolc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0Do`3oo`03o`000?mo0?ooO`3o
01SoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00go0?oo00Go0000ogoo0?moo`3oOol0o`00000Hogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000
ogoo0?moo`3oOol0o`00000Fogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02Oo<
c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIV
olc<c?o<c<`01oo<c<`00ol0003o0?ooo`3oo`0Do`3oo`03o`000?mo0?ooO`3o01SoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00Go0000
ogoo0?moo`3oOol0o`00000Hogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000ogoo0?moo`3oOol0
o`00000Fogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<
olc<c00Bolc<c07ooooo000Solc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`01oo<
c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o01[oO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0
o`00000Iogl0o`03o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Gogl0o`03
o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07o
oooo000Solc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`01oo<c<`00ol0003o0?oo
o`3oo`0Co`3oo`03o`000?mo0?ooO`3o01[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Iogl0o`03
o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Gogl0o`03o`000?l0oooo0?oo
00go0?oo00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c0;o
00006?o<c<`00omVIVKoc<c<olc<c007olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo
0?l06_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03?l0ool01Ol0003oOol0ogoo0?moo`3o000001WoO`3o00?o0000o`3oool0ool03?l0ool01Ol0
003oOol0ogoo0?moo`3o000001OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c008
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00?o0000olc<c?o<c<`05oo<c<`00omV
IVKoc<c<olc<c007olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01Ol0
003oOol0ogoo0?moo`3o000001WoO`3o00?o0000o`3oool0ool03?l0ool01Ol0003oOol0ogoo0?mo
o`3o000001OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c008olc<c003ofIVI_o<
c<coc<c<01;oc<c<0Oooool002?oc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c007
olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0
000Jogl0o`03o`000?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00006?mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<
c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0ool05?l0
ool00ol0003oO`3oogl0o`0Jogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001[oO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0o`00000Hogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02?o<
c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIV
olc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`0Co`3oo`03o`000?mo0?ooO`3o01_oO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?l000006_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001SoO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oc<c<olc<c008olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool0
02?oc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo
01?o0?oo00?o0000ogl0oomo0?l07?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0o`00000Kogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?l000006?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<
00Soc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`00ol0003oc<c<olc<c00Golc<c003
ofIVI_o<c<coc<c<00Koc<c<00?o0000o`3oool0ool04ol0ool00ol0003oO`3oogl0o`0Logl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3o000001_oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0o`00000Iogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`01oo<c<`00omVIVKoc<c<olc<c00Bolc<c07o
oooo000Solc<c003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?oo
o`3oo`0Co`3oo`03o`000?mo0?ooO`3o01coO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?l000006omo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3o000001WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<
olc<c007olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00?o0000olc<c?o<c<`05oo<
c<`00omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo01?o0?oo00?o0000ogl0oomo0?l07?mo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0o`00000Kogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?l000006Omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`04_o<
c<`1ooooo`008oo<c<`00ol0003oc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000
o`3oool0ool05?l0ool00ol0003oO`3oogl0o`0Logl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o000001_oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0o`00000Iogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
olc<c?o<c<`01oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Rolc<c003o`000?o<c<coc<c<
01Soc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003o0?ooo`3oo`0Do`3oo`03o`000?mo0?ooO`3o
01coO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00go0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o0000
01WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c007olc<c003ofIVI_o<c<coc<c<
01;oc<c<0Oooool001Ooc<c<1?l00007olc<c003o`000?o<c<coc<c<017oc<c<5_l0000?o`3oo`03
o`000?mo0?ooO`3o01goO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l06_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?mo0?ooO`3o01SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c007olc<c003
ofIVI_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c004olc<c0KoIVIV4oo<c<`5o`0000coo`002ol00004o`3oo`03o`000?mo0?ooO`3o01koO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogl0oomo0?l06omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01SoO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c007olc<c003ofIVI_o<c<coc<c<01;oc<c<
0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<
c<coc<c<00?oc<c<2OmVIVH;olc<c003ofIVI_o<c<coc<c<00Coc<c<1ol0000=ool000Go00008?mo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool01Ol0
ool8o`0001goO`3o00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Iogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000olc<c?o<c<`01_o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000F
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c00<
olc<c0WoIVIV0_o<c<`00omVIVKoc<c<olc<c00;olc<c0[o00002ooo0005o`0001SoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`05o`3oo`oo00002ooo0005o`0001GoO`3o00?o0000
o`3oool0ool01Ol0ool8o`0001_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c007
olc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool001Koc<c<0_l00003olc<c003o`000?o<c<coc<c<
00Coc<c<00?o0000olc<c?o<c<`05Oo<c<`9ofIVIPkoc<c<1Ol0000@ool000Ko00004?mo0?lFo`00
00coo`001?l0000?ool000Go00002Omo0?l00ol0003oO`3oogl0o`04ogl0o`So00002_oo0005o`00
01CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c007olc<c003ofIVI_o<c<coc<c<
017oc<c<0Oooool001Koc<c<00?o0000olc<c?l000000_l00007olc<c003o`000?o<c<coc<c<01Oo
c<c<00?oIVIVolc<c?o<c<`01?o<c<`9ofIVIPcoc<c<1ol0000=ool000Wo00002ooo0005o`0000[o
o`002Ol0000>ool000_o00001Ooo0009o`0000_oo`001?l0000?ool000Co00002Omo0?l00ol0003o
O`3oogl0o`04ogl0oa?o00001oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo000Folc<c003o`00
0?o<c<coc<c<00Woc<c<00?o0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00=olc<c0WoIVIV
2_o<c<`9o`0000coo`000ol0000?ool000Go00003Ooo000:o`0000[oo`001Ol0000;ool000Oo0000
3_oo000;o`0000Goo`002Ol0000;ool000?o00003?oo0005o`0000;oc<c<00?oIVIVolc<c?o<c<`0
4Oo<c<`1ooooo`005oo<c<`01Ol0003oc<c<olc<c?o<c<co0000023oc<c<00?oIVIVolc<c?o<c<`0
5_o<c<`9ofIVIPKoc<c<00?oIVIVolc<c?o<c<`02Ol0000=ool000Wo00001Ooo0009o`0000coo`00
0ol0000>ool000Go00002?oo00000ol0003oo`00ool00002ool000Wo00002ooo0003o`0000coo`00
1Ol0000?ool000_o00001?oo0002o`0000GoIVIV3oo<c<`1ooooo`006?o<c<`3o`00027oc<c<00?o
IVIVolc<c?o<c<`07oo<c<`9ofIVIPWoc<c<2_l0000;ool000?o00002_oo0007o`0000koo`002_l0
0005ool000So00002ooo0006o`0000goo`002ol00004ool000Wo00003OmVIVH:olc<c003ofIVI_o<
c<coc<c<017oc<c<0Oooool006Coc<c<00?oIVIVolc<c?o<c<`02OmVIVH8olc<c0So00003?oo000:
o`0000?oo`002_l0000:ool000Oo00002_oo0007o`0000[oo`002Ol0000>ofIVIP03olc<c?mVIVKo
c<c<02;oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`00I?o<c<`00omVIVKoc<c<olc<c009olc<
c0WoIVIV1oo<c<`9o`0000_oo`001ol00009ool000Ko00002_oo0009o`0000goIVIV7Oo<c<`00omV
IVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool006Coc<c<00?oIVIVolc<c?o<
c<`04_o<c<`9ofIVIP03olc<c?mVIVKoc<c<00?oc<c<00CoIVIVolc<c?o<c<coc<c<1Ol0000:ool0
00Wo00002_mVIVHGolc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`08Oo<c<`00omV
IVKoc<c<olc<c00Aolc<c07ooooo001Tolc<c003ofIVI_o<c<coc<c<01_oc<c<4OmVIVHBolc<c003
ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00eolc<c07o
oooo0023olc<c003ofIVI_o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`06_o<c<`00omVIVKoc<c<
olc<c00Molc<c003ofIVI_o<c<coc<c<05Ooc<c<0Oooool008?oc<c<00?oIVIVolc<c?o<c<`00_o<
c<`00omVIVKoc<c<olc<c00Jolc<c003ofIVI_o<c<coc<c<07Ooc<c<0Oooool008?oc<c<00?oIVIV
olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c02Dolc<c07ooooo003oolc<c23oc<c<0Oooool00?oo
c<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00<Goc<c<0_l0001H
olc<c07ooooo0036olc<c0;o00000_o<c<`00ol0003oc<c<olc<c01Bolc<c07ooooo0037olc<c0;o
00000_o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo000oolc<c0Go00001?o<c<`3o`0000?oc<c<
0_l00003olc<c0?o00000_o<c<`4o`0000?oc<c<1Ol00003olc<c0;o00001?o<c<`2o`0000;oc<c<
0ol000000oo<c<co0000o`000002olc<c0;o00000_o<c<`4o`0000?oc<c<1?l00003olc<c0Co0000
0oo<c<`4o`0000?oc<c<1?l00004olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<
1?l00003olc<c0?o00000oo<c<`3o`0000?oc<c<0_l00004olc<c0?o000000?oc<c<o`000?l00000
1oo<c<`4o`000004olc<c?l0003oc<c<olc<c0Co00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co
0000o`000005olc<c0Co0000;?o<c<`1ooooo`00?_o<c<`2o`0000?oc<c<0_l00002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0_l00003olc<c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o0000
0_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000
o`000002olc<c0;o00000oo<c<`2o`0000?oc<c<0_l000001?o<c<co0000o`000?o<c<`2o`0000;o
c<c<0_l00002olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00004olc<c0?o
000000?oc<c<o`000?l000001_o<c<`2o`0000;oc<c<0ol000000oo<c<co0000o`000002olc<c0;o
000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000Coc<c<0_l00002olc<c0;o
0000:oo<c<`1ooooo`00?_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o0000
00?oc<c<o`000?l000000oo<c<`2o`0000;oc<c<0_l00005olc<c0;o00000_o<c<`2o`0000?oc<c<
0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l00000
2?o<c<`3o`0000Coc<c<0ol000000oo<c<co0000o`000008olc<c0?o00000oo<c<`2o`0000?oc<c<
0_l000000oo<c<co0000o`000004olc<c0?o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o0000
00?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o000000Ooc<c<0_l00004olc<c0;o0000
00?oc<c<o`000?l000001Oo<c<`2o`0000;oc<c<0_l00007olc<c0;o00000_o<c<`2o`0002_oc<c<
0Oooool004;oc<c<0ol000000oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000000oo<
c<`2o`0000;oc<c<1_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l0
0002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000004o`0000;oc<c<1?l0
0003olc<c0Co00000_o<c<`6o`0000;oc<c<1?l00004olc<c0;o00000oo<c<`2o`000003olc<c?l0
003o000000;oc<c<1?l00003olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`00
0003olc<c0;o000000?oc<c<o`000?l000001oo<c<`2o`0000Coc<c<0_l000000oo<c<co0000o`00
0004o`000003olc<c?l0003o000000;oc<c<0_l0000;olc<c0;o0000:oo<c<`1ooooo`00?oo<c<`5
o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`0000;oc<c<0_l00002
olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<1Ol000000oo<c<co0000o`000002
olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000Coc<c<
o`000?l0003o00001?o<c<`3o`0000Coc<c<0_l00002olc<c0;o000000Coc<c<o`000?l0003o0000
1_o<c<`2o`0000?oc<c<0_l000001?o<c<co0000o`000?o<c<`3o`0000Goc<c<0_l00002olc<c0;o
00000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<c0;o
00000_o<c<`4o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o
00002?o<c<`00ol0003oc<c<olc<c002o`0002_oc<c<0Oooool003koc<c<0ol00006olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`3o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0_l00003olc<c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o0000
0_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000
o`000002olc<c0;o00000oo<c<`7o`000004olc<c?l0003o0000olc<c0;o00000_o<c<`2o`0000;o
c<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`3o`0000;oc<c<0_l000000oo<c<co
0000o`000007olc<c0;o00001oo<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o
00002?o<c<`4o`0002coc<c<0Oooool003koc<c<0_l00003olc<c0;o00000oo<c<`3o`0000?oc<c<
0ol000000oo<c<co0000o`000002o`0000;oc<c<1?l00003olc<c0Go00000oo<c<`2o`0000Coc<c<
0_l000000oo<c<co0000o`000002o`000003olc<c?l0003o000000?o00000oo<c<`4o`0000?oc<c<
1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00004olc<c0;o00000oo<c<`2o`000003olc<
c?l0003o000000;oc<c<1?l00002olc<c0Co00000oo<c<`3o`0000?oc<c<0ol000000oo<c<co0000
o`000003olc<c0;o00001_o<c<`2o`0000Coc<c<0_l00002olc<c0Co00000_o<c<`5o`0000Woc<c<
00?o0000olc<c?o<c<`0;Oo<c<`1ooooo`00?_o<c<`2o`0000?oc<c<0_l0000>olc<c0;o00003Oo<
c<`2o`0000?oc<c<0_l00008olc<c0;o0000;_o<c<`2o`0000?oc<c<0_l0000<olc<c0;o00007?o<
c<`2o`0000;oc<c<0_l0000Golc<c003o`000?o<c<coc<c<02goc<c<0Oooool003ooc<c<1Ol0000?
olc<c0;o00003Oo<c<`2o`0000?oc<c<2?l00002olc<c0;o0000;_o<c<`2o`0000?oc<c<0_l00000
0oo<c<co0000o`000009olc<c0;o00007Oo<c<`4o`0001Soc<c<1Ol0000[olc<c07ooooo003oolc<
c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Ooo
ool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<
8?o<c<`1ooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 6, 6, 6, 6, 6, 6, 6, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(6.`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 0.0147151 5.88604 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -3 -9 ]
[.7381 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(2)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(3)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(4)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(5)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.2619 .60332 L
.5 .60332 L
.7381 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 0.0147151 2.94302 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -3 -9 ]
[.7381 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .16187 -24 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -24 -4.5 ]
[.01131 .45617 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(2)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(3)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(4)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(5)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .16187 m
.03006 .16187 L
s
[(0.05)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.1)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.15)] .01131 .45617 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.2619 .30902 L
.5 .30902 L
.7381 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 -0.377687 0.981006 [
[.2619 .59082 -3 -9 ]
[.2619 .59082 3 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.7381 .59082 -3 -9 ]
[.7381 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -18 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .11282 -18 -4.5 ]
[.01131 .11282 0 4.5 ]
[.01131 .21092 -18 -4.5 ]
[.01131 .21092 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .40712 -18 -4.5 ]
[.01131 .40712 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .60332 m
.2619 .60957 L
s
[(2)] .2619 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(3)] .5 .59082 0 1 Mshowa
.7381 .60332 m
.7381 .60957 L
s
[(4)] .7381 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(5)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.07143 .60332 m
.07143 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.16667 .60332 m
.16667 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.4)] .01131 .01472 1 0 Mshowa
.02381 .11282 m
.03006 .11282 L
s
[(0.5)] .01131 .11282 1 0 Mshowa
.02381 .21092 m
.03006 .21092 L
s
[(0.6)] .01131 .21092 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.7)] .01131 .30902 1 0 Mshowa
.02381 .40712 m
.03006 .40712 L
s
[(0.8)] .01131 .40712 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(0.9)] .01131 .50522 1 0 Mshowa
.125 Mabswid
.02381 .03434 m
.02756 .03434 L
s
.02381 .05396 m
.02756 .05396 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .0932 m
.02756 .0932 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .15206 m
.02756 .15206 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .23054 m
.02756 .23054 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .26978 m
.02756 .26978 L
s
.02381 .2894 m
.02756 .2894 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34826 m
.02756 .34826 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .3875 m
.02756 .3875 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .44636 m
.02756 .44636 L
s
.02381 .46598 m
.02756 .46598 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .52484 m
.02756 .52484 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .56408 m
.02756 .56408 L
s
.02381 .5837 m
.02756 .5837 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.2619 .60332 L
.5 .60332 L
.7381 .59351 L
.97619 .5838 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 -0.272059 1.43387 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -3 -9 ]
[.7381 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .1581 -18 -4.5 ]
[.01131 .1581 0 4.5 ]
[.01131 .30149 -18 -4.5 ]
[.01131 .30149 0 4.5 ]
[.01131 .44488 -18 -4.5 ]
[.01131 .44488 0 4.5 ]
[.01131 .58826 -18 -4.5 ]
[.01131 .58826 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(2)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(3)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(4)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(5)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .1581 m
.03006 .1581 L
s
[(0.3)] .01131 .1581 1 0 Mshowa
.02381 .30149 m
.03006 .30149 L
s
[(0.4)] .01131 .30149 1 0 Mshowa
.02381 .44488 m
.03006 .44488 L
s
[(0.5)] .01131 .44488 1 0 Mshowa
.02381 .58826 m
.03006 .58826 L
s
[(0.6)] .01131 .58826 1 0 Mshowa
.125 Mabswid
.02381 .04339 m
.02756 .04339 L
s
.02381 .07207 m
.02756 .07207 L
s
.02381 .10075 m
.02756 .10075 L
s
.02381 .12942 m
.02756 .12942 L
s
.02381 .18678 m
.02756 .18678 L
s
.02381 .21546 m
.02756 .21546 L
s
.02381 .24413 m
.02756 .24413 L
s
.02381 .27281 m
.02756 .27281 L
s
.02381 .33017 m
.02756 .33017 L
s
.02381 .35884 m
.02756 .35884 L
s
.02381 .38752 m
.02756 .38752 L
s
.02381 .4162 m
.02756 .4162 L
s
.02381 .47355 m
.02756 .47355 L
s
.02381 .50223 m
.02756 .50223 L
s
.02381 .53091 m
.02756 .53091 L
s
.02381 .55959 m
.02756 .55959 L
s
.02381 .61694 m
.02756 .61694 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .01472 m
.2619 .60332 L
.5 .59457 L
.7381 .5859 L
.97619 .57732 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 -0.573889 5.88604 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -3 -9 ]
[.7381 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(2)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(3)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(4)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(5)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.12)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.14)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.16)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.18)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.2619 .01472 L
.5 .01472 L
.7381 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 0.0147151 5.88604 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -3 -9 ]
[.7381 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(2)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(3)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(4)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(5)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.2619 .60332 L
.5 .60332 L
.7381 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 -0.371191 0.97451 [
[.2619 .59082 -3 -9 ]
[.2619 .59082 3 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.7381 .59082 -3 -9 ]
[.7381 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01861 -18 -4.5 ]
[.01131 .01861 0 4.5 ]
[.01131 .11606 -18 -4.5 ]
[.01131 .11606 0 4.5 ]
[.01131 .21352 -18 -4.5 ]
[.01131 .21352 0 4.5 ]
[.01131 .31097 -18 -4.5 ]
[.01131 .31097 0 4.5 ]
[.01131 .40842 -18 -4.5 ]
[.01131 .40842 0 4.5 ]
[.01131 .50587 -18 -4.5 ]
[.01131 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .60332 m
.2619 .60957 L
s
[(2)] .2619 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(3)] .5 .59082 0 1 Mshowa
.7381 .60332 m
.7381 .60957 L
s
[(4)] .7381 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(5)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.07143 .60332 m
.07143 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.16667 .60332 m
.16667 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01861 m
.03006 .01861 L
s
[(0.4)] .01131 .01861 1 0 Mshowa
.02381 .11606 m
.03006 .11606 L
s
[(0.5)] .01131 .11606 1 0 Mshowa
.02381 .21352 m
.03006 .21352 L
s
[(0.6)] .01131 .21352 1 0 Mshowa
.02381 .31097 m
.03006 .31097 L
s
[(0.7)] .01131 .31097 1 0 Mshowa
.02381 .40842 m
.03006 .40842 L
s
[(0.8)] .01131 .40842 1 0 Mshowa
.02381 .50587 m
.03006 .50587 L
s
[(0.9)] .01131 .50587 1 0 Mshowa
.125 Mabswid
.02381 .0381 m
.02756 .0381 L
s
.02381 .05759 m
.02756 .05759 L
s
.02381 .07708 m
.02756 .07708 L
s
.02381 .09657 m
.02756 .09657 L
s
.02381 .13555 m
.02756 .13555 L
s
.02381 .15504 m
.02756 .15504 L
s
.02381 .17453 m
.02756 .17453 L
s
.02381 .19402 m
.02756 .19402 L
s
.02381 .23301 m
.02756 .23301 L
s
.02381 .2525 m
.02756 .2525 L
s
.02381 .27199 m
.02756 .27199 L
s
.02381 .29148 m
.02756 .29148 L
s
.02381 .33046 m
.02756 .33046 L
s
.02381 .34995 m
.02756 .34995 L
s
.02381 .36944 m
.02756 .36944 L
s
.02381 .38893 m
.02756 .38893 L
s
.02381 .42791 m
.02756 .42791 L
s
.02381 .4474 m
.02756 .4474 L
s
.02381 .46689 m
.02756 .46689 L
s
.02381 .48638 m
.02756 .48638 L
s
.02381 .52536 m
.02756 .52536 L
s
.02381 .54485 m
.02756 .54485 L
s
.02381 .56434 m
.02756 .56434 L
s
.02381 .58383 m
.02756 .58383 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.2619 .01472 L
.5 .60332 L
.7381 .59357 L
.97619 .58393 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.214286 0.238095 0.0147151 5.88604 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.7381 .00222 -3 -9 ]
[.7381 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(2)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(3)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(4)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(5)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.2619 .60332 L
.5 .60332 L
.7381 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H003Goi^KV1Ol0000:onKViP?o
00003OoVi^H3o`0000_oi^KV0ol0000jonKViPGo00002ooVi^H3o`0000goi^KV0ol0000:onKViP?o
00005?oVi^H003Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00goi^KV00?o0000onKVi_oVi^H02OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000003[oi^KV00Co0000
onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000goi^KV00?o0000onKVi_oVi^H0
2?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000001?oi^KV000gonKViP03o`000?oVi^Koi^KV00goi^KV
00?o0000onKVi_oVi^H02?oVi^H5o`0000koi^KV00?o0000onKVi_oVi^H0>OoVi^H00ol0003oi^KV
onKViP0>onKViP03o`000?oVi^Koi^KV00Soi^KV1Ol0000=onKViP03o`000?oVi^Koi^KV017oi^KV
000honKViP03o`000?oVi^Koi^KV00[oi^KV0_l0000;onKViP04o`000?oVi^Koi^KVo`0000ooi^KV
00?o0000onKVi_oVi^H0>_oVi^H00ol0003oi^KVonKViP0;onKViP;o00002ooVi^H01?l0003oi^KV
onKVi_l0000>onKViP03o`000?oVi^Koi^KV017oi^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l0
00003OoVi^H00ol0003oi^KVonKViP09onKViP03o`000?oVi^Ko000000_oi^KV1?l0000jonKViP05
o`000?oVi^Koi^KVonKVi_l000003_oVi^H00ol0003oi^KVonKViP09onKViP03o`000?oVi^Ko0000
00[oi^KV1?l0000DonKViP00=OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Woi^KV00Go0000onKV
i_oVi^Koi^KVo`00000<onKViP;o00002ooVi^H00ol0003oi^KVonKViP0konKViP05o`000?oVi^Ko
i^KVonKVi_l000002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000coi^KV0_l0000:onKViP03o`00
0?oVi^Koi^KV01Goi^KV000fonKViP?o00002ooVi^H3o`0000koi^KV00?o0000onKVi_oVi^H02OoV
i^H5o`0003[oi^KV0ol0000<onKViP?o00003_oVi^H00ol0003oi^KVonKViP08onKViPGo00004ooV
i^H00>?oi^KV000YonKViP03o`000?oVi^Koi^KV06Ooi^KV00?o0000onKVi_oVi^H0COoVi^H002Oo
i^KV0_l000000onc/k?o0000o`00000jo`0002coi^KV?ol0000BonKViP00:OoVi^H00onc/k?oi^KV
onKViP1WonKViP03o`000?oVi^Koi^KV04goi^KV000YonKViP03o`000?nc/k?oi^KV06Ooi^KV0_l0
001>onKViP00:OoVi^H00ol0003o/k>conKViP1WonKViP;o0000C_oVi^H002Woi^KV00?o0000ok>c
/ooVi^H0IooVi^H00ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oV
i^H00ooVi^H2o`0000;oi^KV1Ol00002onKViP03o`000?oVi^Ko/k>c06Ooi^KV0_l0001>onKViP00
4OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVok>c/`1AonKViP;o00001?oVi^H00ol0003oi^KVonKViP03
onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H0COoVi^H0017oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00Co
0000onKVi_oVi^Ko/k>cCooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03
ok>c/ooVi^Koi^KV04goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00005
onKViP03o`000?oVi^Ko000004ooi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o/k>conKVi_oV
i^H0C?oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00Co0000
onKVi_l0003o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKV
i_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00onc/k?oi^KVonKViP1<onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP04o`0000;oi^KV00?o
0000onKVi_oVi^H0COoVi^H001;oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000?oi^KV00Go0000
onKVi_oVi^Koi^KVok>c/`1>onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko
0000onKVi_l00005onKViP;o0000C_oVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?o
i^KV0_l00004onKViP?o00000_oVi^H00ol0003oi^KVonKViP02onKViP03ok>c/ooVi^Koi^KV04co
i^KV0_l0000:onKViP;o00000_oVi^H5o`000003onKVi_l0003oi^KV04koi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000Coi^KV00?o/k>conKVi_oVi^H0H_oVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP05o`0000;oi^KV00?o0000onKVi_oVi^H00ooV
i^H00onc/k?oi^KVonKViP1QonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`000005onKV
iP03ok>c/ooVi^Koi^KV057oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKV
iP03o`000?oVi^Koi^KV04goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV00?oi^KV00?o/k>c
onKVi_oVi^H0D?oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o0000
C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP;o
00000ooVi^H00ol0003oi^KVonKViP04onKViP03ok>c/ooVi^Koi^KV04ooi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV000BonKViP;o00002_oVi^H2o`00
00Goi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP03ok>c/ooVi^Koi^KV04ooi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^Hlolc<c1Coi^KV000BonKViP;o00001?oV
i^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H01OoV
i^H00onc/k?oi^KVonKViP1>onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Ko
i^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00007onKViP03ok>c/ooVi^Koi^KV04koi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H2o`0000?oi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKV
i_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00008
onKViP03ok>c/ooVi^Koi^KV04koi^KV0_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000CooV
i^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Co0000
0ooVi^H00ol0003oi^KVonKViP06onKViP03ok>c/ooVi^Koi^KV05koi^KV0_l0001>onKViP004OoV
i^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00001_oVi^H00ol0
003oi^KVonKViP06onKViP03ok>c/ooVi^Koi^KV05koi^KV0_l0001>onKViP004OoVi^H01?l0003o
i^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0ol0003oi^KVonKViP07onKViP03ok>c/ooVi^Koi^KV05goi^KV00?o0000onKVi_oVi^H0COoVi^H0
01;oi^KV0_l0000:onKViP;o00001?oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H01ooVi^H00onc
/k?oi^KVonKViP17onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H3o`00
00;oi^KV0_l0001>onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?o
i^KV0ol00003onKViP03o`000?oVi^Koi^KV00Soi^KV00?o/k>conKVi_oVi^H0AOoVi^H01?l0003o
i^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H00ol0003oi^KVo`00001?
onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0ooVi^H01?l0003oi^KVonKVi_l0000:onKViP03ok>c/ooVi^Koi^KV04Goi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H00ol0003oi^KVonKViP05onKViP04o`000?oVi^Ko0000o`0004koi^KV000AonKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`00
0?oVi^Koi^KVo`0000[oi^KV00?o/k>conKVi_oVi^H0AOoVi^H01?l0003oi^KVonKVi_l00009onKV
iP03o`000?oVi^Koi^KV00Goi^KV00?o0000onKVi_l00000CooVi^H0017oi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000ooVi^H00ol0003oi^KVonKViP09
onKViP03ok>c/ooVi^Koi^KV04Coi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKV
i_oVi^H4o`0000;oi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`00
0?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0000;onKViP03ok>c/ooVi^Ko
i^KV04Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H00ooV
i^H00ol0003oi^KVonKViP1=onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0000<onKViP03ok>c/ooVi^Koi^KV
04Coi^KV0_l0000:onKViP04o`000?oVi^Koi^KVonKViPGo000000?oi^KVo`000?l00000C_oVi^H0
01;oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H02_oVi^H00onc
/k?oi^KVonKViP1JonKViP03o`000?oVi^Koi^KV04goi^KV000YonKViP03o`000?oVi^Koi^KV00_o
i^KV00?o/k>conKVi_oVi^H0FOoVi^H2o`0004koi^KV000HonKViP;o00001?oVi^H00ol0003oi^KV
onKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP0;onKViP03ok>c/ooVi^Koi^KV04Woi^KV
0_l00004onKViP04o`000?oVi^Koi^KVonKViPGo000000?oi^KVo`000?l00000C_oVi^H001Ooi^KV
00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00_o
i^KV00?o/k>conKVi_oVi^H0B?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KV
o`000?oVi^Ko0000CooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKV
iP02onKViP03o`000?oVi^Koi^KV00coi^KV;Onc/k<MonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00Co0000onKVi_oVi^Koi^KV0_l0001>onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKViP03
o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKVi_l0000:onKV
iP04o`000?oVi^Koi^KVo`0004ooi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000
onKVi_oVi^H0FooVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l00000
DOoVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0005goi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko0000057oi^KV000HonKViP;o00002_oVi^H00ol0003o
i^KVonKViP1LonKViP;o00002OoVi^H3o`0005;oi^KV003SonKViP00=ooVi^H3o`0000;oi^KV1_l0
00001?oVi^Ko0000o`000?l00003onKViP?o00000_oVi^H00ol0003oi^KVo`000002o`0004goi^KV
0ol00002onKViP?o000000?oi^KVo`000?l000000ol00002onKViPKo000000Ooi^KVo`000?l0003o
0000onKVi_l0003oi^KV00?o000000?oi^KVo`000?l000008?oVi^H003Soi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000
onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00027oi^KV
000honKViP03o`000?oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKV
iP03onKViP03o`000?oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00004onKViP03o`000?oVi^Ko
i^KV00;oi^KV00Co0000onKVi_l0003o00000_oVi^H00ol0003oi^KVo`00000RonKViP00>?oVi^H3
o`0000?oi^KV0ol00003onKViP?o00000ooVi^H3o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00
001=onKViP;o00000ooVi^H4o`0000;oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV00Co
0000onKVi_l0003o00000_oVi^H2o`0002?oi^KV000honKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H00ol0003oi^KVonKViP1:onKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV
0_l000001ooVi^Ko0000onKVi_oVi^Ko0000onKVi_l000008_oVi^H003Soi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o
0000onKVi_oVi^H00_oVi^H2o`000005onKVi_l0003oi^KVonKVi_l000000_oVi^H00ol0003oi^KV
onKViP0OonKViP00=ooVi^H4o`0000;oi^KV1Ol000000ooVi^Ko0000o`000002o`0000;oi^KV1?l0
0003onKViP?o0000C_oVi^H3o`000005onKVi_l0003o0000o`000?oVi^H01_l00002onKViPGo0000
00Coi^KVo`000?l0003oi^KV1_l000000ooVi^Ko0000o`00000PonKViP00hooVi^H00>?oi^KV003S
onKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV002LonKViPGo00002ooVi^H3o`00
00goi^KV0ol0000:onKViP?o00005ooVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?o
i^KV0ol0001monKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00000=
onKViP03o`000?oVi^Koi^KV00Soi^KV00Go0000onKVi_oVi^Koi^KVo`00000FonKViP004?oVi^H0
1?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000NooVi^H00ol0003oi^KV
onKViP0>onKViP03o`000?oVi^Koi^KV00Soi^KV1Ol0000=onKViP03o`000?oVi^Koi^KV01Coi^KV
000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1Ol00002onKViP03ogmoOooVi^Koi^KV07[oi^KV
00?o0000onKVi_oVi^H02ooVi^H2o`0000_oi^KV00Co0000onKVi_oVi^Ko00003_oVi^H00ol0003o
i^KVonKViP0DonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP04o`000?oVi^Koi^KVo`00
00?oi^KV00?oOgmoonKVi_oVi^H0MooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000koi^KV00?o0000
onKVi_oVi^H02OoVi^H00ol0003oi^KVo`00000:onKViPCo00005ooVi^H0013oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H00ol0003oi^KVo`000003onKViP03o`000?moOgooi^KV07Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`00000:onKViP05o`000?oVi^Koi^KVonKVi_l000003?oVi^H2o`0000[oi^KV
00?o0000onKVi_oVi^H06?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000?oi^KV
00?o0000ogmoOooVi^H0N?oVi^H3o`0000coi^KV0ol0000>onKViP03o`000?oVi^Koi^KV00Soi^KV
1Ol0000FonKViP004OoVi^H2o`0000_oi^KV00Ko0000onKVi_oVi^Koi^KVo`000?moOgnoonKViP00
4OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKVi_moOgl0
JooVi^H00ol0003oi^KVonKViP1@onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`00
0?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVogmoO`1ZonKViP03o`000?nIVIWo000003co
00005OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l00002onKV
iP03ogmoOooVi^Koi^KV06Soi^KV00?oVIVIo`000?oVi^H0D?oVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00002ooVi^H01?l0003oi^KVonKVi_l00002onKViP03ogmoOooVi^Koi^KV06Soi^KV00?o0000
oiVIVOoVi^H0D?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00Co0000
onKVi_oVi^KoOgmoJ_oVi^H00ol0003oVIVIonKViP1@onKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVogmoO`1YonKViP03o`00
0?nIVIWoi^KV053oi^KV000AonKViP;o00002?oVi^H5o`0000;oi^KV00Go0000onKVi_oVi^Koi^KV
ogmoO`1YonKViP;o000000?oVIVIonKVi_oVi^H0C_oVi^H0017oi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV00?oOgmoonKVi_oVi^H0E_oV
i^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o0000onKVi_nIVIT0D?oV
i^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV
00?o0000onKVi_oVi^H00_oVi^H00omoOgooi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Ko0000onKVi_oVi^Koi^KVo`000?oVi^H2o`000003onKVi_nIVIWoi^KV04koi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV00;oi^KV00?oOgmoonKVi_oVi^H0EOoVi^H01?l0003oi^KVonKVi_l0000;onKViP03o`00
0?oVi^Ko000000;oi^KV00?oVIVIonKVi_oVi^H0COoVi^H0013oi^KV00Co0000onKVi_oVi^Ko0000
1ooVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00omoOgooi^KVonKViP1DonKViP04o`00
0?oVi^Koi^KVo`0000Woi^KV0_l00002onKViP;o00000_oVi^H00onIVIWoi^KVonKViP1<onKViP00
4?oVi^H01?l0003oi^KVonKVi_l00007onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_oV
i^H00ooVi^H00omoOgooi^KVonKViP1DonKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKV
i_l0003o00000_oVi^H00onIVIWoi^KVonKViP1<onKViP004?oVi^H01?l0003oi^KVonKVi_l00008
onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H01?oVi^H00omoOgooi^KVonKViP1C
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^Ko000000?o
i^KV00?oVIVIonKVi_oVi^H0C?oVi^H0017oi^KV0_l0000:onKViP;o00000ooVi^H00ol0003oi^KV
onKViP04onKViP03ogmoOooVi^Koi^KV05Coi^KV0_l00009onKViP?o00000_oVi^H2o`0000?oi^KV
00?oVIVIonKVi_oVi^H0BooVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV00?o
0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP04onKViP03ogmoOooVi^Koi^KV06Coi^KV00?o
0000onKVi_oVi^H00_oVi^H00onIVIWoi^KVonKViP1;onKViP004?oVi^H01?l0003oi^KVonKVi_l0
0009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H01OoVi^H00omoOgooi^KVonKV
iP1SonKViP;o00001?oVi^H00onIVIWoi^KVonKViP1:onKViP004?oVi^H01?l0003oi^KVonKVi_l0
000:onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00omoOgooi^KVonKViP1ConKViP;o0000
1?oVi^H00ol0003oi^KVonKViP03onKViP?o000000?oi^KVo`000?oVi^H01?oVi^H00onIVIWoi^KV
onKViP1:onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l0
00002?oVi^H00omoOgooi^KVonKViP1AonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00?o0000onKV
i_oVi^H00_l00004onKViP03oiVIVOoVi^Koi^KV04[oi^KV000@onKViP04o`000?oVi^Koi^KVo`00
00_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00omoOgooi^KVonKViP1AonKViP04o`000?oVi^Ko
i^KVo`0000Ooi^KV1Ol000000ooVi^Ko0000o`000005onKViP03oiVIVOoVi^Koi^KV04Woi^KV000@
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`00
0?oVi^Koi^KV00Ooi^KV00?oOgmoonKVi_oVi^H0D?oVi^H01?l0003oi^KVonKVi_l00007onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H01?oVi^H00onIVIWoi^KVonKViP19onKV
iP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00Ooi^KV00?oOgmoonKVi_oV
i^H0D?oVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Ko000000;oi^KV0_l00006onKV
iP03oiVIVOoVi^Koi^KV04Soi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o
00000ooVi^H00ol0003oi^KVonKViP07onKViP03ogmoOooVi^Koi^KV053oi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H2o`0000;oi^KV00?o0000onKVi_oVi^H01OoVi^H00onIVIWoi^KVonKViP18onKV
iP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H0
0ol0003oi^KVonKViP08onKViP03ogmoOooVi^Koi^KV053oi^KV0_l0000;onKViP03o`000?oVi^Ko
i^KV00;o00001ooVi^H00onIVIWoi^KVonKViP17onKViP004?oVi^H01?l0003oi^KVonKVi_l00007
onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP08onKViP03ogmoOooV
i^Koi^KV063oi^KV00?o0000onKVi_oVi^H01_oVi^H00onIVIWoi^KVonKViP17onKViP004?oVi^H0
1?l0003oi^KVonKVi_l00008onKViP?o00000ooVi^H00ol0003oi^KVonKViP09onKViP03ogmoOooV
i^Koi^KV05ooi^KV0_l00007onKViP03oiVIVOoVi^Koi^KV04Ooi^KV000@onKViP04o`000?oVi^Ko
i^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Woi^KV
00?oOgmoonKVi_oVi^H0CooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV
0_l00008onKViP03oiVIVOoVi^Koi^KV04Koi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV
00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Woi^KV00?oOgmoonKVi_oV
i^H0C_oVi^H01?l0003oi^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVo`00
0009onKViP03oiVIVOoVi^Koi^KV04Koi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02
onKViP?o00000ooVi^H00ol0003oi^KVonKViP0:onKViP03ogmoOooVi^Koi^KV04goi^KV00Co0000
onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVo`000?l00009onKViP03oiVIVOoVi^Koi^KV04Goi^KV
000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00000<onKViP03
ogmoOol0003o000000?o00003?oVi^H3o`0000ooi^KV0ol0000=onKViP?o00006OoVi^H01?l0003o
i^KVonKVi_l0000;onKViP03o`000?oVi^Ko000000[oi^KV00?oVIVIonKVi_oVi^H0AOoVi^H0013o
i^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000=onKViP05ogmoOol0003o
i^KVonKVi_l000002ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000ooi^KV00?o0000onKVi_oVi^H0
2ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000001Soi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`00
00;oi^KV0_l00009onKViP03oiVIVOoVi^Koi^KV04Goi^KV000@onKViP04o`000?oVi^Koi^KVo`00
00Soi^KV1?l00002onKViP03o`000?oVi^Koi^KV00_oi^KV00?oOgmoonKVi_l000004OoVi^H00ol0
003oi^KVonKViP0:onKViPGo00004?oVi^H00ol0003oi^KVonKViP0FonKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP09onKViP03oiVIVOoVi^Ko
i^KV04Coi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00
0002onKViP03o`000?oVi^Koi^KV00_oi^KV00CoOgmoonKVi_oVi^Ko00003_oVi^H2o`0000goi^KV
00Co0000onKVi_oVi^Ko00004OoVi^H00ol0003oi^KVonKViP0GonKViP;o00002?oVi^H5o`000003
onKVi_l0003o000000[oi^KV00?oVIVIonKVi_oVi^H0A?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H02ooVi^H01Ol0
003oOgmoonKVi_oVi^Ko000000ooi^KV00?o0000onKVi_oVi^H02ooVi^H00ol0003oi^KVo`00000=
onKViPCo0000:_oVi^H00ol0003oi^KVonKViP0:onKViP03oiVIVOoVi^Koi^KV04?oi^KV000AonKV
iP;o00002OoVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H02ooVi^H01Ol0003oOgmoonKVi_oVi^Ko
000000_oi^KV00Go0000onKVi_oVi^Koi^KVo`00000>onKViP;o00003OoVi^H00ol0003oi^KVonKV
iP0[onKViP;o00002ooVi^H00onIVIWoi^KVonKViP13onKViP008_oVi^H00ol0003oi^KVonKViP0<
onKViP03o`000?moOgoo000000goi^KV0ol0000@onKViP03o`000?oVi^Koi^KV00_oi^KV1Ol0000I
onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H2o`0000coi^KV00?oVIVI
onKVi_oVi^H0@_oVi^H002;oi^KV00?o0000onKVi_oVi^H03OoVi^H00omoOgooi^KVonKViP0XonKV
iPWoOgmo6OoVi^H01?l0003oi^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KV
o`00000=onKViP03oiVIVOoVi^Koi^KV02?oi^KV2?nIVITGonKViP008_oVi^H00ol0003oi^KVonKV
iP0=onKViP03ogmoOooVi^Koi^KV01Ooi^KV4OmoOglRonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV
00Ko0000onKVi_oVi^Koi^KVo`000?oVi^H2o`0000coi^KV00?oVIVIonKVi_oVi^H05OoVi^H>oiVI
VAooi^KV000PonKViQ?o00006OmoOglLo`0001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`00
00;oi^KV00?o0000onKVi_oVi^H03?oVi^HGoiVIVBgoi^KV000RonKViP03o`000?oVi^Koi^KV05[o
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP03onKViP;o0000DOoVi^H007oo
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP1EonKViP00P?oVi^H2o`0000[o
i^KV0_l0001EonKViP00hooVi^H00>?oi^KV000eonKViP;o000000Coi^KVo`000?l0003o00000_oV
i^H2o`0000?oi^KV0ol00002onKViP;o000000Goi^KVo`000?l0003o0000onKViP03o`00057oi^KV
0ol00003onKViPGo000000Coi^KVo`000?l0003o00000_oVi^H3o`000004onKVi_l0003o0000o`00
02Woi^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003
onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000005?oi^KV
00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H00ol0003oi^KVonKViP0XonKViP00=OoVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_oVi^H5o`0000?oi^KV
00?o0000onKVi_oVi^H0DOoVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00?oi^KV
00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000002[oi^KV000eonKViP05o`00
0?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV
00;oi^KV00?o0000onKVi_l000001?oVi^H00ol0003oi^KVonKViP1AonKViP?o00000ooVi^H3o`00
00?oi^KV0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l00000:_oVi^H003Goi^KV00Go0000onKV
i_l0003oi^KVo`000002onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`00
00;oi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko0000057oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko
0000onKVi_l0003oi^KVo`0002[oi^KV000eonKViP;o000000?oi^KVo`000?l000000_oVi^H02_l0
003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l00003onKViP09o`000?oVi^Koi^KVonKV
i_l0003oi^KVo`000?oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KV
onKVi_l00002onKViP05o`000?oVi^Koi^KVo`000?oVi^H00_l000000ooVi^Ko0000o`00000ZonKV
iP00=OoVi^H01?l0003oi^KVonKVi_oVi^H5o`000003onKVi_l0003o000000Go00000_oVi^H2o`00
00?oi^KV1Ol0001@onKViPCo00000_oVi^H5o`000003onKVi_l0003o000000;o00000_oVi^H01?l0
003oi^KVonKVi_oVi^H2o`0002Woi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H0
0>?oi^KV003SonKViP00hooVi^H003Goi^KV1Ol0000:onKViP?o00003OoVi^H3o`0000_oi^KV0ol0
000jonKViPGo00002ooVi^H3o`0000goi^KV0ol0000:onKViP?o00005?oVi^H003Koi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000goi^KV00?o0000onKVi_oVi^H0
2OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000003[oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000goi^KV00?o0000onKVi_oVi^H02?oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000001?oi^KV000gonKViP03o`000?oVi^Koi^KV00goi^KV00?o0000onKVi_oVi^H02?oVi^H5
o`0000koi^KV00?o0000onKVi_oVi^H0>OoVi^H00ol0003oi^KVonKViP0>onKViP03o`000?oVi^Ko
i^KV00Soi^KV1Ol0000=onKViP03o`000?oVi^Koi^KV017oi^KV000honKViP03o`000?oVi^Koi^KV
00[oi^KV0_l0000;onKViP04o`000?oVi^Koi^KVo`0000ooi^KV00?o0000onKVi_oVi^H0>_oVi^H0
0ol0003oi^KVonKViP0;onKViP;o00002ooVi^H01?l0003oi^KVonKVi_l0000>onKViP03o`000?oV
i^Koi^KV017oi^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l000003OoVi^H00ol0003oi^KVonKV
iP09onKViP03o`000?oVi^Ko000000_oi^KV1?l0000jonKViP05o`000?oVi^Koi^KVonKVi_l00000
3_oVi^H00ol0003oi^KVonKViP09onKViP03o`000?oVi^Ko000000[oi^KV1?l0000DonKViP00=OoV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00000<onKViP;o
00002ooVi^H00ol0003oi^KVonKViP0konKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000coi^KV0_l0000:onKViP03o`000?oVi^Koi^KV01Goi^KV000fonKV
iP?o00002ooVi^H3o`0000koi^KV00?o0000onKVi_oVi^H02OoVi^H5o`0003[oi^KV0ol0000<onKV
iP?o00003_oVi^H00ol0003oi^KVonKViP08onKViPGo00004ooVi^H00>?oi^KV000WonKViQ7o0000
;Om<C4`00ol0003oi^KVonKViP0ZonKViP03o`000?mVIVKo000003co00004_oVi^H002Woi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVoda<
C0;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000^onKViP04ofIV
I_oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00005?oVi^H002Woi^KV
00?o0000onKVi_oVi^H02ooVi^H00om<C4coi^KVonKViP1IonKViP03o`000?mVIVKoi^KV04goi^KV
000YonKViP03o`000?oVi^Koi^KV00_oi^KV00?oC4a<onKVi_oVi^H0FOoVi^H00ol0003oIVIVonKV
iP1=onKViP00:OoVi^H00ol0003oi^KVonKViP0;onKViP03oda<C?oVi^Koi^KV05Woi^KV00?o0000
ofIVI_oVi^H0COoVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKV
iPGo00000_oVi^H00ol0003oi^KVonKViP0:onKViP03oda<C?oVi^Koi^KV04Coi^KV0_l00004onKV
iP03o`000?oVi^Koi^KV00?oi^KV0_l00002onKViPGo000000Coi^KVo`000?oVi^KoIVIVCOoVi^H0
017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H02_oVi^H00om<C4coi^KVonKViP13onKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KVonKVi_l0003oi^KV
00;o000000?oIVIVonKVi_oVi^H0BooVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0
003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H02OoVi^H00om<
C4coi^KVonKViP14onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?oIVIVonKVi_oVi^H0B_oVi^H0017oi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l0
00002ooVi^H00om<C4coi^KVonKViP14onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKV
i_oVi^Ko00001?oVi^H00ol0003oi^KVonKViP02o`000003onKVi_mVIVKoi^KV04_oi^KV000AonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oV
i^Koi^KVo`0000_oi^KV00?oC4a<onKVi_oVi^H0A?oVi^H01?l0003oi^KVonKVi_l00008onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`000002onKViP03ofIVI_oVi^Ko
i^KV04[oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00003onKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP08onKViP03oda<C?oVi^Koi^KV04Goi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKV
i_l0003o00000_oVi^H00omVIVKoi^KVonKViP19onKViP004_oVi^H2o`0000[oi^KV00?o0000onKV
i_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H02?oVi^H00om<C4coi^KVonKViP16onKV
iP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP;o00000_oVi^H00omVIVKoi^KVonKViP19onKV
iP00:OoVi^H00ol0003oi^KVonKViP07onKViP03oda<C?oVi^Koi^KV05goi^KV00?o0000onKVi_oV
i^H00_oVi^H00omVIVKoi^KVonKViP18onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H0
0_oVi^H3o`0000Coi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Ooi^KV00?oC4a<onKVi_oVi^H0
AooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000Coi^KV0ol000000ooVi^Ko0000
o`000003onKViP03ofIVI_oVi^Koi^KV04Soi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Woi^KV00?oC4a<onKVi_oV
i^H0A_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00Co0000
onKVi_oVi^Ko00001?oVi^H00omVIVKoi^KVonKViP18onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0009onKViP04o`000?oVi^Koi^KVonKViPGo00000_oVi^H00ol0003oi^KVonKViP06onKViP03oda<
C?oVi^Koi^KV04Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV
00Go000000?oi^KVo`000?l000001?oVi^H00omVIVKoi^KVonKViP17onKViP004OoVi^H01?l0003o
i^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Soi^KV00?oC4a<onKVi_oVi^H0AooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`00
0?oVi^Koi^KVo`000?oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00005onKViP03ofIVI_oVi^Ko
i^KV04Ooi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H0
0ol0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV00Goi^KV00?oC4a<onKVi_oVi^H0B?oVi^H0
1?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_l00000
0_oVi^H2o`0000Goi^KV00?oIVIVonKVi_oVi^H0A_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H2o`0000Goi^KV0_l00003onKViP03o`000?oVi^Koi^KV00Goi^KV00?oC4a<onKVi_oVi^H0
B?oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l00002onKV
iP03o`000?oVi^Koi^KV00Coi^KV00?oIVIVonKVi_oVi^H0A_oVi^H001;oi^KV0_l0000:onKViP03
o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP03oda<C?oVi^Koi^KV
04[oi^KV0_l0000:onKViP;o00001OoVi^H00ol0003oi^KVonKViP02o`0000Koi^KV00?oIVIVonKV
i_oVi^H0AOoVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP?o
00000ooVi^H00ol0003oi^KVonKViP04onKViP03oda<C?oVi^Koi^KV04[oi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o00000_oVi^H2o`0000Koi^KV00?oIVIVonKVi_oV
i^H0AOoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00?oi^KV00Co0000onKVi_oVi^Ko00001_oVi^H00om<C4coi^KVonKViP19onKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko000000Oo
i^KV00?oIVIVonKVi_oVi^H0AOoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H00om<C4coi^KVonKViP1:
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04
o`000?oVi^Ko0000o`0000Ooi^KV00?oIVIVonKVi_oVi^H0A?oVi^H0017oi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0om<C4coi^KVonKViP1:onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000
onKViP04o`0000;oi^KV00?o0000onKVi_oVi^H01_oVi^H00omVIVKoi^KVonKViP14onKViP004OoV
i^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H00ol0003o
i^KVonKViP02onKViP03oda<C?oVi^Koi^KV04_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0
003oi^KVonKVi_l0003oi^KVo`0000Goi^KV0_l00008onKViP03ofIVI_oVi^Koi^KV04?oi^KV000A
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV00?o
0000onKVi_oVi^H00_oVi^H00om<C4coi^KVonKViP1;onKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00Oo
i^KV00?oIVIVonKVi_oVi^H0@ooVi^H001;oi^KV0_l0000:onKViP03o`000?oVi^Koi^KV00?oi^KV
0_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00?oC4a<onKVi_oVi^H0C?oVi^H2o`0000[oi^KV
0_l00004onKViP;o00000_oVi^H2o`0000Soi^KV00?oIVIVonKVi_oVi^H0@ooVi^H001;oi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP?o00000ooVi^H01Ol0003oi^KVonKV
i_oVi^KoC4a<04ooi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o0000
0_oVi^H00ol0003oi^KVonKViP08onKViP03ofIVI_oVi^Koi^KV04;oi^KV000AonKViP04o`000?oV
i^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`00
00?oi^KV00?oC4a<onKVi_oVi^H0C?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l00009onKViP03ofIVI_oVi^Koi^KV04;o
i^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00?oC4a<onKVi_oVi^H0COoVi^H01?l0003oi^KVonKVi_l0
0008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`00000;onKViP03
ofIVI_oVi^Koi^KV047oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oV
i^H00_oVi^H3o`0000?oi^KV00Co0000onKVi_oVi^KoC4a<CooVi^H01?l0003oi^KVonKVi_l00008
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP;o00002_oVi^H00omVIVKoi^KVonKV
iP11onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l00000
0ooVi^H01?l0003oi^KVonKVi_l00002onKViP03oda<C?oVi^Koi^KV04goi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o0000
2_oVi^H00omVIVKoi^KVonKViP11onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000
0ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_m<C4`0D?oVi^H01?l0003o
i^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`00
000<onKViP03ofIVI_oVi^Koi^KV043oi^KV000BonKViP;o00002_oVi^H00ol0003oi^KVonKViP02
onKViP?o00000ooVi^H00ol0003oi^KVoda<C01AonKViP;o00002_oVi^H2o`0000?oi^KV0ol00002
onKViP;o00002ooVi^H00omVIVKoi^KVonKViP10onKViP006?oVi^H2o`0000Coi^KV00Co0000onKV
i_oVi^Koi^KV1Ol00002onKViP03o`000?m<C4coi^KV05Ooi^KV0_l00004onKViP03o`000?oVi^Ko
i^KV00;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00_oi^KV00?oIVIVonKVi_oVi^H0?ooVi^H0
01Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?m<
C4coi^KV05Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0000co
i^KV00?oIVIVonKVi_oVi^H0?ooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003o
i^KVonKViP02onKViP03o`000?m<C4coi^KV05Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000goi^KV00?oIVIVonKVi_oVi^H0?ooVi^H001Ooi^KV00Co0000onKV
i_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^KoC4a<05Soi^KV00Co0000onKVi_oVi^Ko0000
2OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0000goi^KV;OmVIVHDonKViP005ooVi^H01?l0003oi^KV
onKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP1FonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP005ooVi^H0
1?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l00000FooVi^H01?l0003oi^KV
onKVi_l00008onKViP;o0000DooVi^H001Soi^KV0_l00009onKViP?o0000GOoVi^H2o`0000[oi^KV
00?o0000onKVi_oVi^H0DOoVi^H00>?oi^KV003SonKViP00>_oVi^H4o`0000Coi^KV0_l00002onKV
iP?o00000ooVi^H5o`0004koi^KV1Ol000001_oVi^Ko0000o`000?l0003oi^KVo`0000?oi^KV0_l0
0002onKViP;o000000?oi^KVo`000?l000001?l00004onKViP?o00008_oVi^H003_oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV
00Co0000onKVi_oVi^Ko0000CooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000Go
i^KV00Co0000onKVi_oVi^Ko00008OoVi^H003_oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0
003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H0D?oVi^H0
0ol0003oi^KVonKViP03onKViP06o`000?oVi^Ko0000o`000?oVi^Ko00001OoVi^H5o`0000;oi^KV
00?o0000onKVi_oVi^H01_oVi^H00ol0003oi^KVonKViP0OonKViP00>ooVi^H01?l0003oi^KVonKV
i_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV053o
i^KV0ol00003onKViP06o`000?oVi^Ko0000o`000?oVi^Ko00001_oVi^H00ol0003oi^KVo`000003
onKViP?o00001?oVi^H2o`0002;oi^KV000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV053oi^KV
00?o0000onKVi_oVi^H00ooVi^H2o`000004onKVi_l0003oi^KVo`0000Koi^KV00?o0000onKVi_l0
00000ooVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV02;oi^KV000konKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0
0002onKViP03o`000?oVi^Koi^KV053oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H2o`000005onKV
i_l0003oi^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000QonKViP00>_oVi^H4o`0000;oi^KV0ol00000
0ooVi^Ko0000o`000004o`0000;oi^KV0ol0001@onKViPGo000000Coi^KVo`000?l0003oi^KV0ol0
0002onKViP?o00000_oVi^H2o`0000?oi^KV1?l00004onKViP?o00008OoVi^H00>?oi^KV003SonKV
iP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00WooVi^H5o`0000_oi^KV
0ol0000=onKViP?o00002_oVi^H3o`0001Coi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKV
iP03onKViP?o0000P?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l0
00003OoVi^H00ol0003oi^KVonKViP08onKViP05o`000?oVi^Koi^KVonKVi_l000004ooVi^H0013o
i^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000007koi^KV00?o0000
onKVi_oVi^H03_oVi^H00ol0003oi^KVonKViP08onKViPGo00003OoVi^H00ol0003oi^KVonKViP0A
onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViPGo00000_oVi^HBoaTI6Fkoi^KV00?o0000
onKVi_oVi^H02ooVi^H2o`0000_oi^KV00Co0000onKVi_oVi^Ko00003_oVi^H00ol0003oi^KVonKV
iP0AonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP04o`000?oVi^Koi^KVo`0000?oi^KV
00?o0000onKVi_oVi^H03_oVi^H00olI6AWoi^KVonKViP1YonKViP05o`000?oVi^Koi^KVonKVi_l0
00003_oVi^H00ol0003oi^KVonKViP09onKViP03o`000?oVi^Ko000000[oi^KV1?l0000DonKViP00
4?oVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Ko000000?oi^KV00?o0000onKVi_oV
i^H03ooVi^H00olI6AWoi^KVonKViP1XonKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000coi^KV0_l0000:onKViP03o`000?oVi^Koi^KV01Goi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00003onKViP03o`000?oVi^Koi^KV00ooi^KV00?o6ATI
onKVi_oVi^H0JOoVi^H3o`0000coi^KV0ol0000>onKViP03o`000?oVi^Koi^KV00Soi^KV1Ol0000C
onKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKV
i_oVi^H03ooVi^H00olI6AWoi^KVonKViP1LonKViP03o`000?oVi^Koi^KV04goi^KV000@onKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Ko
i^KV013oi^KV00?o6ATIonKVi_oVi^H0F_oVi^H00ol0003o<c<co`00000lo`0001;oi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00004_oVi^H00olI6AWoi^KVonKV
iP1KonKViP04oc<c<ooVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003o
i^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko0000
5?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000BonKViP03
oaTI6OoVi^Koi^KV05_oi^KV00?o0000oc<c<ooVi^H0COoVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H4o`0000?oi^KV00?o0000onKVi_oVi^H04OoVi^H00olI6AWoi^KVonKViP1JonKViP03
o`000?lc<c?oi^KV04goi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oV
i^H01?oVi^H00ol0003oi^KVonKViP0AonKViP03oaTI6OoVi^Koi^KV05[oi^KV00?o0000oc<c<ooV
i^H0COoVi^H0017oi^KV0_l00008onKViPGo00000_oVi^H00ol0003oi^KVonKViP0BonKViP03oaTI
6OoVi^Koi^KV04?oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00002onKViPGo0000
00Coi^KVo`000?oVi^Ko<c<cCOoVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV
0ol00003onKViP03o`000?oVi^Koi^KV01;oi^KV00?o6ATIonKVi_oVi^H0@_oVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Go0000onKVi_oVi^Ko0000onKViP02
o`000003oc<c<ooVi^Koi^KV04_oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01;oi^KV00?o6ATIonKVi_oVi^H0@_oV
i^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00Go0000onKVi_oV
i^Koi^KVo`000002onKViP03oc<c<ooVi^Koi^KV04[oi^KV000@onKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01?oi^KV00?o6ATI
onKVi_oVi^H0@OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Coi^KV
00?o0000onKVi_oVi^H00_l000000ooVi^Ko<c<conKViP1;onKViP004?oVi^H01?l0003oi^KVonKV
i_l00007onKViPCo00000ooVi^H00ol0003oi^KVonKViP0ConKViP03oaTI6OoVi^Koi^KV047oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Ko0000
onKVi_l0003o0000onKVi_lc<c=<onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP03o`00
0?oVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H05?oVi^H00olI6AWoi^KVonKViP10onKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko
000000?oi^KV00?o<c<conKVi_oVi^H0BOoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
0ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV01Coi^KV00?o6ATIonKVi_oVi^H0@OoVi^H2
o`0000[oi^KV0_l00003onKViP?o00000_oVi^H2o`0000;oi^KV00?o<c<conKVi_oVi^H0BOoVi^H0
017oi^KV0_l0000:onKViP;o00000ooVi^H00ol0003oi^KVonKViP0DonKViP03oaTI6OoVi^Koi^KV
047oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP?o000000?oi^KVo`00
0?oVi^H00ooVi^H00olc<c?oi^KVonKViP18onKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oV
i^H00ooVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV01Goi^KV00?o6ATIonKVi_oV
i^H0?ooVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?o0000
onKVi_oVi^H00_l00003onKViP03oc<c<ooVi^Koi^KV04Soi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0EonKViP03oaTI6OoVi^Ko
i^KV03ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Go0000
00?oi^KVo`000?oVi^H00ooVi^H00olc<c?oi^KVonKViP18onKViP004?oVi^H01?l0003oi^KVonKV
i_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000005ooVi^H00olI6AWoi^KVonKViP0oonKViP04
o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP03o`000?oV
i^Koi^KV00;o00001?oVi^H00olc<c?oi^KVonKViP17onKViP004?oVi^H01?l0003oi^KVonKVi_l0
000:onKViP05o`000?oVi^Koi^KVonKVi_l000006?oVi^H00olI6AWoi^KVonKViP0nonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVo`000002onKV
iP03o`000?oVi^Koi^KV00?oi^KV00?o<c<conKVi_oVi^H0AooVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000HonKViP03oaTI6OoVi^Koi^KV03koi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP;o00000_oVi^H2o`0000Goi^KV
00?o<c<conKVi_oVi^H0A_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H05ooVi^H00olI6AWoi^KVonKViP0nonKViP;o
00002_oVi^H2o`0000Goi^KV00Co0000onKVi_oVi^Ko00001_oVi^H00olc<c?oi^KVonKViP16onKV
iP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oVi^Koi^KV01Ooi^KV00?o6ATIonKVi_oV
i^H0E?oVi^H2o`0000Koi^KV00?o<c<conKVi_oVi^H0AOoVi^H0017oi^KV0_l00004onKViP03o`00
0?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV01Ooi^KV00?o6ATIonKVi_oVi^H0
?_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol00002onKViP;o0000
1_oVi^H00olc<c?oi^KVonKViP15onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`00
0?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0HonKViP03oaTI6OoVi^Koi^KV03co
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o
0000onKVi_l000001ooVi^H00olc<c?oi^KVonKViP15onKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0HonKViP03oaTI
6OoVi^Koi^KV03coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000?oi^KV00Co0000onKVi_l0003o00001ooVi^H00olc<c?oi^KVonKViP14onKViP004?oVi^H0
1?l0003oi^KVonKVi_l00008onKViP?o00000ooVi^H00ol0003oi^KVonKViP0HonKViP03oaTI6OoV
i^Koi^KV03coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Co
00000_oVi^H00ol0003oi^KVonKViP06onKViP03oc<c<ooVi^Koi^KV04Coi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV
01Woi^KV00?o6ATIonKVi_oVi^H0>ooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00001OoVi^H2o`0000Soi^KV00?o<c<conKVi_oVi^H0@ooVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oV
i^H06OoVi^H00olI6AWoi^KVonKViP0konKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00Ooi^KV00?o<c<c
onKVi_oVi^H0@ooVi^H0017oi^KV0_l00009onKViP?o00000ooVi^H00ol0003oi^KVonKViP0JonKV
iP03oaTI6OoVi^Koi^KV03_oi^KV0_l0000:onKViP;o00001?oVi^H2o`0000;oi^KV0_l00008onKV
iP03oc<c<ooVi^Koi^KV04?oi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP;o
00001?oVi^H00ol0003oi^KVonKViP0JonKViP03oaTI6OoVi^Koi^KV03_oi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o00000_oVi^H00ol0003oi^KVonKViP08onKViP03
oc<c<ooVi^Koi^KV04;oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oV
i^Koi^KVo`00000=onKViPGo00002_oVi^H00olI6AWoi^KVo`000002o`0000ooi^KV0ol0000=onKV
iP?o00005_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0ooVi^H01?l0003oi^KVo`000?l00009onKViP03oc<c<ooVi^Koi^KV04;oi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00003_oVi^H01?l0003oi^KVonKVi_l0000;
onKViP05oaTI6OoVi^Koi^KVonKVi_l000003ooVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oV
i^Koi^KVonKVi_l000005OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l0000:onKViP03oc<c<ooVi^Koi^KV047oi^KV000@
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00002onKViP03o`000?oVi^Koi^KV00goi^KV00?o
0000onKVi_oVi^H02ooVi^H01OlI6AWoi^KVonKVi_oVi^Ko000000coi^KV1Ol0000@onKViP03o`00
0?oVi^Koi^KV01?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKV
iP?o00000_oVi^H00ol0003oi^KVonKViP09onKViP03oc<c<ooVi^Koi^KV047oi^KV000@onKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Ko
i^KV00koi^KV00?o0000onKVi_oVi^H02ooVi^H00olI6AWo0000o`00000=onKViP04o`000?oVi^Ko
i^KVo`00017oi^KV00?o0000onKVi_oVi^H04ooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`00
0?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l0000:onKViP03oc<c<ooVi^Ko
i^KV047oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00
0002onKViP03o`000?oVi^Koi^KV00_oi^KV00Go0000onKVi_oVi^Koi^KVo`00000<onKViP04oaTI
6OoVi^Koi^KVo`0000goi^KV00?o0000onKVi_l000003OoVi^H4o`0001Koi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_l000003?oV
i^H00olc<c?oi^KVonKViP10onKViP004OoVi^H2o`0000Woi^KV0ol00003onKViP03o`000?oVi^Ko
i^KV00_oi^KV00Go0000onKVi_oVi^Koi^KVo`00000;onKViP05o`000?lI6AWoi^KVonKVi_l00000
3_oVi^H2o`0000goi^KV00?o0000onKVi_oVi^H06?oVi^H2o`0000[oi^KV0_l00003onKViP?o0000
0_oVi^H2o`0000_oi^KV00?o<c<conKVi_oVi^H0@?oVi^H002;oi^KV00?o0000onKVi_oVi^H03?oV
i^H3o`0000goi^KV00?o0000oaTI6Ol000004?oVi^H00ol0003oi^KVonKViP0;onKViPGo00007?oV
i^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H02ooV
i^H00olc<c?oi^KVonKViP0oonKViP008_oVi^H00ol0003oi^KVonKViP0MonKViP03oaTI6OoVi^Ko
i^KV01Soi^KV2OlI6ATLonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV
0_l0000<onKViP03oc<c<ooVi^Koi^KV03ooi^KV000RonKViP03o`000?oVi^Koi^KV01goi^KV00?o
6ATIonKVi_oVi^H01ooVi^HAoaTI6BGoi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000goi^KV00?o<c<conKVi_oVi^H0?ooVi^H0023oi^KV8ol00009oaTI6Aco0000
6_oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o00003OoVi^H]oc<c
<aCoi^KV000RonKViP03o`000?oVi^Koi^KV05goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0
003oi^KVonKVi_oVi^Ko000004ooi^KV0022onKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l0001C
onKViP00PooVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H0DOoVi^H00>?oi^KV000gonKViP;o0000
0_oVi^H3o`0000;oi^KV00?o0000onKVi_l000000_l00003onKViP?o00000ooVi^H3o`0004koi^KV
1?l00002onKViPGo00000ooVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000o`000004o`0000Coi^KV
0ol0000RonKViP00=_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o
0000onKVi_oVi^H0C?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00Co
0000onKVi_oVi^Ko00008OoVi^H003Goi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVo`00
0002onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KVonKViP03onKViP03o`00
0?oVi^Koi^KV04coi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03
o`000?oVi^Koi^KV00?oi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00Koi^KV00?o0000onKVi_oV
i^H07ooVi^H003Goi^KV00?o0000onKVi_oVi^H01?oVi^H3o`0000;oi^KV00Go0000onKVi_oVi^Ko
i^KVo`000003onKViP;o00001?oVi^H2o`0004ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`00
00;oi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVo`000003onKViP?o00001?oVi^H2o`00
02;oi^KV000eonKViP03o`000?oVi^Koi^KV00Coi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003
onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00?o0000onKVi_oVi^H0CooVi^H01?l0003oi^KVonKV
i_l00002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KV
o`000003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H08_oVi^H003Koi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04coi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oV
i^Koi^KVo`00027oi^KV000gonKViP?o000000?oi^KVo`000?l000000_l00003onKViP?o00001?oV
i^H3o`0000?oi^KV0ol0001=onKViPCo00000_oVi^H5o`0000?oi^KV0ol00002onKViP;o00000ooV
i^H4o`0000Coi^KV0ol0000QonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003S
onKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00F_oVi^H4o`0008Go
i^KV001KonKViP;o0000Q_oVi^H005_oi^KV0_l00026onKViP00?ooVi^H5o`0000;oi^KV1?l00009
onKViPGo00000ooVi^H5o`0000;oi^KV0ol000000ooVi^Ko0000o`000002o`000003onKVi_l0003o
000000Co00000_oVi^H2o`000003onKVi_l0003o000000;o000000?oi^KVo`000?l000000_l00005
onKViPCo00000_oVi^H<o`000003onKVi_l0003o000000Co000000?oi^KVo`000?l000001Ol0000n
onKViP00?_oVi^H2o`0000?oi^KV0_l00002onKViP;o00002OoVi^H2o`0000?oi^KV0_l00002onKV
iP;o00000_oVi^H4o`0000;oi^KV00Co0000onKVi_l0003o00000_oVi^H2o`000003onKVi_l0003o
000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000001ooVi^H2
o`0000;oi^KV0ol000001?oVi^Ko0000o`000?oVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000o`00
0002onKViP;o000000Goi^KVo`000?l0003oi^KVo`000002onKViP;o0000?OoVi^H003goi^KV0_l0
0004onKViP;o00000_oVi^H2o`0000Soi^KV0_l00005onKViP;o000000?oi^KVo`000?l000000_oV
i^H4o`0000Coi^KV0_l00002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0
003o000000;oi^KV0_l000000ooVi^Ko0000o`000007onKViP;o000000Coi^KVo`000?l0003o0000
0_oVi^H2o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o0000
00?oi^KVo`000?l000000ooVi^H3o`0003goi^KV000monKViP;o00000ooVi^H4o`000003onKVi_l0
003o000000?o00001OoVi^H2o`0000Goi^KV0_l000000ooVi^Ko0000o`000002onKViPOo000000?o
i^KVo`000?l000001?oVi^H3o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?o
i^KVo`000?l000001ooVi^H5o`0000Goi^KV0ol00002onKViP;o000000?oi^KVo`000?l000000_oV
i^H4o`0000;oi^KV0ol0000oonKViP00?OoVi^H2o`0000Soi^KV0_l00002onKViP;o00001?oVi^H2
o`0000Goi^KV0_l000001OoVi^Ko0000o`000?l0003oi^KV00Co000000Coi^KVo`000?l0003oi^KV
1_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKV
i_l0003o000000;o00001OoVi^H2o`0000?oi^KV0_l000001?oVi^Ko0000o`000?oVi^H2o`0000;o
i^KV1Ol00002onKViP;o00000_oVi^H01?l0003oi^KVo`000?l00002onKViP03o`000?oVi^Koi^KV
03_oi^KV000monKViP;o00001OoVi^H00ol0003oi^KVonKViP02o`0000;oi^KV0_l00004onKViP;o
00001OoVi^H5o`000003onKVi_l0003o000000;oi^KV0ol000001ooVi^Ko0000o`000?l0003oi^KV
o`000?oVi^H00ol00002onKViPCo000000?oi^KVo`000?l000000_l000001_oVi^Ko0000o`000?l0
003oi^KVo`0000Goi^KV0_l00003onKViP;o00000_oVi^H3o`0000;oi^KV0ol000000ooVi^Ko0000
o`000002onKViP;o000000Goi^KVo`000?l0003o0000onKViP04o`0003goi^KV000nonKViP;o0000
0ooVi^H2o`0000;oi^KV0_l00002onKViP;o00001OoVi^H2o`0000?oi^KV0_l0000IonKViP;o0000
4OoVi^H2o`0000?oi^KV0_l0000?onKViP;o0000A_oVi^H003ooi^KV1?l000000ooVi^Ko0000onKV
iP06o`0000Ooi^KV1Ol0000KonKViP03o`000?oVi^Koi^KV00koi^KV1ol0000?onKViP?o0000A_oV
i^H00>?oi^KV003SonKViP00\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-1.81196, \
-0.0445132, 0.0678825, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-9.04356, -0.0890264, 0.0678825, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-1.05124, -0.711658, 0.0596295, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-8.83992, -0.725265, 0.0678825, 0.0112719}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {-1.81196, -0.306114, 0.0678825, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-9.04356, -0.406114, 0.0678825, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-1.02581, -2.61842, \
0.0592528, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> {-9.04356, \
-0.587, 0.0678825, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 0.9801`}\\)}, \
{\\({DECAPS, 0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, \
{\\({MUTAT, 0.9801`}\\)}, {\\({PERM, 0.5923675395`}\\)}, {\\({REPRO, \
0.1`}\\)}, {\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)}}, ColumnAlignments -> \
Left, GridBaseline -> {Baseline, {1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[_]\)\)[__]\)}\) is not present in \
expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No shrink performed."\)], \
"Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \!\(AntTracker[\(\(seq[\(\
\(advance, advance\)\)]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(6\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 -5.55112e-17 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.77654 .05678 0 -8.77228 ]
[.77654 .05678 10.625 5.22772 ]
[.81671 .10314 0 -8.67452 ]
[.81671 .10314 10.625 5.32548 ]
[.85337 .14544 0 -8.58699 ]
[.85337 .14544 10.625 5.41301 ]
[.88696 .18421 0 -8.50814 ]
[.88696 .18421 10.625 5.49186 ]
[.91785 .21986 0 -8.43677 ]
[.91785 .21986 10.625 5.56323 ]
[.94635 .25275 0 -8.37184 ]
[.94635 .25275 10.625 5.62816 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.76285 .06024 m
.75601 .06197 L
s
gsave
.77654 .05678 -61 -12.7723 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.80298 .10642 m
.79612 .10806 L
s
gsave
.81671 .10314 -61 -12.6745 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.8396 .14856 m
.83272 .15012 L
s
gsave
.85337 .14544 -61 -12.587 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.87316 .18718 m
.86626 .18867 L
s
gsave
.88696 .18421 -61 -12.5081 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.90402 .2227 m
.89711 .22412 L
s
gsave
.91785 .21986 -61 -12.4368 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9325 .25547 m
.92558 .25683 L
s
gsave
.94635 .25275 -61 -12.3718 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.18239 .25488 m
.15043 .92304 L
s
.28706 .31346 m
.26631 .93457 L
s
.37773 .36419 m
.36548 .94444 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.43572 .36583 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.48371 .35659 m .57042 .37159 L .52233 .38044 L F
.43572 .36583 m .48371 .35659 L .52233 .38044 L F
.53296 .34711 m .61975 .36251 L .57042 .37159 L F
.48371 .35659 m .53296 .34711 L .57042 .37159 L F
.39319 .34094 m .48371 .35659 L .43572 .36583 L F
.58354 .33738 m .67039 .35318 L .61975 .36251 L F
.53296 .34711 m .58354 .33738 L .61975 .36251 L F
.44232 .33104 m .53296 .34711 L .48371 .35659 L F
.39319 .34094 m .44232 .33104 L .48371 .35659 L F
.6355 .32738 m .72237 .34361 L .67039 .35318 L F
.58354 .33738 m .6355 .32738 L .67039 .35318 L F
.49279 .32087 m .58354 .33738 L .53296 .34711 L F
.44232 .33104 m .49279 .32087 L .53296 .34711 L F
.68889 .31711 m .77575 .33379 L .72237 .34361 L F
.6355 .32738 m .68889 .31711 L .72237 .34361 L F
.34756 .31424 m .44232 .33104 L .39319 .34094 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .42821 .92712 L p F P
0 0 0 r
s
.54467 .31041 m .6355 .32738 L .58354 .33738 L 1 0 0 r
F
.49279 .32087 m .54467 .31041 L .58354 .33738 L F
.74378 .30655 m .8306 .32369 L .77575 .33379 L F
.68889 .31711 m .74378 .30655 L .77575 .33379 L F
.39786 .30359 m .49279 .32087 L .44232 .33104 L F
.34756 .31424 m .39786 .30359 L .44232 .33104 L F
.57295 .92839 m .52132 .93033 L .47972 .92509 L p F P
0 0 0 r
s
.42821 .92712 m .47972 .92509 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.59801 .29966 m .68889 .31711 L .6355 .32738 L 1 0 0 r
F
.54467 .31041 m .59801 .29966 L .6355 .32738 L F
.80022 .29568 m .88697 .31331 L .8306 .32369 L F
.74378 .30655 m .80022 .29568 L .8306 .32369 L F
.44959 .29265 m .54467 .31041 L .49279 .32087 L F
.39786 .30359 m .44959 .29265 L .49279 .32087 L F
.62603 .92639 m .57295 .92839 L .53271 .923 L p F P
0 0 0 r
s
.47972 .92509 m .53271 .923 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.65288 .2886 m .74378 .30655 L .68889 .31711 L 1 0 0 r
F
.59801 .29966 m .65288 .2886 L .68889 .31711 L F
.29846 .2855 m .39786 .30359 L .34756 .31424 L F
.8583 .28451 m .94492 .30264 L .88697 .31331 L .5 0 1 r
F
.80022 .29568 m .8583 .28451 L .88697 .31331 L 1 0 0 r
F
.47972 .92509 m .42821 .92712 L .3821 .92164 L p F P
0 0 0 r
s
.50283 .28138 m .59801 .29966 L .54467 .31041 L 1 0 0 r
F
.44959 .29265 m .50283 .28138 L .54467 .31041 L F
.68061 .92434 m .62603 .92639 L .58723 .92085 L p F P
0 0 0 r
s
.53271 .923 m .58723 .92085 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.70935 .27722 m .80022 .29568 L .74378 .30655 L 1 0 0 r
F
.65288 .2886 m .70935 .27722 L .74378 .30655 L F
.34998 .27403 m .44959 .29265 L .39786 .30359 L F
.29846 .2855 m .34998 .27403 L .39786 .30359 L F
.8583 .28451 m .91807 .27301 L .94492 .30264 L .5 0 1 r
F
.53271 .923 m .47972 .92509 L .43492 .91945 L p 1 0 0 r
F P
0 0 0 r
s
.3821 .92164 m .43492 .91945 L .47972 .92509 L p 1 0 0 r
F P
0 0 0 r
s
.55762 .26979 m .65288 .2886 L .59801 .29966 L 1 0 0 r
F
.50283 .28138 m .55762 .26979 L .59801 .29966 L F
.73675 .92223 m .68061 .92434 L .64335 .91864 L p F P
0 0 0 r
s
.58723 .92085 m .64335 .91864 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.76749 .2655 m .8583 .28451 L .80022 .29568 L 1 0 0 r
F
.70935 .27722 m .76749 .2655 L .80022 .29568 L F
.40303 .26222 m .50283 .28138 L .44959 .29265 L F
.34998 .27403 m .40303 .26222 L .44959 .29265 L F
.58723 .92085 m .53271 .923 L .48932 .91719 L p F P
0 0 0 r
s
.43492 .91945 m .48932 .91719 L .53271 .923 L p 1 0 0 r
F P
0 0 0 r
s
.61405 .25785 m .70935 .27722 L .65288 .2886 L 1 0 0 r
F
.55762 .26979 m .61405 .25785 L .65288 .2886 L F
.79453 .92005 m .73675 .92223 L .70115 .91636 L p F P
0 0 0 r
s
.64335 .91864 m .70115 .91636 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.24548 .25451 m .34998 .27403 L .29846 .2855 L 1 0 0 r
F
.82736 .25343 m .91807 .27301 L .8583 .28451 L F
.76749 .2655 m .82736 .25343 L .8583 .28451 L F
.43492 .91945 m .3821 .92164 L .33234 .91572 L p F P
0 0 0 r
s
.95551 .49559 m .91529 .91551 L .88538 .90909 L p .5 0 1 r
F P
0 0 0 r
s
.88538 .90909 m .95069 .90652 L .95551 .49559 L p .5 0 1 r
F P
0 0 0 r
s
.45767 .25005 m .55762 .26979 L .50283 .28138 L 1 0 0 r
F
.40303 .26222 m .45767 .25005 L .50283 .28138 L F
.64335 .91864 m .58723 .92085 L .54535 .91487 L p F P
0 0 0 r
s
.48932 .91719 m .54535 .91487 L .58723 .92085 L p 1 0 0 r
F P
0 0 0 r
s
.67218 .24555 m .76749 .2655 L .70935 .27722 L 1 0 0 r
F
.61405 .25785 m .67218 .24555 L .70935 .27722 L F
.85402 .91782 m .79453 .92005 L .7607 .91401 L p F P
0 0 0 r
s
.70115 .91636 m .7607 .91401 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.29826 .2421 m .40303 .26222 L .34998 .27403 L .5 0 1 r
F
.24548 .25451 m .29826 .2421 L .34998 .27403 L 1 0 0 r
F
.82736 .25343 m .88906 .241 L .91807 .27301 L F
.48932 .91719 m .43492 .91945 L .38653 .91335 L p F P
0 0 0 r
s
.33234 .91572 m .38653 .91335 L .43492 .91945 L p 1 0 0 r
F P
0 0 0 r
s
.51398 .23751 m .61405 .25785 L .55762 .26979 L 1 0 0 r
F
.45767 .25005 m .51398 .23751 L .55762 .26979 L F
.70115 .91636 m .64335 .91864 L .6031 .91247 L p F P
0 0 0 r
s
.54535 .91487 m .6031 .91247 L .64335 .91864 L p 1 0 0 r
F P
0 0 0 r
s
.7321 .23287 m .82736 .25343 L .76749 .2655 L .5 0 1 r
F
.67218 .24555 m .7321 .23287 L .76749 .2655 L 1 0 0 r
F
.91529 .91551 m .85402 .91782 L .82208 .91159 L p F P
0 0 0 r
s
.7607 .91401 m .82208 .91159 L .85402 .91782 L p 1 0 0 r
F P
0 0 0 r
s
.35267 .22932 m .45767 .25005 L .40303 .26222 L 0 1 1 r
F
.29826 .2421 m .35267 .22932 L .40303 .26222 L .5 0 1 r
F
.54535 .91487 m .48932 .91719 L .44239 .91091 L p 1 0 0 r
F P
0 0 0 r
s
.38653 .91335 m .44239 .91091 L .48932 .91719 L p 1 0 0 r
F P
0 0 0 r
s
.57204 .22458 m .67218 .24555 L .61405 .25785 L .5 0 1 r
F
.51398 .23751 m .57204 .22458 L .61405 .25785 L 1 0 0 r
F
.7607 .91401 m .70115 .91636 L .66264 .91001 L p F P
0 0 0 r
s
.6031 .91247 m .66264 .91001 L .70115 .91636 L p 1 0 0 r
F P
0 0 0 r
s
.18816 .22096 m .29826 .2421 L .24548 .25451 L 1 0 0 r
F
.79389 .2198 m .88906 .241 L .82736 .25343 L 0 1 1 r
F
.7321 .23287 m .79389 .2198 L .82736 .25343 L .5 0 1 r
F
.38653 .91335 m .33234 .91572 L .27849 .90931 L p 1 0 0 r
F P
0 0 0 r
s
.82208 .91159 m .88538 .90909 L .91529 .91551 L p 1 0 0 r
F P
0 0 0 r
s
.40878 .21613 m .51398 .23751 L .45767 .25005 L 0 1 1 r
F
.35267 .22932 m .40878 .21613 L .45767 .25005 L F
.6031 .91247 m .54535 .91487 L .50001 .90839 L p 1 0 0 r
F P
0 0 0 r
s
.44239 .91091 m .50001 .90839 L .54535 .91487 L p 1 0 0 r
F P
0 0 0 r
s
.63192 .21125 m .7321 .23287 L .67218 .24555 L 0 1 1 r
F
.57204 .22458 m .63192 .21125 L .67218 .24555 L .5 0 1 r
F
.82208 .91159 m .7607 .91401 L .72406 .90746 L p 1 0 0 r
F P
0 0 0 r
s
.66264 .91001 m .72406 .90746 L .7607 .91401 L p 1 0 0 r
F P
0 0 0 r
s
.24223 .20751 m .35267 .22932 L .29826 .2421 L 0 1 1 r
F
.18816 .22096 m .24223 .20751 L .29826 .2421 L 1 0 0 r
F
.79389 .2198 m .85763 .20631 L .88906 .241 L 0 1 1 r
F
.44239 .91091 m .38653 .91335 L .33409 .90675 L p 1 0 0 r
F P
0 0 0 r
s
.27849 .90931 m .33409 .90675 L .38653 .91335 L p 1 0 0 r
F P
0 0 0 r
s
.46668 .20253 m .57204 .22458 L .51398 .23751 L 0 1 1 r
F
.40878 .21613 m .46668 .20253 L .51398 .23751 L F
.66264 .91001 m .6031 .91247 L .55946 .90579 L p 1 0 0 r
F P
0 0 0 r
s
.50001 .90839 m .55946 .90579 L .6031 .91247 L p 1 0 0 r
F P
0 0 0 r
s
.69373 .19749 m .79389 .2198 L .7321 .23287 L .5 1 0 r
F
.63192 .21125 m .69373 .19749 L .7321 .23287 L 0 1 1 r
F
.88538 .90909 m .82208 .91159 L .78745 .90483 L p 1 0 0 r
F P
0 0 0 r
s
.72406 .90746 m .78745 .90483 L .82208 .91159 L p 1 0 0 r
F P
0 0 0 r
s
.29805 .19363 m .40878 .21613 L .35267 .22932 L 1 0 0 r
F
.24223 .20751 m .29805 .19363 L .35267 .22932 L 0 1 1 r
F
.50001 .90839 m .44239 .91091 L .39148 .90409 L p 1 0 0 r
F P
0 0 0 r
s
.33409 .90675 m .39148 .90409 L .44239 .91091 L p 1 0 0 r
F P
0 0 0 r
s
.52645 .18848 m .63192 .21125 L .57204 .22458 L .5 1 0 r
F
.46668 .20253 m .52645 .18848 L .57204 .22458 L 0 1 1 r
F
.72406 .90746 m .66264 .91001 L .62083 .90311 L p 1 0 0 r
F P
0 0 0 r
s
.55946 .90579 m .62083 .90311 L .66264 .91001 L p 1 0 0 r
F P
0 0 0 r
s
.75754 .18328 m .85763 .20631 L .79389 .2198 L 1 0 0 r
F
.69373 .19749 m .75754 .18328 L .79389 .2198 L .5 1 0 r
F
.33409 .90675 m .27849 .90931 L .22002 .90236 L p 1 0 0 r
F P
0 0 0 r
s
.95069 .90652 m .88538 .90909 L .8529 .90212 L p 1 0 0 r
F P
0 0 0 r
s
.78745 .90483 m .8529 .90212 L .88538 .90909 L p 1 0 0 r
F P
0 0 0 r
s
.35568 .17929 m .46668 .20253 L .40878 .21613 L 1 0 0 r
F
.29805 .19363 m .35568 .17929 L .40878 .21613 L F
.55946 .90579 m .50001 .90839 L .45075 .90136 L p F P
0 0 0 r
s
.39148 .90409 m .45075 .90136 L .50001 .90839 L p 1 0 0 r
F P
0 0 0 r
s
.58818 .17398 m .69373 .19749 L .63192 .21125 L 1 0 0 r
F
.52645 .18848 m .58818 .17398 L .63192 .21125 L .5 1 0 r
F
.78745 .90483 m .72406 .90746 L .68423 .90034 L p 1 0 0 r
F P
0 0 0 r
s
.62083 .90311 m .68423 .90034 L .72406 .90746 L p 1 0 0 r
F P
0 0 0 r
s
.75754 .18328 m .82346 .1686 L .85763 .20631 L 1 0 0 r
F
.39148 .90409 m .33409 .90675 L .27708 .89956 L p .5 0 1 r
F P
0 0 0 r
s
.22002 .90236 m .27708 .89956 L .33409 .90675 L p 1 0 0 r
F P
0 0 0 r
s
.45075 .90136 m .39148 .90409 L .34745 .43911 L p 0 1 1 r
F P
0 0 0 r
s
.34745 .43911 m .4051 .42892 L .45075 .90136 L p 0 1 1 r
F P
0 0 0 r
s
.27708 .89956 m .34745 .43911 L .39148 .90409 L p .5 0 1 r
F P
0 0 0 r
s
.4051 .42892 m .34745 .43911 L .29097 .41152 L p 1 0 0 r
F P
0 0 0 r
s
.34745 .43911 m .27708 .89956 L .21487 .89173 L p 0 1 1 r
F P
0 0 0 r
s
.21487 .89173 m .29097 .41152 L .34745 .43911 L p 0 1 1 r
F P
0 0 0 r
s
.8529 .90212 m .92052 .89931 L .95069 .90652 L p 1 0 0 r
F P
0 0 0 r
s
.41523 .16448 m .52645 .18848 L .46668 .20253 L 1 0 0 r
F
.35568 .17929 m .41523 .16448 L .46668 .20253 L F
.62083 .90311 m .55946 .90579 L .51199 .89853 L p F P
0 0 0 r
s
.45075 .90136 m .51199 .89853 L .55946 .90579 L p 1 0 0 r
F P
0 0 0 r
s
.65197 .15899 m .75754 .18328 L .69373 .19749 L 1 0 0 r
F
.58818 .17398 m .65197 .15899 L .69373 .19749 L F
.8529 .90212 m .78745 .90483 L .74975 .89748 L p .5 0 1 r
F P
0 0 0 r
s
.68423 .90034 m .74975 .89748 L .78745 .90483 L p 1 0 0 r
F P
0 0 0 r
s
.92052 .89931 m .8529 .90212 L .8013 .43175 L p 0 1 1 r
F P
0 0 0 r
s
.8013 .43175 m .86703 .42133 L .92052 .89931 L p 0 1 1 r
F P
0 0 0 r
s
.74975 .89748 m .8013 .43175 L .8529 .90212 L p .5 0 1 r
F P
0 0 0 r
s
.86703 .42133 m .8013 .43175 L .76419 .4035 L p 1 0 0 r
F P
0 0 0 r
s
.8013 .43175 m .74975 .89748 L .69838 .4145 L p .5 1 0 r
F P
0 0 0 r
s
.69838 .4145 m .76419 .4035 L .8013 .43175 L p .5 1 0 r
F P
0 0 0 r
s
.51199 .89853 m .45075 .90136 L .4051 .42892 L p 0 1 1 r
F P
0 0 0 r
s
.4051 .42892 m .46463 .4184 L .51199 .89853 L p 0 1 1 r
F P
0 0 0 r
s
.46463 .4184 m .4051 .42892 L .35023 .40041 L p 1 0 0 r
F P
0 0 0 r
s
.29097 .41152 m .35023 .40041 L .4051 .42892 L p 1 0 0 r
F P
0 0 0 r
s
.47679 .14917 m .58818 .17398 L .52645 .18848 L 1 0 0 r
F
.41523 .16448 m .47679 .14917 L .52645 .18848 L F
.68423 .90034 m .62083 .90311 L .5753 .8956 L p .5 0 1 r
F P
0 0 0 r
s
.51199 .89853 m .5753 .8956 L .62083 .90311 L p 1 0 0 r
F P
0 0 0 r
s
.74975 .89748 m .68423 .90034 L .63471 .42515 L p 0 1 1 r
F P
0 0 0 r
s
.63471 .42515 m .69838 .4145 L .74975 .89748 L p 0 1 1 r
F P
0 0 0 r
s
.5753 .8956 m .63471 .42515 L .68423 .90034 L p .5 0 1 r
F P
0 0 0 r
s
.69838 .4145 m .63471 .42515 L .58976 .39629 L p 1 0 0 r
F P
0 0 0 r
s
.63471 .42515 m .5753 .8956 L .52615 .40753 L p .5 1 0 r
F P
0 0 0 r
s
.52615 .40753 m .58976 .39629 L .63471 .42515 L p .5 1 0 r
F P
0 0 0 r
s
.71793 .14349 m .82346 .1686 L .75754 .18328 L 1 0 0 r
F
.65197 .15899 m .71793 .14349 L .75754 .18328 L F
.27708 .89956 m .22002 .90236 L .15631 .89478 L p F P
0 0 0 r
s
.76419 .4035 m .83224 .39212 L .86703 .42133 L p 1 0 0 r
F P
0 0 0 r
s
.5753 .8956 m .51199 .89853 L .46463 .4184 L p 0 1 1 r
F P
0 0 0 r
s
.46463 .4184 m .52615 .40753 L .5753 .8956 L p 0 1 1 r
F P
0 0 0 r
s
.52615 .40753 m .46463 .4184 L .41152 .38893 L p 1 0 0 r
F P
0 0 0 r
s
.35023 .40041 m .41152 .38893 L .46463 .4184 L p 1 0 0 r
F P
0 0 0 r
s
.54047 .13333 m .65197 .15899 L .58818 .17398 L 1 0 0 r
F
.47679 .14917 m .54047 .13333 L .58818 .17398 L F
.76419 .4035 m .69838 .4145 L .65555 .38467 L p F P
0 0 0 r
s
.58976 .39629 m .65555 .38467 L .69838 .4145 L p 1 0 0 r
F P
0 0 0 r
s
.71793 .14349 m .78617 .12745 L .82346 .1686 L 1 0 0 r
F
.15631 .89478 m .21487 .89173 L .27708 .89956 L p F P
0 0 0 r
s
.58976 .39629 m .52615 .40753 L .47494 .37705 L p 1 0 0 r
F P
0 0 0 r
s
.41152 .38893 m .47494 .37705 L .52615 .40753 L p 1 0 0 r
F P
0 0 0 r
s
.60637 .11694 m .71793 .14349 L .65197 .15899 L 1 0 0 r
F
.54047 .13333 m .60637 .11694 L .65197 .15899 L F
.83224 .39212 m .76419 .4035 L .72365 .37264 L p F P
0 0 0 r
s
.65555 .38467 m .72365 .37264 L .76419 .4035 L p 1 0 0 r
F P
0 0 0 r
s
.65555 .38467 m .58976 .39629 L .5406 .36474 L p 1 0 0 r
F P
0 0 0 r
s
.47494 .37705 m .5406 .36474 L .58976 .39629 L p 1 0 0 r
F P
0 0 0 r
s
.67461 .09997 m .78617 .12745 L .71793 .14349 L 1 0 0 r
F
.60637 .11694 m .67461 .09997 L .71793 .14349 L F
.72365 .37264 m .79418 .36017 L .83224 .39212 L p F P
0 0 0 r
s
.72365 .37264 m .65555 .38467 L .60864 .352 L p 1 0 0 r
F P
0 0 0 r
s
.5406 .36474 m .60864 .352 L .65555 .38467 L p 1 0 0 r
F P
0 0 0 r
s
.67461 .09997 m .74533 .08238 L .78617 .12745 L 1 0 0 r
F
.79418 .36017 m .72365 .37264 L .67918 .33878 L p F P
0 0 0 r
s
.60864 .352 m .67918 .33878 L .72365 .37264 L p 1 0 0 r
F P
0 0 0 r
s
.67918 .33878 m .75235 .32507 L .79418 .36017 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00002Qolc<c07ooooo001X
olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?l000000oo<c<`2o`000005olc<c?l0
003oc<c<olc<c?l000000oo<c<`00ol0003oc<c<olc<c02Nolc<c07ooooo001Xolc<c004o`000?o<
c<co0000olc<c0;o00000oo<c<`3o`000004olc<c?l0003oc<c<o`0000;oc<c<00Go0000olc<c?o<
c<coc<c<o`000019olc<c0?o0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<05;oc<c<0Oooool006Soc<c<00?o0000olc<c?o<c<`0
2_o<c<`00ol0003oc<c<o`00000Lolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Lolc<c0Co000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<
olc<c01Aolc<c07ooooo002Eolc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`06?o<
c<`4o`0000Goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c01@olc<c07ooooo002E
olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0000ooc<c<00?o0000
olc<c?o<c<`0Coo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c01>olc<c07ooooo002Folc<c003o`000?o<c<coc<c<00Coc<c<1Ol0000@olc<c0Co
00006Oo<c<`00ol0003oc<c<olc<c01=olc<c07ooooo002Golc<c003o`000?o<c<coc<c<00?oc<c<
00?o0000olc<c?o<c<`03oo<c<`3o`0000;oc<c<00?o0000olc<c?o<c<`06Oo<c<`00ol0003oc<c<
olc<c01<olc<c07ooooo002Holc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`02_o<
c<`4o`0002;oc<c<00?o0000olc<c?o<c<`0Boo<c<`1ooooo`00Too<c<`6o`0000Goc<c<1Ol00004
olc<c0Co000000?oc<c<o`000?o<c<`08oo<c<`00ol0003oc<c<olc<c01;olc<c07ooooo002Tolc<
c0?o00001Oo<c<`00ol0003oc<c<olc<c00Solc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<
c?o<c<`0?Oo<c<`1ooooo`00Loo<c<`4o`0002Woc<c<1Ol0000^olc<c003o`000?o<c<coc<c<00Wo
c<c<00?o0000olc<c?o<c<`0?Oo<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<c003o`00
0?o<c<coc<c<02;oc<c<1?l00004olc<c003o`000?o<c<coc<c<02goc<c<00?o0000olc<c?o<c<`0
2?o<c<`00ol0003oc<c<olc<c00molc<c07ooooo001golc<c003o`000?o<c<coc<c<01ooc<c<0ol0
000iolc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0?Oo<c<`1ooooo`00Moo<c<`0
0ol0003oc<c<olc<c00Kolc<c0Co00000_o<c<`00ol0003oc<c<olc<c00holc<c003o`000?o<c<co
c<c<00Koc<c<00?o0000olc<c?o<c<`0?Oo<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01Ooc<c<1?l00006olc<c003o`000?o<c<coc<c<03Ooc<c<0ol00007olc<
c003o`000?o<c<coc<c<03goc<c<0Oooool007;oc<c<1Ol0000Golc<c0?o00000_o<c<`00ol0003o
c<c<olc<c011olc<c003o`000?o<c<coc<c<00?oc<c<0ol0000oolc<c07ooooo001bolc<c003o`00
0?o<c<coc<c<01Goc<c<1?l0001:olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`0
?Oo<c<`1ooooo`00Loo<c<`00ol0003oc<c<olc<c00@olc<c0Co000000?oc<c<o`000?o<c<`0C?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<03goc<c<0Oooool007?oc<c<1Ol0000;
olc<c0?o0000E?o<c<`00ol0003oc<c<olc<c012olc<c07ooooo001oolc<c0Co000000?oc<c<o`00
0?o<c<`0EOo<c<`00ol0003oc<c<olc<c011olc<c07ooooo0019olc<c0Ko00000_o<c<`00ol0003o
c<c<olc<c004o`0002?oc<c<1?l0001Bolc<c0;oo`002Oo<c<`00ol0003oc<c<olc<c007olc<c0Ko
0000<oo<c<`1ooooo`00BOo<c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<coc<c<00;oc<c<
00?o0000olc<c?o<c<`07Oo<c<`3o`000003olc<c?l0003oc<c<04ooc<c<1ooo0009olc<c003o`00
0?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0=_o<c<`1ooooo`00B_o<c<`00ol0003oc<c<olc<
c00;olc<c003o`000?o<c<coc<c<01Woc<c<1?l00004olc<c003o`000?o<c<coc<c<04Woc<c<3Ooo
0009olc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0=Oo<c<`1ooooo`00Boo<c<`2
o`0000_oc<c<00?o0000olc<c?o<c<`05_o<c<`3o`000003olc<c?l0003oc<c<04goc<c<4_oo0008
olc<c003o`000?o<c<coc<c<00Ooc<c<0_l0000eolc<c07ooooo001=olc<c003o`000?o<c<coc<c<
00?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001?o<c<`00ol0
003oc<c<olc<c018olc<c1Ooo`002?o<c<`00ol0003oc<c<olc<c008olc<c003o`000?o<c<coc<c<
03;oc<c<0Oooool004koc<c<00?o0000olc<c?o<c<`00_o<c<`5o`00017oc<c<1Ol0001>olc<c1co
o`001oo<c<`2o`0000[oc<c<00?o0000olc<c?o<c<`0<Oo<c<`1ooooo`00BOo<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04?o<c<`3o`0000Coc<c<
00?o0000olc<c?o<c<`0B?o<c<`Qool000Soc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<coc<c<037oc<c<0Oooool004Woc<c<00?o0000olc<c?o<c<`00_o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00_oc<c<1Ol0001=olc<c2Koo`002?o<
c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`0<Oo<c<`1ooooo`00B_o<
c<`4o`0000Koc<c<1Ol00005olc<c0Co00001?o<c<`00ol0003oc<c<olc<c017olc<c2_oo`002?o<
c<`01?l0003oc<c<olc<c?o<c<`4o`0003Coc<c<0Oooool002ooc<c<1?l0000Xolc<c0?o000000?o
c<c<o`000?o<c<`0Boo<c<``ool000Soc<c<00?o0000olc<c?o<c<`0>?o<c<`1ooooo`00;_o<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<027oc<c<1?l0001=olc<c3Coo`002Oo<c<`0
0ol0003oc<c<olc<c007olc<c0Co0000;?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01goc<c<1?l000000oo<c<co0000olc<c01:olc<c3Woo`002?o<c<`00ol0
003oc<c<olc<c006olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04?o<c<`4o`00
0004olc<c?l0003oc<c<olc<c0Co00000_o<c<`01ol0003oc<c<olc<c?o<c<co0000olc<c?l00000
1?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01[oc<c<0ol0
001=olc<c3koo`002?o<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00;oc<c<00?o
0000olc<c?o<c<`03oo<c<`00ol0003oc<c<olc<c002olc<c0;o000000?oc<c<o`000?o<c<`00oo<
c<`00ol0003oc<c<o`000003olc<c003o`000?o<c<coc<c<00Coc<c<0Oooool002koc<c<00?o0000
olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Folc<c0Co000000?oc<c<o`000?o<c<`0BOo<c<a3
ool000Soc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003oc<c<olc<c00>olc<c003o`000?o<c<co
c<c<00Coc<c<00?o0000olc<c?l000001_o<c<`01Ol0003oc<c<olc<c?o<c<co000000Koc<c<0Ooo
ool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001Oo<c<`0
0ol0003oc<c<olc<c015olc<c4Ooo`002?o<c<`2o`0000Koc<c<0ol0000Aolc<c003o`000?o<c<co
c<c<00Coc<c<00?o0000olc<c?l000001Ol000000oo<c<co0000olc<c002olc<c003o`000?o<c<co
c<c<00Coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00?olc<
c0?o00000_o<c<`00ol0003oc<c<olc<c018olc<c4coo`001_o<c<`00ol0003oc<c<o`000009olc<
c003o`000?o<c<coc<c<00koc<c<00Co0000olc<c?o<c<coc<c<1?l000000oo<c<co0000olc<c003
olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<c<`00ol0
003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00_oc<c<1?l0001<olc<c57oo`002?o<c<`01Ol0
003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0003oc<c<olc<c006
olc<c003o`000?o<c<coc<c<00;oc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<olc<
c004olc<c07ooooo000_olc<c0Co00002_o<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`0AOo<c<aG
ool000Soc<c<00Co0000olc<c?o<c<co00001?o<c<`00ol0003oc<c<olc<c00>olc<c003o`000?o<
c<coc<c<00Coc<c<00?o0000olc<c?o<c<`01?l00002olc<c004o`000?o<c<co0000o`0000Ooc<c<
0Oooool003[oc<c<1?l00019olc<c5goo`001oo<c<`01?l0003oc<c<olc<c?o<c<`4o`0001;oc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c07ooooo000folc<c0Co00000oo<
c<`00ol0003oc<c<olc<c012olc<c6?oo`001oo<c<`00ol0003oc<c<olc<c00;olc<c003o`000?o<
c<coc<c<00Woc<c<1?l0000Eolc<c07ooooo000bolc<c0Co000000?oc<c<o`000?o<c<`0A_o<c<aV
ool000Soc<c<00?o0000olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c00Rolc<c07ooooo000_olc<
c0?o0000BOo<c<a[ool000Soc<c<00?o0000olc<c?o<c<`01Oo<c<`6o`0002?oc<c<0Oooool002go
c<c<0_l000000oo<c<co0000olc<c016olc<c3?oo`001?moo`0hool000Soc<c<00?o0000olc<c?o<
c<`01?o<c<`01Ol0003oc<c<olc<c?o<c<co000002Coc<c<0Oooool002goc<c<00Co0000olc<c?o<
c<co0000@oo<c<`bool000[oOol0>?oo0008olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<
c?o<c<co00009?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHnolc<c3;oo`004?moo`0R
ool000CoOol04_oo0006olc<c0?o00001_o<c<`00ol0003oc<c<o`00000Tolc<c07ooooo000]olc<
c0;o000000?oc<c<ofIVI_o<c<`0>Oo<c<`bool000Co0?oo4_moo`0Kool000[oOol04_oo0008olc<
c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?l000009?o<c<`1ooooo`00;Oo<c<`01?l0003o
c<c<olc<c?mVIVHfolc<c0Co0?oo;Ooo000:o`3ooa;oOol05Ooo000@ogoo01;oo`001oo<c<`00ol0
003oc<c<olc<c004olc<c0;o00009?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHaolc<
c0[o0?oo9ooo000@o`3ooa?oOol03_oo0004o`3ooa;oOol04_oo0007olc<c003o`000?o<c<coc<c<
00Coc<c<00?o0000olc<c?o<c<`08_o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVH/olc<
c13o0?oo8_oo000Eo`3ooa?oOol02?oo000:o`3ooa;oOol04_oo0007olc<c003o`000?o<c<coc<c<
00Soc<c<1?l0000Lolc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIRSoc<c<1?oo000Bo`3o
oagoo`006_l0oolBogoo00;oo`004?l0oolBogoo00ooo`000ol0ool7olc<c003o`000?o<c<coc<c<
00Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Iolc<c07ooooo000]olc<c004
o`000?o<c<coc<c<ofIVIRGoc<c<2?oo000Bo`3ooaSoo`007ol0ool?ogoo00CoO`3o4Ol0oolBogoo
00Woo`002Ol0ool7olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`06Oo<c<`1oooo
o`00;?o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV02;oc<c<3Ooo000Ao`3ooaCoo`008ol0ool;ogoo
00SoO`3o4Ol0oolBogoo00?oo`003ol0ool7olc<c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<
c?o<c<`06Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHPolc<c17oo`004_l0ool>ool0
02So0?oo1_moo`0=ogl0oa7o0?oo3omoo`03ogl0oa;o0?oo1_o<c<`2o`0000Goc<c<00?o0000olc<
c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Iolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIV
IR3oc<c<4ooo000Ao`3oo`Soo`00;_l0ool2ogoo017oO`3o4Ol0ool9ogoo00WoO`3o4_l0ool7olc<
c003o`000?o<c<coc<c<00;oc<c<1Ol0000Lolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIV
IR;oc<c<4ooo000@o`3oo`;oo`00<Ol0ool4ool001;oO`3o4Ol0ool3ogoo00ooO`3o4_l0ool6olc<
c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`07_o<c<`1ooooo`00;?o<c<`01?l0003o
c<c<olc<c?mVIVHSolc<c1?oo`003Ol0ool4ogl0obco0?oo2_oo000Bogl0o`ko0?oo1?oo000Aogl0
oa;o0?oo1_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01goc<c<0Oooool002co
c<c<0_l000000oo<c<coIVIVolc<c00Tolc<c1?oo`001ol0ool:ogl0obGo0?oo4?oo000Bogl0o`So
0?oo2_oo000Aogl0oa;o0?oo1_o<c<`01?l0003oc<c<olc<c?o<c<`5o`000003olc<c?l0003o0000
00;o00005_o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHWolc<c1;oo`000_l0ool?ogl0
ob3o0?oo5_oo000Aogl0o`;o0?oo4?oo000Aogl0o`oo0?oo0_oo0007olc<c003o`000?o<c<coc<c<
00Goc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Colc<c07ooooo000/olc<c004
o`000?o<c<coc<c<ofIVIRWoc<c<4_oo000Aogl0oaWo0?oo7?oo000>ogl0oaGoo`004Omo0?l9o`3o
o`Soo`001oo<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<
c?o<c<`04oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHZolc<c1?oo`004Omo0?lBo`3o
ob;oo`002?mo0?lKool0017oO`3o0ol0ool>ool000Ooc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0
003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01?oc<c<0Oooool002coc<c<00Co0000olc<c?o<
c<coIVIV7Oo<c<`00omVIVKoc<c<olc<c00<olc<c1;oo`004Omo0?l<o`3oobSoo`000_mo0?lQool0
00koO`3o5?oo0005olc<c0?o00001?o<c<`2o`0000?oc<c<00?o0000olc<c?o<c<`04oo<c<`1oooo
o`00;?o<c<`01?l0003oc<c<olc<c?mVIVHMolc<c003ofIVI_o<c<coc<c<00koc<c<4_oo000Aogl0
o`?o0?ooDooo0008ogl0oa[oo`001_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co0000
00;o00005_o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHMolc<c003ofIVI_o<c<coc<c<
013oc<c<4_oo000=ogl0oeWoo`000_mo0?lPool000Koc<c<00Go0000olc<c?o<c<coc<c<o`00000J
olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQgoc<c<00?oIVIVolc<c?o<c<`04_o<c<`A
ool000SoO`3oP?oo0006olc<c005o`000?o<c<coc<c<olc<c?l000000oo<c<`01?l0003oc<c<olc<
c?l0000Bolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQgoc<c<00?oIVIVolc<c?o<c<`0
5?o<c<`Aool000;oO`3oQOoo0006olc<c004o`000?o<c<coc<c<olc<c0?o00000oo<c<`00ol0003o
c<c<olc<c00@olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQgoc<c<00?oIVIVolc<c?o<
c<`05Oo<c<bEool000;oO`3o1oo<c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<coc<c<00oo
c<c<0Oooool002coc<c<0_l000000oo<c<coIVIVolc<c00Lolc<c003ofIVI_o<c<coc<c<01Ooc<c<
S_oo0008ogl0o`Ooc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c00?olc<c07ooooo
000[olc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`06Oo<c<b7ool000koO`3o
1_o<c<`2o`0000Soc<c<00?o0000olc<c?o<c<`03_o<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<
c?mVIVHNolc<c003ofIVI_o<c<coc<c<01_oc<c<Pooo000Aogl0o`Ooc<c<00?o0000olc<c?o<c<`0
1Oo<c<`00ol0003oc<c<olc<c00>olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQkoc<c<
00?oIVIVolc<c?o<c<`07?o<c<b3ool0017oO`3o0oo<c<`00omVIVKoc<c<olc<c009olc<c003o`00
0?o<c<coc<c<00goc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<
olc<c00Nolc<c8;oo`004Omo0?l2olc<c003ofIVI_o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`0
3?o<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHNolc<c003ofIVI_o<c<coc<c<023oc<c<
POoo000Aogl0o`03olc<c?mVIVKoc<c<00Koc<c<1_l0000>olc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIQgoc<c<00?oIVIVolc<c?o<c<`08_o<c<b1ool000koO`3o0oo<c<`00omVIVKoc<c<
olc<c00Iolc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQgoc<c<00?oIVIVolc<c?o<c<`0
9?o<c<b0ool000SoO`3o2?o<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIQgoc<c<00?oIVIVolc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00;olc<c83oo`00
0_mo0?l=olc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV
7Oo<c<`00omVIVKoc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<00goc<c<Nooo000Bolc<c003ofIV
I_o<c<coc<c<01Woc<c<0Oooool002_oc<c<0_mVIVH00ol0003oIVIVolc<c00Lolc<c003ofIVI_o<
c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`03oo<c<aJool000Co00005?oo000Iolc<c003ofIVI_o<
c<coc<c<01Woc<c<0Oooool0023oc<c<1?l00007olc<c004o`000?o<c<coIVIVofIVIQgoc<c<00?o
IVIVolc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Aolc<c5Coo`001?l00004ool00003o`000?oo
003oo`0000_oo`007oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000Oolc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c003ofIVIQ_oc<c<00?oIVIV
olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Bolc<c4koo`001Ol00009ool00003o`000?oo003o
o`0000?oo`001?o<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool0
01ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<
ofIVIP;oc<c<0_mVIVHIolc<c003ofIVI_o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`05?o<c<a8
ool000Co00003ooo00000ol0003oc<c<olc<c006olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIV
olc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<
00Coc<c<00Co0000olc<c?o<c<coIVIV1?o<c<`3ofIVIQKoc<c<00?oIVIVolc<c?o<c<`05oo<c<`0
0omVIVKoc<c<olc<c00Folc<c47oo`001Ol0000Dool00003o`000?o<c<coc<c<00Goc<c<00?oIVIV
olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH7olc<c0;oIVIV5?o<c<`0
0omVIVKoc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<01Soc<c<>Ooo0006o`0000Goo`0000?o0000
ool00?oo00004_oo00000ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIV
olc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<
00?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP09olc<c0;oIVIV4_o<c<`00omVIVKoc<c<olc<c00G
olc<c003ofIVI_o<c<coc<c<01[oc<c<<_oo0005o`0000coo`0000?o0000ool00?oo00004_oo0000
0ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1
ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<
c?o<c<coIVIV3?o<c<`2ofIVIQ3oc<c<00?oIVIVolc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00K
olc<c2_oo`001_l0000Bool00003o`000?oo003oo`0001;oo`0000?o0000olc<c?o<c<`00_o<c<`0
0omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool001ooc<c<00?o0000olc<
c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<ofIVIPkoc<c<0_mVIVH>
olc<c003ofIVI_o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`07Oo<c<`Tool000Go00001Ooo0000
0ol0003oo`00ool0000Aool000;o00004ooo00001Ol0003oc<c<olc<c?o<c<coIVIV02;oc<c<00?o
IVIVolc<c?o<c<`06?o<c<`1ooooo`008?o<c<`4o`0000Koc<c<00Co0000olc<c?o<c<coIVIV4?o<
c<`2ofIVIPcoc<c<00?oIVIVolc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Oolc<c1goo`001Ol0
000;ool000;o00004ooo00000ol0003oo`00ool0000>ool00003o`000?oo003oo`0000;o000000?o
c<c<ofIVI_o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c0;o000000?oc<c<
ofIVI_o<c<`04Oo<c<`2ofIVIP[oc<c<00?oIVIVolc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00B
olc<c003ofIVI_o<c<coc<c<00_oc<c<5_oo0006o`0001;oo`000_l0000Bool00003o`000?oo003o
o`0000Ooo`001_l00005ool00003o`000?mVIVKoc<c<027oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1
ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHDolc<c0;oIVIV2?o<c<`00omVIVKoc<c<olc<c00G
olc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`03Oo<c<`?ool000Go00001Ooo0002
o`0001?oo`0000?o0000ool00?oo00004?oo00001?l0003oo`00ool00?oo0005o`0000coo`0000?o
0000olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<co
c<c<ofIVIQKoc<c<0_mVIVH6olc<c003ofIVI_o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`04_o<
c<`00omVIVKoc<c<olc<c00?olc<c0Soo`001Ol0000<ool00003o`000?oo003oo`00017oo`000_l0
000=ool000;o00000_oo0003o`0001;oo`000_l0000Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Ooo
ool002[oc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`3ofIVIP?oc<c<00?oIVIVolc<c?o<c<`05oo<
c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<013oc<c<1ol0000Bool000;o00004ooo
00000ol0003oo`00ool00002ool000So00001_oo00000ol0003oo`00ool0000Bool00003o`000?o<
c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mV
IVHKolc<c0;oIVIV00?oc<c<ofIVI_o<c<`05oo<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<
c<coc<c<00Woc<c<1ol00006ool000;o00004ooo0002o`0001;oo`001?l0000?ool000;o00004ooo
00000ol0003oc<c<olc<c00Lolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000
olc<c?o<c<coIVIV7Oo<c<`2ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omVIVKoc<c<olc<
c003olc<c0Ko00003ooo0002o`0001?oo`0000?o0000ool00?oo00002?oo0005o`0000Coo`0000?o
0000ool00?oo00004?oo00000ol0003oo`00ool0000Aool00003o`000?o<c<coc<c<01_oc<c<00?o
IVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHNolc<c0?oIVIV5_o<
c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_l0003o000000?o00001?oo0002o`00017oo`000_l0
000Bool000;o00000ooo0005o`0000[oo`0000?o0000ool00?oo00004?oo00000ol0003oo`00ool0
000>ool00003o`000?oo003oo`0000;o00006oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Z
olc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`00_mVIVHDolc<c003ofIVI_o<
c<coc<c<00ooc<c<1Ol0000;ool000;o00004Ooo00000ol0003oo`00ool0000Aool000?o00004?oo
00000ol0003oo`00ool0000@ool000;o00002Ooo0005o`0000Goo`0000?o0000olc<c?o<c<`06?o<
c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?o
IVIVolc<c?o<c<`00_o<c<`2ofIVIQ;oc<c<00?oIVIVolc<c?o<c<`02oo<c<`4o`0001;oo`000_l0
000@ool000;o00002_oo0005o`0000CoOol000?o0000ool00?oo00003ooo0002o`0001;oo`0000Co
0000ool00?oo003oo`001Ol0000;ool00003o`000?o<c<coc<c<01Ooc<c<00?oIVIVolc<c?o<c<`0
6?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHMolc<c003ofIVI_o<c<coc<c<00Goc<c<
0_mVIVH@olc<c003ofIVI_o<c<coc<c<00Koc<c<1Ol00004ool000;o00004_oo00000ol0003oo`00
ool0000?ool000;o00000ooo0005o`0000[oOol00_l0000Aool00003o`000?oo003oo`0000goo`00
00?o0000ool00?oo00000ol0000Aool00003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`0
6?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHMolc<c003ofIVI_o<c<coc<c<00Ooc<c<
0_mVIVH>olc<c004ofIVI_o<c<coc<c<olc<c0Go00002ooo0002o`00017oo`000_l0000=ool000;o
00000_oo0003o`00017oOol000?o0000ool00?oo00003ooo00000ol0003oo`00ool00007ool000Go
00001Omoo`000ol0003oo`00ool0000@ool00003o`000?o<c<coc<c<01Goc<c<00?oIVIVolc<c?o<
c<`06?o<c<`1ooooo`00:_o<c<`2o`000003olc<c?mVIVKoc<c<01coc<c<00?oIVIVolc<c?o<c<`0
2Oo<c<`3ofIVIP_oc<c<00CoIVIVolc<c?l0003o00004_oo0002o`00017oo`000_l00004ool000Oo
00001?l0ool00ol0003oOol0ogoo000Bogoo0003o`000?oo003oo`0000ooo`0000Co0000ool00?oo
003oo`001Ol0000;ogoo0003o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`05?o<c<`00omV
IVKoc<c<olc<c00Holc<c07ooooo000Yolc<c005o`000?o<c<coc<c<olc<c?mVIVH07Oo<c<`00omV
IVKoc<c<olc<c00<olc<c0;oIVIV2Oo<c<`01?mVIVKoc<c<o`000?l0ool2o`0001;oo`0000?o0000
ool00?oo00004?oo0004o`0000_o0?oo00?o0000ogoo0?moo`004omoo`02o`0000coo`000ol00000
1?oo003o0000o`000?l0000Aogoo00;o00004Ooo00000ol0003oc<c<olc<c00Dolc<c003ofIVI_o<
c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<
c00>olc<c0;oIVIV1oo<c<`00omVIVKoc<c<o`000003o`3oo`;o00004Ooo0002o`0000Woo`001Ol0
000Ao`3oo`03o`000?moo`3oOol001GoOol000?o0000ool00?oo00000_oo0007o`0000Co0?oo00?o
0000ogoo0?moo`004omoo`000ol0003oo`00ool0000?ool00003o`000?o<c<coc<c<01?oc<c<1?mV
IVHFolc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`04?o<
c<`2ofIVIPGoc<c<00?oIVIVolc<c?l000001Ol0ool3o`00013oo`000_l00002ool000Go00005_l0
ool00ol0003oOol0ogoo000Fogoo00Co00002ol0ool00ol0003oOol0ogoo000Dogoo0003o`000?oo
003oo`0000Ooo`001Ol00002o`3oo`03o`000?o<c<coc<c<00coc<c<2?mVIVHIolc<c07ooooo000Y
olc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`04_o<c<`2ofIVIP?oc<c<00?o
IVIVo`000?l0ool02?l0ool2o`0000goo`0000?o0000ool00?oo00000_l0000<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`005_moo`000ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol001GoOol000Co0000ool00?oo003oo`001Ol00007o`3oo`03o`000?o<c<coc<c<00Koc<c<
1_mVIVH7olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV
7_o<c<`00omVIVKoc<c<olc<c00Dolc<c0;oIVIV00?oc<c<ofIVI_l000002ol0ool2o`0000Coo`00
1ol0000Ao`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`005Omoo`000ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol001KoOol00ol0000<o`3oo`03o`000?o<c<coIVIV00KoIVIV
3Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<
00?oIVIVolc<c?o<c<`05_o<c<`2ofIVIP03o`000?l0oooo0?oo00_o0?oo1?l0000Ho`3oo`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`005Omoo`000ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol001GoOol000?o0000o`3oool0ool03?l0ool00ol0003oIVIVolc<c00Colc<c003ofIV
I_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<
olc<c00Golc<c003ofIVI_l0003o0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0Ko`3oo`03o`000?moo`3oOol001GoOol000?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo000Eogoo0003o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`04_o<c<`00omVIVKoc<c<
olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`0
5oo<c<`00omVIVKo0000o`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
6ol0ool00ol0003oOol0ogoo000Dogoo00;o00003ol0ool00ol0003oOol0ogoo000Eogoo0003o`00
0?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo
000Yolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`05oo<c<`00omVIVKo0000
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol001CoOol000?o0000ogl0ool000003_l0ool00ol0003oOol0
ogoo000Eogoo0003o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`04_o<c<`00omVIVKoc<c<
olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`0
5oo<c<`00ol0003o0?ooo`3oo`0;o`3oo`;o00007?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol001CoOol000?o0000ogl0ool000003_l0ool00ol0003oOol0ogoo000Eogoo0003o`00
0?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo
000Yolc<c0;o000000?oc<c<ofIVI_o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Golc<c003o`000?l0
oooo0?oo00_o0?oo0_l0000Lo`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?mo
o`000ol0003oO`3oo`00000>o`3oo`03o`000?moo`3oOol001CoOol000?o0000ogl0ool000003_l0
ool00ol0003oc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000
olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<c00Golc<c003o`000?l0oooo0?oo00_o0?oo00?o
0000ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`005?moo`000ol0003oO`3oo`00000>o`3oo`03o`000?moo`3oOol001CoOol000?o
0000ogl0ool000003_l0ool00ol0003oc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<01Ooc<c<0Ooo
ool002Woc<c<00Co0000olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<c00Golc<c003o`000?l0
oooo0?oo00_o0?oo00?o0000ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`000ol0003oO`3oo`00000>o`3oo`03o`000?mo
o`3oOol001CoOol000?o0000ogl0ool000003_l0ool00ol0003oc<c<olc<c00Bolc<c003ofIVI_o<
c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<
c00Golc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0ool000003Ol0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`000ol0003oO`3oo`00
000>o`3oo`03o`000?moo`3oOol001CoOol000?o0000ogl0ool000003_l0ool00ol0003oc<c<olc<
c00Bolc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV7_o<
c<`00omVIVKoc<c<olc<c00Golc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0ool000003Ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?mo
o`000ol0003oO`3oo`00000?o`3oo`03o`000?moo`3oOol001?oOol000?o0000ogl0ool000003_l0
ool00ol0003oc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000
olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<c00Golc<c003o`000?l0oooo0?oo00_o0?oo00?o
0000ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`004_moo`001?l0003oO`3oogl0ool0000?o`3oo`03o`000?moo`3oOol001?oOol0
00?o0000ogl0ool000003ol0ool00ol0003oc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01Ooc<c<
0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omVIVKoc<c<olc<c00Folc<c003o`00
0?l0oooo0?oo00_o0?oo00Co0000ogl0oomo0?oo00003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004_moo`001?l0003oO`3oogl0ool0000?o`3o
o`03o`000?moo`3oOol001?oOol000?o0000ogl0ool000003ol0ool00ol0003oc<c<olc<c00Aolc<
c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omV
IVKoc<c<olc<c00Folc<c003o`000?l0oooo0?oo00_o0?oo00Co0000ogl0oomo0?oo00003Ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004_moo`00
1Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00
000?o`3oo`03o`000?o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:?o<c<`0
1?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<01Koc<c<00?o0000o`3oool0ool02ol0
ool01?l0003oO`3oogl0ool0000=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo000Bogoo0005o`000?mo0?ooO`3oogl0ool000003_l0ool00ol0003o
Ool0ogoo000Cogoo0003o`000?mo0?oo000000oo0?oo00?o0000olc<c?o<c<`04Oo<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<
c<`05oo<c<`00ol0003o0?ooo`3oo`0;o`3oo`04o`000?mo0?ooO`3oo`0000ko0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001;oOol000Go0000ogl0
oomo0?ooO`3oo`00000>o`3oo`03o`000?moo`3oOol001;oOol000Go0000ogl0oomo0?ooO`3oo`00
000>o`3oo`03o`000?o<c<coc<c<013oc<c<00?o0000olc<c?mVIVH06?o<c<`1ooooo`00:?o<c<`3
o`000003ofIVI_o<c<coc<c<01coc<c<00?oIVIVolc<c?o<c<`05oo<c<`00ol0003o0?ooo`3oo`0;
o`3oo`04o`000?mo0?ooO`3oo`0000ko0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol001;oOol000Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`00
0?moo`3oOol001;oOol000Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?o<c<coc<c<013o
c<c<00?o0000olc<c?mVIVH06?o<c<`1ooooo`007?o<c<`6o`0000Koc<c<0_mVIVH00oo<c<coIVIV
olc<c00Molc<c003ofIVI_o<c<coc<c<01Ooc<c<00?o0000o`3oool0ool02ol0ool01Ol0003oO`3o
ogl0oomo0?oo000000go0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol001;oOol000Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?moo`3oOol0
01;oOol000Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?o<c<coc<c<013oc<c<00?o0000
olc<c?mVIVH06?o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coIVIV
00;oIVIV7Oo<c<`00omVIVKoc<c<olc<c00Folc<c003o`000?l0oooo0?oo00co0?oo00Go0000ogl0
oomo0?ooO`3oo`00000=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000Bogoo0005o`000?mo0?ooO`3oogl0ool000003_l0ool00ol0003oOol0ogoo
000Bogoo0005o`000?mo0?ooO`3oogl0ool000003_l0ool00ol0003oc<c<olc<c00@olc<c003o`00
0?o<c<coIVIV01Soc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`02?o<c<`01Ol0003oc<c<olc<
c?mVIVKoc<c<00?oIVIV6_o<c<`00omVIVKoc<c<olc<c00Folc<c003o`000?l0oooo0?oo00_o0?oo
00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Aogoo0003o`000?mo0?ooO`3o00;oO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Aogoo0005o`000?mo0?ooO`3oogl0ool0
00003_l0ool00ol0003oc<c<olc<c00@olc<c003o`000?o<c<coIVIV01Soc<c<0Oooool001koc<c<
0_l00008olc<c004o`000?o<c<coc<c<ofIVIPCoc<c<0omVIVHGolc<c003ofIVI_o<c<coc<c<01Ko
c<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0017o
Ool000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0017o
Ool000Go0000ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?o<c<coc<c<00koc<c<00CoO`3oo`00
0?o<c<coIVIV6?o<c<`1ooooo`008?o<c<`00ol0003oc<c<olc<c005olc<c004o`000?o<c<coc<c<
ofIVIPOoc<c<0omVIVHDolc<c003ofIVI_o<c<coc<c<01Koc<c<00?o0000o`3oool0ool02ol0ool0
0ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0013oOol000?o0000ogl0oomo0?l00_mo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0017oOol000Go0000ogl0oomo0?ooO`3oo`00
000?o`3oo`03o`000?o<c<coc<c<00koc<c<00CoO`3oo`000?o<c<coIVIV6?o<c<`1ooooo`008Oo<
c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP[oc<c<0omVIVHAolc<c003ofIV
I_o<c<coc<c<01Koc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3oogl0o`02ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol0013oOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol0017oOol000Go0000ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?o<c<coc<c<00ko
c<c<00CoO`3oo`000?o<c<coIVIV6?o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV3Oo<c<`3ofIVIPkoc<c<00?oIVIVolc<
c?o<c<`05_o<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004?moo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004Omoo`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o0000olc<c?o<c<`03_o<c<`0
1?mo0?oo0000olc<c?mVIVHHolc<c07ooooo000Lolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000
olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH@olc<c0;oIVIV3?o<c<`00omVIVKoc<c<olc<
c00Eolc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000@ogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000@ogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<
c00>olc<c004ogl0ool0003oc<c<ofIVIQSoc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<
c<`00ol0003oc<c<olc<c002o`0000;oc<c<00?o0000olc<c?o<c<`02_o<c<`4o`0000Ooc<c<00Co
0000olc<c?o<c<coIVIV4_o<c<`3ofIVIPWoc<c<00?oIVIVolc<c?o<c<`05Oo<c<`00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3o
ogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3o
ogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`03_o<c<`01?mo0?oo0000
olc<c?mVIVHHolc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co
00006oo<c<`01?l0003oc<c<olc<c?mVIVHEolc<c0?oIVIV1_o<c<`00omVIVKoc<c<olc<c00Eolc<
c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c00=olc<
c0;oO`3o00?o0000olc<c?mVIVH06?o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c004
o`000?o<c<coc<c<o`0001[oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP0Holc<c0?oIVIV0oo<c<`0
0omVIVKoc<c<olc<c00Eolc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l01?mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003oc<c<olc<c00=olc<c0;oO`3o00?o0000olc<c?mVIVH06?o<c<`1ooooo`000oo<c<`00ol0
003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001[oc<c<0_l000000oo<c<coIVIVolc<c00K
olc<c0CoIVIV5oo<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`003omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogoo0?moo`003omoo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
olc<c?o<c<`03Oo<c<`2ogl0o`03o`000?o<c<coIVIV01Soc<c<0Oooool000?oc<c<1ol00002olc<
c003o`000?o<c<coc<c<01Soc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`3ofIVIQGoc<c<00?o0000
o`3oool0ool02ol0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ooOol000?o0000
ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000ooOol000?o0000
ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00coc<c<0_mo0?l0
0ol0003oc<c<ofIVIP0Holc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<
c?o<c<co00006_o<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<00;oIVIV4oo<
c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omo
o`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003omo
o`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`03?o<
c<`2ogl0o`03o`000?o<c<coIVIV01Soc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`0
0ol0003oc<c<o`000002o`0001Woc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omVIVKoc<c<olc<
c002olc<c0?oIVIV3oo<c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000olc<c?o<c<`03?o<c<`2ogl0o`03o`000?o<c<coIVIV01Soc<c<0Oooool000?oc<c<00?o0000
olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c00Holc<c004o`000?o<c<coc<c<ofIVIQooc<c<00?o
IVIVolc<c?o<c<`01Oo<c<`3ofIVIPcoc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0
o`04ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?o<c<coc<c<00_oc<c<0omo0?l00ol0003oc<c<ofIVIP0Holc<c07ooooo0003
olc<c0Oo00000_o<c<`00ol0003oc<c<olc<c00Holc<c004o`000?o<c<coc<c<ofIVIQooc<c<00?o
IVIVolc<c?o<c<`02?o<c<`3ofIVIPWoc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3oogl0
o`05ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?o<c<coc<c<00_oc<c<0omo0?l00ol0003oc<c<ofIVIP0Holc<c07ooooo000W
olc<c004o`000?o<c<coc<c<ofIVIQooc<c<00?oIVIVolc<c?o<c<`02oo<c<`3ofIVIPKoc<c<00?o
0000o`3oool0ool02ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o
0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o
0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00_oc<c<0omo
0?l00ol0003oc<c<ofIVIP04ofIVIQCoc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV7oo<
c<`00omVIVKoc<c<olc<c00>olc<c0?oIVIV0oo<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
0?ooO`3o00GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000olc<c?o<c<`02?o<c<`3ofIVIP?oO`3o00Co0000ofIVI_o<c<coIVIV
5oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<017oc<c<
0omVIVH00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
3Omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
3Omoo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?mVIVH0
2?mVIVH3olc<c0?oO`3o00Co0000olc<c?o<c<coIVIV5oo<c<`1ooooo`009oo<c<`01?l0003oc<c<
olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<01?oc<c<00?o0000o`3oool0ool03?l0ool00ol0003o
O`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00[oc<c<0omo0?l01?l0003oc<c<olc<c?mVIVHGolc<
c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`05?o<c<`00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003Omoo`000ol0
003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003Omoo`000ol0
003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02Oo<c<`4ogl0
o`04o`000?o<c<coc<c<ofIVIQOoc<c<0Oooool002Ooc<c<0_l000000oo<c<coIVIVolc<c00Molc<
c003ofIVI_o<c<coc<c<01Coc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`06ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?o<c<coc<c<00Woc<c<1?mo0?l01?l0003oc<c<olc<c?mVIVHGolc<c07ooooo000Wolc<
c004o`000?o<c<coc<c<ofIVIQkoc<c<00?oIVIVolc<c?o<c<`05?o<c<`00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`06
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`05
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`02Oo<c<`4ogl0o`04o`000?o<c<co
c<c<ofIVIQOoc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV7_o<c<`00omVIVKoc<c<olc<
c00Dolc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000=ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000=ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<
c009olc<c0CoO`3o00Co0000olc<c?o<c<coIVIV5oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<
c?mVIVHNolc<c003ofIVI_o<c<coc<c<01Coc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3o
ogl0o`07ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?o<c<coc<c<00Woc<c<1?mo0?l01?l0003oc<c<olc<c?mVIVHGolc<c07o
oooo000Volc<c005o`000?o<c<coc<c<olc<c?mVIVH07_o<c<`00omVIVKoc<c<olc<c00Colc<c003
o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000;ogoo0003
o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000<ogoo0003
o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c009olc<c0Co
O`3o00Co0000olc<c?o<c<coIVIV5oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHOolc<
c003ofIVI_o<c<coc<c<01?oc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`07ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?o<c<coc<c<00Woc<c<1?mo0?l01?l0003oc<c<olc<c?mVIVHGolc<c07ooooo000Volc<
c004o`000?o<c<coc<c<ofIVIQooc<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`08
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`02?o<c<`5ogl0o`04o`000?o<c<co
c<c<ofIVIQOoc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omVIVKoc<c<olc<
c00Colc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000;ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
000;ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<
c007olc<c0GoO`3o00Co0000olc<c?o<c<coIVIV5oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<
c?mVIVHOolc<c003ofIVI_o<c<coc<c<01?oc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3o
ogl0o`09ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?o<c<coc<c<00Ooc<c<1Omo0?l01?l0003oc<c<olc<c?mVIVHGolc<c07o
oooo000Volc<c004o`000?o<c<coc<c<ofIVIQooc<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0003o
O`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003o
O`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`01oo<c<`5ogl0o`04
o`000?o<c<coc<c<ofIVIQOoc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omV
IVKoc<c<olc<c00Colc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oc<c<olc<c007olc<c0GoO`3o00Co0000olc<c?o<c<coIVIV5oo<c<`1ooooo`009_o<c<`2o`00
0003olc<c?mVIVKoc<c<01koc<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`08ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`01oo<c<`5ogl0o`04o`000?o<c<coc<c<
ofIVIQOoc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omVIVKoc<c<olc<c00B
olc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000:
ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000:
ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c006
olc<c0KoO`3o00Co0000olc<c?o<c<coIVIV5oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mV
IVHOolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0
o`09ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?o<c<coc<c<00Koc<c<1_mo0?l01?l0003oc<c<olc<c?mVIVHGolc<c07ooooo
000Volc<c004o`000?o<c<coc<c<ofIVIQooc<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3o
ogl0o`0:ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3o
ogl0o`09ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`01_o<c<`6ogl0o`05o`00
0?o<c<coc<c<olc<c?mVIVH05_o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003
ofIVI_o<c<coc<c<01;oc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3oogl0o`0:ogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?o<c<coc<c<00Koc<c<1_mo0?l01Ol0003oc<c<olc<c?o<c<coIVIV01Koc<c<0Oooool002Ko
c<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo
00_o0?oo00?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o
00[oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o
00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c005olc<c0KoO`3o00Go0000olc<
c?o<c<coc<c<ofIVIP0Folc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQooc<c<00?oIVIV
olc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
olc<c?o<c<`01Oo<c<`6ogl0o`05o`000?o<c<coc<c<olc<c?mVIVH05_o<c<`1ooooo`009_o<c<`0
1?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<017oc<c<00?o0000o`3oool0ool03?l0
ool00ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l02_mo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l02Omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00Coc<c<1omo0?l01Ol0003oc<c<olc<
c?o<c<coIVIV01Koc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7oo<c<`00omVIVKoc<c<
olc<c00Aolc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0009ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo0009ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<
olc<c004olc<c0OoO`3o00Go0000olc<c?o<c<coc<c<ofIVIP0Folc<c07ooooo000Uolc<c004o`00
0?o<c<coc<c<ofIVIR3oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0;ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`09ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`01?o<c<`7ogl0o`05o`000?o<c<coc<c<olc<
c?mVIVH05_o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHPolc<c003ofIVI_o<c<coc<c<
017oc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
00SoOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
00WoOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<
00Coc<c<1omo0?l01Ol0003oc<c<olc<c?o<c<coIVIV01Koc<c<0Oooool001goc<c<00?o0000olc<
c?o<c<`01Oo<c<`4ofIVIQooc<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0<ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0;ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`01?o<c<`7ogl0o`05o`000?o<c<coc<c<
olc<c?mVIVH05_o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<
00CoIVIV7?o<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0
oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003oc<c<olc<c004olc<c0OoO`3o00Go0000olc<c?o<c<coc<c<ofIVIP0F
olc<c07ooooo000Iolc<c0Ko00001_o<c<`01?l0003oc<c<olc<c?mVIVH3olc<c0CoIVIV6?o<c<`0
0omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l03?mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003oc<c<olc<c003olc<c0SoO`3o00Go0000olc<c?o<c<coc<c<ofIVIP0Folc<c07ooooo000I
olc<c005o`000?o<c<coc<c<olc<c?l000001oo<c<`01?l0003oc<c<olc<c?mVIVH7olc<c0GoIVIV
4oo<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l0
3?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oc<c<olc<c002olc<c0OoO`3o00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<
olc<c00Dolc<c07ooooo000Jolc<c004o`000?o<c<coc<c<o`0000Ooc<c<00Co0000olc<c?o<c<co
IVIV3?o<c<`4ofIVIPooc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0<ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0;ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`00_o<c<`7ogl0o`03o`000?o<c<coc<c<00;o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c004o`00
0?o<c<coc<c<ofIVIQ3oc<c<1?mVIVH;olc<c003ofIVI_o<c<coc<c<017oc<c<00?o0000o`3oool0
ool03?l0ool00ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo
0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo
0?l02omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00;oc<c<1omo0?l00ol0003o
c<c<olc<c002olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001_oc<c<00?o0000olc<c?l00000
1oo<c<`01?l0003oc<c<olc<c?mVIVHDolc<c0CoIVIV1oo<c<`00omVIVKoc<c<olc<c00Aolc<c003
o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003
o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0007ogoo0003
o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c002olc<c0Oo
O`3o00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Lolc<c0;o0000
1oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c0CoIVIV0oo<c<`00omVIVKoc<c<olc<c00Aolc<c003
o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003
o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0007ogoo0003
o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c002olc<c0Oo
O`3o00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Molc<c003o`00
0?o<c<coc<c<00Goc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`4ofIVIQ;oc<c<00?o0000o`3oool0
ool03?l0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo
0?l03Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo
0?l02omo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?o<c<coc<c<olc<c0SoO`3o00?o0000olc<
c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIV
IQooc<c<1_mVIVH=olc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03?l0ool01?l0
003oc<c<olc<c?o<c<`8ogl0o`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1
ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<00?oc<c<1?mVIVH9
olc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006
ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006
ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03?l0ool01?l0003oc<c<olc<c?o<
c<`8ogl0o`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`0
1?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<00Ooc<c<1?mVIVH5olc<c003o`000?l0
oooo0?oo00co0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo
0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo
0?ooO`3o00goO`3o00?o0000o`3oool0ool03?l0ool01?l0003oc<c<olc<c?o<c<`8ogl0o`03o`00
0?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009Oo<c<`2o`000003olc<c?mV
IVKoc<c<01koc<c<00?oIVIVolc<c?o<c<`02oo<c<`4ofIVIP03olc<c?l0003o0?oo00go0?oo00?o
0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00koO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00goO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c008ogl0o`03o`000?o<c<coc<c<00OoIVIV4_o<
c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<coc<c<00ooc<c<00?o
IVIVo`000?l0ool03?l0ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000GoOol000?o
0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000GoOol000?o
0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coIVIV00SoO`3o00?o
0000ofIVI_mVIVH00oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<co
c<c<ofIVIR3oc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
0?ooO`3o00ooO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ofIVI_mo0?l02?mo0?l00ol0003oc<c<olc<c003olc<c003ofIVI_o<
c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV8?o<c<`00omVIVKoc<c<olc<
c00?olc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0004ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
0005ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<ogl0
o`08ogl0o`03o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`0
1?l0003oc<c<olc<c?mVIVHPolc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000o`3oool0ool03?l0
ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l03Omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coO`3o00SoO`3o00?o0000olc<c?o<c<`00oo<
c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?o
IVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000olc<c?mo0?l02?mo0?l00ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<01?oc<c<0Ooo
ool002Coc<c<00Co0000olc<c?o<c<coIVIV8?o<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0
oooo0?oo00co0?oo00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo
0?ooO`3o013oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo
0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<ogl0o`08ogl0o`03o`000?o<
c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mV
IVHPolc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0
o`0@ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000?oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?o<c<coO`3o00SoO`3o00?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<
c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?oIVIVolc<c?o<c<`03_o<
c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?mo
o`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000omo
o`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo
0?l00ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000
olc<c?o<c<coIVIV8?o<c<`00omVIVKoc<c<olc<c00>olc<c003o`000?l0oooo0?oo00co0?oo00?o
0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o013oO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<coc<c<00?oc<c<00?o
IVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<
c<coc<c<00ooc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Aogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000?oOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000?oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
0?ooO`3o00OoO`3o00?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000T
olc<c0;o000000?oc<c<ofIVI_o<c<`07_o<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo
0?oo00co0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?oo
O`3o017oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?oo
O`3o00ooO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<co
c<c<00?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHO
olc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0A
ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?moo`3oOol000?oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00C
olc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQooc<c<00?oIVIVolc<c?o<c<`03oo<c<`0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`00
0ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000omoo`00
0ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l0
0ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<
c?o<c<coIVIV7oo<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo00co0?oo00?o0000
ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o017oO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<coc<c<00?oc<c<00?oIVIV
olc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHOolc<c003ofIVI_o<c<co
c<c<00koc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000;oOol000?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000;oOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?oo
O`3o00OoO`3o00?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<
c004o`000?o<c<coc<c<ofIVIQooc<c<00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0B
ogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000ogoo0?moo`3oOol0o`00000Cogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<c003olc<c003ofIVI_o<
c<coc<c<01?oc<c<0Oooool002?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP0Oolc<c003ofIVI_o<
c<coc<c<00koc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000;oOol000?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?mo
o`3oOol0ogoo0?l000004omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o
00?o0000olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Solc<c004o`000?o<
c<coc<c<ofIVIR3oc<c<00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Eogl0o`03o`000?l0oooo0?oo00go
0?oo00Go0000ogoo0?moo`3oOol0o`00000Cogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0
oomo0?l01_mo0?l00ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?o
c<c<00Co0000olc<c?o<c<coIVIV8?o<c<`00omVIVKoc<c<olc<c00>olc<c003o`000?l0oooo0?oo
00co0?oo00?o0000ogl0oomo0?l04omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool03?l0ool01Ol0003oOol0ogoo0?moo`3o000001GoO`3o00?o0000
o`3oool0ool03Ol0ool01Ol0003oOol0ogoo0?moo`3o000001?oO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`04_o<
c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHPolc<c003ofIVI_o<c<coc<c<00koc<c<00?o
0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`000?moo`3oOol0ogoo0?l00000
5Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?moo`3oOol0ogoo0?l000004omo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`01?o<c<`00omVIVKo
c<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?oIVIVolc<c?o<
c<`03Oo<c<`00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?mo
o`3oOol0o`00000Eogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000ogoo0?moo`3oOol0o`00000C
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oc<c<olc<c004
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV8?o<c<`0
0omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l05?mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
1?l0003oOol0ogoo0?l0000Eogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000ogoo0?moo`3oOol0
o`00000Cogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oc<c<
olc<c004olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<0_l000000oo<c<coIVIVolc<
c00Oolc<c003ofIVI_o<c<coc<c<00goc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0
o`0Dogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`04o`000?moo`3oOol0o`0001GoO`3o00?o0000o`3oool0ool03Ol0ool01Ol0003oOol0
ogoo0?moo`3o000001?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`06ogl0o`03
o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<
olc<c?mVIVHPolc<c003ofIVI_o<c<coc<c<00goc<c<00?o0000o`3oool0ool03?l0ool00ol0003o
O`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`04o`000?moo`3oOol0o`0001GoO`3o00?o0000o`3oool0ool03Ol0ool01?l0
003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01_mo0?l0
0ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<
c?o<c<coIVIV8?o<c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00co0?oo00?o0000
ogl0oomo0?l05Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Fogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?l000005Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o
0000olc<c?o<c<`01?o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<co
c<c<ofIVIR3oc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
0?ooO`3o01GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?l000005omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3o000001GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<
c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mV
IVHPolc<c003ofIVI_o<c<coc<c<00coc<c<00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0
o`0Eogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3o000001OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00
000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<
c004olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV8?o<
c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l05Omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0o`00000Gogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005Omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<c<`01?o<
c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?o
IVIVolc<c?o<c<`03?o<c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?l000005omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001GoO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<00Coc<c<00?o
IVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHPolc<c003ofIVI_o<
c<coc<c<00coc<c<00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Fogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3o000001OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00000Eogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<c004olc<c003ofIVI_o<
c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV8?o<c<`00omVIVKoc<c<olc<
c00<olc<c003o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l05_mo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0o`00
000Gogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005Omo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<c<`01?o<c<`00omVIVKoc<c<olc<
c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?oIVIVolc<c?o<c<`03?o<
c<`00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?l000005omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001GoO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`04_o<
c<`1ooooo`008_o<c<`01?l0003oc<c<olc<c?mVIVHPolc<c003ofIVI_o<c<coc<c<00goc<c<00?o
0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`;o00005omo0?l00ol0003o0?ooo`3o
o`0=o`3oo`;o00005_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o
0000olc<c?o<c<`01?o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Golc<c0Co00001oo<c<`0
1?l0003oc<c<olc<c?mVIVHPolc<c003ofIVI_o<c<coc<c<00coc<c<00?o0000o`3oool0ool03Ol0
ool00ol0003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01OoO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l01Omo
0?l00ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o0000
olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c0KoIVIV7_o<c<`00omVIVKoc<c<olc<c00<
olc<c003o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l05omo0?l00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0G
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l05Omo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000olc<c?o<c<`01?o<c<`00omVIVKoc<c<olc<c00B
olc<c07ooooo000Folc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0
003oc<c<olc<c?mVIVH2olc<c0WoIVIV5Oo<c<`00omVIVKo0000o`00000Ao`0000[o0?oo00?o0000
ogl0oomo0?l06?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogl0oomo0?l05Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000
olc<c?o<c<`01?o<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Folc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH;olc<c0WoIVIV3?o<c<`0
0omVIVKoc<c<olc<c003olc<c0?o00002ooo0007o`0000?o0?oo00?o0000ogl0oomo0?l06?mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00Co0?oo5ol0000Iogl0o`03o`000?l0oooo
0?oo00Go0?oo2Ol0000Gogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01?mo0?l0
0ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool001Koc<c<0_l00003olc<
c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`9ofIVIP?oc<c<00?oIVIV
olc<c?o<c<`02_o<c<`;o`0000?oo`001?l0000Jogl0o`03o`000?l0oooo0?oo00Co0?oo3_l0000;
ool000Ko00003?oo0007o`0000coO`3o2?l0000;ool000Go00004?mo0?lEo`0000;oO`3o00?o0000
olc<c?o<c<`01Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo000Folc<c003o`000?o<c<co0000
00;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHMolc<c0WoIVIV3oo<c<`7o`0000[oo`001ol0000<
ogl0o`Oo00002ooo0005o`0000ooo`002Ol0000;ool000Go00003?oo0008o`0000[oo`002Ol0000:
ool000Co00003_oo0003o`0000Ooc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`005_o<c<`00ol0
003oc<c<olc<c009olc<c004o`000?o<c<coc<c<ofIVIR3oc<c<00?oIVIVolc<c?o<c<`00oo<c<`9
ofIVIPcoc<c<00?oIVIVo`000?l000001ol0000:ool000Oo00002_oo0007o`0000Woo`002_l0000;
ool000Go00003_oo0009o`0000[oo`001?l0000=ool000So00002Ooo0009o`0000ooc<c<00?oIVIV
olc<c?o<c<`04Oo<c<`1ooooo`005oo<c<`01Ol0003oc<c<olc<c?o<c<co000002[oc<c<00?oIVIV
olc<c?o<c<`03?o<c<`9ofIVIP?oc<c<00?oIVIVolc<c?o<c<`02?o<c<`6o`0000[oo`002Ol0000:
ool000Go00002ooo0007o`0000[oo`002?l0000:ool000Go00003_oo0009o`0000[oo`000ol0000>
ool000?o00001Oo<c<`?ofIVIPooc<c<0Oooool001Soc<c<0ol0000[olc<c003ofIVI_o<c<coc<c<
01Goc<c<2OmVIVH>olc<c0Go00002ooo0006o`0000Woo`002Ol0000:ool000Go00002ooo0007o`00
00Woo`002?l0000<ool000Oo00002Ooo0009o`0000goIVIV2_o<c<`00omVIVKoc<c<olc<c00Aolc<
c07ooooo0016olc<c003ofIVI_o<c<coc<c<01Soc<c<00?oIVIVolc<c?o<c<`00oo<c<`9ofIVIPWo
c<c<00?oIVIVo`000?l000001ol0000:ool000Go00002_oo0007o`0000Woo`002?l0000<ool000Oo
00001ooo000:o`0000koIVIV00?oc<c<ofIVI_o<c<`08_o<c<`00omVIVKoc<c<olc<c00Aolc<c07o
oooo001Qolc<c003ofIVI_o<c<coc<c<00coc<c<2_mVIVH9olc<c0Ko00002Ooo0008o`0000coo`00
1_l00007ool000[o00003OmVIVHMolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`0
4Oo<c<`1ooooo`00HOo<c<`00omVIVKoc<c<olc<c00Eolc<c0WoIVIV1_o<c<`00omVIVKoc<c<olc<
c003olc<c0Go00001ooo000:o`0000[oIVIV5oo<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<
c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`00HOo<c<`00omVIVKoc<c<olc<c00E
olc<c003ofIVI_o<c<coc<c<00Koc<c<4OmVIVHBolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIV
olc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00eolc<c07ooooo001iolc<c003ofIVI_o<c<coc<c<
00coc<c<00?oIVIVolc<c?o<c<`06_o<c<`00omVIVKoc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<
05Ooc<c<0Oooool007Woc<c<00?oIVIVolc<c?o<c<`03?o<c<`00omVIVKoc<c<olc<c00Jolc<c003
ofIVI_o<c<coc<c<07Ooc<c<0Oooool008Soc<c<00?oIVIVolc<c?o<c<`0U?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo0035olc<c0;o0000F?o<c<`1ooooo`00a_o<c<`2o`0000;oc<c<00?o0000olc<c?o<c<`0D_o<
c<`1ooooo`00aoo<c<`2o`0000;oc<c<00?o0000olc<c?o<c<`0DOo<c<`1ooooo`00?oo<c<`5o`00
00Coc<c<0ol00003olc<c0;o00000oo<c<`3o`0000;oc<c<1?l00003olc<c0Go00000oo<c<`2o`00
00Coc<c<0_l00002olc<c0?o000000?oc<c<o`000?l000000_o<c<`2o`0000;oc<c<1?l00003olc<
c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00001?o<c<`2o`0000?oc<c<0_l000000oo<
c<co0000o`000002olc<c0Co00000oo<c<`3o`0000?oc<c<0ol00003olc<c0;o00001?o<c<`3o`00
0003olc<c?l0003o000000Ooc<c<1?l000001?o<c<co0000olc<c?o<c<`4o`0000;oc<c<0_l00002
olc<c0;o000000?oc<c<o`000?l000001Oo<c<`4o`0002coc<c<0Oooool003koc<c<0_l00003olc<
c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00000_o<c<`2o`00
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<
c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`00
0?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<
c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00003olc<c0;o000000Coc<c<o`00
0?l0003oc<c<0_l00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002
olc<c0;o00001?o<c<`3o`000003olc<c?l0003o000000Koc<c<0_l00002olc<c0?o000000?oc<c<
o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000004
olc<c0;o00000_o<c<`2o`0002_oc<c<0Oooool003koc<c<0_l00003olc<c0;o000000?oc<c<o`00
0?l000000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l00002olc<c0;o00001Oo<c<`2o`00
00;oc<c<0_l00003olc<c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`00
0003olc<c?l0003o000000Soc<c<0ol00004olc<c0?o000000?oc<c<o`000?l000002?o<c<`3o`00
00?oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000001?o<c<`3o`0000;oc<c<0_l00002olc<
c0;o00000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<
c0;o00001?o<c<`2o`000003olc<c?l0003o000000Goc<c<0_l00002olc<c0;o00001oo<c<`2o`00
00;oc<c<0_l0000[olc<c07ooooo0012olc<c0?o000000?oc<c<o`000?l000000oo<c<`2o`000003
olc<c?l0003o000000?oc<c<0_l00002olc<c0Ko000000?oc<c<o`000?l000000_o<c<`2o`0000?o
c<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l0
00001?l00002olc<c0Co00000oo<c<`4o`0000;oc<c<1_l00002olc<c0Co00001?o<c<`2o`0000?o
c<c<0_l000000oo<c<co0000o`000002olc<c0Co00000oo<c<`2o`0000;oc<c<0_l00003olc<c0;o
000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o000000Ooc<c<0_l00004olc<c0;o
000000?oc<c<o`000?l000001?l000000oo<c<co0000o`000002olc<c0;o00001oo<c<`2o`0000;o
c<c<0_l0000[olc<c07ooooo000oolc<c0Go00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000
o`000003olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o0000
0oo<c<`5o`000003olc<c?l0003o000000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0_l000001?o<c<co0000o`000?l00004olc<c0?o00001?o<c<`2o`0000;o
c<c<0_l000001?o<c<co0000o`000?l00006olc<c0;o00000oo<c<`2o`000004olc<c?l0003o0000
olc<c0?o00001Oo<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2
o`000003olc<c?l0003o000000Ooc<c<0_l00002olc<c0Co000000?oc<c<o`000?l000000_o<c<`2
o`000003olc<c?l0003o000000;oc<c<0_l00007olc<c0;o00000_o<c<`2o`0002_oc<c<0Oooool0
03koc<c<0ol00006olc<c0;o000000?oc<c<o`000?l000000_o<c<`3o`0000;oc<c<0_l00002olc<
c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00001?o<c<`2o`00
00;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<
c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o0000
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`7o`000004olc<c?l0003o0000
olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`3
o`0000;oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001oo<c<`2o`0000;oc<c<0_l00000
0oo<c<co0000o`000002olc<c0;o00001oo<c<`5o`0002coc<c<0Oooool003koc<c<0_l00003olc<
c0;o00000oo<c<`3o`0000?oc<c<0ol000000oo<c<co0000o`000002o`0000;oc<c<1?l00003olc<
c0Go00000oo<c<`2o`0000Coc<c<0_l000000oo<c<co0000o`000002o`000003olc<c?l0003o0000
00?o00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00004olc<
c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<1?l00002olc<c0Co00000oo<c<`3o`00
00?oc<c<0ol000000oo<c<co0000o`000003olc<c0;o00001_o<c<`2o`0000Coc<c<0_l00002olc<
c0Co00000_o<c<`5o`0000Soc<c<0_l0000_olc<c07ooooo000nolc<c0;o00000oo<c<`2o`0000ko
c<c<0_l0000=olc<c0;o00000oo<c<`2o`0000Soc<c<0_l0000^olc<c0;o00000oo<c<`2o`0000co
c<c<0_l0000Lolc<c0;o00000_o<c<`2o`0001Koc<c<0_l00002olc<c0;o0000:oo<c<`1ooooo`00
?oo<c<`5o`0000ooc<c<0_l0000=olc<c0;o00000oo<c<`8o`0000;oc<c<0_l0000^olc<c0;o0000
0oo<c<`2o`000003olc<c?l0003o000000Woc<c<0_l0000Molc<c0Co00006?o<c<`4o`0002coc<c<
0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?oo
c<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1
ooooo`00ooo<c<`Polc<c07ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 6, 6, 6, 6, 6, 1, 6, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(5.5`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 0.0147151 5.88604 [
[.21429 .00222 -3 -9 ]
[.21429 .00222 3 0 ]
[.40476 .00222 -3 -9 ]
[.40476 .00222 3 0 ]
[.59524 .00222 -3 -9 ]
[.59524 .00222 3 0 ]
[.78571 .00222 -3 -9 ]
[.78571 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(3)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(4)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(5)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(6)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.21429 .60332 L
.40476 .60332 L
.59524 .60332 L
.78571 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 0.0147151 2.94302 [
[.21429 .00222 -3 -9 ]
[.21429 .00222 3 0 ]
[.40476 .00222 -3 -9 ]
[.40476 .00222 3 0 ]
[.59524 .00222 -3 -9 ]
[.59524 .00222 3 0 ]
[.78571 .00222 -3 -9 ]
[.78571 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .16187 -24 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -24 -4.5 ]
[.01131 .45617 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(3)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(4)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(5)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(6)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .16187 m
.03006 .16187 L
s
[(0.05)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.1)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.15)] .01131 .45617 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.21429 .30902 L
.40476 .30902 L
.59524 .30902 L
.78571 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 -0.377687 0.981006 [
[.21429 .59082 -3 -9 ]
[.21429 .59082 3 0 ]
[.40476 .59082 -3 -9 ]
[.40476 .59082 3 0 ]
[.59524 .59082 -3 -9 ]
[.59524 .59082 3 0 ]
[.78571 .59082 -3 -9 ]
[.78571 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -18 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .11282 -18 -4.5 ]
[.01131 .11282 0 4.5 ]
[.01131 .21092 -18 -4.5 ]
[.01131 .21092 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .40712 -18 -4.5 ]
[.01131 .40712 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .60332 m
.21429 .60957 L
s
[(2)] .21429 .59082 0 1 Mshowa
.40476 .60332 m
.40476 .60957 L
s
[(3)] .40476 .59082 0 1 Mshowa
.59524 .60332 m
.59524 .60957 L
s
[(4)] .59524 .59082 0 1 Mshowa
.78571 .60332 m
.78571 .60957 L
s
[(5)] .78571 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(6)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.0619 .60332 m
.0619 .60707 L
s
.1 .60332 m
.1 .60707 L
s
.1381 .60332 m
.1381 .60707 L
s
.17619 .60332 m
.17619 .60707 L
s
.25238 .60332 m
.25238 .60707 L
s
.29048 .60332 m
.29048 .60707 L
s
.32857 .60332 m
.32857 .60707 L
s
.36667 .60332 m
.36667 .60707 L
s
.44286 .60332 m
.44286 .60707 L
s
.48095 .60332 m
.48095 .60707 L
s
.51905 .60332 m
.51905 .60707 L
s
.55714 .60332 m
.55714 .60707 L
s
.63333 .60332 m
.63333 .60707 L
s
.67143 .60332 m
.67143 .60707 L
s
.70952 .60332 m
.70952 .60707 L
s
.74762 .60332 m
.74762 .60707 L
s
.82381 .60332 m
.82381 .60707 L
s
.8619 .60332 m
.8619 .60707 L
s
.9 .60332 m
.9 .60707 L
s
.9381 .60332 m
.9381 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.4)] .01131 .01472 1 0 Mshowa
.02381 .11282 m
.03006 .11282 L
s
[(0.5)] .01131 .11282 1 0 Mshowa
.02381 .21092 m
.03006 .21092 L
s
[(0.6)] .01131 .21092 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.7)] .01131 .30902 1 0 Mshowa
.02381 .40712 m
.03006 .40712 L
s
[(0.8)] .01131 .40712 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(0.9)] .01131 .50522 1 0 Mshowa
.125 Mabswid
.02381 .03434 m
.02756 .03434 L
s
.02381 .05396 m
.02756 .05396 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .0932 m
.02756 .0932 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .15206 m
.02756 .15206 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .23054 m
.02756 .23054 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .26978 m
.02756 .26978 L
s
.02381 .2894 m
.02756 .2894 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34826 m
.02756 .34826 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .3875 m
.02756 .3875 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .44636 m
.02756 .44636 L
s
.02381 .46598 m
.02756 .46598 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .52484 m
.02756 .52484 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .56408 m
.02756 .56408 L
s
.02381 .5837 m
.02756 .5837 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.21429 .60332 L
.40476 .60332 L
.59524 .59351 L
.78571 .5838 L
.97619 .57418 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 -0.272059 1.43387 [
[.21429 .00222 -3 -9 ]
[.21429 .00222 3 0 ]
[.40476 .00222 -3 -9 ]
[.40476 .00222 3 0 ]
[.59524 .00222 -3 -9 ]
[.59524 .00222 3 0 ]
[.78571 .00222 -3 -9 ]
[.78571 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .1581 -18 -4.5 ]
[.01131 .1581 0 4.5 ]
[.01131 .30149 -18 -4.5 ]
[.01131 .30149 0 4.5 ]
[.01131 .44488 -18 -4.5 ]
[.01131 .44488 0 4.5 ]
[.01131 .58826 -18 -4.5 ]
[.01131 .58826 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(3)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(4)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(5)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(6)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .1581 m
.03006 .1581 L
s
[(0.3)] .01131 .1581 1 0 Mshowa
.02381 .30149 m
.03006 .30149 L
s
[(0.4)] .01131 .30149 1 0 Mshowa
.02381 .44488 m
.03006 .44488 L
s
[(0.5)] .01131 .44488 1 0 Mshowa
.02381 .58826 m
.03006 .58826 L
s
[(0.6)] .01131 .58826 1 0 Mshowa
.125 Mabswid
.02381 .04339 m
.02756 .04339 L
s
.02381 .07207 m
.02756 .07207 L
s
.02381 .10075 m
.02756 .10075 L
s
.02381 .12942 m
.02756 .12942 L
s
.02381 .18678 m
.02756 .18678 L
s
.02381 .21546 m
.02756 .21546 L
s
.02381 .24413 m
.02756 .24413 L
s
.02381 .27281 m
.02756 .27281 L
s
.02381 .33017 m
.02756 .33017 L
s
.02381 .35884 m
.02756 .35884 L
s
.02381 .38752 m
.02756 .38752 L
s
.02381 .4162 m
.02756 .4162 L
s
.02381 .47355 m
.02756 .47355 L
s
.02381 .50223 m
.02756 .50223 L
s
.02381 .53091 m
.02756 .53091 L
s
.02381 .55959 m
.02756 .55959 L
s
.02381 .61694 m
.02756 .61694 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .01472 m
.21429 .60332 L
.40476 .59457 L
.59524 .5859 L
.78571 .57732 L
.97619 .56883 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 -0.573889 5.88604 [
[.21429 .00222 -3 -9 ]
[.21429 .00222 3 0 ]
[.40476 .00222 -3 -9 ]
[.40476 .00222 3 0 ]
[.59524 .00222 -3 -9 ]
[.59524 .00222 3 0 ]
[.78571 .00222 -3 -9 ]
[.78571 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(3)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(4)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(5)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(6)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.12)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.14)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.16)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.18)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.21429 .01472 L
.40476 .01472 L
.59524 .01472 L
.78571 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 0.0147151 5.88604 [
[.21429 .00222 -3 -9 ]
[.21429 .00222 3 0 ]
[.40476 .00222 -3 -9 ]
[.40476 .00222 3 0 ]
[.59524 .00222 -3 -9 ]
[.59524 .00222 3 0 ]
[.78571 .00222 -3 -9 ]
[.78571 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(3)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(4)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(5)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(6)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.21429 .60332 L
.40476 .60332 L
.59524 .60332 L
.78571 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 -0.371191 0.97451 [
[.21429 .59082 -3 -9 ]
[.21429 .59082 3 0 ]
[.40476 .59082 -3 -9 ]
[.40476 .59082 3 0 ]
[.59524 .59082 -3 -9 ]
[.59524 .59082 3 0 ]
[.78571 .59082 -3 -9 ]
[.78571 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01861 -18 -4.5 ]
[.01131 .01861 0 4.5 ]
[.01131 .11606 -18 -4.5 ]
[.01131 .11606 0 4.5 ]
[.01131 .21352 -18 -4.5 ]
[.01131 .21352 0 4.5 ]
[.01131 .31097 -18 -4.5 ]
[.01131 .31097 0 4.5 ]
[.01131 .40842 -18 -4.5 ]
[.01131 .40842 0 4.5 ]
[.01131 .50587 -18 -4.5 ]
[.01131 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .60332 m
.21429 .60957 L
s
[(2)] .21429 .59082 0 1 Mshowa
.40476 .60332 m
.40476 .60957 L
s
[(3)] .40476 .59082 0 1 Mshowa
.59524 .60332 m
.59524 .60957 L
s
[(4)] .59524 .59082 0 1 Mshowa
.78571 .60332 m
.78571 .60957 L
s
[(5)] .78571 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(6)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.0619 .60332 m
.0619 .60707 L
s
.1 .60332 m
.1 .60707 L
s
.1381 .60332 m
.1381 .60707 L
s
.17619 .60332 m
.17619 .60707 L
s
.25238 .60332 m
.25238 .60707 L
s
.29048 .60332 m
.29048 .60707 L
s
.32857 .60332 m
.32857 .60707 L
s
.36667 .60332 m
.36667 .60707 L
s
.44286 .60332 m
.44286 .60707 L
s
.48095 .60332 m
.48095 .60707 L
s
.51905 .60332 m
.51905 .60707 L
s
.55714 .60332 m
.55714 .60707 L
s
.63333 .60332 m
.63333 .60707 L
s
.67143 .60332 m
.67143 .60707 L
s
.70952 .60332 m
.70952 .60707 L
s
.74762 .60332 m
.74762 .60707 L
s
.82381 .60332 m
.82381 .60707 L
s
.8619 .60332 m
.8619 .60707 L
s
.9 .60332 m
.9 .60707 L
s
.9381 .60332 m
.9381 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01861 m
.03006 .01861 L
s
[(0.4)] .01131 .01861 1 0 Mshowa
.02381 .11606 m
.03006 .11606 L
s
[(0.5)] .01131 .11606 1 0 Mshowa
.02381 .21352 m
.03006 .21352 L
s
[(0.6)] .01131 .21352 1 0 Mshowa
.02381 .31097 m
.03006 .31097 L
s
[(0.7)] .01131 .31097 1 0 Mshowa
.02381 .40842 m
.03006 .40842 L
s
[(0.8)] .01131 .40842 1 0 Mshowa
.02381 .50587 m
.03006 .50587 L
s
[(0.9)] .01131 .50587 1 0 Mshowa
.125 Mabswid
.02381 .0381 m
.02756 .0381 L
s
.02381 .05759 m
.02756 .05759 L
s
.02381 .07708 m
.02756 .07708 L
s
.02381 .09657 m
.02756 .09657 L
s
.02381 .13555 m
.02756 .13555 L
s
.02381 .15504 m
.02756 .15504 L
s
.02381 .17453 m
.02756 .17453 L
s
.02381 .19402 m
.02756 .19402 L
s
.02381 .23301 m
.02756 .23301 L
s
.02381 .2525 m
.02756 .2525 L
s
.02381 .27199 m
.02756 .27199 L
s
.02381 .29148 m
.02756 .29148 L
s
.02381 .33046 m
.02756 .33046 L
s
.02381 .34995 m
.02756 .34995 L
s
.02381 .36944 m
.02756 .36944 L
s
.02381 .38893 m
.02756 .38893 L
s
.02381 .42791 m
.02756 .42791 L
s
.02381 .4474 m
.02756 .4474 L
s
.02381 .46689 m
.02756 .46689 L
s
.02381 .48638 m
.02756 .48638 L
s
.02381 .52536 m
.02756 .52536 L
s
.02381 .54485 m
.02756 .54485 L
s
.02381 .56434 m
.02756 .56434 L
s
.02381 .58383 m
.02756 .58383 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.21429 .01472 L
.40476 .60332 L
.59524 .59357 L
.78571 .58393 L
.97619 .37738 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.166667 0.190476 0.0147151 5.88604 [
[.21429 .00222 -3 -9 ]
[.21429 .00222 3 0 ]
[.40476 .00222 -3 -9 ]
[.40476 .00222 3 0 ]
[.59524 .00222 -3 -9 ]
[.59524 .00222 3 0 ]
[.78571 .00222 -3 -9 ]
[.78571 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(2)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(3)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(4)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(5)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(6)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.21429 .60332 L
.40476 .60332 L
.59524 .60332 L
.78571 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H003;oi^KV1Ol00007onKViP?o
00002_oVi^H3o`0000Soi^KV0ol00009onKViP?o0000=ooVi^H5o`0000Soi^KV0ol0000:onKViP?o
00002?oVi^H3o`0000Soi^KV0ol0000DonKViP00<ooVi^H01?l0003oi^KVonKVi_l00006onKViP05
o`000?oVi^Koi^KVonKVi_l000002_oVi^H00ol0003oi^KVonKViP06onKViP05o`000?oVi^Koi^KV
onKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000003Ooi^KV00Co0000onKVi_oVi^Ko0000
1ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000[oi^KV00?o0000onKVi_oVi^H01_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Koi^KV00Go0000onKVi_oVi^Koi^KVo`00000ConKViP00=?oVi^H00ol0
003oi^KVonKViP0:onKViP03o`000?oVi^Koi^KV00Goi^KV1Ol0000;onKViP03o`000?oVi^Koi^KV
00Goi^KV00Go0000onKVi_oVi^Koi^KVo`00000honKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000
onKVi_oVi^H01OoVi^H5o`0000_oi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000001?oi^KV000eonKViP03o`000?oVi^Koi^KV00Ooi^KV0_l00008onKViP04o`000?oVi^Ko
i^KVo`0000coi^KV00?o0000onKVi_oVi^H01OoVi^H4o`0003[oi^KV00?o0000onKVi_oVi^H02?oV
i^H2o`0000Soi^KV00Co0000onKVi_oVi^Ko00003?oVi^H00ol0003oi^KVonKViP04onKViPCo0000
5?oVi^H003;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000:onKViP03o`000?oVi^Koi^KV00Koi^KV
00?o0000onKVi_l000002?oVi^H4o`0000Soi^KV00?o0000onKVi_oVi^H0>?oVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000_oi^KV00?o0000onKVi_oVi^H01_oVi^H00ol0003oi^KVo`000008onKViPCo
00001ooVi^H00ol0003oi^KVonKViP0EonKViP00<_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ko
i^KV00Go0000onKVi_oVi^Koi^KVo`000009onKViP;o00002?oVi^H00ol0003oi^KVonKViP0:onKV
iP03o`000?oVi^Koi^KV03Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Ko
i^KVonKVi_l000002OoVi^H2o`0000Soi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003oi^KVonKV
iP0DonKViP00<ooVi^H3o`0000Soi^KV0ol0000;onKViP03o`000?oVi^Koi^KV00Koi^KV1Ol00009
onKViP;o0000>?oVi^H3o`0000Woi^KV0ol0000;onKViP03o`000?oVi^Koi^KV00Koi^KV1Ol00008
onKViP;o00005?oVi^H00>?oi^KV000YonKViP03o`000?oVi^Koi^KV06Ooi^KV00?o0000onKVi_oV
i^H0COoVi^H002Ooi^KV0_l000000onc/k?o0000o`00000jo`0002coi^KV?ol0000BonKViP00:OoV
i^H00onc/k?oi^KVonKViP1WonKViP03o`000?oVi^Koi^KV04goi^KV000YonKViP03o`000?nc/k?o
i^KV06Ooi^KV0_l0001>onKViP00:OoVi^H00ol0003o/k>conKViP1WonKViP;o0000C_oVi^H002Wo
i^KV00?o0000ok>c/ooVi^H0IooVi^H00ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000Coi^KV
00?o0000onKVi_oVi^H00ooVi^H2o`0000;oi^KV1Ol00002onKViP03o`000?oVi^Ko/k>c06Ooi^KV
0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVok>c/`1AonKViP;o00001?oVi^H00ol0
003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H0COoVi^H0017o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Ko
i^KV00;oi^KV00?o0000onKVi_nc/k<0D?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l0001>onKViP004OoVi^H01?l0003o
i^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00Go0000onKVi_oVi^Koi^KVo`00
0002onKViP03ok>c/ooVi^Koi^KV04goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KV
onKVi_l00005onKViP03o`000?oVi^Ko000004ooi^KV000AonKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o
/k>conKVi_oVi^H0COoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Go
i^KV00Co0000onKVi_l0003o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0
003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00onc/k?oi^KV
onKViP1=onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP04o`00
00;oi^KV00?o0000onKVi_oVi^H0COoVi^H001;oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000?o
i^KV00Go0000onKVi_oVi^Koi^KVok>c/`1>onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00005onKViP;o0000C_oVi^H001;oi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00?oi^KV0_l00004onKViP?o00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko/k>c04ooi^KV
0_l0000:onKViP;o00000_oVi^H5o`000003onKVi_l0003oi^KV04koi^KV000AonKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00?oi^KV00?o/k>conKVi_oVi^H0HooVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Go0000onKVi_oVi^Ko0000onKViP05o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H0
0onc/k?oi^KVonKViP1RonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP03
ok>c/ooVi^Koi^KV05;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViP03
o`000?oVi^Koi^KV04goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H00ol0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV00;oi^KV00?o/k>conKV
i_oVi^H0DOoVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o0000C_oV
i^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP;o0000
0ooVi^H00ol0003oi^KVonKViP03onKViP03ok>c/ooVi^Koi^KV053oi^KV00Co0000onKVi_oVi^Ko
00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV000BonKViP;o00002_oVi^H2o`0000Go
i^KV00Go0000onKVi_oVi^Koi^KVo`000005onKViP03ok>c/ooVi^Koi^KV053oi^KV00Co0000onKV
i_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^Hlolc<c1Coi^KV000BonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0onc/k?oi^KVonKViP1@onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KV
o`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H01?l0003oi^KVonKVi_l00006onKViP03ok>c/ooVi^Koi^KV04ooi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H2o`0000?oi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00006onKV
iP03ok>c/ooVi^Koi^KV053oi^KV0_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000CooVi^H0
017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Co00000ooV
i^H00ol0003oi^KVonKViP04onKViP03ok>c/ooVi^Koi^KV063oi^KV0_l0001>onKViP004OoVi^H0
1?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00001_oVi^H00ol0003o
i^KVonKViP05onKViP03ok>c/ooVi^Koi^KV05ooi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0
003oi^KVonKViP05onKViP03ok>c/ooVi^Koi^KV05ooi^KV00?o0000onKVi_oVi^H0COoVi^H001;o
i^KV0_l0000:onKViP;o00001?oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H01OoVi^H00onc/k?o
i^KVonKViP19onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H3o`0000;o
i^KV0_l0001>onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV
0ol00003onKViP03o`000?oVi^Koi^KV00Koi^KV00?o/k>conKVi_oVi^H0AooVi^H01?l0003oi^KV
onKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H00ol0003oi^KVo`00001?onKV
iP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H01?l0003oi^KVonKVi_l00008onKViP03ok>c/ooVi^Koi^KV04Ooi^KV00Co0000onKVi_oVi^Ko
00002OoVi^H00ol0003oi^KVonKViP05onKViP04o`000?oVi^Ko0000o`0004koi^KV000AonKViP04
o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00?o/k>conKVi_oVi^H0AooVi^H01?l0003oi^KVonKVi_l00009onKViP03
o`000?oVi^Koi^KV00Goi^KV00?o0000onKVi_l00000CooVi^H0017oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000ooVi^H00ol0003oi^KVonKViP07onKV
iP03ok>c/ooVi^Koi^KV04Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oV
i^H4o`0000;oi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00009onKViP03ok>c/ooVi^Koi^KV
04Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0ol0003oi^KVonKViP1=onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00009onKViP03ok>c/ooVi^Koi^KV04Oo
i^KV0_l0000:onKViP04o`000?oVi^Koi^KVonKViPGo000000?oi^KVo`000?l00000C_oVi^H001;o
i^KV0_l0000:onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H02?oVi^H00onc/k?o
i^KVonKViP1LonKViP03o`000?oVi^Koi^KV04goi^KV000YonKViP03o`000?oVi^Koi^KV00Soi^KV
00?o/k>conKVi_oVi^H0G?oVi^H2o`0004koi^KV000HonKViP;o00001?oVi^H00ol0003oi^KVonKV
iP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP08onKViP03ok>c/ooVi^Koi^KV04coi^KV0_l0
0004onKViP04o`000?oVi^Koi^KVonKViPGo000000?oi^KVo`000?l00000C_oVi^H001Ooi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00Woi^KV
00?o/k>conKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko0000CooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02
onKViP03o`000?oVi^Koi^KV00Woi^KV<?nc/k<MonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co
0000onKVi_oVi^Koi^KV0_l0001>onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKViP03o`00
0?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKVi_l0000:onKViP04
o`000?oVi^Koi^KVo`0004ooi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKV
i_oVi^H0FooVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l00000DOoV
i^H001Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0005goi^KV00Co0000onKVi_oVi^Ko0000
1ooVi^H01Ol0003oi^KVonKVi_oVi^Ko0000057oi^KV000HonKViP;o00002_oVi^H00ol0003oi^KV
onKViP1LonKViP;o00002OoVi^H3o`0005;oi^KV003SonKViP00=ooVi^H3o`0000;oi^KV1_l00000
1?oVi^Ko0000o`000?l00003onKViP?o00000_oVi^H00ol0003oi^KVo`000002o`0004goi^KV0ol0
0002onKViP?o000000?oi^KVo`000?l000000ol00002onKViPKo000000Ooi^KVo`000?l0003o0000
onKVi_l0003oi^KV00?o000000?oi^KVo`000?l000008?oVi^H003Soi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00Ko0000onKV
i_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKV
i_oVi^H00_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00027oi^KV000h
onKViP03o`000?oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP03
onKViP03o`000?oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00004onKViP03o`000?oVi^Koi^KV
00;oi^KV00Co0000onKVi_l0003o00000_oVi^H00ol0003oi^KVo`00000RonKViP00>?oVi^H3o`00
00?oi^KV0ol00003onKViP?o00000ooVi^H3o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00001=
onKViP;o00000ooVi^H4o`0000;oi^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000
onKVi_l0003o00000_oVi^H2o`0002?oi^KV000honKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o
0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H00ol0003oi^KVonKViP1:onKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV0_l0
00001ooVi^Ko0000onKVi_oVi^Ko0000onKVi_l000008_oVi^H003Soi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000
onKVi_oVi^H00_oVi^H2o`000005onKVi_l0003oi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKV
iP0OonKViP00=ooVi^H4o`0000;oi^KV1Ol000000ooVi^Ko0000o`000002o`0000;oi^KV1?l00003
onKViP?o0000C_oVi^H3o`000005onKVi_l0003o0000o`000?oVi^H01_l00002onKViPGo000000Co
i^KVo`000?l0003oi^KV1_l000000ooVi^Ko0000o`00000PonKViP00hooVi^H00>?oi^KV003SonKV
iP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV002IonKViPGo00002?oVi^H3o`0000[o
i^KV0ol00008onKViP?o00002?oVi^H3o`0001Ooi^KV000AonKViP;o00001?oVi^H00ol0003oi^KV
onKViP03onKViP?o0000N_oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKV
i_l000002_oVi^H00ol0003oi^KVonKViP06onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000001Koi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go
0000onKVi_oVi^Koi^KVo`00001honKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H0
1OoVi^H5o`0000_oi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000001Ko
i^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1Ol00002onKViP03ogmoOooVi^Koi^KV07Oo
i^KV00?o0000onKVi_oVi^H02?oVi^H2o`0000Soi^KV00Co0000onKVi_oVi^Ko00003?oVi^H00ol0
003oi^KVonKViP04onKViPCo00005ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01?l0
003oi^KVonKVi_l00003onKViP03ogmoOooVi^Koi^KV07Coi^KV00Go0000onKVi_oVi^Koi^KVo`00
000;onKViP03o`000?oVi^Koi^KV00Koi^KV00?o0000onKVi_l000002?oVi^H4o`0000Ooi^KV00?o
0000onKVi_oVi^H06?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVo`00
0003onKViP03ogmoOooVi^Koi^KV07Coi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`00
0?oVi^Koi^KVonKVi_l000002OoVi^H2o`0000Soi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003o
i^KVonKViP0GonKViP004?oVi^H01?l0003oi^KVonKVi_l00009onKViP;o00000ooVi^H00ol0003o
OgmoonKViP1eonKViP?o00002OoVi^H3o`0000_oi^KV00?o0000onKVi_oVi^H01_oVi^H5o`0000So
i^KV0_l0000GonKViP004OoVi^H2o`0000_oi^KV00Ko0000onKVi_oVi^Koi^KVo`000?moOgnoonKV
iP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000ogmoOooV
i^H0JooVi^H00ol0003oi^KVonKViP1@onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05
o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVogmoO`1ZonKViP03o`000?nIVIWo0000
03co00005OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01_l0003oi^KVonKVi_l0003o
i^KVogmoOf_oi^KV00?oVIVIo`000?oVi^H0D?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooV
i^H01_l0003oi^KVonKVi_l0003oi^KVogmoOf_oi^KV00?o0000oiVIVOoVi^H0D?oVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00Co0000onKVi_oVi^KoOgmoJ_oVi^H00ol0
003oVIVIonKViP1@onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP03o`000?oVi^Koi^KV
00Coi^KV00Co0000onKVi_oVi^KoOgmoJ_oVi^H00ol0003oVIVIonKViP1@onKViP004OoVi^H2o`00
00Soi^KV1Ol00002onKViP04o`000?oVi^Koi^KVogmoOf[oi^KV0_l000000onIVIWoi^KVonKViP1>
onKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00Go0000onKV
i_oVi^Koi^KVogmoO`1IonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H0
0ol0003oi^KVoiVIV@1@onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^KoOgmo05Soi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01_l0003oi^KVonKVi_oVi^Ko0000onKViP;o000000?oVIVIonKVi_oVi^H0C_oVi^H0
013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go
0000onKVi_oVi^Koi^KVogmoO`1HonKViP04o`000?oVi^Koi^KVo`0000_oi^KV00?o0000onKVi_l0
00000_oVi^H00onIVIWoi^KVonKViP1=onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViPCo
00000ooVi^H01Ol0003oi^KVonKVi_oVi^KoOgmo05Soi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2
o`0000;oi^KV0_l000000ooVi^KoVIVIonKViP1>onKViP004?oVi^H01?l0003oi^KVonKVi_l00007
onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H00_oVi^H00omoOgooi^KVonKViP1E
onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Ko0000onKVi_l0003o0000onKVi_nIVIU?onKViP00
4?oVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oV
i^H00_oVi^H00omoOgooi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Oo0000onKV
i_oVi^Koi^KVo`000?oVi^Ko000000?oi^KV00?oVIVIonKVi_oVi^H0C?oVi^H0017oi^KV0_l0000:
onKViP;o00000ooVi^H00ol0003oi^KVonKViP02onKViP03ogmoOooVi^Koi^KV05Koi^KV0_l00009
onKViP?o00000_oVi^H2o`0000;oi^KV00?oVIVIonKVi_oVi^H0C?oVi^H0017oi^KV0_l00004onKV
iP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP03onKV
iP03ogmoOooVi^Koi^KV06Goi^KV00Go0000onKVi_oVi^Koi^KVoiVIV@1>onKViP004?oVi^H01?l0
003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0omoOgooi^KVonKViP1UonKViP;o00000ooVi^H00onIVIWoi^KVonKViP1;onKViP004?oVi^H01?l0
003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00omoOgooi^KVonKV
iP1EonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP?o000000?oi^KVo`000?oVi^H00ooV
i^H00onIVIWoi^KVonKViP1;onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oV
i^Koi^KVonKVi_l000001_oVi^H00omoOgooi^KVonKViP1ConKViP04o`000?oVi^Koi^KVo`0000[o
i^KV00?o0000onKVi_oVi^H00_l00003onKViP03oiVIVOoVi^Koi^KV04_oi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00001_oVi^H00omoOgooi^KVonKViP1ConKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV1Ol000000ooVi^Ko0000o`000004onKViP03oiVIVOoVi^Ko
i^KV04[oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00
0002onKViP03o`000?oVi^Koi^KV00Coi^KV00?oOgmoonKVi_oVi^H0DooVi^H01?l0003oi^KVonKV
i_l00007onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00onIVIWo
i^KVonKViP1:onKViP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00Goi^KV
00?oOgmoonKVi_oVi^H0D_oVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Ko000000;o
i^KV0_l00004onKViP03oiVIVOoVi^Koi^KV04[oi^KV000AonKViP;o00001?oVi^H00ol0003oi^KV
onKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP05onKViP03ogmoOooVi^Koi^KV05;oi^KV
00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000;oi^KV00?o0000onKVi_oVi^H01?oVi^H00onIVIWo
i^KVonKViP19onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKV
i_l000000_oVi^H00ol0003oi^KVonKViP05onKViP03ogmoOooVi^Koi^KV05?oi^KV0_l0000;onKV
iP03o`000?oVi^Koi^KV00;o00001OoVi^H00onIVIWoi^KVonKViP19onKViP004?oVi^H01?l0003o
i^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP06
onKViP03ogmoOooVi^Koi^KV06;oi^KV00?o0000onKVi_oVi^H01?oVi^H00onIVIWoi^KVonKViP19
onKViP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP?o00000ooVi^H00ol0003oi^KVonKViP06
onKViP03ogmoOooVi^Koi^KV06;oi^KV0_l00006onKViP03oiVIVOoVi^Koi^KV04Soi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV00Koi^KV00?oOgmoonKVi_oVi^H0D_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oV
i^H3o`0000;oi^KV0_l00006onKViP03oiVIVOoVi^Koi^KV04Soi^KV000@onKViP04o`000?oVi^Ko
i^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Koi^KV
00?oOgmoonKVi_oVi^H0DOoVi^H01?l0003oi^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKV
i_l0003oi^KVo`000007onKViP03oiVIVOoVi^Koi^KV04Soi^KV000AonKViP;o00001?oVi^H00ol0
003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP07onKViP03ogmoOooVi^Koi^KV
053oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVo`000?l00007onKViP03oiVIVOoV
i^Koi^KV04Ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KV
o`000009onKViP03ogmoOol0003o000000;o00002_oVi^H3o`0000_oi^KV0ol0000:onKViP?o0000
2_oVi^H3o`0001Woi^KV00Co0000onKVi_oVi^Ko00002ooVi^H00ol0003oi^KVo`000008onKViP03
oiVIVOoVi^Koi^KV04Ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H01OmoOgoo0000onKVi_oVi^Ko000000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00
000;onKViP03o`000?oVi^Koi^KV00Soi^KV00Go0000onKVi_oVi^Koi^KVo`000008onKViP05o`00
0?oVi^Koi^KVonKVi_l000006?oVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000_oVi^H2o`00
00Ooi^KV00?oVIVIonKVi_oVi^H0AooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H4o`00
00;oi^KV00?o0000onKVi_oVi^H02?oVi^H00omoOgoo0000onKViP0>onKViP03o`000?oVi^Koi^KV
00Koi^KV1Ol0000=onKViP03o`000?oVi^Koi^KV00Koi^KV00Go0000onKVi_oVi^Koi^KVo`00000H
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKV
iP07onKViP03oiVIVOoVi^Koi^KV04Koi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go
0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Soi^KV00?oOgmoonKVi_l00000
3?oVi^H2o`0000Woi^KV00Co0000onKVi_oVi^Ko00003_oVi^H00ol0003oi^KVonKViP06onKViPCo
00006_oVi^H2o`0000Soi^KV1Ol000000ooVi^Ko0000o`000008onKViP03oiVIVOoVi^Koi^KV04Ko
i^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKV
iP03o`000?oVi^Koi^KV00Ooi^KV00Go0000ogmoOooVi^Koi^KVo`00000=onKViP03o`000?oVi^Ko
i^KV00Ooi^KV00?o0000onKVi_l000002_oVi^H4o`0000Woi^KV00?o0000onKVi_oVi^H0:ooVi^H0
0ol0003oi^KVonKViP07onKViP03oiVIVOoVi^Koi^KV04Koi^KV000AonKViP;o00002OoVi^H3o`00
00?oi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVogmoOooVi^Ko000000Woi^KV00Go0000
onKVi_oVi^Koi^KVo`00000:onKViP;o00002_oVi^H00ol0003oi^KVonKViP0;onKViP03o`000?oV
i^Koi^KV02[oi^KV0_l00009onKViP03oiVIVOoVi^Koi^KV04Goi^KV000RonKViP03o`000?oVi^Ko
i^KV00Soi^KV00?o0000ogmoOol000002ooVi^H3o`0000coi^KV00?o0000onKVi_oVi^H02?oVi^H5
o`0000[oi^KV0_l0000JonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H2
o`0000Woi^KV00?oVIVIonKVi_oVi^H0AOoVi^H002;oi^KV00?o0000onKVi_oVi^H02OoVi^H00omo
Ogooi^KVonKViP0PonKViQGoOgmo6OoVi^H01?l0003oi^KVonKVi_l00007onKViP07o`000?oVi^Ko
i^KVonKVi_l0003oi^KVo`00000:onKViP03oiVIVOoVi^Koi^KV01coi^KV4_nIVITGonKViP008_oV
i^H00ol0003oi^KVonKViP0:onKViP03ogmoOooVi^Koi^KV01;oi^KV3OmoOgl^onKViP04o`000?oV
i^Koi^KVo`0000Ooi^KV00Ko0000onKVi_oVi^Koi^KVo`000?oVi^H2o`0000[oi^KV00?oVIVIonKV
i_oVi^H03ooVi^H<oiVIVBWoi^KV000PonKViPoo00005OmoOglTo`0001Ooi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H4o`0000;oi^KV00?o0000onKVi_oVi^H02OoVi^HBoiVIVCGoi^KV000RonKViP03
o`000?oVi^Koi^KV05[oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP03onKV
iP;o0000DOoVi^H007ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP1EonKV
iP00P?oVi^H2o`0000[oi^KV0_l0001EonKViP00hooVi^H00>?oi^KV000eonKViP;o000000Coi^KV
o`000?l0003o00000_oVi^H2o`0000?oi^KV0ol00002onKViP;o000000Goi^KVo`000?l0003o0000
onKViP03o`00057oi^KV0ol00003onKViPGo000000Coi^KVo`000?l0003o00000_oVi^H3o`000004
onKVi_l0003o0000o`0002Woi^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0
003oi^KVonKVi_l00003onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000005?oi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVonKViP0XonKViP00=OoVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01?l0003oi^KVonKV
i_oVi^H5o`0000?oi^KV00?o0000onKVi_oVi^H0DOoVi^H00ol0003oi^KVonKViP03onKViP03o`00
0?oVi^Koi^KV00?oi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000002[o
i^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKV
iP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_l000001?oVi^H00ol0003oi^KVonKViP1AonKV
iP?o00000ooVi^H3o`0000?oi^KV0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l00000:_oVi^H0
03Goi^KV00Go0000onKVi_l0003oi^KVo`000002onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000
onKVi_l0003oi^KVo`0000;oi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko
0000057oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP0:o`000?oV
i^Koi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`0002[oi^KV000eonKViP;o000000?oi^KVo`00
0?l000000_oVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l00003onKViP09
o`000?oVi^Koi^KVonKVi_l0003oi^KVo`000?oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP05o`000?oVi^Koi^KVo`000?oVi^H00_l000000ooV
i^Ko0000o`00000ZonKViP00=OoVi^H01?l0003oi^KVonKVi_oVi^H5o`000003onKVi_l0003o0000
00Go00000_oVi^H2o`0000?oi^KV1Ol0001@onKViPCo00000_oVi^H5o`000003onKVi_l0003o0000
00;o00000_oVi^H01?l0003oi^KVonKVi_oVi^H2o`0002Woi^KV003SonKViP00hooVi^H00>?oi^KV
003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H003;oi^KV1Ol00007onKViP?o00002_oV
i^H3o`0000Soi^KV0ol00009onKViP?o0000=ooVi^H5o`0000Soi^KV0ol0000:onKViP?o00002?oV
i^H3o`0000Soi^KV0ol0000DonKViP00<ooVi^H01?l0003oi^KVonKVi_l00006onKViP05o`000?oV
i^Koi^KVonKVi_l000002_oVi^H00ol0003oi^KVonKViP06onKViP05o`000?oVi^Koi^KVonKVi_l0
00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000003Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000[oi^KV00?o0000onKVi_oVi^H01_oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000Koi^KV00Go0000onKVi_oVi^Koi^KVo`00000ConKViP00=?oVi^H00ol0003oi^KV
onKViP0:onKViP03o`000?oVi^Koi^KV00Goi^KV1Ol0000;onKViP03o`000?oVi^Koi^KV00Goi^KV
00Go0000onKVi_oVi^Koi^KVo`00000honKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oV
i^H01OoVi^H5o`0000_oi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
01?oi^KV000eonKViP03o`000?oVi^Koi^KV00Ooi^KV0_l00008onKViP04o`000?oVi^Koi^KVo`00
00coi^KV00?o0000onKVi_oVi^H01OoVi^H4o`0003[oi^KV00?o0000onKVi_oVi^H02?oVi^H2o`00
00Soi^KV00Co0000onKVi_oVi^Ko00003?oVi^H00ol0003oi^KVonKViP04onKViPCo00005?oVi^H0
03;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000:onKViP03o`000?oVi^Koi^KV00Koi^KV00?o0000
onKVi_l000002?oVi^H4o`0000Soi^KV00?o0000onKVi_oVi^H0>?oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000_oi^KV00?o0000onKVi_oVi^H01_oVi^H00ol0003oi^KVo`000008onKViPCo00001ooV
i^H00ol0003oi^KVonKViP0EonKViP00<_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV00Go
0000onKVi_oVi^Koi^KVo`000009onKViP;o00002?oVi^H00ol0003oi^KVonKViP0:onKViP03o`00
0?oVi^Koi^KV03Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KVonKV
i_l000002OoVi^H2o`0000Soi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003oi^KVonKViP0DonKV
iP00<ooVi^H3o`0000Soi^KV0ol0000;onKViP03o`000?oVi^Koi^KV00Koi^KV1Ol00009onKViP;o
0000>?oVi^H3o`0000Woi^KV0ol0000;onKViP03o`000?oVi^Koi^KV00Koi^KV1Ol00008onKViP;o
00005?oVi^H00>?oi^KV000WonKViPko0000<?m<C4`00ol0003oi^KVonKViP0ZonKViP03o`000?mV
IVKo000003co00004_oVi^H002Woi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oV
i^Ko000000;oi^KV00GoC4a<onKVi_l0003oi^KVo`000002onKViP05o`000?oVi^Ko0000onKVi_l0
00000_oVi^H00ol0003oi^KVo`000002onKViP05o`000?oVi^Ko0000onKVi_l000000_oVi^H01Ol0
003oi^KVo`000?oVi^Ko000000;oi^KV00Go0000onKVi_l0003oi^KVo`000002onKViP05o`000?oV
i^Ko0000onKVi_l000000_oVi^H00ol0003oi^KVonKViP0/onKViP06ofIVI_oVi^Koi^KVo`000?oV
i^Ko00000_oVi^H01Ol0003oi^KVo`000?oVi^Ko000000;oi^KV00Go0000onKVi_l0003oi^KVo`00
0002onKViP05o`000?oVi^Ko0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko000000;o
i^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko000000;oi^KV00Go0000onKV
i_l0003oi^KVo`000002onKViP05o`000?oVi^Ko0000onKVi_l000005?oVi^H002Woi^KV00?o0000
onKVi_oVi^H02OoVi^H00om<C4coi^KVonKViP1KonKViP03ofIVI_l0003oi^KV04goi^KV000YonKV
iP03o`000?oVi^Koi^KV00Soi^KV00?oC4a<onKVi_oVi^H0G?oVi^H00ol0003oIVIVonKViP1=onKV
iP00:OoVi^H00ol0003oi^KVonKViP08onKViP03oda<C?oVi^Koi^KV05coi^KV00?o0000ofIVI_oV
i^H0COoVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViPGo0000
0_oVi^H00ol0003oi^KVonKViP08onKViP03oda<C?oVi^Koi^KV04Koi^KV0_l00004onKViP03o`00
0?oVi^Koi^KV00?oi^KV0_l00002onKViPGo000000?oi^KVo`000?mVIVH0C_oVi^H0017oi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00?o0000onKVi_oVi^H01ooVi^H00om<C4coi^KVonKViP16onKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00;o000000?o
IVIVonKVi_oVi^H0BooVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKV
iP03onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H01ooVi^H00om<C4coi^KVonKV
iP16onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01ol0003o
i^KVonKVi_oVi^Ko0000onKVi_mVIVH0COoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H0
0ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l000002OoVi^H00om<C4coi^KVonKV
iP16onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H00ol0003o
i^KVonKViP02o`000003ofIVI_oVi^Koi^KV04_oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?oC4a<
onKVi_oVi^H0AooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000ooVi^H00ol0003oi^KVo`000002onKViP03ofIVI_oVi^Koi^KV04[oi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV0_l00003onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0
003oi^KVonKViP06onKViP03oda<C?oVi^Koi^KV04Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Ko0000onKVi_l0003o0000onKVi_mVIVI<onKV
iP004_oVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKVi_oV
i^H01_oVi^H00om<C4coi^KVonKViP18onKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP;o
000000?oi^KVofIVI_oVi^H0BooVi^H002Woi^KV00?o0000onKVi_oVi^H01OoVi^H00om<C4coi^KV
onKViP1OonKViP05o`000?oVi^Koi^KVonKVi_mVIVH0BooVi^H001;oi^KV0_l00004onKViP03o`00
0?oVi^Koi^KV00;oi^KV0ol00004onKViP?o00000_oVi^H00ol0003oi^KVonKViP05onKViP03oda<
C?oVi^Koi^KV04Woi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP?o0000
00?oi^KVo`000?l000000_oVi^H00omVIVKoi^KVonKViP19onKViP004OoVi^H01?l0003oi^KVonKV
i_l00009onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03
oda<C?oVi^Koi^KV04Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004
onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?oIVIVonKVi_oVi^H0BOoVi^H0017oi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H0
1?oVi^H00om<C4coi^KVonKViP19onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oV
i^Ko0000onKViP05o`000003onKVi_l0003o000000?oi^KV00?oIVIVonKVi_oVi^H0B?oVi^H0017o
i^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go0000
onKVi_oVi^Koi^KVo`000006onKViP03oda<C?oVi^Koi^KV04Woi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00001?oVi^H0
0omVIVKoi^KVonKViP18onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Ko
i^KV00;oi^KV00?o0000onKVi_l000000ooVi^H00ol0003oi^KVonKViP04onKViP03oda<C?oVi^Ko
i^KV04Woi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`00
0?oVi^Ko000000;oi^KV0_l00003onKViP03ofIVI_oVi^Koi^KV04Soi^KV000AonKViP04o`000?oV
i^Koi^KVo`0000Soi^KV0_l00005onKViP;o00000ooVi^H00ol0003oi^KVonKViP03onKViP03oda<
C?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKV
iP;o00000_oVi^H00ol0003oi^KVonKViP03onKViP03ofIVI_oVi^Koi^KV04Ooi^KV000BonKViP;o
00002_oVi^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00om<
C4coi^KVonKViP1;onKViP;o00002_oVi^H2o`0000Goi^KV00?o0000onKVi_oVi^H00_l00004onKV
iP03ofIVI_oVi^Koi^KV04Ooi^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o
00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00om<C4coi^KVonKViP1;onKViP;o
00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV0_l00004onKViP03
ofIVI_oVi^Koi^KV04Ooi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oV
i^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?oC4a<onKVi_oVi^H0BooVi^H0
1?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003o
i^KVo`000006onKViP03ofIVI_oVi^Koi^KV04Koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?oC4a<
onKVi_oVi^H0BooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000ooVi^H01?l0003oi^KVo`000?l00005onKViP03ofIVI_oVi^Koi^KV04Koi^KV000AonKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV1?l00003onKViP03o`000?oVi^Ko
i^KV00;oi^KV00?oC4a<onKVi_oVi^H0BooVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oV
i^Koi^KVo`000?oVi^H01?l00002onKViP03o`000?oVi^Koi^KV00Coi^KV00?oIVIVonKVi_oVi^H0
A_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ko
i^KV00Go0000onKVi_oVi^Koi^KVoda<C01>onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00005onKViP;o00001_oVi^H00omVIVKoi^KVonKViP15onKViP004OoV
i^H01?l0003oi^KVonKVi_l00008onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP05o`00
0?oVi^Koi^KVonKVi_m<C4`0C_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP05onKViP03ofIVI_oVi^Ko
i^KV04Goi^KV000BonKViP;o00002_oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H01Ol0
003oi^KVonKVi_oVi^KoC4a<04ooi^KV0_l0000:onKViP;o00001?oVi^H2o`0000;oi^KV0_l00006
onKViP03ofIVI_oVi^Koi^KV04Goi^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKV
iP?o00000ooVi^H3o`0000?oi^KV00Co0000onKVi_oVi^KoC4a<D?oVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Koi^KV00?oIVIV
onKVi_oVi^H0A?oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00om<C4coi^KVonKViP1=onKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko
0000o`0000Ooi^KV00?oIVIVonKVi_oVi^H0A?oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00om<C4co
i^KVonKViP1=onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0003onKViP03o`000?oVi^Ko000000Soi^KV00?oIVIVonKVi_oVi^H0A?oVi^H0017oi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVoda<
C01@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000;o
i^KV0_l00008onKViP03ofIVI_oVi^Koi^KV04?oi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP06o`000?oVi^Koi^KVo`000?oVi^KoC4a<D?oV
i^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0
003oi^KVo`000?l00008onKViP03ofIVI_oVi^Koi^KV04?oi^KV000AonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV0_l00003onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVoda<
C01@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP03o`000?oVi^Ko000000Woi^KV00?oIVIVonKVi_oVi^H0@ooVi^H001;oi^KV0_l0000:onKViP03
o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?m<C4coi^KV057oi^KV0_l0000:onKViP;o
00000ooVi^H3o`0000;oi^KV0_l00009onKViP03ofIVI_oVi^Koi^KV04;oi^KV000HonKViP;o0000
1?oVi^H01?l0003oi^KVonKVi_oVi^H5o`0000;oi^KV00?o0000oda<C?oVi^H0EooVi^H2o`0000Co
i^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H02?oVi^H00omVIVKo
i^KVonKViP12onKViP005ooVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00?o0000oda<C?oVi^H0E_oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Ko
i^KVonKViP;o00002OoVi^H00omVIVKoi^KVonKViP12onKViP005ooVi^H01?l0003oi^KVonKVi_l0
0009onKViP03o`000?oVi^Koi^KV00;oi^KV00?oC4a<onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKV
i_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000002ooVi^H00omVIVKoi^KVonKViP11onKViP00
5ooVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_m<C4`0F?oVi^H01?l0
003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o00002_oVi^H`ofIVIQCoi^KV000G
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`00
0?oVi^Koi^KV05Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
04ooi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00001K
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l0001ConKViP006?oVi^H2o`0000Woi^KV0ol0001M
onKViP;o00002_oVi^H00ol0003oi^KVonKViP1AonKViP00hooVi^H00>?oi^KV000jonKViPCo0000
1?oVi^H2o`0000;oi^KV0ol00003onKViPGo0000C_oVi^H5o`000006onKVi_l0003o0000o`000?oV
i^Ko00000ooVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000o`000004o`0000Coi^KV0ol0000RonKV
iP00>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000
onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l0001?onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000
onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l0000QonKViP00>ooVi^H01?l0003oi^KVonKV
i_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003o
i^KVonKViP1@onKViP03o`000?oVi^Koi^KV00?oi^KV00Ko0000onKVi_l0003o0000onKVi_l00005
onKViPGo00000_oVi^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV01ooi^KV000konKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000?oi^KV00?o
0000onKVi_oVi^H0D?oVi^H3o`0000?oi^KV00Ko0000onKVi_l0003o0000onKVi_l00006onKViP03
o`000?oVi^Ko000000?oi^KV0ol00004onKViP;o00008_oVi^H003_oi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000
onKVi_oVi^H0D?oVi^H00ol0003oi^KVonKViP03onKViP;o000000Coi^KVo`000?oVi^Ko00001_oV
i^H00ol0003oi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0
8_oVi^H003_oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0D?oVi^H01?l0003oi^KVonKVi_l00002
onKViP;o000000Goi^KVo`000?oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l00000
1?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00027oi^KV000jonKViPCo
00000_oVi^H3o`000003onKVi_l0003o000000Co00000_oVi^H3o`00053oi^KV1Ol000001?oVi^Ko
0000o`000?oVi^H3o`0000;oi^KV0ol00002onKViP;o00000ooVi^H4o`0000Coi^KV0ol0000QonKV
iP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV002L
onKViPGo00002?oVi^H3o`0000[oi^KV0ol00008onKViP?o00002?oVi^H3o`0001Coi^KV000AonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP?o0000OOoVi^H01?l0003oi^KVonKVi_l00007
onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H00ol0003oi^KVonKViP06onKViP05o`000?oV
i^Koi^KVonKVi_l000001_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000001?oi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00001konKViP03o`000?oVi^Koi^KV
00_oi^KV00?o0000onKVi_oVi^H01OoVi^H5o`0000_oi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000001?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1Ol00002
onKViPko6ATIKooVi^H00ol0003oi^KVonKViP08onKViP;o00002?oVi^H01?l0003oi^KVonKVi_l0
000<onKViP03o`000?oVi^Koi^KV00Coi^KV1?l0000DonKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H02_oVi^H00olI6AWoi^KV
onKViP1ZonKViP05o`000?oVi^Koi^KVonKVi_l000002ooVi^H00ol0003oi^KVonKViP06onKViP03
o`000?oVi^Ko000000Soi^KV1?l00007onKViP03o`000?oVi^Koi^KV01Goi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00?o0000onKVi_l000000ooVi^H00ol0003oi^KVonKViP0;onKViP03
oaTI6OoVi^Koi^KV06Woi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KV
onKVi_l000002OoVi^H2o`0000Soi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003oi^KVonKViP0D
onKViP004?oVi^H01?l0003oi^KVonKVi_l00009onKViP;o00000ooVi^H00ol0003oi^KVonKViP0;
onKViP03oaTI6OoVi^Koi^KV06[oi^KV0ol00009onKViP?o00002ooVi^H00ol0003oi^KVonKViP06
onKViPGo00002?oVi^H2o`0001Coi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKV
iP?o00000ooVi^H00ol0003oi^KVonKViP0;onKViP03oaTI6OoVi^Koi^KV063oi^KV00?o0000onKV
i_oVi^H0COoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000;oi^KV00?o0000onKVi_oVi^H03?oVi^H00olI6AWoi^KVonKViP1NonKViP03o`000?lc<c?o
000003co00004_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0
000>onKViP03oaTI6OoVi^Koi^KV05ooi^KV00Ko<c<conKVi_oVi^Ko0000onKVi_l00002onKViP05
o`000?oVi^Ko0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko000000;oi^KV00Go0000
onKVi_l0003oi^KVo`000002onKViP05o`000?oVi^Ko0000onKVi_l000000_oVi^H00ol0003oi^KV
o`000002onKViP05o`000?oVi^Ko0000onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko0000
00;oi^KV00Go0000onKVi_l0003oi^KVo`00000DonKViP004?oVi^H01?l0003oi^KVonKVi_l0000;
onKViP04o`000?oVi^Koi^KVo`0000koi^KV00?o6ATIonKVi_oVi^H0GooVi^H00olc<c?o0000onKV
iP1=onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000ooVi^H00ol0003oi^KVonKV
iP0=onKViP03oaTI6OoVi^Koi^KV05koi^KV00?o0000oc<c<ooVi^H0COoVi^H0013oi^KV00Co0000
onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV00goi^KV00?o
6ATIonKVi_oVi^H0G_oVi^H00ol0003o<c<conKViP1=onKViP004OoVi^H2o`0000Soi^KV1Ol00002
onKViP03o`000?oVi^Koi^KV00goi^KV00?o6ATIonKVi_oVi^H0B?oVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00ooVi^H2o`0000;oi^KV1Ol000000ooVi^Ko0000oc<c<`1>onKViP004OoVi^H2o`00
00Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H03_oVi^H00olI
6AWoi^KVonKViP16onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H01Ol0003oi^KVonKVi_l0003oi^KV00;o000000?o<c<conKVi_oVi^H0BooVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oV
i^H03_oVi^H00olI6AWoi^KVonKViP16onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKV
i_oVi^Ko00000ooVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_lc<c<0COoVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oV
i^H03_oVi^H00olI6AWoi^KVonKViP16onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKV
i_oVi^Ko00001?oVi^H00ol0003oi^KVonKViP02o`000003oc<c<ooVi^Koi^KV04_oi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l00003onKViP03o`000?oVi^Koi^KV00ooi^KV00?o6ATI
onKVi_oVi^H0AOoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000ooVi^H01_l0003oi^KVo`000?l0003oi^KVoc<c<dcoi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP0?onKViP03oaTI6OoVi^Ko
i^KV04Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?o
i^KV00?o0000onKVi_l000000_oVi^H00olc<c?oi^KVonKViP1:onKViP004?oVi^H01?l0003oi^KV
onKVi_l00008onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H03ooVi^H00olI6AWo
i^KVonKViP16onKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP;o000000?oi^KVoc<c<ooV
i^H0BooVi^H0017oi^KV0_l0000:onKViP;o00000ooVi^H00ol0003oi^KVonKViP0@onKViP03oaTI
6OoVi^Koi^KV04Goi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP?o0000
00?oi^KVo`000?oVi^H00_oVi^H00olc<c?oi^KVonKViP19onKViP004OoVi^H2o`0000Coi^KV00?o
0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV013oi^KV00?o
6ATIonKVi_oVi^H0A?oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Co
i^KV00?o0000onKVi_oVi^H00_l00002onKViP03oc<c<ooVi^Koi^KV04Woi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0@onKViP03
oaTI6OoVi^Koi^KV04Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003o
i^KV00Go000000?oi^KVo`000?oVi^H00_oVi^H00olc<c?oi^KVonKViP19onKViP004?oVi^H01?l0
003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000004ooVi^H00olI6AWoi^KVonKV
iP13onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKV
iP03o`000?oVi^Koi^KV00;o00000ooVi^H00olc<c?oi^KVonKViP18onKViP004?oVi^H01?l0003o
i^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000004ooVi^H00olI6AWoi^KVonKViP13
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KV
o`000002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o<c<conKVi_oVi^H0B?oVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000ConKViP03oaTI6OoVi^Koi^KV04?o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP;o00000_oVi^H2
o`0000?oi^KV00?o<c<conKVi_oVi^H0B?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H04_oVi^H00olI6AWoi^KVonKV
iP13onKViP;o00002_oVi^H2o`0000Goi^KV00Co0000onKVi_oVi^Ko00001OoVi^H00olc<c?oi^KV
onKViP17onKViP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oVi^Koi^KV01;oi^KV00?o
6ATIonKVi_oVi^H0FOoVi^H2o`0000Coi^KV00?o<c<conKVi_oVi^H0AooVi^H0017oi^KV0_l00004
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV01;oi^KV00?o6ATI
onKVi_oVi^H0:ooVi^H00olI6AWoi^KVonKViP0EonKViP;o00001?oVi^H00ol0003oi^KVonKViP03
onKViP;o00000ooVi^H3o`0000;oi^KV0_l00004onKViP03oc<c<ooVi^Koi^KV04Ooi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV01?oi^KV00?o6ATIonKVi_oVi^H0:_oVi^H00olI6AWoi^KVonKViP0DonKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko0000
00Koi^KV00?o<c<conKVi_oVi^H0A_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H04ooVi^H00olI6AWoi^KVonKViP0Y
onKViP03oaTI6OoVi^Koi^KV01Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKV
i_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o00001OoVi^H00olc<c?oi^KVonKViP16onKV
iP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP?o00000ooVi^H00ol0003oi^KVonKViP0ConKV
iP03oaTI6OoVi^Koi^KV02Soi^KV00?o6ATIonKVi_oVi^H05_oVi^H01?l0003oi^KVonKVi_l00008
onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l00002onKViP03o`000?oVi^Koi^KV00Coi^KV00?o
<c<conKVi_oVi^H0A_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H05?oVi^H00olI6AWoi^KVonKViP0VonKViP03oaTI
6OoVi^Koi^KV01Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000Goi^KV0_l00006onKViP03oc<c<ooVi^Koi^KV04Goi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01Coi^KV00?o
6ATIonKVi_oVi^H09OoVi^H00olI6AWoi^KVonKViP0HonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00Go
i^KV00?o<c<conKVi_oVi^H0AOoVi^H0017oi^KV0_l00009onKViP?o00000ooVi^H00ol0003oi^KV
onKViP0DonKViP03oaTI6OoVi^Koi^KV02Coi^KV00?o6ATIonKVi_oVi^H06_oVi^H2o`0000[oi^KV
0_l00004onKViP;o00000_oVi^H2o`0000Koi^KV00?o<c<conKVi_oVi^H0AOoVi^H0017oi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV01Goi^KV00?o
6ATIonKVi_oVi^H08_oVi^H00olI6AWoi^KVonKViP0KonKViP;o00001?oVi^H00ol0003oi^KVonKV
iP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H01_oVi^H00olc<c?oi^KVonKV
iP14onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000
2OoVi^H5o`0000Woi^KV00Co6ATIo`000?l0003o00002ooVi^H3o`0000[oi^KV0ol00005onKViP03
oaTI6OoVi^Koi^KV00;oi^KV0ol0000FonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKV
i_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0000Ooi^KV00?o<c<conKVi_oVi^H0
A?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000:onKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00Go6ATIonKVi_oVi^Koi^KVo`00000;onKViP03o`000?oVi^Ko
i^KV00Soi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP05oaTI6OoVi^Koi^KVonKVi_l00000
0ooVi^H00ol0003oi^KVonKViP0ConKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oV
i^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0000Ooi^KV00?o<c<conKVi_oVi^H0A?oV
i^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H4o`0000;oi^KV00?o0000onKVi_oVi^H02OoV
i^H00ol0003oi^KVonKViP0:onKViP04oaTI6OoVi^Koi^KVo`0000Soi^KV1Ol0000=onKViP05o`00
0?oVi^Koi^KVonKVi_lI6AT01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000001Goi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000_oVi^H00ol0003oi^KVonKV
iP07onKViP03oc<c<ooVi^Koi^KV04?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go
0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00[oi^KV00?o0000onKVi_oVi^H0
2OoVi^H00olI6AWo0000o`000009onKViP04o`000?oVi^Koi^KVo`0000koi^KV00Co0000onKVi_oV
i^Ko6ATI1OoVi^H4o`0001Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0
003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o00002?oVi^H00olc<c?oi^KVonKViP13onKViP00
4?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0
003oi^KVonKViP07onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H01?lI6AWoi^KVonKVi_l0
0009onKViP03o`000?oVi^Ko000000[oi^KV1?l00002onKViP03oaTI6OoVi^Koi^KV00Coi^KV00?o
0000onKVi_oVi^H05ooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H00ol0003oi^KVo`000009onKViP03oc<c<ooVi^Koi^KV04?oi^KV000AonKViP;o
00002OoVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00Woi^KV00Go0000onKVi_lI6AWoi^KVo`00000:onKViP;o00002_oVi^H00ol0003oi^KVonKViP02
onKViP03oaTI6OoVi^Koi^KV00Koi^KV00?o0000onKVi_oVi^H05ooVi^H2o`0000[oi^KV0_l00003
onKViP?o00000_oVi^H2o`0000Woi^KV00?o<c<conKVi_oVi^H0@_oVi^H002;oi^KV00?o0000onKV
i_oVi^H02?oVi^H3o`0000_oi^KV00?o0000oaTI6Ol000003?oVi^H00ol0003oi^KVonKViP08onKV
iPCo000000?o6ATIonKVi_oVi^H02?oVi^H2o`0001goi^KV0_l00004onKViP03o`000?oVi^Koi^KV
00;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Soi^KV00?o<c<conKVi_oVi^H0@_oVi^H002;o
i^KV00?o0000onKVi_oVi^H05ooVi^H00olI6AWoi^KVonKViP0BonKViPSo6ATI:OoVi^H01?l0003o
i^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o00002OoVi^H00olc<c?oi^KVonKViP12
onKViP008_oVi^H00ol0003oi^KVonKViP0HonKViP03oaTI6OoVi^Koi^KV00Coi^KV3OlI6ATaonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00000;onKViP03oc<c<ooV
i^Koi^KV047oi^KV000PonKViQgo00001olI6ATTo`0001[oi^KV00Co0000onKVi_oVi^Ko00002OoV
i^H01?l0003oi^KVonKVi_oVi^H2o`0000[oi^KV<?lc<c<DonKViP008_oVi^H00ol0003oi^KVonKV
iP1MonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP00
P_oVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000DooVi^H008?oi^KV0_l0000:onKViP03o`00
0?oVi^Koi^KV057oi^KV003SonKViP00=ooVi^H2o`0000;oi^KV0ol00002onKViP03o`000?oVi^Ko
000000;o00000ooVi^H3o`0000?oi^KV0ol0001>onKViPCo00000_oVi^H5o`0000?oi^KV0_l00002
onKViP;o000000?oi^KVo`000?l000001?l00004onKViP?o00008_oVi^H003Koi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04coi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00027oi^KV000eonKV
iP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000Goi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP03onKViPGo00000_oV
i^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV01ooi^KV000eonKViP03o`000?oVi^Ko
i^KV00Coi^KV0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H2o`0000Coi^KV0_l0
001?onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Coi^KV
00?o0000onKVi_l000000ooVi^H3o`0000Coi^KV0_l0000RonKViP00=OoVi^H00ol0003oi^KVonKV
iP04onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKV
iP03o`000?oVi^Koi^KV04ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02
onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l0
0002onKViP03o`000?oVi^Koi^KV02;oi^KV000fonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;o
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000QonKViP00=ooVi^H3o`00
0003onKVi_l0003o000000;o00000ooVi^H3o`0000Coi^KV0ol00003onKViP?o0000COoVi^H4o`00
00;oi^KV1Ol00003onKViP?o00000_oVi^H2o`0000?oi^KV1?l00004onKViP?o00008OoVi^H00>?o
i^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H0
0>?oi^KV003SonKViP00hooVi^H005[oi^KV1?l00025onKViP00FooVi^H2o`0008Koi^KV001KonKV
iP;o0000Q_oVi^H003ooi^KV1Ol00002onKViPCo00002OoVi^H5o`0000?oi^KV1Ol00002onKViP?o
000000?oi^KVo`000?l000000_l000000ooVi^Ko0000o`000004o`0000;oi^KV0_l000000ooVi^Ko
0000o`000002o`000003onKVi_l0003o000000;o00001OoVi^H4o`0000;oi^KV3?l000000ooVi^Ko
0000o`000004o`000003onKVi_l0003o000000Go0000?_oVi^H003koi^KV0_l00003onKViP;o0000
0_oVi^H2o`0000Woi^KV0_l00003onKViP;o00000_oVi^H2o`0000;oi^KV1?l00002onKViP04o`00
0?oVi^Ko0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l0
00000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV0_l00002onKViP?o000000Coi^KVo`000?l0
003oi^KV0_l00002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000
onKVi_l000000_oVi^H2o`0003goi^KV000monKViP;o00001?oVi^H2o`0000;oi^KV0_l00008onKV
iP;o00001OoVi^H2o`000003onKVi_l0003o000000;oi^KV1?l00004onKViP;o00000_oVi^H2o`00
0003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`00
0?l000001ooVi^H2o`000004onKVi_l0003o0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002
onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000?oi^KV0ol0000m
onKViP00?OoVi^H2o`0000?oi^KV1?l000000ooVi^Ko0000o`000003o`0000Goi^KV0_l00005onKV
iP;o000000?oi^KVo`000?l000000_oVi^H7o`000003onKVi_l0003o000000Coi^KV0ol00002onKV
iP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV1Ol00005onKV
iP?o00000_oVi^H2o`000003onKVi_l0003o000000;oi^KV1?l00002onKViP?o0000?ooVi^H003go
i^KV0_l00008onKViP;o00000_oVi^H2o`0000Coi^KV0_l00005onKViP;o000000Goi^KVo`000?l0
003o0000onKViP04o`000004onKVi_l0003o0000onKViPKo000000?oi^KVo`000?l000000_oVi^H2
o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002o`0000Goi^KV0_l00003
onKViP;o000000Coi^KVo`000?l0003oi^KV0_l00002onKViPGo00000_oVi^H2o`0000;oi^KV00Co
0000onKVi_l0003o00000_oVi^H00ol0003oi^KVonKViP0konKViP00?OoVi^H2o`0000Goi^KV00?o
0000onKVi_oVi^H00_l00002onKViP;o00001?oVi^H2o`0000Goi^KV1Ol000000ooVi^Ko0000o`00
0002onKViP?o000000Ooi^KVo`000?l0003o0000onKVi_l0003oi^KV00?o00000_oVi^H4o`000003
onKVi_l0003o000000;o000000Koi^KVo`000?l0003o0000onKVi_l00005onKViP;o00000ooVi^H2
o`0000;oi^KV0ol00002onKViP?o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o
0000o`000?oVi^H01?l0000monKViP00?_oVi^H2o`0000?oi^KV0_l00002onKViP;o00000_oVi^H2
o`0000Goi^KV0_l00003onKViP;o00006OoVi^H2o`00017oi^KV0_l00003onKViP;o00003ooVi^H2
o`0004Koi^KV000oonKViPCo000000?oi^KVo`000?oVi^H01_l00007onKViPGo00006ooVi^H00ol0
003oi^KVonKViP0>onKViPOo00003ooVi^H3o`0004Koi^KV003SonKViP00hooVi^H00001\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-2.51495, \
-0.0445132, 0.0848531, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-11.5545, -0.0890264, 0.0848531, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-1.56405, -0.711658, 0.0745369, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-11.2999, -0.725265, 0.0848531, 0.0112719}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {-2.51495, -0.306114, 0.0848531, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-11.5545, -0.406114, 0.0848531, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-1.53227, -2.61842, \
0.0740661, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> {-11.5545, \
-0.587, 0.0848531, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 0.768153375`}\\)}, \
{\\({DECAPS, 0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, \
{\\({MUTAT, 0.9702989999999999`}\\)}, {\\({PERM, \\(\\(\[LeftSkeleton] 19 \
\[RightSkeleton]\\)\\)}\\)}, {\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)}, {\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)}}, ColumnAlignments -> Left, \
GridBaseline -> {Baseline, {1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[_]\)\)[__]\)}\) is not present in \
expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No shrink performed."\)], \
"Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(7\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 -5.55112e-17 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.77124 .05067 0 -8.78531 ]
[.77124 .05067 10.625 5.21469 ]
[.80701 .09195 0 -8.69794 ]
[.80701 .09195 10.625 5.30206 ]
[.84 .13002 0 -8.61872 ]
[.84 .13002 10.625 5.38128 ]
[.87052 .16524 0 -8.54656 ]
[.87052 .16524 10.625 5.45344 ]
[.89884 .19792 0 -8.48056 ]
[.89884 .19792 10.625 5.51944 ]
[.92519 .22833 0 -8.41997 ]
[.92519 .22833 10.625 5.58003 ]
[.94976 .25669 0 -8.36413 ]
[.94976 .25669 10.625 5.63587 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.75757 .05416 m
.75073 .0559 L
s
gsave
.77124 .05067 -61 -12.7853 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.7933 .09528 m
.78644 .09694 L
s
gsave
.80701 .09195 -61 -12.6979 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.82625 .1332 m
.81938 .13479 L
s
gsave
.84 .13002 -61 -12.6187 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.85674 .16829 m
.84985 .16981 L
s
gsave
.87052 .16524 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.88503 .20084 m
.87813 .2023 L
s
gsave
.89884 .19792 -61 -12.4806 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.91136 .23113 m
.90444 .23254 L
s
gsave
.92519 .22833 -61 -12.42 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.93591 .25939 m
.92898 .26074 L
s
gsave
.94976 .25669 -61 -12.3641 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.16815 .24691 m
.13455 .92146 L
s
.26233 .29961 m
.23906 .93186 L
s
.34519 .34598 m
.33001 .94091 L
s
.41866 .3871 m
.40989 .94886 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.44084 .36882 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.48868 .35966 m .57042 .37159 L .52233 .38044 L F
.44084 .36882 m .48868 .35966 L .52233 .38044 L F
.53779 .35027 m .61975 .36251 L .57042 .37159 L F
.48868 .35966 m .53779 .35027 L .57042 .37159 L F
.40411 .34733 m .48868 .35966 L .44084 .36882 L F
.58821 .34062 m .67039 .35318 L .61975 .36251 L F
.53779 .35027 m .58821 .34062 L .61975 .36251 L F
.45294 .3376 m .53779 .35027 L .48868 .35966 L F
.40411 .34733 m .45294 .3376 L .48868 .35966 L F
.64 .33071 m .72237 .34361 L .67039 .35318 L F
.58821 .34062 m .64 .33071 L .67039 .35318 L F
.5031 .32761 m .58821 .34062 L .53779 .35027 L F
.45294 .3376 m .5031 .32761 L .53779 .35027 L F
.36506 .32448 m .45294 .3376 L .40411 .34733 L F
.69321 .32053 m .77575 .33379 L .72237 .34361 L F
.64 .33071 m .69321 .32053 L .72237 .34361 L F
.55465 .31734 m .64 .33071 L .58821 .34062 L F
.5031 .32761 m .55465 .31734 L .58821 .34062 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .43374 .92778 L p F P
0 0 0 r
s
.41491 .31412 m .5031 .32761 L .45294 .3376 L 1 0 0 r
F
.36506 .32448 m .41491 .31412 L .45294 .3376 L F
.7479 .31006 m .8306 .32369 L .77575 .33379 L .5 0 1 r
F
.69321 .32053 m .7479 .31006 L .77575 .33379 L 1 0 0 r
F
.60764 .30678 m .69321 .32053 L .64 .33071 L F
.55465 .31734 m .60764 .30678 L .64 .33071 L F
.57295 .92839 m .52132 .93033 L .48509 .92576 L p F P
0 0 0 r
s
.43374 .92778 m .48509 .92576 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.46617 .30347 m .55465 .31734 L .5031 .32761 L 1 0 0 r
F
.41491 .31412 m .46617 .30347 L .5031 .32761 L F
.32346 .30014 m .41491 .31412 L .36506 .32448 L F
.80415 .2993 m .88697 .31331 L .8306 .32369 L 0 1 1 r
F
.7479 .31006 m .80415 .2993 L .8306 .32369 L .5 0 1 r
F
.66214 .29593 m .7479 .31006 L .69321 .32053 L 1 0 0 r
F
.60764 .30678 m .66214 .29593 L .69321 .32053 L F
.62603 .92639 m .57295 .92839 L .53791 .92369 L p F P
0 0 0 r
s
.48509 .92576 m .53791 .92369 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.51889 .29252 m .60764 .30678 L .55465 .31734 L 1 0 0 r
F
.46617 .30347 m .51889 .29252 L .55465 .31734 L F
.48509 .92576 m .43374 .92778 L .39395 .92305 L p F P
0 0 0 r
s
.37437 .28909 m .46617 .30347 L .41491 .31412 L 1 0 0 r
F
.32346 .30014 m .37437 .28909 L .41491 .31412 L F
.862 .28823 m .94492 .30264 L .88697 .31331 L .5 1 0 r
F
.80415 .2993 m .862 .28823 L .88697 .31331 L 0 1 1 r
F
.7182 .28476 m .80415 .2993 L .7479 .31006 L 1 0 0 r
F
.66214 .29593 m .7182 .28476 L .7479 .31006 L F
.68061 .92434 m .62603 .92639 L .59224 .92156 L p F P
0 0 0 r
s
.53791 .92369 m .59224 .92156 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.57313 .28126 m .66214 .29593 L .60764 .30678 L 1 0 0 r
F
.51889 .29252 m .57313 .28126 L .60764 .30678 L F
.53791 .92369 m .48509 .92576 L .44644 .9209 L p F P
0 0 0 r
s
.39395 .92305 m .44644 .9209 L .48509 .92576 L p 1 0 0 r
F P
0 0 0 r
s
.89593 .50379 m .83801 .51176 L .82622 .91239 L p 0 1 1 r
F P
0 0 0 r
s
.83801 .51176 m .79453 .92005 L .76508 .91479 L p .5 0 1 r
F P
0 0 0 r
s
.76508 .91479 m .82622 .91239 L .83801 .51176 L p .5 0 1 r
F P
0 0 0 r
s
.42676 .27772 m .51889 .29252 L .46617 .30347 L 1 0 0 r
F
.37437 .28909 m .42676 .27772 L .46617 .30347 L F
.862 .28823 m .92154 .27684 L .94492 .30264 L .5 1 0 r
F
.27907 .27416 m .37437 .28909 L .32346 .30014 L 1 0 0 r
F
.77591 .27326 m .862 .28823 L .80415 .2993 L F
.7182 .28476 m .77591 .27326 L .80415 .2993 L F
.73675 .92223 m .68061 .92434 L .64817 .91937 L p F P
0 0 0 r
s
.59224 .92156 m .64817 .91937 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.62896 .26966 m .7182 .28476 L .66214 .29593 L 1 0 0 r
F
.57313 .28126 m .62896 .26966 L .66214 .29593 L F
.59224 .92156 m .53791 .92369 L .50048 .91868 L p F P
0 0 0 r
s
.44644 .9209 m .50048 .91868 L .53791 .92369 L p 1 0 0 r
F P
0 0 0 r
s
.95551 .49559 m .89593 .50379 L .88925 .90992 L p .5 1 0 r
F P
0 0 0 r
s
.82622 .91239 m .88925 .90992 L .89593 .50379 L p 0 1 1 r
F P
0 0 0 r
s
.48069 .26602 m .57313 .28126 L .51889 .29252 L 1 0 0 r
F
.42676 .27772 m .48069 .26602 L .51889 .29252 L F
.44644 .9209 m .39395 .92305 L .35145 .91799 L p F P
0 0 0 r
s
.33106 .26235 m .42676 .27772 L .37437 .28909 L 1 0 0 r
F
.27907 .27416 m .33106 .26235 L .37437 .28909 L F
.83532 .26143 m .92154 .27684 L .862 .28823 L .5 0 1 r
F
.77591 .27326 m .83532 .26143 L .862 .28823 L 1 0 0 r
F
.79453 .92005 m .73675 .92223 L .70576 .91711 L p F P
0 0 0 r
s
.64817 .91937 m .70576 .91711 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.68646 .25772 m .77591 .27326 L .7182 .28476 L 1 0 0 r
F
.62896 .26966 m .68646 .25772 L .7182 .28476 L F
.64817 .91937 m .59224 .92156 L .55613 .91641 L p F P
0 0 0 r
s
.50048 .91868 m .55613 .91641 L .59224 .92156 L p 1 0 0 r
F P
0 0 0 r
s
.88925 .90992 m .93187 .47575 L .95551 .49559 L p .5 1 0 r
F P
0 0 0 r
s
.53623 .25397 m .62896 .26966 L .57313 .28126 L 1 0 0 r
F
.48069 .26602 m .53623 .25397 L .57313 .28126 L F
.50048 .91868 m .44644 .9209 L .40512 .91569 L p F P
0 0 0 r
s
.35145 .91799 m .40512 .91569 L .44644 .9209 L p 1 0 0 r
F P
0 0 0 r
s
.38461 .25019 m .48069 .26602 L .42676 .27772 L 1 0 0 r
F
.33106 .26235 m .38461 .25019 L .42676 .27772 L F
.83532 .26143 m .89653 .24924 L .92154 .27684 L .5 0 1 r
F
.70576 .91711 m .76508 .91479 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.23158 .24637 m .33106 .26235 L .27907 .27416 L 1 0 0 r
F
.7457 .24541 m .83532 .26143 L .77591 .27326 L F
.68646 .25772 m .7457 .24541 L .77591 .27326 L F
.70576 .91711 m .64817 .91937 L .61346 .91406 L p F P
0 0 0 r
s
.55613 .91641 m .61346 .91406 L .64817 .91937 L p 1 0 0 r
F P
0 0 0 r
s
.59346 .24155 m .68646 .25772 L .62896 .26966 L 1 0 0 r
F
.53623 .25397 m .59346 .24155 L .62896 .26966 L F
.55613 .91641 m .50048 .91868 L .46043 .91332 L p F P
0 0 0 r
s
.40512 .91569 m .46043 .91332 L .50048 .91868 L p 1 0 0 r
F P
0 0 0 r
s
.4398 .23765 m .53623 .25397 L .48069 .26602 L 1 0 0 r
F
.38461 .25019 m .4398 .23765 L .48069 .26602 L F
.40512 .91569 m .35145 .91799 L .30596 .91258 L p F P
0 0 0 r
s
.28468 .23372 m .38461 .25019 L .33106 .26235 L .5 0 1 r
F
.23158 .24637 m .28468 .23372 L .33106 .26235 L 1 0 0 r
F
.80676 .23273 m .89653 .24924 L .83532 .26143 L F
.7457 .24541 m .80676 .23273 L .83532 .26143 L F
.76508 .91479 m .70576 .91711 L .67256 .91164 L p F P
0 0 0 r
s
.61346 .91406 m .67256 .91164 L .70576 .91711 L p 1 0 0 r
F P
0 0 0 r
s
.65246 .22875 m .7457 .24541 L .68646 .25772 L 1 0 0 r
F
.59346 .24155 m .65246 .22875 L .68646 .25772 L F
.61346 .91406 m .55613 .91641 L .51744 .91088 L p F P
0 0 0 r
s
.46043 .91332 m .51744 .91088 L .55613 .91641 L p 1 0 0 r
F P
0 0 0 r
s
.93187 .47575 m .88925 .90992 L .86128 .90392 L p .5 0 1 r
F P
0 0 0 r
s
.86128 .90392 m .9283 .90117 L .93187 .47575 L p .5 0 1 r
F P
0 0 0 r
s
.4967 .22473 m .59346 .24155 L .53623 .25397 L 1 0 0 r
F
.4398 .23765 m .4967 .22473 L .53623 .25397 L F
.46043 .91332 m .40512 .91569 L .36084 .91012 L p F P
0 0 0 r
s
.30596 .91258 m .36084 .91012 L .40512 .91569 L p 1 0 0 r
F P
0 0 0 r
s
.33943 .22067 m .4398 .23765 L .38461 .25019 L 0 1 1 r
F
.28468 .23372 m .33943 .22067 L .38461 .25019 L .5 0 1 r
F
.80676 .23273 m .86972 .21965 L .89653 .24924 L 1 0 0 r
F
.82622 .91239 m .76508 .91479 L .7335 .90915 L p F P
0 0 0 r
s
.67256 .91164 m .7335 .90915 L .76508 .91479 L p 1 0 0 r
F P
0 0 0 r
s
.18066 .21658 m .28468 .23372 L .23158 .24637 L 1 0 0 r
F
.71331 .21554 m .80676 .23273 L .7457 .24541 L .5 0 1 r
F
.65246 .22875 m .71331 .21554 L .7457 .24541 L 1 0 0 r
F
.67256 .91164 m .61346 .91406 L .57625 .90836 L p F P
0 0 0 r
s
.51744 .91088 m .57625 .90836 L .61346 .91406 L p 1 0 0 r
F P
0 0 0 r
s
.55538 .2114 m .65246 .22875 L .59346 .24155 L .5 0 1 r
F
.4967 .22473 m .55538 .2114 L .59346 .24155 L 1 0 0 r
F
.51744 .91088 m .46043 .91332 L .41746 .90757 L p F P
0 0 0 r
s
.36084 .91012 m .41746 .90757 L .46043 .91332 L p 1 0 0 r
F P
0 0 0 r
s
.39592 .20721 m .4967 .22473 L .4398 .23765 L 0 1 1 r
F
.33943 .22067 m .39592 .20721 L .4398 .23765 L F
.36084 .91012 m .30596 .91258 L .25713 .90677 L p 1 0 0 r
F P
0 0 0 r
s
.88925 .90992 m .82622 .91239 L .79638 .90657 L p 1 0 0 r
F P
0 0 0 r
s
.7335 .90915 m .79638 .90657 L .82622 .91239 L p 1 0 0 r
F P
0 0 0 r
s
.2349 .20298 m .33943 .22067 L .28468 .23372 L 0 1 1 r
F
.18066 .21658 m .2349 .20298 L .28468 .23372 L 1 0 0 r
F
.77609 .20192 m .86972 .21965 L .80676 .23273 L 0 1 1 r
F
.71331 .21554 m .77609 .20192 L .80676 .23273 L .5 0 1 r
F
.7335 .90915 m .67256 .91164 L .63692 .90576 L p 1 0 0 r
F P
0 0 0 r
s
.57625 .90836 m .63692 .90576 L .67256 .91164 L p 1 0 0 r
F P
0 0 0 r
s
.61595 .19764 m .71331 .21554 L .65246 .22875 L 0 1 1 r
F
.55538 .2114 m .61595 .19764 L .65246 .22875 L .5 0 1 r
F
.57625 .90836 m .51744 .91088 L .4759 .90495 L p 1 0 0 r
F P
0 0 0 r
s
.41746 .90757 m .4759 .90495 L .51744 .91088 L p 1 0 0 r
F P
0 0 0 r
s
.45423 .19332 m .55538 .2114 L .4967 .22473 L 0 1 1 r
F
.39592 .20721 m .45423 .19332 L .4967 .22473 L F
.41746 .90757 m .36084 .91012 L .31328 .90412 L p 1 0 0 r
F P
0 0 0 r
s
.25713 .90677 m .31328 .90412 L .36084 .91012 L p 1 0 0 r
F P
0 0 0 r
s
.79638 .90657 m .86128 .90392 L .88925 .90992 L p 1 0 0 r
F P
0 0 0 r
s
.29089 .18896 m .39592 .20721 L .33943 .22067 L 1 0 0 r
F
.2349 .20298 m .29089 .18896 L .33943 .22067 L 0 1 1 r
F
.77609 .20192 m .84091 .18786 L .86972 .21965 L F
.79638 .90657 m .7335 .90915 L .69956 .90308 L p 1 0 0 r
F P
0 0 0 r
s
.63692 .90576 m .69956 .90308 L .7335 .90915 L p 1 0 0 r
F P
0 0 0 r
s
.67849 .18344 m .77609 .20192 L .71331 .21554 L .5 1 0 r
F
.61595 .19764 m .67849 .18344 L .71331 .21554 L 0 1 1 r
F
.63692 .90576 m .57625 .90836 L .53623 .90224 L p 1 0 0 r
F P
0 0 0 r
s
.4759 .90495 m .53623 .90224 L .57625 .90836 L p 1 0 0 r
F P
0 0 0 r
s
.51443 .17897 m .61595 .19764 L .55538 .2114 L .5 1 0 r
F
.45423 .19332 m .51443 .17897 L .55538 .2114 L 0 1 1 r
F
.4759 .90495 m .41746 .90757 L .37125 .90139 L p 1 0 0 r
F P
0 0 0 r
s
.31328 .90412 m .37125 .90139 L .41746 .90757 L p 1 0 0 r
F P
0 0 0 r
s
.34872 .17446 m .45423 .19332 L .39592 .20721 L 1 0 0 r
F
.29089 .18896 m .34872 .17446 L .39592 .20721 L F
.31328 .90412 m .25713 .90677 L .20461 .90053 L p F P
0 0 0 r
s
.86128 .90392 m .79638 .90657 L .76427 .90031 L p 1 0 0 r
F P
0 0 0 r
s
.69956 .90308 m .76427 .90031 L .79638 .90657 L p 1 0 0 r
F P
0 0 0 r
s
.74309 .16876 m .84091 .18786 L .77609 .20192 L 1 0 0 r
F
.67849 .18344 m .74309 .16876 L .77609 .20192 L .5 1 0 r
F
.69956 .90308 m .63692 .90576 L .59856 .89944 L p 1 0 0 r
F P
0 0 0 r
s
.53623 .90224 m .59856 .89944 L .63692 .90576 L p 1 0 0 r
F P
0 0 0 r
s
.57664 .16415 m .67849 .18344 L .61595 .19764 L 1 0 0 r
F
.51443 .17897 m .57664 .16415 L .61595 .19764 L .5 1 0 r
F
.53623 .90224 m .4759 .90495 L .43116 .89856 L p 1 0 0 r
F P
0 0 0 r
s
.37125 .90139 m .43116 .89856 L .4759 .90495 L p 1 0 0 r
F P
0 0 0 r
s
.43116 .89856 m .37125 .90139 L .33378 .43243 L p 0 1 1 r
F P
0 0 0 r
s
.33378 .43243 m .39182 .42203 L .43116 .89856 L p 0 1 1 r
F P
0 0 0 r
s
.26204 .89767 m .33378 .43243 L .37125 .90139 L p .5 0 1 r
F P
0 0 0 r
s
.39182 .42203 m .33378 .43243 L .28356 .4079 L p 1 0 0 r
F P
0 0 0 r
s
.33378 .43243 m .26204 .89767 L .20669 .8907 L p 0 1 1 r
F P
0 0 0 r
s
.20669 .8907 m .28356 .4079 L .33378 .43243 L p 0 1 1 r
F P
0 0 0 r
s
.40848 .15949 m .51443 .17897 L .45423 .19332 L 1 0 0 r
F
.34872 .17446 m .40848 .15949 L .45423 .19332 L F
.37125 .90139 m .31328 .90412 L .26204 .89767 L p .5 0 1 r
F P
0 0 0 r
s
.20461 .90053 m .26204 .89767 L .31328 .90412 L p 1 0 0 r
F P
0 0 0 r
s
.9283 .90117 m .86128 .90392 L .83114 .89745 L p 1 0 0 r
F P
0 0 0 r
s
.76427 .90031 m .83114 .89745 L .86128 .90392 L p 1 0 0 r
F P
0 0 0 r
s
.74309 .16876 m .80987 .1536 L .84091 .18786 L 1 0 0 r
F
.76427 .90031 m .69956 .90308 L .66299 .89655 L p F P
0 0 0 r
s
.59856 .89944 m .66299 .89655 L .69956 .90308 L p 1 0 0 r
F P
0 0 0 r
s
.64095 .14883 m .74309 .16876 L .67849 .18344 L 1 0 0 r
F
.57664 .16415 m .64095 .14883 L .67849 .18344 L F
.59856 .89944 m .53623 .90224 L .49309 .89564 L p F P
0 0 0 r
s
.43116 .89856 m .49309 .89564 L .53623 .90224 L p 1 0 0 r
F P
0 0 0 r
s
.49309 .89564 m .43116 .89856 L .39182 .42203 L p 0 1 1 r
F P
0 0 0 r
s
.39182 .42203 m .45179 .41128 L .49309 .89564 L p 0 1 1 r
F P
0 0 0 r
s
.45179 .41128 m .39182 .42203 L .34303 .39667 L p 1 0 0 r
F P
0 0 0 r
s
.28356 .4079 m .34303 .39667 L .39182 .42203 L p 1 0 0 r
F P
0 0 0 r
s
.47027 .14401 m .57664 .16415 L .51443 .17897 L 1 0 0 r
F
.40848 .15949 m .47027 .14401 L .51443 .17897 L F
.83114 .89745 m .90029 .89449 L .9283 .90117 L p F P
0 0 0 r
s
.90029 .89449 m .83114 .89745 L .78315 .41793 L p 0 1 1 r
F P
0 0 0 r
s
.78315 .41793 m .85002 .40705 L .90029 .89449 L p 0 1 1 r
F P
0 0 0 r
s
.72963 .89355 m .78315 .41793 L .83114 .89745 L p .5 0 1 r
F P
0 0 0 r
s
.85002 .40705 m .78315 .41793 L .74941 .39225 L p 1 0 0 r
F P
0 0 0 r
s
.78315 .41793 m .72963 .89355 L .68276 .40362 L p .5 1 0 r
F P
0 0 0 r
s
.68276 .40362 m .74941 .39225 L .78315 .41793 L p .5 1 0 r
F P
0 0 0 r
s
.26204 .89767 m .20461 .90053 L .14794 .89379 L p 1 0 0 r
F P
0 0 0 r
s
.83114 .89745 m .76427 .90031 L .72963 .89355 L p .5 0 1 r
F P
0 0 0 r
s
.66299 .89655 m .72963 .89355 L .76427 .90031 L p 1 0 0 r
F P
0 0 0 r
s
.72963 .89355 m .66299 .89655 L .61831 .41462 L p 0 1 1 r
F P
0 0 0 r
s
.61831 .41462 m .68276 .40362 L .72963 .89355 L p 0 1 1 r
F P
0 0 0 r
s
.55716 .89261 m .61831 .41462 L .66299 .89655 L p .5 0 1 r
F P
0 0 0 r
s
.68276 .40362 m .61831 .41462 L .57788 .38867 L p 1 0 0 r
F P
0 0 0 r
s
.61831 .41462 m .55716 .89261 L .51378 .40017 L p .5 1 0 r
F P
0 0 0 r
s
.51378 .40017 m .57788 .38867 L .61831 .41462 L p .5 1 0 r
F P
0 0 0 r
s
.70747 .13298 m .80987 .1536 L .74309 .16876 L 1 0 0 r
F
.64095 .14883 m .70747 .13298 L .74309 .16876 L F
.66299 .89655 m .59856 .89944 L .55716 .89261 L p .5 0 1 r
F P
0 0 0 r
s
.49309 .89564 m .55716 .89261 L .59856 .89944 L p 1 0 0 r
F P
0 0 0 r
s
.55716 .89261 m .49309 .89564 L .45179 .41128 L p 0 1 1 r
F P
0 0 0 r
s
.45179 .41128 m .51378 .40017 L .55716 .89261 L p 0 1 1 r
F P
0 0 0 r
s
.51378 .40017 m .45179 .41128 L .40454 .38506 L p 1 0 0 r
F P
0 0 0 r
s
.34303 .39667 m .40454 .38506 L .45179 .41128 L p 1 0 0 r
F P
0 0 0 r
s
.5342 .12799 m .64095 .14883 L .57664 .16415 L 1 0 0 r
F
.47027 .14401 m .5342 .12799 L .57664 .16415 L F
.74941 .39225 m .81837 .38049 L .85002 .40705 L p F P
0 0 0 r
s
.14794 .89379 m .20669 .8907 L .26204 .89767 L p 1 0 0 r
F P
0 0 0 r
s
.74941 .39225 m .68276 .40362 L .64423 .37678 L p 1 0 0 r
F P
0 0 0 r
s
.57788 .38867 m .64423 .37678 L .68276 .40362 L p 1 0 0 r
F P
0 0 0 r
s
.70747 .13298 m .77632 .11657 L .80987 .1536 L 1 0 0 r
F
.57788 .38867 m .51378 .40017 L .4682 .37304 L p F P
0 0 0 r
s
.40454 .38506 m .4682 .37304 L .51378 .40017 L p 1 0 0 r
F P
0 0 0 r
s
.60037 .11141 m .70747 .13298 L .64095 .14883 L 1 0 0 r
F
.5342 .12799 m .60037 .11141 L .64095 .14883 L F
.81837 .38049 m .74941 .39225 L .71292 .36447 L p F P
0 0 0 r
s
.64423 .37678 m .71292 .36447 L .74941 .39225 L p 1 0 0 r
F P
0 0 0 r
s
.64423 .37678 m .57788 .38867 L .53413 .36059 L p 1 0 0 r
F P
0 0 0 r
s
.4682 .37304 m .53413 .36059 L .57788 .38867 L p 1 0 0 r
F P
0 0 0 r
s
.66891 .09424 m .77632 .11657 L .70747 .13298 L 1 0 0 r
F
.60037 .11141 m .66891 .09424 L .70747 .13298 L F
.71292 .36447 m .78409 .35171 L .81837 .38049 L p F P
0 0 0 r
s
.71292 .36447 m .64423 .37678 L .60246 .34769 L p 1 0 0 r
F P
0 0 0 r
s
.53413 .36059 m .60246 .34769 L .64423 .37678 L p 1 0 0 r
F P
0 0 0 r
s
.66891 .09424 m .73995 .07644 L .77632 .11657 L 1 0 0 r
F
.78409 .35171 m .71292 .36447 L .67331 .33432 L p F P
0 0 0 r
s
.60246 .34769 m .67331 .33432 L .71292 .36447 L p 1 0 0 r
F P
0 0 0 r
s
.67331 .33432 m .74683 .32044 L .78409 .35171 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00002Qolc<c07ooooo001X
olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?l000000oo<c<`2o`000005olc<c?l0
003oc<c<olc<c?l000000oo<c<`00ol0003oc<c<olc<c02Nolc<c07ooooo001Xolc<c004o`000?o<
c<co0000olc<c0;o00000oo<c<`3o`000004olc<c?l0003oc<c<o`0000;oc<c<00Go0000olc<c?o<
c<coc<c<o`000019olc<c0?o0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<05;oc<c<0Oooool006Soc<c<00?o0000olc<c?o<c<`0
2_o<c<`00ol0003oc<c<o`00000Lolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Lolc<c0Co000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<
olc<c01Aolc<c07ooooo002Eolc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`06?o<
c<`4o`0000Goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c01@olc<c07ooooo002E
olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0000ooc<c<00?o0000
olc<c?o<c<`0Coo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c01>olc<c07ooooo002Folc<c003o`000?o<c<coc<c<00Coc<c<1Ol0000@olc<c0Co
00006Oo<c<`00ol0003oc<c<olc<c01=olc<c07ooooo002Golc<c003o`000?o<c<coc<c<00?oc<c<
00?o0000olc<c?o<c<`03oo<c<`3o`0000;oc<c<00?o0000olc<c?o<c<`06Oo<c<`00ol0003oc<c<
olc<c01<olc<c07ooooo002Holc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`02_o<
c<`4o`0002;oc<c<00?o0000olc<c?o<c<`02_o<c<`00ol0003oc<c<olc<c00nolc<c07ooooo002C
olc<c0Ko00001Oo<c<`5o`0000Coc<c<1?l000000oo<c<co0000olc<c00Solc<c003o`000?o<c<co
c<c<00[oc<c<00?o0000olc<c?o<c<`0?_o<c<`1ooooo`00Y?o<c<`3o`0000Goc<c<00?o0000olc<
c?o<c<`08oo<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coc<c<03koc<c<0Oooool007?o
c<c<1?l0000Yolc<c0Go0000;_o<c<`00ol0003oc<c<olc<c008olc<c003o`000?o<c<coc<c<03ko
c<c<0Oooool007;oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Rolc<c0Co0000
1?o<c<`00ol0003oc<c<olc<c00]olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0
?_o<c<`1ooooo`00Moo<c<`00ol0003oc<c<olc<c00Oolc<c0?o0000>Oo<c<`2o`0000Ooc<c<00?o
0000olc<c?o<c<`0?_o<c<`1ooooo`00Moo<c<`00ol0003oc<c<olc<c00Kolc<c0Co00000_o<c<`0
0ol0003oc<c<olc<c00folc<c003o`000?o<c<co000000Goc<c<0ol00010olc<c07ooooo001bolc<
c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`05oo<c<`4o`0000Koc<c<00?o0000olc<
c?o<c<`0>Oo<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<03koc<c<0Oooool007;o
c<c<1Ol0000Golc<c0?o00000_o<c<`00ol0003oc<c<olc<c011olc<c003o`000?o<c<coc<c<00Co
c<c<00?o0000olc<c?o<c<`0?_o<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c00Eolc<c0Co0000
B_o<c<`00ol0003oc<c<olc<c014olc<c07ooooo001colc<c003o`000?o<c<coc<c<013oc<c<1?l0
00000oo<c<co0000olc<c01<olc<c003o`000?o<c<coc<c<00Ooc<c<1_l0000folc<c07ooooo001c
olc<c0Go00002oo<c<`3o`0004Woc<c<0_oo0009olc<c003o`000?o<c<coc<c<00Koc<c<00?o0000
olc<c?o<c<`0>Oo<c<`1ooooo`00Ooo<c<`4o`000003olc<c?l0003oc<c<04Koc<c<1_oo0009olc<
c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0>?o<c<`1ooooo`00BOo<c<`6o`0000;o
c<c<00?o0000olc<c?o<c<`01?l0000Solc<c0Co0000BOo<c<`;ool000Woc<c<00?o0000olc<c?o<
c<`01_o<c<`2o`0003Soc<c<0Oooool004Woc<c<00?o0000olc<c?o<c<`01oo<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<coc<c<01goc<c<0ol000000oo<c<co0000olc<c017olc<c0ooo`00
2Oo<c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<coc<c<03Goc<c<0Oooool004[oc<c<00?o
0000olc<c?o<c<`02oo<c<`00ol0003oc<c<olc<c00Iolc<c0Co00001?o<c<`00ol0003oc<c<olc<
c013olc<c1?oo`001oo<c<`3o`0000Woc<c<00?o0000olc<c?o<c<`0=?o<c<`1ooooo`00Boo<c<`2
o`0000_oc<c<00?o0000olc<c?o<c<`05_o<c<`3o`000003olc<c?l0003oc<c<04Ooc<c<6?oo0008
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00d
olc<c07ooooo001=olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0
003oc<c<olc<c00Bolc<c0Co00001?o<c<`00ol0003oc<c<olc<c012olc<c1goo`002?o<c<`01Ol0
003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`0=?o<c<`1ooooo`00C_o<c<`00ol0
003oc<c<olc<c002olc<c0Go00004Oo<c<`5o`0004Soc<c<8_oo0008olc<c004o`000?o<c<coc<c<
olc<c0Co0000=oo<c<`1ooooo`00BOo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04?o<c<`3o`0000Coc<c<00?o0000olc<c?o<c<`0@_o<c<`Wool0
00Soc<c<00?o0000olc<c?o<c<`02?o<c<`4o`0002ooc<c<0Oooool004Woc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00_oc<c<1Ol00017olc<c2co
o`002?o<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<
c<`0;?o<c<`1ooooo`00B_o<c<`4o`0000Koc<c<1Ol00005olc<c0Co00001?o<c<`00ol0003oc<c<
olc<c011olc<c33oo`002Oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00;oc<c<
00?o0000olc<c?o<c<`0;?o<c<`1ooooo`00;oo<c<`4o`0002Soc<c<0ol000000oo<c<co0000olc<
c016olc<c3Coo`002Oo<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coc<c<02coc<c<0Ooo
ool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Qolc<c0Co0000B?o<c<`i
ool000Woc<c<00?o0000olc<c?o<c<`01Oo<c<`3o`0002ooc<c<0Oooool002koc<c<00?o0000olc<
c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Molc<c0Co000000?oc<c<o`000?o<c<`0A?o<c<`oool0
00Ooc<c<0ol00009olc<c003o`000?o<c<coc<c<01?oc<c<1?l000001?o<c<co0000olc<c?o<c<`4
o`0000;oc<c<00Oo0000olc<c?o<c<coc<c<o`000?o<c<co000000Coc<c<0Oooool002koc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Jolc<c0?o0000A_o<c<a5ool000Soc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01;oc<c<00?o
0000olc<c?o<c<`00_o<c<`2o`000003olc<c?l0003oc<c<00?oc<c<00?o0000olc<c?l000000oo<
c<`00ol0003oc<c<olc<c004olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000
olc<c?o<c<`05_o<c<`4o`000003olc<c?l0003oc<c<047oc<c<Booo0008olc<c005o`000?o<c<co
c<c<olc<c?l000001?o<c<`00ol0003oc<c<olc<c00Aolc<c003o`000?o<c<coc<c<00Coc<c<00?o
0000olc<c?l000001_o<c<`01Ol0003oc<c<olc<c?o<c<co000000Koc<c<0Oooool002koc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001Oo<c<`00ol0003oc<c<olc<
c00kolc<c57oo`002?o<c<`01?l0003oc<c<olc<c?o<c<`4o`0001Coc<c<00?o0000olc<c?o<c<`0
1?o<c<`00ol0003oc<c<o`000005o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?o<c<`0
1?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00ooc<c<0ol0
0002olc<c003o`000?o<c<coc<c<03ooc<c<EOoo0008olc<c003o`000?o<c<coc<c<00[oc<c<00?o
0000olc<c?o<c<`02oo<c<`01?l0003oc<c<olc<c?o<c<`4o`000003olc<c?l0003oc<c<00?oc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c004olc<c07ooooo000^olc<c003o`000?o<
c<coc<c<00;oc<c<00?o0000olc<c?o<c<`02oo<c<`4o`0004?oc<c<F_oo0008olc<c003o`000?o<
c<coc<c<00Woc<c<00?o0000olc<c?o<c<`02oo<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<
c<coc<c<00;oc<c<00Co0000olc<c?l0003o00000_o<c<`00ol0003oc<c<olc<c004olc<c07ooooo
000_olc<c0Co00002_o<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`0?_o<c<aMool000Woc<c<00?o
0000olc<c?o<c<`01?o<c<`6o`0000coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<
c004o`0000;oc<c<00Co0000olc<c?l0003o00001oo<c<`1ooooo`00>_o<c<`4o`0004?oc<c<H_oo
0008olc<c003o`000?o<c<coc<c<00Coc<c<00Go0000olc<c?o<c<coc<c<o`00000>olc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`1ooooo`00=_o<c<`4o`0000?oc<c<00?o
0000olc<c?o<c<`0?_o<c<`[ool000CoOol0=ooo0008olc<c0;o00001Oo<c<`01?l0003oc<c<olc<
c?l0000?olc<c0Co00005Oo<c<`1ooooo`00<_o<c<`4o`000003olc<c?l0003oc<c<047oc<c<:ooo
0009ogoo02;oo`000omoo`0Bool000Koc<c<00?o0000olc<c?l000001_o<c<`00ol0003oc<c<o`00
000Xolc<c07ooooo000_olc<c0?o0000AOo<c<`[ool000goOol07Ooo0008ogoo01;oo`002?o<c<`0
0ol0003oc<c<olc<c003olc<c003o`000?o<c<co000002Soc<c<0Oooool002goc<c<0_l000000oo<
c<co0000olc<c011olc<c2_oo`004_moo`0Iool000coOol04_oo0008olc<c003o`000?o<c<coc<c<
00?oc<c<0_l0000Xolc<c07ooooo000]olc<c004o`000?o<c<coc<c<o`0003goc<c<;?oo0004o`3o
oa?oOol05?oo000Aogoo01;oo`002?o<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<
olc<c0Co00008Oo<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHholc<c2coo`002_l0oolC
ogoo00ooo`001?l0oolBogoo01;oo`002?o<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`07_o<c<`1ooooo`00;Oo<c<`2o`000003olc<c?mVIVKoc<c<
03?oc<c<1?l0oolWool0017o0?oo4_moo`09ool000[o0?oo4_moo`0?ool000?o0?oo2?o<c<`00ol0
003oc<c<olc<c009olc<c003o`000?o<c<coc<c<01koc<c<0Oooool002goc<c<00Co0000olc<c?o<
c<coIVIV;oo<c<`:o`3oob;oo`005_l0oolBogoo00?oo`004?l0oolBogoo00Woo`002Ol0ool7olc<
c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<c?o<c<`07_o<c<`1ooooo`00;Oo<c<`01?l0003o
c<c<olc<c?mVIVH[olc<c0oo0?oo7?oo000Lo`3oo`ooOol01?mo0?lBo`3ooa;oOol00ooo000?o`3o
o`Koc<c<0ol00004olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`07_o<c<`1oooo
o`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHWolc<c0Coo`004Ol0oolEool002?o0?oo2?moo`0:ogl0
oa;o0?oo3omoo`03ogl0oa;o0?oo1oo<c<`00ol0003oc<c<olc<c002olc<c0Go00008Oo<c<`1oooo
o`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHTolc<c0Soo`004Ol0ool@ool002So0?oo0_moo`0@ogl0
oa;o0?oo2Omoo`09ogl0oa;o0?oo1oo<c<`01Ol0003oc<c<olc<c?o<c<co000002Goc<c<0Oooool0
02goc<c<00Co0000olc<c?o<c<coIVIV8Oo<c<`<ool001;o0?oo2ooo000Yo`3oo`Coo`004Omo0?lB
o`3oo`?oOol03omo0?lBo`3oo`Ooc<c<00Go0000olc<c?o<c<coc<c<o`000005olc<c0Co00006oo<
c<`1ooooo`00;?o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01koc<c<4Ooo000Ao`3oo`Koo`00:_l0
ool8ool0017oO`3o3ol0ool4ool0017oO`3o4_l0ool7olc<c003o`000?o<c<coc<c<00Ko00001?o<
c<`00ol0003oc<c<olc<c00Holc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQooc<c<4_oo
000Ao`3oo`;oo`00:Ol0ool=ool0017oO`3o2ol0ool8ool0017oO`3o3ol0ool2ool000Soc<c<00?o
0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01Soc<c<0Ooo
ool002coc<c<00Co0000olc<c?o<c<coIVIV8Oo<c<`Bool000go0?oo1?mo0?lVo`3ooa7oo`004Omo
0?l6o`3oo`goo`004Omo0?l9o`3oo`Soo`002?o<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<
c<coc<c<00;oc<c<00?o0000olc<c?o<c<`06?o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mV
IVHRolc<c1;oo`001ol0ool:ogl0ob7o0?oo5_oo000Aogl0o`;o0?oo4Ooo000Aogl0o`?o0?oo3_oo
0006olc<c0?o00001?o<c<`2o`0000?oc<c<00?o0000olc<c?o<c<`06?o<c<`1ooooo`00;?o<c<`0
1?l0003oc<c<olc<c?mVIVHTolc<c17oo`000_l0ool@ogl0oa[o0?oo7?oo000>ogl0oaKoo`003_mo
0?lDool000Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<o`000002o`0001_oc<c<0Ooo
ool002coc<c<0_l000000oo<c<coIVIVolc<c00Uolc<c17oo`004_mo0?lCo`3oob;oo`002?mo0?lL
ool000SoO`3o6_oo0007olc<c005o`000?o<c<coc<c<olc<c?l000007oo<c<`1ooooo`00;?o<c<`0
1?l0003oc<c<olc<c?mVIVHWolc<c1;oo`004Omo0?l>o`3oobOoo`000_mo0?lRool000;oO`3o8?oo
0007olc<c005o`000?o<c<coc<c<olc<c?l000000oo<c<`00ol0003oc<c<o`00000Holc<c07ooooo
000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`03?o<c<`Bool0017oO`3o
1ol0oomcool000Ooc<c<00Co0000olc<c?o<c<coc<c<0ol00002olc<c003o`000?o<c<coc<c<01Ko
c<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00>olc<c17o
o`004Omo0?l2o`3oogGoo`000_mo0?l8olc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<
c<`05Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<013o
c<c<4Ooo000<ogl0ogGoo`002?mo0?l8olc<c003o`000?o<c<coc<c<00Goc<c<00?o0000olc<c?o<
c<`05Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01;o
c<c<4Ooo0003ogl0ogOoo`003_mo0?l6olc<c0?o00001oo<c<`00ol0003oc<c<olc<c00Dolc<c07o
oooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`04oo<c<b8ool0017o
O`3o1oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<01Coc<c<0Oooool002coc<c<
00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Eolc<c8Ooo`004Omo0?l7olc<c003
o`000?o<c<coc<c<00Goc<c<00?o0000olc<c?o<c<`01?l0000?olc<c07ooooo000/olc<c004o`00
0?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05oo<c<b6ool0017oO`3o1oo<c<`00ol0003o
c<c<olc<c005olc<c0;o00001?o<c<`00ol0003oc<c<olc<c00<olc<c07ooooo000/olc<c004o`00
0?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`06Oo<c<b5ool0017oO`3o1oo<c<`00ol0003o
c<c<o`000006o`0000Coc<c<00?o0000olc<c?o<c<`03?o<c<`1ooooo`00;?o<c<`2o`000003olc<
c?mVIVKoc<c<01Woc<c<00?oIVIVolc<c?o<c<`06oo<c<b4ool000koO`3o0omoo`07olc<c003o`00
0?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00<olc<c07ooooo
000[olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`07Oo<c<b3ool000SoO`3o
2Omoo`06olc<c0;o00001_o<c<`4o`0000ooc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV
6oo<c<`00omVIVKoc<c<olc<c00Nolc<c8?oo`000_mo0?l?ogoo00Ooc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00coc<c<0Oooool002_oc<c<00Co
0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Qolc<c7koo`001?l0oolAogoo00?oc<c<
00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00coc<c<
0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIV
I_o<c<coc<c<00coc<c<MOoo000<o`3ooa7oOol00_o<c<`00omVIVKoc<c<olc<c005olc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03?o<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<
c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`03_o<c<a^ool000?oO`3o
3ol0oolAogoo0003olc<c?mVIVKoc<c<00Ooc<c<1?l0000?olc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00?olc<c6Soo`00
2Omo0?l?o`3oo`koOol00oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Aolc<c67oo`00
3omo0?l?o`3oo`SoOol02?o<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Bolc<c63oo`00
4?mo0?l?o`3oo`;oOol03Oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`000?o<
c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Dolc<c5[oo`00
1?l000000ooo003oO`3oogl0o`0>ogl0o`_o0?oo4_o<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo
000[olc<c0;oIVIV00?o0000ofIVI_o<c<`06Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<
c<coc<c<01Goc<c<EOoo0004o`0000Coo`0000?o0000ool00?oo00003omo0?l3o`3ooaWoc<c<00?o
IVIVolc<c?o<c<`06Oo<c<`1ooooo`008?o<c<`4o`0000Ooc<c<00Co0000olc<c?mVIVKoIVIV6_o<
c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Ooc<c<C_oo0005o`0000Woo`0000?o
0000ool00?oo00002omo0?lOolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool001ooc<c<00?o0000
olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<00?oIVIV6?o<c<`0
0omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Woc<c<B?oo0004o`0000ooo`0000?o0000
ool00?oo00000omo0?l4olc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1
ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<
c?o<c<coIVIV0_o<c<`2ofIVIQKoc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00J
olc<c4;oo`001Ol0000Dool00003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`08?o<c<`0
0omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<
c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH4olc<c0?oIVIV4oo<c<`00omVIVKoc<c<olc<c00D
olc<c003ofIVI_o<c<coc<c<01coc<c<>_oo0006o`0000Goo`0000?o0000ool00?oo00004_oo0000
0ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1
ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<
c?o<c<coIVIV1oo<c<`2ofIVIQ7oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00A
olc<c003ofIVI_o<c<coc<c<00[oc<c<<ooo0005o`0000coo`0000?o0000ool00?oo00004_oo0000
0ol0003oc<c<olc<c004olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1
ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00?oc<c<00Go0000olc<
c?o<c<coc<c<ofIVIP09olc<c0;oIVIV3oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<co
c<c<017oc<c<00?oIVIVolc<c?o<c<`02oo<c<`/ool000Ko00004_oo0002o`0001?oo`0000?o0000
olc<c?o<c<`00oo<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool0
01ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<
ofIVIPcoc<c<0_mVIVH=olc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`04Oo<c<`0
0omVIVKoc<c<olc<c00=olc<c2Goo`001Ol00005ool00003o`000?oo003oo`0001;oo`0000?o0000
ool00?oo00003_oo00000ol0003oo`00ool00002o`0000?oc<c<00?oIVIVolc<c?o<c<`08?o<c<`0
0omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<
c?o<c<`00oo<c<`01?l0003oc<c<olc<c?mVIVH>olc<c0;oIVIV2oo<c<`00omVIVKoc<c<olc<c00D
olc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`03_o<c<`Oool000Go00002ooo0002
o`0001?oo`0000?o0000ool00?oo00001ooo0006o`0000Goo`0000Co0000olc<c?o<c<coIVIV8_o<
c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Polc<c0Co00001_o<c<`01?l0003oc<c<olc<c?mV
IVH@olc<c0;oIVIV2Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<00?o
IVIVolc<c?o<c<`04?o<c<`Gool000Ko00004_oo00000ol0003oo`00ool0000Aool00004o`000?oo
003oo`00ool000Go00003?oo00000ol0003oc<c<ofIVIP0Rolc<c003ofIVI_o<c<coc<c<01Soc<c<
0Oooool002[oc<c<0_l000000oo<c<coIVIVolc<c00Aolc<c0;oIVIV1oo<c<`00omVIVKoc<c<olc<
c00Colc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`04_o<c<`@ool000Go00001Ooo
0002o`0001;oo`0000?o0000ool00?oo00003_oo00000ol0003oo`00ool00003o`0001;oo`000_l0
000Rolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV5?o<
c<`2ofIVIPGoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<
c<coc<c<01?oc<c<2_oo0005o`0000coo`0000?o0000ool00?oo00004?oo0002o`0000Woo`001Ol0
0005ool00003o`000?oo003oo`0001;oo`0000?o0000olc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<
c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQKoc<c<0_mVIVH3olc<c003ofIVI_o<
c<coc<c<01?oc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Eolc<c0?oo`001Ol0
000Bool000;o00004_oo00001?l0003oo`00ool00?oo0005o`0000_oo`000_l0000Cool00003o`00
0?o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<
c?mVIVHHolc<c0?oIVIV5_o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<01?oc<c<
1Ol00004ool000;o00004ooo0002o`0000goo`000_l00002ool000?o00004_oo00000ol0003oo`00
ool0000Aool00003o`000?o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<
c<`01?l0003oc<c<olc<c?mVIVHJolc<c0?oIVIV5?o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIV
I_o<c<coc<c<00koc<c<1Ol0000;ool000;o00004ooo00000ol0003oo`00ool00002ool000So0000
1_oo00000ol0003oo`00ool0000Aool000;o00002Ooo0005o`0000Coo`0000?o0000olc<c?o<c<`0
7?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<
00?oIVIVolc<c?o<c<`00_mVIVHBolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`0
1oo<c<`7o`0001;oo`0000?o0000ool00?oo00004Ooo0004o`0000ooo`000_l0000Cool00004o`00
0?oo003oo`00ool000Go00002_oo00000ol0003oc<c<olc<c00Kolc<c003ofIVI_o<c<coc<c<01So
c<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c002olc<c0;o
IVIV4?o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00Oo00001_oo0002o`0001;o
o`000_l0000:ool000Go00001?moo`000ol0003oo`00ool0000@ool00003o`000?oo003oo`00017o
o`000ol0000@ool00003o`000?o<c<coc<c<01[oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00
:_o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00Coc<c<0_mVIVH>olc<c003
ofIVI_o<c<coc<c<00ooc<c<1_l0000?ool000;o00004_oo0002o`0000?oo`001Ol0000:ogoo0003
o`000?oo003oo`00013oo`000_l00009ool000Go00001Omoo`000ol0003oo`00ool0000?ool00003
o`000?o<c<coc<c<01Woc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<
olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00Koc<c<0_mVIVH<olc<c003ofIVI_o<c<coc<c<00[o
c<c<1Ol00004ool000;o00004Ooo00000ol0003oo`00ool0000Aool000?o00004?moo`02o`0001;o
o`0000Co0000ool00?oo003oo`001Ol0000;ogoo0003o`000?oo003oo`0000ooo`0000?o0000olc<
c?o<c<`06?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIV
IQ[oc<c<00?oIVIVolc<c?o<c<`02?o<c<`2ofIVIP[oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`5o`00
00_oo`000_l0000@ool000;o00002_oo0005o`0000;o0?oo00?o0000ogoo0?moo`004_moo`000ol0
003oo`00ool0000=ool00003o`000?oo003oo`0000?o00004Omoo`02o`00013oo`0000?o0000olc<
c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIV
IQ[oc<c<00?oIVIVolc<c?o<c<`02_o<c<`2ofIVIPSoc<c<00?oIVIVolc<c?o<c<`00oo<c<`2o`00
01;oo`000_l0000@ool000;o00000ooo0005o`0000Oo0?oo00?o0000ogoo0?moo`004omoo`000ol0
003oo`00ool00007ool000Go00000ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?oo003oo`00
00[oo`000_l00002ool00003o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`06?o<c<`1oooo
o`00:_o<c<`2o`000003olc<c?mVIVKoc<c<01Woc<c<00?oIVIVolc<c?o<c<`03?o<c<`3ofIVIPGo
c<c<00?oIVIVolc<c?o<c<`00oo<c<`01?l0003o0?ooo`000?l0000Bool000;o00003Ooo00000ol0
003oo`00ool00003o`0000co0?oo00?o0000ogoo0?moo`005?moo`001?l0003oo`00ool00?oo0005
o`0000So0?oo00?o0000ogoo0?moo`005?moo`000ol0003oo`00ool00002ool000Oo00001?l0ool0
0ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002Woc<c<00Go0000olc<
c?o<c<coc<c<ofIVIP0Jolc<c003ofIVI_o<c<coc<c<00ooc<c<0_mVIVH3olc<c003ofIVI_o<c<co
c<c<00?oc<c<00Co0000o`3oool0oooo0?oo0_l0000Bool000;o00001?oo0007o`0001;o0?oo00?o
0000ogoo0?moo`005Omoo`03o`0000go0?oo00?o0000ogoo0?moo`005Omoo`04o`0000_o0?oo00?o
0000olc<c?o<c<`05oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`2ofIVIP03olc<c?mVIVKoc<c<00Coc<c<00?o
0000o`3oool0ool00ol0ool2o`0001;oo`001?l0000Io`3oo`03o`000?moo`3oOol001GoOol000?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?l0oooo0?oo00co0?oo00?o
0000olc<c?o<c<`05oo<c<`4ofIVIQKoc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<
c<`00omVIVKoc<c<olc<c00Colc<c0;oIVIV1?o<c<`00ol0003o0?ooo`3oo`06o`3oo`;o00002Ooo
0005o`00013o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Eogoo0003o`000?l0
oooo0?oo00go0?oo00?o0000ogoo0?moo`005Omoo`000ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<
c<coc<c<013oc<c<2?mVIVHIolc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`3ofIVIP;oc<c<00?o0000o`3oool0ool02?l0ool2o`0000;oo`001Ol0
000Eo`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`005?moo`000ol0003o0?ooo`3o
o`0>o`3oo`03o`000?moo`3oOol001CoOol000?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<
c00:olc<c0KoIVIV1oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c002ofIVIP03o`000?l0
oooo0?oo00[o0?oo0_l0000<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo000Dogoo0003o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`005?mo
o`000ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<00;oc<c<1omVIVH=olc<c003ofIVI_o<
c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c00Dolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0ool02_l0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
000Cogoo00;o00004?l0ool00ol0003oOol0ogoo000Cogoo00;o00003ol0ool00ol0003oIVIVofIV
IP02ofIVIQCoc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mV
IVHKolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3o
o`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool06ol0ool00ol0003oOol0ogoo
000Cogoo0003o`000?mo0?oo000000oo0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00
000>o`3oo`03o`000?o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`0
1?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`00_o<
c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001?oOol000?o0000ogl0ool000003ol0
ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?oo000000ko0?oo00?o0000olc<c?o<c<`05_o<
c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`01OmVIVKoc<c<olc<c?o<c<co000000co0?oo0_l0000Lo`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00000?o`3oo`03o`00
0?moo`3oOol001?oOol000?o0000ogl0ool000003_l0ool00ol0003oc<c<olc<c00Folc<c003ofIV
I_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<
olc<c00Dolc<c005ofIVI_o<c<coc<c<olc<c?l000003?l0ool2o`0000ko0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001?oOol000?o0000ogl0ool0
00003ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?oo000000ko0?oo00?o0000olc<c?o<
c<`05_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c0;o000000?oc<c<ofIVI_o<c<`0
6_o<c<`00omVIVKoc<c<olc<c00Dolc<c005ofIVI_o<c<coc<c<olc<c?l000003?l0ool2o`0000ko
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001?o
Ool000?o0000ogl0ool000003ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?oo000000ko
0?oo00?o0000olc<c?o<c<`05_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`00
0?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`01OmVIVKoc<c<olc<c?o<c<co0000
00co0?oo00?o0000ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00000?o`3oo`03o`000?moo`3oOol0
01?oOol000?o0000ogl0ool000003_l0ool00ol0003oc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<
01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Eolc<
c005ofIVI_o<c<coc<c<olc<c?l000003?l0ool00ol0003oO`3oo`00000=o`3oo`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?oo
000000oo0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00000>o`3oo`03o`000?o<c<co
c<c<01Koc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHJ
olc<c003ofIVI_o<c<coc<c<01Goc<c<00GoIVIVolc<c?o<c<coc<c<o`00000<o`3oo`03o`000?mo
0?oo000000go0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol001;oOol000Co0000ogl0oomo0?oo00003ol0ool00ol0003oOol0ogoo000Cogoo0003o`00
0?mo0?oo000000oo0?oo00?o0000olc<c?o<c<`05Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo
000Yolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`01OmVIVKoc<c<
olc<c?o<c<co000000co0?oo00?o0000ogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004_moo`001?l0003oO`3oogl0ool0000@o`3o
o`03o`000?moo`3oOol0017oOol000Co0000ogl0oomo0?oo00003ol0ool00ol0003oc<c<olc<c00?
olc<c003o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0
003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Goc<c<00CoIVIVolc<c?o<c<co00003?l0
ool01?l0003oO`3oogl0ool0000=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo000Aogoo0004o`000?mo0?ooO`3oo`00013o0?oo00?o0000ogoo0?mo
o`004Omoo`001?l0003oO`3oogl0ool0000?o`3oo`03o`000?o<c<coc<c<00ooc<c<0_l00004olc<
c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omV
IVKoc<c<olc<c00Eolc<c004ofIVI_o<c<coc<c<o`0000co0?oo00Co0000ogl0oomo0?oo00003Ol0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004Omo
o`001?l0003oO`3oogl0ool0000@o`3oo`03o`000?moo`3oOol0017oOol000Co0000ogl0oomo0?oo
00003ol0ool00ol0003oc<c<olc<c00?olc<c003o`000?moo`3o000000?oc<c<00?oIVIVolc<c?o<
c<`05oo<c<`1ooooo`00:?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01Go
c<c<00CoIVIVolc<c?o<c<co00003?l0ool01?l0003oO`3oogl0ool0000=o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Aogoo0005o`000?mo0?oo
O`3oogl0ool000003ol0ool00ol0003oOol0ogoo000Aogoo0005o`000?mo0?ooO`3oogl0ool00000
3_l0ool00ol0003oc<c<olc<c00?olc<c004o`000?moo`3oOol0o`0000;oc<c<00?oIVIVolc<c?o<
c<`05oo<c<`1ooooo`00:?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01Co
c<c<00GoIVIVolc<c?o<c<coc<c<o`00000<o`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0017oOol000Go0000
ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?moo`3oOol0017oOol000Go0000ogl0oomo0?ooO`3o
o`00000>o`3oo`03o`000?o<c<coc<c<00ooc<c<00Oo0000ogoo0?moo`3oOol0o`000?o<c<coIVIV
01Woc<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Dolc<
c005ofIVI_o<c<coc<c<olc<c?l000003?l0ool01?l0003oO`3oogl0ool0000=o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Aogoo0005o`000?mo
0?ooO`3oogl0ool000003ol0ool00ol0003oOol0ogoo000Aogoo0005o`000?mo0?ooO`3oogl0ool0
00003_l0ool00ol0003oc<c<olc<c00>olc<c003ogl0ool0003oOol000?oOol000?o0000olc<c?mV
IVH06?o<c<`1ooooo`00:?o<c<`3o`000003ofIVI_o<c<coc<c<01Woc<c<00?oIVIVolc<c?o<c<`0
5?o<c<`01OmVIVKoc<c<olc<c?o<c<co000000co0?oo00Co0000ogl0oomo0?oo00003Ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`001Ol0
003oO`3oogl0oomo0?oo000000oo0?oo00?o0000ogoo0?moo`004Omoo`001Ol0003oO`3oogl0oomo
0?oo000000ko0?oo00?o0000olc<c?o<c<`02_o<c<`4o`000003ogl0ool0003oOol000?oOol00_o<
c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Lolc<c0Ko00001_o<c<`2ofIVIP03olc<c?mVIVKo
c<c<01[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`01?mVIVKoc<c<olc<c?l0000<o`3oo`05o`000?mo
0?ooO`3oogl0ool000003_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`004Omoo`001Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000olc<c?o<
c<`00oo<c<`7o`0000CoOol000?oO`3oo`000?moo`000omoo`02olc<c003ofIVI_o<c<coc<c<01Ko
c<c<0Oooool001coc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003oc<c<ofIVIP02ofIVIQ[oc<c<
00?oIVIVolc<c?o<c<`05?o<c<`01?mVIVKoc<c<olc<c?l0000<o`3oo`05o`000?mo0?ooO`3oogl0
ool000003_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004?moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`004Omoo`001Ol0003oO`3oogl0oomo0?oo000000ko0?oo1_l00003o`3oo`03o`000?moo`3o
Ool000GoOol000?oO`3oo`000?moo`000omoo`02olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool0
01goc<c<00?o0000olc<c?o<c<`02?o<c<`01Ol0003oc<c<olc<c?mVIVKoc<c<00?oIVIV5oo<c<`0
0omVIVKoc<c<olc<c00Dolc<c004ofIVI_o<c<coc<c<o`0000co0?oo00?o0000ogl0oomo0?l00_mo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003o0?ooo`3oo`05o`3oo`03o`000?moo`3oOol000GoOol000?oO`3oo`000?moo`000omo
o`02olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001koc<c<0_l00008olc<c004o`000?o<c<co
c<c<ofIVIPCoc<c<0omVIVHDolc<c003ofIVI_o<c<coc<c<01Coc<c<00CoIVIVolc<c?o<c<co0000
3?l0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0013oOol000?o0000ogl0oomo0?l0
0_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l0
0_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00Go0?oo00?o0000ogoo0?moo`00
1Omoo`000omo0?oo0000ogoo0002ogoo00?oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`008?o<
c<`00ol0003oc<c<olc<c005olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<0omVIVHAolc<c003ofIV
I_o<c<coc<c<01Coc<c<00CoIVIVolc<c?o<c<co00003?l0ool00ol0003oO`3oogl0o`02ogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol0013oOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03
o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?l0oooo0?oo00Go0?oo00?o0000ogoo0?moo`001?moo`02ogl0o`04o`000?moo`3oOol0ogoo
00?oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`008Oo<c<`00ol0003oc<c<olc<c004olc<c004
o`000?o<c<coc<c<ofIVIP[oc<c<0omVIVH>olc<c003ofIVI_o<c<coc<c<01Coc<c<00CoIVIVolc<
c?o<c<co00003?l0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000ooOol000?o0000
ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000ooOol000?o0000
ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00Go0?oo00?o0000
ogoo0?moo`001?moo`02ogl0o`04o`000?moo`3oOol0ogoo00?oc<c<00?oIVIVolc<c?o<c<`05_o<
c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000
olc<c?o<c<coIVIV3Oo<c<`3ofIVIP_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<o`00
000=o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0
o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0
o`03ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool01Ol0ool00ol0003oOol0ogoo
0004ogoo00;oO`3o00Co0000ogoo0?moo`3oOol00oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo
000Lolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<
c?mVIVH@olc<c0;oIVIV2Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<co000000co0?oo
00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00?oO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00?oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`05o`3oo`03o`000?moo`3oOol000CoOol0
0_mo0?l01?l0003oOol0ogoo0?moo`03olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<
00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c002o`0000;oc<c<00?o0000olc<c?o<c<`0
2_o<c<`4o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV4_o<c<`3ofIVIPKoc<c<00?oIVIVolc<c?o<
c<`05?o<c<`00omVIVKoc<c<o`00000<o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`003_moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`003omoo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool01Ol0ool00ol0003oOol0ogoo0004ogoo00;oO`3o00Co0000ogoo0?moo`3oOol00oo<c<`00omV
IVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<
c<co00006oo<c<`01?l0003oc<c<olc<c?mVIVHEolc<c0?oIVIV0oo<c<`00omVIVKoc<c<olc<c00D
olc<c003ofIVI_o<c<co000000co0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>
ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000?
ogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`05
o`3oo`03o`000?moo`3oOol000CoOol00_mo0?l01?l0003oOol0ogoo0?moo`03olc<c003ofIVI_o<
c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0
000Jolc<c005o`000?o<c<coc<c<olc<c?mVIVH06?o<c<`3ofIVIQOoc<c<00?oIVIVolc<c?l00000
3?l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l0
1?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l0
1?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00Go0?oo00?o0000ogoo0?moo`00
0omoo`03ogl0o`03o`000?moo`3oOol000Coc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<
c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001[oc<c<0_l000000oo<c<coIVIV
olc<c00Jolc<c0CoIVIV5?o<c<`00omVIVKoc<c<o`00000<o`3oo`03o`000?mo0?ooO`3o00?oO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool01Ol0ool00ol0003oOol0ogoo0003ogoo00?oO`3o00?o0000ogoo0?moo`00
1?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c0Oo00000_o<c<`00ol0003oc<c<olc<
c00Holc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00CoIVIVolc<c?o<c<coc<c<0omVIVHAolc<c003
ofIVI_o<c<co000000co0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003
o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000>ogoo0003
o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`04o`3oo`03
o`000?moo`3oOol000?oOol00omo0?l00ol0003oOol0ogoo0004olc<c003ofIVI_o<c<coc<c<01Ko
c<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c004
o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`01?o<c<`2ofIVIPooc<c<00?oIVIVo`00
0?l0ool02ol0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0
oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0
oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00Co0?oo00?o0000ogoo
0?moo`000omoo`03ogl0o`03o`000?moo`3oOol000Coc<c<00?oIVIVolc<c?o<c<`05_o<c<`1oooo
o`000oo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<co000000;o00006Oo<c<`01?l0003o
c<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Koc<c<0omVIVH<olc<c003ofIVI_l0003o0?oo
00_o0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o
00CoO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o
00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`04o`3oo`03o`000?moo`3oOol0
00?oOol00omo0?l00ol0003oOol0ogoo0004olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?o
c<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c00Holc<c004o`000?o<c<coc<c<ofIV
IQ_oc<c<00?oIVIVolc<c?o<c<`02Oo<c<`3ofIVIPWoc<c<00?oIVIVo`000?l0ool02ol0ool00ol0
003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l01?mo0?l00ol0
003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01?mo0?l00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00Co0?oo00?o0000ogoo0?moo`000omoo`03ogl0
o`03o`000?moo`3oOol000Coc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`7o`0000;o
c<c<00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<
00coc<c<0omVIVH6olc<c003ofIVI_l0003o0?oo00_o0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`04o`3oo`03o`000?moo`3oOol000;oOol01?mo0?l00ol0003oOol0olc<c004olc<
c003ofIVI_o<c<coc<c<01Koc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omV
IVKoc<c<olc<c00?olc<c0?oIVIV0oo<c<`00omVIVKo0000o`3oo`0;o`3oo`03o`000?mo0?ooO`3o
00GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00go0?oo00?o0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo
00go0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool01?l0ool00ol0003oOol0ogoo0002ogoo00CoO`3o00?o0000ogoo
0?o<c<`01?o<c<`5ofIVIQCoc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omV
IVKoc<c<olc<c00Bolc<c0CoIVIV00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`05ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00Co0?oo00?o0000ogoo0?moo`000_moo`04ogl0o`03o`000?moo`3oIVIV
00CoIVIV00?oc<c<ofIVI_o<c<`05_o<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<
c003ofIVI_o<c<coc<c<01Goc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3oogl0o`05ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00Co0?oo00?o0000ogoo0?moo`000_moo`04ogl0o`03o`000?moo`3oc<c<
00Goc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<
c003ofIVI_o<c<coc<c<01Goc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`06ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00Co0?oo00?o0000ogoo0?moo`000_moo`04ogl0o`03o`000?moo`3oc<c<
00Goc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<
c003ofIVI_o<c<coc<c<01Goc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`06ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?l0oooo0?oo00?o0?oo00?o0000ogoo0?moo`000_moo`04ogl0o`03o`000?moo`3oc<c<
00Goc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`2o`000003olc<c?mVIVKoc<c<01[o
c<c<00?oIVIVolc<c?o<c<`05Oo<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o00Ko
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000o`3oool0ool00ol0ool01?l0003oOol0ogoo0?moo`05ogl0o`03o`000?moo`3oc<c<
00Goc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<
c003ofIVI_o<c<coc<c<01Goc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`06ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?l0oooo0?oo00?o0?oo00Co0000ogoo0?moo`3oOol01Omo0?l00ol0003oc<c<olc<c005
olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`0
0omVIVKoc<c<olc<c00Eolc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l01_mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03_l0ool0
0ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003o0?ooo`3oo`03o`3oo`04o`000?moo`3oOol0ogoo00GoO`3o00?o0000olc<c?o<c<`01Oo<
c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o
0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000o`3oool0ool00ol0ool01?l0003oOol0ogoo0?moo`05ogl0o`03o`000?o<c<coc<c<00Goc<c<
00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01_oc<c<
00?oIVIVolc<c?o<c<`05?o<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o00OoO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000o`3oool0ool00ol0ool01?l0003oOol0ogoo0?moo`05ogl0o`03o`000?o<c<coc<c<00Go
c<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003
ofIVI_o<c<coc<c<01Coc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`08ogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00?o0?oo00Co0000ogoo0?moo`3oOol01Omo0?l00ol0003oc<c<olc<c005olc<
c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omV
IVKoc<c<olc<c00Dolc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l02?mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`03o`3oo`03o`000?moo`3oOol000KoO`3o00?o0000olc<c?o<c<`01Oo<c<`00omV
IVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<
c?o<c<`05?o<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`002_moo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`002_moo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool00ol0ool00ol0003oOol0ogoo0006ogl0o`03o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<
c?o<c<`05Oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<
01Goc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0
00[oOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0
00[oOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00?o0?oo00?o0000ogoo0?moo`001_mo0?l00ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<
01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Eolc<
c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000:ogoo
0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000:ogoo
0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`02o`3o
o`03o`000?moo`3oOol000KoO`3o00?o0000olc<c?o<c<`01Oo<c<`00omVIVKoc<c<olc<c00Eolc<
c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002Omoo`000ol0
003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002_moo`000ol0
003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00_l0ool00ol0
003oOol0ogoo0006ogl0o`03o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1oooo
o`009_o<c<`2o`000003olc<c?mVIVKoc<c<01[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00ol0003o
0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002Omoo`000ol0003o
O`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002_moo`000ol0003o
O`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00_l0ool00ol0003o
Ool0ogoo0006ogl0o`03o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`00
9_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01Coc<c<00?o0000o`3oool0
ool02_l0ool00ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo
0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo
0?l02?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?mo
0?l01_mo0?l00ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<
00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Dolc<c003o`000?l0oooo0?oo00[o
0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00Wo
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00So
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`02o`3oo`03o`000?moo`3oO`3o00Ko
O`3o00?o0000olc<c?o<c<`01Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`00
0?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00ol0003o0?ooo`3oo`0:o`3oo`03
o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`09ogl0o`03
o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`09ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00_l0ool00ol0003oOol0ogl0o`06ogl0o`03
o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<
olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01Coc<c<00?o0000o`3oool0ool02_l0ool00ol0003o
O`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?mo0?l01_mo0?l00ol0003o
c<c<olc<c006olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<co
IVIV6oo<c<`00omVIVKoc<c<olc<c00Colc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo
0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`02o`3oo`03o`000?moo`3oO`3o00KoO`3o00?o0000olc<c?o<
c<`01_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_o
c<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o00_o
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool00_l0ool00ol0003oOol0ogl0o`06ogl0o`03o`000?o<c<coc<c<00Ko
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003
ofIVI_o<c<coc<c<01?oc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0;ogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05
o`000?l0oooo0?ooo`3oool000002?mo0?l00ol0003oc<c<olc<c006olc<c003ofIVI_o<c<coc<c<
01Coc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Colc<
c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0007ogoo
0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0008ogoo
0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03Ol0ool01Ol0003o0?ooo`3oool0oooo
000000SoO`3o00?o0000olc<c?o<c<`01_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<
c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`0:
o`3oo`03o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0;
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0:
ogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000o`3oool0oooo0?ooo`000008ogl0o`03o`000?o<
c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mV
IVHLolc<c003ofIVI_o<c<coc<c<01?oc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0
o`0;ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`05o`000?l0oooo0?ooo`3oool000002?mo0?l00ol0003oc<c<olc<c006olc<c003ofIV
I_o<c<coc<c<01Coc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`01Oo<c<`4ofIVIQcoc<c<00?o
IVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o00_oO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00Go
0000o`3oool0oooo0?ooo`000007ogl0o`03o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`0
5?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00CoIVIV6Oo<
c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l03?mo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0
ool01Ol0003o0?ooo`3oool0oooo000000OoO`3o00?o0000olc<c?o<c<`01oo<c<`00omVIVKoc<c<
olc<c00Dolc<c07ooooo000Iolc<c0Ko00001_o<c<`01?l0003oc<c<olc<c?mVIVH3olc<c0CoIVIV
5Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l0
3?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool0
3_l0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool0
3Ol0ool01?l0003o0?ooo`3oool0ool8ogl0o`03o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`006Oo<c<`01Ol0003oc<c<olc<c?o<c<co000000Ooc<c<00Co0000olc<c?o<
c<coIVIV1oo<c<`5ofIVIQ3oc<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`0:o`3o
o`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0<ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3oogl0o`0<ogl0
o`03o`000?l0oooo0?oo00co0?oo00Co0000o`3oool0oooo0?oo2?mo0?l00ol0003oc<c<olc<c007
olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001[oc<c<00Co0000olc<c?o<c<co00001oo<c<`0
1?l0003oc<c<olc<c?mVIVH<olc<c0CoIVIV3?o<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0
oooo0?oo00[o0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo
0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo
0?ooO`3o00coO`3o00?o0000o`3oool0ool03?l0ool01?l0003o0?ooo`3oool0ool8ogl0o`03o`00
0?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006oo<c<`00ol0003oc<c<o`00
0007olc<c004o`000?o<c<coc<c<ofIVIQ3oc<c<1?mVIVH8olc<c003ofIVI_o<c<coc<c<01;oc<c<
00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000KoOol0
00?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000KoOol0
00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`04o`000?l0oooo0?ooo`0000So
O`3o00?o0000olc<c?o<c<`01oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Kolc<c003o`00
0?o<c<co000000Ooc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`4ofIVIP?oc<c<00?oIVIVolc<c?o<
c<`04oo<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`001_moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`001_moo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0
00002?mo0?l00ol0003oc<c<olc<c007olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001coc<c<
0_l00007olc<c004o`000?o<c<coc<c<ofIVIQSoc<c<1?mVIVHDolc<c003o`000?l0oooo0?oo00_o
0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00go
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00co
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`000008ogl0o`03o`000?o<c<coc<c<00Oo
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c004o`00
0?o<c<coc<c<ofIVIQ_oc<c<1OmVIVH@olc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo
0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003o0?ooogl0o`08ogl0o`03o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00;o
c<c<1OmVIVH;olc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo0005ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo0006ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
0?ooogl0o`08ogl0o`03o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`00
9Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00Ooc<c<1?mVIVH7olc<c003
o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0005ogoo0003
o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003
o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooogl0o`08ogl0o`03
o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`01?l0003oc<c<
olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<00_oc<c<1?mVIVH3olc<c003o`000?l0oooo0?oo00[o
0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00go
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00go
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooogl0o`08ogl0o`03o`000?o<c<coc<c<00So
c<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009Oo<c<`2o`000003olc<c?mVIVKoc<c<01[oc<c<
00?oIVIVolc<c?o<c<`03oo<c<`3ofIVIP03o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l0
3_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool0
3_l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003o0?ooogl0o`08ogl0o`03o`000?o<c<coc<c<00Goc<c<1omVIVHBolc<c07ooooo
000Uolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3o
ogl0o`0>ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3o
ogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3ooomo0?l02?mo0?l00ol0003oIVIV
ofIVIP05ofIVIP?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<
c?mVIVHLolc<c003ofIVI_o<c<coc<c<017oc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3o
ogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<
olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`0
4Oo<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
1?moo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
1?moo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l0
1omo0?l00ol0003oc<c<olc<c008olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co
0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00[o0?oo
00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00ooO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00koO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<coc<c<00Soc<c<
00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIV
I_o<c<coc<c<017oc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0?ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000CoOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol000CoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?mo0?ooO`3o00OoO`3o00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo
000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?oo
o`3oo`0:o`3oo`03o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3o
ogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3o
ogl0o`0>ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<
olc<c008olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV
7?o<c<`00omVIVKoc<c<olc<c00@olc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l0
3omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`0
4oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<013oc<c<
00?o0000o`3oool0ool02ol0ool00ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000?oOol0
00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000?oOol0
00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00OoO`3o
00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<
c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`04?o<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`00
0?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0?ogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<c008olc<c003ofIV
I_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<
olc<c00@olc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0002ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo0003ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3o
ogl0o`07ogl0o`03o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<
c<`2o`000003olc<c?mVIVKoc<c<01_oc<c<00?oIVIVolc<c?o<c<`04?o<c<`00ol0003o0?ooo`3o
o`0:o`3oo`03o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0
o`0@ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0
o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<
c008olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<
c<`00omVIVKoc<c<olc<c00@olc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l04Omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03?l0
ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`04oo<
c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<013oc<c<00?o
0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000;oOol000?o
0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o
0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o
0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`04?o<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
0?ooO`3o017oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0Aogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oc<c<olc<c008olc<c003ofIVI_o<
c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c00@olc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0002ogoo0003o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03Ol0ool01Ol0003oOol0ogoo
0?moo`3o000001?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`06ogl0o`03o`00
0?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<
c?mVIVHKolc<c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3o
ogl0o`0Bogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l04Omo0?l00ol0003o0?oo
o`3oo`0=o`3oo`05o`000?moo`3oOol0ogoo0?l000004omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`02?o<c<`00omVIVKoc<c<olc<c00Colc<c07o
oooo000Solc<c005o`000?o<c<coc<c<olc<c?mVIVH06oo<c<`00omVIVKoc<c<olc<c00@olc<c003
o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01Ol0003oOol0ogoo0?moo`3o0000
01CoO`3o00?o0000o`3oool0ool03Ol0ool01Ol0003oOol0ogoo0?moo`3o000001?oO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00Soc<c<00?oIVIV
olc<c?o<c<`04oo<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<co
c<c<013oc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`000?moo`3o
Ool0ogoo0?l000005?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?moo`3oOol0ogoo0?l00000
4omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`0
2Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<
00?oIVIVolc<c?o<c<`04?o<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o01;oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo
00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?moo`3oOol0ogoo
0?l000004omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000olc<
c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIV
IQcoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo0?ooO`3o
01?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00go0?oo00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?moo`3o
Ool0ogoo0?l000004omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o
0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<co
c<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
0?ooO`3o01?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`04o`00
0?moo`3oOol0o`0001?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`06ogl0o`03
o`000?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<
olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000o`3oool0ool02_l0ool00ol0003o
O`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`04o`000?moo`3oOol0o`0001GoO`3o00?o0000o`3oool0ool03Ol0ool01?l0
003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l01_mo0?l0
0ol0003oc<c<olc<c009olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<0_l000000oo<
c<coIVIVolc<c00Kolc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000o`3oool0ool02_l0ool00ol0
003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`04o`000?moo`3oOol0o`0001GoO`3o00?o0000o`3oool0ool03Ol0ool0
1?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo
0?l00ol0003oc<c<olc<c009olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000
olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo00[o0?oo00?o
0000ogl0oomo0?l05?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Eogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?l000005Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o
00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<
c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`00
0?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?l000005_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3o000001GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`00
0?o<c<coc<c<00Woc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<
c?mVIVHLolc<c003ofIVI_o<c<coc<c<00koc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3o
ogl0o`0Dogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3o000001KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
o`00000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<
olc<c009olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV
7?o<c<`00omVIVKoc<c<olc<c00>olc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l0
5?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0o`00000Fogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l00000
5Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<c<`0
2Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<
00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o01GoO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?l000005_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001GoO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<00Woc<c<
00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIV
I_o<c<coc<c<00koc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0Eogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3o000001KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00000Eogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<c009olc<c003ofIV
I_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<
olc<c00>olc<c003o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l05Omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
o`00000Fogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005Omo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<
olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`0
3_o<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo0_l0000Fogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo
000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?oo
o`3oo`0:o`3oo`03o`000?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo0_l0000Fogl0o`03o`000?l0oooo0?oo00ko0?oo
0_l0000Eogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003oc<c<
olc<c009olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002;oc<c<00Co0000olc<c?o<c<coIVIV
7Oo<c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00_o0?oo00?o0000ogl0oomo0?l0
5_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oO`3oogl0o`0Fogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l0
5Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000olc<c?o<c<`0
2Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Golc<c0Co00001oo<c<`01?l0003oc<c<olc<
c?mVIVHLolc<c003ofIVI_o<c<coc<c<00koc<c<00?o0000o`3oool0ool02ol0ool00ol0003oO`3o
ogl0o`0Fogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3o
ogl0o`0Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003oc<c<
olc<c009olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<
c<`00ol0003oc<c<olc<c004olc<c0KoIVIV6_o<c<`00omVIVKoc<c<olc<c007olc<c0_o00002Ol0
ool00ol0003oO`3oogl0o`0Gogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01KoO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01?mo
0?l00ol0003oc<c<olc<c009olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o0000
olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP;oc<c<2OmV
IVHAolc<c003ofIVI_o<c<coc<c<00Oo00002ooo0007o`0000;o0?oo00?o0000ogl0oomo0?l05omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool01Ol0
ool;o`0001GoO`3o00?o0000o`3oool0ool01Ol0ool;o`0001GoO`3o00?o0000o`3oool0ool01Ol0
ool;o`0000CoO`3o00?o0000olc<c?o<c<`02Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000F
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mV
IVH;olc<c0WoIVIV2?o<c<`00omVIVKoc<c<olc<c004olc<c0Oo00003_oo0006o`0001KoO`3o00?o
0000o`3oool0ool01?l0oolNo`0000_oo`001Ol00009ogl0o`oo00002ooo0004o`0000WoO`3o4?l0
000;ool000?o000000?oO`3oo`000?o<c<`02oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo000F
olc<c0;o00000oo<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIQCoc<c<2OmV
IVH=olc<c0Wo00002ooo0006o`0000WoO`3o3_l0000;ool000Go00003?oo0008o`0000[oo`002Ol0
000=ool000Oo00002_oo0009o`0000_oo`000ol0000@ool000;o00003?o<c<`00omVIVKoc<c<olc<
c00Aolc<c07ooooo000Folc<c003o`000?o<c<co000000;o00001oo<c<`01?l0003oc<c<olc<c?mV
IVHLolc<c0[oIVIV3_o<c<`6o`0000[oo`002Ol0000>ool000Oo00002Ooo0009o`0000_oo`001Ol0
000<ool000_o00002_oo0004o`0000goo`002?l00009ool000Wo00005Oo<c<`00omVIVKoc<c<olc<
c00Aolc<c07ooooo000Folc<c003o`000?o<c<coc<c<00Woc<c<00Co0000olc<c?o<c<coIVIV7?o<
c<`00omVIVKoc<c<olc<c007olc<c0WoIVIV1_o<c<`00omVIVKoc<c<olc<c005olc<c0Go00002ooo
000;o`0000_oo`001Ol0000;ool000Oo00002_oo0008o`0000coo`002?l00009ool000Wo00002_oo
0003o`0000koo`000ol0000Eolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool001Ooc<c<00Go0000
olc<c?o<c<coc<c<o`00000Volc<c003ofIVI_o<c<coc<c<013oc<c<2OmVIVH:olc<c0Wo00003Ooo
0006o`0000[oo`002?l0000:ool000Go00002ooo000:o`0000[oo`001?l0000=ool000Oo00002Ooo
0009o`0001?oc<c<3omVIVH?olc<c07ooooo000Holc<c0?o00009oo<c<`00omVIVKoc<c<olc<c00F
olc<c003ofIVI_o<c<coc<c<00WoIVIV2Oo<c<`00omVIVKo0000o`000009o`0000[oo`001Ol0000:
ool000Oo00002Ooo0008o`0000coo`001_l00009ool000So00003?oo0003o`0000Ooc<c<6omVIVH:
olc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool004;oc<c<00?oIVIVolc<c?o<c<`05_o<c<`00omV
IVKoc<c<olc<c009olc<c0[oIVIV2_o<c<`7o`0000Woo`002?l0000;ool000Oo00001_oo000:o`00
00coo`001ol00006ool000[o00003_mVIVH00oo<c<coIVIVolc<c00Rolc<c003ofIVI_o<c<coc<c<
017oc<c<0Oooool005_oc<c<00?oIVIVolc<c?o<c<`04_o<c<`9ofIVIP[oc<c<00?oIVIVolc<c?l0
00001Ol00007ool000Wo00003?oo0006o`0000Koo`002_l0000=ofIVIQgoc<c<00?oIVIVolc<c?o<
c<`08Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo001Kolc<c003ofIVI_o<c<coc<c<01;oc<c<
00?oIVIVolc<c?o<c<`01_o<c<`9ofIVIP03olc<c?mVIVKoc<c<00?oc<c<00?oIVIVolc<c?o<c<`0
1?o<c<`5o`0000Koo`002_l0000:ofIVIQOoc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<
olc<c00Qolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool0073oc<c<00?oIVIVolc<c?o<c<`03oo<
c<`AofIVIQ;oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<
c<coc<c<03Goc<c<0Oooool0073oc<c<00?oIVIVolc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c002
olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c01G
olc<c07ooooo0023olc<c003ofIVI_o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`06_o<c<`00omV
IVKoc<c<olc<c01golc<c07ooooo0023olc<c003ofIVI_o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<
c<`0U?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1
ooooo`00ooo<c<`Polc<c07ooooo0035olc<c0;o0000F?o<c<`1ooooo`00a_o<c<`2o`0000;oc<c<
00?o0000olc<c?o<c<`0D_o<c<`1ooooo`00aoo<c<`2o`0000;oc<c<00?o0000olc<c?o<c<`0DOo<
c<`1ooooo`00?oo<c<`5o`0000Coc<c<0ol00003olc<c0;o00000oo<c<`3o`0000;oc<c<1?l00003
olc<c0Go00000oo<c<`2o`0000Coc<c<0_l00002olc<c0?o000000?oc<c<o`000?l000000_o<c<`2
o`0000;oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00001?o<c<`2
o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0Co00000oo<c<`3o`0000?oc<c<0ol00003
olc<c0;o00001?o<c<`3o`000003olc<c?l0003o000000Ooc<c<1?l000001?o<c<co0000olc<c?o<
c<`4o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000001Oo<c<`2o`0002koc<c<0Ooo
ool003koc<c<0_l00003olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003
olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2
o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002
olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00000
0oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00003
olc<c0;o000000Coc<c<o`000?l0003oc<c<0_l00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l0
00000oo<c<co0000o`000002olc<c0;o00001?o<c<`3o`000003olc<c?l0003o000000Koc<c<0_l0
0002olc<c0?o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l0
00000oo<c<co0000o`000005olc<c0;o0000;_o<c<`1ooooo`00?_o<c<`2o`0000?oc<c<0_l00000
0oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`0000;oc<c<0_l00005
olc<c0;o00000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002
olc<c0;o000000?oc<c<o`000?l000002?o<c<`3o`0000Coc<c<0ol000000oo<c<co0000o`000008
olc<c0?o00000oo<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000004olc<c0?o00000_o<c<`2
o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o
000000Ooc<c<0_l00004olc<c0;o000000?oc<c<o`000?l000001Oo<c<`2o`0000;oc<c<0_l00008
olc<c0;o0000;_o<c<`1ooooo`00@_o<c<`3o`000003olc<c?l0003o000000?oc<c<0_l000000oo<
c<co0000o`000003olc<c0;o00000_o<c<`6o`000003olc<c?l0003o000000;oc<c<0_l00003olc<
c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o0000
00Co00000_o<c<`4o`0000?oc<c<1?l00002olc<c0Ko00000_o<c<`4o`0000Coc<c<0_l00003olc<
c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0_l00002olc<c0;o00000oo<c<`2o`00
0003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001?o<c<`2o`00
0003olc<c?l0003o000000Co000000?oc<c<o`000?l000000_o<c<`2o`0000Woc<c<0_l0000]olc<
c07ooooo000oolc<c0Go00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o
00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`5o`000003
olc<c?l0003o000000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;o
c<c<0_l000001?o<c<co0000o`000?l00004olc<c0?o00001?o<c<`2o`0000;oc<c<0_l000001?o<
c<co0000o`000?l00006olc<c0;o00000oo<c<`2o`000004olc<c?l0003o0000olc<c0?o00001Oo<
c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0
003o000000Ooc<c<0_l00002olc<c0Co000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0
003o000000;oc<c<0_l00009olc<c0;o0000;Oo<c<`1ooooo`00?_o<c<`3o`0000Koc<c<0_l00000
0oo<c<co0000o`000002olc<c0?o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<
o`000?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002
olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00000
0oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o
000000;oc<c<0_l00003olc<c0Oo000000Coc<c<o`000?l0003oc<c<0_l00002olc<c0;o00000_o<
c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0?o00000_o<c<`2o`000003olc<c?l0
003o000000Ooc<c<0_l00007olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l0
000:olc<c003o`000?o<c<coc<c<02_oc<c<0Oooool003koc<c<0_l00003olc<c0;o00000oo<c<`3
o`0000?oc<c<0ol000000oo<c<co0000o`000002o`0000;oc<c<1?l00003olc<c0Go00000oo<c<`2
o`0000Coc<c<0_l000000oo<c<co0000o`000002o`000003olc<c?l0003o000000?o00000oo<c<`4
o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00004olc<c0;o00000oo<c<`2
o`000003olc<c?l0003o000000;oc<c<1?l00002olc<c0Co00000oo<c<`3o`0000?oc<c<0ol00000
0oo<c<co0000o`000003olc<c0;o00001_o<c<`2o`0000Coc<c<0_l00002olc<c0Co00000_o<c<`5
o`0000_oc<c<0_l0000/olc<c07ooooo000nolc<c0;o00000oo<c<`2o`0000koc<c<0_l0000=olc<
c0;o00000oo<c<`2o`0000Soc<c<0_l0000^olc<c0;o00000oo<c<`2o`0000coc<c<0_l0000Lolc<
c0;o00000_o<c<`2o`0001[oc<c<0_l0000[olc<c07ooooo000oolc<c0Go00003oo<c<`2o`0000go
c<c<0_l00003olc<c0So00000_o<c<`2o`0002koc<c<0_l00003olc<c0;o000000?oc<c<o`000?l0
00002Oo<c<`2o`0001goc<c<1?l0000Golc<c0Ko0000:oo<c<`1ooooo`00ooo<c<`Polc<c07ooooo
003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23o
c<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool0
0001\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 1, 6, 6, 6, 1, 6, 1, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(4.5`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 0.0147151 5.88604 [
[.18254 .00222 -3 -9 ]
[.18254 .00222 3 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -3 -9 ]
[.81746 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(2)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(3)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(4)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(5)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(6)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(7)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.18254 .60332 L
.34127 .60332 L
.5 .60332 L
.65873 .60332 L
.81746 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 0.0147151 2.94302 [
[.18254 .00222 -3 -9 ]
[.18254 .00222 3 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -3 -9 ]
[.81746 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .16187 -24 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -24 -4.5 ]
[.01131 .45617 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(2)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(3)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(4)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(5)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(6)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(7)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .16187 m
.03006 .16187 L
s
[(0.05)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.1)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.15)] .01131 .45617 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.18254 .30902 L
.34127 .30902 L
.5 .30902 L
.65873 .30902 L
.81746 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 -0.377687 0.981006 [
[.18254 .59082 -3 -9 ]
[.18254 .59082 3 0 ]
[.34127 .59082 -3 -9 ]
[.34127 .59082 3 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.65873 .59082 -3 -9 ]
[.65873 .59082 3 0 ]
[.81746 .59082 -3 -9 ]
[.81746 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -18 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .11282 -18 -4.5 ]
[.01131 .11282 0 4.5 ]
[.01131 .21092 -18 -4.5 ]
[.01131 .21092 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .40712 -18 -4.5 ]
[.01131 .40712 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .60332 m
.18254 .60957 L
s
[(2)] .18254 .59082 0 1 Mshowa
.34127 .60332 m
.34127 .60957 L
s
[(3)] .34127 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(4)] .5 .59082 0 1 Mshowa
.65873 .60332 m
.65873 .60957 L
s
[(5)] .65873 .59082 0 1 Mshowa
.81746 .60332 m
.81746 .60957 L
s
[(6)] .81746 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(7)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.05556 .60332 m
.05556 .60707 L
s
.0873 .60332 m
.0873 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.15079 .60332 m
.15079 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.24603 .60332 m
.24603 .60707 L
s
.27778 .60332 m
.27778 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.37302 .60332 m
.37302 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.43651 .60332 m
.43651 .60707 L
s
.46825 .60332 m
.46825 .60707 L
s
.53175 .60332 m
.53175 .60707 L
s
.56349 .60332 m
.56349 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.62698 .60332 m
.62698 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.72222 .60332 m
.72222 .60707 L
s
.75397 .60332 m
.75397 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.84921 .60332 m
.84921 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.9127 .60332 m
.9127 .60707 L
s
.94444 .60332 m
.94444 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.4)] .01131 .01472 1 0 Mshowa
.02381 .11282 m
.03006 .11282 L
s
[(0.5)] .01131 .11282 1 0 Mshowa
.02381 .21092 m
.03006 .21092 L
s
[(0.6)] .01131 .21092 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.7)] .01131 .30902 1 0 Mshowa
.02381 .40712 m
.03006 .40712 L
s
[(0.8)] .01131 .40712 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(0.9)] .01131 .50522 1 0 Mshowa
.125 Mabswid
.02381 .03434 m
.02756 .03434 L
s
.02381 .05396 m
.02756 .05396 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .0932 m
.02756 .0932 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .15206 m
.02756 .15206 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .23054 m
.02756 .23054 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .26978 m
.02756 .26978 L
s
.02381 .2894 m
.02756 .2894 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34826 m
.02756 .34826 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .3875 m
.02756 .3875 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .44636 m
.02756 .44636 L
s
.02381 .46598 m
.02756 .46598 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .52484 m
.02756 .52484 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .56408 m
.02756 .56408 L
s
.02381 .5837 m
.02756 .5837 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.18254 .60332 L
.34127 .60332 L
.5 .59351 L
.65873 .5838 L
.81746 .57418 L
.97619 .36834 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 -0.100584 1.15299 [
[.18254 .00222 -3 -9 ]
[.18254 .00222 3 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -3 -9 ]
[.81746 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13001 -18 -4.5 ]
[.01131 .13001 0 4.5 ]
[.01131 .24531 -18 -4.5 ]
[.01131 .24531 0 4.5 ]
[.01131 .36061 -18 -4.5 ]
[.01131 .36061 0 4.5 ]
[.01131 .47591 -18 -4.5 ]
[.01131 .47591 0 4.5 ]
[.01131 .59121 -18 -4.5 ]
[.01131 .59121 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(2)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(3)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(4)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(5)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(6)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(7)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13001 m
.03006 .13001 L
s
[(0.2)] .01131 .13001 1 0 Mshowa
.02381 .24531 m
.03006 .24531 L
s
[(0.3)] .01131 .24531 1 0 Mshowa
.02381 .36061 m
.03006 .36061 L
s
[(0.4)] .01131 .36061 1 0 Mshowa
.02381 .47591 m
.03006 .47591 L
s
[(0.5)] .01131 .47591 1 0 Mshowa
.02381 .59121 m
.03006 .59121 L
s
[(0.6)] .01131 .59121 1 0 Mshowa
.125 Mabswid
.02381 .03777 m
.02756 .03777 L
s
.02381 .06083 m
.02756 .06083 L
s
.02381 .08389 m
.02756 .08389 L
s
.02381 .10695 m
.02756 .10695 L
s
.02381 .15307 m
.02756 .15307 L
s
.02381 .17613 m
.02756 .17613 L
s
.02381 .19919 m
.02756 .19919 L
s
.02381 .22225 m
.02756 .22225 L
s
.02381 .26837 m
.02756 .26837 L
s
.02381 .29143 m
.02756 .29143 L
s
.02381 .31449 m
.02756 .31449 L
s
.02381 .33755 m
.02756 .33755 L
s
.02381 .38367 m
.02756 .38367 L
s
.02381 .40673 m
.02756 .40673 L
s
.02381 .42979 m
.02756 .42979 L
s
.02381 .45285 m
.02756 .45285 L
s
.02381 .49897 m
.02756 .49897 L
s
.02381 .52203 m
.02756 .52203 L
s
.02381 .54509 m
.02756 .54509 L
s
.02381 .56815 m
.02756 .56815 L
s
.02381 .61427 m
.02756 .61427 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .13001 m
.18254 .60332 L
.34127 .59628 L
.5 .58931 L
.65873 .58241 L
.81746 .57558 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 -0.573889 5.88604 [
[.18254 .00222 -3 -9 ]
[.18254 .00222 3 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -3 -9 ]
[.81746 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(2)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(3)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(4)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(5)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(6)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(7)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.12)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.14)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.16)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.18)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.18254 .01472 L
.34127 .01472 L
.5 .01472 L
.65873 .01472 L
.81746 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 0.0147151 5.88604 [
[.18254 .00222 -3 -9 ]
[.18254 .00222 3 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -3 -9 ]
[.81746 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(2)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(3)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(4)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(5)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(6)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(7)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.18254 .60332 L
.34127 .60332 L
.5 .60332 L
.65873 .60332 L
.81746 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 -0.371191 0.97451 [
[.18254 .59082 -3 -9 ]
[.18254 .59082 3 0 ]
[.34127 .59082 -3 -9 ]
[.34127 .59082 3 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.65873 .59082 -3 -9 ]
[.65873 .59082 3 0 ]
[.81746 .59082 -3 -9 ]
[.81746 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01861 -18 -4.5 ]
[.01131 .01861 0 4.5 ]
[.01131 .11606 -18 -4.5 ]
[.01131 .11606 0 4.5 ]
[.01131 .21352 -18 -4.5 ]
[.01131 .21352 0 4.5 ]
[.01131 .31097 -18 -4.5 ]
[.01131 .31097 0 4.5 ]
[.01131 .40842 -18 -4.5 ]
[.01131 .40842 0 4.5 ]
[.01131 .50587 -18 -4.5 ]
[.01131 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .60332 m
.18254 .60957 L
s
[(2)] .18254 .59082 0 1 Mshowa
.34127 .60332 m
.34127 .60957 L
s
[(3)] .34127 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(4)] .5 .59082 0 1 Mshowa
.65873 .60332 m
.65873 .60957 L
s
[(5)] .65873 .59082 0 1 Mshowa
.81746 .60332 m
.81746 .60957 L
s
[(6)] .81746 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(7)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.05556 .60332 m
.05556 .60707 L
s
.0873 .60332 m
.0873 .60707 L
s
.11905 .60332 m
.11905 .60707 L
s
.15079 .60332 m
.15079 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.24603 .60332 m
.24603 .60707 L
s
.27778 .60332 m
.27778 .60707 L
s
.30952 .60332 m
.30952 .60707 L
s
.37302 .60332 m
.37302 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.43651 .60332 m
.43651 .60707 L
s
.46825 .60332 m
.46825 .60707 L
s
.53175 .60332 m
.53175 .60707 L
s
.56349 .60332 m
.56349 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.62698 .60332 m
.62698 .60707 L
s
.69048 .60332 m
.69048 .60707 L
s
.72222 .60332 m
.72222 .60707 L
s
.75397 .60332 m
.75397 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.84921 .60332 m
.84921 .60707 L
s
.88095 .60332 m
.88095 .60707 L
s
.9127 .60332 m
.9127 .60707 L
s
.94444 .60332 m
.94444 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01861 m
.03006 .01861 L
s
[(0.4)] .01131 .01861 1 0 Mshowa
.02381 .11606 m
.03006 .11606 L
s
[(0.5)] .01131 .11606 1 0 Mshowa
.02381 .21352 m
.03006 .21352 L
s
[(0.6)] .01131 .21352 1 0 Mshowa
.02381 .31097 m
.03006 .31097 L
s
[(0.7)] .01131 .31097 1 0 Mshowa
.02381 .40842 m
.03006 .40842 L
s
[(0.8)] .01131 .40842 1 0 Mshowa
.02381 .50587 m
.03006 .50587 L
s
[(0.9)] .01131 .50587 1 0 Mshowa
.125 Mabswid
.02381 .0381 m
.02756 .0381 L
s
.02381 .05759 m
.02756 .05759 L
s
.02381 .07708 m
.02756 .07708 L
s
.02381 .09657 m
.02756 .09657 L
s
.02381 .13555 m
.02756 .13555 L
s
.02381 .15504 m
.02756 .15504 L
s
.02381 .17453 m
.02756 .17453 L
s
.02381 .19402 m
.02756 .19402 L
s
.02381 .23301 m
.02756 .23301 L
s
.02381 .2525 m
.02756 .2525 L
s
.02381 .27199 m
.02756 .27199 L
s
.02381 .29148 m
.02756 .29148 L
s
.02381 .33046 m
.02756 .33046 L
s
.02381 .34995 m
.02756 .34995 L
s
.02381 .36944 m
.02756 .36944 L
s
.02381 .38893 m
.02756 .38893 L
s
.02381 .42791 m
.02756 .42791 L
s
.02381 .4474 m
.02756 .4474 L
s
.02381 .46689 m
.02756 .46689 L
s
.02381 .48638 m
.02756 .48638 L
s
.02381 .52536 m
.02756 .52536 L
s
.02381 .54485 m
.02756 .54485 L
s
.02381 .56434 m
.02756 .56434 L
s
.02381 .58383 m
.02756 .58383 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.18254 .01472 L
.34127 .60332 L
.5 .59357 L
.65873 .58393 L
.81746 .37738 L
.97619 .16404 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.134921 0.15873 0.0147151 5.88604 [
[.18254 .00222 -3 -9 ]
[.18254 .00222 3 0 ]
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.65873 .00222 -3 -9 ]
[.65873 .00222 3 0 ]
[.81746 .00222 -3 -9 ]
[.81746 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(2)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(3)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(4)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(5)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(6)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(7)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.18254 .60332 L
.34127 .60332 L
.5 .60332 L
.65873 .60332 L
.81746 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H0033oi^KV1Ol00006onKViP?o
00001ooVi^H3o`0000Koi^KV0ol00007onKViP?o00002?oVi^H00ol0003oi^KVonKViP0donKViPGo
00001_oVi^H3o`0000Soi^KV0ol00006onKViP?o00001ooVi^H3o`0000Ooi^KV00?o0000onKVi_oV
i^H04ooVi^H0037oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00Ooi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Go0000
onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV03Goi^KV00Co0000onKVi_oVi^Ko0000
1OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Soi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Goi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP03o`000?oVi^Ko
i^KV01?oi^KV000bonKViP03o`000?oVi^Koi^KV00Woi^KV00?o0000onKVi_oVi^H00_oVi^H5o`00
00Woi^KV00?o0000onKVi_oVi^H00ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Soi^KV00?o0000
onKVi_oVi^H0=OoVi^H00ol0003oi^KVonKViP09onKViP03o`000?oVi^Koi^KV00?oi^KV1Ol00009
onKViP03o`000?oVi^Koi^KV00?oi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oV
i^Koi^KV01;oi^KV000conKViP03o`000?oVi^Koi^KV00Koi^KV0_l00005onKViP04o`000?oVi^Ko
i^KVo`0000[oi^KV00?o0000onKVi_oVi^H00ooVi^H4o`0000Woi^KV00?o0000onKVi_oVi^H0=_oV
i^H00ol0003oi^KVonKViP06onKViP;o00001_oVi^H01?l0003oi^KVonKVi_l0000:onKViP03o`00
0?oVi^Koi^KV00?oi^KV1?l00008onKViP03o`000?oVi^Koi^KV01;oi^KV000`onKViP05o`000?oV
i^Koi^KVonKVi_l000002OoVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Ko000000Koi^KV
1?l00006onKViP03o`000?oVi^Koi^KV00_oi^KV00?o0000onKVi_oVi^H0<_oVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000Woi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVo`000006onKViPCo
00001_oVi^H00ol0003oi^KVonKViP0:onKViP03o`000?oVi^Koi^KV017oi^KV000`onKViP05o`00
0?oVi^Koi^KVonKVi_l000001OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV0_l00006onKV
iP03o`000?oVi^Koi^KV00Soi^KV00?o0000onKVi_oVi^H01_oVi^H01Ol0003oi^KVonKVi_oVi^Ko
000003Coi^KV00Go0000onKVi_oVi^Koi^KVo`000005onKViP05o`000?oVi^Koi^KVonKVi_l00000
1ooVi^H2o`0000Koi^KV00?o0000onKVi_oVi^H02?oVi^H00ol0003oi^KVonKViP05onKViP05o`00
0?oVi^Koi^KVonKVi_l000004ooVi^H0037oi^KV0ol00007onKViP?o00002?oVi^H00ol0003oi^KV
onKViP04onKViPGo00001ooVi^H2o`0000Koi^KV1Ol0000eonKViP?o00001ooVi^H3o`0000Woi^KV
00?o0000onKVi_oVi^H01?oVi^H5o`0000Ooi^KV0_l00005onKViPGo00004ooVi^H00>?oi^KV000Y
onKViP03o`000?oVi^Koi^KV06Ooi^KV00?o0000onKVi_oVi^H0COoVi^H002Ooi^KV0_l000000onc
/k?o0000o`00000jo`0002coi^KV?ol0000BonKViP00:OoVi^H00onc/k?oi^KVonKViP1WonKViP03
o`000?oVi^Koi^KV04goi^KV000YonKViP03ok>c/ooVi^Koi^KV06Ooi^KV0_l0001>onKViP00:OoV
i^H00ol0003o/k>conKViP1WonKViP;o0000C_oVi^H002Woi^KV00?o0000ok>c/ooVi^H0IooVi^H0
0ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`00
00;oi^KV1Ol00002onKViP03o`000?nc/k?oi^KV06Ooi^KV0_l0001>onKViP004OoVi^H01?l0003o
i^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H00ol0003oi^KVok>c/`1AonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooV
i^H3o`0000;oi^KV00?o0000onKVi_oVi^H0COoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_nc/k<0
D?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H0
1?l0003oi^KVo`000?l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oV
i^Koi^KVo`0000Coi^KV00Oo0000onKVi_oVi^Koi^KVo`000?oVi^Ko/k>c053oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00005onKViP03o`000?oVi^Ko000004ooi^KV000A
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko/k>cD?oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oV
i^Koi^KVo`0000Goi^KV00Co0000onKVi_l0003o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H00onc/k?oi^KVonKViP1=onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko
0000onKViP04o`0000;oi^KV00?o0000onKVi_oVi^H0COoVi^H001;oi^KV0_l0000:onKViP;o0000
0ooVi^H3o`0000?oi^KV00Co0000onKVi_oVi^Ko/k>cCooVi^H01?l0003oi^KVonKVi_l00008onKV
iP06o`000?oVi^Koi^KVo`000?oVi^Ko00001OoVi^H2o`0004koi^KV000BonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP03onKViP;o00001?oVi^H3o`0000;oi^KV00Co0000onKVi_oVi^Ko/k>cD?oV
i^H2o`0000[oi^KV0_l00002onKViPGo000000?oi^KVo`000?oVi^H0C_oVi^H0017oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP05o`000?oVi^Koi^KVonKVi_l0
00000_oVi^H00onc/k?oi^KVonKViP1TonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Go00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko
/k>c06Goi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00?o/k>conKVi_oV
i^H0DooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o0000onKVi_oV
i^H0COoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKV
iP03o`000?oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KVok>c/`1DonKViP04o`000?oVi^Ko
i^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l0001>onKViP004OoVi^H01?l0003oi^KVonKV
i_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l00003onKViP03o`000?oVi^Koi^KV00;o
i^KV00?o/k>conKVi_oVi^H0DOoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KV
onKVi_l00000CooVi^H001;oi^KV0_l0000:onKViP;o00001OoVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000Coi^KV00?o/k>conKVi_oVi^H0DOoVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oV
i^Koi^KVonKViScoc<c<5?oVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0
0003onKViP?o00000ooVi^H00ol0003oi^KVonKViP02onKViP03ok>c/ooVi^Koi^KV057oi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko
i^KVo`0000Coi^KV00?o/k>conKVi_oVi^H0DOoVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000
0ooVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko
0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00?o/k>conKVi_oVi^H0DOoVi^H2
o`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l00003onKViP03o`000?oVi^Koi^KV00?oi^KV
00?o/k>conKVi_oVi^H0HOoVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Ko0000onKVi_oVi^Ko0000onKVi_l00006onKViP03o`000?oVi^Koi^KV00?oi^KV00?o/k>conKV
i_oVi^H0HOoVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00Coi^KV00?o/k>c
onKVi_oVi^H0H?oVi^H00ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000[oi^KV0_l00004onKV
iP;o00000ooVi^H00ol0003oi^KVonKViP04onKViP03ok>c/ooVi^Koi^KV04[oi^KV0_l00004onKV
iP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP?o00000_oVi^H2o`0004koi^KV000BonKViP;o
00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oV
i^H01?oVi^H00onc/k?oi^KVonKViP19onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKV
i_oVi^Koi^KVo`000003onKViP03o`000?oVi^Ko000004ooi^KV000AonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000Ko
i^KV00?o/k>conKVi_oVi^H0BOoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV
00Goi^KV00Co0000onKVi_l0003o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00onc/k?o
i^KVonKViP18onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0
003oi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00Goi^KV00?o/k>conKVi_oVi^H0B?oVi^H0
1?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViPCo00000_oVi^H2o`0004koi^KV
000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o/k>conKVi_oVi^H0B?oVi^H01?l0003oi^KVonKVi_l0
0008onKViP;o00000ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV04goi^KV000A
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00?o/k>conKVi_oVi^H0BOoVi^H2o`0000[oi^KV00Co0000onKV
i_oVi^Koi^KV1Ol000000ooVi^Ko0000o`00001>onKViP004_oVi^H2o`0000[oi^KV0_l00003onKV
iP?o00000ooVi^H00ol0003oi^KVonKViP06onKViP03ok>c/ooVi^Koi^KV05koi^KV00?o0000onKV
i_oVi^H0COoVi^H002Woi^KV00?o0000onKVi_oVi^H01_oVi^H00onc/k?oi^KVonKViP1NonKViP;o
0000C_oVi^H001Soi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`00
0?oVi^Koi^KV00Koi^KV00?o/k>conKVi_oVi^H0C_oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Ko
i^KV1Ol000000ooVi^Ko0000o`00001>onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKViP03
o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H01ooVi^H00onc/k?oi^KVonKViP1<onKViP04
o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0001?onKViP005ooVi^H0
1?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H01ooV
i^Hbok>c/agoi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0004ko
i^KV000GonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003o
i^KVonKViP1FonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Co0000onKVi_oVi^Ko0000CooVi^H0
01Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP1KonKViP04o`000?oVi^Ko
i^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00001AonKViP005ooVi^H01?l0003oi^KVonKV
i_l00008onKViP;o0000GOoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKV
i_l00000DOoVi^H001Soi^KV0_l0000:onKViP03o`000?oVi^Koi^KV05coi^KV0_l00009onKViP?o
0000D_oVi^H00>?oi^KV000gonKViP?o00000_oVi^H6o`000004onKVi_l0003o0000o`0000?oi^KV
0ol00002onKViP03o`000?oVi^Ko000000;o0000COoVi^H3o`0000;oi^KV0ol000000ooVi^Ko0000
o`000003o`0000;oi^KV1_l000001ooVi^Ko0000o`000?l0003oi^KVo`000?oVi^H00ol000000ooV
i^Ko0000o`00000PonKViP00>?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV
00?o0000onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00008OoVi^H003Soi^KV00?o0000onKVi_l000000ooV
i^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_l000000_oV
i^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003o
i^KVonKVi_l0003oi^KVo`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVo`000?l0
0002onKViP03o`000?oVi^Ko000002;oi^KV000honKViP?o00000ooVi^H3o`0000?oi^KV0ol00003
onKViP?o00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004goi^KV0_l00003onKViPCo00000_oV
i^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVo`000?l00002onKViP;o0000
8ooVi^H003Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko
i^KV04[oi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oV
i^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H2o`000007onKVi_l0003oi^KVonKVi_l0
003oi^KVo`00000RonKViP00>?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?o
i^KV00?o0000onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP;o000000Go
i^KVo`000?oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01ooi^KV000gonKViPCo00000_oV
i^H5o`000003onKVi_l0003o000000;o00000_oVi^H4o`0000?oi^KV0ol0001>onKViP?o000000Go
i^KVo`000?l0003o0000onKViP06o`0000;oi^KV1Ol000001?oVi^Ko0000o`000?oVi^H6o`000003
onKVi_l0003o0000023oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV
003SonKViP00hooVi^H009Ooi^KV1Ol00006onKViP?o00002?oVi^H3o`0000Koi^KV0ol00007onKV
iP?o00001ooVi^H00ol0003oi^KVonKViP0FonKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oV
i^H00ooVi^H3o`0007Soi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000Soi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Go
0000onKVi_oVi^Koi^KVo`000006onKViP03o`000?oVi^Koi^KV01Koi^KV000@onKViP04o`000?oV
i^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00001fonKViP03o`000?oVi^Koi^KV00Wo
i^KV00?o0000onKVi_oVi^H00ooVi^H5o`0000Woi^KV00?o0000onKVi_oVi^H00ooVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H05OoVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H5o`0000;oi^KV00?oOgmoonKVi_oVi^H0MOoVi^H00ol0003oi^KVonKViP06onKV
iP;o00001_oVi^H01?l0003oi^KVonKVi_l0000:onKViP03o`000?oVi^Koi^KV00?oi^KV1?l00008
onKViP03o`000?oVi^Koi^KV01Goi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co0000
onKVi_oVi^Ko00000ooVi^H00omoOgooi^KVonKViP1bonKViP05o`000?oVi^Koi^KVonKVi_l00000
2OoVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Ko000000Koi^KV1?l00006onKViP03o`00
0?oVi^Koi^KV00[oi^KV00?o0000onKVi_oVi^H05?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H00ol0003oi^KVo`000003onKViP03ogmoOooVi^Koi^KV07;oi^KV00Go0000onKVi_oVi^Ko
i^KVo`000005onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H2o`0000Koi^KV00?o0000onKV
i_oVi^H02?oVi^H00ol0003oi^KVonKViP05onKViP05o`000?oVi^Koi^KVonKVi_l000005_oVi^H0
013oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000?oi^KV00?o0000ogmoOooVi^H0LooVi^H3
o`0000Ooi^KV0ol00009onKViP03o`000?oVi^Koi^KV00Coi^KV1Ol00007onKViP;o00001OoVi^H5
o`0001Koi^KV000AonKViP;o00002ooVi^H01_l0003oi^KVonKVi_oVi^Ko0000ogmoOkooi^KV000A
onKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oOgmoonKViP1[
onKViP03o`000?oVi^Koi^KV053oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`000002onKViP03o`000?moOgooi^KV06[oi^KV??l000000onIVIWo0000o`00
000EonKViP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
OgmoJooVi^H2o`0003Woi^KV00?oVIVIonKVi_oVi^H05OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00002ooVi^H01_l0003oi^KVonKVi_l0003oi^KVogmoOf_oi^KV0_l0000ionKViP03oiVIVOoVi^Ko
i^KV01Goi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l00003onKViP03o`000?oVi^Ko
Ogmo06_oi^KV00?o0000onKVi_oVi^H0=ooVi^H00onIVIWoi^KVonKViP0FonKViP004?oVi^H01?l0
003oi^KVonKVi_l00007onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_moOgl0FooVi^H2
o`0000Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol000000ooVi^Ko0000o`00000honKViP03oiVIVOoV
i^Koi^KV01Koi^KV000AonKViP;o00002?oVi^H5o`0000;oi^KV00Co0000onKVi_oVi^KoOgmoFOoV
i^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H00_l0000honKViP03
oiVIVOoVi^Koi^KV01Koi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o0000
0ooVi^H01?l0003oi^KVonKVi_moOgmIonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKV
i_oVi^Koi^KVo`00000ionKViP03oiVIVOoVi^Koi^KV01Koi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP04o`000?oVi^Koi^KVogmoOeWoi^KV
00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_nIVIWo000003Ooi^KV00?oVIVIonKV
i_oVi^H05ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000;oi^KV00Go0000onKVi_oVi^Koi^KVogmoO`1HonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV
00So0000onKVi_oVi^Koi^KVo`000?oVi^KoVIVIo`0003Ooi^KV00?oVIVIonKVi_oVi^H05ooVi^H0
013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00Go0000onKVi_oVi^Koi^KVogmo
O`1HonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00So0000onKVi_oVi^Koi^KVo`000?oVi^Ko0000
oiVIVCOoi^KV00?oVIVIonKVi_oVi^H05ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H0
0ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_moOgl0FOoVi^H2o`0000Woi^KV0ol0
0002onKViP03o`000?nIVIWoi^KV03Goi^KV00?oVIVIonKVi_oVi^H06?oVi^H0013oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_moOgl0
FOoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o0000oiVIVOoVi^H0
=OoVi^H00onIVIWoi^KVonKViP0HonKViP004OoVi^H2o`0000[oi^KV0_l00003onKViP03o`000?oV
i^Koi^KV00;oi^KV00?oOgmoonKVi_oVi^H0EOoVi^H01?l0003oi^KVonKVi_l00007onKViP06o`00
0?oVi^Koi^KVonKVi_l0003oi^KV0_l000000onIVIWoi^KVonKViP0conKViP03oiVIVOoVi^Koi^KV
01Soi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00;o
i^KV00?o0000onKVi_oVi^H00_oVi^H00omoOgooi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`00
00_oi^KV00Go0000onKVi_l0003oi^KVoiVIV@0eonKViP03oiVIVOoVi^Koi^KV01Soi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP02
onKViP03ogmoOooVi^Koi^KV05Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000;oi^KV0_l0
00000onIVIWoi^KVonKViP0bonKViP03oiVIVOoVi^Koi^KV01Woi^KV000@onKViP04o`000?oVi^Ko
i^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP03ogmoOooVi^Koi^KV05Goi^KV
00Co0000onKVi_oVi^Ko00002ooVi^H01_l0003oi^KVo`000?l0003oi^KVoiVIVC?oi^KV00?oVIVI
onKVi_oVi^H06OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Goi^KV00?oOgmoonKVi_oVi^H0E?oVi^H01?l0003oi^KVonKVi_l00007onKViP07o`00
0?oVi^Koi^KVonKVi_l0003oi^KVo`000002onKViP03oiVIVOoVi^Koi^KV037oi^KV00?oVIVIonKV
i_oVi^H06OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l00005
onKViP03ogmoOooVi^Koi^KV05Goi^KV0_l00009onKViP?o00000_oVi^H2o`000003onKVi_nIVIWo
i^KV03;oi^KV00?oVIVIonKVi_oVi^H06OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00omoOgooi^KVonKV
iP1UonKViP;o00000_oVi^H00onIVIWoi^KVonKViP0_onKViP03oiVIVOoVi^Koi^KV01[oi^KV000A
onKViP;o00002?oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00omoOgooi^KVonKViP0j
onKViP03ogmoOooVi^Koi^KV01Soi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0ol00000
0ooVi^Ko0000onKViP02onKViP03oiVIVOoVi^Koi^KV02ooi^KV00?oVIVIonKVi_oVi^H06_oVi^H0
017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV
00Coi^KV00?oOgmoonKVi_oVi^H0>OoVi^H00omoOgooi^KVonKViP0GonKViP04o`000?oVi^Koi^KV
o`0000[oi^KV00?o0000onKVi_oVi^H00_l00002onKViP03oiVIVOoVi^Koi^KV02ooi^KV00?oVIVI
onKVi_oVi^H06_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000;oi^KV00?o0000onKVi_oVi^H01?oVi^H00omoOgooi^KVonKViP0honKViP03ogmoOooV
i^Koi^KV01Soi^KV00Co0000onKVi_oVi^Ko00001ooVi^H5o`000003onKVi_l0003o000000?oi^KV
00?oVIVIonKVi_oVi^H0;_oVi^H00onIVIWoi^KVonKViP0JonKViP004?oVi^H01?l0003oi^KVonKV
i_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP04onKViP03
ogmoOooVi^Koi^KV03Ooi^KV00?oOgmoonKVi_oVi^H06OoVi^H01?l0003oi^KVonKVi_l00007onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV0_l00003onKViP03oiVIVOoVi^Koi^KV02goi^KV00?oVIVI
onKVi_oVi^H06ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H3o`0000?oi^KV00?o0000
onKVi_oVi^H01?oVi^H00omoOgooi^KVonKViP0fonKViP03ogmoOooVi^Koi^KV01[oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVo`000002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o
VIVIonKVi_oVi^H0;OoVi^H00onIVIWoi^KVonKViP0KonKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP05onKViP03ogmo
OooVi^Koi^KV03Goi^KV00?oOgmoonKVi_oVi^H06_oVi^H01?l0003oi^KVonKVi_l00009onKViP;o
00000_oVi^H2o`0000Coi^KV00?oVIVIonKVi_oVi^H0;?oVi^H00onIVIWoi^KVonKViP0KonKViP00
4?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0
003oi^KVonKViP05onKViP03ogmoOooVi^Koi^KV03Coi^KV00?oOgmoonKVi_oVi^H07?oVi^H2o`00
00_oi^KV00?o0000onKVi_oVi^H00_l00004onKViP03oiVIVOoVi^Koi^KV02coi^KV00?oVIVIonKV
i_oVi^H06ooVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03
o`000?oVi^Koi^KV00Goi^KV00?oOgmoonKVi_oVi^H0<ooVi^H00omoOgooi^KVonKViP0MonKViP;o
00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H00ol0003oi^KVonKViP03onKViP03
oiVIVOoVi^Koi^KV02_oi^KV00?oVIVIonKVi_oVi^H07?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000ogmoOol000000_l00007onKV
iP?o00002OoVi^H3o`0000Soi^KV0ol00008onKViP?o00001?oVi^H00omoOgooi^KVonKViP02onKV
iP03o`000?oVi^Koi^KV01Soi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01_l0003oi^KVonKVi_oV
i^Ko0000onKViP;o00001OoVi^H00onIVIWoi^KVonKViP0ZonKViP03oiVIVOoVi^Koi^KV01coi^KV
000@onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?moOgoo
i^KVonKVi_l00006onKViP05o`000?oVi^Koi^KVonKVi_l000002OoVi^H00ol0003oi^KVonKViP06
onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV
00?oOgmoonKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0HonKViP04o`000?oVi^Koi^KVo`0000_o
i^KV00Co0000onKVi_l0003o00001OoVi^H00onIVIWoi^KVonKViP0ZonKViP03oiVIVOoVi^Koi^KV
01coi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00002onKViP03o`000?oVi^Koi^KV
00Koi^KV00?oOgmoo`000?oVi^H02ooVi^H00ol0003oi^KVonKViP04onKViPGo00002ooVi^H00ol0
003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00omoOgooi^KVonKViP04
onKViP03o`000?oVi^Koi^KV01Ooi^KV00Co0000onKVi_oVi^Ko00002ooVi^H00ol0003oi^KVo`00
0006onKViP03oiVIVOoVi^Koi^KV02Woi^KV00?oVIVIonKVi_oVi^H07OoVi^H0013oi^KV00Co0000
onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0
1_oVi^H00omoOgooi^KVo`000009onKViP;o00001ooVi^H01?l0003oi^KVonKVi_l0000<onKViP03
o`000?oVi^Koi^KV00Coi^KV1?l00002onKViP03ogmoOooVi^Koi^KV00Goi^KV00?o0000onKVi_oV
i^H05ooVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000_oVi^H2o`0000Koi^KV00?oVIVIonKV
i_oVi^H0:?oVi^H00onIVIWoi^KVonKViP0MonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKV
iP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP05onKViP05o`000?oVi^Ko
OgmoonKVi_l000002_oVi^H00ol0003oi^KVonKViP05onKViP03o`000?oVi^Ko000000Soi^KV1?l0
0007onKViP03o`000?oVi^Koi^KV00?oi^KV00?oOgmoonKVi_oVi^H01_oVi^H00ol0003oi^KVonKV
iP0FonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000Koi^KV
00?oVIVIonKVi_oVi^H0:?oVi^H00onIVIWoi^KVonKViP0MonKViP004OoVi^H2o`0000Woi^KV0ol0
0003onKViP03o`000?oVi^Koi^KV00Goi^KV00Go0000onKVi_moOgooi^KVo`000006onKViP05o`00
0?oVi^Koi^KVonKVi_l000002?oVi^H2o`0000Soi^KV00?o0000onKVi_oVi^H02OoVi^H01Ol0003o
i^KVonKVi_oVi^KoOgmo00Goi^KV00Go0000onKVi_oVi^Koi^KVo`00000IonKViP;o00002?oVi^H5
o`000003onKVi_l0003o000000Koi^KV00?oVIVIonKVi_oVi^H0:?oVi^H00onIVIWoi^KVonKViP0M
onKViP008_oVi^H00ol0003oi^KVonKViP06onKViP03o`000?moOgoo000000Soi^KV0ol0000:onKV
iP03o`000?oVi^Koi^KV00Koi^KV1Ol00008onKViP;o000000?oOgmoonKVi_oVi^H01?oVi^H5o`00
01Woi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV
00Koi^KV00?oVIVIonKVi_oVi^H09_oVi^H00onIVIWoi^KVonKViP0NonKViP008_oVi^H00ol0003o
i^KVonKViP07onKViP03ogmoOooVi^Koi^KV01[oi^KV4_moOglTonKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV00Ko0000onKVi_oVi^Koi^KVo`000?oVi^H2o`0000Ooi^KV00?oVIVIonKVi_oVi^H08OoV
i^H6oiVIVB3oi^KV000RonKViP03o`000?oVi^Koi^KV00Soi^KV00?oOgmoonKVi_oVi^H03_oVi^H;
ogmoOcKoi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01_l0003oi^KVonKVi_oVi^Ko0000onKViP;o
00001ooVi^H00onIVIWoi^KVonKViP0=onKViQCoVIVI9_oVi^H0023oi^KV3Ol0000AogmoOb[o0000
5ooVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000_oVi^H00ol0003oi^KVonKViP07onKViPoo
VIVI>_oVi^H002;oi^KV00?o0000onKVi_oVi^H0F_oVi^H01?l0003oi^KVonKVi_l00007onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l0001AonKViP00OooVi^H01?l0003oi^KVonKVi_l00008onKViP03
o`000?oVi^Koi^KV05Goi^KV0020onKViP;o00002_oVi^H2o`0005Goi^KV003SonKViP00hooVi^H0
03Goi^KV0_l000001?oVi^Ko0000o`000?l00002onKViP;o00000ooVi^H3o`0000;oi^KV0_l00000
1OoVi^Ko0000o`000?l0003oi^KV00?o0000DOoVi^H3o`0000?oi^KV1Ol000001?oVi^Ko0000o`00
0?l00002onKViP?o000000Coi^KVo`000?l0003o0000:OoVi^H003Goi^KV00Go0000onKVi_oVi^Ko
i^KVo`000002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000003
onKViP05o`000?oVi^Koi^KVonKVi_l00000DooVi^H00ol0003oi^KVonKViP03onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV
02Soi^KV000eonKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003
onKViP04o`000?oVi^Koi^KVonKViPGo00000ooVi^H00ol0003oi^KVonKViP1AonKViP03o`000?oV
i^Koi^KV00?oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVo`000002onKViP05o`000?oV
i^Koi^KVonKVi_l00000:_oVi^H003Goi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP04o`00
0?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVo`000004onKViP03
o`000?oVi^Koi^KV057oi^KV0ol00003onKViP?o00000ooVi^H3o`0000;oi^KV00Go0000onKVi_oV
i^Koi^KVo`00000ZonKViP00=OoVi^H01Ol0003oi^KVo`000?oVi^Ko000000;oi^KV00[o0000onKV
i_oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko00000_oVi^H00ol0003oi^KVo`000002onKViP05
o`000?oVi^Ko0000onKVi_l00000DOoVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Ko
i^KV00?oi^KV00[o0000onKVi_oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000:_oVi^H003Go
i^KV0_l000000ooVi^Ko0000o`000002onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_l0
003oi^KVo`0000?oi^KV00Wo0000onKVi_oVi^Koi^KVo`000?oVi^Ko0000onKVi_l00000DOoVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Go0000onKVi_oVi^Ko
0000onKViP02o`000003onKVi_l0003o000002[oi^KV000eonKViP04o`000?oVi^Koi^KVonKViPGo
000000?oi^KVo`000?l000001Ol00002onKViP;o00000ooVi^H5o`00053oi^KV1?l00002onKViPGo
000000?oi^KVo`000?l000000_l00002onKViP04o`000?oVi^Koi^KVonKViP;o0000:OoVi^H00>?o
i^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00<?oVi^H5
o`0000Koi^KV0ol00007onKViP?o00001_oVi^H3o`0000Ooi^KV0ol00008onKViP03o`000?oVi^Ko
i^KV03Coi^KV1Ol00006onKViP?o00002?oVi^H3o`0000Koi^KV0ol00007onKViP?o00001ooVi^H0
0ol0003oi^KVonKViP0ConKViP00<OoVi^H01?l0003oi^KVonKVi_l00005onKViP05o`000?oVi^Ko
i^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l00000
1OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H0=OoVi^H01?l0003o
i^KVonKVi_l00005onKViP05o`000?oVi^Koi^KVonKVi_l000002?oVi^H00ol0003oi^KVonKViP04
onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV
00?o0000onKVi_oVi^H04ooVi^H003;oi^KV00?o0000onKVi_oVi^H02OoVi^H00ol0003oi^KVonKV
iP02onKViPGo00002OoVi^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_l00000
2?oVi^H00ol0003oi^KVonKViP0eonKViP03o`000?oVi^Koi^KV00Woi^KV00?o0000onKVi_oVi^H0
0ooVi^H5o`0000Woi^KV00?o0000onKVi_oVi^H00ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Oo
i^KV00?o0000onKVi_oVi^H04_oVi^H003?oi^KV00?o0000onKVi_oVi^H01_oVi^H2o`0000Goi^KV
00Co0000onKVi_oVi^Ko00002_oVi^H00ol0003oi^KVonKViP03onKViPCo00002OoVi^H00ol0003o
i^KVonKViP0fonKViP03o`000?oVi^Koi^KV00Koi^KV0_l00006onKViP04o`000?oVi^Koi^KVo`00
00[oi^KV00?o0000onKVi_oVi^H00ooVi^H4o`0000Soi^KV00?o0000onKVi_oVi^H04_oVi^H0033o
i^KV00Go0000onKVi_oVi^Koi^KVo`000009onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKV
i_l000001_oVi^H4o`0000Koi^KV00?o0000onKVi_oVi^H02ooVi^H00ol0003oi^KVonKViP0bonKV
iP05o`000?oVi^Koi^KVonKVi_l000002OoVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Ko
000000Koi^KV1?l00006onKViP03o`000?oVi^Koi^KV00[oi^KV00?o0000onKVi_oVi^H04OoVi^H0
033oi^KV00Go0000onKVi_oVi^Koi^KVo`000005onKViP05o`000?oVi^Koi^KVonKVi_l000001_oV
i^H2o`0000Koi^KV00?o0000onKVi_oVi^H02?oVi^H00ol0003oi^KVonKViP06onKViP05o`000?oV
i^Koi^KVonKVi_l00000=?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Go0000onKVi_oV
i^Koi^KVo`000007onKViP;o00001_oVi^H00ol0003oi^KVonKViP08onKViP03o`000?oVi^Koi^KV
00Goi^KV00Go0000onKVi_oVi^Koi^KVo`00000ConKViP00<OoVi^H3o`0000Ooi^KV0ol00008onKV
iP03o`000?oVi^Koi^KV00Coi^KV1Ol00007onKViP;o00001_oVi^H5o`0003Goi^KV0ol00007onKV
iP?o00002OoVi^H00ol0003oi^KVonKViP04onKViPGo00001ooVi^H2o`0000Goi^KV1Ol0000ConKV
iP00hooVi^H002Ooi^KV3?l0000boda<C003o`000?oVi^Koi^KV02[oi^KV00?o0000ofIVI_l00000
??l0000BonKViP00:OoVi^H05_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko
C4a<onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^H2o`00000TonKVi_l0
003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oV
i^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0
003oi^KVo`000?oVi^Ko0000;_oVi^H0=?mVIVKoi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`00
0?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKV
i_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`00
0?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^H2o`000006
onKVi_l0003oi^KVo`000?oVi^Ko00005?oVi^H002Woi^KV00?o0000onKVi_oVi^H01ooVi^H00om<
C4coi^KVonKViP1MonKViP03ofIVI_l0003oi^KV04goi^KV000YonKViP03o`000?oVi^Koi^KV00Ko
i^KV00?oC4a<onKVi_oVi^H0G_oVi^H00ol0003oIVIVonKViP1=onKViP00:OoVi^H00ol0003oi^KV
onKViP06onKViP03oda<C?oVi^Koi^KV05koi^KV00?o0000ofIVI_oVi^H0COoVi^H001;oi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViPGo00000_oVi^H00ol0003oi^KVonKV
iP06onKViP03oda<C?oVi^Koi^KV04Soi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0
0002onKViPGo000000?oi^KVo`000?mVIVH0C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoV
i^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0
1_oVi^H00om<C4coi^KVonKViP17onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01ol0003oi^KVonKVi_l0003oi^KVo`000?mVIVH0C_oVi^H0017oi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00;oi^KV00?o
0000onKVi_oVi^H01OoVi^H00om<C4coi^KVonKViP18onKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Co0000onKVi_oVi^Ko00000ooVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_mVIVH0COoVi^H0
017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Ko
i^KVonKVi_l000001ooVi^H00om<C4coi^KVonKViP18onKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Co0000onKVi_oVi^Ko00001?oVi^H00ol0003oi^KVonKViP02o`000003ofIVI_oVi^Koi^KV04_o
i^KV000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00?oC4a<onKVi_oVi^H0B?oVi^H01?l0003oi^KVonKVi_l0
0008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01Ol0003oi^KVo`000?oVi^KoIVIV
04goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00003onKViP05o`000?oVi^Koi^KV
onKVi_l000000_oVi^H00ol0003oi^KVonKViP04onKViP03oda<C?oVi^Koi^KV04Woi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Ko0000onKVi_l0
003o0000onKVi_mVIVI<onKViP004_oVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H00_oVi^H3o`00
00?oi^KV00?o0000onKVi_oVi^H01?oVi^H00om<C4coi^KVonKViP1:onKViP;o00002_oVi^H2o`00
00?oi^KV0ol00002onKViP;o000000?oi^KVofIVI_oVi^H0BooVi^H002Woi^KV00?o0000onKVi_oV
i^H01?oVi^H00om<C4coi^KVonKViP1PonKViP04o`000?oVi^Koi^KVofIVITcoi^KV000BonKViP;o
00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00001?oVi^H3o`0000;oi^KV00?o0000onKVi_oV
i^H01?oVi^H00om<C4coi^KVonKViP1:onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o
00001?oVi^H3o`000005onKVi_l0003o0000onKVi_mVIVH0C?oVi^H0017oi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H0
0om<C4coi^KVonKViP1:onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
1?oVi^H01?l0003oi^KVonKVi_l00003onKViP03ofIVI_oVi^Koi^KV04Woi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002onKViP03o`000?oVi^Koi^KV
00?oi^KV00?oC4a<onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Ko
i^KVo`000?oVi^H01Ol000000ooVi^Ko0000o`000002onKViP03ofIVI_oVi^Koi^KV04Woi^KV000A
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP05o`00
0?oVi^Koi^KVonKVi_l000001OoVi^H00om<C4coi^KVonKViP1:onKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV
00?oIVIVonKVi_oVi^H0BOoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KV
onKViP02onKViP03o`000?oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00om<C4coi^KV
onKViP1:onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0
003oi^KVo`000002onKViP;o00000_oVi^H00omVIVKoi^KVonKViP19onKViP004OoVi^H01?l0003o
i^KVonKVi_l00008onKViP;o00001OoVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H00om<
C4coi^KVonKViP1;onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooV
i^H2o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00omVIVKoi^KVonKViP18onKViP004_oVi^H2
o`0000[oi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00?o
C4a<onKVi_oVi^H0C?oVi^H2o`0000[oi^KV0_l00005onKViP03o`000?oVi^Koi^KV00;o00000ooV
i^H00omVIVKoi^KVonKViP18onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3
o`0000?oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV00?oC4a<onKVi_oVi^H0C?oVi^H2
o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol00002onKViP;o00000ooVi^H0
0omVIVKoi^KVonKViP18onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Ko
i^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00003onKViP03oda<C?oVi^Koi^KV04coi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000
onKVi_l000001OoVi^H00omVIVKoi^KVonKViP17onKViP004OoVi^H01?l0003oi^KVonKVi_l00009
onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00003onKViP03oda<
C?oVi^Koi^KV04coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000?oi^KV00Co0000onKVi_l0003o00001?oVi^H00omVIVKoi^KVonKViP17onKViP004OoVi^H0
1?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViPCo00000ooVi^H01Ol0003oi^KV
onKVi_oVi^KoC4a<04koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003o
i^KV00Co00000_oVi^H00ol0003oi^KVonKViP03onKViP03ofIVI_oVi^Koi^KV04Ooi^KV000AonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP05o`000?oV
i^Koi^KVonKVi_m<C4`0C_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00001OoVi^H2o`0000Coi^KV00?oIVIVonKVi_oVi^H0AooVi^H0017oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_m<
C4a?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003o
i^KVonKViP02onKViP03o`000?oVi^Koi^KV00Coi^KV00?oIVIVonKVi_oVi^H0A_oVi^H001;oi^KV
0_l0000:onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP04o`000?oVi^Koi^KVoda<C53o
i^KV0_l0000:onKViP;o00001?oVi^H2o`0000;oi^KV0_l00005onKViP03ofIVI_oVi^Koi^KV04Ko
i^KV000BonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H3o`0000?oi^KV
00Co0000onKVi_oVi^KoC4a<D?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?o
i^KV0ol00002onKViP03o`000?oVi^Koi^KV00Coi^KV00?oIVIVonKVi_oVi^H0A_oVi^H0017oi^KV
00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00om<C4coi^KVonKViP1=onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0000Goi^KV00?oIVIVonKV
i_oVi^H0A_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000?oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_m<C4a@onKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko000000Ooi^KV00?oIVIV
onKVi_oVi^H0AOoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02
onKViP?o00000ooVi^H00ol0003oi^KVoda<C01@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H3o`0000;oi^KV0_l00006onKViP03ofIVI_oVi^Koi^KV04Goi^KV
000AonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP06
o`000?oVi^Koi^KVo`000?oVi^KoC4a<D?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l00006onKViP03ofIVI_oVi^Koi^KV
04Goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00003onKViP05o`000?oVi^Koi^KV
onKVi_l000000_oVi^H00ol0003oC4a<onKViP1@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko000000Soi^KV00?oIVIVonKVi_oV
i^H0A?oVi^H001;oi^KV0_l0000:onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`00
0?m<C4coi^KV057oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000;oi^KV0_l00007onKViP03ofIV
I_oVi^Koi^KV04Coi^KV000HonKViP;o00001?oVi^H01?l0003oi^KVonKVi_oVi^H5o`0000;oi^KV
00?o0000oda<C?oVi^H0EooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV
00?o0000onKVi_oVi^H01_oVi^H00omVIVKoi^KVonKViP14onKViP005ooVi^H01?l0003oi^KVonKV
i_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000oda<C?oVi^H0E_oVi^H01?l0003o
i^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o00001ooVi^H00omVIVKoi^KVonKViP14
onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?oC4a<
onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l00000
2OoVi^H00omVIVKoi^KVonKViP13onKViP005ooVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`00
0?oVi^Koi^KVonKVi_m<C4`0F?oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KV
onKViP;o00002?oVi^HbofIVIQCoi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV05Koi^KV00Co0000onKVi_oVi^Ko0000
2OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`00001KonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l0001C
onKViP006?oVi^H2o`0000Woi^KV0ol0001MonKViP;o00002_oVi^H00ol0003oi^KVonKViP1AonKV
iP00hooVi^H00>?oi^KV000jonKViPCo00001?oVi^H2o`0000;oi^KV0ol00003onKViPGo0000C_oV
i^H5o`000006onKVi_l0003o0000o`000?oVi^Ko00000ooVi^H2o`0000;oi^KV0_l000000ooVi^Ko
0000o`000004o`0000Coi^KV0ol0000RonKViP00>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l0001?
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KV
onKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l0
000QonKViP00>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1@onKViP03o`000?oVi^Koi^KV00?oi^KV
00Ko0000onKVi_l0003o0000onKVi_l00005onKViPGo00000_oVi^H00ol0003oi^KVonKViP06onKV
iP03o`000?oVi^Koi^KV01ooi^KV000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H0D?oVi^H3o`0000?oi^KV00Ko0000
onKVi_l0003o0000onKVi_l00006onKViP03o`000?oVi^Ko000000?oi^KV0ol00004onKViP;o0000
8_oVi^H003_oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0D?oVi^H00ol0003oi^KVonKViP03onKV
iP;o000000Coi^KVo`000?oVi^Ko00001_oVi^H00ol0003oi^KVo`000003onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H08_oVi^H003_oi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oV
i^H0D?oVi^H01?l0003oi^KVonKVi_l00002onKViP;o000000Goi^KVo`000?oVi^Koi^KVo`000002
onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`00
0?oVi^Koi^KVo`00027oi^KV000jonKViPCo00000_oVi^H3o`000003onKVi_l0003o000000Co0000
0_oVi^H3o`00053oi^KV1Ol000001?oVi^Ko0000o`000?oVi^H3o`0000;oi^KV0ol00002onKViP;o
00000ooVi^H4o`0000Coi^KV0ol0000QonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?o
i^KV003SonKViP00hooVi^H00>?oi^KV002JonKViPGo00001_oVi^H3o`0000Soi^KV0ol00006onKV
iP?o00001ooVi^H3o`0000Ooi^KV00?o0000onKVi_oVi^H04ooVi^H0017oi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0ol0001konKViP04o`000?oVi^Koi^KVo`0000Goi^KV00Go0000onKV
i_oVi^Koi^KVo`000008onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`00
0005onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H00ol0003oi^KVonKViP0ConKViP004?oV
i^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000NOoVi^H00ol0003o
i^KVonKViP09onKViP03o`000?oVi^Koi^KV00?oi^KV1Ol00009onKViP03o`000?oVi^Koi^KV00?o
i^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV01;oi^KV000@onKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV1Ol00002onKViPco6ATIKooVi^H00ol0003oi^KVonKViP06onKV
iP;o00001_oVi^H01?l0003oi^KVonKVi_l0000:onKViP03o`000?oVi^Koi^KV00?oi^KV1?l00008
onKViP03o`000?oVi^Koi^KV01;oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co0000
onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP08onKViP03oaTI6OoVi^Koi^KV06[oi^KV00Go
0000onKVi_oVi^Koi^KVo`000009onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l00000
1_oVi^H4o`0000Koi^KV00?o0000onKVi_oVi^H02_oVi^H00ol0003oi^KVonKViP0AonKViP004?oV
i^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H0
2?oVi^H00olI6AWoi^KVonKViP1ZonKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Ooi^KV0_l00006onKViP03o`000?oVi^Koi^KV00Soi^KV00?o0000onKV
i_oVi^H01OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000001?oi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000Woi^KV0_l00003onKViP03o`000?oVi^Koi^KV00Woi^KV00?o6ATIonKVi_oVi^H0J_oVi^H3
o`0000Ooi^KV0ol00009onKViP03o`000?oVi^Koi^KV00Coi^KV1Ol00007onKViP;o00001OoVi^H5
o`0001?oi^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0
003oi^KVonKViP09onKViP03oaTI6OoVi^Koi^KV06;oi^KV00?o0000onKVi_oVi^H0COoVi^H0013o
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000
onKVi_oVi^H02OoVi^H00olI6AWoi^KVonKViP1QonKViP03o`000?lc<c?o000003co00004_oVi^H0
013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000;onKViP03oaTI6OoV
i^Koi^KV06;oi^KV03Co<c<conKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oV
i^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0
003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`000?oV
i^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0003oi^KV0_l000001_oVi^Ko0000onKV
i_l0003oi^KVo`0001Coi^KV000@onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_oV
i^Ko00003?oVi^H00olI6AWoi^KVonKViP1QonKViP03oc<c<ol0003oi^KV04goi^KV000@onKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV1?l00003onKViP03o`000?oVi^Koi^KV00[oi^KV00?o6ATIonKV
i_oVi^H0HOoVi^H00ol0003o<c<conKViP1=onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKV
iP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H02_oVi^H00olI6AWoi^KVonKViP1QonKV
iP03o`000?lc<c?oi^KV04goi^KV000AonKViP;o00002?oVi^H5o`0000;oi^KV00?o0000onKVi_oV
i^H02_oVi^H00olI6AWoi^KVonKViP0conKViP03oaTI6OoVi^Koi^KV01Goi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l00002onKViPGo000000?oi^KVo`000?lc<c<0C_oVi^H0017oi^KV
0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00_oi^KV
00?o6ATIonKVi_oVi^H0<_oVi^H00olI6AWoi^KVonKViP0DonKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H01ol0003oi^KVonKVi_l0003oi^KVo`000?lc<c<0C_oV
i^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV
00?o0000onKVi_oVi^H02ooVi^H00olI6AWoi^KVonKViP0aonKViP03oaTI6OoVi^Koi^KV01Goi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP07o`000?oVi^Koi^KV
onKVi_l0003oi^KVoc<c<`1=onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oV
i^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0;onKViP03oaTI6OoVi^Koi^KV033oi^KV
00?o6ATIonKVi_oVi^H05_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`00
00Coi^KV00?o0000onKVi_oVi^H00_l000000olc<c?oi^KVonKViP1;onKViP004?oVi^H01?l0003o
i^KVonKVi_l00007onKViPCo00000ooVi^H00ol0003oi^KVonKViP0<onKViP03oaTI6OoVi^Koi^KV
02koi^KV00?o6ATIonKVi_oVi^H05ooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00000ooVi^H01Ol0003oi^KVo`000?l0003o<c<c04goi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP0<onKViP03
oaTI6OoVi^Koi^KV02koi^KV00?o6ATIonKVi_oVi^H05ooVi^H01?l0003oi^KVonKVi_l00008onKV
iP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`000002onKViP03oc<c<ooV
i^Koi^KV04[oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?o0000onKVi_oVi^H00ooV
i^H00ol0003oi^KVonKViP0<onKViP03oaTI6OoVi^Koi^KV02goi^KV00?o6ATIonKVi_oVi^H06OoV
i^H2o`0000[oi^KV0_l00003onKViP?o00000_oVi^H2o`000003onKVi_lc<c?oi^KV04_oi^KV000A
onKViP;o00002_oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H03?oVi^H00olI6AWoi^KVonKViP0/
onKViP03oaTI6OoVi^Koi^KV01[oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00004
onKViP?o000000Goi^KVo`000?oVi^Koi^KVoc<c<`1<onKViP004OoVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00goi^KV00?o6ATI
onKVi_oVi^H0:_oVi^H00olI6AWoi^KVonKViP0JonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co
0000onKVi_oVi^Ko00001?oVi^H00ol0003oi^KVonKViP02o`000003onKVi_lc<c?oi^KV04_oi^KV
000@onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KV
onKViP0=onKViP03oaTI6OoVi^Koi^KV02[oi^KV00?o6ATIonKVi_oVi^H06_oVi^H01?l0003oi^KV
onKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01Ol000000ooVi^Ko0000onKViP02onKV
iP03oc<c<ooVi^Koi^KV04Woi^KV000@onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKV
i_oVi^Koi^KVo`00000?onKViP03oaTI6OoVi^Koi^KV02Woi^KV00?o6ATIonKVi_oVi^H06ooVi^H0
1?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000_oVi^H00ol0003o
i^KVonKViP02o`0000;oi^KV00?o<c<conKVi_oVi^H0BOoVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000ooi^KV00?o6ATIonKVi_oVi^H0:?oVi^H00olI
6AWoi^KVonKViP0LonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H00ol0003oi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_lc<c<0BooVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l0000@onKViP03oaTI6OoVi^Koi^KV02Oo
i^KV00?o6ATIonKVi_oVi^H07?oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KV
o`0000?oi^KV0_l00002onKViP;o00000_oVi^H00olc<c?oi^KVonKViP19onKViP004?oVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKV
iP0>onKViP03oaTI6OoVi^Koi^KV02Koi^KV00?o6ATIonKVi_oVi^H07_oVi^H2o`0000[oi^KV0_l0
0005onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?o<c<conKVi_oVi^H0B?oVi^H0017oi^KV0_l0
0008onKViPGo00000_oVi^H00ol0003oi^KVonKViP0>onKViP03oaTI6OoVi^Koi^KV02Goi^KV00?o
6ATIonKVi_oVi^H0=OoVi^H2o`0000?oi^KV00?o<c<conKVi_oVi^H0B?oVi^H0017oi^KV0_l00004
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV00koi^KV00?o6ATI
onKVi_oVi^H09?oVi^H00olI6AWoi^KVonKViP0PonKViP;o00001?oVi^H00ol0003oi^KVonKViP03
onKViP;o00000ooVi^H3o`0000;oi^KV0_l00003onKViP03oc<c<ooVi^Koi^KV04Soi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV00ooi^KV00?o6ATIonKVi_oVi^H08ooVi^H00olI6AWoi^KVonKViP0OonKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Ko0000
00Goi^KV00?o<c<conKVi_oVi^H0AooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H03ooVi^H00olI6AWoi^KVonKViP0R
onKViP03oaTI6OoVi^Koi^KV023oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKV
i_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o00001?oVi^H00olc<c?oi^KVonKViP17onKV
iP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP?o00000ooVi^H00ol0003oi^KVonKViP0?onKV
iP03oaTI6OoVi^Koi^KV027oi^KV00?o6ATIonKVi_oVi^H08OoVi^H01?l0003oi^KVonKVi_l00008
onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00?o
<c<conKVi_oVi^H0AooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H03ooVi^H00olI6AWoi^KVonKViP0PonKViP03oaTI
6OoVi^Koi^KV02;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000Goi^KV0_l00004onKViP03oc<c<ooVi^Koi^KV04Ooi^KV000@onKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV013oi^KV00?o
6ATIonKVi_oVi^H07ooVi^H00olI6AWoi^KVonKViP0RonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00Co
i^KV00?o<c<conKVi_oVi^H0A_oVi^H0017oi^KV0_l00009onKViP?o00000ooVi^H00ol0003oi^KV
onKViP0@onKViP03oaTI6OoVi^Koi^KV01koi^KV00?o6ATIonKVi_oVi^H09?oVi^H2o`0000[oi^KV
0_l00004onKViP;o00000_oVi^H2o`0000Goi^KV00?o<c<conKVi_oVi^H0A_oVi^H0017oi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV013oi^KV00?o
6ATIonKVi_oVi^H07OoVi^H00olI6AWoi^KVonKViP0UonKViP;o00001?oVi^H00ol0003oi^KVonKV
iP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H01?oVi^H00olc<c?oi^KVonKV
iP16onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000
1ooVi^H5o`0000Ooi^KV00?o6ATIo`000?l000002OoVi^H3o`0000Soi^KV0ol00004onKViP04oaTI
6OoVi^Koi^KVonKViP?o00002OoVi^H00ol0003oi^KVonKViP0EonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko0000o`0000Goi^KV
00?o<c<conKVi_oVi^H0A_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Koi^KV00Go0000oaTI6OoVi^Koi^KVo`000009
onKViP03o`000?oVi^Koi^KV00Koi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04oaTI6OoV
i^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H01_oVi^H00ol0003oi^KVonKViP0EonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko
0000o`0000Koi^KV00?o<c<conKVi_oVi^H0AOoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H4o`0000;oi^KV00?o0000onKVi_oVi^H01ooVi^H00ol0003oi^KVonKViP07onKViP04oaTI6OoV
i^Koi^KVo`0000Koi^KV1Ol0000;onKViP04o`000?oVi^Koi^KVoaTI6@?oi^KV00Go0000onKVi_oV
i^Koi^KVo`000009onKViP03o`000?oVi^Koi^KV01Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1?l0003oi^KVonKVi_l00002onKViP?o00000_oVi^H00ol0003oi^KVonKViP05onKViP03oc<c<ooV
i^Koi^KV04Goi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KV
o`000002onKViP03o`000?oVi^Koi^KV00Soi^KV00?o0000onKVi_oVi^H01_oVi^H00olI6AWo0000
o`000007onKViP04o`000?oVi^Koi^KVo`0000coi^KV00?o0000onKVi_lI6AT01?oVi^H4o`0000[o
i^KV00?o0000onKVi_oVi^H05?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KV
o`000?oVi^Ko00000ooVi^H01?l0003oi^KVo`000?l00006onKViP03oc<c<ooVi^Koi^KV04Goi^KV
000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03
o`000?oVi^Koi^KV00Goi^KV00Go0000onKVi_oVi^Koi^KVo`000008onKViP03oaTI6OoVi^Ko0000
00Ooi^KV00?o0000onKVi_l000002?oVi^H4o`0000;oi^KV00?o6ATIonKVi_oVi^H00_oVi^H00ol0
003oi^KVonKViP0<onKViP03o`000?oVi^Koi^KV01?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_l000002?oVi^H00olc<c?oi^KV
onKViP14onKViP004OoVi^H2o`0000Woi^KV0ol00003onKViP03o`000?oVi^Koi^KV00Goi^KV00Go
0000onKVi_oVi^Koi^KVo`000006onKViP05o`000?oVi^Ko6ATIonKVi_l000002?oVi^H2o`0000So
i^KV00?o0000onKVi_oVi^H00_oVi^H00olI6AWoi^KVonKViP04onKViP03o`000?oVi^Koi^KV00Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`00000FonKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKV
iP;o00001ooVi^H00olc<c?oi^KVonKViP14onKViP008_oVi^H00ol0003oi^KVonKViP06onKViP?o
00002?oVi^H00ol0003o6ATIo`00000:onKViP03o`000?oVi^Koi^KV00Koi^KV1?l000000olI6AWo
i^KVonKViP06onKViP;o00001ooVi^H5o`0001coi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;o
i^KV0ol00002onKViP03o`000?oVi^Koi^KV00Koi^KV00?o<c<conKVi_oVi^H0A?oVi^H002;oi^KV
00?o0000onKVi_oVi^H04_oVi^H00olI6AWoi^KVonKViP0?onKViPOo6ATI<_oVi^H01?l0003oi^KV
onKVi_l00009onKViP04o`000?oVi^Koi^KVonKViP;o00001ooVi^H00olc<c?oi^KVonKViP14onKV
iP008_oVi^H00ol0003oi^KVonKViP0ConKViP03oaTI6OoVi^Koi^KV00?oi^KV2olI6ATionKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000009onKViP03oc<c<ooVi^Ko
i^KV04?oi^KV000PonKViQSo00001_lI6ATZo`0001[oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H0
1?l0003oi^KVonKVi_oVi^H2o`0000Soi^KV<_lc<c<DonKViP008_oVi^H00ol0003oi^KVonKViP1M
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP00P_oV
i^H01?l0003oi^KVonKVi_l00008onKViP;o0000DooVi^H008?oi^KV0_l0000:onKViP03o`000?oV
i^Koi^KV057oi^KV003SonKViP00=ooVi^H2o`0000;oi^KV0ol00002onKViP03o`000?oVi^Ko0000
00;o00000ooVi^H3o`0000?oi^KV0ol0001>onKViPCo00000_oVi^H5o`0000?oi^KV0_l00002onKV
iP;o000000?oi^KVo`000?l000001?l00004onKViP?o00008_oVi^H003Koi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04coi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0ooVi^H01?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00027oi^KV000eonKViP03
o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00Goi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP03onKViPGo00000_oVi^H0
0ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV01ooi^KV000eonKViP03o`000?oVi^Koi^KV
00Coi^KV0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H2o`0000Coi^KV0_l0001?
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Coi^KV00?o
0000onKVi_l000000ooVi^H3o`0000Coi^KV0_l0000RonKViP00=OoVi^H00ol0003oi^KVonKViP04
onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP03
o`000?oVi^Koi^KV04ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKV
iP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00002
onKViP03o`000?oVi^Koi^KV02;oi^KV000fonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000QonKViP00=ooVi^H3o`000003
onKVi_l0003o000000;o00000ooVi^H3o`0000Coi^KV0ol00003onKViP?o0000COoVi^H4o`0000;o
i^KV1Ol00003onKViP?o00000_oVi^H2o`0000?oi^KV1?l00004onKViP?o00008OoVi^H00>?oi^KV
003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?o
i^KV003SonKViP00hooVi^H005[oi^KV1?l00025onKViP00FooVi^H2o`0008Koi^KV001KonKViP;o
0000Q_oVi^H003ooi^KV1Ol00002onKViPCo00002OoVi^H5o`0000?oi^KV1Ol00002onKViP?o0000
00?oi^KVo`000?l000000_l000000ooVi^Ko0000o`000004o`0000;oi^KV0_l000000ooVi^Ko0000
o`000002o`000003onKVi_l0003o000000;o00001OoVi^H4o`0000;oi^KV3?l000000ooVi^Ko0000
o`000004o`000003onKVi_l0003o000000Go0000?_oVi^H003koi^KV0_l00003onKViP;o00000_oV
i^H2o`0000Woi^KV0_l00003onKViP;o00000_oVi^H2o`0000;oi^KV1?l00002onKViP04o`000?oV
i^Ko0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l00000
0_oVi^H2o`000003onKVi_l0003o000000Ooi^KV0_l00002onKViP?o000000Coi^KVo`000?l0003o
i^KV0_l00002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000onKV
i_l000000_oVi^H2o`0003goi^KV000monKViP;o00001?oVi^H2o`0000;oi^KV0_l00008onKViP;o
00001OoVi^H2o`000003onKVi_l0003o000000;oi^KV1?l00004onKViP;o00000_oVi^H2o`000003
onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l0
00001ooVi^H2o`000004onKVi_l0003o0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKV
iP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000?oi^KV0ol0000monKV
iP00?OoVi^H2o`0000?oi^KV1?l000000ooVi^Ko0000o`000003o`0000Goi^KV0_l00005onKViP;o
000000?oi^KVo`000?l000000_oVi^H7o`000003onKVi_l0003o000000Coi^KV0ol00002onKViP;o
000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV1Ol00005onKViP?o
00000_oVi^H2o`000003onKVi_l0003o000000;oi^KV1?l00002onKViP?o0000?ooVi^H003goi^KV
0_l00008onKViP;o00000_oVi^H2o`0000Coi^KV0_l00005onKViP;o000000Goi^KVo`000?l0003o
0000onKViP04o`000004onKVi_l0003o0000onKViPKo000000?oi^KVo`000?l000000_oVi^H2o`00
0003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002o`0000Goi^KV0_l00003onKV
iP;o000000Coi^KVo`000?l0003oi^KV0_l00002onKViPGo00000_oVi^H2o`0000;oi^KV00Co0000
onKVi_l0003o00000_oVi^H00ol0003oi^KVonKViP0konKViP00?OoVi^H2o`0000Goi^KV00?o0000
onKVi_oVi^H00_l00002onKViP;o00001?oVi^H2o`0000Goi^KV1Ol000000ooVi^Ko0000o`000002
onKViP?o000000Ooi^KVo`000?l0003o0000onKVi_l0003oi^KV00?o00000_oVi^H4o`000003onKV
i_l0003o000000;o000000Koi^KVo`000?l0003o0000onKVi_l00005onKViP;o00000ooVi^H2o`00
00;oi^KV0ol00002onKViP?o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000
o`000?oVi^H01?l0000monKViP00?_oVi^H2o`0000?oi^KV0_l00002onKViP;o00000_oVi^H2o`00
00Goi^KV0_l00003onKViP;o00006OoVi^H2o`00017oi^KV0_l00003onKViP;o00003ooVi^H2o`00
04Koi^KV000oonKViPCo000000?oi^KVo`000?oVi^H01_l00007onKViPGo00006ooVi^H00ol0003o
i^KVonKViP0>onKViPOo00003ooVi^H3o`0004Koi^KV003SonKViP00hooVi^H00001\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-3.21794, \
-0.0445132, 0.101824, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-14.0653, -0.0890264, 0.101824, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-2.07686, -0.711658, 0.0894443, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-13.7599, -1.05067, 0.101824, 0.0140179}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {-3.21794, -0.306114, 0.101824, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-14.0653, -0.406114, 0.101824, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-2.03872, -2.61842, \
0.0888793, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> {-14.0653, \
-0.587, 0.101824, 0.0027459}}],

Cell[BoxData[
    \(evolveExpressions::"gpOperatorRanksInfo" \(\(:\)\(\ \)\) 
      "GA Operator Ranks: \!\(\[LeftSkeleton] 1 \[RightSkeleton]\)"\)], \
"Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Expression \!\(AntTracker[\(\(seq[advance]\)\)]\) or \!\(AntTracker[\(\
\(seq[advance]\)\)]\) does not contain pattern \!\({\(\(\(ifSensor[_]\)\)[__]\
\)}\).   Crossover not performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Expression \!\(AntTracker[\(\(seq[turnRight]\)\)]\) or \!\(AntTracker[\
\(\(seq[advance]\)\)]\) does not contain pattern \
\!\({\(\(\(ifSensor[_]\)\)[__]\)}\).   Crossover not performed."\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(8\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 0 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.76708 .04587 0 -8.79558 ]
[.76708 .04587 10.625 5.20442 ]
[.79932 .08307 0 -8.71661 ]
[.79932 .08307 10.625 5.28339 ]
[.82929 .11766 0 -8.64429 ]
[.82929 .11766 10.625 5.35571 ]
[.85724 .14992 0 -8.57782 ]
[.85724 .14992 10.625 5.42218 ]
[.88337 .18006 0 -8.51652 ]
[.88337 .18006 10.625 5.48348 ]
[.90783 .2083 0 -8.4598 ]
[.90783 .2083 10.625 5.5402 ]
[.93079 .2348 0 -8.40717 ]
[.93079 .2348 10.625 5.59283 ]
[.95239 .25972 0 -8.3582 ]
[.95239 .25972 10.625 5.6418 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 10.625 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.75341 .04937 m
.74658 .05113 L
s
gsave
.76708 .04587 -61 -12.7956 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.78561 .08643 m
.77876 .08811 L
s
gsave
.79932 .08307 -61 -12.7166 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.81556 .12089 m
.80869 .1225 L
s
gsave
.82929 .11766 -61 -12.6443 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.84348 .15302 m
.83659 .15457 L
s
gsave
.85724 .14992 -61 -12.5778 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.86957 .18305 m
.86268 .18455 L
s
gsave
.88337 .18006 -61 -12.5165 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.89402 .21118 m
.88711 .21262 L
s
gsave
.90783 .2083 -61 -12.4598 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.91696 .23758 m
.91004 .23897 L
s
gsave
.93079 .2348 -61 -12.4072 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.93853 .26241 m
.93161 .26376 L
s
gsave
.95239 .25972 -61 -12.3582 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.15689 .24061 m
.12197 .92021 L
s
.24246 .28849 m
.21711 .92967 L
s
.3187 .33116 m
.30103 .93802 L
s
.38706 .36941 m
.37562 .94545 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.44478 .37113 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.49252 .36203 m .57042 .37159 L .52233 .38044 L F
.44478 .37113 m .49252 .36203 L .52233 .38044 L F
.54151 .3527 m .61975 .36251 L .57042 .37159 L F
.49252 .36203 m .54151 .3527 L .57042 .37159 L F
.41246 .35221 m .49252 .36203 L .44478 .37113 L F
.59181 .34312 m .67039 .35318 L .61975 .36251 L F
.54151 .3527 m .59181 .34312 L .61975 .36251 L F
.46107 .34262 m .54151 .3527 L .49252 .36203 L F
.41246 .35221 m .46107 .34262 L .49252 .36203 L F
.64347 .33328 m .72237 .34361 L .67039 .35318 L F
.59181 .34312 m .64347 .33328 L .67039 .35318 L F
.511 .33276 m .59181 .34312 L .54151 .3527 L F
.46107 .34262 m .511 .33276 L .54151 .3527 L F
.37834 .33225 m .46107 .34262 L .41246 .35221 L F
.69654 .32316 m .77575 .33379 L .72237 .34361 L F
.64347 .33328 m .69654 .32316 L .72237 .34361 L F
.56229 .32264 m .64347 .33328 L .59181 .34312 L F
.511 .33276 m .56229 .32264 L .59181 .34312 L F
.42785 .32211 m .511 .33276 L .46107 .34262 L F
.37834 .33225 m .42785 .32211 L .46107 .34262 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .438 .92828 L p F P
0 0 0 r
s
.75109 .31277 m .8306 .32369 L .77575 .33379 L .5 0 1 r
F
.69654 .32316 m .75109 .31277 L .77575 .33379 L 1 0 0 r
F
.61501 .31223 m .69654 .32316 L .64347 .33328 L F
.56229 .32264 m .61501 .31223 L .64347 .33328 L F
.47874 .31169 m .56229 .32264 L .511 .33276 L F
.42785 .32211 m .47874 .31169 L .511 .33276 L F
.34228 .31115 m .42785 .32211 L .37834 .33225 L F
.57295 .92839 m .52132 .93033 L .48923 .92629 L p F P
0 0 0 r
s
.438 .92828 m .48923 .92629 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.80717 .30209 m .88697 .31331 L .8306 .32369 L .5 1 0 r
F
.75109 .31277 m .80717 .30209 L .8306 .32369 L .5 0 1 r
F
.66922 .30153 m .75109 .31277 L .69654 .32316 L 1 0 0 r
F
.61501 .31223 m .66922 .30153 L .69654 .32316 L F
.53107 .30097 m .61501 .31223 L .56229 .32264 L F
.47874 .31169 m .53107 .30097 L .56229 .32264 L F
.39271 .30042 m .47874 .31169 L .42785 .32211 L F
.34228 .31115 m .39271 .30042 L .42785 .32211 L F
.62603 .92639 m .57295 .92839 L .54191 .92423 L p F P
0 0 0 r
s
.48923 .92629 m .54191 .92423 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.48923 .92629 m .438 .92828 L .40302 .92412 L p 1 0 0 r
F P
0 0 0 r
s
.86486 .2911 m .94492 .30264 L .88697 .31331 L 1 0 0 r
F
.80717 .30209 m .86486 .2911 L .88697 .31331 L .5 1 0 r
F
.72497 .29053 m .80717 .30209 L .75109 .31277 L .5 0 1 r
F
.66922 .30153 m .72497 .29053 L .75109 .31277 L 1 0 0 r
F
.58489 .28995 m .66922 .30153 L .61501 .31223 L F
.53107 .30097 m .58489 .28995 L .61501 .31223 L F
.44459 .28938 m .53107 .30097 L .47874 .31169 L F
.39271 .30042 m .44459 .28938 L .47874 .31169 L F
.3041 .2888 m .39271 .30042 L .34228 .31115 L F
.68061 .92434 m .62603 .92639 L .59611 .92212 L p F P
0 0 0 r
s
.54191 .92423 m .59611 .92212 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.54191 .92423 m .48923 .92629 L .45525 .92201 L p 1 0 0 r
F P
0 0 0 r
s
.40302 .92412 m .45525 .92201 L .48923 .92629 L p 1 0 0 r
F P
0 0 0 r
s
.86486 .2911 m .92421 .27979 L .94492 .30264 L 1 0 0 r
F
.78235 .2792 m .86486 .2911 L .80717 .30209 L 0 1 1 r
F
.72497 .29053 m .78235 .2792 L .80717 .30209 L .5 0 1 r
F
.64027 .27861 m .72497 .29053 L .66922 .30153 L 1 0 0 r
F
.58489 .28995 m .64027 .27861 L .66922 .30153 L F
.49798 .27802 m .58489 .28995 L .53107 .30097 L F
.44459 .28938 m .49798 .27802 L .53107 .30097 L F
.35548 .27743 m .44459 .28938 L .39271 .30042 L F
.3041 .2888 m .35548 .27743 L .39271 .30042 L F
.73675 .92223 m .68061 .92434 L .65188 .91994 L p F P
0 0 0 r
s
.59611 .92212 m .65188 .91994 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.59611 .92212 m .54191 .92423 L .50901 .91983 L p 1 0 0 r
F P
0 0 0 r
s
.45525 .92201 m .50901 .91983 L .54191 .92423 L p 1 0 0 r
F P
0 0 0 r
s
.45525 .92201 m .40302 .92412 L .36594 .91971 L p 1 0 0 r
F P
0 0 0 r
s
.95551 .49559 m .89593 .50379 L .8735 .48672 L p 1 0 0 r
F P
0 0 0 r
s
.89593 .50379 m .85402 .91782 L .8142 .49517 L p .5 1 0 r
F P
0 0 0 r
s
.8142 .49517 m .8735 .48672 L .89593 .50379 L p .5 1 0 r
F P
0 0 0 r
s
.84141 .26754 m .92421 .27979 L .86486 .2911 L .5 1 0 r
F
.78235 .2792 m .84141 .26754 L .86486 .2911 L 0 1 1 r
F
.69728 .26693 m .78235 .2792 L .72497 .29053 L 1 0 0 r
F
.64027 .27861 m .69728 .26693 L .72497 .29053 L F
.55294 .26633 m .64027 .27861 L .58489 .28995 L F
.49798 .27802 m .55294 .26633 L .58489 .28995 L F
.40838 .26572 m .49798 .27802 L .44459 .28938 L F
.35548 .27743 m .40838 .26572 L .44459 .28938 L F
.2636 .26511 m .35548 .27743 L .3041 .2888 L F
.79453 .92005 m .73675 .92223 L .7093 .9177 L p F P
0 0 0 r
s
.65188 .91994 m .7093 .9177 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.65188 .91994 m .59611 .92212 L .56437 .91758 L p 1 0 0 r
F P
0 0 0 r
s
.50901 .91983 m .56437 .91758 L .59611 .92212 L p 1 0 0 r
F P
0 0 0 r
s
.50901 .91983 m .45525 .92201 L .41921 .91747 L p 1 0 0 r
F P
0 0 0 r
s
.36594 .91971 m .41921 .91747 L .45525 .92201 L p 1 0 0 r
F P
0 0 0 r
s
.8735 .48672 m .93457 .47802 L .95551 .49559 L p 1 0 0 r
F P
0 0 0 r
s
.76845 .91539 m .8142 .49517 L .85402 .91782 L p .5 0 1 r
F P
0 0 0 r
s
.8735 .48672 m .8142 .49517 L .80319 .9079 L p 0 1 1 r
F P
0 0 0 r
s
.8142 .49517 m .76845 .91539 L .74071 .91044 L p .5 0 1 r
F P
0 0 0 r
s
.74071 .91044 m .80319 .9079 L .8142 .49517 L p .5 0 1 r
F P
0 0 0 r
s
.84141 .26754 m .90224 .25553 L .92421 .27979 L .5 1 0 r
F
.756 .25491 m .84141 .26754 L .78235 .2792 L 1 0 0 r
F
.69728 .26693 m .756 .25491 L .78235 .2792 L F
.60954 .25428 m .69728 .26693 L .64027 .27861 L F
.55294 .26633 m .60954 .25428 L .64027 .27861 L F
.46286 .25366 m .55294 .26633 L .49798 .27802 L F
.40838 .26572 m .46286 .25366 L .49798 .27802 L F
.31595 .25303 m .40838 .26572 L .35548 .27743 L F
.2636 .26511 m .31595 .25303 L .35548 .27743 L F
.85402 .91782 m .79453 .92005 L .76845 .91539 L p .5 0 1 r
F P
0 0 0 r
s
.7093 .9177 m .76845 .91539 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.7093 .9177 m .65188 .91994 L .62138 .91527 L p 1 0 0 r
F P
0 0 0 r
s
.56437 .91758 m .62138 .91527 L .65188 .91994 L p 1 0 0 r
F P
0 0 0 r
s
.56437 .91758 m .50901 .91983 L .47409 .91515 L p 1 0 0 r
F P
0 0 0 r
s
.41921 .91747 m .47409 .91515 L .50901 .91983 L p 1 0 0 r
F P
0 0 0 r
s
.41921 .91747 m .36594 .91971 L .32657 .91503 L p 1 0 0 r
F P
0 0 0 r
s
.93457 .47802 m .8735 .48672 L .86767 .90529 L p .5 1 0 r
F P
0 0 0 r
s
.80319 .9079 m .86767 .90529 L .8735 .48672 L p 0 1 1 r
F P
0 0 0 r
s
.8165 .24252 m .90224 .25553 L .84141 .26754 L .5 0 1 r
F
.756 .25491 m .8165 .24252 L .84141 .26754 L 1 0 0 r
F
.66787 .24187 m .756 .25491 L .69728 .26693 L F
.60954 .25428 m .66787 .24187 L .69728 .26693 L F
.519 .24123 m .60954 .25428 L .55294 .26633 L F
.46286 .25366 m .519 .24123 L .55294 .26633 L F
.3699 .24058 m .46286 .25366 L .40838 .26572 L F
.31595 .25303 m .3699 .24058 L .40838 .26572 L F
.22057 .23993 m .31595 .25303 L .2636 .26511 L F
.76845 .91539 m .7093 .9177 L .68014 .91289 L p F P
0 0 0 r
s
.62138 .91527 m .68014 .91289 L .7093 .9177 L p 1 0 0 r
F P
0 0 0 r
s
.62138 .91527 m .56437 .91758 L .53064 .91277 L p 1 0 0 r
F P
0 0 0 r
s
.47409 .91515 m .53064 .91277 L .56437 .91758 L p 1 0 0 r
F P
0 0 0 r
s
.47409 .91515 m .41921 .91747 L .38091 .91264 L p 1 0 0 r
F P
0 0 0 r
s
.32657 .91503 m .38091 .91264 L .41921 .91747 L p 1 0 0 r
F P
0 0 0 r
s
.86767 .90529 m .91232 .45934 L .93457 .47802 L p .5 1 0 r
F P
0 0 0 r
s
.8165 .24252 m .87887 .22975 L .90224 .25553 L .5 0 1 r
F
.72799 .22908 m .8165 .24252 L .756 .25491 L 1 0 0 r
F
.66787 .24187 m .72799 .22908 L .756 .25491 L F
.57687 .22841 m .66787 .24187 L .60954 .25428 L F
.519 .24123 m .57687 .22841 L .60954 .25428 L F
.42552 .22775 m .519 .24123 L .46286 .25366 L F
.3699 .24058 m .42552 .22775 L .46286 .25366 L F
.27392 .22708 m .3699 .24058 L .31595 .25303 L .5 0 1 r
F
.22057 .23993 m .27392 .22708 L .31595 .25303 L 1 0 0 r
F
.68014 .91289 m .74071 .91044 L .76845 .91539 L p F P
0 0 0 r
s
.68014 .91289 m .62138 .91527 L .58895 .91031 L p 1 0 0 r
F P
0 0 0 r
s
.53064 .91277 m .58895 .91031 L .62138 .91527 L p 1 0 0 r
F P
0 0 0 r
s
.53064 .91277 m .47409 .91515 L .43694 .91018 L p 1 0 0 r
F P
0 0 0 r
s
.38091 .91264 m .43694 .91018 L .47409 .91515 L p 1 0 0 r
F P
0 0 0 r
s
.38091 .91264 m .32657 .91503 L .28469 .91005 L p 1 0 0 r
F P
0 0 0 r
s
.79 .21589 m .87887 .22975 L .8165 .24252 L 1 0 0 r
F
.72799 .22908 m .79 .21589 L .8165 .24252 L F
.63656 .2152 m .72799 .22908 L .66787 .24187 L F
.57687 .22841 m .63656 .2152 L .66787 .24187 L F
.48288 .21451 m .57687 .22841 L .519 .24123 L F
.42552 .22775 m .48288 .21451 L .519 .24123 L F
.32895 .21382 m .42552 .22775 L .3699 .24058 L 0 1 1 r
F
.27392 .22708 m .32895 .21382 L .3699 .24058 L .5 0 1 r
F
.17477 .21313 m .27392 .22708 L .22057 .23993 L 1 0 0 r
F
.74071 .91044 m .68014 .91289 L .64909 .90777 L p F P
0 0 0 r
s
.58895 .91031 m .64909 .90777 L .68014 .91289 L p 1 0 0 r
F P
0 0 0 r
s
.58895 .91031 m .53064 .91277 L .49473 .90764 L p 1 0 0 r
F P
0 0 0 r
s
.43694 .91018 m .49473 .90764 L .53064 .91277 L p 1 0 0 r
F P
0 0 0 r
s
.43694 .91018 m .38091 .91264 L .34013 .90751 L p 1 0 0 r
F P
0 0 0 r
s
.28469 .91005 m .34013 .90751 L .38091 .91264 L p 1 0 0 r
F P
0 0 0 r
s
.91232 .45934 m .86767 .90529 L .84144 .89966 L p .5 0 1 r
F P
0 0 0 r
s
.84144 .89966 m .90987 .89677 L .91232 .45934 L p .5 0 1 r
F P
0 0 0 r
s
.79 .21589 m .85398 .20228 L .87887 .22975 L 1 0 0 r
F
.69815 .20157 m .79 .21589 L .72799 .22908 L .5 0 1 r
F
.63656 .2152 m .69815 .20157 L .72799 .22908 L 1 0 0 r
F
.54207 .20086 m .63656 .2152 L .57687 .22841 L .5 0 1 r
F
.48288 .21451 m .54207 .20086 L .57687 .22841 L 1 0 0 r
F
.38573 .20014 m .48288 .21451 L .42552 .22775 L 0 1 1 r
F
.32895 .21382 m .38573 .20014 L .42552 .22775 L F
.22914 .19943 m .32895 .21382 L .27392 .22708 L F
.17477 .21313 m .22914 .19943 L .27392 .22708 L 1 0 0 r
F
.80319 .9079 m .74071 .91044 L .71116 .90515 L p F P
0 0 0 r
s
.64909 .90777 m .71116 .90515 L .74071 .91044 L p 1 0 0 r
F P
0 0 0 r
s
.64909 .90777 m .58895 .91031 L .55438 .90502 L p 1 0 0 r
F P
0 0 0 r
s
.49473 .90764 m .55438 .90502 L .58895 .91031 L p 1 0 0 r
F P
0 0 0 r
s
.49473 .90764 m .43694 .91018 L .39735 .90488 L p 1 0 0 r
F P
0 0 0 r
s
.34013 .90751 m .39735 .90488 L .43694 .91018 L p 1 0 0 r
F P
0 0 0 r
s
.34013 .90751 m .28469 .91005 L .24006 .90474 L p 1 0 0 r
F P
0 0 0 r
s
.76173 .18749 m .85398 .20228 L .79 .21589 L 0 1 1 r
F
.69815 .20157 m .76173 .18749 L .79 .21589 L .5 0 1 r
F
.60318 .18676 m .69815 .20157 L .63656 .2152 L 0 1 1 r
F
.54207 .20086 m .60318 .18676 L .63656 .2152 L .5 0 1 r
F
.44436 .18602 m .54207 .20086 L .48288 .21451 L 0 1 1 r
F
.38573 .20014 m .44436 .18602 L .48288 .21451 L F
.28527 .18528 m .38573 .20014 L .32895 .21382 L 1 0 0 r
F
.22914 .19943 m .28527 .18528 L .32895 .21382 L 0 1 1 r
F
.86767 .90529 m .80319 .9079 L .77524 .90245 L p 1 0 0 r
F P
0 0 0 r
s
.71116 .90515 m .77524 .90245 L .80319 .9079 L p 1 0 0 r
F P
0 0 0 r
s
.71116 .90515 m .64909 .90777 L .61597 .90231 L p 1 0 0 r
F P
0 0 0 r
s
.55438 .90502 m .61597 .90231 L .64909 .90777 L p 1 0 0 r
F P
0 0 0 r
s
.55438 .90502 m .49473 .90764 L .45643 .90217 L p 1 0 0 r
F P
0 0 0 r
s
.39735 .90488 m .45643 .90217 L .49473 .90764 L p 1 0 0 r
F P
0 0 0 r
s
.39735 .90488 m .34013 .90751 L .29663 .90203 L p 1 0 0 r
F P
0 0 0 r
s
.24006 .90474 m .29663 .90203 L .34013 .90751 L p 1 0 0 r
F P
0 0 0 r
s
.76173 .18749 m .8274 .17295 L .85398 .20228 L 0 1 1 r
F
.66629 .17219 m .76173 .18749 L .69815 .20157 L .5 1 0 r
F
.60318 .18676 m .66629 .17219 L .69815 .20157 L 0 1 1 r
F
.50491 .17143 m .60318 .18676 L .54207 .20086 L .5 1 0 r
F
.44436 .18602 m .50491 .17143 L .54207 .20086 L 0 1 1 r
F
.34325 .17067 m .44436 .18602 L .38573 .20014 L 1 0 0 r
F
.28527 .18528 m .34325 .17067 L .38573 .20014 L F
.77524 .90245 m .84144 .89966 L .86767 .90529 L p F P
0 0 0 r
s
.77524 .90245 m .71116 .90515 L .67959 .89951 L p 1 0 0 r
F P
0 0 0 r
s
.61597 .90231 m .67959 .89951 L .71116 .90515 L p 1 0 0 r
F P
0 0 0 r
s
.61597 .90231 m .55438 .90502 L .51747 .89937 L p 1 0 0 r
F P
0 0 0 r
s
.45643 .90217 m .51747 .89937 L .55438 .90502 L p 1 0 0 r
F P
0 0 0 r
s
.45643 .90217 m .39735 .90488 L .35507 .89922 L p 1 0 0 r
F P
0 0 0 r
s
.29663 .90203 m .35507 .89922 L .39735 .90488 L p 1 0 0 r
F P
0 0 0 r
s
.29663 .90203 m .24006 .90474 L .19239 .89907 L p 1 0 0 r
F P
0 0 0 r
s
.41548 .89632 m .35507 .89922 L .32294 .42714 L p 0 1 1 r
F P
0 0 0 r
s
.32294 .42714 m .3813 .41656 L .41548 .89632 L p 0 1 1 r
F P
0 0 0 r
s
.25011 .89617 m .32294 .42714 L .35507 .89922 L p .5 0 1 r
F P
0 0 0 r
s
.3813 .41656 m .32294 .42714 L .27775 .40505 L p 1 0 0 r
F P
0 0 0 r
s
.32294 .42714 m .25011 .89617 L .20026 .88989 L p 0 1 1 r
F P
0 0 0 r
s
.20026 .88989 m .27775 .40505 L .32294 .42714 L p 0 1 1 r
F P
0 0 0 r
s
.73152 .15714 m .8274 .17295 L .76173 .18749 L 1 0 0 r
F
.66629 .17219 m .73152 .15714 L .76173 .18749 L .5 1 0 r
F
.56749 .15636 m .66629 .17219 L .60318 .18676 L 1 0 0 r
F
.50491 .17143 m .56749 .15636 L .60318 .18676 L .5 1 0 r
F
.40318 .15557 m .50491 .17143 L .44436 .18602 L 1 0 0 r
F
.34325 .17067 m .40318 .15557 L .44436 .18602 L F
.84144 .89966 m .77524 .90245 L .74536 .89662 L p F P
0 0 0 r
s
.67959 .89951 m .74536 .89662 L .77524 .90245 L p 1 0 0 r
F P
0 0 0 r
s
.67959 .89951 m .61597 .90231 L .58056 .89647 L p 1 0 0 r
F P
0 0 0 r
s
.51747 .89937 m .58056 .89647 L .61597 .90231 L p 1 0 0 r
F P
0 0 0 r
s
.51747 .89937 m .45643 .90217 L .41548 .89632 L p 1 0 0 r
F P
0 0 0 r
s
.35507 .89922 m .41548 .89632 L .45643 .90217 L p 1 0 0 r
F P
0 0 0 r
s
.35507 .89922 m .29663 .90203 L .25011 .89617 L p .5 0 1 r
F P
0 0 0 r
s
.19239 .89907 m .25011 .89617 L .29663 .90203 L p 1 0 0 r
F P
0 0 0 r
s
.47796 .89332 m .41548 .89632 L .3813 .41656 L p 0 1 1 r
F P
0 0 0 r
s
.3813 .41656 m .4416 .40562 L .47796 .89332 L p 0 1 1 r
F P
0 0 0 r
s
.4416 .40562 m .3813 .41656 L .33737 .39373 L p 1 0 0 r
F P
0 0 0 r
s
.27775 .40505 m .33737 .39373 L .3813 .41656 L p 1 0 0 r
F P
0 0 0 r
s
.73152 .15714 m .79898 .14158 L .8274 .17295 L 1 0 0 r
F
.63221 .14077 m .73152 .15714 L .66629 .17219 L F
.56749 .15636 m .63221 .14077 L .66629 .17219 L F
.46515 .13995 m .56749 .15636 L .50491 .17143 L F
.40318 .15557 m .46515 .13995 L .50491 .17143 L F
.90987 .89677 m .84144 .89966 L .81337 .89363 L p F P
0 0 0 r
s
.74536 .89662 m .81337 .89363 L .84144 .89966 L p 1 0 0 r
F P
0 0 0 r
s
.74536 .89662 m .67959 .89951 L .64581 .89348 L p 1 0 0 r
F P
0 0 0 r
s
.58056 .89647 m .64581 .89348 L .67959 .89951 L p 1 0 0 r
F P
0 0 0 r
s
.58056 .89647 m .51747 .89937 L .47796 .89332 L p 1 0 0 r
F P
0 0 0 r
s
.41548 .89632 m .47796 .89332 L .51747 .89937 L p 1 0 0 r
F P
0 0 0 r
s
.25011 .89617 m .19239 .89907 L .14137 .89301 L p 1 0 0 r
F P
0 0 0 r
s
.88375 .89054 m .81337 .89363 L .76848 .40676 L p 0 1 1 r
F P
0 0 0 r
s
.76848 .40676 m .83626 .3955 L .88375 .89054 L p 0 1 1 r
F P
0 0 0 r
s
.71334 .89038 m .76848 .40676 L .81337 .89363 L p .5 0 1 r
F P
0 0 0 r
s
.83626 .3955 m .76848 .40676 L .73757 .38324 L p 1 0 0 r
F P
0 0 0 r
s
.76848 .40676 m .71334 .89038 L .67025 .39491 L p .5 1 0 r
F P
0 0 0 r
s
.67025 .39491 m .73757 .38324 L .76848 .40676 L p .5 1 0 r
F P
0 0 0 r
s
.71334 .89038 m .64581 .89348 L .60518 .40619 L p 0 1 1 r
F P
0 0 0 r
s
.60518 .40619 m .67025 .39491 L .71334 .89038 L p 0 1 1 r
F P
0 0 0 r
s
.54262 .89021 m .60518 .40619 L .64581 .89348 L p .5 0 1 r
F P
0 0 0 r
s
.67025 .39491 m .60518 .40619 L .56846 .38263 L p 1 0 0 r
F P
0 0 0 r
s
.60518 .40619 m .54262 .89021 L .50396 .39432 L p .5 1 0 r
F P
0 0 0 r
s
.50396 .39432 m .56846 .38263 L .60518 .40619 L p .5 1 0 r
F P
0 0 0 r
s
.54262 .89021 m .47796 .89332 L .4416 .40562 L p 0 1 1 r
F P
0 0 0 r
s
.4416 .40562 m .50396 .39432 L .54262 .89021 L p 0 1 1 r
F P
0 0 0 r
s
.50396 .39432 m .4416 .40562 L .39905 .38202 L p 1 0 0 r
F P
0 0 0 r
s
.33737 .39373 m .39905 .38202 L .4416 .40562 L p 1 0 0 r
F P
0 0 0 r
s
.69917 .12464 m .79898 .14158 L .73152 .15714 L 1 0 0 r
F
.63221 .14077 m .69917 .12464 L .73152 .15714 L F
.52927 .12379 m .63221 .14077 L .56749 .15636 L F
.46515 .13995 m .52927 .12379 L .56749 .15636 L F
.81337 .89363 m .88375 .89054 L .90987 .89677 L p F P
0 0 0 r
s
.81337 .89363 m .74536 .89662 L .71334 .89038 L p .5 0 1 r
F P
0 0 0 r
s
.64581 .89348 m .71334 .89038 L .74536 .89662 L p 1 0 0 r
F P
0 0 0 r
s
.64581 .89348 m .58056 .89647 L .54262 .89021 L p .5 0 1 r
F P
0 0 0 r
s
.47796 .89332 m .54262 .89021 L .58056 .89647 L p 1 0 0 r
F P
0 0 0 r
s
.14137 .89301 m .20026 .88989 L .25011 .89617 L p 1 0 0 r
F P
0 0 0 r
s
.73757 .38324 m .80726 .37115 L .83626 .3955 L p 1 0 0 r
F P
0 0 0 r
s
.73757 .38324 m .67025 .39491 L .63524 .37052 L p 1 0 0 r
F P
0 0 0 r
s
.56846 .38263 m .63524 .37052 L .67025 .39491 L p 1 0 0 r
F P
0 0 0 r
s
.56846 .38263 m .50396 .39432 L .46291 .36989 L p 1 0 0 r
F P
0 0 0 r
s
.39905 .38202 m .46291 .36989 L .50396 .39432 L p 1 0 0 r
F P
0 0 0 r
s
.69917 .12464 m .76849 .10794 L .79898 .14158 L 1 0 0 r
F
.59566 .10706 m .69917 .12464 L .63221 .14077 L F
.52927 .12379 m .59566 .10706 L .63221 .14077 L F
.80726 .37115 m .73757 .38324 L .7044 .35798 L p F P
0 0 0 r
s
.63524 .37052 m .7044 .35798 L .73757 .38324 L p 1 0 0 r
F P
0 0 0 r
s
.63524 .37052 m .56846 .38263 L .52905 .35733 L p 1 0 0 r
F P
0 0 0 r
s
.46291 .36989 m .52905 .35733 L .56846 .38263 L p 1 0 0 r
F P
0 0 0 r
s
.66443 .08973 m .76849 .10794 L .69917 .12464 L 1 0 0 r
F
.59566 .10706 m .66443 .08973 L .69917 .12464 L F
.7044 .35798 m .77608 .34499 L .80726 .37115 L p F P
0 0 0 r
s
.7044 .35798 m .63524 .37052 L .5976 .34431 L p 1 0 0 r
F P
0 0 0 r
s
.52905 .35733 m .5976 .34431 L .63524 .37052 L p 1 0 0 r
F P
0 0 0 r
s
.66443 .08973 m .73572 .07177 L .76849 .10794 L 1 0 0 r
F
.77608 .34499 m .7044 .35798 L .6687 .33081 L p F P
0 0 0 r
s
.5976 .34431 m .6687 .33081 L .7044 .35798 L p 1 0 0 r
F P
0 0 0 r
s
.6687 .33081 m .74249 .31679 L .77608 .34499 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00002Qolc<c07ooooo001X
olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?l000000oo<c<`2o`000005olc<c?l0
003oc<c<olc<c?l000000oo<c<`00ol0003oc<c<olc<c02Nolc<c07ooooo001Xolc<c004o`000?o<
c<co0000olc<c0;o00000oo<c<`3o`000004olc<c?l0003oc<c<o`0000;oc<c<00Go0000olc<c?o<
c<coc<c<o`000019olc<c0?o0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<05;oc<c<0Oooool006Soc<c<00?o0000olc<c?o<c<`0
2_o<c<`00ol0003oc<c<o`00000Lolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Lolc<c0Co000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<
olc<c01Aolc<c07ooooo002Eolc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`06?o<
c<`4o`0000Goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c01@olc<c07ooooo002E
olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0000ooc<c<00?o0000
olc<c?o<c<`0Coo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c01>olc<c07ooooo002Folc<c003o`000?o<c<coc<c<00Coc<c<1Ol0000@olc<c0Co
00006Oo<c<`00ol0003oc<c<olc<c01=olc<c07ooooo002Golc<c003o`000?o<c<coc<c<00?oc<c<
00?o0000olc<c?o<c<`03oo<c<`3o`0000;oc<c<00?o0000olc<c?o<c<`06Oo<c<`00ol0003oc<c<
olc<c00:olc<c003o`000?o<c<coc<c<03ooc<c<0Oooool009Soc<c<00?o0000olc<c?o<c<`00oo<
c<`00ol0003oc<c<olc<c00:olc<c0Co00008_o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<
c<coc<c<03ooc<c<0Oooool009?oc<c<1_l00005olc<c0Go00001?o<c<`4o`000003olc<c?l0003o
c<c<02?oc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003oc<c<olc<c00oolc<c07ooooo002Tolc<
c0?o00001Oo<c<`00ol0003oc<c<olc<c00Solc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<
c?o<c<`0?oo<c<`1ooooo`00Loo<c<`4o`0002Woc<c<1Ol0000^olc<c003o`000?o<c<coc<c<00Oo
c<c<00?o0000olc<c?o<c<`0?oo<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<c003o`00
0?o<c<coc<c<02;oc<c<1?l00004olc<c003o`000?o<c<coc<c<02coc<c<0ol00007olc<c003o`00
0?o<c<coc<c<03ooc<c<0Oooool007Ooc<c<00?o0000olc<c?o<c<`07oo<c<`3o`0003Woc<c<00?o
0000olc<c?o<c<`00oo<c<`3o`00047oc<c<0Oooool007Ooc<c<00?o0000olc<c?o<c<`06oo<c<`4
o`0000;oc<c<00?o0000olc<c?o<c<`0>?o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<co
c<c<03ooc<c<0Oooool007;oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Golc<
c0Co00001_o<c<`00ol0003oc<c<olc<c00iolc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<
c?o<c<`0?oo<c<`1ooooo`00L_o<c<`5o`0001Ooc<c<0ol00002olc<c003o`000?o<c<coc<c<047o
c<c<00?o0000olc<c?o<c<`01oo<c<`6o`0003Soc<c<0Oooool007;oc<c<00?o0000olc<c?o<c<`0
5Oo<c<`4o`0004[oc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c00kolc<c07ooooo
001colc<c003o`000?o<c<coc<c<013oc<c<1?l000000oo<c<co0000olc<c011olc<c0;oo`002Oo<
c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<03[oc<c<0Oooool007?oc<c<1Ol0000;
olc<c0?o0000AOo<c<`6ool000Woc<c<00?o0000olc<c?o<c<`01_o<c<`2o`0003[oc<c<0Oooool0
07ooc<c<1?l000000oo<c<co0000olc<c011olc<c0_oo`002Oo<c<`00ol0003oc<c<olc<c007olc<
c003o`000?o<c<coc<c<03Ooc<c<0Oooool004Woc<c<1_l00002olc<c003o`000?o<c<coc<c<00Co
00008oo<c<`4o`0004Goc<c<3ooo0008olc<c0;o00002Oo<c<`00ol0003oc<c<olc<c00folc<c07o
oooo0019olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c00Molc<c0?o000000?oc<c<o`000?o<c<`0@oo<c<`Cool000Woc<c<00Go0000olc<c?o<c<co
c<c<o`000004olc<c003o`000?o<c<coc<c<03Koc<c<0Oooool004[oc<c<00?o0000olc<c?o<c<`0
2oo<c<`00ol0003oc<c<olc<c00Iolc<c0Co00001?o<c<`00ol0003oc<c<olc<c00nolc<c1Soo`00
2Oo<c<`01?l0003oc<c<olc<c?l00004olc<c003o`000?o<c<coc<c<03Koc<c<0Oooool004_oc<c<
0_l0000;olc<c003o`000?o<c<coc<c<01Koc<c<0ol000000oo<c<co0000olc<c012olc<c1goo`00
2?o<c<`01?l0003oc<c<olc<c?o<c<`4o`0003Woc<c<0Oooool004goc<c<00?o0000olc<c?o<c<`0
0oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01;oc<c<1?l00004olc<c003o`00
0?o<c<coc<c<03goc<c<8_oo0008olc<c003o`000?o<c<coc<c<00Soc<c<1?l0000aolc<c07ooooo
001>olc<c003o`000?o<c<coc<c<00;oc<c<1Ol0000Aolc<c0Go0000@oo<c<`Wool000Soc<c<00?o
0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<02koc<c<0Ooo
ool004Woc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<013oc<c<0ol00004olc<c003o`000?o<c<coc<c<03goc<c<:ooo0009olc<c003o`000?o<c<co
c<c<00Goc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00^olc<c07ooooo0019olc<
c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00;olc<
c0Go0000@_o<c<``ool000Woc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003oc<c<olc<c00^olc<
c07ooooo001:olc<c0Co00001_o<c<`5o`0000Goc<c<1?l00004olc<c003o`000?o<c<coc<c<03co
c<c<=Ooo0008olc<c0;o00001oo<c<`3o`00037oc<c<0Oooool002ooc<c<1?l0000Xolc<c0?o0000
00?oc<c<o`000?o<c<`0@?o<c<`jool000Woc<c<00?o0000olc<c?o<c<`01oo<c<`00ol0003oc<c<
olc<c00^olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`08Oo<
c<`4o`0004;oc<c<?ooo0009olc<c005o`000?o<c<coc<c<olc<c?l000001?o<c<`00ol0003oc<c<
olc<c00^olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`07Oo<
c<`4o`000003olc<c?l0003oc<c<03koc<c<AOoo0008olc<c005o`000?o<c<coc<c<olc<c?l00000
1?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<013oc<c<1?l000001?o<c<co0000
olc<c?o<c<`4o`0000;oc<c<00Oo0000olc<c?o<c<coc<c<o`000?o<c<co000000Coc<c<0Oooool0
02koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Jolc<c0?o0000@?o<c<a;ool0
00Soc<c<00Co0000olc<c?o<c<coc<c<1?l00005olc<c003o`000?o<c<coc<c<00ooc<c<00?o0000
olc<c?o<c<`00_o<c<`2o`000003olc<c?l0003oc<c<00?oc<c<00?o0000olc<c?l000000oo<c<`0
0ol0003oc<c<olc<c004olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<
c?o<c<`05_o<c<`4o`000003olc<c?l0003oc<c<03_oc<c<DOoo0008olc<c003o`000?o<c<coc<c<
00Goc<c<1_l0000?olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?l000001_o<c<`01Ol0
003oc<c<olc<c?o<c<co000000Koc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0
003oc<c<olc<c00Bolc<c0Co00001Oo<c<`00ol0003oc<c<olc<c00folc<c5Koo`002?o<c<`00ol0
003oc<c<olc<c004olc<c005o`000?o<c<coc<c<olc<c?l000004?o<c<`00ol0003oc<c<olc<c004
olc<c003o`000?o<c<co000000Go000000?oc<c<o`000?o<c<`00_o<c<`00ol0003oc<c<olc<c004
olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03oo<c<`3o`00
00;oc<c<00?o0000olc<c?o<c<`0>_o<c<aJool000Soc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0
003oc<c<olc<c?l0000@olc<c004o`000?o<c<coc<c<olc<c0Co000000?oc<c<o`000?o<c<`00oo<
c<`00ol0003oc<c<o`000003olc<c003o`000?o<c<coc<c<00Coc<c<0Oooool002koc<c<00?o0000
olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00;olc<c0Co0000?_o<c<aOool000Koc<c<0ol00006
olc<c003o`000?o<c<co0000013oc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c002
olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;oo<c<`4
o`0000[oc<c<1?l00003olc<c003o`000?o<c<coc<c<03Soc<c<9ooo0004ogoo03Woo`002?o<c<`0
0ol0003oc<c<olc<c003olc<c003o`000?o<c<co0000013oc<c<00?o0000olc<c?o<c<`01?o<c<`0
0ol0003oc<c<olc<c004o`0000;oc<c<00Co0000olc<c?l0003o00001oo<c<`1ooooo`00>_o<c<`4
o`0003koc<c<9ooo0008ogoo02;oo`000omoo`0Dool000Ooc<c<00?o0000olc<c?o<c<`01?o<c<`2
o`0000;oc<c<1?l0000;olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`1
ooooo`00=_o<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`0>?o<c<`Wool000goOol07?oo0009ogoo
01Coo`001oo<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<co000000Coc<c<00?o0000olc<
c?o<c<`02Oo<c<`4o`0001Goc<c<0Oooool003;oc<c<1?l000000oo<c<co0000olc<c00lolc<c2Oo
o`004Omoo`0Fool000ooOol05?oo0007olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<
c<`08_o<c<`1ooooo`00;oo<c<`3o`0003ooc<c<9ooo0004o`3ooa;oOol04?oo0003o`3ooa;oOol0
4Ooo0002o`3oo`Soc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003oc<c<olc<c00Rolc<c07ooooo
000]olc<c0;o000000?oc<c<o`000?o<c<`0>_o<c<`Wool000[o0?oo4_moo`0;ool000So0?oo4_mo
o`0<ool000Oo0?oo2?o<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00;oc<c<00?o
0000olc<c?o<c<`08_o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?l0000folc<c2Ooo`004?l0
oolBogoo00Ooo`003?l0oolBogoo00Ooo`003?l0ool6olc<c0?o00001?o<c<`5o`0002Goc<c<0Ooo
ool002goc<c<00Co0000olc<c?o<c<coIVIV<_o<c<`4o`3oob;oo`005_l0oolBogoo00;oo`004Ol0
oolBogoo00;oo`004Ol0ool8olc<c005o`000?o<c<coc<c<olc<c?l00000:Oo<c<`1ooooo`00;Oo<
c<`2o`000003olc<c?mVIVKoc<c<02koc<c<2?l0oolNool001[o0?oo3omoo`04ogl0oa;o0?oo3omo
o`04ogl0oa;o0?oo2?o<c<`01Ol0003oc<c<olc<c?o<c<co000000Goc<c<1?l0000Oolc<c07ooooo
000]olc<c004o`000?o<c<coc<c<ofIVIRcoc<c<3Ol0oolHool001oo0?oo2Omoo`0:ogl0oa;o0?oo
2Omoo`0:ogl0oa;o0?oo1oo<c<`01?l0003oc<c<olc<c?o<c<`6o`0000Coc<c<00?o0000olc<c?o<
c<`07?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHYolc<c1;o0?oo4ooo000So`3oo`?o
Ool04?mo0?lBo`3oo`?oOol04?mo0?lBo`3oo`Ooc<c<00?o0000olc<c?o<c<`01Oo<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<01coc<c<0Oooool002goc<c<00Co0000olc<c?o<c<co
IVIV9Oo<c<`4ool001?o0?oo3_oo000Uo`3oo`Coo`004omo0?l>o`3oo`?oo`004omo0?l?o`3oo`;o
o`002?o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<
c<`07?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHPolc<c0_oo`004ol0ool7ool002Go
0?oo2_oo000Cogl0o`So0?oo2Ooo000Cogl0o`Wo0?oo2?oo0008olc<c0;o00001?o<c<`2o`0000?o
c<c<00?o0000olc<c?o<c<`07?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c17o
o`004_l0ool2ool002Co0?oo4Ooo000Bogl0o`;o0?oo3ooo000Cogl0o`?o0?oo3_oo0006olc<c003
o`000?o<c<co000000Coc<c<00?o0000olc<c?l000000_l0000Oolc<c07ooooo000/olc<c005o`00
0?o<c<coc<c<olc<c?mVIVH07?o<c<`Bool000oo0?oo1?mo0?lPo`3ooaKoo`003omo0?lDool0013o
O`3o5?oo0008olc<c005o`000?o<c<coc<c<olc<c?l000008oo<c<`1ooooo`00;?o<c<`01?l0003o
c<c<olc<c?mVIVHOolc<c1;oo`002?l0ool;ogl0oaWo0?oo7Ooo0008ogl0oa[oo`002omo0?lIool0
00Soc<c<00Go0000olc<c?o<c<coc<c<o`000003olc<c003o`000?o<c<co000001coc<c<0Oooool0
02coc<c<00Co0000olc<c?o<c<coIVIV8Oo<c<`Bool000;o0?oo4?mo0?lDo`3oob;oo`000_mo0?lP
ool000OoO`3o7Ooo0008olc<c004o`000?o<c<coc<c<olc<c0?o00000_o<c<`00ol0003oc<c<olc<
c00Jolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIR;oc<c<4ooo000Bogl0o`ko0?ooBOoo
0002ogl0ob;oo`001oo<c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<coc<c<01Woc<c<0Ooo
ool002coc<c<00Co0000olc<c?o<c<coIVIV9?o<c<`Cool001;oO`3o1ol0oom`ool000?oO`3o1oo<
c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<01Woc<c<0Oooool002coc<c<0_l00000
0oo<c<coIVIVolc<c00Folc<c003ofIVI_o<c<coc<c<00coc<c<4_oo000Bogl0o`;o0?ooKooo0009
ogl0o`Koc<c<0_l00008olc<c003o`000?o<c<coc<c<01Soc<c<0Oooool002coc<c<00Co0000olc<
c?o<c<coIVIV5oo<c<`00omVIVKoc<c<olc<c00>olc<c1;oo`003_mo0?m^ool000ooO`3o1oo<c<`0
0ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00Co00005?o<c<`1ooooo`00;?o<c<`01?l0
003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<013oc<c<4_oo0007ogl0og7oo`004_mo0?l7
olc<c003o`000?o<c<coc<c<00Goc<c<0_l00004olc<c003o`000?o<c<coc<c<017oc<c<0Oooool0
02coc<c<00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKoc<c<olc<c00Aolc<c1;oo`000_mo0?mf
ool001;oO`3o1oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000
olc<c?o<c<`04Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<co
c<c<01?oc<c<ROoo000Bogl0o`Ooc<c<00?o0000olc<c?l000001Ol00004olc<c003o`000?o<c<co
c<c<017oc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKoc<c<olc<c00E
olc<c8Soo`003omo0?l2ogoo00Ooc<c<0_l00006olc<c0Co00005?o<c<`1ooooo`00;?o<c<`01?l0
003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<01Koc<c<R?oo0009ogl0o`SoOol01_o<c<`2
o`0000Goc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Aolc<c07ooooo000/olc<
c004o`000?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`06?o<c<b7ool000?oO`3o3_moo`07
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`00013oc<c<0Oooool0
02coc<c<00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKoc<c<olc<c00Jolc<c8;oo`001Ol0ool@
ogoo00Ooc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c005o`000?o<c<coc<c<olc<c?l00000
3oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<01_oc<c<
N_oo000=o`3ooa3oOol01oo<c<`01?l0003oc<c<olc<c?o<c<`4o`0000Goc<c<00?o0000olc<c?o<
c<`03?o<c<`1ooooo`00;?o<c<`2o`000003olc<c?mVIVKoc<c<01Koc<c<00?oIVIVolc<c?o<c<`0
7Oo<c<abool000?oO`3o4Ol0ool@ogoo00Ooc<c<00?o0000olc<c?o<c<`01Oo<c<`3o`000003olc<
c?l0003oc<c<00goc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKoc<c<
olc<c00Polc<c6_oo`002Omo0?lAo`3oo`coOol01?oo0006olc<c0;o00001Oo<c<`01?l0003oc<c<
olc<c?o<c<`2o`0000koc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKo
c<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00coc<c<I_oo000>ogl0oa7o0?oo1?moo`0<ool000Oo
c<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00co
c<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKoc<c<olc<c00Bolc<c003
ofIVI_o<c<coc<c<00koc<c<I?oo000?ogl0o`ko0?oo0_moo`0Aool000?oc<c<00?oIVIVolc<c?o<
c<`01Oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00coc<c<0Oooool002_oc<c<
00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<013o
c<c<Hooo000?ogl0o`So0?oo2?moo`0Aool000;oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<00coc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<co
IVIV5oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<01;oc<c<H_oo000?ogl0o`;o
0?oo3_moo`0Aool00003olc<c?mVIVKoc<c<00Ooc<c<1?l0000?olc<c07ooooo000[olc<c004o`00
0?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Colc<c6;o
o`004?mo0?l?ogoo00koo`000oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`00
0?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Eolc<c67o
o`004?mo0?l?ogoo00Soo`002?o<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`00
0?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Golc<c5_o
o`001?l00002ool000ooO`3o3omoo`02ool000goc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00
:oo<c<`01?l0003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<
c<`06Oo<c<aDool000Go00001?oo00000ol0003oo`00ool0000?ogl0o`_oOol04_o<c<`00omVIVKo
c<c<olc<c00Iolc<c07ooooo000[olc<c0;oIVIV00?o0000ofIVI_o<c<`05_o<c<`00omVIVKoc<c<
olc<c00Bolc<c003ofIVI_o<c<coc<c<01_oc<c<C_oo0004o`0000[oo`0000?o0000ool00?oo0000
3omo0?l3ogoo01Woc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`008?o<c<`4o`0000Ooc<c<00Co
0000olc<c?mVIVKoIVIV5oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<01coc<c<
B?oo0005o`0000ooo`0000?o0000ool00?oo00002omo0?lOolc<c003ofIVI_o<c<coc<c<01Woc<c<
0Oooool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<
c<coc<c<00?oIVIV5Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00ooc<c<00?o
IVIVolc<c?o<c<`03?o<c<a1ool000Go00005Ooo00000ol0003oo`00ool00003ogl0o`Coc<c<00?o
IVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000Oolc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH2olc<c0;oIVIV4oo<
c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`03_o<
c<`jool000Go00001Ooo00000ol0003oo`00ool0000Cool00003o`000?o<c<coc<c<00Koc<c<00?o
IVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH4olc<c0?oIVIV4?o<
c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`03oo<
c<`dool000Go00002ooo0002o`0001Coo`0000?o0000olc<c?o<c<`01Oo<c<`00omVIVKoc<c<olc<
c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`0
0ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<0_mVIVH>olc<c003ofIVI_o<
c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Aolc<c2coo`001_l0
000Bool00003o`000?oo003oo`0001;oo`000_l00005olc<c003ofIVI_o<c<coc<c<023oc<c<00?o
IVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<co
c<c<00?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP09olc<c0;oIVIV3?o<c<`00omVIVKoc<c<olc<
c00Aolc<c003ofIVI_o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`04oo<c<`Tool000Ko00001Ooo
00000ol0003oo`00ool0000Aool000;o00002Ooo0006o`0000Goo`0000?o0000olc<c?o<c<`00_o<
c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool001ooc<c<00?o0000
olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<ofIVIPcoc<c<0_mV
IVH:olc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<
c00Dolc<c1koo`001Ol0000<ool00003o`000?oo003oo`0001;oo`0000Co0000ool00?oo003oo`00
1Ol0000<ool00005o`000?o<c<coc<c<olc<c?mVIVH08_o<c<`00omVIVKoc<c<olc<c00Holc<c07o
oooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<
olc<c?mVIVH>olc<c0;oIVIV2?o<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<013o
c<c<00?oIVIVolc<c?o<c<`05_o<c<`Gool000Go00004_oo0002o`0001?oo`000ol0000Bool00004
o`000?o<c<coc<c<ofIVIR;oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`008?o<c<`4o`0000Ko
c<c<00Co0000olc<c?o<c<coIVIV4?o<c<`2ofIVIPKoc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00omV
IVKoc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<01Soc<c<4?oo0005o`0000Coo`000_l0000Cool0
0003o`000?oo003oo`0000Ooo`001_l00005ool00003o`000?oo003oo`00017oo`0000?o0000olc<
c?mVIVH08_o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c0;o000000?oc<c<ofIVI_o<
c<`04Oo<c<`2ofIVIPCoc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00@olc<c003
ofIVI_o<c<coc<c<01Woc<c<2_oo0005o`0000_oo`0000?o0000ool00?oo00004Ooo00001?l0003o
o`00ool00?oo0005o`0000coo`0000?o0000ool00?oo00004Ooo00000ol0003oIVIVolc<c00Qolc<
c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`2ofIV
IP03olc<c?mVIVKoc<c<01?oc<c<00?oIVIVolc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00>olc<
c003ofIVI_o<c<coc<c<00[oc<c<0_oo0006o`00017oo`000_l0000Bool000?o00004_oo0002o`00
01;oo`000_l0000Qolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<
c<coIVIV5_o<c<`2ofIVIQCoc<c<00?oIVIVolc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00>olc<
c003ofIVI_o<c<coc<c<00Ooc<c<1Ol00005ool00003o`000?oo003oo`00017oo`000_l00009ool0
00Go00001?oo00000ol0003oo`00ool0000Bool00003o`000?oo003oo`0000Ooo`001Ol00005ool0
0003o`000?o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003o
c<c<olc<c?mVIVHGolc<c0CoIVIV4Oo<c<`00omVIVKoc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<
00koc<c<00?oIVIVolc<c?o<c<`00_o<c<`5o`0000_oo`000_l0000Cool00004o`000?oo003oo`00
ool000Go00002_oo0002o`0001?oo`0000Co0000ool00?oo003oo`001Ol0000;ool00003o`000?o<
c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mV
IVHGolc<c004ofIVI_o<c<coc<c<olc<c0;oIVIV3oo<c<`00omVIVKoc<c<olc<c00@olc<c003ofIV
I_o<c<coc<c<00koc<c<1Ol0000Bool00003o`000?oo003oo`00017oo`000ol0000Aool00003o`00
0?oo003oo`00017oo`000ol0000Aool00003o`000?o<c<coc<c<01coc<c<00?oIVIVolc<c?o<c<`0
6?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<00?oc<c<
0_mVIVH=olc<c003ofIVI_o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`02Oo<c<`5o`0000Coo`00
0_l0000Bool000;o00002Ooo0005o`0000GoOol000?o0000ool00?oo00004?oo0002o`0000Woo`00
1Ol00005ogoo0003o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`06oo<c<`00omVIVKoc<c<
olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`0
1Oo<c<`2ofIVIP_oc<c<00?oIVIVolc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c004olc<c0Go0000
2ooo0003o`00017oo`0000Co0000ool00?oo003oo`001Ol0000;ogoo0003o`000?oo003oo`00017o
o`0000Co0000ool00?oo003oo`001Ol0000;ogoo0003o`000?oo003oo`00013oo`0000?o0000olc<
c?o<c<`06_o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIV
IQOoc<c<00?oIVIVolc<c?o<c<`01oo<c<`2ofIVIPWoc<c<00?oIVIVolc<c?o<c<`04?o<c<`00omV
IVKoc<c<o`000004o`0001?oo`000_l0000@ool000?o00004Omoo`02o`0001;oo`000ol0000Aogoo
0003o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`06Oo<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`02Oo<c<`2ofIV
IPOoc<c<00?oIVIVolc<c?o<c<`02oo<c<`7o`0000Goo`000_l0000Cool000;o00001?oo0007o`00
00?o0?oo00?o0000ogoo0?moo`004omoo`000ol0003oo`00ool00007ool000Go00000ol0ool00ol0
003oOol0ogoo000Bogoo0003o`000?oo003oo`0000Ooo`001Ol00003o`3oo`03o`000?o<c<coc<c<
01Woc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHGolc<
c003ofIVI_o<c<coc<c<00_oc<c<0_mVIVH5olc<c003ofIVI_o<c<coc<c<00Ooc<c<1?l0000>ool0
00;o00004ooo0004o`0000[o0?oo00?o0000ogoo0?moo`005?moo`001?l0003oo`00ool00?oo0005
o`0000So0?oo00?o0000ogoo0?moo`004omoo`001?l0003oo`00ool00?oo0005o`0000So0?oo00?o
0000olc<c?o<c<`06Oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<co
c<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`03Oo<c<`2ofIVIP?oc<c<00?oIVIVolc<c?o<c<`01oo<
c<`01?l0003o0?ooo`000?l0000@ool000;o00002_oo0005o`00013o0?oo00?o0000ogoo0?moo`00
5Omoo`03o`0000go0?oo00?o0000ogoo0?moo`005?moo`03o`0000go0?oo00?o0000olc<c?o<c<`0
6Oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c0;o000000?oc<c<ofIVI_o<c<`05_o<
c<`00omVIVKoc<c<olc<c00?olc<c0CoIVIV2Oo<c<`01Ol0003o0?ooo`3oool0oooo0000017oo`00
0_l00003ool000Go00005Ol0ool00ol0003oOol0ogoo000Eogoo0003o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`005?moo`000ol0003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<01Woc<c<
00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:Oo<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01Ooc<c<
00?oIVIVolc<c?o<c<`04_o<c<`2ofIVIPSoc<c<00?o0000o`3oool0ool00_l0ool2o`00017oo`00
0ol0000<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`005Omoo`000ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol001CoOol000?o0000o`3oool0ool03Ol0ool00ol0003oc<c<
olc<c00Jolc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV
6?o<c<`00omVIVKoc<c<olc<c00Bolc<c004ofIVI_o<c<coIVIVofIVIPGoc<c<00?o0000o`3oool0
ool01Ol0ool2o`0000Soo`001Ol0000Ao`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`005Omoo`000ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001CoOol000?o0000o`3oool0
ool03_l0ool00ol0003oc<c<olc<c00Iolc<c0CoIVIV5_o<c<`1ooooo`00:Oo<c<`01?l0003oc<c<
olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00CoIVIVolc<c?o<c<coc<c<0_mVIVH3olc<
c003o`000?l0oooo0?oo00Oo0?oo00?o0000ool00?oo00001Ol0000Fo`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`005?moo`000ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol0
01?oOol000?o0000o`3oool0ool03_l0ool00ol0003oc<c<olc<c00Bolc<c0SoIVIV6Oo<c<`1oooo
o`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<
c?o<c<`00oo<c<`2ofIVIP03olc<c?l0003o0?oo00Wo0?oo0_l0000<o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Cogoo00;o00004?l0ool00ol0
003oOol0ogoo000Bogoo00;o00004?l0ool00ol0003oc<c<olc<c00<olc<c0KoIVIV1oo<c<`00omV
IVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<
c?o<c<`04_o<c<`00omVIVKoc<c<olc<c005olc<c003ofIVI_l0003o0?oo00Wo0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004omoo`02o`00013o0?oo00?o0000ogoo0?moo`004_moo`000ol0003oO`3oo`00000?o`3o
o`03o`000?o<c<coc<c<00Goc<c<1omVIVH=olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Wo
c<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<
00Koc<c<00?o0000o`3oool0ool02?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00go0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?oo0000
00oo0?oo00?o0000ogoo0?moo`004_moo`000ol0003oO`3oo`00000?o`3oo`03o`000?o<c<coIVIV
00GoIVIV5?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIV
IQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c006olc<c003o`000?l0oooo0?oo
00So0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00000?o`3oo`03o`000?moo`3oOol0
01;oOol000?o0000ogl0ool000003ol0ool00ol0003oIVIVolc<c00Iolc<c003ofIVI_o<c<coc<c<
01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Bolc<
c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool02?l0ool2o`0000go0?oo00?o0000o`3o
ool0ool03Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001?oOol000?o0000ogl0
ool000003ol0ool00ol0003oOol0ogoo000Bogoo0003o`000?mo0?oo000000oo0?oo00?o0000olc<
c?o<c<`06Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIV
IQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c005olc<c003o`000?l0oooo0?oo
00So0?oo0_l0000>o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0
003oOol0ogoo000Cogoo0003o`000?mo0?oo000000oo0?oo00?o0000ogoo0?moo`004_moo`000ol0
003oO`3oo`00000?o`3oo`03o`000?o<c<coc<c<01Woc<c<00?oIVIVolc<c?o<c<`05oo<c<`1oooo
o`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<
c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`08o`3oo`;o00003_l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00000?o`3o
o`03o`000?moo`3oOol001;oOol000?o0000ogl0ool000003ol0ool00ol0003oc<c<olc<c00Iolc<
c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<0_l000000oo<c<coIVIVolc<c00Folc<c003
ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`08o`3oo`;o
00003_l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`004omoo`000ol0003oO`3oo`00000?o`3oo`03o`000?moo`3oOol001;oOol000?o0000ogl0ool0
00003ol0ool00ol0003oc<c<olc<c00>olc<c003o`000?o<c<coc<c<00Soc<c<00?oIVIVolc<c?o<
c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<01;o
c<c<00?oIVIVolc<c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?oo000000go
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001;o
Ool000Co0000ogl0oomo0?oo00003ol0ool00ol0003oOol0ogoo000Bogoo0003o`000?mo0?oo0000
00oo0?oo00?o0000olc<c?o<c<`03_o<c<`2o`0000Woc<c<00?oIVIVolc<c?o<c<`05oo<c<`1oooo
o`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHGolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<
c?o<c<`01_o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?oo000000go0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001;oOol000Co0000ogl0
oomo0?oo00003ol0ool00ol0003oOol0ogoo000Aogoo0004o`000?mo0?ooO`3oo`00013o0?oo00?o
0000olc<c?o<c<`03Oo<c<`00ol0003oOol0o`000008olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Ooo
ool002Woc<c<00Co0000olc<c?o<c<coIVIV5oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<
c<coc<c<00Goc<c<00?o0000o`3oool0ool02Ol0ool00ol0003oO`3oo`00000=o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Bogoo0004o`000?mo
0?ooO`3oo`0000oo0?oo00?o0000ogoo0?moo`004Omoo`001?l0003oO`3oogl0ool0000@o`3oo`03
o`000?o<c<coc<c<00goc<c<00Co0000ogoo0?moo`3o00001oo<c<`00omVIVKoc<c<olc<c00Golc<
c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omV
IVKoc<c<olc<c005olc<c003o`000?l0oooo0?oo00So0?oo00Co0000ogl0oomo0?oo00003Ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`00
1?l0003oO`3oogl0ool0000@o`3oo`03o`000?moo`3oOol0013oOol000Co0000ogl0oomo0?oo0000
4?l0ool00ol0003oc<c<olc<c00=olc<c005o`000?moo`3oOol0ogoo0?l000001_o<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQOoc<c<00?oIVIVolc<c?o<
c<`04_o<c<`00omVIVKoc<c<olc<c005olc<c003o`000?l0oooo0?oo00So0?oo00Co0000ogl0oomo
0?oo00003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004Omoo`001?l0003oO`3oogl0ool0000@o`3oo`03o`000?moo`3oOol0013oOol000Go0000
ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?o<c<coc<c<00coc<c<00?oO`3oo`000?moo`000omo
o`02o`0000Coc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:?o<c<`01?l0003oc<c<olc<c?mV
IVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003o0?ooo`3o
o`08o`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol0017oOol000Go0000ogl0oomo0?ooO`3oo`00000?o`3oo`03
o`000?moo`3oOol0013oOol000Go0000ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?o<c<coc<c<
00Soc<c<1?l000000omo0?oo0000ogoo0003ogoo00;oo`0000Go0000olc<c?o<c<coc<c<ofIVIP0I
olc<c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`0
0omVIVKoc<c<olc<c005olc<c003o`000?l0oooo0?oo00So0?oo00Co0000ogl0oomo0?oo00003Ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omo
o`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o0000ogoo0?moo`004?moo`001Ol0003oO`3o
ogl0oomo0?oo000000oo0?oo00Co0000olc<c?o<c<coc<c<1ol00004ogoo0003ogl0ool0003oOol0
00?oOol00ooo00001?l0003oc<c<olc<c?mVIVHIolc<c07ooooo000Xolc<c004o`000?o<c<coc<c<
ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c005olc<c003o`000?l0oooo
0?oo00So0?oo00Co0000ogl0oomo0?oo00003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo
00?o0000ogoo0?moo`004?moo`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo1?l00003o`3oo`03
o`000?moo`3oOol000GoOol000?oO`3oo`000?moo`000omoo`04ool00003o`000?o<c<coIVIV01Wo
c<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Bolc<c003
ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool02Ol0ool01?l0003oO`3oogl0ool0000=o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000@ogoo
0005o`000?mo0?ooO`3oogl0ool000003ol0ool00ol0003o0?ooo`3oo`04o`3oo`03o`000?moo`3o
Ool000GoOol000?oO`3oo`000?moo`000omoo`05ool00003o`000?o<c<coIVIV01Soc<c<0Oooool0
02Soc<c<0ol000000omVIVKoc<c<olc<c00Folc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<
c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`08o`3oo`05o`000?mo0?ooO`3oogl0ool000003Ol0ool0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004?moo`00
0ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004?moo`00
1Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o0000o`3oool0ool01?l0ool00ol0003oOol0ogoo
0005ogoo0003ogl0ool0003oOol000;oOol00ol00005olc<c003ofIVI_o<c<coc<c<01Koc<c<0Ooo
ool001coc<c<1_l00006olc<c0;oIVIV00?oc<c<ofIVI_o<c<`05oo<c<`00omVIVKoc<c<olc<c00B
olc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool02?l0ool01Ol0003oO`3oogl0oomo
0?oo000000go0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?mo
o`3oOol0013oOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000ooOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0
oooo0?oo00Co0?oo00?o0000ogoo0?moo`001?moo`02ogl0o`04o`000?moo`3oOol0ogoo00Soc<c<
00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<
c<coIVIV00;oIVIV5oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00Coc<c<00?o
0000o`3oool0ool02?l0ool01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol0013oOol000?o0000ogl0oomo0?l0
0_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l0
0_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00Co0?oo00?o0000ogoo0?moo`00
1?moo`02ogl0o`04o`000?moo`3oOol0ogoo00Soc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`00
7Oo<c<`00ol0003oc<c<olc<c008olc<c005o`000?o<c<coc<c<ofIVI_o<c<`00omVIVHDolc<c003
ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`08o`3oo`05
o`000?mo0?ooO`3oogl0ool000003_l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00_o0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo
00go0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo
00ko0?oo00?o0000o`3oool0ool00ol0ool00ol0003oOol0ogoo0004ogoo00;oO`3o00Co0000ogoo
0?moo`3oOol02?o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Nolc<c0;o00002?o<c<`01?l0
003oc<c<olc<c?mVIVH4olc<c0?oIVIV4Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<co
c<c<00Coc<c<00?o0000o`3oool0ool02?l0ool01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol0013oOol000?o
0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000ooOol000?o
0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?l0oooo0?oo00?o0?oo00?o
0000ogoo0?moo`001?moo`02ogl0o`04o`000?moo`3oOol0ogoo00Soc<c<00?oIVIVolc<c?o<c<`0
5_o<c<`1ooooo`008?o<c<`00ol0003oc<c<olc<c005olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<
0omVIVH>olc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?oo
o`3oo`09o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3o
ogl0o`02ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3o
ogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00ol0ool00ol0003oOol0
ogoo0004ogoo00;oO`3o00Co0000ogoo0?moo`3oOol02?o<c<`00omVIVKoc<c<olc<c00Folc<c07o
oooo000Qolc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV2_o<c<`3ofIVIP_o
c<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo00Wo
0?oo00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00;o
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00?o
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`03o`3oo`03o`000?moo`3oOol000Co
Ool00_mo0?l01?l0003oOol0ogoo0?moo`08olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001co
c<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIV
IPgoc<c<0omVIVH8olc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0
003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003_moo`000ol0
003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`003_moo`000ol0
003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00ol0ool00ol0
003oOol0ogoo0003ogoo00?oO`3o00?o0000ogoo0?moo`002Oo<c<`00omVIVKoc<c<olc<c00Folc<
c07ooooo000Lolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003o
c<c<olc<c?mVIVH@olc<c0;oIVIV1_o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<
00?oc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo
00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
00koOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0
00koOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo
00?o0?oo00?o0000ogoo0?moo`000omoo`03ogl0o`03o`000?moo`3oOol000Woc<c<00?oIVIVolc<
c?o<c<`05_o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00;o
00000_o<c<`00ol0003oc<c<olc<c00:olc<c0Co00001oo<c<`01?l0003oc<c<olc<c?mVIVHBolc<
c0?oIVIV0_o<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3o
ool0ool02?l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0
oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0
oomo0?l00omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00?o0?oo00?o0000ogoo
0?moo`000omoo`03ogl0o`03o`000?moo`3oOol000Woc<c<00?oIVIVolc<c?o<c<`05_o<c<`1oooo
o`000oo<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001_oc<c<00Co0000olc<
c?o<c<coIVIV5Oo<c<`3ofIVIQGoc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`08
o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`04
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`04
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00ol0ool00ol0003oOol0ogoo0003
ogoo00?oO`3o00?o0000ogoo0?moo`002Oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<
c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co00006_o<c<`01Ol0003oc<c<olc<c?o<
c<coIVIV01Ooc<c<1?mVIVHBolc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0ool02Ol0
ool00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l01?mo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01?mo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00?o0?oo00?o0000ogoo0?moo`000omo
o`03ogl0o`03o`000?moo`3oOol000Woc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`0
0ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001[oc<c<0_l000000oo<c<coIVIVolc<
c00Golc<c004ofIVI_o<c<coc<c<olc<c0?oIVIV3oo<c<`00omVIVKoc<c<olc<c002olc<c003o`00
0?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`00
0?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo0003o`00
0?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`03o`3oo`03o`00
0?moo`3oOol000?oOol00omo0?l00ol0003oOol0ogoo0009olc<c003ofIVI_o<c<coc<c<01Koc<c<
0Oooool000?oc<c<1ol00002olc<c003o`000?o<c<coc<c<01Soc<c<00Co0000olc<c?o<c<coIVIV
6?o<c<`00omVIVKoc<c<olc<c004olc<c0?oIVIV3?o<c<`00omVIVKoc<c<olc<c002olc<c003o`00
0?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`00
0?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo0003o`00
0?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03_l0ool00ol0003o0?ooo`3oo`02o`3oo`03o`00
0?moo`3oOol000?oOol00omo0?l00ol0003oOol0ogoo0009olc<c003ofIVI_o<c<coc<c<01Koc<c<
0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c004o`00
0?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`01oo<c<`2ofIVIPWoc<c<00?oIVIVolc<c?o<
c<`00oo<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`003_moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`003Omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000o`3oool0
ool00_l0ool00ol0003oOol0ogoo0002ogoo00CoO`3o00?o0000ogoo0?o<c<`02Oo<c<`00omVIVKo
c<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?l00000
0_l0000Iolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`02Oo<c<`3ofIVIPKo
c<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00Co
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00ko
0?oo00?o0000o`3oool0ool00_l0ool00ol0003oOol0ogoo0002ogoo00CoO`3o00?o0000ogoo0?o<
c<`02Oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00Koc<c<
00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<00co
c<c<0omVIVH3olc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3oool0ool02?l0ool00ol0003o
O`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?moo`000_moo`04ogl0o`03
o`000?moo`3oc<c<00Woc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`7o`0000;oc<c<
00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<00oo
c<c<1?mVIVH4olc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000<ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03_l0ool00ol0003o
Ool0ogoo000<ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
0?ooo`3oo`02o`3oo`03o`000?moo`3oOol000;oOol01?mo0?l00ol0003oOol0olc<c009olc<c003
ofIVI_o<c<coc<c<01Koc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKo
c<c<olc<c00Bolc<c0?oIVIV0_o<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o00Co
O`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00ko
0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000o`3oool0ool00_l0ool00ol0003oOol0ogoo0002ogoo00CoO`3o00?o0000ogoo0?o<
c<`02Oo<c<`5ofIVIQCoc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKo
c<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00;oIVIV00?o0000o`3oool0ool02Ol0ool00ol0003o
O`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?moo`000_moo`04ogl0o`04
o`000?moo`3oc<c<olc<c0SoIVIV00?oc<c<ofIVI_o<c<`05_o<c<`1ooooo`009oo<c<`01?l0003o
c<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0
003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003?moo`000ol0
003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0
003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00_l0ool01?l0
003oOol0ogoo0?moo`05ogl0o`04o`000?moo`3oIVIVofIVIPWoc<c<00?oIVIVolc<c?o<c<`05Oo<
c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o
IVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000o`3oool0ool00_l0ool01?l0003oOol0ogoo0?moo`05ogl0o`03o`000?o<c<coc<c<00[oc<c<
00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIV
I_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`00
0?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`06ogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00_l0ool01?l0003oOol0ogoo0?moo`05ogl0o`03
o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`2o`000003olc<
c?mVIVKoc<c<01Ooc<c<00?oIVIVolc<c?o<c<`04_o<c<`01OmVIVKoc<c<olc<c?o<c<co000000_o
0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?ooO`3o00Ko
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00Ko
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`02o`3oo`04o`000?moo`3oOol0ogoo
00GoO`3o00?o0000olc<c?o<c<`02_o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004
o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`01OmVIVKoc<c<olc<c?o<c<co
000000_o0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?oo
O`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?oo
O`3o00KoO`3o00?o0000o`3oool0ool03_l0ool01Ol0003o0?ooo`3oool0oooo000000?oOol01Omo
0?l00ol0003oc<c<olc<c00:olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00Co0000
olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Bolc<c005ofIVI_o<c<coc<c<olc<c?l00000
2ol0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l0
1omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l0
1_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`05o`000?l0oooo0?ooo`3oool000000omoo`05ogl0o`03
o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<
olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00GoIVIVolc<c?o<c<coc<c<o`00000:o`3o
o`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07ogl0
o`03o`000?l0oooo0?oo00go0?oo00Go0000o`3oool0oooo0?ooo`000002ogoo00KoO`3o00?o0000
olc<c?o<c<`02_o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c005o`000?o<c<coc<c<
olc<c?mVIVH06?o<c<`00omVIVKoc<c<olc<c00Bolc<c005ofIVI_o<c<coc<c<olc<c?l000002_l0
ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l02?mo
0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?l0oooo0?ooo`3oool000000_moo`06ogl0o`03o`00
0?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<
c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00GoIVIVolc<c?o<c<coc<c<o`00000:o`3oo`03
o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0o`08ogl0o`03
o`000?l0oooo0?oo00go0?oo00Go0000o`3oool0oooo0?ooo`000002ogoo00KoO`3o00?o0000olc<
c?o<c<`02_o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIV
IQWoc<c<00?oIVIVolc<c?o<c<`04_o<c<`01?mVIVKoc<c<olc<c?l0000;o`3oo`03o`000?mo0?oo
O`3o00OoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo
0?oo00ko0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo
0?oo00go0?oo00Go0000o`3oool0oooo0?ooo`000002ogoo00KoO`3o00?o0000olc<c?o<c<`02_o<
c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?o
IVIVolc<c?o<c<`04oo<c<`01?mVIVKoc<c<olc<c?l0000;o`3oo`03o`000?mo0?ooO`3o00OoO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo
00Go0000o`3oool0oooo0?ooo`000002ogoo00KoO`3o00?o0000olc<c?o<c<`02_o<c<`00omVIVKo
c<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<
c<`04oo<c<`01?mVIVKoc<c<olc<c?l0000;o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`002_moo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`002Omoo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000o`3o
ool0oooo0?ooo`000002ogoo00KoO`3o00?o0000olc<c?o<c<`02_o<c<`00omVIVKoc<c<olc<c00E
olc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04oo<c<`0
1?mVIVKoc<c<olc<c?l0000;o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002Omo
o`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002Omo
o`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00Ko0000o`3oool0oooo0?oo
o`000?moo`07ogl0o`03o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`00
9_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01?oc<c<00CoIVIVolc<c?o<
c<co00002_l0ool00ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0
oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0
oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`06o`000?l0oooo0?ooo`3oool0003oOol01omo
0?l00ol0003oc<c<olc<c00:olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<0_l00000
0oo<c<coIVIVolc<c00Golc<c003ofIVI_o<c<coc<c<01?oc<c<00CoIVIVolc<c?o<c<co00002_l0
ool00ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l02Omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l02?mo
0?l00ol0003o0?ooo`3oo`0>o`3oo`05o`000?l0oooo0?ooo`000?moo`001omo0?l00ol0003oc<c<
olc<c00:olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV
6?o<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<co000000_o0?oo00?o0000ogl0oomo0?l0
2Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool0
3_l0ool01Ol0003o0?ooo`3oool0003oOol000OoO`3o00?o0000olc<c?o<c<`02_o<c<`00omVIVKo
c<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<
c<`04oo<c<`00omVIVKoc<c<o`00000;o`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`002Omoo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`002?moo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000o`3oool0
oooo0000ogoo0007ogl0o`03o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1oooo
o`009_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01?oc<c<00?oIVIVolc<
c?l000002ol0ool00ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0
oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0
oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?l0oooo0?ooo`000?moo`001omo0?l0
0ol0003oc<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<
c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<co000000_o0?oo00?o0000
ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000
o`3oool0ool03Ol0ool01?l0003o0?ooo`3oool00008ogl0o`03o`000?o<c<coc<c<00_oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<
c<coc<c<01?oc<c<00?oIVIVolc<c?l000002_l0ool00ol0003oO`3oogl0o`0:ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000WoOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000SoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?l0
oooo0?ooo`0000SoO`3o00?o0000olc<c?o<c<`02oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo
000Volc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`01?mVIVKoc<c<
olc<c?l0000:o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001omoo`000ol0003o
O`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`001omoo`000ol0003o
O`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00Co0000o`3oool0oooo00002?mo0?l00ol0
003oc<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000olc<c?o<
c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Bolc<c004ofIVI_o<c<coc<c<o`0000[o0?oo00?o0000
ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000
o`3oool0ool03_l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000
o`3oool0ool03Ol0ool01?l0003o0?ooo`3oool00008ogl0o`03o`000?o<c<coc<c<00_oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<
c<coc<c<01;oc<c<00?oIVIVolc<c?l000002ol0ool00ol0003oO`3oogl0o`0:ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000OoOol000?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000OoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?l0
oooo0?ooo`0000SoO`3o00?o0000olc<c?o<c<`02oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo
000Uolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<
o`00000;o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3o
ogl0o`0;ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3o
ogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00Co0000o`3oool0oooo00002?mo0?l00ol0003o
c<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<c?o<c<co
IVIV6Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<co000000_o0?oo00?o0000ogl0oomo
0?l02_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003o0?ooo`3oo`09ogl0o`03o`000?o<c<coc<c<00_oc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c0CoIVIV6Oo<c<`00omVIVKoc<c<
olc<c00Bolc<c003ofIVI_o<c<co000000_o0?oo00?o0000ogl0oomo0?l02_mo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo0006ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03_l0ool00ol0003o0?oo
ogl0o`08ogl0o`03o`000?o<c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<
c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00CoIVIV5_o<c<`00omVIVKoc<c<olc<
c00Bolc<c003ofIVI_o<c<co000000[o0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
0006ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03_l0ool00ol0003o0?ooogl0
o`08ogl0o`03o`000?o<c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006Oo<c<`6
o`0000Koc<c<00Co0000olc<c?o<c<coIVIV0oo<c<`4ofIVIQ;oc<c<00?oIVIVolc<c?o<c<`04_o<
c<`00omVIVKoc<c<o`00000:o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omo
o`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001_mo
o`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo0_l00009ogl0o`03o`000?o<
c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006Oo<c<`01Ol0003oc<c<olc<c?o<
c<co000000Ooc<c<00Co0000olc<c?o<c<coIVIV1oo<c<`5ofIVIPgoc<c<00?oIVIVolc<c?o<c<`0
4_o<c<`00omVIVKo0000o`3oo`0:o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
1_moo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
1_moo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo0_l00009ogl0o`03o`00
0?o<c<coc<c<00_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006_o<c<`01?l0003oc<c<olc<
c?l00007olc<c004o`000?o<c<coc<c<ofIVIPcoc<c<1?mVIVH9olc<c003ofIVI_o<c<coc<c<01;o
c<c<00?oIVIVo`000?l0ool02_l0ool00ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000Ko
Ool000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000Ko
Ool000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`;o00002Omo0?l00ol0003o
c<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001_oc<c<00?o0000olc<c?l00000
1oo<c<`01?l0003oc<c<olc<c?mVIVH@olc<c0CoIVIV1?o<c<`00omVIVKoc<c<olc<c00Colc<c003
ofIVI_l0003o0?oo00[o0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0006ogoo0003
o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0006ogoo0003
o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool2o`0000WoO`3o00?o0000olc<c?o<
c<`02oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Kolc<c003o`000?o<c<co000000Ooc<c<
00Co0000olc<c?o<c<coIVIV5?o<c<`5ofIVIQGoc<c<00?oIVIVo`000?l0ool02_l0ool00ol0003o
O`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o0000olc<c?o<c<`02oo<c<`00omVIVKo
c<c<olc<c00Dolc<c07ooooo000Lolc<c0;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c0Co
IVIV4_o<c<`00omVIVKo0000o`3oo`0:o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?mo
o`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo
0?l02?mo0?l00ol0003oc<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001goc<c<
00?o0000olc<c?o<c<`01Oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c004ofIVI_o<c<coc<c<olc<
c0CoIVIV3_o<c<`00omVIVKo0000o`3oo`09o`3oo`03o`000?mo0?ooO`3o00goO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo
0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0
oomo0?l02?mo0?l00ol0003oc<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Go
c<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c005olc<c0GoIVIV2Oo<c<`00ol0
003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001Omoo`000ol0
003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001?moo`000ol0
003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l02?mo0?l00ol0
003oc<c<olc<c00;olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<c?o<
c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00:olc<c0CoIVIV1Oo<c<`00ol0003o0?ooo`3oo`09o`3o
o`03o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0=ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l02?mo0?l00ol0003oc<c<olc<c00;olc<
c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omV
IVKoc<c<olc<c00>olc<c0CoIVIV00?oc<c<o`000?l0ool02_l0ool00ol0003oO`3oogl0o`0=ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0>o`3o
o`03o`000?mo0?ooO`3o00OoO`3o00?o0000olc<c?o<c<`03?o<c<`00omVIVKoc<c<olc<c00Colc<
c07ooooo000Uolc<c0;o000000?oc<c<ofIVI_o<c<`05oo<c<`00omVIVKoc<c<olc<c00Bolc<c003
ofIVI_l0003o0?oo00[o0?oo00?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0004ogoo0003
o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0004ogoo0003
o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`07ogl0o`03
o`000?o<c<coc<c<00Woc<c<1omVIVHBolc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIVIQSo
c<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o00go
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oIVIVofIVIP09ofIVIP?oc<c<00?oIVIVolc<c?o<
c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01?o
c<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000Co
Ool000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000Co
Ool000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00Oo
O`3o00?o0000olc<c?o<c<`03?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`00
0?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`09o`3oo`03
o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0>ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0>ogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<c00<olc<c003
ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKo
c<c<olc<c00Bolc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo0004ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo0004ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
O`3oogl0o`07ogl0o`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`00
9?o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o0000o`3oool0
ool02Ol0ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo
0?l03_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000?oOol000?o0000ogl0oomo
0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000olc<c?o<
c<`03?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQWo
c<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o00oo
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<c00<olc<c003ofIVI_o<c<coc<c<01?o
c<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003
o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003
o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0002ogoo0003
o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`07ogl0o`03
o`000?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<
olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o0000o`3oool0ool02Ol0ool00ol0003o
O`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000olc<c?o<c<`03?o<c<`00omVIVKo
c<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<
c<`04Oo<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`000_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`000_moo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo
0?l01_mo0?l00ol0003oc<c<olc<c00<olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<
00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00Wo
0?oo00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o013o
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o00oo
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00co
c<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`2o`000003olc<c?mVIVKoc<c<01Soc<c<
00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o013oO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogl0oomo0?l01_mo0?l00ol0003oc<c<olc<c00<olc<c003ofIVI_o<c<coc<c<01?oc<c<
0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00Aolc<c003o`00
0?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003o`00
0?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003o`00
0?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`06ogl0o`03o`00
0?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<
c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o0000o`3oool0ool02Ol0ool00ol0003oO`3o
ogl0o`0@ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l04?mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`03?o<c<`00omVIVKoc<c<
olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`0
4_o<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
0_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000ogoo0?moo`3o
Ool0o`00000Cogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003o
c<c<olc<c00<olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<co
IVIV6?o<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo
0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0
ool03Ol0ool01Ol0003oOol0ogoo0?moo`3o000001?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00coc<c<00?oIVIVolc<c?o<c<`04oo<c<`1oooo
o`009?o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<017oc<c<00?o0000o`3o
ool0ool02Ol0ool00ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`000?moo`3oOol0ogoo0?l000004omo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`05o`000?moo`3oOol0ogoo0?l000004omo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`03?o<c<`00omVIVKoc<c<olc<
c00Colc<c07ooooo000Solc<c005o`000?o<c<coc<c<olc<c?mVIVH06?o<c<`00omVIVKoc<c<olc<
c00Aolc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01Ol0003oOol0ogoo
0?moo`3o000001?oO`3o00?o0000o`3oool0ool03Ol0ool01Ol0003oOol0ogoo0?moo`3o000001?o
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00co
c<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003
ofIVI_o<c<coc<c<017oc<c<00?o0000o`3oool0ool02Ol0ool00ol0003oO`3oogl0o`0Bogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`04
o`000?moo`3oOol0o`0001?oO`3o00?o0000o`3oool0ool03_l0ool01?l0003oOol0ogoo0?l0000C
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oc<c<olc<c00=
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`0
0omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l04_mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool0
1?l0003oOol0ogoo0?l0000Cogl0o`03o`000?l0oooo0?oo00ko0?oo00Co0000ogoo0?moo`3o0000
4omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`0
3Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<
00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o01;oO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo
00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?moo`3oOol0o`00
01?oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<
00goc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<
c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0Bogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3o
o`04o`000?moo`3oOol0o`0001CoO`3o00?o0000o`3oool0ool03Ol0ool01?l0003oOol0ogoo0?l0
000Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<
c00=olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV6Oo<
c<`00omVIVKoc<c<olc<c00@olc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l04omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0
ool01?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00go0?oo00Co0000ogoo0?moo`3o
00005?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<
c<`03Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c0;o000000?oc<c<ofIVI_o<c<`0
6?o<c<`00omVIVKoc<c<olc<c00@olc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l0
4omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3Ol0ool01?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l0
00005Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<
c<`03Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWo
c<c<00?oIVIVolc<c?o<c<`04?o<c<`00ol0003o0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o01?o
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?l000005Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001Go
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<00go
c<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003
ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool02Ol0ool00ol0003oO`3oogl0o`0Cogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3o000001GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00000Eogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<c00=olc<c003
ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKo
c<c<olc<c00@olc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l04omo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0o`00000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005Omo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<c<`03Oo<c<`00omVIVKo
c<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<
c<`03oo<c<`00ol0003o0?ooo`3oo`0:o`3oo`03o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l0
00005Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001GoO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<00goc<c<00?oIVIVolc<c?o<
c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<00oo
c<c<00?o0000o`3oool0ool02Ol0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001Go
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00000Eogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01;o
c<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00?olc<c003
o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l05?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00000Eogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?mo0?ooO`3o00GoO`3o00?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07o
oooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o
0?ooo`3oo`09o`3oo`03o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00go0?oo0_l0000Eogl0o`03o`000?l0oooo0?oo00ko
0?oo0_l0000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003o
c<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<co
IVIV6Oo<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo
0?l05?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03Ol0ool2o`0001KoO`3o00?o0000o`3oool0ool03Ol0ool2o`0001GoO`3o00?o0000o`3oool0
ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?o<c<coc<c<00goc<c<00?oIVIVolc<c?o<
c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<00oo
c<c<00?o0000o`3oool0ool02Ol0ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o01Go
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01;o
c<c<0Oooool002;oc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00?olc<c003
o`000?l0oooo0?oo00[o0?oo00?o0000ogl0oomo0?l05Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`0Eogl0o`03
o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l05Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?mo0?ooO`3o00CoO`3o00?o0000olc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07o
oooo000Golc<c0Co00001oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<00oo
c<c<00?o0000o`3oool0ool02_l0ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o01Go
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`0Eogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01;o
c<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c0KoIVIV
5oo<c<`00omVIVKoc<c<olc<c008olc<c0_o00002?l0ool00ol0003oO`3oogl0o`0Fogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`05o`3oo`_o0000
5Omo0?l00ol0003o0?ooo`3oo`05o`3oo`_o00005Omo0?l00ol0003o0?ooo`3oo`05o`3oo`_o0000
1?mo0?l00ol0003oc<c<olc<c00=olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP;oc<c<
2OmVIVH>olc<c004ofIVI_o<c<coc<c<olc<c0Oo00002ooo0006o`0000;o0?oo00?o0000ogl0oomo
0?l05_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00Go0?oo3ol0000;ool000Go
00002Omo0?l?o`0000_oo`001?l00009ogl0oa3o00002ooo0003o`000003ogl0ool0003oc<c<00ko
c<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c002olc<c003o`00
0?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV2oo<c<`9ofIVIPGoc<c<00?oIVIVolc<c?o<
c<`02?o<c<`7o`0000[oo`002Ol0000Bogl0o`03o`000?l0oooo0?oo00Co0?oo3ol0000;ool000Go
00003ooo0009o`0000[oo`001?l0000@ool000Wo00002ooo0003o`00013oo`000_l0000@olc<c003
ofIVI_o<c<coc<c<017oc<c<0Oooool001Koc<c<0_l00003olc<c003o`000?o<c<coc<c<00Coc<c<
00Co0000olc<c?o<c<coIVIV5?o<c<`9ofIVIQ3oc<c<1_l0000;ool001Wo00003Ooo0008o`0000[o
o`002Ol0000<ool000So00002Ooo0009o`0000goo`001ol0000:ool000Wo00006Oo<c<`00omVIVKo
c<c<olc<c00Aolc<c07ooooo000Folc<c003o`000?o<c<co000000;o00001oo<c<`01?l0003oc<c<
olc<c?mVIVHIolc<c004ofIVI_o<c<coc<c<olc<c0WoIVIV2Oo<c<`01?mVIVKoc<c<olc<c?o<c<`9
o`0000goo`001_l00007ool000_o00002_oo0005o`0000coo`002ol0000:ool000Co00003Ooo000:
o`0000_oo`000ol0000>ool000?o00006_o<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo000Folc<
c003o`000?o<c<coc<c<00Woc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00:
olc<c0[oIVIV2oo<c<`;o`0000[oo`001Ol0000;ool000Oo00002Ooo0008o`0000goo`001ol00009
ool000So00003?oo0007o`0000[oo`002?l00004ogl0o`03o`000?o<c<coc<c<01coc<c<00?oIVIV
olc<c?o<c<`04Oo<c<`1ooooo`005oo<c<`01Ol0003oc<c<olc<c?o<c<co000002?oc<c<00?oIVIV
olc<c?o<c<`04oo<c<`9ofIVIP_oc<c<00?oIVIVolc<c?l000001_l00009ool000So00003?oo0007
o`0000Ooo`002_l0000<ool000Oo00001ooo000:o`0000_oo`001_l0000@ogl0o`03o`000?o<c<co
c<c<01;oc<c<3omVIVH?olc<c07ooooo000Holc<c0?o00009?o<c<`00omVIVKoc<c<olc<c00Colc<
c003ofIVI_o<c<coc<c<00Koc<c<2OmVIVH2olc<c003ofIVI_o<c<coc<c<00Woc<c<1_l00007ool0
00[o00003?oo0006o`0000Ooo`002_l0000;ool000Oo00001ooo0009o`0000_oo`004Ol0000DofIV
IP[oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`00EOo<c<`00omVIVKoc<c<olc<c00?olc<c0Wo
IVIV2oo<c<`00omVIVKoc<c<olc<c007o`0000Koo`002_l0000;ool000Ko00001ooo0009o`0000_o
o`001ol00007ool000Wo00003_mVIVH00oo<c<coIVIVolc<c00Rolc<c003ofIVI_o<c<coc<c<017o
c<c<0Oooool005Goc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c004olc<c0WoIVIV
0_o<c<`00omVIVKoc<c<olc<c009olc<c0Ko00001_oo0009o`0000_oo`001_l00007ool000Wo0000
3OmVIVHMolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`00EOo<
c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<00goc<c<2OmVIVH6olc<c003ofIVI_o<
c<coc<c<00Coc<c<1_l00006ool000Wo00002_mVIVHGolc<c003ofIVI_o<c<coc<c<01ooc<c<00?o
IVIVolc<c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo001Yolc<c003ofIVI_o<c<co
c<c<00ooc<c<00?oIVIVolc<c?o<c<`01?o<c<`AofIVIQ;oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`0
0omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<03Goc<c<0Oooool006Woc<c<00?oIVIVolc<
c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00:olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIVolc<
c?o<c<`07Oo<c<`00omVIVKoc<c<olc<c01Golc<c07ooooo001kolc<c003ofIVI_o<c<coc<c<00[o
c<c<00?oIVIVolc<c?o<c<`06_o<c<`00omVIVKoc<c<olc<c01golc<c07ooooo0028olc<c003ofIV
I_o<c<coc<c<09Coc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00aOo<c<`2o`0005Soc<c<0Oooool00<Koc<c<0_l0
0002olc<c003o`000?o<c<coc<c<05;oc<c<0Oooool00<Ooc<c<0_l00002olc<c003o`000?o<c<co
c<c<057oc<c<0Oooool003ooc<c<1Ol00004olc<c0?o00000oo<c<`2o`0000?oc<c<0ol00002olc<
c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`3o`000003olc<c?l0003o0000
00;oc<c<0_l00002olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`00
00Coc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0ol00003olc<
c0?o00000oo<c<`2o`0000Coc<c<0ol000000oo<c<co0000o`000007olc<c0Co000000Coc<c<o`00
0?o<c<coc<c<1?l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000Goc<c<1?l0000/
olc<c07ooooo000nolc<c0;o00000oo<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<
c0;o00000oo<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`00
00?oc<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`00
0?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<
c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<
c0;o00000oo<c<`2o`000004olc<c?l0003o0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003
olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000Coc<c<0ol000000oo<c<co0000o`000006
olc<c0;o00000_o<c<`3o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002
olc<c0;o000000?oc<c<o`000?l000001?o<c<`2o`0000;oc<c<0_l0000[olc<c07ooooo000nolc<
c0;o00000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000003olc<
c0;o00000_o<c<`2o`0000Goc<c<0_l00002olc<c0;o00000oo<c<`2o`0000Coc<c<0_l00002olc<
c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000008olc<c0?o00001?o<c<`3o`00
0003olc<c?l0003o000000Soc<c<0ol00003olc<c0;o00000oo<c<`2o`000003olc<c?l0003o0000
00Coc<c<0ol00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<
c0;o000000?oc<c<o`000?l000001oo<c<`2o`0000Coc<c<0_l000000oo<c<co0000o`000005olc<
c0;o00000_o<c<`2o`0000Ooc<c<0_l00002olc<c0;o0000:oo<c<`1ooooo`00@_o<c<`3o`000003
olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o00000_o<c<`6o`000003
olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o
00000_o<c<`2o`000003olc<c?l0003o000000Co00000_o<c<`4o`0000?oc<c<1?l00002olc<c0Ko
00000_o<c<`4o`0000Coc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?o
c<c<0_l00002olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co
0000o`000007olc<c0;o00001?o<c<`2o`000003olc<c?l0003o000000Co000000?oc<c<o`000?l0
00000_o<c<`2o`0000Ooc<c<0_l00002olc<c0;o0000:oo<c<`1ooooo`00?oo<c<`5o`0000;oc<c<
0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`0000;oc<c<0_l00002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<1Ol000000oo<c<co0000o`000002olc<c0;o0000
0_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000Coc<c<o`000?l0003o
00001?o<c<`3o`0000Coc<c<0_l00002olc<c0;o000000Coc<c<o`000?l0003o00001_o<c<`2o`00
00?oc<c<0_l000001?o<c<co0000o`000?o<c<`3o`0000Goc<c<0_l00002olc<c0;o00000oo<c<`2
o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00000_o<c<`4
o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00002?o<c<`4
o`0002coc<c<0Oooool003koc<c<0ol00006olc<c0;o000000?oc<c<o`000?l000000_o<c<`3o`00
00;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<
c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o0000
00;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`00
0003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`7o`00
0004olc<c?l0003o0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<
o`000?l000000_o<c<`3o`0000;oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001oo<c<`2
o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00001oo<c<`2o`0000;oc<c<0_l0000[
olc<c07ooooo000nolc<c0;o00000oo<c<`2o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`00
0?l000000_l00002olc<c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<c0;o000000?oc<c<o`00
0?l000000_l000000oo<c<co0000o`000003o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`00
00?oc<c<1?l00003olc<c0Co00001?o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<
c0Co00000_o<c<`4o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`000?l000000oo<c<`2o`00
00Koc<c<0_l00004olc<c0;o00000_o<c<`4o`0000;oc<c<1Ol00008olc<c0;o00000_o<c<`2o`00
02_oc<c<0Oooool003koc<c<0_l00003olc<c0;o00003_o<c<`2o`0000goc<c<0_l00003olc<c0;o
00002?o<c<`2o`0002koc<c<0_l00003olc<c0;o00003?o<c<`2o`0001coc<c<0_l00002olc<c0;o
00005_o<c<`2o`0000;oc<c<0_l0000[olc<c07ooooo000oolc<c0Go00003oo<c<`2o`0000goc<c<
0_l00003olc<c0So00000_o<c<`2o`0002koc<c<0_l00003olc<c0;o000000?oc<c<o`000?l00000
2Oo<c<`2o`0001goc<c<1?l0000Holc<c0Co0000;?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003o
olc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<
0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00001
\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 6, 6, 1, 6, 6, 6, 1, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(5.`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 0.0147151 5.88604 [
[.15986 .00222 -3 -9 ]
[.15986 .00222 3 0 ]
[.29592 .00222 -3 -9 ]
[.29592 .00222 3 0 ]
[.43197 .00222 -3 -9 ]
[.43197 .00222 3 0 ]
[.56803 .00222 -3 -9 ]
[.56803 .00222 3 0 ]
[.70408 .00222 -3 -9 ]
[.70408 .00222 3 0 ]
[.84014 .00222 -3 -9 ]
[.84014 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .01472 m
.15986 .02097 L
s
[(2)] .15986 .00222 0 1 Mshowa
.29592 .01472 m
.29592 .02097 L
s
[(3)] .29592 .00222 0 1 Mshowa
.43197 .01472 m
.43197 .02097 L
s
[(4)] .43197 .00222 0 1 Mshowa
.56803 .01472 m
.56803 .02097 L
s
[(5)] .56803 .00222 0 1 Mshowa
.70408 .01472 m
.70408 .02097 L
s
[(6)] .70408 .00222 0 1 Mshowa
.84014 .01472 m
.84014 .02097 L
s
[(7)] .84014 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(8)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05102 .01472 m
.05102 .01847 L
s
.07823 .01472 m
.07823 .01847 L
s
.10544 .01472 m
.10544 .01847 L
s
.13265 .01472 m
.13265 .01847 L
s
.18707 .01472 m
.18707 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2415 .01472 m
.2415 .01847 L
s
.26871 .01472 m
.26871 .01847 L
s
.32313 .01472 m
.32313 .01847 L
s
.35034 .01472 m
.35034 .01847 L
s
.37755 .01472 m
.37755 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45918 .01472 m
.45918 .01847 L
s
.48639 .01472 m
.48639 .01847 L
s
.51361 .01472 m
.51361 .01847 L
s
.54082 .01472 m
.54082 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62245 .01472 m
.62245 .01847 L
s
.64966 .01472 m
.64966 .01847 L
s
.67687 .01472 m
.67687 .01847 L
s
.73129 .01472 m
.73129 .01847 L
s
.7585 .01472 m
.7585 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.81293 .01472 m
.81293 .01847 L
s
.86735 .01472 m
.86735 .01847 L
s
.89456 .01472 m
.89456 .01847 L
s
.92177 .01472 m
.92177 .01847 L
s
.94898 .01472 m
.94898 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.15986 .60332 L
.29592 .60332 L
.43197 .60332 L
.56803 .60332 L
.70408 .60332 L
.84014 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 0.0147151 2.94302 [
[.15986 .00222 -3 -9 ]
[.15986 .00222 3 0 ]
[.29592 .00222 -3 -9 ]
[.29592 .00222 3 0 ]
[.43197 .00222 -3 -9 ]
[.43197 .00222 3 0 ]
[.56803 .00222 -3 -9 ]
[.56803 .00222 3 0 ]
[.70408 .00222 -3 -9 ]
[.70408 .00222 3 0 ]
[.84014 .00222 -3 -9 ]
[.84014 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .16187 -24 -4.5 ]
[.01131 .16187 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .45617 -24 -4.5 ]
[.01131 .45617 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .01472 m
.15986 .02097 L
s
[(2)] .15986 .00222 0 1 Mshowa
.29592 .01472 m
.29592 .02097 L
s
[(3)] .29592 .00222 0 1 Mshowa
.43197 .01472 m
.43197 .02097 L
s
[(4)] .43197 .00222 0 1 Mshowa
.56803 .01472 m
.56803 .02097 L
s
[(5)] .56803 .00222 0 1 Mshowa
.70408 .01472 m
.70408 .02097 L
s
[(6)] .70408 .00222 0 1 Mshowa
.84014 .01472 m
.84014 .02097 L
s
[(7)] .84014 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(8)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05102 .01472 m
.05102 .01847 L
s
.07823 .01472 m
.07823 .01847 L
s
.10544 .01472 m
.10544 .01847 L
s
.13265 .01472 m
.13265 .01847 L
s
.18707 .01472 m
.18707 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2415 .01472 m
.2415 .01847 L
s
.26871 .01472 m
.26871 .01847 L
s
.32313 .01472 m
.32313 .01847 L
s
.35034 .01472 m
.35034 .01847 L
s
.37755 .01472 m
.37755 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45918 .01472 m
.45918 .01847 L
s
.48639 .01472 m
.48639 .01847 L
s
.51361 .01472 m
.51361 .01847 L
s
.54082 .01472 m
.54082 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62245 .01472 m
.62245 .01847 L
s
.64966 .01472 m
.64966 .01847 L
s
.67687 .01472 m
.67687 .01847 L
s
.73129 .01472 m
.73129 .01847 L
s
.7585 .01472 m
.7585 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.81293 .01472 m
.81293 .01847 L
s
.86735 .01472 m
.86735 .01847 L
s
.89456 .01472 m
.89456 .01847 L
s
.92177 .01472 m
.92177 .01847 L
s
.94898 .01472 m
.94898 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .16187 m
.03006 .16187 L
s
[(0.05)] .01131 .16187 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.1)] .01131 .30902 1 0 Mshowa
.02381 .45617 m
.03006 .45617 L
s
[(0.15)] .01131 .45617 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.15986 .30902 L
.29592 .30902 L
.43197 .30902 L
.56803 .30902 L
.70408 .30902 L
.84014 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 -0.377687 0.981006 [
[.15986 .59082 -3 -9 ]
[.15986 .59082 3 0 ]
[.29592 .59082 -3 -9 ]
[.29592 .59082 3 0 ]
[.43197 .59082 -3 -9 ]
[.43197 .59082 3 0 ]
[.56803 .59082 -3 -9 ]
[.56803 .59082 3 0 ]
[.70408 .59082 -3 -9 ]
[.70408 .59082 3 0 ]
[.84014 .59082 -3 -9 ]
[.84014 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01472 -18 -4.5 ]
[.01131 .01472 0 4.5 ]
[.01131 .11282 -18 -4.5 ]
[.01131 .11282 0 4.5 ]
[.01131 .21092 -18 -4.5 ]
[.01131 .21092 0 4.5 ]
[.01131 .30902 -18 -4.5 ]
[.01131 .30902 0 4.5 ]
[.01131 .40712 -18 -4.5 ]
[.01131 .40712 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .60332 m
.15986 .60957 L
s
[(2)] .15986 .59082 0 1 Mshowa
.29592 .60332 m
.29592 .60957 L
s
[(3)] .29592 .59082 0 1 Mshowa
.43197 .60332 m
.43197 .60957 L
s
[(4)] .43197 .59082 0 1 Mshowa
.56803 .60332 m
.56803 .60957 L
s
[(5)] .56803 .59082 0 1 Mshowa
.70408 .60332 m
.70408 .60957 L
s
[(6)] .70408 .59082 0 1 Mshowa
.84014 .60332 m
.84014 .60957 L
s
[(7)] .84014 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(8)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.05102 .60332 m
.05102 .60707 L
s
.07823 .60332 m
.07823 .60707 L
s
.10544 .60332 m
.10544 .60707 L
s
.13265 .60332 m
.13265 .60707 L
s
.18707 .60332 m
.18707 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.2415 .60332 m
.2415 .60707 L
s
.26871 .60332 m
.26871 .60707 L
s
.32313 .60332 m
.32313 .60707 L
s
.35034 .60332 m
.35034 .60707 L
s
.37755 .60332 m
.37755 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45918 .60332 m
.45918 .60707 L
s
.48639 .60332 m
.48639 .60707 L
s
.51361 .60332 m
.51361 .60707 L
s
.54082 .60332 m
.54082 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.62245 .60332 m
.62245 .60707 L
s
.64966 .60332 m
.64966 .60707 L
s
.67687 .60332 m
.67687 .60707 L
s
.73129 .60332 m
.73129 .60707 L
s
.7585 .60332 m
.7585 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.81293 .60332 m
.81293 .60707 L
s
.86735 .60332 m
.86735 .60707 L
s
.89456 .60332 m
.89456 .60707 L
s
.92177 .60332 m
.92177 .60707 L
s
.94898 .60332 m
.94898 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01472 m
.03006 .01472 L
s
[(0.4)] .01131 .01472 1 0 Mshowa
.02381 .11282 m
.03006 .11282 L
s
[(0.5)] .01131 .11282 1 0 Mshowa
.02381 .21092 m
.03006 .21092 L
s
[(0.6)] .01131 .21092 1 0 Mshowa
.02381 .30902 m
.03006 .30902 L
s
[(0.7)] .01131 .30902 1 0 Mshowa
.02381 .40712 m
.03006 .40712 L
s
[(0.8)] .01131 .40712 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(0.9)] .01131 .50522 1 0 Mshowa
.125 Mabswid
.02381 .03434 m
.02756 .03434 L
s
.02381 .05396 m
.02756 .05396 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .0932 m
.02756 .0932 L
s
.02381 .13244 m
.02756 .13244 L
s
.02381 .15206 m
.02756 .15206 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .23054 m
.02756 .23054 L
s
.02381 .25016 m
.02756 .25016 L
s
.02381 .26978 m
.02756 .26978 L
s
.02381 .2894 m
.02756 .2894 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34826 m
.02756 .34826 L
s
.02381 .36788 m
.02756 .36788 L
s
.02381 .3875 m
.02756 .3875 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .44636 m
.02756 .44636 L
s
.02381 .46598 m
.02756 .46598 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .52484 m
.02756 .52484 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .56408 m
.02756 .56408 L
s
.02381 .5837 m
.02756 .5837 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.15986 .60332 L
.29592 .60332 L
.43197 .59351 L
.56803 .5838 L
.70408 .57418 L
.84014 .36834 L
.97619 .36088 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 -0.100584 1.15299 [
[.15986 .00222 -3 -9 ]
[.15986 .00222 3 0 ]
[.29592 .00222 -3 -9 ]
[.29592 .00222 3 0 ]
[.43197 .00222 -3 -9 ]
[.43197 .00222 3 0 ]
[.56803 .00222 -3 -9 ]
[.56803 .00222 3 0 ]
[.70408 .00222 -3 -9 ]
[.70408 .00222 3 0 ]
[.84014 .00222 -3 -9 ]
[.84014 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13001 -18 -4.5 ]
[.01131 .13001 0 4.5 ]
[.01131 .24531 -18 -4.5 ]
[.01131 .24531 0 4.5 ]
[.01131 .36061 -18 -4.5 ]
[.01131 .36061 0 4.5 ]
[.01131 .47591 -18 -4.5 ]
[.01131 .47591 0 4.5 ]
[.01131 .59121 -18 -4.5 ]
[.01131 .59121 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .01472 m
.15986 .02097 L
s
[(2)] .15986 .00222 0 1 Mshowa
.29592 .01472 m
.29592 .02097 L
s
[(3)] .29592 .00222 0 1 Mshowa
.43197 .01472 m
.43197 .02097 L
s
[(4)] .43197 .00222 0 1 Mshowa
.56803 .01472 m
.56803 .02097 L
s
[(5)] .56803 .00222 0 1 Mshowa
.70408 .01472 m
.70408 .02097 L
s
[(6)] .70408 .00222 0 1 Mshowa
.84014 .01472 m
.84014 .02097 L
s
[(7)] .84014 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(8)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05102 .01472 m
.05102 .01847 L
s
.07823 .01472 m
.07823 .01847 L
s
.10544 .01472 m
.10544 .01847 L
s
.13265 .01472 m
.13265 .01847 L
s
.18707 .01472 m
.18707 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2415 .01472 m
.2415 .01847 L
s
.26871 .01472 m
.26871 .01847 L
s
.32313 .01472 m
.32313 .01847 L
s
.35034 .01472 m
.35034 .01847 L
s
.37755 .01472 m
.37755 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45918 .01472 m
.45918 .01847 L
s
.48639 .01472 m
.48639 .01847 L
s
.51361 .01472 m
.51361 .01847 L
s
.54082 .01472 m
.54082 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62245 .01472 m
.62245 .01847 L
s
.64966 .01472 m
.64966 .01847 L
s
.67687 .01472 m
.67687 .01847 L
s
.73129 .01472 m
.73129 .01847 L
s
.7585 .01472 m
.7585 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.81293 .01472 m
.81293 .01847 L
s
.86735 .01472 m
.86735 .01847 L
s
.89456 .01472 m
.89456 .01847 L
s
.92177 .01472 m
.92177 .01847 L
s
.94898 .01472 m
.94898 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13001 m
.03006 .13001 L
s
[(0.2)] .01131 .13001 1 0 Mshowa
.02381 .24531 m
.03006 .24531 L
s
[(0.3)] .01131 .24531 1 0 Mshowa
.02381 .36061 m
.03006 .36061 L
s
[(0.4)] .01131 .36061 1 0 Mshowa
.02381 .47591 m
.03006 .47591 L
s
[(0.5)] .01131 .47591 1 0 Mshowa
.02381 .59121 m
.03006 .59121 L
s
[(0.6)] .01131 .59121 1 0 Mshowa
.125 Mabswid
.02381 .03777 m
.02756 .03777 L
s
.02381 .06083 m
.02756 .06083 L
s
.02381 .08389 m
.02756 .08389 L
s
.02381 .10695 m
.02756 .10695 L
s
.02381 .15307 m
.02756 .15307 L
s
.02381 .17613 m
.02756 .17613 L
s
.02381 .19919 m
.02756 .19919 L
s
.02381 .22225 m
.02756 .22225 L
s
.02381 .26837 m
.02756 .26837 L
s
.02381 .29143 m
.02756 .29143 L
s
.02381 .31449 m
.02756 .31449 L
s
.02381 .33755 m
.02756 .33755 L
s
.02381 .38367 m
.02756 .38367 L
s
.02381 .40673 m
.02756 .40673 L
s
.02381 .42979 m
.02756 .42979 L
s
.02381 .45285 m
.02756 .45285 L
s
.02381 .49897 m
.02756 .49897 L
s
.02381 .52203 m
.02756 .52203 L
s
.02381 .54509 m
.02756 .54509 L
s
.02381 .56815 m
.02756 .56815 L
s
.02381 .61427 m
.02756 .61427 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .13001 m
.15986 .60332 L
.29592 .59628 L
.43197 .58931 L
.56803 .58241 L
.70408 .57558 L
.84014 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 -0.573889 5.88604 [
[.15986 .00222 -3 -9 ]
[.15986 .00222 3 0 ]
[.29592 .00222 -3 -9 ]
[.29592 .00222 3 0 ]
[.43197 .00222 -3 -9 ]
[.43197 .00222 3 0 ]
[.56803 .00222 -3 -9 ]
[.56803 .00222 3 0 ]
[.70408 .00222 -3 -9 ]
[.70408 .00222 3 0 ]
[.84014 .00222 -3 -9 ]
[.84014 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .01472 m
.15986 .02097 L
s
[(2)] .15986 .00222 0 1 Mshowa
.29592 .01472 m
.29592 .02097 L
s
[(3)] .29592 .00222 0 1 Mshowa
.43197 .01472 m
.43197 .02097 L
s
[(4)] .43197 .00222 0 1 Mshowa
.56803 .01472 m
.56803 .02097 L
s
[(5)] .56803 .00222 0 1 Mshowa
.70408 .01472 m
.70408 .02097 L
s
[(6)] .70408 .00222 0 1 Mshowa
.84014 .01472 m
.84014 .02097 L
s
[(7)] .84014 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(8)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05102 .01472 m
.05102 .01847 L
s
.07823 .01472 m
.07823 .01847 L
s
.10544 .01472 m
.10544 .01847 L
s
.13265 .01472 m
.13265 .01847 L
s
.18707 .01472 m
.18707 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2415 .01472 m
.2415 .01847 L
s
.26871 .01472 m
.26871 .01847 L
s
.32313 .01472 m
.32313 .01847 L
s
.35034 .01472 m
.35034 .01847 L
s
.37755 .01472 m
.37755 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45918 .01472 m
.45918 .01847 L
s
.48639 .01472 m
.48639 .01847 L
s
.51361 .01472 m
.51361 .01847 L
s
.54082 .01472 m
.54082 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62245 .01472 m
.62245 .01847 L
s
.64966 .01472 m
.64966 .01847 L
s
.67687 .01472 m
.67687 .01847 L
s
.73129 .01472 m
.73129 .01847 L
s
.7585 .01472 m
.7585 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.81293 .01472 m
.81293 .01847 L
s
.86735 .01472 m
.86735 .01847 L
s
.89456 .01472 m
.89456 .01847 L
s
.92177 .01472 m
.92177 .01847 L
s
.94898 .01472 m
.94898 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.12)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.14)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.16)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.18)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.2)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.15986 .01472 L
.29592 .01472 L
.43197 .01472 L
.56803 .01472 L
.70408 .01472 L
.84014 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 0.0147151 5.88604 [
[.15986 .00222 -3 -9 ]
[.15986 .00222 3 0 ]
[.29592 .00222 -3 -9 ]
[.29592 .00222 3 0 ]
[.43197 .00222 -3 -9 ]
[.43197 .00222 3 0 ]
[.56803 .00222 -3 -9 ]
[.56803 .00222 3 0 ]
[.70408 .00222 -3 -9 ]
[.70408 .00222 3 0 ]
[.84014 .00222 -3 -9 ]
[.84014 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .01472 m
.15986 .02097 L
s
[(2)] .15986 .00222 0 1 Mshowa
.29592 .01472 m
.29592 .02097 L
s
[(3)] .29592 .00222 0 1 Mshowa
.43197 .01472 m
.43197 .02097 L
s
[(4)] .43197 .00222 0 1 Mshowa
.56803 .01472 m
.56803 .02097 L
s
[(5)] .56803 .00222 0 1 Mshowa
.70408 .01472 m
.70408 .02097 L
s
[(6)] .70408 .00222 0 1 Mshowa
.84014 .01472 m
.84014 .02097 L
s
[(7)] .84014 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(8)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05102 .01472 m
.05102 .01847 L
s
.07823 .01472 m
.07823 .01847 L
s
.10544 .01472 m
.10544 .01847 L
s
.13265 .01472 m
.13265 .01847 L
s
.18707 .01472 m
.18707 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2415 .01472 m
.2415 .01847 L
s
.26871 .01472 m
.26871 .01847 L
s
.32313 .01472 m
.32313 .01847 L
s
.35034 .01472 m
.35034 .01847 L
s
.37755 .01472 m
.37755 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45918 .01472 m
.45918 .01847 L
s
.48639 .01472 m
.48639 .01847 L
s
.51361 .01472 m
.51361 .01847 L
s
.54082 .01472 m
.54082 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62245 .01472 m
.62245 .01847 L
s
.64966 .01472 m
.64966 .01847 L
s
.67687 .01472 m
.67687 .01847 L
s
.73129 .01472 m
.73129 .01847 L
s
.7585 .01472 m
.7585 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.81293 .01472 m
.81293 .01847 L
s
.86735 .01472 m
.86735 .01847 L
s
.89456 .01472 m
.89456 .01847 L
s
.92177 .01472 m
.92177 .01847 L
s
.94898 .01472 m
.94898 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.15986 .60332 L
.29592 .60332 L
.43197 .60332 L
.56803 .60332 L
.70408 .60332 L
.84014 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 -0.371191 0.97451 [
[.15986 .59082 -3 -9 ]
[.15986 .59082 3 0 ]
[.29592 .59082 -3 -9 ]
[.29592 .59082 3 0 ]
[.43197 .59082 -3 -9 ]
[.43197 .59082 3 0 ]
[.56803 .59082 -3 -9 ]
[.56803 .59082 3 0 ]
[.70408 .59082 -3 -9 ]
[.70408 .59082 3 0 ]
[.84014 .59082 -3 -9 ]
[.84014 .59082 3 0 ]
[.97619 .59082 -3 -9 ]
[.97619 .59082 3 0 ]
[.01131 .01861 -18 -4.5 ]
[.01131 .01861 0 4.5 ]
[.01131 .11606 -18 -4.5 ]
[.01131 .11606 0 4.5 ]
[.01131 .21352 -18 -4.5 ]
[.01131 .21352 0 4.5 ]
[.01131 .31097 -18 -4.5 ]
[.01131 .31097 0 4.5 ]
[.01131 .40842 -18 -4.5 ]
[.01131 .40842 0 4.5 ]
[.01131 .50587 -18 -4.5 ]
[.01131 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .60332 m
.15986 .60957 L
s
[(2)] .15986 .59082 0 1 Mshowa
.29592 .60332 m
.29592 .60957 L
s
[(3)] .29592 .59082 0 1 Mshowa
.43197 .60332 m
.43197 .60957 L
s
[(4)] .43197 .59082 0 1 Mshowa
.56803 .60332 m
.56803 .60957 L
s
[(5)] .56803 .59082 0 1 Mshowa
.70408 .60332 m
.70408 .60957 L
s
[(6)] .70408 .59082 0 1 Mshowa
.84014 .60332 m
.84014 .60957 L
s
[(7)] .84014 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(8)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.05102 .60332 m
.05102 .60707 L
s
.07823 .60332 m
.07823 .60707 L
s
.10544 .60332 m
.10544 .60707 L
s
.13265 .60332 m
.13265 .60707 L
s
.18707 .60332 m
.18707 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.2415 .60332 m
.2415 .60707 L
s
.26871 .60332 m
.26871 .60707 L
s
.32313 .60332 m
.32313 .60707 L
s
.35034 .60332 m
.35034 .60707 L
s
.37755 .60332 m
.37755 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45918 .60332 m
.45918 .60707 L
s
.48639 .60332 m
.48639 .60707 L
s
.51361 .60332 m
.51361 .60707 L
s
.54082 .60332 m
.54082 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.62245 .60332 m
.62245 .60707 L
s
.64966 .60332 m
.64966 .60707 L
s
.67687 .60332 m
.67687 .60707 L
s
.73129 .60332 m
.73129 .60707 L
s
.7585 .60332 m
.7585 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.81293 .60332 m
.81293 .60707 L
s
.86735 .60332 m
.86735 .60707 L
s
.89456 .60332 m
.89456 .60707 L
s
.92177 .60332 m
.92177 .60707 L
s
.94898 .60332 m
.94898 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .01861 m
.03006 .01861 L
s
[(0.4)] .01131 .01861 1 0 Mshowa
.02381 .11606 m
.03006 .11606 L
s
[(0.5)] .01131 .11606 1 0 Mshowa
.02381 .21352 m
.03006 .21352 L
s
[(0.6)] .01131 .21352 1 0 Mshowa
.02381 .31097 m
.03006 .31097 L
s
[(0.7)] .01131 .31097 1 0 Mshowa
.02381 .40842 m
.03006 .40842 L
s
[(0.8)] .01131 .40842 1 0 Mshowa
.02381 .50587 m
.03006 .50587 L
s
[(0.9)] .01131 .50587 1 0 Mshowa
.125 Mabswid
.02381 .0381 m
.02756 .0381 L
s
.02381 .05759 m
.02756 .05759 L
s
.02381 .07708 m
.02756 .07708 L
s
.02381 .09657 m
.02756 .09657 L
s
.02381 .13555 m
.02756 .13555 L
s
.02381 .15504 m
.02756 .15504 L
s
.02381 .17453 m
.02756 .17453 L
s
.02381 .19402 m
.02756 .19402 L
s
.02381 .23301 m
.02756 .23301 L
s
.02381 .2525 m
.02756 .2525 L
s
.02381 .27199 m
.02756 .27199 L
s
.02381 .29148 m
.02756 .29148 L
s
.02381 .33046 m
.02756 .33046 L
s
.02381 .34995 m
.02756 .34995 L
s
.02381 .36944 m
.02756 .36944 L
s
.02381 .38893 m
.02756 .38893 L
s
.02381 .42791 m
.02756 .42791 L
s
.02381 .4474 m
.02756 .4474 L
s
.02381 .46689 m
.02756 .46689 L
s
.02381 .48638 m
.02756 .48638 L
s
.02381 .52536 m
.02756 .52536 L
s
.02381 .54485 m
.02756 .54485 L
s
.02381 .56434 m
.02756 .56434 L
s
.02381 .58383 m
.02756 .58383 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.15986 .01472 L
.29592 .60332 L
.43197 .59357 L
.56803 .58393 L
.70408 .37738 L
.84014 .16404 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.112245 0.136054 0.0147151 5.88604 [
[.15986 .00222 -3 -9 ]
[.15986 .00222 3 0 ]
[.29592 .00222 -3 -9 ]
[.29592 .00222 3 0 ]
[.43197 .00222 -3 -9 ]
[.43197 .00222 3 0 ]
[.56803 .00222 -3 -9 ]
[.56803 .00222 3 0 ]
[.70408 .00222 -3 -9 ]
[.70408 .00222 3 0 ]
[.84014 .00222 -3 -9 ]
[.84014 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.01131 .13244 -24 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -24 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -24 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -24 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -18 -4.5 ]
[.01131 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15986 .01472 m
.15986 .02097 L
s
[(2)] .15986 .00222 0 1 Mshowa
.29592 .01472 m
.29592 .02097 L
s
[(3)] .29592 .00222 0 1 Mshowa
.43197 .01472 m
.43197 .02097 L
s
[(4)] .43197 .00222 0 1 Mshowa
.56803 .01472 m
.56803 .02097 L
s
[(5)] .56803 .00222 0 1 Mshowa
.70408 .01472 m
.70408 .02097 L
s
[(6)] .70408 .00222 0 1 Mshowa
.84014 .01472 m
.84014 .02097 L
s
[(7)] .84014 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(8)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05102 .01472 m
.05102 .01847 L
s
.07823 .01472 m
.07823 .01847 L
s
.10544 .01472 m
.10544 .01847 L
s
.13265 .01472 m
.13265 .01847 L
s
.18707 .01472 m
.18707 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2415 .01472 m
.2415 .01847 L
s
.26871 .01472 m
.26871 .01847 L
s
.32313 .01472 m
.32313 .01847 L
s
.35034 .01472 m
.35034 .01847 L
s
.37755 .01472 m
.37755 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45918 .01472 m
.45918 .01847 L
s
.48639 .01472 m
.48639 .01847 L
s
.51361 .01472 m
.51361 .01847 L
s
.54082 .01472 m
.54082 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62245 .01472 m
.62245 .01847 L
s
.64966 .01472 m
.64966 .01847 L
s
.67687 .01472 m
.67687 .01847 L
s
.73129 .01472 m
.73129 .01847 L
s
.7585 .01472 m
.7585 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.81293 .01472 m
.81293 .01847 L
s
.86735 .01472 m
.86735 .01847 L
s
.89456 .01472 m
.89456 .01847 L
s
.92177 .01472 m
.92177 .01847 L
s
.94898 .01472 m
.94898 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.02)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.04)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.06)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.08)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(0.1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.15986 .60332 L
.29592 .60332 L
.43197 .60332 L
.56803 .60332 L
.70408 .60332 L
.84014 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H002koi^KV1Ol00005onKViP?o
00001_oVi^H3o`0000Goi^KV0ol00005onKViP?o00001_oVi^H00ol0003oi^KVonKViP05onKViP?o
0000=?oVi^H5o`0000Coi^KV0ol00007onKViP?o00001?oVi^H3o`0000Koi^KV0ol00006onKViP03
o`000?oVi^Koi^KV00Coi^KV0ol0000DonKViP00;ooVi^H01?l0003oi^KVonKVi_l00004onKViP05
o`000?oVi^Koi^KVonKVi_l000001_oVi^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KV
onKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00?o0000onKVi_oVi^H01?oV
i^H01Ol0003oi^KVonKVi_oVi^Ko000003Coi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H00_oVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000Coi^KV00Go0000onKVi_oVi^Koi^KVo`000005onKViP03o`000?oVi^Koi^KV00?oi^KV00Go
0000onKVi_oVi^Koi^KVo`00000ConKViP00<?oVi^H00ol0003oi^KVonKViP08onKViP04o`000?oV
i^Koi^KVonKViPGo00002?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00?o0000onKVi_oV
i^H01?oVi^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_l00000=OoVi^H00ol0
003oi^KVonKViP07onKViP03o`000?oVi^Koi^KV00;oi^KV1Ol00007onKViP03o`000?oVi^Koi^KV
00;oi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP03o`000?oVi^Koi^KV00;oi^KV00Go0000
onKVi_oVi^Koi^KVo`00000ConKViP00<OoVi^H00ol0003oi^KVonKViP05onKViP;o00001?oVi^H0
1?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViPCo00001ooVi^H00ol0003oi^KV
onKViP04onKViP?o0000=ooVi^H00ol0003oi^KVonKViP04onKViP;o00001OoVi^H01?l0003oi^KV
onKVi_l00008onKViP03o`000?oVi^Koi^KV00;oi^KV1?l00007onKViP03o`000?oVi^Koi^KV00?o
i^KV0ol0000DonKViP00;_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Soi^KV00?o0000onKVi_oV
i^H00_oVi^H00ol0003oi^KVo`000005onKViPCo00001?oVi^H00ol0003oi^KVonKViP09onKViP03
o`000?oVi^Koi^KV00;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000conKViP05o`000?oVi^Koi^KV
onKVi_l000001ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Ko000000Coi^KV1?l00005
onKViP03o`000?oVi^Koi^KV00Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP03o`000?oV
i^Koi^KV017oi^KV000^onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000Goi^KV0_l00005onKViP03o`000?oVi^Koi^KV00Koi^KV00?o0000onKVi_oVi^H0
1?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00Go0000onKVi_oVi^Koi^KVo`00000conKV
iP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV0_l0
0004onKViP03o`000?oVi^Koi^KV00Ooi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KVo`00000ConKViP00;ooVi^H3o`0000Koi^KV
0ol00007onKViP03o`000?oVi^Koi^KV00?oi^KV1Ol00005onKViP;o00001?oVi^H5o`0000Goi^KV
0ol0000eonKViP?o00001OoVi^H3o`0000Soi^KV00?o0000onKVi_oVi^H00_oVi^H5o`0000Koi^KV
0_l00004onKViPGo00001?oVi^H3o`0001Coi^KV003SonKViP00:OoVi^H00ol0003oi^KVonKViP1W
onKViP03o`000?oVi^Koi^KV04goi^KV000WonKViP;o000000?o/k>co`000?l00000>_l0000/onKV
iSoo00004_oVi^H002Woi^KV00?o/k>conKVi_oVi^H0IooVi^H00ol0003oi^KVonKViP1=onKViP00
:OoVi^H00onc/k?oi^KVonKViP1WonKViP;o0000C_oVi^H002Woi^KV00?o0000ok>c/ooVi^H0IooV
i^H2o`0004koi^KV000YonKViP03o`000?nc/k?oi^KV06Ooi^KV00?o0000onKVi_oVi^H0COoVi^H0
01;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00002onKViPGo00000_oVi^H00ol0
003o/k>conKViP1WonKViP;o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0
003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000ok>c/ooVi^H0DOoV
i^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol00002onKViP03o`000?oV
i^Koi^KV04goi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
0ooVi^H00ol0003oi^KVonKViP02onKViP03o`000?nc/k?oi^KV053oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_l0003o0000C_oV
i^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP07o`00
0?oVi^Koi^KVonKVi_l0003oi^KVok>c/`1@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00001OoVi^H00ol0003oi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01_l0003oi^KVonKVi_l0003oi^KV
ok>c/e3oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00005onKViP04o`00
0?oVi^Ko0000o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oV
i^Ko0000onKVi_l00003onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko/k>cD?oVi^H01?l0003oi^KV
onKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l00002onKViP03o`000?oVi^Koi^KV
04goi^KV000BonKViP;o00002_oVi^H2o`0000?oi^KV0ol00003onKViP03o`000?oVi^Ko/k>c053o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Goi^KV0_l0
001>onKViP004_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000Coi^KV0ol00002
onKViP04o`000?oVi^Koi^KVok>c/e3oi^KV0_l0000:onKViP;o00000_oVi^H5o`000003onKVi_l0
003oi^KV04koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
1?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o/k>conKVi_oVi^H0I?oVi^H2o`0004ko
i^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP05o`00
00;oi^KV00Co0000onKVi_oVi^Ko/k>cI_oVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP05o`000?oVi^Koi^KVonKVi_l0
00000_oVi^H00onc/k?oi^KVonKViP1DonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o
00000_oVi^H00ol0003oi^KVonKViP1=onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_nc/k=E
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l0001>onKViP004OoV
i^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l00003onKViP05
o`000?oVi^Koi^KVonKVi_nc/k<0E?oVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Ko
i^KVonKVi_l00000CooVi^H001;oi^KV0_l0000:onKViP;o00001OoVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000?oi^KV00?o/k>conKVi_oVi^H0D_oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`00
0?oVi^Koi^KVonKViScoc<c<5?oVi^H001;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV
0_l00003onKViP?o00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko/k>c05Coi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000004ooi^KV000AonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000?o
i^KV00?o/k>conKVi_oVi^H0D_oVi^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooVi^H2o`00
04koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0003onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?o/k>conKVi_oVi^H0D_oVi^H2o`0000[oi^KV
00Go0000onKVi_oVi^Koi^KVo`00001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP05
o`000?oVi^Koi^KVo`000?oVi^H01?l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00?o/k>conKV
i_oVi^H0H_oVi^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKV
i_oVi^Ko0000onKVi_l00006onKViP03o`000?oVi^Koi^KV00;oi^KV00?o/k>conKVi_oVi^H0H_oV
i^H2o`0004koi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00;oi^KV00?o/k>conKVi_oVi^H0
H_oVi^H00ol0003oi^KVonKViP1=onKViP004_oVi^H2o`0000[oi^KV0_l00004onKViP;o00000ooV
i^H00ol0003oi^KVonKViP02onKViP03ok>c/ooVi^Koi^KV04coi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00;oi^KV0ol00003onKViP?o00000_oVi^H2o`0004koi^KV000BonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0onc/k?oi^KVonKViP1:onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KV
o`000003onKViP03o`000?oVi^Ko000004ooi^KV000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00?o/k>c
onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00Goi^KV00Co
0000onKVi_l0003o0000C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KV
onKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H00onc/k?oi^KVonKViP1:
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0003oi^KVo`00
001?onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
0ol00003onKViP03o`000?oVi^Koi^KV00?oi^KV00?o/k>conKVi_oVi^H0B_oVi^H01?l0003oi^KV
onKVi_l00009onKViP04o`000?oVi^Koi^KVonKViPCo00000_oVi^H2o`0004koi^KV000AonKViP04
o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oV
i^Koi^KVo`0000Koi^KV00?o/k>conKVi_oVi^H0BOoVi^H01?l0003oi^KVonKVi_l00008onKViP;o
00000ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV04goi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko
i^KVo`0000Koi^KV00?o/k>conKVi_oVi^H0B_oVi^H2o`0000[oi^KV00Co0000onKVi_oVi^Koi^KV
1Ol000000ooVi^Ko0000o`00001>onKViP004_oVi^H2o`0000[oi^KV0_l00003onKViP?o00000ooV
i^H00ol0003oi^KVonKViP04onKViP03ok>c/ooVi^Koi^KV063oi^KV00?o0000onKVi_oVi^H0COoV
i^H002Woi^KV00?o0000onKVi_oVi^H01?oVi^H00onc/k?oi^KVonKViP1PonKViP;o0000C_oVi^H0
01Soi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Koi^KV
00Coi^KV00?o/k>conKVi_oVi^H0D?oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol00000
0ooVi^Ko0000o`00001>onKViP005ooVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Ko
i^KV00;oi^KV00?o0000onKVi_oVi^H01OoVi^H00onc/k?oi^KVonKViP1>onKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0001?onKViP005ooVi^H01?l0003oi^KV
onKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H01OoVi^Hdok>c/ago
i^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0004koi^KV000GonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP1F
onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Co0000onKVi_oVi^Ko0000CooVi^H001Ooi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP1KonKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`00001AonKViP005ooVi^H01?l0003oi^KVonKVi_l00008onKV
iP;o0000GOoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l00000DOoV
i^H001Soi^KV0_l0000:onKViP03o`000?oVi^Koi^KV05coi^KV0_l00009onKViP?o0000D_oVi^H0
0>?oi^KV000gonKViP?o00000_oVi^H6o`000004onKVi_l0003o0000o`0000?oi^KV0ol00002onKV
iP03o`000?oVi^Ko000000;o0000COoVi^H3o`0000;oi^KV0ol000000ooVi^Ko0000o`000003o`00
00;oi^KV1_l000001ooVi^Ko0000o`000?l0003oi^KVo`000?oVi^H00ol000000ooVi^Ko0000o`00
000PonKViP00>?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?o0000onKVi_oVi^H00ooVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKV
i_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co
0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00Co0000onKVi_oVi^Ko00008OoVi^H003Soi^KV00?o0000onKVi_l000000ooVi^H00ol0003o
i^KVonKViP03onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_l000000_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000004ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0
003oi^KVo`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVo`000?l00002onKViP03
o`000?oVi^Ko000002;oi^KV000honKViP?o00000ooVi^H3o`0000?oi^KV0ol00003onKViP?o0000
0_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004goi^KV0_l00003onKViPCo00000_oVi^H3o`0000Co
i^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVo`000?l00002onKViP;o00008ooVi^H003So
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03o`000?oVi^Koi^KV04[oi^KV
00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`00
00?oi^KV00?o0000onKVi_oVi^H00_oVi^H2o`000007onKVi_l0003oi^KVonKVi_l0003oi^KVo`00
000RonKViP00>?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000
onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP;o000000Goi^KVo`000?oV
i^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV01ooi^KV000gonKViPCo00000_oVi^H5o`000003
onKVi_l0003o000000;o00000_oVi^H4o`0000?oi^KV0ol0001>onKViP?o000000Goi^KVo`000?l0
003o0000onKViP06o`0000;oi^KV1Ol000001?oVi^Ko0000o`000?oVi^H6o`000003onKVi_l0003o
0000023oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00
hooVi^H009Koi^KV1Ol00004onKViP?o00001ooVi^H3o`0000Coi^KV0ol00006onKViP?o00001_oV
i^H00ol0003oi^KVonKViP04onKViP?o00005ooVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Ko
i^KV00?oi^KV0ol0001gonKViP04o`000?oVi^Koi^KVo`0000?oi^KV00Go0000onKVi_oVi^Koi^KV
o`000007onKViP03o`000?oVi^Koi^KV00;oi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP05
o`000?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KV
onKVi_l000005_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000007Goi^KV00?o0000onKVi_oVi^H01ooVi^H00ol0003oi^KVonKViP02onKViPGo00001ooV
i^H00ol0003oi^KVonKViP02onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H00ol0003oi^KV
onKViP02onKViP05o`000?oVi^Koi^KVonKVi_l000005_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H5o`0000;oi^KV00?oOgmoonKVi_oVi^H0M?oVi^H00ol0003oi^KVonKViP04onKViP;o
00001OoVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Koi^KV00;oi^KV1?l00007onKV
iP03o`000?oVi^Koi^KV00?oi^KV0ol0000GonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKV
iP04o`000?oVi^Koi^KVo`0000?oi^KV00?oOgmoonKVi_oVi^H0LOoVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Ooi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVo`000004onKViPCo00001OoV
i^H00ol0003oi^KVonKViP09onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H00ol0003oi^KV
onKViP0DonKViP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Ko000000?oi^KV
00?oOgmoonKVi_oVi^H0LOoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Go0000onKVi_oV
i^Koi^KVo`000006onKViP;o00001?oVi^H00ol0003oi^KVonKViP07onKViP03o`000?oVi^Koi^KV
00Coi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP05o`000?oVi^Koi^KVonKVi_l000005_oV
i^H0013oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000?oi^KV00?o0000ogmoOooVi^H0L_oV
i^H3o`0000Goi^KV0ol00008onKViP03o`000?oVi^Koi^KV00;oi^KV1Ol00006onKViP;o00001?oV
i^H5o`0000Coi^KV0ol0000GonKViP004OoVi^H2o`0000_oi^KV00Ko0000onKVi_oVi^Koi^KVo`00
0?moOgnoonKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o
0000ogmoOooVi^H0JooVi^H00ol0003oi^KVonKViP1@onKViP004?oVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oOgmoonKViP1ZonKViSCo0000
2OnIVIT2o`0001Goi^KV000@onKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Go0000onKVi_oVi^Ko
0000ogmoO`1/onKViP;o0000<OoVi^H00onIVIWoi^KVonKViP0MonKViP004?oVi^H01?l0003oi^KV
onKVi_l0000;onKViP06o`000?oVi^Koi^KVo`000?oVi^KoOgmoJooVi^H2o`00037oi^KV00?oVIVI
onKVi_oVi^H07OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00?o0000
onKVi_moOgl0JooVi^H00ol0003oi^KVonKViP0_onKViP03oiVIVOoVi^Koi^KV01koi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVogmoO`1K
onKViP;o00001?oVi^H01?l0003oi^KVonKVi_oVi^H5o`000003onKVi_l0003o0000033oi^KV00?o
VIVIonKVi_oVi^H07_oVi^H0017oi^KV0_l00008onKViPGo00000_oVi^H00ol0003oi^KVogmoO`1J
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP02o`00033oi^KV
00?oVIVIonKVi_oVi^H07_oVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol0
0003onKViP03o`000?oVi^KoOgmo05[oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko0000037oi^KV00?oVIVIonKVi_oVi^H07_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Co0000onKVi_oVi^KoOgmoFOoVi^H0
1?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVoiVIVOl00000;ooVi^H00onIVIWoi^KV
onKViP0OonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l0
00000_oVi^H01?l0003oi^KVonKVi_moOgmIonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00So0000
onKVi_oVi^Koi^KVo`000?oVi^KoVIVIo`0002ooi^KV00?oVIVIonKVi_oVi^H07ooVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000?oi^KV00Co0000onKVi_oVi^KoOgmoFOoVi^H01?l0
003oi^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVoiVIV@0`onKViP03oiVI
VOoVi^Koi^KV01ooi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000onKVi_oVi^H0
1?oVi^H01?l0003oi^KVonKVi_moOgmJonKViP;o00002OoVi^H3o`0000;oi^KV00?o0000oiVIVOoV
i^H0;_oVi^H00onIVIWoi^KVonKViP0OonKViP004?oVi^H01?l0003oi^KVonKVi_l00008onKViP03
o`000?oVi^Koi^KV00?oi^KV00Go0000onKVi_oVi^Koi^KVogmoO`1IonKViP;o00001?oVi^H00ol0
003oi^KVonKViP02onKViP?o00000_oVi^H00ol0003oVIVIonKViP0^onKViP03oiVIVOoVi^Koi^KV
01ooi^KV000AonKViP;o00002_oVi^H2o`0000?oi^KV00Go0000onKVi_oVi^Koi^KVogmoO`1HonKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00So0000onKVi_oVi^Koi^KVo`000?oVi^Ko0000oiVIVBko
i^KV00?oVIVIonKVi_oVi^H08?oVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV
00?o0000onKVi_oVi^H00_oVi^H01Ol0003oi^KVonKVi_oVi^KoOgmo05Soi^KV00Co0000onKVi_oV
i^Ko00002ooVi^H01Ol0003oi^KVo`000?oVi^KoVIVI02goi^KV00?oVIVIonKVi_oVi^H08?oVi^H0
013oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP05o`000?oVi^Ko
i^KVonKVi_moOgl0F?oVi^H01?l0003oi^KVonKVi_l00009onKViP;o00000_oVi^H2o`000003oiVI
VOoVi^Koi^KV02_oi^KV00?oVIVIonKVi_oVi^H08?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko0000
2_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00?oOgmoonKVi_oVi^H0E_oVi^H01?l0003o
i^KVonKVi_l0000;onKViP05o`000?oVi^Ko0000o`000?nIVIT0;OoVi^H00onIVIWoi^KVonKViP0P
onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000001?oV
i^H00omoOgooi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Oo0000onKVi_oVi^Ko
i^KVo`000?oVi^Ko000000;oi^KV00?oVIVIonKVi_oVi^H0:OoVi^H00onIVIWoi^KVonKViP0QonKV
iP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?oOgmo
onKVi_oVi^H0E_oVi^H2o`0000Woi^KV0ol00002onKViP;o000000?oi^KVoiVIVOoVi^H0:_oVi^H0
0onIVIWoi^KVonKViP0QonKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP02onKViP03ogmoOooVi^Koi^KV06Koi^KV0_l0
00000ooVi^KoVIVIonKViP0ZonKViP03oiVIVOoVi^Koi^KV027oi^KV000AonKViP;o00002?oVi^H5
o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00omoOgooi^KVonKViP0aonKViP_oOgmo6_oVi^H2
o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H3o`000003onKVi_l0003oi^KV00;oi^KV00?oVIVI
onKVi_oVi^H0:?oVi^H00onIVIWoi^KVonKViP0QonKViP004OoVi^H2o`0000Coi^KV00?o0000onKV
i_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H00omoOgooi^KVonKViP0aonKV
iP03ogmoOooVi^Koi^KV027oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H00ol0003oi^KVonKViP02
o`0000;oi^KV00?oVIVIonKVi_oVi^H09ooVi^H00onIVIWoi^KVonKViP0RonKViP004?oVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKV
iP03onKViP03ogmoOooVi^Koi^KV02ooi^KV00?oOgmoonKVi_oVi^H08_oVi^H01?l0003oi^KVonKV
i_l00007onKViPGo000000?oi^KVo`000?l000000_oVi^H00onIVIWoi^KVonKViP0WonKViP03oiVI
VOoVi^Koi^KV02;oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Ko
i^KVo`000002onKViP03o`000?oVi^Koi^KV00?oi^KV00?oOgmoonKVi_oVi^H0;_oVi^H00omoOgoo
i^KVonKViP0SonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H2
o`0000?oi^KV00?oVIVIonKVi_oVi^H09_oVi^H00onIVIWoi^KVonKViP0RonKViP004?oVi^H01?l0
003oi^KVonKVi_l00008onKViP?o00000ooVi^H00ol0003oi^KVonKViP03onKViP03ogmoOooVi^Ko
i^KV02koi^KV00?oOgmoonKVi_oVi^H08ooVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oV
i^Ko000000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00onIVIWoi^KVonKViP0VonKViP03oiVIVOoV
i^Koi^KV02;oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KV
o`000002onKViP03o`000?oVi^Koi^KV00?oi^KV00?oOgmoonKVi_oVi^H0;OoVi^H00omoOgooi^KV
onKViP0TonKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00002onKViP;o00000ooVi^H00onIVIWo
i^KVonKViP0UonKViP03oiVIVOoVi^Koi^KV02?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00Coi^KV00?oOgmoonKV
i_oVi^H0;?oVi^H00omoOgooi^KVonKViP0UonKViP;o00002ooVi^H00ol0003oi^KVonKViP02o`00
00?oi^KV00?oVIVIonKVi_oVi^H09OoVi^H00onIVIWoi^KVonKViP0SonKViP004OoVi^H2o`0000Co
i^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H01?oVi^H00omoOgoo
i^KVonKViP0[onKViP03ogmoOooVi^Koi^KV02Koi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;o
i^KV0ol00002onKViP03o`000?oVi^Koi^KV00?oi^KV00?oVIVIonKVi_oVi^H09?oVi^H00onIVIWo
i^KVonKViP0SonKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKV
i_l000001OoVi^H00ol0003oOgmoo`000002o`0000Koi^KV0ol00008onKViP?o00001OoVi^H3o`00
00Ooi^KV0ol00003onKViP05ogmoOooVi^Koi^KVonKVi_l000002?oVi^H3o`0001Woi^KV00Co0000
onKVi_oVi^Ko00001ooVi^H01_l0003oi^KVonKVi_oVi^Ko0000onKViP;o00001?oVi^H00onIVIWo
i^KVonKViP0TonKViP03oiVIVOoVi^Koi^KV02?oi^KV000@onKViP04o`000?oVi^Koi^KVo`0000_o
i^KV00Co0000onKVi_oVi^Ko00001_oVi^H01?moOgooi^KVonKVi_l00005onKViP05o`000?oVi^Ko
i^KVonKVi_l000002?oVi^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_l00000
1OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00GoOgmoonKVi_oVi^Koi^KVo`000007onKV
iP05o`000?oVi^Koi^KVonKVi_l000006?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oV
i^Ko0000o`0000Coi^KV00?oVIVIonKVi_oVi^H09?oVi^H00onIVIWoi^KVonKViP0SonKViP004?oV
i^H01?l0003oi^KVonKVi_l00008onKViPCo00000_oVi^H00ol0003oi^KVonKViP04onKViP03ogmo
Ool0003oi^KV00[oi^KV00?o0000onKVi_oVi^H00ooVi^H5o`0000Soi^KV00?o0000onKVi_oVi^H0
0ooVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_moOgl01OoVi^H00ol0003oi^KVonKViP04onKV
iP05o`000?oVi^Koi^KVonKVi_l000006?oVi^H01?l0003oi^KVonKVi_l0000;onKViP03o`000?oV
i^Ko000000Koi^KV00?oVIVIonKVi_oVi^H08_oVi^H00onIVIWoi^KVonKViP0TonKViP004?oVi^H0
1?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KV
onKViP05onKViP03ogmoOol0003oi^KV00Ooi^KV0_l00006onKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00?o0000onKVi_oVi^H00ooVi^H4o`0000;oi^KV00?oOgmoonKVi_oVi^H00ooVi^H00ol0003o
i^KVonKViP05onKViP?o00006OoVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000_oVi^H2o`00
00Goi^KV00?oVIVIonKVi_oVi^H08_oVi^H00onIVIWoi^KVonKViP0TonKViP004?oVi^H01?l0003o
i^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP03
onKViP05o`000?oVi^KoOgmoonKVi_l000002OoVi^H00ol0003oi^KVonKViP04onKViP03o`000?oV
i^Ko000000Goi^KV1?l00006onKViP03o`000?oVi^Koi^KV00;oi^KV00?oOgmoonKVi_oVi^H01OoV
i^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_l000006?oVi^H01?l0003oi^KV
onKVi_l00007onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00005onKViP03oiVIVOoVi^Koi^KV02;o
i^KV00?oVIVIonKVi_oVi^H09?oVi^H0017oi^KV0_l00009onKViP?o00000ooVi^H00ol0003oi^KV
onKViP03onKViP05o`000?oVi^KoOgmoonKVi_l000001OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00Ooi^KV0_l00005onKViP03o`000?oVi^Koi^KV00Soi^KV00Co0000onKVi_oVi^KoOgmo1?oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Go0000onKVi_oVi^Koi^KVo`00000IonKViP;o0000
2?oVi^H5o`000003onKVi_l0003o000000Koi^KV00?oVIVIonKVi_oVi^H08OoVi^H00onIVIWoi^KV
onKViP0TonKViP008_oVi^H00ol0003oi^KVonKViP04onKViP03o`000?moOgoo000000Ooi^KV0ol0
0009onKViP03o`000?oVi^Koi^KV00?oi^KV1Ol00007onKViP;o000000?oOgmoonKVi_oVi^H00_oV
i^H5o`0000Koi^KV0ol0000JonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oV
i^H00ol0003oi^KVonKViP05onKViP03oiVIVOoVi^Koi^KV023oi^KV00?oVIVIonKVi_oVi^H09OoV
i^H002;oi^KV00?o0000onKVi_oVi^H01OoVi^H00omoOgooi^KVonKViP0GonKViPooOgmo;?oVi^H0
1?l0003oi^KVonKVi_l00007onKViP06o`000?oVi^Koi^KVonKVi_l0003oi^KV0_l00006onKViP03
oiVIVOoVi^Koi^KV01coi^KV1OnIVITWonKViP008_oVi^H00ol0003oi^KVonKViP06onKViP03ogmo
OooVi^Koi^KV00coi^KV2_moOglkonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Ko0000onKVi_oV
i^Koi^KVo`000?oVi^H2o`0000Ooi^KV00?oVIVIonKVi_oVi^H02_oVi^HAoiVIVBcoi^KV000PonKV
iP_o00003omoOgl^o`0001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000;oi^KV00?o0000
onKVi_oVi^H01_oVi^H=oiVIVCgoi^KV000RonKViP03o`000?oVi^Koi^KV05[oi^KV00Co0000onKV
i_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP03onKViP;o0000DOoVi^H007ooi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP1EonKViP00P?oVi^H2o`0000[oi^KV0_l0001EonKV
iP00hooVi^H00>?oi^KV000eonKViP;o000000Coi^KVo`000?l0003o00000_oVi^H2o`0000?oi^KV
0ol00002onKViP;o000000Goi^KVo`000?l0003o0000onKViP03o`00057oi^KV0ol00003onKViPGo
000000Coi^KVo`000?l0003o00000_oVi^H3o`000004onKVi_l0003o0000o`0002Woi^KV000eonKV
iP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKViP05o`000?oV
i^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000005?oi^KV00?o0000onKVi_oV
i^H00ooVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H00ol0003oi^KVonKViP0XonKViP00=OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Co
0000onKVi_oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_oVi^H5o`0000?oi^KV00?o0000onKVi_oV
i^H0DOoVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_l0
00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000002[oi^KV000eonKViP05o`000?oVi^Koi^KVonKV
i_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000
onKVi_l000001?oVi^H00ol0003oi^KVonKViP1AonKViP?o00000ooVi^H3o`0000?oi^KV0ol00002
onKViP05o`000?oVi^Koi^KVonKVi_l00000:_oVi^H003Goi^KV00Go0000onKVi_l0003oi^KVo`00
0002onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_l0003oi^KVo`0000;oi^KV00?o0000
onKVi_l000000_oVi^H01Ol0003oi^KVo`000?oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP03onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_l0003o
i^KVo`0002[oi^KV000eonKViP;o000000?oi^KVo`000?l000000_oVi^H02_l0003oi^KVonKVi_l0
003oi^KVo`000?oVi^Ko0000onKVi_l00003onKViP09o`000?oVi^Koi^KVonKVi_l0003oi^KVo`00
0?oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKV
iP05o`000?oVi^Koi^KVo`000?oVi^H00_l000000ooVi^Ko0000o`00000ZonKViP00=OoVi^H01?l0
003oi^KVonKVi_oVi^H5o`000003onKVi_l0003o000000Go00000_oVi^H2o`0000?oi^KV1Ol0001@
onKViPCo00000_oVi^H5o`000003onKVi_l0003o000000;o00000_oVi^H01?l0003oi^KVonKVi_oV
i^H2o`0002Woi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKV
iP00hooVi^H002koi^KV1Ol00005onKViP?o00001_oVi^H3o`0000Goi^KV0ol00005onKViP?o0000
1_oVi^H00ol0003oi^KVonKViP05onKViP?o0000=?oVi^H5o`0000Coi^KV0ol00007onKViP?o0000
1?oVi^H3o`0000Koi^KV0ol00006onKViP03o`000?oVi^Koi^KV00Coi^KV0ol0000DonKViP00;ooV
i^H01?l0003oi^KVonKVi_l00004onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H00ol0003o
i^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000Goi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000003Coi^KV00Co
0000onKVi_oVi^Ko00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oV
i^H00_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00Go0000onKVi_oVi^Koi^KVo`000005
onKViP03o`000?oVi^Koi^KV00?oi^KV00Go0000onKVi_oVi^Koi^KVo`00000ConKViP00<?oVi^H0
0ol0003oi^KVonKViP08onKViP04o`000?oVi^Koi^KVonKViPGo00002?oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP03onKViP05o`00
0?oVi^Koi^KVonKVi_l00000=OoVi^H00ol0003oi^KVonKViP07onKViP03o`000?oVi^Koi^KV00;o
i^KV1Ol00007onKViP03o`000?oVi^Koi^KV00;oi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKV
iP03o`000?oVi^Koi^KV00;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000ConKViP00<OoVi^H00ol0
003oi^KVonKViP05onKViP;o00001?oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Ko
i^KVonKViPCo00001ooVi^H00ol0003oi^KVonKViP04onKViP?o0000=ooVi^H00ol0003oi^KVonKV
iP04onKViP;o00001OoVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?oVi^Koi^KV00;oi^KV
1?l00007onKViP03o`000?oVi^Koi^KV00?oi^KV0ol0000DonKViP00;_oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000Soi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVo`000005onKViPCo0000
1?oVi^H00ol0003oi^KVonKViP09onKViP03o`000?oVi^Koi^KV00;oi^KV00Go0000onKVi_oVi^Ko
i^KVo`00000conKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP03onKV
iP03o`000?oVi^Ko000000Coi^KV1?l00005onKViP03o`000?oVi^Koi^KV00Woi^KV00Go0000onKV
i_oVi^Koi^KVo`000003onKViP03o`000?oVi^Koi^KV017oi^KV000^onKViP05o`000?oVi^Koi^KV
onKVi_l000001?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV0_l00005onKViP03o`000?oV
i^Koi^KV00Koi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV
00Go0000onKVi_oVi^Koi^KVo`00000conKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000Koi^KV0_l00004onKViP03o`000?oVi^Koi^KV00Ooi^KV00?o0000
onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KV
o`00000ConKViP00;ooVi^H3o`0000Koi^KV0ol00007onKViP03o`000?oVi^Koi^KV00?oi^KV1Ol0
0005onKViP;o00001?oVi^H5o`0000Goi^KV0ol0000eonKViP?o00001OoVi^H3o`0000Soi^KV00?o
0000onKVi_oVi^H00_oVi^H5o`0000Koi^KV0_l00004onKViPGo00001?oVi^H3o`0001Coi^KV003S
onKViP009ooVi^H:o`0003CoC4a<00?o0000onKVi_oVi^H0:_oVi^H00ol0003oIVIVo`00000lo`00
01;oi^KV000YonKViP0<o`000?oVi^Ko0000o`000?oVi^Ko0000onKVi_l0003oC4a<onKVi_l0003o
i^KV0_l000000ooVi^Ko0000onKViP02o`000003onKVi_l0003oi^KV00;o000000Goi^KVo`000?oV
i^Ko0000onKViP02o`000003onKVi_l0003oi^KV00;o000000?oi^KVo`000?oVi^H00_l000000ooV
i^Ko0000onKViP02o`000003onKVi_l0003oi^KV00;o000000?oi^KVo`000?oVi^H00_l000001?oV
i^Ko0000onKVi_l0000^onKViP06ofIVI_oVi^Ko0000onKVi_l0003oi^KV0_l000000ooVi^Ko0000
onKViP02o`000003onKVi_l0003oi^KV00;o000000?oi^KVo`000?oVi^H00_l000000ooVi^Ko0000
onKViP02o`000003onKVi_l0003oi^KV00;o000000?oi^KVo`000?oVi^H00_l000001OoVi^Ko0000
onKVi_l0003oi^KV00;o000000?oi^KVo`000?oVi^H00_l000000ooVi^Ko0000onKViP02o`000003
onKVi_l0003oi^KV00;o00005?oVi^H002Woi^KV00?o0000onKVi_oVi^H01OoVi^H00om<C4coi^KV
onKViP1OonKViP03ofIVI_l0003oi^KV04goi^KV000YonKViP03o`000?oVi^Koi^KV00Coi^KV00?o
C4a<onKVi_oVi^H0H?oVi^H00ol0003oIVIVonKViP1=onKViP00:OoVi^H00ol0003oi^KVonKViP04
onKViP03oda<C?oVi^Koi^KV063oi^KV00?o0000ofIVI_oVi^H0COoVi^H001;oi^KV0_l00004onKV
iP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViPGo00000_oVi^H00ol0003oi^KVonKViP04onKV
iP03oda<C?oVi^Koi^KV04[oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00002onKV
iPGo000000?oi^KVo`000?mVIVH0C_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0
003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H01?oVi^H0
0om<C4coi^KVonKViP19onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01ol0003oi^KVonKVi_l0003oi^KVo`000?mVIVH0C_oVi^H0017oi^KV00Co0000onKVi_oV
i^Ko00002OoVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKV
i_oVi^H01?oVi^H00om<C4coi^KVonKViP19onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00000ooVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_mVIVH0COoVi^H0017oi^KV
00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKV
i_l000001OoVi^H00om<C4coi^KVonKViP1:onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00001?oVi^H00ol0003oi^KVonKViP02o`000003ofIVI_oVi^Koi^KV04_oi^KV000A
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`00
0?oVi^Koi^KVo`0000Goi^KV00?oC4a<onKVi_oVi^H0B_oVi^H01?l0003oi^KVonKVi_l00008onKV
iP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01Ol0003oi^KVo`000?oVi^KoIVIV04goi^KV
000AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00003onKViP05o`000?oVi^Koi^KVonKVi_l0
00000_oVi^H00ol0003oi^KVonKViP03onKViP03oda<C?oVi^Koi^KV04[oi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Go0000onKVi_l0003o0000
ofIVIP1=onKViP004_oVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o
0000onKVi_oVi^H00ooVi^H00om<C4coi^KVonKViP1;onKViP;o00002_oVi^H2o`0000?oi^KV0ol0
0002onKViP;o000000?oi^KVofIVI_oVi^H0BooVi^H002Woi^KV00?o0000onKVi_oVi^H00ooVi^H0
0om<C4coi^KVonKViP1QonKViP04o`000?oVi^Koi^KVofIVITcoi^KV000BonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP02onKViP?o00001?oVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H0
0om<C4coi^KVonKViP1<onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00001?oVi^H3
o`000005onKVi_l0003o0000onKVi_mVIVH0C?oVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoV
i^H00ol0003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H00om<C4coi^KV
onKViP1;onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001?oVi^H01?l0
003oi^KVonKVi_l00002onKViP03ofIVI_oVi^Koi^KV04[oi^KV000AonKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o
C4a<onKVi_oVi^H0BooVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oV
i^H01Ol000000ooVi^Ko0000o`000002onKViP03ofIVI_oVi^Koi^KV04Woi^KV000AonKViP04o`00
0?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KV
onKVi_l000001?oVi^H00om<C4coi^KVonKViP1;onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?oIVIVonKV
i_oVi^H0BOoVi^H0017oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKV
iP03o`000?oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KVoda<C01>onKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVo`000002onKViP;o0000
0_oVi^H00omVIVKoi^KVonKViP19onKViP004OoVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000
1OoVi^H2o`0000?oi^KV00Go0000onKVi_oVi^Koi^KVoda<C01>onKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H2o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVofIV
IP1;onKViP004_oVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000?oi^KV00?oC4a<onKVi_oVi^H0COoVi^H2o`0000[oi^KV0_l00005onKViP03o`000?oV
i^Koi^KV00;o00000ooVi^H00omVIVKoi^KVonKViP18onKViP004_oVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00_oVi^H3o`0000?oi^KV0ol00003onKViP05o`000?oVi^Koi^KVonKVi_m<C4`0CooV
i^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol00002onKViP;o00000ooV
i^H00omVIVKoi^KVonKViP18onKViP004OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oV
i^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00003onKViP03oda<C?oVi^Koi^KV04co
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o
0000onKVi_l000001?oVi^H00omVIVKoi^KVonKViP18onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00002onKViP03
oda<C?oVi^Koi^KV04goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003o
i^KVo`0000?oi^KV00Co0000onKVi_l0003o00000ooVi^H00omVIVKoi^KVonKViP18onKViP004OoV
i^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViPCo00000ooVi^H01?l0003o
i^KVonKVi_m<C4a?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKV
iP04o`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00omVIVKoi^KVonKViP18onKViP004OoVi^H0
1?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H01?l0003oi^KV
onKVi_m<C4a?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0005onKViP;o00001?oVi^H00omVIVKoi^KVonKViP17onKViP004OoVi^H01?l0003oi^KVonKVi_l0
0008onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP04o`000?oVi^Koi^KVoda<C4ooi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV
00;oi^KV00?o0000onKVi_oVi^H00ooVi^H00omVIVKoi^KVonKViP17onKViP004_oVi^H2o`0000[o
i^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV00?o0000onKVi_m<C4`0DOoVi^H2o`0000[o
i^KV0_l00004onKViP;o00000_oVi^H2o`0000Coi^KV00?oIVIVonKVi_oVi^H0AooVi^H001;oi^KV
0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP?o00000ooVi^H00ol0003oi^KV
oda<C01AonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV
00?o0000onKVi_oVi^H00ooVi^H00omVIVKoi^KVonKViP17onKViP004OoVi^H01?l0003oi^KVonKV
i_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01_l0003oi^KVonKVi_l0003oi^KV
oda<C53oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?o
i^KV00Co0000onKVi_l0003o00001OoVi^H00omVIVKoi^KVonKViP16onKViP004OoVi^H01?l0003o
i^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01_l0003oi^KVonKVi_l0
003oi^KVoda<C53oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000?oi^KV00?o0000onKVi_l000001_oVi^H00omVIVKoi^KVonKViP16onKViP004OoVi^H01?l0
003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`000?oVi^Ko
C4a<053oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o0000
0_oVi^H2o`0000Goi^KV00?oIVIVonKVi_oVi^H0A_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko0000
2OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Ko0000oda<C01AonKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`00
0?oVi^Ko0000o`0000Goi^KV00?oIVIVonKVi_oVi^H0A_oVi^H0017oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H2o`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?m<C4coi^KV
053oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV
00?o0000onKVi_l000001ooVi^H00omVIVKoi^KVonKViP15onKViP004_oVi^H2o`0000[oi^KV00?o
0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000oda<C?oVi^H0DOoVi^H2o`0000[oi^KV0_l0
0003onKViP?o00000_oVi^H2o`0000Koi^KV00?oIVIVonKVi_oVi^H0AOoVi^H001Soi^KV0_l00004
onKViP04o`000?oVi^Koi^KVonKViPGo00000_oVi^H00ol0003oC4a<onKViP1GonKViP;o00001?oV
i^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H00ol0003oi^KVonKViP05onKViP03ofIVI_oV
i^Koi^KV04Goi^KV000GonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oC4a<onKViP1FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oV
i^Koi^KV0_l00006onKViP03ofIVI_oVi^Koi^KV04Goi^KV000GonKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00?o0000onKVi_oVi^H00_oVi^H00om<C4coi^KVonKViP1FonKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000008onKViP03ofIVI_oVi^Koi^KV04Coi^KV000G
onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVoda<C01HonKViP04o`00
0?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l00007onKViS?oIVIV5?oVi^H001Oo
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000
onKVi_oVi^H0E_oVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l00000
CooVi^H001Ooi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000005_o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0005?oi^KV000HonKViP;o00002OoVi^H3o`0005go
i^KV0_l0000:onKViP03o`000?oVi^Koi^KV057oi^KV003SonKViP00hooVi^H003[oi^KV1?l00004
onKViP;o00000_oVi^H3o`0000?oi^KV1Ol0001>onKViPGo000000Koi^KVo`000?l0003o0000onKV
i_l00003onKViP;o00000_oVi^H2o`000003onKVi_l0003o000000Co00001?oVi^H3o`0002;oi^KV
000konKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003o
i^KVonKViP03onKViP04o`000?oVi^Koi^KVo`0004ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003o
i^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00027oi^KV000konKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oV
i^Koi^KV053oi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0003oi^KVo`000?l0003oi^KVo`0000Go
i^KV1Ol00002onKViP03o`000?oVi^Koi^KV00Koi^KV00?o0000onKVi_oVi^H07ooVi^H003_oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000ooVi^H00ol0
003oi^KVonKViP1@onKViP?o00000ooVi^H01_l0003oi^KVo`000?l0003oi^KVo`0000Koi^KV00?o
0000onKVi_l000000ooVi^H3o`0000Coi^KV0_l0000RonKViP00>ooVi^H01?l0003oi^KVonKVi_l0
0002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003o
i^KVonKViP1@onKViP03o`000?oVi^Koi^KV00?oi^KV0_l000001?oVi^Ko0000onKVi_l00006onKV
iP03o`000?oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP0R
onKViP00>ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1@onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV0_l000001OoVi^Ko0000onKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`000004
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00008OoVi^H003[oi^KV1?l0
0002onKViP?o000000?oi^KVo`000?l000001?l00002onKViP?o0000D?oVi^H5o`000004onKVi_l0
003o0000onKViP?o00000_oVi^H3o`0000;oi^KV0_l00003onKViPCo00001?oVi^H3o`00027oi^KV
003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H009Wo
i^KV1Ol00004onKViP?o00001ooVi^H3o`0000Coi^KV0ol00006onKViP?o00001_oVi^H00ol0003o
i^KVonKViP04onKViP?o00005?oVi^H0017oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV
0ol0001jonKViP04o`000?oVi^Koi^KVo`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKV
iP03o`000?oVi^Koi^KV00;oi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP05o`000?oVi^Ko
i^KVonKVi_l000001OoVi^H00ol0003oi^KVonKViP03onKViP05o`000?oVi^Koi^KVonKVi_l00000
4ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000007So
i^KV00?o0000onKVi_oVi^H01ooVi^H00ol0003oi^KVonKViP02onKViPGo00001ooVi^H00ol0003o
i^KVonKViP02onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H00ol0003oi^KVonKViP02onKV
iP05o`000?oVi^Koi^KVonKVi_l000004ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H5
o`0000;oi^KV2_lI6AU`onKViP03o`000?oVi^Koi^KV00Coi^KV0_l00005onKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00?o0000onKVi_oVi^H00_oVi^H4o`0000Ooi^KV00?o0000onKVi_oVi^H00ooV
i^H3o`0001Coi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co0000onKVi_oVi^Ko0000
0ooVi^H00ol0003oi^KVonKViP06onKViP03oaTI6OoVi^Koi^KV06_oi^KV00Go0000onKVi_oVi^Ko
i^KVo`000007onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_l000001?oVi^H4o`0000Go
i^KV00?o0000onKVi_oVi^H02OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00?o0000onKV
i_oVi^H04OoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVo`000003onKV
iP03o`000?oVi^Koi^KV00Koi^KV00?o6ATIonKVi_oVi^H0JooVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP;o00001?oVi^H00ol0003oi^KVonKV
iP07onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP05o`00
0?oVi^Koi^KVonKVi_l000004ooVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000?o
i^KV00?o0000onKVi_oVi^H01ooVi^H00olI6AWoi^KVonKViP1[onKViP?o00001OoVi^H3o`0000So
i^KV00?o0000onKVi_oVi^H00_oVi^H5o`0000Koi^KV0_l00004onKViPGo00001?oVi^H3o`0001Co
i^KV000AonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KV
onKViP07onKViP03oaTI6OoVi^Koi^KV06Coi^KV00?o0000onKVi_oVi^H0COoVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oV
i^H01ooVi^H00olI6AWoi^KVonKViP1SonKViP03o`000?lc<c?o000003co00004_oVi^H0013oi^KV
00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l00009onKViP03oaTI6OoVi^Koi^KV
06Coi^KV00Ko<c<conKVi_l0003oi^KVo`000?oVi^H2o`000003onKVi_l0003oi^KV00;o000000?o
i^KVo`000?oVi^H00_l000000ooVi^Ko0000onKViP02o`000003onKVi_l0003oi^KV00;o000000?o
i^KVo`000?oVi^H00_l000000ooVi^Ko0000onKViP02o`000005onKVi_l0003oi^KVo`000?oVi^H0
0_l000000ooVi^Ko0000onKViP02o`000003onKVi_l0003oi^KV00;o000000?oi^KVo`000?oVi^H0
0_l0000DonKViP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^Koi^KVo`0000[o
i^KV00?o6ATIonKVi_oVi^H0HooVi^H00olc<c?o0000onKViP1=onKViP004?oVi^H01?l0003oi^KV
onKVi_l00007onKViPCo00000ooVi^H00ol0003oi^KVonKViP08onKViP03oaTI6OoVi^Koi^KV06?o
i^KV00?o0000oc<c<ooVi^H0COoVi^H0013oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003o
i^KVonKViP04onKViP03o`000?oVi^Koi^KV00Soi^KV00?o6ATIonKVi_oVi^H0HooVi^H00ol0003o
<c<conKViP1=onKViP004OoVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oVi^Koi^KV00Soi^KV
00?o6ATIonKVi_oVi^H0;?oVi^H00olI6AWoi^KVonKViP0NonKViP;o00001?oVi^H00ol0003oi^KV
onKViP03onKViP;o00000_oVi^H5o`000003onKVi_l0003o<c<c04koi^KV000AonKViP;o00001?oV
i^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP09onKViP03oaTI6OoV
i^Koi^KV02_oi^KV00?o6ATIonKVi_oVi^H07OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Oo0000onKVi_oVi^Ko0000onKVi_l0003o<c<c04koi^KV000@onKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV00Woi^KV00?o6ATIonKVi_oVi^H0:_oVi^H2oaTI6Aooi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H01?l0003oi^KVonKVi_l00003onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVoc<c<`1=
onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oV
i^H00ol0003oi^KVonKViP09onKViP03oaTI6OoVi^Koi^KV02Woi^KV00Co6ATIonKVi_oVi^Ko6ATI
7_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000Coi^KV00?o0000onKV
i_oVi^H00_l000000olc<c?oi^KVonKViP1;onKViP004?oVi^H01?l0003oi^KVonKVi_l00007onKV
iPCo00000ooVi^H00ol0003oi^KVonKViP09onKViP03oaTI6OoVi^Koi^KV02Woi^KV00Co6ATIonKV
i_oVi^Ko6ATI7_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000ooVi^H01Ol0003oi^KVo`000?l0003o<c<c04goi^KV000@onKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP09onKViP03oaTI6OoVi^Koi^KV
02Soi^KV00Go6ATIonKVi_oVi^Koi^KVoaTI6@0NonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP05o`000?oVi^Ko0000onKVi_lc<c<0COoVi^H0013o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV
00[oi^KV00?o6ATIonKVi_oVi^H09_oVi^H00olI6AWoi^KVonKViP03onKViP03oaTI6OoVi^Koi^KV
01coi^KV0_l0000:onKViP;o00000ooVi^H3o`0000;oi^KV0_l000000ooVi^Ko<c<conKViP1;onKV
iP004OoVi^H2o`0000[oi^KV0_l00003onKViP03o`000?oVi^Koi^KV00[oi^KV00?o6ATIonKVi_oV
i^H09_oVi^H00olI6AWoi^KVonKViP03onKViP03oaTI6OoVi^Koi^KV01coi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP?o000000Goi^KVo`000?oVi^Koi^KVoc<c<`1<onKV
iP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP02onKViP03
o`000?oVi^Koi^KV00[oi^KV00?o6ATIonKVi_oVi^H09OoVi^H00olI6AWoi^KVonKViP04onKViP03
oaTI6OoVi^Koi^KV01_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004
onKViP03o`000?oVi^Koi^KV00;o000000?oi^KVoc<c<ooVi^H0BooVi^H0013oi^KV00Co0000onKV
i_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV00[oi^KV00?o6ATI
onKVi_oVi^H09?oVi^H00olI6AWoi^KVonKViP05onKViP03oaTI6OoVi^Koi^KV01_oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Go000000Goi^KVo`000?oVi^Ko
i^KVoc<c<`1<onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKV
i_l000003OoVi^H00olI6AWoi^KVonKViP0SonKViP03oaTI6OoVi^Koi^KV00Koi^KV00?o6ATIonKV
i_oVi^H06_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP02o`0000;oi^KV00?o<c<conKVi_oVi^H0BOoVi^H0013oi^KV00Co
0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000goi^KV00?o6ATIonKVi_oV
i^H08_oVi^H00olI6AWoi^KVonKViP07onKViP03oaTI6OoVi^Koi^KV01[oi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Ko000000;oi^KV00Go0000
onKVi_oVi^Koi^KVoc<c<`1;onKViP004?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oV
i^Koi^KVo`0000goi^KV00?o6ATIonKVi_oVi^H08OoVi^H00olI6AWoi^KVonKViP08onKViP03oaTI
6OoVi^Koi^KV01[oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKV
iP;o00000_oVi^H2o`0000;oi^KV00?o<c<conKVi_oVi^H0BOoVi^H0013oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H02ooVi^H0
0olI6AWoi^KVonKViP0QonKViP03oaTI6OoVi^Koi^KV00Woi^KV00?o6ATIonKVi_oVi^H06_oVi^H2
o`0000[oi^KV0_l00005onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o<c<conKVi_oVi^H0BOoV
i^H0017oi^KV0_l00008onKViPGo00000_oVi^H00ol0003oi^KVonKViP0<onKViP03oaTI6OoVi^Ko
i^KV01ooi^KV00?o6ATIonKVi_oVi^H02_oVi^H00olI6AWoi^KVonKViP0`onKViP;o00000ooVi^H0
0olc<c?oi^KVonKViP18onKViP004OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`00
00?oi^KV00?o0000onKVi_oVi^H03?oVi^H00olI6AWoi^KVonKViP0NonKViP03oaTI6OoVi^Koi^KV
00_oi^KV00?o6ATIonKVi_oVi^H06_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`00
00?oi^KV0ol00002onKViP;o00000ooVi^H00olc<c?oi^KVonKViP18onKViP004?oVi^H01?l0003o
i^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0<
onKViP03oaTI6OoVi^Koi^KV01koi^KV00?o6ATIonKVi_oVi^H02ooVi^H00olI6AWoi^KVonKViP0I
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03
o`000?oVi^Ko000000Coi^KV00?o<c<conKVi_oVi^H0B?oVi^H0013oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H03?oVi^H00olI
6AWoi^KVonKViP0MonKViP03oaTI6OoVi^Koi^KV00goi^KV00?o6ATIonKVi_oVi^H06?oVi^H01?l0
003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KV
o`000?l00003onKViP03oc<c<ooVi^Koi^KV04Soi^KV000@onKViP04o`000?oVi^Koi^KVo`0000So
i^KV0ol00003onKViP03o`000?oVi^Koi^KV00goi^KV00?o6ATIonKVi_oVi^H06ooVi^H00olI6AWo
i^KVonKViP0>onKViP03oaTI6OoVi^Koi^KV01Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0
003oi^KVonKVi_l0003oi^KV00Co00000_oVi^H00ol0003oi^KVonKViP02onKViP03oc<c<ooVi^Ko
i^KV04Soi^KV000@onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00
0002onKViP03o`000?oVi^Koi^KV00goi^KV00?o6ATIonKVi_oVi^H06ooVi^H00olI6AWoi^KVonKV
iP0>onKViP03oaTI6OoVi^Koi^KV01Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KV
onKVi_l0003oi^KVo`0000Goi^KV0_l00004onKViP03oc<c<ooVi^Koi^KV04Ooi^KV000@onKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Ko
i^KV00goi^KV00?o6ATIonKVi_oVi^H06_oVi^H00olI6AWoi^KVonKViP0?onKViP03oaTI6OoVi^Ko
i^KV01Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`00
0?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H00ooVi^H00olc<c?oi^KVonKViP17onKViP004OoV
i^H2o`0000Woi^KV0ol00003onKViP03o`000?oVi^Koi^KV00goi^KV00?o6ATIonKVi_oVi^H06OoV
i^H00olI6AWoi^KVonKViP0AonKViP03oaTI6OoVi^Koi^KV01Soi^KV0_l0000:onKViP;o00001?oV
i^H2o`0000;oi^KV0_l00004onKViP03oc<c<ooVi^Koi^KV04Ooi^KV000AonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP02onKViP;o00001?oVi^H00ol0003oi^KVonKViP0>onKViP03oaTI6OoVi^Ko
i^KV01Soi^KV00?o6ATIonKVi_oVi^H04OoVi^H00olI6AWoi^KVonKViP0HonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0olc<c?oi^KVonKViP17onKViP004?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Ko
i^KVonKVi_l000001OoVi^H5o`0000Koi^KV00?o6ATIo`000?l000002?oVi^H3o`0000Goi^KV0ol0
0004onKViP03oaTI6OoVi^Koi^KV00?o00002?oVi^H00ol0003oi^KVonKViP04onKViP04oaTI6Ol0
003o0000o`0001Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KV
o`0000?oi^KV00Co0000onKVi_l0003o00001OoVi^H00olc<c?oi^KVonKViP16onKViP004?oVi^H0
1?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^Koi^KVo`0000Koi^KV00Co0000onKVi_oVi^Ko
00001OoVi^H01Ol0003o6ATIonKVi_oVi^Ko000000Soi^KV00?o0000onKVi_oVi^H00ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00Co6ATIonKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKV
iP05onKViP03o`000?oVi^Koi^KV00Coi^KV00Go0000oaTI6OoVi^Koi^KVo`00000EonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko
0000o`0000Goi^KV00?o<c<conKVi_oVi^H0A_oVi^H0013oi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H4o`0000;oi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0003oi^KVonKViP06onKViP04oaTI6OoV
i^Koi^KVo`0000Goi^KV1Ol00008onKViP04o`000?oVi^Koi^KVoaTI6@;oi^KV00Go0000onKVi_oV
i^Koi^KVo`000008onKViP03o`000?oVi^Koi^KV00?oi^KV00Go0000oaTI6OoVi^Koi^KVo`00000E
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000;oi^KV
00?o0000onKVi_oVi^H01?oVi^H00olc<c?oi^KVonKViP16onKViP004?oVi^H01?l0003oi^KVonKV
i_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP06onKViP03
o`000?oVi^Koi^KV00Goi^KV00?o6ATIo`000?l000001_oVi^H01?l0003oi^KVonKVi_l00009onKV
iP03o`000?oVi^Ko6ATI00?oi^KV1?l00009onKViP03o`000?oVi^Koi^KV00Coi^KV00?o6ATIo`00
0?l000005_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko0000
0ooVi^H01?l0003oi^KVo`000?l00005onKViP03oc<c<ooVi^Koi^KV04Koi^KV000@onKViP04o`00
0?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV
00?oi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03oaTI6OoVi^Ko000000Koi^KV00?o0000
onKVi_l000001OoVi^H4o`000003onKVi_lI6AWoi^KV00?oi^KV00?o0000onKVi_oVi^H02ooVi^H0
0ol0003oi^KVonKViP02onKViP05o`000?lI6AWoi^KVonKVi_l000005OoVi^H01?l0003oi^KVonKV
i_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVo`000007onKV
iP03oc<c<ooVi^Koi^KV04Goi^KV000AonKViP;o00002OoVi^H3o`0000?oi^KV00?o0000onKVi_oV
i^H00ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00Go0000onKVi_lI6AWoi^KVo`000007
onKViP;o00001OoVi^H00ol0003oi^KVonKViP02onKViP03oaTI6OoVi^Koi^KV00?oi^KV00?o0000
onKVi_oVi^H01_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV00Go0000onKVi_lI6AWoi^KV
o`00000FonKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP;o00001_oVi^H00olc<c?oi^KV
onKViP15onKViP008_oVi^H00ol0003oi^KVonKViP04onKViP?o00001ooVi^H00ol0003o6ATIo`00
0009onKViP03o`000?oVi^Koi^KV00?oi^KV1?l000000olI6AWoi^KVonKViP05onKViP;o00001_oV
i^H5o`0000Goi^KV00?o0000oaTI6Ol000007OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oV
i^H3o`0000;oi^KV00?o0000onKVi_oVi^H01OoVi^H00olc<c?oi^KVonKViP15onKViP008_oVi^H0
0ol0003oi^KVonKViP0?onKViP03oaTI6OoVi^Koi^KV00goi^KV1OlI6ATKonKViP03oaTI6OoVi^Ko
i^KV01_oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H2o`0000Koi^KV
00?o<c<conKVi_oVi^H0AOoVi^H002;oi^KV00?o0000onKVi_oVi^H04?oVi^H00olI6AWoi^KVonKV
iP02onKViP[o6ATI8OoVi^H00olI6AWoi^KVonKViP0JonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00Go0000onKVi_oVi^Koi^KVo`000008onKViP03oc<c<ooVi^Koi^KV04Coi^KV000PonKViQGo0000
1OlI6AT[o`000003oaTI6Ol0003o000001[oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003o
i^KVonKVi_oVi^H2o`0000Ooi^KV<olc<c<DonKViP008_oVi^H00ol0003oi^KVonKViP1MonKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP00P_oVi^H01?l0
003oi^KVonKVi_l00008onKViP;o0000DooVi^H008?oi^KV0_l0000:onKViP03o`000?oVi^Koi^KV
057oi^KV003SonKViP00=ooVi^H2o`0000;oi^KV0ol00002onKViP03o`000?oVi^Ko000000;o0000
0ooVi^H3o`0000?oi^KV0ol0001>onKViPCo00000_oVi^H5o`0000?oi^KV0_l00002onKViP;o0000
00?oi^KVo`000?l000001?l00004onKViP?o00008_oVi^H003Koi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04coi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H0
1?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00027oi^KV000eonKViP03o`000?oV
i^Koi^KV00Coi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV
00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP03onKViPGo00000_oVi^H00ol0003o
i^KVonKViP06onKViP03o`000?oVi^Koi^KV01ooi^KV000eonKViP03o`000?oVi^Koi^KV00Coi^KV
0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H2o`0000Coi^KV0_l0001?onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKV
i_l000000ooVi^H3o`0000Coi^KV0_l0000RonKViP00=OoVi^H00ol0003oi^KVonKViP04onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP03o`000?oV
i^Koi^KV04ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`00
0?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00002onKViP03
o`000?oVi^Koi^KV02;oi^KV000fonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oV
i^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP1<onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000QonKViP00=ooVi^H3o`000003onKVi_l0
003o000000;o00000ooVi^H3o`0000Coi^KV0ol00003onKViP?o0000COoVi^H4o`0000;oi^KV1Ol0
0003onKViP?o00000_oVi^H2o`0000?oi^KV1?l00004onKViP?o00008OoVi^H00>?oi^KV003SonKV
iP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003S
onKViP00hooVi^H005[oi^KV1?l00025onKViP00FooVi^H2o`0008Koi^KV001KonKViP;o0000Q_oV
i^H003ooi^KV1Ol00002onKViPCo00002OoVi^H5o`0000?oi^KV1Ol00002onKViP?o000000?oi^KV
o`000?l000000_l000000ooVi^Ko0000o`000004o`0000;oi^KV0_l000000ooVi^Ko0000o`000002
o`000003onKVi_l0003o000000;o00001OoVi^H4o`0000;oi^KV3?l000000ooVi^Ko0000o`000004
o`000003onKVi_l0003o000000Go0000?_oVi^H003koi^KV0_l00003onKViP;o00000_oVi^H2o`00
00Woi^KV0_l00003onKViP;o00000_oVi^H2o`0000;oi^KV1?l00002onKViP04o`000?oVi^Ko0000
o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_oVi^H2
o`000003onKVi_l0003o000000Ooi^KV0_l00002onKViP?o000000Coi^KVo`000?l0003oi^KV0_l0
0002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000onKVi_l00000
0_oVi^H2o`0003goi^KV000monKViP;o00001?oVi^H2o`0000;oi^KV0_l00008onKViP;o00001OoV
i^H2o`000003onKVi_l0003o000000;oi^KV1?l00004onKViP;o00000_oVi^H2o`000003onKVi_l0
003o000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000001ooV
i^H2o`000004onKVi_l0003o0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o0000
00?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000?oi^KV0ol0000monKViP00?OoV
i^H2o`0000?oi^KV1?l000000ooVi^Ko0000o`000003o`0000Goi^KV0_l00005onKViP;o000000?o
i^KVo`000?l000000_oVi^H7o`000003onKVi_l0003o000000Coi^KV0ol00002onKViP;o000000?o
i^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV1Ol00005onKViP?o00000_oV
i^H2o`000003onKVi_l0003o000000;oi^KV1?l00002onKViP?o0000?ooVi^H003goi^KV0_l00008
onKViP;o00000_oVi^H2o`0000Coi^KV0_l00005onKViP;o000000Goi^KVo`000?l0003o0000onKV
iP04o`000004onKVi_l0003o0000onKViPKo000000?oi^KVo`000?l000000_oVi^H2o`000003onKV
i_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002o`0000Goi^KV0_l00003onKViP;o0000
00Coi^KVo`000?l0003oi^KV0_l00002onKViPGo00000_oVi^H2o`0000;oi^KV00Co0000onKVi_l0
003o00000_oVi^H00ol0003oi^KVonKViP0konKViP00?OoVi^H2o`0000Goi^KV00?o0000onKVi_oV
i^H00_l00002onKViP;o00001?oVi^H2o`0000Goi^KV1Ol000000ooVi^Ko0000o`000002onKViP?o
000000Ooi^KVo`000?l0003o0000onKVi_l0003oi^KV00?o00000_oVi^H4o`000003onKVi_l0003o
000000;o000000Koi^KVo`000?l0003o0000onKVi_l00005onKViP;o00000ooVi^H2o`0000;oi^KV
0ol00002onKViP?o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000o`000?oV
i^H01?l0000monKViP00?_oVi^H2o`0000?oi^KV0_l00002onKViP;o00000_oVi^H2o`0000Goi^KV
0_l00003onKViP;o00006OoVi^H2o`00017oi^KV0_l00003onKViP;o00003ooVi^H2o`0004Koi^KV
000oonKViPCo000000?oi^KVo`000?oVi^H01_l00007onKViPGo00006ooVi^H00ol0003oi^KVonKV
iP0>onKViPOo00003ooVi^H3o`0004Koi^KV003SonKViP00hooVi^H00001\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-3.92094, \
-0.0445132, 0.118795, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-16.5763, -0.0890264, 0.118795, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-2.58967, -0.711658, 0.104352, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-16.2199, -1.05067, 0.118795, 0.0140179}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {-3.92094, -0.306114, 0.118795, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-16.5763, -0.406114, 0.118795, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-2.54518, -2.61842, \
0.103693, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> {-16.5763, \
-0.587, 0.118795, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 1}\\)}, {\\({DECAPS, \
0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, {\\({MUTAT, \
0.7528671228375`}\\)}, {\\({PERM, 0.1`}\\)}, {\\({REPRO, 0.1`}\\)}, {\\({\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)}}, ColumnAlignments -> Left, \
GridBaseline -> {Baseline, {1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(\(ifSensor[_]\)\)[x__]\)\) /; \(\(\(\(Depth[\(\({x}\
\)\)]\)\) > 1\)\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No encapsulation performed."\)], \
"Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(9\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 -5.55112e-17 1.12899 [
[.5 .9621 -93.8125 0 ]
[.5 .9621 93.8125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.76372 .04199 0 -8.80388 ]
[.76372 .04199 10.625 5.19612 ]
[.79306 .07584 0 -8.73184 ]
[.79306 .07584 10.625 5.26816 ]
[.82052 .10754 0 -8.66534 ]
[.82052 .10754 10.625 5.33466 ]
[.84629 .13728 0 -8.60375 ]
[.84629 .13728 10.625 5.39625 ]
[.87052 .16524 0 -8.54656 ]
[.87052 .16524 10.625 5.45344 ]
[.89334 .19158 0 -8.49331 ]
[.89334 .19158 10.625 5.50669 ]
[.91487 .21642 0 -8.4436 ]
[.91487 .21642 10.625 5.5564 ]
[.93522 .23991 0 -8.39709 ]
[.93522 .23991 10.625 5.60291 ]
[.95448 .26213 0 -8.35349 ]
[.95448 .26213 10.625 5.64651 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 17.25 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -154.812 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
246.625 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.75006 .04551 m
.74322 .04728 L
s
gsave
.76372 .04199 -61 -12.8039 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.77936 .07923 m
.77251 .08093 L
s
gsave
.79306 .07584 -61 -12.7318 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.80679 .11081 m
.79993 .11244 L
s
gsave
.82052 .10754 -61 -12.6653 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.83254 .14043 m
.82566 .14201 L
s
gsave
.84629 .13728 -61 -12.6037 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.85674 .16829 m
.84985 .16981 L
s
gsave
.87052 .16524 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.87954 .19452 m
.87264 .19599 L
s
gsave
.89334 .19158 -61 -12.4933 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.90105 .21927 m
.89414 .2207 L
s
gsave
.91487 .21642 -61 -12.4436 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.92138 .24267 m
.91446 .24405 L
s
gsave
.93522 .23991 -61 -12.3971 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.94062 .26481 m
.93369 .26615 L
s
gsave
.95448 .26213 -61 -12.3535 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.16815 .24691 m
.13455 .92146 L
s
.26233 .29961 m
.23906 .93186 L
s
.34519 .34598 m
.33001 .94091 L
s
.41866 .3871 m
.40989 .94886 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.44792 .37296 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.49557 .36392 m .57042 .37159 L .52233 .38044 L F
.44792 .37296 m .49557 .36392 L .52233 .38044 L F
.41906 .35608 m .49557 .36392 L .44792 .37296 L F
.54447 .35463 m .61975 .36251 L .57042 .37159 L F
.49557 .36392 m .54447 .35463 L .57042 .37159 L F
.4675 .34659 m .54447 .35463 L .49557 .36392 L F
.41906 .35608 m .4675 .34659 L .49557 .36392 L F
.59467 .3451 m .67039 .35318 L .61975 .36251 L F
.54447 .35463 m .59467 .3451 L .61975 .36251 L F
.38878 .33836 m .4675 .34659 L .41906 .35608 L F
.51723 .33684 m .59467 .3451 L .54447 .35463 L F
.4675 .34659 m .51723 .33684 L .54447 .35463 L F
.64622 .33532 m .72237 .34361 L .67039 .35318 L F
.59467 .3451 m .64622 .33532 L .67039 .35318 L F
.43801 .32838 m .51723 .33684 L .4675 .34659 L F
.38878 .33836 m .43801 .32838 L .4675 .34659 L F
.56833 .32683 m .64622 .33532 L .59467 .3451 L F
.51723 .33684 m .56833 .32683 L .59467 .3451 L F
.69919 .32526 m .77575 .33379 L .72237 .34361 L F
.64622 .33532 m .69919 .32526 L .72237 .34361 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .44139 .92869 L p F P
0 0 0 r
s
.35695 .31973 m .43801 .32838 L .38878 .33836 L 1 0 0 r
F
.48861 .31814 m .56833 .32683 L .51723 .33684 L F
.43801 .32838 m .48861 .31814 L .51723 .33684 L F
.62083 .31654 m .69919 .32526 L .64622 .33532 L F
.56833 .32683 m .62083 .31654 L .64622 .33532 L F
.75362 .31493 m .8306 .32369 L .77575 .33379 L F
.69919 .32526 m .75362 .31493 L .77575 .33379 L F
.57295 .92839 m .52132 .93033 L .49252 .9267 L p F P
0 0 0 r
s
.44139 .92869 m .49252 .9267 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.40701 .30924 m .48861 .31814 L .43801 .32838 L 1 0 0 r
F
.35695 .31973 m .40701 .30924 L .43801 .32838 L F
.54062 .3076 m .62083 .31654 L .56833 .32683 L F
.48861 .31814 m .54062 .3076 L .56833 .32683 L F
.67481 .30596 m .75362 .31493 L .69919 .32526 L F
.62083 .31654 m .67481 .30596 L .69919 .32526 L F
.80957 .3043 m .88697 .31331 L .8306 .32369 L 0 1 1 r
F
.75362 .31493 m .80957 .3043 L .8306 .32369 L 1 0 0 r
F
.49252 .9267 m .44139 .92869 L .41017 .92497 L p F P
0 0 0 r
s
.62603 .92639 m .57295 .92839 L .5451 .92466 L p 1 0 0 r
F P
0 0 0 r
s
.49252 .9267 m .5451 .92466 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.32346 .30014 m .40701 .30924 L .35695 .31973 L 1 0 0 r
F
.45849 .29846 m .54062 .3076 L .48861 .31814 L F
.40701 .30924 m .45849 .29846 L .48861 .31814 L F
.59411 .29677 m .67481 .30596 L .62083 .31654 L F
.54062 .3076 m .59411 .29677 L .62083 .31654 L F
.73032 .29508 m .80957 .3043 L .75362 .31493 L .5 0 1 r
F
.67481 .30596 m .73032 .29508 L .75362 .31493 L 1 0 0 r
F
.86712 .29338 m .94492 .30264 L .88697 .31331 L F
.80957 .3043 m .86712 .29338 L .88697 .31331 L 0 1 1 r
F
.5451 .92466 m .49252 .9267 L .46221 .92288 L p 1 0 0 r
F P
0 0 0 r
s
.41017 .92497 m .46221 .92288 L .49252 .9267 L p 1 0 0 r
F P
0 0 0 r
s
.37437 .28909 m .45849 .29846 L .40701 .30924 L 1 0 0 r
F
.32346 .30014 m .37437 .28909 L .40701 .30924 L F
.68061 .92434 m .62603 .92639 L .59918 .92255 L p F P
0 0 0 r
s
.5451 .92466 m .59918 .92255 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.51145 .28736 m .59411 .29677 L .54062 .3076 L 1 0 0 r
F
.45849 .29846 m .51145 .28736 L .54062 .3076 L F
.64913 .28563 m .73032 .29508 L .67481 .30596 L F
.59411 .29677 m .64913 .28563 L .67481 .30596 L F
.78743 .28389 m .86712 .29338 L .80957 .3043 L .5 1 0 r
F
.73032 .29508 m .78743 .28389 L .80957 .3043 L .5 0 1 r
F
.86712 .29338 m .92634 .28214 L .94492 .30264 L 1 0 0 r
F
.46221 .92288 m .41017 .92497 L .37729 .92106 L p F P
0 0 0 r
s
.59918 .92255 m .5451 .92466 L .51575 .92073 L p 1 0 0 r
F P
0 0 0 r
s
.46221 .92288 m .51575 .92073 L .5451 .92466 L p 1 0 0 r
F P
0 0 0 r
s
.28819 .27949 m .37437 .28909 L .32346 .30014 L 1 0 0 r
F
.42676 .27772 m .51145 .28736 L .45849 .29846 L F
.37437 .28909 m .42676 .27772 L .45849 .29846 L F
.73675 .92223 m .68061 .92434 L .65483 .92039 L p F P
0 0 0 r
s
.59918 .92255 m .65483 .92039 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.56595 .27595 m .64913 .28563 L .59411 .29677 L 1 0 0 r
F
.51145 .28736 m .56595 .27595 L .59411 .29677 L F
.70576 .27416 m .78743 .28389 L .73032 .29508 L .5 0 1 r
F
.64913 .28563 m .70576 .27416 L .73032 .29508 L 1 0 0 r
F
.95551 .49559 m .89593 .50379 L .87581 .48847 L p F P
0 0 0 r
s
.89593 .50379 m .85402 .91782 L .83193 .91351 L p 0 1 1 r
F P
0 0 0 r
s
.83193 .91351 m .87581 .48847 L .89593 .50379 L p 0 1 1 r
F P
0 0 0 r
s
.84621 .27237 m .92634 .28214 L .86712 .29338 L 1 0 0 r
F
.78743 .28389 m .84621 .27237 L .86712 .29338 L .5 1 0 r
F
.51575 .92073 m .46221 .92288 L .43025 .91886 L p 1 0 0 r
F P
0 0 0 r
s
.37729 .92106 m .43025 .91886 L .46221 .92288 L p 1 0 0 r
F P
0 0 0 r
s
.65483 .92039 m .59918 .92255 L .57087 .91851 L p 1 0 0 r
F P
0 0 0 r
s
.51575 .92073 m .57087 .91851 L .59918 .92255 L p 1 0 0 r
F P
0 0 0 r
s
.33996 .26784 m .42676 .27772 L .37437 .28909 L 1 0 0 r
F
.28819 .27949 m .33996 .26784 L .37437 .28909 L F
.79453 .92005 m .73675 .92223 L .71212 .91816 L p F P
0 0 0 r
s
.65483 .92039 m .71212 .91816 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.48069 .26602 m .56595 .27595 L .51145 .28736 L 1 0 0 r
F
.42676 .27772 m .48069 .26602 L .51145 .28736 L F
.62206 .26419 m .70576 .27416 L .64913 .28563 L F
.56595 .27595 m .62206 .26419 L .64913 .28563 L F
.76407 .26235 m .84621 .27237 L .78743 .28389 L 0 1 1 r
F
.70576 .27416 m .76407 .26235 L .78743 .28389 L .5 0 1 r
F
.87581 .48847 m .93673 .47982 L .95551 .49559 L p 1 0 0 r
F P
0 0 0 r
s
.84621 .27237 m .90674 .2605 L .92634 .28214 L 1 0 0 r
F
.43025 .91886 m .37729 .92106 L .3426 .91694 L p F P
0 0 0 r
s
.57087 .91851 m .51575 .92073 L .48479 .91658 L p 1 0 0 r
F P
0 0 0 r
s
.43025 .91886 m .48479 .91658 L .51575 .92073 L p 1 0 0 r
F P
0 0 0 r
s
.25097 .25772 m .33996 .26784 L .28819 .27949 L 1 0 0 r
F
.39327 .25585 m .48069 .26602 L .42676 .27772 L F
.33996 .26784 m .39327 .25585 L .42676 .27772 L F
.71212 .91816 m .65483 .92039 L .62763 .91623 L p F P
0 0 0 r
s
.57087 .91851 m .62763 .91623 L .65483 .92039 L p 1 0 0 r
F P
0 0 0 r
s
.53623 .25397 m .62206 .26419 L .56595 .27595 L 1 0 0 r
F
.48069 .26602 m .53623 .25397 L .56595 .27595 L F
.85402 .91782 m .79453 .92005 L .77113 .91587 L p F P
0 0 0 r
s
.71212 .91816 m .77113 .91587 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.67985 .25208 m .76407 .26235 L .70576 .27416 L 1 0 0 r
F
.62206 .26419 m .67985 .25208 L .70576 .27416 L F
.93673 .47982 m .87581 .48847 L .85457 .4723 L p F P
0 0 0 r
s
.87581 .48847 m .83193 .91351 L .7941 .48117 L p .5 1 0 r
F P
0 0 0 r
s
.7941 .48117 m .85457 .4723 L .87581 .48847 L p .5 1 0 r
F P
0 0 0 r
s
.82414 .25019 m .90674 .2605 L .84621 .27237 L .5 1 0 r
F
.76407 .26235 m .82414 .25019 L .84621 .27237 L 0 1 1 r
F
.48479 .91658 m .43025 .91886 L .39651 .91461 L p 1 0 0 r
F P
0 0 0 r
s
.3426 .91694 m .39651 .91461 L .43025 .91886 L p 1 0 0 r
F P
0 0 0 r
s
.30362 .24541 m .39327 .25585 L .33996 .26784 L 1 0 0 r
F
.25097 .25772 m .30362 .24541 L .33996 .26784 L F
.62763 .91623 m .57087 .91851 L .54098 .91424 L p F P
0 0 0 r
s
.48479 .91658 m .54098 .91424 L .57087 .91851 L p 1 0 0 r
F P
0 0 0 r
s
.4482 .24349 m .53623 .25397 L .48069 .26602 L 1 0 0 r
F
.39327 .25585 m .4482 .24349 L .48069 .26602 L F
.77113 .91587 m .71212 .91816 L .68612 .91388 L p F P
0 0 0 r
s
.62763 .91623 m .68612 .91388 L .71212 .91816 L p 1 0 0 r
F P
0 0 0 r
s
.77113 .91587 m .83193 .91351 L .85402 .91782 L p 1 0 0 r
F P
0 0 0 r
s
.59346 .24155 m .67985 .25208 L .62206 .26419 L 1 0 0 r
F
.53623 .25397 m .59346 .24155 L .62206 .26419 L F
.7464 .91145 m .7941 .48117 L .83193 .91351 L p .5 0 1 r
F P
0 0 0 r
s
.85457 .4723 m .7941 .48117 L .78382 .90412 L p 0 1 1 r
F P
0 0 0 r
s
.7941 .48117 m .7464 .91145 L .72022 .90677 L p .5 0 1 r
F P
0 0 0 r
s
.72022 .90677 m .78382 .90412 L .7941 .48117 L p .5 0 1 r
F P
0 0 0 r
s
.73941 .23961 m .82414 .25019 L .76407 .26235 L 1 0 0 r
F
.67985 .25208 m .73941 .23961 L .76407 .26235 L F
.85457 .4723 m .91688 .46317 L .93673 .47982 L p F P
0 0 0 r
s
.82414 .25019 m .88603 .23765 L .90674 .2605 L .5 1 0 r
F
.39651 .91461 m .3426 .91694 L .30596 .91258 L p 1 0 0 r
F P
0 0 0 r
s
.21164 .23471 m .30362 .24541 L .25097 .25772 L 1 0 0 r
F
.54098 .91424 m .48479 .91658 L .45208 .91221 L p F P
0 0 0 r
s
.39651 .91461 m .45208 .91221 L .48479 .91658 L p 1 0 0 r
F P
0 0 0 r
s
.68612 .91388 m .62763 .91623 L .59889 .91183 L p 1 0 0 r
F P
0 0 0 r
s
.54098 .91424 m .59889 .91183 L .62763 .91623 L p 1 0 0 r
F P
0 0 0 r
s
.35789 .23273 m .4482 .24349 L .39327 .25585 L 1 0 0 r
F
.30362 .24541 m .35789 .23273 L .39327 .25585 L F
.50483 .23074 m .59346 .24155 L .53623 .25397 L F
.4482 .24349 m .50483 .23074 L .53623 .25397 L F
.83193 .91351 m .77113 .91587 L .7464 .91145 L p .5 0 1 r
F P
0 0 0 r
s
.68612 .91388 m .7464 .91145 L .77113 .91587 L p 1 0 0 r
F P
0 0 0 r
s
.65246 .22875 m .73941 .23961 L .67985 .25208 L 1 0 0 r
F
.59346 .24155 m .65246 .22875 L .67985 .25208 L F
.91688 .46317 m .85457 .4723 L .8495 .90139 L p .5 1 0 r
F P
0 0 0 r
s
.78382 .90412 m .8495 .90139 L .85457 .4723 L p 0 1 1 r
F P
0 0 0 r
s
.8008 .22674 m .88603 .23765 L .82414 .25019 L .5 0 1 r
F
.73941 .23961 m .8008 .22674 L .82414 .25019 L 1 0 0 r
F
.45208 .91221 m .39651 .91461 L .36084 .91012 L p F P
0 0 0 r
s
.30596 .91258 m .36084 .91012 L .39651 .91461 L p 1 0 0 r
F P
0 0 0 r
s
.59889 .91183 m .54098 .91424 L .50937 .90973 L p 1 0 0 r
F P
0 0 0 r
s
.45208 .91221 m .50937 .90973 L .54098 .91424 L p 1 0 0 r
F P
0 0 0 r
s
.2652 .22169 m .35789 .23273 L .30362 .24541 L .5 0 1 r
F
.21164 .23471 m .2652 .22169 L .30362 .24541 L 1 0 0 r
F
.7464 .91145 m .68612 .91388 L .65861 .90934 L p F P
0 0 0 r
s
.59889 .91183 m .65861 .90934 L .68612 .91388 L p 1 0 0 r
F P
0 0 0 r
s
.41385 .21965 m .50483 .23074 L .4482 .24349 L 1 0 0 r
F
.35789 .23273 m .41385 .21965 L .4482 .24349 L F
.56322 .2176 m .65246 .22875 L .59346 .24155 L F
.50483 .23074 m .56322 .2176 L .59346 .24155 L F
.71331 .21554 m .8008 .22674 L .73941 .23961 L F
.65246 .22875 m .71331 .21554 L .73941 .23961 L F
.8495 .90139 m .89588 .44554 L .91688 .46317 L p .5 1 0 r
F P
0 0 0 r
s
.8008 .22674 m .86412 .21348 L .88603 .23765 L .5 0 1 r
F
.36084 .91012 m .30596 .91258 L .26718 .90797 L p 1 0 0 r
F P
0 0 0 r
s
.50937 .90973 m .45208 .91221 L .41746 .90757 L p 1 0 0 r
F P
0 0 0 r
s
.36084 .91012 m .41746 .90757 L .45208 .91221 L p 1 0 0 r
F P
0 0 0 r
s
.17003 .21036 m .2652 .22169 L .21164 .23471 L 1 0 0 r
F
.32044 .20826 m .41385 .21965 L .35789 .23273 L 0 1 1 r
F
.2652 .22169 m .32044 .20826 L .35789 .23273 L .5 0 1 r
F
.65861 .90934 m .59889 .91183 L .56848 .90717 L p 1 0 0 r
F P
0 0 0 r
s
.50937 .90973 m .56848 .90717 L .59889 .91183 L p 1 0 0 r
F P
0 0 0 r
s
.47159 .20616 m .56322 .2176 L .50483 .23074 L 1 0 0 r
F
.41385 .21965 m .47159 .20616 L .50483 .23074 L F
.65861 .90934 m .72022 .90677 L .7464 .91145 L p F P
0 0 0 r
s
.62347 .20405 m .71331 .21554 L .65246 .22875 L 1 0 0 r
F
.56322 .2176 m .62347 .20405 L .65246 .22875 L F
.77609 .20192 m .86412 .21348 L .8008 .22674 L F
.71331 .21554 m .77609 .20192 L .8008 .22674 L F
.41746 .90757 m .36084 .91012 L .32307 .90536 L p F P
0 0 0 r
s
.26718 .90797 m .32307 .90536 L .36084 .91012 L p 1 0 0 r
F P
0 0 0 r
s
.2245 .19657 m .32044 .20826 L .2652 .22169 L 0 1 1 r
F
.17003 .21036 m .2245 .19657 L .2652 .22169 L 1 0 0 r
F
.56848 .90717 m .50937 .90973 L .4759 .90495 L p F P
0 0 0 r
s
.41746 .90757 m .4759 .90495 L .50937 .90973 L p 1 0 0 r
F P
0 0 0 r
s
.72022 .90677 m .65861 .90934 L .62948 .90454 L p 1 0 0 r
F P
0 0 0 r
s
.56848 .90717 m .62948 .90454 L .65861 .90934 L p 1 0 0 r
F P
0 0 0 r
s
.37746 .1944 m .47159 .20616 L .41385 .21965 L 0 1 1 r
F
.32044 .20826 m .37746 .1944 L .41385 .21965 L F
.53118 .19223 m .62347 .20405 L .56322 .2176 L .5 0 1 r
F
.47159 .20616 m .53118 .19223 L .56322 .2176 L 1 0 0 r
F
.68566 .19005 m .77609 .20192 L .71331 .21554 L .5 0 1 r
F
.62347 .20405 m .68566 .19005 L .71331 .21554 L 1 0 0 r
F
.89588 .44554 m .8495 .90139 L .82483 .89609 L p .5 0 1 r
F P
0 0 0 r
s
.82483 .89609 m .89442 .89308 L .89588 .44554 L p .5 0 1 r
F P
0 0 0 r
s
.77609 .20192 m .84091 .18786 L .86412 .21348 L 1 0 0 r
F
.32307 .90536 m .26718 .90797 L .22609 .90308 L p F P
0 0 0 r
s
.4759 .90495 m .41746 .90757 L .38077 .90266 L p 1 0 0 r
F P
0 0 0 r
s
.32307 .90536 m .38077 .90266 L .41746 .90757 L p 1 0 0 r
F P
0 0 0 r
s
.28074 .18233 m .37746 .1944 L .32044 .20826 L 1 0 0 r
F
.2245 .19657 m .28074 .18233 L .32044 .20826 L 0 1 1 r
F
.62948 .90454 m .56848 .90717 L .53623 .90224 L p 1 0 0 r
F P
0 0 0 r
s
.4759 .90495 m .53623 .90224 L .56848 .90717 L p 1 0 0 r
F P
0 0 0 r
s
.43634 .18009 m .53118 .19223 L .47159 .20616 L 0 1 1 r
F
.37746 .1944 m .43634 .18009 L .47159 .20616 L F
.78382 .90412 m .72022 .90677 L .69247 .90181 L p 1 0 0 r
F P
0 0 0 r
s
.62948 .90454 m .69247 .90181 L .72022 .90677 L p 1 0 0 r
F P
0 0 0 r
s
.59272 .17785 m .68566 .19005 L .62347 .20405 L 0 1 1 r
F
.53118 .19223 m .59272 .17785 L .62347 .20405 L .5 0 1 r
F
.74989 .1756 m .84091 .18786 L .77609 .20192 L 0 1 1 r
F
.68566 .19005 m .74989 .1756 L .77609 .20192 L .5 0 1 r
F
.38077 .90266 m .32307 .90536 L .283 .90031 L p 1 0 0 r
F P
0 0 0 r
s
.22609 .90308 m .283 .90031 L .32307 .90536 L p 1 0 0 r
F P
0 0 0 r
s
.53623 .90224 m .4759 .90495 L .44038 .89988 L p 1 0 0 r
F P
0 0 0 r
s
.38077 .90266 m .44038 .89988 L .4759 .90495 L p 1 0 0 r
F P
0 0 0 r
s
.69247 .90181 m .62948 .90454 L .59856 .89944 L p 1 0 0 r
F P
0 0 0 r
s
.53623 .90224 m .59856 .89944 L .62948 .90454 L p 1 0 0 r
F P
0 0 0 r
s
.33885 .16762 m .43634 .18009 L .37746 .1944 L 1 0 0 r
F
.28074 .18233 m .33885 .16762 L .37746 .1944 L F
.49718 .16531 m .59272 .17785 L .53118 .19223 L .5 1 0 r
F
.43634 .18009 m .49718 .16531 L .53118 .19223 L 0 1 1 r
F
.8495 .90139 m .78382 .90412 L .75755 .899 L p 1 0 0 r
F P
0 0 0 r
s
.69247 .90181 m .75755 .899 L .78382 .90412 L p 1 0 0 r
F P
0 0 0 r
s
.65631 .16299 m .74989 .1756 L .68566 .19005 L .5 1 0 r
F
.59272 .17785 m .65631 .16299 L .68566 .19005 L 0 1 1 r
F
.74989 .1756 m .81627 .16066 L .84091 .18786 L F
.283 .90031 m .22609 .90308 L .18247 .89789 L p 1 0 0 r
F P
0 0 0 r
s
.44038 .89988 m .38077 .90266 L .34182 .89745 L p 1 0 0 r
F P
0 0 0 r
s
.283 .90031 m .34182 .89745 L .38077 .90266 L p 1 0 0 r
F P
0 0 0 r
s
.40263 .89449 m .34182 .89745 L .31414 .42284 L p 0 1 1 r
F P
0 0 0 r
s
.31414 .42284 m .37275 .41212 L .40263 .89449 L p 0 1 1 r
F P
0 0 0 r
s
.24042 .89495 m .31414 .42284 L .34182 .89745 L p .5 0 1 r
F P
0 0 0 r
s
.37275 .41212 m .31414 .42284 L .27306 .40276 L p 1 0 0 r
F P
0 0 0 r
s
.31414 .42284 m .24042 .89495 L .19508 .88924 L p 0 1 1 r
F P
0 0 0 r
s
.19508 .88924 m .27306 .40276 L .31414 .42284 L p 0 1 1 r
F P
0 0 0 r
s
.59856 .89944 m .53623 .90224 L .50199 .897 L p 1 0 0 r
F P
0 0 0 r
s
.44038 .89988 m .50199 .897 L .53623 .90224 L p 1 0 0 r
F P
0 0 0 r
s
.39891 .15241 m .49718 .16531 L .43634 .18009 L 1 0 0 r
F
.33885 .16762 m .39891 .15241 L .43634 .18009 L F
.75755 .899 m .69247 .90181 L .66299 .89655 L p F P
0 0 0 r
s
.59856 .89944 m .66299 .89655 L .69247 .90181 L p 1 0 0 r
F P
0 0 0 r
s
.75755 .899 m .82483 .89609 L .8495 .90139 L p 1 0 0 r
F P
0 0 0 r
s
.56006 .15002 m .65631 .16299 L .59272 .17785 L 1 0 0 r
F
.49718 .16531 m .56006 .15002 L .59272 .17785 L .5 1 0 r
F
.72205 .14763 m .81627 .16066 L .74989 .1756 L 1 0 0 r
F
.65631 .16299 m .72205 .14763 L .74989 .1756 L .5 1 0 r
F
.34182 .89745 m .283 .90031 L .24042 .89495 L p .5 0 1 r
F P
0 0 0 r
s
.18247 .89789 m .24042 .89495 L .283 .90031 L p 1 0 0 r
F P
0 0 0 r
s
.50199 .897 m .44038 .89988 L .40263 .89449 L p 1 0 0 r
F P
0 0 0 r
s
.34182 .89745 m .40263 .89449 L .44038 .89988 L p 1 0 0 r
F P
0 0 0 r
s
.46556 .89142 m .40263 .89449 L .37275 .41212 L p 0 1 1 r
F P
0 0 0 r
s
.37275 .41212 m .43333 .40103 L .46556 .89142 L p 0 1 1 r
F P
0 0 0 r
s
.43333 .40103 m .37275 .41212 L .33281 .39136 L p 1 0 0 r
F P
0 0 0 r
s
.27306 .40276 m .33281 .39136 L .37275 .41212 L p 1 0 0 r
F P
0 0 0 r
s
.66299 .89655 m .59856 .89944 L .5657 .89402 L p 1 0 0 r
F P
0 0 0 r
s
.50199 .897 m .5657 .89402 L .59856 .89944 L p 1 0 0 r
F P
0 0 0 r
s
.46102 .13668 m .56006 .15002 L .49718 .16531 L 1 0 0 r
F
.39891 .15241 m .46102 .13668 L .49718 .16531 L F
.82483 .89609 m .75755 .899 L .72963 .89355 L p F P
0 0 0 r
s
.66299 .89655 m .72963 .89355 L .75755 .899 L p 1 0 0 r
F P
0 0 0 r
s
.6251 .13422 m .72205 .14763 L .65631 .16299 L 1 0 0 r
F
.56006 .15002 m .6251 .13422 L .65631 .16299 L F
.72205 .14763 m .79006 .13174 L .81627 .16066 L F
.24042 .89495 m .18247 .89789 L .13607 .89238 L p F P
0 0 0 r
s
.5657 .89402 m .50199 .897 L .46556 .89142 L p 1 0 0 r
F P
0 0 0 r
s
.40263 .89449 m .46556 .89142 L .50199 .897 L p 1 0 0 r
F P
0 0 0 r
s
.5307 .88825 m .46556 .89142 L .43333 .40103 L p 0 1 1 r
F P
0 0 0 r
s
.43333 .40103 m .49598 .38957 L .5307 .88825 L p 0 1 1 r
F P
0 0 0 r
s
.49598 .38957 m .43333 .40103 L .39463 .37956 L p 1 0 0 r
F P
0 0 0 r
s
.33281 .39136 m .39463 .37956 L .43333 .40103 L p 1 0 0 r
F P
0 0 0 r
s
.72963 .89355 m .66299 .89655 L .63162 .89094 L p 1 0 0 r
F P
0 0 0 r
s
.5657 .89402 m .63162 .89094 L .66299 .89655 L p 1 0 0 r
F P
0 0 0 r
s
.69988 .88775 m .63162 .89094 L .59443 .3993 L p 0 1 1 r
F P
0 0 0 r
s
.59443 .3993 m .66001 .38777 L .69988 .88775 L p 0 1 1 r
F P
0 0 0 r
s
.5307 .88825 m .59443 .3993 L .63162 .89094 L p .5 0 1 r
F P
0 0 0 r
s
.66001 .38777 m .59443 .3993 L .56081 .37771 L p 1 0 0 r
F P
0 0 0 r
s
.59443 .3993 m .5307 .88825 L .49598 .38957 L p .5 1 0 r
F P
0 0 0 r
s
.49598 .38957 m .56081 .37771 L .59443 .3993 L p .5 1 0 r
F P
0 0 0 r
s
.89442 .89308 m .82483 .89609 L .79858 .89046 L p 1 0 0 r
F P
0 0 0 r
s
.72963 .89355 m .79858 .89046 L .82483 .89609 L p 1 0 0 r
F P
0 0 0 r
s
.5253 .12041 m .6251 .13422 L .56006 .15002 L 1 0 0 r
F
.46102 .13668 m .5253 .12041 L .56006 .15002 L F
.86998 .88725 m .79858 .89046 L .75637 .39755 L p 0 1 1 r
F P
0 0 0 r
s
.75637 .39755 m .8249 .38597 L .86998 .88725 L p 0 1 1 r
F P
0 0 0 r
s
.69988 .88775 m .75637 .39755 L .79858 .89046 L p .5 0 1 r
F P
0 0 0 r
s
.8249 .38597 m .75637 .39755 L .72787 .37585 L p 1 0 0 r
F P
0 0 0 r
s
.75637 .39755 m .69988 .88775 L .66001 .38777 L p .5 1 0 r
F P
0 0 0 r
s
.66001 .38777 m .72787 .37585 L .75637 .39755 L p .5 1 0 r
F P
0 0 0 r
s
.69242 .11786 m .79006 .13174 L .72205 .14763 L 1 0 0 r
F
.6251 .13422 m .69242 .11786 L .72205 .14763 L F
.13607 .89238 m .19508 .88924 L .24042 .89495 L p F P
0 0 0 r
s
.63162 .89094 m .5657 .89402 L .5307 .88825 L p .5 0 1 r
F P
0 0 0 r
s
.46556 .89142 m .5307 .88825 L .5657 .89402 L p 1 0 0 r
F P
0 0 0 r
s
.56081 .37771 m .49598 .38957 L .45864 .36735 L p 1 0 0 r
F P
0 0 0 r
s
.39463 .37956 m .45864 .36735 L .49598 .38957 L p 1 0 0 r
F P
0 0 0 r
s
.79858 .89046 m .72963 .89355 L .69988 .88775 L p .5 0 1 r
F P
0 0 0 r
s
.63162 .89094 m .69988 .88775 L .72963 .89355 L p 1 0 0 r
F P
0 0 0 r
s
.72787 .37585 m .66001 .38777 L .62793 .36543 L p 1 0 0 r
F P
0 0 0 r
s
.56081 .37771 m .62793 .36543 L .66001 .38777 L p 1 0 0 r
F P
0 0 0 r
s
.59186 .10356 m .69242 .11786 L .6251 .13422 L 1 0 0 r
F
.5253 .12041 m .59186 .10356 L .6251 .13422 L F
.79858 .89046 m .86998 .88725 L .89442 .89308 L p F P
0 0 0 r
s
.72787 .37585 m .79814 .3635 L .8249 .38597 L p 1 0 0 r
F P
0 0 0 r
s
.69242 .11786 m .76213 .10091 L .79006 .13174 L 1 0 0 r
F
.62793 .36543 m .56081 .37771 L .52495 .3547 L p F P
0 0 0 r
s
.45864 .36735 m .52495 .3547 L .56081 .37771 L p 1 0 0 r
F P
0 0 0 r
s
.79814 .3635 m .72787 .37585 L .69747 .35271 L p 1 0 0 r
F P
0 0 0 r
s
.62793 .36543 m .69747 .35271 L .72787 .37585 L p 1 0 0 r
F P
0 0 0 r
s
.66081 .0861 m .76213 .10091 L .69242 .11786 L 1 0 0 r
F
.59186 .10356 m .66081 .0861 L .69242 .11786 L F
.69747 .35271 m .62793 .36543 L .59368 .34158 L p F P
0 0 0 r
s
.52495 .3547 m .59368 .34158 L .62793 .36543 L p 1 0 0 r
F P
0 0 0 r
s
.69747 .35271 m .76957 .33952 L .79814 .3635 L p 1 0 0 r
F P
0 0 0 r
s
.66081 .0861 m .7323 .068 L .76213 .10091 L 1 0 0 r
F
.76957 .33952 m .69747 .35271 L .66498 .32797 L p F P
0 0 0 r
s
.59368 .34158 m .66498 .32797 L .69747 .35271 L p 1 0 0 r
F P
0 0 0 r
s
.66498 .32797 m .73899 .31385 L .76957 .33952 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00002Qolc<c07ooooo001X
olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?l000000oo<c<`2o`000005olc<c?l0
003oc<c<olc<c?l000000oo<c<`00ol0003oc<c<olc<c02Nolc<c07ooooo001Xolc<c004o`000?o<
c<co0000olc<c0;o00000oo<c<`3o`000004olc<c?l0003oc<c<o`0000;oc<c<00Go0000olc<c?o<
c<coc<c<o`000019olc<c0?o0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<05;oc<c<0Oooool006Soc<c<00?o0000olc<c?o<c<`0
2_o<c<`00ol0003oc<c<o`00000Lolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Lolc<c0Co000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<
olc<c01Aolc<c07ooooo002Eolc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`06?o<
c<`4o`0000Goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c01@olc<c07ooooo002E
olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0000ooc<c<00?o0000
olc<c?o<c<`0Coo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c01>olc<c07ooooo002Folc<c003o`000?o<c<coc<c<00Coc<c<1Ol0000@olc<c0Co
00006Oo<c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<043oc<c<0Oooool009Ooc<c<
00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00?olc<c0?o00000_o<c<`00ol0003oc<c<
olc<c00Iolc<c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<c?o<c<`0@?o<c<`1ooooo`00V?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00[oc<c<1?l0000Rolc<c003o`000?o<
c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0@?o<c<`1ooooo`00Too<c<`6o`0000Goc<c<1Ol00004
olc<c0Co000000?oc<c<o`000?o<c<`08oo<c<`00ol0003oc<c<olc<c008olc<c003o`000?o<c<co
c<c<043oc<c<0Oooool00:Coc<c<0ol00005olc<c003o`000?o<c<coc<c<02?oc<c<00?o0000olc<
c?o<c<`01oo<c<`00ol0003oc<c<olc<c010olc<c07ooooo001colc<c0Co0000:Oo<c<`5o`0002go
c<c<0ol00007olc<c003o`000?o<c<coc<c<043oc<c<0Oooool007;oc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Rolc<c0Co00001?o<c<`00ol0003oc<c<olc<c00]olc<c003o`00
0?o<c<coc<c<00?oc<c<0ol00012olc<c07ooooo001golc<c003o`000?o<c<coc<c<01ooc<c<0ol0
000iolc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`0@?o<c<`1ooooo`00Moo<c<`0
0ol0003oc<c<olc<c00Kolc<c0Co00000_o<c<`00ol0003oc<c<olc<c00holc<c003o`000?o<c<co
c<c<00?oc<c<00?o0000olc<c?o<c<`0@?o<c<`1ooooo`00L_o<c<`00ol0003oc<c<olc<c002olc<
c003o`000?o<c<coc<c<01Ooc<c<1?l00006olc<c003o`000?o<c<coc<c<03Woc<c<00?o0000olc<
c?o<c<`01_o<c<`6o`0003Woc<c<0Oooool007;oc<c<1Ol0000Golc<c0?o00000_o<c<`00ol0003o
c<c<olc<c011olc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0??o<c<`1ooooo`00
L_o<c<`00ol0003oc<c<olc<c00Eolc<c0Co0000@?o<c<`2ool000Soc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c00kolc<c07ooooo001colc<c003o`000?o<c<coc<c<013oc<c<1?l0
00000oo<c<co0000olc<c00nolc<c0Koo`002?o<c<`00ol0003oc<c<olc<c006olc<c0;o0000>oo<
c<`1ooooo`00Loo<c<`5o`0000_oc<c<0ol00011olc<c0_oo`001oo<c<`3o`0000Soc<c<00?o0000
olc<c?o<c<`0>?o<c<`1ooooo`00Ooo<c<`4o`000003olc<c?l0003oc<c<03koc<c<3ooo0008olc<
c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0=oo<c<`1ooooo`00BOo<c<`6o`0000;o
c<c<00?o0000olc<c?o<c<`01?l0000Solc<c0Co0000@_o<c<`Cool000Soc<c<00Go0000olc<c?o<
c<coc<c<o`000004olc<c003o`000?o<c<coc<c<03Ooc<c<0Oooool004Woc<c<00?o0000olc<c?o<
c<`01oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01goc<c<0ol000000oo<c<co
0000olc<c00oolc<c1Soo`002?o<c<`01?l0003oc<c<olc<c?l00004olc<c003o`000?o<c<co0000
00?o0000=?o<c<`1ooooo`00B_o<c<`00ol0003oc<c<olc<c00;olc<c003o`000?o<c<coc<c<01Wo
c<c<1?l00004olc<c003o`000?o<c<coc<c<03[oc<c<7Ooo0008olc<c003o`000?o<c<coc<c<00Co
000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<olc<c00aolc<c07ooooo001;olc<c0;o0000
2oo<c<`00ol0003oc<c<olc<c00Folc<c0?o000000?oc<c<o`000?o<c<`0?Oo<c<`Sool000Ooc<c<
00?o0000olc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<037oc<c<
0Oooool004goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<
c<coc<c<01;oc<c<1?l00004olc<c003o`000?o<c<coc<c<03Soc<c<9ooo0008olc<c003o`000?o<
c<coc<c<00Woc<c<00?o0000olc<c?o<c<`0<Oo<c<`1ooooo`00C_o<c<`00ol0003oc<c<olc<c002
olc<c0Go00004Oo<c<`5o`0003koc<c<;?oo0008olc<c003o`000?o<c<coc<c<00Goc<c<0ol0000d
olc<c07ooooo0019olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0
003oc<c<olc<c00@olc<c0?o00001?o<c<`00ol0003oc<c<olc<c00holc<c37oo`001oo<c<`2o`00
00Woc<c<00?o0000olc<c?o<c<`0<Oo<c<`1ooooo`00BOo<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`02oo<c<`5o`0003goc<c<=_oo0008olc<c005
o`000?o<c<coc<c<olc<c?l000001?o<c<`00ol0003oc<c<olc<c00aolc<c07ooooo001:olc<c0Co
00001_o<c<`5o`0000Goc<c<1?l00004olc<c003o`000?o<c<coc<c<03Ooc<c<>_oo0009olc<c004
o`000?o<c<coc<c<o`0000Coc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00[olc<
c07ooooo000_olc<c0Co0000:?o<c<`3o`000003olc<c?l0003oc<c<03_oc<c<?ooo0009olc<c003
o`000?o<c<coc<c<00Co00001_o<c<`00ol0003oc<c<olc<c00[olc<c07ooooo000^olc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`08Oo<c<`4o`0003goc<c<A?oo0009olc<c003o`00
0?o<c<coc<c<00Goc<c<1_l0000/olc<c07ooooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o
0000olc<c?o<c<`07Oo<c<`4o`000003olc<c?l0003oc<c<03_oc<c<B?oo0008olc<c003o`000?o<
c<coc<c<00Goc<c<00Go0000olc<c?o<c<coc<c<o`00000Dolc<c0Co000000Coc<c<o`000?o<c<co
c<c<1?l00002olc<c007o`000?o<c<coc<c<olc<c?l0003oc<c<o`000004olc<c07ooooo000^olc<
c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`06_o<c<`3o`0003koc<c<COoo0008olc<
c003o`000?o<c<coc<c<00Goc<c<00Co0000olc<c?o<c<co00004oo<c<`00ol0003oc<c<olc<c002
olc<c0;o000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<o`000003olc<c003o`000?o<c<co
c<c<00Coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Folc<
c0Co000000?oc<c<o`000?o<c<`0>_o<c<aBool000Ooc<c<0_l00007olc<c003o`000?o<c<co0000
01;oc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<o`000006olc<c005o`000?o<c<coc<c<
olc<c?l000001_o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<
01;oc<c<1?l00005olc<c003o`000?o<c<coc<c<03Coc<c<F?oo0008olc<c003o`000?o<c<coc<c<
00Coc<c<00?o0000olc<c?l000004_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<co0000
00Go000000?oc<c<o`000?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c07ooooo000^olc<c003
o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03oo<c<`3o`0000;oc<c<00?o0000olc<c?o<
c<`0=_o<c<a8ool000?oOol04ooo0008olc<c003o`000?o<c<coc<c<00Coc<c<0_l000000oo<c<co
0000o`000002o`0000goc<c<00Co0000olc<c?o<c<coc<c<1?l000000oo<c<co0000olc<c003olc<
c003o`000?o<c<co000000?oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<00_oc<c<1?l0000iolc<c2Ooo`001?moo`0Nool000So
Ool04ooo0008olc<c003o`000?o<c<coc<c<00Coc<c<0_l00004olc<c003o`000?o<c<coc<c<00[o
c<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c002olc<c004o`000?o<c<co0000o`00
00;oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;oo<c<`4o`0000[oc<c<1?l00003olc<c003
o`000?o<c<coc<c<03Coc<c<9Ooo000:ogoo01Woo`003Omoo`0Cool000Soc<c<00?o0000olc<c?o<
c<`02Oo<c<`00ol0003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<
c<`01?l00002olc<c004o`000?o<c<co0000o`0000Ooc<c<0Oooool003[oc<c<1?l0000iolc<c2Co
o`004?moo`0Dool001;oOol04?oo0002o`3oo`Soc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003o
c<c<olc<c00;olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`1ooooo`00
=_o<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`0=?o<c<`Rool000Co0?oo4_moo`0?ool000Co0?oo
4omoo`0;ool000Oo0?oo2?o<c<`2o`0000Coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c00<olc<c0Co00005Oo<c<`1ooooo`00<_o<c<`4o`000003olc<c?l0003oc<c<03Ooc<c<8_oo
0009o`3ooa;oOol02Ooo000:o`3ooa?oOol01ooo000;o`3oo`Koc<c<00?o0000olc<c?l000001?o<
c<`5o`0002Soc<c<0Oooool002ooc<c<0ol0000kolc<c2;oo`003Ol0oolBogoo00?oo`004?l0oolC
ogoo00;oo`004?l0ool8olc<c005o`000?o<c<coc<c<olc<c?l000001_o<c<`4o`0002;oc<c<0Ooo
ool002goc<c<0_l000000oo<c<co0000olc<c00golc<c2;oo`004_l0ool?ogoo00CoO`3o4_l0ool?
ogoo00CoO`3o4_l0ool8olc<c005o`000?o<c<coc<c<olc<c?l000001?o<c<`00ol0003oc<c<olc<
c002olc<c003o`000?o<c<coc<c<01ooc<c<0Oooool002goc<c<00Co0000olc<c?o<c<co0000=Oo<
c<`Qool001Oo0?oo2omoo`08ogl0oa;o0?oo2Omoo`0:ogl0oa;o0?oo2?o<c<`00ol0003oc<c<olc<
c006o`0000Coc<c<00?o0000olc<c?o<c<`07oo<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mV
IVHaolc<c0Co0?oo7?oo000Mo`3oo`KoOol03Omo0?lBo`3oo`?oOol04?mo0?lBo`3oo`Soc<c<00?o
0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01ooc<c<0Ooo
ool002goc<c<0_l000000oo<c<coIVIVolc<c00[olc<c0_o0?oo5Ooo000So`3oo`;oOol04Omo0?l?
o`3oo`Coo`004_mo0?l?o`3oo`?oo`002?o<c<`00ol0003oc<c<olc<c003olc<c0;o00000oo<c<`0
0ol0003oc<c<olc<c00Oolc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIRSoc<c<4?l0ool@
ool002Go0?oo1?oo000Bogl0o`_o0?oo2?oo000Bogl0o`Wo0?oo2Ooo0006olc<c0;o00001Oo<c<`0
0ol0003oc<c<o`000002o`0002;oc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV9?o<c<`4
ool001;o0?oo2ooo000So`3oo`[oo`004_mo0?l6o`3oo`goo`004_mo0?l3o`3oo`ooo`001oo<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`07_o<c<`1
ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHOolc<c0_oo`004_l0ool6ool0027o0?oo4?oo000B
ogl0o`;o0?oo4Ooo000?ogl0oaGoo`001oo<c<`00ol0003oc<c<olc<c002olc<c004o`000?o<c<co
c<c<olc<c0;o00008?o<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c13oo`004_l0
ool2ool0023o0?oo5Ooo000?ogl0oaKoo`002Omo0?lKool000Ooc<c<00?o0000olc<c?o<c<`00_o<
c<`3o`0000;oc<c<00?o0000olc<c?o<c<`07Oo<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mV
IVHKolc<c1;oo`003_l0ool4ogl0oa_o0?oo6ooo0009ogl0oacoo`000omo0?lQool000Ooc<c<00?o
0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c00Molc<c07ooooo000/olc<c005o`000?o<c<co
c<c<olc<c?mVIVH07Oo<c<`Bool000Oo0?oo2omo0?lDo`3oob7oo`000omo0?m3ool000;oO`3o2?o<
c<`2o`0000Ooc<c<00?o0000olc<c?o<c<`07?o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mV
IVHOolc<c1;oo`000_l0oolAogl0o`ko0?ooI_oo0008ogl0o`Koc<c<00?o0000olc<c?l000001oo<
c<`00ol0003oc<c<olc<c00Lolc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIR7oc<c<4_oo
000Bogl0o`So0?ooI_oo000>ogl0o`Soc<c<00?o0000olc<c?o<c<`01Oo<c<`00ol0003oc<c<o`00
0003o`0001Soc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV8oo<c<`Bool001;oO`3o0_l0
oomWool001;oO`3o1oo<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<00;oc<c<00?o
0000olc<c?o<c<`05Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHTolc<c1?oo`003_mo
0?m/ool001;oO`3o1oo<c<`00ol0003oc<c<olc<c006o`0000Coc<c<00?o0000olc<c?o<c<`05Oo<
c<`1ooooo`00;?o<c<`2o`000003olc<c?mVIVKoc<c<02Goc<c<4_oo0008ogl0og;oo`004_mo0?l7
olc<c003o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00E
olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIRSoc<c<4_oo0002ogl0ogOoo`003omo0?l3
ogoo00Koc<c<0_l00006olc<c0Co00006?o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHJ
olc<c003ofIVI_o<c<coc<c<00goc<c<R_oo0009ogl0o`WoOol01oo<c<`00ol0003oc<c<olc<c002
olc<c003o`000?o<c<coc<c<00;oc<c<0ol0000Eolc<c07ooooo000/olc<c004o`000?o<c<coc<c<
ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`03_o<c<b:ool000?oO`3o3omoo`07olc<c005o`000?o<c<co
c<c<olc<c?l000000oo<c<`2o`0000;oc<c<00?o0000olc<c?o<c<`04_o<c<`1ooooo`00;?o<c<`0
1?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<013oc<c<QOoo0005o`3ooa7oOol01oo<
c<`01?l0003oc<c<olc<c?l00004olc<c005o`000?o<c<coc<c<olc<c?l000004oo<c<`1ooooo`00
;?o<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01;oc<c<O?oo000=o`3ooa7o
Ool01_o<c<`01?l0003oc<c<olc<c?o<c<`7o`000003olc<c?l0003oc<c<01;oc<c<0Oooool002co
c<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Colc<c7Goo`000omo0?lAo`3o
o`koOol00ooo0005olc<c0?o00001?o<c<`01?l0003oc<c<olc<c?o<c<`2o`0001?oc<c<0Oooool0
02coc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Eolc<c6koo`002Omo0?lA
o`3oo`SoOol02Ooo0006olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00_o<c<`0
1?l0003oc<c<olc<c?l00004olc<c0Co00002?o<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mV
IVHJolc<c003ofIVI_o<c<coc<c<01Koc<c<J?oo000?ogl0oa7o0?oo0_moo`0?ool000Koc<c<00Go
0000olc<c?o<c<coc<c<o`000004olc<c004o`000?o<c<coc<c<o`0000?oc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c005olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQ[o
c<c<00?oIVIVolc<c?o<c<`06?o<c<aVool0013oO`3o3_l0ool2ogoo01;oo`001_o<c<`01?l0003o
c<c<olc<c?l00004olc<c004o`000?o<c<coc<c<o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`0
0ol0003oc<c<olc<c005olc<c07ooooo000/olc<c0;o000000?oc<c<ofIVI_o<c<`06Oo<c<`00omV
IVKoc<c<olc<c00Iolc<c6Koo`004?mo0?l8o`3oo`SoOol04_oo0006olc<c003o`000?o<c<coc<c<
00Co00000oo<c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`01Oo<c<`1
ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01_oc<c<IOoo000@
ogl0o`;o0?oo3_moo`0Aool000Koc<c<0_l00008olc<c005o`000?o<c<coc<c<olc<c?l000001?o<
c<`00ol0003oc<c<olc<c005olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`07Oo<c<aTool0017oO`3o3omoo`0Aool000Ooc<c<00?o0000olc<c?o<c<`01Oo<
c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`01Oo<c<`1ooooo`00:oo<
c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<027oc<c<H_oo000Aogl0o`ooOol0
4Ooo0003olc<c003ofIVI_o<c<coc<c<00Koc<c<0ol00003olc<c003o`000?o<c<coc<c<00;oc<c<
00?o0000olc<c?o<c<`01Oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIV
I_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<c<`03?o<c<aRool0013oO`3o2omoo`04o`3ooa7oo`00
0_o<c<`00omVIVKoc<c<olc<c008olc<c005o`000?o<c<coc<c<olc<c?l000001?o<c<`00ol0003o
c<c<olc<c005olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<
c<`05?o<c<`00omVIVKoc<c<olc<c00>olc<c67oo`004?mo0?l3ogoo00co0?oo4Ooo00000oo<c<co
IVIVolc<c009olc<c003o`000?o<c<coc<c<00;oc<c<1?l00008olc<c07ooooo000[olc<c004o`00
0?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00?olc<c67o
o`003Omo0?l3ool000oo0?oo3_oo0003olc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool002_oc<c<
00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017o
c<c<H?oo0007ogl0o`Woo`003ol0ool8ool000Soc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`00
:oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVolc<c?o<
c<`04_o<c<aIool000Go00000_oo0002ogl0o`koo`003ol0ool2ool000goc<c<00?oIVIVolc<c?o<
c<`06Oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Co
c<c<00?oIVIVolc<c?o<c<`04oo<c<aBool000Ko00001Ooo00000ol0003oo`00ool0000@ool000_o
0?oo4_o<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c0;oIVIV00?o0000ofIVI_o<c<`0
6Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01Goc<c<Booo0005o`0000coo`00
00?o0000ool00?oo00004?oo0003o`3ooaWoc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1ooooo`008?o<
c<`4o`0000Ooc<c<00Co0000olc<c?mVIVKoIVIV6_o<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIV
I_o<c<coc<c<01Koc<c<A?oo0006o`0001;oo`0000?o0000ool00?oo00003?oo000Oolc<c003ofIV
I_o<c<coc<c<01Woc<c<0Oooool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<
c004olc<c003o`000?o<c<coc<c<00?oIVIV6?o<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<
c<coc<c<01Soc<c<??oo0006o`0000Goo`0000?o0000ool00?oo00004Ooo00000ol0003oo`00ool0
0004ool000Coc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000O
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mV
IVH2olc<c0;oIVIV5_o<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<01[oc<c<=Ooo
0005o`0000coo`0000?o0000ool00?oo00004Ooo00000ol0003oc<c<olc<c007olc<c003ofIVI_o<
c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002
olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV1?o<c<`3ofIVIQ?oc<c<00?o
IVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00Kolc<c2koo`001_l0000Bool00003o`000?oo
003oo`00017oo`000_l00007olc<c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<
c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000
olc<c?o<c<coIVIV1oo<c<`2ofIVIQ7oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<
c00Aolc<c003ofIVI_o<c<coc<c<00Woc<c<9_oo0006o`0000Goo`0000?o0000ool00?oo00004Ooo
00000ol0003oo`00ool00007ool000Ko00001Ooo00000ol0003oc<c<olc<c004olc<c003ofIVI_o<
c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<c002
olc<c003o`000?o<c<coc<c<00?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP09olc<c0;oIVIV3oo<
c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`02oo<
c<`Oool000Go00003?oo00000ol0003oo`00ool0000Aool00004o`000?oo003oo`00ool000Go0000
3?oo0002o`0000Coc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo
000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<
c?mVIVH<olc<c0;oIVIV3Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<
00?oIVIVolc<c?o<c<`03?o<c<`Iool000Go00004_oo0002o`0001;oo`000ol0000Cool00005o`00
0?o<c<coc<c<olc<c?mVIVH08_o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?mVIVH>olc<c0;o
IVIV2oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<
c<`03_o<c<`Bool000Go00001?oo00000ol0003oo`00ool0000Bool00003o`000?oo003oo`0000Oo
o`001Ol00005ool00003o`000?oo003oo`0001;oo`0000Co0000olc<c?o<c<coIVIV8_o<c<`00omV
IVKoc<c<olc<c00Holc<c07ooooo000Polc<c0Co00001_o<c<`01?l0003oc<c<olc<c?mVIVH@olc<
c0;oIVIV2Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<
c?o<c<`04?o<c<`;ool000Go00002_oo0002o`0001?oo`0000Co0000ool00?oo003oo`001Ol0000;
ool000;o00004ooo00000ol0003oc<c<ofIVIP0Rolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool0
02[oc<c<0_l000000oo<c<coIVIVolc<c00Aolc<c0;oIVIV1oo<c<`00omVIVKoc<c<olc<c00Colc<
c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`04_o<c<`3ool000Ko00004Ooo00000ol0
003oo`00ool0000Aool000?o00004_oo00000ol0003oo`00ool00007ool000Ko00001?oo00000ol0
003oIVIVolc<c00Qolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<
c<coIVIV5?o<c<`2ofIVIPGoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omVIVKoc<c<olc<c00Bolc<
c003ofIVI_o<c<coc<c<013oc<c<1Ol00005ool00003o`000?oo003oo`00013oo`000_l00009ool0
00Go00001Ooo00000ol0003oo`00ool0000Aool00004o`000?oo003oo`00ool000Go00002ooo0000
0ol0003oc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<
c?o<c<coIVIV5_o<c<`2ofIVIP?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omVIVKoc<c<olc<c00B
olc<c003ofIVI_o<c<coc<c<00_oc<c<1Ol0000;ool00003o`000?oo003oo`00017oo`0000Co0000
ool00?oo003oo`001Ol0000;ool000;o00004_oo0003o`00017oo`0000?o0000olc<c?o<c<`07oo<
c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<0omV
IVHFolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`01_o<c<`5o`00017oo`000_l0
000Bool000?o00004_oo00000ol0003oo`00ool00007ool000Go00001Omoo`000ol0003oo`00ool0
000@ool00003o`000?o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`0
1?l0003oc<c<olc<c?mVIVHJolc<c0?oIVIV5?o<c<`00omVIVKoc<c<olc<c00Bolc<c004ofIVI_o<
c<coc<c<olc<c0Go00001?oo0002o`0001;oo`0000?o0000ool00?oo00001ooo0005o`0000GoOol0
00?o0000ool00?oo00004Ooo00001?l0003oo`00ool00?oo0005o`0000_oOol000?o0000ool00?oo
00004?oo00000ol0003oc<c<olc<c00Molc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<
00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c002ofIVIQ;oc<c<00?oIVIVolc<c?o<
c<`04Oo<c<`5o`0000_oo`000_l0000Aool00004o`000?oo003oo`00ool000Go00002omoo`02o`00
01;oo`000ol0000Aogoo0003o`000?oo003oo`00013oo`0000?o0000olc<c?o<c<`07?o<c<`00omV
IVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<
c?o<c<`00_o<c<`2ofIVIQ3oc<c<00?oIVIVolc<c?o<c<`03Oo<c<`4o`0001;oo`000_l0000@ool0
00?o00004_moo`02o`0000Woo`001Ol00002o`3oo`03o`000?moo`3oOol001;oOol000?o0000ool0
0?oo00001ooo0005o`0000?o0?oo00?o0000olc<c?o<c<`07?o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`01?o<c<`2ofIV
IPkoc<c<00?oIVIVolc<c?o<c<`02?o<c<`5o`0000Coo`000_l0000Bool000;o00001?oo0007o`00
00?o0?oo00?o0000ogoo0?moo`005?moo`001?l0003oo`00ool00?oo0005o`0000Oo0?oo00?o0000
ogoo0?moo`004omoo`001?l0003oo`00ool00?oo0005o`0000So0?oo00?o0000olc<c?o<c<`07?o<
c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?o
IVIVolc<c?o<c<`01_o<c<`2ofIVIPcoc<c<00?oIVIVolc<c?o<c<`00oo<c<`5o`0000_oo`000_l0
000Bool000Co00002_l0ool00ol0003oOol0ogoo000Eogoo00?o00003?l0ool00ol0003oOol0ogoo
000Dogoo00?o00003Ol0ool00ol0003oc<c<olc<c00Lolc<c003ofIVI_o<c<coc<c<01Soc<c<0Ooo
ool002[oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c008olc<c0;oIVIV2_o<
c<`01?mVIVKoc<c<olc<c?o<c<`2o`0001;oo`0000?o0000ool00?oo00002?oo0005o`00013o0?oo
00?o0000ogoo0?moo`005Omoo`000ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001CoOol0
00?o0000o`3oool0ool03Ol0ool00ol0003oc<c<olc<c00Lolc<c003ofIVI_o<c<coc<c<01Soc<c<
0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00:olc<c0;oIVIV
2?o<c<`01_mVIVKoc<c<olc<c?o<c<co0000o`3oo`;o00004Ooo0002o`0000?oo`001Ol0000Eo`3o
o`03o`000?moo`3oOol001GoOol000?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Dogoo
0003o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`07?o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Zolc<c0;o000000?oc<c<ofIVI_o<c<`06Oo<c<`00omVIVKoc<c<olc<c00<olc<c0?o
IVIV1Oo<c<`01OmVIVKoc<c<olc<c?o<c<co000000?o0?oo0_l0000Aool000?o00006_l0ool00ol0
003oOol0ogoo000Eogoo0003o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`000ol0
003o0?ooo`3oo`0>o`3oo`03o`000?o<c<coc<c<01_oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1oooo
o`00:Oo<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01[oc<c<00?oIVIVolc<c?o<c<`03oo<c<`2ofIV
IP?oc<c<00GoIVIVolc<c?o<c<coc<c<o`000005o`3oo`03o`000?oo003oo`0000Ooo`001Ol0000A
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`005Omoo`000ol0003o0?ooo`3oo`0=
o`3oo`03o`000?moo`3oOol001?oOol000?o0000o`3oool0ool03_l0ool00ol0003oc<c<olc<c00L
olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`0
0omVIVKoc<c<olc<c00Aolc<c0;oIVIV00Goc<c<ofIVI_o<c<coc<c<o`000007o`3oo`;o00000_oo
0005o`0001Ko0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Dogoo00;o00003ol0
ool00ol0003oOol0ogoo000Bogoo00;o00004?l0ool00ol0003oc<c<olc<c00Lolc<c0CoIVIV5_o<
c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01?oc<c<0_mV
IVH2olc<c003o`000?l0oooo0?oo00Oo0?oo0_l0000Ko`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`004omoo`02o`0000oo0?oo00?o0000ogoo0?moo`004_moo`02o`00013o0?oo00?o
0000olc<c?o<c<`05Oo<c<`8ofIVIQWoc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<
c<`00omVIVKoc<c<olc<c00Dolc<c0?oIVIV00?o0000o`3oool0ool01ol0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000Cogoo0003o`000?mo0?oo000000ko0?oo00?o0000ogoo0?moo`004_moo`000ol0003oO`3oo`00
000?o`3oo`03o`000?o<c<coc<c<00ooc<c<1_mVIVH7olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Ooo
ool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Dolc<c004ofIVI_o<
c<coc<c<o`0000Wo0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004omoo`000ol0003oO`3oo`00000>o`3oo`03o`00
0?moo`3oOol001;oOol000?o0000ogl0ool000003ol0ool00ol0003oc<c<olc<c008olc<c0OoIVIV
3Oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<
00?oIVIVolc<c?o<c<`05?o<c<`01?mVIVKoc<c<olc<c?l00009o`3oo`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001?o
Ool000?o0000ogl0ool000003_l0ool00ol0003oOol0ogoo000Bogoo0003o`000?mo0?oo000000oo
0?oo00?o0000olc<c?o<c<`00_o<c<`6ofIVIQCoc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00
:Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01Coc<c<00CoIVIVolc<c?o<
c<co00002?l0ool2o`0000go0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?moo`3oOol001?oOol000?o0000ogl0ool000003_l0ool00ol0003oOol0ogoo000Bogoo
0003o`000?mo0?oo000000oo0?oo00?o0000ofIVI_mVIVH00_mVIVHJolc<c003ofIVI_o<c<coc<c<
01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Dolc<
c003ofIVI_o<c<co000000Wo0?oo0_l0000=o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3o
ool0ool02ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?oo000000ko0?oo00?o0000ogoo
0?moo`004_moo`000ol0003oO`3oo`00000?o`3oo`03o`000?o<c<coc<c<00goc<c<0_l0000=olc<
c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omV
IVKoc<c<olc<c00Dolc<c003ofIVI_o<c<co000000Wo0?oo0_l0000>o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?mo0?oo0000
00ko0?oo00?o0000ogoo0?moo`004_moo`000ol0003oO`3oo`00000?o`3oo`03o`000?o<c<coc<c<
00goc<c<00?o0000ogoo0?l000003?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004
o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<o`000009o`3o
o`;o00003_l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo
0?moo`004_moo`001?l0003oO`3oogl0ool0000>o`3oo`03o`000?moo`3oOol001;oOol000?o0000
ogl0ool000003ol0ool00ol0003oc<c<olc<c00=olc<c004o`000?moo`3oOol0o`0000_oc<c<00?o
IVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`2o`000003olc<c?mVIVKoc<c<01[oc<c<00?oIVIV
olc<c?o<c<`05?o<c<`00omVIVKoc<c<o`000009o`3oo`;o00003_l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004_moo`001?l0003oO`3oogl0ool0
000>o`3oo`03o`000?moo`3oOol0017oOol000Co0000ogl0oomo0?oo00004?l0ool00ol0003oc<c<
olc<c00<olc<c005o`000?moo`3oOol0ogoo0?l000002_o<c<`00omVIVKoc<c<olc<c00Golc<c07o
oooo000Yolc<c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`00omVIVKo
c<c<o`000009o`3oo`03o`000?mo0?oo000000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol001;oOol000Co0000ogl0oomo0?oo00003_l0ool00ol0
003oOol0ogoo000Aogoo0004o`000?mo0?ooO`3oo`00013o0?oo00?o0000olc<c?o<c<`03?o<c<`0
0ol0003oOol0ogoo0002ogoo00;o00002?o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<
c004o`000?o<c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`00omVIVKoc<c<o`000009
o`3oo`03o`000?mo0?oo000000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?moo`3oOol001;oOol000Co0000ogl0oomo0?oo00003ol0ool00ol0003oOol0ogoo
000@ogoo0004o`000?mo0?ooO`3oo`00013o0?oo00?o0000olc<c?o<c<`01oo<c<`4o`000003ogl0
ool0003oOol000?oOol00_oo00000ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<01Ooc<c<
0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`00omVIVKoc<c<olc<c00Eolc<c003ofIV
I_l0003o0?oo00So0?oo00Co0000ogl0oomo0?oo00003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`004_moo`001?l0003oO`3oogl0ool0000?o`3o
o`03o`000?moo`3oOol0013oOol000Co0000ogl0oomo0?oo00004?l0ool00ol0003oc<c<o`000007
o`0000CoOol000?oO`3oo`000?moo`000omoo`03ool00003o`000?o<c<coc<c<00Coc<c<00?oIVIV
olc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<co
c<c<01Goc<c<00?oIVIVo`000?l0ool02?l0ool01?l0003oO`3oogl0ool0000=o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000Bogoo0004o`000?mo
0?ooO`3oo`0000oo0?oo00?o0000ogoo0?moo`004?moo`001Ol0003oO`3oogl0oomo0?oo000000oo
0?oo0_l00004o`3oo`03o`000?moo`3oOol000GoOol000?oO`3oo`000?moo`000omoo`04ool00003
o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<
olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<01Goc<c<00?oIVIVo`000?l0ool02?l0ool01?l0003o
O`3oogl0ool0000=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000Aogoo0004o`000?mo0?ooO`3oo`0000oo0?oo00?o0000ogoo0?moo`004?moo`00
1Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o0000o`3oool0ool00ol0ool00ol0003oOol0ogoo
0005ogoo0003ogl0ool0003oOol000?oOol01Ooo00000ol0003oc<c<olc<c002olc<c003ofIVI_o<
c<coc<c<01Ooc<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c00Eolc<c003ofIVI_l0003o0?oo00So0?oo00Co0000ogl0oomo0?oo00003Ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3o
ogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`001Ol0003oO`3o
ogl0oomo0?oo000000oo0?oo00?o0000o`3oool0ool00ol0ool00ol0003oOol0ogoo0005ogoo0003
ogl0ool0003oOol000;oOol00ol00004ool00005o`000?o<c<coc<c<olc<c?mVIVH06Oo<c<`1oooo
o`00:?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01Goc<c<00?oIVIVo`00
0?l0ool02?l0ool01?l0003oO`3oogl0ool0000=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0005o`000?mo0?ooO`3oogl0ool000003ol0
ool00ol0003o0?ooo`3oo`03o`3oo`03o`000?moo`3oOol000GoOol000?oO`3oo`000?moo`000_mo
o`08ool00004o`000?o<c<coc<c<ofIVIQWoc<c<0Oooool002Soc<c<00Co0000olc<c?o<c<coIVIV
6oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<co000000Wo0?oo00Co0000ogl0oomo0?oo
00003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`004?moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`004?moo`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo00?o0000o`3oool0ool00ol0ool00ol0
003oOol0ogoo0004ogoo00;oO`3o00Co0000ogoo0?moo`3oOol02Ooo00000ol0003oc<c<ofIVIP0I
olc<c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`05?o<c<`0
0omVIVKo0000o`3oo`08o`3oo`05o`000?mo0?ooO`3oogl0ool000003Ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`000ol0003oO`3oogl0
o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0
o`02ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool00ol0ool00ol0003oOol0ogoo
0004ogoo00;oO`3o00Co0000ogoo0?moo`3oOol02_oo00000ol0003oc<c<ofIVIP0Holc<c07ooooo
000Xolc<c0?o000000?oIVIVolc<c?o<c<`06Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_l0
003o0?oo00So0?oo00Go0000ogl0oomo0?ooO`3oo`00000=o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00;oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00;oO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`03o`3oo`03o`000?moo`3oOol000CoOol0
0_mo0?l01?l0003oOol0ogoo0?moo`07o`0000Goc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`00
7?o<c<`6o`0000Koc<c<0_mVIVH00oo<c<coIVIVolc<c00Jolc<c003ofIVI_o<c<coc<c<01Coc<c<
00?oIVIVo`000?l0ool02?l0ool01Ol0003oO`3oogl0oomo0?oo000000go0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0013oOol000?o0000ogl0oomo
0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo
0?l00_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?mo
o`001?moo`02ogl0o`04o`000?moo`3oOol0ogoo00coc<c<00?oIVIVolc<c?o<c<`05_o<c<`1oooo
o`007?o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coIVIV00;oIVIV6_o<c<`00omVIVKo
c<c<olc<c00Dolc<c003ofIVI_l0003o0?oo00So0?oo00Go0000ogl0oomo0?ooO`3oo`00000=o`3o
o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0ool00ol0003oOol0ogoo000@ogoo
0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo
0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03_l0ool00ol0003o0?ooo`3oo`02o`3o
o`03o`000?moo`3oOol000CoOol00_mo0?l01?l0003oOol0ogoo0?moo`0<olc<c003ofIVI_o<c<co
c<c<01Koc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`02?o<c<`01Ol0003oc<c<olc<c?mVIVKo
c<c<00?oIVIV5oo<c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_l0003o0?oo00So0?oo00Go0000
ogl0oomo0?ooO`3oo`00000=o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool02ol0
ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03_l0
ool00ol0003o0?ooo`3oo`02o`3oo`03o`000?moo`3oOol000CoOol00_mo0?l00ol0003oOol0ogoo
000=olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool001koc<c<0_l00008olc<c004o`000?o<c<co
c<c<ofIVIPCoc<c<0omVIVHDolc<c003ofIVI_o<c<coc<c<01Coc<c<00?oIVIVo`000?l0ool02?l0
ool01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?moo`001?moo`02ogl0o`03o`00
0?moo`3oOol000goc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`008?o<c<`00ol0003oc<c<olc<
c005olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<0omVIVHAolc<c003ofIVI_o<c<coc<c<01Coc<c<
00?o0000o`3oool0ool02?l0ool01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000o`3oool0
ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo
0?l00omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo
0?l00_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?mo
o`000omoo`03ogl0o`03o`000?moo`3oOol000goc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`00
8Oo<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP[oc<c<0omVIVH>olc<c003
ofIVI_o<c<coc<c<01Coc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`02ogl0o`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?l0oooo0?oo00;o0?oo00?o0000ogoo0?moo`000omoo`03ogl0o`03o`000?moo`3oOol000go
c<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c002olc<c003o`00
0?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV3Oo<c<`3ofIVIP_oc<c<00?oIVIVolc<c?o<
c<`05?o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?mo
o`003omoo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?mo
o`003_moo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0
ool00_l0ool00ol0003oOol0ogoo0003ogoo00?oO`3o00?o0000ogoo0?moo`003Oo<c<`00omVIVKo
c<c<olc<c00Folc<c07ooooo000Lolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`0
1?o<c<`01?l0003oc<c<olc<c?mVIVH@olc<c0;oIVIV2Oo<c<`00omVIVKoc<c<olc<c00Dolc<c003
o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003
o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo0003
o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`02o`3oo`03
o`000?moo`3oOol000?oOol00omo0?l00ol0003oOol0ogoo000=olc<c003ofIVI_o<c<coc<c<01Ko
c<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c002o`0000;oc<c<
00?o0000olc<c?o<c<`02_o<c<`4o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV4_o<c<`3ofIVIPKo
c<c<00?oIVIVolc<c?o<c<`05?o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00?o
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000o`3oool0ool00_l0ool00ol0003oOol0ogoo0003ogoo00?oO`3o00?o0000ogoo0?o<
c<`03Oo<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<
00Co0000olc<c?o<c<co00006oo<c<`01?l0003oc<c<olc<c?mVIVHEolc<c0?oIVIV0oo<c<`00omV
IVKoc<c<olc<c00Dolc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l00omo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003o0?ooo`3oo`02o`3oo`03o`000?moo`3oOol000?oOol00omo0?l00ol0003oOol0olc<c00=olc<
c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003o
c<c<olc<c?l0000Jolc<c005o`000?o<c<coc<c<olc<c?mVIVH06?o<c<`3ofIVIQKoc<c<00?o0000
o`3oool0ool02?l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000
ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o0000
ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00;o0?oo00?o0000
ogoo0?moo`000_moo`04ogl0o`03o`000?moo`3oc<c<00goc<c<00?oIVIVolc<c?o<c<`05_o<c<`1
ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001[oc<c<0_l00000
0oo<c<coIVIVolc<c00Jolc<c0CoIVIV4oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?oo
O`3o00CoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo
0?oo00ko0?oo00Go0000o`3oool0oooo0?ooo`000004ogoo00CoO`3o00?o0000ogoo0?o<c<`03Oo<
c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<c0Oo00000_o<c<`00ol0003oc<c<olc<c00H
olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00CoIVIVolc<c?o<c<coc<c<0omVIVH@olc<c003o`00
0?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000=ogoo0003o`00
0?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000=ogoo0003o`00
0?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03_l0ool01Ol0003o0?ooo`3oool0oooo000000Co
Ool01?mo0?l00ol0003oOol0olc<c00=olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<
00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c004o`000?o<c<coc<c<ofIV
IQ_oc<c<00?oIVIVolc<c?o<c<`01?o<c<`2ofIVIPkoc<c<00?o0000o`3oool0ool01ol0ool00ol0
003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01?mo0?l00ol0
003o0?ooo`3oo`0>o`3oo`05o`000?l0oooo0?ooo`3oool000001?moo`04ogl0o`03o`000?moo`3o
c<c<00goc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<
c003o`000?o<c<co000000;o00006Oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<co
c<c<00Koc<c<0omVIVH;olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l01?mo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03_l0ool0
1Ol0003o0?ooo`3oool0oooo000000CoOol01?mo0?l00ol0003oOol0olc<c00=olc<c003ofIVI_o<
c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c00H
olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`02Oo<c<`3ofIVIPSoc<c<00?o
0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol000?o
0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000coOol000?o
0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`05o`000?l0oooo0?ooo`3oool00000
1?moo`04ogl0o`03o`000?o<c<coc<c<00goc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`000oo<
c<`7o`0000;oc<c<00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIV
I_o<c<coc<c<00coc<c<0omVIVH4olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l0
1?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool0
3_l0ool01Ol0003o0?ooo`3oool0oooo000000?oOol01Omo0?l00ol0003oc<c<olc<c00=olc<c003
ofIVI_o<c<coc<c<01Koc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKo
c<c<olc<c00?olc<c0?oIVIV00?oc<c<o`000?l0ool02Ol0ool00ol0003oO`3oogl0o`04ogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05
o`000?l0oooo0?ooo`3oool000000omoo`05ogl0o`03o`000?o<c<coc<c<00goc<c<1OmVIVHDolc<
c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omV
IVKo0000o`3oo`08o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`003Omoo`000ol0
003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0
003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00Co0000o`3oool0oooo00001?moo`05
ogl0o`03o`000?o<c<coc<c<00Goc<c<2?mVIVH00oo<c<coIVIVolc<c00Folc<c07ooooo000Wolc<
c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`07
o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`06
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06
ogl0o`03o`000?l0oooo0?oo00go0?oo00Co0000o`3oool0oooo00001?moo`05ogl0o`03o`000?mV
IVKoIVIV00GoIVIV2Oo<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo
0?ooO`3o00GoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0
oooo0?oo00go0?oo00Co0000o`3oool0oooo00001?moo`05ogl0o`03o`000?o<c<coc<c<00koc<c<
00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIV
I_o<c<coc<c<01?oc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000_oOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000_oOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`00
0?l0oooo0?ooo`0000CoOol01Omo0?l00ol0003oc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<01Go
c<c<0Oooool002Ooc<c<0_l000000oo<c<coIVIVolc<c00Jolc<c003ofIVI_o<c<coc<c<01;oc<c<
00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol0
00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol0
00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?l0oooo000000CoOol0
1Omo0?l00ol0003oc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Ooc<c<00Co
0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00So0?oo
00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00OoO`3o
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00KoO`3o
00?o0000o`3oool0ool03_l0ool00ol0003o0?ooo`000003ogoo00KoO`3o00?o0000olc<c?o<c<`0
3_o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<
00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00OoO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000o`3oool000000omoo`06ogl0o`03o`000?o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`0
5Oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01;oc<c<
00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol0
00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol0
00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?l0oooo000000?oOol0
1_mo0?l00ol0003oc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Go
0000olc<c?o<c<coc<c<ofIVIP0Kolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o0000o`3oool0ool0
1ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l0
2?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l0
1omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?l0oooo000000?oOol01_mo0?l00ol0003oc<c<
olc<c00>olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV
7?o<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l0
1omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool0
3_l0ool00ol0003o0?ooo`000003ogoo00KoO`3o00?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<
olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`0
4Oo<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
2_moo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
2Omoo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool00000
0omoo`06ogl0o`03o`000?o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<
c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<017oc<c<00?o0000o`3oool0ool0
2?l0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l0
2?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l0
2?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo000000;oOol01omo0?l00ol0003oc<c<
olc<c00>olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV
6oo<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l0
1omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003o0?ooo`000002ogoo00OoO`3o00?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<
olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`0
4_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
2_moo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
2Omoo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool00000
0_moo`07ogl0o`03o`000?o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<
c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o0000o`3oool0ool0
1ol0ool00ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l0
2?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000WoOol000?o0000ogl0oomo0?l0
2?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o00000_moo`07ogl0o`03o`000?o<c<coc<c<00koc<c<
00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009_o<c<`2o`000003olc<c?mVIVKoc<c<01[oc<c<00?o
IVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00ko0?oo0_l0
0002ogoo00OoO`3o00?o0000olc<c?o<c<`03_o<c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000V
olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3o
o`08o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0
o`0:ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0
o`09ogl0o`03o`000?l0oooo0?oo00ko0?oo0_l00002ogoo00OoO`3o00?o0000olc<c?o<c<`03_o<
c<`00omVIVKoc<c<olc<c00Eolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00SoO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00ko0?oo0_l0
00000omoo`3oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`05Oo<
c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<017oc<c<00?o
0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000SoOol000?o
0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000SoOol000?o
0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o000000?oOol0ogl0oomo0?l01_mo
0?l00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000
olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00Oo0?oo00?o
0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool03_l0ool2o`000003ogoo0?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`03oo<
c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00ko0?oo0_l0
00000omoo`3oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`05?o<
c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003ofIVI_o<c<coc<c<017oc<c<00?o
0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000SoOol000?o
0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000OoOol000?o
0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o000000?oOol0ogl0oomo0?l01_mo
0?l00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Koc<c<00Co0000
olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00Aolc<c003o`000?l0oooo0?oo00Oo0?oo00?o
0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool03Ol0ool2o`000003ogoo0?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`03oo<
c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?o
IVIVolc<c?o<c<`04?o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo0_l0
0009ogl0o`03o`000?o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009Oo<c<`0
1?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool02?l0
ool00ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l02omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l02_mo
0?l00ol0003o0?ooo`3oo`0=o`3oo`;o00002Omo0?l00ol0003oc<c<olc<c00?olc<c003ofIVI_o<
c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<
c00@olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
0006ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0
o`07ogl0o`03o`000?o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`0
0ol0003oc<c<olc<c005olc<c0CoIVIV7?o<c<`00omVIVKoc<c<olc<c00@olc<c003o`000?l0oooo
0?oo00Oo0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?oo
O`3o00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?oo
O`3o00_oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<co
c<c<00ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<
c003o`000?o<c<coc<c<00CoIVIV6Oo<c<`00omVIVKoc<c<olc<c00@olc<c003o`000?l0oooo0?oo
00Oo0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o
00_oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o
00_oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?o<c<coc<c<
00ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006Oo<c<`6o`0000Koc<c<00Co0000olc<c?o<
c<coIVIV0oo<c<`4ofIVIQGoc<c<00?oIVIVolc<c?o<c<`04?o<c<`00ol0003o0?ooo`3oo`07o`3o
o`03o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3oogl0o`0;ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3oogl0o`0;ogl0
o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<c00?olc<
c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001Woc<c<00Go0000olc<c?o<c<coc<c<o`000007olc<
c004o`000?o<c<coc<c<ofIVIPOoc<c<1OmVIVH@olc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000
o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000KoOol000?o0000
ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000KoOol000?o0000
ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000
olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Jolc<c004o`000?o<c<coc<c<
o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV3?o<c<`4ofIVIPcoc<c<00?oIVIVolc<c?o<c<`03oo<
c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001_mo
o`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001_mo
o`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01omo
0?l00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001_oc<c<00?o0000
olc<c?l000001oo<c<`01?l0003oc<c<olc<c?mVIVH@olc<c0CoIVIV2?o<c<`00omVIVKoc<c<olc<
c00?olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
0005ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0006ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0
o`07ogl0o`03o`000?o<c<coc<c<00ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006oo<c<`0
0ol0003oc<c<o`000007olc<c004o`000?o<c<coc<c<ofIVIQCoc<c<1?mVIVH3olc<c003ofIVI_o<
c<coc<c<013oc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0;ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000GoOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000GoOol000?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo
0?ooO`3o00OoO`3o00?o0000olc<c?o<c<`03oo<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000L
olc<c0;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c0CoIVIV4_o<c<`00ol0003o0?ooo`3o
o`07o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0
o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0
o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<
c00?olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001goc<c<00?o0000olc<c?o<c<`01Oo<c<`0
1?l0003oc<c<olc<c?mVIVHKolc<c0GoIVIV3_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo
0?ooO`3o00coO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<c00?olc<c003ofIVI_o<
c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<
c002olc<c0GoIVIV2?o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogl0oomo0?l01omo0?l00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Coc<c<0Ooo
ool002Goc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c007olc<c0CoIVIV1?o<
c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001Omo
o`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001?mo
o`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo
0?l00ol0003oc<c<olc<c00?olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000
olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00;olc<c0CoIVIV00?o0000o`3oool0ool02?l0
ool00ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l03Omo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03Omo
0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`04?o<
c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Uolc<c0;o000000?oc<c<ofIVI_o<c<`06_o<c<`0
0omVIVKoc<c<olc<c00?olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l03Omo0?l0
0ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool0
0ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03_l0ool0
0ol0003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<00goc<c<1omVIVHBolc<c07ooooo000Uolc<
c004o`000?o<c<coc<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`07
o`3oo`03o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0>
ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=
ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo0?l01?l0003oc<c<olc<c?o<
c<`<ofIVIP?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mV
IVHLolc<c003ofIVI_o<c<coc<c<00ooc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0
o`0>ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3o
o`0>o`3oo`03o`000?mo0?ooO`3o00KoO`3o00Co0000ofIVI_mVIVKoIVIV3oo<c<`00omVIVKoc<c<
olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`0
3_o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
0omoo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
1?moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l0
1_mo0?l00ol0003oc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co
0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c00>olc<c003o`000?l0oooo0?oo00So0?oo
00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00ooO`3o
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00goO`3o
00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<013oc<c<
00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIV
I_o<c<coc<c<00koc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0>ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol000?oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000?oOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`00
0?mo0?ooO`3o00KoO`3o00?o0000olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo
000Tolc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?oo
o`3oo`08o`3oo`03o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000omoo`000ol0003oO`3o
ogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3o
ogl0o`0>ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oc<c<
olc<c00@olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV
7?o<c<`00omVIVKoc<c<olc<c00>olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l0
3_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`0
4oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00koc<c<
00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000?oOol0
00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol0
00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00KoO`3o
00?o0000olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<
c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`00
0?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0?ogl0o`03o`00
0?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<c00@olc<c003ofIV
I_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<
olc<c00=olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo0002ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo0002ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3o
ogl0o`05ogl0o`03o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<
c<`2o`000003olc<c?mVIVKoc<c<01_oc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3o
o`08o`3oo`03o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0
o`0@ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0
o`0?ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<
c00@olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV7?o<
c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l03omo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03_l0
ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`04oo<
c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00goc<c<00?o
0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000;oOol000?o
0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o
0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o
0000olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<co
c<c<ofIVIQ_oc<c<00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo
0?ooO`3o017oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0@ogl0o`03o`000?l0
oooo0?oo00go0?oo00Go0000ogoo0?moo`3oOol0o`00000Bogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogl0oomo0?l01Omo0?l00ol0003oc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<01?oc<c<
0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6oo<c<`00omVIVKoc<c<olc<c00=olc<c003o`00
0?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0002ogoo0003o`00
0?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03Ol0ool01Ol0003oOol0ogoo0?moo`3o000001;o
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?o<c<coc<c<013o
c<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHKolc<c003
ofIVI_o<c<coc<c<00goc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0Aogl0o`03
o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`05
o`000?moo`3oOol0ogoo0?l000004_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?moo`3oOol0
ogoo0?l000004_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000
olc<c?o<c<`04?o<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Solc<c005o`000?o<c<coc<c<
olc<c?mVIVH06oo<c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00So0?oo00?o0000
ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03Ol0ool01?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00co0?oo00Go
0000ogoo0?moo`3oOol0o`00000Bogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l0
1Omo0?l00ol0003oc<c<olc<c00@olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002?oc<c<00Co
0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00So0?oo
00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03Ol0ool01?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00go
0?oo00Co0000ogoo0?moo`3o00004_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o
00GoO`3o00?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004
o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3oo`08o`3o
o`03o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00go0?oo00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0=
o`3oo`04o`000?moo`3oOol0o`0001?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0
o`05ogl0o`03o`000?o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`0
1?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00goc<c<00?o0000o`3oool0ool02?l0
ool00ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0=o`3oo`04o`000?moo`3oOol0o`0001CoO`3o00?o0000o`3oool0ool0
3Ol0ool01?l0003oOol0ogoo0?l0000Cogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo
0?l01?mo0?l00ol0003oc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<
00Co0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo00So
0?oo00?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03Ol0ool01?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo
00go0?oo00Co0000ogoo0?moo`3o00004omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?oo
O`3o00CoO`3o00?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<
c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03?o<c<`00ol0003o0?ooo`3oo`08
o`3oo`03o`000?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00go0?oo00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`04o`000?moo`3oOol0o`0001?oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3o
ogl0o`04ogl0o`03o`000?o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<
c<`2o`000003olc<c?mVIVKoc<c<01_oc<c<00?oIVIVolc<c?o<c<`03?o<c<`00ol0003o0?ooo`3o
o`08o`3oo`03o`000?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3o000001CoO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3o
ogl0o`04ogl0o`03o`000?o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<
c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIVI_o<c<coc<c<00coc<c<00?o0000o`3oool0ool0
2?l0ool00ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001GoO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0o`00000Dogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l0
1?mo0?l00ol0003oc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co
0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c00<olc<c003o`000?l0oooo0?oo00So0?oo
00?o0000ogl0oomo0?l04_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00000Eogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?l000005?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o
00?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<
c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`03?o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`00
0?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3o000001CoO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`03o`00
0?o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<
c?mVIVHLolc<c003ofIVI_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3o
ogl0o`0Cogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3o000001GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
o`00000Dogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003oc<c<
olc<c00Aolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV
7?o<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l0
4omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0o`00000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l00000
5?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000olc<c?o<c<`0
4Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<
00?oIVIVolc<c?o<c<`02oo<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o01?oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo
0_l0000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005?mo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<
olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?oIVIVolc<c?o<c<`0
2oo<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00go0?oo0_l0000Fogl0o`03o`00
0?l0oooo0?oo00go0?oo0_l0000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l0
1?mo0?l00ol0003oc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co
0000olc<c?o<c<coIVIV7?o<c<`00omVIVKoc<c<olc<c00;olc<c003o`000?l0oooo0?oo00So0?oo
00?o0000ogl0oomo0?l05?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03Ol0ool2o`0001KoO`3o00?o0000o`3oool0ool03Ol0ool2o`0001GoO`3o
00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?o<c<coc<c<017oc<c<
00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIV
I_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0Dogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`0Dogl0o`03o`00
0?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003oc<c<olc<c00Aolc<c003ofIV
I_o<c<coc<c<01;oc<c<0Oooool002;oc<c<00Co0000olc<c?o<c<coIVIV7Oo<c<`00omVIVKoc<c<
olc<c00:olc<c003o`000?l0oooo0?oo00Wo0?oo00?o0000ogl0oomo0?l05?mo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oO`3o
ogl0o`0Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0oomo0?l05?mo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<
olc<c00Bolc<c07ooooo000Golc<c0Co00001oo<c<`01?l0003oc<c<olc<c?mVIVHLolc<c003ofIV
I_o<c<coc<c<00_oc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0o`0Eogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?mo0?ooO`3o01GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`0Dogl0o`03o`00
0?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003oc<c<olc<c00Aolc<c003ofIV
I_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<
c004olc<c0KoIVIV6_o<c<`00omVIVKoc<c<olc<c004olc<c0ko00001?l0ool00ol0003oO`3oogl0
o`0Eogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`05o`3oo`go00004omo0?l00ol0003o0?ooo`3oo`05o`3oo`go00002_mo0?lMo`0000;oO`3o00?o
0000olc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Folc<c003o`000?o<c<co
c<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH2olc<c0WoIVIV4Oo<
c<`7o`0000koo`002?l0000Dogl0o`03o`000?l0oooo0?oo00Co0?oo7_l0000=ool001_o00003Ooo
000:o`0000_oo`000ol0000?ool000?o00004oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000F
olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mV
IVH;olc<c0WoIVIV2?o<c<`00omVIVKoc<c<olc<c004olc<c0_o00002ooo0005o`0000SoO`3o3_l0
000:ool000Go00003Ooo000;o`0000[oo`001?l0000>ool000[o00003?oo0008o`0000[oo`002Ol0
000Molc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool001Koc<c<0_l00003olc<c003o`000?o<c<co
c<c<00Coc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`9ofIVIQ3oc<c<1ol0000:ool000So00003Ooo
0007o`0000Woo`002Ol0000<ool000So00002Ooo0009o`0000coo`002_l0000:ool000?o00003_oo
0004o`0001koc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`005_o<c<`00ol0003oc<c<o`000002
o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV7?o<c<`:ofIVIPooc<c<1Ol0000;ool000[o00003Ooo
0007o`0000Ooo`002_l0000<ool000Oo00002?oo000:o`0000coo`001ol00009ool000Wo00000omo
0?l00ol0003o0?ooo`3oo`02o`3oo`03o`000?o<c<coc<c<01coc<c<00?oIVIVolc<c?o<c<`04Oo<
c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c009olc<c004o`000?o<c<coc<c<ofIVIQcoc<c<00?o
IVIVolc<c?o<c<`01oo<c<`9ofIVIPKoc<c<00?oIVIVolc<c?o<c<`00_o<c<`8o`0000coo`002_l0
000:ool000Co00003?oo000:o`0000[oo`000ol0000=ool000[o00002ooo0006o`00013oO`3o00?o
0000o`3oool0ool00_l0ool00ol0003oc<c<olc<c00Lolc<c003ofIVI_o<c<coc<c<017oc<c<0Ooo
ool001Ooc<c<00Go0000olc<c?o<c<coc<c<o`00000Volc<c003ofIVI_o<c<coc<c<013oc<c<2OmV
IVH9olc<c0[o00003?oo0006o`0000Woo`002?l0000<ool000Oo00002?oo0008o`0000coo`002Ol0
000;ool001Co000000?o0?ooo`000?o<c<`04oo<c<`?ofIVIPooc<c<0Oooool001Soc<c<0ol0000W
olc<c003ofIVI_o<c<coc<c<01Koc<c<00?oIVIVolc<c?o<c<`02OmVIVH9olc<c0[o00002ooo0007
o`0000Koo`002_l0000;ool000Oo00001ooo0009o`0000_oo`002Ol0000;ool000Oo00001ooo0002
o`0001CoIVIV2_o<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo0012olc<c003ofIVI_o<c<coc<c<
01Koc<c<00?oIVIVolc<c?o<c<`02Oo<c<`:ofIVIPOoc<c<2_l0000;ool000Ko00001ooo0009o`00
00_oo`001_l00007ool000Wo00002ooo0009o`0000koIVIV00?oc<c<ofIVI_o<c<`08_o<c<`00omV
IVKoc<c<olc<c00Aolc<c07ooooo001Kolc<c003ofIVI_o<c<coc<c<01;oc<c<2OmVIVH7olc<c0Wo
00002ooo0006o`0000Ooo`002Ol0000:ool000Wo00003OmVIVHMolc<c003ofIVI_o<c<coc<c<027o
c<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`00Foo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIV
I_o<c<coc<c<00Koc<c<2OmVIVH00oo<c<coIVIVolc<c003olc<c003ofIVI_o<c<coc<c<00Goc<c<
1Ol00006ool000Wo00002_mVIVHGolc<c003ofIVI_o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`0
8Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo001`olc<c003ofIVI_o<c<coc<c<00ooc<c<4OmV
IVHBolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<
c00eolc<c07ooooo001`olc<c003ofIVI_o<c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`00_o<c<`0
0omVIVKoc<c<olc<c00Jolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`0Eoo<c<`1
ooooo`00Poo<c<`00omVIVKoc<c<olc<c002olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIVolc<
c?o<c<`0Moo<c<`1ooooo`00Poo<c<`00omVIVKoc<c<olc<c002olc<c003ofIVI_o<c<coc<c<09Co
c<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool0
0?ooc<c<8?o<c<`1ooooo`00aOo<c<`2o`0005Soc<c<0Oooool00<Koc<c<0_l00002olc<c003o`00
0?o<c<coc<c<05;oc<c<0Oooool00<Ooc<c<0_l00002olc<c003o`000?o<c<coc<c<057oc<c<0Ooo
ool003ooc<c<1Ol00004olc<c0?o00000oo<c<`2o`0000?oc<c<0ol00002olc<c0Co00000oo<c<`5
o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`3o`000003olc<c?l0003o000000;oc<c<0_l00002
olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000Coc<c<0_l00003
olc<c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0ol00003olc<c0?o00000oo<c<`2
o`0000Coc<c<0ol000000oo<c<co0000o`000007olc<c0Co000000Coc<c<o`000?o<c<coc<c<1?l0
0002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000Goc<c<0ol0000]olc<c07ooooo000n
olc<c0;o00000oo<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2
o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00004
olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2
o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<
o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00000oo<c<`2
o`000004olc<c?l0003o0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?o
c<c<o`000?l000000_o<c<`2o`0000Coc<c<0ol000000oo<c<co0000o`000006olc<c0;o00000_o<
c<`3o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?o
c<c<o`000?l000001?o<c<`2o`0000;oc<c<00?o0000olc<c?o<c<`0:_o<c<`1ooooo`00?_o<c<`2
o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2
o`0000;oc<c<0_l00005olc<c0;o00000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2
o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000002?o<c<`3o`0000Coc<c<0ol00000
0oo<c<co0000o`000008olc<c0?o00000oo<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000004
olc<c0?o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2
o`000003olc<c?l0003o000000Ooc<c<0_l00004olc<c0;o000000?oc<c<o`000?l000001Oo<c<`2
o`0000;oc<c<0_l0000;olc<c0;o0000:oo<c<`1ooooo`00@_o<c<`3o`000003olc<c?l0003o0000
00?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o00000_o<c<`6o`000003olc<c?l0003o0000
00;oc<c<0_l00003olc<c0;o00001?o<c<`2o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`00
0003olc<c?l0003o000000Co00000_o<c<`4o`0000?oc<c<1?l00002olc<c0Ko00000_o<c<`4o`00
00Coc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0_l00002olc<
c0;o00000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000o`000007olc<
c0;o00001?o<c<`2o`000003olc<c?l0003o000000Co000000?oc<c<o`000?l000000_o<c<`2o`00
00Soc<c<1Ol0000[olc<c07ooooo000oolc<c0Go00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co
0000o`000003olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o
00000oo<c<`5o`000003olc<c?l0003o000000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003
olc<c?l0003o000000;oc<c<0_l000001?o<c<co0000o`000?l00004olc<c0?o00001?o<c<`2o`00
00;oc<c<0_l000001?o<c<co0000o`000?l00006olc<c0;o00000oo<c<`2o`000004olc<c?l0003o
0000olc<c0?o00001Oo<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<
c<`2o`000003olc<c?l0003o000000Ooc<c<0_l00002olc<c0Co000000?oc<c<o`000?l000000_o<
c<`2o`000003olc<c?l0003o000000;oc<c<0_l00007olc<c0;o00000_o<c<`2o`0002_oc<c<0Ooo
ool003koc<c<0ol00006olc<c0;o000000?oc<c<o`000?l000000_o<c<`3o`0000;oc<c<0_l00002
olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<c0;o00001?o<c<`2
o`0000;oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00000
0oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o
000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`7o`000004olc<c?l0003o
0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000_o<
c<`3o`0000;oc<c<0_l000000oo<c<co0000o`000007olc<c0;o00001oo<c<`2o`0000;oc<c<0_l0
00000oo<c<co0000o`000002olc<c0;o00001oo<c<`2o`0000;oc<c<0_l0000[olc<c07ooooo000n
olc<c0;o00000oo<c<`2o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`000?l000000_l00002
olc<c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<c0;o000000?oc<c<o`000?l000000_l00000
0oo<c<co0000o`000003o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003
olc<c0Co00001?o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0Co00000_o<c<`4
o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`000?l000000oo<c<`2o`0000Koc<c<0_l00004
olc<c0;o00000_o<c<`4o`0000;oc<c<1Ol00008olc<c0;o00000_o<c<`2o`0002_oc<c<0Oooool0
03koc<c<0_l00003olc<c0;o00003_o<c<`2o`0000goc<c<0_l00003olc<c0;o00002?o<c<`2o`00
02koc<c<0_l00003olc<c0;o00003?o<c<`2o`0001coc<c<0_l00002olc<c0;o00005_o<c<`2o`00
00;oc<c<00?o0000olc<c?o<c<`0:_o<c<`1ooooo`00?oo<c<`5o`0000ooc<c<0_l0000=olc<c0;o
00000oo<c<`8o`0000;oc<c<0_l0000^olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000Wo
c<c<0_l0000Molc<c0Co00006?o<c<`4o`0002coc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 6, 6, 6, 6, 6, 6, 1, 1, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(5.`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 0.0147151 5.88604 [
[.38095 .00222 -3 -9 ]
[.38095 .00222 3 0 ]
[.61905 .00222 -3 -9 ]
[.61905 .00222 3 0 ]
[.85714 .00222 -3 -9 ]
[.85714 .00222 3 0 ]
[.13036 .13244 -24 -4.5 ]
[.13036 .13244 0 4.5 ]
[.13036 .25016 -24 -4.5 ]
[.13036 .25016 0 4.5 ]
[.13036 .36788 -24 -4.5 ]
[.13036 .36788 0 4.5 ]
[.13036 .4856 -24 -4.5 ]
[.13036 .4856 0 4.5 ]
[.13036 .60332 -18 -4.5 ]
[.13036 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .01472 m
.38095 .02097 L
s
[(4)] .38095 .00222 0 1 Mshowa
.61905 .01472 m
.61905 .02097 L
s
[(6)] .61905 .00222 0 1 Mshowa
.85714 .01472 m
.85714 .02097 L
s
[(8)] .85714 .00222 0 1 Mshowa
.125 Mabswid
.20238 .01472 m
.20238 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.32143 .01472 m
.32143 .01847 L
s
.44048 .01472 m
.44048 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.55952 .01472 m
.55952 .01847 L
s
.67857 .01472 m
.67857 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.79762 .01472 m
.79762 .01847 L
s
.08333 .01472 m
.08333 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.91667 .01472 m
.91667 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.14286 .13244 m
.14911 .13244 L
s
[(0.02)] .13036 .13244 1 0 Mshowa
.14286 .25016 m
.14911 .25016 L
s
[(0.04)] .13036 .25016 1 0 Mshowa
.14286 .36788 m
.14911 .36788 L
s
[(0.06)] .13036 .36788 1 0 Mshowa
.14286 .4856 m
.14911 .4856 L
s
[(0.08)] .13036 .4856 1 0 Mshowa
.14286 .60332 m
.14911 .60332 L
s
[(0.1)] .13036 .60332 1 0 Mshowa
.125 Mabswid
.14286 .04415 m
.14661 .04415 L
s
.14286 .07358 m
.14661 .07358 L
s
.14286 .10301 m
.14661 .10301 L
s
.14286 .16187 m
.14661 .16187 L
s
.14286 .1913 m
.14661 .1913 L
s
.14286 .22073 m
.14661 .22073 L
s
.14286 .27959 m
.14661 .27959 L
s
.14286 .30902 m
.14661 .30902 L
s
.14286 .33845 m
.14661 .33845 L
s
.14286 .39731 m
.14661 .39731 L
s
.14286 .42674 m
.14661 .42674 L
s
.14286 .45617 m
.14661 .45617 L
s
.14286 .51503 m
.14661 .51503 L
s
.14286 .54446 m
.14661 .54446 L
s
.14286 .57389 m
.14661 .57389 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.14286 .60332 L
.2619 .60332 L
.38095 .60332 L
.5 .60332 L
.61905 .60332 L
.7381 .60332 L
.85714 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 0.0147151 2.94302 [
[.38095 .00222 -3 -9 ]
[.38095 .00222 3 0 ]
[.61905 .00222 -3 -9 ]
[.61905 .00222 3 0 ]
[.85714 .00222 -3 -9 ]
[.85714 .00222 3 0 ]
[.13036 .16187 -24 -4.5 ]
[.13036 .16187 0 4.5 ]
[.13036 .30902 -18 -4.5 ]
[.13036 .30902 0 4.5 ]
[.13036 .45617 -24 -4.5 ]
[.13036 .45617 0 4.5 ]
[.13036 .60332 -18 -4.5 ]
[.13036 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .01472 m
.38095 .02097 L
s
[(4)] .38095 .00222 0 1 Mshowa
.61905 .01472 m
.61905 .02097 L
s
[(6)] .61905 .00222 0 1 Mshowa
.85714 .01472 m
.85714 .02097 L
s
[(8)] .85714 .00222 0 1 Mshowa
.125 Mabswid
.20238 .01472 m
.20238 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.32143 .01472 m
.32143 .01847 L
s
.44048 .01472 m
.44048 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.55952 .01472 m
.55952 .01847 L
s
.67857 .01472 m
.67857 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.79762 .01472 m
.79762 .01847 L
s
.08333 .01472 m
.08333 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.91667 .01472 m
.91667 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.14286 .16187 m
.14911 .16187 L
s
[(0.05)] .13036 .16187 1 0 Mshowa
.14286 .30902 m
.14911 .30902 L
s
[(0.1)] .13036 .30902 1 0 Mshowa
.14286 .45617 m
.14911 .45617 L
s
[(0.15)] .13036 .45617 1 0 Mshowa
.14286 .60332 m
.14911 .60332 L
s
[(0.2)] .13036 .60332 1 0 Mshowa
.125 Mabswid
.14286 .04415 m
.14661 .04415 L
s
.14286 .07358 m
.14661 .07358 L
s
.14286 .10301 m
.14661 .10301 L
s
.14286 .13244 m
.14661 .13244 L
s
.14286 .1913 m
.14661 .1913 L
s
.14286 .22073 m
.14661 .22073 L
s
.14286 .25016 m
.14661 .25016 L
s
.14286 .27959 m
.14661 .27959 L
s
.14286 .33845 m
.14661 .33845 L
s
.14286 .36788 m
.14661 .36788 L
s
.14286 .39731 m
.14661 .39731 L
s
.14286 .42674 m
.14661 .42674 L
s
.14286 .4856 m
.14661 .4856 L
s
.14286 .51503 m
.14661 .51503 L
s
.14286 .54446 m
.14661 .54446 L
s
.14286 .57389 m
.14661 .57389 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.14286 .30902 L
.2619 .30902 L
.38095 .30902 L
.5 .30902 L
.61905 .30902 L
.7381 .30902 L
.85714 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 -0.377687 0.981006 [
[.38095 .59082 -3 -9 ]
[.38095 .59082 3 0 ]
[.61905 .59082 -3 -9 ]
[.61905 .59082 3 0 ]
[.85714 .59082 -3 -9 ]
[.85714 .59082 3 0 ]
[.13036 .01472 -18 -4.5 ]
[.13036 .01472 0 4.5 ]
[.13036 .11282 -18 -4.5 ]
[.13036 .11282 0 4.5 ]
[.13036 .21092 -18 -4.5 ]
[.13036 .21092 0 4.5 ]
[.13036 .30902 -18 -4.5 ]
[.13036 .30902 0 4.5 ]
[.13036 .40712 -18 -4.5 ]
[.13036 .40712 0 4.5 ]
[.13036 .50522 -18 -4.5 ]
[.13036 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .60332 m
.38095 .60957 L
s
[(4)] .38095 .59082 0 1 Mshowa
.61905 .60332 m
.61905 .60957 L
s
[(6)] .61905 .59082 0 1 Mshowa
.85714 .60332 m
.85714 .60957 L
s
[(8)] .85714 .59082 0 1 Mshowa
.125 Mabswid
.20238 .60332 m
.20238 .60707 L
s
.2619 .60332 m
.2619 .60707 L
s
.32143 .60332 m
.32143 .60707 L
s
.44048 .60332 m
.44048 .60707 L
s
.5 .60332 m
.5 .60707 L
s
.55952 .60332 m
.55952 .60707 L
s
.67857 .60332 m
.67857 .60707 L
s
.7381 .60332 m
.7381 .60707 L
s
.79762 .60332 m
.79762 .60707 L
s
.08333 .60332 m
.08333 .60707 L
s
.02381 .60332 m
.02381 .60707 L
s
.91667 .60332 m
.91667 .60707 L
s
.97619 .60332 m
.97619 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.14286 .01472 m
.14911 .01472 L
s
[(0.4)] .13036 .01472 1 0 Mshowa
.14286 .11282 m
.14911 .11282 L
s
[(0.5)] .13036 .11282 1 0 Mshowa
.14286 .21092 m
.14911 .21092 L
s
[(0.6)] .13036 .21092 1 0 Mshowa
.14286 .30902 m
.14911 .30902 L
s
[(0.7)] .13036 .30902 1 0 Mshowa
.14286 .40712 m
.14911 .40712 L
s
[(0.8)] .13036 .40712 1 0 Mshowa
.14286 .50522 m
.14911 .50522 L
s
[(0.9)] .13036 .50522 1 0 Mshowa
.125 Mabswid
.14286 .03434 m
.14661 .03434 L
s
.14286 .05396 m
.14661 .05396 L
s
.14286 .07358 m
.14661 .07358 L
s
.14286 .0932 m
.14661 .0932 L
s
.14286 .13244 m
.14661 .13244 L
s
.14286 .15206 m
.14661 .15206 L
s
.14286 .17168 m
.14661 .17168 L
s
.14286 .1913 m
.14661 .1913 L
s
.14286 .23054 m
.14661 .23054 L
s
.14286 .25016 m
.14661 .25016 L
s
.14286 .26978 m
.14661 .26978 L
s
.14286 .2894 m
.14661 .2894 L
s
.14286 .32864 m
.14661 .32864 L
s
.14286 .34826 m
.14661 .34826 L
s
.14286 .36788 m
.14661 .36788 L
s
.14286 .3875 m
.14661 .3875 L
s
.14286 .42674 m
.14661 .42674 L
s
.14286 .44636 m
.14661 .44636 L
s
.14286 .46598 m
.14661 .46598 L
s
.14286 .4856 m
.14661 .4856 L
s
.14286 .52484 m
.14661 .52484 L
s
.14286 .54446 m
.14661 .54446 L
s
.14286 .56408 m
.14661 .56408 L
s
.14286 .5837 m
.14661 .5837 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.14286 .60332 L
.2619 .60332 L
.38095 .59351 L
.5 .5838 L
.61905 .57418 L
.7381 .36834 L
.85714 .36088 L
.97619 .20116 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 -0.100584 1.15299 [
[.38095 .00222 -3 -9 ]
[.38095 .00222 3 0 ]
[.61905 .00222 -3 -9 ]
[.61905 .00222 3 0 ]
[.85714 .00222 -3 -9 ]
[.85714 .00222 3 0 ]
[.13036 .13001 -18 -4.5 ]
[.13036 .13001 0 4.5 ]
[.13036 .24531 -18 -4.5 ]
[.13036 .24531 0 4.5 ]
[.13036 .36061 -18 -4.5 ]
[.13036 .36061 0 4.5 ]
[.13036 .47591 -18 -4.5 ]
[.13036 .47591 0 4.5 ]
[.13036 .59121 -18 -4.5 ]
[.13036 .59121 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .01472 m
.38095 .02097 L
s
[(4)] .38095 .00222 0 1 Mshowa
.61905 .01472 m
.61905 .02097 L
s
[(6)] .61905 .00222 0 1 Mshowa
.85714 .01472 m
.85714 .02097 L
s
[(8)] .85714 .00222 0 1 Mshowa
.125 Mabswid
.20238 .01472 m
.20238 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.32143 .01472 m
.32143 .01847 L
s
.44048 .01472 m
.44048 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.55952 .01472 m
.55952 .01847 L
s
.67857 .01472 m
.67857 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.79762 .01472 m
.79762 .01847 L
s
.08333 .01472 m
.08333 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.91667 .01472 m
.91667 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.14286 .13001 m
.14911 .13001 L
s
[(0.2)] .13036 .13001 1 0 Mshowa
.14286 .24531 m
.14911 .24531 L
s
[(0.3)] .13036 .24531 1 0 Mshowa
.14286 .36061 m
.14911 .36061 L
s
[(0.4)] .13036 .36061 1 0 Mshowa
.14286 .47591 m
.14911 .47591 L
s
[(0.5)] .13036 .47591 1 0 Mshowa
.14286 .59121 m
.14911 .59121 L
s
[(0.6)] .13036 .59121 1 0 Mshowa
.125 Mabswid
.14286 .03777 m
.14661 .03777 L
s
.14286 .06083 m
.14661 .06083 L
s
.14286 .08389 m
.14661 .08389 L
s
.14286 .10695 m
.14661 .10695 L
s
.14286 .15307 m
.14661 .15307 L
s
.14286 .17613 m
.14661 .17613 L
s
.14286 .19919 m
.14661 .19919 L
s
.14286 .22225 m
.14661 .22225 L
s
.14286 .26837 m
.14661 .26837 L
s
.14286 .29143 m
.14661 .29143 L
s
.14286 .31449 m
.14661 .31449 L
s
.14286 .33755 m
.14661 .33755 L
s
.14286 .38367 m
.14661 .38367 L
s
.14286 .40673 m
.14661 .40673 L
s
.14286 .42979 m
.14661 .42979 L
s
.14286 .45285 m
.14661 .45285 L
s
.14286 .49897 m
.14661 .49897 L
s
.14286 .52203 m
.14661 .52203 L
s
.14286 .54509 m
.14661 .54509 L
s
.14286 .56815 m
.14661 .56815 L
s
.14286 .61427 m
.14661 .61427 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .13001 m
.14286 .60332 L
.2619 .59628 L
.38095 .58931 L
.5 .58241 L
.61905 .57558 L
.7381 .01472 L
.85714 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 -0.573889 5.88604 [
[.38095 .00222 -3 -9 ]
[.38095 .00222 3 0 ]
[.61905 .00222 -3 -9 ]
[.61905 .00222 3 0 ]
[.85714 .00222 -3 -9 ]
[.85714 .00222 3 0 ]
[.13036 .13244 -24 -4.5 ]
[.13036 .13244 0 4.5 ]
[.13036 .25016 -24 -4.5 ]
[.13036 .25016 0 4.5 ]
[.13036 .36788 -24 -4.5 ]
[.13036 .36788 0 4.5 ]
[.13036 .4856 -24 -4.5 ]
[.13036 .4856 0 4.5 ]
[.13036 .60332 -18 -4.5 ]
[.13036 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .01472 m
.38095 .02097 L
s
[(4)] .38095 .00222 0 1 Mshowa
.61905 .01472 m
.61905 .02097 L
s
[(6)] .61905 .00222 0 1 Mshowa
.85714 .01472 m
.85714 .02097 L
s
[(8)] .85714 .00222 0 1 Mshowa
.125 Mabswid
.20238 .01472 m
.20238 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.32143 .01472 m
.32143 .01847 L
s
.44048 .01472 m
.44048 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.55952 .01472 m
.55952 .01847 L
s
.67857 .01472 m
.67857 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.79762 .01472 m
.79762 .01847 L
s
.08333 .01472 m
.08333 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.91667 .01472 m
.91667 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.14286 .13244 m
.14911 .13244 L
s
[(0.12)] .13036 .13244 1 0 Mshowa
.14286 .25016 m
.14911 .25016 L
s
[(0.14)] .13036 .25016 1 0 Mshowa
.14286 .36788 m
.14911 .36788 L
s
[(0.16)] .13036 .36788 1 0 Mshowa
.14286 .4856 m
.14911 .4856 L
s
[(0.18)] .13036 .4856 1 0 Mshowa
.14286 .60332 m
.14911 .60332 L
s
[(0.2)] .13036 .60332 1 0 Mshowa
.125 Mabswid
.14286 .04415 m
.14661 .04415 L
s
.14286 .07358 m
.14661 .07358 L
s
.14286 .10301 m
.14661 .10301 L
s
.14286 .16187 m
.14661 .16187 L
s
.14286 .1913 m
.14661 .1913 L
s
.14286 .22073 m
.14661 .22073 L
s
.14286 .27959 m
.14661 .27959 L
s
.14286 .30902 m
.14661 .30902 L
s
.14286 .33845 m
.14661 .33845 L
s
.14286 .39731 m
.14661 .39731 L
s
.14286 .42674 m
.14661 .42674 L
s
.14286 .45617 m
.14661 .45617 L
s
.14286 .51503 m
.14661 .51503 L
s
.14286 .54446 m
.14661 .54446 L
s
.14286 .57389 m
.14661 .57389 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.14286 .01472 L
.2619 .01472 L
.38095 .01472 L
.5 .01472 L
.61905 .01472 L
.7381 .01472 L
.85714 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 0.0147151 5.88604 [
[.38095 .00222 -3 -9 ]
[.38095 .00222 3 0 ]
[.61905 .00222 -3 -9 ]
[.61905 .00222 3 0 ]
[.85714 .00222 -3 -9 ]
[.85714 .00222 3 0 ]
[.13036 .13244 -24 -4.5 ]
[.13036 .13244 0 4.5 ]
[.13036 .25016 -24 -4.5 ]
[.13036 .25016 0 4.5 ]
[.13036 .36788 -24 -4.5 ]
[.13036 .36788 0 4.5 ]
[.13036 .4856 -24 -4.5 ]
[.13036 .4856 0 4.5 ]
[.13036 .60332 -18 -4.5 ]
[.13036 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .01472 m
.38095 .02097 L
s
[(4)] .38095 .00222 0 1 Mshowa
.61905 .01472 m
.61905 .02097 L
s
[(6)] .61905 .00222 0 1 Mshowa
.85714 .01472 m
.85714 .02097 L
s
[(8)] .85714 .00222 0 1 Mshowa
.125 Mabswid
.20238 .01472 m
.20238 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.32143 .01472 m
.32143 .01847 L
s
.44048 .01472 m
.44048 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.55952 .01472 m
.55952 .01847 L
s
.67857 .01472 m
.67857 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.79762 .01472 m
.79762 .01847 L
s
.08333 .01472 m
.08333 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.91667 .01472 m
.91667 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.14286 .13244 m
.14911 .13244 L
s
[(0.02)] .13036 .13244 1 0 Mshowa
.14286 .25016 m
.14911 .25016 L
s
[(0.04)] .13036 .25016 1 0 Mshowa
.14286 .36788 m
.14911 .36788 L
s
[(0.06)] .13036 .36788 1 0 Mshowa
.14286 .4856 m
.14911 .4856 L
s
[(0.08)] .13036 .4856 1 0 Mshowa
.14286 .60332 m
.14911 .60332 L
s
[(0.1)] .13036 .60332 1 0 Mshowa
.125 Mabswid
.14286 .04415 m
.14661 .04415 L
s
.14286 .07358 m
.14661 .07358 L
s
.14286 .10301 m
.14661 .10301 L
s
.14286 .16187 m
.14661 .16187 L
s
.14286 .1913 m
.14661 .1913 L
s
.14286 .22073 m
.14661 .22073 L
s
.14286 .27959 m
.14661 .27959 L
s
.14286 .30902 m
.14661 .30902 L
s
.14286 .33845 m
.14661 .33845 L
s
.14286 .39731 m
.14661 .39731 L
s
.14286 .42674 m
.14661 .42674 L
s
.14286 .45617 m
.14661 .45617 L
s
.14286 .51503 m
.14661 .51503 L
s
.14286 .54446 m
.14661 .54446 L
s
.14286 .57389 m
.14661 .57389 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.14286 .60332 L
.2619 .60332 L
.38095 .60332 L
.5 .60332 L
.61905 .60332 L
.7381 .60332 L
.85714 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 -0.371191 0.97451 [
[.38095 .59082 -3 -9 ]
[.38095 .59082 3 0 ]
[.61905 .59082 -3 -9 ]
[.61905 .59082 3 0 ]
[.85714 .59082 -3 -9 ]
[.85714 .59082 3 0 ]
[.13036 .01861 -18 -4.5 ]
[.13036 .01861 0 4.5 ]
[.13036 .11606 -18 -4.5 ]
[.13036 .11606 0 4.5 ]
[.13036 .21352 -18 -4.5 ]
[.13036 .21352 0 4.5 ]
[.13036 .31097 -18 -4.5 ]
[.13036 .31097 0 4.5 ]
[.13036 .40842 -18 -4.5 ]
[.13036 .40842 0 4.5 ]
[.13036 .50587 -18 -4.5 ]
[.13036 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .60332 m
.38095 .60957 L
s
[(4)] .38095 .59082 0 1 Mshowa
.61905 .60332 m
.61905 .60957 L
s
[(6)] .61905 .59082 0 1 Mshowa
.85714 .60332 m
.85714 .60957 L
s
[(8)] .85714 .59082 0 1 Mshowa
.125 Mabswid
.20238 .60332 m
.20238 .60707 L
s
.2619 .60332 m
.2619 .60707 L
s
.32143 .60332 m
.32143 .60707 L
s
.44048 .60332 m
.44048 .60707 L
s
.5 .60332 m
.5 .60707 L
s
.55952 .60332 m
.55952 .60707 L
s
.67857 .60332 m
.67857 .60707 L
s
.7381 .60332 m
.7381 .60707 L
s
.79762 .60332 m
.79762 .60707 L
s
.08333 .60332 m
.08333 .60707 L
s
.02381 .60332 m
.02381 .60707 L
s
.91667 .60332 m
.91667 .60707 L
s
.97619 .60332 m
.97619 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.14286 .01861 m
.14911 .01861 L
s
[(0.4)] .13036 .01861 1 0 Mshowa
.14286 .11606 m
.14911 .11606 L
s
[(0.5)] .13036 .11606 1 0 Mshowa
.14286 .21352 m
.14911 .21352 L
s
[(0.6)] .13036 .21352 1 0 Mshowa
.14286 .31097 m
.14911 .31097 L
s
[(0.7)] .13036 .31097 1 0 Mshowa
.14286 .40842 m
.14911 .40842 L
s
[(0.8)] .13036 .40842 1 0 Mshowa
.14286 .50587 m
.14911 .50587 L
s
[(0.9)] .13036 .50587 1 0 Mshowa
.125 Mabswid
.14286 .0381 m
.14661 .0381 L
s
.14286 .05759 m
.14661 .05759 L
s
.14286 .07708 m
.14661 .07708 L
s
.14286 .09657 m
.14661 .09657 L
s
.14286 .13555 m
.14661 .13555 L
s
.14286 .15504 m
.14661 .15504 L
s
.14286 .17453 m
.14661 .17453 L
s
.14286 .19402 m
.14661 .19402 L
s
.14286 .23301 m
.14661 .23301 L
s
.14286 .2525 m
.14661 .2525 L
s
.14286 .27199 m
.14661 .27199 L
s
.14286 .29148 m
.14661 .29148 L
s
.14286 .33046 m
.14661 .33046 L
s
.14286 .34995 m
.14661 .34995 L
s
.14286 .36944 m
.14661 .36944 L
s
.14286 .38893 m
.14661 .38893 L
s
.14286 .42791 m
.14661 .42791 L
s
.14286 .4474 m
.14661 .4474 L
s
.14286 .46689 m
.14661 .46689 L
s
.14286 .48638 m
.14661 .48638 L
s
.14286 .52536 m
.14661 .52536 L
s
.14286 .54485 m
.14661 .54485 L
s
.14286 .56434 m
.14661 .56434 L
s
.14286 .58383 m
.14661 .58383 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.14286 .01472 L
.2619 .60332 L
.38095 .59357 L
.5 .58393 L
.61905 .37738 L
.7381 .16404 L
.85714 .60332 L
.97619 .19159 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0952381 0.119048 0.0147151 5.88604 [
[.38095 .00222 -3 -9 ]
[.38095 .00222 3 0 ]
[.61905 .00222 -3 -9 ]
[.61905 .00222 3 0 ]
[.85714 .00222 -3 -9 ]
[.85714 .00222 3 0 ]
[.13036 .13244 -24 -4.5 ]
[.13036 .13244 0 4.5 ]
[.13036 .25016 -24 -4.5 ]
[.13036 .25016 0 4.5 ]
[.13036 .36788 -24 -4.5 ]
[.13036 .36788 0 4.5 ]
[.13036 .4856 -24 -4.5 ]
[.13036 .4856 0 4.5 ]
[.13036 .60332 -18 -4.5 ]
[.13036 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.38095 .01472 m
.38095 .02097 L
s
[(4)] .38095 .00222 0 1 Mshowa
.61905 .01472 m
.61905 .02097 L
s
[(6)] .61905 .00222 0 1 Mshowa
.85714 .01472 m
.85714 .02097 L
s
[(8)] .85714 .00222 0 1 Mshowa
.125 Mabswid
.20238 .01472 m
.20238 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.32143 .01472 m
.32143 .01847 L
s
.44048 .01472 m
.44048 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.55952 .01472 m
.55952 .01847 L
s
.67857 .01472 m
.67857 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.79762 .01472 m
.79762 .01847 L
s
.08333 .01472 m
.08333 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.91667 .01472 m
.91667 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.14286 .13244 m
.14911 .13244 L
s
[(0.02)] .13036 .13244 1 0 Mshowa
.14286 .25016 m
.14911 .25016 L
s
[(0.04)] .13036 .25016 1 0 Mshowa
.14286 .36788 m
.14911 .36788 L
s
[(0.06)] .13036 .36788 1 0 Mshowa
.14286 .4856 m
.14911 .4856 L
s
[(0.08)] .13036 .4856 1 0 Mshowa
.14286 .60332 m
.14911 .60332 L
s
[(0.1)] .13036 .60332 1 0 Mshowa
.125 Mabswid
.14286 .04415 m
.14661 .04415 L
s
.14286 .07358 m
.14661 .07358 L
s
.14286 .10301 m
.14661 .10301 L
s
.14286 .16187 m
.14661 .16187 L
s
.14286 .1913 m
.14661 .1913 L
s
.14286 .22073 m
.14661 .22073 L
s
.14286 .27959 m
.14661 .27959 L
s
.14286 .30902 m
.14661 .30902 L
s
.14286 .33845 m
.14661 .33845 L
s
.14286 .39731 m
.14661 .39731 L
s
.14286 .42674 m
.14661 .42674 L
s
.14286 .45617 m
.14661 .45617 L
s
.14286 .51503 m
.14661 .51503 L
s
.14286 .54446 m
.14661 .54446 L
s
.14286 .57389 m
.14661 .57389 L
s
.25 Mabswid
.14286 0 m
.14286 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.14286 .60332 L
.2619 .60332 L
.38095 .60332 L
.5 .60332 L
.61905 .60332 L
.7381 .60332 L
.85714 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H003_oi^KV0ol0000;onKViP?o
00003?oVi^H3o`0004_oi^KV0ol0000:onKViP?o00003?oVi^H3o`0001koi^KV000lonKViP03o`00
0?oVi^Koi^KV00Woi^KV00Go0000onKVi_oVi^Koi^KVo`00000:onKViP05o`000?oVi^Koi^KVonKV
i_l00000BooVi^H00ol0003oi^KVonKViP08onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000001goi^KV000ionKViPGo00002_oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000[oi^KV00Go0000onKVi_oVi^Koi^KVo`000018onKViPGo00002OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00000MonKViP00>OoVi^H01?l0003o
i^KVonKVi_l0000;onKViPCo00003?oVi^H3o`0004Woi^KV00Co0000onKVi_oVi^Ko00002_oVi^H4
o`0000coi^KV0ol0000NonKViP00>_oVi^H00ol0003oi^KVo`00000;onKViP03o`000?oVi^Koi^KV
00coi^KV00Go0000onKVi_oVi^Koi^KVo`000019onKViP03o`000?oVi^Ko000000[oi^KV00?o0000
onKVi_oVi^H03?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000001goi^KV000konKViP;o00003?oVi^H0
0ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KVonKVi_l00000B_oVi^H2o`0000_oi^KV00?o
0000onKVi_oVi^H02ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000001goi^KV000lonKViP03o`000?oV
i^Koi^KV00_oi^KV0_l0000<onKViP?o0000C?oVi^H00ol0003oi^KVonKViP0:onKViP;o00003?oV
i^H3o`0001koi^KV003SonKViP00;OoVi^H00ol0003oi^KVonKViP1XonKViP03o`000?oVi^Koi^KV
04Soi^KV000UonKViP03o`000?nc/k?o000003_o0000;?oVi^Hoo`0001Goi^KV000VonKViP03ok>c
/ooVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H0J?oVi^H00ol0003oi^KVonKViP18onKViP009_oV
i^H00onc/k?oi^KVonKViP04onKViP;o0000JOoVi^H00ol0003oi^KVonKViP18onKViP009_oVi^H0
0onc/k?oi^KVonKViP04onKViP;o0000JOoVi^H00ol0003oi^KVonKViP18onKViP009ooVi^H00onc
/k?oi^KVonKViP03onKViP03o`000?oVi^Koi^KV06Soi^KV00?o0000onKVi_oVi^H0B?oVi^H001Oo
i^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00002onKViP03ok>c/ol0003o000000;o
000000?oi^KVo`000?l00000JOoVi^H00ol0003oi^KVonKViP18onKViP005_oVi^H01?l0003oi^KV
onKVi_l00008onKViP07o`000?oVi^Koi^KVo`000?oVi^Ko/k>co`000002onKViP03o`000?oVi^Ko
000005?oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o00000ooVi^H0
0ol0003oi^KVonKViP18onKViP005_oVi^H01?l0003oi^KVonKVi_l00008onKViP08o`000?oVi^Ko
i^KVo`000?oVi^Ko/k>conKVi_l00003onKViP;o0000DOoVi^H01?l0003oi^KVonKVi_l00008onKV
iP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l0001:onKViP005_oV
i^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko/k>c0_oVi^H01?l0
003oi^KVonKVi_l0001BonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
1OoVi^H01?l0003oi^KVonKVi_l0001:onKViP005_oVi^H01?l0003oi^KVonKVi_l00008onKViP07
o`000?oVi^Koi^KVo`000?oVi^Ko0000ok>c/`02onKViP04o`000?oVi^Ko0000o`00057oi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`00
04[oi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Oo0000onKVi_oVi^Ko0000onKVi_l0
003o/k>c00;oi^KV00?o0000onKVi_l00000D_oVi^H01?l0003oi^KVonKVi_l00008onKViP05o`00
0?oVi^Koi^KVo`000?oVi^H01?l00003onKViP03o`000?oVi^Koi^KV04Soi^KV000GonKViP;o0000
2_oVi^H2o`0000?oi^KV00?o/k>co`000?l000000_oVi^H2o`00057oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Koi^KV00?o0000onKVi_oVi^H0B?oVi^H0
01Ooi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP06ok>c/ol0003o0000
o`000?oVi^Ko0000DooVi^H2o`0000[oi^KV0_l00002onKViPGo00000_oVi^H00ol0003oi^KVonKV
iP18onKViP005_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?o/k>conKVi_l000000_oVi^H2o`0006Woi^KV00?o0000onKVi_oVi^H0B?oVi^H001Koi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00;o000000Co/k>co`000?l0
003oi^KV0_l0001YonKViP03o`000?oVi^Koi^KV04Soi^KV000FonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Wo0000onKVi_oVi^Ko0000onKVi_l0003oi^KVok>c/ol000000_oVi^H00ol0003oi^KV
onKViP1GonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KV
onKViP18onKViP005_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00?o0000ok>c/ol000000_oVi^H2o`0005Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0
003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV04Soi^KV000FonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01Onc/k?o0000onKVi_oVi^Ko000005Soi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV04Soi^KV
000GonKViP;o00002_oVi^H2o`0000Coi^KV00Co/k>co`000?oVi^Koi^KV0_l0001GonKViP04o`00
0?oVi^Koi^KVo`0000Ooi^KV>oo<c<`GonKViP005ooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H0
0ooVi^H2o`0000?oi^KV0_l000001?nc/k?oi^KVonKVi_l0001HonKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP18onKViP005_oVi^H01?l0003o
i^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000_oVi^H00onc/k?o0000onKV
iP02o`0005Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H0
B?oVi^H001Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`00
00;oi^KV00Co/k>co`000?oVi^Ko0000FOoVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H00_oVi^H0
0ol0003oi^KVonKViP18onKViP005_oVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Ko
i^KVo`000?oVi^H00ol000000onc/k?oi^KVonKViP02o`0006Woi^KV00?o0000onKVi_oVi^H0B?oV
i^H001Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;o
i^KV00?o/k>conKVi_oVi^H00_l0001YonKViP03o`000?oVi^Koi^KV04Soi^KV000FonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_nc/k?o
i^KVo`0006[oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Ooi^KV0_l0000:onKViP;o00001?oVi^H2
o`000004ok>c/ooVi^Ko0000o`0005;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol0
0003onKViP?o00000ooVi^H00ol0003oi^KVonKViP18onKViP005ooVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol000000onc/k?oi^KVo`00001BonKViP04o`000?oVi^Ko
i^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0004[o
i^KV000FonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003
onKViP04ok>c/ooVi^Ko0000o`00057oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KV
onKViP05onKViP04o`000?oVi^Koi^KVo`0004[oi^KV000FonKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03ok>c/ooVi^Ko000005;oi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP05onKViP04o`000?oVi^Koi^KVo`0004[oi^KV
000FonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`000004
onKVi_nc/k?o0000o`00057oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oV
i^H4o`0000?oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Koi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000ok>c/ol00000D_oVi^H01?l0003o
i^KVonKVi_l00008onKViP;o00000ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV
04Soi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0003onKViP04o`000?nc/k?o0000o`0005;oi^KV0_l0000:onKViP04o`000?oVi^Koi^KVonKViPGo
00000_oVi^H00ol0003oi^KVonKViP18onKViP005ooVi^H2o`0000[oi^KV0_l00003onKViP?o0000
00?oi^KVok>c/ol00000J_oVi^H00ol0003oi^KVonKViP18onKViP00;?oVi^H00onc/k?o0000o`00
001YonKViP03o`000?oVi^Koi^KV04Soi^KV000MonKViP;o00001?oVi^H00ol0003oi^KVonKViP02
onKViP?o00000_oVi^H00onc/k?o0000onKViP1GonKViP;o00001?oVi^H01?l0003oi^KVonKVi_oV
i^H5o`0000;oi^KV00?o0000onKVi_oVi^H0B?oVi^H001coi^KV00Co0000onKVi_oVi^Ko00002OoV
i^H01Ol0003oi^KVonKVi_oVi^Ko/k>c05Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003o
i^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04Soi^KV000LonKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00Co0000onKVi_oVi^Koi^KV=Onc/k<TonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o
0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP18onKViP007?oVi^H01?l0003oi^KVonKVi_l0
0009onKViP05o`000?oVi^Koi^KVonKVi_l00000F?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05
o`000?oVi^Koi^KVonKVi_l00000B_oVi^H001coi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0
003oi^KVonKViP1JonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00
001=onKViP007?oVi^H01?l0003oi^KVonKVi_l00008onKViP;o0000G?oVi^H01?l0003oi^KVonKV
i_l00007onKViP05o`000?oVi^Koi^KVonKVi_l00000COoVi^H001goi^KV0_l0000:onKViP03o`00
0?oVi^Koi^KV05_oi^KV0_l00009onKViP?o0000C_oVi^H00>?oi^KV000eonKViP?o00000_oVi^H6
o`000004onKVi_l0003o0000o`0000?oi^KV0ol00002onKViP03o`000?oVi^Ko000000;o0000C?oV
i^H3o`0000;oi^KV0ol000000ooVi^Ko0000o`000003o`0000;oi^KV1_l000001ooVi^Ko0000o`00
0?l0003oi^KVo`000?oVi^H00ol000000ooVi^Ko0000o`00000SonKViP00=_oVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0
003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_oVi^H0BOoVi^H01?l0003oi^KVonKV
i_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0
003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00009?oV
i^H003Koi^KV00?o0000onKVi_l000000ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Ko
i^KV00?oi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004koi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Coi^KV00?o0000onKV
i_oVi^H00_oVi^H01?l0003oi^KVo`000?l00002onKViP03o`000?oVi^Ko000002Goi^KV000fonKV
iP?o00000ooVi^H3o`0000?oi^KV0ol00003onKViP?o00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko
000004coi^KV0_l00003onKViPCo00000_oVi^H3o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H0
1?l0003oi^KVo`000?l00002onKViP;o00009_oVi^H003Koi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H00ol0003oi^KVonKViP03onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko
0000onKVi_l00003onKViP03o`000?oVi^Koi^KV04Woi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0
003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oV
i^H2o`000007onKVi_l0003oi^KVonKVi_l0003oi^KVo`00000UonKViP00=_oVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_oVi^H0BOoVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H0
0ol0003oi^KVonKViP02onKViP;o000000Goi^KVo`000?oVi^Koi^KVo`000002onKViP03o`000?oV
i^Koi^KV02;oi^KV000eonKViPCo00000_oVi^H5o`000003onKVi_l0003o000000;o00000_oVi^H4
o`0000?oi^KV0ol0001=onKViP?o000000Goi^KVo`000?l0003o0000onKViP06o`0000;oi^KV1Ol0
00001?oVi^Ko0000o`000?oVi^H6o`000003onKVi_l0003o000002?oi^KV003SonKViP00hooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00:?oi^KV0ol0000:onKViP?o
00003?oVi^H3o`00027oi^KV000FonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP?o0000
OooVi^H00ol0003oi^KVonKViP08onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko0000023oi^KV000EonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKV
i_oVi^Koi^KVo`00001ionKViPGo00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000[oi^KV00Go
0000onKVi_oVi^Koi^KVo`00000PonKViP005OoVi^H01?l0003oi^KVonKVi_l00005onKViP03ogmo
OooVi^Ko000000Co00000_oVi^H00ol0003oi^KVonKViP1gonKViP04o`000?oVi^Koi^KVo`0000[o
i^KV1?l0000<onKViP?o00008OoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001OoVi^H00omoOgoo
i^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l00000N_oVi^H00ol0003oi^KVo`00000:onKV
iP03o`000?oVi^Koi^KV00coi^KV00Go0000onKVi_oVi^Koi^KVo`00000PonKViP005OoVi^H01?l0
003oi^KVonKVi_l00005onKViP06ogmoOooVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KV
onKViP1ionKViP;o00002ooVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KVonKVi_l0
00008?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001_oVi^H00omoOgooi^KVonKViP02o`0000?o
i^KV00?o0000onKVi_oVi^H0N_oVi^H00ol0003oi^KVonKViP0:onKViP;o00003?oVi^H3o`00027o
i^KV000FonKViP;o00001ooVi^H01OmoOgooi^KVonKVi_oVi^Ko000000?oi^KV00?o0000onKVi_oV
i^H0^OoVi^H001Koi^KV0_l00004onKViP05o`000?oVi^Koi^KVogmoOooVi^H00ol00003onKViP03
o`000?oVi^Koi^KV06_oi^KV00?o0000onKVi_oVi^H0BooVi^H001Goi^KV00Co0000onKVi_oVi^Ko
00001_oVi^H00omoOgoo0000onKViP02onKViP04o`000?oVi^Koi^KVo`0006Coi^KV;_l0000?oiVI
V@;o00006?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001_oVi^H00omoOgooi^KVonKViP02onKV
iP04o`000?oVi^Koi^KVo`0006goi^KV00?o0000onKVi_oVi^H08_oVi^H00onIVIWoi^KVonKViP0V
onKViP005OoVi^H01?l0003oi^KVonKVi_l00007onKViP05ogmoOooVi^Koi^KVonKVi_l000000_oV
i^H00ol0003oi^KVonKViP1[onKViP03o`000?oVi^Koi^KV02;oi^KV00?oVIVIonKVi_oVi^H09_oV
i^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01?moOgoo0000o`000?l00003onKViP03o`00
0?oVi^Koi^KV06_oi^KV00?o0000onKVi_oVi^H08OoVi^H00onIVIWoi^KVonKViP0WonKViP005OoV
i^H01?l0003oi^KVonKVi_l00007onKViP03ogmoOooVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H0
F_oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002onKViP03o`000?oVi^Koi^KV027o
i^KV00?oVIVIonKVi_oVi^H09ooVi^H001Koi^KV0_l00008onKViP03ogmoOol0003o000000;o0000
0_oVi^H00ol0003oi^KVonKViP1IonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H00ol0003oi^KVonKViP0QonKViP03oiVIVOoVi^Koi^KV02Ooi^KV000FonKViP;o
00001?oVi^H01Ol0003oi^KVonKVi_oVi^KoOgmo00?o00000ooVi^H00ol0003oi^KVonKViP1IonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0Q
onKViP03oiVIVOoVi^Koi^KV02Ooi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000
ogmoOooVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV05Woi^KV00Co0000onKVi_oVi^Ko0000
1ooVi^H01?nIVIWoi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV023oi^KV00?oVIVIonKVi_oV
i^H0:?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oOgmoonKVi_oVi^Ko0000
00;oi^KV00?o0000onKVi_oVi^H0=ooVi^H00omoOgooi^KVonKViP0OonKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00GoVIVIonKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV023oi^KV00?o
VIVIonKVi_oVi^H0:?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01?l0003oOgmoo`00
0?l00003onKViP03o`000?oVi^Koi^KV03Ooi^KV00?oOgmoonKVi_oVi^H07ooVi^H01?l0003oi^KV
onKVi_l00007onKViP05oiVIVOoVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0PonKV
iP03oiVIVOoVi^Koi^KV02Soi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00?o0000ogmo
OooVi^H01?oVi^H00ol0003oi^KVonKViP0fonKViP03ogmoOooVi^Koi^KV027oi^KV0_l00009onKV
iP03oiVIVOl0003o000000?oi^KV00?o0000onKVi_oVi^H08?oVi^H00onIVIWoi^KVonKViP0XonKV
iP005OoVi^H01?l0003oi^KVonKVi_l00008onKViP03o`000?moOgooi^KV00?oi^KV00?o0000onKV
i_oVi^H0=OoVi^H00omoOgooi^KVonKViP0RonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKV
iP03oiVIVOl0003o000000?oi^KV00?o0000onKVi_oVi^H08?oVi^H00onIVIWoi^KVonKViP0XonKV
iP005_oVi^H2o`0000[oi^KV00?oOgmoo`000?oVi^H00_oVi^H00ol0003oi^KVonKViP0donKViP03
ogmoOooVi^Koi^KV02;oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oVIVIonKVi_oVi^Ko
000000;oi^KV00?o0000onKVi_oVi^H07ooVi^H00onIVIWoi^KVonKViP0YonKViP005_oVi^H2o`00
00Coi^KV00?o0000onKVi_oVi^H00ooVi^H00omoOgooi^KVonKViP02onKViP03o`000?oVi^Koi^KV
03Coi^KV00?oOgmoonKVi_oVi^H08_oVi^H01?l0003oi^KVonKVi_l00008onKViP04oiVIVOoVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H07ooVi^H00onIVIWoi^KVonKViP0YonKViP005OoVi^H0
1?l0003oi^KVonKVi_l00009onKViP03ogmoOooVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0<ooV
i^H00omoOgooi^KVonKViP0SonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?oVIVIo`000?oVi^H0
0_oVi^H00ol0003oi^KVonKViP0OonKViP03oiVIVOoVi^Koi^KV02Woi^KV000EonKViP04o`000?oV
i^Koi^KVo`0000Woi^KV00?oOgmoo`000?oVi^H00_oVi^H00ol0003oi^KVonKViP0bonKViP03ogmo
OooVi^Koi^KV02Coi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00onIVIWoi^KVo`000002onKViP03
o`000?oVi^Koi^KV01ooi^KV00?oVIVIonKVi_oVi^H0:OoVi^H001Goi^KV00Co0000onKVi_oVi^Ko
00002_oVi^H01OmoOgooi^KVonKVi_oVi^Ko000003Coi^KV00?oOgmoonKVi_oVi^H09?oVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^KoVIVIonKVi_l000000_oVi^H00ol0003oi^KVonKV
iP0NonKViP03oiVIVOoVi^Koi^KV02[oi^KV000EonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go
Ogmoo`000?oVi^Koi^KVo`00000conKViP03ogmoOooVi^Koi^KV02Koi^KV0_l00009onKViP03o`00
0?nIVIWo000000?oi^KV00?o0000onKVi_oVi^H07_oVi^H00onIVIWoi^KVonKViP0ZonKViP005OoV
i^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVogmoOol000000_oVi^H00ol0003o
i^KVonKViP0`onKViP03ogmoOooVi^Koi^KV03Coi^KV00GoVIVIonKVi_oVi^Koi^KVo`00000PonKV
iP03oiVIVOoVi^Koi^KV02[oi^KV000FonKViP;o00002?oVi^H3o`000005ogmoOol0003oi^KVonKV
i_l00000:OoVi^H9ogmoOb[oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000oiVI
VOl000000_oVi^H00ol0003oi^KVonKViP0NonKViP03oiVIVOoVi^Koi^KV02[oi^KV000FonKViP;o
00001?oVi^H00ol0003oi^KVonKViP02onKViP;o000000GoOgmoonKVi_oVi^Koi^KVo`00000YonKV
iP03ogmoOooVi^Koi^KV02ooi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01OnIVIWoi^KVonKVi_oV
i^Ko000001ooi^KV00?oVIVIonKVi_oVi^H0:ooVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooV
i^H01Ol0003oi^KVonKVi_oVi^KoOgmo00;oi^KV00?o0000onKVi_oVi^H09_oVi^H00omoOgooi^KV
onKViP0`onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV0ol000001OnIVIWo0000onKVi_oVi^Ko0000
01ooi^KV00?oVIVIonKVi_oVi^H0:ooVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^KoOgmo00;oi^KV00?o0000onKVi_oVi^H09OoVi^H00omoOgooi^KVonKViP0a
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Ko0000oiVIV@02onKViP03o`00
0?oVi^Koi^KV01goi^KV00?oVIVIonKVi_oVi^H0:ooVi^H001Goi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H3o`000004ogmoOooVi^Koi^KVo`0002Ooi^KV00?oOgmoonKVi_oVi^H0<OoVi^H01?l0003o
i^KVonKVi_l00008onKViP04o`000?oVi^Ko0000oiVIV@;oi^KV00?o0000onKVi_oVi^H07OoVi^H0
0onIVIWoi^KVonKViP0[onKViP005OoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Ko
i^KVonKVi_moOgl00_oVi^H00ol0003oi^KVonKViP0TonKViP03ogmoOooVi^Koi^KV03;oi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H2o`000004oiVIVOoVi^Koi^KVo`0001koi^KV00?oVIVIonKVi_oV
i^H0;?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H02?l0003oi^KVonKVi_oVi^Ko0000
ogmoOooVi^Ko00009_oVi^H00omoOgooi^KVonKViP0conKViP;o00002ooVi^H01Ol0003oVIVIonKV
i_oVi^Ko000001koi^KV00?oVIVIonKVi_oVi^H0;?oVi^H001Koi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00;oi^KV0ol000001?oVi^KoOgmoonKVi_l0000UonKViP03ogmoOooVi^Koi^KV03Coi^KV
0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol000001?nIVIWoi^KVonKVi_l0000NonKViP03
oiVIVOoVi^Koi^KV02coi^KV000EonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_mo
Ogooi^KVo`00000?onKViP?o00003?oVi^H3o`0000?oi^KV00?oOgmoonKVi_oVi^H02?oVi^H3o`00
02Woi^KV00Co0000onKVi_oVi^Ko00001ooVi^H02?l0003oi^KVonKVi_oVi^Ko0000oiVIVOoVi^Ko
00007_oVi^H00onIVIWoi^KVonKViP0/onKViP005OoVi^H01?l0003oi^KVonKVi_l0000;onKViP04
o`000?moOgooi^KVo`00013oi^KV00?o0000onKVi_oVi^H02_oVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000;oi^KV00?oOgmoonKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000002Soi^KV00Co
0000onKVi_oVi^Ko00002ooVi^H01?l0003oVIVIonKVi_l0000NonKViP03oiVIVOoVi^Koi^KV02co
i^KV000EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l000000omoOgooi^KVo`00000=onKViPGo
00002ooVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_moOgl02_oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000002Soi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oVIVIonKVi_l0000MonKViP03
oiVIVOoVi^Koi^KV02goi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00So0000onKVi_oV
i^Koi^KVo`000?oVi^KoOgmoo`0000goi^KV00Co0000onKVi_oVi^Ko00003?oVi^H4o`0000;oi^KV
00?oOgmoonKVi_oVi^H02OoVi^H3o`0002Woi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`000004
onKVi_nIVIWoi^KVo`0001goi^KV00?oVIVIonKVi_oVi^H0;OoVi^H001Goi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H02?l0003oi^KVonKVi_oVi^Ko0000onKVi_moOgoo00003_oVi^H00ol0003oi^KV
o`00000<onKViP03o`000?oVi^Koi^KV00;oi^KV00?oOgmoonKVi_oVi^H02OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko000002Soi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP03onKV
iP03oiVIVOl0003oi^KV01coi^KV00?oVIVIonKVi_oVi^H0;OoVi^H001Koi^KV0_l00009onKViP?o
00000_oVi^H00omoOgoo0000onKViP0>onKViP;o00003OoVi^H01?l0003oi^KVonKVi_moOgl<onKV
iP05o`000?oVi^Koi^KVonKVi_l00000:OoVi^H2o`0000Soi^KV1Ol000000ooVi^KoVIVIo`00000M
onKViP03oiVIVOoVi^Koi^KV02goi^KV000VonKViP03ogmoOol0003oi^KV00ooi^KV00?o0000onKV
i_oVi^H03?oVi^H2o`000003ogmoOooVi^Koi^KV00_oi^KV0ol0000ZonKViP;o00001?oVi^H00ol0
003oi^KVonKViP02onKViP?o00000_oVi^H00onIVIWo0000onKViP0KonKViP03oiVIVOoVi^Koi^KV
02koi^KV000VonKViP03ogmoOol0003oi^KV01?oi^KV3OmoOgljonKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV00So0000onKVi_oVi^Koi^KVo`000?oVi^KoVIVIo`0001Woi^KV1?nIVIT`onKViP009ooV
i^H00omoOgooi^KVonKViP0:onKViPSoOgmoAooVi^H01?l0003oi^KVonKVi_l00007onKViP05o`00
0?oVi^Koi^KVonKVi_l000000_oVi^H00onIVIWoi^KVonKViP08onKViPooVIVI=?oVi^H001goi^KV
2_l0000=ogmoOc3o00007ooVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000ooVi^H;oiVIVD?o
i^KV000WonKViP03o`000?oVi^Koi^KV05Woi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003o
i^KVonKViP04onKViP03o`000?oVi^Koi^KV04_oi^KV0023onKViP04o`000?oVi^Koi^KVo`0000So
i^KV00?o0000onKVi_oVi^H0DOoVi^H008Coi^KV0_l0000:onKViP;o0000DOoVi^H00>?oi^KV003S
onKViP00<OoVi^H2o`000004onKVi_l0003o0000o`0000;oi^KV0_l00003onKViP?o00000_oVi^H2
o`000005onKVi_l0003o0000o`000?oVi^H00ol0001BonKViP?o00000ooVi^H5o`000004onKVi_l0
003o0000o`0000;oi^KV0ol000001?oVi^Ko0000o`000?l0000/onKViP00<OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko
000000?oi^KV00Go0000onKVi_oVi^Koi^KVo`00001DonKViP03o`000?oVi^Koi^KV00?oi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKV
i_oVi^H0:ooVi^H0037oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP04o`000?oVi^Koi^KV
o`0000?oi^KV00Co0000onKVi_oVi^Koi^KV1Ol00003onKViP03o`000?oVi^Koi^KV05;oi^KV00?o
0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Ko000000;oi^KV00Go
0000onKVi_oVi^Koi^KVo`00000]onKViP00<OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV
00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Ko000000Co
i^KV00?o0000onKVi_oVi^H0D_oVi^H3o`0000?oi^KV0ol00003onKViP?o00000_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000002goi^KV000aonKViP05o`000?oVi^Ko0000onKVi_l000000_oVi^H02_l0
003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l00002onKViP03o`000?oVi^Ko000000;o
i^KV00Go0000onKVi_l0003oi^KVo`00001BonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000
onKVi_oVi^H00ooVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0000]onKV
iP00<OoVi^H2o`000003onKVi_l0003o000000;oi^KV00[o0000onKVi_oVi^Ko0000onKVi_l0003o
i^KVo`000?oVi^Ko00000ooVi^H02Ol0003oi^KVonKVi_oVi^Ko0000onKVi_l0003oi^KVo`00001B
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KV
onKVi_l0003oi^KV00;o000000?oi^KVo`000?l00000;OoVi^H0037oi^KV00Co0000onKVi_oVi^Ko
i^KV1Ol000000ooVi^Ko0000o`000005o`0000;oi^KV0_l00003onKViPGo0000DOoVi^H4o`0000;o
i^KV1Ol000000ooVi^Ko0000o`000002o`0000;oi^KV00Co0000onKVi_oVi^Koi^KV0_l0000/onKV
iP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV000k
onKViP?o00002ooVi^H3o`0000coi^KV0ol0001;onKViP?o00002_oVi^H3o`0000coi^KV0ol0000N
onKViP00??oVi^H00ol0003oi^KVonKViP09onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000004_oi^KV00?o0000onKVi_oVi^H02?oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000[oi^KV00Go0000onKVi_oVi^Koi^KVo`00000MonKViP00>OoVi^H5o`0000[oi^KV
00Go0000onKVi_oVi^Koi^KVo`00000:onKViP05o`000?oVi^Koi^KVonKVi_l00000B?oVi^H5o`00
00Woi^KV00Go0000onKVi_oVi^Koi^KVo`00000:onKViP05o`000?oVi^Koi^KVonKVi_l000007OoV
i^H003Woi^KV00Co0000onKVi_oVi^Ko00002ooVi^H4o`0000coi^KV0ol00019onKViP04o`000?oV
i^Koi^KVo`0000[oi^KV1?l0000<onKViP?o00007_oVi^H003[oi^KV00?o0000onKVi_l000002ooV
i^H00ol0003oi^KVonKViP0<onKViP05o`000?oVi^Koi^KVonKVi_l00000BOoVi^H00ol0003oi^KV
o`00000:onKViP03o`000?oVi^Koi^KV00coi^KV00Go0000onKVi_oVi^Koi^KVo`00000MonKViP00
>ooVi^H2o`0000coi^KV00?o0000onKVi_oVi^H02ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000004[o
i^KV0_l0000;onKViP03o`000?oVi^Koi^KV00_oi^KV00Go0000onKVi_oVi^Koi^KVo`00000MonKV
iP00??oVi^H00ol0003oi^KVonKViP0;onKViP;o00003?oVi^H3o`0004coi^KV00?o0000onKVi_oV
i^H02_oVi^H2o`0000coi^KV0ol0000NonKViP00hooVi^H002Goi^KV2?l0000eoda<C003o`000?oV
i^Koi^KV02[oi^KV0_l000000omVIVKo0000o`00000jo`0001Goi^KV000VonKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H01Om<C4coi^KVonKVi_oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko
00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`000003
onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV
00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP0]onKViP04ofIVI_oVi^Koi^KVo`00
00?oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l000000ooV
i^H01?l0003oi^KVonKVi_l00003onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000;oi^KV00?o0000onKVi_oVi^H05OoVi^H002goi^KV00?oC4a<o`000?oVi^H0HOoVi^H0
0omVIVKoi^KVonKViP04onKViP03o`000?oVi^Koi^KV04Soi^KV000]onKViP03oda<C?oVi^Koi^KV
067oi^KV00?oIVIVonKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP18onKViP00;?oVi^H00om<C4co
0000o`00001SonKViP03ofIVI_oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Ooi^KV
0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00002onKViPGo000000?oC4a<o`000?oVi^H0
D_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000;oi^KV00?o0000ofIVI_l00000
0_l00002onKViP03o`000?oVi^Koi^KV04Soi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00?o0000onKVi_oVi^H00_oVi^H01Ol0003oi^KVonKVi_l0003oC4a<00;o0000DOoVi^H01?l0003o
i^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00CoIVIVonKVi_oVi^Ko00000_oV
i^H00ol0003oi^KVonKViP18onKViP005_oVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oV
i^Koi^KV00?oi^KV00Go0000onKVi_oVi^KoC4a<o`00001BonKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H00omVIVKo0000onKViP03onKViP03o`000?oVi^Koi^KV
04Soi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01?oVi^H00ol0
003oi^KVoda<C002o`00057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l0
0002onKViP03ofIVI_oVi^Ko000000?oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Koi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00?oC4a<onKVi_l00000
D_oVi^H01?l0003oi^KVonKVi_l00008onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_mV
IVKoi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Koi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H2o`0000?oi^KV00Ko0000onKVi_oVi^Koi^KVoda<C?oVi^H2o`00057oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^KoIVIVonKVi_l00002onKV
iP03o`000?oVi^Koi^KV04Soi^KV000GonKViP;o00002_oVi^H00ol0003oi^KVonKViP02onKViP?o
000000CoC4a<onKVi_l0003o0000D_oVi^H2o`0000[oi^KV0_l00003onKViP03o`000?mVIVKo0000
00?oi^KV00?o0000onKVi_oVi^H0B?oVi^H002_oi^KV00?oC4a<onKVi_l00000IOoVi^H00omVIVKo
i^KVonKViP02onKViP03o`000?oVi^Koi^KV04Soi^KV000GonKViP;o00001?oVi^H00ol0003oi^KV
onKViP02onKViP?o00001?oVi^H2o`000004oda<C?oVi^Ko0000o`0005;oi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP03ofIVI_l0003o000000;oi^KV00?o0000onKVi_oV
i^H0B?oVi^H001Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP04onKViP04
oda<C?oVi^Koi^KVo`0005;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l0
0004onKViP05ofIVI_oVi^Koi^KVonKVi_l00000B_oVi^H001Koi^KV00Co0000onKVi_oVi^Ko0000
2OoVi^H01?l0003oi^KVonKVi_oVi^H3o`000003oda<C?l0003oi^KV00;o0000DOoVi^H01?l0003o
i^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H00ol000001OmVIVKo0000onKVi_oV
i^Ko000004[oi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KV
o`000002onKViP04oda<C?oVi^Koi^KVo`0005;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0
003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00GoIVIVonKVi_oVi^Koi^KVo`00001:onKViP005_oV
i^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_m<C4`0
0_oVi^H2o`00057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKV
iP03o`000?oVi^KoIVIV00?oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Koi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H2o`0000Goi^KV00Go0000oda<C?oVi^Koi^KVo`00001BonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oIVIVonKViP02onKViP03o`00
0?oVi^Koi^KV04Soi^KV000GonKViP;o00002_oVi^H00ol0003oi^KVonKViP03onKViP04oda<C?l0
003oi^KVonKViP;o0000D_oVi^H2o`0000[oi^KV0_l00005onKViP05o`000?mVIVKoi^KVonKVi_l0
0000B_oVi^H001Ooi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP03o`00
0?m<C4co000000;oi^KV0_l0001BonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o0000
0ooVi^H3o`000004ofIVI_oVi^Koi^KVo`0004[oi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00_o0000onKVi_oVi^Koi^KVo`000?oVi^KoC4a<onKVi_l0003oi^KVo`00001BonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04ofIVI_oVi^Ko
i^KVo`0004[oi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00[o0000onKVi_oVi^Koi^KV
o`000?oVi^KoC4a<onKVi_l0003oi^KV0_l0001AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP04ofIVI_oVi^Koi^KVo`0004[oi^KV000FonKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00Co0000onKVi_oVi^Koi^KV0_l000001Om<C4co0000onKVi_oV
i^Ko000005;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Co
000000CoIVIVonKVi_oVi^Ko0000B_oVi^H001Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01ol0
003oi^KVonKVi_oVi^Ko0000onKVi_m<C4`00ooVi^H2o`00057oi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00CoIVIVonKVi_oVi^Ko0000B_oVi^H0
01Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0000Coi^KV00?oC4a<onKVi_oVi^H00_oVi^H0
0ol0003oi^KVonKViP1@onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01ol0003oi^KVonKVi_oVi^KoIVIVonKVi_l00000B_oVi^H001Ooi^KV0_l0000:onKViP03
o`000?oVi^Koi^KV00;oi^KV00?oC4a<o`000?l000000_oVi^H2o`0005;oi^KV0_l0000:onKViP;o
00001?oVi^H2o`000004onKVi_mVIVKoi^KVo`0004[oi^KV000GonKViP;o00001?oVi^H00ol0003o
i^KVonKViP02onKViP?o00000ooVi^H00om<C4co0000o`000002onKViP03o`000?oVi^Koi^KV057o
i^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o000000Coi^KVofIVI_oV
i^Ko0000B_oVi^H001Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01_l0003oi^KVonKVi_oVi^Ko
0000oda<C0;oi^KV00Co0000onKVi_l0003o0000DOoVi^H01?l0003oi^KVonKVi_l00008onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oIVIVonKVi_l0001:onKViP005_oVi^H0
1?l0003oi^KVonKVi_l00009onKViP06o`000?oVi^Koi^KVonKVi_l0003oC4a<0_oVi^H00ol0003o
i^KVo`00001BonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0003onKViP04o`000?mVIVKoi^KVo`0004[oi^KV000FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00Go0000onKVi_oVi^Koi^KVoda<C003o`0000;oi^KV0_l0001AonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000;oi^KV00?oIVIVo`000?oVi^H0BOoVi^H0
01Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^KoC4a<00?oi^KV00Co
0000onKVi_l0003o0000DOoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H01?l0003oi^KVofIVI_l0001:onKViP005_oVi^H01?l0003oi^KVonKVi_l0
0008onKViP;o00000ooVi^H01om<C4coi^KVonKVi_oVi^Ko0000onKVi_l00000D_oVi^H01?l0003o
i^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVofIV
I_l0001:onKViP005ooVi^H2o`0000[oi^KV00Go0000onKVi_oVi^Koi^KVoda<C003o`0000;oi^KV
0_l0001BonKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP03ofIVI_l0003oi^KV04Woi^KV
000MonKViP;o00001?oVi^H01Ol0003oi^KVonKVi_oVi^KoC4a<00Co000000?oi^KVo`000?oVi^H0
F?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?oIVIVo`000?oVi^H0
BOoVi^H001coi^KV00Co0000onKVi_oVi^Ko00001_oVi^H00om<C4coi^KVo`000002onKViP04o`00
0?oVi^Ko0000o`0005Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKV
iP03ofIVI_oVi^Koi^KV04Soi^KV000LonKViP04o`000?oVi^Koi^KVo`0000Koi^KV00CoC4a<onKV
i_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP1FonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o
0000onKVi_oVi^H00_oVi^H00omVIVKoi^KVonKViP18onKViP007?oVi^H01?l0003oi^KVonKVi_l0
0006onKViP05oda<C?oVi^Koi^KVonKVi_l000000_oVi^H2o`0005Ooi^KV00Co0000onKVi_oVi^Ko
00002OoVi^H00ol0003oi^KVonKViP02onKViSCoIVIV5ooVi^H001coi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_l00000F?oVi^H01?l0003oi^KVonKVi_l0
0009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0B?oVi^H001coi^KV00Co0000
onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000005[oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H2o`0004ooi^KV000MonKViP;o00002OoVi^H3o`0005coi^KV0_l0000:onKViP03o`00
0?oVi^Koi^KV04goi^KV003SonKViP00hooVi^H003Soi^KV1?l00004onKViP;o00000_oVi^H3o`00
00?oi^KV1Ol0001=onKViPGo000000Koi^KVo`000?l0003o0000onKVi_l00003onKViP;o00000_oV
i^H2o`000003onKVi_l0003o000000Co00001?oVi^H3o`0002Goi^KV000ionKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP04o`00
0?oVi^Koi^KVo`0004koi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002
onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP04
o`000?oVi^Koi^KVo`0002Coi^KV000ionKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV04ooi^KV00?o0000
onKVi_oVi^H00ooVi^H01_l0003oi^KVo`000?l0003oi^KVo`0000Goi^KV1Ol00002onKViP03o`00
0?oVi^Koi^KV00Koi^KV00?o0000onKVi_oVi^H08_oVi^H003Woi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000ooVi^H00ol0003oi^KVonKViP1?onKViP?o
00000ooVi^H01_l0003oi^KVo`000?l0003oi^KVo`0000Koi^KV00?o0000onKVi_l000000ooVi^H3
o`0000Coi^KV0_l0000UonKViP00>OoVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1?onKViP03o`00
0?oVi^Koi^KV00?oi^KV0_l000001?oVi^Ko0000onKVi_l00006onKViP03o`000?oVi^Ko000000?o
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP0UonKViP00>OoVi^H01?l0003o
i^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oV
i^H00ol0003oi^KVonKViP1?onKViP04o`000?oVi^Koi^KVo`0000;oi^KV0_l000001OoVi^Ko0000
onKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP04o`000?oVi^Koi^KV
o`0000;oi^KV00Co0000onKVi_oVi^Ko00009?oVi^H003Soi^KV1?l00002onKViP?o000000?oi^KV
o`000?l000001?l00002onKViP?o0000CooVi^H5o`000004onKVi_l0003o0000onKViP?o00000_oV
i^H3o`0000;oi^KV0_l00003onKViPCo00001?oVi^H3o`0002Coi^KV003SonKViP00hooVi^H00>?o
i^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00:Koi^KV0ol0000:onKViP?o0000
3?oVi^H3o`0001koi^KV000FonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP?o0000P_oV
i^H00ol0003oi^KVonKViP08onKViP05o`000?oVi^Koi^KVonKVi_l000002_oVi^H01Ol0003oi^KV
onKVi_oVi^Ko000001goi^KV000EonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oV
i^Koi^KVo`00001lonKViPGo00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000[oi^KV00Go0000
onKVi_oVi^Koi^KVo`00000MonKViP005OoVi^H01?l0003oi^KVonKVi_l00005onKViP[o6ATIO?oV
i^H01?l0003oi^KVonKVi_l0000:onKViPCo00003?oVi^H3o`0001koi^KV000EonKViP04o`000?oV
i^Koi^KVo`0000Ooi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00olI6AWoi^KVonKViP1konKViP03
o`000?oVi^Ko000000[oi^KV00?o0000onKVi_oVi^H03?oVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
01goi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?o0000onKVi_l000000ooVi^H00olI
6AWoi^KVonKViP1lonKViP;o00002ooVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KV
onKVi_l000007OoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`0000?oi^KV00?o6ATI
onKVi_oVi^H0OOoVi^H00ol0003oi^KVonKViP0:onKViP;o00003?oVi^H3o`0001koi^KV000FonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003o6ATIonKViP1^onKV
iP03o`000?oVi^Koi^KV04Soi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKV
i_oVi^Koi^KVo`000002onKViP03o`000?lI6AWoi^KV06Goi^KV0_l000000olc<c?o0000o`00000j
o`0001Goi^KV000EonKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Go0000onKVi_oVi^Ko0000oaTI
6@1XonKViP04oc<c<ooVi^Koi^KVo`0000?oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP05
o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00003onKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko
00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H05OoVi^H001Go
i^KV00Co0000onKVi_oVi^Ko00002ooVi^H01Ol0003oi^KVonKVi_l0003o6ATI06Soi^KV00?o<c<c
onKVi_oVi^H01?oVi^H00ol0003oi^KVonKViP18onKViP005OoVi^H01?l0003oi^KVonKVi_l00007
onKViPCo00000ooVi^H00ol0003o6ATIonKViP1WonKViP03oc<c<ooVi^Koi^KV00Coi^KV00?o0000
onKVi_oVi^H0B?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP04
onKViP03o`000?oVi^Ko6ATI06Soi^KV00?o<c<conKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP18
onKViP005_oVi^H2o`0000Soi^KV1Ol00002onKViP03o`000?oVi^Ko6ATI02Ooi^KV00?o6ATIonKV
i_oVi^H0;OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000;oi^KV00?o0000oc<c
<ol000000_l00002onKViP03o`000?oVi^Koi^KV04Soi^KV000FonKViP;o00001?oVi^H00ol0003o
i^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVoaTI6@0WonKViP03oaTI6OoVi^Koi^KV02co
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP04oc<c<ooVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooV
i^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_lI6AT09_oVi^H2oaTI6A3oi^KV
00?o6ATIonKVi_oVi^H06ooVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00?o<c<co`000?oVi^H00ooVi^H00ol0003oi^KVonKViP18onKViP005OoVi^H01?l0003o
i^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVoaTI6@0U
onKViP04oaTI6OoVi^Koi^KVoaTI6@ooi^KV00?o6ATIonKVi_oVi^H06ooVi^H01?l0003oi^KVonKV
i_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o<c<conKVi_l000000ooVi^H00ol0003o
i^KVonKViP18onKViP005OoVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000ooVi^H01?l0003o
i^KVonKVi_lI6ATTonKViP04oaTI6OoVi^Koi^KVoaTI6@ooi^KV00?o6ATIonKVi_oVi^H06ooVi^H0
1?l0003oi^KVonKVi_l00008onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKVi_lc<c?oi^KV
o`0000;oi^KV00?o0000onKVi_oVi^H0B?oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H0
0ol0003oi^KVonKViP04onKViP04o`000?oVi^Koi^KVoaTI6B?oi^KV00Go6ATIonKVi_oVi^Koi^KV
oaTI6@0>onKViP03oaTI6OoVi^Koi^KV01coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H02_l0003o
i^KVonKVi_l0003oi^KVo`000?oVi^Ko<c<conKVi_l00002onKViP03o`000?oVi^Koi^KV04Soi^KV
000EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KV
onKVi_lI6ATSonKViP05oaTI6OoVi^Koi^KVonKVi_lI6AT03_oVi^H00olI6AWoi^KVonKViP0MonKV
iP;o00002_oVi^H2o`0000?oi^KV00?o0000oc<c<ol000000ooVi^H00ol0003oi^KVonKViP18onKV
iP005_oVi^H2o`0000[oi^KV0_l00003onKViP04o`000?oVi^Koi^KVoaTI6B;oi^KV00?o6ATIonKV
i_oVi^H00ooVi^H00olI6AWoi^KVonKViP0;onKViP03oaTI6OoVi^Koi^KV01goi^KV0_l00004onKV
iP03o`000?oVi^Koi^KV00?oi^KV0_l00004onKViP03oc<c<ol0003o000000;oi^KV00?o0000onKV
i_oVi^H0B?oVi^H001Koi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oV
i^H00_oVi^H01?l0003oi^KVonKVi_lI6ATQonKViP03oaTI6OoVi^Koi^KV00Coi^KV00?o6ATIonKV
i_oVi^H02_oVi^H00olI6AWoi^KVonKViP0MonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00000ooVi^H00olc<c?o0000onKViP02onKViP03o`000?oVi^Koi^KV04Soi^KV000E
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H01Ol0003oi^KVonKV
i_oVi^Ko6ATI023oi^KV00?o6ATIonKVi_oVi^H01?oVi^H00olI6AWoi^KVonKViP0:onKViP03oaTI
6OoVi^Koi^KV01goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV
00?o000000Go<c<co`000?oVi^Koi^KVo`00001:onKViP005OoVi^H01?l0003oi^KVonKVi_l0000:
onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H00olI6AWoi^KVonKViP0MonKViP03oaTI6OoV
i^Koi^KV00Goi^KV00?o6ATIonKVi_oVi^H02_oVi^H00olI6AWoi^KVonKViP0MonKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP05oc<c<ooVi^Koi^KV
onKVi_l00000B_oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000?oi^KV00?o6ATIonKVi_oVi^H07OoVi^H00olI6AWoi^KVonKViP06onKViP03oaTI6OoV
i^Koi^KV00Soi^KV00?o6ATIonKVi_oVi^H07_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_lc<c<00ooVi^H00ol0003oi^KVonKViP18onKViP00
5OoVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o6ATIonKV
i_oVi^H07?oVi^H00olI6AWoi^KVonKViP07onKViP03oaTI6OoVi^Koi^KV00Soi^KV00?o6ATIonKV
i_oVi^H07_oVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o
0000oc<c<ooVi^H00_oVi^H00ol0003oi^KVonKViP18onKViP005OoVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko6ATI01go
i^KV00?o6ATIonKVi_oVi^H02?oVi^H00olI6AWoi^KVonKViP08onKViP03oaTI6OoVi^Koi^KV01oo
i^KV0_l0000:onKViP;o00001OoVi^H01Olc<c?oi^KVonKVi_oVi^Ko000004[oi^KV000FonKViP;o
00002?oVi^H5o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVoaTI6@0MonKViP03oaTI6OoVi^Koi^KV
00Soi^KV00?o6ATIonKVi_oVi^H02?oVi^H00olI6AWoi^KVonKViP0conKViP04oc<c<ooVi^Koi^KV
o`0004[oi^KV000FonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0
003oi^KVonKViP02onKViP03oaTI6OoVi^Koi^KV01Woi^KV00?o6ATIonKVi_oVi^H02_oVi^H00olI
6AWoi^KVonKViP06onKViP03oaTI6OoVi^Koi^KV023oi^KV0_l00004onKViP03o`000?oVi^Koi^KV
00?oi^KV0_l00003onKViP?o000000Co<c<conKVi_oVi^Ko0000B_oVi^H001Goi^KV00Co0000onKV
i_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H00_oV
i^H00olI6AWoi^KVonKViP0IonKViP03oaTI6OoVi^Koi^KV00[oi^KV00?o6ATIonKVi_oVi^H01_oV
i^H00olI6AWoi^KVonKViP0OonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko
0000onKVi_l00003onKViP04oc<c<ooVi^Koi^KVo`0004[oi^KV000EonKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o
6ATIonKVi_oVi^H06?oVi^H00olI6AWoi^KVonKViP0;onKViP03oaTI6OoVi^Koi^KV00Koi^KV00?o
6ATIonKVi_oVi^H07ooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oV
i^Ko00000ooVi^H01?lc<c?oi^KVonKVi_l0001:onKViP005OoVi^H01?l0003oi^KVonKVi_l00008
onKViP?o00000ooVi^H00ol0003oi^KVonKViP02onKViP03oaTI6OoVi^Koi^KV01Soi^KV00?o6ATI
onKVi_oVi^H02ooVi^H00olI6AWoi^KVonKViP05onKViP03oaTI6OoVi^Koi^KV023oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00Co000000Co<c<conKVi_oVi^Ko
0000B_oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00;oi^KV00?o0000onKVi_oVi^H00_oVi^H00olI6AWoi^KVonKViP0GonKViP03oaTI6OoVi^Koi^KV
00goi^KV00?o6ATIonKVi_oVi^H01?oVi^H00olI6AWoi^KVonKViP0PonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04oc<c<ooVi^Koi^KVo`0004[o
i^KV000EonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKV
iP03o`000?oVi^Koi^KV00?oi^KV00?o6ATIonKVi_oVi^H05_oVi^H00olI6AWoi^KVonKViP0=onKV
iP03oaTI6OoVi^Koi^KV00Coi^KV00?o6ATIonKVi_oVi^H08?oVi^H01?l0003oi^KVonKVi_l00008
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Oo0000onKVi_oVi^Koi^KVoc<c<ooVi^Ko000004[o
i^KV000FonKViP;o00002OoVi^H3o`0000?oi^KV00?o0000onKVi_oVi^H00ooVi^H00olI6AWoi^KV
onKViP0EonKViP03oaTI6OoVi^Koi^KV00koi^KV00?o6ATIonKVi_oVi^H00ooVi^H00olI6AWoi^KV
onKViP0RonKViP;o00002_oVi^H2o`0000Coi^KV0_l000001?oVi^Ko<c<conKVi_l0001:onKViP00
5_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H0
0ooVi^H00olI6AWoi^KVonKViP0EonKViP03oaTI6OoVi^Koi^KV00koi^KV00?o6ATIonKVi_oVi^H0
0ooVi^H00olI6AWoi^KVonKViP0RonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o0000
0ooVi^H3o`000004onKVi_lc<c?oi^KVo`0004[oi^KV000EonKViP04o`000?oVi^Koi^KVo`0000[o
i^KV00Go0000onKVi_oVi^Koi^KVo`000005onKViP03oaTI6OoVi^Koi^KV00Koi^KV0ol0000;onKV
iP03oaTI6OoVi^Ko000000;o00003_oVi^H00olI6AWo0000o`000002onKViP03oaTI6OoVi^Koi^KV
027oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV
00Co0000oc<c<ooVi^Ko0000B_oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003o
i^KVonKVi_l00005onKViP03oaTI6OoVi^Koi^KV00Ooi^KV00?o0000onKVi_oVi^H02OoVi^H00olI
6AWoi^KVo`000003onKViP03o`000?oVi^Koi^KV00[oi^KV00Oo0000oaTI6OoVi^Koi^KVo`000?oV
i^Ko6ATI02?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`00
00?oi^KV00Co0000oc<c<ooVi^Ko0000B_oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H4
o`0000;oi^KV00?o0000onKVi_oVi^H01?oVi^H00olI6AWoi^KVonKViP03onKViPGo00002_oVi^H0
0olI6AWoi^KVo`000003onKViP03o`000?oVi^Koi^KV00[oi^KV00Ko0000oaTI6OoVi^Koi^KVo`00
0?lI6ATTonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`00
00;oi^KV00?o<c<co`000?oVi^H0BOoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H01?oVi^H00olI6AWoi^KVonKViP03
onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00?o6ATIonKVi_oVi^H01?l0000>onKViP05oaTI6Ol0
003o0000onKVi_lI6AT09?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H01?l0003oi^KVoc<c<ol0001:onKViP005OoVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP04onKViP03oaTI
6OoVi^Koi^KV00Coi^KV00?o0000onKVi_l000002_oVi^H01?lI6AWoi^KVonKVi_l0000@onKViP06
o`000?oVi^Ko6ATIonKVi_l0003o6ATI9?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVoc<c<ol0001:onKViP005_oVi^H2o`0000Wo
i^KV0ol00003onKViP03o`000?oVi^Koi^KV00Coi^KV00?o6ATIonKVi_oVi^H01OoVi^H2o`0000Wo
i^KV00?o6ATIonKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP0=onKViP05o`000?oVi^Ko6ATIonKV
i_lI6AT09_oVi^H2o`0000[oi^KV0_l00003onKViP?o00000_oVi^H00olc<c?o0000onKViP19onKV
iP009ooVi^H00ol0003oi^KVonKViP04onKViP03oaTI6OoVi^Koi^KV00Koi^KV00?o0000onKVi_oV
i^H01ooVi^H00olI6AWoi^KVonKViP03onKViP;o00003_oVi^H01?l0003o6ATIo`000?lI6AT/onKV
iP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H00olc<c?o0000onKViP19onKV
iP009ooVi^H00ol0003oi^KVonKViP05onKViP03oaTI6OoVi^Koi^KV00[oi^KV1OlI6ATGonKViP03
oaTI6OoVi^Ko6ATI02_oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKV
iP03oc<c<ooVi^Koi^KV04Soi^KV000WonKViP03o`000?oVi^Koi^KV00Goi^KV00Co6ATIonKVi_oV
i^Koi^KV2OlI6ATMonKViP03oaTI6OoVi^Koi^KV02[oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H0
0ol0003oi^KVonKViP02onKViP03oc<c<ooVi^Koi^KV04Soi^KV000LonKViQ?o00001?lI6ATVo`00
0003oaTI6Ol0003o000000So00008_oVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Ko
i^KV00;oi^KV=?lc<c<GonKViP009ooVi^H00ol0003oi^KVonKViP1LonKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP18onKViP00Q_oVi^H01?l0
003oi^KVonKVi_l00008onKViP;o0000CooVi^H008Ooi^KV0_l0000:onKViP03o`000?oVi^Koi^KV
04goi^KV003SonKViP00<ooVi^H2o`0000;oi^KV0ol00002onKViP03o`000?oVi^Ko000000;o0000
0ooVi^H3o`0000?oi^KV0ol0001?onKViPCo00000_oVi^H5o`0000?oi^KV0_l00002onKViP;o0000
00?oi^KVo`000?l000001?l00004onKViP?o00009OoVi^H003;oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV04goi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H0
1?l0003oi^KVonKVi_l00005onKViP04o`000?oVi^Koi^KVo`0002Coi^KV000aonKViP03o`000?oV
i^Koi^KV00Coi^KV00?o0000onKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV
00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1=onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP03onKViPGo00000_oVi^H00ol0003o
i^KVonKViP06onKViP03o`000?oVi^Koi^KV02;oi^KV000aonKViP03o`000?oVi^Koi^KV00Coi^KV
0ol00002onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H2o`0000Coi^KV0_l0001@onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV0ol00002onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKV
i_l000000ooVi^H3o`0000Coi^KV0_l0000UonKViP00<OoVi^H00ol0003oi^KVonKViP04onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00005onKViP03o`000?oV
i^Koi^KV053oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP02onKViP03o`00
0?oVi^Koi^KV00Coi^KV00?o0000onKVi_l000000ooVi^H01?l0003oi^KVonKVi_l00002onKViP03
o`000?oVi^Koi^KV02Goi^KV000bonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oV
i^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP1=onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0000TonKViP00<ooVi^H3o`000003onKVi_l0
003o000000;o00000ooVi^H3o`0000Coi^KV0ol00003onKViP?o0000C_oVi^H4o`0000;oi^KV1Ol0
0003onKViP?o00000_oVi^H2o`0000?oi^KV1?l00004onKViP?o00009?oVi^H00>?oi^KV003SonKV
iP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003S
onKViP00hooVi^H005[oi^KV1?l00025onKViP00FooVi^H2o`0008Koi^KV001KonKViP;o0000Q_oV
i^H003ooi^KV1Ol00002onKViPCo00002OoVi^H5o`0000?oi^KV1Ol00002onKViP?o000000?oi^KV
o`000?l000000_l000000ooVi^Ko0000o`000004o`0000;oi^KV0_l000000ooVi^Ko0000o`000002
o`000003onKVi_l0003o000000;o00001OoVi^H4o`0000;oi^KV3?l000000ooVi^Ko0000o`000004
o`000003onKVi_l0003o000000Go0000?_oVi^H003koi^KV0_l00003onKViP;o00000_oVi^H2o`00
00Woi^KV0_l00003onKViP;o00000_oVi^H2o`0000;oi^KV1?l00002onKViP04o`000?oVi^Ko0000
o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_oVi^H2
o`000003onKVi_l0003o000000Ooi^KV0_l00002onKViP?o000000Coi^KVo`000?l0003oi^KV0_l0
0002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000onKVi_l00000
0_oVi^H2o`0003goi^KV000monKViP;o00001?oVi^H2o`0000;oi^KV0_l00008onKViP;o00001OoV
i^H2o`000003onKVi_l0003o000000;oi^KV1?l00004onKViP;o00000_oVi^H2o`000003onKVi_l0
003o000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000001ooV
i^H2o`000004onKVi_l0003o0000o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o0000
00?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000?oi^KV0ol0000monKViP00?OoV
i^H2o`0000?oi^KV1?l000000ooVi^Ko0000o`000003o`0000Goi^KV0_l00005onKViP;o000000?o
i^KVo`000?l000000_oVi^H7o`000003onKVi_l0003o000000Coi^KV0ol00002onKViP;o000000?o
i^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV1Ol00005onKViP?o00000_oV
i^H2o`000003onKVi_l0003o000000;oi^KV1?l00002onKViP?o0000?ooVi^H003goi^KV0_l00008
onKViP;o00000_oVi^H2o`0000Coi^KV0_l00005onKViP;o000000Goi^KVo`000?l0003o0000onKV
iP04o`000004onKVi_l0003o0000onKViPKo000000?oi^KVo`000?l000000_oVi^H2o`000003onKV
i_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002o`0000Goi^KV0_l00003onKViP;o0000
00Coi^KVo`000?l0003oi^KV0_l00002onKViPGo00000_oVi^H2o`0000;oi^KV00Co0000onKVi_l0
003o00000_oVi^H00ol0003oi^KVonKViP0konKViP00?OoVi^H2o`0000Goi^KV00?o0000onKVi_oV
i^H00_l00002onKViP;o00001?oVi^H2o`0000Goi^KV1Ol000000ooVi^Ko0000o`000002onKViP?o
000000Ooi^KVo`000?l0003o0000onKVi_l0003oi^KV00?o00000_oVi^H4o`000003onKVi_l0003o
000000;o000000Koi^KVo`000?l0003o0000onKVi_l00005onKViP;o00000ooVi^H2o`0000;oi^KV
0ol00002onKViP?o000000?oi^KVo`000?l000000_oVi^H2o`000005onKVi_l0003o0000o`000?oV
i^H01?l0000monKViP00?_oVi^H2o`0000?oi^KV0_l00002onKViP;o00000_oVi^H2o`0000Goi^KV
0_l00003onKViP;o00006OoVi^H2o`00017oi^KV0_l00003onKViP;o00003ooVi^H2o`0004Koi^KV
000oonKViPCo000000?oi^KVo`000?oVi^H01_l00007onKViPGo00006ooVi^H00ol0003oi^KVonKV
iP0>onKViPOo00003ooVi^H3o`0004Koi^KV003SonKViP00hooVi^H00001\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-4.22754, \
-0.0445132, 0.135764, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-18.6907, -0.0890264, 0.135764, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-2.68134, -0.711658, 0.119259, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-18.2834, -1.05067, 0.135764, 0.0140179}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {-4.22754, -0.306114, 0.135764, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-18.6907, -0.406114, 0.135764, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-2.62936, -2.61842, \
0.118505, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> {-18.6907, \
-0.587, 0.135764, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 0.5775`}\\)}, \
{\\({DECAPS, 0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, \
{\\({MUTAT, 0.5900596075238906`}\\)}, {\\({PERM, 0.1`}\\)}, {\\({\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)}, {\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)}}, ColumnAlignments -> Left, GridBaseline -> {Baseline, \
{1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Expression \!\(AntTracker[\(\(seq[advance]\)\)]\) or \!\(AntTracker[\(\
\(seq[advance]\)\)]\) does not contain pattern \!\({\(\(\(ifSensor[_]\)\)[__]\
\)}\).   Crossover not performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(\(ifSensor[_]\)\)[x__]\)\) /; \(\(\(\(Depth[\(\({x}\
\)\)]\)\) > 1\)\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No encapsulation performed."\)], \
"Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({_seq}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No decapsulation performed."\)], \
"Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(10\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 -5.55112e-17 1.12899 [
[.5 .9621 -97.125 0 ]
[.5 .9621 97.125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.76096 .0388 0 -8.81073 ]
[.76096 .0388 10.625 5.18927 ]
[.78787 .06986 0 -8.74451 ]
[.78787 .06986 10.625 5.25549 ]
[.81321 .0991 0 -8.68296 ]
[.81321 .0991 10.625 5.31704 ]
[.83711 .12668 0 -8.62561 ]
[.83711 .12668 10.625 5.37439 ]
[.85969 .15274 0 -8.57204 ]
[.85969 .15274 10.625 5.42796 ]
[.88106 .1774 0 -8.52189 ]
[.88106 .1774 10.625 5.47811 ]
[.90131 .20078 0 -8.47484 ]
[.90131 .20078 10.625 5.52516 ]
[.92053 .22296 0 -8.43061 ]
[.92053 .22296 10.625 5.56939 ]
[.9388 .24404 0 -8.38896 ]
[.9388 .24404 10.625 5.61104 ]
[.95618 .2641 0 -8.34966 ]
[.95618 .2641 17.25 5.65034 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 17.25 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -158.125 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
253.250 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.74729 .04234 m
.74046 .0441 L
s
gsave
.76096 .0388 -61 -12.8107 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.77417 .07327 m
.76733 .07498 L
s
gsave
.78787 .06986 -61 -12.7445 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.79949 .1024 m
.79263 .10405 L
s
gsave
.81321 .0991 -61 -12.683 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.82336 .12987 m
.81649 .13147 L
s
gsave
.83711 .12668 -61 -12.6256 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.84592 .15583 m
.83904 .15738 L
s
gsave
.85969 .15274 -61 -12.572 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.86727 .1804 m
.86038 .1819 L
s
gsave
.88106 .1774 -61 -12.5219 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.8875 .20369 m
.8806 .20514 L
s
gsave
.90131 .20078 -61 -12.4748 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.90671 .22578 m
.89979 .2272 L
s
gsave
.92053 .22296 -61 -12.4306 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.92496 .24678 m
.91803 .24816 L
s
gsave
.9388 .24404 -61 -12.389 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
1.000 setlinewidth
grestore
.94232 .26677 m
.93539 .2681 L
s
gsave
.95618 .2641 -61 -12.3497 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(11) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.15895 .24176 m
.12427 .92043 L
s
.24611 .29054 m
.22115 .93007 L
s
.32359 .3339 m
.3064 .93856 L
s
.39293 .3727 m
.38199 .94608 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.45048 .37446 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.49806 .36545 m .57042 .37159 L .52233 .38044 L F
.45048 .37446 m .49806 .36545 L .52233 .38044 L F
.42441 .35921 m .49806 .36545 L .45048 .37446 L F
.54688 .35621 m .61975 .36251 L .57042 .37159 L F
.49806 .36545 m .54688 .35621 L .57042 .37159 L F
.4727 .3498 m .54688 .35621 L .49806 .36545 L F
.42441 .35921 m .4727 .3498 L .49806 .36545 L F
.597 .34672 m .67039 .35318 L .61975 .36251 L F
.54688 .35621 m .597 .34672 L .61975 .36251 L F
.39718 .34328 m .4727 .3498 L .42441 .35921 L F
.52229 .34014 m .597 .34672 L .54688 .35621 L F
.4727 .3498 m .52229 .34014 L .54688 .35621 L F
.64847 .33698 m .72237 .34361 L .67039 .35318 L F
.597 .34672 m .64847 .33698 L .67039 .35318 L F
.4462 .33344 m .52229 .34014 L .4727 .3498 L F
.39718 .34328 m .4462 .33344 L .4727 .3498 L F
.57321 .33022 m .64847 .33698 L .597 .34672 L F
.52229 .34014 m .57321 .33022 L .597 .34672 L F
.70134 .32697 m .77575 .33379 L .72237 .34361 L F
.64847 .33698 m .70134 .32697 L .72237 .34361 L F
.36871 .32661 m .4462 .33344 L .39718 .34328 L F
.49656 .32333 m .57321 .33022 L .52229 .34014 L F
.4462 .33344 m .49656 .32333 L .52229 .34014 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .44415 .92902 L p F P
0 0 0 r
s
.62554 .32002 m .70134 .32697 L .64847 .33698 L 1 0 0 r
F
.57321 .33022 m .62554 .32002 L .64847 .33698 L F
.75567 .31668 m .8306 .32369 L .77575 .33379 L F
.70134 .32697 m .75567 .31668 L .77575 .33379 L F
.41847 .31632 m .49656 .32333 L .4462 .33344 L F
.36871 .32661 m .41847 .31632 L .4462 .33344 L F
.54832 .31294 m .62554 .32002 L .57321 .33022 L F
.49656 .32333 m .54832 .31294 L .57321 .33022 L F
.57295 .92839 m .52132 .93033 L .4952 .92704 L p F P
0 0 0 r
s
.44415 .92902 m .4952 .92704 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.67933 .30954 m .75567 .31668 L .70134 .32697 L 1 0 0 r
F
.62554 .32002 m .67933 .30954 L .70134 .32697 L F
.3389 .30917 m .41847 .31632 L .36871 .32661 L F
.81153 .30611 m .88697 .31331 L .8306 .32369 L .5 0 1 r
F
.75567 .31668 m .81153 .30611 L .8306 .32369 L 1 0 0 r
F
.46962 .30573 m .54832 .31294 L .49656 .32333 L F
.41847 .31632 m .46962 .30573 L .49656 .32333 L F
.4952 .92704 m .44415 .92902 L .41597 .92566 L p F P
0 0 0 r
s
.60153 .30226 m .67933 .30954 L .62554 .32002 L 1 0 0 r
F
.54832 .31294 m .60153 .30226 L .62554 .32002 L F
.62603 .92639 m .57295 .92839 L .54769 .925 L p F P
0 0 0 r
s
.4952 .92704 m .54769 .925 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.73464 .29876 m .81153 .30611 L .75567 .31668 L 1 0 0 r
F
.67933 .30954 m .73464 .29876 L .75567 .31668 L F
.38942 .29838 m .46962 .30573 L .41847 .31632 L F
.3389 .30917 m .38942 .29838 L .41847 .31632 L F
.86897 .29523 m .94492 .30264 L .88697 .31331 L 0 1 1 r
F
.81153 .30611 m .86897 .29523 L .88697 .31331 L .5 0 1 r
F
.52223 .29485 m .60153 .30226 L .54832 .31294 L 1 0 0 r
F
.46962 .30573 m .52223 .29485 L .54832 .31294 L F
.54769 .925 m .4952 .92704 L .46784 .92359 L p F P
0 0 0 r
s
.41597 .92566 m .46784 .92359 L .4952 .92704 L p 1 0 0 r
F P
0 0 0 r
s
.65627 .29128 m .73464 .29876 L .67933 .30954 L 1 0 0 r
F
.60153 .30226 m .65627 .29128 L .67933 .30954 L F
.68061 .92434 m .62603 .92639 L .60168 .92291 L p F P
0 0 0 r
s
.54769 .925 m .60168 .92291 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.30766 .29089 m .38942 .29838 L .3389 .30917 L 1 0 0 r
F
.79154 .28768 m .86897 .29523 L .81153 .30611 L 0 1 1 r
F
.73464 .29876 m .79154 .28768 L .81153 .30611 L 1 0 0 r
F
.44139 .28729 m .52223 .29485 L .46962 .30573 L F
.38942 .29838 m .44139 .28729 L .46962 .30573 L F
.46784 .92359 m .41597 .92566 L .38643 .92215 L p F P
0 0 0 r
s
.86897 .29523 m .92807 .28404 L .94492 .30264 L 0 1 1 r
F
.57636 .28365 m .65627 .29128 L .60153 .30226 L 1 0 0 r
F
.52223 .29485 m .57636 .28365 L .60153 .30226 L F
.60168 .92291 m .54769 .925 L .5212 .92146 L p F P
0 0 0 r
s
.46784 .92359 m .5212 .92146 L .54769 .925 L p 1 0 0 r
F P
0 0 0 r
s
.71259 .27998 m .79154 .28768 L .73464 .29876 L .5 0 1 r
F
.65627 .29128 m .71259 .27998 L .73464 .29876 L 1 0 0 r
F
.73675 .92223 m .68061 .92434 L .65723 .92076 L p F P
0 0 0 r
s
.60168 .92291 m .65723 .92076 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.35896 .27957 m .44139 .28729 L .38942 .29838 L 1 0 0 r
F
.30766 .29089 m .35896 .27957 L .38942 .29838 L F
.8501 .27627 m .92807 .28404 L .86897 .29523 L F
.79154 .28768 m .8501 .27627 L .86897 .29523 L 0 1 1 r
F
.49487 .27586 m .57636 .28365 L .52223 .29485 L 1 0 0 r
F
.44139 .28729 m .49487 .27586 L .52223 .29485 L F
.5212 .92146 m .46784 .92359 L .43914 .91998 L p F P
0 0 0 r
s
.38643 .92215 m .43914 .91998 L .46784 .92359 L p 1 0 0 r
F P
0 0 0 r
s
.63207 .27212 m .71259 .27998 L .65627 .29128 L 1 0 0 r
F
.57636 .28365 m .63207 .27212 L .65627 .29128 L F
.65723 .92076 m .60168 .92291 L .57613 .91926 L p F P
0 0 0 r
s
.5212 .92146 m .57613 .91926 L .60168 .92291 L p 1 0 0 r
F P
0 0 0 r
s
.27488 .27171 m .35896 .27957 L .30766 .29089 L 1 0 0 r
F
.77057 .26834 m .8501 .27627 L .79154 .28768 L .5 1 0 r
F
.71259 .27998 m .77057 .26834 L .79154 .28768 L .5 0 1 r
F
.79453 .92005 m .73675 .92223 L .71442 .91854 L p 1 0 0 r
F P
0 0 0 r
s
.65723 .92076 m .71442 .91854 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.41176 .26793 m .49487 .27586 L .44139 .28729 L 1 0 0 r
F
.35896 .27957 m .41176 .26793 L .44139 .28729 L F
.43914 .91998 m .38643 .92215 L .35543 .91846 L p F P
0 0 0 r
s
.8501 .27627 m .91038 .26452 L .92807 .28404 L 1 0 0 r
F
.54994 .26411 m .63207 .27212 L .57636 .28365 L F
.49487 .27586 m .54994 .26411 L .57636 .28365 L F
.57613 .91926 m .5212 .92146 L .4934 .91774 L p F P
0 0 0 r
s
.43914 .91998 m .4934 .91774 L .5212 .92146 L p 1 0 0 r
F P
0 0 0 r
s
.68944 .26025 m .77057 .26834 L .71259 .27998 L .5 0 1 r
F
.63207 .27212 m .68944 .26025 L .71259 .27998 L 1 0 0 r
F
.71442 .91854 m .65723 .92076 L .63269 .917 L p F P
0 0 0 r
s
.57613 .91926 m .63269 .917 L .65723 .92076 L p 1 0 0 r
F P
0 0 0 r
s
.32697 .25983 m .41176 .26793 L .35896 .27957 L 1 0 0 r
F
.27488 .27171 m .32697 .25983 L .35896 .27957 L F
.83028 .25636 m .91038 .26452 L .8501 .27627 L F
.77057 .26834 m .83028 .25636 L .8501 .27627 L .5 1 0 r
F
.85402 .91782 m .79453 .92005 L .77331 .91626 L p 1 0 0 r
F P
0 0 0 r
s
.71442 .91854 m .77331 .91626 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.46614 .25593 m .54994 .26411 L .49487 .27586 L 1 0 0 r
F
.41176 .26793 m .46614 .25593 L .49487 .27586 L F
.4934 .91774 m .43914 .91998 L .409 .91618 L p F P
0 0 0 r
s
.35543 .91846 m .409 .91618 L .43914 .91998 L p 1 0 0 r
F P
0 0 0 r
s
.97843 .91314 m .91529 .91551 L .87768 .4899 L p 0 1 1 r
F P
0 0 0 r
s
.87768 .4899 m .93848 .48129 L .97843 .91314 L p 0 1 1 r
F P
0 0 0 r
s
.83399 .91391 m .87768 .4899 L .91529 .91551 L p .5 0 1 r
F P
0 0 0 r
s
.93848 .48129 m .87768 .4899 L .85852 .47531 L p 1 0 0 r
F P
0 0 0 r
s
.87768 .4899 m .83399 .91391 L .81292 .9098 L p 0 1 1 r
F P
0 0 0 r
s
.81292 .9098 m .85852 .47531 L .87768 .4899 L p 0 1 1 r
F P
0 0 0 r
s
.60666 .252 m .68944 .26025 L .63207 .27212 L 1 0 0 r
F
.54994 .26411 m .60666 .252 L .63207 .27212 L F
.63269 .917 m .57613 .91926 L .5493 .91543 L p F P
0 0 0 r
s
.4934 .91774 m .5493 .91543 L .57613 .91926 L p 1 0 0 r
F P
0 0 0 r
s
.24046 .25157 m .32697 .25983 L .27488 .27171 L 1 0 0 r
F
.74853 .24802 m .83028 .25636 L .77057 .26834 L 0 1 1 r
F
.68944 .26025 m .74853 .24802 L .77057 .26834 L .5 0 1 r
F
.77331 .91626 m .71442 .91854 L .69095 .91467 L p 1 0 0 r
F P
0 0 0 r
s
.63269 .917 m .69095 .91467 L .71442 .91854 L p 1 0 0 r
F P
0 0 0 r
s
.38063 .24759 m .46614 .25593 L .41176 .26793 L 1 0 0 r
F
.32697 .25983 m .38063 .24759 L .41176 .26793 L F
.409 .91618 m .35543 .91846 L .32287 .91459 L p F P
0 0 0 r
s
.83028 .25636 m .89179 .24401 L .91038 .26452 L 1 0 0 r
F
.91529 .91551 m .85402 .91782 L .83399 .91391 L p .5 0 1 r
F P
0 0 0 r
s
.77331 .91626 m .83399 .91391 L .85402 .91782 L p 1 0 0 r
F P
0 0 0 r
s
.52217 .24357 m .60666 .252 L .54994 .26411 L 1 0 0 r
F
.46614 .25593 m .52217 .24357 L .54994 .26411 L F
.5493 .91543 m .4934 .91774 L .46419 .91383 L p F P
0 0 0 r
s
.409 .91618 m .46419 .91383 L .4934 .91774 L p 1 0 0 r
F P
0 0 0 r
s
.85852 .47531 m .92057 .46626 L .93848 .48129 L p 1 0 0 r
F P
0 0 0 r
s
.6651 .23952 m .74853 .24802 L .68944 .26025 L 1 0 0 r
F
.60666 .252 m .6651 .23952 L .68944 .26025 L F
.69095 .91467 m .63269 .917 L .60689 .91305 L p F P
0 0 0 r
s
.5493 .91543 m .60689 .91305 L .63269 .917 L p 1 0 0 r
F P
0 0 0 r
s
.29335 .23907 m .38063 .24759 L .32697 .25983 L 1 0 0 r
F
.24046 .25157 m .29335 .23907 L .32697 .25983 L F
.80944 .23542 m .89179 .24401 L .83028 .25636 L .5 1 0 r
F
.74853 .24802 m .80944 .23542 L .83028 .25636 L 0 1 1 r
F
.83399 .91391 m .77331 .91626 L .751 .91227 L p 1 0 0 r
F P
0 0 0 r
s
.69095 .91467 m .751 .91227 L .77331 .91626 L p 1 0 0 r
F P
0 0 0 r
s
.43594 .23497 m .52217 .24357 L .46614 .25593 L 1 0 0 r
F
.38063 .24759 m .43594 .23497 L .46614 .25593 L F
.46419 .91383 m .409 .91618 L .37731 .91219 L p F P
0 0 0 r
s
.32287 .91459 m .37731 .91219 L .409 .91618 L p 1 0 0 r
F P
0 0 0 r
s
.92057 .46626 m .85852 .47531 L .83837 .45997 L p 1 0 0 r
F P
0 0 0 r
s
.85852 .47531 m .81292 .9098 L .77692 .4692 L p .5 1 0 r
F P
0 0 0 r
s
.77692 .4692 m .83837 .45997 L .85852 .47531 L p .5 1 0 r
F P
0 0 0 r
s
.57993 .23083 m .6651 .23952 L .60666 .252 L 1 0 0 r
F
.52217 .24357 m .57993 .23083 L .60666 .252 L F
.60689 .91305 m .5493 .91543 L .52107 .9114 L p F P
0 0 0 r
s
.46419 .91383 m .52107 .9114 L .5493 .91543 L p 1 0 0 r
F P
0 0 0 r
s
.20425 .23038 m .29335 .23907 L .24046 .25157 L 1 0 0 r
F
.72536 .22665 m .80944 .23542 L .74853 .24802 L F
.6651 .23952 m .72536 .22665 L .74853 .24802 L F
.751 .91227 m .69095 .91467 L .66627 .9106 L p F P
0 0 0 r
s
.60689 .91305 m .66627 .9106 L .69095 .91467 L p 1 0 0 r
F P
0 0 0 r
s
.34789 .2262 m .43594 .23497 L .38063 .24759 L 1 0 0 r
F
.29335 .23907 m .34789 .2262 L .38063 .24759 L F
.37731 .91219 m .32287 .91459 L .28861 .91052 L p F P
0 0 0 r
s
.72751 .90808 m .77692 .4692 L .81292 .9098 L p .5 0 1 r
F P
0 0 0 r
s
.83837 .45997 m .77692 .4692 L .76729 .9009 L p 0 1 1 r
F P
0 0 0 r
s
.77692 .4692 m .72751 .90808 L .70275 .90365 L p .5 0 1 r
F P
0 0 0 r
s
.70275 .90365 m .76729 .9009 L .77692 .4692 L p .5 0 1 r
F P
0 0 0 r
s
.80944 .23542 m .87224 .22243 L .89179 .24401 L .5 1 0 r
F
.751 .91227 m .81292 .9098 L .83399 .91391 L p 1 0 0 r
F P
0 0 0 r
s
.49296 .22197 m .57993 .23083 L .52217 .24357 L 1 0 0 r
F
.43594 .23497 m .49296 .22197 L .52217 .24357 L F
.52107 .9114 m .46419 .91383 L .43344 .90971 L p F P
0 0 0 r
s
.37731 .91219 m .43344 .90971 L .46419 .91383 L p 1 0 0 r
F P
0 0 0 r
s
.83837 .45997 m .90173 .45045 L .92057 .46626 L p 1 0 0 r
F P
0 0 0 r
s
.63949 .2177 m .72536 .22665 L .6651 .23952 L 1 0 0 r
F
.57993 .23083 m .63949 .2177 L .6651 .23952 L F
.66627 .9106 m .60689 .91305 L .57974 .9089 L p F P
0 0 0 r
s
.52107 .9114 m .57974 .9089 L .60689 .91305 L p 1 0 0 r
F P
0 0 0 r
s
.25797 .21723 m .34789 .2262 L .29335 .23907 L .5 0 1 r
F
.20425 .23038 m .25797 .21723 L .29335 .23907 L 1 0 0 r
F
.7875 .21338 m .87224 .22243 L .80944 .23542 L .5 0 1 r
F
.72536 .22665 m .7875 .21338 L .80944 .23542 L 1 0 0 r
F
.81292 .9098 m .751 .91227 L .72751 .90808 L p .5 0 1 r
F P
0 0 0 r
s
.66627 .9106 m .72751 .90808 L .751 .91227 L p 1 0 0 r
F P
0 0 0 r
s
.40414 .21291 m .49296 .22197 L .43594 .23497 L 1 0 0 r
F
.34789 .2262 m .40414 .21291 L .43594 .23497 L F
.43344 .90971 m .37731 .91219 L .34395 .90799 L p F P
0 0 0 r
s
.28861 .91052 m .34395 .90799 L .37731 .91219 L p 1 0 0 r
F P
0 0 0 r
s
.90173 .45045 m .83837 .45997 L .83398 .89806 L p .5 1 0 r
F P
0 0 0 r
s
.76729 .9009 m .83398 .89806 L .83837 .45997 L p 0 1 1 r
F P
0 0 0 r
s
.55179 .20855 m .63949 .2177 L .57993 .23083 L 1 0 0 r
F
.49296 .22197 m .55179 .20855 L .57993 .23083 L F
.57974 .9089 m .52107 .9114 L .49136 .90716 L p F P
0 0 0 r
s
.43344 .90971 m .49136 .90716 L .52107 .9114 L p 1 0 0 r
F P
0 0 0 r
s
.16613 .20807 m .25797 .21723 L .20425 .23038 L 1 0 0 r
F
.70094 .20414 m .7875 .21338 L .72536 .22665 L F
.63949 .2177 m .70094 .20414 L .72536 .22665 L F
.72751 .90808 m .66627 .9106 L .64027 .90632 L p F P
0 0 0 r
s
.57974 .9089 m .64027 .90632 L .66627 .9106 L p 1 0 0 r
F P
0 0 0 r
s
.3134 .20366 m .40414 .21291 L .34789 .2262 L 0 1 1 r
F
.25797 .21723 m .3134 .20366 L .34789 .2262 L .5 0 1 r
F
.34395 .90799 m .28861 .91052 L .25252 .90623 L p 1 0 0 r
F P
0 0 0 r
s
.7875 .21338 m .85163 .19969 L .87224 .22243 L .5 0 1 r
F
.46218 .1992 m .55179 .20855 L .49296 .22197 L 1 0 0 r
F
.40414 .21291 m .46218 .1992 L .49296 .22197 L F
.49136 .90716 m .43344 .90971 L .40105 .90538 L p F P
0 0 0 r
s
.34395 .90799 m .40105 .90538 L .43344 .90971 L p 1 0 0 r
F P
0 0 0 r
s
.83398 .89806 m .88188 .43379 L .90173 .45045 L p .5 1 0 r
F P
0 0 0 r
s
.6125 .1947 m .70094 .20414 L .63949 .2177 L 1 0 0 r
F
.55179 .20855 m .6125 .1947 L .63949 .2177 L F
.64027 .90632 m .57974 .9089 L .55113 .90452 L p F P
0 0 0 r
s
.49136 .90716 m .55113 .90452 L .57974 .9089 L p 1 0 0 r
F P
0 0 0 r
s
.22068 .19421 m .3134 .20366 L .25797 .21723 L 0 1 1 r
F
.16613 .20807 m .22068 .19421 L .25797 .21723 L 1 0 0 r
F
.76438 .19015 m .85163 .19969 L .7875 .21338 L F
.70094 .20414 m .76438 .19015 L .7875 .21338 L F
.64027 .90632 m .70275 .90365 L .72751 .90808 L p F P
0 0 0 r
s
.37061 .18965 m .46218 .1992 L .40414 .21291 L 0 1 1 r
F
.3134 .20366 m .37061 .18965 L .40414 .21291 L F
.40105 .90538 m .34395 .90799 L .30878 .90356 L p 1 0 0 r
F P
0 0 0 r
s
.25252 .90623 m .30878 .90356 L .34395 .90799 L p 1 0 0 r
F P
0 0 0 r
s
.52211 .18505 m .6125 .1947 L .55179 .20855 L .5 0 1 r
F
.46218 .1992 m .52211 .18505 L .55179 .20855 L 1 0 0 r
F
.55113 .90452 m .49136 .90716 L .46002 .90268 L p F P
0 0 0 r
s
.40105 .90538 m .46002 .90268 L .49136 .90716 L p 1 0 0 r
F P
0 0 0 r
s
.67519 .1804 m .76438 .19015 L .70094 .20414 L .5 0 1 r
F
.6125 .1947 m .67519 .1804 L .70094 .20414 L 1 0 0 r
F
.70275 .90365 m .64027 .90632 L .61285 .90179 L p F P
0 0 0 r
s
.55113 .90452 m .61285 .90179 L .64027 .90632 L p 1 0 0 r
F P
0 0 0 r
s
.27702 .17989 m .37061 .18965 L .3134 .20366 L 1 0 0 r
F
.22068 .19421 m .27702 .17989 L .3134 .20366 L 0 1 1 r
F
.30878 .90356 m .25252 .90623 L .21445 .9017 L p 1 0 0 r
F P
0 0 0 r
s
.76438 .19015 m .82989 .1757 L .85163 .19969 L 1 0 0 r
F
.4297 .17519 m .52211 .18505 L .46218 .1992 L 0 1 1 r
F
.37061 .18965 m .4297 .17519 L .46218 .1992 L F
.46002 .90268 m .40105 .90538 L .36688 .9008 L p 1 0 0 r
F P
0 0 0 r
s
.30878 .90356 m .36688 .9008 L .40105 .90538 L p 1 0 0 r
F P
0 0 0 r
s
.88188 .43379 m .83398 .89806 L .81072 .89306 L p .5 0 1 r
F P
0 0 0 r
s
.81072 .89306 m .88128 .88995 L .88188 .43379 L p .5 0 1 r
F P
0 0 0 r
s
.58401 .17043 m .67519 .1804 L .6125 .1947 L 0 1 1 r
F
.52211 .18505 m .58401 .17043 L .6125 .1947 L .5 0 1 r
F
.61285 .90179 m .55113 .90452 L .52093 .8999 L p 1 0 0 r
F P
0 0 0 r
s
.46002 .90268 m .52093 .8999 L .55113 .90452 L p 1 0 0 r
F P
0 0 0 r
s
.73997 .16562 m .82989 .1757 L .76438 .19015 L 0 1 1 r
F
.67519 .1804 m .73997 .16562 L .76438 .19015 L .5 0 1 r
F
.76729 .9009 m .70275 .90365 L .67662 .89898 L p 1 0 0 r
F P
0 0 0 r
s
.61285 .90179 m .67662 .89898 L .70275 .90365 L p 1 0 0 r
F P
0 0 0 r
s
.33522 .1651 m .4297 .17519 L .37061 .18965 L 1 0 0 r
F
.27702 .17989 m .33522 .1651 L .37061 .18965 L F
.36688 .9008 m .30878 .90356 L .27165 .89888 L p F P
0 0 0 r
s
.21445 .9017 m .27165 .89888 L .30878 .90356 L p 1 0 0 r
F P
0 0 0 r
s
.49077 .16024 m .58401 .17043 L .52211 .18505 L .5 1 0 r
F
.4297 .17519 m .49077 .16024 L .52211 .18505 L 0 1 1 r
F
.52093 .8999 m .46002 .90268 L .42692 .89795 L p 1 0 0 r
F P
0 0 0 r
s
.36688 .9008 m .42692 .89795 L .46002 .90268 L p 1 0 0 r
F P
0 0 0 r
s
.64799 .15532 m .73997 .16562 L .67519 .1804 L .5 1 0 r
F
.58401 .17043 m .64799 .15532 L .67519 .1804 L 0 1 1 r
F
.67662 .89898 m .61285 .90179 L .58388 .89702 L p 1 0 0 r
F P
0 0 0 r
s
.52093 .8999 m .58388 .89702 L .61285 .90179 L p 1 0 0 r
F P
0 0 0 r
s
.27165 .89888 m .21445 .9017 L .17424 .89692 L p 1 0 0 r
F P
0 0 0 r
s
.39192 .89296 m .33077 .89597 L .30686 .41928 L p 0 1 1 r
F P
0 0 0 r
s
.30686 .41928 m .36567 .40844 L .39192 .89296 L p 0 1 1 r
F P
0 0 0 r
s
.23239 .89394 m .30686 .41928 L .33077 .89597 L p .5 0 1 r
F P
0 0 0 r
s
.36567 .40844 m .30686 .41928 L .26919 .40088 L p 1 0 0 r
F P
0 0 0 r
s
.30686 .41928 m .23239 .89394 L .19081 .8887 L p 0 1 1 r
F P
0 0 0 r
s
.19081 .8887 m .26919 .40088 L .30686 .41928 L p 0 1 1 r
F P
0 0 0 r
s
.73997 .16562 m .80692 .15035 L .82989 .1757 L 0 1 1 r
F
.83398 .89806 m .76729 .9009 L .74254 .89607 L p 1 0 0 r
F P
0 0 0 r
s
.67662 .89898 m .74254 .89607 L .76729 .9009 L p 1 0 0 r
F P
0 0 0 r
s
.39539 .14981 m .49077 .16024 L .4297 .17519 L 1 0 0 r
F
.33522 .1651 m .39539 .14981 L .4297 .17519 L F
.42692 .89795 m .36688 .9008 L .33077 .89597 L p F P
0 0 0 r
s
.27165 .89888 m .33077 .89597 L .36688 .9008 L p 1 0 0 r
F P
0 0 0 r
s
.5539 .14478 m .64799 .15532 L .58401 .17043 L 1 0 0 r
F
.49077 .16024 m .5539 .14478 L .58401 .17043 L .5 1 0 r
F
.58388 .89702 m .52093 .8999 L .48901 .89501 L p 1 0 0 r
F P
0 0 0 r
s
.42692 .89795 m .48901 .89501 L .52093 .8999 L p 1 0 0 r
F P
0 0 0 r
s
.71416 .13969 m .80692 .15035 L .73997 .16562 L 1 0 0 r
F
.64799 .15532 m .71416 .13969 L .73997 .16562 L .5 1 0 r
F
.74254 .89607 m .67662 .89898 L .64898 .89404 L p 1 0 0 r
F P
0 0 0 r
s
.58388 .89702 m .64898 .89404 L .67662 .89898 L p 1 0 0 r
F P
0 0 0 r
s
.33077 .89597 m .27165 .89888 L .23239 .89394 L p .5 0 1 r
F P
0 0 0 r
s
.17424 .89692 m .23239 .89394 L .27165 .89888 L p 1 0 0 r
F P
0 0 0 r
s
.45521 .88984 m .39192 .89296 L .36567 .40844 L p 0 1 1 r
F P
0 0 0 r
s
.36567 .40844 m .42647 .39723 L .45521 .88984 L p 0 1 1 r
F P
0 0 0 r
s
.42647 .39723 m .36567 .40844 L .32905 .38941 L p 1 0 0 r
F P
0 0 0 r
s
.26919 .40088 m .32905 .38941 L .36567 .40844 L p 1 0 0 r
F P
0 0 0 r
s
.74254 .89607 m .81072 .89306 L .83398 .89806 L p 1 0 0 r
F P
0 0 0 r
s
.45762 .13399 m .5539 .14478 L .49077 .16024 L 1 0 0 r
F
.39539 .14981 m .45762 .13399 L .49077 .16024 L F
.48901 .89501 m .42692 .89795 L .39192 .89296 L p F P
0 0 0 r
s
.33077 .89597 m .39192 .89296 L .42692 .89795 L p 1 0 0 r
F P
0 0 0 r
s
.61922 .12879 m .71416 .13969 L .64799 .15532 L 1 0 0 r
F
.5539 .14478 m .61922 .12879 L .64799 .15532 L F
.64898 .89404 m .58388 .89702 L .55323 .89196 L p F P
0 0 0 r
s
.48901 .89501 m .55323 .89196 L .58388 .89702 L p 1 0 0 r
F P
0 0 0 r
s
.23239 .89394 m .17424 .89692 L .1317 .89186 L p 1 0 0 r
F P
0 0 0 r
s
.71416 .13969 m .78262 .12353 L .80692 .15035 L 1 0 0 r
F
.81072 .89306 m .74254 .89607 L .71634 .89096 L p F P
0 0 0 r
s
.64898 .89404 m .71634 .89096 L .74254 .89607 L p 1 0 0 r
F P
0 0 0 r
s
.52076 .88661 m .45521 .88984 L .42647 .39723 L p 0 1 1 r
F P
0 0 0 r
s
.42647 .39723 m .48936 .38564 L .52076 .88661 L p 0 1 1 r
F P
0 0 0 r
s
.48936 .38564 m .42647 .39723 L .39099 .37754 L p 1 0 0 r
F P
0 0 0 r
s
.32905 .38941 m .39099 .37754 L .42647 .39723 L p 1 0 0 r
F P
0 0 0 r
s
.52203 .11762 m .61922 .12879 L .5539 .14478 L 1 0 0 r
F
.45762 .13399 m .52203 .11762 L .5539 .14478 L F
.55323 .89196 m .48901 .89501 L .45521 .88984 L p F P
0 0 0 r
s
.39192 .89296 m .45521 .88984 L .48901 .89501 L p 1 0 0 r
F P
0 0 0 r
s
.68857 .88555 m .61971 .88881 L .58547 .39354 L p 0 1 1 r
F P
0 0 0 r
s
.58547 .39354 m .65146 .38182 L .68857 .88555 L p 0 1 1 r
F P
0 0 0 r
s
.52076 .88661 m .58547 .39354 L .61971 .88881 L p .5 0 1 r
F P
0 0 0 r
s
.65146 .38182 m .58547 .39354 L .55446 .37364 L p 1 0 0 r
F P
0 0 0 r
s
.58547 .39354 m .52076 .88661 L .48936 .38564 L p .5 1 0 r
F P
0 0 0 r
s
.48936 .38564 m .55446 .37364 L .58547 .39354 L p .5 1 0 r
F P
0 0 0 r
s
.68683 .11224 m .78262 .12353 L .71416 .13969 L 1 0 0 r
F
.61922 .12879 m .68683 .11224 L .71416 .13969 L F
.71634 .89096 m .64898 .89404 L .61971 .88881 L p F P
0 0 0 r
s
.55323 .89196 m .61971 .88881 L .64898 .89404 L p 1 0 0 r
F P
0 0 0 r
s
.1317 .89186 m .19081 .8887 L .23239 .89394 L p 1 0 0 r
F P
0 0 0 r
s
.85833 .88447 m .78608 .88777 L .74622 .38982 L p 0 1 1 r
F P
0 0 0 r
s
.74622 .38982 m .81537 .37796 L .85833 .88447 L p 0 1 1 r
F P
0 0 0 r
s
.68857 .88555 m .74622 .38982 L .78608 .88777 L p .5 0 1 r
F P
0 0 0 r
s
.81537 .37796 m .74622 .38982 L .71978 .36969 L p 1 0 0 r
F P
0 0 0 r
s
.74622 .38982 m .68857 .88555 L .65146 .38182 L p .5 1 0 r
F P
0 0 0 r
s
.65146 .38182 m .71978 .36969 L .74622 .38982 L p .5 1 0 r
F P
0 0 0 r
s
.88128 .88995 m .81072 .89306 L .78608 .88777 L p 1 0 0 r
F P
0 0 0 r
s
.71634 .89096 m .78608 .88777 L .81072 .89306 L p 1 0 0 r
F P
0 0 0 r
s
.55446 .37364 m .48936 .38564 L .45512 .36526 L p 1 0 0 r
F P
0 0 0 r
s
.39099 .37754 m .45512 .36526 L .48936 .38564 L p 1 0 0 r
F P
0 0 0 r
s
.58873 .10067 m .68683 .11224 L .61922 .12879 L 1 0 0 r
F
.52203 .11762 m .58873 .10067 L .61922 .12879 L F
.61971 .88881 m .55323 .89196 L .52076 .88661 L p .5 0 1 r
F P
0 0 0 r
s
.45521 .88984 m .52076 .88661 L .55323 .89196 L p 1 0 0 r
F P
0 0 0 r
s
.71978 .36969 m .65146 .38182 L .62187 .36121 L p 1 0 0 r
F P
0 0 0 r
s
.55446 .37364 m .62187 .36121 L .65146 .38182 L p 1 0 0 r
F P
0 0 0 r
s
.68683 .11224 m .75685 .09509 L .78262 .12353 L 1 0 0 r
F
.78608 .88777 m .71634 .89096 L .68857 .88555 L p .5 0 1 r
F P
0 0 0 r
s
.61971 .88881 m .68857 .88555 L .71634 .89096 L p 1 0 0 r
F P
0 0 0 r
s
.71978 .36969 m .79054 .35712 L .81537 .37796 L p 1 0 0 r
F P
0 0 0 r
s
.78608 .88777 m .85833 .88447 L .88128 .88995 L p 1 0 0 r
F P
0 0 0 r
s
.62187 .36121 m .55446 .37364 L .52157 .35253 L p 1 0 0 r
F P
0 0 0 r
s
.45512 .36526 m .52157 .35253 L .55446 .37364 L p 1 0 0 r
F P
0 0 0 r
s
.65783 .08311 m .75685 .09509 L .68683 .11224 L 1 0 0 r
F
.58873 .10067 m .65783 .08311 L .68683 .11224 L F
.79054 .35712 m .71978 .36969 L .69173 .34833 L p F P
0 0 0 r
s
.62187 .36121 m .69173 .34833 L .71978 .36969 L p 1 0 0 r
F P
0 0 0 r
s
.69173 .34833 m .62187 .36121 L .59046 .33933 L p 1 0 0 r
F P
0 0 0 r
s
.52157 .35253 m .59046 .33933 L .62187 .36121 L p 1 0 0 r
F P
0 0 0 r
s
.65783 .08311 m .72949 .0649 L .75685 .09509 L 1 0 0 r
F
.69173 .34833 m .76416 .33498 L .79054 .35712 L p F P
0 0 0 r
s
.76416 .33498 m .69173 .34833 L .66192 .32564 L p 1 0 0 r
F P
0 0 0 r
s
.59046 .33933 m .66192 .32564 L .69173 .34833 L p 1 0 0 r
F P
0 0 0 r
s
.66192 .32564 m .7361 .31143 L .76416 .33498 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00002Qolc<c07ooooo001X
olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?l000000oo<c<`2o`000005olc<c?l0
003oc<c<olc<c?l000000oo<c<`00ol0003oc<c<olc<c02Nolc<c07ooooo001Xolc<c004o`000?o<
c<co0000olc<c0;o00000oo<c<`3o`000004olc<c?l0003oc<c<o`0000;oc<c<00Go0000olc<c?o<
c<coc<c<o`000019olc<c0?o0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<05;oc<c<0Oooool006Soc<c<00?o0000olc<c?o<c<`0
2_o<c<`00ol0003oc<c<o`00000Lolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Lolc<c0Co000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<
olc<c01Aolc<c07ooooo002Eolc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`06?o<
c<`4o`0000Goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c01@olc<c07ooooo002E
olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0000ooc<c<00?o0000
olc<c?o<c<`0Coo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c01>olc<c07ooooo002Folc<c003o`000?o<c<coc<c<00Coc<c<1Ol0000@olc<c0Co
00006Oo<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coc<c<047oc<c<0Oooool009Ooc<c<
00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00?olc<c0?o00000_o<c<`00ol0003oc<c<
olc<c00Iolc<c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0@Oo<c<`1ooooo`00V?o<
c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00[oc<c<1?l0000Rolc<c003o`000?o<
c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`0@Oo<c<`1ooooo`00Too<c<`6o`0000Goc<c<1Ol00004
olc<c0Co000000?oc<c<o`000?o<c<`08oo<c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<co
c<c<047oc<c<0Oooool00:Coc<c<0ol00005olc<c003o`000?o<c<coc<c<02?oc<c<0_l00007olc<
c003o`000?o<c<coc<c<047oc<c<0Oooool007?oc<c<1?l0000Yolc<c0Go0000;?o<c<`00ol0003o
c<c<o`000007olc<c003o`000?o<c<coc<c<047oc<c<0Oooool007;oc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Rolc<c0Co00001?o<c<`00ol0003oc<c<olc<c00]olc<c003o`00
0?o<c<coc<c<00;oc<c<0ol00013olc<c07ooooo001golc<c003o`000?o<c<coc<c<01ooc<c<0ol0
000iolc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<coc<c<1_l0000jolc<c07ooooo
001golc<c003o`000?o<c<coc<c<01_oc<c<1?l00002olc<c003o`000?o<c<coc<c<03Soc<c<00?o
0000olc<c?o<c<`00_o<c<`01Ol0003oc<c<olc<c?o<c<co000003ooc<c<0Oooool007;oc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Golc<c0Co00001_o<c<`00ol0003oc<c<olc<
c00iolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0??o<c<`1ooooo`00L_o<c<`5
o`0001Ooc<c<0ol00002olc<c003o`000?o<c<coc<c<047oc<c<00?o0000olc<c?o<c<`01oo<c<`2
o`0003coc<c<0Oooool007;oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0003ooc<c<0_oo0009olc<
c003o`000?o<c<coc<c<00Soc<c<00?o0000olc<c?o<c<`0>Oo<c<`1ooooo`00Loo<c<`00ol0003o
c<c<olc<c00@olc<c0Co000000?oc<c<o`000?o<c<`0??o<c<`7ool000Soc<c<0_l0000:olc<c003
o`000?o<c<coc<c<03Soc<c<0Oooool007?oc<c<1Ol0000;olc<c0?o0000?_o<c<`=ool000Woc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<03Soc<c<
0Oooool007ooc<c<1?l000000oo<c<co0000olc<c00jolc<c1;oo`002Oo<c<`01Ol0003oc<c<olc<
c?o<c<co000000Coc<c<00?o0000olc<c?l000000ol0000eolc<c07ooooo0019olc<c0Ko00000_o<
c<`00ol0003oc<c<olc<c004o`0002?oc<c<1?l0000molc<c1Ooo`002Oo<c<`01?l0003oc<c<olc<
c?o<c<`4o`000003olc<c?l0003oc<c<00?oc<c<00?o0000olc<c?o<c<`0<_o<c<`1ooooo`00BOo<
c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`07Oo<
c<`3o`000003olc<c?l0003oc<c<03[oc<c<7?oo0009olc<c003o`000?o<c<coc<c<00Goc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00bolc<c07ooooo001:olc<c003o`000?o<c<co
c<c<00_oc<c<00?o0000olc<c?o<c<`06Oo<c<`4o`0000Coc<c<00?o0000olc<c?o<c<`0=?o<c<`R
ool000Woc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003oc<c<olc<c00bolc<c07ooooo001;olc<
c0;o00002oo<c<`00ol0003oc<c<olc<c00Folc<c0?o000000?oc<c<o`000?o<c<`0>?o<c<`Vool0
00Woc<c<00?o0000olc<c?o<c<`01_o<c<`3o`0003Goc<c<0Oooool004goc<c<00?o0000olc<c?o<
c<`00oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01;oc<c<1?l00004olc<c003
o`000?o<c<coc<c<03?oc<c<:ooo0008olc<c0;o00002_o<c<`00ol0003oc<c<olc<c00bolc<c07o
oooo001>olc<c003o`000?o<c<coc<c<00;oc<c<1Ol0000Aolc<c0Go0000>Oo<c<``ool000Woc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<03;oc<c<
0Oooool004Woc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<
c<coc<c<013oc<c<0ol00004olc<c003o`000?o<c<coc<c<03Coc<c<=?oo0009olc<c005o`000?o<
c<coc<c<olc<c?l000001?o<c<`01Ol0003oc<c<olc<c?o<c<co0000033oc<c<0Oooool004Woc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00_oc<c<
1Ol0000iolc<c3Woo`002Oo<c<`01?l0003oc<c<olc<c?o<c<`4o`0000Coc<c<00?o0000olc<c?o<
c<`0;_o<c<`1ooooo`00B_o<c<`4o`0000Koc<c<1Ol00005olc<c0Co00001?o<c<`00ol0003oc<c<
olc<c00colc<c3koo`002Oo<c<`00ol0003oc<c<olc<c004olc<c0Ko0000;oo<c<`1ooooo`00;oo<
c<`4o`0002Soc<c<0ol000000oo<c<co0000olc<c00golc<c4?oo`002Oo<c<`00ol0003oc<c<olc<
c003olc<c005o`000?o<c<coc<c<olc<c?l00000<?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<
c002olc<c003o`000?o<c<coc<c<027oc<c<1?l0000iolc<c4Soo`001oo<c<`3o`0000Goc<c<00Co
0000olc<c?o<c<co0000<?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<
c<coc<c<01goc<c<1?l000000oo<c<co0000olc<c00folc<c4goo`002?o<c<`00ol0003oc<c<olc<
c004olc<c003o`000?o<c<co000001Ooc<c<1?l000001?o<c<co0000olc<c?o<c<`4o`0000;oc<c<
00Oo0000olc<c?o<c<coc<c<o`000?o<c<co000000Coc<c<0Oooool002koc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c00Jolc<c0?o0000>Oo<c<aBool000Soc<c<00?o0000olc<c?o<
c<`00oo<c<`00ol0003oc<c<o`000002olc<c0Co00004?o<c<`00ol0003oc<c<olc<c002olc<c0;o
000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<o`000003olc<c003o`000?o<c<coc<c<00Co
c<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Folc<c0Co0000
00?oc<c<o`000?o<c<`0=_o<c<a0ool000;oOol05?oo0008olc<c003o`000?o<c<coc<c<00?oc<c<
0_l000000oo<c<co0000olc<c003olc<c003o`000?o<c<coc<c<00coc<c<00?o0000olc<c?o<c<`0
1?o<c<`00ol0003oc<c<o`000006olc<c005o`000?o<c<coc<c<olc<c?l000001_o<c<`1ooooo`00
;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01;oc<c<1?l00005olc<c003o`00
0?o<c<coc<c<037oc<c<@?oo0007ogoo01Coo`002?o<c<`00ol0003oc<c<olc<c003olc<c003o`00
0?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`03?o<c<`00ol0003oc<c<olc<c004olc<c003o`00
0?o<c<co000000Go000000?oc<c<o`000?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c07ooooo
000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03oo<c<`3o`0000;oc<c<00?o
0000olc<c?o<c<`0=Oo<c<`Qool000CoOol06ooo000;ogoo01Coo`002?o<c<`00ol0003oc<c<olc<
c009olc<c003o`000?o<c<coc<c<00coc<c<00Co0000olc<c?o<c<coc<c<1?l000000oo<c<co0000
olc<c003olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<
c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00_oc<c<1?l0000iolc<c23oo`002_mo
o`0Fool0013oOol04Ooo0003o`3oo`Soc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<
c002olc<c003o`000?o<c<coc<c<00coc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<
c002olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;oo<
c<`4o`0000[oc<c<1?l00003olc<c003o`000?o<c<coc<c<03;oc<c<8?oo000@ogoo017oo`000ol0
oolBogoo00coo`002?l0ool6olc<c003o`000?o<c<co000000Coc<c<1Ol0000?olc<c003o`000?o<
c<coc<c<00Coc<c<00?o0000olc<c?o<c<`01?l00002olc<c004o`000?o<c<co0000o`0000Ooc<c<
0Oooool003[oc<c<1?l0000folc<c23oo`001?l0oolBogoo00coo`002?l0oolBogoo00Ooo`003Ol0
ool7olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`4o`0000_oc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c07ooooo000folc<c0Co00000oo<c<`0
0ol0003oc<c<olc<c00_olc<c2;oo`002?l0oolBogoo00Ooo`003Ol0oolBogoo00;oo`004_l0ool7
olc<c003o`000?o<c<coc<c<00;oc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<
c<coc<c<00Woc<c<1?l0000Eolc<c07ooooo000bolc<c0Co000000?oc<c<o`000?o<c<`0<oo<c<`Q
ool000go0?oo4_moo`02ool001;o0?oo3omoo`04ogl0oa?o0?oo1oo<c<`01?l0003oc<c<olc<c?o<
c<`5o`0000Coc<c<00?o0000olc<c?o<c<`08_o<c<`1ooooo`00;oo<c<`3o`0003Ooc<c<8Ooo000B
o`3oo`koOol01?mo0?lCo`3oo`WoOol02_mo0?lCo`3oo`Ooc<c<00?o0000olc<c?o<c<`01?o<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<02;oc<c<0Oooool002goc<c<0_l000000oo<
c<co0000olc<c00dolc<c23oo`005ol0ool8ogoo00[oO`3o4ol0ool3ogoo013oO`3o3ol0ool3ool0
00Ooc<c<0ol00004olc<c0;o00000oo<c<`00ol0003oc<c<olc<c00Rolc<c07ooooo000]olc<c004
o`000?o<c<coc<c<o`00037oc<c<1?l0oolKool001go0?oo0_moo`0Aogl0o`oo0?oo0ooo000Cogl0
o`Wo0?oo2Ooo0008olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?l000000_l000000oo<
c<co0000olc<c00Rolc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIRcoc<c<2_l0oolEool0
023o0?oo1?oo000Bogl0o`Wo0?oo2Ooo000Cogl0o`?o0?oo3ooo0008olc<c005o`000?o<c<coc<c<
olc<c?l000001Oo<c<`00ol0003oc<c<olc<c00Qolc<c07ooooo000]olc<c0;o000000?oc<c<ofIV
I_o<c<`09_o<c<`@o`3ooa3oo`008?l0ool9ool001;oO`3o0ol0ool?ool0013oO`3o5Ooo0008olc<
c005o`000?o<c<coc<c<olc<c?l000000oo<c<`00ol0003oc<c<o`00000Rolc<c07ooooo000]olc<
c004o`000?o<c<coc<c<ofIVIR?oc<c<1?oo000Bo`3oo`_oo`008?l0ool=ool000ooO`3o5Ooo000;
ogl0oa[oo`001oo<c<`00ol0003oc<c<olc<c002olc<c0?o00000_o<c<`00ol0003oc<c<olc<c00P
olc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIR3oc<c<2?oo000Bo`3oo`Koo`008?l0oolB
ool000_oO`3o6Ooo0007ogl0oakoo`001oo<c<`00ol0003oc<c<olc<c007olc<c003o`000?o<c<co
c<c<01ooc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV7Oo<c<`=ool0017o0?oo0_oo000O
o`3ooaOoo`001_mo0?lNool000;oO`3o8?oo0003ogl0o`Koc<c<0_l00008olc<c003o`000?o<c<co
c<c<01ooc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV6_o<c<`Aool000ko0?oo1?mo0?lJ
o`3ooagoo`000_mo0?lnool000WoO`3o1oo<c<`00ol0003oc<c<olc<c006olc<c0Go00007?o<c<`1
ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c1?oo`001ol0ool:ogl0oaGo0?ooG?oo000?
ogl0o`Ooc<c<00?o0000olc<c?o<c<`01Oo<c<`2o`0000?oc<c<00?o0000olc<c?o<c<`06Oo<c<`1
ooooo`00;?o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01coc<c<4_oo0002o`3ooa3oO`3o3ol0oomN
ool001;oO`3o1oo<c<`00ol0003oc<c<olc<c006o`0000?oc<c<00?o0000olc<c?o<c<`06Oo<c<`1
ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHOolc<c1;oo`004_mo0?l8o`3oofCoo`004_mo0?l7
olc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00I
olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIR3oc<c<4_oo000Bogl0o`;o0?ooJ_oo000?
ogl0o`;oOol01_o<c<`3o`0000Goc<c<1?l0000Lolc<c07ooooo000/olc<c004o`000?o<c<coc<c<
ofIVIR;oc<c<4_oo000>ogl0ofooo`002Omo0?l8ogoo00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`0
0ol0003oc<c<olc<c002olc<c0?o00006Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHT
olc<c1;oo`001omo0?meool000?oO`3o3_moo`07olc<c005o`000?o<c<coc<c<olc<c?l000000oo<
c<`2o`0000;oc<c<00?o0000olc<c?o<c<`05_o<c<`1ooooo`00;?o<c<`2o`000003olc<c?mVIVKo
c<c<02Goc<c<4Ooo0002ogl0ogOoo`000ol0oolAogoo00Ooc<c<00Co0000olc<c?o<c<co00001?o<
c<`01Ol0003oc<c<olc<c?o<c<co000001Ooc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV
6?o<c<`00omVIVKoc<c<olc<c00=olc<c8?oo`002Ol0oolAogoo00Ooc<c<00?o0000olc<c?o<c<`0
1ol000000oo<c<co0000olc<c00Folc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIQSoc<c<
00?oIVIVolc<c?o<c<`03_o<c<amool000oo0?oo3_moo`03ool000Koc<c<0_l00004olc<c004o`00
0?o<c<coc<c<olc<c0;o00005oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003
ofIVI_o<c<coc<c<013oc<c<M_oo0004ogl0oa7o0?oo2?moo`09ool000Ooc<c<00Go0000olc<c?o<
c<coc<c<o`000004olc<c004o`000?o<c<coc<c<o`0000Coc<c<1?l0000<olc<c07ooooo000/olc<
c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<a_ool000[oO`3o4Ol0ool2
ogoo00ooo`001oo<c<`01?l0003oc<c<olc<c?l00004olc<c004o`000?o<c<coc<c<o`0000?oc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c009olc<c07ooooo000/olc<c004o`000?o<
c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04oo<c<aYool0013oO`3o3_l0ool2ogoo01;oo`00
1_o<c<`01?l0003oc<c<olc<c?l00004olc<c004o`000?o<c<coc<c<o`0000?oc<c<00?o0000olc<
c?o<c<`00_o<c<`00ol0003oc<c<olc<c009olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIV
IQSoc<c<00?oIVIVolc<c?o<c<`05Oo<c<aWool0017oO`3o2?l0ool8ogoo01;oo`001_o<c<`00ol0
003oc<c<olc<c004o`0000?oc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<co
c<c<00Woc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00G
olc<c6Koo`004Omo0?l2o`3oo`koOol04Ooo0006olc<c0;o00002?o<c<`01Ol0003oc<c<olc<c?o<
c<co000000Coc<c<00?o0000olc<c?l000002Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mV
IVHHolc<c003ofIVI_o<c<coc<c<01Soc<c<I_oo000Bogl0o`ooOol04Ooo0007olc<c003o`000?o<
c<coc<c<00Goc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<co000000Woc<c<
0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Jolc<c6Goo`00
4_mo0?l?ogoo017oo`001oo<c<`00ol0003oc<c<olc<c002olc<c0?o00000oo<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<co000000Woc<c<0Oooool002coc<c<0_l000000oo<c<coIVIVolc<
c00Golc<c003ofIVI_o<c<coc<c<01coc<c<I?oo000Bogl0o`_oOol01Ol0ool@ool000Ooc<c<00?o
0000olc<c?o<c<`00oo<c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?l00000
2Oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01ooc<c<
I?oo000Aogl0o`?oOol03Ol0ool@ool000Koc<c<0_l00004olc<c004o`000?o<c<coc<c<olc<c0Go
00000_o<c<`00ol0003oc<c<olc<c007olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQSo
c<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00<olc<c6?oo`003_mo0?l2ool0017o
0?oo3?oo0004o`3oo`Ooc<c<00?o0000olc<c?o<c<`01Oo<c<`00ol0003oc<c<olc<c004olc<c003
o`000?o<c<coc<c<00Ooc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKo
c<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00koc<c<H_oo0008ogl0o`Soo`004Ol0ool4ool000co
0?oo0oo<c<`00omVIVKoc<c<olc<c006olc<c0?o00001?o<c<`3o`0000Woc<c<0Oooool002_oc<c<
00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<00oo
c<c<H_oo0002ogl0o`koo`003_l0ool2ogl0oa7o0?oo0_o<c<`00omVIVKoc<c<olc<c008olc<c003
o`000?o<c<coc<c<00Coc<c<00?o0000olc<c?o<c<`01oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<
olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`04Oo<c<aaool000So
0?oo2?mo0?lAo`3oo`03olc<c?mVIVKoc<c<00Woc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003o
c<c<olc<c007olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<
c<`04_o<c<`00omVIVKoc<c<olc<c00Bolc<c77oo`000_l0ool>ogl0o`ko0?oo0oo<c<`00omVIVKo
c<c<olc<c00Iolc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<
c<`04_o<c<`00omVIVKoc<c<olc<c00Colc<c5_oo`001Ol0000Bool000ooO`3o2?l0ool8olc<c003
ofIVI_o<c<coc<c<01Woc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKo
c<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<01Goc<c<Dooo0006o`0000Goo`0000?o0000ool00?oo
00004?oo000?ogl0o`;o0?oo3Oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`00
0?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Golc<c4co
o`001Ol0000<ool00003o`000?oo003oo`00013oo`002omo0?lBolc<c003ofIVI_o<c<coc<c<01Wo
c<c<0Oooool002_oc<c<0_mVIVH00ol0003oIVIVolc<c00Golc<c003ofIVI_o<c<coc<c<01;oc<c<
00?oIVIVolc<c?o<c<`06?o<c<a6ool000Go00004_oo00000ol0003oo`00ool0000@ool000?oO`3o
6Oo<c<`00omVIVKoc<c<olc<c00Iolc<c07ooooo000Polc<c0Co00001oo<c<`01?l0003oc<c<ofIV
I_mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`06_o<c<a0ool000Co0000
1?oo00000ol0003oo`00ool0000Aool00003o`000?oo003oo`0000coo`007oo<c<`00omVIVKoc<c<
olc<c00Iolc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<
c<`00ol0003oc<c<olc<c003ofIVIQKoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<
c00@olc<c003ofIVI_o<c<coc<c<00Woc<c<>Ooo0005o`0000Woo`0000?o0000ool00?oo00004Ooo
00000ol0003oo`00ool00004ool000Coc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<
c00Iolc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`0
1?l0003oc<c<olc<c?mVIVH2olc<c0;oIVIV5?o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<
c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`02oo<c<`cool000Co00003ooo00000ol0003oo`00ool0
000Aool000;o00002?o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Ooo
ool001ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<co
c<c<ofIVIPCoc<c<0omVIVHAolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`04?o<
c<`00omVIVKoc<c<olc<c00<olc<c2goo`001Ol0000Dool00003o`000?oo003oo`0000Ooo`001_l0
0005ool00003o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<
c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`0
1?l0003oc<c<olc<c?mVIVH7olc<c0;oIVIV3oo<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<
c<coc<c<013oc<c<00?oIVIVolc<c?o<c<`03_o<c<`Vool000Go00001Ooo00000ol0003oo`00ool0
000Bool00004o`000?oo003oo`00ool000Go00003?oo00000ol0003oc<c<olc<c004olc<c003ofIV
I_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003oc<c<olc<
c002olc<c003o`000?o<c<coc<c<00?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP09olc<c0;oIVIV
3Oo<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`0
4?o<c<`Oool000Go00002ooo0002o`0001?oo`000ol0000Bool00003o`000?o<c<coc<c<00?oc<c<
00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<
c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?mVIVH<olc<c0;oIVIV
2oo<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`0
4_o<c<`Gool000Ko00004_oo00000ol0003oo`00ool00007ool000Ko00001Ooo00000ol0003oo`00
ool0000Aool00003o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<
olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<
c<`01?l0003oc<c<olc<c?mVIVH>olc<c0;oIVIV2Oo<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIV
I_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`05?o<c<`@ool000Go00001Ooo00000ol0003oo`00
ool0000Aool00004o`000?oo003oo`00ool000Go00003?oo0002o`0001;oo`000_l00002olc<c003
ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`008?o<c<`4o`0000Koc<c<
00Co0000olc<c?o<c<coIVIV4?o<c<`2ofIVIPKoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKo
c<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01Koc<c<2Ooo0005o`0000_oo`000_l0000Bool000?o
00004ooo00000ol0003oo`00ool00007ool000Go00001Ooo00000ol0003oc<c<ofIVIP0Rolc<c003
ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<0_l000000oo<c<coIVIVolc<c00Aolc<c0;oIVIV
1?o<c<`00omVIVKoc<c<olc<c00Bolc<c003ofIVI_o<c<coc<c<017oc<c<00?oIVIVolc<c?o<c<`0
6?o<c<`2ool000Go00004_oo00000ol0003oo`00ool00007ool000Go00001Ooo00000ol0003oo`00
ool0000Bool00004o`000?oo003oo`00ool000Go00002ooo00000ol0003oIVIVolc<c00Qolc<c003
ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV5?o<c<`2ofIVIP;o
c<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<01Go
c<c<1Ol00004ool00003o`000?oo003oo`00017oo`0000Co0000ool00?oo003oo`001Ol0000;ool0
00;o00004ooo0003o`00017oo`0000?o0000olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQKoc<c<0omVIVHDolc<c003ofIVI_o<c<coc<c<
017oc<c<00?oIVIVolc<c?o<c<`03Oo<c<`00omVIVKoc<c<olc<c005o`0000[oo`000_l0000Bool0
00?o00004_oo00000ol0003oo`00ool00007ool000Ko00001Omoo`000ol0003oo`00ool0000@ool0
0003o`000?o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003o
c<c<olc<c?mVIVHHolc<c0?oIVIV4_o<c<`00omVIVKoc<c<olc<c00Aolc<c003ofIVI_o<c<coc<c<
00_oc<c<1Ol0000Aool000;o00002Ooo0005o`0000CoOol000?o0000ool00?oo00004Ooo00001?l0
003oo`00ool00?oo0005o`0000coOol000?o0000ool00?oo00004?oo00000ol0003oc<c<olc<c00N
olc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`0
0omVIVKoc<c<olc<c002ofIVIQ3oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00omVIVKoc<c<olc<c006
olc<c0Go00001?oo0002o`0001;oo`0000Co0000ool00?oo003oo`001Ol0000:ogoo00;o00004_oo
0003o`0001;oOol000?o0000ool00?oo00001ooo0005o`0000?o0?oo00?o0000olc<c?o<c<`07_o<
c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?o
IVIVolc<c?o<c<`00_o<c<`2ofIVIPkoc<c<00?oIVIVolc<c?o<c<`04Oo<c<`01?mVIVKoc<c<olc<
c?o<c<`5o`0000_oo`000_l0000Aool000?o00004Omoo`02o`0000Woo`001Ol00002o`3oo`03o`00
0?moo`3oOol001?oOol000Co0000ool00?oo003oo`001Ol00008o`3oo`03o`000?o<c<coc<c<01ko
c<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003
ofIVI_o<c<coc<c<00Coc<c<0_mVIVH<olc<c003ofIVI_o<c<coc<c<00ooc<c<1_l0000Bool000;o
00001?oo0007o`0000Co0?oo00?o0000ogoo0?moo`004omoo`001?l0003oo`00ool00?oo0005o`00
00Oo0?oo00?o0000ogoo0?moo`005?moo`03o`0000go0?oo00?o0000olc<c?o<c<`07_o<c<`00omV
IVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<
c?o<c<`01_o<c<`2ofIVIP[oc<c<00?oIVIVolc<c?o<c<`02?o<c<`7o`0000Goo`000_l0000Cool0
00Co00002ol0ool00ol0003oOol0ogoo000Dogoo00?o00003?l0ool00ol0003oOol0ogoo000Dogoo
0003o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`02?o<c<`2ofIV
IPSoc<c<00?oIVIVolc<c?o<c<`01?o<c<`4o`0000koo`000ol00009ool000Go00004Ol0ool00ol0
003oOol0ogoo000Dogoo0003o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`000ol0
003o0?ooo`3oo`0=o`3oo`03o`000?o<c<coc<c<01koc<c<00?oIVIVolc<c?o<c<`06?o<c<`1oooo
o`00:_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<00[oc<c<0_mVIVH6olc<
c003ofIVI_o<c<coc<c<00Coc<c<00Co0000o`3oool0003o00004Ooo0002o`0000;oo`001Ol0000F
o`3oo`03o`000?moo`3oOol001CoOol000?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000D
ogoo0003o`000?l0oooo0?oo00go0?oo00?o0000olc<c?o<c<`07_o<c<`00omVIVKoc<c<olc<c00H
olc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`03?o<c<`2
ofIVIPCoc<c<00?oIVIVolc<c?o<c<`01?o<c<`01?l0003o0?ooo`3oool0ool2o`00017oo`000_l0
000Ko`3oo`03o`000?moo`3oOol001CoOol000?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000Dogoo0003o`000?l0oooo0?oo00ko0?oo00?o0000olc<c?o<c<`07Oo<c<`00omVIVKoc<c<olc<
c00Holc<c07ooooo000Zolc<c0;o000000?oc<c<ofIVI_o<c<`05oo<c<`00omVIVKoc<c<olc<c00>
olc<c0?oIVIV00?oc<c<ofIVI_o<c<`01Oo<c<`00ol0003o0?ooo`3oo`03o`3oo`03o`000?oo003o
o`0000Ooo`001Ol0000@o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`005?moo`00
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001?oOol00_l0000@o`3oo`03o`000?o<c<co
c<c<01goc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:Oo<c<`01Ol0003oc<c<olc<c?o<c<co
IVIV01Soc<c<00?oIVIVolc<c?o<c<`04Oo<c<`2ofIVIPGoc<c<00?o0000o`3oool0ool01Ol0ool2
o`0000;oo`001Ol0000Eo`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004omoo`02
o`0000oo0?oo00?o0000ogoo0?moo`004_moo`02o`00013o0?oo00?o0000olc<c?o<c<`07_o<c<`0
0omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIV
olc<c?o<c<`04_o<c<`3ofIVIP?oc<c<00?o0000o`3oool0ool01ol0ool2o`0001[o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000Cogoo00;o00003ol0ool00ol0003oOol0ogoo000B
ogoo00;o00004?l0ool00ol0003oc<c<olc<c00Nolc<c0CoIVIV5_o<c<`1ooooo`00:Oo<c<`01?l0
003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00_mVIVH0
0oo<c<co0000o`3oo`08o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001;oOol00_l0000?o`3oo`03o`000?moo`3o
Ool001;oOol000?o0000ogl0ool000003ol0ool00ol0003oc<c<olc<c00Golc<c0SoIVIV6Oo<c<`1
ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIV
olc<c?o<c<`00_o<c<`00omVIVKo0000o`3oo`08o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol001;oOol000?o0000
ogl0ool000003_l0ool00ol0003oOol0ogoo000Bogoo0003o`000?mo0?oo000000oo0?oo00?o0000
olc<c?o<c<`04Oo<c<`6ofIVIPOoc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0
003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00oo<c<`0
0ol0003o0?ooo`3oo`07o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001;oOol000?o0000ogl0ool000003_l0ool0
0ol0003oOol0ogoo000Bogoo0003o`000?mo0?oo000000oo0?oo00?o0000olc<c?o<c<`02_o<c<`2
ofIVIP;o00000omVIVH=olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<
c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000
o`3oool0ool01_l0ool2o`0000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol001;oOol000?o0000ogl0ool000003_l0ool00ol0003oOol0ogoo000B
ogoo0003o`000?mo0?oo000000oo0?oo00?o0000olc<c?o<c<`01?o<c<`6ofIVIP;oc<c<00?o0000
ogoo0?l000003oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<
ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo
0?oo00Oo0?oo0_l0000=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000Bogoo0003o`000?mo0?oo000000ko0?oo00?o0000ogoo0?moo`004_moo`00
0ol0003oO`3oo`00000?o`3oo`03o`000?mVIVKoIVIV00CoIVIV2?o<c<`01?l0003oOol0ogoo0?l0
000>olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV6?o<
c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0ool01ol0
ool2o`0000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol0017oOol000Co0000ogl0oomo0?oo00003_l0ool00ol0003oOol0ogoo000Bogoo0003o`00
0?mo0?oo000000oo0?oo00?o0000olc<c?o<c<`03?o<c<`01Ol0003oOol0ogoo0?moo`3o000000go
c<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003
ofIVI_o<c<coc<c<01?oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`07o`3oo`;o
00003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`004Omoo`001?l0003oO`3oogl0ool0000>o`3oo`03o`000?moo`3oOol0017oOol000Co0000ogl0
oomo0?oo00003ol0ool00ol0003oc<c<olc<c00<olc<c003o`000?moo`3oOol000;oOol000?o0000
olc<c?o<c<`02_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<
ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo
0?oo00Oo0?oo0_l0000>o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003oOol0ogoo000Aogoo0004o`000?mo0?ooO`3oo`0000ko0?oo00?o0000ogoo0?moo`004Omo
o`001?l0003oO`3oogl0ool0000?o`3oo`03o`000?o<c<coc<c<00Koc<c<1Ol000000omo0?oo0000
ogoo0003ogoo0003ool00?l0003oc<c<00[oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<
c<`2o`000003olc<c?mVIVKoc<c<01Ooc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<
c003olc<c003o`000?l0oooo0?oo00Oo0?oo0_l0000>o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000Aogoo0004o`000?mo0?ooO`3oo`0000ko0?oo
00?o0000ogoo0?moo`004Omoo`001?l0003oO`3oogl0ool0000@o`3oo`03o`000?o<c<co000000Go
00001Omoo`000omo0?oo0000ogoo0003ogoo00;oo`0000?o0000olc<c?o<c<`02?o<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<
c<`04_o<c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0ool0
00003_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?mo
o`004Omoo`001?l0003oO`3oogl0ool0000>o`3oo`03o`000?moo`3oOol0017oOol000Co0000ogl0
oomo0?oo00004?l0ool2o`0000;o0?oo00?o0000ogoo0?moo`001_moo`000omo0?oo0000ogoo0003
ogoo00?oo`0000?o0000olc<c?o<c<`01oo<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<
c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c002
olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0ool000003_l0ool00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`004Omoo`001?l0003oO`3oogl0ool0
000>o`3oo`03o`000?moo`3oOol0017oOol000Co0000ogl0oomo0?oo00004?l0ool01Ol0003o0?oo
o`3oool0oooo000000SoOol000?oO`3oo`000?moo`000omoo`04ool000;o00001oo<c<`00omVIVKo
c<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<
c<`04_o<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo00Oo0?oo00Co0000ogl0oomo
0?oo00003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`004Omoo`001?l0003oO`3oogl0ool0000?o`3oo`03o`000?moo`3oOol0013oOol000Co0000
ogl0oomo0?oo00004?l0ool01Ol0003o0?ooo`3oool0oooo000000SoOol000?oO`3oo`000?moo`00
0_moo`000ol0003oo`00ool00004ool00003o`000?o<c<coc<c<00Coc<c<00?oIVIVolc<c?o<c<`0
5oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<
00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`07o`3oo`04o`000?mo0?ooO`3oo`0000go
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0013o
Ool000Go0000ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?moo`3oOol0013oOol000Co0000ogl0
oomo0?oo00004?l0ool01Ol0003o0?ooo`3oool0oooo000000SoOol000?oO`3oo`000?moo`000_mo
o`08ool00003o`000?o<c<coc<c<00?oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`0
1?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00_o<
c<`00ol0003o0?ooo`3oo`07o`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0013oOol000Go0000ogl0oomo0?oo
O`3oo`00000?o`3oo`03o`000?moo`3oOol0013oOol000Go0000ogl0oomo0?ooO`3oo`00000?o`3o
o`05o`000?l0oooo0?ooo`3oool000002?moo`000omo0?oo0000ogoo0002ogoo00Woo`0000?o0000
olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Xolc<c004o`000?o<c<coc<c<
ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo
0?oo00Oo0?oo00Co0000ogl0oomo0?oo00003Ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`004?moo`001Ol0003oO`3oogl0oomo0?oo000000oo0?oo
00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo
00Go0000o`3oool0oooo0?ooo`000007ogoo00;oO`3o00Co0000ogoo0?moo`3oOol01_l00003o`3o
o`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:?o<c<`01?l0003o
c<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0
003o0?ooo`3oo`07o`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0013oOol000Go0000ogl0oomo0?ooO`3oo`00
000?o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`05o`000?l0oooo0?ooo`3oool000001omoo`02ogl0o`04o`000?moo`3oOol0ogoo00Wo
0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Golc<c07ooooo000Xolc<c004o`00
0?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04_o<c<`01OmVIVKoc<c<olc<c?o<c<co0000
00Wo0?oo00Go0000ogl0oomo0?ooO`3oo`00000=o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000
o`3oool0ool03Ol0ool01Ol0003o0?ooo`3oool0oooo000000OoOol00_mo0?l01?l0003oOol0ogoo
0?moo`09o`3oo`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:?o<
c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00GoIVIVolc<c?o<c<co
c<c<o`000009o`3oo`05o`000?mo0?ooO`3oogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`02ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`02ogl0
o`03o`000?l0oooo0?oo00go0?oo00Go0000o`3oool0oooo0?ooo`000007ogoo00;oO`3o00Co0000
ogoo0?moo`3oOol02Ol0ool00ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<01Koc<c<0Ooo
ool002Soc<c<0ol000000omVIVKoc<c<olc<c00Golc<c003ofIVI_o<c<coc<c<01;oc<c<00GoIVIV
olc<c?o<c<coc<c<o`000009o`3oo`05o`000?mo0?ooO`3oogl0ool000003Ol0ool00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3o
ogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3o
ogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo00Go0000o`3oool0oooo0?ooo`000007ogoo00;o
O`3o00?o0000ogoo0?moo`002_l0ool00ol0003oc<c<olc<c003olc<c003ofIVI_o<c<coc<c<01Ko
c<c<0Oooool001coc<c<1_l00006olc<c0;oIVIV00?oc<c<ofIVI_o<c<`06?o<c<`00omVIVKoc<c<
olc<c00Bolc<c005ofIVI_o<c<coc<c<olc<c?l000002Ol0ool01Ol0003oO`3oogl0oomo0?oo0000
00go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
00ooOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
00ooOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`05o`000?l0oooo0?oo
o`3oool000001omoo`02ogl0o`03o`000?moo`3oOol000_o0?oo00?o0000olc<c?o<c<`00_o<c<`0
0omVIVKoc<c<olc<c00Folc<c07ooooo000Lolc<c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<
c?mVIVH00_mVIVHHolc<c003ofIVI_o<c<coc<c<01;oc<c<00GoIVIVolc<c?o<c<coc<c<o`000009
o`3oo`05o`000?mo0?ooO`3oogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`003omoo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0
oooo0?oo00ko0?oo00Co0000o`3oool0oooo00001_moo`03ogl0o`03o`000?moo`3oOol000_o0?oo
00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Molc<c003o`000?o<
c<coc<c<00Soc<c<00Go0000olc<c?o<c<coIVIVolc<c003ofIVIQCoc<c<00?oIVIVolc<c?o<c<`0
4oo<c<`01OmVIVKoc<c<olc<c?o<c<co000000Wo0?oo00Go0000ogl0oomo0?ooO`3oo`00000=o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000>ogoo
0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo
0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03_l0ool01?l0003o0?ooo`3oool00006
ogoo00?oO`3o00?o0000ogoo0?moo`002ol0ool00ol0003oc<c<olc<c002olc<c003ofIVI_o<c<co
c<c<01Koc<c<0Oooool001koc<c<0_l00008olc<c004o`000?o<c<coc<c<ofIVIPCoc<c<0omVIVHA
olc<c003ofIVI_o<c<coc<c<01?oc<c<00CoIVIVolc<c?o<c<co00002Ol0ool00ol0003oO`3oogl0
o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3o
o`0>o`3oo`04o`000?l0oooo0?ooo`0000KoOol00omo0?l00ol0003oOol0ogoo000;o`3oo`03o`00
0?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`008?o<c<`00ol0003oc<c<olc<
c005olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<0omVIVH>olc<c003ofIVI_o<c<coc<c<01?oc<c<
00CoIVIVolc<c?o<c<co00002Ol0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ko
Ool000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ko
Ool000?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0>o`3oo`04o`000?l0oooo0?ooo`00
00KoOol00omo0?l00ol0003oOol0ogoo000;o`3oo`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<
c?o<c<`05_o<c<`1ooooo`008Oo<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIV
IP[oc<c<0omVIVH;olc<c003ofIVI_o<c<coc<c<01?oc<c<00CoIVIVolc<c?o<c<co00002Ol0ool0
0ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00omo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l00omo0?l0
0ol0003o0?ooo`3oo`0>o`3oo`04o`000?l0oooo0?ooo`0000KoOol00omo0?l00ol0003oOol0ogoo
000;o`3oo`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`05_o<c<`1ooooo`007?o<c<`0
0ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV3Oo<
c<`3ofIVIPSoc<c<00?oIVIVolc<c?o<c<`04oo<c<`01?mVIVKoc<c<olc<c?l00009o`3oo`03o`00
0?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`03ogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`03ogl0o`03o`00
0?l0oooo0?oo00ko0?oo00Co0000o`3oool0oooo00001_moo`03ogl0o`03o`000?moo`3o0?oo00_o
0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo000Lolc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH@olc<c0;o
IVIV1_o<c<`00omVIVKoc<c<olc<c00Colc<c004ofIVI_o<c<coc<c<o`0000Wo0?oo00?o0000ogl0
oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo000>ogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3o
ool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3o
ool0ool03Ol0ool01?l0003o0?ooo`3oool00005ogoo00CoO`3o00?o0000ogoo0?l0ool02ol0ool0
0ol0003oc<c<olc<c002olc<c003ofIVI_o<c<coc<c<01Koc<c<0Oooool000?oc<c<00?o0000olc<
c?o<c<`00oo<c<`00ol0003oc<c<olc<c002o`0000;oc<c<00?o0000olc<c?o<c<`02_o<c<`4o`00
00Ooc<c<00Co0000olc<c?o<c<coIVIV4_o<c<`3ofIVIP?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`0
1?mVIVKoc<c<olc<c?l00009o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003Omo
o`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003Omo
o`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo00Co0000o`3oool0oooo0000
1Omoo`04ogl0o`03o`000?moo`3o0?oo00_o0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<
olc<c00Folc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co0000
6oo<c<`01?l0003oc<c<olc<c?mVIVHEolc<c0CoIVIV5Oo<c<`01?mVIVKoc<c<olc<c?l00008o`3o
o`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`04ogl0
o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`04ogl0
o`03o`000?l0oooo0?oo00go0?oo00Co0000o`3oool0oooo00001Omoo`04ogl0o`03o`000?moo`3o
0?oo00_o0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<olc<c00Folc<c07ooooo0003olc<
c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<co00006_o<c<`01Ol0003oc<c<olc<c?o<
c<coIVIV01Soc<c<0omVIVHColc<c003ofIVI_o<c<co000000Wo0?oo00?o0000ogl0oomo0?l00omo
0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0
ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0
ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0
ool01?l0003o0?ooo`3oool00005ogoo00CoO`3o00?o0000ogoo0?l0ool03?l0ool01Ol0003oc<c<
olc<c?o<c<coIVIV01Soc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<
olc<c?l0000Jolc<c0;o000000?oc<c<ofIVI_o<c<`06?o<c<`00omVIVKoc<c<olc<c003ofIVIQ3o
c<c<00?oIVIVolc<c?l000002Ol0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000go
Ool000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000go
Ool000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?l0oooo0?ooo`00
00GoOol01?mo0?l00ol0003oOol0o`3oo`0<o`3oo`05o`000?o<c<coc<c<olc<c?mVIVH06?o<c<`1
ooooo`000oo<c<`7o`0000;oc<c<00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<c?mVIVHI
olc<c003ofIVI_o<c<coc<c<00?oc<c<0omVIVH=olc<c003ofIVI_o<c<co000000Wo0?oo00?o0000
ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000
o`3oool0ool03Ol0ool01?l0003o0?ooo`3oool00005ogoo00CoO`3o00?o0000o`3oool0ool03?l0
ool01Ol0003oc<c<olc<c?o<c<coIVIV01Soc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`00oo<
c<`01?l0003oc<c<olc<c?l0000Jolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<
c<`01_o<c<`2ofIVIP[oc<c<00CoIVIVolc<c?o<c<co00002Ol0ool00ol0003oO`3oogl0o`03ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0>o`3o
o`03o`000?l0oooo000000GoOol01?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`05o`000?o<c<coc<c<
olc<c?mVIVH06?o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<co0000
00;o00006Oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<00Soc<c<0omVIVH7
olc<c004ofIVI_o<c<coc<c<o`0000Wo0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000=ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000<ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03_l0ool00ol0003o0?ooo`00
0004ogoo00GoO`3o0_l0000=o`3oo`05o`000?o<c<coc<c<olc<c?mVIVH06?o<c<`1ooooo`000oo<
c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<01Soc<c<00Co0000olc<c?o<c<coIVIV
6Oo<c<`00omVIVKoc<c<olc<c00;olc<c0?oIVIV1?o<c<`01?mVIVKoc<c<olc<c?l00008o`3oo`03
o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0;o`3oo`03
o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003?moo`000ol0003oO`3oogl0o`05ogl0o`03
o`000?l0oooo0?oo00ko0?oo00?o0000o`3oool000001?moo`05ogl0o`;o00003Ol0ool01Ol0003o
c<c<olc<c?o<c<coIVIV01Soc<c<0Oooool000?oc<c<1ol00002olc<c003o`000?o<c<coc<c<01So
c<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00>olc<c0?oIVIV00Coc<c<ofIV
I_o<c<co00002Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000
ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000
ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?l0oooo000000CoOol01Omo0?l2
o`0000go0?oo00Go0000olc<c?o<c<coc<c<ofIVIP0Holc<c07ooooo000Wolc<c004o`000?o<c<co
c<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04Oo<c<`3ofIVIP03o`000?l0oooo0?oo00Oo0?oo00?o
0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00KoO`3o00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o
0000o`3oool0ool03_l0ool00ol0003o0?ooo`000004ogoo00GoO`3o0_l0000=o`3oo`04o`000?o<
c<coc<c<olc<c0GoIVIV5?o<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIV
I_o<c<coc<c<01;oc<c<00?oIVIVolc<c?l000002Ol0ool00ol0003oO`3oogl0o`05ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000_oOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?moo`3oOol000_oOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`00
0?l0oooo000000CoOol01Omo0?l2o`0000go0?oo00Ko0000ofIVI_mVIVKoIVIVolc<c?mVIVHGolc<
c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omV
IVKoc<c<o`000009o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0
003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002omoo`000ol0
003oO`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000o`3oool000001?moo`05ogl0
o`;o00003Ol0ool00ol0003oc<c<olc<c002olc<c003ofIVI_o<c<coc<c<01Goc<c<0Oooool002Oo
c<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_o<c<co0000
00Wo0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o
00KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o
00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`000003ogoo00KoO`3o0_l0000=o`3o
o`03o`000?o<c<coc<c<00;oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`009oo<c<`01?l0003o
c<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01?oc<c<00?oIVIVolc<c?l000002?l0ool00ol0
003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01_mo0?l00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000[oOol000?o0000ogl0oomo0?l01omo0?l00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo000000?oOol01_mo0?l2o`0000ko0?oo00Go0000olc<
c?o<c<coc<c<ofIVIP0Golc<c07ooooo000Wolc<c0;o000000?oc<c<ofIVI_o<c<`05oo<c<`00omV
IVKoc<c<olc<c00Colc<c003ofIVI_l0003o0?oo00So0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0
003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003o0?ooo`000003ogoo00KoO`3o0_l0000>o`3oo`05o`000?o<c<coc<c<olc<c?mVIVH05oo<c<`1
ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01?oc<c<00?oIVIV
o`000?l0ool02?l0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000[oOol000?o0000
ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000[oOol000?o0000
ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo000000?oOol01_mo0?l2
o`0000ko0?oo00Go0000olc<c?o<c<coc<c<ofIVIP0Golc<c07ooooo000Wolc<c004o`000?o<c<co
c<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omVIVKo0000o`3oo`08o`3oo`03o`000?mo
0?ooO`3o00KoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0
oooo0?oo00go0?oo00?o0000o`3oool000000omoo`06ogl0o`;o00003_l0ool01Ol0003oc<c<olc<
c?o<c<coIVIV01Ooc<c<0Oooool002Ooc<c<00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<
olc<c00Colc<c003ofIVI_l0003o0?oo00So0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo000:ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo000:ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03_l0ool2o`0000?oOol0
1_mo0?l00ol0003oO`3oo`00000=o`3oo`05o`000?o<c<coc<c<olc<c?mVIVH05oo<c<`1ooooo`00
9_o<c<`01Ol0003oc<c<olc<c?o<c<coIVIV01Soc<c<00?oIVIVolc<c?o<c<`04oo<c<`00omVIVKo
0000o`3oo`08o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003o
O`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003o
O`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00ko0?oo0_l00003ogoo00KoO`3o00?o0000ogl0ool0
00003Ol0ool01Ol0003oc<c<olc<c?o<c<coIVIV01Ooc<c<0Oooool002Koc<c<00Co0000olc<c?o<
c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00Colc<c003ofIVI_l0003o0?oo00So0?oo00?o0000ogl0
oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3o
ool0ool03_l0ool2o`0000;oOol01omo0?l00ol0003oO`3oo`00000=o`3oo`05o`000?o<c<coc<c<
olc<c?mVIVH05oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<co
c<c<01?oc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000[oOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000WoOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o00000_moo`07
ogl0o`03o`000?mo0?oo000000go0?oo00Go0000olc<c?o<c<coc<c<ofIVIP0Golc<c07ooooo000V
olc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04oo<c<`00ol0003o0?ooo`3o
o`07o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0
o`08ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0
o`08ogl0o`03o`000?l0oooo0?oo00ko0?oo0_l00002ogoo00OoO`3o00?o0000ogl0ool000003Ol0
ool01Ol0003oc<c<olc<c?o<c<coIVIV01Ooc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV
6Oo<c<`00omVIVKoc<c<olc<c00Colc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l0
1omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000o`3oool0ool0
3_l0ool2o`0000;oOol01omo0?l00ol0003oO`3oo`00000=o`3oo`05o`000?o<c<coc<c<olc<c?mV
IVH05oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01?o
c<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000Wo
Ool000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000So
Ool000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o00000_moo`07ogl0o`03
o`000?mo0?oo000000ko0?oo00Co0000olc<c?o<c<coIVIV5oo<c<`1ooooo`009_o<c<`01?l0003o
c<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01?oc<c<00?o0000o`3oool0ool01ol0ool00ol0
003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02Omo0?l00ol0
003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02?mo0?l00ol0
003o0?ooo`3oo`0>o`3oo`;o00000_moo`07ogl0o`03o`000?mo0?oo000000ko0?oo00Co0000olc<
c?o<c<coIVIV5oo<c<`1ooooo`009_o<c<`2o`000003olc<c?mVIVKoc<c<01Soc<c<00?oIVIVolc<
c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`002?moo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`002?moo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo0_l000000omo
o`3oO`3oogl0o`06ogl0o`03o`000?mo0?oo000000ko0?oo00Co0000olc<c?o<c<coIVIV5oo<c<`1
ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<01;oc<c<00?o0000
o`3oool0ool01ol0ool00ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000SoOol000?o0000
ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000SoOol000?o0000
ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`;o000000?oOol0ogl0oomo0?l01_mo0?l0
0ol0003oO`3oo`00000>o`3oo`04o`000?o<c<coc<c<ofIVIQOoc<c<0Oooool002Koc<c<00Co0000
olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00Oo0?oo00?o
0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool03Ol0ool2o`000003ogoo0?mo0?ooO`3o00KoO`3o00?o0000ogl0ool000003_l0
ool01?l0003oc<c<olc<c?mVIVHGolc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQWoc<c<
00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00SoO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00go0?oo
0_l000000omoo`3oO`3oogl0o`06ogl0o`04o`000?mo0?ooO`3oo`0000go0?oo00Go0000olc<c?o<
c<coc<c<ofIVIP0Folc<c07ooooo000Volc<c004o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<
c?o<c<`04oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00WoO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo
0?mo0?l01omo0?l01?l0003oO`3oogl0ool0000=o`3oo`05o`000?o<c<coc<c<olc<c?mVIVH05_o<
c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<01?oc<c<00?o
0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`09ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000OoOol000?o
0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000OoOol000?o
0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oO`3o00OoO`3o00Co
0000ogl0oomo0?oo00003Ol0ool01Ol0003oc<c<olc<c?o<c<coIVIV01Koc<c<0Oooool002Koc<c<
00Co0000olc<c?o<c<coIVIV6?o<c<`00omVIVKoc<c<olc<c00Colc<c003o`000?l0oooo0?oo00Oo
0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[o
O`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[o
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`07ogl0o`04o`000?mo0?ooO`3oo`00
00go0?oo00Go0000olc<c?o<c<coc<c<ofIVIP0Folc<c07ooooo000Volc<c004o`000?o<c<coc<c<
ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?oo
O`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo
0?oo00go0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo
0?oo00ko0?oo00?o0000ogl0oomo0?l01omo0?l01?l0003oO`3oogl0ool0000=o`3oo`05o`000?o<
c<coc<c<olc<c?mVIVH05_o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIV
I_o<c<coc<c<01;oc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0:ogl0o`03o`00
0?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000OoOol000?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol000OoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`00
0?mo0?ooO`3o00OoO`3o00Co0000ogl0oomo0?oo00003_l0ool01?l0003oc<c<olc<c?mVIVHFolc<
c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04_o<c<`00ol0
003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0
003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0
003oO`3oogl0o`0:ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01omo0?l01?l0
003oO`3oogl0ool0000>o`3oo`04o`000?o<c<coc<c<ofIVIQKoc<c<0Oooool002Goc<c<00Co0000
olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00Oo0?oo00?o
0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o
0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`07ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo
00Co0000olc<c?o<c<coIVIV5_o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c0CoIVIV
6Oo<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l0
2_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0007ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool0
3_l0ool00ol0003oO`3oogl0o`07ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo00Co0000olc<c?o<
c<coIVIV5_o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c003o`000?o<c<coc<c<00Co
IVIV5_o<c<`00omVIVKoc<c<olc<c00Bolc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo
0?l02_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo0006ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0
ool03_l0ool00ol0003oO`3oogl0o`07ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo00Co0000olc<
c?o<c<coIVIV5_o<c<`1ooooo`006Oo<c<`6o`0000Koc<c<00Co0000olc<c?o<c<coIVIV0oo<c<`4
ofIVIQ;oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?oo
O`3o00_oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo
0?oo00go0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo
0?oo00go0?oo00?o0000ogl0oomo0?l01omo0?l01?l0003oO`3oogl0ool0000>o`3oo`04o`000?o<
c<coc<c<ofIVIQKoc<c<0Oooool001Woc<c<00Go0000olc<c?o<c<coc<c<o`000007olc<c004o`00
0?o<c<coc<c<ofIVIPOoc<c<1OmVIVH=olc<c003ofIVI_o<c<coc<c<017oc<c<00?o0000o`3oool0
ool01ol0ool00ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo
0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo
0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o00OoO`3o00Go0000ogl0oomo
0?ooO`3oo`00000=o`3oo`04o`000?o<c<coc<c<ofIVIQKoc<c<0Oooool001[oc<c<00Co0000olc<
c?o<c<co00001oo<c<`01?l0003oc<c<olc<c?mVIVH<olc<c0CoIVIV2Oo<c<`00omVIVKoc<c<olc<
c00Aolc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0006ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
0005ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0
o`07ogl0o`05o`000?mo0?ooO`3oogl0ool000003Ol0ool01?l0003oc<c<olc<c?mVIVHFolc<c07o
oooo000Kolc<c003o`000?o<c<co000000Ooc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`4ofIVIPGo
c<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00_o
O`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00ko
0?oo00?o0000ogl0oomo0?l01_mo0?l01Ol0003oO`3oogl0oomo0?oo000000go0?oo00Co0000olc<
c?o<c<coIVIV5_o<c<`1ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c004o`000?o<c<coc<c<
ofIVIQCoc<c<1?mVIVH00oo<c<coIVIVolc<c00Bolc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000
ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000
o`3oool0ool03_l0ool00ol0003oO`3oogl0o`06ogl0o`05o`000?mo0?ooO`3oogl0ool000003Ol0
ool01?l0003oc<c<olc<c?mVIVHFolc<c07ooooo000Lolc<c0;o00001oo<c<`01?l0003oc<c<olc<
c?mVIVHHolc<c0CoIVIV4Oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00_oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogl0oomo0?l01_mo0?l01Ol0003oO`3oogl0oomo0?oo000000go0?oo00Co0000olc<c?o<
c<coIVIV5_o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c004o`000?o<c<coc<c<ofIV
IQWoc<c<00?oIVIVolc<c?o<c<`01?mVIVH<olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0
oomo0?l02omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3o
ool0ool03Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3o
ool0ool03_l0ool00ol0003oO`3oogl0o`06ogl0o`05o`000?mo0?ooO`3oogl0ool000003_l0ool0
0ol0003oc<c<ofIVIP0Folc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIV
olc<c?o<c<`01?o<c<`5ofIVIPOoc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0<
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0>
o`3oo`03o`000?mo0?ooO`3o00KoO`3o00Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?o<
c<coIVIV01Koc<c<0Oooool002Goc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<
c009olc<c0CoIVIV0oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o
0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o
0000ogl0oomo0?l01_mo0?l01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000olc<c?mVIVH0
5_o<c<`1ooooo`009Oo<c<`01?l0003oc<c<olc<c?mVIVHHolc<c003ofIVI_o<c<coc<c<00koc<c<
0omVIVH00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
1?moo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
1?moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l0
1_mo0?l01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00Co0000olc<c?o<c<coIVIV5Oo<c<`1oooo
o`009Oo<c<`2o`000003olc<c?mVIVKoc<c<01Ooc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o
0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003o
O`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003o
O`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo0?l01Ol0003o
O`3oogl0oomo0?oo000000ko0?oo00?o0000ofIVI_mVIVH01?mVIVHBolc<c07ooooo000Uolc<c004
o`000?o<c<coc<c<ofIVIQSoc<c<00?oIVIVolc<c?o<c<`04Oo<c<`00ol0003o0?ooo`3oo`07o`3o
o`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0>ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=ogl0
o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo0?l01Ol0003oO`3oogl0oomo0?oo
000000ko0?oo00Co0000olc<c?o<c<coIVIV5Oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mV
IVHIolc<c003ofIVI_o<c<coc<c<013oc<c<00?o0000o`3oool0ool02?l0ool00ol0003oO`3oogl0
o`0<ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?moo`3oOol000?oOol000?o0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3o
o`0>o`3oo`03o`000?mo0?ooO`3o00KoO`3o00Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`04o`00
0?o<c<coc<c<ofIVIQGoc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKo
c<c<olc<c00@olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l03Omo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo0003ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo0003ogoo0003o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
O`3oogl0o`06ogl0o`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool02ol0ool01?l0003o
c<c<olc<c?mVIVHEolc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<
c?o<c<`04?o<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00koO`3o00?o0000o`3o
ool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo
0?moo`000omoo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo
0?moo`000omoo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogl0
oomo0?l01_mo0?l00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00Co0000olc<
c?o<c<coIVIV5Oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<co
c<c<013oc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo
0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000?oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o
Ool000?oOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?oo
O`3o00GoO`3o00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`04o`000?o<c<co
c<c<ofIVIQGoc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<
c00@olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0003ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo
0002ogoo0003o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0
o`05ogl0o`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<ofIV
IP0Eolc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`04?o<
c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool02ol0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`000omo
o`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_mo
o`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01Omo
0?l00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?mVIVH05Oo<
c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<c<coc<c<013oc<c<00?o
0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000?oOol000?o
0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o
0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o
0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coIVIV01Goc<c<0Ooo
ool002Coc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00?olc<c003o`000?l0
oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo
0?ooO`3o00ooO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo
0?ooO`3o00ooO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?mo
0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<ofIVIP0Eolc<c07ooooo000T
olc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3o
o`07o`3oo`03o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3o
o`0;o`3oo`03o`000?l0oooo0?oo00go0?oo00Go0000ogoo0?moo`3oOol0o`00000Bogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0?ogl0o`03o`00
0?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003oO`3oogl0o`02ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000olc<c?mVIVH05Oo<c<`1ooooo`009?o<c<`2o`000003olc<c?mV
IVKoc<c<01Soc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo
0?ooO`3o00ooO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0
oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Bogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogl0oomo0?l01Omo0?l00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000olc<c?mVIVH05Oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIV
I_o<c<coc<c<00ooc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0?ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`00
0?moo`3oOol0ogoo0?l000004_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;o
Ool000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00Go
O`3o00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coIVIV01Go
c<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00?olc<c003
o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01Ol0003oOol0ogoo0?moo`3o0000
01;oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o
00ooO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?mo0?ooO`3o
00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<ofIVIP0Eolc<c07ooooo000Tolc<c004
o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`07o`3o
o`03o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Cogl0o`03o`000?l0oooo
0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Bogl0o`03o`000?l0oooo0?oo00ko0?oo00?o
0000ogl0oomo0?l01Omo0?l00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o
0000olc<c?mVIVH05Oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIVI_o<
c<coc<c<00koc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0@ogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`000?mo
o`3oOol0ogoo0?l000004omo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?moo`3oOol0o`0001;o
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`05ogl0o`03o`000?mo0?ooO`3o00?o
O`3o00?o0000o`3oool0ool02ol0ool00ol0003oc<c<ofIVIP0Eolc<c07ooooo000Tolc<c004o`00
0?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03
o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Cogl0o`03o`000?l0oooo0?oo
00go0?oo00Co0000ogoo0?moo`3o00004omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?oo
O`3o00GoO`3o00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mVIVKo
c<c<01Coc<c<0Oooool002?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP0Holc<c003ofIVI_o<c<co
c<c<00ooc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0@ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`000?moo`3o
Ool0ogoo0?l000004omo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?moo`3oOol0o`0001?oO`3o
00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?mo0?ooO`3o00?oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003oIVIVolc<c00Dolc<c07ooooo000Solc<c004o`000?o<
c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`00
0?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`04
o`000?moo`3oOol0o`0001?oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0
o`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<ofIVIP0Dolc<
c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03oo<c<`00ol0
003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00005?mo0?l0
0ol0003o0?ooo`3oo`0=o`3oo`04o`000?moo`3oOol0o`0001?oO`3o00?o0000o`3oool0ool03_l0
ool00ol0003oO`3oogl0o`04ogl0o`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0
ool00ol0003oc<c<ofIVIP0Dolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?o
IVIVolc<c?o<c<`03oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00Co
0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`04o`000?moo`3oOol0o`0001?o
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`03o`000?mo0?ooO`3o00?o
O`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<ofIVIP0Dolc<c07ooooo000Solc<c004o`00
0?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03_o<c<`00ol0003o0?ooo`3oo`07o`3oo`03
o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00005?mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`04o`000?moo`3oOol0o`0001?oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04
ogl0o`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<ofIVIP0D
olc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00?oIVIVolc<c?o<c<`03_o<c<`0
0ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00Co0000ogoo0?moo`3o00005?mo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3o000001CoO`3o00?o0000o`3oool0ool03_l0
ool00ol0003oO`3oogl0o`04ogl0o`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0
ool00ol0003oc<c<ofIVIP0Dolc<c07ooooo000Solc<c0;o000000?oc<c<ofIVI_o<c<`06?o<c<`0
0omVIVKoc<c<olc<c00>olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l04Omo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
1?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005?mo
0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000ogl0oomo0?l00omo
0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coIVIV01Coc<c<0Oooool002?oc<c<00Co0000
olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00>olc<c003o`000?l0oooo0?oo00Oo0?oo00?o
0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Dogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?l000005?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o
00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coIVIV01Coc<c<
0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<olc<c00>olc<c003o`00
0?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0o`00000Eogl0o`03o`00
0?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`00
0?mo0?ooO`3o00CoO`3o00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?o<c<coIVIV01Coc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`00omVIVKoc<c<
olc<c00>olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
o`00000Eogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?l000005?mo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?oo
o`3oo`0;o`3oo`03o`000?o<c<coIVIV01Coc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV
6Oo<c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00So0?oo00?o0000ogl0oomo0?l0
4_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool0
3Ol0ool2o`0001GoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0o`00000Dogl0o`03o`00
0?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01?mo0?l00ol0003oO`3oogl0o`04ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000ofIVI_o<c<`04oo<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<
c?mVIVHIolc<c003ofIVI_o<c<coc<c<00goc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3o
ogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`;o00005Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o00005?mo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?mVIVKoc<c<01?oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV
6Oo<c<`00omVIVKoc<c<olc<c00=olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l0
4omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool2o`0001KoO`3o00?o0000o`3oool0ool03Ol0ool2o`0001GoO`3o00?o0000o`3oool0ool0
3_l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oIVIVolc<c00Colc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<
00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o01?oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
0_l0000Fogl0o`03o`000?l0oooo0?oo00go0?oo0_l0000Eogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogl0oomo0?l00omo0?l00ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000ofIVI_o<c<`04oo<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIV
I_o<c<coc<c<00goc<c<00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0Cogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`;o0000
5_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool0
3_l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oIVIVolc<c00Colc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIQWoc<c<
00?oIVIVolc<c?o<c<`03Oo<c<`00ol0003o0?ooo`3oo`07o`3oo`03o`000?mo0?ooO`3o01?oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogl0oomo0?l05Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo0?ooO`3o01CoO`3o
00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?mo0?ooO`3o00CoO`3o
00?o0000o`3oool0ool03?l0ool00ol0003oIVIVolc<c00Colc<c07ooooo000Rolc<c004o`000?o<
c<coc<c<ofIVIQ[oc<c<00?oIVIVolc<c?o<c<`03?o<c<`00ol0003o0?ooo`3oo`08o`3oo`03o`00
0?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l05Omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`00
0?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`03ogl0o`03o`00
0?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oIVIVolc<c00Colc<c07ooooo
000Golc<c0Co00001oo<c<`01?l0003oc<c<olc<c?mVIVHJolc<c003ofIVI_o<c<coc<c<00coc<c<
00?o0000o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01GoO`3o
00?o0000o`3oool0ool01Ol0ool;o`0001CoO`3o00?o0000o`3oool0ool01_l0ool<o`0000;oO`3o
00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mVIVKoc<c<01?oc<c<
0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c0KoIVIV5oo<
c<`00omVIVKoc<c<olc<c006olc<c0go00001?l0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0
oooo0?oo00co0?oo00?o0000o`3oool0ool01Ol0oolKo`0000_oO`3o4?l0000;ool000?o00002Omo
0?lAo`0000coo`000ol00006ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ofIVI_o<c<`04oo<
c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000
olc<c?o<c<coIVIV0_o<c<`9ofIVIPkoc<c<00?oIVIVolc<c?l000001_l0000=ool000[o00004Omo
0?l00ol0003o0?ooo`3oo`05o`3oo`oo00002_oo0004o`0000goo`002ol0000=ool000So00002Ooo
0009o`0000coo`002ol0000@ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000ofIVI_o<c<`04oo<
c<`1ooooo`005_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Coc<c<00Co0000
olc<c?o<c<coIVIV2oo<c<`9ofIVIPGoc<c<00?oIVIVolc<c?o<c<`01Oo<c<`;o`0000goo`006Ol0
000<ool000So00002Ooo0009o`0000coo`002_l0000<ool000So00002?oo000:o`0000coo`000ol0
000Bogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ofIVI_o<c<`04_o<c<`1ooooo`005_o<c<`2
o`0000?oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVHDolc<c0WoIVIV3_o<
c<`;o`0000Woo`001Ol0000<ool000[o00003?oo0007o`0000Soo`002_l0000<ool000[o00002_oo
0003o`0000koo`002_l00003ogl0o`03o`000?l0oooo0?oo00;o0?oo00?o0000ogl0oomo0?l04?mo
0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mVIVKoc<c<01;oc<c<0Oooool001Koc<c<00?o0000
olc<c?l000000_l00007olc<c004o`000?o<c<coc<c<ofIVIQWoc<c<00CoIVIVolc<c?o<c<coc<c<
2OmVIVH:olc<c003ofIVI_o<c<coc<c<00;oc<c<1_l00009ool000So00003?oo000:o`0000coo`00
1ol00007ool000[o00003?oo0007o`0000Woo`002Ol0000Bogl0o`03o`000?l0oooo0?oo00;o0?oo
00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mVIVKoc<c<01;oc<c<
0Oooool001Koc<c<00?o0000olc<c?o<c<`02Oo<c<`01?l0003oc<c<olc<c?mVIVHIolc<c003ofIV
I_o<c<coc<c<00[oc<c<2OmVIVH00oo<c<coIVIVolc<c00;olc<c0Oo00001_oo000:o`0000coo`00
2_l0000;ool000Oo00001ooo000:o`0000_oo`001ol00008ool000Go00002_mo0?l;o`000003o`3o
ool0003oO`3o017oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oIVIVolc<c00Bolc<c07ooooo
000Golc<c005o`000?o<c<coc<c<olc<c?l000008oo<c<`00omVIVKoc<c<olc<c00Colc<c0WoIVIV
3Oo<c<`7o`0000Koo`002_l0000<ool000Wo00002ooo0007o`0000Ooo`002Ol0000;ool000Oo0000
1ooo000:o`0000_oo`001?l00009ogl0oaOo00001OmVIVH?olc<c07ooooo000Holc<c0?o00009?o<
c<`00omVIVKoc<c<olc<c00Dolc<c003ofIVI_o<c<coc<c<00Goc<c<2OmVIVH4olc<c003ofIVI_o<
c<coc<c<00Goc<c<1ol00006ool000[o00002ooo0009o`0000[oo`001ol00007ool000Wo00002ooo
0007o`0000Ooo`002Ol0000:ool000Wo00003OmVIVH:olc<c003ofIVI_o<c<coc<c<017oc<c<0Ooo
ool003ooc<c<00?oIVIVolc<c?o<c<`05?o<c<`00omVIVKoc<c<olc<c00>olc<c0WoIVIV2oo<c<`9
o`0000_oo`001_l00006ool000Wo00002ooo0006o`0000Ooo`002Ol0000:ool000Wo00003_mVIVH0
0oo<c<coIVIVolc<c00Rolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool005Koc<c<00?oIVIVolc<
c?o<c<`04_o<c<`00omVIVKoc<c<olc<c002olc<c0WoIVIV0oo<c<`00omVIVKoc<c<olc<c003olc<
c0Wo00002_oo0007o`0000Koo`002Ol0000:ool000So00003OmVIVHMolc<c003ofIVI_o<c<coc<c<
027oc<c<00?oIVIVolc<c?o<c<`04Oo<c<`1ooooo`00E_o<c<`00omVIVKoc<c<olc<c00Bolc<c003
ofIVI_o<c<coc<c<00_oc<c<2OmVIVH6olc<c003ofIVI_l0003o000000Ko00002_oo0009o`0000[o
IVIV5oo<c<`00omVIVKoc<c<olc<c00Oolc<c003ofIVI_o<c<coc<c<027oc<c<00?oIVIVolc<c?o<
c<`04Oo<c<`1ooooo`00Joo<c<`00omVIVKoc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<00?oc<c<
4OmVIVHBolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<
olc<c00eolc<c07ooooo001[olc<c003ofIVI_o<c<coc<c<00koc<c<00?oIVIVolc<c?o<c<`02Oo<
c<`00omVIVKoc<c<olc<c00Jolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`0Eoo<
c<`1ooooo`00O?o<c<`00omVIVKoc<c<olc<c009olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIV
olc<c?o<c<`0Moo<c<`1ooooo`00O?o<c<`00omVIVKoc<c<olc<c009olc<c003ofIVI_o<c<coc<c<
09Coc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Ooo
ool00?ooc<c<8?o<c<`1ooooo`00`_o<c<`2o`0005_oc<c<0Oooool00<?oc<c<0_l00002olc<c003
o`000?o<c<coc<c<05Goc<c<0Oooool00<Coc<c<0_l00002olc<c003o`000?o<c<coc<c<05Coc<c<
0Oooool003_oc<c<1Ol00004olc<c0?o00000oo<c<`2o`0000?oc<c<0ol00002olc<c0Co00000oo<
c<`5o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`3o`000003olc<c?l0003o000000;oc<c<0_l0
0002olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000Goc<c<0_l0
0003olc<c0;o000000?oc<c<o`000?l000000_o<c<`4o`0000?oc<c<0ol00003olc<c0?o00000oo<
c<`2o`0000Coc<c<0ol000000oo<c<co0000o`000006olc<c0Co000000Coc<c<o`000?o<c<coc<c<
1?l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00005olc<c0;o00001?o<c<`4o`0002Woc<c<
0Oooool003[oc<c<0_l00003olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l0
0003olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<
c<`2o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`00
0002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l0
00000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000Coc<c<0_l0
0003olc<c0;o000000Coc<c<o`000?l0003oc<c<0_l00002olc<c0;o00000_o<c<`2o`0000?oc<c<
0_l000000oo<c<co0000o`000002olc<c0;o00001?o<c<`3o`000003olc<c?l0003o000000Goc<c<
0_l00002olc<c0?o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0003o000000;oc<c<
0_l00002olc<c0;o00001Oo<c<`2o`0000?oc<c<0_l00002olc<c0;o0000:?o<c<`1ooooo`00>_o<
c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000000oo<
c<`2o`0000;oc<c<0_l00005olc<c0;o00000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<
c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000002?o<c<`3o`0000Coc<c<0ol0
00000oo<c<co0000o`000008olc<c0?o00001?o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`00
0004olc<c0?o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<
c<`2o`000003olc<c?l0003o000000Koc<c<0_l00004olc<c0;o000000?oc<c<o`000?l000001Oo<
c<`2o`0000;oc<c<0_l00009olc<c0;o00000oo<c<`2o`0000;oc<c<0_l0000Xolc<c07ooooo000n
olc<c0?o000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l00002
olc<c0Ko000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2
o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000001?l00002olc<c0Co00000oo<c<`4
o`0000;oc<c<1_l00002olc<c0Co00001Oo<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002
olc<c0Co00000oo<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2
o`000003olc<c?l0003o000000Koc<c<0_l00004olc<c0;o000000?oc<c<o`000?l000001?l00000
0oo<c<co0000o`000002olc<c0;o00002Oo<c<`2o`0000?oc<c<0_l00002olc<c0;o0000:?o<c<`1
ooooo`00>oo<c<`5o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`00
00;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<1Ol000000oo<
c<co0000o`000002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<
c0;o000000Coc<c<o`000?l0003o00001?o<c<`3o`0000Coc<c<0_l00002olc<c0;o000000Coc<c<
o`000?l0003o00001oo<c<`2o`0000?oc<c<0_l000001?o<c<co0000o`000?o<c<`3o`0000Goc<c<
0_l00002olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000?oc<c<0_l000000oo<c<co0000
o`000006olc<c0;o00000_o<c<`4o`000003olc<c?l0003o000000;oc<c<0_l000000oo<c<co0000
o`000002olc<c0;o00002Oo<c<`2o`0000?oc<c<0_l00002olc<c0;o0000:?o<c<`1ooooo`00>_o<
c<`3o`0000Koc<c<0_l000000oo<c<co0000o`000002olc<c0?o00000_o<c<`2o`0000;oc<c<0_l0
0002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<
c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0
003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<
c<`2o`000003olc<c?l0003o000000;oc<c<0_l00004olc<c0Oo000000Coc<c<o`000?l0003oc<c<
0_l00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0?o0000
0_o<c<`2o`000003olc<c?l0003o000000Koc<c<0_l00007olc<c0;o00000_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0_l00009olc<c0;o00000oo<c<`2o`0000;oc<c<0_l0000Xolc<c07ooooo
000jolc<c0;o00000oo<c<`2o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`000?l000000_l0
0002olc<c0Co00000oo<c<`5o`0000?oc<c<0_l00004olc<c0;o000000?oc<c<o`000?l000000_l0
00000oo<c<co0000o`000003o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l0
0003olc<c0Co00001Oo<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0Co00000_o<
c<`4o`0000?oc<c<0ol00003olc<c0?o000000?oc<c<o`000?l000000oo<c<`2o`0000Goc<c<0_l0
0004olc<c0;o00000_o<c<`4o`0000;oc<c<1Ol0000:olc<c0;o00000oo<c<`2o`0000;oc<c<0_l0
000Xolc<c07ooooo000jolc<c0;o00000oo<c<`2o`0000koc<c<0_l0000=olc<c0;o00000oo<c<`2
o`0000Soc<c<0_l0000_olc<c0;o00000oo<c<`2o`0000coc<c<0_l0000Kolc<c0;o00000_o<c<`2
o`0001Koc<c<1?l00003olc<c0;o00000_o<c<`2o`0002Soc<c<0Oooool003_oc<c<1Ol0000?olc<
c0;o00003Oo<c<`2o`0000?oc<c<2?l00002olc<c0;o0000;oo<c<`2o`0000?oc<c<0_l000000oo<
c<co0000o`000009olc<c0;o00007?o<c<`4o`0001Woc<c<0_l00004olc<c0Co0000:Oo<c<`1oooo
o`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`P
olc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo
003oolc<c23oc<c<0Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 6, 6, 6, 6, 6, 6, 6, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(6.`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 0.0147151 5.88604 [
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.55291 .00222 -3 -9 ]
[.55291 .00222 3 0 ]
[.76455 .00222 -3 -9 ]
[.76455 .00222 3 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.11713 .13244 -24 -4.5 ]
[.11713 .13244 0 4.5 ]
[.11713 .25016 -24 -4.5 ]
[.11713 .25016 0 4.5 ]
[.11713 .36788 -24 -4.5 ]
[.11713 .36788 0 4.5 ]
[.11713 .4856 -24 -4.5 ]
[.11713 .4856 0 4.5 ]
[.11713 .60332 -18 -4.5 ]
[.11713 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .01472 m
.34127 .02097 L
s
[(4)] .34127 .00222 0 1 Mshowa
.55291 .01472 m
.55291 .02097 L
s
[(6)] .55291 .00222 0 1 Mshowa
.76455 .01472 m
.76455 .02097 L
s
[(8)] .76455 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(10)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.18254 .01472 m
.18254 .01847 L
s
.23545 .01472 m
.23545 .01847 L
s
.28836 .01472 m
.28836 .01847 L
s
.39418 .01472 m
.39418 .01847 L
s
.44709 .01472 m
.44709 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.60582 .01472 m
.60582 .01847 L
s
.65873 .01472 m
.65873 .01847 L
s
.71164 .01472 m
.71164 .01847 L
s
.81746 .01472 m
.81746 .01847 L
s
.87037 .01472 m
.87037 .01847 L
s
.92328 .01472 m
.92328 .01847 L
s
.07672 .01472 m
.07672 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.12963 .13244 m
.13588 .13244 L
s
[(0.02)] .11713 .13244 1 0 Mshowa
.12963 .25016 m
.13588 .25016 L
s
[(0.04)] .11713 .25016 1 0 Mshowa
.12963 .36788 m
.13588 .36788 L
s
[(0.06)] .11713 .36788 1 0 Mshowa
.12963 .4856 m
.13588 .4856 L
s
[(0.08)] .11713 .4856 1 0 Mshowa
.12963 .60332 m
.13588 .60332 L
s
[(0.1)] .11713 .60332 1 0 Mshowa
.125 Mabswid
.12963 .04415 m
.13338 .04415 L
s
.12963 .07358 m
.13338 .07358 L
s
.12963 .10301 m
.13338 .10301 L
s
.12963 .16187 m
.13338 .16187 L
s
.12963 .1913 m
.13338 .1913 L
s
.12963 .22073 m
.13338 .22073 L
s
.12963 .27959 m
.13338 .27959 L
s
.12963 .30902 m
.13338 .30902 L
s
.12963 .33845 m
.13338 .33845 L
s
.12963 .39731 m
.13338 .39731 L
s
.12963 .42674 m
.13338 .42674 L
s
.12963 .45617 m
.13338 .45617 L
s
.12963 .51503 m
.13338 .51503 L
s
.12963 .54446 m
.13338 .54446 L
s
.12963 .57389 m
.13338 .57389 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.12963 .60332 L
.23545 .60332 L
.34127 .60332 L
.44709 .60332 L
.55291 .60332 L
.65873 .60332 L
.76455 .60332 L
.87037 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 0.0147151 2.94302 [
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.55291 .00222 -3 -9 ]
[.55291 .00222 3 0 ]
[.76455 .00222 -3 -9 ]
[.76455 .00222 3 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.11713 .16187 -24 -4.5 ]
[.11713 .16187 0 4.5 ]
[.11713 .30902 -18 -4.5 ]
[.11713 .30902 0 4.5 ]
[.11713 .45617 -24 -4.5 ]
[.11713 .45617 0 4.5 ]
[.11713 .60332 -18 -4.5 ]
[.11713 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .01472 m
.34127 .02097 L
s
[(4)] .34127 .00222 0 1 Mshowa
.55291 .01472 m
.55291 .02097 L
s
[(6)] .55291 .00222 0 1 Mshowa
.76455 .01472 m
.76455 .02097 L
s
[(8)] .76455 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(10)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.18254 .01472 m
.18254 .01847 L
s
.23545 .01472 m
.23545 .01847 L
s
.28836 .01472 m
.28836 .01847 L
s
.39418 .01472 m
.39418 .01847 L
s
.44709 .01472 m
.44709 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.60582 .01472 m
.60582 .01847 L
s
.65873 .01472 m
.65873 .01847 L
s
.71164 .01472 m
.71164 .01847 L
s
.81746 .01472 m
.81746 .01847 L
s
.87037 .01472 m
.87037 .01847 L
s
.92328 .01472 m
.92328 .01847 L
s
.07672 .01472 m
.07672 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.12963 .16187 m
.13588 .16187 L
s
[(0.05)] .11713 .16187 1 0 Mshowa
.12963 .30902 m
.13588 .30902 L
s
[(0.1)] .11713 .30902 1 0 Mshowa
.12963 .45617 m
.13588 .45617 L
s
[(0.15)] .11713 .45617 1 0 Mshowa
.12963 .60332 m
.13588 .60332 L
s
[(0.2)] .11713 .60332 1 0 Mshowa
.125 Mabswid
.12963 .04415 m
.13338 .04415 L
s
.12963 .07358 m
.13338 .07358 L
s
.12963 .10301 m
.13338 .10301 L
s
.12963 .13244 m
.13338 .13244 L
s
.12963 .1913 m
.13338 .1913 L
s
.12963 .22073 m
.13338 .22073 L
s
.12963 .25016 m
.13338 .25016 L
s
.12963 .27959 m
.13338 .27959 L
s
.12963 .33845 m
.13338 .33845 L
s
.12963 .36788 m
.13338 .36788 L
s
.12963 .39731 m
.13338 .39731 L
s
.12963 .42674 m
.13338 .42674 L
s
.12963 .4856 m
.13338 .4856 L
s
.12963 .51503 m
.13338 .51503 L
s
.12963 .54446 m
.13338 .54446 L
s
.12963 .57389 m
.13338 .57389 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.12963 .30902 L
.23545 .30902 L
.34127 .30902 L
.44709 .30902 L
.55291 .30902 L
.65873 .30902 L
.76455 .30902 L
.87037 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 -0.377687 0.981006 [
[.34127 .59082 -3 -9 ]
[.34127 .59082 3 0 ]
[.55291 .59082 -3 -9 ]
[.55291 .59082 3 0 ]
[.76455 .59082 -3 -9 ]
[.76455 .59082 3 0 ]
[.97619 .59082 -6 -9 ]
[.97619 .59082 6 0 ]
[.11713 .01472 -18 -4.5 ]
[.11713 .01472 0 4.5 ]
[.11713 .11282 -18 -4.5 ]
[.11713 .11282 0 4.5 ]
[.11713 .21092 -18 -4.5 ]
[.11713 .21092 0 4.5 ]
[.11713 .30902 -18 -4.5 ]
[.11713 .30902 0 4.5 ]
[.11713 .40712 -18 -4.5 ]
[.11713 .40712 0 4.5 ]
[.11713 .50522 -18 -4.5 ]
[.11713 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .60332 m
.34127 .60957 L
s
[(4)] .34127 .59082 0 1 Mshowa
.55291 .60332 m
.55291 .60957 L
s
[(6)] .55291 .59082 0 1 Mshowa
.76455 .60332 m
.76455 .60957 L
s
[(8)] .76455 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(10)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.18254 .60332 m
.18254 .60707 L
s
.23545 .60332 m
.23545 .60707 L
s
.28836 .60332 m
.28836 .60707 L
s
.39418 .60332 m
.39418 .60707 L
s
.44709 .60332 m
.44709 .60707 L
s
.5 .60332 m
.5 .60707 L
s
.60582 .60332 m
.60582 .60707 L
s
.65873 .60332 m
.65873 .60707 L
s
.71164 .60332 m
.71164 .60707 L
s
.81746 .60332 m
.81746 .60707 L
s
.87037 .60332 m
.87037 .60707 L
s
.92328 .60332 m
.92328 .60707 L
s
.07672 .60332 m
.07672 .60707 L
s
.02381 .60332 m
.02381 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.12963 .01472 m
.13588 .01472 L
s
[(0.4)] .11713 .01472 1 0 Mshowa
.12963 .11282 m
.13588 .11282 L
s
[(0.5)] .11713 .11282 1 0 Mshowa
.12963 .21092 m
.13588 .21092 L
s
[(0.6)] .11713 .21092 1 0 Mshowa
.12963 .30902 m
.13588 .30902 L
s
[(0.7)] .11713 .30902 1 0 Mshowa
.12963 .40712 m
.13588 .40712 L
s
[(0.8)] .11713 .40712 1 0 Mshowa
.12963 .50522 m
.13588 .50522 L
s
[(0.9)] .11713 .50522 1 0 Mshowa
.125 Mabswid
.12963 .03434 m
.13338 .03434 L
s
.12963 .05396 m
.13338 .05396 L
s
.12963 .07358 m
.13338 .07358 L
s
.12963 .0932 m
.13338 .0932 L
s
.12963 .13244 m
.13338 .13244 L
s
.12963 .15206 m
.13338 .15206 L
s
.12963 .17168 m
.13338 .17168 L
s
.12963 .1913 m
.13338 .1913 L
s
.12963 .23054 m
.13338 .23054 L
s
.12963 .25016 m
.13338 .25016 L
s
.12963 .26978 m
.13338 .26978 L
s
.12963 .2894 m
.13338 .2894 L
s
.12963 .32864 m
.13338 .32864 L
s
.12963 .34826 m
.13338 .34826 L
s
.12963 .36788 m
.13338 .36788 L
s
.12963 .3875 m
.13338 .3875 L
s
.12963 .42674 m
.13338 .42674 L
s
.12963 .44636 m
.13338 .44636 L
s
.12963 .46598 m
.13338 .46598 L
s
.12963 .4856 m
.13338 .4856 L
s
.12963 .52484 m
.13338 .52484 L
s
.12963 .54446 m
.13338 .54446 L
s
.12963 .56408 m
.13338 .56408 L
s
.12963 .5837 m
.13338 .5837 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.12963 .60332 L
.23545 .60332 L
.34127 .59351 L
.44709 .5838 L
.55291 .57418 L
.65873 .36834 L
.76455 .36088 L
.87037 .20116 L
.97619 .19538 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 -0.100584 1.15299 [
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.55291 .00222 -3 -9 ]
[.55291 .00222 3 0 ]
[.76455 .00222 -3 -9 ]
[.76455 .00222 3 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.11713 .13001 -18 -4.5 ]
[.11713 .13001 0 4.5 ]
[.11713 .24531 -18 -4.5 ]
[.11713 .24531 0 4.5 ]
[.11713 .36061 -18 -4.5 ]
[.11713 .36061 0 4.5 ]
[.11713 .47591 -18 -4.5 ]
[.11713 .47591 0 4.5 ]
[.11713 .59121 -18 -4.5 ]
[.11713 .59121 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .01472 m
.34127 .02097 L
s
[(4)] .34127 .00222 0 1 Mshowa
.55291 .01472 m
.55291 .02097 L
s
[(6)] .55291 .00222 0 1 Mshowa
.76455 .01472 m
.76455 .02097 L
s
[(8)] .76455 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(10)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.18254 .01472 m
.18254 .01847 L
s
.23545 .01472 m
.23545 .01847 L
s
.28836 .01472 m
.28836 .01847 L
s
.39418 .01472 m
.39418 .01847 L
s
.44709 .01472 m
.44709 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.60582 .01472 m
.60582 .01847 L
s
.65873 .01472 m
.65873 .01847 L
s
.71164 .01472 m
.71164 .01847 L
s
.81746 .01472 m
.81746 .01847 L
s
.87037 .01472 m
.87037 .01847 L
s
.92328 .01472 m
.92328 .01847 L
s
.07672 .01472 m
.07672 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.12963 .13001 m
.13588 .13001 L
s
[(0.2)] .11713 .13001 1 0 Mshowa
.12963 .24531 m
.13588 .24531 L
s
[(0.3)] .11713 .24531 1 0 Mshowa
.12963 .36061 m
.13588 .36061 L
s
[(0.4)] .11713 .36061 1 0 Mshowa
.12963 .47591 m
.13588 .47591 L
s
[(0.5)] .11713 .47591 1 0 Mshowa
.12963 .59121 m
.13588 .59121 L
s
[(0.6)] .11713 .59121 1 0 Mshowa
.125 Mabswid
.12963 .03777 m
.13338 .03777 L
s
.12963 .06083 m
.13338 .06083 L
s
.12963 .08389 m
.13338 .08389 L
s
.12963 .10695 m
.13338 .10695 L
s
.12963 .15307 m
.13338 .15307 L
s
.12963 .17613 m
.13338 .17613 L
s
.12963 .19919 m
.13338 .19919 L
s
.12963 .22225 m
.13338 .22225 L
s
.12963 .26837 m
.13338 .26837 L
s
.12963 .29143 m
.13338 .29143 L
s
.12963 .31449 m
.13338 .31449 L
s
.12963 .33755 m
.13338 .33755 L
s
.12963 .38367 m
.13338 .38367 L
s
.12963 .40673 m
.13338 .40673 L
s
.12963 .42979 m
.13338 .42979 L
s
.12963 .45285 m
.13338 .45285 L
s
.12963 .49897 m
.13338 .49897 L
s
.12963 .52203 m
.13338 .52203 L
s
.12963 .54509 m
.13338 .54509 L
s
.12963 .56815 m
.13338 .56815 L
s
.12963 .61427 m
.13338 .61427 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .13001 m
.12963 .60332 L
.23545 .59628 L
.34127 .58931 L
.44709 .58241 L
.55291 .57558 L
.65873 .01472 L
.76455 .01472 L
.87037 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 -0.573889 5.88604 [
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.55291 .00222 -3 -9 ]
[.55291 .00222 3 0 ]
[.76455 .00222 -3 -9 ]
[.76455 .00222 3 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.11713 .13244 -24 -4.5 ]
[.11713 .13244 0 4.5 ]
[.11713 .25016 -24 -4.5 ]
[.11713 .25016 0 4.5 ]
[.11713 .36788 -24 -4.5 ]
[.11713 .36788 0 4.5 ]
[.11713 .4856 -24 -4.5 ]
[.11713 .4856 0 4.5 ]
[.11713 .60332 -18 -4.5 ]
[.11713 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .01472 m
.34127 .02097 L
s
[(4)] .34127 .00222 0 1 Mshowa
.55291 .01472 m
.55291 .02097 L
s
[(6)] .55291 .00222 0 1 Mshowa
.76455 .01472 m
.76455 .02097 L
s
[(8)] .76455 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(10)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.18254 .01472 m
.18254 .01847 L
s
.23545 .01472 m
.23545 .01847 L
s
.28836 .01472 m
.28836 .01847 L
s
.39418 .01472 m
.39418 .01847 L
s
.44709 .01472 m
.44709 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.60582 .01472 m
.60582 .01847 L
s
.65873 .01472 m
.65873 .01847 L
s
.71164 .01472 m
.71164 .01847 L
s
.81746 .01472 m
.81746 .01847 L
s
.87037 .01472 m
.87037 .01847 L
s
.92328 .01472 m
.92328 .01847 L
s
.07672 .01472 m
.07672 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.12963 .13244 m
.13588 .13244 L
s
[(0.12)] .11713 .13244 1 0 Mshowa
.12963 .25016 m
.13588 .25016 L
s
[(0.14)] .11713 .25016 1 0 Mshowa
.12963 .36788 m
.13588 .36788 L
s
[(0.16)] .11713 .36788 1 0 Mshowa
.12963 .4856 m
.13588 .4856 L
s
[(0.18)] .11713 .4856 1 0 Mshowa
.12963 .60332 m
.13588 .60332 L
s
[(0.2)] .11713 .60332 1 0 Mshowa
.125 Mabswid
.12963 .04415 m
.13338 .04415 L
s
.12963 .07358 m
.13338 .07358 L
s
.12963 .10301 m
.13338 .10301 L
s
.12963 .16187 m
.13338 .16187 L
s
.12963 .1913 m
.13338 .1913 L
s
.12963 .22073 m
.13338 .22073 L
s
.12963 .27959 m
.13338 .27959 L
s
.12963 .30902 m
.13338 .30902 L
s
.12963 .33845 m
.13338 .33845 L
s
.12963 .39731 m
.13338 .39731 L
s
.12963 .42674 m
.13338 .42674 L
s
.12963 .45617 m
.13338 .45617 L
s
.12963 .51503 m
.13338 .51503 L
s
.12963 .54446 m
.13338 .54446 L
s
.12963 .57389 m
.13338 .57389 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.12963 .01472 L
.23545 .01472 L
.34127 .01472 L
.44709 .01472 L
.55291 .01472 L
.65873 .01472 L
.76455 .01472 L
.87037 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 0.0147151 5.88604 [
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.55291 .00222 -3 -9 ]
[.55291 .00222 3 0 ]
[.76455 .00222 -3 -9 ]
[.76455 .00222 3 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.11713 .13244 -24 -4.5 ]
[.11713 .13244 0 4.5 ]
[.11713 .25016 -24 -4.5 ]
[.11713 .25016 0 4.5 ]
[.11713 .36788 -24 -4.5 ]
[.11713 .36788 0 4.5 ]
[.11713 .4856 -24 -4.5 ]
[.11713 .4856 0 4.5 ]
[.11713 .60332 -18 -4.5 ]
[.11713 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .01472 m
.34127 .02097 L
s
[(4)] .34127 .00222 0 1 Mshowa
.55291 .01472 m
.55291 .02097 L
s
[(6)] .55291 .00222 0 1 Mshowa
.76455 .01472 m
.76455 .02097 L
s
[(8)] .76455 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(10)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.18254 .01472 m
.18254 .01847 L
s
.23545 .01472 m
.23545 .01847 L
s
.28836 .01472 m
.28836 .01847 L
s
.39418 .01472 m
.39418 .01847 L
s
.44709 .01472 m
.44709 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.60582 .01472 m
.60582 .01847 L
s
.65873 .01472 m
.65873 .01847 L
s
.71164 .01472 m
.71164 .01847 L
s
.81746 .01472 m
.81746 .01847 L
s
.87037 .01472 m
.87037 .01847 L
s
.92328 .01472 m
.92328 .01847 L
s
.07672 .01472 m
.07672 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.12963 .13244 m
.13588 .13244 L
s
[(0.02)] .11713 .13244 1 0 Mshowa
.12963 .25016 m
.13588 .25016 L
s
[(0.04)] .11713 .25016 1 0 Mshowa
.12963 .36788 m
.13588 .36788 L
s
[(0.06)] .11713 .36788 1 0 Mshowa
.12963 .4856 m
.13588 .4856 L
s
[(0.08)] .11713 .4856 1 0 Mshowa
.12963 .60332 m
.13588 .60332 L
s
[(0.1)] .11713 .60332 1 0 Mshowa
.125 Mabswid
.12963 .04415 m
.13338 .04415 L
s
.12963 .07358 m
.13338 .07358 L
s
.12963 .10301 m
.13338 .10301 L
s
.12963 .16187 m
.13338 .16187 L
s
.12963 .1913 m
.13338 .1913 L
s
.12963 .22073 m
.13338 .22073 L
s
.12963 .27959 m
.13338 .27959 L
s
.12963 .30902 m
.13338 .30902 L
s
.12963 .33845 m
.13338 .33845 L
s
.12963 .39731 m
.13338 .39731 L
s
.12963 .42674 m
.13338 .42674 L
s
.12963 .45617 m
.13338 .45617 L
s
.12963 .51503 m
.13338 .51503 L
s
.12963 .54446 m
.13338 .54446 L
s
.12963 .57389 m
.13338 .57389 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.12963 .60332 L
.23545 .60332 L
.34127 .60332 L
.44709 .60332 L
.55291 .60332 L
.65873 .60332 L
.76455 .60332 L
.87037 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 -0.371191 0.97451 [
[.34127 .59082 -3 -9 ]
[.34127 .59082 3 0 ]
[.55291 .59082 -3 -9 ]
[.55291 .59082 3 0 ]
[.76455 .59082 -3 -9 ]
[.76455 .59082 3 0 ]
[.97619 .59082 -6 -9 ]
[.97619 .59082 6 0 ]
[.11713 .01861 -18 -4.5 ]
[.11713 .01861 0 4.5 ]
[.11713 .11606 -18 -4.5 ]
[.11713 .11606 0 4.5 ]
[.11713 .21352 -18 -4.5 ]
[.11713 .21352 0 4.5 ]
[.11713 .31097 -18 -4.5 ]
[.11713 .31097 0 4.5 ]
[.11713 .40842 -18 -4.5 ]
[.11713 .40842 0 4.5 ]
[.11713 .50587 -18 -4.5 ]
[.11713 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .60332 m
.34127 .60957 L
s
[(4)] .34127 .59082 0 1 Mshowa
.55291 .60332 m
.55291 .60957 L
s
[(6)] .55291 .59082 0 1 Mshowa
.76455 .60332 m
.76455 .60957 L
s
[(8)] .76455 .59082 0 1 Mshowa
.97619 .60332 m
.97619 .60957 L
s
[(10)] .97619 .59082 0 1 Mshowa
.125 Mabswid
.18254 .60332 m
.18254 .60707 L
s
.23545 .60332 m
.23545 .60707 L
s
.28836 .60332 m
.28836 .60707 L
s
.39418 .60332 m
.39418 .60707 L
s
.44709 .60332 m
.44709 .60707 L
s
.5 .60332 m
.5 .60707 L
s
.60582 .60332 m
.60582 .60707 L
s
.65873 .60332 m
.65873 .60707 L
s
.71164 .60332 m
.71164 .60707 L
s
.81746 .60332 m
.81746 .60707 L
s
.87037 .60332 m
.87037 .60707 L
s
.92328 .60332 m
.92328 .60707 L
s
.07672 .60332 m
.07672 .60707 L
s
.02381 .60332 m
.02381 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.12963 .01861 m
.13588 .01861 L
s
[(0.4)] .11713 .01861 1 0 Mshowa
.12963 .11606 m
.13588 .11606 L
s
[(0.5)] .11713 .11606 1 0 Mshowa
.12963 .21352 m
.13588 .21352 L
s
[(0.6)] .11713 .21352 1 0 Mshowa
.12963 .31097 m
.13588 .31097 L
s
[(0.7)] .11713 .31097 1 0 Mshowa
.12963 .40842 m
.13588 .40842 L
s
[(0.8)] .11713 .40842 1 0 Mshowa
.12963 .50587 m
.13588 .50587 L
s
[(0.9)] .11713 .50587 1 0 Mshowa
.125 Mabswid
.12963 .0381 m
.13338 .0381 L
s
.12963 .05759 m
.13338 .05759 L
s
.12963 .07708 m
.13338 .07708 L
s
.12963 .09657 m
.13338 .09657 L
s
.12963 .13555 m
.13338 .13555 L
s
.12963 .15504 m
.13338 .15504 L
s
.12963 .17453 m
.13338 .17453 L
s
.12963 .19402 m
.13338 .19402 L
s
.12963 .23301 m
.13338 .23301 L
s
.12963 .2525 m
.13338 .2525 L
s
.12963 .27199 m
.13338 .27199 L
s
.12963 .29148 m
.13338 .29148 L
s
.12963 .33046 m
.13338 .33046 L
s
.12963 .34995 m
.13338 .34995 L
s
.12963 .36944 m
.13338 .36944 L
s
.12963 .38893 m
.13338 .38893 L
s
.12963 .42791 m
.13338 .42791 L
s
.12963 .4474 m
.13338 .4474 L
s
.12963 .46689 m
.13338 .46689 L
s
.12963 .48638 m
.13338 .48638 L
s
.12963 .52536 m
.13338 .52536 L
s
.12963 .54485 m
.13338 .54485 L
s
.12963 .56434 m
.13338 .56434 L
s
.12963 .58383 m
.13338 .58383 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.12963 .01472 L
.23545 .60332 L
.34127 .59357 L
.44709 .58393 L
.55291 .37738 L
.65873 .16404 L
.76455 .60332 L
.87037 .19159 L
.97619 .18596 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0820106 0.10582 0.0147151 5.88604 [
[.34127 .00222 -3 -9 ]
[.34127 .00222 3 0 ]
[.55291 .00222 -3 -9 ]
[.55291 .00222 3 0 ]
[.76455 .00222 -3 -9 ]
[.76455 .00222 3 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.11713 .13244 -24 -4.5 ]
[.11713 .13244 0 4.5 ]
[.11713 .25016 -24 -4.5 ]
[.11713 .25016 0 4.5 ]
[.11713 .36788 -24 -4.5 ]
[.11713 .36788 0 4.5 ]
[.11713 .4856 -24 -4.5 ]
[.11713 .4856 0 4.5 ]
[.11713 .60332 -18 -4.5 ]
[.11713 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.34127 .01472 m
.34127 .02097 L
s
[(4)] .34127 .00222 0 1 Mshowa
.55291 .01472 m
.55291 .02097 L
s
[(6)] .55291 .00222 0 1 Mshowa
.76455 .01472 m
.76455 .02097 L
s
[(8)] .76455 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(10)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.18254 .01472 m
.18254 .01847 L
s
.23545 .01472 m
.23545 .01847 L
s
.28836 .01472 m
.28836 .01847 L
s
.39418 .01472 m
.39418 .01847 L
s
.44709 .01472 m
.44709 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.60582 .01472 m
.60582 .01847 L
s
.65873 .01472 m
.65873 .01847 L
s
.71164 .01472 m
.71164 .01847 L
s
.81746 .01472 m
.81746 .01847 L
s
.87037 .01472 m
.87037 .01847 L
s
.92328 .01472 m
.92328 .01847 L
s
.07672 .01472 m
.07672 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.12963 .13244 m
.13588 .13244 L
s
[(0.02)] .11713 .13244 1 0 Mshowa
.12963 .25016 m
.13588 .25016 L
s
[(0.04)] .11713 .25016 1 0 Mshowa
.12963 .36788 m
.13588 .36788 L
s
[(0.06)] .11713 .36788 1 0 Mshowa
.12963 .4856 m
.13588 .4856 L
s
[(0.08)] .11713 .4856 1 0 Mshowa
.12963 .60332 m
.13588 .60332 L
s
[(0.1)] .11713 .60332 1 0 Mshowa
.125 Mabswid
.12963 .04415 m
.13338 .04415 L
s
.12963 .07358 m
.13338 .07358 L
s
.12963 .10301 m
.13338 .10301 L
s
.12963 .16187 m
.13338 .16187 L
s
.12963 .1913 m
.13338 .1913 L
s
.12963 .22073 m
.13338 .22073 L
s
.12963 .27959 m
.13338 .27959 L
s
.12963 .30902 m
.13338 .30902 L
s
.12963 .33845 m
.13338 .33845 L
s
.12963 .39731 m
.13338 .39731 L
s
.12963 .42674 m
.13338 .42674 L
s
.12963 .45617 m
.13338 .45617 L
s
.12963 .51503 m
.13338 .51503 L
s
.12963 .54446 m
.13338 .54446 L
s
.12963 .57389 m
.13338 .57389 L
s
.25 Mabswid
.12963 0 m
.12963 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.12963 .60332 L
.23545 .60332 L
.34127 .60332 L
.44709 .60332 L
.55291 .60332 L
.65873 .60332 L
.76455 .60332 L
.87037 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H003Ooi^KV0ol00009onKViP?o
00002_oVi^H3o`0000Ooi^KV0ol00004onKViP;o0000?_oVi^H3o`0000Woi^KV0ol0000;onKViP?o
00001ooVi^H3o`0000Coi^KV0_l0000EonKViP00>?oVi^H00ol0003oi^KVonKViP07onKViP05o`00
0?oVi^Koi^KVonKVi_l000002?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKV
i_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000nonKViP03o`000?oVi^Koi^KV00Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`000009onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KV
onKViP02onKViP04o`000?oVi^Koi^KVo`0001Coi^KV000eonKViPGo00002?oVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000Soi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV
00;oi^KV00Co0000onKVi_oVi^Ko0000>ooVi^H5o`0000Soi^KV00Go0000onKVi_oVi^Koi^KVo`00
0009onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP02onKViP04o`00
0?oVi^Koi^KVo`0001Coi^KV000eonKViP04o`000?oVi^Koi^KVo`0000Woi^KV1?l0000:onKViP?o
00002?oVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0003_oi^KV00Co0000onKV
i_oVi^Ko00002OoVi^H4o`0000_oi^KV0ol00008onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000
onKVi_oVi^Ko00005?oVi^H003Koi^KV00?o0000onKVi_l000002OoVi^H00ol0003oi^KVonKViP0:
onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oV
i^Koi^KVo`0003coi^KV00?o0000onKVi_l000002OoVi^H00ol0003oi^KVonKViP0;onKViP05o`00
0?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`00
01Coi^KV000gonKViP;o00002_oVi^H00ol0003oi^KVonKViP09onKViP05o`000?oVi^Koi^KVonKV
i_l000001_oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Ko0000?OoVi^H2o`0000[oi^KV00?o0000
onKVi_oVi^H02_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV0_l00004onKViP04o`000?oV
i^Koi^KVo`0001Coi^KV000honKViP03o`000?oVi^Koi^KV00Woi^KV0_l0000:onKViP?o00002?oV
i^H00ol0003oi^KVonKViP03onKViP;o0000?ooVi^H00ol0003oi^KVonKViP09onKViP;o00002ooV
i^H3o`0000Soi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0001Goi^KV003SonKViP00:ooVi^H00ol0
003oi^KVonKViP1WonKViP03o`000?oVi^Koi^KV04_oi^KV000SonKViP03o`000?nc/k?o000003co
0000:ooVi^Hoo`0001Ooi^KV000TonKViP03ok>c/ooVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H0
IooVi^H00ol0003oi^KVonKViP1;onKViP009?oVi^H00onc/k?oi^KVonKViP04onKViP03o`000?oV
i^Koi^KV06Ooi^KV00?o0000onKVi_oVi^H0BooVi^H002Coi^KV00?o/k>conKVi_oVi^H01?oVi^H0
0ol0003oi^KVonKViP1WonKViP03o`000?oVi^Koi^KV04_oi^KV000UonKViP03ok>c/ooVi^Koi^KV
00?oi^KV00?o0000onKVi_oVi^H0IooVi^H00ol0003oi^KVonKViP1;onKViP005?oVi^H2o`0000Co
i^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000;oi^KV00?o0000ok>c/ol000000_l00002onKViP03
o`000?oVi^Koi^KV06Ooi^KV00?o0000onKVi_oVi^H0BooVi^H001?oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP04ok>c/ooVi^Koi^KVo`0000;oi^KV00?o0000
onKVi_oVi^H0D?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol00003
onKViP03o`000?oVi^Koi^KV04_oi^KV000ConKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H00onc/k?o0000onKViP03onKViP03o`000?oVi^Koi^KV04ooi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKV
i_oVi^Ko0000COoVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l0
0002onKViP03ok>c/ooVi^Ko000000?oi^KV00?o0000onKVi_oVi^H0CooVi^H01?l0003oi^KVonKV
i_l00008onKViP04o`000?oVi^Koi^KVo`0000Goi^KV00Co0000onKVi_oVi^Ko0000COoVi^H001?o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko/k>c
onKVi_l00002onKViP03o`000?oVi^Koi^KV04ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0
003oi^KVonKVi_l00005onKViP03o`000?oVi^Koi^KV00;o0000C?oVi^H001?oi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko/k>conKVi_l00002onKV
iP03o`000?oVi^Koi^KV04ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0
003oi^KV00Co00000ooVi^H00ol0003oi^KVonKViP1;onKViP005?oVi^H2o`0000[oi^KV0_l00003
onKViP03o`000?nc/k?o000000?oi^KV00?o0000onKVi_oVi^H0CooVi^H01?l0003oi^KVonKVi_l0
0008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00001_oVi^H00ol0003oi^KVonKViP1;onKViP00
5?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000Coi^KV00?o/k>co`000?l00000
0_oVi^H00ol0003oi^KVonKViP1@onKViP;o00002_oVi^H2o`0000;oi^KV1Ol00002onKViP03o`00
0?oVi^Koi^KV04_oi^KV000ConKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko
00000ooVi^H00onc/k?o0000onKViP02onKViP03o`000?oVi^Koi^KV06Ooi^KV00?o0000onKVi_oV
i^H0BooVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV
00?o000000Go/k>co`000?oVi^Koi^KVo`00001YonKViP03o`000?oVi^Koi^KV04_oi^KV000ConKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP05ok>c
/ooVi^Koi^KVonKVi_l00000F?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?o
i^KV00?o0000onKVi_oVi^H0BooVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003o
i^KVonKVi_l00002onKViP03o`000?oVi^Ko/k>c00?oi^KV00?o0000onKVi_oVi^H0EOoVi^H01?l0
003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0BooVi^H0
01?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03o`000?nc
/k?oi^KV00;oi^KV00?o0000onKVi_oVi^H0EOoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`00
0?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0BooVi^H001Coi^KV0_l0000:onKViP;o00001OoV
i^H01Onc/k?oi^KVonKVi_oVi^Ko000005Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^Hlolc<c1So
i^KV000DonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3o`000004ok>c
/ooVi^Koi^KVo`0005Ooi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKV
iP03o`000?oVi^Koi^KV04_oi^KV000ConKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKV
i_oVi^Ko0000onKVi_l00003onKViP04ok>c/ooVi^Koi^KVo`0005Ooi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H0BooVi^H001?oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co/k>conKVi_oVi^Ko0000F?oV
i^H2o`0000[oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP1;onKViP004ooVi^H0
1?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l000001?nc/k?oi^KV
onKVi_l0001YonKViP03o`000?oVi^Koi^KV04_oi^KV000ConKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04ok>c/ooVi^Koi^KVo`0006Woi^KV00?o
0000onKVi_oVi^H0BooVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKV
i_l00002onKViP07o`000?oVi^Koi^KVonKVi_nc/k?oi^KVo`00001YonKViP03o`000?oVi^Koi^KV
04_oi^KV000DonKViP;o00002_oVi^H2o`0000Coi^KV0_l000001?oVi^Ko/k>conKVi_l0001BonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H3o`0000?oi^KV00?o0000onKV
i_oVi^H0BooVi^H001Coi^KV0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o
000000Coi^KVok>c/ooVi^Ko0000DOoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Ko
i^KVonKVi_l000000ooVi^H01?l0003oi^KVonKVi_l0001=onKViP004ooVi^H01?l0003oi^KVonKV
i_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003o/k>conKVi_l0001A
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01OoVi^H00ol0003oi^KVonKV
iP02o`0004coi^KV000ConKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000
onKVi_l00003onKViP04o`000?nc/k?oi^KVo`00057oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H0
0ol0003oi^KVonKViP05onKViP04o`000?oVi^Koi^KVo`0004goi^KV000ConKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000;oi^KV00?o/k>co`000?oVi^H0
D?oVi^H01?l0003oi^KVonKVi_l00009onKViP04o`000?oVi^Koi^KVonKViPCo00000ooVi^H00ol0
003oi^KVonKViP1;onKViP004ooVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KV
o`000?oVi^Ko00000ooVi^H01?l0003oi^KVok>c/ol0001AonKViP04o`000?oVi^Koi^KVo`0000So
i^KV0_l00003onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000onKVi_oVi^H0BooVi^H001?oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000
onKVi_nc/k?o0000D_oVi^H2o`0000[oi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002onKViP03o`00
0?oVi^Koi^KV04_oi^KV000DonKViP;o00002_oVi^H2o`0000?oi^KV0ol00002onKViP03ok>c/ol0
003oi^KV06Soi^KV00?o0000onKVi_oVi^H0BooVi^H002[oi^KV00?o/k>co`000?oVi^H0J?oVi^H0
0ol0003oi^KVonKViP1;onKViP006_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`00
00?oi^KV00?o/k>conKVi_oVi^H0E_oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002
onKViP03o`000?oVi^Koi^KV04_oi^KV000IonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000
onKVi_oVi^H00_oVi^H00onc/k?oi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co
0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1;onKViP006OoVi^H01?l0003oi^KVonKV
i_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV=Onc/k<SonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00?o0000onKVi_oVi^H00_oVi^H2o`0004coi^KV000IonKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`00
00[oi^KV00Go0000onKVi_oVi^Koi^KVo`00001=onKViP006OoVi^H01?l0003oi^KVonKVi_l00009
onKViP03o`000?oVi^Koi^KV05[oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko0000053oi^KV000IonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l0001LonKViP04o`00
0?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00001@onKViP006_oVi^H2o`0000[o
i^KV00?o0000onKVi_oVi^H0FooVi^H2o`0000Woi^KV0ol0001AonKViP00hooVi^H003?oi^KV0ol0
0002onKViPKo000000Coi^KVo`000?l0003o00000ooVi^H3o`0000;oi^KV00?o0000onKVi_l00000
0_l0001<onKViP?o00000_oVi^H3o`000003onKVi_l0003o000000?o00000_oVi^H6o`000007onKV
i_l0003o0000o`000?oVi^Ko0000onKViP03o`000003onKVi_l0003o000002Goi^KV000donKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP03
onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVonKViP19onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00003
onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKV
i_l0000VonKViP00=?oVi^H00ol0003oi^KVo`000003onKViP03o`000?oVi^Koi^KV00?oi^KV00?o
0000onKVi_oVi^H00ooVi^H00ol0003oi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l00000
C_oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00001?oVi^H0
0ol0003oi^KVonKViP02onKViP04o`000?oVi^Ko0000o`0000;oi^KV00?o0000onKVi_l000009ooV
i^H003Coi^KV0ol00003onKViP?o00000ooVi^H3o`0000?oi^KV0ol00002onKViP05o`000?oVi^Ko
i^KVonKVi_l00000C?oVi^H2o`0000?oi^KV1?l00002onKViP?o00001?oVi^H00ol0003oi^KVonKV
iP02onKViP04o`000?oVi^Ko0000o`0000;oi^KV0_l0000XonKViP00=?oVi^H01?l0003oi^KVonKV
i_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003o
i^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_oVi^H0BOoVi^H00ol0003oi^KVonKViP03
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KV
onKViP02onKViP;o000000Ooi^KVo`000?oVi^Koi^KVo`000?oVi^Ko000002Ooi^KV000donKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0
0002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVonKViP19onKViP04
o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0
0003onKViP03o`000?oVi^Koi^KV00;oi^KV0_l000001OoVi^Ko0000onKVi_oVi^Ko000000;oi^KV
00?o0000onKVi_oVi^H09?oVi^H003?oi^KV1?l00002onKViPGo000000?oi^KVo`000?l000000_l0
0002onKViPCo00000ooVi^H3o`0004goi^KV0ol000001OoVi^Ko0000o`000?l0003oi^KV00Ko0000
0_oVi^H5o`000004onKVi_l0003o0000onKViPKo000000?oi^KVo`000?l000009OoVi^H00>?oi^KV
003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00W_oVi^H3o`00
00Woi^KV0ol0000;onKViP?o00001ooVi^H3o`0000Coi^KV0_l0000HonKViP004ooVi^H2o`0000Co
i^KV00?o0000onKVi_oVi^H00ooVi^H3o`0007goi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Ko
i^KV00;oi^KV00Co0000onKVi_oVi^Ko00005ooVi^H001;oi^KV00Co0000onKVi_oVi^Ko00002_oV
i^H01Ol0003oi^KVonKVi_oVi^Ko000007Ooi^KV1Ol00008onKViP05o`000?oVi^Koi^KVonKVi_l0
00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0
003oi^KVonKVi_l0000GonKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP03ogmoOol0003o
000000;o00000_oVi^H2o`0007Koi^KV00Co0000onKVi_oVi^Ko00002OoVi^H4o`0000_oi^KV0ol0
0008onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko00005ooVi^H001;oi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01?moOgooi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV07Ko
i^KV00?o0000onKVi_l000002OoVi^H00ol0003oi^KVonKViP0;onKViP05o`000?oVi^Koi^KVonKV
i_l000001ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0001Ooi^KV000BonKV
iP04o`000?oVi^Koi^KVo`0000Ooi^KV00CoOgmoo`000?oVi^Ko00000ooVi^H00ol0003oi^KVonKV
iP1gonKViP;o00002_oVi^H00ol0003oi^KVonKViP0:onKViP05o`000?oVi^Koi^KVonKVi_l00000
1_oVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Ko00005ooVi^H001;oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01?moOgooi^KVo`000?l00003onKViP03o`000?oVi^Koi^KV07Soi^KV00?o0000onKV
i_oVi^H02OoVi^H2o`0000_oi^KV0ol00008onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0000HonKV
iP004ooVi^H2o`0000Woi^KV00?oOgmoonKVi_l000000ooVi^H00ol0003oi^KVonKViP2lonKViP00
4ooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H00omoOgoo0000o`000003onKViP03o`00
0?oVi^Koi^KV06_oi^KV00?o0000onKVi_oVi^H0C_oVi^H001;oi^KV00Co0000onKVi_oVi^Ko0000
1ooVi^H01Ol0003oOgmoonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0HooVi^HYo`0001Go
VIVI00?o0000onKVi_oVi^H06?oVi^H001;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?moOgoo
i^KVonKVi_l00002onKViP;o0000K?oVi^H00ol0003oi^KVonKViP0NonKViP03oiVIVOoVi^Koi^KV
02goi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00CoOgmoonKVi_oVi^Ko00000_oVi^H0
0ol0003oi^KVonKViP1[onKViP03o`000?oVi^Koi^KV01koi^KV00?oVIVIonKVi_oVi^H0;OoVi^H0
01;oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01?l0003oOgmoo`000?l00003onKViP03o`000?oV
i^Koi^KV06_oi^KV00?o0000onKVi_oVi^H07OoVi^H00onIVIWoi^KVonKViP0^onKViP004_oVi^H0
1?l0003oi^KVonKVi_l00007onKViP03o`000?oVi^KoOgmo00Coi^KV00?o0000onKVi_oVi^H0F_oV
i^H2o`0000Coi^KV00Co0000onKVi_oVi^Koi^KV1Ol00002onKViP03o`000?oVi^Koi^KV01goi^KV
00?oVIVIonKVi_oVi^H0;_oVi^H001?oi^KV0_l00008onKViP;o000000?oOgmoo`000?l000000_oV
i^H00ol0003oi^KVonKViP1IonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko
00000_oVi^H00ol0003oi^KVonKViP0MonKViP03oiVIVOoVi^Koi^KV02koi^KV000ConKViP;o0000
1?oVi^H00ol0003oi^KVonKViP02onKViP03o`000?moOgoo000000?oi^KV00?o0000onKVi_oVi^H0
FOoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oV
i^H07OoVi^H00onIVIWoi^KVonKViP0^onKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP05
o`000?oVi^KoOgmoonKVi_l000000_oVi^H00ol0003oi^KVonKViP0eonKViPGoOgmo7ooVi^H01?l0
003oi^KVonKVi_l00008onKViP03oiVIVOoVi^Ko000000?oi^KV0_l0000NonKViP03oiVIVOoVi^Ko
i^KV02koi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_moOgooi^KVo`00
0002onKViP;o0000<_oVi^H4ogmoObCoi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oVIVI
onKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H07?oVi^H00onIVIWoi^KVonKViP0_onKViP00
4_oVi^H01?l0003oi^KVonKVi_l00007onKViP;o000000?oOgmoo`000?oVi^H00_oVi^H00ol0003o
i^KVonKViP0aonKViP03ogmoOooVi^Koi^KV02Goi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0
003oVIVIonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H07?oVi^H00onIVIWoi^KVonKViP0_
onKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP04o`000?oVi^Koi^KVogmoO`?oi^KV00?o
0000onKVi_oVi^H0<?oVi^H00omoOgooi^KVonKViP0WonKViP;o00002OoVi^H00ol0003oVIVIo`00
0003onKViP03o`000?oVi^Koi^KV01coi^KV00?oVIVIonKVi_oVi^H0;ooVi^H001;oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVogmoO`03onKViP03o`000?oVi^Koi^KV02ooi^KV00?o
OgmoonKVi_oVi^H0:?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oVIVIo`00
0003onKViP03o`000?oVi^Koi^KV01coi^KV00?oVIVIonKVi_oVi^H0;ooVi^H001?oi^KV0_l0000:
onKViP03o`000?moOgooi^KV00;oi^KV00?o0000onKVi_oVi^H0;ooVi^H00omoOgooi^KVonKViP0W
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_nIVIWoi^KVo`000002onKViP03o`00
0?oVi^Koi^KV01coi^KV00?oVIVIonKVi_oVi^H0;ooVi^H001?oi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00?oi^KV00?o0000ogmoOooVi^H00_oVi^H00ol0003oi^KVonKViP0^onKViP03ogmoOooV
i^Koi^KV02Soi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00onIVIWoi^KVo`000002onKViP03o`00
0?oVi^Koi^KV01_oi^KV00?oVIVIonKVi_oVi^H0<?oVi^H001;oi^KV00Co0000onKVi_oVi^Ko0000
2OoVi^H00ol0003oOgmoonKViP02onKViP03o`000?oVi^Koi^KV02goi^KV00?oOgmoonKVi_oVi^H0
:OoVi^H01?l0003oi^KVonKVi_l00009onKViP03oiVIVOl0003oi^KV00;oi^KV0_l0000LonKViP03
oiVIVOoVi^Koi^KV033oi^KV000BonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00CoOgmoonKVi_oV
i^Koi^KV0_l0000^onKViP03ogmoOooVi^Koi^KV02Woi^KV00Co0000onKVi_oVi^Ko00002_oVi^H0
1OnIVIWo0000onKVi_oVi^Ko000001goi^KV00?oVIVIonKVi_oVi^H0<?oVi^H001;oi^KV00Co0000
onKVi_oVi^Ko00002_oVi^H01Ol0003oOgmoonKVi_oVi^Ko000002koi^KV00?oOgmoonKVi_oVi^H0
:_oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVoiVIVOl000000_oVi^H00ol0
003oi^KVonKViP0KonKViP03oiVIVOoVi^Koi^KV033oi^KV000BonKViP04o`000?oVi^Koi^KVo`00
00_oi^KV00CoOgmoonKVi_oVi^Ko0000;_oVi^H00omoOgooi^KVonKViP0[onKViP;o00002OoVi^H2
o`000005oiVIVOoVi^Koi^KVonKVi_l000007OoVi^H00onIVIWoi^KVonKViP0`onKViP004_oVi^H0
1?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_moOgl00_oVi^H00ol0003oi^KV
onKViP0[onKViP03ogmoOooVi^Koi^KV03Woi^KV00GoVIVIonKVi_oVi^Koi^KVo`00000LonKViP03
oiVIVOoVi^Koi^KV037oi^KV000ConKViP;o00002?oVi^H4o`000004ogmoOooVi^Koi^KVo`0002Co
i^KV2OmoOgl_onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP03o`000?nIVIWo000000;o
i^KV00?o0000onKVi_oVi^H06_oVi^H00onIVIWoi^KVonKViP0aonKViP004ooVi^H2o`0000Coi^KV
00?o0000onKVi_oVi^H00_oVi^H3o`000004ogmoOooVi^Koi^KVo`0002Coi^KV00?oOgmoonKVi_oV
i^H0=?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?nIVIWoi^KVonKVi_l000007?oVi^H0
0onIVIWoi^KVonKViP0aonKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Ko
i^KVonKVi_moOgl00_oVi^H00ol0003oi^KVonKViP0QonKViP03ogmoOooVi^Koi^KV03Goi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H4o`000003oiVIVOoVi^Koi^KV00;o00006ooVi^H00onIVIWoi^KV
onKViP0aonKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP07o`000?oVi^Koi^KVonKVi_l0
003oOgmoonKViP02o`0002;oi^KV00?oOgmoonKVi_oVi^H0=OoVi^H01?l0003oi^KVonKVi_l00007
onKViP05o`000?oVi^Koi^KVo`000?nIVIT00_oVi^H00ol0003oi^KVonKViP0JonKViP03oiVIVOoV
i^Koi^KV037oi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0ol000001?oVi^KoOgmoonKV
i_l0000RonKViP03ogmoOooVi^Koi^KV03Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003o
i^KVo`000?nIVIT2onKViP03o`000?oVi^Koi^KV01Woi^KV00?oVIVIonKVi_oVi^H0<_oVi^H001;o
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H02?l0003oi^KVonKVi_oVi^Ko0000ogmoOooVi^Ko0000
8_oVi^H00omoOgooi^KVonKViP0fonKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l000001?nIVIWo
i^KVonKVi_l0000KonKViP03oiVIVOoVi^Koi^KV03;oi^KV000BonKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV00So0000onKVi_oVi^Koi^KVo`000?moOgooi^KVo`00027oi^KV00?oOgmoonKVi_oVi^H0
>?oVi^H2o`0000_oi^KV00Go0000onKVi_nIVIWoi^KVo`00000KonKViP03oiVIVOoVi^Koi^KV03;o
i^KV000ConKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o000000Coi^KVogmoOooVi^Ko
00008OoVi^H00omoOgooi^KVonKViP0honKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o
000000Coi^KVoiVIVOoVi^Ko00006ooVi^H00onIVIWoi^KVonKViP0bonKViP004_oVi^H01?l0003o
i^KVonKVi_l0000:onKViP05o`000?oVi^KoOgmoonKVi_l000003OoVi^H3o`0000_oi^KV0ol00002
onKViP03ogmoOooVi^Koi^KV00Ooi^KV0ol00009onKViP?o00001?oVi^H2o`0001coi^KV00Co0000
onKVi_oVi^Ko00001ooVi^H02?l0003oi^KVonKVi_oVi^Ko0000oiVIVOoVi^Ko00006ooVi^H00onI
VIWoi^KVonKViP0bonKViP004_oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oVi^KoOgmo
o`0000koi^KV00?o0000onKVi_oVi^H02OoVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_moOgl0
2?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Woi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003o
i^KVonKVi_l0000KonKViP04o`000?oVi^Koi^KVo`0000_oi^KV00?o0000oiVIVOoVi^H00_l0000I
onKViP03oiVIVOoVi^Koi^KV03?oi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00000
1?oVi^KoOgmoo`000?l0000:onKViPGo00002_oVi^H01ol0003oi^KVonKVi_oVi^Ko0000onKVi_mo
Ogl02?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Woi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0
003oi^KVonKVi_l0000KonKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000oiVIVOoVi^Ko0000
6_oVi^H00onIVIWoi^KVonKViP0conKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP08o`00
0?oVi^Koi^KVonKVi_l0003oi^KVogmoOol0000;onKViP04o`000?oVi^Koi^KVo`0000_oi^KV1?l0
00000ooVi^KoOgmoonKViP09onKViP?o00002_oVi^H00ol0003oi^KVonKViP02onKViP04o`000?oV
i^Koi^KVo`0001_oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H4o`0000;oi^KV00?oVIVIo`000?oV
i^H06OoVi^H00onIVIWoi^KVonKViP0conKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP08
o`000?oVi^Koi^KVonKVi_l0003oi^KVogmoOol0000<onKViP03o`000?oVi^Ko000000_oi^KV00?o
0000onKVi_oVi^H00_oVi^H00omoOgooi^KVonKViP07onKViP05o`000?oVi^Koi^KVonKVi_l00000
2OoVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0001_oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H00ol0003oi^KVonKViP03onKViP03oiVIVOl0003oi^KV01Woi^KV00?oVIVIonKV
i_oVi^H0<ooVi^H001?oi^KV0_l00009onKViP?o00000_oVi^H00omoOgoo0000onKViP0<onKViP;o
00003?oVi^H01?l0003oi^KVonKVi_moOgl:onKViP05o`000?oVi^Koi^KVonKVi_l000002?oVi^H2
o`0000Coi^KV00Co0000onKVi_oVi^Ko00007?oVi^H2o`0000Soi^KV1Ol000000ooVi^KoVIVIo`00
000JonKViP03oiVIVOoVi^Koi^KV03?oi^KV000SonKViP03ogmoOol0003oi^KV00goi^KV00?o0000
onKVi_oVi^H02ooVi^H2o`000003ogmoOooVi^Koi^KV00Woi^KV0ol0000:onKViP03o`000?oVi^Ko
i^KV00?oi^KV0_l0000MonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H0
0onIVIWo0000onKViP0HonKViP03oiVIVOoVi^Koi^KV03Coi^KV000TonKViP03ogmoOooVi^Koi^KV
013oi^KV3?moOglmonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00So0000onKVi_oVi^Koi^KVo`00
0?oVi^KoVIVIo`0001Koi^KV1?nIVITfonKViP009?oVi^H00omoOgooi^KVonKViP09onKViPOoOgmo
BOoVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00onI
VIWo0000onKViP07onKViPgoVIVI>_oVi^H001_oi^KV2Ol0000<ogmoOc;o00007_oVi^H01?l0003o
i^KVonKVi_l00007onKViPCo00000ooVi^H:oiVIVDOoi^KV000TonKViP03o`000?oVi^Koi^KV05Wo
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Koi^KV
04koi^KV0020onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00?o0000onKVi_oVi^H0E?oVi^H0087o
i^KV0_l0000:onKViP;o0000E?oVi^H00>?oi^KV003SonKViP00;ooVi^H2o`000004onKVi_l0003o
0000o`0000;oi^KV0_l00003onKViP?o00000_oVi^H2o`000005onKVi_l0003o0000o`000?oVi^H0
0ol0001BonKViP?o00000ooVi^H5o`000004onKVi_l0003o0000o`0000;oi^KV0ol000001?oVi^Ko
0000o`000?l0000^onKViP00;ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Co0000onKV
i_oVi^Ko00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV00Go0000onKVi_oVi^Koi^KV
o`00001DonKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003o
i^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_oVi^H0;OoVi^H002ooi^KV00Go0000onKV
i_oVi^Koi^KVo`000002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00Co0000onKVi_oVi^Koi^KV
1Ol00003onKViP03o`000?oVi^Koi^KV05;oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KV
onKViP03onKViP03o`000?oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00000_onKViP00
;ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0
003oi^KVonKViP02onKViP03o`000?oVi^Ko000000Coi^KV00?o0000onKVi_oVi^H0D_oVi^H3o`00
00?oi^KV0ol00003onKViP?o00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000002ooi^KV000_onKV
iP05o`000?oVi^Ko0000onKVi_l000000_oVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko
0000onKVi_l00002onKViP03o`000?oVi^Ko000000;oi^KV00Go0000onKVi_l0003oi^KVo`00001B
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H02_l0003oi^KVonKV
i_l0003oi^KVo`000?oVi^Ko0000onKVi_l0000_onKViP00;ooVi^H2o`000003onKVi_l0003o0000
00;oi^KV00[o0000onKVi_oVi^Ko0000onKVi_l0003oi^KVo`000?oVi^Ko00000ooVi^H02Ol0003o
i^KVonKVi_oVi^Ko0000onKVi_l0003oi^KVo`00001BonKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00;o000000?oi^KVo`00
0?l00000;ooVi^H002ooi^KV00Co0000onKVi_oVi^Koi^KV1Ol000000ooVi^Ko0000o`000005o`00
00;oi^KV0_l00003onKViPGo0000DOoVi^H4o`0000;oi^KV1Ol000000ooVi^Ko0000o`000002o`00
00;oi^KV00Co0000onKVi_oVi^Koi^KV0_l0000^onKViP00hooVi^H00>?oi^KV003SonKViP00hooV
i^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV000gonKViP?o00002OoVi^H3o`0000[oi^KV0ol0
0007onKViP?o00001?oVi^H2o`0003koi^KV0ol00009onKViP?o00002ooVi^H3o`0000Ooi^KV0ol0
0004onKViP;o00005OoVi^H003Soi^KV00?o0000onKVi_oVi^H01ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Soi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP03o`000?oVi^Koi^KV00;oi^KV
00Co0000onKVi_oVi^Ko0000?_oVi^H00ol0003oi^KVonKViP07onKViP05o`000?oVi^Koi^KVonKV
i_l000002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H00_oVi^H0
1?l0003oi^KVonKVi_l0000DonKViP00=OoVi^H5o`0000Soi^KV00Go0000onKVi_oVi^Koi^KVo`00
0008onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP02onKViP04o`00
0?oVi^Koi^KVo`0003_oi^KV1Ol00008onKViP05o`000?oVi^Koi^KVonKVi_l000002OoVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0
000DonKViP00=OoVi^H01?l0003oi^KVonKVi_l00009onKViPCo00002_oVi^H3o`0000Soi^KV00?o
0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000konKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV1?l0000;onKViP?o00002?oVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`00
01Coi^KV000fonKViP03o`000?oVi^Ko000000Woi^KV00?o0000onKVi_oVi^H02_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000l
onKViP03o`000?oVi^Ko000000Woi^KV00?o0000onKVi_oVi^H02ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Ooi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000DonKViP00=ooV
i^H2o`0000[oi^KV00?o0000onKVi_oVi^H02OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV
0_l00004onKViP04o`000?oVi^Koi^KVo`0003goi^KV0_l0000:onKViP03o`000?oVi^Koi^KV00[o
i^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP;o00001?oVi^H01?l0003oi^KVonKVi_l0000D
onKViP00>?oVi^H00ol0003oi^KVonKViP09onKViP;o00002_oVi^H3o`0000Soi^KV00?o0000onKV
i_oVi^H00ooVi^H2o`0003ooi^KV00?o0000onKVi_oVi^H02OoVi^H2o`0000_oi^KV0ol00008onKV
iP03o`000?oVi^Koi^KV00?oi^KV0_l0000EonKViP00hooVi^H002?oi^KV2?l0000eoda<C0;o0000
:ooVi^H2o`000003ofIVI_l0003o000003[o00005ooVi^H002Coi^KV00Co0000onKVi_oVi^Ko0000
0ooVi^H01?m<C4coi^KVonKVi_l00002onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0
003oi^KVonKVi_l00002onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKV
i_l00002onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0;OoVi^H01?mVIVKoi^KVonKVi_l0
0002onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00002onKViP05
o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00002onKViP05o`000?oVi^Ko
i^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP0FonKViP00:ooVi^H00om<C4co
i^KVonKViP1QonKViP03ofIVI_oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H0BooVi^H002_oi^KV
00?oC4a<onKVi_oVi^H0HOoVi^H00omVIVKoi^KVonKViP03onKViP03o`000?oVi^Koi^KV04_oi^KV
000ZonKViP03oda<C?l0003oi^KV06?oi^KV00?oIVIVonKVi_oVi^H00_oVi^H00ol0003oi^KVonKV
iP1;onKViP005?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV1Ol00000
0ooVi^KoC4a<o`00001BonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000_oVi^H2
o`000003ofIVI_l0003o000000;oi^KV00?o0000onKVi_oVi^H0BooVi^H001?oi^KV00Co0000onKV
i_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP07o`000?oVi^Koi^KVo`000?oVi^KoC4a<
o`00001AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0
003oIVIVonKVi_l00002onKViP03o`000?oVi^Koi^KV04_oi^KV000ConKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00?o0000onKVi_oVi^H00ooVi^H01_l0003oi^KVonKVi_oVi^KoC4a<o`00057oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03ofIVI_oVi^Koi^KV
00;oi^KV00?o0000onKVi_oVi^H0BooVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0
003oi^KVonKViP04onKViP05o`000?oVi^Koi^KVoda<C?l00000DOoVi^H01?l0003oi^KVonKVi_l0
0008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?oIVIVo`000?oVi^H00_oVi^H2o`0004coi^KV
000ConKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04
o`000?m<C4coi^KVo`00057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H02_l0003oi^KVonKVi_l0
003oi^KVo`000?oVi^KoIVIVonKVi_l00002onKViP03o`000?oVi^Koi^KV04_oi^KV000ConKViP04
o`000?oVi^Koi^KVo`0000Soi^KV0_l00003onKViP08o`000?oVi^Koi^KVonKVi_l0003oC4a<onKV
i_l0001AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002
onKViP05ofIVI_l0003oi^KVonKVi_l00000COoVi^H001Coi^KV0_l0000:onKViP03o`000?oVi^Ko
i^KV00;oi^KV0ol000001?oVi^KoC4a<onKVi_l0001BonKViP;o00002_oVi^H2o`0000?oi^KV0_l0
00001OmVIVKoi^KVonKVi_oVi^Ko000004goi^KV000YonKViP03oda<C?oVi^Ko000006Goi^KV00Go
IVIVonKVi_oVi^Koi^KVo`00001=onKViP005?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oV
i^H3o`0000Coi^KV0ol000000om<C4coi^KVo`00001BonKViP;o00001?oVi^H00ol0003oi^KVonKV
iP03onKViP;o00001?oVi^H00ol0003oIVIVo`000002onKViP03o`000?oVi^Koi^KV04_oi^KV000C
onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oC4a<onKV
i_oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKV
iP05ofIVI_oVi^Koi^KVonKVi_l00000COoVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H0
1?l0003oi^KVonKVi_oVi^H4o`000004oda<C?oVi^Koi^KVo`00057oi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01Ol0003oi^KVonKVi_l0003oi^KV00?o000000CoIVIVo`000?oVi^Koi^KV0_l0001<
onKViP004ooVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000_oV
i^H01Ol0003oC4a<onKVi_oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003o
i^KVonKVi_l0003oi^KVo`0000;oi^KV00Go0000ofIVI_oVi^Koi^KVo`00001=onKViP004ooVi^H0
1?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_l0003oC4a<
0_oVi^H00ol0003oi^KVonKViP1?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01?l0003oi^KVo`000?mVIVH2onKViP03o`000?oVi^Koi^KV04_oi^KV000ConKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV0_l00005onKViP;o000000CoC4a<onKVi_oVi^Ko0000DOoV
i^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l000001?mVIVKo
i^KVonKVi_l0001=onKViP005?oVi^H2o`0000[oi^KV00?o0000onKVi_oVi^H01?oVi^H01Om<C4co
i^KVonKVi_oVi^Ko000005;oi^KV0_l0000:onKViP;o00001OoVi^H01Ol0003oIVIVonKVi_oVi^Ko
000004goi^KV000DonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H2o`00
0005oda<C?oVi^Koi^KVonKVi_l00000D_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2
o`0000?oi^KV0ol000001?mVIVKoi^KVonKVi_l0001=onKViP004ooVi^H01?l0003oi^KVonKVi_l0
0009onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Om<C4co0000onKVi_oVi^Ko0000057o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co
IVIVonKVi_oVi^Ko0000COoVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000;oi^KV00GoC4a<o`000?oVi^Koi^KVo`00001AonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03ofIVI_oVi^Koi^KV00;o0000
C?oVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H3o`000005
oda<C?oVi^Koi^KVonKVi_l00000DOoVi^H01?l0003oi^KVonKVi_l00008onKViP05o`000?oVi^Ko
i^KVo`000?oVi^H01?l000001?oVi^KoIVIVonKVi_l0001=onKViP004ooVi^H01?l0003oi^KVonKV
i_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Om<C4coi^KVonKVi_oVi^Ko0000
057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Coi^KV
00?oIVIVonKVi_l00000COoVi^H001?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0000Coi^KV
00?o0000oda<C?oVi^H00ooVi^H00ol0003oi^KVonKViP1?onKViP04o`000?oVi^Koi^KVo`0000So
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H01ol0003oi^KVonKVi_oVi^KoIVIVonKVi_l00000COoV
i^H001Coi^KV0_l0000:onKViP03o`000?oVi^Koi^KV00?oi^KV00?oC4a<o`000?oVi^H00_oVi^H0
0ol0003oi^KVonKViP1@onKViP;o00002_oVi^H2o`0000Coi^KV0_l000001?oVi^KoIVIVonKVi_l0
001=onKViP005?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000?oi^KV00?o0000
oda<C?l000000ooVi^H00ol0003oi^KVonKViP1@onKViP;o00001?oVi^H00ol0003oi^KVonKViP03
onKViP;o00000ooVi^H3o`000004onKVi_mVIVKoi^KVo`0004goi^KV000ConKViP04o`000?oVi^Ko
i^KVo`0000Woi^KV00Wo0000onKVi_oVi^Koi^KVo`000?oVi^KoC4a<onKVi_l000000_oVi^H00ol0
003oi^KVonKViP1?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKV
i_l00003onKViP04o`000?mVIVKoi^KVo`0004goi^KV000ConKViP04o`000?oVi^Koi^KVo`0000Wo
i^KV00Wo0000onKVi_oVi^Koi^KVo`000?oVi^KoC4a<onKVi_l000000_oVi^H00ol0003oi^KVonKV
iP1?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP04o`000?oVi^KoIVIVo`0004goi^KV000ConKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000
onKVi_oVi^H00_oVi^H00om<C4co0000o`000003onKViP03o`000?oVi^Koi^KV04ooi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000_oVi^H00omVIVKo0000
o`00001<onKViP004ooVi^H01?l0003oi^KVonKVi_l00009onKViP06o`000?oVi^Koi^KVonKVi_l0
003oC4a<0_oVi^H01?l0003oi^KVonKVi_l0001AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^KoIVIVo`0004goi^KV000ConKViP04
o`000?oVi^Koi^KVo`0000Soi^KV0_l00003onKViP05o`000?m<C4coi^KVonKVi_l000000_oVi^H0
0ol0003oi^KVonKViP1?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000
onKVi_l00003onKViP04o`000?oVi^KoIVIVo`0004goi^KV000DonKViP;o00002_oVi^H00ol0003o
i^KVonKViP02onKViP03oda<C?l0003o000000?oi^KV00?o0000onKVi_oVi^H0D?oVi^H2o`0000[o
i^KV0_l00003onKViP?o00000_oVi^H00omVIVKo0000onKViP1<onKViP006_oVi^H2o`0000Coi^KV
00Ko0000onKVi_oVi^Koi^KVo`000?m<C4`3o`0000;oi^KV00?o0000onKVi_oVi^H0E_oVi^H2o`00
00Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?oIVIVo`000?oVi^H0C?oVi^H001Wo
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Om<C4co0000onKVi_oVi^Ko000000;oi^KV00?o0000
onKVi_oVi^H0EOoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o
IVIVonKVi_oVi^H0BooVi^H001Woi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00om<C4coi^KVo`00
0004onKViP03o`000?oVi^Koi^KV05Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KV
onKViP02onKViP03ofIVI_oVi^Koi^KV04_oi^KV000IonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV
00CoC4a<onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00?o0000onKVi_oVi^H00_oVi^HfofIVIQSoi^KV000IonKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Koi^KV05Goi^KV00Co0000
onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Koi^KV04_oi^KV000I
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00001JonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV0_l0001BonKViP006_oVi^H2o`0000Woi^KV0ol0001LonKViP;o0000
2_oVi^H00ol0003oi^KVonKViP1@onKViP00hooVi^H00>?oi^KV000fonKViPCo00001?oVi^H2o`00
00;oi^KV0ol00003onKViPGo0000COoVi^H5o`000006onKVi_l0003o0000o`000?oVi^Ko00000ooV
i^H2o`0000;oi^KV0_l000000ooVi^Ko0000o`000004o`0000Coi^KV0ol0000WonKViP00=ooVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0
0ooVi^H01?l0003oi^KVonKVi_l0001>onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko
00001OoVi^H01?l0003oi^KVonKVi_l0000VonKViP00=ooVi^H01?l0003oi^KVonKVi_l00002onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1?
onKViP03o`000?oVi^Koi^KV00?oi^KV00Ko0000onKVi_l0003o0000onKVi_l00005onKViPGo0000
0_oVi^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV02Coi^KV000gonKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000?oi^KV00?o0000onKVi_oV
i^H0CooVi^H3o`0000?oi^KV00Ko0000onKVi_l0003o0000onKVi_l00006onKViP03o`000?oVi^Ko
000000?oi^KV0ol00004onKViP;o00009ooVi^H003Ooi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
1?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0
CooVi^H00ol0003oi^KVonKViP03onKViP;o000000Coi^KVo`000?oVi^Ko00001_oVi^H00ol0003o
i^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H09ooVi^H003Oo
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H0CooVi^H01?l0003oi^KVonKVi_l00002onKViP;o0000
00Goi^KVo`000?oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H01?l0
003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0002Koi^KV000fonKViPCo00000_oVi^H3
o`000003onKVi_l0003o000000Co00000_oVi^H3o`0004ooi^KV1Ol000001?oVi^Ko0000o`000?oV
i^H3o`0000;oi^KV0ol00002onKViP;o00000ooVi^H4o`0000Coi^KV0ol0000VonKViP00hooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV002QonKViP?o0000
2OoVi^H3o`0000_oi^KV0ol00007onKViP?o00001?oVi^H2o`0001Goi^KV000ConKViP;o00001?oV
i^H00ol0003oi^KVonKViP03onKViP?o0000P?oVi^H00ol0003oi^KVonKViP07onKViP05o`000?oV
i^Koi^KVonKVi_l000002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oV
i^H00_oVi^H01?l0003oi^KVonKVi_l0000DonKViP004_oVi^H01?l0003oi^KVonKVi_l0000:onKV
iP05o`000?oVi^Koi^KVonKVi_l00000N_oVi^H5o`0000Soi^KV00Go0000onKVi_oVi^Koi^KVo`00
0009onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H00ol0003oi^KVonKViP02onKViP04o`00
0?oVi^Koi^KVo`0001Coi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Koi^KV2OlI6AUjonKViP04
o`000?oVi^Koi^KVo`0000Woi^KV1?l0000;onKViP?o00002?oVi^H00ol0003oi^KVonKViP02onKV
iP04o`000?oVi^Koi^KVo`0001Coi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co0000
onKVi_oVi^Ko00000ooVi^H00olI6AWoi^KVonKViP1ionKViP03o`000?oVi^Ko000000Woi^KV00?o
0000onKVi_oVi^H02ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00?o0000onKVi_oVi^H0
0_oVi^H01?l0003oi^KVonKVi_l0000DonKViP004_oVi^H01?l0003oi^KVonKVi_l00008onKViP03
o`000?oVi^Ko000000?oi^KV00?o6ATIonKVi_oVi^H0N_oVi^H2o`0000[oi^KV00?o0000onKVi_oV
i^H02_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV0_l00004onKViP04o`000?oVi^Koi^KV
o`0001Coi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00003onKViP03oaTI6OoVi^Ko
i^KV07_oi^KV00?o0000onKVi_oVi^H02OoVi^H2o`0000_oi^KV0ol00008onKViP03o`000?oVi^Ko
i^KV00?oi^KV0_l0000EonKViP004ooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`00
00?oi^KV00?o0000oaTI6OoVi^H0K_oVi^H00ol0003oi^KVonKViP1;onKViP004_oVi^H01?l0003o
i^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003o6ATIonKViP1V
onKViP;o000000?o<c<co`000?l00000>_l0000GonKViP004_oVi^H01?l0003oi^KVonKVi_l0000;
onKViP05o`000?oVi^Koi^KVo`000?lI6AT0JOoVi^H01?lc<c?oi^KVonKVi_l00002onKViP05o`00
0?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00002onKViP05o`000?oVi^Koi^KV
onKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00002onKViP05o`000?oVi^Koi^KVonKVi_l00000
0_oVi^H01?l0003oi^KVonKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP0FonKViP004_oVi^H01?l0003oi^KVonKVi_l0000;
onKViP05o`000?oVi^Koi^KVo`000?lI6AT0JOoVi^H00olc<c?oi^KVonKViP03onKViP03o`000?oV
i^Koi^KV04_oi^KV000BonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l00003onKViP03o`000?lI
6AWoi^KV06Soi^KV00?o<c<conKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP1;onKViP004_oVi^H0
1?l0003oi^KVonKVi_l00007onKViP03o`000?oVi^Koi^KV00Coi^KV00?o0000oaTI6OoVi^H0JOoV
i^H00olc<c?oi^KVonKViP02onKViP03o`000?oVi^Koi^KV04_oi^KV000ConKViP;o00002?oVi^H5
o`0000;oi^KV00?o0000onKVi_lI6AT08_oVi^H00olI6AWoi^KVonKViP0bonKViP;o00001?oVi^H0
0ol0003oi^KVonKViP03onKViP;o00000_oVi^H2o`000003oc<c<ol0003o000000;oi^KV00?o0000
onKVi_oVi^H0BooVi^H001?oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKV
iP03o`000?oVi^Ko6ATI02;oi^KV00?o6ATIonKVi_oVi^H0<OoVi^H01?l0003oi^KVonKVi_l00008
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000oc<c<ooVi^Ko00000_oVi^H00ol0003oi^KV
onKViP1;onKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l0
00000_oVi^H00ol0003oi^KVoaTI6@0QonKViP;o6ATI3_oVi^H9oaTI6Acoi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03oc<c<ooVi^Koi^KV00;oi^KV00?o0000
onKVi_oVi^H0BooVi^H001;oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000;oi^KV00?o0000onKVi_lI6AT08OoVi^H00olI6AWoi^KVoaTI6@0=onKViP03oaTI6OoV
i^Koi^KV02;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03
oc<c<ol0003oi^KV00;oi^KV0_l0001<onKViP004_oVi^H01?l0003oi^KVonKVi_l00007onKViPCo
00000ooVi^H00ol0003oi^KVoaTI6@0PonKViP04oaTI6OoVi^Koi^KVoaTI6@goi^KV00?o6ATIonKV
i_oVi^H08_oVi^H01?l0003oi^KVonKVi_l00008onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000
onKVi_lc<c?oi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0BooVi^H001;oi^KV00Co0000onKVi_oV
i^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Ko6ATI023oi^KV00Co6ATIonKV
i_oVi^Ko6ATI3?oVi^H00olI6AWoi^KVonKViP0SonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00002onKViP05oc<c<ol0003oi^KVonKVi_l00000COoVi^H001;o
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP03onKViP04o`000?oVi^Koi^KV
oaTI6Akoi^KV00Go6ATIonKVi_oVi^Koi^KVoaTI6@0<onKViP03oaTI6OoVi^Koi^KV02Coi^KV0_l0
000:onKViP;o00000ooVi^H2o`000005oc<c<ooVi^Koi^KVonKVi_l00000COoVi^H001?oi^KV0_l0
000:onKViP;o00000ooVi^H01?l0003oi^KVonKVi_lI6ATNonKViP03oaTI6OoVi^Koi^KV00;oi^KV
00?o6ATIonKVi_oVi^H02OoVi^H00olI6AWoi^KVonKViP0TonKViP;o00001?oVi^H00ol0003oi^KV
onKViP03onKViP;o00001?oVi^H00ol0003o<c<co`000002onKViP03o`000?oVi^Koi^KV04_oi^KV
000ConKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Koi^KV00;oi^KV00Co
0000onKVi_oVi^Ko6ATI7OoVi^H00olI6AWoi^KVonKViP03onKViP03oaTI6OoVi^Koi^KV00Woi^KV
00?o6ATIonKVi_oVi^H08ooVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`00
00Coi^KV00Go<c<conKVi_oVi^Koi^KVo`00001=onKViP004_oVi^H01?l0003oi^KVonKVi_l00009
onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko6ATI7OoVi^H00olI6AWoi^KVonKV
iP03onKViP03oaTI6OoVi^Koi^KV00Soi^KV00?o6ATIonKVi_oVi^H09?oVi^H01?l0003oi^KVonKV
i_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H00ol000001Olc<c?o0000onKVi_oVi^Ko0000
04goi^KV000BonKViP04o`000?oVi^Koi^KVo`0000[oi^KV00Go0000onKVi_oVi^Koi^KVo`000002
onKViP03oaTI6OoVi^Koi^KV01_oi^KV00?o6ATIonKVi_oVi^H00ooVi^H00olI6AWoi^KVonKViP08
onKViP03oaTI6OoVi^Koi^KV02Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKV
i_l0003oi^KVo`0000;oi^KV00Co<c<conKVi_oVi^Koi^KV0_l0001<onKViP004_oVi^H01?l0003o
i^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00olI6AWoi^KVonKViP0J
onKViP03oaTI6OoVi^Koi^KV00Goi^KV00?o6ATIonKVi_oVi^H01ooVi^H00olI6AWoi^KVonKViP0T
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KV
o`000?lc<c<2onKViP03o`000?oVi^Koi^KV04_oi^KV000BonKViP04o`000?oVi^Koi^KVo`0000_o
i^KV00Co0000onKVi_oVi^Ko00000ooVi^H00olI6AWoi^KVonKViP0IonKViP03oaTI6OoVi^Koi^KV
00Goi^KV00?o6ATIonKVi_oVi^H01ooVi^H00olI6AWoi^KVonKViP0TonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Co0000onKVi_oVi^Ko00000ooVi^H2o`000004oc<c<ooVi^Koi^KVo`0004goi^KV
000BonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP05
o`000?oVi^Koi^KVonKVi_lI6AT06_oVi^H00olI6AWoi^KVonKViP06onKViP03oaTI6OoVi^Koi^KV
00Ooi^KV00?o6ATIonKVi_oVi^H09OoVi^H2o`0000[oi^KV0_l00005onKViP05o`000?lc<c?oi^KV
onKVi_l00000COoVi^H001?oi^KV0_l00008onKViPGo00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko
6ATI01[oi^KV00?o6ATIonKVi_oVi^H01_oVi^H00olI6AWoi^KVonKViP06onKViP03oaTI6OoVi^Ko
i^KV03[oi^KV00Co<c<conKVi_oVi^Ko0000COoVi^H001?oi^KV0_l00004onKViP03o`000?oVi^Ko
i^KV00;oi^KV0ol00003onKViP05o`000?oVi^Koi^KVonKVi_lI6AT06OoVi^H00olI6AWoi^KVonKV
iP08onKViP03oaTI6OoVi^Koi^KV00Goi^KV00?o6ATIonKVi_oVi^H09_oVi^H2o`0000Coi^KV00?o
0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol000001?lc<c?oi^KVonKVi_l0001=onKViP004_oV
i^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko6ATI01Woi^KV00?o6ATIonKVi_oVi^H02?oVi^H00olI6AWoi^KVonKViP05onKV
iP03oaTI6OoVi^Koi^KV02Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0
003oi^KVo`0000?oi^KV00Co<c<conKVi_oVi^Ko0000COoVi^H001;oi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVoaTI6@0H
onKViP03oaTI6OoVi^Koi^KV00Woi^KV00?o6ATIonKVi_oVi^H01OoVi^H00olI6AWoi^KVonKViP0U
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03
oc<c<ooVi^Koi^KV00;o0000C?oVi^H001;oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H3o`0000?o
i^KV00?o0000onKVi_oVi^H00_oVi^H00olI6AWoi^KVonKViP0EonKViP03oaTI6OoVi^Koi^KV00Wo
i^KV00?o6ATIonKVi_oVi^H01?oVi^H00olI6AWoi^KVonKViP0VonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Go0000onKVi_oVi^Ko0000onKViP04o`000004onKVi_lc<c?oi^KVo`0004goi^KV000B
onKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`00
0?oVi^Koi^KV00;oi^KV00?o6ATIonKVi_oVi^H05?oVi^H00olI6AWoi^KVonKViP0;onKViP03oaTI
6OoVi^Koi^KV00?oi^KV00?o6ATIonKVi_oVi^H09_oVi^H01?l0003oi^KVonKVi_l00008onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00001?oVi^H00olc<c?oi^KVo`00001=onKViP004_oVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKV
iP02onKViP03oaTI6OoVi^Koi^KV01Coi^KV00?o6ATIonKVi_oVi^H02ooVi^H00olI6AWoi^KVonKV
iP03onKViP03oaTI6OoVi^Koi^KV02Koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KV
onKVi_l00002onKViP07o`000?oVi^Koi^KVonKVi_lc<c?oi^KVo`00001=onKViP004ooVi^H2o`00
00Woi^KV0ol00003onKViP03o`000?oVi^Koi^KV00;oi^KV00?o6ATIonKVi_oVi^H04ooVi^H00olI
6AWoi^KVonKViP0<onKViP03oaTI6OoVi^Koi^KV00?oi^KV00?o6ATIonKVi_oVi^H09ooVi^H2o`00
00[oi^KV0_l00004onKViP;o000000Coi^KVoc<c<ooVi^Ko0000COoVi^H001?oi^KV0_l00004onKV
iP03o`000?oVi^Koi^KV00;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV00?o6ATIonKV
i_oVi^H04ooVi^H00olI6AWoi^KVonKViP0<onKViP03oaTI6OoVi^Koi^KV00;oi^KV00?o6ATIonKV
i_oVi^H0:?oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol000001?oV
i^Ko<c<conKVi_l0001=onKViP004_oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Ko
i^KVonKVi_l000001?oVi^H00olI6AWoi^KVonKViP06onKViP?o00002OoVi^H00olI6AWoi^KVo`00
0002o`0000coi^KV00Go6ATIo`000?l0003oi^KVoaTI6@07onKViP?o00001?oVi^H2o`0001Woi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000
oc<c<ooVi^Ko0000COoVi^H001;oi^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKV
i_l00005onKViP03oaTI6OoVi^Koi^KV00Koi^KV00?o0000onKVi_oVi^H01ooVi^H00olI6AWoi^KV
o`000003onKViP03o`000?oVi^Koi^KV00Soi^KV00Ko0000oaTI6OoVi^Koi^KVo`000?lI6AT8onKV
iP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko00006?oVi^H01?l0003oi^KVonKVi_l0
0008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KVoc<c<`02o`0004co
i^KV000BonKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00002onKViP03o`000?oVi^Koi^KV00?o
i^KV00?o6ATIonKVi_oVi^H00ooVi^H5o`0000Soi^KV00?o6ATIonKVi_l000000ooVi^H00ol0003o
i^KVonKViP08onKViP06o`000?lI6AWoi^KVonKVi_l0003o6ATI2?oVi^H00ol0003oi^KVonKViP02
onKViP04o`000?oVi^Koi^KVo`0001Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KV
onKVi_l00002onKViP?o00000_oVi^H00olc<c?o0000onKViP1<onKViP004_oVi^H01?l0003oi^KV
onKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP03onKV
iP03oaTI6OoVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00olI6AWoi^KVonKViP04
o`0000coi^KV00Go6ATIo`000?l0003oi^KVoaTI6@08onKViP03o`000?oVi^Koi^KV00;oi^KV00Co
0000onKVi_oVi^Ko00006?oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`00
0?oVi^Ko00000ooVi^H01?l0003oi^KVoc<c<ol0001=onKViP004_oVi^H01?l0003oi^KVonKVi_l0
0007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP03onKViP03oaTI
6OoVi^Koi^KV00Coi^KV00?o0000onKVi_l000002?oVi^H01?lI6AWoi^KVonKVi_l0000>onKViP05
o`000?oVi^Ko6ATIonKVi_lI6AT02OoVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KV
o`0001Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?o
i^KV00Co0000onKVi_lc<c?o0000COoVi^H001?oi^KV0_l00009onKViP?o00000ooVi^H00ol0003o
i^KVonKViP03onKViP03oaTI6OoVi^Koi^KV00Goi^KV0_l00007onKViP03oaTI6OoVi^Koi^KV00;o
i^KV00?o0000onKVi_oVi^H02ooVi^H01Ol0003oi^KVoaTI6OoVi^Ko6ATI00Soi^KV0_l00004onKV
iP04o`000?oVi^Koi^KVo`0001Woi^KV0_l0000:onKViP;o00000ooVi^H3o`0000;oi^KV00?o<c<c
o`000?oVi^H0C?oVi^H002Coi^KV00?o0000onKVi_oVi^H00ooVi^H00olI6AWoi^KVonKViP06onKV
iP03o`000?oVi^Koi^KV00Goi^KV00?o6ATIonKVi_oVi^H00ooVi^H2o`0000coi^KV00Co0000oaTI
6Ol0003o6ATI2OoVi^H00ol0003oi^KVonKViP03onKViP;o00008?oVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o<c<co`000?oVi^H0C?oVi^H002Coi^KV00?o0000onKV
i_oVi^H01?oVi^H00olI6AWoi^KVonKViP09onKViPCo6ATI5OoVi^H00olI6AWoi^KVoaTI6@0`onKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00olc<c?oi^KVonKViP1;
onKViP009?oVi^H00ol0003oi^KVonKViP04onKViP04oaTI6OoVi^Koi^KVonKViPSo6ATI6_oVi^H0
0olI6AWoi^KVonKViP0_onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oV
i^H00olc<c?oi^KVonKViP1;onKViP006ooVi^H@o`0000Co6ATI8_l000000olI6AWo0000o`00000?
o`00023oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViSKo<c<c6?oV
i^H002Coi^KV00?o0000onKVi_oVi^H0G?oVi^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oV
i^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0BooVi^H008?oi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H2o`0005;oi^KV0024onKViP;o00002_oVi^H00ol0003oi^KVonKViP1@onKViP00hooVi^H0037o
i^KV0_l00002onKViP?o00000_oVi^H00ol0003oi^KVo`000002o`0000?oi^KV0ol00003onKViP?o
0000CooVi^H4o`0000;oi^KV1Ol00003onKViP;o00000_oVi^H2o`000003onKVi_l0003o000000Co
00001?oVi^H3o`0002Ooi^KV000`onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oV
i^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP1=onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oV
i^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko0000
1OoVi^H01?l0003oi^KVonKVi_l0000VonKViP00;ooVi^H00ol0003oi^KVonKViP04onKViP03o`00
0?oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`000005onKViP03o`000?oVi^Koi^KV00?o
i^KV00?o0000onKVi_oVi^H0COoVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV
00;oi^KV00?o0000onKVi_oVi^H00ooVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H01_oVi^H00ol0
003oi^KVonKViP0TonKViP00;ooVi^H00ol0003oi^KVonKViP04onKViP?o00000_oVi^H01Ol0003o
i^KVonKVi_oVi^Ko000000?oi^KV0_l00004onKViP;o0000D?oVi^H01?l0003oi^KVonKVi_l00002
onKViP?o00000_oVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Ko000000?oi^KV0ol00004
onKViP;o00009ooVi^H002ooi^KV00?o0000onKVi_oVi^H01?oVi^H01_l0003oi^KVonKVi_l0003o
i^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H00ol0003oi^KVonKViP1@onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP04onKViP03
o`000?oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP0WonKV
iP00<?oVi^H01?l0003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooV
i^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oV
i^H0COoVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000
onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00009_oVi^H0037oi^KV0ol000000ooVi^Ko0000o`000002o`0000?oi^KV
0ol00004onKViP?o00000ooVi^H3o`0004koi^KV1?l00002onKViPGo00000ooVi^H3o`0000;oi^KV
0_l00003onKViPCo00001?oVi^H3o`0002Koi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00
hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV001JonKV
iPCo0000QOoVi^H005_oi^KV0_l00026onKViP00FooVi^H2o`0008Koi^KV000oonKViPGo00000_oV
i^H4o`0000Woi^KV1Ol00003onKViPGo00000_oVi^H3o`000003onKVi_l0003o000000;o000000?o
i^KVo`000?l000001?l00002onKViP;o000000?oi^KVo`000?l000000_l000000ooVi^Ko0000o`00
0002o`0000Goi^KV1?l00002onKViPco000000?oi^KVo`000?l000001?l000000ooVi^Ko0000o`00
0005o`0003koi^KV000nonKViP;o00000ooVi^H2o`0000;oi^KV0_l00009onKViP;o00000ooVi^H2
o`0000;oi^KV0_l00002onKViPCo00000_oVi^H01?l0003oi^KVo`000?l00002onKViP;o000000?o
i^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`00
0007onKViP;o00000_oVi^H3o`000004onKVi_l0003o0000onKViP;o00000_oVi^H2o`000003onKV
i_l0003o000000;oi^KV0_l000001OoVi^Ko0000o`000?oVi^Ko000000;oi^KV0_l0000monKViP00
?OoVi^H2o`0000Coi^KV0_l00002onKViP;o00002?oVi^H2o`0000Goi^KV0_l000000ooVi^Ko0000
o`000002onKViPCo00001?oVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o0000
00?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000Ooi^KV0_l000001?oVi^Ko0000
o`000?l00002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o000000;o
i^KV0_l000000ooVi^Ko0000o`000003onKViP?o0000?OoVi^H003goi^KV0_l00003onKViPCo0000
00?oi^KVo`000?l000000ol00005onKViP;o00001OoVi^H2o`000003onKVi_l0003o000000;oi^KV
1ol000000ooVi^Ko0000o`000004onKViP?o00000_oVi^H2o`000003onKVi_l0003o000000;oi^KV
0_l000000ooVi^Ko0000o`000007onKViPGo00001OoVi^H3o`0000;oi^KV0_l000000ooVi^Ko0000
o`000002onKViPCo00000_oVi^H3o`0003ooi^KV000monKViP;o00002?oVi^H2o`0000;oi^KV0_l0
0004onKViP;o00001OoVi^H2o`000005onKVi_l0003o0000o`000?oVi^H01?l000001?oVi^Ko0000
o`000?oVi^H6o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000002onKViP;o
000000?oi^KVo`000?l000000_l00005onKViP;o00000ooVi^H2o`000004onKVi_l0003o0000onKV
iP;o00000_oVi^H5o`0000;oi^KV0_l00002onKViP04o`000?oVi^Ko0000o`0000;oi^KV00?o0000
onKVi_oVi^H0>ooVi^H003goi^KV0_l00005onKViP03o`000?oVi^Koi^KV00;o00000_oVi^H2o`00
00Coi^KV0_l00005onKViPGo000000?oi^KVo`000?l000000_oVi^H3o`000007onKVi_l0003o0000
o`000?oVi^Ko0000onKViP03o`0000;oi^KV1?l000000ooVi^Ko0000o`000002o`000006onKVi_l0
003o0000o`000?oVi^Ko00001OoVi^H2o`0000?oi^KV0_l00002onKViP?o00000_oVi^H3o`000003
onKVi_l0003o000000;oi^KV0_l000001OoVi^Ko0000o`000?l0003oi^KV00Co0000?OoVi^H003ko
i^KV0_l00003onKViP;o00000_oVi^H2o`0000;oi^KV0_l00005onKViP;o00000ooVi^H2o`0001Wo
i^KV0_l0000AonKViP;o00000ooVi^H2o`0000ooi^KV0_l00016onKViP00?ooVi^H4o`000003onKV
i_l0003oi^KV00Ko00001ooVi^H5o`0001_oi^KV00?o0000onKVi_oVi^H03_oVi^H7o`0000ooi^KV
0ol00016onKViP00hooVi^H00>?oi^KV0000\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-4.59781, \
-0.0445132, 0.152736, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-20.8689, -0.0890264, 0.152736, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-2.91404, -0.711658, 0.134166, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-20.4107, -1.05067, 0.152736, 0.0140179}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {-4.59781, -0.306114, 0.152736, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-20.8689, -0.406114, 0.152736, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-2.8581, -2.61842, \
0.133319, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> {-20.8689, \
-0.587, 0.152736, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 0.571725`}\\)}, \
{\\({DECAPS, 0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, \
{\\({MUTAT, 0.5841590114486517`}\\)}, {\\({PERM, 0.1`}\\)}, {\\({\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)}, {\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)}}, ColumnAlignments -> Left, GridBaseline -> {Baseline, \
{1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Expression \!\(AntTracker[\(\(seq[advance]\)\)]\) or \!\(AntTracker[\(\
\(seq[advance]\)\)]\) does not contain pattern \!\({\(\(\(ifSensor[_]\)\)[__]\
\)}\).   Crossover not performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Expression \!\(AntTracker[\(\(seq[advance]\)\)]\) or \!\(AntTracker[\(\
\(seq[advance]\)\)]\) does not contain pattern \!\({\(\(\(ifSensor[_]\)\)[__]\
\)}\).   Crossover not performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(\(ifSensor[\(\(dust | phero | food | wall\)\)]\)\)[\(\
\(_seq, _seq\)\)]\)}\) is not present in expression \
\!\(AntTracker[\(\(seq[advance]\)\)]\). No mutation performed."\)], "Message"],

Cell[BoxData[
    \(i::"info" \(\(:\)\(\ \)\) 
      "Pattern \!\({\(\(seq[k__]\)\) /; \(\(\(\(Length[\(\({k}\)\)]\)\) > 1\)\
\)}\) is not present in expression \!\(AntTracker[\(\(seq[advance]\)\)]\). No \
shrink performed."\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"generationInfo" \(\(:\)\(\ \)\) 
      "Generation: \!\(11\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .9496 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-0.0282645 1.12899 -5.55112e-17 1.12899 [
[.5 .9621 -97.125 0 ]
[.5 .9621 97.125 14 ]
[.06258 .16229 -4.96804 -14 ]
[.06258 .16229 5.65696 0 ]
[.20005 .12484 -9.80566 -14 ]
[.20005 .12484 10.7568 0 ]
[.34952 .08412 -5.17525 -14 ]
[.34952 .08412 5.44975 0 ]
[.51263 .03969 -10.2475 -14 ]
[.51263 .03969 10.315 0 ]
[.69134 -0.00898 -8.81254 -14 ]
[.69134 -0.00898 8.43746 0 ]
[.35134 .01358 -15.8302 -14 ]
[.35134 .01358 16.6698 0 ]
[.75864 .03613 0 -8.81647 ]
[.75864 .03613 10.625 5.18353 ]
[.7835 .06481 0 -8.75521 ]
[.7835 .06481 10.625 5.24479 ]
[.80701 .09195 0 -8.69794 ]
[.80701 .09195 10.625 5.30206 ]
[.82929 .11766 0 -8.64429 ]
[.82929 .11766 10.625 5.35571 ]
[.85044 .14206 0 -8.59393 ]
[.85044 .14206 10.625 5.40607 ]
[.87052 .16524 0 -8.54656 ]
[.87052 .16524 10.625 5.45344 ]
[.88963 .18729 0 -8.50193 ]
[.88963 .18729 10.625 5.49807 ]
[.90783 .2083 0 -8.4598 ]
[.90783 .2083 10.625 5.5402 ]
[.92519 .22833 0 -8.41997 ]
[.92519 .22833 10.625 5.58003 ]
[.94175 .24745 0 -8.38225 ]
[.94175 .24745 17.25 5.61775 ]
[.95759 .26572 0 -8.34649 ]
[.95759 .26572 17.25 5.65351 ]
[.97273 .2832 0 -8.31253 ]
[.97273 .2832 17.25 5.68747 ]
[.93942 .15002 0 -8.54656 ]
[.93942 .15002 29.875 5.45344 ]
[.0251 .32781 -10.625 -5.40139 ]
[.0251 .32781 0 8.59861 ]
[.01303 .5062 -10.625 -5.78036 ]
[.01303 .5062 0 8.21964 ]
[.0004 .69332 -10.625 -6.18094 ]
[.0004 .69332 0 7.81906 ]
[-0.01282 .88985 -10.625 -6.60506 ]
[-0.01282 .88985 0 7.39494 ]
[-0.05812 .54074 -20.5625 -5.82921 ]
[-0.05812 .54074 0 8.17079 ]
[ 0 0 0 0 ]
[ 1 .9496 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .9621 -158.125 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Sorted) show
104.125 14.000 moveto
(Fitnesses) show
162.438 14.000 moveto
(History) show
203.500 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
210.125 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
233.375 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
240.000 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(11) show
253.250 14.000 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
[ ] 0 setdash
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.7105 0 m
.96328 .29088 L
s
.74498 .03967 m
.73815 .04144 L
s
gsave
.75864 .03613 -61 -12.8165 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.76981 .06824 m
.76296 .06996 L
s
gsave
.7835 .06481 -61 -12.7552 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.7933 .09528 m
.78644 .09694 L
s
gsave
.80701 .09195 -61 -12.6979 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.81556 .12089 m
.80869 .1225 L
s
gsave
.82929 .11766 -61 -12.6443 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.83668 .14519 m
.8298 .14676 L
s
gsave
.85044 .14206 -61 -12.5939 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.85674 .16829 m
.84985 .16981 L
s
gsave
.87052 .16524 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.87583 .19025 m
.86893 .19173 L
s
gsave
.88963 .18729 -61 -12.5019 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.89402 .21118 m
.88711 .21262 L
s
gsave
.90783 .2083 -61 -12.4598 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.91136 .23113 m
.90444 .23254 L
s
gsave
.92519 .22833 -61 -12.42 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
1.000 setlinewidth
grestore
.92791 .25018 m
.92099 .25155 L
s
gsave
.94175 .24745 -61 -12.3823 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.94373 .26839 m
.9368 .26972 L
s
gsave
.95759 .26572 -61 -12.3465 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(11) show
1.000 setlinewidth
grestore
.95886 .2858 m
.95193 .2871 L
s
gsave
.97273 .2832 -61 -12.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
1.000 setlinewidth
grestore
gsave
.93942 .15002 -61 -12.5466 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Gen) show
85.562 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
88.875 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0485 .17995 m
0 .90807 L
s
.03886 .32467 m
.04574 .3231 L
s
gsave
.0251 .32781 -71.625 -9.40139 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02693 .50378 m
.03388 .50256 L
s
gsave
.01303 .5062 -71.625 -9.78036 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.01441 .69168 m
.02142 .69086 L
s
gsave
.0004 .69332 -71.625 -10.1809 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.00127 .88905 m
.00831 .88866 L
s
gsave
-0.01282 .88985 -71.625 -10.6051 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
.03593 .36866 m
.04007 .36777 L
s
.03296 .41316 m
.03711 .41233 L
s
.02996 .4582 m
.03412 .45742 L
s
.02386 .5499 m
.02804 .54923 L
s
.02075 .59659 m
.02494 .59598 L
s
.0176 .64384 m
.0218 .64329 L
s
.01119 .74011 m
.0154 .73968 L
s
.00792 .78914 m
.01214 .78877 L
s
.00461 .83878 m
.00884 .83848 L
s
.04175 .2812 m
.04587 .28021 L
s
.04461 .23823 m
.04872 .23719 L
s
.04744 .19576 m
.05153 .19466 L
s
gsave
-0.05812 .54074 -81.5625 -9.82921 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Fit) show
76.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
79.562 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.4 g
.25 Mabswid
.03886 .32467 m
.42389 .50407 L
s
.02693 .50378 m
.42185 .64262 L
s
.01441 .69168 m
.41974 .78628 L
s
.00127 .88905 m
.41755 .93534 L
s
.06017 .18649 m
.01322 .90938 L
s
.2323 .28281 m
.20587 .92855 L
s
.37064 .36022 m
.35776 .94367 L
s
.43675 .38887 m
.42934 .9492 L
s
.55259 .36731 m
.55385 .94504 L
s
.676 .34434 m
.68713 .94059 L
s
.80772 .31983 m
.83013 .93581 L
s
.94864 .29361 m
.98397 .93068 L
s
.42389 .50407 m
.97065 .4192 L
s
.42185 .64262 m
.97972 .57713 L
s
.41974 .78628 m
.98918 .7418 L
s
.41755 .93534 m
.99905 .91365 L
s
0 0 m
1 0 L
1 .9496 L
0 .9496 L
closepath
clip
newpath
.4526 .3757 m .52233 .38044 L .47545 .38907 L 1 0 0 r
F
.50012 .36673 m .57042 .37159 L .52233 .38044 L F
.4526 .3757 m .50012 .36673 L .52233 .38044 L F
.42884 .3618 m .50012 .36673 L .4526 .3757 L F
.54888 .35752 m .61975 .36251 L .57042 .37159 L F
.50012 .36673 m .54888 .35752 L .57042 .37159 L F
.47701 .35246 m .54888 .35752 L .50012 .36673 L F
.42884 .3618 m .47701 .35246 L .50012 .36673 L F
.59894 .34806 m .67039 .35318 L .61975 .36251 L F
.54888 .35752 m .59894 .34806 L .61975 .36251 L F
.40411 .34733 m .47701 .35246 L .42884 .3618 L F
.52646 .34287 m .59894 .34806 L .54888 .35752 L F
.47701 .35246 m .52646 .34287 L .54888 .35752 L F
.65033 .33836 m .72237 .34361 L .67039 .35318 L F
.59894 .34806 m .65033 .33836 L .67039 .35318 L F
.45294 .3376 m .52646 .34287 L .47701 .35246 L F
.40411 .34733 m .45294 .3376 L .47701 .35246 L F
.57725 .33302 m .65033 .33836 L .59894 .34806 L F
.52646 .34287 m .57725 .33302 L .59894 .34806 L F
.37834 .33225 m .45294 .3376 L .40411 .34733 L F
.70313 .32838 m .77575 .33379 L .72237 .34361 L F
.65033 .33836 m .70313 .32838 L .72237 .34361 L F
.5031 .32761 m .57725 .33302 L .52646 .34287 L F
.45294 .3376 m .5031 .32761 L .52646 .34287 L F
.5 Mabswid
.52132 .93033 m .47106 .93222 L .44644 .92929 L p F P
0 0 0 r
s
.62944 .3229 m .70313 .32838 L .65033 .33836 L 1 0 0 r
F
.57725 .33302 m .62944 .3229 L .65033 .33836 L F
.42785 .32211 m .5031 .32761 L .45294 .3376 L F
.37834 .33225 m .42785 .32211 L .45294 .3376 L F
.75738 .31814 m .8306 .32369 L .77575 .33379 L F
.70313 .32838 m .75738 .31814 L .77575 .33379 L F
.55465 .31734 m .62944 .3229 L .57725 .33302 L F
.5031 .32761 m .55465 .31734 L .57725 .33302 L F
.35149 .31654 m .42785 .32211 L .37834 .33225 L F
.57295 .92839 m .52132 .93033 L .49742 .92732 L p F P
0 0 0 r
s
.44644 .92929 m .49742 .92732 L .52132 .93033 L p 1 0 0 r
F P
0 0 0 r
s
.68307 .3125 m .75738 .31814 L .70313 .32838 L 1 0 0 r
F
.62944 .3229 m .68307 .3125 L .70313 .32838 L F
.47874 .31169 m .55465 .31734 L .5031 .32761 L F
.42785 .32211 m .47874 .31169 L .5031 .32761 L F
.49742 .92732 m .44644 .92929 L .42076 .92623 L p F P
0 0 0 r
s
.81315 .3076 m .88697 .31331 L .8306 .32369 L 1 0 0 r
F
.75738 .31814 m .81315 .3076 L .8306 .32369 L F
.60764 .30678 m .68307 .3125 L .62944 .3229 L F
.55465 .31734 m .60764 .30678 L .62944 .3229 L F
.40169 .30596 m .47874 .31169 L .42785 .32211 L F
.35149 .31654 m .40169 .30596 L .42785 .32211 L F
.62603 .92639 m .57295 .92839 L .54984 .92529 L p F P
0 0 0 r
s
.49742 .92732 m .54984 .92529 L .57295 .92839 L p 1 0 0 r
F P
0 0 0 r
s
.73822 .30181 m .81315 .3076 L .75738 .31814 L 1 0 0 r
F
.68307 .3125 m .73822 .30181 L .75738 .31814 L F
.53107 .30097 m .60764 .30678 L .55465 .31734 L F
.47874 .31169 m .53107 .30097 L .55465 .31734 L F
.32346 .30014 m .40169 .30596 L .35149 .31654 L F
.54984 .92529 m .49742 .92732 L .47249 .92418 L p F P
0 0 0 r
s
.42076 .92623 m .47249 .92418 L .49742 .92732 L p 1 0 0 r
F P
0 0 0 r
s
.8705 .29677 m .94492 .30264 L .88697 .31331 L .5 0 1 r
F
.81315 .3076 m .8705 .29677 L .88697 .31331 L 1 0 0 r
F
.66214 .29593 m .73822 .30181 L .68307 .3125 L F
.60764 .30678 m .66214 .29593 L .68307 .3125 L F
.45332 .29508 m .53107 .30097 L .47874 .31169 L F
.40169 .30596 m .45332 .29508 L .47874 .31169 L F
.68061 .92434 m .62603 .92639 L .60375 .92321 L p F P
0 0 0 r
s
.54984 .92529 m .60375 .92321 L .62603 .92639 L p 1 0 0 r
F P
0 0 0 r
s
.47249 .92418 m .42076 .92623 L .39395 .92305 L p 1 0 0 r
F P
0 0 0 r
s
.79494 .29081 m .8705 .29677 L .81315 .3076 L .5 0 1 r
F
.73822 .30181 m .79494 .29081 L .81315 .3076 L 1 0 0 r
F
.58489 .28995 m .66214 .29593 L .60764 .30678 L F
.53107 .30097 m .58489 .28995 L .60764 .30678 L F
.37437 .28909 m .45332 .29508 L .40169 .30596 L F
.32346 .30014 m .37437 .28909 L .40169 .30596 L F
.60375 .92321 m .54984 .92529 L .52571 .92206 L p F P
0 0 0 r
s
.47249 .92418 m .52571 .92206 L .54984 .92529 L p 1 0 0 r
F P
0 0 0 r
s
.8705 .29677 m .92951 .28563 L .94492 .30264 L .5 0 1 r
F
.7182 .28476 m .79494 .29081 L .73822 .30181 L 1 0 0 r
F
.66214 .29593 m .7182 .28476 L .73822 .30181 L F
.50644 .28389 m .58489 .28995 L .53107 .30097 L F
.45332 .29508 m .50644 .28389 L .53107 .30097 L F
.2942 .28301 m .37437 .28909 L .32346 .30014 L F
.73675 .92223 m .68061 .92434 L .65922 .92106 L p F P
0 0 0 r
s
.60375 .92321 m .65922 .92106 L .68061 .92434 L p 1 0 0 r
F P
0 0 0 r
s
.52571 .92206 m .47249 .92418 L .44644 .9209 L p 1 0 0 r
F P
0 0 0 r
s
.39395 .92305 m .44644 .9209 L .47249 .92418 L p 1 0 0 r
F P
0 0 0 r
s
.85331 .27949 m .92951 .28563 L .8705 .29677 L 0 1 1 r
F
.79494 .29081 m .85331 .27949 L .8705 .29677 L .5 0 1 r
F
.64027 .27861 m .7182 .28476 L .66214 .29593 L 1 0 0 r
F
.58489 .28995 m .64027 .27861 L .66214 .29593 L F
.42676 .27772 m .50644 .28389 L .45332 .29508 L F
.37437 .28909 m .42676 .27772 L .45332 .29508 L F
.65922 .92106 m .60375 .92321 L .58047 .91988 L p F P
0 0 0 r
s
.52571 .92206 m .58047 .91988 L .60375 .92321 L p 1 0 0 r
F P
0 0 0 r
s
.44644 .9209 m .39395 .92305 L .36594 .91971 L p 1 0 0 r
F P
0 0 0 r
s
.77591 .27326 m .85331 .27949 L .79494 .29081 L 0 1 1 r
F
.7182 .28476 m .77591 .27326 L .79494 .29081 L 1 0 0 r
F
.56111 .27237 m .64027 .27861 L .58489 .28995 L F
.50644 .28389 m .56111 .27237 L .58489 .28995 L F
.34582 .27147 m .42676 .27772 L .37437 .28909 L F
.2942 .28301 m .34582 .27147 L .37437 .28909 L F
.79453 .92005 m .73675 .92223 L .71632 .91886 L p F P
0 0 0 r
s
.65922 .92106 m .71632 .91886 L .73675 .92223 L p 1 0 0 r
F P
0 0 0 r
s
.58047 .91988 m .52571 .92206 L .50048 .91868 L p 1 0 0 r
F P
0 0 0 r
s
.44644 .9209 m .50048 .91868 L .52571 .92206 L p 1 0 0 r
F P
0 0 0 r
s
.85331 .27949 m .91339 .26784 L .92951 .28563 L 0 1 1 r
F
.69728 .26693 m .77591 .27326 L .7182 .28476 L .5 0 1 r
F
.64027 .27861 m .69728 .26693 L .7182 .28476 L 1 0 0 r
F
.48069 .26602 m .56111 .27237 L .50644 .28389 L F
.42676 .27772 m .48069 .26602 L .50644 .28389 L F
.2636 .26511 m .34582 .27147 L .2942 .28301 L F
.95551 .49559 m .91529 .91551 L .89814 .91183 L p .5 0 1 r
F P
0 0 0 r
s
.89814 .91183 m .96253 .90934 L .95551 .49559 L p .5 0 1 r
F P
0 0 0 r
s
.71632 .91886 m .65922 .92106 L .63686 .91764 L p 1 0 0 r
F P
0 0 0 r
s
.58047 .91988 m .63686 .91764 L .65922 .92106 L p 1 0 0 r
F P
0 0 0 r
s
.50048 .91868 m .44644 .9209 L .41921 .91747 L p 1 0 0 r
F P
0 0 0 r
s
.36594 .91971 m .41921 .91747 L .44644 .9209 L p 1 0 0 r
F P
0 0 0 r
s
.83532 .26143 m .91339 .26784 L .85331 .27949 L 1 0 0 r
F
.77591 .27326 m .83532 .26143 L .85331 .27949 L 0 1 1 r
F
.6174 .2605 m .69728 .26693 L .64027 .27861 L 1 0 0 r
F
.56111 .27237 m .6174 .2605 L .64027 .27861 L F
.39898 .25958 m .48069 .26602 L .42676 .27772 L F
.34582 .27147 m .39898 .25958 L .42676 .27772 L F
.85402 .91782 m .79453 .92005 L .77512 .91658 L p F P
0 0 0 r
s
.71632 .91886 m .77512 .91658 L .79453 .92005 L p 1 0 0 r
F P
0 0 0 r
s
.63686 .91764 m .58047 .91988 L .55613 .91641 L p 1 0 0 r
F P
0 0 0 r
s
.50048 .91868 m .55613 .91641 L .58047 .91988 L p 1 0 0 r
F P
0 0 0 r
s
.41921 .91747 m .36594 .91971 L .33663 .91623 L p 1 0 0 r
F P
0 0 0 r
s
.756 .25491 m .83532 .26143 L .77591 .27326 L .5 1 0 r
F
.69728 .26693 m .756 .25491 L .77591 .27326 L .5 0 1 r
F
.53623 .25397 m .6174 .2605 L .56111 .27237 L 1 0 0 r
F
.48069 .26602 m .53623 .25397 L .56111 .27237 L F
.31595 .25303 m .39898 .25958 L .34582 .27147 L F
.2636 .26511 m .31595 .25303 L .34582 .27147 L F
.77512 .91658 m .71632 .91886 L .69495 .91533 L p F P
0 0 0 r
s
.63686 .91764 m .69495 .91533 L .71632 .91886 L p 1 0 0 r
F P
0 0 0 r
s
.55613 .91641 m .50048 .91868 L .47409 .91515 L p 1 0 0 r
F P
0 0 0 r
s
.41921 .91747 m .47409 .91515 L .50048 .91868 L p 1 0 0 r
F P
0 0 0 r
s
.83532 .26143 m .89653 .24924 L .91339 .26784 L 1 0 0 r
F
.67539 .24828 m .756 .25491 L .69728 .26693 L .5 0 1 r
F
.6174 .2605 m .67539 .24828 L .69728 .26693 L 1 0 0 r
F
.45374 .24733 m .53623 .25397 L .48069 .26602 L F
.39898 .25958 m .45374 .24733 L .48069 .26602 L F
.23158 .24637 m .31595 .25303 L .2636 .26511 L F
.91529 .91551 m .85402 .91782 L .8357 .91424 L p F P
0 0 0 r
s
.77512 .91658 m .8357 .91424 L .85402 .91782 L p 1 0 0 r
F P
0 0 0 r
s
.69495 .91533 m .63686 .91764 L .61346 .91406 L p 1 0 0 r
F P
0 0 0 r
s
.55613 .91641 m .61346 .91406 L .63686 .91764 L p 1 0 0 r
F P
0 0 0 r
s
.47409 .91515 m .41921 .91747 L .39071 .91388 L p 1 0 0 r
F P
0 0 0 r
s
.33663 .91623 m .39071 .91388 L .41921 .91747 L p 1 0 0 r
F P
0 0 0 r
s
.8165 .24252 m .89653 .24924 L .83532 .26143 L 1 0 0 r
F
.756 .25491 m .8165 .24252 L .83532 .26143 L .5 1 0 r
F
.59346 .24155 m .67539 .24828 L .6174 .2605 L 1 0 0 r
F
.53623 .25397 m .59346 .24155 L .6174 .2605 L F
.3699 .24058 m .45374 .24733 L .39898 .25958 L F
.31595 .25303 m .3699 .24058 L .39898 .25958 L F
.96253 .90934 m .89814 .91183 L .86178 .47779 L p 0 1 1 r
F P
0 0 0 r
s
.86178 .47779 m .92362 .46882 L .96253 .90934 L p 0 1 1 r
F P
0 0 0 r
s
.81651 .9105 m .86178 .47779 L .89814 .91183 L p .5 0 1 r
F P
0 0 0 r
s
.92362 .46882 m .86178 .47779 L .8435 .46388 L p 1 0 0 r
F P
0 0 0 r
s
.86178 .47779 m .81651 .9105 L .79638 .90657 L p 0 1 1 r
F P
0 0 0 r
s
.79638 .90657 m .8435 .46388 L .86178 .47779 L p 0 1 1 r
F P
0 0 0 r
s
.8357 .91424 m .77512 .91658 L .7548 .91295 L p 1 0 0 r
F P
0 0 0 r
s
.69495 .91533 m .7548 .91295 L .77512 .91658 L p 1 0 0 r
F P
0 0 0 r
s
.61346 .91406 m .55613 .91641 L .53064 .91277 L p 1 0 0 r
F P
0 0 0 r
s
.47409 .91515 m .53064 .91277 L .55613 .91641 L p 1 0 0 r
F P
0 0 0 r
s
.39071 .91388 m .33663 .91623 L .30596 .91258 L p 1 0 0 r
F P
0 0 0 r
s
.73516 .23569 m .8165 .24252 L .756 .25491 L 0 1 1 r
F
.67539 .24828 m .73516 .23569 L .756 .25491 L .5 0 1 r
F
.51018 .23471 m .59346 .24155 L .53623 .25397 L 1 0 0 r
F
.45374 .24733 m .51018 .23471 L .53623 .25397 L F
.28468 .23372 m .3699 .24058 L .31595 .25303 L F
.23158 .24637 m .28468 .23372 L .31595 .25303 L F
.8357 .91424 m .89814 .91183 L .91529 .91551 L p F P
0 0 0 r
s
.7548 .91295 m .69495 .91533 L .67256 .91164 L p 1 0 0 r
F P
0 0 0 r
s
.61346 .91406 m .67256 .91164 L .69495 .91533 L p 1 0 0 r
F P
0 0 0 r
s
.53064 .91277 m .47409 .91515 L .44645 .91145 L p 1 0 0 r
F P
0 0 0 r
s
.39071 .91388 m .44645 .91145 L .47409 .91515 L p 1 0 0 r
F P
0 0 0 r
s
.8165 .24252 m .87887 .22975 L .89653 .24924 L 1 0 0 r
F
.65246 .22875 m .73516 .23569 L .67539 .24828 L F
.59346 .24155 m .65246 .22875 L .67539 .24828 L F
.42552 .22775 m .51018 .23471 L .45374 .24733 L F
.3699 .24058 m .42552 .22775 L .45374 .24733 L F
.19804 .22674 m .28468 .23372 L .23158 .24637 L F
.8435 .46388 m .90653 .45448 L .92362 .46882 L p F P
0 0 0 r
s
.89814 .91183 m .8357 .91424 L .81651 .9105 L p .5 0 1 r
F P
0 0 0 r
s
.7548 .91295 m .81651 .9105 L .8357 .91424 L p 1 0 0 r
F P
0 0 0 r
s
.67256 .91164 m .61346 .91406 L .58895 .91031 L p 1 0 0 r
F P
0 0 0 r
s
.53064 .91277 m .58895 .91031 L .61346 .91406 L p 1 0 0 r
F P
0 0 0 r
s
.44645 .91145 m .39071 .91388 L .36084 .91012 L p 1 0 0 r
F P
0 0 0 r
s
.30596 .91258 m .36084 .91012 L .39071 .91388 L p 1 0 0 r
F P
0 0 0 r
s
.79678 .22271 m .87887 .22975 L .8165 .24252 L .5 1 0 r
F
.73516 .23569 m .79678 .22271 L .8165 .24252 L 0 1 1 r
F
.56838 .22169 m .65246 .22875 L .59346 .24155 L 1 0 0 r
F
.51018 .23471 m .56838 .22169 L .59346 .24155 L F
.33943 .22067 m .42552 .22775 L .3699 .24058 L F
.28468 .23372 m .33943 .22067 L .3699 .24058 L F
.90653 .45448 m .8435 .46388 L .82435 .4493 L p F P
0 0 0 r
s
.8435 .46388 m .79638 .90657 L .76206 .45885 L p .5 1 0 r
F P
0 0 0 r
s
.76206 .45885 m .82435 .4493 L .8435 .46388 L p .5 1 0 r
F P
0 0 0 r
s
.81651 .9105 m .7548 .91295 L .7335 .90915 L p 1 0 0 r
F P
0 0 0 r
s
.67256 .91164 m .7335 .90915 L .7548 .91295 L p 1 0 0 r
F P
0 0 0 r
s
.58895 .91031 m .53064 .91277 L .50393 .90895 L p 1 0 0 r
F P
0 0 0 r
s
.44645 .91145 m .50393 .90895 L .53064 .91277 L p 1 0 0 r
F P
0 0 0 r
s
.36084 .91012 m .30596 .91258 L .2738 .90876 L p 1 0 0 r
F P
0 0 0 r
s
.71331 .21554 m .79678 .22271 L .73516 .23569 L 1 0 0 r
F
.65246 .22875 m .71331 .21554 L .73516 .23569 L F
.48288 .21451 m .56838 .22169 L .51018 .23471 L F
.42552 .22775 m .48288 .21451 L .51018 .23471 L F
.25189 .21348 m .33943 .22067 L .28468 .23372 L .5 0 1 r
F
.19804 .22674 m .25189 .21348 L .28468 .23372 L 1 0 0 r
F
.71116 .90515 m .76206 .45885 L .79638 .90657 L p .5 0 1 r
F P
0 0 0 r
s
.82435 .4493 m .76206 .45885 L .75302 .89812 L p 0 1 1 r
F P
0 0 0 r
s
.76206 .45885 m .71116 .90515 L .68768 .90096 L p .5 0 1 r
F P
0 0 0 r
s
.68768 .90096 m .75302 .89812 L .76206 .45885 L p .5 0 1 r
F P
0 0 0 r
s
.7335 .90915 m .67256 .91164 L .64909 .90777 L p 1 0 0 r
F P
0 0 0 r
s
.58895 .91031 m .64909 .90777 L .67256 .91164 L p 1 0 0 r
F P
0 0 0 r
s
.50393 .90895 m .44645 .91145 L .41746 .90757 L p 1 0 0 r
F P
0 0 0 r
s
.36084 .91012 m .41746 .90757 L .44645 .91145 L p 1 0 0 r
F P
0 0 0 r
s
.79678 .22271 m .86035 .20931 L .87887 .22975 L .5 1 0 r
F
.62842 .20826 m .71331 .21554 L .65246 .22875 L 1 0 0 r
F
.56838 .22169 m .62842 .20826 L .65246 .22875 L F
.39592 .20721 m .48288 .21451 L .42552 .22775 L F
.33943 .22067 m .39592 .20721 L .42552 .22775 L F
.16286 .20616 m .25189 .21348 L .19804 .22674 L F
.82435 .4493 m .88861 .43944 L .90653 .45448 L p F P
0 0 0 r
s
.7335 .90915 m .79638 .90657 L .81651 .9105 L p 1 0 0 r
F P
0 0 0 r
s
.64909 .90777 m .58895 .91031 L .56323 .90637 L p 1 0 0 r
F P
0 0 0 r
s
.50393 .90895 m .56323 .90637 L .58895 .91031 L p 1 0 0 r
F P
0 0 0 r
s
.41746 .90757 m .36084 .91012 L .32952 .90617 L p 1 0 0 r
F P
0 0 0 r
s
.2738 .90876 m .32952 .90617 L .36084 .91012 L p 1 0 0 r
F P
0 0 0 r
s
.77609 .20192 m .86035 .20931 L .79678 .22271 L .5 0 1 r
F
.71331 .21554 m .77609 .20192 L .79678 .22271 L 1 0 0 r
F
.54207 .20086 m .62842 .20826 L .56838 .22169 L F
.48288 .21451 m .54207 .20086 L .56838 .22169 L F
.30747 .19979 m .39592 .20721 L .33943 .22067 L 0 1 1 r
F
.25189 .21348 m .30747 .19979 L .33943 .22067 L .5 0 1 r
F
.88861 .43944 m .82435 .4493 L .82057 .89518 L p .5 1 0 r
F P
0 0 0 r
s
.75302 .89812 m .82057 .89518 L .82435 .4493 L p 0 1 1 r
F P
0 0 0 r
s
.79638 .90657 m .7335 .90915 L .71116 .90515 L p .5 0 1 r
F P
0 0 0 r
s
.64909 .90777 m .71116 .90515 L .7335 .90915 L p 1 0 0 r
F P
0 0 0 r
s
.56323 .90637 m .50393 .90895 L .4759 .90495 L p 1 0 0 r
F P
0 0 0 r
s
.41746 .90757 m .4759 .90495 L .50393 .90895 L p 1 0 0 r
F P
0 0 0 r
s
.32952 .90617 m .2738 .90876 L .24006 .90474 L p 1 0 0 r
F P
0 0 0 r
s
.69038 .1944 m .77609 .20192 L .71331 .21554 L 1 0 0 r
F
.62842 .20826 m .69038 .1944 L .71331 .21554 L F
.45423 .19332 m .54207 .20086 L .48288 .21451 L F
.39592 .20721 m .45423 .19332 L .48288 .21451 L F
.21748 .19223 m .30747 .19979 L .25189 .21348 L 0 1 1 r
F
.16286 .20616 m .21748 .19223 L .25189 .21348 L 1 0 0 r
F
.71116 .90515 m .64909 .90777 L .62445 .90371 L p F P
0 0 0 r
s
.56323 .90637 m .62445 .90371 L .64909 .90777 L p 1 0 0 r
F P
0 0 0 r
s
.4759 .90495 m .41746 .90757 L .38704 .9035 L p 1 0 0 r
F P
0 0 0 r
s
.32952 .90617 m .38704 .9035 L .41746 .90757 L p 1 0 0 r
F P
0 0 0 r
s
.77609 .20192 m .84091 .18786 L .86035 .20931 L .5 0 1 r
F
.60318 .18676 m .69038 .1944 L .62842 .20826 L 1 0 0 r
F
.54207 .20086 m .60318 .18676 L .62842 .20826 L F
.36485 .18565 m .45423 .19332 L .39592 .20721 L 0 1 1 r
F
.30747 .19979 m .36485 .18565 L .39592 .20721 L F
.82057 .89518 m .8698 .42365 L .88861 .43944 L p .5 1 0 r
F P
0 0 0 r
s
.62445 .90371 m .56323 .90637 L .53623 .90224 L p 1 0 0 r
F P
0 0 0 r
s
.4759 .90495 m .53623 .90224 L .56323 .90637 L p 1 0 0 r
F P
0 0 0 r
s
.38704 .9035 m .32952 .90617 L .29663 .90203 L p 1 0 0 r
F P
0 0 0 r
s
.24006 .90474 m .29663 .90203 L .32952 .90617 L p 1 0 0 r
F P
0 0 0 r
s
.75437 .18009 m .84091 .18786 L .77609 .20192 L 1 0 0 r
F
.69038 .1944 m .75437 .18009 L .77609 .20192 L F
.51443 .17897 m .60318 .18676 L .54207 .20086 L .5 0 1 r
F
.45423 .19332 m .51443 .17897 L .54207 .20086 L 1 0 0 r
F
.27389 .17785 m .36485 .18565 L .30747 .19979 L F
.21748 .19223 m .27389 .17785 L .30747 .19979 L 0 1 1 r
F
.62445 .90371 m .68768 .90096 L .71116 .90515 L p 1 0 0 r
F P
0 0 0 r
s
.53623 .90224 m .4759 .90495 L .44645 .90074 L p 1 0 0 r
F P
0 0 0 r
s
.38704 .9035 m .44645 .90074 L .4759 .90495 L p 1 0 0 r
F P
0 0 0 r
s
.29663 .90203 m .24006 .90474 L .20461 .90053 L p 1 0 0 r
F P
0 0 0 r
s
.66629 .17219 m .75437 .18009 L .69038 .1944 L .5 0 1 r
F
.60318 .18676 m .66629 .17219 L .69038 .1944 L 1 0 0 r
F
.42412 .17105 m .51443 .17897 L .45423 .19332 L 0 1 1 r
F
.36485 .18565 m .42412 .17105 L .45423 .19332 L F
.68768 .90096 m .62445 .90371 L .59856 .89944 L p 1 0 0 r
F P
0 0 0 r
s
.53623 .90224 m .59856 .89944 L .62445 .90371 L p 1 0 0 r
F P
0 0 0 r
s
.44645 .90074 m .38704 .9035 L .35507 .89922 L p 1 0 0 r
F P
0 0 0 r
s
.29663 .90203 m .35507 .89922 L .38704 .9035 L p 1 0 0 r
F P
0 0 0 r
s
.75437 .18009 m .82048 .16531 L .84091 .18786 L 1 0 0 r
F
.57664 .16415 m .66629 .17219 L .60318 .18676 L 0 1 1 r
F
.51443 .17897 m .57664 .16415 L .60318 .18676 L .5 0 1 r
F
.33218 .16299 m .42412 .17105 L .36485 .18565 L 1 0 0 r
F
.27389 .17785 m .33218 .16299 L .36485 .18565 L F
.8698 .42365 m .82057 .89518 L .79858 .89046 L p .5 0 1 r
F P
0 0 0 r
s
.79858 .89046 m .86998 .88725 L .8698 .42365 L p .5 0 1 r
F P
0 0 0 r
s
.59856 .89944 m .53623 .90224 L .50784 .89789 L p 1 0 0 r
F P
0 0 0 r
s
.44645 .90074 m .50784 .89789 L .53623 .90224 L p 1 0 0 r
F P
0 0 0 r
s
.35507 .89922 m .29663 .90203 L .26204 .89767 L p 1 0 0 r
F P
0 0 0 r
s
.20461 .90053 m .26204 .89767 L .29663 .90203 L p 1 0 0 r
F P
0 0 0 r
s
.73152 .15714 m .82048 .16531 L .75437 .18009 L 0 1 1 r
F
.66629 .17219 m .73152 .15714 L .75437 .18009 L .5 0 1 r
F
.48537 .15596 m .57664 .16415 L .51443 .17897 L .5 1 0 r
F
.42412 .17105 m .48537 .15596 L .51443 .17897 L 0 1 1 r
F
.75302 .89812 m .68768 .90096 L .66299 .89655 L p 1 0 0 r
F P
0 0 0 r
s
.59856 .89944 m .66299 .89655 L .68768 .90096 L p 1 0 0 r
F P
0 0 0 r
s
.50784 .89789 m .44645 .90074 L .41548 .89632 L p 1 0 0 r
F P
0 0 0 r
s
.35507 .89922 m .41548 .89632 L .44645 .90074 L p 1 0 0 r
F P
0 0 0 r
s
.38286 .89166 m .32142 .89472 L .30072 .41628 L p 0 1 1 r
F P
0 0 0 r
s
.30072 .41628 m .35971 .40534 L .38286 .89166 L p 0 1 1 r
F P
0 0 0 r
s
.22562 .89308 m .30072 .41628 L .32142 .89472 L p .5 0 1 r
F P
0 0 0 r
s
.35971 .40534 m .30072 .41628 L .26596 .3993 L p 1 0 0 r
F P
0 0 0 r
s
.30072 .41628 m .22562 .89308 L .18724 .88825 L p 0 1 1 r
F P
0 0 0 r
s
.18724 .88825 m .26596 .3993 L .30072 .41628 L p 0 1 1 r
F P
0 0 0 r
s
.26204 .89767 m .20461 .90053 L .16732 .89609 L p 1 0 0 r
F P
0 0 0 r
s
.64095 .14883 m .73152 .15714 L .66629 .17219 L .5 1 0 r
F
.57664 .16415 m .64095 .14883 L .66629 .17219 L 0 1 1 r
F
.39244 .14763 m .48537 .15596 L .42412 .17105 L 1 0 0 r
F
.33218 .16299 m .39244 .14763 L .42412 .17105 L F
.66299 .89655 m .59856 .89944 L .57132 .89495 L p F P
0 0 0 r
s
.50784 .89789 m .57132 .89495 L .59856 .89944 L p 1 0 0 r
F P
0 0 0 r
s
.41548 .89632 m .35507 .89922 L .32142 .89472 L p 1 0 0 r
F P
0 0 0 r
s
.26204 .89767 m .32142 .89472 L .35507 .89922 L p 1 0 0 r
F P
0 0 0 r
s
.73152 .15714 m .79898 .14158 L .82048 .16531 L 0 1 1 r
F
.54872 .14036 m .64095 .14883 L .57664 .16415 L 1 0 0 r
F
.48537 .15596 m .54872 .14036 L .57664 .16415 L .5 1 0 r
F
.82057 .89518 m .75302 .89812 L .72963 .89355 L p 1 0 0 r
F P
0 0 0 r
s
.66299 .89655 m .72963 .89355 L .75302 .89812 L p 1 0 0 r
F P
0 0 0 r
s
.57132 .89495 m .50784 .89789 L .47796 .89332 L p 1 0 0 r
F P
0 0 0 r
s
.41548 .89632 m .47796 .89332 L .50784 .89789 L p 1 0 0 r
F P
0 0 0 r
s
.44645 .8885 m .38286 .89166 L .35971 .40534 L p 0 1 1 r
F P
0 0 0 r
s
.35971 .40534 m .4207 .39403 L .44645 .8885 L p 0 1 1 r
F P
0 0 0 r
s
.4207 .39403 m .35971 .40534 L .3259 .38777 L p 1 0 0 r
F P
0 0 0 r
s
.26596 .3993 m .3259 .38777 L .35971 .40534 L p 1 0 0 r
F P
0 0 0 r
s
.32142 .89472 m .26204 .89767 L .22562 .89308 L p .5 0 1 r
F P
0 0 0 r
s
.16732 .89609 m .22562 .89308 L .26204 .89767 L p 1 0 0 r
F P
0 0 0 r
s
.70747 .13298 m .79898 .14158 L .73152 .15714 L 1 0 0 r
F
.64095 .14883 m .70747 .13298 L .73152 .15714 L .5 1 0 r
F
.45477 .13174 m .54872 .14036 L .48537 .15596 L 1 0 0 r
F
.39244 .14763 m .45477 .13174 L .48537 .15596 L F
.72963 .89355 m .66299 .89655 L .63699 .8919 L p F P
0 0 0 r
s
.57132 .89495 m .63699 .8919 L .66299 .89655 L p 1 0 0 r
F P
0 0 0 r
s
.47796 .89332 m .41548 .89632 L .38286 .89166 L p 1 0 0 r
F P
0 0 0 r
s
.32142 .89472 m .38286 .89166 L .41548 .89632 L p 1 0 0 r
F P
0 0 0 r
s
.22562 .89308 m .16732 .89609 L .12804 .89142 L p 1 0 0 r
F P
0 0 0 r
s
.61426 .12422 m .70747 .13298 L .64095 .14883 L 1 0 0 r
F
.54872 .14036 m .61426 .12422 L .64095 .14883 L F
.72963 .89355 m .79858 .89046 L .82057 .89518 L p F P
0 0 0 r
s
.63699 .8919 m .57132 .89495 L .54262 .89021 L p 1 0 0 r
F P
0 0 0 r
s
.47796 .89332 m .54262 .89021 L .57132 .89495 L p 1 0 0 r
F P
0 0 0 r
s
.51233 .88522 m .44645 .8885 L .4207 .39403 L p 0 1 1 r
F P
0 0 0 r
s
.4207 .39403 m .4838 .38232 L .51233 .88522 L p 0 1 1 r
F P
0 0 0 r
s
.4838 .38232 m .4207 .39403 L .38794 .37585 L p 1 0 0 r
F P
0 0 0 r
s
.3259 .38777 m .38794 .37585 L .4207 .39403 L p 1 0 0 r
F P
0 0 0 r
s
.70747 .13298 m .77632 .11657 L .79898 .14158 L 1 0 0 r
F
.51929 .11529 m .61426 .12422 L .54872 .14036 L F
.45477 .13174 m .51929 .11529 L .54872 .14036 L F
.79858 .89046 m .72963 .89355 L .70497 .88874 L p F P
0 0 0 r
s
.63699 .8919 m .70497 .88874 L .72963 .89355 L p 1 0 0 r
F P
0 0 0 r
s
.67894 .88367 m .60957 .887 L .57788 .38867 L p 0 1 1 r
F P
0 0 0 r
s
.57788 .38867 m .64423 .37678 L .67894 .88367 L p 0 1 1 r
F P
0 0 0 r
s
.51233 .88522 m .57788 .38867 L .60957 .887 L p .5 0 1 r
F P
0 0 0 r
s
.64423 .37678 m .57788 .38867 L .54911 .37021 L p 1 0 0 r
F P
0 0 0 r
s
.57788 .38867 m .51233 .88522 L .4838 .38232 L p .5 1 0 r
F P
0 0 0 r
s
.4838 .38232 m .54911 .37021 L .57788 .38867 L p .5 1 0 r
F P
0 0 0 r
s
.54262 .89021 m .47796 .89332 L .44645 .8885 L p 1 0 0 r
F P
0 0 0 r
s
.38286 .89166 m .44645 .8885 L .47796 .89332 L p 1 0 0 r
F P
0 0 0 r
s
.12804 .89142 m .18724 .88825 L .22562 .89308 L p 1 0 0 r
F P
0 0 0 r
s
.68211 .1075 m .77632 .11657 L .70747 .13298 L 1 0 0 r
F
.61426 .12422 m .68211 .1075 L .70747 .13298 L F
.84836 .88209 m .77538 .88548 L .73757 .38324 L p 0 1 1 r
F P
0 0 0 r
s
.73757 .38324 m .80726 .37115 L .84836 .88209 L p 0 1 1 r
F P
0 0 0 r
s
.67894 .88367 m .73757 .38324 L .77538 .88548 L p .5 0 1 r
F P
0 0 0 r
s
.80726 .37115 m .73757 .38324 L .71292 .36447 L p 1 0 0 r
F P
0 0 0 r
s
.73757 .38324 m .67894 .88367 L .64423 .37678 L p .5 1 0 r
F P
0 0 0 r
s
.64423 .37678 m .71292 .36447 L .73757 .38324 L p .5 1 0 r
F P
0 0 0 r
s
.70497 .88874 m .63699 .8919 L .60957 .887 L p 1 0 0 r
F P
0 0 0 r
s
.54262 .89021 m .60957 .887 L .63699 .8919 L p 1 0 0 r
F P
0 0 0 r
s
.54911 .37021 m .4838 .38232 L .45218 .3635 L p 1 0 0 r
F P
0 0 0 r
s
.38794 .37585 m .45218 .3635 L .4838 .38232 L p 1 0 0 r
F P
0 0 0 r
s
.5861 .09825 m .68211 .1075 L .61426 .12422 L 1 0 0 r
F
.51929 .11529 m .5861 .09825 L .61426 .12422 L F
.86998 .88725 m .79858 .89046 L .77538 .88548 L p F P
0 0 0 r
s
.70497 .88874 m .77538 .88548 L .79858 .89046 L p 1 0 0 r
F P
0 0 0 r
s
.71292 .36447 m .64423 .37678 L .61677 .35766 L p 1 0 0 r
F P
0 0 0 r
s
.54911 .37021 m .61677 .35766 L .64423 .37678 L p 1 0 0 r
F P
0 0 0 r
s
.60957 .887 m .54262 .89021 L .51233 .88522 L p .5 0 1 r
F P
0 0 0 r
s
.44645 .8885 m .51233 .88522 L .54262 .89021 L p 1 0 0 r
F P
0 0 0 r
s
.68211 .1075 m .7524 .09019 L .77632 .11657 L 1 0 0 r
F
.71292 .36447 m .78409 .35171 L .80726 .37115 L p F P
0 0 0 r
s
.77538 .88548 m .70497 .88874 L .67894 .88367 L p .5 0 1 r
F P
0 0 0 r
s
.60957 .887 m .67894 .88367 L .70497 .88874 L p 1 0 0 r
F P
0 0 0 r
s
.61677 .35766 m .54911 .37021 L .51874 .35071 L p 1 0 0 r
F P
0 0 0 r
s
.45218 .3635 m .51874 .35071 L .54911 .37021 L p 1 0 0 r
F P
0 0 0 r
s
.65534 .0806 m .7524 .09019 L .68211 .1075 L 1 0 0 r
F
.5861 .09825 m .65534 .0806 L .68211 .1075 L F
.77538 .88548 m .84836 .88209 L .86998 .88725 L p F P
0 0 0 r
s
.78409 .35171 m .71292 .36447 L .68688 .34465 L p 1 0 0 r
F P
0 0 0 r
s
.61677 .35766 m .68688 .34465 L .71292 .36447 L p 1 0 0 r
F P
0 0 0 r
s
.68688 .34465 m .61677 .35766 L .58775 .33745 L p 1 0 0 r
F P
0 0 0 r
s
.51874 .35071 m .58775 .33745 L .61677 .35766 L p 1 0 0 r
F P
0 0 0 r
s
.65534 .0806 m .72713 .0623 L .7524 .09019 L 1 0 0 r
F
.68688 .34465 m .75961 .33116 L .78409 .35171 L p F P
0 0 0 r
s
.75961 .33116 m .68688 .34465 L .65935 .32369 L p 1 0 0 r
F P
0 0 0 r
s
.58775 .33745 m .65935 .32369 L .68688 .34465 L p 1 0 0 r
F P
0 0 0 r
s
.65935 .32369 m .73368 .3094 L .75961 .33116 L p 1 0 0 r
F P
0 0 0 r
s
0 g
.25 Mabswid
.0485 .17995 m
.7105 0 L
s
.06166 .17637 m
.06121 .18342 L
s
gsave
.06258 .16229 -65.968 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.1994 .13893 m
.19907 .14598 L
s
gsave
.20005 .12484 -70.8057 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.34915 .09823 m
.34897 .10528 L
s
gsave
.34952 .08412 -66.1753 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.51259 .0538 m
.51256 .06086 L
s
gsave
.51263 .03969 -71.2475 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.69165 .00512 m
.69181 .01218 L
s
gsave
.69134 -0.00898 -69.8125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.08832 .16913 m
.08806 .17336 L
s
.11541 .16177 m
.11516 .16599 L
s
.14294 .15428 m
.14272 .15851 L
s
.17094 .14667 m
.17072 .1509 L
s
.22834 .13107 m
.22816 .1353 L
s
.25777 .12307 m
.25761 .1273 L
s
.28771 .11493 m
.28756 .11916 L
s
.31817 .10665 m
.31804 .11088 L
s
.38069 .08965 m
.3806 .09389 L
s
.41278 .08093 m
.41271 .08516 L
s
.44546 .07205 m
.4454 .07628 L
s
.47872 .06301 m
.47868 .06724 L
s
.54708 .04442 m
.54709 .04866 L
s
.58221 .03487 m
.58224 .03911 L
s
.61801 .02514 m
.61806 .02938 L
s
.65448 .01523 m
.65455 .01946 L
s
gsave
.35134 .01358 -76.8302 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Indiv) show
88.188 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
91.500 14.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 273.438},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P00014B000`400?l00000o`00003ooooooolQ
ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<
c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07o
oooo003oolc<c23oc<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<
c23oc<c<0Oooool00<;oc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0005Coc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool00<;oc<c<
00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<
00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c003o`000004olc<c?l0003oc<c<o`0000Co
c<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00molc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c01Aolc<c07ooooo001Xolc<c003o`000?o<c<co000000?o
c<c<00?o0000olc<c?l000000oo<c<`2o`000003olc<c?l0003oc<c<00;oc<c<00?o0000olc<c?l0
0000@_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c01Aolc<c07o
oooo001Xolc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l000001?o<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<co000004Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003
o`000?o<c<coc<c<057oc<c<0Oooool006Soc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<
o`000004olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?l00000A?o<c<`00ol0003oc<c<
olc<c002olc<c0Co0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<co000000Coc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<o`00002Qolc<c07ooooo001X
olc<c004o`000?o<c<co0000o`0000;oc<c<00?o0000olc<c?l000000oo<c<`2o`000005olc<c?l0
003oc<c<olc<c?l000000oo<c<`00ol0003oc<c<olc<c02Nolc<c07ooooo001Xolc<c004o`000?o<
c<co0000olc<c0;o00000oo<c<`3o`000004olc<c?l0003oc<c<o`0000;oc<c<00Go0000olc<c?o<
c<coc<c<o`000019olc<c0?o0000E?o<c<`1ooooo`00J?o<c<`00ol0003oc<c<olc<c00:olc<c003
o`000?o<c<coc<c<01coc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0002?o
c<c<0ol00002olc<c003o`000?o<c<coc<c<05;oc<c<0Oooool006Soc<c<00?o0000olc<c?o<c<`0
2_o<c<`00ol0003oc<c<o`00000Lolc<c003o`000?o<c<coc<c<00Koc<c<00?o0000olc<c?o<c<`0
0_o<c<`00ol0003oc<c<olc<c00Lolc<c0Co000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<
olc<c01Aolc<c07ooooo002Eolc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`06?o<
c<`4o`0000Goc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c01@olc<c07ooooo002E
olc<c003o`000?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0000ooc<c<00?o0000
olc<c?o<c<`0Coo<c<`1ooooo`00U_o<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<
00;oc<c<00?o0000olc<c?o<c<`04Oo<c<`4o`0000?oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0
003oc<c<olc<c00:olc<c003o`000?o<c<coc<c<047oc<c<0Oooool009Koc<c<00?o0000olc<c?o<
c<`01?o<c<`5o`00013oc<c<1?l0000Iolc<c003o`000?o<c<coc<c<00Woc<c<00?o0000olc<c?o<
c<`0@Oo<c<`1ooooo`00Uoo<c<`00ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00ooc<c<
0ol00002olc<c003o`000?o<c<coc<c<01Woc<c<00?o0000olc<c?o<c<`02?o<c<`00ol0003oc<c<
olc<c011olc<c07ooooo002Holc<c003o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?o<c<`02_o<
c<`4o`0002;oc<c<00?o0000olc<c?o<c<`01oo<c<`00ol0003oc<c<olc<c011olc<c07ooooo002C
olc<c0Ko00001Oo<c<`5o`0000Coc<c<1?l000000oo<c<co0000olc<c00Solc<c003o`000?o<c<co
c<c<00Ooc<c<00?o0000olc<c?o<c<`0@Oo<c<`1ooooo`00Y?o<c<`3o`0000Goc<c<00?o0000olc<
c?o<c<`08_o<c<`3o`0000Ooc<c<00?o0000olc<c?o<c<`0@Oo<c<`1ooooo`00Loo<c<`4o`0002Wo
c<c<1Ol0000^olc<c003o`000?o<c<coc<c<00?oc<c<0ol00013olc<c07ooooo001bolc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`08_o<c<`4o`0000Coc<c<00?o0000olc<c?o<c<`0
;Oo<c<`00ol0003oc<c<olc<c004olc<c003o`000?o<c<coc<c<00Ko0000>oo<c<`1ooooo`00Moo<
c<`00ol0003oc<c<olc<c00Oolc<c0?o0000>Oo<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<
c<coc<c<o`00043oc<c<0Oooool007Ooc<c<00?o0000olc<c?o<c<`06oo<c<`4o`0000;oc<c<00?o
0000olc<c?o<c<`0>?o<c<`00ol0003oc<c<olc<c006olc<c003o`000?o<c<coc<c<03goc<c<0Ooo
ool007;oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Golc<c0Co00001_o<c<`0
0ol0003oc<c<olc<c00iolc<c003o`000?o<c<coc<c<00Koc<c<0_l0000molc<c07ooooo001bolc<
c0Go00005oo<c<`3o`0000;oc<c<00?o0000olc<c?o<c<`0=_o<c<`2ool000Woc<c<0_l00009olc<
c003o`000?o<c<coc<c<03[oc<c<0Oooool007;oc<c<00?o0000olc<c?o<c<`05Oo<c<`4o`0003[o
c<c<1ooo0008olc<c0;o00002_o<c<`00ol0003oc<c<olc<c00iolc<c07ooooo001colc<c003o`00
0?o<c<coc<c<013oc<c<1?l000000oo<c<co0000olc<c00folc<c0goo`002Oo<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<coc<c<00;oc<c<1Ol0000golc<c07ooooo001colc<c0Go00002oo<
c<`3o`0003Woc<c<4_oo0009olc<c005o`000?o<c<coc<c<olc<c?l000001?o<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<coc<c<03Coc<c<0Oooool007ooc<c<1?l000000oo<c<co0000olc<
c00eolc<c1Ooo`002Oo<c<`01?l0003oc<c<olc<c?o<c<`5o`0000Coc<c<00?o0000olc<c?o<c<`0
=?o<c<`1ooooo`00BOo<c<`6o`0000;oc<c<00?o0000olc<c?o<c<`01?l0000Solc<c0Co0000>Oo<
c<`Kool000Woc<c<00?o0000olc<c?o<c<`02Oo<c<`00ol0003oc<c<olc<c00dolc<c07ooooo0019
olc<c003o`000?o<c<coc<c<00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00M
olc<c0?o000000?oc<c<o`000?o<c<`0=oo<c<`Oool000Woc<c<00?o0000olc<c?o<c<`01Oo<c<`3
o`0003Ooc<c<0Oooool004[oc<c<00?o0000olc<c?o<c<`02oo<c<`00ol0003oc<c<olc<c00Iolc<
c0Co00001?o<c<`00ol0003oc<c<olc<c00colc<c2?oo`001oo<c<`3o`0000Woc<c<00?o0000olc<
c?o<c<`0=?o<c<`1ooooo`00Boo<c<`2o`0000_oc<c<00?o0000olc<c?o<c<`05_o<c<`3o`000003
olc<c?l0003oc<c<03Soc<c<9ooo0008olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c00dolc<c07ooooo001=olc<c003o`000?o<c<coc<c<00?oc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c0Co00001?o<c<`00ol0003oc<c<
olc<c00colc<c2coo`002?o<c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<
c<`00_o<c<`00ol0003oc<c<olc<c00_olc<c07ooooo001>olc<c003o`000?o<c<coc<c<00;oc<c<
1Ol0000Aolc<c0Go0000>Oo<c<`aool000Soc<c<00Co0000olc<c?o<c<coc<c<1?l00005olc<c003
o`000?o<c<coc<c<02ooc<c<0Oooool004Woc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<
olc<c002olc<c003o`000?o<c<coc<c<013oc<c<0ol00004olc<c003o`000?o<c<coc<c<03?oc<c<
=_oo0008olc<c003o`000?o<c<coc<c<00Goc<c<1_l0000`olc<c07ooooo0019olc<c003o`000?o<
c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`00ol0003oc<c<olc<c00;olc<c0Go0000>?o<
c<`kool000Soc<c<00?o0000olc<c?o<c<`01?o<c<`01Ol0003oc<c<olc<c?o<c<co0000037oc<c<
0Oooool004[oc<c<1?l00006olc<c0Go00001Oo<c<`4o`0000Coc<c<00?o0000olc<c?o<c<`0<_o<
c<`oool000Soc<c<0_l00006olc<c004o`000?o<c<coc<c<o`00037oc<c<0Oooool002ooc<c<1?l0
000Xolc<c0?o000000?oc<c<o`000?o<c<`0=_o<c<a4ool000Woc<c<00?o0000olc<c?o<c<`01?o<
c<`01?l0003oc<c<o`000?o<c<`4o`0002coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<
c<`00ol0003oc<c<olc<c00Qolc<c0Co0000>Oo<c<a8ool000Woc<c<00?o0000olc<c?o<c<`00oo<
c<`01?l0003oc<c<o`000?l00004olc<c003o`000?o<c<coc<c<02Woc<c<0Oooool002koc<c<00?o
0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Molc<c0Co000000?oc<c<o`000?o<c<`0=_o<
c<a=ool000Soc<c<00?o0000olc<c?o<c<`01?o<c<`2o`0000Goc<c<00?o0000olc<c?o<c<`04?o<
c<`4o`000004olc<c?l0003oc<c<olc<c0Co00000_o<c<`01ol0003oc<c<olc<c?o<c<co0000olc<
c?l000001?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<01[o
c<c<0ol0000iolc<c3coo`000_moo`0Dool000Soc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003o
c<c<olc<c003olc<c003o`000?o<c<coc<c<00ooc<c<00?o0000olc<c?o<c<`00_o<c<`2o`000003
olc<c?l0003oc<c<00?oc<c<00?o0000olc<c?l000000oo<c<`00ol0003oc<c<olc<c004olc<c07o
oooo000^olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`05_o<c<`4o`000003olc<
c?l0003oc<c<03Coc<c<?Ooo0007ogoo01Coo`002?o<c<`00ol0003oc<c<olc<c004olc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03_o<c<`00ol0003oc<c<olc<c004olc<c003o`00
0?o<c<co000000Koc<c<00Go0000olc<c?o<c<coc<c<o`000006olc<c07ooooo000^olc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`04_o<c<`4o`0000Goc<c<00?o0000olc<c?o<c<`0
;_o<c<`Pool000CoOol06_oo000<ogoo017oo`000ol0ool7olc<c0;o00001Oo<c<`5o`00017oc<c<
00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<o`000005o`000003olc<c?l0003oc<c<00;oc<c<
00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;_o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<
c<coc<c<00ooc<c<0ol00002olc<c003o`000?o<c<coc<c<033oc<c<8?oo000:ogoo01Goo`004Omo
o`0<ool000So0?oo2?o<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00;oc<c<1?l0
000=olc<c004o`000?o<c<coc<c<olc<c0Co000000?oc<c<o`000?o<c<`00oo<c<`00ol0003oc<c<
o`000003olc<c003o`000?o<c<coc<c<00Coc<c<0Oooool002koc<c<00?o0000olc<c?o<c<`00_o<
c<`00ol0003oc<c<olc<c00;olc<c0Co0000=Oo<c<`Nool0017oOol03ooo0004o`3ooa;oOol01ooo
000=o`3oo`Soc<c<00?o0000olc<c?o<c<`00_o<c<`01?l0003oc<c<olc<c?l00004olc<c003o`00
0?o<c<coc<c<00[oc<c<00?o0000olc<c?o<c<`01_o<c<`00ol0003oc<c<olc<c002olc<c004o`00
0?o<c<co0000o`0000;oc<c<00?o0000olc<c?o<c<`01?o<c<`1ooooo`00;oo<c<`4o`0000[oc<c<
1?l00003olc<c003o`000?o<c<coc<c<02ooc<c<7Ooo0004o`3ooa?oOol02Ooo000:o`3ooa;oOol0
0_oo000Bo`3oo`Soc<c<00Co0000olc<c?o<c<coc<c<1Ol00003olc<c003o`000?o<c<coc<c<00[o
c<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c004o`0000;oc<c<00Co0000olc<c?l0
003o00001oo<c<`1ooooo`00>_o<c<`4o`0003Goc<c<7?oo0009o`3ooa?oOol00ooo000@o`3oo`oo
Ool01?mo0?lCo`3oo`Ooc<c<00?o0000olc<c?o<c<`01?o<c<`00ol0003oc<c<olc<c002olc<c003
o`000?o<c<coc<c<00_oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00Bolc<c07o
oooo000folc<c0Co00000oo<c<`00ol0003oc<c<olc<c00_olc<c1goo`003Ol0ool@ogoo00?oO`3o
4ol0ool9ogoo00[oO`3o4?l0ool2ool000Soc<c<0_l00004olc<c0;o00000oo<c<`00ol0003oc<c<
olc<c00<olc<c0Co00005Oo<c<`1ooooo`00<_o<c<`4o`000003olc<c?l0003oc<c<037oc<c<7_oo
000Bo`3oo`_oOol02?mo0?lCo`3oo`?oOol04?mo0?l;o`3oo`Ooo`001_o<c<`00ol0003oc<c<o`00
0004olc<c003o`000?o<c<co000000;o000000?oc<c<o`000?o<c<`09Oo<c<`1ooooo`00;oo<c<`3
o`0003?oc<c<7ooo000Go`3oo`OoOol03?mo0?l@o`3oo`Coo`004_mo0?l7o`3oo`_oo`002?o<c<`0
1Ol0003oc<c<olc<c?o<c<co000000Goc<c<00?o0000olc<c?o<c<`09?o<c<`1ooooo`00;Oo<c<`2
o`000003olc<c?l0003oc<c<02ooc<c<1?l0oolJool001go0?oo0_moo`0Aogl0o`_o0?oo2Ooo000B
ogl0o`;o0?oo4?oo0008olc<c005o`000?o<c<coc<c<olc<c?l000000oo<c<`00ol0003oc<c<o`00
000Uolc<c07ooooo000]olc<c004o`000?o<c<coc<c<o`0002goc<c<2?l0oolDool0023o0?oo1?oo
000Bogl0o`Oo0?oo3Ooo000?ogl0oaGoo`002?o<c<`01?l0003oc<c<olc<c?o<c<`3o`0000;oc<c<
00?o0000olc<c?o<c<`08oo<c<`1ooooo`00;Oo<c<`01?l0003oc<c<olc<c?mVIVHYolc<c0go0?oo
3ooo000Oo`3oo`[oo`004_mo0?l2o`3ooa;oo`002Omo0?lKool000Soc<c<0_l00007olc<c003o`00
0?o<c<coc<c<02;oc<c<0Oooool002goc<c<0_l000000oo<c<coIVIVolc<c00Uolc<c1;o0?oo2_oo
000Mo`3ooa3oo`003omo0?lGool000?oO`3o7_oo0003ogl0o`Koc<c<00?o0000olc<c?l000001oo<
c<`00ol0003oc<c<o`000003o`0001ooc<c<0Oooool002goc<c<00Co0000olc<c?o<c<coIVIV8_o<
c<`4ool001?o0?oo1_oo000Lo`3ooaGoo`002Omo0?lhool000WoO`3o1oo<c<`00ol0003oc<c<olc<
c006olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`07?o<c<`1ooooo`00;Oo<c<`0
1?l0003oc<c<olc<c?mVIVHMolc<c0_oo`004_l0ool2ool001[o0?oo6ooo0003ogl0ocSoo`003omo
0?l7olc<c003o`000?o<c<coc<c<00Goc<c<0_l00003olc<c003o`000?o<c<coc<c<01coc<c<0Ooo
ool002goc<c<00Co0000olc<c?o<c<coIVIV6Oo<c<`Aool000ko0?oo1?mo0?lEo`3ooeWoo`004_mo
0?l7olc<c003o`000?o<c<coc<c<00Ko00000oo<c<`00ol0003oc<c<olc<c00Lolc<c07ooooo000]
olc<c004o`000?o<c<coc<c<ofIVIQWoc<c<4_oo0008o`3oo`[oO`3o4?l0oomNool001;oO`3o1oo<
c<`2o`0000Goc<c<1?l0000Oolc<c07ooooo000]olc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<4_oo
0002o`3ooa3oO`3o2ol0oomRool000ooO`3o0_moo`06olc<c003o`000?o<c<co000000Coc<c<00?o
0000olc<c?o<c<`00_o<c<`3o`0001coc<c<0Oooool002coc<c<00Go0000olc<c?o<c<coc<c<ofIV
IP0Molc<c1;oo`004Omo0?l6o`3oofOoo`002Omo0?l8ogoo00Soc<c<00Go0000olc<c?o<c<coc<c<
o`000003olc<c0;o00000_o<c<`00ol0003oc<c<olc<c00Iolc<c07ooooo000/olc<c004o`000?o<
c<coc<c<ofIVIQooc<c<4_oo000Aogl0o`;o0?ooJooo0003ogl0o`koOol02?o<c<`01?l0003oc<c<
olc<c?l00004olc<c005o`000?o<c<coc<c<olc<c?l000006_o<c<`1ooooo`00;?o<c<`01?l0003o
c<c<olc<c?mVIVHQolc<c1;oo`003Omo0?m]ool000;o0?oo4_moo`08olc<c003o`000?o<c<coc<c<
00Oo000000?oc<c<o`000?o<c<`06Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHSolc<
c17oo`001omo0?m]ool000So0?oo4_moo`06olc<c0?o00001?o<c<`01?l0003oc<c<olc<c?o<c<`2
o`0001[oc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV9?o<c<`Aool000;oO`3oK?oo000>
o`3oo`ooOol00ooo0007olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00_o<c<`0
0ol0003oc<c<o`000004olc<c0Co00004?o<c<`1ooooo`00;?o<c<`2o`000003olc<c?mVIVKoc<c<
02Goc<c<N?oo0003ogl0oa7o0?oo2Omoo`09ool000Ooc<c<00Go0000olc<c?o<c<coc<c<o`000004
olc<c003o`000?o<c<co000000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c00=
olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIRSoc<c<LOoo0009ogl0oa7o0?oo0omoo`0?
ool000Ooc<c<00Co0000olc<c?o<c<co00001?o<c<`00ol0003oc<c<o`000003olc<c003o`000?o<
c<coc<c<00;oc<c<00?o0000olc<c?o<c<`03Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mV
IVHYolc<c6_oo`003omo0?l>o`3oo`CoOol04Ooo0007olc<c003o`000?o<c<coc<c<00Co00000_o<
c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?o<c<`03Oo<c<`1ooooo`00;?o<
c<`01?l0003oc<c<olc<c?mVIVH[olc<c6Soo`004Omo0?l8o`3oo`[oOol04?oo0006olc<c0?o0000
1oo<c<`01Ol0003oc<c<olc<c?o<c<co000000Coc<c<00?o0000olc<c?l000003Oo<c<`1ooooo`00
;?o<c<`01?l0003oc<c<olc<c?mVIVH]olc<c6Ooo`004Omo0?l2o`3ooa3oOol04?oo0008olc<c003
o`000?o<c<coc<c<00Coc<c<00Go0000olc<c?o<c<coc<c<o`000004olc<c003o`000?o<c<co0000
00goc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV;_o<c<aWool001;oO`3o4Omoo`0@ool0
00Ooc<c<00?o0000olc<c?o<c<`00_o<c<`3o`0000?oc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0
003oc<c<o`00000=olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVIS3oc<c<I_oo000Bogl0
o`koOol00_l0oolAool000Ooc<c<00?o0000olc<c?o<c<`00oo<c<`01Ol0003oc<c<olc<c?o<c<co
000000Coc<c<00?o0000olc<c?l000003Oo<c<`1ooooo`00;?o<c<`01?l0003oc<c<olc<c?mVIVHb
olc<c6Goo`004_mo0?l8ogoo00So0?oo4Ooo0006olc<c0?o00000oo<c<`01?l0003oc<c<olc<c?o<
c<`5o`0000;oc<c<1ol00007olc<c07ooooo000/olc<c004o`000?o<c<coc<c<ofIVISCoc<c<IOoo
000Aogl0o`;oOol03_l0ool>ool000?o0?oo1oo<c<`00ol0003oc<c<olc<c005olc<c005o`000?o<
c<coc<c<olc<c?l000000_o<c<`2o`0000coc<c<0Oooool002coc<c<00Co0000olc<c?o<c<coIVIV
=_o<c<aTool000koO`3o0ooo000@o`3oo`Soo`002Ol0ool7olc<c003o`000?o<c<coc<c<00;oc<c<
0ol00003olc<c0Co000000?oc<c<o`000?o<c<`02_o<c<`1ooooo`00;?o<c<`2o`000003olc<c?mV
IVKoc<c<02Soc<c<00?oIVIVolc<c?o<c<`03?o<c<aSool000SoO`3o2Ooo000@o`3oo`;oo`003ol0
ool7olc<c003o`000?o<c<coc<c<00?oc<c<00Go0000olc<c?o<c<coc<c<o`000002olc<c003o`00
0?o<c<coc<c<00;o00002Oo<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003ofIV
I_o<c<coc<c<00koc<c<H_oo0002ogl0o`ooo`003?l0ool4ogl0oa7o0?oo1_o<c<`2o`0000Coc<c<
00Go0000olc<c?o<c<coc<c<o`000002olc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<
c<`01_o<c<`1ooooo`00:oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003ofIVI_o<c<coc<c<013o
c<c<L_oo0004o`3oo`coO`3o3_l0ool3ogl0o`Ooc<c<00?o0000olc<c?o<c<`01Oo<c<`00ol0003o
c<c<olc<c006olc<c003o`000?o<c<coc<c<00Goc<c<0Oooool002_oc<c<00Co0000olc<c?o<c<co
IVIV:_o<c<`00omVIVKoc<c<olc<c00Aolc<c7?oo`003omo0?l8o`3oo`WoO`3o0oo<c<`00omVIVKo
c<c<olc<c006olc<c0?o00000oo<c<`00ol0003oc<c<olc<c002olc<c003o`000?o<c<coc<c<00Go
c<c<0Oooool002_oc<c<00Co0000olc<c?o<c<coIVIV:_o<c<`00omVIVKoc<c<olc<c00Colc<c7;o
o`003omo0?l2o`3oo`ooO`3o0_o<c<`00omVIVKoc<c<olc<c008olc<c005o`000?o<c<coc<c<olc<
c?l000001?o<c<`00ol0003oc<c<olc<c005olc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIV
IR[oc<c<00?oIVIVolc<c?o<c<`05Oo<c<aaool000_oO`3o1?oo000Aogl0o`03olc<c?mVIVKoc<c<
00Woc<c<00?o0000olc<c?o<c<`00_o<c<`4o`0000Soc<c<0Oooool002_oc<c<00Co0000olc<c?o<
c<coIVIV:_o<c<`00omVIVKoc<c<olc<c00Folc<c77oo`000omo0?l<ool000koO`3o0oo<c<`00omV
IVKoc<c<olc<c00Iolc<c07ooooo000[olc<c004o`000?o<c<coc<c<ofIVIR[oc<c<00?oIVIVolc<
c?o<c<`06?o<c<aIool000Go00008Ooo0008ogl0o`Soc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1oooo
o`00:oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003ofIVI_o<c<coc<c<01Woc<c<D_oo0006o`00
00Goo`0000?o0000ool00?oo00007ooo0002ogl0o`goc<c<00?oIVIVolc<c?o<c<`06Oo<c<`1oooo
o`00:oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003ofIVI_o<c<coc<c<01_oc<c<B_oo0006o`00
00coo`0000?o0000ool00?oo00006ooo000Bolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool002_o
c<c<0_mVIVH00ol0003oIVIVolc<c00Yolc<c003ofIVI_o<c<coc<c<01goc<c<@_oo0006o`0001?o
o`0000?o0000ool00?oo00004ooo000Iolc<c003ofIVI_o<c<coc<c<01Woc<c<0Oooool0023oc<c<
1?l00007olc<c004o`000?o<c<coIVIVofIVIR[oc<c<00?oIVIVolc<c?o<c<`07_o<c<`kool000Ko
00001Ooo00000ol0003oo`00ool0000Bool00003o`000?oo003oo`0000coo`007oo<c<`00omVIVKo
c<c<olc<c00Iolc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`0
1?o<c<`00ol0003oc<c<olc<c003ofIVIRSoc<c<00?oIVIVolc<c?o<c<`08?o<c<`dool000Go0000
3?oo0002o`0001?oo`000_l00005ool000Coc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<
olc<c00Iolc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<
c<`01?l0003oc<c<olc<c?mVIVH2olc<c0;oIVIV9_o<c<`00omVIVKoc<c<olc<c00Rolc<c2coo`00
1_l0000Cool00003o`000?oo003oo`0000Ooo`001_l00005ool00003o`000?o<c<coc<c<00Koc<c<
00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<
c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH4olc<c0?oIVIV
8_o<c<`00omVIVKoc<c<olc<c00Tolc<c2Koo`001Ol00005ool00003o`000?oo003oo`0001;oo`00
00Co0000ool00?oo003oo`001Ol0000<ool00003o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<
c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`000?o<c<coc<c<00;oc<c<
00?o0000olc<c?o<c<`01?o<c<`01?l0003oc<c<olc<c?mVIVH7olc<c0;oIVIV8?o<c<`00omVIVKo
c<c<olc<c00Volc<c1ooo`001Ol0000;ool000;o00004ooo0003o`0001;oo`0000?o0000olc<c?o<
c<`01?o<c<`00omVIVKoc<c<olc<c00Polc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool001ooc<c<
00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c003olc<c005o`000?o<c<coc<c<olc<c?mV
IVH02Oo<c<`2ofIVIQkoc<c<00?oIVIVolc<c?o<c<`09oo<c<`Hool000Ko00004_oo00000ol0003o
o`00ool00007ool000Ko00001Ooo00000ol0003oo`00ool0000Aool00003o`000?o<c<coc<c<00?o
c<c<00?oIVIVolc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Oolc<c003o`00
0?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?mVIVH<olc<c0;o
IVIV7?o<c<`00omVIVKoc<c<olc<c00Yolc<c17oo`001Ol00005ool00003o`000?oo003oo`00017o
o`0000Co0000ool00?oo003oo`001Ol0000<ool00003o`000?oo003oo`00017oo`000_l00003olc<
c003ofIVI_o<c<coc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`007oo<c<`00ol0003o
c<c<olc<c002olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000olc<c?o<c<coIVIV3_o<c<`2ofIV
IQ[oc<c<00?oIVIVolc<c?o<c<`0:oo<c<`:ool000Go00002ooo0002o`0001;oo`000ol0000Bool0
0003o`000?oo003oo`0000Ooo`001_l00005ool00004o`000?o<c<coc<c<ofIVIR;oc<c<00?oIVIV
olc<c?o<c<`06?o<c<`1ooooo`008?o<c<`4o`0000Koc<c<00Co0000olc<c?o<c<coIVIV4?o<c<`2
ofIVIQSoc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00;olc<c0?oo`001Ol0000B
ool00003o`000?oo003oo`0000Ooo`001Ol00005ool00003o`000?oo003oo`00017oo`0000Co0000
ool00?oo003oo`001Ol0000<ool00003o`000?o<c<coIVIV02;oc<c<00?oIVIVolc<c?o<c<`06?o<
c<`1ooooo`00:_o<c<`2o`000003olc<c?mVIVKoc<c<017oc<c<0_mVIVHFolc<c003ofIVI_o<c<co
c<c<01ooc<c<00?oIVIVolc<c?o<c<`02Oo<c<`5o`0000Coo`0000?o0000ool00?oo00004Ooo0000
1?l0003oo`00ool00?oo0005o`0000_oo`000_l0000Bool000?o00004_oo00000ol0003oIVIVolc<
c00Qolc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV5?o<
c<`2ofIVIQCoc<c<00?oIVIVolc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c004olc<c0Go00002_oo
0002o`0001;oo`000ol0000Bool00003o`000?oo003oo`0000Ooo`001Ol00005ogoo0003o`000?oo
003oo`00017oo`0000?o0000olc<c?o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Z
olc<c004o`000?o<c<coc<c<ofIVIQKoc<c<0_mVIVHBolc<c003ofIVI_o<c<coc<c<01ooc<c<00?o
IVIVolc<c?l000001?l0000Aool000;o00002Ooo0005o`0000CoOol00_l0000Bool00004o`000?oo
003oo`00ool000Go00002omoo`02o`0000Woo`001Ol00003o`3oo`03o`000?mVIVKoc<c<023oc<c<
00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHHolc<c0?oIVIV
3oo<c<`00omVIVKoc<c<olc<c00Lolc<c0Go00001?oo00000ol0003oo`00ool0000Aool00004o`00
0?oo003oo`00ool000Go00002omoo`000ol0003oo`00ool0000@ool000?o00004_moo`001?l0003o
o`00ool00?oo0005o`0000So0?oo00?o0000ofIVI_o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<
c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIVIQ_oc<c<0_mVIVH=olc<c003ofIVI_o<c<coc<c<
01Ooc<c<1Ol0000:ool000;o00004_oo0003o`00017oOol00_l00004ool000So00001?l0ool00ol0
003oOol0ogoo000Cogoo00?o00003Ol0ool00ol0003oIVIVolc<c00Polc<c003ofIVI_o<c<coc<c<
01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV7Oo<c<`2ofIVIP_oc<c<00?oIVIVolc<
c?o<c<`04_o<c<`5o`00017oo`000_l00009ool000Go00000_l0ool00ol0003oOol0ogoo000Cogoo
00Co00003?l0ool00ol0003oOol0ogoo000Cogoo0003o`000?l0oooo0?oo00go0?oo00?o0000ofIV
I_o<c<`08?o<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<ofIV
IQooc<c<0_mVIVH9olc<c003ofIVI_o<c<coc<c<00goc<c<1Ol00004ool000;o00004_oo00001?l0
003oo`00ool00?oo0005o`0000Oo0?oo00?o0000ogoo0?moo`004omoo`000ol0003o0?ooo`3oo`0=
o`3oo`03o`000?moo`3oOol001?oOol000?o0000o`3oool0ool03Ol0ool00ol0003oIVIVolc<c00P
olc<c003ofIVI_o<c<coc<c<01Soc<c<0Oooool002[oc<c<00Co0000olc<c?o<c<coIVIV8Oo<c<`2
ofIVIPOoc<c<00?oIVIVolc<c?o<c<`02?o<c<`5o`0000_oo`000_l0000Aool000?o00003?l0ool0
0ol0003oOol0ogoo000Cogoo0003o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004omoo`00
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?mVIVKoc<c<023oc<c<00?oIVIVolc<c?o<c<`06?o<c<`1
ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHSolc<c0;oIVIV1Oo<c<`00omVIVKoc<c<olc<c006
olc<c0;o00004_oo0002o`0000Coo`001ol0000Co`3oo`03o`000?moo`3oOol001?oOol000?o0000
o`3oool0ool03Ol0ool00ol0003oOol0ogoo000Cogoo0003o`000?l0oooo0?oo00ko0?oo00?o0000
olc<c?o<c<`07oo<c<`00omVIVKoc<c<olc<c00Holc<c07ooooo000Zolc<c004o`000?o<c<coc<c<
ofIVIRGoc<c<0_mVIVH3olc<c003ofIVI_o<c<coc<c<00Koc<c<00Co0000o`3oool0003o00004_oo
0004o`0001[o0?oo00?o0000ogoo0?moo`004omoo`000ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol001;oOol00_l0000@o`3oo`03o`000?o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`06?o<
c<`1ooooo`00:_o<c<`01?l0003oc<c<olc<c?mVIVHWolc<c0;oIVIV00?oc<c<ofIVI_o<c<`01oo<
c<`01?l0003o0?ooo`3oool0ool2o`0000Woo`001Ol0000Po`3oo`03o`000?moo`3oOol001;oOol0
0_l0000?o`3oo`03o`000?moo`3oOol001;oOol00_l0000@o`3oo`03o`000?o<c<coc<c<01ooc<c<
00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:_o<c<`2o`000003olc<c?mVIVKoc<c<02Soc<c<0omV
IVH7olc<c003o`000?l0oooo0?oo00?o0?oo0_l00002ool000Go00005_l0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?moo`3oOol001;oOol00_l0000@o`3oo`03o`000?moo`3oOol0017oOol00_l0
000@o`3oo`03o`000?o<c<coc<c<01ooc<c<00?oIVIVolc<c?o<c<`06?o<c<`1ooooo`00:Oo<c<`0
1Ol0003oc<c<olc<c?o<c<coIVIV02[oc<c<00CoIVIVolc<c?mVIVKoIVIV1?o<c<`00ol0003o0?oo
o`3oo`06o`3oo`;o00006ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol001;oOol0
0_l0000@o`3oo`03o`000?moo`3oOol0017oOol000?o0000ogl0ool000003ol0ool00ol0003oc<c<
olc<c00Polc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV
:oo<c<`01?mVIVKoc<c<olc<c?o<c<`2ofIVIP;oc<c<00?o0000o`3oool0ool01_l0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000Bogoo00;o00004?l0ool00ol0003oOol0ogoo000Aogoo0003o`000?mo0?oo000000oo
0?oo00?o0000olc<c?o<c<`08?o<c<`4ofIVIQKoc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<co
IVIV:oo<c<`00omVIVKoc<c<olc<c003olc<c0;oIVIV00?o0000o`3oool0ool01_l0ool00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000Bogoo0003o`000?mo0?oo000000oo0?oo00?o0000ogoo0?moo`004Omoo`000ol0003o
O`3oo`00000?o`3oo`03o`000?o<c<coc<c<00_oc<c<0_l0000<olc<c0SoIVIV6Oo<c<`1ooooo`00
:Oo<c<`01?l0003oc<c<olc<c?mVIVH[olc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0
ool01_l0ool00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03Ol0ool00ol0003oOol0ogoo000Aogoo0003o`000?mo0?oo000000oo0?oo00?o0000ogoo0?mo
o`004Omoo`000ol0003oO`3oo`00000?o`3oo`03o`000?o<c<coc<c<00_oc<c<00Co0000ogoo0?l0
003o00001?o<c<`6ofIVIPOoc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<c<`01?l0003o
c<c<olc<c?mVIVH[olc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool01Ol0ool2o`00
00go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0
017oOol000?o0000ogl0ool000003ol0ool00ol0003oOol0ogoo000Aogoo0003o`000?mo0?oo0000
00oo0?oo00?o0000olc<c?o<c<`02oo<c<`01Ol0003oOol0ogoo0?moo`3o000000?oIVIV3Oo<c<`0
0omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIR_oc<c<00?oIVIV
olc<c?o<c<`01Oo<c<`00ol0003o0?ooo`3oo`05o`3oo`;o00003Ol0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`004?moo`001?l0003oO`3oogl0ool0
000?o`3oo`03o`000?moo`3oOol0017oOol000?o0000ogl0ool000003ol0ool00ol0003oc<c<olc<
c006olc<c0GoIVIV00?o0000ogoo0?moo`000_moo`000ol0003oc<c<olc<c00=olc<c003ofIVI_o<
c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV:oo<c<`00omVIVKoc<c<olc<
c004olc<c003o`000?l0oooo0?oo00Ko0?oo0_l0000=o`3oo`03o`000?l0oooo0?oo00go0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0004o`000?mo0?ooO`3oo`0000oo0?oo
00?o0000ogoo0?moo`004?moo`001?l0003oO`3oogl0ool0000?o`3oo`03o`000?o<c<coIVIV00Ko
IVIV0_o<c<`4o`0000CoOol000?oo`00o`000?o<c<`03Oo<c<`00omVIVKoc<c<olc<c00Golc<c07o
oooo000Yolc<c004o`000?o<c<coc<c<ofIVIR[oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`00ol0003o
0?ooo`3oo`06o`3oo`;o00003Ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`004?moo`001?l0003oO`3oogl0ool0000?o`3oo`03o`000?moo`3oOol0
013oOol000Co0000ogl0oomo0?oo00003ol0ool00ol0003oIVIVolc<c003olc<c0Go00000_moo`00
0omo0?oo0000ogoo0003ogoo00;oo`0000?o0000olc<c?o<c<`02oo<c<`00omVIVKoc<c<olc<c00G
olc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIR[oc<c<00?oIVIVolc<c?o<c<`01Oo<c<`0
0ol0003o0?ooo`3oo`06o`3oo`;o00003_l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`004?moo`001?l0003oO`3oogl0ool0000?o`3oo`03o`000?mo
o`3oOol0013oOol000Co0000ogl0oomo0?oo00004?l0ool5o`0000OoOol000?oO`3oo`000?moo`00
0omoo`03ool00003o`000?o<c<coc<c<00[oc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:Oo<
c<`01?l0003oc<c<olc<c?mVIVHZolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool0
1_l0ool2o`0000ko0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?moo`3oOol0013oOol000Co0000ogl0oomo0?oo00003ol0ool00ol0003oOol0ogoo000@ogoo0004
o`000?mo0?ooO`3oo`00013o0?oo00?o0000o`3oool000002Omoo`000omo0?oo0000ogoo0003ogoo
00Coo`000_l0000:olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<0_l000000oo<c<co
IVIVolc<c00Yolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000o`3oool0ool01Ol0ool00ol0003o
O`3oo`00000>o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000@ogoo0004o`000?mo0?ooO`3oo`0000oo0?oo00?o0000ogoo0?moo`004?moo`001?l0
003oO`3oogl0ool0000@o`3oo`03o`000?l0oooo000000WoOol000?oO`3oo`000?moo`000_moo`00
0ol0003oo`00ool00004ool00003o`000?o<c<coc<c<00Ooc<c<00?oIVIVolc<c?o<c<`05oo<c<`1
ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003ofIVI_o<c<coc<c<00Goc<c<00?o0000
o`3oool0ool01Ol0ool00ol0003oO`3oo`00000>o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo000@ogoo0004o`000?mo0?ooO`3oo`0000oo0?oo00?o
0000ogoo0?moo`004?moo`001?l0003oO`3oogl0ool0000@o`3oo`03o`000?l0oooo000000WoOol0
00?oO`3oo`000?moo`000_moo`08ool00003o`000?o<c<coc<c<00Koc<c<00?oIVIVolc<c?o<c<`0
5oo<c<`1ooooo`00:Oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003ofIVI_o<c<coc<c<00Coc<c<
00?o0000o`3oool0ool01_l0ool01?l0003oO`3oogl0ool0000=o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000?ogoo0005o`000?mo0?ooO`3oogl0
ool000003ol0ool00ol0003oOol0ogoo000@ogoo0004o`000?mo0?ooO`3oo`00013o0?oo00?o0000
o`3oool000002Omoo`000omo0?oo0000ogoo0002ogoo00Woo`0000?o0000olc<c?o<c<`01Oo<c<`0
0omVIVKoc<c<olc<c00Golc<c07ooooo000Yolc<c004o`000?o<c<coc<c<ofIVIR[oc<c<00?oIVIV
olc<c?o<c<`01?o<c<`00ol0003o0?ooo`3oo`06o`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o
0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ooOol000Go
0000ogl0oomo0?ooO`3oo`00000?o`3oo`03o`000?moo`3oOol0013oOol000Go0000ogl0oomo0?oo
O`3oo`00000?o`3oo`03o`000?l0oooo000000WoOol000?oO`3oo`000?moo`000_moo`02ool000Go
00000_l0ool00ol0003oc<c<olc<c005olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<
00Co0000olc<c?o<c<coIVIV:_o<c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo00Ko
0?oo00Co0000ogl0oomo0?oo00003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000ogoo0?moo`003omoo`001Ol0003oO`3oogl0oomo0?oo0000013o0?oo00?o0000
ogoo0?moo`003_moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
o`3oool000002?moo`02ogl0o`04o`000?moo`3oOol0ogoo00;o00001ol0ool00ol0003oc<c<olc<
c005olc<c003ofIVI_o<c<coc<c<01Ooc<c<0Oooool002Woc<c<00Co0000olc<c?o<c<coIVIV:_o<
c<`00omVIVKoc<c<olc<c004olc<c003o`000?l0oooo0?oo00Ko0?oo00Co0000ogl0oomo0?oo0000
3Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
3omoo`001Ol0003oO`3oogl0oomo0?oo0000013o0?oo00?o0000ogoo0?moo`003_moo`000ol0003o
O`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000o`3oool000002?moo`02ogl0o`04
o`000?moo`3oOol0ogoo00Wo0?oo00?o0000olc<c?o<c<`01Oo<c<`00omVIVKoc<c<olc<c00Golc<
c07ooooo000Xolc<c004o`000?o<c<coc<c<ofIVIR_oc<c<00?oIVIVolc<c?o<c<`01?o<c<`00ol0
003o0?ooo`3oo`06o`3oo`04o`000?mo0?ooO`3oo`0000go0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ooOol000Go0000ogl0oomo0?ooO`3oo`00
000@o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3o
o`0=o`3oo`03o`000?l0oooo000000SoOol00_mo0?l01?l0003oOol0ogoo0?moo`09o`3oo`03o`00
0?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:?o<c<`01?l0003oc<c<olc<
c?mVIVH[olc<c003ofIVI_o<c<coc<c<00Coc<c<00?o0000o`3oool0ool01Ol0ool01Ol0003oO`3o
ogl0oomo0?oo000000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000ooOol000Go0000ogl0oomo0?ooO`3oo`00000@o`3oo`03o`000?moo`3oOol0
00koOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0000
00SoOol00_mo0?l00ol0003oOol0ogoo000:o`3oo`03o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<
c?o<c<`05oo<c<`1ooooo`00:?o<c<`01?l0003oc<c<olc<c?mVIVH[olc<c003ofIVI_o<c<coc<c<
00?oc<c<00?o0000o`3oool0ool01_l0ool01Ol0003oO`3oogl0oomo0?oo000000go0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000ooOol000Go0000
ogl0oomo0?ooO`3oo`00000@o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00_mo
0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo000000SoOol00_mo0?l00ol0003oOol0ogoo
000:o`3oo`03o`000?o<c<coc<c<00Goc<c<00?oIVIVolc<c?o<c<`05oo<c<`1ooooo`00:?o<c<`0
1?l0003oc<c<olc<c?mVIVH[olc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3oool0ool01_l0
ool01Ol0003oO`3oogl0oomo0?oo000000go0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000ooOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000koOol000?o0000ogl0oomo0?l00_mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?l0oooo000000SoOol00_mo0?l00ol0003oOol0ogoo000;o`3oo`03o`00
0?o<c<coc<c<00?oc<c<00?o0000olc<c?mVIVH06?o<c<`1ooooo`00:?o<c<`3o`000003ofIVI_o<
c<coc<c<02Woc<c<00?oIVIVolc<c?o<c<`00oo<c<`00ol0003o0?ooo`3oo`06o`3oo`05o`000?mo
0?ooO`3oogl0ool000003Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogoo0?moo`003_moo`000ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00ko0?oo
0_l00007ogoo00?oO`3o00?o0000ogoo0?moo`002ol0ool00ol0003oc<c<olc<c003olc<c003o`00
0?o<c<coIVIV01Soc<c<0Oooool001coc<c<1_l00006olc<c0;oIVIV00?oc<c<ofIVI_o<c<`0:_o<
c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo00Ko0?oo00Go0000ogl0oomo0?ooO`3o
o`00000=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo000>ogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo000>ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03_l0ool2o`0000OoOol0
0omo0?l00ol0003oOol0ogoo000;o`3oo`03o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?mVIVH0
6?o<c<`1ooooo`007?o<c<`00ol0003oc<c<olc<c009olc<c003o`000?o<c<coIVIV00;oIVIV:_o<
c<`00omVIVKoc<c<olc<c003olc<c003o`000?l0oooo0?oo00Ko0?oo00Go0000ogl0oomo0?ooO`3o
o`00000=o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0
ogoo000>ogoo0003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0
ogoo000>ogoo0003o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03_l0ool2o`0000OoOol0
0omo0?l00ol0003oOol0ogoo000;o`3oo`03o`000?o<c<coc<c<00?oc<c<00?o0000olc<c?mVIVH0
6?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c008olc<c005o`000?o<c<coc<c<ofIVI_o<c<`0
0omVIVHWolc<c003ofIVI_o<c<coc<c<00?oc<c<00?o0000o`3oool0ool01Ol0ool00ol0003oO`3o
ogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000goOol000?o0000ogl0oomo0?l00omo0?l00ol0003o0?oo
o`3oo`0>o`3oo`;o00001omoo`03ogl0o`03o`000?moo`3o0?oo00_o0?oo00?o0000olc<c?o<c<`0
0oo<c<`00ol0003oc<c<ofIVIP0Holc<c07ooooo000Nolc<c0;o00002?o<c<`01?l0003oc<c<olc<
c?mVIVH4olc<c0?oIVIV9?o<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo00Ko0?oo
00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00?oO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?ooO`3o00?oO`3o
00?o0000o`3oool0ool03_l0ool2o`0000OoOol00omo0?l00ol0003oOol0o`3oo`0;o`3oo`03o`00
0?o<c<coc<c<00?oc<c<00?o0000olc<c?mVIVH06?o<c<`1ooooo`008?o<c<`00ol0003oc<c<olc<
c005olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<0omVIVHQolc<c003ofIVI_o<c<coc<c<00;oc<c<
00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00_o0?oo
00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000goOol0
00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000goOol0
00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o00001omoo`03ogl0o`03o`00
0?moo`3o0?oo00_o0?oo00?o0000olc<c?o<c<`00_o<c<`01?mo0?oo0000olc<c?mVIVHHolc<c07o
oooo000Qolc<c003o`000?o<c<coc<c<00Coc<c<00Co0000olc<c?o<c<coIVIV2_o<c<`3ofIVIQko
c<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o00;o
O`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00go
0?oo00?o0000ogoo0?moo`003Omoo`000ol0003oO`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go
0?oo0_l00007ogoo00?oO`3o00?o0000ogoo0?l0ool02ol0ool00ol0003oc<c<olc<c002olc<c004
ogl0ool0003oc<c<ofIVIQSoc<c<0Oooool001coc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003o
c<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIPgoc<c<0omVIVHKolc<c003ofIVI_o<c<coc<c<
00;oc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol0
00coOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol0
00goOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`;o00001_moo`04ogl0
o`03o`000?moo`3o0?oo00_o0?oo00?o0000olc<c?o<c<`00_o<c<`01?mo0?oo0000olc<c?mVIVHH
olc<c07ooooo000Lolc<c003o`000?o<c<coc<c<00;oc<c<00?o0000olc<c?o<c<`01?o<c<`01?l0
003oc<c<olc<c?mVIVH@olc<c0;oIVIV6Oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo
0?oo00Ko0?oo00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?oo
O`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000=ogoo0003o`000?mo0?oo
O`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool2o`0000KoOol01?mo0?l00ol0003oOol0o`3oo`0;
o`3oo`03o`000?o<c<coc<c<00;oc<c<00CoO`3oo`000?o<c<coIVIV6?o<c<`1ooooo`000oo<c<`0
0ol0003oc<c<olc<c003olc<c003o`000?o<c<coc<c<00;o00000_o<c<`00ol0003oc<c<olc<c00:
olc<c0Co00001oo<c<`01?l0003oc<c<olc<c?mVIVHBolc<c0?oIVIV5_o<c<`00omVIVKoc<c<olc<
c002olc<c003o`000?l0oooo0?oo00Go0?oo00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
000<ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo
000<ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0ool03Ol0ool2o`0000KoOol01?mo
0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?o<c<coc<c<00;oc<c<00CoO`3oo`000?o<c<coIVIV
6?o<c<`1ooooo`000oo<c<`00ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001_oc<c<
00Co0000olc<c?o<c<coIVIV5Oo<c<`3ofIVIQ?oc<c<00?oIVIVolc<c?o<c<`00_o<c<`00ol0003o
0?ooo`3oo`05o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`003?moo`000ol0003o
O`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`003?moo`000ol0003o
O`3oogl0o`04ogl0o`03o`000?l0oooo0?oo00go0?oo0_l00006ogoo00CoO`3o00?o0000o`3oool0
ool03?l0ool02?l0003oc<c<olc<c?o<c<coO`3oo`000?o<c<coIVIV6?o<c<`1ooooo`000oo<c<`0
0ol0003oc<c<olc<c003olc<c004o`000?o<c<coc<c<o`0001[oc<c<00Go0000olc<c?o<c<coc<c<
ofIVIP0Holc<c0?oIVIV4?o<c<`01OmVIVKoc<c<olc<c?o<c<co000000So0?oo00?o0000ogl0oomo
0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?ooO`3o00CoO`3o00?o0000o`3oool0
ool03_l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0
ool03Ol0ool2o`0000KoOol01?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`08o`000?o<c<coc<c<olc<
c?mo0?oo0000olc<c?mVIVHHolc<c07ooooo0003olc<c003o`000?o<c<coc<c<00?oc<c<00Co0000
olc<c?o<c<co00006_o<c<`2o`000003olc<c?mVIVKoc<c<01_oc<c<0omVIVH=olc<c005ofIVI_o<
c<coc<c<olc<c?l000002?l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol0
00?o0000ogl0oomo0?l01?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000_oOol0
00?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000CoOol0
1?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00;oO`3o00?o0000olc<c?mVIVH0
6?o<c<`1ooooo`000oo<c<`7o`0000;oc<c<00?o0000olc<c?o<c<`06?o<c<`01?l0003oc<c<olc<
c?mVIVHOolc<c0?oIVIV2Oo<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo00Ko0?oo
00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo000<ogoo0003o`000?mo0?ooO`3o00CoO`3o
00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00GoO`3o
00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0003ogoo00GoO`3o00?o0000o`3oool0ool0
3?l0ool00ol0003oc<c<olc<c002ogl0o`03o`000?o<c<coIVIV01Soc<c<0Oooool000?oc<c<00?o
0000olc<c?o<c<`00oo<c<`01?l0003oc<c<olc<c?l0000Jolc<c004o`000?o<c<coc<c<ofIVIR;o
c<c<0_mVIVH7olc<c003ofIVI_o<c<coc<c<00;oc<c<00?o0000o`3oool0ool01_l0ool00ol0003o
O`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000coOol000?o0000ogl0oomo0?l01?mo0?l00ol0003o
0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o
0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000?oOol01Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?o<c<coc<c<00;oO`3o00?o0000olc<c?mVIVH06?o<c<`1ooooo`000oo<c<`00ol0003oc<c<
olc<c003olc<c003o`000?o<c<co000000;o00006Oo<c<`01?l0003oc<c<olc<c?mVIVHTolc<c0?o
IVIV1?o<c<`00omVIVKoc<c<olc<c002olc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo
0?l01?mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03?l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0
ool03_l0ool00ol0003oOol0ogoo000;ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0
ool03_l0ool00ol0003oOol0ogoo0003ogoo00GoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
c<c<olc<c002ogl0o`03o`000?o<c<coIVIV01Soc<c<0Oooool000?oc<c<00?o0000olc<c?o<c<`0
1_o<c<`00ol0003oc<c<olc<c00Holc<c004o`000?o<c<coc<c<ofIVIROoc<c<0omVIVH00oo<c<co
IVIVolc<c003olc<c003o`000?l0oooo0?oo00Go0?oo00?o0000ogl0oomo0?l01Omo0?l00ol0003o
0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo000;ogoo0003o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo000;ogoo0003o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool03_l0ool00ol0003o
Ool0ogoo0003ogoo00GoO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c002ogl0o`03
o`000?o<c<coIVIV01Soc<c<0Oooool000?oc<c<1ol00002olc<c003o`000?o<c<coc<c<01Soc<c<
00Co0000olc<c?o<c<coIVIV:_o<c<`3ofIVIP;oc<c<00?o0000o`3oool0ool01_l0ool00ol0003o
O`3oogl0o`05ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o
0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o
0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000?oOol01Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?o<c<coc<c<00;oO`3o00?o0000olc<c?mVIVH06?o<c<`1ooooo`009oo<c<`01?l0003oc<c<
olc<c?mVIVH[olc<c005ofIVI_o<c<coIVIVofIVI_l000002?l0ool00ol0003oO`3oogl0o`05ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0=o`3o
o`03o`000?moo`3oOol000_oOol000?o0000ogl0oomo0?l01Omo0?l00ol0003o0?ooo`3oo`0>o`3o
o`03o`000?moo`3oOol000?oOol01Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<
00;oO`3o00?o0000olc<c?mVIVH01?mVIVHDolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIV
IR_oc<c<00GoIVIVolc<c?o<c<coc<c<o`000008o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000
o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogoo0?moo`002omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogoo0?moo`000omoo`05ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000ofIVI_mVIVH00_mo0?l0
1?l0003oIVIVolc<c?mVIVHGolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIR_oc<c<00Go
IVIVolc<c?o<c<coc<c<o`000008o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool0
2ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`00
2omoo`000ol0003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
2_moo`000ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`00
0_moo`06ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?mo0?l00_mo0?l01?l0003oc<c<
olc<c?mVIVHGolc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIR_oc<c<00GoIVIVolc<c?o<
c<coc<c<o`000008o`3oo`03o`000?mo0?ooO`3o00GoO`3o00?o0000o`3oool0ool02ol0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002omoo`000ol0
003oO`3oogl0o`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002_moo`000ol0
003oO`3oogl0o`07ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`06ogl0
o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?mo0?l00_mo0?l01?l0003oc<c<olc<c?mVIVHG
olc<c07ooooo000Wolc<c004o`000?o<c<coc<c<ofIVIR_oc<c<00GoIVIVolc<c?o<c<coc<c<o`00
0007o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0
o`07ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`002_moo`000ol0003oO`3oogl0
o`07ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`000_moo`06ogl0o`03o`000?l0
oooo0?oo00go0?oo00Go0000ogl0oomo0?ooO`3oo`000002olc<c003ofIVI_o<c<coc<c<01Goc<c<
0Oooool002Ooc<c<0_l000000oo<c<coIVIVolc<c00Zolc<c004ofIVI_o<c<coc<c<o`0000So0?oo
00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00OoO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo000:ogoo0003o`000?mo0?ooO`3o00OoO`3o
00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo00KoO`3o00?o0000o`3oool0ool0
3Ol0ool01Ol0003oO`3oogl0oomo0?oo000000;oc<c<00?oIVIVolc<c?o<c<`05Oo<c<`1ooooo`00
9oo<c<`01?l0003oc<c<olc<c?mVIVH[olc<c004ofIVI_o<c<coc<c<o`0000So0?oo00?o0000ogl0
oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03Ol0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3o
ool0ool03_l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3o
ool0ool03_l0ool01?l0003oOol0ogoo0?moo`06ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogl0oomo0?l00_mo0?l00ol0003oc<c<ofIVIP0Golc<c07ooooo000Wolc<c004o`000?o<c<coc<c<
ofIVIR_oc<c<00CoIVIVolc<c?o<c<co00002?l0ool00ol0003oO`3oogl0o`06ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000WoOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo
o`3oOol000WoOol000?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0>o`3oo`04o`000?mo
o`3oOol0ogoo00KoO`3o0_l0000>o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000olc<c?mVIVH0
5oo<c<`1ooooo`009oo<c<`01?l0003oc<c<olc<c?mVIVH[olc<c004ofIVI_o<c<coc<c<o`0000So
0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00Oo
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00Oo
O`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0007ogl0o`;o00003_l0ool00ol0003o
O`3oogl0o`02ogl0o`03o`000?o<c<coIVIV01Ooc<c<0Oooool002Koc<c<00Go0000olc<c?o<c<co
c<c<ofIVIP0[olc<c004ofIVI_o<c<coc<c<o`0000So0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03_l0ool00ol0
003oOol0ogoo0009ogoo0003o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03_l0ool00ol0
003oOol0ogoo0007ogl0o`;o00003_l0ool00ol0003oO`3oogl0o`02ogl0o`03o`000?o<c<coIVIV
01Ooc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV;?o<c<`01?mVIVKoc<c<olc<c?l00007
o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002Omoo`000ol0003oO`3oogl0o`07
ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`002?moo`000ol0003oO`3oogl0o`08
ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`001omo0?l2o`0000ko0?oo00?o0000
ogl0oomo0?l00_mo0?l00ol0003oc<c<ofIVIP0Golc<c07ooooo000Volc<c004o`000?o<c<coc<c<
ofIVIRcoc<c<00?oIVIVolc<c?l000002?l0ool00ol0003oO`3oogl0o`07ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3o
Ool000SoOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3o
Ool000SoOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3o
Ool000OoO`3o0_l0000>o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000olc<c?mVIVH05oo<c<`1
ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVH/olc<c003ofIVI_o<c<co000000So0?oo00?o0000
ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000
o`3oool0ool03_l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00SoO`3o00?o0000
o`3oool0ool03_l0ool00ol0003oOol0ogoo0007ogl0o`;o00003_l0ool00ol0003oO`3oogl0o`02
ogl0o`03o`000?o<c<coIVIV01Ooc<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV;?o<c<`0
0omVIVKoc<c<o`000008o`3oo`03o`000?mo0?ooO`3o00OoO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`002?moo`00
0ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`002?moo`00
0ol0003oO`3oogl0o`08ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`001omo0?l2
o`0000ko0?oo00?o0000ogl0oomo0?l00_mo0?l00ol0003oc<c<ofIVIP0Golc<c07ooooo000Volc<
c004o`000?o<c<coc<c<ofIVIRcoc<c<00?oIVIVolc<c?l000002?l0ool00ol0003oO`3oogl0o`07
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0>
o`3oo`03o`000?moo`3oOol000SoOol000?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0=
o`3oo`03o`000?moo`3oOol000OoO`3o0_l0000>o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000
olc<c?mVIVH05oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVH/olc<c003ofIVI_o<c<co
000000So0?oo00?o0000ogl0oomo0?l01omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?oo
O`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?oo
O`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogl0o`07ogl0o`;o00003_l0ool0
0ol0003oO`3oogl0o`02ogl0o`03o`000?o<c<coIVIV01Ooc<c<0Oooool002Koc<c<0_l000000oo<
c<coIVIVolc<c00[olc<c003ofIVI_o<c<co000000Oo0?oo00?o0000ogl0oomo0?l02?mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0
003oOol0ogl0o`07ogl0o`;o00003ol0ool01ol0003oO`3oogl0oomo0?oo0000olc<c?mVIVH05oo<
c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVH/olc<c003ofIVI_l0003o0?oo00Oo0?oo00?o
0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0008ogoo0003o`000?mo0?ooO`3o00WoO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oOol0ogl0o`07ogl0o`;o00003ol0ool01ol0003oO`3oogl0
oomo0?oo0000olc<c?mVIVH05oo<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVH/olc<c003
ofIVI_l0003o0?oo00Oo0?oo00?o0000ogl0oomo0?l02?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0008ogoo0003
o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0008ogoo0003
o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogl0o`07ogl0o`03
o`000?mo0?oo000000ko0?oo00Oo0000ogl0oomo0?ooO`3oo`000?o<c<coIVIV01Ooc<c<0Oooool0
02Koc<c<00Co0000olc<c?o<c<coIVIV;?o<c<`00omVIVKo0000o`3oo`07o`3oo`03o`000?mo0?oo
O`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo
0?oo00go0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03o`000?l0oooo
0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oO`3oo`00000>o`3oo`05o`000?mo0?oo
O`3oogl0ool000000_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Volc<c004o`000?o<c<co
c<c<ofIVIR_oc<c<00?oIVIVolc<c?l000002?l0ool00ol0003oO`3oogl0o`09ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000OoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?mo
o`3oOol000OoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo
0?ooO`3o00KoO`3o00?o0000ogl0ool000003_l0ool01Ol0003oO`3oogl0oomo0?oo000000;oc<c<
00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVH[olc<c003ofIV
I_o<c<co000000So0?oo00?o0000ogl0oomo0?l02Omo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0007ogoo0003o`00
0?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0006ogoo0003o`00
0?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`06ogl0o`03o`00
0?mo0?oo000000ko0?oo00Go0000ogl0oomo0?ooO`3oo`000002olc<c003ofIVI_o<c<coc<c<01Co
c<c<0Oooool002Koc<c<00Co0000olc<c?o<c<coIVIV:oo<c<`00omVIVKoc<c<o`000008o`3oo`03
o`000?mo0?ooO`3o00WoO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001omoo`000ol0003oO`3oogl0o`0:ogl0o`03
o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3oogl0o`0:ogl0o`03
o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oO`3oo`00000>o`3oo`05
o`000?mo0?ooO`3oogl0ool000000_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Volc<c004
o`000?o<c<coc<c<ofIVIR_oc<c<00?oIVIVo`000?l0ool01ol0ool00ol0003oO`3oogl0o`0:ogl0
o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3o
o`03o`000?moo`3oOol000OoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0>o`3o
o`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0>o`3o
o`03o`000?mo0?ooO`3o00KoO`3o00?o0000ogl0ool000003_l0ool01Ol0003oO`3oogl0oomo0?oo
000000;oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`009_o<c<`01?l0003oc<c<olc<c?mVIVH[
olc<c003ofIVI_l0003o0?oo00Oo0?oo00?o0000ogl0oomo0?l02_mo0?l00ol0003o0?ooo`3oo`0;
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0006
ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0006
ogoo0003o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`06
ogl0o`03o`000?mo0?oo000000ko0?oo00Go0000ogl0oomo0?ooO`3oo`000002olc<c003ofIVI_o<
c<coc<c<01Coc<c<0Oooool002Goc<c<00Co0000olc<c?o<c<coIVIV;?o<c<`00omVIVKo0000o`3o
o`07o`3oo`03o`000?mo0?ooO`3o00[oO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3oogl0
o`0:ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`001_moo`000ol0003oO`3oogl0
o`0:ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01_mo0?l00ol0003oO`3oo`00
000>o`3oo`05o`000?mo0?ooO`3oogl0ool000000_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo
000Uolc<c004o`000?o<c<coc<c<ofIVIRcoc<c<00?oIVIVo`000?l0ool01ol0ool00ol0003oO`3o
ogl0o`0:ogl0o`03o`000?l0oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l02omo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?moo`3oOol000KoOol000?o0000ogl0oomo0?l02_mo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?mo0?ooO`3o00KoO`3o00?o0000ogl0ool000003_l0ool01Ol0003oO`3o
ogl0oomo0?oo000000;oc<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<
olc<c005olc<c0CoIVIV;?o<c<`00omVIVKo0000o`3oo`07o`3oo`03o`000?mo0?ooO`3o00[oO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogl0oomo0?l01_mo0?l00ol0003oO`3oo`00000?o`3oo`04o`000?mo0?ooO`3oo`0000;o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c003o`00
0?o<c<coc<c<00CoIVIV:Oo<c<`00omVIVKo0000o`3oo`07o`3oo`03o`000?mo0?ooO`3o00[oO`3o
00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogl0oomo0?l01_mo0?l00ol0003oO`3oo`00000?o`3oo`04o`000?mo0?ooO`3oo`0000;o
c<c<00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`006Oo<c<`6o`0000Koc<c<00Co0000olc<c?o<c<co
IVIV0oo<c<`4ofIVIRGoc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0;ogl0o`03
o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03
o`000?moo`3oOol000GoOol000?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03
o`000?mo0?ooO`3o00KoO`3o00Co0000ogl0oomo0?oo00003_l0ool01?l0003oO`3oogl0ool00002
olc<c003ofIVI_o<c<coc<c<01Coc<c<0Oooool001Woc<c<00Go0000olc<c?o<c<coc<c<o`000007
olc<c004o`000?o<c<coc<c<ofIVIPOoc<c<1OmVIVHPolc<c003o`000?l0oooo0?oo00Ko0?oo00?o
0000ogl0oomo0?l02omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00_oO`3o00?o
0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00coO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`06ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo
00Co0000ogl0oomo0?oo00000_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Jolc<c004o`00
0?o<c<coc<c<o`0000Ooc<c<00Co0000olc<c?o<c<coIVIV3?o<c<`4ofIVIQcoc<c<00?o0000o`3o
ool0ool01_l0ool00ol0003oO`3oogl0o`0;ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0
oomo0?l02omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000GoOol000?o0000ogl0
oomo0?l03?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00GoO`3o00Co0000ogl0
oomo0?oo00003_l0ool01?l0003oO`3oogl0ool00002olc<c003ofIVI_o<c<coc<c<01Coc<c<0Ooo
ool001_oc<c<00?o0000olc<c?l000001oo<c<`01?l0003oc<c<olc<c?mVIVH@olc<c0CoIVIV6?o<
c<`00ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o00_oO`3o00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001Omo
o`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000ogoo0?moo`001Omo
o`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01Omo
0?l01?l0003oO`3oogl0ool0000>o`3oo`04o`000?mo0?ooO`3oo`0000;oc<c<00?oIVIVolc<c?o<
c<`05?o<c<`1ooooo`006oo<c<`00ol0003oc<c<o`000007olc<c004o`000?o<c<coc<c<ofIVIQCo
c<c<1?mVIVHDolc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l02omo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o
Ool0ogoo0004ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03Ol0ool00ol0003o
Ool0ogoo0005ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03_l0ool00ol0003o
O`3oogl0o`05ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo00Co0000ogl0oomo0?oo00000_o<c<`0
0omVIVKoc<c<olc<c00Dolc<c07ooooo000Lolc<c0;o00001oo<c<`01?l0003oc<c<olc<c?mVIVHH
olc<c0CoIVIV4?o<c<`00ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o00_oO`3o00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000
ogoo0?moo`001?moo`000ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00go0?oo00?o0000
ogoo0?moo`001Omoo`000ol0003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000
ogl0oomo0?l01Omo0?l01?l0003oO`3oogl0ool0000>o`3oo`04o`000?mo0?ooO`3oo`0000;oc<c<
00?oIVIVolc<c?o<c<`05?o<c<`1ooooo`007Oo<c<`00ol0003oc<c<olc<c005olc<c004o`000?o<
c<coc<c<ofIVIQcoc<c<1?mVIVH;olc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l0
3?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool0
3?l0ool00ol0003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool0
3Ol0ool00ol0003oOol0ogoo0005ogoo0003o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool0
3_l0ool00ol0003oO`3oogl0o`05ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo00Co0000ogl0oomo
0?oo00000_o<c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIV
IR3oc<c<1OmVIVH6olc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003oOol0ogoo0004ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03_l0ool00ol0
003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03_l0ool00ol0
003oO`3oogl0o`05ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo00Co0000ogl0oomo0?oo00000_o<
c<`00omVIVKoc<c<olc<c00Dolc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIVIRGoc<c<1?mV
IVH2olc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l03?mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo
0004ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo
0003ogoo0003o`000?mo0?ooO`3o00goO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0
o`05ogl0o`04o`000?mo0?ooO`3oo`0000ko0?oo00Co0000ogl0oomo0?oo00000_o<c<`00omVIVKo
c<c<olc<c00Dolc<c07ooooo000Uolc<c004o`000?o<c<coc<c<ofIVIRWoc<c<0_mVIVH00ol0003o
0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03?l0ool00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`000ol0003o
O`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`000omoo`000ol0003o
O`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01Omo0?l01?l0003o
O`3oogl0ool0000>o`3oo`04o`000?mo0?ooO`3oo`0000?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1
ooooo`009Oo<c<`2o`000003olc<c?mVIVKoc<c<02[oc<c<00?o0000o`3oool0ool01_l0ool00ol0
003oO`3oogl0o`0<ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000CoOol000?o0000ogl0oomo0?l03Omo0?l00ol0
003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000?oOol000?o0000ogl0oomo0?l03Omo0?l00ol0
003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00GoO`3o00Co0000ogl0oomo0?oo00003ol0ool0
0ol0003oO`3oo`000007ofIVIQ;oc<c<0Oooool002Goc<c<00Co0000olc<c?o<c<coIVIV:oo<c<`0
0ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o00coO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?moo`001?moo`00
0ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogoo0?moo`000omoo`00
0ol0003oO`3oogl0o`0=ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l01Omo0?l0
1?l0003oO`3oogl0ool0000?o`3oo`03o`000?mo0?oo000000?oc<c<00?oIVIVolc<c?o<c<`04oo<
c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVH[olc<c003o`000?l0oooo0?oo00Ko0?oo00?o
0000ogl0oomo0?l03Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o
0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00koO`3o00?o
0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0003ogoo0003o`000?mo0?ooO`3o00koO`3o00?o
0000o`3oool0ool03Ol0ool00ol0003oO`3oogl0o`05ogl0o`05o`000?mo0?ooO`3oogl0ool00000
3_l0ool00ol0003oO`3oo`000003olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co
0000olc<c?o<c<coIVIV:oo<c<`00ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o00koO`3o
00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo
00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00ko0?oo
00?o0000ogoo0?moo`000omoo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00go0?oo
00?o0000ogl0oomo0?l01Omo0?l01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000ogl0ool0
00000oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<ofIVIR_o
c<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo0?oo00_o
0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?moo`3oOol000?o
Ool000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3oOol000?o
Ool000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00Co
O`3o00Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?mo0?oo000000?oc<c<00?oIVIVolc<
c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVH[olc<c003o`000?l0oooo0?oo
00Ko0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0;o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03Ol0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o
00koO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0002ogoo0003o`000?mo0?ooO`3o
00ooO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`05o`000?mo0?ooO`3o
ogl0ool000003_l0ool00ol0003oO`3oo`000003olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool0
02Coc<c<00Co0000olc<c?o<c<coIVIV:oo<c<`00ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?oo
O`3o00koO`3o00?o0000o`3oool0ool02ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00go0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0>ogl0o`03o`000?l0oooo
0?oo00ko0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo
0?oo00ko0?oo00?o0000ogl0oomo0?l01?mo0?l01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o
0000ogl0ool000000oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<co
c<c<ofIVIR_oc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0>ogl0o`03o`000?l0
oooo0?oo00_o0?oo00?o0000o`3oool0ool03Ol0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
o`3oOol000;oOol000?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo
o`3oOol000;oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo
0?ooO`3o00CoO`3o00Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?mo0?oo000000?oc<c<
00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVH[olc<c003o`00
0?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l03_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oOol0ogoo0002ogoo0003o`00
0?mo0?ooO`3o00koO`3o00?o0000o`3oool0ool03_l0ool00ol0003oOol0ogoo0002ogoo0003o`00
0?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`05o`00
0?mo0?ooO`3oogl0ool000003_l0ool00ol0003oO`3oo`000003olc<c003ofIVI_o<c<coc<c<01?o
c<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV:_o<c<`00ol0003o0?ooo`3oo`06o`3oo`03
o`000?mo0?ooO`3o00ooO`3o00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03
o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00000Aogl0o`03o`000?l0oooo0?oo
00ko0?oo00?o0000ogoo0?moo`000_moo`000ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo
00ko0?oo00?o0000ogl0oomo0?l01?mo0?l01Ol0003oO`3oogl0oomo0?oo000000ko0?oo00?o0000
ogl0ool000000oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<c<coc<c<
ofIVIR[oc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`000?moo`3o
Ool0ogoo0?l000004_mo0?l00ol0003o0?ooo`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o
0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o00Go
0000ogl0oomo0?ooO`3oo`00000>o`3oo`03o`000?mo0?oo000000?oc<c<00?oIVIVolc<c?o<c<`0
4oo<c<`1ooooo`009?o<c<`2o`000003olc<c?mVIVKoc<c<02Woc<c<00?o0000o`3oool0ool01_l0
ool00ol0003oO`3oogl0o`0?ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0
ool00ol0003o0?ooo`3oo`0<o`3oo`05o`000?moo`3oOol0ogoo0?l000004_mo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?moo`3oOol000;oOol000?o0000ogl0oomo0?l03omo0?l00ol0003o0?oo
o`3oo`0>o`3oo`03o`000?mo0?ooO`3o00CoO`3o00Go0000ogl0oomo0?ooO`3oo`00000>o`3oo`03
o`000?mo0?oo000000?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<
olc<c?mVIVHZolc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01Ol0003o
Ool0ogoo0?moo`3o000001;oO`3o00?o0000o`3oool0ool03_l0ool01Ol0003oOol0ogoo0?moo`3o
0000017oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`05o`000?mo0?oo
O`3oogl0ool000003ol0ool2o`0000?oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`009?o<c<`0
1?l0003oc<c<olc<c?mVIVHZolc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l03omo
0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0
ool01Ol0003oOol0ogoo0?moo`3o000001;oO`3o00?o0000o`3oool0ool03_l0ool01Ol0003oOol0
ogoo0?moo`3o0000017oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`04ogl0o`03
o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03?l0ool2o`0000?oc<c<00?oIVIVolc<c?o<
c<`04oo<c<`1ooooo`009?o<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003o`000?l0oooo0?oo00Ko
0?oo00?o0000ogl0oomo0?l03omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co
0?oo00?o0000o`3oool0ool03?l0ool01Ol0003oOol0ogoo0?moo`3o000001;oO`3o00?o0000o`3o
ool0ool03_l0ool01?l0003oOol0ogoo0?l0000Bogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000
ogl0oomo0?l01?mo0?l00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00co0?oo0_l00003
olc<c003ofIVI_o<c<coc<c<01?oc<c<0Oooool002Coc<c<00Co0000olc<c?o<c<coIVIV:Oo<c<`0
0ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o013oO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00Go0000ogoo0?moo`3oOol0o`00
000Bogl0o`03o`000?l0oooo0?oo00ko0?oo00Co0000ogoo0?moo`3o00004omo0?l00ol0003o0?oo
o`3oo`0=o`3oo`03o`000?mo0?ooO`3o00CoO`3o00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?oo
o`3oo`0<o`3oo`;o00000oo<c<`00omVIVKoc<c<olc<c00Colc<c07ooooo000Tolc<c004o`000?o<
c<coc<c<ofIVIRWoc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0@ogl0o`03o`00
0?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`05o`00
0?moo`3oOol0ogoo0?l000004_mo0?l00ol0003o0?ooo`3oo`0>o`3oo`04o`000?moo`3oOol0o`00
01?oO`3o00?o0000o`3oool0ool03_l0ool00ol0003oO`3oogl0o`03ogl0o`03o`000?mo0?ooO`3o
00;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oO`3oo`000002olc<c003ofIVI_o<c<coc<c<
01?oc<c<0Oooool002?oc<c<00Go0000olc<c?o<c<coc<c<ofIVIP0Yolc<c003o`000?l0oooo0?oo
00Ko0?oo00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo
00co0?oo00?o0000o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Cogl0o`03o`000?l0oooo
0?oo00ko0?oo00Co0000ogoo0?moo`3o00004omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo
0?ooO`3o00?oO`3o00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo
0?oo000000;oc<c<00?oIVIVolc<c?o<c<`04oo<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mV
IVHZolc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3o
o`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01?l0003oOol0ogoo
0?l0000Cogl0o`03o`000?l0oooo0?oo00ko0?oo00Co0000ogoo0?moo`3o00004omo0?l00ol0003o
0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000ogl0oomo0?l00_mo0?l00ol0003o
0?ooo`3oo`0<o`3oo`03o`000?mo0?oo000000?oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`00
8oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo
0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0
ool03?l0ool01?l0003oOol0ogoo0?l0000Cogl0o`03o`000?l0oooo0?oo00ko0?oo00Co0000ogoo
0?moo`3o00004omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000
ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?oo000000?oc<c<00?oIVIV
olc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHZolc<c003o`000?l0oooo
0?oo00Ko0?oo00?o0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01?l0003oOol0ogoo0?l0000Cogl0o`03o`000?l0
oooo0?oo00ko0?oo00Co0000ogoo0?moo`3o00004omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`00
0?mo0?ooO`3o00?oO`3o00?o0000ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`00
0?mo0?oo000000?oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<
c?mVIVHYolc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?oo
o`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool01?l0003oOol0
ogoo0?l0000Cogl0o`03o`000?l0oooo0?oo00ko0?oo00Co0000ogoo0?moo`3o00004omo0?l00ol0
003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000ogl0oomo0?l00_mo0?l00ol0
003o0?ooo`3oo`0<o`3oo`03o`000?mo0?oo000000?oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1oooo
o`008oo<c<`01?l0003oc<c<olc<c?mVIVHYolc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0
oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03?l0ool01?l0003oOol0ogoo0?l0000Cogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000
ogoo0?l000005?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000
ogl0oomo0?l00_mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?oo000000?oc<c<00?oIVIV
olc<c?o<c<`04_o<c<`1ooooo`008oo<c<`2o`000003olc<c?mVIVKoc<c<02Soc<c<00?o0000o`3o
ool0ool01_l0ool00ol0003oO`3oogl0o`0Aogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3o
ool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`04o`000?moo`3oOol0o`0001?oO`3o00?o0000
o`3oool0ool03_l0ool00ol0003oOol0o`00000Dogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000
ogl0oomo0?l00omo0?l00ol0003oO`3oogl0o`02ogl0o`03o`000?l0oooo0?oo00go0?oo0_l00003
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV:Oo<c<`0
0ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o017oO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogoo0?l000005?mo0?l0
0ol0003o0?ooo`3oo`0>o`3oo`03o`000?moo`3o000001CoO`3o00?o0000o`3oool0ool03_l0ool0
0ol0003oO`3oogl0o`03ogl0o`03o`000?mo0?ooO`3o00;oO`3o00?o0000o`3oool0ool03Ol0ool2
o`0000?oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008oo<c<`01?l0003oc<c<olc<c?mVIVHY
olc<c003o`000?l0oooo0?oo00Ko0?oo00?o0000ogl0oomo0?l04Omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03Ol0ool2o`0001CoO`3o00?o0000
o`3oool0ool03_l0ool00ol0003oOol0o`00000Dogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000
ogl0oomo0?l00omo0?l00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo0_l00003
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV:Oo<c<`0
0ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o01;oO`3o00?o0000o`3oool0ool02ol0ool0
0ol0003o0?ooo`3oo`0=o`3oo`03o`000?l0oooo0?oo00co0?oo0_l0000Dogl0o`03o`000?l0oooo
0?oo00ko0?oo00?o0000ogoo0?l000005?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?oo
O`3o00?oO`3o00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`;o00000oo<c<`0
0omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIRSoc<c<00?o0000
o`3oool0ool01ol0ool00ol0003oO`3oogl0o`0Bogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`;o00005Omo0?l00ol0003o0?ooo`3oo`0>
o`3oo`;o00005?mo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00?oO`3o00?o0000
ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`;o00000oo<c<`00omVIVKoc<c<olc<c00B
olc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIRSoc<c<00?o0000o`3oool0ool01_l0ool0
0ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`;o00005Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o00005Omo0?l0
0ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000ogl0oomo0?l00omo0?l0
0ol0003o0?ooo`3oo`0<o`3oo`;o00000oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<
c004o`000?o<c<coc<c<ofIVIRSoc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0C
ogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<
o`3oo`;o00005Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`;o00005Omo0?l00ol0003o0?ooo`3oo`0>
o`3oo`03o`000?mo0?ooO`3o00;oO`3o00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`;o00000oo<c<`00omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<
ofIVIRSoc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`;o00005Omo0?l0
0ol0003o0?ooo`3oo`0>o`3oo`;o00005Omo0?l00ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?oo
O`3o00;oO`3o00?o0000ogl0oomo0?l00omo0?l00ol0003o0?ooo`3oo`0<o`3oo`;o00000oo<c<`0
0omVIVKoc<c<olc<c00Bolc<c07ooooo000Solc<c004o`000?o<c<coc<c<ofIVIRSoc<c<00?o0000
o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0Cogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000
o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`0<o`3oo`03o`000?mo0?ooO`3o01CoO`3o00?o0000
o`3oool0ool03_l0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000
ogl0oomo0?l00_mo0?l00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo0_l00003
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool002?oc<c<00Co0000olc<c?o<c<coIVIV:?o<c<`0
0ol0003o0?ooo`3oo`06o`3oo`03o`000?mo0?ooO`3o01?oO`3o00?o0000o`3oool0ool03?l0ool0
0ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000ogl0oomo0?l05?mo0?l0
0ol0003o0?ooo`3oo`0>o`3oo`03o`000?mo0?ooO`3o01CoO`3o00?o0000o`3oool0ool03_l0ool0
0ol0003oO`3oogl0o`02ogl0o`03o`000?mo0?ooO`3o00?oO`3o00?o0000o`3oool0ool03?l0ool2
o`0000?oc<c<00?oIVIVolc<c?o<c<`04_o<c<`1ooooo`008_o<c<`01?l0003oc<c<olc<c?mVIVHX
olc<c003o`000?l0oooo0?oo00Oo0?oo00?o0000ogl0oomo0?l04omo0?l00ol0003o0?ooo`3oo`0<
o`3oo`03o`000?l0oooo0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003oO`3oogl0o`0D
ogl0o`03o`000?l0oooo0?oo00ko0?oo00?o0000ogl0oomo0?l05?mo0?l00ol0003o0?ooo`3oo`06
o`3oo`[o00000omo0?l00ol0003oO`3oogl0o`03ogl0o`03o`000?l0oooo0?oo00co0?oo0_l00003
olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Ooc<c<1?l00007olc<c004o`000?o<c<coc<c<
ofIVIRSoc<c<00?o0000o`3oool0ool01_l0ool00ol0003oO`3oogl0o`0Dogl0o`03o`000?l0oooo
0?oo00co0?oo00?o0000o`3oool0ool03?l0ool00ol0003o0?ooo`3oo`05o`3oo`co00004_mo0?l0
0ol0003o0?ooo`3oo`06o`3oo`co00002omo0?lAo`0000[oo`001?l00005ogl0o`03o`000?l0oooo
0?oo00co0?oo0_l00003olc<c003ofIVI_o<c<coc<c<01;oc<c<0Oooool001Koc<c<00?o0000olc<
c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c0KoIVIV7oo<c<`=o`0000?o0?oo00?o0000ogl0
oomo0?l05?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?l0oooo0?oo00Go0?oo3ol0000<ool0
01_o00003?oo000;o`0000coo`002?l0000:ool00003o`000?mo0?ooO`3o00?oO`3o00?o0000o`3o
ool0ool03Ol0ool01Ol0003oc<c<olc<c?o<c<coIVIV01Coc<c<0Oooool001Koc<c<00?o0000olc<
c?o<c<`00_o<c<`00ol0003oc<c<olc<c004olc<c004o`000?o<c<coc<c<ofIVIP;oc<c<2OmVIVH?
olc<c0Oo00003Ooo0009o`0000[oO`3o7_l0000<ool000[o00003?oo0008o`0000Soo`002_l0000<
ool000[o00002_oo0004o`0001;oO`3o00?o0000o`3oool0ool03?l0ool01Ol0003oc<c<olc<c?o<
c<coIVIV01Coc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`00_o<c<`00ol0003oc<c<olc<c004
olc<c004o`000?o<c<coc<c<ofIVIP_oc<c<2OmVIVH<olc<c0_o00003?oo000:o`0000[oo`001?l0
000=ool000[o00003?oo000:o`0000[oo`000ol0000>ool000[o00003?oo0008o`0000Woo`0000?o
0000ogl0oomo0?l04?mo0?l00ol0003o0?ooo`3oo`0<o`3oo`03o`000?o<c<coc<c<00;oc<c<00?o
IVIVolc<c?o<c<`04Oo<c<`1ooooo`005_o<c<`2o`0000?oc<c<00?o0000olc<c?o<c<`01?o<c<`0
1?l0003oc<c<olc<c?mVIVHDolc<c0WoIVIV3?o<c<`:o`0000coo`001ol00009ool000So00003?oo
000:o`0000coo`001ol00009ool000Wo00002ooo000:o`0001;oO`3o00Go0000o`3oool0oooo0?oo
o`00000Cogl0o`03o`000?l0oooo0?oo00co0?oo00?o0000olc<c?o<c<`00_o<c<`00omVIVKoc<c<
olc<c00Aolc<c07ooooo000Folc<c003o`000?o<c<co000000;o00001oo<c<`01?l0003oc<c<olc<
c?mVIVHMolc<c0WoIVIV1oo<c<`00omVIVKoc<c<olc<c002olc<c0[o00002ooo0007o`0000Ooo`00
2_l0000<ool000Wo00002ooo0008o`0000Ooo`002_l0000;ool000Go00002_mo0?l:o`000003o`3o
ool0003oO`3o01;oO`3o00?o0000o`3oool0ool03?l0ool00ol0003oc<c<olc<c002olc<c003ofIV
I_o<c<coc<c<017oc<c<0Oooool001Koc<c<00?o0000olc<c?o<c<`02Oo<c<`01?l0003oc<c<olc<
c?mVIVHVolc<c0WoIVIV2oo<c<`:o`0000_oo`002Ol0000<ool000Ko00001ooo0009o`0000coo`00
1ol00007ool000Wo00002ooo000:o`0000[oo`001Ol0000@ogl0o`03o`000?l0oooo0?oo00Go0?oo
2?l00004olc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool001Ooc<c<00Go0000olc<c?o<c<coc<c<
o`00000golc<c003ofIVI_o<c<coIVIV00SoIVIV2_o<c<`9o`0000_oo`002_l0000:ool000Oo0000
1ooo0009o`0000_oo`002?l0000;ool000Oo00002?oo0008o`0000_oo`006?l00002olc<c0ooIVIV
3oo<c<`1ooooo`006?o<c<`3o`0003Soc<c<00?oIVIVolc<c?o<c<`02?o<c<`9ofIVIPSoc<c<2_l0
000:ool000Wo00002ooo0006o`0000Ooo`002Ol0000:ool000Wo00002ooo0007o`0000Ooo`002?l0
000:ool000Wo00003OmVIVH:olc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool005?oc<c<00?oIVIV
olc<c?o<c<`04Oo<c<`9ofIVIPOoc<c<00?oIVIVolc<c?o<c<`00oo<c<`7o`0000Koo`002Ol0000:
ool000Wo00002_oo0006o`0000Ooo`002?l0000;ool000So00003_mVIVH00oo<c<coIVIVolc<c00R
olc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool005?oc<c<00?oIVIVolc<c?o<c<`06_o<c<`9ofIV
IP_oc<c<2?l0000:ool000Ko00001ooo0008o`0000[oo`002?l0000=ofIVIQgoc<c<00?oIVIVolc<
c?o<c<`08Oo<c<`00omVIVKoc<c<olc<c00Aolc<c07ooooo001golc<c003ofIVI_o<c<coIVIV00So
IVIV1_o<c<`00omVIVKoc<c<o`000007o`0000[oo`002?l0000:ofIVIQOoc<c<00?oIVIVolc<c?o<
c<`07oo<c<`00omVIVKoc<c<olc<c00Qolc<c003ofIVI_o<c<coc<c<017oc<c<0Oooool007Ooc<c<
00?oIVIVolc<c?o<c<`02?o<c<`AofIVIQ;oc<c<00?oIVIVolc<c?o<c<`07Oo<c<`00omVIVKoc<c<
olc<c00Oolc<c003ofIVI_o<c<coc<c<03Goc<c<0Oooool007Ooc<c<00?oIVIVolc<c?o<c<`03_o<
c<`00omVIVKoc<c<olc<c00Jolc<c003ofIVI_o<c<coc<c<01goc<c<00?oIVIVolc<c?o<c<`0Eoo<
c<`1ooooo`00Moo<c<`00omVIVKoc<c<olc<c00>olc<c003ofIVI_o<c<coc<c<01[oc<c<00?oIVIV
olc<c?o<c<`0Moo<c<`1ooooo`00R?o<c<`00omVIVKoc<c<olc<c02Dolc<c07ooooo003oolc<c23o
c<c<0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool0
0<;oc<c<0_l0001Kolc<c07ooooo0033olc<c0;o00000_o<c<`00ol0003oc<c<olc<c01Eolc<c07o
oooo0034olc<c0;o00000_o<c<`00ol0003oc<c<olc<c01Dolc<c07ooooo000kolc<c0Go00001?o<
c<`3o`0000?oc<c<0_l00003olc<c0?o00000_o<c<`4o`0000?oc<c<1Ol00003olc<c0;o00001?o<
c<`2o`0000;oc<c<0ol000000oo<c<co0000o`000002olc<c0;o00000_o<c<`4o`0000?oc<c<1?l0
0003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l00005olc<c0;o00000oo<c<`2o`000003olc<c?l0
003o000000;oc<c<1?l00003olc<c0?o00000oo<c<`3o`0000?oc<c<0_l00004olc<c0?o000000?o
c<c<o`000?l000001_o<c<`4o`000004olc<c?l0003oc<c<olc<c0Co00000_o<c<`2o`0000;oc<c<
0_l00002olc<c0;o00001Oo<c<`2o`0000Goc<c<0_l0000Zolc<c07ooooo000jolc<c0;o00000oo<
c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2o`0000;oc<c<0_l0
0002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<
c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0
003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<
c<`2o`000003olc<c?l0003o000000;oc<c<0_l00004olc<c0;o00000oo<c<`2o`000004olc<c?l0
003o0000olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00003olc<c0;o000000?oc<c<o`000?l00000
0_o<c<`2o`0000Coc<c<0ol000000oo<c<co0000o`000005olc<c0;o00000_o<c<`3o`000003olc<
c?l0003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o00000_o<c<`2o`0000Goc<c<
0_l00005olc<c0;o0000:_o<c<`1ooooo`00>_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`00
0003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`0000;oc<c<0_l00005olc<c0;o00000_o<
c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?o
c<c<o`000?l000002?o<c<`3o`0000Coc<c<0ol000000oo<c<co0000o`000008olc<c0?o00001?o<
c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000004olc<c0?o00000_o<c<`2o`0000;oc<c<0_l0
0003olc<c0;o000000?oc<c<o`000?l000000oo<c<`2o`000003olc<c?l0003o000000Koc<c<0_l0
0004olc<c0;o000000?oc<c<o`000?l000001Oo<c<`2o`0000;oc<c<0_l00009olc<c0;o00001Oo<
c<`2o`0002[oc<c<0Oooool003koc<c<0ol000000oo<c<co0000o`000003olc<c0;o000000?oc<c<
o`000?l000000oo<c<`2o`0000;oc<c<1_l000000oo<c<co0000o`000002olc<c0;o00000oo<c<`2
o`0000Coc<c<0_l00002olc<c0;o00000_o<c<`2o`0000;oc<c<0_l000000oo<c<co0000o`000004
o`0000;oc<c<1?l00003olc<c0Co00000_o<c<`6o`0000;oc<c<1?l00005olc<c0;o00000oo<c<`2
o`000003olc<c?l0003o000000;oc<c<1?l00003olc<c0;o00000_o<c<`2o`0000?oc<c<0_l00000
0oo<c<co0000o`000003olc<c0;o000000?oc<c<o`000?l000001_o<c<`2o`0000Coc<c<0_l00000
0oo<c<co0000o`000004o`000003olc<c?l0003o000000;oc<c<0_l00009olc<c0;o00001Oo<c<`2
o`0002[oc<c<0Oooool003_oc<c<1Ol00002olc<c0;o00000oo<c<`2o`000003olc<c?l0003o0000
00?oc<c<0_l00002olc<c0;o00000_o<c<`2o`000003olc<c?l0003o000000;oc<c<0_l00003olc<
c0Go000000?oc<c<o`000?l000000_o<c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`00
0?l000000_o<c<`2o`000004olc<c?l0003o0000o`0000Coc<c<0ol00004olc<c0;o00000_o<c<`2
o`000004olc<c?l0003o0000o`0000Ooc<c<0_l00003olc<c0;o000000Coc<c<o`000?l0003oc<c<
0ol00005olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000003olc<c0;o0000
00?oc<c<o`000?l000001_o<c<`2o`0000;oc<c<1?l000000oo<c<co0000o`000002olc<c0;o0000
00?oc<c<o`000?l000000_o<c<`2o`0000Woc<c<0_l00005olc<c0;o0000:_o<c<`1ooooo`00>_o<
c<`3o`0000Koc<c<0_l000000oo<c<co0000o`000002olc<c0?o00000_o<c<`2o`0000;oc<c<0_l0
0002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`0000?oc<c<0_l00004olc<c0;o00000_o<
c<`2o`0000;oc<c<0_l00002olc<c0;o000000?oc<c<o`000?l000000_o<c<`2o`000003olc<c?l0
003o000000;oc<c<0_l000000oo<c<co0000o`000002olc<c0;o000000?oc<c<o`000?l000000_o<
c<`2o`000003olc<c?l0003o000000;oc<c<0_l00004olc<c0Oo000000Coc<c<o`000?l0003oc<c<
0_l00002olc<c0;o00000_o<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000002olc<c0?o0000
0_o<c<`2o`000003olc<c?l0003o000000Koc<c<0_l00007olc<c0;o00000_o<c<`2o`000003olc<
c?l0003o000000;oc<c<0_l00009olc<c0;o00001Oo<c<`2o`0002[oc<c<0Oooool003[oc<c<0_l0
0003olc<c0;o00000oo<c<`3o`0000?oc<c<0ol000000oo<c<co0000o`000002o`0000;oc<c<1?l0
0003olc<c0Go00000oo<c<`2o`0000Coc<c<0_l000000oo<c<co0000o`000002o`000003olc<c?l0
003o000000?o00000oo<c<`4o`0000?oc<c<1?l00003olc<c0Co00000oo<c<`4o`0000?oc<c<1?l0
0005olc<c0;o00000oo<c<`2o`000003olc<c?l0003o000000;oc<c<1?l00002olc<c0Co00000oo<
c<`3o`0000?oc<c<0ol000000oo<c<co0000o`000003olc<c0;o00001Oo<c<`2o`0000Coc<c<0_l0
0002olc<c0Co00000_o<c<`5o`0000[oc<c<0_l00005olc<c0;o0000:_o<c<`1ooooo`00>_o<c<`2
o`0000?oc<c<0_l0000>olc<c0;o00003Oo<c<`2o`0000?oc<c<0_l00008olc<c0;o0000;oo<c<`2
o`0000?oc<c<0_l0000<olc<c0;o00006oo<c<`2o`0000;oc<c<0_l0000Folc<c0Co00000oo<c<`4
o`0002[oc<c<0Oooool003_oc<c<1Ol0000?olc<c0;o00003Oo<c<`2o`0000?oc<c<2?l00002olc<
c0;o0000;oo<c<`2o`0000?oc<c<0_l000000oo<c<co0000o`000009olc<c0;o00007?o<c<`4o`00
01Woc<c<0_l00005olc<c0;o0000:_o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<
0Oooool00?ooc<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00?oo
c<c<8?o<c<`1ooooo`00ooo<c<`Polc<c07ooooo003oolc<c23oc<c<0Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {272.438, 0}} -> {-0.103251, -0.0866747, \
0.00373507, 0.00373507}}],

Cell[BoxData[
    \(evolveExpressions::"fitnessesInfo" \(\(:\)\(\ \)\) 
      "Fitnesses: \!\({6, 1, 6, 6, 6, 6, 6, 6, 6, 6}\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMax" \(\(:\)\(\ \)\) 
      "Max. Fitness: \!\(6\)"\)], "Message"],

Cell[BoxData[
    \(evolveExpressions::"fitnessMean" \(\(:\)\(\ \)\) 
      "Mean Fitness: \!\(5.5`\)"\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2655 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.0238095 0.47619 0.0301309 0.47619 [
[.5 1.278 -53.4688 0 ]
[.5 1.278 53.4688 14 ]
[ 0 0 0 0 ]
[ 1 1.2655 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 1.278 -114.469 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GP) show
82.625 14.000 moveto
(Operator) show
133.438 14.000 moveto
(Ranks) show
165.938 14.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.2655 L
0 1.2655 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0301309 0.477324 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 0.0147151 5.88604 [
[.30952 .00222 -3 -9 ]
[.30952 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.69048 .00222 -3 -9 ]
[.69048 .00222 3 0 ]
[.88095 .00222 -6 -9 ]
[.88095 .00222 6 0 ]
[.10655 .13244 -24 -4.5 ]
[.10655 .13244 0 4.5 ]
[.10655 .25016 -24 -4.5 ]
[.10655 .25016 0 4.5 ]
[.10655 .36788 -24 -4.5 ]
[.10655 .36788 0 4.5 ]
[.10655 .4856 -24 -4.5 ]
[.10655 .4856 0 4.5 ]
[.10655 .60332 -18 -4.5 ]
[.10655 .60332 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(4)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(6)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(8)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(10)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.11905 .13244 m
.1253 .13244 L
s
[(0.02)] .10655 .13244 1 0 Mshowa
.11905 .25016 m
.1253 .25016 L
s
[(0.04)] .10655 .25016 1 0 Mshowa
.11905 .36788 m
.1253 .36788 L
s
[(0.06)] .10655 .36788 1 0 Mshowa
.11905 .4856 m
.1253 .4856 L
s
[(0.08)] .10655 .4856 1 0 Mshowa
.11905 .60332 m
.1253 .60332 L
s
[(0.1)] .10655 .60332 1 0 Mshowa
.125 Mabswid
.11905 .04415 m
.1228 .04415 L
s
.11905 .07358 m
.1228 .07358 L
s
.11905 .10301 m
.1228 .10301 L
s
.11905 .16187 m
.1228 .16187 L
s
.11905 .1913 m
.1228 .1913 L
s
.11905 .22073 m
.1228 .22073 L
s
.11905 .27959 m
.1228 .27959 L
s
.11905 .30902 m
.1228 .30902 L
s
.11905 .33845 m
.1228 .33845 L
s
.11905 .39731 m
.1228 .39731 L
s
.11905 .42674 m
.1228 .42674 L
s
.11905 .45617 m
.1228 .45617 L
s
.11905 .51503 m
.1228 .51503 L
s
.11905 .54446 m
.1228 .54446 L
s
.11905 .57389 m
.1228 .57389 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(REPRO) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.7 g
.014 w
.02381 .01472 m
.11905 .60332 L
.21429 .60332 L
.30952 .60332 L
.40476 .60332 L
.5 .60332 L
.59524 .60332 L
.69048 .60332 L
.78571 .60332 L
.88095 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0301309 0.97619 0.310418 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 0.0147151 2.94302 [
[.30952 .00222 -3 -9 ]
[.30952 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.69048 .00222 -3 -9 ]
[.69048 .00222 3 0 ]
[.88095 .00222 -6 -9 ]
[.88095 .00222 6 0 ]
[.10655 .16187 -24 -4.5 ]
[.10655 .16187 0 4.5 ]
[.10655 .30902 -18 -4.5 ]
[.10655 .30902 0 4.5 ]
[.10655 .45617 -24 -4.5 ]
[.10655 .45617 0 4.5 ]
[.10655 .60332 -18 -4.5 ]
[.10655 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(4)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(6)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(8)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(10)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.11905 .16187 m
.1253 .16187 L
s
[(0.05)] .10655 .16187 1 0 Mshowa
.11905 .30902 m
.1253 .30902 L
s
[(0.1)] .10655 .30902 1 0 Mshowa
.11905 .45617 m
.1253 .45617 L
s
[(0.15)] .10655 .45617 1 0 Mshowa
.11905 .60332 m
.1253 .60332 L
s
[(0.2)] .10655 .60332 1 0 Mshowa
.125 Mabswid
.11905 .04415 m
.1228 .04415 L
s
.11905 .07358 m
.1228 .07358 L
s
.11905 .10301 m
.1228 .10301 L
s
.11905 .13244 m
.1228 .13244 L
s
.11905 .1913 m
.1228 .1913 L
s
.11905 .22073 m
.1228 .22073 L
s
.11905 .25016 m
.1228 .25016 L
s
.11905 .27959 m
.1228 .27959 L
s
.11905 .33845 m
.1228 .33845 L
s
.11905 .36788 m
.1228 .36788 L
s
.11905 .39731 m
.1228 .39731 L
s
.11905 .42674 m
.1228 .42674 L
s
.11905 .4856 m
.1228 .4856 L
s
.11905 .51503 m
.1228 .51503 L
s
.11905 .54446 m
.1228 .54446 L
s
.11905 .57389 m
.1228 .57389 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SHRINK) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.8 g
.014 w
.02381 .30902 m
.11905 .30902 L
.21429 .30902 L
.30952 .30902 L
.40476 .30902 L
.5 .30902 L
.59524 .30902 L
.69048 .30902 L
.78571 .30902 L
.88095 .30902 L
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.338447 0.477324 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 -0.377687 0.981006 [
[.30952 .59082 -3 -9 ]
[.30952 .59082 3 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.69048 .59082 -3 -9 ]
[.69048 .59082 3 0 ]
[.88095 .59082 -6 -9 ]
[.88095 .59082 6 0 ]
[.10655 .01472 -18 -4.5 ]
[.10655 .01472 0 4.5 ]
[.10655 .11282 -18 -4.5 ]
[.10655 .11282 0 4.5 ]
[.10655 .21092 -18 -4.5 ]
[.10655 .21092 0 4.5 ]
[.10655 .30902 -18 -4.5 ]
[.10655 .30902 0 4.5 ]
[.10655 .40712 -18 -4.5 ]
[.10655 .40712 0 4.5 ]
[.10655 .50522 -18 -4.5 ]
[.10655 .50522 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .60332 m
.30952 .60957 L
s
[(4)] .30952 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(6)] .5 .59082 0 1 Mshowa
.69048 .60332 m
.69048 .60957 L
s
[(8)] .69048 .59082 0 1 Mshowa
.88095 .60332 m
.88095 .60957 L
s
[(10)] .88095 .59082 0 1 Mshowa
.125 Mabswid
.16667 .60332 m
.16667 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.2619 .60332 m
.2619 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.7381 .60332 m
.7381 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.07143 .60332 m
.07143 .60707 L
s
.02381 .60332 m
.02381 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.97619 .60332 m
.97619 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.11905 .01472 m
.1253 .01472 L
s
[(0.4)] .10655 .01472 1 0 Mshowa
.11905 .11282 m
.1253 .11282 L
s
[(0.5)] .10655 .11282 1 0 Mshowa
.11905 .21092 m
.1253 .21092 L
s
[(0.6)] .10655 .21092 1 0 Mshowa
.11905 .30902 m
.1253 .30902 L
s
[(0.7)] .10655 .30902 1 0 Mshowa
.11905 .40712 m
.1253 .40712 L
s
[(0.8)] .10655 .40712 1 0 Mshowa
.11905 .50522 m
.1253 .50522 L
s
[(0.9)] .10655 .50522 1 0 Mshowa
.125 Mabswid
.11905 .03434 m
.1228 .03434 L
s
.11905 .05396 m
.1228 .05396 L
s
.11905 .07358 m
.1228 .07358 L
s
.11905 .0932 m
.1228 .0932 L
s
.11905 .13244 m
.1228 .13244 L
s
.11905 .15206 m
.1228 .15206 L
s
.11905 .17168 m
.1228 .17168 L
s
.11905 .1913 m
.1228 .1913 L
s
.11905 .23054 m
.1228 .23054 L
s
.11905 .25016 m
.1228 .25016 L
s
.11905 .26978 m
.1228 .26978 L
s
.11905 .2894 m
.1228 .2894 L
s
.11905 .32864 m
.1228 .32864 L
s
.11905 .34826 m
.1228 .34826 L
s
.11905 .36788 m
.1228 .36788 L
s
.11905 .3875 m
.1228 .3875 L
s
.11905 .42674 m
.1228 .42674 L
s
.11905 .44636 m
.1228 .44636 L
s
.11905 .46598 m
.1228 .46598 L
s
.11905 .4856 m
.1228 .4856 L
s
.11905 .52484 m
.1228 .52484 L
s
.11905 .54446 m
.1228 .54446 L
s
.11905 .56408 m
.1228 .56408 L
s
.11905 .5837 m
.1228 .5837 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MUTAT) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 g
.014 w
.02381 .01472 m
.11905 .60332 L
.21429 .60332 L
.30952 .59351 L
.40476 .5838 L
.5 .57418 L
.59524 .36834 L
.69048 .36088 L
.78571 .20116 L
.88095 .19538 L
.97619 .07145 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.338447 0.97619 0.618735 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 -0.100584 1.15299 [
[.30952 .00222 -3 -9 ]
[.30952 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.69048 .00222 -3 -9 ]
[.69048 .00222 3 0 ]
[.88095 .00222 -6 -9 ]
[.88095 .00222 6 0 ]
[.10655 .13001 -18 -4.5 ]
[.10655 .13001 0 4.5 ]
[.10655 .24531 -18 -4.5 ]
[.10655 .24531 0 4.5 ]
[.10655 .36061 -18 -4.5 ]
[.10655 .36061 0 4.5 ]
[.10655 .47591 -18 -4.5 ]
[.10655 .47591 0 4.5 ]
[.10655 .59121 -18 -4.5 ]
[.10655 .59121 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(4)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(6)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(8)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(10)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.11905 .13001 m
.1253 .13001 L
s
[(0.2)] .10655 .13001 1 0 Mshowa
.11905 .24531 m
.1253 .24531 L
s
[(0.3)] .10655 .24531 1 0 Mshowa
.11905 .36061 m
.1253 .36061 L
s
[(0.4)] .10655 .36061 1 0 Mshowa
.11905 .47591 m
.1253 .47591 L
s
[(0.5)] .10655 .47591 1 0 Mshowa
.11905 .59121 m
.1253 .59121 L
s
[(0.6)] .10655 .59121 1 0 Mshowa
.125 Mabswid
.11905 .03777 m
.1228 .03777 L
s
.11905 .06083 m
.1228 .06083 L
s
.11905 .08389 m
.1228 .08389 L
s
.11905 .10695 m
.1228 .10695 L
s
.11905 .15307 m
.1228 .15307 L
s
.11905 .17613 m
.1228 .17613 L
s
.11905 .19919 m
.1228 .19919 L
s
.11905 .22225 m
.1228 .22225 L
s
.11905 .26837 m
.1228 .26837 L
s
.11905 .29143 m
.1228 .29143 L
s
.11905 .31449 m
.1228 .31449 L
s
.11905 .33755 m
.1228 .33755 L
s
.11905 .38367 m
.1228 .38367 L
s
.11905 .40673 m
.1228 .40673 L
s
.11905 .42979 m
.1228 .42979 L
s
.11905 .45285 m
.1228 .45285 L
s
.11905 .49897 m
.1228 .49897 L
s
.11905 .52203 m
.1228 .52203 L
s
.11905 .54509 m
.1228 .54509 L
s
.11905 .56815 m
.1228 .56815 L
s
.11905 .61427 m
.1228 .61427 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PERM) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.6 g
.014 w
.02381 .13001 m
.11905 .60332 L
.21429 .59628 L
.30952 .58931 L
.40476 .58241 L
.5 .57558 L
.59524 .01472 L
.69048 .01472 L
.78571 .01472 L
.88095 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.646763 0.477324 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 -0.573889 5.88604 [
[.30952 .00222 -3 -9 ]
[.30952 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.69048 .00222 -3 -9 ]
[.69048 .00222 3 0 ]
[.88095 .00222 -6 -9 ]
[.88095 .00222 6 0 ]
[.10655 .13244 -24 -4.5 ]
[.10655 .13244 0 4.5 ]
[.10655 .25016 -24 -4.5 ]
[.10655 .25016 0 4.5 ]
[.10655 .36788 -24 -4.5 ]
[.10655 .36788 0 4.5 ]
[.10655 .4856 -24 -4.5 ]
[.10655 .4856 0 4.5 ]
[.10655 .60332 -18 -4.5 ]
[.10655 .60332 0 4.5 ]
[.5 .63053 -14 0 ]
[.5 .63053 14 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(4)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(6)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(8)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(10)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.11905 .13244 m
.1253 .13244 L
s
[(0.12)] .10655 .13244 1 0 Mshowa
.11905 .25016 m
.1253 .25016 L
s
[(0.14)] .10655 .25016 1 0 Mshowa
.11905 .36788 m
.1253 .36788 L
s
[(0.16)] .10655 .36788 1 0 Mshowa
.11905 .4856 m
.1253 .4856 L
s
[(0.18)] .10655 .4856 1 0 Mshowa
.11905 .60332 m
.1253 .60332 L
s
[(0.2)] .10655 .60332 1 0 Mshowa
.125 Mabswid
.11905 .04415 m
.1228 .04415 L
s
.11905 .07358 m
.1228 .07358 L
s
.11905 .10301 m
.1228 .10301 L
s
.11905 .16187 m
.1228 .16187 L
s
.11905 .1913 m
.1228 .1913 L
s
.11905 .22073 m
.1228 .22073 L
s
.11905 .27959 m
.1228 .27959 L
s
.11905 .30902 m
.1228 .30902 L
s
.11905 .33845 m
.1228 .33845 L
s
.11905 .39731 m
.1228 .39731 L
s
.11905 .42674 m
.1228 .42674 L
s
.11905 .45617 m
.1228 .45617 L
s
.11905 .51503 m
.1228 .51503 L
s
.11905 .54446 m
.1228 .54446 L
s
.11905 .57389 m
.1228 .57389 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DUPL) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.3 g
.014 w
.02381 .60332 m
.11905 .01472 L
.21429 .01472 L
.30952 .01472 L
.40476 .01472 L
.5 .01472 L
.59524 .01472 L
.69048 .01472 L
.78571 .01472 L
.88095 .01472 L
.97619 .01472 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.646763 0.97619 0.927051 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 0.0147151 5.88604 [
[.30952 .00222 -3 -9 ]
[.30952 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.69048 .00222 -3 -9 ]
[.69048 .00222 3 0 ]
[.88095 .00222 -6 -9 ]
[.88095 .00222 6 0 ]
[.10655 .13244 -24 -4.5 ]
[.10655 .13244 0 4.5 ]
[.10655 .25016 -24 -4.5 ]
[.10655 .25016 0 4.5 ]
[.10655 .36788 -24 -4.5 ]
[.10655 .36788 0 4.5 ]
[.10655 .4856 -24 -4.5 ]
[.10655 .4856 0 4.5 ]
[.10655 .60332 -18 -4.5 ]
[.10655 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(4)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(6)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(8)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(10)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.11905 .13244 m
.1253 .13244 L
s
[(0.02)] .10655 .13244 1 0 Mshowa
.11905 .25016 m
.1253 .25016 L
s
[(0.04)] .10655 .25016 1 0 Mshowa
.11905 .36788 m
.1253 .36788 L
s
[(0.06)] .10655 .36788 1 0 Mshowa
.11905 .4856 m
.1253 .4856 L
s
[(0.08)] .10655 .4856 1 0 Mshowa
.11905 .60332 m
.1253 .60332 L
s
[(0.1)] .10655 .60332 1 0 Mshowa
.125 Mabswid
.11905 .04415 m
.1228 .04415 L
s
.11905 .07358 m
.1228 .07358 L
s
.11905 .10301 m
.1228 .10301 L
s
.11905 .16187 m
.1228 .16187 L
s
.11905 .1913 m
.1228 .1913 L
s
.11905 .22073 m
.1228 .22073 L
s
.11905 .27959 m
.1228 .27959 L
s
.11905 .30902 m
.1228 .30902 L
s
.11905 .33845 m
.1228 .33845 L
s
.11905 .39731 m
.1228 .39731 L
s
.11905 .42674 m
.1228 .42674 L
s
.11905 .45617 m
.1228 .45617 L
s
.11905 .51503 m
.1228 .51503 L
s
.11905 .54446 m
.1228 .54446 L
s
.11905 .57389 m
.1228 .57389 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ENCAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.4 g
.014 w
.02381 .01472 m
.11905 .60332 L
.21429 .60332 L
.30952 .60332 L
.40476 .60332 L
.5 .60332 L
.59524 .60332 L
.69048 .60332 L
.78571 .60332 L
.88095 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.95508 0.477324 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 -0.371191 0.97451 [
[.30952 .59082 -3 -9 ]
[.30952 .59082 3 0 ]
[.5 .59082 -3 -9 ]
[.5 .59082 3 0 ]
[.69048 .59082 -3 -9 ]
[.69048 .59082 3 0 ]
[.88095 .59082 -6 -9 ]
[.88095 .59082 6 0 ]
[.10655 .01861 -18 -4.5 ]
[.10655 .01861 0 4.5 ]
[.10655 .11606 -18 -4.5 ]
[.10655 .11606 0 4.5 ]
[.10655 .21352 -18 -4.5 ]
[.10655 .21352 0 4.5 ]
[.10655 .31097 -18 -4.5 ]
[.10655 .31097 0 4.5 ]
[.10655 .40842 -18 -4.5 ]
[.10655 .40842 0 4.5 ]
[.10655 .50587 -18 -4.5 ]
[.10655 .50587 0 4.5 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .60332 m
.30952 .60957 L
s
[(4)] .30952 .59082 0 1 Mshowa
.5 .60332 m
.5 .60957 L
s
[(6)] .5 .59082 0 1 Mshowa
.69048 .60332 m
.69048 .60957 L
s
[(8)] .69048 .59082 0 1 Mshowa
.88095 .60332 m
.88095 .60957 L
s
[(10)] .88095 .59082 0 1 Mshowa
.125 Mabswid
.16667 .60332 m
.16667 .60707 L
s
.21429 .60332 m
.21429 .60707 L
s
.2619 .60332 m
.2619 .60707 L
s
.35714 .60332 m
.35714 .60707 L
s
.40476 .60332 m
.40476 .60707 L
s
.45238 .60332 m
.45238 .60707 L
s
.54762 .60332 m
.54762 .60707 L
s
.59524 .60332 m
.59524 .60707 L
s
.64286 .60332 m
.64286 .60707 L
s
.7381 .60332 m
.7381 .60707 L
s
.78571 .60332 m
.78571 .60707 L
s
.83333 .60332 m
.83333 .60707 L
s
.07143 .60332 m
.07143 .60707 L
s
.02381 .60332 m
.02381 .60707 L
s
.92857 .60332 m
.92857 .60707 L
s
.97619 .60332 m
.97619 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.11905 .01861 m
.1253 .01861 L
s
[(0.4)] .10655 .01861 1 0 Mshowa
.11905 .11606 m
.1253 .11606 L
s
[(0.5)] .10655 .11606 1 0 Mshowa
.11905 .21352 m
.1253 .21352 L
s
[(0.6)] .10655 .21352 1 0 Mshowa
.11905 .31097 m
.1253 .31097 L
s
[(0.7)] .10655 .31097 1 0 Mshowa
.11905 .40842 m
.1253 .40842 L
s
[(0.8)] .10655 .40842 1 0 Mshowa
.11905 .50587 m
.1253 .50587 L
s
[(0.9)] .10655 .50587 1 0 Mshowa
.125 Mabswid
.11905 .0381 m
.1228 .0381 L
s
.11905 .05759 m
.1228 .05759 L
s
.11905 .07708 m
.1228 .07708 L
s
.11905 .09657 m
.1228 .09657 L
s
.11905 .13555 m
.1228 .13555 L
s
.11905 .15504 m
.1228 .15504 L
s
.11905 .17453 m
.1228 .17453 L
s
.11905 .19402 m
.1228 .19402 L
s
.11905 .23301 m
.1228 .23301 L
s
.11905 .2525 m
.1228 .2525 L
s
.11905 .27199 m
.1228 .27199 L
s
.11905 .29148 m
.1228 .29148 L
s
.11905 .33046 m
.1228 .33046 L
s
.11905 .34995 m
.1228 .34995 L
s
.11905 .36944 m
.1228 .36944 L
s
.11905 .38893 m
.1228 .38893 L
s
.11905 .42791 m
.1228 .42791 L
s
.11905 .4474 m
.1228 .4474 L
s
.11905 .46689 m
.1228 .46689 L
s
.11905 .48638 m
.1228 .48638 L
s
.11905 .52536 m
.1228 .52536 L
s
.11905 .54485 m
.1228 .54485 L
s
.11905 .56434 m
.1228 .56434 L
s
.11905 .58383 m
.1228 .58383 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(CROSS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 g
.014 w
.02381 .01861 m
.11905 .01472 L
.21429 .60332 L
.30952 .59357 L
.40476 .58393 L
.5 .37738 L
.59524 .16404 L
.69048 .60332 L
.78571 .19159 L
.88095 .18596 L
.97619 .18039 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.95508 0.97619 1.23537 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 0.0147151 5.88604 [
[.30952 .00222 -3 -9 ]
[.30952 .00222 3 0 ]
[.5 .00222 -3 -9 ]
[.5 .00222 3 0 ]
[.69048 .00222 -3 -9 ]
[.69048 .00222 3 0 ]
[.88095 .00222 -6 -9 ]
[.88095 .00222 6 0 ]
[.10655 .13244 -24 -4.5 ]
[.10655 .13244 0 4.5 ]
[.10655 .25016 -24 -4.5 ]
[.10655 .25016 0 4.5 ]
[.10655 .36788 -24 -4.5 ]
[.10655 .36788 0 4.5 ]
[.10655 .4856 -24 -4.5 ]
[.10655 .4856 0 4.5 ]
[.10655 .60332 -18 -4.5 ]
[.10655 .60332 0 4.5 ]
[.5 .63053 -20 0 ]
[.5 .63053 20 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(4)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(6)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(8)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(10)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.11905 .13244 m
.1253 .13244 L
s
[(0.02)] .10655 .13244 1 0 Mshowa
.11905 .25016 m
.1253 .25016 L
s
[(0.04)] .10655 .25016 1 0 Mshowa
.11905 .36788 m
.1253 .36788 L
s
[(0.06)] .10655 .36788 1 0 Mshowa
.11905 .4856 m
.1253 .4856 L
s
[(0.08)] .10655 .4856 1 0 Mshowa
.11905 .60332 m
.1253 .60332 L
s
[(0.1)] .10655 .60332 1 0 Mshowa
.125 Mabswid
.11905 .04415 m
.1228 .04415 L
s
.11905 .07358 m
.1228 .07358 L
s
.11905 .10301 m
.1228 .10301 L
s
.11905 .16187 m
.1228 .16187 L
s
.11905 .1913 m
.1228 .1913 L
s
.11905 .22073 m
.1228 .22073 L
s
.11905 .27959 m
.1228 .27959 L
s
.11905 .30902 m
.1228 .30902 L
s
.11905 .33845 m
.1228 .33845 L
s
.11905 .39731 m
.1228 .39731 L
s
.11905 .42674 m
.1228 .42674 L
s
.11905 .45617 m
.1228 .45617 L
s
.11905 .51503 m
.1228 .51503 L
s
.11905 .54446 m
.1228 .54446 L
s
.11905 .57389 m
.1228 .57389 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.5 .63053 -81 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DECAPS) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 g
.014 w
.02381 .01472 m
.11905 .60332 L
.21429 .60332 L
.30952 .60332 L
.40476 .60332 L
.5 .60332 L
.59524 .60332 L
.69048 .60332 L
.78571 .60332 L
.88095 .60332 L
.97619 .60332 L
s
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{227.562, 287.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003S00017b000`400?l00000o`00003ohooVi^H0
0>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H003Ooi^KV0ol00008onKViP?o
00002OoVi^H3o`0000Koi^KV0ol00004onKViP;o0000@_oVi^H3o`0000Soi^KV0ol00009onKViP?o
00001OoVi^H3o`0000Coi^KV0_l0000IonKViP00>?oVi^H00ol0003oi^KVonKViP06onKViP05o`00
0?oVi^Koi^KVonKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV00?o0000onKV
i_oVi^H00_oVi^H01?l0003oi^KVonKVi_l00012onKViP03o`000?oVi^Koi^KV00Koi^KV00Go0000
onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KV
onKViP02onKViP04o`000?oVi^Koi^KVo`0001Soi^KV000eonKViPGo00001ooVi^H01Ol0003oi^KV
onKVi_oVi^Ko000000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000006onKViP03o`000?oVi^Koi^KV
00;oi^KV00Co0000onKVi_oVi^Ko0000?ooVi^H5o`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`00
0007onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KVonKViP02onKViP04o`00
0?oVi^Koi^KVo`0001Soi^KV000eonKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00009onKViP?o
00001ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0003ooi^KV00Co0000onKV
i_oVi^Ko00002?oVi^H4o`0000Woi^KV0ol00006onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000
onKVi_oVi^Ko00006?oVi^H003Koi^KV00?o0000onKVi_l000002?oVi^H00ol0003oi^KVonKViP09
onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H00ol0003oi^KVonKViP02onKViP04o`000?oV
i^Koi^KVo`00043oi^KV00?o0000onKVi_l000002?oVi^H00ol0003oi^KVonKViP09onKViP05o`00
0?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`00
01Soi^KV000gonKViP;o00002OoVi^H00ol0003oi^KVonKViP08onKViP05o`000?oVi^Koi^KVonKV
i_l000001OoVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Ko0000@OoVi^H2o`0000Woi^KV00?o0000
onKVi_oVi^H02?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV0_l00004onKViP04o`000?oV
i^Koi^KVo`0001Soi^KV000honKViP03o`000?oVi^Koi^KV00Soi^KV0_l00009onKViP?o00001ooV
i^H00ol0003oi^KVonKViP03onKViP;o0000@ooVi^H00ol0003oi^KVonKViP08onKViP;o00002OoV
i^H3o`0000Koi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0001Woi^KV003SonKViP00;OoVi^H00ol0
003oi^KVonKViP1WonKViP03o`000?oVi^Koi^KV04Woi^KV000UonKViP;o000000?o/k>co`000?l0
0000>_l0000/onKViSoo00005?oVi^H002Ooi^KV00?o/k>conKVi_oVi^H00ooVi^H00ol0003oi^KV
onKViP1WonKViP03o`000?oVi^Koi^KV04Woi^KV000WonKViP03ok>c/ooVi^Koi^KV00?oi^KV00?o
0000onKVi_oVi^H0IooVi^H00ol0003oi^KVonKViP19onKViP009ooVi^H00onc/k?oi^KVonKViP03
onKViP03o`000?oVi^Koi^KV06Ooi^KV00?o0000onKVi_oVi^H0BOoVi^H002Soi^KV00?o/k>conKV
i_oVi^H00_oVi^H00ol0003oi^KVonKViP1WonKViP03o`000?oVi^Koi^KV04Woi^KV000FonKViP;o
00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000_oVi^H2o`000003ok>c/ol0003o000000;o
i^KV00?o0000onKVi_oVi^H0IooVi^H00ol0003oi^KVonKViP19onKViP005OoVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000ok>c/ooVi^Ko00000_oVi^H0
0ol0003oi^KVonKViP1@onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000ooVi^H3
o`0000?oi^KV00?o0000onKVi_oVi^H0BOoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1?l0003oi^KVonKVi_l00003onKViP03ok>c/ooVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0CooV
i^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0
003oi^KVonKVi_l0001;onKViP005OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Ko
i^KVo`0000?oi^KV00?o/k>co`000?oVi^H00_oVi^H00ol0003oi^KVonKViP1?onKViP04o`000?oV
i^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l0001;onKV
iP005OoVi^H01?l0003oi^KVonKVi_l00008onKViP0:o`000?oVi^Koi^KVo`000?oVi^Ko0000onKV
i_nc/k?oi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0CooVi^H01?l0003oi^KVonKVi_l00008onKV
iP04o`000?oVi^Koi^KVo`0000Goi^KV00?o0000onKVi_oVi^H00_l0001:onKViP005OoVi^H01?l0
003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000_oVi^H01Onc/k?o0000
onKVi_oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0003o
i^KV00Co00000ooVi^H00ol0003oi^KVonKViP19onKViP005_oVi^H2o`0000[oi^KV0_l00003onKV
iP;o000000Go/k>conKVi_oVi^Koi^KVo`00001AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko
0000onKVi_oVi^Ko0000onKVi_l00006onKViP03o`000?oVi^Koi^KV04Woi^KV000FonKViP;o0000
1?oVi^H00ol0003oi^KVonKViP03onKViP;o00001?oVi^H00ol0003o/k>co`000002onKViP03o`00
0?oVi^Koi^KV053oi^KV0_l0000:onKViP;o00000_oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H0
BOoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP05
ok>c/ooVi^Koi^KVonKVi_l00000JOoVi^H00ol0003oi^KVonKViP19onKViP005OoVi^H01?l0003o
i^KVonKVi_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H00ol000001Onc/k?o0000onKVi_oV
i^Ko000006Woi^KV00?o0000onKVi_oVi^H0BOoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV00Go/k>conKVi_oVi^Koi^KVo`00001HonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00ol0003oi^KVonKViP19onKV
iP005OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000
onKVi_l0003o/k>c0_oVi^H00ol0003oi^KVonKViP1EonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP19onKViP005OoVi^H01?l0003oi^KVonKV
i_l00008onKViP04o`000?oVi^Koi^KVo`0000?oi^KV0_l000001?nc/k?oi^KVonKVi_l0001GonKV
iP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP19
onKViP005_oVi^H2o`0000[oi^KV0_l00005onKViP05o`000?nc/k?oi^KVonKVi_l00000EooVi^H0
1?l0003oi^KVonKVi_l00008onKViScoc<c<5_oVi^H001Koi^KV0_l00004onKViP03o`000?oVi^Ko
i^KV00?oi^KV0_l00003onKViP?o000000Co/k>conKVi_oVi^Ko0000EooVi^H01?l0003oi^KVonKV
i_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0BOoVi^H001Goi^KV00Co
0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co/k>conKV
i_oVi^Ko0000EooVi^H01?l0003oi^KVonKVi_l00008onKViP;o00001?oVi^H00ol0003oi^KVonKV
iP19onKViP005OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko
00000ooVi^H01?nc/k?oi^KVonKVi_l0001HonKViP;o00002_oVi^H00ol0003oi^KVonKViP02onKV
iP03o`000?oVi^Koi^KV04Woi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKV
i_oVi^Ko0000onKViP04o`000004onKVi_nc/k?oi^KVo`0006Woi^KV00?o0000onKVi_oVi^H0BOoV
i^H001Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000Co
i^KV00?o/k>conKVi_l00000JOoVi^H00ol0003oi^KVonKViP19onKViP005OoVi^H01?l0003oi^KV
onKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Oo0000onKVi_oVi^Koi^KVok>c/ooV
i^Ko000006Woi^KV00?o0000onKVi_oVi^H0BOoVi^H001Koi^KV0_l0000:onKViP;o00001?oVi^H2
o`000004onKVi_nc/k?oi^KVo`0005;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol0
0003onKViP?o00000ooVi^H00ol0003oi^KVonKViP19onKViP005_oVi^H2o`0000Coi^KV00?o0000
onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol000001?oVi^Ko/k>conKVi_l0001AonKViP04o`000?oV
i^Koi^KVo`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^Koi^KVo`00
04_oi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0003onKViP04o`000?nc/k?oi^KVo`00057oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003o
i^KVonKViP05onKViP03o`000?oVi^Koi^KV00;o0000B_oVi^H001Goi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_nc/k?o0000DOoV
i^H01?l0003oi^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00Goi^KV00Co0000onKVi_oVi^Ko
0000BooVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKV
iP?o00000_oVi^H00onc/k?o0000onKViP1@onKViP04o`000?oVi^Koi^KVo`0000Woi^KV00Co0000
onKVi_oVi^Koi^KV1?l00003onKViP03o`000?oVi^Koi^KV04Woi^KV000EonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Ko/k>co`00
057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`0000?oi^KV00?o0000onKVi_oVi^H01?oVi^H0
0ol0003oi^KVonKViP19onKViP005OoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Ko
i^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVok>c/ol0001BonKViP;o00002_oVi^H01?l0003o
i^KVonKVi_oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H0BOoVi^H001Koi^KV0_l0000:onKViP;o
00000ooVi^H3o`0000;oi^KV00?o/k>co`000?oVi^H0J?oVi^H00ol0003oi^KVonKViP19onKViP00
;?oVi^H00onc/k?o0000onKViP1XonKViP03o`000?oVi^Koi^KV04Woi^KV000LonKViP;o00001?oV
i^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H00onc/k?oi^KVonKViP1FonKViP;o00001?oV
i^H01?l0003oi^KVonKVi_oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H0BOoVi^H001_oi^KV00Co
0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03ok>c/ooVi^Koi^KV05Goi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP03o`000?oVi^Koi^KV
04Woi^KV000KonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^Hfok>c
/b;oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP;o0000B_oVi^H0
01_oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Ko
i^KV05Goi^KV00Co0000onKVi_oVi^Ko00002_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000004_oi^KV
000KonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H0F_oVi^H01?l0003oi^KV
onKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l00000C_oVi^H001_oi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H2o`0005coi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000004koi^KV000LonKViP;o00002_oVi^H00ol0003oi^KVonKViP1KonKViP;o00002OoVi^H3
o`0004ooi^KV003SonKViP00=OoVi^H3o`0000;oi^KV1_l000001?oVi^Ko0000o`000?l00003onKV
iP?o00000_oVi^H00ol0003oi^KVo`000002o`0004goi^KV0ol00002onKViP?o000000?oi^KVo`00
0?l000000ol00002onKViPKo000000Ooi^KVo`000?l0003o0000onKVi_l0003oi^KV00?o000000?o
i^KVo`000?l000008_oVi^H003Koi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKV
i_l00002onKViP03o`000?oVi^Koi^KV00?oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l0
0002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0002?oi^KV000fonKViP03o`000?oVi^Ko000000?o
i^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Ko000000;o
i^KV00Go0000onKVi_oVi^Koi^KVo`00001?onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000
onKVi_oVi^Ko0000onKVi_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_l0003o
00000_oVi^H00ol0003oi^KVo`00000TonKViP00=_oVi^H3o`0000?oi^KV0ol00003onKViP?o0000
0ooVi^H3o`0000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00001=onKViP;o00000ooVi^H4o`0000;o
i^KV0ol00004onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_l0003o00000_oVi^H2o`00
02Goi^KV000fonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H01?l0
003oi^KVonKVi_l00002onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H00ol0003oi^KV
onKViP1:onKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003o
i^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV00;oi^KV0_l000001ooVi^Ko0000onKVi_oVi^Ko
0000onKVi_l000009?oVi^H003Koi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKV
i_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003
onKViP03o`000?oVi^Koi^KV04[oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKV
i_l00002onKViP04o`000?oVi^Koi^KVo`0000?oi^KV00?o0000onKVi_oVi^H00_oVi^H2o`000005
onKVi_l0003oi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP0QonKViP00=OoVi^H4o`0000;o
i^KV1Ol000000ooVi^Ko0000o`000002o`0000;oi^KV1?l00003onKViP?o0000C_oVi^H3o`000005
onKVi_l0003o0000o`000?oVi^H01_l00002onKViPGo000000Coi^KVo`000?l0003oi^KV1_l00000
0ooVi^Ko0000o`00000RonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKV
iP00hooVi^H00>?oi^KV002OonKViP?o00002?oVi^H3o`0000Woi^KV0ol00005onKViP?o00001?oV
i^H2o`0001coi^KV000EonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP?o0000O?oVi^H0
0ol0003oi^KVonKViP06onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000Goi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000KonKViP00
5?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000M_oVi^H5o`00
00Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KVonKVi_l000001OoV
i^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0001_oi^KV000DonKViP04o`000?oV
i^Koi^KVo`0000Ooi^KV00?oOgmoo`000?l000000_l00002onKViP03o`000?oVi^Koi^KV07Coi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H4o`0000Woi^KV0ol00006onKViP03o`000?oVi^Koi^KV00;o
i^KV00Co0000onKVi_oVi^Ko00006ooVi^H001Coi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01?mo
Ogooi^KVonKVi_l00003onKViP03o`000?oVi^Koi^KV07Goi^KV00?o0000onKVi_l000002?oVi^H0
0ol0003oi^KVonKViP09onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KVonKV
iP02onKViP04o`000?oVi^Koi^KVo`0001_oi^KV000DonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV
00CoOgmoo`000?oVi^Ko00000ooVi^H00ol0003oi^KVonKViP1fonKViP;o00002OoVi^H00ol0003o
i^KVonKViP08onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H2o`0000Coi^KV00Co0000onKV
i_oVi^Ko00006ooVi^H001Coi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01?moOgooi^KVo`000?l0
0003onKViP03o`000?oVi^Koi^KV07Ooi^KV00?o0000onKVi_oVi^H02?oVi^H2o`0000Woi^KV0ol0
0006onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0000LonKViP005OoVi^H2o`0000Woi^KV00?oOgmo
onKVi_l000000ooVi^H00ol0003oi^KVonKViP0ionKViP03ogmoOooVi^Koi^KV07koi^KV000EonKV
iP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP03ogmoOol0003o000000?oi^KV00?o0000onKV
i_oVi^H0>OoVi^H00omoOgooi^KVonKViP0_onKViP03o`000?oVi^Koi^KV04coi^KV000DonKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000ogmoOooVi^Koi^KVo`000002onKViP03o`000?oVi^Ko
i^KV03Soi^KV00?oOgmoonKVi_oVi^H0:OoVi^HUo`0001SoVIVI0_l0000GonKViP005?oVi^H01?l0
003oi^KVonKVi_l00008onKViP04ogmoOooVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0=ooV
i^H00omoOgooi^KVonKViP0aonKViP03o`000?oVi^Koi^KV01_oi^KV00?oVIVIonKVi_oVi^H0;_oV
i^H001Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?moOgooi^KVonKVi_l00002onKViP03o`00
0?oVi^Koi^KV03Ooi^KV00?oOgmoonKVi_oVi^H0<OoVi^H00ol0003oi^KVonKViP0KonKViP03oiVI
VOoVi^Koi^KV02koi^KV000DonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Co0000ogmoOol0003o
00000ooVi^H00ol0003oi^KVonKViP0fonKViP03ogmoOooVi^Koi^KV03;oi^KV00?o0000onKVi_oV
i^H06ooVi^H00onIVIWoi^KVonKViP0^onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP03
o`000?oVi^KoOgmo00Coi^KV00?o0000onKVi_oVi^H0=OoVi^H00omoOgooi^KVonKViP0RonKViP;o
00001?oVi^H01?l0003oi^KVonKVi_oVi^H5o`0000;oi^KV00?o0000onKVi_oVi^H06_oVi^H00onI
VIWoi^KVonKViP0_onKViP005OoVi^H2o`0000Soi^KV0_l000000omoOgoo0000o`000002onKViP03
o`000?oVi^Koi^KV03Goi^KV00?oOgmoonKVi_oVi^H08OoVi^H01?l0003oi^KVonKVi_l00008onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H06_oVi^H00onIVIWoi^KVonKViP0_
onKViP005OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oOgmoo`000003onKV
iP03o`000?oVi^Koi^KV03Coi^KV00?oOgmoonKVi_oVi^H08_oVi^H01?l0003oi^KVonKVi_l00009
onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H06_oVi^H00onIVIWoi^KVonKViP0_
onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^KoOgmoonKVi_l000000_oV
i^H00ol0003oi^KVonKViP0`onKViPCoOgmo9OoVi^H01?l0003oi^KVonKVi_l00008onKViP03oiVI
VOoVi^Ko000000?oi^KV0_l0000KonKViP03oiVIVOoVi^Koi^KV02ooi^KV000DonKViP04o`000?oV
i^Koi^KVo`0000Ooi^KV00Go0000onKVi_moOgooi^KVo`000002onKViP03o`000?oVi^Koi^KV02co
i^KV1?moOglYonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000oiVIVOoVi^Koi^KVo`000002
onKViP03o`000?oVi^Koi^KV01[oi^KV00?oVIVIonKVi_oVi^H0;ooVi^H001Coi^KV00Co0000onKV
i_oVi^Ko00001ooVi^H2o`000003ogmoOol0003oi^KV00;oi^KV00?o0000onKVi_oVi^H0;?oVi^H0
0omoOgooi^KVonKViP0ZonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000oiVIVOoVi^Koi^KV
o`000002onKViP03o`000?oVi^Koi^KV01Woi^KV00?oVIVIonKVi_oVi^H0<?oVi^H001Coi^KV00Co
0000onKVi_oVi^Ko00001ooVi^H01?l0003oi^KVonKVi_moOgl3onKViP03o`000?oVi^Koi^KV02_o
i^KV00?oOgmoonKVi_oVi^H0;?oVi^H2o`0000Woi^KV00?o0000oiVIVOl000000ooVi^H00ol0003o
i^KVonKViP0IonKViP03oiVIVOoVi^Koi^KV033oi^KV000DonKViP04o`000?oVi^Koi^KVo`0000So
i^KV00?o0000onKVi_moOgl00ooVi^H00ol0003oi^KVonKViP0ZonKViP03ogmoOooVi^Koi^KV02go
i^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000oiVIVOl000000ooVi^H00ol0003o
i^KVonKViP0IonKViP03oiVIVOoVi^Koi^KV033oi^KV000EonKViP;o00002_oVi^H00ol0003oOgmo
onKViP02onKViP03o`000?oVi^Koi^KV02[oi^KV00?oOgmoonKVi_oVi^H0;?oVi^H01?l0003oi^KV
onKVi_l00007onKViP05o`000?oVi^KoVIVIonKVi_l000000_oVi^H00ol0003oi^KVonKViP0IonKV
iP03oiVIVOoVi^Koi^KV033oi^KV000EonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP03
o`000?moOgooi^KV00;oi^KV00?o0000onKVi_oVi^H0:OoVi^H00omoOgooi^KVonKViP0]onKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00?oVIVIonKVi_l000000_oVi^H00ol0003oi^KVonKViP0IonKV
iP03oiVIVOoVi^Koi^KV033oi^KV000DonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000ogmo
OooVi^H00_oVi^H00ol0003oi^KVonKViP0XonKViP03ogmoOooVi^Koi^KV02koi^KV00Co0000onKV
i_oVi^Ko00002OoVi^H00onIVIWo0000onKViP02onKViP;o00006_oVi^H00onIVIWoi^KVonKViP0`
onKViP005?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05ogmoOooVi^Koi^KVonKVi_l00000:_oV
i^H00omoOgooi^KVonKViP0^onKViP04o`000?oVi^Koi^KVo`0000[oi^KV00GoVIVIo`000?oVi^Ko
i^KVo`00000JonKViP03oiVIVOoVi^Koi^KV037oi^KV000DonKViP04o`000?oVi^Koi^KVo`0000[o
i^KV00Go0000ogmoOooVi^Koi^KVo`00000YonKViP03ogmoOooVi^Koi^KV02ooi^KV00Co0000onKV
i_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_nIVIWo000000;oi^KV00?o0000onKVi_oVi^H06?oV
i^H00onIVIWoi^KVonKViP0aonKViP005?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04ogmoOooV
i^Koi^KVo`0002Woi^KV00?oOgmoonKVi_oVi^H0<?oVi^H2o`0000Woi^KV0_l000001OnIVIWoi^KV
onKVi_oVi^Ko000001[oi^KV00?oVIVIonKVi_oVi^H0<OoVi^H001Coi^KV00Co0000onKVi_oVi^Ko
00001ooVi^H01Ol0003oi^KVonKVi_oVi^KoOgmo00;oi^KV00?o0000onKVi_oVi^H09_oVi^H00omo
Ogooi^KVonKViP0nonKViP05oiVIVOoVi^Koi^KVonKVi_l000006_oVi^H00onIVIWoi^KVonKViP0a
onKViP005OoVi^H2o`0000Soi^KV1?l000001?moOgooi^KVonKVi_l0000PonKViPSoOgmo=?oVi^H2
o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oVIVIo`000002onKViP03o`000?oVi^Ko
i^KV01Soi^KV00?oVIVIonKVi_oVi^H0<OoVi^H001Goi^KV0_l00004onKViP03o`000?oVi^Koi^KV
00;oi^KV0ol000001?moOgooi^KVonKVi_l0000PonKViP03ogmoOooVi^Koi^KV03Soi^KV00Co0000
onKVi_oVi^Ko00002_oVi^H01Ol0003oVIVIonKVi_oVi^Ko000001[oi^KV00?oVIVIonKVi_oVi^H0
<OoVi^H001Coi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKVi_oVi^KoOgmo00;o
i^KV00?o0000onKVi_oVi^H07OoVi^H00omoOgooi^KVonKViP0ionKViP04o`000?oVi^Koi^KVo`00
00Ooi^KV1?l000000onIVIWoi^KVonKViP02o`0001Soi^KV00?oVIVIonKVi_oVi^H0<_oVi^H001Co
i^KV00Co0000onKVi_oVi^Ko00001ooVi^H02?l0003oi^KVonKVi_oVi^Ko0000ogmoOooVi^Ko0000
7ooVi^H00omoOgooi^KVonKViP0ionKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oV
i^Ko0000oiVIV@02onKViP03o`000?oVi^Koi^KV01Ooi^KV00?oVIVIonKVi_oVi^H0<_oVi^H001Co
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H3o`000004onKVi_moOgooi^KVo`0001ooi^KV00?oOgmo
onKVi_oVi^H0>OoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Ko0000oiVIV@;oi^KV
00?o0000onKVi_oVi^H05ooVi^H00onIVIWoi^KVonKViP0bonKViP005?oVi^H01?l0003oi^KVonKV
i_l00007onKViP08o`000?oVi^Koi^KVonKVi_l0003oOgmoonKVi_l0000NonKViP03ogmoOooVi^Ko
i^KV03[oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H2o`000004oiVIVOoVi^Koi^KVo`0001Woi^KV
00?oVIVIonKVi_oVi^H0<_oVi^H001Coi^KV00Co0000onKVi_oVi^Ko00001ooVi^H02?l0003oi^KV
onKVi_oVi^Ko0000ogmoOooVi^Ko00007_oVi^H00omoOgooi^KVonKViP0konKViP;o00002ooVi^H0
1Ol0003oi^KVoiVIVOoVi^Ko000001Woi^KV00?oVIVIonKVi_oVi^H0<_oVi^H001Goi^KV0_l00004
onKViP03o`000?oVi^Koi^KV00;oi^KV0ol000001?oVi^KoOgmoonKVi_l0000MonKViP03ogmoOooV
i^Koi^KV03coi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol000001?oVi^KoVIVIonKV
i_l0000HonKViP03oiVIVOoVi^Koi^KV03?oi^KV000DonKViP04o`000?oVi^Koi^KVo`0000[oi^KV
00Go0000onKVi_moOgooi^KVo`00000;onKViP?o00002_oVi^H3o`0000;oi^KV00?oOgmoonKVi_oV
i^H01OoVi^H3o`0000Soi^KV0ol00004onKViP;o00008_oVi^H01?l0003oi^KVonKVi_l00007onKV
iP08o`000?oVi^Koi^KVonKVi_l0003oVIVIonKVi_l0000HonKViP03oiVIVOoVi^Koi^KV03?oi^KV
000DonKViP04o`000?oVi^Koi^KVo`0000_oi^KV00Co0000onKVi_moOgoo00003?oVi^H00ol0003o
i^KVonKViP08onKViP07o`000?oVi^Koi^KVonKVi_l0003oi^KVogmoO`06onKViP05o`000?oVi^Ko
i^KVonKVi_l000002?oVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`00027oi^KV
00Co0000onKVi_oVi^Ko00002ooVi^H00ol0003oVIVIonKViP02o`0001Ooi^KV00?oVIVIonKVi_oV
i^H0<ooVi^H001Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H4o`000003onKVi_moOgoo000000Wo
i^KV1Ol00009onKViP06o`000?oVi^Koi^KVonKVi_l0003oOgmo1ooVi^H01Ol0003oi^KVonKVi_oV
i^Ko000000Soi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000QonKViP04o`00
0?oVi^Koi^KVo`0000_oi^KV00Co0000oiVIVOoVi^Ko00006?oVi^H00onIVIWoi^KVonKViP0conKV
iP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP08o`000?oVi^Koi^KVonKVi_l0003oi^KVogmo
Ool00009onKViP04o`000?oVi^Koi^KVo`0000[oi^KV1?l000000ooVi^KoOgmoonKViP07onKViP?o
00002OoVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`00027oi^KV00Co0000onKV
i_oVi^Ko00001ooVi^H4o`0000;oi^KV00?oVIVIo`000?oVi^H05ooVi^H00onIVIWoi^KVonKViP0c
onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP08o`000?oVi^Koi^KVonKVi_l0003oi^KV
ogmoOol0000:onKViP03o`000?oVi^Ko000000[oi^KV00Go0000onKVi_oVi^Koi^KVogmoO`08onKV
iP05o`000?oVi^Koi^KVonKVi_l000002?oVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Ko
i^KVo`00027oi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP03onKViP03oiVI
VOl0003oi^KV01Ooi^KV00?oVIVIonKVi_oVi^H0<ooVi^H001Goi^KV0_l00009onKViP?o00000_oV
i^H00omoOgoo0000onKViP0:onKViP;o00002ooVi^H01?l0003oi^KVonKVi_moOgl8onKViP05o`00
0?oVi^Koi^KVonKVi_l000001ooVi^H2o`0000Coi^KV00Co0000onKVi_oVi^Ko00008_oVi^H2o`00
00Soi^KV1Ol000000ooVi^KoVIVIo`00000GonKViP03oiVIVOoVi^Koi^KV03Coi^KV000UonKViP03
ogmoOol0003oi^KV00_oi^KV00?o0000onKVi_oVi^H02_oVi^H2o`000003ogmoOooVi^Koi^KV00Oo
i^KV0ol00009onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0000SonKViP;o00001?oVi^H00ol0003o
i^KVonKViP02onKViP?o00000_oVi^H00onIVIWo0000onKViP0FonKViP03oiVIVOoVi^Koi^KV03Co
i^KV000VonKViP03ogmoOooVi^Koi^KV00koi^KV2omoOgm0onKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV00So0000onKVi_oVi^Koi^KVo`000?oVi^KoVIVIo`0001Coi^KV1?nIVITfonKViP009_oVi^H0
0omoOgooi^KVonKViP07onKViPOoOgmoBooVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oV
i^Koi^KVonKVi_l000000_oVi^H00onIVIWo0000onKViP06onKViPcoVIVI>_oVi^H001koi^KV2?l0
000:ogmoOcGo00007OoVi^H01?l0003oi^KVonKVi_l00007onKViPCo00000ooVi^H9oiVIVDKoi^KV
000VonKViP03o`000?oVi^Koi^KV05Woi^KV00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KV
onKViP04onKViP03o`000?oVi^Koi^KV04coi^KV0022onKViP04o`000?oVi^Koi^KVo`0000Soi^KV
00?o0000onKVi_oVi^H0D_oVi^H008?oi^KV0_l0000:onKViP;o0000D_oVi^H00>?oi^KV003SonKV
iP00<_oVi^H2o`000004onKVi_l0003o0000o`0000;oi^KV0_l00003onKViP?o00000_oVi^H2o`00
0005onKVi_l0003o0000o`000?oVi^H00ol0001BonKViP?o00000ooVi^H5o`000004onKVi_l0003o
0000o`0000;oi^KV0ol000001?oVi^Ko0000o`000?l0000[onKViP00<_oVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00?oi^KV00Go0000onKVi_oVi^Koi^KVo`00001DonKViP03o`000?oVi^Koi^KV00?oi^KV00Co0000
onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00?o0000onKVi_oV
i^H0:_oVi^H003;oi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP04o`000?oVi^Koi^KVo`00
00?oi^KV00Co0000onKVi_oVi^Koi^KV1Ol00003onKViP03o`000?oVi^Koi^KV05;oi^KV00?o0000
onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP03onKViP03o`000?oVi^Ko000000;oi^KV00Go0000
onKVi_oVi^Koi^KVo`00000/onKViP00<_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00Co
0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKViP03o`000?oVi^Ko000000Coi^KV
00?o0000onKVi_oVi^H0D_oVi^H3o`0000?oi^KV0ol00003onKViP?o00000_oVi^H01Ol0003oi^KV
onKVi_oVi^Ko000002coi^KV000bonKViP05o`000?oVi^Ko0000onKVi_l000000_oVi^H02_l0003o
i^KVonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l00002onKViP03o`000?oVi^Ko000000;oi^KV
00Go0000onKVi_l0003oi^KVo`00001BonKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKV
i_oVi^H00ooVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^Ko0000onKVi_l0000/onKViP00
<_oVi^H2o`000003onKVi_l0003o000000;oi^KV00[o0000onKVi_oVi^Ko0000onKVi_l0003oi^KV
o`000?oVi^Ko00000ooVi^H02Ol0003oi^KVonKVi_oVi^Ko0000onKVi_l0003oi^KVo`00001BonKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01Ol0003oi^KVonKV
i_l0003oi^KV00;o000000?oi^KVo`000?l00000;?oVi^H003;oi^KV00Co0000onKVi_oVi^Koi^KV
1Ol000000ooVi^Ko0000o`000005o`0000;oi^KV0_l00003onKViPGo0000DOoVi^H4o`0000;oi^KV
1Ol000000ooVi^Ko0000o`000002o`0000;oi^KV00Co0000onKVi_oVi^Koi^KV0_l0000[onKViP00
hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV000gonKV
iP?o00002?oVi^H3o`0000Woi^KV0ol00006onKViP?o00001?oVi^H2o`0004;oi^KV0ol00008onKV
iP?o00002OoVi^H3o`0000Goi^KV0ol00004onKViP;o00006OoVi^H003Soi^KV00?o0000onKVi_oV
i^H01_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000006
onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko0000@_oVi^H00ol0003oi^KVonKV
iP06onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Go
i^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000HonKViP00=OoVi^H5o`0000Oo
i^KV00Go0000onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KVonKVi_l000001_oVi^H0
0ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0003ooi^KV1Ol00007onKViP05o`000?oV
i^Koi^KVonKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00?o0000onKVi_oV
i^H00_oVi^H01?l0003oi^KVonKVi_l0000HonKViP00=OoVi^H01?l0003oi^KVonKVi_l00008onKV
iPCo00002OoVi^H3o`0000Ooi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000o
onKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00009onKViP?o00001_oVi^H00ol0003oi^KVonKV
iP02onKViP04o`000?oVi^Koi^KVo`0001Soi^KV000fonKViP03o`000?oVi^Ko000000Soi^KV00?o
0000onKVi_oVi^H02OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Koi^KV00?o0000onKVi_oVi^H0
0_oVi^H01?l0003oi^KVonKVi_l00010onKViP03o`000?oVi^Ko000000Soi^KV00?o0000onKVi_oV
i^H02OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV00?o0000onKVi_oVi^H00_oVi^H01?l0
003oi^KVonKVi_l0000HonKViP00=ooVi^H2o`0000Woi^KV00?o0000onKVi_oVi^H02?oVi^H01Ol0
003oi^KVonKVi_oVi^Ko000000Goi^KV0_l00004onKViP04o`000?oVi^Koi^KVo`00047oi^KV0_l0
0009onKViP03o`000?oVi^Koi^KV00Soi^KV00Go0000onKVi_oVi^Koi^KVo`000004onKViP;o0000
1?oVi^H01?l0003oi^KVonKVi_l0000HonKViP00>?oVi^H00ol0003oi^KVonKViP08onKViP;o0000
2OoVi^H3o`0000Ooi^KV00?o0000onKVi_oVi^H00ooVi^H2o`0004?oi^KV00?o0000onKVi_oVi^H0
2?oVi^H2o`0000Woi^KV0ol00006onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0000IonKViP00hooV
i^H002Goi^KV2?l0000foda<C003o`000?oVi^Koi^KV02[oi^KV00?o0000ofIVI_l00000??l0000D
onKViP009ooVi^H01?l0003oi^KVonKVi_l00002onKViP04oda<C?oVi^Koi^KVo`0000;oi^KV00?o
0000onKVi_l000000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;o
i^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP03
o`000?oVi^Koi^KV02coi^KV00CoIVIVonKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KV
onKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H0
0ol0003oi^KVo`000002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP0DonKViP00;OoVi^H00om<C4coi^KVonKViP1QonKViP03ofIVI_oV
i^Koi^KV00?oi^KV00?o0000onKVi_oVi^H0BOoVi^H002goi^KV00?oC4a<onKVi_oVi^H0HOoVi^H0
0omVIVKoi^KVonKViP03onKViP03o`000?oVi^Koi^KV04Woi^KV000/onKViP03oda<C?l0003oi^KV
06?oi^KV00?oIVIVonKVi_oVi^H00_oVi^H00ol0003oi^KVonKViP19onKViP005_oVi^H2o`0000Co
i^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV1Ol000000ooVi^KoC4a<o`00001BonKViP;o
00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000_oVi^H2o`000003ofIVI_l0003o000000;o
i^KV00?o0000onKVi_oVi^H0BOoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003o
i^KVonKViP02onKViP07o`000?oVi^Koi^KVo`000?oVi^KoC4a<o`00001AonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oIVIVonKVi_l00002onKViP03
o`000?oVi^Koi^KV04Woi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oV
i^H00ooVi^H01_l0003oi^KVonKVi_oVi^KoC4a<o`00057oi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01?l0003oi^KVonKVi_l00003onKViP03ofIVI_oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0
BOoVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP04onKViP05o`00
0?oVi^Koi^KVoda<C?l00000DOoVi^H01?l0003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KV
o`0000?oi^KV00?oIVIVo`000?oVi^H00_oVi^H2o`0004[oi^KV000EonKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00Go0000onKVi_oVi^Koi^KVo`000003onKViP04o`000?oVi^KoC4a<o`00057oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H02_l0003oi^KVonKVi_l0003oi^KVo`000?oVi^KoIVIVonKV
i_l00002onKViP03o`000?oVi^Koi^KV04Woi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
0_l00003onKViP08o`000?oVi^Koi^KVonKVi_l0003oC4a<onKVi_l0001AonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP05ofIVI_l0003oi^KVonKV
i_l00000BooVi^H001Koi^KV0_l0000:onKViP03o`000?oVi^Koi^KV00;oi^KV0ol000001?oVi^Ko
C4a<onKVi_l0001BonKViP;o00002_oVi^H2o`0000?oi^KV0_l000001OmVIVKoi^KVonKVi_oVi^Ko
000004_oi^KV000[onKViP03oda<C?oVi^Ko000006Goi^KV00GoIVIVonKVi_oVi^Koi^KVo`00001;
onKViP005_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000Coi^KV0ol000000om<
C4coi^KVo`00001BonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00001?oVi^H00ol0
003oIVIVo`000002onKViP03o`000?oVi^Koi^KV04Woi^KV000EonKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oi^KVoda<C?oVi^Ko0000057oi^KV00Co0000
onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP05ofIVI_oVi^Koi^KVonKVi_l0
0000BooVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0003oi^KVonKVi_oVi^H5o`00
0003oda<C?oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01Ol0003oi^KVonKVi_l0
003oi^KV00?o000000CoIVIVo`000?oVi^Koi^KV0_l0001:onKViP005OoVi^H01?l0003oi^KVonKV
i_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003oC4a<onKVi_oVi^Ko0000
057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000;oi^KV
00Go0000ofIVI_oVi^Koi^KVo`00001;onKViP005OoVi^H01?l0003oi^KVonKVi_l00009onKViP03
o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_l0003oC4a<0_oVi^H00ol0003oi^KVonKViP1?onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVo`00
0?mVIVH2onKViP03o`000?oVi^Koi^KV04Woi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Soi^KV
0_l00005onKViP;o000000CoC4a<onKVi_oVi^Ko0000DOoVi^H01?l0003oi^KVonKVi_l00008onKV
iP04o`000?oVi^Koi^KVo`0000?oi^KV0_l000001?mVIVKoi^KVonKVi_l0001;onKViP005_oVi^H2
o`0000[oi^KV00?o0000onKVi_oVi^H01?oVi^H01Ol0003oC4a<onKVi_oVi^Ko000005;oi^KV0_l0
000:onKViP;o00001OoVi^H01Ol0003oIVIVonKVi_oVi^Ko000004_oi^KV000FonKViP;o00001?oV
i^H00ol0003oi^KVonKViP02onKViP?o00000ooVi^H3o`000004oda<C?oVi^Koi^KVo`0005;oi^KV
0_l00004onKViP03o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o000000CoIVIVonKVi_oVi^Ko
0000BooVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko0000
00?oi^KV00CoC4a<onKVi_oVi^Ko0000DOoVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oV
i^Koi^KVo`000?oVi^Ko00000ooVi^H01?mVIVKoi^KVonKVi_l0001;onKViP005OoVi^H01?l0003o
i^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000ooVi^H01?m<C4coi^KVonKVi_l0
001AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKV
iP03ofIVI_oVi^Koi^KV00;o0000B_oVi^H001Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H01?l0
003oi^KVonKVi_oVi^H3o`000005oda<C?oVi^Koi^KVonKVi_l00000DOoVi^H01?l0003oi^KVonKV
i_l00008onKViP05o`000?oVi^Koi^KVo`000?oVi^H01?l000001?oVi^KoIVIVonKVi_l0001;onKV
iP005OoVi^H01?l0003oi^KVonKVi_l00009onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H0
1Om<C4coi^KVonKVi_oVi^Ko0000057oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KV
onKVi_l0003oi^KVo`0000Coi^KV00?oIVIVonKVi_l00000BooVi^H001Goi^KV00Co0000onKVi_oV
i^Ko00002?oVi^H2o`0000Coi^KV00?o0000onKVi_m<C4`00ooVi^H00ol0003oi^KVonKViP1?onKV
iP04o`000?oVi^Koi^KVo`0000Soi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01ol0003oi^KVonKV
i_oVi^KoIVIVonKVi_l00000BooVi^H001Koi^KV0_l0000:onKViP03o`000?oVi^Koi^KV00?oi^KV
00?o0000oda<C?oVi^H00_oVi^H00ol0003oi^KVonKViP1@onKViP;o00002_oVi^H2o`0000Coi^KV
0_l000001?oVi^KoIVIVonKVi_l0001;onKViP005_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H0
0_oVi^H3o`0000?oi^KV0_l000001Om<C4coi^KVonKVi_oVi^Ko000005;oi^KV0_l00004onKViP03
o`000?oVi^Koi^KV00?oi^KV0_l00003onKViP?o000000Coi^KVofIVI_oVi^Ko0000BooVi^H001Go
i^KV00Co0000onKVi_oVi^Ko00002OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00GoC4a<
o`000?oVi^Koi^KVo`00001AonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko
0000onKVi_l00003onKViP04o`000?mVIVKoi^KVo`0004_oi^KV000EonKViP04o`000?oVi^Koi^KV
o`0000Woi^KV00Wo0000onKVi_oVi^Koi^KVo`000?oVi^KoC4a<onKVi_l000000_oVi^H00ol0003o
i^KVonKViP1?onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0003onKViP04o`000?oVi^KoIVIVo`0004_oi^KV000EonKViP04o`000?oVi^Koi^KVo`0000Woi^KV
00?o0000onKVi_oVi^H00_oVi^H00ol0003oC4a<o`000003onKViP03o`000?oVi^Koi^KV04ooi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000_oVi^H00omV
IVKo0000o`00001:onKViP005OoVi^H01?l0003oi^KVonKVi_l00009onKViP09o`000?oVi^Koi^KV
onKVi_l0003oi^KVoda<C?oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0CooVi^H01?l0003oi^KV
onKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVofIVI_l0
001;onKViP005OoVi^H01?l0003oi^KVonKVi_l00008onKViP;o00000ooVi^H01Ol0003oi^KVoda<
C?oVi^Ko000000;oi^KV00?o0000onKVi_oVi^H0CooVi^H01?l0003oi^KVonKVi_l00008onKViP06
o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVofIVI_l0001;onKViP005_oVi^H2
o`0000[oi^KV00?o0000onKVi_oVi^H00_oVi^H00ol0003oC4a<o`000003onKViP03o`000?oVi^Ko
i^KV053oi^KV0_l0000:onKViP;o00000ooVi^H3o`0000;oi^KV00?oIVIVo`000?oVi^H0B_oVi^H0
01coi^KV0_l00004onKViP04o`000?oVi^Koi^KVonKViP;o000000?oC4a<o`000?l000000_oVi^H0
0ol0003oi^KVonKViP1FonKViP;o00001?oVi^H00ol0003oi^KVonKViP02onKViP?o00000_oVi^H0
0omVIVKo0000onKViP1:onKViP006ooVi^H01?l0003oi^KVonKVi_l00008onKViP04oda<C?oVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H0EOoVi^H01?l0003oi^KVonKVi_l00009onKViP03o`00
0?oVi^Koi^KV00;oi^KV00?oIVIVonKVi_oVi^H0BOoVi^H001_oi^KV00Co0000onKVi_oVi^Ko0000
2?oVi^H00om<C4co0000onKViP03onKViP03o`000?oVi^Koi^KV05Goi^KV00Co0000onKVi_oVi^Ko
00002OoVi^H00ol0003oi^KVonKViP02onKViP03ofIVI_oVi^Koi^KV04Woi^KV000KonKViP04o`00
0?oVi^Koi^KVo`0000Soi^KV00?oC4a<onKVi_l000000ooVi^H00ol0003oi^KVonKViP1EonKViP04
o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oVi^H00_oVi^HfofIVIQKoi^KV000KonKViP04
o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KVo`000002onKViP03o`000?oVi^Ko
i^KV05Goi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003oi^KVonKViP02onKViP03o`000?oV
i^Koi^KV04Woi^KV000KonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000onKVi_oVi^Koi^KV
o`00001JonKViP04o`000?oVi^Koi^KVo`0000Soi^KV0_l0001@onKViP007?oVi^H2o`0000Woi^KV
0ol0001LonKViP;o00002_oVi^H00ol0003oi^KVonKViP1>onKViP00hooVi^H00>?oi^KV000honKV
iPCo00001?oVi^H2o`0000;oi^KV0ol00003onKViPGo0000C_oVi^H5o`000006onKVi_l0003o0000
o`000?oVi^Ko00000ooVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000o`000004o`0000Coi^KV0ol0
000TonKViP00>OoVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?o0000onKVi_oVi^H00ooVi^H01?l0003oi^KVonKVi_l0001?onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV
00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l0000SonKViP00>OoVi^H01?l0003o
i^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00ooVi^H0
0ol0003oi^KVonKViP1@onKViP03o`000?oVi^Koi^KV00?oi^KV00Ko0000onKVi_l0003o0000onKV
i_l00005onKViPGo00000_oVi^H00ol0003oi^KVonKViP06onKViP03o`000?oVi^Koi^KV027oi^KV
000ionKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H3o`0000?o
i^KV00?o0000onKVi_oVi^H0D?oVi^H3o`0000?oi^KV00Ko0000onKVi_l0003o0000onKVi_l00006
onKViP03o`000?oVi^Ko000000?oi^KV0ol00004onKViP;o00009?oVi^H003Woi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00?o0000onKVi_oVi^H0D?oVi^H00ol0003oi^KVonKViP03onKViP;o000000Coi^KVo`000?oVi^Ko
00001_oVi^H00ol0003oi^KVo`000003onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKV
i_oVi^H09?oVi^H003Woi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002
onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0D?oVi^H01?l0003oi^KVonKV
i_l00002onKViP;o000000Goi^KVo`000?oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KVonKV
i_l000001?oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0002?oi^KV000h
onKViPCo00000_oVi^H3o`000003onKVi_l0003o000000Co00000_oVi^H3o`00053oi^KV1Ol00000
1?oVi^Ko0000o`000?oVi^H3o`0000;oi^KV0ol00002onKViP;o00000ooVi^H4o`0000Coi^KV0ol0
000SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?o
i^KV002RonKViP?o00002?oVi^H3o`0000Woi^KV0ol00005onKViP?o00001?oVi^H2o`0001Woi^KV
000EonKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP?o0000OooVi^H00ol0003oi^KVonKV
iP06onKViP05o`000?oVi^Koi^KVonKVi_l000001ooVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Go
i^KV00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000HonKViP005?oVi^H01?l0003o
i^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l00000NOoVi^H5o`0000Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`000007onKViP05o`000?oVi^Koi^KVonKVi_l000001OoVi^H00ol0003oi^KV
onKViP02onKViP04o`000?oVi^Koi^KVo`0001Soi^KV000DonKViP04o`000?oVi^Koi^KVo`0000Oo
i^KV2?lI6AUionKViP04o`000?oVi^Koi^KVo`0000Soi^KV1?l00009onKViP?o00001_oVi^H00ol0
003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0001Soi^KV000DonKViP04o`000?oVi^Koi^KV
o`0000Ooi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00olI6AWoi^KVonKViP1honKViP03o`000?oV
i^Ko000000Soi^KV00?o0000onKVi_oVi^H02OoVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Goi^KV
00?o0000onKVi_oVi^H00_oVi^H01?l0003oi^KVonKVi_l0000HonKViP005?oVi^H01?l0003oi^KV
onKVi_l00008onKViP03o`000?oVi^Ko000000?oi^KV00?o6ATIonKVi_oVi^H0NOoVi^H2o`0000Wo
i^KV00?o0000onKVi_oVi^H02?oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000Coi^KV0_l00004onKV
iP04o`000?oVi^Koi^KVo`0001Soi^KV000DonKViP04o`000?oVi^Koi^KVo`0000Woi^KV0_l00003
onKViP03oaTI6OoVi^Koi^KV07[oi^KV00?o0000onKVi_oVi^H02?oVi^H2o`0000Woi^KV0ol00006
onKViP03o`000?oVi^Koi^KV00?oi^KV0_l0000IonKViP005OoVi^H2o`0000Coi^KV00?o0000onKV
i_oVi^H00_oVi^H3o`0000?oi^KV00?o0000oaTI6OoVi^H0K_oVi^H00ol0003oi^KVonKViP19onKV
iP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H0
0ol0003o6ATIonKViP1WonKViP03o`000?lc<c?o000003co00005?oVi^H001Coi^KV00Co0000onKV
i_oVi^Ko00002ooVi^H01Ol0003oi^KVonKVi_l0003o6ATI06Woi^KV00Co<c<conKVi_oVi^Ko0000
0_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKV
i_oVi^Ko00000_oVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Koi^KVo`0000;oi^KV
00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVo`000002onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP0DonKViP005?oVi^H01?l0
003oi^KVonKVi_l0000;onKViP05o`000?oVi^Koi^KVo`000?lI6AT0JOoVi^H00olc<c?oi^KVonKV
iP03onKViP03o`000?oVi^Koi^KV04Woi^KV000DonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV1?l0
0003onKViP03o`000?lI6AWoi^KV06Soi^KV00?o<c<conKVi_oVi^H00ooVi^H00ol0003oi^KVonKV
iP19onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP03o`000?oVi^Koi^KV00Coi^KV00?o
0000oaTI6OoVi^H0JOoVi^H00olc<c?oi^KVonKViP02onKViP03o`000?oVi^Koi^KV04Woi^KV000E
onKViP;o00002?oVi^H5o`0000;oi^KV00?o0000oaTI6OoVi^H07_oVi^H00olI6AWoi^KVonKViP0f
onKViP;o00001?oVi^H00ol0003oi^KVonKViP03onKViP;o00000_oVi^H2o`000003oc<c<ol0003o
000000;oi^KV00?o0000onKVi_oVi^H0BOoVi^H001Goi^KV0_l00004onKViP03o`000?oVi^Koi^KV
00;oi^KV0ol00003onKViP03o`000?oVi^Ko6ATI01koi^KV00?o6ATIonKVi_oVi^H0=OoVi^H01?l0
003oi^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000oc<c<ooVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP19onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`00
0?oVi^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVoaTI6@0MonKViP;o6ATI3OoVi^H>oaTI6Aco
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00003onKViP03oc<c<ooVi^Ko
i^KV00;oi^KV00?o0000onKVi_oVi^H0BOoVi^H001Coi^KV00Co0000onKVi_oVi^Ko00001ooVi^H0
1Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o0000onKVi_lI6AT07OoVi^H00olI6AWoi^KVoaTI
6@0<onKViP03oaTI6OoVi^Koi^KV02Ooi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KV
onKVi_l00003onKViP03oc<c<ol0003oi^KV00;oi^KV0_l0001:onKViP005?oVi^H01?l0003oi^KV
onKVi_l00007onKViPCo00000ooVi^H00ol0003oi^KVoaTI6@0MonKViP03oaTI6OoVi^Ko6ATI00co
i^KV00?o6ATIonKVi_oVi^H09ooVi^H01?l0003oi^KVonKVi_l00008onKViP0:o`000?oVi^Koi^KV
o`000?oVi^Ko0000onKVi_lc<c?oi^KVo`0000;oi^KV00?o0000onKVi_oVi^H0BOoVi^H001Coi^KV
00Co0000onKVi_oVi^Ko00001ooVi^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Ko6ATI01co
i^KV00Co6ATIonKVi_oVi^Ko6ATI2ooVi^H00olI6AWoi^KVonKViP0XonKViP04o`000?oVi^Koi^KV
o`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00002onKViP05oc<c<ol0003oi^KVonKVi_l0
0000BooVi^H001Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H00ol0003oi^KVonKViP03onKViP03
o`000?oVi^Ko6ATI01coi^KV00Co6ATIonKVi_oVi^Ko6ATI2ooVi^H00olI6AWoi^KVonKViP0YonKV
iP;o00002_oVi^H2o`0000?oi^KV0_l000001Olc<c?oi^KVonKVi_oVi^Ko000004_oi^KV000EonKV
iP;o00002_oVi^H2o`0000?oi^KV00?o0000onKVi_lI6AT06ooVi^H01OlI6AWoi^KVonKVi_oVi^Ko
6ATI00_oi^KV00?o6ATIonKVi_oVi^H0:OoVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2
o`0000Coi^KV00?o0000oc<c<ol000000_oVi^H00ol0003oi^KVonKViP19onKViP005OoVi^H2o`00
00Coi^KV00?o0000onKVi_oVi^H00ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KV
oaTI6A[oi^KV00?o6ATIonKVi_oVi^H00_oVi^H00olI6AWoi^KVonKViP08onKViP03oaTI6OoVi^Ko
i^KV02Soi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00004onKViP05oc<c
<ooVi^Koi^KVonKVi_l00000BooVi^H001Coi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0003o
i^KVonKViP02onKViP04o`000?oVi^Koi^KVoaTI6A[oi^KV00?o6ATIonKVi_oVi^H00_oVi^H00olI
6AWoi^KVonKViP07onKViP03oaTI6OoVi^Koi^KV02Woi^KV00Co0000onKVi_oVi^Ko00002?oVi^H0
1Ol0003oi^KVonKVi_l0003oi^KV00?o000000Go<c<co`000?oVi^Koi^KVo`00001;onKViP005?oV
i^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H00olI6AWo
i^KVonKViP0GonKViP03oaTI6OoVi^Koi^KV00?oi^KV00?o6ATIonKVi_oVi^H01ooVi^H00olI6AWo
i^KVonKViP0YonKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l0
0002onKViP04oc<c<ooVi^Koi^KVonKViP;o0000B_oVi^H001Coi^KV00Co0000onKVi_oVi^Ko0000
2_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000;oi^KV00?o6ATIonKVi_oVi^H05ooVi^H00olI6AWo
i^KVonKViP03onKViP03oaTI6OoVi^Koi^KV00Ooi^KV00?o6ATIonKVi_oVi^H0:OoVi^H01?l0003o
i^KVonKVi_l00008onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_l0003o<c<c0_oV
i^H00ol0003oi^KVonKViP19onKViP005?oVi^H01?l0003oi^KVonKVi_l0000;onKViP04o`000?oV
i^Koi^KVo`0000;oi^KV00?o6ATIonKVi_oVi^H05_oVi^H00olI6AWoi^KVonKViP05onKViP03oaTI
6OoVi^Koi^KV00Koi^KV00?o6ATIonKVi_oVi^H0:OoVi^H01?l0003oi^KVonKVi_l00008onKViP04
o`000?oVi^Koi^KVo`0000?oi^KV0_l000001?lc<c?oi^KVonKVi_l0001;onKViP005?oVi^H01?l0
003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01?l0003oi^KVonKV
i_lI6ATHonKViP03oaTI6OoVi^Koi^KV00Goi^KV00?o6ATIonKVi_oVi^H01_oVi^H00olI6AWoi^KV
onKViP0ZonKViP;o00002_oVi^H2o`0000Goi^KV00Go0000oc<c<ooVi^Koi^KVo`00001;onKViP00
5OoVi^H2o`0000Soi^KV1Ol00002onKViP04o`000?oVi^Koi^KVoaTI6ASoi^KV00?o6ATIonKVi_oV
i^H01OoVi^H00olI6AWoi^KVonKViP05onKViP03oaTI6OoVi^Koi^KV03ooi^KV00Co<c<conKVi_oV
i^Ko0000BooVi^H001Goi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV0ol00003onKViP05
o`000?oVi^Koi^KVonKVi_lI6AT05_oVi^H00olI6AWoi^KVonKViP06onKViP03oaTI6OoVi^Koi^KV
00Goi^KV00?o6ATIonKVi_oVi^H0:ooVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00ooVi^H2o`00
00?oi^KV0ol000001?lc<c?oi^KVonKVi_l0001;onKViP005?oVi^H01?l0003oi^KVonKVi_l00007
onKViP05o`000?oVi^Koi^KVonKVi_l000000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko6ATI01Koi^KV
00?o6ATIonKVi_oVi^H01_oVi^H00olI6AWoi^KVonKViP05onKViP03oaTI6OoVi^Koi^KV02[oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co<c<c
onKVi_oVi^Ko0000BooVi^H001Coi^KV00Co0000onKVi_oVi^Ko00001ooVi^H01Ol0003oi^KVonKV
i_oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVoaTI6@0EonKViP03oaTI6OoVi^Koi^KV00So
i^KV00?o6ATIonKVi_oVi^H01?oVi^H00olI6AWoi^KVonKViP0ZonKViP04o`000?oVi^Koi^KVo`00
00Soi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP03oc<c<ooVi^Koi^KV00;o0000B_oV
i^H001Coi^KV00Co0000onKVi_oVi^Ko00002?oVi^H3o`0000?oi^KV00Go0000onKVi_oVi^Koi^KV
oaTI6@0EonKViP03oaTI6OoVi^Koi^KV00Soi^KV00?o6ATIonKVi_oVi^H00ooVi^H00olI6AWoi^KV
onKViP0[onKViP04o`000?oVi^Koi^KVo`0000Soi^KV00Go0000onKVi_oVi^Ko0000onKViP04o`00
0004onKVi_lc<c?oi^KVo`0004_oi^KV000DonKViP04o`000?oVi^Koi^KVo`0000Ooi^KV00Go0000
onKVi_oVi^Koi^KVo`000002onKViP05o`000?oVi^Koi^KVonKVi_lI6AT05?oVi^H00olI6AWoi^KV
onKViP09onKViP03oaTI6OoVi^Koi^KV00?oi^KV00?o6ATIonKVi_oVi^H0:ooVi^H01?l0003oi^KV
onKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00001?oVi^H00olc<c?oi^KVo`00001;
onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KVonKVi_l000000_oV
i^H01Ol0003oi^KVonKVi_oVi^Ko6ATI01Coi^KV00?o6ATIonKVi_oVi^H02OoVi^H00olI6AWoi^KV
onKViP03onKViP03oaTI6OoVi^Koi^KV02_oi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003o
i^KVonKVi_l00002onKViP07o`000?oVi^Koi^KVonKVi_lc<c?oi^KVo`00001;onKViP005OoVi^H2
o`0000Woi^KV0ol00003onKViP05o`000?oVi^Koi^KVonKVi_lI6AT04ooVi^H00olI6AWoi^KVonKV
iP0:onKViP03oaTI6OoVi^Koi^KV00?oi^KV00?o6ATIonKVi_oVi^H0;?oVi^H2o`0000[oi^KV0_l0
0004onKViP;o000000Coi^KVoc<c<ooVi^Ko0000BooVi^H001Goi^KV0_l00004onKViP03o`000?oV
i^Koi^KV00;oi^KV0_l00004onKViP03o`000?oVi^Koi^KV00;oi^KV00?o6ATIonKVi_oVi^H04?oV
i^H00olI6AWoi^KVonKViP0;onKViP05oaTI6OoVi^Koi^KVonKVi_lI6AT0;ooVi^H2o`0000Coi^KV
00?o0000onKVi_oVi^H00ooVi^H2o`0000?oi^KV0ol000001?oVi^Ko<c<conKVi_l0001;onKViP00
5?oVi^H01?l0003oi^KVonKVi_l0000:onKViP05o`000?oVi^Koi^KVonKVi_l000001?oVi^H00olI
6AWoi^KVonKViP04onKViP?o00002?oVi^H00olI6AWoi^KVo`000002o`0000[oi^KV00Go6ATIo`00
0?l0003oi^KVoaTI6@06onKViP?o00001?oVi^H2o`0001ooi^KV00Co0000onKVi_oVi^Ko00002?oV
i^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000oc<c<ooVi^Ko0000BooVi^H001Co
i^KV00Co0000onKVi_oVi^Ko00002ooVi^H01?l0003oi^KVonKVi_l00004onKViP03oaTI6OoVi^Ko
i^KV00Goi^KV00?o0000onKVi_oVi^H01ooVi^H00olI6AWo0000onKViP02onKViP03o`000?oVi^Ko
i^KV00Koi^KV00Ko0000oaTI6OoVi^Koi^KVo`000?lI6AT7onKViP03o`000?oVi^Koi^KV00;oi^KV
00Co0000onKVi_oVi^Ko00007_oVi^H01?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KV
o`000?oVi^Ko00000ooVi^H00ol0003oi^KVoc<c<`02o`0004[oi^KV000DonKViP04o`000?oVi^Ko
i^KVo`0000Soi^KV1?l00002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o6ATIonKVi_oVi^H00_oV
i^H5o`0000Soi^KV00?o6ATIo`000?oVi^H00_oVi^H00ol0003oi^KVonKViP06onKViP06o`000?lI
6AWoi^KVonKVi_l0003o6ATI1ooVi^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`00
01koi^KV00Co0000onKVi_oVi^Ko00002?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000_oV
i^H00olc<c?o0000onKViP1:onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oV
i^Koi^KVonKVi_l000000_oVi^H00ol0003oi^KVonKViP02onKViP03oaTI6OoVi^Koi^KV00;oi^KV
00Co0000onKVi_oVi^Ko00002?oVi^H00olI6AWoi^KVo`000003o`0000[oi^KV00Go0000oaTI6Ol0
003oi^KVoaTI6@07onKViP03o`000?oVi^Koi^KV00;oi^KV00Co0000onKVi_oVi^Ko00007_oVi^H0
1?l0003oi^KVonKVi_l00008onKViP06o`000?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003o
i^KVoc<c<ol0001;onKViP005?oVi^H01?l0003oi^KVonKVi_l00007onKViP05o`000?oVi^Koi^KV
onKVi_l000000_oVi^H00ol0003oi^KVonKViP02onKViP03oaTI6OoVi^Koi^KV00?oi^KV00?o0000
onKVi_l000002?oVi^H00olI6AWoi^KVo`00000<onKViP05o`000?oVi^Ko6ATIonKVi_lI6AT02?oV
i^H00ol0003oi^KVonKViP02onKViP04o`000?oVi^Koi^KVo`0001koi^KV00Co0000onKVi_oVi^Ko
00002?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_lc<c?o0000BooV
i^H001Goi^KV0_l00009onKViP?o00000ooVi^H00ol0003oi^KVonKViP02onKViP03oaTI6OoVi^Ko
i^KV00Coi^KV0_l00007onKViP05oaTI6OoVi^Koi^KVonKVi_l000002ooVi^H01Ol0003oi^KVoaTI
6OoVi^Ko6ATI00Ooi^KV0_l00004onKViP04o`000?oVi^Koi^KVo`0001ooi^KV0_l0000:onKViP;o
00000ooVi^H3o`0000;oi^KV00?o<c<co`000?oVi^H0B_oVi^H002Koi^KV00?o0000onKVi_oVi^H0
0ooVi^H00olI6AWoi^KVonKViP04onKViP03o`000?oVi^Koi^KV00Goi^KV00?o6ATIonKVi_oVi^H0
0_oVi^H2o`0000[oi^KV00Co0000oaTI6Ol0003o6ATI2?oVi^H00ol0003oi^KVonKViP03onKViP;o
00009_oVi^H2o`0000Coi^KV00?o0000onKVi_oVi^H00_oVi^H3o`0000;oi^KV00?o<c<co`000?oV
i^H0B_oVi^H002Koi^KV00?o0000onKVi_oVi^H00ooVi^H00olI6AWoi^KVonKViP08onKViPCo6ATI
4_oVi^H00olI6AWoi^KVoaTI6@0eonKViP04o`000?oVi^Koi^KVo`0000Woi^KV00?o0000onKVi_oV
i^H00_oVi^H00olc<c?oi^KVonKViP19onKViP009_oVi^H00ol0003oi^KVonKViP03onKViP04oaTI
6OoVi^Koi^KVonKViPOo6ATI5ooVi^H00olI6AWoi^KVonKViP0donKViP04o`000?oVi^Koi^KVo`00
00Woi^KV00?o0000onKVi_oVi^H00_oVi^H00olc<c?oi^KVonKViP19onKViP007OoVi^H?o`0000Co
6ATI7_l000000olI6AWo0000o`00000Do`00023oi^KV00Co0000onKVi_oVi^Ko00002OoVi^H00ol0
003oi^KVonKViP02onKViSKo<c<c5_oVi^H002Koi^KV00?o0000onKVi_oVi^H0G?oVi^H01?l0003o
i^KVonKVi_l00009onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H0BOoVi^H008Go
i^KV00Co0000onKVi_oVi^Ko00002?oVi^H2o`00053oi^KV0026onKViP;o00002_oVi^H00ol0003o
i^KVonKViP1>onKViP00hooVi^H003Coi^KV0_l00002onKViP?o00000_oVi^H00ol0003oi^KVo`00
0002o`0000?oi^KV0ol00003onKViP?o0000CooVi^H4o`0000;oi^KV1Ol00003onKViP;o00000_oV
i^H2o`000003onKVi_l0003o000000Co00001?oVi^H3o`0002Coi^KV000conKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Ko0000onKVi_oVi^Ko0000onKVi_l00003onKViP04o`000?oVi^Koi^KVo`00
00;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H00ol0003oi^KVonKViP1=onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000_oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`00
00?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H01?l0003oi^KVonKVi_l0000SonKViP00<_oVi^H0
0ol0003oi^KVonKViP04onKViP03o`000?oVi^Ko000000;oi^KV00Go0000onKVi_oVi^Koi^KVo`00
0005onKViP03o`000?oVi^Koi^KV00?oi^KV00?o0000onKVi_oVi^H0COoVi^H01?l0003oi^KVonKV
i_l00002onKViP03o`000?oVi^Koi^KV00;oi^KV00?o0000onKVi_oVi^H00ooVi^H5o`0000;oi^KV
00?o0000onKVi_oVi^H01_oVi^H00ol0003oi^KVonKViP0QonKViP00<_oVi^H00ol0003oi^KVonKV
iP04onKViP?o00000_oVi^H01Ol0003oi^KVonKVi_oVi^Ko000000?oi^KV0_l00004onKViP;o0000
D?oVi^H01?l0003oi^KVonKVi_l00002onKViP?o00000_oVi^H00ol0003oi^KVonKViP04onKViP03
o`000?oVi^Ko000000?oi^KV0ol00004onKViP;o00009?oVi^H003;oi^KV00?o0000onKVi_oVi^H0
1?oVi^H01_l0003oi^KVonKVi_l0003oi^KVo`0000?oi^KV00Co0000onKVi_oVi^Ko00001OoVi^H0
0ol0003oi^KVonKViP1@onKViP04o`000?oVi^Koi^KVo`0000;oi^KV00?o0000onKVi_oVi^H00_oV
i^H00ol0003oi^KVonKViP04onKViP03o`000?oVi^Ko000000?oi^KV00Co0000onKVi_oVi^Ko0000
0_oVi^H00ol0003oi^KVonKViP0TonKViP00<ooVi^H01?l0003oi^KVonKVi_l00002onKViP06o`00
0?oVi^Koi^KVo`000?oVi^Ko00000ooVi^H01?l0003oi^KVonKVi_l00002onKViP04o`000?oVi^Ko
i^KVo`0000;oi^KV00?o0000onKVi_oVi^H0COoVi^H01?l0003oi^KVonKVi_l00002onKViP04o`00
0?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00000ooVi^H00ol0003oi^KVonKViP02onKV
iP04o`000?oVi^Koi^KVo`0000;oi^KV00Co0000onKVi_oVi^Ko00008ooVi^H003Coi^KV0ol00000
0ooVi^Ko0000o`000002o`0000?oi^KV0ol00004onKViP?o00000ooVi^H3o`0004koi^KV1?l00002
onKViPGo00000ooVi^H3o`0000;oi^KV0_l00003onKViPCo00001?oVi^H3o`0002?oi^KV003SonKV
iP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003SonKViP00hooVi^H00>?oi^KV003S
onKViP00hooVi^H00>?oi^KV001JonKViPCo0000QOoVi^H005_oi^KV0_l00026onKViP00FooVi^H2
o`0008Koi^KV000oonKViPGo00000_oVi^H4o`0000Woi^KV1Ol00003onKViPGo00000_oVi^H3o`00
0003onKVi_l0003o000000;o000000?oi^KVo`000?l000001?l00002onKViP;o000000?oi^KVo`00
0?l000000_l000000ooVi^Ko0000o`000002o`0000Goi^KV1?l00002onKViPco000000?oi^KVo`00
0?l000001?l000000ooVi^Ko0000o`000005o`0003koi^KV000nonKViP;o00000ooVi^H2o`0000;o
i^KV0_l00009onKViP;o00000ooVi^H2o`0000;oi^KV0_l00002onKViPCo00000_oVi^H01?l0003o
i^KVo`000?l00002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o0000
00;oi^KV0_l000000ooVi^Ko0000o`000007onKViP;o00000_oVi^H3o`000004onKVi_l0003o0000
onKViP;o00000_oVi^H2o`000003onKVi_l0003o000000;oi^KV0_l000001OoVi^Ko0000o`000?oV
i^Ko000000;oi^KV0_l0000monKViP00?OoVi^H2o`0000Coi^KV0_l00002onKViP;o00002?oVi^H2
o`0000Goi^KV0_l000000ooVi^Ko0000o`000002onKViPCo00001?oVi^H2o`0000;oi^KV0_l00000
0ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_oVi^H2o`000003onKVi_l0003o
000000Ooi^KV0_l000001?oVi^Ko0000o`000?l00002onKViP;o000000?oi^KVo`000?l000000_oV
i^H2o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000003onKViP?o0000?OoV
i^H003goi^KV0_l00003onKViPCo000000?oi^KVo`000?l000000ol00005onKViP;o00001OoVi^H2
o`000003onKVi_l0003o000000;oi^KV1ol000000ooVi^Ko0000o`000004onKViP?o00000_oVi^H2
o`000003onKVi_l0003o000000;oi^KV0_l000000ooVi^Ko0000o`000007onKViPGo00001OoVi^H3
o`0000;oi^KV0_l000000ooVi^Ko0000o`000002onKViPCo00000_oVi^H3o`0003ooi^KV000monKV
iP;o00002?oVi^H2o`0000;oi^KV0_l00004onKViP;o00001OoVi^H2o`000005onKVi_l0003o0000
o`000?oVi^H01?l000001?oVi^Ko0000o`000?oVi^H6o`000003onKVi_l0003o000000;oi^KV0_l0
00000ooVi^Ko0000o`000002onKViP;o000000?oi^KVo`000?l000000_l00005onKViP;o00000ooV
i^H2o`000004onKVi_l0003o0000onKViP;o00000_oVi^H5o`0000;oi^KV0_l00002onKViP04o`00
0?oVi^Ko0000o`0000;oi^KV00?o0000onKVi_oVi^H0>ooVi^H003goi^KV0_l00005onKViP03o`00
0?oVi^Koi^KV00;o00000_oVi^H2o`0000Coi^KV0_l00005onKViPGo000000?oi^KVo`000?l00000
0_oVi^H3o`000007onKVi_l0003o0000o`000?oVi^Ko0000onKViP03o`0000;oi^KV1?l000000ooV
i^Ko0000o`000002o`000006onKVi_l0003o0000o`000?oVi^Ko00001OoVi^H2o`0000?oi^KV0_l0
0002onKViP?o00000_oVi^H3o`000003onKVi_l0003o000000;oi^KV0_l000001OoVi^Ko0000o`00
0?l0003oi^KV00Co0000?OoVi^H003koi^KV0_l00003onKViP;o00000_oVi^H2o`0000;oi^KV0_l0
0005onKViP;o00000ooVi^H2o`0001Woi^KV0_l0000AonKViP;o00000ooVi^H2o`0000ooi^KV0_l0
0016onKViP00?ooVi^H4o`000003onKVi_l0003oi^KV00Ko00001ooVi^H5o`0001_oi^KV00?o0000
onKVi_oVi^H03_oVi^H7o`0000ooi^KV0ol00016onKViP00hooVi^H00>?oi^KV0000\
\>"],
  ImageRangeCache->{{{0, 226.562}, {286.938, 0}} -> {-0.113908, -0.0632884, \
0.00983313, 0.00983313}, {{11.5625, 108.438}, {280.5, 220.625}} -> {-5.65944, \
-0.0445132, 0.169706, 0.0027459}, {{118.125, 214.938}, {280.5, 220.625}} -> \
{-23.7384, -0.0890264, 0.169706, 0.0054918}, {{11.5625, 108.438}, {214.625, \
154.75}} -> {-3.72669, -0.711658, 0.149074, 0.0144724}, {{118.125, 214.938}, \
{214.625, 154.75}} -> {-23.2293, -1.05067, 0.169706, 0.0140179}, {{11.5625, \
108.438}, {148.812, 88.9375}} -> {-5.65944, -0.306114, 0.169706, 0.0027459}, \
{{118.125, 214.938}, {148.812, 88.9375}} -> {-23.7384, -0.406114, 0.169706, \
0.0027459}, {{11.5625, 108.438}, {82.9375, 23.0625}} -> {-3.66172, -2.61842, \
0.148132, 0.0144768}, {{118.125, 214.938}, {82.9375, 23.0625}} -> {-23.7384, \
-0.587, 0.169706, 0.0027459}}],

Cell[BoxData[
    RowBox[{\(evolveExpressions::"gpOperatorRanksInfo"\), \(\(:\)\(\ \)\), \
"\<\"GA Operator Ranks: \\!\\(\\*GridBox[{{\\({CROSS, 0.56600775`}\\)}, \
{\\({DECAPS, 0.1`}\\)}, {\\({DUPL, 0.1`}\\)}, {\\({ENCAPS, 0.1`}\\)}, \
{\\({MUTAT, 0.4578346252228808`}\\)}, {\\({PERM, 0.1`}\\)}, {\\({\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)}, {\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)}}, ColumnAlignments -> Left, GridBaseline -> {Baseline, \
{1, 1}}]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** Input panel information: *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Enter an index list for the expressions to be \
selected.\"\>"},
          {"\<\"Enter a list of the form: { {generation,index}.. }\"\>"},
          {"\<\" \"\>"},
          {"\<\"If you only enter an index this refers to the last \
generation.\"\>"},
          {"\<\" \"\>"},
          {"\<\"Enter 'all' to refer to the whole population.\"\>"},
          {"\<\" \"\>"},
          {"\<\"Enter 'stop' to abort.\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {"Enter an index list for the expressions to be selected.", 
        "Enter a list of the form: { {generation,index}.. }", " ", 
        "If you only enter an index this refers to the last generation.", " ",
         "Enter 'all' to refer to the whole population.", " ", 
        "Enter 'stop' to abort."}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("INPUT: "\[InvisibleSpace]stop\),
      SequenceForm[ "INPUT: ", stop],
      Editable->False]], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("***** End of input panel info *****"\)], "Print"],

Cell[BoxData[
    \(" "\)], "Print"],

Cell[BoxData[
    \("Evolution aborted ..."\)], "Print"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[" Reference", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "C. Jacob, ",
  StyleBox["Illustrating Evolutionary Computation with Mathematica.",
    FontWeight->"Bold"],
  " Morgan Kaufmann Publishers, San Fancisco, 2001. Chapter 8.\n"
}], "Text"]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 746}},
AutoGeneratedPackage->None,
WindowToolbars->{},
Evaluator->"Local",
InitializationCellEvaluation->True,
CellGrouping->Automatic,
WindowSize->{879, 711},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellBracket->False,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"MacintoshAutomaticEncoding",
StyleDefinitions -> \
FrontEnd`FileName[{ParentDirectory[ParentDirectory[ParentDirectory[]]], \
"IEC-Setup"}, "EvolvicaStyle.nb", CharacterEncoding -> "MacintoshRoman"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "AntTracker2D - Gen 18"->{
    Cell[1998, 65, 95818, 6369, 323, 63706, 5966, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 18"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"AntTracker2D - Gen 18", 2421611, 69850}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 103, 5, 129, "Title",
  Evaluatable->False],
Cell[1882, 60, 113, 3, 62, "Subsubtitle"],
Cell[1998, 65, 95818, 6369, 323, 63706, 5966, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 18"],

Cell[CellGroupData[{
Cell[97841, 6438, 81, 2, 76, "Subtitle",
  Evaluatable->False],
Cell[97925, 6442, 181, 5, 26, "Text",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[98143, 6452, 91, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[98259, 6458, 95, 2, 56, "Subsection",
  Evaluatable->False],
Cell[98357, 6462, 208, 6, 44, "Text"],
Cell[98568, 6470, 355, 13, 26, "Text"],

Cell[CellGroupData[{
Cell[98948, 6487, 219, 4, 73, "Input",
  InitializationCell->True],
Cell[99170, 6493, 137, 2, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[99356, 6501, 95, 2, 40, "Subsection",
  Evaluatable->False],
Cell[99454, 6505, 123, 2, 26, "Text",
  Evaluatable->False],
Cell[99580, 6509, 73, 1, 41, "Input"],
Cell[99656, 6512, 70, 1, 41, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[99763, 6518, 111, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[99899, 6524, 99, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[100001, 6528, 115, 2, 41, "Input",
  InitializationCell->True],
Cell[100119, 6532, 81, 1, 41, "Input"],
Cell[100203, 6535, 101, 2, 41, "Input",
  InitializationCell->True],
Cell[100307, 6539, 101, 2, 41, "Input",
  InitializationCell->True],
Cell[100411, 6543, 98, 2, 41, "Input",
  InitializationCell->True],
Cell[100512, 6547, 112, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[100661, 6557, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[100764, 6561, 106, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[100907, 6568, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[101010, 6572, 96, 2, 41, "Input",
  InitializationCell->True],
Cell[101109, 6576, 98, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[101268, 6585, 55, 0, 50, "Subtitle"],

Cell[CellGroupData[{
Cell[101348, 6589, 99, 2, 78, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[101472, 6595, 89, 2, 56, "Subsection",
  Evaluatable->False],
Cell[101564, 6599, 138, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[101739, 6612, 88, 2, 40, "Subsection",
  Evaluatable->False],
Cell[101830, 6616, 179, 11, 146, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[102046, 6632, 90, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[102161, 6638, 406, 14, 191, "Input",
  InitializationCell->True],
Cell[102570, 6654, 185, 3, 70, "Message"],
Cell[102758, 6659, 191, 3, 70, "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[102998, 6668, 142, 3, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[103165, 6675, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[103269, 6679, 664, 29, 416, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[103970, 6713, 97, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[104070, 6717, 780, 32, 461, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[104887, 6754, 167, 6, 34, "Subsubsection",
  Evaluatable->False],
Cell[105057, 6762, 209, 13, 176, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[105327, 6782, 91, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[105443, 6788, 105, 2, 56, "Subsection",
  Evaluatable->False],
Cell[105551, 6792, 209, 4, 44, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[105785, 6800, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[105879, 6804, 181, 8, 101, "Input",
  InitializationCell->True],
Cell[106063, 6814, 151, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[106251, 6824, 92, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[106346, 6828, 157, 8, 101, "Input",
  InitializationCell->True],
Cell[106506, 6838, 153, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[106696, 6848, 89, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[106788, 6852, 174, 8, 101, "Input",
  InitializationCell->True],
Cell[106965, 6862, 147, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[107149, 6872, 94, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[107246, 6876, 158, 8, 101, "Input",
  InitializationCell->True],
Cell[107407, 6886, 157, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[107601, 6896, 94, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[107698, 6900, 159, 8, 101, "Input",
  InitializationCell->True],
Cell[107860, 6910, 157, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[108054, 6920, 96, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[108153, 6924, 196, 8, 101, "Input",
  InitializationCell->True],
Cell[108352, 6934, 161, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[108550, 6944, 96, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[108649, 6948, 255, 10, 131, "Input",
  InitializationCell->True],
Cell[108907, 6960, 161, 5, 56, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[109117, 6971, 97, 2, 40, "Subsection",
  Evaluatable->False],
Cell[109217, 6975, 865, 30, 206, "Input",
  InitializationCell->True],
Cell[110085, 7007, 231, 6, 71, "Input",
  InitializationCell->True],
Cell[110319, 7015, 140, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[110520, 7027, 80, 2, 50, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[110625, 7033, 94, 2, 78, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[110744, 7039, 94, 2, 56, "Subsection",
  Evaluatable->False],
Cell[110841, 7043, 296, 15, 221, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[111174, 7063, 97, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[111296, 7069, 102, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[111423, 7075, 8266, 159, 1929, "Input",
  InitializationCell->True],
Cell[119692, 7236, 199, 3, 70, "Message"],
Cell[119894, 7241, 197, 3, 70, "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[120140, 7250, 90, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[120233, 7254, 189, 9, 116, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[120483, 7270, 98, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[120606, 7276, 148, 6, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[120779, 7286, 95, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[120877, 7290, 665, 38, 551, "Input",
  InitializationCell->True],
Cell[121545, 7330, 198, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[121792, 7344, 152, 6, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[121969, 7354, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[122063, 7358, 43, 1, 41, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[122143, 7364, 95, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[122241, 7368, 1182, 29, 476, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[123460, 7402, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[123553, 7406, 278, 10, 131, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[123880, 7422, 148, 6, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[124053, 7432, 111, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[124167, 7436, 851, 18, 416, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[125055, 7459, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[125148, 7463, 282, 12, 161, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[125479, 7481, 99, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[125603, 7487, 98, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[125704, 7491, 938, 19, 551, "Input",
  InitializationCell->True],
Cell[126645, 7512, 206, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[126888, 7527, 91, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[126982, 7531, 383, 17, 236, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[127390, 7552, 17266, 306, 4617, "Input",
  InitializationCell->True],
Cell[144659, 7860, 194, 3, 70, "Message"],
Cell[144856, 7865, 179, 3, 70, "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[145084, 7874, 90, 2, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[145199, 7880, 433, 19, 281, "Input",
  InitializationCell->True],
Cell[145635, 7901, 169, 3, 70, "Message"],
Cell[145807, 7906, 161, 3, 70, "Message"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[146029, 7916, 92, 2, 40, "Subsection",
  Evaluatable->False],
Cell[146124, 7920, 3749, 73, 633, "Input",
  InitializationCell->True],
Cell[149876, 7995, 117, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[150030, 8007, 89, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[150144, 8013, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[150247, 8017, 2265, 39, 617, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[152549, 8061, 111, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[152663, 8065, 345, 13, 236, "Input",
  InitializationCell->True],
Cell[153011, 8080, 370, 14, 221, "Input",
  InitializationCell->True],
Cell[153384, 8096, 129, 7, 86, "Input",
  InitializationCell->True],
Cell[153516, 8105, 265, 13, 176, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[153818, 8123, 104, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[153925, 8127, 502, 25, 356, "Input",
  InitializationCell->True],
Cell[154430, 8154, 550, 20, 311, "Input",
  InitializationCell->True],
Cell[154983, 8176, 307, 15, 206, "Input",
  InitializationCell->True],
Cell[155293, 8193, 371, 17, 236, "Input",
  InitializationCell->True],
Cell[155667, 8212, 232, 12, 161, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[155960, 8231, 90, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[156075, 8237, 104, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[156204, 8243, 98, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[156305, 8247, 1076, 21, 581, "Input",
  InitializationCell->True],
Cell[157384, 8270, 206, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[157627, 8285, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[157721, 8289, 337, 14, 191, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[158083, 8307, 5991, 101, 1641, "Input",
  InitializationCell->True],
Cell[164077, 8410, 197, 3, 70, "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[164323, 8419, 90, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[164438, 8425, 327, 13, 191, "Input",
  InitializationCell->True],
Cell[164768, 8440, 169, 3, 70, "Message"],
Cell[164940, 8445, 161, 3, 70, "Message"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[165174, 8456, 85, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[165284, 8462, 94, 2, 56, "Subsection",
  Evaluatable->False],
Cell[165381, 8466, 569, 25, 356, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[165975, 8495, 2290, 36, 1196, "Input",
  InitializationCell->True],
Cell[168268, 8533, 193, 3, 70, "Message"]
}, Open  ]],
Cell[168476, 8539, 155, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[168668, 8552, 95, 2, 56, "Subsection",
  Evaluatable->False],
Cell[168766, 8556, 131, 7, 86, "Input",
  InitializationCell->True],
Cell[168900, 8565, 1281, 20, 731, "Input",
  InitializationCell->True],
Cell[170184, 8587, 239, 4, 161, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[170460, 8596, 92, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[170577, 8602, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[170671, 8606, 779, 25, 356, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[171487, 8636, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[171584, 8640, 838, 36, 521, "Input",
  InitializationCell->True],
Cell[172425, 8678, 590, 28, 401, "Input",
  InitializationCell->True],
Cell[173018, 8708, 375, 15, 206, "Input",
  InitializationCell->True],
Cell[173396, 8725, 466, 19, 266, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[173899, 8749, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[173996, 8753, 803, 32, 461, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[174872, 8793, 94, 2, 50, "Subtitle",
  Evaluatable->False],
Cell[174969, 8797, 152, 5, 26, "Text"],

Cell[CellGroupData[{
Cell[175146, 8806, 39, 0, 56, "Subsection"],
Cell[175188, 8808, 190, 4, 57, "Input"],

Cell[CellGroupData[{
Cell[175403, 8816, 471, 25, 371, "Input"],
Cell[175877, 8843, 38, 1, 23, "Print"],
Cell[175918, 8846, 411, 8, 39, "Print"],
Cell[176332, 8856, 99, 2, 23, "Print"],
Cell[176434, 8860, 115, 2, 23, "Message"],
Cell[176552, 8864, 36, 1, 23, "Print"],
Cell[176591, 8867, 71, 1, 23, "Print"],
Cell[176665, 8870, 36, 1, 23, "Print"],
Cell[176704, 8873, 217, 7, 23, "Print"],
Cell[176924, 8882, 36, 1, 23, "Print"],
Cell[176963, 8885, 139, 3, 23, "Print"],
Cell[177105, 8890, 36, 1, 23, "Print"],
Cell[177144, 8893, 70, 1, 23, "Print"],
Cell[177217, 8896, 36, 1, 23, "Print"],
Cell[177256, 8899, 36, 1, 23, "Print"],
Cell[177295, 8902, 57, 1, 23, "Print"],
Cell[177355, 8905, 93, 1, 23, "Print"],
Cell[177451, 8908, 1253, 39, 166, "Print"],
Cell[178707, 8949, 41631, 1205, 248, 21899, 957, "GraphicsData", \
"PostScript", "Graphics"],
Cell[220341, 10156, 142, 2, 23, "Message"],
Cell[220486, 10160, 113, 2, 23, "Message"],
Cell[220602, 10164, 116, 2, 23, "Message"],
Cell[220721, 10168, 36, 1, 23, "Print"],
Cell[220760, 10171, 71, 1, 23, "Print"],
Cell[220834, 10174, 36, 1, 23, "Print"],
Cell[220873, 10177, 927, 20, 134, "Print"],
Cell[221803, 10199, 36, 1, 23, "Print"],
Cell[221842, 10202, 141, 3, 23, "Print"],
Cell[221986, 10207, 36, 1, 23, "Print"],
Cell[222025, 10210, 70, 1, 23, "Print"],
Cell[222098, 10213, 36, 1, 23, "Print"],
Cell[222137, 10216, 36, 1, 23, "Print"],
Cell[222176, 10219, 71, 1, 23, "Print"],
Cell[222250, 10222, 36, 1, 23, "Print"],
Cell[222289, 10225, 472, 11, 70, "Print"],
Cell[222764, 10238, 36, 1, 23, "Print"],
Cell[222803, 10241, 139, 3, 23, "Print"],
Cell[222945, 10246, 36, 1, 23, "Print"],
Cell[222984, 10249, 70, 1, 23, "Print"],
Cell[223057, 10252, 36, 1, 23, "Print"],
Cell[223096, 10255, 36, 1, 23, "Print"],
Cell[223135, 10258, 71, 1, 23, "Print"],
Cell[223209, 10261, 36, 1, 23, "Print"],
Cell[223248, 10264, 412, 9, 38, "Print"],
Cell[223663, 10275, 36, 1, 23, "Print"],
Cell[223702, 10278, 139, 3, 23, "Print"],
Cell[223844, 10283, 36, 1, 23, "Print"],
Cell[223883, 10286, 70, 1, 23, "Print"],
Cell[223956, 10289, 36, 1, 23, "Print"],
Cell[223995, 10292, 115, 2, 23, "Message"],
Cell[224113, 10296, 83142, 1919, 344, 28909, 1245, "GraphicsData", \
"PostScript", "Graphics"],
Cell[307258, 12217, 142, 2, 23, "Message"],
Cell[307403, 12221, 113, 2, 23, "Message"],
Cell[307519, 12225, 116, 2, 23, "Message"],
Cell[307638, 12229, 239, 4, 39, "Message"],
Cell[307880, 12235, 212, 4, 39, "Message"],
Cell[308095, 12241, 235, 4, 39, "Message"],
Cell[308333, 12247, 275, 4, 39, "Message"],
Cell[308611, 12253, 207, 4, 39, "Message"],
Cell[308821, 12259, 258, 4, 39, "Message"],
Cell[309082, 12265, 115, 2, 23, "Message"],
Cell[309200, 12269, 96499, 2185, 344, 32230, 1387, "GraphicsData", \
"PostScript", "Graphics"],
Cell[405702, 14456, 142, 2, 23, "Message"],
Cell[405847, 14460, 113, 2, 23, "Message"],
Cell[405963, 14464, 116, 2, 23, "Message"],
Cell[406082, 14468, 84325, 2614, 358, 31793, 1961, "GraphicsData", \
"PostScript", "Graphics"],
Cell[490410, 17084, 413, 6, 134, "Message"],
Cell[490826, 17092, 239, 4, 39, "Message"],
Cell[491068, 17098, 254, 4, 39, "Message"],
Cell[491325, 17104, 258, 4, 39, "Message"],
Cell[491586, 17110, 239, 4, 39, "Message"],
Cell[491828, 17116, 115, 2, 23, "Message"],
Cell[491946, 17120, 103152, 2361, 344, 35420, 1520, "GraphicsData", \
"PostScript", "Graphics"],
Cell[595101, 19483, 142, 2, 23, "Message"],
Cell[595246, 19487, 113, 2, 23, "Message"],
Cell[595362, 19491, 116, 2, 23, "Message"],
Cell[595481, 19495, 85105, 2646, 358, 31600, 1981, "GraphicsData", \
"PostScript", "Graphics"],
Cell[680589, 22143, 410, 6, 134, "Message"],
Cell[681002, 22151, 207, 4, 39, "Message"],
Cell[681212, 22157, 207, 4, 39, "Message"],
Cell[681422, 22163, 115, 2, 23, "Message"],
Cell[681540, 22167, 114081, 2591, 344, 38703, 1656, "GraphicsData", \
"PostScript", "Graphics"],
Cell[795624, 24760, 142, 2, 23, "Message"],
Cell[795769, 24764, 113, 2, 23, "Message"],
Cell[795885, 24768, 116, 2, 23, "Message"],
Cell[796004, 24772, 90500, 2957, 358, 35743, 2277, "GraphicsData", \
"PostScript", "Graphics"],
Cell[886507, 27731, 448, 6, 134, "Message"],
Cell[886958, 27739, 275, 4, 39, "Message"],
Cell[887236, 27745, 233, 4, 39, "Message"],
Cell[887472, 27751, 258, 4, 39, "Message"],
Cell[887733, 27757, 258, 4, 39, "Message"],
Cell[887994, 27763, 239, 4, 39, "Message"],
Cell[888236, 27769, 115, 2, 23, "Message"],
Cell[888354, 27773, 117370, 2714, 344, 41777, 1776, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1005727, 30489, 142, 2, 23, "Message"],
Cell[1005872, 30493, 113, 2, 23, "Message"],
Cell[1005988, 30497, 116, 2, 23, "Message"],
Cell[1006107, 30501, 81577, 2616, 358, 31814, 1997, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1087687, 33119, 446, 6, 134, "Message"],
Cell[1088136, 33127, 207, 4, 39, "Message"],
Cell[1088346, 33133, 239, 4, 39, "Message"],
Cell[1088588, 33139, 275, 4, 39, "Message"],
Cell[1088866, 33145, 115, 2, 23, "Message"],
Cell[1088984, 33149, 121703, 2866, 344, 45041, 1915, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1210690, 36017, 142, 2, 23, "Message"],
Cell[1210835, 36021, 113, 2, 23, "Message"],
Cell[1210951, 36025, 117, 2, 23, "Message"],
Cell[1211071, 36029, 85186, 2785, 358, 33998, 2149, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1296260, 38816, 520, 7, 134, "Message"],
Cell[1296783, 38825, 258, 4, 39, "Message"],
Cell[1297044, 38831, 207, 4, 39, "Message"],
Cell[1297254, 38837, 115, 2, 23, "Message"],
Cell[1297372, 38841, 128392, 3048, 344, 48356, 2055, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1425767, 41891, 142, 2, 23, "Message"],
Cell[1425912, 41895, 113, 2, 23, "Message"],
Cell[1426028, 41899, 117, 2, 23, "Message"],
Cell[1426148, 41903, 90480, 2992, 358, 36306, 2319, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1516631, 44897, 162, 3, 23, "Message"],
Cell[1516796, 44902, 254, 4, 39, "Message"],
Cell[1517053, 44908, 256, 4, 39, "Message"],
Cell[1517312, 44914, 115, 2, 23, "Message"],
Cell[1517430, 44918, 133027, 3197, 344, 51537, 2186, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1650460, 48117, 142, 2, 23, "Message"],
Cell[1650605, 48121, 113, 2, 23, "Message"],
Cell[1650721, 48125, 116, 2, 23, "Message"],
Cell[1650840, 48129, 94459, 3165, 358, 38594, 2471, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1745302, 51296, 448, 6, 134, "Message"],
Cell[1745753, 51304, 258, 4, 39, "Message"],
Cell[1746014, 51310, 263, 5, 39, "Message"],
Cell[1746280, 51317, 115, 2, 23, "Message"],
Cell[1746398, 51321, 135412, 3324, 344, 54818, 2325, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1881813, 54647, 142, 2, 23, "Message"],
Cell[1881958, 54651, 113, 2, 23, "Message"],
Cell[1882074, 54655, 116, 2, 23, "Message"],
Cell[1882193, 54659, 79868, 2534, 358, 31050, 1927, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1962064, 57195, 480, 7, 134, "Message"],
Cell[1962547, 57204, 254, 4, 39, "Message"],
Cell[1962804, 57210, 263, 5, 39, "Message"],
Cell[1963070, 57217, 239, 4, 39, "Message"],
Cell[1963312, 57223, 239, 4, 39, "Message"],
Cell[1963554, 57229, 191, 4, 39, "Message"],
Cell[1963748, 57235, 116, 2, 23, "Message"],
Cell[1963867, 57239, 141337, 3491, 344, 57956, 2457, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2105207, 60732, 142, 2, 23, "Message"],
Cell[2105352, 60736, 113, 2, 23, "Message"],
Cell[2105468, 60740, 116, 2, 23, "Message"],
Cell[2105587, 60744, 84030, 2649, 358, 32402, 2007, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2189620, 63395, 482, 7, 134, "Message"],
Cell[2190105, 63404, 258, 4, 39, "Message"],
Cell[2190366, 63410, 254, 4, 39, "Message"],
Cell[2190623, 63416, 254, 4, 39, "Message"],
Cell[2190880, 63422, 258, 4, 39, "Message"],
Cell[2191141, 63428, 239, 4, 39, "Message"],
Cell[2191383, 63434, 116, 2, 23, "Message"],
Cell[2191502, 63438, 141841, 3583, 344, 61174, 2583, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2333346, 67023, 142, 2, 23, "Message"],
Cell[2333491, 67027, 113, 2, 23, "Message"],
Cell[2333607, 67031, 117, 2, 23, "Message"],
Cell[2333727, 67035, 84405, 2705, 358, 32744, 2063, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2418135, 69742, 484, 7, 134, "Message"],
Cell[2418622, 69751, 36, 1, 23, "Print"],
Cell[2418661, 69754, 71, 1, 23, "Print"],
Cell[2418735, 69757, 36, 1, 23, "Print"],
Cell[2418774, 69760, 927, 20, 134, "Print"],
Cell[2419704, 69782, 36, 1, 23, "Print"],
Cell[2419743, 69785, 143, 3, 23, "Print"],
Cell[2419889, 69790, 36, 1, 23, "Print"],
Cell[2419928, 69793, 70, 1, 23, "Print"],
Cell[2420001, 69796, 36, 1, 23, "Print"],
Cell[2420040, 69799, 56, 1, 23, "Print"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2420157, 69807, 78, 2, 76, "Subtitle",
  Evaluatable->False],
Cell[2420238, 69811, 204, 5, 58, "Text"]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

