(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1545747,      44607]*)
(*NotebookOutlinePosition[   1572107,      45243]*)
(*  CellTagsIndexPosition[   1567495,      45143]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
  StyleBox["Evolvica",
    FontSlant->"Italic"],
  " Evolution on Symbolic Expressions\n\nGenetic Operators"
}], "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Christian Jacob, jacob@cpsc.ucalgary.ca  April 1997 / February 2001 \
\[Copyright]\
\>", "Subsubtitle"],

Cell[TextData[{
  " ",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Mshowa
P
1 g
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.44709 .16187 L
s
.62346 .30902 m
.79982 .16187 L
s
1 g
.05 w
.44709 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Mshowa
P
.004 w
.79982 .16187 m
.62346 .01472 L
s
.79982 .16187 m
.97619 .01472 L
s
1 g
.05 w
.62346 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.79982 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Mshowa
P
.9 g
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    Evaluatable->False,
    AspectRatioFixed->True,
    ImageSize->{226, 139.375},
    ImageMargins->{{0, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003R0000Ra000`40O003h00OhW=i0029LgT4Oom8
LgT4Ool9LgT008McN@QoodAcN@Qoo`McN@00Qg=i1@000gooA7=i0goo100000=oog=iLgT01G=i0026
LgT2Ool200000goo00000003Oom2LgT5Ool20003Ool6LgT008IcN@9oo`800003Ool0000000=ood9c
N@9oo`H0009oo`IcN@00QW=i0Woo0P0000=oo`0000000goo@W=i0Woo0P0000=oo`0000000goo1W=i
0026LgT2Ool40004Oom2LgT3Ool40003Ool6LgT008McN@03Ool0000000EoodAcN@=oo`<0009oo`Mc
N@00Qg=i0`001Goo00<007=iLgT0@G=i17oo0P000Woo1g=i0029LgT4Ool3LgT2000oLgT20002LgT4
Ool9LgT0099cN@03001cNG=i03]cN@03001cNG=i00mcN@00Tg=i00<007=iLgT0>G=i00<007=iLgT0
47=i002DLgT00`00LgUcN@0gLgT00`00LgUcN@0ALgT009EcN@03001cNG=i03EcN@03001cNG=i019c
N@00UW=i0P00<g=i0P005G=i002HLgT00`00LgUcN@0_LgT00`00LgUcN@0ELgT009UcN@03001cNG=i
02ecN@03001cNG=i01IcN@00VW=i00<007=iLgT0:g=i00<007=iLgT05g=i002KLgT2000YLgT2000J
LgT009ecN@03001cNG=i02EcN@03001cNG=i01YcN@00WW=i00<007=iLgT08g=i00<007=iLgT06g=i
002OLgT00`00LgUcN@0QLgT00`00LgUcN@0LLgT00:1cN@03001cNG=i01mcN@03001cNG=i01ecN@00
XG=i0P007G=i0P0087=i002SLgT00`00LgUcN@0ILgT00`00LgUcN@0PLgT00:AcN@03001cNG=i01Mc
N@03001cNG=i025cN@00YG=i00<007=iLgT05G=i00<007=iLgT08W=i002VLgT2000CLgT2000ULgT0
0:QcN@03001cNG=i00mcN@03001cNG=i02EcN@00ZG=i00<007=iLgT03G=i00<007=iLgT09W=i002Z
LgT00`00LgUcN@0;LgT00`00LgUcN@0WLgT00:]cN@03001cNG=i00UcN@03001cNG=i02QcN@00Hg=i
17ooAG=i1P0000=cW7=iLgT00P00:g=i001QLgT8Oom4LgT4Li`20002Li`]LgT0065cN@03Ool00000
008000=oodAcN@03Li`0000000<0009cW2ecN@00H7=i00=oo`0000000Woo0P000goo@W=i00=cW000
00000W>L0P000g>L;7=i001PLgT00goo00000007Oom2LgT00g>L00000002Li`20003Li`/LgT0061c
N@03Ool00000009oo`8000=ood9cN@03Li`00000009cW08000=cW2acN@00H7=i0Woo100017oo@W=i
0W>L1P000W>L;7=i001QLgT8Ool00`00LgUcN@11LgT8Li`]LgT0065cN@Qoo`03LgT007=i041cN@03
001cW7>L00IcW2ecN@00Hg=i17oo17=i0P00?G=i0P000g=i17>L;g=i001]LgT00`00LgUcN@0iLgT0
0`00LgUcN@0fLgT006icN@03001cNG=i03McN@03001cNG=i03McN@00Kg=i00<007=iLgT0=G=i00<0
07=iLgT0>7=i001`LgT00`00LgUcN@0cLgT00`00LgUcN@0iLgT0075cN@03001cNG=i035cN@03001c
NG=i03YcN@00LW=i0P00;g=i0P00?G=i001dLgT00`00LgUcN@0[LgT00`00LgUcN@0mLgT007EcN@03
001cNG=i02UcN@03001cNG=i03icN@00MW=i00<007=iLgT09g=i00<007=iLgT0?g=i001gLgT00`00
LgUcN@0ULgT00`00LgUcN@10LgT007QcN@8002=cN@8004=cN@00NW=i00<007=iLgT07g=i00<007=i
LgT0@g=i001kLgT00`00LgUcN@0MLgT00`00LgUcN@14LgT007acN@03001cNG=i01]cN@03001cNG=i
04EcN@00OG=i00<007=iLgT06G=i00<007=iLgT0AW=i001nLgT2000GLgT20019LgT0081cN@03001c
NG=i01=cN@03001cNG=i04UcN@00PG=i00<007=iLgT04G=i00<007=iLgT0BW=i0022LgT00`00LgUc
N@0?LgT00`00LgUcN@1;LgT008=cN@03001cNG=i00ecN@03001cNG=i04acN@00Q7=i00<007=iLgT0
2g=i00<007=iLgT0CG=i0025LgT20009LgT2001@LgT001icN@Aooa]cN@AoobUcN@AooaUcN@D00004
LiacNG=i001BLgT001acN@QooaMcN@QoobEcN@QooaMcN@AcW080009cW5=cN@0077=i1@000goo5g=i
00=oo`0000000P000goo9G=i0Woo10000Woo5g=i00=cW00000000`000W>LDg=i000KLgT2Ool20000
0goo00000003OolELgT00goo00000002Ool20003OolSLgT2Ool20006OolELgT00g>L00000002Li`2
0003LiaBLgT001]cN@9oo`800003Ool0000000=ooaEcN@Eoo`8000=oob=cN@9oo`H0009ooaEcN@03
Li`00000009cW08000=cW59cN@006g=i0Woo0P0000=oo`0000000goo5G=i0goo0`0017oo8g=i0Woo
0P000Woo0P000Woo5G=i00=cW00000000W>L0P000g>LDW=i000KLgT2Ool40004OolELgT5Ool20003
OolSLgT3Ool40003OolELgT2Li`60002LiaBLgT001acN@03Ool0000000EooaMcN@80009oo`80009o
obEcN@QooaMcN@QcW5=cN@0077=i0`001Goo5g=i00=oo`0000000P000goo9G=i27oo5g=i27>LDg=i
000NLgT4Ool00`00LgUcN@0GLgT00`00Oomoo`02OolYLgT4Ool00`00LgUcN@0HLgT4LiaELgT002=c
N@03001cNG=i01EcN@03001cNG=i035cN@03001cNG=i01IcN@03001cNG=i05McN@008g=i00<007=i
LgT05G=i00<007=iLgT0<G=i00<007=iLgT05W=i00<007=iLgT0Eg=i000TLgT00`00LgUcN@0CLgT0
0`00LgUcN@0cLgT00`00LgUcN@0DLgT00`00LgUcN@1HLgT002AcN@03001cNG=i01=cN@03001cNG=i
03=cN@03001cNG=i01AcN@03001cNG=i05QcN@0097=i00<007=iLgT04g=i00<007=iLgT0<g=i00<0
07=iLgT04g=i00<007=iLgT0FG=i000ULgT00`00LgUcN@0ALgT00`00LgUcN@0eLgT00`00LgUcN@0B
LgT00`00LgUcN@1ILgT002EcN@03001cNG=i015cN@03001cNG=i03EcN@03001cNG=i015cN@03001c
NG=i05YcN@009W=i00<007=iLgT03g=i00<007=iLgT0=g=i00<007=iLgT047=i00<007=iLgT0FW=i
000VLgT00`00LgUcN@0?LgT00`00LgUcN@0gLgT00`00LgUcN@0?LgT00`00LgUcN@1KLgT002McN@03
001cNG=i00ecN@03001cNG=i03UcN@03001cNG=i00icN@03001cNG=i05]cN@009g=i00<007=iLgT0
3G=i00<007=iLgT0>G=i00<007=iLgT03G=i00<007=iLgT0G7=i000XLgT00`00LgUcN@0;LgT00`00
LgUcN@0kLgT00`00LgUcN@0<LgT00`00LgUcN@1LLgT002QcN@03001cNG=i00]cN@03001cNG=i03]c
N@03001cNG=i00]cN@03001cNG=i05ecN@00:G=i00<007=iLgT02G=i00<007=iLgT0?G=i00<007=i
LgT02W=i00<007=iLgT0GG=i000YLgT00`00LgUcN@09LgT00`00LgUcN@0mLgT00`00LgUcN@09LgT0
0`00LgUcN@1NLgT002YcN@03001cNG=i00McN@03001cNG=i03mcN@03001cNG=i00QcN@03001cNG=i
05icN@00:W=i00<007=iLgT01g=i00<007=iLgT0?g=i00<007=iLgT01g=i00<007=iLgT0Gg=i000[
LgT00`00LgUcN@05LgT00`00LgUcN@11LgT00`00LgUcN@06LgT00`00LgUcN@1OLgT002]cN@03001c
NG=i00EcN@03001cNG=i045cN@03001cNG=i00EcN@03001cNG=i061cN@00:g=i00<007=iLgT01G=i
00<007=iLgT0@G=i00<007=iLgT01G=i00<007=iLgT0H7=i000/LgT00`00LgUcN@03LgT00`00LgUc
N@13LgT00`00LgUcN@03LgT00`00LgUcN@1QLgT002acN@03001cNG=i00=cN@03001cNG=i04=cN@03
001cNG=i00=cN@03001cNG=i065cN@001g=i17oo8W=i1@008G=i17oo8W=i00<007>LLi`00W>L8W=i
17oo?W=i0005LgT8OolNLgT5Li`200000g>LLgUcN@0LLgT8OolOLgT8Li`NLgT8OollLgT000EcN@03
Ool0000000<0009ooaicN@9cW0D00003LiacNG=i01acN@9oo`@0009ooamcN@L00003LiacNG=i01ac
N@H0009oocacN@0017=i00Aoo`00001oo`8000AooaacN@9cW080009cW080009cW1acN@9oo`80009o
o`80009ooaecN@9cW0800003Li`0000000=cW1acN@9oo`800003Ool0000000=ooc]cN@0017=i0Woo
100017oo77=i0W>L0P000W>L0P000W>L77=i0Woo0P001Woo7G=i0W>L0P0000=cW00000000g>L77=i
0goo0P001Goo>g=i0004LgT017oo000007oo0P0017oo77=i0W>L0P000W>L0P000W>L77=i0Woo0P00
0Woo0P000Woo7G=i0W>L0P0000=cW00000000g>L77=i17oo0P0017oo>g=i0004LgT2Ool30005Ool2
000JLgT3Li`600000g>LLgUcN@0JLgT3Ool40003OolMLgT2Li`40004Li`KLgT01000Ool000000Woo
0P000goo>g=i0005LgT8Ool3LgT2000ILgT8Li`00`00LgUcN@0KLgT8OolNLgT01000Li`000001G>L
6W=i0P000W=i0P000Woo0P000Woo?7=i0005LgT8Ool5LgT3000FLgT8Li`00g=i001cN@0KLgT8OolM
LgT00`00LgT000020005Li`GLgT30004LgT00goo000000020003OollLgT000McN@Aoo`YcN@8001Ic
N@AcW0AcN@8001acN@AooaecN@8000AcN@AcW1McN@8000UcN@AoocicN@005g=i0P007W=i00<007=i
LgT06g=i00<007=iLgT06g=i00<007=iLgT077=i0`00CG=i000ILgT3000LLgT00`00LgUcN@0JLgT0
0`00LgUcN@0JLgT00`00LgUcN@0KLgT2001@LgT001acN@8001]cN@03001cNG=i01UcN@03001cNG=i
01UcN@03001cNG=i01YcN@80059cN@007W=i0`006G=i00<007=iLgT067=i00<007=iLgT067=i00<0
07=iLgT067=i0`00E7=i000QLgT2000HLgT00`00LgUcN@0GLgT00`00LgUcN@0GLgT00`00LgUcN@0G
LgT2001GLgT002=cN@8001McN@8001McN@03001cNG=i01EcN@8001McN@<005UcN@009G=i0`005W=i
00<007=iLgT057=i00<007=iLgT057=i00<007=iLgT05G=i0P00G7=i000XLgT2000ELgT00`00LgUc
N@0CLgT00`00LgUcN@0CLgT00`00LgUcN@0DLgT2001NLgT002YcN@8001AcN@03001cNG=i019cN@03
001cNG=i019cN@03001cNG=i019cN@<0061cN@00;7=i0`004W=i00<007=iLgT04G=i00<007=iLgT0
4G=i00<007=iLgT04G=i0P00Hg=i000_LgT2000ALgT2000ALgT00`00LgUcN@0?LgT2000ALgT3001U
LgT0035cN@<0011cN@03001cNG=i00icN@03001cNG=i00icN@03001cNG=i00mcN@8006QcN@00=7=i
0P003g=i00<007=iLgT03G=i00<007=iLgT03G=i00<007=iLgT03G=i0`00JW=i000fLgT2000>LgT0
0`00LgUcN@0<LgT00`00LgUcN@0<LgT00`00LgUcN@0<LgT2001]LgT003QcN@<000acN@03001cNG=i
00]cN@03001cNG=i00]cN@03001cNG=i00]cN@8006mcN@00>g=i0P002g=i0P002g=i00<007=iLgT0
2G=i0P002g=i0`00LG=i000mLgT2000;LgT00`00LgUcN@08LgT00`00LgUcN@08LgT00`00LgUcN@09
LgT2001dLgT003mcN@<000UcN@03001cNG=i00McN@03001cNG=i00McN@03001cNG=i00McN@<007Ic
N@00@W=i0P0027=i00<007=iLgT01W=i00<007=iLgT01W=i00<007=iLgT01W=i0P00NG=i0014LgT3
0006LgT00`00LgUcN@05LgT00`00LgUcN@05LgT00`00LgUcN@05LgT2001kLgT004McN@8000EcN@03
001cNG=i00AcN@03001cNG=i00AcN@03001cNG=i00=cN@<007ecN@00BG=i0P0017=i0P0017=i00<0
07=iLgT00W=i0P0017=i0P00P7=i001;LgT30003LgT00`00LgUcW003Li`2LgT01000LgUcNG=i0`00
PW=i001>LgT200000g=iLi`0000500000g>LLgUcN@020025LgT0051cN@04001cW7>LLi`20003Li`2
0027LgT0051cN@AcW08000AcW8QcN@00D7=i17>L0P0017>LR7=i001@LgT3Li`50002Lib8LgT0051c
N@AcW08000AcW8QcN@00DG=i17>L0`0000=cW7=iLgT0Qg=i001ALgT8Lib9LgT005=cN@AcW8]cN@00
\
\>"],
    ImageRangeCache->{{{0, 225}, {138.375, 0}} -> {-2, 0, 0, 0}},
    CellTags->"Mutation - basic expression 2"],
  " ",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .34481 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .65519 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .6178 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .85839 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .70071 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .9413 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .821 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Mshowa
P
.004 w
.2619 .40712 m
.179 .21092 L
s
.2619 .40712 m
.34481 .21092 L
s
1 g
.05 w
.179 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .21092 0 0 Mshowa
P
1 g
.34481 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .34481 .21092 0 0 Mshowa
P
.9 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .40712 0 0 Mshowa
P
.004 w
.7381 .40712 m
.65519 .21092 L
s
.7381 .40712 m
.7381 .21092 L
s
.7381 .40712 m
.821 .21092 L
s
1 g
.05 w
.65519 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .65519 .21092 0 0 Mshowa
P
.004 w
.7381 .21092 m
.6178 .01472 L
s
.7381 .21092 m
.85839 .01472 L
s
1 g
.05 w
.6178 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .6178 .01472 0 0 Mshowa
P
1 g
.85839 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .85839 .01472 0 0 Mshowa
P
.9 g
.7381 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .21092 0 0 Mshowa
P
.004 w
.821 .21092 m
.70071 .01472 L
s
.821 .21092 m
.9413 .01472 L
s
1 g
.05 w
.70071 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .70071 .01472 0 0 Mshowa
P
1 g
.9413 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .9413 .01472 0 0 Mshowa
P
.9 g
.821 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .821 .21092 0 0 Mshowa
P
.9 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    Evaluatable->False,
    AspectRatioFixed->True,
    ImageSize->{226, 139.375},
    ImageMargins->{{0, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    AnimationDisplayTime->1.00948,
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003R0000Ra000`40O003h00OhW=i0028LgT4Ool>
LgT4OolNLgT4Ool>LgT4Ool@LgT008IcN@Qoo`YcN@QooaYcN@Qoo`YcN@Qoo`icN@00QW=i00=oo`00
00000`000Woo2W=i00=oo`0000000`000Woo6W=i00=oo`0000000P000goo2W=i1@000goo3W=i0025
LgT017oo000007oo0P0017oo27=i00Aoo`00001oo`8000AooaQcN@03Ool00000009oo`8000=oo`Qc
N@9oo`800003Ool0000000=oo`ecN@00QG=i0Woo100017oo27=i0Woo100017oo67=i1Goo0P000goo
27=i0Woo0P0000=oo`0000000goo3G=i0025LgT017oo000007oo0P0017oo27=i00Aoo`00001oo`80
00AooaQcN@=oo`<000Aoo`QcN@9oo`800003Ool0000000=oo`ecN@00QG=i0Woo0`001Goo27=i0Woo
0`001Goo67=i1Goo0P000goo27=i0Woo100017oo3G=i0026LgT8Ool:LgT8OolJLgT20002Ool20002
Ool:LgT00goo00000005Ool>LgT008IcN@Qoo`YcN@QooaYcN@03Ool00000008000=oo`YcN@<000Eo
o`icN@00R7=i17oo3W=i17oo7W=i17oo3G=i00<007ooOol00Woo47=i002<LgT00`00LgUcN@0?LgT0
0`00LgUcN@0JLgT00`00LgUcN@0>LgT00`00LgUcN@0CLgT008ecN@03001cNG=i00icN@03001cNG=i
01YcN@03001cNG=i00icN@03001cNG=i01=cN@00SG=i00<007=iLgT03g=i00<007=iLgT067=i00<0
07=iLgT03W=i00<007=iLgT057=i002>LgT00`00LgUcN@0?LgT00`00LgUcN@0FLgT00`00LgUcN@0>
LgT00`00LgUcN@0ELgT008icN@03001cNG=i00mcN@03001cNG=i01IcN@03001cNG=i00icN@03001c
NG=i01EcN@00Sg=i00<007=iLgT03g=i00<007=iLgT057=i00<007=iLgT03W=i00<007=iLgT05W=i
002@LgT00`00LgUcN@0?LgT00`00LgUcN@0BLgT00`00LgUcN@0>LgT00`00LgUcN@0GLgT0091cN@03
001cNG=i00mcN@03001cNG=i019cN@03001cNG=i00icN@03001cNG=i01McN@00TG=i00<007=iLgT0
3g=i00<007=iLgT047=i00<007=iLgT03W=i00<007=iLgT067=i002BLgT00`00LgUcN@0>LgT00`00
LgUcN@0@LgT00`00LgUcN@0>LgT00`00LgUcN@0HLgT0099cN@03001cNG=i00mcN@03001cNG=i00ic
N@03001cNG=i00icN@03001cNG=i01UcN@00Tg=i00<007=iLgT03g=i00<007=iLgT037=i00<007=i
LgT03W=i00<007=iLgT06W=i002DLgT00`00LgUcN@0>LgT00`00LgUcN@0<LgT00`00LgUcN@0>LgT0
0`00LgUcN@0JLgT009AcN@03001cNG=i00mcN@03001cNG=i00YcN@03001cNG=i00icN@03001cNG=i
01]cN@00UG=i00<007=iLgT03W=i00<007=iLgT02W=i00<007=iLgT03W=i00<007=iLgT06g=i002F
LgT00`00LgUcN@0>LgT00`00LgUcN@08LgT00`00LgUcN@0>LgT00`00LgUcN@0LLgT009IcN@03001c
NG=i00mcN@03001cNG=i00IcN@03001cNG=i00icN@03001cNG=i01ecN@00Ug=i00<007=iLgT03W=i
00<007=iLgT01W=i00<007=iLgT03W=i00<007=iLgT07G=i002GLgT00`00LgUcN@0?LgT00`00LgUc
N@04LgT00`00LgUcN@0>LgT00`00LgUcN@0NLgT009QcN@03001cNG=i00mcN@03001cNG=i009cN@03
001cNG=i00icN@03001cNG=i01mcN@00VG=i00<007=iLgT03W=i00<007=iLgT00W=i00<007=iLgT0
3W=i00<007=iLgT07g=i002ILgT00`00LgUcN@0?LgT01000LgUcN@0047=i00<007=iLgT087=i002J
LgT00`00LgUcN@0>LgT01000LgUcN@0047=i00<007=iLgT087=i002KLgT00`00LgUcN@0>LgT2000@
LgT00`00LgUcN@0QLgT009]cN@03001cNG=i00icN@8000mcN@03001cNG=i029cN@00W7=i00<007=i
LgT03G=i0P003g=i00<007=iLgT08W=i002MLgT00`00LgUcN@0;LgT01000LgUcN@003G=i00<007=i
LgT08g=i002MLgT00`00LgUcN@0:LgT00`00LgUcN@02LgT00`00LgUcN@09LgT00`00LgUcN@0TLgT0
09icN@03001cNG=i00UcN@03001cNG=i009cN@03001cNG=i00UcN@03001cNG=i02AcN@00Wg=i00<0
07=iLgT01g=i00<007=iLgT017=i00<007=iLgT01g=i00<007=iLgT09G=i002OLgT00`00LgUcN@07
LgT00`00LgUcN@04LgT00`00LgUcN@07LgT00`00LgUcN@0ULgT00:1cN@03001cNG=i00EcN@03001c
NG=i00IcN@03001cNG=i00EcN@03001cNG=i02IcN@00X7=i00<007=iLgT017=i00<007=iLgT027=i
00<007=iLgT00g=i00<007=iLgT09g=i000YLgT4OolPLgT4OoloLgT4Ool=LgT400000g>LLgT0000:
LgT500000g>L001cN@0XLgT002McN@QooaacN@Qooc]cN@Qoo`YcN@AcW080009cW0YcN@AcW080009c
W2QcN@009g=i1@000goo77=i00=oo`0000000P000goo>g=i00=oo`0000000P000goo2W=i00=cW000
00000`000W>L2W=i00=cW00000000`000W>L:7=i000VLgT2Ool200000goo00000003OolJLgT00goo
00000002Ool20003OoliLgT00goo00000002Ool20003Ool8LgT00g>L00000002Li`20003Li`8LgT0
0g>L00000002Li`20003Li`WLgT002IcN@9oo`800003Ool0000000=ooaYcN@Eoo`8000=oocUcN@Eo
o`8000=oo`QcN@03Li`00000009cW08000=cW0QcN@03Li`00000009cW08000=cW2McN@009W=i0Woo
0P0000=oo`0000000goo6W=i0goo0`0017oo>G=i1Goo0P000goo27=i00=cW00000000W>L0P000g>L
27=i00=cW00000000W>L0P000g>L9g=i000VLgT2Ool40004OolJLgT5Ool20003OoliLgT00goo0000
00030004Ool8LgT2Li`60002Li`8LgT2Li`60002Li`WLgT002McN@03Ool0000000EooaacN@80009o
o`80009ooc]cN@8000Ioo`YcN@QcW0YcN@QcW2QcN@009g=i0`001Goo77=i00=oo`0000000P000goo
>g=i1P000Woo2W=i27>L2W=i27>L:7=i000YLgT4Ool00`00LgUcN@0LLgT00`00Oomoo`02OoloLgT4
Ool00`00LgUcN@0;LgT4Li`=LgT00`00LiacW002Li`ZLgT002ecN@03001cNG=i01acN@03001cNG=i
04EcN@03001cNG=i00ecN@03001cNG=i00acN@03001cNG=i02acN@00;W=i00<007=iLgT06W=i00<0
07=iLgT0Ag=i00<007=iLgT037=i00<007=iLgT02g=i00<007=iLgT0;G=i000^LgT00`00LgUcN@0J
LgT00`00LgUcN@17LgT00`00LgUcN@0<LgT00`00LgUcN@0;LgT00`00LgUcN@0]LgT002icN@03001c
NG=i01UcN@03001cNG=i04UcN@03001cNG=i00]cN@03001cNG=i00]cN@03001cNG=i02ecN@00;g=i
00<007=iLgT067=i00<007=iLgT0BG=i00<007=iLgT02g=i00<007=iLgT02W=i00<007=iLgT0;W=i
000_LgT00`00LgUcN@0HLgT00`00LgUcN@19LgT00`00LgUcN@0;LgT00`00LgUcN@0:LgT00`00LgUc
N@0^LgT0031cN@03001cNG=i01IcN@03001cNG=i04]cN@03001cNG=i00YcN@03001cNG=i00UcN@03
001cNG=i02mcN@00<7=i00<007=iLgT05W=i00<007=iLgT0Bg=i00<007=iLgT02W=i00<007=iLgT0
2G=i00<007=iLgT0;g=i000`LgT00`00LgUcN@0ELgT00`00LgUcN@1=LgT00`00LgUcN@09LgT00`00
LgUcN@09LgT00`00LgUcN@0_LgT0035cN@03001cNG=i01AcN@03001cNG=i04ecN@03001cNG=i00Uc
N@03001cNG=i00QcN@03001cNG=i031cN@00<G=i00<007=iLgT057=i00<007=iLgT0CG=i00<007=i
LgT02G=i00<007=iLgT027=i00<007=iLgT0<7=i000bLgT00`00LgUcN@0BLgT00`00LgUcN@1?LgT0
0`00LgUcN@08LgT00`00LgUcN@07LgT00`00LgUcN@0aLgT0039cN@03001cNG=i019cN@03001cNG=i
04mcN@03001cNG=i00QcN@03001cNG=i00McN@03001cNG=i035cN@00<W=i00<007=iLgT04G=i00<0
07=iLgT0DG=i00<007=iLgT01g=i00<007=iLgT01g=i00<007=iLgT0<G=i000cLgT00`00LgUcN@0@
LgT00`00LgUcN@1ALgT00`00LgUcN@07LgT00`00LgUcN@06LgT00`00LgUcN@0bLgT003=cN@03001c
NG=i00mcN@03001cNG=i05=cN@03001cNG=i00IcN@03001cNG=i00IcN@03001cNG=i039cN@00=7=i
00<007=iLgT03W=i00<007=iLgT0Dg=i00<007=iLgT01W=i00<007=iLgT01G=i00<007=iLgT0<g=i
000dLgT00`00LgUcN@0>LgT00`00LgUcN@1CLgT00`00LgUcN@06LgT00`00LgUcN@05LgT00`00LgUc
N@0cLgT003AcN@03001cNG=i00ecN@03001cNG=i05EcN@03001cNG=i00EcN@03001cNG=i00EcN@03
001cNG=i03=cN@00=G=i00<007=iLgT037=i00<007=iLgT0EG=i00<007=iLgT01G=i00<007=iLgT0
17=i00<007=iLgT0=7=i000eLgT00`00LgUcN@0;LgT00`00LgUcN@1GLgT00`00LgUcN@04LgT00`00
LgUcN@04LgT00`00LgUcN@0dLgT003EcN@03001cNG=i00]cN@03001cNG=i05McN@03001cNG=i00Ac
N@03001cNG=i00AcN@03001cNG=i03AcN@00=W=i00<007=iLgT02G=i00<007=iLgT0FG=i00<007=i
LgT00g=i00<007=iLgT00g=i00<007=iLgT0=G=i000fLgT00`00LgUcN@09LgT00`00LgUcN@1ILgT0
0`00LgUcN@03LgT00`00LgUcN@03LgT00`00LgUcN@0eLgT003McN@03001cNG=i00QcN@03001cNG=i
05UcN@03001cNG=i00=cN@03001cNG=i009cN@03001cNG=i03IcN@00=g=i00<007=iLgT01g=i00<0
07=iLgT0Fg=i00<007=iLgT00W=i00<007=iLgT00W=i00<007=iLgT0=W=i000gLgT00`00LgUcN@07
LgT00`00LgUcN@1KLgT00`00LgUcN@02LgT00`00LgUcN@02LgT00`00LgUcN@0fLgT003QcN@03001c
NG=i00EcN@03001cNG=i05ecN@05001cNG=iLgT00003LgT00`00LgUcN@0gLgT003QcN@03001cNG=i
00EcN@03001cNG=i05ecN@05001cNG=iLgT00003LgT00`00LgUcN@0gLgT003UcN@03001cNG=i00Ac
N@03001cNG=i05ecN@05001cNG=iLgT00002LgT00`00LgUcN@0hLgT003UcN@03001cNG=i00=cN@03
001cNG=i05mcN@04001cNG=i0002LgT00`00LgUcN@0hLgT003UcN@03001cNG=i00=cN@03001cNG=i
05mcN@04001cNG=i0002LgT00`00LgUcN@0hLgT000McN@AoobmcN@@00003LiacNG=i02ecN@Aooc1c
N@AcW003001cNG=i02acN@Aoo`UcN@001G=i27oo;7=i17>L0P000W>L:g=i27oo;7=i27>L:g=i27oo
1g=i0005LgT00goo000000030002Ool/LgT00g>L000000030002Li`[LgT2Ool40002Ool/LgT70000
0g>LLgUcN@0YLgT00goo0000000400000gooLgUcN@05LgT000AcN@04Ool00000Ool20004OolZLgT0
0g>L00000002Li`20003Li`YLgT2Ool20002Ool20002OolZLgT2Li`200000g>L00000003Li`YLgT3
Ool200000goo00000002Ool6LgT000AcN@9oo`@000AoobYcN@03Li`00000009cW08000=cW2UcN@9o
o`8000IoobYcN@9cW0800003Li`0000000=cW2UcN@Aoo`8000Aoo`IcN@0017=i00Aoo`00001oo`80
00AoobYcN@03Li`00000009cW08000=cW2UcN@9oo`80009oo`80009oobYcN@9cW0800003Li`00000
00=cW2UcN@Eoo`8000=oo`IcN@0017=i0Woo0`001Goo:W=i0W>L1P000W>L:G=i0goo10000goo:W=i
0W>L100017>L:G=i0Woo0P000Woo0P000Woo1W=i0005LgT8Ool00g=i0000000YLgT8Li`[LgT8Ool/
LgT00g>L00000005Li`YLgT200000goo00000002Ool200000gooLgUcN@05LgT000EcN@Qoo`=cN@<0
02IcN@QcW2]cN@QoobacN@<000EcW2IcN@<0009cN@9oo`@0009oo`McN@001g=i17oo27=i0P009W=i
17>L0W=i0P00:g=i17oo;7=i0P000W=i17>L9W=i0P001g=i17oo2G=i000ELgT2000/LgT00`00LgUc
N@0ZLgT00`00LgUcN@0ZLgT00`00LgUcN@0ZLgT2000FLgT001McN@<002YcN@03001cNG=i02UcN@03
001cNG=i02UcN@03001cNG=i02QcN@<001QcN@006W=i0P00:G=i00<007=iLgT0:7=i00<007=iLgT0
:7=i00<007=iLgT09g=i0P006g=i000LLgT3000WLgT2000XLgT00`00LgUcN@0VLgT2000WLgT3000M
LgT001mcN@8002McN@03001cNG=i02EcN@03001cNG=i02EcN@03001cNG=i02EcN@80021cN@008G=i
0`009G=i00<007=iLgT097=i00<007=iLgT097=i00<007=iLgT08g=i0`008W=i000TLgT2000TLgT0
0`00LgUcN@0SLgT00`00LgUcN@0SLgT00`00LgUcN@0RLgT2000ULgT002IcN@<0029cN@03001cNG=i
029cN@03001cNG=i029cN@03001cNG=i021cN@<002McN@00:G=i0P008G=i0P008W=i00<007=iLgT0
87=i0P008G=i0P00:W=i000[LgT3000PLgT00`00LgUcN@0OLgT00`00LgUcN@0OLgT00`00LgUcN@0N
LgT3000/LgT002icN@8001mcN@03001cNG=i01icN@03001cNG=i01icN@03001cNG=i01ecN@8002mc
N@00<7=i0P007W=i00<007=iLgT07G=i00<007=iLgT07G=i00<007=iLgT077=i0P00<G=i000bLgT3
000LLgT2000MLgT00`00LgUcN@0KLgT2000LLgT3000cLgT003EcN@8001acN@03001cNG=i01YcN@03
001cNG=i01YcN@03001cNG=i01YcN@8003IcN@00=g=i0`006W=i00<007=iLgT06G=i00<007=iLgT0
6G=i00<007=iLgT067=i0`00>7=i000jLgT2000ILgT00`00LgUcN@0HLgT00`00LgUcN@0HLgT00`00
LgUcN@0GLgT2000kLgT003acN@<001McN@8001QcN@03001cNG=i01IcN@8001McN@<003ecN@00?g=i
0P005g=i00<007=iLgT05G=i00<007=iLgT05G=i00<007=iLgT05G=i0P00@7=i0011LgT3000ELgT0
0`00LgUcN@0DLgT00`00LgUcN@0DLgT00`00LgUcN@0CLgT30012LgT004AcN@8001AcN@03001cNG=i
01=cN@03001cNG=i01=cN@03001cNG=i019cN@8004EcN@00AW=i0`004W=i0P004g=i00<007=iLgT0
4G=i0P004W=i0`00Ag=i0019LgT2000BLgT00`00LgUcN@0@LgT00`00LgUcN@0@LgT00`00LgUcN@0@
LgT2001:LgT004]cN@80015cN@03001cNG=i00mcN@03001cNG=i00mcN@03001cNG=i00mcN@8004ac
N@00CG=i0`003g=i00<007=iLgT03W=i00<007=iLgT03W=i00<007=iLgT03G=i0`00CW=i001@LgT2
000>LgT2000>LgT00`00LgUcN@0<LgT2000>LgT2001ALgT0059cN@<000ecN@03001cNG=i00]cN@03
001cNG=i00]cN@03001cNG=i00]cN@<005=cN@00EG=i0P0037=i00<007=iLgT02W=i00<007=iLgT0
2W=i00<007=iLgT02W=i0P00EW=i001GLgT3000:LgT00`00LgUcN@09LgT00`00LgUcN@09LgT00`00
LgUcN@08LgT3001HLgT005YcN@8000UcN@03001cNG=i00QcN@03001cNG=i00QcN@03001cNG=i00Mc
N@8005]cN@00G7=i0`001g=i0P0027=i00<007=iLgT01W=i0P001g=i0`00GG=i001OLgT20007LgT0
0`00LgUcN@05LgT00`00LgUcN@05LgT00`00LgUcN@05LgT2001PLgT0065cN@<000EcN@03001cNG=i
00AcN@03001cNG=i00AcN@03001cNG=i00=cN@<0069cN@00I7=i0P0017=i00<007=iLgT00g=i00<0
07=iLgT00g=i00<007=iLgT00W=i0P00IG=i001VLgT20003LgT200000g=iLiacW002Li`2LgT20003
LgT2001WLgT006QcN@<00003LgUcW00000D00003LiacNG=i00<006UcN@00Jg=i00@007>LLiacW080
00=cW08006acN@00Jg=i17>L0P0017>LKG=i001[LgT4Li`20004Lia]LgT006]cN@=cW0D0009cW6ec
N@00Jg=i17>L0P0017>LKG=i001/LgT4Li`300000g>LLgUcN@1/LgT006acN@QcW6icN@00KW=i17>L
L7=i0000\
\>"],
    ImageRangeCache->{{{0, 225}, {138.375, 0}} -> {-2, 0, 0, 0}},
    CellTags->"Mutation - mutant 9"]
}], "Text"],

Cell[CellGroupData[{

Cell["Introduction", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "This notebook contains programs and examples of operators used in the ",
  StyleBox["Evolvica",
    FontSlant->"Italic"],
  " evolutionary algorithm environment. In the current version of ",
  StyleBox["Evolvica",
    FontSlant->"Italic"],
  " the following genetic operators are implemented: "
}], "Text"],

Cell[TextData[
"\[Bullet] mutation \n\[Bullet] recombination \n\[Bullet] duplication \n\
\[Bullet] deletion \n\[Bullet] inversion \n\[Bullet] encapsulation \n\
\[Bullet] decapsulation \n\[Bullet] macro extraction"], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Operator examples", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Mutation", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Mutation - Intro"],

Cell[CellGroupData[{

Cell["Templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(patterns = {f[__, _g, __, _h, __], g[a | b | c, __], 
          h[_Integer | _Symbol, __g], a, b, c, d, e, 
          Sequence @@ Range[1, 5]};\)\)], "InputDemo",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Generating S-expression chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(theChromos = 
      createChromosomes[1, StartPattern \[Rule] _f, 
        SequenceRange \[Rule] {1, 2}, MaxDepth \[Rule] 6, 
        ExprPatterns \[Rule] patterns]\)], "InputDemo",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[5, g[a, 2], g[c, b, e], 1, h[e, g[c, a], g[c, c]], c, 
            c]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> .2];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.13323 .21092 -5 -6 ]
[.13323 .21092 5 6 ]
[.23184 .21092 -5 -6 ]
[.23184 .21092 5 6 ]
[.18254 .40712 -5 -6 ]
[.18254 .40712 5 6 ]
[.29197 .21092 -5 -6 ]
[.29197 .21092 5 6 ]
[.34127 .21092 -5 -6 ]
[.34127 .21092 5 6 ]
[.39057 .21092 -5 -6 ]
[.39057 .21092 5 6 ]
[.34127 .40712 -5 -6 ]
[.34127 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.60943 .21092 -5 -6 ]
[.60943 .21092 5 6 ]
[.57535 .01472 -5 -6 ]
[.57535 .01472 5 6 ]
[.74211 .01472 -5 -6 ]
[.74211 .01472 5 6 ]
[.65873 .21092 -5 -6 ]
[.65873 .21092 5 6 ]
[.62465 .01472 -5 -6 ]
[.62465 .01472 5 6 ]
[.79142 .01472 -5 -6 ]
[.79142 .01472 5 6 ]
[.70803 .21092 -5 -6 ]
[.70803 .21092 5 6 ]
[.65873 .40712 -5 -6 ]
[.65873 .40712 5 6 ]
[.81746 .40712 -5 -6 ]
[.81746 .40712 5 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.18254 .40712 L
s
.5 .60332 m
.34127 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.65873 .40712 L
s
.5 .60332 m
.81746 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.18254 .40712 m
.13323 .21092 L
s
.18254 .40712 m
.23184 .21092 L
s
1 g
.05 w
.13323 .21092 Mdot
0 g
gsave
.13323 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.23184 .21092 Mdot
0 g
gsave
.23184 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.18254 .40712 Mdot
0 g
gsave
.18254 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.34127 .40712 m
.29197 .21092 L
s
.34127 .40712 m
.34127 .21092 L
s
.34127 .40712 m
.39057 .21092 L
s
1 g
.05 w
.29197 .21092 Mdot
0 g
gsave
.29197 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.34127 .21092 Mdot
0 g
gsave
.34127 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.39057 .21092 Mdot
0 g
gsave
.39057 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.9 g
.34127 .40712 Mdot
0 g
gsave
.34127 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 Mabswid
.65873 .40712 m
.60943 .21092 L
s
.65873 .40712 m
.65873 .21092 L
s
.65873 .40712 m
.70803 .21092 L
s
1 g
.05 w
.60943 .21092 Mdot
0 g
gsave
.60943 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.65873 .21092 m
.57535 .01472 L
s
.65873 .21092 m
.74211 .01472 L
s
1 g
.05 w
.57535 .01472 Mdot
0 g
gsave
.57535 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.74211 .01472 Mdot
0 g
gsave
.74211 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.65873 .21092 Mdot
0 g
gsave
.65873 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70803 .21092 m
.62465 .01472 L
s
.70803 .21092 m
.79142 .01472 L
s
1 g
.05 w
.62465 .01472 Mdot
0 g
gsave
.62465 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.79142 .01472 Mdot
0 g
gsave
.79142 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.70803 .21092 Mdot
0 g
gsave
.70803 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.65873 .40712 Mdot
0 g
gsave
.65873 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.81746 .40712 Mdot
0 g
gsave
.81746 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.812, 174.188},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[R000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00W_ooool4
o`0000[ooooo1?l0000Looooo`Go00002?ooool4o`0003cooooo002Mooooo`;o00000_ooool2o`00
00Sooooo0_l00002ooooo`;o00006_ooool2o`000003ooooool0003o000000Sooooo0_l00002oooo
o`;o0000>oooool009gooooo0_l0000<ooooo`;o00007oooool4o`0000Sooooo0_l0000oooooo`00
WOooool2o`0000;ooooo0_l00008ooooo`;o00000_ooool2o`0001[ooooo0_l000000ooooooo0000
o`000008ooooo`;o00000_ooool2o`0003_ooooo002Nooooo`Co00002_ooool4o`0001cooooo0ol0
000:ooooo`Co0000??ooool00?oooooo6_ooool00?oooooo6_ooool00?oooooo6_ooool00;3ooooo
00?o0000ooooooooool0I_ooool00:?ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0?_ooool00:?ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool0?_ooool00:Cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0?oooool00:Cooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool0?oooool00:Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0@?ooool00:Gooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0@?oo
ool00:Gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0@?ooool00:Kooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0@Oooool00:Ko
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0@Oooool00:Oooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0@_ooool00:Oooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0@_ooool00:Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0@oooool00:Sooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0@oooool00:Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0@oooool00:Wooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
A?ooool00:Wooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool0A?ooool00:[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0AOooool0
0:[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool0AOooool00:_ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0A_ooool00:_ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool0A_ooool00:cooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0Aoooool00:cooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool0Aoooool00:cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0Aoooool00:gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool0B?ooool00:gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0B?ooool00:kooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0BOoo
ool00:kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0BOooool00:oooooo00?o0000ooooooooool02_ooool01?l0
003oooooooooool0000<ooooo`03o`000?oooooooooo04[ooooo002_ooooo`03o`000?oooooooooo
00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`1:ooooo`00[oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool0B_ooool00;3o
oooo00?o0000ooooooooool02_ooool2o`0000cooooo00?o0000ooooooooool0Boooool00;3ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04_ooooo
002aooooo`03o`000?oooooooooo00Wooooo0_l0000;ooooo`03o`000?oooooooooo04cooooo002a
ooooo`03o`000?oooooooooo00Wooooo0_l0000;ooooo`03o`000?oooooooooo04cooooo002boooo
o`03o`000?oooooooooo00Oooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`1=
ooooo`00/_ooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000
ooooooooool0COooool00;;ooooo00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo
000000Sooooo00?o0000ooooooooool0COooool00;?ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0C_ooool00;?o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0C_ooool00;Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Coooool00;Cooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0Coooool00;Gooooo1OoVi^H8ooooo`Goi^KVD_ooool00;?ooooo0_oVi^H4o`00
00?oi^KV1?ooool2onKViPCo00000ooVi^I@ooooo`00/_ooool6onKViP;o00000ooVi^H2ooooo`Ko
i^KV0_l00003onKViToooooo000Wooooo`Go00005?ooool6o`0000_ooooo1?l00009ooooo`Go0000
2Oooool4o`0003Sooooo1?l00006ooooo`?oi^KV1Ol00003onKViP;ooooo0ooVi^H5o`0000?oi^KV
Coooool002Kooooo0_l000000ooooooo0000o`00000Fooooo`;o000000?oooooo`000?l000002_oo
ool2o`0000;ooooo0_l00009ooooo`;o000000?oooooo`000?l000001oooool2o`0003[ooooo0_l0
0008ooooo`?oi^KV0_l00002onKViP;o00001ooVi^H2o`0000;oi^KV0_l00004onKViTkooooo000W
ooooo`Co00005oooool2o`0000cooooo0_l0000=ooooo`;o000000?oooooo`000?l000001oooool6
o`0003Kooooo1_l00004ooooo`?oi^KV0_l00002onKViP;o00001ooVi^H2o`0000;oi^KV0_l00004
onKViTkooooo000Vooooo`;o000000?oooooo`000?l000006?ooool2o`0000_ooooo0_l00002oooo
o`;o00002Oooool2o`000003ooooool0003o000000Oooooo0_l00002ooooo`;o0000=_ooool2o`00
00;ooooo0_l00004ooooo`?oi^KV0_l00002onKViP;o00001ooVi^H2o`0000;oi^KV0_l00004onKV
iTkooooo000Wooooo`?o00005_ooool2o`0000;ooooo0_l0000;ooooo`Co00002_ooool4o`0000Wo
oooo1?l0000hooooo`Co00001Oooool4onKViPKo00001ooVi^H6o`0000?oi^KVC_ooool0043ooooo
0_l00002ooooo`;o00006Oooool2o`00053ooooo6_oVi^I>ooooo`00@Oooool4o`0001Wooooo0ol0
001Aooooo`_oi^KV0_ooool;onKViToooooo002booooo`_oi^KV0_ooool;onKViToooooo002coooo
o`Woi^KV1?ooool9onKViU3ooooo002/ooooo`03o`000?oooooooooo00Kooooo1OoVi^H8ooooo`Go
i^KVD_ooool002[ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0mooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Dooooo`00:_oo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Cooooo000Zooooo`03o`000?oooooo
oooo01Cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0E?ooool002_ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0oooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`1Eooooo`00:oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Go
oooo000[ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0?oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0EOooool002cooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`1Eooooo`00;?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo03oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05Gooooo000/ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool05Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0@Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0E_ooool002cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`11ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Fooooo`00
;Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Kooooo000]ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0E_ooool002gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`13ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`1Gooooo`00;Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
04?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
05Oooooo000^ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0@oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Eoooool002kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Gooooo`00;_ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo05Sooooo000^ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0AOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0F?ooool002oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`15oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Hoooo
o`00;oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo04Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05Sooooo000_ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0FOooool002oooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`1Iooooo`00<?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo04Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo05Wooooo000`ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Aoooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0FOooool0033o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Jooooo`00<?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo05[ooooo000aooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0BOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0F_ooool0037ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`19
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1J
ooooo`00<Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01oooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000004gooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo05_ooooo000aooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000COoo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0Foooool003;ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0Pooooo`05o`000?ooooooooooooooool00000
0oooool00ol0003oooooooooo`1;ooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`1Kooooo`00<_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo023ooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo04_ooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo05_ooooo000booooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool08Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0COooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo05cooooo000coooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool08_ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo04gooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`1Looooo`00<oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02;ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`1=ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0G?ooool003?ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Rooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0COooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo05cooooo000cooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool08_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo04go
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`1Looooo`00=?ooool01Ol0003o
oooooooooooooooo000002Kooooo00Go0000ooooool0003oooooo`00001Aooooo`05o`000?oooooo
0000ooooool00000Goooool003Cooooo00Go0000ooooooooooooooooo`00000Vooooo`05o`000?oo
oooo0000ooooool00000DOooool01Ol0003oooooo`000?oooooo000005oooooo000dooooo`05o`00
0?ooooooooooooooool000009_ooool01Ol0003oooooo`000?oooooo0000057ooooo00Go0000oooo
ool0003oooooo`00001Oooooo`00=?ooool5onKViRKooooo1OoVi^IAooooo`Goi^KVGoooool003;o
oooo2OoVi^HRooooo`Woi^KVCOooool9onKViUgooooo000aooooo`?oi^KV1?l00004onKViR3ooooo
0ooVi^H4o`0000Coi^KVBoooool;onKViUcooooo000aooooo`Koi^KV0_l00003onKViR3ooooo1_oV
i^H2o`0000?oi^KVBoooool;onKViUcooooo0009ooooo`Co00008oooool4onKViPGo00001?oVi^HN
ooooo`Coi^KV1Ol00004onKViR;ooooo1?l0000Sooooo`?oi^KV1ol00003onKViR;ooooo1?l0000W
ooooo`Co00002_ooool000Sooooo0_l00002ooooo`;o00008_ooool3onKViP;o00000_oVi^H2o`00
00Coi^KV7_ooool3onKViP;o00000_oVi^H2o`0000Coi^KV8oooool2o`0002Cooooo1?oVi^H2o`00
0003onKVi_l0003o000000Coi^KV8Oooool2o`0000;ooooo0_l0000Uooooo`;o00000_ooool2o`00
00Wooooo000<ooooo`;o00008_ooool3onKViP;o00000_oVi^H2o`0000Coi^KV7_ooool3onKViP;o
00000_oVi^H2o`0000Coi^KV8oooool2o`0002Cooooo1?oVi^H2o`000003onKVi_l0003o000000Co
i^KV8Oooool2o`0002Wooooo0_l0000=ooooo`003?ooool2o`0002;ooooo0ooVi^H2o`0000;oi^KV
0_l00004onKViQkooooo0ooVi^H2o`0000;oi^KV0_l00004onKViR?ooooo0_l0000Tooooo`Coi^KV
0_l000000ooVi^Ko0000o`000004onKViR7ooooo0_l00002ooooo`;o00009Oooool2o`0000;ooooo
0_l00009ooooo`002?ooool5o`0002?ooooo1?oVi^H6o`0000?oi^KV7_ooool4onKViPKo00000ooV
i^HSooooo`;o00009?ooool4onKViPCo00001OoVi^HRooooo`Co00009oooool4o`0000[ooooo0008
ooooo`;o00002?ooool3o`0001cooooo2ooVi^H00ol0003oooooooooo`0Mooooo`_oi^KV8oooool3
o`0002Gooooo0ooVi^H2o`0000Koi^KV7oooool00ol0003oooooooooo`0Uooooo`?o00004_ooool0
00Sooooo1_l00007ooooo`;o00006_ooool;onKViP03ooooool0003ooooo01gooooo2ooVi^HToooo
o`;o00009Oooool2onKViP?o00001_oVi^HNooooo`03o`000?oooooooooo02Cooooo0_l0000Eoooo
o`005oooool2o`0001Wooooo2OoVi^H3ooooo`;o00007Oooool9onKViTgooooo2OoVi^HMooooo`;o
00009Oooool2o`0001Oooooo000Iooooo`?o00006?ooool5onKViPOooooo0_l0000Mooooo`Goi^KV
00?oooooo`000?ooool0C?ooool00ol0003oooooonKViP04onKViQgooooo0_l0000Tooooo`?o0000
6Oooool001cooooo0_l0000Tooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08_oo
ool2o`0001cooooo000Nooooo`?o00008_ooool2o`0002;ooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo023ooooo0_l0000Rooooo`?o00007_ooool0
027ooooo0_l0000Rooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool2o`00
027ooooo000Sooooo`?o00008?ooool2o`00027ooooo00?o0000ooooooooool08?ooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo01oooooo0_l0000Pooooo`?o00008oooool002Kooooo
0_l0000Pooooo`;o00008?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo
00?o0000ooooooooool07_ooool2o`00023ooooo0_l0000Vooooo`00:?ooool2o`00023ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`0Nooooo`;o0000:?ooool002[ooooo0ol0000N
ooooo`;o00007_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000
ooooooooool07?ooool2o`0001kooooo0ol0000Zooooo`00;Oooool2o`0001kooooo0_l0000Moooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Koooo
o`;o00007_ooool2o`0002gooooo000_ooooo`?o00007Oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01_ooooo0ol0000_ooooo`00<_ooool2o`0001cooooo0_l0000Looooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Jooooo`;o0000
7?ooool2o`0003;ooooo000dooooo`?o00006oooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo01Wooooo0ol0000dooooo`00=oooool2o`0001[ooooo0_l0000Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Hooooo`;o00006_ooool2
o`0003Oooooo000iooooo`;o00006_ooool2o`0001Wooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo01Oooooo0_l0000Jooooo`;o0000>Oooool003_o
oooo0ol0000Iooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool3o`0003_o
oooo000nooooo`;o00006?ooool2o`0001Sooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo01Kooooo0_l0000Hooooo`;o0000?_ooool0043ooooo0ol0
000Gooooo`;o00005_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool05?ooool2o`0001Oooooo0ol00010ooooo`00@oooool2o`0001Oooooo00?o0000
ooooooooool05?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000
ooooooooool05?ooool00ol0003oooooooooo`0Eooooo`;o0000@oooool004Gooooo0ol0000Eoooo
o`;o00005Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool04oooool2o`0001Gooooo0ol00015ooooo`00B?ooool2o`0001Gooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0Cooooo`;o0000B?ooool004[ooooo0ol0000Cooooo`;o0000
5?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo0ol0001:ooooo`00COooool2o`0001?ooooo0_l0000Cooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`;o00004ooo
ool2o`0004gooooo001?ooooo`;o00004oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo017ooooo0_l0001?ooooo`00DOooool3o`00017ooooo0_l0000Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0?ooooo`;o00004Oooool3o`00
057ooooo001Dooooo`;o00004Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oo
oooo0_l0001Dooooo`00E_ooool3o`0000oooooo0_l0000@ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`;o00003oooool3o`0005Kooooo
001Iooooo`;o00003oooool2o`0000oooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo0_l0000?ooooo`;o0000FOooool005_ooooo0ol0000>
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool3o`0005_ooooo001Noooo
o`;o00003Oooool2o`0000gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00_ooooo0_l0000=ooooo`;o0000G_ooool0063ooooo0_l0000=ooooo`;o
00003?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool02_ooool2o`0000gooooo0_l0001Pooooo`00H_ooool3o`0000cooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`0:ooooo`?o0000H_ooool006Gooooo0_l0000;ooooo`;o00002ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool2o`0000_ooooo0_l0001Uooooo`00Ioooool3o`0000[ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`?o0000Ioooool006[ooooo0_l00009ooooo`;o00002Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool2o`00
00Wooooo0_l0001Zooooo`00K?ooool3o`0000Sooooo0_l00008ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`;o00002?ooool3o`0006co
oooo001_ooooo`;o00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
0_l0001_ooooo`00LOooool2o`0000Oooooo0_l00007ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`;o00001oooool2o`00077ooooo001c
ooooo`?o00001_ooool2o`0000Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00?ooooo0_l00006ooooo`?o0000Loooool007Kooooo0_l00006oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool2o`0007Kooooo001hooooo`?o
00001?ooool2o`0000Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00;ooooo0_l00004ooooo`?o0000N?ooool007_ooooo0_l00004ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool2o`0007_ooooo001mooooo`?o00000_oo
ool2o`0000?ooooo00?o0000ooooooooool01OoVi^H2ooooo`04o`000?ooooooooooooooo`;o0000
0_ooool3o`0007gooooo0020ooooo`;o00000_ooool2o`0000;ooooo2OoVi^H2ooooo`;o00000_oo
ool2o`00083ooooo0022ooooo`;o00000_ooool00ol0003oi^KVonKViP09onKViP03o`000?oooooo
oooo00;o0000P_ooool008Cooooo0ol0000;onKViP?o0000Q?ooool008Kooooo0ooVi^H6o`0000Co
i^KVQ_ooool008Kooooo1OoVi^H2o`0000Koi^KVQ_ooool008Kooooo1OoVi^H2o`0000Koi^KVQ_oo
ool008Kooooo1OoVi^H2o`0000Koi^KVQ_ooool008Kooooo1?oVi^H5o`0000Coi^KVQ_ooool008Oo
oooo1?oVi^H2o`0000Goi^KVQoooool008Oooooo1OoVi^H3o`0000?oi^KVQoooool008Sooooo2OoV
i^J8ooooo`00R_ooool5onKViX[ooooo0000\
\>"],
  ImageRangeCache->{{{0, 280.812}, {173.188, 0}} -> {-2.17447, -0.625483, \
0.015487, 0.00375876}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic expression tree", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[a, g[b,3], c, h[e, g[c, g[b,4]]], 2]
    ]
  ]
]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]]]\
\>"],
   "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Mshowa
P
1 g
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.44709 .16187 L
s
.62346 .30902 m
.79982 .16187 L
s
1 g
.05 w
.44709 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Mshowa
P
.004 w
.79982 .16187 m
.62346 .01472 L
s
.79982 .16187 m
.97619 .01472 L
s
1 g
.05 w
.62346 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.79982 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Mshowa
P
.9 g
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{396, 244.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006<0000m0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0S@000?l0S@000?l0S@000?l0S@000?l0
S@000?l0S@000?l0S@000?l0S@000?801?n400?o3`000?8000Go0000o`240003o`0000h0003b0005
o`000?l0P@05o`l0003b0005o`000?l0PP000ol0o`0@0000lP04oh<000?o0?l040000?8000?o0000
Q@02oa00003a00;oV@000?l0S@000?`000?o0000L`000ol0000G0000o@000ol0001a0003o`0001P0
003n0003o`0006l000?o00006@000?l000?o0000K@000ol0000J0000o`0100;oJ`02oad0003o00<0
00?o0000I`000ol0000M0000o`040003o`0006D000?o00007P000?l01@000ol0001S0003o`0001l0
003o00H000?o0000H@000ol0000P0000o`0700;oG`02ob<0003o00T000?o0000F`000ol0000S0000
o`0:0003o`0005T000?o000090000?l02`000ol0001G0003o`0002D0003o00`000?o0000E@000ol0
000V0000o`0=00;oD`02obT0003o00l000?o0000C`000ol0000Y0000o`0@0003o`0004d000?o0000
:P000?l04@000ol0001;0003o`0002/0003o018000?o0000B@000ol0000/0000o`0C00;oA`02obl0
003o01D000?o0000@`000ol0000_0000o`0F0003o`00044000?o0000<0000?l05`000ol0000o0003
o`000340003o01P000?o0000?@000ol0000b0000o`0I0003o`0003/000?o0000<`000?l06P02ocT0
0_lf0000o`0L0003o`0003D000?o0000=P000?l07@000ol0000c0003o`0003L0003o01h000?o0000
<@000ol0000h0000o`0O0003o`0002l000?o0000>@000?l08002obd00_ll0000o`0R0003o`0002T0
00?o0000?0000?l08`000ol0000W0003o`0003d0003o02@000?o00009@000ol0000n0000o`0U0003
o`0002<000?o0000?`000?l09P02ob400_m20000o`0X0003o`0001d000?o0000@P000?l0:@000ol0
000K0003o`0004<0003o02X000?o00006@000ol000140000o`0[0003o`0001L000?o0000A@000?l0
;002oaD00_m80000o`0^0003o`0000@01l/60003o`0004P0003o02l000Co00002l/30003o`0004T0
003o030000?o0</03</00`3o001;0000o`0a00o;C@000?l0<00Abd`0003o03001//3o`S;C0000?l0
;`0:b`03ol_;00K;B`000:l01?mk00O;1?l8bd/0002^0003o`0007d01//01Oo;bl_o00S;B`000:h0
00?o0000O@06b`05ol_;bol02<];0000[P001Ol0003o07/01//01Oo;bl_o00S;B`000:l01?mk00O;
1Ol7bd/0003o02l04l];0000o`0`017;C0000?l0<00Abd`0002i0003o`0007<000?obl/03L]=0000
^P000ol0001a0003o`0000g;CP000;/000?o0000K`000ol0000200_;C`000;`000?o0000K@000ol0
000500O;D@000;d00_m[00;oH0000;l000?o0000I`000ol0001P0000`0000ol0001U0003o`000640
00310003o`0006<000?o0000HP000<8000?o0000H@000ol0001S0000``02oel00_mV0000a@000ol0
001K0003o`0006H000360003o`0005T000?o0000I`000<L000?o0000E`000ol0001X0000b0000ol0
001E0003o`0006T0003900;oD`02of`0003;0003o`0004l000?o0000K0000<`000?o0000C@000ol0
001]0000c@000ol0001;0003o`0006h0003>0003o`0004T000?o0000K`000<l00_m700;oLP000=40
00?o0000@`000ol0001b0000dP000ol000110003o`0007<0003C0003o`0003l000?o0000M0000=@0
00?o0000?@000ol0001e0000e@000ol0000k0003o`0007H0003F00;o>@02ogT0003H0003o`0003D0
00?o0000N@000=T000?o0000<`000ol0001j0000fP000ol0000a0003o`0007/0003K0003o`0002l0
00?o0000O0000=`00_l]00;oO`000=h000?o0000:@000ol0001o0000g`000ol0000W0003o`000800
003P0003o`0002D000?o0000P@000>4000?o00008`000ol000220000hP02ob400_n50000i0000ol0
000M0003o`0008D0003U0003o`0001/000?o0000QP000>H000?o00006@000ol000270000i`000ol0
000G0003o`0008P0003X00;o5@02oh/0003Z0003o`0000@01l/60003o`0008/0003[0004o`0000_;
0`000ol0002<0000k0000ol0b`0<b`030?l008h0003]00o;T0000>`04L^?0000k006b`?o2<^?0000
j`0:b`03ol_;00K;SP0003H01?lb00?oC@04ob/01l/4o`S;SP0003H000Go0000o`0d0003o`0004T0
00?o0000;@06b`05ol_;bol02<^>0000=P001Ol0003o03@000?o0000B@05ob/01//01Oo;bl_o00S;
SP0003H000Go0000o`0b00;oC0001Ol0003o02/01//01Oo;bl_o00S;SP0003H01?le0003o`0004X0
0ol/00O;1Ol7bhh0000f0003o`0003<00oml01?;SP0003D00_ne017;S`000>`04L^?0000k@0?bi00
003^00g;T@000>l02l^B0000?0000ol0000[0003o`0005D000?o0000:`000oo;b`05bi@0000m0003
o`0002T000?o0000E`000ol0000Y0003o`0009X0000m0003o`0002T000?o0000E`000ol0000Y0003
o`0009X0000n0003o`0002L000?o0000F@000ol0000W0003o`0009/0000n0003o`0002L000?o0000
F@000ol0000W0003o`0009/0000o0003o`0002D000?o0000F`000ol0000U0003o`0009`0000o0003
o`0002D000?o0000F`000ol0000U0003o`0009`0000o0003o`0002D000?o0000F`000ol0000U0003
o`0009`000100003o`0002<000?o0000G@000ol0000S0003o`0009d000100003o`0002<000?o0000
G@000ol0000S0003o`0009d000110003o`00024000?o0000G`000ol0000Q0003o`0009h000110003
o`00024000?o0000G`000ol0000Q0003o`0009h000120003o`0001l000?o0000H@000ol0000O0003
o`0009l000120003o`0001l000?o0000H@000ol0000O0003o`0009l000130003o`0001d000?o0000
H`000ol0000M0003o`000:0000130003o`0001d000?o0000H`000ol0000M0003o`000:0000140003
o`0001/000?o0000I@000ol0000K0003o`000:4000140003o`0001/000?o0000I@000ol0000K0003
o`000:4000150003o`0001T000?o0000I`000ol0000I0003o`000:8000150003o`0001T000?o0000
I`000ol0000I0003o`000:8000160003o`0001L000?o0000J@000ol0000G0003o`000:<000160003
o`0001L000?o0000J@000ol0000G0003o`000:<000170003o`0001D000?o0000J`000ol0000E0003
o`000:@000170003o`0001D000?o0000J`000ol0000E0003o`000:@000180003o`0001<000?o0000
K@000ol0000C0003o`000:D000180003o`0001<000?o0000K@000ol0000C0003o`000:D000190003
o`00014000?o0000K`000ol0000A0003o`000:H000190003o`00014000?o0000K`000ol0000A0003
o`000:H0001:0003o`0000l000?o0000L@000ol0000?0003o`000:L0001:0003o`0000l000?o0000
L@000ol0000?0003o`000:L0001;0003o`0000d000?o0000L`000ol0000=0003o`000:P0001;0003
o`0000d000?o0000L`000ol0000=0003o`000:P0001<0003o`0000/000?o0000M@000ol0000;0003
o`000:T0001<0003o`0000/000?o0000M@000ol0000;0003o`000:T0001<0003o`0000/000?o0000
M@000ol0000;0003o`000:T0001=0003o`0000T000?o0000M`000ol000090003o`000:X0001=0003
o`0000T000?o0000M`000ol000090003o`000:X0001>0003o`0000L000?o0000N@000ol000070003
o`000:/0001>0003o`3;00K;00<0o`00NP000ol0b`06b`030?l00:`0001>00_;N`0;bjd0001=00g;
N@0=bj`0001<00o;M`0?bj/0001;017;M@0AbjX0001;00K;0ol8bgD04L^Z0000BP0:b`03ol_;00K;
L`0CbjT0000=00Go>007b`Co2</g00Co>007b`;o00?;ool01l/g00CoKP0000d000Co003o>@06b`05
ol_;bol02</f0003o`0003X01l/01?o;bol8bcP000?o0000KP0000d01?li00K;00Gobl_;o`08bcH0
00?o0000>P07b`04ol_;o`S;>@000ol0001]000040000ol0000g00K;00Gobl_;o`08bcH000Go0000
o`0h00O;00Cobl_o2</j0003o`0006`0000=00Co>@07b`Go1l/g00Co>007b`Co2</j0003o`0006`0
001:01?;L`07b`03ol_;00W;=`03ofl0000I00?o;`0AbgD01L/2o`[;;`03ogP0000L00;o;@0AbgD0
4L/]00;oN`0001h00ol[00o;00?o0000L`000oo;b`0=bb/00omm00008@02obX03L/20003o`000740
00?o00003L/Z00;oP00002<00_lY00_;10000ol0001_0003o`0000802l/Y00;oPP0002D00olX00O;
1`000ol0001]0003o`0000D01l/X00?oQ00002P00_le00;o=@000ol0000c00;o=@02ohL0000Z00?o
=0000ol0000b0003o`00038000?o0000<P03ohT0000]00;o<`000ol0000a0003o`00034000?o0000
<@02oh`0000_00;o<P000ol0000`0003o`00030000?o0000<002ohh0000a00?o<0000ol0000_0003
o`0002l000?o0000;P03oi00000d00;o;`02obl000?o0000;@02obl00_nC0000=P02obl000?o0000
;0000ol0000/0003o`0002d00_nE0000>003obd000?o0000:`000ol0000[0003o`0002/00onG0000
>`02ob`000?o0000:P000ol0000Z0003o`0002X00_nJ0000?@03obX000?o0000:@000ol0000Y0003
o`0002P00onL0000@002obT00_lY0003o`0002L00_lY00;oW`0004800_lY0003o`0002H000?o0000
9P000ol0000W00;oX@0004@00olW0003o`0002D000?o00009@000ol0000U00?oX`0004L00_lV0003
o`0002@000?o000090000ol0000T00;oYP0004T00olT0003o`0002<000?o00008`000ol0000R00?o
Z00004`00_lS00;o8`000ol0000Q00;o8`02oj/0001>00;o8`000ol0000P0003o`00020000?o0000
8@02ojd0001@00?o8@000ol0000O0003o`0001l000?o00007`03ojl0001C00;o80000ol0000N0003
o`0001h000?o00007P02ok80001E00?o7P000ol0000M0003o`0001d000?o00007003ok@0001H00;o
7@000ol0000L0003o`0001`000?o00006`02okL0001J00;o7002oa`000?o00006P02oa`00_ni0000
G003oa/000?o00006@000ol0000I0003o`0001T00onk0000G`02oaX000?o000060000ol0000H0003
o`0001P00_nn0000H@03oaP000?o00005`000ol0000G0003o`0001H00oo00000I002oaL000?o0000
5P000ol0000F0003o`0001D00_o30000IP02oaH00_lF0003o`0001@00_lF00;oa@0006P00olE0003
o`0001<000?o00004`000ol0000C00?oa`0006/00_lD0003o`00018000?o00004P000ol0000B00;o
bP0006d00olB0003o`00014000?o00004@000ol0000@00?oc00007000_lA0003o`00010000?o0000
40000ol0000?00;oc`0007800_l@00;o40000ol0000>00;o4002om40001d00?o3`000ol0000=0003
o`0000d000?o00003@03om<0001g00;o3P000ol0000<0003o`0000`000?o00003002omH0001i00;o
3@000ol0000;0003o`0000/000?o00002`02omP0001k00?o2`000ol0000:0003o`0000X000?o0000
2@03omX0001n00;o2P02o`X000?o00002002o`X00_oM0000P003o`T000?o00001`000ol000070003
o`0000L00ooO0000P`02o`P000?o00000`07b`D000?o00001P02on80002500;o1`000ol0000;b`80
00?o00001@02on@0002700?o1@000oo;b`0;b`03o`0000<00ooV0000RP02o`<03l/300;oj@0008`0
0_lAb`;oj`0008h04L_]0000S@07b`Co2<_/0000S@08b`03ol_;00S;k00008d02</00oo;b`08bn`0
002=00S;00?obl/02<_/0000S@07b`Co2<_/0000S@08b`03ol_;00S;k00008d02</3o`S;k00008h0
4L_]0000SP0Abnd0002?00o;kP0009003L__0000T@0;bo000000\
\>"],
  ImageRangeCache->{{{0, 395}, {243.25, 0}} -> {-2.23988, -0.833976, 
  0.0148855, 0.00356818}},
  CellTags->"Mutation - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simple GP mutation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["A set of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
mutChromos = Join @@ Table[
Mutation[theChromos, RespectHead -> False,

         MaxDepth -> 6, SequenceRange -> {1,2},
         ExprPatterns -> patterns,
         SelectionMode -> RANDOM], {10}]

mutChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], 
 
     h[d, g[b, a]]]]], chromo[q[undef], 
 
   p[f[a, g[b, g[c, 3, e]], c, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], 2, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[5, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[4, 4]]], 2]]], 
 
  chromo[q[undef], p[2]], chromo[q[undef], 
 
   p[f[a, g[b, 3], c, h[b, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, a], c, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], g[c, e]]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, 
 
     h[f[h[5, g[a, c, 1], g[c, e, b]], g[c, 5], b, e, h[5, g[b, 2]], 1, 5], 
 
      g[c, g[b, 4]]], 2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], 
 
     h[d, g[b, a]]]]], chromo[q[undef], 
 
   p[f[a, g[b, g[c, 3, e]], c, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], 2, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[5, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[4, 4]]], 2]]], 
 
  chromo[q[undef], p[2]], chromo[q[undef], 
 
   p[f[a, g[b, 3], c, h[b, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, a], c, h[e, g[c, g[b, 4]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], g[c, e]]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, 
 
     h[f[h[5, g[a, c, 1], g[c, e, b]], g[c, 5], b, e, h[5, g[b, 2]], 1, 5], 
 
      g[c, g[b, 4]]], 2]]]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], h[d, g[b, \
a]]]]]
chromo[q[undef], p[f[a, g[b, g[c, 3, e]], c, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], 2, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[5, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[4, 4]]], 2]]]
chromo[q[undef], p[2]]
chromo[q[undef], p[f[a, g[b, 3], c, h[b, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, a], c, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], g[c, e]]]]
chromo[q[undef], p[f[a, g[b, 3], c, 
 
    h[f[h[5, g[a, c, 1], g[c, e, b]], g[c, 5], b, e, h[5, g[b, 2]], 1, 5], 
 
     g[c, g[b, 4]]], 2]]]\
\>", 
"\<\
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], h[d, g[b, \
a]]]]]
chromo[q[undef], p[f[a, g[b, g[c, 3, e]], c, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], 2, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[5, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[4, 4]]], 2]]]
chromo[q[undef], p[2]]
chromo[q[undef], p[f[a, g[b, 3], c, h[b, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, a], c, h[e, g[c, g[b, 4]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], g[c, e]]]]
chromo[q[undef], p[f[a, g[b, 3], c, 
 
    h[f[h[5, g[a, c, 1], g[c, e, b]], g[c, 5], b, e, h[5, g[b, 2]], 1, 5], 
 
     g[c, g[b, 4]]], 2]]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ mutChromos;", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.396848 0.186519 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .14538 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27528 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .21033 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .39685 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .51842 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .50696 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .66661 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .91273 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .78967 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .64832 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .58337 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .70494 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .69348 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .83484 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .76989 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .39685 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.39685 .60332 m
.02381 .45617 L
s
.39685 .60332 m
.21033 .45617 L
s
.39685 .60332 m
.39685 .45617 L
s
.39685 .60332 m
.58337 .45617 L
s
.39685 .60332 m
.76989 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.21033 .45617 m
.14538 .30902 L
s
.21033 .45617 m
.27528 .30902 L
s
1 g
.05 w
.14538 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .14538 .30902 0 0 Mshowa
P
1 g
.27528 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27528 .30902 0 0 Mshowa
P
.9 g
.21033 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .21033 .45617 0 0 Mshowa
P
1 g
.39685 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .39685 .45617 0 0 Mshowa
P
.004 w
.58337 .45617 m
.51842 .30902 L
s
.58337 .45617 m
.64832 .30902 L
s
1 g
.05 w
.51842 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .51842 .30902 0 0 Mshowa
P
.004 w
.64832 .30902 m
.50696 .16187 L
s
.64832 .30902 m
.78967 .16187 L
s
1 g
.05 w
.50696 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .50696 .16187 0 0 Mshowa
P
.004 w
.78967 .16187 m
.66661 .01472 L
s
.78967 .16187 m
.91273 .01472 L
s
1 g
.05 w
.66661 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .66661 .01472 0 0 Mshowa
P
1 g
.91273 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .91273 .01472 0 0 Mshowa
P
.9 g
.78967 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .78967 .16187 0 0 Mshowa
P
.9 g
.64832 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .64832 .30902 0 0 Mshowa
P
.9 g
.58337 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .58337 .45617 0 0 Mshowa
P
.004 w
.76989 .45617 m
.70494 .30902 L
s
.76989 .45617 m
.83484 .30902 L
s
1 g
.05 w
.70494 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .70494 .30902 0 0 Mshowa
P
.004 w
.83484 .30902 m
.69348 .16187 L
s
.83484 .30902 m
.97619 .16187 L
s
1 g
.05 w
.69348 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .69348 .16187 0 0 Mshowa
P
1 g
.97619 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .16187 0 0 Mshowa
P
.9 g
.83484 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .83484 .30902 0 0 Mshowa
P
.9 g
.76989 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .76989 .45617 0 0 Mshowa
P
.9 g
.39685 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .39685 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?h01?mJ00?o9P000?h000Go0000o`1J0003o`0002D0003n0005
o`000?l0E`05obH0003n0005o`000?l0F0000ol0o`0W0000oP04oeT000?o0?l09`000?h000?o0000
F`02obL0003m00;oQP000?l0QP000?l0QP000?l0QP000?l01`000ol0001=0003o`0002`0003o00P0
00?o0000B`000ol0000]0000o`090003o`0004T000?o0000;P000?l02P000ol000170003o`0002l0
003o00/000?o0000A@000ol0000`0000o`0;0003o`0004D000?o0000<0000?l030000ol000130003
o`000340003o00d000?o0000@@000ol0000b0000o`0>0003o`0003l000?o0000<`000?l03`000ol0
000m0003o`0003@0003o010000?o0000>`000ol0000e0000o`0@0003o`0003/000?o0000=@000?l0
4@000ol0000i0003o`0003H0003o018000?o0000=`000ol0000g0000o`0C0003o`0003D000?o0000
>0000?l050000ol0000c0003o`0003T0003o01D000?o0000<@000ol0000j0000o`0E0003o`000340
00?o0000>P000?l05P000ol0000_0003o`0003/0003o01L000?o0000;@000ol0000l0000o`0H0003
o`0002/000?o0000?@000?l06@000ol0000Y0003o`0003h0003o01X000?o00009`000ol0000o0000
o`0K0003o`0002D000?o0000@0000?l06`000ol0000U0003o`000400003o01`000?o00008`000ol0
00110000o`0M0003o`00024000?o0000@P000?l07P000ol0000O0003o`0004<0003o01l000?o0000
7@000ol000140000o`0P0003o`0001/000?o0000A@000?l080000ol0000K0003o`0004D0003o0240
00?o00006@000ol000160000o`0R0003o`0001L000?o0000A`000?l08`000ol0000E0003o`0004P0
003o02@000?o00004`000ol000190000o`0U0003o`00014000?o0000BP000?l09@000ol0000A0003
o`0004X0003o02H000?o00003`000ol0001;0000o`0W0003o`0000d000?o0000C0000?l0:0001?l0
0006b`@000?o0000C@000?l0:@000oo;b`08b`030?l004l0003o02T03<]A0000o`0X00k;D0000?l0
9`06b`?o1l]?0000o`0W00W;00?obl/01<]?0000`P04od801?lI00O;1?l7bcX01Ol?0000`@000ol0
00140005o`000?l06006b`05ol_;bol01l/j0004o`00oa0000310003o`0004@000Go0000o`0H00K;
00Gobl_;o`07bcX01?l@0000`@001Ol0003o048000Go0000o`0H00K;00Gobl_;o`07bcd000?o0000
3P000<801?m200Co6@07b`Go1//j00Co40000?l02@000ol0000J01;;CP000?l02002oad04<]?0000
o`0W013;C`000?l0:00>be00003:0003o`0004<000?o00005@0<be40003;0003o`0004<000?o0000
4`000ol0b`09bcX000?o00005@000<`000?o0000@`000ol0000A0003o`0000801//k0003o`0001H0
003=0003o`0004<000?o00003`000ol000130003o`0001L0003>0003o`0004<000?o00003@000ol0
00130003o`0001P0003?0003o`0004<000?o00002`000ol000130003o`0001T0003@0003o`0004<0
00?o00002@000ol000130003o`0001X0003A0003o`0004<000?o00001`000ol000130003o`0001/0
003B0003o`0004<000?o00001@000ol000130003o`0001`0003C0003o`0004<000?o00000`000ol0
00130003o`0001d0003D0003o`0004<000Go0000o`150003o`0001h0003E0003o`0004<000?o0?l0
A@000ol0000O0000eP000ol000130003o`0004<000?o000080000=L000?o0000@@000ol0o`130003
o`000240003H0003o`0003l000Go0000o`110003o`000280003I0003o`0003d000?o00000`000ol0
000m0003o`0002<0003J0003o`0003/000?o00001@000ol0000k0003o`0002@0003K0003o`0003T0
00?o00001`000ol0000i0003o`0002D0003L0003o`0003L000?o00002@000ol0000g0003o`0002H0
003M0003o`0003D000?o00002`000ol0000e0003o`0002L0003N0003o`0003<000?o00003@000ol0
000c0003o`0002P0003O0003o`00034000?o00003`000ol0000a0003o`0002T0003O0003o`000340
00?o00003`000ol0000a0003o`0002T0003P0003o`0002l000?o00004@000ol0000_0003o`0002X0
003Q0003o`0002d000?o00004`000ol0000]0003o`0002/0003R0003o`0002/000?o00005@000ol0
000[0003o`0002`0003S0003o`0002T000?o00005`000ol0000Y0003o`0002d0003T0003o`0002L0
00?o00006@000ol0000W0003o`0002h0003U0003o`0002D000?o00006`000ol0000U0003o`0002l0
003V0003o`0002<000?o00007@000ol0000S0003o`000300003W0003o`00024000?o00007`000ol0
000Q0003o`000340003X0003o`0001l000?o00008@000ol0000O0003o`000380003Y0003o`0001d0
00?o00008`000ol0000M0003o`0003<0003Z0003o`0001/000?o00009@000ol0000K0003o`0003@0
003[0003o`0001T000?o00009`000ol0000I0003o`0003D0003/0003o`0001L000?o0000:@000ol0
000G0003o`0003H0003]0003o`0001D000?o0000:`000ol0000E0003o`0003L0003^0003o`0001<0
00?o0000;@000ol0000C0003o`0003P0003_0003o`00014000?o0000;`000ol0000A0003o`0003T0
003`0003o`0000l000?o0000<@000ol0000?0003o`0003X0003a0003o`0000801//50003o`0003<0
00?o00000P06b`D000?o0000>`000?8000?o0</02L/20003o`0003D000?o0</02L/20003o`0003`0
003c00c;00?o0000=`0<b`03o`0003d0003b00k;>00>bcl0003a00K;0ol7bcH01//3o`O;?P000?40
2L/00oo;b`04bcH02L/00oo;b`04bch0000k00Co;003oeP01?lV00O;1?l7b`X01OlU00O;1?l7bcd0
000k0005o`000?l0;P000ol0001D0003o`0002P01//01Oo;bl_o00O;2@001Ol0003o02H01//01Oo;
bl_o00O;?@0003/000Go0000o`0^0003o`0005@01OlV00K;00Gobl_;o`07b`T000Go0000o`0V00K;
00Gobl_;o`07bcd0000k0005o`000?l0;002oeL000Go0000o`0V00K;00Gobl_;o`07b`T000Go0000
o`0V00K;00Gobl_;o`07bcd0000k00Co;`000ol0001E00?o9`07b`Go1//:00Co9P07b`Go1//m0000
>`000ol0000]00?oPP0Bb`d000?o0000900Bbcd0000j00;o]@0@b`d00_lW013;?P000?404</f013;
?P000?803//h00k;?`000?<03</j00c;@0000?@02//l00[;@@00044000?o00009@000ol0001P0003
o`0002H000?obl/01</F0003o`0002H000?obl/01<]30000@@000ol0000U0003o`00060000?o0000
9P000ol0000J0003o`0002H000?o0000A`00048000?o00008`000ol0001R0003o`0002@000?o0000
70000ol0000T0003o`0004P000120003o`0002<000?o0000HP000ol0000T0003o`0001`000?o0000
90000ol000180000@P000ol0000S0003o`0006<000?o00008`000ol0000M0003o`0002<000?o0000
B00004<000?o00008@000ol0001T0003o`00028000?o00007P000ol0000R0003o`0004T000130003
o`00024000?o0000I@000ol0000Q0003o`0001l000?o00008@000ol000190000A0000ol0000O0003
o`0006H000?o000080000ol0000P0003o`00020000?o0000BP0004@000?o00007`000ol0001W0003
o`0001l000?o00008@000ol0000O0003o`0004X000150003o`0001d000?o0000J0000ol0000N0003
o`00028000?o00007P000ol0001;0000A@000ol0000M0003o`0006P000?o00007P000ol0000R0003
o`0001h000?o0000B`0004H000?o00006`000ol0001Z0003o`0001`000?o000090000ol0000L0003
o`0004`000160003o`0001/000?o0000JP000ol0000L0003o`0002@000?o000070000ol0001<0000
AP000ol0000K0003o`0006/000?o00006`000ol0000U0003o`0001/000?o0000C00004L000?o0000
6@000ol0001/0003o`0001X000?o00009P000ol0000J0003o`0004d000170003o`0001T000?o0000
K@000ol0000I0003o`0002L000?o00006@000ol0001=0000B0000ol0000G0003o`0006h000?o0000
60000ol0000X0003o`0001P000?o0000CP0004P000?o00005`000ol0001_0003o`0001L000?o0000
:@000ol0000G0003o`0004h000190003o`0001D000?o0000L0000ol0000F0003o`0002X000?o0000
5P000ol0001?0000B@000ol0000E0003o`00074000?o00005@000ol0000[0003o`0001D000?o0000
C`0004T000?o00005@000ol0001a0003o`0001D000?o0000:`000ol0000E0003o`0004l0001:0003
o`0001<000?o0000LP000ol0000D0003o`0002`000?o000050000ol0001@0000BP000ol0000C0003
o`0007<000?o00004`000ol0000]0003o`0001<000?o0000D00004/000?o00004@000ol0001d0003
o`00018000?o0000;P000ol0000B0003o`000540001;0003o`00014000?o0000M@000ol0000A0003
o`0002l000?o00004@000ol0001A0000C0000ol0000?0003o`0007H000?o000040000ol0000`0003
o`00010000?o0000DP0004`000?o00003`000ol0001g0003o`0000l000?o0000<@000ol0000?0003
o`000580001<0003o`0000l000?o0000M`000ol0000?0003o`00034000?o00003`000ol0001B0000
C@000ol0000=0003o`0007T000?o00003@000ol0000c0003o`0000d000?o0000D`0004d000?o0000
3@000ol0001i0003o`0000d000?o0000<`000ol0000=0003o`0005<0001>0003o`0000/000?o0000
N`000ol0000;0003o`0003D000?o00002`000ol0001D0000CP000ol0000;0003o`0007/000?o0000
2`000ol0000e0003o`0000/000?o0000E00004l000?o00002@000ol0001l0003o`0000X000?o0000
=P000ol0000:0003o`0005D0001?0003o`0000T000?o0000O@000ol000090003o`0003L000?o0000
2@000ol0001E0000D0000ol000070003o`0007h000?o000020000ol0000h0003o`0000P000?o0000
EP00050000?o00001`000ol0001o0003o`0000L000?o0000>@000ol000070003o`0005H0001@0003
o`0000L000?o0000O`000ol000070003o`0003T000?o00001`000ol0001F0000D@000ol000050003
o`00084000?o00001@000ol0000k0003o`0000D000?o0000E`00054000?obl/01</00`3o00220003
ol_;00C;00<0o`00?0000oo;b`04b`030?l005P0001@00[;PP0:bc`02/]I0000C`0<bh003</j00c;
F00004h03/]n00k;>00>beL0001=00K;0ol7bg`04</f013;EP0004d02L/00oo;b`04bg`04</f013;
EP0000`01Olk00O;1?l7bc/01?lk00O;0_l00l_oo`06bc@01l/2o`03booo00K;E@0000`000Co003o
?006b`05ol_;bol01l/j0003o`0003d01l/01?o;bol7bc@01l/01?o;bol7beD0000<00Co?006b`05
ol_;bol01l/j0003o`0003d01l/01?o;bol7bc@01l/01?o;bol7beD0000?0003o`0003X01//01Oo;
bl_o00O;>P001Ol0003o03/01l/01?o;bol7bc@01l/01?o;bol7beD0000<00Co?007b`Go1//k00Co
>`07b`Co1l/d00O;1?l7beD0000H0003o`0003404/]j00O;00?obl/02</d00O;00?obl/02<]E0000
6@02oc804<]l00G;0_l9bc<00_l00`3;b`03b`;o2L]F00006`03obl04<]l013;<003o`<04<]F0000
7P03obd03//00`3o001j0003ol_;00c;;P03o`L03/]G00008@02ob`03</300;oM`02o`803</]00;o
2`0<beP0000S00?o:P0:b`H000?o0000L`000ol0000300[;:`03o`h02/]I00009P02obX01//90003
o`00074000?o00001P06bb/00_lC00K;F`0002P00olg0003o`0003H000?o0000=P000ol0000e00?o
MP0002/00_lf00;o=P000ol0000d00;o=P02ogT0000]00?o=@000ol0000c0003o`0003<000?o0000
<`03og/0000`00;o=0000ol0000b0003o`00038000?o0000<P02ogh0000b00?o<P000ol0000a0003
o`00034000?o0000<003oh00000e00;o<@02oc4000?o0000;`02oc400_n30000=`03oc0000?o0000
;P000ol0000^0003o`0002h00on50000>P03obh000?o0000;@000ol0000]0003o`0002`00on80000
?@02obd00_l]0003o`0002/00_l]00;oR`0003l00ol/0003o`0002X000?o0000:P000ol0000Z00?o
S@0004800_l[0003o`0002T000?o0000:@000ol0000Y00;oT00004@00olY0003o`0002P000?o0000
:0000ol0000W00?oTP0004L00_lX00;o:0000ol0000V00;o:002oiD0001900?o9`000ol0000U0003
o`0002D000?o00009@03oiL0001<00;o9P000ol0000T0003o`0002@000?o00009002oiX0001>00?o
90000ol0000S0003o`0002<000?o00008P03oi`0001A00;o8`02ob<000?o00008@02ob<00_nO0000
D`03ob8000?o000080000ol0000P0003o`0002000onQ0000EP03ob0000?o00007`000ol0000O0003
o`0001h00onT0000F@02oal00_lO0003o`0001d00_lO00;oY`0005/00olN0003o`0001`000?o0000
70000ol0000L00?oZ@0005h00_lM0003o`0001/000?o00006`000ol0000K00;o[00006000olK0003
o`0001X000?o00006P000ol0000I00?o[P0006<00_lJ00;o6P000ol0000H00;o6P02ok40001U00?o
6@000ol0000G0003o`0001L000?o00005`03ok<0001X00;o60000ol0000F0003o`0001H000?o0000
5P02okH0001Z00?o5P000ol0000E0003o`0001D000?o00005003okP0001]00;o5@02oaD000?o0000
4`02oaD00_nk0000K`03oa@000?o00004P000ol0000B0003o`0001800onm0000LP03oa8000?o0000
4@000ol0000A0003o`0001000oo00000M@02oa400_lA0003o`0000l00_lA00;o``0007L00ol@0003
o`0000h000?o00003P000ol0000>00?oa@0007X00_l?0003o`0000d000?o00003@000ol0000=00;o
b00007`00ol=0003o`0000`000?o000030000ol0000;00?obP0007l00_l<00;o30000ol0000:00;o
3002old0002100?o2`000ol000090003o`0000T000?o00002@03oll0002400;o2P000ol000080003
o`0000P000?o00002002om80002600?o20000ol000070003o`0000L000?o00001P03om@0002900;o
1`02o`@01//500;o1`02omL0002;00?o1P000ol0b`09b`8000?o00001003omT0002>00?o100<b`03
o`0000800ooL0000T@02o`030<_;00c;0P02oml0002C013;00?o0000g`0009<01//4o`K;hP000980
2</00oo;b`07bn40002B00S;00?obl/01l_Q0000TP08b`03ol_;00O;h@0009801l/4o`O;h@000980
2</00oo;b`07bn40002B00S;0ol7bn40002C013;hP0009<04<_R0000U00>bn<0002E00c;i00009H0
2/_U0000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.22613, -0.833976, 0.0143256, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 1"]
}, Open  ]],

Cell[TextData[{
  "Mutant 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .14178 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .44468 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
.004 w
.29323 .30902 m
.14178 .16187 L
s
.29323 .30902 m
.29323 .16187 L
s
.29323 .30902 m
.44468 .16187 L
s
1 g
.05 w
.14178 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .14178 .16187 0 0 Mshowa
P
1 g
.29323 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .16187 0 0 Mshowa
P
1 g
.44468 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .44468 .16187 0 0 Mshowa
P
.9 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004of400ol>0000o`0@0005o`000?l0H@000ol0000=0000
o`0@0005o`000?l0GP05o`h0003o010000Go0000o`1O0003o`3o00l0003o01001?mP0003o`3o00l0
003o010000?o0000HP02o`l0003o00l00_me0000o`260000o`260000o`0H0003o`0006/0003o01T0
00?o0000DP000ol0000E0000o`0J0003o`00050000?o00005P000?l06P000ol0001?0003o`0001L0
003o01/000?o0000C@000ol0000H0000o`0L0003o`0004`000?o000060000?l07@000ol0001:0003
o`0001T0003o01h000?o0000B0000ol0000J0000o`0O0003o`0004H000?o00006`000?l080000ol0
00140003o`0001`0003o024000?o0000@P000ol0000M0000o`0R0003o`00040000?o00007P000?l0
8P000ol0000o0003o`0001l0003o02<000?o0000?@000ol0000P0000o`0T0003o`0003/000?o0000
8@000?l09@000ol0000i0003o`000280003o02H000?o0000>0000ol0000R0000o`0W0003o`0003H0
00?o00008`000?l0:0000ol0000d0003o`0002@0003o02T000?o0000<P000ol0000U0000o`0Z0003
o`00030000?o00009P000?l0:`000ol0000^0003o`0002L0003o02/000?o0000;@000ol0000X0000
o`0/0003o`0002/000?o0000:@000?l0;@000ol0000Y0003o`0002X0003o02h000?o00009`000ol0
000[0000o`0_0003o`0002D000?o0000;0000?l0<0000ol0000T0003o`0002`0003o034000?o0000
8P000ol0000]0000o`0b0003o`00020000?o0000;P000?l0<`000ol0000N0003o`0002l0003o03<0
00?o00007@000ol0000`0000o`0d0003o`0001/000?o0000<@000?l0=@000ol0000I0003o`000380
003o03H000?o00005`000ol0000c0000o`0g0003o`0001D000?o0000=0000?l0>0000ol0000C0003
o`0003D0003o03T000?o00004@000ol0000f0000o`0j0003o`00010000?o0000=P000?l0>`000ol0
000>0003o`0003L0003o03/000?o00000`06b`@000?o0000>0000?l0?0000ol0000:b`030?l003X0
003o03d000?obl/02//l0000o`0m00k;>`000?l0?005b`?o2</j0000o`0l00S;00?obl/01L/j0000
>@04ocD00olf00Co8004ofL01//4o`S;>@0003P000?o0000>P000ol0000b0003o`00024000?o0000
J@05b`05ol_;bol02</i0000>0000ol0000j0003o`0003801OlO0003o`0006T01L/01Oo;bl_o00S;
>@0003P000Go0000o`0f00;o=@001Ol0003o01l000Go0000o`1W00G;00Gobl_;o`08bcT0000i00Co
>0000ol0000c00?o8@04ofL01//5o`O;>@0007800oo501;;>@000?l0?00@bcX0003o03`04</j0000
f0000ol0001P0003ol_;00c;>`0004<000?o0000G`000ol0000a0003o`0005h000?o00003</l0000
A0000ol0001M0003o`0003<000?o0000G0000ol0000200[;?@0004D000?o0000F`000ol0000e0003
o`0005X000?o00001@06bcl000160003o`0002/000?o0000:`000ol0000g0003o`0005P000?o0000
B`0004L000?o0000:P000ol0000Z0003o`0003T000?o0000EP000ol0001<0000B0000ol0000Y0003
o`0002T000?o0000>`000ol0001D0003o`0004d000190003o`0002P000?o0000:0000ol0000m0003
o`00058000?o0000CP0004X000?o00009`000ol0000W0003o`0003l000?o0000D0000ol0001?0000
B`000ol0000V0003o`0002H000?o0000@@000ol0001>0003o`000500001<0003o`0002D000?o0000
9@000ol000130003o`0004`000?o0000D@0004d000?o000090000ol0000T0003o`0004D000?o0000
BP000ol0001B0000CP000ol0000S0003o`0002<000?o0000A`000ol000180003o`0005<0001?0003
o`00028000?o00008P000ol000190003o`0004H000?o0000E000050000?o00008@000ol0000Q0003
o`0004/000?o0000A0000ol0001E0000D@000ol0000P0003o`00020000?o0000C@000ol000120003
o`0005H0001B0003o`0001l000?o00007`000ol0001?0003o`00040000?o0000E`0005<000?o0000
7P000ol0000N0003o`00054000?o0000?P000ol0001H0000E0000ol0000M0003o`0001d000?o0000
D`000ol0000l0003o`0005T0001E0003o`0001`000?o000070000ol0001E0003o`0003X000?o0000
FP0005H000?o00006`000ol0000K0003o`0005L000?o0000>0000ol0001K0000E`02oa/000?o0000
6@02oe/00_lg0003o`0005`0001I0003o`0001P000?o000060000ol0001M0003o`0003<000?o0000
G@0005X000?o00005`000ol0000G0003o`0005l000?o0000<@000ol0001N0000F`000ol0000F0003
o`0001H000?o0000H@000ol0000_0003o`0005l0001L0003o`0001D000?o00005@000ol0001S0003
o`0002d000?o0000H00005d000?o000050000ol0000D0003o`0006D000?o0000:`000ol0001Q0000
GP000ol0000C0003o`0001<000?o0000I`000ol0000Y0003o`000680001O0003o`00018000?o0000
4P000ol0001Y0003o`0002L000?o0000H`00060000?o00004@000ol0000A0003o`0006/000?o0000
9@000ol0001T0000H@000ol0000@0003o`00010000?o0000K@000ol0000S0003o`0006D0001R0003
o`0000l000?o00003`000ol0001_0003o`00024000?o0000IP0006<000?o00003P000ol0000>0003
o`00074000?o00007`000ol0001W0000I0000ol0000=0003o`0000d000?o0000L`000ol0000M0003
o`0006P0001U0003o`0000`000?o000030000ol0001e0003o`0001/000?o0000J@0006H000?o0000
2`000ol0000;0003o`0007L000?o00006@000ol0001Z0000I`000ol0000:0003o`0000X000?o0000
N@000ol0000G0003o`0006/0001X0003o`0000T000?o00002@000ol0001k0003o`0001D000?o0000
K00006T000?o000020000ol000080003o`0007d000?o00004`000ol0001]0000JP000ol000070003
o`0000L000?o0000O`000ol0000A0003o`0006h0001[0003o`0000H000?o00001P000ol000210003
o`0000l000?o0000K`0006`000?o00000P06b`D000?o0000P`000ol0000200K;1@000ol0001`0000
K@000ol0b`09b`8000?o0000Q@000ol0b`09b`8000?o0000L@0006h03</00ol0002700c;00?o0000
LP0006d03/^800k;M00006`01//3o`O;QP06b`?o1l]c0000K009b`03ol_;00C;QP09b`03ol_;00C;
L`0003h01?lY00O;1?l7beL01?lY00O;1?l7bg80000n0005o`000?l0:006b`05ol_;bol01l]F0003
o`0002/01//01Oo;bl_o00O;LP0003h000Go0000o`0X00K;00Gobl_;o`07beH01OlY00K;00Gobl_;
o`07bg80000n0005o`000?l0:006b`05ol_;bol01l]F0005o`000?l0:@06b`05ol_;bol01l]b0000
?P04obT01l/5o`K;E`03obX01l/5o`K;LP0003h000?o0000:P0Bbh@04/]b0000?@02obd04<^6013;
L`0006`04<^6013;L`0006d03/^800k;M00006h03<^:00c;M@0006l02/^<00[;MP0004@000?o0000
:@000oo;b`04bf<000?o0000:@000oo;b`04bgP000140003o`0002T000?o0000I`000ol0000Y0003
o`0007`000150003o`0002L000?o0000J@000ol0000W0003o`0007d000150003o`0002L000?o0000
J@000ol0000W0003o`0007d000160003o`0002D000?o0000J`000ol0000U0003o`0007h000160003
o`0002D000?o0000J`000ol0000U0003o`0007h000170003o`0002<000?o0000K@000ol0000S0003
o`0007l000170003o`0002<000?o0000K@000ol0000S0003o`0007l000180003o`00024000?o0000
K`000ol0000Q0003o`00080000180003o`00024000?o0000K`000ol0000Q0003o`00080000190003
o`0001l000?o0000L@000ol0000O0003o`00084000190003o`0001l000?o0000L@000ol0000O0003
o`000840001:0003o`0001d000?o0000L`000ol0000M0003o`000880001:0003o`0001d000?o0000
L`000ol0000M0003o`000880001;0003o`0001/000?o0000M@000ol0000K0003o`0008<0001;0003
o`0001/000?o0000M@000ol0000K0003o`0008<0001<0003o`0001T000?o0000M`000ol0000I0003
o`0008@0001<0003o`0001T000?o0000M`000ol0000I0003o`0008@0001=0003o`0001L000?o0000
N@000ol0000G0003o`0008D0001=0003o`0001L000?o0000N@000ol0000G0003o`0008D0001=0003
o`0001L000?o0000N@000ol0000G0003o`0008D0001>0003o`0001D000?o0000N`000ol0000E0003
o`0008H0001>0003o`0001D000?o0000N`000ol0000E0003o`0008H0001?0003o`0001<000?o0000
O@000ol0000C0003o`0008L0001?0003o`0001<000?o0000O@000ol0000C0003o`0008L0001@0003
o`00014000?o0000O`000ol0000A0003o`0008P0001@0003o`00014000?o0000O`000ol0000A0003
o`0008P0001A0003o`0000l000?o0000P@000ol0000?0003o`0008T0001A0003o`0000l000?o0000
P@000ol0000?0003o`0008T0001B0003o`0000d000?o0000P`000ol0000=0003o`0008X0001B0003
o`0000d000?o0000P`000ol0000=0003o`0008X0001C0003o`0000/000?o0000Q@000ol0000;0003
o`0008/0001C0003o`0000/000?o0000Q@000ol0000;0003o`0008/0001D0003o`0000T000?o0000
Q`000ol000090003o`0008`0001D0003o`0000T000?o0000Q`000ol000090003o`0008`0001E0003
o`0000L000?o0000R@000ol000070003o`0008d0001E0003o`0000L000?o0000R@000ol000070003
o`0008d0001F0003o`0000D000?o0000R`000ol000050003o`0008h0001F0003ol_;00C;00<0o`00
S0000oo;b`04b`030?l008l0001E00[;S00:bi00001D00c;RP0<bhl0001C00k;R00>bhh0001B00K;
0ol7bhH04<^=0000DP09b`03ol_;00C;QP0@bhd0000<00Go@007b`Co1l]000Co@007b`;o00?;ool0
1//o00CoB@0000`000Co003o@@06b`05ol_;bol01l/o0003o`0004801l/01?o;bol7bd0000?o0000
B@0000`01?m100K;00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;@@000ol0001800003`000ol0
000o00K;00Gobl_;o`07bcl000Go0000o`1000O;00Cobl_o1l]20003o`0004L0000<00Co@@07b`Go
1/]000Co@007b`Co1l]20003o`0004L0000H00;o=`0Bbh@01l/00oo;b`08bcP000?o00001003odX0
000J00;o=P0@bhH01L/2o`W;=P03oe@0000L00?o<`0@b`03o`0008<04</c00?oE`0001l00ola00k;
0P000ol000210003o`3;00g;<@03oeX0000R00;o<00<b`@000?o0000O`001?l0000<bc000_mM0000
9003obh02//600;oO@02o`D02//^00?oG`0002L00ol]00K;2P000ol0001i0003o`0000L01//]00?o
HP0002X00olk0003o`0003X000?o0000>P000ol0000i00;oI@0002d00_lj00;o>P000ol0000h00;o
>@03ofL0000_00?o>@000ol0000g0003o`0003L000?o0000=P03ofX0000b00?o=`000ol0000f0003
o`0003H000?o0000=003ofd0000e00?o=@02ocH000?o0000=002ocD00_m`0000>002ocD000?o0000
<`000ol0000c0003o`0003800omb0000>P03oc<00_lc0003o`0003400_lb00?oM@0003d00olb0003
o`00030000?o0000<0000ol0000`00;oN00004000_la0003o`0002l000?o0000;`000ol0000^00?o
NP0004800ol_00;o;`000ol0000]00;o;P03ogd0001500?o;P000ol0000/0003o`0002`000?o0000
:`03oh00001800?o;0000ol0000[0003o`0002/000?o0000:P02oh<0001;00;o:`02ob/000?o0000
:@02obX00on50000C@03obX000?o0000:0000ol0000X0003o`0002L00on80000D003obP000?o0000
9`000ol0000W0003o`0002H00_n;0000D`03obH00_lW0003o`0002D00_lV00?oS@0005H00_lV0003
o`0002@000?o000090000ol0000S00?oT00005P00olT00;o90000ol0000R00;o8`03oi<0001K00?o
8`000ol0000Q0003o`00024000?o00008@02oiH0001N00;o8P000ol0000P0003o`00020000?o0000
7`03oiP0001P00?o8002ob0000?o00007P02oal00onK0000H`03oal000?o00007@000ol0000M0003
o`0001d00_nN0000IP03oad000?o000070000ol0000L0003o`0001/00onP0000J@02oa`00_lL0003
o`0001X00_lK00?oX`0006/00olK0003o`0001T000?o00006@000ol0000I00;oYP0006h00olI0003
o`0001P000?o000060000ol0000G00?oZ00007400olG00;o60000ol0000F00;o5`03oj/0001d00;o
5`000ol0000E0003o`0001D000?o00005003ojh0001f00?o5@02oaD000?o00004`02oaD00_na0000
N@03oa@000?o00004P000ol0000B0003o`0001800onc0000O002oa<000?o00004@000ol0000A0003
o`0001000onf0000OP03oa400_lA0003o`0000l00_lA00;o^@0008400ol@0003o`0000h000?o0000
3P000ol0000>00?o^`0008@00ol>0003o`0000d000?o00003@000ol0000<00?o_P0008L00_l=00;o
3@000ol0000;00;o3003ol40002900?o30000ol0000:0003o`0000X000?o00002P02ol@0002<00?o
2P000ol000090003o`0000T000?o00002003olH0002?00?o2002o`T000?o00001`02o`P00oo90000
TP02o`P000?o00000`06b`H000?o00001P02ol`0002D00?o1P02o`030<_;00S;0P02o`H00oo>0000
U`03o`D03</00ol0000300?od@0009X00_l200k;0P03om@0002L0003ol_;00k;00?o0000e@0009d0
1//4o`K;f00009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000W008b`03ol_;00O;e`0009`0
1l/4o`O;e`0009`02</00oo;b`07bmL0002L00S;0ol7bmL0002M013;f00009d04<_H0000WP0>bmT0
002O00c;fP000:002/_K0000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 2"],

Cell[TextData[{
  "Mutant 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004of400ol>0000o`0@0005o`000?l0H@000ol0000=0000
o`0@0005o`000?l0GP05o`h0003o010000Go0000o`1O0003o`3o00l0003o01001?mP0003o`3o00l0
003o010000?o0000HP02o`l0003o00l00_me0000o`260000o`260000o`0H0003o`0006/0003o01T0
00?o0000DP000ol0000E0000o`0J0003o`00050000?o00005P000?l06P000ol0001?0003o`0001L0
003o01/000?o0000C@000ol0000H0000o`0L0003o`0004`000?o000060000?l07@000ol0001:0003
o`0001T0003o01h000?o0000B0000ol0000J0000o`0O0003o`0004H000?o00006`000?l080000ol0
00140003o`0001`0003o024000?o0000@P000ol0000M0000o`0R0003o`00040000?o00007P000?l0
8P000ol0000o0003o`0001l0003o02<000?o0000?@000ol0000P0000o`0T0003o`0003/000?o0000
8@000?l09@000ol0000i0003o`000280003o02H000?o0000>0000ol0000R0000o`0W0003o`0003H0
00?o00008`000?l0:0000ol0000d0003o`0002@0003o02T000?o0000<P000ol0000U0000o`0Z0003
o`00030000?o00009P000?l0:`000ol0000^0003o`0002L0003o02/000?o0000;@000ol0000X0000
o`0/0003o`0002/000?o0000:@000?l0;@000ol0000Y0003o`0002X0003o02h000?o00009`000ol0
000[0000o`0_0003o`0002D000?o0000;0000?l0<0000ol0000T0003o`0002`0003o034000?o0000
8P000ol0000]0000o`0b0003o`00020000?o0000;P000?l0<`000ol0000N0003o`0002l0003o03<0
00?o00007@000ol0000`0000o`0d0003o`0001/000?o0000<@000?l0=@000ol0000I0003o`000380
003o03H000?o00005`000ol0000c0000o`0g0003o`0001D000?o0000=0000?l0>0000ol0000C0003
o`0003D0003o03T000?o00004@000ol0000f0000o`0j0003o`00010000?o0000=P000?l0>`000ol0
000>0003o`0003L0003o03/000?o00000`06b`@000?o0000>0000?l0?0000ol0000:b`030?l003X0
003o03d000?obl/02//l0000o`0m00k;>`000?l0?005b`?o2</j0000o`0l00S;00?obl/01L/j0000
c`04ofL01//4o`S;>@000<h000?o0000J@05b`05ol_;bol02</i0000cP000ol0001Y00G;00Gobl_;
o`08bcT0003>0005o`000?l0I`05b`05ol_;bol02</i0000c`04ofL01//5o`O;>@000?l0>`0BbcT0
003o03`04</j0000o`0l013;>P000=P000?o0000H0000oo;b`0<bc/0003I0003o`0005h000?o0000
3</l0000fP000ol0001L0003o`0000802//m0000f`000ol0001J0003o`0000D01//o0000g0000ol0
001H0003o`0004/0003M0003o`0005H000?o0000C0000=h000?o0000E0000ol0001=0000g`000ol0
001B0003o`0004h0003P0003o`00050000?o0000C`000>4000?o0000CP000ol0001@0000hP000ol0
001<0003o`000540003S0003o`0004X000?o0000DP000>@000?o0000B0000ol0001C0000i@000ol0
00160003o`0005@0003V0003o`0004@000?o0000E@000>L000?o0000@P000ol0001F0000j0000ol0
00100003o`0005L0003Y0003o`0003h000?o0000F0000>X000?o0000?0000ol0001I0000j`000ol0
000j0003o`0005X0003/0003o`0003P000?o0000F`000>d00_lg0003o`0005`0003_0003o`0003<0
00?o0000G@000?0000?o0000<@000ol0001N0000l@000ol0000_0003o`0005l0003b0003o`0002d0
00?o0000H0000?<000?o0000:`000ol0001Q0000m0000ol0000Y0003o`000680003e0003o`0002L0
00?o0000H`000?H000?o00009@000ol0001T0000m`000ol0000S0003o`0006D0003h0003o`000240
00?o0000IP000?T000?o00007`000ol0001W0000nP000ol0000M0003o`0006P0003k0003o`0001/0
00?o0000J@000?`000?o00006@000ol0001Z0000o@000ol0000G0003o`0006/0003n0003o`0001D0
00?o0000K0000?l000?o00004`000ol0001]0000o`010003o`00014000?o0000KP000?l00P000ol0
000?0003o`0006l0003o00<000?o00000P06b`D000?o0000L0000?l010000ol0b`09b`8000?o0000
L@000?l01@0<b`03o`000780003o00@03/]d0000o`0300K;0ol7bg<0003o00<02L/00oo;b`04bg<0
000n00Co<003oel01?lY00O;1?l7bg80000n0005o`000?l0<P000ol0001K0003o`0002/01//01Oo;
bl_o00O;LP0003h000Go0000o`0b0003o`0005/01OlY00K;00Gobl_;o`07bg80000n0005o`000?l0
<002oeh000Go0000o`0Y00K;00Gobl_;o`07bg80000n00Co<`000ol0001L00?o:P07b`Go1/]b0000
?P000ol0000a00?oS00Bbg80000m00;o``0@bg<0003o00<04<]c0000o`0400k;M0000?l01@0<bgD0
003o00H02/]f0000A0000ol0000Y0003o`0006L000?o0000:@000oo;b`04bgP000140003o`0002T0
00?o0000I`000ol0000Y0003o`0007`000150003o`0002L000?o0000J@000ol0000W0003o`0007d0
00150003o`0002L000?o0000J@000ol0000W0003o`0007d000160003o`0002D000?o0000J`000ol0
000U0003o`0007h000160003o`0002D000?o0000J`000ol0000U0003o`0007h000170003o`0002<0
00?o0000K@000ol0000S0003o`0007l000170003o`0002<000?o0000K@000ol0000S0003o`0007l0
00180003o`00024000?o0000K`000ol0000Q0003o`00080000180003o`00024000?o0000K`000ol0
000Q0003o`00080000190003o`0001l000?o0000L@000ol0000O0003o`00084000190003o`0001l0
00?o0000L@000ol0000O0003o`000840001:0003o`0001d000?o0000L`000ol0000M0003o`000880
001:0003o`0001d000?o0000L`000ol0000M0003o`000880001;0003o`0001/000?o0000M@000ol0
000K0003o`0008<0001;0003o`0001/000?o0000M@000ol0000K0003o`0008<0001<0003o`0001T0
00?o0000M`000ol0000I0003o`0008@0001<0003o`0001T000?o0000M`000ol0000I0003o`0008@0
001=0003o`0001L000?o0000N@000ol0000G0003o`0008D0001=0003o`0001L000?o0000N@000ol0
000G0003o`0008D0001=0003o`0001L000?o0000N@000ol0000G0003o`0008D0001>0003o`0001D0
00?o0000N`000ol0000E0003o`0008H0001>0003o`0001D000?o0000N`000ol0000E0003o`0008H0
001?0003o`0001<000?o0000O@000ol0000C0003o`0008L0001?0003o`0001<000?o0000O@000ol0
000C0003o`0008L0001@0003o`00014000?o0000O`000ol0000A0003o`0008P0001@0003o`000140
00?o0000O`000ol0000A0003o`0008P0001A0003o`0000l000?o0000P@000ol0000?0003o`0008T0
001A0003o`0000l000?o0000P@000ol0000?0003o`0008T0001B0003o`0000d000?o0000P`000ol0
000=0003o`0008X0001B0003o`0000d000?o0000P`000ol0000=0003o`0008X0001C0003o`0000/0
00?o0000Q@000ol0000;0003o`0008/0001C0003o`0000/000?o0000Q@000ol0000;0003o`0008/0
001D0003o`0000T000?o0000Q`000ol000090003o`0008`0001D0003o`0000T000?o0000Q`000ol0
00090003o`0008`0001E0003o`0000L000?o0000R@000ol000070003o`0008d0001E0003o`0000L0
00?o0000R@000ol000070003o`0008d0001F0003o`0000D000?o0000R`000ol000050003o`0008h0
001F0003ol_;00C;00<0o`00S0000oo;b`04b`030?l008l0001E00[;S00:bi00001D00c;RP0<bhl0
001C00k;R00>bhh0001B00K;0ol7bhH04<^=0000DP09b`03ol_;00C;QP0@bhd0000<00Go@007b`Co
1l]000Co@007b`;o00?;ool01//o00CoB@0000`000Co003o@@06b`05ol_;bol01l]10003o`000400
1l/01?o;bol7bd0000?o0000B@0000`01?m100K;00Gobl_;o`07bd8000?o0000?`07b`04ol_;o`O;
@@000ol0001800003`000ol0000o00K;00Gobl_;o`07bd<000?o0000?P07b`04ol_;o`O;@P000ol0
001700003004od401l/5o`K;@`000ol0000n00O;1?l7bd8000?o0000A`0001P00_lg01;;@003od40
1l/00oo;b`08bcP000?o00001003odX0000J00;o=P0@bhH01L/2o`W;=P03oe@0000L00?o<`0@b`03
o`0008<04</c00?oE`0001l00ola00k;0P000ol000210003o`3;00g;<@03oeX0000R00;o<00<b`@0
00?o0000O`001?l0000<bc000_mM00009003obh02//600;oO@02o`D02//^00?oG`0002L00ol]00K;
2P000ol0001i0003o`0000L01//]00?oHP0002X00olk0003o`0003X000?o0000>P000ol0000i00;o
I@0002d00_lj00;o>P000ol0000h00;o>@03ofL0000_00?o>@000ol0000g0003o`0003L000?o0000
=P03ofX0000b00?o=`000ol0000f0003o`0003H000?o0000=003ofd0000e00?o=@02ocH000?o0000
=002ocD00_m`0000>002ocD000?o0000<`000ol0000c0003o`0003800omb0000>P03oc<00_lc0003
o`0003400_lb00?oM@0003d00olb0003o`00030000?o0000<0000ol0000`00;oN00004000_la0003
o`0002l000?o0000;`000ol0000^00?oNP0004800ol_00;o;`000ol0000]00;o;P03ogd0001500?o
;P000ol0000/0003o`0002`000?o0000:`03oh00001800?o;0000ol0000[0003o`0002/000?o0000
:P02oh<0001;00;o:`02ob/000?o0000:@02obX00on50000C@03obX000?o0000:0000ol0000X0003
o`0002L00on80000D003obP000?o00009`000ol0000W0003o`0002H00_n;0000D`03obH00_lW0003
o`0002D00_lV00?oS@0005H00_lV0003o`0002@000?o000090000ol0000S00?oT00005P00olT00;o
90000ol0000R00;o8`03oi<0001K00?o8`000ol0000Q0003o`00024000?o00008@02oiH0001N00;o
8P000ol0000P0003o`00020000?o00007`03oiP0001P00?o8002ob0000?o00007P02oal00onK0000
H`03oal000?o00007@000ol0000M0003o`0001d00_nN0000IP03oad000?o000070000ol0000L0003
o`0001/00onP0000J@02oa`00_lL0003o`0001X00_lK00?oX`0006/00olK0003o`0001T000?o0000
6@000ol0000I00;oYP0006h00olI0003o`0001P000?o000060000ol0000G00?oZ00007400olG00;o
60000ol0000F00;o5`03oj/0001d00;o5`000ol0000E0003o`0001D000?o00005003ojh0001f00?o
5@02oaD000?o00004`02oaD00_na0000N@03oa@000?o00004P000ol0000B0003o`0001800onc0000
O002oa<000?o00004@000ol0000A0003o`0001000onf0000OP03oa400_lA0003o`0000l00_lA00;o
^@0008400ol@0003o`0000h000?o00003P000ol0000>00?o^`0008@00ol>0003o`0000d000?o0000
3@000ol0000<00?o_P0008L00_l=00;o3@000ol0000;00;o3003ol40002900?o30000ol0000:0003
o`0000X000?o00002P02ol@0002<00?o2P000ol000090003o`0000T000?o00002003olH0002?00?o
2002o`T000?o00001`02o`P00oo90000TP02o`P000?o00000`06b`H000?o00001P02ol`0002D00?o
1P02o`030<_;00S;0P02o`H00oo>0000U`03o`D03</00ol0000300?od@0009X00_l200k;0P03om@0
002L0003ol_;00k;00?o0000e@0009d01//4o`K;f00009`02</00oo;b`07bmL0002L00S;00?obl/0
1l_G0000W008b`03ol_;00O;e`0009`01l/4o`O;e`0009`02</00oo;b`07bmL0002L00S;0ol7bmL0
002M013;f00009d04<_H0000WP0>bmT0002O00c;fP000:002/_K0000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 3"],

Cell[TextData[{
  "Mutant 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004of400ol>0000o`0@0005o`000?l0H@000ol0000=0000
o`0@0005o`000?l0GP05o`h0003o010000Go0000o`1O0003o`3o00l0003o01001?mP0003o`3o00l0
003o010000?o0000HP02o`l0003o00l00_me0000o`260000o`260000o`0H0003o`0006/0003o01T0
00?o0000DP000ol0000E0000o`0J0003o`00050000?o00005P000?l06P000ol0001?0003o`0001L0
003o01/000?o0000C@000ol0000H0000o`0L0003o`0004`000?o000060000?l07@000ol0001:0003
o`0001T0003o01h000?o0000B0000ol0000J0000o`0O0003o`0004H000?o00006`000?l080000ol0
00140003o`0001`0003o024000?o0000@P000ol0000M0000o`0R0003o`00040000?o00007P000?l0
8P000ol0000o0003o`0001l0003o02<000?o0000?@000ol0000P0000o`0T0003o`0003/000?o0000
8@000?l09@000ol0000i0003o`000280003o02H000?o0000>0000ol0000R0000o`0W0003o`0003H0
00?o00008`000?l0:0000ol0000d0003o`0002@0003o02T000?o0000<P000ol0000U0000o`0Z0003
o`00030000?o00009P000?l0:`000ol0000^0003o`0002L0003o02/000?o0000;@000ol0000X0000
o`0/0003o`0002/000?o0000:@000?l0;@000ol0000Y0003o`0002X0003o02h000?o00009`000ol0
000[0000o`0_0003o`0002D000?o0000;0000?l0<0000ol0000T0003o`0002`0003o034000?o0000
8P000ol0000]0000o`0b0003o`00020000?o0000;P000?l0<`000ol0000N0003o`0002l0003o03<0
00?o00007@000ol0000`0000o`0d0003o`0001/000?o0000<@000?l0=@000ol0000I0003o`000380
003o03H000?o00005`000ol0000c0000o`0g0003o`0001D000?o0000=0000?l0>0000ol0000C0003
o`0003D0003o03T000?o00004@000ol0000f0000o`0j0003o`00010000?o0000=P000?l0>`000ol0
000>0003o`0003L0003o03/000?o00000`06b`@000?o0000>0000?l0?0000ol0000:b`030?l003X0
003o03d000?obl/02//l0000o`0m00k;>`000?l0?005b`?o2</j0000o`0l00S;00?obl/01L/j0000
c`04ofL01//4o`S;>@000<h000?o0000J@05b`05ol_;bol02</i0000cP000ol0001Y00G;00Gobl_;
o`08bcT0003>0005o`000?l0I`05b`05ol_;bol02</i0000c`04ofL01//5o`O;>@000?l0>`0BbcT0
003o03`04</j0000o`0l013;>P000=P000?o0000H0000oo;b`0<bc/0003I0003o`0005h000?o0000
3</l0000fP000ol0001L0003o`0000802//m0000f`000ol0001J0003o`0000D01//o0000g0000ol0
001H0003o`0004/0003M0003o`0005H000?o0000C0000=h000?o0000E0000ol0001=0000g`000ol0
001B0003o`0004h0003P0003o`00050000?o0000C`000>4000?o0000CP000ol0001@0000hP000ol0
001<0003o`000540003S0003o`0004X000?o0000DP000>@000?o0000B0000ol0001C0000i@000ol0
00160003o`0005@0003V0003o`0004@000?o0000E@000>L000?o0000@P000ol0001F0000j0000ol0
00100003o`0005L0003Y0003o`0003h000?o0000F0000>X000?o0000?0000ol0001I0000j`000ol0
000j0003o`0005X0003/0003o`0003P000?o0000F`000>d00_lg0003o`0005`0003_0003o`0003<0
00?o0000G@000?0000?o0000<@000ol0001N0000l@000ol0000_0003o`0005l0003b0003o`0002d0
00?o0000H0000?<000?o0000:`000ol0001Q0000m0000ol0000Y0003o`000680003e0003o`0002L0
00?o0000H`000?H000?o00009@000ol0001T0000m`000ol0000S0003o`0006D0003h0003o`000240
00?o0000IP000?T000?o00007`000ol0001W0000nP000ol0000M0003o`0006P0003k0003o`0001/0
00?o0000J@000?`000?o00006@000ol0001Z0000o@000ol0000G0003o`0006/0003n0003o`0001D0
00?o0000K0000?l000?o00004`000ol0001]0000o`010003o`00014000?o0000KP000?l00P000ol0
000?0003o`0006l0003o00<000?o00000P06b`D000?o0000L0000?l010000ol0b`09b`8000?o0000
L@000?l01@0<b`03o`000780003o00@03/]d0000o`0300K;0ol7bg<0003o00<02L/00oo;b`04bg<0
000n00Co<003oel01?lY00O;1?l7bg80000n0005o`000?l0<P000ol0001K0003o`0002/01//01Oo;
bl_o00O;LP0003h000Go0000o`0b0003o`0005/01OlY00K;00Gobl_;o`07bg80000n0005o`000?l0
<002oeh000Go0000o`0Y00K;00Gobl_;o`07bg80000n00Co<`000ol0001L00?o:P07b`Go1/]b0000
?P000ol0000a00?oS00Bbg80000m00;o``0@bg<0003o00<04<]c0000o`0400k;M0000?l01@0<bgD0
003o00H02/]f0000A0000ol0000Y0003o`0006L000?o0000:@000oo;b`04bgP000140003o`0002T0
00?o0000I`000ol0000Y0003o`0007`000150003o`0002L000?o0000J@000ol0000W0003o`0007d0
00150003o`0002L000?o0000J@000ol0000W0003o`0007d000160003o`0002D000?o0000J`000ol0
000U0003o`0007h000160003o`0002D000?o0000J`000ol0000U0003o`0007h000170003o`0002<0
00?o0000K@000ol0000S0003o`0007l000170003o`0002<000?o0000K@000ol0000S0003o`0007l0
00180003o`00024000?o0000K`000ol0000Q0003o`00080000180003o`00024000?o0000K`000ol0
000Q0003o`00080000190003o`0001l000?o0000L@000ol0000O0003o`00084000190003o`0001l0
00?o0000L@000ol0000O0003o`000840001:0003o`0001d000?o0000L`000ol0000M0003o`000880
001:0003o`0001d000?o0000L`000ol0000M0003o`000880001;0003o`0001/000?o0000M@000ol0
000K0003o`0008<0001;0003o`0001/000?o0000M@000ol0000K0003o`0008<0001<0003o`0001T0
00?o0000M`000ol0000I0003o`0008@0001<0003o`0001T000?o0000M`000ol0000I0003o`0008@0
001=0003o`0001L000?o0000N@000ol0000G0003o`0008D0001=0003o`0001L000?o0000N@000ol0
000G0003o`0008D0001=0003o`0001L000?o0000N@000ol0000G0003o`0008D0001>0003o`0001D0
00?o0000N`000ol0000E0003o`0008H0001>0003o`0001D000?o0000N`000ol0000E0003o`0008H0
001?0003o`0001<000?o0000O@000ol0000C0003o`0008L0001?0003o`0001<000?o0000O@000ol0
000C0003o`0008L0001@0003o`00014000?o0000O`000ol0000A0003o`0008P0001@0003o`000140
00?o0000O`000ol0000A0003o`0008P0001A0003o`0000l000?o0000P@000ol0000?0003o`0008T0
001A0003o`0000l000?o0000P@000ol0000?0003o`0008T0001B0003o`0000d000?o0000P`000ol0
000=0003o`0008X0001B0003o`0000d000?o0000P`000ol0000=0003o`0008X0001C0003o`0000/0
00?o0000Q@000ol0000;0003o`0008/0001C0003o`0000/000?o0000Q@000ol0000;0003o`0008/0
001D0003o`0000T000?o0000Q`000ol000090003o`0008`0001D0003o`0000T000?o0000Q`000ol0
00090003o`0008`0001E0003o`0000L000?o0000R@000ol000070003o`0008d0001E0003o`0000L0
00?o0000R@000ol000070003o`0008d0001F0003o`0000D000?o0000R`000ol000050003o`0008h0
001F0003ol_;00C;00<0o`00S0000oo;b`04b`030?l008l0001E00[;S00:bi00001D00c;RP0<bhl0
001C00k;R00>bhh0001B00K;0ol7bhH04<^=0000DP09b`03ol_;00C;QP0@bhd0000=00?o@@07b`Co
1l]000Co@007b`;o00?;ool01//o00CoB@00010000?o0000?P06b`05ol_;bol01l/o0003o`000480
1l/01?o;bol7bd0000?o0000B@00010000?o0000?P06b`05ol_;bol01l/o0003o`0004801l/01?o;
bol7bd4000?o0000B00000d00om100K;00Gobl_;o`07bcl000Go0000o`1000O;00Cobl_o1l]20003
o`0004L0000=0003o`0004401l/5o`K;@004od001l/4o`O;@P000ol0001700003@04o`L00_lg01;;
Q007b`03ol_;00S;>0000ol0000400?oBP0001X00_lf013;QP05b`;o2L/f00?oE00001`00olc013;
00?o0000P`0@bc<00omG00007`03oc403//20003o`00084000?o0</03L/a00?oFP0002800_l`00c;
10000ol0001o0004o`0000c;<002oed0000T00?o;P0:b`H00_mm00;o1@0:bbh00omO00009`03obd0
1//:0003o`0007T000?o00001`06bbd00omR0000:P03oc/000?o0000>P000ol0000j0003o`0003T0
0_mU0000;@02ocX00_lj0003o`0003P00_li00?oI`0002l00oli0003o`0003L000?o0000=`000ol0
000f00?oJP0003800olg0003o`0003H000?o0000=P000ol0000d00?oK@0003D00ole00;o=P000ol0
000d00;o=@02og00000h00;o=@000ol0000c0003o`0003<000?o0000<P03og80000j00?o<`02oc<0
00?o0000<@02oc800ome0000?@03oc8000?o0000<0000ol0000`0003o`0003000_mh0000@002oc40
00?o0000;`000ol0000_0003o`0002h00omj0000@P03obl00_l_0003o`0002d00_l^00?oO@0004D0
0ol^0003o`0002`000?o0000;0000ol0000[00?oP00004P00ol/0003o`0002/000?o0000:`000ol0
000Z00;oP`0004/00_l[00;o:`000ol0000Y00;o:P03ohD0001=00?o:P000ol0000X0003o`0002P0
00?o00009`03ohP0001@00?o:0000ol0000W0003o`0002L000?o00009P02oh/0001C00?o9P02obL0
00?o00009@02obH00on=0000EP02obH000?o000090000ol0000T0003o`0002<00on@0000F003ob@0
0_lT0003o`0002800_lS00?oT`0005/00olS0003o`00024000?o00008@000ol0000Q00;oUP0005h0
0_lR0003o`00020000?o000080000ol0000O00?oV00006000olP00;o80000ol0000N00;o7`03oi/0
001S00?o7`000ol0000M0003o`0001d000?o00007@02oih0001V00?o7@000ol0000L0003o`0001`0
00?o00006`03oj00001Y00;o7002oa`000?o00006P02oa/00onS0000J`03oa/000?o00006@000ol0
000I0003o`0001T00_nV0000KP03oaT000?o000060000ol0000H0003o`0001L00onX0000L@03oaL0
0_lH0003o`0001H00_lG00?oZ`0007@00_lG0003o`0001D000?o00005@000ol0000D00?o[P0007H0
0olE00;o5@000ol0000C00;o5@02ok40001i00?o50000ol0000B0003o`00018000?o00004P03ok<0
001l00;o4`000ol0000A0003o`00014000?o00004003okH0001n00?o4@02oa4000?o00003`02oa40
0_ni0000P@03oa0000?o00003P000ol0000>0003o`0000h00onk0000Q003o`h000?o00003@000ol0
000=0003o`0000`00onn0000Q`02o`d00_l=0003o`0000/00_l<00?o`@0008T00ol<0003o`0000X0
00?o00002P000ol0000:00;oa00008`00ol:0003o`0000T000?o00002@000ol0000800?oaP0008l0
0ol800;o2@000ol0000700;o2003olT0002B00;o20000ol0000300K;1P000ol0000600;oc00009@0
0ol600;o00<0bl/02</200;o1P03olh0002G00?o1@0<b`03o`0000<00ooA0000VP02o`803//200?o
e00009`000?obl/03//00ol0003E0000W@06b`Co1/_H0000W008b`03ol_;00O;e`0009`02</00oo;
b`07bmL0002L00S;00?obl/01l_G0000W007b`Co1l_G0000W008b`03ol_;00O;e`0009`02</3o`O;
e`0009d04<_H0000W@0@bmP0002N00k;f@0009l03<_J0000X00:bm/00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 4"],

Cell[TextData[{
  "Mutant 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04P03of000ol>0000o`0C0003o`00060000?o00003@000?l0
4005oeh01Ol>0000o`0A0003o`3o060000?o0?l03`000?l04@000ol0o`1P0003o`3o00l0003o0180
0_mQ00;o3`000?l0QP000?l0QP000?l0QP000?l060000ol0001[0000o`0I0003o`00058000?o0000
5@000?l06P000ol0001@0003o`0001H0003o01X000?o0000C`000ol0000G0000o`0K0003o`0004d0
00?o000060000?l070000ol0001<0003o`0001P0003o01d000?o0000BP000ol0000I0000o`0N0003
o`0004P000?o00006P000?l07`000ol000160003o`0001/0003o020000?o0000A0000ol0000L0000
o`0Q0003o`00048000?o00007@000?l08P000ol000100003o`0001h0003o028000?o0000?`000ol0
000O0000o`0S0003o`0003d000?o000080000?l090000ol0000k0003o`000240003o02D000?o0000
>@000ol0000R0000o`0V0003o`0003P000?o00008P000?l09`000ol0000f0003o`0002<0003o02P0
00?o0000=0000ol0000T0000o`0Y0003o`00038000?o00009@000?l0:P000ol0000`0003o`0002H0
003o02/000?o0000;P000ol0000W0000o`0[0003o`0002d000?o0000:0000?l0;0000ol0000[0003
o`0002T0003o02d000?o0000:@000ol0000Z0000o`0^0003o`0002L000?o0000:`000?l0;`000ol0
000U0003o`0002`0003o030000?o000090000ol0000/0000o`0a0003o`00028000?o0000;@000?l0
<P000ol0000P0003o`0002h0003o03<000?o00007P000ol0000_0000o`0c0003o`0001d000?o0000
<0000?l0=0000ol0000K0003o`000340003o03D000?o00006@000ol0000b0000o`0f0003o`0001L0
00?o0000<`000?l0=`000ol0000E0003o`0003@0003o03P000?o00004`000ol0000e0000o`0i0003
o`00014000?o0000=P000?l0>P000ol0000@0003o`0003H0003o03/000?o00003P000ol0000g0000
o`0k0003o`0000<01//40003o`0003P0003o03`000?o00002//00`3o000j0000o`0m0003ol_;00[;
?0000?l0?@0>bc/0003o03`01L/3o`S;>P000?l0?008b`03ol_;00G;>P000<l01?mW00K;1?l8bcT0
003>0003o`0006T01L/01Oo;bl_o00S;>@000<h000?o0000J@05b`05ol_;bol02</i0000cP001Ol0
003o06L01L/01Oo;bl_o00S;>@000<l01?mW00K;1Ol7bcT0003o03/04//i0000o`0l013;>P000?l0
?00@bcX0003H0003o`00060000?obl/03</k0000f@000ol0001N0003o`0000c;?0000=X000?o0000
G0000ol0000200[;?@000=/000?o0000FP000ol0000500K;?`000=`000?o0000F0000ol0001;0000
g@000ol0001F0003o`0004`0003N0003o`0005@000?o0000C@000=l000?o0000DP000ol0001>0000
h0000ol0001@0003o`0004l0003Q0003o`0004h000?o0000D0000>8000?o0000C0000ol0001A0000
h`000ol0001:0003o`000580003T0003o`0004P000?o0000D`000>D000?o0000AP000ol0001D0000
iP000ol000140003o`0005D0003W0003o`00048000?o0000EP000>P000?o0000@0000ol0001G0000
j@000ol0000n0003o`0005P0003Z0003o`0003`000?o0000F@000>/000?o0000>P000ol0001J0000
k0000ol0000h0003o`0005/0003]00;o=`000ol0001L0000k`000ol0000c0003o`0005d0003`0003
o`00034000?o0000GP000?4000?o0000;`000ol0001O0000lP000ol0000]0003o`000600003c0003
o`0002/000?o0000H@000?@000?o0000:@000ol0001R0000m@000ol0000W0003o`0006<0003f0003
o`0002D000?o0000I0000?L000?o00008`000ol0001U0000n0000ol0000Q0003o`0006H0003i0003
o`0001l000?o0000I`000?X000?o00007@000ol0001X0000n`000ol0000K0003o`0006T0003l0003
o`0001T000?o0000JP000?d000?o00005`000ol0001[0000oP000ol0000E0003o`0006`0003o0003
o`0001<000?o0000K@000?l00@000ol0000A0003o`0006h0003o008000?o00003`000ol0001_0000
o`030003o`0000801//50003o`000700003o00@000?o0</02L/20003o`000740003o00D03</00ol0
001b0000o`0400k;M0000?l00`06b`?o1l]c0000o`0300W;00?obl/01<]c0000?P04oc000omO00Co
:@07b`Co1l]b0000?P001Ol0003o038000?o0000F`000ol0000[00K;00Gobl_;o`07bg80000n0005
o`000?l0<P000ol0001K00Go:@06b`05ol_;bol01l]b0000?P001Ol0003o03000_mN0005o`000?l0
:@06b`05ol_;bol01l]b0000?P04oc<000?o0000G003obX01l/5o`K;LP0003h000?o0000<@03oh`0
4/]b0000?@02ol<04<]c0000o`03013;L`000?l0100>bg@0003o00D03<]e0000o`0600[;MP0004@0
00?o0000:@000ol0001W0003o`0002T000?obl/01<]h0000A0000ol0000Y0003o`0006L000?o0000
:@000ol0001l0000A@000ol0000W0003o`0006T000?o00009`000ol0001m0000A@000ol0000W0003
o`0006T000?o00009`000ol0001m0000AP000ol0000U0003o`0006/000?o00009@000ol0001n0000
AP000ol0000U0003o`0006/000?o00009@000ol0001n0000A`000ol0000S0003o`0006d000?o0000
8`000ol0001o0000A`000ol0000S0003o`0006d000?o00008`000ol0001o0000B0000ol0000Q0003
o`0006l000?o00008@000ol000200000B0000ol0000Q0003o`0006l000?o00008@000ol000200000
B@000ol0000O0003o`00074000?o00007`000ol000210000B@000ol0000O0003o`00074000?o0000
7`000ol000210000BP000ol0000M0003o`0007<000?o00007@000ol000220000BP000ol0000M0003
o`0007<000?o00007@000ol000220000B`000ol0000K0003o`0007D000?o00006`000ol000230000
B`000ol0000K0003o`0007D000?o00006`000ol000230000C0000ol0000I0003o`0007L000?o0000
6@000ol000240000C0000ol0000I0003o`0007L000?o00006@000ol000240000C@000ol0000G0003
o`0007T000?o00005`000ol000250000C@000ol0000G0003o`0007T000?o00005`000ol000250000
C@000ol0000G0003o`0007T000?o00005`000ol000250000CP000ol0000E0003o`0007/000?o0000
5@000ol000260000CP000ol0000E0003o`0007/000?o00005@000ol000260000C`000ol0000C0003
o`0007d000?o00004`000ol000270000C`000ol0000C0003o`0007d000?o00004`000ol000270000
D0000ol0000A0003o`0007l000?o00004@000ol000280000D0000ol0000A0003o`0007l000?o0000
4@000ol000280000D@000ol0000?0003o`00084000?o00003`000ol000290000D@000ol0000?0003
o`00084000?o00003`000ol000290000DP000ol0000=0003o`0008<000?o00003@000ol0002:0000
DP000ol0000=0003o`0008<000?o00003@000ol0002:0000D`000ol0000;0003o`0008D000?o0000
2`000ol0002;0000D`000ol0000;0003o`0008D000?o00002`000ol0002;0000E0000ol000090003
o`0008L000?o00002@000ol0002<0000E0000ol000090003o`0008L000?o00002@000ol0002<0000
E@000ol000070003o`0008T000?o00001`000ol0002=0000E@000ol000070003o`0008T000?o0000
1`000ol0002=0000EP000ol000050003o`0008/000?o00001@000ol0002>0000EP000oo;b`04b`03
0?l008`000?obl/01</00`3o002?0000E@0:bh`02/^@0000E00<bhX03<^?0000D`0>bhP03/^>0000
DP06b`?o1l^6013;S@0005802L/00oo;b`04bhH04<^=00003005od001l/4o`O;@004od001l/2o`03
booo00K;?`04odT0000<0004o`00od401//01Oo;bl_o00O;?`000ol0001200O;00Cobl_o1l]00003
o`0004T0000<00Co@@06b`05ol_;bol01l/o0003o`0004801l/01?o;bol7bd4000?o0000B00000l0
00?o0000?`06b`05ol_;bol01l/o0005o`000?l0@007b`04ol_;o`O;@P000ol0001700003004od40
1l/5o`K;@004od001l/4o`O;@P000ol0001700006002ocL04/^400O;00?obl/02</h0003o`0000@0
0om:00006P02ocH04<^600G;0_l9bcH00omD00007003oc<04</00ol00023013;<`03oeL0000O00?o
<@0>b`8000?o0000P@000ol0b`0=bc400omJ00008P02oc003</40003o`0007l000Co00003</`00;o
G@0002@00ol^00[;1P02ogd00_l500[;;P03oel0000W00?o;@06b`X000?o0000N@000ol0000700K;
;@03of80000Z00?o>`000ol0000j0003o`0003X000?o0000>@02ofD0000]00;o>P02ocX000?o0000
>002ocT00omW0000;`03ocT000?o0000=`000ol0000g0003o`0003H00omZ0000<P03ocL000?o0000
=P000ol0000f0003o`0003@00om]0000=@03ocD00_lf0003o`0003@00_le00;oL00003P00_le0003
o`0003<000?o0000<`000ol0000b00?oLP0003X00olc00;o<`000ol0000a00;o<P03ogD0000m00?o
<P000ol0000`0003o`00030000?o0000<002ogP0001000;o<@000ol0000_0003o`0002l000?o0000
;P03ogX0001200?o;`02obl000?o0000;@02obh00omm0000A@03obh000?o0000;0000ol0000/0003
o`0002/00on00000B003ob`000?o0000:`000ol0000[0003o`0002X00_n30000B`02ob/00_l[0003
o`0002T00_lZ00?oQ@0004d00olZ0003o`0002P000?o0000:0000ol0000W00?oR00005000olX0003
o`0002L000?o00009`000ol0000V00;oR`0005<00olV00;o9`000ol0000U00;o9P03ohd0001F00;o
9P000ol0000T0003o`0002@000?o00008`03oi00001H00?o9002ob@000?o00008P02ob<00onC0000
F`03ob<000?o00008@000ol0000Q0003o`0002400_nF0000GP02ob8000?o000080000ol0000P0003
o`0001l00onH0000H003ob000_lP0003o`0001h00_lO00?oV`0006<00olO0003o`0001d000?o0000
7@000ol0000M00;oWP0006H00olM0003o`0001`000?o000070000ol0000K00?oX00006T00_lL00;o
70000ol0000J00;o6`03oj<0001[00?o6`000ol0000I0003o`0001T000?o00006@02ojH0001^00?o
6@000ol0000H0003o`0001P000?o00005`03ojP0001a00?o5`02oaP000?o00005P02oaL00on[0000
M002oaL000?o00005@000ol0000E0003o`0001@00on^0000MP03oaD00_lE0003o`0001<00_lE00;o
/@0007T00olD0003o`00018000?o00004P000ol0000B00?o/`0007`00_lC0003o`00014000?o0000
4@000ol0000@00?o]P0007h00olA00;o4@000ol0000?00;o4@02okT0002100?o40000ol0000>0003
o`0000h000?o00003P03ok/0002400?o3P000ol0000=0003o`0000d000?o00003003okh0002700;o
3@02o`d000?o00002`02o``00oo10000R@03o``000?o00002P000ol0000:0003o`0000X00_o40000
S003o`X000?o00002@000ol000090003o`0000P00oo60000S`03o`P00_l90003o`0000L00_l800?o
b@0009800_l80003o`0000<01//60003o`0000H00_o<0000U003o`H00_l00`3;b`08b`800_l600?o
cP0009L00ol500c;00?o00000`03om40002J00;o0P0>b`800ooD0000W0000oo;b`0>b`03o`000=D0
002M00K;1?l6bmP0002L00S;00?obl/01l_G0000W008b`03ol_;00O;e`0009`02</00oo;b`07bmL0
002L00O;1?l7bmL0002L00S;00?obl/01l_G0000W008b`?o1l_G0000W@0@bmP0002M013;f00009h0
3/_I0000W`0<bmX0002P00[;f`000001\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 5"],

Cell[TextData[{
  "Mutant 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 6",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.952381 0.309017 0.588604 [
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .5 .30902 0 0 Msboxa
P
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
1 g
.04 w
.5 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .5 .30902 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000<001?o10000`@000ol000310000`P000ol000300000``000ol0
002o0000``000ol0002o0000`003ol80003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0003o08H0
0000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-0.526753, -0.525005, 0.00271522,
   0.00439332}},
  CellTags->"GP-Mutation - mutant 6"],

Cell[TextData[{
  "Mutant 6: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 7",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004of400ol>0000o`0@0005o`000?l0H@000ol0000=0000
o`0@0005o`000?l0GP05o`h0003o010000Go0000o`1O0003o`3o00l0003o01001?mP0003o`3o00l0
003o010000?o0000HP02o`l0003o00l00_me0000o`260000o`260000o`0H0003o`0006/0003o01T0
00?o0000DP000ol0000E0000o`0J0003o`00050000?o00005P000?l06P000ol0001?0003o`0001L0
003o01/000?o0000C@000ol0000H0000o`0L0003o`0004`000?o000060000?l07@000ol0001:0003
o`0001T0003o01h000?o0000B0000ol0000J0000o`0O0003o`0004H000?o00006`000?l080000ol0
00140003o`0001`0003o024000?o0000@P000ol0000M0000o`0R0003o`00040000?o00007P000?l0
8P000ol0000o0003o`0001l0003o02<000?o0000?@000ol0000P0000o`0T0003o`0003/000?o0000
8@000?l09@000ol0000i0003o`000280003o02H000?o0000>0000ol0000R0000o`0W0003o`0003H0
00?o00008`000?l0:0000ol0000d0003o`0002@0003o02T000?o0000<P000ol0000U0000o`0Z0003
o`00030000?o00009P000?l0:`000ol0000^0003o`0002L0003o02/000?o0000;@000ol0000X0000
o`0/0003o`0002/000?o0000:@000?l0;@000ol0000Y0003o`0002X0003o02h000?o00009`000ol0
000[0000o`0_0003o`0002D000?o0000;0000?l0<0000ol0000T0003o`0002`0003o034000?o0000
8P000ol0000]0000o`0b0003o`00020000?o0000;P000?l0<`000ol0000N0003o`0002l0003o03<0
00?o00007@000ol0000`0000o`0d0003o`0001/000?o0000<@000?l0=@000ol0000I0003o`000380
003o03H000?o00005`000ol0000c0000o`0g0003o`0001D000?o0000=0000?l0>0000ol0000C0003
o`0003D0003o03T000?o00004@000ol0000f0000o`0j0003o`00010000?o0000=P000?l0>`000ol0
000>0003o`0003L0003o03/000?o00000`06b`@000?o0000>0000?l0?0000ol0000:b`030?l003X0
003o03d000?obl/02//l0000o`0m00k;>`000?l0?005b`?o2</j0000o`0l00S;00?obl/01L/j0000
c`04ofL01//4o`S;>@000<h000?o0000J@05b`05ol_;bol02</i0000cP000ol0001Y00G;00Gobl_;
o`08bcT0003>0005o`000?l0I`05b`05ol_;bol02</i0000c`04ofL01//5o`O;>@000?l0>`0BbcT0
003o03`04</j0000o`0l013;>P000=P000?o0000H0000oo;b`0<bc/0003I0003o`0005h000?o0000
3</l0000fP000ol0001L0003o`0000802//m0000f`000ol0001J0003o`0000D01//o0000g0000ol0
001H0003o`0004/0003M0003o`0005H000?o0000C0000=h000?o0000E0000ol0001=0000g`000ol0
001B0003o`0004h0003P0003o`00050000?o0000C`000>4000?o0000CP000ol0001@0000hP000ol0
001<0003o`000540003S0003o`0004X000?o0000DP000>@000?o0000B0000ol0001C0000i@000ol0
00160003o`0005@0003V0003o`0004@000?o0000E@000>L000?o0000@P000ol0001F0000j0000ol0
00100003o`0005L0003Y0003o`0003h000?o0000F0000>X000?o0000?0000ol0001I0000j`000ol0
000j0003o`0005X0003/0003o`0003P000?o0000F`000>d00_lg0003o`0005`0003_0003o`0003<0
00?o0000G@000?0000?o0000<@000ol0001N0000l@000ol0000_0003o`0005l0003b0003o`0002d0
00?o0000H0000?<000?o0000:`000ol0001Q0000m0000ol0000Y0003o`000680003e0003o`0002L0
00?o0000H`000?H000?o00009@000ol0001T0000m`000ol0000S0003o`0006D0003h0003o`000240
00?o0000IP000?T000?o00007`000ol0001W0000nP000ol0000M0003o`0006P0003k0003o`0001/0
00?o0000J@000?`000?o00006@000ol0001Z0000o@000ol0000G0003o`0006/0003n0003o`0001D0
00?o0000K0000?l000?o00004`000ol0001]0000o`010003o`00014000?o0000KP000?l00P000ol0
000?0003o`0006l0003o00<000?o00000P06b`D000?o0000L0000?l010000ol0b`09b`8000?o0000
L@000?l01@0<b`03o`000780003o00@03/]d0000o`0300K;0ol7bg<0003o00<02L/00oo;b`04bg<0
000n00Co<003oel01?lY00O;1?l7bg80000n0005o`000?l0<P000ol0001L0005o`000?l0:006b`05
ol_;bol01l]b0000?P001Ol0003o038000?o0000G0001Ol0003o02P01//01Oo;bl_o00O;LP0003h0
00Go0000o`0`00;oG`001Ol0003o02P01//01Oo;bl_o00O;LP0003h01?lc0003o`0005`01?lY00O;
1Ol6bg80000n0003o`0003400omO0003o`0002X04/]b0000?@02oi@00_l]013;L`000?l00`0@bg<0
003o00@03/]d0000o`0500c;M@000?l01P0:bgH000140003o`0002T000?o0000I`000ol0000Y0003
ol_;00C;N00004@000?o0000:@000ol0001W0003o`0002T000?o0000O00004D000?o00009`000ol0
001Y0003o`0002L000?o0000O@0004D000?o00009`000ol0001Y0003o`0002L000?o0000O@0004H0
00?o00009@000ol0001[0003o`0002D000?o0000OP0004H000?o00009@000ol0001[0003o`0002D0
00?o0000OP0004L000?o00008`000ol0001]0003o`0002<000?o0000O`0004L000?o00008`000ol0
001]0003o`0002<000?o0000O`0004P000?o00008@000ol0001_0003o`00024000?o0000P00004P0
00?o00008@000ol0001_0003o`00024000?o0000P00004T000?o00007`000ol0001a0003o`0001l0
00?o0000P@0004T000?o00007`000ol0001a0003o`0001l000?o0000P@0004X000?o00007@000ol0
001c0003o`0001d000?o0000PP0004X000?o00007@000ol0001c0003o`0001d000?o0000PP0004/0
00?o00006`000ol0001e0003o`0001/000?o0000P`0004/000?o00006`000ol0001e0003o`0001/0
00?o0000P`0004`000?o00006@000ol0001g0003o`0001T000?o0000Q00004`000?o00006@000ol0
001g0003o`0001T000?o0000Q00004d000?o00005`000ol0001i0003o`0001L000?o0000Q@0004d0
00?o00005`000ol0001i0003o`0001L000?o0000Q@0004d000?o00005`000ol0001i0003o`0001L0
00?o0000Q@0004h000?o00005@000ol0001k0003o`0001D000?o0000QP0004h000?o00005@000ol0
001k0003o`0001D000?o0000QP0004l000?o00004`000ol0001m0003o`0001<000?o0000Q`0004l0
00?o00004`000ol0001m0003o`0001<000?o0000Q`00050000?o00004@000ol0001o0003o`000140
00?o0000R000050000?o00004@000ol0001o0003o`00014000?o0000R000054000?o00003`000ol0
00210003o`0000l000?o0000R@00054000?o00003`000ol000210003o`0000l000?o0000R@000580
00?o00003@000ol000230003o`0000d000?o0000RP00058000?o00003@000ol000230003o`0000d0
00?o0000RP0005<000?o00002`000ol000250003o`0000/000?o0000R`0005<000?o00002`000ol0
00250003o`0000/000?o0000R`0005@000?o00002@000ol000270003o`0000T000?o0000S00005@0
00?o00002@000ol000270003o`0000T000?o0000S00005D000?o00001`000ol000290003o`0000L0
00?o0000S@0005D000?o00001`000ol000290003o`0000L000?o0000S@0005H000?o00001@000ol0
002;0003o`0000D000?o0000SP0005H000?obl/01</00`3o002<0003ol_;00C;00<0o`00S`0005D0
2/^<00[;T00005@03<^:00c;S`0005<03/^800k;SP0005801//3o`O;QP0@bhd0001B00W;00?obl/0
1<^6013;S@0000`01Om000O;1?l7bd001?m000O;0_l00l_oo`06bcl01?m9000030001?l00?m100K;
00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;@0000ol0001900003004od401//01Oo;bl_o00O;
?`000ol0001200O;00Cobl_o1l]10003o`0004P0000?0003o`0003l01//01Oo;bl_o00O;?`001Ol0
003o04001l/01?o;bol7bd8000?o0000A`0000`01?m100O;1Ol6bd001?m000O;1?l7bd8000?o0000
A`0001P00_lg01;;Q007b`03ol_;00S;>0000ol0000400?oBP0001X00_lf013;QP05b`;o2L/f00?o
E00001`00olc013;00?o0000P`0@bc<00omG00007`03oc403//20003o`00084000?o0</03L/a00?o
FP0002800_l`00c;10000ol0001o0004o`0000c;<002oed0000T00?o;P0:b`H00_mm00;o1@0:bbh0
0omO00009`03obd01//:0003o`0007T000?o00001`06bbd00omR0000:P03oc/000?o0000>P000ol0
000j0003o`0003T00_mU0000;@02ocX00_lj0003o`0003P00_li00?oI`0002l00oli0003o`0003L0
00?o0000=`000ol0000f00?oJP0003800olg0003o`0003H000?o0000=P000ol0000d00?oK@0003D0
0ole00;o=P000ol0000d00;o=@02og00000h00;o=@000ol0000c0003o`0003<000?o0000<P03og80
000j00?o<`02oc<000?o0000<@02oc800ome0000?@03oc8000?o0000<0000ol0000`0003o`000300
0_mh0000@002oc4000?o0000;`000ol0000_0003o`0002h00omj0000@P03obl00_l_0003o`0002d0
0_l^00?oO@0004D00ol^0003o`0002`000?o0000;0000ol0000[00?oP00004P00ol/0003o`0002/0
00?o0000:`000ol0000Z00;oP`0004/00_l[00;o:`000ol0000Y00;o:P03ohD0001=00?o:P000ol0
000X0003o`0002P000?o00009`03ohP0001@00?o:0000ol0000W0003o`0002L000?o00009P02oh/0
001C00?o9P02obL000?o00009@02obH00on=0000EP02obH000?o000090000ol0000T0003o`0002<0
0on@0000F003ob@00_lT0003o`0002800_lS00?oT`0005/00olS0003o`00024000?o00008@000ol0
000Q00;oUP0005h00_lR0003o`00020000?o000080000ol0000O00?oV00006000olP00;o80000ol0
000N00;o7`03oi/0001S00?o7`000ol0000M0003o`0001d000?o00007@02oih0001V00?o7@000ol0
000L0003o`0001`000?o00006`03oj00001Y00;o7002oa`000?o00006P02oa/00onS0000J`03oa/0
00?o00006@000ol0000I0003o`0001T00_nV0000KP03oaT000?o000060000ol0000H0003o`0001L0
0onX0000L@03oaL00_lH0003o`0001H00_lG00?oZ`0007@00_lG0003o`0001D000?o00005@000ol0
000D00?o[P0007H00olE00;o5@000ol0000C00;o5@02ok40001i00?o50000ol0000B0003o`000180
00?o00004P03ok<0001l00;o4`000ol0000A0003o`00014000?o00004003okH0001n00?o4@02oa40
00?o00003`02oa400_ni0000P@03oa0000?o00003P000ol0000>0003o`0000h00onk0000Q003o`h0
00?o00003@000ol0000=0003o`0000`00onn0000Q`02o`d00_l=0003o`0000/00_l<00?o`@0008T0
0ol<0003o`0000X000?o00002P000ol0000:00;oa00008`00ol:0003o`0000T000?o00002@000ol0
000800?oaP0008l00ol800;o2@000ol0000700;o2003olT0002B00;o20000ol0000300K;1P000ol0
000600;oc00009@00ol600;o00<0bl/02</200;o1P03olh0002G00?o1@0<b`03o`0000<00ooA0000
VP02o`803//200?oe00009`000?obl/03//00ol0003E0000W@06b`Co1/_H0000W008b`03ol_;00O;
e`0009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000W007b`Co1l_G0000W008b`03ol_;00O;
e`0009`02</3o`O;e`0009d04<_H0000W@0@bmP0002N00k;f@0009l03<_J0000X00:bm/00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 7"],

Cell[TextData[{
  "Mutant 7: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 8",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004of400ol>0000o`0@0005o`000?l0H@000ol0000=0000
o`0@0005o`000?l0GP05o`h0003o010000Go0000o`1O0003o`3o00l0003o01001?mP0003o`3o00l0
003o010000?o0000HP02o`l0003o00l00_me0000o`260000o`260000o`0H0003o`0006/0003o01T0
00?o0000DP000ol0000E0000o`0J0003o`00050000?o00005P000?l06P000ol0001?0003o`0001L0
003o01/000?o0000C@000ol0000H0000o`0L0003o`0004`000?o000060000?l07@000ol0001:0003
o`0001T0003o01h000?o0000B0000ol0000J0000o`0O0003o`0004H000?o00006`000?l080000ol0
00140003o`0001`0003o024000?o0000@P000ol0000M0000o`0R0003o`00040000?o00007P000?l0
8P000ol0000o0003o`0001l0003o02<000?o0000?@000ol0000P0000o`0T0003o`0003/000?o0000
8@000?l09@000ol0000i0003o`000280003o02H000?o0000>0000ol0000R0000o`0W0003o`0003H0
00?o00008`000?l0:0000ol0000d0003o`0002@0003o02T000?o0000<P000ol0000U0000o`0Z0003
o`00030000?o00009P000?l0:`000ol0000^0003o`0002L0003o02/000?o0000;@000ol0000X0000
o`0/0003o`0002/000?o0000:@000?l0;@000ol0000Y0003o`0002X0003o02h000?o00009`000ol0
000[0000o`0_0003o`0002D000?o0000;0000?l0<0000ol0000T0003o`0002`0003o034000?o0000
8P000ol0000]0000o`0b0003o`00020000?o0000;P000?l0<`000ol0000N0003o`0002l0003o03<0
00?o00007@000ol0000`0000o`0d0003o`0001/000?o0000<@000?l0=@000ol0000I0003o`000380
003o03H000?o00005`000ol0000c0000o`0g0003o`0001D000?o0000=0000?l0>0000ol0000C0003
o`0003D0003o03T000?o00004@000ol0000f0000o`0j0003o`00010000?o0000=P000?l0>`000ol0
000>0003o`0003L0003o03/000?o00000`06b`@000?o0000>0000?l0?0000ol0000:b`030?l003X0
003o03d000?obl/02//l0000o`0m00k;>`000?l0?005b`?o2</j0000o`0l00S;00?obl/01L/j0000
c`04ofL01//4o`S;>@000<h000?o0000J@05b`05ol_;bol02</i0000cP000ol0001Y00G;00Gobl_;
o`08bcT0003>0005o`000?l0I`05b`05ol_;bol02</i0000c`04ofL01//5o`O;>@000?l0>`0BbcT0
003o03`04</j0000o`0l013;>P000=P000?o0000H0000oo;b`0<bc/0003I0003o`0005h000?o0000
3</l0000fP000ol0001L0003o`0000802//m0000f`000ol0001J0003o`0000D01//o0000g0000ol0
001H0003o`0004/0003M0003o`0005H000?o0000C0000=h000?o0000E0000ol0001=0000g`000ol0
001B0003o`0004h0003P0003o`00050000?o0000C`000>4000?o0000CP000ol0001@0000hP000ol0
001<0003o`000540003S0003o`0004X000?o0000DP000>@000?o0000B0000ol0001C0000i@000ol0
00160003o`0005@0003V0003o`0004@000?o0000E@000>L000?o0000@P000ol0001F0000j0000ol0
00100003o`0005L0003Y0003o`0003h000?o0000F0000>X000?o0000?0000ol0001I0000j`000ol0
000j0003o`0005X0003/0003o`0003P000?o0000F`000>d00_lg0003o`0005`0003_0003o`0003<0
00?o0000G@000?0000?o0000<@000ol0001N0000l@000ol0000_0003o`0005l0003b0003o`0002d0
00?o0000H0000?<000?o0000:`000ol0001Q0000m0000ol0000Y0003o`000680003e0003o`0002L0
00?o0000H`000?H000?o00009@000ol0001T0000m`000ol0000S0003o`0006D0003h0003o`000240
00?o0000IP000?T000?o00007`000ol0001W0000nP000ol0000M0003o`0006P0003k0003o`0001/0
00?o0000J@000?`000?o00006@000ol0001Z0000o@000ol0000G0003o`0006/0003n0003o`0001D0
00?o0000K0000?l000?o00004`000ol0001]0000o`010003o`00014000?o0000KP000?l00P000ol0
000?0003o`0006l0003o00<000?o00000P06b`D000?o0000L0000?l010000ol0b`09b`8000?o0000
L@000?l01@0<b`03o`000780003o00@03/]d0000o`0300K;0ol7bg<0003o00<02L/00oo;b`04bg<0
000n00Co;`05oeh01?lY00O;1?l7bg80000n0005o`000?l0;P001?l00?mN0003o`0002/01//01Oo;
bl_o00O;LP0003h000Go0000o`0^00CoGP05obT01//01Oo;bl_o00O;LP0003h000Go0000o`0a0003
o`0005`000Go0000o`0Y00K;00Gobl_;o`07bg80000n00Co;`04oel00olZ00O;1Ol6bg80000n0003
o`000<004/]b0000?@02ol<04<]c0000o`03013;L`000?l0100>bg@0003o00D03<]e0000o`0600[;
MP0004@000?o0000:@000ol0001W0003o`0002T000?obl/01<]h0000A0000ol0000Y0003o`0006L0
00?o0000:@000ol0001l0000A@000ol0000W0003o`0006T000?o00009`000ol0001m0000A@000ol0
000W0003o`0006T000?o00009`000ol0001m0000AP000ol0000U0003o`0006/000?o00009@000ol0
001n0000AP000ol0000U0003o`0006/000?o00009@000ol0001n0000A`000ol0000S0003o`0006d0
00?o00008`000ol0001o0000A`000ol0000S0003o`0006d000?o00008`000ol0001o0000B0000ol0
000Q0003o`0006l000?o00008@000ol000200000B0000ol0000Q0003o`0006l000?o00008@000ol0
00200000B@000ol0000O0003o`00074000?o00007`000ol000210000B@000ol0000O0003o`000740
00?o00007`000ol000210000BP000ol0000M0003o`0007<000?o00007@000ol000220000BP000ol0
000M0003o`0007<000?o00007@000ol000220000B`000ol0000K0003o`0007D000?o00006`000ol0
00230000B`000ol0000K0003o`0007D000?o00006`000ol000230000C0000ol0000I0003o`0007L0
00?o00006@000ol000240000C0000ol0000I0003o`0007L000?o00006@000ol000240000C@000ol0
000G0003o`0007T000?o00005`000ol000250000C@000ol0000G0003o`0007T000?o00005`000ol0
00250000C@000ol0000G0003o`0007T000?o00005`000ol000250000CP000ol0000E0003o`0007/0
00?o00005@000ol000260000CP000ol0000E0003o`0007/000?o00005@000ol000260000C`000ol0
000C0003o`0007d000?o00004`000ol000270000C`000ol0000C0003o`0007d000?o00004`000ol0
00270000D0000ol0000A0003o`0007l000?o00004@000ol000280000D0000ol0000A0003o`0007l0
00?o00004@000ol000280000D@000ol0000?0003o`00084000?o00003`000ol000290000D@000ol0
000?0003o`00084000?o00003`000ol000290000DP000ol0000=0003o`0008<000?o00003@000ol0
002:0000DP000ol0000=0003o`0008<000?o00003@000ol0002:0000D`000ol0000;0003o`0008D0
00?o00002`000ol0002;0000D`000ol0000;0003o`0008D000?o00002`000ol0002;0000E0000ol0
00090003o`0008L000?o00002@000ol0002<0000E0000ol000090003o`0008L000?o00002@000ol0
002<0000E@000ol000070003o`0008T000?o00001`000ol0002=0000E@000ol000070003o`0008T0
00?o00001`000ol0002=0000EP000ol000050003o`0008/000?o00001@000ol0002>0000EP000oo;
b`04b`030?l008`000?obl/01</00`3o002?0000E@0:bh`02/^@0000E00<bhX03<^?0000D`0>bhP0
3/^>0000DP06b`?o1l^6013;S@0005802L/00oo;b`04bhH04<^=00003005od001l/4o`O;@004od00
1l/2o`03booo00K;?`04odT0000<0004o`00od401//01Oo;bl_o00O;?`000ol0001200O;00Cobl_o
1l]00003o`0004T0000<00Co@@06b`05ol_;bol01l/o0003o`0004801l/01?o;bol7bd4000?o0000
B00000l000?o0000?`06b`05ol_;bol01l/o0005o`000?l0@007b`04ol_;o`O;@P000ol000170000
3004od401l/5o`K;@004od001l/4o`O;@P000ol0001700006002ocL04/^400O;00?obl/02</h0003
o`0000@00om:00006P02ocH04<^600G;0_l9bcH00omD00007003oc<04</00ol00023013;<`03oeL0
000O00?o<@0>b`8000?o0000P@000ol0b`0=bc400omJ00008P02oc003</40003o`0007l000Co0000
3</`00;oG@0002@00ol^00[;1P02ogd00_l500[;;P03oel0000W00?o;@06b`X000?o0000N@000ol0
000700K;;@03of80000Z00?o>`000ol0000j0003o`0003X000?o0000>@02ofD0000]00;o>P02ocX0
00?o0000>002ocT00omW0000;`03ocT000?o0000=`000ol0000g0003o`0003H00omZ0000<P03ocL0
00?o0000=P000ol0000f0003o`0003@00om]0000=@03ocD00_lf0003o`0003@00_le00;oL00003P0
0_le0003o`0003<000?o0000<`000ol0000b00?oLP0003X00olc00;o<`000ol0000a00;o<P03ogD0
000m00?o<P000ol0000`0003o`00030000?o0000<002ogP0001000;o<@000ol0000_0003o`0002l0
00?o0000;P03ogX0001200?o;`02obl000?o0000;@02obh00omm0000A@03obh000?o0000;0000ol0
000/0003o`0002/00on00000B003ob`000?o0000:`000ol0000[0003o`0002X00_n30000B`02ob/0
0_l[0003o`0002T00_lZ00?oQ@0004d00olZ0003o`0002P000?o0000:0000ol0000W00?oR0000500
0olX0003o`0002L000?o00009`000ol0000V00;oR`0005<00olV00;o9`000ol0000U00;o9P03ohd0
001F00;o9P000ol0000T0003o`0002@000?o00008`03oi00001H00?o9002ob@000?o00008P02ob<0
0onC0000F`03ob<000?o00008@000ol0000Q0003o`0002400_nF0000GP02ob8000?o000080000ol0
000P0003o`0001l00onH0000H003ob000_lP0003o`0001h00_lO00?oV`0006<00olO0003o`0001d0
00?o00007@000ol0000M00;oWP0006H00olM0003o`0001`000?o000070000ol0000K00?oX00006T0
0_lL00;o70000ol0000J00;o6`03oj<0001[00?o6`000ol0000I0003o`0001T000?o00006@02ojH0
001^00?o6@000ol0000H0003o`0001P000?o00005`03ojP0001a00?o5`02oaP000?o00005P02oaL0
0on[0000M002oaL000?o00005@000ol0000E0003o`0001@00on^0000MP03oaD00_lE0003o`0001<0
0_lE00;o/@0007T00olD0003o`00018000?o00004P000ol0000B00?o/`0007`00_lC0003o`000140
00?o00004@000ol0000@00?o]P0007h00olA00;o4@000ol0000?00;o4@02okT0002100?o40000ol0
000>0003o`0000h000?o00003P03ok/0002400?o3P000ol0000=0003o`0000d000?o00003003okh0
002700;o3@02o`d000?o00002`02o``00oo10000R@03o``000?o00002P000ol0000:0003o`0000X0
0_o40000S003o`X000?o00002@000ol000090003o`0000P00oo60000S`03o`P00_l90003o`0000L0
0_l800?ob@0009800_l80003o`0000<01//60003o`0000H00_o<0000U003o`H00_l00`3;b`08b`80
0_l600?ocP0009L00ol500c;00?o00000`03om40002J00;o0P0>b`800ooD0000W0000oo;b`0>b`03
o`000=D0002M00K;1?l6bmP0002L00S;00?obl/01l_G0000W008b`03ol_;00O;e`0009`02</00oo;
b`07bmL0002L00O;1?l7bmL0002L00S;00?obl/01l_G0000W008b`?o1l_G0000W@0@bmP0002M013;
f00009h03/_I0000W`0<bmX0002P00[;f`000001\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 8"],

Cell[TextData[{
  "Mutant 8: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .75356 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .89274 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
.004 w
.82315 .45617 m
.75356 .30902 L
s
.82315 .45617 m
.89274 .30902 L
s
1 g
.05 w
.75356 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .75356 .30902 0 0 Mshowa
P
1 g
.89274 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .89274 .30902 0 0 Mshowa
P
.9 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004of400ol>0000o`0@0005o`000?l0H@000ol0000=0000
o`0@0005o`000?l0GP05o`h0003o010000Go0000o`1O0003o`3o00l0003o01001?mP0003o`3o00l0
003o010000?o0000HP02o`l0003o00l00_me0000o`260000o`260000o`0H0003o`0006/0003o01T0
00?o0000DP000ol0000E0000o`0J0003o`00050000?o00005P000?l06P000ol0001?0003o`0001L0
003o01/000?o0000C@000ol0000H0000o`0L0003o`0004`000?o000060000?l07@000ol0001:0003
o`0001T0003o01h000?o0000B0000ol0000J0000o`0O0003o`0004H000?o00006`000?l080000ol0
00140003o`0001`0003o024000?o0000@P000ol0000M0000o`0R0003o`00040000?o00007P000?l0
8P000ol0000o0003o`0001l0003o02<000?o0000?@000ol0000P0000o`0T0003o`0003/000?o0000
8@000?l09@000ol0000i0003o`000280003o02H000?o0000>0000ol0000R0000o`0W0003o`0003H0
00?o00008`000?l0:0000ol0000d0003o`0002@0003o02T000?o0000<P000ol0000U0000o`0Z0003
o`00030000?o00009P000?l0:`000ol0000^0003o`0002L0003o02/000?o0000;@000ol0000X0000
o`0/0003o`0002/000?o0000:@000?l0;@000ol0000Y0003o`0002X0003o02h000?o00009`000ol0
000[0000o`0_0003o`0002D000?o0000;0000?l0<0000ol0000T0003o`0002`0003o034000?o0000
8P000ol0000]0000o`0b0003o`00020000?o0000;P000?l0<`000ol0000N0003o`0002l0003o03<0
00?o00007@000ol0000`0000o`0d0003o`0001/000?o0000<@000?l0=@000ol0000I0003o`000380
003o03H000?o00005`000ol0000c0000o`0g0003o`0001D000?o0000=0000?l0>0000ol0000C0003
o`0003D0003o03T000?o00004@000ol0000f0000o`0j0003o`00010000?o0000=P000?l0>`000ol0
000>0003o`0003L0003o03/000?o00000`06b`@000?o0000>0000?l0?0000ol0000:b`030?l003X0
003o03d000?obl/02//l0000o`0m00k;>`000?l0?005b`?o2</j0000o`0l00S;00?obl/01L/j0000
c`04ofL01//4o`S;>@000<h000?o0000J@05b`05ol_;bol02</i0000cP000ol0001Y00G;00Gobl_;
o`08bcT0003>0005o`000?l0I`05b`05ol_;bol02</i0000c`04ofL01//5o`O;>@000?l0>`0BbcT0
003o03`04</j0000o`0l013;>P000=P000?o0000H0000oo;b`0<bc/0003I0003o`0005h000?o0000
3</l0000fP000ol0001L0003o`0000802//m0000f`000ol0001J0003o`0000D01//o0000g0000ol0
001H0003o`0004/0003M0003o`0005H000?o0000C0000=h000?o0000E0000ol0001=0000g`000ol0
001B0003o`0004h0003P0003o`00050000?o0000C`000>4000?o0000CP000ol0001@0000hP000ol0
001<0003o`000540003S0003o`0004X000?o0000DP000>@000?o0000B0000ol0001C0000i@000ol0
00160003o`0005@0003V0003o`0004@000?o0000E@000>L000?o0000@P000ol0001F0000j0000ol0
00100003o`0005L0003Y0003o`0003h000?o0000F0000>X000?o0000?0000ol0001I0000j`000ol0
000j0003o`0005X0003/0003o`0003P000?o0000F`000>d00_lg0003o`0005`0003_0003o`0003<0
00?o0000G@000?0000?o0000<@000ol0001N0000l@000ol0000_0003o`0005l0003b0003o`0002d0
00?o0000H0000?<000?o0000:`000ol0001Q0000m0000ol0000Y0003o`000680003e0003o`0002L0
00?o0000H`000?H000?o00009@000ol0001T0000m`000ol0000S0003o`0006D0003h0003o`000240
00?o0000IP000?T000?o00007`000ol0001W0000nP000ol0000M0003o`0006P0003k0003o`0001/0
00?o0000J@000?`000?o00006@000ol0001Z0000o@000ol0000G0003o`0006/0003n0003o`0001D0
00?o0000K0000?l000?o00004`000ol0001]0000o`010003o`00014000?o0000KP000?l00P000ol0
000?0003o`0006l0003o00<000?o00000P06b`D000?o0000L0000?l010000ol0b`09b`8000?o0000
L@000?l01@0<b`03o`000780003o00@03/]d0000o`0300K;0ol7bg<0003o00<02L/00oo;b`04bg<0
000n00Co<003oel01?lY00O;1?l7b`/01?l`00Co;`0003h000Go0000o`0b0003o`0005/000?o0000
:`06b`05ol_;bol01l/:0003o`00034000?o0000<@0003h000Go0000o`0b0003o`0005/01OlY00K;
00Gobl_;o`07b`X000?o0000<@05obl0000n0005o`000?l0<002oeh000Go0000o`0Y00K;00Gobl_;
o`07b`X000Go0000o`0_0005o`000?l0;`0003h01?lc0003o`0005`00olZ00O;1Ol6b`/01?l`00?o
<00003h000?o0000<@03oh`04/]b0000?@02ol<04<]c0000o`03013;L`000?l0100>bg@0003o00D0
3<]e0000o`0600[;MP0004@000?o0000:@000ol0001W0003o`0002T000?obl/01</G0003o`0002T0
00?o0000<P0004@000?o0000:@000ol0001W0003o`0002T000?o00006`000ol0000Y0003o`000380
00150003o`0002L000?o0000J@000ol0000W0003o`0001d000?o00009`000ol0000c0000A@000ol0
000W0003o`0006T000?o00009`000ol0000M0003o`0002L000?o0000<`0004H000?o00009@000ol0
001[0003o`0002D000?o00007`000ol0000U0003o`0003@000160003o`0002D000?o0000J`000ol0
000U0003o`0001l000?o00009@000ol0000d0000A`000ol0000S0003o`0006d000?o00008`000ol0
000Q0003o`0002<000?o0000=@0004L000?o00008`000ol0001]0003o`0002<000?o00008@000ol0
000S0003o`0003D000180003o`00024000?o0000K`000ol0000Q0003o`0002<000?o00008@000ol0
000f0000B0000ol0000Q0003o`0006l000?o00008@000ol0000S0003o`00024000?o0000=P0004T0
00?o00007`000ol0001a0003o`0001l000?o00009@000ol0000O0003o`0003L000190003o`0001l0
00?o0000L@000ol0000O0003o`0002D000?o00007`000ol0000g0000BP000ol0000M0003o`0007<0
00?o00007@000ol0000W0003o`0001d000?o0000>00004X000?o00007@000ol0001c0003o`0001d0
00?o00009`000ol0000M0003o`0003P0001;0003o`0001/000?o0000M@000ol0000K0003o`0002T0
00?o00006`000ol0000i0000B`000ol0000K0003o`0007D000?o00006`000ol0000Y0003o`0001/0
00?o0000>@0004`000?o00006@000ol0001g0003o`0001T000?o0000:`000ol0000I0003o`0003X0
001<0003o`0001T000?o0000M`000ol0000I0003o`0002/000?o00006@000ol0000j0000C@000ol0
000G0003o`0007T000?o00005`000ol0000]0003o`0001L000?o0000>`0004d000?o00005`000ol0
001i0003o`0001L000?o0000;@000ol0000G0003o`0003/0001=0003o`0001L000?o0000N@000ol0
000G0003o`0002d000?o00005`000ol0000k0000CP000ol0000E0003o`0007/000?o00005@000ol0
000_0003o`0001D000?o0000?00004h000?o00005@000ol0001k0003o`0001D000?o0000;`000ol0
000E0003o`0003`0001?0003o`0001<000?o0000O@000ol0000C0003o`00034000?o00004`000ol0
000m0000C`000ol0000C0003o`0007d000?o00004`000ol0000a0003o`0001<000?o0000?@000500
00?o00004@000ol0001o0003o`00014000?o0000<`000ol0000A0003o`0003h0001@0003o`000140
00?o0000O`000ol0000A0003o`0003<000?o00004@000ol0000n0000D@000ol0000?0003o`000840
00?o00003`000ol0000e0003o`0000l000?o0000?`00054000?o00003`000ol000210003o`0000l0
00?o0000=@000ol0000?0003o`0003l0001B0003o`0000d000?o0000P`000ol0000=0003o`0003L0
00?o00003@000ol000100000DP000ol0000=0003o`0008<000?o00003@000ol0000g0003o`0000d0
00?o0000@00005<000?o00002`000ol000250003o`0000/000?o0000>@000ol0000;0003o`000440
001C0003o`0000/000?o0000Q@000ol0000;0003o`0003T000?o00002`000ol000110000E0000ol0
00090003o`0008L000?o00002@000ol0000k0003o`0000T000?o0000@P0005@000?o00002@000ol0
00270003o`0000T000?o0000>`000ol000090003o`000480001E0003o`0000L000?o0000R@000ol0
00070003o`0003d000?o00001`000ol000130000E@000ol000070003o`0008T000?o00001`000ol0
000m0003o`0000L000?o0000@`0005H000?o00001@000ol0002;0003o`0000D000?o0000?`000ol0
00050003o`0004@0001F0003ol_;00C;00<0o`00S0000oo;b`04b`030?l0040000?o0</01L/00ol0
00140000E@0:bh`02/]100[;A@0005@03<^:00c;?`0<bd@0001C00k;R00>bcd03/]30000DP06b`?o
1l^6013;>`05b`?o2<]20000DP09b`03ol_;00C;QP0@bc/02</00oo;b`05bd80000<00Go@007b`Co
1l]000Co@007b`;o00?;ool01//i00K;1?l8bd40000<0004o`00od401//01Oo;bl_o00O;?`000ol0
001200O;00Cobl_o1l/i00G;00Gobl_;o`08bd40000<00Co@@06b`05ol_;bol01l/o0003o`000480
1l/01?o;bol7bcT01L/01Oo;bl_o00S;@@0000l000?o0000?`06b`05ol_;bol01l/o0005o`000?l0
@007b`04ol_;o`O;>@05b`05ol_;bol02<]100003004od401l/5o`K;@004od001l/4o`O;>@06b`Go
1l]100006002ocL04/^400O;00?obl/02</h0003ol_;013;@@0001X00_lf013;QP05b`;o2L/f00?o
0P0@bd80000L00?o<`0@b`03o`0008<04</c00?o1@0@bd80000O00?o<@0>b`8000?o0000P@000ol0
b`0=bc400ol900k;@`0002800_l`00c;10000ol0001o0004o`0000c;<002o`d03<]400009003obh0
2//600;oO@02o`D02//^00?o400:bdD0000W00?o;@06b`X000?o0000N@000ol0000700K;;@03oaD0
1/]70000:P03oc/000?o0000>P000ol0000j0003o`0003T00_mU0000;@02ocX00_lj0003o`0003P0
0_li00?oI`0002l00oli0003o`0003L000?o0000=`000ol0000f00?oJP0003800olg0003o`0003H0
00?o0000=P000ol0000d00?oK@0003D00ole00;o=P000ol0000d00;o=@02og00000h00;o=@000ol0
000c0003o`0003<000?o0000<P03og80000j00?o<`02oc<000?o0000<@02oc800ome0000?@03oc80
00?o0000<0000ol0000`0003o`0003000_mh0000@002oc4000?o0000;`000ol0000_0003o`0002h0
0omj0000@P03obl00_l_0003o`0002d00_l^00?oO@0004D00ol^0003o`0002`000?o0000;0000ol0
000[00?oP00004P00ol/0003o`0002/000?o0000:`000ol0000Z00;oP`0004/00_l[00;o:`000ol0
000Y00;o:P03ohD0001=00?o:P000ol0000X0003o`0002P000?o00009`03ohP0001@00?o:0000ol0
000W0003o`0002L000?o00009P02oh/0001C00?o9P02obL000?o00009@02obH00on=0000EP02obH0
00?o000090000ol0000T0003o`0002<00on@0000F003ob@00_lT0003o`0002800_lS00?oT`0005/0
0olS0003o`00024000?o00008@000ol0000Q00;oUP0005h00_lR0003o`00020000?o000080000ol0
000O00?oV00006000olP00;o80000ol0000N00;o7`03oi/0001S00?o7`000ol0000M0003o`0001d0
00?o00007@02oih0001V00?o7@000ol0000L0003o`0001`000?o00006`03oj00001Y00;o7002oa`0
00?o00006P02oa/00onS0000J`03oa/000?o00006@000ol0000I0003o`0001T00_nV0000KP03oaT0
00?o000060000ol0000H0003o`0001L00onX0000L@03oaL00_lH0003o`0001H00_lG00?oZ`0007@0
0_lG0003o`0001D000?o00005@000ol0000D00?o[P0007H00olE00;o5@000ol0000C00;o5@02ok40
001i00?o50000ol0000B0003o`00018000?o00004P03ok<0001l00;o4`000ol0000A0003o`000140
00?o00004003okH0001n00?o4@02oa4000?o00003`02oa400_ni0000P@03oa0000?o00003P000ol0
000>0003o`0000h00onk0000Q003o`h000?o00003@000ol0000=0003o`0000`00onn0000Q`02o`d0
0_l=0003o`0000/00_l<00?o`@0008T00ol<0003o`0000X000?o00002P000ol0000:00;oa00008`0
0ol:0003o`0000T000?o00002@000ol0000800?oaP0008l00ol800;o2@000ol0000700;o2003olT0
002B00;o20000ol0000300K;1P000ol0000600;oc00009@00ol600;o00<0bl/02</200;o1P03olh0
002G00?o1@0<b`03o`0000<00ooA0000VP02o`803//200?oe00009`000?obl/03//00ol0003E0000
W@06b`Co1/_H0000W008b`03ol_;00O;e`0009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000
W007b`Co1l_G0000W008b`03ol_;00O;e`0009`02</3o`O;e`0009d04<_H0000W@0@bmP0002N00k;
f@0009l03<_J0000X00:bm/00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"GP-Mutation - mutant 9"],

Cell[TextData[{
  "Mutant 9: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"GP-Mutation - mutant 10",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.588604 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .36461 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .32576 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .40228 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .4788 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .40228 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .36343 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .43995 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .51647 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .43995 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .40228 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .41509 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .49043 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .45276 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .50325 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .56654 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .5271 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .75665 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .64188 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .60421 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .65469 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .70518 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .55373 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .4856 L
s
.42348 .60332 m
.22364 .4856 L
s
.42348 .60332 m
.42348 .4856 L
s
.42348 .60332 m
.62332 .4856 L
s
.42348 .60332 m
.82315 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .4856 0 0 Mshowa
P
.004 w
.22364 .4856 m
.15406 .36788 L
s
.22364 .4856 m
.29323 .36788 L
s
1 g
.05 w
.15406 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .36788 0 0 Mshowa
P
1 g
.29323 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .36788 0 0 Mshowa
P
.9 g
.22364 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .4856 0 0 Mshowa
P
1 g
.42348 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .4856 0 0 Mshowa
P
.004 w
.62332 .4856 m
.55373 .36788 L
s
.62332 .4856 m
.6929 .36788 L
s
.55373 .36788 m
.40228 .25016 L
s
.55373 .36788 m
.45276 .25016 L
s
.55373 .36788 m
.50325 .25016 L
s
.55373 .36788 m
.55373 .25016 L
s
.55373 .36788 m
.60421 .25016 L
s
.55373 .36788 m
.65469 .25016 L
s
.55373 .36788 m
.70518 .25016 L
s
.40228 .25016 m
.36461 .13244 L
s
.40228 .25016 m
.40228 .13244 L
s
.40228 .25016 m
.43995 .13244 L
s
1 g
.05 w
.36461 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .36461 .13244 0 0 Mshowa
P
.004 w
.40228 .13244 m
.32576 .01472 L
s
.40228 .13244 m
.40228 .01472 L
s
.40228 .13244 m
.4788 .01472 L
s
1 g
.05 w
.32576 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .32576 .01472 0 0 Mshowa
P
1 g
.40228 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .40228 .01472 0 0 Mshowa
P
1 g
.4788 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .4788 .01472 0 0 Mshowa
P
.9 g
.40228 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .40228 .13244 0 0 Mshowa
P
.004 w
.43995 .13244 m
.36343 .01472 L
s
.43995 .13244 m
.43995 .01472 L
s
.43995 .13244 m
.51647 .01472 L
s
1 g
.05 w
.36343 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .36343 .01472 0 0 Mshowa
P
1 g
.43995 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .43995 .01472 0 0 Mshowa
P
1 g
.51647 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .51647 .01472 0 0 Mshowa
P
.9 g
.43995 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .43995 .13244 0 0 Mshowa
P
.9 g
.40228 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .40228 .25016 0 0 Mshowa
P
.004 w
.45276 .25016 m
.41509 .13244 L
s
.45276 .25016 m
.49043 .13244 L
s
1 g
.05 w
.41509 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .41509 .13244 0 0 Mshowa
P
1 g
.49043 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .49043 .13244 0 0 Mshowa
P
.9 g
.45276 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .45276 .25016 0 0 Mshowa
P
1 g
.50325 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .50325 .25016 0 0 Mshowa
P
1 g
.55373 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .25016 0 0 Mshowa
P
.004 w
.60421 .25016 m
.56654 .13244 L
s
.60421 .25016 m
.64188 .13244 L
s
1 g
.05 w
.56654 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .56654 .13244 0 0 Mshowa
P
.004 w
.64188 .13244 m
.5271 .01472 L
s
.64188 .13244 m
.75665 .01472 L
s
1 g
.05 w
.5271 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .5271 .01472 0 0 Mshowa
P
1 g
.75665 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .75665 .01472 0 0 Mshowa
P
.9 g
.64188 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .64188 .13244 0 0 Mshowa
P
.9 g
.60421 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .60421 .25016 0 0 Mshowa
P
1 g
.65469 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .65469 .25016 0 0 Mshowa
P
1 g
.70518 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .70518 .25016 0 0 Mshowa
P
.9 g
.55373 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .55373 .36788 0 0 Mshowa
P
.004 w
.6929 .36788 m
.54145 .25016 L
s
.6929 .36788 m
.84435 .25016 L
s
1 g
.05 w
.54145 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .25016 0 0 Mshowa
P
.004 w
.84435 .25016 m
.71251 .13244 L
s
.84435 .25016 m
.97619 .13244 L
s
1 g
.05 w
.71251 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .13244 0 0 Mshowa
P
1 g
.97619 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .13244 0 0 Mshowa
P
.9 g
.84435 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .25016 0 0 Mshowa
P
.9 g
.6929 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .36788 0 0 Mshowa
P
.9 g
.62332 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .4856 0 0 Mshowa
P
1 g
.82315 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .4856 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP0007d01Ol:00Co2`04o`X01?l<00?o3P04oe801?mQ0000O@001?l0
0?l:0003o`0000`000?o00002`000ol0000?0003o`0000d000Go0000o`1B0003o`000640001m00Co
2P000ol0000<0003o`0000/01Ol=0003o`0000d000Go0000o`1C0003o`00060000200003o`0000P0
00Go0000o`0:0005o`000?l02@001Ol0003o00d000?o00003@001Ol0003o05@000?o0000G`0007d0
1?l;00Co2`04o`X00ol>0003o`0000d01?mE0003o`0005l0002i00;o3`000ol0001C00?oHP000<T0
0_nj0000o`260000o`260000dP000ol0002`0000Q@000ol0001;0003o`0004D000?o0000I`0008H0
00?o00002`000ol0000M0003o`0000/000?o00003`000ol000130003o`0006P000260003o`0000/0
00?o00001P000ol0000;0003o`0000H000?o00002`000ol0000@0003o`00044000?o0000J@0008L0
00?o00002`000ol000050003o`0000/000?o00001@000ol0000;0003o`00018000?o0000?`000ol0
001Z0000R0000ol0000;0003o`0000@000?o00002`000ol000040003o`0000/000?o000050000ol0
000m0003o`0006/000280003o`0000/000?o000010000ol0000;0003o`0000@000?o00002`000ol0
000E0003o`0003/000?o0000K00008T000?o00002`000ol000030003o`0000/000?o00000`000ol0
000;0003o`0001L000?o0000>@000ol0001]0000RP000ol0000;0003o`00008000?o00002`000ol0
00020003o`0000/000?o00006@000ol0000g0003o`0006h0002:0003o`0000/000?o00000P000ol0
000;0003o`00008000?o00002`000ol0000J0003o`0003D000?o0000K`0008/000?o00002`001Ol0
003o00d000Go0000o`0=0003o`0001`000?o0000<`000ol0001`0000S0000ol0000;0004o`00o`d0
00Co003o3@000ol0000N0003o`00034000?o0000L@0008`000?o00002`001?l00?l=0004o`00o`d0
00?o00007`000ol0000_0003o`000780002=0003o`0000/000?o0?l03@000ol0o`0=0003o`000240
00?o0000;@000ol0001c0000SP000ol0000;00;o3@02o`d000?o00008`000ol0000[0003o`0007@0
002>0003o`0000/00_l=00;o3@000ol0000T0003o`0002T000?o0000M@0008l000?o00002`000ol0
000;0003o`0000/000?o00009P000ol0000W0003o`0007H0002?0003o`0000/000?o00002`000ol0
000;0003o`0002L000?o00009@000ol0001g0000T0000ol0000:00;o2`02o``000?o0000:@000ol0
000S0003o`0007P0002A0003o`0000T000?o0?l02@000ol0o`0;0003o`0002/000?o00008@000ol0
001i0000T@000ol000090003o`3o00T000?o0?l02`000ol0000/0003o`0001l000?o0000NP000980
00?o000020001?l00?l70004o`00o`X000?o0000;P000ol0000M0003o`0007/0002C0003o`0000L0
00Go0000o`050005o`000?l02@000ol0000`0003o`0001/000?o0000O00009<000?o00001`001Ol0
003o00D000Go0000o`090003o`00034000?o00006@000ol0001m0000U0000ol000060003o`000080
00Go0000o`040003o`0000H000?o0000<`000ol0000G0003o`0007h0002E0003o`0000D000?o0000
0`000ol0o`050003o`0000D000?o0000=@000ol0000E0003o`0007l0002E0003o`0000D000?o0000
0`000ol0o`050003o`0000D000?o0000=P000ol0000C0003o`000800002F0003o`0000@000?o0000
10000ol000040003o`0000@000?o0000>0000ol0000A0003o`000840002G0003o`0000<000?o0000
0`000ol0o`050003o`0000<000?o0000>P000ol0000?0003o`000880002G0003o`0000G;1P000ol0
0006b`<000?o0000>`000ol0000200K;1@000ol000230000V005b`X02L/00ol0000m0003o`3;00W;
0P000ol000240000U`05b``02L]000c;00?o0000Q@0009H01L/>00W;?P0>bhL0002E00G;4002o`O;
?006b`?o1l^60000U@05ba000//00oo;b`04bc`02L/00oo;b`04bhH0002=00?o1005b`L01?l700;o
1l/800?o6@03oa<01l/4o`O;3`04of400ol>0000T0001?l00005b`H000?o00002@000l_ob`06b`/0
00?o00006@000ol0000@00K;00Gobl_;o`07b`l000Go0000o`1Q0003o`0000d0002@0004o`0000G;
1P000ol000090003boo;00K;2`000ol0000I0003o`0001001//01Oo;bl_o00O;3`001Ol0003o05h0
1Ol>0000S@03o`@01L/60005o`000?l01`000l_ob`06b`P00olI00?o4`06b`05ol_;bol01l/?0005
o`000?l0G`000ol0o`0?0000S@000ol0000400G;1`04o`L00ol6b`P000?o00006@000ol0000C00O;
1Ol6b`l01?mP0003o`3o00l0002=00Co0`05ba802L/800Co6004oa804//?0003o`0006800_l?0000
U@05ba002L/l013;3`02ogD0002E00G;4009bc`04<^60000UP05b`h02L/n00k;6P000ol0001Z0000
U`05b``02L]000c;70000ol0001?00;o600009P01L/:00W;@P0:bah000?o0000C@000ol0000H0000
TP000ol0000500G;1P000ol00006bdH01//Q00;oC0000ol0000I0000TP000ol000080003o`0000D0
00Co003o4P000ol0000O0003o`0001@000?o00009P000ol000180003o`0001X0002B0003o`0000P0
00?o00001@001?l00?lB0003o`00020000?o00004`000ol0000W0003o`0004H000?o00006`0009<0
00?o00001`000ol0000600;o4P000ol0000Q0003o`00018000?o0000:@000ol000140003o`0001`0
002C0003o`0000L000?o00001P02oa8000?o00008@000ol0000B0003o`0002X000?o0000@P000ol0
000M0000T`000ol000070003o`0000H00_lB0003o`00028000?o00004@000ol0000[0003o`000400
00?o00007P0009@000?o00001P000ol0000600;o4@000ol0000S0003o`00010000?o0000;@000ol0
000m00;o8@0009@000?o00001P000ol0000600;o4@000ol0000S0003o`00010000?o0000;P000ol0
000k0003o`000240002D0003o`0000H000?o00001P02oa4000?o000090000ol0000?0003o`0002l0
00?o0000>@000ol0000R0000U@000ol000050003o`0000D000Co003o3`000ol0000U0003o`0000h0
00?o0000<@02ocP000?o00008`0009D000?o00001@000ol000050004o`00o`l000?o00009@000ol0
000>0003o`0003<000?o0000=0000ol0000T0000U@000ol000050003o`0000D000Co003o3`000ol0
000V0003o`0000d000?o0000=0000ol0000b0003o`0002D0002F0003o`0000@000?o000010000ol0
00020003o`0000/000?o00009`000ol0000<0003o`0003H000?o0000<0000ol0000V0000UP000ol0
00040003o`0000@000?o00000P000ol0000;0003o`0002L000?o000030000ol0000g0003o`0002d0
0_lY0000UP000ol000040003o`0000@000?o00000P000ol0000;0003o`0002P000?o00002`000ol0
000h0003o`0002/000?o0000:@0009H000?o000010000ol000040003o`00008000?o00002`000ol0
000X0003o`0000/000?o0000>@000ol0000Y0003o`0002X0002G0003o`0000<000?o00000`000ol0
00040003o`0000T000?o0000:@000ol0000:0003o`0003/000?o00009`000ol0000[0000U`000ol0
00030003o`0000<000?o000010000ol000090003o`0002X000?o00002@000ol0000l00;o9P000ol0
000/0000U`000ol000030003o`0000<000?o000010000ol000090003o`0002X000?o00002@000ol0
000n0003o`00028000?o0000;@0009P000?o00000P000ol000020003o`0000H000?o00001`000ol0
000[0003o`0000P000?o0000@0000ol0000P0003o`0002h0002H0003o`00008000?o00000P000ol0
00060003o`0000L000?o0000;0000ol000070003o`00044000?o00007@02oc40002H0003o`000080
00?o00000P000ol000060003o`0000L000?o0000;0000ol000070003o`00048000?o00006`000ol0
000a0000V@001Ol0003o00<000?o000020000ol000050003o`0002d000?o00001P000ol000140003
o`0001T000?o0000<P0009T000Go0000o`030003o`0000P000?o00001@000ol0000^0003o`0000D0
00?o0000A@000ol0000G0003o`0003<0002I0005o`000?l00`000ol000080003o`0000D000?o0000
;P000ol000050003o`0004H000?o00005@000ol0000d0000VP001?l00?l20003o`0000X000?o0000
0`000ol0000_0003o`0000@000?o0000B0000ol0000C0003o`0003D0002J0004o`00o`8000?o0000
2P000ol000030003o`00030000?o00000`000ol0001900;o4P000ol0000f0000VP06b`03o`0000X0
1//00ol0000`00K;00?o0000B`000ol0000300K;1@000ol0000g0000V00:b`T02//_00[;C@000ol0
000:b`030?oo03X0002G00c;1`0<bbd03<]=0003ol_;00[;?00009H03//500k;:`0>bd`03//k0000
U@0@b`<01//3o`O;:@0@bdX01L/3o`S;>P0009D04</300W;00?obl/01</Y013;BP08b`03ol_;00G;
>P0009@01l/2o`03booo00K;00<0bl/01L/4o`O;2004o`X01?l=00O;0_l00l_oo`06b`P00ol?00?o
:`06b`Co2</i0000U007b`04ol_;o`O;00<0bl/01</01Oo;bl_o00O;20001Ol0003o00P000?o0000
3`07b`04ol_;o`O;2@000ol0000A0003o`0002P01L/01Oo;bl_o00S;>@0009@01l/01?o;bol7b`03
0<_;00C;00Gobl_;o`07b`P000Go0000o`080003o`0000l01l/01?o;bol7b`T000?o00004@000ol0
000X00G;00Gobl_;o`08bcT0002D00O;00Cobl_o1l/00`3;b`04b`05ol_;bol01l/80005o`000?l0
20001Ol0003o00d01l/01?o;bol7b`T000?o00003P03ob/01L/01Oo;bl_o00S;>@0009@01l/4o`O;
00<0bl/01L/5o`K;2004o`X01?l=00O;1?l7b`T000?o00003P000ol0000[00K;1Ol7bcT0002D00O;
00?obl/02</00`3;b`0@b`P000?o00007007b`03ol_;00S;2002oa001?lZ01;;>@0009D01L/2o`W;
0`0@b`P00_lO00G;0_l9bdX04</j0000U@0@b`<04</Y013;BP0@bcX0002F00k;00<0o`000P0>bb80
00?o00001P0>baH000?o0000<@000ol0b`0=bc/0002G00c;0`02o`803</00ol0000Q00;o1`0<baD0
0_lb00;o0`0<bc`0002H00[;1P000ol0000:b`030?l002@000?o00001@0:b`L000?o00002`000ol0
000a0003o`0000@02//m0000VP06b`T000Co00001//40003o`0000d000?o00004`000ol000050003
ol_;00C;20000ol0000;0003o`00034000?o00001`06bcl0002Z00;o30000ol0000<0003o`0000`0
00?o00001@02o`D000?o00002`000ol0000;0003o`00034000?o0000C@000:`000?o00002P000ol0
000<0003o`0000/000?o00001`001Ol0003o00d000?o00002P02oc800_m@0000[@000ol0000:0003
o`0000/000?o00002`000ol000080004o`00o``000?o00002P000ol0000a0003o`000500002^0003
o`0000X000?o00002P000ol0000;0003o`0000T000?o0?l02`000ol0000:0003o`00034000?o0000
D@000:l00_l;0003o`0000X000?o00002P000ol0000:00;o2`000ol000090003o`00034000?o0000
DP000;4000?o00002@000ol000090003o`0000X000?o00002P000ol0o`090003o`0000P00_lb00;o
E@000;8000?o000020000ol0000:0003o`0000T000?o00002@001Ol0003o00L000?o000020000ol0
000a0003o`0005D0002c00;o2@000ol000090003o`0000T000?o00002@000ol0000200;o10000ol0
00080003o`00034000?o0000EP000;D000?o00001`000ol000090003o`0000P000?o000020000ol0
00050004o`00o`T00_lb00;oF@000;H000?o00001`000ol000080003o`0000P000?o000020000ol0
000600;o2@000ol0000a0003o`0005T0002g00;o20000ol000070003o`0000P000?o000020000ol0
000700;o1`000ol0000a0003o`0005X0002i0003o`0000H000?o00001`000ol000070003o`0000L0
00?o00001`001?l00?l50003o`00034000?o0000F`000;X000?o00001P000ol000060003o`0000L0
00?o00001`000ol000060003o`00008000?o00000_lb00;oGP000;/000?o00001@000ol000070003
o`0000H000?o00001P000ol000060003o`0000@00_lc0003o`0005h0002l00;o1P000ol000060003
o`0000H000?o00001P000ol000050003o`0000D00ola0003o`0005l0002n0003o`0000@000?o0000
1P000ol000050003o`0000D000?o00001@000ol000050005o`000?l0;`000ol0001P0000_`000ol0
00040003o`0000D000?o00001@000ol000050003o`0000D000?o00000`02o`D000?o0000:P02of<0
003000;o1@000ol000040003o`0000D000?o00001@000ol000040003o`0000<000?o00001P02obT0
00?o0000H`000<8000?o00000`000ol000040003o`0000@000?o000010000ol000040003o`0000<0
00?o00002@000ol0000U0003o`0006@000330003o`0000<000?o00000`000ol000040003o`0000@0
00?o00000`000ol0000200;o3@000ol0000R00;oI`000<@00_l30003o`0000@000?o00000`000ol0
00030003o`0000<000?o00000P000ol0000>00;o8@000ol0001W0000aP001Ol0003o00D000?o0000
0`000ol000030003o`00008000?o00000P000ol0000A0003o`0001d000?o0000J0000<L000Go0000
o`050003o`00008000?o00000P000ol000030005o`000?l05@000ol0000K0003o`0006T000380005
o`000?l010000ol000020003o`00008000?o00000P000ol00002oaL000?o00006002of`0003900;o
0P001Ol0003o00@000?o00000P001Ol0003o008000?o00006002oaL000?o0000K0000</000Co003o
0`001Ol0003o00<000Go0000o`020003o`0001/000?o00004`000ol0001]0000c0001?l00?l20003
ol_;00C;00D0o`00o`020003o`0001d000?o00001006b`L000?o0000KP000<d00_l00`3ob`09b`03
0?l000;o8@02o`802//300;oL@000<l000?obl/02//00`3o000T0003ol_;00[;00<0o`00LP000<l0
3//V00k;M0000<h04</T00K;0ol7bg<0003>013;9009b`03ol_;00C;L`0003h01?l`00?oF007b`Co
1l/R00O;1?l7bg80000n0005o`000?l0<P000ol0001E00S;00?obl/01l/R00K;00Gobl_;o`07bg80
000n0005o`000?l0<P000ol0001E00S;00?obl/01l/R00K;00Gobl_;o`07bg80000n0005o`000?l0
<002oeP02</00oo;b`07bb801//01Oo;bl_o00O;LP0003h01?lc0003o`0005D01l/4o`O;8P07b`Go
1/]b0000?P000ol0000a00?oF008b`03ol_;00O;8P0Bbg80000m00;oS`07b`?o1//T013;L`000<h0
4</T013;L`000<l03//V00k;M0000=003</X00c;M@000=402//Z00[;MP0004D000?o00009`000ol0
001Q00K;0P000ol0000W0003o`3;00G;N00004H000?o00009@000ol0001[0003o`0002D000?o0000
OP0004H000?o00009@000ol0001[0003o`0002D000?o0000OP0004L000?o00008`000ol0001]0003
o`0002<000?o0000O`0004L000?o00008`000ol0001]0003o`0002<000?o0000O`0004P000?o0000
8@000ol0001_0003o`00024000?o0000P00004T000?o00007`000ol0001a0003o`0001l000?o0000
P@0004T000?o00007`000ol0001a0003o`0001l000?o0000P@0004X000?o00007@000ol0001c0003
o`0001d000?o0000PP0004X000?o00007@000ol0001c0003o`0001d000?o0000PP0004/000?o0000
6`000ol0001e0003o`0001/000?o0000P`0004`000?o00006@000ol0001g0003o`0001T000?o0000
Q00004`000?o00006@000ol0001g0003o`0001T000?o0000Q00004d000?o00005`000ol0001i0003
o`0001L000?o0000Q@0004d000?o00005`000ol0001i0003o`0001L000?o0000Q@0004h000?o0000
5@000ol0001k0003o`0001D000?o0000QP0004h000?o00005@000ol0001k0003o`0001D000?o0000
QP0004l000?o00004`000ol0001m0003o`0001<000?o0000Q`00050000?o00004@000ol0001o0003
o`00014000?o0000R000050000?o00004@000ol0001o0003o`00014000?o0000R000054000?o0000
3`000ol000210003o`0000l000?o0000R@00054000?o00003`000ol000210003o`0000l000?o0000
R@00058000?o00003@000ol000230003o`0000d000?o0000RP0005<000?o00002`000ol000250003
o`0000/000?o0000R`0005<000?o00002`000ol000250003o`0000/000?o0000R`0005@000?o0000
2@000ol000270003o`0000T000?o0000S00005@000?o00002@000ol000270003o`0000T000?o0000
S00005D000?o0</01L/20003o`0008T000?o0</01L/20003o`0008d0001E00[;S00:bi00001D00c;
RP0<bhl0001C00k;R00>bhh0001B00K;0ol7bhH04<^=0000DP09b`03ol_;00C;QP0@bhd0000<00Go
@007b`Co1l]000Co@007b`;o00?;ool01//o00CoB@0000`000Co003o@@06b`05ol_;bol01l/o0003
o`0004801l/01?o;bol7bd0000?o0000B@0000`01?m100K;00Gobl_;o`07bcl000?o0000@P07b`04
ol_;o`O;@@000ol0001800003`000ol0000o00K;00Gobl_;o`07bcl000Go0000o`1000O;00Cobl_o
1l]20003o`0004L0000<00Co20000ol0000f00O;1Ol6bd001?m000O;1?l7bd8000?o0000A`0001T0
0ole01;;Q007b`03ol_;00S;=@04o`H00om:00007003oc<04</00ol0002300G;0_l9bc<00omG0000
7`04obl04</00`3o00220003ol_;00k;;`04oeX0000S00?o;@0>b`<00_mo00;o0P0>bbd00omN0000
9P04obX03</600;oN`02o`D03</[00?oH@0002X00olX00[;2@000ol0001g0003o`0000H02//X00Co
I00002d00olW00K;3002ogD00_l;00K;9`03ofP0000`00Co=`02ocP000?o0000=P02ocH01?m[0000
=003ocH00_lf0003o`0003@00_le00?oK`0003L01?ld0003o`0003<000?o0000<`000ol0000b00?o
LP0003/00olb00;o<`000ol0000a00;o<@04ogD0000n00?o<@02oc4000?o0000;`02oc000omi0000
@@04obl000?o0000;P000ol0000^0003o`0002d00oml0000A@03obd00_l^0003o`0002`00_l/00Co
O`0004P01?l[00;o;0000ol0000Z00;o:`03oh<0001<00?o:P02obX000?o0000:002obT01?n60000
C`03obT000?o00009`000ol0000W0003o`0002H00on:0000DP04obH00_lW0003o`0002D00_lV00?o
S@0005H00olU00;o9@000ol0000S00;o9004oi00001I00Co8`000ol0000R0003o`00028000?o0000
8@03oi@0001M00?o8@02ob8000?o00008002ob001?nG0000H004oal00_lP0003o`0001h00_lO00?o
V`0006@00olN0003o`0001d000?o00007@000ol0000L00?oWP0006L00olL00;o7@000ol0000K00;o
6`04oj40001Z00Co6P02oa/000?o00006@02oaX00onU0000KP03oaT00_lI0003o`0001L00_lH00Co
Z00007401?lG0003o`0001H000?o00005P000ol0000E00?o[00007D00olE00;o5P000ol0000D00;o
5@03ojl0001h00?o5002oa@000?o00004P02oa<01?nb0000N`04oa8000?o00004@000ol0000A0003
o`0001000onf0000O`03oa000_lA0003o`0000l00_l@00?o^@0008801?l>00;o3`000ol0000=00;o
3P04ok`0002600?o3@02o`d000?o00002`02o`d00oo00000R@03o``000?o00002P000ol0000:0003
o`0000T01?o30000S004o`T00_l700K;2002o`T00oo70000T003o`P00_l300[;1002o`P00oo:0000
T`04o`H000?o0</02l/20003o`0000@01?o=0000U`03o`@03//00ol0000200?od@0009X00ol@b`Co
e00009d01//4o`K;f00009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000W008b`03ol_;00O;
e`0009`01l/4o`O;e`0009`02</00oo;b`07bmL0002L00S;0ol7bmL0002M013;f00009d04<_H0000
WP0>bmT0002O00c;fP000:002/_K0000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -1.04247, 0.013371, 
  0.00453954}},
  CellTags->"GP-Mutation - mutant 10"],

Cell[TextData[{
  "Mutant 10: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"GP-Mutation - mutant 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selective mutations", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["The basic expression", "Subsubsection"],

Cell["\<\
theChromos = 
pop[chromo[q[undef], 
  p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]]];\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Mshowa
P
1 g
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.44709 .16187 L
s
.62346 .30902 m
.79982 .16187 L
s
1 g
.05 w
.44709 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Mshowa
P
.004 w
.79982 .16187 m
.62346 .01472 L
s
.79982 .16187 m
.97619 .01472 L
s
1 g
.05 w
.62346 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.79982 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Mshowa
P
.9 g
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000>h01?n200?o3P000>h000Go0000o`220003o`0000d0003^0005
o`000?l0O`05o`h0003^0005o`000?l0P0000ol0o`0?0000kP04oh4000?o0?l03`000>h000?o0000
P`02o`l0003]00;oUP000?l0QP000?P000?o0000L@000ol0000F0000n@000ol0001_0003o`0001L0
003j0003o`0006d000?o000060000?/000?o0000J`000ol0000I0000o002ofT00_lL0000oP000ol0
001U0003o`0001`0003o0003o`0006<000?o00007@000?l00@000ol0001Q0003o`0001h0003o0080
00?o0000G`000ol0000O0000o`0300;oG@02ob80003o00D000?o0000F@000ol0000R0000o`060003
o`0005L000?o00008`000?l01`000ol0001E0003o`0002@0003o00P000?o0000D`000ol0000U0000
o`0900;oD@02obP0003o00/000?o0000C@000ol0000X0000o`0<0003o`0004/000?o0000:@000?l0
3@000ol000190003o`0002X0003o00h000?o0000A`000ol0000[0000o`0?00;oA@02obh0003o0140
00?o0000@@000ol0000^0000o`0B0003o`0003l000?o0000;`000?l04`000ol0000m0003o`000300
003o01@000?o0000>`000ol0000a0000o`0E00;o>@02oc@0003o01L000?o0000=@000ol0000d0000
o`0H0003o`0003<000?o0000=@000?l06@000ol0000a0003o`0003H0003o01X000?o0000;`000ol0
000g0000o`0K00;o;@02ocX0003o01d000?o0000:@000ol0000j0000o`0N0003o`0002L000?o0000
>`000?l07`000ol0000U0003o`0003`0003o020000?o00008`000ol0000m0000o`0Q00;o8@02od00
003o02<000?o00007@000ol000100000o`0T0003o`0001/000?o0000@@000?l09@000ol0000I0003
o`000480003o02H000?o00005`000ol000130000o`0W00;o5@02odH0003o02T000?o00004@000ol0
00160000o`0Z0003o`0000<01//60003o`0004L0003o02/000?o00002//30003o`0004P0003o02`0
00?obl/02//00`3o001:0000o`0/00k;C0000?l0:`06b`?o1l];0000o`0[00W;00?obl/01<];0000
[004ogT01l/4o`O;BP000:/000?o0000N`06b`05ol_;bol01l]:0000Z`000ol0001k00K;00Gobl_;
o`07bdX0002[0005o`000?l0N@06b`05ol_;bol01l]:0000[004ogT01l/5o`K;BP000?l0:P0BbdX0
003o02/04<];0000o`0[013;B`000;H000?o0000L@000oo;b`0<bd`0002g0003o`0006l000?o0000
3<]=0000^0000ol0001]0003o`0000802/]>0000^@000ol0001[0003o`0000D01/]@0000^P02ofT0
0_mN0000_0000ol0001U0003o`0005h0002m0003o`0006<000?o0000G`000;h000?o0000H@000ol0
001P0000_`000ol0001O0003o`000640003000;oG@02of@000320003o`0005T000?o0000I0000<<0
00?o0000E`000ol0001U0000a0000ol0001E0003o`0006H000350003o`0005<000?o0000I`000<H0
0_mA00;oJP000<P000?o0000C@000ol0001Z0000b@000ol0001;0003o`0006/0003:0003o`0004T0
00?o0000K0000</000?o0000A`000ol0001]0000c002odD00_m`0000cP000ol000110003o`000700
003?0003o`0003l000?o0000L@000=0000?o0000?@000ol0001b0000d@000ol0000k0003o`0007<0
003B00;o>@02ogH0003D0003o`0003D000?o0000MP000=D000?o0000<`000ol0001g0000eP000ol0
000a0003o`0007P0003G0003o`0002l000?o0000N@000=P00_l]00;oO0000=X000?o0000:@000ol0
001l0000f`000ol0000W0003o`0007d0003L0003o`0002D000?o0000OP000=d000?o00008`000ol0
001o0000gP02ob400_n20000h0000ol0000M0003o`000880003Q0003o`0001/000?o0000P`000>80
00?o00006@000ol000240000h`000ol0000G0003o`0008D0003T00;o5@02ohP0003V0003o`000140
00?o0000R0000>L000?o00000`06b`H000?o0000R@000>P000?o00002//30003o`0008X0003Y0003
ol_;00[;00<0o`00S0000>T03/^>0000j006b`?o1l^=0000j009b`03ol_;00C;S@0003D01?la00?o
C004obX01l/4o`O;S00003D000Go0000o`0c0003o`0004P000?o0000;006b`05ol_;bol01l^<0000
=@001Ol0003o03<000?o0000B005obX01//01Oo;bl_o00O;S00003D000Go0000o`0a00;oB`001Ol0
003o02X01//01Oo;bl_o00O;S00003D01?ld0003o`0004T00ol[00O;1Ol6bh`0000e0003o`000380
0omj01;;S00003@00_nb013;S@000>P04<^=0000j@0>bhh0003Z00c;S`000>/02/^@0000>`000ol0
000Z0003o`0005@000?o0000:P000oo;b`04bi80000k0003o`0002T000?o0000E@000ol0000Y0003
o`0009L0000l0003o`0002P000?o0000EP000ol0000X0003o`0009L0000l0003o`0002L000?o0000
E`000ol0000W0003o`0009P0000m0003o`0002H000?o0000F0000ol0000V0003o`0009P0000m0003
o`0002D000?o0000F@000ol0000U0003o`0009T0000n0003o`0002@000?o0000FP000ol0000T0003
o`0009T0000n0003o`0002<000?o0000F`000ol0000S0003o`0009X0000o0003o`00028000?o0000
G0000ol0000R0003o`0009X0000o0003o`00024000?o0000G@000ol0000Q0003o`0009/000100003
o`00020000?o0000GP000ol0000P0003o`0009/000100003o`0001l000?o0000G`000ol0000O0003
o`0009`000110003o`0001h000?o0000H0000ol0000N0003o`0009`000110003o`0001d000?o0000
H@000ol0000M0003o`0009d000120003o`0001`000?o0000HP000ol0000L0003o`0009d000120003
o`0001/000?o0000H`000ol0000K0003o`0009h000130003o`0001X000?o0000I0000ol0000J0003
o`0009h000130003o`0001T000?o0000I@000ol0000I0003o`0009l000140003o`0001P000?o0000
IP000ol0000H0003o`0009l000140003o`0001L000?o0000I`000ol0000G0003o`000:0000140003
o`0001L000?o0000I`000ol0000G0003o`000:0000150003o`0001H000?o0000J0000ol0000F0003
o`000:0000150003o`0001D000?o0000J@000ol0000E0003o`000:4000160003o`0001@000?o0000
JP000ol0000D0003o`000:4000160003o`0001<000?o0000J`000ol0000C0003o`000:8000170003
o`00018000?o0000K0000ol0000B0003o`000:8000170003o`00014000?o0000K@000ol0000A0003
o`000:<000180003o`00010000?o0000KP000ol0000@0003o`000:<000180003o`0000l000?o0000
K`000ol0000?0003o`000:@000190003o`0000h000?o0000L0000ol0000>0003o`000:@000190003
o`0000d000?o0000L@000ol0000=0003o`000:D0001:0003o`0000`000?o0000LP000ol0000<0003
o`000:D0001:0003o`0000/000?o0000L`000ol0000;0003o`000:H0001;0003o`0000X000?o0000
M0000ol0000:0003o`000:H0001;0003o`0000T000?o0000M@000ol000090003o`000:L0001<0003
o`0000P000?o0000MP000ol000080003o`000:L0001<0003o`0000L000?o0000M`000ol000070003
o`000:P0001=0003o`0000H000?o0000N0000ol000060003o`000:P0001=0003ol_;00C;00<0o`00
NP000oo;b`04b`030?l00:X0001<00[;NP0:bj/0001;00c;N00<bjX0001:00k;MP0>bjT0001900K;
0ol7bg@04<^X0000B@09b`03ol_;00C;M00@bjP0000<00Go=`07b`Co1l/g00Co=`07b`;o00?;ool0
1//g00CoK00000`000Co003o>006b`05ol_;bol01l/f0003o`0003T01l/01?o;bol7bcP000?o0000
K00000`01?lh00K;00Gobl_;o`07bcH000?o0000>@07b`04ol_;o`O;>@000ol0001[00003`000ol0
000f00K;00Gobl_;o`07bcH000Go0000o`0g00O;00Cobl_o1l/j0003o`0006X0000<00Co>007b`Go
1//g00Co=`07b`Co1l/j0003o`0006X0001801;;LP07b`03ol_;00S;=`03ofd0000H00?o;P0@bg@0
1L/2o`W;;`03ogH0000K00;o;00@bg@04</]00;oN@0001d00olZ00k;00<0o`00LP000oo;b`0<bb/0
0omk00008002obT03</30003o`0006l000?o00003</Z00;oOP0002800_lX00[;1@000ol0001]0003
o`0000802//Y00;oP00002@00olW00K;20000ol0001[0003o`0000D01//X00?oPP0002L00_ld00;o
=0000ol0000b00;o=002ohD0000Y00?o<`000ol0000a0003o`00034000?o0000<@03ohL0000/00;o
<P000ol0000`0003o`00030000?o0000<002ohX0000^00;o<@000ol0000_0003o`0002l000?o0000
;`02oh`0000`00?o;`000ol0000^0003o`0002h000?o0000;@03ohh0000c00;o;P02obh000?o0000
;002obh00_nA0000=@03obd000?o0000:`000ol0000[0003o`0002/00onC0000>002ob`000?o0000
:P000ol0000Z0003o`0002X00_nF0000>P02ob/000?o0000:@000ol0000Y0003o`0002T00_nH0000
?003obT000?o0000:0000ol0000X0003o`0002L00onJ0000?`02obP00_lX0003o`0002H00_lX00;o
W@0004400olW0003o`0002D000?o00009@000ol0000U00?oW`0004@00_lV0003o`0002@000?o0000
90000ol0000T00;oXP0004H00_lU0003o`0002<000?o00008`000ol0000S00;oY00004P00olS0003
o`00028000?o00008P000ol0000Q00?oYP0004/00_lR00;o8P000ol0000P00;o8P02ojT0001=00?o
8@000ol0000O0003o`0001l000?o00007`03oj/0001@00;o80000ol0000N0003o`0001h000?o0000
7P02ojh0001B00;o7`000ol0000M0003o`0001d000?o00007@02ok00001D00?o7@000ol0000L0003
o`0001`000?o00006`03ok80001G00;o7002oa`000?o00006P02oa`00_ne0000F@03oa/000?o0000
6@000ol0000I0003o`0001T00ong0000G002oaX000?o000060000ol0000H0003o`0001P00_nj0000
GP02oaT000?o00005`000ol0000G0003o`0001L00_nl0000H003oaL000?o00005P000ol0000F0003
o`0001D00onn0000H`02oaH00_lF0003o`0001@00_lF00;o`@0006D00olE0003o`0001<000?o0000
4`000ol0000C00?o``0006P00_lD0003o`00018000?o00004P000ol0000B00;oaP0006X00_lC0003
o`00014000?o00004@000ol0000A00;ob00006`00olA0003o`00010000?o000040000ol0000?00?o
bP0006l00_l@00;o40000ol0000>00;o4002old0001a00?o3`000ol0000=0003o`0000d000?o0000
3@03oll0001d00;o3P000ol0000<0003o`0000`000?o00003002om80001f00;o3@000ol0000;0003
o`0000/000?o00002`02om@0001h00?o2`000ol0000:0003o`0000X000?o00002@03omH0001k00;o
2P02o`X000?o00002002o`X00_oI0000O@03o`T000?o00001`000ol000070003o`0000L00ooK0000
P002o`P000?o00001P000ol000060003o`0000H00_oN0000PP02o`L000?o00000P06b`D000?o0000
1@02on00002400?o1@000ol0b`09b`8000?o00000`03on80002700;o100<b`03o`0000800_oU0000
R@03o`k;00@0ooooi`0008/04<_Z0000R`06b`Co1/_Z0000RP08b`03ol_;00O;j@0008X02</00oo;
b`07bnT0002:00S;00?obl/01l_Y0000RP07b`Co1l_Y0000RP08b`03ol_;00O;j@0008X02</3o`O;
j@0008/04<_Z0000R`0@bnX0002<00k;j`0008d03<_/0000SP0:bnd00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.23914, -0.833976, 0.0151502, \
0.00363163}},
  CellTags->"Mutation - basic expression 2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["A set of mutated expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
According to the selection templates for subexpressions, only a \
restricted set of nodes is in the scope of the mutation operator.\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
mutChromos = Join @@ Table[
Mutation[theChromos, Templates -> {{{_h, \[Section] _g}, 3},
                                   {{_h},       1}},
                                   
         MaxDepth -> 6, SequenceRange -> {1,2},
         ExprPatterns -> patterns,
         SelectionMode -> RANDOM], {10}]
         
mutChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, e]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, d, 2]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, 5]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, 4]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, b, d]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, 3]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, e]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4, 2]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[5, g[a, 3], g[a, b]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[1, g[c, d]], 2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, e]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, d, 2]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, 5]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, 4]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, b, d]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, 3]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, e]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4, 2]]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[5, g[a, 3], g[a, b]], 2]]], 
 
  chromo[q[undef], p[f[a, g[b, 3], c, h[1, g[c, d]], 2]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, e]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, d, 2]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, 5]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, 4]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, b, d]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, 3]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, e]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4, 2]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[5, g[a, 3], g[a, b]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[1, g[c, d]], 2]]]\
\>", 
"\<\
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, e]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, d, 2]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, 5]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, 4]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, b, d]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[c, 3]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 3, e]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 4, 2]]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[5, g[a, 3], g[a, b]], 2]]]
chromo[q[undef], p[f[a, g[b, 3], c, h[1, g[c, d]], 2]]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ mutChromos;", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004oel01?l?0000o`0?0003o`00060000?o00004@000?l0
3`000ol0001P00Go3`000?l03`001Ol0003o05h000Go0000o`0?0000o`0@00CoG`03oa00003o08H0
003o08H0003o08H0003o08H0003o01P000?o0000J`000?l06@000ol0001B0003o`0001D0003o01X0
00?o0000D0000ol0000F0000o`0J0003o`0004l000?o00005`000?l06`000ol0001=0003o`0001P0
003o01`000?o0000C0000ol0000H0000o`0M0003o`0004X000?o00006@000?l07P000ol000180003
o`0001X0003o01l000?o0000AP000ol0000K0000o`0P0003o`0004@000?o000070000?l08@000ol0
00120003o`0001d0003o028000?o0000@0000ol0000N0000o`0R0003o`0003l000?o00007`000?l0
8`000ol0000m0003o`000200003o02@000?o0000>`000ol0000Q0000o`0U0003o`0003T000?o0000
8P000?l09P000ol0000h0003o`000280003o02L000?o0000=P000ol0000S0000o`0X0003o`0003@0
00?o000090000?l0:@000ol0000b0003o`0002D0003o02X000?o0000<0000ol0000V0000o`0[0003
o`0002h000?o00009`000?l0:`000ol0000]0003o`0002P0003o02`000?o0000:`000ol0000Y0000
o`0]0003o`0002T000?o0000:P000?l0;P000ol0000W0003o`0002/0003o02l000?o00009@000ol0
000/0000o`0`0003o`0002@000?o0000;0000?l0<@000ol0000R0003o`0002d0003o038000?o0000
80000ol0000^0000o`0c0003o`0001h000?o0000;`000?l0<`000ol0000M0003o`000300003o03@0
00?o00006`000ol0000a0000o`0e0003o`0001T000?o0000<P000?l0=P000ol0000G0003o`0003<0
003o03L000?o00005@000ol0000d0000o`0h0003o`0001<000?o0000=@000?l0>@000ol0000A0003
o`0003H0003o03X000?o000040000ol0000f0000o`0k0003o`0000h000?o0000=`000?l0>`000ol0
000300K;10000ol0000h0000o`0l0003o`0000[;00<0o`00>P000?l0?@000oo;b`0:bc`0003o03d0
3//k0000o`0l00G;0ol8bcX0003o03`02</00oo;b`05bcX0003?00CoI`06b`Co2</i0000cP000ol0
001Y00G;00Gobl_;o`08bcT0003>0003o`0006T01L/01Oo;bl_o00S;>@000<h000Go0000o`1W00G;
00Gobl_;o`08bcT0003?00CoI`06b`Go1l/i0000o`0k01;;>@000?l0?00@bcX0003o03`04</j0000
f0000ol0001P0003ol_;00c;>`000=T000?o0000GP000ol0000<bc`0003J0003o`0005`000?o0000
0P0:bcd0003K0003o`0005X000?o00001@06bcl0003L0003o`0005P000?o0000B`000=d000?o0000
EP000ol0001<0000gP000ol0001D0003o`0004d0003O0003o`00058000?o0000CP000>0000?o0000
D0000ol0001?0000h@000ol0001>0003o`000500003R0003o`0004`000?o0000D@000><000?o0000
BP000ol0001B0000i0000ol000180003o`0005<0003U0003o`0004H000?o0000E0000>H000?o0000
A0000ol0001E0000i`000ol000120003o`0005H0003X0003o`00040000?o0000E`000>T000?o0000
?P000ol0001H0000jP000ol0000l0003o`0005T0003[0003o`0003X000?o0000FP000>`000?o0000
>0000ol0001K0000k@02ocL000?o0000G0000>l000?o0000<`000ol0001M0000l0000ol0000a0003
o`0005h0003a0003o`0002l000?o0000G`000?8000?o0000;@000ol0001P0000l`000ol0000[0003
o`000640003d0003o`0002T000?o0000HP000?D000?o00009`000ol0001S0000mP000ol0000U0003
o`0006@0003g0003o`0002<000?o0000I@000?P000?o00008@000ol0001V0000n@000ol0000O0003
o`0006L0003j0003o`0001d000?o0000J0000?/000?o00006`000ol0001Y0000o0000ol0000I0003
o`0006X0003m0003o`0001L000?o0000J`000?h000?o00005@000ol0001/0000o`000ol0000C0003
o`0006d0003o004000?o00004@000ol0001^0000o`020003o`0000l000?o0000K`000?l00`000ol0
000200K;1@000ol0001`0000o`040003o`3;00W;0P000ol0001a0000o`0500c;00?o0000LP000?l0
100>bg@0003o00<01//3o`O;L`000?l00`09b`03ol_;00C;L`0003h01?l`00?oG`04obT01l/4o`O;
LP0003h000Go0000o`0b0003o`0005/000?o0000:`06b`05ol_;bol01l]b0000?P001Ol0003o0380
00?o0000F`05obT01//01Oo;bl_o00O;LP0003h000Go0000o`0`00;oGP001Ol0003o02T01//01Oo;
bl_o00O;LP0003h01?lc0003o`0005`00olZ00O;1Ol6bg80000n0003o`0003400on<01;;LP0003d0
0_o3013;L`000?l00`0@bg<0003o00@03/]d0000o`0500c;M@000?l01P0:bgH000140003o`0002T0
00?o0000I`000ol0000Y0003ol_;00C;N00004@000?o0000:@000ol0001W0003o`0002T000?o0000
O00004D000?o00009`000ol0001Y0003o`0002L000?o0000O@0004D000?o00009`000ol0001Y0003
o`0002L000?o0000O@0004H000?o00009@000ol0001[0003o`0002D000?o0000OP0004H000?o0000
9@000ol0001[0003o`0002D000?o0000OP0004L000?o00008`000ol0001]0003o`0002<000?o0000
O`0004L000?o00008`000ol0001]0003o`0002<000?o0000O`0004P000?o00008@000ol0001_0003
o`00024000?o0000P00004P000?o00008@000ol0001_0003o`00024000?o0000P00004T000?o0000
7`000ol0001a0003o`0001l000?o0000P@0004T000?o00007`000ol0001a0003o`0001l000?o0000
P@0004X000?o00007@000ol0001c0003o`0001d000?o0000PP0004X000?o00007@000ol0001c0003
o`0001d000?o0000PP0004/000?o00006`000ol0001e0003o`0001/000?o0000P`0004/000?o0000
6`000ol0001e0003o`0001/000?o0000P`0004`000?o00006@000ol0001g0003o`0001T000?o0000
Q00004`000?o00006@000ol0001g0003o`0001T000?o0000Q00004d000?o00005`000ol0001i0003
o`0001L000?o0000Q@0004d000?o00005`000ol0001i0003o`0001L000?o0000Q@0004d000?o0000
5`000ol0001i0003o`0001L000?o0000Q@0004h000?o00005@000ol0001k0003o`0001D000?o0000
QP0004h000?o00005@000ol0001k0003o`0001D000?o0000QP0004l000?o00004`000ol0001m0003
o`0001<000?o0000Q`0004l000?o00004`000ol0001m0003o`0001<000?o0000Q`00050000?o0000
4@000ol0001o0003o`00014000?o0000R000050000?o00004@000ol0001o0003o`00014000?o0000
R000054000?o00003`000ol000210003o`0000l000?o0000R@00054000?o00003`000ol000210003
o`0000l000?o0000R@00058000?o00003@000ol000230003o`0000d000?o0000RP00058000?o0000
3@000ol000230003o`0000d000?o0000RP0005<000?o00002`000ol000250003o`0000/000?o0000
R`0005<000?o00002`000ol000250003o`0000/000?o0000R`0005@000?o00002@000ol000270003
o`0000T000?o0000S00005@000?o00002@000ol000270003o`0000T000?o0000S00005D000?o0000
1`000ol000290003o`0000L000?o0000S@0005D000?o00001`000ol000290003o`0000L000?o0000
S@0005H000?o00001@000ol0002;0003o`0000D000?o0000SP0005H000?obl/01</00`3o002<0003
ol_;00C;00<0o`00S`0005D02/^<00[;T00005@03<^:00c;S`0005<03/^800k;SP0005801//3o`O;
QP0@bhd0001B00W;00?obl/01<^6013;S@0000`01Om000O;1?l7bd001?m000O;0_l00l_oo`06bcl0
1?m9000030001?l00?m100K;00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;@0000ol000190000
3004od401//01Oo;bl_o00O;?`000ol0001200O;00Cobl_o1l]10003o`0004P0000?0003o`0003l0
1//01Oo;bl_o00O;?`001Ol0003o04001l/01?o;bol7bd8000?o0000A`0000`01?m100O;1Ol6bd00
1?m000O;1?l7bd8000?o0000A`0001P00_lg01;;Q007b`03ol_;00S;>0000ol0000400?oBP0001X0
0_lf013;QP05b`;o2L/f00?oE00001`00olc013;00?o0000P`0@bc<00omG00007`03oc403//20003
o`00084000?o0</03L/a00?oFP0002800_l`00c;10000ol0001o0004o`0000c;<002oed0000T00?o
;P0:b`H00_mm00;o1@0:bbh00omO00009`03obd01//:0003o`0007T000?o00001`06bbd00omR0000
:P03oc/000?o0000>P000ol0000j0003o`0003T00_mU0000;@02ocX00_lj0003o`0003P00_li00?o
I`0002l00oli0003o`0003L000?o0000=`000ol0000f00?oJP0003800olg0003o`0003H000?o0000
=P000ol0000d00?oK@0003D00ole00;o=P000ol0000d00;o=@02og00000h00;o=@000ol0000c0003
o`0003<000?o0000<P03og80000j00?o<`02oc<000?o0000<@02oc800ome0000?@03oc8000?o0000
<0000ol0000`0003o`0003000_mh0000@002oc4000?o0000;`000ol0000_0003o`0002h00omj0000
@P03obl00_l_0003o`0002d00_l^00?oO@0004D00ol^0003o`0002`000?o0000;0000ol0000[00?o
P00004P00ol/0003o`0002/000?o0000:`000ol0000Z00;oP`0004/00_l[00;o:`000ol0000Y00;o
:P03ohD0001=00?o:P000ol0000X0003o`0002P000?o00009`03ohP0001@00?o:0000ol0000W0003
o`0002L000?o00009P02oh/0001C00?o9P02obL000?o00009@02obH00on=0000EP02obH000?o0000
90000ol0000T0003o`0002<00on@0000F003ob@00_lT0003o`0002800_lS00?oT`0005/00olS0003
o`00024000?o00008@000ol0000Q00;oUP0005h00_lR0003o`00020000?o000080000ol0000O00?o
V00006000olP00;o80000ol0000N00;o7`03oi/0001S00?o7`000ol0000M0003o`0001d000?o0000
7@02oih0001V00?o7@000ol0000L0003o`0001`000?o00006`03oj00001Y00;o7002oa`000?o0000
6P02oa/00onS0000J`03oa/000?o00006@000ol0000I0003o`0001T00_nV0000KP03oaT000?o0000
60000ol0000H0003o`0001L00onX0000L@03oaL00_lH0003o`0001H00_lG00?oZ`0007@00_lG0003
o`0001D000?o00005@000ol0000D00?o[P0007H00olE00;o5@000ol0000C00;o5@02ok40001i00?o
50000ol0000B0003o`00018000?o00004P03ok<0001l00;o4`000ol0000A0003o`00014000?o0000
4003okH0001n00?o4@02oa4000?o00003`02oa400_ni0000P@03oa0000?o00003P000ol0000>0003
o`0000h00onk0000Q003o`h000?o00003@000ol0000=0003o`0000`00onn0000Q`02o`d00_l=0003
o`0000/00_l<00?o`@0008T00ol<0003o`0000X000?o00002P000ol0000:00;oa00008`00ol:0003
o`0000T000?o00002@000ol0000800?oaP0008l00ol800;o2@000ol0000700;o2003olT0002B00;o
20000ol0000300K;1P000ol0000600;oc00009@00ol600;o00<0bl/02</200;o1P03olh0002G00?o
1@0<b`03o`0000<00ooA0000VP02o`803//200?oe00009`000?obl/03//00ol0003E0000W@06b`Co
1/_H0000W008b`03ol_;00O;e`0009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000W007b`Co
1l_G0000W008b`03ol_;00O;e`0009`02</3o`O;e`0009d04<_H0000W@0@bmP0002N00k;f@0009l0
3<_J0000X00:bm/00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"Mutation - mutant 1"]
}, Open  ]],

Cell[TextData[{
  "Selective mutation 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .84435 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.84435 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.84435 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .84435 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004obd01Ol]00Co3`000?l040001Ol0003o02/000Go0000
o`0_0003o`0000l0003o010000Go0000o`0[0005o`000?l0<0000ol0000>0000o`0@0005o`000?l0
:`001Ol0003o034000?o00003@000?l04004obd01?la0003o`0000d0003o010000?o0000<@000ol0
000/00?o40000?l03`02oc800_m10000o`260000o`260000o`0H0003o`0006/0003o01T000?o0000
DP000ol0000E0000o`0J0003o`00050000?o00005P000?l06P000ol0000V0003o`0002H000?o0000
5`000?l06`000ol0000U0003o`0002D000?o000060000?l070000ol0000T0003o`0002D000?o0000
60000?l07@000ol0000S0003o`0002@000?o00006@000?l07P000ol0000R0003o`0002<000?o0000
6P000?l07`000ol0000Q0003o`00028000?o00006`000?l080000ol0000P0003o`00024000?o0000
70000?l08@000ol0000O0003o`00020000?o00007@000?l08P000ol0000N0003o`0001l000?o0000
7P000?l08P000ol0000N0003o`0001h000?o00007`000?l08`000ol0000M0003o`0001d000?o0000
80000?l090000ol0000L0003o`0001`000?o00008@000?l09@000ol0000K0003o`0001/000?o0000
8P000?l09P000ol0000J0003o`0001/000?o00008P000?l09`000ol0000I0003o`0001X000?o0000
8`000?l0:0000ol0000H0003o`0001T000?o000090000?l0:@000ol0000G0003o`0001P000?o0000
9@000?l0:P000ol0000F0003o`0001L000?o00009P000?l0:`000ol0000E0003o`0001H000?o0000
9`000?l0:`000ol0000E0003o`0001D000?o0000:0000?l0;0000ol0000D0003o`0001@000?o0000
:@000?l0;@000ol0000C0003o`0001<000?o0000:P000?l0;P000ol0000B0003o`00018000?o0000
:`000?l0;`000ol0000A0003o`00014000?o0000;0000?l0<0000ol0000@0003o`00014000?o0000
;0000?l0<@000ol0000?0003o`00010000?o0000;@000?l0<P000ol0000>0003o`0000l000?o0000
;P000?l0<`000ol0000=0003o`0000h000?o0000;`000?l0<`000ol0000=0003o`0000d000?o0000
<0000?l0=0000ol0000<0003o`0000`000?o0000<@000?l0=@000ol0000;0003o`0000/000?o0000
<P000?l0=P000ol0000:0003o`0000X000?o0000<`000?l0=`000ol000090003o`0000T000?o0000
=0000?l0>0000ol000080003o`0000P000?o0000=@000?l0>@000ol000070003o`0000L000?o0000
=P000?l0>P000ol000060003o`0000L000?o0000=P000?l0>`000ol000050003o`0000H000?o0000
=`000?l0>`000ol0000300K;10000ol0000h0000o`0l0003o`0000[;00<0o`00>P000?l0?@000oo;
b`0:bc`0003o03d03//k0000o`0l00G;0ol8bcX0003o03`02</00oo;b`05bcX0003?00CoI`06b`Co
2</i0000cP000ol0001Y00G;00Gobl_;o`08bcT0003>0003o`0006T01L/01Oo;bl_o00S;>@000<h0
00Go0000o`1W00G;00Gobl_;o`08bcT0003?00CoI`06b`Go1l/i0000o`0k01;;>@000?l0?00@bcX0
003o03`04</j0000f0000ol0001P0003ol_;00c;>`000=T000?o0000GP000ol0000<bc`0003J0003
o`0005`000?o00000P0:bcd0003K0003o`0005X000?o00001@06bcl0003L0003o`0005P000?o0000
B`000=d000?o0000EP000ol0001<0000gP000ol0001D0003o`0004d0003O0003o`00058000?o0000
CP000>0000?o0000D0000ol0001?0000h@000ol0001>0003o`000500003R0003o`0004`000?o0000
D@000><000?o0000BP000ol0001B0000i0000ol000180003o`0005<0003U0003o`0004H000?o0000
E0000>H000?o0000A0000ol0001E0000i`000ol000120003o`0005H0003X0003o`00040000?o0000
E`000>T000?o0000?P000ol0001H0000jP000ol0000l0003o`0005T0003[0003o`0003X000?o0000
FP000>`000?o0000>0000ol0001K0000k@02ocL000?o0000G0000>l000?o0000<`000ol0001M0000
l0000ol0000a0003o`0005h0003a0003o`0002l000?o0000G`000?8000?o0000;@000ol0001P0000
l`000ol0000[0003o`000640003d0003o`0002T000?o0000HP000?D000?o00009`000ol0001S0000
mP000ol0000U0003o`0006@0003g0003o`0002<000?o0000I@000?P000?o00008@000ol0001V0000
n@000ol0000O0003o`0006L0003j0003o`0001d000?o0000J0000?/000?o00006`000ol0001Y0000
o0000ol0000I0003o`0006X0003m0003o`0001L000?o0000J`000?h000?o00005@000ol0001/0000
o`000ol0000C0003o`0006d0003o004000?o00004@000ol0001^0000o`020003o`0000l000?o0000
K`000?l00`000ol0000200K;1@000ol0001`0000o`040003o`3;00W;0P000ol0001a0000o`0500c;
00?o0000LP000?l0100>bg@0003o00<01//3o`O;L`000?l00`09b`03ol_;00C;L`0003h01?l`00?o
G`04obT01l/4o`O;LP0003h000Go0000o`0b0003o`0005/000?o0000:`06b`05ol_;bol01l]b0000
?P001Ol0003o038000?o0000F`05obT01//01Oo;bl_o00O;LP0003h000Go0000o`0`00;oGP001Ol0
003o02T01//01Oo;bl_o00O;LP0003h01?lc0003o`0005`00olZ00O;1Ol6bg80000n0003o`000340
0on<01;;LP0003d00_o3013;L`000?l00`0@bg<0003o00@03/]d0000o`0500c;M@000?l01P0:bgH0
00140003o`0002T000?o0000I`000ol0000Y0003ol_;00C;N00004@000?o0000:@000ol0001W0003
o`0002T000?o0000O00004D000?o00009`000ol0001Y0003o`0002L000?o0000O@0004D000?o0000
9`000ol0001Y0003o`0002L000?o0000O@0004H000?o00009@000ol0001[0003o`0002D000?o0000
OP0004H000?o00009@000ol0001[0003o`0002D000?o0000OP0004L000?o00008`000ol0001]0003
o`0002<000?o0000O`0004L000?o00008`000ol0001]0003o`0002<000?o0000O`0004P000?o0000
8@000ol0001_0003o`00024000?o0000P00004P000?o00008@000ol0001_0003o`00024000?o0000
P00004T000?o00007`000ol0001a0003o`0001l000?o0000P@0004T000?o00007`000ol0001a0003
o`0001l000?o0000P@0004X000?o00007@000ol0001c0003o`0001d000?o0000PP0004X000?o0000
7@000ol0001c0003o`0001d000?o0000PP0004/000?o00006`000ol0001e0003o`0001/000?o0000
P`0004/000?o00006`000ol0001e0003o`0001/000?o0000P`0004`000?o00006@000ol0001g0003
o`0001T000?o0000Q00004`000?o00006@000ol0001g0003o`0001T000?o0000Q00004d000?o0000
5`000ol0001i0003o`0001L000?o0000Q@0004d000?o00005`000ol0001i0003o`0001L000?o0000
Q@0004d000?o00005`000ol0001i0003o`0001L000?o0000Q@0004h000?o00005@000ol0001k0003
o`0001D000?o0000QP0004h000?o00005@000ol0001k0003o`0001D000?o0000QP0004l000?o0000
4`000ol0001m0003o`0001<000?o0000Q`0004l000?o00004`000ol0001m0003o`0001<000?o0000
Q`00050000?o00004@000ol0001o0003o`00014000?o0000R000050000?o00004@000ol0001o0003
o`00014000?o0000R000054000?o00003`000ol000210003o`0000l000?o0000R@00054000?o0000
3`000ol000210003o`0000l000?o0000R@00058000?o00003@000ol000230003o`0000d000?o0000
RP00058000?o00003@000ol000230003o`0000d000?o0000RP0005<000?o00002`000ol000250003
o`0000/000?o0000R`0005<000?o00002`000ol000250003o`0000/000?o0000R`0005@000?o0000
2@000ol000270003o`0000T000?o0000S00005@000?o00002@000ol000270003o`0000T000?o0000
S00005D000?o00001`000ol000290003o`0000L000?o0000S@0005D000?o00001`000ol000290003
o`0000L000?o0000S@0005H000?o00001@000ol0002;0003o`0000D000?o0000SP0005H000?obl/0
1</00`3o002<0003ol_;00C;00<0o`00S`0005D02/^<00[;T00005@03<^:00c;S`0005<03/^800k;
SP0005801//3o`O;QP0@bhd0001B00W;00?obl/01<^6013;S@0000`01Om000O;1?l7bd001?m000O;
0_l00l_oo`06bcl01?m9000030001?l00?m100K;00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;
@0000ol0001900003004od401//01Oo;bl_o00O;?`000ol0001200O;00Cobl_o1l]10003o`0004P0
000?0003o`0003l01//01Oo;bl_o00O;?`001Ol0003o04001l/01?o;bol7bd8000?o0000A`0000`0
1?m100O;1Ol6bd001?m000O;1?l7bd8000?o0000A`0001P00_lg01;;Q007b`03ol_;00S;>0000ol0
000400?oBP0001X00_lf013;QP05b`;o2L/f00?oE00001`00olc013;00?o0000P`0@bc<00omG0000
7`03oc403//20003o`00084000?o0</03L/a00?oFP0002800_l`00c;10000ol0001o0004o`0000c;
<002oed0000T00?o;P0:b`H00_mm00;o1@0:bbh00omO00009`03obd01//:0003o`0007T000?o0000
1`06bbd00omR0000:P03oc/000?o0000>P000ol0000j0003o`0003T00_mU0000;@02ocX00_lj0003
o`0003P00_li00?oI`0002l00oli0003o`0003L000?o0000=`000ol0000f00?oJP0003800olg0003
o`0003H000?o0000=P000ol0000d00?oK@0003D00ole00;o=P000ol0000d00;o=@02og00000h00;o
=@000ol0000c0003o`0003<000?o0000<P03og80000j00?o<`02oc<000?o0000<@02oc800ome0000
?@03oc8000?o0000<0000ol0000`0003o`0003000_mh0000@002oc4000?o0000;`000ol0000_0003
o`0002h00omj0000@P03obl00_l_0003o`0002d00_l^00?oO@0004D00ol^0003o`0002`000?o0000
;0000ol0000[00?oP00004P00ol/0003o`0002/000?o0000:`000ol0000Z00;oP`0004/00_l[00;o
:`000ol0000Y00;o:P03ohD0001=00?o:P000ol0000X0003o`0002P000?o00009`03ohP0001@00?o
:0000ol0000W0003o`0002L000?o00009P02oh/0001C00?o9P02obL000?o00009@02obH00on=0000
EP02obH000?o000090000ol0000T0003o`0002<00on@0000F003ob@00_lT0003o`0002800_lS00?o
T`0005/00olS0003o`00024000?o00008@000ol0000Q00;oUP0005h00_lR0003o`00020000?o0000
80000ol0000O00?oV00006000olP00;o80000ol0000N00;o7`03oi/0001S00?o7`000ol0000M0003
o`0001d000?o00007@02oih0001V00?o7@000ol0000L0003o`0001`000?o00006`03oj00001Y00;o
7002oa`000?o00006P02oa/00onS0000J`03oa/000?o00006@000ol0000I0003o`0001T00_nV0000
KP03oaT000?o000060000ol0000H0003o`0001L00onX0000L@03oaL00_lH0003o`0001H00_lG00?o
Z`0007@00_lG0003o`0001D000?o00005@000ol0000D00?o[P0007H00olE00;o5@000ol0000C00;o
5@02ok40001i00?o50000ol0000B0003o`00018000?o00004P03ok<0001l00;o4`000ol0000A0003
o`00014000?o00004003okH0001n00?o4@02oa4000?o00003`02oa400_ni0000P@03oa0000?o0000
3P000ol0000>0003o`0000h00onk0000Q003o`h000?o00003@000ol0000=0003o`0000`00onn0000
Q`02o`d00_l=0003o`0000/00_l<00?o`@0008T00ol<0003o`0000X000?o00002P000ol0000:00;o
a00008`00ol:0003o`0000T000?o00002@000ol0000800?oaP0008l00ol800;o2@000ol0000700;o
2003olT0002B00;o20000ol0000300K;1P000ol0000600;oc00009@00ol600;o00<0bl/02</200;o
1P03olh0002G00?o1@0<b`03o`0000<00ooA0000VP02o`803//200?oe00009`000?obl/03//00ol0
003E0000W@06b`Co1/_H0000W008b`03ol_;00O;e`0009`02</00oo;b`07bmL0002L00S;00?obl/0
1l_G0000W007b`Co1l_G0000W008b`03ol_;00O;e`0009`02</3o`O;e`0009d04<_H0000W@0@bmP0
002N00k;f@0009l03<_J0000X00:bm/00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"Mutation - mutant 2"],

Cell[TextData[{
  "Selective mutation 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .84435 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.84435 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.84435 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .84435 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004obd00ol_00?o40000?l040001Ol0003o02l000?o0000
;`000ol0000=0000o`0@0005o`000?l0;`000ol0000_0003o`0000d0003o010000Go0000o`0]00;o
;`03oa00003o01001?l`0003o`0002`000?o000040000?l040000ol0000^00?o;`04o`l0003o00l0
0_me0000o`260000o`260000o`0H0003o`0006/0003o01T000?o0000DP000ol0000E0000o`0J0003
o`00050000?o00005P000?l06P000ol0000V0003o`0002H000?o00005`000?l06`000ol0000U0003
o`0002D000?o000060000?l070000ol0000T0003o`0002D000?o000060000?l07@000ol0000S0003
o`0002@000?o00006@000?l07P000ol0000R0003o`0002<000?o00006P000?l07`000ol0000Q0003
o`00028000?o00006`000?l080000ol0000P0003o`00024000?o000070000?l08@000ol0000O0003
o`00020000?o00007@000?l08P000ol0000N0003o`0001l000?o00007P000?l08P000ol0000N0003
o`0001h000?o00007`000?l08`000ol0000M0003o`0001d000?o000080000?l090000ol0000L0003
o`0001`000?o00008@000?l09@000ol0000K0003o`0001/000?o00008P000?l09P000ol0000J0003
o`0001/000?o00008P000?l09`000ol0000I0003o`0001X000?o00008`000?l0:0000ol0000H0003
o`0001T000?o000090000?l0:@000ol0000G0003o`0001P000?o00009@000?l0:P000ol0000F0003
o`0001L000?o00009P000?l0:`000ol0000E0003o`0001H000?o00009`000?l0:`000ol0000E0003
o`0001D000?o0000:0000?l0;0000ol0000D0003o`0001@000?o0000:@000?l0;@000ol0000C0003
o`0001<000?o0000:P000?l0;P000ol0000B0003o`00018000?o0000:`000?l0;`000ol0000A0003
o`00014000?o0000;0000?l0<0000ol0000@0003o`00014000?o0000;0000?l0<@000ol0000?0003
o`00010000?o0000;@000?l0<P000ol0000>0003o`0000l000?o0000;P000?l0<`000ol0000=0003
o`0000h000?o0000;`000?l0<`000ol0000=0003o`0000d000?o0000<0000?l0=0000ol0000<0003
o`0000`000?o0000<@000?l0=@000ol0000;0003o`0000/000?o0000<P000?l0=P000ol0000:0003
o`0000X000?o0000<`000?l0=`000ol000090003o`0000T000?o0000=0000?l0>0000ol000080003
o`0000P000?o0000=@000?l0>@000ol000070003o`0000L000?o0000=P000?l0>P000ol000060003
o`0000L000?o0000=P000?l0>`000ol000050003o`0000H000?o0000=`000?l0>`000ol0000300K;
10000ol0000h0000o`0l0003o`0000[;00<0o`00>P000?l0?@000oo;b`0:bc`0003o03d03//k0000
o`0l00G;0ol8bcX0003o03`02</00oo;b`05bcX0003?00CoI`06b`Co2</i0000cP000ol0001Y00G;
00Gobl_;o`08bcT0003>0003o`0006T01L/01Oo;bl_o00S;>@000<h000Go0000o`1W00G;00Gobl_;
o`08bcT0003?00CoI`06b`Go1l/i0000o`0k01;;>@000?l0?00@bcX0003o03`04</j0000f0000ol0
001P0003ol_;00c;>`000=T000?o0000GP000ol0000<bc`0003J0003o`0005`000?o00000P0:bcd0
003K0003o`0005X000?o00001@06bcl0003L0003o`0005P000?o0000B`000=d000?o0000EP000ol0
001<0000gP000ol0001D0003o`0004d0003O0003o`00058000?o0000CP000>0000?o0000D0000ol0
001?0000h@000ol0001>0003o`000500003R0003o`0004`000?o0000D@000><000?o0000BP000ol0
001B0000i0000ol000180003o`0005<0003U0003o`0004H000?o0000E0000>H000?o0000A0000ol0
001E0000i`000ol000120003o`0005H0003X0003o`00040000?o0000E`000>T000?o0000?P000ol0
001H0000jP000ol0000l0003o`0005T0003[0003o`0003X000?o0000FP000>`000?o0000>0000ol0
001K0000k@02ocL000?o0000G0000>l000?o0000<`000ol0001M0000l0000ol0000a0003o`0005h0
003a0003o`0002l000?o0000G`000?8000?o0000;@000ol0001P0000l`000ol0000[0003o`000640
003d0003o`0002T000?o0000HP000?D000?o00009`000ol0001S0000mP000ol0000U0003o`0006@0
003g0003o`0002<000?o0000I@000?P000?o00008@000ol0001V0000n@000ol0000O0003o`0006L0
003j0003o`0001d000?o0000J0000?/000?o00006`000ol0001Y0000o0000ol0000I0003o`0006X0
003m0003o`0001L000?o0000J`000?h000?o00005@000ol0001/0000o`000ol0000C0003o`0006d0
003o004000?o00004@000ol0001^0000o`020003o`0000l000?o0000K`000?l00`000ol0000200K;
1@000ol0001`0000o`040003o`3;00W;0P000ol0001a0000o`0500c;00?o0000LP000?l0100>bg@0
003o00<01//3o`O;L`000?l00`09b`03ol_;00C;L`0003h01?l`00?oG`04obT01l/4o`O;LP0003h0
00Go0000o`0b0003o`0005/000?o0000:`06b`05ol_;bol01l]b0000?P001Ol0003o038000?o0000
F`05obT01//01Oo;bl_o00O;LP0003h000Go0000o`0`00;oGP001Ol0003o02T01//01Oo;bl_o00O;
LP0003h01?lc0003o`0005`00olZ00O;1Ol6bg80000n0003o`0003400on<01;;LP0003d00_o3013;
L`000?l00`0@bg<0003o00@03/]d0000o`0500c;M@000?l01P0:bgH000140003o`0002T000?o0000
I`000ol0000Y0003ol_;00C;N00004@000?o0000:@000ol0001W0003o`0002T000?o0000O00004D0
00?o00009`000ol0001Y0003o`0002L000?o0000O@0004D000?o00009`000ol0001Y0003o`0002L0
00?o0000O@0004H000?o00009@000ol0001[0003o`0002D000?o0000OP0004H000?o00009@000ol0
001[0003o`0002D000?o0000OP0004L000?o00008`000ol0001]0003o`0002<000?o0000O`0004L0
00?o00008`000ol0001]0003o`0002<000?o0000O`0004P000?o00008@000ol0001_0003o`000240
00?o0000P00004P000?o00008@000ol0001_0003o`00024000?o0000P00004T000?o00007`000ol0
001a0003o`0001l000?o0000P@0004T000?o00007`000ol0001a0003o`0001l000?o0000P@0004X0
00?o00007@000ol0001c0003o`0001d000?o0000PP0004X000?o00007@000ol0001c0003o`0001d0
00?o0000PP0004/000?o00006`000ol0001e0003o`0001/000?o0000P`0004/000?o00006`000ol0
001e0003o`0001/000?o0000P`0004`000?o00006@000ol0001g0003o`0001T000?o0000Q00004`0
00?o00006@000ol0001g0003o`0001T000?o0000Q00004d000?o00005`000ol0001i0003o`0001L0
00?o0000Q@0004d000?o00005`000ol0001i0003o`0001L000?o0000Q@0004d000?o00005`000ol0
001i0003o`0001L000?o0000Q@0004h000?o00005@000ol0001k0003o`0001D000?o0000QP0004h0
00?o00005@000ol0001k0003o`0001D000?o0000QP0004l000?o00004`000ol0001m0003o`0001<0
00?o0000Q`0004l000?o00004`000ol0001m0003o`0001<000?o0000Q`00050000?o00004@000ol0
001o0003o`00014000?o0000R000050000?o00004@000ol0001o0003o`00014000?o0000R0000540
00?o00003`000ol000210003o`0000l000?o0000R@00054000?o00003`000ol000210003o`0000l0
00?o0000R@00058000?o00003@000ol000230003o`0000d000?o0000RP00058000?o00003@000ol0
00230003o`0000d000?o0000RP0005<000?o00002`000ol000250003o`0000/000?o0000R`0005<0
00?o00002`000ol000250003o`0000/000?o0000R`0005@000?o00002@000ol000270003o`0000T0
00?o0000S00005@000?o00002@000ol000270003o`0000T000?o0000S00005D000?o00001`000ol0
00290003o`0000L000?o0000S@0005D000?o00001`000ol000290003o`0000L000?o0000S@0005H0
00?o00001@000ol0002;0003o`0000D000?o0000SP0005H000?obl/01</00`3o002<0003ol_;00C;
00<0o`00S`0005D02/^<00[;T00005@03<^:00c;S`0005<03/^800k;SP0005801//3o`O;QP0@bhd0
001B00W;00?obl/01<^6013;S@0000`01Om000O;1?l7bd001?m000O;0_l00l_oo`06bcl01?m90000
30001?l00?m100K;00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;@0000ol0001900003004od40
1//01Oo;bl_o00O;?`000ol0001200O;00Cobl_o1l]10003o`0004P0000?0003o`0003l01//01Oo;
bl_o00O;?`001Ol0003o04001l/01?o;bol7bd8000?o0000A`0000`01?m100O;1Ol6bd001?m000O;
1?l7bd8000?o0000A`0001P00_lg01;;Q007b`03ol_;00S;>0000ol0000400?oBP0001X00_lf013;
QP05b`;o2L/f00?oE00001`00olc013;00?o0000P`0@bc<00omG00007`03oc403//20003o`000840
00?o0</03L/a00?oFP0002800_l`00c;10000ol0001o0004o`0000c;<002oed0000T00?o;P0:b`H0
0_mm00;o1@0:bbh00omO00009`03obd01//:0003o`0007T000?o00001`06bbd00omR0000:P03oc/0
00?o0000>P000ol0000j0003o`0003T00_mU0000;@02ocX00_lj0003o`0003P00_li00?oI`0002l0
0oli0003o`0003L000?o0000=`000ol0000f00?oJP0003800olg0003o`0003H000?o0000=P000ol0
000d00?oK@0003D00ole00;o=P000ol0000d00;o=@02og00000h00;o=@000ol0000c0003o`0003<0
00?o0000<P03og80000j00?o<`02oc<000?o0000<@02oc800ome0000?@03oc8000?o0000<0000ol0
000`0003o`0003000_mh0000@002oc4000?o0000;`000ol0000_0003o`0002h00omj0000@P03obl0
0_l_0003o`0002d00_l^00?oO@0004D00ol^0003o`0002`000?o0000;0000ol0000[00?oP00004P0
0ol/0003o`0002/000?o0000:`000ol0000Z00;oP`0004/00_l[00;o:`000ol0000Y00;o:P03ohD0
001=00?o:P000ol0000X0003o`0002P000?o00009`03ohP0001@00?o:0000ol0000W0003o`0002L0
00?o00009P02oh/0001C00?o9P02obL000?o00009@02obH00on=0000EP02obH000?o000090000ol0
000T0003o`0002<00on@0000F003ob@00_lT0003o`0002800_lS00?oT`0005/00olS0003o`000240
00?o00008@000ol0000Q00;oUP0005h00_lR0003o`00020000?o000080000ol0000O00?oV0000600
0olP00;o80000ol0000N00;o7`03oi/0001S00?o7`000ol0000M0003o`0001d000?o00007@02oih0
001V00?o7@000ol0000L0003o`0001`000?o00006`03oj00001Y00;o7002oa`000?o00006P02oa/0
0onS0000J`03oa/000?o00006@000ol0000I0003o`0001T00_nV0000KP03oaT000?o000060000ol0
000H0003o`0001L00onX0000L@03oaL00_lH0003o`0001H00_lG00?oZ`0007@00_lG0003o`0001D0
00?o00005@000ol0000D00?o[P0007H00olE00;o5@000ol0000C00;o5@02ok40001i00?o50000ol0
000B0003o`00018000?o00004P03ok<0001l00;o4`000ol0000A0003o`00014000?o00004003okH0
001n00?o4@02oa4000?o00003`02oa400_ni0000P@03oa0000?o00003P000ol0000>0003o`0000h0
0onk0000Q003o`h000?o00003@000ol0000=0003o`0000`00onn0000Q`02o`d00_l=0003o`0000/0
0_l<00?o`@0008T00ol<0003o`0000X000?o00002P000ol0000:00;oa00008`00ol:0003o`0000T0
00?o00002@000ol0000800?oaP0008l00ol800;o2@000ol0000700;o2003olT0002B00;o20000ol0
000300K;1P000ol0000600;oc00009@00ol600;o00<0bl/02</200;o1P03olh0002G00?o1@0<b`03
o`0000<00ooA0000VP02o`803//200?oe00009`000?obl/03//00ol0003E0000W@06b`Co1/_H0000
W008b`03ol_;00O;e`0009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000W007b`Co1l_G0000
W008b`03ol_;00O;e`0009`02</3o`O;e`0009d04<_H0000W@0@bmP0002N00k;f@0009l03<_J0000
X00:bm/00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"Mutation - mutant 3"],

Cell[TextData[{
  "Selective mutation 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33652 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .63887 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62463 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .95159 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Mshowa
P
.004 w
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Mshowa
P
1 g
.33652 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33652 .21092 0 0 Mshowa
P
.9 g
.25575 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Mshowa
P
1 g
.4877 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Mshowa
P
.004 w
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .63887 .21092 0 0 Mshowa
P
.004 w
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62463 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.80041 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Mshowa
P
.9 g
.71964 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Mshowa
P
1 g
.95159 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .95159 .40712 0 0 Mshowa
P
.9 g
.4877 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000>h01?n200?o3P000>h000Go0000o`220003o`0000d0003^0005
o`000?l0O`05o`h0003^0005o`000?l0P0000ol0o`0?0000kP04oh4000?o0?l03`000>h000?o0000
P`02o`l0003]00;oUP000?l0QP000?l0QP000?H000?o0000S0000?L000?o0000L`000ol0000E0000
n0000ol0001a0003o`0001H0003i0003o`0006l000?o00005`000?T000?o0000K`000ol0000G0000
nP000ol0001]0003o`0001P0003k0003o`0006/000?o00006@000?`000?o0000J@000ol0000J0000
o@000ol0001W0003o`0001/0003n0003o`0006D000?o000070000?l000?o0000H`000ol0000M0000
o`010003o`00064000?o00007P000?l00P000ol0001O0003o`0001l0003o00<000?o0000G@000ol0
000P0000o`040003o`0005/000?o00008@000?l010000ol0001K0003o`000240003o00D000?o0000
F@000ol0000R0000o`060003o`0005L000?o00008`000?l01`000ol0001E0003o`0002@0003o00P0
00?o0000D`000ol0000U0000o`090003o`00054000?o00009P000?l02P000ol0001?0003o`0002L0
003o00/000?o0000C@000ol0000X0000o`0<0003o`0004/000?o0000:@000?l03@000ol000190003
o`0002X0003o00d000?o0000B@000ol0000Z0000o`0>0003o`0004L000?o0000:`000?l03`000ol0
00150003o`0002`0003o010000?o0000@`000ol0000]0000o`0A0003o`00044000?o0000;P000?l0
4P000ol0000o0003o`0002l0003o01<000?o0000?@000ol0000`0000o`0D0003o`0003/000?o0000
<@000?l05@000ol0000i0003o`000380003o01H000?o0000=`000ol0000c0000o`0G0003o`0003D0
00?o0000=0000?l05`000ol0000e0003o`0003@0003o01P000?o0000<`000ol0000e0000o`0I0003
o`00034000?o0000=P000?l06P000ol0000_0003o`0003L0003o01/000?o0000;@000ol0000h0000
o`0L0003o`0002/000?o0000>@000?l07@000ol0000Y0003o`0003X0003o01h000?o00009`000ol0
000k0000o`0O0003o`0002D000?o0000?0000?l080000ol0000S0003o`0003d0003o020000?o0000
8`000ol0000m0000o`0Q0003o`00024000?o0000?P000?l08P000ol0000O0003o`0003l0003o02<0
00?o00007@000ol000100000o`0T0003o`0001/000?o0000@@000?l09@000ol0000I0003o`000480
003o02H000?o00005`000ol000130000o`0W0003o`0001D000?o0000A0000?l0:0000ol0000C0003
o`0004D0003o02T000?o00004@000ol000160000o`0Z0003o`0000l000?o0000A`000?l0:P000ol0
000?0003o`0004L0003o02/000?o00000P06b`D000?o0000B0000?l0;0000ol0b`09b`8000?o0000
B@000?l0;@0<b`03o`0004X0003o02`03/]<0000o`0[00K;0ol7bd/0003o02/02L/00oo;b`04bd/0
001600Co>003ofh01?lb00O;1?l7bdX000160005o`000?l0>P000ol0001Z0003o`0003@01//01Oo;
bl_o00O;BP0004H000Go0000o`0j0003o`0006X01Olb00K;00Gobl_;o`07bdX000160005o`000?l0
>002ofd000Go0000o`0b00K;00Gobl_;o`07bdX0001600Co>`000ol0001[00?o<`07b`Go1/]:0000
AP000ol0000i00?oY00BbdX0001500;oh`0@bd/0003o02/04<];0000o`0/00k;C0000?l0;@0<bdd0
003o02h02/]>0000B`000ol0000c0003o`0007D000?o0000<`06be00001<0003o`00034000?o0000
MP000ol0000b0003o`0005@0001<0003o`00034000?o0000MP000ol0000b0003o`0005@0001=0003
o`0002l000?o0000N0000ol0000`0003o`0005D0001=0003o`0002l000?o0000N0000ol0000`0003
o`0005D0001=0003o`0002l000?o0000N@000ol0000_0003o`0005D0001>0003o`0002d000?o0000
NP000ol0000^0003o`0005H0001>0003o`0002d000?o0000NP000ol0000^0003o`0005H0001?0003
o`0002/000?o0000O0000ol0000/0003o`0005L0001?0003o`0002/000?o0000O0000ol0000/0003
o`0005L0001@0003o`0002T000?o0000OP000ol0000Z0003o`0005P0001@0003o`0002T000?o0000
OP000ol0000Z0003o`0005P0001@0003o`0002T000?o0000O`000ol0000Y0003o`0005P0001A0003
o`0002L000?o0000P0000ol0000X0003o`0005T0001A0003o`0002L000?o0000P0000ol0000X0003
o`0005T0001B0003o`0002D000?o0000PP000ol0000V0003o`0005X0001B0003o`0002D000?o0000
PP000ol0000V0003o`0005X0001B0003o`0002D000?o0000P`000ol0000U0003o`0005X0001C0003
o`0002<000?o0000Q0000ol0000T0003o`0005/0001C0003o`0002<000?o0000Q@000ol0000S0003
o`0005/0001D0003o`00024000?o0000QP000ol0000R0003o`0005`0001D0003o`00024000?o0000
QP000ol0000R0003o`0005`0001D0003o`00024000?o0000Q`000ol0000Q0003o`0005`0001E0003
o`0001l000?o0000R0000ol0000P0003o`0005d0001E0003o`0001l000?o0000R@000ol0000O0003
o`0005d0001F0003o`0001d000?o0000RP000ol0000N0003o`0005h0001F0003o`0001d000?o0000
RP000ol0000N0003o`0005h0001F0003o`0001d000?o0000R`000ol0000M0003o`0005h0001G0003
o`0001/000?o0000S0000ol0000L0003o`0005l0001G0003o`0001/000?o0000S@000ol0000K0003
o`0005l0001H0003o`0001T000?o0000SP000ol0000J0003o`000600001H0003o`0001T000?o0000
S`000ol0000I0003o`000600001H0003o`0001T000?o0000S`000ol0000I0003o`000600001I0003
o`0001L000?o0000T0000ol0000H0003o`000640001I0003o`0001L000?o0000T@000ol0000G0003
o`000640001J0003o`0001D000?o0000TP000ol0000F0003o`000680001J0003o`0001D000?o0000
T`000ol0000E0003o`000680001J0003o`0001D000?o0000T`000ol0000E0003o`000680001K0003
o`0001<000?o0000U0000ol0000D0003o`0006<0001K0003o`0001<000?o0000U@000ol0000C0003
o`0006<0001L0003o`00014000?o0000UP000ol0000B0003o`0006@0001L0003o`00014000?o0000
U`000ol0000A0003o`0006@0001L0003o`00014000?o0000U`000ol0000A0003o`0006@0001M0003
o`0000l000?o0000V@000ol0000?0003o`0006D0001M0003o`0000l000?o0000V@000ol0000?0003
o`0006D0001N0003o`0000d000?o0000VP000ol0000>0003o`0006H0001N0003o`0000d000?o0000
V`000ol0000=0003o`0006H0001O0003o`0000/000?o0000W0000ol0000<0003o`0006L0001O0003
o`0000/000?o0000W@000ol0000;0003o`0006L0001O0003o`0000/000?o0000W@000ol0000;0003
o`0006L0001P0003o`0000T000?o0000W`000ol000090003o`0006P0001P0003o`0000T000?o0000
W`000ol000090003o`0006P0001Q0003o`0000L000?o0000X0000ol000080003o`0006T0001Q0003
o`0000L000?o0000X@000ol000070003o`0006T0001Q0003o`0000L000?o0000X@000ol000070003
o`0006T0001R0003o`0000D000?o0000X`000ol000050003o`0006X0001R0003o`0000D000?o0000
X`000ol000050003o`0006X0001S00K;00?o0000Y0000oo;b`04b`03o`0006/0001Q00[;Y00:bf`0
001P00c;XP0<bf/0001O00k;X00>bfX0001N00K;0ol7bih04<]Y0000GP09b`03ol_;00C;WP0@bfT0
000<00GoC007b`Co1l]<00CoC007b`;o00?;ool01/]<00Co600000`000Co003oC@06b`05ol_;bol0
1l];0003o`0004h01l/01?o;bol7bdd000?o0000600000`01?m=00K;00Gobl_;o`07bd/000?o0000
CP07b`04ol_;o`O;CP000ol0000G00003`000ol0001;00K;00Gobl_;o`07bd/000Go0000o`1<00O;
00Cobl_o1l]?0003o`0001H0000<00CoC@07b`Go1/]<00CoC007b`Co1l]?0003o`0001H0001M01;;
W007b`03ol_;00S;C003oaT0000H00?o@`0@bih01L/2o`W;A003ob80000K00;o@@0@bih04<]200;o
9@0001d00_m000k;00<0o`00W0000oo;b`0<bd400_lW00007`03och03</30003o`0009T000?o0000
3</o00?o:@0002800_lm00[;1@000ol0002G0003o`0000802//n00;o;00002@00oll00K;20000ol0
002E0003o`0000D01//m00?o;P0002L00_m900;oB@000ol0001700;oB@02oc40000Y00;oB@000ol0
00160003o`0004H000?o0000A`02oc<0000[00?oA`000ol000150003o`0004D000?o0000A@03ocD0
000^00;oAP000ol000140003o`0004@000?o0000A002ocP0000`00?oA0000ol000130003o`0004<0
00?o0000@P03ocX0000c00;o@`000ol000120003o`00048000?o0000@@02ocd0000e00;o@P02od80
00?o0000@002od800_lo0000=`03od4000?o0000?`000ol0000o0003o`0003l00om10000>P02od00
00?o0000?P000ol0000n0003o`0003h00_m40000?002ocl000?o0000?@000ol0000m0003o`0003d0
0_m60000?P03ocd000?o0000?0000ol0000l0003o`0003/00om80000@@02oc`00_ll0003o`0003X0
0_ll00;oB`0004<00olk0003o`0003T000?o0000>@000ol0000i00?oC@0004H00_lj0003o`0003P0
00?o0000>0000ol0000h00;oD00004P00_li0003o`0003L000?o0000=`000ol0000g00;oDP0004X0
0olg0003o`0003H000?o0000=P000ol0000e00?oE00004d00_lf00;o=P000ol0000d00;o=P02oeL0
001?00?o=@000ol0000c0003o`0003<000?o0000<`03oeT0001B00;o=0000ol0000b0003o`000380
00?o0000<P02oe`0001D00;o<`000ol0000a0003o`00034000?o0000<@02oeh0001F00?o<@000ol0
000`0003o`00030000?o0000;`03of00001I00;o<002oc0000?o0000;P02oc000_mS0000F`02oc00
00?o0000;@000ol0000]0003o`0002h00_mU0000G@03obh000?o0000;0000ol0000/0003o`0002`0
0omW0000H002obd000?o0000:`000ol0000[0003o`0002/00_mZ0000HP03ob/000?o0000:P000ol0
000Z0003o`0002T00om/0000I@02obX00_lZ0003o`0002P00_lZ00;oK`0006L00_lZ0003o`0002L0
00?o00009`000ol0000X00;oL@0006T00olX0003o`0002H000?o00009P000ol0000V00?oL`0006`0
0_lW0003o`0002D000?o00009@000ol0000U00;oMP0006h00olU0003o`0002@000?o000090000ol0
000S00?oN00007400_lT0003o`0002<000?o00008`000ol0000R00;oN`0007<00_lS00;o8`000ol0
000Q00;o8`02ogd0001e00?o8P000ol0000P0003o`00020000?o00008003ogl0001h00;o8@000ol0
000O0003o`0001l000?o00007`02oh80001j00;o80000ol0000N0003o`0001h000?o00007P02oh@0
001l00?o7P000ol0000M0003o`0001d000?o00007003ohH0001o00;o7@02oad000?o00006`02oad0
0_n90000P@03oa`000?o00006P000ol0000J0003o`0001X00on;0000Q002oa/000?o00006@000ol0
000I0003o`0001T00_n>0000QP02oaX000?o000060000ol0000H0003o`0001P00_n@0000R003oaP0
00?o00005`000ol0000G0003o`0001H00onB0000R`02oaL00_lG0003o`0001D00_lG00;oU@0008d0
0olF0003o`0001@000?o000050000ol0000D00?oU`0009000_lE0003o`0001<000?o00004`000ol0
000C00;oVP0009800_lD0003o`00018000?o00004P000ol0000B00;oW00009@00olB0003o`000140
00?o00004@000ol0000@00?oWP0009L00_lA00;o4@000ol0000?00;o4@02oj40002I00;o4@000ol0
000>0003o`0000h000?o00003`02oj<0002K00?o3`000ol0000=0003o`0000d000?o00003@03ojD0
002N00;o3P000ol0000<0003o`0000`000?o00003002ojP0002P00?o30000ol0000;0003o`0000/0
00?o00002P03ojX0002S00;o2`000ol0000:0003o`0000X000?o00002@02ojd0002U00;o2P02o`X0
00?o00002002o`X00_n_0000Y`03o`T000?o00001`000ol000070003o`0000L00ona0000ZP02o`P0
00?o00001P000ol000060003o`0000H00_nd0000[003o`H000?o00000P06b`D000?o00001003okH0
002_00;o1@000ol0b`09b`8000?o00000`02okT0002a00;o100<b`03o`0000800_nk0000/`03o`k;
00@0oooo_@000;D04<_00000]@06b`Co1/_00000]008b`03ol_;00O;_`000;@02</00oo;b`07bkl0
002d00S;00?obl/01l^o0000]007b`Co1l^o0000]008b`03ol_;00O;_`000;@02</3o`O;_`000;D0
4<_00000]@0@bl00002f00k;`@000;L03<_20000^00:bl<00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.18184, -0.625483, 0.01152, 
  0.00272373}},
  CellTags->"Mutation - mutant 4"],

Cell[TextData[{
  "Selective mutation 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33652 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .63887 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .62463 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .80041 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .95159 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Mshowa
P
.004 w
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Mshowa
P
1 g
.33652 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33652 .21092 0 0 Mshowa
P
.9 g
.25575 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Mshowa
P
1 g
.4877 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Mshowa
P
.004 w
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .63887 .21092 0 0 Mshowa
P
.004 w
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.80041 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .62463 .01472 0 0 Mshowa
P
1 g
.80041 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .80041 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .97619 .01472 0 0 Mshowa
P
.9 g
.80041 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Mshowa
P
.9 g
.71964 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Mshowa
P
1 g
.95159 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .95159 .40712 0 0 Mshowa
P
.9 g
.4877 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000>h01?ln00Co?P05o`h0003]0003o`00040000Go0000o`0l0005
o`000?l03`000>d000?o0000@0001Ol0003o03`000Go0000o`0?0000k@001Ol0003o03h000Go0000
o`0l0005o`000?l03`000>h01?ln00Co?P04o`l0003o034000?o0000@P000ol0000=0000o`0`00;o
@`02o`l0003o08H0003o08H0003f0003o`0008`0003g0003o`0007<000?o00005@000?P000?o0000
L@000ol0000F0000n@000ol0000f0003o`0003H000?o00005`000?T000?o0000=P000ol0000f0003
o`0001L0003j0003o`0003D000?o0000=@000ol0000H0000n`000ol0000d0003o`0003@000?o0000
6@000?`000?o0000<`000ol0000c0003o`0001X0003m0003o`00038000?o0000<P000ol0000K0000
oP000ol0000a0003o`00034000?o000070000?l000?o0000<0000ol0000`0003o`0001d0003o0040
00?o0000;`000ol0000_0003o`0001h0003o008000?o0000;P000ol0000^0003o`0001l0003o00<0
00?o0000;@000ol0000]0003o`000200003o00@000?o0000;0000ol0000/0003o`000240003o00@0
00?o0000;0000ol0000/0003o`000240003o00D000?o0000:`000ol0000[0003o`000280003o00H0
00?o0000:P000ol0000Z0003o`0002<0003o00L000?o0000:@000ol0000Y0003o`0002@0003o00P0
00?o0000:0000ol0000X0003o`0002D0003o00T000?o00009`000ol0000W0003o`0002H0003o00X0
00?o00009P000ol0000V0003o`0002L0003o00/000?o00009@000ol0000U0003o`0002P0003o00`0
00?o000090000ol0000T0003o`0002T0003o00d000?o00008`000ol0000S0003o`0002X0003o00d0
00?o00008`000ol0000S0003o`0002X0003o00h000?o00008P000ol0000R0003o`0002/0003o00l0
00?o00008@000ol0000Q0003o`0002`0003o010000?o000080000ol0000P0003o`0002d0003o0140
00?o00007`000ol0000O0003o`0002h0003o018000?o00007P000ol0000N0003o`0002l0003o01<0
00?o00007@000ol0000M0003o`000300003o01@000?o000070000ol0000L0003o`000340003o01D0
00?o00006`000ol0000K0003o`000380003o01H000?o00006P000ol0000J0003o`0003<0003o01L0
00?o00006@000ol0000I0003o`0003@0003o01L000?o00006@000ol0000I0003o`0003@0003o01P0
00?o000060000ol0000H0003o`0003D0003o01T000?o00005`000ol0000G0003o`0003H0003o01X0
00?o00005P000ol0000F0003o`0003L0003o01/000?o00005@000ol0000E0003o`0003P0003o01`0
00?o000050000ol0000D0003o`0003T0003o01d000?o00004`000ol0000C0003o`0003X0003o01h0
00?o00004P000ol0000B0003o`0003/0003o01l000?o00004@000ol0000A0003o`0003`0003o0200
00?o000040000ol0000@0003o`0003d0003o020000?o000040000ol0000@0003o`0003d0003o0240
00?o00003`000ol0000?0003o`0003h0003o028000?o00003P000ol0000>0003o`0003l0003o02<0
00?o00003@000ol0000=0003o`000400003o02@000?o000030000ol0000<0003o`000440003o02D0
00?o00002`000ol0000;0003o`000480003o02H000?o00002P000ol0000:0003o`0004<0003o02L0
00?o00002@000ol000090003o`0004@0003o02P000?o000020000ol000080003o`0004D0003o02T0
00?o00001`000ol000070003o`0004H0003o02X000?o00001P000ol000060003o`0004L0003o02X0
00?o00001P000ol000060003o`0004L0003o02/000?o00000P06b`D000?o0000B0000?l0;0000ol0
b`09b`8000?o0000B@000?l0;@0<b`03o`0004X0003o02`03/]<0000o`0[00K;0ol7bd/0003o02/0
2L/00oo;b`04bd/0001600Co>003ofh01?lb00O;1?l7bdX000160005o`000?l0>P000ol0001Z0003
o`0003@01//01Oo;bl_o00O;BP0004H000Go0000o`0j0003o`0006X01Olb00K;00Gobl_;o`07bdX0
00160005o`000?l0>002ofd000Go0000o`0b00K;00Gobl_;o`07bdX0001600Co>`000ol0001[00?o
<`07b`Go1/]:0000AP000ol0000i00?oY00BbdX0001500;oh`0@bd/0003o02/04<];0000o`0/00k;
C0000?l0;@0<bdd0003o02h02/]>0000B`000ol0000c0003o`0007D000?o0000<`06be00001<0003
o`00034000?o0000MP000ol0000b0003o`0005@0001<0003o`00034000?o0000MP000ol0000b0003
o`0005@0001=0003o`0002l000?o0000N0000ol0000`0003o`0005D0001=0003o`0002l000?o0000
N0000ol0000`0003o`0005D0001=0003o`0002l000?o0000N@000ol0000_0003o`0005D0001>0003
o`0002d000?o0000NP000ol0000^0003o`0005H0001>0003o`0002d000?o0000NP000ol0000^0003
o`0005H0001?0003o`0002/000?o0000O0000ol0000/0003o`0005L0001?0003o`0002/000?o0000
O0000ol0000/0003o`0005L0001@0003o`0002T000?o0000OP000ol0000Z0003o`0005P0001@0003
o`0002T000?o0000OP000ol0000Z0003o`0005P0001@0003o`0002T000?o0000O`000ol0000Y0003
o`0005P0001A0003o`0002L000?o0000P0000ol0000X0003o`0005T0001A0003o`0002L000?o0000
P0000ol0000X0003o`0005T0001B0003o`0002D000?o0000PP000ol0000V0003o`0005X0001B0003
o`0002D000?o0000PP000ol0000V0003o`0005X0001B0003o`0002D000?o0000P`000ol0000U0003
o`0005X0001C0003o`0002<000?o0000Q0000ol0000T0003o`0005/0001C0003o`0002<000?o0000
Q@000ol0000S0003o`0005/0001D0003o`00024000?o0000QP000ol0000R0003o`0005`0001D0003
o`00024000?o0000QP000ol0000R0003o`0005`0001D0003o`00024000?o0000Q`000ol0000Q0003
o`0005`0001E0003o`0001l000?o0000R0000ol0000P0003o`0005d0001E0003o`0001l000?o0000
R@000ol0000O0003o`0005d0001F0003o`0001d000?o0000RP000ol0000N0003o`0005h0001F0003
o`0001d000?o0000RP000ol0000N0003o`0005h0001F0003o`0001d000?o0000R`000ol0000M0003
o`0005h0001G0003o`0001/000?o0000S0000ol0000L0003o`0005l0001G0003o`0001/000?o0000
S@000ol0000K0003o`0005l0001H0003o`0001T000?o0000SP000ol0000J0003o`000600001H0003
o`0001T000?o0000S`000ol0000I0003o`000600001H0003o`0001T000?o0000S`000ol0000I0003
o`000600001I0003o`0001L000?o0000T0000ol0000H0003o`000640001I0003o`0001L000?o0000
T@000ol0000G0003o`000640001J0003o`0001D000?o0000TP000ol0000F0003o`000680001J0003
o`0001D000?o0000T`000ol0000E0003o`000680001J0003o`0001D000?o0000T`000ol0000E0003
o`000680001K0003o`0001<000?o0000U0000ol0000D0003o`0006<0001K0003o`0001<000?o0000
U@000ol0000C0003o`0006<0001L0003o`00014000?o0000UP000ol0000B0003o`0006@0001L0003
o`00014000?o0000U`000ol0000A0003o`0006@0001L0003o`00014000?o0000U`000ol0000A0003
o`0006@0001M0003o`0000l000?o0000V@000ol0000?0003o`0006D0001M0003o`0000l000?o0000
V@000ol0000?0003o`0006D0001N0003o`0000d000?o0000VP000ol0000>0003o`0006H0001N0003
o`0000d000?o0000V`000ol0000=0003o`0006H0001O0003o`0000/000?o0000W0000ol0000<0003
o`0006L0001O0003o`0000/000?o0000W@000ol0000;0003o`0006L0001O0003o`0000/000?o0000
W@000ol0000;0003o`0006L0001P0003o`0000T000?o0000W`000ol000090003o`0006P0001P0003
o`0000T000?o0000W`000ol000090003o`0006P0001Q0003o`0000L000?o0000X0000ol000080003
o`0006T0001Q0003o`0000L000?o0000X@000ol000070003o`0006T0001Q0003o`0000L000?o0000
X@000ol000070003o`0006T0001R0003o`0000D000?o0000X`000ol000050003o`0006X0001R0003
o`0000D000?o0000X`000ol000050003o`0006X0001S00K;00?o0000Y0000oo;b`04b`03o`0006/0
001Q00[;Y00:bf`0001P00c;XP0<bf/0001O00k;X00>bfX0001N00K;0ol7bih04<]Y0000GP09b`03
ol_;00C;WP0@bfT0000<00GoC007b`Co1l]<00CoC007b`;o00?;ool01/]<00Co600000`000Co003o
C@06b`05ol_;bol01l];0003o`0004h01l/01?o;bol7bdd000?o0000600000`01?m=00K;00Gobl_;
o`07bd/000?o0000CP07b`04ol_;o`O;CP000ol0000G00003`000ol0001;00K;00Gobl_;o`07bd/0
00Go0000o`1<00O;00Cobl_o1l]?0003o`0001H0000<00CoC@07b`Go1/]<00CoC007b`Co1l]?0003
o`0001H0001M01;;W007b`03ol_;00S;C003oaT0000H00?o@`0@bih01L/2o`W;A003ob80000K00;o
@@0@bih04<]200;o9@0001d00_m000k;00<0o`00W0000oo;b`0<bd400_lW00007`03och03</30003
o`0009T000?o00003</o00?o:@0002800_lm00[;1@000ol0002G0003o`0000802//n00;o;00002@0
0oll00K;20000ol0002E0003o`0000D01//m00?o;P0002L00_m900;oB@000ol0001700;oB@02oc40
000Y00;oB@000ol000160003o`0004H000?o0000A`02oc<0000[00?oA`000ol000150003o`0004D0
00?o0000A@03ocD0000^00;oAP000ol000140003o`0004@000?o0000A002ocP0000`00?oA0000ol0
00130003o`0004<000?o0000@P03ocX0000c00;o@`000ol000120003o`00048000?o0000@@02ocd0
000e00;o@P02od8000?o0000@002od800_lo0000=`03od4000?o0000?`000ol0000o0003o`0003l0
0om10000>P02od0000?o0000?P000ol0000n0003o`0003h00_m40000?002ocl000?o0000?@000ol0
000m0003o`0003d00_m60000?P03ocd000?o0000?0000ol0000l0003o`0003/00om80000@@02oc`0
0_ll0003o`0003X00_ll00;oB`0004<00olk0003o`0003T000?o0000>@000ol0000i00?oC@0004H0
0_lj0003o`0003P000?o0000>0000ol0000h00;oD00004P00_li0003o`0003L000?o0000=`000ol0
000g00;oDP0004X00olg0003o`0003H000?o0000=P000ol0000e00?oE00004d00_lf00;o=P000ol0
000d00;o=P02oeL0001?00?o=@000ol0000c0003o`0003<000?o0000<`03oeT0001B00;o=0000ol0
000b0003o`00038000?o0000<P02oe`0001D00;o<`000ol0000a0003o`00034000?o0000<@02oeh0
001F00?o<@000ol0000`0003o`00030000?o0000;`03of00001I00;o<002oc0000?o0000;P02oc00
0_mS0000F`02oc0000?o0000;@000ol0000]0003o`0002h00_mU0000G@03obh000?o0000;0000ol0
000/0003o`0002`00omW0000H002obd000?o0000:`000ol0000[0003o`0002/00_mZ0000HP03ob/0
00?o0000:P000ol0000Z0003o`0002T00om/0000I@02obX00_lZ0003o`0002P00_lZ00;oK`0006L0
0_lZ0003o`0002L000?o00009`000ol0000X00;oL@0006T00olX0003o`0002H000?o00009P000ol0
000V00?oL`0006`00_lW0003o`0002D000?o00009@000ol0000U00;oMP0006h00olU0003o`0002@0
00?o000090000ol0000S00?oN00007400_lT0003o`0002<000?o00008`000ol0000R00;oN`0007<0
0_lS00;o8`000ol0000Q00;o8`02ogd0001e00?o8P000ol0000P0003o`00020000?o00008003ogl0
001h00;o8@000ol0000O0003o`0001l000?o00007`02oh80001j00;o80000ol0000N0003o`0001h0
00?o00007P02oh@0001l00?o7P000ol0000M0003o`0001d000?o00007003ohH0001o00;o7@02oad0
00?o00006`02oad00_n90000P@03oa`000?o00006P000ol0000J0003o`0001X00on;0000Q002oa/0
00?o00006@000ol0000I0003o`0001T00_n>0000QP02oaX000?o000060000ol0000H0003o`0001P0
0_n@0000R003oaP000?o00005`000ol0000G0003o`0001H00onB0000R`02oaL00_lG0003o`0001D0
0_lG00;oU@0008d00olF0003o`0001@000?o000050000ol0000D00?oU`0009000_lE0003o`0001<0
00?o00004`000ol0000C00;oVP0009800_lD0003o`00018000?o00004P000ol0000B00;oW00009@0
0olB0003o`00014000?o00004@000ol0000@00?oWP0009L00_lA00;o4@000ol0000?00;o4@02oj40
002I00;o4@000ol0000>0003o`0000h000?o00003`02oj<0002K00?o3`000ol0000=0003o`0000d0
00?o00003@03ojD0002N00;o3P000ol0000<0003o`0000`000?o00003002ojP0002P00?o30000ol0
000;0003o`0000/000?o00002P03ojX0002S00;o2`000ol0000:0003o`0000X000?o00002@02ojd0
002U00;o2P02o`X000?o00002002o`X00_n_0000Y`03o`T000?o00001`000ol000070003o`0000L0
0ona0000ZP02o`P000?o00001P000ol000060003o`0000H00_nd0000[003o`H000?o00000P06b`D0
00?o00001003okH0002_00;o1@000ol0b`09b`8000?o00000`02okT0002a00;o100<b`03o`000080
0_nk0000/`03o`k;00@0oooo_@000;D04<_00000]@06b`Co1/_00000]008b`03ol_;00O;_`000;@0
2</00oo;b`07bkl0002d00S;00?obl/01l^o0000]007b`Co1l^o0000]008b`03ol_;00O;_`000;@0
2</3o`O;_`000;D04<_00000]@0@bl00002f00k;`@000;L03<_20000^00:bl<00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.18184, -0.625483, 0.01152, 
  0.00272373}},
  CellTags->"Mutation - mutant 5"],

Cell[TextData[{
  "Selective mutation 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 6",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004oel00ol@0000o`0?0003o`0006@000?o00003@000?l0
3`000ol0001T0003o`0000d0003o00l000Go0000o`1P00;o40000?l04004of8000?o00003@000?l0
L`03oa00003o08H0003o08H0003o08H0003o01P000?o0000J`000?l06@000ol0001B0003o`0001D0
003o01X000?o0000D0000ol0000F0000o`0J0003o`0004l000?o00005`000?l06`000ol0001=0003
o`0001P0003o01`000?o0000C0000ol0000H0000o`0M0003o`0004X000?o00006@000?l07P000ol0
00180003o`0001X0003o01l000?o0000AP000ol0000K0000o`0P0003o`0004@000?o000070000?l0
8@000ol000120003o`0001d0003o028000?o0000@0000ol0000N0000o`0R0003o`0003l000?o0000
7`000?l08`000ol0000m0003o`000200003o02@000?o0000>`000ol0000Q0000o`0U0003o`0003T0
00?o00008P000?l09P000ol0000h0003o`000280003o02L000?o0000=P000ol0000S0000o`0X0003
o`0003@000?o000090000?l0:@000ol0000b0003o`0002D0003o02X000?o0000<0000ol0000V0000
o`0[0003o`0002h000?o00009`000?l0:`000ol0000]0003o`0002P0003o02`000?o0000:`000ol0
000Y0000o`0]0003o`0002T000?o0000:P000?l0;P000ol0000W0003o`0002/0003o02l000?o0000
9@000ol0000/0000o`0`0003o`0002@000?o0000;0000?l0<@000ol0000R0003o`0002d0003o0380
00?o000080000ol0000^0000o`0c0003o`0001h000?o0000;`000?l0<`000ol0000M0003o`000300
003o03@000?o00006`000ol0000a0000o`0e0003o`0001T000?o0000<P000?l0=P000ol0000G0003
o`0003<0003o03L000?o00005@000ol0000d0000o`0h0003o`0001<000?o0000=@000?l0>@000ol0
000A0003o`0003H0003o03X000?o000040000ol0000f0000o`0k0003o`0000h000?o0000=`000?l0
>`000ol0000300K;10000ol0000h0000o`0l0003o`0000[;00<0o`00>P000?l0?@000oo;b`0:bc`0
003o03d03//k0000o`0l00G;0ol8bcX0003o03`02</00oo;b`05bcX0003?00CoI`06b`Co2</i0000
cP000ol0001Y00G;00Gobl_;o`08bcT0003>0003o`0006T01L/01Oo;bl_o00S;>@000<h000Go0000
o`1W00G;00Gobl_;o`08bcT0003?00CoI`06b`Go1l/i0000o`0k01;;>@000?l0?00@bcX0003o03`0
4</j0000f0000ol0001P0003ol_;00c;>`000=T000?o0000GP000ol0000<bc`0003J0003o`0005`0
00?o00000P0:bcd0003K0003o`0005X000?o00001@06bcl0003L0003o`0005P000?o0000B`000=d0
00?o0000EP000ol0001<0000gP000ol0001D0003o`0004d0003O0003o`00058000?o0000CP000>00
00?o0000D0000ol0001?0000h@000ol0001>0003o`000500003R0003o`0004`000?o0000D@000><0
00?o0000BP000ol0001B0000i0000ol000180003o`0005<0003U0003o`0004H000?o0000E0000>H0
00?o0000A0000ol0001E0000i`000ol000120003o`0005H0003X0003o`00040000?o0000E`000>T0
00?o0000?P000ol0001H0000jP000ol0000l0003o`0005T0003[0003o`0003X000?o0000FP000>`0
00?o0000>0000ol0001K0000k@02ocL000?o0000G0000>l000?o0000<`000ol0001M0000l0000ol0
000a0003o`0005h0003a0003o`0002l000?o0000G`000?8000?o0000;@000ol0001P0000l`000ol0
000[0003o`000640003d0003o`0002T000?o0000HP000?D000?o00009`000ol0001S0000mP000ol0
000U0003o`0006@0003g0003o`0002<000?o0000I@000?P000?o00008@000ol0001V0000n@000ol0
000O0003o`0006L0003j0003o`0001d000?o0000J0000?/000?o00006`000ol0001Y0000o0000ol0
000I0003o`0006X0003m0003o`0001L000?o0000J`000?h000?o00005@000ol0001/0000o`000ol0
000C0003o`0006d0003o004000?o00004@000ol0001^0000o`020003o`0000l000?o0000K`000?l0
0`000ol0000200K;1@000ol0001`0000o`040003o`3;00W;0P000ol0001a0000o`0500c;00?o0000
LP000?l0100>bg@0003o00<01//3o`O;L`000?l00`09b`03ol_;00C;L`0003h01?l`00?oG`04obT0
1l/4o`O;LP0003h000Go0000o`0b0003o`0005/000?o0000:`06b`05ol_;bol01l]b0000?P001Ol0
003o038000?o0000F`05obT01//01Oo;bl_o00O;LP0003h000Go0000o`0`00;oGP001Ol0003o02T0
1//01Oo;bl_o00O;LP0003h01?lc0003o`0005`00olZ00O;1Ol6bg80000n0003o`0003400on<01;;
LP0003d00_o3013;L`000?l00`0@bg<0003o00@03/]d0000o`0500c;M@000?l01P0:bgH000140003
o`0002T000?o0000I`000ol0000Y0003ol_;00C;N00004@000?o0000:@000ol0001W0003o`0002T0
00?o0000O00004D000?o00009`000ol0001Y0003o`0002L000?o0000O@0004D000?o00009`000ol0
001Y0003o`0002L000?o0000O@0004H000?o00009@000ol0001[0003o`0002D000?o0000OP0004H0
00?o00009@000ol0001[0003o`0002D000?o0000OP0004L000?o00008`000ol0001]0003o`0002<0
00?o0000O`0004L000?o00008`000ol0001]0003o`0002<000?o0000O`0004P000?o00008@000ol0
001_0003o`00024000?o0000P00004P000?o00008@000ol0001_0003o`00024000?o0000P00004T0
00?o00007`000ol0001a0003o`0001l000?o0000P@0004T000?o00007`000ol0001a0003o`0001l0
00?o0000P@0004X000?o00007@000ol0001c0003o`0001d000?o0000PP0004X000?o00007@000ol0
001c0003o`0001d000?o0000PP0004/000?o00006`000ol0001e0003o`0001/000?o0000P`0004/0
00?o00006`000ol0001e0003o`0001/000?o0000P`0004`000?o00006@000ol0001g0003o`0001T0
00?o0000Q00004`000?o00006@000ol0001g0003o`0001T000?o0000Q00004d000?o00005`000ol0
001i0003o`0001L000?o0000Q@0004d000?o00005`000ol0001i0003o`0001L000?o0000Q@0004d0
00?o00005`000ol0001i0003o`0001L000?o0000Q@0004h000?o00005@000ol0001k0003o`0001D0
00?o0000QP0004h000?o00005@000ol0001k0003o`0001D000?o0000QP0004l000?o00004`000ol0
001m0003o`0001<000?o0000Q`0004l000?o00004`000ol0001m0003o`0001<000?o0000Q`000500
00?o00004@000ol0001o0003o`00014000?o0000R000050000?o00004@000ol0001o0003o`000140
00?o0000R000054000?o00003`000ol000210003o`0000l000?o0000R@00054000?o00003`000ol0
00210003o`0000l000?o0000R@00058000?o00003@000ol000230003o`0000d000?o0000RP000580
00?o00003@000ol000230003o`0000d000?o0000RP0005<000?o00002`000ol000250003o`0000/0
00?o0000R`0005<000?o00002`000ol000250003o`0000/000?o0000R`0005@000?o00002@000ol0
00270003o`0000T000?o0000S00005@000?o00002@000ol000270003o`0000T000?o0000S00005D0
00?o00001`000ol000290003o`0000L000?o0000S@0005D000?o00001`000ol000290003o`0000L0
00?o0000S@0005H000?o00001@000ol0002;0003o`0000D000?o0000SP0005H000?obl/01</00`3o
002<0003ol_;00C;00<0o`00S`0005D02/^<00[;T00005@03<^:00c;S`0005<03/^800k;SP000580
1//3o`O;QP0@bhd0001B00W;00?obl/01<^6013;S@0000`01Om000O;1?l7bd001?m000O;0_l00l_o
o`06bcl01?m9000030001?l00?m100K;00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;@0000ol0
001900003004od401//01Oo;bl_o00O;?`000ol0001200O;00Cobl_o1l]10003o`0004P0000?0003
o`0003l01//01Oo;bl_o00O;?`001Ol0003o04001l/01?o;bol7bd8000?o0000A`0000`01?m100O;
1Ol6bd001?m000O;1?l7bd8000?o0000A`0001P00_lg01;;Q007b`03ol_;00S;>0000ol0000400?o
BP0001X00_lf013;QP05b`;o2L/f00?oE00001`00olc013;00?o0000P`0@bc<00omG00007`03oc40
3//20003o`00084000?o0</03L/a00?oFP0002800_l`00c;10000ol0001o0004o`0000c;<002oed0
000T00?o;P0:b`H00_mm00;o1@0:bbh00omO00009`03obd01//:0003o`0007T000?o00001`06bbd0
0omR0000:P03oc/000?o0000>P000ol0000j0003o`0003T00_mU0000;@02ocX00_lj0003o`0003P0
0_li00?oI`0002l00oli0003o`0003L000?o0000=`000ol0000f00?oJP0003800olg0003o`0003H0
00?o0000=P000ol0000d00?oK@0003D00ole00;o=P000ol0000d00;o=@02og00000h00;o=@000ol0
000c0003o`0003<000?o0000<P03og80000j00?o<`02oc<000?o0000<@02oc800ome0000?@03oc80
00?o0000<0000ol0000`0003o`0003000_mh0000@002oc4000?o0000;`000ol0000_0003o`0002h0
0omj0000@P03obl00_l_0003o`0002d00_l^00?oO@0004D00ol^0003o`0002`000?o0000;0000ol0
000[00?oP00004P00ol/0003o`0002/000?o0000:`000ol0000Z00;oP`0004/00_l[00;o:`000ol0
000Y00;o:P03ohD0001=00?o:P000ol0000X0003o`0002P000?o00009`03ohP0001@00?o:0000ol0
000W0003o`0002L000?o00009P02oh/0001C00?o9P02obL000?o00009@02obH00on=0000EP02obH0
00?o000090000ol0000T0003o`0002<00on@0000F003ob@00_lT0003o`0002800_lS00?oT`0005/0
0olS0003o`00024000?o00008@000ol0000Q00;oUP0005h00_lR0003o`00020000?o000080000ol0
000O00?oV00006000olP00;o80000ol0000N00;o7`03oi/0001S00?o7`000ol0000M0003o`0001d0
00?o00007@02oih0001V00?o7@000ol0000L0003o`0001`000?o00006`03oj00001Y00;o7002oa`0
00?o00006P02oa/00onS0000J`03oa/000?o00006@000ol0000I0003o`0001T00_nV0000KP03oaT0
00?o000060000ol0000H0003o`0001L00onX0000L@03oaL00_lH0003o`0001H00_lG00?oZ`0007@0
0_lG0003o`0001D000?o00005@000ol0000D00?o[P0007H00olE00;o5@000ol0000C00;o5@02ok40
001i00?o50000ol0000B0003o`00018000?o00004P03ok<0001l00;o4`000ol0000A0003o`000140
00?o00004003okH0001n00?o4@02oa4000?o00003`02oa400_ni0000P@03oa0000?o00003P000ol0
000>0003o`0000h00onk0000Q003o`h000?o00003@000ol0000=0003o`0000`00onn0000Q`02o`d0
0_l=0003o`0000/00_l<00?o`@0008T00ol<0003o`0000X000?o00002P000ol0000:00;oa00008`0
0ol:0003o`0000T000?o00002@000ol0000800?oaP0008l00ol800;o2@000ol0000700;o2003olT0
002B00;o20000ol0000300K;1P000ol0000600;oc00009@00ol600;o00<0bl/02</200;o1P03olh0
002G00?o1@0<b`03o`0000<00ooA0000VP02o`803//200?oe00009`000?obl/03//00ol0003E0000
W@06b`Co1/_H0000W008b`03ol_;00O;e`0009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000
W007b`Co1l_G0000W008b`03ol_;00O;e`0009`02</3o`O;e`0009d04<_H0000W@0@bmP0002N00k;
f@0009l03<_J0000X00:bm/00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"Mutation - mutant 6"],

Cell[TextData[{
  "Selective mutation 6: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 7",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .84435 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.84435 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.84435 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .84435 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004obd00ol_00Co3`000?l040001Ol0003o02l000?o0000
:`000ol0000A0000o`0@0005o`000?l0;`000ol0000[00Go3`000?l040001Ol0003o02d00_l^0005
o`000?l03`000?l04004oc0000?o0000;003oa00003o010000?o0000;P03od80003o00l00_me0000
o`260000o`260000o`0H0003o`0006/0003o01T000?o0000DP000ol0000E0000o`0J0003o`000500
00?o00005P000?l06P000ol0000V0003o`0002H000?o00005`000?l06`000ol0000U0003o`0002D0
00?o000060000?l070000ol0000T0003o`0002D000?o000060000?l07@000ol0000S0003o`0002@0
00?o00006@000?l07P000ol0000R0003o`0002<000?o00006P000?l07`000ol0000Q0003o`000280
00?o00006`000?l080000ol0000P0003o`00024000?o000070000?l08@000ol0000O0003o`000200
00?o00007@000?l08P000ol0000N0003o`0001l000?o00007P000?l08P000ol0000N0003o`0001h0
00?o00007`000?l08`000ol0000M0003o`0001d000?o000080000?l090000ol0000L0003o`0001`0
00?o00008@000?l09@000ol0000K0003o`0001/000?o00008P000?l09P000ol0000J0003o`0001/0
00?o00008P000?l09`000ol0000I0003o`0001X000?o00008`000?l0:0000ol0000H0003o`0001T0
00?o000090000?l0:@000ol0000G0003o`0001P000?o00009@000?l0:P000ol0000F0003o`0001L0
00?o00009P000?l0:`000ol0000E0003o`0001H000?o00009`000?l0:`000ol0000E0003o`0001D0
00?o0000:0000?l0;0000ol0000D0003o`0001@000?o0000:@000?l0;@000ol0000C0003o`0001<0
00?o0000:P000?l0;P000ol0000B0003o`00018000?o0000:`000?l0;`000ol0000A0003o`000140
00?o0000;0000?l0<0000ol0000@0003o`00014000?o0000;0000?l0<@000ol0000?0003o`000100
00?o0000;@000?l0<P000ol0000>0003o`0000l000?o0000;P000?l0<`000ol0000=0003o`0000h0
00?o0000;`000?l0<`000ol0000=0003o`0000d000?o0000<0000?l0=0000ol0000<0003o`0000`0
00?o0000<@000?l0=@000ol0000;0003o`0000/000?o0000<P000?l0=P000ol0000:0003o`0000X0
00?o0000<`000?l0=`000ol000090003o`0000T000?o0000=0000?l0>0000ol000080003o`0000P0
00?o0000=@000?l0>@000ol000070003o`0000L000?o0000=P000?l0>P000ol000060003o`0000L0
00?o0000=P000?l0>`000ol000050003o`0000H000?o0000=`000?l0>`000ol0000300K;10000ol0
000h0000o`0l0003o`0000[;00<0o`00>P000?l0?@000oo;b`0:bc`0003o03d03//k0000o`0l00G;
0ol8bcX0003o03`02</00oo;b`05bcX0003?00CoI`06b`Co2</i0000cP000ol0001Y00G;00Gobl_;
o`08bcT0003>0003o`0006T01L/01Oo;bl_o00S;>@000<h000Go0000o`1W00G;00Gobl_;o`08bcT0
003?00CoI`06b`Go1l/i0000o`0k01;;>@000?l0?00@bcX0003o03`04</j0000f0000ol0001P0003
ol_;00c;>`000=T000?o0000GP000ol0000<bc`0003J0003o`0005`000?o00000P0:bcd0003K0003
o`0005X000?o00001@06bcl0003L0003o`0005P000?o0000B`000=d000?o0000EP000ol0001<0000
gP000ol0001D0003o`0004d0003O0003o`00058000?o0000CP000>0000?o0000D0000ol0001?0000
h@000ol0001>0003o`000500003R0003o`0004`000?o0000D@000><000?o0000BP000ol0001B0000
i0000ol000180003o`0005<0003U0003o`0004H000?o0000E0000>H000?o0000A0000ol0001E0000
i`000ol000120003o`0005H0003X0003o`00040000?o0000E`000>T000?o0000?P000ol0001H0000
jP000ol0000l0003o`0005T0003[0003o`0003X000?o0000FP000>`000?o0000>0000ol0001K0000
k@02ocL000?o0000G0000>l000?o0000<`000ol0001M0000l0000ol0000a0003o`0005h0003a0003
o`0002l000?o0000G`000?8000?o0000;@000ol0001P0000l`000ol0000[0003o`000640003d0003
o`0002T000?o0000HP000?D000?o00009`000ol0001S0000mP000ol0000U0003o`0006@0003g0003
o`0002<000?o0000I@000?P000?o00008@000ol0001V0000n@000ol0000O0003o`0006L0003j0003
o`0001d000?o0000J0000?/000?o00006`000ol0001Y0000o0000ol0000I0003o`0006X0003m0003
o`0001L000?o0000J`000?h000?o00005@000ol0001/0000o`000ol0000C0003o`0006d0003o0040
00?o00004@000ol0001^0000o`020003o`0000l000?o0000K`000?l00`000ol0000200K;1@000ol0
001`0000o`040003o`3;00W;0P000ol0001a0000o`0500c;00?o0000LP000?l0100>bg@0003o00<0
1//3o`O;L`000?l00`09b`03ol_;00C;L`0003h01?l`00?oG`04obT01l/4o`O;LP0003h000Go0000
o`0b0003o`0005/000?o0000:`06b`05ol_;bol01l]b0000?P001Ol0003o038000?o0000F`05obT0
1//01Oo;bl_o00O;LP0003h000Go0000o`0`00;oGP001Ol0003o02T01//01Oo;bl_o00O;LP0003h0
1?lc0003o`0005`00olZ00O;1Ol6bg80000n0003o`0003400on<01;;LP0003d00_o3013;L`000?l0
0`0@bg<0003o00@03/]d0000o`0500c;M@000?l01P0:bgH000140003o`0002T000?o0000I`000ol0
000Y0003ol_;00C;N00004@000?o0000:@000ol0001W0003o`0002T000?o0000O00004D000?o0000
9`000ol0001Y0003o`0002L000?o0000O@0004D000?o00009`000ol0001Y0003o`0002L000?o0000
O@0004H000?o00009@000ol0001[0003o`0002D000?o0000OP0004H000?o00009@000ol0001[0003
o`0002D000?o0000OP0004L000?o00008`000ol0001]0003o`0002<000?o0000O`0004L000?o0000
8`000ol0001]0003o`0002<000?o0000O`0004P000?o00008@000ol0001_0003o`00024000?o0000
P00004P000?o00008@000ol0001_0003o`00024000?o0000P00004T000?o00007`000ol0001a0003
o`0001l000?o0000P@0004T000?o00007`000ol0001a0003o`0001l000?o0000P@0004X000?o0000
7@000ol0001c0003o`0001d000?o0000PP0004X000?o00007@000ol0001c0003o`0001d000?o0000
PP0004/000?o00006`000ol0001e0003o`0001/000?o0000P`0004/000?o00006`000ol0001e0003
o`0001/000?o0000P`0004`000?o00006@000ol0001g0003o`0001T000?o0000Q00004`000?o0000
6@000ol0001g0003o`0001T000?o0000Q00004d000?o00005`000ol0001i0003o`0001L000?o0000
Q@0004d000?o00005`000ol0001i0003o`0001L000?o0000Q@0004d000?o00005`000ol0001i0003
o`0001L000?o0000Q@0004h000?o00005@000ol0001k0003o`0001D000?o0000QP0004h000?o0000
5@000ol0001k0003o`0001D000?o0000QP0004l000?o00004`000ol0001m0003o`0001<000?o0000
Q`0004l000?o00004`000ol0001m0003o`0001<000?o0000Q`00050000?o00004@000ol0001o0003
o`00014000?o0000R000050000?o00004@000ol0001o0003o`00014000?o0000R000054000?o0000
3`000ol000210003o`0000l000?o0000R@00054000?o00003`000ol000210003o`0000l000?o0000
R@00058000?o00003@000ol000230003o`0000d000?o0000RP00058000?o00003@000ol000230003
o`0000d000?o0000RP0005<000?o00002`000ol000250003o`0000/000?o0000R`0005<000?o0000
2`000ol000250003o`0000/000?o0000R`0005@000?o00002@000ol000270003o`0000T000?o0000
S00005@000?o00002@000ol000270003o`0000T000?o0000S00005D000?o00001`000ol000290003
o`0000L000?o0000S@0005D000?o00001`000ol000290003o`0000L000?o0000S@0005H000?o0000
1@000ol0002;0003o`0000D000?o0000SP0005H000?obl/01</00`3o002<0003ol_;00C;00<0o`00
S`0005D02/^<00[;T00005@03<^:00c;S`0005<03/^800k;SP0005801//3o`O;QP0@bhd0001B00W;
00?obl/01<^6013;S@0000`01Om000O;1?l7bd001?m000O;0_l00l_oo`06bcl01?m9000030001?l0
0?m100K;00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;@0000ol0001900003004od401//01Oo;
bl_o00O;?`000ol0001200O;00Cobl_o1l]10003o`0004P0000?0003o`0003l01//01Oo;bl_o00O;
?`001Ol0003o04001l/01?o;bol7bd8000?o0000A`0000`01?m100O;1Ol6bd001?m000O;1?l7bd80
00?o0000A`0001P00_lg01;;Q007b`03ol_;00S;>0000ol0000400?oBP0001X00_lf013;QP05b`;o
2L/f00?oE00001`00olc013;00?o0000P`0@bc<00omG00007`03oc403//20003o`00084000?o0</0
3L/a00?oFP0002800_l`00c;10000ol0001o0004o`0000c;<002oed0000T00?o;P0:b`H00_mm00;o
1@0:bbh00omO00009`03obd01//:0003o`0007T000?o00001`06bbd00omR0000:P03oc/000?o0000
>P000ol0000j0003o`0003T00_mU0000;@02ocX00_lj0003o`0003P00_li00?oI`0002l00oli0003
o`0003L000?o0000=`000ol0000f00?oJP0003800olg0003o`0003H000?o0000=P000ol0000d00?o
K@0003D00ole00;o=P000ol0000d00;o=@02og00000h00;o=@000ol0000c0003o`0003<000?o0000
<P03og80000j00?o<`02oc<000?o0000<@02oc800ome0000?@03oc8000?o0000<0000ol0000`0003
o`0003000_mh0000@002oc4000?o0000;`000ol0000_0003o`0002h00omj0000@P03obl00_l_0003
o`0002d00_l^00?oO@0004D00ol^0003o`0002`000?o0000;0000ol0000[00?oP00004P00ol/0003
o`0002/000?o0000:`000ol0000Z00;oP`0004/00_l[00;o:`000ol0000Y00;o:P03ohD0001=00?o
:P000ol0000X0003o`0002P000?o00009`03ohP0001@00?o:0000ol0000W0003o`0002L000?o0000
9P02oh/0001C00?o9P02obL000?o00009@02obH00on=0000EP02obH000?o000090000ol0000T0003
o`0002<00on@0000F003ob@00_lT0003o`0002800_lS00?oT`0005/00olS0003o`00024000?o0000
8@000ol0000Q00;oUP0005h00_lR0003o`00020000?o000080000ol0000O00?oV00006000olP00;o
80000ol0000N00;o7`03oi/0001S00?o7`000ol0000M0003o`0001d000?o00007@02oih0001V00?o
7@000ol0000L0003o`0001`000?o00006`03oj00001Y00;o7002oa`000?o00006P02oa/00onS0000
J`03oa/000?o00006@000ol0000I0003o`0001T00_nV0000KP03oaT000?o000060000ol0000H0003
o`0001L00onX0000L@03oaL00_lH0003o`0001H00_lG00?oZ`0007@00_lG0003o`0001D000?o0000
5@000ol0000D00?o[P0007H00olE00;o5@000ol0000C00;o5@02ok40001i00?o50000ol0000B0003
o`00018000?o00004P03ok<0001l00;o4`000ol0000A0003o`00014000?o00004003okH0001n00?o
4@02oa4000?o00003`02oa400_ni0000P@03oa0000?o00003P000ol0000>0003o`0000h00onk0000
Q003o`h000?o00003@000ol0000=0003o`0000`00onn0000Q`02o`d00_l=0003o`0000/00_l<00?o
`@0008T00ol<0003o`0000X000?o00002P000ol0000:00;oa00008`00ol:0003o`0000T000?o0000
2@000ol0000800?oaP0008l00ol800;o2@000ol0000700;o2003olT0002B00;o20000ol0000300K;
1P000ol0000600;oc00009@00ol600;o00<0bl/02</200;o1P03olh0002G00?o1@0<b`03o`0000<0
0ooA0000VP02o`803//200?oe00009`000?obl/03//00ol0003E0000W@06b`Co1/_H0000W008b`03
ol_;00O;e`0009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000W007b`Co1l_G0000W008b`03
ol_;00O;e`0009`02</3o`O;e`0009d04<_H0000W@0@bmP0002N00k;f@0009l03<_J0000X00:bm/0
0000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"Mutation - mutant 7"],

Cell[TextData[{
  "Selective mutation 7: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 8",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .84435 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.84435 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.84435 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .84435 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000?l04004obl00ol]00Co3`000?l040001Ol0003o02l000?o0000
;@000ol0000?0000o`0@0005o`000?l0;005obl000?o00003P000?l040001Ol0003o02d000?o0?l0
<@000ol0000=0000o`0@00Co;P000ol0o`0a0003o`0000d0003o010000?o0000<002obh00ol@0000
o`0?00;oM@000?l0QP000?l0QP000?l060000ol0001[0000o`0I0003o`00058000?o00005@000?l0
6P000ol0001@0003o`0001H0003o01X000?o00009P000ol0000V0003o`0001L0003o01/000?o0000
9@000ol0000U0003o`0001P0003o01`000?o000090000ol0000U0003o`0001P0003o01d000?o0000
8`000ol0000T0003o`0001T0003o01h000?o00008P000ol0000S0003o`0001X0003o01l000?o0000
8@000ol0000R0003o`0001/0003o020000?o000080000ol0000Q0003o`0001`0003o024000?o0000
7`000ol0000P0003o`0001d0003o028000?o00007P000ol0000O0003o`0001h0003o028000?o0000
7P000ol0000N0003o`0001l0003o02<000?o00007@000ol0000M0003o`000200003o02@000?o0000
70000ol0000L0003o`000240003o02D000?o00006`000ol0000K0003o`000280003o02H000?o0000
6P000ol0000K0003o`000280003o02L000?o00006@000ol0000J0003o`0002<0003o02P000?o0000
60000ol0000I0003o`0002@0003o02T000?o00005`000ol0000H0003o`0002D0003o02X000?o0000
5P000ol0000G0003o`0002H0003o02/000?o00005@000ol0000F0003o`0002L0003o02/000?o0000
5@000ol0000E0003o`0002P0003o02`000?o000050000ol0000D0003o`0002T0003o02d000?o0000
4`000ol0000C0003o`0002X0003o02h000?o00004P000ol0000B0003o`0002/0003o02l000?o0000
4@000ol0000A0003o`0002`0003o030000?o000040000ol0000A0003o`0002`0003o034000?o0000
3`000ol0000@0003o`0002d0003o038000?o00003P000ol0000?0003o`0002h0003o03<000?o0000
3@000ol0000>0003o`0002l0003o03<000?o00003@000ol0000=0003o`000300003o03@000?o0000
30000ol0000<0003o`000340003o03D000?o00002`000ol0000;0003o`000380003o03H000?o0000
2P000ol0000:0003o`0003<0003o03L000?o00002@000ol000090003o`0003@0003o03P000?o0000
20000ol000080003o`0003D0003o03T000?o00001`000ol000070003o`0003H0003o03X000?o0000
1P000ol000070003o`0003H0003o03/000?o00001@000ol000060003o`0003L0003o03/000?o0000
0`06b`@000?o0000>0000?l0?0000ol0000:b`030?l003X0003o03d000?obl/02//l0000o`0m00k;
>`000?l0?005b`?o2</j0000o`0l00S;00?obl/01L/j0000c`04ofL01//4o`S;>@000<h000?o0000
J@05b`05ol_;bol02</i0000cP000ol0001Y00G;00Gobl_;o`08bcT0003>0005o`000?l0I`05b`05
ol_;bol02</i0000c`04ofL01//5o`O;>@000?l0>`0BbcT0003o03`04</j0000o`0l013;>P000=P0
00?o0000H0000oo;b`0<bc/0003I0003o`0005h000?o00003</l0000fP000ol0001L0003o`000080
2//m0000f`000ol0001J0003o`0000D01//o0000g0000ol0001H0003o`0004/0003M0003o`0005H0
00?o0000C0000=h000?o0000E0000ol0001=0000g`000ol0001B0003o`0004h0003P0003o`000500
00?o0000C`000>4000?o0000CP000ol0001@0000hP000ol0001<0003o`000540003S0003o`0004X0
00?o0000DP000>@000?o0000B0000ol0001C0000i@000ol000160003o`0005@0003V0003o`0004@0
00?o0000E@000>L000?o0000@P000ol0001F0000j0000ol000100003o`0005L0003Y0003o`0003h0
00?o0000F0000>X000?o0000?0000ol0001I0000j`000ol0000j0003o`0005X0003/0003o`0003P0
00?o0000F`000>d00_lg0003o`0005`0003_0003o`0003<000?o0000G@000?0000?o0000<@000ol0
001N0000l@000ol0000_0003o`0005l0003b0003o`0002d000?o0000H0000?<000?o0000:`000ol0
001Q0000m0000ol0000Y0003o`000680003e0003o`0002L000?o0000H`000?H000?o00009@000ol0
001T0000m`000ol0000S0003o`0006D0003h0003o`00024000?o0000IP000?T000?o00007`000ol0
001W0000nP000ol0000M0003o`0006P0003k0003o`0001/000?o0000J@000?`000?o00006@000ol0
001Z0000o@000ol0000G0003o`0006/0003n0003o`0001D000?o0000K0000?l000?o00004`000ol0
001]0000o`010003o`00014000?o0000KP000?l00P000ol0000?0003o`0006l0003o00<000?o0000
0P06b`D000?o0000L0000?l010000ol0b`09b`8000?o0000L@000?l01@0<b`03o`000780003o00@0
3/]d0000o`0300K;0ol7bg<0003o00<02L/00oo;b`04bg<0000n00Co<003oel01?lY00O;1?l7bg80
000n0005o`000?l0<P000ol0001K0003o`0002/01//01Oo;bl_o00O;LP0003h000Go0000o`0b0003
o`0005/01OlY00K;00Gobl_;o`07bg80000n0005o`000?l0<002oeh000Go0000o`0Y00K;00Gobl_;
o`07bg80000n00Co<`000ol0001L00?o:P07b`Go1/]b0000?P000ol0000a00?oS00Bbg80000m00;o
``0@bg<0003o00<04<]c0000o`0400k;M0000?l01@0<bgD0003o00H02/]f0000A0000ol0000Y0003
o`0006L000?o0000:@000oo;b`04bgP000140003o`0002T000?o0000I`000ol0000Y0003o`0007`0
00150003o`0002L000?o0000J@000ol0000W0003o`0007d000150003o`0002L000?o0000J@000ol0
000W0003o`0007d000160003o`0002D000?o0000J`000ol0000U0003o`0007h000160003o`0002D0
00?o0000J`000ol0000U0003o`0007h000170003o`0002<000?o0000K@000ol0000S0003o`0007l0
00170003o`0002<000?o0000K@000ol0000S0003o`0007l000180003o`00024000?o0000K`000ol0
000Q0003o`00080000180003o`00024000?o0000K`000ol0000Q0003o`00080000190003o`0001l0
00?o0000L@000ol0000O0003o`00084000190003o`0001l000?o0000L@000ol0000O0003o`000840
001:0003o`0001d000?o0000L`000ol0000M0003o`000880001:0003o`0001d000?o0000L`000ol0
000M0003o`000880001;0003o`0001/000?o0000M@000ol0000K0003o`0008<0001;0003o`0001/0
00?o0000M@000ol0000K0003o`0008<0001<0003o`0001T000?o0000M`000ol0000I0003o`0008@0
001<0003o`0001T000?o0000M`000ol0000I0003o`0008@0001=0003o`0001L000?o0000N@000ol0
000G0003o`0008D0001=0003o`0001L000?o0000N@000ol0000G0003o`0008D0001=0003o`0001L0
00?o0000N@000ol0000G0003o`0008D0001>0003o`0001D000?o0000N`000ol0000E0003o`0008H0
001>0003o`0001D000?o0000N`000ol0000E0003o`0008H0001?0003o`0001<000?o0000O@000ol0
000C0003o`0008L0001?0003o`0001<000?o0000O@000ol0000C0003o`0008L0001@0003o`000140
00?o0000O`000ol0000A0003o`0008P0001@0003o`00014000?o0000O`000ol0000A0003o`0008P0
001A0003o`0000l000?o0000P@000ol0000?0003o`0008T0001A0003o`0000l000?o0000P@000ol0
000?0003o`0008T0001B0003o`0000d000?o0000P`000ol0000=0003o`0008X0001B0003o`0000d0
00?o0000P`000ol0000=0003o`0008X0001C0003o`0000/000?o0000Q@000ol0000;0003o`0008/0
001C0003o`0000/000?o0000Q@000ol0000;0003o`0008/0001D0003o`0000T000?o0000Q`000ol0
00090003o`0008`0001D0003o`0000T000?o0000Q`000ol000090003o`0008`0001E0003o`0000L0
00?o0000R@000ol000070003o`0008d0001E0003o`0000L000?o0000R@000ol000070003o`0008d0
001F0003o`0000D000?o0000R`000ol000050003o`0008h0001F0003ol_;00C;00<0o`00S0000oo;
b`04b`030?l008l0001E00[;S00:bi00001D00c;RP0<bhl0001C00k;R00>bhh0001B00K;0ol7bhH0
4<^=0000DP09b`03ol_;00C;QP0@bhd0000<00Go@007b`Co1l]000Co@007b`;o00?;ool01//o00Co
B@0000`000Co003o@@06b`05ol_;bol01l/o0003o`0004801l/01?o;bol7bd0000?o0000B@0000`0
1?m100K;00Gobl_;o`07bcl000?o0000@P07b`04ol_;o`O;@@000ol0001800003`000ol0000o00K;
00Gobl_;o`07bcl000Go0000o`1000O;00Cobl_o1l]20003o`0004L0000<00Co@@07b`Go1/]000Co
@007b`Co1l]20003o`0004L0000H00;o=`0Bbh@01l/00oo;b`08bcP000?o00001003odX0000J00;o
=P0@bhH01L/2o`W;=P03oe@0000L00?o<`0@b`03o`0008<04</c00?oE`0001l00ola00k;0P000ol0
00210003o`3;00g;<@03oeX0000R00;o<00<b`@000?o0000O`001?l0000<bc000_mM00009003obh0
2//600;oO@02o`D02//^00?oG`0002L00ol]00K;2P000ol0001i0003o`0000L01//]00?oHP0002X0
0olk0003o`0003X000?o0000>P000ol0000i00;oI@0002d00_lj00;o>P000ol0000h00;o>@03ofL0
000_00?o>@000ol0000g0003o`0003L000?o0000=P03ofX0000b00?o=`000ol0000f0003o`0003H0
00?o0000=003ofd0000e00?o=@02ocH000?o0000=002ocD00_m`0000>002ocD000?o0000<`000ol0
000c0003o`0003800omb0000>P03oc<00_lc0003o`0003400_lb00?oM@0003d00olb0003o`000300
00?o0000<0000ol0000`00;oN00004000_la0003o`0002l000?o0000;`000ol0000^00?oNP000480
0ol_00;o;`000ol0000]00;o;P03ogd0001500?o;P000ol0000/0003o`0002`000?o0000:`03oh00
001800?o;0000ol0000[0003o`0002/000?o0000:P02oh<0001;00;o:`02ob/000?o0000:@02obX0
0on50000C@03obX000?o0000:0000ol0000X0003o`0002L00on80000D003obP000?o00009`000ol0
000W0003o`0002H00_n;0000D`03obH00_lW0003o`0002D00_lV00?oS@0005H00_lV0003o`0002@0
00?o000090000ol0000S00?oT00005P00olT00;o90000ol0000R00;o8`03oi<0001K00?o8`000ol0
000Q0003o`00024000?o00008@02oiH0001N00;o8P000ol0000P0003o`00020000?o00007`03oiP0
001P00?o8002ob0000?o00007P02oal00onK0000H`03oal000?o00007@000ol0000M0003o`0001d0
0_nN0000IP03oad000?o000070000ol0000L0003o`0001/00onP0000J@02oa`00_lL0003o`0001X0
0_lK00?oX`0006/00olK0003o`0001T000?o00006@000ol0000I00;oYP0006h00olI0003o`0001P0
00?o000060000ol0000G00?oZ00007400olG00;o60000ol0000F00;o5`03oj/0001d00;o5`000ol0
000E0003o`0001D000?o00005003ojh0001f00?o5@02oaD000?o00004`02oaD00_na0000N@03oa@0
00?o00004P000ol0000B0003o`0001800onc0000O002oa<000?o00004@000ol0000A0003o`000100
0onf0000OP03oa400_lA0003o`0000l00_lA00;o^@0008400ol@0003o`0000h000?o00003P000ol0
000>00?o^`0008@00ol>0003o`0000d000?o00003@000ol0000<00?o_P0008L00_l=00;o3@000ol0
000;00;o3003ol40002900?o30000ol0000:0003o`0000X000?o00002P02ol@0002<00?o2P000ol0
00090003o`0000T000?o00002003olH0002?00?o2002o`T000?o00001`02o`P00oo90000TP02o`P0
00?o00000`06b`H000?o00001P02ol`0002D00?o1P02o`030<_;00S;0P02o`H00oo>0000U`03o`D0
3</00ol0000300?od@0009X00_l200k;0P03om@0002L0003ol_;00k;00?o0000e@0009d01//4o`K;
f00009`02</00oo;b`07bmL0002L00S;00?obl/01l_G0000W008b`03ol_;00O;e`0009`01l/4o`O;
e`0009`02</00oo;b`07bmL0002L00S;0ol7bmL0002M013;f00009d04<_H0000WP0>bmT0002O00c;
fP000:002/_K0000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.21106, -0.833976, 0.013371, 
  0.00363163}},
  CellTags->"Mutation - mutant 8"],

Cell[TextData[{
  "Selective mutation 8: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .34481 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .65519 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .6178 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .85839 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .70071 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .9413 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .821 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Mshowa
P
.004 w
.2619 .40712 m
.179 .21092 L
s
.2619 .40712 m
.34481 .21092 L
s
1 g
.05 w
.179 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .21092 0 0 Mshowa
P
1 g
.34481 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .34481 .21092 0 0 Mshowa
P
.9 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .40712 0 0 Mshowa
P
.004 w
.7381 .40712 m
.65519 .21092 L
s
.7381 .40712 m
.7381 .21092 L
s
.7381 .40712 m
.821 .21092 L
s
1 g
.05 w
.65519 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .65519 .21092 0 0 Mshowa
P
.004 w
.7381 .21092 m
.6178 .01472 L
s
.7381 .21092 m
.85839 .01472 L
s
1 g
.05 w
.6178 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .6178 .01472 0 0 Mshowa
P
1 g
.85839 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .85839 .01472 0 0 Mshowa
P
.9 g
.7381 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .21092 0 0 Mshowa
P
.004 w
.821 .21092 m
.70071 .01472 L
s
.821 .21092 m
.9413 .01472 L
s
1 g
.05 w
.70071 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .70071 .01472 0 0 Mshowa
P
1 g
.9413 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .9413 .01472 0 0 Mshowa
P
.9 g
.821 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .821 .21092 0 0 Mshowa
P
.9 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000>/01OlJ00Go=`03oa`01?lL0000j`001?l00?lK0004o`00oc/0
00?o00006@001Ol0003o01/0003[00Co6`04oc/000?o00006@001Ol0003o01/0003^0003o`0001`0
00?o0000=`02oa`000Go0000o`0K0000j`04oa/01?lk0003o`0001T01?lL0000o`1700?o70000ol0
000M0000o`1U00;o7`000?l0QP000?l0QP000?l0QP000?<000?o000070000ol0001`0000l`000ol0
000L0003o`0002h000?o000070000ol0000P0000m0000ol0000L0003o`0002`000?o000070000ol0
000Q0000m0000ol0000L0003o`0002`000?o000070000ol0000Q0000m@000ol0000L0003o`0002X0
00?o000070000ol0000R0000mP000ol0000L0003o`0002P000?o000070000ol0000S0000mP000ol0
000L0003o`0002P000?o000070000ol0000S0000m`000ol0000L0003o`0002H000?o000070000ol0
000T0000n0000ol0000L0003o`0002@000?o000070000ol0000U0000n0000ol0000L0003o`0002@0
00?o000070000ol0000U0000n@000ol0000L0003o`00028000?o000070000ol0000V0000n@000ol0
000L0003o`00028000?o000070000ol0000V0000nP000ol0000L0003o`00020000?o000070000ol0
000W0000n`000ol0000L0003o`0001h000?o000070000ol0000X0000n`000ol0000L0003o`0001h0
00?o000070000ol0000X0000o0000ol0000L0003o`0001`000?o000070000ol0000Y0000o0000ol0
000L0003o`0001`000?o000070000ol0000Y0000o@000ol0000L0003o`0001X000?o000070000ol0
000Z0000oP000ol0000L0003o`0001P000?o000070000ol0000[0000oP000ol0000L0003o`0001P0
00?o000070000ol0000[0000o`000ol0000L0003o`0001H000?o000070000ol0000/0000o`010003
o`0001`000?o000050000ol0000L0003o`0002d0003o004000?o000070000ol0000D0003o`0001`0
00?o0000;@000?l00P000ol0000L0003o`00018000?o000070000ol0000^0000o`020003o`0001`0
00?o00004P000ol0000L0003o`0002h0003o00<000?o000070000ol0000@0003o`0001`000?o0000
;`000?l010000ol0000L0003o`0000h000?o000070000ol0000`0000o`040003o`0001`000?o0000
3P000ol0000L0003o`000300003o00D000?o000070000ol0000<0003o`0001`000?o0000<@000?l0
1P000ol0000L0003o`0000X000?o000070000ol0000b0000o`060003o`0001`000?o00002P000ol0
000L0003o`000380003o00L000?o000070000ol000080003o`0001`000?o0000<`000?l01`000ol0
000L0003o`0000P000?o000070000ol0000c0000o`080003o`0001`000?o00001P000ol0000L0003
o`0003@0003o00T000?o000070000ol000040003o`0001`000?o0000=@000?l02@000ol0000L0003
o`0000@000?o000070000ol0000e0000o`0:0003o`0001`000?o00000P000ol0000L0003o`0003H0
003o00X000?o000070000ol000020003o`0001`000?o0000=P000?l02`000ol0000L0004o`00oah0
00?o0000=`000?l030000ol0000L00;o7P000ol0000h0000o`0<0003o`0001`00_lN0003o`0003P0
003o00d000?o00006`02oad000?o0000>@000?l03P000ol0000I0004o`00oa/000?o0000>P000?l0
3P000ol0000I0004o`00oa/000?o0000>P000?l03`000ol0000G0003o`00008000?o00005`000ol0
000k0000o`0?0003o`0001L000?o00000P000ol0000G0003o`0003/0003o010000?o00005@000ol0
00040003o`0001D000?o0000?0000?l04@000ol0000C0003o`0000H000?o00004`000ol0000m0000
o`0A0003o`0001<000?o00001P000ol0000C0003o`0003d0003o018000?o00004@000ol000080003
o`00014000?o0000?P000?l04P000ol0000A0003o`0000P000?o00004@000ol0000n0000o`0C0003
o`0000l000?o00002P000ol0000?0003o`0003l0003o01@000?o00003@000ol0000<0003o`0000d0
00?o0000@0000?l050000ol0000=0003o`0000`000?o00003@000ol000100000o`0E0003o`0000/0
00?o00003P000ol0000;0003o`000440003o01H000?o00002@000ol0000@0003o`0000T000?o0000
@P000?l05P000ol000090003o`00010000?o00002@000ol000120000o`0G0003o`3;00G;0P000ol0
000B0003o`3;00G;0P000ol000130000o`0G00[;00?o00004P0:b`03o`0004<0003o01H03</C00c;
A@000?l05@0>ba403/]40000o`0D00K;0ol7b`l01//3o`O;@`000?l05009b`03ol_;00C;3`09b`03
ol_;00C;@`0004L01?lj00?oLP03oaD01l/4o`O;3@07b`Co1l]20000A`001Ol0003o03`000?o0000
LP000ol0000B00K;00Gobl_;o`07b`d01//01Oo;bl_o00O;@P0004L000Go0000o`0l0003o`000780
00?o00004P06b`05ol_;bol01l/=00K;00Gobl_;o`07bd8000170005o`000?l0>P02og800olE00K;
00Gobl_;o`07b`d01//01Oo;bl_o00O;@P0004L01?lm0003o`0006l000?o00005@07b`Go1//=00O;
1Ol6bd8000170003o`0003/00omb00Co500Bb`d04/]20000AP02ol/04</?013;@`000?l0500@b`l0
4<]30000o`0E00k;4@0>bd@0003o01H03</C00c;A@000?l05`0:baD02/]60000C@000ol0000c0003
o`0007X000?o00005@06baP000?obl/01<]80000C@000ol0000c0003o`0007X000?o000060000ol0
000H0003o`0004`0001=0003o`0003<000?o0000NP000ol0000H0003o`0001P000?o0000C00004h0
00?o0000<@000ol0001l0003o`0001L000?o00005`000ol0001=0000CP000ol0000a0003o`0007`0
00?o00005`000ol0000G0003o`0004d0001?0003o`0002l000?o0000OP000ol0000F0003o`0001H0
00?o0000CP0004l000?o0000;`000ol0001n0003o`0001H000?o00005P000ol0001>0000C`000ol0
000_0003o`0007h000?o00005P000ol0000F0003o`0004h0001@0003o`0002d000?o0000P0000ol0
000E0003o`0001D000?o0000C`00050000?o0000;@000ol000200003o`0001D000?o00005@000ol0
001?0000D@000ol0000[0003o`00088000?o000050000ol0000D0003o`000500001A0003o`0002/0
00?o0000PP000ol0000D0003o`0001@000?o0000D000058000?o0000:@000ol000240003o`0001<0
00?o00004`000ol0001A0000DP000ol0000Y0003o`0008@000?o00004`000ol0000C0003o`000540
001B0003o`0002T000?o0000Q0000ol0000C0003o`0001<000?o0000D@0005<000?o00009`000ol0
00260003o`00018000?o00004P000ol0001B0000D`000ol0000W0003o`0008H000?o00004P000ol0
000B0003o`000580001D0003o`0002D000?o0000R0000ol0000A0003o`00014000?o0000D`0005@0
00?o00009@000ol000280003o`00014000?o00004@000ol0001C0000E@000ol0000S0003o`0008X0
00?o000040000ol0000@0003o`0005@0001E0003o`0002<000?o0000RP000ol0000@0003o`000100
00?o0000E00005D000?o00008`000ol0002:0003o`00010000?o000040000ol0001D0000EP000ol0
000Q0003o`0008`000?o00003`000ol0000?0003o`0005D0001F0003o`00024000?o0000S0000ol0
000?0003o`0000l000?o0000E@0005L000?o00007`000ol0002>0003o`0000h000?o00003P000ol0
001F0000E`000ol0000O0003o`0008h000?o00003P000ol0000>0003o`0005H0001G0003o`0001l0
00?o0000SP000ol0000>0003o`0000h000?o0000EP0005P000?o00007@000ol0002@0003o`0000d0
00?o00003@000ol0001G0000F0000ol0000M0003o`00090000?o00003@000ol0000=0003o`0005L0
001I0003o`0001/000?o0000TP000ol0000<0003o`0000`000?o0000F00005T000?o00006`000ol0
002B0003o`0000`000?o000030000ol0001H0000FP000ol0000I0003o`0009@000?o00002`000ol0
000;0003o`0005T0001J0003o`0001T000?o0000U0000ol0000;0003o`0000/000?o0000F@0005X0
00?o00006@000ol0002D0003o`0000/000?o00002`000ol0001I0000F`000ol0000G0003o`0009H0
00?o00002P000ol0000:0003o`0005X0001K0003o`0001L000?o0000UP000ol0000:0003o`0000X0
00?o0000FP0005`000?o00005@000ol0002H0003o`0000T000?o00002@000ol0001K0000G0000ol0
000E0003o`0009P000?o00002@000ol000090003o`0005/0001L0003o`0001D000?o0000V0000ol0
00090003o`0000T000?o0000F`0005d000?o00004`000ol0002J0003o`0000P000?o000020000ol0
001L0000G@000ol0000C0003o`0009X000?o000020000ol000080003o`0005`0001N0003o`000140
00?o0000W0000ol000070003o`0000L000?o0000G@0005h000?o00004@000ol0002L0003o`0000L0
00?o00001`000ol0001M0000G`000ol0000?0003o`0009h000?o00001P000ol000060003o`0005h0
001O0003o`0000l000?o0000WP000ol000060003o`0000H000?o0000GP0005l000?o00003`000ol0
002N0003o`0000H000?o00001P000ol0001N0000H0000ol0000=0003o`000:0000?o00001@000ol0
00050003o`0005l0001P0003o`0000d000?o0000X0000ol000050003o`0000D000?o0000G`000640
00?o00002`000ol0002R0003o`0000@000?o000010000ol0001P0000H@000ol0000;0003o`000:80
00?o000010000ol000040003o`000600001R0003o`0000T000?o0000Y0000ol000030003o`0000<0
00?o0000H@00068000?o00002@000ol0002T0003o`0000<000?o00000`000ol0001Q0000HP000ol0
00090003o`000:@000?o00000`000ol000030003o`000640001S0003o`0000L000?o0000YP000ol0
00020003o`00008000?o0000HP0006<000?o00001`000ol0002V0003o`00008000?o00000P000ol0
001R0000I0000ol000050003o`000:P000Go0000o`030003o`0006<0001T0003o`0000D000?o0000
Z0001Ol0003o00<000?o0000H`0006@000?o0</01L/00ol0002X0003ol_;00C;00<0o`00I00006@0
2/^X00[;I@0006<03<^V00c;I00006803/^T00k;H`0006401L/3o`S;XP0@bf80001Q00S;00?obl/0
1L^R013;HP0000`01Om?00K;1?l8bdh01?m>00O;0_l00l_oo`06bdh01?l?000030001?l00?m@00G;
00Gobl_;o`08bdd000?o0000D007b`04ol_;o`O;C`000ol0000?00003004oe001L/01Oo;bl_o00S;
C@000ol0001@00O;00Cobl_o1l]@0003o`0000h0000?0003o`0004h01L/01Oo;bl_o00S;C@001Ol0
003o04h01l/01?o;bol7be4000?o00003@0000`01?m@00K;1Ol7bdh01?m>00O;1?l7be4000?o0000
3@0001P000?o0000A@0Bbj001l/00oo;b`08bdh00ol@00006@02odH04<^R00G;0_l9bdH00_lJ0000
6`02od@04<^R013;A002oa`0000M00?o@P0>b`03o`000:0000?obl/03<]200?o7P0002000_m100c;
0P000ol0002N0003o`0000c;@@02ob40000R00?o?`0:b`@000?o0000W0000ol0000200[;?`03ob<0
000U00;o?`06b`L00_nJ00;o1`06bcl00_lV00009`03od/000?o0000BP000ol000190003o`0004T0
0olX0000:P02odX000?o0000B@000ol000180003o`0004P00_l[0000;003odP000?o0000B0000ol0
00170003o`0004L00_l]0000;`02odL00_m80003o`0004H000?o0000A@03obl0000a00?oAP000ol0
00150003o`0004@00_m600;o<P0003@00_m50003o`0004@000?o0000@`000ol0001300?o=00003H0
0_m40003o`0004<000?o0000@P000ol0001200;o=`0003P00om200;o@`000ol000110003o`000400
0oli0000>`02od8000?o0000@0000ol0000o00;o@@02oc`0000m00?o@0000ol0000o0003o`0003h0
00?o0000?P03och0001000;o?`000ol0000n0003o`0003d000?o0000?@02od40001200?o?@02och0
00?o0000?0000ol0000l00;o@`0004D00_lm0003o`0003/000?o0000>`000ol0000j00?oA@0004L0
0olk0003o`0003X000?o0000>@02oc/00_m80000BP02ocX000?o0000>@000ol0000h0003o`0003P0
0om:0000C003ocP000?o0000>0000ol0000g0003o`0003L00_m=0000C`02ocL00_lh0003o`0003H0
00?o0000=@03odl0001A00;o=`000ol0000e0003o`0003@00_lf00;oDP0005<00ole0003o`0003@0
00?o0000<`000ol0000d00;oE00005H00_ld0003o`0003<000?o0000<P000ol0000b00?oEP0005P0
0olb00;o<`000ol0000a0003o`0003400_mI0000F`02oc8000?o0000<0000ol0000`0003o`0002l0
0omK0000G@03oc0000?o0000;`000ol0000^00;o<002oeh0001P00;o;`000ol0000^0003o`0002d0
00?o0000;@03of00001R00?o;@02obh000?o0000;0000ol0000/00;oH`0006D00_l]0003o`0002/0
00?o0000:`000ol0000Z00?oI@0006L00ol[0003o`0002X000?o0000:@02ob/00_mX0000JP02obX0
00?o0000:@000ol0000X0003o`0002T00_mZ0000K002obT000?o0000:0000ol0000W0003o`0002L0
0om/0000KP03obL00_lX0003o`0002H000?o00009P02ofl0001a00;o9`000ol0000U0003o`0002D0
00?o00009003og40001c00?o9@000ol0000T0003o`0002<00_lU00;oM00007H00_lT0003o`0002<0
00?o00008P000ol0000R00?oMP0007P00olR00;o8`000ol0000Q0003o`0002400_mi0000N`02ob80
00?o000080000ol0000P0003o`0001l00omk0000O@03ob0000?o00007`000ol0000O0003o`0001h0
0_mn0000P002oal000?o00007P000ol0000M00;o7`02oh00002200;o7P02oah000?o000070000ol0
000L00?oPP0008@00olM0003o`0001/000?o00006`000ol0000K00;oQ@0008L00_lL0003o`0001X0
00?o00006P000ol0000I00?oQ`0008T00olJ0003o`0001T000?o00006002oaX00_n:0000S002oaT0
00?o000060000ol0000G0003o`0001L00on<0000SP03oaL00_lH0003o`0001H000?o00005P02ohl0
002A00;o5`000ol0000E0003o`0001D000?o00005@02oi40002C00?o5@000ol0000D0003o`0001@0
00?o00004`03oi<0002F00;o50000ol0000C0003o`0001800_lD00;oUP0009P00olB00;o4`000ol0
000A0003o`0001400onH0000V`02oa8000?o000040000ol0000@0003o`0001000_nK0000W@02oa40
00?o00003`000ol0000?0003o`0000h00onM0000W`03o`l000?o00003P000ol0000=00;o3`02oj00
002R00;o3P02o`h000?o000030000ol0000<00?oXP000:@00ol=0003o`0000/000?o00002`000ol0
000;00;oY@000:L00_l<0003o`0000X000?o00002P000ol0000:00;oY`000:T00ol:0003o`0000T0
00?o00002@000ol0000800?oZ@000:`00_l900;o2@000ol0000700;o2@02oj`0002^00?o20000ol0
00060003o`0000H000?o00001P03ojh0002a00;o1`000ol0000200K;1@000ol0000500;o/@000;<0
0ol50003o`3;00W;0P000ol0000300?o/`000;H00_l400c;00?o00000P02okH0002h00;o00<0bl/0
3</200;o^0000;X04</00ol0002h0000^P06b`Co1/^k0000^@08b`03ol_;00O;^P000;T02</00oo;
b`07bkX0002i00S;00?obl/01l^j0000^@07b`Co1l^j0000^@08b`03ol_;00O;^P000;T02</3o`O;
^P000;X04<^k0000^P0@bk/0002k00k;_0000;`03<^m0000_@0:bkh00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.17714, -0.625483, 0.0112224, \
0.00272373}},
  CellTags->"Mutation - mutant 9"],

Cell[TextData[{
  "Selective mutation 9: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Mutation - mutant 10",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33652 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .63887 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .62463 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .95159 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Mshowa
P
.004 w
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Mshowa
P
1 g
.33652 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33652 .21092 0 0 Mshowa
P
.9 g
.25575 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Mshowa
P
1 g
.4877 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Mshowa
P
.004 w
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .63887 .21092 0 0 Mshowa
P
.004 w
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .62463 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .97619 .01472 0 0 Mshowa
P
.9 g
.80041 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Mshowa
P
.9 g
.71964 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Mshowa
P
1 g
.95159 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .95159 .40712 0 0 Mshowa
P
.9 g
.4877 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{389, 240},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000650000l0P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0QP000?l0QP000?l0QP000?l0QP000?l0
QP000?l0QP000?l0QP000?l0QP000>h01?n000Go3P000>d000?o0000P@001Ol0003o00l0003]0003
o`00084000Go0000o`0?0000k@001Ol0003o07l000Go0000o`0?0000kP04oh001?l?0000o`1f0003
o`0000d0003o07D00_l?0000o`260000o`260000mP000ol0002<0000m`000ol0001c0003o`0001D0
003h0003o`00074000?o00005P000?T000?o0000K`000ol0000G0000n@000ol0001_0003o`0001L0
003j0003o`0006d000?o000060000?/000?o0000J`000ol0000I0000o0000ol0001Y0003o`0001X0
003m0003o`0006L000?o00006`000?h000?o0000I@000ol0000L0000o`000ol0001S0003o`0001d0
003o004000?o0000H@000ol0000N0000o`020003o`0005l000?o00007`000?l00`000ol0001M0003
o`000200003o00@000?o0000F`000ol0000Q0000o`040003o`0005/000?o00008@000?l01@000ol0
001I0003o`000280003o00H000?o0000E`000ol0000S0000o`070003o`0005D000?o000090000?l0
20000ol0001C0003o`0002D0003o00T000?o0000D@000ol0000V0000o`0:0003o`0004l000?o0000
9`000?l02`000ol0001=0003o`0002P0003o00`000?o0000B`000ol0000Y0000o`0=0003o`0004T0
00?o0000:P000?l03@000ol000190003o`0002X0003o00h000?o0000A`000ol0000[0000o`0?0003
o`0004D000?o0000;0000?l040000ol000130003o`0002d0003o014000?o0000@@000ol0000^0000
o`0B0003o`0003l000?o0000;`000?l04`000ol0000m0003o`000300003o01@000?o0000>`000ol0
000a0000o`0E0003o`0003T000?o0000<P000?l05P000ol0000g0003o`0003<0003o01L000?o0000
=@000ol0000d0000o`0G0003o`0003D000?o0000=0000?l060000ol0000c0003o`0003D0003o01T0
00?o0000<@000ol0000f0000o`0J0003o`0002l000?o0000=`000?l06`000ol0000]0003o`0003P0
003o01`000?o0000:`000ol0000i0000o`0M0003o`0002T000?o0000>P000?l07P000ol0000W0003
o`0003/0003o01l000?o00009@000ol0000l0000o`0P0003o`0002<000?o0000?@000?l080000ol0
000S0003o`0003d0003o024000?o00008@000ol0000n0000o`0R0003o`0001l000?o0000?`000?l0
8`000ol0000M0003o`000400003o02@000?o00006`000ol000110000o`0U0003o`0001T000?o0000
@P000?l09P000ol0000G0003o`0004<0003o02L000?o00005@000ol000140000o`0X0003o`0001<0
00?o0000A@000?l0:@000ol0000A0003o`0004H0003o02X000?o00003`000ol000170000o`0Z0003
o`0000l000?o0000A`000?l0:`000ol0000200K;1@000ol000180000o`0/0003o`3;00W;0P000ol0
00190000o`0]00c;00?o0000BP000?l0;00>bd`0003o02/01//3o`O;B`000?l0:`09b`03ol_;00C;
B`0004H01?lh00?oK`03oc801l/4o`O;BP0004H000Go0000o`0j0003o`0006d000?o0000<@06b`05
ol_;bol01l]:0000AP001Ol0003o03X000?o0000K@000ol0000a00K;00Gobl_;o`07bdX000160005
o`000?l0>002og0000?o0000<@06b`05ol_;bol01l]:0000AP04oc/000?o0000K@000ol0000a00O;
1Ol6bdX000160003o`0003T00om_00;o<`0BbdX0001500;oh`0@bd/0003o02/04<];0000o`0/00k;
C0000?l0;@0<bdd0003o02h02/]>0000B`000ol0000c0003o`0007D000?o0000<`06be00001<0003
o`00034000?o0000MP000ol0000b0003o`0005@0001<0003o`00034000?o0000MP000ol0000b0003
o`0005@0001=0003o`0002l000?o0000N0000ol0000`0003o`0005D0001=0003o`0002l000?o0000
N0000ol0000`0003o`0005D0001=0003o`0002l000?o0000N@000ol0000_0003o`0005D0001>0003
o`0002d000?o0000NP000ol0000^0003o`0005H0001>0003o`0002d000?o0000NP000ol0000^0003
o`0005H0001?0003o`0002/000?o0000O0000ol0000/0003o`0005L0001?0003o`0002/000?o0000
O0000ol0000/0003o`0005L0001@0003o`0002T000?o0000OP000ol0000Z0003o`0005P0001@0003
o`0002T000?o0000OP000ol0000Z0003o`0005P0001@0003o`0002T000?o0000O`000ol0000Y0003
o`0005P0001A0003o`0002L000?o0000P0000ol0000X0003o`0005T0001A0003o`0002L000?o0000
P0000ol0000X0003o`0005T0001B0003o`0002D000?o0000PP000ol0000V0003o`0005X0001B0003
o`0002D000?o0000PP000ol0000V0003o`0005X0001B0003o`0002D000?o0000P`000ol0000U0003
o`0005X0001C0003o`0002<000?o0000Q0000ol0000T0003o`0005/0001C0003o`0002<000?o0000
Q@000ol0000S0003o`0005/0001D0003o`00024000?o0000QP000ol0000R0003o`0005`0001D0003
o`00024000?o0000QP000ol0000R0003o`0005`0001D0003o`00024000?o0000Q`000ol0000Q0003
o`0005`0001E0003o`0001l000?o0000R0000ol0000P0003o`0005d0001E0003o`0001l000?o0000
R@000ol0000O0003o`0005d0001F0003o`0001d000?o0000RP000ol0000N0003o`0005h0001F0003
o`0001d000?o0000RP000ol0000N0003o`0005h0001F0003o`0001d000?o0000R`000ol0000M0003
o`0005h0001G0003o`0001/000?o0000S0000ol0000L0003o`0005l0001G0003o`0001/000?o0000
S@000ol0000K0003o`0005l0001H0003o`0001T000?o0000SP000ol0000J0003o`000600001H0003
o`0001T000?o0000S`000ol0000I0003o`000600001H0003o`0001T000?o0000S`000ol0000I0003
o`000600001I0003o`0001L000?o0000T0000ol0000H0003o`000640001I0003o`0001L000?o0000
T@000ol0000G0003o`000640001J0003o`0001D000?o0000TP000ol0000F0003o`000680001J0003
o`0001D000?o0000T`000ol0000E0003o`000680001J0003o`0001D000?o0000T`000ol0000E0003
o`000680001K0003o`0001<000?o0000U0000ol0000D0003o`0006<0001K0003o`0001<000?o0000
U@000ol0000C0003o`0006<0001L0003o`00014000?o0000UP000ol0000B0003o`0006@0001L0003
o`00014000?o0000U`000ol0000A0003o`0006@0001L0003o`00014000?o0000U`000ol0000A0003
o`0006@0001M0003o`0000l000?o0000V@000ol0000?0003o`0006D0001M0003o`0000l000?o0000
V@000ol0000?0003o`0006D0001N0003o`0000d000?o0000VP000ol0000>0003o`0006H0001N0003
o`0000d000?o0000V`000ol0000=0003o`0006H0001O0003o`0000/000?o0000W0000ol0000<0003
o`0006L0001O0003o`0000/000?o0000W@000ol0000;0003o`0006L0001O0003o`0000/000?o0000
W@000ol0000;0003o`0006L0001P0003o`0000T000?o0000W`000ol000090003o`0006P0001P0003
o`0000T000?o0000W`000ol000090003o`0006P0001Q0003o`0000L000?o0000X0000ol000080003
o`0006T0001Q0003o`0000L000?o0000X@000ol000070003o`0006T0001Q0003o`0000L000?o0000
X@000ol000070003o`0006T0001R0003o`0000D000?o0000X`000ol000050003o`0006X0001R0003
o`0000D000?o0000X`000ol000050003o`0006X0001S00K;00?o0000Y0000oo;b`04b`03o`0006/0
001Q00[;Y00:bf`0001P00c;XP0<bf/0001O00k;X00>bfX0001N00K;0ol7bih04<]Y0000GP09b`03
ol_;00C;WP0@bfT0000<00GoC007b`Co1l]<00CoC007b`;o00?;ool01/]<00Co600000`000Co003o
C@06b`05ol_;bol01l];0003o`0004h01l/01?o;bol7bdd000?o0000600000`01?m=00K;00Gobl_;
o`07bd/000?o0000CP07b`04ol_;o`O;CP000ol0000G00003`000ol0001;00K;00Gobl_;o`07bd/0
00Go0000o`1<00O;00Cobl_o1l]?0003o`0001H0000<00CoC@07b`Go1/]<00CoC007b`Co1l]?0003
o`0001H0001M01;;W007b`03ol_;00S;C003oaT0000H00?o@`0@bih01L/2o`W;A003ob80000K00;o
@@0@bih04<]200;o9@0001d00_m000k;00<0o`00W0000oo;b`0<bd400_lW00007`03och03</30003
o`0009T000?o00003</o00?o:@0002800_lm00[;1@000ol0002G0003o`0000802//n00;o;00002@0
0oll00K;20000ol0002E0003o`0000D01//m00?o;P0002L00_m900;oB@000ol0001700;oB@02oc40
000Y00;oB@000ol000160003o`0004H000?o0000A`02oc<0000[00?oA`000ol000150003o`0004D0
00?o0000A@03ocD0000^00;oAP000ol000140003o`0004@000?o0000A002ocP0000`00?oA0000ol0
00130003o`0004<000?o0000@P03ocX0000c00;o@`000ol000120003o`00048000?o0000@@02ocd0
000e00;o@P02od8000?o0000@002od800_lo0000=`03od4000?o0000?`000ol0000o0003o`0003l0
0om10000>P02od0000?o0000?P000ol0000n0003o`0003h00_m40000?002ocl000?o0000?@000ol0
000m0003o`0003d00_m60000?P03ocd000?o0000?0000ol0000l0003o`0003/00om80000@@02oc`0
0_ll0003o`0003X00_ll00;oB`0004<00olk0003o`0003T000?o0000>@000ol0000i00?oC@0004H0
0_lj0003o`0003P000?o0000>0000ol0000h00;oD00004P00_li0003o`0003L000?o0000=`000ol0
000g00;oDP0004X00olg0003o`0003H000?o0000=P000ol0000e00?oE00004d00_lf00;o=P000ol0
000d00;o=P02oeL0001?00?o=@000ol0000c0003o`0003<000?o0000<`03oeT0001B00;o=0000ol0
000b0003o`00038000?o0000<P02oe`0001D00;o<`000ol0000a0003o`00034000?o0000<@02oeh0
001F00?o<@000ol0000`0003o`00030000?o0000;`03of00001I00;o<002oc0000?o0000;P02oc00
0_mS0000F`02oc0000?o0000;@000ol0000]0003o`0002h00_mU0000G@03obh000?o0000;0000ol0
000/0003o`0002`00omW0000H002obd000?o0000:`000ol0000[0003o`0002/00_mZ0000HP03ob/0
00?o0000:P000ol0000Z0003o`0002T00om/0000I@02obX00_lZ0003o`0002P00_lZ00;oK`0006L0
0_lZ0003o`0002L000?o00009`000ol0000X00;oL@0006T00olX0003o`0002H000?o00009P000ol0
000V00?oL`0006`00_lW0003o`0002D000?o00009@000ol0000U00;oMP0006h00olU0003o`0002@0
00?o000090000ol0000S00?oN00007400_lT0003o`0002<000?o00008`000ol0000R00;oN`0007<0
0_lS00;o8`000ol0000Q00;o8`02ogd0001e00?o8P000ol0000P0003o`00020000?o00008003ogl0
001h00;o8@000ol0000O0003o`0001l000?o00007`02oh80001j00;o80000ol0000N0003o`0001h0
00?o00007P02oh@0001l00?o7P000ol0000M0003o`0001d000?o00007003ohH0001o00;o7@02oad0
00?o00006`02oad00_n90000P@03oa`000?o00006P000ol0000J0003o`0001X00on;0000Q002oa/0
00?o00006@000ol0000I0003o`0001T00_n>0000QP02oaX000?o000060000ol0000H0003o`0001P0
0_n@0000R003oaP000?o00005`000ol0000G0003o`0001H00onB0000R`02oaL00_lG0003o`0001D0
0_lG00;oU@0008d00olF0003o`0001@000?o000050000ol0000D00?oU`0009000_lE0003o`0001<0
00?o00004`000ol0000C00;oVP0009800_lD0003o`00018000?o00004P000ol0000B00;oW00009@0
0olB0003o`00014000?o00004@000ol0000@00?oWP0009L00_lA00;o4@000ol0000?00;o4@02oj40
002I00;o4@000ol0000>0003o`0000h000?o00003`02oj<0002K00?o3`000ol0000=0003o`0000d0
00?o00003@03ojD0002N00;o3P000ol0000<0003o`0000`000?o00003002ojP0002P00?o30000ol0
000;0003o`0000/000?o00002P03ojX0002S00;o2`000ol0000:0003o`0000X000?o00002@02ojd0
002U00;o2P02o`X000?o00002002o`X00_n_0000Y`03o`T000?o00001`000ol000070003o`0000L0
0ona0000ZP02o`P000?o00001P000ol000060003o`0000H00_nd0000[003o`H000?o00000P06b`D0
00?o00001003okH0002_00;o1@000ol0b`09b`8000?o00000`02okT0002a00;o100<b`03o`000080
0_nk0000/`03o`k;00@0oooo_@000;D04<_00000]@06b`Co1/_00000]008b`03ol_;00O;_`000;@0
2</00oo;b`07bkl0002d00S;00?obl/01l^o0000]007b`Co1l^o0000]008b`03ol_;00O;_`000;@0
2</3o`O;_`000;D04<_00000]@0@bl00002f00k;`@000;L03<_20000^00:bl<00000\
\>"],
  ImageRangeCache->{{{0, 388}, {239, 0}} -> {-2.18184, -0.625483, 0.01152, 
  0.00272373}},
  CellTags->"Mutation - mutant 10"],

Cell[TextData[{
  "Selective mutation 10: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Mutation - basic expression 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Mutation - mutant 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Recombination - Intro"],

Cell[CellGroupData[{

Cell["Templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
patterns =
{
  f[__, _g, __, _h, __],
  
  g[a | b | c, __],
  
  h[_Integer | _Symbol, __g],
  
  a, b, c, d, e,
  
  Sequence @@ Range[1,5]
};\
\>", "InputDemo",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Generating S-expression chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos =
createChromosomes[1, 
                 StartPattern -> _f,
                 SequenceRange -> {1,2},
                 MaxDepth -> 6,
                 ExprPatterns -> patterns]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], g[a, g[c, 2, 5], 3], 
 
     h[e, g[c, h[5, g[c, e, 4], g[c, b]]]], 1]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[a, g[b, 3], g[a, g[c, 2, 5], 3], 
 
     h[e, g[c, h[5, g[c, e, 4], g[c, b]]]], 1]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell["\<\
theChromos = pop[chromo[q[undef], p[f[a, g[b, 3], g[a, g[c, 2, 5], \
3], 
 
     h[e, g[c, h[5, g[c, e, 4], g[c, b]]]], 1]]]];\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> .2];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.458695 0.217443 0.603319 0.588604 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17821 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .30429 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .24125 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .39566 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .38255 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .4587 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .53484 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .4587 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .52173 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .4587 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .6131 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .62495 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .77061 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .8134 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .8534 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .8934 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .8534 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .89619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .93619 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .8534 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .73918 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .67614 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .89358 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4587 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.4587 .60332 m
.02381 .4856 L
s
.4587 .60332 m
.24125 .4856 L
s
.4587 .60332 m
.4587 .4856 L
s
.4587 .60332 m
.67614 .4856 L
s
.4587 .60332 m
.89358 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .4856 0 0 Mshowa
P
.004 w
.24125 .4856 m
.17821 .36788 L
s
.24125 .4856 m
.30429 .36788 L
s
1 g
.05 w
.17821 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17821 .36788 0 0 Mshowa
P
1 g
.30429 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .30429 .36788 0 0 Mshowa
P
.9 g
.24125 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .24125 .4856 0 0 Mshowa
P
.004 w
.4587 .4856 m
.39566 .36788 L
s
.4587 .4856 m
.4587 .36788 L
s
.4587 .4856 m
.52173 .36788 L
s
1 g
.05 w
.39566 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .39566 .36788 0 0 Mshowa
P
.004 w
.4587 .36788 m
.38255 .25016 L
s
.4587 .36788 m
.4587 .25016 L
s
.4587 .36788 m
.53484 .25016 L
s
1 g
.05 w
.38255 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .38255 .25016 0 0 Mshowa
P
1 g
.4587 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .4587 .25016 0 0 Mshowa
P
1 g
.53484 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .53484 .25016 0 0 Mshowa
P
.9 g
.4587 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .4587 .36788 0 0 Mshowa
P
1 g
.52173 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .52173 .36788 0 0 Mshowa
P
.9 g
.4587 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .4587 .4856 0 0 Mshowa
P
.004 w
.67614 .4856 m
.6131 .36788 L
s
.67614 .4856 m
.73918 .36788 L
s
1 g
.05 w
.6131 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .6131 .36788 0 0 Mshowa
P
.004 w
.73918 .36788 m
.62495 .25016 L
s
.73918 .36788 m
.8534 .25016 L
s
1 g
.05 w
.62495 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .62495 .25016 0 0 Mshowa
P
.004 w
.8534 .25016 m
.77061 .13244 L
s
.8534 .25016 m
.8534 .13244 L
s
.8534 .25016 m
.93619 .13244 L
s
1 g
.05 w
.77061 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .77061 .13244 0 0 Mshowa
P
.004 w
.8534 .13244 m
.8134 .01472 L
s
.8534 .13244 m
.8534 .01472 L
s
.8534 .13244 m
.8934 .01472 L
s
1 g
.05 w
.8134 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .8134 .01472 0 0 Mshowa
P
1 g
.8534 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .8534 .01472 0 0 Mshowa
P
1 g
.8934 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .8934 .01472 0 0 Mshowa
P
.9 g
.8534 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .8534 .13244 0 0 Mshowa
P
.004 w
.93619 .13244 m
.89619 .01472 L
s
.93619 .13244 m
.97619 .01472 L
s
1 g
.05 w
.89619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .89619 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .97619 .01472 0 0 Mshowa
P
.9 g
.93619 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .93619 .13244 0 0 Mshowa
P
.9 g
.8534 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .8534 .25016 0 0 Mshowa
P
.9 g
.73918 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .73918 .36788 0 0 Mshowa
P
.9 g
.67614 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .67614 .4856 0 0 Mshowa
P
1 g
.89358 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(1)] .89358 .4856 0 0 Mshowa
P
.9 g
.4587 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4587 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000=l01?l700Co1`04oa801?l;0000gP000ol000080003o`0000P000?o000050001Ol0003o00X0
003N0003o`0000P01Ol60003o`0001@000Go0000o`0:0000gP001Ol0003o00H000Go0000o`060005
o`000?l04P001Ol0003o00X0003O00Co1`03o`P01?lB00Co2`000?l030000ol0000<0000o`0;00;o
3P000?l06`000?l06`000?l06`000>@000?o00001@000ol000050003o`0000<000?o00003@000ol0
000=0000i0000ol000050003o`0000D000?o00000`000ol0000=0003o`0000d0003T0003o`0000D0
00?o00001@000ol000030003o`0000d000?o00003@000>D000?o000010000ol000040003o`0000D0
00?o00002`000ol0000>0000i@000ol000040003o`0000@000?o00001@000ol0000;0003o`0000h0
003U0003o`0000@000?o000010000ol000050003o`0000/000?o00003P000>H000?o00000`000ol0
00030003o`0000L000?o00002@000ol0000?0000iP000ol000030003o`0000<000?o00001`000ol0
00090003o`0000l0003V0003o`0000<000?o00000`000ol000070003o`0000T000?o00003`000>L0
00?o00000P000ol000020003o`0000T000?o00001`000ol0000@0000i`000ol000020003o`000080
00?o00002@000ol000070003o`000100003W0003o`00008000?o00000P000ol000090003o`0000L0
00?o000040000>P000Go0000o`030003o`0000/000?o00001@000ol0000A0000j0001Ol0003o00<0
00?o00002`000ol000050003o`000140003X0005o`000?l00`000ol0000;0003o`0000D000?o0000
4@000>T000Co003o0P000ol0000=0003o`0000<000?o00004P000>T000Co003o0P000ol0000=0003
o`0000<000?o00004P000>T000Co003o0P000ol0000=0003o`0000<000?o00004P000>T000K>g/kN
c_lA0005g/kNc]h05@000>L02Lh>00W>4`000>H000CNc]k>0ol01<kNc]h<0003c]k>00?o00G>g/kN
cP0B0000iP07cP04olk>cP`01/h00oo>cP02cQ80003C00?o3`001LkNc]k>00Co00CNc]k>2P001=k>
g/h4o`05g/kNc]h04@000=H000?o00003004cP05olk>c_l01<h:00?>00Goc/k>o`05cQ40003F0003
o`0000`000g>g/kNomk>g_oNc]k>00X000gNc]kog/kNomk>g/kN0140003C00?o3`04cP05olk>c_l0
1<h:00?>00Goc/k>o`05cQ40003C0003o`0000l000G>g/kNcP05o`03c]k>00X000CNc]k>1Ol01<kN
c]hA0000d`04o`l02lh<00_>4P000>H000_Nc]k>g/kNc]k>gP0<000;c]k>g/kNc]k>g/h04P000>L0
2Lh>00W>4`000=T000?o00003@001LkNc]k>010000Oo0=k>g/kN01D0003J0003o`0000l000?o0000
3`000ol0000I0000fP000ol0000?0003o`0000h000?o00006P000=/000?o00003P000ol0000=0003
o`0001/0003L0003o`0000d000?o000030000ol0000L0000g@000ol0000<0003o`0000`000?o0000
70000=d000?o000030000ol0000;0003o`0001d0003N0003o`0000/000?o00002P000ol0000N0000
g`000ol0000:0003o`0000X000?o00007P000=l000?o00002P000ol000090003o`0001l0003P0003
o`0000T000?o000020000ol0000P0000h@000ol000080003o`0000P000?o000080000>8000?o0000
1`000ol000070003o`000240003R0003o`0000L000?o00001P000ol0000R0000h`000ol000060003
o`0000H000?o00008P000>@000?o00001@000ol000050003o`0002<0003T0003o`0000D000?o0000
10000ol0000T0000i@000ol000040003o`0000@000?o000090000>H000?o00000`000ol000030003
o`0002D0003W0003o`00008000?o00000P000ol0000V0000i`001ol0c]k>g/h00P000ol0000W0000
i`09cP03o`0002L0003V000;g/kNc]k>g/kNc]h0:@000>H02lhY0000JP04oa401?l@00?o5P04ocD0
00G>g/kNcP02o`06g_ooc]k>:00006T000?o000050000ol0000C0003o`00018000?o0000=`05cP04
olk>o`C>:00006T000?o00005@000ol0000B0003o`00018000?o0000=`003LkNc]k>olkNomk>g/h0
:00006T000Go0000o`0D0003o`0000h00olE0005o`000?l0=@05cP04olk>o`C>:00006X01?lD0003
o`0000h000?o00005P04ocD000G>g/kNcP04o`04g/kNcRP0001o00?o4@04odl01<h00oo>cP04cRT0
003V0003g/kN00;o00K>g/kNc]hY0000i`09cRX0001`0003o`0001l000?o00007P000ol0000a0007
o`3>g/kNcP0/0000L0000ol0000>0003o`0000d000?o000080000ol0000_0003o`000340001a0003
o`0000d000?o000030000ol0000R0003o`0002d000?o0000<P00078000?o000030000ol0000<0003
o`0002<000?o0000:`000ol0000c0000LP000ol0000<0003o`0000/000?o00009@000ol0000Y0003
o`0003@0001c0003o`0000/000?o00002P000ol0000W0003o`0002L000?o0000=@0007@000?o0000
2P000ol0000:0003o`0002P000?o00009@000ol0000f0000M0000ol0000:0003o`0000T000?o0000
:P000ol0000S0003o`0003L0001e0003o`0000T000?o00002@000ol0000[0003o`00024000?o0000
>00007H000?o000020000ol000080003o`0002d000?o00007`000ol0000i0000MP000ol000080003
o`0000L000?o0000;`000ol0000M0003o`0003X0001g0003o`0000L000?o00001`000ol0000`0003
o`0001/000?o0000>`0007L000?o00001`000ol000060003o`00038000?o00006@000ol0000l0000
N0000ol000060003o`0000D000?o0000=0000ol0000G0003o`0003d0001i0003o`0000D000?o0000
1@000ol0000e0003o`0001D000?o0000?P0007T000?o00001@000ol000040003o`0003L000?o0000
4`000ol0000o0000NP000ol000040003o`0000@000?o0000>0000ol0000A0003o`000400001k0003
o`0000<000?o00000`000ol0000j0003o`0000l000?o0000@@0007/000?o00000`000ol000020003
o`0003`000?o00003@000ol000120000O0000ol000020003o`00008000?o0000?@000ol0000;0003
o`0004<0001m0009o`3>g/kNcP3o044000Wo0000c]k>g/h00`000ol000140000O@09cT8000?oc/h0
1lh00ol000150000O0000mk>gP03o`05g/kNc]h0@@000mk>gP03o`05g/kNc]h0A`0007`01/h00oo>
cP02cT401/h00oo>cP02cTL0000c00Co7P03oaD01Ol90004c]k>gPCo00G>g/kNcP0800?o5P04oaX0
00C>g/kN1?l01LkNc]k>04H0000c0005o`000?l080000ol0000B0004o`00o`X00lh01Oo>c/ko00G>
2`000ol0000B0003o`0001`00lh01Oo>c/ko00G>AP0003<000Go0000o`0P0003o`0001801?l:000=
c]k>olkNc_o>g/kNcP0;0003o`0001801OlJ000=c]k>olkNc_o>g/kNcP160000<`001Ol0003o01h0
0_lH0003o`0000P00lh01Oo>c/ko00G>2@02oaD000Go0000o`0J00?>00Goc/k>o`05cTH0000c00Co
8@000ol0000B00Co2P001<kNc]h5o`04g/kNcP/000?o00004`03oa/000C>g/kN1Ol01=k>g/i60000
<`000ol0000O00?o900;cPT00ole00_>A`0003800_m8000;g/kNc]k>g/kNc]h0@@002mk>g/kNc]k>
g/kN04L0001m00W>@`09cTP0000h0003o`0001T000?o000070000ol000090005c]k>g/h02`000ol0
000L0003o`0001T000Koc]k>g/i:0000>0000ol0000I0003o`0001`000?o00002`000ol0000;0003
o`0001`000?o00006@000ol0001=0000>@000ol0000G0003o`0001h000?o00002P000ol0000:0003
o`0001h000?o00005`000ol0001>0000>P000ol0000E0003o`00020000?o00002@000ol000090003
o`00020000?o00005@000ol0001?0000>P000ol0000E0003o`00020000?o00002@000ol000090003
o`00020000?o00005@000ol0001?0000>`000ol0000C0003o`00028000?o000020000ol000080003
o`00028000?o00004`000ol0001@0000>`000ol0000C0003o`00028000?o000020000ol000080003
o`00028000?o00004`000ol0001@0000?0000ol0000A0003o`0002@000?o00001`000ol000070003
o`0002@000?o00004@000ol0001A0000?0000ol0000A0003o`0002@000?o00001`000ol000070003
o`0002@000?o00004@000ol0001A0000?@000ol0000?0003o`0002H000?o00001P000ol000060003
o`0002H000?o00003`000ol0001B0000?@000ol0000?0003o`0002H000?o00001P000ol000060003
o`0002H000?o00003`000ol0001B0000?P000ol0000=0003o`0002P000?o00001@000ol000050003
o`0002P000?o00003@000ol0001C0000?P000ol0000=0003o`0002P000?o00001@000ol000050003
o`0002P000?o00003@000ol0001C0000?`000ol0000;0003o`0002X000?o000010000ol000040003
o`0002X000?o00002`000ol0001D0000?`000ol0000;0003o`0002X000?o000010000ol000040003
o`0002X000?o00002`000ol0001D0000@0000ol000090003o`0002`000?o00000`000ol000030003
o`0002`000?o00002@000ol0001E0000@0000ol000090003o`0002`000?o00000`000ol000030003
o`0002`000?o00002@000ol0001E0000@@000ol000070003o`0002h000?o00000P000ol000020003
o`0002h000?o00001`000ol0001F0000@@000ol000070003o`0002h000?o00000P000ol000020003
o`0002h000?o00001`000ol0001F0000@P000ol000050003o`00030000Go0000o`030003o`000300
00?o00001@000ol0001G0000@`001ooNc]k>g_l0=0001oo>g/kNc_l0=0001lkNc]k>0?l0FP000480
2Lhb00W><@09cUX000110003c]k>00?o00G>g/kNcP0`0003g/kN00?o00GNc]k>gP0_000;g/kNc]k>
g/kNc]h0F@0004401/h00oo>cP02cS001/h00oo>cP02cRl02liI00002005oc<000CNc]k>1?l01Mk>
g/kN02h000C>g/kN1?l01LkNc]k>02d000G>g/kNcP02o`06g_ooc]k>=003ob4000080004o`00oc@0
0lh01Oo>c/ko00G>;P03cP05olk>c_l01Lh]00G>00Coc/ko1<he0003o`000200000800Co=0003Mk>
g_oNc]kog/kNc]h0;P003LkNc_o>g/koc]k>g/h0;@003LkNc]k>olkNomk>g/h0=@000ol0000P0000
2`000ol0000b00?>00Goc/k>o`05cRh00lh01Oo>c/ko00G>;@05cP04olk>o`C>=@000ol0000P0000
2004o`H00ol[0004g/kNcPGo00C>g/kN;P001<kNc]h5o`04g/kNcRd000G>g/kNcP04o`04g/kNcR`0
0_l70003o`000200000E00Co:00;cP03o`0002d02lh_00C>00?oc/h01<hY00Co2002ob80000I00Co
90003<kNc]k>g/kNc]k>00;o;@002mk>g/kNc]k>g/kN02d00_l00mk>gP02o`06c]k>g/kN9@04oc00
000M00?o8P09cP@00_l/00W>;002o`<02LhS00?o=00002001?lP0005g/kNc]h02002ob`000G>g/kN
cP0/00;o1`001LkNc]k>02401?lg00009004ob/00_l/0003o`0002X00_l[00Co>`0002P00olZ00;o
:P000ol0000X00;o:P03ocl0000[00Co:002obP000?o00009P02obP01?m20000;`04obH000?o0000
9@000ol0000U0003o`0002@01?m60000<`03ob@00_lU0003o`0002<00_lT00?oBP0003H01?lR00;o
8`000ol0000Q00;o8P04odd0000j00Co8002ob4000?o00007`02ob001?mA0000?P03oal00_lO0003
o`0001d00_lO00?oE@0004401?lM00;o7@000ol0000K00;o7@04oeP0001500Co6`000ol0000J0003
o`0001X000?o00006@04oe`0001900Co6002oaX000?o00006002oaP01?mP0000C@03oaL00_lH0003
o`0001H00_lG00?oI00005001?lE00;o5P000ol0000D00;o5@04ofL0001D00Co4`02oa@000?o0000
4P02oa<01?m[0000F003oa800_lB0003o`0001000_lB00?oK`0005/01?l@0003o`0000l000?o0000
3`000ol0000>00CoLP0005l01?l=00;o3`000ol0000=00;o3@04ogH0001S00?o3002o`d000?o0000
2`02o``00omj0000IP04o`X00_l;0003o`0000T00_l:00CoO@0006X01?l800;o2@000ol0000700;o
2004oh40001^00?o1`02o`D01Lh500;o1`03ohD0001a00Co1@02o`0;0<kNc]k>g/kNcP000_l500Co
R00007D01?l300_>0`04oh`0001i00?o00?Nc]h01?l01<kNc]h3oi00001k00G>00?oc/h01LjB0000
N`003LkNc]k>olkNc]k>g/h0TP0007/01Lh00oo>cP05cY80001k0004c]k>gPCo00G>g/kNcP2B0000
N`05cP03olk>00G>TP0007`000CNc]k>0ol01<kNc]jC0000O00;cY<0001m0009c]k>g/kNc]k>09@0
0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1952, -1.04247, 0.0169762, 
  0.00627139}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic expression trees", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[a, g[b,d], c, h[e, g[c, g[b,a]]], d]
    ]
  ],
  chromo[q[undef],
    p[
      f[A, h[E, g[C, g[B,A]]], C, g[B,D], D]
    ]
  ]
]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[b, a]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[B, D], D]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[b, a]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[B, D], D]]]]\
\>"], 
  "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Mshowa
P
1 g
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.44709 .16187 L
s
.62346 .30902 m
.79982 .16187 L
s
1 g
.05 w
.44709 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Mshowa
P
.004 w
.79982 .16187 m
.62346 .01472 L
s
.79982 .16187 m
.97619 .01472 L
s
1 g
.05 w
.62346 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Mshowa
P
.9 g
.79982 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Mshowa
P
.9 g
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{255, 157.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003o0000W@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0003o0000o`000?l0002K00CoD@05o`X0
002K0005o`000?l0D0001?l00?l;0000V`001Ol0003o05001?l;0000V`001Ol0003o05<000?o0000
2@0009/01?mA00Co2`0009/000?o0000H@0009X00_l60003o`0005X0002S00;oA`02oa40002U0003
o`0004<000?o00004@000:H000?o0000@@000ol0000B0000Y`000ol0000o0003o`0001<0002X0003
o`0003d000?o000050000:T00_lk00;o5`000:/000?o0000=`000ol0000G0000[0000ol0000e0003
o`0001P0002]0003o`0003<000?o00006@000:h000?o0000<@000ol0000J0000[`02obl00_lM0000
/@000ol0000[0003o`0001d0002b0003o`0002T000?o00007P000;<000?o00009`000ol0000O0000
]0000ol0000U0003o`000200002e0003o`0002<000?o00008@000;H00_lQ00;o90000;P000?o0000
7@000ol0000T0000^@000ol0000K0003o`0002D0002j0003o`0001T000?o00009P000;/000?o0000
5`000ol0000W0000_002oaD00_lZ0000_P000ol0000A0003o`0002X0002o0003o`0000l000?o0000
:`000<0000?o00003@000ol0000/0000`@000ol0000;0003o`0002d0003200;o0P04b`<00_l`0000
a002b`?o0l/00ol0000`0000``06b`04ol_;bc80001`00CoC`03b`Co0l/b0000K`000ol0001@00?;
00Gobl_;o`04bc40001_0003o`0005000l/01Oo;bl_o00C;<@0006l000Go0000o`1>00?;00Gobl_;
o`04bc40001`00CoCP04b`Go0l/a0000``0:bc80001g0003o`0004T02//b0000N002odL00_l00`3;
b`06bc<0001j0003o`0004<000?o00000`04bcD0001k0003o`00044000?o0000?@0007`000?o0000
?`000ol0000n0000O@000ol0000m0003o`0003l0001n00;o>`02od8000200003o`0003L000?o0000
@P00084000?o0000=@000ol000130000PP000ol0000c0003o`0004@000230003o`00034000?o0000
A@0008@00_l_00;oB00008H000?o0000:`000ol000180000Q`000ol0000Y0003o`0004T000280003
o`0002L000?o0000BP0008T000?o00009@000ol0001;0000RP000ol0000S0003o`0004`0002;00;o
8@02odl0002=0003o`0001d000?o0000C`0008h000?o00006`000ol0001@0000S`000ol0000I0003
o`000540002@0003o`0001L000?o0000DP0009400_lE00;oE@0009<000?o00004@000ol0001E0000
U0000ol0000?0003o`0005H0002E0003o`0000d000?o0000E`0009H000?o00002`000ol0001H0000
U`02o`801</300;oF`0009T00//3o`?;00?o0000F`0009P01//01?o;bl]M00008P04oah01Ol_00Co
7003b`Co0l]M00008P001Ol0003o01`000Go0000o`0_0003o`0001d00l/01Oo;bl_o00C;G0000280
00Go0000o`0L0005o`000?l0;`05oa/00l/01Oo;bl_o00C;G000028000Go0000o`0L0005o`000?l0
;`001Ol0003o01/00l/01Oo;bl_o00C;G00002801?lN00Co<003oa`01</5o`?;G000028000?o0000
8P000ol0001>00[;G@0002400_lS00;oD00:bed0002I00S;GP0002L000?o00006@000ol0000g0003
o`0001X000?obl/00/]P00009`000ol0000I0003o`0003L000?o00006P000ol0001R0000:0000ol0
000G0003o`0003T000?o000060000ol0001S0000:0000ol0000G0003o`0003T000?o000060000ol0
001S0000:0000ol0000G0003o`0003T000?o00005`000ol0001T0000:@000ol0000E0003o`0003/0
00?o00005P000ol0001T0000:@000ol0000E0003o`0003/000?o00005@000ol0001U0000:P000ol0
000C0003o`0003d000?o000050000ol0001U0000:P000ol0000C0003o`0003d000?o00004`000ol0
001V0000:`000ol0000A0003o`0003l000?o00004P000ol0001V0000:`000ol0000A0003o`0003l0
00?o00004@000ol0001W0000;0000ol0000?0003o`00044000?o000040000ol0001W0000;0000ol0
000?0003o`00044000?o00003`000ol0001X0000;@000ol0000=0003o`0004<000?o00003P000ol0
001X0000;@000ol0000=0003o`0004<000?o00003@000ol0001Y0000;P000ol0000;0003o`0004D0
00?o000030000ol0001Y0000;P000ol0000;0003o`0004D000?o00002`000ol0001Z0000;`000ol0
00090003o`0004L000?o00002P000ol0001Z0000;`000ol000090003o`0004L000?o00002@000ol0
001[0000<0000ol000070003o`0004T000?o000020000ol0001[0000<0000ol000070003o`0004T0
00?o00001`000ol0001/0000<@000ol000050003o`0004/000?o00001P000ol0001/0000<@000ol0
00050003o`0004/000?o00001@000ol0001]0000<@000ol000050003o`0004/000?o00001@000ol0
001]0000<P000ol000030003o`0004d000?o00000`000ol0001^0000<P000ol0b`03b`03o`0004d0
00?o0</00l/00ol0001^0000<P001<_oool4bdh02<]_0000<@05b`03ol_;00;;C00:bfh0000700Go
9@02b`Co1</S00Co9@02b`;o00?;ool00l/T00GoA@0000L000Co003o9@02b`05ol_;bol01L/Q0003
o`0002H00l/01?o;bol5bb8000Go0000o`1600001`04obD00//01Oo;bl_o00G;8@000ol0000V00?;
00Cobl_o1L/R0005o`000?l0AP0000X000?o00008`02b`05ol_;bol01L/Q0005o`000?l09003b`04
ol_;o`G;8P001Ol0003o04H0000700Co1@000ol0000M00?;1Ol4bb801?lT00?;1?l5bb<01?m60000
4@02oah02/]<00;;00?obl/01L/N00;o1`000ol0001400004`03oa/02/];0004ol_oo`O;6`03o`P0
0_m600005P02oaX02</00`3oo`1700;o0P08baX00_mC00006003oaT01</50003o`0004<000?o0000
1004baT00omE00006`02ob4000?o00007`000ol0000O0003o`0002000_mH00007@02ob0000?o0000
7P000ol0000N0003o`0001h00omJ00007`03oah000?o00007@000ol0000M0003o`0001d00_mM0000
8P02oad00_lM0003o`0001/00_lN00;oG`0002@00_lM0003o`0001X000?o00006P000ol0000K00?o
H@0002H00olK0003o`0001T000?o00006@000ol0000J00;oI00002T00_lJ0003o`0001P000?o0000
60000ol0000H00?oIP0002/00olH0003o`0001L000?o00005`000ol0000G00;oJ@0002h00_lG00;o
5`000ol0000E00;o6002of/0000`00;o5`000ol0000D0003o`0001@000?o00005@03ofd0000b00?o
5@000ol0000C0003o`0001<000?o00005002og00000e00;o50000ol0000B0003o`00018000?o0000
4P03og80000g00?o4P000ol0000A0003o`00014000?o00004@02ogD0000j00;o4@000ol0000@0003
o`00010000?o00003`03ogL0000l00;o4002oa0000?o00003P02oa000_mj0000?P03o`l000?o0000
3@000ol0000=0003o`0000h00_ml0000@@02o`h000?o000030000ol0000<0003o`0000`00omn0000
@`03o``000?o00002`000ol0000;0003o`0000/00_n10000AP02o`/000?o00002P000ol0000:0003
o`0000T00on30000B002o`X00_l:0003o`0000P00_l:00;oQP0004X00ol90003o`0000L000?o0000
1`000ol0000800;oR00004d00_l80003o`0000H000?o00001P000ol0000600?oRP0004l00_l70003
o`0000D000?o00001@000ol0000500;oS@0005400ol50003o`0000@000?o000010000ol0000300?o
S`0005@00_l400;o10000ol0000200;o1002oi80001F00?o0`000ol00004b`030?l000800onD0000
F@02o`802</00`3oo`2G0000F`000oo;b`04o`C;V@0005`00l/00oo;b`04biT0001K00C;00?obl/0
1L^H0000F`04b`03ol_;00G;V00005/00l/4o`G;V00005/01</00oo;b`05biP0001L00?;0ol4biT0
001L00[;V@0005d02<^J0000\
\>"],
  ImageRangeCache->{{{0, 254}, {156.312, 0}} -> {-2.24189, -0.833976, 
  0.0231645, 0.00555273}},
  CellTags->"Recombination - basic expressions"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .16667 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .11905 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .35714 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .83333 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .59524 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .35714 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .64286 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .83333 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.2619 .45617 m
.16667 .30902 L
s
.2619 .45617 m
.35714 .30902 L
s
1 g
.05 w
.16667 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .16667 .30902 0 0 Mshowa
P
.004 w
.35714 .30902 m
.11905 .16187 L
s
.35714 .30902 m
.59524 .16187 L
s
1 g
.05 w
.11905 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .11905 .16187 0 0 Mshowa
P
.004 w
.59524 .16187 m
.35714 .01472 L
s
.59524 .16187 m
.83333 .01472 L
s
1 g
.05 w
.35714 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .35714 .01472 0 0 Mshowa
P
1 g
.83333 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .83333 .01472 0 0 Mshowa
P
.9 g
.59524 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .59524 .16187 0 0 Mshowa
P
.9 g
.35714 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .35714 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Mshowa
P
.004 w
.7381 .45617 m
.64286 .30902 L
s
.7381 .45617 m
.83333 .30902 L
s
1 g
.05 w
.64286 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .64286 .30902 0 0 Mshowa
P
1 g
.83333 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .83333 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{255, 157.312},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003o0000W@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0003o0000o`000?l0001I00GoK`02o`80
0_l/0000FP001Ol0003o06l000Co003o;@0005X000Go0000o`1_00Co;@0005X01?m`0004o`00obd0
001J0005o`000?l0L002obh0001I00Go0`02ofL00_l200?o;P0006<000?o0000H`000ol0000c0000
I002of400_lf0000IP000ol0001M0003o`0003H0001W00;oF`02ocT0001Y00;oE`02oc/0001[0003
o`0005<000?o0000>`0006`00_mA00;o?P0006h00_m=00;o@000070000?o0000B@000ol000100000
L@02odL00_m30000L`000ol000130003o`0004<0001d00;o@@02odH0001f00;o?@02odP0001h0003
o`0003T000?o0000B00007T00_lg00;oB`0007/000?o0000<`000ol0001;0000O002oc400_m>0000
OP02obd00_m@0000P0000ol0000Y0003o`000500002100;o9`02oe<000230003o`0002<000?o0000
D`0008@00_lQ00;oEP0008H00_lM00;oF00008P000?o00006@000ol0001H0000R@02oaL00_mK0000
R`02oa<00_mM0000S@000ol0000?0003o`0005d0002>00;o1004b`D00_mP0000T0001?l0bl/3o`?;
0P000ol0001P0000T@06b`05ol_;bol0H`0001l00om_00?;1?l3bf@0000N0005o`000?l0K@03b`05
ol_;bol01<]S00007P000ol0001_00?;00Gobl_;o`04bf<0000N0003o`0006l00l/01Oo;bl_o00C;
H`0001h000Go0000o`1]00C;1Ol3bf<0000O00Co10000ol0001V0003ol_;00S;I00002P000?o0000
I0000ol0b`09bf@0000Y00;oHP02o`<02<]U0000:`02oel000?o00001@04bfL0000]0003o`0005X0
0_mc0000;P02oeP00_me0000<002oeD000?o0000M@00038000?o0000D002ogP0000c00;oCP02ogX0
000e0003o`0004X000?o0000NP0003H00_m800;oO@0003P00_m50003o`0007d0000j0003o`000400
0_n00000>`02och00_n20000?@02oc/000?o0000PP0003l000?o0000=P02ohD0001000;o=@000ol0
00250000@P02oc400_n80000A0000ol0000/00;oRP0004D00_l[0003o`0008X0001700;o9`02ohd0
00190003o`0002<000?o0000S@0004X00_lQ00;oT00004`000?o00007002oi80001=00;o6`000ol0
002B0000C`02oaL00_nE0000D@000ol0000B00;oU`0005800_lA0003o`0009L0001D00;o1004b`D0
0_nJ0000EP001?l0bl/3o`?;0P000ol0002J0000E`06b`05ol_;bol0W@0002X01_lW00?;1?l3bcd0
1OlZ00Go;@0002/000?o0000:003b`05ol_;bol01</m0005o`000?l0:P001Ol0003o02`0000[0003
o`0002P00l/01Oo;bl_o00C;?@001Ol0003o02X000Go0000o`0/0000:`04obL00l/01Oo;bl_o00C;
?@04ob/000Go0000o`0/0000:`000ol0000X00C;1Ol3bcd000Go0000o`0Z0005o`000?l0;00002X0
1_lW00[;?@05obX01Ol]0000E`0:bih0001H00S;W`00034000?o000090000ol0b`03bdL000?o0000
90000ol0000`0000<@000ol0000T0003o`0004X000?o000090000ol0000`0000<P000ol0000R0003
o`0004`000?o00008P000ol0000a0000<P000ol0000Q0003o`0004h000?o00008@000ol0000a0000
<`000ol0000P0003o`0004h000?o000080000ol0000b0000=0000ol0000N0003o`00050000?o0000
7P000ol0000c0000=0000ol0000M0003o`00058000?o00007@000ol0000c0000=@000ol0000L0003
o`00058000?o000070000ol0000d0000=P000ol0000J0003o`0005@000?o00006P000ol0000e0000
=P000ol0000I0003o`0005H000?o00006@000ol0000e0000=`000ol0000H0003o`0005H000?o0000
60000ol0000f0000>0000ol0000F0003o`0005P000?o00005P000ol0000g0000>0000ol0000E0003
o`0005X000?o00005@000ol0000g0000>@000ol0000D0003o`0005X000?o000050000ol0000h0000
>@000ol0000C0003o`0005`000?o00004`000ol0000h0000>P000ol0000A0003o`0005h000?o0000
4@000ol0000i0000>`000ol0000@0003o`0005h000?o000040000ol0000j0000>`000ol0000?0003
o`00060000?o00003`000ol0000j0000?0000ol0000=0003o`00068000?o00003@000ol0000k0000
?@000ol0000<0003o`00068000?o000030000ol0000l0000?@000ol0000;0003o`0006@000?o0000
2`000ol0000l0000?P000ol000090003o`0006H000?o00002@000ol0000m0000?`000ol000080003
o`0006H000?o000020000ol0000n0000?`000ol000070003o`0006P000?o00001`000ol0000n0000
@0000ol000050003o`0006X000?o00001@000ol0000o0000@0000ol00004b`030?l006/000?o0</0
0l/20003o`0003l0001100S;K002b`?o0l]20000@00:bfX01//01?o;bl]100001`02o`800_lc00;;
0_l00l_oo`03bc<00old00?;1?l3bc801Ol:000020001?l00?lc00?;00Cobl_o1L/a0005o`000?l0
<P03b`05ol_;bol01</b0005o`000?l02@0000P01?lc00?;00Cobl_o1L/a0003o`0003@00l/01Oo;
bl_o00C;<P001Ol0003o00T000080004o`00oc<00l/01?o;bol5bc4000?o0000=003b`05ol_;bol0
1</b0005o`000?l02@0000T00_l500?o;003b`Co1L/a0005o`000?l0<P04b`Go0l//00;o10001Ol0
003o00T0000800?o2003obX00//00oo;b`05b`03o`0003001?lb0003ol_;00S;:P03o`D01Ol:0000
5P04obH000?;ool01l/00`3o001U0003o`3;00W;9P04oaL0000J00?o9008b`<00_mR00;o0`08bb@0
0olK00007@03ob<01</700;oG`000ol0000500C;8`03oah0000P00?o;@000ol0000/0003o`0002/0
0_l/00?o8@0002<01?lZ00;o;0000ol0000Y00;o:`03ob@0000W00?o:@02obX000?o0000:0000ol0
000W00Co9`0002X00olX0003o`0002L000?o00009P02obL00ol[0000;@03obH00_lW0003o`0002@0
0_lV00?o;P0003001?lT0003o`0002@000?o00008`000ol0000S00?o<@0003@00olR00;o90000ol0
000Q00;o8P04oc@0000g00?o8@02ob8000?o000080000ol0000O00?o>00003X00olP0003o`0001l0
00?o00007P02oal00olk0000?@04oad00_lO0003o`0001`00_lN00?o?P0004400olL00;o7@000ol0
000K0003o`0001/00om10000A003oa/000?o00006P000ol0000I00;o6P04od@0001700?o6@02oaX0
00?o000060000ol0000G00?oB00004X01?lG00;o60000ol0000F00;o5`03od/0001>00?o5P000ol0
000E0003o`0001@00_lF00?oCP0005400olD00;o5@000ol0000C0003o`0001801?mA0000E003oa<0
0_lC0003o`0001400_lB00?oE@0005L01?lA0003o`00010000?o000040000ol0000?00?oF00005/0
0ol?00;o40000ol0000>00;o3`03oe/0001N00?o3P000ol0000=0003o`0000`00_l>00?oGP000640
0ol<00;o3@000ol0000;0003o`0000X01?mQ0000I004o`X00_l;0003o`0000T00_l:00?oI@0006P0
0ol90003o`0000P000?o00001`02o`T00omX0000J`03o`L00_l80003o`0000H000?o00001P03of/0
001^00?o1P02o`H000?o00001002o`D01?m^0000L@04o`@000Co00001</40003o`0000800omb0000
M@03o`8000?obl/01//2o`800ome0000N002o`?;1?l3b`?oN00007X01</00oo;b`03bg/0001i00G;
00?obl/01<]j0000N@05b`03ol_;00C;NP0007T01</4o`C;NP0007T01L/00oo;b`04bgX0001j00C;
0ol3bg/0001j00[;N`0007/02<]l0000\
\>"],
  ImageRangeCache->{{{0, 254}, {156.312, 0}} -> {-2.17918, -0.833976, 
  0.0171589, 0.00555273}},
  CellTags->"Recombination - basic expressions"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination without restricting templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of recombined chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
recChromos = Join @@ Table[
  Recombination[theChromos, SelectionMode -> RANDOM], {5}];

recChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, 
 
    g[B, f[a, g[b, d], c, h[e, g[c, g[b, a]]], d]], D]]]
chromo[q[undef], p[D]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[A, D], D]]]
chromo[q[undef], p[f[B, h[E, g[C, g[B, A]]], C, g[B, D], D]]]
chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], g[b, d], g[B, D], D]]]
chromo[q[undef], p[f[a, C, c, h[e, g[c, g[b, a]]], d]]]
chromo[q[undef], p[f[a, g[b, d], c, D, d]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[B, h[e, g[c, g[b, a]]]], 
 
    D]]]\
\>", "\<\
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, 
 
    g[B, f[a, g[b, d], c, h[e, g[c, g[b, a]]], d]], D]]]
chromo[q[undef], p[D]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[A, D], D]]]
chromo[q[undef], p[f[B, h[E, g[C, g[B, A]]], C, g[B, D], D]]]
chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], g[b, d], g[B, D], D]]]
chromo[q[undef], p[f[a, C, c, h[e, g[c, g[b, a]]], d]]]
chromo[q[undef], p[f[a, g[b, d], c, D, d]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[B, h[e, g[c, g[b, a]]]], 
 
    D]]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["recChromos", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
pop[chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, 
 
     g[B, f[a, g[b, d], c, h[e, g[c, g[b, a]]], d]], D]]], 
 
  chromo[q[undef], p[D]], chromo[q[undef], 
 
   p[f[A, h[E, g[C, g[B, A]]], C, g[A, D], D]]], 
 
  chromo[q[undef], p[f[B, h[E, g[C, g[B, A]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], g[b, d], g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, C, c, h[e, g[c, g[b, a]]], d]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, D, d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[B, h[e, g[c, g[b, a]]]], 
 
     D]]]]\
\>", "\<\
pop[chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, 
 
     g[B, f[a, g[b, d], c, h[e, g[c, g[b, a]]], d]], D]]], 
 
  chromo[q[undef], p[D]], chromo[q[undef], 
 
   p[f[A, h[E, g[C, g[B, A]]], C, g[A, D], D]]], 
 
  chromo[q[undef], p[f[B, h[E, g[C, g[B, A]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], g[b, d], g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, C, c, h[e, g[c, g[b, a]]], d]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, D, d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[B, h[e, g[c, g[b, a]]]], 
 
     D]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ recChromos;", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.399843 0.188017 0.603319 0.490503 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .50522 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .14636 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .13481 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .29574 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .54383 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .41979 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2773 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .21183 .50522 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .39984 .50522 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .52239 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .51084 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .53247 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .6317 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .58209 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .65333 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .67496 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .66621 .11282 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .78817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .88218 .11282 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .77419 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72458 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .79582 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .65333 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .58786 .50522 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .77588 .50522 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .39984 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.39984 .60332 m
.02381 .50522 L
s
.39984 .60332 m
.21183 .50522 L
s
.39984 .60332 m
.39984 .50522 L
s
.39984 .60332 m
.58786 .50522 L
s
.39984 .60332 m
.77588 .50522 L
s
1 g
.05 w
.02381 .50522 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .50522 0 0 Mshowa
P
.004 w
.21183 .50522 m
.14636 .40712 L
s
.21183 .50522 m
.2773 .40712 L
s
1 g
.05 w
.14636 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .14636 .40712 0 0 Mshowa
P
.004 w
.2773 .40712 m
.13481 .30902 L
s
.2773 .40712 m
.41979 .30902 L
s
1 g
.05 w
.13481 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .13481 .30902 0 0 Mshowa
P
.004 w
.41979 .30902 m
.29574 .21092 L
s
.41979 .30902 m
.54383 .21092 L
s
1 g
.05 w
.29574 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .29574 .21092 0 0 Mshowa
P
1 g
.54383 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .54383 .21092 0 0 Mshowa
P
.9 g
.41979 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .41979 .30902 0 0 Mshowa
P
.9 g
.2773 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2773 .40712 0 0 Mshowa
P
.9 g
.21183 .50522 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .21183 .50522 0 0 Mshowa
P
1 g
.39984 .50522 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .39984 .50522 0 0 Mshowa
P
.004 w
.58786 .50522 m
.52239 .40712 L
s
.58786 .50522 m
.65333 .40712 L
s
1 g
.05 w
.52239 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .52239 .40712 0 0 Mshowa
P
.004 w
.65333 .40712 m
.51084 .30902 L
s
.65333 .40712 m
.58209 .30902 L
s
.65333 .40712 m
.65333 .30902 L
s
.65333 .40712 m
.72458 .30902 L
s
.65333 .40712 m
.79582 .30902 L
s
1 g
.05 w
.51084 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .51084 .30902 0 0 Mshowa
P
.004 w
.58209 .30902 m
.53247 .21092 L
s
.58209 .30902 m
.6317 .21092 L
s
1 g
.05 w
.53247 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .53247 .21092 0 0 Mshowa
P
1 g
.6317 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .6317 .21092 0 0 Mshowa
P
.9 g
.58209 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .58209 .30902 0 0 Mshowa
P
1 g
.65333 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .65333 .30902 0 0 Mshowa
P
.004 w
.72458 .30902 m
.67496 .21092 L
s
.72458 .30902 m
.77419 .21092 L
s
1 g
.05 w
.67496 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .67496 .21092 0 0 Mshowa
P
.004 w
.77419 .21092 m
.66621 .11282 L
s
.77419 .21092 m
.88218 .11282 L
s
1 g
.05 w
.66621 .11282 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .66621 .11282 0 0 Mshowa
P
.004 w
.88218 .11282 m
.78817 .01472 L
s
.88218 .11282 m
.97619 .01472 L
s
1 g
.05 w
.78817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .78817 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Mshowa
P
.9 g
.88218 .11282 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .88218 .11282 0 0 Mshowa
P
.9 g
.77419 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .77419 .21092 0 0 Mshowa
P
.9 g
.72458 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72458 .30902 0 0 Mshowa
P
1 g
.79582 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .79582 .30902 0 0 Mshowa
P
.9 g
.65333 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .65333 .40712 0 0 Mshowa
P
.9 g
.58786 .50522 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .58786 .50522 0 0 Mshowa
P
1 g
.77588 .50522 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .77588 .50522 0 0 Mshowa
P
.9 g
.39984 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .39984 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002j00Co9`05o`X0
002j0005o`000?l09P001?l00?l;0000^P001Ol0003o02H01?l;0000^P001Ol0003o02T000?o0000
2@000;X01?lW00Co2`000;X000?o0000=`000;T00_li0000`0000ol0000Q0003o`0000d000310003
o`0001l000?o00003P000<8000?o00007@000ol0000?0000``000ol0000K0003o`00010000340003
o`0001T000?o00004@000<D000?o00005`000ol0000B0000aP000ol0000E0003o`0001<000370003
o`0001<000?o000050000<P000?o00004@000ol0000E0000b@000ol0000?0003o`0001H0003:0003
o`0000d000?o00005`000</000?o00002`000ol0000H0000c0000ol000090003o`0001T0003=0003
o`0000G;0P000ol0000J0000cP000oo;o`02o`?;00?o00006`000<h01L/01?o;bl/M0000WP04ob/0
0l/4o`C;700009d000?o0000;@02b`05ol_;bol01</L0000W@000ol0000]00;;00Gobl_;o`04ba`0
002M0005o`000?l0:`02b`05ol_;bol01</L0000WP04ob/00l/5o`?;70000<h02L/M0000Y@000ol0
000U0003o`3;00K;7P000:H000?o00008`001?l00005bal0002W0003o`00024000?o00009P000:P0
00?o00007`000ol0000W0000Z@000ol0000M0003o`0002P0002Z0003o`0001/000?o0000:@000:/0
00?o00006@000ol0000Z0000[002oaL00_l]0000[P000ol0000C0003o`0002d0002_0003o`000140
00?o0000;P000;0000?o00003`000ol0000_0000/@000ol0000=0003o`000300002b0003o`0000/0
00?o0000<@000;<000?o00002@000ol0000b0000]0000ol00005b`8000?o0000<`000;D000?obol0
0_l3b`03o`0003@0002e00G;00Cobl_;=P0004H01Old00Co4`05o`D01?l@00?;1?l4bcD000170005
o`000?l0<`001Ol0003o014000Go0000o`050003o`0001800//01Oo;bl_o00C;=@0004L000Go0000
o`0c0005o`000?l04@001Ol0003o00D01Ol@00;;00Gobl_;o`04bcD0001700Co=0001Ol0003o0140
00Go0000o`050005o`000?l04002b`05ol_;bol01</e0000A`001Ol0003o03<01?lC00Co1P03oa40
0l/5o`?;=@0004H01Old0003o`0001L000?o00006@09bcH0001>00;o;P02oaP00_lL00O;=`000500
00?o0000:@000ol000040003o`0003401L/h0000D@000ol0000W0003o`0000H000?o00003P000ol0
000=0003o`0000h000?o0000>`00058000?o00009@000ol000070003o`0000h000?o00003@000ol0
000>0003o`0003/0001C00;o8`02o`/000?o000030000ol0000?0003o`0000`000?o0000?00005D0
00?o00007`000ol0000;0003o`0000`000?o00003`000ol0000<0003o`0003`0001F0003o`0001d0
00?o00003@000ol0000:0003o`00014000?o00002P000ol0000m0000E`02oa/00_l@0003o`0000X0
00?o00004@000ol0000:0003o`0003d0001I0003o`0001L000?o00004@000ol000080003o`0001<0
00?o000020000ol0000n0000FP000ol0000E0003o`00018000?o00001`000ol0000E0003o`0000L0
00?o0000?P0005/000?o00004`000ol0000C0003o`0000L000?o00005@000ol000070003o`0003h0
001L00;o4@02oaL000?o00001@000ol0000G0003o`0000D000?o0000?`0005h000?o00003@000ol0
000G0003o`0000D000?o00005`000ol000050003o`0003l0001O0003o`0000/000?o00006@000ol0
00030003o`0001T000?o00000`000ol000100000H0001?l00005b`<000?o00006P000oo;b`03b`03
o`0001T01L/00`3o00110000H@02o`04boooo`?;0_lM0004boooo`?;6P07bd<0001R00G;00Cobl_;
7@05b`04ol_;baP02L]200008P03oc`00l/4o`C;3@05o`T00l/4o`C;2@04o`T01</2o`03booo00;;
2@05oc<0000Q0005o`000?l0>`02b`05ol_;bol01</=0004o`00o`X00//01Oo;bl_o00C;20000ol0
000;00C;00Cobl_o0l/80005o`000?l0=000024000?o0000?@02b`05ol_;bol01</=00Co2P02b`05
ol_;bol01</80003o`0000/01</01?o;bol3b`P000Go0000o`0d00008@000ol0000m00;;00Gobl_;
o`04ba0000?o00002002b`05ol_;bol01</80005o`000?l02@04b`04ol_;o`?;20001Ol0003o03@0
000Q0005o`000?l0>`03b`Go0l/=00Co2P03b`Go0l/900Co2@04b`Co0l/900Co=00002801?l30003
o`0003D000?obl/01l/F0003o`0000@02L/H00?;00?obl/00l/70003o`0000<000?o0000<P0002X0
00?o0000<`000ol00007baP000?o00001007baX000?;ool01</70003o`0000<00_ld0000:`02oc40
0_l400G;6P02o`D01L/00ol0000I00G;1P02oc`0000]0003o`0002d000?o00009@000ol000080003
o`0000X000?o00002P000ol000080003o`0003`0000^00;o:`02obT00_l90003o`0000T000?o0000
2@000ol0000700;o?`00030000?o00009`000ol0000[0003o`0000L000?o000020000ol000080003
o`0000L000?o0000?`0003400_lU00;o;`02o`L000?o000020000ol000080003o`0000D00_m20000
<`000ol0000Q0003o`00034000?o00001@000ol000070003o`0000L000?o00001@000ol000120000
=002oal00_le00;o1P000ol000060003o`0000H000?o00001002odD0000f0003o`0001/000?o0000
=`000ol000040003o`0000D000?o00001@000ol000040003o`0004D0000g0003o`0001T000?o0000
>@000ol000030003o`0000D000?o00001@000ol000030003o`0004H0000h00;o5`02ocd00_l40003
o`0000@000?o000010000ol0000200;oB@0003X000?o00004`000ol0000o0003o`00008000?o0000
0`000ol000030003o`00008000?o0000B@0003/00_lA00;o@`02o`8000?o00000`000ol000030003
o`0000;oC00003d000?o00003@000ol000150004o`00o`@000?o00000P001?l00?m>0000?P02o`<0
1L/300;oB@02o`030?l000G;00<0o`000_m?0000@0000ol0b`03o`?;00<0o`00C0000ol0b`06b`03
0?l00500001100G;00Cobl_;C`09be80000S00Ko5`03b`Co1</`00Go6003b`Co1<]A000090000ol0
000I00;;00Gobl_;o`04bc4000Go0000o`0G00C;00?obl/01<]A000090000ol0000I00;;00Gobl_;
o`04bc4000Go0000o`0G00C;00?obl/01<]A00009004oaP00//01Oo;bl_o00C;<@04oaP01</00oo;
b`04be40000T0003o`0001T00l/5o`?;<@001Ol0003o01L00l/4o`C;D@0002<01_lH00W;<@05oaT0
0l/00oo;b`03be80001200O;D@02b`?o0/]C0000:@000ol0000F0003ol_;00?;>@000ol0000F0003
ol_;00?;E00002X000?o000050000ol0000n0003o`0001@000?o0000F00002/000?o00004`000ol0
000o0003o`0001<000?o0000F00002/000?o00004P000ol000100003o`00018000?o0000F@0002`0
00?o000040000ol000120003o`00010000?o0000FP0002d000?o00003`000ol000130003o`0000l0
00?o0000FP0002d000?o00003P000ol000140003o`0000h000?o0000F`0002h000?o000030000ol0
00160003o`0000`000?o0000G00002l000?o00002`000ol000170003o`0000/000?o0000G00002l0
00?o00002P000ol000180003o`0000X000?o0000G@00030000?o00002@000ol000190003o`0000T0
00?o0000G@00034000?o00001`000ol0001;0003o`0000L000?o0000GP00034000?o00001P000ol0
001<0003o`0000H000?o0000G`00038000?obl/00l/20003o`0004d000?obl/00l/20003o`0005l0
000b00O;00?o0000CP02b`?o0//00ol0001P0000<@09bdl01//00oo;b`1R00001`02o`800_lS00C;
0_l00l_oo`02bbD00olU00C;1?l3bb@01Olh000020001?l00?lT00C;00Cobl_o0l/T0005o`000?l0
9003b`05ol_;bol00l/U0005o`000?l0=`0000P01?lT00C;00Cobl_o0l/T0003o`0002H00l/01Oo;
bl_o00?;9@001Ol0003o03L000080004o`00o`<00_lO00C;00Cobl_o0l/T0003o`0002H00l/01Oo;
bl_o00?;9@001Ol0003o03L0000900;o1P04oa/01</4o`?;00?o00008@001Ol0003o02@01</5o`;;
7@04o`@000Go0000o`0g00002003o`X00olI00?;00?obl/00l/200;o8P04ob<00_l9ba/00ol700Go
>00001P01?lF0003booo00C;1@02odD00_l300O;6004odL0000L00Co4`05b`P00_m100;o1P05baD0
1?m;00008004oah000?o00007@000ol0000M0003o`0001`01?m?00009004oa/00_lM0003o`0001/0
0_lK00CoD`0002P01?lI00;o6`000ol0000I00;o6@04oeL0000/00?o6002oaT000?o00005`02oaP0
0omK0000;`04oaH00_lG0003o`0001D00_lF00CoGP0003<01?lD00;o5@000ol0000C00;o5004of80
000g00Co4P02oa<000?o00004@02oa801?mV0000>`04oa000_lA0003o`0000l00_l@00CoJP0003l0
0ol?00;o3`000ol0000=00;o3`03ofh0001200Co3@02o`d000?o00002`02o`d01?ma0000AP04o`/0
0_l;0003o`0000T00_l;00CoM@0004X01?l90003o`0000P000?o000020000ol0000700CoN@0004h0
1?l600;o20000ol0000600;o1P04ogd0001B00Co1002o`<01L/500;o1004oh40001F00?o0`02o`O;
0P02o`<00on50000F@04o`?;1?l2b`03o`3o00?oR00005`01L/00oo;b`03b`03o`0008X0001L00G;
00?obl/00l^=0000G005b`03ol_;00?;S@0005`01</4o`?;S@0005`01L/00oo;b`03bhd0001M00C;
0ol2bhh0001N00O;S`000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.22769, -1.25097, 0.0227193, 
  0.00870864}},
  CellTags->"Recombination - expression pair 1"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.952381 0.309017 0.588604 [
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .30902 0 0 Msboxa
P
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
1 g
.04 w
.5 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .30902 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0001f00GoN@0007L000Go0000o`1h0000M`001Ol0003o07P0
001g0005o`000?l0N00007L000Go0000o`1h0000MP05ogT0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0003d0000m0000?@0
003d0000m0000?@0003d0000m0000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-0.527398, -0.525005, 
  0.00434072, 0.00702343}},
  CellTags->"Recombination - expression pair 1"]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
  "Recombination 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination - expression pair 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .36817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .68234 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .65519 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.2619 .45617 m
.179 .30902 L
s
.2619 .45617 m
.34481 .30902 L
s
1 g
.05 w
.179 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Mshowa
P
.004 w
.34481 .30902 m
.16437 .16187 L
s
.34481 .30902 m
.52526 .16187 L
s
1 g
.05 w
.16437 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Mshowa
P
.004 w
.52526 .16187 m
.36817 .01472 L
s
.52526 .16187 m
.68234 .01472 L
s
1 g
.05 w
.36817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .36817 .01472 0 0 Mshowa
P
1 g
.68234 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .68234 .01472 0 0 Mshowa
P
.9 g
.52526 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Mshowa
P
.9 g
.34481 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Mshowa
P
.004 w
.7381 .45617 m
.65519 .30902 L
s
.7381 .45617 m
.821 .30902 L
s
1 g
.05 w
.65519 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .65519 .30902 0 0 Mshowa
P
1 g
.821 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001G00GoA@02o`80
0_m=0000F0001Ol0003o04D000Co003oCP0005P000Go0000o`1500CoCP0005P01?m60004o`00odh0
001H0005o`000?l0AP02odl0001G00GoAP03odl0001O0003o`0003d000?o0000DP00060000?o0000
>`000ol0001C0000H@000ol0000i0003o`0005@0001R0003o`0003L000?o0000E@0006<000?o0000
=@000ol0001F0000I0000ol0000c0003o`0005L0001U0003o`00034000?o0000F00006H00_l_00;o
F`0006P000?o0000:`000ol0001K0000J@000ol0000Y0003o`0005`0001Z0003o`0002L000?o0000
G@0006/000?o00009@000ol0001N0000K0000ol0000S0003o`0005l0001]0003o`00024000?o0000
H00006h000?o00007`000ol0001Q0000K`000ol0000M0003o`000680001`0003o`0001/000?o0000
H`00074000?o00006@000ol0001T0000LP000ol0000G0003o`0006D0001c00;o5@02ofP0001e0003
o`00014000?o0000J00007H000?o00003`000ol0001Y0000M`000ol0000=0003o`0006X0001h0003
o`0000/000?o0000J`0007T000?o00002@000ol0001/0000NP000ol000070003o`0006d0001k0003
o`3o00;o0//00`3o001_0000O004b`03ol_;0740000X00?oD002b`Co0l]`00009`001Ol0003o04h0
0//01Oo;bl_o00C;K`0002L000?o0000D002b`05ol_;bol01<]_00009`000ol0001@00;;00Gobl_;
o`04bfl0000W0005o`000?l0CP03b`Go0l]_0000:004odh02l]_0000;`02odT000?obl/01l]`0000
<@000ol0001400;o0P07bg40000b0003o`00048000?o00000`05bg80000c0003o`00040000?o0000
N`0003@000?o0000?P000ol0001l0000=@02ocd000?o0000O@0003L000?o0000>002oh00000h0003
o`0003H000?o0000P00003T000?o0000=0000ol000210000>P02oc<000?o0000PP0003`000?o0000
;`000ol000230000?@000ol0000/00;oQP0003h000?o0000:P000ol000260000?`02obT000?o0000
Q`00044000?o00009@000ol000280000@P000ol0000S0003o`0008T000130003o`0002000_n<0000
A0000ol0000N0003o`0008`0001500;o7@000ol0002=0000A`000ol0000I0003o`0008h000180003
o`0001L000?o0000S`0004T000?o00005002oi80001:00;o4`000ol0002B0000C0000ol0000?0003
o`0009<0001=0003o`0000d000?o0000U00004h000?o00002`000ol0002E0000C`000ol00005b`<0
0_nH0000D0000oo;b`03o`;;00<0o`00V@0005001//00oo;b`2K0000:`06oah01</4o`?;@002o`80
0_lQ00Go;P0002`000?o00008003b`05ol_;bol00l]10004o`00ob<000Go0000o`0]0000;0000ol0
000P00?;00Gobl_;o`03bd401?lS0005o`000?l0;@0002`01?lO00?;00Gobl_;o`03bd4000Co003o
8`001Ol0003o02d0000/0003o`0002001</5o`;;@P02ob@000Go0000o`0]0000:`06oal02L]200?o
8`05obh0001A00O;W000034000?o00007P05bdT000?o00007P000ol0000`0000<@000ol0000N0003
o`0004/000?o00007P000ol0000`0000<P000ol0000L0003o`0004d000?o000070000ol0000a0000
<P000ol0000L0003o`0004d000?o000070000ol0000a0000<`000ol0000J0003o`0004l000?o0000
6P000ol0000b0000<`000ol0000I0003o`00054000?o00006@000ol0000b0000=0000ol0000H0003
o`00054000?o000060000ol0000c0000=0000ol0000G0003o`0005<000?o00005`000ol0000c0000
=@000ol0000F0003o`0005<000?o00005P000ol0000d0000=P000ol0000D0003o`0005D000?o0000
50000ol0000e0000=P000ol0000C0003o`0005L000?o00004`000ol0000e0000=`000ol0000B0003
o`0005L000?o00004P000ol0000f0000=`000ol0000A0003o`0005T000?o00004@000ol0000f0000
>0000ol0000@0003o`0005T000?o000040000ol0000g0000>0000ol0000?0003o`0005/000?o0000
3`000ol0000g0000>@000ol0000>0003o`0005/000?o00003P000ol0000h0000>@000ol0000=0003
o`0005d000?o00003@000ol0000h0000>P000ol0000;0003o`0005l000?o00002`000ol0000i0000
>`000ol0000:0003o`0005l000?o00002P000ol0000j0000>`000ol000090003o`00064000?o0000
2@000ol0000j0000?0000ol000080003o`00064000?o000020000ol0000k0000?0000ol000070003
o`0006<000?o00001`000ol0000k0000?@000ol000050003o`0006D000?o00001@000ol0000l0000
?@000ol000050003o`0006D000?o00001@000ol0000l0000?P000ol000030003o`0006L000?o0000
0`000ol0000m0000?P000oo;b`03b`03o`0006L000O;oooob`3o03l0000n00O;J005b`03ol/003l0
000700;o0P02oc000//2o`03booo00;;<@03oc800l/4o`;;<005o`X000080004o`00oc000l/01?o;
bol4bbl000Go0000o`0`00?;00Gobl_;o`03bc0000Go0000o`0900002004oc000l/01?o;bol4bbl0
00?o0000<P03b`05ol_;bol00l/`0005o`000?l02@0000P000Co003o0`000ol0000Z00?;00Cobl_o
1</_0003o`0003800l/01Oo;bl_o00?;<0001Ol0003o00T0000900;o1@03obT00l/4o`C;;`001Ol0
003o03001</5o`;;:P03o`<000Go0000o`0900002003o`P00olV00?;00?obl/01L/00ol0000]00Co
<00;bbL00ol500Go2P0001H00olT0003booo00K;0P000ol0001O0003o`3;00S;9@03oaL0000I00?o
8P07b`@00_mM00;o0`07bb<00olJ00007004oal01L/70003o`0005T000?o00001005bb001?lM0000
8003obT00_l[0003o`0002T00_lY00?o8@0002<00olX00;o:@000ol0000W00;o:003ob@0000V00?o
9`000ol0000V0003o`0002H000?o00009@03obL0000Y00?o9@02obH000?o00009002obD00olZ0000
;003ob@000?o00008`000ol0000S0003o`0002800ol]0000;`04ob400_lS0003o`0002400_lQ00Co
<00003<00olP00;o8@000ol0000O00;o8003oc@0000f00?o7`000ol0000N0003o`0001h000?o0000
7@03ocL0000i00?o7@02oah000?o00007002oad00olj0000?003oa`000?o00006`000ol0000K0003
o`0001X00olm0000?`04oaT00_lK0003o`0001T00_lI00Co@00004<00olH00;o6@000ol0000G00;o
6003od@0001600?o5`000ol0000F0003o`0001H000?o00005@03odL0001900?o5@02oaH000?o0000
5002oaD00om:0000C003oa@000?o00004`000ol0000C0003o`0001800om=0000C`03oa800_lC0003
o`0001400_lB00?oD00005801?l@00;o4@000ol0000?00;o4004oe<0001F00?o3`000ol0000>0003
o`0000h000?o00003@03oeL0001I00?o3@02o`h000?o00003002o`d00omJ0000G003o``000?o0000
2`000ol0000;0003o`0000X00omM0000G`03o`X00_l;0003o`0000T00_l:00?oH00006800ol900;o
2@000ol0000700;o2@03of<0001U00Co1`000ol000060003o`0000H000?o00001@04ofH0001Y00?o
1@02o`H000?o00001002o`D00omZ0000K003o`@000Co00001L/30003o`0000800om]0000K`03o`80
0_l7b`;o0P03og00001b00?o0//4o`?;0omc0000M004b`03ol_;00C;M@0007@01</00oo;b`04bgD0
001d00C;00?obl/01<]e0000M003b`Co1<]e0000M004b`03ol_;00C;M@0007D00l/3o`?;MP0007H0
1l]g0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.833976, 0.0179408,
   0.00580576}},
  CellTags->"Recombination - expression pair 2"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .36817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .68234 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .02381 .45617 0 0 Mshowa
P
.004 w
.2619 .45617 m
.179 .30902 L
s
.2619 .45617 m
.34481 .30902 L
s
1 g
.05 w
.179 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Mshowa
P
.004 w
.34481 .30902 m
.16437 .16187 L
s
.34481 .30902 m
.52526 .16187 L
s
1 g
.05 w
.16437 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Mshowa
P
.004 w
.52526 .16187 m
.36817 .01472 L
s
.52526 .16187 m
.68234 .01472 L
s
1 g
.05 w
.36817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .36817 .01472 0 0 Mshowa
P
1 g
.68234 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .68234 .01472 0 0 Mshowa
P
.9 g
.52526 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Mshowa
P
.9 g
.34481 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Mshowa
P
.004 w
.7381 .45617 m
.65519 .30902 L
s
.7381 .45617 m
.821 .30902 L
s
1 g
.05 w
.65519 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Mshowa
P
1 g
.821 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001G00GoA@02o`80
0_m=0000F0001Ol0003o04D000Co003oCP0005P000Go0000o`1500CoCP0005P01?m60004o`00odh0
001H0005o`000?l0AP02odl0001G00GoAP03odl0001O0003o`0003d000?o0000DP00060000?o0000
>`000ol0001C0000H@000ol0000i0003o`0005@0001R0003o`0003L000?o0000E@0006<000?o0000
=@000ol0001F0000I0000ol0000c0003o`0005L0001U0003o`00034000?o0000F00006H00_l_00;o
F`0006P000?o0000:`000ol0001K0000J@000ol0000Y0003o`0005`0001Z0003o`0002L000?o0000
G@0006/000?o00009@000ol0001N0000K0000ol0000S0003o`0005l0001]0003o`00024000?o0000
H00006h000?o00007`000ol0001Q0000K`000ol0000M0003o`000680001`0003o`0001/000?o0000
H`00074000?o00006@000ol0001T0000LP000ol0000G0003o`0006D0001c00;o5@02ofP0001e0003
o`00014000?o0000J00007H000?o00003`000ol0001Y0000M`000ol0000=0003o`0006X0001h0003
o`0000/000?o0000J`0007T000?o00002@000ol0001/0000NP000ol000070003o`0006d0001k0003
o`3o00;o0//00`3o001_0000O004b`03ol_;0740000X00?oD002b`Co0l]`00009`001Ol0003o04h0
0//01Oo;bl_o00C;K`0002L000?o0000D002b`05ol_;bol01<]_00009`000ol0001@00;;00Gobl_;
o`04bfl0000W0005o`000?l0CP03b`Go0l]_0000:004odh02l]_0000;`02odT000?obl/01l]`0000
<@000ol0001400;o0P07bg40000b0003o`00048000?o00000`05bg80000c0003o`00040000?o0000
N`0003@000?o0000?P000ol0001l0000=@02ocd000?o0000O@0003L000?o0000>002oh00000h0003
o`0003H000?o0000P00003T000?o0000=0000ol000210000>P02oc<000?o0000PP0003`000?o0000
;`000ol000230000?@000ol0000/00;oQP0003h000?o0000:P000ol000260000?`02obT000?o0000
Q`00044000?o00009@000ol000280000@P000ol0000S0003o`0008T000130003o`0002000_n<0000
A0000ol0000N0003o`0008`0001500;o7@000ol0002=0000A`000ol0000I0003o`0008h000180003
o`0001L000?o0000S`0004T000?o00005002oi80001:00;o4`000ol0002B0000C0000ol0000?0003
o`0009<0001=0003o`0000d000?o0000U00004h000?o00002`000ol0002E0000C`000ol00005b`<0
0_nH0000D0000oo;b`03o`;;00<0o`00V@0005001//00oo;b`2K0000:`06oah01</4o`?;@005ob80
1Ol^0000;0000ol0000P00?;00Gobl_;o`03bd4000Go0000o`0R0005o`000?l0;@0002`000?o0000
8003b`05ol_;bol00l]10005o`000?l08P001Ol0003o02d0000/00Co7`03b`05ol_;bol00l]100Co
8`001Ol0003o02d0000/0003o`0002001</5o`;;@@001Ol0003o028000Go0000o`0]0000:`06oal0
2L]100Go8P05obh0001A00O;W000034000?o00007P05bdT000?o00007P000ol0000`0000<@000ol0
000N0003o`0004/000?o00007P000ol0000`0000<P000ol0000L0003o`0004d000?o000070000ol0
000a0000<P000ol0000L0003o`0004d000?o000070000ol0000a0000<`000ol0000J0003o`0004l0
00?o00006P000ol0000b0000<`000ol0000I0003o`00054000?o00006@000ol0000b0000=0000ol0
000H0003o`00054000?o000060000ol0000c0000=0000ol0000G0003o`0005<000?o00005`000ol0
000c0000=@000ol0000F0003o`0005<000?o00005P000ol0000d0000=P000ol0000D0003o`0005D0
00?o000050000ol0000e0000=P000ol0000C0003o`0005L000?o00004`000ol0000e0000=`000ol0
000B0003o`0005L000?o00004P000ol0000f0000=`000ol0000A0003o`0005T000?o00004@000ol0
000f0000>0000ol0000@0003o`0005T000?o000040000ol0000g0000>0000ol0000?0003o`0005/0
00?o00003`000ol0000g0000>@000ol0000>0003o`0005/000?o00003P000ol0000h0000>@000ol0
000=0003o`0005d000?o00003@000ol0000h0000>P000ol0000;0003o`0005l000?o00002`000ol0
000i0000>`000ol0000:0003o`0005l000?o00002P000ol0000j0000>`000ol000090003o`000640
00?o00002@000ol0000j0000?0000ol000080003o`00064000?o000020000ol0000k0000?0000ol0
00070003o`0006<000?o00001`000ol0000k0000?@000ol000050003o`0006D000?o00001@000ol0
000l0000?@000ol000050003o`0006D000?o00001@000ol0000l0000?P000ol000030003o`0006L0
00?o00000`000ol0000m0000?P000oo;b`03b`03o`0006L000O;oooob`3o03l0000n00O;J005b`03
ol/003l0000700Go<@02b`;o00?;ool00//a00?o<P03b`Co0//`00Go2P0000P000Go0000o`0_00?;
00Cobl_o1</_0005o`000?l0<003b`05ol_;bol00l/`0005o`000?l02@0000P000Go0000o`0_00?;
00Cobl_o1</_0003o`0003800l/01Oo;bl_o00?;<0001Ol0003o00T0000800Co0`000ol0000Z00?;
00Cobl_o1</_0003o`0003800l/01Oo;bl_o00?;<0001Ol0003o00T000080005o`000?l00`03obT0
0l/4o`C;;`001Ol0003o03001</5o`;;:P03o`<000Go0000o`0900001`05o`L00olV00?;00?obl/0
1L/00ol0000]00Co<00;bbL00ol500Go2P0001H00olT0003booo00K;0P000ol0001O0003o`3;00S;
9@03oaL0000I00?o8P07b`@00_mM00;o0`07bb<00olJ00007004oal01L/70003o`0005T000?o0000
1005bb001?lM00008003obT00_l[0003o`0002T00_lY00?o8@0002<00olX00;o:@000ol0000W00;o
:003ob@0000V00?o9`000ol0000V0003o`0002H000?o00009@03obL0000Y00?o9@02obH000?o0000
9002obD00olZ0000;003ob@000?o00008`000ol0000S0003o`0002800ol]0000;`04ob400_lS0003
o`0002400_lQ00Co<00003<00olP00;o8@000ol0000O00;o8003oc@0000f00?o7`000ol0000N0003
o`0001h000?o00007@03ocL0000i00?o7@02oah000?o00007002oad00olj0000?003oa`000?o0000
6`000ol0000K0003o`0001X00olm0000?`04oaT00_lK0003o`0001T00_lI00Co@00004<00olH00;o
6@000ol0000G00;o6003od@0001600?o5`000ol0000F0003o`0001H000?o00005@03odL0001900?o
5@02oaH000?o00005002oaD00om:0000C003oa@000?o00004`000ol0000C0003o`0001800om=0000
C`03oa800_lC0003o`0001400_lB00?oD00005801?l@00;o4@000ol0000?00;o4004oe<0001F00?o
3`000ol0000>0003o`0000h000?o00003@03oeL0001I00?o3@02o`h000?o00003002o`d00omJ0000
G003o``000?o00002`000ol0000;0003o`0000X00omM0000G`03o`X00_l;0003o`0000T00_l:00?o
H00006800ol900;o2@000ol0000700;o2@03of<0001U00Co1`000ol000060003o`0000H000?o0000
1@04ofH0001Y00?o1@02o`H000?o00001002o`D00omZ0000K003o`@000Co00001L/30003o`000080
0om]0000K`03o`800_l7b`;o0P03og00001b00?o0//4o`?;0omc0000M004b`03ol_;00C;M@0007@0
1</00oo;b`04bgD0001d00C;00?obl/01<]e0000M003b`Co1<]e0000M004b`03ol_;00C;M@0007D0
0l/3o`?;MP0007H01l]g0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.833976, 0.0179408,
   0.00580576}},
  CellTags->"Recombination - expression pair 2"]
}, Open  ]],

Cell[TextData[{
  "Recombination 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination - expression pair 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .16437 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52526 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
.004 w
.2619 .40712 m
.179 .21092 L
s
.2619 .40712 m
.34481 .21092 L
s
1 g
.05 w
.179 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .21092 0 0 Mshowa
P
.004 w
.34481 .21092 m
.16437 .01472 L
s
.34481 .21092 m
.52526 .01472 L
s
1 g
.05 w
.16437 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .16437 .01472 0 0 Mshowa
P
1 g
.52526 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52526 .01472 0 0 Mshowa
P
.9 g
.34481 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .21092 0 0 Mshowa
P
.9 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .40712 0 0 Mshowa
P
.004 w
.7381 .40712 m
.65519 .21092 L
s
.7381 .40712 m
.821 .21092 L
s
1 g
.05 w
.65519 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .21092 0 0 Mshowa
P
1 g
.821 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .21092 0 0 Mshowa
P
.9 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .40712 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0000W00GoD005og<0
000X0005o`000?l0D0001Ol0003o0780000X0005o`000?l0D0001Ol0003o0780000X00CoD@001Ol0
003o0780000X0005o`000?l0D0001Ol0003o0780000W00GoD005og<0003d0000;P000ol0001:0003
o`0007H0000_0003o`0004P000?o0000M`00030000?o0000AP000ol0001h0000<@000ol000140003
o`0007T0000b0003o`00048000?o0000NP0003<000?o0000@0000ol0001k0000=0000ol0000n0003
o`0007`0000e0003o`0003`000?o0000O@0003H000?o0000>`000ol0001m0000=`000ol0000i0003
o`0007h0000h0003o`0003L000?o0000O`0003P000?o0000=P000ol000200000>@000ol0000d0003
o`000840000j0003o`00038000?o0000PP0003/000?o0000<0000ol000230000?0000ol0000^0003
o`0008@0000m0003o`0002`000?o0000Q@0003h000?o0000:P000ol000260000?`000ol0000X0003
o`0008L000100003o`0002L000?o0000Q`00044000?o00009@000ol000280000@P000ol0000S0003
o`0008T000130003o`00024000?o0000RP0004@000?o00007`000ol0002;0000A@000ol0000M0003
o`0008`000160003o`0001/000?o0000S@0004L000?o00006@000ol0002>0000A`000ol0000H0003
o`0008l000180003o`0001H000?o0000T00004T000?o000050000ol0002A0000BP000ol0000B0003
o`000980001;0003o`00014000?o0000TP0004`000?o00003`000ol0002C0000C@000ol0000=0003
o`0009@0001>0003o`0000/000?o0000U@0004l000?o00002@000ol0002F0000D0000ol0b`04b`<0
00?o0000U`0005400//3o`;;00<0o`00V@0005001//00oo;b`2K0000:`06oah01</4o`?;@005ob80
1Ol^0000;0000ol0000P00?;00Gobl_;o`03bd4000Go0000o`0R0005o`000?l0;@0002`000?o0000
8003b`05ol_;bol00l]10005o`000?l08P001Ol0003o02d0000/00Co7`03b`05ol_;bol00l]100Co
8`001Ol0003o02d0000/0003o`0002001</5o`;;@@001Ol0003o028000Go0000o`0]0000:`06oal0
2L]100Go8P05obh0001A00O;W00005801L^M0000<0000ol0000P0003o`0004T000?o000080000ol0
000_0000<@000ol0000N0003o`0004/000?o00007P000ol0000`0000<@000ol0000N0003o`0004/0
00?o00007P000ol0000`0000<P000ol0000L0003o`0004d000?o000070000ol0000a0000<P000ol0
000L0003o`0004d000?o000070000ol0000a0000<P000ol0000K0003o`0004l000?o00006`000ol0
000a0000<`000ol0000J0003o`0004l000?o00006P000ol0000b0000<`000ol0000J0003o`0004l0
00?o00006P000ol0000b0000=0000ol0000H0003o`00054000?o000060000ol0000c0000=0000ol0
000H0003o`00054000?o000060000ol0000c0000=0000ol0000G0003o`0005<000?o00005`000ol0
000c0000=@000ol0000F0003o`0005<000?o00005P000ol0000d0000=@000ol0000E0003o`0005D0
00?o00005@000ol0000d0000=P000ol0000D0003o`0005D000?o000050000ol0000e0000=P000ol0
000D0003o`0005D000?o000050000ol0000e0000=P000ol0000C0003o`0005L000?o00004`000ol0
000e0000=`000ol0000B0003o`0005L000?o00004P000ol0000f0000=`000ol0000A0003o`0005T0
00?o00004@000ol0000f0000>0000ol0000@0003o`0005T000?o000040000ol0000g0000>0000ol0
000?0003o`0005/000?o00003`000ol0000g0000>@000ol0000>0003o`0005/000?o00003P000ol0
000h0000>@000ol0000=0003o`0005d000?o00003@000ol0000h0000>@000ol0000=0003o`0005d0
00?o00003@000ol0000h0000>P000ol0000<0003o`0005d000?o000030000ol0000i0000>P000ol0
000;0003o`0005l000?o00002`000ol0000i0000>`000ol0000:0003o`0005l000?o00002P000ol0
000j0000>`000ol000090003o`00064000?o00002@000ol0000j0000>`000ol000090003o`000640
00?o00002@000ol0000j0000?0000ol000070003o`0006<000?o00001`000ol0000k0000?0000ol0
00070003o`0006<000?o00001`000ol0000k0000?@000ol000060003o`0006<000?o00001P000ol0
000l0000?@000ol000050003o`0006D000?o00001@000ol0000l0000?@000ol000050003o`0006D0
00?o00001@000ol0000l0000?P000ol000030003o`0006L000?o00000`000ol0000m0000?P000ol0
00030003o`0006L000?o00000`000ol0000m0000?`05bfX01L/00ol0000n0000?P07bfP00//3o`;;
@00003d02L]V00K;00?obl/0?`0000L00_l200;o;`03b`;o00?;ool00l/`00?o<@04b`Co0l/_00Go
2P0000P000Co003o<003b`04ol_;o`C;;`001Ol0003o03000l/01Oo;bl_o00?;<0001Ol0003o00T0
000800Co<003b`04ol_;o`C;;`000ol0000b00?;00Gobl_;o`03bc0000Go0000o`09000020001?l0
0?l`00?;00Cobl_o1</_0003o`0003800l/01Oo;bl_o00?;<0001Ol0003o00T0000900;o1002ob/0
0l/4o`C;;`001Ol0003o03001</5o`;;;0001Ol0003o00<000?o00001`0000P00ol600;o:P02b`03
ol_;00C;<@04oc402L/[00;o0`05o`X0000C00?o:002o`G;00<0o`00I0000oo;b`05bbT00olD0000
5P02obL01L/300;oH@02o`801L/X00;o5`0001P00ol^0003o`0002d000?o0000;@000ol0000/00?o
6@0001/00_l]0003o`0002`000?o0000;0000ol0000[00;o700001d00ol[0003o`0002/000?o0000
:`000ol0000Y00?o7P0002000_lZ00;o:`000ol0000Y00;o:P02ob40000R00;o:P000ol0000X0003
o`0002P000?o0000:002ob<0000T00?o:0000ol0000W0003o`0002L000?o00009P03obD0000W00;o
9`000ol0000V0003o`0002H000?o00009@02obP0000Y00?o9@000ol0000U0003o`0002D000?o0000
8`03obX0000/00;o9002obD000?o00008`02ob@00_l]0000;P02ob@000?o00008P000ol0000R0003
o`0002800_l_0000<003ob8000?o00008@000ol0000Q0003o`0002000ola0000<`02ob4000?o0000
80000ol0000P0003o`0001l00_ld0000=@03oal00_lP0003o`0001h00_lO00?o=P0003P00_lO0003
o`0001d000?o00007@000ol0000M00;o>@0003X00_lN0003o`0001`000?o000070000ol0000L00;o
>`0003`00olL0003o`0001/000?o00006`000ol0000J00?o?@0003l00_lK0003o`0001X000?o0000
6P000ol0000I00;o@00004400olI00;o6P000ol0000H00;o6@03od80001400;o6@000ol0000G0003
o`0001L000?o00005`02odD0001600?o5`000ol0000F0003o`0001H000?o00005@03odL0001900;o
5P000ol0000E0003o`0001D000?o00005002odX0001;00;o5@000ol0000D0003o`0001@000?o0000
4`02od`0001=00?o4`02oa@000?o00004P02oa<00om>0000D002oa<000?o00004@000ol0000A0003
o`0001400_mA0000DP03oa4000?o000040000ol0000@0003o`0000l00omC0000E@02oa0000?o0000
3`000ol0000?0003o`0000h00_mF0000E`02o`l00_l?0003o`0000d00_l?00;oF00005T00ol>0003
o`0000`000?o000030000ol0000<00?oFP0005`00_l=0003o`0000/000?o00002`000ol0000;00;o
G@0005h00ol;0003o`0000X000?o00002P000ol0000900?oG`0006400_l:0003o`0000T000?o0000
2@000ol0000800;oHP0006<00_l900;o2@000ol0000700;o2@02of@0001U00?o20000ol000060003
o`0000H000?o00001P03ofH0001X00;o1`000ol000050003o`0000D000?o00001@02ofT0001Z00?o
1@000ol000040003o`0000@000?o00000`03of/0001]00;o1002o`@000?o00000P02o`@00_m^0000
K`03o`<000?o0</01</00`3o000200?oL00007800_l200O;0P02og<0001d0003ol_;00Co0l/00ol0
001c0000M004b`03ol_;00C;M@0007@01</00oo;b`04bgD0001d00C;00?obl/01<]e0000M003b`Co
1<]e0000M004b`03ol_;00C;M@0007D00l/3o`?;MP0007H01l]g0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.625483, 0.0179408,
   0.00435432}},
  CellTags->"Recombination - expression pair 3"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .17499 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16074 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .35928 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .66533 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5123 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33652 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .25575 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .4877 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .63887 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .62463 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71964 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .95159 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.4877 .60332 m
.02381 .45617 L
s
.4877 .60332 m
.25575 .45617 L
s
.4877 .60332 m
.4877 .45617 L
s
.4877 .60332 m
.71964 .45617 L
s
.4877 .60332 m
.95159 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.25575 .45617 m
.17499 .30902 L
s
.25575 .45617 m
.33652 .30902 L
s
1 g
.05 w
.17499 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .17499 .30902 0 0 Mshowa
P
.004 w
.33652 .30902 m
.16074 .16187 L
s
.33652 .30902 m
.5123 .16187 L
s
1 g
.05 w
.16074 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16074 .16187 0 0 Mshowa
P
.004 w
.5123 .16187 m
.35928 .01472 L
s
.5123 .16187 m
.66533 .01472 L
s
1 g
.05 w
.35928 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .35928 .01472 0 0 Mshowa
P
1 g
.66533 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .66533 .01472 0 0 Mshowa
P
.9 g
.5123 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5123 .16187 0 0 Mshowa
P
.9 g
.33652 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33652 .30902 0 0 Mshowa
P
.9 g
.25575 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .25575 .45617 0 0 Mshowa
P
1 g
.4877 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .4877 .45617 0 0 Mshowa
P
.004 w
.71964 .45617 m
.63887 .30902 L
s
.71964 .45617 m
.80041 .30902 L
s
1 g
.05 w
.63887 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .63887 .30902 0 0 Mshowa
P
.004 w
.80041 .30902 m
.62463 .16187 L
s
.80041 .30902 m
.97619 .16187 L
s
1 g
.05 w
.62463 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .62463 .16187 0 0 Mshowa
P
1 g
.97619 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .16187 0 0 Mshowa
P
.9 g
.80041 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .30902 0 0 Mshowa
P
.9 g
.71964 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71964 .45617 0 0 Mshowa
P
1 g
.95159 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .95159 .45617 0 0 Mshowa
P
.9 g
.4877 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001E00Go@`02o`80
0_mA0000EP001Ol0003o04<000Co003oDP0005H000Go0000o`1300CoDP0005H01?m40004o`00oe80
001F0005o`000?l0A002oe<0001E00GoA003oe<0001M0003o`0003/000?o0000EP0005h000?o0000
>@000ol0001G0000G`000ol0000g0003o`0005P0001P0003o`0003D000?o0000F@00064000?o0000
<`000ol0001J0000HP000ol0000a0003o`0005/0001S0003o`0002l000?o0000G00006@000?o0000
;@000ol0001M0000I@000ol0000[0003o`0005h0001V0003o`0002T000?o0000G`0006L000?o0000
9`000ol0001P0000J0000ol0000U0003o`000640001Y0003o`0002<000?o0000HP0006X00_lQ00;o
I@0006`000?o00007@000ol0001U0000K@000ol0000K0003o`0006H0001^0003o`0001T000?o0000
I`0006l000?o00005`000ol0001X0000L0000ol0000E0003o`0006T0001a0003o`0001<000?o0000
JP00078000?o00004@000ol0001[0000L`000ol0000?0003o`0006`0001d0003o`0000d000?o0000
K@0007D000?o00002`000ol0001^0000MP000ol000090003o`0006l0001g0003o`0000L000?o0000
L00007P000?o0?l00_l2b`030?l00780001i00C;00?obl/0M00002P00om=00;;1?l3ba801Om=00;o
0P02o`T0000W0005o`000?l0B`02b`05ol_;bol01</B0005o`000?l0C@001?l00?l:00009`000ol0
001=00;;00Gobl_;o`04ba8000Go0000o`1=00Co2P0002L000?o0000C@02b`05ol_;bol01</B00Co
CP001?l00?l:00009`001Ol0003o04/00l/5o`?;4P001Ol0003o04h00_l;0000:004od/02l/A00Go
CP03o`/0000_0003o`0004D000?obl/01l/J0003o`0004D000?o00003P00030000?o0000@`000ol0
0007ba`000?o0000@`000ol0000?0000<@02od400_l400G;7P02od400_lB0000<`000ol0000m0003
o`0002T000?o0000?@000ol0000B0000=0000ol0000k0003o`0002/000?o0000>`000ol0000C0000
=@000ol0000i0003o`0002d000?o0000>@000ol0000D0000=P000ol0000g0003o`0002l000?o0000
=`000ol0000E0000=`000ol0000e0003o`00034000?o0000=@000ol0000F0000>002oc<00_le00;o
<`02oaT0000j0003o`0002l000?o0000=`000ol0000_0003o`0001T0000k0003o`0002d000?o0000
>@000ol0000]0003o`0001X0000l0003o`0002/000?o0000>`000ol0000[0003o`0001/0000m0003
o`0002T000?o0000?@000ol0000Y0003o`0001`0000n00;o9`02od400_lW00;o7`00040000?o0000
8`000ol000130003o`0002<000?o00007`00044000?o00008@000ol000150003o`00024000?o0000
8000048000?o00007`000ol000170003o`0001l000?o00008@0004<000?o00007@000ol000190003
o`0001d000?o00008P0004@000?o00006`000ol0001;0003o`0001/000?o00008`0004D00_lI00;o
C`02oaT00_lV0000A`000ol0000E0003o`00054000?o00005@000ol0000V0000B0000ol0000C0003
o`0005<000?o00004`000ol0000W0000B@000ol0000A0003o`0005D000?o00004@000ol0000X0000
BP000ol0000?0003o`0005L000?o00003`000ol0000Y0000B`000ol0000=0003o`0005T000?o0000
3@000ol0000Z0000C002o`/00_mM00;o2`02obd0001>0003o`3;00C;0`000ol0001O0003o`0000G;
0P000ol0000]0000C`02b`?o0//00`3o001R0003ol_o00;o0l/00ol0000^0000CP06b`03ol_;06@0
1L/01?o;bl/`0000:P06oad01</4o`?;@003oal00l/4o`C;;`0002/000?o00007`03b`05ol_;bol0
0l/o0005o`000?l07P02b`05ol_;bol01</_0000:`000ol0000O00?;00Gobl_;o`03bcl000?o0000
8002b`05ol_;bol01</_0000:`04oah00l/01Oo;bl_o00?;?`000ol0000P00;;00Gobl_;o`04bbl0
000[0003o`0001l01</5o`;;?`001Ol0003o01h00l/5o`?;;`0002X01_lN00W;@@04oal02L/`0000
C`07bfH01l/a0000<0000ol0000M00G;A`000ol0000M0003ol_;00?;<P00030000?o00007@000ol0
001:0003o`0001`000?o0000=@00034000?o00006`000ol0001;0003o`0001/000?o0000=P000340
00?o00006`000ol0001<0003o`0001X000?o0000=P00038000?o00006@000ol0001>0003o`0001P0
00?o0000=`00038000?o00006@000ol0001>0003o`0001P000?o0000=`0003<000?o00005`000ol0
001@0003o`0001H000?o0000>00003<000?o00005`000ol0001@0003o`0001H000?o0000>00003@0
00?o00005@000ol0001B0003o`0001@000?o0000>@0003D000?o00004`000ol0001C0003o`0001<0
00?o0000>P0003D000?o00004`000ol0001D0003o`00018000?o0000>P0003H000?o00004@000ol0
001E0003o`00014000?o0000>`0003H000?o00004@000ol0001F0003o`00010000?o0000>`0003L0
00?o00003`000ol0001G0003o`0000l000?o0000?00003L000?o00003`000ol0001H0003o`0000h0
00?o0000?00003P000?o00003@000ol0001I0003o`0000d000?o0000?@0003P000?o00003@000ol0
001J0003o`0000`000?o0000?@0003T000?o00002`000ol0001K0003o`0000/000?o0000?P0003X0
00?o00002@000ol0001M0003o`0000T000?o0000?`0003X000?o00002@000ol0001M0003o`0000T0
00?o0000?`0003/000?o00001`000ol0001O0003o`0000L000?o0000@00003/000?o00001`000ol0
001P0003o`0000H000?o0000@00003`000?o00001@000ol0001Q0003o`0000D000?o0000@@0003`0
00?o00001@000ol0001R0003o`0000@000?o0000@@0003d000?o00000`000ol0001S0003o`0000<0
00?o0000@P0003d000?obl/00l/00ol0001T00?o0//00ol000120000?@07bfD01</00oo;b`140000
1`02o`800_l_00;;0_l00l_oo`02bbl00ola00;;1?l3bbl01Ol?000020001?l00?l_00?;00Cobl_o
1</]0005o`000?l0;`02b`05ol_;bol01</_0005o`000?l03P0000P01?l_00?;00Cobl_o1</]0003
o`0003400//01Oo;bl_o00C;;`001Ol0003o00h000080004o`00o`<000?o0000:@03b`04ol_;o`C;
;@000ol0000a00;;00Gobl_;o`04bbl000Go0000o`0>00002@02o`D00olX00?;1?l4bbd000Go0000
o`0_00?;1Ol3bbT00_l40005o`000?l03P0000P00ol800?o9@03b`03ol_;00G;;P04obl02l/V00?o
1@05o`l0000F00?o8`000l_oo`06b`030?oo05d00_l00`3;b`07bb@00olL00006@03ob401l/40003
o`0005T000?o00000P07bb800olO00007003oal01L/600;oE`02o`H01L/P00?o8P0001l00olY00;o
:@000ol0000W00;o:P03obD0000R00?o:0000ol0000V0003o`0002H000?o00009`03obP0000U00?o
9P02obH000?o00009002obH01?l[0000:003obD000?o00008`000ol0000S0003o`0002<00ol_0000
:`03ob<00_lS0003o`0002400_lS00?o<P0002h01?lQ0003o`00020000?o000080000ol0000P00?o
=@0003800olO00;o80000ol0000N00;o8003ocP0000e00?o7P000ol0000M0003o`0001d000?o0000
7@03oc/0000h00?o7002oad000?o00006`02oad00oln0000>`03oa/000?o00006P000ol0000J0003
o`0001X00om10000?P03oaT00_lJ0003o`0001P00_lI00CoA00004400olH00;o60000ol0000F00;o
6003odP0001400?o5`000ol0000E0003o`0001D000?o00005@03od/0001700?o5@02oaD000?o0000
4`02oaD00om>0000BP03oa@000?o00004P000ol0000B0003o`0001800omA0000C@03oa800_lB0003
o`0001000_lB00?oE00005001?l@0003o`0000l000?o00003`000ol0000?00?oE`0005@00ol>00;o
3`000ol0000=00;o3`03oeX0001G00?o3@000ol0000<0003o`0000`000?o00003003oed0001J00?o
2`02o``000?o00002P02o`/01?mP0000G@03o`X000?o00002@000ol000090003o`0000P00omT0000
H003o`P00_l90003o`0000L00_l800?oI`0006<00ol700;o1`000ol0000500;o1`03ofX0001V00?o
1P000ol000040003o`0000@000?o00001003ofd0001Y00?o1002o`801L/200;o1003og00001/00?o
0`000oo;b`05b`04o`0000?oL`0006l00ol2b`Co0l/3ogH0001a00C;00?obl/01<]h0000L@04b`03
ol_;00C;N00007401</00oo;b`04bgP0001a00?;1?l4bgP0001a00C;00?obl/01<]h0000LP03b`?o
0l]i0000L`07bgX00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.18458, -0.833976, 0.0184166,
   0.00580576}},
  CellTags->"Recombination - expression pair 3"]
}, Open  ]],

Cell[TextData[{
  "Recombination 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination - expression pair 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .36817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .68234 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .41709 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .58291 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.2619 .45617 m
.179 .30902 L
s
.2619 .45617 m
.34481 .30902 L
s
1 g
.05 w
.179 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Mshowa
P
.004 w
.34481 .30902 m
.16437 .16187 L
s
.34481 .30902 m
.52526 .16187 L
s
1 g
.05 w
.16437 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Mshowa
P
.004 w
.52526 .16187 m
.36817 .01472 L
s
.52526 .16187 m
.68234 .01472 L
s
1 g
.05 w
.36817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .36817 .01472 0 0 Mshowa
P
1 g
.68234 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .68234 .01472 0 0 Mshowa
P
.9 g
.52526 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Mshowa
P
.9 g
.34481 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
.004 w
.5 .45617 m
.41709 .30902 L
s
.5 .45617 m
.58291 .30902 L
s
1 g
.05 w
.41709 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .41709 .30902 0 0 Mshowa
P
1 g
.58291 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .58291 .30902 0 0 Mshowa
P
.9 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5 .45617 0 0 Mshowa
P
.004 w
.7381 .45617 m
.65519 .30902 L
s
.7381 .45617 m
.821 .30902 L
s
1 g
.05 w
.65519 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Mshowa
P
1 g
.821 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001G00GoA@02o`80
0_m=0000F0001Ol0003o04D000Co003oCP0005P000Go0000o`1500CoCP0005P01?m60004o`00odh0
001H0005o`000?l0AP02odl0001G00GoAP03odl0001O0003o`0003d000?o0000DP00060000?o0000
>`000ol0001C0000H@000ol0000i0003o`0005@0001R0003o`0003L000?o0000E@0006<000?o0000
=@000ol0001F0000I0000ol0000c0003o`0005L0001U0003o`00034000?o0000F00006H00_l_00;o
F`0006P000?o0000:`000ol0001K0000J@000ol0000Y0003o`0005`0001Z0003o`0002L000?o0000
G@0006/000?o00009@000ol0001N0000K0000ol0000S0003o`0005l0001]0003o`00024000?o0000
H00006h000?o00007`000ol0001Q0000K`000ol0000M0003o`000680001`0003o`0001/000?o0000
H`00074000?o00006@000ol0001T0000LP000ol0000G0003o`0006D0001c00;o5@02ofP0001e0003
o`00014000?o0000J00007H000?o00003`000ol0001Y0000M`000ol0000=0003o`0006X0001h0003
o`0000/000?o0000J`0007T000?o00002@000ol0001/0000NP000ol000070003o`0006d0001k0003
o`3o00;o0//00`3o001_0000O004b`03ol_;0740000X00?oD002b`Co0l]`00009`001Ol0003o04h0
0//01Oo;bl_o00C;K`0002L000?o0000D002b`05ol_;bol01<]_00009`000ol0001@00;;00Gobl_;
o`04bfl0000W0005o`000?l0CP03b`Go0l]_0000:004odh02l]_0000;`02odT000?obl/01l]`0000
<@000ol0001400;o0P07bg40000b0003o`00048000?o00000`05bg80000c0003o`00040000?o0000
N`0003@000?o0000?P000ol0001l0000=@02ocd000?o0000O@0003L000?o0000>002oh00000h0003
o`0003H000?o0000P00003T000?o0000=0000ol000210000>P02oc<000?o0000PP0003`000?o0000
;`000ol000230000?@000ol0000/00;oQP0003h000?o0000:P000ol000260000?`02obT000?o0000
Q`00044000?o00009@000ol000280000@P000ol0000S0003o`0008T000130003o`0002000_n<0000
A0000ol0000N0003o`0008`0001500;o7@000ol0002=0000A`000ol0000I0003o`0008h000180003
o`0001L000?o0000S`0004T000?o00005002oi80001:00;o4`000ol0002B0000C0000ol0000?0003
o`0009<0001=0003o`0000d000?o0000U00004h000?o00002`000ol0002E0000C`000ol00005b`<0
0_nH0000D0000oo;b`03o`;;00<0o`00V@0005001//00oo;b`2K0000:`06oah01</4o`?;2P04ob80
1Ol;00Go8P05obh0000/0003o`0002000l/01Oo;bl_o00?;2P001Ol0003o020000Go0000o`0=0005
o`000?l08P001Ol0003o02d0000/0003o`0002000l/01Oo;bl_o00?;2P001Ol0003o020000Go0000
o`0=0005o`000?l08P001Ol0003o02d0000/00Co7`03b`05ol_;bol00l/:0005o`000?l080001Ol0
003o00d01?lS0005o`000?l0;@0002`000?o00008004b`Go0//:00Co8P04o`d000Go0000o`0R0005
o`000?l0;@0002/01_lO00W;2`000ol0000V0003o`0000X01OlR00Go;P0005401l/;00;o9`02ofH0
000a0003o`0001h01L/B0003o`0001d000?o000050000ol0000N0003o`000300000a0003o`0001h0
00?o000050000ol0000M0003o`0001@000?o00007P000ol0000`0000<P000ol0000L0003o`0001H0
00?o00006`000ol0000F0003o`0001`000?o0000<@00038000?o000070000ol0000F0003o`0001/0
00?o00005P000ol0000L0003o`000340000c0003o`0001X000?o000060000ol0000I0003o`0001P0
00?o00006P000ol0000b0000<`000ol0000I0003o`0001T000?o00006@000ol0000I0003o`0001T0
00?o0000<P0003@000?o000060000ol0000J0003o`0001L000?o00006P000ol0000H0003o`0003<0
000d0003o`0001L000?o00006`000ol0000G0003o`0001/000?o00005`000ol0000c0000=@000ol0
000F0003o`0001`000?o00005@000ol0000L0003o`0001H000?o0000=00003H000?o000050000ol0
000N0003o`0001<000?o00007P000ol0000D0003o`0003D0000f0003o`0001<000?o00007`000ol0
000C0003o`0001l000?o00004`000ol0000e0000=`000ol0000B0003o`00020000?o00004@000ol0
000P0003o`00018000?o0000=P0003L000?o00004@000ol0000Q0003o`00014000?o00008@000ol0
000A0003o`0003H0000h0003o`00010000?o00008P000ol0000?0003o`00028000?o000040000ol0
000g0000>0000ol0000?0003o`0002<000?o00003`000ol0000S0003o`0000l000?o0000=`0003T0
00?o00003P000ol0000T0003o`0000d000?o000090000ol0000>0003o`0003P0000i0003o`0000d0
00?o00009@000ol0000=0003o`0002D000?o00003@000ol0000h0000>P000ol0000;0003o`0002L0
00?o00002`000ol0000W0003o`0000/000?o0000>@0003/000?o00002P000ol0000X0003o`0000T0
00?o0000:0000ol0000:0003o`0003X0000k0003o`0000T000?o0000:@000ol000090003o`0002T0
00?o00002@000ol0000j0000?0000ol000080003o`0002X000?o00001`000ol0000Z0003o`0000P0
00?o0000>`0003`000?o00001`000ol0000[0003o`0000L000?o0000:`000ol000070003o`0003/0
000m0003o`0000D000?o0000;@000ol000050003o`0002d000?o00001@000ol0000l0000?@000ol0
00050003o`0002d000?o00001@000ol0000]0003o`0000D000?o0000?00003h000?o00000`000ol0
000_0003o`0000<000?o0000;`000ol000030003o`0003d0000n0003ol_;00?;00?o0000;`04o`;;
00?o0000;`001l_oooo;0?l0?`0003h01l/a00C;00?obl/0<005b`03ol/003l0000700;o0P02oc00
0//2o`03booo00;;;`02b`Co0l/^00?;1?l2bc001Ol:000020001?l00?l`00?;00Cobl_o1</]00;;
00Gobl_;o`04bb`00l/01Oo;bl_o00?;<0001Ol0003o00T0000800Co<003b`04ol_;o`C;;@02b`05
ol_;bol01<//00?;00Gobl_;o`03bc0000Go0000o`09000020001?l00?l30003o`0002X00l/01?o;
bol4bbd00//01Oo;bl_o00C;;003b`05ol_;bol00l/`0005o`000?l02@0000T00_l500?o:@03b`Co
1</]00?;1Ol3bb`01</5o`;;:P03o`<000Go0000o`0900002003o`P00olV00?;00?obl/01L/00ol0
000Z00_;;00;bbL00ol500Go2P0001H00olT0003booo00K;0P000ol0000Z00W;;0000ol0b`08bbD0
0olG00006@03ob801l/400;o:`07bb/00_l300O;8`03oaX0000L00Co7`05b`L000?o0000:@05bb/0
00?o00001005bb001?lM00008003obT00_l[0003o`0002T00_lY00?o8@0002<00olX00;o:@000ol0
000W00;o:003ob@0000V00?o9`000ol0000V0003o`0002H000?o00009@03obL0000Y00?o9@02obH0
00?o00009002obD00olZ0000;003ob@000?o00008`000ol0000S0003o`0002800ol]0000;`04ob40
0_lS0003o`0002400_lQ00Co<00003<00olP00;o8@000ol0000O00;o8003oc@0000f00?o7`000ol0
000N0003o`0001h000?o00007@03ocL0000i00?o7@02oah000?o00007002oad00olj0000?003oa`0
00?o00006`000ol0000K0003o`0001X00olm0000?`04oaT00_lK0003o`0001T00_lI00Co@00004<0
0olH00;o6@000ol0000G00;o6003od@0001600?o5`000ol0000F0003o`0001H000?o00005@03odL0
001900?o5@02oaH000?o00005002oaD00om:0000C003oa@000?o00004`000ol0000C0003o`000180
0om=0000C`03oa800_lC0003o`0001400_lB00?oD00005801?l@00;o4@000ol0000?00;o4004oe<0
001F00?o3`000ol0000>0003o`0000h000?o00003@03oeL0001I00?o3@02o`h000?o00003002o`d0
0omJ0000G003o``000?o00002`000ol0000;0003o`0000X00omM0000G`03o`X00_l;0003o`0000T0
0_l:00?oH00006800ol900;o2@000ol0000700;o2@03of<0001U00Co1`000ol000060003o`0000H0
00?o00001@04ofH0001Y00?o1@02o`H000?o00001002o`D00omZ0000K003o`@000Co00001L/30003
o`0000800om]0000K`03o`800_l7b`;o0P03og00001b00?o0//4o`?;0omc0000M004b`03ol_;00C;
M@0007@01</00oo;b`04bgD0001d00C;00?obl/01<]e0000M003b`Co1<]e0000M004b`03ol_;00C;
M@0007D00l/3o`?;MP0007H01l]g0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.833976, 0.0179408,
   0.00580576}},
  CellTags->"Recombination - expression pair 4"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
1 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002Y00Co>005o`X0
002Y0005o`000?l0=`001?l00?l;0000Z@001Ol0003o03L01?l;0000Z@001Ol0003o03X000?o0000
2@000:T01?lh00Co2`000:T000?o0000B0000:P00_l40003o`0004<0002_0003o`00038000?o0000
3@000;0000?o0000<0000ol0000>0000/@000ol0000^0003o`0000l0002b0003o`0002`000?o0000
40000;<000?o0000:P000ol0000A0000]0000ol0000Y0003o`000140002e0003o`0002L000?o0000
4P000;D000?o00009P000ol0000C0000]P000ol0000T0003o`0001@0002g0003o`00028000?o0000
5@000;P000?o000080000ol0000F0000^@000ol0000N0003o`0001L0002j0003o`0001`000?o0000
60000;/000?o00006`000ol0000H0000_0000ol0000I0003o`0001T0002m0003o`0001L000?o0000
6P000;h000?o00005@000ol0000K0000_`000ol0000C0003o`0001`000300003o`00014000?o0000
7@000<0000?o000040000ol0000N0000`@000ol0000>0003o`0001l000320003o`0000`000?o0000
80000<<000?o00002`000ol0000P0000a0000ol000090003o`00024000350003o`0000L000?o0000
8P000<H000?obol00_l01</00?lU0000aP05b`03ol_o02H0002100Co@003b`Co0//V0000P0000ol0
001100?;00Gobl_;o`03bbD000200003o`0004400l/01Oo;bl_o00?;9@00080000Go0000o`0o00?;
00Gobl_;o`03bbD0002100Co?`04b`Go0//U0000a00;bbD000270003o`0003/02L/V0000R0000ol0
000i0003o`3;00K;9`0008T000?o0000=`001?l00005bbP0002:0003o`0003D000?o0000;`0008/0
00?o0000<`000ol0000`0000S0000ol0000a0003o`000340002=0003o`0002l000?o0000<P0008h0
00?o0000;@000ol0000c0000S`000ol0000[0003o`0003@0002@0003o`0002T000?o0000=@000940
00?o00009`000ol0000f0000TP000ol0000U0003o`0003L0002C0003o`0002<000?o0000>00009@0
00?o00008@000ol0000i0000U@000ol0000O0003o`0003X0002F0003o`0001d000?o0000>`0009L0
00?o00006`000ol0000l0000V0000ol0000I0003o`0003d0002I0003o`0001L000?o0000?P0009X0
00?o00005@000ol0000o0000V`000ol0000C0003o`000400002L0003o`00014000?o0000@@0009d0
00?o00003`000ol000120000WP000ol0000=0003o`0004<0002O0003o`0000/000?o0000A0000:00
00?o00002@000ol000150000X@000ol00005b`8000?o0000AP000:8000?obol00_l3b`03o`0004L0
002R00G;00Cobl_;B@0008@01?lI00?;1?l4bdP000230003o`0001/00//01Oo;bl_o00C;B00008<0
1OlI00;;00Gobl_;o`04bdP000230005o`000?l06@02b`05ol_;bol01<]80000Q003oaX00l/5o`?;
B0000:802L]90000X`07bdX000280003o`0001T01L];0000R@000ol0000G0003o`0004h000290003
o`0001L000?o0000CP0008X000?o00005@000ol0001?0000RP000ol0000E0003o`0004l0002:0003
o`0001D000?o0000C`0008/000?o00004`000ol0001@0000R`000ol0000C0003o`000500002<0003
o`00014000?o0000D@0008`000?o00004@000ol0001A0000S@000ol0000?0003o`000580002=0003
o`0000l000?o0000DP0008h000?o00003@000ol0001C0000SP000ol0000=0003o`0005<0002?0003
o`0000/000?o0000E00008l000?o00002`000ol0001D0000T0000ol000090003o`0005D0002@0003
o`0000T000?o0000E@00094000?o00001`000ol0001F0000T@000ol000070003o`0005H0002B0003
o`0000D000?o0000E`00098000?o00001@000ol0001G0000TP000ol000050003o`0005L0002C0003
o`0000<000?o0000F00009<000?o00000`000ol0001H0000U005be/0002C00O;FP0000L01OlZ00?o
;004obT00//2o`03booo00;;:005ob`000070004o`00obX000Go0000o`0Z0003o`0002X00l/01?o;
bol4bbH000Go0000o`0]00001`04obX000?o0000;0000ol0000Z00?;00Cobl_o1</V0005o`000?l0
;@0000X000?o0000:0000ol0000/0005o`000?l0:003b`04ol_;o`C;9P001Ol0003o02d0000700Co
1003ob<000Go0000o`0[00Co:003b`Co1</R0003o`0000801?l]00004P02ob801?mG00?;00?obl/0
1L/P00;o20000ol0000[00005003obL000?o0000C`000ol0b`02o`K;7P03o`T00_l]00005`03obD0
00?o0000C@001?l00007ba`00olk00006P02ob@00_m;00;o1@05ba/00_ln00007003ob<000?o0000
8P000ol0000R0003o`0002800om000007`03ob4000?o00008@000ol0000Q0003o`0002000om30000
8P02ob000_lQ0003o`0001l00_lP00?oAP0002@00olO0003o`0001h000?o00007P000ol0000N00;o
B@0002L00olM0003o`0001d000?o00007@000ol0000L00?oB`0002X00_lL00;o7@000ol0000K00;o
7003odh0000/00?o6`000ol0000J0003o`0001X000?o00006P02oe40000_00?o6@000ol0000I0003
o`0001T000?o00006003oe<0000b00;o6002oaT000?o00005`02oaP00omF0000=003oaL000?o0000
5P000ol0000F0003o`0001H00_mI0000=`03oaD00_lF0003o`0001@00_lF00?oF`0003X00_lE0003
o`0001<000?o00004`000ol0000C00?oGP0003`00olC0003o`00018000?o00004P000ol0000B00;o
H@0003l00_lB00;o4P000ol0000@00;o4P03of<0001100?o4@000ol0000?0003o`0000l000?o0000
3`03ofH0001400?o3`000ol0000>0003o`0000h000?o00003P02ofT0001700;o3P02o`h000?o0000
3002o`h00om[0000B@03o`d000?o00002`000ol0000;0003o`0000/00om^0000C003o`/000?o0000
2P000ol0000:0003o`0000X00_ma0000C`02o`X00_l:0003o`0000P00_l:00?oL`0005400ol90003
o`0000L000?o00001`000ol0000700?oMP0005@00ol70003o`0000H000?o00001P000ol0000500?o
N@0005L00_l600;o1P000ol0000400;o1P02og`0001I00?o1@000ol000030003o`0000<000?o0000
0`03ogh0001L00?o0`000ol00005b`8000Co00000on10000G`02o`8000?obl/01L/00ol00002oh@0
001Q00;o0//4o`?;0_n60000HP04b`03ol_;00C;Q`0006801</00oo;b`04bhL0001R00C;00?obl/0
1<^70000HP03b`Co1<^70000HP04b`03ol_;00C;Q`0006<00l/3o`?;R00006@01l^90000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.21423, -0.833976, 0.0213757,
   0.00580576}},
  CellTags->"Recombination - expression pair 4"]
}, Open  ]],

Cell[TextData[{
  "Recombination 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination - expression pair 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 1.47151 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .34481 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .7381 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .97619 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .30902 L
s
.5 .60332 m
.2619 .30902 L
s
.5 .60332 m
.5 .30902 L
s
.5 .60332 m
.7381 .30902 L
s
.5 .60332 m
.97619 .30902 L
s
1 g
.05 w
.02381 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .30902 0 0 Mshowa
P
.004 w
.2619 .30902 m
.179 .01472 L
s
.2619 .30902 m
.34481 .01472 L
s
1 g
.05 w
.179 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .01472 0 0 Mshowa
P
1 g
.34481 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .34481 .01472 0 0 Mshowa
P
.9 g
.2619 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Mshowa
P
1 g
.5 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .30902 0 0 Mshowa
P
1 g
.7381 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .7381 .30902 0 0 Mshowa
P
1 g
.97619 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .97619 .30902 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0000/00Co8`05oi`0
000/0005o`000?l08@001Ol0003o09d0000/0005o`000?l08@001Ol0003o09d0000/0005o`000?l0
8@001Ol0003o09d0000/00Co8`04oid0000/0003o`0002L000?o0000V`0002/00_lX00;oW@000?@0
000`0003o`00020000?o0000WP00030000?o000080000ol0002N0000<0000ol0000P0003o`0009h0
000`0003o`00020000?o0000WP00034000?o00007P000ol0002O0000<@000ol0000N0003o`0009l0
000a0003o`0001h000?o0000W`00034000?o00007@000ol0002P0000<P000ol0000L0003o`000:00
000b0003o`0001`000?o0000X000038000?o000070000ol0002P0000<`000ol0000J0003o`000:40
000c0003o`0001X000?o0000X@0003<000?o00006P000ol0002Q0000<`000ol0000I0003o`000:80
000d0003o`0001P000?o0000XP0003@000?o000060000ol0002R0000=0000ol0000G0003o`000:<0
000d0003o`0001L000?o0000X`0003D000?o00005P000ol0002S0000=@000ol0000F0003o`000:<0
000e0003o`0001D000?o0000Y00003H000?o000050000ol0002T0000=P000ol0000D0003o`000:@0
000f0003o`0001<000?o0000Y@0003H000?o00004`000ol0002U0000=`000ol0000B0003o`000:D0
000g0003o`00018000?o0000Y@0003L000?o00004@000ol0002V0000>0000ol0000@0003o`000:H0
000h0003o`00010000?o0000YP0003P000?o00003`000ol0002W0000>0000ol0000?0003o`000:L0
000i0003o`0000h000?o0000Y`0003T000?o00003P000ol0002W0000>@000ol0000=0003o`000:P0
000i0003o`0000d000?o0000Z00003X000?o000030000ol0002X0000>P000ol0000;0003o`000:T0
000j0003o`0000/000?o0000Z@0003/000?o00002P000ol0002Y0000>`000ol0000:0003o`000:T0
000k0003o`0000T000?o0000ZP0003/000?o00002@000ol0002Z0000?0000ol000080003o`000:X0
000l0003o`0000L000?o0000Z`0003`000?o00001`000ol0002[0000?0000ol000070003o`000:/0
000m0003o`0000D000?o0000[00003d000?o00001@000ol0002/0000?@000ol000050003o`000:`0
000n0003o`0000@000?o0000[00003h000?o00000`000ol0002]0000?P000ol000030003o`000:d0
000n0003o`0000<000?o0000[@0003l000Go0000o`2`0000?`001Ol0003o0;00000o0005o`000?l0
/00003l01L^`0000?P001<_oool3bjl0000m00G;00Cobl_;[P0000L01Ol`00?;1?l4bc001?lc00Go
<`05o`T000070004o`00oc400//01Oo;bl_o00C;;`000ol0000f0005o`000?l0<@001Ol0003o00X0
000700Co<@02b`05ol_;bol01</_0003o`0003H000Go0000o`0a0005o`000?l02P0000X000?o0000
;`02b`05ol_;bol01</_0005o`000?l0=0001Ol0003o034000Go0000o`0:00001`04oc400l/5o`?;
<004oc@000Go0000o`0b00Co2P0000l00_l/00W;J005obl00_l50003o`0000P0000A0003o`0002X0
1l^L0003o`0000@00_l:00004P02ob/01L/00`3o001V0003o`0002l00_lC000050000ol0000^0003
o`00034000?o0000<@000ol0000^0003o`0001<0000E00;o;`000ol0000`0003o`00030000?o0000
;@02oaH0000G00;o;P000ol0000_0003o`0002l000?o0000;002oaP0000I0003o`0002`000?o0000
;P000ol0000^0003o`0002`000?o0000600001X00_l]0003o`0002d000?o0000;@000ol0000[00;o
6`0001`00_l/0003o`0002`000?o0000;0000ol0000Z00;o7@0001h000?o0000:@000ol0000/0003
o`0002`000?o0000:@000ol0000M00007`02obX000?o0000:`000ol0000[0003o`0002P00_lP0000
8@000ol0000X0003o`0002X000?o0000:P000ol0000X0003o`000200000R00;o:@000ol0000Y0003
o`0002T000?o00009`02ob<0000T00;o:0000ol0000X0003o`0002P000?o00009P02obD0000V0003
o`0002D000?o0000:0000ol0000X0003o`0002D000?o00009@0002L00_lV0003o`0002L000?o0000
9`000ol0000T00;o:00002T000?o000090000ol0000V0003o`0002H000?o000090000ol0000X0000
:P02obD000?o00009@000ol0000U0003o`0002<00_l[0000;002ob@000?o000090000ol0000T0003
o`0002800_l]0000;P000ol0000Q0003o`0002@000?o000090000ol0000Q0003o`0002d0000_00;o
8P000ol0000S0003o`0002<000?o00008002oc00000a0003o`00020000?o00008P000ol0000R0003
o`00020000?o0000<00003800_lQ0003o`00024000?o00008@000ol0000O00;o<`0003@00_lP0003
o`00020000?o000080000ol0000N00;o=@0003H000?o00007P000ol0000O0003o`0001l000?o0000
7P000ol0000e0000=`02oah000?o00007`000ol0000O0003o`0001`00_lh0000>@000ol0000L0003
o`0001h000?o00007P000ol0000L0003o`0003P0000j00;o7@000ol0000M0003o`0001d000?o0000
6`02oc/0000l00;o70000ol0000L0003o`0001`000?o00006P02ocd0000n0003o`0001X000?o0000
6`000ol0000K0003o`0001X000?o0000?@0003l00_lJ0003o`0001/000?o00006`000ol0000H00;o
@00004400_lI0003o`0001X000?o00006P000ol0000G00;o@P0004<000?o00005`000ol0000I0003
o`0001T000?o00005`000ol000120000A002oaP000?o000060000ol0000H0003o`0001H00_m50000
AP000ol0000F0003o`0001L000?o00005`000ol0000F0003o`0004D0001700;o5P000ol0000G0003
o`0001L000?o00005002odP0001900;o5@000ol0000F0003o`0001H000?o00004`02odX0001;0003
o`0001<000?o00005@000ol0000E0003o`0001<000?o0000BP0004`00_lD0003o`0001@000?o0000
50000ol0000B00;oC@0004h000?o00004P000ol0000C0003o`0001<000?o00004P000ol0001=0000
C`02oa8000?o00004`000ol0000C0003o`0001000_m@0000D@02oa4000?o00004P000ol0000B0003
o`0000l00_mB0000D`000ol0000?0003o`00014000?o00004@000ol0000?0003o`000580001D00;o
40000ol0000@0003o`00010000?o00003P02oeD0001F0003o`0000h000?o00003`000ol0000?0003
o`0000h000?o0000E@0005L00_l?0003o`0000h000?o00003P000ol0000=00;oF00005T00_l=0003
o`0000h000?o00003P000ol0000;00;oFP0005/000?o00002`000ol0000=0003o`0000d000?o0000
2`000ol0001J0000G002o``000?o000030000ol0000<0003o`0000X00_mM0000GP000ol0000:0003
o`0000/000?o00002`000ol0000:0003o`0005d0001O00;o2`000ol0000:0003o`0000X000?o0000
2@02of00001Q00;o2@000ol0000:0003o`0000X000?o00001`02of80001S0003o`0000L000?o0000
2@000ol000090003o`0000L000?o0000HP0006@00_l80003o`0000P000?o000020000ol0000600;o
I@0006H00_l70003o`0000L000?o00001`000ol0000500;oI`0006P000?o00001@000ol000060003
o`0000H000?o00001@000ol0001W0000J@02o`D000?o00001P000ol000060003o`0000<00_mZ0000
J`000ol000030003o`0000D000?o00001@000ol000030003o`0006X0001/00;o10000ol000040003
o`0000@000?o00000P02ofd0001^00;o0`000ol000030003o`0000<000Co00000_m_0000L0001Ol0
003o00@000?o00000P001Ol0003o0740001a00;o0P001Ol0003o00<000?o00000_mb0000L`001?l0
o`05b`040?l0og@0001d00;o1l/2ogD0001e00;;1?l3bgH0001d00C;00?obl/01<]e0000M004b`03
ol_;00C;M@0007@01</00oo;b`04bgD0001d00?;1?l4bgD0001d00C;00?obl/01<]e0000M@03b`?o
0l]f0000MP07bgL00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.416988, 0.0179408,
   0.00290288}},
  CellTags->"Recombination - expression pair 5"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.380494 0.178342 0.603319 0.588604 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .14005 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .1291 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .28175 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .51707 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .39941 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .26425 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .20215 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .38049 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .49673 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48578 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .63844 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .77133 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .87376 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7561 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62094 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .55884 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .73718 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .38049 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.38049 .60332 m
.02381 .4856 L
s
.38049 .60332 m
.20215 .4856 L
s
.38049 .60332 m
.38049 .4856 L
s
.38049 .60332 m
.55884 .4856 L
s
.38049 .60332 m
.73718 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .4856 0 0 Mshowa
P
.004 w
.20215 .4856 m
.14005 .36788 L
s
.20215 .4856 m
.26425 .36788 L
s
1 g
.05 w
.14005 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .14005 .36788 0 0 Mshowa
P
.004 w
.26425 .36788 m
.1291 .25016 L
s
.26425 .36788 m
.39941 .25016 L
s
1 g
.05 w
.1291 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .1291 .25016 0 0 Mshowa
P
.004 w
.39941 .25016 m
.28175 .13244 L
s
.39941 .25016 m
.51707 .13244 L
s
1 g
.05 w
.28175 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .28175 .13244 0 0 Mshowa
P
1 g
.51707 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .51707 .13244 0 0 Mshowa
P
.9 g
.39941 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .39941 .25016 0 0 Mshowa
P
.9 g
.26425 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .26425 .36788 0 0 Mshowa
P
.9 g
.20215 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .20215 .4856 0 0 Mshowa
P
1 g
.38049 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .38049 .4856 0 0 Mshowa
P
.004 w
.55884 .4856 m
.49673 .36788 L
s
.55884 .4856 m
.62094 .36788 L
s
1 g
.05 w
.49673 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .49673 .36788 0 0 Mshowa
P
.004 w
.62094 .36788 m
.48578 .25016 L
s
.62094 .36788 m
.7561 .25016 L
s
1 g
.05 w
.48578 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48578 .25016 0 0 Mshowa
P
.004 w
.7561 .25016 m
.63844 .13244 L
s
.7561 .25016 m
.87376 .13244 L
s
1 g
.05 w
.63844 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .63844 .13244 0 0 Mshowa
P
.004 w
.87376 .13244 m
.77133 .01472 L
s
.87376 .13244 m
.97619 .01472 L
s
1 g
.05 w
.77133 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .77133 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Mshowa
P
.9 g
.87376 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .87376 .13244 0 0 Mshowa
P
.9 g
.7561 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7561 .25016 0 0 Mshowa
P
.9 g
.62094 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62094 .36788 0 0 Mshowa
P
.9 g
.55884 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .55884 .4856 0 0 Mshowa
P
1 g
.73718 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .73718 .4856 0 0 Mshowa
P
.9 g
.38049 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .38049 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002g00Co:P05o`X0
002g0005o`000?l0:@001?l00?l;0000]`001Ol0003o02T01?l;0000]`001Ol0003o02`000?o0000
2@000;L01?lZ00Co2`000;L000?o0000>P000;H00_l40003o`0003D0002m0003o`0002@000?o0000
3@000;h000?o00008P000ol0000>0000_`000ol0000P0003o`0000l000300003o`0001l000?o0000
3`000<4000?o00007@000ol0000@0000`@000ol0000L0003o`00014000320003o`0001X000?o0000
4P000<<000?o000060000ol0000C0000a0000ol0000F0003o`0001@000350003o`0001@000?o0000
5@000<H000?o00004`000ol0000E0000a`000ol0000A0003o`0001H000380003o`0000l000?o0000
5`000<T000?o00003@000ol0000H0000b@000ol0000<0003o`0001T0003:0003o`0000X000?o0000
6P000</000?o00002@000ol0000J0000c0000ol000070003o`0001/0003=0003ol_o00;o00C;003o
7P000<d01L/00oo;o`0O0000@`05oc800_l200;o5`04oc400l/4o`;;7`0004@000Go0000o`0b0004
o`00oaL000?o0000<P03b`05ol_;bol00l/N0000A0001Ol0003o03801?lG0003o`0003800l/01Oo;
bl_o00?;7P0004@01?lc0004o`00oaL000Go0000o`0`00?;00Gobl_;o`03bah000140005o`000?l0
<`02oaT01?l`00C;1Ol2bah0001300Go<`03odd02l/N0000c009bal0001:0003o`0002/000?o0000
8`000ol0000[0003ol_;00G;800004/000?o0000:@000ol0000U0003o`0002T000?o00001L/Q0000
C0000ol0000W0003o`0002L000?o00009`000ol0000W0000C@000ol0000U0003o`0002T000?o0000
9@000ol0000X0000CP000ol0000S0003o`0002/000?o00008`000ol0000Y0000C`000ol0000Q0003
o`0002d000?o00008@000ol0000Z0000D0000ol0000O0003o`0002l000?o00007`000ol0000[0000
D@000ol0000M0003o`00034000?o00007@000ol0000/0000DP000ol0000K0003o`0003<000?o0000
6`000ol0000]0000D`000ol0000I0003o`0003D000?o00006@000ol0000^0000E0000ol0000G0003
o`0003L000?o00005`000ol0000_0000E@000ol0000E0003o`0003T000?o00005@000ol0000`0000
EP000ol0000C0003o`0003/000?o00004`000ol0000a0000E`000ol0000A0003o`0003d000?o0000
4@000ol0000b0000F0000ol0000?0003o`0003l000?o00003`000ol0000c0000F@000ol0000=0003
o`00044000?o00003@000ol0000d0000FP000ol0000;0003o`0004<000?o00002`000ol0000e0000
F`000ol000090003o`0004D000?o00002@000ol0000f0000G0000ol00005b`8000?o0000A`000ol0
0005b`8000?o0000=`0005d000?obol00_l3b`03o`0004T000?obol00_l3b`03o`0003P0001M00G;
00Cobl_;B`05b`04ol_;bcX0000P00?o>@03b`Co1</=00Co>003b`Co1</i00007`001Ol0003o03P0
0//01Oo;bl_o00C;30000ol0000j00;;00Gobl_;o`04bcT0000O0003o`0003X00//01Oo;bl_o00C;
3005ocP00//01Oo;bl_o00C;>@0001l000?o0000>P02b`05ol_;bol01</<0005o`000?l0>002b`05
ol_;bol01</i00007`001Ol0003o03P00l/5o`?;3@03ocT00l/5o`?;>@0002001?li00W;50000ol0
000d00W;>P0002L000?o0000<P000ol0b`06baH000?o0000<P000ol0b`06bc/0000X0003o`000300
00Co00001L/H0003o`00030000Co00001L/l0000:@000ol0000^0003o`00020000?o0000;P000ol0
00130000:P02obd000?o00008P000ol0000[00;oAP0002`000?o0000:@000ol0000T0003o`0002T0
00?o0000AP0002d000?o00009P02obP00_lX0003o`0004L0000^0003o`0002@000?o0000:P000ol0
000T0003o`0004P0000_0003o`00028000?o0000;0000ol0000R0003o`0004T0000`0003o`000200
00?o0000;P000ol0000P0003o`0004X0000a0003o`0001h000?o0000<0000ol0000N0003o`0004/0
000b00;o7@000ol0000b0003o`0001/00_m>0000=0000ol0000I0003o`0003@000?o00006@000ol0
001>0000=@000ol0000G0003o`0003H000?o00005`000ol0001?0000=P000ol0000E0003o`0003P0
00?o00005@000ol0001@0000=`000ol0000C0003o`0003X000?o00004`000ol0001A0000>0000ol0
000@00;o?P02oa8000?o0000DP0003T000?o00003P000ol000100003o`0000h000?o0000D`0003X0
0_l=0003o`00048000?o00002`02oeH0000l0003o`0000T000?o0000A0000ol000090003o`0005H0
000m0003o`3;00C;0`000ol000160003o`0000G;0P000ol0001G0000?P02b`?o0//00`3o00190003
ol_;00G;00?o0000F00003d01//00oo;b`1;00W;FP0002801_lD00C;1?l3bbh01OlF00?;0_l00l_o
o`03beT0000S0003o`0001H00l/01Oo;bl_o00?;;`001Ol0003o01D00l/01?o;bol4beT0000S0003
o`0001H00l/01Oo;bl_o00?;;`001Ol0003o01D00l/01?o;bol4beT0000S00Co5@03b`05ol_;bol0
0l/_00Co5P03b`04ol_;o`C;F@0002<000?o00005P04b`Go0//_0005o`000?l05@03b`Co1<]I0000
8P06oaD02L/_00Go5`02b`03ol_;00C;FP0003h01l]=00;o1L]K00009`000ol0000E00G;=`000ol0
000E00G;G00002P000?o000050000ol0000i0003o`0001@000?o0000G`0002P000?o00004`000ol0
000k0003o`0001<000?o0000G`0002T000?o00004P000ol0000k0003o`00018000?o0000H00002T0
00?o00004@000ol0000m0003o`00014000?o0000H00002X000?o000040000ol0000m0003o`000100
00?o0000H@0002X000?o00003`000ol0000o0003o`0000l000?o0000H@0002/000?o00003P000ol0
000o0003o`0000h000?o0000HP0002/000?o00003@000ol000110003o`0000d000?o0000HP0002`0
00?o00002`000ol000130003o`0000/000?o0000H`0002d000?o00002P000ol000130003o`0000X0
00?o0000I00002d000?o00002@000ol000150003o`0000T000?o0000I00002h000?o000020000ol0
00150003o`0000P000?o0000I@0002h000?o00001`000ol000170003o`0000L000?o0000I@0002l0
00?o00001P000ol000170003o`0000H000?o0000IP0002l000?o00001@000ol000190003o`0000D0
00?o0000IP00030000?o000010000ol000190003o`0000@000?o0000I`00030000?obl/00l/00ol0
001;00G;00<0o`00J00003001l]<00;;0ol2bfX0000_00W;BP06b`03ol_;06T0000700;o0P02ob40
0l/2o`03booo00?;8P03ob<01</4o`?;8P05od4000080004o`00ob800l/01?o;bol4bb4000Go0000
o`0R00?;00Gobl_;o`03bb<000Go0000o`1000002004ob800l/01?o;bol4bb4000?o00009003b`05
ol_;bol00l/S0005o`000?l0@00000P000Co003o8P03b`04ol_;o`C;8@000ol0000T00?;00Gobl_;
o`03bb<000Go0000o`1000002@02o`@00olL00?;1?l4bb4000Go0000o`0R00C;1Ol2bah000?o0000
0P001Ol0003o0400000800?o1`03oaX00//00oo;b`04b`03o`0002001?lS00W;7003o`@01Om10000
5@03oaP00_l5b`800_m500;o00<0bl/01L/J00?oC@0001P00olF00G;1@000ol000110003o`000080
1L/H00?oD00001/00olN00;o7`000ol0000M00;o7`03oe<0000N00?o7@000ol0000L0003o`0001`0
00?o00007003oeH0000Q00?o6`02oa`000?o00006P02oa`00omI00009003oaX000?o00006@000ol0
000I0003o`0001T00omL00009`03oaP00_lI0003o`0001L00_lI00?oG`0002X00olG0003o`0001H0
00?o00005P000ol0000F00?oHP0002d00olE00;o5P000ol0000D00;o5P03ofD0000`00?o50000ol0
000C0003o`0001<000?o00004`03ofP0000c00?o4P02oa<000?o00004@02oa<00om[0000=P03oa40
00?o000040000ol0000@0003o`0001000om^0000>@03o`l00_l@0003o`0000h00_l@00?oL@0003`0
0ol>0003o`0000d000?o00003@000ol0000=00?oM00003l00ol<00;o3@000ol0000;00;o3@03ogL0
001200?o2`000ol0000:0003o`0000X000?o00002P03ogX0001500?o2@02o`X000?o00002002o`X0
0omm0000B003o`P000?o00001`000ol000070003o`0000L00on00000B`03o`H00_l70003o`0000D0
0_l700?oP`0004h00ol50003o`0000@000?o000010000ol0000400?oQP0005400ol300;o0P05b`80
0_l400?oR@0005@00ol20003ol_;00G;00Co00000on<0000E`02o`;;1?l3b`?oS`0005P01</00oo;
b`04bi40001H00C;00?obl/01<^A0000F004b`03ol_;00C;T@0005P00l/4o`C;T@0005P01</00oo;
b`04bi40001I00?;0ol3bi80001J00O;T`000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.24005, -1.04247, 0.0239518, 
  0.0072572}},
  CellTags->"Recombination - expression pair 5"]
}, Open  ]],

Cell[TextData[{
  "Recombination 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Recombination - expression pair 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Template controlled recombination", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of selectively recombined chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
recChromos = Join @@ Table[
  Recombination[theChromos, Templates -> {{{_g}, 1}},
    SelectionMode -> RANDOM], {5}];

recChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[A, h[E, g[C, g[b, a]]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[B, A]]], d]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]]
chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[b, a]], d]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[c, g[b, a]]]], d]]]
chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]]
chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]]\
\>", 
"\<\
chromo[q[undef], p[f[A, h[E, g[C, g[b, a]]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[B, A]]], d]]]
chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]]
chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[b, a]], d]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[c, g[b, a]]]], d]]]
chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]]
chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]]
chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]]\
\>"], "Output",\

  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["recChromos", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, h[E, g[C, g[b, a]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[B, A]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[b, a]], d]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[c, g[b, a]]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, h[E, g[C, g[b, a]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[B, A]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[C, g[B, A]]], C, g[C, g[B, A]], D]]], 
 
  chromo[q[undef], p[f[A, h[E, g[B, D]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[b, a]], d]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[c, g[c, g[b, a]]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]], 
 
  chromo[q[undef], p[f[A, h[E, g[c, g[b, a]]], C, g[B, D], D]]], 
 
  chromo[q[undef], p[f[a, g[b, d], c, h[e, g[C, g[B, A]]], d]]]]\
\>"], 
  "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ recChromos;", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .36817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .68234 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.2619 .45617 m
.179 .30902 L
s
.2619 .45617 m
.34481 .30902 L
s
1 g
.05 w
.179 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Mshowa
P
.004 w
.34481 .30902 m
.16437 .16187 L
s
.34481 .30902 m
.52526 .16187 L
s
1 g
.05 w
.16437 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16437 .16187 0 0 Mshowa
P
.004 w
.52526 .16187 m
.36817 .01472 L
s
.52526 .16187 m
.68234 .01472 L
s
1 g
.05 w
.36817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .36817 .01472 0 0 Mshowa
P
1 g
.68234 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .68234 .01472 0 0 Mshowa
P
.9 g
.52526 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Mshowa
P
.9 g
.34481 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Mshowa
P
.004 w
.7381 .45617 m
.65519 .30902 L
s
.7381 .45617 m
.821 .30902 L
s
1 g
.05 w
.65519 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Mshowa
P
1 g
.821 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001H00CoA@05odh0
001H0005o`000?l0A0001?l00?m?0000F0001Ol0003o04@01?m?0000F0001Ol0003o04L000?o0000
C@0005P01?m500CoC`0005P000?o0000V@0005L00_l60003o`0003d000?o0000DP00060000?o0000
>`000ol0001C0000H@000ol0000i0003o`0005@0001R0003o`0003L000?o0000E@0006<000?o0000
=@000ol0001F0000I0000ol0000c0003o`0005L0001U0003o`00034000?o0000F00006H00_l_00;o
F`0006P000?o0000:`000ol0001K0000J@000ol0000Y0003o`0005`0001Z0003o`0002L000?o0000
G@0006/000?o00009@000ol0001N0000K0000ol0000S0003o`0005l0001]0003o`00024000?o0000
H00006h000?o00007`000ol0001Q0000K`000ol0000M0003o`000680001`0003o`0001/000?o0000
H`00074000?o00006@000ol0001T0000LP000ol0000G0003o`0006D0001c00;o5@02ofP0001e0003
o`00014000?o0000J00007H000?o00003`000ol0001Y0000M`000ol0000=0003o`0006X0001h0003
o`0000/000?o0000J`0007T000?o00002@000ol0001/0000NP000ol000070003o`0006d0001k0003
o`3o00;o0//00`3o001_0000O004b`03ol_;0740000X00?oD002b`Co0l]`00009`001Ol0003o04h0
0//01Oo;bl_o00C;K`0002L000?o0000D002b`05ol_;bol01<]_00009`000ol0001@00;;00Gobl_;
o`04bfl0000W0005o`000?l0CP03b`Go0l]_0000:004odh02l]_0000;`02odT000?obl/01l]`0000
<@000ol0001400;o0P07bg40000b0003o`00048000?o00000`05bg80000c0003o`00040000?o0000
N`0003@000?o0000?P000ol0001l0000=@02ocd000?o0000O@0003L000?o0000>002oh00000h0003
o`0003H000?o0000P00003T000?o0000=0000ol000210000>P02oc<000?o0000PP0003`000?o0000
;`000ol000230000?@000ol0000/00;oQP0003h000?o0000:P000ol000260000?`02obT000?o0000
Q`00044000?o00009@000ol000280000@P000ol0000S0003o`0008T000130003o`0002000_n<0000
A0000ol0000N0003o`0008`0001500;o7@000ol0002=0000A`000ol0000I0003o`0008h000180003
o`0001L000?o0000S`0004T000?o00005002oi80001:00;o4`000ol0002B0000C0000ol0000?0003
o`0009<0001=0003o`0000d000?o0000U00004h000?o00002`000ol0002E0000C`000ol00005b`<0
0_nH0000D0000oo;b`03o`;;00<0o`00V@0005001//00oo;b`2K0000:`06oah01</4o`?;@005ob80
1Ol^0000;0000ol0000P00?;00Gobl_;o`03bd4000Go0000o`0R0005o`000?l0;@0002`000?o0000
8003b`05ol_;bol00l]10005o`000?l08P001Ol0003o02d0000/00Co7`03b`05ol_;bol00l]100Co
8`001Ol0003o02d0000/0003o`0002001</5o`;;@@001Ol0003o028000Go0000o`0]0000:`06oal0
2L]100Go8P05obh0001A00O;W000034000?o00007P05bdT000?o00007P000ol0000`0000<@000ol0
000N0003o`0004/000?o00007P000ol0000`0000<P000ol0000L0003o`0004d000?o000070000ol0
000a0000<P000ol0000L0003o`0004d000?o000070000ol0000a0000<`000ol0000J0003o`0004l0
00?o00006P000ol0000b0000<`000ol0000I0003o`00054000?o00006@000ol0000b0000=0000ol0
000H0003o`00054000?o000060000ol0000c0000=0000ol0000G0003o`0005<000?o00005`000ol0
000c0000=@000ol0000F0003o`0005<000?o00005P000ol0000d0000=P000ol0000D0003o`0005D0
00?o000050000ol0000e0000=P000ol0000C0003o`0005L000?o00004`000ol0000e0000=`000ol0
000B0003o`0005L000?o00004P000ol0000f0000=`000ol0000A0003o`0005T000?o00004@000ol0
000f0000>0000ol0000@0003o`0005T000?o000040000ol0000g0000>0000ol0000?0003o`0005/0
00?o00003`000ol0000g0000>@000ol0000>0003o`0005/000?o00003P000ol0000h0000>@000ol0
000=0003o`0005d000?o00003@000ol0000h0000>P000ol0000;0003o`0005l000?o00002`000ol0
000i0000>`000ol0000:0003o`0005l000?o00002P000ol0000j0000>`000ol000090003o`000640
00?o00002@000ol0000j0000?0000ol000080003o`00064000?o000020000ol0000k0000?0000ol0
00070003o`0006<000?o00001`000ol0000k0000?@000ol000050003o`0006D000?o00001@000ol0
000l0000?@000ol000050003o`0006D000?o00001@000ol0000l0000?P000ol000030003o`0006L0
00?o00000`000ol0000m0000?P000oo;b`03b`03o`0006L000O;oooob`3o03l0000n00O;J005b`03
ol/003l0000700;o0P02oc000//2o`03booo00;;<@03oc800l/4o`;;<005o`X000080004o`00oc00
0l/01?o;bol4bbl000Go0000o`0`00?;00Gobl_;o`03bc0000Go0000o`0900002004oc000l/01?o;
bol4bbl000?o0000<P03b`05ol_;bol00l/`0005o`000?l02@0000P000Co003o0`000ol0000Z00?;
00Cobl_o1</_0003o`0003800l/01Oo;bl_o00?;<0001Ol0003o00T0000900;o1@03obT00l/4o`C;
;`001Ol0003o03001</5o`;;:P03o`<000Go0000o`0900002003o`P00olV00?;00?obl/01L/00ol0
000]00Co<00;bbL00ol500Go2P0001H00olT0003booo00K;0P000ol0001O0003o`3;00S;9@03oaL0
000I00?o8P07b`@00_mM00;o0`07bb<00olJ00007004oal01L/70003o`0005T000?o00001005bb00
1?lM00008003obT00_l[0003o`0002T00_lY00?o8@0002<00olX00;o:@000ol0000W00;o:003ob@0
000V00?o9`000ol0000V0003o`0002H000?o00009@03obL0000Y00?o9@02obH000?o00009002obD0
0olZ0000;003ob@000?o00008`000ol0000S0003o`0002800ol]0000;`04ob400_lS0003o`000240
0_lQ00Co<00003<00olP00;o8@000ol0000O00;o8003oc@0000f00?o7`000ol0000N0003o`0001h0
00?o00007@03ocL0000i00?o7@02oah000?o00007002oad00olj0000?003oa`000?o00006`000ol0
000K0003o`0001X00olm0000?`04oaT00_lK0003o`0001T00_lI00Co@00004<00olH00;o6@000ol0
000G00;o6003od@0001600?o5`000ol0000F0003o`0001H000?o00005@03odL0001900?o5@02oaH0
00?o00005002oaD00om:0000C003oa@000?o00004`000ol0000C0003o`0001800om=0000C`03oa80
0_lC0003o`0001400_lB00?oD00005801?l@00;o4@000ol0000?00;o4004oe<0001F00?o3`000ol0
000>0003o`0000h000?o00003@03oeL0001I00?o3@02o`h000?o00003002o`d00omJ0000G003o``0
00?o00002`000ol0000;0003o`0000X00omM0000G`03o`X00_l;0003o`0000T00_l:00?oH0000680
0ol900;o2@000ol0000700;o2@03of<0001U00Co1`000ol000060003o`0000H000?o00001@04ofH0
001Y00?o1@02o`H000?o00001002o`D00omZ0000K003o`@000Co00001L/30003o`0000800om]0000
K`03o`800_l7b`;o0P03og00001b00?o0//4o`?;0omc0000M004b`03ol_;00C;M@0007@01</00oo;
b`04bgD0001d00C;00?obl/01<]e0000M003b`Co1<]e0000M004b`03ol_;00C;M@0007D00l/3o`?;
MP0007H01l]g0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.833976, 0.0179408,
   0.00580576}},
  CellTags->"Recombination sel - expression pair 1"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002X00Go>002o`80
0_l90000Z@001Ol0003o03P000Co003o2P000:T000Go0000o`0h00Co2P000:T01?li0004o`00o`X0
002Y0005o`000?l0>@02o`/0002X00Go>@03o`/0002^0003o`0004<0002_0003o`00038000?o0000
3@000;0000?o0000<0000ol0000>0000/@000ol0000^0003o`0000l0002b0003o`0002`000?o0000
40000;<000?o0000:P000ol0000A0000]0000ol0000Y0003o`000140002e0003o`0002L000?o0000
4P000;D000?o00009P000ol0000C0000]P000ol0000T0003o`0001@0002g0003o`00028000?o0000
5@000;P000?o000080000ol0000F0000^@000ol0000N0003o`0001L0002j0003o`0001`000?o0000
60000;/000?o00006`000ol0000H0000_0000ol0000I0003o`0001T0002m0003o`0001L000?o0000
6P000;h000?o00005@000ol0000K0000_`000ol0000C0003o`0001`000300003o`00014000?o0000
7@000<0000?o000040000ol0000N0000`@000ol0000>0003o`0001l000320003o`0000`000?o0000
80000<<000?o00002`000ol0000P0000a0000ol000090003o`00024000350003o`0000L000?o0000
8P000<H000?obol00_l01</00?lU0000aP05b`03ol_o02H0002100Co@003b`Co0//V0000P0000ol0
001100?;00Gobl_;o`03bbD000200003o`0004400l/01Oo;bl_o00?;9@00080000Go0000o`0o00?;
00Gobl_;o`03bbD0002100Co?`04b`Go0//U0000a00;bbD000270003o`0003/02L/V0000R0000ol0
000i0003o`3;00K;9`0008T000?o0000=`001?l00005bbP0002:0003o`0003D000?o0000;`0008/0
00?o0000<`000ol0000`0000S0000ol0000a0003o`000340002=0003o`0002l000?o0000<P0008h0
00?o0000;@000ol0000c0000S`000ol0000[0003o`0003@0002@0003o`0002T000?o0000=@000940
00?o00009`000ol0000f0000TP000ol0000U0003o`0003L0002C0003o`0002<000?o0000>00009@0
00?o00008@000ol0000i0000U@000ol0000O0003o`0003X0002F0003o`0001d000?o0000>`0009L0
00?o00006`000ol0000l0000V0000ol0000I0003o`0003d0002I0003o`0001L000?o0000?P0009X0
00?o00005@000ol0000o0000V`000ol0000C0003o`000400002L0003o`00014000?o0000@@0009d0
00?o00003`000ol000120000WP000ol0000=0003o`0004<0002O0003o`0000/000?o0000A0000:00
00?o00002@000ol000150000X@000ol00005b`8000?o0000AP000:8000?obol00_l3b`03o`0004L0
002R00G;00Cobl_;B@0002H01?lM00Go>004oaT00l/4o`C;B00002H000Go0000o`0K0005o`000?l0
>0000ol0000K00;;00Gobl_;o`04bdP0000V0005o`000?l06`001Ol0003o03P01OlI00;;00Gobl_;
o`04bdP0000V0005o`000?l06`001Ol0003o03P000Go0000o`0I00;;00Gobl_;o`04bdP0000V00Co
7@04ocT00olJ00?;1Ol3bdP0000V0003o`00024000?o0000E@09bdT0000U00;o8P02oeP01l]:0000
R0000ol0000I00G;B`0002/000?o000060000ol000100003o`0001L000?o0000CP0002/000?o0000
60000ol000100003o`0001L000?o0000CP0002`000?o00005P000ol000120003o`0001D000?o0000
C`0002`000?o00005P000ol000120003o`0001D000?o0000C`0002`000?o00005@000ol000130003
o`0001D000?o0000C`0002d000?o000050000ol000140003o`0001<000?o0000D00002d000?o0000
4`000ol000150003o`0001<000?o0000D00002h000?o00004P000ol000160003o`00014000?o0000
D@0002h000?o00004@000ol000170003o`00014000?o0000D@0002l000?o000040000ol000180003
o`0000l000?o0000DP0002l000?o00003`000ol000190003o`0000l000?o0000DP00030000?o0000
3P000ol0001:0003o`0000d000?o0000D`00030000?o00003@000ol0001;0003o`0000d000?o0000
D`00034000?o000030000ol0001<0003o`0000/000?o0000E000034000?o00002`000ol0001=0003
o`0000/000?o0000E000038000?o00002P000ol0001>0003o`0000T000?o0000E@00038000?o0000
2@000ol0001?0003o`0000T000?o0000E@0003<000?o000020000ol0001@0003o`0000L000?o0000
EP0003<000?o00001`000ol0001A0003o`0000L000?o0000EP0003@000?o00001P000ol0001B0003
o`0000D000?o0000E`0003@000?o00001@000ol0001C0003o`0000D000?o0000E`0003@000?o0000
1@000ol0001C0003o`0000D000?o0000E`0003D000?o00000`000ol0001E0003o`0000<000?o0000
F00003D000?o00000`000ol0001E0003o`0000<000?o0000F00003H00ol2beT01L]K0000=@04b`03
ol_;05L01l]J00001`05obP00//4o`?;:004obT00//2o`03booo00;;:005ob`000070004o`00obP0
0//01Oo;bl_o00C;9P000ol0000Z00?;00Cobl_o1</V0005o`000?l0;@0000L01?lX00;;00Gobl_;
o`04bbH000?o0000:P03b`04ol_;o`C;9P001Ol0003o02d0000:0003o`0002H00//01Oo;bl_o00C;
9P001Ol0003o02P00l/01?o;bol4bbH000Go0000o`0]00001`04o`@00olQ00?;1Ol3bbL01?lX00?;
1?l4bb8000?o00000P04obd0000B00;o7`0;be<00l/00oo;b`05bb000_l80003o`0002/0000D00?o
7@09b`030?l0050000?o0</00_l6bah00ol900;o;@0001L00olK00O;0`000ol0001=0004o`0000O;
7003oc/0000J00;o6P05b`D00_m;00;o1@05ba/00_ln00007003ob<000?o00008P000ol0000R0003
o`0002800om000007`03ob4000?o00008@000ol0000Q0003o`0002000om300008P02ob000_lQ0003
o`0001l00_lP00?oAP0002@00olO0003o`0001h000?o00007P000ol0000N00;oB@0002L00olM0003
o`0001d000?o00007@000ol0000L00?oB`0002X00_lL00;o7@000ol0000K00;o7003odh0000/00?o
6`000ol0000J0003o`0001X000?o00006P02oe40000_00?o6@000ol0000I0003o`0001T000?o0000
6003oe<0000b00;o6002oaT000?o00005`02oaP00omF0000=003oaL000?o00005P000ol0000F0003
o`0001H00_mI0000=`03oaD00_lF0003o`0001@00_lF00?oF`0003X00_lE0003o`0001<000?o0000
4`000ol0000C00?oGP0003`00olC0003o`00018000?o00004P000ol0000B00;oH@0003l00_lB00;o
4P000ol0000@00;o4P03of<0001100?o4@000ol0000?0003o`0000l000?o00003`03ofH0001400?o
3`000ol0000>0003o`0000h000?o00003P02ofT0001700;o3P02o`h000?o00003002o`h00om[0000
B@03o`d000?o00002`000ol0000;0003o`0000/00om^0000C003o`/000?o00002P000ol0000:0003
o`0000X00_ma0000C`02o`X00_l:0003o`0000P00_l:00?oL`0005400ol90003o`0000L000?o0000
1`000ol0000700?oMP0005@00ol70003o`0000H000?o00001P000ol0000500?oN@0005L00_l600;o
1P000ol0000400;o1P02og`0001I00?o1@000ol000030003o`0000<000?o00000`03ogh0001L00?o
0`000ol00005b`8000Co00000on10000G`02o`8000?obl/01L/00ol00002oh@0001Q00;o0//4o`?;
0_n60000HP04b`03ol_;00C;Q`0006801</00oo;b`04bhL0001R00C;00?obl/01<^70000HP03b`Co
1<^70000HP04b`03ol_;00C;Q`0006<00l/3o`?;R00006@01l^90000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.21423, -0.833976, 0.0213757,
   0.00580576}},
  CellTags->"Recombination sel - expression pair 1"]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
  "Selective recombination 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination sel - expression pair 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .17499 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16074 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .35928 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .66533 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5123 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33652 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .25575 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .4877 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .63887 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .62463 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71964 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .95159 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.4877 .60332 m
.02381 .45617 L
s
.4877 .60332 m
.25575 .45617 L
s
.4877 .60332 m
.4877 .45617 L
s
.4877 .60332 m
.71964 .45617 L
s
.4877 .60332 m
.95159 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.25575 .45617 m
.17499 .30902 L
s
.25575 .45617 m
.33652 .30902 L
s
1 g
.05 w
.17499 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .17499 .30902 0 0 Mshowa
P
.004 w
.33652 .30902 m
.16074 .16187 L
s
.33652 .30902 m
.5123 .16187 L
s
1 g
.05 w
.16074 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .16074 .16187 0 0 Mshowa
P
.004 w
.5123 .16187 m
.35928 .01472 L
s
.5123 .16187 m
.66533 .01472 L
s
1 g
.05 w
.35928 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .35928 .01472 0 0 Mshowa
P
1 g
.66533 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .66533 .01472 0 0 Mshowa
P
.9 g
.5123 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5123 .16187 0 0 Mshowa
P
.9 g
.33652 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33652 .30902 0 0 Mshowa
P
.9 g
.25575 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .25575 .45617 0 0 Mshowa
P
1 g
.4877 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .4877 .45617 0 0 Mshowa
P
.004 w
.71964 .45617 m
.63887 .30902 L
s
.71964 .45617 m
.80041 .30902 L
s
1 g
.05 w
.63887 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .63887 .30902 0 0 Mshowa
P
.004 w
.80041 .30902 m
.62463 .16187 L
s
.80041 .30902 m
.97619 .16187 L
s
1 g
.05 w
.62463 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .62463 .16187 0 0 Mshowa
P
1 g
.97619 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .16187 0 0 Mshowa
P
.9 g
.80041 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .30902 0 0 Mshowa
P
.9 g
.71964 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71964 .45617 0 0 Mshowa
P
1 g
.95159 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .95159 .45617 0 0 Mshowa
P
.9 g
.4877 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001E00Go@`02o`80
0_mA0000EP001Ol0003o04<000Co003oDP0005H000Go0000o`1300CoDP0005H01?m40004o`00oe80
001F0005o`000?l0A002oe<0001E00GoA003oe<0001M0003o`0003/000?o0000EP0005h000?o0000
>@000ol0001G0000G`000ol0000g0003o`0005P0001P0003o`0003D000?o0000F@00064000?o0000
<`000ol0001J0000HP000ol0000a0003o`0005/0001S0003o`0002l000?o0000G00006@000?o0000
;@000ol0001M0000I@000ol0000[0003o`0005h0001V0003o`0002T000?o0000G`0006L000?o0000
9`000ol0001P0000J0000ol0000U0003o`000640001Y0003o`0002<000?o0000HP0006X00_lQ00;o
I@0006`000?o00007@000ol0001U0000K@000ol0000K0003o`0006H0001^0003o`0001T000?o0000
I`0006l000?o00005`000ol0001X0000L0000ol0000E0003o`0006T0001a0003o`0001<000?o0000
JP00078000?o00004@000ol0001[0000L`000ol0000?0003o`0006`0001d0003o`0000d000?o0000
K@0007D000?o00002`000ol0001^0000MP000ol000090003o`0006l0001g0003o`0000L000?o0000
L00007P000?o0?l00_l2b`030?l00780001i00C;00?obl/0M00002P00om=00;;1?l3ba801Om=00;o
0P02o`T0000W0005o`000?l0B`02b`05ol_;bol01</B0005o`000?l0C@001?l00?l:00009`000ol0
001=00;;00Gobl_;o`04ba8000Go0000o`1=00Co2P0002L000?o0000C@02b`05ol_;bol01</B00Co
CP001?l00?l:00009`001Ol0003o04/00l/5o`?;4P001Ol0003o04h00_l;0000:004od/02l/A00Go
CP03o`/0000_0003o`0004D000?obl/01l/J0003o`0004D000?o00003P00030000?o0000@`000ol0
0007ba`000?o0000@`000ol0000?0000<@02od400_l400G;7P02od400_lB0000<`000ol0000m0003
o`0002T000?o0000?@000ol0000B0000=0000ol0000k0003o`0002/000?o0000>`000ol0000C0000
=@000ol0000i0003o`0002d000?o0000>@000ol0000D0000=P000ol0000g0003o`0002l000?o0000
=`000ol0000E0000=`000ol0000e0003o`00034000?o0000=@000ol0000F0000>002oc<00_le00;o
<`02oaT0000j0003o`0002l000?o0000=`000ol0000_0003o`0001T0000k0003o`0002d000?o0000
>@000ol0000]0003o`0001X0000l0003o`0002/000?o0000>`000ol0000[0003o`0001/0000m0003
o`0002T000?o0000?@000ol0000Y0003o`0001`0000n00;o9`02od400_lW00;o7`00040000?o0000
8`000ol000130003o`0002<000?o00007`00044000?o00008@000ol000150003o`00024000?o0000
8000048000?o00007`000ol000170003o`0001l000?o00008@0004<000?o00007@000ol000190003
o`0001d000?o00008P0004@000?o00006`000ol0001;0003o`0001/000?o00008`0004D00_lI00;o
C`02oaT00_lV0000A`000ol0000E0003o`00054000?o00005@000ol0000V0000B0000ol0000C0003
o`0005<000?o00004`000ol0000W0000B@000ol0000A0003o`0005D000?o00004@000ol0000X0000
BP000ol0000?0003o`0005L000?o00003`000ol0000Y0000B`000ol0000=0003o`0005T000?o0000
3@000ol0000Z0000C002o`/00_mM00;o2`02obd0001>0003o`3;00C;0`000ol0001O0003o`0000G;
0P000ol0000]0000C`02b`?o0//00`3o001R0003ol_o00;o0l/00ol0000^0000CP06b`03ol_;06@0
1L/01?o;bl/`0000:P06oad01</4o`?;@003oal00l/4o`C;;`0002/000?o00007`03b`05ol_;bol0
0l/o0005o`000?l07P02b`05ol_;bol01</_0000:`000ol0000O00?;00Gobl_;o`03bcl000?o0000
8002b`05ol_;bol01</_0000:`04oah00l/01Oo;bl_o00?;?`000ol0000P00;;00Gobl_;o`04bbl0
000[0003o`0001l01</5o`;;?`001Ol0003o01h00l/5o`?;;`0002X01_lN00W;@@04oal02L/`0000
C`07bfH01l/a0000<0000ol0000M00G;A`000ol0000M0003ol_;00?;<P00030000?o00007@000ol0
001:0003o`0001`000?o0000=@00034000?o00006`000ol0001;0003o`0001/000?o0000=P000340
00?o00006`000ol0001<0003o`0001X000?o0000=P00038000?o00006@000ol0001>0003o`0001P0
00?o0000=`00038000?o00006@000ol0001>0003o`0001P000?o0000=`0003<000?o00005`000ol0
001@0003o`0001H000?o0000>00003<000?o00005`000ol0001@0003o`0001H000?o0000>00003@0
00?o00005@000ol0001B0003o`0001@000?o0000>@0003D000?o00004`000ol0001C0003o`0001<0
00?o0000>P0003D000?o00004`000ol0001D0003o`00018000?o0000>P0003H000?o00004@000ol0
001E0003o`00014000?o0000>`0003H000?o00004@000ol0001F0003o`00010000?o0000>`0003L0
00?o00003`000ol0001G0003o`0000l000?o0000?00003L000?o00003`000ol0001H0003o`0000h0
00?o0000?00003P000?o00003@000ol0001I0003o`0000d000?o0000?@0003P000?o00003@000ol0
001J0003o`0000`000?o0000?@0003T000?o00002`000ol0001K0003o`0000/000?o0000?P0003X0
00?o00002@000ol0001M0003o`0000T000?o0000?`0003X000?o00002@000ol0001M0003o`0000T0
00?o0000?`0003/000?o00001`000ol0001O0003o`0000L000?o0000@00003/000?o00001`000ol0
001P0003o`0000H000?o0000@00003`000?o00001@000ol0001Q0003o`0000D000?o0000@@0003`0
00?o00001@000ol0001R0003o`0000@000?o0000@@0003d000?o00000`000ol0001S0003o`0000<0
00?o0000@P0003d000?obl/00l/00ol0001T00?o0//00ol000120000?@07bfD01</00oo;b`140000
1`02o`800_l_00;;0_l00l_oo`02bbl00ola00;;1?l3bbl01Ol?000020001?l00?l_00?;00Cobl_o
1</]0005o`000?l0;`02b`05ol_;bol01</_0005o`000?l03P0000P01?l_00?;00Cobl_o1</]0003
o`0003400//01Oo;bl_o00C;;`001Ol0003o00h000080004o`00o`<000?o0000:@03b`04ol_;o`C;
;@000ol0000a00;;00Gobl_;o`04bbl000Go0000o`0>00002@02o`D00olX00?;1?l4bbd000Go0000
o`0_00?;1Ol3bbT00_l40005o`000?l03P0000P00ol800?o9@03b`03ol_;00G;;P04obl02l/V00?o
1@05o`l0000F00?o8`000l_oo`06b`030?oo05d00_l00`3;b`07bb@00olL00006@03ob401l/40003
o`0005T000?o00000P07bb800olO00007003oal01L/600;oE`02o`H01L/P00?o8P0001l00olY00;o
:@000ol0000W00;o:P03obD0000R00?o:0000ol0000V0003o`0002H000?o00009`03obP0000U00?o
9P02obH000?o00009002obH01?l[0000:003obD000?o00008`000ol0000S0003o`0002<00ol_0000
:`03ob<00_lS0003o`0002400_lS00?o<P0002h01?lQ0003o`00020000?o000080000ol0000P00?o
=@0003800olO00;o80000ol0000N00;o8003ocP0000e00?o7P000ol0000M0003o`0001d000?o0000
7@03oc/0000h00?o7002oad000?o00006`02oad00oln0000>`03oa/000?o00006P000ol0000J0003
o`0001X00om10000?P03oaT00_lJ0003o`0001P00_lI00CoA00004400olH00;o60000ol0000F00;o
6003odP0001400?o5`000ol0000E0003o`0001D000?o00005@03od/0001700?o5@02oaD000?o0000
4`02oaD00om>0000BP03oa@000?o00004P000ol0000B0003o`0001800omA0000C@03oa800_lB0003
o`0001000_lB00?oE00005001?l@0003o`0000l000?o00003`000ol0000?00?oE`0005@00ol>00;o
3`000ol0000=00;o3`03oeX0001G00?o3@000ol0000<0003o`0000`000?o00003003oed0001J00?o
2`02o``000?o00002P02o`/01?mP0000G@03o`X000?o00002@000ol000090003o`0000P00omT0000
H003o`P00_l90003o`0000L00_l800?oI`0006<00ol700;o1`000ol0000500;o1`03ofX0001V00?o
1P000ol000040003o`0000@000?o00001003ofd0001Y00?o1002o`801L/200;o1003og00001/00?o
0`000oo;b`05b`04o`0000?oL`0006l00ol2b`Co0l/3ogH0001a00C;00?obl/01<]h0000L@04b`03
ol_;00C;N00007401</00oo;b`04bgP0001a00?;1?l4bgP0001a00C;00?obl/01<]h0000LP03b`?o
0l]i0000L`07bgX00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.18458, -0.833976, 0.0184166,
   0.00580576}},
  CellTags->"Recombination sel - expression pair 2"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .16437 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52526 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
.004 w
.2619 .40712 m
.179 .21092 L
s
.2619 .40712 m
.34481 .21092 L
s
1 g
.05 w
.179 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .21092 0 0 Mshowa
P
.004 w
.34481 .21092 m
.16437 .01472 L
s
.34481 .21092 m
.52526 .01472 L
s
1 g
.05 w
.16437 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .16437 .01472 0 0 Mshowa
P
1 g
.52526 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52526 .01472 0 0 Mshowa
P
.9 g
.34481 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .21092 0 0 Mshowa
P
.9 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .40712 0 0 Mshowa
P
.004 w
.7381 .40712 m
.65519 .21092 L
s
.7381 .40712 m
.821 .21092 L
s
1 g
.05 w
.65519 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .21092 0 0 Mshowa
P
1 g
.821 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .21092 0 0 Mshowa
P
.9 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .40712 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0000W00GoD005og<0
000X0005o`000?l0D0001Ol0003o0780000X0005o`000?l0D0001Ol0003o0780000X00CoD@001Ol0
003o0780000X0005o`000?l0D0001Ol0003o0780000W00GoD005og<0003d0000;P000ol0001:0003
o`0007H0000_0003o`0004P000?o0000M`00030000?o0000AP000ol0001h0000<@000ol000140003
o`0007T0000b0003o`00048000?o0000NP0003<000?o0000@0000ol0001k0000=0000ol0000n0003
o`0007`0000e0003o`0003`000?o0000O@0003H000?o0000>`000ol0001m0000=`000ol0000i0003
o`0007h0000h0003o`0003L000?o0000O`0003P000?o0000=P000ol000200000>@000ol0000d0003
o`000840000j0003o`00038000?o0000PP0003/000?o0000<0000ol000230000?0000ol0000^0003
o`0008@0000m0003o`0002`000?o0000Q@0003h000?o0000:P000ol000260000?`000ol0000X0003
o`0008L000100003o`0002L000?o0000Q`00044000?o00009@000ol000280000@P000ol0000S0003
o`0008T000130003o`00024000?o0000RP0004@000?o00007`000ol0002;0000A@000ol0000M0003
o`0008`000160003o`0001/000?o0000S@0004L000?o00006@000ol0002>0000A`000ol0000H0003
o`0008l000180003o`0001H000?o0000T00004T000?o000050000ol0002A0000BP000ol0000B0003
o`000980001;0003o`00014000?o0000TP0004`000?o00003`000ol0002C0000C@000ol0000=0003
o`0009@0001>0003o`0000/000?o0000U@0004l000?o00002@000ol0002F0000D0000ol0b`04b`<0
00?o0000U`0005400//3o`;;00<0o`00V@0005001//00oo;b`2K0000:`06oah01</4o`?;@005ob80
1Ol^0000;0000ol0000P00?;00Gobl_;o`03bd4000Go0000o`0R0005o`000?l0;@0002`000?o0000
8003b`05ol_;bol00l]10005o`000?l08P001Ol0003o02d0000/00Co7`03b`05ol_;bol00l]100Co
8`001Ol0003o02d0000/0003o`0002001</5o`;;@@001Ol0003o028000Go0000o`0]0000:`06oal0
2L]100Go8P05obh0001A00O;W00005801L^M0000<0000ol0000P0003o`0004T000?o000080000ol0
000_0000<@000ol0000N0003o`0004/000?o00007P000ol0000`0000<@000ol0000N0003o`0004/0
00?o00007P000ol0000`0000<P000ol0000L0003o`0004d000?o000070000ol0000a0000<P000ol0
000L0003o`0004d000?o000070000ol0000a0000<P000ol0000K0003o`0004l000?o00006`000ol0
000a0000<`000ol0000J0003o`0004l000?o00006P000ol0000b0000<`000ol0000J0003o`0004l0
00?o00006P000ol0000b0000=0000ol0000H0003o`00054000?o000060000ol0000c0000=0000ol0
000H0003o`00054000?o000060000ol0000c0000=0000ol0000G0003o`0005<000?o00005`000ol0
000c0000=@000ol0000F0003o`0005<000?o00005P000ol0000d0000=@000ol0000E0003o`0005D0
00?o00005@000ol0000d0000=P000ol0000D0003o`0005D000?o000050000ol0000e0000=P000ol0
000D0003o`0005D000?o000050000ol0000e0000=P000ol0000C0003o`0005L000?o00004`000ol0
000e0000=`000ol0000B0003o`0005L000?o00004P000ol0000f0000=`000ol0000A0003o`0005T0
00?o00004@000ol0000f0000>0000ol0000@0003o`0005T000?o000040000ol0000g0000>0000ol0
000?0003o`0005/000?o00003`000ol0000g0000>@000ol0000>0003o`0005/000?o00003P000ol0
000h0000>@000ol0000=0003o`0005d000?o00003@000ol0000h0000>@000ol0000=0003o`0005d0
00?o00003@000ol0000h0000>P000ol0000<0003o`0005d000?o000030000ol0000i0000>P000ol0
000;0003o`0005l000?o00002`000ol0000i0000>`000ol0000:0003o`0005l000?o00002P000ol0
000j0000>`000ol000090003o`00064000?o00002@000ol0000j0000>`000ol000090003o`000640
00?o00002@000ol0000j0000?0000ol000070003o`0006<000?o00001`000ol0000k0000?0000ol0
00070003o`0006<000?o00001`000ol0000k0000?@000ol000060003o`0006<000?o00001P000ol0
000l0000?@000ol000050003o`0006D000?o00001@000ol0000l0000?@000ol000050003o`0006D0
00?o00001@000ol0000l0000?P000ol000030003o`0006L000?o00000`000ol0000m0000?P000ol0
00030003o`0006L000?o00000`000ol0000m0000?`05bfX01L/00ol0000n0000?P07bfP00//3o`;;
@00003d02L]V00K;00?obl/0?`0000L00_l200;o;`03b`;o00?;ool00l/`00?o<@04b`Co0l/_00Go
2P0000P000Co003o<003b`04ol_;o`C;;`001Ol0003o03000l/01Oo;bl_o00?;<0001Ol0003o00T0
000800Co<003b`04ol_;o`C;;`000ol0000b00?;00Gobl_;o`03bc0000Go0000o`09000020001?l0
0?l`00?;00Cobl_o1</_0003o`0003800l/01Oo;bl_o00?;<0001Ol0003o00T0000900;o1002ob/0
0l/4o`C;;`001Ol0003o03001</5o`;;;0001Ol0003o00<000?o00001`0000P00ol600;o:P02b`03
ol_;00C;<@04oc402L/[00;o0`05o`X0000C00?o:002o`G;00<0o`00I0000oo;b`05bbT00olD0000
5P02obL01L/300;oH@02o`801L/X00;o5`0001P00ol^0003o`0002d000?o0000;@000ol0000/00?o
6@0001/00_l]0003o`0002`000?o0000;0000ol0000[00;o700001d00ol[0003o`0002/000?o0000
:`000ol0000Y00?o7P0002000_lZ00;o:`000ol0000Y00;o:P02ob40000R00;o:P000ol0000X0003
o`0002P000?o0000:002ob<0000T00?o:0000ol0000W0003o`0002L000?o00009P03obD0000W00;o
9`000ol0000V0003o`0002H000?o00009@02obP0000Y00?o9@000ol0000U0003o`0002D000?o0000
8`03obX0000/00;o9002obD000?o00008`02ob@00_l]0000;P02ob@000?o00008P000ol0000R0003
o`0002800_l_0000<003ob8000?o00008@000ol0000Q0003o`0002000ola0000<`02ob4000?o0000
80000ol0000P0003o`0001l00_ld0000=@03oal00_lP0003o`0001h00_lO00?o=P0003P00_lO0003
o`0001d000?o00007@000ol0000M00;o>@0003X00_lN0003o`0001`000?o000070000ol0000L00;o
>`0003`00olL0003o`0001/000?o00006`000ol0000J00?o?@0003l00_lK0003o`0001X000?o0000
6P000ol0000I00;o@00004400olI00;o6P000ol0000H00;o6@03od80001400;o6@000ol0000G0003
o`0001L000?o00005`02odD0001600?o5`000ol0000F0003o`0001H000?o00005@03odL0001900;o
5P000ol0000E0003o`0001D000?o00005002odX0001;00;o5@000ol0000D0003o`0001@000?o0000
4`02od`0001=00?o4`02oa@000?o00004P02oa<00om>0000D002oa<000?o00004@000ol0000A0003
o`0001400_mA0000DP03oa4000?o000040000ol0000@0003o`0000l00omC0000E@02oa0000?o0000
3`000ol0000?0003o`0000h00_mF0000E`02o`l00_l?0003o`0000d00_l?00;oF00005T00ol>0003
o`0000`000?o000030000ol0000<00?oFP0005`00_l=0003o`0000/000?o00002`000ol0000;00;o
G@0005h00ol;0003o`0000X000?o00002P000ol0000900?oG`0006400_l:0003o`0000T000?o0000
2@000ol0000800;oHP0006<00_l900;o2@000ol0000700;o2@02of@0001U00?o20000ol000060003
o`0000H000?o00001P03ofH0001X00;o1`000ol000050003o`0000D000?o00001@02ofT0001Z00?o
1@000ol000040003o`0000@000?o00000`03of/0001]00;o1002o`@000?o00000P02o`@00_m^0000
K`03o`<000?o0</01</00`3o000200?oL00007800_l200O;0P02og<0001d0003ol_;00Co0l/00ol0
001c0000M004b`03ol_;00C;M@0007@01</00oo;b`04bgD0001d00C;00?obl/01<]e0000M003b`Co
1<]e0000M004b`03ol_;00C;M@0007D00l/3o`?;MP0007H01l]g0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.625483, 0.0179408,
   0.00435432}},
  CellTags->"Recombination sel - expression pair 2"]
}, Open  ]],

Cell[TextData[{
  "Selective recombination 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination sel - expression pair 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .33652 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .63887 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62463 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .95159 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Mshowa
P
.004 w
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .17499 .21092 0 0 Mshowa
P
1 g
.33652 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .33652 .21092 0 0 Mshowa
P
.9 g
.25575 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25575 .40712 0 0 Mshowa
P
1 g
.4877 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .4877 .40712 0 0 Mshowa
P
.004 w
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .63887 .21092 0 0 Mshowa
P
.004 w
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62463 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Mshowa
P
.9 g
.80041 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80041 .21092 0 0 Mshowa
P
.9 g
.71964 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .71964 .40712 0 0 Mshowa
P
1 g
.95159 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .95159 .40712 0 0 Mshowa
P
.9 g
.4877 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .4877 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002D00CoC@05o`X0
002D0005o`000?l0C0001?l00?l;0000U0001Ol0003o04`01?l;0000U0001Ol0003o04l000?o0000
2@0009@01?m=00Co2`0009@000?o0000G@0009<00_mO0000VP000ol000170003o`0000d0002K0003
o`0004D000?o00003P0009`000?o0000@`000ol0000?0000W@000ol000110003o`000100002N0003
o`0003l000?o00004@0009h000?o0000?`000ol0000A0000W`000ol0000m0003o`000180002P0003
o`0003/000?o00004`000:4000?o0000>@000ol0000D0000XP000ol0000g0003o`0001D0002S0003
o`0003D000?o00005P000:@000?o0000<`000ol0000G0000Y@000ol0000a0003o`0001P0002V0003
o`0002l000?o00006@000:H000?o0000;`000ol0000I0000Y`000ol0000]0003o`0001X0002X0003
o`0002/000?o00006`000:T000?o0000:@000ol0000L0000ZP000ol0000W0003o`0001d0002[0003
o`0002D000?o00007P000:`000?o00008`000ol0000O0000[@000ol0000Q0003o`000200002^0003
o`0001l000?o00008@000:l000?o00007@000ol0000R0000[`000ol0000M0003o`000280002`0003
o`0001/000?o00008`000;4000?o00006@000ol0000T0000/P000ol0000G0003o`0002D0002c0003
o`0001D000?o00009P000;@000?o00004`000ol0000W0000]@000ol0000A0003o`0002P0002f0003
o`0000l000?o0000:@000;L000?o00003@000ol0000Z0000]`000ol0000=0003o`0002X0002h0003
o`0000/000?o0000:`000;T000?o00002@000ol0000/0000^P000ol00005b`8000?o0000;@000;/0
00?obol00_l3b`03o`0002h0002k00G;00Cobl_;<00002/01?lR00Go@P04oah00l/4o`C;;`0002/0
00Go0000o`0P0005o`000?l0@P000ol0000P00;;00Gobl_;o`04bbl0000[0005o`000?l080001Ol0
003o04801OlN00;;00Gobl_;o`04bbl0000[0005o`000?l080001Ol0003o048000Go0000o`0N00;;
00Gobl_;o`04bbl0000[00Co8P04od<00olO00?;1Ol3bbl0000[0003o`0002H000?o0000I009bc00
000Z00;o9`02ofL01l/a0000W0000ol0000N00G;<P0002l000?o00007`000ol000180003o`0001h0
00?o0000=000030000?o00007@000ol0001:0003o`0001`000?o0000=@00030000?o00007@000ol0
001:0003o`0001`000?o0000=@00034000?o00006`000ol0001;0003o`0001/000?o0000=P000340
00?o00006`000ol0001<0003o`0001X000?o0000=P00034000?o00006`000ol0001<0003o`0001X0
00?o0000=P00038000?o00006@000ol0001>0003o`0001P000?o0000=`00038000?o00006@000ol0
001>0003o`0001P000?o0000=`0003<000?o00005`000ol0001?0003o`0001L000?o0000>00003<0
00?o00005`000ol0001@0003o`0001H000?o0000>00003<000?o00005`000ol0001@0003o`0001H0
00?o0000>00003@000?o00005@000ol0001A0003o`0001D000?o0000>@0003@000?o00005@000ol0
001B0003o`0001@000?o0000>@0003D000?o00004`000ol0001C0003o`0001<000?o0000>P0003D0
00?o00004`000ol0001D0003o`00018000?o0000>P0003D000?o00004`000ol0001D0003o`000180
00?o0000>P0003H000?o00004@000ol0001E0003o`00014000?o0000>`0003H000?o00004@000ol0
001F0003o`00010000?o0000>`0003L000?o00003`000ol0001G0003o`0000l000?o0000?00003L0
00?o00003`000ol0001H0003o`0000h000?o0000?00003P000?o00003@000ol0001I0003o`0000d0
00?o0000?@0003P000?o00003@000ol0001I0003o`0000d000?o0000?@0003P000?o00003@000ol0
001J0003o`0000`000?o0000?@0003T000?o00002`000ol0001K0003o`0000/000?o0000?P0003T0
00?o00002`000ol0001L0003o`0000X000?o0000?P0003X000?o00002@000ol0001M0003o`0000T0
00?o0000?`0003X000?o00002@000ol0001M0003o`0000T000?o0000?`0003X000?o00002@000ol0
001N0003o`0000P000?o0000?`0003/000?o00001`000ol0001O0003o`0000L000?o0000@00003/0
00?o00001`000ol0001P0003o`0000H000?o0000@00003`000?o00001@000ol0001Q0003o`0000D0
00?o0000@@0003`000?o00001@000ol0001Q0003o`0000D000?o0000@@0003`000?o00001@000ol0
001R0003o`0000@000?o0000@@0003d000?o00000`000ol0001S0003o`0000<000?o0000@P0003d0
00?o00000`000ol0001S0003o`0000<000?o0000@P0003h01L]W00G;A@0003d000C;oooo0l]U00O;
A00003`01L/01?o;bl]S00W;@`0000L01Ol_00?;1?l4bbh01?l_00?;0_l00l_oo`03bbl01Ol>0000
1`001?l00?l`00;;00Gobl_;o`04bbd000?o0000<@03b`04ol_;o`C;;P001Ol0003o00l0000700Co
<002b`05ol_;bol01</]0003o`0003400l/01?o;bol4bbh000Go0000o`0?00002P000ol0000^00;;
00Gobl_;o`04bbd000Go0000o`0_00?;00Cobl_o1</^0005o`000?l03`0000L01?l400;o:P03b`Go
0l/^00Co;`03b`Co1</_00Co3`0001400_lY00W;H`02b`03ol_;00C;:P02o`L000?o00003@0001<0
0olW00O;00<0o`00H0001?l0ool5bbP00ol800;o3`0001H00_lV00G;0`000ol0001M0004o`0000G;
9`02oa`0000H00;o;@02obd000?o0000:`02obh00_lN00006P03ob`000?o0000:P000ol0000Z0003
o`0002/00olP00007@02ob/000?o0000:@000ol0000Y0003o`0002X00_lS00007`02obX000?o0000
:0000ol0000X0003o`0002P00olU00008@03obP000?o00009`000ol0000W0003o`0002L00_lX0000
9002obL00_lW0003o`0002D00_lX00;o:P0002H00_lW0003o`0002@000?o000090000ol0000U00?o
;00002P00olU0003o`0002<000?o00008`000ol0000T00;o;`0002/00_lT0003o`00028000?o0000
8P000ol0000S00;o<@0002d00_lS0003o`00024000?o00008@000ol0000Q00?o<`0002l00olQ0003
o`00020000?o000080000ol0000P00;o=P0003800_lP00;o80000ol0000N00;o8@02ocP0000d00;o
80000ol0000M0003o`0001d000?o00007P03ocX0000f00?o7P000ol0000L0003o`0001`000?o0000
7@02ocd0000i00;o7@000ol0000K0003o`0001/000?o00006`03ocl0000k00;o70000ol0000J0003
o`0001X000?o00006P02od80000m00?o6P000ol0000I0003o`0001T000?o00006@02od@0001000;o
6@02oaT000?o00005`02oaT00om60000@P03oaP000?o00005P000ol0000F0003o`0001L00_m90000
A@02oaL000?o00005@000ol0000E0003o`0001H00_m;0000A`02oaH000?o000050000ol0000D0003
o`0001@00om=0000B@03oa@000?o00004`000ol0000C0003o`0001<00_m@0000C002oa<000?o0000
4P000ol0000B0003o`0001400omB0000CP02oa800_lB0003o`0001000_lB00;oE@0005000olA0003
o`0000l000?o00003`000ol0000@00;oE`0005<00_l@0003o`0000h000?o00003P000ol0000>00?o
F@0005D00_l?0003o`0000d000?o00003@000ol0000=00;oG00005L00ol=0003o`0000`000?o0000
30000ol0000<00;oGP0005X00_l<00;o30000ol0000:00;o3003of00001L00;o30000ol000090003
o`0000T000?o00002P02of<0001N00?o2P000ol000080003o`0000P000?o00002@02ofD0001Q00;o
2@000ol000070003o`0000L000?o00001`03ofL0001S00;o20000ol000060003o`0000H000?o0000
1P02ofX0001U00?o1P000ol000050003o`0000D000?o00001003of`0001X00;o1@02o`D000?o0000
0`02o`D00_m_0000JP02o`D000?o00000P000ol000020003o`0000<00_ma0000K003o`<000?o0</0
1</00`3o000200?oL`0006l00_l200O;0P02ogH0001a0003ol_;00Co0l/00ol0001f0000L@04b`03
ol_;00C;N00007401</00oo;b`04bgP0001a00C;00?obl/01<]h0000L@03b`Co1<]h0000L@04b`03
ol_;00C;N00007800l/3o`?;N@0007<01l]j0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.18458, -0.625483, 0.0184166,
   0.00435432}},
  CellTags->"Recombination sel - expression pair 3"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.380494 0.178342 0.603319 0.588604 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .14005 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .26425 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20215 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .38049 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .49673 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .48578 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .63844 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .77133 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .87376 .13244 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7561 .25016 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62094 .36788 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55884 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .73718 .4856 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .38049 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.38049 .60332 m
.02381 .4856 L
s
.38049 .60332 m
.20215 .4856 L
s
.38049 .60332 m
.38049 .4856 L
s
.38049 .60332 m
.55884 .4856 L
s
.38049 .60332 m
.73718 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .4856 0 0 Mshowa
P
.004 w
.20215 .4856 m
.14005 .36788 L
s
.20215 .4856 m
.26425 .36788 L
s
1 g
.05 w
.14005 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .14005 .36788 0 0 Mshowa
P
1 g
.26425 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .26425 .36788 0 0 Mshowa
P
.9 g
.20215 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20215 .4856 0 0 Mshowa
P
1 g
.38049 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .38049 .4856 0 0 Mshowa
P
.004 w
.55884 .4856 m
.49673 .36788 L
s
.55884 .4856 m
.62094 .36788 L
s
1 g
.05 w
.49673 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .49673 .36788 0 0 Mshowa
P
.004 w
.62094 .36788 m
.48578 .25016 L
s
.62094 .36788 m
.7561 .25016 L
s
1 g
.05 w
.48578 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .48578 .25016 0 0 Mshowa
P
.004 w
.7561 .25016 m
.63844 .13244 L
s
.7561 .25016 m
.87376 .13244 L
s
1 g
.05 w
.63844 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .63844 .13244 0 0 Mshowa
P
.004 w
.87376 .13244 m
.77133 .01472 L
s
.87376 .13244 m
.97619 .01472 L
s
1 g
.05 w
.77133 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .77133 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .97619 .01472 0 0 Mshowa
P
.9 g
.87376 .13244 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .87376 .13244 0 0 Mshowa
P
.9 g
.7561 .25016 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7561 .25016 0 0 Mshowa
P
.9 g
.62094 .36788 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62094 .36788 0 0 Mshowa
P
.9 g
.55884 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55884 .4856 0 0 Mshowa
P
1 g
.73718 .4856 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .73718 .4856 0 0 Mshowa
P
.9 g
.38049 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .38049 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002g00Co:P05o`X0
002g0005o`000?l0:@001?l00?l;0000]`001Ol0003o02T01?l;0000]`001Ol0003o02`000?o0000
2@000;L01?lZ00Co2`000;L000?o0000>P000;H00_l40003o`0003D0002m0003o`0002@000?o0000
3@000;h000?o00008P000ol0000>0000_`000ol0000P0003o`0000l000300003o`0001l000?o0000
3`000<4000?o00007@000ol0000@0000`@000ol0000L0003o`00014000320003o`0001X000?o0000
4P000<<000?o000060000ol0000C0000a0000ol0000F0003o`0001@000350003o`0001@000?o0000
5@000<H000?o00004`000ol0000E0000a`000ol0000A0003o`0001H000380003o`0000l000?o0000
5`000<T000?o00003@000ol0000H0000b@000ol0000<0003o`0001T0003:0003o`0000X000?o0000
6P000</000?o00002@000ol0000J0000c0000ol000070003o`0001/0003=0003ol_o00;o00C;003o
7P000<d01L/00oo;o`0O0000U`04oc400l/4o`;;7`0009H000?o0000<P03b`05ol_;bol00l/N0000
UP000ol0000b00?;00Gobl_;o`03bah0002F0005o`000?l0<003b`05ol_;bol00l/N0000U`04oc00
1</5o`;;7P000</02l/N0000c009bal0002N0003o`0002/000?obl/01L/P0000W`000ol0000Y0003
o`0000G;8@000:0000?o00009`000ol0000W0000X@000ol0000U0003o`0002P0002R0003o`0002<0
00?o0000:@000:<000?o00008@000ol0000Z0000Y0000ol0000O0003o`0002/0002U0003o`0001d0
00?o0000;0000:H000?o00006`000ol0000]0000Y`000ol0000I0003o`0002h0002X0003o`0001L0
00?o0000;`000:T000?o00005@000ol0000`0000ZP000ol0000C0003o`000340002[0003o`000140
00?o0000<P000:`000?o00003`000ol0000c0000[@000ol0000=0003o`0003@0002^0003o`0000/0
00?o0000=@000:l000?o00002@000ol0000f0000/0000ol00005b`8000?o0000=`000;4000?obol0
0_l3b`03o`0003P0002a00G;00Cobl_;>P0007@01?lh00?;1?l4bcT0001c0003o`0003X00//01Oo;
bl_o00C;>@0007<000?o0000>P02b`05ol_;bol01</i0000L`001Ol0003o03P00//01Oo;bl_o00C;
>@0007@01?lh00?;1Ol3bcT0001j0003o`0003@02L/j0000N`000ol0000b0003o`3;00K;>`0007`0
00?o0000<0001?l00005bc`0001m0003o`0002h000?o0000@`0007h000?o0000:`02odH0001o0003
o`0002T000?o0000AP0008000_lX0003o`0004L000220003o`0002@000?o0000B00008<000?o0000
8P000ol000190000Q0000ol0000P0003o`0004X000250003o`0001h000?o0000B`0008H000?o0000
6`02odh000270003o`0001T000?o0000CP0008P000?o00005`000ol0001?0000R@000ol0000E0003
o`000500002:0003o`0001<000?o0000D@0008/00_lB0003o`000580002=0003o`0000h000?o0000
D`0008h000?o00002`02oeH0002?0003o`0000T000?o0000EP00090000?o00001L/20003o`0005L0
002A0003ol_o00;o0l/00ol0001H0000T@05b`04ol_;beX0000S00Co6@05oc401?lF00?;1?l4beT0
000S0005o`000?l05`001Ol0003o034000?o00006002b`05ol_;bol01<]I00008`001Ol0003o01L0
00Go0000o`0a00Go5P02b`05ol_;bol01<]I00008`001Ol0003o01L000Go0000o`0a0005o`000?l0
5P02b`05ol_;bol01<]I00008`04oaT01?lb00?o5`03b`Go0l]I00008`000ol0000M0003o`0004/0
2L]J00008P02oah00_m>00O;F`0002L000?o0000D@000ol0000E00G;G00002P000?o000050000ol0
000i0003o`0001@000?o0000G`0002P000?o00004`000ol0000k0003o`0001<000?o0000G`0002T0
00?o00004P000ol0000k0003o`00018000?o0000H00002T000?o00004@000ol0000m0003o`000140
00?o0000H00002X000?o000040000ol0000m0003o`00010000?o0000H@0002X000?o00003`000ol0
000o0003o`0000l000?o0000H@0002/000?o00003P000ol0000o0003o`0000h000?o0000HP0002/0
00?o00003@000ol000110003o`0000d000?o0000HP0002`000?o00002`000ol000130003o`0000/0
00?o0000H`0002d000?o00002P000ol000130003o`0000X000?o0000I00002d000?o00002@000ol0
00150003o`0000T000?o0000I00002h000?o000020000ol000150003o`0000P000?o0000I@0002h0
00?o00001`000ol000170003o`0000L000?o0000I@0002l000?o00001P000ol000170003o`0000H0
00?o0000IP0002l000?o00001@000ol000190003o`0000D000?o0000IP00030000?o000010000ol0
00190003o`0000@000?o0000I`00030000?obl/00l/00ol0001;00G;00<0o`00J000030000C;oooo
0l]<00O;JP0002l01L/01?o;bl]:00W;J@0000L01OlR00?;1?l4bb801?lR00C;0_l00l_oo`02bb<0
1Om000001`001?l00?lS00;;00Gobl_;o`04bb4000?o00009004b`04ol_;o`?;8P001Ol0003o0440
000700Co8`02b`05ol_;bol01</Q0003o`0002@01</01?o;bol3bb8000Go0000o`1100002P000ol0
000Q00;;00Gobl_;o`04bb4000Go0000o`0R00C;00Cobl_o0l/R0005o`000?l0@@0000L01?l400?o
7003b`Go0l/R00Co8P04b`Co0l/N0003o`0000801?m100004P03oaX02L/00ol0001700?;00?obl/0
0l/L00?o20000ol0000o00005@03oaP01l/200;oA@02o`040<_oo`C;6P03o`X00_m100006003oaH0
1L/50003o`00044000?o00000P05baP00om@00006`03oah00_lO0003o`0001d00_lO00?oD`0001h0
0olM0003o`0001`000?o000070000ol0000L00?oEP0002400olK00;o70000ol0000J00;o7003oeT0
000T00?o6P000ol0000I0003o`0001T000?o00006@03oe`0000W00?o6002oaT000?o00005`02oaT0
0omO0000:P03oaL000?o00005P000ol0000F0003o`0001H00omR0000;@03oaD00_lF0003o`0001@0
0_lF00?oI@0003000olD0003o`0001<000?o00004`000ol0000C00?oJ00003<00olB00;o4`000ol0
000A00;o4`03of/0000f00?o4@000ol0000@0003o`00010000?o00004003ofh0000i00?o3`02oa00
00?o00003P02oa000oma0000?003o`h000?o00003@000ol0000=0003o`0000d00omd0000?`03o``0
0_l=0003o`0000/00_l=00?oM`0004800ol;0003o`0000X000?o00002P000ol0000:00?oNP0004D0
0ol900;o2P000ol0000800;o2P03ogd0001800?o20000ol000070003o`0000L000?o00001`03oh00
001;00?o1P02o`L000?o00001@02o`L00on30000CP03o`D000?o000010000ol000040003o`0000@0
0on60000D@03o`<00_l200G;0P02o`@00on90000E003o`8000?obl/01L/01?l00003oh`0001G00;o
0//4o`?;0on?0000F004b`03ol_;00C;T@0005P01</00oo;b`04bi40001H00C;00?obl/01<^A0000
F003b`Co1<^A0000F004b`03ol_;00C;T@0005T00l/3o`?;TP0005X01l^C0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.24005, -1.04247, 0.0239518, 
  0.0072572}},
  CellTags->"Recombination sel - expression pair 3"]
}, Open  ]],

Cell[TextData[{
  "Selective recombination 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination sel - expression pair 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .16437 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .36817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .68234 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.2619 .45617 m
.179 .30902 L
s
.2619 .45617 m
.34481 .30902 L
s
1 g
.05 w
.179 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Mshowa
P
.004 w
.34481 .30902 m
.16437 .16187 L
s
.34481 .30902 m
.52526 .16187 L
s
1 g
.05 w
.16437 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .16437 .16187 0 0 Mshowa
P
.004 w
.52526 .16187 m
.36817 .01472 L
s
.52526 .16187 m
.68234 .01472 L
s
1 g
.05 w
.36817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .36817 .01472 0 0 Mshowa
P
1 g
.68234 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .68234 .01472 0 0 Mshowa
P
.9 g
.52526 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Mshowa
P
.9 g
.34481 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Mshowa
P
.004 w
.7381 .45617 m
.65519 .30902 L
s
.7381 .45617 m
.821 .30902 L
s
1 g
.05 w
.65519 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Mshowa
P
1 g
.821 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001H00CoA@05odh0
001H0005o`000?l0A0001?l00?m?0000F0001Ol0003o04@01?m?0000F0001Ol0003o04L000?o0000
C@0005P01?m500CoC`0005P000?o0000V@0005L00_l60003o`0003d000?o0000DP00060000?o0000
>`000ol0001C0000H@000ol0000i0003o`0005@0001R0003o`0003L000?o0000E@0006<000?o0000
=@000ol0001F0000I0000ol0000c0003o`0005L0001U0003o`00034000?o0000F00006H00_l_00;o
F`0006P000?o0000:`000ol0001K0000J@000ol0000Y0003o`0005`0001Z0003o`0002L000?o0000
G@0006/000?o00009@000ol0001N0000K0000ol0000S0003o`0005l0001]0003o`00024000?o0000
H00006h000?o00007`000ol0001Q0000K`000ol0000M0003o`000680001`0003o`0001/000?o0000
H`00074000?o00006@000ol0001T0000LP000ol0000G0003o`0006D0001c00;o5@02ofP0001e0003
o`00014000?o0000J00007H000?o00003`000ol0001Y0000M`000ol0000=0003o`0006X0001h0003
o`0000/000?o0000J`0007T000?o00002@000ol0001/0000NP000ol000070003o`0006d0001k0003
o`3o00;o0//00`3o001_0000O004b`03ol_;0740000X00CoC`02b`Co0l]`00009`000ol0001@00;;
00Gobl_;o`04bfl0000W0003o`0005000//01Oo;bl_o00C;K`0002L000Go0000o`1>00;;00Gobl_;
o`04bfl0000X00CoCP03b`Go0l]_0000NP0;bfl0000_00;oB@000oo;b`07bg00000a0003o`0004@0
0_l200O;L@00038000?o0000@P000ol0000300G;LP0003<000?o0000@0000ol0001k0000=0000ol0
000n0003o`0007`0000e00;o?@000ol0001m0000=`000ol0000h00;oP00003P000?o0000=P000ol0
00200000>@000ol0000d0003o`000840000j00;o<`000ol000220000?0000ol0000_0003o`0008<0
000m0003o`0002`00_n60000?P000ol0000Z0003o`0008H0000o00;o:@000ol000270000@@000ol0
000U0003o`0008P000120003o`0002<000?o0000R@0004<000?o00008002oh`000140003o`0001h0
00?o0000S00004D00_lM0003o`0008d000170003o`0001T000?o0000SP0004P000?o00005`000ol0
002?0000B@000ol0000D00;oTP0004X00_lC0003o`000980001<0003o`0000l000?o0000T`0004d0
00?o00003@000ol0002D0000CP000ol0000;0003o`0009D0001?0003o`0000G;0`02oiP0001@0003
ol_;00?o0//00`3o002I0000D006b`03ol_;09/0000[00Ko7P04b`Co0l]000Go8P05obh0000/0003
o`0002000l/01Oo;bl_o00?;@@001Ol0003o028000Go0000o`0]0000;0000ol0000P00?;00Gobl_;
o`03bd4000Go0000o`0R0005o`000?l0;@0002`01?lO00?;00Gobl_;o`03bd401?lS0005o`000?l0
;@0002`000?o00008004b`Go0/]10005o`000?l08P001Ol0003o02d0000[00Ko7`09bd401OlR00Go
;P0005401l^L0000<@000ol0000N00G;B@000ol0000N0003o`000300000a0003o`0001h000?o0000
B`000ol0000N0003o`000300000b0003o`0001`000?o0000C@000ol0000L0003o`000340000b0003
o`0001`000?o0000C@000ol0000L0003o`000340000c0003o`0001X000?o0000C`000ol0000J0003
o`000380000c0003o`0001T000?o0000D@000ol0000I0003o`000380000d0003o`0001P000?o0000
D@000ol0000H0003o`0003<0000d0003o`0001L000?o0000D`000ol0000G0003o`0003<0000e0003
o`0001H000?o0000D`000ol0000F0003o`0003@0000f0003o`0001@000?o0000E@000ol0000D0003
o`0003D0000f0003o`0001<000?o0000E`000ol0000C0003o`0003D0000g0003o`00018000?o0000
E`000ol0000B0003o`0003H0000g0003o`00014000?o0000F@000ol0000A0003o`0003H0000h0003
o`00010000?o0000F@000ol0000@0003o`0003L0000h0003o`0000l000?o0000F`000ol0000?0003
o`0003L0000i0003o`0000h000?o0000F`000ol0000>0003o`0003P0000i0003o`0000d000?o0000
G@000ol0000=0003o`0003P0000j0003o`0000/000?o0000G`000ol0000;0003o`0003T0000k0003
o`0000X000?o0000G`000ol0000:0003o`0003X0000k0003o`0000T000?o0000H@000ol000090003
o`0003X0000l0003o`0000P000?o0000H@000ol000080003o`0003/0000l0003o`0000L000?o0000
H`000ol000070003o`0003/0000m0003o`0000D000?o0000I@000ol000050003o`0003`0000m0003
o`0000D000?o0000I@000ol000050003o`0003`0000n0003o`0000<000?o0000I`000ol000030003
o`0003d0000n0003ol_;00?;00?o0000I`001l_oooo;0?l0?`0003h01l]X00G;00?ob`00?`0000L0
0_l200;o<002b`;o00?;ool00//a00?o<P03b`Co0//`00Go2P0000P000Co003o<003b`04ol_;o`C;
;`001Ol0003o03000l/01Oo;bl_o00?;<0001Ol0003o00T0000800Co<003b`04ol_;o`C;;`000ol0
000b00?;00Gobl_;o`03bc0000Go0000o`09000020001?l00?l30003o`0002X00l/01?o;bol4bbl0
00?o0000<P03b`05ol_;bol00l/`0005o`000?l02@0000T00_l500?o:@03b`Co1</_0005o`000?l0
<004b`Go0//Z00?o0`001Ol0003o00T0000800?o2003obH00l/00oo;b`05b`03o`0002d01?l`00_;
9`03o`D01Ol:00005P03ob@000?;ool01//20003o`0005l000?o0</02</U00?o5`0001T00olR00O;
1002oed00_l300O;8`03oaX0000L00Co7`05b`L000?o0000F@000ol0000400G;8004oad0000P00?o
:@02ob/000?o0000:@02obT00olQ00008`03obP00_lY0003o`0002L00_lX00?o900002H00olW0003
o`0002H000?o00009P000ol0000U00?o9`0002T00olU00;o9P000ol0000T00;o9@03obX0000/00?o
90000ol0000S0003o`0002<000?o00008P03obd0000_00Co8@02ob<000?o00008@02ob401?l`0000
<`03ob000_lQ0003o`0001l00_lP00?o=00003H00olO0003o`0001h000?o00007P000ol0000M00?o
=`0003T00olM00;o7P000ol0000L00;o7@03ocX0000l00?o70000ol0000K0003o`0001/000?o0000
6P03ocd0000o00Co6@02oa/000?o00006@02oaT01?m00000@`03oaP00_lI0003o`0001L00_lH00?o
A00004H00olG0003o`0001H000?o00005P000ol0000E00?oA`0004T00olE00;o5P000ol0000D00;o
5@03odX0001<00?o50000ol0000C0003o`0001<000?o00004P03odd0001?00?o4P02oa<000?o0000
4@02oa800om@0000DP04oa000_lA0003o`0000l00_l@00CoD`0005H00ol?0003o`0000h000?o0000
3P000ol0000=00?oE`0005T00ol=00;o3P000ol0000<00;o3@03oeX0001L00?o30000ol0000;0003
o`0000/000?o00002P03oed0001O00?o2P02o`/000?o00002@02o`X00omP0000HP03o`T00_l90003
o`0000L00_l900?oH`0006D01?l70003o`0000H000?o00001P000ol0000500CoIP0006T00ol500;o
1P000ol0000400;o1@03ofX0001/00?o10001?l00005b`<000?o00000P03ofd0001_00?o0P02o`O;
0_l200?oL00007800ol2b`Co0l/3og<0001d00C;00?obl/01<]e0000M004b`03ol_;00C;M@0007@0
1</00oo;b`04bgD0001d00?;1?l4bgD0001d00C;00?obl/01<]e0000M@03b`?o0l]f0000MP07bgL0
0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.833976, 0.0179408,
   0.00580576}},
  CellTags->"Recombination sel - expression pair 4"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002X00Go>002o`80
0_l90000Z@001Ol0003o03P000Co003o2P000:T000Go0000o`0h00Co2P000:T01?li0004o`00o`X0
002Y0005o`000?l0>@02o`/0002X00Go>@03o`/0002^0003o`0004<0002_0003o`00038000?o0000
3@000;0000?o0000<0000ol0000>0000/@000ol0000^0003o`0000l0002b0003o`0002`000?o0000
40000;<000?o0000:P000ol0000A0000]0000ol0000Y0003o`000140002e0003o`0002L000?o0000
4P000;D000?o00009P000ol0000C0000]P000ol0000T0003o`0001@0002g0003o`00028000?o0000
5@000;P000?o000080000ol0000F0000^@000ol0000N0003o`0001L0002j0003o`0001`000?o0000
60000;/000?o00006`000ol0000H0000_0000ol0000I0003o`0001T0002m0003o`0001L000?o0000
6P000;h000?o00005@000ol0000K0000_`000ol0000C0003o`0001`000300003o`00014000?o0000
7@000<0000?o000040000ol0000N0000`@000ol0000>0003o`0001l000320003o`0000`000?o0000
80000<<000?o00002`000ol0000P0000a0000ol000090003o`00024000350003o`0000L000?o0000
8P000<H000?obol00_l01</00?lU0000aP05b`03ol_o02H0002100?o@@03b`Co0//V0000P0001Ol0
003o03l00l/01Oo;bl_o00?;9@00080000?o0000@@03b`05ol_;bol00l/U0000P0000ol0001100?;
00Gobl_;o`03bbD000200005o`000?l0?`04b`Go0//U0000P@04ocl02l/U0000Q`000ol0000k00W;
9P0008P000?o0000>@000ol0b`06bbL000290003o`0003L000Co00001L/X0000RP000ol0000e0003
o`0002l0002;0003o`0003<000?o0000<00008`000?o0000<@000ol0000a0000S@000ol0000_0003
o`000380002>0003o`0002d000?o0000<`0008l000?o0000:`000ol0000d0000T0000ol0000Y0003
o`0003D0002A0003o`0002L000?o0000=P00098000?o00009@000ol0000g0000T`000ol0000S0003
o`0003P0002D0003o`00024000?o0000>@0009D000?o00007`000ol0000j0000UP000ol0000M0003
o`0003/0002G0003o`0001/000?o0000?00009P000?o00006@000ol0000m0000V@000ol0000G0003
o`0003h0002J0003o`0001D000?o0000?`0009/000?o00004`000ol000100000W0000ol0000A0003
o`000440002M0003o`0000l000?o0000@P0009h000?o00003@000ol000130000W`000ol0000;0003
o`0004@0002P0003o`0000T000?o0000A@000:4000?o00001L/20003o`0004H0002R0003ol_o00;o
0l/00ol000170000XP05b`04ol_;bdT0000V00Co7@05ocP01?lI00?;1?l4bdP0000V0005o`000?l0
6`001Ol0003o03P000?o00006`02b`05ol_;bol01<]800009P001Ol0003o01/000Go0000o`0h00Go
6@02b`05ol_;bol01<]800009P001Ol0003o01/000Go0000o`0h0005o`000?l06@02b`05ol_;bol0
1<]800009P04oad01?li00?o6P03b`Go0l]800009P000ol0000Q0003o`0005D02L]900009@02ob80
0_mH00O;BP0008P000?o00006@05bd/0000[0003o`0001P000?o0000@0000ol0000G0003o`0004h0
000[0003o`0001P000?o0000@0000ol0000G0003o`0004h0000/0003o`0001H000?o0000@P000ol0
000E0003o`0004l0000/0003o`0001H000?o0000@P000ol0000E0003o`0004l0000/0003o`0001D0
00?o0000@`000ol0000E0003o`0004l0000]0003o`0001@000?o0000A0000ol0000C0003o`000500
000]0003o`0001<000?o0000A@000ol0000C0003o`000500000^0003o`00018000?o0000AP000ol0
000A0003o`000540000^0003o`00014000?o0000A`000ol0000A0003o`000540000_0003o`000100
00?o0000B0000ol0000?0003o`000580000_0003o`0000l000?o0000B@000ol0000?0003o`000580
000`0003o`0000h000?o0000BP000ol0000=0003o`0005<0000`0003o`0000d000?o0000B`000ol0
000=0003o`0005<0000a0003o`0000`000?o0000C0000ol0000;0003o`0005@0000a0003o`0000/0
00?o0000C@000ol0000;0003o`0005@0000b0003o`0000X000?o0000CP000ol000090003o`0005D0
000b0003o`0000T000?o0000C`000ol000090003o`0005D0000c0003o`0000P000?o0000D0000ol0
00070003o`0005H0000c0003o`0000L000?o0000D@000ol000070003o`0005H0000d0003o`0000H0
00?o0000DP000ol000050003o`0005L0000d0003o`0000D000?o0000D`000ol000050003o`0005L0
000d0003o`0000D000?o0000D`000ol000050003o`0005L0000e0003o`0000<000?o0000E@000ol0
00030003o`0005P0000e0003o`0000<000?o0000E@000ol000030003o`0005P0000f00?o0/]I00G;
F`0003D01</00oo;b`1G00O;FP0000L01OlX00;;1?l3bbP01?lY00;;0_l00l_oo`02bbP01Ol/0000
1`001?l00?lX00;;00Gobl_;o`04bbH000?o0000:P03b`04ol_;o`C;9P001Ol0003o02d0000700Co
:002b`05ol_;bol01</V0003o`0002X00l/01?o;bol4bbH000Go0000o`0]00002P000ol0000V00;;
00Gobl_;o`04bbH000Go0000o`0X00?;00Cobl_o1</V0005o`000?l0;@0000L01?l400?o8@03b`Go
0l/W00Co:003b`Co1</R0003o`0000801?l]00004P02oal02l]C00?;00?obl/01L/P00;o20000ol0
000[00005003oad02L/00`3o001@0003o`3;00;o1//N00?o2@02obd0000G00?o6`07b`<000?o0000
C@001?l00007ba`00olk00006P02oaX01L/500;oB`02o`D01L/K00;o?P0001`00olS0003o`000280
00?o00008P000ol0000R00?o@00001l00olQ0003o`00024000?o00008@000ol0000P00?o@`000280
0_lP00;o8@000ol0000O00;o8003odH0000T00?o7`000ol0000N0003o`0001h000?o00007P02odT0
000W00?o7@000ol0000M0003o`0001d000?o00007003od/0000Z00;o7002oad000?o00006`02oa`0
0om>0000;003oa/000?o00006P000ol0000J0003o`0001X00_mA0000;`03oaT000?o00006@000ol0
000I0003o`0001P00omC0000<P02oaP00_lI0003o`0001L00_lH00?oEP0003@00olG0003o`0001H0
00?o00005P000ol0000F00;oF@0003L00olE00;o5P000ol0000D00;o5P03oe/0000j00;o5@000ol0
000C0003o`0001<000?o00004`03oeh0000l00?o4`000ol0000B0003o`00018000?o00004P02of40
000o00;o4P02oa8000?o00004002oa800omS0000@@03oa4000?o00003`000ol0000?0003o`0000l0
0omV0000A003o`l000?o00003P000ol0000>0003o`0000h00_mY0000A`02o`h00_l>0003o`0000`0
0_l>00?oJ`0004T00ol=0003o`0000/000?o00002`000ol0000;00?oKP0004`00ol;0003o`0000X0
00?o00002P000ol0000:00;oL@0004l00_l:00;o2P000ol0000800;o2P03og<0001A00?o2@000ol0
00070003o`0000L000?o00001`03ogH0001D00?o1`000ol000060003o`0000H000?o00001@03ogT0
001G00;o1P02o`H000?o00001002o`H00_ml0000F@03o`D000?o00000`000ol000030003o`0000<0
0omn0000G003o`<000?o00001L/20004o`0000?oP@0005l00_l20003ol_;00G;00?o00000_n40000
H@02o`;;1?l3b`;oQP0006801</00oo;b`04bhL0001R00C;00?obl/01<^70000HP04b`03ol_;00C;
Q`0006800l/4o`C;Q`0006801</00oo;b`04bhL0001S00?;0ol3bhP0001T00O;R@000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.21423, -0.833976, 0.0213757,
   0.00580576}},
  CellTags->"Recombination sel - expression pair 4"]
}, Open  ]],

Cell[TextData[{
  "Selective recombination 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Recombination sel - expression pair 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .16437 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .36817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .68234 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.2619 .45617 m
.179 .30902 L
s
.2619 .45617 m
.34481 .30902 L
s
1 g
.05 w
.179 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .179 .30902 0 0 Mshowa
P
.004 w
.34481 .30902 m
.16437 .16187 L
s
.34481 .30902 m
.52526 .16187 L
s
1 g
.05 w
.16437 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .16437 .16187 0 0 Mshowa
P
.004 w
.52526 .16187 m
.36817 .01472 L
s
.52526 .16187 m
.68234 .01472 L
s
1 g
.05 w
.36817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .36817 .01472 0 0 Mshowa
P
1 g
.68234 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .68234 .01472 0 0 Mshowa
P
.9 g
.52526 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .52526 .16187 0 0 Mshowa
P
.9 g
.34481 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .34481 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .5 .45617 0 0 Mshowa
P
.004 w
.7381 .45617 m
.65519 .30902 L
s
.7381 .45617 m
.821 .30902 L
s
1 g
.05 w
.65519 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65519 .30902 0 0 Mshowa
P
1 g
.821 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .821 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0001H00CoA@05odh0
001H0005o`000?l0A0001?l00?m?0000F0001Ol0003o04@01?m?0000F0001Ol0003o04L000?o0000
C@0005P01?m500CoC`0005P000?o0000V@0005L00_l60003o`0003d000?o0000DP00060000?o0000
>`000ol0001C0000H@000ol0000i0003o`0005@0001R0003o`0003L000?o0000E@0006<000?o0000
=@000ol0001F0000I0000ol0000c0003o`0005L0001U0003o`00034000?o0000F00006H00_l_00;o
F`0006P000?o0000:`000ol0001K0000J@000ol0000Y0003o`0005`0001Z0003o`0002L000?o0000
G@0006/000?o00009@000ol0001N0000K0000ol0000S0003o`0005l0001]0003o`00024000?o0000
H00006h000?o00007`000ol0001Q0000K`000ol0000M0003o`000680001`0003o`0001/000?o0000
H`00074000?o00006@000ol0001T0000LP000ol0000G0003o`0006D0001c00;o5@02ofP0001e0003
o`00014000?o0000J00007H000?o00003`000ol0001Y0000M`000ol0000=0003o`0006X0001h0003
o`0000/000?o0000J`0007T000?o00002@000ol0001/0000NP000ol000070003o`0006d0001k0003
o`3o00;o0//00`3o001_0000O004b`03ol_;0740000X00CoC`02b`Co0l]`00009`000ol0001@00;;
00Gobl_;o`04bfl0000W0003o`0005000//01Oo;bl_o00C;K`0002L000Go0000o`1>00;;00Gobl_;
o`04bfl0000X00CoCP03b`Go0l]_0000NP0;bfl0000_00;oB@000oo;b`07bg00000a0003o`0004@0
0_l200O;L@00038000?o0000@P000ol0000300G;LP0003<000?o0000@0000ol0001k0000=0000ol0
000n0003o`0007`0000e00;o?@000ol0001m0000=`000ol0000h00;oP00003P000?o0000=P000ol0
00200000>@000ol0000d0003o`000840000j00;o<`000ol000220000?0000ol0000_0003o`0008<0
000m0003o`0002`00_n60000?P000ol0000Z0003o`0008H0000o00;o:@000ol000270000@@000ol0
000U0003o`0008P000120003o`0002<000?o0000R@0004<000?o00008002oh`000140003o`0001h0
00?o0000S00004D00_lM0003o`0008d000170003o`0001T000?o0000SP0004P000?o00005`000ol0
002?0000B@000ol0000D00;oTP0004X00_lC0003o`000980001<0003o`0000l000?o0000T`0004d0
00?o00003@000ol0002D0000CP000ol0000;0003o`0009D0001?0003o`0000G;0`02oiP0001@0003
ol_;00?o0//00`3o002I0000D006b`03ol_;09/0000[00Ko7P04b`Co0l]000Go8P05obh0000/0003
o`0002000l/01Oo;bl_o00?;@@001Ol0003o028000Go0000o`0]0000;0000ol0000P00?;00Gobl_;
o`03bd4000Go0000o`0R0005o`000?l0;@0002`01?lO00?;00Gobl_;o`03bd401?lS0005o`000?l0
;@0002`000?o00008004b`Go0/]10005o`000?l08P001Ol0003o02d0000[00Ko7`09bd401OlR00Go
;P0005401l^L0000<@000ol0000N00G;B@000ol0000N0003o`000300000a0003o`0001h000?o0000
B`000ol0000N0003o`000300000b0003o`0001`000?o0000C@000ol0000L0003o`000340000b0003
o`0001`000?o0000C@000ol0000L0003o`000340000c0003o`0001X000?o0000C`000ol0000J0003
o`000380000c0003o`0001T000?o0000D@000ol0000I0003o`000380000d0003o`0001P000?o0000
D@000ol0000H0003o`0003<0000d0003o`0001L000?o0000D`000ol0000G0003o`0003<0000e0003
o`0001H000?o0000D`000ol0000F0003o`0003@0000f0003o`0001@000?o0000E@000ol0000D0003
o`0003D0000f0003o`0001<000?o0000E`000ol0000C0003o`0003D0000g0003o`00018000?o0000
E`000ol0000B0003o`0003H0000g0003o`00014000?o0000F@000ol0000A0003o`0003H0000h0003
o`00010000?o0000F@000ol0000@0003o`0003L0000h0003o`0000l000?o0000F`000ol0000?0003
o`0003L0000i0003o`0000h000?o0000F`000ol0000>0003o`0003P0000i0003o`0000d000?o0000
G@000ol0000=0003o`0003P0000j0003o`0000/000?o0000G`000ol0000;0003o`0003T0000k0003
o`0000X000?o0000G`000ol0000:0003o`0003X0000k0003o`0000T000?o0000H@000ol000090003
o`0003X0000l0003o`0000P000?o0000H@000ol000080003o`0003/0000l0003o`0000L000?o0000
H`000ol000070003o`0003/0000m0003o`0000D000?o0000I@000ol000050003o`0003`0000m0003
o`0000D000?o0000I@000ol000050003o`0003`0000n0003o`0000<000?o0000I`000ol000030003
o`0003d0000n0003ol_;00?;00?o0000I`001l_oooo;0?l0?`0003h01l]X00G;00?ob`00?`0000L0
0_l200;o<002b`;o00?;ool00//a00?o<P03b`Co0//`00Go2P0000P000Co003o<003b`04ol_;o`C;
;`001Ol0003o03000l/01Oo;bl_o00?;<0001Ol0003o00T0000800Co<003b`04ol_;o`C;;`000ol0
000b00?;00Gobl_;o`03bc0000Go0000o`09000020001?l00?l30003o`0002X00l/01?o;bol4bbl0
00?o0000<P03b`05ol_;bol00l/`0005o`000?l02@0000T00_l500?o:@03b`Co1</_0005o`000?l0
<004b`Go0//Z00?o0`001Ol0003o00T0000800?o2003obH00l/00oo;b`05b`03o`0002d01?l`00_;
9`03o`D01Ol:00005P03ob@000?;ool01//20003o`0005l000?o0</02</U00?o5`0001T00olR00O;
1002oed00_l300O;8`03oaX0000L00Co7`05b`L000?o0000F@000ol0000400G;8004oad0000P00?o
:@02ob/000?o0000:@02obT00olQ00008`03obP00_lY0003o`0002L00_lX00?o900002H00olW0003
o`0002H000?o00009P000ol0000U00?o9`0002T00olU00;o9P000ol0000T00;o9@03obX0000/00?o
90000ol0000S0003o`0002<000?o00008P03obd0000_00Co8@02ob<000?o00008@02ob401?l`0000
<`03ob000_lQ0003o`0001l00_lP00?o=00003H00olO0003o`0001h000?o00007P000ol0000M00?o
=`0003T00olM00;o7P000ol0000L00;o7@03ocX0000l00?o70000ol0000K0003o`0001/000?o0000
6P03ocd0000o00Co6@02oa/000?o00006@02oaT01?m00000@`03oaP00_lI0003o`0001L00_lH00?o
A00004H00olG0003o`0001H000?o00005P000ol0000E00?oA`0004T00olE00;o5P000ol0000D00;o
5@03odX0001<00?o50000ol0000C0003o`0001<000?o00004P03odd0001?00?o4P02oa<000?o0000
4@02oa800om@0000DP04oa000_lA0003o`0000l00_l@00CoD`0005H00ol?0003o`0000h000?o0000
3P000ol0000=00?oE`0005T00ol=00;o3P000ol0000<00;o3@03oeX0001L00?o30000ol0000;0003
o`0000/000?o00002P03oed0001O00?o2P02o`/000?o00002@02o`X00omP0000HP03o`T00_l90003
o`0000L00_l900?oH`0006D01?l70003o`0000H000?o00001P000ol0000500CoIP0006T00ol500;o
1P000ol0000400;o1@03ofX0001/00?o10001?l00005b`<000?o00000P03ofd0001_00?o0P02o`O;
0_l200?oL00007800ol2b`Co0l/3og<0001d00C;00?obl/01<]e0000M004b`03ol_;00C;M@0007@0
1</00oo;b`04bgD0001d00?;1?l4bgD0001d00C;00?obl/01<]e0000M@03b`?o0l]f0000MP07bgL0
0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.17981, -0.833976, 0.0179408,
   0.00580576}},
  CellTags->"Recombination sel - expression pair 5"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .29323 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .54145 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .71251 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .15406 .30902 0 0 Mshowa
P
1 g
.29323 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .29323 .30902 0 0 Mshowa
P
.9 g
.22364 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .22364 .45617 0 0 Mshowa
P
1 g
.42348 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .42348 .45617 0 0 Mshowa
P
.004 w
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .55373 .30902 0 0 Mshowa
P
.004 w
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(C)] .54145 .16187 0 0 Mshowa
P
.004 w
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .71251 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Mshowa
P
.9 g
.84435 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .84435 .16187 0 0 Mshowa
P
.9 g
.6929 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .6929 .30902 0 0 Mshowa
P
.9 g
.62332 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .62332 .45617 0 0 Mshowa
P
1 g
.82315 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .82315 .45617 0 0 Mshowa
P
.9 g
.42348 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .42348 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?@0003d0000m0000?@0002X00Go>002o`80
0_l90000Z@001Ol0003o03P000Co003o2P000:T000Go0000o`0h00Co2P000:T01?li0004o`00o`X0
002Y0005o`000?l0>@02o`/0002X00Go>@03o`/0002^0003o`0004<0002_0003o`00038000?o0000
3@000;0000?o0000<0000ol0000>0000/@000ol0000^0003o`0000l0002b0003o`0002`000?o0000
40000;<000?o0000:P000ol0000A0000]0000ol0000Y0003o`000140002e0003o`0002L000?o0000
4P000;D000?o00009P000ol0000C0000]P000ol0000T0003o`0001@0002g0003o`00028000?o0000
5@000;P000?o000080000ol0000F0000^@000ol0000N0003o`0001L0002j0003o`0001`000?o0000
60000;/000?o00006`000ol0000H0000_0000ol0000I0003o`0001T0002m0003o`0001L000?o0000
6P000;h000?o00005@000ol0000K0000_`000ol0000C0003o`0001`000300003o`00014000?o0000
7@000<0000?o000040000ol0000N0000`@000ol0000>0003o`0001l000320003o`0000`000?o0000
80000<<000?o00002`000ol0000P0000a0000ol000090003o`00024000350003o`0000L000?o0000
8P000<H000?obol00_l01</00?lU0000aP05b`03ol_o02H0002100?o@@03b`Co0//V0000P0001Ol0
003o03l00l/01Oo;bl_o00?;9@00080000?o0000@@03b`05ol_;bol00l/U0000P0000ol0001100?;
00Gobl_;o`03bbD000200005o`000?l0?`04b`Go0//U0000P@04ocl02l/U0000Q`000ol0000k00W;
9P0008P000?o0000>@000ol0b`06bbL000290003o`0003L000Co00001L/X0000RP000ol0000e0003
o`0002l0002;0003o`0003<000?o0000<00008`000?o0000<@000ol0000a0000S@000ol0000_0003
o`000380002>0003o`0002d000?o0000<`0008l000?o0000:`000ol0000d0000T0000ol0000Y0003
o`0003D0002A0003o`0002L000?o0000=P00098000?o00009@000ol0000g0000T`000ol0000S0003
o`0003P0002D0003o`00024000?o0000>@0009D000?o00007`000ol0000j0000UP000ol0000M0003
o`0003/0002G0003o`0001/000?o0000?00009P000?o00006@000ol0000m0000V@000ol0000G0003
o`0003h0002J0003o`0001D000?o0000?`0009/000?o00004`000ol000100000W0000ol0000A0003
o`000440002M0003o`0000l000?o0000@P0009h000?o00003@000ol000130000W`000ol0000;0003
o`0004@0002P0003o`0000T000?o0000A@000:4000?o00001L/20003o`0004H0002R0003ol_o00;o
0l/00ol000170000XP05b`04ol_;bdT0000V00Co7@05ocP01?lI00?;1?l4bdP0000V0005o`000?l0
6`001Ol0003o03P000?o00006`02b`05ol_;bol01<]800009P001Ol0003o01/000Go0000o`0h00Go
6@02b`05ol_;bol01<]800009P001Ol0003o01/000Go0000o`0h0005o`000?l06@02b`05ol_;bol0
1<]800009P04oad01?li00?o6P03b`Go0l]800009P000ol0000Q0003o`0005D02L]900009@02ob80
0_mH00O;BP0008P000?o00006@05bd/0000[0003o`0001P000?o0000@0000ol0000G0003o`0004h0
000[0003o`0001P000?o0000@0000ol0000G0003o`0004h0000/0003o`0001H000?o0000@P000ol0
000E0003o`0004l0000/0003o`0001H000?o0000@P000ol0000E0003o`0004l0000/0003o`0001D0
00?o0000@`000ol0000E0003o`0004l0000]0003o`0001@000?o0000A0000ol0000C0003o`000500
000]0003o`0001<000?o0000A@000ol0000C0003o`000500000^0003o`00018000?o0000AP000ol0
000A0003o`000540000^0003o`00014000?o0000A`000ol0000A0003o`000540000_0003o`000100
00?o0000B0000ol0000?0003o`000580000_0003o`0000l000?o0000B@000ol0000?0003o`000580
000`0003o`0000h000?o0000BP000ol0000=0003o`0005<0000`0003o`0000d000?o0000B`000ol0
000=0003o`0005<0000a0003o`0000`000?o0000C0000ol0000;0003o`0005@0000a0003o`0000/0
00?o0000C@000ol0000;0003o`0005@0000b0003o`0000X000?o0000CP000ol000090003o`0005D0
000b0003o`0000T000?o0000C`000ol000090003o`0005D0000c0003o`0000P000?o0000D0000ol0
00070003o`0005H0000c0003o`0000L000?o0000D@000ol000070003o`0005H0000d0003o`0000H0
00?o0000DP000ol000050003o`0005L0000d0003o`0000D000?o0000D`000ol000050003o`0005L0
000d0003o`0000D000?o0000D`000ol000050003o`0005L0000e0003o`0000<000?o0000E@000ol0
00030003o`0005P0000e0003o`0000<000?o0000E@000ol000030003o`0005P0000f00?o0/]I00G;
F`0003D01</00oo;b`1G00O;FP0000L01OlX00;;1?l3bbP01?lY00;;0_l00l_oo`02bbP01Ol/0000
1`001?l00?lX00;;00Gobl_;o`04bbH000?o0000:P03b`04ol_;o`C;9P001Ol0003o02d0000700Co
:002b`05ol_;bol01</V0003o`0002X00l/01?o;bol4bbH000Go0000o`0]00002P000ol0000V00;;
00Gobl_;o`04bbH000Go0000o`0X00?;00Cobl_o1</V0005o`000?l0;@0000L01?l400?o8@03b`Go
0l/W00Co:003b`Co1</R0003o`0000801?l]00004P02oal02l]C00?;00?obl/01L/P00;o20000ol0
000[00005003oad02L/00`3o001@0003o`3;00;o1//N00?o2@02obd0000G00?o6`07b`<000?o0000
C@001?l00007ba`00olk00006P02oaX01L/500;oB`02o`D01L/K00;o?P0001`00olS0003o`000280
00?o00008P000ol0000R00?o@00001l00olQ0003o`00024000?o00008@000ol0000P00?o@`000280
0_lP00;o8@000ol0000O00;o8003odH0000T00?o7`000ol0000N0003o`0001h000?o00007P02odT0
000W00?o7@000ol0000M0003o`0001d000?o00007003od/0000Z00;o7002oad000?o00006`02oa`0
0om>0000;003oa/000?o00006P000ol0000J0003o`0001X00_mA0000;`03oaT000?o00006@000ol0
000I0003o`0001P00omC0000<P02oaP00_lI0003o`0001L00_lH00?oEP0003@00olG0003o`0001H0
00?o00005P000ol0000F00;oF@0003L00olE00;o5P000ol0000D00;o5P03oe/0000j00;o5@000ol0
000C0003o`0001<000?o00004`03oeh0000l00?o4`000ol0000B0003o`00018000?o00004P02of40
000o00;o4P02oa8000?o00004002oa800omS0000@@03oa4000?o00003`000ol0000?0003o`0000l0
0omV0000A003o`l000?o00003P000ol0000>0003o`0000h00_mY0000A`02o`h00_l>0003o`0000`0
0_l>00?oJ`0004T00ol=0003o`0000/000?o00002`000ol0000;00?oKP0004`00ol;0003o`0000X0
00?o00002P000ol0000:00;oL@0004l00_l:00;o2P000ol0000800;o2P03og<0001A00?o2@000ol0
00070003o`0000L000?o00001`03ogH0001D00?o1`000ol000060003o`0000H000?o00001@03ogT0
001G00;o1P02o`H000?o00001002o`H00_ml0000F@03o`D000?o00000`000ol000030003o`0000<0
0omn0000G003o`<000?o00001L/20004o`0000?oP@0005l00_l20003ol_;00G;00?o00000_n40000
H@02o`;;1?l3b`;oQP0006801</00oo;b`04bhL0001R00C;00?obl/01<^70000HP04b`03ol_;00C;
Q`0006800l/4o`C;Q`0006801</00oo;b`04bhL0001S00?;0ol3bhP0001T00O;R@000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.21423, -0.833976, 0.0213757,
   0.00580576}},
  CellTags->"Recombination sel - expression pair 5"]
}, Open  ]],

Cell[TextData[{
  "Selective recombination 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expressions\),
          ButtonData:>"Recombination - basic expressions",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Recombination sel - expression pair 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Duplication - Intro"],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Mshowa
P
.004 w
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Mshowa
P
1 g
.04 w
.20018 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Mshowa
P
1 g
.05 w
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Mshowa
P
1 g
.52939 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Mshowa
P
1 g
.57643 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.004 w
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.62346 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`0004/00_l200;o^@05o`/0001<0004o`00ok/000Go0000o`0:0000C004ok/000Go0000o`0:0000
C0001?l00?nk00Co2`0004d00_nl0005o`000?l02P0004`00ol600;o[P02o`<01Ol;0000E`03ojP0
0olE0000FP02oj@00_lH0000G002oil00olJ0000GP03oiX00_lM0000H@02oiH00_lO0000H`03oi00
0olQ0000IP02oh`00_lT0000J002ohL00olV0000JP03oh800_lY0000K@02ogh00_l[0000K`02ogT0
0ol]0000L@03og@00_l`0000M002ofl00olb0000MP03ofX00_le0000N@02ofH00_lg0000N`02of40
0oli0000O@03oe`00_ll0000P002oeL00oln0000PP02oe<00_m10000Q003odh00_m30000Q`02odT0
0om50000R@03od@00_m80000S002ocl00om:0000SP02oc/00_m=0000T003ocH00_m?0000T`02oc40
0omA0000U@02obd00_mD0000U`03obL00omF0000VP02ob<00_mI0000W003oah00_mK0000W`02o`X0
00G>g/kNcP0:00?oG@000:400_l600W>1P02of00002S00?o0P000mk>gP03o`05g/kNc]h00P03of80
002V00;o1/h00oo>cP02cP;oI@0003/00omY0004c]k>gPCo00G>g/kNcP1V0000?0000ol0001X00?>
00Goc/k>o`05cVH0000i00GoJ@003LkNc_o>g/koc]k>g/h0IP0003X000?o0?l0JP03cP05olk>c_l0
1LiV0000>P000ol0o`1Z0004c]k>gPGo00CNc]k>IP0003/00_m[00_>I`000:P000_Nc]k>g/kNc]k>
gP1W0000Z@09cVP0000k0003o`0006d000G>g/kNcP1Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>@001LkNc]k>06d000G>g/kNcP1Z0000
=`09cVT02LiX0000=P000mk>gP03o`05g/kNc]h0I`000mk>gP03o`05g/kNc]h0I`0003H01/h00oo>
cP02cVL01/h00oo>cP02cVL0000U00Go2`001<kNc]h4o`05c]k>g/h02P03ocD01_l700Go2005o`@0
00C>g/kN1?l01LkNc]k>06H0000V0005o`000?l02P03cP05olk>c_l01Lh=0003o`0003<000?o0000
2P001Ol0003o00P000Go0000o`0300?>00Goc/k>o`05cVH0000V0005o`000?l02P003LkNc_o>g/ko
c]k>g/h03@000ol0000c0003o`0000X000Go0000o`080005o`000?l00`003LkNc_o>g/koc]k>g/h0
IP0002H01?l;00?>00Goc/k>o`05cP/00_lf00Co2@001Ol0003o00P01?l400?>00Goc/k>o`05cVH0
000V0005o`000?l02P001<kNc]h5o`04g/kNcPd000?o0000<`000ol0000:0005o`000?l020001Ol0
003o00<000C>g/kN1Ol01=k>g/iV00009@05o``02lh;00?o=@06o`L01Ol800Go1@0;cVL0000f000;
g/kNc]k>g/kNc]h0I`002mk>g/kNc]k>g/kN06L0000g00W>J@09cVP0000[0003o`0000/000G>g/kN
cP0=0003o`0003`000?o00007@001_o>g/kNcVX0000[0003o`0000d000?o00003@000ol0000l0003
o`0000P000?o000020000ol000070003o`0006d0000/0003o`0000`000?o000030000ol0000n0003
o`0000L000?o000020000ol000060003o`0006h0000/0003o`0000`000?o000030000ol0000n0003
o`0000L000?o000020000ol000060003o`0006h0000]0003o`0000/000?o00002`000ol000100003
o`0000H000?o00001`000ol000060003o`0006l0000]0003o`0000/000?o00002`000ol000100003
o`0000L000?o00001P000ol000060003o`0006l0000]0003o`0000/000?o00002`000ol000100003
o`0000L000?o00001P000ol000060003o`0006l0000^0003o`0000X000?o00002P000ol000120003
o`0000H000?o00001P000ol000050003o`000700000^0003o`0000X000?o00002P000ol000120003
o`0000H000?o00001P000ol000050003o`000700000_0003o`0000T000?o00002@000ol000140003
o`0000D000?o00001@000ol000050003o`000740000_0003o`0000T000?o00002@000ol000140003
o`0000D000?o00001@000ol000050003o`000740000`0003o`0000P000?o000020000ol000160003
o`0000@000?o00001@000ol000040003o`000780000`0003o`0000P000?o000020000ol000160003
o`0000D000?o000010000ol000040003o`000780000a0003o`0000L000?o00001`000ol000180003
o`0000@000?o000010000ol000030003o`0007<0000a0003o`0000L000?o00001`000ol000180003
o`0000@000?o000010000ol000030003o`0007<0000b0003o`0000H000?o00001P000ol0001:0003
o`0000<000?o00000`000ol000030003o`0007@0000b0003o`0000H000?o00001P000ol0001:0003
o`0000<000?o00000`000ol000030003o`0007@0000c0003o`0000D000?o00001@000ol0001<0003
o`00008000?o00000`000ol000020003o`0007D0000c0003o`0000D000?o00001@000ol0001<0003
o`0000<000?o00000P000ol000020003o`0007D0000d0003o`0000@000?o000010000ol0001>0003
o`00008000?o00000P001Ol0003o07P0000d0003o`0000@000?o000010000ol0001>0003o`000080
00?o00000P001Ol0003o07P0000e0003o`0000<000?o00000`000ol0001@0005o`000?l00`001Ol0
003o07T0000e0003o`0000<000?o00000`000ol0001@0005o`000?l00`001Ol0003o07T0000f0003
o`00008000?o00000P000ol0001B0004o`00o`<000Co003oNP0003H000?o00000P000ol000020003
o`00058000Co003o0`001?l00?mj0000=P000ol000020003o`00008000?o0000DP001Ol0003o0080
00Co003oNP0003L000Go0000o`030003o`0005@000Ko003o0?l20003o`0007T0000g0005o`000?l0
0`000ol0001D0006o`00o`3o0P000ol0001i0000>0001oo>g/kNc_l0F0001ooNc]k>g_l0O00003L0
2LiF00W>N`0003H000?Nc]h00ol01Mk>g/kN05@000_>g/kNc]k>g/kNcP1j0000=P06cP03olk>00;>
E00;cWX0000800;o0P02obL000C>g/kN1?l01LkNc]k>02H01OlW0004g/kNcP;o00ONooo>g/kN02L0
1?m>00002@001?l00?lX00?>00Goc/k>o`05cRL000Go0000o`0V00C>00Coc/ko1LhX0003o`0004h0
000900Co:0003LkNc_o>g/koc]k>g/h09`001Ol0003o02H000gNc]k>olkNomk>g/kN02T000?o0000
C@0000T000Co003o:003cP05olk>c_l01LhW0005o`000?l09P04cP04olk>o`G>:P000ol0001<0000
2P02obT000C>g/kN1Ol01=k>g/hW0005o`000?l09P001=k>g/h4o`05g/kNc]h0:P000ol0001<0000
2@03o`H00_lR00_>9`05obP00lh00oo>cP05cR800_l400?oC`0001@00olO000;g/kNc]k>g/kNc]h0
E0002lkNooo>g/kNc]k>01l00omH00005`02oah02Lh00`3oo`1A0003o`3>00S>7P02oe/0000I00?o
7@001LkNc]k>00D000?o0000C002o`@000GNc]k>gP0N00;oG@0001`00_lV0003o`0002@000?o0000
8`000ol0000T00?oG`0001h00_lU0003o`0002<000?o00008P000ol0000S00;oHP0002000olS0003
o`00028000?o00008@000ol0000Q00?oI00002<00_lR00;o8P000ol0000P0003o`0002000_mW0000
9@03ob4000?o00007`000ol0000N00;o8@02ofT0000X00;o80000ol0000N0003o`0001d000?o0000
7P03of/0000Z00;o7`000ol0000M0003o`0001`000?o00007@02ofh0000/00?o7@000ol0000L0003
o`0001/000?o00007002og00000_00;o7002oa`000?o00006P000ol0000J00?oLP0003400olK0003
o`0001T000?o00006@000ol0000I00;oM@0003@00_lJ0003o`0001P000?o00005`02oaT00omg0000
=P02oaT000?o00005`000ol0000F0003o`0001L00_mj0000>003oaL000?o00005P000ol0000E0003
o`0001H00_ml0000>`02oaH00_lF0003o`0001@000?o00005003ogh0000m00?o5@000ol0000C0003
o`0001<000?o00004`02oh40001000;o50000ol0000B0003o`00018000?o00004P02oh<0001200;o
4`000ol0000A0003o`0001000_lB00?oQ@0004@00olA0003o`00010000?o00003`000ol0000@00;o
R00004L00_l@00;o40000ol0000>0003o`0000h00on:0000B@03o`l000?o00003@000ol0000=0003
o`0000d00_n=0000C002o`h000?o000030000ol0000<0003o`0000`00_n?0000CP02o`d000?o0000
2`000ol0000;0003o`0000X00onA0000D003o`/000?o00002P000ol0000900;o2`02oi@0001C00;o
2P02o`X000?o000020000ol0000900;oUP0005D00ol90003o`0000L000?o00001`000ol0000700?o
V00005P00_l80003o`0000H000?o00001P000ol0000600;oV`0005X00_l70003o`0000D000?o0000
1@000ol0000400?oW@0005`00ol50003o`0000@000?o00000`02o`D00_nP0000G`02o`@00_l00`3>
cP03cP<000?o00000`02oj80001Q00?o0P002]k>g/kNc]k>g_l300?oY00006@000?oc/h02Lh00`3o
o`2W0000I@001<kNc]h4o`04c]k>ojT0001T00K>00?oc/h01<jY0000I0003Mk>g/kNc_o>g/kNc]h0
Z@0006@01/h00oo>cP04cZT0001T0005g/kNc]h01?l01<kNc]jY0000I006cP03olk>00C>Z@0006D0
00G>g/kNcP03o`03c]k>0:X0001U00_>ZP0006H000WNc]k>g/kNc]h0Z`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.24067, -0.833976, 0.02093, 
  0.00501711}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
TermPlot[theChromos, 
  TreeWidth -> .2, 
  LabelSize -> 0.02, LabelColor -> 0,
  TextDisplay -> False
];\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0007X000?o00003@000>l00_mh00;o40000?4000?o0000M0000ol0000@0000lP000ol0001b0003
o`000140003c0003o`00070000?o00004P000?@000?o0000K@02oaD0003e00;oK0000ol0000E0000
m`000ol0001X0003o`0001H0003h0003o`0006H000?o00005`000?T000?o0000I0000ol0000H0000
nP000ol0001Q00;o6`000?/00_mP0003o`0001/0003m0003o`0005`000?o000070000?h000?o0000
FP000ol0000M0000o`000ol0001H0003o`0001h0003o004000?o0000E@02ob40003o00800_mD0003
o`000240003o00@000?o0000D0000ol0000R0000o`050003o`0004h000?o00008`000?l01P000ol0
001;00;o9P000?l01`000ol000190003o`0002H0003o00P00_m80003o`0002L0003o00X000?o0000
A0000ol0000X0000o`0;0003o`00048000?o0000:@000?l030000ol0000o00;o;0000?l03@000ol0
000m0003o`0002`0003o00h000?o0000>`000ol0000]0000o`0?00;o>P000ol0000^0000o`0A0003
o`0003H000?o0000;`000?l04P000ol0000c00;o<P000?l04`000ol0000a0003o`000380003o01@0
00?o0000;`000ol0000c0000o`0E00;o;P000ol0000d0000o`0G0003o`0002T00_lg0000o`0H0003
o`0002L000?o0000=`000?l06@000ol0000U0003o`0003P0003o01X000?o00008`000ol0000i0000
o`0K00;o8P000ol0000j0000o`0M0003o`0001d00_lm0000o`0N0003o`0001/000?o0000?@000?l0
7`000ol0000I0003o`0003h0003o020000?o00005`000ol0000o0000o`0Q00;o5P000ol000100000
o`0S0003o`0001400_m30000o`0T0003o`0000l000?o0000@`000?l09@000ol0000=0003o`0004@0
003o02H000?o00002`000ol000150000o`0W00;o2@02odP0003o02T000?o00001@000ol000180000
o`0Z0003o`3o00;o00<0o`00BP000?l0:`05od`0003o02X01om;0000o`0Z00OoB`000?l0:P07od/0
003o02/01Om<0000o`0/00?oC@00068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C00006000oo800?oC@0005l01Oo600GoC00005h01oo400OoB`0005h0
1oo400OoB`0005h01oo400OoB`0005l01Oo600GoC00006000oo800?oC@0004X000?o00005@000ol0
000D0003o`0007l000?o00003@000ol0000<0003o`0000d000?o0000CP0004X000?o00005@000ol0
000D0003o`0007l000?o00003@000ol0000<0003o`0000d000?o0000CP0004/000?o000050000ol0
000D0003o`00080000?o000030000ol0000<0003o`0000d000?o0000CP0004/000?o000050000ol0
000C0003o`00084000?o000030000ol0000<0003o`0000`000?o0000C`0004/000?o000050000ol0
000C0003o`00084000?o000030000ol0000<0003o`0000`000?o0000C`0004`000?o00004`000ol0
000B0003o`0008<000?o00002`000ol0000<0003o`0000/000?o0000D00004`000?o00004`000ol0
000B0003o`0008<000?o000030000ol0000;0003o`0000/000?o0000D00004d000?o00004P000ol0
000A0003o`0008D000?o00002`000ol0000:0003o`0000/000?o0000D@0004d000?o00004P000ol0
000A0003o`0008D000?o00002`000ol0000:0003o`0000/000?o0000D@0004h000?o00004@000ol0
000@0003o`0008L000?o00002P000ol0000:0003o`0000X000?o0000DP0004h000?o00004@000ol0
000@0003o`0008L000?o00002P000ol0000:0003o`0000X000?o0000DP0004l000?o000040000ol0
000@0003o`0008P000?o00002@000ol0000:0003o`0000X000?o0000DP0004l000?o000040000ol0
000?0003o`0008T000?o00002@000ol0000:0003o`0000T000?o0000D`00050000?o00003`000ol0
000?0003o`0008X000?o00002@000ol000090003o`0000T000?o0000D`00050000?o00003`000ol0
000>0003o`0008/000?o00002@000ol000080003o`0000T000?o0000E000054000?o00003P000ol0
000>0003o`0008`000?o000020000ol000080003o`0000T000?o0000E000054000?o00003P000ol0
000=0003o`0008d000?o000020000ol000080003o`0000P000?o0000E@00058000?o00003@000ol0
000=0003o`0008h000?o00001`000ol000080003o`0000P000?o0000E@00058000?o00003@000ol0
000<0003o`0008l000?o00001`000ol000080003o`0000L000?o0000EP00058000?o00003@000ol0
000<0003o`0008l000?o000020000ol000070003o`0000L000?o0000EP0005<000?o000030000ol0
000<0003o`00090000?o00001`000ol000070003o`0000L000?o0000EP0005<000?o000030000ol0
000;0003o`00094000?o00001`000ol000060003o`0000L000?o0000E`0005@000?o00002`000ol0
000;0003o`00098000?o00001P000ol000060003o`0000L000?o0000E`0005@000?o00002`000ol0
000:0003o`0009<000?o00001P000ol000060003o`0000H000?o0000F00005D000?o00002P000ol0
000:0003o`0009@000?o00001@000ol000060003o`0000H000?o0000F00005D000?o00002P000ol0
00090003o`0009D000?o00001P000ol000050003o`0000D000?o0000F@0005H000?o00002@000ol0
00090003o`0009H000?o00001@000ol000050003o`0000D000?o0000F@0005H000?o00002@000ol0
00080003o`0009L000?o00001@000ol000050003o`0000@000?o0000FP0005L000?o000020000ol0
00080003o`0009P000?o000010000ol000040003o`0000D000?o0000FP0005L000?o000020000ol0
00070003o`0009T000?o000010000ol000040003o`0000@000?o0000F`0005P000?o00001`000ol0
00070003o`0009X000?o00000`000ol000040003o`0000@000?o0000F`0005P000?o00001`000ol0
00070003o`0009X000?o000010000ol000030003o`0000@000?o0000F`0005P000?o00001`000ol0
00060003o`0009/000?o000010000ol000030003o`0000<000?o0000G00005T000?o00001P000ol0
00060003o`0009`000?o00000`000ol000030003o`0000<000?o0000G00005T000?o00001P000ol0
00050003o`0009d000?o00000`000ol000030003o`00008000?o0000G@0005X000?o00001@000ol0
00050003o`0009h000?o00000P000ol000020003o`0000<000?o0000G@0005X000?o00001@000ol0
00040003o`0009l000?o00000P000ol000020003o`00008000?o0000GP0005/000?o000010000ol0
00040003o`000:0000?o00000P001Ol0003o00@000?o0000GP0005/000?o000010000ol000030003
o`000:4000?o00000P001Ol0003o00<000?o0000G`0005`000?o00000`000ol000030003o`000:80
00Go0000o`030005o`000?l0H@0005`000?o00000`000ol000030003o`000:8000Go0000o`030005
o`000?l0H@0005d000?o00000P000ol000020003o`000:@000Co003o0`001?l00?mR0000G@000ol0
00020003o`00008000?o0000Y0001?l00?l20005o`000?l0HP0005h000Go0000o`030003o`000:H0
00?o0?l00P001?l00?mS0000GP001Ol0003o00<000?o0000YP001_l00?l0o`8000?o0000H@0005l0
00Co003o0P000ol0002X0007o`3o0?l0o`1T0000G`001?l00?l20003o`000:P000Oo0?l0o`3o06@0
001O0006o`00o`3oZ`001?l0o`02ofD0001P0005o`3o0?l0[002o`030?oo06D0001P00?o00<0o`00
Z`05ofD0001O00Go[@05ofD0001N00OoZ`07of@0001N00OoZ`07of@0000=00;oC`07oj/01om?00;o
4`0000l00om=00Go00<0ool0Z007odd00olE00004P03od/00ol400;oY002o`<00om;00?o600001D0
0omA0003o`0004h000?o0000C`000ol0001>00?o6`0001P01?m>00;oCP000ol0001=00;oC@04oah0
000L00?oC@000ol0001;0003o`0004/00_m<00?o8P0001l00om;00;oB`000ol0001:0003o`0004T0
0olU00008P03odX00_m90003o`0004P00_m900?o:00002D01?m80003o`0004H000?o0000A`000ol0
001500Co:`0002T00om600;oAP000ol0001500;oA@03obl0000/00?oA@000ol000130003o`0004<0
0_m400?o<P0002l00om300;o@`000ol000120003o`0004400ole0000<P03od800_m10003o`000400
0_m100?o>00003D01?m00003o`0003h000?o0000?`000ol0000m00Co>`0003T00oln00;o?P000ol0
000m00;o?@03ocl0000l00?o?@000ol0000k0003o`0003/00_ll00?o@P0003l00olk00;o>`000ol0
000j0003o`0003T00om50000@P04ocT00_li0003o`0003P00_lh00CoB00004H00olh0003o`0003H0
00?o0000=P02ocL00om<0000B@03ocH00_lf0003o`0003D000?o0000=003odl0001<00?o=@000ol0
000c0003o`0003<00_ld00?oDP0004l00olc00;o<`000ol0000b0003o`0003400omE0000DP04oc40
0_la0003o`0003000_l`00CoF00005H00ol`0003o`0002h000?o0000;P02obl00omL0000F@03obh0
0_l^0003o`0002d000?o0000;003oel0001L00?o;@000ol0000[0003o`0002/00_l/00?oHP0005l0
1?lZ00;o:`000ol0000Y00;o:P04ofD0001S00?o:@02obT000?o0000:0000ol0000W00?oJ@0006H0
0olX0003o`0002H000?o00009P02obL00om/0000J@03obH00_lV0003o`0002D000?o00009003ofl0
001/00?o9@000ol0000S0003o`0002<00_lT00?oLP0006l01?lR00;o8`000ol0000Q00;o8P04ogD0
001c00?o8@02ob4000?o000080000ol0000O00?oN@0007H00olP0003o`0001h000?o00007P02oal0
0oml0000N@03oah00_lN0003o`0001d000?o00007003ogl0001l00?o7@000ol0000K0003o`0001/0
0_lL00?oPP0007l01?lJ00;o6`000ol0000I00;o6P04ohD0002300?o6@02oaT000?o000060000ol0
000G00?oR@0008H00olH0003o`0001H000?o00005P02oaL00on<0000R@03oaH00_lF0003o`0001@0
0_lF00?oS`0008`01?lD0003o`0001<000?o00004`000ol0000B00CoTP0009000olB00;o4`000ol0
000A00;o4P03oiH0002C00?o4@02oa4000?o000040000ol0000?00?oV@0009H00ol@0003o`0000h0
00?o00003P02o`l00onL0000V@03o`h00_l>0003o`0000`00_l>00?oW`0009`01?l<0003o`0000/0
00?o00002`000ol0000:00CoXP000:000ol:00;o2`000ol0000900;o2P03ojH0002S00?o2@02o`T0
00?o000020000ol0000700?oZ@000:H00ol80003o`0000H000?o00001P02o`L00on/0000Z@04o`D0
0_l60003o`0000@00_l500Co[`000:d00ol40003o`0000<000?o00000`000ol0000200?o/`000;00
0ol200;o0P03o`800_l200?o]P000;<00ol00`3oo`05o`040?oookT0002f00Wo_0000;L01onm0000
]`07okd0002h00Go_P000;T00ono0000o`1l0000o`1l0000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
dupChromos = Join @@ Table[
Duplication[theChromos, 
  Templates -> {{{_f}, 1},
                {{_h}, 1},
                {{g[x__]/; Length[{x}] > 1}, 1}
               },
  
  SelectionMode -> RANDOM], {10}]

dupChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, D, B, g[g[A, B]]], \

 
     2]]], chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]], g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]], B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B, A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]
 
     ]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, D, B, g[g[A, B]]], \

 
     2]]], chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]], g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]], B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B, A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g[g[A, B]]], A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]
 
     ]]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, D, B, g[g[A, B]]], \
2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]], g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]], B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, E, D, B, g[g[A, B]]], 
 
    2]]]
chromo[q[undef], p[f[A, g[B, g[4], B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 
 
    2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B, A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], A, 
 
    g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]]\
\>", 
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, D, B, g[g[A, B]]], \
2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]], g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]], B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
 
    h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, E, D, B, g[g[A, B]]], 
 
    2]]]
chromo[q[undef], p[f[A, g[B, g[4], B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 
 
    2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B, A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], A, 
 
    g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> False,
            LabelSize -> 0.02, LabelColor -> 0
]& /@ dupChromos;\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.69496 .30902 L
s
.72904 .45617 m
.72904 .30902 L
s
.72904 .45617 m
.76311 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.69496 .30902 Mdot
.72904 .30902 Mdot
.76311 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0007X000?o00003@000>l00_mh00;o40000?4000?o0000M0000ol0000@0000lP000ol0001b0003
o`000140003c0003o`00070000?o00004P000?@000?o0000K@02oaD0003e00;oK0000ol0000E0000
m`000ol0001X0003o`0001H0003h0003o`0006H000?o00005`000?T000?o0000I0000ol0000H0000
nP000ol0001Q00;o6`000?/00_mP0003o`0001/0003m0003o`0005`000?o000070000?h000?o0000
FP000ol0000M0000o`000ol0001H0003o`0001h0003o004000?o0000E@02ob40003o00800_mD0003
o`000240003o00@000?o0000D0000ol0000R0000o`050003o`0004h000?o00008`000?l01P000ol0
001;00;o9P000?l01`000ol000190003o`0002H0003o00P00_m80003o`0002L0003o00X000?o0000
A0000ol0000X0000o`0;0003o`00048000?o0000:@000?l030000ol0000o00;o;0000?l03@000ol0
000m0003o`0002`0003o00h000?o0000>`000ol0000]0000o`0?00;o>P000ol0000^0000o`0A0003
o`0003H000?o0000;`000?l04P000ol0000c00;o<P000?l04`000ol0000a0003o`000380003o01@0
00?o0000;`000ol0000c0000o`0E00;o;P000ol0000d0000o`0G0003o`0002T00_lg0000o`0H0003
o`0002L000?o0000=`000?l06@000ol0000U0003o`0003P0003o01X000?o00008`000ol0000i0000
o`0K00;o8P000ol0000j0000o`0M0003o`0001d00_lm0000o`0N0003o`0001/000?o0000?@000?l0
7`000ol0000I0003o`0003h0003o020000?o00005`000ol0000o0000o`0Q00;o5P000ol000100000
o`0S0003o`0001400_m30000o`0T0003o`0000l000?o0000@`000?l09@000ol0000=0003o`0004@0
003o02H000?o00002`000ol000150000o`0W00;o2@02odP0003o02T000?o00001@000ol000180000
o`0Z0003o`3o00;o00<0o`00BP000?l0:`05od`0003o02X01om;0000o`0Z00OoB`000?l0:P07od/0
003o02/01Om<0000o`0/00?oC@00068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C00006000oo800?oC@0005l01Oo600GoC00005h01oo400OoB`0005h0
1oo400OoB`0005h01oo400OoB`0005l01Oo600GoC00006000oo800?oC@0004X000?o00005@000ol0
000D0003o`0007l000?o00002@000ol000090003o`0000T000?o000020000ol0001>0000BP000ol0
000E0003o`0001@000?o0000O`000ol000090003o`0000T000?o00002@000ol000080003o`0004h0
001;0003o`0001@000?o000050000ol000200003o`0000P000?o00002@000ol000090003o`0000P0
00?o0000CP0004/000?o000050000ol0000C0003o`00084000?o00002@000ol000080003o`0000P0
00?o000020000ol0001?0000B`000ol0000D0003o`0001<000?o0000P@000ol000090003o`0000P0
00?o000020000ol000080003o`0004l0001<0003o`0001<000?o00004P000ol000230003o`0000P0
00?o000020000ol000080003o`0000L000?o0000D00004`000?o00004`000ol0000B0003o`0008<0
00?o000020000ol000080003o`0000P000?o00001`000ol0001@0000C@000ol0000B0003o`000140
00?o0000Q@000ol000070003o`0000P000?o000020000ol000060003o`000540001=0003o`000180
00?o00004@000ol000250003o`0000P000?o00001`000ol000070003o`0000L000?o0000D@0004h0
00?o00004@000ol0000@0003o`0008L000?o00001`000ol000070003o`0000L000?o00001P000ol0
001B0000CP000ol0000A0003o`00010000?o0000Q`000ol000070003o`0000L000?o00001`000ol0
00060003o`000580001?0003o`00010000?o000040000ol000280003o`0000H000?o00001`000ol0
00070003o`0000H000?o0000DP0004l000?o000040000ol0000?0003o`0008T000?o00001`000ol0
00060003o`0000H000?o00001P000ol0001C0000D0000ol0000?0003o`0000l000?o0000RP000ol0
00060003o`0000H000?o00001P000ol000060003o`0005<0001@0003o`0000l000?o00003P000ol0
002;0003o`0000H000?o00001P000ol000060003o`0000D000?o0000E000054000?o00003P000ol0
000>0003o`0008`000?o00001@000ol000060003o`0000H000?o00001@000ol0001D0000D@000ol0
000>0003o`0000d000?o0000S@000ol000060003o`0000D000?o00001@000ol000050003o`0005D0
001B0003o`0000d000?o00003@000ol0002>0003o`0000D000?o00001@000ol000050003o`0000D0
00?o0000E@00058000?o00003@000ol0000<0003o`0008l000?o00001@000ol000050003o`0000D0
00?o000010000ol0001F0000DP000ol0000=0003o`0000`000?o0000S`000ol000050003o`0000D0
00?o00001@000ol000040003o`0005H0001C0003o`0000`000?o000030000ol0002@0003o`0000@0
00?o00001@000ol000050003o`0000@000?o0000EP0005<000?o000030000ol0000;0003o`000940
00?o00001@000ol000040003o`0000@000?o000010000ol0001G0000E0000ol0000;0003o`0000/0
00?o0000TP000ol000040003o`0000@000?o000010000ol000040003o`0005L0001D0003o`0000/0
00?o00002P000ol0002C0003o`0000@000?o000010000ol000040003o`0000<000?o0000F00005D0
00?o00002P000ol0000:0003o`0009@000?o00000`000ol000040003o`0000@000?o00000`000ol0
001H0000E@000ol0000:0003o`0000T000?o0000U@000ol000040003o`0000<000?o00000`000ol0
00030003o`0005T0001F0003o`0000T000?o00002@000ol0002F0003o`0000<000?o00000`000ol0
00030003o`0000<000?o0000F@0005H000?o00002@000ol000080003o`0009L000?o00000`000ol0
00030003o`0000<000?o00000P000ol0001J0000E`000ol000080003o`0000P000?o0000V0000ol0
00020003o`0000<000?o00000`000ol000020003o`0005X0001G0003o`0000P000?o00001`000ol0
002I0003o`0000<000?o00000P000ol000020003o`00008000?o0000F`0005P000?o00001`000ol0
00070003o`0009X000?o00000P000ol000020003o`00008000?o00000P000ol0001K0000F0000ol0
00070003o`0000L000?o0000VP000ol000020003o`00008000?o00000P000ol000020003o`0005/0
001H0003o`0000L000?o00001P000ol0002K0003o`00008000?o00000P000ol000020005o`000?l0
GP0005T000?o00001P000ol000060003o`0009`000Go0000o`040003o`00008000Go0000o`1N0000
F@000ol000060003o`0000D000?o0000W@000ol000020005o`000?l00`001Ol0003o05l0001J0003
o`0000D000?o00001@000ol0002N0005o`000?l00`001Ol0003o00<000?o0000G@0005X000?o0000
1@000ol000040003o`0009l000Go0000o`030005o`000?l00P000ol0001N0000F`000ol000040003
o`0000@000?o0000X0001?l00?l30005o`000?l00P000ol0001N0000F`000ol000040003o`0000<0
00?o0000X@001Ol0003o008000Co003o0P000ol0001O0000G0000ol000030003o`0000<000?o0000
XP001?l00?l20004o`00o`8000?o0000G`0005`000?o00000`000ol000030003o`000:8000Co003o
0P001?l00?l20003o`0005l0001M0003o`00008000?o00000P000ol0002T0003o`3o008000Ko003o
0?mR0000G@000ol000020003o`00008000?o0000Y0002?l00?l0o`3o0P000ol0001P0000GP001Ol0
003o00<000?o0000YP002Ol0o`3o0?l0o`1S0000GP001Ol0003o00<000?o0000YP002Ol0o`3o0?l0
o`1S0000G`001?l00?l20003o`000:P00_l00`3o0002of@0001O0004o`00o`8000?o0000Z002o`03
0?l000;oI00005l000Ko003o0?n[0003o`3o00?oI@00060000Go0?l0o`2/00GoI@0006000ol00`3o
002[00GoI@0005l01On]00GoI@0005h01on[00OoI00005h01on[00OoI00000d00_m?00OoZ`07odl0
0_lC00003`03odd01Ol00`3oo`2X00OoC@03oaD0000B00?oB`03o`@00_nT00;o0`03od/00olH0000
5@03oe4000?o0000CP000ol0001?0003o`0004h00olK00006004odh00_m>0003o`0004d00_m=00Co
7P0001`00om=0003o`0004/000?o0000B`02od`00olR00007`03od/00_m;0003o`0004X000?o0000
B@03obD0000R00?oBP02odT000?o0000B002odT00olX00009@04odP000?o0000AP000ol000170003
o`0004D01?l[0000:@03odH00_m60003o`0004D00_m500?o;`0002`00om50003o`0004<000?o0000
@`02od@00olb0000;`03od<00_m30003o`00048000?o0000@@03ocD0000b00?o@P02od4000?o0000
@002od400olh0000=@04od0000?o0000?P000ol0000o0003o`0003d01?lk0000>@03och00_ln0003
o`0003d00_lm00?o?`0003`00olm0003o`0003/000?o0000>`02oc`00om20000?`03oc/00_lk0003
o`0003X000?o0000>@03odD0001200Co>@02ocT000?o0000>002ocP01?m80000AP03ocP000?o0000
=P000ol0000f00;o=`03od`0001900?o=P02ocH000?o0000=@000ol0000d00?oC`0004`00ole0003
o`0003<000?o0000<`02oc@00omB0000C`03oc<00_lc0003o`00038000?o0000<@03oeD0001B00Co
<@02oc4000?o0000<002oc001?mH0000EP03oc0000?o0000;P000ol0000^00;o;`03oe`0001I00?o
;P02obh000?o0000;@000ol0000/00?oG`0005`00ol]0003o`0002/000?o0000:`02ob`00omR0000
G`04obX00_l[0003o`0002T00_lZ00CoI@0006<00olY00;o:@000ol0000X0003o`0002L00omY0000
IP03obP000?o00009P000ol0000V00;o9`03of`0001Y00?o9P02obH000?o00009@000ol0000T00?o
K`0006`00olU0003o`0002<000?o00008`02ob@00omb0000K`04ob800_lS0003o`0002400_lR00Co
M@0007<00olQ00;o8@000ol0000P0003o`0001l00omi0000MP03ob0000?o00007P000ol0000N00;o
7`03og`0001i00?o7P02oah000?o00007@000ol0000L00?oO`0007`00olM0003o`0001/000?o0000
6`02oa`00on20000O`04oaX00_lK0003o`0001T00_lJ00CoQ@0008<00olI00;o6@000ol0000H0003
o`0001L00on90000QP03oaP000?o00005P000ol0000F00;o5`03oh`0002900?o5P02oaH000?o0000
5002oaH00on?0000S004oa@000?o00004`000ol0000C0003o`0001801?nB0000T003oa800_lC0003
o`0001400_lB00?oUP0009<00olA00;o4@000ol0000@0003o`0000l00onI0000UP03oa0000?o0000
3P000ol0000>00;o3`03oi`0002I00?o3P02o`h000?o00003002o`h00onO0000W004o``000?o0000
2`000ol0000;0003o`0000X01?nR0000X003o`X00_l;0003o`0000T00_l:00?oYP000:<00ol900;o
2@000ol000080003o`0000L00onY0000YP03o`P000?o00001P000ol0000600;o1`03oj`0002Y00Co
1@02o`H000?o00001002o`D01?n_0000[@03o`@000?o00000`000ol000030003o`0000800onc0000
/003o`800_l200?o0P02o`800onf0000/`03o`030?oo00Go00@0oooo^@000;H02Onl0000]`07okd0
002g00Oo_@000;P01Onn0000^@03okl0003o07`0003o07`00000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 1"]
}, Open  ]],

Cell[TextData[{
  "Selective duplication 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.79719 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.79719 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0003/000?o0000?0000ol0000=0000k`02oc/000?o0000>P02oa00003a0003o`0003P000?o0000
>@000ol0000@0000lP000ol0000g0003o`0003P000?o00004@000?<000?o0000=P000ol0000g0003
o`000180003d0003o`0003D000?o0000=@02oaD0003e00;o=@000ol0000d0003o`0001D0003g0003
o`00038000?o0000<`000ol0000F0000n0000ol0000a0003o`00038000?o00005`000?T000?o0000
<0000ol0000a0003o`0001P0003j0003o`0002l000?o0000;`02oa/0003k00;o;`000ol0000^0003
o`0001/0003m0003o`0002`000?o0000;@000ol0000L0000oP000ol0000[0003o`0002`000?o0000
7@000?l000?o0000:P000ol0000[0003o`0001h0003o004000?o0000:@000ol0000Y00;o8@000?l0
0P02obT000?o0000:0000ol0000Q0000o`040003o`0002H000?o00009`000ol0000R0000o`050003
o`0002D000?o00009P000ol0000S0000o`060003o`0002@000?o00009002obH0003o00L000?o0000
8`000ol0000S0003o`0002H0003o00P00_lS0003o`00028000?o00009`000?l02P000ol0000P0003
o`00024000?o0000:0000?l02`000ol0000O0003o`00020000?o0000:@000?l030000ol0000N0003
o`0001h00_l/0000o`0=0003o`0001d000?o00007@000ol0000/0000o`0>0003o`0001`000?o0000
70000ol0000]0000o`0?00;o70000ol0000K0003o`0002h0003o014000?o00006@000ol0000J0003
o`0002l0003o018000?o000060000ol0000H00;o<P000?l04`000ol0000G0003o`0001L000?o0000
<P000?l050000ol0000F0003o`0001H000?o0000<`000?l05@02oaH000?o00005@000ol0000d0000
o`0G0003o`0001<000?o00004`02ocL0003o01P000?o00004P000ol0000B0003o`0003L0003o01T0
00?o00004@000ol0000A0003o`0003P0003o01X000?o000040000ol0000@0003o`0003T0003o01/0
0_l@0003o`0000l000?o0000>P000?l07@000ol0000=0003o`0000d00_lm0000o`0N0003o`0000`0
00?o000030000ol0000m0000o`0O0003o`0000/000?o00002`000ol0000n0000o`0P0003o`0000X0
00?o00002P000ol0000o0000o`0Q00;o2P000ol000090003o`000400003o02<000?o00001`000ol0
000700;o@`000?l090000ol000060003o`0000H000?o0000@`000?l09@000ol000050003o`0000D0
00?o0000A0000?l09P000ol000040003o`0000@000?o0000A@000?l09`02o`@000?o00000P02odP0
003o02T000Go0000o`030003o`0004P0003o02X000?o0?l00_l00`3o001:0000o`0[00GoC0000?l0
:P07od/0003o02X01om;0000o`0Z00OoB`000?l0:`05od`0003o02`00om=0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003
o`0004`0001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000H003olP00om=0000
G`05olH01Om<0000GP07ol@01om;0000GP07ol@01om;0000GP07ol@01om;0000G`05olH01Om<0000
H003olP00om=0000BP000ol0000E0003o`0001@000?o0000O`000ol0000=0003o`0000`000?o0000
3@000ol0001>0000BP000ol0000E0003o`0001@000?o0000O`000ol0000=0003o`0000`000?o0000
3@000ol0001>0000B`000ol0000D0003o`0001@000?o0000P0000ol0000<0003o`0000`000?o0000
3@000ol0001>0000B`000ol0000D0003o`0001<000?o0000P@000ol0000<0003o`0000`000?o0000
30000ol0001?0000B`000ol0000D0003o`0001<000?o0000P@000ol0000<0003o`0000`000?o0000
30000ol0001?0000C0000ol0000C0003o`00018000?o0000P`000ol0000;0003o`0000`000?o0000
2`000ol0001@0000C0000ol0000C0003o`00018000?o0000P`000ol0000<0003o`0000/000?o0000
2`000ol0001@0000C@000ol0000B0003o`00014000?o0000Q@000ol0000;0003o`0000X000?o0000
2`000ol0001A0000C@000ol0000B0003o`00014000?o0000Q@000ol0000;0003o`0000X000?o0000
2`000ol0001A0000CP000ol0000A0003o`00010000?o0000Q`000ol0000:0003o`0000X000?o0000
2P000ol0001B0000CP000ol0000A0003o`00010000?o0000Q`000ol0000:0003o`0000X000?o0000
2P000ol0001B0000C`000ol0000@0003o`00010000?o0000R0000ol000090003o`0000X000?o0000
2P000ol0001B0000C`000ol0000@0003o`0000l000?o0000R@000ol000090003o`0000X000?o0000
2@000ol0001C0000D0000ol0000?0003o`0000l000?o0000RP000ol000090003o`0000T000?o0000
2@000ol0001C0000D0000ol0000?0003o`0000h000?o0000R`000ol000090003o`0000P000?o0000
2@000ol0001D0000D@000ol0000>0003o`0000h000?o0000S0000ol000080003o`0000P000?o0000
2@000ol0001D0000D@000ol0000>0003o`0000d000?o0000S@000ol000080003o`0000P000?o0000
20000ol0001E0000DP000ol0000=0003o`0000d000?o0000SP000ol000070003o`0000P000?o0000
20000ol0001E0000DP000ol0000=0003o`0000`000?o0000S`000ol000070003o`0000P000?o0000
1`000ol0001F0000DP000ol0000=0003o`0000`000?o0000S`000ol000080003o`0000L000?o0000
1`000ol0001F0000D`000ol0000<0003o`0000`000?o0000T0000ol000070003o`0000L000?o0000
1`000ol0001F0000D`000ol0000<0003o`0000/000?o0000T@000ol000070003o`0000H000?o0000
1`000ol0001G0000E0000ol0000;0003o`0000/000?o0000TP000ol000060003o`0000H000?o0000
1`000ol0001G0000E0000ol0000;0003o`0000X000?o0000T`000ol000060003o`0000H000?o0000
1P000ol0001H0000E@000ol0000:0003o`0000X000?o0000U0000ol000050003o`0000H000?o0000
1P000ol0001H0000E@000ol0000:0003o`0000T000?o0000U@000ol000060003o`0000D000?o0000
1@000ol0001I0000EP000ol000090003o`0000T000?o0000UP000ol000050003o`0000D000?o0000
1@000ol0001I0000EP000ol000090003o`0000P000?o0000U`000ol000050003o`0000D000?o0000
10000ol0001J0000E`000ol000080003o`0000P000?o0000V0000ol000040003o`0000@000?o0000
1@000ol0001J0000E`000ol000080003o`0000L000?o0000V@000ol000040003o`0000@000?o0000
10000ol0001K0000F0000ol000070003o`0000L000?o0000VP000ol000030003o`0000@000?o0000
10000ol0001K0000F0000ol000070003o`0000L000?o0000VP000ol000040003o`0000<000?o0000
10000ol0001K0000F0000ol000070003o`0000H000?o0000V`000ol000040003o`0000<000?o0000
0`000ol0001L0000F@000ol000060003o`0000H000?o0000W0000ol000030003o`0000<000?o0000
0`000ol0001L0000F@000ol000060003o`0000D000?o0000W@000ol000030003o`0000<000?o0000
0P000ol0001M0000FP000ol000050003o`0000D000?o0000WP000ol000020003o`00008000?o0000
0`000ol0001M0000FP000ol000050003o`0000@000?o0000W`000ol000020003o`00008000?o0000
0P000ol0001N0000F`000ol000040003o`0000@000?o0000X0000ol000020005o`000?l010000ol0
001N0000F`000ol000040003o`0000<000?o0000X@000ol000020005o`000?l00`000ol0001O0000
G0000ol000030003o`0000<000?o0000XP001Ol0003o00<000Go0000o`1Q0000G0000ol000030003
o`0000<000?o0000XP001Ol0003o00<000Go0000o`1Q0000G@000ol000020003o`00008000?o0000
Y0001?l00?l30004o`00of80001M0003o`00008000?o00000P000ol0002T0004o`00o`8000Go0000
o`1R0000GP001Ol0003o00<000?o0000YP000ol0o`020004o`00of<0001N0005o`000?l00`000ol0
002V0006o`00o`3o0P000ol0001Q0000G`001?l00?l20003o`000:P000Oo0?l0o`3o06@0001O0004
o`00o`8000?o0000Z0001ol0o`3o0?l0I00005l000Ko003o0?n[0004o`3o00;oI@00060000Go0?l0
o`2/00;o00<0ool0I@0006000ol00`3o002[00GoI@0005l01On]00GoI@0005h01on[00OoI00005h0
1on[00OoI00000d00_m?00OoZ`07odl00_lC00003`03odd01Ol00`3oo`2X00OoC@03oaD0000B00?o
B`03o`@00_nT00;o0`03od/00olH00005@03oe4000?o0000CP000ol0001?0003o`0004h00olK0000
6004odh00_m>0003o`0004d00_m=00Co7P0001`00om=0003o`0004/000?o0000B`02od`00olR0000
7`03od/00_m;0003o`0004X000?o0000B@03obD0000R00?oBP02odT000?o0000B002odT00olX0000
9@04odP000?o0000AP000ol000170003o`0004D01?l[0000:@03odH00_m60003o`0004D00_m500?o
;`0002`00om50003o`0004<000?o0000@`02od@00olb0000;`03od<00_m30003o`00048000?o0000
@@03ocD0000b00?o@P02od4000?o0000@002od400olh0000=@04od0000?o0000?P000ol0000o0003
o`0003d01?lk0000>@03och00_ln0003o`0003d00_lm00?o?`0003`00olm0003o`0003/000?o0000
>`02oc`00om20000?`03oc/00_lk0003o`0003X000?o0000>@03odD0001200Co>@02ocT000?o0000
>002ocP01?m80000AP03ocP000?o0000=P000ol0000f00;o=`03od`0001900?o=P02ocH000?o0000
=@000ol0000d00?oC`0004`00ole0003o`0003<000?o0000<`02oc@00omB0000C`03oc<00_lc0003
o`00038000?o0000<@03oeD0001B00Co<@02oc4000?o0000<002oc001?mH0000EP03oc0000?o0000
;P000ol0000^00;o;`03oe`0001I00?o;P02obh000?o0000;@000ol0000/00?oG`0005`00ol]0003
o`0002/000?o0000:`02ob`00omR0000G`04obX00_l[0003o`0002T00_lZ00CoI@0006<00olY00;o
:@000ol0000X0003o`0002L00omY0000IP03obP000?o00009P000ol0000V00;o9`03of`0001Y00?o
9P02obH000?o00009@000ol0000T00?oK`0006`00olU0003o`0002<000?o00008`02ob@00omb0000
K`04ob800_lS0003o`0002400_lR00CoM@0007<00olQ00;o8@000ol0000P0003o`0001l00omi0000
MP03ob0000?o00007P000ol0000N00;o7`03og`0001i00?o7P02oah000?o00007@000ol0000L00?o
O`0007`00olM0003o`0001/000?o00006`02oa`00on20000O`04oaX00_lK0003o`0001T00_lJ00Co
Q@0008<00olI00;o6@000ol0000H0003o`0001L00on90000QP03oaP000?o00005P000ol0000F00;o
5`03oh`0002900?o5P02oaH000?o00005002oaH00on?0000S004oa@000?o00004`000ol0000C0003
o`0001801?nB0000T003oa800_lC0003o`0001400_lB00?oUP0009<00olA00;o4@000ol0000@0003
o`0000l00onI0000UP03oa0000?o00003P000ol0000>00;o3`03oi`0002I00?o3P02o`h000?o0000
3002o`h00onO0000W004o``000?o00002`000ol0000;0003o`0000X01?nR0000X003o`X00_l;0003
o`0000T00_l:00?oYP000:<00ol900;o2@000ol000080003o`0000L00onY0000YP03o`P000?o0000
1P000ol0000600;o1`03oj`0002Y00Co1@02o`H000?o00001002o`D01?n_0000[@03o`@000?o0000
0`000ol000030003o`0000800onc0000/003o`800_l200?o0P02o`800onf0000/`03o`030?oo00Go
00@0oooo^@000;H02Onl0000]`07okd0002g00Oo_@000;P01Onn0000^@03okl0003o07`0003o07`0
0000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 2"],

Cell[TextData[{
  "Selective duplication 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.69496 .30902 L
s
.72904 .45617 m
.72904 .30902 L
s
.72904 .45617 m
.76311 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.69496 .30902 Mdot
.72904 .30902 Mdot
0 g
0 w
.76311 .30902 m
.76311 .16187 L
s
.02 w
.76311 .30902 Mdot
0 w
.76311 .16187 m
.58411 .01472 L
s
.76311 .16187 m
.94211 .01472 L
s
1 g
.02 w
.58411 .01472 Mdot
.94211 .01472 Mdot
0 g
.76311 .16187 Mdot
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000=l000?o00002P000ol0001a0003o`0000X000?o00002`000>0000?o0000
2P000ol0001_0003o`0000X000?o000030000>4000?o00002P000ol0001]0003o`0000X000?o0000
3@000>800_l;00;oJ`02o`/00_l@0000i0000ol0000:0003o`0006L000?o00002P000ol0000@0000
i@000ol0000:0003o`0006D000?o00002P000ol0000A0000iP000ol0000:0003o`0006<000?o0000
2P000ol0000B0000i`02o`/000?o0000H@000ol0000900;o5@000>T000?o00002@02oel00_l;0003
o`0001D0003Z0003o`0000X000?o0000F`000ol0000:0003o`0001H0003[0003o`0000X000?o0000
F@000ol0000:0003o`0001L0003/0003o`0000X000?o0000E`000ol0000:0003o`0001P0003]00;o
2`000ol0001E0003o`0000T00_lK0000k`000ol0000900;oD`02o`/000?o00006`000?0000?o0000
2P000ol0001?0003o`0000X000?o000070000?4000?o00002P000ol0001=0003o`0000X000?o0000
7@000?8000?o00002P000ol0001;0003o`0000X000?o00007P000?<00_l;0003o`0004T000?o0000
2@02ob40003e0003o`0000T00_m700;o2`000ol0000Q0000mP000ol0000:0003o`0004<000?o0000
2P000ol0000R0000m`000ol0000:0003o`00044000?o00002P000ol0000S0000n002o`/000?o0000
?`000ol0000900;o9P000?X000?o00002@000ol0000m0003o`0000T000?o00009P000?/000?o0000
2@02oc/00_l;0003o`0002L0003l0003o`0000X000?o0000=`000ol0000:0003o`0002P0003m0003
o`0000X000?o0000=@000ol0000:0003o`0002T0003n00;o2`000ol0000c0003o`0000T00_l/0000
o`010003o`0000T000?o0000<@000ol000090003o`0002`0003o008000?o00002@000ol0000_0003
o`0000T000?o0000;@000?l00`000ol0000900;o;@02o`/000?o0000;P000?l010000ol0000:0003
o`0002T000?o00002P000ol0000_0000o`0500;o2`000ol0000W0003o`0000T00_lb0000o`070003
o`0000T000?o00009@000ol000090003o`000380003o00P000?o00002@000ol0000S0003o`0000T0
00?o0000<`000?l02@000ol0000900;o8@02o`/000?o0000=0000?l02P02o`/000?o00007@000ol0
000900;o=`000?l030000ol000090003o`0001/000?o00002@000ol0000g0000o`0=0003o`0000T0
00?o00006@000ol000090003o`0003P0003o00h000?o00002@000ol0000G0003o`0000T000?o0000
>@000?l03`000ol0000900;o5@02o`/000?o0000>P000?l04002o`/000?o00004@000ol0000900;o
?@000?l04P000ol000090003o`0000l000?o00002@000ol0000m0000o`0C0003o`0000T000?o0000
3@000ol000090003o`0003h0003o01@000?o00002@000ol0000;0003o`0000T000?o0000?`000?l0
5@000ol0000900;o2@02o`/000?o0000@0000?l05P02o`/000?o00001@000ol0000900;o@`000?l0
60000ol000090003o`0000<000?o00002@000ol000130000o`0I0003o`0000T000Go0000o`0;0003
o`0004@0003o01X000?o00002@000ol0o`0;0003o`0004D0003o01/00_l900?o2@02odP0003o01d0
00?o00001@001Ol0003o00L000?o0000B0000?l07P04o`8000?o00000`000ol0o`02o`030?l004X0
003o01h01_l700GoC0000?l07@07o`H01om;0000o`0M00Oo1P07od/0003o01d01ol600OoB`000?l0
7P05o`P01Om<0000o`0O00?o2P03odd0001R0003o`000;/000?o00002@000ol0001<0000HP000ol0
002k0003o`0000T000?o0000C000068000?o0000^`000ol000090003o`0004`0001R0003o`000;/0
00?o00002@000ol0001<0000HP000ol0002k0003o`0000T000?o0000C000068000?o0000^`000ol0
00090003o`0004`0001R0003o`000;/000?o00002@000ol0001<0000HP000ol0002k0003o`0000T0
00?o0000C000068000?o0000^`000ol000090003o`0004`0001R0003o`000;/000?o00002@000ol0
001<0000HP000ol0002k0003o`0000T000?o0000C000068000?o0000^`000ol000090003o`0004`0
001R0003o`000;/000?o00002@000ol0001<0000HP000ol0002k0003o`0000T000?o0000C0000680
00?o0000^`000ol000090003o`0004`0001R0003o`000;/000?o00002@000ol0001<0000HP000ol0
002k0003o`0000T000?o0000C000068000?o0000^`000ol000090003o`0004`0001R0003o`000;/0
00?o00002@000ol0001<0000HP000ol0002k0003o`0000T000?o0000C000068000?o0000^`000ol0
00090003o`0004`0001R0003o`000;/000?o00002@000ol0001<0000HP000ol0002k0003o`0000T0
00?o0000C000068000?o0000^`000ol000090003o`0004`0001R0003o`000;/000?o00002@000ol0
001<0000HP000ol0002k0003o`0000T000?o0000C000068000?o0000^`000ol000090003o`0004`0
001R0003o`000;/000?o00002@000ol0001<0000HP000ol0002k0003o`0000T000?o0000C0000680
00?o0000^`000ol000090003o`0004`0001R0003o`000;/000?o00002@000ol0001<0000HP000ol0
002k0003o`0000T000?o0000C000068000?o0000^`000ol000090003o`0004`0001R0003o`000;/0
00?o00002@000ol0001<0000HP000ol0002k0003o`0000T000?o0000C000068000?o0000^`000ol0
00090003o`0004`0001R0003o`000;/000?o00002@000ol0001<0000HP000ol0002k0003o`0000T0
00?o0000C000068000?o0000^`000ol000090003o`0004`0001R0003o`000;/000?o00002@000ol0
001<0000HP000ol0002k0003o`0000T000?o0000C000068000?o0000^`000ol000090003o`0004`0
001R0003o`000;/000?o00002@000ol0001<0000HP000ol0002k0003o`0000T000?o0000C0000680
00?o0000^`000ol000090003o`0004`0001R0003o`000;/000?o00002@000ol0001<0000HP000ol0
002k0003o`0000T000?o0000C000068000?o0000^`000ol000090003o`0004`0001P00?o^`03o`X0
0om=0000G`05okT01Ol800GoC00005h01ong00Oo1P07od/0001N00Oo]`07o`H01om;0000GP07okL0
1ol600OoB`0005l01Oni00Go2005od`0001P00?o^`03o`X00om=0000BP000ol0000E0003o`0001@0
00?o0000O`000ol000090003o`0000T000?o00002@000ol000080003o`0004h0001:0003o`0001D0
00?o000050000ol0001o0003o`0000T000?o00002@000ol000090003o`0000P000?o0000CP0004/0
00?o000050000ol0000D0003o`00080000?o000020000ol000090003o`0000T000?o000020000ol0
001>0000B`000ol0000D0003o`0001<000?o0000P@000ol000090003o`0000P000?o000020000ol0
00080003o`0004l0001;0003o`0001@000?o00004`000ol000210003o`0000T000?o000020000ol0
00080003o`0000P000?o0000C`0004`000?o00004`000ol0000B0003o`0008<000?o000020000ol0
00080003o`0000P000?o00001`000ol0001@0000C0000ol0000C0003o`00018000?o0000P`000ol0
00080003o`0000P000?o000020000ol000070003o`000500001=0003o`00018000?o00004@000ol0
00250003o`0000L000?o000020000ol000080003o`0000H000?o0000D@0004d000?o00004P000ol0
000A0003o`0008D000?o000020000ol000070003o`0000L000?o00001`000ol0001A0000CP000ol0
000A0003o`00010000?o0000Q`000ol000070003o`0000L000?o00001`000ol000060003o`000580
001>0003o`00014000?o000040000ol000270003o`0000L000?o00001`000ol000070003o`0000H0
00?o0000DP0004l000?o000040000ol0000@0003o`0008P000?o00001P000ol000070003o`0000L0
00?o00001P000ol0001B0000C`000ol0000@0003o`0000l000?o0000R@000ol000070003o`0000H0
00?o00001P000ol000060003o`0005<0001@0003o`0000l000?o00003`000ol0002:0003o`0000H0
00?o00001P000ol000060003o`0000H000?o0000D`00050000?o00003`000ol0000>0003o`0008/0
00?o00001P000ol000060003o`0000H000?o00001@000ol0001D0000D@000ol0000>0003o`0000h0
00?o0000S0000ol000050003o`0000H000?o00001P000ol000050003o`0005@0001A0003o`0000h0
00?o00003@000ol0002=0003o`0000H000?o00001@000ol000050003o`0000D000?o0000E@000580
00?o00003@000ol0000=0003o`0008h000?o00001@000ol000050003o`0000D000?o00001@000ol0
001E0000DP000ol0000=0003o`0000`000?o0000S`000ol000050003o`0000D000?o00001@000ol0
00040003o`0005H0001B0003o`0000d000?o000030000ol0002?0003o`0000D000?o00001@000ol0
00050003o`0000@000?o0000EP0005<000?o000030000ol0000<0003o`00090000?o000010000ol0
00050003o`0000D000?o000010000ol0001F0000D`000ol0000<0003o`0000/000?o0000T@000ol0
00050003o`0000@000?o000010000ol000040003o`0005L0001D0003o`0000/000?o00002`000ol0
002B0003o`0000@000?o000010000ol000040003o`0000@000?o0000E`0005@000?o00002`000ol0
000:0003o`0009<000?o000010000ol000040003o`0000@000?o00000`000ol0001H0000E@000ol0
000:0003o`0000X000?o0000U0000ol000030003o`0000@000?o000010000ol000030003o`0005P0
001E0003o`0000X000?o00002@000ol0002E0003o`0000@000?o00000`000ol000030003o`0000<0
00?o0000F@0005H000?o00002@000ol000090003o`0009H000?o00000`000ol000030003o`0000<0
00?o00000`000ol0001I0000EP000ol000090003o`0000P000?o0000U`000ol000030003o`0000<0
00?o00000`000ol000020003o`0005X0001G0003o`0000P000?o000020000ol0002H0003o`000080
00?o00000`000ol000030003o`00008000?o0000FP0005L000?o000020000ol000070003o`0009T0
00?o00000`000ol000020003o`00008000?o00000P000ol0001K0000F0000ol000070003o`0000L0
00?o0000VP000ol000020003o`00008000?o00000P000ol000020003o`0005/0001H0003o`0000L0
00?o00001`000ol0002J0003o`00008000?o00000P000ol000020003o`00008000?o0000F`0005P0
00?o00001`000ol000060003o`0009/000?o00000P000ol000020003o`00008000Go0000o`1N0000
F@000ol000060003o`0000H000?o0000W0001Ol0003o00@000?o00000P001Ol0003o05h0001I0003
o`0000H000?o00001@000ol0002M0003o`00008000Go0000o`030005o`000?l0G`0005X000?o0000
1@000ol000050003o`0009h000Go0000o`030005o`000?l00`000ol0001M0000FP000ol000050003
o`0000@000?o0000W`001Ol0003o00<000Go0000o`020003o`0005h0001K0003o`0000@000?o0000
10000ol0002P0004o`00o`<000Go0000o`020003o`0005h0001K0003o`0000@000?o00000`000ol0
002Q0005o`000?l00P001?l00?l20003o`0005l0001L0003o`0000<000?o00000`000ol0002R0004
o`00o`8000Co003o0P000ol0001O0000G0000ol000030003o`0000<000?o0000XP001?l00?l20004
o`00o`8000?o0000G`0005d000?o00000P000ol000020003o`000:@000?o0?l00P001_l00?l0of80
001M0003o`00008000?o00000P000ol0002T0008o`00o`3o0?l20003o`000600001N0005o`000?l0
0`000ol0002V0009o`3o0?l0o`3o06<0001N0005o`000?l00`000ol0002V0009o`3o0?l0o`3o06<0
001O0004o`00o`8000?o0000Z002o`030?l000;oI00005l000Co003o0P000ol0002X00;o00<0o`00
0_mT0000G`001_l00?l0oj/000?o0?l00omU0000H0001Ol0o`3o0:`01OmU0000H003o`030?l00:/0
1OmU0000G`05ojd01OmU0000GP07oj/01omT0000GP07oj/01omT00003@02odl01on[00OoC`02oa<0
000?00?oC@05o`030?oo0:P01om=00?o5@0001800om;00?o1002oj@00_l300?oB`03oaP0000E00?o
D@000ol0001>0003o`0004l000?o0000CP03oa/0000H00CoCP02odh000?o0000C@02odd01?lN0000
7003odd000?o0000B`000ol0001;00;oC003ob80000O00?oB`02od/000?o0000BP000ol0001900?o
9@0002800om:00;oB@000ol0001800;oB@03obP0000U00CoB0000ol000160003o`0004L000?o0000
A@04ob/0000Y00?oAP02odH000?o0000A@02odD00ol_0000;003odD000?o0000@`000ol0001300;o
A003oc80000_00?o@`02od<000?o0000@P000ol0001100?o=@0003800om200;o@@000ol0001000;o
@@03ocP0000e00Co@0000ol0000n0003o`0003l000?o0000?@04oc/0000i00?o?P02och000?o0000
?@02ocd00olo0000?003ocd000?o0000>`000ol0000k00;o?003od80000o00?o>`02oc/000?o0000
>P000ol0000i00?oA@0004801?li00;o>@000ol0000h00;o>004odP0001600?o>0000ol0000f0003
o`0003H00_lg00?oC00004T00olf00;o=P000ol0000e0003o`0003@00om?0000C003ocD000?o0000
<`000ol0000c00;o=003oe80001?00?o<`02oc<000?o0000<P000ol0000a00?oE@0005801?la00;o
<@000ol0000`00;o<004oeP0001F00?o<0000ol0000^0003o`0002h00_l_00?oG00005T00ol^00;o
;P000ol0000]0003o`0002`00omO0000G003obd000?o0000:`000ol0000[00;o;003of80001O00Co
:P02ob/000?o0000:@02obX01?mU0000H`03obT00_lY0003o`0002P000?o00009`03ofT0001V00?o
:0000ol0000V0003o`0002H00_lW00?oK00006T00olV00;o9P000ol0000U0003o`0002@00om_0000
K003obD000?o00008`000ol0000S00;o9003og80001_00Co8P02ob<000?o00008@02ob801?me0000
L`03ob400_lQ0003o`00020000?o00007`03ogT0001f00?o80000ol0000N0003o`0001h00_lO00?o
O00007T00olN00;o7P000ol0000M0003o`0001`00omo0000O003oad000?o00006`000ol0000K00;o
7003oh80001o00Co6P02oa/000?o00006@02oaX01?n50000P`03oaT00_lI0003o`0001P000?o0000
5`03ohT0002600?o60000ol0000F0003o`0001H00_lG00?oS00008T00olF00;o5P000ol0000D00;o
5P03ohl0002<00Co50000ol0000C0003o`0001<000?o00004P04oi80002@00?o4P02oa<000?o0000
4@02oa800onF0000T`03oa400_lA0003o`00010000?o00003`03oiT0002F00?o40000ol0000>0003
o`0000h00_l?00?oW00009T00ol>00;o3P000ol0000<00;o3P03oil0002L00Co30000ol0000;0003
o`0000/000?o00002P04oj80002P00?o2P02o`/000?o00002@02o`X00onV0000X`03o`T00_l90003
o`0000P000?o00001`03ojT0002V00?o20000ol000060003o`0000H00_l700?o[0000:T01?l500;o
1P000ol0000400;o1@04ojl0002]00?o10000ol000030003o`0000<000?o00000P03ok<0002`00?o
0P02o`800ol200;o0P03okH0002c00?o00<0ool01Ol0103oooni0000]P09ok`0002g00Oo_@000;L0
1onm0000^005okh0002i00?o_`000?l0O0000?l0O0000001\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 3"],

Cell[TextData[{
  "Selective duplication 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.21799 .30902 L
s
.25889 .45617 m
.24526 .30902 L
s
.25889 .45617 m
.27252 .30902 L
s
.25889 .45617 m
.29978 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.21799 .30902 m
.21799 .16187 L
s
.02 w
.21799 .30902 Mdot
1 g
.21799 .16187 Mdot
.24526 .30902 Mdot
.27252 .30902 Mdot
0 g
0 w
.29978 .30902 m
.29978 .16187 L
s
.02 w
.29978 .30902 Mdot
1 g
.29978 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0007X000?o00003@000>l00_mh00;o40000?4000?o0000M0000ol0000@0000lP000ol0001b0003
o`000140003c0003o`00070000?o00004P000?@000?o0000K@02oaD0003e00;oK0000ol0000E0000
m`000ol0001X0003o`0001H0003h0003o`0006H000?o00005`000?T000?o0000I0000ol0000H0000
nP000ol0001Q00;o6`000?/00_mP0003o`0001/0003m0003o`0005`000?o000070000?h000?o0000
FP000ol0000M0000o`000ol0001H0003o`0001h0003o004000?o0000E@02ob40003o00800_mD0003
o`000240003o00@000?o0000D0000ol0000R0000o`050003o`0004h000?o00008`000?l01P000ol0
001;00;o9P000?l01`000ol000190003o`0002H0003o00P00_m80003o`0002L0003o00X000?o0000
A0000ol0000X0000o`0;0003o`00048000?o0000:@000?l030000ol0000o00;o;0000?l03@000ol0
000m0003o`0002`0003o00h000?o0000>`000ol0000]0000o`0?00;o>P000ol0000^0000o`0A0003
o`0003H000?o0000;`000?l04P000ol0000c00;o<P000?l04`000ol0000a0003o`000380003o01@0
00?o0000;`000ol0000c0000o`0E00;o;P000ol0000d0000o`0G0003o`0002T00_lg0000o`0H0003
o`0002L000?o0000=`000?l06@000ol0000U0003o`0003P0003o01X000?o00008`000ol0000i0000
o`0K00;o8P000ol0000j0000o`0M0003o`0001d00_lm0000o`0N0003o`0001/000?o0000?@000?l0
7`000ol0000I0003o`0003h0003o020000?o00005`000ol0000o0000o`0Q00;o5P000ol000100000
o`0S0003o`0001400_m30000o`0T0003o`0000l000?o0000@`000?l09@000ol0000=0003o`0004@0
003o02H000?o00002`000ol000150000o`0W00;o2@02odP0003o02T000?o00001@000ol000180000
o`0Z0003o`3o00;o00<0o`00BP000?l0:`05od`0003o02X01om;0000o`0Z00OoB`000?l0:P07od/0
003o02/01Om<0000o`0/00?oC@00058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0
002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P0
00?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0
001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0
001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C0000580
00?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0
000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0
002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P0
00?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0
001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0
001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C0000580
00?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0
000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0
002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P0
00?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0
001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0
001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C0000580
00?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0
000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C00005400olL00?o^003odd0
001@00Go6P05okH01Om<0000C`07oaP01ond00OoB`0004l01olH00Oo]007od/0001?00Oo6007ok@0
1om;0000D005oaX01Onf00GoC00005400olL00?o^003odd0001:0003o`0000H000?o00001`000ol0
00070003o`0000H000?o00001P000ol0001o0003o`0000d000?o000030000ol0000=0003o`0004h0
001:0003o`0000H000?o00001`000ol000070003o`0000H000?o00001P000ol0001o0003o`0000d0
00?o000030000ol0000=0003o`0004h0001;0003o`0000H000?o00001P000ol000070003o`0000H0
00?o00001P000ol000200003o`0000`000?o000030000ol0000=0003o`0004h0001;0003o`0000H0
00?o00001`000ol000050003o`0000H000?o00001P000ol000210003o`0000`000?o000030000ol0
000<0003o`0004l0001;0003o`0000H000?o00001`000ol000050003o`0000H000?o00001P000ol0
00210003o`0000`000?o000030000ol0000<0003o`0004l0001<0003o`0000D000?o00001`000ol0
00050003o`0000H000?o00001@000ol000230003o`0000/000?o000030000ol0000;0003o`000500
001<0003o`0000H000?o00001P000ol000050003o`0000D000?o00001P000ol000230003o`0000`0
00?o00002`000ol0000;0003o`000500001=0003o`0000D000?o00001P000ol000050003o`0000D0
00?o00001@000ol000250003o`0000/000?o00002P000ol0000;0003o`000540001=0003o`0000D0
00?o00001P000ol000050003o`0000D000?o00001@000ol000250003o`0000/000?o00002P000ol0
000;0003o`000540001>0003o`0000D000?o00001@000ol000050003o`0000D000?o000010000ol0
00270003o`0000X000?o00002P000ol0000:0003o`000580001>0003o`0000D000?o00001@000ol0
00050003o`0000@000?o00001@000ol000270003o`0000X000?o00002P000ol0000:0003o`000580
001?0003o`0000@000?o00001@000ol000050003o`0000@000?o00001@000ol000280003o`0000T0
00?o00002P000ol0000:0003o`000580001?0003o`0000@000?o00001@000ol000050003o`0000@0
00?o000010000ol000290003o`0000T000?o00002P000ol000090003o`0005<0001@0003o`0000@0
00?o000010000ol000050003o`0000@000?o000010000ol0002:0003o`0000T000?o00002@000ol0
00090003o`0005<0001@0003o`0000@000?o00001@000ol000030003o`0000@000?o000010000ol0
002;0003o`0000T000?o000020000ol000090003o`0005@0001A0003o`0000<000?o00001@000ol0
00030003o`0000@000?o000010000ol0002<0003o`0000P000?o000020000ol000090003o`0005@0
001A0003o`0000@000?o000010000ol000030003o`0000@000?o00000`000ol0002=0003o`0000P0
00?o000020000ol000080003o`0005D0001B0003o`0000<000?o000010000ol000030003o`0000@0
00?o00000`000ol0002>0003o`0000L000?o000020000ol000080003o`0005D0001B0003o`0000<0
00?o000010000ol000030003o`0000<000?o00000`000ol0002?0003o`0000L000?o000020000ol0
00070003o`0005H0001B0003o`0000<000?o000010000ol000030003o`0000<000?o00000`000ol0
002?0003o`0000P000?o00001`000ol000070003o`0005H0001C0003o`0000<000?o00000`000ol0
00030003o`0000<000?o00000`000ol0002@0003o`0000L000?o00001`000ol000070003o`0005H0
001C0003o`0000<000?o00000`000ol000030003o`00008000?o00000`000ol0002A0003o`0000L0
00?o00001P000ol000070003o`0005L0001D0003o`00008000?o00000`000ol000030003o`000080
00?o00000`000ol0002B0003o`0000H000?o00001P000ol000070003o`0005L0001D0003o`0000<0
00?o00000P000ol000030003o`00008000?o00000P000ol0002C0003o`0000H000?o00001P000ol0
00060003o`0005P0001E0003o`00008000?o00000P000ol000030003o`00008000?o00000P000ol0
002D0003o`0000D000?o00001P000ol000060003o`0005P0001E0003o`00008000?o00000`001Ol0
003o00@000?o00000P000ol0002E0003o`0000H000?o00001@000ol000050003o`0005T0001F0005
o`000?l01@001Ol0003o00@000?o00000P000ol0002F0003o`0000D000?o00001@000ol000050003
o`0005T0001F0003o`00008000?o00000P001Ol0003o00@000Go0000o`2I0003o`0000D000?o0000
1@000ol000040003o`0005X0001G0005o`000?l010001Ol0003o00@000Go0000o`2J0003o`0000@0
00?o000010000ol000050003o`0005X0001G0005o`000?l010001Ol0003o00<000Go0000o`2K0003
o`0000@000?o000010000ol000040003o`0005/0001H0005o`000?l00`001Ol0003o00<000Go0000
o`2L0003o`0000<000?o000010000ol000040003o`0005/0001H0005o`000?l00`001Ol0003o00<0
00Go0000o`2L0003o`0000@000?o00000`000ol000040003o`0005/0001H0005o`000?l00`001Ol0
003o008000Go0000o`2M0003o`0000@000?o00000`000ol000030003o`0005`0001I0004o`00o`<0
00Go0000o`020005o`000?l0WP000ol000030003o`0000<000?o00000`000ol0001L0000F@001Ol0
003o008000Go0000o`020004o`00oil000?o00000`000ol000030003o`00008000?o0000G@0005X0
00Co003o0P001Ol0003o008000Co003oX0000ol000020003o`00008000?o00000`000ol0001M0000
FP001?l00?l30003o`3o008000Co003oX@000ol000020003o`00008000?o00000P000ol0001N0000
F`001?l00?l20003o`3o008000Co003oXP000ol000020005o`000?l010000ol0001N0000F`001?l0
0?l20003o`3o008000?o0?l0X`000ol000020005o`000?l00`000ol0001O0000G0000ol0o`020003
o`3o008000?o0?l0Y0001Ol0003o00<000Go0000o`1Q0000G0000ol0o`020005o`3o0?l00P000ol0
002R0005o`000?l00`001Ol0003o0640001M000;o`3o0?l0o`3o0?l0YP001?l00?l30004o`00of80
001M000;o`3o0?l0o`3o0?l0YP001?l00?l20005o`000?l0HP0005h00_l01@3o0?l000;oZ0000ol0
o`020004o`00of<0001N0005o`3oo`000_l00`3o002W0006o`00o`3o0P000ol0001Q0000G`03o`04
0?ooojX000Oo0?l0o`3o06@0001O00?o00@0ooooZP001ol0o`3o0?l0I00005l00_l0103ooon[0004
o`3o00;oI@0006001On/00;o00<0ool0I@0006001On/00GoI@0005l01On]00GoI@0005h01on[00Oo
I00005h01on[00OoI00000d00_m?00OoZ`07odl00_lC00003`03odd01Ol00`3oo`2X00OoC@03oaD0
000B00?oB`03o`@00_nT00;o0`03od/00olH00005@03oe4000?o0000CP000ol0001?0003o`0004h0
0olK00006004odh00_m>0003o`0004d00_m=00Co7P0001`00om=0003o`0004/000?o0000B`02od`0
0olR00007`03od/00_m;0003o`0004X000?o0000B@03obD0000R00?oBP02odT000?o0000B002odT0
0olX00009@04odP000?o0000AP000ol000170003o`0004D01?l[0000:@03odH00_m60003o`0004D0
0_m500?o;`0002`00om50003o`0004<000?o0000@`02od@00olb0000;`03od<00_m30003o`000480
00?o0000@@03ocD0000b00?o@P02od4000?o0000@002od400olh0000=@04od0000?o0000?P000ol0
000o0003o`0003d01?lk0000>@03och00_ln0003o`0003d00_lm00?o?`0003`00olm0003o`0003/0
00?o0000>`02oc`00om20000?`03oc/00_lk0003o`0003X000?o0000>@03odD0001200Co>@02ocT0
00?o0000>002ocP01?m80000AP03ocP000?o0000=P000ol0000f00;o=`03od`0001900?o=P02ocH0
00?o0000=@000ol0000d00?oC`0004`00ole0003o`0003<000?o0000<`02oc@00omB0000C`03oc<0
0_lc0003o`00038000?o0000<@03oeD0001B00Co<@02oc4000?o0000<002oc001?mH0000EP03oc00
00?o0000;P000ol0000^00;o;`03oe`0001I00?o;P02obh000?o0000;@000ol0000/00?oG`0005`0
0ol]0003o`0002/000?o0000:`02ob`00omR0000G`04obX00_l[0003o`0002T00_lZ00CoI@0006<0
0olY00;o:@000ol0000X0003o`0002L00omY0000IP03obP000?o00009P000ol0000V00;o9`03of`0
001Y00?o9P02obH000?o00009@000ol0000T00?oK`0006`00olU0003o`0002<000?o00008`02ob@0
0omb0000K`04ob800_lS0003o`0002400_lR00CoM@0007<00olQ00;o8@000ol0000P0003o`0001l0
0omi0000MP03ob0000?o00007P000ol0000N00;o7`03og`0001i00?o7P02oah000?o00007@000ol0
000L00?oO`0007`00olM0003o`0001/000?o00006`02oa`00on20000O`04oaX00_lK0003o`0001T0
0_lJ00CoQ@0008<00olI00;o6@000ol0000H0003o`0001L00on90000QP03oaP000?o00005P000ol0
000F00;o5`03oh`0002900?o5P02oaH000?o00005002oaH00on?0000S004oa@000?o00004`000ol0
000C0003o`0001801?nB0000T003oa800_lC0003o`0001400_lB00?oUP0009<00olA00;o4@000ol0
000@0003o`0000l00onI0000UP03oa0000?o00003P000ol0000>00;o3`03oi`0002I00?o3P02o`h0
00?o00003002o`h00onO0000W004o``000?o00002`000ol0000;0003o`0000X01?nR0000X003o`X0
0_l;0003o`0000T00_l:00?oYP000:<00ol900;o2@000ol000080003o`0000L00onY0000YP03o`P0
00?o00001P000ol0000600;o1`03oj`0002Y00Co1@02o`H000?o00001002o`D01?n_0000[@03o`@0
00?o00000`000ol000030003o`0000800onc0000/003o`800_l200?o0P02o`800onf0000/`03o`03
0?oo00Go00@0oooo^@000;H02Onl0000]`07okd0002g00Oo_@000;P01Onn0000^@03okl0003o07`0
003o07`00000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 4"],

Cell[TextData[{
  "Selective duplication 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.68815 .30902 L
s
.72904 .45617 m
.71541 .30902 L
s
.72904 .45617 m
.74267 .30902 L
s
.72904 .45617 m
.76993 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.68815 .30902 Mdot
.71541 .30902 Mdot
0 g
0 w
.74267 .30902 m
.74267 .16187 L
s
.02 w
.74267 .30902 Mdot
0 w
.74267 .16187 m
.56367 .01472 L
s
.74267 .16187 m
.92167 .01472 L
s
1 g
.02 w
.56367 .01472 Mdot
.92167 .01472 Mdot
0 g
.74267 .16187 Mdot
1 g
.76993 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000=L000?o00004P000ol0001Y0003o`00018000?o00002`000=P000?o0000
4P000ol0001W0003o`00018000?o000030000=T000?o00004P000ol0001U0003o`00018000?o0000
3@000=X00_lC00;oH`02oa<00_l@0000g0000ol0000B0003o`0005l000?o00004P000ol0000@0000
g@000ol0000B0003o`0005d000?o00004P000ol0000A0000gP000ol0000B0003o`0005/000?o0000
4P000ol0000B0000g`02oa<000?o0000F@000ol0000A00;o5@000>4000?o00004@02oeL00_lC0003
o`0001D0003R0003o`00018000?o0000D`000ol0000B0003o`0001H0003S0003o`00018000?o0000
D@000ol0000B0003o`0001L0003T0003o`00018000?o0000C`000ol0000B0003o`0001P0003U00;o
4`000ol0001=0003o`0001400_lK0000i`000ol0000A00;oB`02oa<000?o00006`000>P000?o0000
4P000ol000170003o`00018000?o000070000>T000?o00004P000ol000150003o`00018000?o0000
7@000>X000?o00004P000ol000130003o`00018000?o00007P000>/00_lC0003o`00044000?o0000
4@02ob40003]0003o`0001400_lo00;o4`000ol0000Q0000kP000ol0000B0003o`0003/000?o0000
4P000ol0000R0000k`000ol0000B0003o`0003T000?o00004P000ol0000S0000l002oa<000?o0000
=`000ol0000A00;o9P000?8000?o00004@000ol0000e0003o`00014000?o00009P000?<000?o0000
4@02oc<00_lC0003o`0002L0003d0003o`00018000?o0000;`000ol0000B0003o`0002P0003e0003
o`00018000?o0000;@000ol0000B0003o`0002T0003f00;o4`000ol0000[0003o`0001400_l/0000
n0000ol0000A0003o`0002T000?o00004@000ol0000/0000n@000ol0000A0003o`0002L000?o0000
4@000ol0000]0000nP000ol0000A00;o9@02oa<000?o0000;P000?/000?o00004P000ol0000Q0003
o`00018000?o0000;`000?`00_lC0003o`0001l000?o00004@02oc80003n0003o`00014000?o0000
7@000ol0000A0003o`000380003o0003o`00014000?o00006`000ol0000A0003o`0003<0003o0040
00?o00004@02oaT00_lC0003o`0003@0003o00800_lC0003o`0001D000?o00004@02ocL0003o00@0
00?o00004@000ol0000C0003o`00014000?o0000=`000?l01@000ol0000A0003o`00014000?o0000
4@000ol0000h0000o`060003o`00014000?o00003`000ol0000A0003o`0003T0003o00L000?o0000
4@02o`d00_lC0003o`0003X0003o00P00_lC0003o`0000T000?o00004@02ocd0003o00X000?o0000
4@000ol000070003o`00014000?o0000?@000?l02`000ol0000A0003o`0000D000?o00004@000ol0
000n0000o`0<0003o`00014000?o00000`000ol0000A0003o`0003l0003o00d000?o00004@02o`03
0?oo01<000?o0000@0000?l03P02oa<000?o00004@02od<0003o010000?o00003`000ol0o`0A0003
o`0004<0003o014000?o00003@001Ol0003o00l000?o0000A0000?l04P000ol0000;0003o`0000<0
00?o00002`000ol000150000o`0C00;o2@02o`L00_l900;oB0000?l05@000ol000050003o`0000T0
00?o00001@000ol000180000o`0F0003o`3o00;o00<0o`0030000ol0o`02o`030?l004X0003o01L0
1Ol?00GoC0000?l05P07o`d01om;0000o`0F00Oo3@07od/0003o01H01ol=00OoB`000?l05`05o`l0
1Om<0000o`0H00?o4@03odd0001R0003o`000;<000?o00004@000ol0001<0000HP000ol0002c0003
o`00014000?o0000C000068000?o0000/`000ol0000A0003o`0004`0001R0003o`000;<000?o0000
4@000ol0001<0000HP000ol0002c0003o`00014000?o0000C000068000?o0000/`000ol0000A0003
o`0004`0001R0003o`000;<000?o00004@000ol0001<0000HP000ol0002c0003o`00014000?o0000
C000068000?o0000/`000ol0000A0003o`0004`0001R0003o`000;<000?o00004@000ol0001<0000
HP000ol0002c0003o`00014000?o0000C000068000?o0000/`000ol0000A0003o`0004`0001R0003
o`000;<000?o00004@000ol0001<0000HP000ol0002c0003o`00014000?o0000C000068000?o0000
/`000ol0000A0003o`0004`0001R0003o`000;<000?o00004@000ol0001<0000HP000ol0002c0003
o`00014000?o0000C000068000?o0000/`000ol0000A0003o`0004`0001R0003o`000;<000?o0000
4@000ol0001<0000HP000ol0002c0003o`00014000?o0000C000068000?o0000/`000ol0000A0003
o`0004`0001R0003o`000;<000?o00004@000ol0001<0000HP000ol0002c0003o`00014000?o0000
C000068000?o0000/`000ol0000A0003o`0004`0001R0003o`000;<000?o00004@000ol0001<0000
HP000ol0002c0003o`00014000?o0000C000068000?o0000/`000ol0000A0003o`0004`0001R0003
o`000;<000?o00004@000ol0001<0000HP000ol0002c0003o`00014000?o0000C000068000?o0000
/`000ol0000A0003o`0004`0001R0003o`000;<000?o00004@000ol0001<0000HP000ol0002c0003
o`00014000?o0000C000068000?o0000/`000ol0000A0003o`0004`0001R0003o`000;<000?o0000
4@000ol0001<0000HP000ol0002c0003o`00014000?o0000C000068000?o0000/`000ol0000A0003
o`0004`0001R0003o`000;<000?o00004@000ol0001<0000HP000ol0002c0003o`00014000?o0000
C000068000?o0000/`000ol0000A0003o`0004`0001R0003o`000;<000?o00004@000ol0001<0000
HP000ol0002c0003o`00014000?o0000C000068000?o0000/`000ol0000A0003o`0004`0001R0003
o`000;<000?o00004@000ol0001<0000HP000ol0002c0003o`00014000?o0000C000068000?o0000
/`000ol0000A0003o`0004`0001R0003o`000;<000?o00004@000ol0001<0000HP000ol0002c0003
o`00014000?o0000C000068000?o0000/`000ol0000A0003o`0004`0001P00?o]003oa400om=0000
G`05ok801Ol?00GoC00005h01on`00Oo3@07od/0001N00Oo/007o`d01om;0000GP07ok001ol=00Oo
B`0005l01Onb00Go3`05od`0001P00?o]003oa400om=0000BP000ol0000E0003o`0001@000?o0000
O`000ol000060003o`0000L000?o00001`000ol000060003o`0000H000?o0000CP0004X000?o0000
5@000ol0000D0003o`0007l000?o00001P000ol000070003o`0000L000?o00001P000ol000060003
o`0004h0001;0003o`0001@000?o000050000ol000200003o`0000H000?o00001P000ol000070003
o`0000H000?o00001P000ol0001>0000B`000ol0000D0003o`0001<000?o0000P@000ol000060003
o`0000L000?o00001@000ol000060003o`0000H000?o0000C`0004/000?o000050000ol0000C0003
o`00084000?o00001P000ol000070003o`0000D000?o00001P000ol000060003o`0004l0001<0003
o`0001<000?o00004P000ol000230003o`0000D000?o00001`000ol000050003o`0000H000?o0000
1@000ol0001@0000C0000ol0000C0003o`00018000?o0000P`000ol000060003o`0000H000?o0000
1@000ol000050003o`0000H000?o0000D00004d000?o00004P000ol0000A0003o`0008D000?o0000
1@000ol000060003o`0000D000?o00001@000ol000050003o`000540001=0003o`00018000?o0000
4@000ol000250003o`0000D000?o00001P000ol000050003o`0000D000?o00001@000ol0001A0000
CP000ol0000A0003o`00010000?o0000Q`000ol000050003o`0000D000?o00001@000ol000050003
o`0000@000?o0000DP0004h000?o00004@000ol0000@0003o`0008L000?o00001@000ol000050003
o`0000D000?o000010000ol000050003o`000580001?0003o`00010000?o000040000ol000280003
o`0000@000?o00001@000ol000050003o`0000@000?o00001@000ol0001B0000C`000ol0000@0003
o`0000l000?o0000R@000ol000040003o`0000D000?o00001@000ol000040003o`0000@000?o0000
D`00050000?o00003`000ol0000?0003o`0008X000?o000010000ol000040003o`0000D000?o0000
10000ol000040003o`0005<0001@0003o`0000l000?o00003P000ol0002;0003o`0000@000?o0000
1@000ol000030003o`0000@000?o000010000ol0001D0000D@000ol0000>0003o`0000h000?o0000
S0000ol000030003o`0000D000?o00000`000ol000040003o`0000@000?o0000E000054000?o0000
3P000ol0000=0003o`0008d000?o000010000ol000040003o`0000<000?o000010000ol000030003
o`0005D0001B0003o`0000d000?o00003@000ol0002>0003o`0000<000?o000010000ol000030003
o`0000@000?o00000`000ol0001E0000DP000ol0000=0003o`0000`000?o0000S`000ol000030003
o`0000@000?o00000`000ol000030003o`0000<000?o0000EP00058000?o00003@000ol0000<0003
o`0008l000?o00000`000ol000040003o`0000<000?o00000`000ol000030003o`0005H0001C0003
o`0000`000?o000030000ol0002@0003o`0000<000?o00000`000ol000030003o`0000<000?o0000
0`000ol0001F0000D`000ol0000<0003o`0000/000?o0000T@000ol000030003o`0000<000?o0000
0`000ol000020003o`0000<000?o0000E`0005@000?o00002`000ol0000;0003o`00098000?o0000
0P000ol000030003o`0000<000?o00000P000ol000030003o`0005L0001D0003o`0000/000?o0000
2P000ol0002C0003o`0000<000?o00000P000ol000030003o`00008000?o00000P000ol0001H0000
E@000ol0000:0003o`0000X000?o0000U0000ol000020003o`00008000?o00000`000ol000020003
o`00008000?o0000F00005D000?o00002P000ol000090003o`0009D000?o00000P000ol000030005
o`000?l010000ol000020003o`0005T0001F0003o`0000T000?o00002@000ol0002F0005o`000?l0
1@001Ol0003o00@000?o00000P000ol0001I0000EP000ol000090003o`0000P000?o0000U`000ol0
00020003o`00008000Go0000o`040005o`000?l0G00005L000?o000020000ol000080003o`0009P0
00Go0000o`040005o`000?l010001Ol0003o05`0001G0003o`0000P000?o00001`000ol0002I0005
o`000?l010001Ol0003o00<000Go0000o`1M0000F0000ol000070003o`0000L000?o0000VP001Ol0
003o00<000Go0000o`030005o`000?l0G@0005P000?o00001`000ol000070003o`0009X000Go0000
o`030005o`000?l00`001Ol0003o05d0001H0003o`0000L000?o00001P000ol0002K0005o`000?l0
0`001Ol0003o008000Go0000o`1N0000F@000ol000060003o`0000H000?o0000W0001?l00?l30005
o`000?l00P001Ol0003o05h0001I0003o`0000H000?o00001@000ol0002M0005o`000?l00P001Ol0
003o008000Co003oG`0005X000?o00001@000ol000050003o`0009h000Co003o0P001Ol0003o0080
00Co003oG`0005X000?o00001@000ol000040003o`0009l000Co003o0`000ol0o`020004o`00of00
001K0003o`0000@000?o000010000ol0002P0004o`00o`8000?o0?l00P001?l00?mP0000F`000ol0
00040003o`0000<000?o0000X@001?l00?l20003o`3o008000?o0?l0H@0005`000?o00000`000ol0
00030003o`000:8000?o0?l00P000ol0o`020003o`3o0640001L0003o`0000<000?o00000`000ol0
002R0003o`3o008000Go0?l0o`020003o`0005l0001M0003o`00008000?o00000P000ol0002T000;
o`3o0?l0o`3o0?l0HP0005d000?o00000P000ol000020003o`000:@000_o0?l0o`3o0?l0o`1R0000
GP001Ol0003o00<000?o0000YP02o`050?l0o`000_mS0000GP001Ol0003o00<000?o0000YP001Ol0
ool000;o00<0o`00HP0005l000Co003o0P000ol0002X00?o00@0ooooI00005l000Co003o0P000ol0
002X00?o00@0ooooI00005l000Ko003o0?n[00;o00@0ooooI@00060000Go0?l0o`2/00GoI@000600
0ol00`3o002[00GoI@0005l01On]00GoI@0005h01on[00OoI00005h01on[00OoI00000d00_m?00Oo
Z`07odl00_lC00003`03odd01Ol00`3oo`2X00OoC@03oaD0000B00?oB`03o`@00_nT00;o0`03od/0
0olH00005@03oe4000?o0000CP000ol0001?0003o`0004h00olK00006004odh00_m>0003o`0004d0
0_m=00Co7P0001`00om=0003o`0004/000?o0000B`02od`00olR00007`03od/00_m;0003o`0004X0
00?o0000B@03obD0000R00?oBP02odT000?o0000B002odT00olX00009@04odP000?o0000AP000ol0
00170003o`0004D01?l[0000:@03odH00_m60003o`0004D00_m500?o;`0002`00om50003o`0004<0
00?o0000@`02od@00olb0000;`03od<00_m30003o`00048000?o0000@@03ocD0000b00?o@P02od40
00?o0000@002od400olh0000=@04od0000?o0000?P000ol0000o0003o`0003d01?lk0000>@03och0
0_ln0003o`0003d00_lm00?o?`0003`00olm0003o`0003/000?o0000>`02oc`00om20000?`03oc/0
0_lk0003o`0003X000?o0000>@03odD0001200Co>@02ocT000?o0000>002ocP01?m80000AP03ocP0
00?o0000=P000ol0000f00;o=`03od`0001900?o=P02ocH000?o0000=@000ol0000d00?oC`0004`0
0ole0003o`0003<000?o0000<`02oc@00omB0000C`03oc<00_lc0003o`00038000?o0000<@03oeD0
001B00Co<@02oc4000?o0000<002oc001?mH0000EP03oc0000?o0000;P000ol0000^00;o;`03oe`0
001I00?o;P02obh000?o0000;@000ol0000/00?oG`0005`00ol]0003o`0002/000?o0000:`02ob`0
0omR0000G`04obX00_l[0003o`0002T00_lZ00CoI@0006<00olY00;o:@000ol0000X0003o`0002L0
0omY0000IP03obP000?o00009P000ol0000V00;o9`03of`0001Y00?o9P02obH000?o00009@000ol0
000T00?oK`0006`00olU0003o`0002<000?o00008`02ob@00omb0000K`04ob800_lS0003o`000240
0_lR00CoM@0007<00olQ00;o8@000ol0000P0003o`0001l00omi0000MP03ob0000?o00007P000ol0
000N00;o7`03og`0001i00?o7P02oah000?o00007@000ol0000L00?oO`0007`00olM0003o`0001/0
00?o00006`02oa`00on20000O`04oaX00_lK0003o`0001T00_lJ00CoQ@0008<00olI00;o6@000ol0
000H0003o`0001L00on90000QP03oaP000?o00005P000ol0000F00;o5`03oh`0002900?o5P02oaH0
00?o00005002oaH00on?0000S004oa@000?o00004`000ol0000C0003o`0001801?nB0000T003oa80
0_lC0003o`0001400_lB00?oUP0009<00olA00;o4@000ol0000@0003o`0000l00onI0000UP03oa00
00?o00003P000ol0000>00;o3`03oi`0002I00?o3P02o`h000?o00003002o`h00onO0000W004o``0
00?o00002`000ol0000;0003o`0000X01?nR0000X003o`X00_l;0003o`0000T00_l:00?oYP000:<0
0ol900;o2@000ol000080003o`0000L00onY0000YP03o`P000?o00001P000ol0000600;o1`03oj`0
002Y00Co1@02o`H000?o00001002o`D01?n_0000[@03o`@000?o00000`000ol000030003o`000080
0onc0000/003o`800_l200?o0P02o`800onf0000/`03o`030?oo00Go00@0oooo^@000;H02Onl0000
]`07okd0002g00Oo_@000;P01Onn0000^@03okl0003o07`0003o07`00000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 5"],

Cell[TextData[{
  "Selective duplication 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 6",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.21799 .30902 L
s
.25889 .45617 m
.24526 .30902 L
s
.25889 .45617 m
.27252 .30902 L
s
.25889 .45617 m
.29978 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.21799 .30902 m
.21799 .16187 L
s
.02 w
.21799 .30902 Mdot
1 g
.21799 .16187 Mdot
.24526 .30902 Mdot
.27252 .30902 Mdot
0 g
0 w
.29978 .30902 m
.29978 .16187 L
s
.02 w
.29978 .30902 Mdot
1 g
.29978 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0007X000?o00003@000>l00_mh00;o40000?4000?o0000M0000ol0000@0000lP000ol0001b0003
o`000140003c0003o`00070000?o00004P000?@000?o0000K@02oaD0003e00;oK0000ol0000E0000
m`000ol0001X0003o`0001H0003h0003o`0006H000?o00005`000?T000?o0000I0000ol0000H0000
nP000ol0001Q00;o6`000?/00_mP0003o`0001/0003m0003o`0005`000?o000070000?h000?o0000
FP000ol0000M0000o`000ol0001H0003o`0001h0003o004000?o0000E@02ob40003o00800_mD0003
o`000240003o00@000?o0000D0000ol0000R0000o`050003o`0004h000?o00008`000?l01P000ol0
001;00;o9P000?l01`000ol000190003o`0002H0003o00P00_m80003o`0002L0003o00X000?o0000
A0000ol0000X0000o`0;0003o`00048000?o0000:@000?l030000ol0000o00;o;0000?l03@000ol0
000m0003o`0002`0003o00h000?o0000>`000ol0000]0000o`0?00;o>P000ol0000^0000o`0A0003
o`0003H000?o0000;`000?l04P000ol0000c00;o<P000?l04`000ol0000a0003o`000380003o01@0
00?o0000;`000ol0000c0000o`0E00;o;P000ol0000d0000o`0G0003o`0002T00_lg0000o`0H0003
o`0002L000?o0000=`000?l06@000ol0000U0003o`0003P0003o01X000?o00008`000ol0000i0000
o`0K00;o8P000ol0000j0000o`0M0003o`0001d00_lm0000o`0N0003o`0001/000?o0000?@000?l0
7`000ol0000I0003o`0003h0003o020000?o00005`000ol0000o0000o`0Q00;o5P000ol000100000
o`0S0003o`0001400_m30000o`0T0003o`0000l000?o0000@`000?l09@000ol0000=0003o`0004@0
003o02H000?o00002`000ol000150000o`0W00;o2@02odP0003o02T000?o00001@000ol000180000
o`0Z0003o`3o00;o00<0o`00BP000?l0:`05od`0003o02X01om;0000o`0Z00OoB`000?l0:P07od/0
003o02/01Om<0000o`0/00?oC@00058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0
002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P0
00?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0
001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0
001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C0000580
00?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0
000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0
002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P0
00?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0
001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0
001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C0000580
00?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0
000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0
002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P0
00?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0
001<0000DP000ol0000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0
001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C0000580
00?o000070000ol0002h0003o`0004`0001B0003o`0001`000?o0000^0000ol0001<0000DP000ol0
000L0003o`000;P000?o0000C000058000?o000070000ol0002h0003o`0004`0001B0003o`0001`0
00?o0000^0000ol0001<0000DP000ol0000L0003o`000;P000?o0000C00005400olL00?o^003odd0
001@00Go6P05okH01Om<0000C`07oaP01ond00OoB`0004l01olH00Oo]007od/0001?00Oo6007ok@0
1om;0000D005oaX01Onf00GoC00005400olL00?o^003odd0001:0003o`0000H000?o00001`000ol0
00070003o`0000H000?o00001P000ol0001o0003o`0000d000?o000030000ol0000=0003o`0004h0
001:0003o`0000H000?o00001`000ol000070003o`0000H000?o00001P000ol0001o0003o`0000d0
00?o000030000ol0000=0003o`0004h0001;0003o`0000H000?o00001P000ol000070003o`0000H0
00?o00001P000ol000200003o`0000`000?o000030000ol0000=0003o`0004h0001;0003o`0000H0
00?o00001`000ol000050003o`0000H000?o00001P000ol000210003o`0000`000?o000030000ol0
000<0003o`0004l0001;0003o`0000H000?o00001`000ol000050003o`0000H000?o00001P000ol0
00210003o`0000`000?o000030000ol0000<0003o`0004l0001<0003o`0000D000?o00001`000ol0
00050003o`0000H000?o00001@000ol000230003o`0000/000?o000030000ol0000;0003o`000500
001<0003o`0000H000?o00001P000ol000050003o`0000D000?o00001P000ol000230003o`0000`0
00?o00002`000ol0000;0003o`000500001=0003o`0000D000?o00001P000ol000050003o`0000D0
00?o00001@000ol000250003o`0000/000?o00002P000ol0000;0003o`000540001=0003o`0000D0
00?o00001P000ol000050003o`0000D000?o00001@000ol000250003o`0000/000?o00002P000ol0
000;0003o`000540001>0003o`0000D000?o00001@000ol000050003o`0000D000?o000010000ol0
00270003o`0000X000?o00002P000ol0000:0003o`000580001>0003o`0000D000?o00001@000ol0
00050003o`0000@000?o00001@000ol000270003o`0000X000?o00002P000ol0000:0003o`000580
001?0003o`0000@000?o00001@000ol000050003o`0000@000?o00001@000ol000280003o`0000T0
00?o00002P000ol0000:0003o`000580001?0003o`0000@000?o00001@000ol000050003o`0000@0
00?o000010000ol000290003o`0000T000?o00002P000ol000090003o`0005<0001@0003o`0000@0
00?o000010000ol000050003o`0000@000?o000010000ol0002:0003o`0000T000?o00002@000ol0
00090003o`0005<0001@0003o`0000@000?o00001@000ol000030003o`0000@000?o000010000ol0
002;0003o`0000T000?o000020000ol000090003o`0005@0001A0003o`0000<000?o00001@000ol0
00030003o`0000@000?o000010000ol0002<0003o`0000P000?o000020000ol000090003o`0005@0
001A0003o`0000@000?o000010000ol000030003o`0000@000?o00000`000ol0002=0003o`0000P0
00?o000020000ol000080003o`0005D0001B0003o`0000<000?o000010000ol000030003o`0000@0
00?o00000`000ol0002>0003o`0000L000?o000020000ol000080003o`0005D0001B0003o`0000<0
00?o000010000ol000030003o`0000<000?o00000`000ol0002?0003o`0000L000?o000020000ol0
00070003o`0005H0001B0003o`0000<000?o000010000ol000030003o`0000<000?o00000`000ol0
002?0003o`0000P000?o00001`000ol000070003o`0005H0001C0003o`0000<000?o00000`000ol0
00030003o`0000<000?o00000`000ol0002@0003o`0000L000?o00001`000ol000070003o`0005H0
001C0003o`0000<000?o00000`000ol000030003o`00008000?o00000`000ol0002A0003o`0000L0
00?o00001P000ol000070003o`0005L0001D0003o`00008000?o00000`000ol000030003o`000080
00?o00000`000ol0002B0003o`0000H000?o00001P000ol000070003o`0005L0001D0003o`0000<0
00?o00000P000ol000030003o`00008000?o00000P000ol0002C0003o`0000H000?o00001P000ol0
00060003o`0005P0001E0003o`00008000?o00000P000ol000030003o`00008000?o00000P000ol0
002D0003o`0000D000?o00001P000ol000060003o`0005P0001E0003o`00008000?o00000`001Ol0
003o00@000?o00000P000ol0002E0003o`0000H000?o00001@000ol000050003o`0005T0001F0005
o`000?l01@001Ol0003o00@000?o00000P000ol0002F0003o`0000D000?o00001@000ol000050003
o`0005T0001F0003o`00008000?o00000P001Ol0003o00@000Go0000o`2I0003o`0000D000?o0000
1@000ol000040003o`0005X0001G0005o`000?l010001Ol0003o00@000Go0000o`2J0003o`0000@0
00?o000010000ol000050003o`0005X0001G0005o`000?l010001Ol0003o00<000Go0000o`2K0003
o`0000@000?o000010000ol000040003o`0005/0001H0005o`000?l00`001Ol0003o00<000Go0000
o`2L0003o`0000<000?o000010000ol000040003o`0005/0001H0005o`000?l00`001Ol0003o00<0
00Go0000o`2L0003o`0000@000?o00000`000ol000040003o`0005/0001H0005o`000?l00`001Ol0
003o008000Go0000o`2M0003o`0000@000?o00000`000ol000030003o`0005`0001I0004o`00o`<0
00Go0000o`020005o`000?l0WP000ol000030003o`0000<000?o00000`000ol0001L0000F@001Ol0
003o008000Go0000o`020004o`00oil000?o00000`000ol000030003o`00008000?o0000G@0005X0
00Co003o0P001Ol0003o008000Co003oX0000ol000020003o`00008000?o00000`000ol0001M0000
FP001?l00?l30003o`3o008000Co003oX@000ol000020003o`00008000?o00000P000ol0001N0000
F`001?l00?l20003o`3o008000Co003oXP000ol000020005o`000?l010000ol0001N0000F`001?l0
0?l20003o`3o008000?o0?l0X`000ol000020005o`000?l00`000ol0001O0000G0000ol0o`020003
o`3o008000?o0?l0Y0001Ol0003o00<000Go0000o`1Q0000G0000ol0o`020005o`3o0?l00P000ol0
002R0005o`000?l00`001Ol0003o0640001M000;o`3o0?l0o`3o0?l0YP001?l00?l30004o`00of80
001M000;o`3o0?l0o`3o0?l0YP001?l00?l20005o`000?l0HP0005h00_l01@3o0?l000;oZ0000ol0
o`020004o`00of<0001N0005o`3oo`000_l00`3o002W0006o`00o`3o0P000ol0001Q0000G`03o`04
0?ooojX000Oo0?l0o`3o06@0001O00?o00@0ooooZP001ol0o`3o0?l0I00005l00_l0103ooon[0004
o`3o00;oI@0006001On/00;o00<0ool0I@0006001On/00GoI@0005l01On]00GoI@0005h01on[00Oo
I00005h01on[00OoI00000d00_m?00OoZ`07odl00_lC00003`03odd01Ol00`3oo`2X00OoC@03oaD0
000B00?oB`03o`@00_nT00;o0`03od/00olH00005@03oe4000?o0000CP000ol0001?0003o`0004h0
0olK00006004odh00_m>0003o`0004d00_m=00Co7P0001`00om=0003o`0004/000?o0000B`02od`0
0olR00007`03od/00_m;0003o`0004X000?o0000B@03obD0000R00?oBP02odT000?o0000B002odT0
0olX00009@04odP000?o0000AP000ol000170003o`0004D01?l[0000:@03odH00_m60003o`0004D0
0_m500?o;`0002`00om50003o`0004<000?o0000@`02od@00olb0000;`03od<00_m30003o`000480
00?o0000@@03ocD0000b00?o@P02od4000?o0000@002od400olh0000=@04od0000?o0000?P000ol0
000o0003o`0003d01?lk0000>@03och00_ln0003o`0003d00_lm00?o?`0003`00olm0003o`0003/0
00?o0000>`02oc`00om20000?`03oc/00_lk0003o`0003X000?o0000>@03odD0001200Co>@02ocT0
00?o0000>002ocP01?m80000AP03ocP000?o0000=P000ol0000f00;o=`03od`0001900?o=P02ocH0
00?o0000=@000ol0000d00?oC`0004`00ole0003o`0003<000?o0000<`02oc@00omB0000C`03oc<0
0_lc0003o`00038000?o0000<@03oeD0001B00Co<@02oc4000?o0000<002oc001?mH0000EP03oc00
00?o0000;P000ol0000^00;o;`03oe`0001I00?o;P02obh000?o0000;@000ol0000/00?oG`0005`0
0ol]0003o`0002/000?o0000:`02ob`00omR0000G`04obX00_l[0003o`0002T00_lZ00CoI@0006<0
0olY00;o:@000ol0000X0003o`0002L00omY0000IP03obP000?o00009P000ol0000V00;o9`03of`0
001Y00?o9P02obH000?o00009@000ol0000T00?oK`0006`00olU0003o`0002<000?o00008`02ob@0
0omb0000K`04ob800_lS0003o`0002400_lR00CoM@0007<00olQ00;o8@000ol0000P0003o`0001l0
0omi0000MP03ob0000?o00007P000ol0000N00;o7`03og`0001i00?o7P02oah000?o00007@000ol0
000L00?oO`0007`00olM0003o`0001/000?o00006`02oa`00on20000O`04oaX00_lK0003o`0001T0
0_lJ00CoQ@0008<00olI00;o6@000ol0000H0003o`0001L00on90000QP03oaP000?o00005P000ol0
000F00;o5`03oh`0002900?o5P02oaH000?o00005002oaH00on?0000S004oa@000?o00004`000ol0
000C0003o`0001801?nB0000T003oa800_lC0003o`0001400_lB00?oUP0009<00olA00;o4@000ol0
000@0003o`0000l00onI0000UP03oa0000?o00003P000ol0000>00;o3`03oi`0002I00?o3P02o`h0
00?o00003002o`h00onO0000W004o``000?o00002`000ol0000;0003o`0000X01?nR0000X003o`X0
0_l;0003o`0000T00_l:00?oYP000:<00ol900;o2@000ol000080003o`0000L00onY0000YP03o`P0
00?o00001P000ol0000600;o1`03oj`0002Y00Co1@02o`H000?o00001002o`D01?n_0000[@03o`@0
00?o00000`000ol000030003o`0000800onc0000/003o`800_l200?o0P02o`800onf0000/`03o`03
0?oo00Go00@0oooo^@000;H02Onl0000]`07okd0002g00Oo_@000;P01Onn0000^@03okl0003o07`0
003o07`00000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 6"],

Cell[TextData[{
  "Selective duplication 6: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 7",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.6836 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.72904 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.77447 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.6836 .30902 Mdot
.70632 .30902 Mdot
.72904 .30902 Mdot
.75175 .30902 Mdot
.77447 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0007X000?o00003@000>l00_mh00;o40000?4000?o0000M0000ol0000@0000lP000ol0001b0003
o`000140003c0003o`00070000?o00004P000?@000?o0000K@02oaD0003e00;oK0000ol0000E0000
m`000ol0001X0003o`0001H0003h0003o`0006H000?o00005`000?T000?o0000I0000ol0000H0000
nP000ol0001Q00;o6`000?/00_mP0003o`0001/0003m0003o`0005`000?o000070000?h000?o0000
FP000ol0000M0000o`000ol0001H0003o`0001h0003o004000?o0000E@02ob40003o00800_mD0003
o`000240003o00@000?o0000D0000ol0000R0000o`050003o`0004h000?o00008`000?l01P000ol0
001;00;o9P000?l01`000ol000190003o`0002H0003o00P00_m80003o`0002L0003o00X000?o0000
A0000ol0000X0000o`0;0003o`00048000?o0000:@000?l030000ol0000o00;o;0000?l03@000ol0
000m0003o`0002`0003o00h000?o0000>`000ol0000]0000o`0?00;o>P000ol0000^0000o`0A0003
o`0003H000?o0000;`000?l04P000ol0000c00;o<P000?l04`000ol0000a0003o`000380003o01@0
00?o0000;`000ol0000c0000o`0E00;o;P000ol0000d0000o`0G0003o`0002T00_lg0000o`0H0003
o`0002L000?o0000=`000?l06@000ol0000U0003o`0003P0003o01X000?o00008`000ol0000i0000
o`0K00;o8P000ol0000j0000o`0M0003o`0001d00_lm0000o`0N0003o`0001/000?o0000?@000?l0
7`000ol0000I0003o`0003h0003o020000?o00005`000ol0000o0000o`0Q00;o5P000ol000100000
o`0S0003o`0001400_m30000o`0T0003o`0000l000?o0000@`000?l09@000ol0000=0003o`0004@0
003o02H000?o00002`000ol000150000o`0W00;o2@02odP0003o02T000?o00001@000ol000180000
o`0Z0003o`3o00;o00<0o`00BP000?l0:`05od`0003o02X01om;0000o`0Z00OoB`000?l0:P07od/0
003o02/01Om<0000o`0/00?oC@00068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C000068000?o0000a`000ol0001<0000HP000ol000370003o`0004`0
001R0003o`000<L000?o0000C00006000oo800?oC@0005l01Oo600GoC00005h01oo400OoB`0005h0
1oo400OoB`0005h01oo400OoB`0005l01Oo600GoC00006000onP0003o`0002D00om=0000BP000ol0
000E0003o`0001@000?o0000O`000ol000050003o`0000D000?o00001@000ol000040003o`0000H0
00?o000010000ol0001>0000BP000ol0000E0003o`0001@000?o0000O`000ol000050003o`0000D0
00?o00001@000ol000040003o`0000H000?o000010000ol0001>0000B`000ol0000D0003o`0001@0
00?o0000P0000ol000050003o`0000@000?o00001@000ol000040003o`0000D000?o00001@000ol0
001>0000B`000ol0000D0003o`0001<000?o0000P@000ol000050003o`0000@000?o00001@000ol0
00040003o`0000D000?o000010000ol0001?0000B`000ol0000D0003o`0001<000?o0000P@000ol0
00050003o`0000@000?o00001@000ol000040003o`0000D000?o000010000ol0001?0000C0000ol0
000C0003o`00018000?o0000P`000ol000050003o`0000<000?o00001@000ol000040003o`0000@0
00?o000010000ol0001@0000C0000ol0000C0003o`00018000?o0000P`000ol000050003o`0000@0
00?o000010000ol000040003o`0000@000?o000010000ol0001@0000C@000ol0000B0003o`000140
00?o0000Q@000ol000040003o`0000@000?o000010000ol000030003o`0000D000?o00000`000ol0
001A0000C@000ol0000B0003o`00014000?o0000Q@000ol000040003o`0000@000?o000010000ol0
00030003o`0000D000?o00000`000ol0001A0000CP000ol0000A0003o`00010000?o0000Q`000ol0
00040003o`0000<000?o000010000ol000030003o`0000@000?o00000`000ol0001B0000CP000ol0
000A0003o`00010000?o0000Q`000ol000040003o`0000<000?o000010000ol000030003o`0000@0
00?o00000`000ol0001B0000C`000ol0000@0003o`00010000?o0000R0000ol000030003o`0000<0
00?o000010000ol000030003o`0000@000?o00000`000ol0001B0000C`000ol0000@0003o`0000l0
00?o0000R@000ol000040003o`00008000?o000010000ol000030003o`0000<000?o00000`000ol0
001C0000D0000ol0000?0003o`0000l000?o0000RP000ol000030003o`0000<000?o00000`000ol0
00030003o`0000<000?o00000`000ol0001C0000D0000ol0000?0003o`0000h000?o0000R`000ol0
00030003o`0000<000?o00000`000ol000020003o`0000@000?o00000P000ol0001D0000D@000ol0
000>0003o`0000h000?o0000S0000ol000030003o`00008000?o00000`000ol000020003o`0000<0
00?o00000`000ol0001D0000D@000ol0000>0003o`0000d000?o0000S@000ol000030003o`000080
00?o00000`000ol000020003o`0000<000?o00000P000ol0001E0000DP000ol0000=0003o`0000d0
00?o0000SP000ol000020003o`00008000?o00000`000ol000020003o`0000<000?o00000P000ol0
001E0000DP000ol0000=0003o`0000`000?o0000S`000ol000030005o`000?l01@000ol000020003
o`00008000?o00000P000ol0001F0000DP000ol0000=0003o`0000`000?o0000S`000ol000030003
o`00008000?o00000P000ol000020003o`00008000?o00000P000ol0001F0000D`000ol0000<0003
o`0000`000?o0000T0000ol000020003o`00008000?o00000P000ol000020003o`00008000?o0000
0P000ol0001F0000D`000ol0000<0003o`0000/000?o0000T@000ol000020003o`00008000?o0000
0P001Ol0003o00D000Go0000o`1I0000E0000ol0000;0003o`0000/000?o0000TP000ol000020005
o`000?l010001Ol0003o00@000?o00000P000ol0001G0000E0000ol0000;0003o`0000X000?o0000
T`000ol000020005o`000?l010001Ol0003o00@000Go0000o`1J0000E@000ol0000:0003o`0000X0
00?o0000U0001Ol0003o00<000?o00000P001Ol0003o00@000Go0000o`1J0000E@000ol0000:0003
o`0000T000?o0000U@000ol000020005o`000?l00`001Ol0003o00<000Go0000o`1K0000EP000ol0
00090003o`0000T000?o0000UP001Ol0003o00<000Go0000o`030005o`000?l00`000ol0001I0000
EP000ol000090003o`0000P000?o0000U`001Ol0003o00<000Go0000o`030005o`000?l00P000ol0
001J0000E`000ol000080003o`0000P000?o0000V0001Ol0003o008000Go0000o`020005o`000?l0
0`000ol0001J0000E`000ol000080003o`0000L000?o0000V@001Ol0003o008000Go0000o`020005
o`000?l00P000ol0001K0000F0000ol000070003o`0000L000?o0000VP001?l00?l20005o`000?l0
0P001Ol0003o008000?o0000F`0005P000?o00001`000ol000070003o`0009X000Co003o0`001?l0
0?l20005o`000?l00P000ol0001K0000F0000ol000070003o`0000H000?o0000V`001Ol0003o0080
00Co003o0P001?l00?l20003o`0005`0001I0003o`0000H000?o00001P000ol0002L0004o`00o`80
00Co003o0P001?l00?l20003o`0005`0001I0003o`0000H000?o00001@000ol0002M0004o`00o`80
00Co003o0P001_l00?l0oel0001J0003o`0000D000?o00001@000ol0002N0006o`00o`3o0P000ol0
o`020004o`00oel0001J0003o`0000D000?o000010000ol0002O0006o`00o`3o0P000ol0o`020003
o`3o0600001K0003o`0000@000?o000010000ol0002P0003o`3o008000Go0?l0o`020003o`3o0600
001K0003o`0000@000?o00000`000ol0002Q000>o`00o`3o0?l0o`3o0?mQ0000G0000ol000030003
o`0000<000?o0000XP003Ol0o`3o0?l0o`3o0?l0H@0005`000?o00000`000ol000030003o`000:80
00go0?l0o`3o0?l0o`3o0640001M0003o`00008000?o00000P000ol0002T0007o`3oo`3o0002o`03
0?l00640001M0003o`00008000?o00000P000ol0002T0005o`3oo`000_l0103o0?mR0000GP001Ol0
003o00<000?o0000YP03o`040?oo00;oH`0005h000Go0000o`030003o`000:H00_l01@3oool000;o
H`0005l000Co003o0P000ol0002X00OoI00005l000Co003o0P000ol0002X00OoI00005l000Ko003o
0?n[00KoI@00060000Go0?l0o`2/00GoI@0006000ol00`3o002[00GoI@0005l01On]00GoI@0005h0
1on[00OoI00005h01on[00OoI00000d00_m?00OoZ`07odl00_lC00003`03odd01Ol00`3oo`2X00Oo
C@03oaD0000B00?oB`03o`@00_nT00;o0`03od/00olH00005@03oe4000?o0000CP000ol0001?0003
o`0004h00olK00006004odh00_m>0003o`0004d00_m=00Co7P0001`00om=0003o`0004/000?o0000
B`02od`00olR00007`03od/00_m;0003o`0004X000?o0000B@03obD0000R00?oBP02odT000?o0000
B002odT00olX00009@04odP000?o0000AP000ol000170003o`0004D01?l[0000:@03odH00_m60003
o`0004D00_m500?o;`0002`00om50003o`0004<000?o0000@`02od@00olb0000;`03od<00_m30003
o`00048000?o0000@@03ocD0000b00?o@P02od4000?o0000@002od400olh0000=@04od0000?o0000
?P000ol0000o0003o`0003d01?lk0000>@03och00_ln0003o`0003d00_lm00?o?`0003`00olm0003
o`0003/000?o0000>`02oc`00om20000?`03oc/00_lk0003o`0003X000?o0000>@03odD0001200Co
>@02ocT000?o0000>002ocP01?m80000AP03ocP000?o0000=P000ol0000f00;o=`03od`0001900?o
=P02ocH000?o0000=@000ol0000d00?oC`0004`00ole0003o`0003<000?o0000<`02oc@00omB0000
C`03oc<00_lc0003o`00038000?o0000<@03oeD0001B00Co<@02oc4000?o0000<002oc001?mH0000
EP03oc0000?o0000;P000ol0000^00;o;`03oe`0001I00?o;P02obh000?o0000;@000ol0000/00?o
G`0005`00ol]0003o`0002/000?o0000:`02ob`00omR0000G`04obX00_l[0003o`0002T00_lZ00Co
I@0006<00olY00;o:@000ol0000X0003o`0002L00omY0000IP03obP000?o00009P000ol0000V00;o
9`03of`0001Y00?o9P02obH000?o00009@000ol0000T00?oK`0006`00olU0003o`0002<000?o0000
8`02ob@00omb0000K`04ob800_lS0003o`0002400_lR00CoM@0007<00olQ00;o8@000ol0000P0003
o`0001l00omi0000MP03ob0000?o00007P000ol0000N00;o7`03og`0001i00?o7P02oah000?o0000
7@000ol0000L00?oO`0007`00olM0003o`0001/000?o00006`02oa`00on20000O`04oaX00_lK0003
o`0001T00_lJ00CoQ@0008<00olI00;o6@000ol0000H0003o`0001L00on90000QP03oaP000?o0000
5P000ol0000F00;o5`03oh`0002900?o5P02oaH000?o00005002oaH00on?0000S004oa@000?o0000
4`000ol0000C0003o`0001801?nB0000T003oa800_lC0003o`0001400_lB00?oUP0009<00olA00;o
4@000ol0000@0003o`0000l00onI0000UP03oa0000?o00003P000ol0000>00;o3`03oi`0002I00?o
3P02o`h000?o00003002o`h00onO0000W004o``000?o00002`000ol0000;0003o`0000X01?nR0000
X003o`X00_l;0003o`0000T00_l:00?oYP000:<00ol900;o2@000ol000080003o`0000L00onY0000
YP03o`P000?o00001P000ol0000600;o1`03oj`0002Y00Co1@02o`H000?o00001002o`D01?n_0000
[@03o`@000?o00000`000ol000030003o`0000800onc0000/003o`800_l200?o0P02o`800onf0000
/`03o`030?oo00Go00@0oooo^@000;H02Onl0000]`07okd0002g00Oo_@000;P01Onn0000^@03okl0
003o07`0003o07`00000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 7"],

Cell[TextData[{
  "Selective duplication 7: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 8",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.22481 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.29296 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.22481 .30902 m
.22481 .16187 L
s
.02 w
.22481 .30902 Mdot
1 g
.22481 .16187 Mdot
.25889 .30902 Mdot
0 g
0 w
.29296 .30902 m
.29296 .16187 L
s
.02 w
.29296 .30902 Mdot
1 g
.29296 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0007X000?o00003@000>l00_mh00;o40000?4000?o0000M0000ol0000@0000lP000ol0001b0003
o`000140003c0003o`00070000?o00004P000?@000?o0000K@02oaD0003e00;oK0000ol0000E0000
m`000ol0001X0003o`0001H0003h0003o`0006H000?o00005`000?T000?o0000I0000ol0000H0000
nP000ol0001Q00;o6`000?/00_mP0003o`0001/0003m0003o`0005`000?o000070000?h000?o0000
FP000ol0000M0000o`000ol0001H0003o`0001h0003o004000?o0000E@02ob40003o00800_mD0003
o`000240003o00@000?o0000D0000ol0000R0000o`050003o`0004h000?o00008`000?l01P000ol0
001;00;o9P000?l01`000ol000190003o`0002H0003o00P00_m80003o`0002L0003o00X000?o0000
A0000ol0000X0000o`0;0003o`00048000?o0000:@000?l030000ol0000o00;o;0000?l03@000ol0
000m0003o`0002`0003o00h000?o0000>`000ol0000]0000o`0?00;o>P000ol0000^0000o`0A0003
o`0003H000?o0000;`000?l04P000ol0000c00;o<P000?l04`000ol0000a0003o`000380003o01@0
00?o0000;`000ol0000c0000o`0E00;o;P000ol0000d0000o`0G0003o`0002T00_lg0000o`0H0003
o`0002L000?o0000=`000?l06@000ol0000U0003o`0003P0003o01X000?o00008`000ol0000i0000
o`0K00;o8P000ol0000j0000o`0M0003o`0001d00_lm0000o`0N0003o`0001/000?o0000?@000?l0
7`000ol0000I0003o`0003h0003o020000?o00005`000ol0000o0000o`0Q00;o5P000ol000100000
o`0S0003o`0001400_m30000o`0T0003o`0000l000?o0000@`000?l09@000ol0000=0003o`0004@0
003o02H000?o00002`000ol000150000o`0W00;o2@02odP0003o02T000?o00001@000ol000180000
o`0Z0003o`3o00;o00<0o`00BP000?l0:`05od`0003o02X01om;0000o`0Z00OoB`000?l0:P07od/0
003o02/01Om<0000o`0/00?oC@0005D000?o00005`000ol0002j0003o`0004`0001E0003o`0001L0
00?o0000^P000ol0001<0000E@000ol0000G0003o`000;X000?o0000C00005D000?o00005`000ol0
002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0000G0003o`000;X0
00?o0000C00005D000?o00005`000ol0002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0
001<0000E@000ol0000G0003o`000;X000?o0000C00005D000?o00005`000ol0002j0003o`0004`0
001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0000G0003o`000;X000?o0000C00005D0
00?o00005`000ol0002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0
000G0003o`000;X000?o0000C00005D000?o00005`000ol0002j0003o`0004`0001E0003o`0001L0
00?o0000^P000ol0001<0000E@000ol0000G0003o`000;X000?o0000C00005D000?o00005`000ol0
002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0000G0003o`000;X0
00?o0000C00005D000?o00005`000ol0002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0
001<0000E@000ol0000G0003o`000;X000?o0000C00005D000?o00005`000ol0002j0003o`0004`0
001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0000G0003o`000;X000?o0000C00005D0
00?o00005`000ol0002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0
000G0003o`000;X000?o0000C00005D000?o00005`000ol0002j0003o`0004`0001E0003o`0001L0
00?o0000^P000ol0001<0000E@000ol0000G0003o`000;X000?o0000C00005D000?o00005`000ol0
002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0000G0003o`000;X0
00?o0000C00005D000?o00005`000ol0002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0
001<0000E@000ol0000G0003o`000;X000?o0000C00005D000?o00005`000ol0002j0003o`0004`0
001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0000G0003o`000;X000?o0000C00005D0
00?o00005`000ol0002j0003o`0004`0001E0003o`0001L000?o0000^P000ol0001<0000E@000ol0
000G0003o`000;X000?o0000C00005D000?o00005`000ol0002j0003o`0004`0001E0003o`0001L0
00?o0000^P000ol0001<0000E@000ol0000G0003o`000;X000?o0000C00005@00olF00?o^`03odd0
001C00Go5005okT01Om<0000DP07oa801ong00OoB`0005801olB00Oo]`07od/0001B00Oo4P07okL0
1om;0000D`05oa@01Oni00GoC00005@00olF00?o^`03odd0001:0003o`0000T000?o00002@000ol0
00090003o`0000P000?o0000O`000ol0000=0003o`0000`000?o00003@000ol0001>0000BP000ol0
00090003o`0000T000?o00002@000ol000080003o`0007l000?o00003@000ol0000<0003o`0000d0
00?o0000CP0004/000?o000020000ol000090003o`0000T000?o000020000ol000200003o`0000`0
00?o000030000ol0000=0003o`0004h0001;0003o`0000T000?o000020000ol000080003o`0000P0
00?o0000P@000ol0000<0003o`0000`000?o000030000ol0001?0000B`000ol000090003o`0000P0
00?o000020000ol000080003o`00084000?o000030000ol0000<0003o`0000`000?o0000C`0004`0
00?o000020000ol000080003o`0000P000?o00001`000ol000230003o`0000/000?o000030000ol0
000;0003o`000500001<0003o`0000P000?o000020000ol000080003o`0000L000?o0000P`000ol0
000<0003o`0000/000?o00002`000ol0001@0000C@000ol000070003o`0000P000?o000020000ol0
00060003o`0008D000?o00002`000ol0000:0003o`0000/000?o0000D@0004d000?o000020000ol0
00070003o`0000L000?o00001`000ol000250003o`0000/000?o00002P000ol0000;0003o`000540
001>0003o`0000L000?o00001`000ol000070003o`0000H000?o0000Q`000ol0000:0003o`0000X0
00?o00002P000ol0001B0000CP000ol000070003o`0000L000?o00001`000ol000060003o`0008L0
00?o00002P000ol0000:0003o`0000X000?o0000DP0004l000?o00001P000ol000070003o`0000L0
00?o00001P000ol000280003o`0000T000?o00002P000ol0000:0003o`000580001?0003o`0000L0
00?o00001P000ol000060003o`0000H000?o0000R@000ol000090003o`0000X000?o00002@000ol0
001C0000D0000ol000060003o`0000H000?o00001P000ol000060003o`0008X000?o00002@000ol0
00090003o`0000T000?o0000D`00050000?o00001P000ol000060003o`0000H000?o00001@000ol0
002;0003o`0000T000?o000020000ol000090003o`0005@0001A0003o`0000D000?o00001P000ol0
00060003o`0000D000?o0000S0000ol000080003o`0000P000?o00002@000ol0001D0000D@000ol0
00060003o`0000D000?o00001@000ol000050003o`0008d000?o000020000ol000080003o`0000P0
00?o0000E@00058000?o00001@000ol000050003o`0000D000?o00001@000ol0002>0003o`0000L0
00?o000020000ol000080003o`0005D0001B0003o`0000D000?o00001@000ol000050003o`0000@0
00?o0000S`000ol000070003o`0000P000?o00001`000ol0001F0000DP000ol000050003o`0000D0
00?o00001@000ol000040003o`0008l000?o000020000ol000070003o`0000L000?o0000EP0005<0
00?o000010000ol000050003o`0000D000?o000010000ol0002@0003o`0000L000?o00001`000ol0
00070003o`0005H0001C0003o`0000D000?o000010000ol000040003o`0000@000?o0000T@000ol0
00070003o`0000H000?o00001`000ol0001G0000E0000ol000040003o`0000@000?o000010000ol0
00040003o`00098000?o00001P000ol000060003o`0000L000?o0000E`0005@000?o000010000ol0
00040003o`0000@000?o00000`000ol0002C0003o`0000H000?o00001P000ol000060003o`0005P0
001E0003o`0000<000?o000010000ol000040003o`0000<000?o0000U0000ol000050003o`0000H0
00?o00001P000ol0001H0000E@000ol000040003o`0000<000?o00000`000ol000030003o`0009D0
00?o00001P000ol000050003o`0000D000?o0000F@0005H000?o00000`000ol000030003o`0000<0
00?o00000`000ol0002F0003o`0000D000?o00001@000ol000050003o`0005T0001F0003o`0000<0
00?o00000`000ol000030003o`00008000?o0000U`000ol000050003o`0000D000?o000010000ol0
001J0000E`000ol000020003o`0000<000?o00000`000ol000020003o`0009P000?o000010000ol0
00040003o`0000D000?o0000FP0005L000?o00000`000ol000020003o`00008000?o00000P000ol0
002I0003o`0000@000?o000010000ol000040003o`0005/0001H0003o`00008000?o00000P000ol0
00020003o`00008000?o0000VP000ol000030003o`0000@000?o000010000ol0001K0000F0000ol0
00020003o`00008000?o00000P000ol000020003o`0009X000?o000010000ol000030003o`0000@0
00?o0000F`0005P000?o00000P000ol000020003o`00008000Go0000o`2M0003o`0000@000?o0000
0`000ol000030003o`0005`0001I0005o`000?l010000ol000020005o`000?l0WP000ol000030003
o`0000<000?o00000`000ol0001L0000F@000ol000020005o`000?l00`001Ol0003o09l000?o0000
0`000ol000030003o`00008000?o0000G@0005X000Go0000o`030005o`000?l00`000ol0002N0003
o`00008000?o00000P000ol000030003o`0005d0001J0005o`000?l00`001Ol0003o008000?o0000
W`000ol000020003o`00008000?o00000P000ol0001N0000F`001?l00?l30005o`000?l00P000ol0
002P0003o`00008000Go0000o`040003o`0005h0001K0005o`000?l00P001?l00?l20003o`000:40
00?o00000P001Ol0003o00<000?o0000G`0005`000Co003o0P001?l00?l20003o`000:8000Go0000
o`030005o`000?l0H@0005`000Co003o0P001?l00?l20003o`000:8000Go0000o`030005o`000?l0
H@0005d000?o0?l00P001_l00?l0ojH000Co003o0`001?l00?mR0000G@002?l00?l0o`3o0P000ol0
002T0004o`00o`8000Go0000o`1R0000GP002Ol0o`3o0?l0o`2X0003o`3o008000Co003oH`0005h0
00Wo0?l0o`3o0?l0Z0001_l00?l0o`8000?o0000H@0005l00_l00`3o0002ojX000Oo0?l0o`3o06@0
001O00;o00<0o`000_nZ0007o`3o0?l0o`1T0000G`000ol0o`03oj/000Co0?l00_mU0000H005oj`0
0_l00`3oo`1U0000H005oj`01OmU0000G`05ojd01OmU0000GP07oj/01omT0000GP07oj/01omT0000
3@02odl01on[00OoC`02oa<0000?00?oC@05o`030?oo0:P01om=00?o5@0001800om;00?o1002oj@0
0_l300?oB`03oaP0000E00?oD@000ol0001>0003o`0004l000?o0000CP03oa/0000H00CoCP02odh0
00?o0000C@02odd01?lN00007003odd000?o0000B`000ol0001;00;oC003ob80000O00?oB`02od/0
00?o0000BP000ol0001900?o9@0002800om:00;oB@000ol0001800;oB@03obP0000U00CoB0000ol0
00160003o`0004L000?o0000A@04ob/0000Y00?oAP02odH000?o0000A@02odD00ol_0000;003odD0
00?o0000@`000ol0001300;oA003oc80000_00?o@`02od<000?o0000@P000ol0001100?o=@000380
0om200;o@@000ol0001000;o@@03ocP0000e00Co@0000ol0000n0003o`0003l000?o0000?@04oc/0
000i00?o?P02och000?o0000?@02ocd00olo0000?003ocd000?o0000>`000ol0000k00;o?003od80
000o00?o>`02oc/000?o0000>P000ol0000i00?oA@0004801?li00;o>@000ol0000h00;o>004odP0
001600?o>0000ol0000f0003o`0003H00_lg00?oC00004T00olf00;o=P000ol0000e0003o`0003@0
0om?0000C003ocD000?o0000<`000ol0000c00;o=003oe80001?00?o<`02oc<000?o0000<P000ol0
000a00?oE@0005801?la00;o<@000ol0000`00;o<004oeP0001F00?o<0000ol0000^0003o`0002h0
0_l_00?oG00005T00ol^00;o;P000ol0000]0003o`0002`00omO0000G003obd000?o0000:`000ol0
000[00;o;003of80001O00Co:P02ob/000?o0000:@02obX01?mU0000H`03obT00_lY0003o`0002P0
00?o00009`03ofT0001V00?o:0000ol0000V0003o`0002H00_lW00?oK00006T00olV00;o9P000ol0
000U0003o`0002@00om_0000K003obD000?o00008`000ol0000S00;o9003og80001_00Co8P02ob<0
00?o00008@02ob801?me0000L`03ob400_lQ0003o`00020000?o00007`03ogT0001f00?o80000ol0
000N0003o`0001h00_lO00?oO00007T00olN00;o7P000ol0000M0003o`0001`00omo0000O003oad0
00?o00006`000ol0000K00;o7003oh80001o00Co6P02oa/000?o00006@02oaX01?n50000P`03oaT0
0_lI0003o`0001P000?o00005`03ohT0002600?o60000ol0000F0003o`0001H00_lG00?oS00008T0
0olF00;o5P000ol0000D00;o5P03ohl0002<00Co50000ol0000C0003o`0001<000?o00004P04oi80
002@00?o4P02oa<000?o00004@02oa800onF0000T`03oa400_lA0003o`00010000?o00003`03oiT0
002F00?o40000ol0000>0003o`0000h00_l?00?oW00009T00ol>00;o3P000ol0000<00;o3P03oil0
002L00Co30000ol0000;0003o`0000/000?o00002P04oj80002P00?o2P02o`/000?o00002@02o`X0
0onV0000X`03o`T00_l90003o`0000P000?o00001`03ojT0002V00?o20000ol000060003o`0000H0
0_l700?o[0000:T01?l500;o1P000ol0000400;o1@04ojl0002]00?o10000ol000030003o`0000<0
00?o00000P03ok<0002`00?o0P02o`800ol200;o0P03okH0002c00?o00<0ool01Ol0103oooni0000
]P09ok`0002g00Oo_@000;L01onm0000^005okh0002i00?o_`000?l0O0000?l0O0000001\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 8"],

Cell[TextData[{
  "Selective duplication 8: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.73752 .01472 L
s
.79719 .16187 m
.85686 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.73752 .01472 Mdot
.85686 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O0000>`000?o0000OP000ol0000;0000k@000ol0001l0003o`0000`0003^0003
o`0002H000?o0000:0000ol0000V0003o`0000d0003_00;o9`000ol0000V0003o`0002D00_l@0000
l@000ol0000T0003o`0002H000?o000090000ol0000@0000lP000ol0000T0003o`0002@000?o0000
90000ol0000A0000l`000ol0000S0003o`0002@000?o00008`000ol0000B0000m0000ol0000R0003
o`0002@000?o00008@02oaD0003e00;o8`000ol0000R0003o`00024000?o00005@000?L000?o0000
80000ol0000R0003o`00020000?o00005P000?P000?o000080000ol0000P0003o`00020000?o0000
5`000?T000?o00007`000ol0000P0003o`0001l000?o000060000?X000?o00007P000ol0000O0003
o`0001h00_lK0000n`02oal000?o00007P000ol0000M0003o`0001/0003m0003o`0001`000?o0000
7P000ol0000L0003o`0001`0003n0003o`0001/000?o00007@000ol0000L0003o`0001d0003o0003
o`0001/000?o000070000ol0000K0003o`0001h0003o004000?o00006P000ol0000K0003o`0001X0
0_lQ0000o`0200;o6`000ol0000J0003o`0001T000?o00008@000?l010000ol0000H0003o`0001X0
00?o000060000ol0000R0000o`050003o`0001L000?o00006@000ol0000H0003o`0002<0003o00H0
00?o00005`000ol0000H0003o`0001H00_lV0000o`070003o`0001H000?o00005`000ol0000F0003
o`0002H0003o00P00_lG0003o`0001H000?o00005@000ol0000W0000o`0:0003o`0001@000?o0000
5P000ol0000D0003o`0002P0003o00/000?o00004`000ol0000E0003o`0001@000?o0000:@000?l0
30000ol0000C0003o`0001@000?o00004P02ob`0003o00d000?o00004P000ol0000C0003o`000180
00?o0000;0000?l03P000ol0000B0003o`00018000?o00004@000ol0000]0000o`0?00;o4P000ol0
000A0003o`00014000?o0000;P000?l04@000ol0000?0003o`00014000?o000040000ol0000_0000
o`0B0003o`0000l000?o000040000ol0000>00;o<P000?l04`000ol0000>0003o`0000l000?o0000
3P000ol0000b0000o`0D0003o`0000h000?o00003P000ol0000=0003o`0003<0003o01D00_l>0003
o`0000d000?o00003@000ol0000d0000o`0G0003o`0000/000?o00003@000ol0000;00;o=`000?l0
60000ol0000;0003o`0000`000?o00002P000ol0000g0000o`0I0003o`0000X000?o00002`000ol0
000:0003o`0003P0003o01X000?o00002P000ol0000:0003o`0000T000?o0000>@000?l06`02o`X0
00?o00002@000ol000090003o`0003X0003o01d000?o00001`000ol000090003o`0000L00_lm0000
o`0N0003o`0000L000?o000020000ol000060003o`0003d0003o01l000?o00001P000ol000070003
o`0000H000?o0000?P000?l080000ol000050003o`0000L000?o00001@000ol0000o0000o`0Q00;o
1P000ol000050003o`0000D000?o0000@0000?l08`000ol000030003o`0000D000?o00000`02od<0
003o02@000?o00000`000ol000030003o`0000<000?o0000@`000?l09@000ol000020003o`0000<0
00?o00000P000ol000140000o`0V0005o`000?l01@001Ol0003o04L0003o02L00_l20005o`000?l0
0P02odP0003o02T000?o0?l00`000ol0o`1:0000o`0Z0003o`3o00;o00<0o`00BP000?l0:`05od`0
003o02X01om;0000o`0Z00OoB`000?l0:P07od/0003o02/01Om<0000o`0/00?oC@00068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C000068000?o0000
a`000ol0001<0000HP000ol000370003o`0004`0001R0003o`000<L000?o0000C00006000oo800?o
C@0005l01Oo600GoC00005h01oo400OoB`0005h01oo400OoB`0005h01oo400OoB`0005l01Oo600Go
C00006000oo800?oC@0004X000?o00005@000ol0000D0003o`0007l000?o00003@000ol0000<0003
o`0000d000?o0000CP0004X000?o00005@000ol0000D0003o`0007l000?o00003@000ol0000<0003
o`0000d000?o0000CP0004/000?o000050000ol0000D0003o`00080000?o000030000ol0000<0003
o`0000d000?o0000CP0004/000?o000050000ol0000C0003o`00084000?o000030000ol0000<0003
o`0000`000?o0000C`0004/000?o000050000ol0000C0003o`00084000?o000030000ol0000<0003
o`0000`000?o0000C`0004`000?o00004`000ol0000B0003o`0008<000?o00002`000ol0000<0003
o`0000/000?o0000D00004`000?o00004`000ol0000B0003o`0008<000?o000030000ol0000;0003
o`0000/000?o0000D00004d000?o00004P000ol0000A0003o`0008D000?o00002`000ol0000:0003
o`0000/000?o0000D@0004d000?o00004P000ol0000A0003o`0008D000?o00002`000ol0000:0003
o`0000/000?o0000D@0004h000?o00004@000ol0000@0003o`0008L000?o00002P000ol0000:0003
o`0000X000?o0000DP0004h000?o00004@000ol0000@0003o`0008L000?o00002P000ol0000:0003
o`0000X000?o0000DP0004l000?o000040000ol0000@0003o`0008P000?o00002@000ol0000:0003
o`0000X000?o0000DP0004l000?o000040000ol0000?0003o`0008T000?o00002@000ol0000:0003
o`0000T000?o0000D`00050000?o00003`000ol0000?0003o`0008X000?o00002@000ol000090003
o`0000T000?o0000D`00050000?o00003`000ol0000>0003o`0008/000?o00002@000ol000080003
o`0000T000?o0000E000054000?o00003P000ol0000>0003o`0008`000?o000020000ol000080003
o`0000T000?o0000E000054000?o00003P000ol0000=0003o`0008d000?o000020000ol000080003
o`0000P000?o0000E@00058000?o00003@000ol0000=0003o`0008h000?o00001`000ol000080003
o`0000P000?o0000E@00058000?o00003@000ol0000<0003o`0008l000?o00001`000ol000080003
o`0000L000?o0000EP00058000?o00003@000ol0000<0003o`0008l000?o000020000ol000070003
o`0000L000?o0000EP0005<000?o000030000ol0000<0003o`00090000?o00001`000ol000070003
o`0000L000?o0000EP0005<000?o000030000ol0000;0003o`00094000?o00001`000ol000060003
o`0000L000?o0000E`0005@000?o00002`000ol0000;0003o`00098000?o00001P000ol000060003
o`0000L000?o0000E`0005@000?o00002`000ol0000:0003o`0009<000?o00001P000ol000060003
o`0000H000?o0000F00005D000?o00002P000ol0000:0003o`0009@000?o00001@000ol000060003
o`0000H000?o0000F00005D000?o00002P000ol000090003o`0009D000?o00001P000ol000050003
o`0000D000?o0000F@0005H000?o00002@000ol000090003o`0009H000?o00001@000ol000050003
o`0000D000?o0000F@0005H000?o00002@000ol000080003o`0009L000?o00001@000ol000050003
o`0000@000?o0000FP0005L000?o000020000ol000080003o`0009P000?o000010000ol000040003
o`0000D000?o0000FP0005L000?o000020000ol000070003o`0009T000?o000010000ol000040003
o`0000@000?o0000F`0005P000?o00001`000ol000070003o`0009X000?o00000`000ol000040003
o`0000@000?o0000F`0005P000?o00001`000ol000070003o`0009X000?o000010000ol000030003
o`0000@000?o0000F`0005P000?o00001`000ol000060003o`0009/000?o000010000ol000030003
o`0000<000?o0000G00005T000?o00001P000ol000060003o`0009`000?o00000`000ol000030003
o`0000<000?o0000G00005T000?o00001P000ol000050003o`0009d000?o00000`000ol000030003
o`00008000?o0000G@0005X000?o00001@000ol000050003o`0009h000?o00000P000ol000020003
o`0000<000?o0000G@0005X000?o00001@000ol000040003o`0009l000?o00000P000ol000020003
o`00008000?o0000GP0005/000?o000010000ol000040003o`000:0000?o00000P001Ol0003o00@0
00?o0000GP0005/000?o000010000ol000030003o`000:4000?o00000P001Ol0003o00<000?o0000
G`0005`000?o00000`000ol000030003o`000:8000Go0000o`030005o`000?l0H@0005`000?o0000
0`000ol000030003o`000:8000Go0000o`030005o`000?l0H@0005d000?o00000P000ol000020003
o`000:@000Co003o0`001?l00?mR0000G@000ol000020003o`00008000?o0000Y0001?l00?l20005
o`000?l0HP0005h000Go0000o`030003o`000:H000?o0?l00P001?l00?mS0000GP001Ol0003o00<0
00?o0000YP001_l00?l0o`8000?o0000H@0005l000Co003o0P000ol0002X0007o`3o0?l0o`1T0000
G`001?l00?l20003o`000:P000Oo0?l0o`3o06@0001O0006o`00o`3oZ`001?l0o`02ofD0001P0005
o`3o0?l0[002o`030?oo06D0001P00?o00<0o`00Z`05ofD0001O00Go[@05ofD0001N00OoZ`07of@0
001N00OoZ`07of@0000=00;oC`07oj/01om?00;o4`0000l00om=00Go00<0ool0Z007odd00olE0000
4P03od/00ol400;oY002o`<00om;00?o600001D00omA0003o`0004h000?o0000C`000ol0001>00?o
6`0001P01?m>00;oCP000ol0001=00;oC@04oah0000L00?oC@000ol0001;0003o`0004/00_m<00?o
8P0001l00om;00;oB`000ol0001:0003o`0004T00olU00008P03odX00_m90003o`0004P00_m900?o
:00002D01?m80003o`0004H000?o0000A`000ol0001500Co:`0002T00om600;oAP000ol0001500;o
A@03obl0000/00?oA@000ol000130003o`0004<00_m400?o<P0002l00om300;o@`000ol000120003
o`0004400ole0000<P03od800_m10003o`0004000_m100?o>00003D01?m00003o`0003h000?o0000
?`000ol0000m00Co>`0003T00oln00;o?P000ol0000m00;o?@03ocl0000l00?o?@000ol0000k0003
o`0003/00_ll00?o@P0003l00olk00;o>`000ol0000j0003o`0003T00om50000@P04ocT00_li0003
o`0003P00_lh00CoB00004H00olh0003o`0003H000?o0000=P02ocL00om<0000B@03ocH00_lf0003
o`0003D000?o0000=003odl0001<00?o=@000ol0000c0003o`0003<00_ld00?oDP0004l00olc00;o
<`000ol0000b0003o`0003400omE0000DP04oc400_la0003o`0003000_l`00CoF00005H00ol`0003
o`0002h000?o0000;P02obl00omL0000F@03obh00_l^0003o`0002d000?o0000;003oel0001L00?o
;@000ol0000[0003o`0002/00_l/00?oHP0005l01?lZ00;o:`000ol0000Y00;o:P04ofD0001S00?o
:@02obT000?o0000:0000ol0000W00?oJ@0006H00olX0003o`0002H000?o00009P02obL00om/0000
J@03obH00_lV0003o`0002D000?o00009003ofl0001/00?o9@000ol0000S0003o`0002<00_lT00?o
LP0006l01?lR00;o8`000ol0000Q00;o8P04ogD0001c00?o8@02ob4000?o000080000ol0000O00?o
N@0007H00olP0003o`0001h000?o00007P02oal00oml0000N@03oah00_lN0003o`0001d000?o0000
7003ogl0001l00?o7@000ol0000K0003o`0001/00_lL00?oPP0007l01?lJ00;o6`000ol0000I00;o
6P04ohD0002300?o6@02oaT000?o000060000ol0000G00?oR@0008H00olH0003o`0001H000?o0000
5P02oaL00on<0000R@03oaH00_lF0003o`0001@00_lF00?oS`0008`01?lD0003o`0001<000?o0000
4`000ol0000B00CoTP0009000olB00;o4`000ol0000A00;o4P03oiH0002C00?o4@02oa4000?o0000
40000ol0000?00?oV@0009H00ol@0003o`0000h000?o00003P02o`l00onL0000V@03o`h00_l>0003
o`0000`00_l>00?oW`0009`01?l<0003o`0000/000?o00002`000ol0000:00CoXP000:000ol:00;o
2`000ol0000900;o2P03ojH0002S00?o2@02o`T000?o000020000ol0000700?oZ@000:H00ol80003
o`0000H000?o00001P02o`L00on/0000Z@04o`D00_l60003o`0000@00_l500Co[`000:d00ol40003
o`0000<000?o00000`000ol0000200?o/`000;000ol200;o0P03o`800_l200?o]P000;<00ol00`3o
o`05o`040?oookT0002f00Wo_0000;L01onm0000]`07okd0002h00Go_P000;T00ono0000o`1l0000
o`1l0000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.10864, -0.820004, 
  0.0112927, 0.00360807}},
  CellTags->"Duplication - mutant 9"],

Cell[TextData[{
  "Selective duplication 9: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Duplication - mutant 10",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.454505 0.215348 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.45451 .60332 m
.02381 .45617 L
s
.45451 .60332 m
.13148 .45617 L
s
.45451 .60332 m
.23916 .45617 L
s
.45451 .60332 m
.34683 .45617 L
s
.45451 .60332 m
.45451 .45617 L
s
.45451 .60332 m
.56218 .45617 L
s
.45451 .60332 m
.66985 .45617 L
s
.45451 .60332 m
.77753 .45617 L
s
.45451 .60332 m
.8852 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.13148 .45617 m
.0968 .30902 L
s
.13148 .45617 m
.13148 .30902 L
s
.13148 .45617 m
.16617 .30902 L
s
1 g
.02 w
.0968 .30902 Mdot
0 g
0 w
.13148 .30902 m
.13148 .16187 L
s
.02 w
.13148 .30902 Mdot
1 g
.13148 .16187 Mdot
.16617 .30902 Mdot
0 g
.13148 .45617 Mdot
1 g
.23916 .45617 Mdot
0 g
0 w
.34683 .45617 m
.31215 .30902 L
s
.34683 .45617 m
.33527 .30902 L
s
.34683 .45617 m
.35839 .30902 L
s
.34683 .45617 m
.38152 .30902 L
s
1 g
.02 w
.31215 .30902 Mdot
.33527 .30902 Mdot
.35839 .30902 Mdot
0 g
0 w
.38152 .30902 m
.38152 .16187 L
s
.02 w
.38152 .30902 Mdot
0 w
.38152 .16187 m
.21754 .01472 L
s
.38152 .16187 m
.54549 .01472 L
s
1 g
.02 w
.21754 .01472 Mdot
.54549 .01472 Mdot
0 g
.38152 .16187 Mdot
.34683 .45617 Mdot
1 g
.45451 .45617 Mdot
0 g
0 w
.56218 .45617 m
.52749 .30902 L
s
.56218 .45617 m
.56218 .30902 L
s
.56218 .45617 m
.59686 .30902 L
s
1 g
.02 w
.52749 .30902 Mdot
0 g
0 w
.56218 .30902 m
.56218 .16187 L
s
.02 w
.56218 .30902 Mdot
1 g
.56218 .16187 Mdot
.59686 .30902 Mdot
0 g
.56218 .45617 Mdot
1 g
.66985 .45617 Mdot
0 g
0 w
.77753 .45617 m
.74284 .30902 L
s
.77753 .45617 m
.76597 .30902 L
s
.77753 .45617 m
.78909 .30902 L
s
.77753 .45617 m
.81221 .30902 L
s
1 g
.02 w
.74284 .30902 Mdot
.76597 .30902 Mdot
.78909 .30902 Mdot
0 g
0 w
.81221 .30902 m
.81221 .16187 L
s
.02 w
.81221 .30902 Mdot
0 w
.81221 .16187 m
.64823 .01472 L
s
.81221 .16187 m
.97619 .01472 L
s
1 g
.02 w
.64823 .01472 Mdot
.97619 .01472 Mdot
0 g
.81221 .16187 Mdot
.77753 .45617 Mdot
1 g
.8852 .45617 Mdot
0 g
.45451 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{379, 233.812},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005k0000j@P10`4000010?ooooooc?ooZ_ooISLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc3/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00?l0VOl0I_l0<ol003lo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIV@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0o`L71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcV@l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<oa<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<aLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVA/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=VoalO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<b<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IVBLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000ob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A3<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0O0000?l0O0000?l0O0000?l0O0000?l0
O0000?l0O0000?l0O00005D000?o0000W`000ol0001c0003o`0000/0001F0003o`00074000?o0000
:`000ol0001a0003o`0000`0001G0003o`0006l000?o0000;@000ol0001_0003o`0000d0001H0003
o`0006d000?o0000;`000ol0001]0003o`0000h0001I0003o`0006/000?o0000<@000ol0001[0003
o`0000l0001J0003o`0006T000?o0000<`000ol0001Y0003o`000100001K0003o`0006L000?o0000
=@000ol0001W0003o`000140001L00;oI@02ocT00_mU00;o500005h000?o0000H@000ol0000k0003
o`00064000?o0000500005l000?o0000G`000ol0000m0003o`0005l000?o00005@00060000?o0000
G@000ol0000o0003o`0005d000?o00005P00064000?o0000F`000ol000110003o`0005/000?o0000
5`00068000?o0000F@000ol000130003o`0005T000?o0000600006<000?o0000E`000ol000150003
o`0005L000?o00006@0006@000?o0000E@000ol000170003o`0005D000?o00006P0006D000?o0000
D`000ol000190003o`0005<000?o00006`0006H000?o0000D@000ol0001;0003o`00054000?o0000
700006L00_m?00;oC`02odl00_lO0000J@000ol0001;0003o`00054000?o0000B`000ol0000O0000
JP000ol000190003o`0005<000?o0000B@000ol0000P0000J`000ol000170003o`0005D000?o0000
A`000ol0000Q0000K0000ol000150003o`0005L000?o0000A@000ol0000R0000K@000ol000130003
o`0005T000?o0000@`000ol0000S0000KP000ol000110003o`0005/000?o0000@@000ol0000T0000
K`000ol0000o0003o`0005d000?o0000?`000ol0000U0000L0000ol0000m0003o`0005l000?o0000
?@000ol0000V0000L@02oc/00_mS00;o>`02obT0001c0003o`0003L000?o0000I@000ol0000g0003
o`0002T0001d0003o`0003D000?o0000I`000ol0000e0003o`0002X0001e0003o`0003<000?o0000
J@000ol0000c0003o`0002/0001f0003o`00034000?o0000J`000ol0000a0003o`0002`0001g0003
o`0002l000?o0000K@000ol0000_0003o`0002d0001h0003o`0002d000?o0000K`000ol0000]0003
o`0002h0001i0003o`0002/000?o0000L@000ol0000[0003o`0002l0001j0003o`0002T000?o0000
L`000ol0000Y0003o`000300001k00;o9`02ogL00_lW00;o<`0007d000?o00008`000ol0001i0003
o`0002<000?o0000<`0007h000?o00008@000ol0001k0003o`00024000?o0000=00007l000?o0000
7`000ol0001m0003o`0001l000?o0000=@00080000?o00007@000ol0001o0003o`0001d000?o0000
=P00084000?o00006`000ol000210003o`0001/000?o0000=`00088000?o00006@000ol000230003
o`0001T000?o0000>00008<000?o00005`000ol000250003o`0001L000?o0000>@0008@000?o0000
5@000ol000270003o`0001D000?o0000>P0008D000?o00004`000ol000290003o`0001<000?o0000
>`0008H00_lA00;oS@02oa400_ln0000R0000ol0000=0003o`0008l000?o00003@000ol0000n0000
R@000ol0000;0003o`00094000?o00002`000ol0000o0000RP000ol000090003o`0009<000?o0000
2@000ol000100000R`000ol000070003o`0009D000?o00001`000ol000110000S0000ol000050003
o`0009L000?o00001@000ol000120000S@000ol0o`02o`030?l009X000?o0?l00_l00`3o00140000
SP05oid01Om60000S@07oi/01om50000S@07oi/01om50000S@07oi/01om50000SP05oid01Om60000
S`03oil00om70000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000
F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000<P000ol0001K0003
o`00044000?o0000F`000ol000160000<P000ol0001K0003o`00044000?o0000F`000ol000160000
<003oe`00om100?oF`03odL0000_00GoFP05ocl01OmI00GoAP0002h01omH00Oo?@07oeL01om50000
;P07oeP01olm00OoE`07odD0000^00OoF007ocd01omG00OoA@0002l01OmJ00Go?`05oeT01Om60000
9P000ol0000700?oA0000ol0000E00?o@@03oe/00om700009P000ol000090003o`0000T000?o0000
=P000ol000040003o`0000H000?o00001@000ol0000f0003o`0000T000?o00002@000ol0000f0003
o`0000D000?o00001@000ol000050003o`0004L0000V0003o`0000T000?o00002@000ol0000f0003
o`0000@000?o00001P000ol000050003o`0003H000?o00002@000ol000090003o`0003H000?o0000
1@000ol000050003o`0000D000?o0000A`0002H000?o00002@000ol000090003o`0003H000?o0000
10000ol000060003o`0000D000?o0000=P000ol000090003o`0000T000?o0000=P000ol000050003
o`0000D000?o00001@000ol0001700009`000ol000080003o`0000P000?o0000>0000ol000040003
o`0000D000?o000010000ol0000h0003o`0000P000?o000020000ol0000h0003o`0000@000?o0000
1@000ol000040003o`0004P0000W0003o`0000P000?o000020000ol0000h0003o`0000@000?o0000
10000ol000050003o`0003P000?o000020000ol000080003o`0003P000?o00001@000ol000030003
o`0000D000?o0000B00002L000?o000020000ol000080003o`0003P000?o000010000ol000040003
o`0000D000?o0000>0000ol000080003o`0000P000?o0000>0000ol000050003o`0000<000?o0000
1@000ol0001800009`000ol000080003o`0000P000?o0000>0000ol000040003o`0000@000?o0000
1@000ol0000h0003o`0000P000?o000020000ol0000h0003o`0000D000?o00000`000ol000050003
o`0004P0000W0003o`0000P000?o000020000ol0000h0003o`0000@000?o000010000ol000050003
o`0003P000?o000020000ol000080003o`0003P000?o00001@000ol000030003o`0000D000?o0000
B00002P000?o00001`000ol000070003o`0003X000?o00000`000ol000040003o`0000@000?o0000
>P000ol000070003o`0000L000?o0000>P000ol000040003o`0000<000?o000010000ol000190000
:0000ol000070003o`0000L000?o0000>P000ol000030003o`0000@000?o000010000ol0000j0003
o`0000L000?o00001`000ol0000j0003o`0000@000?o00000`000ol000040003o`0004T0000X0003
o`0000L000?o00001`000ol0000j0003o`0000<000?o000010000ol000040003o`0003X000?o0000
1`000ol000070003o`0003X000?o000010000ol000030003o`0000@000?o0000B@0002P000?o0000
1`000ol000070003o`0003X000?o00000`000ol000040003o`0000@000?o0000>P000ol000070003
o`0000L000?o0000>P000ol000040003o`0000<000?o000010000ol000190000:@000ol000060003
o`0000H000?o0000?0000ol000020003o`0000@000?o00000`000ol0000l0003o`0000H000?o0000
1P000ol0000l0003o`0000<000?o00000`000ol000030003o`0004X0000Y0003o`0000H000?o0000
1P000ol0000l0003o`00008000?o000010000ol000030003o`0003`000?o00001P000ol000060003
o`0003`000?o00000`000ol000030003o`0000<000?o0000BP0002T000?o00001P000ol000060003
o`0003`000?o00000`000ol000030003o`0000<000?o0000?0000ol000060003o`0000H000?o0000
?0000ol000030003o`0000<000?o00000`000ol0001:0000:@000ol000060003o`0000H000?o0000
?0000ol000030003o`0000<000?o00000`000ol0000l0003o`0000H000?o00001P000ol0000l0003
o`0000<000?o00000`000ol000030003o`0004X0000Z0003o`0000D000?o00001@000ol0000n0003
o`00008000?o00000`000ol000020003o`0003h000?o00001@000ol000050003o`0003h000?o0000
0P000ol000030003o`00008000?o0000B`0002X000?o00001@000ol000050003o`0003h000?o0000
0P000ol000030003o`00008000?o0000?P000ol000050003o`0000D000?o0000?P000ol000020003
o`0000<000?o00000P000ol0001;0000:P000ol000050003o`0000D000?o0000?P000ol000020003
o`00008000?o00000`000ol0000n0003o`0000D000?o00001@000ol0000n0003o`0000<000Go0000
o`050003o`0004/0000Z0003o`0000D000?o00001@000ol0000n0003o`00008000?o00000P000ol0
00030003o`0003h000?o00001@000ol000050003o`0003h000?o00000`001Ol0003o00D000?o0000
B`0002X000?o00001@000ol000050003o`0003h000?o00000P000ol000020003o`0000<000?o0000
?P000ol000050003o`0000D000?o0000?P000ol000030005o`000?l01@000ol0001;0000:`000ol0
00040003o`0000@000?o0000@0001Ol0003o00@000?o00000P000ol000100003o`0000@000?o0000
10000ol000100003o`00008000Go0000o`040003o`0004`0000[0003o`0000@000?o000010000ol0
00100005o`000?l010000ol000020003o`00040000?o000010000ol000040003o`00040000?o0000
0P001Ol0003o00@000?o0000C00002/000?o000010000ol000040003o`00040000Go0000o`040003
o`00008000?o0000@0000ol000040003o`0000@000?o0000@0000ol000020005o`000?l010000ol0
001<0000:`000ol000040003o`0000@000?o0000@0001Ol0003o00@000?o00000P000ol000100003
o`0000@000?o000010000ol000100003o`00008000Go0000o`040003o`0004`0000/0003o`0000<0
00?o00000`000ol000120005o`000?l00`001Ol0003o04@000?o00000`000ol000030003o`000480
00Go0000o`030005o`000?l0C`0002`000?o00000`000ol000030003o`00048000Go0000o`030005
o`000?l0A0000ol000030003o`0000<000?o0000@P001Ol0003o00<000Go0000o`1?0000;0000ol0
00030003o`0000<000?o0000@P001Ol0003o00<000Go0000o`140003o`0000<000?o00000`000ol0
00120005o`000?l00`001Ol0003o04l0000/0003o`0000<000?o00000`000ol000120005o`000?l0
0`001Ol0003o04@000?o00000`000ol000030003o`00048000Go0000o`030005o`000?l0C`0002d0
00?o00000P000ol000020003o`0004@000Co003o0`001?l00?m60003o`00008000?o00000P000ol0
00140004o`00o`<000Co003oD00002d000?o00000P000ol000020003o`0004@000Co003o0`001?l0
0?m60003o`00008000?o00000P000ol000140004o`00o`<000Co003oD00002d000?o00000P000ol0
00020003o`0004@000Co003o0`001?l00?m60003o`00008000?o00000P000ol000140004o`00o`<0
00Co003oD00002d000?o00000P000ol000020003o`0004@000Co003o0P001Ol0003o04H000?o0000
0P000ol000020003o`0004@000Oo0000o`3o00<000?o0000CP0002d000?o00000P000ol000020003
o`0004@000Co003o0P001Ol0003o04H000?o00000P000ol000020003o`0004@000Oo0000o`3o00<0
00?o0000CP0002h000Go0000o`030003o`0004H000?o0?l00P001?l00?m80005o`000?l00`000ol0
00160006o`00o`3o0P000ol0001?0000;P001Ol0003o00<000?o0000AP000ol0o`020004o`00odP0
00Go0000o`030003o`0004H000Ko003o0?l20003o`0004l0000^0005o`000?l00`000ol000160006
o`00o`3o0P000ol000160005o`000?l00`000ol000160006o`00o`3o0P000ol0001?0000;P001Ol0
003o00<000?o0000AP001_l00?l0o`8000?o0000AP001Ol0003o00<000?o0000AP001_l00?l0o`80
00?o0000C`0002l000Co003o0P000ol000180007o`3o0?l0o`1:0004o`00o`8000?o0000B0001ol0
o`3o0?l0DP0002l000Co003o0P000ol000180007o`3o0?l0o`1:0004o`00o`8000?o0000B0001ol0
o`3o0?l0DP0002l000Co003o0P000ol000180007o`3o0?l0o`1:0004o`00o`8000?o0000B0001ol0
o`3o0?l0DP0002l000Co003o0P000ol000180007o`3o0?l0o`1:0004o`00o`8000?o0000B0001ol0
o`3o0?l0DP00030000Go0?l0o`1<00;o00<0ool0C0001Ol0o`3o04`00_l00`3oo`1C0000<0001Ol0
o`3o04`00_l00`3oo`1<0005o`3o0?l0C002o`030?oo05<0000`0005o`3o0?l0C002o`030?oo04`0
00Go0?l0o`1<00;o00<0ool0D`00030000Go0?l0o`1<00;o00<0ool0C0001Ol0o`3o04`00_l00`3o
o`1C0000<0001Ol0o`3o04`00ol00`3o001;0005o`3o0?l0C0001Ol0o`3o05<0000a00?oCP03odh0
0om>00?oE00003400om>00?oCP03odh00omD0000<004odh00om>00?oCP03oe@0000_00GoC@05od`0
1Om<00GoD`0002h01om;00OoBP07odX01omB0000;P07od/01om:00OoBP07oe80000=0003o`0001h0
2?m:00OoBP07odX01omB00003P03oah01Ol200?o9002ob801Om<00Go8@02obD00ol00`3oo`03oal0
0ola00004@03oa`00ol600;o90000ol0000P00CoC004ob4000?o00008`02o`D00olM00?o=00001@0
0olT00;o8`02ob@000?o00008P000ol0000S0003o`0002400_lT00;o9003ocL0000G00?o8`02ob<0
00?o00008@000ol0000R0003o`0002<000?o000080000ol0000R00;o8`03ocX0000J00?o8P02ob80
0_lR0003o`00024000?o00008P000ol0000O00;o8`02ob800olm00007@03ob400olQ0003o`000200
00?o000080000ol0000Q0003o`0001l000?o00008003ob400om000008003ob400_lP00;o80000ol0
000P0003o`00020000?o00007P02ob400_lQ00?o@`0002<00olP00;o80000ol0000N0003o`0001l0
00?o000080000ol0000M0003o`0001l00_lP00?oAP0002H00olO00;o7`000ol0000N0003o`0001h0
00?o00007`000ol0000M0003o`0001h00_lO00?oB@0002T00olN00;o7P02oal000?o00007@000ol0
000N0003o`0001`00_lN00?o7P03od`0000/00?o7@03oad000?o000070000ol0000M0003o`0001d0
00?o000070000ol0000L00;o7P03odl0000_00?o7@02oa`00_lM0003o`0001`000?o00007@000ol0
000J00;o7@02oad00omB0000<P03oa`00_lL0003o`0001/000?o00006`000ol0000L0003o`0001X0
00?o00006`02oa`00omE0000=@03oa/00_lK00;o70000ol0000J0003o`0001/000?o00006@02oa`0
0_lK00?oF00003P00olJ00;o6`000ol0000I0003o`0001X000?o00006P000ol0000I0003o`0001T0
0olJ00?oF`0003/00olI00?o6@02oaX000?o00006@000ol0000J0003o`0001L00_lJ00;o6P03oeh0
000n00;o6P02oaT000?o000060000ol0000H0003o`0001T000?o00005`000ol0000H00;o6@03of40
001000?o6@02oaP00_lH0003o`0001P000?o000060000ol0000F00;o6@02oaP00omT0000@`03oaP0
0_lH0003o`0001H000?o00005`000ol0000G0003o`0001H000?o00005`02oaL00omW0000AP03oaL0
0_lG00;o5`000ol0000F0003o`0001L000?o00005002oaL00olF00?oJP0004T00olF00?o5P000ol0
000E0003o`0001D000?o00005P000ol0000D0003o`0001D00_lF00?oK@0004`00olF00;o5@02oaD0
00?o00005@000ol0000E0003o`0001<00_lF00;o5@03og00001?00?o5@02oaD000?o00004`000ol0
000D0003o`0001@000?o00004`000ol0000D00;o5003og<0001B00?o5002oa@00_lD0003o`0001<0
00?o000050000ol0000A00;o5003oa<00omf0000E@03oa<00_lD0003o`00018000?o00004P000ol0
000C0003o`00014000?o00004P02oa<00omi0000F003oa800olB00;o4P000ol0000B0003o`000180
00?o00004002oa<00_lB00?oO00005/00olB00;o4P000ol0000@0003o`00014000?o00004@000ol0
000@0003o`0001400_lB00;oO`0005h00olA00;o4@000ol0000@0003o`00010000?o00004@000ol0
000?0003o`0001000_lA00?oP@0006400ol@00;o4002oa0000?o000040000ol0000@0003o`0000h0
0_l@00?o4003oh@0001T00?o3`02oa0000?o00003P000ol0000?0003o`0000l000?o00003P000ol0
000>00;o4003ohL0001W00?o3P03o`h00_l?0003o`0000h000?o00003`000ol0000<00;o3`02o`l0
0on:0000JP03o`h00_l>0003o`0000d000?o00003@000ol0000>0003o`0000`000?o00003@02o`h0
0on=0000K@03o`d00_l=00;o3@000ol0000=0003o`0000d000?o00002`02o`d00ol=00?oT0000700
0ol<00;o3@000ol0000;0003o`0000`000?o000030000ol0000;0003o`0000/00_l=00?oT`0007<0
0ol;00;o3002o``000?o00002`000ol0000<0003o`0000T00_l<00;o3003oiH0001f00;o2`03o`/0
00?o00002P000ol0000:0003o`0000/000?o00002@000ol0000:00;o2`03oiT0001h00?o2`02o`X0
0_l:0003o`0000X000?o00002P000ol0000800;o2`02o`X00onL0000N`03o`X00_l:0003o`0000P0
00?o00002@000ol000090003o`0000P000?o00002003o`T00onO0000OP03o`T00_l900;o2@000ol0
00080003o`0000T000?o00001P02o`T00_l900?oXP0008400ol800;o2@000ol000060003o`0000P0
00?o000020000ol000060003o`0000L00_l800?oY@0008@00ol700?o1`02o`L000?o00001`000ol0
00070003o`0000D00_l800;o1`03ojP0002700?o1`02o`L000?o00001@000ol000060003o`0000H0
00?o00001@000ol0000600;o1P03oj/0002:00?o1P02o`H00_l60003o`0000D000?o00001P000ol0
000300;o1P03o`D00on^0000S@03o`D00_l60003o`0000<000?o00001@000ol000050003o`0000<0
00?o00001002o`D00ona0000T003o`@00_l50003o`0000<000?o000010000ol000040003o`0000<0
00?o00000`02o`@00ond0000T`03o`<00ol300;o10000ol000030003o`0000<000?o00000P02o`@0
0_l300?o]`0009H00ol300;o0`000ol000020003o`00008000?o00000`001Ol0003o00<00ol200?o
^P0009T00ol200;o0P02o`8000?o00000P000ol000020003o`0000;o0P02o`800onm0000W003o`03
0?oo008000Co003o0`001Ol0003o008000?o00000_l0103oooo00000W`05o`050?oo0?l00P001Ol0
0?l000;o00<0ool00oo30000XP07o`050?ooo`000_l00`3oo`02olH0002U00gob@000:P01oo<0000
Z007ol`0002X00Ooc0000:T01Oo=0000ZP03olh0003o07`0003o07`00000\
\>"],
  ImageRangeCache->{{{0, 378}, {232.812, 0}} -> {-2.11859, -0.820004, 
  0.0123273, 0.00360807}},
  CellTags->"Duplication - mutant 10"],

Cell[TextData[{
  "Selective duplication 10: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Duplication - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Duplication - mutant 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Deletion"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Deletion - Intro"],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Mshowa
P
.004 w
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Mshowa
P
1 g
.04 w
.20018 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Mshowa
P
1 g
.05 w
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Mshowa
P
1 g
.52939 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Mshowa
P
1 g
.57643 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.004 w
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.62346 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`0004/00_l200;o^@05o`/0001<0004o`00ok/000Go0000o`0:0000C004ok/000Go0000o`0:0000
C0001?l00?nk00Co2`0004d00_nl0005o`000?l02P0004`00ol600;o[P02o`<01Ol;0000E`03ojP0
0olE0000FP02oj@00_lH0000G002oil00olJ0000GP03oiX00_lM0000H@02oiH00_lO0000H`03oi00
0olQ0000IP02oh`00_lT0000J002ohL00olV0000JP03oh800_lY0000K@02ogh00_l[0000K`02ogT0
0ol]0000L@03og@00_l`0000M002ofl00olb0000MP03ofX00_le0000N@02ofH00_lg0000N`02of40
0oli0000O@03oe`00_ll0000P002oeL00oln0000PP02oe<00_m10000Q003odh00_m30000Q`02odT0
0om50000R@03od@00_m80000S002ocl00om:0000SP02oc/00_m=0000T003ocH00_m?0000T`02oc40
0omA0000U@02obd00_mD0000U`03obL00omF0000VP02ob<00_mI0000W003oah00_mK0000W`02o`X0
00G>g/kNcP0:00?oG@000:400_l600W>1P02of00002S00?o0P000mk>gP03o`05g/kNc]h00P03of80
002V00;o1/h00oo>cP02cP;oI@0003/00omY0004c]k>gPCo00G>g/kNcP1V0000?0000ol0001X00?>
00Goc/k>o`05cVH0000i00GoJ@003LkNc_o>g/koc]k>g/h0IP0003X000?o0?l0JP03cP05olk>c_l0
1LiV0000>P000ol0o`1Z0004c]k>gPGo00CNc]k>IP0003/00_m[00_>I`000:P000_Nc]k>g/kNc]k>
gP1W0000Z@09cVP0000k0003o`0006d000G>g/kNcP1Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>@001LkNc]k>06d000G>g/kNcP1Z0000
=`09cVT02LiX0000=P000mk>gP03o`05g/kNc]h0I`000mk>gP03o`05g/kNc]h0I`0003H01/h00oo>
cP02cVL01/h00oo>cP02cVL0000U00Go2`001<kNc]h4o`05c]k>g/h02P03ocD01_l700Go2005o`@0
00C>g/kN1?l01LkNc]k>06H0000V0005o`000?l02P03cP05olk>c_l01Lh=0003o`0003<000?o0000
2P001Ol0003o00P000Go0000o`0300?>00Goc/k>o`05cVH0000V0005o`000?l02P003LkNc_o>g/ko
c]k>g/h03@000ol0000c0003o`0000X000Go0000o`080005o`000?l00`003LkNc_o>g/koc]k>g/h0
IP0002H01?l;00?>00Goc/k>o`05cP/00_lf00Co2@001Ol0003o00P01?l400?>00Goc/k>o`05cVH0
000V0005o`000?l02P001<kNc]h5o`04g/kNcPd000?o0000<`000ol0000:0005o`000?l020001Ol0
003o00<000C>g/kN1Ol01=k>g/iV00009@05o``02lh;00?o=@06o`L01Ol800Go1@0;cVL0000f000;
g/kNc]k>g/kNc]h0I`002mk>g/kNc]k>g/kN06L0000g00W>J@09cVP0000[0003o`0000/000G>g/kN
cP0=0003o`0003`000?o00007@001_o>g/kNcVX0000[0003o`0000d000?o00003@000ol0000l0003
o`0000P000?o000020000ol000070003o`0006d0000/0003o`0000`000?o000030000ol0000n0003
o`0000L000?o000020000ol000060003o`0006h0000/0003o`0000`000?o000030000ol0000n0003
o`0000L000?o000020000ol000060003o`0006h0000]0003o`0000/000?o00002`000ol000100003
o`0000H000?o00001`000ol000060003o`0006l0000]0003o`0000/000?o00002`000ol000100003
o`0000L000?o00001P000ol000060003o`0006l0000]0003o`0000/000?o00002`000ol000100003
o`0000L000?o00001P000ol000060003o`0006l0000^0003o`0000X000?o00002P000ol000120003
o`0000H000?o00001P000ol000050003o`000700000^0003o`0000X000?o00002P000ol000120003
o`0000H000?o00001P000ol000050003o`000700000_0003o`0000T000?o00002@000ol000140003
o`0000D000?o00001@000ol000050003o`000740000_0003o`0000T000?o00002@000ol000140003
o`0000D000?o00001@000ol000050003o`000740000`0003o`0000P000?o000020000ol000160003
o`0000@000?o00001@000ol000040003o`000780000`0003o`0000P000?o000020000ol000160003
o`0000D000?o000010000ol000040003o`000780000a0003o`0000L000?o00001`000ol000180003
o`0000@000?o000010000ol000030003o`0007<0000a0003o`0000L000?o00001`000ol000180003
o`0000@000?o000010000ol000030003o`0007<0000b0003o`0000H000?o00001P000ol0001:0003
o`0000<000?o00000`000ol000030003o`0007@0000b0003o`0000H000?o00001P000ol0001:0003
o`0000<000?o00000`000ol000030003o`0007@0000c0003o`0000D000?o00001@000ol0001<0003
o`00008000?o00000`000ol000020003o`0007D0000c0003o`0000D000?o00001@000ol0001<0003
o`0000<000?o00000P000ol000020003o`0007D0000d0003o`0000@000?o000010000ol0001>0003
o`00008000?o00000P001Ol0003o07P0000d0003o`0000@000?o000010000ol0001>0003o`000080
00?o00000P001Ol0003o07P0000e0003o`0000<000?o00000`000ol0001@0005o`000?l00`001Ol0
003o07T0000e0003o`0000<000?o00000`000ol0001@0005o`000?l00`001Ol0003o07T0000f0003
o`00008000?o00000P000ol0001B0004o`00o`<000Co003oNP0003H000?o00000P000ol000020003
o`00058000Co003o0`001?l00?mj0000=P000ol000020003o`00008000?o0000DP001Ol0003o0080
00Co003oNP0003L000Go0000o`030003o`0005@000Ko003o0?l20003o`0007T0000g0005o`000?l0
0`000ol0001D0006o`00o`3o0P000ol0001i0000>0001oo>g/kNc_l0F0001ooNc]k>g_l0O00003L0
2LiF00W>N`0003H000?Nc]h00ol01Mk>g/kN05@000_>g/kNc]k>g/kNcP1j0000=P06cP03olk>00;>
E00;cWX0000800;o0P02obL000C>g/kN1?l01LkNc]k>02H01OlW0004g/kNcP;o00ONooo>g/kN02L0
1?m>00002@001?l00?lX00?>00Goc/k>o`05cRL000Go0000o`0V00C>00Coc/ko1LhX0003o`0004h0
000900Co:0003LkNc_o>g/koc]k>g/h09`001Ol0003o02H000gNc]k>olkNomk>g/kN02T000?o0000
C@0000T000Co003o:003cP05olk>c_l01LhW0005o`000?l09P04cP04olk>o`G>:P000ol0001<0000
2P02obT000C>g/kN1Ol01=k>g/hW0005o`000?l09P001=k>g/h4o`05g/kNc]h0:P000ol0001<0000
2@03o`H00_lR00_>9`05obP00lh00oo>cP05cR800_l400?oC`0001@00olO000;g/kNc]k>g/kNc]h0
E0002lkNooo>g/kNc]k>01l00omH00005`02oah02Lh00`3oo`1A0003o`3>00S>7P02oe/0000I00?o
7@001LkNc]k>00D000?o0000C002o`@000GNc]k>gP0N00;oG@0001`00_lV0003o`0002@000?o0000
8`000ol0000T00?oG`0001h00_lU0003o`0002<000?o00008P000ol0000S00;oHP0002000olS0003
o`00028000?o00008@000ol0000Q00?oI00002<00_lR00;o8P000ol0000P0003o`0002000_mW0000
9@03ob4000?o00007`000ol0000N00;o8@02ofT0000X00;o80000ol0000N0003o`0001d000?o0000
7P03of/0000Z00;o7`000ol0000M0003o`0001`000?o00007@02ofh0000/00?o7@000ol0000L0003
o`0001/000?o00007002og00000_00;o7002oa`000?o00006P000ol0000J00?oLP0003400olK0003
o`0001T000?o00006@000ol0000I00;oM@0003@00_lJ0003o`0001P000?o00005`02oaT00omg0000
=P02oaT000?o00005`000ol0000F0003o`0001L00_mj0000>003oaL000?o00005P000ol0000E0003
o`0001H00_ml0000>`02oaH00_lF0003o`0001@000?o00005003ogh0000m00?o5@000ol0000C0003
o`0001<000?o00004`02oh40001000;o50000ol0000B0003o`00018000?o00004P02oh<0001200;o
4`000ol0000A0003o`0001000_lB00?oQ@0004@00olA0003o`00010000?o00003`000ol0000@00;o
R00004L00_l@00;o40000ol0000>0003o`0000h00on:0000B@03o`l000?o00003@000ol0000=0003
o`0000d00_n=0000C002o`h000?o000030000ol0000<0003o`0000`00_n?0000CP02o`d000?o0000
2`000ol0000;0003o`0000X00onA0000D003o`/000?o00002P000ol0000900;o2`02oi@0001C00;o
2P02o`X000?o000020000ol0000900;oUP0005D00ol90003o`0000L000?o00001`000ol0000700?o
V00005P00_l80003o`0000H000?o00001P000ol0000600;oV`0005X00_l70003o`0000D000?o0000
1@000ol0000400?oW@0005`00ol50003o`0000@000?o00000`02o`D00_nP0000G`02o`@00_l00`3>
cP03cP<000?o00000`02oj80001Q00?o0P002]k>g/kNc]k>g_l300?oY00006@000?oc/h02Lh00`3o
o`2W0000I@001<kNc]h4o`04c]k>ojT0001T00K>00?oc/h01<jY0000I0003Mk>g/kNc_o>g/kNc]h0
Z@0006@01/h00oo>cP04cZT0001T0005g/kNc]h01?l01<kNc]jY0000I006cP03olk>00C>Z@0006D0
00G>g/kNcP03o`03c]k>0:X0001U00_>ZP0006H000WNc]k>g/kNc]h0Z`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.24067, -0.833976, 0.02093, 
  0.00501711}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
TermPlot[theChromos, 
  TreeWidth -> .2, 
  LabelSize -> 0.02, LabelColor -> 0,
  TextDisplay -> False
];\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;0000?o0000F`000ol000090000/@000ol0001I0003o`0000X0002b0003
o`0005L000?o00002`000;<00_mE00;o3P000;D000?o0000D@000ol0000>0000]P000ol0001?0003
o`0000l0002g0003o`0004d000?o000040000;P00_m;00;o4`000;X000?o0000A`000ol0000C0000
^`000ol000150003o`0001@0002l0003o`0004<000?o00005@000;d000?o0000@@000ol0000F0000
_P02ocl00_lI0000`0000ol0000k0003o`0001T000310003o`0003T000?o00006P000<8000?o0000
=`000ol0000K0000``02ocD00_lN0000a@000ol0000a0003o`0001h000360003o`0002l000?o0000
7`000<L000?o0000;@000ol0000P0000b0000ol0000[0003o`000240003900;o:@02ob@0003;0003
o`0002D000?o000090000<`000?o00008`000ol0000U0000c@000ol0000Q0003o`0002H0003>00;o
7`02obT0003@0003o`0001/000?o0000:@000=4000?o00006@000ol0000Z0000dP000ol0000G0003
o`0002/0003C0003o`0001D000?o0000;0000=@00_lC00;o;`000=H000?o00003`000ol0000_0000
e`000ol0000=0003o`000300003H0003o`0000/000?o0000<@000=T00_l900;o=0000=/000?o0000
1@000ol0000d0000g0000ol000030003o`0003D0003M00Go>0000=d01Olh0000g@05ocP0003M00Go
>0000=h00oli0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000A`03oi@00oli0000AP05oi801Olh0000AP05oi801Olh0000AP05oi801Olh0000
A`03oi@00oli0000=P000ol0000@0003o`0000l000?o0000G0000ol000090003o`0000T000?o0000
2@000ol0000i0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000P000?o0000JP000ol000040003o`0000D000?o0000
10000ol000100000?P000ol000080003o`0000P000?o0000JP000ol000050003o`0000<000?o0000
1@000ol000100000?P000ol000080003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000D000?o0000L0000ol000020003o`0000<000?o0000
0P000ol000130000@@000ol000050003o`0000D000?o0000L0000ol000030005o`000?l01@000ol0
00130000@@000ol000050003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000
@P000ol000040003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000@P000ol0
00040003o`0000<000?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`0000<0
00?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`00008000?o0000MP001?l0
0?l30004o`00odP000140003o`00008000?o00000P000ol0001f0004o`00o`<000Co003oB00004@0
00?o00000P001Ol0003o07X000Ko003o0?l20003o`0004L000150005o`000?l00`000ol0001h0006
o`00o`3o0P000ol000170000A@001Ol0003o008000?o0000NP001ol0o`3o0?l0BP0004H000Co003o
0P000ol0001j0007o`3o0?l0o`1:0000AP001?l00?l20003o`0007X000Oo0?l0o`3o04X000170005
o`3o0?l0OP02o`030?oo04/000170005o`3o0?l0OP02o`030?oo04/0001700CoP003od`0001600Go
O`05od/000090003o`0003X01Omo00GoB`0000X00oli00KoOP05ocX00ol>00003@03ocL00ol200;o
NP02o`040?ooocP00olA00004003oc/00_lj0003o`0003T00_lk00?o500001<00olj0003o`0003L0
00?o0000>0000ol0000h00?o5`0001H01?lg00;o=`000ol0000f00;o=`04oaX0000J00?o=P000ol0
000d0003o`0003D000?o0000=003oah0000M00?o=002oc@000?o0000<`02oc@00olQ00008003oc<0
00?o0000<@000ol0000a00;o<`03ob@0000S00?o<@02oc4000?o0000<0000ol0000_00Co9`0002H0
1?l_00;o;`000ol0000^00;o;`03ob/0000Z00?o;P000ol0000/0003o`0002`00_l^00?o;P0002d0
0ol/00;o;0000ol0000[0003o`0002/00ola0000<003ob/000?o0000:@000ol0000Y00;o:`03oc@0
000c00?o:@02obT000?o0000:0000ol0000W00Co=`0003H01?lW00;o9`000ol0000V00;o9`03oc/0
000j00?o9P000ol0000T0003o`0002@00_lV00?o?P0003d00olT00;o90000ol0000S0003o`0002<0
0om10000@003ob<000?o00008@000ol0000Q00;o8P04od@0001300?o8@02ob4000?o000080000ol0
000O00?oB00004H01?lO00;o7`000ol0000N00;o7`03od/0001:00?o7P000ol0000L0003o`0001`0
0_lN00?oCP0004d00olL00;o70000ol0000K0003o`0001/00omA0000D003oa/000?o00006@000ol0
000I00;o6P04oe@0001C00?o6@02oaT000?o000060000ol0000G00?oF00005H00olH0003o`0001H0
00?o00005P02oaL00omK0000F@04oaD00_lF0003o`0001@00_lF00?oGP0005d00olD00;o50000ol0
000C0003o`0001801?mQ0000H003oa<000?o00004@000ol0000A00;o4P03ofD0001S00?o4@02oa40
00?o000040000ol0000?00?oJ00006H00ol@0003o`0000h000?o00003P02o`l00om[0000J@04o`d0
0_l>0003o`0000`00_l>00?oKP0006d00ol<00;o30000ol0000;0003o`0000X01?ma0000L003o`/0
00?o00002@000ol0000900;o2P03ogD0001c00?o2@02o`T000?o00001`02o`T00omh0000MP03o`P0
00?o00001P000ol000060003o`0000H00omk0000N@04o`D00_l60003o`0000@00_l500CoOP0007d0
0ol40003o`0000<000?o00000`000ol0000200?oPP0008000ol200;o0`001?l00002o`800on50000
P`03o`060?oo0?l00_l0103ooon80000QP09oh/0002800GoS@0008P01On=0000R005ohd0002900?o
SP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1095, -0.820004, 0.0151971, 
  0.00485551}},
  CellTags->"Deletion - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
delChromos = Join @@ Table[
Deletion[theChromos, 
  Templates -> {{{_f}, 1},
                {{_h}, 1},
                {{g[x__]/; Length[{x}] > 1}, 1}
               },
  
  SelectionMode -> RANDOM], {10}]

delChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]]]]], 
 
  chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A]]], 2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]]]]], 
 
  chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A]]], 2]]]]\
\>"], 
  "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]]]]]
chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A]]], 2]]]\
\>", 
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]]]]]
chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A]]], 2]]]\
\>"], 
  "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> False,
            LabelSize -> 0.02, LabelColor -> 0
]& /@ delChromos;\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.7381 .30902 L
s
.02 w
.7381 .45617 Mdot
0 w
.7381 .30902 m
.7381 .16187 L
s
.02 w
.7381 .30902 Mdot
0 w
.7381 .16187 m
.55679 .01472 L
s
.7381 .16187 m
.9194 .01472 L
s
1 g
.02 w
.55679 .01472 Mdot
.9194 .01472 Mdot
0 g
.7381 .16187 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`0009l000?o0000G0000ol0000I0000X0000ol0001J0003o`0001X0002Q00;o
F@000ol0000K0000X`000ol0001D00;o7P000:@000?o0000DP000ol0000N0000Y@000ol0001@0003
o`0001l0002V00;oC`000ol0000P0000Z0000ol0001:00;o8`000:T000?o0000B0000ol0000S0000
ZP000ol000160003o`0002@0002[00;oA@000ol0000U0000[@000ol000110003o`0002H0002^0003
o`0003h00_lY0000[`000ol0000l0003o`0002T0002`00;o>`000ol0000Z0000/P000ol0000g0003
o`0002/0002c0003o`0003@00_l^0000]0000ol0000b0003o`0002h0002e00;o<@000ol0000_0000
]`000ol0000]0003o`000300002h0003o`0002/000?o0000<@000;T000?o0000:002oc@0002j0003
o`0002H000?o0000=0000;/00_lU0003o`0003D0002m0003o`00024000?o0000=P000;h000?o0000
7P02ocT0002o0003o`0001`000?o0000>@000<000_lK0003o`0003X000320003o`0001L000?o0000
>`000<<000?o00005@000ol0000l0000a0000ol0000B00;o?`000<D00_lA0003o`0003l000370003
o`0000d000?o0000@0000<P000?o00002`000ol000110000b@000ol0000800;oA0000<X00_l70003
o`0004@0003<0003o`0000<000?o0000A@000<d00ol00`3o00170000c005odT0003<00GoB@000<`0
1Om90000c@03odX000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P0001800?oPP03odX0001700GoP005odT0001700GoP005odT0001700GoP005odT0
001800?oPP03odX0000g0003o`0000l000?o000040000ol0001`0003o`0004P0000h0003o`0000h0
00?o00003`000ol0001a0003o`0004P0000h0003o`0000h000?o00003`000ol0001a0003o`0004P0
000i0003o`0000d000?o00003P000ol0001b0003o`0004P0000i0003o`0000d000?o00003P000ol0
001b0003o`0004P0000i0003o`0000d000?o00003@000ol0001c0003o`0004P0000j0003o`0000`0
00?o00003@000ol0001c0003o`0004P0000j0003o`0000`000?o000030000ol0001d0003o`0004P0
000k0003o`0000/000?o000030000ol0001d0003o`0004P0000k0003o`0000/000?o00002`000ol0
001e0003o`0004P0000l0003o`0000X000?o00002`000ol0001e0003o`0004P0000l0003o`0000X0
00?o00002P000ol0001f0003o`0004P0000m0003o`0000T000?o00002P000ol0001f0003o`0004P0
000m0003o`0000T000?o00002@000ol0001g0003o`0004P0000n0003o`0000P000?o00002@000ol0
001g0003o`0004P0000n0003o`0000P000?o000020000ol0001h0003o`0004P0000o0003o`0000L0
00?o000020000ol0001h0003o`0004P0000o0003o`0000L000?o00001`000ol0001i0003o`0004P0
00100003o`0000H000?o00001`000ol0001i0003o`0004P000100003o`0000H000?o00001`000ol0
001i0003o`0004P000100003o`0000H000?o00001P000ol0001j0003o`0004P000110003o`0000D0
00?o00001P000ol0001j0003o`0004P000110003o`0000D000?o00001@000ol0001k0003o`0004P0
00120003o`0000@000?o00001@000ol0001k0003o`0004P000120003o`0000@000?o000010000ol0
001l0003o`0004P000130003o`0000<000?o000010000ol0001l0003o`0004P000130003o`0000<0
00?o00000`000ol0001m0003o`0004P000140003o`00008000?o00000`000ol0001m0003o`0004P0
00140003o`00008000?o00000P000ol0001n0003o`0004P000150005o`000?l010000ol0001n0003
o`0004P000150005o`000?l00`000ol0001o0003o`0004P000160004o`00o`<000?o0000O`000ol0
00180000AP001?l00?l20003o`00080000?o0000B00004H000Co003o0P000ol000200003o`0004P0
00170005o`3o0?l0P`000ol000180000A`001Ol0o`3o08<000?o0000B00004P00on200?oBP0004L0
1On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o>003o`03
0?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0000i0003
o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH00_lg0003
o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P0002001?lb00;o
=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc0000?o0000
;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d01?l/0003
o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80000d00?o
:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H00olh0000
>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0001100?o
8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob400om50000
A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0000L00?o
C00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X000?o0000
6@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H00_lG00Co
F00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0000C00;o
5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0000@0003
o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d000?o0000
3@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/000?o0000
2@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L00_l80003
o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol000030003
o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3oo`3o00;o
00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}},
  CellTags->"Deletion - mutant 1"]
}, Open  ]],

Cell[TextData[{
  "Selective deletion 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.7381 .30902 L
s
.02 w
.7381 .45617 Mdot
0 w
.7381 .30902 m
.7381 .16187 L
s
.02 w
.7381 .30902 Mdot
0 w
.7381 .16187 m
.55679 .01472 L
s
.7381 .16187 m
.9194 .01472 L
s
1 g
.02 w
.55679 .01472 Mdot
.9194 .01472 Mdot
0 g
.7381 .16187 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`0009l000?o0000G0000ol0000I0000X0000ol0001J0003o`0001X0002Q00;o
F@000ol0000K0000X`000ol0001D00;o7P000:@000?o0000DP000ol0000N0000Y@000ol0001@0003
o`0001l0002V00;oC`000ol0000P0000Z0000ol0001:00;o8`000:T000?o0000B0000ol0000S0000
ZP000ol000160003o`0002@0002[00;oA@000ol0000U0000[@000ol000110003o`0002H0002^0003
o`0003h00_lY0000[`000ol0000l0003o`0002T0002`00;o>`000ol0000Z0000/P000ol0000g0003
o`0002/0002c0003o`0003@00_l^0000]0000ol0000b0003o`0002h0002e00;o<@000ol0000_0000
]`000ol0000]0003o`000300002h0003o`0002/000?o0000<@000;T000?o0000:002oc@0002j0003
o`0002H000?o0000=0000;/00_lU0003o`0003D0002m0003o`00024000?o0000=P000;h000?o0000
7P02ocT0002o0003o`0001`000?o0000>@000<000_lK0003o`0003X000320003o`0001L000?o0000
>`000<<000?o00005@000ol0000l0000a0000ol0000B00;o?`000<D00_lA0003o`0003l000370003
o`0000d000?o0000@0000<P000?o00002`000ol000110000b@000ol0000800;oA0000<X00_l70003
o`0004@0003<0003o`0000<000?o0000A@000<d00ol00`3o00170000c005odT0003<00GoB@000<`0
1Om90000c@03odX000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P0001800?oPP03odX0001700GoP005odT0001700GoP005odT0001700GoP005odT0
001800?oPP03odX0000g0003o`0000l000?o000040000ol0001`0003o`0004P0000h0003o`0000h0
00?o00003`000ol0001a0003o`0004P0000h0003o`0000h000?o00003`000ol0001a0003o`0004P0
000i0003o`0000d000?o00003P000ol0001b0003o`0004P0000i0003o`0000d000?o00003P000ol0
001b0003o`0004P0000i0003o`0000d000?o00003@000ol0001c0003o`0004P0000j0003o`0000`0
00?o00003@000ol0001c0003o`0004P0000j0003o`0000`000?o000030000ol0001d0003o`0004P0
000k0003o`0000/000?o000030000ol0001d0003o`0004P0000k0003o`0000/000?o00002`000ol0
001e0003o`0004P0000l0003o`0000X000?o00002`000ol0001e0003o`0004P0000l0003o`0000X0
00?o00002P000ol0001f0003o`0004P0000m0003o`0000T000?o00002P000ol0001f0003o`0004P0
000m0003o`0000T000?o00002@000ol0001g0003o`0004P0000n0003o`0000P000?o00002@000ol0
001g0003o`0004P0000n0003o`0000P000?o000020000ol0001h0003o`0004P0000o0003o`0000L0
00?o000020000ol0001h0003o`0004P0000o0003o`0000L000?o00001`000ol0001i0003o`0004P0
00100003o`0000H000?o00001`000ol0001i0003o`0004P000100003o`0000H000?o00001`000ol0
001i0003o`0004P000100003o`0000H000?o00001P000ol0001j0003o`0004P000110003o`0000D0
00?o00001P000ol0001j0003o`0004P000110003o`0000D000?o00001@000ol0001k0003o`0004P0
00120003o`0000@000?o00001@000ol0001k0003o`0004P000120003o`0000@000?o000010000ol0
001l0003o`0004P000130003o`0000<000?o000010000ol0001l0003o`0004P000130003o`0000<0
00?o00000`000ol0001m0003o`0004P000140003o`00008000?o00000`000ol0001m0003o`0004P0
00140003o`00008000?o00000P000ol0001n0003o`0004P000150005o`000?l010000ol0001n0003
o`0004P000150005o`000?l00`000ol0001o0003o`0004P000160004o`00o`<000?o0000O`000ol0
00180000AP001?l00?l20003o`00080000?o0000B00004H000Co003o0P000ol000200003o`0004P0
00170005o`3o0?l0P`000ol000180000A`001Ol0o`3o08<000?o0000B00004P00on200?oBP0004L0
1On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o>003o`03
0?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0000i0003
o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH00_lg0003
o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P0002001?lb00;o
=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc0000?o0000
;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d01?l/0003
o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80000d00?o
:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H00olh0000
>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0001100?o
8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob400om50000
A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0000L00?o
C00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X000?o0000
6@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H00_lG00Co
F00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0000C00;o
5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0000@0003
o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d000?o0000
3@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/000?o0000
2@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L00_l80003
o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol000030003
o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3oo`3o00;o
00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}},
  CellTags->"Deletion - mutant 2"],

Cell[TextData[{
  "Selective deletion 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.7381 .30902 L
s
.02 w
.7381 .45617 Mdot
0 w
.7381 .30902 m
.7381 .16187 L
s
.02 w
.7381 .30902 Mdot
0 w
.7381 .16187 m
.55679 .01472 L
s
.7381 .16187 m
.9194 .01472 L
s
1 g
.02 w
.55679 .01472 Mdot
.9194 .01472 Mdot
0 g
.7381 .16187 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`0009l000?o0000G0000ol0000I0000X0000ol0001J0003o`0001X0002Q00;o
F@000ol0000K0000X`000ol0001D00;o7P000:@000?o0000DP000ol0000N0000Y@000ol0001@0003
o`0001l0002V00;oC`000ol0000P0000Z0000ol0001:00;o8`000:T000?o0000B0000ol0000S0000
ZP000ol000160003o`0002@0002[00;oA@000ol0000U0000[@000ol000110003o`0002H0002^0003
o`0003h00_lY0000[`000ol0000l0003o`0002T0002`00;o>`000ol0000Z0000/P000ol0000g0003
o`0002/0002c0003o`0003@00_l^0000]0000ol0000b0003o`0002h0002e00;o<@000ol0000_0000
]`000ol0000]0003o`000300002h0003o`0002/000?o0000<@000;T000?o0000:002oc@0002j0003
o`0002H000?o0000=0000;/00_lU0003o`0003D0002m0003o`00024000?o0000=P000;h000?o0000
7P02ocT0002o0003o`0001`000?o0000>@000<000_lK0003o`0003X000320003o`0001L000?o0000
>`000<<000?o00005@000ol0000l0000a0000ol0000B00;o?`000<D00_lA0003o`0003l000370003
o`0000d000?o0000@0000<P000?o00002`000ol000110000b@000ol0000800;oA0000<X00_l70003
o`0004@0003<0003o`0000<000?o0000A@000<d00ol00`3o00170000c005odT0003<00GoB@000<`0
1Om90000c@03odX000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P0001800?oPP03odX0001700GoP005odT0001700GoP005odT0001700GoP005odT0
001800?oPP03odX0000g0003o`0000l000?o000040000ol0001`0003o`0004P0000h0003o`0000h0
00?o00003`000ol0001a0003o`0004P0000h0003o`0000h000?o00003`000ol0001a0003o`0004P0
000i0003o`0000d000?o00003P000ol0001b0003o`0004P0000i0003o`0000d000?o00003P000ol0
001b0003o`0004P0000i0003o`0000d000?o00003@000ol0001c0003o`0004P0000j0003o`0000`0
00?o00003@000ol0001c0003o`0004P0000j0003o`0000`000?o000030000ol0001d0003o`0004P0
000k0003o`0000/000?o000030000ol0001d0003o`0004P0000k0003o`0000/000?o00002`000ol0
001e0003o`0004P0000l0003o`0000X000?o00002`000ol0001e0003o`0004P0000l0003o`0000X0
00?o00002P000ol0001f0003o`0004P0000m0003o`0000T000?o00002P000ol0001f0003o`0004P0
000m0003o`0000T000?o00002@000ol0001g0003o`0004P0000n0003o`0000P000?o00002@000ol0
001g0003o`0004P0000n0003o`0000P000?o000020000ol0001h0003o`0004P0000o0003o`0000L0
00?o000020000ol0001h0003o`0004P0000o0003o`0000L000?o00001`000ol0001i0003o`0004P0
00100003o`0000H000?o00001`000ol0001i0003o`0004P000100003o`0000H000?o00001`000ol0
001i0003o`0004P000100003o`0000H000?o00001P000ol0001j0003o`0004P000110003o`0000D0
00?o00001P000ol0001j0003o`0004P000110003o`0000D000?o00001@000ol0001k0003o`0004P0
00120003o`0000@000?o00001@000ol0001k0003o`0004P000120003o`0000@000?o000010000ol0
001l0003o`0004P000130003o`0000<000?o000010000ol0001l0003o`0004P000130003o`0000<0
00?o00000`000ol0001m0003o`0004P000140003o`00008000?o00000`000ol0001m0003o`0004P0
00140003o`00008000?o00000P000ol0001n0003o`0004P000150005o`000?l010000ol0001n0003
o`0004P000150005o`000?l00`000ol0001o0003o`0004P000160004o`00o`<000?o0000O`000ol0
00180000AP001?l00?l20003o`00080000?o0000B00004H000Co003o0P000ol000200003o`0004P0
00170005o`3o0?l0P`000ol000180000A`001Ol0o`3o08<000?o0000B00004P00on200?oBP0004L0
1On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o>003o`03
0?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0000i0003
o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH00_lg0003
o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P0002001?lb00;o
=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc0000?o0000
;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d01?l/0003
o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80000d00?o
:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H00olh0000
>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0001100?o
8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob400om50000
A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0000L00?o
C00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X000?o0000
6@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H00_lG00Co
F00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0000C00;o
5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0000@0003
o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d000?o0000
3@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/000?o0000
2@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L00_l80003
o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol000030003
o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3oo`3o00;o
00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}},
  CellTags->"Deletion - mutant 3"],

Cell[TextData[{
  "Selective deletion 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.573047 0.201572 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.57305 .60332 m
.1699 .45617 L
s
.57305 .60332 m
.97619 .45617 L
s
.1699 .45617 m
.02381 .30902 L
s
.1699 .45617 m
.12121 .30902 L
s
.1699 .45617 m
.2186 .30902 L
s
.1699 .45617 m
.316 .30902 L
s
1 g
.02 w
.02381 .30902 Mdot
.12121 .30902 Mdot
.2186 .30902 Mdot
0 g
0 w
.316 .30902 m
.316 .16187 L
s
.02 w
.316 .30902 Mdot
0 w
.316 .16187 m
.16251 .01472 L
s
.316 .16187 m
.46949 .01472 L
s
1 g
.02 w
.16251 .01472 Mdot
.46949 .01472 Mdot
0 g
.316 .16187 Mdot
.1699 .45617 Mdot
1 g
.97619 .45617 Mdot
0 g
.57305 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`00030000?o0000i`00034000?o0000C0000ol0002G0000<P000ol0001:0003o`0009P0
000c0003o`0004P000?o0000V@0003@000?o0000AP000ol0002J0000=@000ol000140003o`0009/0
000f0003o`00048000?o0000W00003L000?o0000@0000ol0002M0000>0000ol0000n0003o`0009h0
000i0003o`0003`000?o0000W`0003X000?o0000>P000ol0002P0000>`000ol0000h0003o`000:40
000l0003o`0003H000?o0000XP0003d000?o0000=0000ol0002S0000?P000ol0000b0003o`000:@0
000o0003o`00030000?o0000Y@00040000?o0000;P000ol0002V0000@@000ol0000/0003o`000:L0
00120003o`0002X000?o0000Z00004<000?o00009`02oj/000140003o`0002D000?o0000Z`0004D0
00?o00008`000ol0002/0000AP000ol0000Q0003o`000:d000170003o`0001l000?o0000[P0004P0
00?o00007@000ol0002_0000B@000ol0000K0003o`000;00001:0003o`0001T000?o0000/@0004/0
00?o00005`000ol0002b0000C0000ol0000E0003o`000;<0001=0003o`0001<000?o0000]00004h0
00?o00004@000ol0002e0000C`000ol0000?0003o`000;H0001@0003o`0000d000?o0000]`000540
00?o00002`000ol0002h0000DP000ol000090003o`000;T0001C0003o`0000L000?o0000^P0005@0
00?o00001@000ol0002k0000E@000ol000030003o`000;`0001F00Go_`0005H01Ono0000EP05okl0
001F00Go_`0005L00oo00000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000E`03ol00001F00Go_`0005H01Ono0000EP05okl0
00090003o`0004/00oo000002P000ol0000F0003o`0001H000?o00005`000ol0003100002`000ol0
000E0003o`0001H000?o00005P000ol00032000030000ol0000E0003o`0001D000?o00005@000ol0
003300003@000ol0000D0003o`0001@000?o00005@000ol0003400003P000ol0000C0003o`0001@0
00?o000050000ol0003500003`000ol0000C0003o`0001<000?o00004`000ol00036000040000ol0
000B0003o`00018000?o00004`000ol0003700004@000ol0000A0003o`00018000?o00004P000ol0
003800004P000ol0000A0003o`00014000?o00004@000ol0003900004`000ol0000@0003o`000100
00?o00004@000ol0003:000050000ol0000?0003o`00010000?o000040000ol0003;00005@000ol0
000?0003o`0000l000?o00003`000ol0003<00005P000ol0000>0003o`0000h000?o00003`000ol0
003=00005`000ol0000=0003o`0000h000?o00003P000ol0003>000060000ol0000=0003o`0000d0
00?o00003@000ol0003?00006@000ol0000<0003o`0000`000?o00003@000ol0003@00006P000ol0
000;0003o`0000`000?o000030000ol0003A00006`000ol0000;0003o`0000/000?o00002`000ol0
003B000070000ol0000:0003o`0000X000?o00002`000ol0003C00007@000ol000090003o`0000X0
00?o00002P000ol0003D00007P000ol000090003o`0000T000?o00002@000ol0003E00007`000ol0
00080003o`0000T000?o000020000ol0003F000080000ol000070003o`0000P000?o000020000ol0
003G00008@000ol000070003o`0000L000?o00001`000ol0003H00008P000ol000060003o`0000L0
00?o00001P000ol0003I00008`000ol000050003o`0000H000?o00001P000ol0003J000090000ol0
00050003o`0000D000?o00001@000ol0003K00009@000ol000040003o`0000D000?o000010000ol0
003L00009P000ol000030003o`0000@000?o000010000ol0003M00009`000ol000030003o`0000<0
00?o00000`000ol0003N0000:0000ol000020003o`0000<000?o00000P000ol0003O0000:@001Ol0
003o00@000?o00000P000ol0003P0000:P001Ol0003o00<000Go0000o`3S0000:`001?l00?l30004
o`00on@0000/0003o`3o008000Co003oi@0002d000Oo0?l0o`3o0>H0000^00Goi`0002d01OoX0000
;@05onP0000]00Sof002o`/0000^00?o1003om800ol=0000>003ol`00ol@0000>`02olP00_lC0000
?@03ol800olE0000@003ok`00olH0000@`02okL00olK0000A@03ok800_lN0000B003oj`00olP0000
B`03ojH00olS0000CP02oj400olV0000D003oi`00_lY0000D`03oiH00ol[0000EP03oi000ol^0000
F@02oh/00ola0000F`03ohH00_ld0000GP03oh000olf0000H@03ogX00oli0000I002ogD00oll0000
IP03ofl00olo0000J@03ofX00_m20000K002ofD00om40000KP03oel00om70000L@03oeT00om:0000
M003oe@00_m=0000M`02odl00om?0000N@03odT00omB0000O003od<00omE0000O`03och00_mH0000
PP02ocT00omJ0000Q003oc<00omM0000Q`03obd00omP0000RP03obP00_mS0000S@02ob<00omU0000
S`03oad00omX0000TP03oaL00om[0000U@02oa<00_m^0000U`03o`d00om`0000VP03o`L00omc0000
W@07ogH0002N00GoM`0009h01Omg0000WP05ogL0002O00?oN0000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.85247, -0.820004, 0.017723, 
  0.00485551}},
  CellTags->"Deletion - mutant 4"],

Cell[TextData[{
  "Selective deletion 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.7381 .30902 L
s
.02 w
.7381 .45617 Mdot
0 w
.7381 .30902 m
.7381 .16187 L
s
.02 w
.7381 .30902 Mdot
0 w
.7381 .16187 m
.55679 .01472 L
s
.7381 .16187 m
.9194 .01472 L
s
1 g
.02 w
.55679 .01472 Mdot
.9194 .01472 Mdot
0 g
.7381 .16187 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`0009l000?o0000G0000ol0000I0000X0000ol0001J0003o`0001X0002Q00;o
F@000ol0000K0000X`000ol0001D00;o7P000:@000?o0000DP000ol0000N0000Y@000ol0001@0003
o`0001l0002V00;oC`000ol0000P0000Z0000ol0001:00;o8`000:T000?o0000B0000ol0000S0000
ZP000ol000160003o`0002@0002[00;oA@000ol0000U0000[@000ol000110003o`0002H0002^0003
o`0003h00_lY0000[`000ol0000l0003o`0002T0002`00;o>`000ol0000Z0000/P000ol0000g0003
o`0002/0002c0003o`0003@00_l^0000]0000ol0000b0003o`0002h0002e00;o<@000ol0000_0000
]`000ol0000]0003o`000300002h0003o`0002/000?o0000<@000;T000?o0000:002oc@0002j0003
o`0002H000?o0000=0000;/00_lU0003o`0003D0002m0003o`00024000?o0000=P000;h000?o0000
7P02ocT0002o0003o`0001`000?o0000>@000<000_lK0003o`0003X000320003o`0001L000?o0000
>`000<<000?o00005@000ol0000l0000a0000ol0000B00;o?`000<D00_lA0003o`0003l000370003
o`0000d000?o0000@0000<P000?o00002`000ol000110000b@000ol0000800;oA0000<X00_l70003
o`0004@0003<0003o`0000<000?o0000A@000<d00ol00`3o00170000c005odT0003<00GoB@000<`0
1Om90000c@03odX000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P0001800?oPP03odX0001700GoP005odT0001700GoP005odT0001700GoP005odT0
001800?oPP03odX0000g0003o`0000l000?o000040000ol0001`0003o`0004P0000h0003o`0000h0
00?o00003`000ol0001a0003o`0004P0000h0003o`0000h000?o00003`000ol0001a0003o`0004P0
000i0003o`0000d000?o00003P000ol0001b0003o`0004P0000i0003o`0000d000?o00003P000ol0
001b0003o`0004P0000i0003o`0000d000?o00003@000ol0001c0003o`0004P0000j0003o`0000`0
00?o00003@000ol0001c0003o`0004P0000j0003o`0000`000?o000030000ol0001d0003o`0004P0
000k0003o`0000/000?o000030000ol0001d0003o`0004P0000k0003o`0000/000?o00002`000ol0
001e0003o`0004P0000l0003o`0000X000?o00002`000ol0001e0003o`0004P0000l0003o`0000X0
00?o00002P000ol0001f0003o`0004P0000m0003o`0000T000?o00002P000ol0001f0003o`0004P0
000m0003o`0000T000?o00002@000ol0001g0003o`0004P0000n0003o`0000P000?o00002@000ol0
001g0003o`0004P0000n0003o`0000P000?o000020000ol0001h0003o`0004P0000o0003o`0000L0
00?o000020000ol0001h0003o`0004P0000o0003o`0000L000?o00001`000ol0001i0003o`0004P0
00100003o`0000H000?o00001`000ol0001i0003o`0004P000100003o`0000H000?o00001`000ol0
001i0003o`0004P000100003o`0000H000?o00001P000ol0001j0003o`0004P000110003o`0000D0
00?o00001P000ol0001j0003o`0004P000110003o`0000D000?o00001@000ol0001k0003o`0004P0
00120003o`0000@000?o00001@000ol0001k0003o`0004P000120003o`0000@000?o000010000ol0
001l0003o`0004P000130003o`0000<000?o000010000ol0001l0003o`0004P000130003o`0000<0
00?o00000`000ol0001m0003o`0004P000140003o`00008000?o00000`000ol0001m0003o`0004P0
00140003o`00008000?o00000P000ol0001n0003o`0004P000150005o`000?l010000ol0001n0003
o`0004P000150005o`000?l00`000ol0001o0003o`0004P000160004o`00o`<000?o0000O`000ol0
00180000AP001?l00?l20003o`00080000?o0000B00004H000Co003o0P000ol000200003o`0004P0
00170005o`3o0?l0P`000ol000180000A`001Ol0o`3o08<000?o0000B00004P00on200?oBP0004L0
1On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o>003o`03
0?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0000i0003
o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH00_lg0003
o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P0002001?lb00;o
=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc0000?o0000
;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d01?l/0003
o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80000d00?o
:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H00olh0000
>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0001100?o
8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob400om50000
A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0000L00?o
C00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X000?o0000
6@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H00_lG00Co
F00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0000C00;o
5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0000@0003
o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d000?o0000
3@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/000?o0000
2@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L00_l80003
o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol000030003
o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3oo`3o00;o
00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}},
  CellTags->"Deletion - mutant 5"],

Cell[TextData[{
  "Selective deletion 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 6",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.7381 .30902 L
s
.02 w
.7381 .45617 Mdot
0 w
.7381 .30902 m
.7381 .16187 L
s
.02 w
.7381 .30902 Mdot
0 w
.7381 .16187 m
.55679 .01472 L
s
.7381 .16187 m
.9194 .01472 L
s
1 g
.02 w
.55679 .01472 Mdot
.9194 .01472 Mdot
0 g
.7381 .16187 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`0009l000?o0000G0000ol0000I0000X0000ol0001J0003o`0001X0002Q00;o
F@000ol0000K0000X`000ol0001D00;o7P000:@000?o0000DP000ol0000N0000Y@000ol0001@0003
o`0001l0002V00;oC`000ol0000P0000Z0000ol0001:00;o8`000:T000?o0000B0000ol0000S0000
ZP000ol000160003o`0002@0002[00;oA@000ol0000U0000[@000ol000110003o`0002H0002^0003
o`0003h00_lY0000[`000ol0000l0003o`0002T0002`00;o>`000ol0000Z0000/P000ol0000g0003
o`0002/0002c0003o`0003@00_l^0000]0000ol0000b0003o`0002h0002e00;o<@000ol0000_0000
]`000ol0000]0003o`000300002h0003o`0002/000?o0000<@000;T000?o0000:002oc@0002j0003
o`0002H000?o0000=0000;/00_lU0003o`0003D0002m0003o`00024000?o0000=P000;h000?o0000
7P02ocT0002o0003o`0001`000?o0000>@000<000_lK0003o`0003X000320003o`0001L000?o0000
>`000<<000?o00005@000ol0000l0000a0000ol0000B00;o?`000<D00_lA0003o`0003l000370003
o`0000d000?o0000@0000<P000?o00002`000ol000110000b@000ol0000800;oA0000<X00_l70003
o`0004@0003<0003o`0000<000?o0000A@000<d00ol00`3o00170000c005odT0003<00GoB@000<`0
1Om90000c@03odX000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P000190003o`0008<000?o0000B00004T000?o0000P`000ol000180000B@000ol0
00230003o`0004P0001800?oPP03odX0001700GoP005odT0001700GoP005odT0001700GoP005odT0
001800?oPP03odX0000g0003o`0000l000?o000040000ol0001`0003o`0004P0000h0003o`0000h0
00?o00003`000ol0001a0003o`0004P0000h0003o`0000h000?o00003`000ol0001a0003o`0004P0
000i0003o`0000d000?o00003P000ol0001b0003o`0004P0000i0003o`0000d000?o00003P000ol0
001b0003o`0004P0000i0003o`0000d000?o00003@000ol0001c0003o`0004P0000j0003o`0000`0
00?o00003@000ol0001c0003o`0004P0000j0003o`0000`000?o000030000ol0001d0003o`0004P0
000k0003o`0000/000?o000030000ol0001d0003o`0004P0000k0003o`0000/000?o00002`000ol0
001e0003o`0004P0000l0003o`0000X000?o00002`000ol0001e0003o`0004P0000l0003o`0000X0
00?o00002P000ol0001f0003o`0004P0000m0003o`0000T000?o00002P000ol0001f0003o`0004P0
000m0003o`0000T000?o00002@000ol0001g0003o`0004P0000n0003o`0000P000?o00002@000ol0
001g0003o`0004P0000n0003o`0000P000?o000020000ol0001h0003o`0004P0000o0003o`0000L0
00?o000020000ol0001h0003o`0004P0000o0003o`0000L000?o00001`000ol0001i0003o`0004P0
00100003o`0000H000?o00001`000ol0001i0003o`0004P000100003o`0000H000?o00001`000ol0
001i0003o`0004P000100003o`0000H000?o00001P000ol0001j0003o`0004P000110003o`0000D0
00?o00001P000ol0001j0003o`0004P000110003o`0000D000?o00001@000ol0001k0003o`0004P0
00120003o`0000@000?o00001@000ol0001k0003o`0004P000120003o`0000@000?o000010000ol0
001l0003o`0004P000130003o`0000<000?o000010000ol0001l0003o`0004P000130003o`0000<0
00?o00000`000ol0001m0003o`0004P000140003o`00008000?o00000`000ol0001m0003o`0004P0
00140003o`00008000?o00000P000ol0001n0003o`0004P000150005o`000?l010000ol0001n0003
o`0004P000150005o`000?l00`000ol0001o0003o`0004P000160004o`00o`<000?o0000O`000ol0
00180000AP001?l00?l20003o`00080000?o0000B00004H000Co003o0P000ol000200003o`0004P0
00170005o`3o0?l0P`000ol000180000A`001Ol0o`3o08<000?o0000B00004P00on200?oBP0004L0
1On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o>003o`03
0?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0000i0003
o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH00_lg0003
o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P0002001?lb00;o
=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc0000?o0000
;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d01?l/0003
o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80000d00?o
:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H00olh0000
>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0001100?o
8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob400om50000
A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0000L00?o
C00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X000?o0000
6@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H00_lG00Co
F00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0000C00;o
5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0000@0003
o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d000?o0000
3@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/000?o0000
2@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L00_l80003
o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol000030003
o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3oo`3o00;o
00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}},
  CellTags->"Deletion - mutant 6"],

Cell[TextData[{
  "Selective deletion 6: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 7",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.395554 0.185872 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.39555 .60332 m
.02381 .45617 L
s
.39555 .60332 m
.27164 .45617 L
s
.39555 .60332 m
.51947 .45617 L
s
.39555 .60332 m
.7673 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.27164 .45617 m
.20428 .30902 L
s
.27164 .45617 m
.27164 .30902 L
s
.27164 .45617 m
.339 .30902 L
s
1 g
.02 w
.20428 .30902 Mdot
0 g
0 w
.27164 .30902 m
.27164 .16187 L
s
.02 w
.27164 .30902 Mdot
1 g
.27164 .16187 Mdot
.339 .30902 Mdot
0 g
.27164 .45617 Mdot
1 g
.51947 .45617 Mdot
0 g
0 w
.7673 .45617 m
.69994 .30902 L
s
.7673 .45617 m
.74485 .30902 L
s
.7673 .45617 m
.78975 .30902 L
s
.7673 .45617 m
.83466 .30902 L
s
1 g
.02 w
.69994 .30902 Mdot
.74485 .30902 Mdot
.78975 .30902 Mdot
0 g
0 w
.83466 .30902 m
.83466 .16187 L
s
.02 w
.83466 .30902 Mdot
0 w
.83466 .16187 m
.69312 .01472 L
s
.83466 .16187 m
.97619 .01472 L
s
1 g
.02 w
.69312 .01472 Mdot
.97619 .01472 Mdot
0 g
.83466 .16187 Mdot
.7673 .45617 Mdot
.39555 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000?l06`000<@000?o0000B0000ol000080000a@000ol000160003o`0000T0
00360003o`0004@000?o00002P000<L000?o0000@P000ol0000;0000b0000ol000100003o`0000`0
00390003o`0003h000?o00003@000<X000?o0000?0000ol0000>0000b`000ol0000j0003o`0000l0
003<0003o`0003P000?o000040000<d000?o0000=P000ol0000A0000cP000ol0000d0003o`000180
003?0003o`00038000?o00004`000=0000?o0000<0000ol0000D0000d@000ol0000^0003o`0001D0
003B0003o`0002`000?o00005P000=<000?o0000:P000ol0000G0000e0000ol0000X0003o`0001P0
003E0003o`0002H000?o00006@000=H000?o000090000ol0000J0000e`000ol0000S0003o`0001X0
003H0003o`00024000?o00006`000=T000?o00007`000ol0000L0000fP000ol0000M0003o`0001d0
003K0003o`0001/000?o00007P000=`000?o00006@000ol0000O0000g@000ol0000G0003o`000200
003N0003o`0001D000?o00008@000=l000?o00004`000ol0000R0000h0000ol0000A0003o`0002<0
003Q0003o`0000l000?o000090000>8000?o00003@000ol0000U0000h`000ol0000;0003o`0002H0
003T0003o`0000T000?o00009`000>D000?o00001`000ol0000X0000iP000ol000050003o`0002T0
003W0003o`0000<000?o0000:P000>P00ol00`3o000/0000i`05obh0003W00Go;P000>L01Ol^0000
j003obl0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001<0003o`0009/000?o0000;@0004`000?o0000V`000ol0000]0000C0000ol0002K0003
o`0002d0001;00?oVP03obl0001:00GoV005obh0001:00GoV005obh0001:00GoV005obh0001;00?o
VP03obl0000j0003o`0000l000?o00003`000ol0001T0003o`0000T000?o00002@000ol000090003
o`0002h0000k0003o`0000h000?o00003P000ol0001V0003o`0000T000?o00001`000ol000090003
o`0002l0000k0003o`0000h000?o00003P000ol0001V0003o`0000T000?o00001`000ol000090003
o`0002l0000l0003o`0000d000?o00003@000ol0001X0003o`0000P000?o00001`000ol000080003
o`000300000l0003o`0000d000?o00003@000ol0001X0003o`0000P000?o00001`000ol000080003
o`000300000l0003o`0000d000?o00003@000ol0001X0003o`0000P000?o00001`000ol000080003
o`000300000m0003o`0000`000?o000030000ol0001Z0003o`0000L000?o00001`000ol000070003
o`000340000m0003o`0000`000?o000030000ol0001Z0003o`0000L000?o00001`000ol000070003
o`000340000n0003o`0000/000?o00002`000ol0001/0003o`0000L000?o00001@000ol000070003
o`000380000n0003o`0000/000?o00002`000ol0001/0003o`0000L000?o00001@000ol000070003
o`000380000o0003o`0000X000?o00002P000ol0001^0003o`0000H000?o00001@000ol000060003
o`0003<0000o0003o`0000X000?o00002P000ol0001^0003o`0000H000?o00001@000ol000060003
o`0003<000100003o`0000T000?o00002@000ol0001`0003o`0000D000?o00001@000ol000050003
o`0003@000100003o`0000T000?o00002@000ol0001`0003o`0000D000?o00001@000ol000050003
o`0003@000110003o`0000P000?o000020000ol0001b0003o`0000@000?o00001@000ol000040003
o`0003D000110003o`0000P000?o000020000ol0001b0003o`0000D000?o00000`000ol000050003
o`0003D000120003o`0000L000?o00001`000ol0001d0003o`0000@000?o00000`000ol000040003
o`0003H000120003o`0000L000?o00001`000ol0001d0003o`0000@000?o00000`000ol000040003
o`0003H000130003o`0000H000?o00001P000ol0001f0003o`0000<000?o00000`000ol000030003
o`0003L000130003o`0000H000?o00001P000ol0001f0003o`0000<000?o00000`000ol000030003
o`0003L000130003o`0000H000?o00001P000ol0001f0003o`0000<000?o00000`000ol000030003
o`0003L000140003o`0000D000?o00001@000ol0001h0003o`00008000?o00000`000ol000020003
o`0003P000140003o`0000D000?o00001@000ol0001h0003o`0000<000Go0000o`050003o`0003P0
00150003o`0000@000?o000010000ol0001j0003o`00008000Go0000o`040003o`0003T000150003
o`0000@000?o000010000ol0001j0003o`00008000Go0000o`040003o`0003T000160003o`0000<0
00?o00000`000ol0001l0005o`000?l00`001Ol0003o03`000160003o`0000<000?o00000`000ol0
001l0005o`000?l00`001Ol0003o03`000170003o`00008000?o00000P000ol0001n0004o`00o`<0
00Co003o?@0004L000?o00000P000ol000020003o`0007h000Co003o0`001?l00?lm0000B0001Ol0
003o00<000?o0000P0001_l00?l0o`8000?o0000?00004P000Go0000o`030003o`00080000Ko003o
0?l20003o`0003`000190004o`00o`8000?o0000PP001ol0o`3o0?l0?`0004T000Co003o0P000ol0
00220007o`3o0?l0o`0o0000B@001?l00?l20003o`00088000Oo0?l0o`3o03l0001:0005o`3o0?l0
QP02o`030?oo0400001:0005o`3o0?l0QP02o`030?oo0400001;00?oR003od40001:00GoQP05od00
001:00GoQP05od00000900?o?P05oh@01om000003002ocd00on300;o0`03od40000>00?o?@000ol0
000n0003o`0003`00om900004@02oc`000?o0000?0000ol0000k00;oC00001<00olj0003o`0003X0
00?o0000>@03odh0000F00;o>@000ol0000h0003o`0003P00_mA00006003ocL000?o0000=`000ol0
000e00?oD`0001/00old0003o`0003H000?o0000<`03oeH0000N00;o<`000ol0000d0003o`000380
0_mI00008003oc4000?o0000<P000ol0000`00?oF`0002<00_l`0003o`00030000?o0000;`02oeh0
000U00?o;P000ol0000^0003o`0002d00omP0000:002obd000?o0000;@000ol0000[00;oH`0002X0
0ol[0003o`0002/000?o0000:@03ofD0000]00;o:@000ol0000Z0003o`0002P00_mX0000;`03obL0
00?o0000:0000ol0000V00?oJP0003800_lV0003o`0002H000?o00009@02ofd0000d00?o90000ol0
000T0003o`0002<00om_0000=`02ob<000?o00008`000ol0000Q00;oLP0003T00olQ0003o`000240
00?o00007`03og@0000l00?o7`000ol0000O0003o`0001d00omg0000?`02oad000?o00007P000ol0
000L00;oNP0004400olK0003o`0001`000?o00006P03og`0001400;o6P000ol0000K0003o`0001P0
0_mo0000AP03oaP000?o00006@000ol0000F00?oP@0004T00_lG0003o`0001L000?o00005@02oh@0
001;00?o5@000ol0000E0003o`0001<00on60000CP02oa<000?o000050000ol0000B00;oR@000500
0olA0003o`00018000?o00004003oh/0001C00;o40000ol0000A0003o`0000h00_n>0000E@03o`h0
00?o00003`000ol0000<00?oT00005P00_l=0003o`0000d000?o00002`02oi<0001J00?o2`000ol0
000;0003o`0000T00onE0000G@03o`T000?o00002@000ol0000700?oV00006000_l70003o`0000P0
00?o00001P02oi/0001R00?o1@000ol000070003o`0000<00onM0000I@02o`@000?o00001@000ol0
000200;oX00006L00ol20003o`0000<000?o00000onR0000JP02o`030?l0008000Co0?ooY@0006`0
1onW0000K@05ojP0001]00GoZ00006d01OnX0000KP03ojT0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.13849, -0.820004, 0.01922, 
  0.00485551}},
  CellTags->"Deletion - mutant 7"],

Cell[TextData[{
  "Selective deletion 7: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 8",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.573047 0.201572 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.57305 .60332 m
.1699 .45617 L
s
.57305 .60332 m
.97619 .45617 L
s
.1699 .45617 m
.02381 .30902 L
s
.1699 .45617 m
.12121 .30902 L
s
.1699 .45617 m
.2186 .30902 L
s
.1699 .45617 m
.316 .30902 L
s
1 g
.02 w
.02381 .30902 Mdot
.12121 .30902 Mdot
.2186 .30902 Mdot
0 g
0 w
.316 .30902 m
.316 .16187 L
s
.02 w
.316 .30902 Mdot
0 w
.316 .16187 m
.16251 .01472 L
s
.316 .16187 m
.46949 .01472 L
s
1 g
.02 w
.16251 .01472 Mdot
.46949 .01472 Mdot
0 g
.316 .16187 Mdot
.1699 .45617 Mdot
1 g
.97619 .45617 Mdot
0 g
.57305 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`00030000?o0000i`00034000?o0000C0000ol0002G0000<P000ol0001:0003o`0009P0
000c0003o`0004P000?o0000V@0003@000?o0000AP000ol0002J0000=@000ol000140003o`0009/0
000f0003o`00048000?o0000W00003L000?o0000@0000ol0002M0000>0000ol0000n0003o`0009h0
000i0003o`0003`000?o0000W`0003X000?o0000>P000ol0002P0000>`000ol0000h0003o`000:40
000l0003o`0003H000?o0000XP0003d000?o0000=0000ol0002S0000?P000ol0000b0003o`000:@0
000o0003o`00030000?o0000Y@00040000?o0000;P000ol0002V0000@@000ol0000/0003o`000:L0
00120003o`0002X000?o0000Z00004<000?o00009`02oj/000140003o`0002D000?o0000Z`0004D0
00?o00008`000ol0002/0000AP000ol0000Q0003o`000:d000170003o`0001l000?o0000[P0004P0
00?o00007@000ol0002_0000B@000ol0000K0003o`000;00001:0003o`0001T000?o0000/@0004/0
00?o00005`000ol0002b0000C0000ol0000E0003o`000;<0001=0003o`0001<000?o0000]00004h0
00?o00004@000ol0002e0000C`000ol0000?0003o`000;H0001@0003o`0000d000?o0000]`000540
00?o00002`000ol0002h0000DP000ol000090003o`000;T0001C0003o`0000L000?o0000^P0005@0
00?o00001@000ol0002k0000E@000ol000030003o`000;`0001F00Go_`0005H01Ono0000EP05okl0
001F00Go_`0005L00oo00000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0002o0000F0000ol0
002o0000F0000ol0002o0000F0000ol0002o0000E`03ol00001F00Go_`0005H01Ono0000EP05okl0
00090003o`0004/00oo000002P000ol0000F0003o`0001H000?o00005`000ol0003100002`000ol0
000E0003o`0001H000?o00005P000ol00032000030000ol0000E0003o`0001D000?o00005@000ol0
003300003@000ol0000D0003o`0001@000?o00005@000ol0003400003P000ol0000C0003o`0001@0
00?o000050000ol0003500003`000ol0000C0003o`0001<000?o00004`000ol00036000040000ol0
000B0003o`00018000?o00004`000ol0003700004@000ol0000A0003o`00018000?o00004P000ol0
003800004P000ol0000A0003o`00014000?o00004@000ol0003900004`000ol0000@0003o`000100
00?o00004@000ol0003:000050000ol0000?0003o`00010000?o000040000ol0003;00005@000ol0
000?0003o`0000l000?o00003`000ol0003<00005P000ol0000>0003o`0000h000?o00003`000ol0
003=00005`000ol0000=0003o`0000h000?o00003P000ol0003>000060000ol0000=0003o`0000d0
00?o00003@000ol0003?00006@000ol0000<0003o`0000`000?o00003@000ol0003@00006P000ol0
000;0003o`0000`000?o000030000ol0003A00006`000ol0000;0003o`0000/000?o00002`000ol0
003B000070000ol0000:0003o`0000X000?o00002`000ol0003C00007@000ol000090003o`0000X0
00?o00002P000ol0003D00007P000ol000090003o`0000T000?o00002@000ol0003E00007`000ol0
00080003o`0000T000?o000020000ol0003F000080000ol000070003o`0000P000?o000020000ol0
003G00008@000ol000070003o`0000L000?o00001`000ol0003H00008P000ol000060003o`0000L0
00?o00001P000ol0003I00008`000ol000050003o`0000H000?o00001P000ol0003J000090000ol0
00050003o`0000D000?o00001@000ol0003K00009@000ol000040003o`0000D000?o000010000ol0
003L00009P000ol000030003o`0000@000?o000010000ol0003M00009`000ol000030003o`0000<0
00?o00000`000ol0003N0000:0000ol000020003o`0000<000?o00000P000ol0003O0000:@001Ol0
003o00@000?o00000P000ol0003P0000:P001Ol0003o00<000Go0000o`3S0000:`001?l00?l30004
o`00on@0000/0003o`3o008000Co003oi@0002d000Oo0?l0o`3o0>H0000^00Goi`0002d01OoX0000
;@05onP0000]00Sof002o`/0000^00?o1003om800ol=0000>003ol`00ol@0000>`02olP00_lC0000
?@03ol800olE0000@003ok`00olH0000@`02okL00olK0000A@03ok800_lN0000B003oj`00olP0000
B`03ojH00olS0000CP02oj400olV0000D003oi`00_lY0000D`03oiH00ol[0000EP03oi000ol^0000
F@02oh/00ola0000F`03ohH00_ld0000GP03oh000olf0000H@03ogX00oli0000I002ogD00oll0000
IP03ofl00olo0000J@03ofX00_m20000K002ofD00om40000KP03oel00om70000L@03oeT00om:0000
M003oe@00_m=0000M`02odl00om?0000N@03odT00omB0000O003od<00omE0000O`03och00_mH0000
PP02ocT00omJ0000Q003oc<00omM0000Q`03obd00omP0000RP03obP00_mS0000S@02ob<00omU0000
S`03oad00omX0000TP03oaL00om[0000U@02oa<00_m^0000U`03o`d00om`0000VP03o`L00omc0000
W@07ogH0002N00GoM`0009h01Omg0000WP05ogL0002O00?oN0000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.85247, -0.820004, 0.017723, 
  0.00485551}},
  CellTags->"Deletion - mutant 8"],

Cell[TextData[{
  "Selective deletion 8: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.25889 .30902 L
s
.02 w
.25889 .45617 Mdot
1 g
.25889 .30902 Mdot
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;0000?o0000F`000ol000090000/@000ol0001I0003o`0000X0002b0003
o`0005L000?o00002`000;<00_mE00;o3P000;D000?o0000D@000ol0000>0000]P000ol0001?0003
o`0000l0002g0003o`0004d000?o000040000;P00_m;00;o4`000;X000?o0000A`000ol0000C0000
^`000ol000150003o`0001@0002l0003o`0004<000?o00005@000;d000?o0000@@000ol0000F0000
_P02ocl00_lI0000`0000ol0000k0003o`0001T000310003o`0003T000?o00006P000<8000?o0000
=`000ol0000K0000``02ocD00_lN0000a@000ol0000a0003o`0001h000360003o`0002l000?o0000
7`000<L000?o0000;@000ol0000P0000b0000ol0000[0003o`000240003900;o:@02ob@0003;0003
o`0002D000?o000090000<`000?o00008`000ol0000U0000c@000ol0000Q0003o`0002H0003>00;o
7`02obT0003@0003o`0001/000?o0000:@000=4000?o00006@000ol0000Z0000dP000ol0000G0003
o`0002/0003C0003o`0001D000?o0000;0000=@00_lC00;o;`000=H000?o00003`000ol0000_0000
e`000ol0000=0003o`000300003H0003o`0000/000?o0000<@000=T00_l900;o=0000=/000?o0000
1@000ol0000d0000g0000ol000030003o`0003D0003M00Go>0000=d01Olh0000g@05ocP0003M00Go
>0000=h00oli0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000
g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000
g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000
g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000
g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000
g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000
g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000g`000ol0000h0000
g`000ol0000h0000g`000ol0000h0000gP03ocT0003M00Go>0000=d01Olh0000g@05ocP0003N00?o
>@0004T000?o0000KP000ol000090003o`0000T000?o00002@000ol0000i0000B@000ol0001_0003
o`0000T000?o00001`000ol000090003o`0003X000190003o`0006l000?o00002@000ol000070003
o`0000T000?o0000>P0004T000?o0000L0000ol000080003o`0000L000?o000020000ol0000k0000
B@000ol0001`0003o`0000P000?o00001`000ol000080003o`0003/000190003o`00070000?o0000
20000ol000070003o`0000P000?o0000>`0004T000?o0000L@000ol000070003o`0000L000?o0000
1`000ol0000l0000B@000ol0001a0003o`0000L000?o00001`000ol000070003o`0003`000190003
o`00078000?o00001`000ol000050003o`0000L000?o0000?@0004T000?o0000LP000ol000070003
o`0000D000?o00001`000ol0000m0000B@000ol0001c0003o`0000H000?o00001@000ol000060003
o`0003h000190003o`0007<000?o00001P000ol000050003o`0000H000?o0000?P0004T000?o0000
M0000ol000050003o`0000D000?o00001@000ol0000o0000B@000ol0001d0003o`0000D000?o0000
1@000ol000050003o`0003l000190003o`0007D000?o000010000ol000050003o`0000@000?o0000
@00004T000?o0000M@000ol000050003o`0000<000?o00001@000ol000100000B@000ol0001f0003
o`0000@000?o00000`000ol000040003o`00044000190003o`0007H000?o000010000ol000030003
o`0000@000?o0000@@0004T000?o0000M`000ol000030003o`0000<000?o00000`000ol000120000
B@000ol0001g0003o`0000<000?o00000`000ol000030003o`00048000190003o`0007L000?o0000
0`000ol000030003o`0000<000?o0000@P0004T000?o0000N0000ol000020003o`0000<000?o0000
0P000ol000130000B@000ol0001h0003o`0000<000Go0000o`050003o`0004<000190003o`0007T0
00?o00000P001Ol0003o00@000?o0000A00004T000?o0000N@000ol000020005o`000?l010000ol0
00140000B@000ol0001j0005o`000?l00`001Ol0003o04L000190003o`0007X000Go0000o`030005
o`000?l0A`0004T000?o0000N`001?l00?l30004o`00odP000190003o`0007/000Co003o0`001?l0
0?m80000B@000ol0001l0006o`00o`3o0P000ol000170000B@000ol0001l0006o`00o`3o0P000ol0
00170000B@000ol0001m0007o`3o0?l0o`1:0000B@000ol0001m0007o`3o0?l0o`1:0000B@000ol0
001m0007o`3o0?l0o`1:0000B@000ol0001n00;o00<0ool0B`0004T000?o0000OP02o`030?oo04/0
001700?oP@03od`0001600GoO`05od/000090003o`0003X01Omo00GoB`0000X00oli00KoOP05ocX0
0ol>00003@03ocL00ol200;oNP02o`040?ooocP00olA00004003oc/00_lj0003o`0003T00_lk00?o
500001<00olj0003o`0003L000?o0000>0000ol0000h00?o5`0001H01?lg00;o=`000ol0000f00;o
=`04oaX0000J00?o=P000ol0000d0003o`0003D000?o0000=003oah0000M00?o=002oc@000?o0000
<`02oc@00olQ00008003oc<000?o0000<@000ol0000a00;o<`03ob@0000S00?o<@02oc4000?o0000
<0000ol0000_00Co9`0002H01?l_00;o;`000ol0000^00;o;`03ob/0000Z00?o;P000ol0000/0003
o`0002`00_l^00?o;P0002d00ol/00;o;0000ol0000[0003o`0002/00ola0000<003ob/000?o0000
:@000ol0000Y00;o:`03oc@0000c00?o:@02obT000?o0000:0000ol0000W00Co=`0003H01?lW00;o
9`000ol0000V00;o9`03oc/0000j00?o9P000ol0000T0003o`0002@00_lV00?o?P0003d00olT00;o
90000ol0000S0003o`0002<00om10000@003ob<000?o00008@000ol0000Q00;o8P04od@0001300?o
8@02ob4000?o000080000ol0000O00?oB00004H01?lO00;o7`000ol0000N00;o7`03od/0001:00?o
7P000ol0000L0003o`0001`00_lN00?oCP0004d00olL00;o70000ol0000K0003o`0001/00omA0000
D003oa/000?o00006@000ol0000I00;o6P04oe@0001C00?o6@02oaT000?o000060000ol0000G00?o
F00005H00olH0003o`0001H000?o00005P02oaL00omK0000F@04oaD00_lF0003o`0001@00_lF00?o
GP0005d00olD00;o50000ol0000C0003o`0001801?mQ0000H003oa<000?o00004@000ol0000A00;o
4P03ofD0001S00?o4@02oa4000?o000040000ol0000?00?oJ00006H00ol@0003o`0000h000?o0000
3P02o`l00om[0000J@04o`d00_l>0003o`0000`00_l>00?oKP0006d00ol<00;o30000ol0000;0003
o`0000X01?ma0000L003o`/000?o00002@000ol0000900;o2P03ogD0001c00?o2@02o`T000?o0000
1`02o`T00omh0000MP03o`P000?o00001P000ol000060003o`0000H00omk0000N@04o`D00_l60003
o`0000@00_l500CoOP0007d00ol40003o`0000<000?o00000`000ol0000200?oPP0008000ol200;o
0`001?l00002o`800on50000P`03o`060?oo0?l00_l0103ooon80000QP09oh/0002800GoS@0008P0
1On=0000R005ohd0002900?oSP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1095, -0.820004, 0.0151971, 
  0.00485551}},
  CellTags->"Deletion - mutant 9"],

Cell[TextData[{
  "Selective deletion 9: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Deletion - mutant 10",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.02 w
.66907 .30902 Mdot
.71509 .30902 Mdot
.7611 .30902 Mdot
0 g
0 w
.80712 .30902 m
.80712 .16187 L
s
.02 w
.80712 .30902 Mdot
0 w
.80712 .16187 m
.80712 .01472 L
s
.02 w
.80712 .16187 Mdot
1 g
.80712 .01472 Mdot
0 g
.7381 .45617 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000?l06`000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>80
00?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>80
00?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>80
00?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>80
00?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>80
00?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>80
00?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>8000?o0000=@000>80
00?o0000=@000>8000?o0000=@000>8000?o0000=@000>400olf0000h005ocD0003P00Go=@000>00
1Ole0000h@03ocH000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D000190003o`0009H000?o0000=@0004T000?o0000UP000ol0000e0000B@000ol0
002F0003o`0003D0001800?oUP03ocH0001700GoU005ocD0001700GoU005ocD0001700GoU005ocD0
001800?oUP03ocH0000g0003o`0000l000?o000040000ol0001M0003o`0000T000?o00002P000ol0
00090003o`0003H0000h0003o`0000h000?o00003`000ol0001O0003o`0000T000?o000020000ol0
00090003o`0003L0000h0003o`0000h000?o00003`000ol0001O0003o`0000T000?o000020000ol0
00090003o`0003L0000i0003o`0000d000?o00003P000ol0001Q0003o`0000P000?o000020000ol0
00080003o`0003P0000i0003o`0000d000?o00003P000ol0001Q0003o`0000P000?o000020000ol0
00080003o`0003P0000i0003o`0000d000?o00003@000ol0001S0003o`0000L000?o000020000ol0
00080003o`0003P0000j0003o`0000`000?o00003@000ol0001S0003o`0000L000?o000020000ol0
00070003o`0003T0000j0003o`0000`000?o000030000ol0001U0003o`0000L000?o00001`000ol0
00070003o`0003T0000k0003o`0000/000?o000030000ol0001U0003o`0000L000?o00001P000ol0
00070003o`0003X0000k0003o`0000/000?o00002`000ol0001W0003o`0000H000?o00001P000ol0
00070003o`0003X0000l0003o`0000X000?o00002`000ol0001W0003o`0000H000?o00001P000ol0
00060003o`0003/0000l0003o`0000X000?o00002P000ol0001Y0003o`0000D000?o00001P000ol0
00060003o`0003/0000m0003o`0000T000?o00002P000ol0001Y0003o`0000D000?o00001P000ol0
00050003o`0003`0000m0003o`0000T000?o00002@000ol0001[0003o`0000D000?o00001@000ol0
00050003o`0003`0000n0003o`0000P000?o00002@000ol0001[0003o`0000D000?o00001@000ol0
00040003o`0003d0000n0003o`0000P000?o000020000ol0001]0003o`0000@000?o000010000ol0
00050003o`0003d0000o0003o`0000L000?o000020000ol0001]0003o`0000@000?o000010000ol0
00040003o`0003h0000o0003o`0000L000?o00001`000ol0001_0003o`0000<000?o000010000ol0
00040003o`0003h000100003o`0000H000?o00001`000ol0001_0003o`0000@000?o00000`000ol0
00030003o`0003l000100003o`0000H000?o00001`000ol0001_0003o`0000@000?o00000`000ol0
00030003o`0003l000100003o`0000H000?o00001P000ol0001a0003o`0000<000?o00000`000ol0
00030003o`0003l000110003o`0000D000?o00001P000ol0001a0003o`0000<000?o00000`000ol0
00020003o`00040000110003o`0000D000?o00001@000ol0001c0003o`00008000?o00000P000ol0
00030003o`00040000120003o`0000@000?o00001@000ol0001c0003o`00008000?o00000P000ol0
00020003o`00044000120003o`0000@000?o000010000ol0001e0003o`00008000Go0000o`040003
o`00044000130003o`0000<000?o000010000ol0001e0003o`00008000Go0000o`030003o`000480
00130003o`0000<000?o00000`000ol0001g0005o`000?l00`001Ol0003o04@000140003o`000080
00?o00000`000ol0001g0005o`000?l00`001?l00?m50000A0000ol000020003o`00008000?o0000
N@001?l00?l30004o`00odD000150005o`000?l010000ol0001i0004o`00o`8000Co003oAP0004D0
00Go0000o`030003o`0007/000Ko003o0?l20003o`0004@000160004o`00o`<000?o0000N`002?l0
0?l0o`3oA`0004H000Co003o0P000ol0001m0007o`3o0?l0o`170000AP001?l00?l20003o`0007d0
00Oo0?l0o`3o04L000170005o`3o0?l0P@02o`030?oo04P000170005o`3o0?l0P@02o`030?oo04P0
001800?oPP04odT0001700GoP005odT000090003o`0003/01On000GoB@0000X00olj00GoP005oc/0
0ol;00003@03ocP00ol00`3oo`1m00Go>@03o`h0000@00?o>`02oc`000?o0000>P02oc/00olA0000
4`04ocT000?o0000>@000ol0000i0003o`0003L01?lD00005`03ocL00_li0003o`0003L00_lg00?o
600001X00olf00;o=`000ol0000e00;o=P03oa/0000M00?o=@000ol0000d0003o`0003@000?o0000
<`03oah0000P00Co<P02oc@000?o0000<P02oc801?lQ00009003oc400_lb0003o`0003000_la00?o
9@0002L00ol`0003o`0002l000?o0000;`000ol0000^00?o:00002X00ol^00;o;`000ol0000]00;o
;P03ob/0000]00Co;0000ol0000/0003o`0002`000?o0000:P04obh0000a00?o:P02ob`000?o0000
:P02obX00olb0000=003obT00_lZ0003o`0002P00_lY00?o=@0003L00olX0003o`0002L000?o0000
9`000ol0000V00?o>00003X01?lU00;o9`000ol0000U00;o9@04oc/0000n00?o9002obD000?o0000
8`02ob@00olo0000@@03ob<000?o00008P000ol0000R0003o`0002400om20000A003ob400_lR0003
o`0002000_lQ00?oA@0004L01?lO00;o80000ol0000N00;o7`04odP0001;00?o7P000ol0000M0003
o`0001d000?o00007003od`0001>00?o7002oad000?o00006`02oa`00om?0000D@03oa/000?o0000
6P000ol0000J0003o`0001T00omB0000E003oaT00_lJ0003o`0001P00_lI00?oE@0005L01?lG00;o
60000ol0000F00;o5`04oeP0001K00?o5P000ol0000E0003o`0001D000?o00005003oe`0001N00?o
5002oaD000?o00004`02oa@00omO0000H@03oa<00_lC0003o`0001400_lC00?oHP0006@01?lA0003
o`00010000?o000040000ol0000?00CoI@0006P00ol?00;o40000ol0000>00;o3`03ofT0001[00?o
3P000ol0000=0003o`0000d000?o00003003of`0001^00?o3002o`d000?o00002`02o``00om_0000
L@04o`X00_l;0003o`0000T00_l:00CoLP0007D00ol90003o`0000P000?o000020000ol0000700?o
MP0007P00ol700;o20000ol0000600;o1`03ogT0001k00?o1P02o`H000?o00001002o`H00oml0000
OP04o`@000?o00000`000ol000030003o`0000801?mo0000PP03o`800_l30004o`0000;o0P03oh<0
002500?o00H0ool0o`02o`040?ooohH0002800WoR@0008X01On;0000RP05oh/0002:00GoR`0008/0
0on<0000o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}},
  CellTags->"Deletion - mutant 10"],

Cell[TextData[{
  "Selective deletion 10: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Deletion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Deletion - mutant 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Inversion"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Inversion - Intro"],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Mshowa
P
.004 w
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Mshowa
P
1 g
.04 w
.20018 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Mshowa
P
1 g
.05 w
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Mshowa
P
1 g
.52939 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Mshowa
P
1 g
.57643 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.004 w
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.62346 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`0004/00_l200;o^@05o`/0001<0004o`00ok/000Go0000o`0:0000C004ok/000Go0000o`0:0000
C0001?l00?nk00Co2`0004d00_nl0005o`000?l02P0004`00ol600;o[P02o`<01Ol;0000E`03ojP0
0olE0000FP02oj@00_lH0000G002oil00olJ0000GP03oiX00_lM0000H@02oiH00_lO0000H`03oi00
0olQ0000IP02oh`00_lT0000J002ohL00olV0000JP03oh800_lY0000K@02ogh00_l[0000K`02ogT0
0ol]0000L@03og@00_l`0000M002ofl00olb0000MP03ofX00_le0000N@02ofH00_lg0000N`02of40
0oli0000O@03oe`00_ll0000P002oeL00oln0000PP02oe<00_m10000Q003odh00_m30000Q`02odT0
0om50000R@03od@00_m80000S002ocl00om:0000SP02oc/00_m=0000T003ocH00_m?0000T`02oc40
0omA0000U@02obd00_mD0000U`03obL00omF0000VP02ob<00_mI0000W003oah00_mK0000W`02o`X0
00G>g/kNcP0:00?oG@000:400_l600W>1P02of00002S00?o0P000mk>gP03o`05g/kNc]h00P03of80
002V00;o1/h00oo>cP02cP;oI@0003/00omY0004c]k>gPCo00G>g/kNcP1V0000?0000ol0001X00?>
00Goc/k>o`05cVH0000i00GoJ@003LkNc_o>g/koc]k>g/h0IP0003X000?o0?l0JP03cP05olk>c_l0
1LiV0000>P000ol0o`1Z0004c]k>gPGo00CNc]k>IP0003/00_m[00_>I`000:P000_Nc]k>g/kNc]k>
gP1W0000Z@09cVP0000k0003o`0006d000G>g/kNcP1Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>`000ol0001_0003o`0006X0000k0003
o`0006l000?o0000JP0003/000?o0000K`000ol0001Z0000>@001LkNc]k>06d000G>g/kNcP1Z0000
=`09cVT02LiX0000=P000mk>gP03o`05g/kNc]h0I`000mk>gP03o`05g/kNc]h0I`0003H01/h00oo>
cP02cVL01/h00oo>cP02cVL0000U00Go2`001<kNc]h4o`05c]k>g/h02P03ocD01_l700Go2005o`@0
00C>g/kN1?l01LkNc]k>06H0000V0005o`000?l02P03cP05olk>c_l01Lh=0003o`0003<000?o0000
2P001Ol0003o00P000Go0000o`0300?>00Goc/k>o`05cVH0000V0005o`000?l02P003LkNc_o>g/ko
c]k>g/h03@000ol0000c0003o`0000X000Go0000o`080005o`000?l00`003LkNc_o>g/koc]k>g/h0
IP0002H01?l;00?>00Goc/k>o`05cP/00_lf00Co2@001Ol0003o00P01?l400?>00Goc/k>o`05cVH0
000V0005o`000?l02P001<kNc]h5o`04g/kNcPd000?o0000<`000ol0000:0005o`000?l020001Ol0
003o00<000C>g/kN1Ol01=k>g/iV00009@05o``02lh;00?o=@06o`L01Ol800Go1@0;cVL0000f000;
g/kNc]k>g/kNc]h0I`002mk>g/kNc]k>g/kN06L0000g00W>J@09cVP0000[0003o`0000/000G>g/kN
cP0=0003o`0003`000?o00007@001_o>g/kNcVX0000[0003o`0000d000?o00003@000ol0000l0003
o`0000P000?o000020000ol000070003o`0006d0000/0003o`0000`000?o000030000ol0000n0003
o`0000L000?o000020000ol000060003o`0006h0000/0003o`0000`000?o000030000ol0000n0003
o`0000L000?o000020000ol000060003o`0006h0000]0003o`0000/000?o00002`000ol000100003
o`0000H000?o00001`000ol000060003o`0006l0000]0003o`0000/000?o00002`000ol000100003
o`0000L000?o00001P000ol000060003o`0006l0000]0003o`0000/000?o00002`000ol000100003
o`0000L000?o00001P000ol000060003o`0006l0000^0003o`0000X000?o00002P000ol000120003
o`0000H000?o00001P000ol000050003o`000700000^0003o`0000X000?o00002P000ol000120003
o`0000H000?o00001P000ol000050003o`000700000_0003o`0000T000?o00002@000ol000140003
o`0000D000?o00001@000ol000050003o`000740000_0003o`0000T000?o00002@000ol000140003
o`0000D000?o00001@000ol000050003o`000740000`0003o`0000P000?o000020000ol000160003
o`0000@000?o00001@000ol000040003o`000780000`0003o`0000P000?o000020000ol000160003
o`0000D000?o000010000ol000040003o`000780000a0003o`0000L000?o00001`000ol000180003
o`0000@000?o000010000ol000030003o`0007<0000a0003o`0000L000?o00001`000ol000180003
o`0000@000?o000010000ol000030003o`0007<0000b0003o`0000H000?o00001P000ol0001:0003
o`0000<000?o00000`000ol000030003o`0007@0000b0003o`0000H000?o00001P000ol0001:0003
o`0000<000?o00000`000ol000030003o`0007@0000c0003o`0000D000?o00001@000ol0001<0003
o`00008000?o00000`000ol000020003o`0007D0000c0003o`0000D000?o00001@000ol0001<0003
o`0000<000?o00000P000ol000020003o`0007D0000d0003o`0000@000?o000010000ol0001>0003
o`00008000?o00000P001Ol0003o07P0000d0003o`0000@000?o000010000ol0001>0003o`000080
00?o00000P001Ol0003o07P0000e0003o`0000<000?o00000`000ol0001@0005o`000?l00`001Ol0
003o07T0000e0003o`0000<000?o00000`000ol0001@0005o`000?l00`001Ol0003o07T0000f0003
o`00008000?o00000P000ol0001B0004o`00o`<000Co003oNP0003H000?o00000P000ol000020003
o`00058000Co003o0`001?l00?mj0000=P000ol000020003o`00008000?o0000DP001Ol0003o0080
00Co003oNP0003L000Go0000o`030003o`0005@000Ko003o0?l20003o`0007T0000g0005o`000?l0
0`000ol0001D0006o`00o`3o0P000ol0001i0000>0001oo>g/kNc_l0F0001ooNc]k>g_l0O00003L0
2LiF00W>N`0003H000?Nc]h00ol01Mk>g/kN05@000_>g/kNc]k>g/kNcP1j0000=P06cP03olk>00;>
E00;cWX0000800;o0P02obL000C>g/kN1?l01LkNc]k>02H01OlW0004g/kNcP;o00ONooo>g/kN02L0
1?m>00002@001?l00?lX00?>00Goc/k>o`05cRL000Go0000o`0V00C>00Coc/ko1LhX0003o`0004h0
000900Co:0003LkNc_o>g/koc]k>g/h09`001Ol0003o02H000gNc]k>olkNomk>g/kN02T000?o0000
C@0000T000Co003o:003cP05olk>c_l01LhW0005o`000?l09P04cP04olk>o`G>:P000ol0001<0000
2P02obT000C>g/kN1Ol01=k>g/hW0005o`000?l09P001=k>g/h4o`05g/kNc]h0:P000ol0001<0000
2@03o`H00_lR00_>9`05obP00lh00oo>cP05cR800_l400?oC`0001@00olO000;g/kNc]k>g/kNc]h0
E0002lkNooo>g/kNc]k>01l00omH00005`02oah02Lh00`3oo`1A0003o`3>00S>7P02oe/0000I00?o
7@001LkNc]k>00D000?o0000C002o`@000GNc]k>gP0N00;oG@0001`00_lV0003o`0002@000?o0000
8`000ol0000T00?oG`0001h00_lU0003o`0002<000?o00008P000ol0000S00;oHP0002000olS0003
o`00028000?o00008@000ol0000Q00?oI00002<00_lR00;o8P000ol0000P0003o`0002000_mW0000
9@03ob4000?o00007`000ol0000N00;o8@02ofT0000X00;o80000ol0000N0003o`0001d000?o0000
7P03of/0000Z00;o7`000ol0000M0003o`0001`000?o00007@02ofh0000/00?o7@000ol0000L0003
o`0001/000?o00007002og00000_00;o7002oa`000?o00006P000ol0000J00?oLP0003400olK0003
o`0001T000?o00006@000ol0000I00;oM@0003@00_lJ0003o`0001P000?o00005`02oaT00omg0000
=P02oaT000?o00005`000ol0000F0003o`0001L00_mj0000>003oaL000?o00005P000ol0000E0003
o`0001H00_ml0000>`02oaH00_lF0003o`0001@000?o00005003ogh0000m00?o5@000ol0000C0003
o`0001<000?o00004`02oh40001000;o50000ol0000B0003o`00018000?o00004P02oh<0001200;o
4`000ol0000A0003o`0001000_lB00?oQ@0004@00olA0003o`00010000?o00003`000ol0000@00;o
R00004L00_l@00;o40000ol0000>0003o`0000h00on:0000B@03o`l000?o00003@000ol0000=0003
o`0000d00_n=0000C002o`h000?o000030000ol0000<0003o`0000`00_n?0000CP02o`d000?o0000
2`000ol0000;0003o`0000X00onA0000D003o`/000?o00002P000ol0000900;o2`02oi@0001C00;o
2P02o`X000?o000020000ol0000900;oUP0005D00ol90003o`0000L000?o00001`000ol0000700?o
V00005P00_l80003o`0000H000?o00001P000ol0000600;oV`0005X00_l70003o`0000D000?o0000
1@000ol0000400?oW@0005`00ol50003o`0000@000?o00000`02o`D00_nP0000G`02o`@00_l00`3>
cP03cP<000?o00000`02oj80001Q00?o0P002]k>g/kNc]k>g_l300?oY00006@000?oc/h02Lh00`3o
o`2W0000I@001<kNc]h4o`04c]k>ojT0001T00K>00?oc/h01<jY0000I0003Mk>g/kNc_o>g/kNc]h0
Z@0006@01/h00oo>cP04cZT0001T0005g/kNc]h01?l01<kNc]jY0000I006cP03olk>00C>Z@0006D0
00G>g/kNcP03o`03c]k>0:X0001U00_>ZP0006H000WNc]k>g/kNc]h0Z`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.24067, -0.833976, 0.02093, 
  0.00501711}},
  CellTags->"Inversion - basic expression"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
TermPlot[theChromos, TreeWidth -> .2, 
                     LabelSize -> 0.02, LabelColor -> 0,
                     TextDisplay -> False
];\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;0000?o0000F`000ol000090000/@000ol0001I0003o`0000X0002b0003
o`0005L000?o00002`000;<00_mE00;o3P000;D000?o0000D@000ol0000>0000]P000ol0001?0003
o`0000l0002g0003o`0004d000?o000040000;P00_m;00;o4`000;X000?o0000A`000ol0000C0000
^`000ol000150003o`0001@0002l0003o`0004<000?o00005@000;d000?o0000@@000ol0000F0000
_P02ocl00_lI0000`0000ol0000k0003o`0001T000310003o`0003T000?o00006P000<8000?o0000
=`000ol0000K0000``02ocD00_lN0000a@000ol0000a0003o`0001h000360003o`0002l000?o0000
7`000<L000?o0000;@000ol0000P0000b0000ol0000[0003o`000240003900;o:@02ob@0003;0003
o`0002D000?o000090000<`000?o00008`000ol0000U0000c@000ol0000Q0003o`0002H0003>00;o
7`02obT0003@0003o`0001/000?o0000:@000=4000?o00006@000ol0000Z0000dP000ol0000G0003
o`0002/0003C0003o`0001D000?o0000;0000=@00_lC00;o;`000=H000?o00003`000ol0000_0000
e`000ol0000=0003o`000300003H0003o`0000/000?o0000<@000=T00_l900;o=0000=/000?o0000
1@000ol0000d0000g0000ol000030003o`0003D0003M00Go>0000=d01Olh0000g@05ocP0003M00Go
>0000=h00oli0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000A`03oi@00oli0000AP05oi801Olh0000AP05oi801Olh0000AP05oi801Olh0000
A`03oi@00oli0000=P000ol0000@0003o`0000l000?o0000G0000ol000090003o`0000T000?o0000
2@000ol0000i0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000P000?o0000JP000ol000040003o`0000D000?o0000
10000ol000100000?P000ol000080003o`0000P000?o0000JP000ol000050003o`0000<000?o0000
1@000ol000100000?P000ol000080003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000D000?o0000L0000ol000020003o`0000<000?o0000
0P000ol000130000@@000ol000050003o`0000D000?o0000L0000ol000030005o`000?l01@000ol0
00130000@@000ol000050003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000
@P000ol000040003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000@P000ol0
00040003o`0000<000?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`0000<0
00?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`00008000?o0000MP001?l0
0?l30004o`00odP000140003o`00008000?o00000P000ol0001f0004o`00o`<000Co003oB00004@0
00?o00000P001Ol0003o07X000Ko003o0?l20003o`0004L000150005o`000?l00`000ol0001h0006
o`00o`3o0P000ol000170000A@001Ol0003o008000?o0000NP001ol0o`3o0?l0BP0004H000Co003o
0P000ol0001j0007o`3o0?l0o`1:0000AP001?l00?l20003o`0007X000Oo0?l0o`3o04X000170005
o`3o0?l0OP02o`030?oo04/000170005o`3o0?l0OP02o`030?oo04/0001700CoP003od`0001600Go
O`05od/000090003o`0003X01Omo00GoB`0000X00oli00KoOP05ocX00ol>00003@03ocL00ol200;o
NP02o`040?ooocP00olA00004003oc/00_lj0003o`0003T00_lk00?o500001<00olj0003o`0003L0
00?o0000>0000ol0000h00?o5`0001H01?lg00;o=`000ol0000f00;o=`04oaX0000J00?o=P000ol0
000d0003o`0003D000?o0000=003oah0000M00?o=002oc@000?o0000<`02oc@00olQ00008003oc<0
00?o0000<@000ol0000a00;o<`03ob@0000S00?o<@02oc4000?o0000<0000ol0000_00Co9`0002H0
1?l_00;o;`000ol0000^00;o;`03ob/0000Z00?o;P000ol0000/0003o`0002`00_l^00?o;P0002d0
0ol/00;o;0000ol0000[0003o`0002/00ola0000<003ob/000?o0000:@000ol0000Y00;o:`03oc@0
000c00?o:@02obT000?o0000:0000ol0000W00Co=`0003H01?lW00;o9`000ol0000V00;o9`03oc/0
000j00?o9P000ol0000T0003o`0002@00_lV00?o?P0003d00olT00;o90000ol0000S0003o`0002<0
0om10000@003ob<000?o00008@000ol0000Q00;o8P04od@0001300?o8@02ob4000?o000080000ol0
000O00?oB00004H01?lO00;o7`000ol0000N00;o7`03od/0001:00?o7P000ol0000L0003o`0001`0
0_lN00?oCP0004d00olL00;o70000ol0000K0003o`0001/00omA0000D003oa/000?o00006@000ol0
000I00;o6P04oe@0001C00?o6@02oaT000?o000060000ol0000G00?oF00005H00olH0003o`0001H0
00?o00005P02oaL00omK0000F@04oaD00_lF0003o`0001@00_lF00?oGP0005d00olD00;o50000ol0
000C0003o`0001801?mQ0000H003oa<000?o00004@000ol0000A00;o4P03ofD0001S00?o4@02oa40
00?o000040000ol0000?00?oJ00006H00ol@0003o`0000h000?o00003P02o`l00om[0000J@04o`d0
0_l>0003o`0000`00_l>00?oKP0006d00ol<00;o30000ol0000;0003o`0000X01?ma0000L003o`/0
00?o00002@000ol0000900;o2P03ogD0001c00?o2@02o`T000?o00001`02o`T00omh0000MP03o`P0
00?o00001P000ol000060003o`0000H00omk0000N@04o`D00_l60003o`0000@00_l500CoOP0007d0
0ol40003o`0000<000?o00000`000ol0000200?oPP0008000ol200;o0`001?l00002o`800on50000
P`03o`060?oo0?l00_l0103ooon80000QP09oh/0002800GoS@0008P01On=0000R005ohd0002900?o
SP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1095, -0.820004, 0.0151971, 
  0.00485551}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of inverted mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
invChromos = Join @@ Table[
Inversion[theChromos, 
  Templates -> {{{_f}, 2},
                {{_h}, 2},
                {{g[x__]/; Length[{x}] > 1}, 1}
               },
  
  SelectionMode -> RANDOM], {10}]

invChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], D, g[B, g[4], 3], A, \
2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], h[E, D, B, g[g[A, B]]], 2, D]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, h[E, D, B, g[g[A, B]]], g[B, g[4], 3], D, 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, g[g[A, B]], B, D], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[B, A]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], 2, h[E, D, B, g[g[A, B]]], D]]], 
 
  chromo[q[undef], p[f[g[B, g[4], 3], A, D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], D, g[B, g[4], 3], A, \
2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], h[E, D, B, g[g[A, B]]], 2, D]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, h[E, D, B, g[g[A, B]]], g[B, g[4], 3], D, 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, g[g[A, B]], B, D], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[B, A]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], 2, h[E, D, B, g[g[A, B]]], D]]], 
 
  chromo[q[undef], p[f[g[B, g[4], 3], A, D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], D, g[B, g[4], 3], A, 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], h[E, D, B, g[g[A, B]]], 2, D]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, h[E, D, B, g[g[A, B]]], g[B, g[4], 3], D, 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, g[g[A, B]], B, D], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[B, A]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], 2, h[E, D, B, g[g[A, B]]], D]]]
chromo[q[undef], p[f[g[B, g[4], 3], A, D, h[E, D, B, g[g[A, B]]], 2]]]\
\>", 
"\<\
chromo[q[undef], p[f[h[E, D, B, g[g[A, B]]], D, g[B, g[4], 3], A, 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], h[E, D, B, g[g[A, B]]], 2, D]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, h[E, D, B, g[g[A, B]]], g[B, g[4], 3], D, 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, g[g[A, B]], B, D], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, g[g[A, B]], B], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[B, A]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], 2, h[E, D, B, g[g[A, B]]], D]]]
chromo[q[undef], p[f[g[B, g[4], 3], A, D, h[E, D, B, g[g[A, B]]], 2]]]\
\>"], 
  "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection"],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, LabelSize -> .04]& /@ \
invChromos;\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.550217 0.212987 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .0625 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .10366 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .14483 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .18599 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .34817 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .18599 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .12424 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .33723 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .48847 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .55022 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .55022 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .61196 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .55022 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .7632 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .55022 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.55022 .60332 m
.12424 .45617 L
s
.55022 .60332 m
.33723 .45617 L
s
.55022 .60332 m
.55022 .45617 L
s
.55022 .60332 m
.7632 .45617 L
s
.55022 .60332 m
.97619 .45617 L
s
.12424 .45617 m
.0625 .30902 L
s
.12424 .45617 m
.10366 .30902 L
s
.12424 .45617 m
.14483 .30902 L
s
.12424 .45617 m
.18599 .30902 L
s
1 g
.04 w
.0625 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .0625 .30902 0 0 Mshowa
P
1 g
.10366 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .10366 .30902 0 0 Mshowa
P
1 g
.14483 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .14483 .30902 0 0 Mshowa
P
0 w
.18599 .30902 m
.18599 .16187 L
s
.9 g
.04 w
.18599 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .18599 .30902 0 0 Mshowa
P
0 w
.18599 .16187 m
.02381 .01472 L
s
.18599 .16187 m
.34817 .01472 L
s
1 g
.04 w
.02381 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .01472 0 0 Mshowa
P
1 g
.34817 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .34817 .01472 0 0 Mshowa
P
.9 g
.18599 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .18599 .16187 0 0 Mshowa
P
.9 g
.12424 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .12424 .45617 0 0 Mshowa
P
1 g
.33723 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .33723 .45617 0 0 Mshowa
P
0 w
.55022 .45617 m
.48847 .30902 L
s
.55022 .45617 m
.55022 .30902 L
s
.55022 .45617 m
.61196 .30902 L
s
1 g
.04 w
.48847 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .48847 .30902 0 0 Mshowa
P
0 w
.55022 .30902 m
.55022 .16187 L
s
.9 g
.04 w
.55022 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .55022 .30902 0 0 Mshowa
P
1 g
.55022 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .55022 .16187 0 0 Mshowa
P
1 g
.61196 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .61196 .30902 0 0 Mshowa
P
.9 g
.55022 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .55022 .45617 0 0 Mshowa
P
1 g
.7632 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .7632 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Mshowa
P
.9 g
.55022 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .55022 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00000D00_l200;oA`05oid0
00060004o`00odT000Go0000o`2L00001P04odT000Go0000o`2L00001P001?l00?m900CoW@0000L0
0_m:0005o`000?l0W00000H00ol30003o`0004801_nM00003@000ol000100003o`000:40000>0003
o`0003h000?o0000XP0000l000?o0000?0000ol0002S000040000ol0000j0003o`000:@0000A0003
o`0003P000?o0000Y@0001800_lg0003o`000:H0000D0003o`0003<000?o0000Y`0001D000?o0000
<@000ol0002X00005P000ol0000^00;oZ`0001L000?o0000;0000ol0002[000060000ol0000Z0003
o`000:`0000I0003o`0002P000?o0000[@0001X000?o00009P000ol0002^00006`02obD000?o0000
[`0001d000?o00008@000ol0002`00007P000ol0000O0003o`000;40000O0003o`0001d000?o0000
/P00020000?o00006`000ol0002c00008@000ol0000I0003o`000;@0000R0003o`0001H00_ng0000
8`000ol0000D0003o`000;L0000T0003o`00018000?o0000^00002D00_lA0003o`000;T0000W0003
o`0000d000?o0000^P0002P000?o00002`000ol0002k0000:@000ol000090003o`000;`0000Z0003
o`0000L000?o0000_@0002/000?og_l00_l01=h00?o00000:`05gP03omko0<40000Z00?N1?l2gU80
0om/0000:P02gP05omkNg_l00]iC0003o`0006/0000Z00;N00Gog]kNo`02gU001Om/0000:P02gP05
omkNg_l00]iA0003o`3o06d0000Z00?N1Ol00mh0001?0003o`3o06d0000[00OND`02ofd0000/00GN
``0002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000_0003o`0005<000?o0000
K00002l000?o0000D`000ol0001/0000;`000ol0001C0003o`0006`0000/0005g_ooomh0DP03o`;N
K00002/01Mh00ooN001?00CN00?og]h0J`0000h01_l400Go1@05o`<00mh4o`;N@005o`T00]h4o`?N
2003oel0000?0003o`0000L000Go0000o`050005o`000?l00P02gP05omkNg_l00]i10005o`000?l0
20000mkogP02gP04omkNgP/000?o0000G00000l000?o00001`001Ol0003o00D000Go0000o`0200;N
00Gog]kNo`02gT4000Go0000o`080003g_oN00;N00Cog]kN2`000ol0001L00003`04o`H000Go0000
o`0500Co0`02gP05omkNg_l00]i100Co2@000mkogP02gP04omkNgPT00_mO00003`000ol000070005
o`000?l01@001Ol0003o00800mh5o`03gP0003l000Go0000o`0800;N1Ol2gP/000?o0000G00000h0
1_l400Go1@05o`@01mi100Go2P07gPT00omO0000;005gU801Mi/00004`000ol000060003o`0000D0
00?o00001P000ol000180003o`0000X000?o00002P000ol0001O00004`000ol000060003o`0000D0
00?o00001P000ol000180003o`0000X000?o00002P000ol0001O000050000ol000050003o`0000D0
00?o00001@000ol0001:0003o`0000T000?o00002@000ol0001P000050000ol000050003o`0000D0
00?o00001@000ol0001:0003o`0000T000?o00002@000ol0001P00005@000ol000040003o`0000D0
00?o000010000ol0001<0003o`0000P000?o000020000ol0001Q00005@000ol000040003o`0000D0
00?o000010000ol0001<0003o`0000P000?o000020000ol0001Q00005P000ol000040003o`0000<0
00?o000010000ol0001>0003o`0000L000?o00001`000ol0001R00005P000ol000040003o`0000<0
00?o000010000ol0001>0003o`0000L000?o00001`000ol0001R00005P000ol000040003o`0000<0
00?o000010000ol0001>0003o`0000L000?o00001`000ol0001R00005`000ol000030003o`0000<0
00?o00000`000ol0001@0003o`0000H000?o00001P000ol0001S00005`000ol000030003o`0000<0
00?o00000`000ol0001@0003o`0000H000?o00001P000ol0001S000060000ol000020003o`0000<0
00?o00000P000ol0001B0003o`0000D000?o00001@000ol0001T000060000ol000020003o`0000<0
00?o00000P000ol0001B0003o`0000D000?o00001@000ol0001T00006@000ol000020005o`000?l0
10000ol0001D0003o`0000@000?o000010000ol0001U00006@000ol000020005o`000?l010000ol0
001D0003o`0000@000?o000010000ol0001U00006@000ol000020005o`000?l010000ol0001D0003
o`0000@000?o000010000ol0001U00006P001Ol0003o00<000Go0000o`1H0003o`0000<000?o0000
0`000ol0001V00006P001Ol0003o00<000Go0000o`1H0003o`0000<000?o00000`000ol0001V0000
6`001?l00?l30004o`00oeX000?o00000P000ol000020003o`0006L0000K0004o`00o`<000Co003o
FP000ol000020003o`00008000?o0000I`0001`000Ko003o0?l20003o`0005X000Go0000o`030003
o`0006P0000L0006o`00o`3o0P000ol0001J0005o`000?l00`000ol0001X000070001_l00?l0o`80
00?o0000FP001Ol0003o00<000?o0000J00001d000Oo0?l0o`3o05h000Co003o0P000ol0001Y0000
7@001ol0o`3o0?l0GP001?l00?l20003o`0006T0000N00;o00<0ool0H0001Ol0o`3o06`0000N00GN
H003o`;NK00001d01miN00CN00?og]h0J`0001`00]h2o`03g_oo00;N:P05obd00]h4o`?N:P02o`80
0_l^00Co200001`00]h01?oNg_l3gR/000Go0000o`0/0003g_oN00;N00Cog]kN:`001?l00?l`0003
o`0000P0000L00;N00Cog]ko0mh[0005o`000?l0;0000mkogP02gP04omkNgR/01?la0003o`0000L0
000L00;N00Cog]ko0mh[0005o`000?l0;0000mkogP02gP04omkNgR/000Co003o<P000ol000060000
7002gPCo0mh3obP000Go0000o`0/00;N1Ol2gR`00_l[00?o1@000ol0000600007@000mkogP04gP@0
0olT00Go0`000ol0000X00ON:@000ol00003obP00ol500?o2@0001d00_l4gPP00olZ00;o:@05gRP0
0_l[00?o500002h00olY0003o`0002P000?o00009`000ol0000X00?o5`0003400olW00;o:0000ol0
000U00;o:003oaX0000d00?o9P000ol0000U0003o`0002@000?o00009@03oad0000g00?o9002obD0
00?o00008P02obD00olP0000>P03ob<000?o00008P000ol0000Q0003o`0002800olS0000?@03ob40
0_lR0003o`00020000?o00008003obH0001000?o80000ol0000O0003o`0001h00_lP00?o:@0004<0
0olN00;o7`000ol0000M0003o`0001d00ol/0000AP03oad000?o000070000ol0000K00;o7@03obl0
001900?o6`02oa`000?o00006P000ol0000J00?o<P0004`00olJ0003o`0001T000?o00006002oaX0
0ole0000C`03oaP00_lI0003o`0001L000?o00005`03ocP0001B00?o5`000ol0000F0003o`0001D0
0_lG00?o>`0005D00olE00;o5P000ol0000D0003o`0001@00oln0000F003oa@000?o00004`000ol0
000B00;o5003od40001K00?o4P02oa<000?o00004@000ol0000A00?oA00005h00olA0003o`000100
00?o00003`02oa400om70000H@03o`l00_l@0003o`0000h000?o00003P03odX0001T00?o3P000ol0
000=0003o`0000`00_l>00?oC@0006L00ol<00;o3@000ol0000;0003o`0000/00om@0000JP03o`/0
00?o00002P000ol0000900;o2`03oe<0001]00?o2@02o`X000?o000020000ol0000800?oEP000700
0ol80003o`0000L000?o00001`000ol0000600?oF@0007<00ol600;o1`000ol0000500;o1P03oe`0
001f00?o1@000ol000040003o`0000@000?o00000`03oel0001i00?o0`02o`@000?o00000P02o`<0
0omR0000O003o`8000?o0=h01=h0103o0003ofD0001o00?o00?Nool00_l2gP?oJ00008400mh00ooN
gP03gVX0002100?N00?og]h00miZ0000P@03gP03omkN00?NJP0008400]h4o`?NJP0008400mh00ooN
gP03gVX0002200;N0ol2gV/0002300GNK0000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.64276, -0.828671, 0.0198106,
   0.00573478}},
  CellTags->"Inversion - mutant 1"]
}, Open  ]],

Cell[TextData[{
  "Selective inversion 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .43097 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .47699 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .52301 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .56903 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .38773 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75033 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .56903 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.04 w
.19288 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Mshowa
P
0 w
.2619 .30902 m
.2619 .16187 L
s
.9 g
.04 w
.2619 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Mshowa
P
1 g
.2619 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Mshowa
P
1 g
.33093 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Mshowa
P
0 w
.5 .45617 m
.43097 .30902 L
s
.5 .45617 m
.47699 .30902 L
s
.5 .45617 m
.52301 .30902 L
s
.5 .45617 m
.56903 .30902 L
s
1 g
.04 w
.43097 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .43097 .30902 0 0 Mshowa
P
1 g
.47699 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .47699 .30902 0 0 Mshowa
P
1 g
.52301 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .52301 .30902 0 0 Mshowa
P
0 w
.56903 .30902 m
.56903 .16187 L
s
.9 g
.04 w
.56903 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .56903 .30902 0 0 Mshowa
P
0 w
.56903 .16187 m
.38773 .01472 L
s
.56903 .16187 m
.75033 .01472 L
s
1 g
.04 w
.38773 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .38773 .01472 0 0 Mshowa
P
1 g
.75033 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75033 .01472 0 0 Mshowa
P
.9 g
.56903 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .56903 .16187 0 0 Mshowa
P
.9 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .5 .45617 0 0 Mshowa
P
1 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00005/00_l200;oD005och0
001L0004o`00oe8000Go0000o`0m0000G004oe8000Go0000o`0m0000G0001?l00?mB00Co?P0005d0
0_mC0005o`000?l0?@0005`00ol30003o`0004/01_ln0000H`02odT00_m40000I@000ol000150003
o`0004@0001V0003o`0004<000?o0000A@0006L000?o0000@@000ol000160000J0000ol0000o0003
o`0004L0001Y00;o?@02odX0001[0003o`0003T000?o0000BP0006`000?o0000=`000ol0001;0000
K@000ol0000e0003o`0004`0001^00;o<`02odl0001`0003o`0002l000?o0000C`00074000?o0000
;@000ol0001@0000LP000ol0000[0003o`000540001c00;o:@02oe@0001e0003o`0002D000?o0000
E00007H000?o00008`000ol0001E0000M`000ol0000Q0003o`0005H0001h0003o`0001l000?o0000
E`0007T00_lM00;oFP0007/000?o00006@000ol0001J0000O0000ol0000G0003o`0005/0001m0003
o`0001D000?o0000G00007h00_lC00;oG`00080000?o00003`000ol0001O0000P@000ol0000=0003
o`00060000220003o`0000/000?o0000H@0008<000?o00002@000ol0001R0000Q002o`040?ooo`;N
00<0ool0I@0008H01=h00ooNgP1W0000@@03od400]h4o`?NIP00048000?o0000@0000mkogP02gP04
omkNgVH0000o00Go@@000mkogP02gP04omkNgVH000100003o`3o048000?Nomh00]h01?oNg]iV0000
@0000ol0o`1200;N1Ol2gVH0001100;o@`07gVL0002700GNJ000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P000110003o`0004D000?o0000J000044000?o0000A@000ol0001X0000
@@000ol000150003o`0006P0000n0005g_ooomh0A003o`;NJ00003d01Mh00ooN001100CN00?og]h0
I`0002d01Ol:00?N1?l2gPX00olD00Ko1@05o`D01Ol500;N1?l3gVH0000^0005o`000?l02@02gP05
omkNg_l00]h=0003o`00018000?o000020001Ol0003o00D000Go0000o`040003g_oN00;N00Cog]kN
IP0002h000Go0000o`0900;N00Gog]kNo`02gPd000?o00004P000ol000080005o`000?l01@001Ol0
003o00@000?Nomh00]h01?oNg]iV0000;P04o`X00]h01OoNg]ko00;N2`02oaD01?l70005o`000?l0
1@04o`D000?Nomh00]h01?oNg]iV0000;P001Ol0003o00T00mh5o`03gP0000/000?o00004P000ol0
00080005o`000?l01@001Ol0003o00@00]h5o`;NIP0002d01Ol;00ON2`03oa@01_l500Go1@05o`H0
1miW0000?P05gRP000?o00006@05gVP0000b0003o`0000`000?o00002`000ol0000I0003o`0000L0
00?o00001@000ol000070003o`0006X0000c0003o`0000/000?o00002P000ol0000K0003o`0000H0
00?o00001@000ol000060003o`0006/0000c0003o`0000/000?o00002P000ol0000K0003o`0000H0
00?o00001@000ol000060003o`0006/0000d0003o`0000X000?o00002P000ol0000K0003o`0000H0
00?o00001@000ol000060003o`0006/0000d0003o`0000X000?o00002@000ol0000M0003o`0000D0
00?o00001@000ol000050003o`0006`0000e0003o`0000T000?o00002@000ol0000M0003o`0000D0
00?o00001@000ol000050003o`0006`0000e0003o`0000T000?o000020000ol0000O0003o`0000D0
00?o00000`000ol000050003o`0006d0000f0003o`0000P000?o000020000ol0000O0003o`0000D0
00?o00000`000ol000050003o`0006d0000f0003o`0000P000?o00001`000ol0000Q0003o`0000@0
00?o00000`000ol000040003o`0006h0000g0003o`0000L000?o00001`000ol0000Q0003o`0000@0
00?o00000`000ol000040003o`0006h0000g0003o`0000L000?o00001P000ol0000S0003o`0000<0
00?o00000`000ol000030003o`0006l0000h0003o`0000H000?o00001P000ol0000S0003o`0000<0
00?o00000`000ol000030003o`0006l0000h0003o`0000H000?o00001@000ol0000U0003o`000080
00?o00000`000ol000020003o`000700000i0003o`0000D000?o00001@000ol0000U0003o`0000<0
00Go0000o`050003o`000700000i0003o`0000D000?o00001@000ol0000U0003o`0000<000Go0000
o`050003o`000700000i0003o`0000D000?o000010000ol0000W0003o`00008000Go0000o`040003
o`000740000j0003o`0000@000?o000010000ol0000W0003o`00008000Go0000o`040003o`000740
000j0003o`0000@000?o00000`000ol0000Y0005o`000?l00`001Ol0003o07@0000k0003o`0000<0
00?o00000`000ol0000Y0005o`000?l00`001Ol0003o07@0000k0003o`0000<000?o00000P000ol0
000[0004o`00o`<000Co003oM@0003`000?o00000P000ol000020003o`0002/000Oo0000o`3o00<0
00?o0000L`0003`000?o00000P001Ol0003o02l000Ko003o0?l20003o`0007@0000m0005o`000?l0
0`000ol0000]0006o`00o`3o0P000ol0001d0000?@001Ol0003o008000?o0000;`001ol0o`3o0?l0
M`0003h000Co003o0P000ol0000_0007o`3o0?l0o`1g0000?P001?l00?l20003o`0002l000Oo0?l0
o`3o07L0000n0006g_ooomko<`05gWP0000m00GN00?ogP00<@07gWL0000500;o0P02oc400mh4o`;N
<002gP;o00?Nool00]ha00Co=005o`P000060004o`00oc800]h01OoNg]ko00;N<002gP04omkNo`?N
<P000ol0000e0005o`000?l01`0000H01?lb00;N00Gog]kNo`02gS000]h01?oNg_l3gS<000?o0000
=0001Ol0003o00L000060004o`00o`<000?o0000;002gP05omkNg_l00]h`00;N00Cog]ko0mhd0003
o`00030000Co003o0`000ol0000500001`02o`D00ol[00?N1Ol00mko000^00;N1?l3gS@000?o0000
;@03o`<000Go0000o`0700001P03o`P01?lX00ON0P02obh000?Nomh01=h^00;o0P03ob`01?l500Go
200001D00olV00GN1@000ol0000[00;o1=h^0003o`0002h00olF00006003obh00_l^0003o`0002`0
0_l^00?o6@0001/01?l/00;o;0000ol0000Z00;o;004oa`0000O00?o:`000ol0000Y0003o`0002T0
00?o0000:@03ob00000R00?o:@02obT000?o00009`02obT00olS00009@04obL00_lW0003o`0002D0
0_lW00Co9P0002T00olV0003o`0002@000?o000090000ol0000T00?o:P0002`00olT00;o90000ol0
000R00;o9003obd0000_00Co8P02ob8000?o00008002ob801?l`0000<`03ob4000?o00007`000ol0
000O0003o`0001l00old0000=P03oal00_lO0003o`0001d00_lO00?o=`0003T01?lM00;o7@000ol0
000K00;o7@04ocX0000m00?o70000ol0000J0003o`0001X000?o00006P03och0001000?o6P02oaX0
00?o00006002oaX00om10000@`03oaT000?o00005`000ol0000G0003o`0001L00om40000AP04oaH0
0_lG0003o`0001D00_lF00CoA`0004X00olE00;o5@000ol0000C00;o5@03od/0001=00?o50000ol0
000B0003o`00018000?o00004P03odh0001@00Co4@02oa8000?o00004002oa401?mA0000E003oa00
0_l@0003o`0000h00_l@00?oE@0005L00ol?0003o`0000d000?o00003@000ol0000=00?oF00005X0
1?l<00;o3@000ol0000;00;o3004oe/0001N00?o2`02o`/000?o00002@02o`/00omO0000H@03o`X0
00?o000020000ol000080003o`0000P00omR0000I004o`L00_l80003o`0000H00_l700CoI@0006P0
0ol600;o1P000ol0000400;o1P03ofT0001[00?o1@000ol000030003o`0000<000?o00000`03of`0
001^00Co0P02o`030=kN00?N00<0ool00P04ofl0001b00?o00<0g_l00ol2gP040?ooog<0001e00?N
00?og]h00mif0000M@03gP03omkN00?NMP0007D00mh00ooNgP03gWH0001e00;N1?l3gWH0001e00?N
00?og]h00mif0000MP02gP?o0]ig0000M`05gWP00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15316, -0.828671, 0.0177215,
   0.00573478}},
  CellTags->"Inversion - mutant 2"],

Cell[TextData[{
  "Selective inversion 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .5798 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .9424 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .80712 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.04 w
.19288 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Mshowa
P
0 w
.2619 .30902 m
.2619 .16187 L
s
.9 g
.04 w
.2619 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Mshowa
P
1 g
.2619 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Mshowa
P
1 g
.33093 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .45617 0 0 Mshowa
P
0 w
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.04 w
.66907 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .30902 0 0 Mshowa
P
1 g
.71509 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .30902 0 0 Mshowa
P
0 w
.7611 .30902 m
.7611 .16187 L
s
.9 g
.04 w
.7611 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .30902 0 0 Mshowa
P
0 w
.7611 .16187 m
.5798 .01472 L
s
.7611 .16187 m
.9424 .01472 L
s
1 g
.04 w
.5798 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .5798 .01472 0 0 Mshowa
P
1 g
.9424 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .9424 .01472 0 0 Mshowa
P
.9 g
.7611 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .16187 0 0 Mshowa
P
1 g
.80712 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .80712 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00008T00_l200;oD005oa00
002:0004o`00oe8000Go0000o`0?0000RP04oe8000Go0000o`0?0000RP001?l00?mB00Co400008/0
0_mC0005o`000?l03`0008X00ol30003o`0004/01_l@0000T@02odT00_lF0000T`000ol000150003
o`0001H0002D0003o`0004<000?o00005`0009D000?o0000@@000ol0000H0000UP000ol0000o0003
o`0001T0002G00;o?@02oa`0002I0003o`0003T000?o0000700009X000?o0000=`000ol0000M0000
V`000ol0000e0003o`0001h0002L00;o<`02ob40002N0003o`0002l000?o00008@0009l000?o0000
;@000ol0000R0000X0000ol0000[0003o`0002<0002Q00;o:@02obH0002S0003o`0002D000?o0000
9P000:@000?o00008`000ol0000W0000Y@000ol0000Q0003o`0002P0002V0003o`0001l000?o0000
:@000:L00_lM00;o;0000:T000?o00006@000ol0000/0000ZP000ol0000G0003o`0002d0002[0003
o`0001D000?o0000;P000:`00_lC00;o<@000:h000?o00003`000ol0000a0000[`000ol0000=0003
o`000380002`0003o`0000/000?o0000<`000;4000?o00002@000ol0000d0000/P02o`040?ooo`;N
00<0ool0=`000;@01=h00ooNgP0i0000@@03ofl00]h4o`?N>000048000?o0000KP000mkogP02gP04
omkNgSP0000o00GoK`000mkogP02gP04omkNgSP000100003o`3o070000?Nomh00]h01?oNg]hh0000
@0000ol0o`1`00;N1Ol2gSP0001100;oL@07gST0002e00GN>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X0000n0005g_ooomh0LP03o`;N>P0003d01Mh00ooN001_00CN00?og]h0
>@0002d01Ol:00?N1?l2gPX00om<00Ko1@05o`D00]h4o`?N0`05oc00000^0005o`000?l02@02gP05
omkNg_l00]h=0003o`0004X000?o000020001Ol0003o00@000?Nomh00]h01?oNg]h40005o`000?l0
;`0002h000Go0000o`0900;N00Gog]kNo`02gPd000?o0000BP000ol000080005o`000?l010000mko
gP02gP04omkNgP@000Go0000o`0_0000;P04o`X00]h01OoNg]ko00;N2`02odd01?l70005o`000?l0
10000mkogP02gP04omkNgP@01?l`0000;P001Ol0003o00T00mh5o`03gP0000/000?o0000BP000ol0
00080005o`000?l01002gPGo0]h40005o`000?l0;`0002d01Ol;00ON2`03od`01_l500Go1P07gP@0
1Ol`0000?P05gW801Mhj0000<P000ol0000<0003o`0000/000?o0000D@000ol000070003o`0000H0
00?o00001`000ol0000a0000<`000ol0000;0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001P000ol0000b0000<`000ol0000;0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001P000ol0000b0000=0000ol0000:0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001@000ol0000c0000=0000ol0000:0003o`0000T000?o0000E@000ol000050003o`0000H0
00?o00001@000ol0000c0000=@000ol000090003o`0000T000?o0000E@000ol000050003o`0000D0
00?o00001@000ol0000d0000=@000ol000090003o`0000P000?o0000E`000ol000050003o`0000@0
00?o00001@000ol0000d0000=P000ol000080003o`0000P000?o0000E`000ol000050003o`0000@0
00?o000010000ol0000e0000=P000ol000080003o`0000L000?o0000F@000ol000040003o`0000@0
00?o000010000ol0000e0000=`000ol000070003o`0000L000?o0000F@000ol000040003o`0000@0
00?o00000`000ol0000f0000=`000ol000070003o`0000H000?o0000F`000ol000030003o`0000@0
00?o00000`000ol0000f0000>0000ol000060003o`0000H000?o0000F`000ol000030003o`0000<0
00?o00000`000ol0000g0000>0000ol000060003o`0000D000?o0000G@000ol000020003o`0000<0
00?o00000`000ol0000g0000>@000ol000050003o`0000D000?o0000G@000ol000030003o`000080
00?o00000P000ol0000h0000>@000ol000050003o`0000D000?o0000G@000ol000030003o`000080
00?o00000P000ol0000h0000>@000ol000050003o`0000@000?o0000G`000ol000020003o`000080
00?o00000P000ol0000h0000>P000ol000040003o`0000@000?o0000G`000ol000020005o`000?l0
10000ol0000i0000>P000ol000040003o`0000<000?o0000H@001Ol0003o00<000?o00000P000ol0
000i0000>`000ol000030003o`0000<000?o0000H@001Ol0003o00<000Go0000o`0l0000>`000ol0
00030003o`00008000?o0000H`001?l00?l30005o`000?l0?00003`000?o00000P000ol000020003
o`0006<000Go0000o`020004o`00ocd0000l0003o`00008000Go0000o`1W0004o`00o`8000Co003o
?@0003d000Go0000o`030003o`0006D000Ko003o0?l20003o`0003`0000m0005o`000?l00P000ol0
001W0005o`3o0?l00P000ol0000l0000?P001?l00?l20003o`0006L000Oo0?l0o`3o03l0000n0004
o`00o`8000?o0000I`001ol0o`3o0?l0?`0003h000KNoooog_m[00GN@00003d01Mh00ooN001Y00ON
?`0000D00_l200;o<@03gPCo0]ha00Go<P02gP;o00?Nool00]hb00Co200000H000Co003o<P02gP05
omkNg_l00]hb0005o`000?l0<@02gP04omkNo`?N<`000ol0000800001P04oc800]h01OoNg]ko00;N
<P001Ol0003o03400]h01?oNg_l3gS@000?o00001`0000H000Co003o0`000ol0000/00;N00Gog]kN
o`02gS8000Go0000o`0a00;N00Cog]ko0mh_0003o`0000<000?o00001P0000L00_l500?o:`03gPGo
00?No`00<0001Ol0003o03400]h4o`?N;003o`H000?o00001P0000H00ol800Co:007gP800_l^00Go
<002o`030=ko00GN:@04o`H00ol900005@03obH01Mh50003o`0005l000Co00000_l4gRL00olF0000
6003obh00_l^0003o`0002`00_l^00?o6@0001/01?l/00;o;0000ol0000Z00;o;004oa`0000O00?o
:`000ol0000Y0003o`0002T000?o0000:@03ob00000R00?o:@02obT000?o00009`02obT00olS0000
9@04obL00_lW0003o`0002D00_lW00Co9P0002T00olV0003o`0002@000?o000090000ol0000T00?o
:P0002`00olT00;o90000ol0000R00;o9003obd0000_00Co8P02ob8000?o00008002ob801?l`0000
<`03ob4000?o00007`000ol0000O0003o`0001l00old0000=P03oal00_lO0003o`0001d00_lO00?o
=`0003T01?lM00;o7@000ol0000K00;o7@04ocX0000m00?o70000ol0000J0003o`0001X000?o0000
6P03och0001000?o6P02oaX000?o00006002oaX00om10000@`03oaT000?o00005`000ol0000G0003
o`0001L00om40000AP04oaH00_lG0003o`0001D00_lF00CoA`0004X00olE00;o5@000ol0000C00;o
5@03od/0001=00?o50000ol0000B0003o`00018000?o00004P03odh0001@00Co4@02oa8000?o0000
4002oa401?mA0000E003oa000_l@0003o`0000h00_l@00?oE@0005L00ol?0003o`0000d000?o0000
3@000ol0000=00?oF00005X01?l<00;o3@000ol0000;00;o3004oe/0001N00?o2`02o`/000?o0000
2@02o`/00omO0000H@03o`X000?o000020000ol000080003o`0000P00omR0000I004o`L00_l80003
o`0000H00_l700CoI@0006P00ol600;o1P000ol0000400;o1P03ofT0001[00?o1@000ol000030003
o`0000<000?o00000`03of`0001^00Co0P02o`030=kN00?N00<0ool00P04ofl0001b00?o00<0g_l0
0ol2gP040?ooog<0001e00?N00?og]h00mif0000M@03gP03omkN00?NMP0007D00mh00ooNgP03gWH0
001e00;N1?l3gWH0001e00?N00?og]h00mif0000MP02gP?o0]ig0000M`05gWP00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15316, -0.828671, 0.0177215,
   0.00573478}},
  CellTags->"Inversion - mutant 3"],

Cell[TextData[{
  "Selective inversion 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
0 w
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Mshowa
P
1 g
.25889 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
.9 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
.9 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
.9 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00009800_l200;oC`05o`P0
002C0004o`00oe4000Go0000o`070000T`04oe4000Go0000o`070000T`001?l00?mA00Co200009@0
0_mB0005o`000?l01`0009<00ol30003o`0004X01_l80000VP000ol0001700;o3P0009/00_m60003
o`0000h0002M0003o`00048000?o00003`0009h000?o0000@0000ol0000@0000W`000ol0000n0003
o`000140002P0003o`0003/00_lD0000X@02ocX000?o000050000:<000?o0000=P000ol0000E0000
Y0000ol0000d0003o`0001H0002U0003o`0003400_lI0000YP000ol0000_0003o`0001T0002W00;o
;P000ol0000J0000Z@000ol0000Z0003o`0001/0002Z0003o`0002L00_lN0000Z`000ol0000U0003
o`0001h0002/0003o`0002<000?o00007`000:d00_lR0003o`000200002_0003o`0001h000?o0000
8@000;0000?o00006`02ob@0002a0003o`0001T000?o000090000;8000?o00005`000ol0000U0000
/`02oaH000?o00009P000;D000?o00004@02obT0002f0003o`0000l000?o0000:@000;L000?o0000
3@000ol0000Z0000^0000ol0000;0003o`0002/0002i00;o2P000ol0000/0000^`000ol0o`02o`;N
00<0ool0;`000;`01=h00ooNgP0a0000@003ogP00]h4o`?N<000044000?o0000M`000mkogP02gP04
omkNgS00000n00GoN0000mkogP02gP04omkNgS00000o0003o`3o07T000?Nomh00]h01?oNg]h`0000
?`000ol0o`1i00;N1Ol2gS00001000;oNP07gS40002m00GN<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`000380000n00?o0]ij00?o0]hb0000?@04gP03omkN07P01=h00ooNgP0a0000
;@05o`X00]h4o`?N2@03od/01_l500Go1P05o`@00]h4o`?N<00002h000Go0000o`090003g_oN00;N
00Cog]kN30000ol000190003o`0000P000Go0000o`060005o`000?l00`000mkogP02gP04omkNgS00
000^0005o`000?l02@000mkogP02gP04omkNgP`000?o0000B@000ol000080005o`000?l01P001Ol0
003o00<000?Nomh00]h01?oNg]h`0000;P04o`X000?Nomh00]h01?oNg]h:00;oC004o`L000Go0000
o`0600Co10000mkogP02gP04omkNgS00000^0005o`000?l02@02gPGo0]h<0003o`0004T000?o0000
20001Ol0003o00H000Go0000o`0300;N1Ol2gS00000]00Go2`07gPX00om;00Ko1@05o`H01Ol500ON
<@0003h01Mij00GN<P00038000?o00002`000ol0000;0003o`00050000?o00001`000ol000060003
o`0000H000?o0000=00003<000?o00002P000ol0000:0003o`00058000?o00001P000ol000060003
o`0000D000?o0000=@0003<000?o00002P000ol0000:0003o`00058000?o00001P000ol000060003
o`0000D000?o0000=@0003<000?o00002P000ol0000:0003o`00058000?o00001P000ol000060003
o`0000D000?o0000=@0003@000?o00002@000ol000090003o`0005@000?o00001@000ol000060003
o`0000@000?o0000=P0003@000?o00002@000ol000090003o`0005@000?o00001@000ol000050003
o`0000D000?o0000=P0003D000?o000020000ol000080003o`0005H000?o00001@000ol000040003
o`0000@000?o0000=`0003D000?o000020000ol000080003o`0005H000?o00001@000ol000040003
o`0000@000?o0000=`0003H000?o00001`000ol000070003o`0005P000?o000010000ol000040003
o`0000<000?o0000>00003H000?o00001`000ol000070003o`0005P000?o000010000ol000040003
o`0000<000?o0000>00003L000?o00001P000ol000060003o`0005X000?o00000`000ol000040003
o`00008000?o0000>@0003L000?o00001P000ol000060003o`0005X000?o00000`000ol000030003
o`0000<000?o0000>@0003P000?o00001@000ol000050003o`0005`000?o00000P000ol000030003
o`00008000?o0000>P0003P000?o00001@000ol000050003o`0005`000?o00000`000ol000020003
o`00008000?o0000>P0003P000?o00001@000ol000050003o`0005`000?o00000`000ol000020003
o`00008000?o0000>P0003T000?o000010000ol000040003o`0005h000?o00000P000ol000020005
o`000?l0?@0003T000?o000010000ol000040003o`0005h000?o00000P001Ol0003o00@000?o0000
>`0003X000?o00000`000ol000030003o`00060000Go0000o`030005o`000?l0?P0003X000?o0000
0`000ol000030003o`00060000Go0000o`030005o`000?l0?P0003/000?o00000P000ol000020003
o`00068000Co003o0`001?l00?lo0000>`000ol000020003o`00008000?o0000HP001Ol0003o0080
00Co003o?`0003`000Go0000o`030003o`0006@000Co003o0P000ol0o`100000?0001Ol0003o00<0
00?o0000I0001_l00?l0o`8000?o0000?P0003d000Co003o0P000ol0001V0007o`3o0?l0o`110000
?@001?l00?l20003o`0006H000Oo0?l0o`3o0440000m0004o`00o`8000?o0000IP001ol0o`3o0?l0
@@0003h00ol2gVX01Mi20000?@04gP03omkN06P01mi100001@02o`800_la00;N1?l3gS001Ola00;N
0_l00mkoo`02gS401?l;00001P001?l00?lb0003g_oN00;N00Cog]kN<@001Ol0003o03000]h01?oN
g_l3gS8000?o00002`0000H01?lb0003g_oN00;N00Cog]kN<@001Ol0003o03000]h01?oNg_l3gS<0
00?o00002P0000H000Co003o0`000ol0000/0003g_oN00;N00Cog]kN<@001Ol0003o03000]h01?oN
g_l3gRh000?o00000`000ol0000900001`02o`D00ol[00;N1Ol2gS4000Go0000o`0`00;N1?l3gR/0
0ol60003o`0000T0000600?o2004obP01mh00`3oo`0^00Go;`02o`030=ko00GN:@03o`H00ol<0000
5@03obH01Mh40003o`0005h000Co00000_l4gRH01?lH00006003obd00_l^0003o`0002/00_l]00?o
700001/00ol/00;o;0000ol0000Y00;o;003oal0000N00Co:P000ol0000Y0003o`0002P000?o0000
:@03ob80000R00?o:002obT000?o00009P02obP01?lU00009@03obL00_lW0003o`0002D000?o0000
9@03obT0000X00Co9@000ol0000T0003o`0002<00_lU00?o;00002`00olS00;o90000ol0000Q00;o
8`04obl0000_00?o8P02ob8000?o000080000ol0000P00?o<`0003800olQ0003o`0001l000?o0000
7P02ob000olf0000=@04oah00_lO0003o`0001d000?o00007@03ocT0000i00?o7@02oad000?o0000
6`02oa`01?ll0000?003oa`000?o00006P000ol0000I00;o6`03od00000o00Co6@02oaX000?o0000
60000ol0000H00?o@`0004<00olH0003o`0001L000?o00005P02oaP00om60000AP03oaH00_lG0003
o`0001@00_lF00CoB@0004T01?lD00;o5@000ol0000C0003o`0001<00om=0000C@03oa<000?o0000
4P000ol0000A00;o4`03oe00001@00?o4@02oa8000?o000040000ol0000@00?oD`0005<00ol@00;o
40000ol0000>00;o3`04oeH0001F00Co3P000ol0000=0003o`0000`00_l>00?oFP0005X00ol<00;o
3@000ol0000;0003o`0000/00omM0000G@03o`/00_l;0003o`0000T00_l:00CoH00006001?l90003
o`0000P000?o000020000ol0000700?oI00006@00ol700;o20000ol0000600;o1`03ofL0001W00?o
1P02o`H000?o00001002o`H00omZ0000JP03o`D000?o00000`000ol000030003o`0000801?m]0000
K@04o`800_l5gP800_l200?oL@0007400ol2gPCo00?No`000omd0000L`04gP03omkN00;N00?o0000
M@0007<01=h00ooNgP02gWP0001c00CN00?og]h00]ih0000L`03gPCo0]ih0000L`04gP03omkN00;N
N00007@00mh3o`03gP0007L0001e00GNNP000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15513, -0.828671, 0.0179491,
   0.00573478}},
  CellTags->"Inversion - mutant 4"],

Cell[TextData[{
  "Selective inversion 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .19288 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .2389 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .28491 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33093 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .14963 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .51223 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33093 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .43097 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .5 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .56903 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2389 .30902 L
s
.2619 .45617 m
.28491 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.04 w
.19288 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .19288 .30902 0 0 Mshowa
P
1 g
.2389 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .2389 .30902 0 0 Mshowa
P
1 g
.28491 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .28491 .30902 0 0 Mshowa
P
0 w
.33093 .30902 m
.33093 .16187 L
s
.9 g
.04 w
.33093 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33093 .30902 0 0 Mshowa
P
0 w
.33093 .16187 m
.14963 .01472 L
s
.33093 .16187 m
.51223 .01472 L
s
1 g
.04 w
.14963 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .14963 .01472 0 0 Mshowa
P
1 g
.51223 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .51223 .01472 0 0 Mshowa
P
.9 g
.33093 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .33093 .16187 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .2619 .45617 0 0 Mshowa
P
0 w
.5 .45617 m
.43097 .30902 L
s
.5 .45617 m
.5 .30902 L
s
.5 .45617 m
.56903 .30902 L
s
1 g
.04 w
.43097 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .43097 .30902 0 0 Mshowa
P
0 w
.5 .30902 m
.5 .16187 L
s
.9 g
.04 w
.5 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5 .30902 0 0 Mshowa
P
1 g
.5 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .5 .16187 0 0 Mshowa
P
1 g
.56903 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .56903 .30902 0 0 Mshowa
P
.9 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .5 .45617 0 0 Mshowa
P
1 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00002<00_l200;oD005ogH0
000T0004o`00oe8000Go0000o`1e00009004oe8000Go0000o`1e000090001?l00?mB00CoMP0002D0
0_mC0005o`000?l0M@0002@00ol30003o`0004/01_mf0000:`02odT00_ml0000;@000ol000150003
o`0007`0000^0003o`0004<000?o0000O@0002l000?o0000@@000ol0001n0000<0000ol0000o0003
o`0007l0000a00;o?@02oh80000c0003o`0003T000?o0000PP0003@000?o0000=`000ol000230000
=@000ol0000e0003o`0008@0000f00;o<`02ohL0000h0003o`0002l000?o0000Q`0003T000?o0000
;@000ol000280000>P000ol0000[0003o`0008T0000k00;o:@02oh`0000m0003o`0002D000?o0000
S00003h000?o00008`000ol0002=0000?`000ol0000Q0003o`0008h000100003o`0001l000?o0000
S`0004400_lM00;oTP0004<000?o00006@000ol0002B0000A0000ol0000G0003o`0009<000150003
o`0001D000?o0000U00004H00_lC00;oU`0004P000?o00003`000ol0002G0000B@000ol0000=0003
o`0009P0001:0003o`0000/000?o0000V@0004/000?o00002@000ol0002J0000C002o`040?ooo`;N
00<0ool0W@0004h01=h00ooNgP2O0000C@02gPCo0mhS00?oN00004d000?Nomh00]h01?oNg]hT0003
o`0007L0001=0003g_oN00;N00Cog]kN8@05ogP0001=0003g_oN00;N00Cog]kN8P000ol0o`1i0000
C@02gPGo0]hR0003o`3o07T0001>00ON9002ogT0001?00GNX000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001A0003o`0002D000?o0000N000054000?o00009@000ol0001h0000
D@000ol0000U0003o`0007P0001?00?o0]hS00?o0]ih0000CP04gP03omkN02401=h00ooNgP1g0000
;@06o`D01Ol600Go1@02gPCo0mh@00Go2P02gPCo0mh900?oJP0002h000?o000020001Ol0003o00H0
00Go0000o`040003g_oN00;N00Cog]kN4@001Ol0003o00T000?Nomh00]h01?oNg]h<0003o`0006L0
000^0003o`0000P000Go0000o`060005o`000?l010000mkogP02gP04omkNgQ4000Go0000o`090003
g_oN00;N00Cog]kN30000ol0001W0000;P04o`L000Go0000o`0600Co1@000mkogP02gP04omkNgQ40
1?l:0003g_oN00;N00Cog]kN2P02ofX0000^0003o`0000P000Go0000o`060005o`000?l01002gPGo
0]hA0005o`000?l02@02gPGo0]h<0003o`0006L0000]00Ko1@05o`H01Ol600ON4@05o`/01mh:00?o
JP0004l01MhG0003o`0000T01Mih0000<P000ol000070003o`0000H000?o00001`000ol0000I0003
o`0000/000?o00002`000ol0001Z0000<`000ol000060003o`0000H000?o00001P000ol0000K0003
o`0000X000?o00002P000ol0001[0000<`000ol000060003o`0000H000?o00001P000ol0000K0003
o`0000X000?o00002P000ol0001[0000=0000ol000050003o`0000H000?o00001P000ol0000K0003
o`0000X000?o00002P000ol0001[0000=0000ol000050003o`0000H000?o00001@000ol0000M0003
o`0000T000?o00002@000ol0001/0000=@000ol000050003o`0000D000?o00001@000ol0000M0003
o`0000T000?o00002@000ol0001/0000=@000ol000050003o`0000@000?o00001@000ol0000O0003
o`0000P000?o000020000ol0001]0000=P000ol000040003o`0000@000?o00001@000ol0000O0003
o`0000P000?o000020000ol0001]0000=P000ol000040003o`0000@000?o000010000ol0000Q0003
o`0000L000?o00001`000ol0001^0000=`000ol000030003o`0000@000?o000010000ol0000Q0003
o`0000L000?o00001`000ol0001^0000=`000ol000030003o`0000@000?o00000`000ol0000S0003
o`0000H000?o00001P000ol0001_0000>0000ol000030003o`0000<000?o00000`000ol0000S0003
o`0000H000?o00001P000ol0001_0000>0000ol000030003o`0000<000?o00000P000ol0000U0003
o`0000D000?o00001@000ol0001`0000>@000ol000020003o`00008000?o00000`000ol0000U0003
o`0000D000?o00001@000ol0001`0000>@000ol000020003o`00008000?o00000`000ol0000U0003
o`0000D000?o00001@000ol0001`0000>@000ol000020003o`00008000?o00000P000ol0000W0003
o`0000@000?o000010000ol0001a0000>P000ol000020005o`000?l010000ol0000W0003o`0000@0
00?o000010000ol0001a0000>P000ol000020005o`000?l00`000ol0000Y0003o`0000<000?o0000
0`000ol0001b0000>`001Ol0003o00<000Go0000o`0[0003o`0000<000?o00000`000ol0001b0000
>`001Ol0003o00<000Co003o;@000ol000020003o`00008000?o0000L`0003`000Co003o0P001Ol0
003o02d000?o00000P000ol000020003o`0007<0000l0004o`00o`8000Co003o;`001Ol0003o00<0
00?o0000M00003d000Ko003o0?l20003o`0002d000Go0000o`030003o`0007@0000m0008o`00o`3o
0?la0004o`00o`8000?o0000M@0003h000Oo0?l0o`3o034000Co003o0P000ol0001e0000?P001ol0
o`3o0?l0<@001?l00?l20003o`0007D0000n00GN00?o0000<@03o`;NN00003d01mhb00CN00?og]h0
M`0000D00_l200;o<@03gP;o00CNoooN<002gPCo0mh`00Go=@04o`P000060004o`00oc800mh01?oN
g_l2gS0000?Nomh00]h01?oNg]ha0005o`000?l0=@000ol0000800001P04oc800mh01?oNg_l2gS00
00?Nomh00]h01?oNg]ha0005o`000?l0=P000ol0000700001P001?l00?l30003o`0002`00mh01?oN
g_l2gS0000?Nomh00]h01?oNg]ha0005o`000?l0<@000ol000030003o`0000H0000700;o1@03ob/0
0mh4o`;N00?o0000;@02gPGo0]ha0005o`000?l0;P03o`H000?o00001P0000H00ol800Co:002gP03
omkN00;N0P02obh01mh^00;o00<0ool00ol[00Co1P03o`T0000E00?o9P02o`?N1@000ol0000/00GN
;P000ol0000^00?o5P0001P00ol^00;o;P000ol0000/00;o;P03oaT0000K00Co;002ob`000?o0000
:P02ob`01?lL00007`03ob/000?o0000:@000ol0000Y0003o`0002T00olP00008P03obT00_lY0003
o`0002L00_lY00?o8`0002D01?lW00;o9`000ol0000U00;o9`04obH0000Y00?o9P000ol0000T0003
o`0002@000?o00009003obX0000/00?o9002ob@000?o00008P02ob@00ol]0000;`04ob800_lR0003
o`0002000_lR00Co<00003<00olQ0003o`0001l000?o00007`000ol0000O00?o=00003H00olO00;o
7`000ol0000M00;o7`03ocL0000i00Co7@02oad000?o00006`02oad01?lj0000?@03oa`000?o0000
6P000ol0000J0003o`0001X00oln0000@003oaX00_lJ0003o`0001P00_lJ00?o@@0004<00olI0003
o`0001L000?o00005`000ol0000G00?oA00004H01?lF00;o5`000ol0000E00;o5P04odL0001:00?o
5@02oaD000?o00004`02oaD00om;0000C@03oa@000?o00004P000ol0000B0003o`0001800om>0000
D004oa400_lB0003o`0001000_lA00CoD@0005@00ol@00;o40000ol0000>00;o4003oeD0001G00?o
3`000ol0000=0003o`0000d000?o00003@03oeP0001J00Co3002o`d000?o00002`02o``01?mK0000
GP03o`/00_l;0003o`0000T00_l;00?oG`0006400ol:0003o`0000P000?o000020000ol0000800?o
HP0006@01?l700;o20000ol0000600;o1`04ofD0001X00?o1P02o`H000?o00001002o`H00omY0000
J`03o`D000?o00000`000ol000030003o`0000<00om/0000KP04o`800_l00`3NgP03gP030?oo0080
1?m_0000LP03o`030=ko00?o0]h0103ooomc0000M@03gP03omkN00?NMP0007D00mh00ooNgP03gWH0
001e00?N00?og]h00mif0000M@02gPCo0mif0000M@03gP03omkN00?NMP0007H00]h3o`;NM`0007L0
1Mih0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15316, -0.828671, 0.0177215,
   0.00573478}},
  CellTags->"Inversion - mutant 5"],

Cell[TextData[{
  "Selective inversion 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 6",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71509 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .53379 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .89639 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71509 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .80712 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.04 w
.19288 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Mshowa
P
0 w
.2619 .30902 m
.2619 .16187 L
s
.9 g
.04 w
.2619 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Mshowa
P
1 g
.2619 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Mshowa
P
1 g
.33093 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .45617 0 0 Mshowa
P
0 w
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.04 w
.66907 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .30902 0 0 Mshowa
P
0 w
.71509 .30902 m
.71509 .16187 L
s
.9 g
.04 w
.71509 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71509 .30902 0 0 Mshowa
P
0 w
.71509 .16187 m
.53379 .01472 L
s
.71509 .16187 m
.89639 .01472 L
s
1 g
.04 w
.53379 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .53379 .01472 0 0 Mshowa
P
1 g
.89639 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .89639 .01472 0 0 Mshowa
P
.9 g
.71509 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .71509 .16187 0 0 Mshowa
P
1 g
.7611 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .30902 0 0 Mshowa
P
1 g
.80712 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .80712 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00007h00_l200;oD005oa/0
001o0004o`00oe8000Go0000o`0J0000O`04oe8000Go0000o`0J0000O`001?l00?mB00Co6`000800
0_mC0005o`000?l06P0007l00ol30003o`0004/01_lK0000QP02odT00_lQ0000R0000ol000150003
o`00024000290003o`0004<000?o00008P0008X000?o0000@@000ol0000S0000R`000ol0000o0003
o`0002@0002<00;o?@02obL0002>0003o`0003T000?o00009`0008l000?o0000=`000ol0000X0000
T0000ol0000e0003o`0002T0002A00;o<`02ob`0002C0003o`0002l000?o0000;00009@000?o0000
;@000ol0000]0000U@000ol0000[0003o`0002h0002F00;o:@02oc40002H0003o`0002D000?o0000
<@0009T000?o00008`000ol0000b0000VP000ol0000Q0003o`0003<0002K0003o`0001l000?o0000
=00009`00_lM00;o=`0009h000?o00006@000ol0000g0000W`000ol0000G0003o`0003P0002P0003
o`0001D000?o0000>@000:400_lC00;o?0000:<000?o00003`000ol0000l0000Y0000ol0000=0003
o`0003d0002U0003o`0000/000?o0000?P000:H000?o00002@000ol0000o0000Y`02o`040?ooo`;N
00<0ool0@P000:T01=h00ooNgP140000@@03of@00]h4o`?N@`00048000?o0000H`000mkogP02gP04
omkNgT<0000o00GoI0000mkogP02gP04omkNgT<000100003o`3o06D000?Nomh00]h01?oNg]i30000
@0000ol0o`1U00;N1Ol2gT<0001100;oIP07gT@0002Z00GNA@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D000110003o`0006P000?o0000A@00044000?o0000J0000ol000150000
@@000ol0001X0003o`0004D0000n0005g_ooomh0I`03o`;NA@0003d01Mh00ooN001T00CN00?og]h0
A00002d01Ol:00?N1?l2gPX00om<00Ko1002gPCo0mh300Go1P05oc00000^0005o`000?l02@02gP05
omkNg_l00]h=0003o`0004X000?o00001P000mkogP02gP04omkNgP@000Go0000o`060005o`000?l0
;`0002h000Go0000o`0900;N00Gog]kNo`02gPd000?o0000BP000ol000060003g_oN00;N00Cog]kN
10001Ol0003o00H000Go0000o`0_0000;P04o`X00]h01OoNg]ko00;N2`02odd01?l50003g_oN00;N
00Cog]kN1004o`L000Go0000o`0_0000;P001Ol0003o00T00mh5o`03gP0000/000?o0000BP000ol0
000600;N1Ol2gP@000Go0000o`060005o`000?l0;`0002d01Ol;00ON2`03od`01_l500ON1005o`H0
1Ol`0000?P05gVL01Mi50000<P000ol0000<0003o`0000/000?o0000D@000ol000070003o`0000H0
00?o00001`000ol0000a0000<`000ol0000;0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001P000ol0000b0000<`000ol0000;0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001P000ol0000b0000=0000ol0000:0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001@000ol0000c0000=0000ol0000:0003o`0000T000?o0000E@000ol000050003o`0000H0
00?o00001@000ol0000c0000=@000ol000090003o`0000T000?o0000E@000ol000050003o`0000D0
00?o00001@000ol0000d0000=@000ol000090003o`0000P000?o0000E`000ol000050003o`0000@0
00?o00001@000ol0000d0000=P000ol000080003o`0000P000?o0000E`000ol000050003o`0000@0
00?o000010000ol0000e0000=P000ol000080003o`0000L000?o0000F@000ol000040003o`0000@0
00?o000010000ol0000e0000=`000ol000070003o`0000L000?o0000F@000ol000040003o`0000@0
00?o00000`000ol0000f0000=`000ol000070003o`0000H000?o0000F`000ol000030003o`0000@0
00?o00000`000ol0000f0000>0000ol000060003o`0000H000?o0000F`000ol000030003o`0000<0
00?o00000`000ol0000g0000>0000ol000060003o`0000D000?o0000G@000ol000020003o`0000<0
00?o00000`000ol0000g0000>@000ol000050003o`0000D000?o0000G@000ol000030003o`000080
00?o00000P000ol0000h0000>@000ol000050003o`0000D000?o0000G@000ol000030003o`000080
00?o00000P000ol0000h0000>@000ol000050003o`0000@000?o0000G`000ol000020003o`000080
00?o00000P000ol0000h0000>P000ol000040003o`0000@000?o0000G`000ol000020005o`000?l0
10000ol0000i0000>P000ol000040003o`0000<000?o0000H@001Ol0003o00<000?o00000P000ol0
000i0000>`000ol000030003o`0000<000?o0000H@001Ol0003o00<000Go0000o`0l0000>`000ol0
00030003o`00008000?o0000H`001?l00?l30005o`000?l0?00003`000?o00000P000ol000020003
o`0006<000Go0000o`020004o`00ocd0000l0003o`00008000Go0000o`1W0004o`00o`8000Co003o
?@0003d000Go0000o`030003o`0006D000Ko003o0?l20003o`0003`0000m0005o`000?l00P000ol0
001W0005o`3o0?l00P000ol0000l0000?P001?l00?l20003o`0006L000Oo0?l0o`3o03l0000n0004
o`00o`8000?o0000I`001ol0o`3o0?l0?`0003h000KNoooog_m[00GN@00003d01Mh00ooN001Y00ON
?`0000D00_l200;o<@03gPCo0]ha00Go<P02gP;o00?Nool00]hb00Co200000H000Co003o<P02gP05
omkNg_l00]hb0005o`000?l0<@02gP04omkNo`?N<`000ol0000800001P04oc800]h01OoNg]ko00;N
<P001Ol0003o03400]h01?oNg_l3gS@000?o00001`0000H000Co003o0`000ol0000/00;N00Gog]kN
o`02gS8000Go0000o`0a00;N00Cog]ko0mh_0003o`0000<000?o00001P0000L00_l500?o:`03gPGo
00?No`00<0001Ol0003o03400]h4o`?N;003o`H000?o00001P0000H00ol800Co:007gP800_l^00Go
<002o`030=ko00GN:@04o`H00ol900005@03obH01Mh50003o`0005l000Co00000_l4gRL00olF0000
6003obh00_l^0003o`0002`00_l^00?o6@0001/01?l/00;o;0000ol0000Z00;o;004oa`0000O00?o
:`000ol0000Y0003o`0002T000?o0000:@03ob00000R00?o:@02obT000?o00009`02obT00olS0000
9@04obL00_lW0003o`0002D00_lW00Co9P0002T00olV0003o`0002@000?o000090000ol0000T00?o
:P0002`00olT00;o90000ol0000R00;o9003obd0000_00Co8P02ob8000?o00008002ob801?l`0000
<`03ob4000?o00007`000ol0000O0003o`0001l00old0000=P03oal00_lO0003o`0001d00_lO00?o
=`0003T01?lM00;o7@000ol0000K00;o7@04ocX0000m00?o70000ol0000J0003o`0001X000?o0000
6P03och0001000?o6P02oaX000?o00006002oaX00om10000@`03oaT000?o00005`000ol0000G0003
o`0001L00om40000AP04oaH00_lG0003o`0001D00_lF00CoA`0004X00olE00;o5@000ol0000C00;o
5@03od/0001=00?o50000ol0000B0003o`00018000?o00004P03odh0001@00Co4@02oa8000?o0000
4002oa401?mA0000E003oa000_l@0003o`0000h00_l@00?oE@0005L00ol?0003o`0000d000?o0000
3@000ol0000=00?oF00005X01?l<00;o3@000ol0000;00;o3004oe/0001N00?o2`02o`/000?o0000
2@02o`/00omO0000H@03o`X000?o000020000ol000080003o`0000P00omR0000I004o`L00_l80003
o`0000H00_l700CoI@0006P00ol600;o1P000ol0000400;o1P03ofT0001[00?o1@000ol000030003
o`0000<000?o00000`03of`0001^00Co0P02o`030=kN00?N00<0ool00P04ofl0001b00?o00<0g_l0
0ol2gP040?ooog<0001e00?N00?og]h00mif0000M@03gP03omkN00?NMP0007D00mh00ooNgP03gWH0
001e00;N1?l3gWH0001e00?N00?og]h00mif0000MP02gP?o0]ig0000M`05gWP00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15316, -0.828671, 0.0177215,
   0.00573478}},
  CellTags->"Inversion - mutant 6"],

Cell[TextData[{
  "Selective inversion 6: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 7",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .5798 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .9424 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .80712 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.04 w
.19288 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .30902 0 0 Mshowa
P
0 w
.2619 .30902 m
.2619 .16187 L
s
.9 g
.04 w
.2619 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .30902 0 0 Mshowa
P
1 g
.2619 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .16187 0 0 Mshowa
P
1 g
.33093 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .30902 0 0 Mshowa
P
.9 g
.2619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .45617 0 0 Mshowa
P
1 g
.5 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .45617 0 0 Mshowa
P
0 w
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.04 w
.66907 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .30902 0 0 Mshowa
P
1 g
.71509 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .30902 0 0 Mshowa
P
0 w
.7611 .30902 m
.7611 .16187 L
s
.9 g
.04 w
.7611 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .30902 0 0 Mshowa
P
0 w
.7611 .16187 m
.5798 .01472 L
s
.7611 .16187 m
.9424 .01472 L
s
1 g
.04 w
.5798 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .5798 .01472 0 0 Mshowa
P
1 g
.9424 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .9424 .01472 0 0 Mshowa
P
.9 g
.7611 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7611 .16187 0 0 Mshowa
P
1 g
.80712 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .80712 .30902 0 0 Mshowa
P
.9 g
.7381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .45617 0 0 Mshowa
P
1 g
.97619 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00008T00_l200;oD005oa00
002:0004o`00oe8000Go0000o`0?0000RP04oe8000Go0000o`0?0000RP001?l00?mB00Co400008/0
0_mC0005o`000?l03`0008X00ol30003o`0004/01_l@0000T@02odT00_lF0000T`000ol000150003
o`0001H0002D0003o`0004<000?o00005`0009D000?o0000@@000ol0000H0000UP000ol0000o0003
o`0001T0002G00;o?@02oa`0002I0003o`0003T000?o0000700009X000?o0000=`000ol0000M0000
V`000ol0000e0003o`0001h0002L00;o<`02ob40002N0003o`0002l000?o00008@0009l000?o0000
;@000ol0000R0000X0000ol0000[0003o`0002<0002Q00;o:@02obH0002S0003o`0002D000?o0000
9P000:@000?o00008`000ol0000W0000Y@000ol0000Q0003o`0002P0002V0003o`0001l000?o0000
:@000:L00_lM00;o;0000:T000?o00006@000ol0000/0000ZP000ol0000G0003o`0002d0002[0003
o`0001D000?o0000;P000:`00_lC00;o<@000:h000?o00003`000ol0000a0000[`000ol0000=0003
o`000380002`0003o`0000/000?o0000<`000;4000?o00002@000ol0000d0000/P02o`040?ooo`;N
00<0ool0=`000;@01=h00ooNgP0i0000@@03ofl00]h4o`?N>000048000?o0000KP000mkogP02gP04
omkNgSP0000o00GoK`000mkogP02gP04omkNgSP000100003o`3o070000?Nomh00]h01?oNg]hh0000
@0000ol0o`1`00;N1Ol2gSP0001100;oL@07gST0002e00GN>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X000110003o`0007<000?o0000>P00044000?o0000L`000ol0000j0000
@@000ol0001c0003o`0003X0000n0005g_ooomh0LP03o`;N>P0003d01Mh00ooN001_00CN00?og]h0
>@0002d01Ol:00?N1?l2gPX00om<00Ko1@05o`D00]h4o`?N0`05oc00000^0005o`000?l02@02gP05
omkNg_l00]h=0003o`0004X000?o000020001Ol0003o00@000?Nomh00]h01?oNg]h40005o`000?l0
;`0002h000Go0000o`0900;N00Gog]kNo`02gPd000?o0000BP000ol000080005o`000?l010000mko
gP02gP04omkNgP@000Go0000o`0_0000;P04o`X00]h01OoNg]ko00;N2`02odd01?l70005o`000?l0
10000mkogP02gP04omkNgP@01?l`0000;P001Ol0003o00T00mh5o`03gP0000/000?o0000BP000ol0
00080005o`000?l01002gPGo0]h40005o`000?l0;`0002d01Ol;00ON2`03od`01_l500Go1P07gP@0
1Ol`0000?P05gW801Mhj0000<P000ol0000<0003o`0000/000?o0000D@000ol000070003o`0000H0
00?o00001`000ol0000a0000<`000ol0000;0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001P000ol0000b0000<`000ol0000;0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001P000ol0000b0000=0000ol0000:0003o`0000X000?o0000D`000ol000060003o`0000H0
00?o00001@000ol0000c0000=0000ol0000:0003o`0000T000?o0000E@000ol000050003o`0000H0
00?o00001@000ol0000c0000=@000ol000090003o`0000T000?o0000E@000ol000050003o`0000D0
00?o00001@000ol0000d0000=@000ol000090003o`0000P000?o0000E`000ol000050003o`0000@0
00?o00001@000ol0000d0000=P000ol000080003o`0000P000?o0000E`000ol000050003o`0000@0
00?o000010000ol0000e0000=P000ol000080003o`0000L000?o0000F@000ol000040003o`0000@0
00?o000010000ol0000e0000=`000ol000070003o`0000L000?o0000F@000ol000040003o`0000@0
00?o00000`000ol0000f0000=`000ol000070003o`0000H000?o0000F`000ol000030003o`0000@0
00?o00000`000ol0000f0000>0000ol000060003o`0000H000?o0000F`000ol000030003o`0000<0
00?o00000`000ol0000g0000>0000ol000060003o`0000D000?o0000G@000ol000020003o`0000<0
00?o00000`000ol0000g0000>@000ol000050003o`0000D000?o0000G@000ol000030003o`000080
00?o00000P000ol0000h0000>@000ol000050003o`0000D000?o0000G@000ol000030003o`000080
00?o00000P000ol0000h0000>@000ol000050003o`0000@000?o0000G`000ol000020003o`000080
00?o00000P000ol0000h0000>P000ol000040003o`0000@000?o0000G`000ol000020005o`000?l0
10000ol0000i0000>P000ol000040003o`0000<000?o0000H@001Ol0003o00<000?o00000P000ol0
000i0000>`000ol000030003o`0000<000?o0000H@001Ol0003o00<000Go0000o`0l0000>`000ol0
00030003o`00008000?o0000H`001?l00?l30005o`000?l0?00003`000?o00000P000ol000020003
o`0006<000Go0000o`020004o`00ocd0000l0003o`00008000Go0000o`1W0004o`00o`8000Co003o
?@0003d000Go0000o`030003o`0006D000Ko003o0?l20003o`0003`0000m0005o`000?l00P000ol0
001W0005o`3o0?l00P000ol0000l0000?P001?l00?l20003o`0006L000Oo0?l0o`3o03l0000n0004
o`00o`8000?o0000I`001ol0o`3o0?l0?`0003h000KNoooog_m[00GN@00003d01Mh00ooN001Y00ON
?`0000D00_l200;o<@03gPCo0]ha00Go<P02gP;o00?Nool00]hb00Co200000H000Co003o<P02gP05
omkNg_l00]hb0005o`000?l0<@02gP04omkNo`?N<`000ol0000800001P04oc800]h01OoNg]ko00;N
<P001Ol0003o03400]h01?oNg_l3gS@000?o00001`0000H000Co003o0`000ol0000/00;N00Gog]kN
o`02gS8000Go0000o`0a00;N00Cog]ko0mh_0003o`0000<000?o00001P0000L00_l500?o:`03gPGo
00?No`00<0001Ol0003o03400]h4o`?N;003o`H000?o00001P0000H00ol800Co:007gP800_l^00Go
<002o`030=ko00GN:@04o`H00ol900005@03obH01Mh50003o`0005l000Co00000_l4gRL00olF0000
6003obh00_l^0003o`0002`00_l^00?o6@0001/01?l/00;o;0000ol0000Z00;o;004oa`0000O00?o
:`000ol0000Y0003o`0002T000?o0000:@03ob00000R00?o:@02obT000?o00009`02obT00olS0000
9@04obL00_lW0003o`0002D00_lW00Co9P0002T00olV0003o`0002@000?o000090000ol0000T00?o
:P0002`00olT00;o90000ol0000R00;o9003obd0000_00Co8P02ob8000?o00008002ob801?l`0000
<`03ob4000?o00007`000ol0000O0003o`0001l00old0000=P03oal00_lO0003o`0001d00_lO00?o
=`0003T01?lM00;o7@000ol0000K00;o7@04ocX0000m00?o70000ol0000J0003o`0001X000?o0000
6P03och0001000?o6P02oaX000?o00006002oaX00om10000@`03oaT000?o00005`000ol0000G0003
o`0001L00om40000AP04oaH00_lG0003o`0001D00_lF00CoA`0004X00olE00;o5@000ol0000C00;o
5@03od/0001=00?o50000ol0000B0003o`00018000?o00004P03odh0001@00Co4@02oa8000?o0000
4002oa401?mA0000E003oa000_l@0003o`0000h00_l@00?oE@0005L00ol?0003o`0000d000?o0000
3@000ol0000=00?oF00005X01?l<00;o3@000ol0000;00;o3004oe/0001N00?o2`02o`/000?o0000
2@02o`/00omO0000H@03o`X000?o000020000ol000080003o`0000P00omR0000I004o`L00_l80003
o`0000H00_l700CoI@0006P00ol600;o1P000ol0000400;o1P03ofT0001[00?o1@000ol000030003
o`0000<000?o00000`03of`0001^00Co0P02o`030=kN00?N00<0ool00P04ofl0001b00?o00<0g_l0
0ol2gP040?ooog<0001e00?N00?og]h00mif0000M@03gP03omkN00?NMP0007D00mh00ooNgP03gWH0
001e00;N1?l3gWH0001e00?N00?og]h00mif0000MP02gP?o0]ig0000M`05gWP00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15316, -0.828671, 0.0177215,
   0.00573478}},
  CellTags->"Inversion - mutant 7"],

Cell[TextData[{
  "Selective inversion 7: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 8",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
0 w
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Mshowa
P
1 g
.25889 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
.9 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .97619 .01472 0 0 Mshowa
P
.9 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
.9 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
.9 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00009801Om@00;o0P02o`L0
002C0005o`000?l0D0001?l00?l80000T`001Ol0003o05001?l80000T`04oe4000Co003o200009<0
00Go0000o`1A00;o2@0009801Ol20003o`0004X000?o0?l00_l90000VP000ol0001700;o3P0009/0
0_m60003o`0000h0002M0003o`00048000?o00003`0009h000?o0000@0000ol0000@0000W`000ol0
000n0003o`000140002P0003o`0003/00_lD0000X@02ocX000?o000050000:<000?o0000=P000ol0
000E0000Y0000ol0000d0003o`0001H0002U0003o`0003400_lI0000YP000ol0000_0003o`0001T0
002W00;o;P000ol0000J0000Z@000ol0000Z0003o`0001/0002Z0003o`0002L00_lN0000Z`000ol0
000U0003o`0001h0002/0003o`0002<000?o00007`000:d00_lR0003o`000200002_0003o`0001h0
00?o00008@000;0000?o00006`02ob@0002a0003o`0001T000?o000090000;8000?o00005`000ol0
000U0000/`02oaH000?o00009P000;D000?o00004@02obT0002f0003o`0000l000?o0000:@000;L0
00?o00003@000ol0000Z0000^0000ol0000;0003o`0002/0002i00;o2P000ol0000/0000^`000ol0
o`02o`;N00<0ool0;`000;`01=h00ooNgP0a0000@003ogP00]h4o`?N<000044000?o0000M`000mko
gP02gP04omkNgS00000n00GoN0000mkogP02gP04omkNgS00000o0003o`3o07T000?Nomh00]h01?oN
g]h`0000?`000ol0o`1i00;N1Ol2gS00001000;oNP07gS40002m00GN<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0
000b0000@0000ol0001l0003o`000380000n00?o0]ij00?o0]hb0000?@04gP03omkN07P01=h00ooN
gP0a0000;@05o`X00]h4o`?N2@03od/01_l500Go1P05o`@00]h4o`?N<00002h000Go0000o`090003
g_oN00;N00Cog]kN30000ol000190003o`0000P000Go0000o`060005o`000?l00`000mkogP02gP04
omkNgS00000^0005o`000?l02@000mkogP02gP04omkNgP`000?o0000B@000ol000080005o`000?l0
1P001Ol0003o00<000?Nomh00]h01?oNg]h`0000;P04o`X000?Nomh00]h01?oNg]h:00;oC004o`L0
00Go0000o`0600Co10000mkogP02gP04omkNgS00000^0005o`000?l02@02gPGo0]h<0003o`0004T0
00?o000020001Ol0003o00H000Go0000o`0300;N1Ol2gS00000]00Go2`07gPX00om;00Ko1@05o`H0
1Ol500ON<@0003h01Mij00GN<P00038000?o00002`000ol0000;0003o`00050000?o00001`000ol0
00060003o`0000H000?o0000=00003<000?o00002P000ol0000:0003o`00058000?o00001P000ol0
00060003o`0000D000?o0000=@0003<000?o00002P000ol0000:0003o`00058000?o00001P000ol0
00060003o`0000D000?o0000=@0003<000?o00002P000ol0000:0003o`00058000?o00001P000ol0
00060003o`0000D000?o0000=@0003@000?o00002@000ol000090003o`0005@000?o00001@000ol0
00060003o`0000@000?o0000=P0003@000?o00002@000ol000090003o`0005@000?o00001@000ol0
00050003o`0000D000?o0000=P0003D000?o000020000ol000080003o`0005H000?o00001@000ol0
00040003o`0000@000?o0000=`0003D000?o000020000ol000080003o`0005H000?o00001@000ol0
00040003o`0000@000?o0000=`0003H000?o00001`000ol000070003o`0005P000?o000010000ol0
00040003o`0000<000?o0000>00003H000?o00001`000ol000070003o`0005P000?o000010000ol0
00040003o`0000<000?o0000>00003L000?o00001P000ol000060003o`0005X000?o00000`000ol0
00040003o`00008000?o0000>@0003L000?o00001P000ol000060003o`0005X000?o00000`000ol0
00030003o`0000<000?o0000>@0003P000?o00001@000ol000050003o`0005`000?o00000P000ol0
00030003o`00008000?o0000>P0003P000?o00001@000ol000050003o`0005`000?o00000`000ol0
00020003o`00008000?o0000>P0003P000?o00001@000ol000050003o`0005`000?o00000`000ol0
00020003o`00008000?o0000>P0003T000?o000010000ol000040003o`0005h000?o00000P000ol0
00020005o`000?l0?@0003T000?o000010000ol000040003o`0005h000?o00000P001Ol0003o00@0
00?o0000>`0003X000?o00000`000ol000030003o`00060000Go0000o`030005o`000?l0?P0003X0
00?o00000`000ol000030003o`00060000Go0000o`030005o`000?l0?P0003/000?o00000P000ol0
00020003o`00068000Co003o0`001?l00?lo0000>`000ol000020003o`00008000?o0000HP001Ol0
003o008000Co003o?`0003`000Go0000o`030003o`0006@000Co003o0P000ol0o`100000?0001Ol0
003o00<000?o0000I0001_l00?l0o`8000?o0000?P0003d000Co003o0P000ol0001V0007o`3o0?l0
o`110000?@001?l00?l20003o`0006H000Oo0?l0o`3o0440000m0004o`00o`8000?o0000IP001ol0
o`3o0?l0@@0003h00ol2gVX01Mi20000?@04gP03omkN06P01mi100001@02o`800_la00;N1?l3gS00
1Ola00;N0_l00mkoo`02gS401?l;00001P001?l00?lb0003g_oN00;N00Cog]kN<@001Ol0003o0300
0]h01?oNg_l3gS8000?o00002`0000H01?lb0003g_oN00;N00Cog]kN<@001Ol0003o03000]h01?oN
g_l3gS<000?o00002P0000H000Co003o0`000ol0000/0003g_oN00;N00Cog]kN<@001Ol0003o0300
0]h01?oNg_l3gRh000?o00000`000ol0000900001`02o`D00ol[00;N1Ol2gS4000Go0000o`0`00;N
1?l3gR/00ol60003o`0000T0000600?o2004obP01mh00`3oo`0^00Go;`02o`030=ko00GN:@03o`H0
0ol<00005@03obH01Mh40003o`0005h000Co00000_l4gRH01?lH00006003obd00_l^0003o`0002/0
0_l]00?o700001/00ol/00;o;0000ol0000Y00;o;003oal0000N00Co:P000ol0000Y0003o`0002P0
00?o0000:@03ob80000R00?o:002obT000?o00009P02obP01?lU00009@03obL00_lW0003o`0002D0
00?o00009@03obT0000X00Co9@000ol0000T0003o`0002<00_lU00?o;00002`00olS00;o90000ol0
000Q00;o8`04obl0000_00?o8P02ob8000?o000080000ol0000P00?o<`0003800olQ0003o`0001l0
00?o00007P02ob000olf0000=@04oah00_lO0003o`0001d000?o00007@03ocT0000i00?o7@02oad0
00?o00006`02oa`01?ll0000?003oa`000?o00006P000ol0000I00;o6`03od00000o00Co6@02oaX0
00?o000060000ol0000H00?o@`0004<00olH0003o`0001L000?o00005P02oaP00om60000AP03oaH0
0_lG0003o`0001@00_lF00CoB@0004T01?lD00;o5@000ol0000C0003o`0001<00om=0000C@03oa<0
00?o00004P000ol0000A00;o4`03oe00001@00?o4@02oa8000?o000040000ol0000@00?oD`0005<0
0ol@00;o40000ol0000>00;o3`04oeH0001F00Co3P000ol0000=0003o`0000`00_l>00?oFP0005X0
0ol<00;o3@000ol0000;0003o`0000/00omM0000G@03o`/00_l;0003o`0000T00_l:00CoH0000600
1?l90003o`0000P000?o000020000ol0000700?oI00006@00ol700;o20000ol0000600;o1`03ofL0
001W00?o1P02o`H000?o00001002o`H00omZ0000JP03o`D000?o00000`000ol000030003o`000080
1?m]0000K@04o`800_l5gP800_l200?oL@0007400ol2gPCo00?No`000omd0000L`04gP03omkN00;N
00?o0000M@0007<01=h00ooNgP02gWP0001c00CN00?og]h00]ih0000L`03gPCo0]ih0000L`04gP03
omkN00;NN00007@00mh3o`03gP0007L0001e00GNNP000001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15513, -0.828671, 0.0179491,
   0.00573478}},
  CellTags->"Inversion - mutant 8"],

Cell[TextData[{
  "Selective inversion 8: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
0 w
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Mshowa
P
1 g
.25889 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
.9 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
.9 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .96411 .45617 0 0 Mshowa
P
.9 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00009800_l200;oC`05o`P0
002C0004o`00oe4000Go0000o`070000T`04oe4000Go0000o`070000T`001?l00?mA00Co200009@0
0_mB0005o`000?l01`0009<00ol30003o`0004X01_l80000VP000ol0001700;o3P0009/00_m60003
o`0000h0002M0003o`00048000?o00003`0009h000?o0000@0000ol0000@0000W`000ol0000n0003
o`000140002P0003o`0003/00_lD0000X@02ocX000?o000050000:<000?o0000=P000ol0000E0000
Y0000ol0000d0003o`0001H0002U0003o`0003400_lI0000YP000ol0000_0003o`0001T0002W00;o
;P000ol0000J0000Z@000ol0000Z0003o`0001/0002Z0003o`0002L00_lN0000Z`000ol0000U0003
o`0001h0002/0003o`0002<000?o00007`000:d00_lR0003o`000200002_0003o`0001h000?o0000
8@000;0000?o00006`02ob@0002a0003o`0001T000?o000090000;8000?o00005`000ol0000U0000
/`02oaH000?o00009P000;D000?o00004@02obT0002f0003o`0000l000?o0000:@000;L000?o0000
3@000ol0000Z0000^0000ol0000;0003o`0002/0002i00;o2P000ol0000/0000^`000ol0o`02o`;N
00<0ool0;`000;`01=h00ooNgP0a0000@003ogP00]h4o`?N<000044000?o0000M`000mkogP02gP04
omkNgS00000n00GoN0000mkogP02gP04omkNgS00000o0003o`3o07T000?Nomh00]h01?oNg]h`0000
?`000ol0o`1i00;N1Ol2gS00001000;oNP07gS40002m00GN<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`00038000100003o`0007`000?o0000<P00040000?o0000O0000ol0000b0000
@0000ol0001l0003o`000380000n00?o0]ij00?o0]hb0000?@04gP03omkN07P01=h00ooNgP0a0000
;@05o`X00]h4o`?N2@03od/01_l500Go1P05o`@00]h4o`?N<00002h000Go0000o`090003g_oN00;N
00Cog]kN30000ol000190003o`0000P000Go0000o`060005o`000?l00`000mkogP02gP04omkNgS00
000^0005o`000?l02@000mkogP02gP04omkNgP`000?o0000B@000ol000080005o`000?l01P001Ol0
003o00<000?Nomh00]h01?oNg]h`0000;P04o`X000?Nomh00]h01?oNg]h:00;oC004o`L000Go0000
o`0600Co10000mkogP02gP04omkNgS00000^0005o`000?l02@02gPGo0]h<0003o`0004T000?o0000
20001Ol0003o00H000Go0000o`0300;N1Ol2gS00000]00Go2`07gPX00om;00Ko1@05o`H01Ol500ON
<@0003h01Mij00GN<P00038000?o00002`000ol0000;0003o`00050000?o00001`000ol000060003
o`0000H000?o0000=00003<000?o00002P000ol0000:0003o`00058000?o00001P000ol000060003
o`0000D000?o0000=@0003<000?o00002P000ol0000:0003o`00058000?o00001P000ol000060003
o`0000D000?o0000=@0003<000?o00002P000ol0000:0003o`00058000?o00001P000ol000060003
o`0000D000?o0000=@0003@000?o00002@000ol000090003o`0005@000?o00001@000ol000060003
o`0000@000?o0000=P0003@000?o00002@000ol000090003o`0005@000?o00001@000ol000050003
o`0000D000?o0000=P0003D000?o000020000ol000080003o`0005H000?o00001@000ol000040003
o`0000@000?o0000=`0003D000?o000020000ol000080003o`0005H000?o00001@000ol000040003
o`0000@000?o0000=`0003H000?o00001`000ol000070003o`0005P000?o000010000ol000040003
o`0000<000?o0000>00003H000?o00001`000ol000070003o`0005P000?o000010000ol000040003
o`0000<000?o0000>00003L000?o00001P000ol000060003o`0005X000?o00000`000ol000040003
o`00008000?o0000>@0003L000?o00001P000ol000060003o`0005X000?o00000`000ol000030003
o`0000<000?o0000>@0003P000?o00001@000ol000050003o`0005`000?o00000P000ol000030003
o`00008000?o0000>P0003P000?o00001@000ol000050003o`0005`000?o00000`000ol000020003
o`00008000?o0000>P0003P000?o00001@000ol000050003o`0005`000?o00000`000ol000020003
o`00008000?o0000>P0003T000?o000010000ol000040003o`0005h000?o00000P000ol000020005
o`000?l0?@0003T000?o000010000ol000040003o`0005h000?o00000P001Ol0003o00@000?o0000
>`0003X000?o00000`000ol000030003o`00060000Go0000o`030005o`000?l0?P0003X000?o0000
0`000ol000030003o`00060000Go0000o`030005o`000?l0?P0003/000?o00000P000ol000020003
o`00068000Co003o0`001?l00?lo0000>`000ol000020003o`00008000?o0000HP001Ol0003o0080
00Co003o?`0003`000Go0000o`030003o`0006@000Co003o0P000ol0o`100000?0001Ol0003o00<0
00?o0000I0001_l00?l0o`8000?o0000?P0003d000Co003o0P000ol0001V0007o`3o0?l0o`110000
?@001?l00?l20003o`0006H000Oo0?l0o`3o0440000m0004o`00o`8000?o0000IP001ol0o`3o0?l0
@@0003h00ol2gVX01Mi20000?@04gP03omkN06P01mi100001@02o`800_la00;N1?l3gS401?la00;N
0_l00mkoo`02gS001Ol;00001P001?l00?lb0003g_oN00;N00Cog]kN<P000ol0000a00;N00Cog]ko
0mha0005o`000?l02P0000H01?lb0003g_oN00;N00Cog]kN<`000ol0000`00;N00Cog]ko0mha0005
o`000?l02P0000H000Co003o0`000ol0000/0003g_oN00;N00Cog]kN=0000ol0000_00;N00Cog]ko
0mh^0004o`00o`<000?o0000200000L00_l500?o:`02gPGo0]hd0003o`0002l00]h4o`?N:`03o`<0
00Go0000o`0:00001P03o`P01?lX00ON00<0ool0;`03oc000_l00`3No`05gRT00ol500Go2`0001D0
0olV00GN10000ol0001N0004o`0000;o1=hV00Co600001P00ol]00;o;P000ol0000[00;o;@03oa`0
000K00?o;002ob`000?o0000:@02ob`00olO00007P04obX000?o0000:@000ol0000X0003o`0002T0
0olR00008P03obP00_lY0003o`0002H00_lX00Co9@0002D00olW00;o9`000ol0000U0003o`0002D0
0olY0000:004obD000?o000090000ol0000S00;o9@03ob`0000/00?o8`02ob@000?o00008@02ob<0
1?l_0000;`03ob800_lR0003o`00020000?o00008003oc<0000b00?o8@000ol0000O0003o`0001h0
0_lP00?o=P0003D01?lN00;o7`000ol0000M0003o`0001d00oli0000>@03oad00_lM0003o`0001/0
0_lL00Co?00003`00olL0003o`0001X000?o00006@02oa/00om00000?`04oaT00_lJ0003o`0001P0
00?o00006003od<0001300?o60000ol0000G0003o`0001H00_lH00?oAP0004H00olF00;o5`000ol0
000D00;o5P04odT0001900Co5002oaD000?o00004`000ol0000C00?oC@0004d00olC0003o`000180
00?o00004@02oa<00om@0000D003oa400_lB0003o`00010000?o00004003oe<0001C00?o4002oa00
00?o00003P02o`l01?mF0000EP04o`h000?o00003@000ol0000<00;o3P03oeX0001J00?o3002o`d0
00?o00002`000ol0000;00?oG@0005d00ol;00;o2`000ol0000900;o2P04of00001P00Co2@000ol0
00080003o`0000P000?o00001`03of@0001T00?o1`02o`P000?o00001P02o`L00omW0000I`03o`H0
0_l60003o`0000@00_l600?oJP0006X00ol50003o`0000<000?o00000`000ol0000200CoK@0006d0
1?l200;o1Mh200;o0P03og40001a00?o0]h4o`03g_l000?oM00007<01=h00ooNgP02gP03o`0007D0
001c00CN00?og]h00]ih0000L`04gP03omkN00;NN00007<00mh4o`;NN00007<01=h00ooNgP02gWP0
001d00?N0ol00mh0001g0000M@05gWX00000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.15513, -0.828671, 0.0179491,
   0.00573478}},
  CellTags->"Inversion - mutant 9"],

Cell[TextData[{
  "Selective inversion 9: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Inversion - mutant 10",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.526165 0.219378 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .02381 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .08741 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .08741 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .15101 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .08741 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .30679 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52616 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .68194 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .72434 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .76674 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80914 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .6421 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80914 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .74554 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96492 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .52616 .60332 0 0 Msboxa
P
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.52616 .60332 m
.08741 .45617 L
s
.52616 .60332 m
.30679 .45617 L
s
.52616 .60332 m
.52616 .45617 L
s
.52616 .60332 m
.74554 .45617 L
s
.52616 .60332 m
.96492 .45617 L
s
.08741 .45617 m
.02381 .30902 L
s
.08741 .45617 m
.08741 .30902 L
s
.08741 .45617 m
.15101 .30902 L
s
1 g
.04 w
.02381 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .02381 .30902 0 0 Mshowa
P
0 w
.08741 .30902 m
.08741 .16187 L
s
.9 g
.04 w
.08741 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .08741 .30902 0 0 Mshowa
P
1 g
.08741 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .08741 .16187 0 0 Mshowa
P
1 g
.15101 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .15101 .30902 0 0 Mshowa
P
.9 g
.08741 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .08741 .45617 0 0 Mshowa
P
1 g
.30679 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .30679 .45617 0 0 Mshowa
P
1 g
.52616 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52616 .45617 0 0 Mshowa
P
0 w
.74554 .45617 m
.68194 .30902 L
s
.74554 .45617 m
.72434 .30902 L
s
.74554 .45617 m
.76674 .30902 L
s
.74554 .45617 m
.80914 .30902 L
s
1 g
.04 w
.68194 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .68194 .30902 0 0 Mshowa
P
1 g
.72434 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .72434 .30902 0 0 Mshowa
P
1 g
.76674 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .76674 .30902 0 0 Mshowa
P
0 w
.80914 .30902 m
.80914 .16187 L
s
.9 g
.04 w
.80914 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80914 .30902 0 0 Mshowa
P
0 w
.80914 .16187 m
.6421 .01472 L
s
.80914 .16187 m
.97619 .01472 L
s
1 g
.04 w
.6421 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .6421 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.80914 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80914 .16187 0 0 Mshowa
P
.9 g
.74554 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .74554 .45617 0 0 Mshowa
P
1 g
.96492 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96492 .45617 0 0 Mshowa
P
.9 g
.52616 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .52616 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.5},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5D005Gooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00?l003lo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?l0ZP00
oeD0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?@0003d0000m00009P00_l200;oB@05o`P0
002I0004o`00od/000Go0000o`070000V@04od/000Go0000o`070000V@001?l00?m;00Co200009X0
0_m<0005o`000?l01`0009T00ol30003o`0004@01_l80000X0000ol000120003o`0000`0002Q0003
o`00040000?o00003@000:8000?o0000?P000ol0000>0000X`000ol0000k00;o4@000:@000?o0000
>@000ol0000A0000Y@02ocP000?o00004P000:L000?o0000=0000ol0000C0000Z0000ol0000b0003
o`0001@0002Y0003o`00030000?o00005@000:X000?o0000;P000ol0000F0000Z`000ol0000[00;o
6@000:`000?o0000:@000ol0000I0000[@000ol0000W0003o`0001X0002^00;o9P000ol0000K0000
/0000ol0000R0003o`0001`0002a0003o`00020000?o00007@000;8000?o00007P000ol0000N0000
/`000ol0000K00;o8@000;@000?o00006@000ol0000Q0000]@000ol0000G0003o`000280002f0003
o`0001D000?o00008`000;L000?o00004`000ol0000T0000^002oa8000?o00009@000;X000?o0000
3P000ol0000V0000^`000ol0000;00;o:@000;`000?o00002@000ol0000Y0000_@000ol000070003
o`0002X0002n0003o`3o00;o0]h00`3o000/0000_`04gP03omkN02h0000G00?oY002gPCo0mh]0000
60000ol0002S0003g_oN00;N00Cog]kN;@0001D01OnT0003g_oN00;N00Cog]kN;@0001H000?o0?l0
Y@000mkogP02gP04omkNgRd0000F0003o`3o0:D00]h5o`;N;@0001L00_nV00ON;P000<001Mh_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001L000?o0000Z0000ol0000_0000
5`000ol0002X0003o`0002l0000G0003o`000:P000?o0000;`0001D00ol2gZH00ol2gRl0000D00CN
00?og]h0Y004gP03omkN02h0000500Go2@02gPCo0mh800?oNP06o`@01Ol500Go1002gPCo0mh]0000
1P001Ol0003o00P000?Nomh00]h01?oNg]h;0003o`0007P000?o00001`001Ol0003o00D000Go0000
o`030003g_oN00;N00Cog]kN;@0000H000Go0000o`080003g_oN00;N00Cog]kN2`000ol0001h0003
o`0000L000Go0000o`050005o`000?l00`000mkogP02gP04omkNgRd0000600Co2@000mkogP02gP04
omkNgPT00_mk00Co1P001Ol0003o00D01?l40003g_oN00;N00Cog]kN;@0000H000Go0000o`0800;N
1Ol2gP/000?o0000N0000ol000070005o`000?l01@001Ol0003o00<00]h5o`;N;@0000D01Ol:00ON
2@03ogX01_l400Go1@05o`D01mh^00005@05gZH01Mh_00002P000ol0000:0003o`0000X000?o0000
O`000ol000060003o`0000D000?o00001P000ol0000a00002P000ol0000:0003o`0000X000?o0000
O`000ol000060003o`0000D000?o00001P000ol0000a00002`000ol000090003o`0000T000?o0000
P@000ol000050003o`0000D000?o00001@000ol0000b00002`000ol000090003o`0000T000?o0000
P@000ol000050003o`0000D000?o00001@000ol0000b000030000ol000080003o`0000P000?o0000
P`000ol000040003o`0000D000?o000010000ol0000c000030000ol000080003o`0000P000?o0000
P`000ol000040003o`0000D000?o000010000ol0000c00003@000ol000070003o`0000L000?o0000
Q@000ol000040003o`0000<000?o000010000ol0000d00003@000ol000070003o`0000L000?o0000
Q@000ol000040003o`0000<000?o000010000ol0000d00003@000ol000070003o`0000L000?o0000
Q@000ol000040003o`0000<000?o000010000ol0000d00003P000ol000060003o`0000H000?o0000
Q`000ol000030003o`0000<000?o00000`000ol0000e00003P000ol000060003o`0000H000?o0000
Q`000ol000030003o`0000<000?o00000`000ol0000e00003`000ol000050003o`0000D000?o0000
R@000ol000020003o`0000<000?o00000P000ol0000f00003`000ol000050003o`0000D000?o0000
R@000ol000020003o`0000<000?o00000P000ol0000f000040000ol000040003o`0000@000?o0000
R`000ol000020005o`000?l010000ol0000g000040000ol000040003o`0000@000?o0000R`000ol0
00020005o`000?l010000ol0000g000040000ol000040003o`0000@000?o0000R`000ol000020005
o`000?l010000ol0000g00004@000ol000030003o`0000<000?o0000S@001Ol0003o00<000Go0000
o`0j00004@000ol000030003o`0000<000?o0000S@001Ol0003o00<000Go0000o`0j00004P000ol0
00020003o`00008000?o0000S`001?l00?l30004o`00oc/0000B0003o`00008000?o00000P000ol0
002?0004o`00o`<000Co003o>`0001<000Go0000o`030003o`00094000Ko003o0?l20003o`0003X0
000C0005o`000?l00`000ol0002A0006o`00o`3o0P000ol0000j00004`001Ol0003o00<000?o0000
T@001_l00?l0o`8000?o0000>P0001@000Co003o0P000ol0002C0007o`3o0?l0o`0m000050001?l0
0?l20003o`0009<000Oo0?l0o`3o03d0000E0005o`3o0?l0U`02o`030?oo03h0000E00?o0]jG00GN
?P0001@01=h00ooNgP2E00ON?@0001<00]h4o`?N;002o`800_l^00Go;P02gP;o00?Nool00]h]00Co
2`0001<000?Nomh00]h01?oNg]h]0004o`00oc0000Go0000o`0]00;N00Cog]ko0mh^0003o`0000/0
000C0003g_oN00;N00Cog]kN;@04oc0000Go0000o`0]00;N00Cog]ko0mh_0003o`0000X0000C0003
g_oN00;N00Gog]kNo`0/0004o`00oc0000Go0000o`0]00;N00Cog]ko0mhZ0003o`0000<000?o0000
2@0001<00]h5o`;N00@0oooo:P02oc4000Go0000o`0]00;N1?l3gRL00ol60003o`0000T0000D00ON
1@03obH00ol40003o`0002T01Ol]0004o`3No`GN9@03o`H00ol<00005@05gPT00ol[00;oF@02o`80
0_l4gR<00olH00009P03obX000?o0000:@000ol0000Y0003o`0002P00olK0000:@03obP00_lY0003
o`0002L00_lX00?o7P0002`00olW0003o`0002H000?o00009P000ol0000U00?o8@0002l00olU00;o
9P000ol0000T00;o9@03ob@0000b00?o9002ob@000?o00008P02ob@00olW0000=@03ob<000?o0000
8@000ol0000Q0003o`0002400olZ0000>003ob400_lQ0003o`0001l00_lQ00?o;@0003/00olP0003
o`0001h000?o00007P000ol0000N00?o<00003h00olN00;o7P000ol0000L00;o7P03oc<0001100?o
7@000ol0000K0003o`0001/000?o00006`03ocH0001400?o6`02oa/000?o00006@02oa/00oli0000
A`03oaX000?o000060000ol0000H0003o`0001P00oll0000BP04oaL00_lH0003o`0001H00_lG00Co
?`0004h00olF0003o`0001D000?o00005@000ol0000D00?o@`0005400olD00;o5@000ol0000C00;o
5003odH0001D00?o4`000ol0000B0003o`00018000?o00004@03odT0001G00?o4@02oa8000?o0000
4002oa400om<0000FP03oa0000?o00003`000ol0000?0003o`0000h00om?0000G@03o`h00_l?0003
o`0000d00_l>00?oDP0006000ol=0003o`0000`000?o000030000ol0000;00?oE@0006<00ol;00;o
30000ol0000:00;o2`03oeP0001V00?o2P02o`X000?o00002002o`X00omK0000J@03o`T000?o0000
1`000ol000070003o`0000L00omN0000K003o`L00_l70003o`0000D00_l700?oH@0006l00ol60003
o`0000@000?o000010000ol0000400?oI00007800ol400;o10000ol0000200;o1003ofL0001e00?o
0`000ol0gP04gP030?l000800omZ0000N003o`030=ko00?o0]h0103ooom]0000N`03gP03omkN00?N
L00007/00mh00ooNgP03gW00001k00?N00?og]h00mi`0000N`02gPCo0mi`0000N`03gP03omkN00?N
L00007`00]h3o`;NL@0007d01Mib0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.5, 0}} -> {-2.45613, -0.828671, 0.0192335,
   0.00573478}},
  CellTags->"Inversion - mutant 10"],

Cell[TextData[{
  "Selective inversion 10: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Inversion - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Inversion - mutant 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation (non-labelled)", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> False,
            LabelSize -> 0.02, LabelColor -> 0
]& /@ invChromos;\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.550217 0.212987 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.55022 .60332 m
.12424 .45617 L
s
.55022 .60332 m
.33723 .45617 L
s
.55022 .60332 m
.55022 .45617 L
s
.55022 .60332 m
.7632 .45617 L
s
.55022 .60332 m
.97619 .45617 L
s
.12424 .45617 m
.0625 .30902 L
s
.12424 .45617 m
.10366 .30902 L
s
.12424 .45617 m
.14483 .30902 L
s
.12424 .45617 m
.18599 .30902 L
s
1 g
.02 w
.0625 .30902 Mdot
.10366 .30902 Mdot
.14483 .30902 Mdot
0 g
0 w
.18599 .30902 m
.18599 .16187 L
s
.02 w
.18599 .30902 Mdot
0 w
.18599 .16187 m
.02381 .01472 L
s
.18599 .16187 m
.34817 .01472 L
s
1 g
.02 w
.02381 .01472 Mdot
.34817 .01472 Mdot
0 g
.18599 .16187 Mdot
.12424 .45617 Mdot
1 g
.33723 .45617 Mdot
0 g
0 w
.55022 .45617 m
.48847 .30902 L
s
.55022 .45617 m
.55022 .30902 L
s
.55022 .45617 m
.61196 .30902 L
s
1 g
.02 w
.48847 .30902 Mdot
0 g
0 w
.55022 .30902 m
.55022 .16187 L
s
.02 w
.55022 .30902 Mdot
1 g
.55022 .16187 Mdot
.61196 .30902 Mdot
0 g
.55022 .45617 Mdot
1 g
.7632 .45617 Mdot
.97619 .45617 Mdot
0 g
.55022 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`0000T000?o0000o`0?00002P000ol0001B0003o`000;P0000;0003o`00050000?o0000
^@0000`000?o0000CP000ol0002j00003@000ol0001<0003o`000;/0000>0003o`0004X000?o0000
_00000l000?o0000B0000ol0002m000040000ol0001500;o`000014000?o0000@`000ol000300000
4P02od8000?o0000`@0001@000?o0000?P000ol0003200005@000ol0000l0003o`000<<0000F0003
o`0003X000?o0000a00001L000?o0000>0000ol00035000060000ol0000f0003o`000<H0000I0003
o`0003<00_o900006P000ol0000a0003o`000<T0000K0003o`0002l000?o0000bP0001`000?o0000
;@000ol0003;00007@02ob`000?o0000c00001l000?o0000:0000ol0003=000080000ol0000V0003
o`000<h0000Q0003o`0002@000?o0000c`00028000?o00008P000ol0003@00008`000ol0000O00;o
d`0002@000?o00007@000ol0003C00009@000ol0000K0003o`000=@0000V0003o`0001T000?o0000
e@0002L000?o00005`000ol0003F0000:0000ol0000E0003o`000=L0000Y00;o50000ol0003H0000
:`000ol0000@0003o`000=T0000/0003o`0000d00_oL0000;@000ol0000;0003o`000=`0000^0003
o`0000T000?o0000g@0002l000?o00001`000ol0003N0000<0000ol000050003o`000=l0000a0003
o`0000<000?o0000h00003801OoS0000<P05on<0000b00Goh`0003801OoS0000<`03on@0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000d0003
o`0006<000?o0000O@0003@000?o0000H`000ol0001m0000=0000ol0001S0003o`0007d0000c00?o
H`03ogh0000b00GoH@05ogd0000b00GoH@05ogd0000b00GoH@05ogd0000C0003o`0001d00omS00?o
OP0001<000?o00001`000ol000090003o`0000L000?o0000E0000ol0000=0003o`0000d000?o0000
K@0001<000?o000020000ol000070003o`0000P000?o0000E0000ol0000=0003o`0000d000?o0000
K@0001@000?o00001`000ol000070003o`0000L000?o0000EP000ol0000<0003o`0000`000?o0000
KP0001@000?o00001`000ol000070003o`0000L000?o0000EP000ol0000<0003o`0000`000?o0000
KP0001D000?o00001P000ol000070003o`0000H000?o0000F0000ol0000;0003o`0000/000?o0000
K`0001D000?o00001P000ol000070003o`0000H000?o0000F0000ol0000;0003o`0000/000?o0000
K`0001H000?o00001@000ol000070003o`0000D000?o0000FP000ol0000:0003o`0000X000?o0000
L00001H000?o00001@000ol000070003o`0000D000?o0000FP000ol0000:0003o`0000X000?o0000
L00001H000?o00001P000ol000050003o`0000H000?o0000FP000ol0000:0003o`0000X000?o0000
L00001L000?o00001@000ol000050003o`0000D000?o0000G0000ol000090003o`0000T000?o0000
L@0001L000?o00001@000ol000050003o`0000D000?o0000G0000ol000090003o`0000T000?o0000
L@0001P000?o000010000ol000050003o`0000@000?o0000GP000ol000080003o`0000P000?o0000
LP0001P000?o000010000ol000050003o`0000@000?o0000GP000ol000080003o`0000P000?o0000
LP0001P000?o000010000ol000050003o`0000@000?o0000GP000ol000080003o`0000P000?o0000
LP0001T000?o00000`000ol000050003o`0000<000?o0000H0000ol000070003o`0000L000?o0000
L`0001T000?o000010000ol000030003o`0000@000?o0000H0000ol000070003o`0000L000?o0000
L`0001X000?o00000`000ol000030003o`0000<000?o0000HP000ol000060003o`0000H000?o0000
M00001X000?o00000`000ol000030003o`0000<000?o0000HP000ol000060003o`0000H000?o0000
M00001/000?o00000P000ol000030003o`00008000?o0000I0000ol000050003o`0000D000?o0000
M@0001/000?o00000P000ol000030003o`00008000?o0000I0000ol000050003o`0000D000?o0000
M@0001/000?o00000P000ol000030003o`00008000?o0000I0000ol000050003o`0000D000?o0000
M@0001`000Go0000o`050005o`000?l0J0000ol000040003o`0000@000?o0000MP0001`000?o0000
0P001Ol0003o00@000?o0000IP000ol000040003o`0000@000?o0000MP0001d000Go0000o`030005
o`000?l0JP000ol000030003o`0000<000?o0000M`0001d000Go0000o`030005o`000?l0JP000ol0
00030003o`0000<000?o0000M`0001d000Go0000o`030005o`000?l0JP000ol000030003o`0000<0
00?o0000M`0001h000Co003o0`001?l00?m/0003o`00008000?o00000P000ol0001h00007P001?l0
0?l30004o`00of`000?o00000P000ol000020003o`0007P0000O0003o`3o00<000?o0?l0KP001Ol0
003o00<000?o0000N@0001l000Ko003o0?l20003o`0006`000Go0000o`030003o`0007T0000O0006
o`00o`3o0P000ol0001/0005o`000?l00`000ol0001i000080001ol0o`3o0?l0L0001?l00?l20003
o`0007X0000P0007o`3o0?l0o`1`0004o`00o`8000?o0000NP0002400_l00`3oo`1b0005o`3o0?l0
O@0002400_l00`3oo`1b0005o`3o0?l0O@00028000?o0?l0M003ogh0000R00?oM003ogh0000Q00Go
LP05ogd0000Q00GoLP05ogd0000Q00OoL005og000_l;00008P03o`<00olf00;o=P03ocH00_lf00?o
3@0002/00ole0003o`0003@000?o0000=0000ol0000c00?o400002h00olc00;o=0000ol0000b00;o
<`03oa<0000a00?o<P000ol0000a0003o`00034000?o0000<003oaH0000d00?o<002oc4000?o0000
;`02oc000olI0000=`03obl000?o0000;P000ol0000^0003o`0002d00olL0000>P03obd000?o0000
;@000ol0000]0003o`0002/00olO0000?@03ob/00_l]0003o`0002/00_l[00?o8P0004000_l[0003
o`0002X000?o0000:P000ol0000Y00;o9@0004800olY00;o:P000ol0000X00;o:@03obL0001500?o
:0000ol0000W0003o`0002L000?o00009P03obX0001800?o9P02obL000?o00009@02obH00ol]0000
B`03obD000?o000090000ol0000T0003o`0002<00ol`0000CP03ob<00_lT0003o`0002800_lS00?o
<`0005400olR0003o`00024000?o00008@000ol0000P00?o=P0005@00olP00;o8@000ol0000O00;o
8003ocT0001G00?o7`000ol0000N0003o`0001h000?o00007@03oc`0001J00?o7@02oah000?o0000
7002oad00olo0000G@03oa`000?o00006`000ol0000K0003o`0001X00om20000H002oa/000?o0000
6P000ol0000J0003o`0001T00_m50000HP03oaT00_lJ0003o`0001P00_lI00?oA`0006D00olH0003
o`0001L000?o00005`000ol0000F00?oBP0006P00olF00;o5`000ol0000E00;o5P03odd0001[00?o
5@000ol0000D0003o`0001@000?o00004`03oe00001^00?o4`02oa@000?o00004P02oa<00omC0000
L@03oa8000?o00004@000ol0000A0003o`0001000omF0000M003oa000_lA0003o`0000l00_l@00?o
F@0007L00ol?0003o`0000h000?o00003P000ol0000=00?oG00007X00ol=00;o3P000ol0000<00;o
3@03oel0001m00;o3@000ol0000;0003o`0000/000?o00002`02of80001o00?o2`02o`/000?o0000
2@02o`/00omT0000PP03o`X000?o000020000ol000080003o`0000P00omW0000Q@03o`P000?o0000
1`000ol000070003o`0000H00omZ0000R003o`H00_l70003o`0000D00_l600?oK@0008/00ol50003
o`0000@000?o000010000ol0000300?oL00008h00ol300;o10000ol0000200;o0`03og<0002A00?o
0P001Ol0003o00<000?o00000omf0000U005o`030?l000GoN@0009L01oml0000V005ogd0002H00Go
O@0009P01Omm0000V@03ogh0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.5924, -0.820004, 0.0167732, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
0 w
.5 .45617 m
.43097 .30902 L
s
.5 .45617 m
.47699 .30902 L
s
.5 .45617 m
.52301 .30902 L
s
.5 .45617 m
.56903 .30902 L
s
1 g
.02 w
.43097 .30902 Mdot
.47699 .30902 Mdot
.52301 .30902 Mdot
0 g
0 w
.56903 .30902 m
.56903 .16187 L
s
.02 w
.56903 .30902 Mdot
0 w
.56903 .16187 m
.38773 .01472 L
s
.56903 .16187 m
.75033 .01472 L
s
1 g
.02 w
.38773 .01472 Mdot
.75033 .01472 Mdot
0 g
.56903 .16187 Mdot
.5 .45617 Mdot
1 g
.7381 .45617 Mdot
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`0006l000?o0000Z000070000?o0000G0000ol000180000L@000ol0001J0003o`0004T0
001b0003o`0005L00_m<0000L`02oeH000?o0000C00007D000?o0000DP000ol0001=0000MP000ol0
001@0003o`0004h0001g0003o`0004d00_mA0000N002od`000?o0000D@0007X000?o0000B0000ol0
001B0000N`000ol000160003o`0005<0001l0003o`0004<00_mF0000O@000ol000110003o`0005H0
001n00;o@0000ol0001G0000P0000ol0000l0003o`0005P000210003o`0003T00_mK0000PP000ol0
000g0003o`0005/0002300;o=P000ol0001L0000Q@000ol0000b0003o`0005d000260003o`0002l0
0_mP0000Q`000ol0000]0003o`00060000280003o`0002/000?o0000H@0008T00_lZ0003o`000680
002;0003o`0002H000?o0000H`0008`000?o00008`02ofH0002=0003o`00024000?o0000IP0008h0
0_lP0003o`0006L0002@0003o`0001`000?o0000J000094000?o00006@02of/0002B0003o`0001L0
00?o0000J`0009<000?o00005@000ol0001/0000U002oa@000?o0000K@0009H000?o00003`02og00
002G0003o`0000d000?o0000L00009P000?o00002`000ol0001a0000V@02o`X000?o0000LP0009/0
00?o00001@02ogD0002L0003o`0000<000?o0000M@0009d01Omh0000W@05ogP0002M00GoN00009d0
1Omh0000WP03ogT000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P000190003o`0005<000?o0000N00004T000?o0000D`000ol0001h0000B@000ol0
001C0003o`0007P0001800?oD`03ogT0001700GoD@05ogP0001700GoD@05ogP0001700GoD@05ogP0
001800?o;`000ol0000Q00?oN@0003L000?o00003`000ol0000@0003o`0001/000?o00002@000ol0
00090003o`0000T000?o0000N@0003P000?o00003P000ol0000?0003o`0001d000?o00002@000ol0
00070003o`0000T000?o0000NP0003P000?o00003P000ol0000?0003o`0001d000?o00002@000ol0
00070003o`0000T000?o0000NP0003T000?o00003@000ol0000>0003o`0001l000?o000020000ol0
00070003o`0000P000?o0000N`0003T000?o00003@000ol0000>0003o`0001l000?o000020000ol0
00070003o`0000P000?o0000N`0003T000?o00003@000ol0000=0003o`00020000?o000020000ol0
00070003o`0000P000?o0000N`0003X000?o000030000ol0000=0003o`00024000?o00001`000ol0
00070003o`0000L000?o0000O00003X000?o000030000ol0000<0003o`00028000?o00001`000ol0
00070003o`0000L000?o0000O00003/000?o00002`000ol0000<0003o`0002<000?o00001`000ol0
00050003o`0000L000?o0000O@0003/000?o00002`000ol0000;0003o`0002@000?o00001`000ol0
00050003o`0000L000?o0000O@0003`000?o00002P000ol0000;0003o`0002D000?o00001P000ol0
00050003o`0000H000?o0000OP0003`000?o00002P000ol0000:0003o`0002H000?o00001P000ol0
00050003o`0000H000?o0000OP0003d000?o00002@000ol0000:0003o`0002L000?o00001@000ol0
00050003o`0000D000?o0000O`0003d000?o00002@000ol000090003o`0002P000?o00001@000ol0
00050003o`0000D000?o0000O`0003h000?o000020000ol000090003o`0002T000?o000010000ol0
00050003o`0000@000?o0000P00003h000?o000020000ol000080003o`0002X000?o00001@000ol0
00030003o`0000D000?o0000P00003l000?o00001`000ol000080003o`0002/000?o000010000ol0
00030003o`0000@000?o0000P@0003l000?o00001`000ol000070003o`0002`000?o000010000ol0
00030003o`0000@000?o0000P@00040000?o00001P000ol000070003o`0002d000?o00000`000ol0
00030003o`0000<000?o0000PP00040000?o00001P000ol000070003o`0002d000?o00000`000ol0
00030003o`0000<000?o0000PP00040000?o00001P000ol000060003o`0002h000?o00000`000ol0
00030003o`0000<000?o0000PP00044000?o00001@000ol000060003o`0002l000?o00000P000ol0
00030003o`00008000?o0000P`00044000?o00001@000ol000050003o`00030000?o00000`001Ol0
003o00D000?o0000P`00048000?o000010000ol000050003o`00034000?o00000P001Ol0003o00@0
00?o0000Q000048000?o000010000ol000040003o`00038000?o00000P001Ol0003o00@000?o0000
Q00004<000?o00000`000ol000040003o`0003<000Go0000o`030005o`000?l0Q`0004<000?o0000
0`000ol000030003o`0003@000Go0000o`030005o`000?l0Q`0004@000?o00000P000ol000030003
o`0003D000Co003o0`001?l00?n80000A0000ol000020003o`00008000?o0000=P001?l00?l30004
o`00ohP000150005o`000?l010000ol0000g0006o`00o`3o0P000ol000270000A@001Ol0003o00<0
00?o0000>0001_l00?l0o`8000?o0000Q`0004H000Co003o0`000ol0000i0007o`3o0?l0o`2:0000
AP001?l00?l20003o`0003X000Oo0?l0o`3o08X000160004o`00o`8000?o0000>P001ol0o`3o0?l0
RP0004L000Go0?l0o`0n00;o00<0ool0R`0004L000Go0?l0o`0n00;o00<0ool0R`0004P00om000?o
S00004L01Oln00GoR`0000T000?o0000>`05och01On;00002P03ocX01Oln00GoO@03o`/0000=00?o
>003o`030?oo03d00olm00;o?003o`h0000@00?o>`02oc`000?o0000>P02oc/00olA00004`04ocT0
00?o0000>@000ol0000i0003o`0003L01?lD00005`03ocL00_li0003o`0003L00_lg00?o600001X0
0olf00;o=`000ol0000e00;o=P03oa/0000M00?o=@000ol0000d0003o`0003@000?o0000<`03oah0
000P00Co<P02oc@000?o0000<P02oc801?lQ00009003oc400_lb0003o`0003000_la00?o9@0002L0
0ol`0003o`0002l000?o0000;`000ol0000^00?o:00002X00ol^00;o;`000ol0000]00;o;P03ob/0
000]00Co;0000ol0000/0003o`0002`000?o0000:P04obh0000a00?o:P02ob`000?o0000:P02obX0
0olb0000=003obT00_lZ0003o`0002P00_lY00?o=@0003L00olX0003o`0002L000?o00009`000ol0
000V00?o>00003X01?lU00;o9`000ol0000U00;o9@04oc/0000n00?o9002obD000?o00008`02ob@0
0olo0000@@03ob<000?o00008P000ol0000R0003o`0002400om20000A003ob400_lR0003o`000200
0_lQ00?oA@0004L01?lO00;o80000ol0000N00;o7`04odP0001;00?o7P000ol0000M0003o`0001d0
00?o00007003od`0001>00?o7002oad000?o00006`02oa`00om?0000D@03oa/000?o00006P000ol0
000J0003o`0001T00omB0000E003oaT00_lJ0003o`0001P00_lI00?oE@0005L01?lG00;o60000ol0
000F00;o5`04oeP0001K00?o5P000ol0000E0003o`0001D000?o00005003oe`0001N00?o5002oaD0
00?o00004`02oa@00omO0000H@03oa<00_lC0003o`0001400_lC00?oHP0006@01?lA0003o`000100
00?o000040000ol0000?00CoI@0006P00ol?00;o40000ol0000>00;o3`03ofT0001[00?o3P000ol0
000=0003o`0000d000?o00003003of`0001^00?o3002o`d000?o00002`02o``00om_0000L@04o`X0
0_l;0003o`0000T00_l:00CoLP0007D00ol90003o`0000P000?o000020000ol0000700?oMP0007P0
0ol700;o20000ol0000600;o1`03ogT0001k00?o1P02o`H000?o00001002o`H00oml0000OP04o`@0
00?o00000`000ol000030003o`0000801?mo0000PP03o`800_l30004o`0000;o0P03oh<0002500?o
00H0ool0o`02o`040?ooohH0002800WoR@0008X01On;0000RP05oh/0002:00GoR`0008/00on<0000
o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.02 w
.66907 .30902 Mdot
.71509 .30902 Mdot
0 g
0 w
.7611 .30902 m
.7611 .16187 L
s
.02 w
.7611 .30902 Mdot
0 w
.7611 .16187 m
.5798 .01472 L
s
.7611 .16187 m
.9424 .01472 L
s
1 g
.02 w
.5798 .01472 Mdot
.9424 .01472 Mdot
0 g
.7611 .16187 Mdot
1 g
.80712 .30902 Mdot
0 g
.7381 .45617 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000:D000?o0000G@000ol0000B0000YP000ol0001K0003o`0001<0002W00;o
F@02oaH0002Y0003o`0005D000?o00005P000:X000?o0000D`000ol0000G0000Z`000ol0001A0003
o`0001P0002/00;oC`02oa/0002^0003o`0004/000?o00006`000:l000?o0000B@000ol0000L0000
/0000ol000170003o`0001d0002a00;oA@02ob00002c0003o`00044000?o000080000;@000?o0000
?`000ol0000Q0000]@000ol0000m0003o`000280002f00;o>`02obD0002h0003o`0003L000?o0000
9@000;T000?o0000=@000ol0000V0000^P000ol0000c0003o`0002L0002k00;o<@02obX0002m0003
o`0002d000?o0000:P000;h000?o0000:`000ol0000[0000_`000ol0000Y0003o`0002`000300003
o`0002L000?o0000;@000<400_lU00;o<0000<<000?o00008@000ol0000`0000a0000ol0000O0003
o`00034000350003o`0001d000?o0000<P000<H00_lK00;o=@000<P000?o00005`000ol0000e0000
b@000ol0000E0003o`0003H0003:0003o`0001<000?o0000=`000</00_lA00;o>P000<d000?o0000
3@000ol0000j0000cP000ol0000;0003o`0003/0003?0003o`0000T000?o0000?0000=000_l700;o
?`000=8000?o00000`000ol0000o0000d`05od80003C00Go@P000=<01Om20000d`05od80003D00?o
@`0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004P00on900?o@`0004L01On700Go@P0004L01On700Go@P0004L01On700Go@P0004P00on900?o
@`0003L000?o00003`000ol0000@0003o`0005d000?o00002@000ol0000:0003o`0000T000?o0000
=P0003P000?o00003P000ol0000?0003o`0005l000?o00002@000ol000080003o`0000T000?o0000
=`0003P000?o00003P000ol0000?0003o`0005l000?o00002@000ol000080003o`0000T000?o0000
=`0003T000?o00003@000ol0000>0003o`00064000?o000020000ol000080003o`0000P000?o0000
>00003T000?o00003@000ol0000>0003o`00064000?o000020000ol000080003o`0000P000?o0000
>00003T000?o00003@000ol0000=0003o`0006<000?o00001`000ol000080003o`0000P000?o0000
>00003X000?o000030000ol0000=0003o`0006<000?o00001`000ol000080003o`0000L000?o0000
>@0003X000?o000030000ol0000<0003o`0006D000?o00001`000ol000070003o`0000L000?o0000
>@0003/000?o00002`000ol0000<0003o`0006D000?o00001`000ol000060003o`0000L000?o0000
>P0003/000?o00002`000ol0000;0003o`0006L000?o00001P000ol000060003o`0000L000?o0000
>P0003`000?o00002P000ol0000;0003o`0006L000?o00001P000ol000060003o`0000H000?o0000
>`0003`000?o00002P000ol0000:0003o`0006T000?o00001@000ol000060003o`0000H000?o0000
>`0003d000?o00002@000ol0000:0003o`0006T000?o00001@000ol000060003o`0000D000?o0000
?00003d000?o00002@000ol000090003o`0006/000?o00001@000ol000050003o`0000D000?o0000
?00003h000?o000020000ol000090003o`0006/000?o00001@000ol000050003o`0000@000?o0000
?@0003h000?o000020000ol000080003o`0006d000?o000010000ol000040003o`0000D000?o0000
?@0003l000?o00001`000ol000080003o`0006d000?o000010000ol000040003o`0000@000?o0000
?P0003l000?o00001`000ol000070003o`0006l000?o00000`000ol000040003o`0000@000?o0000
?P00040000?o00001P000ol000070003o`0006l000?o000010000ol000030003o`0000<000?o0000
?`00040000?o00001P000ol000070003o`0006l000?o000010000ol000030003o`0000<000?o0000
?`00040000?o00001P000ol000060003o`00074000?o00000`000ol000030003o`0000<000?o0000
?`00044000?o00001@000ol000060003o`00074000?o00000`000ol000030003o`00008000?o0000
@000044000?o00001@000ol000050003o`0007<000?o00000P000ol000020003o`0000<000?o0000
@000048000?o000010000ol000050003o`0007<000?o00000P000ol000020003o`00008000?o0000
@@00048000?o000010000ol000040003o`0007D000?o00000P001Ol0003o00@000?o0000@@0004<0
00?o00000`000ol000040003o`0007D000?o00000P001Ol0003o00<000?o0000@P0004<000?o0000
0`000ol000030003o`0007L000Go0000o`030005o`000?l0A00004@000?o00000P000ol000030003
o`0007L000Go0000o`030004o`00odD000140003o`00008000?o00000P000ol0001i0004o`00o`<0
00Co003oA@0004D000Go0000o`040003o`0007T000Co003o0P001?l00?m60000A@001Ol0003o00<0
00?o0000N`001_l00?l0o`8000?o0000A00004H000Co003o0`000ol0001k0008o`00o`3o0?m70000
AP001?l00?l20003o`0007d000Oo0?l0o`3o04L000160004o`00o`8000?o0000O@001ol0o`3o0?l0
A`0004L000Go0?l0o`2100;o00<0ool0B00004L000Go0?l0o`2100;o00<0ool0B00004P00on200Co
B@0004L01On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o
>003o`030?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0
000i0003o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH0
0_lg0003o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P000200
1?lb00;o=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc00
00?o0000;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d0
1?l/0003o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80
000d00?o:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H0
0olh0000>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0
001100?o8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob40
0om50000A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0
000L00?oC00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X0
00?o00006@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H0
0_lG00CoF00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0
000C00;o5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0
000@0003o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d0
00?o00003@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/0
00?o00002@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L0
0_l80003o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol0
00030003o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3o
o`3o00;o00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/0
0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;0000?o0000F`000ol000090000/@000ol0001I0003o`0000X0002b0003
o`0005L000?o00002`000;<00_mE00;o3P000;D000?o0000D@000ol0000>0000]P000ol0001?0003
o`0000l0002g0003o`0004d000?o000040000;P00_m;00;o4`000;X000?o0000A`000ol0000C0000
^`000ol000150003o`0001@0002l0003o`0004<000?o00005@000;d000?o0000@@000ol0000F0000
_P02ocl00_lI0000`0000ol0000k0003o`0001T000310003o`0003T000?o00006P000<8000?o0000
=`000ol0000K0000``02ocD00_lN0000a@000ol0000a0003o`0001h000360003o`0002l000?o0000
7`000<L000?o0000;@000ol0000P0000b0000ol0000[0003o`000240003900;o:@02ob@0003;0003
o`0002D000?o000090000<`000?o00008`000ol0000U0000c@000ol0000Q0003o`0002H0003>00;o
7`02obT0003@0003o`0001/000?o0000:@000=4000?o00006@000ol0000Z0000dP000ol0000G0003
o`0002/0003C0003o`0001D000?o0000;0000=@00_lC00;o;`000=H000?o00003`000ol0000_0000
e`000ol0000=0003o`000300003H0003o`0000/000?o0000<@000=T00_l900;o=0000=/000?o0000
1@000ol0000d0000g0000ol000030003o`0003D0003M00Go>0000=d01Olh0000g@05ocP0003M00Go
>0000=h00oli0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000A`03oi@00oli0000AP05oi801Olh0000AP05oi801Olh0000AP05oi801Olh0000
A`03oi@00oli0000=P000ol0000@0003o`0000l000?o0000G0000ol000090003o`0000T000?o0000
2@000ol0000i0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000P000?o0000JP000ol000040003o`0000D000?o0000
10000ol000100000?P000ol000080003o`0000P000?o0000JP000ol000050003o`0000<000?o0000
1@000ol000100000?P000ol000080003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000D000?o0000L0000ol000020003o`0000<000?o0000
0P000ol000130000@@000ol000050003o`0000D000?o0000L0000ol000030005o`000?l01@000ol0
00130000@@000ol000050003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000
@P000ol000040003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000@P000ol0
00040003o`0000<000?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`0000<0
00?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`00008000?o0000MP001?l0
0?l30004o`00odP000140003o`00008000?o00000P000ol0001f0004o`00o`<000Co003oB00004@0
00?o00000P001Ol0003o07X000Ko003o0?l20003o`0004L000150005o`000?l00`000ol0001h0006
o`00o`3o0P000ol000170000A@001Ol0003o008000?o0000NP001ol0o`3o0?l0BP0004H000Co003o
0P000ol0001j0007o`3o0?l0o`1:0000AP001?l00?l20003o`0007X000Oo0?l0o`3o04X000170005
o`3o0?l0OP02o`030?oo04/000170005o`3o0?l0OP02o`030?oo04/0001700CoP003od`0001600Go
O`05od/000090003o`0003X01Omo00GoB`0000X00oli00KoOP05ocX00ol>00003@03ocL00ol200;o
NP02o`040?ooocP00olA00004003oc/00_lj0003o`0003T00_lk00?o500001<00olj0003o`0003L0
00?o0000>0000ol0000h00?o5`0001H01?lg00;o=`000ol0000f00;o=`04oaX0000J00?o=P000ol0
000d0003o`0003D000?o0000=003oah0000M00?o=002oc@000?o0000<`02oc@00olQ00008003oc<0
00?o0000<@000ol0000a00;o<`03ob@0000S00?o<@02oc4000?o0000<0000ol0000_00Co9`0002H0
1?l_00;o;`000ol0000^00;o;`03ob/0000Z00?o;P000ol0000/0003o`0002`00_l^00?o;P0002d0
0ol/00;o;0000ol0000[0003o`0002/00ola0000<003ob/000?o0000:@000ol0000Y00;o:`03oc@0
000c00?o:@02obT000?o0000:0000ol0000W00Co=`0003H01?lW00;o9`000ol0000V00;o9`03oc/0
000j00?o9P000ol0000T0003o`0002@00_lV00?o?P0003d00olT00;o90000ol0000S0003o`0002<0
0om10000@003ob<000?o00008@000ol0000Q00;o8P04od@0001300?o8@02ob4000?o000080000ol0
000O00?oB00004H01?lO00;o7`000ol0000N00;o7`03od/0001:00?o7P000ol0000L0003o`0001`0
0_lN00?oCP0004d00olL00;o70000ol0000K0003o`0001/00omA0000D003oa/000?o00006@000ol0
000I00;o6P04oe@0001C00?o6@02oaT000?o000060000ol0000G00?oF00005H00olH0003o`0001H0
00?o00005P02oaL00omK0000F@04oaD00_lF0003o`0001@00_lF00?oGP0005d00olD00;o50000ol0
000C0003o`0001801?mQ0000H003oa<000?o00004@000ol0000A00;o4P03ofD0001S00?o4@02oa40
00?o000040000ol0000?00?oJ00006H00ol@0003o`0000h000?o00003P02o`l00om[0000J@04o`d0
0_l>0003o`0000`00_l>00?oKP0006d00ol<00;o30000ol0000;0003o`0000X01?ma0000L003o`/0
00?o00002@000ol0000900;o2P03ogD0001c00?o2@02o`T000?o00001`02o`T00omh0000MP03o`P0
00?o00001P000ol000060003o`0000H00omk0000N@04o`D00_l60003o`0000@00_l500CoOP0007d0
0ol40003o`0000<000?o00000`000ol0000200?oPP0008000ol200;o0`001?l00002o`800on50000
P`03o`060?oo0?l00_l0103ooon80000QP09oh/0002800GoS@0008P01On=0000R005ohd0002900?o
SP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1095, -0.820004, 0.0151971, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2389 .30902 L
s
.2619 .45617 m
.28491 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
.2389 .30902 Mdot
.28491 .30902 Mdot
0 g
0 w
.33093 .30902 m
.33093 .16187 L
s
.02 w
.33093 .30902 Mdot
0 w
.33093 .16187 m
.14963 .01472 L
s
.33093 .16187 m
.51223 .01472 L
s
1 g
.02 w
.14963 .01472 Mdot
.51223 .01472 Mdot
0 g
.33093 .16187 Mdot
.2619 .45617 Mdot
0 w
.5 .45617 m
.43097 .30902 L
s
.5 .45617 m
.5 .30902 L
s
.5 .45617 m
.56903 .30902 L
s
1 g
.02 w
.43097 .30902 Mdot
0 g
0 w
.5 .30902 m
.5 .16187 L
s
.02 w
.5 .30902 Mdot
1 g
.5 .16187 Mdot
.56903 .30902 Mdot
0 g
.5 .45617 Mdot
1 g
.7381 .45617 Mdot
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`0002d000?o0000G0000ol0002;0000;P000ol0001J0003o`0008`0000_00;o
F@000ol0002=0000<@000ol0001D00;oT000038000?o0000DP000ol0002@0000<`000ol0001@0003
o`000940000d00;oC`000ol0002B0000=P000ol0001:00;oU@0003L000?o0000B0000ol0002E0000
>0000ol000160003o`0009H0000i00;oA@000ol0002G0000>`000ol000110003o`0009P0000l0003
o`0003h00_nK0000?@000ol0000l0003o`0009/0000n00;o>`000ol0002L0000@0000ol0000g0003
o`0009d000110003o`0003@00_nP0000@P000ol0000b0003o`000:00001300;o<@000ol0002Q0000
A@000ol0000]0003o`000:8000160003o`0002/000?o0000X`0004L000?o0000:002ojH000180003
o`0002H000?o0000YP0004T00_lU0003o`000:L0001;0003o`00024000?o0000Z00004`000?o0000
7P02oj/0001=0003o`0001`000?o0000Z`0004h00_lK0003o`000:`0001@0003o`0001L000?o0000
[@00054000?o00005@000ol0002^0000DP000ol0000B00;o/@0005<00_lA0003o`000;40001E0003
o`0000d000?o0000/P0005H000?o00002`000ol0002c0000E`000ol0000800;o]P0005P00_l70003
o`000;H0001J0003o`0000<000?o0000]`0005/00ol00`3o002i0000FP05ok/0001J00Go^`0005X0
1Onk0000F`03ok`0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001M0003o`0002`000?o0000R`0005d000?o0000;0000ol0002;0000G@000ol0
000/0003o`0008/0001K00?o;@03oh`0001J00Go:`05oh/0001J00Go:`05oh/0001J00Go:`05oh/0
001K00?o70000ol0000>00?oS00003L000?o00002@000ol0000:0003o`0000T000?o00006`000ol0
000?0003o`0000l000?o0000N@0003P000?o00002@000ol000080003o`0000T000?o00007@000ol0
000>0003o`0000h000?o0000NP0003P000?o00002@000ol000080003o`0000T000?o00007@000ol0
000>0003o`0000h000?o0000NP0003T000?o000020000ol000080003o`0000P000?o00007`000ol0
000=0003o`0000d000?o0000N`0003T000?o000020000ol000080003o`0000P000?o00007`000ol0
000=0003o`0000d000?o0000N`0003T000?o000020000ol000080003o`0000L000?o000080000ol0
000=0003o`0000d000?o0000N`0003X000?o00001`000ol000080003o`0000L000?o00008@000ol0
000<0003o`0000`000?o0000O00003X000?o00001`000ol000070003o`0000L000?o00008P000ol0
000<0003o`0000`000?o0000O00003/000?o00001`000ol000060003o`0000L000?o00008`000ol0
000;0003o`0000/000?o0000O@0003/000?o00001`000ol000060003o`0000H000?o000090000ol0
000;0003o`0000/000?o0000O@0003`000?o00001P000ol000060003o`0000H000?o00009@000ol0
000:0003o`0000X000?o0000OP0003`000?o00001P000ol000060003o`0000D000?o00009P000ol0
000:0003o`0000X000?o0000OP0003d000?o00001@000ol000060003o`0000D000?o00009`000ol0
00090003o`0000T000?o0000O`0003d000?o00001@000ol000050003o`0000D000?o0000:0000ol0
00090003o`0000T000?o0000O`0003h000?o000010000ol000050003o`0000D000?o0000:@000ol0
00080003o`0000P000?o0000P00003h000?o00001@000ol000040003o`0000@000?o0000:P000ol0
00080003o`0000P000?o0000P00003l000?o000010000ol000040003o`0000@000?o0000:`000ol0
00070003o`0000L000?o0000P@0003l000?o000010000ol000040003o`0000<000?o0000;0000ol0
00070003o`0000L000?o0000P@00040000?o00000`000ol000030003o`0000@000?o0000;@000ol0
00060003o`0000H000?o0000PP00040000?o00000`000ol000030003o`0000@000?o0000;@000ol0
00060003o`0000H000?o0000PP00040000?o00000`000ol000030003o`0000<000?o0000;P000ol0
00060003o`0000H000?o0000PP00044000?o00000P000ol000030003o`0000<000?o0000;`000ol0
00050003o`0000D000?o0000P`00044000?o00000`000ol000020003o`00008000?o0000<0000ol0
00050003o`0000D000?o0000P`00048000?o00000P000ol000020003o`00008000?o0000<@000ol0
00040003o`0000@000?o0000Q000048000?o00000P001Ol0003o00@000?o0000<P000ol000040003
o`0000@000?o0000Q00004<000Go0000o`030003o`00008000?o0000<`000ol000030003o`0000<0
00?o0000Q@0004<000Go0000o`030005o`000?l0=P000ol000030003o`0000<000?o0000Q@0004@0
00Co003o0`001Ol0003o03L000?o00000P000ol000020003o`0008H000140004o`00o`<000Co003o
>0000ol000020003o`00008000?o0000QP0004D000Co003o0P001?l00?li0005o`000?l00`000ol0
00270000A@001_l00?l0o`8000?o0000>0001Ol0003o00<000?o0000Q`0004H000Go0?l0o`020003
o`0003T000Co003o0P000ol000280000AP001ol0o`3o0?l0?0001?l00?l20003o`0008P000160007
o`3o0?l0o`0l0004o`00o`8000?o0000R00004L00_l00`3oo`0n0005o`3o0?l0R`0004L00_l00`3o
o`0n0005o`3o0?l0R`0004P00om000?oS00004L01Oln00GoR`0000T000?o0000>`05och01On;0000
2P03ocX01Oln00GoO@03o`/0000=00?o>003o`030?oo03d00olm00;o?003o`h0000@00?o>`02oc`0
00?o0000>P02oc/00olA00004`04ocT000?o0000>@000ol0000i0003o`0003L01?lD00005`03ocL0
0_li0003o`0003L00_lg00?o600001X00olf00;o=`000ol0000e00;o=P03oa/0000M00?o=@000ol0
000d0003o`0003@000?o0000<`03oah0000P00Co<P02oc@000?o0000<P02oc801?lQ00009003oc40
0_lb0003o`0003000_la00?o9@0002L00ol`0003o`0002l000?o0000;`000ol0000^00?o:00002X0
0ol^00;o;`000ol0000]00;o;P03ob/0000]00Co;0000ol0000/0003o`0002`000?o0000:P04obh0
000a00?o:P02ob`000?o0000:P02obX00olb0000=003obT00_lZ0003o`0002P00_lY00?o=@0003L0
0olX0003o`0002L000?o00009`000ol0000V00?o>00003X01?lU00;o9`000ol0000U00;o9@04oc/0
000n00?o9002obD000?o00008`02ob@00olo0000@@03ob<000?o00008P000ol0000R0003o`000240
0om20000A003ob400_lR0003o`0002000_lQ00?oA@0004L01?lO00;o80000ol0000N00;o7`04odP0
001;00?o7P000ol0000M0003o`0001d000?o00007003od`0001>00?o7002oad000?o00006`02oa`0
0om?0000D@03oa/000?o00006P000ol0000J0003o`0001T00omB0000E003oaT00_lJ0003o`0001P0
0_lI00?oE@0005L01?lG00;o60000ol0000F00;o5`04oeP0001K00?o5P000ol0000E0003o`0001D0
00?o00005003oe`0001N00?o5002oaD000?o00004`02oa@00omO0000H@03oa<00_lC0003o`000140
0_lC00?oHP0006@01?lA0003o`00010000?o000040000ol0000?00CoI@0006P00ol?00;o40000ol0
000>00;o3`03ofT0001[00?o3P000ol0000=0003o`0000d000?o00003003of`0001^00?o3002o`d0
00?o00002`02o``00om_0000L@04o`X00_l;0003o`0000T00_l:00CoLP0007D00ol90003o`0000P0
00?o000020000ol0000700?oMP0007P00ol700;o20000ol0000600;o1`03ogT0001k00?o1P02o`H0
00?o00001002o`H00oml0000OP04o`@000?o00000`000ol000030003o`0000801?mo0000PP03o`80
0_l30004o`0000;o0P03oh<0002500?o00H0ool0o`02o`040?ooohH0002800WoR@0008X01On;0000
RP05oh/0002:00GoR`0008/00on<0000o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.02 w
.66907 .30902 Mdot
0 g
0 w
.71509 .30902 m
.71509 .16187 L
s
.02 w
.71509 .30902 Mdot
0 w
.71509 .16187 m
.53379 .01472 L
s
.71509 .16187 m
.89639 .01472 L
s
1 g
.02 w
.53379 .01472 Mdot
.89639 .01472 Mdot
0 g
.71509 .16187 Mdot
1 g
.7611 .30902 Mdot
.80712 .30902 Mdot
0 g
.7381 .45617 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`0009P000?o0000G@000ol0000O0000V@000ol0001K0003o`000200002J00;o
F@02ob<0002L0003o`0005D000?o00008`0009d000?o0000D`000ol0000T0000WP000ol0001A0003
o`0002D0002O00;oC`02obP0002Q0003o`0004/000?o0000:0000:8000?o0000B@000ol0000Y0000
X`000ol000170003o`0002X0002T00;oA@02obd0002V0003o`00044000?o0000;@000:L000?o0000
?`000ol0000^0000Z0000ol0000m0003o`0002l0002Y00;o>`02oc80002[0003o`0003L000?o0000
<P000:`000?o0000=@000ol0000c0000[@000ol0000c0003o`0003@0002^00;o<@02ocL0002`0003
o`0002d000?o0000=`000;4000?o0000:`000ol0000h0000/P000ol0000Y0003o`0003T0002c0003
o`0002L000?o0000>P000;@00_lU00;o?@000;H000?o00008@000ol0000m0000]`000ol0000O0003
o`0003h0002h0003o`0001d000?o0000?`000;T00_lK00;o@P000;/000?o00005`000ol000120000
_0000ol0000E0003o`0004<0002m0003o`0001<000?o0000A0000;h00_lA00;oA`000<0000?o0000
3@000ol000170000`@000ol0000;0003o`0004P000320003o`0000T000?o0000B@000<<00_l700;o
C0000<D000?o00000`000ol0001<0000aP05odl0003600GoC`000<H01Om?0000aP05odl0003700?o
D00004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004T000?o0000O0000ol0001?0000B@000ol0001l0003o`0004l000190003o`0007`000?o0000
C`0004P00oml00?oD00004L01Omj00GoC`0004L01Omj00GoC`0004L01Omj00GoC`0004P00oml00?o
D00003L000?o00003`000ol0000@0003o`0005d000?o00002@000ol0000:0003o`0000T000?o0000
=P0003P000?o00003P000ol0000?0003o`0005l000?o00002@000ol000080003o`0000T000?o0000
=`0003P000?o00003P000ol0000?0003o`0005l000?o00002@000ol000080003o`0000T000?o0000
=`0003T000?o00003@000ol0000>0003o`00064000?o000020000ol000080003o`0000P000?o0000
>00003T000?o00003@000ol0000>0003o`00064000?o000020000ol000080003o`0000P000?o0000
>00003T000?o00003@000ol0000=0003o`0006<000?o00001`000ol000080003o`0000P000?o0000
>00003X000?o000030000ol0000=0003o`0006<000?o00001`000ol000080003o`0000L000?o0000
>@0003X000?o000030000ol0000<0003o`0006D000?o00001`000ol000070003o`0000L000?o0000
>@0003/000?o00002`000ol0000<0003o`0006D000?o00001`000ol000060003o`0000L000?o0000
>P0003/000?o00002`000ol0000;0003o`0006L000?o00001P000ol000060003o`0000L000?o0000
>P0003`000?o00002P000ol0000;0003o`0006L000?o00001P000ol000060003o`0000H000?o0000
>`0003`000?o00002P000ol0000:0003o`0006T000?o00001@000ol000060003o`0000H000?o0000
>`0003d000?o00002@000ol0000:0003o`0006T000?o00001@000ol000060003o`0000D000?o0000
?00003d000?o00002@000ol000090003o`0006/000?o00001@000ol000050003o`0000D000?o0000
?00003h000?o000020000ol000090003o`0006/000?o00001@000ol000050003o`0000@000?o0000
?@0003h000?o000020000ol000080003o`0006d000?o000010000ol000040003o`0000D000?o0000
?@0003l000?o00001`000ol000080003o`0006d000?o000010000ol000040003o`0000@000?o0000
?P0003l000?o00001`000ol000070003o`0006l000?o00000`000ol000040003o`0000@000?o0000
?P00040000?o00001P000ol000070003o`0006l000?o000010000ol000030003o`0000<000?o0000
?`00040000?o00001P000ol000070003o`0006l000?o000010000ol000030003o`0000<000?o0000
?`00040000?o00001P000ol000060003o`00074000?o00000`000ol000030003o`0000<000?o0000
?`00044000?o00001@000ol000060003o`00074000?o00000`000ol000030003o`00008000?o0000
@000044000?o00001@000ol000050003o`0007<000?o00000P000ol000020003o`0000<000?o0000
@000048000?o000010000ol000050003o`0007<000?o00000P000ol000020003o`00008000?o0000
@@00048000?o000010000ol000040003o`0007D000?o00000P001Ol0003o00@000?o0000@@0004<0
00?o00000`000ol000040003o`0007D000?o00000P001Ol0003o00<000?o0000@P0004<000?o0000
0`000ol000030003o`0007L000Go0000o`030005o`000?l0A00004@000?o00000P000ol000030003
o`0007L000Go0000o`030004o`00odD000140003o`00008000?o00000P000ol0001i0004o`00o`<0
00Co003oA@0004D000Go0000o`040003o`0007T000Co003o0P001?l00?m60000A@001Ol0003o00<0
00?o0000N`001_l00?l0o`8000?o0000A00004H000Co003o0`000ol0001k0008o`00o`3o0?m70000
AP001?l00?l20003o`0007d000Oo0?l0o`3o04L000160004o`00o`8000?o0000O@001ol0o`3o0?l0
A`0004L000Go0?l0o`2100;o00<0ool0B00004L000Go0?l0o`2100;o00<0ool0B00004P00on200Co
B@0004L01On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o
>003o`030?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0
000i0003o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH0
0_lg0003o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P000200
1?lb00;o=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc00
00?o0000;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d0
1?l/0003o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80
000d00?o:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H0
0olh0000>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0
001100?o8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob40
0om50000A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0
000L00?oC00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X0
00?o00006@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H0
0_lG00CoF00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0
000C00;o5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0
000@0003o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d0
00?o00003@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/0
00?o00002@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L0
0_l80003o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol0
00030003o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3o
o`3o00;o00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/0
0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.02 w
.19288 .30902 Mdot
0 g
0 w
.2619 .30902 m
.2619 .16187 L
s
.02 w
.2619 .30902 Mdot
1 g
.2619 .16187 Mdot
.33093 .30902 Mdot
0 g
.2619 .45617 Mdot
1 g
.5 .45617 Mdot
0 g
0 w
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.02 w
.66907 .30902 Mdot
.71509 .30902 Mdot
0 g
0 w
.7611 .30902 m
.7611 .16187 L
s
.02 w
.7611 .30902 Mdot
0 w
.7611 .16187 m
.5798 .01472 L
s
.7611 .16187 m
.9424 .01472 L
s
1 g
.02 w
.5798 .01472 Mdot
.9424 .01472 Mdot
0 g
.7611 .16187 Mdot
1 g
.80712 .30902 Mdot
0 g
.7381 .45617 Mdot
1 g
.97619 .45617 Mdot
0 g
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000:D000?o0000G@000ol0000B0000YP000ol0001K0003o`0001<0002W00;o
F@02oaH0002Y0003o`0005D000?o00005P000:X000?o0000D`000ol0000G0000Z`000ol0001A0003
o`0001P0002/00;oC`02oa/0002^0003o`0004/000?o00006`000:l000?o0000B@000ol0000L0000
/0000ol000170003o`0001d0002a00;oA@02ob00002c0003o`00044000?o000080000;@000?o0000
?`000ol0000Q0000]@000ol0000m0003o`000280002f00;o>`02obD0002h0003o`0003L000?o0000
9@000;T000?o0000=@000ol0000V0000^P000ol0000c0003o`0002L0002k00;o<@02obX0002m0003
o`0002d000?o0000:P000;h000?o0000:`000ol0000[0000_`000ol0000Y0003o`0002`000300003
o`0002L000?o0000;@000<400_lU00;o<0000<<000?o00008@000ol0000`0000a0000ol0000O0003
o`00034000350003o`0001d000?o0000<P000<H00_lK00;o=@000<P000?o00005`000ol0000e0000
b@000ol0000E0003o`0003H0003:0003o`0001<000?o0000=`000</00_lA00;o>P000<d000?o0000
3@000ol0000j0000cP000ol0000;0003o`0003/0003?0003o`0000T000?o0000?0000=000_l700;o
?`000=8000?o00000`000ol0000o0000d`05od80003C00Go@P000=<01Om20000d`05od80003D00?o
@`0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004T000?o0000R@000ol000120000B@000ol000290003o`00048000190003o`0008T000?o0000
@P0004P00on900?o@`0004L01On700Go@P0004L01On700Go@P0004L01On700Go@P0004P00on900?o
@`0003L000?o00003`000ol0000@0003o`0005d000?o00002@000ol0000:0003o`0000T000?o0000
=P0003P000?o00003P000ol0000?0003o`0005l000?o00002@000ol000080003o`0000T000?o0000
=`0003P000?o00003P000ol0000?0003o`0005l000?o00002@000ol000080003o`0000T000?o0000
=`0003T000?o00003@000ol0000>0003o`00064000?o000020000ol000080003o`0000P000?o0000
>00003T000?o00003@000ol0000>0003o`00064000?o000020000ol000080003o`0000P000?o0000
>00003T000?o00003@000ol0000=0003o`0006<000?o00001`000ol000080003o`0000P000?o0000
>00003X000?o000030000ol0000=0003o`0006<000?o00001`000ol000080003o`0000L000?o0000
>@0003X000?o000030000ol0000<0003o`0006D000?o00001`000ol000070003o`0000L000?o0000
>@0003/000?o00002`000ol0000<0003o`0006D000?o00001`000ol000060003o`0000L000?o0000
>P0003/000?o00002`000ol0000;0003o`0006L000?o00001P000ol000060003o`0000L000?o0000
>P0003`000?o00002P000ol0000;0003o`0006L000?o00001P000ol000060003o`0000H000?o0000
>`0003`000?o00002P000ol0000:0003o`0006T000?o00001@000ol000060003o`0000H000?o0000
>`0003d000?o00002@000ol0000:0003o`0006T000?o00001@000ol000060003o`0000D000?o0000
?00003d000?o00002@000ol000090003o`0006/000?o00001@000ol000050003o`0000D000?o0000
?00003h000?o000020000ol000090003o`0006/000?o00001@000ol000050003o`0000@000?o0000
?@0003h000?o000020000ol000080003o`0006d000?o000010000ol000040003o`0000D000?o0000
?@0003l000?o00001`000ol000080003o`0006d000?o000010000ol000040003o`0000@000?o0000
?P0003l000?o00001`000ol000070003o`0006l000?o00000`000ol000040003o`0000@000?o0000
?P00040000?o00001P000ol000070003o`0006l000?o000010000ol000030003o`0000<000?o0000
?`00040000?o00001P000ol000070003o`0006l000?o000010000ol000030003o`0000<000?o0000
?`00040000?o00001P000ol000060003o`00074000?o00000`000ol000030003o`0000<000?o0000
?`00044000?o00001@000ol000060003o`00074000?o00000`000ol000030003o`00008000?o0000
@000044000?o00001@000ol000050003o`0007<000?o00000P000ol000020003o`0000<000?o0000
@000048000?o000010000ol000050003o`0007<000?o00000P000ol000020003o`00008000?o0000
@@00048000?o000010000ol000040003o`0007D000?o00000P001Ol0003o00@000?o0000@@0004<0
00?o00000`000ol000040003o`0007D000?o00000P001Ol0003o00<000?o0000@P0004<000?o0000
0`000ol000030003o`0007L000Go0000o`030005o`000?l0A00004@000?o00000P000ol000030003
o`0007L000Go0000o`030004o`00odD000140003o`00008000?o00000P000ol0001i0004o`00o`<0
00Co003oA@0004D000Go0000o`040003o`0007T000Co003o0P001?l00?m60000A@001Ol0003o00<0
00?o0000N`001_l00?l0o`8000?o0000A00004H000Co003o0`000ol0001k0008o`00o`3o0?m70000
AP001?l00?l20003o`0007d000Oo0?l0o`3o04L000160004o`00o`8000?o0000O@001ol0o`3o0?l0
A`0004L000Go0?l0o`2100;o00<0ool0B00004L000Go0?l0o`2100;o00<0ool0B00004P00on200Co
B@0004L01On000GoB@0000T000?o0000>`05oh001Om900002P03ocX01On000Go>`03o`/0000=00?o
>003o`030?oo07d01Oli00?o3P0001000olk00;o?0000ol0000j00;o>`03oa40000C00Co>@000ol0
000i0003o`0003T000?o0000=`04oa@0000G00?o=`02ocT000?o0000=`02ocL00olH00006P03ocH0
0_lg0003o`0003D00_lf00?o6`0001d00ole0003o`0003@000?o0000=0000ol0000c00?o7P000200
1?lb00;o=0000ol0000b00;o<P04ob40000T00?o<@02oc8000?o0000<002oc400olU00009`03oc00
00?o0000;`000ol0000_0003o`0002h00olX0000:P03obh00_l_0003o`0002d00_l^00?o:`0002d0
1?l/0003o`0002`000?o0000;0000ol0000Z00Co;P0003400olZ00;o;0000ol0000Z00;o:P03oc80
000d00?o:@02obX000?o0000:002obT00ole0000=`03obP000?o00009`000ol0000W0003o`0002H0
0olh0000>P04obD00_lW0003o`0002D00_lU00Co>`0003h00olT00;o9@000ol0000S00;o9003ocl0
001100?o8`000ol0000R0003o`00028000?o00008@03od80001400?o8@02ob8000?o00008002ob40
0om50000A`04oal00_lP0003o`0001h00_lO00CoB00004/00olN0003o`0001d000?o00007@000ol0
000L00?oC00004h00olL00;o7@000ol0000K00;o7003odl0001A00?o6`000ol0000J0003o`0001X0
00?o00006@03oe80001D00?o6@02oaX000?o00006002oaT00omE0000E`04oaL00_lH0003o`0001H0
0_lG00CoF00005/00olF0003o`0001D000?o00005@000ol0000D00?oG00005h00olD00;o5@000ol0
000C00;o5003oel0001Q00?o4`02oa<000?o00004@02oa<00omR0000I004oa4000?o000040000ol0
000@0003o`0000l01?mU0000J003o`l00_l@0003o`0000h00_l?00?oJ@0006/00ol>0003o`0000d0
00?o00003@000ol0000<00?oK00006h00ol<00;o3@000ol0000;00;o3003ofl0001a00Co2P02o`/0
00?o00002@02o`X01?mb0000M@03o`T000?o000020000ol000080003o`0000L00omf0000N003o`L0
0_l80003o`0000H00_l700?oN@0007/00ol600;o1P000ol0000400;o1P03og`0001n00Co10000ol0
00030003o`0000<000?o00000P04ogl0002200?o0P02o`<000Co00000_l200?oP`0008D00ol01P3o
o`3o00;o00@0ooooQP0008P02On90000RP05oh/0002:00GoR`0008X01On;0000R`03oh`0003o01/0
0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.10811, -0.820004, 0.0150044, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;0000?o0000F`000ol000090000/@000ol0001I0003o`0000X0002b0003
o`0005L000?o00002`000;<00_mE00;o3P000;D000?o0000D@000ol0000>0000]P000ol0001?0003
o`0000l0002g0003o`0004d000?o000040000;P00_m;00;o4`000;X000?o0000A`000ol0000C0000
^`000ol000150003o`0001@0002l0003o`0004<000?o00005@000;d000?o0000@@000ol0000F0000
_P02ocl00_lI0000`0000ol0000k0003o`0001T000310003o`0003T000?o00006P000<8000?o0000
=`000ol0000K0000``02ocD00_lN0000a@000ol0000a0003o`0001h000360003o`0002l000?o0000
7`000<L000?o0000;@000ol0000P0000b0000ol0000[0003o`000240003900;o:@02ob@0003;0003
o`0002D000?o000090000<`000?o00008`000ol0000U0000c@000ol0000Q0003o`0002H0003>00;o
7`02obT0003@0003o`0001/000?o0000:@000=4000?o00006@000ol0000Z0000dP000ol0000G0003
o`0002/0003C0003o`0001D000?o0000;0000=@00_lC00;o;`000=H000?o00003`000ol0000_0000
e`000ol0000=0003o`000300003H0003o`0000/000?o0000<@000=T00_l900;o=0000=/000?o0000
1@000ol0000d0000g0000ol000030003o`0003D0003M00Go>0000=d01Olh0000g@05ocP0003M00Go
>0000=h00oli0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000A`03oi@00oli0000AP05oi801Olh0000AP05oi801Olh0000AP05oi801Olh0000
A`03oi@00oli0000=P000ol0000@0003o`0000l000?o0000G0000ol000090003o`0000T000?o0000
2@000ol0000i0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000P000?o0000JP000ol000040003o`0000D000?o0000
10000ol000100000?P000ol000080003o`0000P000?o0000JP000ol000050003o`0000<000?o0000
1@000ol000100000?P000ol000080003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000D000?o0000L0000ol000020003o`0000<000?o0000
0P000ol000130000@@000ol000050003o`0000D000?o0000L0000ol000030005o`000?l01@000ol0
00130000@@000ol000050003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000
@P000ol000040003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000@P000ol0
00040003o`0000<000?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`0000<0
00?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`00008000?o0000MP001?l0
0?l30004o`00odP000140003o`00008000?o00000P000ol0001f0004o`00o`<000Co003oB00004@0
00?o00000P001Ol0003o07X000Ko003o0?l20003o`0004L000150005o`000?l00`000ol0001h0006
o`00o`3o0P000ol000170000A@001Ol0003o008000?o0000NP001ol0o`3o0?l0BP0004H000Co003o
0P000ol0001j0007o`3o0?l0o`1:0000AP001?l00?l20003o`0007X000Oo0?l0o`3o04X000170005
o`3o0?l0OP02o`030?oo04/000170005o`3o0?l0OP02o`030?oo04/0001700CoP003od`0001600Go
O`05od/000090003o`0003X01Omo00GoB`0000X00oli00KoOP05ocX00ol>00003@03ocL00ol200;o
NP02o`040?ooocP00olA00004003oc/00_lj0003o`0003T00_lk00?o500001<00olj0003o`0003L0
00?o0000>0000ol0000h00?o5`0001H01?lg00;o=`000ol0000f00;o=`04oaX0000J00?o=P000ol0
000d0003o`0003D000?o0000=003oah0000M00?o=002oc@000?o0000<`02oc@00olQ00008003oc<0
00?o0000<@000ol0000a00;o<`03ob@0000S00?o<@02oc4000?o0000<0000ol0000_00Co9`0002H0
1?l_00;o;`000ol0000^00;o;`03ob/0000Z00?o;P000ol0000/0003o`0002`00_l^00?o;P0002d0
0ol/00;o;0000ol0000[0003o`0002/00ola0000<003ob/000?o0000:@000ol0000Y00;o:`03oc@0
000c00?o:@02obT000?o0000:0000ol0000W00Co=`0003H01?lW00;o9`000ol0000V00;o9`03oc/0
000j00?o9P000ol0000T0003o`0002@00_lV00?o?P0003d00olT00;o90000ol0000S0003o`0002<0
0om10000@003ob<000?o00008@000ol0000Q00;o8P04od@0001300?o8@02ob4000?o000080000ol0
000O00?oB00004H01?lO00;o7`000ol0000N00;o7`03od/0001:00?o7P000ol0000L0003o`0001`0
0_lN00?oCP0004d00olL00;o70000ol0000K0003o`0001/00omA0000D003oa/000?o00006@000ol0
000I00;o6P04oe@0001C00?o6@02oaT000?o000060000ol0000G00?oF00005H00olH0003o`0001H0
00?o00005P02oaL00omK0000F@04oaD00_lF0003o`0001@00_lF00?oGP0005d00olD00;o50000ol0
000C0003o`0001801?mQ0000H003oa<000?o00004@000ol0000A00;o4P03ofD0001S00?o4@02oa40
00?o000040000ol0000?00?oJ00006H00ol@0003o`0000h000?o00003P02o`l00om[0000J@04o`d0
0_l>0003o`0000`00_l>00?oKP0006d00ol<00;o30000ol0000;0003o`0000X01?ma0000L003o`/0
00?o00002@000ol0000900;o2P03ogD0001c00?o2@02o`T000?o00001`02o`T00omh0000MP03o`P0
00?o00001P000ol000060003o`0000H00omk0000N@04o`D00_l60003o`0000@00_l500CoOP0007d0
0ol40003o`0000<000?o00000`000ol0000200?oPP0008000ol200;o0`001?l00002o`800on50000
P`03o`060?oo0?l00_l0103ooon80000QP09oh/0002800GoS@0008P01On=0000R005ohd0002900?o
SP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1095, -0.820004, 0.0151971, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;0000?o0000F`000ol000090000/@000ol0001I0003o`0000X0002b0003
o`0005L000?o00002`000;<00_mE00;o3P000;D000?o0000D@000ol0000>0000]P000ol0001?0003
o`0000l0002g0003o`0004d000?o000040000;P00_m;00;o4`000;X000?o0000A`000ol0000C0000
^`000ol000150003o`0001@0002l0003o`0004<000?o00005@000;d000?o0000@@000ol0000F0000
_P02ocl00_lI0000`0000ol0000k0003o`0001T000310003o`0003T000?o00006P000<8000?o0000
=`000ol0000K0000``02ocD00_lN0000a@000ol0000a0003o`0001h000360003o`0002l000?o0000
7`000<L000?o0000;@000ol0000P0000b0000ol0000[0003o`000240003900;o:@02ob@0003;0003
o`0002D000?o000090000<`000?o00008`000ol0000U0000c@000ol0000Q0003o`0002H0003>00;o
7`02obT0003@0003o`0001/000?o0000:@000=4000?o00006@000ol0000Z0000dP000ol0000G0003
o`0002/0003C0003o`0001D000?o0000;0000=@00_lC00;o;`000=H000?o00003`000ol0000_0000
e`000ol0000=0003o`000300003H0003o`0000/000?o0000<@000=T00_l900;o=0000=/000?o0000
1@000ol0000d0000g0000ol000030003o`0003D0003M00Go>0000=d01Olh0000g@05ocP0003M00Go
>0000=h00oli0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000A`03oi@00oli0000AP05oi801Olh0000AP05oi801Olh0000AP05oi801Olh0000
A`03oi@00oli0000=P000ol0000@0003o`0000l000?o0000G0000ol000090003o`0000T000?o0000
2@000ol0000i0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000P000?o0000JP000ol000040003o`0000D000?o0000
10000ol000100000?P000ol000080003o`0000P000?o0000JP000ol000050003o`0000<000?o0000
1@000ol000100000?P000ol000080003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000D000?o0000L0000ol000020003o`0000<000?o0000
0P000ol000130000@@000ol000050003o`0000D000?o0000L0000ol000030005o`000?l01@000ol0
00130000@@000ol000050003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000
@P000ol000040003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000@P000ol0
00040003o`0000<000?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`0000<0
00?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`00008000?o0000MP001?l0
0?l30004o`00odP000140003o`00008000?o00000P000ol0001f0004o`00o`<000Co003oB00004@0
00?o00000P001Ol0003o07X000Ko003o0?l20003o`0004L000150005o`000?l00`000ol0001h0006
o`00o`3o0P000ol000170000A@001Ol0003o008000?o0000NP001ol0o`3o0?l0BP0004H000Co003o
0P000ol0001j0007o`3o0?l0o`1:0000AP001?l00?l20003o`0007X000Oo0?l0o`3o04X000170005
o`3o0?l0OP02o`030?oo04/000170005o`3o0?l0OP02o`030?oo04/0001700CoP003od`0001600Go
O`05od/000090003o`0003X01Omo00GoB`0000X00oli00KoOP05ocX00ol>00003@03ocL00ol200;o
NP02o`040?ooocP00olA00004003oc/00_lj0003o`0003T00_lk00?o500001<00olj0003o`0003L0
00?o0000>0000ol0000h00?o5`0001H01?lg00;o=`000ol0000f00;o=`04oaX0000J00?o=P000ol0
000d0003o`0003D000?o0000=003oah0000M00?o=002oc@000?o0000<`02oc@00olQ00008003oc<0
00?o0000<@000ol0000a00;o<`03ob@0000S00?o<@02oc4000?o0000<0000ol0000_00Co9`0002H0
1?l_00;o;`000ol0000^00;o;`03ob/0000Z00?o;P000ol0000/0003o`0002`00_l^00?o;P0002d0
0ol/00;o;0000ol0000[0003o`0002/00ola0000<003ob/000?o0000:@000ol0000Y00;o:`03oc@0
000c00?o:@02obT000?o0000:0000ol0000W00Co=`0003H01?lW00;o9`000ol0000V00;o9`03oc/0
000j00?o9P000ol0000T0003o`0002@00_lV00?o?P0003d00olT00;o90000ol0000S0003o`0002<0
0om10000@003ob<000?o00008@000ol0000Q00;o8P04od@0001300?o8@02ob4000?o000080000ol0
000O00?oB00004H01?lO00;o7`000ol0000N00;o7`03od/0001:00?o7P000ol0000L0003o`0001`0
0_lN00?oCP0004d00olL00;o70000ol0000K0003o`0001/00omA0000D003oa/000?o00006@000ol0
000I00;o6P04oe@0001C00?o6@02oaT000?o000060000ol0000G00?oF00005H00olH0003o`0001H0
00?o00005P02oaL00omK0000F@04oaD00_lF0003o`0001@00_lF00?oGP0005d00olD00;o50000ol0
000C0003o`0001801?mQ0000H003oa<000?o00004@000ol0000A00;o4P03ofD0001S00?o4@02oa40
00?o000040000ol0000?00?oJ00006H00ol@0003o`0000h000?o00003P02o`l00om[0000J@04o`d0
0_l>0003o`0000`00_l>00?oKP0006d00ol<00;o30000ol0000;0003o`0000X01?ma0000L003o`/0
00?o00002@000ol0000900;o2P03ogD0001c00?o2@02o`T000?o00001`02o`T00omh0000MP03o`P0
00?o00001P000ol000060003o`0000H00omk0000N@04o`D00_l60003o`0000@00_l500CoOP0007d0
0ol40003o`0000<000?o00000`000ol0000200?oPP0008000ol200;o0`001?l00002o`800on50000
P`03o`060?oo0?l00_l0103ooon80000QP09oh/0002800GoS@0008P01On=0000R005ohd0002900?o
SP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1095, -0.820004, 0.0151971, 
  0.00485551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.526165 0.219378 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.52616 .60332 m
.08741 .45617 L
s
.52616 .60332 m
.30679 .45617 L
s
.52616 .60332 m
.52616 .45617 L
s
.52616 .60332 m
.74554 .45617 L
s
.52616 .60332 m
.96492 .45617 L
s
.08741 .45617 m
.02381 .30902 L
s
.08741 .45617 m
.08741 .30902 L
s
.08741 .45617 m
.15101 .30902 L
s
1 g
.02 w
.02381 .30902 Mdot
0 g
0 w
.08741 .30902 m
.08741 .16187 L
s
.02 w
.08741 .30902 Mdot
1 g
.08741 .16187 Mdot
.15101 .30902 Mdot
0 g
.08741 .45617 Mdot
1 g
.30679 .45617 Mdot
.52616 .45617 Mdot
0 g
0 w
.74554 .45617 m
.68194 .30902 L
s
.74554 .45617 m
.72434 .30902 L
s
.74554 .45617 m
.76674 .30902 L
s
.74554 .45617 m
.80914 .30902 L
s
1 g
.02 w
.68194 .30902 Mdot
.72434 .30902 Mdot
.76674 .30902 Mdot
0 g
0 w
.80914 .30902 m
.80914 .16187 L
s
.02 w
.80914 .30902 Mdot
0 w
.80914 .16187 m
.6421 .01472 L
s
.80914 .16187 m
.97619 .01472 L
s
1 g
.02 w
.6421 .01472 Mdot
.97619 .01472 Mdot
0 g
.80914 .16187 Mdot
.74554 .45617 Mdot
1 g
.96492 .45617 Mdot
0 g
.52616 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;L000?o0000E0000ol000090000^0000ol0001B0003o`0000X0002i0003
o`00050000?o00002`000;X000?o0000CP000ol0000<0000^`000ol0001<0003o`0000d0002l00;o
B`000ol0000>0000_P000ol0001600;o4@000;l000?o0000A0000ol0000A0000`0000ol000120003
o`00018000310003o`00040000?o00004`000<8000?o0000?P000ol0000D0000``000ol0000l0003
o`0001D0003400;o>`000ol0000F0000aP000ol0000g0003o`0001L000370003o`0003@00_lJ0000
b0000ol0000b0003o`0001X000390003o`00030000?o00006`000<X000?o0000;P000ol0000L0000
b`02obd000?o00007@000<d000?o0000:@000ol0000N0000cP000ol0000W0003o`0001l0003?0003
o`0002D000?o000080000=0000?o00008`000ol0000Q0000d@000ol0000P00;o90000=8000?o0000
7P000ol0000T0000d`02oad000?o00009@000=D000?o00006@000ol0000V0000eP000ol0000G0003
o`0002L0003G0003o`0001D000?o0000:0000=P000?o00004`000ol0000Y0000f@000ol0000A0003
o`0002X0003J0003o`0000h00_l]0000f`02o`d000?o0000;@000=d000?o00002@000ol0000^0000
gP000ol000070003o`0002l0003O0003o`0000D000?o0000<0000>0000?o00000`000ol0000a0000
h@03o`030?l003<0003P00Go=@000>001Ole0000h005ocD0003Q00?o=P0001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001T000?o0000a`000ol0
000d00006@000ol000370003o`0003@0000I0003o`000<L000?o0000=00001L00oo700?o=P0001H0
1Oo500Go=@0001H01Oo500Go=@0001H01Oo500Go=@0000P000?o00003003olL00olf000020000ol0
000>0003o`0000d000?o0000U0000ol000080003o`0000T000?o000020000ol0000e00002@000ol0
000=0003o`0000d000?o0000U@000ol000080003o`0000L000?o000020000ol0000f00002@000ol0
000=0003o`0000`000?o0000UP000ol000080003o`0000L000?o000020000ol0000f00002@000ol0
000=0003o`0000`000?o0000UP000ol000080003o`0000L000?o000020000ol0000f00002P000ol0
000<0003o`0000/000?o0000V0000ol000070003o`0000L000?o00001`000ol0000g00002P000ol0
000<0003o`0000/000?o0000V0000ol000070003o`0000L000?o00001`000ol0000g00002`000ol0
000;0003o`0000X000?o0000VP000ol000060003o`0000L000?o00001P000ol0000h00002`000ol0
000;0003o`0000X000?o0000VP000ol000060003o`0000L000?o00001P000ol0000h000030000ol0
000:0003o`0000X000?o0000V`000ol000060003o`0000D000?o00001P000ol0000i000030000ol0
000:0003o`0000T000?o0000W0000ol000060003o`0000D000?o00001P000ol0000i000030000ol0
000:0003o`0000T000?o0000W0000ol000060003o`0000D000?o00001P000ol0000i00003@000ol0
00090003o`0000P000?o0000WP000ol000050003o`0000D000?o00001@000ol0000j00003@000ol0
00090003o`0000P000?o0000WP000ol000050003o`0000D000?o00001@000ol0000j00003P000ol0
00080003o`0000P000?o0000W`000ol000040003o`0000D000?o000010000ol0000k00003P000ol0
00080003o`0000L000?o0000X0000ol000040003o`0000D000?o000010000ol0000k00003`000ol0
00070003o`0000L000?o0000X@000ol000040003o`0000<000?o000010000ol0000l00003`000ol0
00070003o`0000H000?o0000XP000ol000040003o`0000<000?o000010000ol0000l000040000ol0
00060003o`0000H000?o0000X`000ol000030003o`0000<000?o00000`000ol0000m000040000ol0
00060003o`0000D000?o0000Y0000ol000030003o`0000<000?o00000`000ol0000m000040000ol0
00060003o`0000D000?o0000Y0000ol000030003o`0000<000?o00000`000ol0000m00004@000ol0
00050003o`0000D000?o0000Y@000ol000020003o`0000<000?o00000P000ol0000n00004@000ol0
00050003o`0000@000?o0000YP000ol000020003o`0000<000?o00000P000ol0000n00004P000ol0
00040003o`0000@000?o0000Y`000ol000020005o`000?l010000ol0000o00004P000ol000040003
o`0000<000?o0000Z0000ol000020005o`000?l010000ol0000o00004`000ol000030003o`0000<0
00?o0000Z@001Ol0003o00<000Go0000o`1200004`000ol000030003o`0000<000?o0000Z@001Ol0
003o00<000Go0000o`12000050000ol000020003o`00008000?o0000Z`001?l00?l30004o`00od<0
000D0003o`00008000?o00000P000ol0002[0004o`00o`<000Co003o@`0001@000?o00000P001Ol0
003o0:h000Co003o0`001?l00?m300005@001Ol0003o00<000?o0000[@001_l00?l0o`8000?o0000
@P0001D000Go0000o`030003o`000:d000Ko003o0?l20003o`000480000F0004o`00o`8000?o0000
[`001ol0o`3o0?l0A@0001H000Co003o0P000ol0002_0007o`3o0?l0o`1500005`001Ol0o`3o0;<0
0_l00`3oo`1600005`001Ol0o`3o0;<00_l00`3oo`1600005`001?l0oond00;o00<0ool0AP0001L0
1?nd00CoA`0001H01Onc00GoA`0001H01Onc00GoA`0001H02?n`00Go=`02o`h0000G00?o1003ocP0
0_mb00Go=@03oa00000Q00?o=`000ol0000e0003o`0003H000?o0000=@03oa<0000T00?o=@02ocD0
00?o0000=002ocD00olF00009`03oc@000?o0000<P000ol0000c0003o`0003800olI0000:P03oc80
0_lb0003o`0003400_lb00?o700002d00ola0003o`0002l000?o0000<0000ol0000_00?o7`000300
0ol_00;o;`000ol0000^00;o;`03ob80000c00?o;P000ol0000/0003o`0002d000?o0000;003obD0
000f00?o;002ob`000?o0000:`02ob`00olX0000>@03ob/000?o0000:@000ol0000Z0003o`0002T0
0ol[0000?003obT00_lY0003o`0002P00_lY00?o;P0003l00olX0003o`0002H000?o00009`000ol0
000V00?o<@0004800olV00;o9P000ol0000U00;o9P03oc@0001500?o9@000ol0000S0003o`0002@0
00?o00008`03ocL0001800?o8`02ob<000?o00008P02ob<00olj0000B`03ob8000?o000080000ol0
000Q0003o`0002000olm0000CP03ob000_lP0003o`0001l00_lP00?o@00005400olO0003o`0001d0
00?o00007P000ol0000M00?o@`0005@00olM00;o7@000ol0000L00;o7@03odH0001G00?o70000ol0
000J0003o`0001X00_lL00?oB@0005X00olJ0003o`0001T000?o00006@000ol0000I00?oC00005d0
0olH00;o6@000ol0000G00;o6@03odl0001P00?o5`000ol0000F0003o`0001H000?o00005P03oe80
001S00?o5@02oaH000?o00005002oaH00omE0000IP03oa@000?o00004`000ol0000C0003o`0001<0
0omH0000J@03oa800_lC0003o`0001400_lC00?oF`0006`00olA0003o`00010000?o000040000ol0
000@00?oGP0006l00ol?00;o40000ol0000>00;o4003of40001b00?o3P000ol0000=0003o`0000d0
00?o00003@03of@0001e00?o3002o`d000?o00002`02o`d00omW0000N003o`/000?o00002P000ol0
000:0003o`0000X00omZ0000N`03o`T00_l:0003o`0000P00_l:00?oK@0007h00ol80003o`0000L0
00?o00001`000ol0000700?oL00008400ol600;o1`000ol0000500;o1`03og<0002400?o1@000ol0
00040003o`0000@000?o00001003ogH0002700?o0`02o`@000?o00000P02o`@00omi0000RP03o`80
00Go0000o`030004o`0000?oO00008d01Ol00`3o0002o`040?ooogl0002@00SoPP0009401On40000
T@05oh@0002A00GoQ00009800on50000o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.40724, -0.820004, 0.0162845, 
  0.00485551}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation and Decapsulation", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Encapsulation - Intro"],

Cell[CellGroupData[{

Cell["Introducory encapsulation example", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
theExpr = 
f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2];\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
EncapsulationRules = {};

{encExpr, encPos, encRule} =
exprEncapsulation[theExpr, Templates -> {{{_,_},1}}]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{f[A, g[B, g[4], 3], D, h[E, D, B, g$196[]], 2], {4, 4}, 
 
  g$196[] :> g[g[A, B]]}\
\>", 
"\<\
{f[A, g[B, g[4], 3], D, h[E, D, B, g$196[]], 2], {4, 4}, 
 
  g$196[] :> g[g[A, B]]}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["EncapsulationRules", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{g$196[] :> g[g[A, B]]}\
\>", 
"\<\
{g$196[] :> g[g[A, B]]}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprDecapsulation[encExpr]", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2], {}}\
\>", 
"\<\
{f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2], {}}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Mshowa
P
.004 w
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Mshowa
P
1 g
.04 w
.20018 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Mshowa
P
1 g
.05 w
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Mshowa
P
1 g
.52939 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Mshowa
P
1 g
.57643 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.004 w
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.62346 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388, 239.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000k`P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0Q@000?l0Q@000?l0Q@000?l0Q@000?l0
Q@000?l0Q@000?l0Q@0006P00_l200;oo`0300Go3`0006T000Co003oo`050005o`000?l03P0006T0
1?oo00D000Go0000o`0>0000J@001?l00?oo00D01?l?0000JP02ool01P001Ol0003o00h0001Y00?o
o`0500Go3`0007@00ooa00?o6@0007L00_o]00;o700007T00ooW00?o7P0007`00_oS00;o8@0007h0
0_oO00;o8`0008000ooI00?o9@0008<00_oE00;o:00008D00oo?00?o:P0008P00_o;00;o;@0008X0
0_o700;o;`0008`00oo100?o<@0008l00_nm00;o=00009400ong00?o=P0009@00_nc00;o>@0009H0
0_n_00;o>`0009P00onY00?o?@0009/00_nU00;o@00009d00onO00?o@P000:000_nK00;oA@000:80
0_nG00;oA`000:@00onA00?oB@000:L00_n=00;oC0000:T00on700?oCP000:`00_n300;oD@000:h0
0_mo00;oD`000;000omi00?oE@000;<00_me00;oF0000;D00om_00?oFP000;P00_m[00;oG@000;X0
0_mW00;oG`000;`00omQ00?oH@000;l00_mM00;oI0000<400omG00?oIP000<@00_mC00;oJ@000<H0
0_m?00;oJ`000<P00om900?oK@000</00_m500;oL0000<d00olo00?oLP000=000_lk00;oM@000=80
0_lg00;oM`000=@00ola00?oN@000=L00_l]00;oO0000=T00olW00?oOP000=`00_l>00KF3`02oh40
003N00;o2P0:eP/00_n30000h003o`H03=H700?oQ@000><00_l300kF1002ohP0003U00;o1]H3o`OF
0on:0000i`09eP03omKF00CFS@0005400onB00OF1?l7eX`0001B0003o`0009401]H01OoFe]Ko00OF
S00004l01OnB00KF00Goe]KFo`07eX`0001@0003o`3o09<01]H01OoFe]Ko00OFS000050000?o0?l0
T`07ePGo1]J<0000D@02oi<04]J<0000i`0@eXd0003W013FS@000>P03]J>0000j@0<eXl0001A0003
o`0009H02]J@0000D@000ol0002H00KFTP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000D@000ol0002K0003
o`000980001A0003o`0009/000?o0000TP00054000?o0000V`000ol0002B0000CP06eYP01]JB0000
C00:eY@02]J@0000B`0<eY803=J?0000BP0>eY003]J>0000B@06eP?o1mJ>00KF0ol7eXd0001900WF
00?oe]H01=J>00WF00?oe]H01=J=0000=005o`l01mH4o`OF3`03od/01_l<00Go3@05o`H01mH4o`OF
S00003D000Go0000o`0>00KF00Goe]KFo`07eQ8000?o0000B@000ol0000?0005o`000?l03@001Ol0
003o00D01]H01OoFe]Ko00OFS00003D000Go0000o`0>00KF00Goe]KFo`07eQ8000?o0000B@000ol0
000?0005o`000?l03@001Ol0003o00D01]H01OoFe]Ko00OFS00003D01?l?00KF00Goe]KFo`07eQ00
0_m<00Co3P001Ol0003o00d01?l600KF00Goe]KFo`07eX`0000e0005o`000?l03P07ePGo1]HB0003
o`0004T000?o00003`001Ol0003o00d000Go0000o`0500OF1Ol6eX`0000d00Go3`0BePl00om;00Ko
3005o`d01Ol601;FS00004T04=J>013FS@0004T04=J>013FS@0004X03]J@00kFSP0004/03=JB00cF
S`0004`02]JD00[FT00003/000?o00004006eQ<000?o0000E0000ol0000Z0003omKF00CFTP0003/0
00?o00004`000ol0000C0003o`0005D000?o000030000ol0000;0003o`0000`000?o0000UP0003`0
00?o00004P000ol0000B0003o`0005H000?o000030000ol0000;0003o`0000/000?o0000U`0003`0
00?o00004P000ol0000B0003o`0005L000?o00002`000ol0000;0003o`0000/000?o0000U`0003d0
00?o00004@000ol0000A0003o`0005P000?o00002`000ol0000;0003o`0000X000?o0000V00003d0
00?o00004@000ol0000A0003o`0005T000?o00002P000ol0000;0003o`0000X000?o0000V00003h0
00?o000040000ol0000@0003o`0005X000?o00002P000ol0000;0003o`0000T000?o0000V@0003h0
00?o000040000ol0000@0003o`0005/000?o00002P000ol000090003o`0000X000?o0000V@0003l0
00?o00003`000ol0000?0003o`0005`000?o00002P000ol000090003o`0000T000?o0000VP0003l0
00?o00003`000ol0000?0003o`0005d000?o00002@000ol000090003o`0000T000?o0000VP000400
00?o00003P000ol0000>0003o`0005h000?o00002@000ol000090003o`0000P000?o0000V`000400
00?o00003P000ol0000>0003o`0005l000?o000020000ol000090003o`0000P000?o0000V`000440
00?o00003@000ol0000=0003o`00060000?o000020000ol000090003o`0000L000?o0000W0000440
00?o00003@000ol0000=0003o`00064000?o000020000ol000070003o`0000P000?o0000W0000480
00?o000030000ol0000<0003o`00068000?o000020000ol000070003o`0000L000?o0000W@000480
00?o000030000ol0000<0003o`0006<000?o00001`000ol000070003o`0000L000?o0000W@0004<0
00?o00002`000ol0000;0003o`0006@000?o00001`000ol000070003o`0000H000?o0000WP0004<0
00?o00002`000ol0000;0003o`0006D000?o00001P000ol000070003o`0000H000?o0000WP0004@0
00?o00002P000ol0000:0003o`0006H000?o00001P000ol000070003o`0000D000?o0000W`0004@0
00?o00002P000ol0000:0003o`0006L000?o00001P000ol000050003o`0000H000?o0000W`0004@0
00?o00002P000ol0000:0003o`0006L000?o00001P000ol000050003o`0000H000?o0000W`0004D0
00?o00002@000ol000090003o`0006P000?o00001P000ol000050003o`0000D000?o0000X00004D0
00?o00002@000ol000090003o`0006T000?o00001@000ol000050003o`0000D000?o0000X00004H0
00?o000020000ol000080003o`0006X000?o00001@000ol000050003o`0000@000?o0000X@0004H0
00?o000020000ol000080003o`0006/000?o000010000ol000050003o`0000@000?o0000X@0004L0
00?o00001`000ol000070003o`0006`000?o000010000ol000050003o`0000<000?o0000XP0004L0
00?o00001`000ol000070003o`0006d000?o000010000ol000030003o`0000@000?o0000XP0004P0
00?o00001P000ol000060003o`0006h000?o000010000ol000030003o`0000<000?o0000X`0004P0
00?o00001P000ol000060003o`0006l000?o00000`000ol000030003o`0000<000?o0000X`0004T0
00?o00001@000ol000050003o`00070000?o00000`000ol000030003o`00008000?o0000Y00004T0
00?o00001@000ol000050003o`00074000?o00000P000ol000030003o`00008000?o0000Y00004X0
00?o000010000ol000040003o`00078000?o00000P000ol000030005o`000?l0Y`0004X000?o0000
10000ol000040003o`0007<000?o00000P001Ol0003o00@000?o0000Y@0004/000?o00000`000ol0
00030003o`0007@000?o00000P001Ol0003o00<000?o0000YP0004/000?o00000`000ol000030003
o`0007D000Go0000o`030005o`000?l0Z00004`000?o00000P000ol000020003o`0007H000Go0000
o`030004o`00ojT0001<0003o`00008000?o00000P000ol0001g0004o`00o`<000Co003oZ@0004d0
00Go0000o`030003o`0007P000Co003o0`000ol0o`2Z0000C@000ooFeP04eP030?l007X000?oe]H0
1=H00`3o002Y0000C00:eWX02]JZ0000B`0<eWP03=JY0000BP0>eWH03]JX0000B@06eP?o1mId013F
Y`0004T02MH00ooFeP04eW@04=JW00003002o`800_lf00OF1?l7eSH01Olg00OF0_l00mKoo`06eSL0
1?m[00003@001?l00?lg00KF00Goe]KFo`07eSL000Go0000o`0f00OF00Coe]Ko1mHh0003o`0006/0
000=00Co=`06eP05omKFe_l01mHg0005o`000?l0=P07eP04omKFo`OF>@000ol0001Z00003@001?l0
0?lg00KF00Goe]KFo`07eSL000Go0000o`0f00OF00Coe]Ko1mHj0003o`0006T0000>00;o>007ePGo
1]Hg0005o`000?l0=P07ePCo1mHj0003o`0006T0000=00?o>00BeSH01Olg00OF00?oe]H02=Hg00?o
K00001P00ol^013FM005eP;o2MH_00?oM@0001/00_l/013FM00@eRd00_mh00007@03obX03]H00`3o
001b0003omKF00cF:`03ogX0000P00;o:@0<eP<000?o0000K`000ol0000<eRX00_mm00008P02obP0
2]H50003o`0006d000?o00000P0:eRT00_mo00009003obL01]H80003o`0006/000?o00001@06eRP0
0on100009`02oc@00_ld0003o`0003800_ld00;oQ00002T00olc0003o`00034000?o0000<@000ol0
000a00?oQP0002`00_lb0003o`00030000?o0000<0000ol0000`00;oR@0002h00_la0003o`0002l0
00?o0000;`000ol0000_00;oR`0003000ol_0003o`0002h000?o0000;P000ol0000]00?oS@0003<0
0_l^00;o;P000ol0000/00;o;P02oi00000e00?o;@000ol0000[0003o`0002/000?o0000:`03oi80
000h00;o;0000ol0000Z0003o`0002X000?o0000:P02oiD0000j00;o:`000ol0000Y0003o`0002T0
00?o0000:@02oiL0000l00?o:@000ol0000X0003o`0002P000?o00009`03oiT0000o00;o:002obP0
00?o00009P02obP00_nL0000@@03obL000?o00009@000ol0000U0003o`0002D00onN0000A002obH0
00?o000090000ol0000T0003o`0002@00_nQ0000AP02obD000?o00008`000ol0000S0003o`0002<0
0_nS0000B003ob<000?o00008P000ol0000R0003o`0002400onU0000B`02ob800_lR0003o`000200
0_lR00;oZ00004d00olQ0003o`0001l000?o00007`000ol0000O00?oZP0005000_lP0003o`0001h0
00?o00007P000ol0000N00;o[@0005800_lO0003o`0001d000?o00007@000ol0000M00;o[`0005@0
0olM0003o`0001`000?o000070000ol0000K00?o/@0005L00_lL00;o70000ol0000J00;o7002ok@0
001I00?o6`000ol0000I0003o`0001T000?o00006@03okH0001L00;o6P000ol0000H0003o`0001P0
00?o00006002okT0001N00;o6@000ol0000G0003o`0001L000?o00005`02ok/0001P00?o5`000ol0
000F0003o`0001H000?o00005@03okd0001S00;o5P02oaH000?o00005002oaH00_o00000I@03oaD0
00?o00004`000ol0000C0003o`0001<00oo20000J002oa@000?o00004P000ol0000B0003o`000180
0_o50000JP02oa<000?o00004@000ol0000A0003o`0001400_o70000K003oa4000?o000040000ol0
000@0003o`0000l00oo90000K`02oa000_l@0003o`0000h00_l@00;oc00007400ol?0003o`0000d0
00?o00003@000ol0000=00?ocP0007@00_l>0003o`0000`000?o000030000ol0000<00;od@0007H0
0_l=0003o`0000/000?o00002`000ol0000;00;od`0007P00ol;0003o`0000X000?o00002P000ol0
000900?oe@0007/00_l:00;o2P000ol0000800;o2P02omP0001m00?o2@000ol000070003o`0000L0
00?o00001`03omX0002000;o20000ol000060003o`0000H000?o00001P02omd0002200;o1`000ol0
000200KF1@000ol0000500;og`0008@00ol50003o`3F00WF0P000ol0000300?oh@0008L00_l400cF
00?o00000P02on@0002900?o3]H0103ooooV0000R`0@e^T0002;00KF1?l6e^T0002:00SF00?oe]H0
1mKX0000RP08eP03omKF00OFj00008X02=H00ooFeP07e^P0002:00OF1?l7e^P0002:00SF00?oe]H0
1mKX0000RP08eP?o1mKX0000R`0@e^T0002;013Fj@0008`03]KZ0000S@0<e^/0002>00[Fk0000001
\
\>"],
  ImageRangeCache->{{{0, 387}, {238.375, 0}} -> {-2.23922, -0.833972, 
  0.0151898, 0.00364112}},
  CellTags->"Encapsulation - basic expression"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
TermPlot[theChromos, TreeWidth -> .2, 
                     LabelSize -> 0.02, LabelColor -> 0,
                     TextDisplay -> False
];\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.02 w
.02381 .45617 Mdot
0 g
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.02 w
.19073 .30902 Mdot
0 g
0 w
.25889 .30902 m
.25889 .16187 L
s
.02 w
.25889 .30902 Mdot
1 g
.25889 .16187 Mdot
.32704 .30902 Mdot
0 g
.25889 .45617 Mdot
1 g
.49396 .45617 Mdot
0 g
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.02 w
.66089 .30902 Mdot
.70632 .30902 Mdot
.75175 .30902 Mdot
0 g
0 w
.79719 .30902 m
.79719 .16187 L
s
.02 w
.79719 .30902 Mdot
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.02 w
.61819 .01472 Mdot
.97619 .01472 Mdot
0 g
.79719 .16187 Mdot
.72904 .45617 Mdot
1 g
.96411 .45617 Mdot
0 g
.49396 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^CLg=gIfM[Fe]OCdm?clo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_C/k>gYjN[Vi^OShn000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`3lo
?ginO[fm_Ol0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5Q@<30d92@X61PL30`?88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9R@L71dI6AXF5QLC4a?l0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=S@/;2dY:BXV9RLS8b?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6AT@l?3di>CXf=SLc<c?mEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUA<C4e9B
DY6ATM3@d?mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVALG5eIFEYFEUMCDe?mEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWA/K6eYJFYVIVMSHf?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXAlO7eiNGYfMWMcLg?nZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYB<S8f9RHZ6QXN3Ph?nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZBLW9fIV
IZFUYNCTi?nZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][B/[:fYZJZVYZNSXj?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/Bl_;fi^KZf][Nc/k?ooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]C<c<g9bL[6a/O3`l0000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000;0000?o0000F`000ol000090000/@000ol0001I0003o`0000X0002b0003
o`0005L000?o00002`000;<00_mE00;o3P000;D000?o0000D@000ol0000>0000]P000ol0001?0003
o`0000l0002g0003o`0004d000?o000040000;P00_m;00;o4`000;X000?o0000A`000ol0000C0000
^`000ol000150003o`0001@0002l0003o`0004<000?o00005@000;d000?o0000@@000ol0000F0000
_P02ocl00_lI0000`0000ol0000k0003o`0001T000310003o`0003T000?o00006P000<8000?o0000
=`000ol0000K0000``02ocD00_lN0000a@000ol0000a0003o`0001h000360003o`0002l000?o0000
7`000<L000?o0000;@000ol0000P0000b0000ol0000[0003o`000240003900;o:@02ob@0003;0003
o`0002D000?o000090000<`000?o00008`000ol0000U0000c@000ol0000Q0003o`0002H0003>00;o
7`02obT0003@0003o`0001/000?o0000:@000=4000?o00006@000ol0000Z0000dP000ol0000G0003
o`0002/0003C0003o`0001D000?o0000;0000=@00_lC00;o;`000=H000?o00003`000ol0000_0000
e`000ol0000=0003o`000300003H0003o`0000/000?o0000<@000=T00_l900;o=0000=/000?o0000
1@000ol0000d0000g0000ol000030003o`0003D0003M00Go>0000=d01Olh0000g@05ocP0003M00Go
>0000=h00oli0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000B@000ol0002C0003o`0003P000190003o`0009<000?o0000>00004T000?o0000
T`000ol0000h0000A`03oi@00oli0000AP05oi801Olh0000AP05oi801Olh0000AP05oi801Olh0000
A`03oi@00oli0000=P000ol0000@0003o`0000l000?o0000G0000ol000090003o`0000T000?o0000
2@000ol0000i0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000=`000ol0000?0003o`0000h000?o0000GP000ol000090003o`0000L000?o0000
2@000ol0000j0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>0000ol0000>0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000d000?o0000H0000ol000080003o`0000L000?o0000
20000ol0000k0000>@000ol0000=0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000`000?o0000HP000ol000070003o`0000L000?o0000
1`000ol0000l0000>P000ol0000<0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000/000?o0000I0000ol000070003o`0000D000?o0000
1`000ol0000m0000>`000ol0000;0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000X000?o0000IP000ol000060003o`0000D000?o0000
1P000ol0000n0000?0000ol0000:0003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000T000?o0000J0000ol000050003o`0000D000?o0000
1@000ol0000o0000?@000ol000090003o`0000P000?o0000JP000ol000040003o`0000D000?o0000
10000ol000100000?P000ol000080003o`0000P000?o0000JP000ol000050003o`0000<000?o0000
1@000ol000100000?P000ol000080003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000L000?o0000K0000ol000040003o`0000<000?o0000
10000ol000110000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000?`000ol000070003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000H000?o0000KP000ol000030003o`0000<000?o0000
0`000ol000120000@0000ol000060003o`0000D000?o0000L0000ol000020003o`0000<000?o0000
0P000ol000130000@@000ol000050003o`0000D000?o0000L0000ol000030005o`000?l01@000ol0
00130000@@000ol000050003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000
@P000ol000040003o`0000@000?o0000LP000ol000020005o`000?l010000ol000140000@P000ol0
00040003o`0000<000?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`0000<0
00?o0000M0001Ol0003o00<000Go0000o`170000@`000ol000030003o`00008000?o0000MP001?l0
0?l30004o`00odP000140003o`00008000?o00000P000ol0001f0004o`00o`<000Co003oB00004@0
00?o00000P001Ol0003o07X000Ko003o0?l20003o`0004L000150005o`000?l00`000ol0001h0006
o`00o`3o0P000ol000170000A@001Ol0003o008000?o0000NP001ol0o`3o0?l0BP0004H000Co003o
0P000ol0001j0007o`3o0?l0o`1:0000AP001?l00?l20003o`0007X000Oo0?l0o`3o04X000170005
o`3o0?l0OP02o`030?oo04/000170005o`3o0?l0OP02o`030?oo04/0001700CoP003od`0001600Go
O`05od/000090003o`0003X01Omo00GoB`0000X00oli00KoOP05ocX00ol>00003@03ocL00ol200;o
NP02o`040?ooocP00olA00004003oc/00_lj0003o`0003T00_lk00?o500001<00olj0003o`0003L0
00?o0000>0000ol0000h00?o5`0001H01?lg00;o=`000ol0000f00;o=`04oaX0000J00?o=P000ol0
000d0003o`0003D000?o0000=003oah0000M00?o=002oc@000?o0000<`02oc@00olQ00008003oc<0
00?o0000<@000ol0000a00;o<`03ob@0000S00?o<@02oc4000?o0000<0000ol0000_00Co9`0002H0
1?l_00;o;`000ol0000^00;o;`03ob/0000Z00?o;P000ol0000/0003o`0002`00_l^00?o;P0002d0
0ol/00;o;0000ol0000[0003o`0002/00ola0000<003ob/000?o0000:@000ol0000Y00;o:`03oc@0
000c00?o:@02obT000?o0000:0000ol0000W00Co=`0003H01?lW00;o9`000ol0000V00;o9`03oc/0
000j00?o9P000ol0000T0003o`0002@00_lV00?o?P0003d00olT00;o90000ol0000S0003o`0002<0
0om10000@003ob<000?o00008@000ol0000Q00;o8P04od@0001300?o8@02ob4000?o000080000ol0
000O00?oB00004H01?lO00;o7`000ol0000N00;o7`03od/0001:00?o7P000ol0000L0003o`0001`0
0_lN00?oCP0004d00olL00;o70000ol0000K0003o`0001/00omA0000D003oa/000?o00006@000ol0
000I00;o6P04oe@0001C00?o6@02oaT000?o000060000ol0000G00?oF00005H00olH0003o`0001H0
00?o00005P02oaL00omK0000F@04oaD00_lF0003o`0001@00_lF00?oGP0005d00olD00;o50000ol0
000C0003o`0001801?mQ0000H003oa<000?o00004@000ol0000A00;o4P03ofD0001S00?o4@02oa40
00?o000040000ol0000?00?oJ00006H00ol@0003o`0000h000?o00003P02o`l00om[0000J@04o`d0
0_l>0003o`0000`00_l>00?oKP0006d00ol<00;o30000ol0000;0003o`0000X01?ma0000L003o`/0
00?o00002@000ol0000900;o2P03ogD0001c00?o2@02o`T000?o00001`02o`T00omh0000MP03o`P0
00?o00001P000ol000060003o`0000H00omk0000N@04o`D00_l60003o`0000@00_l500CoOP0007d0
0ol40003o`0000<000?o00000`000ol0000200?oPP0008000ol200;o0`001?l00002o`800on50000
P`03o`060?oo0?l00_l0103ooon80000QP09oh/0002800GoS@0008P01On=0000R005ohd0002900?o
SP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.1095, -0.820004, 0.0151971, 
  0.00485551}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of encapsulated exprressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
encChromos = Join @@ Table[
Encapsulation[theChromos, 
  Templates -> {{{_, _}, 1}},
  SelectionMode -> RANDOM], {10}]

encChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$128[], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g$148[], 3], D, h[E, D, B, g[g[A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g$168[], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g$188[], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g$208[], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g$228[], 3], D, h[E, D, B, g[g[A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g$248[], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$268[], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g$288[]]], 2]]], 
 
  chromo[q[undef], p[f[A, g$308[], D, h[E, D, B, g[g[A, B]]], 2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$128[], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g$148[], 3], D, h[E, D, B, g[g[A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g$168[], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g$188[], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g$208[], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g$228[], 3], D, h[E, D, B, g[g[A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g$248[], 3], D, 
 
     h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$268[], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g$288[]]], 2]]], 
 
  chromo[q[undef], p[f[A, g$308[], D, h[E, D, B, g[g[A, B]]], 2]]]]\
\>"], 
  "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$128[], 2]]]
chromo[q[undef], p[f[A, g[B, g$148[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g$168[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g$188[], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g$208[], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g$228[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g$248[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$268[], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g$288[]]], 2]]]
chromo[q[undef], p[f[A, g$308[], D, h[E, D, B, g[g[A, B]]], 2]]]\
\>", 
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$128[], 2]]]
chromo[q[undef], p[f[A, g[B, g$148[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g$168[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g$188[], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g$208[], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g$228[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g$248[], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$268[], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g$288[]]], 2]]]
chromo[q[undef], p[f[A, g$308[], D, h[E, D, B, g[g[A, B]]], 2]]]\
\>"], 
  "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> True,
            LabelSize -> 0.05, LabelColor -> 1
]& /@ encChromos;\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h$128)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
0 w
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Mshowa
P
0 w
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Mshowa
P
1 g
.2619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Mshowa
P
1 g
.33093 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Mshowa
P
1 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Mshowa
P
1 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h$128)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
1 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@0006L00ooo01L0001X0003o`000?l05P0006D01Ooo01L0001V0003o`3o0?l0
600006H000?o0?l0o`0H0000I`02ool060000?l0P@000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000
I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003
o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000
o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0
001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L0
00?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0
003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l0
5`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000
I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003
o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000
o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0
001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L0
00?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`000?l0P@000?l0P@000?l0P@000?l0
P@0006D00ooo01T0001X0003o`000?l05P0004/01OlE00Co5P03ooh0001<0005o`000?l04`001Ol0
003o01T000?o0000n`0004`000Go0000o`0C0005o`000?l06@000ol0003k0000C004oa@000Go0000
o`0G00;ooP0004`000Go0000o`0D00Go60000ol0003k0000B`05obl00oon0000o`210000o`210000
o`210000o`210000o`210000D@000ol0003o02d0001A0003o`0001<000?o000050000ol0003o0000
DP000ol0000B0003o`0001<000?o0000o`010000DP000ol0000B0003o`0001<000?o0000o`010000
DP000ol0000B0003o`0001<000?o0000o`010000D`000ol0000A0003o`00018000?o0000o`020000
D`000ol0000A0003o`00018000?o0000o`020000D`000ol0000A0003o`00014000?o0000o`030000
E0000ol0000@0003o`00014000?o0000o`030000E0000ol0000@0003o`00014000?o0000o`030000
E0000ol0000@0003o`00010000?o0000o`040000E@000ol0000?0003o`00010000?o0000o`040000
E@000ol0000?0003o`00010000?o0000o`040000E@000ol0000?0003o`0000l000?o0000o`050000
EP000ol0000>0003o`0000l000?o0000o`050000EP000ol0000>0003o`0000l000?o0000o`050000
EP000ol0000>0003o`0000h000?o0000o`060000E`000ol0000=0003o`0000h000?o0000o`060000
E`000ol0000=0003o`0000h000?o0000o`060000E`000ol0000=0003o`0000d000?o0000o`070000
F0000ol0000<0003o`0000d000?o0000o`070000F0000ol0000<0003o`0000`000?o0000o`080000
F0000ol0000<0003o`0000`000?o0000o`080000F@000ol0000;0003o`0000`000?o0000o`080000
F@000ol0000;0003o`0000/000?o0000o`090000F@000ol0000;0003o`0000/000?o0000o`090000
FP000ol0000:0003o`0000/000?o0000o`090000FP000ol0000:0003o`0000X000?o0000o`0:0000
F`000ol000090003o`0000X000?o0000o`0:0000F`000ol000090003o`0000X000?o0000o`0:0000
F`000ol000090003o`0000T000?o0000o`0;0000G0000ol000080003o`0000T000?o0000o`0;0000
G0000ol000080003o`0000T000?o0000o`0;0000G0000ol000080003o`0000P000?o0000o`0<0000
G@000ol000070003o`0000P000?o0000o`0<0000G@000ol000070003o`0000P000?o0000o`0<0000
G@000ol000070003o`0000L000?o0000o`0=0000GP000ol000060003o`0000L000?o0000o`0=0000
GP000ol000060003o`0000H000?o0000o`0>0000GP000ol000060003o`0000H000?o0000o`0>0000
G`000ol000050003o`0000H000?o0000o`0>0000G`000ol000050003o`0000D000?o0000o`0?0000
G`000ol000050003o`0000D000?o0000o`0?0000H0000ol000040003o`0000D000?o0000o`0?0000
H0000ol000040003o`0000@000?o0000o`0@0000H0000ol000040003o`0000@000?o0000o`0@0000
H@000ol000030003o`0000@000?o0000o`0@0000H@000ol000030003o`0000<000?o0000o`0A0000
H@000ol000030003o`0000<000?o0000o`0A0000HP000ol000020003o`0000<000?o0000o`0A0000
HP000ol000020003o`00008000?o0000o`0B0000HP000ol000020003o`00008000?o0000o`0B0000
H`001Ol0003o00<000?o0000o`0C0000H`001Ol0003o00<000?o0000o`0C0000H`001Ol0003o00<0
00?o0000o`0C0000JP000ol0003o01@0003o0840003o0840003o0840003o0840001U00?oo`0I0000
J0000ol0002U0003o`0006d0000<00;o0P02oe<01?mC00GoB002o`040?oo00Co0`03o`801?l300?o
B004o`l0000=0004o`00oe<000Go0000o`1D0005o`000?l0A`001?l00?l20004o`00o`@000?o0000
0P000ol000020005o`000?l0B0000ol0000?00003@04oe<000Go0000o`1D0005o`000?l0A`001?l0
0?l400;o10000ol000030005o`000?l00`000ol000170003o`0000h0000=0004o`00oe<000Go0000
o`1D0005o`000?l0A`001?l00?l200;o1P000ol000040004o`0000?oB`000ol0000=00003P02oeD0
1OmC0005o`000?l0A`04o`8000Co003o10000ol000040004o`00o`<000?o0000B0000ol0000=0000
3@03o`L00_nS00GoB0000ol0000300Co0`02o`<00ol400?o@@000ol0000400?o400001T00_o]00;o
1`000ol0001@00;o6P0001/00_mA0003o`000?400_lL00007@03odl000?o0000W@000ol0001=00?o
7P0002000_m>0003o`0009/000?o0000C002ob40000R00?oC0000ol0002I0003o`0004X00olS0000
9@02od/00_m;0003o`0004T00_m;00;o9P0002L00om:0003o`0004P000?o0000B0000ol0001800?o
:00002X00_m90003o`0004L000?o0000A`000ol0001700;o:`0002`00om70003o`0004H000?o0000
AP000ol0001500?o;@0002l00_m600;oAP000ol0001400;oAP02oc00000a00;oAP000ol000130003
o`0004<000?o0000A002oc80000c00?oA0000ol000120003o`00048000?o0000@P03oc@0000f00;o
@`000ol000110003o`00044000?o0000@@02ocL0000h00?o@@000ol000100003o`00040000?o0000
?`03ocT0000k00;o@002od0000?o0000?P02od000_ll0000?@03ocl000?o0000?@000ol0000m0003
o`0003d00oln0000@002och000?o0000?0000ol0000l0003o`0003`00_m10000@P03oc`000?o0000
>`000ol0000k0003o`0003X00om30000A@02oc/00_lk0003o`0003T00_lk00;oAP0004L00_lk0003
o`0003P000?o0000>0000ol0000i00;oB00004T00oli0003o`0003L000?o0000=`000ol0000g00?o
BP0004`00_lh0003o`0003H000?o0000=P000ol0000f00;oC@0004h00olf0003o`0003D000?o0000
=@000ol0000d00?oC`0005400_le00;o=@000ol0000c00;o=@02oe80001C00?o=0000ol0000b0003
o`00038000?o0000<P03oe@0001F00;o<`000ol0000a0003o`00034000?o0000<@02oeL0001H00?o
<@000ol0000`0003o`00030000?o0000;`03oeT0001K00;o<002oc0000?o0000;P02oc000_mL0000
G@02oc0000?o0000;@000ol0000]0003o`0002h00_mN0000G`03obh000?o0000;0000ol0000/0003
o`0002`00omP0000HP02obd000?o0000:`000ol0000[0003o`0002/00_mS0000I003ob/000?o0000
:P000ol0000Z0003o`0002T00omU0000I`02obX00_lZ0003o`0002P00_lZ00;oJ00006T00olY0003
o`0002L000?o00009`000ol0000W00?oJP0006`00_lX0003o`0002H000?o00009P000ol0000V00;o
K@0006h00olV0003o`0002D000?o00009@000ol0000T00?oK`0007400_lU00;o9@000ol0000S00;o
9@02og80001c00;o9@000ol0000R0003o`00028000?o00008`02og@0001e00?o8`000ol0000Q0003
o`00024000?o00008@03ogH0001h00;o8P000ol0000P0003o`00020000?o00008002ogT0001j00?o
80000ol0000O0003o`0001l000?o00007P03og/0001m00;o7`02oal000?o00007@02oal00_mn0000
O`03oah000?o000070000ol0000L0003o`0001`00on00000PP02oad000?o00006`000ol0000K0003
o`0001/00_n30000Q003oa/000?o00006P000ol0000J0003o`0001T00on50000Q`02oaX00_lJ0003
o`0001P00_lJ00;oR00008T00_lJ0003o`0001L000?o00005`000ol0000H00;oRP0008/00olH0003
o`0001H000?o00005P000ol0000F00?oS00008h00_lG0003o`0001D000?o00005@000ol0000E00;o
S`0009000olE0003o`0001@000?o000050000ol0000C00?oT@0009<00_lD00;o50000ol0000B00;o
5002oi@0002E00?o4`000ol0000A0003o`00014000?o00004@03oiH0002H00;o4P000ol0000@0003
o`00010000?o00004002oiT0002J00?o40000ol0000?0003o`0000l000?o00003P03oi/0002M00;o
3`02o`l000?o00003@02o`l00_nN0000W`02o`l000?o000030000ol0000<0003o`0000d00_nP0000
X@03o`d000?o00002`000ol0000;0003o`0000/00onR0000Y002o``000?o00002P000ol0000:0003
o`0000X00_nU0000YP03o`X000?o00002@000ol000090003o`0000P00onW0000Z@02o`T00_l90003
o`0000L00_l900;oZP000:/00ol80003o`0000H000?o00001P000ol0000600?o[0000:h00_l70003
o`0000d000?o00001@02ojl0002`00?o1@000ol0000;0003o`0000<00ona0000/`02oa0000?o0000
0P02ok@0002e00;o4@02okH000370003o`000;H0002m00Co_`000;h000?o0000_`000;h000?o0000
_`000;h000?o0000_`000;d01?no0000_P000ol0002o0000_P03okl0003o0840003o0840003o0840
003o0840003o08400000\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17756, -0.625483, 
  0.0113711, 0.00275981}},
  CellTags->"Encapsulation - mutant 1"]
}, Open  ]],

Cell[TextData[{
  "Selective encapsulation 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$148)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
1 g
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$148)] .25889 .30902 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@000>P00_l200;oOP05o`l0003Y0004o`00oh0000Go0000o`0>0000j@04oh00
00Go0000o`0>0000j@001?l00?n000Co3`000>X00_n10005o`000?l03P000>T00on000Go3`000?l0
P@000?l0P@000?<000?o0000L@000ol0000F0000m0000ol0001_0003o`0001L0003e0003o`0006d0
00?o000060000?H00_m[00;o6`000?P000?o0000I`000ol0000K0000n@000ol0001U0003o`0001`0
003j0003o`0006<000?o00007@000?/00_mQ00;o80000?d000?o0000G@000ol0000P0000oP000ol0
001K0003o`000240003o0003o`0005T000?o00008P000?l00@000ol0001G0003o`0002<0003o0080
0_mE00;o9P000?l010000ol0001A0003o`0002H0003o00D000?o0000C`000ol0000W0000o`060003
o`0004d000?o0000:0000?l01`02od/00_l[0000o`090003o`0004L000?o0000:`000?l02P000ol0
00150003o`0002`0003o00/000?o0000@`000ol0000]0000o`0<0003o`00044000?o0000;P000?l0
3@02ocl00_la0000o`0?0003o`0003/000?o0000<@000?l040000ol0000i0003o`000380003o0140
00?o0000=`000ol0000c0000o`0B00;o=@02ocH0003o01@000?o0000<@000ol0000f0000o`0E0003
o`0002l000?o0000=`000?l05P000ol0000]0003o`0003P0003o01L000?o0000:`000ol0000i0000
o`0H00;o:@02oc`0003o01X000?o00009@000ol0000l0000o`0K0003o`0002<000?o0000?@000?l0
70000ol0000Q0003o`0003h0003o01d00_lO00;o@@000?l07`000ol0000K0003o`000440003o0200
00?o00006@000ol000120000o`0Q0003o`0001L000?o0000@`000?l08P000ol0000E0003o`0004@0
003o02<00_lC00;oA`000?l09@000ol0000?0003o`0004L0003o02H000?o00003@000ol000180000
o`0W0003o`0000/000?o0000B@000?l0P@000?l0;003oe80003o02l000?o0000C`000?l0;004oe40
003o02/000Go0000o`1A0000o`0[0005o`000?l0D@000?l0:`001Ol0003o0540003o02`01Om@0000
o`210000o`210000o`210000o`210000o`210000o`210000o`210000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500
003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0
;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003
o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000
D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000
o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`210000o`210000o`210000o`210000o`210000F003om000omB0000F`001Ol0003o0<h0
00?o0000C`0004X01Ol900Co0P04o`<00ol400?o0P03o`T00omg00Ko2`05o``01Ol=00CoD@0004/0
00Go0000o`070005o`000?l00P001?l00?l40003o`0000@000Co003o0`000ol000090003o`0007D0
00?o00003P001Ol0003o00`000Go0000o`0;0005o`000?l0D@0004/000Go0000o`070005o`000?l0
1002o`@000Co00001Ol00`3o00020003o`0000T000?o0000M@000ol0000>0005o`000?l030001Ol0
003o00/000Go0000o`1A0000B`04o`P000Go0000o`0200;o1P000ol000020003o`3o00<00ol:00;o
N004o`d000Go0000o`0<00Co30001Ol0003o0540001;0005o`000?l02005o`050?l00?l010000ol0
00020003o`3o008000Go0000o`0;0003o`0007D000?o00003P001Ol0003o00`000Go0000o`0<00Go
D00004X01Ol?00Co0`02o`D00_l300?o2@03ogL01_l;00Go3005of80001P0003o`000?l07P000?l0
P@000?l0P@000?l0P@00050000?o0000Z`000ol0001o0000D@000ol0000B0003o`00018000?o0000
P0000ol0000;0003o`0000`000?o00002`000ol0001D0000D@000ol0000B0003o`00018000?o0000
P@000ol0000;0003o`0000/000?o00002`000ol0001D0000DP000ol0000A0003o`00014000?o0000
PP000ol0000;0003o`0000X000?o00002`000ol0001E0000DP000ol0000A0003o`00014000?o0000
P`000ol0000:0003o`0000X000?o00002`000ol0001E0000D`000ol0000@0003o`00010000?o0000
Q0000ol0000:0003o`0000X000?o00002P000ol0001F0000D`000ol0000@0003o`00010000?o0000
Q@000ol000090003o`0000X000?o00002P000ol0001F0000E0000ol0000?0003o`0000l000?o0000
QP000ol000090003o`0000X000?o00002@000ol0001G0000E0000ol0000?0003o`0000l000?o0000
QP000ol0000:0003o`0000T000?o00002@000ol0001G0000E@000ol0000>0003o`0000h000?o0000
R0000ol000090003o`0000T000?o000020000ol0001H0000E@000ol0000>0003o`0000h000?o0000
R0000ol000090003o`0000P000?o00002@000ol0001H0000EP000ol0000=0003o`0000d000?o0000
RP000ol000080003o`0000P000?o000020000ol0001I0000EP000ol0000=0003o`0000d000?o0000
RP000ol000080003o`0000P000?o000020000ol0001I0000EP000ol0000=0003o`0000d000?o0000
R`000ol000070003o`0000P000?o000020000ol0001I0000E`000ol0000<0003o`0000`000?o0000
S0000ol000080003o`0000L000?o00001`000ol0001J0000E`000ol0000<0003o`0000`000?o0000
S@000ol000070003o`0000L000?o00001`000ol0001J0000F0000ol0000;0003o`0000/000?o0000
SP000ol000070003o`0000L000?o00001P000ol0001K0000F0000ol0000;0003o`0000/000?o0000
S`000ol000060003o`0000H000?o00001`000ol0001K0000F@000ol0000:0003o`0000X000?o0000
T0000ol000060003o`0000H000?o00001P000ol0001L0000F@000ol0000:0003o`0000X000?o0000
T@000ol000050003o`0000H000?o00001P000ol0001L0000FP000ol000090003o`0000T000?o0000
TP000ol000060003o`0000D000?o00001@000ol0001M0000FP000ol000090003o`0000T000?o0000
T`000ol000050003o`0000D000?o00001@000ol0001M0000F`000ol000080003o`0000P000?o0000
U0000ol000050003o`0000D000?o000010000ol0001N0000F`000ol000080003o`0000P000?o0000
U@000ol000040003o`0000@000?o00001@000ol0001N0000G0000ol000070003o`0000L000?o0000
UP000ol000040003o`0000@000?o000010000ol0001O0000G0000ol000070003o`0000L000?o0000
U`000ol000030003o`0000@000?o000010000ol0001O0000G@000ol000060003o`0000H000?o0000
V0000ol000040003o`0000<000?o00000`000ol0001P0000G@000ol000060003o`0000H000?o0000
V@000ol000030003o`0000<000?o00000`000ol0001P0000G@000ol000060003o`0000H000?o0000
V@000ol000030003o`0000<000?o00000`000ol0001P0000GP000ol000050003o`0000D000?o0000
V`000ol000020003o`0000<000?o00000P000ol0001Q0000GP000ol000050003o`0000D000?o0000
V`000ol000020003o`00008000?o00000`000ol0001Q0000G`000ol000040003o`0000@000?o0000
W@001Ol0003o00@000?o00000P000ol0001R0000G`000ol000040003o`0000@000?o0000W@000ol0
00020005o`000?l010000ol0001R0000H0000ol000030003o`0000<000?o0000W`001Ol0003o00<0
00Go0000o`1U0000H0000ol000030003o`0000<000?o0000W`001Ol0003o00<000Go0000o`1U0000
H@000ol000020003o`00008000?o0000X0001Ol0003o00<000Co003oIP00064000?o00000P000ol0
00020003o`000:4000Co003o0`001?l00?mV0000HP001Ol0003o00<000?o0000XP001?l00?l20004
o`00ofL0001R0003o`0000D000?o0000X`000ol000050003o`0006D0003o0840003o0840003o0840
001T00?oo`0J0000I`000ol0003o01L0000<00;o0P02oe801?mB00GoD`02o`030?oo05401?lD0000
3@001?l00?mB0005o`000?l0D`001Ol0003o058000Co003oD`000ol0000D00003@04oe8000Go0000
o`1C0005o`000?l0DP001?l00?mD0003o`0001<0000=0004o`00oe8000Go0000o`1C0005o`000?l0
DP001?l00?mE0003o`000180000>00;oE005oe8000Go0000o`1B00CoE@000ol0000B00003@03o`P0
0onO00GoD`000ol0001:00?o1P03oaD0000K00ColP02odT00olQ00007`03od`00_nK0003o`0004X0
1?lT00008P03od/000?o0000U`000ol0001800?o:00002D00om900;oU@02odP00ol[0000:003odP0
0_nA00;oA`03obh0000[00CoAP000ol0002=0003o`0004@00ola0000;`03od@00_m50003o`0004<0
0_m300Co=00003800om300;o@`000ol0001100;o@P03ocP0000e00?o@P000ol000100003o`000400
00?o0000?`03oc/0000h00Co?`02od0000?o0000?P02ocl00oln0000?003och000?o0000?@000ol0
000m0003o`0003`00om10000?`03oc`00_lm0003o`0003/00_lk00CoA00004800olk00;o>`000ol0
000i00;o>P03odP0001500?o>P000ol0000h0003o`0003P000?o0000=`03od/0001800Co=`02ocP0
00?o0000=P02ocL00om>0000C003ocH000?o0000=@000ol0000e0003o`0003@00omA0000C`03oc@0
0_le0003o`0003<00_lc00CoE00005800olc00;o<`000ol0000a00;o<P03oeP0001E00Co<@000ol0
000`0003o`00030000?o0000;`03oe/0001I00?o;`02oc0000?o0000;P02obl00omN0000G003obh0
00?o0000;@000ol0000]0003o`0002`00omQ0000G`03ob`00_l]0003o`0002/00_l[00CoI0000680
0ol[00;o:`000ol0000Y00;o:P03ofP0001U00Co:@000ol0000X0003o`0002P000?o00009`03of/0
001Y00?o9`02obP000?o00009P02obL00om^0000K003obH00_lV0003o`0002@00_lU00CoL@0006l0
0olU0003o`0002<000?o00008`000ol0000R00?oM@0007801?lR00;o8`000ol0000Q00;o8P03ogP0
001f00?o8@000ol0000P0003o`00020000?o00007`03og/0001i00?o7`02ob0000?o00007P02oal0
0omn0000O003oah00_lN0003o`0001`00_lM00CoP@0007l00olM0003o`0001/000?o00006`000ol0
000J00?oQ@0008801?lJ00;o6`000ol0000I00;o6P03ohP0002600?o6@000ol0000H0003o`0001P0
00?o00005`03oh/0002900?o5`02oaP000?o00005P02oaL00on>0000S003oaH00_lF0003o`0001@0
0_lE00CoT@0008l01?lD0003o`0001<000?o00004`000ol0000B00?oU@0009<00olB00;o4`000ol0
000A00;o4P03oiP0002F00?o4@000ol0000@0003o`00010000?o00003`03oi/0002I00?o3`02oa00
00?o00003P02o`l00onN0000W003o`h00_l>0003o`0000`00_l=00CoX@0009l01?l<0003o`0000/0
00?o00002`000ol0000:00?oY@000:<00ol:00;o2`000ol0000900;o2P03ojP0002V00?o2@02oa<0
0_l900?oZ`000:T00ol80003o`0000l000?o00001P03ojh0002/00Co1@02o`d00_l500Co/@000;00
0olE00?o]@000;<00_l@00?o^0000;/01?o10000_0000ol000310000_0000ol000310000_0000ol0
00310000^`04ol40002l0003o`000<40002l00?o`@000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000001\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17984, -0.833976, 
  0.0115171, 0.00367975}},
  CellTags->"Encapsulation - mutant 2"],

Cell[TextData[{
  "Selective encapsulation 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$168)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
1 g
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$168)] .25889 .30902 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@000>P00_l200;oOP05o`l0003Y0004o`00oh0000Go0000o`0>0000j@04oh00
00Go0000o`0>0000j@001?l00?n000Co3`000>X00_n10005o`000?l03P000>T00on000Go3`000?l0
P@000?l0P@000?<000?o0000L@000ol0000F0000m0000ol0001_0003o`0001L0003e0003o`0006d0
00?o000060000?H00_m[00;o6`000?P000?o0000I`000ol0000K0000n@000ol0001U0003o`0001`0
003j0003o`0006<000?o00007@000?/00_mQ00;o80000?d000?o0000G@000ol0000P0000oP000ol0
001K0003o`000240003o0003o`0005T000?o00008P000?l00@000ol0001G0003o`0002<0003o0080
0_mE00;o9P000?l010000ol0001A0003o`0002H0003o00D000?o0000C`000ol0000W0000o`060003
o`0004d000?o0000:0000?l01`02od/00_l[0000o`090003o`0004L000?o0000:`000?l02P000ol0
00150003o`0002`0003o00/000?o0000@`000ol0000]0000o`0<0003o`00044000?o0000;P000?l0
3@02ocl00_la0000o`0?0003o`0003/000?o0000<@000?l040000ol0000i0003o`000380003o0140
00?o0000=`000ol0000c0000o`0B00;o=@02ocH0003o01@000?o0000<@000ol0000f0000o`0E0003
o`0002l000?o0000=`000?l05P000ol0000]0003o`0003P0003o01L000?o0000:`000ol0000i0000
o`0H00;o:@02oc`0003o01X000?o00009@000ol0000l0000o`0K0003o`0002<000?o0000?@000?l0
70000ol0000Q0003o`0003h0003o01d00_lO00;o@@000?l07`000ol0000K0003o`000440003o0200
00?o00006@000ol000120000o`0Q0003o`0001L000?o0000@`000?l08P000ol0000E0003o`0004@0
003o02<00_lC00;oA`000?l09@000ol0000?0003o`0004L0003o02H000?o00003@000ol000180000
o`0W0003o`0000/000?o0000B@000?l0P@000?l0;003oe80003o02l000?o0000C`000?l0;004oe40
003o02/000Go0000o`1A0000o`0[0005o`000?l0D@000?l0:`001Ol0003o0540003o02`01Om@0000
o`210000o`210000o`210000o`210000o`210000o`210000o`210000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500
003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0
;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003
o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000
D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000
o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`210000o`210000o`210000o`210000o`210000F003om000omB0000F`001Ol0003o0<h0
00?o0000C`0004X01Ol900Co0P04o`<00ol300;o1003o`T00omg00Ko2`05o``01Ol=00CoD@0004/0
00Go0000o`070005o`000?l00P001?l00?l40005o`000?l00P001?l00?l30003o`0000T000?o0000
M@000ol0000>0005o`000?l030001Ol0003o00/000Go0000o`1A0000B`001Ol0003o00L000Go0000
o`0400;o10001Ol0003o008000Co003o0`000ol000090003o`0007D000?o00003P001Ol0003o00`0
00Go0000o`0;0005o`000?l0D@0004/01?l80005o`000?l00P02o`H000Co00000ol400?o2P02ogP0
1?l=0005o`000?l03004o``000Go0000o`1A0000B`001Ol0003o00P01Ol01@3o003o00@000Go0000
o`050005o`000?l02`000ol0001e0003o`0000h000Go0000o`0<0005o`000?l03005oe00001:00Go
3`04o`<00_l400?o0`03o`T00omg00Ko2`05o``01OmR0000H0000ol0003o01h0003o0840003o0840
003o0840001@0003o`000:/000?o0000O`00054000?o00004P000ol0000B0003o`00080000?o0000
2`000ol0000<0003o`0000/000?o0000E000054000?o00004P000ol0000B0003o`00084000?o0000
2`000ol0000;0003o`0000/000?o0000E000058000?o00004@000ol0000A0003o`00088000?o0000
2`000ol0000:0003o`0000/000?o0000E@00058000?o00004@000ol0000A0003o`0008<000?o0000
2P000ol0000:0003o`0000/000?o0000E@0005<000?o000040000ol0000@0003o`0008@000?o0000
2P000ol0000:0003o`0000X000?o0000EP0005<000?o000040000ol0000@0003o`0008D000?o0000
2@000ol0000:0003o`0000X000?o0000EP0005@000?o00003`000ol0000?0003o`0008H000?o0000
2@000ol0000:0003o`0000T000?o0000E`0005@000?o00003`000ol0000?0003o`0008H000?o0000
2P000ol000090003o`0000T000?o0000E`0005D000?o00003P000ol0000>0003o`0008P000?o0000
2@000ol000090003o`0000P000?o0000F00005D000?o00003P000ol0000>0003o`0008P000?o0000
2@000ol000080003o`0000T000?o0000F00005H000?o00003@000ol0000=0003o`0008X000?o0000
20000ol000080003o`0000P000?o0000F@0005H000?o00003@000ol0000=0003o`0008X000?o0000
20000ol000080003o`0000P000?o0000F@0005H000?o00003@000ol0000=0003o`0008/000?o0000
1`000ol000080003o`0000P000?o0000F@0005L000?o000030000ol0000<0003o`0008`000?o0000
20000ol000070003o`0000L000?o0000FP0005L000?o000030000ol0000<0003o`0008d000?o0000
1`000ol000070003o`0000L000?o0000FP0005P000?o00002`000ol0000;0003o`0008h000?o0000
1`000ol000070003o`0000H000?o0000F`0005P000?o00002`000ol0000;0003o`0008l000?o0000
1P000ol000060003o`0000L000?o0000F`0005T000?o00002P000ol0000:0003o`00090000?o0000
1P000ol000060003o`0000H000?o0000G00005T000?o00002P000ol0000:0003o`00094000?o0000
1@000ol000060003o`0000H000?o0000G00005X000?o00002@000ol000090003o`00098000?o0000
1P000ol000050003o`0000D000?o0000G@0005X000?o00002@000ol000090003o`0009<000?o0000
1@000ol000050003o`0000D000?o0000G@0005/000?o000020000ol000080003o`0009@000?o0000
1@000ol000050003o`0000@000?o0000GP0005/000?o000020000ol000080003o`0009D000?o0000
10000ol000040003o`0000D000?o0000GP0005`000?o00001`000ol000070003o`0009H000?o0000
10000ol000040003o`0000@000?o0000G`0005`000?o00001`000ol000070003o`0009L000?o0000
0`000ol000040003o`0000@000?o0000G`0005d000?o00001P000ol000060003o`0009P000?o0000
10000ol000030003o`0000<000?o0000H00005d000?o00001P000ol000060003o`0009T000?o0000
0`000ol000030003o`0000<000?o0000H00005d000?o00001P000ol000060003o`0009T000?o0000
0`000ol000030003o`0000<000?o0000H00005h000?o00001@000ol000050003o`0009/000?o0000
0P000ol000030003o`00008000?o0000H@0005h000?o00001@000ol000050003o`0009/000?o0000
0P000ol000020003o`0000<000?o0000H@0005l000?o000010000ol000040003o`0009d000Go0000
o`040003o`00008000?o0000HP0005l000?o000010000ol000040003o`0009d000?o00000P001Ol0
003o00@000?o0000HP00060000?o00000`000ol000030003o`0009l000Go0000o`030005o`000?l0
I@00060000?o00000`000ol000030003o`0009l000Go0000o`030005o`000?l0I@00064000?o0000
0P000ol000020003o`000:0000Go0000o`030004o`00ofH0001Q0003o`00008000?o00000P000ol0
002Q0004o`00o`<000Co003oIP00068000Go0000o`030003o`000:8000Co003o0P001?l00?mW0000
HP000ol000050003o`000:<000?o00001@000ol0001U0000o`210000o`210000o`210000I003ool0
6P0006L000?o0000o`0G00003002o`800_mB00CoDP05oe<00_l00`3oo`1A00Co500000d000Co003o
DP001Ol0003o05<000Go0000o`1B0004o`00oe<000?o0000500000d01?mB0005o`000?l0D`001Ol0
003o058000Co003oE0000ol0000C00003@001?l00?mB0005o`000?l0D`001Ol0003o058000Co003o
E@000ol0000B00003P02oe@01OmB0005o`000?l0DP04oeD000?o00004P0000d00ol800?oW`05oe<0
00?o0000BP03o`H00olE00006`04oo800_m900?o8@0001l00om<00;oV`000ol0001:00Co90000280
0om;0003o`0009L000?o0000B003obP0000U00?oB@02oiD00_m800?o:`0002P00om800;oT@02odL0
0ol^0000:`04odH000?o0000S@000ol0001400?o<@0002l00om400;oA@000ol0001300;o@`04oc@0
000b00?o@`02od<000?o0000@@02od800olh0000=@03od8000?o0000@0000ol000100003o`0003l0
0olk0000>004ocl00_m00003o`0003h00_lo00?o?P0003`00oln0003o`0003d000?o0000?@000ol0
000l00?o@@0003l00oll00;o?@000ol0000k00;o>`04od@0001200?o>`02oc/000?o0000>@02ocX0
0om80000A@03ocX000?o0000>0000ol0000h0003o`0003L00om;0000B004ocL00_lh0003o`0003H0
0_lg00?oCP0004`00olf0003o`0003D000?o0000=@000ol0000d00?oD@0004l00old00;o=@000ol0
000c00;o<`04oe@0001B00?o<`02oc<000?o0000<@02oc800omH0000E@04oc4000?o0000<0000ol0
000`0003o`0002l00omK0000F@03obl00_l`0003o`0002h00_l_00?oGP0005`00ol^0003o`0002d0
00?o0000;@000ol0000/00?oH@0005l00ol/00;o;@000ol0000[00;o:`04of@0001R00?o:`02ob/0
00?o0000:@02obX00omX0000I@04obT000?o0000:0000ol0000X0003o`0002L00om[0000J@03obL0
0_lX0003o`0002H00_lW00?oKP0006`00olV00;o9P000ol0000T00;o9@04og40001_00?o9@000ol0
000S0003o`0002<000?o00008P03ogD0001b00Co8P02ob<000?o00008@02ob800omh0000MP03ob40
00?o000080000ol0000P0003o`0001l00omk0000N@03oal00_lP0003o`0001h00_lO00?oOP0007`0
0olN00;o7P000ol0000L00;o7@04oh40001o00?o7@000ol0000K0003o`0001/000?o00006P03ohD0
002200Co6P02oa/000?o00006@02oaX00on80000QP03oaT000?o000060000ol0000H0003o`0001L0
0on;0000R@03oaL00_lH0003o`0001H00_lG00?oSP0008`00olF00;o5P000ol0000D00;o5@04oi40
002?00Co50000ol0000C0003o`0001<000?o00004P03oiD0002C00?o4P02oa<000?o00004@02oa80
0onH0000UP03oa4000?o000040000ol0000@0003o`0000l00onK0000V@03o`l00_l@0003o`0000h0
0_l?00?oWP0009`00ol>00;o3P000ol0000<00;o3@04oj40002O00Co30000ol0000;0003o`0000/0
00?o00002P03ojD0002S00?o2P02o`/000?o00002@02o`X00onX0000YP03o`T00_lC00;o2@03oj/0
002Y00?o20000ol0000?0003o`0000H00on^0000[004o`D00_l=00;o1@04ok40002`00?o5@03okD0
002c00;o4003okP0002k00Co`@000;`000?o0000`@000;`000?o0000`@000;`000?o0000`@000;/0
1?o10000_0000ol000310000_003ol40003o0840003o0840003o0840003o0840003o08400000\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17984, -0.833976, 
  0.0115171, 0.00367975}},
  CellTags->"Encapsulation - mutant 3"],

Cell[TextData[{
  "Selective encapsulation 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$188)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$188)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@000>P00_l200;oOP05o`l0003Y0004o`00oh0000Go0000o`0>0000j@04oh00
00Go0000o`0>0000j@001?l00?n000Co3`000>X00_n10005o`000?l03P000>T00on000Go3`000?l0
P@000?l0P@000?<000?o0000L@000ol0000F0000m0000ol0001_0003o`0001L0003e0003o`0006d0
00?o000060000?H00_m[00;o6`000?P000?o0000I`000ol0000K0000n@000ol0001U0003o`0001`0
003j0003o`0006<000?o00007@000?/00_mQ00;o80000?d000?o0000G@000ol0000P0000oP000ol0
001K0003o`000240003o0003o`0005T000?o00008P000?l00@000ol0001G0003o`0002<0003o0080
0_mE00;o9P000?l010000ol0001A0003o`0002H0003o00D000?o0000C`000ol0000W0000o`060003
o`0004d000?o0000:0000?l01`02od/00_l[0000o`090003o`0004L000?o0000:`000?l02P000ol0
00150003o`0002`0003o00/000?o0000@`000ol0000]0000o`0<0003o`00044000?o0000;P000?l0
3@02ocl00_la0000o`0?0003o`0003/000?o0000<@000?l040000ol0000i0003o`000380003o0140
00?o0000=`000ol0000c0000o`0B00;o=@02ocH0003o01@000?o0000<@000ol0000f0000o`0E0003
o`0002l000?o0000=`000?l05P000ol0000]0003o`0003P0003o01L000?o0000:`000ol0000i0000
o`0H00;o:@02oc`0003o01X000?o00009@000ol0000l0000o`0K0003o`0002<000?o0000?@000?l0
70000ol0000Q0003o`0003h0003o01d00_lO00;o@@000?l07`000ol0000K0003o`000440003o0200
00?o00006@000ol000120000o`0Q0003o`0001L000?o0000@`000?l08P000ol0000E0003o`0004@0
003o02<00_lC00;oA`000?l09@000ol0000?0003o`0004L0003o02H000?o00003@000ol000180000
o`0W0003o`0000/000?o0000B@000?l0P@000?l0;003oe80003o02l000?o0000C`000?l0;004oe40
003o02/000Go0000o`1A0000o`0[0005o`000?l0D@000?l0:`001Ol0003o0540003o02`01Om@0000
o`210000o`210000o`210000o`210000o`210000o`210000o`210000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500
003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0
;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003
o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000
D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000
o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`210000o`210000o`210000o`210000o`210000o`0/00?oDP000?l0;`000ol0001?0000
m`06o`/01Ol<00Go3@04oe40003h0003o`0000h000Go0000o`0<0005o`000?l02`001Ol0003o0540
003h0003o`0000h000Go0000o`0<0005o`000?l02`001Ol0003o0540003h00Co3@001Ol0003o00`0
1?l<0005o`000?l0D@000?P000?o00003P001Ol0003o00`000Go0000o`0<00GoD0000?L01_l;00Go
3005of80003o0840003o0840003o0840003o0840003n0003o`0007l0003n0003o`0000/000?o0000
30000ol0000;0003o`0005@0003o0003o`0000/000?o00002`000ol0000;0003o`0005@0003o0003
o`0000/000?o00002P000ol0000;0003o`0005D0003o004000?o00002P000ol0000:0003o`0000/0
00?o0000E@000?l00@000ol0000:0003o`0000X000?o00002P000ol0001F0000o`020003o`0000T0
00?o00002P000ol0000:0003o`0005H0003o008000?o00002@000ol0000:0003o`0000T000?o0000
E`000?l00P000ol0000:0003o`0000T000?o00002@000ol0001G0000o`030003o`0000T000?o0000
2@000ol000080003o`0005P0003o00<000?o00002@000ol000080003o`0000T000?o0000F0000?l0
10000ol000080003o`0000P000?o000020000ol0001I0000o`040003o`0000P000?o000020000ol0
00080003o`0005T0003o00D000?o00001`000ol000080003o`0000P000?o0000F@000?l01@000ol0
00080003o`0000L000?o00001`000ol0001J0000o`060003o`0000L000?o00001`000ol000070003
o`0005X0003o00H000?o00001`000ol000070003o`0000H000?o0000F`000?l01`000ol000060003
o`0000H000?o00001`000ol0001K0000o`070003o`0000H000?o00001P000ol000060003o`0005`0
003o00P000?o00001@000ol000060003o`0000H000?o0000G0000?l020000ol000060003o`0000D0
00?o00001@000ol0001M0000o`090003o`0000D000?o00001@000ol000050003o`0005d0003o00T0
00?o00001@000ol000050003o`0000@000?o0000GP000?l02P000ol000040003o`0000@000?o0000
1@000ol0001N0000o`0:0003o`0000@000?o000010000ol000040003o`0005l0003o00/000?o0000
0`000ol000040003o`0000@000?o0000G`000?l02`000ol000040003o`0000<000?o00000`000ol0
001P0000o`0<0003o`0000<000?o00000`000ol000030003o`000600003o00`000?o00000`000ol0
00030003o`0000<000?o0000H0000?l03@000ol000020003o`0000<000?o00000P000ol0001Q0000
o`0=0003o`00008000?o00000P000ol000030003o`000640003o00h000Go0000o`040003o`000080
00?o0000HP000?l03P000ol000020005o`000?l010000ol0001R0000o`0?0005o`000?l00`001Ol0
003o06D0003o00l000Go0000o`030005o`000?l0I@000?l03`001Ol0003o00<000Co003oIP000?l0
40001?l00?l30004o`00ofH0003o010000Co003o0P001?l00?mW0000o`0A0003o`0000D000?o0000
I@000?l0P@000?l0P@000?l0P@0005P00ooo02H0001K0005o`000?l0o`0Q00003002o`800_m600Co
0P04o`<00ol300?o0`03odH01OmC00;o00<0ool0D@04oa@0000=0004o`00odH000Go0000o`020004
o`00o`@000Go0000o`030003o`3o00<000?o0000A0001Ol0003o058000Co003oD`000ol0000D0000
3@04odH000Go0000o`0400;o10001Ol0003o00<000?o0?l00`000ol000140005o`000?l0DP001?l0
0?mD0003o`0001<0000=0004o`00odH000Go0000o`0200;o1P000ol0000200?o0`03odL000Go0000
o`1B0004o`00oeD000?o00004P0000h00_m800Go00D0o`00o`040005o`000?l00`000ol0o`030003
o`0004@000Go0000o`1B00CoE@000ol0000B00003@03o`P00om300Co0`02o`@00ol300?oAP05oe<0
00?o0000BP03o`H00olE00006`04od4000?o0000[P02odT00olQ00007`03od`00_nK0003o`0004X0
1?lT00008P03od/000?o0000U`000ol0001800?o:00002D00om900;oU@02odP00ol[0000:003odP0
0_nA00;oA`03obh0000[00CoAP000ol0002=0003o`0004@00ola0000;`03od@00_m50003o`0004<0
0_m300Co=00003800om300;o@`000ol0001100;o@P03ocP0000e00?o@P000ol000100003o`000400
00?o0000?`03oc/0000h00Co?`02od0000?o0000?P02ocl00oln0000?003och000?o0000?@000ol0
000m0003o`0003`00om10000?`03oc`00_lm0003o`0003/00_lk00CoA00004800olk00;o>`000ol0
000i00;o>P03odP0001500?o>P000ol0000h0003o`0003P000?o0000=`03od/0001800Co=`02ocP0
00?o0000=P02ocL00om>0000C003ocH000?o0000=@000ol0000e0003o`0003@00omA0000C`03oc@0
0_le0003o`0003<00_lc00CoE00005800olc00;o<`000ol0000a00;o<P03oeP0001E00Co<@000ol0
000`0003o`00030000?o0000;`03oe/0001I00?o;`02oc0000?o0000;P02obl00omN0000G003obh0
00?o0000;@000ol0000]0003o`0002`00omQ0000G`03ob`00_l]0003o`0002/00_l[00CoI0000680
0ol[00;o:`000ol0000Y00;o:P03ofP0001U00Co:@000ol0000X0003o`0002P000?o00009`03of/0
001Y00?o9`02obP000?o00009P02obL00om^0000K003obH00_lV0003o`0002@00_lU00CoL@0006l0
0olU0003o`0002<000?o00008`000ol0000R00?oM@0007801?lR00;o8`000ol0000Q00;o8P03ogP0
001f00?o8@000ol0000P0003o`00020000?o00007`03og/0001i00?o7`02ob0000?o00007P02oal0
0omn0000O003oah00_lN0003o`0001`00_lM00CoP@0007l00olM0003o`0001/000?o00006`000ol0
000J00?oQ@0008801?lJ00;o6`000ol0000I00;o6P03ohP0002600?o6@000ol0000H0003o`0001P0
00?o00005`03oh/0002900?o5`02oaP000?o00005P02oaL00on>0000S003oaH00_lF0003o`0001@0
0_lE00CoT@0008l01?lD0003o`0001<000?o00004`000ol0000B00?oU@0009<00olB00;o4`000ol0
000A00;o4P03oiP0002F00?o4@000ol0000@0003o`00010000?o00003`03oi/0002I00?o3`02oa00
00?o00003P02o`l00onN0000W003o`h00_l>0003o`0000`00_l=00CoX@0009l01?l<0003o`0000/0
00?o00002`000ol0000:00?oY@000:<00ol:00;o2`000ol0000900;o2P03ojP0002V00?o2@02oa<0
0_l900?oZ`000:T00ol80003o`0000l000?o00001P03ojh0002/00Co1@02o`d00_l500Co/@000;00
0olE00?o]@000;<00_l@00?o^0000;/01?o10000_0000ol000310000_0000ol000310000_0000ol0
00310000^`04ol40002l0003o`000<40002l00?o`@000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000001\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17984, -0.833976, 
  0.0115171, 0.00367975}},
  CellTags->"Encapsulation - mutant 4"],

Cell[TextData[{
  "Selective encapsulation 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$208)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$208)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@000>P00_l200;oOP05o`l0003Y0004o`00oh0000Go0000o`0>0000j@04oh00
00Go0000o`0>0000j@001?l00?n000Co3`000>X00_n10005o`000?l03P000>T00on000Go3`000?l0
P@000?l0P@000?<000?o0000L@000ol0000F0000m0000ol0001_0003o`0001L0003e0003o`0006d0
00?o000060000?H00_m[00;o6`000?P000?o0000I`000ol0000K0000n@000ol0001U0003o`0001`0
003j0003o`0006<000?o00007@000?/00_mQ00;o80000?d000?o0000G@000ol0000P0000oP000ol0
001K0003o`000240003o0003o`0005T000?o00008P000?l00@000ol0001G0003o`0002<0003o0080
0_mE00;o9P000?l010000ol0001A0003o`0002H0003o00D000?o0000C`000ol0000W0000o`060003
o`0004d000?o0000:0000?l01`02od/00_l[0000o`090003o`0004L000?o0000:`000?l02P000ol0
00150003o`0002`0003o00/000?o0000@`000ol0000]0000o`0<0003o`00044000?o0000;P000?l0
3@02ocl00_la0000o`0?0003o`0003/000?o0000<@000?l040000ol0000i0003o`000380003o0140
00?o0000=`000ol0000c0000o`0B00;o=@02ocH0003o01@000?o0000<@000ol0000f0000o`0E0003
o`0002l000?o0000=`000?l05P000ol0000]0003o`0003P0003o01L000?o0000:`000ol0000i0000
o`0H00;o:@02oc`0003o01X000?o00009@000ol0000l0000o`0K0003o`0002<000?o0000?@000?l0
70000ol0000Q0003o`0003h0003o01d00_lO00;o@@000?l07`000ol0000K0003o`000440003o0200
00?o00006@000ol000120000o`0Q0003o`0001L000?o0000@`000?l08P000ol0000E0003o`0004@0
003o02<00_lC00;oA`000?l09@000ol0000?0003o`0004L0003o02H000?o00003@000ol000180000
o`0W0003o`0000/000?o0000B@000?l0P@000?l0;003oe80003o02l000?o0000C`000?l0;004oe40
003o02/000Go0000o`1A0000o`0[0005o`000?l0D@000?l0:`001Ol0003o0540003o02`01Om@0000
o`210000o`210000o`210000o`210000o`210000o`210000o`210000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500
003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0
;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003
o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000
D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000
o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`210000o`210000o`210000o`210000o`210000o`0/00?oDP000?l0;`000ol0001?0000
m`06o`/01Ol<00Go3@04oe40003h0003o`0000h000Go0000o`0<0005o`000?l02`001Ol0003o0540
003h0003o`0000h000Go0000o`0<0005o`000?l02`001Ol0003o0540003h00Co3@001Ol0003o00`0
1?l<0005o`000?l0D@000?P000?o00003P001Ol0003o00`000Go0000o`0<00GoD0000?L01_l;00Go
3005of80003o0840003o0840003o0840003o0840003n0003o`0007l0003n0003o`0000/000?o0000
30000ol0000;0003o`0005@0003o0003o`0000/000?o00002`000ol0000;0003o`0005@0003o0003
o`0000/000?o00002P000ol0000;0003o`0005D0003o004000?o00002P000ol0000:0003o`0000/0
00?o0000E@000?l00@000ol0000:0003o`0000X000?o00002P000ol0001F0000o`020003o`0000T0
00?o00002P000ol0000:0003o`0005H0003o008000?o00002@000ol0000:0003o`0000T000?o0000
E`000?l00P000ol0000:0003o`0000T000?o00002@000ol0001G0000o`030003o`0000T000?o0000
2@000ol000080003o`0005P0003o00<000?o00002@000ol000080003o`0000T000?o0000F0000?l0
10000ol000080003o`0000P000?o000020000ol0001I0000o`040003o`0000P000?o000020000ol0
00080003o`0005T0003o00D000?o00001`000ol000080003o`0000P000?o0000F@000?l01@000ol0
00080003o`0000L000?o00001`000ol0001J0000o`060003o`0000L000?o00001`000ol000070003
o`0005X0003o00H000?o00001`000ol000070003o`0000H000?o0000F`000?l01`000ol000060003
o`0000H000?o00001`000ol0001K0000o`070003o`0000H000?o00001P000ol000060003o`0005`0
003o00P000?o00001@000ol000060003o`0000H000?o0000G0000?l020000ol000060003o`0000D0
00?o00001@000ol0001M0000o`090003o`0000D000?o00001@000ol000050003o`0005d0003o00T0
00?o00001@000ol000050003o`0000@000?o0000GP000?l02P000ol000040003o`0000@000?o0000
1@000ol0001N0000o`0:0003o`0000@000?o000010000ol000040003o`0005l0003o00/000?o0000
0`000ol000040003o`0000@000?o0000G`000?l02`000ol000040003o`0000<000?o00000`000ol0
001P0000o`0<0003o`0000<000?o00000`000ol000030003o`000600003o00`000?o00000`000ol0
00030003o`0000<000?o0000H0000?l03@000ol000020003o`0000<000?o00000P000ol0001Q0000
o`0=0003o`00008000?o00000P000ol000030003o`000640003o00h000Go0000o`040003o`000080
00?o0000HP000?l03P000ol000020005o`000?l010000ol0001R0000o`0?0005o`000?l00`001Ol0
003o06D0003o00l000Go0000o`030005o`000?l0I@000?l03`001Ol0003o00<000Co003oIP000?l0
40001?l00?l30004o`00ofH0003o010000Co003o0P001?l00?mW0000o`0A0003o`0000D000?o0000
I@000?l0P@000?l0P@000?l0P@0005P00ooo02H0001K0005o`000?l0o`0Q00003002o`800_m600Co
0P04o`801?l300?o0`03odH01OmC00;o00<0ool0D@04oa@0000=0004o`00odH000Go0000o`020004
o`00o`<000?o00000P001ol0003o0?l00`000ol000140005o`000?l0DP001?l00?mC0003o`0001@0
000=00CoAP001Ol0003o00@00_l40005o`000?l00`000ol0o`030003o`0004@000Go0000o`1B0004
o`00oe@000?o00004`0000d000Co003oAP001Ol0003o00800_l70004o`00o`<000?o00000om70005
o`000?l0DP001?l00?mE0003o`000180000>00;oB005o`050?l00?l01@001?l00?l30003o`3o00<0
00?o0000A0001Ol0003o05801?mE0003o`000180000=00?o2003od<01?l200?o1003o`<00om600Go
D`000ol0001:00?o1P03oaD0000K00Co@@000ol0002^00;oB@03ob40000O00?oC002oi/000?o0000
BP04ob@0000R00?oB`000ol0002G0003o`0004P00olX00009@03odT00_nE00;oB003ob/0000X00?o
B002oi400_m700?o;P0002/01?m60003o`0008d000?o0000A003oc40000_00?oA002odD000?o0000
@`02od<01?ld0000<P03od<00_m30003o`0004400_m200?o>00003D00om20003o`00040000?o0000
@0000ol0000o00?o>`0003P01?lo00;o@0000ol0000n00;o?`03och0000l00?o?P000ol0000m0003
o`0003d000?o0000?003od40000o00?o?002ocd000?o0000>`02oc/01?m40000@P03oc/00_lk0003
o`0003T00_lj00?oB00004D00olj0003o`0003P000?o0000>0000ol0000g00?oB`0004P01?lg00;o
>0000ol0000f00;o=`03odh0001<00?o=P000ol0000e0003o`0003D000?o0000=003oe40001?00?o
=002ocD000?o0000<`02oc<01?mD0000DP03oc<00_lc0003o`0003400_lb00?oF00005D01?la0003
o`00030000?o0000<0000ol0000_00?oF`0005T00ol_00;o<0000ol0000^00;o;`03oeh0001L00?o
;P000ol0000]0003o`0002d000?o0000;003of40001O00?o;002obd000?o0000:`02ob/01?mT0000
HP03ob/00_l[0003o`0002T00_lZ00?oJ00006D01?lY0003o`0002P000?o0000:0000ol0000W00?o
J`0006T00olW00;o:0000ol0000V00;o9`03ofh0001/00?o9P02obH000?o00009002obD01?ma0000
K`03obD000?o00008`000ol0000S0003o`0002800ome0000LP04ob800_lS0003o`0002400_lR00?o
N00007H00olQ0003o`00020000?o000080000ol0000O00?oN`0007T00olO00;o80000ol0000N00;o
7`03ogh0001l00?o7P02oah000?o00007002oad01?n10000O`03oad000?o00006`000ol0000K0003
o`0001X00on50000PP04oaX00_lK0003o`0001T00_lJ00?oR00008H00olI0003o`0001P000?o0000
60000ol0000G00?oR`0008T00olG00;o60000ol0000F00;o5`03ohh0002<00?o5P02oaH000?o0000
5002oaD01?nA0000S`04oa@000?o00004`000ol0000C0003o`0001800onE0000T`03oa800_lC0003
o`0001400_lB00?oV00009H00olA0003o`00010000?o000040000ol0000?00?oV`0009T00ol?00;o
40000ol0000>00;o3`03oih0002L00?o3P02o`h000?o00003002o`d01?nQ0000W`04o``000?o0000
2`000ol0000;0003o`0000X00onU0000X`03o`X00_l;0003o`0000T00_l:00?oZ0000:H00ol900;o
4`02o`T00on[0000Z@03o`P000?o00003`000ol0000600?o[P000:`01?l500;o3@02o`D01?na0000
/003oaD00one0000/`02oa000onh0000^`04ol40002l0003o`000<40002l0003o`000<40002l0003
o`000<40002k00Co`@000;`000?o0000`@000;`00oo10000o`210000o`210000o`210000o`210000
o`210000\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17984, -0.833976, 
  0.0115171, 0.00367975}},
  CellTags->"Encapsulation - mutant 5"],

Cell[TextData[{
  "Selective encapsulation 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 6",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$228)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
1 g
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$228)] .25889 .30902 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@000>P00_l200;oOP05o`l0003Y0004o`00oh0000Go0000o`0>0000j@04oh00
00Go0000o`0>0000j@001?l00?n000Co3`000>X00_n10005o`000?l03P000>T00on000Go3`000?l0
P@000?l0P@000?<000?o0000L@000ol0000F0000m0000ol0001_0003o`0001L0003e0003o`0006d0
00?o000060000?H00_m[00;o6`000?P000?o0000I`000ol0000K0000n@000ol0001U0003o`0001`0
003j0003o`0006<000?o00007@000?/00_mQ00;o80000?d000?o0000G@000ol0000P0000oP000ol0
001K0003o`000240003o0003o`0005T000?o00008P000?l00@000ol0001G0003o`0002<0003o0080
0_mE00;o9P000?l010000ol0001A0003o`0002H0003o00D000?o0000C`000ol0000W0000o`060003
o`0004d000?o0000:0000?l01`02od/00_l[0000o`090003o`0004L000?o0000:`000?l02P000ol0
00150003o`0002`0003o00/000?o0000@`000ol0000]0000o`0<0003o`00044000?o0000;P000?l0
3@02ocl00_la0000o`0?0003o`0003/000?o0000<@000?l040000ol0000i0003o`000380003o0140
00?o0000=`000ol0000c0000o`0B00;o=@02ocH0003o01@000?o0000<@000ol0000f0000o`0E0003
o`0002l000?o0000=`000?l05P000ol0000]0003o`0003P0003o01L000?o0000:`000ol0000i0000
o`0H00;o:@02oc`0003o01X000?o00009@000ol0000l0000o`0K0003o`0002<000?o0000?@000?l0
70000ol0000Q0003o`0003h0003o01d00_lO00;o@@000?l07`000ol0000K0003o`000440003o0200
00?o00006@000ol000120000o`0Q0003o`0001L000?o0000@`000?l08P000ol0000E0003o`0004@0
003o02<00_lC00;oA`000?l09@000ol0000?0003o`0004L0003o02H000?o00003@000ol000180000
o`0W0003o`0000/000?o0000B@000?l0P@000?l0;003oe80003o02l000?o0000C`000?l0;004oe40
003o02/000Go0000o`1A0000o`0[0005o`000?l0D@000?l0:`001Ol0003o0540003o02`01Om@0000
o`210000o`210000o`210000o`210000o`210000o`210000o`210000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500
003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0
;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003
o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000
D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000
o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`210000o`210000o`210000o`210000o`210000F003om000omB0000F`001Ol0003o0<h0
00?o0000C`0004X01Ol900Co0P04o`801?l200Co0`03o`T00omg00Ko2`05o``01Ol=00CoD@0004/0
00Go0000o`070005o`000?l00P001?l00?l30003o`0000<000?o00000P001Ol0003o00/000?o0000
M@000ol0000>0005o`000?l030001Ol0003o00/000Go0000o`1A0000B`001Ol0003o00L000Go0000
o`0400;o10000ol000030005o`000?l00`000ol000090003o`0007D000?o00003P001Ol0003o00`0
00Go0000o`0;0005o`000?l0D@0004/01?l80005o`000?l00P02o`L000?o00000`001?l00003o`X0
0_mh00Co3@001Ol0003o00`01?l<0005o`000?l0D@0004/000Go0000o`0800Go00D0o`00o`050003
o`0000<000Co003o0`000ol000090003o`0007D000?o00003P001Ol0003o00`000Go0000o`0<00Go
D00004X01Ol?00Co0P03o`<00ol400?o2@03ogL01_l;00Go3005of80001P0003o`000?l07P000?l0
P@000?l0P@000?l0P@00050000?o0000Z`000ol0001o0000D@000ol0000B0003o`00018000?o0000
P0000ol0000;0003o`0000`000?o00002`000ol0001D0000D@000ol0000B0003o`00018000?o0000
P@000ol0000;0003o`0000/000?o00002`000ol0001D0000DP000ol0000A0003o`00014000?o0000
PP000ol0000;0003o`0000X000?o00002`000ol0001E0000DP000ol0000A0003o`00014000?o0000
P`000ol0000:0003o`0000X000?o00002`000ol0001E0000D`000ol0000@0003o`00010000?o0000
Q0000ol0000:0003o`0000X000?o00002P000ol0001F0000D`000ol0000@0003o`00010000?o0000
Q@000ol000090003o`0000X000?o00002P000ol0001F0000E0000ol0000?0003o`0000l000?o0000
QP000ol000090003o`0000X000?o00002@000ol0001G0000E0000ol0000?0003o`0000l000?o0000
QP000ol0000:0003o`0000T000?o00002@000ol0001G0000E@000ol0000>0003o`0000h000?o0000
R0000ol000090003o`0000T000?o000020000ol0001H0000E@000ol0000>0003o`0000h000?o0000
R0000ol000090003o`0000P000?o00002@000ol0001H0000EP000ol0000=0003o`0000d000?o0000
RP000ol000080003o`0000P000?o000020000ol0001I0000EP000ol0000=0003o`0000d000?o0000
RP000ol000080003o`0000P000?o000020000ol0001I0000EP000ol0000=0003o`0000d000?o0000
R`000ol000070003o`0000P000?o000020000ol0001I0000E`000ol0000<0003o`0000`000?o0000
S0000ol000080003o`0000L000?o00001`000ol0001J0000E`000ol0000<0003o`0000`000?o0000
S@000ol000070003o`0000L000?o00001`000ol0001J0000F0000ol0000;0003o`0000/000?o0000
SP000ol000070003o`0000L000?o00001P000ol0001K0000F0000ol0000;0003o`0000/000?o0000
S`000ol000060003o`0000H000?o00001`000ol0001K0000F@000ol0000:0003o`0000X000?o0000
T0000ol000060003o`0000H000?o00001P000ol0001L0000F@000ol0000:0003o`0000X000?o0000
T@000ol000050003o`0000H000?o00001P000ol0001L0000FP000ol000090003o`0000T000?o0000
TP000ol000060003o`0000D000?o00001@000ol0001M0000FP000ol000090003o`0000T000?o0000
T`000ol000050003o`0000D000?o00001@000ol0001M0000F`000ol000080003o`0000P000?o0000
U0000ol000050003o`0000D000?o000010000ol0001N0000F`000ol000080003o`0000P000?o0000
U@000ol000040003o`0000@000?o00001@000ol0001N0000G0000ol000070003o`0000L000?o0000
UP000ol000040003o`0000@000?o000010000ol0001O0000G0000ol000070003o`0000L000?o0000
U`000ol000030003o`0000@000?o000010000ol0001O0000G@000ol000060003o`0000H000?o0000
V0000ol000040003o`0000<000?o00000`000ol0001P0000G@000ol000060003o`0000H000?o0000
V@000ol000030003o`0000<000?o00000`000ol0001P0000G@000ol000060003o`0000H000?o0000
V@000ol000030003o`0000<000?o00000`000ol0001P0000GP000ol000050003o`0000D000?o0000
V`000ol000020003o`0000<000?o00000P000ol0001Q0000GP000ol000050003o`0000D000?o0000
V`000ol000020003o`00008000?o00000`000ol0001Q0000G`000ol000040003o`0000@000?o0000
W@001Ol0003o00@000?o00000P000ol0001R0000G`000ol000040003o`0000@000?o0000W@000ol0
00020005o`000?l010000ol0001R0000H0000ol000030003o`0000<000?o0000W`001Ol0003o00<0
00Go0000o`1U0000H0000ol000030003o`0000<000?o0000W`001Ol0003o00<000Go0000o`1U0000
H@000ol000020003o`00008000?o0000X0001Ol0003o00<000Co003oIP00064000?o00000P000ol0
00020003o`000:4000Co003o0`001?l00?mV0000HP001Ol0003o00<000?o0000XP001?l00?l20004
o`00ofL0001R0003o`0000D000?o0000X`000ol000050003o`0006D0003o0840003o0840003o0840
001T00?oo`0J0000I`000ol0003o01L0000<00;o0P02oe801?mB00GoD`02o`030?oo05401?lD0000
3@001?l00?mB0005o`000?l0D`001Ol0003o058000Co003oD`000ol0000D00003@04oe8000Go0000
o`1C0005o`000?l0DP001?l00?mD0003o`0001<0000=0004o`00oe8000Go0000o`1C0005o`000?l0
DP001?l00?mE0003o`000180000>00;oE005oe8000Go0000o`1B00CoE@000ol0000B00003@03o`P0
0onO00GoD`000ol0001:00?o1P03oaD0000K00ColP02odT00olQ00007`03od`00_nK0003o`0004X0
1?lT00008P03od/000?o0000U`000ol0001800?o:00002D00om900;oU@02odP00ol[0000:003odP0
0_nA00;oA`03obh0000[00CoAP000ol0002=0003o`0004@00ola0000;`03od@00_m50003o`0004<0
0_m300Co=00003800om300;o@`000ol0001100;o@P03ocP0000e00?o@P000ol000100003o`000400
00?o0000?`03oc/0000h00Co?`02od0000?o0000?P02ocl00oln0000?003och000?o0000?@000ol0
000m0003o`0003`00om10000?`03oc`00_lm0003o`0003/00_lk00CoA00004800olk00;o>`000ol0
000i00;o>P03odP0001500?o>P000ol0000h0003o`0003P000?o0000=`03od/0001800Co=`02ocP0
00?o0000=P02ocL00om>0000C003ocH000?o0000=@000ol0000e0003o`0003@00omA0000C`03oc@0
0_le0003o`0003<00_lc00CoE00005800olc00;o<`000ol0000a00;o<P03oeP0001E00Co<@000ol0
000`0003o`00030000?o0000;`03oe/0001I00?o;`02oc0000?o0000;P02obl00omN0000G003obh0
00?o0000;@000ol0000]0003o`0002`00omQ0000G`03ob`00_l]0003o`0002/00_l[00CoI0000680
0ol[00;o:`000ol0000Y00;o:P03ofP0001U00Co:@000ol0000X0003o`0002P000?o00009`03of/0
001Y00?o9`02obP000?o00009P02obL00om^0000K003obH00_lV0003o`0002@00_lU00CoL@0006l0
0olU0003o`0002<000?o00008`000ol0000R00?oM@0007801?lR00;o8`000ol0000Q00;o8P03ogP0
001f00?o8@000ol0000P0003o`00020000?o00007`03og/0001i00?o7`02ob0000?o00007P02oal0
0omn0000O003oah00_lN0003o`0001`00_lM00CoP@0007l00olM0003o`0001/000?o00006`000ol0
000J00?oQ@0008801?lJ00;o6`000ol0000I00;o6P03ohP0002600?o6@000ol0000H0003o`0001P0
00?o00005`03oh/0002900?o5`02oaP000?o00005P02oaL00on>0000S003oaH00_lF0003o`0001@0
0_lE00CoT@0008l01?lD0003o`0001<000?o00004`000ol0000B00?oU@0009<00olB00;o4`000ol0
000A00;o4P03oiP0002F00?o4@000ol0000@0003o`00010000?o00003`03oi/0002I00?o3`02oa00
00?o00003P02o`l00onN0000W003o`h00_l>0003o`0000`00_l=00CoX@0009l01?l<0003o`0000/0
00?o00002`000ol0000:00?oY@000:<00ol:00;o2`000ol0000900;o2P03ojP0002V00?o2@02oa<0
0_l900?oZ`000:T00ol80003o`0000l000?o00001P03ojh0002/00Co1@02o`d00_l500Co/@000;00
0olE00?o]@000;<00_l@00?o^0000;/01?o10000_0000ol000310000_0000ol000310000_0000ol0
00310000^`04ol40002l0003o`000<40002l00?o`@000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000001\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17984, -0.833976, 
  0.0115171, 0.00367975}},
  CellTags->"Encapsulation - mutant 6"],

Cell[TextData[{
  "Selective encapsulation 6: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 7",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$248)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
1 g
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$248)] .25889 .30902 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@000>P00_l200;oOP05o`l0003Y0004o`00oh0000Go0000o`0>0000j@04oh00
00Go0000o`0>0000j@001?l00?n000Co3`000>X00_n10005o`000?l03P000>T00on000Go3`000?l0
P@000?l0P@000?<000?o0000L@000ol0000F0000m0000ol0001_0003o`0001L0003e0003o`0006d0
00?o000060000?H00_m[00;o6`000?P000?o0000I`000ol0000K0000n@000ol0001U0003o`0001`0
003j0003o`0006<000?o00007@000?/00_mQ00;o80000?d000?o0000G@000ol0000P0000oP000ol0
001K0003o`000240003o0003o`0005T000?o00008P000?l00@000ol0001G0003o`0002<0003o0080
0_mE00;o9P000?l010000ol0001A0003o`0002H0003o00D000?o0000C`000ol0000W0000o`060003
o`0004d000?o0000:0000?l01`02od/00_l[0000o`090003o`0004L000?o0000:`000?l02P000ol0
00150003o`0002`0003o00/000?o0000@`000ol0000]0000o`0<0003o`00044000?o0000;P000?l0
3@02ocl00_la0000o`0?0003o`0003/000?o0000<@000?l040000ol0000i0003o`000380003o0140
00?o0000=`000ol0000c0000o`0B00;o=@02ocH0003o01@000?o0000<@000ol0000f0000o`0E0003
o`0002l000?o0000=`000?l05P000ol0000]0003o`0003P0003o01L000?o0000:`000ol0000i0000
o`0H00;o:@02oc`0003o01X000?o00009@000ol0000l0000o`0K0003o`0002<000?o0000?@000?l0
70000ol0000Q0003o`0003h0003o01d00_lO00;o@@000?l07`000ol0000K0003o`000440003o0200
00?o00006@000ol000120000o`0Q0003o`0001L000?o0000@`000?l08P000ol0000E0003o`0004@0
003o02<00_lC00;oA`000?l09@000ol0000?0003o`0004L0003o02H000?o00003@000ol000180000
o`0W0003o`0000/000?o0000B@000?l0P@000?l0;003oe80003o02l000?o0000C`000?l0;004oe40
003o02/000Go0000o`1A0000o`0[0005o`000?l0D@000?l0:`001Ol0003o0540003o02`01Om@0000
o`210000o`210000o`210000o`210000o`210000o`210000o`210000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500
003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0
;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003
o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000
D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000
o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`210000o`210000o`210000o`210000o`210000F003om000omB0000F`001Ol0003o0<h0
00?o0000C`0004X01Ol900Co0P04o`801?l400?o0P03o`T00omg00Ko2`05o``01Ol=00CoD@0004/0
00Go0000o`070005o`000?l00P001?l00?l30003o`0000D000Co003o0`000ol000090003o`0007D0
00?o00003P001Ol0003o00`000Go0000o`0;0005o`000?l0D@0004/000Go0000o`070005o`000?l0
1002o`@000Co00001Ol00`3o00020003o`0000T000?o0000M@000ol0000>0005o`000?l030001Ol0
003o00/000Go0000o`1A0000B`04o`P000Go0000o`0200;o1`001ol0003o0?l00`03o`X00_mh00Co
3@001Ol0003o00`01?l<0005o`000?l0D@0004/000Go0000o`0800Go00D0o`00o`050007o`000?l0
o`020005o`000?l02`000ol0001e0003o`0000h000Go0000o`0<0005o`000?l03005oe00001:00Go
3`04o`800ol500;o0`03o`T00omg00Ko2`05o``01OmR0000H0000ol0003o01h0003o0840003o0840
003o0840001@0003o`000:/000?o0000O`00054000?o00004P000ol0000B0003o`00080000?o0000
2`000ol0000<0003o`0000/000?o0000E000054000?o00004P000ol0000B0003o`00084000?o0000
2`000ol0000;0003o`0000/000?o0000E000058000?o00004@000ol0000A0003o`00088000?o0000
2`000ol0000:0003o`0000/000?o0000E@00058000?o00004@000ol0000A0003o`0008<000?o0000
2P000ol0000:0003o`0000/000?o0000E@0005<000?o000040000ol0000@0003o`0008@000?o0000
2P000ol0000:0003o`0000X000?o0000EP0005<000?o000040000ol0000@0003o`0008D000?o0000
2@000ol0000:0003o`0000X000?o0000EP0005@000?o00003`000ol0000?0003o`0008H000?o0000
2@000ol0000:0003o`0000T000?o0000E`0005@000?o00003`000ol0000?0003o`0008H000?o0000
2P000ol000090003o`0000T000?o0000E`0005D000?o00003P000ol0000>0003o`0008P000?o0000
2@000ol000090003o`0000P000?o0000F00005D000?o00003P000ol0000>0003o`0008P000?o0000
2@000ol000080003o`0000T000?o0000F00005H000?o00003@000ol0000=0003o`0008X000?o0000
20000ol000080003o`0000P000?o0000F@0005H000?o00003@000ol0000=0003o`0008X000?o0000
20000ol000080003o`0000P000?o0000F@0005H000?o00003@000ol0000=0003o`0008/000?o0000
1`000ol000080003o`0000P000?o0000F@0005L000?o000030000ol0000<0003o`0008`000?o0000
20000ol000070003o`0000L000?o0000FP0005L000?o000030000ol0000<0003o`0008d000?o0000
1`000ol000070003o`0000L000?o0000FP0005P000?o00002`000ol0000;0003o`0008h000?o0000
1`000ol000070003o`0000H000?o0000F`0005P000?o00002`000ol0000;0003o`0008l000?o0000
1P000ol000060003o`0000L000?o0000F`0005T000?o00002P000ol0000:0003o`00090000?o0000
1P000ol000060003o`0000H000?o0000G00005T000?o00002P000ol0000:0003o`00094000?o0000
1@000ol000060003o`0000H000?o0000G00005X000?o00002@000ol000090003o`00098000?o0000
1P000ol000050003o`0000D000?o0000G@0005X000?o00002@000ol000090003o`0009<000?o0000
1@000ol000050003o`0000D000?o0000G@0005/000?o000020000ol000080003o`0009@000?o0000
1@000ol000050003o`0000@000?o0000GP0005/000?o000020000ol000080003o`0009D000?o0000
10000ol000040003o`0000D000?o0000GP0005`000?o00001`000ol000070003o`0009H000?o0000
10000ol000040003o`0000@000?o0000G`0005`000?o00001`000ol000070003o`0009L000?o0000
0`000ol000040003o`0000@000?o0000G`0005d000?o00001P000ol000060003o`0009P000?o0000
10000ol000030003o`0000<000?o0000H00005d000?o00001P000ol000060003o`0009T000?o0000
0`000ol000030003o`0000<000?o0000H00005d000?o00001P000ol000060003o`0009T000?o0000
0`000ol000030003o`0000<000?o0000H00005h000?o00001@000ol000050003o`0009/000?o0000
0P000ol000030003o`00008000?o0000H@0005h000?o00001@000ol000050003o`0009/000?o0000
0P000ol000020003o`0000<000?o0000H@0005l000?o000010000ol000040003o`0009d000Go0000
o`040003o`00008000?o0000HP0005l000?o000010000ol000040003o`0009d000?o00000P001Ol0
003o00@000?o0000HP00060000?o00000`000ol000030003o`0009l000Go0000o`030005o`000?l0
I@00060000?o00000`000ol000030003o`0009l000Go0000o`030005o`000?l0I@00064000?o0000
0P000ol000020003o`000:0000Go0000o`030004o`00ofH0001Q0003o`00008000?o00000P000ol0
002Q0004o`00o`<000Co003oIP00068000Go0000o`030003o`000:8000Co003o0P001?l00?mW0000
HP000ol000050003o`000:<000?o00001@000ol0001U0000o`210000o`210000o`210000I003ool0
6P0006L000?o0000o`0G00003002o`800_mB00CoDP05oe<00_l00`3oo`1A00Co500000d000Co003o
DP001Ol0003o05<000Go0000o`1B0004o`00oe<000?o0000500000d01?mB0005o`000?l0D`001Ol0
003o058000Co003oE0000ol0000C00003@001?l00?mB0005o`000?l0D`001Ol0003o058000Co003o
E@000ol0000B00003P02oe@01OmB0005o`000?l0DP04oeD000?o00004P0000d00ol800?oW`05oe<0
00?o0000BP03o`H00olE00006`04oo800_m900?o8@0001l00om<00;oV`000ol0001:00Co90000280
0om;0003o`0009L000?o0000B003obP0000U00?oB@02oiD00_m800?o:`0002P00om800;oT@02odL0
0ol^0000:`04odH000?o0000S@000ol0001400?o<@0002l00om400;oA@000ol0001300;o@`04oc@0
000b00?o@`02od<000?o0000@@02od800olh0000=@03od8000?o0000@0000ol000100003o`0003l0
0olk0000>004ocl00_m00003o`0003h00_lo00?o?P0003`00oln0003o`0003d000?o0000?@000ol0
000l00?o@@0003l00oll00;o?@000ol0000k00;o>`04od@0001200?o>`02oc/000?o0000>@02ocX0
0om80000A@03ocX000?o0000>0000ol0000h0003o`0003L00om;0000B004ocL00_lh0003o`0003H0
0_lg00?oCP0004`00olf0003o`0003D000?o0000=@000ol0000d00?oD@0004l00old00;o=@000ol0
000c00;o<`04oe@0001B00?o<`02oc<000?o0000<@02oc800omH0000E@04oc4000?o0000<0000ol0
000`0003o`0002l00omK0000F@03obl00_l`0003o`0002h00_l_00?oGP0005`00ol^0003o`0002d0
00?o0000;@000ol0000/00?oH@0005l00ol/00;o;@000ol0000[00;o:`04of@0001R00?o:`02ob/0
00?o0000:@02obX00omX0000I@04obT000?o0000:0000ol0000X0003o`0002L00om[0000J@03obL0
0_lX0003o`0002H00_lW00?oKP0006`00olV00;o9P000ol0000T00;o9@04og40001_00?o9@000ol0
000S0003o`0002<000?o00008P03ogD0001b00Co8P02ob<000?o00008@02ob800omh0000MP03ob40
00?o000080000ol0000P0003o`0001l00omk0000N@03oal00_lP0003o`0001h00_lO00?oOP0007`0
0olN00;o7P000ol0000L00;o7@04oh40001o00?o7@000ol0000K0003o`0001/000?o00006P03ohD0
002200Co6P02oa/000?o00006@02oaX00on80000QP03oaT000?o000060000ol0000H0003o`0001L0
0on;0000R@03oaL00_lH0003o`0001H00_lG00?oSP0008`00olF00;o5P000ol0000D00;o5@04oi40
002?00Co50000ol0000C0003o`0001<000?o00004P03oiD0002C00?o4P02oa<000?o00004@02oa80
0onH0000UP03oa4000?o000040000ol0000@0003o`0000l00onK0000V@03o`l00_l@0003o`0000h0
0_l?00?oWP0009`00ol>00;o3P000ol0000<00;o3@04oj40002O00Co30000ol0000;0003o`0000/0
00?o00002P03ojD0002S00?o2P02o`/000?o00002@02o`X00onX0000YP03o`T00_lC00;o2@03oj/0
002Y00?o20000ol0000?0003o`0000H00on^0000[004o`D00_l=00;o1@04ok40002`00?o5@03okD0
002c00;o4003okP0002k00Co`@000;`000?o0000`@000;`000?o0000`@000;`000?o0000`@000;/0
1?o10000_0000ol000310000_003ol40003o0840003o0840003o0840003o0840003o08400000\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17984, -0.833976, 
  0.0115171, 0.00367975}},
  CellTags->"Encapsulation - mutant 7"],

Cell[TextData[{
  "Selective encapsulation 7: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 8",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h$268)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
0 w
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Mshowa
P
0 w
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Mshowa
P
1 g
.2619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Mshowa
P
1 g
.33093 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Mshowa
P
1 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Mshowa
P
1 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h$268)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
1 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@0006L00ooo01L0001X0003o`000?l05P0006D01Ooo01L0001V0003o`3o0?l0
600006H000?o0?l0o`0H0000I`02ool060000?l0P@000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000
I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003
o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000
o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0
001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L0
00?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0
003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l0
5`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000
I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003
o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000
o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0
001W0003o`000?l05`0006L000?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`0006L0
00?o0000o`0G0000I`000ol0003o01L0001W0003o`000?l05`000?l0P@000?l0P@000?l0P@000?l0
P@0006D00ooo01T0001X0003o`000?l05P0004/01OlE00Co5P03ooh0001<0005o`000?l04`001Ol0
003o01T000?o0000n`0004`000Go0000o`0C0005o`000?l06@000ol0003k0000C004oa@000Go0000
o`0G00;ooP0004`000Go0000o`0D00Go60000ol0003k0000B`05obl00oon0000o`210000o`210000
o`210000o`210000o`210000D@000ol0003o02d0001A0003o`0001<000?o000050000ol0003o0000
DP000ol0000B0003o`0001<000?o0000o`010000DP000ol0000B0003o`0001<000?o0000o`010000
DP000ol0000B0003o`0001<000?o0000o`010000D`000ol0000A0003o`00018000?o0000o`020000
D`000ol0000A0003o`00018000?o0000o`020000D`000ol0000A0003o`00014000?o0000o`030000
E0000ol0000@0003o`00014000?o0000o`030000E0000ol0000@0003o`00014000?o0000o`030000
E0000ol0000@0003o`00010000?o0000o`040000E@000ol0000?0003o`00010000?o0000o`040000
E@000ol0000?0003o`00010000?o0000o`040000E@000ol0000?0003o`0000l000?o0000o`050000
EP000ol0000>0003o`0000l000?o0000o`050000EP000ol0000>0003o`0000l000?o0000o`050000
EP000ol0000>0003o`0000h000?o0000o`060000E`000ol0000=0003o`0000h000?o0000o`060000
E`000ol0000=0003o`0000h000?o0000o`060000E`000ol0000=0003o`0000d000?o0000o`070000
F0000ol0000<0003o`0000d000?o0000o`070000F0000ol0000<0003o`0000`000?o0000o`080000
F0000ol0000<0003o`0000`000?o0000o`080000F@000ol0000;0003o`0000`000?o0000o`080000
F@000ol0000;0003o`0000/000?o0000o`090000F@000ol0000;0003o`0000/000?o0000o`090000
FP000ol0000:0003o`0000/000?o0000o`090000FP000ol0000:0003o`0000X000?o0000o`0:0000
F`000ol000090003o`0000X000?o0000o`0:0000F`000ol000090003o`0000X000?o0000o`0:0000
F`000ol000090003o`0000T000?o0000o`0;0000G0000ol000080003o`0000T000?o0000o`0;0000
G0000ol000080003o`0000T000?o0000o`0;0000G0000ol000080003o`0000P000?o0000o`0<0000
G@000ol000070003o`0000P000?o0000o`0<0000G@000ol000070003o`0000P000?o0000o`0<0000
G@000ol000070003o`0000L000?o0000o`0=0000GP000ol000060003o`0000L000?o0000o`0=0000
GP000ol000060003o`0000H000?o0000o`0>0000GP000ol000060003o`0000H000?o0000o`0>0000
G`000ol000050003o`0000H000?o0000o`0>0000G`000ol000050003o`0000D000?o0000o`0?0000
G`000ol000050003o`0000D000?o0000o`0?0000H0000ol000040003o`0000D000?o0000o`0?0000
H0000ol000040003o`0000@000?o0000o`0@0000H0000ol000040003o`0000@000?o0000o`0@0000
H@000ol000030003o`0000@000?o0000o`0@0000H@000ol000030003o`0000<000?o0000o`0A0000
H@000ol000030003o`0000<000?o0000o`0A0000HP000ol000020003o`0000<000?o0000o`0A0000
HP000ol000020003o`00008000?o0000o`0B0000HP000ol000020003o`00008000?o0000o`0B0000
H`001Ol0003o00<000?o0000o`0C0000H`001Ol0003o00<000?o0000o`0C0000H`001Ol0003o00<0
00?o0000o`0C0000JP000ol0003o01@0003o0840003o0840003o0840003o0840001U00?oo`0I0000
J0000ol0002U0003o`0006d0000<00;o0P02oe<01?mC00GoB002o`040?oo00Co0P04o`<00_l400?o
B004o`l0000=0004o`00oe<000Go0000o`1D0005o`000?l0A`001?l00?l20004o`00o`<000?o0000
0P001?l00?l20005o`000?l0B0000ol0000?00003@04oe<000Go0000o`1D0005o`000?l0A`001?l0
0?l400;o10001Ol0003o008000Co003o0`000ol000170003o`0000h0000=0004o`00oe<000Go0000
o`1D0005o`000?l0A`001?l00?l200;o1`000ol00003o`@00om;0003o`0000d0000>00;oE@05oe<0
00Go0000o`1700Co0P001?l00?l50004o`00o`D000Go0000o`1:0003o`0000d0000=00?o1`02oj<0
1Om80003o`0000<01?l200?o1003o`<00om10003o`0000@00ol@00006@02ond00_l70003o`000500
0_lJ00006`02oe4000?o0000l@02oa`0000M00?oC`000ol0002M0003o`0004d00olN00008002odh0
00?o0000V`000ol0001<00;o8@0002800om<0003o`0009T000?o0000BP03ob<0000U00;oB`02od/0
00?o0000B@02od/00_lV00009`03odX000?o0000B0000ol000180003o`0004P00olX0000:P02odT0
00?o0000A`000ol000170003o`0004L00_l[0000;003odL000?o0000AP000ol000160003o`0004D0
0ol]0000;`02odH00_m60003o`0004@00_m600;o<00003400_m60003o`0004<000?o0000@`000ol0
001400;o<P0003<00om40003o`00048000?o0000@P000ol0001200?o=00003H00_m30003o`000440
00?o0000@@000ol0001100;o=`0003P00om10003o`00040000?o0000@0000ol0000o00?o>@0003/0
0_m000;o@0000ol0000n00;o@002oc`0000m00?o?`000ol0000m0003o`0003d000?o0000?@03och0
001000;o?P000ol0000l0003o`0003`000?o0000?002od40001200?o?0000ol0000k0003o`0003/0
00?o0000>P03od<0001500;o>`02oc/000?o0000>@02oc/00_m60000A`02oc/000?o0000>0000ol0
000h0003o`0003T00_m80000B@03ocT000?o0000=`000ol0000g0003o`0003L00om:0000C002ocP0
00?o0000=P000ol0000f0003o`0003H00_m=0000CP03ocH000?o0000=@000ol0000e0003o`0003@0
0om?0000D@02ocD00_le0003o`0003<00_le00;oDP0005<00old0003o`00038000?o0000<P000ol0
000b00?oE00005H00_lc0003o`00034000?o0000<@000ol0000a00;oE`0005P00ola0003o`000300
00?o0000<0000ol0000_00?oF@0005/00_l`00;o<0000ol0000^00;o<002oe`0001M00;o<0000ol0
000]0003o`0002d000?o0000;P02oeh0001O00?o;P000ol0000/0003o`0002`000?o0000;003of00
001R00;o;@000ol0000[0003o`0002/000?o0000:`02of<0001T00?o:`000ol0000Z0003o`0002X0
00?o0000:@03ofD0001W00;o:P02obX000?o0000:002obX00_mX0000J@03obT000?o00009`000ol0
000W0003o`0002L00omZ0000K002obP000?o00009P000ol0000V0003o`0002H00_m]0000KP03obH0
00?o00009@000ol0000U0003o`0002@00om_0000L@02obD00_lU0003o`0002<00_lU00;oLP0007<0
0_lU0003o`00028000?o00008P000ol0000S00;oM00007D00olS0003o`00024000?o00008@000ol0
000Q00?oMP0007P00_lR0003o`00020000?o000080000ol0000P00;oN@0007X00olP0003o`0001l0
00?o00007`000ol0000N00?oN`0007d00_lO00;o7`000ol0000M00;o7`02ogh0001o00?o7P000ol0
000L0003o`0001`000?o00007003oh00002200;o7@000ol0000K0003o`0001/000?o00006`02oh<0
002400?o6`000ol0000J0003o`0001X000?o00006@03ohD0002700;o6P02oaX000?o00006002oaX0
0_n80000R@02oaX000?o00005`000ol0000G0003o`0001P00_n:0000R`03oaP000?o00005P000ol0
000F0003o`0001H00on<0000SP02oaL000?o00005@000ol0000E0003o`0001D00_n?0000T003oaD0
00?o000050000ol0000D0003o`0001<00onA0000T`02oa@00_lD0003o`0001800_lD00;oU00009D0
0olC0003o`00014000?o00004@000ol0000A00?oUP0009P00_lB0003o`00010000?o000040000ol0
000@00;oV@0009X00ol@0003o`0000l000?o00003`000ol0000>00?oV`0009d00_l?00;o3`000ol0
000=00;o3`02oih0002O00;o3`000ol0000<0003o`0000`000?o00003@02oj00002Q00?o3@000ol0
000;0003o`0000/000?o00002`03oj80002T00;o30000ol0000:0003o`0000X000?o00002P02ojD0
002V00?o2P000ol000090003o`0000T000?o00002003ojL0002Y00;o2@02o`T000?o00001`02o`T0
0_nZ0000Z`03o`P000?o00001P000ol000060003o`0000H00on/0000[P02o`L000?o00003@000ol0
000500;o[`000;000ol50003o`0000/000?o00000`03ok40002c00;o40000ol0000200;o]0000;D0
0_lA00;o]P000<L000?o0000]P000;d01?no0000_P000ol0002o0000_P000ol0002o0000_P000ol0
002o0000_@04okl0002n0003o`000;l0002n00?o_`000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000001\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17756, -0.625483, 
  0.0113711, 0.00275981}},
  CellTags->"Encapsulation - mutant 8"],

Cell[TextData[{
  "Selective encapsulation 8: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80712 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$288)] .80712 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
0 w
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Mshowa
P
0 w
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Mshowa
P
1 g
.2619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Mshowa
P
1 g
.33093 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Mshowa
P
1 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Mshowa
P
0 w
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Mshowa
P
1 g
.71509 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Mshowa
P
1 g
.7611 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Mshowa
P
0 w
.80712 .21092 m
.80712 .01472 L
s
1 g
.05 w
.80712 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .80712 .21092 0 0 Mshowa
P
1 g
.80712 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$288)] .80712 .01472 0 0 Mshowa
P
1 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
1 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l08`03oe/0003o02H000Go0000o`1F0000I`03okP01?l200Co0P04o`<00ol300?o@P0006P0
00?o0000]P001Ol0003o008000Co003o0`000ol000020007o`000?l0o`030003o`0003l0001U00Go
]`001Ol0003o00@00_l40005o`000?l00`000ol0o`030003o`0003l0001V0003o`3o0;P000Go0000
o`0200;o1`001?l00003o`<00om20000IP000ol0o`2i00Go00D0o`00o`050004o`00o`<000?o0?l0
0`000ol0000o0000I`02okl01?l200?o1003o`<00om20000o`0[0003o`0005<0003o0840003o0840
003o0840003o0840003o0840001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0001W0003o`000<H000?o0000C@0006L000?o0000aP000ol0001=0000
I`000ol000360003o`0004d0003o0840003o0840003o0840003o0840001U00?oaP03odl0001X0003
o`000<H000?o0000C00004/01OlE00Co5P03ogP01_l;00Go3005o`d01?m>0000C0001Ol0003o01<0
00Go0000o`0I0003o`0007H000?o00003P001Ol0003o00`000Go0000o`0;0005o`000?l0CP0004`0
00Go0000o`0C0005o`000?l06@000ol0001f0003o`0000h000Go0000o`0<0005o`000?l02`001Ol0
003o04h0001<00Co50001Ol0003o01L00_mi00Co3@001Ol0003o00`01?l<0005o`000?l0CP0004`0
00Go0000o`0D00Go60000ol0001f0003o`0000h000Go0000o`0<0005o`000?l03005odd0001;00Go
;`03ogP01_l;00Go3005oel0003o0840003o0840003o0840003o0840003o0840001A0003o`000=T0
00?o0000D000054000?o00004`000ol0000D0003o`0007l000?o000030000ol0000<0003o`0000`0
00?o0000D000058000?o00004P000ol0000C0003o`00084000?o00002`000ol0000<0003o`0000/0
00?o0000D@00058000?o00004P000ol0000C0003o`00084000?o00002`000ol0000<0003o`0000/0
00?o0000D@00058000?o00004P000ol0000C0003o`00084000?o000030000ol0000;0003o`0000/0
00?o0000D@0005<000?o00004@000ol0000B0003o`0008<000?o00002`000ol0000;0003o`0000X0
00?o0000DP0005<000?o00004@000ol0000B0003o`0008<000?o00002`000ol0000:0003o`0000/0
00?o0000DP0005<000?o00004@000ol0000A0003o`0008D000?o00002P000ol0000:0003o`0000/0
00?o0000DP0005@000?o000040000ol0000A0003o`0008D000?o00002P000ol0000:0003o`0000X0
00?o0000D`0005@000?o000040000ol0000A0003o`0008D000?o00002P000ol0000:0003o`0000X0
00?o0000D`0005@000?o000040000ol0000@0003o`0008L000?o00002@000ol0000:0003o`0000X0
00?o0000D`0005D000?o00003`000ol0000@0003o`0008L000?o00002@000ol0000:0003o`0000T0
00?o0000E00005D000?o00003`000ol0000@0003o`0008L000?o00002P000ol000090003o`0000T0
00?o0000E00005D000?o00003`000ol0000?0003o`0008T000?o00002@000ol000090003o`0000T0
00?o0000E00005H000?o00003P000ol0000?0003o`0008T000?o00002@000ol000090003o`0000P0
00?o0000E@0005H000?o00003P000ol0000?0003o`0008T000?o00002@000ol000080003o`0000T0
00?o0000E@0005H000?o00003P000ol0000>0003o`0008/000?o000020000ol000080003o`0000T0
00?o0000E@0005L000?o00003@000ol0000>0003o`0008/000?o000020000ol000080003o`0000P0
00?o0000EP0005L000?o00003@000ol0000>0003o`0008/000?o000020000ol000080003o`0000P0
00?o0000EP0005L000?o00003@000ol0000=0003o`0008d000?o00001`000ol000080003o`0000P0
00?o0000EP0005P000?o000030000ol0000=0003o`0008d000?o000020000ol000070003o`0000L0
00?o0000E`0005P000?o000030000ol0000<0003o`0008l000?o00001`000ol000070003o`0000L0
00?o0000E`0005P000?o000030000ol0000<0003o`0008l000?o00001`000ol000070003o`0000L0
00?o0000E`0005T000?o00002`000ol0000<0003o`0008l000?o00001`000ol000070003o`0000H0
00?o0000F00005T000?o00002`000ol0000;0003o`00094000?o00001P000ol000060003o`0000L0
00?o0000F00005T000?o00002`000ol0000;0003o`00094000?o00001P000ol000060003o`0000L0
00?o0000F00005X000?o00002P000ol0000;0003o`00094000?o00001P000ol000060003o`0000H0
00?o0000F@0005X000?o00002P000ol0000:0003o`0009<000?o00001@000ol000060003o`0000H0
00?o0000F@0005/000?o00002@000ol0000:0003o`0009<000?o00001P000ol000050003o`0000D0
00?o0000FP0005/000?o00002@000ol0000:0003o`0009<000?o00001P000ol000050003o`0000D0
00?o0000FP0005/000?o00002@000ol000090003o`0009D000?o00001@000ol000050003o`0000D0
00?o0000FP0005`000?o000020000ol000090003o`0009D000?o00001@000ol000050003o`0000@0
00?o0000F`0005`000?o000020000ol000090003o`0009D000?o00001@000ol000050003o`0000@0
00?o0000F`0005`000?o000020000ol000080003o`0009L000?o000010000ol000040003o`0000D0
00?o0000F`0005d000?o00001`000ol000080003o`0009L000?o000010000ol000040003o`0000@0
00?o0000G00005d000?o00001`000ol000080003o`0009L000?o000010000ol000040003o`0000@0
00?o0000G00005d000?o00001`000ol000070003o`0009T000?o00000`000ol000040003o`0000@0
00?o0000G00005h000?o00001P000ol000070003o`0009T000?o000010000ol000030003o`0000<0
00?o0000G@0005h000?o00001P000ol000060003o`0009/000?o00000`000ol000030003o`0000<0
00?o0000G@0005h000?o00001P000ol000060003o`0009/000?o00000`000ol000030003o`0000<0
00?o0000G@0005l000?o00001@000ol000060003o`0009/000?o00000`000ol000030003o`000080
00?o0000GP0005l000?o00001@000ol000050003o`0009d000?o00000P000ol000030003o`000080
00?o0000GP0005l000?o00001@000ol000050003o`0009d000?o00000P000ol000020003o`0000<0
00?o0000GP00060000?o000010000ol000050003o`0009d000?o00000P000ol000020003o`000080
00?o0000G`00060000?o000010000ol000040003o`0009l000Go0000o`040003o`00008000?o0000
G`00060000?o000010000ol000040003o`0009l000?o00000P001Ol0003o00@000?o0000G`000640
00?o00000`000ol000040003o`0009l000?o00000P001Ol0003o00<000?o0000H000064000?o0000
0`000ol000030003o`000:4000Go0000o`030005o`000?l0HP00064000?o00000`000ol000030003
o`000:4000Go0000o`030005o`000?l0HP00068000?o00000P000ol000030003o`000:4000Go0000
o`030004o`00of<0001R0003o`00008000?o00000P000ol0002S0004o`00o`<000Co003oH`000680
00?o00000P000ol000020003o`000:<000Co003o0P001Ol0003o06<0001S0005o`000?l00`000ol0
002U0003o`3o008000Co003oI00006<000Go0000o`030003o`000:D000Ko003o0?l20003o`000680
001S0005o`000?l00`000ol0002U0006o`00o`3o0P000ol0001R0000JP000ol0002]0003o`0006<0
003o0840003o0840003o0840003o0840001U00?oo`0I0000J0000ol0003o01H0000<00;o0P02oe<0
1?mC00GoE002o`030?oo05<01?l?00003@001?l00?mC0005o`000?l0E0001Ol0003o05<000Co003o
E@000ol0000?00003@04oe<000Go0000o`1D0005o`000?l0D`001?l00?mF0003o`0000h0000=0004
o`00oe<000Go0000o`1D0005o`000?l0D`001?l00?mG0003o`0000d0000>00;oE@05oe<000Go0000
o`1C00CoE`000ol0000=00003@03o`L00_nS00GoE0000ol0001>0003o`0000@00ol@00006@02ooT0
0_m>00;o6P0001/00_mA0003o`000?400_lL00007@03odl000?o0000W@000ol0001=00?o7P000200
0_m>0003o`0009/000?o0000C002ob40000R00?oC0000ol0002I0003o`0004X00olS00009@02od/0
0_m;0003o`0004T00_m;00;o9P0002L00om:0003o`0004P000?o0000B0000ol0001800?o:00002X0
0_m90003o`0004L000?o0000A`000ol0001700;o:`0002`00om70003o`0004H000?o0000AP000ol0
001500?o;@0002l00_m600;oAP000ol0001400;oAP02oc00000a00;oAP000ol000130003o`0004<0
00?o0000A002oc80000c00?oA0000ol000120003o`00048000?o0000@P03oc@0000f00;o@`000ol0
00110003o`00044000?o0000@@02ocL0000h00?o@@000ol000100003o`00040000?o0000?`03ocT0
000k00;o@002od0000?o0000?P02od000_ll0000?@03ocl000?o0000?@000ol0000m0003o`0003d0
0oln0000@002och000?o0000?0000ol0000l0003o`0003`00_m10000@P03oc`000?o0000>`000ol0
000k0003o`0003X00om30000A@02oc/00_lk0003o`0003T00_lk00;oAP0004L00_lk0003o`0003P0
00?o0000>0000ol0000i00;oB00004T00oli0003o`0003L000?o0000=`000ol0000g00?oBP0004`0
0_lh0003o`0003H000?o0000=P000ol0000f00;oC@0004h00olf0003o`0003D000?o0000=@000ol0
000d00?oC`0005400_le00;o=@000ol0000c00;o=@02oe80001C00?o=0000ol0000b0003o`000380
00?o0000<P03oe@0001F00;o<`000ol0000a0003o`00034000?o0000<@02oeL0001H00?o<@000ol0
000`0003o`00030000?o0000;`03oeT0001K00;o<002oc0000?o0000;P02oc000_mL0000G@02oc00
00?o0000;@000ol0000]0003o`0002h00_mN0000G`03obh000?o0000;0000ol0000/0003o`0002`0
0omP0000HP02obd000?o0000:`000ol0000[0003o`0002/00_mS0000I003ob/000?o0000:P000ol0
000Z0003o`0002T00omU0000I`02obX00_lZ0003o`0002P00_lZ00;oJ00006T00olY0003o`0002L0
00?o00009`000ol0000W00?oJP0006`00_lX0003o`0002H000?o00009P000ol0000V00;oK@0006h0
0olV0003o`0002D000?o00009@000ol0000T00?oK`0007400_lU00;o9@000ol0000S00;o9@02og80
001c00;o9@000ol0000R0003o`00028000?o00008`02og@0001e00?o8`000ol0000Q0003o`000240
00?o00008@03ogH0001h00;o8P000ol0000P0003o`00020000?o00008002ogT0001j00?o80000ol0
000O0003o`0001l000?o00007P03og/0001m00;o7`02oal000?o00007@02oal00_mn0000O`03oah0
00?o000070000ol0000L0003o`0001`00on00000PP02oad000?o00006`000ol0000K0003o`0001/0
0_n30000Q003oa/000?o00006P000ol0000J0003o`0001T00on50000Q`02oaX00_lJ0003o`0001P0
0_lJ00;oR00008T00_lJ0003o`0001L000?o00005`000ol0000H00;oRP0008/00olH0003o`0001H0
00?o00005P000ol0000F00?oS00008h00_lG0003o`0001D000?o00005@000ol0000E00;oS`000900
0olE0003o`0001@000?o000050000ol0000C00?oT@0009<00_lD00;o50000ol0000B00;o5002oi@0
002E00?o4`000ol0000A0003o`00014000?o00004@03oiH0002H00;o4P000ol0000@0003o`000100
00?o00004002oiT0002J00?o40000ol0000?0003o`0000l000?o00003P03oi/0002M00;o3`02o`l0
00?o00003@02o`l00_nN0000W`02o`l000?o000030000ol0000<0003o`0000d00_nP0000X@03o`d0
00?o00002`000ol0000;0003o`0000/00onR0000Y002o``000?o00002P000ol0000:0003o`0000X0
0_nU0000YP03o`X000?o00002@000ol000090003o`0000P00onW0000Z@02o`T00_l90003o`0000L0
0_l900;oZP000:/00ol80003o`0000H000?o00001P000ol0000600?o[0000:h00_l70003o`0000d0
00?o00001@02ojl0002`00?o1@000ol0000;0003o`0000<00ona0000/`02oa0000?o00000P02ok@0
002e00;o4@02okH000370003o`000;H0002m00Co_`000;h000?o0000_`000;h000?o0000_`000;h0
00?o0000_`000;d01?no0000_P000ol0002o0000_P03okl0003o0840003o0840003o0840003o0840
003o08400000\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17756, -0.625483, 
  0.0113711, 0.00275981}},
  CellTags->"Encapsulation - mutant 9"],

Cell[TextData[{
  "Selective encapsulation 9: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Encapsulation - mutant 10",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$308)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$308)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{384, 236.875},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000600000k0P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0P@000?l0P@000?l0P@000?l0P@000?l0
P@000?l0P@000?l0P@000>P00_l200;oOP05o`l0003Y0004o`00oh0000Go0000o`0>0000j@04oh00
00Go0000o`0>0000j@001?l00?n000Co3`000>X00_n10005o`000?l03P000>T00on000Go3`000?l0
P@000?l0P@000?<000?o0000L@000ol0000F0000m0000ol0001_0003o`0001L0003e0003o`0006d0
00?o000060000?H00_m[00;o6`000?P000?o0000I`000ol0000K0000n@000ol0001U0003o`0001`0
003j0003o`0006<000?o00007@000?/00_mQ00;o80000?d000?o0000G@000ol0000P0000oP000ol0
001K0003o`000240003o0003o`0005T000?o00008P000?l00@000ol0001G0003o`0002<0003o0080
0_mE00;o9P000?l010000ol0001A0003o`0002H0003o00D000?o0000C`000ol0000W0000o`060003
o`0004d000?o0000:0000?l01`02od/00_l[0000o`090003o`0004L000?o0000:`000?l02P000ol0
00150003o`0002`0003o00/000?o0000@`000ol0000]0000o`0<0003o`00044000?o0000;P000?l0
3@02ocl00_la0000o`0?0003o`0003/000?o0000<@000?l040000ol0000i0003o`000380003o0140
00?o0000=`000ol0000c0000o`0B00;o=@02ocH0003o01@000?o0000<@000ol0000f0000o`0E0003
o`0002l000?o0000=`000?l05P000ol0000]0003o`0003P0003o01L000?o0000:`000ol0000i0000
o`0H00;o:@02oc`0003o01X000?o00009@000ol0000l0000o`0K0003o`0002<000?o0000?@000?l0
70000ol0000Q0003o`0003h0003o01d00_lO00;o@@000?l07`000ol0000K0003o`000440003o0200
00?o00006@000ol000120000o`0Q0003o`0001L000?o0000@`000?l08P000ol0000E0003o`0004@0
003o02<00_lC00;oA`000?l09@000ol0000?0003o`0004L0003o02H000?o00003@000ol000180000
o`0W0003o`0000/000?o0000B@000?l0P@000?l0;003oe80003o02l000?o0000C`000?l0;004oe40
003o02/000Go0000o`1A0000o`0[0005o`000?l0D@000?l0:`001Ol0003o0540003o02`01Om@0000
o`210000o`210000o`210000o`210000o`210000o`210000o`210000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500
003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0
;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003
o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000
D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000
o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h0
00?o0000D0000?l0;P000ol0001@0000o`0^0003o`000500003o02h000?o0000D0000?l0;P000ol0
001@0000o`210000o`210000o`210000o`210000o`210000o`0/00?oDP000?l0;`000ol0001?0000
m`06o`/01Ol<00Go3@04oe40003h0003o`0000h000Go0000o`0<0005o`000?l02`001Ol0003o0540
003h0003o`0000h000Go0000o`0<0005o`000?l02`001Ol0003o0540003h00Co3@001Ol0003o00`0
1?l<0005o`000?l0D@000?P000?o00003P001Ol0003o00`000Go0000o`0<00GoD0000?L01_l;00Go
3005of80003o0840003o0840003o0840003o0840003n0003o`0007l0003n0003o`0000/000?o0000
30000ol0000;0003o`0005@0003o0003o`0000/000?o00002`000ol0000;0003o`0005@0003o0003
o`0000/000?o00002P000ol0000;0003o`0005D0003o004000?o00002P000ol0000:0003o`0000/0
00?o0000E@000?l00@000ol0000:0003o`0000X000?o00002P000ol0001F0000o`020003o`0000T0
00?o00002P000ol0000:0003o`0005H0003o008000?o00002@000ol0000:0003o`0000T000?o0000
E`000?l00P000ol0000:0003o`0000T000?o00002@000ol0001G0000o`030003o`0000T000?o0000
2@000ol000080003o`0005P0003o00<000?o00002@000ol000080003o`0000T000?o0000F0000?l0
10000ol000080003o`0000P000?o000020000ol0001I0000o`040003o`0000P000?o000020000ol0
00080003o`0005T0003o00D000?o00001`000ol000080003o`0000P000?o0000F@000?l01@000ol0
00080003o`0000L000?o00001`000ol0001J0000o`060003o`0000L000?o00001`000ol000070003
o`0005X0003o00H000?o00001`000ol000070003o`0000H000?o0000F`000?l01`000ol000060003
o`0000H000?o00001`000ol0001K0000o`070003o`0000H000?o00001P000ol000060003o`0005`0
003o00P000?o00001@000ol000060003o`0000H000?o0000G0000?l020000ol000060003o`0000D0
00?o00001@000ol0001M0000o`090003o`0000D000?o00001@000ol000050003o`0005d0003o00T0
00?o00001@000ol000050003o`0000@000?o0000GP000?l02P000ol000040003o`0000@000?o0000
1@000ol0001N0000o`0:0003o`0000@000?o000010000ol000040003o`0005l0003o00/000?o0000
0`000ol000040003o`0000@000?o0000G`000?l02`000ol000040003o`0000<000?o00000`000ol0
001P0000o`0<0003o`0000<000?o00000`000ol000030003o`000600003o00`000?o00000`000ol0
00030003o`0000<000?o0000H0000?l03@000ol000020003o`0000<000?o00000P000ol0001Q0000
o`0=0003o`00008000?o00000P000ol000030003o`000640003o00h000Go0000o`040003o`000080
00?o0000HP000?l03P000ol000020005o`000?l010000ol0001R0000o`0?0005o`000?l00`001Ol0
003o06D0003o00l000Go0000o`030005o`000?l0I@000?l03`001Ol0003o00<000Co003oIP000?l0
40001?l00?l30004o`00ofH0003o010000Co003o0P001?l00?mW0000o`0A0003o`0000D000?o0000
I@000?l0P@000?l0P@000?l0P@0005P00ooo02H0001K0005o`000?l0o`0Q00003002o`800_m600Co
0P04o`800ol400?o0`03odH01OmC00;o00<0ool0D@04oa@0000=0004o`00odH000Go0000o`020004
o`00o`D000Co003o0`000ol0o`030003o`0004@000Go0000o`1B0004o`00oe<000?o0000500000d0
1?m60005o`000?l01002o`D000Co003o0`000ol0o`030003o`0004@000Go0000o`1B0004o`00oe@0
00?o00004`0000d000Co003oAP001Ol0003o00800_l500;o0`001Ol0003o00800om70005o`000?l0
DP001?l00?mE0003o`000180000>00;oB005o`050?l00?l01@001?l00?l30003o`3o00<000?o0000
A0001Ol0003o05801?mE0003o`000180000=00?o2003od<01?l200?o1003o`<00om600GoD`000ol0
001:00?o1P03oaD0000K00Co@@000ol0002^00;oB@03ob40000O00?oC002oi/000?o0000BP04ob@0
000R00?oB`000ol0002G0003o`0004P00olX00009@03odT00_nE00;oB003ob/0000X00?oB002oi40
0_m700?o;P0002/01?m60003o`0008d000?o0000A003oc40000_00?oA002odD000?o0000@`02od<0
1?ld0000<P03od<00_m30003o`0004400_m200?o>00003D00om20003o`00040000?o0000@0000ol0
000o00?o>`0003P01?lo00;o@0000ol0000n00;o?`03och0000l00?o?P000ol0000m0003o`0003d0
00?o0000?003od40000o00?o?002ocd000?o0000>`02oc/01?m40000@P03oc/00_lk0003o`0003T0
0_lj00?oB00004D00olj0003o`0003P000?o0000>0000ol0000g00?oB`0004P01?lg00;o>0000ol0
000f00;o=`03odh0001<00?o=P000ol0000e0003o`0003D000?o0000=003oe40001?00?o=002ocD0
00?o0000<`02oc<01?mD0000DP03oc<00_lc0003o`0003400_lb00?oF00005D01?la0003o`000300
00?o0000<0000ol0000_00?oF`0005T00ol_00;o<0000ol0000^00;o;`03oeh0001L00?o;P000ol0
000]0003o`0002d000?o0000;003of40001O00?o;002obd000?o0000:`02ob/01?mT0000HP03ob/0
0_l[0003o`0002T00_lZ00?oJ00006D01?lY0003o`0002P000?o0000:0000ol0000W00?oJ`0006T0
0olW00;o:0000ol0000V00;o9`03ofh0001/00?o9P02obH000?o00009002obD01?ma0000K`03obD0
00?o00008`000ol0000S0003o`0002800ome0000LP04ob800_lS0003o`0002400_lR00?oN00007H0
0olQ0003o`00020000?o000080000ol0000O00?oN`0007T00olO00;o80000ol0000N00;o7`03ogh0
001l00?o7P02oah000?o00007002oad01?n10000O`03oad000?o00006`000ol0000K0003o`0001X0
0on50000PP04oaX00_lK0003o`0001T00_lJ00?oR00008H00olI0003o`0001P000?o000060000ol0
000G00?oR`0008T00olG00;o60000ol0000F00;o5`03ohh0002<00?o5P02oaH000?o00005002oaD0
1?nA0000S`04oa@000?o00004`000ol0000C0003o`0001800onE0000T`03oa800_lC0003o`000140
0_lB00?oV00009H00olA0003o`00010000?o000040000ol0000?00?oV`0009T00ol?00;o40000ol0
000>00;o3`03oih0002L00?o3P02o`h000?o00003002o`d01?nQ0000W`04o``000?o00002`000ol0
000;0003o`0000X00onU0000X`03o`X00_l;0003o`0000T00_l:00?oZ0000:H00ol900;o4`02o`T0
0on[0000Z@03o`P000?o00003`000ol0000600?o[P000:`01?l500;o3@02o`D01?na0000/003oaD0
0one0000/`02oa000onh0000^`04ol40002l0003o`000<40002l0003o`000<40002l0003o`000<40
002k00Co`@000;`000?o0000`@000;`00oo10000o`210000o`210000o`210000o`210000o`210000
\
\>"],
  ImageRangeCache->{{{0, 383}, {235.875, 0}} -> {-2.17984, -0.833976, 
  0.0115171, 0.00367975}},
  CellTags->"Encapsulation - mutant 10"],

Cell[TextData[{
  "Selective encapsulation 10: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Encapsulation - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Encapsulation - mutant 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pattern extraction", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Pattern extraction - Intro"],

Cell[CellGroupData[{

Cell["Introduction: Pattern extraction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Basic expression", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["theExpr = f[a, g[b, h[d]], i[e]];", "InputDemo",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Depth[theExpr]", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
4\
\>", "\<\
4\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 0:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 0]", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{f[a, g[b, h[d]], i[e]], {}, {}, {}}\
\>", 
"\<\
{f[a, g[b, h[d]], i[e]], {}, {}, {}}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 1:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 1] // ColumnForm", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
f$16[x1_Symbol, x2_g, x3_i] :> f[x1, x2, x3]
f$16[a, g[b, h[d]], i[e]]\
\>", 
"\<\
f$16[x1_Symbol, x2_g, x3_i] :> f[x1, x2, x3]
f$16[a, g[b, h[d]], i[e]]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 2:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 2] // ColumnForm", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
f$18[x1_Symbol, x2_h, x3_Symbol] :> f[a, g[x1, x2], i[x3]]
f$18[b, h[d], e]\
\>", 
"\<\
f$18[x1_Symbol, x2_h, x3_Symbol] :> f[a, g[x1, x2], i[x3]]
f$18[b, h[d], e]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 3:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 3] // ColumnForm", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
f$20[x1_Symbol] :> f[a, g[b, h[x1]], i[e]]
f$20[d]\
\>", "\<\
f$20[x1_Symbol] :> f[a, g[b, h[x1]], i[e]]
f$20[d]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 4:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 4] // ColumnForm", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
f$22[] :> f[a, g[b, h[d]], i[e]]
f$22[]\
\>", "\<\
f$22[] :> f[a, g[b, h[d]], i[e]]
f$22[]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 5:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 5] // ColumnForm", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
f$24[] :> f[a, g[b, h[d]], i[e]]
f$24[]\
\>", "\<\
f$24[] :> f[a, g[b, h[d]], i[e]]
f$24[]\
\>"], "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .12963 .30902 0 0 Mshowa
P
.004 w
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .30902 0 0 Mshowa
P
1 g
.04 w
.20018 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .20018 .16187 0 0 Mshowa
P
1 g
.05 w
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .48236 .30902 0 0 Mshowa
P
1 g
.52939 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52939 .30902 0 0 Mshowa
P
1 g
.57643 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .57643 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.004 w
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .27072 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
.9 g
.62346 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .16187 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{416, 256.625},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006P000100P10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0X@000?l0X@000?l0X@000?l0X@000?l0
X@000?l0X@000?l0X@000?l0X@0007000_l200;oo`0F00Go4000074000Co003oo`0H0005o`000?l0
3`0007401?oo01P000Go0000o`0?0000L@001?l00?oo01P01?l@0000LP02ool06@001Ol0003o00l0
001a00?oo`0H00Go400007d00_oo00D00_lK0000O`02ool00@02oad0002100?onP03oal0002400;o
mP02ob80002600;olP02ob@0002800?ok003obH0002;00;oj002obT0002=00;oh`03ob/0002?00?o
gP02obh0002B00;ofP02oc00002D00?oe003oc80002G00;od002ocD0002I00;ob`03ocL0002K00?o
aP02ocX0002N00;o`@03oc`0002P00?o_002ocl0002S00;o^002od40002U00;o/`03od<0002W00?o
[P02odH0002Z00;oZ@03odP0002/00?oY002od/0002_00;oX002odd0002a00;oV`03odl0002c00?o
UP02oe80002f00;oT@03oe@0002h00?oS002oeL0002k00;oR002oeT0002m00;oP`03oe/0002o00?o
OP02oeh0003200;oN@03of00003400;oM@02of<0003600?oL002ofD0003900;oJ`03ofL0003;00?o
IP02ofX0003>00;oH@03of`0003@00;oG@02ofl0003B00?oF002og40003E00;oD`03og<0003G00?o
CP02ogH0003J00;oB@03ogP0003L00;oA@02og/0003N00?o?`03ogd0003Q00;o>`02oh00003S00?o
=P02oh80003V00;o<@03oh@0003X00;o5006eQ<00_n70000jP03o`l02]H>00?oR@000>d00_l;00kF
2P02oh`0003_00;o200@ePL00_n>0000l@03o`D04=H400?oT0000?@00_l201;F00<0ool0T`000?H0
0_l6eP?o2MH00ol0002C0000m`0:eP03omKF00OFU@0005L00onM00OF1?l9eYD0001H0003o`0009`0
1]H01OoFe]Ko00WFU@0005D01OnM00KF00Goe]KFo`09eYD0001F0003o`3o09h01]H01OoFe]Ko00WF
U@0005H000?o0?l0WP07ePGo2=JE0000E`02oil04]JF0000n00BeYH0003i013FU`000?T04=JG0000
nP0>eYP0001G0003o`000:802]JJ0000E`000ol0002T00KFW00005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005L000?o0000YP000ol0002M0000
E`000ol0002V0003o`0009d0001G0003o`000:H000?o0000W@0005@01]JT00KFW00005802]JP00[F
VP0005003]JL00kFV00004l04=JJ013FU`0004l04=JJ013FU`0004h04]JH01;FUP0004h01mH3o`SF
V006eP?o2MJF0000C@0;eP03omKF00KFUP0:eP03omKF00OFU@0003P01Ol@00SF1?l8eQ000omA00Ko
3@05o`h01Ol700OF1?l9eYD0000i0005o`000?l03`07eP05omKFe_l02=HC0003o`0004l000?o0000
40001Ol0003o00h000Go0000o`0600KF00Goe]KFo`09eYD0000i0005o`000?l03`07eP05omKFe_l0
2=HC0003o`0004l000?o000040001Ol0003o00h000Go0000o`0600KF00Goe]KFo`09eYD0000i00Co
4007eP05omKFe_l02=HA00;oDP04o`l000Go0000o`0>00Co1`06eP05omKFe_l02MJE0000>@001Ol0
003o00l02=H5o`OF4`000ol0001?0003o`00010000Go0000o`0>0005o`000?l01P07ePGo2=JE0000
>005oa404]HA00?oD@06o`d01Ol>00Go200BeYH0001>01;FV00BeYH0001?013FVP0@eYL0001?013F
VP0@eYL0001@00kFW00>eYP0001B00[FX00:eYX0000o0003o`0001801]HE0003o`0005X000?o0000
;@000ol0eP05eY`000100003o`0001@000?o000050000ol0001L0003o`0000`000?o00003@000ol0
000<0003o`000:8000100003o`0001@000?o000050000ol0001L0003o`0000d000?o000030000ol0
000<0003o`000:8000100003o`0001@000?o000050000ol0001L0003o`0000d000?o000030000ol0
000<0003o`000:8000110003o`0001<000?o00004`000ol0001N0003o`0000`000?o000030000ol0
000;0003o`000:<000110003o`0001<000?o00004`000ol0001N0003o`0000`000?o000030000ol0
000;0003o`000:<000120003o`00018000?o00004P000ol0001P0003o`0000/000?o000030000ol0
000:0003o`000:@000120003o`00018000?o00004P000ol0001P0003o`0000/000?o00002`000ol0
000;0003o`000:@000130003o`00014000?o00004@000ol0001R0003o`0000/000?o00002P000ol0
000:0003o`000:D000130003o`00014000?o00004@000ol0001R0003o`0000/000?o00002P000ol0
000:0003o`000:D000140003o`00010000?o000040000ol0001T0003o`0000X000?o00002P000ol0
00090003o`000:H000140003o`00010000?o000040000ol0001T0003o`0000X000?o00002P000ol0
00090003o`000:H000150003o`0000l000?o00003`000ol0001V0003o`0000T000?o00002P000ol0
00080003o`000:L000150003o`0000l000?o00003`000ol0001V0003o`0000T000?o00002@000ol0
00090003o`000:L000160003o`0000h000?o00003P000ol0001X0003o`0000P000?o00002@000ol0
00080003o`000:P000160003o`0000h000?o00003P000ol0001X0003o`0000T000?o000020000ol0
00080003o`000:P000170003o`0000d000?o00003@000ol0001Z0003o`0000P000?o000020000ol0
00070003o`000:T000170003o`0000d000?o00003@000ol0001Z0003o`0000P000?o000020000ol0
00070003o`000:T000180003o`0000`000?o000030000ol0001/0003o`0000L000?o000020000ol0
00060003o`000:X000180003o`0000`000?o000030000ol0001/0003o`0000L000?o00001`000ol0
00070003o`000:X000190003o`0000/000?o00002`000ol0001^0003o`0000H000?o00001`000ol0
00060003o`000:/000190003o`0000/000?o00002`000ol0001^0003o`0000L000?o00001P000ol0
00060003o`000:/000190003o`0000/000?o00002`000ol0001^0003o`0000L000?o00001P000ol0
00060003o`000:/0001:0003o`0000X000?o00002P000ol0001`0003o`0000H000?o00001P000ol0
00050003o`000:`0001:0003o`0000X000?o00002P000ol0001`0003o`0000H000?o00001@000ol0
00060003o`000:`0001;0003o`0000T000?o00002@000ol0001b0003o`0000D000?o00001@000ol0
00050003o`000:d0001;0003o`0000T000?o00002@000ol0001b0003o`0000D000?o00001@000ol0
00050003o`000:d0001<0003o`0000P000?o000020000ol0001d0003o`0000@000?o00001@000ol0
00040003o`000:h0001<0003o`0000P000?o000020000ol0001d0003o`0000D000?o000010000ol0
00040003o`000:h0001=0003o`0000L000?o00001`000ol0001f0003o`0000@000?o000010000ol0
00030003o`000:l0001=0003o`0000L000?o00001`000ol0001f0003o`0000@000?o00000`000ol0
00040003o`000:l0001>0003o`0000H000?o00001P000ol0001h0003o`0000<000?o00000`000ol0
00030003o`000;00001>0003o`0000H000?o00001P000ol0001h0003o`0000<000?o00000`000ol0
00030003o`000;00001?0003o`0000D000?o00001@000ol0001j0003o`00008000?o00000`000ol0
00020003o`000;40001?0003o`0000D000?o00001@000ol0001j0003o`00008000?o00000`000ol0
00020003o`000;40001@0003o`0000@000?o000010000ol0001l0003o`00008000?o00000P001Ol0
003o0;@0001@0003o`0000@000?o000010000ol0001l0003o`00008000Go0000o`040003o`000;80
001A0003o`0000<000?o00000`000ol0001n0005o`000?l00`001Ol0003o0;D0001A0003o`0000<0
00?o00000`000ol0001n0005o`000?l00`001Ol0003o0;D0001B0003o`00008000?o00000P000ol0
00200004o`00o`<000Co003o]P00058000?o0=H01MH20003o`00080000?o00001]H00`3o002e0000
DP0:eP03o`00080000?oe]H02=Jf0000D00>eX003]Jd0000C`0@eWh04=Jc0000C`0@eWh04=Jc0000
CP0BeW`04]Jb0000CP07eP?o2=Il01;F/P0004d02mH00ooFeP06eWX05=Ja00003@02o`800_lj00SF
1?l8eSX01Olk00OF0_l00mKoo`08eSX01?mc00003P001?l00?lk00OF00Goe]KFo`08eS/000Go0000
o`0j00OF00Coe]Ko2MHk0003o`0007<0000>00Co>`07eP05omKFe_l02=Hk0005o`000?l0>P07eP04
omKFo`WF?0000ol0001b00003P001?l00?lk00OF00Goe]KFo`08eS/000Go0000o`0j00OF00Coe]Ko
2MHm0003o`000740000?00;o?008ePGo1mHk0005o`000?l0>P07ePCo2MHm0003o`000740000>00?o
?@0BeS/01Oll00KF00?oe]H02MHk00?oM00001X00_lb01;FO005eP;o2mHb00;oOP0001`00_la013F
OP0@eS400_n000007P03obh04=H00ol0001j0003omKF00kF;P03oh80000Q00;o;@0>eP8000?o0000
N0000ol0000>eRd00_n500008`03ob`02]H50003o`0007H000?o00000`0:eR`00on700009P02ob`0
1]H800;oM@000ol0000600KF;002ohX0000X00?o>@000ol0000g0003o`0003H00_lh00?oS00002/0
0_lh0003o`0003H000?o0000=@000ol0000f00;oS`0002d00olf0003o`0003D000?o0000=0000ol0
000e00;oT@0003000_le00;o=@000ol0000c0003o`0003<00onC0000<P03oc@000?o0000<P000ol0
000a00;o=002oiH0000e00;o<`000ol0000a0003o`00030000?o0000<@03oiP0000g00;o<P000ol0
000`0003o`0002l000?o0000<002oi/0000i00?o<0000ol0000_0003o`0002h000?o0000;P03oid0
000l00;o;`02obl000?o0000;@000ol0000]00;oX00003h00ol^0003o`0002`000?o0000:`02obh0
0_nR0000@@02obd000?o0000:`000ol0000Z0003o`0002/00onT0000@`03ob/000?o0000:P000ol0
000Y0003o`0002X00_nW0000AP02obX00_lZ0003o`0002P000?o0000:003ojT0001800?o:@000ol0
000W0003o`0002L000?o00009`02oj`0001;00;o:0000ol0000V0003o`0002D00_lW00?o[P0004d0
0_lW0003o`0002D000?o000090000ol0000U00;o/@0004l00olU0003o`0002@000?o00008`000ol0
000T00;o/`0005800_lT00;o90000ol0000R0003o`0002800one0000E003ob<000?o00008@000ol0
000Q0003o`0002400_nh0000E`02ob8000?o000080000ol0000O00;o8@03okX0001I00?o80000ol0
000O0003o`0001h000?o00007`02okd0001L00;o7`02oal000?o00007@000ol0000M00?o_`0005h0
0olN0003o`0001`000?o000070000ol0000L00;o`P0006400_lM0003o`0001/000?o00006`000ol0
000K00;oa00006<00_lL0003o`0001X000?o00006@02oa/00oo60000I@03oaX000?o00006@000ol0
000H0003o`0001T00_o90000J002oaT00_lI0003o`0001L000?o00005`03ol/0001Z00?o60000ol0
000F0003o`0001H000?o00005P02olh0001]00;o5`000ol0000E0003o`0001D000?o00005003om00
001_00?o5@000ol0000D0003o`0001<00_lE00;od`0007800_lD00;o50000ol0000B0003o`0001<0
0_oE0000M003oa<000?o00004@000ol0000A0003o`0001400ooG0000M`02oa8000?o000040000ol0
000@0003o`0001000_oJ0000N@03oa0000?o00003`000ol0000>00;o4003om`0001l00;o3`000ol0
000>0003o`0000d000?o00003P02oml0001n00;o3P02o`h000?o000030000ol0000<00?oh@000800
0ol=0003o`0000/000?o00002`000ol0000;00;oi00008<00_l<0003o`0000X000?o00002P000ol0
000:00;oiP0008D00ol:0003o`0000T000?o00002002o`X00ooX0000R002o`T00_l90003o`0000L0
00?o00002002on/0002:00?o20000ol0000300KF1P000ol0000600?ok@0008d00_l70003o`0000[F
0`000ol0000500;ol00008l00ol500kF00?o00000`03oo80002B00;o0P0@eP<00_oe0000U002oa3F
00<0ool0m`0009D04]Ki0000U@07ePCo1mKi0000U009eP03omKF00SFn00009@02MH00ooFeP08e_P0
002D00WF00?oe]H02=Kh0000U008ePCo2=Kh0000U009eP03omKF00SFn00009@02MH3o`SFn00009D0
4]Ki0000U@0Be_T0002F013FnP0009H04=Kj0000U`0>e_/0002I00[Fo@000001\
\>"],
  ImageRangeCache->{{{0, 415}, {255.625, 0}} -> {-2.23921, -0.833976, 
  0.0141649, 0.00339544}},
  CellTags->"Pattern extraction - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pattern extraction examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
EncapsulationRules = {};

macroChromos = Join @@ Table[
MacroExtraction[theChromos, SelectionMode -> RANDOM], {10}]

macroChromos // ColumnForm\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$216[A, B]], \
2]]], 
 
  chromo[q[undef], p[f$235[B, g[4], 3, E, D, B, g[g[A, B]]]]], 
 
  chromo[q[undef], p[f$254[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g$273[A, B]], 2]]], 
 
  chromo[q[undef], p[f[A, g$292[4], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f$311[]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$330[g[A, B]], 2]]], 
 
  chromo[q[undef], p[f$349[A, B]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$368[A, B]], 2]]], 
 
  chromo[q[undef], p[f[A, g$387[], D, h[E, D, B, g[g[A, B]]], 2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$216[A, B]], \
2]]], 
 
  chromo[q[undef], p[f$235[B, g[4], 3, E, D, B, g[g[A, B]]]]], 
 
  chromo[q[undef], p[f$254[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 
 
     2]]], chromo[q[undef], p[f[A, g[B, g[4], 3], D, 
 
     h[E, D, B, g$273[A, B]], 2]]], 
 
  chromo[q[undef], p[f[A, g$292[4], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f$311[]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$330[g[A, B]], 2]]], 
 
  chromo[q[undef], p[f$349[A, B]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$368[A, B]], 2]]], 
 
  chromo[q[undef], p[f[A, g$387[], D, h[E, D, B, g[g[A, B]]], 2]]]]\
\>"], 
  "Output",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$216[A, B]], 2]]]
chromo[q[undef], p[f$235[B, g[4], 3, E, D, B, g[g[A, B]]]]]
chromo[q[undef], p[f$254[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$273[A, B]], 2]]]
chromo[q[undef], p[f[A, g$292[4], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f$311[]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$330[g[A, B]], 2]]]
chromo[q[undef], p[f$349[A, B]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$368[A, B]], 2]]]
chromo[q[undef], p[f[A, g$387[], D, h[E, D, B, g[g[A, B]]], 2]]]\
\>", 
"\<\
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$216[A, B]], 2]]]
chromo[q[undef], p[f$235[B, g[4], 3, E, D, B, g[g[A, B]]]]]
chromo[q[undef], p[f$254[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$273[A, B]], 2]]]
chromo[q[undef], p[f[A, g$292[4], D, h[E, D, B, g[g[A, B]]], 2]]]
chromo[q[undef], p[f$311[]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$330[g[A, B]], 2]]]
chromo[q[undef], p[f$349[A, B]]]
chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g$368[A, B]], 2]]]
chromo[q[undef], p[f[A, g$387[], D, h[E, D, B, g[g[A, B]]], 2]]]\
\>"], 
  "Output",
  Evaluatable->False,
  LineSpacing->{1, 0},
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Encapsulation / decapsulation rules", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["EncapsulationRules", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
{g$196[] :> g[g[A, B]], g$216[x1_, x2_] :> g[g[x1, x2]], 
 
  f$235[x1_, x2_g, x3_Integer, x4_, x5_, x6_, x7_g] :> 
 
   f[A, g[x6, x2, x3], D, h[x4, x5, B, x7], 2], 
 
  f$254[x1_, x2_g, x3_, x4_h, x5_Integer] :> f[x1, x2, x3, x4, x5], 
 
  g$273[x1_, x2_] :> g[g[x1, x2]], g$292[x1_Integer] :> g[B, g[x1], 3], 
 
  f$311[] :> f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2], 
 
  h$330[x1_g] :> h[E, D, B, g[x1]], 
 
  f$349[x1_, x2_] :> f[A, g[B, g[4], 3], D, h[E, D, B, g[g[x1, x2]]], 2], 
 
  g$368[x1_, x2_] :> g[g[x1, x2]], g$387[] :> g[B, g[4], 3]}\
\>", 
"\<\
{g$196[] :> g[g[A, B]], g$216[x1_, x2_] :> g[g[x1, x2]], 
 
  f$235[x1_, x2_g, x3_Integer, x4_, x5_, x6_, x7_g] :> 
 
   f[A, g[x6, x2, x3], D, h[x4, x5, B, x7], 2], 
 
  f$254[x1_, x2_g, x3_, x4_h, x5_Integer] :> f[x1, x2, x3, x4, x5], 
 
  g$273[x1_, x2_] :> g[g[x1, x2]], g$292[x1_Integer] :> g[B, g[x1], 3], 
 
  f$311[] :> f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2], 
 
  h$330[x1_g] :> h[E, D, B, g[x1]], 
 
  f$349[x1_, x2_] :> f[A, g[B, g[4], 3], D, h[E, D, B, g[g[x1, x2]]], 2], 
 
  g$368[x1_, x2_] :> g[g[x1, x2]], g$387[] :> g[B, g[4], 3]}\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> True,
            LabelSize -> 0.05, LabelColor -> 1
]& /@ macroChromos;\
\>", "InputDemo",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .74459 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .86966 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$216)] .80712 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
0 w
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Mshowa
P
0 w
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Mshowa
P
1 g
.2619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Mshowa
P
1 g
.33093 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Mshowa
P
1 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Mshowa
P
0 w
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Mshowa
P
1 g
.71509 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Mshowa
P
1 g
.7611 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Mshowa
P
0 w
.80712 .21092 m
.74459 .01472 L
s
.80712 .21092 m
.86966 .01472 L
s
1 g
.05 w
.74459 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .74459 .01472 0 0 Mshowa
P
1 g
.86966 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .86966 .01472 0 0 Mshowa
P
1 g
.80712 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$216)] .80712 .21092 0 0 Mshowa
P
1 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
1 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T00006/00onc00;o0P02obX01Oli0000K0000ol0002c0004o`00ob`0
00Go0000o`0h0000J@05ok@01?l/0005o`000?l0>00006X000?o0?l0]@001?l00?l/00Co>@0006X0
00?o0?l0]P02obd000Go0000o`0h0000J`02okD00ol/00Go>@000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T00006/000?o0000^@000ol0000W0003o`0003/0001[0003o`000;T000?o0000
9`000ol0000k0000J`000ol0002j0003o`0002D000?o0000?00006/000?o0000^P000ol0000U0003
o`0003`0001[0003o`000;X000?o00009@000ol0000l0000J`000ol0002k0003o`0002<000?o0000
?@0006/000?o0000^`000ol0000S0003o`0003d0001[0003o`000;/000?o00008`000ol0000m0000
J`000ol0002l0003o`00024000?o0000?P0006/000?o0000_0000ol0000Q0003o`0003h0001[0003
o`000;`000?o00008@000ol0000n0000J`000ol0002m0003o`0001l000?o0000?`0006/000?o0000
_@000ol0000O0003o`0003l0001[0003o`000;d000?o00007`000ol0000o0000J`000ol0002n0003
o`0001d000?o0000@00006/000?o0000_P000ol0000M0003o`000400001[0003o`000;h000?o0000
7@000ol000100000J`000ol0002n0003o`0001d000?o0000@00006/000?o0000_`000ol0000K0003
o`000440001[0003o`000;l000?o00006`000ol000110000J`000ol0002o0003o`0001/000?o0000
@@0006/000?o0000`0000ol0000I0003o`000480001[0003o`000<0000?o00006@000ol000120000
J`000ol000300003o`0001T000?o0000@P0006/000?o0000`@000ol0000G0003o`0004<0001[0003
o`000<4000?o00005`000ol000130000J`000ol000310003o`0001L000?o0000@`0006/000?o0000
`P000ol0000E0003o`0004@0001[0003o`000<8000?o00005@000ol000140000J`000ol000320003
o`0001D000?o0000A00006/000?o0000``000ol0000C0003o`0004D0001[0003o`000<<000?o0000
4`000ol000150000J`000ol000330003o`0001<000?o0000A@0006/000?o0000a0000ol0000A0003
o`0004H0001[0003o`000<@000?o00004@000ol000160000J`000ol000340003o`00014000?o0000
AP0006/000?o0000a@000ol0000?0003o`0004L0001[0003o`000<D000?o00003`000ol000170000
J`000ol000350003o`0000l000?o0000A`0006/000?o0000aP000ol0000=0003o`0004P0001[0003
o`000<H000?o00003@000ol000180000J`000ol000360003o`0000d000?o0000B00006/000?o0000
aP000ol0000=0003o`0004P0001[0003o`000<L000?o00002`000ol000190000J`000ol000370003
o`0000/000?o0000B@0006/000?o0000a`000ol0000;0003o`0004T0001[0003o`000<P000?o0000
2@000ol0001:0000J`000ol000380003o`0000T000?o0000BP0006/000?o0000b0000ol000090003
o`0004X0001[0003o`000<T000?o00001`000ol0001;0000J`000ol000390003o`0000L000?o0000
B`0006/000?o0000b@000ol000070003o`0004/0001[0003o`000<X000?o00001@000ol0001<0000
J`000ol0003:0003o`0000D000?o0000C00006/000?o0000bP000ol000050003o`0004`0001[0003
o`000</000?o00000`000ol0001=0000o`2@0000o`2@0000o`2@0000o`2@0000o`2@0000J@03ol80
0omN0000K0000ol000320005o`000?l0F@0004h01OlF00Co5`03ogd01_l<00Go3@05o`030?oo00;o
0P04o`801?l300?o0`02odH0001?0005o`000?l050001Ol0003o01X000?o0000N`000ol0000?0005
o`000?l03@001Ol0003o00<000Co003o0P001Ol0003o00H000Go0000o`020003o`0004<0001?0005
o`000?l050001Ol0003o01X000?o0000N`000ol0000?0005o`000?l03@001Ol0003o00<000?o0000
0P02o`@000?o00000`001Ol0003o008000?o0000@`0004l01?lE0005o`000?l06002ogh01?l>0005
o`000?l03@05o`<000?o00000_l70003o`00008000Co00000om60000C`001Ol0003o01D01OlI0003
o`0007/000?o00003`001Ol0003o00d000Co00001_l01@3o003o00D000?o00000P001Ol0003o04P0
001>00Go<@03ogd01_l<00Go3@05o`L01?l200?o1002o`@00om50000o`0g0003o`0005H0003o0900
003o0900003o0900003o0900003o0900001D0003o`0001@000?o00005@000ol000240003o`0000d0
00?o00003@000ol0000<0003o`0005<0001E0003o`0001<000?o000050000ol000260003o`0000`0
00?o00003@000ol0000;0003o`0005@0001E0003o`0001<000?o000050000ol000260003o`0000`0
00?o00003@000ol0000;0003o`0005@0001E0003o`0001<000?o000050000ol000260003o`0000`0
00?o00003@000ol0000;0003o`0005@0001F0003o`00018000?o00004`000ol000280003o`0000`0
00?o00002`000ol0000;0003o`0005D0001F0003o`00018000?o00004`000ol000280003o`0000`0
00?o00002`000ol0000;0003o`0005D0001F0003o`00018000?o00004P000ol0002:0003o`0000/0
00?o00002`000ol0000;0003o`0005D0001G0003o`00014000?o00004P000ol0002:0003o`0000/0
00?o00002`000ol0000:0003o`0005H0001G0003o`00014000?o00004P000ol0002:0003o`0000/0
00?o00002`000ol0000:0003o`0005H0001G0003o`00014000?o00004@000ol0002<0003o`0000X0
00?o00002`000ol0000:0003o`0005H0001H0003o`00010000?o00004@000ol0002<0003o`0000X0
00?o00002`000ol000090003o`0005L0001H0003o`00010000?o00004@000ol0002<0003o`0000X0
00?o00002`000ol000090003o`0005L0001H0003o`00010000?o000040000ol0002>0003o`0000X0
00?o00002@000ol0000:0003o`0005L0001I0003o`0000l000?o000040000ol0002>0003o`0000X0
00?o00002@000ol000090003o`0005P0001I0003o`0000l000?o000040000ol0002>0003o`0000X0
00?o00002@000ol000090003o`0005P0001I0003o`0000l000?o00003`000ol0002@0003o`0000T0
00?o00002@000ol000090003o`0005P0001J0003o`0000h000?o00003`000ol0002@0003o`0000T0
00?o00002@000ol000080003o`0005T0001J0003o`0000h000?o00003`000ol0002@0003o`0000T0
00?o00002@000ol000080003o`0005T0001J0003o`0000h000?o00003P000ol0002B0003o`0000P0
00?o00002@000ol000080003o`0005T0001K0003o`0000d000?o00003P000ol0002B0003o`0000P0
00?o00002@000ol000070003o`0005X0001K0003o`0000d000?o00003P000ol0002B0003o`0000P0
00?o00002@000ol000070003o`0005X0001K0003o`0000d000?o00003@000ol0002D0003o`0000P0
00?o00001`000ol000080003o`0005X0001L0003o`0000`000?o00003@000ol0002D0003o`0000P0
00?o00001`000ol000070003o`0005/0001L0003o`0000`000?o000030000ol0002F0003o`0000L0
00?o00001`000ol000070003o`0005/0001L0003o`0000`000?o000030000ol0002F0003o`0000L0
00?o00001`000ol000070003o`0005/0001M0003o`0000/000?o000030000ol0002F0003o`0000L0
00?o00001`000ol000060003o`0005`0001M0003o`0000/000?o00002`000ol0002H0003o`0000H0
00?o00001`000ol000060003o`0005`0001M0003o`0000/000?o00002`000ol0002H0003o`0000H0
00?o00001`000ol000060003o`0005`0001N0003o`0000X000?o00002`000ol0002H0003o`0000H0
00?o00001`000ol000050003o`0005d0001N0003o`0000X000?o00002P000ol0002J0003o`0000H0
00?o00001@000ol000060003o`0005d0001O0003o`0000T000?o00002P000ol0002J0003o`0000H0
00?o00001@000ol000050003o`0005h0001O0003o`0000T000?o00002P000ol0002J0003o`0000H0
00?o00001@000ol000050003o`0005h0001O0003o`0000T000?o00002@000ol0002L0003o`0000D0
00?o00001@000ol000050003o`0005h0001P0003o`0000P000?o00002@000ol0002L0003o`0000D0
00?o00001@000ol000040003o`0005l0001P0003o`0000P000?o00002@000ol0002L0003o`0000D0
00?o00001@000ol000040003o`0005l0001P0003o`0000P000?o000020000ol0002N0003o`0000@0
00?o00001@000ol000040003o`0005l0001Q0003o`0000L000?o000020000ol0002N0003o`0000@0
00?o00001@000ol000030003o`000600001Q0003o`0000L000?o00001`000ol0002P0003o`0000@0
00?o00000`000ol000040003o`000600001Q0003o`0000L000?o00001`000ol0002P0003o`0000@0
00?o00000`000ol000040003o`000600001R0003o`0000H000?o00001`000ol0002P0003o`0000@0
00?o00000`000ol000030003o`000640001R0003o`0000H000?o00001P000ol0002R0003o`0000<0
00?o00000`000ol000030003o`000640001R0003o`0000H000?o00001P000ol0002R0003o`0000<0
00?o00000`000ol000030003o`000640001S0003o`0000D000?o00001P000ol0002R0003o`0000<0
00?o00000`000ol000020003o`000680001S0003o`0000D000?o00001@000ol0002T0003o`000080
00?o00000`000ol000020003o`000680001S0003o`0000D000?o00001@000ol0002T0003o`000080
00?o00000`000ol000020003o`000680001T0003o`0000@000?o00001@000ol0002T0003o`000080
00?o00000`001Ol0003o06D0001T0003o`0000@000?o000010000ol0002V0003o`00008000Go0000
o`040003o`0006<0001T0003o`0000@000?o000010000ol0002V0003o`00008000Go0000o`040003
o`0006<0001U0003o`0000<000?o000010000ol0002V0003o`00008000Go0000o`030003o`0006@0
001U0003o`0000<000?o00000`000ol0002X0005o`000?l00`001Ol0003o06H0001U0003o`0000<0
00?o00000`000ol0002X0005o`000?l00`001Ol0003o06H0001V0003o`00008000?o00000`000ol0
002X0005o`000?l00`001?l00?mW0000IP000ol000020003o`00008000?o0000ZP001?l00?l30004
o`00ofL0001V0003o`00008000?o00000P000ol0002Z0004o`00o`<000Co003oI`0006L000Go0000
o`030003o`000:`000Ko003o0?l20003o`0006H0001W0005o`000?l00`000ol0002/0006o`00o`3o
0P000ol0001V0000I`001Ol0003o00<000?o0000[0001_l00?l0o`8000?o0000IP000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T00006T00ooo02@0001/0003o`000?l08@0000d00_l200;oEP04oeL0
1OmG00;o00<0ool0EP04oa00000>0004o`00oeH000Go0000o`1H0005o`000?l0EP001?l00?mH0003
o`000100000>00CoEP001Ol0003o05P000Go0000o`1F0004o`00oeT000?o00003`0000h000Co003o
EP001Ol0003o05P000Go0000o`1F0004o`00oeX000?o00003P0000l00_mH00GoE`001Ol0003o05H0
1?mJ0003o`0000h0000>00?o/`05oeL000?o0000F003oa40000J00;oo`0400;oD@03oaX0000L00;o
o`1C00;o7@0001h00omB0003o`000:@000?o0000D003oal0000Q00;oD@000ol0002R0003o`0004l0
0_lR00008`03odl000?o0000X0000ol0001=00?o900002H00_m>00;oWP02odh00_lW0000:003odd0
00?o0000C0000ol0001;0003o`0004`00_lY0000:`02od`000?o0000B`000ol0001:0003o`0004X0
0ol[0000;@03odX000?o0000BP000ol000190003o`0004T00_l^0000<002odT00_m:0003o`0004P0
00?o0000A`03oc00000b00;oB@000ol000170003o`0004H00_m800;o<`0003@00om70003o`0004H0
00?o0000A@000ol0001500?o=@0003L00_m60003o`0004D000?o0000A0000ol0001400;o>00003T0
0om40003o`0004@000?o0000@`000ol0001300;o>P0003`00_m300;oA0000ol000120003o`000440
0oll0000?P03od8000?o0000@@000ol0001000;o@P02ocl0001100;o@@000ol000100003o`0003l0
00?o0000?`03od40001300;o@0000ol0000o0003o`0003h000?o0000?P02od@0001500?o?P02ocl0
00?o0000?@000ol0000l00?oAP0004P00_ln0003o`0003`000?o0000>`02ocd00_m90000BP03oc`0
00?o0000>`000ol0000j0003o`0003/00_m;0000C@02oc/000?o0000>P000ol0000i0003o`0003T0
0om=0000C`03ocT00_lj0003o`0003P000?o0000>002oe00001B00;o>@000ol0000g0003o`0003L0
00?o0000=P03oe80001D00?o=`000ol0000f0003o`0003D00_lg00;oE@0005L00_lf0003o`0003D0
00?o0000=0000ol0000d00?oE`0005T00_le0003o`0003@000?o0000<`000ol0000c00;oFP0005/0
0olc00;o=0000ol0000b0003o`0003800_mL0000GP02oc<000?o0000<@000ol0000a0003o`000300
0omN0000H003oc4000?o0000<0000ol0000_00;o<@02of40001S00;o<0000ol0000_0003o`0002h0
00?o0000;P03of<0001U00?o;P02obl000?o0000;@000ol0000]00;oIP0006P00_l^0003o`0002`0
00?o0000;0000ol0000[00?oJ00006X00ol/0003o`0002/000?o0000:P02ob`00_m[0000K@02ob/0
00?o0000:P000ol0000Y0003o`0002X00_m]0000K`02obX000?o0000:@000ol0000X0003o`0002P0
0om_0000L@03obP00_lY0003o`0002L000?o00009`02og80001d00;o:0000ol0000V0003o`0002H0
00?o00009@03og@0001f00?o9P000ol0000U0003o`0002@00_lV00;oM`0007T00_lU0003o`0002@0
00?o00008`000ol0000S00?oN@0007/00olS00;o90000ol0000R0003o`0002800_ml0000OP02ob<0
00?o00008@000ol0000Q0003o`0002400_mn0000P002ob8000?o000080000ol0000P0003o`0001l0
0on00000PP03ob0000?o00007`000ol0000N00;o8002oh<0002500;o7`000ol0000N0003o`0001d0
00?o00007@03ohD0002700?o7@02oah000?o000070000ol0000L00;oR00008X00_lM0003o`0001/0
00?o00006`000ol0000J00?oRP0008`00olK0003o`0001X000?o00006P000ol0000I00;oS@0008l0
0_lJ0003o`0001T000?o00006002oaX00_n?0000T@03oaP00_lI0003o`0001L000?o00005`03oi40
002D00;o60000ol0000F0003o`0001H000?o00005P02oi@0002F00;o5`000ol0000E0003o`0001D0
00?o00005003oiH0002H00?o5@000ol0000D0003o`0001<00_lE00;oV@0009/00_lD00;o50000ol0
000B0003o`0001800onK0000W@03oa<000?o00004@000ol0000A0003o`0001400_nN0000X002oa80
00?o000040000ol0000@0003o`0001000_nP0000XP03oa0000?o00003`000ol0000?0003o`0000h0
0onR0000Y@02o`l000?o00003P000ol0000=00;o3`02ojD0002W00?o3@02o`h000?o000030000ol0
000<00?oY`000:X00_l=0003o`0000/000?o00002`000ol0000;00;oZP000:`00_l<0003o`0000X0
00?o00002P000ol0000900?o[0000:h00ol:0003o`0000T000?o00002@000ol0000800;o[`000;40
0_l900;o2@000ol0000700;o2@02ok40002c00?o20000ol0000?0003o`0000H00onc0000]P02o`L0
00?o00003@000ol0000500;o]P000;P00olC0003o`0000<00onh0000^`02oaD00_nk0000_@000ol0
000?00?o_@000?l0T0000<D01?o60000aP000ol000360000aP000ol000360000aP000ol000360000
a@04olH000360003o`000<H0003600?oaP000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000001
\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.1769, -0.625483, 
  0.0109392, 0.00265499}},
  CellTags->"Pattern extraction - mutant 1"]
}, Open  ]],

Cell[TextData[{
  "Selective pattern extraction 1: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 2",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.400944 0.188567 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .14952 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .14952 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27523 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .40094 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52666 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65237 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .77808 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .57997 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .77808 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f$235)] .40094 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.40094 .60332 m
.02381 .40712 L
s
.40094 .60332 m
.14952 .40712 L
s
.40094 .60332 m
.27523 .40712 L
s
.40094 .60332 m
.40094 .40712 L
s
.40094 .60332 m
.52666 .40712 L
s
.40094 .60332 m
.65237 .40712 L
s
.40094 .60332 m
.77808 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .02381 .40712 0 0 Mshowa
P
0 w
.14952 .40712 m
.14952 .21092 L
s
1 g
.05 w
.14952 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .14952 .40712 0 0 Mshowa
P
1 g
.14952 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .14952 .21092 0 0 Mshowa
P
1 g
.27523 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27523 .40712 0 0 Mshowa
P
1 g
.40094 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .40094 .40712 0 0 Mshowa
P
1 g
.52666 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .52666 .40712 0 0 Mshowa
P
1 g
.65237 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .65237 .40712 0 0 Mshowa
P
0 w
.77808 .40712 m
.77808 .21092 L
s
1 g
.05 w
.77808 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .77808 .40712 0 0 Mshowa
P
0 w
.77808 .21092 m
.57997 .01472 L
s
.77808 .21092 m
.97619 .01472 L
s
1 g
.05 w
.57997 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .57997 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.77808 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .77808 .21092 0 0 Mshowa
P
1 g
.40094 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f$235)] .40094 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000>800_l200;oTP05oa00003S0004o`00oi@000Go0000o`0?0000
h`04oi@000Go0000o`0?0000h`001?l00?nD00Co40000>@00_nE0005o`000?l03`000><00onD00Go
40000?l0T0000?l0T0000?l0T0000>d000?o0000Q@000ol0000G0000kP000ol000230003o`0001P0
003_0003o`00084000?o00006@000?0000?o0000O`000ol0000J0000l@000ol0001m0003o`0001/0
003b0003o`0007/000?o000070000?<000?o0000N@000ol0000M0000m0000ol0001g0003o`0001h0
003e0003o`0007D000?o00007`000?H000?o0000L`000ol0000P0000m`000ol0001a0003o`000240
003h0003o`0006l000?o00008P000?T000?o0000K@000ol0000S0000nP000ol0001[0003o`0002@0
003k0003o`0006T000?o00009@000?`000?o0000I`000ol0000V0000o@000ol0001U0003o`0002L0
003n0003o`0006<000?o0000:0000?l000?o0000H@000ol0000Y0000o`010003o`0005l000?o0000
:P000?l00P000ol0001M0003o`0002/0003o00<000?o0000F`000ol0000/0000o`040003o`0005T0
00?o0000;@000?l01@000ol0001G0003o`0002h0003o00H000?o0000E@000ol0000_0000o`070003
o`0005<000?o0000<0000?l020000ol0001A0003o`000340003o00T000?o0000C`000ol0000b0000
o`0:0003o`0004d000?o0000<`000?l02`000ol0001;0003o`0003@0003o00`000?o0000B@000ol0
000e0000o`0=0003o`0004L000?o0000=P000?l03P000ol000150003o`0003L0003o00l000?o0000
@`000ol0000h0000o`0@0003o`00044000?o0000>@000?l04@000ol0000o0003o`0003X0003o0180
00?o0000?@000ol0000k0000o`0C0003o`0003/000?o0000?0000?l050000ol0000i0003o`0003d0
003o01D000?o0000=`000ol0000n0000o`0F0003o`0003D000?o0000?`000?l05`000ol0000c0003
o`000400003o01P000?o0000<@000ol000110000o`0I0003o`0002l000?o0000@P000?l06P000ol0
000]0003o`0004<0003o01/000?o0000:`000ol000140000o`0L0003o`0002T000?o0000A@000?l0
7@000ol0000W0003o`0004H0003o01h000?o00009@000ol000170000o`0O0003o`0002<000?o0000
B0000?l080000ol0000Q0003o`0004T0003o024000?o00007`000ol0001:0000o`0R0003o`0001d0
00?o0000B`000?l08`000ol0000K0003o`0004`0003o02@000?o00006@000ol0001=0000o`0U0003
o`0001L000?o0000CP000?l09P000ol0000E0003o`0004l0003o02L000?o00004`000ol0001@0000
o`0X0003o`00014000?o0000D@000?l0:@000ol0000?0003o`000580003o02X000?o00003@000ol0
001C0000o`0[0003o`0000/000?o0000E0000?l0T0000?l0T0000?l0<003oed0003o03<000?o0000
FP0004000oo/00CoG000044000?o0000jP001Ol0003o05`0000n00Goj`001Ol0003o05`0000o0003
o`3o0>`000Go0000o`1L0000?`000ol0o`3]00GoF`0004000_oo04h0003o0900003o0900003o0900
003o0900003o0900003o090000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/000100003o`000>h000?o0000F`00040000?o0000kP000ol0001K0000
@0000ol0003^0003o`0005/0003o0900003o0900003o0900003o0900003o0900000n00?okP03oed0
00110003o`000>h000?o0000FP0000d01Ol/00Co;003ob`01_l[00Go:`05ob`01?mL00003P001Ol0
003o02X000Go0000o`0_0003o`0002X000?o0000;P001Ol0003o02/000Go0000o`0Z0005o`000?l0
G00000h000Go0000o`0Z0005o`000?l0;`000ol0000Z0003o`0002h000Go0000o`0[0005o`000?l0
:P001Ol0003o05`0000>00Co:`001Ol0003o02d00_l]00Co;@001Ol0003o02/01?l[0005o`000?l0
G00000h000Go0000o`0[00Go;P000ol0000Z0003o`0002h000Go0000o`0[0005o`000?l0:`05oe/0
000=00GoG003ob`01_l[00Go:`05oh`0000I0003o`000?l03@000ol0001T00006P02ool02`02ofL0
000L0003o`0002T000?o0000[P000ol0000X00;oJ@0001d00_lZ00;o[002obT00_m[00007`02obX0
00?o0000Z0000ol0000X0003o`0006/0000Q00;o:@000ol0000V0003o`0005<000?o00009`000ol0
000W00;oKP0002<00_lX0003o`0002H000?o00009`000ol0000X0003o`0002D00_lX00;oL00002D0
0_lW00;o9`000ol0000V0003o`0002L000?o00009@000ol0000V00;oLP0002L00_lW0003o`0002@0
00?o00009P000ol0000V0003o`0002D000?o00009@02og@0000Y00;o9P000ol0000T0003o`0002D0
00?o00009P000ol0000T0003o`0002@00_mf0000:`02obD00_lU0003o`0002@000?o00009@000ol0
000S00;o9@02ogP0000]00;o9@000ol0000R0003o`0002@000?o00009@000ol0000R0003o`0002<0
0_mj0000;`02ob@000?o00008P000ol0000S0003o`0002@000?o00008P000ol0000R00;oO0000340
0_lS0003o`00028000?o00008P000ol0000S0003o`0002400_lS00;oOP0003<00_lR00;o8P000ol0
000R0003o`0002<000?o000080000ol0000Q00;oP00003D000?o00008@000ol0000P0003o`000240
00?o00008P000ol0000P0003o`0002000_n20000=P02ob8000?o00007`000ol0000Q0003o`000240
00?o00007`02ob400_n40000>002ob400_lP0003o`00020000?o00008@000ol0000N0003o`0001l0
0_n60000>P02ob4000?o00007P000ol0000O0003o`00020000?o00007P000ol0000N00;oR00003`0
0_lP0003o`0001d000?o00007`000ol0000O0003o`0001h000?o00007P000ol000280000?P02oal0
00?o00007@000ol0000N0003o`0001l000?o00007002oal00_n;0000@002oah00_lN0003o`0001d0
00?o00007P000ol0000L0003o`0001d00_n=0000@P02oah000?o00006`000ol0000M0003o`0001d0
00?o000070000ol0000L00;oS`0004@00_lM0003o`0001/000?o000070000ol0000M0003o`0001X0
0_lM00;oT@0004H00_lL0003o`0001/000?o00006`000ol0000L0003o`0001X000?o00006`02oi<0
001800;o6`02oa/000?o00006`000ol0000K0003o`0001X000?o00006P02oiD0001:00;o6`000ol0
000I0003o`0001X000?o00006`000ol0000I0003o`0001T00_nG0000C0000ol0000I0003o`0001T0
00?o00006@000ol0000J0003o`0001P00_lJ00;oV@0004d00_lJ00;o6@000ol0000I0003o`0001T0
00?o000060000ol0000H00;oV`0004l00_lJ0003o`0001L000?o000060000ol0000I0003o`0001L0
00?o00005`02oid0001A00;o6@000ol0000F0003o`0001P000?o000060000ol0000F00;o6002oil0
001C00;o60000ol0000F0003o`0001L000?o00005`000ol0000F0003o`0001H00_nQ0000E@02oaL0
0_lG0003o`0001H000?o00005`000ol0000E0003o`0001D00_nS0000E`02oaL000?o000050000ol0
000F0003o`0001H000?o00005002oaH00_nU0000F@02oaH000?o000050000ol0000E0003o`0001D0
00?o000050000ol0000E0003o`000:D0001K00;o5@02oaD000?o000050000ol0000E0003o`0001<0
00?o00005002ojP0001M00;o5@000ol0000B0003o`0001@000?o000050000ol0000C0003o`0001<0
0_nZ0000G`02oa@000?o00004P000ol0000C0003o`0001@000?o00004@02oa@00_n/0000H@02oa<0
00?o00004P000ol0000B0003o`0001<000?o00004@000ol0000B00;o[P0006<00_lB00;o4P000ol0
000B0003o`00018000?o00004@000ol0000A00;o/00006D000?o00004@000ol0000@0003o`000140
00?o00004P000ol0000?00;o4P02ok80001V00;o4P000ol0000?0003o`00014000?o00004@000ol0
000?0003o`0001000_nd0000J002oa400_l@0003o`00010000?o000040000ol0000?0003o`0000l0
0_nf0000JP02oa4000?o00003P000ol0000?0003o`00010000?o00003P000ol0000>00;o^00006`0
0_l@0003o`0000d000?o00003`000ol0000?0003o`0000d00_l?00;o^P0006h00_l?0003o`0000d0
00?o00003P000ol0000>0003o`0000d000?o00003@02ok`0001`00;o3P02o`h000?o00003@000ol0
000>0003o`0000`000?o00003002okh0001b00;o3P000ol0000;0003o`0000d000?o00003@000ol0
000;00;o3@02ol00001d00;o3@000ol0000;0003o`0000`000?o000030000ol0000;0003o`0000/0
0_o20000MP02o``000?o00002`000ol0000;0003o`0000`000?o00002P000ol0000;0003o`000<80
001h00;o2`02o`/000?o00002`000ol0000;0003o`0000X000?o00002P02olD0001j00;o2`000ol0
00090003o`0000X000?o00002P000ol0000900;o2`02olL0001l0003o`0000T000?o00002@000ol0
00090003o`0000X000?o000020000ol0000900;ob@0007d00_l:00;o2@000ol000090003o`0000T0
00?o000020000ol0000800;ob`0007l00_l:0003o`0000L000?o000020000ol000080003o`0000L0
0_l900;oc@0008400_l90003o`0000H000?o000020000ol000080003o`0000H000?o00001`02oll0
002300;o20000ol000060003o`0000L000?o00001`000ol000060003o`0000H00_oA0000Q@02o`L0
0_l70003o`0000H000?o00001P000ol0000500;o1`02om<0002700;o1`000ol000040003o`0000H0
00?o00001P000ol000040003o`0000D00_oE0000R@02o`H000?o000010000ol000050003o`0000D0
00?o000010000ol0000400;oe`0008/00_l500;o1@000ol000040003o`0000D000?o00000`000ol0
000300;of@0008d00_l50003o`00008000?o000010000ol000040003o`0000800_l400;of`0008l0
0_l40003o`00008000?o00000`000ol000030003o`00008000?o00000P02omd0002A00;o0`000ol0
00020003o`0000P000Go0000o`0300;og`0009<00_l200;o3`02o`<000?o0000g`0009D000Go0000
o`0=0004o`0000;ohP0009H00_lA00;oi0000?l0T00009T000?o0000l`0009801?l200Co0P04o`80
0ol300?ohP0009<000?o00000P001?l00?l30003o`0000D000?o00000`000ol0003O0000T`000ol0
000400;o10000ol000040003o`0000<000?o0000g`0009<000?o00000P02o`L000Co00000_l300?o
hP0009801?l20004o`00o`D000?o00000`001?l00?oT0000T`000ol0000200Co0P03o`<00ol300Co
h@0009<00ol40003o`000?80003o0900003o0900003o0900003o0900003o09000000\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.22336, -0.625483, 
  0.0138124, 0.00265499}},
  CellTags->"Pattern extraction - mutant 2"],

Cell[TextData[{
  "Selective pattern extraction 2: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 3",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f$254)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19073 .30902 0 0 Mshowa
P
0 w
.25889 .30902 m
.25889 .16187 L
s
1 g
.05 w
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .30902 0 0 Mshowa
P
1 g
.25889 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .16187 0 0 Mshowa
P
1 g
.32704 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32704 .30902 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f$254)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?400_l200;oP`05oa00003b0004o`00ohD000Go0000o`0?0000
lP04ohD000Go0000o`0?0000lP001?l00?n500Co40000?<00_n60005o`000?l03`000?800on500Go
40000?l0T0000?l0T0000?`000?o0000MP000ol0000G0000o@000ol0001d0003o`0001P0003n0003
o`00078000?o00006@000?l00_m`00;o70000?l00P000ol0001/0003o`0001`0003o00<000?o0000
JP000ol0000M0000o`040003o`0006P000?o00007P000?l01@02ofL000?o00007`000?l01`000ol0
001R00;o8P000?l020000ol0001P0003o`000280003o00T000?o0000GP000ol0000S0000o`0:00;o
G@000ol0000T0000o`0<0003o`0005T000?o00009@000?l03@000ol0001F00;o:0000?l03P000ol0
001D0003o`0002P0003o00l000?o0000DP000ol0000Y0000o`0@00;oD@000ol0000Z0000o`0B0003
o`0004`00_l]0000o`0C0003o`0004X000?o0000;@000?l050000ol000180003o`0002h0003o01D0
0_m70003o`0002l0003o01L000?o0000@`000ol0000`0000o`0H0003o`0004000_lc0000o`0I0003
o`0003h000?o0000<`000?l06P02ocd000?o0000=0000?l070000ol0000i0003o`0003D0003o01d0
00?o0000=`000ol0000f0000o`0N0003o`0003@00_li0000o`0O00;o<`000ol0000i0000o`0Q0003
o`0002l000?o0000>P000?l08P000ol0000]0003o`0003/0003o02<000?o0000:P02och0003o02@0
00?o0000:0000ol0000n0000o`0U00;o9`000ol0000o0000o`0W0003o`0002<000?o0000@0000?l0
:0000ol0000Q0003o`000440003o02T000?o00007P02od@0003o02X00_lM0003o`0004@0003o02`0
00?o00006@000ol000150000o`0]0003o`0001L000?o0000AP000?l0;P000ol0000E0003o`0004L0
003o02l00_lC00;oBP000?l0<@000ol0000?0003o`0004X0003o038000?o00003@000ol0001;0000
o`2@0000o`2@0000o`0h00?oE@000?l0>`000ol0001B0000JP03olX01?mD0000J`000ol000380005
o`000?l0E00006P01Oo90005o`000?l0E00006T000?o0?l0bP001Ol0003o05@0001Y0003o`3o0</0
1OmC0000JP02ool090000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T00006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0001Z0003o`000<`000?o0000D`0006X000?o0000
c0000ol0001C0000JP000ol0003<0003o`0005<0003o0900003o0900003o0900003o0900003o0900
001X00?oc003oeD0001[0003o`000<`000?o0000DP0004d01OlF00Co5P03og`01_l<00Go3005o`h0
1?mD0000CP001Ol0003o01@000Go0000o`0I0003o`0007X000?o00003`001Ol0003o00`000Go0000
o`0<0005o`000?l0E00004h000Go0000o`0D0005o`000?l06@000ol0001j0003o`0000l000Go0000
o`0<0005o`000?l030001Ol0003o05@0001>00Co5@001Ol0003o01L00_mm00Co3P001Ol0003o00`0
1?l=0005o`000?l0E00004h000Go0000o`0E00Go60000ol0001j0003o`0000l000Go0000o`0<0005
o`000?l03@05oe<0001=00Go<003og`01_l<00Go3005ofH0003o0900003o0900003o0900003o0900
003o0900001D0003o`0002T000?o0000Q@000ol0000Z0003o`0005L0001D0003o`0001<000?o0000
4`000ol000250003o`0000`000?o00002`000ol0000<0003o`0005P0001E0003o`00018000?o0000
4P000ol000270003o`0000`000?o00002P000ol0000<0003o`0005P0001E0003o`00018000?o0000
4P000ol000270003o`0000`000?o00002P000ol0000;0003o`0005T0001F0003o`00014000?o0000
4@000ol000290003o`0000/000?o00002P000ol0000;0003o`0005T0001F0003o`00014000?o0000
4@000ol000290003o`0000/000?o00002P000ol0000:0003o`0005X0001G0003o`00010000?o0000
40000ol0002;0003o`0000X000?o00002P000ol0000:0003o`0005X0001G0003o`00010000?o0000
40000ol0002;0003o`0000X000?o00002P000ol0000:0003o`0005X0001H0003o`0000l000?o0000
3`000ol0002=0003o`0000T000?o00002@000ol0000:0003o`0005/0001H0003o`0000l000?o0000
3`000ol0002=0003o`0000X000?o000020000ol0000:0003o`0005/0001I0003o`0000h000?o0000
3P000ol0002?0003o`0000T000?o000020000ol000090003o`0005`0001I0003o`0000h000?o0000
3P000ol0002?0003o`0000T000?o000020000ol000090003o`0005`0001J0003o`0000d000?o0000
3@000ol0002A0003o`0000P000?o000020000ol000080003o`0005d0001J0003o`0000d000?o0000
3@000ol0002A0003o`0000P000?o000020000ol000080003o`0005d0001J0003o`0000d000?o0000
3@000ol0002A0003o`0000P000?o00001`000ol000080003o`0005h0001K0003o`0000`000?o0000
30000ol0002C0003o`0000L000?o00001`000ol000080003o`0005h0001K0003o`0000`000?o0000
30000ol0002C0003o`0000P000?o00001P000ol000070003o`0005l0001L0003o`0000/000?o0000
2`000ol0002E0003o`0000L000?o00001P000ol000070003o`0005l0001L0003o`0000/000?o0000
2`000ol0002E0003o`0000L000?o00001P000ol000060003o`000600001M0003o`0000X000?o0000
2P000ol0002G0003o`0000H000?o00001P000ol000060003o`000600001M0003o`0000X000?o0000
2P000ol0002G0003o`0000H000?o00001@000ol000060003o`000640001N0003o`0000T000?o0000
2@000ol0002I0003o`0000D000?o00001@000ol000060003o`000640001N0003o`0000T000?o0000
2@000ol0002I0003o`0000D000?o00001@000ol000050003o`000680001O0003o`0000P000?o0000
20000ol0002K0003o`0000D000?o000010000ol000050003o`000680001O0003o`0000P000?o0000
20000ol0002K0003o`0000D000?o000010000ol000040003o`0006<0001P0003o`0000L000?o0000
1`000ol0002M0003o`0000@000?o000010000ol000040003o`0006<0001P0003o`0000L000?o0000
1`000ol0002M0003o`0000@000?o00000`000ol000040003o`0006@0001P0003o`0000L000?o0000
1`000ol0002M0003o`0000@000?o00000`000ol000040003o`0006@0001Q0003o`0000H000?o0000
1P000ol0002O0003o`0000<000?o00000`000ol000030003o`0006D0001Q0003o`0000H000?o0000
1P000ol0002O0003o`0000<000?o00000`000ol000030003o`0006D0001R0003o`0000D000?o0000
1@000ol0002Q0003o`0000<000?o00000P000ol000020003o`0006H0001R0003o`0000D000?o0000
1@000ol0002Q0003o`0000<000?o00000P000ol000020003o`0006H0001S0003o`0000@000?o0000
10000ol0002S0003o`00008000Go0000o`040003o`0006L0001S0003o`0000@000?o000010000ol0
002S0003o`00008000Go0000o`040003o`0006L0001T0003o`0000<000?o00000`000ol0002U0005
o`000?l00`000ol000020003o`0006L0001T0003o`0000<000?o00000`000ol0002U0005o`000?l0
0`001Ol0003o06X0001U0003o`00008000?o00000P000ol0002W0004o`00o`<000Go0000o`1Z0000
I@000ol000020003o`00008000?o0000Y`001Ol0003o008000Co003oJ`0006H000?o00001@000ol0
002Y0003o`0000H000?o0000J@000?l0T0000?l0T0000?l0T0000?l0T00006P00ooo02D0001[0003
o`000?l08P0000d00_l200;oE@04oeD01OmF00;o00<0ool0EP04oa@0000>0004o`00oeD000Go0000
o`1F0005o`000?l0E@001?l00?mH0003o`0001@0000>00CoE@001Ol0003o05H000Go0000o`1E0004
o`00oeT000?o00004`0000h000Co003oE@001Ol0003o05H000Go0000o`1E0004o`00oeX000?o0000
4P0000l00_mG00GoE@001Ol0003o05D01?mJ0003o`000180000>00?o2@02ojD01OmF0003o`0004l0
0_l700?o5@0001`00ool00;oCP03ob40000O00?oD@000ol0002O0003o`0005000olT00008P04odh0
00?o0000W@000ol0001=00Co9`0002H00om<00;oV`02odd00ol[0000:@03od/000?o0000U`000ol0
001:00?o;P0002`00om900;oU@02odX00ola0000;`03odP00_m80003o`0004H00_m900?o=0000380
0om70003o`0004D000?o0000A@000ol0001500Co=`0003D00om500;oA@000ol0001300;oA@03oc/0
000h00Co@`000ol000120003o`00048000?o0000@P03och0000l00?o@@02od8000?o0000@002od80
0om10000?`03od0000?o0000?`000ol0000o0003o`0003l00om40000@P03och00_lo0003o`0003d0
0_lo00?oA`0004D00olm00;o?@000ol0000k00;o?@04odX0001800?o?0000ol0000j0003o`0003X0
00?o0000>P03odh0001;00Co>@02ocX000?o0000>002ocX00omA0000C`03ocP000?o0000=`000ol0
000g0003o`0003L00omD0000DP03ocH00_lg0003o`0003D00_lg00?oE`0005D00ole00;o=@000ol0
000c00;o=P03oeX0001H00?o=0000ol0000b0003o`00038000?o0000<P04oed0001K00?o<P02oc80
00?o0000<002oc800omQ0000GP04oc0000?o0000;`000ol0000_0003o`0002l00omT0000HP03obh0
0_l_0003o`0002d00_l_00?oI`0006D00ol]0003o`0002`000?o0000;0000ol0000/00?oJP0006P0
0ol[00;o;0000ol0000Z00;o:`04ofd0001[00?o:P02obX000?o0000:002obX00oma0000KP03obT0
00?o00009`000ol0000W0003o`0002L00omd0000L@03obL00_lW0003o`0002D00_lW00?oM`0007@0
1?lU0003o`0002@000?o000090000ol0000T00?oNP0007P00olS00;o90000ol0000R00;o9003ogd0
001k00?o8P000ol0000Q0003o`00024000?o00008004oh00001n00?o8002ob4000?o00007`02ob00
0on40000P@03oal00_lO0003o`0001d00_lO00?oQ`0008@00olN0003o`0001`000?o000070000ol0
000L00?oRP0008L01?lK00;o70000ol0000J00;o7003ohd0002;00?o6P000ol0000I0003o`0001T0
00?o00006@03oi00002>00?o6002oaT000?o00005`02oaP01?nC0000T@03oaL00_lG0003o`0001D0
0_lG00?oU`0009@00olF0003o`0001@000?o000050000ol0000D00?oVP0009L00olD00;o50000ol0
000B00;o5003oid0002J00Co4P000ol0000A0003o`00014000?o00004@03oj00002N00?o4002oa40
00?o00003`02oa400onS0000X@03o`l000?o00003P000ol0000>0003o`0000d01?nV0000Y003o`d0
0_l>0003o`0000`00_l=00?oZP000:L00ol<00;o30000ol0000:00;o3003ojd0002Z00?o2`000ol0
000E0003o`0000T00on`0000[@03o`T00_lC00;o2@03ok<0002`00Co1`000ol0000?0003o`0000D0
1?nf0000]003o`D000?o00003@000ol0000300?o^P000;L00olE00?o_@000;X00_l00`3o000>00;o
`0000;H01?l200Co0P04o`800ol500?o_0000;L000?o00000P001?l00?l30003o`0000D000?o0000
0`000ol0002k0000]`000ol0000400;o10000ol000040003o`0000Go_0000;L000?o00000P02o`L0
00?o00000ol40003o`3o0;d0002f00Co0P001?l00?l50004o`00o`H000?o0?l0_@000;L000?o0000
0P04o`800ol300Co1002okd0002g00?o10000ol0003>0000o`2@0000o`2@0000o`2@0000o`2@0000
o`2@0000\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.17917, -0.833976, 
  0.0110797, 0.00353999}},
  CellTags->"Pattern extraction - mutant 3"],

Cell[TextData[{
  "Selective pattern extraction 3: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .74459 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .86966 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$273)] .80712 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
0 w
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Mshowa
P
0 w
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Mshowa
P
1 g
.2619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Mshowa
P
1 g
.33093 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Mshowa
P
1 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Mshowa
P
0 w
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Mshowa
P
1 g
.71509 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Mshowa
P
1 g
.7611 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Mshowa
P
0 w
.80712 .21092 m
.74459 .01472 L
s
.80712 .21092 m
.86966 .01472 L
s
1 g
.05 w
.74459 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .74459 .01472 0 0 Mshowa
P
1 g
.86966 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .86966 .01472 0 0 Mshowa
P
1 g
.80712 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$273)] .80712 .21092 0 0 Mshowa
P
1 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
1 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T00006/00onc00;o0P02obX01Oli0000K0000ol0002c0004o`00ob`0
00Go0000o`0h0000J@05ok@01?l/0005o`000?l0>00006X000?o0?l0]@001?l00?l/00Co>@0006X0
00?o0?l0]P02obd000Go0000o`0h0000J`02okD00ol/00Go>@000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T00006/000?o0000^@000ol0000W0003o`0003/0001[0003o`000;T000?o0000
9`000ol0000k0000J`000ol0002j0003o`0002D000?o0000?00006/000?o0000^P000ol0000U0003
o`0003`0001[0003o`000;X000?o00009@000ol0000l0000J`000ol0002k0003o`0002<000?o0000
?@0006/000?o0000^`000ol0000S0003o`0003d0001[0003o`000;/000?o00008`000ol0000m0000
J`000ol0002l0003o`00024000?o0000?P0006/000?o0000_0000ol0000Q0003o`0003h0001[0003
o`000;`000?o00008@000ol0000n0000J`000ol0002m0003o`0001l000?o0000?`0006/000?o0000
_@000ol0000O0003o`0003l0001[0003o`000;d000?o00007`000ol0000o0000J`000ol0002n0003
o`0001d000?o0000@00006/000?o0000_P000ol0000M0003o`000400001[0003o`000;h000?o0000
7@000ol000100000J`000ol0002n0003o`0001d000?o0000@00006/000?o0000_`000ol0000K0003
o`000440001[0003o`000;l000?o00006`000ol000110000J`000ol0002o0003o`0001/000?o0000
@@0006/000?o0000`0000ol0000I0003o`000480001[0003o`000<0000?o00006@000ol000120000
J`000ol000300003o`0001T000?o0000@P0006/000?o0000`@000ol0000G0003o`0004<0001[0003
o`000<4000?o00005`000ol000130000J`000ol000310003o`0001L000?o0000@`0006/000?o0000
`P000ol0000E0003o`0004@0001[0003o`000<8000?o00005@000ol000140000J`000ol000320003
o`0001D000?o0000A00006/000?o0000``000ol0000C0003o`0004D0001[0003o`000<<000?o0000
4`000ol000150000J`000ol000330003o`0001<000?o0000A@0006/000?o0000a0000ol0000A0003
o`0004H0001[0003o`000<@000?o00004@000ol000160000J`000ol000340003o`00014000?o0000
AP0006/000?o0000a@000ol0000?0003o`0004L0001[0003o`000<D000?o00003`000ol000170000
J`000ol000350003o`0000l000?o0000A`0006/000?o0000aP000ol0000=0003o`0004P0001[0003
o`000<H000?o00003@000ol000180000J`000ol000360003o`0000d000?o0000B00006/000?o0000
aP000ol0000=0003o`0004P0001[0003o`000<L000?o00002`000ol000190000J`000ol000370003
o`0000/000?o0000B@0006/000?o0000a`000ol0000;0003o`0004T0001[0003o`000<P000?o0000
2@000ol0001:0000J`000ol000380003o`0000T000?o0000BP0006/000?o0000b0000ol000090003
o`0004X0001[0003o`000<T000?o00001`000ol0001;0000J`000ol000390003o`0000L000?o0000
B`0006/000?o0000b@000ol000070003o`0004/0001[0003o`000<X000?o00001@000ol0001<0000
J`000ol0003:0003o`0000D000?o0000C00006/000?o0000bP000ol000050003o`0004`0001[0003
o`000</000?o00000`000ol0001=0000o`2@0000o`2@0000o`2@0000o`2@0000o`2@0000J@03ol80
0omN0000K0000ol000320005o`000?l0F@0004h01OlF00Co5`03ogd01_l<00Go3@05o`030?oo00;o
0P04o`801?l30003o`0000800om60000C`001Ol0003o01@000Go0000o`0J0003o`0007/000?o0000
3`001Ol0003o00d000Go0000o`030004o`00o`8000Go0000o`060003o`0000@000?o0000@`0004l0
00Go0000o`0D0005o`000?l06P000ol0001k0003o`0000l000Go0000o`0=0005o`000?l00`000ol0
000200;o10000ol000030003o`0000@000?o0000@`0004l01?lE0005o`000?l06002ogh01?l>0005
o`000?l03@05o`<000?o00000_l70003o`00008000?o00000P02odH0001?0005o`000?l05@05oaT0
00?o0000N`000ol0000?0005o`000?l03@001?l00006o`050?l00?l01@001?l00?l20003o`0000<0
00?o0000@`0004h01Ola00?oO@06o``01Ol=00Go1`04o`800ol300Co0P03odH0003o03L000?o0000
EP000?l0T0000?l0T0000?l0T0000?l0T0000?l0T00005@000?o000050000ol0000E0003o`0008@0
00?o00003@000ol0000=0003o`0000`000?o0000D`0005D000?o00004`000ol0000D0003o`0008H0
00?o000030000ol0000=0003o`0000/000?o0000E00005D000?o00004`000ol0000D0003o`0008H0
00?o000030000ol0000=0003o`0000/000?o0000E00005D000?o00004`000ol0000D0003o`0008H0
00?o000030000ol0000=0003o`0000/000?o0000E00005H000?o00004P000ol0000C0003o`0008P0
00?o000030000ol0000;0003o`0000/000?o0000E@0005H000?o00004P000ol0000C0003o`0008P0
00?o000030000ol0000;0003o`0000/000?o0000E@0005H000?o00004P000ol0000B0003o`0008X0
00?o00002`000ol0000;0003o`0000/000?o0000E@0005L000?o00004@000ol0000B0003o`0008X0
00?o00002`000ol0000;0003o`0000X000?o0000EP0005L000?o00004@000ol0000B0003o`0008X0
00?o00002`000ol0000;0003o`0000X000?o0000EP0005L000?o00004@000ol0000A0003o`0008`0
00?o00002P000ol0000;0003o`0000X000?o0000EP0005P000?o000040000ol0000A0003o`0008`0
00?o00002P000ol0000;0003o`0000T000?o0000E`0005P000?o000040000ol0000A0003o`0008`0
00?o00002P000ol0000;0003o`0000T000?o0000E`0005P000?o000040000ol0000@0003o`0008h0
00?o00002P000ol000090003o`0000X000?o0000E`0005T000?o00003`000ol0000@0003o`0008h0
00?o00002P000ol000090003o`0000T000?o0000F00005T000?o00003`000ol0000@0003o`0008h0
00?o00002P000ol000090003o`0000T000?o0000F00005T000?o00003`000ol0000?0003o`000900
00?o00002@000ol000090003o`0000T000?o0000F00005X000?o00003P000ol0000?0003o`000900
00?o00002@000ol000090003o`0000P000?o0000F@0005X000?o00003P000ol0000?0003o`000900
00?o00002@000ol000090003o`0000P000?o0000F@0005X000?o00003P000ol0000>0003o`000980
00?o000020000ol000090003o`0000P000?o0000F@0005/000?o00003@000ol0000>0003o`000980
00?o000020000ol000090003o`0000L000?o0000FP0005/000?o00003@000ol0000>0003o`000980
00?o000020000ol000090003o`0000L000?o0000FP0005/000?o00003@000ol0000=0003o`0009@0
00?o000020000ol000070003o`0000P000?o0000FP0005`000?o000030000ol0000=0003o`0009@0
00?o000020000ol000070003o`0000L000?o0000F`0005`000?o000030000ol0000<0003o`0009H0
00?o00001`000ol000070003o`0000L000?o0000F`0005`000?o000030000ol0000<0003o`0009H0
00?o00001`000ol000070003o`0000L000?o0000F`0005d000?o00002`000ol0000<0003o`0009H0
00?o00001`000ol000070003o`0000H000?o0000G00005d000?o00002`000ol0000;0003o`0009P0
00?o00001P000ol000070003o`0000H000?o0000G00005d000?o00002`000ol0000;0003o`0009P0
00?o00001P000ol000070003o`0000H000?o0000G00005h000?o00002P000ol0000;0003o`0009P0
00?o00001P000ol000070003o`0000D000?o0000G@0005h000?o00002P000ol0000:0003o`0009X0
00?o00001P000ol000050003o`0000H000?o0000G@0005l000?o00002@000ol0000:0003o`0009X0
00?o00001P000ol000050003o`0000D000?o0000GP0005l000?o00002@000ol0000:0003o`0009X0
00?o00001P000ol000050003o`0000D000?o0000GP0005l000?o00002@000ol000090003o`0009`0
00?o00001@000ol000050003o`0000D000?o0000GP00060000?o000020000ol000090003o`0009`0
00?o00001@000ol000050003o`0000@000?o0000G`00060000?o000020000ol000090003o`0009`0
00?o00001@000ol000050003o`0000@000?o0000G`00060000?o000020000ol000080003o`0009h0
00?o000010000ol000050003o`0000@000?o0000G`00064000?o00001`000ol000080003o`0009h0
00?o000010000ol000050003o`0000<000?o0000H000064000?o00001`000ol000070003o`000:00
00?o000010000ol000030003o`0000@000?o0000H000064000?o00001`000ol000070003o`000:00
00?o000010000ol000030003o`0000@000?o0000H000068000?o00001P000ol000070003o`000:00
00?o000010000ol000030003o`0000<000?o0000H@00068000?o00001P000ol000060003o`000:80
00?o00000`000ol000030003o`0000<000?o0000H@00068000?o00001P000ol000060003o`000:80
00?o00000`000ol000030003o`0000<000?o0000H@0006<000?o00001@000ol000060003o`000:80
00?o00000`000ol000030003o`00008000?o0000HP0006<000?o00001@000ol000050003o`000:@0
00?o00000P000ol000030003o`00008000?o0000HP0006<000?o00001@000ol000050003o`000:@0
00?o00000P000ol000030003o`00008000?o0000HP0006@000?o000010000ol000050003o`000:@0
00?o00000P000ol000030005o`000?l0I@0006@000?o000010000ol000040003o`000:H000?o0000
0P001Ol0003o00@000?o0000H`0006@000?o000010000ol000040003o`000:H000?o00000P001Ol0
003o00@000?o0000H`0006D000?o00000`000ol000040003o`000:H000?o00000P001Ol0003o00<0
00?o0000I00006D000?o00000`000ol000030003o`000:P000Go0000o`030005o`000?l0IP0006D0
00?o00000`000ol000030003o`000:P000Go0000o`030005o`000?l0IP0006H000?o00000P000ol0
00030003o`000:P000Go0000o`030004o`00ofL0001V0003o`00008000?o00000P000ol0002Z0004
o`00o`<000Co003oI`0006H000?o00000P000ol000020003o`000:X000Co003o0`001?l00?mW0000
I`001Ol0003o00<000?o0000[0001_l00?l0o`8000?o0000IP0006L000Go0000o`030003o`000:`0
00Ko003o0?l20003o`0006H0001W0005o`000?l00`000ol0002/0006o`00o`3o0P000ol0001V0000
o`2@0000o`2@0000o`2@0000o`2@0000o`2@0000J@03ool0900006`000?o0000o`0Q00003@02o`80
0_mF00CoE`05oeL00_l00`3oo`1F00Co400000h000Co003oEP001Ol0003o05P000Go0000o`1F0004
o`00oeP000?o0000400000h01?mF0005o`000?l0F0001Ol0003o05H000Co003oF@000ol0000?0000
3P001?l00?mF0005o`000?l0F0001Ol0003o05H000Co003oFP000ol0000>00003`02oeP01OmG0005
o`000?l0EP04oeX000?o00003P0000h00onc00GoE`000ol0001H00?o4@0001X00_oo00@00_mA00?o
6P0001`00_oo05<00_lM00007P03oe8000?o0000Y0000ol0001@00?o7`0002400_mA0003o`000:80
00?o0000C`02ob80000S00?oC`000ol0002P0003o`0004d00olT00009P02odh00_nN00;oCP02obL0
000X00?oC@000ol0001<0003o`0004/000?o0000C002obT0000[00;oC0000ol0001;0003o`0004X0
00?o0000BP03ob/0000]00?oBP000ol0001:0003o`0004T000?o0000B@02obh0000`00;oB@02odX0
00?o0000B0000ol0001700?o<00003800_m90003o`0004L000?o0000AP02odP00_lc0000=003odL0
00?o0000AP000ol000150003o`0004D00ole0000=`02odH000?o0000A@000ol000140003o`0004@0
0_lh0000>@03od@000?o0000A0000ol000130003o`0004<00_lj0000?002od<00_m40003o`000480
00?o0000@@03oc`0000n00?o@P000ol000110003o`0004000_m200;o?`0004400_m10003o`000400
00?o0000?`000ol0000o00?o@@0004<00_m00003o`0003l000?o0000?P000ol0000n00;oA00004D0
0oln00;o?`000ol0000m0003o`0003`00om60000B002och000?o0000?0000ol0000k00;o?@02odT0
001:00?o?0000ol0000k0003o`0003X000?o0000>`02od/0001=00;o>`000ol0000j0003o`0003T0
00?o0000>@03odd0001?00?o>@02ocX000?o0000>0000ol0000h00;oD00005800_li0003o`0003L0
00?o0000=`000ol0000f00?oDP0005@00olg0003o`0003H000?o0000=@02ocL00_mE0000E`02ocH0
00?o0000=@000ol0000d0003o`0003@00omG0000F@02ocD000?o0000=0000ol0000c0003o`0003<0
0_mJ0000F`03oc<00_ld0003o`00038000?o0000<P02oe`0001N00;o<`000ol0000a0003o`000340
00?o0000<003oeh0001P00?o<@000ol0000`0003o`0002l00_la00;oH@0006<00_l`0003o`0002l0
00?o0000;P000ol0000^00?oH`0006D00ol^00;o;`000ol0000]0003o`0002d00_mV0000J002obh0
00?o0000;0000ol0000/0003o`0002/00omX0000JP03ob`000?o0000:`000ol0000Z00;o;002of/0
001]00;o:`000ol0000Z0003o`0002T000?o0000:P02ofd0001_00;o:P000ol0000Y0003o`0002P0
00?o0000:003ofl0001a00?o:002obT000?o00009`000ol0000W00;oLP0007@00_lX0003o`0002H0
00?o00009P000ol0000U00?oM00007H00olV0003o`0002D000?o00009002obH00_mg0000N@02obD0
00?o000090000ol0000S0003o`0002<00omi0000N`03ob<00_lT0003o`00028000?o00008P02og`0
001n00;o8`000ol0000Q0003o`00024000?o00008@02ogh0002000;o8P000ol0000P0003o`000200
00?o00007`03oh00002200?o80000ol0000O0003o`0001h00_lP00;oP`0008D00_lO0003o`0001h0
00?o00007@000ol0000M00?oQ@0008L00olM00;o7P000ol0000L0003o`0001`00_n80000RP02oad0
00?o00006`000ol0000K0003o`0001X00on:0000S003oa/000?o00006P000ol0000J0003o`0001T0
0_n=0000S`02oaX000?o00006@000ol0000H00;o6P02ohl0002A00?o6002oaT000?o00005`000ol0
000G00?oT@0009@00_lH0003o`0001H000?o00005P000ol0000F00;oU00009H00_lG0003o`0001D0
00?o00005@000ol0000D00?oUP0009P00olE0003o`0001@000?o00004`02oaD00_nI0000V`02oa@0
0_lD0003o`00018000?o00004P03oi/0002M00?o4`000ol0000A0003o`00014000?o00004@02oih0
002P00;o4P000ol0000@0003o`00010000?o00004002oj00002R00?o40000ol0000?0003o`0000l0
00?o00003P03oj80002U00;o3`000ol0000>0003o`0000d00_l?00;oY@000:L00ol=00;o3P000ol0
000<0003o`0000`00onW0000ZP02o`d000?o00002`000ol0000;0003o`0000/00_nZ0000[002o``0
00?o00002P000ol0000:0003o`0000T00on/0000[P03o`X000?o00002@000ol000090003o`0000P0
0_n_0000/@02o`T00_l90003o`0000L00_l900;o/@000;<00ol80003o`0000l000?o00001P03ok<0
002f00;o1`000ol0000=0003o`0000D00_nf0000^003oa<000?o00000`03okP0002k00;o5@02ok/0
002m0003o`0000l00onm0000o`2@0000a@04olH000360003o`000<H000360003o`000<H000360003
o`000<H0003500CoaP000<H000?o0000aP000<H00oo60000o`2@0000o`2@0000o`2@0000o`2@0000
o`2@0000\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.1769, -0.625483, 
  0.0109392, 0.00265499}},
  CellTags->"Pattern extraction - mutant 4"],

Cell[TextData[{
  "Selective pattern extraction 4: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$292)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
0 w
.25889 .45617 m
.25889 .30902 L
s
1 g
.05 w
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$292)] .25889 .45617 0 0 Mshowa
P
1 g
.25889 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25889 .30902 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?400_l200;oP`05oa00003b0004o`00ohD000Go0000o`0?0000
lP04ohD000Go0000o`0?0000lP001?l00?n500Co40000?<00_n60005o`000?l03`000?800on500Go
40000?l0T0000?l0T0000?`000?o0000MP000ol0000G0000o@000ol0001d0003o`0001P0003n0003
o`00078000?o00006@000?l00_m`00;o70000?l00P000ol0001/0003o`0001`0003o00<000?o0000
JP000ol0000M0000o`040003o`0006P000?o00007P000?l01@02ofL000?o00007`000?l01`000ol0
001R00;o8P000?l020000ol0001P0003o`000280003o00T000?o0000GP000ol0000S0000o`0:00;o
G@000ol0000T0000o`0<0003o`0005T000?o00009@000?l03@000ol0001F00;o:0000?l03P000ol0
001D0003o`0002P0003o00l000?o0000DP000ol0000Y0000o`0@00;oD@000ol0000Z0000o`0B0003
o`0004`00_l]0000o`0C0003o`0004X000?o0000;@000?l050000ol000180003o`0002h0003o01D0
0_m70003o`0002l0003o01L000?o0000@`000ol0000`0000o`0H0003o`0004000_lc0000o`0I0003
o`0003h000?o0000<`000?l06P02ocd000?o0000=0000?l070000ol0000i0003o`0003D0003o01d0
00?o0000=`000ol0000f0000o`0N0003o`0003@00_li0000o`0O00;o<`000ol0000i0000o`0Q0003
o`0002l000?o0000>P000?l08P000ol0000]0003o`0003/0003o02<000?o0000:P02och0003o02@0
00?o0000:0000ol0000n0000o`0U00;o9`000ol0000o0000o`0W0003o`0002<000?o0000@0000?l0
:0000ol0000Q0003o`000440003o02T000?o00007P02od@0003o02X00_lM0003o`0004@0003o02`0
00?o00006@000ol000150000o`0]0003o`0001L000?o0000AP000?l0;P000ol0000E0003o`0004L0
003o02l00_lC00;oBP000?l0<@000ol0000?0003o`0004X0003o038000?o00003@000ol0001;0000
o`2@0000o`2@0000o`0h00?oE@000?l0>`000ol0001B0000o`0h00CoE0000?l0=`001Ol0003o05@0
003o03L000Go0000o`1D0000o`0g0005o`000?l0E0000?l0>005oe<0003o0900003o0900003o0900
003o0900003o0900003o0900003o0900003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003
o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000
D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000
o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X0
00?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0
001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0
003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0
>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003
o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000
D`000?l0>P000ol0001C0000o`2@0000o`2@0000o`2@0000o`2@0000o`2@0000o`0h00?oE@000?l0
>`000ol0001B0000JP03oi@01_l<00Go3005o`h01?mD0000J`000ol0002D0003o`0000l000Go0000
o`0<0005o`000?l030001Ol0003o05@0001X00GoU@000ol0000?0005o`000?l030001Ol0003o00`0
00Go0000o`1D0000J@000ol0o`2F00Co3P001Ol0003o00`01?l=0005o`000?l0E00006T000?o0?l0
UP000ol0000?0005o`000?l030001Ol0003o00d01OmC0000JP02oiD01_l<00Go3005ofH0003o0900
003o0900003o0900003o0900003o0900003o00T000?o0000:P000ol0001G0000JP000ol0002K0003
o`0000`000?o00002`000ol0000<0003o`0005P0001Z0003o`0009`000?o000030000ol0000:0003
o`0000`000?o0000F00006X000?o0000W0000ol0000<0003o`0000X000?o00002`000ol0001I0000
JP000ol0002M0003o`0000/000?o00002P000ol0000;0003o`0005T0001Z0003o`0009d000?o0000
2`000ol0000:0003o`0000X000?o0000FP0006X000?o0000WP000ol0000:0003o`0000X000?o0000
2P000ol0001J0000JP000ol0002N0003o`0000X000?o00002P000ol0000:0003o`0005X0001Z0003
o`0009l000?o00002@000ol000090003o`0000X000?o0000F`0006X000?o0000W`000ol0000:0003
o`0000P000?o00002P000ol0001K0000JP000ol0002P0003o`0000T000?o000020000ol000090003
o`0005`0001Z0003o`000:0000?o00002@000ol000080003o`0000T000?o0000G00006X000?o0000
X@000ol000080003o`0000P000?o000020000ol0001M0000JP000ol0002Q0003o`0000P000?o0000
20000ol000080003o`0005d0001Z0003o`000:4000?o000020000ol000070003o`0000P000?o0000
GP0006X000?o0000XP000ol000070003o`0000L000?o000020000ol0001N0000JP000ol0002R0003
o`0000P000?o00001P000ol000070003o`0005l0001Z0003o`000:<000?o00001`000ol000060003
o`0000L000?o0000G`0006X000?o0000X`000ol000070003o`0000H000?o00001P000ol0001P0000
JP000ol0002T0003o`0000H000?o00001P000ol000060003o`000600001Z0003o`000:@000?o0000
1P000ol000050003o`0000H000?o0000H@0006X000?o0000Y@000ol000050003o`0000D000?o0000
1P000ol0001Q0000JP000ol0002U0003o`0000D000?o00001@000ol000050003o`000680001Z0003
o`000:H000?o00001@000ol000040003o`0000D000?o0000HP0006X000?o0000YP000ol000050003
o`0000@000?o000010000ol0001S0000JP000ol0002W0003o`0000@000?o000010000ol000040003
o`0006<0001Z0003o`000:L000?o000010000ol000030003o`0000@000?o0000I00006X000?o0000
Y`000ol000040003o`0000<000?o000010000ol0001T0000JP000ol0002X0003o`0000<000?o0000
0`000ol000030003o`0006D0001Z0003o`000:P000?o00000`000ol000030003o`0000<000?o0000
I@0006X000?o0000Z@000ol000030003o`00008000?o00000P000ol0001V0000JP000ol0002Y0003
o`0000<000?o00000P000ol000020003o`0006H0001Z0003o`000:X000?o00000P001Ol0003o00@0
00?o0000I`0006X000?o0000ZP000ol000020005o`000?l010000ol0001W0000JP000ol0002[0005
o`000?l00`000ol000020003o`0006L0001Z0003o`000:/000Go0000o`030005o`000?l0JP0006X0
00?o0000[0001?l00?l30005o`000?l0JP0006X000?o0000[0001Ol0003o008000Co003oJ`000?l0
6`000ol000060003o`0006T0003o0900003o0900003o0900003o0900001L00?oo`0a0000G`001Ol0
003o0?l0;00000d00_l200;oB@04o`801?l200Co0P03o`<01?m900GoEP02o`030?oo05H01?lD0000
3P001?l00?m90005o`000?l00P001?l00?l30003o`0000D000Go0000o`1<0005o`000?l0E@001?l0
0?mH0003o`0001@0000>00CoB@001Ol0003o00@00_l40003o`0000800ol40003o`0004T000Go0000
o`1E0004o`00oeT000?o00004`0000h000Co003oB@001Ol0003o00800_l70004o`00o`8000?o0000
0`000ol000180005o`000?l0E@001?l00?mJ0003o`000180000?00;oB`05o`050?l00?l01@001?l0
0?l20003o`0000<000?o0000B0001Ol0003o05D01?mJ0003o`000180000>00?o2@02odH01?l200?o
1002o`<00om:00GoEP000ol0001?00;o1`03oaD0000L00?oA@000ol0002d00;oCP03ob40000O00?o
D@000ol0002O0003o`0005000olT00008P04odh000?o0000W@000ol0001=00Co9`0002H00om<00;o
V`02odd00ol[0000:@03od/000?o0000U`000ol0001:00?o;P0002`00om900;oU@02odX00ola0000
;`03odP00_m80003o`0004H00_m900?o=00003800om70003o`0004D000?o0000A@000ol0001500Co
=`0003D00om500;oA@000ol0001300;oA@03oc/0000h00Co@`000ol000120003o`00048000?o0000
@P03och0000l00?o@@02od8000?o0000@002od800om10000?`03od0000?o0000?`000ol0000o0003
o`0003l00om40000@P03och00_lo0003o`0003d00_lo00?oA`0004D00olm00;o?@000ol0000k00;o
?@04odX0001800?o?0000ol0000j0003o`0003X000?o0000>P03odh0001;00Co>@02ocX000?o0000
>002ocX00omA0000C`03ocP000?o0000=`000ol0000g0003o`0003L00omD0000DP03ocH00_lg0003
o`0003D00_lg00?oE`0005D00ole00;o=@000ol0000c00;o=P03oeX0001H00?o=0000ol0000b0003
o`00038000?o0000<P04oed0001K00?o<P02oc8000?o0000<002oc800omQ0000GP04oc0000?o0000
;`000ol0000_0003o`0002l00omT0000HP03obh00_l_0003o`0002d00_l_00?oI`0006D00ol]0003
o`0002`000?o0000;0000ol0000/00?oJP0006P00ol[00;o;0000ol0000Z00;o:`04ofd0001[00?o
:P02obX000?o0000:002obX00oma0000KP03obT000?o00009`000ol0000W0003o`0002L00omd0000
L@03obL00_lW0003o`0002D00_lW00?oM`0007@01?lU0003o`0002@000?o000090000ol0000T00?o
NP0007P00olS00;o90000ol0000R00;o9003ogd0001k00?o8P000ol0000Q0003o`00024000?o0000
8004oh00001n00?o8002ob4000?o00007`02ob000on40000P@03oal00_lO0003o`0001d00_lO00?o
Q`0008@00olN0003o`0001`000?o000070000ol0000L00?oRP0008L01?lK00;o70000ol0000J00;o
7003ohd0002;00?o6P000ol0000I0003o`0001T000?o00006@03oi00002>00?o6002oaT000?o0000
5`02oaP01?nC0000T@03oaL00_lG0003o`0001D00_lG00?oU`0009@00olF0003o`0001@000?o0000
50000ol0000D00?oVP0009L00olD00;o50000ol0000B00;o5003oid0002J00Co4P000ol0000A0003
o`00014000?o00004@03oj00002N00?o4002oa4000?o00003`02oa400onS0000X@03o`l000?o0000
3P000ol0000>0003o`0000d01?nV0000Y003o`d00_l>0003o`0000`00_l=00?oZP000:L00ol<00;o
30000ol0000:00;o3003ojd0002Z00?o2`000ol0000E0003o`0000T00on`0000[@03o`T00_lC00;o
2@03ok<0002`00Co1`000ol0000?0003o`0000D01?nf0000]003o`D000?o00003@000ol0000300?o
^P000;L00olE00?o_@000;X00_lA00;o`0000<801?o90000``000ol000390000``000ol000390000
``000ol000390000`P04olT000330003o`000<T0003300?ob@000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000001\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.17917, -0.833976, 
  0.0110797, 0.00353999}},
  CellTags->"Pattern extraction - mutant 5"],

Cell[TextData[{
  "Selective pattern extraction 5: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 6",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.952381 0.309017 0.588604 [
p
/Courier-Bold findfont 10 scalefont setfont
[(f$311)] .5 .30902 0 0 Msboxa
P
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
1 g
.05 w
.5 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f$311)] .5 .30902 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000<0000?o0000c0000;T01?l200Co0P03o`@0
0ol300?o^P000;X000?o00000P001?l00?l50003o`00008000?o00000`000ol0002i0000^P000ol0
000400;o1@000ol000020003o`0000<000?o0000^@000;X000?o00000P02o`D00_l50003o`0000<0
00?o0000^@000;T01?l20004o`00o`D000?o00000P000ol000030003o`000;T0002j0003o`000080
1?l200?o1002o`@00_nk0000^P03o`@000?o0000b`000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000001\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-0.526693, -0.525005, 
  0.0026467, 0.00428245}},
  CellTags->"Pattern extraction - mutant 6"],

Cell[TextData[{
  "Selective pattern extraction 6: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 7",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.49405 0.23512 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19077 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25893 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25893 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32709 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25893 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49405 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h$330)] .72917 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .48215 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .72917 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96429 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49405 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49405 .60332 m
.02381 .40712 L
s
.49405 .60332 m
.25893 .40712 L
s
.49405 .60332 m
.49405 .40712 L
s
.49405 .60332 m
.72917 .40712 L
s
.49405 .60332 m
.96429 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
0 w
.25893 .40712 m
.19077 .21092 L
s
.25893 .40712 m
.25893 .21092 L
s
.25893 .40712 m
.32709 .21092 L
s
1 g
.05 w
.19077 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19077 .21092 0 0 Mshowa
P
0 w
.25893 .21092 m
.25893 .01472 L
s
1 g
.05 w
.25893 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25893 .21092 0 0 Mshowa
P
1 g
.25893 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .25893 .01472 0 0 Mshowa
P
1 g
.32709 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .32709 .21092 0 0 Mshowa
P
1 g
.25893 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .25893 .40712 0 0 Mshowa
P
1 g
.49405 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49405 .40712 0 0 Mshowa
P
0 w
.72917 .40712 m
.72917 .21092 L
s
1 g
.05 w
.72917 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h$330)] .72917 .40712 0 0 Mshowa
P
0 w
.72917 .21092 m
.48215 .01472 L
s
.72917 .21092 m
.97619 .01472 L
s
1 g
.05 w
.48215 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .48215 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.72917 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .72917 .21092 0 0 Mshowa
P
1 g
.96429 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96429 .40712 0 0 Mshowa
P
1 g
.49405 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49405 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T00006X00om@00;o0P02okL01Ol@0000J`000ol0001@0004o`00okT0
00Go0000o`0?0000J005oe401?ni0005o`000?l03`0006T000?o0?l0DP001?l00?ni00Co400006T0
00?o0?l0D`02okX000Go0000o`0?0000JP02oe800oni00Go40000?l0T0000?l0T0000<P000?o0000
ZP000ol0000G0000b@000ol0002W00;o6P000<X00_nV0003o`0001X0003<0003o`000:8000?o0000
6`0006X000?o0000H0000ol0002P0003o`0001`0001Z0003o`00064000?o0000W@02oal0001Z0003
o`0006800_nL0003o`0001l0001Z0003o`0006@000?o0000V0000ol0000P0000JP000ol0001U0003
o`0009H000?o00008@0006X000?o0000IP000ol0002C00;o900006X000?o0000I`02oi8000?o0000
900006X000?o0000J@000ol0002>0003o`0002D0001Z0003o`0006X000?o0000S0000ol0000V0000
JP000ol0001[0003o`0008T00_lY0000JP000ol0001/00;oR0000ol0000Y0000JP000ol0001^0003
o`0008@000?o0000:P0006X000?o0000K`000ol0002100;o;@0006X000?o0000L0000ol0001o0003
o`0002d0001Z0003o`0007400_mn0003o`0002h0001Z0003o`0007<000?o0000NP000ol0000_0000
JP000ol0001d0003o`0007L00_lb0000JP000ol0001e0003o`0007D000?o0000<P0006X000?o0000
MP02og@000?o0000<`0006X000?o0000N0000ol0001`0003o`0003@0001Z0003o`0007T000?o0000
K@02ocL0001Z0003o`0007X000?o0000J`000ol0000g0000JP000ol0001k00;oJP000ol0000h0000
JP000ol0001m0003o`0006H000?o0000>@0006X000?o0000OP000ol0001S00;o?00006X000?o0000
O`000ol0001Q0003o`0003`0001Z0003o`0008000_mP0003o`0003d0001Z0003o`00088000?o0000
F`02od00001Z0003o`0008<000?o0000F@000ol000100000JP000ol0002400;oF0000ol000110000
JP000ol000260003o`0005@000?o0000@P0006X000?o0000Q`000ol0001A00;oA@0006X000?o0000
R0000ol0001?0003o`0004D0001Z0003o`0008T00_m>0003o`0004H0001Z0003o`0008/000?o0000
BP000ol000170000JP000ol0002<0003o`0004L00_m:0000JP000ol0002=0003o`0004D000?o0000
BP0006X000?o0000SP02od@000?o0000B`0006X000?o0000T0000ol000100003o`0004`0001Z0003
o`00094000?o0000?@02odl0001Z0003o`00098000?o0000>`000ol0001?0000JP000ol0002C00;o
>P000ol0001@0000JP000ol0002E0003o`0003D00_mC0000JP000ol0002F0003o`0003<000?o0000
D`0006X000?o0000U`000ol0000a0003o`0005@0001Z0003o`0009P00_l`0003o`0005D0001Z0003
o`0009X000?o0000:`02oeP0001Z0003o`0009/000?o0000:@000ol0001H0000JP000ol0002L0003
o`0002L000?o0000F@0006X000?o0000W@02obH000?o0000FP0006X000?o0000W`000ol0000Q00;o
G@0006X000?o0000X0000ol0000O0003o`0005d0001Z0003o`000:4000?o00007@000ol0001N0000
JP000ol0002R00;o70000ol0001O0000JP000ol0002T0003o`0001L00_mR0000JP000ol0002U0003
o`0001D000?o0000HP000?l050000ol0000C0003o`0006<0003o01D00_lA00;oIP000?l05`000ol0
000=0003o`0006H0003o0900003o0900001X00?o/@03og00001[0003o`000;4000?o0000K@0004d0
1OlF00Co5P03oiL01?m_0000CP001Ol0003o01@000Go0000o`0I0003o`0009<000Go0000o`1_0000
CP001Ol0003o01@000Go0000o`0I0003o`0009<000Go0000o`1_0000CP04oaD000Go0000o`0G00;o
UP001Ol0003o06l0001>0005o`000?l05@05oaP000?o0000U005ofh0001=00Go<003ool02`000?l0
T0000?l0T0000?l0T0000?l0T0000?l0T0000?l0T00005<000?o000050000ol0000D0003o`0009X0
00?o0000KP0005@000?o00004`000ol0000C0003o`0009/000?o0000KP0005@000?o00004`000ol0
000C0003o`0009/000?o0000KP0005@000?o00004`000ol0000C0003o`0009/000?o0000KP0005D0
00?o00004P000ol0000B0003o`0009`000?o0000KP0005D000?o00004P000ol0000B0003o`0009`0
00?o0000KP0005D000?o00004P000ol0000B0003o`0009`000?o0000KP0005H000?o00004@000ol0
000A0003o`0009d000?o0000KP0005H000?o00004@000ol0000A0003o`0009d000?o0000KP0005H0
00?o00004@000ol0000A0003o`0009d000?o0000KP0005L000?o000040000ol0000@0003o`0009h0
00?o0000KP0005L000?o000040000ol0000@0003o`0009h000?o0000KP0005L000?o000040000ol0
000@0003o`0009h000?o0000KP0005P000?o00003`000ol0000?0003o`0009l000?o0000KP0005P0
00?o00003`000ol0000?0003o`0009l000?o0000KP0005P000?o00003`000ol0000?0003o`0009l0
00?o0000KP0005T000?o00003P000ol0000>0003o`000:0000?o0000KP0005T000?o00003P000ol0
000>0003o`000:0000?o0000KP0005T000?o00003P000ol0000>0003o`000:0000?o0000KP0005X0
00?o00003@000ol0000=0003o`000:4000?o0000KP0005X000?o00003@000ol0000=0003o`000:40
00?o0000KP0005X000?o00003@000ol0000=0003o`000:4000?o0000KP0005/000?o000030000ol0
000<0003o`000:8000?o0000KP0005/000?o000030000ol0000<0003o`000:8000?o0000KP0005/0
00?o000030000ol0000<0003o`000:8000?o0000KP0005`000?o00002`000ol0000;0003o`000:<0
00?o0000KP0005`000?o00002`000ol0000;0003o`000:<000?o0000KP0005`000?o00002`000ol0
000;0003o`000:<000?o0000KP0005d000?o00002P000ol0000:0003o`000:@000?o0000KP0005d0
00?o00002P000ol0000:0003o`000:@000?o0000KP0005h000?o00002@000ol000090003o`000:D0
00?o0000KP0005h000?o00002@000ol000090003o`000:D000?o0000KP0005h000?o00002@000ol0
00090003o`000:D000?o0000KP0005l000?o000020000ol000080003o`000:H000?o0000KP0005l0
00?o000020000ol000080003o`000:H000?o0000KP0005l000?o000020000ol000080003o`000:H0
00?o0000KP00060000?o00001`000ol000070003o`000:L000?o0000KP00060000?o00001`000ol0
00070003o`000:L000?o0000KP00060000?o00001`000ol000070003o`000:L000?o0000KP000640
00?o00001P000ol000060003o`000:P000?o0000KP00064000?o00001P000ol000060003o`000:P0
00?o0000KP00064000?o00001P000ol000060003o`000:P000?o0000KP00068000?o00001@000ol0
00050003o`000:T000?o0000KP00068000?o00001@000ol000050003o`000:T000?o0000KP000680
00?o00001@000ol000050003o`000:T000?o0000KP0006<000?o000010000ol000040003o`000:X0
00?o0000KP0006<000?o000010000ol000040003o`000:X000?o0000KP0006<000?o000010000ol0
00040003o`000:X000?o0000KP0006@000?o00000`000ol000030003o`000:/000?o0000KP0006@0
00?o00000`000ol000030003o`000:/000?o0000KP0006@000?o00000`000ol000030003o`000:/0
00?o0000KP0006D000?o00000P000ol000020003o`000:`000?o0000KP0006D000?o00000P000ol0
00020003o`000:`000?o0000KP0006D000?o00000P000ol000020003o`000:`000?o0000KP0006H0
00Go0000o`030003o`000:d000?o0000KP0006H000Go0000o`030003o`000:d000?o0000KP0006H0
00Go0000o`030003o`000:d000?o0000KP000?l0T0000?l0T0000?l0T0000?l0T0000?l0T00006P0
0ooo02D0001[0003o`000:T000?o0000M@0000d00_l200;oE@04oeD01Om:00;o00@0ool01?l200?o
0`03o`@00om;00Co500000h000Co003oE@001Ol0003o05H000Go0000o`190004o`00o`8000Co003o
1@000ol000030004o`00o`<000?o0000B@000ol0000D00003P04oeD000Go0000o`1F0005o`000?l0
B@001?l00?l400;o1@000ol000030004o`00o`<000?o0000BP000ol0000C00003P001?l00?mE0005
o`000?l0EP001Ol0003o04T000Co003o0P02o`D00_l400;o0`001Ol0003o04d000?o00004P0000l0
0_mG00GoE@001Ol0003o04T01?l20004o`00o`D000?o00000`001?l00?l30003o`0004/000?o0000
4P0000h00on`00GoBP000ol0000300Co0P03o`<00ol400?oB`03oaD0000I00?ol`02o`L000?o0000
D`03oah0000L00;oo`1?00;o8@0001h00omA0003o`000:4000?o0000D003ob<0000Q00;oD0000ol0
002O0003o`0004l00_lV00008`02odl000?o0000W@000ol0001=00?o:00002D00om=0003o`0009/0
00?o0000C002ob/0000X00;oC002od`000?o0000BP02odd00_l]0000:P03od/000?o0000B@000ol0
00190003o`0004X00ol_0000;@02odX000?o0000B0000ol000180003o`0004T00_lb0000;`02odT0
00?o0000A`000ol000170003o`0004L00old0000<@03odL000?o0000AP000ol000160003o`0004H0
0_lg0000=002odH00_m60003o`0004@00_m700;o>@0003H00om50003o`0004<000?o0000@`000ol0
001400?o>`0003T00_m40003o`00048000?o0000@P000ol0001300;o?P0003/00_m30003o`000440
00?o0000@@000ol0001100?o@00003d00om10003o`00040000?o0000@0000ol0001000;o@`000400
0_m000;o@0000ol0000n00;o@@02odD0001200?o?`000ol0000m0003o`0003d000?o0000?P03odL0
001500;o?P000ol0000l0003o`0003`000?o0000?@02odX0001700;o?@000ol0000k0003o`0003/0
00?o0000>`03od`0001900?o>`000ol0000j0003o`0003X000?o0000>P02odl0001<00;o>P02ocX0
00?o0000>002ocX00omA0000CP03ocT000?o0000=`000ol0000g0003o`0003P00_mD0000D@02ocP0
00?o0000=P000ol0000f0003o`0003L00_mF0000D`02ocL000?o0000=@000ol0000e0003o`0003D0
0omH0000E@03ocD000?o0000=0000ol0000d0003o`0003@00_mK0000F002oc@00_ld0003o`000380
0_ld00?oG@0005X00olc0003o`00034000?o0000<@000ol0000b00;oH00005d00_lb0003o`000300
00?o0000<0000ol0000a00;oHP0005l00_la0003o`0002l000?o0000;`000ol0000_00?oI0000640
0ol_0003o`0002h000?o0000;P000ol0000^00;oI`0006@00_l^00;o;P000ol0000/00;o;P03ofT0
001V00?o;@000ol0000[0003o`0002/000?o0000;002of`0001Y00;o;0000ol0000Z0003o`0002X0
00?o0000:P03ofh0001[00;o:`000ol0000Y0003o`0002T000?o0000:@02og40001]00?o:@000ol0
000X0003o`0002P000?o0000:002og<0001`00;o:002obP000?o00009P02obP00ome0000LP03obL0
00?o00009@000ol0000U0003o`0002H00_mh0000M@02obH000?o000090000ol0000T0003o`0002@0
0omj0000M`02obD000?o00008`000ol0000S0003o`0002<00_mm0000N@03ob<000?o00008P000ol0
000R0003o`0002800_mo0000O002ob800_lR0003o`0002000_lR00?oP@0007h00olQ0003o`0001l0
00?o00007`000ol0000P00;oQ00008400_lP0003o`0001h000?o00007P000ol0000N00?oQP0008<0
0_lO0003o`0001d000?o00007@000ol0000M00;oR@0008D00olM0003o`0001`000?o000070000ol0
000L00;oR`0008P00_lL00;o70000ol0000J00;o7003ohd0002:00?o6`000ol0000I0003o`0001T0
00?o00006P02oi00002=00;o6P000ol0000H0003o`0001P000?o00006003oi80002?00;o6@000ol0
000G0003o`0001L000?o00005`02oiD0002A00?o5`000ol0000F0003o`0001H000?o00005@03oiL0
002D00;o5P02oaH000?o00005002oaH00_nJ0000UP03oaD000?o00004`000ol0000C0003o`0001@0
0_nL0000V@02oa@000?o00004P000ol0000B0003o`0001800onN0000V`02oa<000?o00004@000ol0
000A0003o`0001400_nQ0000W@03oa4000?o000040000ol0000@0003o`0000l00onS0000X002oa00
0_l@0003o`0000h00_l@00;oYP000:800ol?0003o`0000d000?o00003@000ol0000>00;oZ0000:D0
0_l>0003o`0000`000?o000030000ol0000<00?oZP000:L00_l=0003o`0000/000?o00002`000ol0
000;00;o[@000:T00ol;0003o`0000X000?o00002P000ol0000900?o[`000:`00_l:00;o2P000ol0
000800;o2P02ok80002^00?o2@000ol000070003o`0000L000?o00002002ok@0002a00;o20000ol0
000?0003o`0000H00onf0000/`02o`L000?o00003@000ol0000500;o^@000;D00ol50003o`0000/0
00?o00000`03ok/0002h00;o5@02okh0002j00;o4@02ol00003o0900003200Cob@000<<000?o0000
b@000<<000?o0000b@000<<000?o0000b@000<801?o90000``000ol000390000``03olT0003o0900
003o0900003o0900003o0900003o09000000\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.17913, -0.625483, 
  0.0110776, 0.00265499}},
  CellTags->"Pattern extraction - mutant 7"],

Cell[TextData[{
  "Selective pattern extraction 7: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 8",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 2.94302 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f$349)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .01472 L
s
.5 .60332 m
.97619 .01472 L
s
1 g
.05 w
.02381 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f$349)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T00000d00_l200;oo`1X00Go400000h000Co003oo`1Z0005o`000?l0
3`0000h01?oo06X000Go0000o`0?00003P001?l00?oo06X01?l@00003`02ool0J`001Ol0003o00l0
000>00?oo`1Z00Go40000?l0T0000?l0T0000?l0T0000?l0T00001H000?o0000o`1O0003o`0001D0
000G0003o`000?l0G@000ol0000F000060000ol0003o05/000?o00005`0001T000?o0000o`1J0003
o`0001L0000I0003o`000?l0F@000ol0000H00006P000ol0003o05L000?o00006@0001/000?o0000
o`1E0003o`0001X0000L0003o`000?l0D`000ol0000K00007@000ol0003o058000?o00006`0001d0
00?o0000o`1A0003o`0001`0000N0003o`000?l0C`000ol0000M00007`000ol0003o04d000?o0000
7P00020000?o0000o`1;0003o`0001l0000Q0003o`000?l0B@000ol0000P00008@000ol0003o04T0
00?o00008000028000?o0000o`170003o`000240000S0003o`000?l0A@000ol0000R000090000ol0
003o04<000?o00008`0002D000?o0000o`110003o`0002@0000U0003o`000?l0@@000ol0000T0000
9P000ol0003o03l000?o00009@0002L000?o0000o`0m0003o`0002H0000X0003o`000?l0>`000ol0
000W0000:@000ol0003o03T000?o0000:00002X000?o0000o`0h0003o`0002P0000Z0003o`000?l0
=`000ol0000Y0000:`000ol0003o03D000?o0000:P0002`000?o0000o`0c0003o`0002/0000]0003
o`000?l0<@000ol0000/0000;P000ol0003o030000?o0000;00002h000?o0000o`0_0003o`0002d0
000_0003o`000?l0;@000ol0000^0000<0000ol0003o02/000?o0000;`00034000?o0000o`0Y0003
o`000300000b0003o`000?l0:0000ol0000`0000<P000ol0003o02L000?o0000<@0003<000?o0000
o`0U0003o`000380000d0003o`000?l08`000ol0000c0000=@000ol0003o024000?o0000=00003H0
00?o0000o`0P0003o`0003@0000f0003o`000?l07`000ol0000e0000=`000ol0003o01d000?o0000
=P0003P000?o0000o`0K0003o`0003L0000i0003o`000?l06@000ol0000h0000>P000ol0003o01P0
00?o0000>00003/000?o0000o`0F0003o`0003T0000k0003o`000?l05@000ol0000j0000?0000ol0
003o01<000?o0000>`0003d000?o0000o`0A0003o`0003`0000n0003o`000?l03`000ol0000m0000
?`000ol0003o00h000?o0000?@0003l000?o0000o`0=0003o`0003h000100003o`000?l02`000ol0
000o0000@@000ol0003o00T000?o0000@000048000?o0000o`070003o`00044000130003o`000?l0
1P000ol000110000@`000ol0003o00D000?o0000@P0004@000?o0000o`030003o`0004<000150003
o`000?l00@000ol000140000AP000ol0003n0003o`0004D000170003o`000?d000?o0000A@0004L0
00?o0000o0000ol000160000B0000ol0003j0003o`0004L000190003o`000?P000?o0000B00004X0
00?o0000mP000ol000190000B`000ol0003e0003o`0004T0001<0003o`000?<000?o0000BP0004`0
00?o0000lP000ol0001;0000C@000ol0003`0003o`0004`0001>0003o`000>h000?o0000C@0004l0
00?o0000k@000ol0001=0000D0000ol0003[0003o`0004h0001@0003o`000>X000?o0000C`000540
00?o0000j0000ol0001@0000DP000ol0003V0003o`000540001C0003o`000>D000?o0000D@0005@0
00?o0000h`000ol0001B0000E0000ol0003R0003o`0005<0001E0003o`000>0000?o0000E00005H0
00?o0000gP000ol0001E0000E`000ol0003M0003o`0005D0001H0003o`000=/000?o0000EP0005P0
00?o0000fP000ol0001G0000F@000ol0003H0003o`0005P0001J0003o`000=H000?o0000F@0005/0
00?o0000e@000ol0001I0000G0000ol0003C0003o`0005X0001M0003o`000=4000?o0000F`0005d0
00?o0000d0000ol0001L0000GP000ol0003>0003o`0005d0001O0003o`000<`000?o0000GP000600
00?o0000b`000ol0001N0000H@000ol000390003o`0005l0001Q0003o`000<P000?o0000H0000680
00?o0000aP000ol0001Q0000H`000ol000340003o`000680001T0003o`000<<000?o0000HP0006D0
00?o0000`@000ol0001S0000I@000ol000300003o`0006@0001V0003o`000;h000?o0000I@0006L0
00?o0000_0000ol0001V0000J0000ol0002k0003o`0006H0001Y0003o`000;T000?o0000I`0006T0
00?o0000^0000ol0001X0000JP000ol0002f0003o`0006T0001[0003o`000;@000?o0000JP0006`0
00?o0000/`000ol0001Z0000K@000ol0002a0003o`0006/0001^0003o`000:l000?o0000K00006h0
00?o0000[P000ol0001]0000K`000ol0002/0003o`0006h0001`0003o`000:/000?o0000KP000740
00?o0000Z@000ol0001_0000LP000ol0002W0003o`000700001b0003o`000:H000?o0000L@0007<0
00?o0000Y0000ol0001b0000M0000ol0002S0003o`000780001e0003o`000:4000?o0000L`0007H0
00?o0000W`000ol0001d0000MP000ol0002N0003o`0007D0001g0003o`0009`000?o0000MP0007P0
00?o0000V`000ol0001f0000N@000ol0002I0003o`0007L0001j0003o`0009L000?o0000N00007X0
00?o0000UP000ol0001i0000N`000ol0002D0003o`0007X0001l0003o`00098000?o0000N`0007d0
00?o0000T@000ol0001k0000OP000ol0002?0003o`0007`0001o0003o`0008d000?o0000O@0007l0
00?o0000S0000ol0001n0000P0000ol0002:0003o`0007l000210003o`0008T000?o0000O`000880
00?o0000Q`000ol000200000P`000ol000250003o`00084000230003o`0008@000?o0000PP0008@0
00?o0000PP000ol000230000Q@000ol000210003o`0008<000260003o`0007l000?o0000Q00008L0
00?o0000O@000ol000250000Q`000ol0001l0003o`0008H000280003o`0007X000?o0000Q`0008T0
00?o0000N@000ol000270000RP000ol0001g0003o`0008P0002;0003o`0007D000?o0000R@0008/0
00?o0000M0000ol0002:0000S0000ol0001b0003o`0008/0002=0003o`00074000?o0000R`0008h0
00?o0000K`000ol0002<0000S`000ol0001]0003o`0008d0002@0003o`0006/000?o0000SP000900
00?o0000JP000ol0002?0000T@000ol0001Y0003o`0008l0002B0003o`0006L000?o0000T00009<0
00?o0000I@000ol0002A0000U0000ol0001S0003o`000980002D0003o`00068000?o0000T`0009D0
00?o0000H@000ol0002C0000UP000ol0001O0003o`0009@0002G0003o`0005d000?o0000U@0009P0
00?o0000F`000ol0002F0000V0000ol0001J0003o`0009L0002I0003o`0005P000?o0000V00009X0
00?o0000E`000ol0002H0000V`000ol0001E0003o`0009T0002L0003o`0005<000?o0000VP0009`0
00?o0000DP000ol0002K0000W@000ol0001@0003o`0009`0002N0003o`0004l000?o0000W00009l0
00?o0000C@000ol0002M0000X0000ol0001;0003o`0009h0002Q0003o`0004T000?o0000W`000:40
00?o0000B0000ol0002P0000XP000ol000170003o`000:00002S0003o`0004D000?o0000X@000:@0
00?o0000@`000ol0002R0000Y@000ol000110003o`000:<0002U0003o`00040000?o0000Y0000:H0
00?o0000?`000ol0002T0000Y`000ol0000m0003o`000:D0002X0003o`0003/000?o0000YP000:T0
00?o0000>@000ol0002W0000Z@000ol0000h0003o`000:P0002Z0003o`0003L000?o0000Z0000:/0
00?o0000=@000ol0002Y0000[0000ol0000c0003o`000:X0002]0003o`00034000?o0000Z`000:d0
00?o0000<0000ol0002/0000[P000ol0000_0003o`000:`0002_0003o`0002d000?o0000[@000;00
00?o0000:`000ol0002^0000/@000ol0000Y0003o`000:l0002b0003o`0002L000?o0000/0000;80
00?o00009`000ol0002`0000/`000ol0000U0003o`000;40002d0003o`0002<000?o0000/P000;D0
00?o00008@000ol0002c0000]P000ol0000O0003o`000;@0002f0003o`0001l000?o0000]0000;L0
00?o00007@000ol0002e0000^0000ol0000K0003o`000;H0002i0003o`0001T000?o0000]`000;X0
00?o00005`000ol0002h0000^P000ol0000F0003o`000;T0002k0003o`0001D000?o0000^@000;`0
00?o00004`000ol0002j0000_@000ol0000A0003o`000;/0002n0003o`0000l000?o0000_0000;h0
00?o00003P000ol0002m0000_`000ol0000=0003o`000;d000300003o`0000/000?o0000_P000<d0
00?o0000_`000?l0T0000?l0T0000?l0T0000<0000?o0000c0000;T01?l200Co0P03o`D00ol0103o
oonk0000^P000ol000020004o`00o`D000?o00000`000ol000030003o`000;P0002j0003o`0000@0
0_l50003o`0000Go0P03okX0002j0003o`0000800_l500;o10000ol0o`020004o`00okX0002i00Co
0P001?l00?l50007o`000?l0o`020004o`00okX0002j0003o`0000801?l200?o1@02o`<00_nk0000
^P03o`@000?o0000b`000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000001\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.1769, -0.208494, 
  0.0109392, 0.000884997}},
  CellTags->"Pattern extraction - mutant 8"],

Cell[TextData[{
  "Selective pattern extraction 8: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .74459 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .86966 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$368)] .80712 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .40712 0 0 Mshowa
P
0 w
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .19288 .21092 0 0 Mshowa
P
0 w
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .21092 0 0 Mshowa
P
1 g
.2619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .2619 .01472 0 0 Mshowa
P
1 g
.33093 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .33093 .21092 0 0 Mshowa
P
1 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .5 .40712 0 0 Mshowa
P
0 w
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66907 .21092 0 0 Mshowa
P
1 g
.71509 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .71509 .21092 0 0 Mshowa
P
1 g
.7611 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .7611 .21092 0 0 Mshowa
P
0 w
.80712 .21092 m
.74459 .01472 L
s
.80712 .21092 m
.86966 .01472 L
s
1 g
.05 w
.74459 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .74459 .01472 0 0 Mshowa
P
1 g
.86966 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .86966 .01472 0 0 Mshowa
P
1 g
.80712 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$368)] .80712 .21092 0 0 Mshowa
P
1 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
1 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T00006/00onc00;o0P02obX01Oli0000K0000ol0002c0004o`00ob`0
00Go0000o`0h0000J@05ok@01?l/0005o`000?l0>00006X000?o0?l0]@001?l00?l/00Co>@0006X0
00?o0?l0]P02obd000Go0000o`0h0000J`02okD00ol/00Go>@000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T00006/000?o0000^@000ol0000W0003o`0003/0001[0003o`000;T000?o0000
9`000ol0000k0000J`000ol0002j0003o`0002D000?o0000?00006/000?o0000^P000ol0000U0003
o`0003`0001[0003o`000;X000?o00009@000ol0000l0000J`000ol0002k0003o`0002<000?o0000
?@0006/000?o0000^`000ol0000S0003o`0003d0001[0003o`000;/000?o00008`000ol0000m0000
J`000ol0002l0003o`00024000?o0000?P0006/000?o0000_0000ol0000Q0003o`0003h0001[0003
o`000;`000?o00008@000ol0000n0000J`000ol0002m0003o`0001l000?o0000?`0006/000?o0000
_@000ol0000O0003o`0003l0001[0003o`000;d000?o00007`000ol0000o0000J`000ol0002n0003
o`0001d000?o0000@00006/000?o0000_P000ol0000M0003o`000400001[0003o`000;h000?o0000
7@000ol000100000J`000ol0002n0003o`0001d000?o0000@00006/000?o0000_`000ol0000K0003
o`000440001[0003o`000;l000?o00006`000ol000110000J`000ol0002o0003o`0001/000?o0000
@@0006/000?o0000`0000ol0000I0003o`000480001[0003o`000<0000?o00006@000ol000120000
J`000ol000300003o`0001T000?o0000@P0006/000?o0000`@000ol0000G0003o`0004<0001[0003
o`000<4000?o00005`000ol000130000J`000ol000310003o`0001L000?o0000@`0006/000?o0000
`P000ol0000E0003o`0004@0001[0003o`000<8000?o00005@000ol000140000J`000ol000320003
o`0001D000?o0000A00006/000?o0000``000ol0000C0003o`0004D0001[0003o`000<<000?o0000
4`000ol000150000J`000ol000330003o`0001<000?o0000A@0006/000?o0000a0000ol0000A0003
o`0004H0001[0003o`000<@000?o00004@000ol000160000J`000ol000340003o`00014000?o0000
AP0006/000?o0000a@000ol0000?0003o`0004L0001[0003o`000<D000?o00003`000ol000170000
J`000ol000350003o`0000l000?o0000A`0006/000?o0000aP000ol0000=0003o`0004P0001[0003
o`000<H000?o00003@000ol000180000J`000ol000360003o`0000d000?o0000B00006/000?o0000
aP000ol0000=0003o`0004P0001[0003o`000<L000?o00002`000ol000190000J`000ol000370003
o`0000/000?o0000B@0006/000?o0000a`000ol0000;0003o`0004T0001[0003o`000<P000?o0000
2@000ol0001:0000J`000ol000380003o`0000T000?o0000BP0006/000?o0000b0000ol000090003
o`0004X0001[0003o`000<T000?o00001`000ol0001;0000J`000ol000390003o`0000L000?o0000
B`0006/000?o0000b@000ol000070003o`0004/0001[0003o`000<X000?o00001@000ol0001<0000
J`000ol0003:0003o`0000D000?o0000C00006/000?o0000bP000ol000050003o`0004`0001[0003
o`000</000?o00000`000ol0001=0000o`2@0000o`2@0000o`2@0000o`2@0000o`2@0000J@03ol80
0omN0000K0000ol000320005o`000?l0F@0004h01OlF00Co5`03ogd01_l<00Go3@05o`030?oo00;o
0P04o`800ol400;o1003odD0001?0005o`000?l050001Ol0003o01X000?o0000N`000ol0000?0005
o`000?l03@001Ol0003o00<000Co003o0P000ol000030004o`00o`8000Co003o0`000ol000120000
C`001Ol0003o01@000Go0000o`0J0003o`0007/000?o00003`001Ol0003o00d000Go0000o`030003
o`0000800_l50004o`00o`8000Co003o0`000ol000120000C`04oaD000Go0000o`0H00;oOP04o`h0
00Go0000o`0=00Go0`000ol00002o`D00_l300?o1003odD0001?0005o`000?l05@05oaT000?o0000
N`000ol0000?0005o`000?l03@001?l00006o`050?l00?l01@001?l00?l50005o`000?l0A00004h0
1Ola00?oO@06o``01Ol=00Go1`04o`800ol400?o0`03odD0003o03L000?o0000EP000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T00005@000?o000050000ol0000E0003o`0008@000?o00003@000ol0
000=0003o`0000`000?o0000D`0005D000?o00004`000ol0000D0003o`0008H000?o000030000ol0
000=0003o`0000/000?o0000E00005D000?o00004`000ol0000D0003o`0008H000?o000030000ol0
000=0003o`0000/000?o0000E00005D000?o00004`000ol0000D0003o`0008H000?o000030000ol0
000=0003o`0000/000?o0000E00005H000?o00004P000ol0000C0003o`0008P000?o000030000ol0
000;0003o`0000/000?o0000E@0005H000?o00004P000ol0000C0003o`0008P000?o000030000ol0
000;0003o`0000/000?o0000E@0005H000?o00004P000ol0000B0003o`0008X000?o00002`000ol0
000;0003o`0000/000?o0000E@0005L000?o00004@000ol0000B0003o`0008X000?o00002`000ol0
000;0003o`0000X000?o0000EP0005L000?o00004@000ol0000B0003o`0008X000?o00002`000ol0
000;0003o`0000X000?o0000EP0005L000?o00004@000ol0000A0003o`0008`000?o00002P000ol0
000;0003o`0000X000?o0000EP0005P000?o000040000ol0000A0003o`0008`000?o00002P000ol0
000;0003o`0000T000?o0000E`0005P000?o000040000ol0000A0003o`0008`000?o00002P000ol0
000;0003o`0000T000?o0000E`0005P000?o000040000ol0000@0003o`0008h000?o00002P000ol0
00090003o`0000X000?o0000E`0005T000?o00003`000ol0000@0003o`0008h000?o00002P000ol0
00090003o`0000T000?o0000F00005T000?o00003`000ol0000@0003o`0008h000?o00002P000ol0
00090003o`0000T000?o0000F00005T000?o00003`000ol0000?0003o`00090000?o00002@000ol0
00090003o`0000T000?o0000F00005X000?o00003P000ol0000?0003o`00090000?o00002@000ol0
00090003o`0000P000?o0000F@0005X000?o00003P000ol0000?0003o`00090000?o00002@000ol0
00090003o`0000P000?o0000F@0005X000?o00003P000ol0000>0003o`00098000?o000020000ol0
00090003o`0000P000?o0000F@0005/000?o00003@000ol0000>0003o`00098000?o000020000ol0
00090003o`0000L000?o0000FP0005/000?o00003@000ol0000>0003o`00098000?o000020000ol0
00090003o`0000L000?o0000FP0005/000?o00003@000ol0000=0003o`0009@000?o000020000ol0
00070003o`0000P000?o0000FP0005`000?o000030000ol0000=0003o`0009@000?o000020000ol0
00070003o`0000L000?o0000F`0005`000?o000030000ol0000<0003o`0009H000?o00001`000ol0
00070003o`0000L000?o0000F`0005`000?o000030000ol0000<0003o`0009H000?o00001`000ol0
00070003o`0000L000?o0000F`0005d000?o00002`000ol0000<0003o`0009H000?o00001`000ol0
00070003o`0000H000?o0000G00005d000?o00002`000ol0000;0003o`0009P000?o00001P000ol0
00070003o`0000H000?o0000G00005d000?o00002`000ol0000;0003o`0009P000?o00001P000ol0
00070003o`0000H000?o0000G00005h000?o00002P000ol0000;0003o`0009P000?o00001P000ol0
00070003o`0000D000?o0000G@0005h000?o00002P000ol0000:0003o`0009X000?o00001P000ol0
00050003o`0000H000?o0000G@0005l000?o00002@000ol0000:0003o`0009X000?o00001P000ol0
00050003o`0000D000?o0000GP0005l000?o00002@000ol0000:0003o`0009X000?o00001P000ol0
00050003o`0000D000?o0000GP0005l000?o00002@000ol000090003o`0009`000?o00001@000ol0
00050003o`0000D000?o0000GP00060000?o000020000ol000090003o`0009`000?o00001@000ol0
00050003o`0000@000?o0000G`00060000?o000020000ol000090003o`0009`000?o00001@000ol0
00050003o`0000@000?o0000G`00060000?o000020000ol000080003o`0009h000?o000010000ol0
00050003o`0000@000?o0000G`00064000?o00001`000ol000080003o`0009h000?o000010000ol0
00050003o`0000<000?o0000H000064000?o00001`000ol000070003o`000:0000?o000010000ol0
00030003o`0000@000?o0000H000064000?o00001`000ol000070003o`000:0000?o000010000ol0
00030003o`0000@000?o0000H000068000?o00001P000ol000070003o`000:0000?o000010000ol0
00030003o`0000<000?o0000H@00068000?o00001P000ol000060003o`000:8000?o00000`000ol0
00030003o`0000<000?o0000H@00068000?o00001P000ol000060003o`000:8000?o00000`000ol0
00030003o`0000<000?o0000H@0006<000?o00001@000ol000060003o`000:8000?o00000`000ol0
00030003o`00008000?o0000HP0006<000?o00001@000ol000050003o`000:@000?o00000P000ol0
00030003o`00008000?o0000HP0006<000?o00001@000ol000050003o`000:@000?o00000P000ol0
00030003o`00008000?o0000HP0006@000?o000010000ol000050003o`000:@000?o00000P000ol0
00030005o`000?l0I@0006@000?o000010000ol000040003o`000:H000?o00000P001Ol0003o00@0
00?o0000H`0006@000?o000010000ol000040003o`000:H000?o00000P001Ol0003o00@000?o0000
H`0006D000?o00000`000ol000040003o`000:H000?o00000P001Ol0003o00<000?o0000I00006D0
00?o00000`000ol000030003o`000:P000Go0000o`030005o`000?l0IP0006D000?o00000`000ol0
00030003o`000:P000Go0000o`030005o`000?l0IP0006H000?o00000P000ol000030003o`000:P0
00Go0000o`030004o`00ofL0001V0003o`00008000?o00000P000ol0002Z0004o`00o`<000Co003o
I`0006H000?o00000P000ol000020003o`000:X000Co003o0`001?l00?mW0000I`001Ol0003o00<0
00?o0000[0001_l00?l0o`8000?o0000IP0006L000Go0000o`030003o`000:`000Ko003o0?l20003
o`0006H0001W0005o`000?l00`000ol0002/0006o`00o`3o0P000ol0001V0000o`2@0000o`2@0000
o`2@0000o`2@0000o`2@0000J@03ool0900006`000?o0000o`0Q00003@02o`800_mF00CoE`05oeL0
0_l00`3oo`1F00Co400000h000Co003oEP001Ol0003o05P000Go0000o`1F0004o`00oeP000?o0000
400000h01?mF0005o`000?l0F0001Ol0003o05H000Co003oF@000ol0000?00003P001?l00?mF0005
o`000?l0F0001Ol0003o05H000Co003oFP000ol0000>00003`02oeP01OmG0005o`000?l0EP04oeX0
00?o00003P0000h00onc00GoE`000ol0001H00?o4@0001X00_oo00@00_mA00?o6P0001`00_oo05<0
0_lM00007P03oe8000?o0000Y0000ol0001@00?o7`0002400_mA0003o`000:8000?o0000C`02ob80
000S00?oC`000ol0002P0003o`0004d00olT00009P02odh00_nN00;oCP02obL0000X00?oC@000ol0
001<0003o`0004/000?o0000C002obT0000[00;oC0000ol0001;0003o`0004X000?o0000BP03ob/0
000]00?oBP000ol0001:0003o`0004T000?o0000B@02obh0000`00;oB@02odX000?o0000B0000ol0
001700?o<00003800_m90003o`0004L000?o0000AP02odP00_lc0000=003odL000?o0000AP000ol0
00150003o`0004D00ole0000=`02odH000?o0000A@000ol000140003o`0004@00_lh0000>@03od@0
00?o0000A0000ol000130003o`0004<00_lj0000?002od<00_m40003o`00048000?o0000@@03oc`0
000n00?o@P000ol000110003o`0004000_m200;o?`0004400_m10003o`00040000?o0000?`000ol0
000o00?o@@0004<00_m00003o`0003l000?o0000?P000ol0000n00;oA00004D00oln00;o?`000ol0
000m0003o`0003`00om60000B002och000?o0000?0000ol0000k00;o?@02odT0001:00?o?0000ol0
000k0003o`0003X000?o0000>`02od/0001=00;o>`000ol0000j0003o`0003T000?o0000>@03odd0
001?00?o>@02ocX000?o0000>0000ol0000h00;oD00005800_li0003o`0003L000?o0000=`000ol0
000f00?oDP0005@00olg0003o`0003H000?o0000=@02ocL00_mE0000E`02ocH000?o0000=@000ol0
000d0003o`0003@00omG0000F@02ocD000?o0000=0000ol0000c0003o`0003<00_mJ0000F`03oc<0
0_ld0003o`00038000?o0000<P02oe`0001N00;o<`000ol0000a0003o`00034000?o0000<003oeh0
001P00?o<@000ol0000`0003o`0002l00_la00;oH@0006<00_l`0003o`0002l000?o0000;P000ol0
000^00?oH`0006D00ol^00;o;`000ol0000]0003o`0002d00_mV0000J002obh000?o0000;0000ol0
000/0003o`0002/00omX0000JP03ob`000?o0000:`000ol0000Z00;o;002of/0001]00;o:`000ol0
000Z0003o`0002T000?o0000:P02ofd0001_00;o:P000ol0000Y0003o`0002P000?o0000:003ofl0
001a00?o:002obT000?o00009`000ol0000W00;oLP0007@00_lX0003o`0002H000?o00009P000ol0
000U00?oM00007H00olV0003o`0002D000?o00009002obH00_mg0000N@02obD000?o000090000ol0
000S0003o`0002<00omi0000N`03ob<00_lT0003o`00028000?o00008P02og`0001n00;o8`000ol0
000Q0003o`00024000?o00008@02ogh0002000;o8P000ol0000P0003o`00020000?o00007`03oh00
002200?o80000ol0000O0003o`0001h00_lP00;oP`0008D00_lO0003o`0001h000?o00007@000ol0
000M00?oQ@0008L00olM00;o7P000ol0000L0003o`0001`00_n80000RP02oad000?o00006`000ol0
000K0003o`0001X00on:0000S003oa/000?o00006P000ol0000J0003o`0001T00_n=0000S`02oaX0
00?o00006@000ol0000H00;o6P02ohl0002A00?o6002oaT000?o00005`000ol0000G00?oT@0009@0
0_lH0003o`0001H000?o00005P000ol0000F00;oU00009H00_lG0003o`0001D000?o00005@000ol0
000D00?oUP0009P00olE0003o`0001@000?o00004`02oaD00_nI0000V`02oa@00_lD0003o`000180
00?o00004P03oi/0002M00?o4`000ol0000A0003o`00014000?o00004@02oih0002P00;o4P000ol0
000@0003o`00010000?o00004002oj00002R00?o40000ol0000?0003o`0000l000?o00003P03oj80
002U00;o3`000ol0000>0003o`0000d00_l?00;oY@000:L00ol=00;o3P000ol0000<0003o`0000`0
0onW0000ZP02o`d000?o00002`000ol0000;0003o`0000/00_nZ0000[002o``000?o00002P000ol0
000:0003o`0000T00on/0000[P03o`X000?o00002@000ol000090003o`0000P00_n_0000/@02o`T0
0_l90003o`0000L00_l900;o/@000;<00ol80003o`0000l000?o00001P03ok<0002f00;o1`000ol0
000=0003o`0000D00_nf0000^003oa<000?o00000`03okP0002k00;o5@02ok/0002m0003o`0000l0
0onm0000o`2@0000a@04olH000360003o`000<H000360003o`000<H000360003o`000<H0003500Co
aP000<H000?o0000aP000<H00oo60000o`2@0000o`2@0000o`2@0000o`2@0000o`2@0000\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.1769, -0.625483, 
  0.0109392, 0.00265499}},
  CellTags->"Pattern extraction - mutant 9"],

Cell[TextData[{
  "Selective pattern extraction 9: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"Pattern extraction - mutant 10",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g$387)] .25889 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
0 w
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .02381 .45617 0 0 Mshowa
P
1 g
.25889 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g$387)] .25889 .45617 0 0 Mshowa
P
1 g
.49396 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .49396 .45617 0 0 Mshowa
P
0 w
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(E)] .66089 .30902 0 0 Mshowa
P
1 g
.70632 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(D)] .70632 .30902 0 0 Mshowa
P
1 g
.75175 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .75175 .30902 0 0 Mshowa
P
0 w
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .30902 0 0 Mshowa
P
0 w
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(A)] .61819 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(B)] .97619 .01472 0 0 Mshowa
P
1 g
.79719 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79719 .16187 0 0 Mshowa
P
1 g
.72904 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .72904 .45617 0 0 Mshowa
P
1 g
.96411 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .96411 .45617 0 0 Mshowa
P
1 g
.49396 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .49396 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{399, 246.188},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageRegion->{{Inherited, 1}, {0, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006?0000mPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0T0000?l0T0000?l0T0000?l0T0000?l0
T0000?l0T0000?l0T0000?l0T0000?400_l200;oP`05oa00003b0004o`00ohD000Go0000o`0?0000
lP04ohD000Go0000o`0?0000lP001?l00?n500Co40000?<00_n60005o`000?l03`000?800on500Go
40000?l0T0000?l0T0000?`000?o0000MP000ol0000G0000o@000ol0001d0003o`0001P0003n0003
o`00078000?o00006@000?l00_m`00;o70000?l00P000ol0001/0003o`0001`0003o00<000?o0000
JP000ol0000M0000o`040003o`0006P000?o00007P000?l01@02ofL000?o00007`000?l01`000ol0
001R00;o8P000?l020000ol0001P0003o`000280003o00T000?o0000GP000ol0000S0000o`0:00;o
G@000ol0000T0000o`0<0003o`0005T000?o00009@000?l03@000ol0001F00;o:0000?l03P000ol0
001D0003o`0002P0003o00l000?o0000DP000ol0000Y0000o`0@00;oD@000ol0000Z0000o`0B0003
o`0004`00_l]0000o`0C0003o`0004X000?o0000;@000?l050000ol000180003o`0002h0003o01D0
0_m70003o`0002l0003o01L000?o0000@`000ol0000`0000o`0H0003o`0004000_lc0000o`0I0003
o`0003h000?o0000<`000?l06P02ocd000?o0000=0000?l070000ol0000i0003o`0003D0003o01d0
00?o0000=`000ol0000f0000o`0N0003o`0003@00_li0000o`0O00;o<`000ol0000i0000o`0Q0003
o`0002l000?o0000>P000?l08P000ol0000]0003o`0003/0003o02<000?o0000:P02och0003o02@0
00?o0000:0000ol0000n0000o`0U00;o9`000ol0000o0000o`0W0003o`0002<000?o0000@0000?l0
:0000ol0000Q0003o`000440003o02T000?o00007P02od@0003o02X00_lM0003o`0004@0003o02`0
00?o00006@000ol000150000o`0]0003o`0001L000?o0000AP000?l0;P000ol0000E0003o`0004L0
003o02l00_lC00;oBP000?l0<@000ol0000?0003o`0004X0003o038000?o00003@000ol0001;0000
o`2@0000o`2@0000o`0h00?oE@000?l0>`000ol0001B0000o`0h00CoE0000?l0=`001Ol0003o05@0
003o03L000Go0000o`1D0000o`0g0005o`000?l0E0000?l0>005oe<0003o0900003o0900003o0900
003o0900003o0900003o0900003o0900003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003
o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000
D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000
o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X0
00?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0
001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0
003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0
>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003
o`0005<0003o03X000?o0000D`000?l0>P000ol0001C0000o`0j0003o`0005<0003o03X000?o0000
D`000?l0>P000ol0001C0000o`2@0000o`2@0000o`2@0000o`2@0000o`2@0000o`0h00?oE@000?l0
>`000ol0001B0000o`0200Ko3005o``01Ol>00CoE0000?l00`000ol0000?0005o`000?l030001Ol0
003o00`000Go0000o`1D0000o`030003o`0000l000Go0000o`0<0005o`000?l030001Ol0003o05@0
003o00<01?l>0005o`000?l03004o`d000Go0000o`1D0000o`030003o`0000l000Go0000o`0<0005
o`000?l03@05oe<0003o00801_l<00Go3005ofH0003o0900003o0900003o0900003o0900003o0900
003o00T000?o0000:P000ol0001G0000o`090003o`0000`000?o00002`000ol0000<0003o`0005P0
003o00X000?o000030000ol0000:0003o`0000`000?o0000F0000?l02P000ol0000<0003o`0000X0
00?o00002`000ol0001I0000o`0;0003o`0000/000?o00002P000ol0000;0003o`0005T0003o00/0
00?o00002`000ol0000:0003o`0000X000?o0000FP000?l030000ol0000:0003o`0000X000?o0000
2P000ol0001J0000o`0<0003o`0000X000?o00002P000ol0000:0003o`0005X0003o00d000?o0000
2@000ol000090003o`0000X000?o0000F`000?l03@000ol0000:0003o`0000P000?o00002P000ol0
001K0000o`0>0003o`0000T000?o000020000ol000090003o`0005`0003o00h000?o00002@000ol0
00080003o`0000T000?o0000G0000?l03`000ol000080003o`0000P000?o000020000ol0001M0000
o`0?0003o`0000P000?o000020000ol000080003o`0005d0003o00l000?o000020000ol000070003
o`0000P000?o0000GP000?l040000ol000070003o`0000L000?o000020000ol0001N0000o`0@0003
o`0000P000?o00001P000ol000070003o`0005l0003o014000?o00001`000ol000060003o`0000L0
00?o0000G`000?l04@000ol000070003o`0000H000?o00001P000ol0001P0000o`0B0003o`0000H0
00?o00001P000ol000060003o`000600003o018000?o00001P000ol000050003o`0000H000?o0000
H@000?l04`000ol000050003o`0000D000?o00001P000ol0001Q0000o`0C0003o`0000D000?o0000
1@000ol000050003o`000680003o01@000?o00001@000ol000040003o`0000D000?o0000HP000?l0
50000ol000050003o`0000@000?o000010000ol0001S0000o`0E0003o`0000@000?o000010000ol0
00040003o`0006<0003o01D000?o000010000ol000030003o`0000@000?o0000I0000?l05@000ol0
00040003o`0000<000?o000010000ol0001T0000o`0F0003o`0000<000?o00000`000ol000030003
o`0006D0003o01H000?o00000`000ol000030003o`0000<000?o0000I@000?l05`000ol000030003
o`00008000?o00000P000ol0001V0000o`0G0003o`0000<000?o00000P000ol000020003o`0006H0
003o01P000?o00000P001Ol0003o00@000?o0000I`000?l060000ol000020005o`000?l010000ol0
001W0000o`0I0005o`000?l00`000ol000020003o`0006L0003o01T000Go0000o`030005o`000?l0
JP000?l06P001?l00?l30005o`000?l0JP000?l06P001Ol0003o008000Co003oJ`000?l06`000ol0
00060003o`0006T0003o0900003o0900003o0900003o0900001L00?oo`0a0000G`001Ol0003o0?l0
;00000d00_l200;oB@04o`801?l200?o1003o`<000?o0000B@05oeH00_l00`3oo`1F00Co500000h0
00Co003oB@001Ol0003o008000Co003o1@001?l00?l30005o`000?l0B`001Ol0003o05D000Co003o
F0000ol0000D00003P04odT000Go0000o`0400;o1@001?l00?l30005o`000?l0B`001Ol0003o05D0
00Co003oF@000ol0000C00003P001?l00?m90005o`000?l00P02o`D00_l400?o10000ol000190005
o`000?l0E@001?l00?mJ0003o`000180000?00;oB`05o`050?l00?l01@001?l00?l30003o`3o0080
00?o0000B0001Ol0003o05D01?mJ0003o`000180000>00?o2@02odH01?l200?o1003o`801?m900Go
EP000ol0001?00;o1`03oaD0000L00?oA@000ol0002d00;oCP03ob40000O00?oD@000ol0002O0003
o`0005000olT00008P04odh000?o0000W@000ol0001=00Co9`0002H00om<00;oV`02odd00ol[0000
:@03od/000?o0000U`000ol0001:00?o;P0002`00om900;oU@02odX00ola0000;`03odP00_m80003
o`0004H00_m900?o=00003800om70003o`0004D000?o0000A@000ol0001500Co=`0003D00om500;o
A@000ol0001300;oA@03oc/0000h00Co@`000ol000120003o`00048000?o0000@P03och0000l00?o
@@02od8000?o0000@002od800om10000?`03od0000?o0000?`000ol0000o0003o`0003l00om40000
@P03och00_lo0003o`0003d00_lo00?oA`0004D00olm00;o?@000ol0000k00;o?@04odX0001800?o
?0000ol0000j0003o`0003X000?o0000>P03odh0001;00Co>@02ocX000?o0000>002ocX00omA0000
C`03ocP000?o0000=`000ol0000g0003o`0003L00omD0000DP03ocH00_lg0003o`0003D00_lg00?o
E`0005D00ole00;o=@000ol0000c00;o=P03oeX0001H00?o=0000ol0000b0003o`00038000?o0000
<P04oed0001K00?o<P02oc8000?o0000<002oc800omQ0000GP04oc0000?o0000;`000ol0000_0003
o`0002l00omT0000HP03obh00_l_0003o`0002d00_l_00?oI`0006D00ol]0003o`0002`000?o0000
;0000ol0000/00?oJP0006P00ol[00;o;0000ol0000Z00;o:`04ofd0001[00?o:P02obX000?o0000
:002obX00oma0000KP03obT000?o00009`000ol0000W0003o`0002L00omd0000L@03obL00_lW0003
o`0002D00_lW00?oM`0007@01?lU0003o`0002@000?o000090000ol0000T00?oNP0007P00olS00;o
90000ol0000R00;o9003ogd0001k00?o8P000ol0000Q0003o`00024000?o00008004oh00001n00?o
8002ob4000?o00007`02ob000on40000P@03oal00_lO0003o`0001d00_lO00?oQ`0008@00olN0003
o`0001`000?o000070000ol0000L00?oRP0008L01?lK00;o70000ol0000J00;o7003ohd0002;00?o
6P000ol0000I0003o`0001T000?o00006@03oi00002>00?o6002oaT000?o00005`02oaP01?nC0000
T@03oaL00_lG0003o`0001D00_lG00?oU`0009@00olF0003o`0001@000?o000050000ol0000D00?o
VP0009L00olD00;o50000ol0000B00;o5003oid0002J00Co4P000ol0000A0003o`00014000?o0000
4@03oj00002N00?o4002oa4000?o00003`02oa400onS0000X@03o`l000?o00003P000ol0000>0003
o`0000d01?nV0000Y003o`d00_l>0003o`0000`00_l=00?oZP000:L00ol<00;o30000ol0000:00;o
3003ojd0002Z00?o2`000ol0000E0003o`0000T00on`0000[@03o`T00_lC00;o2@03ok<0002`00Co
1`000ol0000?0003o`0000D01?nf0000]003o`D000?o00003@000ol0000300?o^P000;L00olE00?o
_@000;X00_lA00;o`0000<801?o90000``000ol000390000``000ol000390000``000ol000390000
`P04olT000330003o`000<T0003300?ob@000?l0T0000?l0T0000?l0T0000?l0T0000?l0T0000001
\
\>"],
  ImageRangeCache->{{{0, 398}, {245.188, 0}} -> {-2.17917, -0.833976, 
  0.0110797, 0.00353999}},
  CellTags->"Pattern extraction - mutant 10"],

Cell[TextData[{
  "Selective pattern extraction 10: ",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(Basic\ expression\),
          ButtonData:>"Pattern extraction - basic expression",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"Pattern extraction - mutant 1",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0,
  AnimationDisplayTime->1.00948]
}, Open  ]],

Cell[CellGroupData[{

Cell["Decapsulation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Decapsulation /@ macroChromos", "InputDemo",
  AspectRatioFixed->True],

Cell[OutputFormData[
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>", 
"\<\
pop[chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], 2]]], 
 
  chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A, B]]], \
2]]]]\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Loading external packages", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Defining the packages directory", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Note",
  StyleBox[": Evaluate the following cells to load the definitions needed to \
perform any calculations in this notebook.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "For setting the ",
  StyleBox["Evolvica Directory",
    FontWeight->"Bold"],
  StyleBox[" ",
    FontSlant->"Italic"],
  "please refer to the ",
  ButtonBox["IEC Notebook",
    ButtonData:>{
      FrontEnd`FileName[ {"..", "..", "IEC-Contents.nb"}], 
      "Setting EVOLVICA Directory"},
    ButtonStyle->"Hyperlink"],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SetDirectory[\[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
"\<Chapters\>", \[IndentingNewLine]"\<08-AdvancedGP\>", "\<Packages\>"}]]\)], \
"Input",
  InitializationCell->True],

Cell[BoxData[
    \("/Users/jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/08-\
AdvancedGP/Packages"\)], "Output"]
}, Open  ]],

Cell["To turn off spelling error messages:", "Text"],

Cell["Off[General::spell1]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reading packages", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Expression Generation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"ExprGeneration.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extraction of Substructures", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"Filters.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Implementation", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Generating Expressions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Generating Lists of Expressions", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
createExpressions[howMany_Integer, startPattern_, opts___] :=
Module[{exprs = {}, lim = 10 howMany, i=0},

  While[(Length[exprs] < howMany) && (i < lim),
  
    exprs = Union[exprs ~Join~ 
      {createExpression[startPattern, opts]}];
    i++
  ];
  
  If[i === lim, 
    Print[\"Warning: \",howMany,
          \" diff. expressions not possible.\"]];
    
  exprs
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Options[createExpressions] := Options[createExpression]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["createExpressions[2, x, ExprPatterns -> {a}]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[\("Warning: "\[InvisibleSpace]2\[InvisibleSpace]" diff. \
expressions not possible."\),
      SequenceForm[ "Warning: ", 2, " diff. expressions not possible."],
      Editable->False]], "Print"],

Cell[BoxData[
    \({createExpression[x, ExprPatterns \[Rule] {a}]}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Generation Function for Expressions", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
createExpression[startPattern_, opts___] :=
Module[{patts, depth, cont = True, i = 1, tr, expr},

  depth = MaxDepth /. {opts} /. Options[createExpression];
  patts = ExprPatterns /. {opts} /. Options[createExpression];
  tr    = Trials /. {opts} /. Options[createExpression];
  
  While[cont,
    expr = randomExpr[startPattern, depth, patts, opts];
             
    If[Not[PatternQ[expr]], cont = False];
    
    If[i > tr,
      Print[\"Warning: No pattern free expression after \",
        tr,\" trials.\"];
      cont = False
    ];
    i++
  ];
  
  expr
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[createExpression] =
{
  MaxDepth -> 10, Trials -> 10,
  ExprPatterns -> {}, ExprWeights -> {}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Random Expressions: randomExpr", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[randomExpr]", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Variable Number of Arguments", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_BlankSequence, depth_?Positive,
           patterns_List, opts___] :=
Module[{argRange},
  
  argRange = SequenceRange /. {opts} /. Options[randomExpr];
  
  Sequence @@ Table[
    randomExpr[
      If[Length[pat]>0,
        If[Head[First[pat]] === Alternatives,
          First[pat],
          Blank[First[pat]]],
        _],
      depth, patterns, opts],
    {Random[Integer,argRange]}]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_BlankNullSequence, depth_?Positive,
           patterns_List, opts___] :=
Module[{argRange},
  
  argRange = SequenceRange /. {opts} /. Options[randomExpr];
  
  Sequence @@ Table[
    randomExpr[
      If[Length[pat]>0,
        If[Head[First[pat]] === Alternatives,
          First[pat],
          Blank[First[pat]]],
        _],
      depth, patterns, opts],
    {randomSelect[Union[{0},argRange]]}]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Alternative Arguments", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_Alternatives, depth_?Positive,
           patterns_List, opts___] :=
Module[{},
  
  (*randomExpr[randomSelect[pat], depth, patterns, opts]*)
  
  randomExpr[
    randomSelectWeight[patterns,pat,opts], 
    depth, patterns, opts
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Condition", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_Condition, depth_?Positive,
           patterns_List, opts___] :=
Module[{randPat},
  
  randPat = randomSelectWeight[patterns, pat, opts];
  
  If[randPat === {},
    pat,
    randomExpr[randPat, depth, patterns, opts]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Blank Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_Blank, depth_?Positive,
           patterns_List, opts___] :=
Module[{randPat},
  
  randPat = randomSelectWeight[patterns, pat, opts];
  
  If[randPat === {},
    pat,
    randomExpr[randPat, depth, patterns, opts]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Expressions with Patterns or Alternatives", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[startPattern_/; (PatternQ[startPattern] ||
                            AlternativesQ[startPattern]), 
           maxDepth_?Positive,
           patterns_List, opts___] :=
Module[{},
      
  Map[
    randomExpr[#, maxDepth-1,patterns,opts]&, 
    startPattern, Heads -> True]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Expressions without Patterns or Alternatives", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[np_/; Not[PatternQ[np]] && Not[AlternativesQ[np]], 
           maxDepth_?NonNegative,
           patterns_List, opts___] := np\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Level-0 Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["randomExpr[pat_, 0, _List, opts___] := pat", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[randomExpr] =
{
  SequenceRange -> {1,1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["S-Expression Chromosomes", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["S-Expression Chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(createChromosomes[howMany_, \ opts___]\  := \n
      Apply[pop, \n\ \ \(chromo[q[undef], 
              p[#]] &\)\  /@ \n\ \ createExpressions[
            howMany, \n\ \ \ \ \(StartPattern\  /. \ {opts}\)\  /. \ 
              Options[createChromosomes], \n\ \ \ \ opts]]\)], "Input",
  InitializationCell->True],

Cell["\<\
Options[createChromosomes] =
{
  StartPattern -> _
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Genetic Operators", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Reproduction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Copying a GP Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Copy[chromoPop_pop, opts___] :=
Module[{},

  pop[ Selection[chromoPop, opts]//First ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Recombination of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Recombination[chromoPop_pop, opts___] :=
Module[{exprOne, exprTwo},

  exprOne = First[Last[Selection[chromoPop, opts]//First]];
  exprTwo = First[Last[Selection[chromoPop, opts]//First]];
  
  pop @@ Map[chromo[q[undef],p[#]]&,
    exprRecombination[{exprOne,exprTwo},opts]//First]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Recombination] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Recombination] =
{
  {{_}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprRecombination[exprs_List, opts___] :=
Module[{randPos, randSubs},

  randPos = 
  Map[
    randomSelect[
      exprInstances[#, 
        selectTemplate[getTemplates[Recombination,opts]]]//Last
    ]&, 
    exprs];
      
  randSubs = 
  MapThread[Part[#1, Sequence @@ #2]&, {exprs,randPos}];
  
  {MapThread[ReplacePart,
    {exprs, RotateRight[randSubs], randPos}], randPos}
  
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Extension of ReplacePart", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Unprotect[ReplacePart];

ReplacePart[expr_, new_, {}] := new

Protect[ReplacePart];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mutation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Mutation of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Mutation[chromoPop_pop, opts___] :=
Module[{},

  pop[ Mutation[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Mutation of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Mutation[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprMutation[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Mutation] = {RespectHead -> True};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Mutation] =
{
  {{_}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Mutation of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprMutation[expr_, opts___] :=
Module[{randPos, newSubExpr, insts, instPos, theHead},

  {insts, instPos} =
  exprInstances[expr, 
    selectTemplate[getTemplates[Mutation,opts]]];
    
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  
  theHead = 
  If[RespectHead /. {opts} /. Options[Mutation],
    Blank[Head[Part[expr, Sequence @@ randPos]]], 
    Blank[]
  ];
  
  newSubExpr = createExpression[theHead, opts];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Duplication of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Duplication[chromoPop_pop, opts___] :=
Module[{},

  pop[ Duplication[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Duplication[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprDuplication[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Duplication] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Duplication] =
{
  {{_, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["exprDuplication[atomExpr_?AtomQ, opts___] := atomExpr", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprDuplication[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, i1, i2, l},

  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Duplication,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
  
  l = Length[subExpr];
  {i1, i2} = 
  Sort[Table[Random[Integer,{1,l=Length[subExpr]}],{2}]];
  
  newSubExpr = 
  Join[
    Take[subExpr, Max[0,i1-1]],
    Take[subExpr, {i1,i2}], Take[subExpr, {i1,i2}],
    Take[subExpr, Min[l,i2]-l]
  ];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Deletion of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Deletion[chromoPop_pop, opts___] :=
Module[{},

  pop[ Deletion[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Deletion[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprDeletion[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Deletion] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Deletion] =
{
  {{_, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["exprDeletion[atomExpr_?AtomQ, opts___] := atomExpr", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[{
  "exprDeletion[expr_, opts___] :=\nModule[{instPos, randPos, subExpr, \
newSubExpr, i1, i2, l},\n\n  instPos =\n  exprInstances[expr, \n    \
selectTemplate[getTemplates[Deletion,opts]]] // Last;\n  \n  If[instPos === \
{}, Return[{expr,{}}]];\n  \n  randPos = randomSelect[instPos];\n  subExpr = \
Part[expr, Sequence @@ randPos];\n  \n  l = Length[subExpr];\n  {i1, i2} = \n \
 Sort[Table[Random[Integer,{1,l=Length[subExpr]}],{2}]];\n  \n  newSubExpr = \
\n  Join[\n    Take[subExpr, Max[0,i1-1]],\n    Take[subExpr, Min[l,i2]-l]\n  \
];\n  \n  ",
  StyleBox["(* If no argument left, return original expression *)",
    FontSlant->"Italic"],
  "\n  If[Length[newSubExpr] == 0, newSubExpr = subExpr];\n  \n  \
{ReplacePart[expr, newSubExpr, randPos], randPos}\n]"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Inversion of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Inversion[chromoPop_pop, opts___] :=
Module[{},

  pop[ Inversion[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Inversion[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprInversion[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[Inversion] =
{
  InvPermutation :> 
    randomSelect[
    {
      Reverse, 
      RotateRight[#,Random[Integer,{1,Length[#]}]]&
    }]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Inversion] =
{
  {{_, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["exprInversion[atomExpr_?AtomQ, opts___] := atomExpr", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprInversion[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, 
        i1, i2, l, perm},

  perm = InvPermutation /. {opts} /. Options[Inversion];
  
  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Inversion,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
  
  l = Length[subExpr];
  {i1, i2} = 
  Sort[Table[Random[Integer,{1,l=Length[subExpr]}],{2}]];
  
  newSubExpr = 
  Join[
    Take[subExpr, Max[0,i1-1]],
    perm[Take[subExpr, {i1,i2}]],
    Take[subExpr, Min[l,i2]-l]
  ];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Encapsulation of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Encapsulation[chromoPop_pop, opts___] :=
Module[{},

  pop[ Encapsulation[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Encapsulation[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprEncapsulation[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Encapsulation] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Encapsulation] =
{
  {{_, _, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprEncapsulation[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, i1, i2, l},

  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Encapsulation,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
  
  {encRule, newSubExpr} = 
    patternExtraction[subExpr,Depth[subExpr]];
    
  AppendTo[EncapsulationRules, encRule];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos, encRule}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Decapsulation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Decapsulation of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Decapsulation[chromoPop_pop, opts___] :=
Module[{},

  pop[ Decapsulation[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Decapsulation of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Decapsulation[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprDecapsulation[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Decapsulation] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Decapsulation] =
{
  {{_}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Decapsulation of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprDecapsulation[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, i1, i2, l},
  
  {expr /. EncapsulationRules, {}}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Macro Extraction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Macro Extraction of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
MacroExtraction[chromoPop_pop, opts___] :=
Module[{},

  pop[ MacroExtraction[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Macro Extraction of an S-Expression Chromosome ", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
MacroExtraction[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprMacroExtraction[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[MacroExtraction] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[MacroExtraction] =
{
  {{_, _, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Macro Extraction of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprMacroExtraction[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr},

  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Encapsulation,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
    
  {encRule, newSubExpr} = 
    patternExtraction[subExpr,
      Random[Integer,{1,Depth[subExpr]}]];
    
  AppendTo[EncapsulationRules, encRule];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos, encRule}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Pattern Extraction", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[patternExtraction]", "Input",
  AspectRatioFixed->True],

Cell["patternExtraction[expr_, 0] := {expr, {}}", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
patternExtraction[expr_, level_Integer /; level > 0] :=
Module[{doReplacePart, uniqueVars, searchLevel,
        instances, instHeads, patternList, patternPosList,
        vars, fctHead},

  (* Locally defined functions *)
  
  doReplacePart[e_,{n_,p_}] := ReplacePart[e,n,p];
  
  uniqueVars[sym_String, howMany_Integer] :=
    ToExpression[sym <> ToString[#]]& /@ Range[howMany];
    
  (* Extract instances and their heads *)
  searchLevel = {level,level};
  instances   = Cases[expr, _, searchLevel];
  instHeads   = Head /@ instances;
  
  patternList = 
    MapThread[
      (**If[#1 === Symbol, 
        Pattern[#2,Blank[]], Pattern[#2,Blank[#1]]]&,**)
      Pattern[#2,Blank[#1]]&,
      {instHeads, vars = uniqueVars[\"x\",Length[instHeads]]}];
      
  patternPosList = 
    First[Position[expr,#,searchLevel]]& /@ instances;
    
  fctHead = Unique[Head[expr]];
  
  {(**Fold[doReplacePart, expr, 
     {patternList, patternPosList} // Transpose],**)
     
   RULE[
     fctHead @@ patternList,
     Fold[doReplacePart, expr,
       {vars, patternPosList} // Transpose]
   ] /. {RULE -> RuleDelayed},
   
   vars = {vars, Part[expr, Sequence @@ #]& /@ patternPosList}
          // Transpose;
   fctHead @@ (#[[2]]& /@ vars)
  }   
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Utility Functions", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Template Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
selectTemplate[templList_List] :=
Module[{templs, weights},

  (* Extract templates and weights *)
  
  templs = First /@ templList;
  weights = Last /@ templList;
  (**Print[templs]; Print[weights];**)
  
  (* Select template index fitness-proportionate *)
  
  templs[[selectFitProp[weights]]] 
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Template Composition", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
getTemplates[op_, opts___] :=
Module[{},

  Templates /. {opts} /. {Templates -> Templates[op]}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Random Selection on Lists", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Random Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomSelect[s_List] := 
  s[[Random[Integer,{1,Length[s]}]]]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Multiple Random Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomSelectMultiple[s_List,n_Integer:1,opts___] :=
Module[{m,i},
  m=Map[s[[#]]&,i=Take[RandomPermutation[Length[s]],n]];
  
  If[ReturnIndices /. {opts} /. Options[randomSelectMultiple],
    {m,i},
    m
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Options[randomSelectMultiple] = {ReturnIndices -> False};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection on Lists", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Fitness-proportionate Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[selectFitProp]", "Input",
  AspectRatioFixed->True],

Cell["\<\
selectFitProp[fitnesses_, opts___] :=
Module[{cumFits, fits, r, m},

  fits = 
  If[Negative[m = Min[fitnesses]], fitnesses -m, fitnesses];
  
  cumFits = FoldList[Plus, 0, fits] // Rest;
  
  r = Random[] Last[cumFits];
  
  Position[cumFits, _?(# >= r &), {1}, 1][[1,1]]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["selectFitProp[{-2,-2,-2}]", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
1\
\>", "\<\
1\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Rank-based Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[selectRankBased]", "Input",
  AspectRatioFixed->True],

Cell["\<\
selectRankBased[fitnesses_, opts___] :=
Module[{fitsAndIndsSorted, index},
  
  fitsAndIndsSorted = 
    Sort[MapIndexed[{#1,First[#2]}&,fitnesses]];
  
  index = selectFitProp[Range[Length[fitnesses]]];
  
  fitsAndIndsSorted[[index]]//Last
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Elite Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
selectElite[fitnesses_, opts___] :=
Module[{bestCount, fitsAndIndsSorted},

  bestCount = Elite /. {opts} /. Options[selectElite];
  
  fitsAndIndsSorted = 
    Reverse[Sort[MapIndexed[{#1,First[#2]}&,fitnesses]]];
    
  selectRandom[
    Last /@ 
    If[IntegerQ[bestCount],
      Take[fitsAndIndsSorted, bestCount],
      Take[fitsAndIndsSorted, 
        Max[1, Floor[bestCount Length[fitnesses]]]]
    ]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[selectElite] =
{
  Elite -> 1
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Best Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
selectBest[fitnesses_, opts___] :=
Module[{bestCount, fitsAndIndsSorted},

  bestCount = Best /. {opts} /. Options[selectBest];
  
  fitsAndIndsSorted = 
    Reverse[Sort[MapIndexed[{#1,First[#2]}&,fitnesses]]];
    
  Last /@ 
  If[IntegerQ[bestCount],
    Take[fitsAndIndsSorted, bestCount],
    Take[fitsAndIndsSorted, 
      Max[1, Floor[bestCount Length[fitnesses]]]]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Best\)\" is similar to \
existing symbols \!\({Nest, Rest}\)."\)], "Message"]
}, Open  ]],

Cell["\<\
Options[selectBest] =
{
  Best -> 1
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection of GP Chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Selection Function", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Selection[population_pop,howMany_Integer:1,
  opts___] :=
  
Module[{},
  
  Switch[
    SelectionMode /. {opts} /. Options[Selection],
    
    BEST,
      Take[
        population // Sort // Reverse,
        howMany
      ],
      
    RANDOM,
      pop @@
      Table[
        population[[Random[Integer,
                           {1,Length[population]}]]],
        {howMany}
      ],
      
    FITPROP,
      Table[
        population[[
          selectFitProp[extractQuals[population],opts]
        ]],
        {howMany}],
        
    RANKBASED,
      Table[
        population[[
          selectRankBased[extractQuals[population],opts]
        ]],
        {howMany}],
        
    ELITE,
      Table[
        population[[
          selectElite[extractQuals[population],opts,
            Elite -> 1.
          ]
        ]],
        {howMany}]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[Selection] =
{
  SelectionMode -> FITPROP
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Extraction of Fitness Values", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
extractQuals[population_pop] := 
  List @@ Map[First[First[#]]&,population]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Evaluation Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Evaluation Function", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Evaluation[chromo[quality_q,prog_p,x___],
  opts___] :=

Module[{g},

  g = EvaluationFunction /. {opts} /. Options[Evaluation];
  
  chromo[q[g[prog]//N],prog,x]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[Evaluation] =
{
  EvaluationFunction :> Depth
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["GP Evolution Scheme", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[Evolution]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(Evolution[\[IndentingNewLine]GP[
            m_?IntegerQ,  (*parents*) \[IndentingNewLine]s_?
              AtomQ,  (*PLUS\ or\ COMMA*) \[IndentingNewLine]l_?
              IntegerQ,  (*children*) \[IndentingNewLine]g_?
              IntegerQ,  (*generations*) \[IndentingNewLine]opts___]\ i_:  
          1\  (*options*) \  (*independent\ runs*) ] \
:= \[IndentingNewLine]Module[\[IndentingNewLine]{initialParents, evalFct, 
          parents, children, selPool, selectOperator, opsAndProbs, 
          gen}, \[IndentingNewLine]\[IndentingNewLine]Print["\<GP evolution \
...\>"]; \[IndentingNewLine]\[IndentingNewLine] (*Define\ an\ operator\ \
selection\ function*) 
          opsAndProbs = \(Operators /. {opts}\) /. 
            Options[Evolution]; \
\[IndentingNewLine]\[IndentingNewLine]selectOperator := \(First[
              Transpose[opsAndProbs]]\)[\([selectFitProp[
                Last[Transpose[
                    opsAndProbs]]]]\)]; \
\[IndentingNewLine]\[IndentingNewLine] (*Generate\ m\ initial\ individuals\
*) \[IndentingNewLine]If[\((initialParents = \((\(InitialPopulation /. {opts}\
\) /. Options[Evolution])\))\) === {}, \(initialParents = 
              createChromosomes[m, 
                opts];\)\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*Get\ the\ evaluation\ \
function*) \[IndentingNewLine]evalFct = \(EvaluationFunction /. {opts}\) /. 
            Options[Evaluation]; \[IndentingNewLine]\[IndentingNewLine] \
(*Evaluate\ initial\ individuals*) Print["\<Generation \>", 
          gen = 0]; \[IndentingNewLine]\[IndentingNewLine]initialParents = 
          Map[Evaluation[#, EvaluationFunction \[RuleDelayed] evalFct] &, 
            initialParents]; \[IndentingNewLine]\[IndentingNewLine] (*Iterate\
\ for\ i\ independent\ runs*) \[IndentingNewLine]Table[ (*Iterate\ for\ g\ \
generations*) 
            NestList[\((Print["\<Generation \>", \(++gen\)]; \
\[IndentingNewLine]parents = #; \[IndentingNewLine]children = 
                  pop[]; \[IndentingNewLine]\[IndentingNewLine]While[
                  Length[children] < l, 
                  children = 
                    children~Join~
                      selectOperator[parents, 
                        opts]]; \
\[IndentingNewLine]\[IndentingNewLine]children = 
                  Map[Evaluation[#, opts] &, 
                    Take[children, 
                      l]]; \[IndentingNewLine]\[IndentingNewLine]selPool = 
                  Switch[s, PLUS, Join[parents, children], COMMA, 
                    children]; \[IndentingNewLine]\[IndentingNewLine]selPool \
= Join[selPool, Selection[parents, 1, 
                      SelectionMode \[Rule] 
                        BEST]]; \
\[IndentingNewLine]\[IndentingNewLine]Selection[selPool, m, 
                  SelectionMode \[Rule] BEST])\) &, initialParents, 
            g\[IndentingNewLine]],  (*end\ nesting*) \[IndentingNewLine]{i}\  \
(*independent\ runs*) \[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  InitializationCell->True],

Cell["\<\
Options[Evolution] = 
{
  InitialPopulation -> {},
  SelectionMode -> FITPROP,
  
  Operators -> {{Recombination, .5},
                {Mutation -> .25},
                {Copy -> .25}
               },
  
  MaxDepth -> 2,
  ExprPatterns -> {},
  ExprAtoms -> {}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualization", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Terms as Trees", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Terms in Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["TermPlot[chromo[_q, p[t_]], opts___] := TermPlot[t,opts]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Terms in Chromosome Populations", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["TermPlot[p_pop, opts___] := TermPlot[#,opts]& /@ p", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fitness Values", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Needs[\"Statistics`DescriptiveStatistics`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`FilledPlot`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["ClearAll[plotFitnesses]", "Input",
  AspectRatioFixed->True],

Cell["\<\
plotFitnesses[es_List,opts___] :=
Module[{fitnesses},

  fitnesses =
    Map[Sort[Cases[#,_q,Infinity]]&,es] /. {q[x_] :> x};
    
  ListFilledPlot[Map[Max[#]&,fitnesses],
                 Map[Mean[#]&,fitnesses],
    PlotRange -> All,
    AxesLabel -> {\"Gen.\",\"Fit.\"},
    PlotLabel -> FontForm[\"Best and Mean Fitness\\n\" <>
      PlotTitle /. {opts} /. Options[plotFitnesses],
                   {\"Helvetica-Bold\",10}]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[plotFitnesses] =
{
  PlotTitle -> \"\"
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Playground ", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
printFitnesses[es_List] :=
Module[{fitnesses},

  fitnesses =
    Map[Sort[Cases[#,_q,Infinity]]&,es] /. {q[x_] :> x}
]\
\>", "Input",
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Saving GP Experiment Data", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
saveGPData[gp_,file_String:\"\"] := 
Module[{fileName},

  If[file === \"\",
    fileName = StringReplace[\"GP-Data.\" <> ToString[Unique[GA]],
                 \"$\" -> \"\"],
    fileName = file
  ];
  
  Put[gp,fileName];
  
  fileName
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Utility Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Random Selection: randomSelect, randomSelectWeight, fitPropSelect\
\
\>", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Random Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["randomSelect[s_] := s[[Random[Integer,{1,Length[s]}]]]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["randomSelect[{}] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection of Weighted Patterns", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomSelectWeight[selExpr_, pat_, opts___] :=
Module[{weights, matchPat, matchPos, matchWeights},

  weights = ExprWeights /. {opts} 
            /. {ExprWeights :> Table[1,{Length[selExpr]}]};
  
  {matchPat, matchPos} = 
    {Cases[selExpr, pat], 
     Position[selExpr, pat, 1, Heads -> False]};
  (**Print[\"matchPat: \",matchPat];**)
  (**Print[\"matchPos: \",matchPos];**)
  
  matchWeights = Map[weights[[#//First]]&, matchPos];
  (**Print[\"matchWeights: \", matchWeights];**)
  pos = fitPropSelect[matchWeights];
  (**Print[\"pos: \",pos];**)
  matchPat[[pos]]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Fitness-proportionate Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
fitPropSelect[fitnesses_, opts___] :=
Module[{cumFits, fits, r, m},

  fits = 
  If[Negative[m = Min[fitnesses]], fitnesses -m, fitnesses];
  
  cumFits = FoldList[Plus, 0, fits] // Rest;
  
  r = Random[] Last[cumFits];
  
  Position[cumFits, _?(# >= r &), {1}, 1][[1,1]]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["fitPropSelect[{}, opts___] := {}", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Testing for Pattern Expressions: PatternQ", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
PatternQ[x_] :=
Module[{realPats,pats},

  {realPats,pats} = {{Blank, BlankSequence,BlankNullSequence},
                     {BLANK, BLANKSEQ, BLANKNULLSEQ}};

  If[Count[{x} /. MapThread[#1->#2&,{realPats,pats}],
       Alternatives @@ Map[#[___]&,pats],Infinity,
       Heads -> True] > 0, 
    True, False
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Testing for Alternatives: AlternativesQ", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
AlternativesQ[x_] :=
Module[{realPats,pats},

  {realPats,pats} = {{Alternatives},
                     {ALTERNATIVES}};

  If[Count[{x} /. MapThread[#1->#2&,{realPats,pats}],
       Alternatives @@ Map[#[___]&,pats],Infinity,
       Heads -> True] > 0, 
    True, False
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["AlternativesQ[g[a ]]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(False\)], "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "C. Jacob, ",
  StyleBox["Illustrating Evolutionary Computation with Mathematica.",
    FontWeight->"Bold"],
  " Morgan Kaufmann Publishers, San Fancisco, 2001. Chapter 8.\n"
}], "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 746}},
AutoGeneratedPackage->None,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{822, 704},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellBracket->False,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"MacintoshAutomaticEncoding",
StyleDefinitions -> FrontEnd`FileName[{ParentDirectory[ParentDirectory[]], \
"IEC-Setup"}, "EvolvicaStyle.nb", CharacterEncoding -> "MacintoshRoman"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Mutation - Intro"->{
    Cell[28934, 834, 49, 1, 26, "Text",
      CellTags->"Mutation - Intro"]},
  "Mutation - basic expression"->{
    Cell[75635, 2105, 12952, 357, 315, 3575, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - basic expression"]},
  "GP-Mutation - mutant 1"->{
    Cell[92551, 2603, 15988, 444, 310, 4479, 295, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 1"]},
  "GP-Mutation - mutant 2"->{
    Cell[108998, 3067, 15228, 421, 310, 4239, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 2"]},
  "GP-Mutation - mutant 3"->{
    Cell[124673, 3507, 13050, 358, 310, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 3"]},
  "GP-Mutation - mutant 4"->{
    Cell[138170, 3884, 13054, 358, 310, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 4"]},
  "GP-Mutation - mutant 5"->{
    Cell[151671, 4261, 13026, 358, 310, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 5"]},
  "GP-Mutation - mutant 6"->{
    Cell[165144, 4638, 4066, 93, 310, 627, 44, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 6"]},
  "GP-Mutation - mutant 7"->{
    Cell[169657, 4750, 13070, 358, 310, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 7"]},
  "GP-Mutation - mutant 8"->{
    Cell[183174, 5127, 13034, 358, 310, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 8"]},
  "GP-Mutation - mutant 9"->{
    Cell[196655, 5504, 14527, 401, 310, 4020, 265, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 9"]},
  "GP-Mutation - mutant 10"->{
    Cell[211630, 5924, 23603, 747, 310, 8426, 553, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"GP-Mutation - mutant 10"]},
  "Mutation - basic expression 2"->{
    Cell[236141, 6714, 12874, 356, 310, 3575, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - basic expression 2"]},
  "Mutation - mutant 1"->{
    Cell[252857, 7189, 13044, 359, 310, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 1"]},
  "Mutation - mutant 2"->{
    Cell[266404, 7569, 13765, 379, 310, 3787, 249, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 2"]},
  "Mutation - mutant 3"->{
    Cell[280660, 7968, 13741, 379, 310, 3787, 249, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 3"]},
  "Mutation - mutant 4"->{
    Cell[294892, 8367, 13428, 339, 310, 3111, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 4"]},
  "Mutation - mutant 5"->{
    Cell[308811, 8726, 14311, 361, 310, 3330, 219, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 5"]},
  "Mutation - mutant 6"->{
    Cell[323613, 9107, 13052, 359, 310, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 6"]},
  "Mutation - mutant 7"->{
    Cell[337156, 9486, 13733, 379, 310, 3787, 249, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 7"]},
  "Mutation - mutant 8"->{
    Cell[351380, 9885, 13745, 379, 310, 3787, 249, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 8"]},
  "Mutation - mutant 9"->{
    Cell[365616, 10284, 15932, 407, 310, 3694, 249, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 9"]},
  "Mutation - mutant 10"->{
    Cell[382040, 10711, 13445, 339, 310, 3111, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Mutation - mutant 10"]},
  "Recombination - Intro"->{
    Cell[396119, 11079, 54, 1, 26, "Text",
      CellTags->"Recombination - Intro"]},
  "Recombination - basic expressions"->{
    Cell[414626, 11743, 10340, 325, 228, 3575, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - basic expressions"],
    Cell[424969, 12070, 10072, 322, 228, 3510, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - basic expressions"]},
  "Recombination - expression pair 1"->{
    Cell[438801, 12527, 14457, 532, 221, 6482, 427, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 1"],
    Cell[453261, 13061, 2975, 79, 221, 627, 44, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 1"]},
  "Recombination - expression pair 2"->{
    Cell[456787, 13164, 10109, 323, 221, 3494, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 2"],
    Cell[466899, 13489, 10125, 323, 221, 3494, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 2"]},
  "Recombination - expression pair 3"->{
    Cell[477563, 13835, 10191, 299, 221, 3042, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 3"],
    Cell[487757, 14136, 11365, 362, 221, 4009, 265, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 3"]},
  "Recombination - expression pair 4"->{
    Cell[499661, 14521, 11306, 362, 221, 3938, 265, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 4"],
    Cell[510970, 14885, 9066, 284, 221, 3116, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 4"]},
  "Recombination - expression pair 5"->{
    Cell[520575, 15192, 9098, 237, 221, 2147, 145, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 5"],
    Cell[529676, 15431, 12433, 424, 221, 4897, 325, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination - expression pair 5"]},
  "Recombination sel - expression pair 1"->{
    Cell[546351, 15999, 10121, 323, 221, 3494, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 1"],
    Cell[556475, 16324, 10235, 323, 221, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 1"]},
  "Recombination sel - expression pair 2"->{
    Cell[567275, 16671, 11369, 362, 221, 4009, 265, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 2"],
    Cell[578647, 17035, 10195, 299, 221, 3042, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 2"]},
  "Recombination sel - expression pair 3"->{
    Cell[589395, 17357, 10248, 299, 221, 3111, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 3"],
    Cell[599646, 17658, 10346, 349, 221, 3997, 265, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 3"]},
  "Recombination sel - expression pair 4"->{
    Cell[610545, 18030, 10109, 323, 221, 3494, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 4"],
    Cell[620657, 18355, 10251, 323, 221, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 4"]},
  "Recombination sel - expression pair 5"->{
    Cell[631461, 18701, 10109, 323, 221, 3494, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 5"],
    Cell[641573, 19026, 10251, 323, 221, 3568, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Recombination sel - expression pair 5"]},
  "Duplication - Intro"->{
    Cell[652495, 19379, 52, 1, 26, "Text",
      CellTags->"Duplication - Intro"]},
  "Duplication - basic expression"->{
    Cell[666049, 19823, 11786, 257, 304, 1436, 123, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - basic expression"]},
  "Duplication - mutant 1"->{
    Cell[682721, 20273, 12159, 265, 304, 1489, 127, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 1"]},
  "Duplication - mutant 2"->{
    Cell[695390, 20559, 12386, 268, 304, 1489, 127, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 2"]},
  "Duplication - mutant 3"->{
    Cell[708274, 20847, 13913, 302, 304, 1676, 145, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 3"]},
  "Duplication - mutant 4"->{
    Cell[722685, 21169, 13462, 295, 304, 1666, 143, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 4"]},
  "Duplication - mutant 5"->{
    Cell[736645, 21484, 14148, 310, 304, 1737, 151, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 5"]},
  "Duplication - mutant 6"->{
    Cell[751291, 21814, 13462, 295, 304, 1666, 143, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 6"]},
  "Duplication - mutant 7"->{
    Cell[765251, 22129, 12668, 278, 304, 1593, 135, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 7"]},
  "Duplication - mutant 8"->{
    Cell[778417, 22427, 13226, 288, 304, 1613, 139, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 8"]},
  "Duplication - mutant 9"->{
    Cell[792141, 22735, 12929, 278, 304, 1542, 131, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 9"]},
  "Duplication - mutant 10"->{
    Cell[805569, 23033, 18868, 415, 304, 2325, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Duplication - mutant 10"]},
  "Deletion - Intro"->{
    Cell[825083, 23477, 49, 1, 26, "Text",
      CellTags->"Deletion - Intro"]},
  "Deletion - basic expression"->{
    Cell[838634, 23921, 9222, 225, 244, 1436, 123, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - basic expression"]},
  "Deletion - mutant 1"->{
    Cell[851568, 24273, 8077, 199, 244, 1210, 109, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 1"]},
  "Deletion - mutant 2"->{
    Cell[860146, 24493, 8077, 199, 244, 1210, 109, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 2"]},
  "Deletion - mutant 3"->{
    Cell[868712, 24712, 8077, 199, 244, 1210, 109, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 3"]},
  "Deletion - mutant 4"->{
    Cell[877278, 24931, 6539, 155, 244, 981, 81, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 4"]},
  "Deletion - mutant 5"->{
    Cell[884306, 25106, 8077, 199, 244, 1210, 109, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 5"]},
  "Deletion - mutant 6"->{
    Cell[892872, 25325, 8077, 199, 244, 1210, 109, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 6"]},
  "Deletion - mutant 7"->{
    Cell[901438, 25544, 9024, 217, 244, 1365, 117, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 7"]},
  "Deletion - mutant 8"->{
    Cell[910951, 25781, 6539, 155, 244, 981, 81, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 8"]},
  "Deletion - mutant 9"->{
    Cell[917979, 25956, 7919, 193, 244, 1251, 105, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 9"]},
  "Deletion - mutant 10"->{
    Cell[926388, 26169, 8784, 217, 244, 1328, 119, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Deletion - mutant 10"]},
  "Inversion - Intro"->{
    Cell[935810, 26415, 50, 1, 26, "Text",
      CellTags->"Inversion - Intro"]},
  "Inversion - basic expression"->{
    Cell[936547, 26456, 12659, 390, 244, 4258, 281, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - basic expression"]},
  "Inversion - mutant 1"->{
    Cell[962657, 27210, 11609, 375, 221, 4197, 277, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 1"]},
  "Inversion - mutant 2"->{
    Cell[974770, 27606, 11574, 377, 221, 4126, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 2"]},
  "Inversion - mutant 3"->{
    Cell[986836, 28003, 11591, 377, 221, 4119, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 3"]},
  "Inversion - mutant 4"->{
    Cell[998919, 28400, 11659, 377, 221, 4215, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 4"]},
  "Inversion - mutant 5"->{
    Cell[1011070, 28797, 11591, 378, 221, 4098, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 5"]},
  "Inversion - mutant 6"->{
    Cell[1023153, 29195, 11606, 377, 221, 4134, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 6"]},
  "Inversion - mutant 7"->{
    Cell[1035251, 29592, 11591, 377, 221, 4119, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 7"]},
  "Inversion - mutant 8"->{
    Cell[1047334, 29989, 11667, 377, 221, 4215, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 8"]},
  "Inversion - mutant 9"->{
    Cell[1059493, 30386, 11655, 377, 221, 4215, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 9"]},
  "Inversion - mutant 10"->{
    Cell[1071641, 30783, 11638, 375, 221, 4201, 277, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Inversion - mutant 10"]},
  "Encapsulation - Intro"->{
    Cell[1175800, 33461, 54, 1, 26, "Text",
      CellTags->"Encapsulation - Intro"]},
  "Encapsulation - basic expression"->{
    Cell[1177854, 33571, 14481, 414, 310, 4258, 281, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - basic expression"]},
  "Encapsulation - mutant 1"->{
    Cell[1205703, 34353, 11371, 290, 307, 2594, 175, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 1"]},
  "Encapsulation - mutant 2"->{
    Cell[1217590, 34664, 13770, 390, 307, 4001, 263, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 2"]},
  "Encapsulation - mutant 3"->{
    Cell[1231864, 35074, 13725, 389, 307, 4001, 263, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 3"]},
  "Encapsulation - mutant 4"->{
    Cell[1246093, 35483, 11807, 330, 307, 3334, 219, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 4"]},
  "Encapsulation - mutant 5"->{
    Cell[1258404, 35833, 11807, 330, 307, 3334, 219, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 5"]},
  "Encapsulation - mutant 6"->{
    Cell[1270715, 36183, 13770, 390, 307, 4001, 263, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 6"]},
  "Encapsulation - mutant 7"->{
    Cell[1284989, 36593, 13757, 389, 307, 4001, 263, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 7"]},
  "Encapsulation - mutant 8"->{
    Cell[1299250, 37002, 11391, 290, 307, 2594, 175, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 8"]},
  "Encapsulation - mutant 9"->{
    Cell[1311145, 37312, 15256, 398, 307, 3701, 249, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 9"]},
  "Encapsulation - mutant 10"->{
    Cell[1326906, 37730, 11800, 330, 307, 3334, 219, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Encapsulation - mutant 10"]},
  "Pattern extraction - Intro"->{
    Cell[1339358, 38089, 59, 1, 26, "Text",
      CellTags->"Pattern extraction - Intro"]},
  "Pattern extraction - basic expression"->{
    Cell[1343600, 38306, 15036, 420, 327, 4258, 281, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - basic expression"]},
  "Pattern extraction - mutant 1"->{
    Cell[1363739, 38909, 16407, 424, 317, 3920, 263, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 1"]},
  "Pattern extraction - mutant 2"->{
    Cell[1380677, 39354, 13435, 338, 317, 3115, 205, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 2"]},
  "Pattern extraction - mutant 3"->{
    Cell[1394631, 39712, 14652, 414, 317, 4230, 279, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 3"]},
  "Pattern extraction - mutant 4"->{
    Cell[1409802, 40146, 16447, 424, 317, 3920, 263, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 4"]},
  "Pattern extraction - mutant 5"->{
    Cell[1426768, 40590, 12697, 354, 317, 3563, 235, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 5"]},
  "Pattern extraction - mutant 6"->{
    Cell[1439984, 40964, 4359, 96, 317, 635, 44, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 6"]},
  "Pattern extraction - mutant 7"->{
    Cell[1444862, 41080, 14035, 359, 317, 3342, 221, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 7"]},
  "Pattern extraction - mutant 8"->{
    Cell[1459416, 41459, 9055, 177, 317, 1088, 73, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 8"]},
  "Pattern extraction - mutant 9"->{
    Cell[1468990, 41656, 16398, 423, 317, 3920, 263, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 9"]},
  "Pattern extraction - mutant 10"->{
    Cell[1485908, 42099, 12129, 334, 317, 3334, 219, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Pattern extraction - mutant 10"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Mutation - Intro", 1546808, 44634},
  {"Mutation - basic expression", 1546921, 44637},
  {"GP-Mutation - mutant 1", 1547123, 44642},
  {"GP-Mutation - mutant 2", 1547320, 44647},
  {"GP-Mutation - mutant 3", 1547518, 44652},
  {"GP-Mutation - mutant 4", 1547716, 44657},
  {"GP-Mutation - mutant 5", 1547914, 44662},
  {"GP-Mutation - mutant 6", 1548112, 44667},
  {"GP-Mutation - mutant 7", 1548306, 44672},
  {"GP-Mutation - mutant 8", 1548504, 44677},
  {"GP-Mutation - mutant 9", 1548702, 44682},
  {"GP-Mutation - mutant 10", 1548901, 44687},
  {"Mutation - basic expression 2", 1549107, 44692},
  {"Mutation - mutant 1", 1549309, 44697},
  {"Mutation - mutant 2", 1549501, 44702},
  {"Mutation - mutant 3", 1549693, 44707},
  {"Mutation - mutant 4", 1549885, 44712},
  {"Mutation - mutant 5", 1550077, 44717},
  {"Mutation - mutant 6", 1550269, 44722},
  {"Mutation - mutant 7", 1550461, 44727},
  {"Mutation - mutant 8", 1550653, 44732},
  {"Mutation - mutant 9", 1550845, 44737},
  {"Mutation - mutant 10", 1551039, 44742},
  {"Recombination - Intro", 1551235, 44747},
  {"Recombination - basic expressions", 1551362, 44750},
  {"Recombination - expression pair 1", 1551762, 44759},
  {"Recombination - expression pair 2", 1552158, 44768},
  {"Recombination - expression pair 3", 1552558, 44777},
  {"Recombination - expression pair 4", 1552958, 44786},
  {"Recombination - expression pair 5", 1553357, 44795},
  {"Recombination sel - expression pair 1", 1553760, 44804},
  {"Recombination sel - expression pair 2", 1554172, 44813},
  {"Recombination sel - expression pair 3", 1554584, 44822},
  {"Recombination sel - expression pair 4", 1554996, 44831},
  {"Recombination sel - expression pair 5", 1555408, 44840},
  {"Duplication - Intro", 1555802, 44849},
  {"Duplication - basic expression", 1555924, 44852},
  {"Duplication - mutant 1", 1556131, 44857},
  {"Duplication - mutant 2", 1556330, 44862},
  {"Duplication - mutant 3", 1556529, 44867},
  {"Duplication - mutant 4", 1556728, 44872},
  {"Duplication - mutant 5", 1556927, 44877},
  {"Duplication - mutant 6", 1557126, 44882},
  {"Duplication - mutant 7", 1557325, 44887},
  {"Duplication - mutant 8", 1557524, 44892},
  {"Duplication - mutant 9", 1557723, 44897},
  {"Duplication - mutant 10", 1557923, 44902},
  {"Deletion - Intro", 1558117, 44907},
  {"Deletion - basic expression", 1558233, 44910},
  {"Deletion - mutant 1", 1558433, 44915},
  {"Deletion - mutant 2", 1558625, 44920},
  {"Deletion - mutant 3", 1558817, 44925},
  {"Deletion - mutant 4", 1559009, 44930},
  {"Deletion - mutant 5", 1559199, 44935},
  {"Deletion - mutant 6", 1559391, 44940},
  {"Deletion - mutant 7", 1559583, 44945},
  {"Deletion - mutant 8", 1559775, 44950},
  {"Deletion - mutant 9", 1559965, 44955},
  {"Deletion - mutant 10", 1560158, 44960},
  {"Inversion - Intro", 1560349, 44965},
  {"Inversion - basic expression", 1560467, 44968},
  {"Inversion - mutant 1", 1560670, 44973},
  {"Inversion - mutant 2", 1560865, 44978},
  {"Inversion - mutant 3", 1561060, 44983},
  {"Inversion - mutant 4", 1561255, 44988},
  {"Inversion - mutant 5", 1561450, 44993},
  {"Inversion - mutant 6", 1561646, 44998},
  {"Inversion - mutant 7", 1561842, 45003},
  {"Inversion - mutant 8", 1562038, 45008},
  {"Inversion - mutant 9", 1562234, 45013},
  {"Inversion - mutant 10", 1562431, 45018},
  {"Encapsulation - Intro", 1562629, 45023},
  {"Encapsulation - basic expression", 1562756, 45026},
  {"Encapsulation - mutant 1", 1562968, 45031},
  {"Encapsulation - mutant 2", 1563172, 45036},
  {"Encapsulation - mutant 3", 1563376, 45041},
  {"Encapsulation - mutant 4", 1563580, 45046},
  {"Encapsulation - mutant 5", 1563784, 45051},
  {"Encapsulation - mutant 6", 1563988, 45056},
  {"Encapsulation - mutant 7", 1564192, 45061},
  {"Encapsulation - mutant 8", 1564396, 45066},
  {"Encapsulation - mutant 9", 1564600, 45071},
  {"Encapsulation - mutant 10", 1564805, 45076},
  {"Pattern extraction - Intro", 1565012, 45081},
  {"Pattern extraction - basic expression", 1565149, 45084},
  {"Pattern extraction - mutant 1", 1565371, 45089},
  {"Pattern extraction - mutant 2", 1565585, 45094},
  {"Pattern extraction - mutant 3", 1565799, 45099},
  {"Pattern extraction - mutant 4", 1566013, 45104},
  {"Pattern extraction - mutant 5", 1566227, 45109},
  {"Pattern extraction - mutant 6", 1566441, 45114},
  {"Pattern extraction - mutant 7", 1566651, 45119},
  {"Pattern extraction - mutant 8", 1566865, 45124},
  {"Pattern extraction - mutant 9", 1567077, 45129},
  {"Pattern extraction - mutant 10", 1567292, 45134}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 185, 6, 167, "Title",
  Evaluatable->False],
Cell[1964, 61, 113, 3, 62, "Subsubtitle"],
Cell[2080, 66, 25970, 732, 152, "Text"],

Cell[CellGroupData[{
Cell[28075, 802, 80, 2, 76, "Subtitle",
  Evaluatable->False],
Cell[28158, 806, 325, 8, 44, "Text"],
Cell[28486, 816, 223, 3, 152, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28746, 824, 85, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[28856, 830, 75, 2, 78, "Section",
  Evaluatable->False],
Cell[28934, 834, 49, 1, 26, "Text",
  CellTags->"Mutation - Intro"],

Cell[CellGroupData[{
Cell[29008, 839, 79, 2, 56, "Subsection",
  Evaluatable->False],
Cell[29090, 843, 210, 4, 57, "InputDemo"]
}, Closed]],

Cell[CellGroupData[{
Cell[29337, 852, 105, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[29467, 858, 227, 5, 57, "InputDemo"],
Cell[29697, 865, 147, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29881, 874, 85, 1, 41, "InputDemo"],
Cell[29969, 877, 44979, 1187, 245, 21154, 887, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[74997, 2070, 91, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[75113, 2076, 156, 10, 146, "InputDemo"],
Cell[75272, 2088, 239, 9, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[75548, 2102, 84, 1, 41, "InputDemo"],
Cell[75635, 2105, 12952, 357, 315, 3575, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[88636, 2468, 88, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[88749, 2474, 89, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[88863, 2480, 276, 10, 146, "InputDemo"],
Cell[89142, 2492, 1645, 57, 350, "Output",
  Evaluatable->False],
Cell[90790, 2551, 1507, 37, 207, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[92346, 2594, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[92457, 2600, 91, 1, 41, "InputDemo"],
Cell[92551, 2603, 15988, 444, 310, 4479, 295, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 1"]
}, Open  ]],
Cell[108554, 3050, 441, 15, 29, "Text"],
Cell[108998, 3067, 15228, 421, 310, 4239, 279, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 2"],
Cell[124229, 3490, 441, 15, 29, "Text"],
Cell[124673, 3507, 13050, 358, 310, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 3"],
Cell[137726, 3867, 441, 15, 29, "Text"],
Cell[138170, 3884, 13054, 358, 310, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 4"],
Cell[151227, 4244, 441, 15, 29, "Text"],
Cell[151671, 4261, 13026, 358, 310, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 5"],
Cell[164700, 4621, 441, 15, 29, "Text"],
Cell[165144, 4638, 4066, 93, 310, 627, 44, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 6"],
Cell[169213, 4733, 441, 15, 29, "Text"],
Cell[169657, 4750, 13070, 358, 310, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 7"],
Cell[182730, 5110, 441, 15, 29, "Text"],
Cell[183174, 5127, 13034, 358, 310, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 8"],
Cell[196211, 5487, 441, 15, 29, "Text"],
Cell[196655, 5504, 14527, 401, 310, 4020, 265, "GraphicsData", "PostScript",
   "Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 9"],
Cell[211185, 5907, 442, 15, 29, "Text"],
Cell[211630, 5924, 23603, 747, 310, 8426, 553, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"GP-Mutation - mutant 10"],
Cell[235236, 6673, 443, 15, 29, "Text"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[235728, 6694, 89, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[235842, 6700, 45, 0, 60, "Subsubsection"],
Cell[235890, 6702, 139, 5, 71, "InputDemo"],

Cell[CellGroupData[{
Cell[236054, 6711, 84, 1, 41, "InputDemo"],
Cell[236141, 6714, 12874, 356, 310, 3575, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - basic expression 2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[249064, 7076, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[249168, 7080, 155, 3, 44, "Text"],

Cell[CellGroupData[{
Cell[249348, 7087, 391, 11, 161, "InputDemo"],
Cell[249742, 7100, 1460, 44, 187, "Output",
  Evaluatable->False],
Cell[251205, 7146, 1365, 27, 155, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[252619, 7179, 119, 3, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[252763, 7186, 91, 1, 41, "InputDemo"],
Cell[252857, 7189, 13044, 359, 310, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 1"]
}, Open  ]],
Cell[265916, 7551, 485, 16, 29, "Text"],
Cell[266404, 7569, 13765, 379, 310, 3787, 249, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 2"],
Cell[280172, 7950, 485, 16, 29, "Text"],
Cell[280660, 7968, 13741, 379, 310, 3787, 249, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 3"],
Cell[294404, 8349, 485, 16, 29, "Text"],
Cell[294892, 8367, 13428, 339, 310, 3111, 205, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 4"],
Cell[308323, 8708, 485, 16, 29, "Text"],
Cell[308811, 8726, 14311, 361, 310, 3330, 219, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 5"],
Cell[323125, 9089, 485, 16, 29, "Text"],
Cell[323613, 9107, 13052, 359, 310, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 6"],
Cell[336668, 9468, 485, 16, 29, "Text"],
Cell[337156, 9486, 13733, 379, 310, 3787, 249, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 7"],
Cell[350892, 9867, 485, 16, 29, "Text"],
Cell[351380, 9885, 13745, 379, 310, 3787, 249, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 8"],
Cell[365128, 10266, 485, 16, 29, "Text"],
Cell[365616, 10284, 15932, 407, 310, 3694, 249, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 9"],
Cell[381551, 10693, 486, 16, 29, "Text"],
Cell[382040, 10711, 13445, 339, 310, 3111, 205, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Mutation - mutant 10"],
Cell[395488, 11052, 487, 16, 29, "Text"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[396036, 11075, 80, 2, 62, "Section",
  Evaluatable->False],
Cell[396119, 11079, 54, 1, 26, "Text",
  CellTags->"Recombination - Intro"],

Cell[CellGroupData[{
Cell[396198, 11084, 79, 2, 56, "Subsection",
  Evaluatable->False],
Cell[396280, 11088, 199, 14, 206, "InputDemo"]
}, Closed]],

Cell[CellGroupData[{
Cell[396516, 11107, 105, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[396646, 11113, 242, 8, 116, "InputDemo"],
Cell[396891, 11123, 324, 12, 59, "Output",
  Evaluatable->False]
}, Open  ]],
Cell[397230, 11138, 181, 6, 71, "InputDemo"],

Cell[CellGroupData[{
Cell[397436, 11148, 85, 1, 41, "InputDemo"],
Cell[397524, 11151, 16174, 540, 244, 6176, 411, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[413747, 11697, 92, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[413864, 11703, 238, 15, 221, "InputDemo"],
Cell[414105, 11720, 375, 13, 59, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[414517, 11738, 84, 1, 41, "InputDemo"],

Cell[CellGroupData[{
Cell[414626, 11743, 10340, 325, 228, 3575, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - basic expressions"],
Cell[424969, 12070, 10072, 322, 228, 3510, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - basic expressions"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[435102, 12399, 113, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[435240, 12405, 109, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[435374, 12411, 168, 6, 86, "InputDemo"],
Cell[435545, 12419, 1391, 33, 207, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[436973, 12457, 57, 1, 41, "InputDemo"],
Cell[437033, 12460, 1492, 50, 219, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[438574, 12516, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[438685, 12522, 91, 1, 41, "InputDemo"],

Cell[CellGroupData[{
Cell[438801, 12527, 14457, 532, 221, 6482, 427, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 1"],
Cell[453261, 13061, 2975, 79, 221, 627, 44, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 1"]
}, Open  ]]
}, Open  ]],
Cell[456263, 13144, 499, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[456787, 13164, 10109, 323, 221, 3494, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 2"],
Cell[466899, 13489, 10125, 323, 221, 3494, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 2"]
}, Open  ]],
Cell[477039, 13815, 499, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[477563, 13835, 10191, 299, 221, 3042, 205, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 3"],
Cell[487757, 14136, 11365, 362, 221, 4009, 265, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 3"]
}, Open  ]],
Cell[499137, 14501, 499, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[499661, 14521, 11306, 362, 221, 3938, 265, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 4"],
Cell[510970, 14885, 9066, 284, 221, 3116, 205, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 4"]
}, Open  ]],
Cell[520051, 15172, 499, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[520575, 15192, 9098, 237, 221, 2147, 145, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 5"],
Cell[529676, 15431, 12433, 424, 221, 4897, 325, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination - expression pair 5"]
}, Open  ]],
Cell[542124, 15858, 500, 16, 29, "Text"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[542673, 15880, 103, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[542801, 15886, 121, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[542947, 15892, 198, 7, 101, "InputDemo"],
Cell[543148, 15901, 1367, 28, 155, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[544552, 15934, 57, 1, 41, "InputDemo"],
Cell[544612, 15937, 1463, 45, 187, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[546124, 15988, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[546235, 15994, 91, 1, 41, "InputDemo"],

Cell[CellGroupData[{
Cell[546351, 15999, 10121, 323, 221, 3494, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 1"],
Cell[556475, 16324, 10235, 323, 221, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 1"]
}, Open  ]]
}, Open  ]],
Cell[566737, 16651, 513, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[567275, 16671, 11369, 362, 221, 4009, 265, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 2"],
Cell[578647, 17035, 10195, 299, 221, 3042, 205, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 2"]
}, Open  ]],
Cell[588857, 17337, 513, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[589395, 17357, 10248, 299, 221, 3111, 205, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 3"],
Cell[599646, 17658, 10346, 349, 221, 3997, 265, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 3"]
}, Open  ]],
Cell[610007, 18010, 513, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[610545, 18030, 10109, 323, 221, 3494, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 4"],
Cell[620657, 18355, 10251, 323, 221, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 4"]
}, Open  ]],
Cell[630923, 18681, 513, 16, 29, "Text"],

Cell[CellGroupData[{
Cell[631461, 18701, 10109, 323, 221, 3494, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 5"],
Cell[641573, 19026, 10251, 323, 221, 3568, 235, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Recombination sel - expression pair 5"]
}, Open  ]],
Cell[651839, 19352, 514, 16, 29, "Text"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[652414, 19375, 78, 2, 62, "Section",
  Evaluatable->False],
Cell[652495, 19379, 52, 1, 26, "Text",
  CellTags->"Duplication - Intro"],

Cell[CellGroupData[{
Cell[652572, 19384, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[652683, 19390, 166, 10, 146, "InputDemo"],
Cell[652852, 19402, 258, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[653147, 19417, 84, 1, 41, "InputDemo"],
Cell[653234, 19420, 12615, 389, 244, 4258, 281, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[665886, 19814, 160, 7, 101, "InputDemo"],
Cell[666049, 19823, 11786, 257, 304, 1436, 123, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[677884, 20086, 90, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[677999, 20092, 94, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[678118, 20098, 290, 12, 176, "InputDemo"],
Cell[678411, 20112, 2075, 83, 506, "Output",
  Evaluatable->False],
Cell[680489, 20197, 1899, 57, 337, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[682437, 20260, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[682548, 20266, 170, 5, 71, "InputDemo"],
Cell[682721, 20273, 12159, 265, 304, 1489, 127, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 1"]
}, Open  ]],
Cell[694895, 20541, 492, 16, 29, "Text"],
Cell[695390, 20559, 12386, 268, 304, 1489, 127, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 2"],
Cell[707779, 20829, 492, 16, 29, "Text"],
Cell[708274, 20847, 13913, 302, 304, 1676, 145, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 3"],
Cell[722190, 21151, 492, 16, 29, "Text"],
Cell[722685, 21169, 13462, 295, 304, 1666, 143, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 4"],
Cell[736150, 21466, 492, 16, 29, "Text"],
Cell[736645, 21484, 14148, 310, 304, 1737, 151, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 5"],
Cell[750796, 21796, 492, 16, 29, "Text"],
Cell[751291, 21814, 13462, 295, 304, 1666, 143, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 6"],
Cell[764756, 22111, 492, 16, 29, "Text"],
Cell[765251, 22129, 12668, 278, 304, 1593, 135, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 7"],
Cell[777922, 22409, 492, 16, 29, "Text"],
Cell[778417, 22427, 13226, 288, 304, 1613, 139, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 8"],
Cell[791646, 22717, 492, 16, 29, "Text"],
Cell[792141, 22735, 12929, 278, 304, 1542, 131, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 9"],
Cell[805073, 23015, 493, 16, 29, "Text"],
Cell[805569, 23033, 18868, 415, 304, 2325, 205, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Duplication - mutant 10"],
Cell[824440, 23450, 494, 16, 29, "Text"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[824995, 23473, 85, 2, 62, "Section",
  Evaluatable->False],
Cell[825083, 23477, 49, 1, 26, "Text",
  CellTags->"Deletion - Intro"],

Cell[CellGroupData[{
Cell[825157, 23482, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[825268, 23488, 166, 10, 146, "InputDemo"],
Cell[825437, 23500, 258, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[825732, 23515, 84, 1, 41, "InputDemo"],
Cell[825819, 23518, 12615, 389, 244, 4258, 281, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[838471, 23912, 160, 7, 101, "InputDemo"],
Cell[838634, 23921, 9222, 225, 244, 1436, 123, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[847905, 24152, 87, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[848017, 24158, 94, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[848136, 24164, 287, 12, 176, "InputDemo"],
Cell[848426, 24178, 1462, 46, 272, "Output",
  Evaluatable->False],
Cell[849891, 24226, 1344, 28, 155, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[851284, 24260, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[851395, 24266, 170, 5, 71, "InputDemo"],
Cell[851568, 24273, 8077, 199, 244, 1210, 109, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 1"]
}, Open  ]],
Cell[859660, 24475, 483, 16, 29, "Text"],
Cell[860146, 24493, 8077, 199, 244, 1210, 109, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 2"],
Cell[868226, 24694, 483, 16, 29, "Text"],
Cell[868712, 24712, 8077, 199, 244, 1210, 109, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 3"],
Cell[876792, 24913, 483, 16, 29, "Text"],
Cell[877278, 24931, 6539, 155, 244, 981, 81, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 4"],
Cell[883820, 25088, 483, 16, 29, "Text"],
Cell[884306, 25106, 8077, 199, 244, 1210, 109, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 5"],
Cell[892386, 25307, 483, 16, 29, "Text"],
Cell[892872, 25325, 8077, 199, 244, 1210, 109, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 6"],
Cell[900952, 25526, 483, 16, 29, "Text"],
Cell[901438, 25544, 9024, 217, 244, 1365, 117, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 7"],
Cell[910465, 25763, 483, 16, 29, "Text"],
Cell[910951, 25781, 6539, 155, 244, 981, 81, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 8"],
Cell[917493, 25938, 483, 16, 29, "Text"],
Cell[917979, 25956, 7919, 193, 244, 1251, 105, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 9"],
Cell[925901, 26151, 484, 16, 29, "Text"],
Cell[926388, 26169, 8784, 217, 244, 1328, 119, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Deletion - mutant 10"],
Cell[935175, 26388, 485, 16, 29, "Text"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[935721, 26411, 86, 2, 62, "Section",
  Evaluatable->False],
Cell[935810, 26415, 50, 1, 26, "Text",
  CellTags->"Inversion - Intro"],

Cell[CellGroupData[{
Cell[935885, 26420, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[935996, 26426, 166, 10, 146, "InputDemo"],
Cell[936165, 26438, 258, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[936460, 26453, 84, 1, 41, "InputDemo"],
Cell[936547, 26456, 12659, 390, 244, 4258, 281, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Inversion - basic expression"]
}, Open  ]],

Cell[CellGroupData[{
Cell[949243, 26851, 195, 6, 86, "InputDemo"],
Cell[949441, 26859, 9179, 224, 244, 1436, 123, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[958669, 27089, 88, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[958782, 27095, 103, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[958910, 27101, 288, 12, 176, "InputDemo"],
Cell[959201, 27115, 1671, 49, 272, "Output",
  Evaluatable->False],
Cell[960875, 27166, 1548, 28, 155, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[962472, 27200, 38, 0, 60, "Subsubsection"],

Cell[CellGroupData[{
Cell[962535, 27204, 119, 4, 41, "InputDemo"],
Cell[962657, 27210, 11609, 375, 221, 4197, 277, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 1"]
}, Open  ]],
Cell[974281, 27588, 486, 16, 29, "Text"],
Cell[974770, 27606, 11574, 377, 221, 4126, 279, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 2"],
Cell[986347, 27985, 486, 16, 29, "Text"],
Cell[986836, 28003, 11591, 377, 221, 4119, 279, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 3"],
Cell[998430, 28382, 486, 16, 29, "Text"],
Cell[998919, 28400, 11659, 377, 221, 4215, 279, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 4"],
Cell[1010581, 28779, 486, 16, 29, "Text"],
Cell[1011070, 28797, 11591, 378, 221, 4098, 279, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 5"],
Cell[1022664, 29177, 486, 16, 29, "Text"],
Cell[1023153, 29195, 11606, 377, 221, 4134, 279, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 6"],
Cell[1034762, 29574, 486, 16, 29, "Text"],
Cell[1035251, 29592, 11591, 377, 221, 4119, 279, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 7"],
Cell[1046845, 29971, 486, 16, 29, "Text"],
Cell[1047334, 29989, 11667, 377, 221, 4215, 279, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 8"],
Cell[1059004, 30368, 486, 16, 29, "Text"],
Cell[1059493, 30386, 11655, 377, 221, 4215, 279, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 9"],
Cell[1071151, 30765, 487, 16, 29, "Text"],
Cell[1071641, 30783, 11638, 375, 221, 4201, 277, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Inversion - mutant 10"],
Cell[1083282, 31160, 488, 16, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1083807, 31181, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1083933, 31187, 170, 5, 71, "InputDemo"],

Cell[CellGroupData[{
Cell[1084128, 31196, 9177, 220, 244, 1414, 119, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1093308, 31418, 9099, 222, 244, 1363, 121, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1102410, 31642, 9112, 226, 244, 1380, 125, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1111525, 31870, 9179, 224, 244, 1436, 123, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1120707, 32096, 9117, 222, 244, 1349, 121, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1129827, 32320, 9121, 226, 244, 1389, 125, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1138951, 32548, 9112, 226, 244, 1380, 125, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1148066, 32776, 9179, 224, 244, 1436, 123, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1157248, 33002, 9179, 224, 244, 1436, 123, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1166430, 33228, 9184, 220, 244, 1416, 119, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1175699, 33457, 98, 2, 62, "Section",
  Evaluatable->False],
Cell[1175800, 33461, 54, 1, 26, "Text",
  CellTags->"Encapsulation - Intro"],

Cell[CellGroupData[{
Cell[1175879, 33466, 103, 2, 56, "Subsection",
  Evaluatable->False],
Cell[1175985, 33470, 115, 4, 56, "InputDemo"],

Cell[CellGroupData[{
Cell[1176125, 33478, 162, 6, 86, "InputDemo"],
Cell[1176290, 33486, 272, 12, 59, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1176599, 33503, 65, 1, 41, "InputDemo"],
Cell[1176667, 33506, 149, 7, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1176853, 33518, 73, 1, 41, "InputDemo"],
Cell[1176929, 33521, 214, 8, 43, "Output",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1177192, 33535, 86, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1177303, 33541, 166, 10, 146, "InputDemo"],
Cell[1177472, 33553, 258, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1177767, 33568, 84, 1, 41, "InputDemo"],
Cell[1177854, 33571, 14481, 414, 310, 4258, 281, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - basic expression"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1192372, 33990, 195, 6, 86, "InputDemo"],
Cell[1192570, 33998, 9179, 224, 244, 1436, 123, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1201798, 34228, 92, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1201915, 34234, 112, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1202052, 34240, 199, 8, 116, "InputDemo"],
Cell[1202254, 34250, 1638, 54, 324, "Output",
  Evaluatable->False],
Cell[1203895, 34306, 1476, 28, 155, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1205420, 34340, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1205531, 34346, 169, 5, 71, "InputDemo"],
Cell[1205703, 34353, 11371, 290, 307, 2594, 175, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 1"]
}, Open  ]],
Cell[1217089, 34646, 498, 16, 29, "Text"],
Cell[1217590, 34664, 13770, 390, 307, 4001, 263, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 2"],
Cell[1231363, 35056, 498, 16, 29, "Text"],
Cell[1231864, 35074, 13725, 389, 307, 4001, 263, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 3"],
Cell[1245592, 35465, 498, 16, 29, "Text"],
Cell[1246093, 35483, 11807, 330, 307, 3334, 219, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 4"],
Cell[1257903, 35815, 498, 16, 29, "Text"],
Cell[1258404, 35833, 11807, 330, 307, 3334, 219, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 5"],
Cell[1270214, 36165, 498, 16, 29, "Text"],
Cell[1270715, 36183, 13770, 390, 307, 4001, 263, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 6"],
Cell[1284488, 36575, 498, 16, 29, "Text"],
Cell[1284989, 36593, 13757, 389, 307, 4001, 263, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 7"],
Cell[1298749, 36984, 498, 16, 29, "Text"],
Cell[1299250, 37002, 11391, 290, 307, 2594, 175, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 8"],
Cell[1310644, 37294, 498, 16, 29, "Text"],
Cell[1311145, 37312, 15256, 398, 307, 3701, 249, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 9"],
Cell[1326404, 37712, 499, 16, 29, "Text"],
Cell[1326906, 37730, 11800, 330, 307, 3334, 219, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Encapsulation - mutant 10"],
Cell[1338709, 38062, 500, 16, 29, "Text"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1339270, 38085, 85, 2, 62, "Section",
  Evaluatable->False],
Cell[1339358, 38089, 59, 1, 26, "Text",
  CellTags->"Pattern extraction - Intro"],

Cell[CellGroupData[{
Cell[1339442, 38094, 102, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1339569, 38100, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1339661, 38104, 80, 1, 41, "InputDemo"],

Cell[CellGroupData[{
Cell[1339766, 38109, 61, 1, 41, "InputDemo"],
Cell[1339830, 38112, 104, 6, 43, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1339983, 38124, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1340109, 38130, 76, 1, 41, "InputDemo"],
Cell[1340188, 38133, 175, 7, 43, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1340412, 38146, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1340538, 38152, 90, 1, 41, "InputDemo"],
Cell[1340631, 38155, 266, 10, 51, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1340946, 38171, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1341072, 38177, 90, 1, 41, "InputDemo"],
Cell[1341165, 38180, 277, 11, 51, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1341491, 38197, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1341617, 38203, 90, 1, 41, "InputDemo"],
Cell[1341710, 38206, 225, 9, 51, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1341984, 38221, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1342110, 38227, 90, 1, 41, "InputDemo"],
Cell[1342203, 38230, 203, 9, 51, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1342455, 38245, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1342581, 38251, 90, 1, 41, "InputDemo"],
Cell[1342674, 38254, 203, 9, 51, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1342938, 38270, 86, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1343049, 38276, 166, 10, 146, "InputDemo"],
Cell[1343218, 38288, 258, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1343513, 38303, 84, 1, 41, "InputDemo"],
Cell[1343600, 38306, 15036, 420, 327, 4258, 281, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - basic expression"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1358685, 38732, 97, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1358807, 38738, 94, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1358926, 38744, 198, 8, 116, "InputDemo"],
Cell[1359127, 38754, 1463, 51, 203, "Output",
  Evaluatable->False],
Cell[1360593, 38807, 1342, 28, 155, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1361984, 38841, 108, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1362117, 38847, 65, 1, 41, "InputDemo"],
Cell[1362185, 38850, 1220, 40, 171, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1363454, 38896, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1363565, 38902, 171, 5, 71, "InputDemo"],
Cell[1363739, 38909, 16407, 424, 317, 3920, 263, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 1"]
}, Open  ]],
Cell[1380161, 39336, 513, 16, 29, "Text"],
Cell[1380677, 39354, 13435, 338, 317, 3115, 205, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 2"],
Cell[1394115, 39694, 513, 16, 29, "Text"],
Cell[1394631, 39712, 14652, 414, 317, 4230, 279, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 3"],
Cell[1409286, 40128, 513, 16, 29, "Text"],
Cell[1409802, 40146, 16447, 424, 317, 3920, 263, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 4"],
Cell[1426252, 40572, 513, 16, 29, "Text"],
Cell[1426768, 40590, 12697, 354, 317, 3563, 235, "GraphicsData", "PostScript",
   "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 5"],
Cell[1439468, 40946, 513, 16, 29, "Text"],
Cell[1439984, 40964, 4359, 96, 317, 635, 44, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 6"],
Cell[1444346, 41062, 513, 16, 29, "Text"],
Cell[1444862, 41080, 14035, 359, 317, 3342, 221, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 7"],
Cell[1458900, 41441, 513, 16, 29, "Text"],
Cell[1459416, 41459, 9055, 177, 317, 1088, 73, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 8"],
Cell[1468474, 41638, 513, 16, 29, "Text"],
Cell[1468990, 41656, 16398, 423, 317, 3920, 263, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 9"],
Cell[1485391, 42081, 514, 16, 29, "Text"],
Cell[1485908, 42099, 12129, 334, 317, 3334, 219, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Pattern extraction - mutant 10"],
Cell[1498040, 42435, 515, 16, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1498592, 42456, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1498703, 42462, 76, 1, 41, "InputDemo"],
Cell[1498782, 42465, 1648, 48, 187, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1500515, 42522, 93, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1500633, 42528, 101, 2, 56, "Subsection",
  Evaluatable->False],
Cell[1500737, 42532, 208, 6, 26, "Text"],
Cell[1500948, 42540, 355, 13, 26, "Text"],

Cell[CellGroupData[{
Cell[1501328, 42557, 201, 4, 73, "Input",
  InitializationCell->True],
Cell[1501532, 42563, 126, 2, 56, "Output"]
}, Open  ]],
Cell[1501673, 42568, 52, 0, 26, "Text"],
Cell[1501728, 42570, 91, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1501856, 42577, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1501967, 42583, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1502064, 42587, 96, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1502197, 42594, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1502300, 42598, 89, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1502450, 42607, 82, 2, 50, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1502557, 42613, 89, 2, 78, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1502671, 42619, 101, 2, 56, "Subsection",
  Evaluatable->False],
Cell[1502775, 42623, 446, 19, 266, "Input",
  InitializationCell->True],
Cell[1503224, 42644, 126, 2, 41, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[1503375, 42650, 87, 1, 41, "Input"],
Cell[1503465, 42653, 230, 4, 70, "Print"],
Cell[1503698, 42659, 81, 1, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1503828, 42666, 105, 2, 40, "Subsection",
  Evaluatable->False],
Cell[1503936, 42670, 643, 25, 356, "Input",
  InitializationCell->True],
Cell[1504582, 42697, 183, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1504802, 42710, 100, 2, 40, "Subsection",
  Evaluatable->False],
Cell[1504905, 42714, 63, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[1504993, 42719, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1505097, 42723, 484, 19, 266, "Input",
  InitializationCell->True],
Cell[1505584, 42744, 497, 19, 266, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1506118, 42768, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1506215, 42772, 328, 14, 191, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1506580, 42791, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1506665, 42795, 319, 14, 191, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1507021, 42814, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1507114, 42818, 315, 14, 191, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1507466, 42837, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1507583, 42841, 367, 13, 176, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1507987, 42859, 117, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1508107, 42863, 216, 6, 71, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1508360, 42874, 92, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1508455, 42878, 113, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[1508605, 42885, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1508688, 42889, 130, 7, 86, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1508879, 42903, 91, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1508995, 42909, 94, 2, 56, "Subsection",
  Evaluatable->False],
Cell[1509092, 42913, 333, 6, 121, "Input",
  InitializationCell->True],
Cell[1509428, 42921, 132, 7, 86, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1509609, 42934, 84, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1509718, 42940, 82, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1509825, 42946, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1509924, 42950, 167, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1510140, 42964, 83, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1510248, 42970, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1510365, 42974, 363, 12, 161, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1510765, 42991, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1510848, 42995, 99, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1510984, 43002, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1511069, 43006, 121, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1511227, 43018, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1511331, 43022, 463, 21, 296, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1511831, 43048, 97, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1511931, 43052, 162, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1512142, 43066, 78, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1512245, 43072, 109, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1512357, 43076, 187, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1512581, 43089, 111, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1512695, 43093, 211, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1512943, 43108, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1513026, 43112, 113, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1513176, 43119, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1513261, 43123, 116, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1513414, 43135, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1513513, 43139, 585, 24, 341, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1514147, 43169, 81, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1514253, 43175, 112, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1514368, 43179, 193, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1514598, 43192, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1514715, 43196, 217, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1514969, 43211, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1515052, 43215, 97, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1515186, 43222, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1515271, 43226, 122, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1515430, 43238, 99, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1515532, 43242, 124, 2, 41, "Input",
  InitializationCell->True],
Cell[1515659, 43246, 698, 28, 401, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1516406, 43280, 78, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1516509, 43286, 109, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1516621, 43290, 187, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1516845, 43303, 111, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1516959, 43307, 211, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1517207, 43322, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1517290, 43326, 94, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1517421, 43333, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1517506, 43337, 119, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1517662, 43349, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1517761, 43353, 121, 2, 41, "Input",
  InitializationCell->True],
Cell[1517885, 43357, 849, 15, 431, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1518783, 43378, 79, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1518887, 43384, 110, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1519000, 43388, 189, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1519226, 43401, 112, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1519341, 43405, 213, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1519591, 43420, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1519674, 43424, 224, 12, 161, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1519935, 43441, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1520020, 43445, 120, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1520177, 43457, 97, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1520277, 43461, 122, 2, 41, "Input",
  InitializationCell->True],
Cell[1520402, 43465, 751, 31, 446, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1521202, 43502, 83, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1521310, 43508, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1521427, 43512, 197, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1521661, 43525, 116, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1521780, 43529, 221, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1522038, 43544, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1522121, 43548, 99, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1522257, 43555, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1522342, 43559, 127, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1522506, 43571, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1522610, 43575, 589, 22, 311, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1523248, 43603, 83, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1523356, 43609, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1523473, 43613, 197, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1523707, 43626, 116, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1523826, 43630, 221, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1524084, 43645, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1524167, 43649, 99, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1524303, 43656, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1524388, 43660, 121, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1524546, 43672, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1524650, 43676, 214, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1524913, 43690, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1525024, 43696, 117, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1525144, 43700, 201, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1525382, 43713, 120, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1525505, 43717, 225, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1525767, 43732, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1525850, 43736, 101, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1525988, 43743, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1526073, 43747, 129, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1526239, 43759, 104, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1526346, 43763, 609, 23, 326, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1526992, 43791, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1527086, 43795, 70, 1, 41, "Input"],
Cell[1527159, 43798, 112, 2, 41, "Input",
  InitializationCell->True],
Cell[1527274, 43802, 1321, 46, 671, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1528644, 43854, 87, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1528756, 43860, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1528850, 43864, 377, 16, 221, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1529264, 43885, 93, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1529360, 43889, 176, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1529597, 43904, 86, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1529708, 43910, 95, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1529828, 43916, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1529920, 43920, 140, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1530097, 43930, 98, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1530198, 43934, 290, 12, 161, "Input",
  InitializationCell->True],
Cell[1530491, 43948, 128, 2, 41, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1530668, 43956, 88, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1530781, 43962, 104, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1530888, 43966, 66, 1, 41, "Input"],
Cell[1530957, 43969, 353, 15, 206, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[1531335, 43988, 68, 1, 41, "Input"],
Cell[1531406, 43991, 104, 6, 43, "Output",
  Evaluatable->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1531559, 44003, 93, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1531655, 44007, 68, 1, 41, "Input"],
Cell[1531726, 44010, 322, 13, 176, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1532085, 44028, 88, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1532176, 44032, 492, 20, 281, "Input",
  InitializationCell->True],
Cell[1532671, 44054, 119, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1532827, 44066, 87, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1532939, 44072, 457, 18, 251, "Input",
  InitializationCell->True],
Cell[1533399, 44092, 185, 3, 70, "Message"]
}, Open  ]],
Cell[1533599, 44098, 117, 7, 86, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1533765, 44111, 97, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1533887, 44117, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1533981, 44121, 935, 49, 716, "Input",
  InitializationCell->True],
Cell[1534919, 44172, 131, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1535087, 44184, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1535191, 44188, 154, 5, 56, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1535406, 44200, 87, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1535518, 44206, 89, 2, 56, "Subsection",
  Evaluatable->False],
Cell[1535610, 44210, 243, 12, 161, "Input",
  InitializationCell->True],
Cell[1535856, 44224, 135, 7, 86, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1536040, 44237, 86, 2, 62, "Section",
  Evaluatable->False],
Cell[1536129, 44241, 62, 1, 41, "Input"],
Cell[1536194, 44244, 3037, 53, 857, "Input",
  InitializationCell->True],
Cell[1539234, 44299, 343, 17, 236, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1539614, 44321, 80, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1539719, 44327, 84, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1539828, 44333, 93, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1539924, 44337, 127, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1540088, 44344, 104, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1540195, 44348, 121, 2, 41, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1540365, 44356, 84, 2, 56, "Subsection",
  Evaluatable->False],
Cell[1540452, 44360, 115, 2, 41, "Input",
  InitializationCell->True],
Cell[1540570, 44364, 102, 2, 41, "Input",
  InitializationCell->True],
Cell[1540675, 44368, 66, 1, 41, "Input"],
Cell[1540744, 44371, 513, 18, 251, "Input",
  InitializationCell->True],
Cell[1541260, 44391, 128, 7, 86, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[1541413, 44402, 84, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1541500, 44406, 170, 8, 116, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1541731, 44421, 92, 2, 62, "Section",
  Evaluatable->False],
Cell[1541826, 44425, 319, 16, 221, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1542182, 44446, 84, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1542291, 44452, 145, 5, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1542461, 44461, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[1542553, 44465, 125, 2, 41, "Input",
  InitializationCell->True],
Cell[1542681, 44469, 93, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1542811, 44476, 103, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[1542917, 44480, 651, 21, 296, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1543605, 44506, 104, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[1543712, 44510, 353, 15, 206, "Input",
  InitializationCell->True],
Cell[1544068, 44527, 103, 2, 41, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1544220, 44535, 111, 2, 40, "Subsection",
  Evaluatable->False],
Cell[1544334, 44539, 393, 15, 206, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1544764, 44559, 109, 2, 40, "Subsection",
  Evaluatable->False],
Cell[1544876, 44563, 355, 15, 206, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[1545256, 44582, 63, 1, 41, "Input"],
Cell[1545322, 44585, 39, 1, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1545434, 44594, 78, 2, 50, "Subtitle",
  Evaluatable->False],
Cell[1545515, 44598, 204, 5, 62, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

